Notebook[{

Cell[CellGroupData[{
Cell[TextData[StyleBox["xTensor",
 FontColor->RGBColor[
  1, 0, 0]]], "Title",ExpressionUUID->"921dfa05-74da-47c6-8a0d-8965082897a4"],

Cell[TextData[StyleBox["Fast abstract tensor computer algebra",
 FontColor->RGBColor[
  0, 0, 1]]], \
"Subtitle",ExpressionUUID->"7dc94c3d-3e3a-48df-a54e-f9e60200022a"],

Cell[TextData[{
 StyleBox["Jos\[EAcute] M. Mart\[IAcute]n-Garc\[IAcute]a\n",
  FontSize->18],
 "(c) 2002-2021, under GPL\n\njose@xact.es\nhttp://www.xact.es/\n\
http://groups.google.com/group/xAct"
}], "Subsubtitle",ExpressionUUID->"90a71547-d8da-40f6-92a1-f9e583a9b5f8"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["0. Info and copyright",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"77ed63e9-78eb-42a9-b7c9-4f9cb7ed6c99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "*********************************************************************)"}\
], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], "*", 
    " ", "0.", " ", "Info", " ", "and", " ", 
    RowBox[{"copyright", " ", "**", "**", "**"}]}], "*****************)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
  "(*", "*********************************************************************)"}\
]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c66171e4-7741-4bf6-89c9-b4ab43df6452"],

Cell[CellGroupData[{

Cell[BoxData["Today"], \
"Input",ExpressionUUID->"8671452c-ab51-43a5-a8e0-81760e4ebcd7"],

Cell[BoxData[
 TemplateBox[{
   RowBox[{"\"Sun 17 Oct 2021\""}], 
   RowBox[{"DateObject", "[", 
     RowBox[{
       RowBox[{"{", 
         RowBox[{"2021", ",", "10", ",", "17"}], "}"}], ",", "\"Day\"", ",", 
       "\"Gregorian\"", ",", 
       RowBox[{"-", "5.`"}]}], "]"}]},
  "DateObject",
  Editable->
   False]], "Output",ExpressionUUID->"78e20066-14f6-4fbb-b232-65199e8b7f22"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"xAct`xTensor`$Version", "=", 
   RowBox[{"{", 
    RowBox[{"\"\<1.2.0\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"2021", ",", "10", ",", "17"}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"xAct`xTensor`$xPermVersionExpected", "=", 
   RowBox[{"{", 
    RowBox[{"\"\<1.2.3\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}], "}"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"13ed265b-a76f-4903-9628-41f1a2da6150"],

Cell[CellGroupData[{

Cell[BoxData["$SessionID"], \
"Input",ExpressionUUID->"da5ba3ba-f507-445b-a13d-f30f4b87a8da"],

Cell[BoxData["20004237238521869222"], \
"Output",ExpressionUUID->"3453123c-4d89-46fe-95d8-54555e16c84b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["0.0. TODO LIST", \
"Subsection",ExpressionUUID->"b80e4aea-8ea6-4afe-92f1-43201f4afa88"],

Cell[CellGroupData[{

Cell["Soon", \
"Subsubsection",ExpressionUUID->"b3ebb22a-fe27-4ddd-8f10-d474c8309cc5"],

Cell["\<\
- What should we do with SeparateMetric on delta[a,-b] ?
- Index-modifiers and Dagger.
- None of the functions is able to tell that v[a] + v[{a,B}] is wrong.
- Guillaume's suggestions for improved symmetrization. Need computation of \
transversals.
- Suggest the use of Implode / Explode to handle derivatives. Problems with \
derivative-related symmetries and with induced derivatives.
- There are still problems with dim=1. In particular MakeRule[ contracted \
Riemann, Ricci, MetricOn->All ] kills the kernel when defining a covariant \
derivative!
- Perhaps we need another sign variable controlling where we contract the \
orthogonal vector with the n-dim eta/epsilon tensors to get the n-1-dim \
versions.
- Allow multiindex derivative operators. Partially done with CovD[expr, \
CD[-a], PD[-b], ...]. Section on connections not updated.
- Rethink DependenciesOf. How is it possible that DependenciesOfTensor[delta] \
is simpler than DependenciesOfTensor[Basis] if they are the same object in \
principle?
- What about MakeRule and Dagger?
- ChangeCovD[expr, cd1, cd2] does not work if cd1 and cd2 are \"direct-sum \
derivatives\" and cd1 appears in expr with an index of a subvbundle. It is \
just a matter of changing some Q or pmQ functions by IndexOnQ because the \
latter sees subvbundles, but not the former. There is actually much \
redundancy between those functions.
- The simplification algorithms do not see Basis[{-1},a] and Basis[{-1},b] as \
two instances of the same vector.
- Tensors now depend on parameters, but covariant derivatives do not yet. \
This is related to the question of whether parametric derivatives commute \
with covariant derivatives (even ordinary covariant derivatives).
- Analyze why and when do we need pattern indices and which functions must \
act on them.
- Block abstract indices with a Block[Evaluate[Flatten@$AbstractIndices], \
expr] in $Pre. Be careful with C,D,K,N,O.
- Sort indices a11, a2, a$11, a$2, etc correctly. Most importantly, with \
priority \"positional\"/\"antipositional\".
- Patterns in MakeRule should be given both through PatternIndices or as \
actual pattern indices.
- Check consistency of dimensionality with the products of epsilons.
- Rethink the SortCovDs rules to see if they are valid for non-abstract \
indices.
- Do we need to define QFunctionQ[...]? The `Q functions are not recognized \
by Validate.
- Introduce epsilon tensors for the induced metrics.
- Perhaps MathinputExpand is too slow, because it uses FixedPoint.
- Add a definition of FirstDerQ for derivatives with multiple indices in \
Spinors, as suggested by Thomas.
- Bitensors can be imitated by declaring a tensor to depend on two different \
manifolds, assumed to be copies of each other. Every geometrical structured \
must be then duplicated. How can we automatize that idea, without having to \
duplicate everything by hand? In particular, Adam has pointed out that in \
xCoba this becomes odd, because Christoffels are generated complaining that \
they cannot communicate derivatives acting on different manifolds.\
\>", "Text",ExpressionUUID->"d965a5bb-89dd-4275-9cc2-6244ad567c5e"]
}, Closed]],

Cell[CellGroupData[{

Cell["Not soon", \
"Subsubsection",ExpressionUUID->"27d8bcc8-7759-4c99-bc3c-92f5974f312b"],

Cell["\<\
- Introduce the idea of mapping between manifolds, including inmersions. We \
need the concept of vector on a trajectory (e.g. the fourvelocity of a \
particle, or equivalently the tangent to a line). This is related to the \
1-dim manifold problem.
- Algorithm for trace decomposition of a tensor.
- Full compatibilization of Sort priorities and canonicalization
- Encode UserTypeDef
- Unify the different Contract* commands in a single structure. See notebook \
Contractions.nb for tests.
- Possibility of saving a session.
- Encode forms.
- Encode Grassmann variables.
- Inverses.
- We could generalize the concept of inert-head.\
\>", "Text",ExpressionUUID->"4dc49dba-90c8-45c9-995b-213b9aae4449"]
}, Closed]],

Cell[CellGroupData[{

Cell["Questions", \
"Subsubsection",ExpressionUUID->"66de2a99-5606-4633-b90a-1c3c47f26d9d"],

Cell["\<\
- Can we have a Christoffel between a derivative on a manifold M and a \
derivative on a submanifold of M?
- Is it possible to implement antilinear operators with abstract indices? It \
doesn't seem so.
- Is it possible to define constant tensors on the inner vbundle? Is it \
possible to define constant tensors (wrt to all derivatives) at all?\
\>", "Text",ExpressionUUID->"1135f123-7c4c-460b-89c3-dbeafb52e324"]
}, Closed]],

Cell[CellGroupData[{

Cell["Comments", \
"Subsubsection",ExpressionUUID->"cc880019-100b-428f-8e67-5957eac45b0e"],

Cell["\<\
- Parameters are assumed to be real.
- Dagger[x y] is defined to be Dagger[x] Dagger[y]. In general Dagger[f[x,y]] \
is defined Dagger[f][Dagger[x],Dagger[y]].
- The antisymmetric product Wedge is half-developed.
- The idea of modified indices (IModQ) is half-developed.\
\>", "Text",ExpressionUUID->"fa9a3322-407e-4d92-8617-cd46b7a711b6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["0.1. GPL", \
"Subsection",ExpressionUUID->"e2c82d5d-60dc-4cc2-a4d2-56ff88eacfdc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"xTensor", ",", " ", 
    RowBox[{
    "fast", " ", "abstract", " ", "tensor", " ", "computer", " ", 
     "algebra"}]}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Copyright", " ", 
     RowBox[{"(", "C", ")"}], " ", "2002"}], "-", 
    RowBox[{"2021", " ", "Jose", " ", 
     RowBox[{"M", ".", " ", "Martin"}]}], "-", "Garcia"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "This", " ", "program", " ", "is", " ", "free", " ", "software"}], ";", 
     " ", 
     RowBox[{"you", " ", "can", " ", "redistribute", " ", "it", " ", 
      RowBox[{"and", "/", "or"}], " ", "modify", "\[IndentingNewLine]", " ", 
      "it", " ", "under", " ", "the", " ", "terms", " ", "of", " ", "the", 
      " ", "GNU", " ", "General", " ", "Public", " ", "License", " ", "as", 
      " ", "published", "\[IndentingNewLine]", " ", "by", " ", "the", " ", 
      "Free", " ", "Software", " ", "Foundation"}], ";", " ", 
     RowBox[{
     "either", " ", "version", " ", "2", " ", "of", " ", "the", " ", 
      "License"}]}], ",", "\[IndentingNewLine]", "  ", 
    RowBox[{"or", " ", 
     RowBox[{"(", 
      RowBox[{"at", " ", "your", " ", "option"}], ")"}], " ", "any", " ", 
     "later", " ", 
     RowBox[{
     "version", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", "This"}], 
     " ", "program", " ", "is", " ", "distributed", " ", "in", " ", "the", 
     " ", "hope", " ", "that", " ", "it", " ", "will", " ", "be", " ", 
     "useful"}], ",", "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"but", " ", "WITHOUT", " ", "ANY", " ", "WARRANTY"}], ";", " ", 
     RowBox[{
     "without", " ", "even", " ", "the", " ", "implied", " ", "warranty", " ",
       "of", "\[IndentingNewLine]", " ", "MERCHANTABILITY", " ", "or", " ", 
      "FITNESS", " ", "FOR", " ", "A", " ", "PARTICULAR", " ", 
      RowBox[{"PURPOSE", ".", " ", "See"}], " ", "the", " ", "GNU", 
      "\[IndentingNewLine]", " ", "General", " ", "Public", " ", "License", 
      " ", "for", " ", "more", " ", 
      RowBox[{
      "details", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", "You"}], 
      " ", "should", " ", "have", " ", "received", " ", "a", " ", "copy", " ",
       "of", " ", "the", " ", "GNU", " ", "General", " ", "Public", " ", 
      "License", "\[IndentingNewLine]", " ", "along", " ", "with", " ", 
      "this", " ", "program"}], ";", " ", 
     RowBox[{"if", " ", "not"}]}], ",", " ", 
    RowBox[{
    "write", " ", "to", " ", "the", " ", "Free", " ", "Software", 
     "\[IndentingNewLine]", " ", "Foundation"}], ",", " ", 
    RowBox[{"Inc", "."}], ",", " ", 
    RowBox[{
     RowBox[{"59", " ", "Temple", " ", "Place"}], "-", 
     RowBox[{"Suite", " ", "330"}]}], ",", " ", "Boston", ",", " ", 
    RowBox[{
     RowBox[{"MA", " ", "02111"}], "-", "1307"}], ",", "\[IndentingNewLine]", 
    "  ", 
    RowBox[{"USA", "."}]}], " ", "\[IndentingNewLine]", "*)"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"82bddea8-582c-4022-8587-ba832ada4067"]
}, Closed]],

Cell[CellGroupData[{

Cell["0.2. Info package", \
"Subsection",ExpressionUUID->"dd37ad63-9974-4e2b-9942-c545908e6ba7"],

Cell["\<\
(* :Title: xTensor *)

(* :Author: Jose M. Martin-Garcia *)

(* :Summary: Efficient abstract tensor computer algebra *)

(* :Brief Discussion:
   - Perform generic abstract tensor calculations.
   - Define manifolds, vector bundles, tensors, covariant derivatives and \
metrics.
   - Define symmetries as groups of permutations. Package xPerm.
   - Define Lie derivatives, Lie brackets and variational derivatives.
   - Define constant-symbols, parameters and parametric derivatives.
   - Simplifications: use Portugal's algorithms. Package xPerm.
   - Define bases and charts. Compute components. Package xCoba.
   - Define the concept of tensor equation and tensor rule.
*)
  
(* :Context: xAct`xTensor` *)

(* :Package Version: 1.2.0 *)

(* :Copyright: Jose M. Martin-Garcia (2002-2021) *)

(* :History: see xTensor.History file *)

(* :Keywords: *)

(* :Source: xTensor.nb *)

(* :Warning: *)

(* :Mathematica Version: 6.0 and later *)

(* :Limitations: Many. xTensor knows what its author knows! *)\
\>", "Input",
 PageWidth:>PaperWidth,
 CellMargins->{{60, -272}, {Inherited, Inherited}},
 InitializationCell->
  True,ExpressionUUID->"b8d77a9a-4586-4c39-ba8b-fc454f230514"],

Cell[TextData[{
 StyleBox["Four leading rules:", "Subsubsection"],
 "\n\t1. Mathematical structure\n\t2. Compliance with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s way of working\n\t3. Efficiency\n\t4. Simplicity of notations"
}], "Text",ExpressionUUID->"0bf8fed7-37d7-417b-a911-92ae5e7103b3"],

Cell[TextData[{
 StyleBox["Main design decisions:", "Subsubsection"],
 "\n\t1. Mathematical tensor notation: Abstract indices formalism (see \
Penrose&Rindler, Wald, Ashtekar).\n\t2. Input/Output based on ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " symbols, not on strings. Strings give you more flexibility for notations, \
but you need to develop a syntactic parser, which obstructs the interaction \
of the user and the internals.\n\t3. Organization of the information: we \
shall define expressions denoting objects and functions. The definitions will \
be associated to the heads of the expressions, either as upvalues, ownvalues \
or downvalues. We do not include the properties of the objects as arguments \
in their expressions. Again, it is not possible to associate definitions to \
strings. This rule is relaxed in version 1.0, allowing non-atomic objects in \
some cases.\n\t4. Indexed objects will have the form name[indices]. We do not \
tag objects, due to several reasons:\n\t\ta) Expressions like Tensor[T, \
{A,-B}] are harder to input than T[-A,B]\n\t\tb) The limitation in depth for \
upvalues is greater for tagged objects.\n\t\tc) Even though it is possible to \
have Tensor[T, ...] and Spinor[T, ...], we cannot associated definitions \
consistently to symbol T.\n\t\td) The internals should be simple enough so \
that the users can define new rules without having to use MakeRule and the \
like.\n\t5. Indices are represented in the simplest form I can think of (a \
for an up-index, -a for a down-index). Because there is no tagging for \
indices, we need to define what is an index: it is anything that can be found \
at positions in expressions reserved just for indices (index-slots). \
Currently they are\n\t\ta) tensor[indices]\n\t\tb) covd[index][ expr ] or the \
newer CovD[expr, ___, covd[index], ___]\n\t\tc) inerthead[ expr, ___, \
IndexList[ indices ], ___ ]\n\t\td) product[ expr1, expr2, ... ]\nThis means \
that tensor indices cannot be mixed with other types of arguments in the same \
sequence. This is a strong rule. Note that we cannot combine all of them into \
a single structure. We have at least nonindexedhead[indices] and \
possiblyindexedhead[ indexedexpressions ]. We could try a mixture of\n\t\tA) \
possiblyindexedhead[ indices ] representing the elementary tensors\n\t\tB) \
possiblyindexedhead[ indexedexpressions ] representing the operators on all \
kinds of tensors\nBut the additional arguments of the inert-heads do not fit \
well here. They should have been in the head. Same thing happens with label \
indices.\n\t6. Control of evaluation: most functions in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " evaluate their arguments on input. This is what the user expects. However, \
there are exceptions with those functions that can be used to analyze or \
change the input: for instance FindIndices and ReplaceIndex."
}], "Text",ExpressionUUID->"921b3657-a3e1-4d9f-a6d8-b2c31691381a"]
}, Closed]],

Cell[CellGroupData[{

Cell["0.3. BeginPackage", \
"Subsection",ExpressionUUID->"470428eb-522d-432e-ae18-782ecbc28fdb"],

Cell["Protect against multiple loading of the package:", \
"Text",ExpressionUUID->"564c1fa4-f65b-4e5d-a677-0d9ea97b21be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xAct`xTensor`Private`xTensorSymbols", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Names", "[", "\"\<xAct`xTensor`*\>\"", "]"}], ",", 
          RowBox[{"Names", "[", "\"\<xAct`xTensor`Private`*\>\"", "]"}]}], 
         "]"}], ",", 
        RowBox[{
        "\"\<$Version\>\"", "|", "\"\<xAct`xTensor`$Version\>\"", "|", 
         "\"\<$xPermVersionExpected\>\"", "|", 
         "\"\<xAct`xTensor`$xPermVersionExpected\>\"", "|", 
         "\"\<xAct`xTensor`$ReadingVerbose\>\""}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Unprotect", "/@", "xAct`xTensor`Private`xTensorSymbols"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Clear", "/@", "xAct`xTensor`Private`xTensorSymbols"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1f10ba4e-5992-44dd-819e-30a32e21a3cd"],

Cell["Last package read in a session:", \
"Text",ExpressionUUID->"85ffe464-2e9b-44f4-9be7-dade8e774462"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Unevaluated", "[", "xAct`xCore`Private`$LastPackage", "]"}], "===",
      "xAct`xCore`Private`$LastPackage"}], ",", 
    RowBox[{
    "xAct`xCore`Private`$LastPackage", "=", "\"\<xAct`xTensor`\>\""}]}], 
   "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7b1b09fb-b136-4158-b744-884344737087"],

Cell[CellGroupData[{

Cell[BoxData["xAct`xCore`Private`$LastPackage"], \
"Input",ExpressionUUID->"84911d8c-84a5-470e-ad2e-b3d4e630d278"],

Cell[BoxData["\<\"xAct`xTensor`\"\>"], \
"Output",ExpressionUUID->"18444f9c-a67a-429a-ba21-21f9784542a3"]
}, Open  ]],

Cell[TextData[{
 "Fix for the conflict with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9:"
}], "Text",ExpressionUUID->"06b2b77c-917d-4222-8202-1420482bc214"],

Cell[BoxData[{
 RowBox[{"xAct`xTensor`Symmetrize", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"System`Symmetrize", "::", "shdw"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bdc84d6e-c3f5-4dfd-baf1-21fa2d45cfc1"],

Cell[TextData[{
 "Explicit (not hidden) import of ",
 StyleBox["xCore",
  FontSlant->"Italic"],
 ",  ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 " and ",
 StyleBox["ExpressionManipulation",
  FontSlant->"Italic"],
 " (the latter is not automatically read from version 0.6.2 of ",
 StyleBox["xCore",
  FontSlant->"Italic"],
 "):"
}], "Text",ExpressionUUID->"c41cf39e-33c1-4e47-bc46-f50b1098d60c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BeginPackage", "[", 
  RowBox[{"\"\<xAct`xTensor`\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<xAct`xCore`\>\"", ",", "\"\<xAct`xPerm`\>\""}], "}"}]}], 
  "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ea5a0555-74e7-47c8-8c7e-db6a41c44d1d"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"ba285e69-42d9-466b-8e75-89dab76bedf4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xPerm`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xPerm`  version ", "1.2.3", ", ", {2015, 8, 23}],
  
  Editable->
   False]], "Print",ExpressionUUID->"70ceb986-be41-44e1-a160-e790246c43df"],

Cell[BoxData["\<\"CopyRight (C) 2003-2020, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], \
"Print",ExpressionUUID->"8c0ffe19-ee68-4cfa-9907-f71dbd617848"],

Cell[BoxData["\<\"Connecting to external mac executable...\"\>"], \
"Print",ExpressionUUID->"3ce683c0-97ea-4213-aff4-0f36eecf8134"],

Cell[BoxData["\<\"Connection established.\"\>"], \
"Print",ExpressionUUID->"dde23e75-667d-4618-93ed-86ad2fff19a0"]
}, Open  ]],

Cell[BoxData["\<\"xAct`xTensor`\"\>"], \
"Output",ExpressionUUID->"1c875431-36dc-4952-8b8e-039ce8ab9831"]
}, Open  ]],

Cell["Information on the link to xperm.c:", \
"Text",ExpressionUUID->"807456e4-7231-43da-abaf-01869870b1f6"],

Cell[CellGroupData[{

Cell[BoxData["$xpermExecutable"], \
"Input",ExpressionUUID->"8ca40f8c-19e6-4629-8002-8fdf87c53420"],

Cell[BoxData["\<\"/Users/jose/Library/Mathematica/Applications/xAct//xPerm/\
mathlink/xperm.mac\"\>"], \
"Output",ExpressionUUID->"bb3c36d0-46cc-49bf-a0d1-93a521496de5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$xpermLink"], \
"Input",ExpressionUUID->"f5083ea0-39e9-4a38-a4d2-d33ec284da53"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["LinkObject",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{
      PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource["FEBitmaps", "SummaryBoxOpener"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              BaseStyle -> {}, Evaluator -> Automatic, Method -> 
              "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{
              Thickness[0.038461538461538464`], {
               FaceForm[{
                 GrayLevel[0.93], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
                1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}}, {{{
                25.499999999999996`, 2.5}, {25.499999999999996`, 
                1.3953100000000003`}, {24.604699999999998`, 
                0.49999999999999994`}, {23.5, 0.49999999999999994`}, {2.5, 
                0.49999999999999994`}, {1.3953100000000003`, 
                0.49999999999999994`}, {0.49999999999999994`, 
                1.3953100000000003`}, {0.49999999999999994`, 2.5}, {
                0.49999999999999994`, 23.5}, {0.49999999999999994`, 
                24.604699999999998`}, {1.3953100000000003`, 
                25.499999999999996`}, {2.5, 25.499999999999996`}, {23.5, 
                25.499999999999996`}, {24.604699999999998`, 
                25.499999999999996`}, {25.499999999999996`, 
                24.604699999999998`}, {25.499999999999996`, 23.5}, {
                25.499999999999996`, 2.5}}}]}, {
               FaceForm[{
                 RGBColor[0.5, 0.5, 0.5], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{20.5426, 
                19.116799999999998`}, {16.3832, 21.876199999999997`}, {
                16.3832, 20.021499999999996`}, {6.930469999999999, 
                20.021499999999996`}, {6.930469999999999, 
                18.212100000000003`}, {16.3832, 18.212100000000003`}, {
                16.3832, 16.357399999999995`}, {20.5426, 
                19.116799999999998`}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
                 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIRIGYC4sIjUTVcAooO8+XdOPpnKDg8YkwNXuen7JA2
W/qycJSgw5sbHEde31CB82PFhGf3n1V1aFVgVz0zR8oBrF9czWFHsFXE/9Wy
Dje0Dj4qiFWDy7cVLYptDVKH65/g6Xbu0HMNOB9sn4I23H6w+SWacD5De8DS
tDQNB7ldC/alskg4aD2+nx6joeFgnPFi/oMZog5B9vlaQa/UHao9k7f0KUhA
+D/UUPVbqML5jCB+oIpDzJHypGv8Eg4eGad3ikiqwM2T57H5LndPGW6eya7m
GzMvKcH1o4cXABG3d/Y=
                "]], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}}}, {{{14.163129999999999`, 
                4.337966249999999}, {16.96813, 4.337966249999999}, {16.96813, 
                5.047809999999999}, {14.98813, 5.047809999999999}, {14.98813, 
                8.29796625}, {14.163129999999999`, 8.29796625}, {
                14.163129999999999`, 4.337966249999999}}}]}}, Background -> 
             GrayLevel[0.93], Axes -> False, AspectRatio -> 1, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}], Frame -> True, FrameTicks -> None, 
             FrameStyle -> Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Name: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  StyleBox[
                   PaneBox[
                   "\"'/Users/jose/Library/Mathematica/Applications/xAct//\
xPerm/mathlink/xperm.mac'\"", ContentPadding -> False, FrameMargins -> 0, 
                    StripOnInput -> True, BaselinePosition -> Baseline, 
                    ImageSize -> {{1, 300}, Automatic}], LineBreakWithin -> 
                   False], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link mode: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["Listen", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
          AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource["FEBitmaps", "SummaryBoxCloser"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              BaseStyle -> {}, Evaluator -> Automatic, Method -> 
              "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{
              Thickness[0.038461538461538464`], {
               FaceForm[{
                 GrayLevel[0.93], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
                1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}}, {{{
                25.499999999999996`, 2.5}, {25.499999999999996`, 
                1.3953100000000003`}, {24.604699999999998`, 
                0.49999999999999994`}, {23.5, 0.49999999999999994`}, {2.5, 
                0.49999999999999994`}, {1.3953100000000003`, 
                0.49999999999999994`}, {0.49999999999999994`, 
                1.3953100000000003`}, {0.49999999999999994`, 2.5}, {
                0.49999999999999994`, 23.5}, {0.49999999999999994`, 
                24.604699999999998`}, {1.3953100000000003`, 
                25.499999999999996`}, {2.5, 25.499999999999996`}, {23.5, 
                25.499999999999996`}, {24.604699999999998`, 
                25.499999999999996`}, {25.499999999999996`, 
                24.604699999999998`}, {25.499999999999996`, 23.5}, {
                25.499999999999996`, 2.5}}}]}, {
               FaceForm[{
                 RGBColor[0.5, 0.5, 0.5], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{20.5426, 
                19.116799999999998`}, {16.3832, 21.876199999999997`}, {
                16.3832, 20.021499999999996`}, {6.930469999999999, 
                20.021499999999996`}, {6.930469999999999, 
                18.212100000000003`}, {16.3832, 18.212100000000003`}, {
                16.3832, 16.357399999999995`}, {20.5426, 
                19.116799999999998`}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
                 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIRIGYC4sIjUTVcAooO8+XdOPpnKDg8YkwNXuen7JA2
W/qycJSgw5sbHEde31CB82PFhGf3n1V1aFVgVz0zR8oBrF9czWFHsFXE/9Wy
Dje0Dj4qiFWDy7cVLYptDVKH65/g6Xbu0HMNOB9sn4I23H6w+SWacD5De8DS
tDQNB7ldC/alskg4aD2+nx6joeFgnPFi/oMZog5B9vlaQa/UHao9k7f0KUhA
+D/UUPVbqML5jCB+oIpDzJHypGv8Eg4eGad3ikiqwM2T57H5LndPGW6eya7m
GzMvKcH1o4cXABG3d/Y=
                "]], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}}}, {{{14.163129999999999`, 
                4.337966249999999}, {16.96813, 4.337966249999999}, {16.96813, 
                5.047809999999999}, {14.98813, 5.047809999999999}, {14.98813, 
                8.29796625}, {14.163129999999999`, 8.29796625}, {
                14.163129999999999`, 4.337966249999999}}}]}}, Background -> 
             GrayLevel[0.93], Axes -> False, AspectRatio -> 1, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}], Frame -> True, FrameTicks -> None, 
             FrameStyle -> Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Name: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  PaneBox[
                  "\"'/Users/jose/Library/Mathematica/Applications/xAct//\
xPerm/mathlink/xperm.mac'\"", ImageSize -> {{1, 500}, Automatic}, 
                   BaselinePosition -> Baseline, ContentPadding -> False, 
                   FrameMargins -> 0, StripOnInput -> True], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link mode: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["Listen", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link protocol: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"SharedMemory\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
          AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  LinkObject[
  "'/Users/jose/Library/Mathematica/Applications/xAct//xPerm/mathlink/xperm.\
mac'", 248, 10],
  Editable->False,
  SelectWithContents->True,
  Selectable->
   False]], "Output",ExpressionUUID->"f6212515-99c8-4aa8-b302-ea2c57b3d985"]
}, Open  ]],

Cell[TextData[{
 "Check version of ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 ". We simply compare dates:"
}], "Text",ExpressionUUID->"f5ab3c96-5e95-465c-95d9-764657bc176a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"Not", "@", 
     RowBox[{"OrderedQ", "@", 
      RowBox[{"Map", "[", 
       RowBox[{"Last", ",", 
        RowBox[{"{", 
         RowBox[{"$xPermVersionExpected", ",", "xAct`xPerm`$Version"}], 
         "}"}]}], "]"}]}]}], ",", 
    RowBox[{"Throw", "@", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"General", "::", "versions"}], ",", "\"\<xPerm\>\"", ",", 
       "xAct`xPerm`$Version", ",", "$xPermVersionExpected"}], "]"}]}]}], 
   "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"95f94d38-66a9-45c9-87d7-790c8dbc2ea9"],

Cell["Message:", \
"Text",ExpressionUUID->"6800b98e-e924-44f3-888d-3229a49783b0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Print", "[", "xAct`xCore`Private`bars", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Package xAct`xTensor`  version \>\"", ",", 
    RowBox[{"xAct`xTensor`$Version", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<, \>\"", ",", 
    RowBox[{"xAct`xTensor`$Version", "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
  "Print", "[", 
   "\"\<CopyRight (C) 2002-2021, Jose M. Martin-Garcia, under the General \
Public License.\>\"", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"efdcaf97-33a0-47ba-b1d4-f25baae04d46"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"76305d8a-1490-41d4-b40a-cb2eb3f5cf0c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xTensor`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.0\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "10", ",", "17"}], "}"}]}],
  SequenceForm[
  "Package xAct`xTensor`  version ", "1.2.0", ", ", {2021, 10, 17}],
  Editable->
   False]], "Print",ExpressionUUID->"23313868-8a7d-4619-95a8-537613ffc13a"],

Cell[BoxData["\<\"CopyRight (C) 2002-2021, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], \
"Print",ExpressionUUID->"45d7ed64-0a63-4b47-81eb-4fdf5b4d13f5"]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 "We specify the context xAct`xTensor` to avoid overriding the Disclaimer of ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 " and ",
 StyleBox["xCore",
  FontSlant->"Italic"],
 ".",
 " However we need to turn off the message General:shdw temporarily:"
}], "Text",ExpressionUUID->"66f63bbc-ca9b-48f7-99f3-c8283f902593"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"General", "::", "shdw"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xTensor`Disclaimer", "[", "]"}], ":=", 
   RowBox[{
   "Print", "[", 
    "\"\<These are points 11 and 12 of the General Public \
License:\\n\\nBECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO \
WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT \
WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES \
PROVIDE THE PROGRAM `AS IS\.b4 WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED \
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF \
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO \
THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM \
PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR \
CORRECTION.\\n\\nIN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO \
IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY \
AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR \
DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES \
ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT \
LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED \
BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER \
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE \
POSSIBILITY OF SUCH DAMAGES.\>\"", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"On", "[", 
   RowBox[{"General", "::", "shdw"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fb9600a4-5c04-4587-9baa-365f62227c45"],

Cell[TextData[{
 "If ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is the last package begin read, print the GPL message:"
}], "Text",ExpressionUUID->"ba5906b1-ceb6-402a-b712-2f6bc39859e5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
    "xAct`xCore`Private`$LastPackage", "===", "\"\<xAct`xTensor`\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Unset", "[", "xAct`xCore`Private`$LastPackage", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "xAct`xCore`Private`bars", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
     "Print", "[", 
      "\"\<These packages come with ABSOLUTELY NO WARRANTY; for details type \
Disclaimer[]. This is free software, and you are welcome to redistribute it \
under certain conditions. See the General Public License for details.\>\"", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "xAct`xCore`Private`bars", "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8fc118c3-e677-49d5-b400-f8d11374ad91"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"32ffbd98-2f0a-47a9-8470-c38ce719800f"],

Cell[BoxData["\<\"These packages come with ABSOLUTELY NO WARRANTY; for \
details type Disclaimer[]. This is free software, and you are welcome to \
redistribute it under certain conditions. See the General Public License for \
details.\"\>"], \
"Print",ExpressionUUID->"ff26d676-b825-4ec4-ae11-86c01f4909cb"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"f4a1400e-e16d-4159-bbc1-8a8dad4f999a"]
}, Open  ]]
}, Open  ]],

Cell["We already have these symbols in the xTensor` context:", \
"Text",ExpressionUUID->"33736c60-d026-4bb7-92d3-1454c064326a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "xAct`xTensor`*"}]], \
"Input",ExpressionUUID->"5aefff87-b8d3-4115-8a8a-1bd52fb0e730"],

Cell[BoxData[
 StyleBox[
  FrameBox[GridBox[{
     {
      DynamicModuleBox[{Typeset`open$$ = True}, 
       PaneSelectorBox[{False->
        ButtonBox[
         RowBox[{
          
          DynamicBox[FEPrivate`FrontEndResource[
           "FEBitmaps", "RightPointerOpener"]], " ", 
          StyleBox["xAct`xTensor`", "InformationGridGroupHeader"]}],
         Appearance->None,
         BaseStyle->"InformationGridLink",
         ButtonFunction:>FEPrivate`Set[Typeset`open$$, True],
         Evaluator->Automatic,
         Method->"Preemptive"], True->
        PaneBox[GridBox[{
           {
            ButtonBox[
             RowBox[{
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {3., 7.}}], " ", 
              StyleBox["xAct`xTensor`", "InformationGridGroupHeader"]}],
             Appearance->None,
             BaseStyle->"InformationGridLink",
             ButtonFunction:>FEPrivate`Set[Typeset`open$$, False],
             Evaluator->Automatic,
             Method->"Preemptive"]},
           {
            PaneBox[GridBox[{
               {
                ButtonBox[
                 StyleBox["Disclaimer", "InformationGridButton"],
                 Appearance->None,
                 BaseStyle->"InformationGridLink",
                 
                 ButtonData:>{
                  "Info-6674e04b-65ed-4306-a8c1-5ec035572e00", {
                   "Disclaimer", "xAct`xTensor`"}, False},
                 ButtonNote->"xAct`xTensor`",
                 Evaluator->Automatic], 
                ButtonBox[
                 StyleBox["Symmetrize", "InformationGridButton"],
                 Appearance->None,
                 BaseStyle->"InformationGridLink",
                 
                 ButtonData:>{
                  "Info-6674e04b-65ed-4306-a8c1-5ec035572e00", {
                   "Symmetrize", "xAct`xTensor`"}, False},
                 ButtonNote->"xAct`xTensor`",
                 Evaluator->Automatic], 
                ButtonBox[
                 StyleBox["$Version", "InformationGridButton"],
                 Appearance->None,
                 BaseStyle->"InformationGridLink",
                 
                 ButtonData:>{
                  "Info-6674e04b-65ed-4306-a8c1-5ec035572e00", {
                   "$Version", "xAct`xTensor`"}, False},
                 ButtonNote->"xAct`xTensor`",
                 Evaluator->Automatic], 
                ButtonBox[
                 StyleBox["$xPermVersionExpected", "InformationGridButton"],
                 Appearance->None,
                 BaseStyle->"InformationGridLink",
                 
                 ButtonData:>{
                  "Info-6674e04b-65ed-4306-a8c1-5ec035572e00", {
                   "$xPermVersionExpected", "xAct`xTensor`"}, False},
                 ButtonNote->"xAct`xTensor`",
                 Evaluator->Automatic]}
              },
              DefaultBaseStyle->"Text",
              
              GridBoxAlignment->{
               "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
              GridBoxItemSize->{"Columns" -> {{
                   Scaled[0.2375]}}}],
             ImageMargins->{{10, 0}, {0, 2}}]}
          },
          GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}],
         FrameMargins->{{0, 0}, {8, 0}}]}, Dynamic[Typeset`open$$],
        ImageSize->Automatic]]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
    GridBoxDividers->{"ColumnsIndexed" -> {{False}}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.8]}, 
        Offset[0.2]}}],
   BaseStyle->"InformationTitleFrame"], 
  "InformationGridPlain"]], \
"Output",ExpressionUUID->"a733b223-2dff-4d54-9f30-bcd6af2d82a9"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "0.4. Bases and charts. Relation with ",
 StyleBox["xCoba",
  FontSlant->"Italic"]
}], "Subsection",ExpressionUUID->"7103db06-bacf-468f-8389-b10550cb3068"],

Cell[TextData[{
 "Almost everything related to bases and charts should go into ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ". However there are a few things that I want to treat here in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", and this section is a description of them."
}], "Text",ExpressionUUID->"ca77feb0-8d34-4649-9911-172cd97c9588"],

Cell[TextData[{
 "The single most important thing is the manipulation of basis-indices and \
component-indices (bc-indices in the following). These types of indices are \
considered in most sections of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", but of course section 5 on notations and section 8 on formatting are the \
most important cases. I want to keep all those additional definitions for \
bc-indices in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 "; otherwise half of the definitions on identifications and formatting would \
go into ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " and the other half into ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ", with a large risk of developing inconsistencies. Those parts of the code \
working with bc-indices in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " have been marked with the word BASIS. Currently there are two alternative \
notations for basis indices, denoted with BASIS1 and BASIS2 (mostly \
controlled through IMOD definitions). A second important issue is that of \
densities: most of it is included in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ": functions WeightOf, WeightOfTensor and metric determinants. However, the \
general concept of determinant and the eta tensors are in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ".\n\nFunctions in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " having influence on bases and charts:\n\t- BasisQ and ChartQ are the \
symbol-type identification functions. Associated global variables: $Bases and \
$Charts\n\t- BIndexQ, CIndexQ and BCIndexQ\n\t- CIndexForm, $CIndexForm\n\
Functions in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 " which are used in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", but already with xAct`xCoba` context:\n\t- xAct`xCoba`VBundleOfBasis is \
used to find out the vbundle of c-indices\n\t- xAct`xCoba`CNumbersOf[basis] \
is used in CIndexQ\n\t- xAct`xCoba`BasisColor is used in the formatting \
routines\n\t- xAct`xCoba`DefBasis and xAct`xCoba`DefChart\n\t- \
xAct`xCoba`UndefBasis and xAct`xCoba`UndefChart are called by Undef\n\t- \
xAct`xCoba`DaggerCIndex\n\t- xAct`xCoba`Private`DaggerBIndex\n\t- \
xAct`xCoba`DependenciesOfBasis\n\t- xAct`xCoba`PDOfBasis\n\t- \
xAct`xCoba`BasisOfCovD\n\t- xAct`xCoba`Coordinate is used by CIndexForm"
}], "Text",ExpressionUUID->"d614eff1-6ef7-4c9d-b08c-7d456e7f7c4c"],

Cell["We declare the symbols here:", \
"Text",ExpressionUUID->"dc67ae1d-5e2f-4e64-b83f-0a6a29090830"],

Cell[BoxData[{
 RowBox[{"xAct`xCoba`DefBasis", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`UndefBasis", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`DefChart", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`UndefChart", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`DependenciesOfBasis", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`DaggerCIndex", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`Private`DaggerBIndex", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`VBundleOfBasis", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`CNumbersOf", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`Coordinate", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`BasisColor", ";"}], "\[IndentingNewLine]", 
 RowBox[{"xAct`xCoba`PDOfBasis", 
  ";"}]}], "Input",ExpressionUUID->"dbafd5d7-a8df-42e4-bf02-98c099213725"]
}, Closed]],

Cell[CellGroupData[{

Cell["0.5. Bad decisions in xTensor. Too late to change them", \
"Subsection",ExpressionUUID->"b259fe80-f714-41c9-bcd0-d3d2211d5034"],

Cell[TextData[{
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", and actually most of ",
 StyleBox["xAct",
  FontSlant->"Italic"],
 ", has grown organically, as my own needs first and then the needs of other \
authors required. Some decisions were originally made without taking into \
account future extensions, and have been later found to be inconvenient. But \
now they are too deeply ingrained in the system, and would be too much work \
for me (and too much hassle for the users) to change them, at least in many \
cases. Here there is a list of the main things, in order of importance:\n\n\t\
1) The CD[-a][ expr ] notation for covariant derivatives is inconvenient in \
output. This has been partially alleviated by TensorDerivative, but the \
former remains as the standard.\n\t\n\t2) The asymmetry between the syntax of \
upper and lower indices.\n\t\n\t3) We are too restrictive asking for objects \
being symbols. This is being progressively relaxed, and it is not true \
anymore for the two main types: Tensor and CovD.\n\t\n\t4) Label indices are \
absurd. Their information should have been in the tensor head.\n\t\n\t5) \
There is no indexed zero tensor, and so rank information is lost during some \
computations. We have recently added Zero, but we only use it in internal \
computations.\n\t\n\t6) We assign to vbundles properties that are really of \
their fibers (vspaces), like dimension."
}], "Text",ExpressionUUID->"6c714df6-09cc-405f-b96e-93cc646a93a5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["1. Usage messages",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"2fdf6f8f-7527-4436-9db3-559a887a5ae8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "*********************************************************************)"}\
], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
     "**", "**", "**", "**", "**", "**", "**", "**", "**", " ", "1."}], " ", 
     "Symbols"}], ",", " ", 
    RowBox[{"names", " ", "and", " ", "messages"}]}], " ", 
   "*******************)"}], "\[IndentingNewLine]", 
  RowBox[{
  "(*", "*********************************************************************)"}\
]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fcfd6d04-ed7e-48e7-93f7-e3509d27646d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"15f36169-62d2-4232-87b6-ed453326aeda"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5.510812`", ",", "196.190825`8.744223686932143", ",", 
   "0.02808919478150994`"}], 
  "}"}]], "Output",ExpressionUUID->"5851521f-3419-448c-bcf2-0a3c5e339c2e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["1.0. Comments", \
"Subsection",ExpressionUUID->"0b652672-d0a7-4205-99d3-4d323b279486"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 1: Usage messages.\>\"", "]"}], 
   ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5f63f07b-b64c-41b5-b7e6-e6696db487f4"],

Cell["\<\
This section simply decides which functions are public and which are not. The \
usage messages of private functions are not included in the package.\
\>", "Text",ExpressionUUID->"2708cb91-8057-475d-ba32-1e257e094694"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1. Usage of functions. Public", \
"Subsection",ExpressionUUID->"b4298243-4cd3-43e1-9bec-d6f22ecb8f44"],

Cell[CellGroupData[{

Cell["1.1.0. Info and copyright", \
"Subsubsection",ExpressionUUID->"77d9d484-4950-434d-88dc-57beeec041d9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Versions", " ", "and", " ", "GPL", " ", "disclaimer"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xTensor`$Version", "::", "usage"}], "=", 
     "\"\<$Version is a global variable giving the version of the package \
xTensor in use.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "xAct`xTensor`$xPermVersionExpected", "=", 
     "\"\<$xPermVersionExpected is a global variable giving the oldest \
possible version of the package xPerm which is required by the version of the \
package xTensor in use.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xTensor`Disclaimer", "::", "usage"}], "=", 
     "\"\<Disclaimer[] gives the General Public License (GPL) disclaimer \
message.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"74631bce-6b1d-4294-949a-b2c1a5e23caa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Verbose", " ", "while", " ", "reading", " ", "the", " ", 
    RowBox[{"package", "?"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"xAct`xTensor`$ReadingVerbose", "::", "usage"}], "=", 
    "\"\<$ReadingVerbose is a Boolean global variable that turns on \
log-messages while the xTensor package is being read. By default it is not \
set.\>\""}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f5068105-90ab-420b-ace7-c34284d3bdcc"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.2. Types. Conventions and signs", \
"Subsubsection",ExpressionUUID->"0cbac22f-415f-4e17-979e-4cfd22bae02a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Generic", " ", "options", " ", "in", " ", "Def", " ", "commands"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"$ProtectNewSymbols", "::", "usage"}], "=", 
     "\"\<$ProtectNewSymbols is a Boolean global variable specifying the \
default value for the option ProtectNewSymbol of all DefType commands. The \
default initial value is False.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProtectNewSymbol", "::", "usage"}], "=", 
     "\"\<ProtectNewSymbol is a Boolean option for all DefType commands that \
specifies whether the defined symbol will be protected or not. The default \
value is given by the global variable $ProtectNewSymbols.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefInfo", "::", "usage"}], "=", 
     "\"\<DefInfo is an option for all DefType commands specifying an \
additional message to output at definition time. DefInfo[x] returns the \
DefInfo image associated with x at definition time.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$DefInfoQ", "::", "usage"}], "=", 
     "\"\<$DefInfoQ is a boolean global variable controlling whether the info \
definition messages are printed. By default it is True, but setting it to \
False deactivates all Def messages.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$UndefInfoQ", "::", "usage"}], "=", 
     "\"\<$UndefInfoQ is a boolean global variable controlling whether the \
info undefinition messages are printed. By default it is True, but setting it \
to False deactivates all Undef messages.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"df81e146-9e85-4fbf-915d-a022cd40cb3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Formatting", " ", "of", " ", "objects"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xTensorFormStart", "::", "usage"}], "=", 
     "\"\<xTensorFormStart[class] starts formatting for a class of objects. \
Valid classes are: ConstantSymbol, Parameter, InertHead, Tensor, CovD, LieD. \
xTensorFormStart[] starts formatting for all those classes.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xTensorFormStop", "::", "usage"}], "=", 
     "\"\<xTensorFormStop[class] stops formatting for a class of objects. \
Valid classes are: ConstantSymbol, Parameter, InertHead, Tensor, CovD, LieD. \
xTensorFormStop[] stops formatting for all those classes.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAs", "::", "usage"}], "=", 
     "\"\<PrintAs[symbol] gives the output string or boxes for symbol in \
StandardForm.\\n\\nPrintAs is also an option for the DefType commands that \
specifies the output form of a defined symbol. It can be PrintAs -> string or \
PrintAs -> boxes. If boxes are to be constructed in a delayed way then use \
PrintAs -> Hold[delayedboxes]. Finally it can also be PrintAs -> function, \
such that the output will be ToString[function[symbol]].\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsCharacter", "::", "usage"}], "=", 
     "\"\<PrintAsCharacter[symbol] returns a character to be used in the \
typesetting of fundamental objects in xTensor. For example \\\"R\\\" for \
Riemann, \\\"G\\\" for Einstein, etc.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f8873389-2fa5-4606-a708-d02d4a320867"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Relations", " ", "among", " ", "symbols"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VisitorsOf", "::", "usage"}], "=", 
     "\"\<VisitorsOf[symbol] gives the list of all symbols which require \
symbol to exist before they can be defined. symbol can only be removed if \
this list is empty.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HostsOf", "::", "usage"}], "=", 
     "\"\<HostsOf[symbol] gives the list of symbols which are required to \
exist previously, before symbol was defined, and which cannot be undefined as \
long as symbol exists.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MasterOf", "::", "usage"}], "=", 
     "\"\<MasterOf[servant] gives the master symbol of the symbol servant. \
The latter is defined and removed when, and only when, the former is defined \
and removed, respectively.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ServantsOf", "::", "usage"}], "=", 
     "\"\<ServantsOf[symbol] gives the list of symbols which have been \
simultaneously defined with symbol. They will be removed when, and only when, \
symbol is removed.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Master", "::", "usage"}], "=", 
     "\"\<Master is an option for DefType commands specifying the master \
symbol of the defined symbol. By default, no master is associated.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7613c61c-2d3f-4229-b1e9-5a7708761094"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Reserved", " ", "words", " ", "for", " ", "types"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"AbstractIndex", "::", "usage"}], "=", 
     "\"\<AbstractIndex represents the type for symbols denoting abstract \
indices of a vector bundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Manifold", "::", "usage"}], "=", 
     "\"\<Manifold represents the type for smooth, differentiable \
manifolds.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Mapping", "::", "usage"}], "=", 
     "\"\<Mapping represents the type for smooth mappings between \
manifolds.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundle", "::", "usage"}], "=", 
     "\"\<VBundle represents the type for smooth, differentiable vector \
bundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Tensor", "::", "usage"}], "=", 
     "\"\<Tensor represents the type for smooth tensor fields in the product \
of several vector bundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Metric", "::", "usage"}], "=", 
     "\"\<Metric represents the type for smooth metric tensor fields on a \
vector bundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "::", "usage"}], "=", 
     "\"\<CovD represents the type for smooth connections living on some \
manifold.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InertHead", "::", "usage"}], "=", 
     "\"\<InertHead represents the type for tensor wrappers of \
tensors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarFunction", "::", "usage"}], "=", 
     "\"\<ScalarFunction represents the type for scalar functions.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConstantSymbol", "::", "usage"}], "=", 
     "\"\<ConstantSymbol represents the type for constant symbols.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Parameter", "::", "usage"}], "=", 
     "\"\<Parameter represents the type for parameter symbols.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Basis", "::", "usage"}], "=", 
     "\"\<Basis represents both the type and the tensor head for a basis \
vector/covector field.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Chart", "::", "usage"}], "=", 
     "\"\<Chart represents the type for smooth coordinate charts on \
manifolds.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"87a79e4f-7dcf-4423-bfa4-9a6cf2c4f0b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Data", "-", "bases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"$AbstractIndices", "::", "usage"}], "=", 
     "\"\<$AbstractIndices is a global variables storing the list of all \
currently defined abstract indices, including those internally \
generated.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ConstantSymbols", "::", "usage"}], "=", 
     "\"\<$ConstantSymbols is a global variable storing the list of all \
currently defined constant symbols.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Tensors", "::", "usage"}], "=", 
     "\"\<$Tensors is a global variable storing the list of all currently \
defined tensors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$CovDs", "::", "usage"}], "=", 
     "\"\<$CovDs is a global variable storing the list of all currently \
defined covariant derivatives, including the fiducial partial derivative \
PD.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Manifolds", "::", "usage"}], "=", 
     "\"\<$Manifolds is a global variable storing the list of all currently \
defined manifolds.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Mappings", "::", "usage"}], "=", 
     "\"\<$Mappings is a global variable storing the list of all currently \
defined mappings.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$VBundles", "::", "usage"}], "=", 
     "\"\<$VBundles is a global variable storing the list of all currently \
defined vector bundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ProductManifolds", "::", "usage"}], "=", 
     "\"\<$ProductManifolds is a global variable storing the list of all \
currently defined product manifolds. It is a subset of $Manifolds.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$SumVBundles", "::", "usage"}], "=", 
     "\"\<$SumVBundles is a global variable storing the list of all currently \
defined direct-sum vector bundles. It is a subset of $VBundles.\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Metrics", "::", "usage"}], "=", 
     "\"\<$Metrics is a global variable storing the list of all currently \
defined metrics. It is a subset of $Tensors.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ProductMetrics", "::", "usage"}], "=", 
     "\"\<$ProductMetrics is a global variable storing the list of all \
currently defined product metrics. It is a subset of $Metrics.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$InertHeads", "::", "usage"}], "=", 
     "\"\<$InertHeads is a global variable storing the list of all currently \
defined inert heads of indexed expressions.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ScalarFunctions", "::", "usage"}], "=", 
     "\"\<$ScalarFunctions is a global variable storing the list of all \
currently defined functions acting on scalars.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Rules", "::", "usage"}], "=", 
     "\"\<$Rules is a global variable storing the list of all rules \
registered as global rules.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Bases", "::", "usage"}], "=", 
     "\"\<$Bases is a global variable containing the list of all symbols \
registered as bases (not necessarily coordinate bases) on the bundles in \
$VBundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Charts", "::", "usage"}], "=", 
     "\"\<$Charts is a global variable containing the list of all symbols \
registered as charts on the manifolds in $Manifolds. It is a subset of \
$Bases.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Parameters", "::", "usage"}], "=", 
     "\"\<$Parameters is a global variable storing the list of all currently \
defined parameters.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$Products", "::", "usage"}], "=", 
     "\"\<$Products is a global variable storing the list of all currently \
defined products.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fb190aff-13b9-4a0f-af03-5751a3f1b20c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Collecting", " ", "function"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FindAllOfType", "::", "usage"}], "=", 
    "\"\<FindAllOfType[expr, type] gives the list of all occurrences of \
elements of the given type in expr, including their indices for types like \
Tensor, CovD, etc.\>\""}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"65cca8ba-7033-466f-89ab-9bffacb3cb53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Undefinition", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Undef", "::", "usage"}], "=", 
    "\"\<Undef[symbol] undefines the symbol, whatever its type may be. The \
only exception are abstract indices.\>\""}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"34f0905f-51a1-415f-ad9e-58f435ba6ba1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Name", " ", "validation", " ", "in", " ", "session"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ValidateSymbolInSession", "::", "usage"}], "=", 
    "\"\<ValidateSymbolInSession[symbol] throws an error if symbol is already \
used in this session as a constant-symbol, parameter, manifold, vector \
bundle, abstract index, tensor (or metric), form, covariant derivative, basis \
(or chart), inert head or scalar function. Otherwise it gives Null.\>\""}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"21667eeb-64f7-49ff-9a59-d671a09bf328"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Q", "-", 
    RowBox[{"functions", " ", "on", " ", "symbols"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"AbstractIndexQ", "::", "usage"}], "=", 
     "\"\<AbstractIndexQ[symbol] gives True if symbol has been registered as \
an abstract index. Note that it gives False on down-indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConstantSymbolQ", "::", "usage"}], "=", 
     "\"\<ConstantSymbolQ[symbol] gives True if symbol has been registered as \
a constant symbol, and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldQ", "::", "usage"}], "=", 
     "\"\<ManifoldQ[expr] gives True if expr has been registered as a \
manifold, and False otherwise.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"MappingQ", "::", "usage"}], "=", 
     "\"\<MappingQ[symbol] gives True if symbol has been registered as a \
mapping, and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundleQ", "::", "usage"}], "=", 
     "\"\<VBundleQ[symbol] gives True if symbol has been registered as a \
vector bundle, and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParameterQ", "::", "usage"}], "=", 
     "\"\<ParameterQ[symbol] gives True if symbol has been registered as a \
parameter and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xTensorQ", "::", "usage"}], "=", 
     "\"\<xTensorQ[expr] gives True if expr has been registered as a tensor, \
and False otherwise. Do not confuse with Mathematica's TensorQ.\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovDQ", "::", "usage"}], "=", 
     "\"\<CovDQ[expr] gives True if expr has been registered as a covariant \
derivative operator, and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricQ", "::", "usage"}], "=", 
     "\"\<MetricQ[expr] gives True if expr has been registered as a metric, \
and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BasisQ", "::", "usage"}], "=", 
     "\"\<BasisQ[symbol] gives True if symbol has been registered as a basis \
or chart, and False otherwise. BasisQ[basis, vbundle] gives True if basis is \
one of the bases of the vector bundle vbundle, and False otherwise.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChartQ", "::", "usage"}], "=", 
     "\"\<ChartQ[symbol] gives True if symbol has been registered as a chart, \
and False otherwise. ChartQ[chart, manifold] gives True if chart is one of \
the charts of manifold, and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InertHeadQ", "::", "usage"}], "=", 
     "\"\<InertHeadQ[head] gives True if head[object] must be treated as \
object form the point of view of symmetries and canonicalization in xTensor, \
and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarFunctionQ", "::", "usage"}], "=", 
     "\"\<ScalarFunctionQ[f] gives True if f has been defined as a \
mathematical function acting on scalars, or a derivative of one of those, and \
False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProductQ", "::", "usage"}], "=", 
     "\"\<ProductQ[symbol] gives True if symbol has been registered as a \
product on indexed objects.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Q", "-", 
     RowBox[{"functions", " ", "on", " ", "other", " ", "expressions"}]}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FirstDerQ", "::", "usage"}], "=", 
     "\"\<FirstDerQ[expr] gives True if expr is of the form covd[i], LieD[v], \
ParamD[par] or OverDot, or False otherwise. In particular it gives False on \
multiple (nested) derivatives like ParamD[par1, par2].\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpVectorQ", "::", "usage"}], "=", 
     "\"\<UpVectorQ[expr] gives True if expr has only one free up-index, and \
False otherwise. UpVectorQ[expr, vbundle] gives True if also the free index \
of expr belongs to the vector bundle vbundle.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"DownVectorQ", "::", "usage"}], "=", 
     "\"\<DownVectorQ[expr] gives True if expr has only one free down-index, \
and False otherwise. DownVectorQ[expr, vbundle] gives True if also the free \
index of expr belongs to the vector bundle vbundle.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ConstantQ", "::", "usage"}], "=", 
     "\"\<ConstantQ[x] gives True if x is a number or a numeric symbol or a \
constant symbol. Otherwise it gives False.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8dac558e-24d2-47a1-893c-e1fcda91014e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Inert", " ", "heads"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefInertHead", "::", "usage"}], "=", 
     "\"\<DefInertHead[head] defines an inert head such that head[expr] is \
treated as expr from the tensorial point of view.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefInertHead", "::", "usage"}], "=", 
     "\"\<UndefInertHead[head] undefines the inert head.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LinearQ", "::", "usage"}], "=", 
     "\"\<LinearQ is a Boolean option for DefInertHead and DefProduct stating \
that the symbol defined is linear with respect to constants in its tensorial \
argument(s). The default value is False.\\n\\nLinearQ[head] gives True if \
head has been defined as a linear inert-head or product, and False otherwise.\
\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContractThrough", "::", "usage"}], "=", 
     "\"\<ContractThrough is an option for DefInertHead specifying a list of \
metrics and/or the delta tensor which can be contracted through the defined \
inert-head.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContractThroughQ", "::", "usage"}], "=", 
     "\"\<ContractThroughQ[head, metric] says whether the given metric can be \
contracted through the inert head. The default value is False.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ERROR", "::", "usage"}], "=", 
     "\"\<ERROR[expr] is an expression where an error has been detected. \
ERROR is an inert head with a single argument.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Keep", "::", "usage"}], "=", 
     "\"\<Keep[expr] represents the tensorial expression expr, but prevents \
its expansion under the action of other functions.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfInertHead", "::", "usage"}], "=", 
     "\"\<DependenciesOfInertHead[ih] returns the implicit dependencies \
(manifols and/or parameters) of the inert head ih.\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Complex", " ", "conjugation"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "::", "usage"}], "=", 
     "\"\<Dagger[expr] returns the complex conjugate of an expression. Dagger \
is an inert head. Use DaggerIndex on indices.\\n\\nDagger is also an option \
for several DefType commands, specifying how they behave under complex \
conjugation: possible values are Real, Imaginary, Complex, Hermitian and \
Antihermitian, the latter two only applying to tensors.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "::", "usage"}], "=", 
     "\"\<DaggerIndex[ind] returns the conjugated index to ind. \
DaggerIndex[IndexList[i1, ..., in]] returns the list (also with head \
IndexList) of respective conjugated indices. Label indices are considered \
real by default.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerQ", "::", "usage"}], "=", 
     "\"\<DaggerQ[expr] gives True if expr is complex (Dagger[expr] different \
from expr) and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDagger", "::", "usage"}], "=", 
     "\"\<TransposeDagger[tensor[inds]] exchange the positions of the complex \
conjugated indices following this rule: the n-th index of the complex vbundle \
C is exchanged with the n-th index of the vbundle Dagger[C]. If the number of \
indices in tensor belonging to C and Dagger[C] is not the same, an error is \
thrown. There is no conjugation in this process, simply swapping of indices. \
TransposeDagger[tensor[inds], vbs] only transposes indices of vbs (a vbundle \
or a list of them).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Pair", "::", "usage"}], "=", 
     "\"\<Pair[A, B\[Dagger]] represents a conjugated pair of indices on \
conjugated vbundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Imaginary", "::", "usage"}], "=", 
     "\"\<Imaginary is a possible value for the option Dagger.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Hermitian", "::", "usage"}], "=", 
     "\"\<Hermitian is a possible value for the option Dagger of DefTensor.\>\
\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Antihermitian", "::", "usage"}], "=", 
     "\"\<Antihermitian is a possible value for the option Dagger of \
DefTensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HermitianQ", "::", "usage"}], "=", 
     "\"\<HermitianQ[tensor] gives True if tensor is a complex Hermitian \
tensor, and False otherwise. In particular, this function returns False on \
real tensors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AntihermitianQ", "::", "usage"}], "=", 
     "\"\<AntihermitianQ[tensor] gives True if tensor is a complex \
antihermitian tensor, and False otherwise.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d9da8e47-d132-402c-92b9-82b3f2b0f348"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Scalar", " ", "functions"}], " ", "*)"}], " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefScalarFunction", "::", "usage"}], "=", 
     "\"\<DefScalarFunction[f] defines f to be a scalar function of one or \
several scalar arguments.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefScalarFunction", "::", "usage"}], "=", 
     "\"\<UndefScalarFunction[f] undefines the scalar function f.\>\""}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Parameters", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefParameter", "::", "usage"}], "=", 
     "\"\<DefParameter[t] defines t to be a real parameter on which indexed \
objects can depend.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefParameter", "::", "usage"}], "=", 
     "\"\<UndefParameter[t] undefines the parameter t.\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Scalars", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarQ", "::", "usage"}], "=", 
     "\"\<ScalarQ[expr] gives true if expr is a scalar, that is, it has no \
free index.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Scalar", "::", "usage"}], "=", 
     "\"\<Scalar[expr] denotes that expr is a scalar (no free indices) \
expression. The expression is simplified as much as possible extracting \
scalars and constants.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$SeparateScalarsFromScalar", "::", "usage"}], "=", 
     "\"\<$SeparateScalarsFromScalar is a global variable specifying whether \
Scalar[x] should be converted into x for a non-indexed scalar x.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ScalarColor", "::", "usage"}], "=", 
     "\"\<$ScalarColor is a global variable specifying the color of the \
parentheses surrounding the formatting of a Scalar expression.\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Products", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefProduct", "::", "usage"}], "=", 
     "\"\<DefProduct[prod, pbs, pos] defines prod to be an algebra product of \
indexed objects, in which pos is the product of scalars and pbs is the \
product of scalars by elements of the algebra. The second and third arguments \
may be omitted, both having default value Times.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefProduct", "::", "usage"}], "=", 
     "\"\<UndefProduct[prod] undefines the product prod.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AssociativeProductQ", "::", "usage"}], "=", 
     "\"\<AssociativeProductQ[prod] gives whether the product prod is \
associative or not.\\n\\nAssociativeProductQ is also a boolean option of \
DefProduct, specifying whether the product being defined is associative. Its \
default value is True.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradedProductQ", "::", "usage"}], "=", 
     "\"\<GradedProductQ[prod] says whether the algebra associated to the \
product prod is graded or not. If it is, grades are computed using \
Grade[expr, prod].\\n\\nGradedProductQ is also a boolean option of \
DefProduct, specifying whether the product being defined is graded or not. \
Its default value is False.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CommutativityOfProduct", "::", "usage"}], "=", 
     "\"\<CommutativityOfProduct[prod] describes the symmetry of the product \
prod. It can be \\\"Commutative\\\", \\\"Anticommutative\\\", \
\\\"SuperCommutative\\\", \\\"SuperAnticommutative\\\" or None. It can also \
be a function f of two arguments returning the sign under exchange of any two \
consecutive factors.\\n\\nCommutativityOfProduct is also an option of \
DefProduct, specifying the symmetry of the product being defined. Its default \
value is None.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IdentityElementOfProduct", "::", "usage"}], "=", 
     "\"\<IdentityElementOfProduct[prod] returns the neutral element of the \
product prod.\\n\\nIdentityElementOfProduct is also an option of DefProduct, \
specifying the neutral element of the product being defined. Its default \
value is None.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarsOfProduct", "::", "usage"}], "=", 
     "\"\<ScalarsOfProduct[prod] returns a function that gives True on the \
scalars of the product algebra prod, and gives False \
otherwise.\\n\\nScalarsOfProduct is also an option of DefProduct, specifying \
that function at definition time. Its default value is NumericQ.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProductByScalar", "::", "usage"}], "=", 
     "\"\<ProductByScalar[prod] returns the product used to multiply elements \
of the algebra by scalars of the algebra defined by the product prod. The \
result may be the product pbs or {Left, pbs} or {Right, pbs} depending on \
whether pbs is orderless or must be used as pbs[scalar, x] or pbs[x, scalar], \
respectively.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProductOfScalars", "::", "usage"}], "=", 
     "\"\<ProductOfScalars[prod] returns the product used to multiply scalars \
of the the product algebra defined by the product prod.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefineCommutator", "::", "usage"}], "=", 
     "\"\<DefineCommutator is a boolean option of DefProduct, specifying \
whether the the associated product Commutator[prod] must be defined together \
with the product prod being defined. Its default value is False.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Commutator", "::", "usage"}], "=", 
     "\"\<Commutator[prod][a, b] represents the commutator associated to the \
product prod, that is prod[a, b] - prod[b, a]. Commutator[prod] is an \
Anticommutative product. If prod is associative then Commutator[prod] obeys \
the Jacobi identity and defines a Lie algebra.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Anticommutator", "::", "usage"}], "=", 
     "\"\<Anticommutator[prod][a, b] represents the anticommutator associated \
to the product prod, that is prod[a, b] + prod[b, a]. Commutator[prod] is a \
Commutative product.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Supercommutator", "::", "usage"}], "=", 
     "\"\<Supercommutator[prod][a, b] represents the supercommutator \
associated to the product prod, that is prod[a, b] - \
(-1)^(|a|\[CenterDot]|b|) prod[b, a], where |a| is the grade of a. \
Supercommutator[prod] is a SuperAnticommutative product. If prod is \
associative then Supercommutator[prod] obeys a graded Jacobi identity and \
defines a graded Lie algebra.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpandCommutator", "::", "usage"}], "=", 
     "\"\<ExpandCommutator[expr] expands all commutators, anticommutators, \
and supercommutators to their underlying base products.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "::", "usage"}], "=", 
     "\"\<Grade[expr, prod] returns the grade of the expression expr with \
respect to the product prod.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfTensor", "::", "usage"}], "=", 
     "\"\<GradeOfTensor[T, prod] gives the grade of the tensor T in the \
product prod.\\n\\nGradeOfTensor is also an option of DefTensor specifying \
the grade of the tensor being defined in various products, as in \
GradeOfTensor->{wedge->1, clifford->2}.\>\""}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfCovD", "::", "usage"}], "=", 
     "\"\<GradeOfCovD[cd, prod] gives the grade of the covariant derivative \
cd in the product prod.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfProduct", "::", "usage"}], "=", 
     "\"\<GradeOfProduct[prod, prod2] returns the grade with respect to \
product prod2 added by the presence of a product prod of \
expressions.\\n\\nGradeOfProduct is also an option of DefProduct, specifying \
that the value of GradeOfProduct[prod, prod] when the product prod is \
defined.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xSortOrder", "::", "usage"}], "=", 
     "\"\<xSortOrder is an option of DefProduct specifying an Order-like \
function used to sort the factors of the product being defined. Its default \
value is Automatic, which represents the standard ordering used by the Times \
product in xTensor.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7e1a4a1f-e809-4ebc-83cd-7b0e09862e0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Conventions", " ", "and", " ", "signs"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"$epsilonSign", "::", "usage"}], "=", 
     "\"\<$epsilonSign is a global sign giving the default value for the \
function epsilonOrientation. This variable is kept for backward \
compatibility.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$RiemannSign", "::", "usage"}], "=", 
     "\"\<$RiemannSign defines the global sign of the Riemann tensor from \
derivatives of a connection: Riemann[-a,-b,-c,d] = $RiemannSign * ( \
PD[-b][Christoffel[d,-a,-c] + ...)\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$RicciSign", "::", "usage"}], "=", 
     "\"\<$RicciSign defines the global sign of the Ricci tensor from \
contraction of the Riemann tensor: Ricci[-a,-b] = $RicciSign * \
Riemann[-a,-c,-b,c]\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$TorsionSign", "::", "usage"}], "=", 
     "\"\<$TorsionSign defines the global sign of the torsion tensor of a \
covariant derivative: cd[-a]@cd[-b]@f[] - cd[-b]@cd[-a]@f[] = - $TorsionSign \
Torsioncd[c,-a,-b] cd[-c]@f[].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ExtrinsicKSign", "::", "usage"}], "=", 
     "\"\<$ExtrinsicKSign defines the global sign of the extrisic curvature \
tensor in terms of the derivative of a vector field: ExtrinsicK[-a,-b] = \
$ExtrinsicKSign Projector[ cd[-a][ n[-b] ] ].\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$AccelerationSign", "::", "usage"}], "=", 
     "\"\<$AccelerationSign defines the global sign of the acceleration \
vector in terms of the derivative of a vector field: Acceleration[-a] = \
$AccelerationSign n[b] cd[-b][ n[-a] ] / norm.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"736cf359-9df7-46a8-a5d1-f820132674b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Creating", " ", "names"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"GiveSymbol", "::", "usage"}], "=", 
     "\"\<GiveSymbol[object, case] constructs a symbol for the required \
object in the special given case. Both must be symbols or strings.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GiveOutputString", "::", "usage"}], "=", 
     "\"\<GiveOutputString[object, case] gives the string to be used as \
output in StandardForm. Both object and case must be symbols or \
strings.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b5c6001c-94a2-4b13-bcbd-715ec662228f"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.3. G-Indices", \
"Subsubsection",ExpressionUUID->"525e0d68-1f97-4b77-9136-5f73c694207e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Types", " ", "of", " ", "g"}], "-", 
    RowBox[{
     RowBox[{"indices", ".", " ", "BASIS1", ".", " ", "BASIS2"}], " ", "is", 
     " ", "not", " ", "yet", " ", "documented"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefAbstractIndex", "::", "usage"}], "=", 
     "\"\<DefAbstractIndex[symbol] defines symbol to be an abstract index \
without associating it to a vector bundle yet.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefAbstractIndex", "::", "usage"}], "=", 
     "\"\<UndefAbstractIndex[index] undefines index, making it \
unusable.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "::", "usage"}], "=", 
     "\"\<GIndexQ[x] gives True if x is a valid generalized index (an \
abstract index, a label index, a valid basis index, or a valid direction). \
Patterns are not accepted. Otherwise it gives False. GIndexQ[x, vbundle] \
gives True if x is a valid generalized index belonging to the vector bundle \
vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AIndexQ", "::", "usage"}], "=", 
     "\"\<AIndexQ[x] gives True if x is recognized as a valid abstract index, \
and False otherwise. AIndexQ[x, vbundle] gives True if x is a valid abstract \
index belonging to the vector bundle vbundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "::", "usage"}], "=", 
     "\"\<BIndexQ[x] gives True if x is a valid basis index: {i, basis}, \
where i is an abstract index. BIndexQ[x, basis] gives True if x is a valid \
basis index belonging to basis. BIndexQ[x, vbundle] gives True if x is a \
valid basis index belonging to the vector bundle vbundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "::", "usage"}], "=", 
     "\"\<CIndexQ[x] gives True if x is a valid component index: {i, basis}, \
where i is an integer cnumber compatible with basis. CIndexQ[x, basis] gives \
True if x is a valid component index belonging to basis. CIndexQ[x, vbundle] \
gives True if x is a valid component index belonging to some basis of the \
vector bundle vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DIndexQ", "::", "usage"}], "=", 
     "\"\<DIndexQ[x] gives True if x is a valid directional index of the form \
Dir[v], where v is a covariant or contravariant vector. DIndexQ[x, vbundle] \
gives True if x is a valid directional index belonging to the vector bundle \
vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LIndexQ", "::", "usage"}], "=", 
     "\"\<LIndexQ[x] gives True if x is a label (an expression with head LI, \
perhaps multiplied by -1), and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "::", "usage"}], "=", 
     "\"\<PIndexQ[ind] gives True if ind is a valid pattern for an index: _, \
_h, a_h, a_h?Q where a must be a valid abstract index and h must be one of \
Symbol, Dir, LI, List, Blank, Pattern, PatternTest. Other kinds of pattern, \
in particular Condition, are not accepted.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ABIndexQ", "::", "usage"}], "=", 
     "\"\<ABIndexQ[x] gives True if x is an ABIndex (abstract index or basis \
index) and False otherwise. ABIndexQ[x, basis] gives True if x is an ABIndex \
belonging to basis and False otherwise. ABIndexQ[x, vbundle] gives True if x \
is an ABIndex belonging to the vector bundle vbundle and False \
otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BCIndexQ", "::", "usage"}], "=", 
     "\"\<BCIndexQ[x] gives True if x is a BCIndex (basis index or component \
index), and False otherwise. BCIndexQ[x, basis] gives True if x is a BCIndex \
belonging to basis and False otherwise. BCIndexQ[x, vbundle] gives True if x \
is an BCIndex belonging to the vector bundle vbundle and False \
otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CDIndexQ", "::", "usage"}], "=", 
     "\"\<CDIndexQ[x] gives True if x is a CDIndex (component index or \
directional index), and False otherwise. CDIndexQ[x, basis] gives True if x \
is a CDIndex belonging to basis and False otherwise. CDIndexQ[x, vbundle] \
gives True if x is an CDIndex belonging to the vector bundle vbundle and \
False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dir", "::", "usage"}], "=", 
     "\"\<Dir[v] is a directional index in any tensorial slot. Its single \
argument v is assumed to be a vector or a covector.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LI", "::", "usage"}], "=", 
     "\"\<LI is the head for label indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Labels", "::", "usage"}], "=", 
     "\"\<Labels is the \\\"vector bundle\\\" to which all labels \
belong.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndex", "::", "usage"}], "=", 
     "\"\<UpIndex[ind] converts ind into an up-index: On expressions of the \
form -expr it returns expr. On basis- and component-indices UpIndex[{1, \
basis}] and UpIndex[{1, -basis}] return {1, basis}. On directions Dir[...] \
the function UpIndex returns a covector. On other cases it returns the input \
expr.\>\""}], ";", 
    RowBox[{
     RowBox[{"DownIndex", "::", "usage"}], "=", 
     "\"\<DownIndex[ind] converts ind into a down-index, returning opposite \
results to UpIndex.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeIndex", "::", "usage"}], "=", 
     "\"\<ChangeIndex[ind] converts up-indices to down-indices and viceversa.\
\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "::", "usage"}], "=", 
     "\"\<UpIndexQ[a] gives True if a is an upper index and False otherwise. \
It gives False on patterns.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "::", "usage"}], "=", 
     "\"\<DownIndexQ[a] gives True if a is a lower index and False otherwise. \
It gives False on patterns.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "::", "usage"}], "=", 
     "\"\<EIndexQ[ind] identifies indices which can obey the Einstein \
convention, returning opposite results to BlockedQ. We call them Einstein, \
contractible or traceable indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BlockedQ", "::", "usage"}], "=", 
     "\"\<BlockedQ[ind] returns True on blocked indices: types C, D and L. On \
other cases (traceable indices) it returns False, including indices of types \
A, B and patterns.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PairQ", "::", "usage"}], "=", 
     "\"\<PairQ[a, b] returns True if indices a, b form an Einstein pair of \
contracted indices. Currently this is only possible for a pair a, -a of \
abstract indices or a pair {a, B}, {-a,-B} of basis indices of the same basis \
B.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexList", "::", "usage"}], "=", 
     "\"\<IndexList[i1, i2, ...] is a list of g-indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$IndexListColor", "::", "usage"}], "=", 
     "\"\<$IndexListColor is a global variable specifying the color to format \
the braces of IndexList expressions in StandardForm. The default color is \
blue, RGBColor[0,0,1].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternIndex", "::", "usage"}], "=", 
     "\"\<PatternIndex[name, type] constructs a pattern index for the given \
type (AIndex, DIndex or LIndex), with the given name. PatternIndex[name, \
type, character] also specifies the given character (Up or Down). \
PatternIndex[name, type, character, vbundle] restricts the pattern to the \
vector bundle vbundle (use character Null when accepting both Up and Down).\>\
\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AIndex", "::", "usage"}], "=", 
     "\"\<AIndex represents the logic type for abstract indices. It also \
represents the abstract basis corresponding to abstract indices.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndex", "::", "usage"}], "=", 
     "\"\<BIndex represents the logic type for basis indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndex", "::", "usage"}], "=", 
     "\"\<CIndex represents the logic type for component indices.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DIndex", "::", "usage"}], "=", 
     "\"\<DIndex represents the logic type for directional indices.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LIndex", "::", "usage"}], "=", 
     "\"\<LIndex represents the logic type for label indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndex", "::", "usage"}], "=", 
     "\"\<PIndex represents the logic type for pattern indices.\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Off", "[", 
     RowBox[{"General", "::", "shdw"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xTensor`Up", "::", "usage"}], "=", 
     "\"\<Up represents the logic type for up-indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xTensor`Down", "::", "usage"}], "=", 
     "\"\<Down represents the logic type for down-indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"On", "[", 
     RowBox[{"General", "::", "shdw"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Free", "::", "usage"}], "=", 
     "\"\<Free represents the logic type for free indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dummy", "::", "usage"}], "=", 
     "\"\<Dummy represents the logic type for dummy indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Blocked", "::", "usage"}], "=", 
     "\"\<Blocked represents the logic type for blocked indices (components, \
directions and labels).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IModQ", "::", "usage"}], "=", 
     "\"\<IModQ[expr] returns True if expr is a valid index-modifier, and \
False otherwise.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"96a54a88-aa86-4f58-8c48-bee4397fa1ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Sorting", " ", "g"}], "-", "indices"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexSort", "::", "usage"}], "=", 
     "\"\<IndexSort[list] sorts the elements of list (assumed to be \
g-indices) according to three priorities set up by SetIndexSortPriorities. \
Currently: \>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexOrderedQ", "::", "usage"}], "=", 
     "\"\<IndexOrderedQ[{i1, i2, ...}] gives True if the list of g-indices is \
sorted according to IndexSort and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DisorderedPairQ", "::", "usage"}], "=", 
     "\"\<DisorderedPairQ[i1, i2] gives True if the list of indices {i1, i2} \
is not in canonical order according to IndexSort, and False otherwise.\>\""}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetIndexSortPriorities", "::", "usage"}], "=", 
     "\"\<SetIndexSortPriorities[p1, p2, p3] sets the three priorities for \
g-index sorting. The pi are strings among these: priorities p1 and p2 are \
chosen from two of the pairs `up\.b4/`down\.b4 and `free\.b4/`dummy\.b4. \
Priority 3 can be chosen from one of the pairs \
`lexicographic\.b4/`antilexicographic\.b4 and `positional\.b4/`antipositional\
\.b4.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f4fdac8a-c7d1-49f8-9fef-c449899790e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Finding", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "::", "usage"}], "=", 
     "\"\<FindIndices[expr] returns an IndexList with the (order kept) union \
of all-gindices of expr. Indices in directional arguments, Scalar expressions \
or scalar-functions are not found. FindIndices has attribute HoldFirst, and \
hence requires very often the use of Evaluate.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AnyIndices", "::", "usage"}], "=", 
     "\"\<AnyIndices is an internal symbol of xTensor returned by the \
expression FindIndices[0]. AnyIndices[vbundle] also represents an arbitrary \
sequence of abstract indices in the given vbundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$FindIndicesAcceptedHeads", "::", "usage"}], "=", 
     "\"\<$FindIndicesAcceptedHeas is a global variable giving the list of \
heads for which FindIndices does not complain and continues looking for \
indexed objects inside. It is initialized to {Hold}.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindFreeIndices", "::", "usage"}], "=", 
     "\"\<FindFreeIndices[expr] gives an IndexList with the (order not kept) \
free indices of expr, throwing an error if they are not homogeneous in all \
terms of expr. FindFreeIndices[expr, selector] uses SelectIndices on \
FindFreeIndices[expr] with the given selector. FindFreeIndices has attribute \
HoldFirst, and hence requires very often the use of Evaluate.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindDummyIndices", "::", "usage"}], "=", 
     "\"\<FindDummyIndices[expr] gives an IndexList with the (up-) indices \
wich are contracted in expr. FindDummyIndices[expr, selector] uses \
SelectIndices on FindDummyIndices[expr] with the given selector. \
FindDummyIndices has attribute HoldFirst, and hence requires very often the \
use of Evaluate.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindBlockedIndices", "::", "usage"}], "=", 
     "\"\<FindBlockedIndices[expr] gives an IndexList with the (order not \
kept) blocked indices of expr. FindBlockedIndices[expr, selector] uses \
SelectIndices on FindBlockedIndices[expr] with the given selector. \
FindBlockedIndices has attribute HoldFirst, and hence requires very often the \
use of Evaluate.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IsIndexOf", "::", "usage"}], "=", 
     "\"\<IsIndexOf[object, index] gives True if (Verbatim) index is one of \
the indices of object, and False otherwise. IsIndexOf[object, index, tensor] \
gives IndexOf[object, index] unless object is an inert head expression with \
head IH; in that case there is the further check ContractThroughQ[IH, \
tensor].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndicesOf", "::", "usage"}], "=", 
     "\"\<IndicesOf[selectors][expr] returns a list (head IndexList) of the \
indices in expression selected by the given selectors. Different selectors \
are applied succesively from left to right. Possible selectors are Free, \
Dummy, Blocked, Up, Down, AIndex, BIndex, CIndex, DIndex, LIndex, or a \
manifold, a vbundle, a basis, a tensor (including Basis), or a covd.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4685481f-9f86-4de6-9dc1-af723a3cf537"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Replacing", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceIndex", "::", "usage"}], "=", 
     "\"\<ReplaceIndex[expr, rule] replaces indices of objects in expr as \
given by rule (a single rule or a list of rules of the form i1->i2). Note \
that the rules a->b and -a->-b are independent and both must be given if this \
is what we want. ReplaceIndex[expr, {{rule1, ...}, {rule2, ...}, ...}] is \
automatically threaded, giving a list of expressions.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceDummies", "::", "usage"}], "=", 
     "\"\<ReplaceDummies[expr] replaces dummy indices in expr by new \
(dollar-) dummy indices. ReplaceDummies[expr, inds] chooses new indices from \
inds before starting generation of new indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SameDummies", "::", "usage"}], "=", 
     "\"\<SameDummies[expr] returns expr minimizing the number of different \
dummies used among the summands of the expr. No new dummy is \
introduced.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ComputeNewDummies", "::", "usage"}], "=", 
     "\"\<$ComputeNewDummies is a global Boolean variable which specifies \
whether new (dollar-) indices must be generated during the action of \
ReplaceDummies.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplitIndex", "::", "usage"}], "=", 
     "\"\<SplitIndex[expr, splitrules] returns an array whose elements are \
expr with certain indices replaced as given by the splitrules. A split-rule \
must be of the form index -> Indexlist[i1, i2, ...], meaning that index is to \
be replaced by i1, i2, ... respectively in each of the terms of the array. It \
is possible to give a list of splitrules or a compacted form \
IndexList[index1, index2, ...] -> IndexList[i1 ,i2, ...], where each of the \
indices indexi is to be splitted as IndexList[i1, i2, ...].\>\""}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TraceDummy", "::", "usage"}], "=", 
     "\"\<TraceDummy[expr, trules] traces dummy indices in expr as given by \
the trace-rules trules. These are rules of the form index -> IndexList[i1, \
i2, ...], where index can be a pattern.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"$TraceDummyVerbose", "::", "usage"}], "=", 
     "\"\<$TraceDummyVerbose is a global Boolean variable turning on and off \
log messages from the command TraceDummy.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f6bfca73-618c-4480-814a-a3766d4a3e21"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Formatting", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "::", "usage"}], "=", 
     "\"\<IndexForm[index] returns the string which will be used to format \
the generalized index (assumed not to have a minus sign in front). By \
default, abstract indices are simply converted into a string, basis and \
component indices are colored according to the basis they belong to, \
directional indices are converted into the name of the vector or into \\\"#\\\
\" when they are composite expressions, and patterns are underlined. \
(Component indices are dealt with through the associated function \
CIndexForm.) If changed, IndexForm must be manipulated with great \
care.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$CIndexForm", "::", "usage"}], "=", 
     "\"\<$CIndexForm is a Boolean global variable. If True the coordinate \
indices are represented in tensor slots as the name of the associated \
coordinate. If False (the default) no such replacemente is performed.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexForm", "::", "usage"}], "=", 
     "\"\<CIndexForm[cnumber, chart] returns the string to be used to \
represent the coordinate index {cnumber, chart} in a tensor slot.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrimeDagger", "::", "usage"}], "=", 
     "\"\<PrimeDagger[ind] for a daggered index ind returns the formatting of \
the index replacing the dagger by a prime.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c5e8faea-d1c9-45f8-a5a4-9b37e3b6a297"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.4. Manifolds, mappings and vector bundles", \
"Subsubsection",ExpressionUUID->"307f164a-8ba0-41fb-94b7-2e40e70f22a5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Manifolds", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexRange", "::", "usage"}], "=", 
     "\"\<IndexRange[a, p] and IndexRange[{a, p}] return the list of symbols \
between symbols a and p (using CharacterRange internally). IndexRange[{a1, \
p1}, {a2, p2}, ...] returns the union (using Union, and hence sorted) of the \
ranges defined by the given pairs of indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefManifold", "::", "usage"}], "=", 
     "\"\<DefManifold[M, dim, {a, b, c,...}] defines M to be an n-dimensional \
differentiable manifold with dimension dim (a positive integer or a constant \
symbol) and tensor abstract indices a, b, c, ... .  DefManifold[M, {M1, ..., \
Mm}, {a, b, c,...}] defines M to be the product manifold of previously \
defined manifolds M1 ... Mm. For backward compatibility dim can be a list of \
positive integers, whose length is interpreted as the dimension of the \
defined manifold.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefManifold", "::", "usage"}], "=", 
     "\"\<UndefManifold[manifold] undefines manifold.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DimOfManifold", "::", "usage"}], "=", 
     "\"\<DimOfManifold[M] yields the dimension of manifold M.\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Cartesian", " ", "products"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CartesianProduct", "::", "usage"}], "=", 
     "\"\<CartesianProduct[O1, O2, ...] represents the Cartesian product of \
the objects Oi.\>\""}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Manifold", " ", "splitting"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplitManifold", "::", "usage"}], "=", 
     "\"\<SplitManifold[M, {m1, ..., mn}] identifies the manifold M as the \
(external) Cartesian product of the manifolds mi. Both the M manifold and the \
mi manifolds are assumed to exist already. The dimension of M must coincide \
with the sum of the dimensions of the mi manifolds.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"SplittingsOfManifold", "::", "usage"}], "=", 
     "\"\<SplittingsOfManifold[M] returns a list of known CartesianProduct \
splittings of the manifold M.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SubmanifoldsOfManifold", "::", "usage"}], "=", 
     "\"\<SubmanifoldsOfManifold has been removed from xTensor in version \
1.1.0. Please use SplittingsOfManifold for similar functionality.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SubmanifoldQ", "::", "usage"}], "=", 
     "\"\<SubmanifoldQ[large, small] gives True if manifold small is \
contained in or equal to manifold large, and False otherwise.\>\""}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"DisjointManifoldsQ", "::", "usage"}], "=", 
     "\"\<DisjointManifoldsQ[manifolds1, manifolds2] gives True if none of \
the manifolds of the list manifolds1 is a submanifold or a supermanifold of \
the manifolds of the list manifolds2, and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DisjointVBundlesQ", "::", "usage"}], "=", 
     "\"\<DisjointVBundlesQ[vbundles1, vbundles2] gives True if none of the \
vbundles of the list vbundles1 is a subvbundle or a supervbundle of the \
vbundles of the list vbundles2, and False otherwise.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4150307b-343d-4ed1-8b4c-8369779b55c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Dependencies", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOf", "::", "usage"}], "=", 
     "\"\<DependenciesOf[expr] gives the list of manifolds and parameters \
upon which expr depends.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldsOf", "::", "usage"}], "=", 
     "\"\<ManifoldsOf[expr] gives the list of manifolds on which expr \
lives.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParametersOf", "::", "usage"}], "=", 
     "\"\<ParametersOf[expr] gives the list of parameters on which expr \
depends.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AnyDependencies", "::", "usage"}], "=", 
     "\"\<AnyDependencies is an internal symbol of xTensor returned by \
DependenciesOf acting on an unknown expression (unregistered symbols, \
patterns, etc.).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OtherDependencies", "::", "usage"}], "=", 
     "\"\<OtherDependencies is an option for DefCovD and DefMetric specifying \
that all derivatives and tensors defined have the given list of additional \
dependencies (manifolds and parameters) and not only the manifold on which \
the derivative or metric are defined.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"813ad112-2a66-4361-b3ef-21c2e7440c48"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Boundaries", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldBoundary", "::", "usage"}], "=", 
     "\"\<ManifoldBoundary[M] represents the manifold (without boundary) of \
the manifold (with boundary) M.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EmptyManifold", "::", "usage"}], "=", 
     "\"\<EmptyManifold is a manifold with no points. ManifoldBoundary[M] of \
a manifold M without boundary returns EmptyManifold.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cb336b9d-deaa-4746-95af-cbc0a0e676e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Mappings", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefMapping", "::", "usage"}], "=", 
     "\"\<DefMapping[phi, M1->M2] defines phi to be a mapping having manifold \
M1 as domain and manifold M2 as image.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefMapping", "::", "usage"}], "=", 
     "\"\<UndefMapping[phi] undefines the mapping phi.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MappingDomain", "::", "usage"}], "=", 
     "\"\<MappingDomain[phi] returns the domain manifold of the mapping \
phi.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MappingImage", "::", "usage"}], "=", 
     "\"\<MappingImage[phi] returns the image manifold of the mapping phi, in \
general a supermanifold of phi[domain].\>\""}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"ImmersionQ", "::", "usage"}], "=", 
     "\"\<ImmersionQ is a Boolean option of DefMapping. ImmersionQ[phi] \
returns True if the mapping phi is an immersion on its image, and False \
otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SubmersionQ", "::", "usage"}], "=", 
     "\"\<SubmersionsQ is a Booleann option of DefMapping. SubmersionQ[phi] \
returns True if the mapping phi is a submersion on its image, and False \
otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DiffeomorphismQ", "::", "usage"}], "=", 
     "\"\<DiffeomorphismQ[phi] returns True if the mapping phi is a local \
diffeomorphism between its domain and image, and False otherwise.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InverseMapping", "::", "usage"}], "=", 
     "\"\<InverseMapping[phi] returns the inverse of the mapping phi, if phi \
is invertible (at least left or right invertible), and throws an error \
otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IdentityMapping", "::", "usage"}], "=", 
     "\"\<IdentityMapping[M] represents the identity mapping from the \
manifold M to itself.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"48b6a704-9ccd-4add-aa7d-5e378ea7a292"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Vector", " ", "bundles"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefVBundle", "::", "usage"}], "=", 
     "\"\<DefVBundle[vbundle, M, dim, {a, b, c,...}] defines vbundle to be a \
vector bundle with base manifold M and fiber vector space with dimension \
given by dim (a positive integer) and represented by the abstract indices {a, \
b, c, ...}.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefVBundle", "::", "usage"}], "=", 
     "\"\<UndefVBundle[vbundle] undefines the vector bundle vbundle.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AnyVBundles", "::", "usage"}], "=", 
     "\"\<AnyVBundles is an internal symbol of xTensor returned by \
SlotsOfTensor acting on the Zero tensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BaseOfVBundle", "::", "usage"}], "=", 
     "\"\<BaseOfVBundle[vbundle] gives the base manifold of the vector bundle \
vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Tangent", "::", "usage"}], "=", 
     "\"\<Tangent[M] returns the tangent bundle of the manifold M. For a \
symbolic M the name of the bundle is constructed by default prepending the \
name of the manifold with Tangent.\\n\\nTangent is also an option for \
DefManifold, giving the name of the tangent bundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TangentBundleOfManifold", "::", "usage"}], "=", 
     "\"\<TangentBundleOfManifold = Tangent. Kept for backward compatibility.\
\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndicesOfVBundle", "::", "usage"}], "=", 
     "\"\<IndicesOfVBundle[vbundle] returns the abstract indices associated \
to vector bundle vbundle. There are two lists: that of the registered indices \
and that of the internally generated indices.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"LastIndex", "::", "usage"}], "=", 
     "\"\<LastIndex[vbundle] gives a pair {i, n} such that dollar-indices \
will be formed using the symbol i (see function DummyIn) and \
computer-generated indices will be formed using the symbol i and the integer \
n (see function NewIndexIn). LastIndex[vbundle, map] given the corresponding \
pair for the pullback vbundle PullBackVBundle[vbundle, map].\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DimOfVBundle", "::", "usage"}], "=", 
     "\"\<DimOfVBundle[vbundle] yields the dimension of vector bundle \
vbundle.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TangentBundleQ", "::", "usage"}], "=", 
     "\"\<TangentBundleQ[vbundle] gives True if vbundle is the tangent vector \
bundle of some manifold, and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricEndowedQ", "::", "usage"}], "=", 
     "\"\<MetricEndowedQ[vbundle] gives True if the vector bundle vbundle has \
at least one registered metric (which will be contained in \
MetricsOfVBundle[vbundle]) or False otherwise.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricsOfVBundle", "::", "usage"}], "=", 
     "\"\<MetricsOfVBundle[vbundle] gives the list of metrics that have been \
defined on the vector bundle vbundle. Only the first one will be used to \
raise and lower indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Direct", " ", "sums", "  ", "and", " ", "tensor", " ", "products"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CirclePlus", "::", "usage"}], "=", 
     "\"\<CirclePlus[vb1, vb2, ...] represents the direct sum of the vector \
bundles vb1, vb2, ...\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CircleTimes", "::", "usage"}], "=", 
     "\"\<CircleTimes[O1, O2, ...] represents the tensor product of the \
objects O1, O2, ...\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"VBundle", " ", "splitting"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplitVBundle", "::", "usage"}], "=", 
     "\"\<SplitVBundle[V, {v1, ..., vn}] identifies the vbundle V as the \
direct sum of the vbundles vi. Both the V vbundle and the vi vbundles are \
assumed to exist already. The dimension of V must coincide with the sum of \
the dimensions of the vi vbundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplittingsOfVBundle", "::", "usage"}], "=", 
     "\"\<SplittingsOfVBundle[vb] returns a list of known direct sum \
splittings of the vbundle vb.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SubvbundlesOfVBundle", "::", "usage"}], "=", 
     "\"\<SubvbundlesOfVBundle has been removed from xTensor in version \
1.1.0. Please use SplittingsOfVBundle for similar functionality.\>\""}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"SubvbundleQ", "::", "usage"}], "=", 
     "\"\<SubvbundleQ[large, small] gives True if vector bundle small is \
contained in or equal to vector bundle large, and False otherwise.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SubdummiesIn", "::", "usage"}], "=", 
     "\"\<SubdummiesIn[vbundle] gives a list of unique (dollar) indices on \
the respective subvbundles of vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetSplitTensors", "::", "usage"}], "=", 
     "\"\<SetSplitTensors[vbundle, Tlist] declares the tensors in the list \
Tlist to be projectors and their duals for the given vbundle, that must have \
been declared previously as a sum vbundle (using either DefVBundle or \
DefManifold). Currently xTensor can only decompose into two subvbundle, and \
hence Tlist must contain four tensors with character {down, up}, in any \
order. \>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplitTensor", "::", "usage"}], "=", 
     "\"\<SplitTensor[T] decomposes the tensor T as a sum of projected parts \
using the projectors declared with SetSplitTensors.\>\""}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Project", "::", "usage"}], "=", 
     "\"\<Project[expr, P, inds] project the indices inds with the projector \
P, by explicit multiplication of expr by copies of P. The inds argument \
admits a single index, and IndexList or an IndicesOf expression.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Projected", "::", "usage"}], "=", 
     "\"\<Projected[T, {P, Q, ...}][a, b, ...] represents the tensor T \
projected with projector P in index a, Q in index b, ... Non-projected slots \
are denoted by the formal projector delta. Each projector can be replaced by \
a sum of projectors. The whole list of projectors can be replaced by a single \
projector or sum of projectors acting on all indices of the \
expression.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProjectorQ", "::", "usage"}], "=", 
     "\"\<ProjectorQ[P] returns True if tensor P has been declared as a \
projector with MakeProjectors, and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeProjectors", "::", "usage"}], "=", 
     "\"\<MakeProjectors[{P1[-a, b], ..., Pn[-a, b]}, {dim1, ..., dimn}] \
defines tensors P1, ..., Pn, assumed to existe already, to be complementary \
projectors on the vbundle of the indices -a, b. Projector Pi projects onto a \
subspace of dimension dimi. The option OrthogonalWithMetric specifies a \
metric with respect to which the projectors are orthogonal.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OrthogonalWithMetric", "::", "usage"}], "=", 
     "\"\<OrthogonalWithMetric is an option of MakeProjectors specifiying the \
metric with respect to which a given set of complementary projectors are also \
a set of orthogonal projectors. The default value Null represents no \
metric.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ProjectedFormat", "::", "usage"}], "=", 
     "\"\<$ProjectedFormat is a Boolean global variable selecting the type of \
formatting of indices of Projected tensors. With False the projectors are \
staggered with the indices, in gray font. With True the projectors are placed \
on top of upper indices or underneath lower indices. This should not be a \
Boolean variable...\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContractProjector", "::", "usage"}], "=", 
     "\"\<ContractProjector[expr, P] transforms products of projector P with \
other tensors in expr into Projected notation. ContractProjector[expr] \
contracts all projectors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FromProjected", "::", "usage"}], "=", 
     "\"\<FromProjected[expr] converts Projected expressions into explicit \
products of tensors and projectors.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Indices", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundleOfIndex", "::", "usage"}], "=", 
     "\"\<VBundleOfIndex[i] gives the vector bundle to which the g-index i \
belongs. Otherwise it throws an error message.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RegisterIndices", "::", "usage"}], "=", 
     "\"\<RegisterIndices[vb, inds] associates the given list inds of \
abstract indices to the vbundle vb.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DummyIn", "::", "usage"}], "=", 
     "\"\<DummyIn[vbundle] gives a unique abstract dollar-index on the vector \
bundle vbundle, using the last of the user-defined indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DummyAs", "::", "usage"}], "=", 
     "\"\<DummyAs[ind] gives a dummy abstract index in the vector bundle of \
ind, having the same up/down character.\>\""}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"AddIndices", "::", "usage"}], "=", 
     "\"\<AddIndices[vbundle, indlist] adds the abstract indices in indlist \
to the user-defined part of the indices associated to the the vector bundle \
vbundle.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"RemoveIndices", "::", "usage"}], "=", 
     "\"\<RemoveIndices[vbundle, indlist] removes the abstract indices in \
indlist from the user-defined part of the indices associated to the vector \
bundle vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NewIndexIn", "::", "usage"}], "=", 
     "\"\<NewIndexIn[vbundle] gives and registers a new computer-defined \
abstract index associated to the vector bundle vbundle. The index is \
constructed using the last index of the user-defined part and a sequential \
number starting at 1. This is an internal function, and users are expected to \
use GetIndicesOfVBundle instead.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GetIndicesOfVBundle", "::", "usage"}], "=", 
     "\"\<GetIndicesOfVBundle[vbundle, n, list] gives a list of n abstract \
indices on the vector bundle vbundle, checking that they are not in list. If \
there are not enough indices in IndicesOfVBundle[vbundle] then new indices \
are generated using NewIndexIn.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"75b07f54-17bf-49e2-8f0c-14ef2a999695"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tracing", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy", "::", "usage"}], "=", 
    "\"\<TraceProductDummy[expr, index] expands the dummy index of a \
sum-vbundle in expr to dummy indices of its subvbundles. \
TraceProductDummy[expr] expands all dummies. TraceProductDummy[expr, {i1, i2, \
...}] expands the dummies i1, i2,... TraceProductDummy[expr, {VBundle[VB1], \
i1, ...}] expands the indices i1,... and all dummies of the sum-vbundle VB1, \
...\>\""}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"59c69c64-9d9d-4327-9943-c6783390c379"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.5. ConstantSymbols", \
"Subsubsection",ExpressionUUID->"cb12c092-99ef-40f3-9a91-0db307e4c96f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefConstantSymbol", "::", "usage"}], "=", 
   "\"\<DefConstantSymbol[symbol] defines symbol to be a constant with \
respect to all derivatives (covariant derivatives, Lie derivatives, \
variational derivatives and parameter derivatives).\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefConstantSymbol", "::", "usage"}], "=", 
   "\"\<UndefConstantSymbol[symbol] undefines the constant symbol.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9b4dd69e-ad6b-47a0-b9ba-cfec07fc386c"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.6. Tensors", \
"Subsubsection",ExpressionUUID->"04077b00-dd40-4abe-877a-b07238bcf7dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"$TensorBoxes", "::", "usage"}], "=", 
   "\"\<$TensorBoxes is a global variable specifying the internal notation to \
be used for indexed tensors. From version 1.0 of xTensor the default is \
\\\"GridBox\\\" but before it was \\\"ScriptBox\\\".\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"057a4756-f0ce-47df-8a1e-cff9215a344d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tensors", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefTensor", "::", "usage"}], "=", 
     "\"\<DefTensor[T[-a, b, c, ...], {M1, ...}] defines T to be a tensor \
field on manifolds and parameters M1,... and the base manifolds associated to \
the vector bundles of its indices. DefTensor[T[-a, b, c, ...], {M1, ...}, \
symmetry] defines a tensor with symmetry given by a generating set or strong \
generating set of the associated permutation group.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefTensor", "::", "usage"}], "=", 
     "\"\<UndefTensor[tensor] undefines tensor.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VanishingQ", "::", "usage"}], "=", 
     "\"\<VanishingQ is a Boolean option for DefTensor stating that the \
defined tensor must be given a zero value.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ForceSymmetries", "::", "usage"}], "=", 
     "\"\<ForceSymmetries is a Boolean option for DefTensor. If True \
symmetries are registered even if involved indices do not have the same \
up/down character.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FrobeniusQ", "::", "usage"}], "=", 
     "\"\<FrobeniusQ is a Boolean option for DefTensor stating that the \
defined vector obeys the Frobenius condition with every torsionless covariant \
derivative.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetOrthogonal", "::", "usage"}], "=", 
     "\"\<SetOrthogonal[tensor[inds], vector[ind]] defines automatic rules \
for tensor such that tensor[inds]*vector[ind] is zero. \
SetOrthogonal[tensor[inds], vector] defines those rules for all abstract \
indices of tensor[inds].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OrthogonalTo", "::", "usage"}], "=", 
     "\"\<OrthogonalTo is an option for several DefType functions. For \
DefTensor it gives a list of vectors which are orthogonal to the tensor \
defined, one for each index. For DefCovD it gives a vector which is \
orthogonal to the whole derivative.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetProjected", "::", "usage"}], "=", 
     "\"\<SetProjected[tensor[inds], proj[i1, i2]] defines automatic rules \
for tensor such that tensor[inds]*proj[i1, i2] returns tensor again, but with \
new indices. SetProjected[tensor[inds], proj] defines those rules for all \
abstract indices of tensor[inds].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProjectedWith", "::", "usage"}], "=", 
     "\"\<ProjectedWith is an option for several Def functions. For DefTensor \
it gives a list of 2-tensors which project the tensor defined into itself. \
For DefCovD it gives a projector for the whole derivative.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OrthogonalToVectorQ", "::", "usage"}], "=", 
     "\"\<OrthogonalToVectorQ[v][T] for a vector v and a tensor T returns \
True if T is orthogonal in all its slots to v, and False otherwise. The value \
is remembered as un upvalue of T.\\n\\nOrthogonalToVectorQ[v][expr] for a \
vector v and an indexed expression expr returns True if the expression is \
orthogonal in all its slots to v, and False otherwise. The value is not \
remembered.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfTensor", "::", "usage"}], "=", 
     "\"\<SymmetryGroupOfTensor[tensor] gives the generating set or strong \
generating set of the symmetries of tensor, using Cycles notation on the \
numeric slots of the tensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryTableauxOfTensor", "::", "usage"}], "=", 
     "\"\<SymmetryTableauxOfTensor[tensor] gives the list of symmetry \
tableaux of tensor, using numeric slots.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SlotsOfTensor", "::", "usage"}], "=", 
     "\"\<SlotsOfTensor[tensor] gives the list of vector bundles with up/down \
marks corresponding to the slots of tensor as it was defined. Slots related \
by the symmetries of tensor must belong to the same vector bundle and must \
have the same up/down character, unless the option ForceSymmetries is used.\>\
\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorID", "::", "usage"}], "=", 
     "\"\<TensorID[tensor] returns a list with information on how to compute \
the components of the tensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOfTensor", "::", "usage"}], "=", 
     "\"\<WeightOfTensor[tensor] gives the weight of tensor as a tensorial \
density. It is always a linear combination of names of bases. It is 0 if \
tensor is not a density. Upvalues for tensor are stored only if tensor is a \
density. WeightOfTensor is also an option for DefTensor giving the weight of \
the defined tensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "::", "usage"}], "=", 
     "\"\<WeightOf[expr] returns the density weight of the expression. The \
weight of the basis-determinant of the metric is defined to be \
2*basis.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfTensor", "::", "usage"}], "=", 
     "\"\<DependenciesOfTensor[tensor] gives the list of manifolds and \
parameters on which the tensor depends.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Other", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Zero", "::", "usage"}], "=", 
     "\"\<Zero[e1, ..., en] is 0 no matter what the arguments are.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HeadOfTensor", "::", "usage"}], "=", 
     "\"\<HeadOfTensor[T[a, b, ...], {a, b, ...}] returns T. HeadOfTensor[k \
T[a, b, ...], {a, b, ...}] returns MultipliyHead[k, T].\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MultiplyHead", "::", "usage"}], "=", 
     "\"\<MultiplyHead[k, T][a, b, ...] returns k T[a, b, ...].\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "::", "usage"}], "=", 
     "\"\<delta[-a, b] represents the identity tensor on any vector bundle. \
In the presence of a metric the object delta[b, -a] is also allowed, being \
related to the former as given by that metric.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Gdelta", "::", "usage"}], "=", 
     "\"\<Gdelta[-a1, ..., -an, b1, ..., bn] represents the generalized delta \
tensor on any vector bundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpandGdelta", "::", "usage"}], "=", 
     "\"\<ExpandGdelta[expr] expands Gdelta as a linear combination of \
products of delta.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sdelta", "::", "usage"}], "=", 
     "\"\<Sdelta[sym][inds] represents a tensor with symmetry sym in the \
first half of its slots and symmetry sym in the second half of its \
slots.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpandSdelta", "::", "usage"}], "=", 
     "\"\<ExpandSdelta[expr] expands Sdelta[sym] as a linear combination of \
products of delta.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateDir", "::", "usage"}], "=", 
     "\"\<SeparateDir[expr] converts all directional indices (expressions \
Dir[v]) in expr into products of the direction v and the corresponding \
tensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContractDir", "::", "usage"}], "=", 
     "\"\<ContractDir[expr, v] converts contracted vectors v into Dir[v[.]] \
expressions in expr.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dab2f6a1-c4b4-4b17-bfb1-4f069665cdf1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"PushForward", " ", "and", " ", "PullBack"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PullBack", "::", "usage"}], "=", 
     "\"\<PullBack[expr, phi, firules] computes the pull back of the tensor \
expression expr along the mapping phi, changing free indices of expr into \
free indices of the domain tangent vbundle as given by the list of rules \
firules.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PullBackVBundle", "::", "usage"}], "=", 
     "\"\<PullBackVBundle[vb, phi] represents the pull back of the vector \
bundle bun under the mapping phi. It is also treated as a (nonatomic) \
vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Precompose", "::", "usage"}], "=", 
     "\"\<Precompose[T, phi] represents the precomposition of the tensor \
field T with the mapping phi, a section of a pullback vbundle. The result has \
dependencies given by the domain of the mapping phi.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PullBackTensor", "::", "usage"}], "=", 
     "\"\<PullBackTensor[T, phi] represents the pull back of the tensor T \
under the mapping phi. It is also treated as a (nonatomic) tensor.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PullBackCovD", "::", "usage"}], "=", 
     "\"\<PullBackCovD[CD, phi] represents the pull back of the covariant \
derivative CD under the mapping phi. It is also treated as a (nonatomic) \
covariant derivative.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpandPullBack", "::", "usage"}], "=", 
     "\"\<ExpandPullBack[expr] expands the PullBackTensor[T, phi] expressions \
into a contraction of Precompose[T, phi] with explicit dphi or Inv[dphi] \
factors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TangentTensor", "::", "usage"}], "=", 
     "\"\<TangentTensor[phi] returns the tangent (or differential) of the \
mapping phi. This is a 2-tensor along the mapping phi, with its first slot \
being the cotangent vbundle of the domain of phi and the second slot being \
the pullback of the tangent bundle of the image of phi.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PushForward", "::", "usage"}], "=", 
     "\"\<PushForward[expr, phi, firules] computes the push forward of the \
tensor expression expr along the mapping phi, changing free indices of expr \
into free indices of the image tangent vbundle as given by the list of rules \
firules.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LinearPush", "::", "usage"}], "=", 
     "\"\<LinearPush[T, dphi] represents a tensor along the mapping phi, \
whose differential is dphi. It is equivalent to a contraction of the \
contravariant slots of T with dphi, and of the covariant slots of T with the \
inverse of dphi.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InvertibleQ", "::", "usage"}], "=", 
     "\"\<InvertibleQ[dphi] returns True if dphi is an invertible 2-tensor, \
and False otherwise. InvertibleQ[dphi, Left] returns True if dphi is \
left-invertible, and False otherwise. InvertibleQ[dphi, Right] returns True \
if dphi is right-invertible, and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PushForwardTensor", "::", "usage"}], "=", 
     "\"\<PushForwardTensor[T, phi] represents the push forward of the tensor \
T under the mapping phi. It is also treated as a (nonatomic) tensor.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpandPushForward", "::", "usage"}], "=", 
     "\"\<ExpandPushForward[expr] expands the PushForwardTensor[T, phi] \
expressions into a contraction of Precompose[T, iphi] with explicit diphi or \
Inv[diphi] factors, where iphi is the inverse mapping of phi.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"At", "::", "usage"}], "=", 
     "\"\<At[texpr, sub] represents the restriction of the tensorial \
expression texpr to the submanifold sub, which may be a point.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorAt", "::", "usage"}], "=", 
     "\"\<TensorAt[T, sub] represents the restriction of the tensor T to the \
submanifold sub, which may be a point.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8961af3c-7d1b-4576-bf5a-a90596a1ea59"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ATensor", "::", "usage"}], "=", 
   "\"\<ATensor[name, slots, deps, sym] represents an abstract tensor with \
the given properties.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"585db315-9f7c-44e0-bbb6-a5fd0b82b65e"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.7. Rules", \
"Subsubsection",ExpressionUUID->"e184df4b-c221-4dd3-8a79-cc82b1e7ffdc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Rules", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "::", "usage"}], "=", 
     "\"\<PermuteIndices[expr, indices, perm] permutes the indices of expr \
given by the list indices (head IndexList) with the permutation perm, in \
general a linear combination of permutations.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeRule", "::", "usage"}], "=", 
     "\"\<MakeRule[{LHS, RHS}] gives a list of delayed rules with left and \
right hand sides as given by LHS and RHS respectively, but moving indices to \
consider all possible equivalent rules. See notes for its options \
PatternIndices, MetricOn, UseSymmetries and TestIndices. MakeRule[{LHS, RHS, \
conditions}] adds conditions to the rules.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ToRule", "::", "ToRule"}], "=", 
     "\"\<ToRule[lhs==rhs] evaluates the given equation and returns a rule \
lhs:>Module[{..}, rhs] constructed with MakeRule. ToRule also accepts rules \
and lists in input, and takes all options of MakeRule.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AutomaticRules", "::", "usage"}], "=", 
     "\"\<AutomaticRules[symbol, {rule1, rule2, ...}] declares the rules as \
upvalues or downvalues for symbol, or append them to $Rules if symbol is too \
deep in the rules.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexRule", "::", "usage"}], "=", 
     "\"\<IndexRule[lhs, rhs] construct a DelayedRule expression between \
indexed expressions lhs and rhs, evaluating rhs in advance.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexRuleDelayed", "::", "usage"}], "=", 
     "\"\<IndexRuleDelayed[lhs, rhs] construct a DelayedRule expression \
between indexed expressions lhs and rhs, without evaluating rhs.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexSet", "::", "usage"}], "=", 
     "\"\<IndexSet[lhs, rhs] defines a relation between indexed expressions \
lhs and rhs, evaluating rhs in advance.\>\""}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"IndexSetDelayed", "::", "usage"}], "=", 
     "\"\<IndexSet[lhs, rhs] defines a relation between indexed expressions \
lhs and rhs, withoug evaluating rhs.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DoubleRightTee", "::", "usage"}], "=", 
     "\"\<Infix form for IndexRule. Note that it has a very high precedence \
(much higher than that of = ).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RightTeeArrow", "::", "usage"}], "=", 
     "\"\<Infix form for IndexRule. Note that it has a very high precedence \
(much higher than that of -> ).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternIndices", "::", "usage"}], "=", 
     "\"\<PatternIndices is an option for MakeRule expressing the indices \
that will be converted into patterns in the final expression of the rule. \
Possible values are None (default), All or a list of indices.\>\""}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricOn", "::", "usage"}], "=", 
     "\"\<MetricOn is an option for MakeRule. MetricOn->None (default) means \
that no index can be raised or lowered. MetricOn->All means that all indices \
can be raised or lowered. MetricOn->{i1, i2, ...} explicitly gives the list \
of indices that can be raised or lowered with the metric. This option is not \
relevant if there is no metric.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TestIndices", "::", "usage"}], "=", 
     "\"\<TestIndices is a Boolean option for MakeRule. TestIndices->True \
(default) means that patterntests are added to the indices of the rules to \
check that they belong to the right vector bundle.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"UseSymmetries", "::", "usage"}], "=", 
     "\"\<UseSymmetries is a Boolean option for MakeRule. UseSymmetries->True \
(default) means that symmetries of the tensors are considered to construct \
the rules.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContractMetrics", "::", "usage"}], "=", 
     "\"\<ContractMetrics is a Boolean option for MakeRule that specifies \
that all metric objects must be contracted (if possible) in the RHS of the \
rules. Its default value is False.\>\""}], ";", 
    RowBox[{
     RowBox[{"Verbose", "::", "usage"}], "=", 
     "\"\<Verbose is a Boolean option for MakeRule, AutomaticRules and \
ToCanonical. Verbose->True gives lots of log-info about the internals of the \
calculation. Its default value is False.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a83eecda-f809-44db-9676-c690163a6e28"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.8. Covariant derivatives", \
"Subsubsection",ExpressionUUID->"a3ee8798-4f74-4ad3-bbd7-3f47c12e4dab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Leibnitz", "::", "usage"}], "=", 
   "\"\<Leibnitz[expr][-a, b] gives a sum of copies of expr*delta in which \
each free upper index has been replaced by b and each lower index has been \
replaced by -a.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"18130788-e88f-4095-83de-01ff9f3208d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Covariant", " ", "derivatives"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"$CovDFormat", "::", "usage"}], "=", 
     "\"\<$CovDFormat is a global variable containing a string with the \
formatting form of covariant derivatives. Possible values are currently: \
\\\"Prefix\\\" (default) for nabla-like notation, and \\\"Postfix\\\" for \
comma-like notation.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$ParamDFormat", "::", "usage"}], "=", 
     "\"\<$ParamDFormat is a global variable containing a string with the \
formatting form of parametric derivatives. Possible values are currently: \
\\\"Prefix\\\" (default) or \\\"SinglePrefix\\\" for partial-like notation, \
and \\\"Postfix\\\" for comma-like notation.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefCovD", "::", "usage"}], "=", 
     "\"\<DefCovD[covd[-a], {post, pre}] defines covd to be a connection on \
the tangent bundle of index a. DefCovD[covd[-a], vbundle, {post, pre}] \
defines covd to be a connection on the tangent bundle of index a and the \
inner vbundle (which must have the same base manifold). The connection will \
be represented in StandardForm using the character pre in \\\"Prefix\\\" \
notation and the character post in \\\"Postfix\\\" notation.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefCovD", "::", "usage"}], "=", 
     "\"\<UndefCovD[covd] undefines covd.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PD", "::", "usage"}], "=", 
     "\"\<PD denotes the fiducial connection without curvature nor torsion \
(called ordinary derivative by Wald).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Curvature", "::", "usage"}], "=", 
     "\"\<Curvature is an option for DefCovD giving whether a newly defined \
covariant derivative has curvature or not. There are several possible values: \
Riemann (the connection has curvature only on the tangent bundle), FRiemann \
(only on the inner bundle, and its conjugate), True (on both vbundles), False \
(no curvature), a vbundle on which we want to have curvature, or a list of \
such vbundles. The default value is True.\\n\\nCurvature is also a Boolean \
option for DefMetric, saying whether a metric defined on a tangent bundle has \
a Levi-Civita connection with curvature or not.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CurvatureRelations", "::", "usage"}], "=", 
     "\"\<CurvatureRelations is a Boolean option for DefCovD giving whether \
automatic rules relating the curvature tensors of a newly define covariant \
derivative should be defined or not. Its default value is True.\\n\\n \
CurvatureRelations[covd, Riemann] gives a list of the relations between the \
contracted Riemann of cov and the Ricci tensor. CurvatureRelations[covd, \
Ricci] give the corresponding list of relations between the contracted Ricci \
and the RicciScalar if there is a metric. CurvatureRelations[covd] gives the \
union of those two lists.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FromMetric", "::", "usage"}], "=", 
     "\"\<FromMetric is an option for DefCovD giving the metric associated to \
the covariant derivative. Use FromMetric -> metric or FromMetric -> \
Null.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExtendedFrom", "::", "usage"}], "=", 
     "\"\<ExtendedFrom is an option for DefCovD (generally used when defining \
a covd on an inner vbundle), specifying that the Riemann, Ricci, Christoffel \
and Torsion tensors must be shared with another, already existing, \
covd.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightedWithBasis", "::", "usage"}], "=", 
     "\"\<WeightedWithBasis is an option for DefCovD (though typically used \
through DefMetric) to extend a Levi-Civita connection on densities in a given \
basis (which can be AIndex as special case). Its default value is \
Null.\\n\\nWeightedBasis[covd] returns the basis along which the Levi-Civita \
connection covd has been extended, or Null otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfCovD", "::", "usage"}], "=", 
     "\"\<SymmetryGroupOfCovD[covd] gives the symmetry group of the covariant \
derivative covd when it acts as a multiple index derivative.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfCovD", "::", "usage"}], "=", 
     "\"\<DependenciesOfCovD[covd] gives the list of dependencies (manifolds \
and parameters) on which the covariant derivative covd depends.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0d3655c3-41b8-480b-84c0-39f9285bb8b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Associated", " ", "tensors"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Christoffel", "::", "usage"}], "=", 
     "\"\<Christoffel[covd1, covd2][a, -b, -c] returns the Christoffel tensor \
relating the connections covd1 and covd2, and defines it if it does not exist \
yet. Christoffel[covd][a, -b, -c] is equivalent to Christoffel[covd, PD][a, \
-b, -c].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AChristoffel", "::", "usage"}], "=", 
     "\"\<AChristoffel[covd1, covd2][A, -b, -C] returns the Christoffel \
tensor relating the connections covd1 and covd2 on an inner vbundle, and \
defines it if it does not exist yet. This proceeds by immediate conversion of \
AChristoffel into Christoffel. AChristoffel[covd][A, -b, -C} is equivalent to \
AChristoffel[covd, PD][A, -b, -C].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Torsion", "::", "usage"}], "=", 
     "\"\<Torsion[covd] returns the torsion tensor associated to a connection \
covd.\\n\\nTorsion is also a Boolean option for DefCovD that specifies \
whether the defined covariant derivative has torsion or not. Its default \
value is False.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Riemann", "::", "usage"}], "=", 
     "\"\<Riemann[covd] returns the Riemann curvature tensor associated to a \
connection covd acting on a tangent bundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FRiemann", "::", "usage"}], "=", 
     "\"\<FRiemann[covd] returns the Riemann curvature tensor associated to a \
connection covd acting on an inner (not tangent) vector bundle.\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannDown", "::", "usage"}], "=", 
     "\"\<RiemannDown[covd] returns the Riemann curvature tensor associated \
to the connection covd of a frozen metric, with its four indices being lower \
indices, so that it has full Riemann symmetry.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Ricci", "::", "usage"}], "=", 
     "\"\<Ricci[covd] returns the Ricci curvature tensor associated to a \
connection acting on a tangent bundle.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TFRicci", "::", "usage"}], "=", 
     "\"\<TFRicci[covd] returns the Traceless Ricci curvature tensor \
associated to a connection covd acting on a tangent bundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciScalar", "::", "usage"}], "=", 
     "\"\<RicciScalar[covd] returns the Ricci curvature scalar associated to \
a metric-compatible connection covd acting on a tangent bundle.\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Einstein", "::", "usage"}], "=", 
     "\"\<Einstein[covd] returns the Einstein curvature tensor associated to \
a metric-compatible connection covd acting on a tangent bundle.\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Weyl", "::", "usage"}], "=", 
     "\"\<Weyl[covd[ returns the Weyl curvature tensor associated to a \
metric-compatible connection covd acting on a tangent bundle.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Kretschmann", "::", "usage"}], "=", 
     "\"\<Kretschmann[covd] returns the Kretschmann curvature scalar \
associated to a metric-compatible connection covd acting on a tangent bundle.\
\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LC", "::", "usage"}], "=", 
     "\"\<LC[g] returns the Levi-Civita covariant derivative associated to \
the metric g.\>\""}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Implode", "::", "usage"}], "=", 
     "\"\<Implode[expr, covd] converts covd derivatives of tensors into new \
tensors formed from the names of the tensor and the covd.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "$ImplodeInfoQ", "=", 
     "\"\<$ImplodeInfoQ is a boolean global variable which specifies whether \
definition of imploded tensors is to be reported or not.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Explode", "::", "usage"}], "=", 
     "\"\<Explode[expr, covd] converts imploded tensors into their \
corresponding form with explicit covd operators. Metric factors may appear in \
this process.\>\""}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"epsilon", "::", "usage"}], "=", 
     "\"\<epsilon[g] returns the totally antisymmetric tensor associate to \
the metric g.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExtrinsicK", "::", "usage"}], "=", 
     "\"\<ExtrinsicK[h] returns the extrinsic curvature tensor associated a \
the induced metric h.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Acceleration", "::", "usage"}], "=", 
     "\"\<Acceleration[n] returns the acceleration vector associated to the \
vector n, registered as the vector orthogonal to some induced metric.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Projector", "::", "usage"}], "=", 
     "\"\<Projector[h] returns the projector tensor on the tangent subvbundle \
defined by the induced metric h.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3b98db65-07b2-4d99-8738-494f95ecb66c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Info", " ", "on", " ", "covds"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CurvatureQ", "::", "usage"}], "=", 
     "\"\<CurvatureQ[covd] gives True if covd has been defined as a covariant \
derivative with curvature and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TorsionQ", "::", "usage"}], "=", 
     "\"\<TorsionQ[covd] gives True if covd has been defined as a covariant \
derivative with torsion and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymbolOfCovD", "::", "usage"}], "=", 
     "\"\<SymbolOfCovD[covd] gives the pair of strings that represent the \
covariant derivative covd in StandardForm in formats \\\"Postfix\\\" and \
\\\"Prefix\\\" respectively.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldOfCovD", "::", "usage"}], "=", 
     "\"\<ManifoldOfCovD[covd] gives the manifold where the covariant \
derivative covd lives. It is always a dependency of covd.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundlesOfCovD", "::", "usage"}], "=", 
     "\"\<VBundlesOfCovD[covd] gives a list of vector bundles on which the \
derivative acts. The list can contain: one element (a tangent vector bundle), \
two elements (a tangent vector bundle and an inner real vector bundle) or \
three elements (a tangent bundle and an inner complex bundle with its \
conjugate).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricOfCovD", "::", "usage"}], "=", 
     "\"\<MetricOfCovD[covd] gives the metric from which covd derives, if \
covd is a metric covariant derivative. Otherwise it gives Null.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"230486c9-af65-4809-a163-2a154cd487ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Manipulation", " ", "of", " ", "covds"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ContractCurvature", "::", "usage"}], "=", 
     "\"\<ContractCurvature[expr] replaces all contracted Riemann tensors by \
Ricci and all contracted Ricci tensors by RicciScalar. \
ContractCurvature[expr, covd] does it only for the given covariant \
derivative. ContractCurvature[expr, covd, Riemann] only replaces Riemann by \
Ricci. ContractCurvature[expr, covd, Ricci] only replaces Ricci by \
RicciScalar.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckZeroDerivative", "::", "usage"}], "=", 
     "\"\<CheckZeroDerivative[expr] performs some checks on expr to see if \
there are derivatives of some manifolds acting on fields on other manifolds, \
which hence can be removed.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$CheckZeroDerivativeVerbose", "::", "usage"}], "=", 
     "\"\<$CheckZeroDerivativeVerbose is a Boolean global variable which says \
whether the action of CheckZeroDerivative must be reported or not. By default \
it is set to False.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckZeroDerivativeStart", "::", "usage"}], "=", 
     "\"\<CheckZeroDerivativeStart[covd] starts automatic zero checking of \
derivative covd.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckZeroDerivativeStop", "::", "usage"}], "=", 
     "\"\<CheckZeroDerivativeStop[covd] stops automatic zero checking of \
derivative covd.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BreakChristoffel", "::", "usage"}], "=", 
     "\"\<BreakChristoffel[expr, chr, covd] transforms all instances of \
chr[inds] (from covd1 to covd2) in expr into Christoffel[covd1, \
covd][inds]-Christoffel[covd2, covd][inds]. BreakChristoffel[expr, chr] is \
converted into BreakChristoffel[expr, chr, PD]. BreakChristoffel[expr, covd] \
breaks all Christoffel tensors using covd as intermediate connection. \
BreakChristoffel[expr] is converted into BreakChristoffel[expr, PD].\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeTorsion", "::", "usage"}], "=", 
     "\"\<ChangeTorsion[expr, covd1, covd2] changes the torsion tensor of \
covd1 by the torsion tensor of covd2 using the antisymmetric part of the \
Christoffel relating covd1 and covd2. The second argument is listable. \
ChangeTorsion[expr, covd1] is converted into ChangeTorsion[expr, covd1, PD]. \
ChangeTorsion[expr] is converted into ChangeTorsion[expr, $CovDs].\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TorsionToChristoffel", "::", "usage"}], "=", 
     "\"\<TorsionToChristoffel = ChangeTorsion. Kept for backwards \
compatibility.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeCovD", "::", "usage"}], "=", 
     "\"\<ChangeCovD[expr, covd1, covd2] changes any instance of the \
covariant derivative covd1 in expr into a covariant derivative covd2 and \
Christoffel tensors relating both connections. The second argument is \
listable. ChangeCovD[expr, covd1] is converted into ChangeCovD[expr, covd1, \
PD]. ChangeCovD[expr] is converted into ChangeCovD[expr, $CovDs].\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovDToChristoffel", "::", "usage"}], "=", 
     "\"\<CovDToChristoffel = ChangeCovD. Kept for backwards compatibility.\>\
\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeCurvature", "::", "usage"}], "=", 
     "\"\<ChangeCurvature[expr, covd1, covd2] changes the curvature tensors \
(Riemann, Ricci, RicciScalar and FRiemann) of covd1 into the curvature \
tensors of covd2 using the Christoffels relating covd1 and covd2. The second \
argument is listable. ChangeCurvature[expr, covd1] is converted into \
ChangeCurvature[expr, covd1, PD]. ChangeCurvature[expr] is converted into \
ChangeCurvature[expr, $CovDs].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannToChristoffel", "::", "usage"}], "=", 
     "\"\<RiemannToChristoffel = ChangeCurvature. Kept for backwards \
compatibility.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannToWeyl", "::", "usage"}], "=", 
     "\"\<RiemannToWeyl[expr, covd] expands expr expressing all Riemann \
tensors of covd in terms of the Weyl and other tensors of covd. If the second \
argument is a list of covariant derivatives the command is applied \
sequentially on expr. RiemannToWeyl[expr] expands all Riemann tensors.\>\""}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeylToRiemann", "::", "usage"}], "=", 
     "\"\<WeylToRiemann[expr, covd] expands expr expressing all Weyl tensors \
of covd in terms of the Riemann and other tensors of covd. If the second \
argument is a list of covariant derivatives the command is applied \
sequentially on expr. WeylToRiemann[expr] expands all Weyl tensors.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciToTFRicci", "::", "usage"}], "=", 
     "\"\<RicciToTFRicci[expr, covd] expands expr expressing all Ricci \
tensors of covd in terms of the TFRicci and other tensors of covd. If the \
second argument is a list of covariant derivatives the command is applied \
sequentially on expr. RicciToTFRicci[expr] expands all Ricci tensors.\>\""}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TFRicciToRicci", "::", "usage"}], "=", 
     "\"\<TFRicciToRicci[expr, covd] expands expr expressing all TFRicci \
tensors of covd in terms of the Ricci and other tensors of covd. If the \
second argument is a list of covariant derivatives the command is applied \
sequentially on expr. TFRicciToRicci[expr] expands all TFRicci \
tensors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciToEinstein", "::", "usage"}], "=", 
     "\"\<RicciToEinstein[expr, covd] expands expr expressing all Ricci \
tensors of covd in terms of the Einstein and RicciScalar tensors of covd. If \
the second argument is a list of covariant derivatives the command is applied \
sequentially on expr. RicciToEinstein[expr] expands all Ricci tensors.\>\""}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EinsteinToRicci", "::", "usage"}], "=", 
     "\"\<EinsteinToRicci[expr, covd] expands expr expressing all Einstein \
tensors of covd in terms of the Ricci and RicciScalar tensors of covd. If the \
second argument is a list of covariant derivatives the command is applied \
sequentially on expr. EinsteinToRicci[expr] expands all Einstein \
tensors.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannToRiemannDown", "::", "usage"}], "=", 
     "\"\<RiemannToRiemannDown[expr, covd] expands expr expressing all \
Riemann tensors of covd (the Levi-Civita derivative of a frozen metric) in \
terms of the RiemannDown tensor of covd. If the second argument is a list of \
covariant derivatives the command is applied sequentially on expr. \
RiemannToRiemannDown[expr] expands all Riemann tensors of frozen \
metrics.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannDownToRiemann", "::", "usage"}], "=", 
     "\"\<RiemannDownToRiemann[expr, covd] expands expr expressing all \
RiemannDown tensors of covd (the Levi-Civita derivative of a frozen metric) \
in terms of the Riemann tensor of covd. If the second argument is a list of \
covariant derivatives the command is applied sequentially on expr. \
RiemannDownToRiemann[expr] expands all RiemannDown tensors of frozen metrics.\
\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"aa414deb-884f-4fe5-a780-efdb5d03e203"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Parametric", " ", "derivatives"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"OverDot", "::", "usage"}], "=", 
     "\"\<OverDot[expr] represents a simple ordinary derivative of expr with \
respect to some internal parameter (say time) which is independent of the \
coordinates of the manifolds where expr live. It commutes with partial \
derivatives, but not with other covariant derivatives or with Lie derivatives \
because in general the vector field of the Lie derivative could depend upon \
the parameter as well.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParamD", "::", "usage"}], "=", 
     "\"\<ParamD[params][expr] represents the multiple ordinary derivative of \
expr with respect to the sequence params of parameters, automatically sorted \
into canonical order.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"aececeb5-6740-41a1-a300-cbb4bbd6ee62"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Sorting", " ", "derivatives"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SortCovDs", "::", "usage"}], "=", 
     "\"\<SortCovDs[expr, covd] exchange repeatedly two instances of the \
covariant derivative covd, introducing Riemann tensors if needed, until the \
indices of the derivatives are sorted in canonical order. \>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CommuteCovDs", "::", "usage"}], "=", 
     "\"\<CommuteCovDs[expr, covd, {a, b}] converts subexpressions \
covd[b]@covd[a]@expr1 of expr into covd[a]@covd[b]@expr1 plus Riemann terms \
linear in expr1.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CommuteCovDLieD", "::", "usage"}], "=", 
     "\"\<CommuteCovDLieD[expr, LieD[v], covd] converts subexpressions \
covd[a]@LieD[v]@expr1 of expr into LieD[v]@covd[a]@expr1 plus terms linear in \
LieDvcovd. CommuteCovDLieD[expr, covd, LieD[v]] converts subexpressions \
LieD[v]@covd[a]@expr1 of expr into covd[a]@LieD[v]@expr1 plus terms linear in \
LieDvcovd.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortCovDsStart", "::", "usage"}], "=", 
     "\"\<SortCovDsStart[covd] automatizes the commutation of covariant \
derivative covd.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortCovDsStop", "::", "usage"}], "=", 
     "\"\<SortCovDsStop[covd] removes automatic commutation of covariant \
derivative covd.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8d3f5a34-b3fb-4b02-b8d7-0def464786e2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TensorD", "::", "usage"}], "=", 
   "\"\<TensorD[expr, der1, der2, ...] computes the given derivatives of \
expr, returning the result using TensorDerivative notation. The deri can be \
either covariant derivatives or Lie derivatives or parametric \
derivatives.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorDerivative", "::", "usage"}], "=", 
   "\"\<TensorDerivative[T, der] represents the name of the tensor obtained \
by differentitation of the tensor T. The derivative der can be either a \
covariant derivative or a Lie derivative or a parametric derivative. \
TensorDerivative[T, der1, der2, ...] represents a high-order \
derivative.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToTensorDerivative", "::", "usage"}], "=", 
   "\"\<ToTensorDerivative[expr] converts derivatives in expr from standard \
covd[-a][T[b,c]] notation to TensorDerivative[T,covd][b,c,-a] notation. Note \
that the derivative index is placed last in the latter notation.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromTensorDerivative", "::", "usage"}], "=", 
   "\"\<FromTensorDerivative[expr] converts derivatives in expr from \
TensorDerivative[T,covd][b,c,-a] notation to standard covd[-a][T[b,c]] \
notation. Note the the derivative index is the last in the former notation.\>\
\""}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"98262911-7136-4500-9bf9-788e99f734c3"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.9. Lie derivatives", \
"Subsubsection",ExpressionUUID->"d88eebce-ef5a-4ea4-88e3-10f63bf0b28a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Lie", " ", "derivatives"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LieD", "::", "usage"}], "=", 
     "\"\<LieD[v][expr] represents the Lie derivative of expr along the \
contravariant vector field v. LieD[v, covd][expr] computes the Lie derivative \
of expr using the covariant derivative covd.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Bracket", "::", "usage"}], "=", 
     "\"\<Bracket[v1, v2][i] represents the Lie Bracket of vector fields v1 \
and v2, giving a vector field with index i.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LieDToCovD", "::", "usage"}], "=", 
     "\"\<LieDToCovD[expr, covd] transforms LieD[v][expr1] into LieD[v, \
covd][expr1] so that the Lie derivative of expr1 along v is computed in terms \
of the covariant derivative covd.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DirCovDToLieD", "::", "usage"}], "=", 
     "\"\<DirCovDToLieD[expr, v] changes all directional derivatives along \
the vector v to Lie derivatives along the same vector field. The vector v is \
the name of the vector, without an index.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BracketToCovD", "::", "usage"}], "=", 
     "\"\<BracketToCovD[expr, covd] changes all Lie brackets in expr by their \
expressions in terms of the derivative covd (with optional value PD).\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"88819adb-c1ef-4bde-bbc5-1d3a308d72c0"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.10. Variational derivatives", \
"Subsubsection",ExpressionUUID->"2c2ec31d-cf5d-4fc2-ae03-722aea58ffba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Variational", " ", "derivatives"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VarD", "::", "usage"}], "=", 
     "\"\<VarD[T, covd][expr, rest] computes the variational derivative of \
expr*rest with respect to the tensor field T. Integrations by parts will be \
performed with the covariant derivative covd.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ImplicitTensorDepQ", "::", "usage"}], "=", 
     "\"\<ImplicitTensorDepQ[T1, T2] returns False if tensor T1 does not \
depend implicitly on tensor T2, an hence the variational derivative of T1 \
with respect to T2 is zero. This is the default behaviour for any two \
different tensors. The trivial subcase ImplicitTensorDepQ[T, T] returns True. \
Nontrivial tensor dependencies must be set by hand, if possible as upvalues \
for T1. \>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b7089e54-bbdc-4e59-a2a7-b06b20ac7fac"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.11. Canonicalization", \
"Subsubsection",ExpressionUUID->"9474cbc8-7886-496c-a61f-6cff24dd66dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Stripping", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToStripped", "::", "usage"}], "=", 
     "\"\<ToStripped[expr] returns the stripped form of the expression \
expr.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FromStripped", "::", "usage"}], "=", 
     "\"\<FromStripped[sexpr] converts back the stripped expression sexpr \
into a standard expression.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Stripped", "::", "usage"}], "=", 
     "\"\<Stripped[T, t][inds] represents the stripped form of the object t, \
of type T, with indices inds\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a51dcb92-0c22-4c35-b737-55adb0665756"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Monomials", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"BreakInMonomials", "::", "usage"}], "=", 
     "\"\<BreakInMonomials[expr] returns expr with terms separated into \
products of monomials (head Monomial) and scalars.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Monomial", "::", "usage"}], "=", 
     "\"\<Monomial[expr] represents a monomial (a product of objects sharing \
contracted indices).\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bde5172b-13b7-41fe-9518-734a1dffe815"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Canonicalization", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Symmetry", "::", "usage"}], "=", 
     "\"\<Symmetry is the head of symmetry expressions.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xSort", "::", "usage"}], "=", 
     "\"\<xSort[expr] returns a unique sorted form of the expression expr, \
using the internal Object notation.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UxSort", "::", "usage"}], "=", 
     "\"\<UxSort[object] converts back the object, given in internal Object \
notation, into a standard tensorial expression.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xSortPrecedence", "::", "usage"}], "=", 
     "\"\<xSortPrecedence[t] returns an integer value that determines the \
precedence of tensor t in xSort. Precedence values are sorted with Sort and \
hence smaller values correspond to earlier places in the sorted list.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "$MixedDers", "=", 
     "\"\<$MixedDers is a global variable stating whether the \
canonicalization process must take into account the fact that there are \
connections different from that of the metric. The initial default value is \
True.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "::", "usage"}], "=", 
     "\"\<ToCanonical[expr] gives a canonical reorganization of the tensors \
and their indices in expr, according to the symmetries of tensors and \
positions of dummies and repeated indices.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UseMetricOnVBundle", "::", "usage"}], "=", 
     "\"\<UseMetricOnVBundle is an option for ToCanonical giving the vector \
bundles where the (first) metric (if any) should be used in the process of \
canonicalization. Possible values for this option are All, None or a list of \
vector bundles.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ImposeSymmetry", "::", "usage"}], "=", 
     "\"\<ImposeSymmetry[expr, inds, GS] imposes the symmetry given by the \
generating set (or strong generating set) GS on the indices inds of \
expr.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xTensor`Symmetrize", "::", "usage"}], "=", 
     "\"\<Symmetrize[expr, {i1, ..., in}] symmetrizes the expr with respect \
to the n abstract indices i1, ..., in. By convention, the result has a factor \
1/n! multiplying. Symmetrize[expr] symmetrizes all free indices.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Antisymmetrize", "::", "usage"}], "=", 
     "\"\<Antisymmetrize[expr, {i1, ..., in}] antisymmetrizes the expr with \
respect to the n abstract indices i1, ..., in. By convention, the result has \
a factor 1/n! multiplying. Antisymmetrize[expr] antisymmetrizes all free \
indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PairSymmetrize", "::", "usage"}], "=", 
     "\"\<PairSymmetrize[expr, {{i1,j1}, ..., {in,jn}}] symmetrizes expr with \
respect to exchange of both indices among any two pairs, i.e., under \
simultaneous change of i3<->i7 and of j3<->j7.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PairAntisymmetrize", "::", "usage"}], "=", 
     "\"\<PairAntisymmetrize[expr, {{i1,j1}, ..., {in,jn}}] antisymmetrizes \
expr with respect to exchange of both indices among any two pairs, i.e., \
under simultaneous change of i3<->i7 and of j3<->j7.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Cyclize", "::", "usage"}], "=", 
     "\"\<Cyclize[expr, {i1, ..., in}] returns expr cyclizing the given \
indices. Note that the result depends on the order of the indices in the \
list.\>\""}], ";"}], " ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryOf", "::", "usage"}], "=", 
     "\"\<SymmetryOf[expr] gives a description (a result with head Symmetry) \
of the symmetry of the expression expr. This includes a generating set for \
that symmetry using Cycles notation on the indices of expr.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CommutePDs", "::", "usage"}], "=", 
     "\"\<CommutePDs is a Boolean option for SymmetryOf specifying whether it \
is possible or not to commute PD derivatives.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConstantMetric", "::", "usage"}], "=", 
     "\"\<ConstantMetric is a Boolean option for SymmetryOf specifying \
whether all derivatives should be considered to be metric compatible when \
determining the symmetry of an expression.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$CommuteCovDsOnScalars", "::", "usage"}], "=", 
     "\"\<$CommuteCovDsOnScalars is a Boolean global variable stating whether \
two non-torsion equal covds must be considered as commuting by SymmetryOf. \
The default initial variable is True.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"78992b5e-0804-4d49-8ce8-c72726c833f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Manipulation", " ", "of", " ", "Scalar"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "::", "usage"}], "=", 
     "\"\<NoScalar[expr] removes Scalar from expr, introducing new dummy \
indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BreakScalars", "::", "usage"}], "=", 
     "\"\<BreakScalars[expr] separates scalars inside a single Scalar head.\>\
\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PutScalar", "::", "usage"}], "=", 
     "\"\<PutScalar[expr] surrounds scalars with the head Scalar.\>\""}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f9419af4-a925-4c2a-a8ad-577ae3c1b00c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"STFPart", "::", "usage"}], "=", 
   "\"\<STFPart[expr, metric] returns the symmetric, trace-free part of expr \
with respect to all its free abstract indices. STFPart[expr, metric, indices] \
allows to specify a list of indices to symmetrize.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sym", "::", "usage"}], "=", 
   "\"\<Sym[expr, inds, sym] represents the symmetrization of the expression \
expr in the indices inds as given by the symmetry group sym. It plays a \
similar role to ImposeSymmetry, but without expanding the expression.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3b192183-e2e6-4d01-a457-45e11d3e3049"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.12. Metrics", \
"Subsubsection",ExpressionUUID->"bd1a511e-aab1-4baa-be87-68d2fc1e6fa1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Metrics", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DefMetric", "::", "usage"}], "=", 
     "\"\<DefMetric[signdet, metric[-a,-b], covd, covdsymbol] defines \
metric[-a, -b] with signdet 1 or -1 and associates the covariant derivative \
covd[-a] to it.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefProductMetric", "::", "usage"}], "=", 
     "\"\<DefProductMetric[metric[-a,-b], {{M1, scalar1[]}, ...}, covd, \
covdsymbol] defines the metric scalar1[]^2 metric1[-a,-b] + scalar2[]^2 \
metric2[-A,-B] + ... and its associated curvature tensors.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UndefMetric", "::", "usage"}], "=", 
     "\"\<UndefMetric[metric] undefines metric and all its associated \
servants.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FlatMetric", "::", "usage"}], "=", 
     "\"\<FlatMetric is a Boolean option for DefMetric specifying whether the \
defined metric is flat or not.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Inv", "::", "usage"}], "=", 
     "\"\<Inv is a prefix symbol used to define the inverse of a (frozen) \
metric or any linear operator (2-tensor).\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InducedFrom", "::", "usage"}], "=", 
     "\"\<InducedFrom is an option for DefMetric with form {G, v}, stating \
that the defined metric is actually the induced metric G on a codimension-1 \
hypersurface orthogonal to the non-null vector v (with respect to metric G). \
For a non-induced metric the option has the value Null, which is the default.\
\\n\\nInducedFrom[hmetric] returns the pair {G, v} from which the projected \
metric hmetric has been induced, or Null if hmetric is not an induced metric.\
\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConformalFactor", "::", "usage"}], "=", 
     "\"\<ConformalFactor[metric1, metric2] returns an scalar expression X \
such that the metrics are related by the conformal transformation \
metric1[-a,-b] = X metric2[-a,-b].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConformalRules", "::", "usage"}], "=", 
     "\"\<ConformalRules[tensor1, tensor2] returns a list of rules relating \
the given two tensors by a (general) conformal transformation. These rules \
are automatically stored by DefMetric when using the option ConformalTo. For \
other tensors the rules must be specified manually as a tagset for one of the \
tensors. ConformalRules[list1, list2] joins the lists of transformations for \
respective tensors in the lists, which hence must have the same \
length.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConformalTo", "::", "usage"}], "=", 
     "\"\<ConformalTo is an option for DefMetric with form {metexpr, \
confactor} specifying that the defined metric is conformal to the product of \
metexpr and confactor, the former a metric expression and the latter a scalar \
expression to be used as conformal factor.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetConformalTo", "::", "usage"}], "=", 
     "\"\<SetConformalTo[metric[-a, -b], {g[-a, -b], confactor}] declares \
metric[-a, -b] to be equal to confactor * g[-a, -b], that is they are metrics \
related by a conformal transformation. The conformal factor is stored as an \
upvalue for the head ConformalFactor, the conformal transformation is stored \
as an upvalue for ConformalRules, and the Christoffel relating their \
respective Levi-Civita connections is also stored.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"epsilonOrientationInBasis", "::", "usage"}], "=", 
     "\"\<epsilonOrientationInBasis is an option for DefMetric specifying a \
pair {basis, o} where o is the factor between the epsilon tensor of the \
metric being defined and the eta tensors of the given basis. By default this \
pair is {AIndex, $epsilonSign}.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"epsilonOrientation", "::", "usage"}], "=", 
     "\"\<epsilonOrientation[metric, basis] gives the factor between the \
epsilon tensor of metric and the eta tensors of basis. Its default value is \
$epsilonSign, for backward compatibility.\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FlatMetricQ", "::", "usage"}], "=", 
     "\"\<FlatMetricQ[metric] gives True if metric has been defined as a flat \
metric, or False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SignDetOfMetric", "::", "usage"}], "=", 
     "\"\<SignDetOfMetric[metric] gives the sign of the determinant of metric \
in real bases.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SignatureOfMetric", "::", "usage"}], "=", 
     "\"\<SignatureOfMetric[metric] gives the signature of the metric, in the \
form of a list of three elements: {p1s, m1s, zeros} giving the numbers of \
+1's, -1's and zeros, respectively, always in this order.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Determinant", "::", "usage"}], "=", 
     "\"\<Determinant[metric, basis][] returns the scalar density tensor \
(with weight +2 in basis) representing the determinant of metric with both \
indices expanded in the given basis. The tensor is defined if it does not \
exist yet. The default value for basis is AIndex.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovDOfMetric", "::", "usage"}], "=", 
     "\"\<CovDOfMetric[metric] gives the covariant derivative operator \
associated to metric at definition time. CovDOfMetric[metric, torsion] gives \
the covariant derivative operator associated to metric and having the given \
torsion tensor. Specifying Zero torsion returns the Levi-Civita connection of \
the metric.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundleOfMetric", "::", "usage"}], "=", 
     "\"\<VBundleOfMetric[metric] gives the vector bundle where metric lives, \
or an error if metric is not known.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContractMetric", "::", "usage"}], "=", 
     "\"\<ContractMetric[expr, metric] contracts all instances of metric in \
expr. If the second argument is a list of metrics the command is applied \
sequentially on expr. ContractMetric[expr] contracts all metrics.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OverDerivatives", "::", "usage"}], "=", 
     "\"\<OverDerivatives is a Boolean option for ContractMetric.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric", "::", "usage"}], "=", 
     "\"\<SeparateMetric[g, b][expr, i] separates the index i in the \
expression expr using the metric g and a dummy index in basis b. The default \
for b is AIndex, introducing an abstract index. The default for g is the \
first metric of the vbundle of the index i. The default for i is the list of \
indices in expr which do not have their natural character (that specified at \
definition time for tensors, or covariant for all derivatives).\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AllowUpperDerivatives", "::", "usage"}], "=", 
     "\"\<AllowUpperDerivatives is a Boolean option for ContractMetric. If \
True, an inverse metric can be contracted with a covariant derivative giving \
a derivative with a contravariant index. If False, that cannot be \
done.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToMetric", "::", "usage"}], "=", 
     "\"\<ChristoffelToMetric = ChristoffelToGradMetric. Kept for backwards \
compatibility.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "::", "usage"}], "=", 
     "\"\<ChristoffelToGradMetric[expr, metric] expands expr expressing all \
Christoffels of metric in terms of the metric. If the second argument is a \
list of metrics the command is applied sequentially on expr. \
ChristoffelToGradMetric[expr] expands all Christoffel symbols.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "::", "usage"}], "=", 
     "\"\<GradMetricToChristoffel[expr, metric, covd] expands expr expressing \
all covd-derivatives of metric as Christoffel tensors from the Levi-Civita \
connection of the metric to covd. If the second and/or third arguments are \
lists the command is applied sequentially on expr in all possible cases. \
GradMetricToChristoffel[expr, metric] expands to all defined covariant \
derivatives. GradMetricToChristoffel expands to all defined metrics and \
covariant derivatives.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradConformal", "::", "usage"}], "=", 
     "\"\<ChristoffelToGradConformal[expr, metric1, metric2] expands expr \
expressing all Christoffel[covd1, covd2], where covdi is the Levi-Civita \
connection of metrici, in terms of derivatives (using covd2) of the conformal \
factor relating those metrics. The covariant derivatives covdi can be used in \
input instead of the metrici.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricToProjector", "::", "usage"}], "=", 
     "\"\<MetricToProjector[expr, metric] expands expr expressing the metric \
tensor in terms of a projector and its orthogonal vector field. If the second \
argument is a list of metrics the command is applied sequentially on expr. \
MetricToProjector[expr] expands all metric tensors.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ProjectorToMetric", "::", "usage"}], "=", 
     "\"\<ProjectorToMetric[expr, proj] expands expr expressing the projector \
proj in terms of the corresponding metric and orthogonal vector field. If the \
second argument is a list of projectors the command is applied sequentially \
on expr. ProjectorToMetric[expr] expands all projectors.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProjectWith", "::", "usage"}], "=", 
     "\"\<ProjectWith[projector][expr] projects all free indices of \
expression using the given projector. Note the double pair of brackets, which \
simplifies the replacement of the projecting inert head with the actual \
projecting function using a rule like ih -> ProjectWith[proj].\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradNormalToExtrinsicK", "::", "usage"}], "=", 
     "\"\<GradNormalToExtrinsicK[expr, imetric] transforms the derivatives of \
the normal vector to the induced metric imetric into extrinsic curvature \
tensors. If the second argument is a list then the function is applied \
sequentially on all elements. GradNormalToExtrinsicK[expr] expands all \
induced metrics.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExtrinsicKToGradNormal", "::", "usage"}], "=", 
     "\"\<ExtrinsicKToGradNormal[expr, imetric] transforms the extrinsic \
curvature tensors associated to the induced metric imetric into derivatives \
of its normal vector. If the second argument is a list then the function is \
folded sequentially on all elements. ExtrinsicKToGradNormal[expr] expands all \
induced metrics.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProjectDerivative", "::", "usage"}], "=", 
     "\"\<ProjectDerivative[expr, cd] converts the induced derivative cd into \
the original derivative but projected. If the second argument is a list then \
the function is folded sequentially on all elements. ProjectDerivative[expr] \
converts all induced derivatives.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InducedDecomposition", "::", "usage"}], "=", 
     "\"\<InducedDecomposition[expr, {imetric, vector}] decomposes the \
tensors in expr in their longitudinal and transversal parts with respect to \
the induced metric imetric and its orthogonal vector.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToInducedDerivative", "::", "usage"}], "=", 
     "\"\<\!\(\*StyleBox[\"ToInducedDerivative\",FontFamily->\"Courier\"]\)[\
expr, supercd, cd] converts the supercd-derivatives into the sum of an \
induced cd-derivative, a Lie derivative along the orthogonal vector of the \
projection and additional extrinsic curvature terms.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VectorOfInducedMetric", "::", "usage"}], "=", 
     "\"\<VectorOfInducedMetric[metric] returns the vector to which the \
induced metric is orthogonal.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GaussCodazzi", "::", "usage"}], "=", 
     "\"\<GaussCodazzi[expr, imetric] projects curvature tensors of the \
Levi-Civita connection of the metric from which imetric is induced into their \
projected components.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Product", " ", "metrics"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricScalar", "::", "usage"}], "=", 
     "\"\<MetricScalar[metric, subvbundle] gives the scalar that relates \
metric (of a product manifold) with the metric of the subvbundle.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpandProductMetric", "::", "usage"}], "=", 
     "\"\<ExpandProductMetric[expr, metric] expands expr decomposing all \
instances of the product metric and its derived curvature tensors in terms of \
the objects of the subvbundle that form the vbundle of metric. If the second \
argument is a list of product metrics the command is applied sequentially on \
expr.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d8de0315-27f1-44e8-afa8-0576c9216e42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tetra", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Tetra", "::", "usage"}], "=", 
     "\"\<Tetra[metric] returns the name of the tetra-metric associated to \
metric.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TetraRule", "::", "usage"}], "=", 
     "\"\<TetraRule[metric] gives the list of rules translating the \
tetra-metric of metric into products of metric and an imaginary term with the \
volume form of metric.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"248cc3fe-ae5e-4ff3-9a91-34ff298d4d24"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.13. Calculations", \
"Subsubsection",ExpressionUUID->"5ddc1620-dd11-46a7-aa54-4cc2603d915f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Calculations", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ScreenDollarIndices", "::", "usage"}], "=", 
     "\"\<ScreenDollarIndices[expr] replaces internal dummies \
(dollar-indices) by new non-dollar dummies for output.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Simplification", "::", "usage"}], "=", 
     "\"\<Simplification[expr] simplifies expr by calling Simplify[ \
ToCanonical[expr] ].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Validate", "::", "usage"}], "=", 
     "\"\<Validate[expr] checks that the tensorial expression expr 1) does \
not have unknown heads, 2) does not have objects with invalid index \
structure, 3) does have homogeneous free indices and 4) does not have \
repeated indices. There is a wrapping Catch.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"UncatchedValidate", "::", "usage"}], "=", 
      "\"\<UncatchedValidate[expr] is equivalente to Validate[expr] but \
without the wrapping Catch.\>\""}], ";"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexSolve", "::", "usage"}], "=", 
     "\"\<IndexSolve[eqn, tensor] solves a linear equation eqn for tensor, \
returning a rule (see MakeRule). Currently that tensor cannot have contracted \
indices. Options to IndexSolve are understood as options to MakeRule.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient", "::", "usage"}], "=", 
     "\"\<IndexCoefficient[expr, form] gives the coefficient of form (any \
indexed object with no division present) in expr.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeFreeIndices", "::", "usage"}], "=", 
     "\"\<ChangeFreeIndices[expr, newfrees] changes the free indices in expr \
(after sorting them with IndexSort) by indices in the list newfrees, changing \
the dummies of expr which could interfere with any of those new \
indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EqualExpressionsQ", "::", "usage"}], "=", 
     "\"\<EqualExpressionsQ[expr1, expr2] returns True if there is a \
permutation of the free indices of expr1 such that its canonical form equals \
that of expr2, and False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCollect", "::", "usage"}], "=", 
     "\"\<IndexCollect[expr, form, function] imitates the action of Collect, \
but allowing indexed expressions in form. This is still a very limited \
function, almost experimental.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetCharacters", "::", "usage"}], "=", 
     "\"\<SetCharacters[expr, tensor, chars] returns expr with all instances \
of tensor[inds] corrected to match the characters chars, a list of elements \
Up or Down. The command introduces deltas, which automatically transform into \
metrics or Basis objects if required.\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d558edca-40c5-4b1d-9f67-ef1d3d05a4dd"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.1.14. Color terms", \
"Subsubsection",ExpressionUUID->"e7f06f35-2484-4bb2-b7bf-8bd7aea13d2f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ColorTerms", "::", "usage"}], "=", 
   "\"\<ColorTerms[expr] uses the function ColorPositions (from the package \
ExpressionManipulation) to color the elements of the first level of expr, \
tagging them with their respective positions.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ColorPositionsOfPattern", "::", "usage"}], "=", 
   "\"\<ColoPositionsOfPattern[pattern][expr] uses the function \
ColorPositions (from the package ExpressionManipulation) to color the \
occurrences of pattern in expr, tagging them with their respective positions. \
Options can be passed to ColorPositions within the first pair of \
brackets.\>\""}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9b12c593-728f-46a8-9bb9-91c715e6d50a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.2. Begin Private", \
"Subsection",ExpressionUUID->"2f6fcf10-6acd-4368-80ee-dce444ee7a86"],

Cell[CellGroupData[{

Cell[TextData[{
 "1.2.1. A ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 5 bug with contexts. Fixed in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 6. Now deactivated"
}], "Subsubsection",ExpressionUUID->"5df3c2dd-a7fe-4ccd-9105-f4cc0d61d6c1"],

Cell["Nothing here goes into the package.", \
"Text",ExpressionUUID->"cca46c39-53f7-4ae8-b47e-dcdaa5bf0abf"],

Cell["\<\
Currently there are four contexts in the $ContextPath. Note that none of them \
is Global`.\
\>", "Text",ExpressionUUID->"7f20aedb-bbe0-46a1-9478-01178904958c"],

Cell[CellGroupData[{

Cell[BoxData["$ContextPath"], "Input",
 Evaluatable->False,ExpressionUUID->"89e92be6-6159-4b2a-960b-792e36b38b4c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`\"\>", ",", "\<\"xAct`xCore`\"\>", 
   ",", "\<\"xAct`xPerm`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"fe4b4895-2864-4875-8254-a2c66f0c2c2e"]
}, Open  ]],

Cell["\<\
and the current context is (because we are constructing the package)\
\>", "Text",ExpressionUUID->"31719b88-e9c1-4777-b776-8b764d8caf99"],

Cell[CellGroupData[{

Cell[BoxData["$Context"], "Input",
 Evaluatable->False,ExpressionUUID->"2e7b557c-445d-40c4-9143-24a10edb5fc1"],

Cell[BoxData["\<\"xAct`xTensor`\"\>"], \
"Output",ExpressionUUID->"fb4bc73c-e3d1-4b64-a761-471b40c21953"]
}, Open  ]],

Cell[TextData[{
 "There is a bug in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 5 (solved in 6). It creates symbols in $Context even if they already \
exists in one of the contexts of $ContextPath:"
}], "Text",ExpressionUUID->"d0e8a9a5-2a63-4bf3-8d57-5c6a78e02b95"],

Cell["Note the contexts of the five capitals:", \
"Text",ExpressionUUID->"0046e5fa-8c53-4030-835f-1939d4a22d72"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Context", "/@", 
  RowBox[{"{", 
   RowBox[{"C", ",", "D", ",", "K", ",", "N", ",", "O"}], "}"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"46a9195f-db0f-4309-b58d-c8c8c9aa3996"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"System`\"\>", ",", "\<\"System`\"\>", ",", "\<\"System`\"\>", 
   ",", "\<\"System`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"5ea7865a-f5c6-4d28-a2dc-72f77ec35953"]
}, Open  ]],

Cell["\<\
For reference, let us introduce capitals A and B. Capital A is defined in the \
package context:\
\>", "Text",ExpressionUUID->"bfc7903c-3639-4047-bfbf-32338a23d4f9"],

Cell[CellGroupData[{

Cell[BoxData["A"], "Input",
 Evaluatable->False,ExpressionUUID->"7a1d32aa-5a12-4f86-a0de-c91983ec2e7c"],

Cell[BoxData["A"], \
"Output",ExpressionUUID->"e5af9785-bfb2-4e24-a06e-4976cfdb5ada"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Context", "[", "A", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"e8d79b9f-3c3c-4e99-a851-c10c56a400b2"],

Cell[BoxData["\<\"xAct`xTensor`\"\>"], \
"Output",ExpressionUUID->"56998aa1-507f-452f-9c05-ea1a28678b10"]
}, Open  ]],

Cell["Now we start the Private` context:", \
"Text",ExpressionUUID->"f55ac99e-2875-4495-a9dc-b2c0335637f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"857c8ab2-3832-436c-bcf2-83df4231476e"],

Cell[BoxData["\<\"xAct`xTensor`Private`\"\>"], \
"Output",ExpressionUUID->"a801f4f6-5752-4008-b682-f6cde08fa528"]
}, Open  ]],

Cell["That changes the current $Context:", \
"Text",ExpressionUUID->"26bac830-a939-4324-82fd-05f05eab1a82"],

Cell[CellGroupData[{

Cell[BoxData["$Context"], "Input",
 Evaluatable->False,ExpressionUUID->"dcda3b21-d1b2-4df2-a978-15c157b00406"],

Cell[BoxData["\<\"xAct`xTensor`Private`\"\>"], \
"Output",ExpressionUUID->"3c3adc0f-5598-451f-a7b8-5b1f504d906d"]
}, Open  ]],

Cell["but not the $ContextPath:", \
"Text",ExpressionUUID->"7783a0ec-d2d6-49ab-b077-78f2f8779954"],

Cell[CellGroupData[{

Cell[BoxData["$ContextPath"], "Input",
 Evaluatable->False,ExpressionUUID->"826dabe9-73d7-4c82-b591-2611b983d54a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`\"\>", ",", "\<\"xAct`xCore`\"\>", 
   ",", "\<\"xAct`xPerm`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"77ef610e-fb2b-4ffa-bc0e-78fc16afe240"]
}, Open  ]],

Cell["Capital B is now defined in the Private context:", \
"Text",ExpressionUUID->"f6bec1c3-8907-46ff-baf3-da069d78beb5"],

Cell[CellGroupData[{

Cell[BoxData["B"], "Input",
 Evaluatable->False,ExpressionUUID->"d2a552c6-9e83-4978-9a14-a2f06382b309"],

Cell[BoxData["B"], \
"Output",ExpressionUUID->"733c44d3-92b0-4e49-a905-83b4ee274755"]
}, Open  ]],

Cell["Therefore these three are all different:", \
"Text",ExpressionUUID->"2d853900-9858-4617-b71f-d0820f63f088"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Context", "/@", 
  RowBox[{"{", 
   RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"9ca03be1-b015-46ef-9f58-79bd8d257139"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`\"\>", ",", "\<\"xAct`xTensor`Private`\"\>", ",", 
   "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"9f88c72b-cd4b-4e15-9305-87c8aba2513c"]
}, Open  ]],

Cell["The problem is that if we do", \
"Text",ExpressionUUID->"2f83e430-2484-43c0-b040-4261f1492fb8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "A$", ",", "B$", ",", "C$", ",", "D$", ",", "K$", ",", "N$", ",", "O$"}], 
    "}"}], ",", 
   RowBox[{"Print", "[", 
    RowBox[{"{", 
     RowBox[{
     "A$", ",", "B$", ",", "C$", ",", "D$", ",", "K$", ",", "N$", ",", "O$"}],
      "}"}], "]"}]}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"bda149be-a028-47ec-acc3-8987c756d8d8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A$476", ",", "B$476", ",", "C$476", ",", "D$476", ",", "K$476", ",", 
   "N$476", ",", "O$476"}], 
  "}"}]], "Print",ExpressionUUID->"603e5239-4184-46a8-a363-c312885bd314"]
}, Open  ]],

Cell[TextData[{
 "This was the result with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 5:"
}], "Text",ExpressionUUID->"251e1611-a798-4026-86d8-0a2696644c0a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Context", "/@", 
  RowBox[{"{", 
   RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "K", ",", "N", ",", "O"}], 
   "}"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"dbd4dfb7-8f22-4455-959b-d1ef2d08c8d9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`Private`\"\>", 
   ",", "\<\"xAct`xTensor`Private`\"\>", ",", "\<\"xAct`xTensor`Private`\"\>",
    ",", "\<\"xAct`xTensor`Private`\"\>", 
   ",", "\<\"xAct`xTensor`Private`\"\>", ",", "\<\"xAct`xTensor`Private`\"\>",
    ",", "\<\"xAct`xTensor`Private`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"afaccd5d-ac8d-4406-88b5-23327d78cb3e"]
}, Open  ]],

Cell["Now it is", \
"Text",ExpressionUUID->"0ef30433-8b75-4ac3-952b-9fd591dd743f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Context", "/@", 
  RowBox[{"{", 
   RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "K", ",", "N", ",", "O"}], 
   "}"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"e7b32e1a-26af-4bee-9cc6-729edab4e14a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`\"\>", ",", "\<\"xAct`xTensor`Private`\"\>", 
   ",", "\<\"System`\"\>", ",", "\<\"System`\"\>", ",", "\<\"System`\"\>", 
   ",", "\<\"System`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"05f95cb6-265d-4689-bda0-72fba39dbdbc"]
}, Open  ]],

Cell[TextData[{
 "We see that symbols without dollar have been created in the \
xAct`xTensor`Private` context (the current $Context). It seems that the \
dollars in the variables in the Module list have been removed because the \
ouput variables contain just a single $ and not two, as I would have \
expected. I think this is a bug because it didn't happen in the previous 4.* \
versions of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". Developers from Wolfram Research Inc. tell me that you are not supposed \
to use something like C$ in the Module list, but I really want to do it. This \
problem is present in all 5.* versions of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " and has been solved in 6.0."
}], "Text",ExpressionUUID->"a3dc3cde-f6fc-43d9-94db-8b189fa4d7c2"],

Cell["\<\
The most important consequence of this is that now the System` variables are \
shadowed by the xAct`xTensor`Private` symbols. If we now try to take a \
derivative nothing happens because D here is xAct`xTensor`Private`D and not \
System`D:\
\>", "Text",ExpressionUUID->"af36da0c-1f8b-4a27-b202-a9a93956d6e8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", "x"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"ec486950-f05c-4f9c-85cc-9f3d83645ccf"],

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", "x"}], 
  "]"}]], "Output",ExpressionUUID->"c30f93f1-b43f-41fe-859a-5d8d8488b543"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", "x"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"8cdf9c33-a35d-469b-ab81-f2815a3ebbb1"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["f", "\[Prime]",
   MultilineFunction->None], "[", "x", 
  "]"}]], "Output",ExpressionUUID->"3282b397-f675-4aad-8d75-00f4b951ec8e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"System`D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", "x"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"f0e66425-a59e-4deb-9fe0-555ed7d11f88"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["f", "\[Prime]",
   MultilineFunction->None], "[", "x", 
  "]"}]], "Output",ExpressionUUID->"5fb43d33-013c-45b8-958e-2bffaacea23c"]
}, Open  ]],

Cell["Clean up:", \
"Text",ExpressionUUID->"5cac0b31-4dfb-4342-88d3-face46143e02"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "K", ",", "N", ",", "O"}], 
  "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"39893b17-5018-433c-9729-f6210236aa1d"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"xAct`xTensor`A", ",", "xAct`xTensor`Private`B"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"32aa3a0a-252c-4030-a0de-6297cfef071e"],

Cell["Now we get again", \
"Text",ExpressionUUID->"9d8a71e0-8e22-48ef-a38c-97533ad76cdb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Context", "/@", 
  RowBox[{"{", 
   RowBox[{"C", ",", "D", ",", "K", ",", "N", ",", "O"}], "}"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"1ba4023f-ea39-4312-b92f-4122fcb25562"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"System`\"\>", ",", "\<\"System`\"\>", ",", "\<\"System`\"\>", 
   ",", "\<\"System`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"46360a44-b7e6-45eb-8b37-f49a8a3c4f44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"d461b865-f3ba-45cd-970e-58a683dba9eb"],

Cell[BoxData["\<\"xAct`xTensor`Private`\"\>"], \
"Output",ExpressionUUID->"bc2004d9-7738-4a1c-ad77-f08a44e42a8b"]
}, Open  ]],

Cell[TextData[{
 "This problem is closely related to the problem of the most appropriate \
context for the capitals C, D, K, N, O. The fact that ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " might generate new symbols in the $Context means that probably this is the \
best place to put those symbols when they are indices. During a normal \
session that context will be Global`. Therefore my recommendation is to \
define indices Global`D, etc, and then use System`D when a derivative is \
required. However, ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " will be prepared below to overload the system capitals, and that will be \
the default option if the user doesn't worry about this problem."
}], "Text",ExpressionUUID->"2ff7f469-c63d-44a9-bf5e-0bfdd64d7d95"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.2.2. Begin Private", \
"Subsubsection",ExpressionUUID->"5b4e3b60-0d98-41c4-a151-6240503fd2b5"],

Cell["Now we do start the private context:", \
"Text",ExpressionUUID->"4ced89d9-e7ef-4743-abe3-f9ad77ead3d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"eb9464c6-cc59-407c-96ac-b6a46bc918e9"],

Cell[BoxData["\<\"xAct`xTensor`Private`\"\>"], \
"Output",ExpressionUUID->"bfdd50c6-b207-4007-86d4-62c50c7d37de"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.2.3. Context for the examples", \
"Subsubsection",ExpressionUUID->"cbe5e463-4e02-40f4-aed6-64e00f1bf1ec"],

Cell["\<\
In this notebook we shall follow this convention: examples are carried out in \
the Global` context, before ending the package, and therefore it is not \
possible to access xAct`xTensor`Private`  unless we append it to the \
$ContextPath:\
\>", "Text",ExpressionUUID->"db69a5d8-4b59-4c6e-9e48-ef6a55dbd46c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginExamples", "[", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Set", "[", 
     RowBox[{"$Context", ",", "\"\<Global`\>\""}], "]"}], ";", 
    RowBox[{"Global`symbols", "=", 
     RowBox[{"Names", "[", "\"\<Global`*\>\"", "]"}]}], ";", "Null"}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Global`EndExamples", "[", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"#", "=!=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<There are new symbols in Global`:\>\"", ",", "#"}], 
         "]"}]}], "]"}], ";", 
      RowBox[{"Set", "[", 
       RowBox[{"$Context", ",", "\"\<xAct`xTensor`Private`\>\""}], "]"}], ";",
       "Null"}], ")"}], "&"}], "@", 
   RowBox[{"Complement", "[", 
    RowBox[{
     RowBox[{"Names", "[", "\"\<Global`*\>\"", "]"}], ",", "Global`symbols"}],
     "]"}]}]}]}], \
"Input",ExpressionUUID->"475ba399-6f88-446e-9f69-3d31fcf0e0b0"],

Cell["\<\
The only problem is that writing xAct`xTensor`Private is rather long. We \
define (ONLY IN THIS NOTEBOOK):\
\>", "Text",ExpressionUUID->"68268c91-77eb-4885-a108-030f8753dcde"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$PreRead", "=", 
  RowBox[{
   RowBox[{"ReplaceAll", "[", 
    RowBox[{"#", ",", 
     RowBox[{"expr_String", "\[RuleDelayed]", 
      RowBox[{"StringReplace", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"\"\<xATP\>\"", "\[Rule]", "\"\<xAct`xTensor`Private\>\""}]}],
        "]"}]}]}], "]"}], 
   "&"}]}]], "Input",ExpressionUUID->"e2d189e3-c393-4d81-94d5-c482e8118223"],

Cell[BoxData[
 RowBox[{
  RowBox[{"#1", "/.", "\[VeryThinSpace]", 
   RowBox[{"expr_String", "\[RuleDelayed]", 
    RowBox[{"StringReplace", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"\<\"xATP\"\>", "\[Rule]", "\<\"xAct`xTensor`Private\"\>"}]}], 
     "]"}]}]}], 
  "&"}]], "Output",ExpressionUUID->"e71bbf96-02fb-4cb2-9905-158e231967a2"]
}, Open  ]],

Cell[TextData[{
 "The global variable $PreRead is not used by any of the ",
 StyleBox["xAct",
  FontSlant->"Italic"],
 " packages. I find it too dangerous."
}], "Text",ExpressionUUID->"cf09f6d4-47f1-4683-abd9-4dac6a589675"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3. Usage of functions. Private", \
"Subsection",ExpressionUUID->"7f4d5ad6-8d43-4823-a270-1c06947067dc"],

Cell["All these usage messages do not go into the package.", \
"Text",ExpressionUUID->"18f59468-65e4-4a5a-830c-9e1a64e51c15"],

Cell[CellGroupData[{

Cell["1.3.1. Counting public symbols", \
"Subsubsection",ExpressionUUID->"e553feb1-a6a7-4f22-bcad-c5128e9ad71d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$xTensorNames", "=", 
   RowBox[{"Names", "[", "\"\<xAct`xTensor`*\>\"", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"05c36e7c-c745-40e1-9f30-5b774432d2f5"],

Cell[CellGroupData[{

Cell[BoxData["$xTensorNames"], \
"Input",ExpressionUUID->"a1d986be-6c64-4abe-97e1-a8d05d3069aa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ABIndexQ\"\>", ",", "\<\"AbstractIndex\"\>", 
   ",", "\<\"AbstractIndexQ\"\>", ",", "\<\"Acceleration\"\>", 
   ",", "\<\"AChristoffel\"\>", ",", "\<\"AddIndices\"\>", 
   ",", "\<\"AIndex\"\>", ",", "\<\"AIndexQ\"\>", 
   ",", "\<\"AllowUpperDerivatives\"\>", ",", "\<\"Anticommutator\"\>", 
   ",", "\<\"Antihermitian\"\>", ",", "\<\"AntihermitianQ\"\>", 
   ",", "\<\"Antisymmetrize\"\>", ",", "\<\"AnyDependencies\"\>", 
   ",", "\<\"AnyIndices\"\>", ",", "\<\"AnyVBundles\"\>", 
   ",", "\<\"AssociativeProductQ\"\>", ",", "\<\"At\"\>", 
   ",", "\<\"AutomaticRules\"\>", ",", "\<\"BaseOfVBundle\"\>", 
   ",", "\<\"Basis\"\>", ",", "\<\"BasisQ\"\>", ",", "\<\"BCIndexQ\"\>", 
   ",", "\<\"BIndex\"\>", ",", "\<\"BIndexQ\"\>", ",", "\<\"Blocked\"\>", 
   ",", "\<\"BlockedQ\"\>", ",", "\<\"Bracket\"\>", 
   ",", "\<\"BracketToCovD\"\>", ",", "\<\"BreakChristoffel\"\>", 
   ",", "\<\"BreakInMonomials\"\>", ",", "\<\"BreakScalars\"\>", 
   ",", "\<\"CartesianProduct\"\>", ",", "\<\"CDIndexQ\"\>", 
   ",", "\<\"ChangeCovD\"\>", ",", "\<\"ChangeCurvature\"\>", 
   ",", "\<\"ChangeFreeIndices\"\>", ",", "\<\"ChangeIndex\"\>", 
   ",", "\<\"ChangeTorsion\"\>", ",", "\<\"Chart\"\>", ",", "\<\"ChartQ\"\>", 
   ",", "\<\"CheckZeroDerivative\"\>", 
   ",", "\<\"CheckZeroDerivativeStart\"\>", 
   ",", "\<\"CheckZeroDerivativeStop\"\>", ",", "\<\"Christoffel\"\>", 
   ",", "\<\"ChristoffelToGradConformal\"\>", 
   ",", "\<\"ChristoffelToGradMetric\"\>", ",", "\<\"ChristoffelToMetric\"\>",
    ",", "\<\"CIndex\"\>", ",", "\<\"CIndexForm\"\>", ",", "\<\"CIndexQ\"\>", 
   ",", "\<\"ColorPositionsOfPattern\"\>", ",", "\<\"ColorTerms\"\>", 
   ",", "\<\"CommutativityOfProduct\"\>", ",", "\<\"Commutator\"\>", 
   ",", "\<\"CommuteCovDs\"\>", ",", "\<\"CommutePDs\"\>", 
   ",", "\<\"ConformalFactor\"\>", ",", "\<\"ConformalRules\"\>", 
   ",", "\<\"ConformalTo\"\>", ",", "\<\"ConstantMetric\"\>", 
   ",", "\<\"ConstantQ\"\>", ",", "\<\"ConstantSymbol\"\>", 
   ",", "\<\"ConstantSymbolQ\"\>", ",", "\<\"ContractCurvature\"\>", 
   ",", "\<\"ContractDir\"\>", ",", "\<\"ContractMetric\"\>", 
   ",", "\<\"ContractMetrics\"\>", ",", "\<\"ContractProjector\"\>", 
   ",", "\<\"ContractThrough\"\>", ",", "\<\"ContractThroughQ\"\>", 
   ",", "\<\"CovD\"\>", ",", "\<\"CovDOfMetric\"\>", ",", "\<\"CovDQ\"\>", 
   ",", "\<\"CovDToChristoffel\"\>", ",", "\<\"Curvature\"\>", 
   ",", "\<\"CurvatureQ\"\>", ",", "\<\"CurvatureRelations\"\>", 
   ",", "\<\"Cyclize\"\>", ",", "\<\"Dagger\"\>", ",", "\<\"DaggerIndex\"\>", 
   ",", "\<\"DaggerQ\"\>", ",", "\<\"DefAbstractIndex\"\>", 
   ",", "\<\"DefConstantSymbol\"\>", ",", "\<\"DefCovD\"\>", 
   ",", "\<\"DefineCommutator\"\>", ",", "\<\"DefInertHead\"\>", 
   ",", "\<\"DefInfo\"\>", ",", "\<\"DefManifold\"\>", 
   ",", "\<\"DefMapping\"\>", ",", "\<\"DefMetric\"\>", 
   ",", "\<\"DefParameter\"\>", ",", "\<\"DefProduct\"\>", 
   ",", "\<\"DefProductMetric\"\>", ",", "\<\"DefScalarFunction\"\>", 
   ",", "\<\"DefTensor\"\>", ",", "\<\"DefVBundle\"\>", ",", "\<\"delta\"\>", 
   ",", "\<\"DependenciesOf\"\>", ",", "\<\"DependenciesOfCovD\"\>", 
   ",", "\<\"DependenciesOfInertHead\"\>", 
   ",", "\<\"DependenciesOfTensor\"\>", ",", "\<\"Determinant\"\>", 
   ",", "\<\"DiffeomorphismQ\"\>", ",", "\<\"DimOfManifold\"\>", 
   ",", "\<\"DimOfVBundle\"\>", ",", "\<\"DIndex\"\>", ",", "\<\"DIndexQ\"\>",
    ",", "\<\"Dir\"\>", ",", "\<\"DirCovDToLieD\"\>", 
   ",", "\<\"Disclaimer\"\>", ",", "\<\"DisjointManifoldsQ\"\>", 
   ",", "\<\"DisjointVBundlesQ\"\>", ",", "\<\"DisorderedPairQ\"\>", 
   ",", "\<\"Down\"\>", ",", "\<\"DownIndex\"\>", ",", "\<\"DownIndexQ\"\>", 
   ",", "\<\"DownVectorQ\"\>", ",", "\<\"Dummy\"\>", ",", "\<\"DummyAs\"\>", 
   ",", "\<\"DummyIn\"\>", ",", "\<\"EIndexQ\"\>", ",", "\<\"Einstein\"\>", 
   ",", "\<\"EinsteinToRicci\"\>", ",", "\<\"EmptyManifold\"\>", 
   ",", "\<\"epsilon\"\>", ",", "\<\"epsilonOrientation\"\>", 
   ",", "\<\"epsilonOrientationInBasis\"\>", ",", "\<\"EqualExpressionsQ\"\>",
    ",", "\<\"ERROR\"\>", ",", "\<\"ExpandCommutator\"\>", 
   ",", "\<\"ExpandGdelta\"\>", ",", "\<\"ExpandProductMetric\"\>", 
   ",", "\<\"ExpandPullBack\"\>", ",", "\<\"ExpandPushForward\"\>", 
   ",", "\<\"ExpandSdelta\"\>", ",", "\<\"Explode\"\>", 
   ",", "\<\"ExtendedFrom\"\>", ",", "\<\"ExtrinsicK\"\>", 
   ",", "\<\"ExtrinsicKToGradNormal\"\>", ",", "\<\"FindAllOfType\"\>", 
   ",", "\<\"FindBlockedIndices\"\>", ",", "\<\"FindDummyIndices\"\>", 
   ",", "\<\"FindFreeIndices\"\>", ",", "\<\"FindIndices\"\>", 
   ",", "\<\"FirstDerQ\"\>", ",", "\<\"FlatMetric\"\>", 
   ",", "\<\"FlatMetricQ\"\>", ",", "\<\"ForceSymmetries\"\>", 
   ",", "\<\"Free\"\>", ",", "\<\"FRiemann\"\>", ",", "\<\"FrobeniusQ\"\>", 
   ",", "\<\"FromMetric\"\>", ",", "\<\"FromProjected\"\>", 
   ",", "\<\"FromStripped\"\>", ",", "\<\"FromTensorDerivative\"\>", 
   ",", "\<\"GaussCodazzi\"\>", ",", "\<\"Gdelta\"\>", 
   ",", "\<\"GetIndicesOfVBundle\"\>", ",", "\<\"GIndexQ\"\>", 
   ",", "\<\"GiveOutputString\"\>", ",", "\<\"GiveSymbol\"\>", 
   ",", "\<\"Grade\"\>", ",", "\<\"GradedProductQ\"\>", 
   ",", "\<\"GradeOfCovD\"\>", ",", "\<\"GradeOfProduct\"\>", 
   ",", "\<\"GradeOfTensor\"\>", ",", "\<\"GradMetricToChristoffel\"\>", 
   ",", "\<\"GradNormalToExtrinsicK\"\>", ",", "\<\"HeadOfTensor\"\>", 
   ",", "\<\"Hermitian\"\>", ",", "\<\"HermitianQ\"\>", 
   ",", "\<\"HostsOf\"\>", ",", "\<\"IdentityElementOfProduct\"\>", 
   ",", "\<\"IdentityMapping\"\>", ",", "\<\"Imaginary\"\>", 
   ",", "\<\"ImmersionQ\"\>", ",", "\<\"IModQ\"\>", 
   ",", "\<\"ImplicitTensorDepQ\"\>", ",", "\<\"Implode\"\>", 
   ",", "\<\"ImposeSymmetry\"\>", ",", "\<\"IndexCoefficient\"\>", 
   ",", "\<\"IndexCollect\"\>", ",", "\<\"IndexForm\"\>", 
   ",", "\<\"IndexList\"\>", ",", "\<\"IndexOrderedQ\"\>", 
   ",", "\<\"IndexRange\"\>", ",", "\<\"IndexRule\"\>", 
   ",", "\<\"IndexRuleDelayed\"\>", ",", "\<\"IndexSet\"\>", 
   ",", "\<\"IndexSetDelayed\"\>", ",", "\<\"IndexSolve\"\>", 
   ",", "\<\"IndexSort\"\>", ",", "\<\"IndicesOf\"\>", 
   ",", "\<\"IndicesOfVBundle\"\>", ",", "\<\"InducedDecomposition\"\>", 
   ",", "\<\"InducedFrom\"\>", ",", "\<\"InertHead\"\>", 
   ",", "\<\"InertHeadQ\"\>", ",", "\<\"Inv\"\>", 
   ",", "\<\"InverseMapping\"\>", ",", "\<\"InvertibleQ\"\>", 
   ",", "\<\"IsIndexOf\"\>", ",", "\<\"Keep\"\>", ",", "\<\"Kretschmann\"\>", 
   ",", "\<\"Labels\"\>", ",", "\<\"LastIndex\"\>", ",", "\<\"LC\"\>", 
   ",", "\<\"Leibnitz\"\>", ",", "\<\"LI\"\>", ",", "\<\"LieD\"\>", 
   ",", "\<\"LieDToCovD\"\>", ",", "\<\"LIndex\"\>", ",", "\<\"LIndexQ\"\>", 
   ",", "\<\"LinearPush\"\>", ",", "\<\"LinearQ\"\>", 
   ",", "\<\"MakeProjectors\"\>", ",", "\<\"MakeRule\"\>", 
   ",", "\<\"Manifold\"\>", ",", "\<\"ManifoldBoundary\"\>", 
   ",", "\<\"ManifoldOfCovD\"\>", ",", "\<\"ManifoldQ\"\>", 
   ",", "\<\"ManifoldsOf\"\>", ",", "\<\"Mapping\"\>", 
   ",", "\<\"MappingDomain\"\>", ",", "\<\"MappingImage\"\>", 
   ",", "\<\"MappingQ\"\>", ",", "\<\"Master\"\>", ",", "\<\"MasterOf\"\>", 
   ",", "\<\"Metric\"\>", ",", "\<\"MetricEndowedQ\"\>", 
   ",", "\<\"MetricOfCovD\"\>", ",", "\<\"MetricOn\"\>", 
   ",", "\<\"MetricQ\"\>", ",", "\<\"MetricScalar\"\>", 
   ",", "\<\"MetricsOfVBundle\"\>", ",", "\<\"MetricToProjector\"\>", 
   ",", "\<\"Monomial\"\>", ",", "\<\"MultiplyHead\"\>", 
   ",", "\<\"NewIndexIn\"\>", ",", "\<\"NoScalar\"\>", 
   ",", "\<\"OrthogonalTo\"\>", ",", "\<\"OrthogonalToVectorQ\"\>", 
   ",", "\<\"OrthogonalWithMetric\"\>", ",", "\<\"OtherDependencies\"\>", 
   ",", "\<\"OverDerivatives\"\>", ",", "\<\"Pair\"\>", 
   ",", "\<\"PairAntisymmetrize\"\>", ",", "\<\"PairQ\"\>", 
   ",", "\<\"PairSymmetrize\"\>", ",", "\<\"ParamD\"\>", 
   ",", "\<\"ParameterQ\"\>", ",", "\<\"ParametersOf\"\>", 
   ",", "\<\"PatternIndex\"\>", ",", "\<\"PatternIndices\"\>", 
   ",", "\<\"PD\"\>", ",", "\<\"PermuteIndices\"\>", ",", "\<\"PIndex\"\>", 
   ",", "\<\"PIndexQ\"\>", ",", "\<\"Precompose\"\>", 
   ",", "\<\"PrimeDagger\"\>", ",", "\<\"PrintAs\"\>", 
   ",", "\<\"PrintAsCharacter\"\>", ",", "\<\"ProductByScalar\"\>", 
   ",", "\<\"ProductOfScalars\"\>", ",", "\<\"ProductQ\"\>", 
   ",", "\<\"Project\"\>", ",", "\<\"ProjectDerivative\"\>", 
   ",", "\<\"Projected\"\>", ",", "\<\"ProjectedWith\"\>", 
   ",", "\<\"Projector\"\>", ",", "\<\"ProjectorQ\"\>", 
   ",", "\<\"ProjectorToMetric\"\>", ",", "\<\"ProjectWith\"\>", 
   ",", "\<\"ProtectNewSymbol\"\>", ",", "\<\"PullBack\"\>", 
   ",", "\<\"PullBackCovD\"\>", ",", "\<\"PullBackTensor\"\>", 
   ",", "\<\"PullBackVBundle\"\>", ",", "\<\"PushForward\"\>", 
   ",", "\<\"PushForwardTensor\"\>", ",", "\<\"PutScalar\"\>", 
   ",", "\<\"RegisterIndices\"\>", ",", "\<\"RemoveIndices\"\>", 
   ",", "\<\"ReplaceDummies\"\>", ",", "\<\"ReplaceIndex\"\>", 
   ",", "\<\"Ricci\"\>", ",", "\<\"RicciScalar\"\>", 
   ",", "\<\"RicciToEinstein\"\>", ",", "\<\"RicciToTFRicci\"\>", 
   ",", "\<\"Riemann\"\>", ",", "\<\"RiemannDown\"\>", 
   ",", "\<\"RiemannDownToRiemann\"\>", ",", "\<\"RiemannToChristoffel\"\>", 
   ",", "\<\"RiemannToRiemannDown\"\>", ",", "\<\"RiemannToWeyl\"\>", 
   ",", "\<\"SameDummies\"\>", ",", "\<\"Scalar\"\>", 
   ",", "\<\"ScalarFunction\"\>", ",", "\<\"ScalarFunctionQ\"\>", 
   ",", "\<\"ScalarQ\"\>", ",", "\<\"ScalarsOfProduct\"\>", 
   ",", "\<\"ScreenDollarIndices\"\>", ",", "\<\"Sdelta\"\>", 
   ",", "\<\"SeparateDir\"\>", ",", "\<\"SeparateMetric\"\>", 
   ",", "\<\"ServantsOf\"\>", ",", "\<\"SetCharacters\"\>", 
   ",", "\<\"SetConformalTo\"\>", ",", "\<\"SetIndexSortPriorities\"\>", 
   ",", "\<\"SetOrthogonal\"\>", ",", "\<\"SetProjected\"\>", 
   ",", "\<\"SetSplitTensors\"\>", ",", "\<\"SignatureOfMetric\"\>", 
   ",", "\<\"SignDetOfMetric\"\>", ",", "\<\"Simplification\"\>", 
   ",", "\<\"SlotsOfTensor\"\>", ",", "\<\"SortCovDs\"\>", 
   ",", "\<\"SortCovDsStart\"\>", ",", "\<\"SortCovDsStop\"\>", 
   ",", "\<\"SplitIndex\"\>", ",", "\<\"SplitManifold\"\>", 
   ",", "\<\"SplitTensor\"\>", ",", "\<\"SplittingsOfManifold\"\>", 
   ",", "\<\"SplittingsOfVBundle\"\>", ",", "\<\"SplitVBundle\"\>", 
   ",", "\<\"STFPart\"\>", ",", "\<\"Stripped\"\>", 
   ",", "\<\"SubdummiesIn\"\>", ",", "\<\"SubmanifoldQ\"\>", 
   ",", "\<\"SubmanifoldsOfManifold\"\>", ",", "\<\"SubmersionQ\"\>", 
   ",", "\<\"SubvbundleQ\"\>", ",", "\<\"SubvbundlesOfVBundle\"\>", 
   ",", "\<\"Supercommutator\"\>", ",", "\<\"Sym\"\>", 
   ",", "\<\"SymbolOfCovD\"\>", ",", "\<\"Symmetrize\"\>", 
   ",", "\<\"Symmetry\"\>", ",", "\<\"SymmetryGroupOfCovD\"\>", 
   ",", "\<\"SymmetryGroupOfTensor\"\>", ",", "\<\"SymmetryOf\"\>", 
   ",", "\<\"SymmetryTableauxOfTensor\"\>", ",", "\<\"Tangent\"\>", 
   ",", "\<\"TangentBundleOfManifold\"\>", ",", "\<\"TangentTensor\"\>", 
   ",", "\<\"Tensor\"\>", ",", "\<\"TensorD\"\>", 
   ",", "\<\"TensorDerivative\"\>", ",", "\<\"TensorID\"\>", 
   ",", "\<\"TestIndices\"\>", ",", "\<\"Tetra\"\>", ",", "\<\"TetraRule\"\>",
    ",", "\<\"TFRicci\"\>", ",", "\<\"TFRicciToRicci\"\>", 
   ",", "\<\"ToCanonical\"\>", ",", "\<\"ToInducedDerivative\"\>", 
   ",", "\<\"Torsion\"\>", ",", "\<\"TorsionQ\"\>", 
   ",", "\<\"TorsionToChristoffel\"\>", ",", "\<\"ToRule\"\>", 
   ",", "\<\"ToStripped\"\>", ",", "\<\"ToTensorDerivative\"\>", 
   ",", "\<\"TraceDummy\"\>", ",", "\<\"TraceProductDummy\"\>", 
   ",", "\<\"TransposeDagger\"\>", ",", "\<\"Undef\"\>", 
   ",", "\<\"UndefAbstractIndex\"\>", ",", "\<\"UndefConstantSymbol\"\>", 
   ",", "\<\"UndefCovD\"\>", ",", "\<\"UndefInertHead\"\>", 
   ",", "\<\"UndefManifold\"\>", ",", "\<\"UndefMapping\"\>", 
   ",", "\<\"UndefMetric\"\>", ",", "\<\"UndefParameter\"\>", 
   ",", "\<\"UndefProduct\"\>", ",", "\<\"UndefScalarFunction\"\>", 
   ",", "\<\"UndefTensor\"\>", ",", "\<\"UndefVBundle\"\>", ",", "\<\"Up\"\>",
    ",", "\<\"UpIndex\"\>", ",", "\<\"UpIndexQ\"\>", ",", "\<\"UpVectorQ\"\>",
    ",", "\<\"UseMetricOnVBundle\"\>", ",", "\<\"UseSymmetries\"\>", 
   ",", "\<\"UxSort\"\>", ",", "\<\"Validate\"\>", 
   ",", "\<\"ValidateSymbolInSession\"\>", ",", "\<\"VanishingQ\"\>", 
   ",", "\<\"VarD\"\>", ",", "\<\"VBundle\"\>", ",", "\<\"VBundleOfIndex\"\>",
    ",", "\<\"VBundleOfMetric\"\>", ",", "\<\"VBundleQ\"\>", 
   ",", "\<\"VBundlesOfCovD\"\>", ",", "\<\"VectorOfInducedMetric\"\>", 
   ",", "\<\"VisitorsOf\"\>", ",", "\<\"WeightedWithBasis\"\>", 
   ",", "\<\"WeightOf\"\>", ",", "\<\"WeightOfTensor\"\>", 
   ",", "\<\"Weyl\"\>", ",", "\<\"WeylToRiemann\"\>", ",", "\<\"xSort\"\>", 
   ",", "\<\"xSortOrder\"\>", ",", "\<\"xSortPrecedence\"\>", 
   ",", "\<\"xTensorFormStart\"\>", ",", "\<\"xTensorFormStop\"\>", 
   ",", "\<\"xTensorQ\"\>", ",", "\<\"Zero\"\>", 
   ",", "\<\"$AbstractIndices\"\>", ",", "\<\"$AccelerationSign\"\>", 
   ",", "\<\"$Bases\"\>", ",", "\<\"$Charts\"\>", 
   ",", "\<\"$CheckZeroDerivativeVerbose\"\>", ",", "\<\"$CIndexForm\"\>", 
   ",", "\<\"$CommuteCovDsOnScalars\"\>", ",", "\<\"$ComputeNewDummies\"\>", 
   ",", "\<\"$ConstantSymbols\"\>", ",", "\<\"$CovDFormat\"\>", 
   ",", "\<\"$CovDs\"\>", ",", "\<\"$DefInfoQ\"\>", 
   ",", "\<\"$epsilonSign\"\>", ",", "\<\"$ExtrinsicKSign\"\>", 
   ",", "\<\"$FindIndicesAcceptedHeads\"\>", ",", "\<\"$ImplodeInfoQ\"\>", 
   ",", "\<\"$IndexListColor\"\>", ",", "\<\"$InertHeads\"\>", 
   ",", "\<\"$Manifolds\"\>", ",", "\<\"$Mappings\"\>", 
   ",", "\<\"$Metrics\"\>", ",", "\<\"$MixedDers\"\>", 
   ",", "\<\"$ParamDFormat\"\>", ",", "\<\"$Parameters\"\>", 
   ",", "\<\"$ProductManifolds\"\>", ",", "\<\"$ProductMetrics\"\>", 
   ",", "\<\"$Products\"\>", ",", "\<\"$ProjectedFormat\"\>", 
   ",", "\<\"$ProtectNewSymbols\"\>", ",", "\<\"$ReadingVerbose\"\>", 
   ",", "\<\"$RicciSign\"\>", ",", "\<\"$RiemannSign\"\>", 
   ",", "\<\"$Rules\"\>", ",", "\<\"$ScalarColor\"\>", 
   ",", "\<\"$ScalarFunctions\"\>", ",", "\<\"$SeparateScalarsFromScalar\"\>",
    ",", "\<\"$SumVBundles\"\>", ",", "\<\"$TensorBoxes\"\>", 
   ",", "\<\"$Tensors\"\>", ",", "\<\"$TorsionSign\"\>", 
   ",", "\<\"$TraceDummyVerbose\"\>", ",", "\<\"$UndefInfoQ\"\>", 
   ",", "\<\"$VBundles\"\>", ",", "\<\"$Version\"\>", 
   ",", "\<\"$xPermVersionExpected\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"25e15193-f8ab-4802-b55c-f80e2ae62a2b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$xTensorDollarNames", "=", 
  RowBox[{"Select", "[", 
   RowBox[{"$xTensorNames", ",", 
    RowBox[{
     RowBox[{"StringMatchQ", "[", 
      RowBox[{"#", ",", "\"\<$*\>\""}], "]"}], "&"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"519dbb31-b257-4f95-a67e-b155f358b135"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"$AbstractIndices\"\>", ",", "\<\"$AccelerationSign\"\>", 
   ",", "\<\"$Bases\"\>", ",", "\<\"$Charts\"\>", 
   ",", "\<\"$CheckZeroDerivativeVerbose\"\>", ",", "\<\"$CIndexForm\"\>", 
   ",", "\<\"$CommuteCovDsOnScalars\"\>", ",", "\<\"$ComputeNewDummies\"\>", 
   ",", "\<\"$ConstantSymbols\"\>", ",", "\<\"$CovDFormat\"\>", 
   ",", "\<\"$CovDs\"\>", ",", "\<\"$DefInfoQ\"\>", 
   ",", "\<\"$epsilonSign\"\>", ",", "\<\"$ExtrinsicKSign\"\>", 
   ",", "\<\"$FindIndicesAcceptedHeads\"\>", ",", "\<\"$ImplodeInfoQ\"\>", 
   ",", "\<\"$IndexListColor\"\>", ",", "\<\"$InertHeads\"\>", 
   ",", "\<\"$Manifolds\"\>", ",", "\<\"$Mappings\"\>", 
   ",", "\<\"$Metrics\"\>", ",", "\<\"$MixedDers\"\>", 
   ",", "\<\"$ParamDFormat\"\>", ",", "\<\"$Parameters\"\>", 
   ",", "\<\"$ProductManifolds\"\>", ",", "\<\"$ProductMetrics\"\>", 
   ",", "\<\"$Products\"\>", ",", "\<\"$ProjectedFormat\"\>", 
   ",", "\<\"$ProtectNewSymbols\"\>", ",", "\<\"$ReadingVerbose\"\>", 
   ",", "\<\"$RicciSign\"\>", ",", "\<\"$RiemannSign\"\>", 
   ",", "\<\"$Rules\"\>", ",", "\<\"$ScalarColor\"\>", 
   ",", "\<\"$ScalarFunctions\"\>", ",", "\<\"$SeparateScalarsFromScalar\"\>",
    ",", "\<\"$SumVBundles\"\>", ",", "\<\"$TensorBoxes\"\>", 
   ",", "\<\"$Tensors\"\>", ",", "\<\"$TorsionSign\"\>", 
   ",", "\<\"$TraceDummyVerbose\"\>", ",", "\<\"$UndefInfoQ\"\>", 
   ",", "\<\"$VBundles\"\>", ",", "\<\"$Version\"\>", 
   ",", "\<\"$xPermVersionExpected\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"24b0f0b0-1fc9-4b8d-bb85-624d8d40dffd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$xTensorNonDollarNames", "=", 
  RowBox[{"Complement", "[", 
   RowBox[{"$xTensorNames", ",", "$xTensorDollarNames"}], 
   "]"}]}]], "Input",ExpressionUUID->"c10303f1-d48a-471a-9603-6794c7dfecf2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ABIndexQ\"\>", ",", "\<\"AbstractIndex\"\>", 
   ",", "\<\"AbstractIndexQ\"\>", ",", "\<\"Acceleration\"\>", 
   ",", "\<\"AChristoffel\"\>", ",", "\<\"AddIndices\"\>", 
   ",", "\<\"AIndex\"\>", ",", "\<\"AIndexQ\"\>", 
   ",", "\<\"AllowUpperDerivatives\"\>", ",", "\<\"Anticommutator\"\>", 
   ",", "\<\"Antihermitian\"\>", ",", "\<\"AntihermitianQ\"\>", 
   ",", "\<\"Antisymmetrize\"\>", ",", "\<\"AnyDependencies\"\>", 
   ",", "\<\"AnyIndices\"\>", ",", "\<\"AnyVBundles\"\>", 
   ",", "\<\"AssociativeProductQ\"\>", ",", "\<\"At\"\>", 
   ",", "\<\"AutomaticRules\"\>", ",", "\<\"BaseOfVBundle\"\>", 
   ",", "\<\"Basis\"\>", ",", "\<\"BasisQ\"\>", ",", "\<\"BCIndexQ\"\>", 
   ",", "\<\"BIndex\"\>", ",", "\<\"BIndexQ\"\>", ",", "\<\"Blocked\"\>", 
   ",", "\<\"BlockedQ\"\>", ",", "\<\"Bracket\"\>", 
   ",", "\<\"BracketToCovD\"\>", ",", "\<\"BreakChristoffel\"\>", 
   ",", "\<\"BreakInMonomials\"\>", ",", "\<\"BreakScalars\"\>", 
   ",", "\<\"CartesianProduct\"\>", ",", "\<\"CDIndexQ\"\>", 
   ",", "\<\"ChangeCovD\"\>", ",", "\<\"ChangeCurvature\"\>", 
   ",", "\<\"ChangeFreeIndices\"\>", ",", "\<\"ChangeIndex\"\>", 
   ",", "\<\"ChangeTorsion\"\>", ",", "\<\"Chart\"\>", ",", "\<\"ChartQ\"\>", 
   ",", "\<\"CheckZeroDerivative\"\>", 
   ",", "\<\"CheckZeroDerivativeStart\"\>", 
   ",", "\<\"CheckZeroDerivativeStop\"\>", ",", "\<\"Christoffel\"\>", 
   ",", "\<\"ChristoffelToGradConformal\"\>", 
   ",", "\<\"ChristoffelToGradMetric\"\>", ",", "\<\"ChristoffelToMetric\"\>",
    ",", "\<\"CIndex\"\>", ",", "\<\"CIndexForm\"\>", ",", "\<\"CIndexQ\"\>", 
   ",", "\<\"ColorPositionsOfPattern\"\>", ",", "\<\"ColorTerms\"\>", 
   ",", "\<\"CommutativityOfProduct\"\>", ",", "\<\"Commutator\"\>", 
   ",", "\<\"CommuteCovDs\"\>", ",", "\<\"CommutePDs\"\>", 
   ",", "\<\"ConformalFactor\"\>", ",", "\<\"ConformalRules\"\>", 
   ",", "\<\"ConformalTo\"\>", ",", "\<\"ConstantMetric\"\>", 
   ",", "\<\"ConstantQ\"\>", ",", "\<\"ConstantSymbol\"\>", 
   ",", "\<\"ConstantSymbolQ\"\>", ",", "\<\"ContractCurvature\"\>", 
   ",", "\<\"ContractDir\"\>", ",", "\<\"ContractMetric\"\>", 
   ",", "\<\"ContractMetrics\"\>", ",", "\<\"ContractProjector\"\>", 
   ",", "\<\"ContractThrough\"\>", ",", "\<\"ContractThroughQ\"\>", 
   ",", "\<\"CovD\"\>", ",", "\<\"CovDOfMetric\"\>", ",", "\<\"CovDQ\"\>", 
   ",", "\<\"CovDToChristoffel\"\>", ",", "\<\"Curvature\"\>", 
   ",", "\<\"CurvatureQ\"\>", ",", "\<\"CurvatureRelations\"\>", 
   ",", "\<\"Cyclize\"\>", ",", "\<\"Dagger\"\>", ",", "\<\"DaggerIndex\"\>", 
   ",", "\<\"DaggerQ\"\>", ",", "\<\"DefAbstractIndex\"\>", 
   ",", "\<\"DefConstantSymbol\"\>", ",", "\<\"DefCovD\"\>", 
   ",", "\<\"DefineCommutator\"\>", ",", "\<\"DefInertHead\"\>", 
   ",", "\<\"DefInfo\"\>", ",", "\<\"DefManifold\"\>", 
   ",", "\<\"DefMapping\"\>", ",", "\<\"DefMetric\"\>", 
   ",", "\<\"DefParameter\"\>", ",", "\<\"DefProduct\"\>", 
   ",", "\<\"DefProductMetric\"\>", ",", "\<\"DefScalarFunction\"\>", 
   ",", "\<\"DefTensor\"\>", ",", "\<\"DefVBundle\"\>", ",", "\<\"delta\"\>", 
   ",", "\<\"DependenciesOf\"\>", ",", "\<\"DependenciesOfCovD\"\>", 
   ",", "\<\"DependenciesOfInertHead\"\>", 
   ",", "\<\"DependenciesOfTensor\"\>", ",", "\<\"Determinant\"\>", 
   ",", "\<\"DiffeomorphismQ\"\>", ",", "\<\"DimOfManifold\"\>", 
   ",", "\<\"DimOfVBundle\"\>", ",", "\<\"DIndex\"\>", ",", "\<\"DIndexQ\"\>",
    ",", "\<\"Dir\"\>", ",", "\<\"DirCovDToLieD\"\>", 
   ",", "\<\"Disclaimer\"\>", ",", "\<\"DisjointManifoldsQ\"\>", 
   ",", "\<\"DisjointVBundlesQ\"\>", ",", "\<\"DisorderedPairQ\"\>", 
   ",", "\<\"Down\"\>", ",", "\<\"DownIndex\"\>", ",", "\<\"DownIndexQ\"\>", 
   ",", "\<\"DownVectorQ\"\>", ",", "\<\"Dummy\"\>", ",", "\<\"DummyAs\"\>", 
   ",", "\<\"DummyIn\"\>", ",", "\<\"EIndexQ\"\>", ",", "\<\"Einstein\"\>", 
   ",", "\<\"EinsteinToRicci\"\>", ",", "\<\"EmptyManifold\"\>", 
   ",", "\<\"epsilon\"\>", ",", "\<\"epsilonOrientation\"\>", 
   ",", "\<\"epsilonOrientationInBasis\"\>", ",", "\<\"EqualExpressionsQ\"\>",
    ",", "\<\"ERROR\"\>", ",", "\<\"ExpandCommutator\"\>", 
   ",", "\<\"ExpandGdelta\"\>", ",", "\<\"ExpandProductMetric\"\>", 
   ",", "\<\"ExpandPullBack\"\>", ",", "\<\"ExpandPushForward\"\>", 
   ",", "\<\"ExpandSdelta\"\>", ",", "\<\"Explode\"\>", 
   ",", "\<\"ExtendedFrom\"\>", ",", "\<\"ExtrinsicK\"\>", 
   ",", "\<\"ExtrinsicKToGradNormal\"\>", ",", "\<\"FindAllOfType\"\>", 
   ",", "\<\"FindBlockedIndices\"\>", ",", "\<\"FindDummyIndices\"\>", 
   ",", "\<\"FindFreeIndices\"\>", ",", "\<\"FindIndices\"\>", 
   ",", "\<\"FirstDerQ\"\>", ",", "\<\"FlatMetric\"\>", 
   ",", "\<\"FlatMetricQ\"\>", ",", "\<\"ForceSymmetries\"\>", 
   ",", "\<\"Free\"\>", ",", "\<\"FRiemann\"\>", ",", "\<\"FrobeniusQ\"\>", 
   ",", "\<\"FromMetric\"\>", ",", "\<\"FromProjected\"\>", 
   ",", "\<\"FromStripped\"\>", ",", "\<\"FromTensorDerivative\"\>", 
   ",", "\<\"GaussCodazzi\"\>", ",", "\<\"Gdelta\"\>", 
   ",", "\<\"GetIndicesOfVBundle\"\>", ",", "\<\"GIndexQ\"\>", 
   ",", "\<\"GiveOutputString\"\>", ",", "\<\"GiveSymbol\"\>", 
   ",", "\<\"Grade\"\>", ",", "\<\"GradedProductQ\"\>", 
   ",", "\<\"GradeOfCovD\"\>", ",", "\<\"GradeOfProduct\"\>", 
   ",", "\<\"GradeOfTensor\"\>", ",", "\<\"GradMetricToChristoffel\"\>", 
   ",", "\<\"GradNormalToExtrinsicK\"\>", ",", "\<\"HeadOfTensor\"\>", 
   ",", "\<\"Hermitian\"\>", ",", "\<\"HermitianQ\"\>", 
   ",", "\<\"HostsOf\"\>", ",", "\<\"IdentityElementOfProduct\"\>", 
   ",", "\<\"IdentityMapping\"\>", ",", "\<\"Imaginary\"\>", 
   ",", "\<\"ImmersionQ\"\>", ",", "\<\"IModQ\"\>", 
   ",", "\<\"ImplicitTensorDepQ\"\>", ",", "\<\"Implode\"\>", 
   ",", "\<\"ImposeSymmetry\"\>", ",", "\<\"IndexCoefficient\"\>", 
   ",", "\<\"IndexCollect\"\>", ",", "\<\"IndexForm\"\>", 
   ",", "\<\"IndexList\"\>", ",", "\<\"IndexOrderedQ\"\>", 
   ",", "\<\"IndexRange\"\>", ",", "\<\"IndexRule\"\>", 
   ",", "\<\"IndexRuleDelayed\"\>", ",", "\<\"IndexSet\"\>", 
   ",", "\<\"IndexSetDelayed\"\>", ",", "\<\"IndexSolve\"\>", 
   ",", "\<\"IndexSort\"\>", ",", "\<\"IndicesOf\"\>", 
   ",", "\<\"IndicesOfVBundle\"\>", ",", "\<\"InducedDecomposition\"\>", 
   ",", "\<\"InducedFrom\"\>", ",", "\<\"InertHead\"\>", 
   ",", "\<\"InertHeadQ\"\>", ",", "\<\"Inv\"\>", 
   ",", "\<\"InverseMapping\"\>", ",", "\<\"InvertibleQ\"\>", 
   ",", "\<\"IsIndexOf\"\>", ",", "\<\"Keep\"\>", ",", "\<\"Kretschmann\"\>", 
   ",", "\<\"Labels\"\>", ",", "\<\"LastIndex\"\>", ",", "\<\"LC\"\>", 
   ",", "\<\"Leibnitz\"\>", ",", "\<\"LI\"\>", ",", "\<\"LieD\"\>", 
   ",", "\<\"LieDToCovD\"\>", ",", "\<\"LIndex\"\>", ",", "\<\"LIndexQ\"\>", 
   ",", "\<\"LinearPush\"\>", ",", "\<\"LinearQ\"\>", 
   ",", "\<\"MakeProjectors\"\>", ",", "\<\"MakeRule\"\>", 
   ",", "\<\"Manifold\"\>", ",", "\<\"ManifoldBoundary\"\>", 
   ",", "\<\"ManifoldOfCovD\"\>", ",", "\<\"ManifoldQ\"\>", 
   ",", "\<\"ManifoldsOf\"\>", ",", "\<\"Mapping\"\>", 
   ",", "\<\"MappingDomain\"\>", ",", "\<\"MappingImage\"\>", 
   ",", "\<\"MappingQ\"\>", ",", "\<\"Master\"\>", ",", "\<\"MasterOf\"\>", 
   ",", "\<\"Metric\"\>", ",", "\<\"MetricEndowedQ\"\>", 
   ",", "\<\"MetricOfCovD\"\>", ",", "\<\"MetricOn\"\>", 
   ",", "\<\"MetricQ\"\>", ",", "\<\"MetricScalar\"\>", 
   ",", "\<\"MetricsOfVBundle\"\>", ",", "\<\"MetricToProjector\"\>", 
   ",", "\<\"Monomial\"\>", ",", "\<\"MultiplyHead\"\>", 
   ",", "\<\"NewIndexIn\"\>", ",", "\<\"NoScalar\"\>", 
   ",", "\<\"OrthogonalTo\"\>", ",", "\<\"OrthogonalToVectorQ\"\>", 
   ",", "\<\"OrthogonalWithMetric\"\>", ",", "\<\"OtherDependencies\"\>", 
   ",", "\<\"OverDerivatives\"\>", ",", "\<\"Pair\"\>", 
   ",", "\<\"PairAntisymmetrize\"\>", ",", "\<\"PairQ\"\>", 
   ",", "\<\"PairSymmetrize\"\>", ",", "\<\"ParamD\"\>", 
   ",", "\<\"ParameterQ\"\>", ",", "\<\"ParametersOf\"\>", 
   ",", "\<\"PatternIndex\"\>", ",", "\<\"PatternIndices\"\>", 
   ",", "\<\"PD\"\>", ",", "\<\"PermuteIndices\"\>", ",", "\<\"PIndex\"\>", 
   ",", "\<\"PIndexQ\"\>", ",", "\<\"Precompose\"\>", 
   ",", "\<\"PrimeDagger\"\>", ",", "\<\"PrintAs\"\>", 
   ",", "\<\"PrintAsCharacter\"\>", ",", "\<\"ProductByScalar\"\>", 
   ",", "\<\"ProductOfScalars\"\>", ",", "\<\"ProductQ\"\>", 
   ",", "\<\"Project\"\>", ",", "\<\"ProjectDerivative\"\>", 
   ",", "\<\"Projected\"\>", ",", "\<\"ProjectedWith\"\>", 
   ",", "\<\"Projector\"\>", ",", "\<\"ProjectorQ\"\>", 
   ",", "\<\"ProjectorToMetric\"\>", ",", "\<\"ProjectWith\"\>", 
   ",", "\<\"ProtectNewSymbol\"\>", ",", "\<\"PullBack\"\>", 
   ",", "\<\"PullBackCovD\"\>", ",", "\<\"PullBackTensor\"\>", 
   ",", "\<\"PullBackVBundle\"\>", ",", "\<\"PushForward\"\>", 
   ",", "\<\"PushForwardTensor\"\>", ",", "\<\"PutScalar\"\>", 
   ",", "\<\"RegisterIndices\"\>", ",", "\<\"RemoveIndices\"\>", 
   ",", "\<\"ReplaceDummies\"\>", ",", "\<\"ReplaceIndex\"\>", 
   ",", "\<\"Ricci\"\>", ",", "\<\"RicciScalar\"\>", 
   ",", "\<\"RicciToEinstein\"\>", ",", "\<\"RicciToTFRicci\"\>", 
   ",", "\<\"Riemann\"\>", ",", "\<\"RiemannDown\"\>", 
   ",", "\<\"RiemannDownToRiemann\"\>", ",", "\<\"RiemannToChristoffel\"\>", 
   ",", "\<\"RiemannToRiemannDown\"\>", ",", "\<\"RiemannToWeyl\"\>", 
   ",", "\<\"SameDummies\"\>", ",", "\<\"Scalar\"\>", 
   ",", "\<\"ScalarFunction\"\>", ",", "\<\"ScalarFunctionQ\"\>", 
   ",", "\<\"ScalarQ\"\>", ",", "\<\"ScalarsOfProduct\"\>", 
   ",", "\<\"ScreenDollarIndices\"\>", ",", "\<\"Sdelta\"\>", 
   ",", "\<\"SeparateDir\"\>", ",", "\<\"SeparateMetric\"\>", 
   ",", "\<\"ServantsOf\"\>", ",", "\<\"SetCharacters\"\>", 
   ",", "\<\"SetConformalTo\"\>", ",", "\<\"SetIndexSortPriorities\"\>", 
   ",", "\<\"SetOrthogonal\"\>", ",", "\<\"SetProjected\"\>", 
   ",", "\<\"SetSplitTensors\"\>", ",", "\<\"SignatureOfMetric\"\>", 
   ",", "\<\"SignDetOfMetric\"\>", ",", "\<\"Simplification\"\>", 
   ",", "\<\"SlotsOfTensor\"\>", ",", "\<\"SortCovDs\"\>", 
   ",", "\<\"SortCovDsStart\"\>", ",", "\<\"SortCovDsStop\"\>", 
   ",", "\<\"SplitIndex\"\>", ",", "\<\"SplitManifold\"\>", 
   ",", "\<\"SplitTensor\"\>", ",", "\<\"SplittingsOfManifold\"\>", 
   ",", "\<\"SplittingsOfVBundle\"\>", ",", "\<\"SplitVBundle\"\>", 
   ",", "\<\"STFPart\"\>", ",", "\<\"Stripped\"\>", 
   ",", "\<\"SubdummiesIn\"\>", ",", "\<\"SubmanifoldQ\"\>", 
   ",", "\<\"SubmanifoldsOfManifold\"\>", ",", "\<\"SubmersionQ\"\>", 
   ",", "\<\"SubvbundleQ\"\>", ",", "\<\"SubvbundlesOfVBundle\"\>", 
   ",", "\<\"Supercommutator\"\>", ",", "\<\"Sym\"\>", 
   ",", "\<\"SymbolOfCovD\"\>", ",", "\<\"Symmetrize\"\>", 
   ",", "\<\"Symmetry\"\>", ",", "\<\"SymmetryGroupOfCovD\"\>", 
   ",", "\<\"SymmetryGroupOfTensor\"\>", ",", "\<\"SymmetryOf\"\>", 
   ",", "\<\"SymmetryTableauxOfTensor\"\>", ",", "\<\"Tangent\"\>", 
   ",", "\<\"TangentBundleOfManifold\"\>", ",", "\<\"TangentTensor\"\>", 
   ",", "\<\"Tensor\"\>", ",", "\<\"TensorD\"\>", 
   ",", "\<\"TensorDerivative\"\>", ",", "\<\"TensorID\"\>", 
   ",", "\<\"TestIndices\"\>", ",", "\<\"Tetra\"\>", ",", "\<\"TetraRule\"\>",
    ",", "\<\"TFRicci\"\>", ",", "\<\"TFRicciToRicci\"\>", 
   ",", "\<\"ToCanonical\"\>", ",", "\<\"ToInducedDerivative\"\>", 
   ",", "\<\"Torsion\"\>", ",", "\<\"TorsionQ\"\>", 
   ",", "\<\"TorsionToChristoffel\"\>", ",", "\<\"ToRule\"\>", 
   ",", "\<\"ToStripped\"\>", ",", "\<\"ToTensorDerivative\"\>", 
   ",", "\<\"TraceDummy\"\>", ",", "\<\"TraceProductDummy\"\>", 
   ",", "\<\"TransposeDagger\"\>", ",", "\<\"Undef\"\>", 
   ",", "\<\"UndefAbstractIndex\"\>", ",", "\<\"UndefConstantSymbol\"\>", 
   ",", "\<\"UndefCovD\"\>", ",", "\<\"UndefInertHead\"\>", 
   ",", "\<\"UndefManifold\"\>", ",", "\<\"UndefMapping\"\>", 
   ",", "\<\"UndefMetric\"\>", ",", "\<\"UndefParameter\"\>", 
   ",", "\<\"UndefProduct\"\>", ",", "\<\"UndefScalarFunction\"\>", 
   ",", "\<\"UndefTensor\"\>", ",", "\<\"UndefVBundle\"\>", ",", "\<\"Up\"\>",
    ",", "\<\"UpIndex\"\>", ",", "\<\"UpIndexQ\"\>", ",", "\<\"UpVectorQ\"\>",
    ",", "\<\"UseMetricOnVBundle\"\>", ",", "\<\"UseSymmetries\"\>", 
   ",", "\<\"UxSort\"\>", ",", "\<\"Validate\"\>", 
   ",", "\<\"ValidateSymbolInSession\"\>", ",", "\<\"VanishingQ\"\>", 
   ",", "\<\"VarD\"\>", ",", "\<\"VBundle\"\>", ",", "\<\"VBundleOfIndex\"\>",
    ",", "\<\"VBundleOfMetric\"\>", ",", "\<\"VBundleQ\"\>", 
   ",", "\<\"VBundlesOfCovD\"\>", ",", "\<\"VectorOfInducedMetric\"\>", 
   ",", "\<\"VisitorsOf\"\>", ",", "\<\"WeightedWithBasis\"\>", 
   ",", "\<\"WeightOf\"\>", ",", "\<\"WeightOfTensor\"\>", 
   ",", "\<\"Weyl\"\>", ",", "\<\"WeylToRiemann\"\>", ",", "\<\"xSort\"\>", 
   ",", "\<\"xSortOrder\"\>", ",", "\<\"xSortPrecedence\"\>", 
   ",", "\<\"xTensorFormStart\"\>", ",", "\<\"xTensorFormStop\"\>", 
   ",", "\<\"xTensorQ\"\>", ",", "\<\"Zero\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"9005f9e3-6c25-45f3-954b-d7ad5a2d9731"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "/@", 
  RowBox[{"{", 
   RowBox[{
   "$xTensorNonDollarNames", ",", "$xTensorDollarNames", ",", 
    "$xTensorNames"}], 
   "}"}]}]], "Input",ExpressionUUID->"0d35fa2a-56fd-44cb-b26c-7425007a5d17"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"409", ",", "45", ",", "454"}], 
  "}"}]], "Output",ExpressionUUID->"b88007f9-9581-4bb5-a36f-f787095eb45a"]
}, Open  ]],

Cell["Compare with the documentation files:", \
"Text",ExpressionUUID->"3f814537-f621-47f5-a3c0-0a944707be89"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"filename", "[", "string_String", "]"}], ":=", 
   RowBox[{"StringReplacePart", "[", 
    RowBox[{
     RowBox[{"StringReplacePart", "[", 
      RowBox[{"string", ",", "\"\<\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{
          RowBox[{"StringLength", "[", "$xActDocDirectory", "]"}], "+", 
          "9"}]}], "}"}]}], "]"}], ",", "\"\<\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"docfiles", "=", 
   RowBox[{"filename", "/@", 
    RowBox[{"FileNames", "[", 
     RowBox[{"$xActDocDirectory", "<>", "\"\</xTensor/*.nb\>\""}], "]"}]}]}], 
  ";"}]}], "Input",ExpressionUUID->"a43189ce-6dd2-4f72-a9cd-8661f8466673"],

Cell[TextData[{
 "These are the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " builtins which have been overloaded:"
}], "Text",ExpressionUUID->"9ccf3417-5fcf-492a-af3d-d3681f06b5f0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{"docfiles", ",", "$xTensorNames"}], 
  "]"}]], "Input",ExpressionUUID->"d35fae05-7148-4a3c-bece-6b81d58397aa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"CircleDot\"\>", ",", "\<\"Complex\"\>", 
   ",", "\<\"DoubleRightTee\"\>", ",", "\<\"OverDot\"\>", 
   ",", "\<\"Parameter\"\>", ",", "\<\"Real\"\>", 
   ",", "\<\"RightTeeArrow\"\>", ",", "\<\"Verbose\"\>", 
   ",", "\<\"$CommuteFreeIndices\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"2eeeccc8-e042-4f63-b1dc-335f17d8643b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Complex"}]], \
"Input",ExpressionUUID->"b4833fa9-632d-465c-b03c-7494b8ae79fa"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox[
           PaneBox[
            TooltipBox[
             ButtonBox[
              PaneSelectorBox[{False->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIcon"]], True->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIconHot"]]}, Dynamic[
                CurrentValue["MouseOver"]]],
              Appearance->None,
              BaseStyle->"Link",
              ButtonData->"paclet:ref/Complex",
              ButtonNote->"paclet:ref/Complex"],
             "\"paclet:ref/Complex\""],
            FrameMargins->{{0, 4}, {0, 2}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Complex is the head used for complex numbers. \"\>",
              "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Documentation\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Documentation\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Documentation", "Tooltip"]& ], 
                   TemplateBox[{
                    
                    TemplateBox[{
                    "\"Local \[RightGuillemet]\"", "paclet:ref/Complex", 
                    "paclet:ref/Complex", "Link", {
                    RGBColor[0.9686274509803922, 0.4666666666666667, 0.]}, 
                    BaseStyle -> {
                    RGBColor[0.0784313725490196, 0.1568627450980392, 0.6]}}, 
                    "HyperlinkTemplate"], "\"  \"", 
                    StyleBox[
                    "\"|\"", "InformationRowLabel", StripOnInput -> False], 
                    "\"  \"", 
                    TemplateBox[{"\"Web \[RightGuillemet]\"", {
                    URL[
                    "http://reference.wolfram.com/language/ref/Complex.html"],
                     None}, 
                    "http://reference.wolfram.com/language/ref/Complex.html", 
                    "Hyperlink", {
                    RGBColor[0.9686274509803922, 0.4666666666666667, 0.]}, 
                    BaseStyle -> {
                    RGBColor[0.0784313725490196, 0.1568627450980392, 0.6]}}, 
                    "HyperlinkTemplate"]},
                    "RowDefault"]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"System`Complex\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox[
           PaneBox[
            TooltipBox[
             ButtonBox[
              PaneSelectorBox[{False->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIcon"],
                ImageSizeCache->{13., {4., 9.}}], True->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIconHot"],
                ImageSizeCache->{13., {4., 9.}}]}, Dynamic[
                CurrentValue["MouseOver"]]],
              Appearance->None,
              BaseStyle->"Link",
              ButtonData->"paclet:ref/Complex",
              ButtonNote->"paclet:ref/Complex"],
             "\"paclet:ref/Complex\""],
            FrameMargins->{{0, 4}, {0, 2}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Complex is the head used for complex numbers. \"\>",
              "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "Complex is the head used for complex numbers. ", "Documentation" -> 
    Association[
     "Local" -> "paclet:ref/Complex", "Web" -> 
      "http://reference.wolfram.com/language/ref/Complex.html"], "OwnValues" -> 
    None, "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {Protected}, "FullName" -> 
    "System`Complex"], 
   False]]], "Output",ExpressionUUID->"89dc2ceb-321d-4470-bf57-52b424274d37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Real"}]], "Input",ExpressionUUID->"abe31ff7-73fe-4af5-8423-ec930281985c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox[
           PaneBox[
            TooltipBox[
             ButtonBox[
              PaneSelectorBox[{False->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIcon"]], True->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIconHot"]]}, Dynamic[
                CurrentValue["MouseOver"]]],
              Appearance->None,
              BaseStyle->"Link",
              ButtonData->"paclet:ref/Real",
              ButtonNote->"paclet:ref/Real"],
             "\"paclet:ref/Real\""],
            FrameMargins->{{0, 4}, {0, 2}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Real is the head used for real \
(floating\[Hyphen]point) numbers. \"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Documentation\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Documentation\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Documentation", "Tooltip"]& ], 
                   TemplateBox[{
                    
                    TemplateBox[{
                    "\"Local \[RightGuillemet]\"", "paclet:ref/Real", 
                    "paclet:ref/Real", "Link", {
                    RGBColor[0.9686274509803922, 0.4666666666666667, 0.]}, 
                    BaseStyle -> {
                    RGBColor[0.0784313725490196, 0.1568627450980392, 0.6]}}, 
                    "HyperlinkTemplate"], "\"  \"", 
                    StyleBox[
                    "\"|\"", "InformationRowLabel", StripOnInput -> False], 
                    "\"  \"", 
                    TemplateBox[{"\"Web \[RightGuillemet]\"", {
                    URL[
                    "http://reference.wolfram.com/language/ref/Real.html"], 
                    None}, "http://reference.wolfram.com/language/ref/Real.\
html", "Hyperlink", {
                    RGBColor[0.9686274509803922, 0.4666666666666667, 0.]}, 
                    BaseStyle -> {
                    RGBColor[0.0784313725490196, 0.1568627450980392, 0.6]}}, 
                    "HyperlinkTemplate"]},
                    "RowDefault"]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"System`Real\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox[
           PaneBox[
            TooltipBox[
             ButtonBox[
              PaneSelectorBox[{False->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIcon"],
                ImageSizeCache->{13., {4., 9.}}], True->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "InformationHelpIconHot"],
                ImageSizeCache->{13., {4., 9.}}]}, Dynamic[
                CurrentValue["MouseOver"]]],
              Appearance->None,
              BaseStyle->"Link",
              ButtonData->"paclet:ref/Real",
              ButtonNote->"paclet:ref/Real"],
             "\"paclet:ref/Real\""],
            FrameMargins->{{0, 4}, {0, 2}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Real is the head used for real \
(floating\[Hyphen]point) numbers. \"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "Real is the head used for real (floating\[Hyphen]point) numbers. ", 
    "Documentation" -> 
    Association[
     "Local" -> "paclet:ref/Real", "Web" -> 
      "http://reference.wolfram.com/language/ref/Real.html"], "OwnValues" -> 
    None, "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {Protected}, "FullName" -> 
    "System`Real"], 
   False]]], "Output",ExpressionUUID->"49e0c387-cc27-408d-9648-f40558ddb345"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Verbose"}]], \
"Input",ExpressionUUID->"88b32b73-2b81-4f33-b541-ba161c27bd44"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Verbose is a Boolean option for MakeRule, \
AutomaticRules and ToCanonical. Verbose->True gives lots of log-info about \
the internals of the calculation. Its default value is False.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"System`Verbose\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Verbose is a Boolean option for MakeRule, \
AutomaticRules and ToCanonical. Verbose->True gives lots of log-info about \
the internals of the calculation. Its default value is False.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "Verbose is a Boolean option for MakeRule, AutomaticRules and \
ToCanonical. Verbose->True gives lots of log-info about the internals of the \
calculation. Its default value is False.", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "System`Verbose"], 
   False]]], "Output",ExpressionUUID->"e5095704-ebfb-4c66-a772-c238140b4281"]
}, Open  ]],

Cell["These are the missing symbols to document:", \
"Text",ExpressionUUID->"6363d603-5caf-4f2c-854d-5670759ea1cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"toclassify1", "=", 
  RowBox[{"Complement", "[", 
   RowBox[{"$xTensorNames", ",", "docfiles"}], 
   "]"}]}]], "Input",ExpressionUUID->"8478b926-5fbc-4115-9f25-b07e429a5616"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Anticommutator\"\>", ",", "\<\"AntihermitianQ\"\>", 
   ",", "\<\"AnyVBundles\"\>", ",", "\<\"AssociativeProductQ\"\>", 
   ",", "\<\"At\"\>", ",", "\<\"CartesianProduct\"\>", 
   ",", "\<\"ChristoffelToGradConformal\"\>", 
   ",", "\<\"CommutativityOfProduct\"\>", ",", "\<\"Commutator\"\>", 
   ",", "\<\"ConformalFactor\"\>", ",", "\<\"ConformalRules\"\>", 
   ",", "\<\"ConformalTo\"\>", ",", "\<\"ContractProjector\"\>", 
   ",", "\<\"Cyclize\"\>", ",", "\<\"DefineCommutator\"\>", 
   ",", "\<\"DefMapping\"\>", ",", "\<\"DefProduct\"\>", 
   ",", "\<\"DependenciesOfCovD\"\>", ",", "\<\"DependenciesOfInertHead\"\>", 
   ",", "\<\"DiffeomorphismQ\"\>", ",", "\<\"DirCovDToLieD\"\>", 
   ",", "\<\"DisjointVBundlesQ\"\>", ",", "\<\"DummyAs\"\>", 
   ",", "\<\"EmptyManifold\"\>", ",", "\<\"epsilonOrientation\"\>", 
   ",", "\<\"epsilonOrientationInBasis\"\>", ",", "\<\"ExpandCommutator\"\>", 
   ",", "\<\"ExpandPullBack\"\>", ",", "\<\"ExpandPushForward\"\>", 
   ",", "\<\"ExpandSdelta\"\>", ",", "\<\"Explode\"\>", 
   ",", "\<\"FromProjected\"\>", ",", "\<\"FromStripped\"\>", 
   ",", "\<\"FromTensorDerivative\"\>", ",", "\<\"GaussCodazzi\"\>", 
   ",", "\<\"Grade\"\>", ",", "\<\"GradedProductQ\"\>", 
   ",", "\<\"GradeOfCovD\"\>", ",", "\<\"GradeOfProduct\"\>", 
   ",", "\<\"GradeOfTensor\"\>", ",", "\<\"HeadOfTensor\"\>", 
   ",", "\<\"HermitianQ\"\>", ",", "\<\"IdentityElementOfProduct\"\>", 
   ",", "\<\"IdentityMapping\"\>", ",", "\<\"ImmersionQ\"\>", 
   ",", "\<\"IModQ\"\>", ",", "\<\"ImplicitTensorDepQ\"\>", 
   ",", "\<\"Implode\"\>", ",", "\<\"InverseMapping\"\>", 
   ",", "\<\"InvertibleQ\"\>", ",", "\<\"Keep\"\>", 
   ",", "\<\"Kretschmann\"\>", ",", "\<\"LastIndex\"\>", ",", "\<\"LC\"\>", 
   ",", "\<\"Leibnitz\"\>", ",", "\<\"LinearPush\"\>", 
   ",", "\<\"MakeProjectors\"\>", ",", "\<\"ManifoldBoundary\"\>", 
   ",", "\<\"Mapping\"\>", ",", "\<\"MappingDomain\"\>", 
   ",", "\<\"MappingImage\"\>", ",", "\<\"MappingQ\"\>", 
   ",", "\<\"MultiplyHead\"\>", ",", "\<\"OrthogonalToVectorQ\"\>", 
   ",", "\<\"OrthogonalWithMetric\"\>", ",", "\<\"OtherDependencies\"\>", 
   ",", "\<\"Pair\"\>", ",", "\<\"Precompose\"\>", ",", "\<\"PrimeDagger\"\>",
    ",", "\<\"PrintAsCharacter\"\>", ",", "\<\"ProductByScalar\"\>", 
   ",", "\<\"ProductOfScalars\"\>", ",", "\<\"ProductQ\"\>", 
   ",", "\<\"Project\"\>", ",", "\<\"Projected\"\>", 
   ",", "\<\"ProjectorQ\"\>", ",", "\<\"PullBack\"\>", 
   ",", "\<\"PullBackCovD\"\>", ",", "\<\"PullBackTensor\"\>", 
   ",", "\<\"PullBackVBundle\"\>", ",", "\<\"PushForward\"\>", 
   ",", "\<\"PushForwardTensor\"\>", ",", "\<\"RegisterIndices\"\>", 
   ",", "\<\"RiemannDown\"\>", ",", "\<\"RiemannDownToRiemann\"\>", 
   ",", "\<\"RiemannToRiemannDown\"\>", ",", "\<\"ScalarsOfProduct\"\>", 
   ",", "\<\"Sdelta\"\>", ",", "\<\"SetConformalTo\"\>", 
   ",", "\<\"SetSplitTensors\"\>", ",", "\<\"SplitManifold\"\>", 
   ",", "\<\"SplitTensor\"\>", ",", "\<\"SplittingsOfManifold\"\>", 
   ",", "\<\"SplittingsOfVBundle\"\>", ",", "\<\"SplitVBundle\"\>", 
   ",", "\<\"Stripped\"\>", ",", "\<\"SubmersionQ\"\>", 
   ",", "\<\"Supercommutator\"\>", ",", "\<\"Sym\"\>", 
   ",", "\<\"SymmetryGroupOfCovD\"\>", ",", "\<\"TangentTensor\"\>", 
   ",", "\<\"TensorD\"\>", ",", "\<\"TensorDerivative\"\>", 
   ",", "\<\"Tetra\"\>", ",", "\<\"TetraRule\"\>", ",", "\<\"ToRule\"\>", 
   ",", "\<\"ToStripped\"\>", ",", "\<\"ToTensorDerivative\"\>", 
   ",", "\<\"UndefMapping\"\>", ",", "\<\"UndefProduct\"\>", 
   ",", "\<\"UxSort\"\>", ",", "\<\"xSortOrder\"\>", 
   ",", "\<\"xSortPrecedence\"\>", ",", "\<\"$DefInfoQ\"\>", 
   ",", "\<\"$ImplodeInfoQ\"\>", ",", "\<\"$IndexListColor\"\>", 
   ",", "\<\"$Mappings\"\>", ",", "\<\"$ParamDFormat\"\>", 
   ",", "\<\"$Products\"\>", ",", "\<\"$ProjectedFormat\"\>", 
   ",", "\<\"$ScalarColor\"\>", ",", "\<\"$SeparateScalarsFromScalar\"\>", 
   ",", "\<\"$TensorBoxes\"\>", ",", "\<\"$UndefInfoQ\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"f20ce355-7fb4-4543-a925-ccb5f70400b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"2cf50901-760c-4d44-95ee-7670047f3bda"],

Cell[BoxData["124"], \
"Output",ExpressionUUID->"b3d09e9f-af1d-4a89-81e9-fc9d16ae5a05"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"toclassify2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<Conformal\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<ConformalFactor\>\"", ",", "\"\<ConformalRules\>\"", ",", 
        "\"\<ConformalTo\>\"", ",", "\"\<SetConformalTo\>\"", ",", 
        "\"\<ChristoffelToGradConformal\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<Mapping\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<At\>\"", ",", "\"\<CartesianProduct\>\"", ",", 
        "\"\<DefMapping\>\"", ",", "\"\<DiffeomorphismQ\>\"", ",", 
        "\"\<ExpandPullBack\>\"", ",", "\"\<ExpandPushForward\>\"", ",", 
        "\"\<IdentityMapping\>\"", ",", "\"\<ImmersionQ\>\"", ",", 
        "\"\<InverseMapping\>\"", ",", "\"\<InvertibleQ\>\"", ",", 
        "\"\<LinearPush\>\"", ",", "\"\<Mapping\>\"", ",", 
        "\"\<MappingDomain\>\"", ",", "\"\<MappingImage\>\"", ",", 
        "\"\<MappingQ\>\"", ",", "\"\<Precompose\>\"", ",", 
        "\"\<PullBack\>\"", ",", "\"\<PullBackCovD\>\"", ",", 
        "\"\<PullBackTensor\>\"", ",", "\"\<PullBackVBundle\>\"", ",", 
        "\"\<PushForward\>\"", ",", "\"\<PushForwardTensor\>\"", ",", 
        "\"\<SubmersionQ\>\"", ",", "\"\<TangentTensor\>\"", ",", 
        "\"\<UndefMapping\>\"", ",", "\"\<$Mappings\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<Projectors\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<ContractProjector\>\"", ",", "\"\<DisjointVBundlesQ\>\"", ",", 
        "\"\<ProjectorQ\>\"", ",", "\"\<SetSplitTensors\>\"", ",", 
        "\"\<SplitManifold\>\"", ",", "\"\<SplitTensor\>\"", ",", 
        "\"\<SplitVBundle\>\"", ",", "\"\<FromProjected\>\"", ",", 
        "\"\<Project\>\"", ",", "\"\<Projected\>\"", ",", 
        "\"\<$ProjectedFormat\>\"", ",", "\"\<MakeProjectors\>\"", ",", 
        "\"\<OrthogonalWithMetric\>\"", ",", "\"\<OrthogonalToVectorQ\>\""}], 
       "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<Symmetries\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Cyclize\>\"", ",", "\"\<ExpandSdelta\>\"", ",", "\"\<Sdelta\>\"", 
        ",", "\"\<Sym\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<Derivatives\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<LC\>\"", ",", "\"\<DependenciesOfCovD\>\"", ",", 
        "\"\<DirCovDToLieD\>\"", ",", "\"\<FromTensorDerivative\>\"", ",", 
        "\"\<Explode\>\"", ",", "\"\<Implode\>\"", ",", 
        "\"\<ImplicitTensorDepQ\>\"", ",", "\"\<Kretschmann\>\"", ",", 
        "\"\<OtherDependencies\>\"", ",", "\"\<RiemannDown\>\"", ",", 
        "\"\<RiemannDownToRiemann\>\"", ",", "\"\<RiemannToRiemannDown\>\"", 
        ",", "\"\<ToTensorDerivative\>\"", ",", "\"\<$ImplodeInfoQ\>\"", ",", 
        "\"\<TensorD\>\"", ",", "\"\<TensorDerivative\>\"", ",", 
        "\"\<$ParamDFormat\>\"", ",", "\"\<Tetra\>\"", ",", 
        "\"\<TetraRule\>\"", ",", "\"\<SymmetryGroupOfCovD\>\"", ",", 
        "\"\<Leibnitz\>\"", ",", "\"\<GaussCodazzi\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<Other\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<AnyVBundles\>\"", ",", "\"\<DummyAs\>\"", ",", 
        "\"\<FromStripped\>\"", ",", "\"\<Keep\>\"", ",", "\"\<LastIndex\>\"",
         ",", "\"\<PrintAsCharacter\>\"", ",", "\"\<RegisterIndices\>\"", 
        ",", "\"\<SplittingsOfManifold\>\"", ",", 
        "\"\<SplittingsOfVBundle\>\"", ",", "\"\<Stripped\>\"", ",", 
        "\"\<ToStripped\>\"", ",", "\"\<IModQ\>\"", ",", "\"\<$DefInfoQ\>\"", 
        ",", "\"\<$IndexListColor\>\"", ",", "\"\<$ScalarColor\>\"", ",", 
        "\"\<$TensorBoxes\>\"", ",", "\"\<$UndefInfoQ\>\"", ",", 
        "\"\<HeadOfTensor\>\"", ",", "\"\<MultiplyHead\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<Complex\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<AntihermitianQ\>\"", ",", "\"\<HermitianQ\>\"", ",", 
        "\"\<Pair\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<epsilon\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<epsilonOrientation\>\"", ",", 
        "\"\<epsilonOrientationInBasis\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<Products\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<AssociativeProductQ\>\"", ",", "\"\<Commutator\>\"", ",", 
        "\"\<DefineCommutator\>\"", ",", "\"\<DefProduct\>\"", ",", 
        "\"\<Grade\>\"", ",", "\"\<GradedProductQ\>\"", ",", 
        "\"\<GradeOfCovD\>\"", ",", "\"\<GradeOfProduct\>\"", ",", 
        "\"\<GradeOfTensor\>\"", ",", "\"\<IdentityElementOfProduct\>\"", 
        ",", "\"\<ProductByScalar\>\"", ",", "\"\<ProductQ\>\"", ",", 
        "\"\<ScalarsOfProduct\>\"", ",", "\"\<CommutativityOfProduct\>\"", 
        ",", "\"\<UndefProduct\>\"", ",", "\"\<$Products\>\""}], "}"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"3aa2839a-4378-4e89-8808-0d1ff8fd94b9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{"toclassify1", ",", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Last", "/@", "toclassify2"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1d7b53fd-8b51-4b51-92f7-294dcbbddd85"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Anticommutator\"\>", ",", "\<\"DependenciesOfInertHead\"\>", 
   ",", "\<\"EmptyManifold\"\>", ",", "\<\"ExpandCommutator\"\>", 
   ",", "\<\"ManifoldBoundary\"\>", ",", "\<\"PrimeDagger\"\>", 
   ",", "\<\"ProductOfScalars\"\>", ",", "\<\"Supercommutator\"\>", 
   ",", "\<\"ToRule\"\>", ",", "\<\"UxSort\"\>", ",", "\<\"xSortOrder\"\>", 
   ",", "\<\"xSortPrecedence\"\>", 
   ",", "\<\"$SeparateScalarsFromScalar\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"36cfbbdf-6629-4060-9aae-7720d0eb2cbc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    RowBox[{"Last", "/@", "toclassify2"}], "]"}], ",", "toclassify1"}], 
  "]"}]], "Input",ExpressionUUID->"90bbaa5d-d2df-4424-901e-37c83e6fb779"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"24414689-34a4-40d2-a1fd-b38777abec42"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", 
   RowBox[{
   "filename", ",", "docfiles", ",", "toclassify1", ",", "toclassify2"}], 
   "]"}], ";"}]], \
"Input",ExpressionUUID->"39d8090e-c842-4a6d-8dd6-3525afbf0426"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.2. Types", \
"Subsubsection",ExpressionUUID->"a6d888f9-7d29-4fa6-8912-794e4f977d12"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Removing", " ", "symbols"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CheckRemoveSymbol", "::", "usage"}], "=", 
     "\"\<xTensor`Private`CheckRemoveSymbol[symbol] throws an error if symbol \
has visitors or its master has other servants. Otherwise it gives \
Null.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RemoveSymbol", "::", "usage"}], "=", 
     "\"\<xTensor`Private`RemoveSymbol[symbol] unprotects (if protected) and \
removes symbol.\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"16b39a67-a977-4961-8fce-9100b0c3057c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbols", " ", "relations"}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{"SymbolRelations", "::", "usage"}], "=", 
    "\"\<xTensor`Private`SymbolRelations[symbol, master, hosts] defines the \
pair master-servant, and register symbol as a visitor of the given list of \
hosts. This function is listable in its first argument.\>\""}], 
   ";"}]}]], "Input",ExpressionUUID->"842dbcfc-f19b-4731-80ca-0c4c8b5abc75"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Types", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"$Types", "::", "usage"}], "=", 
     "\"\<xTensor`Private`$Types is a global variable containing the list of \
types currently defined in xTensor.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$QFunctions", "::", "usage"}], "=", 
     "\"\<xTensor`Private`$QFunctions is a global variable containing the \
list of Q-functions associated to the types in $Types.\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"48e73b1b-3888-4e35-829f-c2334bd9c846"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Box", "-", 
    RowBox[{"formatting", " ", "of", " ", "expressions"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetPrintAs", "::", "usage"}], "=", 
     "\"\<xTensor`Private`SetPrintAs[symbol, string] defines the PrintAs \
upvalue associated to the symbol to be the given string. It uses xUpSet or \
xUpSetDelayed to protect/unprotect symbol if required.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AddDaggerCharacter", "::", "usage"}], "=", 
     "\"\<xTensor`Private`AddDaggerCharacter[string, Conjugate] appends the \
$DaggerCharacter to string if it not present already. \
AddDaggerCharacter[string, dag] returns string for any other value of \
dag.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsString", "::", "usage"}], "=", 
     "\"\<xTensor`Private`PrintAsString[symbol, pa] returns pa if pa has head \
String. Otherwise it assumes pa is a function to be applied on symbol and \
returns ToString[pa[symbol]].\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"interpretbox", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"interpretboxcolor", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"boxof", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeSequenceBox", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"dce2bfb7-4ba1-4796-be40-3f42d5d14695"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Def", "/", "Undef"}], " ", "messages"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"makespace", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeDefInfo", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeUndefInfo", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], "Input",ExpressionUUID->"2b3bd74d-dd92-4b92-8cbe-17611de497cf"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.3. Four simple types", \
"Subsubsection",ExpressionUUID->"f01b656a-5c08-4169-9804-b4dcd34a252c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"$sfunctions", "::", "usage"}], "=", 
   "\"\<xTensor`Private`$sfunctions is a global variable containing the list \
of functions which are initially defined as scalar-functions.\>\""}], 
  ";"}]], "Input",ExpressionUUID->"14084b26-b50b-4982-861c-098bf312aa4b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetDaggerPair", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",ExpressionUUID->"23f9e531-3fac-4854-a26b-9ef737e82ce8"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.4. The mathematical input", \
"Subsubsection",ExpressionUUID->"a2d47976-15f8-40fd-bd94-9874666231c5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ListOfTerms", "::", "usage"}], "=", 
   "\"\<xTensor`Private`ListOfTerms[expr] gives the list of elements of expr \
if its head is Plus and {expr} otherwise. The expression expr is evaluated \
and expanded (using Expand) before checking its head.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListOfFactors", "::", "usage"}], "=", 
   "\"\<xTensor`Private`ListOfFactors[expr] gives the list of elements of \
expr if its head is Times and {expr} otherwise. The expression expr is \
evaluated and factored (usign Factor) before checking its head.\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"6e2c9935-82ca-4687-81b7-28e39a9c025f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MathInputExpand", "::", "usage"}], "=", 
   "\"\<xTensor`Private`MathInputExpand[expr] applies Expand to expr using \
FixedPoint.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NonIndexedScalarQ", "::", "usage"}], "=", 
   "\"\<xTensor`Private`NonIndexedScalarQ[expr] returns True if expr is an \
explicit scalar: Scalar[x], tensor[], constant, parameter, \
scalar-function[x].\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"742ad1ac-dd57-4b5f-b787-bf5600b1ae0f"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.5. Indices", \
"Subsubsection",ExpressionUUID->"3b7d66fa-4762-4a14-a650-3d102f34f331"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Index", " ", "validation"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ValidateIndex", "::", "usage"}], "=", 
     "\"\<xTensor`Private`ValidateIndex[i] checks that i is a valid symbol, \
that it does not have an associated type, and gives a warning message if it \
is one of the capitals that Mathematica uses. \
xTensor`Private`ValidateIndex[i, False] does not give that warning message.\>\
\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ValidateGIndex", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ValidateIndexList", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ModuleNumberOfIndex", "::", "usage"}], "=", 
     "\"\<ModuleNumberOfIndex[i] returns the value of $ModuleNumber at the \
time of definition of the abstract index i. This is used to remove the dollar \
indices associated to i in UndefAbstractIndex.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RemoveDollarIndices", "::", "usage"}], "=", "\"\<\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexOnQ", "::", "usage"}], "=", 
     "\"\<xTensor`Private`IndexOnQ[i, vbundle] gives True if index i belongs \
to the bundle vbundle (or to a subvbundle of vbundle) and False otherwise. \
xTensor`Private`IndexQ[i, {vb1, vb2, ...}] gives True if index i belongs to \
one of the bundles (or their subvbundles) in the list {vb1, vb2, ...}.\>\""}],
     ";"}]}]}]], \
"Input",ExpressionUUID->"6a650724-a2e4-44fa-a16c-7b95959c5aff"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Index", " ", "notations"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"upQ", "::", "usage"}], "=", 
     "\"\<xTensor`Private`upQ[ind] gives True if ind is an up-index and False \
otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"downQ", "::", "usage"}], "=", 
     "\"\<xTensor`Private`downQ[ind] gives True if ind is a down-index and \
False otherwise.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "::", "usage"}], "=", 
     "\"\<xTensor`Private`NoDollar[ind] returns the symbol ind (possibly \
including a sign) removing all characters starting from the first $. Values \
are stored as upvalues of the index ind.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DollarQ", "::", "usage"}], "=", 
     "\"\<xTensor`Private`DollarQ[ind] and DollarQ[-ind] give True if ind \
contains the character $ and False otherwise.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndexQ", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "::", "usage"}], "=", 
     "\"\<xTensor`Private`PatternToIndex[expr] changes every pattern, \
patterntest or condition in expr to the name of the pattern, patterntest or \
condition.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexPosition", "::", "usage"}], "=", 
     "\"\<xTensor`Private`IndexPosition[list, ind] gives the positions of \
index ind in list. The index ind can be an up/down-index and the list can \
have any head.\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"c1b451ab-7a7f-4443-87d5-c760f91580ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defining", " ", "free", " ", "and", " ", "paired", " ", "indices"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TakeOrderedEPairs", "::", "usage"}], "=", 
     "\"\<xTensor`Private`TakeOrderedEPairs[indlist] gives the list of \
g-indices in list indlist which are paired, keeping the original \
order.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeFrees", "::", "usage"}], "=", 
     "\"\<xTensor`Private`TakeFrees[indlist] gives the list of g-indices in \
list indlist which are not paired. The original order is not kept.\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeEIndices", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeEPairs", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"dbd1c983-20ff-4f92-8e09-ebb500eeda01"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Sorting", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Sort0", "::", "usage"}], "=", 
     "\"\<xTensor`Private`Sort0 is an internal function sorting the types of \
indices: 1) labels, 2) patterns, 3) directions, 4) integer bases, 5) symbol \
bases, 6) abstract-indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sort1", "::", "usage"}], "=", 
     "\"\<xTensor`Private`Sort1 is an internal function specifying the first \
priority for sorting indices.\>\""}], ";", 
    RowBox[{
     RowBox[{"Sort2", "::", "usage"}], "=", 
     "\"\<xTensor`Private`Sort2 is an internal function specifying the second \
priority for sorting indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sort3", "::", "usage"}], "=", 
     "\"\<xTensor`Private`Sort3 is an internal function specifying the third \
priority for sorting indices.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "::", "usage"}], "=", 
     "\"\<xTensor`Private`SortPriority[string] returns the function to be \
used for index sorting associated to the given string priority: one of \\\"up\
\\\"/\\\"down\\\", \\\"free\\\"/\\\"dummy\\\", \
\\\"lexicographic\\\"/\\\"antilexicographic\\\"/\\\"positional\\\"/\\\"\
antipositional\\\".\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"validpriority", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"9e024b60-0fe8-4e03-a142-06f270e763cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Finding", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexName", "::", "usage"}], "=", 
     "\"\<xTensor`Private`IndexName[i] returns the so-called name of the \
g-index i. For abstract indices, the name equals the index. For basis \
indices, it returns the corresponding abstract index or 0 for a component \
index. For directional indices, labels and Blanks the name is also defined as \
0.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckHomogeneity", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"check", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckRepeated", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckIndexType", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"check2", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices1", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindFreeAndDummyIndices", "::", "usage"}], "=", 
     "\"\<xTensor`Private`FindFreeAndDummyIndices[expr] gives a list \
containing FindFreeIndices[expr] and FindDummyIndices[expr] respectively. See \
notes for those functions.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeRepeated", "::", "usage"}], "=", 
     "\"\<xTensor`Private`TakeRepeated[list] returns the list of indices \
which are repeated in the list (both input and output lists with head \
IndexList).\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeUp", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "::", "usage"}], "=", 
     "\"\<xTensor`Private`UltraindexOf[expr] checks that expr is a covariant \
or a contravariant vector and returns its free index. On Pattern expressions \
it gives None.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"checkultraindex", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"3ea3cc74-5d2e-4eb8-b2b0-b0d80a1ca6b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Replacing", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"replacepattern", "::", "usage"}], "=", 
     "\"\<xTensor`Private`replacepattern[patindex, rules, sign] replaces the \
pattern index patindex according to the rules. If the index is actually \
changed then a message is sent reporting about it and asking to contact \
JMM.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceBasisIndex", "::", "usage"}], "=", 
     "\"\<xTensor`Private`ReplaceBasisIndex[biold, binew, rules] replaces the \
basis index biold. It first tries to use the rules on the abstract index of \
biold, keeping the basis. If that does not produce a change then binew is \
returned.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceIndexList", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceDummies2", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FastReplaceDummies", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SameVBundleRules", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"md", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], "Input",ExpressionUUID->"b0576941-a454-4389-8b4e-160e950ce813"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.6. Manifolds and vector bundles", \
"Subsubsection",ExpressionUUID->"8297f5b7-7eda-4001-b0bb-c56143aa4960"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Manifolds", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"checkDefManifold", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RegisterIndexInVBundle", "::", "usage"}], "=", 
     "\"\<xTensor`Private`RegisterIndexInVBundle[ind, vb] registers the \
abstract index ind (a symbol) in the vbundle vb.\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"checkDefVBundle", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RegisterVBundle", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Dependencies", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfIndices", "::", "usage"}], "=", 
     "\"\<xTensor`Private`DependenciesOfIndices\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfIndex", "::", "usage"}], "=", 
     "\"\<xTensor`Private`DependenciesOfIndex\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortDependencies", "::", "usage"}], "=", 
     "\"\<xTensor`Private`SortDependencies\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "VBundles", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FirstMetricOfVBundle", "::", "usage"}], "=", 
     "\"\<xAct`xTensor`Private`FirstMetricOfVBundle[vbundle] gives the first \
metric of the list MetricsOfVBundle[vbundle]. There is an optional Boolean \
second argument which decides if an error message is thrown in case that list \
is empty. The default is True.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FirstMetricQ", "::", "usage"}], "=", 
     "\"\<xAct`xTensor`Private`FirstMetricQ[metric] returns True if metric is \
the first-metric of some vbundle, and False otherwise. \
xAct`xTensor`Private`FirstMetricQ[metric, vbundle] returns True if metric is \
the first-metric of vbundle, False if it is not, and throws an error if \
vbundle has no metrics.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"$FirstMetrics", "::", "usage"}], "=", 
     "\"\<xAct`xTensor`Private`$FirstMetrics is a global variable containing \
the list of all metrics which are first-metric of some vbundle.\>\""}], 
    ";"}]}]}]], "Input",ExpressionUUID->"22eb2295-2034-4d69-a7d5-07e3cc77db1f"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.7. Formatting", \
"Subsubsection",ExpressionUUID->"b9807281-448c-49fb-82ab-aa38eb8f491b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AddIndex", "::", "usage"}], "=", 
   "\"\<AddIndex[{downstring, upstring}, index] adds index to downstring or \
upstring depending on whether index is covariant or contravariant, \
respectively, and a space to the other. It returns the new pair of \
strings.\\n\n    AddIndex[{downstring, upstring}, index, covd] adds the \
symbol of derivative covd and index to downstring or upstring depending on \
whether index is covariant or contravariant, respectively, and two spaces to \
the other. It returns the new pair of strings.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AddLastQuote", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DropLastQuote", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"horizonal", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"addIndex", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"screenrules", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"screenindices", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"screenreplace", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"getindex", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexPair", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"UpIndexPair", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"7c628094-706b-4251-ad87-cdb12e503923"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.8. Tensors", \
"Subsubsection",ExpressionUUID->"01b7523b-cf62-4d30-9fd1-c5dca5085ce3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkSetOrthogonal", "::", "usage"}], "=", 
   "\"\<xTensor`Private`checkSetOrthogonal[inds, ind] checks compatibility \
between the list of indices inds and the index ind.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkSetProjected", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateTensor", "::", "usage"}], "=", 
   "\"\<xAct`xTensor`Private`ValidateTensor[tensor[inds]] validates the name, \
indices and index-structure of the given tensor.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateDir", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ParametersOfTensor", "::", "usage"}], "=", 
   "\"\<xTensor`Private`ParametersOfTensor\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldsOfTensor", "::", "usage"}], "=", 
   "\"\<xTensor`Private`ManifoldsOfTensor\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"641e11a8-937e-4811-a9a7-060bc2f4b55a"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.0. Rules", \
"Subsubsection",ExpressionUUID->"3542fac1-d7ae-44d4-ab0b-fd34c408196b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Rules", " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MakeRule1", "::", "usage"}], "=", 
     "\"\<xAct`xTensor`Private`MakeRule1[{LHS, RHS}] gives a delayed rule \
with left and right hand sides as given by LHS and RHS respectively. See \
notes for its options MetricOn and TestIndices. MakeRule1[{LHS, RHS, \
conditions}] adds conditions to the rules.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryEquivalentsOfTensor", "::", "usage"}], "=", 
     "\"\<xAct`xTensor`Private`SymmetryEquivalentsOfTensor[tensor[indices], \
freeinds] gives a list of tensors which are equivalent to the given tensor \
(with free indices freeinds) from the symmetry point of view, but are not \
equal from the pattern point of view.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryEquivalentsOf", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], "Input",ExpressionUUID->"7b6e021b-ba49-4937-8d1e-d6a31600eb16"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.10. Covariant derivatives", \
"Subsubsection",ExpressionUUID->"5e4db639-a260-4834-99a7-3ce8935dd0fb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RiemannToWeylRules", "::", "usage"}], "=", 
   "\"\<RiemannToWeylRules[covd] gives the list of rules that are applied by \
RiemannToWeyl.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeylToRiemannRules", "::", "usage"}], "=", 
   "\"\<WeylToRiemannRules[covd] gives the list of rules that are applied by \
WeylToRiemann.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RicciToEinsteinRules", "::", "usage"}], "=", 
   "\"\<RicciToEinsteinRules[covd] gives the list of rules that are applied \
by RicciToEinstein.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EinsteinToRicciRules", "::", "usage"}], "=", 
   "\"\<EinsteinToRicciRules[covd] gives the list of rules that are applied \
by EinsteinToRicci.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricToProjectorRules", "::", "usage"}], "=", 
   "\"\<MetricToProjectorRules[metric] gives the list of rules that are \
applied by MetricToProjector.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ProjectorToMetricRules", "::", "usage"}], "=", 
   "\"\<ProjectorToMetricRules[metric] gives the list of rules that are \
applied by ProjectorToMetric.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateCovD", "::", "usage"}], 
   "\"\<ValidateCovD[covd[ind][expr]] validates the name, index and \
compatibility of the given covariant derivative. It uses Validate on \
expr.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ZeroDerivativeQ", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeOrthogonalDerivative", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeProjectedDerivative", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InducedCovDQ", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"8530bcc3-9060-4e55-bd87-fe43899d4e32"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.11. Lie derivatives", \
"Subsubsection",ExpressionUUID->"b4d843fd-a92e-43a0-8e10-71bb4f72b2b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidateLieD", "::", "usage"}], "=", 
   "\"\<ValidateLieD[LieD[v][expr]] validates that that v is a contravariant \
vector and uses Validate on expr.\>\""}], 
  ";"}]], "Input",ExpressionUUID->"84dc90c8-c81a-42dc-a3fe-16d8f38d548c"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.12. Canonicalization", \
"Subsubsection",ExpressionUUID->"00ffdb66-2a1c-469a-8623-0882c6e31ea6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Canonicalization", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalOne", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Sorting", " ", "tensors"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ObjectsWithIndices", "::", "usage"}], "=", 
     "\"\<ObjectsWithIndices[term, index] yields the objects in term (a Times \
product) that have the given index. ObjectsWithIndices[term, indlist] yields \
a list of objects in term having one or several of the indices in \
indlist.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindMonomial", "::", "usage"}], "=", 
     "\"\<FindMonomial[term, index, frees] gives the monomial (contracted \
product of tensors) in term (a Times product containing tensors) that has the \
given index. The list frees is the list of free indices of term, supplied to \
avoid repetition of its computation.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ObjectOrder", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CommutingObjects", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], "Input",ExpressionUUID->"7bb9b950-65d7-4d61-b5bc-51e959c0f077"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.13. Metrics", \
"Subsubsection",ExpressionUUID->"7cb53dbe-f977-47b8-a599-2fda8da0f074"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Metrics", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ContractMetric1", "::", "usage"}], "=", 
     "\"\<ContractMetric1[expr, metric] contracts all instances of metric in \
expr.\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ProductMetricRules", "::", "usage"}], "=", 
     "\"\<ProductMetricRules[metric] gives the list of rules that are applied \
by ExpandProductMetric.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FrozenMetricQ", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], "Input",ExpressionUUID->"b3c1d2eb-76c3-4f88-a833-ed60deec02fb"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3.14. Collect symbols", \
"Subsubsection",ExpressionUUID->"d47d8114-c411-41d3-8fae-fc9d4fd8c8c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$xTensorPrivateNames", "=", 
  RowBox[{
  "Names", "[", "\"\<xAct`xTensor`Private`*\>\"", 
   "]"}]}]], "Input",ExpressionUUID->"f7ee4b68-0a50-4e88-9902-0c7c2d7fb5a5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"AddDaggerCharacter\"\>", ",", "\<\"addIndex\"\>", 
   ",", "\<\"AddIndex\"\>", ",", "\<\"AddLastQuote\"\>", 
   ",", "\<\"BeginExamples\"\>", ",", "\<\"boxof\"\>", ",", "\<\"check\"\>", 
   ",", "\<\"check2\"\>", ",", "\<\"checkDefManifold\"\>", 
   ",", "\<\"checkDefVBundle\"\>", ",", "\<\"CheckHomogeneity\"\>", 
   ",", "\<\"CheckIndexType\"\>", ",", "\<\"CheckRemoveSymbol\"\>", 
   ",", "\<\"CheckRepeated\"\>", ",", "\<\"checkSetOrthogonal\"\>", 
   ",", "\<\"checkSetProjected\"\>", ",", "\<\"checkultraindex\"\>", 
   ",", "\<\"CommutingObjects\"\>", ",", "\<\"ContractMetric1\"\>", 
   ",", "\<\"DaggerIndexQ\"\>", ",", "\<\"DependenciesOfIndex\"\>", 
   ",", "\<\"DependenciesOfIndices\"\>", ",", "\<\"DollarQ\"\>", 
   ",", "\<\"downQ\"\>", ",", "\<\"DropLastQuote\"\>", 
   ",", "\<\"EinsteinToRicciRules\"\>", ",", "\<\"expr\"\>", 
   ",", "\<\"FastReplaceDummies\"\>", ",", "\<\"FindFreeAndDummyIndices\"\>", 
   ",", "\<\"FindIndices1\"\>", ",", "\<\"FindMonomial\"\>", 
   ",", "\<\"FirstMetricOfVBundle\"\>", ",", "\<\"FirstMetricQ\"\>", 
   ",", "\<\"FrozenMetricQ\"\>", ",", "\<\"getindex\"\>", 
   ",", "\<\"HoldReplaceIndex\"\>", ",", "\<\"horizonal\"\>", 
   ",", "\<\"IndexName\"\>", ",", "\<\"IndexOnQ\"\>", 
   ",", "\<\"IndexPair\"\>", ",", "\<\"IndexPosition\"\>", 
   ",", "\<\"IndexType\"\>", ",", "\<\"InducedCovDQ\"\>", 
   ",", "\<\"interpretbox\"\>", ",", "\<\"interpretboxcolor\"\>", 
   ",", "\<\"ListOfFactors\"\>", ",", "\<\"ListOfTerms\"\>", 
   ",", "\<\"MakeDefInfo\"\>", ",", "\<\"MakeOrthogonalDerivative\"\>", 
   ",", "\<\"MakeProjectedDerivative\"\>", ",", "\<\"MakeRule1\"\>", 
   ",", "\<\"MakeSequenceBox\"\>", ",", "\<\"makespace\"\>", 
   ",", "\<\"MakeUndefInfo\"\>", ",", "\<\"ManifoldsOfTensor\"\>", 
   ",", "\<\"MathInputExpand\"\>", ",", "\<\"md\"\>", 
   ",", "\<\"MetricToProjectorRules\"\>", ",", "\<\"ModuleNumberOfIndex\"\>", 
   ",", "\<\"NoDollar\"\>", ",", "\<\"NonIndexedScalarQ\"\>", 
   ",", "\<\"ObjectOrder\"\>", ",", "\<\"ObjectsWithIndices\"\>", 
   ",", "\<\"ParametersOfTensor\"\>", ",", "\<\"PatternToIndex\"\>", 
   ",", "\<\"PrintAsString\"\>", ",", "\<\"ProductMetricRules\"\>", 
   ",", "\<\"ProjectorToMetricRules\"\>", 
   ",", "\<\"RegisterIndexInVBundle\"\>", ",", "\<\"RegisterVBundle\"\>", 
   ",", "\<\"RemoveDollarIndices\"\>", ",", "\<\"RemoveSymbol\"\>", 
   ",", "\<\"ReplaceBasisIndex\"\>", ",", "\<\"ReplaceDummies2\"\>", 
   ",", "\<\"ReplaceIndexList\"\>", ",", "\<\"ReplaceOneIndex\"\>", 
   ",", "\<\"replacepattern\"\>", ",", "\<\"RicciToEinsteinRules\"\>", 
   ",", "\<\"RiemannToWeylRules\"\>", ",", "\<\"SameVBundleRules\"\>", 
   ",", "\<\"screenindices\"\>", ",", "\<\"screenreplace\"\>", 
   ",", "\<\"screenrules\"\>", ",", "\<\"SetDaggerPair\"\>", 
   ",", "\<\"SetPrintAs\"\>", ",", "\<\"Sort0\"\>", ",", "\<\"Sort1\"\>", 
   ",", "\<\"Sort2\"\>", ",", "\<\"Sort3\"\>", 
   ",", "\<\"SortDependencies\"\>", ",", "\<\"SortPriority\"\>", 
   ",", "\<\"string\"\>", ",", "\<\"SymbolRelations\"\>", 
   ",", "\<\"SymmetryEquivalentsOf\"\>", 
   ",", "\<\"SymmetryEquivalentsOfTensor\"\>", ",", "\<\"TakeEIndices\"\>", 
   ",", "\<\"TakeEPairs\"\>", ",", "\<\"TakeFrees\"\>", 
   ",", "\<\"TakeOrderedEPairs\"\>", ",", "\<\"TakeRepeated\"\>", 
   ",", "\<\"TakeUp\"\>", ",", "\<\"ToCanonicalOne\"\>", 
   ",", "\<\"UltraindexOf\"\>", ",", "\<\"UpIndexPair\"\>", 
   ",", "\<\"upQ\"\>", ",", "\<\"ValidateCovD\"\>", 
   ",", "\<\"ValidateDir\"\>", ",", "\<\"ValidateGIndex\"\>", 
   ",", "\<\"ValidateIndex\"\>", ",", "\<\"ValidateIndexList\"\>", 
   ",", "\<\"ValidateLieD\"\>", ",", "\<\"ValidateTensor\"\>", 
   ",", "\<\"validpriority\"\>", ",", "\<\"WeylToRiemannRules\"\>", 
   ",", "\<\"xTensorSymbols\"\>", ",", "\<\"ZeroDerivativeQ\"\>", 
   ",", "\<\"$FirstMetrics\"\>", ",", "\<\"$QFunctions\"\>", 
   ",", "\<\"$sfunctions\"\>", ",", "\<\"$Types\"\>", 
   ",", "\<\"$xTensorDollarNames\"\>", ",", "\<\"$xTensorNonDollarNames\"\>", 
   ",", "\<\"$xTensorPrivateNames\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"b5cc7021-c9cc-4b41-9c9e-d5a478fab34c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"19742f0c-314b-4ab5-bf95-d907f6a253b5"],

Cell[BoxData["123"], \
"Output",ExpressionUUID->"91dfe864-48f2-4eee-8397-4b203da61a76"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["2. Types",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"c726b000-5623-48d4-9ce1-652522522aa2"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
    "**", "**", "**", " ", "2."}], "Types"}], " ", 
  "******************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7e45b16a-d6d4-4a2b-9b05-1ca6bddcf014"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"f8ac9967-6aae-44ce-86ce-d60183701bd1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "6.805566`", ",", "286.372818`8.908476786626052", ",", 
   "0.023764799064045317`"}], 
  "}"}]], "Output",ExpressionUUID->"2c1efe68-c039-4e71-aa0f-94db818d5bf8"]
}, Open  ]],

Cell[CellGroupData[{

Cell["2.0. Comments", \
"Subsection",ExpressionUUID->"e72ca677-ee65-43ab-b838-b6cad68aad69"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "  is an untyped system, but I think it is convenient to use a \
type-definition system to do tensor calculus. Here we construct our own type \
system."
}], "Text",ExpressionUUID->"02a54039-dc0a-46e6-9a61-153216d4c5cb"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 2: Types.\>\"", "]"}], ",", 
   "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a8641868-ccd4-461c-998b-bd63d925653a"],

Cell[CellGroupData[{

Cell["2.0.1. Symbols versus strings", \
"Subsubsection",ExpressionUUID->"e76d73e2-71e6-4a0f-83f0-ff889e9bdcf8"],

Cell["\<\
Note the difference between symbols and names: names are always strings; \
symbols have names. From strings to symbols use Symbol:\
\>", "Text",ExpressionUUID->"de00aba8-8302-449a-b8b4-9a90185371e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Symbol", "[", "\"\<hello\>\"", 
  "]"}]], "Input",ExpressionUUID->"494a8541-705a-4bbf-a6cb-52f9a7449a1f"],

Cell[BoxData["hello"], \
"Output",ExpressionUUID->"d0200351-68e2-421f-8912-170e2a0daea3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"a1d8b74b-9e79-49c2-8b58-50d0ec2d3df4"],

Cell[BoxData["Symbol"], \
"Output",ExpressionUUID->"143e4440-c08e-4a25-8306-426e809c0612"]
}, Open  ]],

Cell["\<\
or the more general ToExpression. From symbols to strings use SymbolName:\
\>", "Text",ExpressionUUID->"f29f9989-28f7-4ac6-9c62-dc1b7101bda3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymbolName", "[", "%%", 
  "]"}]], "Input",ExpressionUUID->"51ebd49e-f8e8-4e6e-a715-6d50b9c06fa4"],

Cell[BoxData["\<\"hello\"\>"], \
"Output",ExpressionUUID->"fa2f0aea-8399-49e7-95a2-4ef1bd29596d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"173513af-f482-4b88-ace0-00b9afa4110e"],

Cell[BoxData["String"], \
"Output",ExpressionUUID->"68aa663a-24eb-4c25-bbcc-8398220353f2"]
}, Open  ]],

Cell["or the more general ToString.", \
"Text",ExpressionUUID->"6d003617-f69c-4f25-82fa-8204bd51aaea"],

Cell[TextData[{
 "A first major decision in the design of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is the following: all objects will be identified with symbols (not \
strings) in order to associate them the corresponding definitions (it is not \
possible to associate definitions to strings). This follows both the rule of \
simplicity and the rule of compliance with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s way. This decision has, however, several drawbacks:\n\t1) Many symbols \
are already used by ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", or by ",
 StyleBox["xTensor, xPerm, xCoba, xCore.",
  FontSlant->"Italic"],
 " Those symbols will not be allowed to represent  ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " objects. We shall define a set of functions that store the known symbols \
and analyze whether a candidate name for a new object is allowed or not. We \
will see that there are a few special cases.\n\t2) Defined symbols will have \
a \"type\". A symbol cannot have two types to avoid conflicting information. \
We could introduce contexts Tensor`, Spinor`, Form`, etc, but it is not clear \
what it would really improve. I think it is more flexible to let the user \
decide two different names to distinguish the objects.\n\t3) A symbol can \
have ownvalues. For example if T is a tensor we can also say T=1, which will \
generate all kinds of errors. This is normal ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ": if you have a function f[x] you can say f=1. A way of avoiding this could \
be protecting the symbol of any defined object, but this requires \
unprotecting symbols when you want to associate new definitions to them. We \
introduce the global variable $ProtectNewSymbols and the option \
ProtectNewSymbol to control this point, together with some ",
 StyleBox["xCore",
  FontSlant->"Italic"],
 " functions xUpSet and similar which are able to unprotect/reprotect symbols."
}], "Text",ExpressionUUID->"938060d9-3870-4dc5-b551-f64838a9e3bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
  "x", "^", 
   "2"}]}]], "Input",ExpressionUUID->"4669f067-6c2a-4240-9d94-9db4eadea4d9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "3", 
  "]"}]], "Input",ExpressionUUID->"4c2850b1-17f0-4a56-8b99-bfc1e05a9e6c"],

Cell[BoxData["9"], \
"Output",ExpressionUUID->"d3bca5da-1dca-45d0-ac0c-32eea98a2581"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "=", 
  "1"}]], "Input",ExpressionUUID->"1e807120-b794-48ea-81fe-819f2a8169cf"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"3b6c077b-3498-47da-9b85-a62809c0c9d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "f"}]], "Input",ExpressionUUID->"483fe4a4-20d8-47c4-a2f9-712352bf9ee7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xAct`xTensor`Private`f\"\>", "InformationUsageText",
             
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Assignment\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"OwnValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "OwnValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{"f", "=", "1"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" DownValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"DownValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "DownValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"f", "[", "x_", "]"}], ":=", 
                    SuperscriptBox["x", "2"]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`Private`f\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xAct`xTensor`Private`f\"\>", "InformationUsageText",
             
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "xAct`xTensor`Private`f", 
    "Documentation" -> None, "OwnValues" -> 
    Information`InformationValueForm[
     OwnValues, xAct`xTensor`Private`f, {xAct`xTensor`Private`f -> 1}], 
    "UpValues" -> None, "DownValues" -> 
    Information`InformationValueForm[
     DownValues, xAct`xTensor`Private`f, {xAct`xTensor`Private`f[
         Pattern[xAct`xTensor`Private`x, 
          Blank[]]] :> xAct`xTensor`Private`x^2}], "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`Private`f"], 
   False]]], "Output",ExpressionUUID->"cda6442f-786e-4770-b862-a7f04a7916bc"]
}, Open  ]],

Cell["The ownvalue for f is used before its downvalue:", \
"Text",ExpressionUUID->"92f03fc8-960e-48be-a16a-ded93570e13c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "3", 
  "]"}]], "Input",ExpressionUUID->"8d021855-f4c5-49de-82b4-c526002b50ca"],

Cell[BoxData[
 RowBox[{"1", "[", "3", 
  "]"}]], "Output",ExpressionUUID->"82abae58-4c5f-4681-9bae-89f3821df40c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"f", ",", "x", ",", "hello"}], 
  "]"}]], "Input",ExpressionUUID->"dfc34f19-78fa-4b9f-ae70-b36b1d5ab0f7"],

Cell[TextData[{
 "The basic use of symbols rather than strings can be compared to ",
 StyleBox["GRTensor",
  FontSlant->"Italic"],
 "'s input, based on strings. The strings give you more flexibility in the \
notations, but heavily rely on the parser. In other words, because the user \
cannot modify the parser, it is difficult for the user to use tricks of the \
system without changing the code of the package. Working with symbols has the \
problems referred to above and does not allow beautiful notations such as \
using parenthesis for symmetrization of indices. However it is much closer to \
",
 StyleBox["Mathematica'",
  FontSlant->"Italic"],
 "s spirit and allows the user to interact closely with the internals of the \
package because there is no parser acting as interface. There is an important \
comment here: if I had to write a system for other users I would write a \
parser; but because I am the the main user of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", I don't want to have a parser."
}], "Text",ExpressionUUID->"1fcd7d10-ff05-437b-a56a-aac47d561a5b"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.0.2. Tagging versus no-tagging", \
"Subsubsection",ExpressionUUID->"c47e3746-6913-43ad-bd84-7d26984b0721"],

Cell[TextData[{
 "Good programming suggests to tag values of a given type with the name of \
the type, as in Tensor[T, ...] (or Tensor[T][...], as recommended by Maeder), \
rather than using the simpler form T[...]. Advantages of tagging:\n\t- \
Clarity\n\t- Efficient pattern matching\n\t- Safety\nDisadvantages:\n\t- \
Harder to type in and read\n\t- The depth-1 restriction of upvalues in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " becomes a depth-0 restriction.\n\n",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " only defines up-values for symbols at levels 0 and 1 of the full \
expression. For example the definition T[a]T[-a]:=1 can be associated to the \
symbol T, but the definition Tensor[T,{a},{}] Tensor[T,{},{a}]:=1 can only be \
associated to the symbol Tensor, because the symbol T is too deep (level 2):"
}], "Text",ExpressionUUID->"2e2adde1-3bf4-42e3-87d1-4112922df61f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"63082a99-60a1-4ab8-97da-e0fd9cea9a95"],

Cell["This is not valid:", \
"Text",ExpressionUUID->"1fa88f48-72cb-4b0f-b7db-c202efa7bc31"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "/:", 
  RowBox[{
   RowBox[{"Tensor", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], 
   RowBox[{"Tensor", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "a", "}"}]}], "]"}]}], ":=", 
  "1"}]], "Input",ExpressionUUID->"e75a33fa-3e27-49cd-b534-afd59ef0d3a7"],

Cell[BoxData[
 TemplateBox[{
  "TagSetDelayed", "tagpos", 
   "\"Tag \\!\\(\\*RowBox[{\\\"T\\\"}]\\) in \
\\!\\(\\*RowBox[{RowBox[{\\\"Tensor\\\", \\\"[\\\", RowBox[{\\\"T\\\", \
\\\",\\\", RowBox[{\\\"{\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"a\\\", \\\"}\\\"}]}], \\\"]\\\"}], \\\" \\\", RowBox[{\\\"Tensor\\\", \
\\\"[\\\", RowBox[{\\\"T\\\", \\\",\\\", RowBox[{\\\"{\\\", \\\"a\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"}\\\"}]}], \\\"]\\\"}]}]\\) is \
too deep for an assigned rule to be found.\"", 2, 680, 1, 
   19659342612246381582, "Local"},
  "MessageTemplate"]], "Message", \
"MSG",ExpressionUUID->"78ca0afc-8e8b-4a53-9c4f-77401fb1db8f"],

Cell[BoxData["$Failed"], \
"Output",ExpressionUUID->"c8bbe78b-52d8-4f47-af11-258b2ddf9fa9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "T"}]], "Input",ExpressionUUID->"5468ae92-8559-4c5f-a307-65dcc896e2ea"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`T\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`T\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`T\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`T", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "Global`T"], 
   False]]], "Output",ExpressionUUID->"aafa33f3-9257-4a3a-a79a-93e3a735f26e"]
}, Open  ]],

Cell["This is correct:", \
"Text",ExpressionUUID->"38a9f23d-d0d4-4aaa-afa8-90e57e9ff9ff"],

Cell[BoxData[
 RowBox[{"T", "/:", 
  RowBox[{
   RowBox[{"T", "[", "a", "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"-", "a"}], "]"}]}], ":=", 
  "1"}]], "Input",ExpressionUUID->"2d023a05-9f4f-40f4-b406-066b6d6e9676"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "T"}]], "Input",ExpressionUUID->"41909f26-aaab-40e0-abb7-bea6a23320d2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`T\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"-", "a"}], "]"}], " ", 
                    RowBox[{"T", "[", "a", "]"}]}], "^:=", "1"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`T\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`T\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`T", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`T, {$CellContext`T[-$CellContext`a] \
$CellContext`T[$CellContext`a] :> 1}], "DownValues" -> None, "SubValues" -> 
    None, "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> "Global`T"], 
   False]]], "Output",ExpressionUUID->"c84be433-12a2-4524-8dac-8976009757fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "a", "]"}], 
  RowBox[{"T", "[", 
   RowBox[{"-", "a"}], 
   "]"}]}]], "Input",ExpressionUUID->"bfab0264-f5a4-45e8-aba8-10af76fe7b04"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"0e69930a-e98e-48e5-aec6-4a09a5cf2c1b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"b0e0f054-d250-4690-960a-eabfb0170b4b"],

Cell["\<\
An alternative (certainly ugly), based on the idea that the symbolic-head of \
an expression is always found no matter how many pairs of brackets there are, \
could be:\
\>", "Text",ExpressionUUID->"3546de24-1ef7-4c11-9754-b9860fb881b8"],

Cell[BoxData[
 RowBox[{"T", "/:", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", "Tensor", "]"}], "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], 
   RowBox[{
    RowBox[{"T", "[", "Tensor", "]"}], "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "a", "}"}]}], "]"}]}], ":=", 
  "1"}]], "Input",ExpressionUUID->"969564fd-aabf-4aa5-b1ff-f4c893c0e580"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "T"}]], "Input",ExpressionUUID->"aac53a96-fc36-4ffd-ba5b-f4b9c4bc09ef"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`T\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"T", "[", "Tensor", "]"}], "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", "a", "}"}]}], "]"}], " ", 
                    RowBox[{
                    RowBox[{"T", "[", "Tensor", "]"}], "[", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], "^:=", "1"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`T\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`T\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`T", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`T, {$CellContext`T[
         xAct`xTensor`Tensor][{}, {$CellContext`a}] $CellContext`T[
         xAct`xTensor`Tensor][{$CellContext`a}, {}] :> 1}], "DownValues" -> 
    None, "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "Global`T"], 
   False]]], "Output",ExpressionUUID->"6324c1c9-ad25-4b25-9070-c5e5d1b05e6f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"T", ",", "a"}], 
  "]"}]], "Input",ExpressionUUID->"a6b976b0-717e-44f2-9488-4e9f31c96e53"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3f2f25a9-2d27-4dd1-b1c9-21d891543fd1"],

Cell[TextData[{
 "Currently we do not use tagging. (This is probably the most important \
design decision in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", and it is unlikely to change in future versions.) We introduce a  number \
of checking functions xTensorQ, etc. such that objects of the corresponding \
type are given True upvalues for the function, which is itself defined as \
False on any other input. The main point is the difference in efficiency. I \
estimate that the Q functions are slower by a factor between 3 and 6, but \
they take very little anyway with respect to the global computation time.\n\n\
I must say that when I have asked the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " developers about this issue they have also recommended me this option, \
though they also mention the loss of efficiency..."
}], "Text",ExpressionUUID->"5baf428f-6e64-4fc8-aa2a-e2f6f8e1ce56"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.0.3. Types of symbols", \
"Subsubsection",ExpressionUUID->"1e93d876-5e52-42b4-9e7b-7f493747ef10"],

Cell[TextData[{
 "Currently there are 14 types of definable symbols:\n\tAbstractIndex: \
abstract indices\n\tTensor: tensors of the form T[ inds ] (with Metric as a \
special case)\n\tCovD: operators of the form CD[ ind ][   ] or perhaps CD[ \
inds ][   ]\n\tScalarFunction: function mapping (possibly several) scalars to \
scalars\n\tInertHead: a head that does not change the type and properties of \
an object. Assume its first argument is tensorial, but not the rest\n\t\
Product: a product of tensorial objects, generalizing our use of Times\n\t\
Manifold\n\tMapping\n\tVBundle\n\tParameter\n\tConstantSymbol\n\tBasis (in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ")\n\tChart (in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ")\n\tMetric: particular type of tensor"
}], "Text",ExpressionUUID->"6bb8759a-f4b8-4f4d-9c85-bbdfe70c68ad"],

Cell["\<\
Functions that must use types of objects because they expect a generic \
mathinput expr:
\t- FindAllOfType
\t- FindIndices
\t- ReplaceIndex
\t- IsIndexOf
\t- SymmetryOf
\t- ContractMetric
\t- Scalar
\t- DependenciesOf
\t- WeightOf
Then we have other functions using types, though not through mathinput:
\t- ValidateSymbolInSession
\t- IndexForm\
\>", "Text",ExpressionUUID->"265132c5-0050-4664-bde4-a6728ec910ce"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.1. Protection of symbols", \
"Subsection",ExpressionUUID->"e6b12379-eba9-4c5d-88e4-6f6cbefc31d1"],

Cell["\<\
An additional decision: defined objects are not protected by default .\
\>", "Text",ExpressionUUID->"edcd7095-77e8-4e52-a182-cf25a223bf82"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$ProtectNewSymbols"}]], \
"Input",ExpressionUUID->"9d47a23c-1a86-4a8b-b81c-85b5e8bbc10f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"$ProtectNewSymbols is a Boolean global variable \
specifying the default value for the option ProtectNewSymbol of all DefType \
commands. The default initial value is False.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`$ProtectNewSymbols\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"$ProtectNewSymbols is a Boolean global variable \
specifying the default value for the option ProtectNewSymbol of all DefType \
commands. The default initial value is False.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "$ProtectNewSymbols is a Boolean global variable specifying the default \
value for the option ProtectNewSymbol of all DefType commands. The default \
initial value is False.", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`$ProtectNewSymbols"], 
   False]]], "Output",ExpressionUUID->"01b15e82-2d1a-44c9-9c3d-c74c226885fe"]
}, Open  ]],

Cell["Its default value is False:", \
"Text",ExpressionUUID->"948e803a-9af2-4c55-befd-753caeefe596"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ProtectNewSymbols", "=", "False"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7dec35d1-c70a-496f-a4d2-b66f6e29c107"],

Cell["But here we want to check it:", \
"Text",ExpressionUUID->"9f0ad63e-a589-4b60-8a91-78514ce94071"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ProtectNewSymbols", "=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"da759be4-7fc3-4249-8bed-155f5c11c198"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.2. Symbol relations", \
"Subsection",ExpressionUUID->"2ebdee7d-4769-4fba-a693-2f8e52ebb705"],

Cell["\<\
There are symbols which require others to exist previously (like a tensor \
field needs a manifold) and there are symbols which force simultaneuous \
existence of others (like a connection requires existence of its Riemann \
tensor). These two types of relations are important when defining and \
undefining symbols. We shall introduce the following silly terminology:
\t- A symbol (like that tensor) is a \"visitor\" of a previously defined \
\"host\" symbol (like that manifold). Any symbol has a list of visitors and a \
list of hosts.
\t- A symbol (like the connection) is a \"master\" for the symbols which it \
requires to be defined, to be called \"servants\". Any symbol has a master \
(default Null) and a list of servants.
\t
There is the question of whether a symbol can have several masters. I \
currently think this is impossible because we would have to define and \
undefine all together, and if that is the case we can well define one of them \
as master and the rest as servants of that one.
\t
Those lists will be upvalues of the symbols when they are not empty. They \
will have empty default definitions in general.\
\>", "Text",ExpressionUUID->"cfe4a9a4-774f-4418-94bd-8e7d5c24cb9e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "HostsOf"}]], \
"Input",ExpressionUUID->"f14064fc-8b6b-43a7-95e5-7f969f0c2601"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"HostsOf[symbol] gives the list of symbols which are \
required to exist previously, before symbol was defined, and which cannot be \
undefined as long as symbol exists.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`HostsOf\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"HostsOf[symbol] gives the list of symbols which are \
required to exist previously, before symbol was defined, and which cannot be \
undefined as long as symbol exists.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "HostsOf[symbol] gives the list of symbols which are required to exist \
previously, before symbol was defined, and which cannot be undefined as long \
as symbol exists.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    None, "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`HostsOf"], 
   False]]], "Output",ExpressionUUID->"70acf0e7-af9b-4143-9fa2-c84394c665b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "VisitorsOf"}]], \
"Input",ExpressionUUID->"48d36adb-6a25-4697-b032-3da2285ad9be"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"VisitorsOf[symbol] gives the list of all symbols \
which require symbol to exist before they can be defined. symbol can only be \
removed if this list is empty.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`VisitorsOf\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"VisitorsOf[symbol] gives the list of all symbols \
which require symbol to exist before they can be defined. symbol can only be \
removed if this list is empty.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "VisitorsOf[symbol] gives the list of all symbols which require symbol to \
exist before they can be defined. symbol can only be removed if this list is \
empty.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`VisitorsOf"], 
   False]]], "Output",ExpressionUUID->"f9cdabaa-a6a9-48ae-b9f9-81acb4b961d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ServantsOf"}]], \
"Input",ExpressionUUID->"c7c7c9f0-4c25-4c80-9366-c9360ac26b7b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ServantsOf[symbol] gives the list of symbols which \
have been simultaneously defined with symbol. They will be removed when, and \
only when, symbol is removed.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`ServantsOf\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ServantsOf[symbol] gives the list of symbols which \
have been simultaneously defined with symbol. They will be removed when, and \
only when, symbol is removed.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "ServantsOf[symbol] gives the list of symbols which have been \
simultaneously defined with symbol. They will be removed when, and only when, \
symbol is removed.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    None, "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`ServantsOf"], 
   False]]], "Output",ExpressionUUID->"ff073466-b06b-4371-90fd-897d68f98c83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "MasterOf"}]], \
"Input",ExpressionUUID->"44c7b140-e524-43d3-bae2-280d241d6774"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"MasterOf[servant] gives the master symbol of the \
symbol servant. The latter is defined and removed when, and only when, the \
former is defined and removed, respectively.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`MasterOf\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"MasterOf[servant] gives the master symbol of the \
symbol servant. The latter is defined and removed when, and only when, the \
former is defined and removed, respectively.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "MasterOf[servant] gives the master symbol of the symbol servant. The \
latter is defined and removed when, and only when, the former is defined and \
removed, respectively.", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`MasterOf"], 
   False]]], "Output",ExpressionUUID->"2bdefd68-4b39-4def-a199-12454fbfd4f7"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ServantsOf", "[", "Symbol", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"delta", ",", "Gdelta", ",", "Sdelta", ",", "Basis", ",", "PD"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HostsOf", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VisitorsOf", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MasterOf", "[", "_", "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ServantsOf", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "HostsOf", ",", "VisitorsOf", ",", "MasterOf", ",", "ServantsOf"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"HostsOf", ",", "VisitorsOf", ",", "MasterOf", ",", "ServantsOf"}],
    "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cee78c48-f04b-4db5-9c99-b107c6501a6d"],

Cell["\<\
A symbol which cannot be removed can be made servant of a non-removable \
symbol. I choose the symbol Symbol, and certain objects (now delta, Gdelta, \
Sdelta, Basis and PD) will have Symbol as master.\
\>", "Text",ExpressionUUID->"9424d98d-cfde-4067-9a15-361711a4be42"],

Cell["\<\
Trivial coding. Note that we drop the master (and its master, and so on) from \
the list of hosts; that is, a symbol cannot be simultaneously servant and \
visitor: if we ask for both it will be a servant. This function assumes that \
symbol is unprotected because it is called during the declaration of the \
symbol:\
\>", "Text",ExpressionUUID->"6744a6e3-721f-46ff-a205-0075f00f167f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymbolRelations", "[", 
    RowBox[{"list_List", ",", "master_Symbol", ",", "hosts_List"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SymbolRelations", "[", 
      RowBox[{"#", ",", "master", ",", "hosts"}], "]"}], "&"}], "/@", 
    "list"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolRelations", "[", 
    RowBox[{"symbol_Symbol", ",", "master_Symbol", ",", "hosts_List"}], "]"}],
    ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hosts2", "=", 
       RowBox[{"Complement", "[", 
        RowBox[{"hosts", ",", 
         RowBox[{"FixedPointList", "[", 
          RowBox[{"MasterOf", ",", "master"}], "]"}]}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"master", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MasterOf", "[", "symbol", "]"}], "^=", "master"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"xUpAppendTo", "[", 
          RowBox[{
           RowBox[{"ServantsOf", "[", "master", "]"}], ",", "symbol"}], 
          "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"hosts2", "=!=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"xUpSet", "[", 
         RowBox[{
          RowBox[{"HostsOf", "[", "symbol", "]"}], ",", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"HostsOf", "[", "symbol", "]"}], ",", "hosts2"}], "]"}]}],
          "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"VisitorsOf", "[", "#", "]"}], ",", "symbol"}], "]"}]}],
            ",", 
           RowBox[{"xUpAppendTo", "[", 
            RowBox[{
             RowBox[{"VisitorsOf", "[", "#", "]"}], ",", "symbol"}], "]"}]}], 
          "]"}], "&"}], ",", "hosts2"}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"12cedcae-1416-42af-b78d-f929b693f643"],

Cell["\<\
The master of a declared symbol can be specified at declaration time, using \
the option Master:\
\>", "Text",ExpressionUUID->"ce7b5a77-5a6a-4d07-96c0-be73797ae6ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "Master", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6eb837ac-0bb3-427d-ad74-4cc507d852b0"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.3. Removing symbols", \
"Subsection",ExpressionUUID->"b4b6ef84-4cb1-43c9-97f3-d57d8b30abb3"],

Cell["\<\
This function removes a symbol, unprotecting it first if needed. Note that we \
do not have the head Symbol in the pattern because sometimes we use it with a \
symbol-name (a string); this is when the symbol has an ownvalue and hence we \
need to avoid its evaluation. QUESTION: Why do we do that? Wouldn't it be \
better to use a holding attribute?\
\>", "Text",ExpressionUUID->"0cde8cfd-9e7e-4f01-80fd-418cabee77bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RemoveSymbol"}]], \
"Input",ExpressionUUID->"34858117-6744-46b0-be8b-2b5e65db510a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensor`Private`RemoveSymbol[symbol] unprotects (if \
protected) and removes symbol.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`Private`RemoveSymbol\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensor`Private`RemoveSymbol[symbol] unprotects (if \
protected) and removes symbol.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "xTensor`Private`RemoveSymbol[symbol] unprotects (if protected) and \
removes symbol.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    None, "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`Private`RemoveSymbol"], 
   False]]], "Output",ExpressionUUID->"47a6fe38-ed4c-4620-91fc-d42d4e0dcbbf"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RemoveSymbol", "[", "symbol_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Unprotect", "[", "symbol", "]"}], ";", 
     RowBox[{"Remove", "[", "symbol", "]"}], ";"}], ")"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"57b99683-6222-4ff0-9a23-10619096bbcd"],

Cell["\<\
Before removing a symbol we check that the symbol can be actually removed:\
\>", "Text",ExpressionUUID->"fbc4f20e-7d4c-4e52-95ac-de35a009141e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckRemoveSymbol"}]], \
"Input",ExpressionUUID->"12285af4-ec96-4006-8a14-73682a3f5b1e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensor`Private`CheckRemoveSymbol[symbol] throws an \
error if symbol has visitors or its master has other servants. Otherwise it \
gives Null.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], \
"\<\"xAct`xTensor`Private`CheckRemoveSymbol\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensor`Private`CheckRemoveSymbol[symbol] throws an \
error if symbol has visitors or its master has other servants. Otherwise it \
gives Null.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "xTensor`Private`CheckRemoveSymbol[symbol] throws an error if symbol has \
visitors or its master has other servants. Otherwise it gives Null.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`Private`CheckRemoveSymbol"], 
   False]]], "Output",ExpressionUUID->"c1abe8d4-323e-41d2-9f19-402551a2f525"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckRemoveSymbol", "[", "symbol_Symbol", "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"VisitorsOf", "[", "symbol", "]"}], "=!=", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"General", "::", "noundef"}], ",", "\"\<Symbol\>\"", ",", 
        "symbol", ",", "\"\<it has visitors\>\""}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ServantsOf", "[", 
       RowBox[{"MasterOf", "[", "symbol", "]"}], "]"}], "=!=", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"General", "::", "noundef"}], ",", "\"\<Symbol\>\"", ",", 
        "symbol", ",", "\"\<its master is still alive\>\""}], "]"}]}], ",", 
     "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", "Null"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f3ebd497-6b15-4fe5-8db5-f5c31f60d3f5"],

Cell["\<\
After checking that a symbol can be removed, we have to drop it from the \
lists of visitors of its hosts:\
\>", "Text",ExpressionUUID->"4913ae10-0c6d-4541-a7ea-078d2b359d22"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DropFromHosts", "[", "symbol_Symbol", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"xUpDeleteCasesTo", "[", 
       RowBox[{
        RowBox[{"VisitorsOf", "[", "#", "]"}], ",", "symbol"}], "]"}], "&"}], 
     ",", 
     RowBox[{"HostsOf", "[", "symbol", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"743954f7-df15-4b5f-8e52-55a7fef5cb5c"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.4. Initialize type treatment", \
"Subsection",ExpressionUUID->"e1c26ded-2646-40ae-bc96-eec15f6272b6"],

Cell[CellGroupData[{

Cell["2.4.1. Basic functions and variables", \
"Subsubsection",ExpressionUUID->"df77a496-f99e-4f05-893a-a41f3d1ed54e"],

Cell["\<\
These 14 names define the types of symbols and will be used for several \
purposes in the package. Users should not use them for their own purposes:\
\>", "Text",ExpressionUUID->"c9c69d8e-d00d-4788-9294-16feb61b6a74"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$Types"}]], "Input",ExpressionUUID->"a020e711-c6ad-46b1-8644-db99656e868d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensor`Private`$Types is a global variable \
containing the list of types currently defined in xTensor.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`Private`$Types\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensor`Private`$Types is a global variable \
containing the list of types currently defined in xTensor.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "xTensor`Private`$Types is a global variable containing the list of types \
currently defined in xTensor.", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`Private`$Types"], 
   False]]], "Output",ExpressionUUID->"14939b78-7b86-4ac1-b62b-cf51ea29439b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Types", "=", 
   RowBox[{"{", 
    RowBox[{
    "AbstractIndex", ",", "Manifold", ",", "Mapping", ",", "VBundle", ",", 
     "Tensor", ",", "Metric", ",", "CovD", ",", "InertHead", ",", 
     "ScalarFunction", ",", "ConstantSymbol", ",", "Parameter", ",", 
     "Product", ",", "Chart", ",", "Basis"}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6d7dcb79-af5a-4610-8a31-a731a70d36c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "/@", "$Types"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8500c20f-5be2-4345-b9bf-620dbf512b60"],

Cell[TextData[{
 "The word Constant is already used and protected by ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". It will be never used in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". Product is also already protected."
}], "Text",ExpressionUUID->"283bfdd5-4452-4b9f-852a-44eb0ced1e7d"],

Cell["\<\
Lists of objects (apart from $Types, already defined). These global variables \
are all public:\
\>", "Text",ExpressionUUID->"282813cc-f8c4-4e42-accc-973bc4c4c38b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Main", " ", "14", " ", "data", " ", "bases"}], " ", "*)"}], "\n", 
  
  RowBox[{
   RowBox[{
    RowBox[{"$Manifolds", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Mappings", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VBundles", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$AbstractIndices", ":=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"IndicesOfVBundle", "/@", "$VBundles"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$ConstantSymbols", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Tensors", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$CovDs", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Metrics", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$InertHeads", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$ScalarFunctions", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Parameters", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Products", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Bases", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Charts", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Additional", " ", "4", " ", "data", " ", "bases"}], ",", " ", 
     RowBox[{
     "apart", " ", "from", " ", "the", " ", "private", " ", 
      "$FirstMetrics"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$ProductManifolds", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$SumVBundles", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$ProductMetrics", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$Rules", "=", 
     RowBox[{"{", "}"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bb6a3876-af44-467b-b805-14739c9c4a4a"],

Cell[TextData[{
 "Inquiring functions (predicates) for types  (ProductManifoldQ is considered \
to be included in ManifoldQ; ProductMetricQ is considered to be included in \
MetricQ; we write xTensorQ rather than TensorQ because ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " has a built-in TensorQ from version 5.):"
}], "Text",ExpressionUUID->"c943e588-fdf0-4916-ace0-0ee64adce8d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "TensorQ"}]], \
"Input",ExpressionUUID->"bb9f4674-82f8-4b64-817b-5f22444bfb92"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"System`TensorQ\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"System`TensorQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"System`TensorQ\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "System`TensorQ", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "System`TensorQ"], 
   True]]], "Output",ExpressionUUID->"e825bcc8-1250-481b-8e7d-2453255bb838"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "xTensorQ"}]], \
"Input",ExpressionUUID->"03471721-132f-4e6c-9811-a30204863728"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensorQ[expr] gives True if expr has been \
registered as a tensor, and False otherwise. Do not confuse with \
Mathematica's TensorQ.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`xTensorQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensorQ[expr] gives True if expr has been \
registered as a tensor, and False otherwise. Do not confuse with \
Mathematica's TensorQ.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "xTensorQ[expr] gives True if expr has been registered as a tensor, and \
False otherwise. Do not confuse with Mathematica's TensorQ.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`xTensorQ"], 
   False]]], "Output",ExpressionUUID->"f8784cd9-16e4-4149-97ec-1c634b79be0e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$QFunctions", "=", 
   RowBox[{"{", 
    RowBox[{
    "AbstractIndexQ", ",", "ConstantSymbolQ", ",", "xTensorQ", ",", "CovDQ", 
     ",", "MetricQ", ",", "ManifoldQ", ",", "MappingQ", ",", "VBundleQ", ",", 
     "InertHeadQ", ",", "ScalarFunctionQ", ",", "BasisQ", ",", "ChartQ", ",", 
     "ParameterQ", ",", "ProductQ"}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"39dbea1b-533d-4879-a124-077225da0b1a"],

Cell[TextData[{
 "All typeQ functions must be handled using upvalues. With unknown symbols \
they all give False, without errors (because these functions will be used on \
all kinds of input, including ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " expressions):"
}], "Text",ExpressionUUID->"ea87404f-fc28-4333-a3e1-08fb7ac16df2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetDelayed", "[", 
     RowBox[{
      RowBox[{"#", "[", "_", "]"}], ",", "False"}], "]"}], "&"}], "/@", 
   "$QFunctions"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d473076d-3f93-4959-ba71-b50e5dd32034"],

Cell["They only accept one argument.", \
"Text",ExpressionUUID->"dae874d4-13c9-4e5b-8830-4aa575027a0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", "$QFunctions"}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"db322793-3ec9-4b69-bcda-dfb3188886d8"],

Cell["\<\
Protect them because they will be used only in the assignments of upvalues \
for symbols.\
\>", "Text",ExpressionUUID->"08c69c30-9a7c-443c-a1f7-a69bc9cc6800"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", "$QFunctions", "]"}], "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1f799aed-396c-4133-ae0d-0e0881b67369"],

Cell["Example:", \
"Text",ExpressionUUID->"73764527-9a6a-4bc8-aa51-e827fe7fc4ca"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "AbstractIndexQ"}]], \
"Input",ExpressionUUID->"e325565b-15d7-4ecf-ada8-ad0c12ee0a92"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"AbstractIndexQ[symbol] gives True if symbol has \
been registered as an abstract index. Note that it gives False on \
down-indices.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Definitions\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Definitions", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"AbstractIndexQ", "[", "]"}], ":=", 
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"AbstractIndexQ", "::", "argx"}], "MessageName"], 
                    ",", "AbstractIndexQ", ",", "0"}], "]"}]}]},
                    {
                    RowBox[{
                    RowBox[{"AbstractIndexQ", "[", "_", "]"}], ":=", 
                    "False"}]},
                    {
                    RowBox[{
                    RowBox[{"AbstractIndexQ", "[", 
                    RowBox[{"_", ",", "xAct`xCore`Private`x$__"}], "]"}], ":=", 
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"AbstractIndexQ", "::", "argx"}], "MessageName"], 
                    ",", "AbstractIndexQ", ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"Length", "[", 
                    RowBox[{"{", "xAct`xCore`Private`x$", "}"}], "]"}]}]}], 
                    "]"}]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`AbstractIndexQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"AbstractIndexQ[symbol] gives True if symbol has \
been registered as an abstract index. Note that it gives False on \
down-indices.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "AbstractIndexQ[symbol] gives True if symbol has been registered as an \
abstract index. Note that it gives False on down-indices.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> 
    Information`InformationValueForm[
     DownValues, xAct`xTensor`AbstractIndexQ, {
      xAct`xTensor`AbstractIndexQ[] :> Message[
         MessageName[xAct`xTensor`AbstractIndexQ, "argx"], 
         xAct`xTensor`AbstractIndexQ, 0], xAct`xTensor`AbstractIndexQ[
         Blank[]] :> False, xAct`xTensor`AbstractIndexQ[
         Blank[], 
         Pattern[xAct`xCore`Private`x$, 
          BlankSequence[]]] :> Message[
         MessageName[xAct`xTensor`AbstractIndexQ, "argx"], 
         xAct`xTensor`AbstractIndexQ, 1 + Length[{xAct`xCore`Private`x$}]]}], 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "xAct`xTensor`AbstractIndexQ"], 
   True]]], "Output",ExpressionUUID->"06c130e8-e95d-4f69-8492-dcfd6fc4d25f"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.4.2. FindAllOfType", \
"Subsubsection",ExpressionUUID->"818519c4-26ba-4585-b56a-c18a2988f309"],

Cell[TextData[{
 "We use Heads->True, so that we find the objects in heads (for example in \
the vector field of a Lie Derivative or in InChart). This function evaluates \
its argument. Right now it is used in MakeRule to look for tensors, and in \
ToValues in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 " to detect which tensors we need values for."
}], "Text",ExpressionUUID->"9a4669af-719c-4e57-9bec-6cc284c4b542"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FindAllOfType"}]], \
"Input",ExpressionUUID->"f2960a99-5fd1-4748-b35f-fbbdddbac6e6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FindAllOfType[expr, type] gives the list of all \
occurrences of elements of the given type in expr, including their indices \
for types like Tensor, CovD, etc.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`FindAllOfType\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FindAllOfType[expr, type] gives the list of all \
occurrences of elements of the given type in expr, including their indices \
for types like Tensor, CovD, etc.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "FindAllOfType[expr, type] gives the list of all occurrences of elements \
of the given type in expr, including their indices for types like Tensor, \
CovD, etc.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None,
     "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`FindAllOfType"], 
   False]]], "Output",ExpressionUUID->"f2e0019f-db94-4eed-ab42-e84c698ca9af"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "AbstractIndex"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_Symbol", "?", "AbstractIndexQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "ConstantSymbol"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_Symbol", "?", "ConstantSymbolQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Parameter"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_Symbol", "?", "ParameterQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Manifold"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_", "?", "ManifoldQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Mapping"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_", "?", "MappingQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "VBundle"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_", "?", "VBundleQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Tensor"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"_", "?", "xTensorQ"}], "[", "___", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Metric"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"_Symbol", "?", "MetricQ"}], "[", 
      RowBox[{"_", ",", "_"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "CovD"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"_", "?", "CovDQ"}], "[", "__", "]"}], "[", "_", "]"}], "|", 
      RowBox[{"CovD", "[", 
       RowBox[{"_", ",", "__"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "InertHead"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"_", "?", "InertHeadQ"}], "[", "__", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "ScalarFunction"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "___", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Product"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_Symbol", "?", "ProductQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Chart"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"_Symbol", "?", "ChartQ"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindAllOfType", "[", 
    RowBox[{"expr_", ",", "Basis"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Basis", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       InterpretationBox["\[Infinity]",
        DirectedInfinity[1]]}], "}"}], ",", 
     RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FindAllOfType", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FindAllOfType", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a9f4cb3c-36bb-4381-881f-b3fc2fad4d9b"],

Cell[TextData[{
 "Note that there is no Symbol head for ScalarFunction. This is to work with \
InChart in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ". From version 1.0 we have also relaxed the restriction in the tensor's \
heads, and in mappings, to include mapping composition."
}], "Text",ExpressionUUID->"31f0aa96-c37f-483c-a50a-2d5577b22753"],

Cell["\<\
Note that Basis is treated differently: we are not looking for all basis \
symbols, but for all Basis tensors, which is a very different thing. I don't \
remember why is that.\
\>", "Text",ExpressionUUID->"292c9e39-713a-4e5f-b690-8be95f41b3ec"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.4.3. Undef", \
"Subsubsection",ExpressionUUID->"dc41bade-bb8c-40da-bbf0-a2b18bc041f9"],

Cell["This function is a generic driver for undefinition:", \
"Text",ExpressionUUID->"f86c6d3a-0c86-49dc-b192-ab5dfc8f3c6f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Undef"}]], "Input",ExpressionUUID->"a906c00d-2fa7-4157-b064-13f6a2af6c23"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Undef[symbol] undefines the symbol, whatever its \
type may be. The only exception are abstract indices.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`Undef\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Undef[symbol] undefines the symbol, whatever its \
type may be. The only exception are abstract indices.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "Undef[symbol] undefines the symbol, whatever its type may be. The only \
exception are abstract indices.", "Documentation" -> None, "OwnValues" -> 
    None, "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`Undef"], 
   False]]], "Output",ExpressionUUID->"0f7e94ce-3374-49ff-9829-90dc73b092da"]
}, Open  ]],

Cell["\<\
We give definitions for 12 types. The definition for metrics is not needed \
because we have the definition for tensors. I don't want to allow \
undefinition of indices through Undef and hence that generates an error. Note \
that here it does not make sense to remove the _Symbol specification in the \
patterns.\
\>", "Text",ExpressionUUID->"3d77dce4-1919-45c4-9bc1-9e1f3c41cd7d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "ManifoldQ"}], "]"}], ":=", 
   RowBox[{"UndefManifold", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "MappingQ"}], "]"}], ":=", 
   RowBox[{"UndefMapping", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "VBundleQ"}], "]"}], ":=", 
   RowBox[{"UndefVBundle", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "ParameterQ"}], "]"}], ":=", 
   RowBox[{"UndefParameter", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{"UndefTensor", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "CovDQ"}], "]"}], ":=", 
   RowBox[{"UndefCovD", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "ConstantSymbolQ"}], "]"}], ":=", 
   RowBox[{"UndefConstantSymbol", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "ScalarFunctionQ"}], "]"}], ":=", 
   RowBox[{"UndefScalarFunction", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "InertHeadQ"}], "]"}], ":=", 
   RowBox[{"UndefInertHead", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "ProductQ"}], "]"}], ":=", 
   RowBox[{"UndefProduct", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "ChartQ"}], "]"}], ":=", 
   RowBox[{"xAct`xCoba`UndefChart", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "BasisQ"}], "]"}], ":=", 
   RowBox[{"xAct`xCoba`UndefBasis", "[", "symbol", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", 
    RowBox[{"symbol_Symbol", "?", "AbstractIndexQ"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Undef", "::", "nouse"}], ",", "\"\<Undef\>\"", ",", 
      "\"\<an abstract index\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Undef", "[", "symbol_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Undef", "::", "unknown"}], ",", "\"\<symbol type of\>\"", ",", 
      "symbol"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Undef", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Undef", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fbb6a6e7-9ed4-46e0-9cfb-fd3cf2e6e8a6"],

Cell["\<\
TODO: It has been suggested that Undef[All], and perhaps even Undef[],  \
undefines everything in the current session. I think this may be useful to \
avoid quitting the kernel to restart afresh.\
\>", "Text",ExpressionUUID->"5c89549f-cde0-409e-8f66-91d31db93560"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.5. Validate new symbols in a session", \
"Subsection",ExpressionUUID->"4961ea1f-e080-4a31-bcd7-86b4e3bc27c8"],

Cell[TextData[{
 "We check that symbol is not a metric before checking that it is not a \
tensor. This function could be moved to ",
 StyleBox["xCore",
  FontSlant->"Italic"],
 ", but right now all types belong to ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", and so that does not make much sense."
}], "Text",ExpressionUUID->"a14aac6e-0541-43e5-8814-2ac5a3b4791c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ValidateSymbolInSession", "[", "symbol_", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"name", "=", 
       RowBox[{"ToString", "[", "symbol", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"AbstractIndexQ", "[", "symbol", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as an abstract index\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ConstantSymbolQ", "[", "symbol", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a constant-symbol\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ParameterQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a parameter\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"ManifoldQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a manifold\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"MappingQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a mapping\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"VBundleQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a vector bundle\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"MetricQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a metric\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"xTensorQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a tensor\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"CovDQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a covariant derivative\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ScalarFunctionQ", "[", "symbol", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a scalar function\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InertHeadQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as an inert head\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"ProductQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a product\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"ChartQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a chart\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"BasisQ", "[", "symbol", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ValidateSymbol", "::", "used"}], ",", "name", ",", 
          "\"\<as a basis\>\""}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ValidateSymbolInSession", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ValidateSymbolInSession", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3a485aed-e2db-46b0-a93b-44b87193cf5d"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.6. Formatting", \
"Subsection",ExpressionUUID->"d0b2e988-8dcb-47a9-86ec-5eaaa020e740"],

Cell[TextData[{
 "All this could be done much better with newer capabilities of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "..."
}], "Text",ExpressionUUID->"ff479a3e-55c3-49b2-902d-ecc686dccdbd"],

Cell[CellGroupData[{

Cell["2.6.1. Interpretation of boxes", \
"Subsubsection",ExpressionUUID->"fe54606c-5828-4b69-9449-e18ad0bb6b6c"],

Cell[TextData[{
 "We shall use InterpretationBox to allow cut-and-paste of box-formatted \
expressions. A problem is that InterpretationBox has attribute \
HoldAllComplete and hence we need to pass the box after full evaluation. We \
do it simply with the intermediate function interpretbox, which only holds \
its first argument (the expression). Note that the order interpretbox[ expr, \
box ] is reversed with respect to InterpretationBox[ box, expr ] because we \
want to hold expr, but not box. We also introduce AutoSpacing->False to give \
indices their proper sizes, and ShowAutoStyles->False to avoid the blue \
coloring of unknown symbols in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 6+. Thanks to Alessandro Stecchina for spotting the latter problem.\n\n\
TODO: The fact that the second argument of interpretbox is evaluated is \
probably an evaluation leak. Can we avoid it?"
}], "Text",ExpressionUUID->"d58d4308-5b41-4c9c-8927-f1cd6cc92b67"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"interpretbox", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"interpretbox", "[", 
    RowBox[{"expr_", ",", "box_"}], "]"}], ":=", 
   RowBox[{"InterpretationBox", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"StyleBox", "[", 
      RowBox[{"box", ",", 
       RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
       RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "expr", ",", "\[IndentingNewLine]", 
     RowBox[{"Editable", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3672d39a-9dc8-4dc8-a960-d7d09368ab61"],

Cell["\<\
Colored background (right now not being used, not even by Scalar, as \
originally planned. Nobody likes it!):\
\>", "Text",ExpressionUUID->"67335124-37df-406c-a8ce-3de96a989090"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"interpretboxcolor", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"interpretboxcolor", "[", 
    RowBox[{"expr_", ",", "box_", ",", "color_"}], "]"}], ":=", 
   RowBox[{"interpretbox", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"StyleBox", "[", 
      RowBox[{"box", ",", 
       RowBox[{"Background", "\[Rule]", "color"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"164ab7df-5787-4d5d-ba0b-9ad3e98537ea"],

Cell["\<\
Now that we have wrapped the boxes with InterpretationBox and StyleBox, we \
need a function to undo that:\
\>", "Text",ExpressionUUID->"b6f6f536-5454-4aa8-b7af-c212028e8a1d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"boxof", "[", 
    RowBox[{"InterpretationBox", "[", 
     RowBox[{"box_", ",", "__"}], "]"}], "]"}], ":=", 
   RowBox[{"boxof", "[", "box", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"boxof", "[", 
    RowBox[{"StyleBox", "[", 
     RowBox[{"box_", ",", "__"}], "]"}], "]"}], ":=", 
   RowBox[{"boxof", "[", "box", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"boxof", "[", "box_", "]"}], ":=", "box"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dad832d4-b901-469f-bb46-87781d06cfae"],

Cell["Action on a list of arguments:", \
"Text",ExpressionUUID->"d949d650-cc0e-4110-ac1f-7d8933b80584"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"MakeSequenceBox", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeSequenceBox", "[", 
    RowBox[{"list_List", ",", "char_", ",", "format_"}], "]"}], ":=", 
   RowBox[{"RowBox", "@", 
    RowBox[{"Riffle", "[", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Function", "[", 
         RowBox[{"Null", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"#", ",", "format"}], "]"}], ",", "HoldFirst"}], "]"}], 
        ",", 
        RowBox[{"Unevaluated", "[", "list", "]"}]}], "]"}], ",", "char"}], 
     "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8720657c-b1db-45a8-9a04-ae2790481381"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeSequenceBox", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], "}"}], ",", 
   "\"\<,\>\"", ",", "StandardForm"}], 
  "]"}]], "Input",ExpressionUUID->"0f824f72-8955-4a6f-a729-d6a92653bf81"],

Cell[BoxData[
 RowBox[{"RowBox", "[", 
  RowBox[{"{", 
   RowBox[{"\<\"\\\"a\\\"\"\>", ",", "\<\",\"\>", ",", "\<\"\\\"b\\\"\"\>", 
    ",", "\<\",\"\>", ",", "\<\"\\\"c\\\"\"\>"}], "}"}], 
  "]"}]], "Output",ExpressionUUID->"f12554c1-b2b1-462e-ad1d-4ff51e4c0556"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RawBoxes", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"69fffb46-ae04-4a07-a3a6-a256aa7dbc67"],

Cell[BoxData[
 RowBox[{"\<\"a\"\>", ",", "\<\"b\"\>", 
  ",", "\<\"c\"\>"}]], \
"Output",ExpressionUUID->"38b9e9ec-c5e7-413f-b963-15592f36ce78"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeSequenceBox", "[", 
  RowBox[{
   RowBox[{"{", "\"\<a\>\"", "}"}], ",", "\"\<,\>\"", ",", "StandardForm"}], 
  "]"}]], "Input",ExpressionUUID->"8fb69acb-9a03-450a-8cda-7acf790f0c93"],

Cell[BoxData[
 RowBox[{"RowBox", "[", 
  RowBox[{"{", "\<\"\\\"a\\\"\"\>", "}"}], 
  "]"}]], "Output",ExpressionUUID->"3d18c013-69c8-4e2e-b28b-de998a27699d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RawBoxes", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"af89d254-7047-44f9-84bd-3cee8d227ccd"],

Cell[BoxData["\<\"a\"\>"], \
"Output",ExpressionUUID->"46398f52-9899-4225-9d68-d271cd621d6b"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.6.2. xTensorFormStart/Stop", \
"Subsubsection",ExpressionUUID->"23bb1675-af06-47fa-a187-ff4efd0a3f7d"],

Cell["\<\
These two functions start and stop formatting of different things. With an \
argument they only start/stop formatting for that class of objects. Products \
are not included among the classes because each product has its own MakeBoxes \
definition.\
\>", "Text",ExpressionUUID->"7a620464-895b-4e8c-bb8c-a12021281786"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "xTensorFormStart"}]], \
"Input",ExpressionUUID->"51f0e3cc-df40-4b7a-97df-6c348e450872"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensorFormStart[class] starts formatting for a \
class of objects. Valid classes are: ConstantSymbol, Parameter, InertHead, \
Tensor, CovD, LieD. xTensorFormStart[] starts formatting for all those \
classes.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`xTensorFormStart\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensorFormStart[class] starts formatting for a \
class of objects. Valid classes are: ConstantSymbol, Parameter, InertHead, \
Tensor, CovD, LieD. xTensorFormStart[] starts formatting for all those \
classes.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "xTensorFormStart[class] starts formatting for a class of objects. Valid \
classes are: ConstantSymbol, Parameter, InertHead, Tensor, CovD, LieD. \
xTensorFormStart[] starts formatting for all those classes.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`xTensorFormStart"], 
   False]]], "Output",ExpressionUUID->"315b6a78-e942-472d-b4d0-d6ff481028d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "xTensorFormStop"}]], \
"Input",ExpressionUUID->"6f3c0f61-0cfc-4132-95f4-41f2c8553c68"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensorFormStop[class] stops formatting for a class \
of objects. Valid classes are: ConstantSymbol, Parameter, InertHead, Tensor, \
CovD, LieD. xTensorFormStop[] stops formatting for all those classes.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`xTensorFormStop\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"xTensorFormStop[class] stops formatting for a class \
of objects. Valid classes are: ConstantSymbol, Parameter, InertHead, Tensor, \
CovD, LieD. xTensorFormStop[] stops formatting for all those classes.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "xTensorFormStop[class] stops formatting for a class of objects. Valid \
classes are: ConstantSymbol, Parameter, InertHead, Tensor, CovD, LieD. \
xTensorFormStop[] stops formatting for all those classes.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`xTensorFormStop"], 
   False]]], "Output",ExpressionUUID->"edcf06fe-8270-4ce0-a1c0-6623ffd094c8"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "]"}], ":=", 
   RowBox[{"xTensorFormStart", "/@", 
    RowBox[{"{", 
     RowBox[{
     "InertHead", ",", "ConstantSymbol", ",", "Parameter", ",", "Tensor", ",",
       "CovD", ",", "LieD", ",", "ParamD"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "]"}], ":=", 
   RowBox[{"xTensorFormStop", "/@", 
    RowBox[{"{", 
     RowBox[{
     "InertHead", ",", "ConstantSymbol", ",", "Parameter", ",", "Tensor", ",",
       "CovD", ",", "LieD", ",", "ParamD"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"xTensorFormStart", "::", "unknown"}], ",", 
      "\"\<class to format\>\"", ",", 
      RowBox[{"ToString", "[", "x", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"xTensorFormStop", "::", "unknown"}], ",", 
      "\"\<class to format\>\"", ",", 
      RowBox[{"ToString", "[", "x", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"xTensorFormStart", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"xTensorFormStop", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a2fdf2ab-b211-4120-80e9-d9c389ddff1f"],

Cell["\<\
We do not protect them because they will be given particular definitions \
below.\
\>", "Text",ExpressionUUID->"84689087-70d9-43c7-83a0-15f51dd4bee2"],

Cell["\<\
TODO: There should be a xTensorForm command. I need to study the *Form \
commands.\
\>", "Text",ExpressionUUID->"ff1b1e71-c0e7-4876-a77a-ef2f674e4c05"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.6.3. PrintAs", \
"Subsubsection",ExpressionUUID->"e76e8306-515d-43d0-ac3d-1172066f248a"],

Cell["\<\
These are functions to format symbols of objects. We need a discussion on why \
we use them instead of directly using Format. Currently the only reason is to \
have full control on the process. Format is one of those functions that does \
many things in an obscure way. Any defined symbol has its own PrintAs \
definition, including the abstract indices. In any other case PrintAs is \
simply ToString.

Addition in 1.1.4: We now accept box specifications in PrintAs. There is no \
System` function to detect what a box expression is, but there is \
System`Convert`TeXFormDump`BoxQ which contains all (or at least most) \
possibilities:\
\>", "Text",ExpressionUUID->"2dfc3550-89d8-46ce-9bb5-c8e6ab41b70b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "System`Convert`TeXFormDump`BoxQ"}]], \
"Input",ExpressionUUID->"973aaf21-c1cb-4768-accd-cd6470a16b31"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"System`Convert`TeXFormDump`BoxQ\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Definitions\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Definitions", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{
                    "System`Convert`TeXFormDump`BoxQ", "[", 
                    "System`Convert`CommonDump`box_", "]"}], ":=", 
                    RowBox[{"MatchQ", "[", 
                    RowBox[{
                    RowBox[{
                    "Unevaluated", "[", "System`Convert`CommonDump`box", 
                    "]"}], ",", 
                    RowBox[{
                    "_String", "|", "_RowBox", "|", "_GridBox", "|", 
                    "_SuperscriptBox", "|", "_SubscriptBox", "|", 
                    "_SubsuperscriptBox", "|", "_OverscriptBox", "|", 
                    "_UnderscriptBox", "|", "_UnderoverscriptBox", "|", 
                    "_FractionBox", "|", "_SqrtBox", "|", "_RadicalBox", "|", 
                    "_StyleBox", "|", "_FrameBox", "|", "_PaneBox", "|", 
                    "_PanelBox", "|", "_AdjustmentBox", "|", "_ButtonBox", 
                    "|", "_FormBox", "|", "_InterpretationBox", "|", 
                    "_TagBox", "|", "_ErrorBox", "|", "_CounterBox", "|", 
                    "_ValueBox", "|", "_OptionValueBox", "|", "_Cell", "|", 
                    "_BoxData", "|", "_TextData", "|", "_Notebook", "|", 
                    "_Graphics", "|", "_Graphics3D", "|", "_GraphicsArray", 
                    "|", "_GraphicsGrid", "|", "_SurfaceGraphics", "|", 
                    "_ContourGraphics", "|", "_DensityGraphics", "|", 
                    "_AnimatorBox", "|", "_CheckboxBox", "|", "_DynamicBox", 
                    "|", "_InputFieldBox", "|", 
                    "_System`Convert`TeXFormDump`MultiviewBox", "|", 
                    "_OpenerBox", "|", "_PopupMenuBox", "|", 
                    "_RadioButtonBox", "|", "_SliderBox", "|", 
                    "_System`Convert`TeXFormDump`TabbedMultiviewBox", "|", 
                    "_TooltipBox", "|", 
                    "_System`Convert`TeXFormDump`AreaSliderBox", "|", 
                    "_PaneSelectorBox", "|", "_TemplateBox", "|", 
                    "_TabViewBox"}]}], "]"}]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"System`Convert`TeXFormDump`BoxQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"System`Convert`TeXFormDump`BoxQ\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "System`Convert`TeXFormDump`BoxQ", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> 
    Information`InformationValueForm[
     DownValues, System`Convert`TeXFormDump`BoxQ, {
      System`Convert`TeXFormDump`BoxQ[
         Pattern[System`Convert`CommonDump`box, 
          Blank[]]] :> MatchQ[
         Unevaluated[System`Convert`CommonDump`box], 
         Alternatives[
          Blank[String], 
          Blank[RowBox], 
          Blank[GridBox], 
          Blank[SuperscriptBox], 
          Blank[SubscriptBox], 
          Blank[SubsuperscriptBox], 
          Blank[OverscriptBox], 
          Blank[UnderscriptBox], 
          Blank[UnderoverscriptBox], 
          Blank[FractionBox], 
          Blank[SqrtBox], 
          Blank[RadicalBox], 
          Blank[StyleBox], 
          Blank[FrameBox], 
          Blank[PaneBox], 
          Blank[PanelBox], 
          Blank[AdjustmentBox], 
          Blank[ButtonBox], 
          Blank[FormBox], 
          Blank[InterpretationBox], 
          Blank[TagBox], 
          Blank[ErrorBox], 
          Blank[CounterBox], 
          Blank[ValueBox], 
          Blank[OptionValueBox], 
          Blank[Cell], 
          Blank[BoxData], 
          Blank[TextData], 
          Blank[Notebook], 
          Blank[Graphics], 
          Blank[Graphics3D], 
          Blank[GraphicsArray], 
          Blank[GraphicsGrid], 
          Blank[SurfaceGraphics], 
          Blank[ContourGraphics], 
          Blank[DensityGraphics], 
          Blank[AnimatorBox], 
          Blank[CheckboxBox], 
          Blank[DynamicBox], 
          Blank[InputFieldBox], 
          Blank[System`Convert`TeXFormDump`MultiviewBox], 
          Blank[OpenerBox], 
          Blank[PopupMenuBox], 
          Blank[RadioButtonBox], 
          Blank[SliderBox], 
          Blank[System`Convert`TeXFormDump`TabbedMultiviewBox], 
          Blank[TooltipBox], 
          Blank[System`Convert`TeXFormDump`AreaSliderBox], 
          Blank[PaneSelectorBox], 
          Blank[TemplateBox], 
          Blank[TabViewBox]]]}], "SubValues" -> None, "DefaultValues" -> None,
     "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "System`Convert`TeXFormDump`BoxQ"], 
   True]]], "Output",ExpressionUUID->"94ecb755-e8de-4d42-9e93-6aaf554bb920"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"A", " ", "string", " ", "is", " ", "a", " ", 
    RowBox[{"string", ".", " ", "Null"}], " ", "means", " ", 
    RowBox[{"\"\<do not set typesetting\>\"", ".", " ", "Anything"}], " ", 
    "else", " ", "is", " ", "interpreted", " ", "as", " ", "a", " ", 
    "function"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"StripContext", "[", "string_String", "]"}], ":=", 
     RowBox[{"Last", "@", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"string", ",", "\"\<`\>\""}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsString", "[", 
      RowBox[{"symbol_", ",", "Null"}], "]"}], ":=", "Null"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsString", "[", 
      RowBox[{"symbol_", ",", "pa_String"}], "]"}], ":=", "pa"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsString", "[", 
      RowBox[{"symbol_", ",", "pa_Hold"}], "]"}], ":=", "pa"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsString", "[", 
      RowBox[{"symbol_", ",", 
       RowBox[{"pa_", "?", "System`Convert`TeXFormDump`BoxQ"}]}], "]"}], ":=",
      "pa"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsString", "[", 
      RowBox[{"symbol_", ",", "pa_"}], "]"}], ":=", 
     RowBox[{"StripContext", "[", "\[IndentingNewLine]", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"res", "=", 
          RowBox[{"pa", "[", "symbol", "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"StringQ", "[", "res", "]"}], ",", "res", ",", 
          RowBox[{"ToString", "[", "res", "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Handling", " ", "of", " ", "conjugate", " ", 
     RowBox[{"symbols", ":", " ", 
      RowBox[{
      "add", " ", "a", " ", "dagger", " ", "if", " ", "not", " ", "already", 
       " ", "present"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AddDaggerCharacter", "[", 
      RowBox[{"boxes_Hold", ",", "_"}], "]"}], ":=", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Don't know how to conjugate \>\"", ",", "boxes"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AddDaggerCharacter", "[", 
      RowBox[{"string_String", ",", "Conjugate"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"HasDaggerCharacterQ", "[", "string", "]"}], ",", "string", 
       ",", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"string", ",", "$DaggerCharacter"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AddDaggerCharacter", "[", 
      RowBox[{"boxes_", ",", "Conjugate"}], "]"}], ":=", 
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{"boxes", ",", "$DaggerCharacter"}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AddDaggerCharacter", "[", 
      RowBox[{"boxes_", ",", "dag_"}], "]"}], ":=", "boxes"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Main", ".", " ", "The"}], " ", "previous", " ", "two", " ", 
      "functions", " ", "will", " ", "be", " ", "used", " ", "in", " ", "its",
       " ", "second", " ", "argument"}], ",", " ", 
     RowBox[{"if", " ", "needed"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetPrintAs", "[", 
      RowBox[{"symbol_", ",", "Null"}], "]"}], ":=", "Null"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetPrintAs", "[", 
      RowBox[{"symbol_", ",", 
       RowBox[{"Hold", "[", "boxes_", "]"}]}], "]"}], ":=", 
     RowBox[{"xUpSetDelayed", "[", 
      RowBox[{
       RowBox[{"PrintAs", "[", "symbol", "]"}], ",", "boxes"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetPrintAs", "[", 
      RowBox[{"symbol_", ",", "string_"}], "]"}], ":=", 
     RowBox[{"xUpSet", "[", 
      RowBox[{
       RowBox[{"PrintAs", "[", "symbol", "]"}], ",", "string"}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3defeeb4-499d-47fa-bd99-c5f5f351b722"],

Cell["\<\
The PrintAs framework is very evaluation-leaky. This should be avoided, also \
generalizing the use of strings to general box expressions. TODO.\
\>", "Text",ExpressionUUID->"2a34b1d9-666f-4fa5-bcdd-be898d63d33e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "PrintAs"}]], \
"Input",ExpressionUUID->"81737b02-3415-4277-9f7d-1fb1429d7b7e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"PrintAs[symbol] gives the output string or boxes \
for symbol in StandardForm.\\n\\nPrintAs is also an option for the DefType \
commands that specifies the output form of a defined symbol. It can be \
PrintAs -> string or PrintAs -> boxes. If boxes are to be constructed in a \
delayed way then use PrintAs -> Hold[delayedboxes]. Finally it can also be \
PrintAs -> function, such that the output will be ToString[function[symbol]].\
\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`PrintAs\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"PrintAs[symbol] gives the output string or boxes \
for symbol in StandardForm.\\n\\nPrintAs is also an option for the DefType \
commands that specifies the output form of a defined symbol. It can be \
PrintAs -> string or PrintAs -> boxes. If boxes are to be constructed in a \
delayed way then use PrintAs -> Hold[delayedboxes]. Finally it can also be \
PrintAs -> function, such that the output will be ToString[function[symbol]].\
\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "PrintAs[symbol] gives the output string or boxes for symbol in \
StandardForm.\n\nPrintAs is also an option for the DefType commands that \
specifies the output form of a defined symbol. It can be PrintAs -> string or \
PrintAs -> boxes. If boxes are to be constructed in a delayed way then use \
PrintAs -> Hold[delayedboxes]. Finally it can also be PrintAs -> function, \
such that the output will be ToString[function[symbol]].", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`PrintAs"], 
   False]]], "Output",ExpressionUUID->"cc4b0a72-cf8e-440f-bf87-1a203aff8050"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"PrintAs", ",", "HoldFirst"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "head_", "]"}], ":=", 
   RowBox[{"ToString", "[", 
    RowBox[{"Unevaluated", "[", "head", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"PrintAs", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "PrintAs", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ebf14ca5-b7f7-4c0f-9cae-35eb616beb54"],

Cell["\<\
Finally, a simple way to print with a very small font, currently only used \
with projectors.\
\>", "Text",ExpressionUUID->"140032b7-ca7a-4328-ae6b-a346ec207be7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "STRINGPRINTAS", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"PrintAsSmaller", "[", "proj_", "]"}], ":=", 
    RowBox[{"\"\<\\*StyleBox[\\\"\>\"", "<>", 
     RowBox[{"PrintAs", "[", "proj", "]"}], "<>", 
     "\"\<\\\",FontSize->Tiny]\>\""}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0c58a60c-1d0e-4706-a8b0-823bfceb64fd"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.6.4. GiveSymbol, GiveOutputString, PrintAsCharacter", \
"Subsubsection",ExpressionUUID->"80de2df8-c7d7-4004-abd1-ad12ec6ede71"],

Cell["\<\
These functions give names to all tensors that are associated in real time to \
other previously defined **symbols**. GiveSymbol defines the internal (true) \
name of the tensors. GiveOutputString defines the PrintAs name for those \
tensors. Special definitions for special types of tensors will be defined \
below. Note that GiveSymbol returns a symbol but GiveOutputString returns a \
string.\
\>", "Text",ExpressionUUID->"1208cad2-442a-410e-8ab5-e8369e81db37"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "GiveSymbol"}]], \
"Input",ExpressionUUID->"ddac6cf0-329d-4f3a-a363-0576624a49b8"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"GiveSymbol[object, case] constructs a symbol for \
the required object in the special given case. Both must be symbols or \
strings.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`GiveSymbol\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"GiveSymbol[object, case] constructs a symbol for \
the required object in the special given case. Both must be symbols or \
strings.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "GiveSymbol[object, case] constructs a symbol for the required object in \
the special given case. Both must be symbols or strings.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`GiveSymbol"], 
   False]]], "Output",ExpressionUUID->"ab0fd2cb-30df-4283-ac26-0e9276165da6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "GiveOutputString"}]], \
"Input",ExpressionUUID->"6af09ef7-70bb-427b-8aec-b741bfb07a05"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"GiveOutputString[object, case] gives the string to \
be used as output in StandardForm. Both object and case must be symbols or \
strings.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`GiveOutputString\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"GiveOutputString[object, case] gives the string to \
be used as output in StandardForm. Both object and case must be symbols or \
strings.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "GiveOutputString[object, case] gives the string to be used as output in \
StandardForm. Both object and case must be symbols or strings.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`GiveOutputString"], 
   False]]], "Output",ExpressionUUID->"ba508b6d-8c57-4734-a16f-e9f0c3af76ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "PrintAsCharacter"}]], \
"Input",ExpressionUUID->"d000f998-4f29-42ba-bae0-0052bb2c2d00"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"PrintAsCharacter[symbol] returns a character to be \
used in the typesetting of fundamental objects in xTensor. For example \
\\\"R\\\" for Riemann, \\\"G\\\" for Einstein, etc.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`PrintAsCharacter\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"PrintAsCharacter[symbol] returns a character to be \
used in the typesetting of fundamental objects in xTensor. For example \
\\\"R\\\" for Riemann, \\\"G\\\" for Einstein, etc.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "PrintAsCharacter[symbol] returns a character to be used in the \
typesetting of fundamental objects in xTensor. For example \"R\" for Riemann, \
\"G\" for Einstein, etc.", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`PrintAsCharacter"], 
   False]]], "Output",ExpressionUUID->"4e912b26-92f0-48c2-933e-115ff8e7b68a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Default", " ", "definition", " ", "for", " ", "the", " ", "names", " ", 
     "of", " ", "automatically"}], "-", 
    RowBox[{"defined", " ", 
     RowBox[{"tensors", ".", " ", "They"}], " ", "must", " ", "be", " ", 
     "symbols"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"GiveSymbol", "[", 
      RowBox[{"symbol_Symbol", ",", "post___"}], "]"}], ":=", 
     RowBox[{"SymbolJoin", "[", 
      RowBox[{"symbol", ",", "post"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{"(*", " ", 
    RowBox[{
    "Do", " ", "not", " ", "put", " ", "any", " ", "restrictions", " ", 
     "here", " ", "to", " ", "make", " ", "this", " ", "definition", " ", 
     "be", " ", "always", " ", "the", " ", "last", " ", 
     RowBox[{"downvalue", ".", " ", "STRINGPRINTAS"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GiveOutputString", "[", 
      RowBox[{"symbol_Symbol", ",", "post___"}], "]"}], ":=", 
     RowBox[{"StringJoin", "[", 
      RowBox[{
       RowBox[{"PrintAsCharacter", "[", "symbol", "]"}], ",", 
       RowBox[{"PrintAs", "/@", 
        RowBox[{"{", "post", "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetAttributes", "[", 
     RowBox[{"PrintAsCharacter", ",", "HoldFirst"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAsCharacter", "[", "symbol_Symbol", "]"}], ":=", 
     RowBox[{"First", "@", 
      RowBox[{"Characters", "@", 
       RowBox[{"ToString", "[", 
        RowBox[{"Unevaluated", "[", "symbol", "]"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"GiveSymbol", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"GiveOutputString", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"PrintAsCharacter", ",", "1"}], "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"98eb494f-2571-4dfd-9264-d555760bff2a"],

Cell["\<\
These functions cannot be protected because we will give particular \
definitions for them below.\
\>", "Text",ExpressionUUID->"12901494-5d73-4a2b-8292-12c49d261c41"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "2.6.5. ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"T", 
    AdjustmentBox["E",
     BoxBaselineShift->0.5,
     BoxMargins->{{-0.075, -0.085}, {0, 0}}], "X"}]]],ExpressionUUID->
  "d8502830-efac-4c1d-a5ab-8d7a041db975"]
}], "Subsubsection",ExpressionUUID->"2d48be67-cc40-4eb1-b43a-328fe5a126ea"],

Cell[TextData[{
 "We have a fully dedicated package now: ",
 StyleBox["TexAct",
  FontSlant->"Italic"],
 "."
}], "Text",ExpressionUUID->"9565f2d9-7fba-4a6c-a5e4-f5f1a0164046"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.6.6. Formatting pullbacks, pushforwards, etc", \
"Subsubsection",ExpressionUUID->"be9a3951-8a64-4f7c-b3fc-786ec45a1469"],

Cell["Utilities for formatting.", \
"Text",ExpressionUUID->"f233d529-6658-454b-879c-35acb4cf24e7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$StarCharacter", "=", "\"\<*\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$PrecomposeCharacter", "=", "\"\<\[SmallCircle]\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$LinearPushCharacter", "=", "\"\<\[CenterDot]\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"959d78be-19e0-408d-b80f-148aeb97fd44"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PullBackString", "[", 
    RowBox[{"string_String", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<(\\!\\(\>\"", ",", 
     RowBox[{"PrintAs", "[", "phi", "]"}], ",", "\"\<\\^\>\"", ",", 
     "$StarCharacter", ",", "string", ",", "\"\<\\))\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrecomposeString", "[", 
    RowBox[{"string_String", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<(\>\"", ",", "string", ",", "$PrecomposeCharacter", ",", 
     RowBox[{"PrintAs", "[", "phi", "]"}], ",", "\"\<)\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackBox", "[", 
    RowBox[{"box_", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SuperscriptBox", "[", 
       RowBox[{
        RowBox[{"PrintAs", "[", "phi", "]"}], ",", "$StarCharacter"}], "]"}], 
      ",", "box"}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrecomposeBox", "[", 
    RowBox[{"box_", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{"box", ",", "$PrecomposeCharacter", ",", 
      RowBox[{"PrintAs", "[", "phi", "]"}]}], "}"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e9ab53bc-2778-419c-8233-6297425ae6a6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PushForwardString", "[", 
    RowBox[{"string_String", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<(\\!\\(\>\"", ",", 
     RowBox[{"PrintAs", "[", "phi", "]"}], ",", "\"\<\\_\>\"", ",", 
     "$StarCharacter", ",", "string", ",", "\"\<\\))\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LinearPushString", "[", 
    RowBox[{"string_String", ",", "dphi_"}], "]"}], ":=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<(\>\"", ",", 
     RowBox[{"PrintAs", "[", "dphi", "]"}], ",", "$LinearPushCharacter", ",", 
     "string", ",", "\"\<)\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PushForwardBox", "[", 
    RowBox[{"box_", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SubscriptBox", "[", 
       RowBox[{
        RowBox[{"PrintAs", "[", "phi", "]"}], ",", "$StarCharacter"}], "]"}], 
      ",", "box"}], "}"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4d344fe4-40b4-4780-8ad6-dffbf614a967"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.7. The Info messages: MakeDefInfo, MakeUndefInfo", \
"Subsection",ExpressionUUID->"d654d2db-4e29-49e6-a8f8-b9bad2cd7191"],

Cell["\<\
These functions and variables control the info messages printed at definition \
and undefinition times. Those messages can be deactivated globally with \
$DefInfoQ=False and/or $UndefInfoQ=False, or locally with the option \
DefInfo->False. There is not yet an UndefInfo option.\
\>", "Text",ExpressionUUID->"fe7da32f-c82e-4157-aba5-04146a25840a"],

Cell["Add a blank after any non-empty string:", \
"Text",ExpressionUUID->"27e6eb30-bc96-4899-aecd-b96422cad39a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"makespace", "[", "\"\<\>\"", "]"}], ":=", "\"\<\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"makespace", "[", "other_", "]"}], ":=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"other", ",", "\"\< \>\""}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e1e15d88-5381-4aff-b5a0-ef5d1e3ce9d1"],

Cell["\<\
The default value of DefInfo is controlled globally with the following global \
variable:\
\>", "Text",ExpressionUUID->"fefb464d-aabe-4ce4-9a19-666353736ba7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$DefInfoQ"}]], \
"Input",ExpressionUUID->"32d16567-a70d-4272-a952-8a38e5844a77"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"$DefInfoQ is a boolean global variable controlling \
whether the info definition messages are printed. By default it is True, but \
setting it to False deactivates all Def messages.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`$DefInfoQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"$DefInfoQ is a boolean global variable controlling \
whether the info definition messages are printed. By default it is True, but \
setting it to False deactivates all Def messages.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "$DefInfoQ is a boolean global variable controlling whether the info \
definition messages are printed. By default it is True, but setting it to \
False deactivates all Def messages.", "Documentation" -> None, "OwnValues" -> 
    None, "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`$DefInfoQ"], 
   False]]], "Output",ExpressionUUID->"ac6fe185-d94e-4ced-a022-d02f6102f5f4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"aa198a08-c339-4f92-a1b6-ea71ba5310bc"],

Cell["\<\
This function constructs all \"defininig\" messages (always three arguments, \
to avoid worrying about whether we have set up or not DefInfo already):\
\>", "Text",ExpressionUUID->"2448ab52-6e5c-44dc-80f9-fce96b4f8f88"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeDefInfo", "[", 
    RowBox[{"_", ",", "_", ",", "False", ",", 
     RowBox[{"vanishQ_", ":", "False"}]}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDefInfo", "[", 
    RowBox[{"command_Symbol", ",", "object_", ",", 
     RowBox[{"{", 
      RowBox[{"secondarytype_String", ",", "info_String", ",", "___"}], "}"}],
      ",", 
     RowBox[{"vanishQ_", ":", "False"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{"$DefInfoQ", ",", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<** \>\"", ",", "command", ",", "\"\<: Defining \>\"", ",", 
       RowBox[{"makespace", "@", 
        RowBox[{"If", "[", 
         RowBox[{"vanishQ", ",", 
          RowBox[{"\"\<vanishing \>\"", "<>", "secondarytype"}], ",", 
          "secondarytype"}], "]"}]}], ",", " ", "object", ",", "\"\<. \>\"", 
       ",", "info"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"22e7731c-2498-4603-9ec4-f1eb0a50b959"],

Cell["\<\
Only objects registered through a DefType function have a value for DefInfo:\
\>", "Text",ExpressionUUID->"44b52715-6b21-4642-a724-4d3aab5e5ab7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefInfo", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefInfo", "::", "error1"}], ",", 
      "\"\<Object `1` has not been registered using a DefType function.\>\"", 
      ",", "x"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c58c0549-76a1-4dad-956d-d2eccd217d5e"],

Cell["\<\
Corresponding function for undefinition (False as third argument is currently \
not being used, because the UndefType functions do not have options):\
\>", "Text",ExpressionUUID->"4b9a7e49-bef3-44aa-a2d3-4b14d962cc6d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$UndefInfoQ"}]], \
"Input",ExpressionUUID->"98017df3-59e2-468a-b7a1-edea674a79cc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"$UndefInfoQ is a boolean global variable \
controlling whether the info undefinition messages are printed. By default it \
is True, but setting it to False deactivates all Undef messages.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`$UndefInfoQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"$UndefInfoQ is a boolean global variable \
controlling whether the info undefinition messages are printed. By default it \
is True, but setting it to False deactivates all Undef messages.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "$UndefInfoQ is a boolean global variable controlling whether the info \
undefinition messages are printed. By default it is True, but setting it to \
False deactivates all Undef messages.", "Documentation" -> None, "OwnValues" -> 
    None, "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`$UndefInfoQ"], 
   False]]], "Output",ExpressionUUID->"e86fd276-8feb-48af-a075-2dca93a52b8f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$UndefInfoQ", "=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c7c6cfad-ecf0-4751-aa62-336f586ad4b4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeUndefInfo", "[", 
    RowBox[{"command_Symbol", ",", "object_"}], "]"}], ":=", 
   RowBox[{"MakeUndefInfo", "[", 
    RowBox[{"command", ",", "object", ",", 
     RowBox[{"DefInfo", "[", "object", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeUndefInfo", "[", 
    RowBox[{"command_Symbol", ",", "object_", ",", "False"}], "]"}], ":=", 
   "Null"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeUndefInfo", "[", 
    RowBox[{"command_Symbol", ",", "object_", ",", 
     RowBox[{"{", 
      RowBox[{"info_", ",", "_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{"$UndefInfoQ", ",", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<** \>\"", ",", "command", ",", "\"\<: Undefined \>\"", ",", "info",
        ",", "\"\< \>\"", ",", "object"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"cb3b5eeb-b496-40e2-b450-79de0cf2a868"],

Cell["Example:", \
"Text",ExpressionUUID->"c43e6003-7fd5-4a66-85ee-dbe0eec3e7d6"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"2bfa071f-c18c-4dc9-bf8e-41dc87fc0873"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`MakeDefInfo", "[", 
  RowBox[{"DefTensor", ",", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<some tensor\>\"", ",", "\"\<\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1e96ea72-3d46-4f39-a234-8da6f6e3de55"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"some tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "some tensor ", 
   $CellContext`T[$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"28192585-cf65-4451-a29d-9ab12c9487b3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "T"}], 
  "]"}]], "Input",ExpressionUUID->"221fe6a0-3e08-49ad-a5c3-c1ba5964af43"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"6c83cb3d-ad77-4d5c-b5e6-ff06a97c81d0"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["3. Four simple types",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"3d30da11-0891-4872-98dc-d28b0385eabd"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     " ", "3."}], " ", "Four", " ", "simple", " ", "types"}], " ", 
  "***************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5e1aa4a4-b8b1-4a11-8d86-1953d0c24063"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"5d942096-14f5-40a5-8562-ff37c05a88f4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "10.325855`", ",", "303.092136`8.933119661846073", ",", 
   "0.03406845968588716`"}], 
  "}"}]], "Output",ExpressionUUID->"8f731098-201b-4eb3-b964-780c7614e01f"]
}, Open  ]],

Cell[CellGroupData[{

Cell["3.0. Comments", \
"Subsection",ExpressionUUID->"7bcbd4f1-dfc0-4c36-a999-6c11dae921bd"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 3: Simple types.\>\"", "]"}], 
   ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a05491c0-e569-49e0-982a-20a793a6845e"],

Cell["\<\
Just a comment: there is no need of efficiency in the Def-functions.\
\>", "Text",ExpressionUUID->"e2e46824-3a09-42d5-86a5-04327bfd14b6"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.1. InertHeads. ERROR, Dagger and Keep", \
"Subsection",ExpressionUUID->"2dccfbb1-63a5-432d-a38e-dea7523ff162"],

Cell[CellGroupData[{

Cell["3.1.0. Comments", \
"Subsubsection",ExpressionUUID->"ded638d4-863a-4fef-8317-91ab9cbc0331"],

Cell[TextData[{
 "The concept of inert-head was designed initially in a very simple way, just \
as a slight modifier of a tensor expression, with the only property of \
representing a tensor expression whose indices and symmetries are exactly \
those of the wrapped expression. Now, mostly due to suggestions by Guillaume \
Faye, it has become clear that this concept must be expanded and clarified, \
making it far more powerful and useful.\n\nThe first issue is whether an \
inert-head must be linear or not necessarily. I think that the tensorial \
character of the expression is intimately connected with linearity. However, \
what happens if we want the inert-head to be antilinear? As pointed out by \
Guillaume, perhaps it could be even truly nonlinear. Another possibility is \
that of an inert-head that acts as a differential operator, and hence behaves \
differently on constants and scalar fields. Because it is very simple to do \
it, there is an option LinearQ->True/False at definition time to control \
that. The default will be False. Linearity is with respect to constants, and \
not with respect to scalar fields.\n\nThe second issue is whether the metric \
or the delta tensor can be contracted through the inert-head. In general this \
is not true, and another option ContractThrough controls that point. Think of \
the inert-head TracelessPart as an example.\n\nA third point is what kind of \
additional arguments an inert-head can have. In principle we could have many \
more arguments, with the only restriction that the \"wrapped expression\" is \
in the first argument. Other arguments can contain indexed tensors, but these \
tensors will not be seen by ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". I cannot think of a single example where such a thing could be needed. \
Then we can have arguments containing indices, and there are clear examples \
of that. Those indices could be a subset of the indices of the tensor \
expression or could be additional indices (some kind of \"extension\" of the \
expression). Those indices are simply marked with the head IndexList. We \
assume that the indices of the whole expression are the unsorted union of the \
indices of the expression and the additional indices. All commands must \
ensure synchronicity of both sets of indices, in case such a thing is \
expected; that is, if indices are repeated  in the inert-head and we do some \
index replacement then those indices must be repeated at the end too."
}], "Text",ExpressionUUID->"7b025705-b318-42b4-a8ab-9fa26c63a89d"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.1.1. Definition", \
"Subsubsection",ExpressionUUID->"2fcc93f8-7c7c-4fb7-957c-977dbcb9cea6"],

Cell["\<\
A prototypical example of an inert-head is TracelessPart. We can have \
expressions like TracelessPart[ T[a,b] ] with obvious meaning. Considered as \
a tensor, TracelessPart[ T[a,b] ] inherits all symmetry properties from \
T[a,b] and has more.\
\>", "Text",ExpressionUUID->"57114ce1-3824-459d-94d7-67b982d3d078"],

Cell["\<\
Following Leo, xAct 1.1.0 accepts nonatomic inert heads, and actually \
DefInertHead does that too, which is something new in xAct. I mean, \
DefInertHead is the first command that defines something different from a \
symbol. Still, definitions are attached to the subhead (as computed by \
SubHead) of the defined object, which is always a symbol. This change \
requires deciding when to play with the whole inert head and when with its \
subhead, and I\[CloseCurlyQuote]m still not sure we got all decisions right \
yet...\
\>", "Text",ExpressionUUID->"b27d73c3-0a57-4d42-8887-c9092a1622d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DefInertHead"}]], \
"Input",ExpressionUUID->"a25105e5-fd5e-44a5-aeb9-d7c6f7594fd1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DefInertHead[head] defines an inert head such that \
head[expr] is treated as expr from the tensorial point of view.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`DefInertHead\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DefInertHead[head] defines an inert head such that \
head[expr] is treated as expr from the tensorial point of view.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "DefInertHead[head] defines an inert head such that head[expr] is treated \
as expr from the tensorial point of view.", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`DefInertHead"], 
   False]]], "Output",ExpressionUUID->"7bc4f38a-5db6-4892-a1d4-912c019d3737"]
}, Open  ]],

Cell["\<\
We do not associate dependencies, hosts or visitors to the inert head; any \
holding attribute must be introduced by hand by the user. A general \
inert-head could have any number of arguments, but only the first one is \
assumed to be a tensor. QUESTION: Perhaps we should define anti-linear \
inert-heads. There is no predefined concept of complex conjugation here.\
\>", "Text",ExpressionUUID->"28d1c817-f2ad-4a63-8862-e0dce7118752"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefInertHead", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"LinearQ", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ContractThrough", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<inert head\>\"", ",", "\"\<\>\""}], "}"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInertHead", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefInertHead", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInertHead", "[", 
    RowBox[{"ih_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"head", "=", 
        RowBox[{"SubHead", "[", "ih", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "lin", ",", "cthrough", ",", "master", ",", "pa", ",", "pns", ",", 
          "info", ",", "x", ",", "y"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "lin", ",", "cthrough", ",", "master", ",", "pa", ",", "pns", ",", 
            "info"}], "}"}], "=", 
          RowBox[{"OptionValue", "[", 
           RowBox[{"{", 
            RowBox[{
            "LinearQ", ",", "ContractThrough", ",", "Master", ",", "PrintAs", 
             ",", "ProtectNewSymbol", ",", "DefInfo"}], "}"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "Validate", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"ValidateSymbol", "[", "head", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ValidateSymbolInSession", "[", "head", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"MakeDefInfo", "[", 
          RowBox[{"DefInertHead", ",", "ih", ",", "info"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakexTensions", "[", 
          RowBox[{
          "DefInertHead", ",", "\"\<Beginning\>\"", ",", "ih", ",", 
           "options"}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendToUnevaluated", "[", 
          RowBox[{"$InertHeads", ",", "head"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"head", "/:", 
          RowBox[{"InertHeadQ", "[", "ih", "]"}], "=", "True"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"head", "/:", 
          RowBox[{"DefInfo", "[", "ih", "]"}], "=", "info"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"SetPrintAs", "[", 
          RowBox[{"ih", ",", 
           RowBox[{"PrintAsString", "[", 
            RowBox[{"ih", ",", "pa"}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"SymbolRelations", "[", 
          RowBox[{"head", ",", "master", ",", 
           RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Metric", " ", "/", " ", "projector"}], " ", "/", " ", 
            "delta"}], " ", "contraction"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"xTagSet", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"head", ",", 
               RowBox[{"ContractThroughQ", "[", 
                RowBox[{"ih", ",", "#"}], "]"}]}], "}"}], ",", "True"}], 
            "]"}], "&"}], "/@", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", "cthrough", "}"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Linearity", ".", " ", "Only"}], " ", "with", " ", 
            "respect", " ", "to", " ", "constants"}], ",", " ", 
           RowBox[{"not", " ", "general", " ", "scalar", " ", "fields"}]}], 
          " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"head", "/:", 
          RowBox[{"LinearQ", "[", "ih", "]"}], "=", "lin"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"lin", ",", 
           RowBox[{"MakeLinear", "[", 
            RowBox[{"ih", ",", 
             RowBox[{"NoPattern", "[", "ih", "]"}]}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakexTensions", "[", 
          RowBox[{
          "DefInertHead", ",", "\"\<End\>\"", ",", "ih", ",", "options"}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "Protect", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"pns", ",", 
           RowBox[{"Protect", "[", "head", "]"}]}], "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefInertHead", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "DefInertHead", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bf67d8ca-26da-44a4-82a4-c272c78e1e42"],

Cell["\<\
To avoid variable renaming on the LHS we need to send both ihL and ihR to \
MakeLinear.\
\>", "Text",ExpressionUUID->"fbb7dd75-e1a1-4365-816d-a16f93302d8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeLinear", "[", 
    RowBox[{"ihL_", ",", "ihR_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"ihL", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Verbatim", "[", "Times", "]"}], "[", 
         RowBox[{"l___", ",", 
          RowBox[{"x_", "?", "ConstantQ"}], ",", "r___"}], "]"}], ",", 
        "z___"}], "]"}], ":=", 
      RowBox[{"x", " ", 
       RowBox[{"ihR", "[", 
        RowBox[{
         RowBox[{"Times", "[", 
          RowBox[{"l", ",", "r"}], "]"}], ",", "z"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ihL", "[", 
       RowBox[{"sum_Plus", ",", "z___"}], "]"}], ":=", 
      RowBox[{
       RowBox[{
        RowBox[{"ihR", "[", 
         RowBox[{"#", ",", "z"}], "]"}], "&"}], "/@", "sum"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ihL", "[", 
       RowBox[{"expr_SeriesData", ",", "z___"}], "]"}], ":=", 
      RowBox[{"SeriesDataMap", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ihR", "[", 
          RowBox[{"#", ",", "z"}], "]"}], "&"}], ",", "expr"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ihL", "[", 
       RowBox[{"0", ",", "z___"}], "]"}], ":=", "0"}], ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2663f74e-1ac3-47d0-8f98-d3d15369ad9d"],

Cell["\<\
Now that we accept nonatomic inert-heads containing tensorial objects, we \
need this function, as pointed out by Leo. It must be configured locally by \
the user; this is just the default:\
\>", "Text",ExpressionUUID->"ed229dc7-5527-4138-bdf9-83f63210ed0e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfInertHead", "[", "ih_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DependenciesOfInertHead", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DependenciesOfInertHead", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"32be1d1a-3f07-4b2b-ac61-f2165fcd4bef"],

Cell["\<\
Note once more that linearity is only with respect to constants, and not with \
respect to scalars in general.\
\>", "Text",ExpressionUUID->"fbb66d20-e40a-409c-8f16-4479b38025e0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "LinearQ"}]], \
"Input",ExpressionUUID->"24b07115-863c-4695-9257-e5a5608f2c6d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"LinearQ is a Boolean option for DefInertHead and \
DefProduct stating that the symbol defined is linear with respect to \
constants in its tensorial argument(s). The default value is \
False.\\n\\nLinearQ[head] gives True if head has been defined as a linear \
inert-head or product, and False otherwise.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`LinearQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"LinearQ is a Boolean option for DefInertHead and \
DefProduct stating that the symbol defined is linear with respect to \
constants in its tensorial argument(s). The default value is \
False.\\n\\nLinearQ[head] gives True if head has been defined as a linear \
inert-head or product, and False otherwise.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "LinearQ is a Boolean option for DefInertHead and DefProduct stating that \
the symbol defined is linear with respect to constants in its tensorial \
argument(s). The default value is False.\n\nLinearQ[head] gives True if head \
has been defined as a linear inert-head or product, and False otherwise.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`LinearQ"], 
   False]]], "Output",ExpressionUUID->"3e3e4582-c11b-4ced-a7ee-b420150c2090"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LinearQ", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"LinearQ", "::", "unknown"}], ",", "\"\<inert-head\>\"", ",", 
      "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"LinearQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "LinearQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3d9ff630-a55c-4034-baa9-ed151b380464"],

Cell["\<\
This function states whether it is possible to contract a metric through the \
inert-head:\
\>", "Text",ExpressionUUID->"91ecdfad-7749-4bc2-82a0-de7d9602529b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ContractThrough"}]], \
"Input",ExpressionUUID->"a07a617e-e32a-4274-bc90-d4808bbd9e7b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ContractThrough is an option for DefInertHead \
specifying a list of metrics and/or the delta tensor which can be contracted \
through the defined inert-head.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`ContractThrough\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ContractThrough is an option for DefInertHead \
specifying a list of metrics and/or the delta tensor which can be contracted \
through the defined inert-head.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "ContractThrough is an option for DefInertHead specifying a list of \
metrics and/or the delta tensor which can be contracted through the defined \
inert-head.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    None, "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`ContractThrough"], 
   False]]], "Output",ExpressionUUID->"35c466b6-56f3-42da-b3b7-2f2fb850227d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "ContractThrough", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"842701fd-b34a-4215-ba4b-56f6004cc2c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ContractThroughQ"}]], \
"Input",ExpressionUUID->"8d494eff-cce6-44c0-84e0-d0e5b4008505"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ContractThroughQ[head, metric] says whether the \
given metric can be contracted through the inert head. The default value is \
False.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`ContractThroughQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ContractThroughQ[head, metric] says whether the \
given metric can be contracted through the inert head. The default value is \
False.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "ContractThroughQ[head, metric] says whether the given metric can be \
contracted through the inert head. The default value is False.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`ContractThroughQ"], 
   False]]], "Output",ExpressionUUID->"5e64df33-8741-4f7f-9cd8-ddb162abe780"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ContractThroughQ", "[", 
    RowBox[{"ih_", ",", "metric_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ContractThroughQ", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ContractThroughQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8610faa7-e65c-4aba-89d8-a9a89e19e689"],

Cell["Undefinition:", \
"Text",ExpressionUUID->"87f9541f-7670-483b-a807-6f7fc177692a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefInertHead"}]], \
"Input",ExpressionUUID->"adebd7ac-0e7a-449c-8ef2-56237f6949c1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"UndefInertHead[head] undefines the inert head.\"\>",
              "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`UndefInertHead\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"UndefInertHead[head] undefines the inert head.\"\>",
              "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "UndefInertHead[head] undefines the inert head.", "Documentation" -> None,
     "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`UndefInertHead"], 
   False]]], "Output",ExpressionUUID->"38f1fac0-9256-4718-a296-5d32017ff226"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefInertHead", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "InertHeadQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefInertHead", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefInertHead", "[", "ih_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"head", "=", 
        RowBox[{"SubHead", "[", "ih", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"servants", "=", 
          RowBox[{"ServantsOf", "[", "head", "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"InertHeadQ", "[", "ih", "]"}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"UndefInertHead", "::", "unknown"}], ",", 
              "\"\<inert head\>\"", ",", "ih"}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"CheckRemoveSymbol", "[", "head", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakexTensions", "[", 
          RowBox[{"UndefInertHead", ",", "\"\<Beginning\>\"", ",", "ih"}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"xUpSet", "[", 
          RowBox[{
           RowBox[{"ServantsOf", "[", "head", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"DropFromHosts", "[", "head", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Undef", "/@", 
          RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"$InertHeads", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{"$InertHeads", ",", "head"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakexTensions", "[", 
          RowBox[{"UndefInertHead", ",", "\"\<End\>\"", ",", "ih"}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"MakeUndefInfo", "[", 
          RowBox[{"UndefInertHead", ",", "ih"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"RemoveSymbol", "[", "head", "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefInertHead", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefInertHead", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7ec829ff-f256-4431-add7-fe0b52c3d58f"],

Cell["Examples:", \
"Text",ExpressionUUID->"7308921f-e857-416d-8157-622fe07f9011"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"fb5341e0-439c-473c-9e91-a21b43191ee7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefInertHead", "[", 
  RowBox[{"TTPart", ",", 
   RowBox[{"LinearQ", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"bd4f8993-922e-45f4-89c0-783538f630eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefInertHead", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"inert head \"\>", "\[InvisibleSpace]", "TTPart", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefInertHead, ": Defining ", 
   "inert head ", $CellContext`TTPart, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e4b5ede6-eb65-4390-9b8a-38bdcd88614f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TTPart"}]], "Input",ExpressionUUID->"43fa2dbb-8faf-4b1d-87a4-a89f5687a7ce"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`TTPart\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"InertHeadQ", "[", "TTPart", "]"}], "^=", 
                    "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", "TTPart", "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"inert head\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", "TTPart", "]"}], 
                    "^=", "\<\"TTPart\"\>"}]},
                    {
                    RowBox[{
                    RowBox[{"LinearQ", "[", "TTPart", "]"}], "^=", "True"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" DownValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"DownValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "DownValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"TTPart", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Verbatim", "[", "Times", "]"}], "[", 
                    RowBox[{"xAct`xTensor`Private`l$___", ",", 
                    RowBox[{"xAct`xTensor`Private`x$_", "?", "ConstantQ"}], 
                    ",", "xAct`xTensor`Private`r$___"}], "]"}], ",", 
                    "xAct`xTensor`Private`z$___"}], "]"}], ":=", 
                    RowBox[{"xAct`xTensor`Private`x$", " ", 
                    RowBox[{"TTPart", "[", 
                    RowBox[{
                    RowBox[{
                    "xAct`xTensor`Private`l$", " ", 
                    "xAct`xTensor`Private`r$"}], ",", 
                    "xAct`xTensor`Private`z$"}], "]"}]}]}]},
                    {
                    RowBox[{
                    RowBox[{"TTPart", "[", 
                    RowBox[{
                    "xAct`xTensor`Private`sum$_Plus", ",", 
                    "xAct`xTensor`Private`z$___"}], "]"}], ":=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"TTPart", "[", 
                    RowBox[{"#1", ",", "xAct`xTensor`Private`z$"}], "]"}], 
                    "&"}], ")"}], "/@", "xAct`xTensor`Private`sum$"}]}]},
                    {
                    RowBox[{
                    RowBox[{"TTPart", "[", 
                    RowBox[{
                    "xAct`xTensor`Private`expr$_SeriesData", ",", 
                    "xAct`xTensor`Private`z$___"}], "]"}], ":=", 
                    RowBox[{"xAct`xTensor`Private`SeriesDataMap", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"TTPart", "[", 
                    RowBox[{"#1", ",", "xAct`xTensor`Private`z$"}], "]"}], 
                    "&"}], ",", "xAct`xTensor`Private`expr$"}], "]"}]}]},
                    {
                    RowBox[{
                    RowBox[{"TTPart", "[", 
                    RowBox[{"0", ",", "xAct`xTensor`Private`z___"}], "]"}], ":=",
                     "0"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`TTPart\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`TTPart\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`TTPart", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`TTPart, {
      xAct`xTensor`InertHeadQ[$CellContext`TTPart] -> True, 
       xAct`xTensor`DefInfo[$CellContext`TTPart] -> {"inert head", ""}, 
       xAct`xTensor`PrintAs[$CellContext`TTPart] -> "TTPart", 
       xAct`xTensor`LinearQ[$CellContext`TTPart] -> True}], "DownValues" -> 
    Information`InformationValueForm[
     DownValues, $CellContext`TTPart, {$CellContext`TTPart[
         Verbatim[Times][
          Pattern[xAct`xTensor`Private`l$, 
           BlankNullSequence[]], 
          PatternTest[
           Pattern[xAct`xTensor`Private`x$, 
            Blank[]], xAct`xTensor`ConstantQ], 
          Pattern[xAct`xTensor`Private`r$, 
           BlankNullSequence[]]], 
         Pattern[xAct`xTensor`Private`z$, 
          BlankNullSequence[]]] :> 
       xAct`xTensor`Private`x$ $CellContext`TTPart[
         xAct`xTensor`Private`l$ xAct`xTensor`Private`r$, 
          xAct`xTensor`Private`z$], $CellContext`TTPart[
         Pattern[xAct`xTensor`Private`sum$, 
          Blank[Plus]], 
         Pattern[xAct`xTensor`Private`z$, 
          BlankNullSequence[]]] :> 
       Map[$CellContext`TTPart[#, xAct`xTensor`Private`z$]& , 
         xAct`xTensor`Private`sum$], $CellContext`TTPart[
         Pattern[xAct`xTensor`Private`expr$, 
          Blank[SeriesData]], 
         Pattern[xAct`xTensor`Private`z$, 
          BlankNullSequence[]]] :> 
       xAct`xTensor`Private`SeriesDataMap[$CellContext`TTPart[#, 
          xAct`xTensor`Private`z$]& , 
         xAct`xTensor`Private`expr$], $CellContext`TTPart[0, 
         Pattern[xAct`xTensor`Private`z, 
          BlankNullSequence[]]] :> 0}], "SubValues" -> None, "DefaultValues" -> 
    None, "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {Protected}, "FullName" -> "Global`TTPart"], 
   False]]], "Output",ExpressionUUID->"82fb7bd6-9fbf-4843-9fc9-a7468a52ccbd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$InertHeads"], \
"Input",ExpressionUUID->"cd8865c7-e867-43ac-a5bf-b4556ded26ea"],

Cell[BoxData[
 RowBox[{"{", "TTPart", 
  "}"}]], "Output",ExpressionUUID->"c7564ec6-2fb7-404c-8135-c7bb06080fed"]
}, Open  ]],

Cell["\<\
We have not defined yet ConstantQ, and so the integers are not taken out:\
\>", "Text",ExpressionUUID->"398cbca4-f593-45a7-8064-447f2ca78263"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TTPart", "[", 
  RowBox[{
   RowBox[{"2", "a"}], "-", 
   RowBox[{"3", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"64646040-9bc2-4211-a772-346b499f1bbe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TTPart", "[", 
   RowBox[{"2", " ", "a"}], "]"}], "+", 
  RowBox[{"TTPart", "[", 
   RowBox[{
    RowBox[{"-", "3"}], " ", "b"}], 
   "]"}]}]], "Output",ExpressionUUID->"59c81cbf-1288-4096-adb6-ad3b186ece98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefInertHead", "[", "TTPart", 
  "]"}]], "Input",ExpressionUUID->"9b940ad5-c2b9-4ea5-8cfc-bef79e31c4dc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefInertHead", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"inert head\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TTPart"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefInertHead, ": Undefined ", "inert head", 
   " ", $CellContext`TTPart],
  Editable->
   False]], "Print",ExpressionUUID->"83bf25a3-dc1f-40e8-9b1d-3f973555b7aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TTPart"}]], "Input",ExpressionUUID->"e2861613-d003-4b1c-853e-1a381bcc29d6"],

Cell[BoxData[
 RowBox[{"Missing", "[", 
  RowBox[{"\<\"UnknownSymbol\"\>", ",", "\<\"TTPart\"\>"}], 
  "]"}]], "Output",ExpressionUUID->"de3ea9e6-6a5d-4306-bb75-89907f7baa5d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$InertHeads"], \
"Input",ExpressionUUID->"fa6e9844-4088-4329-a1cd-131604fe2c9a"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"0f23ef2c-f7f0-4d6a-92e1-a15396f5f635"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b"}], 
  "]"}]], "Input",ExpressionUUID->"318681de-ec73-4220-a815-b034fa3dd21c"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"8bb924f3-a2eb-4cab-8ea6-a0c3c27097c6"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.1.2. ERROR", \
"Subsubsection",ExpressionUUID->"a9228881-dbba-4f48-9858-ec00f65981c2"],

Cell["\<\
We define the inert-head ERROR, that will be used in the validation routines. \
Note that we do not use DefInertHead to declare it:\
\>", "Text",ExpressionUUID->"17495933-b278-497a-b242-e8693a6725d9"],

Cell[BoxData[{
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ERROR", ",", "HoldFirst"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InertHeadQ", "[", "ERROR", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LinearQ", "[", "ERROR", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInfo", "[", "ERROR", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<inert head\>\"", ",", 
     "\"\<Generic head to wrap expressions with errors.\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "ERROR", "]"}], "^=", 
   RowBox[{"ColorString", "[", 
    RowBox[{"\"\<ERROR\>\"", ",", 
     RowBox[{"Hue", "[", "0", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AppendToUnevaluated", "[", 
   RowBox[{"$InertHeads", ",", "ERROR"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ERROR", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b8ac0571-14b2-41fe-9b9c-1d5456a100fa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "ERROR"}]], "Input",ExpressionUUID->"8eb82b0a-e7e3-4202-b474-e6c7a4815d24"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ERROR[expr] is an expression where an error has \
been detected. ERROR is an inert head with a single argument.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"InertHeadQ", "[", "ERROR", "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"LinearQ", "[", "ERROR", "]"}], "^=", "False"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", "ERROR", "]"}], "^=", 
                    RowBox[{"{", 
                    
                    RowBox[{"\<\"inert head\"\>", 
                    ",", "\<\"Generic head to wrap expressions with errors.\"\
\>"}], "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", "ERROR", "]"}], 
                    "^=", "\<\"\\!\\(\\*StyleBox[\\\"ERROR\\\",FontColor->Hue[\
0.]]\\)\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", 
                    RowBox[{"HoldFirst", ",", "Protected"}], "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`ERROR\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ERROR[expr] is an expression where an error has \
been detected. ERROR is an inert head with a single argument.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "ERROR[expr] is an expression where an error has been detected. ERROR is \
an inert head with a single argument.", "Documentation" -> None, "OwnValues" -> 
    None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, xAct`xTensor`ERROR, {
      xAct`xTensor`InertHeadQ[xAct`xTensor`ERROR] -> True, 
       xAct`xTensor`LinearQ[xAct`xTensor`ERROR] -> False, 
       xAct`xTensor`DefInfo[xAct`xTensor`ERROR] -> {
        "inert head", "Generic head to wrap expressions with errors."}, 
       xAct`xTensor`PrintAs[xAct`xTensor`ERROR] -> 
       "\!\(\*StyleBox[\"ERROR\",FontColor->Hue[0.]]\)"}], "DownValues" -> 
    None, "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {HoldFirst, Protected}, "FullName" -> 
    "xAct`xTensor`ERROR"], 
   True]]], "Output",ExpressionUUID->"3eee59ea-961f-41d4-9e54-0352d0f46e5c"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.1.3. Keep", \
"Subsubsection",ExpressionUUID->"01ce7417-d077-4ba4-b727-c6b37ad66ed7"],

Cell["\<\
Keep is just a wrapper to keep expressions protected from greedy actions, \
like derivatives that try to apply the Leibnitz rule or products that try to \
distribute over Plus.\
\>", "Text",ExpressionUUID->"d3b70ec8-6f40-49e7-af89-7a66adf0a761"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InerthHeadQ", "[", "Keep", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LinearQ", "[", "Keep", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInfo", "[", "Keep", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<inert head\>\"", ",", 
     "\"\<Generic head to avoid expression expansion.\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AppendToUnevaluated", "[", 
   RowBox[{"$InertHeads", ",", "Keep"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Keep", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5dd5280e-3159-40fd-9035-040911973b44"],

Cell["It has its own formatting, with parentheses:", \
"Text",ExpressionUUID->"285ce8cb-3f23-4a78-9f37-87ab97cdace4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"Keep", "[", 
      RowBox[{"expr_", ",", "z___"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<(\>\"", ",", 
      RowBox[{"MakeBoxes", "[", 
       RowBox[{"expr", ",", "StandardForm"}], "]"}], ",", "\"\<)\>\""}], 
     "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"919da261-7b47-42fa-8615-cfb4115b605e"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.1.4. Formatting", \
"Subsubsection",ExpressionUUID->"49400ccb-3667-4f9b-9440-450e75c70a94"],

Cell["\<\
Held version of InertHeadQ to avoid evaluation leaks during typesetting:\
\>", "Text",ExpressionUUID->"6fa302a5-c2d9-4b04-bbc8-e1a88fa27f73"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldInertHeadQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldInertHeadQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"InertHeadQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f473e1d4-2d55-476d-bff9-fccbfe57d8c6"],

Cell["Currently we forget about other but the first argument.", \
"Text",ExpressionUUID->"1e352831-1afe-4cf5-82c4-cc1c74857203"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "InertHead", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ih_", "?", "HeldInertHeadQ"}], "[", 
        RowBox[{"expr_", ",", "z___"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{
       RowBox[{"ih", "[", 
        RowBox[{"expr", ",", "z"}], "]"}], ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PrintAs", "[", 
           RowBox[{"Unevaluated", "[", "ih", "]"}], "]"}], ",", "\"\<[\>\"", 
          ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"expr", ",", "StandardForm"}], "]"}], ",", "\"\<]\>\""}], 
         "}"}], "]"}]}], "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "InertHead", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ih_", "?", "HeldInertHeadQ"}], "[", 
        RowBox[{"expr_", ",", "z___"}], "]"}], ",", "StandardForm"}], "]"}], 
     "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"xTensorFormStart", "[", "InertHead", "]"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c3837629-017c-4c3f-a644-5ef9a5cd8360"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f9c8e9b9-65af-4a14-aadb-cd3ea02d20af"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ERROR", "[", "hello", 
  "]"}]], "Input",ExpressionUUID->"04836b74-9aac-4edc-b7f8-6d9aae755625"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", "hello", "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[$CellContext`hello],
  Editable->
   False]], "Output",ExpressionUUID->"2bbfbd7e-f270-40f1-b7b1-cd67d690650b"]
}, Open  ]],

Cell["Cut and paste:", \
"Text",ExpressionUUID->"5903bd5e-d992-485d-9fa4-8851b628ceef"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   StyleBox["ERROR",
    FontColor->RGBColor[1, 0, 0]], "[", "hello", "]"}],
  ERROR[hello],
  Editable->
   False]], "Input",ExpressionUUID->"38912494-a0a3-4758-8552-4db8a26e484b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", "hello", "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[$CellContext`hello],
  Editable->
   False]], "Output",ExpressionUUID->"387dd3b1-3c71-4c1a-b70b-2b56fd090ddc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"9c2e6d24-624b-4774-893b-5e018e7bbd96"],

Cell["ERROR[hello]", \
"Output",ExpressionUUID->"bb3aa9e9-82a2-4a47-b7c7-3a24fbb4de56"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"xTensorFormStop", "[", "InertHead", 
  "]"}]], "Input",ExpressionUUID->"03e4f7ca-661f-49a2-bf54-6085db09b3f2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   StyleBox["ERROR",
    FontColor->RGBColor[1, 0, 0]], "[", "hello", "]"}],
  ERROR[hello],
  Editable->
   False]], "Input",ExpressionUUID->"5c6564b5-1c53-48c4-bf73-5dd97d8c11a0"],

Cell[BoxData[
 RowBox[{"ERROR", "[", "hello", 
  "]"}]], "Output",ExpressionUUID->"20ac63f7-6f24-4e06-aee0-5ba3e643c48d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"xTensorFormStart", "[", "InertHead", 
  "]"}]], "Input",ExpressionUUID->"4c427984-fba8-47f0-b6c8-440126ce8a07"],

Cell[CellGroupData[{

Cell[BoxData["%%"], \
"Input",ExpressionUUID->"5acdb230-c9a3-42f6-afca-cee7e84ac3e1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", "hello", "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[$CellContext`hello],
  Editable->
   False]], "Output",ExpressionUUID->"01dc58da-2b1e-45a3-a394-10cf05662d9d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "hello", 
  "]"}]], "Input",ExpressionUUID->"170d5c99-5698-4ab1-bd2a-098a57085715"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"52a22088-8b8c-41fa-8186-47577bdab6dd"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.1.5. Dagger and DaggerQ", \
"Subsubsection",ExpressionUUID->"2fe7ea5c-bf12-49eb-becc-e4534980eb2b"],

Cell["\<\
I don't want to overload the Conjugate command, so I introduce a new \
conjugation command, called Dagger. Formally, it is an (antilinear) \
inert-head:\
\>", "Text",ExpressionUUID->"168a7deb-9ae6-4643-b81e-33c1be9d7b9b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Dagger"}]], "Input",ExpressionUUID->"c9a4b1e9-17ef-455c-a1c8-79478b16e4fe"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Dagger[expr] returns the complex conjugate of an \
expression. Dagger is an inert head. Use DaggerIndex on indices.\\n\\nDagger \
is also an option for several DefType commands, specifying how they behave \
under complex conjugation: possible values are Real, Imaginary, Complex, \
Hermitian and Antihermitian, the latter two only applying to tensors.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`Dagger\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"Dagger[expr] returns the complex conjugate of an \
expression. Dagger is an inert head. Use DaggerIndex on indices.\\n\\nDagger \
is also an option for several DefType commands, specifying how they behave \
under complex conjugation: possible values are Real, Imaginary, Complex, \
Hermitian and Antihermitian, the latter two only applying to tensors.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "Dagger[expr] returns the complex conjugate of an expression. Dagger is \
an inert head. Use DaggerIndex on indices.\n\nDagger is also an option for \
several DefType commands, specifying how they behave under complex \
conjugation: possible values are Real, Imaginary, Complex, Hermitian and \
Antihermitian, the latter two only applying to tensors.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`Dagger"], 
   False]]], "Output",ExpressionUUID->"169fba61-285e-41d6-bd83-8d406bf2b207"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InertHeadQ", "[", "Dagger", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LinearQ", "[", "Dagger", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "Dagger", "]"}], "^=", "\"\<Dagger\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"AppendToUnevaluated", "[", 
   RowBox[{"$InertHeads", ",", "Dagger"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e47ff315-3f4f-48e2-8463-b5fc198bf2cd"],

Cell["\<\
The definition on products means that we do not worry about \
angle-determinations:\
\>", "Text",ExpressionUUID->"95bccbc7-fbc5-4792-b675-87f63602fb44"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Listability", ",", " ", 
    RowBox[{"linearity", " ", "and", " ", "product", " ", "expansion"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "expr_List", "]"}], ":=", 
     RowBox[{"Dagger", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "expr_Equal", "]"}], ":=", 
     RowBox[{"Dagger", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "expr_Plus", "]"}], ":=", 
     RowBox[{"Dagger", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"HoldPattern", "[", 
       RowBox[{"SeriesData", "[", 
        RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], "]"}], 
       "]"}], "]"}], ":=", 
     RowBox[{"SeriesData", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "var", "]"}], ",", 
       RowBox[{"Dagger", "[", "orig", "]"}], ",", 
       RowBox[{"Dagger", "/@", "coeffs"}], ",", "rest"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "expr_Times", "]"}], ":=", 
     RowBox[{"Dagger", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"SeriesData", "[", 
        RowBox[{"par_", ",", "origin_", ",", "coeffs_", ",", "args__"}], 
        "]"}]}], "]"}], ":=", 
     RowBox[{"SeriesData", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "par", "]"}], ",", 
       RowBox[{"Dagger", "[", "origin", "]"}], ",", 
       RowBox[{"Dagger", "[", "coeffs", "]"}], ",", "args"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Constant", "-", 
     RowBox[{
     "symbols", " ", "have", " ", "an", " ", "upvalue", " ", "for", " ", 
      "Dagger"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
     RowBox[{"Conjugate", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"All", " ", "parameters", " ", "assumed", " ", "real"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"param_Symbol", "?", "ParameterQ"}], "]"}], ":=", "param"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Integer", " ", "powers"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"Power", "[", 
       RowBox[{"expr_", ",", "n_Integer"}], "]"}], "]"}], ":=", 
     RowBox[{"Power", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "expr", "]"}], ",", "n"}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c904fac2-5ed1-4b76-b34a-2808e8a24ace"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Involutivity", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Dagger", "[", 
     RowBox[{"Dagger", "[", "expr_", "]"}], "]"}], ":=", "expr"}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"271d2a3e-3891-461e-87b5-b3f618a02245"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Action", " ", "on", " ", "composite", " ", "types"}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"Scalar", "[", 
      RowBox[{"Dagger", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{
       RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{"Dagger", ",", 
        RowBox[{"ParamD", "[", "ps", "]"}]}], "]"}], "[", 
      RowBox[{"Dagger", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"LieD", "[", 
       RowBox[{"Dagger", "[", "v", "]"}], "]"}], "[", 
      RowBox[{"Dagger", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Covariant", " ", 
     RowBox[{"derivatives", ".", " ", "So"}], " ", "far", " ", "we", " ", 
     "do", " ", "not", " ", "touch", " ", "the", " ", "covd", " ", "head"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", 
       "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"DaggerCovD", "[", 
       RowBox[{"covd", "[", "inds", "]"}], "]"}], "[", 
      RowBox[{"Dagger", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerCovD", "[", 
      RowBox[{"covd_", "[", "inds__", "]"}], "]"}], ":=", 
     RowBox[{"Map", "[", 
      RowBox[{"DaggerIndex", ",", 
       RowBox[{"covd", "[", "inds", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"CovD", "[", 
       RowBox[{"expr_", ",", "covdinds__"}], "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"CovD", "[", 
        RowBox[{
         RowBox[{"Dagger", "[", "expr", "]"}], ",", "##"}], "]"}], "&"}], "@@", 
      RowBox[{"Map", "[", 
       RowBox[{"DaggerCovD", ",", 
        RowBox[{"{", "covdinds", "}"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Action", " ", "on", " ", 
      RowBox[{"tensors", ".", " ", "Note"}], " ", "that", " ", "this", " ", 
      "includes", " ", "Basis"}], ",", " ", 
     RowBox[{"Bracket", " ", "and", " ", "TensorDerivative"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "tensor", "]"}], ",", 
       RowBox[{"DaggerIndex", "@", 
        RowBox[{"IndexList", "[", "inds", "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"QUESTION", ":", " ", 
     RowBox[{
     "Is", " ", "there", " ", "any", " ", "\"\<analyticity\>\"", " ", 
      "assumption", " ", 
      RowBox[{"here", "?", " ", "Why"}], " ", "do", " ", "we", " ", "dagger", 
      " ", "sf", " ", 
      RowBox[{"itself", "?"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{
       RowBox[{"sf_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], 
     ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "sf", "]"}], ",", 
       RowBox[{"Dagger", "/@", 
        RowBox[{"{", "args", "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Scalar", " ", "functions", " ", "are", " ", "assumed", " ", "real", " ", 
     "by", " ", "default"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"sf_", "?", "ScalarFunctionQ"}], "]"}], ":=", "sf"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Mappings", " ", "are", " ", "taken", " ", "as", " ", "real", " ", 
     "because", " ", "they", " ", "are", " ", "between", " ", "real", " ", 
     "manifolds"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"phi_", "?", "MappingQ"}], "]"}], ":=", "phi"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d5569e51-90e0-41c1-8d19-cc91e946691d"],

Cell["\<\
We have introduced the private function DaggerCovD to deal with the \
\"Hermitian\" spincovds with two indices.\
\>", "Text",ExpressionUUID->"36744d44-0814-48ef-868d-0e3420181f23"],

Cell["\<\
We always want to get back something meaningful for symbols and indices. For \
indices we separate the command DaggerIndex, which will throw an error in \
case something is wrong. For symbols we add this special case:\
\>", "Text",ExpressionUUID->"bc16aff5-dbb1-43ed-846b-33b17927c46e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Generic", " ", "action", " ", "on", " ", "symbols"}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Dagger", "[", "x_Symbol", "]"}], ":=", 
    RowBox[{"Throw", "@", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"Dagger", "::", "unknown"}], ",", 
       "\"\<conjugate of symbol\>\"", ",", "x"}], "]"}]}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"524541e2-94dd-4fa1-b5f7-0f78fb8fcca3"],

Cell["\<\
There is no general definition for Dagger (except for symbols). Therefore \
Dagger may stay unevaluated during the evaluation process, being always \
treated as any other inert-head.\
\>", "Text",ExpressionUUID->"63295163-9a60-4b4e-b274-e40841cc0434"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Dagger", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Dagger", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b1ae3774-952c-4699-bfc1-d60b185dffbe"],

Cell["\<\
The function DaggerQ says whether an expression is complex or not:\
\>", "Text",ExpressionUUID->"33218092-e778-468c-a05b-27727b32f5a9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DaggerQ"}]], \
"Input",ExpressionUUID->"9e023405-7cda-4925-bfd9-b75115cfa623"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DaggerQ[expr] gives True if expr is complex \
(Dagger[expr] different from expr) and False otherwise.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`DaggerQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DaggerQ[expr] gives True if expr is complex \
(Dagger[expr] different from expr) and False otherwise.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "DaggerQ[expr] gives True if expr is complex (Dagger[expr] different from \
expr) and False otherwise.", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`DaggerQ"], 
   False]]], "Output",ExpressionUUID->"452bfa07-2d04-44c2-801e-7e8c158c3833"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DaggerQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"UnsameQ", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Dagger", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DaggerQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DaggerQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e83f6e55-1957-4ec5-80cd-22fcc53bbae1"],

Cell["\<\
Private function to arrange the dagger pairs. It is almost symmetric. The \
only difference is that the function returns symbol2.\
\>", "Text",ExpressionUUID->"17a3627f-1ffa-492e-ad02-b0f5d61e0acc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetDaggerPair", "[", 
    RowBox[{"symbol1_Symbol", ",", "symbol2_Symbol"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xUpSet", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "symbol2", "]"}], ",", "symbol1"}], "]"}], ";", 
     
     RowBox[{"xUpSet", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "symbol1", "]"}], ",", "symbol2"}], "]"}]}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetDaggerPair", "[", 
    RowBox[{"x_", ",", "_Symbol"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Validate", "::", "nouse"}], ",", "\"\<SetDaggerPair\>\"", ",", 
      "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetDaggerPair", "[", 
    RowBox[{"_Symbol", ",", "x_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Validate", "::", "nouse"}], ",", "\"\<SetDaggerPair\>\"", ",", 
      "x"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d1d06776-79f6-4136-a333-9d5d8e5aedfb"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2. ScalarFunctions", \
"Subsection",ExpressionUUID->"9659dacf-a9e9-4606-b0d3-892b62062edf"],

Cell[CellGroupData[{

Cell["3.2.0. Comments", \
"Subsubsection",ExpressionUUID->"1fc22752-e408-46b0-b6c2-9ed226195072"],

Cell[TextData[{
 "A scalar-function is a general mapping from ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "n"], TraditionalForm]],
  ExpressionUUID->"f781f8fb-7c6a-41a4-9f9c-075580361d46"],
 " to \[DoubleStruckCapitalR], or perhaps from ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalC]", "n"], TraditionalForm]],
  ExpressionUUID->"e6e6b11d-ea3d-4359-91c0-2a85215f597f"],
 " to \[DoubleStruckCapitalC]. There is no concept yet of function from ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "n"], TraditionalForm]],
  ExpressionUUID->"f861469e-383e-40ec-80c4-fce723e2f3e1"],
 " to ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "m"], TraditionalForm]],
  ExpressionUUID->"8f5c8b0e-41a0-4250-b460-0f9fdd7b60dc"],
 ", and that's something which could be really useful. QUESTION: How can we \
do that? The obvious answer is using a list of scalar-functions, but it is \
not clear that we can assume that every list of objects can be treated as a \
mapping."
}], "Text",ExpressionUUID->"04e81858-8f95-4035-8689-1ee496908ff5"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2.1. Definition", \
"Subsubsection",ExpressionUUID->"47c54ed3-332b-4c68-ac1d-4ec3a755c3b7"],

Cell["\<\
We do not allow mathematical functions with arguments which are not scalars. \
Only functions on scalars can be unambiguosly differentiated, for example. \
There is no need to declare how many arguments a scalar-function has.\
\>", "Text",ExpressionUUID->"8e3bfdc7-8b87-4555-b2b9-1ebacaf36496"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DefScalarFunction"}]], \
"Input",ExpressionUUID->"29c86d51-d494-4701-af1a-737120496312"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DefScalarFunction[f] defines f to be a scalar \
function of one or several scalar arguments.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`DefScalarFunction\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DefScalarFunction[f] defines f to be a scalar \
function of one or several scalar arguments.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "DefScalarFunction[f] defines f to be a scalar function of one or several \
scalar arguments.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    None, "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`DefScalarFunction"], 
   False]]], "Output",ExpressionUUID->"37563f09-44a1-4236-b55e-6389ee215ec1"]
}, Open  ]],

Cell["\<\
We do not associate dependencies to the scalar-function. QUESTION: Why have \
we introduced the Validate option?

QUESTION: The whole issue of daggering a scalar-function is confusing. Why is \
it not enough to dagger its arguments? Why do we allow imaginary scalar \
functions for instance?\
\>", "Text",ExpressionUUID->"08418cb2-7230-4544-a949-fc737b9ebbe0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefScalarFunction", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Dagger", "\[Rule]", "Real"}], ",", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<scalar function\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"Validate", "\[Rule]", "True"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefScalarFunction", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefScalarFunction", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefScalarFunction", "[", 
    RowBox[{"sf_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "dag", ",", "master", ",", "pa", ",", "pns", ",", "info", ",", "val"}],
        "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "dag", ",", "master", ",", "pa", ",", "pns", ",", "info", ",", 
          "val"}], "}"}], "=", 
        RowBox[{"OptionValue", "[", 
         RowBox[{"{", 
          RowBox[{
          "Dagger", ",", "Master", ",", "PrintAs", ",", "ProtectNewSymbol", 
           ",", "DefInfo", ",", "Validate"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"val", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ValidateSymbol", "[", "sf", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"ValidateSymbolInSession", "[", "sf", "]"}]}]}], "]"}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"MakeDefInfo", "[", 
        RowBox[{"DefScalarFunction", ",", "sf", ",", "info"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{
        "DefScalarFunction", ",", "\"\<Beginning\>\"", ",", "sf", ",", 
         "options"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", 
        RowBox[{"dag", ",", "\[IndentingNewLine]", "Complex", ",", 
         RowBox[{
          RowBox[{"SetDaggerPair", "[", 
           RowBox[{"sf", ",", 
            RowBox[{"MakeDaggerSymbol", "[", "sf", "]"}]}], "]"}], ";", 
          RowBox[{"DefScalarFunction", "[", 
           RowBox[{
            RowBox[{"Dagger", "[", "sf", "]"}], ",", 
            RowBox[{"Dagger", "\[Rule]", "Conjugate"}], ",", 
            RowBox[{"Master", "\[Rule]", "sf"}], ",", "options"}], "]"}]}], 
         ",", "\[IndentingNewLine]", "Conjugate", ",", "Null", ",", 
         "\[IndentingNewLine]", "Imaginary", ",", 
         RowBox[{
          RowBox[{"Dagger", "[", "sf", "]"}], "^=", 
          RowBox[{"MultiplyHead", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "sf"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "Real", ",", 
         RowBox[{
          RowBox[{"Dagger", "[", "sf", "]"}], "^=", "sf"}], ",", 
         "\[IndentingNewLine]", "_", ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefScalarFunction", "::", "unknown"}], ",", 
            "\"\<Dagger value\>\"", ",", "dag"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"AppendToUnevaluated", "[", 
        RowBox[{"$ScalarFunctions", ",", "sf"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ScalarFunctionQ", "[", "sf", "]"}], "^=", "True"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefInfo", "[", "sf", "]"}], "^=", "info"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetPrintAs", "[", 
        RowBox[{"sf", ",", 
         RowBox[{"AddDaggerCharacter", "[", 
          RowBox[{
           RowBox[{"PrintAsString", "[", 
            RowBox[{"sf", ",", "pa"}], "]"}], ",", "dag"}], "]"}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"SymbolRelations", "[", 
        RowBox[{"sf", ",", "master", ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{
        "DefScalarFunction", ",", "\"\<End\>\"", ",", "sf", ",", "options"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"pns", ",", 
         RowBox[{"Protect", "[", "sf", "]"}]}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefScalarFunction", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "DefScalarFunction", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ba1132da-80a2-4344-b80a-37954b49ab7f"],

Cell["\<\
All functions with attribute NumericFunction are scalar-functions by default, \
except for Times and Plus, which are always treated through special linear \
rules, because they admit tensors with free indices :\
\>", "Text",ExpressionUUID->"a12729b1-9ae1-4fc2-a56d-eebe677ee723"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "ScalarFunctionQ", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ScalarFunctionQ", "[", 
    RowBox[{"Times", "|", "Plus"}], "]"}], "=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ScalarFunctionQ", "[", 
    RowBox[{
     RowBox[{"Derivative", "[", "__Integer", "]"}], "[", "f_", "]"}], "]"}], ":=", 
   RowBox[{"ScalarFunctionQ", "[", "f", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ScalarFunctionQ", "[", "head_Symbol", "]"}], ":=", 
   RowBox[{"MemberQ", "[", 
    RowBox[{
     RowBox[{"Attributes", "[", "head", "]"}], ",", "NumericFunction"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ScalarFunctionQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ScalarFunctionQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"442ad7b3-ceb9-4c6d-9263-d5b300fc4bf8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefScalarFunction"}]], \
"Input",ExpressionUUID->"c7971986-cbaa-47cd-b437-154a403e3137"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"UndefScalarFunction[f] undefines the scalar \
function f.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], \
"\<\"xAct`xTensor`UndefScalarFunction\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"UndefScalarFunction[f] undefines the scalar \
function f.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "UndefScalarFunction[f] undefines the scalar function f.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "xAct`xTensor`UndefScalarFunction"], 
   False]]], "Output",ExpressionUUID->"3550b3b8-03c6-49ba-b397-b24854423151"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefScalarFunction", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "ScalarFunctionQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefScalarFunction", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefScalarFunction", "[", "sf_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"servants", "=", 
        RowBox[{"ServantsOf", "[", "sf", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"ScalarFunctionQ", "[", "sf", "]"}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefScalarFunction", "::", "unknown"}], ",", 
            "\"\<scalar function\>\"", ",", "sf"}], "]"}], "]"}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "sf", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefScalarFunction", ",", "\"\<Beginning\>\"", ",", "sf"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "sf", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "sf", "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$ScalarFunctions", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$ScalarFunctions", ",", "sf"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefScalarFunction", ",", "\"\<End\>\"", ",", "sf"}], "]"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"MakeUndefInfo", "[", 
        RowBox[{"UndefScalarFunction", ",", "sf"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"RemoveSymbol", "[", "sf", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefScalarFunction", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefScalarFunction", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"86dec043-83f8-4703-a69b-fc10ec92334c"],

Cell["\<\
It is not necessary to give head Scalar to the argument of a scalar function, \
but it does not hurt either.\
\>", "Text",ExpressionUUID->"f1912b1d-a143-491a-be16-b2855063a7d1"],

Cell["\<\
We need an additional definition to detect derivatives of scalar functions:\
\>", "Text",ExpressionUUID->"225a6fe7-b7cc-416a-bbb2-3da4d449e3b8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ScalarFunctionQ"}]], \
"Input",ExpressionUUID->"70ea2272-e78d-4cd2-8728-385975d922ff"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ScalarFunctionQ[f] gives True if f has been defined \
as a mathematical function acting on scalars, or a derivative of one of \
those, and False otherwise.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Definitions\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Definitions", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", "]"}], ":=", 
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"ScalarFunctionQ", "::", "argx"}], "MessageName"],
                     ",", "ScalarFunctionQ", ",", "0"}], "]"}]}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", 
                    RowBox[{"Times", "|", "Plus"}], "]"}], "=", "False"}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", 
                    SuperscriptBox["f_", 
                    TagBox[
                    RowBox[{"(", "__Integer", ")"}],
                    Derivative],
                    MultilineFunction->None], "]"}], ":=", 
                    RowBox[{"ScalarFunctionQ", "[", "f", "]"}]}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", "head_Symbol", "]"}], ":=", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"Attributes", "[", "head", "]"}], ",", 
                    "NumericFunction"}], "]"}]}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", "_", "]"}], ":=", 
                    "False"}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", 
                    RowBox[{"_", ",", "xAct`xCore`Private`x$__"}], "]"}], ":=", 
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"ScalarFunctionQ", "::", "argx"}], "MessageName"],
                     ",", "ScalarFunctionQ", ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"Length", "[", 
                    RowBox[{"{", "xAct`xCore`Private`x$", "}"}], "]"}]}]}], 
                    "]"}]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`ScalarFunctionQ\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"ScalarFunctionQ[f] gives True if f has been defined \
as a mathematical function acting on scalars, or a derivative of one of \
those, and False otherwise.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "ScalarFunctionQ[f] gives True if f has been defined as a mathematical \
function acting on scalars, or a derivative of one of those, and False \
otherwise.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None,
     "DownValues" -> 
    Information`InformationValueForm[
     DownValues, xAct`xTensor`ScalarFunctionQ, {
      xAct`xTensor`ScalarFunctionQ[] :> Message[
         MessageName[xAct`xTensor`ScalarFunctionQ, "argx"], 
         xAct`xTensor`ScalarFunctionQ, 0], xAct`xTensor`ScalarFunctionQ[
         Alternatives[Times, Plus]] -> False, xAct`xTensor`ScalarFunctionQ[
         Derivative[
          BlankSequence[Integer]][
          Pattern[xAct`xTensor`Private`f, 
           Blank[]]]] :> xAct`xTensor`ScalarFunctionQ[xAct`xTensor`Private`f],
        xAct`xTensor`ScalarFunctionQ[
         Pattern[xAct`xTensor`Private`head, 
          Blank[Symbol]]] :> MemberQ[
         Attributes[xAct`xTensor`Private`head], NumericFunction], 
       xAct`xTensor`ScalarFunctionQ[
         Blank[]] :> False, xAct`xTensor`ScalarFunctionQ[
         Blank[], 
         Pattern[xAct`xCore`Private`x$, 
          BlankSequence[]]] :> Message[
         MessageName[xAct`xTensor`ScalarFunctionQ, "argx"], 
         xAct`xTensor`ScalarFunctionQ, 1 + Length[{xAct`xCore`Private`x$}]]}],
     "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "xAct`xTensor`ScalarFunctionQ"], 
   False]]], "Output",ExpressionUUID->"36deaf9e-aeec-4a88-bc2f-c593fe546513"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2.2. Formatting", \
"Subsubsection",ExpressionUUID->"f09d09d9-44bc-408b-b9b5-0d9192388416"],

Cell["\<\
Held version of ScalarFunctionQ to avoid evaluation leaks during typesetting:\
\
\>", "Text",ExpressionUUID->"4ba04a0a-a7c9-4179-9a78-b23e35e5d5fc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldScalarFunctionQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldScalarFunctionQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"ScalarFunctionQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"794b77d6-c93a-4987-86f9-29340b8f9b5a"],

Cell["\<\
StandardForm. We only format the symbol itself, and not its arguments. \
QUESTION: Why do we need RowBox with one argument?\
\>", "Text",ExpressionUUID->"6636295e-3474-4418-a81f-ddcd8ed45da1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "ScalarFunction", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"sf_Symbol", "?", "HeldScalarFunctionQ"}], ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{"sf", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"PrintAs", "[", 
          RowBox[{"Unevaluated", "[", "sf", "]"}], "]"}], "}"}], "]"}]}], 
      "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "ScalarFunction", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"sf_Symbol", "?", "HeldScalarFunctionQ"}], ",", 
       "StandardForm"}], "]"}], "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "ScalarFunction", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"262485ad-3e6f-4465-9887-623514ce1d71"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2.3. Examples", \
"Subsubsection",ExpressionUUID->"0a4065bb-1b72-4437-bcdd-3d67d5efdcca"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9f86c02f-3f11-4fee-936b-3ce127503b20"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", "ff", 
  "]"}]], "Input",ExpressionUUID->"2d6ddaf7-08bd-4d5f-86e7-ba5733b991c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefScalarFunction", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"scalar function \"\>", "\[InvisibleSpace]", "ff",
    "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefScalarFunction, ": Defining ", 
   "scalar function ", $CellContext`ff, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ac193341-6d41-4e6b-b6e1-2ec05e5e7393"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ff"}]], "Input",ExpressionUUID->"7ca0afea-b46a-4a37-9504-368e2f883b91"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`ff\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Dagger", "[", 
                    InterpretationBox[
                    StyleBox["ff",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    xAct`xTensor`Dagger[$CellContext`ff],
                    Editable->False], "^=", 
                    InterpretationBox[
                    StyleBox["ff",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False]}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", 
                    InterpretationBox[
                    StyleBox["ff",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["ff",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"scalar function\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["ff",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}], "^=", "\<\"ff\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`ff\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`ff\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`ff", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`ff, {
      xAct`xTensor`Dagger[$CellContext`ff] -> $CellContext`ff, 
       xAct`xTensor`ScalarFunctionQ[$CellContext`ff] -> True, 
       xAct`xTensor`DefInfo[$CellContext`ff] -> {"scalar function", ""}, 
       xAct`xTensor`PrintAs[$CellContext`ff] -> "ff"}], "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "Global`ff"], 
   False]]], "Output",ExpressionUUID->"12978b76-cda2-42d3-b59e-23726eac9c3b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarFunctionQ", "[", "ff", 
  "]"}]], "Input",ExpressionUUID->"012f3544-5991-4e66-b7ef-c3788871db02"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"cfc074df-4bac-4446-823f-71afe4226750"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarFunctionQ", "[", 
  RowBox[{"ff", "'"}], 
  "]"}]], "Input",ExpressionUUID->"070d7ab3-b26e-4c37-8afb-7f939b34f898"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"b70fc4d9-41fa-47cc-a8a4-98aa49e71c1b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", "ff", 
  "]"}]], "Input",ExpressionUUID->"6d770341-62bb-4897-9d87-3f375ed17cbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefScalarFunction", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"scalar function\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["ff",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ff,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefScalarFunction, ": Undefined ", "scalar function", 
   " ", $CellContext`ff],
  Editable->
   False]], "Print",ExpressionUUID->"5f614ebc-82b3-4fe7-b107-7c4c08784e3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ff"}]], "Input",ExpressionUUID->"c4751934-85e9-433b-b824-df4081d96882"],

Cell[BoxData[
 RowBox[{"Missing", "[", 
  RowBox[{"\<\"UnknownSymbol\"\>", ",", "\<\"ff\"\>"}], 
  "]"}]], "Output",ExpressionUUID->"520c3d30-1b11-4a73-b9a7-0dfbf668981e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", 
  RowBox[{"ff", ",", 
   RowBox[{"PrintAs", "->", "\"\<F\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"5b47b7f1-8a4b-4c42-b912-b1a04d152acd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefScalarFunction", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"scalar function \"\>", "\[InvisibleSpace]", "ff",
    "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefScalarFunction, ": Defining ", 
   "scalar function ", $CellContext`ff, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"41f9f05e-dcff-4d98-b3a0-efe541280e54"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ff"}]], "Input",ExpressionUUID->"4abb90ea-65e1-4cc2-b9c7-51d881a450b6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`ff\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Dagger", "[", 
                    InterpretationBox[
                    StyleBox["F",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    xAct`xTensor`Dagger[$CellContext`ff],
                    Editable->False], "^=", 
                    InterpretationBox[
                    StyleBox["F",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False]}]},
                    {
                    RowBox[{
                    RowBox[{"ScalarFunctionQ", "[", 
                    InterpretationBox[
                    StyleBox["F",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["F",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"scalar function\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["F",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`ff,
                    Editable->False], "]"}], "^=", "\<\"F\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`ff\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`ff\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`ff", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`ff, {
      xAct`xTensor`Dagger[$CellContext`ff] -> $CellContext`ff, 
       xAct`xTensor`ScalarFunctionQ[$CellContext`ff] -> True, 
       xAct`xTensor`DefInfo[$CellContext`ff] -> {"scalar function", ""}, 
       xAct`xTensor`PrintAs[$CellContext`ff] -> "F"}], "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "Global`ff"], 
   False]]], "Output",ExpressionUUID->"6220eb20-c01d-406e-bd38-df9f911af31e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarFunctionQ", "[", 
  RowBox[{
   RowBox[{"Derivative", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", "ff", "]"}], 
  "]"}]], "Input",ExpressionUUID->"69714550-2a05-4ed3-aa13-4708e72f4506"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"f86e443b-f815-46a3-a4ac-a16b897a0adf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ff", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "]"}]], "Input",ExpressionUUID->"99f7e311-3c44-4661-bf67-1d6057c23f15"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox["F",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ff,
   Editable->False], "[", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "]"}]], "Output",ExpressionUUID->"5ed44dc0-201b-47ba-aa75-1209caf8ce49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", "ff", 
  "]"}]], "Input",ExpressionUUID->"49d08908-f0f5-4c87-b56d-c30eab288232"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefScalarFunction", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"scalar function\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["F",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ff,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefScalarFunction, ": Undefined ", "scalar function", 
   " ", $CellContext`ff],
  Editable->
   False]], "Print",ExpressionUUID->"261858b5-a39d-4f0b-9ae1-912bcb22f180"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "]"}]], "Input",ExpressionUUID->"822d41b7-5ffc-4c1c-bb46-c3ea95d11b7d"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"475dd363-4946-4736-ba3a-9f6f67def5aa"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3. ConstantSymbols", \
"Subsection",ExpressionUUID->"0babaa63-2df8-49b2-b7de-5549f12344b4"],

Cell[CellGroupData[{

Cell["3.3.1. Definition", \
"Subsubsection",ExpressionUUID->"b178c7af-ae76-438f-a5e1-dc8c134dd2d4"],

Cell[TextData[{
 "The attribute Constant pinpoints constant symbols with respect to \
Derivative. We need something similar for the ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " derivatives. We introduce the type ConstantSymbol. Note that constants are \
real by default, but can also be complex or imaginary."
}], "Text",ExpressionUUID->"c597e5cb-c295-4f5a-9e02-05f0a98627a7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefConstantSymbol", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Dagger", "\[Rule]", "Real"}], ",", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<constant symbol\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     RowBox[{"Validate", "\[Rule]", "True"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DefConstantSymbol", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefConstantSymbol", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefConstantSymbol", "[", 
   RowBox[{"symbol_", ",", 
    RowBox[{"options", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Catch", "@", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "dag", ",", "master", ",", "pa", ",", "pns", ",", "info", ",", "val"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "dag", ",", "master", ",", "pa", ",", "pns", ",", "info", ",", 
         "val"}], "}"}], "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"{", 
         RowBox[{
         "Dagger", ",", "Master", ",", "PrintAs", ",", "ProtectNewSymbol", 
          ",", "DefInfo", ",", "Validate"}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"val", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ValidateSymbol", "[", "symbol", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ValidateSymbolInSession", "[", "symbol", "]"}]}]}], "]"}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"MakeDefInfo", "[", 
       RowBox[{"DefConstantSymbol", ",", "symbol", ",", "info"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"MakexTensions", "[", 
       RowBox[{
       "DefConstantSymbol", ",", "\"\<Beginning\>\"", ",", "symbol", ",", 
        "options"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", 
       RowBox[{"dag", ",", "\[IndentingNewLine]", "Complex", ",", 
        RowBox[{
         RowBox[{"SetDaggerPair", "[", 
          RowBox[{"symbol", ",", 
           RowBox[{"MakeDaggerSymbol", "[", "symbol", "]"}]}], "]"}], ";", 
         RowBox[{"DefConstantSymbol", "[", 
          RowBox[{
           RowBox[{"Dagger", "[", "symbol", "]"}], ",", 
           RowBox[{"Dagger", "\[Rule]", "Conjugate"}], ",", 
           RowBox[{"Master", "\[Rule]", "symbol"}], ",", "options"}], "]"}]}],
         ",", "\[IndentingNewLine]", "Conjugate", ",", "Null", ",", 
        "\[IndentingNewLine]", "Imaginary", ",", 
        RowBox[{
         RowBox[{"Dagger", "[", "symbol", "]"}], "^=", 
         RowBox[{"-", "symbol"}]}], ",", "\[IndentingNewLine]", "Real", ",", 
        RowBox[{
         RowBox[{"Dagger", "[", "symbol", "]"}], "^=", "symbol"}], ",", 
        "\[IndentingNewLine]", "_", ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefConstantSymbol", "::", "unknown"}], ",", 
           "\"\<Dagger value\>\"", ",", "dag"}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"AppendToUnevaluated", "[", 
       RowBox[{"$ConstantSymbols", ",", "symbol"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ConstantSymbolQ", "[", "symbol", "]"}], "^=", "True"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SetAttributes", "[", 
       RowBox[{"symbol", ",", "Constant"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DefInfo", "[", "symbol", "]"}], "^=", "info"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SetPrintAs", "[", 
       RowBox[{"symbol", ",", 
        RowBox[{"AddDaggerCharacter", "[", 
         RowBox[{
          RowBox[{"PrintAsString", "[", 
           RowBox[{"symbol", ",", "pa"}], "]"}], ",", "dag"}], "]"}]}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"SymbolRelations", "[", 
       RowBox[{"symbol", ",", "master", ",", 
        RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"MakexTensions", "[", 
       RowBox[{
       "DefConstantSymbol", ",", "\"\<End\>\"", ",", "symbol", ",", 
        "options"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"pns", ",", 
        RowBox[{"Protect", "[", "symbol", "]"}]}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefConstantSymbol", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "DefConstantSymbol", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b53c0ad9-bbcd-4f77-8287-7118dfef64ae"],

Cell["Undefinition:", \
"Text",ExpressionUUID->"43444c77-8aac-4e36-8b67-e3df73500801"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefConstantSymbol", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "ConstantSymbolQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefConstantSymbol", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UndefConstantSymbol", "[", "symbol_", "]"}], ":=", 
  RowBox[{"Catch", "@", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"servants", "=", 
       RowBox[{"ServantsOf", "[", "symbol", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"ConstantSymbolQ", "[", "symbol", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"UndefConstantSymbol", "::", "unknown"}], ",", 
           "\"\<constant-symbol\>\"", ",", "symbol"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CheckRemoveSymbol", "[", "symbol", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"MakexTensions", "[", 
       RowBox[{
       "UndefConstantSymbol", ",", "\"\<Beginning\>\"", ",", "symbol"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"ServantsOf", "[", "symbol", "]"}], ",", 
        RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"DropFromHosts", "[", "symbol", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Undef", "/@", 
       RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"$ConstantSymbols", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"$ConstantSymbols", ",", "symbol"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"MakexTensions", "[", 
       RowBox[{"UndefConstantSymbol", ",", "\"\<End\>\"", ",", "symbol"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"MakeUndefInfo", "[", 
       RowBox[{"UndefConstantSymbol", ",", "symbol"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RemoveSymbol", "[", "symbol", "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefConstantSymbol", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefConstantSymbol", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7898d48d-1fe8-4b95-89ae-c65ca6beeebb"],

Cell["Symbols with Constant attribute are constant-symbols.", \
"Text",ExpressionUUID->"6fac6c08-99b5-4efa-b759-79350849afba"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "ConstantSymbolQ", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConstantSymbolQ", "[", "x_Symbol", "]"}], ":=", 
   RowBox[{"MemberQ", "[", 
    RowBox[{
     RowBox[{"Attributes", "[", "x", "]"}], ",", "Constant"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ConstantSymbolQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4bc9e45f-095d-4765-99d2-1e3a2ae6fdc3"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3.2. Formatting", \
"Subsubsection",ExpressionUUID->"f939773c-0561-494b-aab9-e1defa1a8521"],

Cell["\<\
Held version of ConstantSymbolQ to avoid evaluation leaks during typesetting:\
\
\>", "Text",ExpressionUUID->"79ae6543-a304-4149-8097-601ce636ca99"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldConstantSymbolQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldConstantSymbolQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"ConstantSymbolQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4ee0039d-5fef-4b3c-b2b1-8553ac1f0098"],

Cell["StandardForm:", \
"Text",ExpressionUUID->"2785c93f-7528-4cf0-bd1e-9a9f33ba3ceb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "ConstantSymbol", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"x_Symbol", "?", "HeldConstantSymbolQ"}], ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{"x", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"PrintAs", "[", 
          RowBox[{"Unevaluated", "[", "x", "]"}], "]"}], "}"}], "]"}]}], 
      "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "ConstantSymbol", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"x_Symbol", "?", "HeldConstantSymbolQ"}], ",", 
       "StandardForm"}], "]"}], "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "ConstantSymbol", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dde06a4e-0789-4bd7-b1c9-b2cdf0024638"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3.3. Examples", \
"Subsubsection",ExpressionUUID->"ef94e43a-e71f-4a4a-ae67-12294e062883"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"be37dee9-370c-4391-9be0-8a5d4a777883"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Mass", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<M\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"0dc70302-ccbe-47eb-a3f3-d479a9326887"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Mass", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Mass, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"628dde6e-63b7-41e1-a6f7-24cc15f55ae3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mass"}]], "Input",ExpressionUUID->"12279bd4-1730-42bf-9a62-c0aaf3db8c72"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Mass\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Dagger", "[", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], "]"}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    xAct`xTensor`Dagger[$CellContext`Mass],
                    Editable->False], "^=", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}]},
                    {
                    RowBox[{
                    RowBox[{"ConstantSymbolQ", "[", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"constant symbol\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], "]"}], "^=", "\<\"M\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "Protected"}], "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`Mass\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Mass\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`Mass", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`Mass, {
      xAct`xTensor`Dagger[$CellContext`Mass] -> $CellContext`Mass, 
       xAct`xTensor`ConstantSymbolQ[$CellContext`Mass] -> True, 
       xAct`xTensor`DefInfo[$CellContext`Mass] -> {"constant symbol", ""}, 
       xAct`xTensor`PrintAs[$CellContext`Mass] -> "M"}], "DownValues" -> None,
     "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {Constant, Protected}, "FullName" -> "Global`Mass"], 
   False]]], "Output",ExpressionUUID->"c542815c-6aa8-4ba2-9b1e-7764d19af82b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Mass"], \
"Input",ExpressionUUID->"aec18f53-5271-46c0-ac1b-b02307f46c3a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["M",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Mass,
  Editable->
   False]], "Output",ExpressionUUID->"8987a779-f51b-44d2-a14a-792a9869ed67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToBoxes", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"f1534a12-339b-4de4-908c-7d62753d36de"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"RowBox", "[", 
      RowBox[{"{", "\<\"M\"\>", "}"}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox["M",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"24c7db3a-0918-4ef5-85ee-a5da3af086ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%%", 
  "]"}]], "Input",ExpressionUUID->"3aeebf91-dbb7-40f0-ad8a-27ae96be9ae7"],

Cell["Mass", "Output",ExpressionUUID->"5b8c74d4-a69d-404b-831a-04b97cf655eb"]
}, Open  ]],

Cell["Cut and paste:", \
"Text",ExpressionUUID->"334e0433-ab94-4a5b-b38d-b3bd4a4bb230"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox["M",
  Mass,
  Editable->
   False]], "Input",ExpressionUUID->"e78aab84-bac1-4480-b9a2-7c5a160df236"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["M",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Mass,
  Editable->
   False]], "Output",ExpressionUUID->"a8b862af-7d0e-4311-b55c-705141a1bced"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"0bcf77ad-95d2-4479-b527-3312ea2e3710"],

Cell["Mass", "Output",ExpressionUUID->"62065368-8eea-4b81-8d81-8eb02bd50e3b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"xTensorFormStop", "[", "ConstantSymbol", 
  "]"}]], "Input",ExpressionUUID->"77a7c984-e572-447c-8f50-7d81fca2d560"],

Cell[CellGroupData[{

Cell[BoxData["Mass"], \
"Input",ExpressionUUID->"1d874518-2a02-4e68-92e8-27ea6c1cb6db"],

Cell[BoxData["Mass"], \
"Output",ExpressionUUID->"cdd79cf0-82cb-44ee-b31d-3b68e4b6e624"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"xTensorFormStart", "[", "ConstantSymbol", 
  "]"}]], "Input",ExpressionUUID->"505ddcc9-e86d-4fa3-bee7-5f2a777f2a4c"],

Cell[CellGroupData[{

Cell[BoxData["Mass"], \
"Input",ExpressionUUID->"6d2277cd-30ea-4b95-837a-0c84f5afb7a4"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["M",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Mass,
  Editable->
   False]], "Output",ExpressionUUID->"95559173-a7a4-4f43-b0e3-7dc424645720"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"d6e22b48-d789-4375-bdae-705ba2559ee3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["M",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Mass],
  Editable->
   False]], "Print",ExpressionUUID->"b7a1780e-281a-4582-82af-f7acae97c6dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "Mass"}]], "Input",ExpressionUUID->"77165dd6-ad03-4be3-9230-c0254381b9fc"],

Cell[BoxData[
 RowBox[{"Missing", "[", 
  RowBox[{"\<\"UnknownSymbol\"\>", ",", "\<\"Mass\"\>"}], 
  "]"}]], "Output",ExpressionUUID->"cccd54c3-46f9-4eec-a07a-5bc053b1e36c"]
}, Open  ]],

Cell["A complex constant:", \
"Text",ExpressionUUID->"86f25f84-a5ed-4904-b388-6b725e439bdd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Omega", ",", 
   RowBox[{"Dagger", "\[Rule]", "Complex"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<\[CapitalOmega]\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"0dec9cd2-b95e-44fd-aecf-f141642839d1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Omega", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Omega, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"49b04f09-f051-457d-8a94-fdd00c519823"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Omega\[Dagger]", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Omega\[Dagger], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4bc18649-2f8a-4f36-8307-55c8304261ad"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Note that Omega and Omega\[Dagger] are related through a master-servant \
relation:\
\>", "Text",ExpressionUUID->"66064426-2673-4fef-8cb1-5bfc83b93ff7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Omega"}]], "Input",ExpressionUUID->"c6f6b126-53b0-465e-a99f-def50e2abff4"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Omega\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Dagger", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    xAct`xTensor`Dagger[$CellContext`Omega],
                    Editable->False], "^=", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False]}]},
                    {
                    RowBox[{
                    RowBox[{"ServantsOf", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False], "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"ConstantSymbolQ", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"constant symbol\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", "\<\"\[CapitalOmega]\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "Protected"}], "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`Omega\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Omega\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`Omega", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`Omega, {
      xAct`xTensor`Dagger[$CellContext`Omega] -> $CellContext`Omega\[Dagger], 
       xAct`xTensor`ServantsOf[$CellContext`Omega] -> {$CellContext`Omega\
\[Dagger]}, xAct`xTensor`ConstantSymbolQ[$CellContext`Omega] -> True, 
       xAct`xTensor`DefInfo[$CellContext`Omega] -> {"constant symbol", ""}, 
       xAct`xTensor`PrintAs[$CellContext`Omega] -> "\[CapitalOmega]"}], 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {Constant, Protected}, "FullName" -> "Global`Omega"], 
   False]]], "Output",ExpressionUUID->"7bb50dbc-7402-4e44-b2d4-af4d982709a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Omega\[Dagger]"}]], \
"Input",ExpressionUUID->"4f80fa97-6eeb-4c21-9d1f-00ef08714f3f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Omega\[Dagger]\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Dagger", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False], "]"}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    xAct`xTensor`Dagger[$CellContext`Omega\[Dagger]],
                    Editable->False], "^=", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False]}]},
                    {
                    RowBox[{
                    RowBox[{"ConstantSymbolQ", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"constant symbol\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False], "]"}], 
                    "^=", "\<\"\[CapitalOmega]\[Dagger]\"\>"}]},
                    {
                    RowBox[{
                    RowBox[{"MasterOf", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]\[Dagger]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega\[Dagger],
                    Editable->False], "]"}], "^=", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "Protected"}], "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`Omega\[Dagger]\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Omega\[Dagger]\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`Omega\[Dagger]", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`Omega\[Dagger], {
      xAct`xTensor`Dagger[$CellContext`Omega\[Dagger]] -> $CellContext`Omega, 
       xAct`xTensor`ConstantSymbolQ[$CellContext`Omega\[Dagger]] -> True, 
       xAct`xTensor`DefInfo[$CellContext`Omega\[Dagger]] -> {
        "constant symbol", ""}, 
       xAct`xTensor`PrintAs[$CellContext`Omega\[Dagger]] -> 
       "\[CapitalOmega]\[Dagger]", 
       xAct`xTensor`MasterOf[$CellContext`Omega\[Dagger]] -> \
$CellContext`Omega}], "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {Constant, Protected}, "FullName" -> 
    "Global`Omega\[Dagger]"], 
   False]]], "Output",ExpressionUUID->"1d1e118d-878c-4569-a469-9e2aacec9168"]
}, Open  ]],

Cell["Omega has a servant but not master:", \
"Text",ExpressionUUID->"b9415034-c0c3-45ce-947e-535e033e0bef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ServantsOf", "[", "Omega", 
  "]"}]], "Input",ExpressionUUID->"eaa79b9e-c7aa-4756-9aa4-5f8a965091bb"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox["\[CapitalOmega]\[Dagger]",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Omega\[Dagger],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"3c902b2d-7a21-44e7-ab92-f2bbcf29415d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"MasterOf", "[", "Omega", 
  "]"}]], "Input",ExpressionUUID->"07d81a9c-4250-49d0-a363-5eead36cdca3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ServantsOf", "[", "Omega\[Dagger]", 
  "]"}]], "Input",ExpressionUUID->"d6f9da2a-4b2e-407d-96b2-a698d3583be2"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"8b682da6-8023-4724-8f47-f8b2217acd80"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MasterOf", "[", "Omega\[Dagger]", 
  "]"}]], "Input",ExpressionUUID->"4b27611a-9ee6-4255-9db1-fb77cabd8fe2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[CapitalOmega]",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Omega,
  Editable->
   False]], "Output",ExpressionUUID->"ed865faf-1b93-44c8-bc37-2fd6e39c1a2c"]
}, Open  ]],

Cell["We cannot undefine Omega\[Dagger] alone:", \
"Text",ExpressionUUID->"9d56376a-375e-49bb-bb90-075f48a7c504"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "UndefConstantSymbol", "[", "Omega\[Dagger]", 
   "]"}]}]], "Input",ExpressionUUID->"517d9f52-7716-4923-b72f-c475e2ee2b8c"],

Cell[BoxData[
 TemplateBox[{
  "General", "noundef", 
   "\"\\!\\(\\*RowBox[{\\\"\\\\\\\"Symbol\\\\\\\"\\\"}]\\) \
\\!\\(\\*InterpretationBox[StyleBox[RowBox[{\\\"\[CapitalOmega]\[Dagger]\\\"}]\
, Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], Omega\\\\[Dagger], \
Rule[Editable, False]]\\) cannot be undefined because \\!\\(\\*RowBox[{\\\"\\\
\\\\\"its master is still alive\\\\\\\"\\\"}]\\).\"", 2, 1031, 2, 
   19659342612246381582, "Local"},
  "MessageTemplate"]], "Message", \
"MSG",ExpressionUUID->"68b99121-f108-42ef-8403-deb6896033be"]
}, Open  ]],

Cell["Undefining Omega also undefines Omega\[Dagger] :", \
"Text",ExpressionUUID->"c7ee947a-b1b4-4d85-a95c-90238dc1606d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Omega", 
  "]"}]], "Input",ExpressionUUID->"5f7c9e86-df61-4aba-ae3b-6851c432d25d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[CapitalOmega]\[Dagger]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Omega\[Dagger],
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Omega\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"1566e87d-c053-4124-8e67-2d4afd52b530"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[CapitalOmega]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Omega,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Omega],
  Editable->
   False]], "Print",ExpressionUUID->"86c67eb5-b209-4acd-aa14-b62248a199a6"]
}, Open  ]]
}, Open  ]],

Cell["An imaginary constant (note that Omega\[Dagger] is never defined):", \
"Text",ExpressionUUID->"af12f185-d016-4dbe-91a5-91829ac16e87"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Omega", ",", 
   RowBox[{"Dagger", "\[Rule]", "Imaginary"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<\[CapitalOmega]\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"91cea377-b061-4eec-9e2e-4b384fa7b443"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Omega", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Omega, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"38292d3c-93e8-4a32-9fd8-a01eb89a51dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Omega"}]], "Input",ExpressionUUID->"1fe5d5a1-9062-473f-b255-b38a104aa241"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Omega\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Dagger", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    xAct`xTensor`Dagger[$CellContext`Omega],
                    Editable->False], "^=", 
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False]}]}]},
                    {
                    RowBox[{
                    RowBox[{"ConstantSymbolQ", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"constant symbol\"\>", ",", "\<\"\"\>"}], 
                    "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["\[CapitalOmega]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Omega,
                    Editable->False], "]"}], "^=", "\<\"\[CapitalOmega]\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "Protected"}], "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`Omega\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`Omega\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`Omega", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`Omega, {
      xAct`xTensor`Dagger[$CellContext`Omega] -> -$CellContext`Omega, 
       xAct`xTensor`ConstantSymbolQ[$CellContext`Omega] -> True, 
       xAct`xTensor`DefInfo[$CellContext`Omega] -> {"constant symbol", ""}, 
       xAct`xTensor`PrintAs[$CellContext`Omega] -> "\[CapitalOmega]"}], 
    "DownValues" -> None, "SubValues" -> None, "DefaultValues" -> None, 
    "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {Constant, Protected}, "FullName" -> "Global`Omega"], 
   False]]], "Output",ExpressionUUID->"c5cfba62-b076-4c57-854f-2a6a6b688f9e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dagger", "[", "Omega", 
  "]"}]], "Input",ExpressionUUID->"6b13ee30-9534-4d9d-ab30-f3d26e2915f4"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox["\[CapitalOmega]",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Omega,
   Editable->
    False]}]], "Output",ExpressionUUID->"20833245-347d-4ad7-97e0-2ca72d6adb7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Omega", 
  "]"}]], "Input",ExpressionUUID->"b39acf3c-42ae-4dd2-a611-d3189b412a21"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[CapitalOmega]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Omega,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Omega],
  Editable->
   False]], "Print",ExpressionUUID->"4d637240-89a8-45d6-ba48-882565c36640"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"47d20388-6605-4ad0-bbf7-b590cc5bdf07"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.4. Parameters", \
"Subsection",ExpressionUUID->"5b73f78e-1548-4a65-a8f7-d8037dce7b7b"],

Cell[CellGroupData[{

Cell["3.4.1. Definition", \
"Subsubsection",ExpressionUUID->"84a45cf6-f04a-4547-9212-b94f44d8e053"],

Cell["\<\
Typical examples of parameters are time after a 3+1 decomposition, or proper \
time of a particle. Parameters are always real, though this could be easily \
generalized:\
\>", "Text",ExpressionUUID->"9b30ed92-f621-4dea-89ab-d4cbc365e14c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DefParameter"}]], \
"Input",ExpressionUUID->"47b058d5-9cda-4432-996b-3d0989afd675"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DefParameter[t] defines t to be a real parameter on \
which indexed objects can depend.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`DefParameter\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DefParameter[t] defines t to be a real parameter on \
which indexed objects can depend.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "DefParameter[t] defines t to be a real parameter on which indexed \
objects can depend.", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`DefParameter"], 
   False]]], "Output",ExpressionUUID->"cf8f6e9a-19f2-47ba-b8fc-212bc4817096"]
}, Open  ]],

Cell["\<\
Note that we initialize VisitorsOf because once we have defined a parameter, \
it is expected that other objects will be defined that depend on the \
parameter (See ParametersOfTensor.) We do not expect a parameter to have \
servants.\
\>", "Text",ExpressionUUID->"b1f63ba1-e0b3-410b-b28a-2330d793134b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefParameter", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Master", "\[Rule]", "Null"}], ",", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<parameter\>\"", ",", "\"\<\>\""}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefParameter", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefParameter", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefParameter", "[", 
    RowBox[{"param_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"master", ",", "pa", ",", "pns", ",", "info"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"master", ",", "pa", ",", "pns", ",", "info"}], "}"}], "=", 
        RowBox[{"OptionValue", "[", 
         RowBox[{"{", 
          RowBox[{
          "Master", ",", "PrintAs", ",", "ProtectNewSymbol", ",", "DefInfo"}],
           "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ValidateSymbol", "[", "param", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ValidateSymbolInSession", "[", "param", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakeDefInfo", "[", 
        RowBox[{"DefParameter", ",", "param", ",", "info"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{
        "DefParameter", ",", "\"\<Beginning\>\"", ",", "param", ",", 
         "options"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"AppendToUnevaluated", "[", 
        RowBox[{"$Parameters", ",", "param"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ParameterQ", "[", "param", "]"}], "^=", "True"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefInfo", "[", "param", "]"}], "^=", "info"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetPrintAs", "[", 
        RowBox[{"param", ",", 
         RowBox[{"PrintAsString", "[", 
          RowBox[{"param", ",", "pa"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SymbolRelations", "[", 
        RowBox[{"param", ",", "master", ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{
        "DefParameter", ",", "\"\<End\>\"", ",", "param", ",", "options"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"pns", ",", 
         RowBox[{"Protect", "[", "param", "]"}]}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefParameter", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "DefParameter", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7fabe11a-3213-4153-83fe-c564613cf6c3"],

Cell["Undefinition:", \
"Text",ExpressionUUID->"d6d59588-7daf-4f0d-b47c-0194aadbdee0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefParameter"}]], \
"Input",ExpressionUUID->"d74524ed-c29e-46f1-9b76-e7aec5ded65e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"UndefParameter[t] undefines the parameter t.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"xAct`xTensor`UndefParameter\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"UndefParameter[t] undefines the parameter t.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "UndefParameter[t] undefines the parameter t.", "Documentation" -> None, 
    "OwnValues" -> None, "UpValues" -> None, "DownValues" -> None, 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "xAct`xTensor`UndefParameter"], 
   False]]], "Output",ExpressionUUID->"86d35f98-de00-47fb-ab95-fcdd1b064966"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefParameter", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "ParameterQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefParameter", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefParameter", "[", "param_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"servants", "=", 
        RowBox[{"ServantsOf", "[", "param", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"ParameterQ", "[", "param", "]"}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefParameter", "::", "unknown"}], ",", 
            "\"\<parameter\>\"", ",", "param"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "param", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefParameter", ",", "\"\<Beginning\>\"", ",", "param"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "param", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "param", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$Parameters", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$Parameters", ",", "param"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefParameter", ",", "\"\<End\>\"", ",", "param"}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"MakeUndefInfo", "[", 
        RowBox[{"UndefParameter", ",", "param"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"RemoveSymbol", "[", "param", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefParameter", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefParameter", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"822bfbdc-5c7f-4d65-803d-15afeb30fc11"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.4.2. Formatting", \
"Subsubsection",ExpressionUUID->"1eab5d4b-2cc4-455d-8afd-867b54a746be"],

Cell["\<\
Held version of ConstantSymbolQ to avoid evaluation leaks during typesetting:\
\
\>", "Text",ExpressionUUID->"1a8675fd-047e-4e20-b22c-161b11cd2f69"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldParameterQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldParameterQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"ParameterQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5ddf17c5-1627-4e5c-88fb-e514dada26ec"],

Cell["StandardForm:", \
"Text",ExpressionUUID->"7bad3dc1-0c80-4bb5-8b31-f5ea53e8e7e3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "Parameter", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"param_Symbol", "?", "HeldParameterQ"}], ",", "StandardForm"}],
       "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{"param", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"PrintAs", "[", 
          RowBox[{"Unevaluated", "[", "param", "]"}], "]"}], "}"}], "]"}]}], 
      "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "Parameter", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"param_Symbol", "?", "HeldParameterQ"}], ",", "StandardForm"}],
       "]"}], "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"xTensorFormStart", "[", "Parameter", "]"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6b744ba3-5815-4292-a60b-4ab6c1368e7c"]
}, Closed]],

Cell[CellGroupData[{

Cell["3.4.3. Examples", \
"Subsubsection",ExpressionUUID->"2a013223-18ad-4729-8d01-d1238295ddc0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"497fe4c3-28c3-4d37-9d66-a530745144b4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefParameter", "[", 
  RowBox[{"time", ",", 
   RowBox[{"PrintAs", "->", "\"\<t\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"b48e6ace-c819-47fd-ac04-dbe5710af15f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefParameter", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"parameter \"\>", "\[InvisibleSpace]", "time", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefParameter, ": Defining ", 
   "parameter ", $CellContext`time, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"81c00846-9f86-4221-9187-31e97a63f53a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "time"}]], "Input",ExpressionUUID->"418772d0-b0e7-4bf4-9c3c-7b52c33418a5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = True, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`time\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" UpValue Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"UpValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "UpValues", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"ParameterQ", "[", 
                    InterpretationBox[
                    StyleBox["t",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`time,
                    Editable->False], "]"}], "^=", "True"}]},
                    {
                    RowBox[{
                    RowBox[{"DefInfo", "[", 
                    InterpretationBox[
                    StyleBox["t",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`time,
                    Editable->False], "]"}], "^=", 
                    RowBox[{"{", 
                    RowBox[{"\<\"parameter\"\>", ",", "\<\"\"\>"}], "}"}]}]},
                    {
                    RowBox[{
                    RowBox[{"PrintAs", "[", 
                    InterpretationBox[
                    StyleBox["t",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`time,
                    Editable->False], "]"}], "^=", "\<\"t\"\>"}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Attributes\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Attributes\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Attributes", "Tooltip"]& ], 
                   RowBox[{"{", "Protected", "}"}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Global`time\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\"Global`time\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> "Global`time", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> 
    Information`InformationValueForm[
     UpValues, $CellContext`time, {
      xAct`xTensor`ParameterQ[$CellContext`time] -> True, 
       xAct`xTensor`DefInfo[$CellContext`time] -> {"parameter", ""}, 
       xAct`xTensor`PrintAs[$CellContext`time] -> "t"}], "DownValues" -> None,
     "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {Protected}, 
    "FullName" -> "Global`time"], 
   False]]], "Output",ExpressionUUID->"5cd6ace5-09a6-4c9d-a077-efb44f96f671"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Parameters"], \
"Input",ExpressionUUID->"586bca4c-96cd-4a7b-8029-22ec17d98b57"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox["t",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`time,
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"3de410a8-0dc4-4d0c-900f-a61b3df1a960"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["time"], \
"Input",ExpressionUUID->"6beb215e-9a74-4b54-8072-30f1b151daf8"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["t",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`time,
  Editable->
   False]], "Output",ExpressionUUID->"98318d2f-d08f-4e86-b14f-f7920073a0c1"]
}, Open  ]],

Cell["Cut and paste:", \
"Text",ExpressionUUID->"21d4b387-5db4-4372-8754-ec954d334ec6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox["t",
  time,
  Editable->
   False]], "Input",ExpressionUUID->"861ec766-8a04-401c-966d-b5435e99b41f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["t",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`time,
  Editable->
   False]], "Output",ExpressionUUID->"55bdac5a-38e0-40e3-9d4d-f5a0aa188eca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"ff76c9e7-e177-411a-a587-a0a4f7d1df1b"],

Cell["time", "Output",ExpressionUUID->"01f0040a-f75d-46fe-8ed1-0210ba69d069"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dagger", "[", "time", 
  "]"}]], "Input",ExpressionUUID->"61a1b567-eeb2-4b86-b6b3-e42769150caf"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["t",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`time,
  Editable->
   False]], "Output",ExpressionUUID->"92faded9-b127-463b-9199-f8d806419c85"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefParameter", "[", "time", 
  "]"}]], "Input",ExpressionUUID->"a1d36cf9-34af-4c1a-9f81-ac73355c13cd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefParameter", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"parameter\"\>", "\[InvisibleSpace]", "\<\" \"\>",
    "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["t",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`time,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefParameter, ": Undefined ", "parameter", 
   " ", $CellContext`time],
  Editable->
   False]], "Print",ExpressionUUID->"1203baa0-5f2a-42fc-ad76-b23e81d3bea4"]
}, Open  ]],

Cell["Note that even at the end we got t instead of time.", \
"Text",ExpressionUUID->"da67bcb1-66d6-418c-bdc6-1443fb8a8f5f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "time"}]], "Input",ExpressionUUID->"79668440-da9d-4c78-b896-4e3edad3f5f5"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"time\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a0279710-7e6a-44e7-8d3a-bef8a7e537b5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Parameters"], \
"Input",ExpressionUUID->"7858c4dd-2bb9-4154-829e-e212c9be4299"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"439610d3-0cc4-48b5-b720-80c5cdae58cd"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5472503b-f00b-4994-b1f8-d1524d44464c"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["4. The mathematical input",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"a4dcb0d7-0319-4413-8a9c-b9db136e2435"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "*********************************************************************)"}\
], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", " ", "4."}], 
    " ", "The", " ", "mathematical", " ", "input"}], " ", 
   "**********************)"}], "\[IndentingNewLine]", 
  RowBox[{
  "(*", "*********************************************************************)"}\
]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"56218382-a19f-4e8f-a41e-216dd3d68810"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"cc6410d2-4625-4a45-86b9-b6eec0ef6673"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "6.263811`", ",", "86.429238`8.388205677572598", ",", 
   "0.07247364735166552`"}], 
  "}"}]], "Output",ExpressionUUID->"c216fba2-cbb3-4dd2-981d-5f6ca9f09c24"]
}, Open  ]],

Cell[CellGroupData[{

Cell["4.0. Comments", \
"Subsection",ExpressionUUID->"703c6285-bdb0-4b89-91f7-351d6ae1ab24"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{
   "Print", "[", "\"\<Reading section 4: Mathematical input.\>\"", "]"}], ",",
    "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8ab69f5d-1f7c-4f52-885c-39e7b2ed215e"],

Cell[TextData[{
 "Structure of input and output:\n\nThe\"mathematical\" input (called \
mathinput) will be an expression of arbitrary depth containing objects as \
elements (including the particular case of the input being an object itself). \
This structure is validated with Validate. Currently an object can be a/an\n\t\
- expression with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " head Plus. Its elements (mathinput) are called terms (see ListOfTerms)\n\t\
- expression with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " head Times. Its elements (mathinput) are called factors (see \
ListOfFactors). Times is always conmutative!\n\t- expression with a head \
which has been defined as an inert-head, containing mathinput as first \
element, and possibly additional arguments\n\t- expression with a head which \
has been defined as a scalar-function, containing mathinput as (possibly \
several) scalar elements. In particular, Power. All ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " builtins with attribute NumericFunction are considered scalar-functions \
(except Plus and Times).\n\t- tensor of the form Thead[indices]. Use \
ValidateTensor\n\t- covariant derivative of the form Chead[index][ mathinput \
]. Use ValidateCovD. Several indices are also accepted in some situations \
instead of one index. Now we have introduced (though only partially) the \
notations CovD[ mathinput, cd1[i1], cd2[i2], ...]. Note also the alternative \
notation based on TensorDerivative.\n\t- Lie derivative of the form LieD[ \
mathinput ][ mathinput ]. Use ValidateLieD\n\t- expression with head Scalar \
and a single element of scalar mathinput\n\t- symbol which has been defined \
as constant-symbol or parameter\n\t- numeric quantity\n\nWith mathinput we \
denote an arbitrary expression with the structure above. Thead and Chead are \
symbols identifying the tensor or covariant derivative, respectively. \n\n\
Comments:\n\t- During execution new heads, not mentioned here, could be \
generated, but those would always be removed before returning the output.\n\t\
- indices and mathinput never appear together in a list of elements. \
Mathinput and defined symbols can appear together as in LieD[ mathinput, \
Chead ][ mathinput ] or as in mathinput + const\n\t- There is also a more \
general type of mathinput: lists, equations, rules and delayed rules. They \
must be taken into account in the input/output routines because they contain \
objects."
}], "Text",ExpressionUUID->"3102cdd1-5dac-4e1a-b357-8b6a18a60d0a"],

Cell[TextData[{
 "More recent comments. Several ideas are under development to generalize the \
",
 StyleBox["xAct",
  FontSlant->"Italic"],
 " language:\n\t- Index-free language, at least for differential forms.\n\t- \
Non-declarative handling of tensors.\n\t- Alternative notations for \
derivatives."
}], "Text",ExpressionUUID->"297998f7-0f04-4ab2-90d2-3a0208acb482"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1. Sums and products. Type Product", \
"Subsection",ExpressionUUID->"7e17b214-19ba-4955-98a3-e9548b2c3b9b"],

Cell[CellGroupData[{

Cell["4.1.0. Comments", \
"Subsubsection",ExpressionUUID->"48007139-beb0-44f4-a4c2-851eada70346"],

Cell[TextData[{
 "We shall use the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " builtins Plus and Times, to be able to use Simplify, Expand, etc on our \
tensor expressions."
}], "Text",ExpressionUUID->"c9fe595e-1033-462d-abdb-a3a03d6af41e"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1.1. MathInputExpand", \
"Subsubsection",ExpressionUUID->"3c77f91f-74b1-44e7-b1c2-c44758e099d6"],

Cell["Note that Expand is threaded over lists:", \
"Text",ExpressionUUID->"cad18027-a63b-4ee4-8f16-51f369a0b0f1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{"List", "[", 
   RowBox[{
    RowBox[{"a", 
     RowBox[{"(", 
      RowBox[{"a1", "+", "a2"}], ")"}]}], ",", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e26c7e40-47fc-4cdf-bbd5-16d07fafc433"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", " ", "a1"}], "+", 
    RowBox[{"a", " ", "a2"}]}], ",", "b"}], 
  "}"}]], "Output",ExpressionUUID->"afc47086-6b23-4e23-b88d-b054a6882e9c"]
}, Open  ]],

Cell["and now also over rules and equations", \
"Text",ExpressionUUID->"736277ba-c9c9-4a00-92d2-b4390ef3250c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{"Rule", "[", 
   RowBox[{
    RowBox[{"a", 
     RowBox[{"(", 
      RowBox[{"a1", "+", "a2"}], ")"}]}], ",", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"bcd67634-1ff0-4b8e-b78a-ce3616a5af5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", " ", "a1"}], "+", 
   RowBox[{"a", " ", "a2"}]}], "\[Rule]", 
  "b"}]], "Output",ExpressionUUID->"cfa88e37-8e23-462a-a378-5e32992e90f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{"Equal", "[", 
   RowBox[{
    RowBox[{"a", 
     RowBox[{"(", 
      RowBox[{"a1", "+", "a2"}], ")"}]}], ",", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5154dc07-5020-48b7-820d-9fa3a4b5bc11"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", " ", "a1"}], "+", 
   RowBox[{"a", " ", "a2"}]}], "\[Equal]", 
  "b"}]], "Output",ExpressionUUID->"d8af47f3-1559-4a20-898a-fb9a7aaacc55"]
}, Open  ]],

Cell["\<\
The function MathInputExpand evaluates its argument and then expands it, \
checking that no new expansion is needed again, because new definitions could \
have been used. It is a private function. It is used in ListOfTerms, \
ContractMetric, SymmetryOf and ToCanonical.\
\>", "Text",ExpressionUUID->"dd28f253-c7f2-4cbf-a962-7ec9196ab0e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "MathInputExpand"}]], \
"Input",ExpressionUUID->"58db1238-5bd7-46c1-86a9-ce73a52a21c3"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`MathInputExpand[expr] applies Expand to expr \
using FixedPoint.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672356-5338953",ExpressionUUID->"4f8fd4c4-f6a6-4ab8-bd27-\
e209b8ed2ff8"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MathInputExpand", "[", 
    RowBox[{"Equal", "[", 
     RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
   RowBox[{"Equal", "[", 
    RowBox[{
     RowBox[{"MathInputExpand", "[", "lhs", "]"}], ",", 
     RowBox[{"MathInputExpand", "[", "rhs", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MathInputExpand", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
   RowBox[{"Rule", "[", 
    RowBox[{
     RowBox[{"MathInputExpand", "[", "lhs", "]"}], ",", 
     RowBox[{"MathInputExpand", "[", "rhs", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MathInputExpand", "[", "expr_", "]"}], ":=", 
   RowBox[{"FixedPoint", "[", 
    RowBox[{"Expand", ",", "expr"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"57a40c49-70fd-4985-b912-12de34c666d4"],

Cell["\<\
I think we don't need parallel functions for Factor and similar. For very \
large expressions Expand is slow, and hence MathInputExpand is even slower. \
It is possible to change MathInputExpand by any other function using \
Block[{MathInputExpand=...}, ...].\
\>", "Text",ExpressionUUID->"f636fa80-4883-4570-9844-b37e1ca1c569"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1.2. ListOfTerms", \
"Subsubsection",ExpressionUUID->"4a8be44c-19b1-4126-a906-08de3cbd0cfb"],

Cell["\<\
This function gives terms (summands). Note that mathinput is always evaluated \
and expanded before checking the head:\
\>", "Text",ExpressionUUID->"214e75f7-f4e3-48a4-9df1-f1082ea040a8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ListOfTerms"}]], \
"Input",ExpressionUUID->"45efd7c3-91d0-4641-baa6-242b5b29b072"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`ListOfTerms[expr] gives the list of elements \
of expr if its head is Plus and {expr} otherwise. The expression expr is \
evaluated and expanded (using Expand) before checking its head.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672358-5338953",ExpressionUUID->"13e214e0-7e35-421b-826e-\
a4294f3dafaa"]
}, Open  ]],

Cell["\<\
Detailed structure of a SeriesData expression (now not evaluatable):\
\>", "Text",ExpressionUUID->"966213d5-7c20-45a0-b397-6985d107b446"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListOfTerms", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"SeriesData", "[", 
      RowBox[{
      "var_", ",", "origin_", ",", "coeffs_", ",", "iord_", ",", "ford_", ",",
        "root_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"coeffs", " ", 
      RowBox[{"Power", "[", 
       RowBox[{"var", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"iord", "+", 
           RowBox[{"Range", "[", 
            RowBox[{"origin", ",", 
             RowBox[{
              RowBox[{"Length", "[", "coeffs", "]"}], "-", "1"}]}], "]"}]}], 
          ")"}], "/", "root"}]}], "]"}]}], ",", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"var", ",", "origin", ",", 
       RowBox[{"0", " ", "coeffs"}], ",", "iord", ",", "ford", ",", "root"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"06df8dcf-eafc-4947-8109-ff10ea0d90e3"],

Cell["\<\
With SeriesData expressions, we compute the terms of its normal form and \
append the \"series information\", so that apply Plus later will reconstruct \
the complete series.\
\>", "Text",ExpressionUUID->"32ed269c-f061-434a-a9e7-3c7dd3250d0a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ListOfTerms", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"expr", ":", 
      RowBox[{"SeriesData", "[", 
       RowBox[{"var_", ",", "origin_", ",", "coeffs_", ",", "args__"}], 
       "]"}]}], "]"}], "]"}], ":=", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"ListOfTerms", "[", 
      RowBox[{"Normal", "[", "expr", "]"}], "]"}], ",", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"var", ",", "origin", ",", 
       RowBox[{"0", " ", "coeffs"}], ",", "args"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListOfTerms", "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "#", "]"}], "===", "Plus"}], ",", 
       RowBox[{"List", "@@", "#"}], ",", 
       RowBox[{"List", "@", "#"}]}], "]"}], "&"}], "@", 
    RowBox[{"MathInputExpand", "[", "expr", "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d972f80a-6281-4ea3-b53a-797060209b53"],

Cell["Examples:", \
"Text",ExpressionUUID->"e2b5a275-3ddb-4c8e-ab1d-7e9c2bd69ab7"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5ed77d1f-bb7a-4011-a2e8-ddc9f26e4d0e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfTerms", "[", 
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"6b38fc59-4798-460d-bbb9-d765f069806a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], 
  "}"}]], "Output",ExpressionUUID->"cdcfb1ca-bd91-4712-8a43-90f44bcd47a4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfTerms", "[", 
  RowBox[{"6", "+", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c293a5ab-62ff-46f7-a1da-b7a9ec32e2bd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"96e01084-1f7a-41cf-93bc-e1b7966b2e8e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfTerms", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"0502b9d8-5dee-4c0c-9450-b784d7974951"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], " ", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"48a8a095-f91a-4b53-a0b9-647d911e15af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfTerms", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}], "+", 
   RowBox[{"r", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"fae63374-ff12-4c04-b1ef-fa44afd86543"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}], " ", 
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"985038a7-2623-47cb-b7d3-6a60fc65f60a"]
}, Open  ]],

Cell["\<\
Evaluation of the next line generates a large number of System`SeriesDump` \
symbols:\
\>", "Text",ExpressionUUID->"e9aed36c-4eb5-4c3c-a49c-a45a7d3a39ec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfTerms", "[", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{"f", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "3"}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"9fec7396-1679-4fd0-ba63-332b2a68188c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", "0", "]"}], ",", 
   RowBox[{"x", " ", 
    RowBox[{
     SuperscriptBox["f", "\[Prime]",
      MultilineFunction->None], "[", "0", "]"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox["x", "2"], " ", 
    RowBox[{
     SuperscriptBox["f", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "0", "]"}]}], ",", 
   RowBox[{
    FractionBox["1", "6"], " ", 
    SuperscriptBox["x", "3"], " ", 
    RowBox[{
     SuperscriptBox["f", 
      TagBox[
       RowBox[{"(", "3", ")"}],
       Derivative],
      MultilineFunction->None], "[", "0", "]"}]}], ",", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "4"],
    SeriesData[$CellContext`x, 0, {}, 4, 4, 1],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"3cfdaacc-5a8c-4b2c-ba58-443361fb3814"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plus", "@@", 
  "%"}]], "Input",ExpressionUUID->"8b46fd78-63af-4cb4-b1e0-d1b04939aed3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"f", "[", "0", "]"}], "+", 
   RowBox[{
    RowBox[{
     SuperscriptBox["f", "\[Prime]",
      MultilineFunction->None], "[", "0", "]"}], " ", "x"}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{
     SuperscriptBox["f", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "0", "]"}], " ", 
    SuperscriptBox["x", "2"]}], "+", 
   RowBox[{
    FractionBox["1", "6"], " ", 
    RowBox[{
     SuperscriptBox["f", 
      TagBox[
       RowBox[{"(", "3", ")"}],
       Derivative],
      MultilineFunction->None], "[", "0", "]"}], " ", 
    SuperscriptBox["x", "3"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "4"],
    SeriesData[$CellContext`x, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {
    $CellContext`f[0], 
    Derivative[1][$CellContext`f][0], Rational[1, 2] 
    Derivative[2][$CellContext`f][0], Rational[1, 6] 
    Derivative[3][$CellContext`f][0]}, 0, 4, 1],
  Editable->
   False]], "Output",ExpressionUUID->"e397c4c4-57bd-4d1a-8408-67ba722f2494"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"7d9e55b5-fe01-4a6e-85f8-8667d6099686"],

Cell["\<\
SeriesData[x, 0, {f[0], Derivative[1][f][0], Derivative[2][f][0]/2, \
Derivative[3][f][0]/6}, 0, 4, 1]\
\>", "Output",ExpressionUUID->"d3342b17-065a-4654-805e-1653ae2d5f00"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"T", ",", "a", ",", "b", ",", "r", ",", "f", ",", "x"}], 
  "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"d388bc16-eae0-42ad-aea3-7ac0c183f859"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1.3. ListOfFactors", \
"Subsubsection",ExpressionUUID->"6bbb961f-1a9f-43fb-bb06-a862b747c2c1"],

Cell["\<\
This function is currently used only in InducedDecomposition and \
MonomialsOfTerm.\
\>", "Text",ExpressionUUID->"aba4d611-c75c-4b99-84fa-499de04149d9"],

Cell["\<\
An intermediate function to give factors. Note that expr is always evaluated \
and factorized before checking the head:\
\>", "Text",ExpressionUUID->"8696c182-20d6-4075-bbce-97cd351c11aa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ListOfFactors"}]], \
"Input",ExpressionUUID->"92f45d02-6f53-47e3-b580-dfd192634cbf"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`ListOfFactors[expr] gives the list of elements \
of expr if its head is Times and {expr} otherwise. The expression expr is \
evaluated and factored (usign Factor) before checking its head.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672360-5338953",ExpressionUUID->"c8f3ee18-9322-4252-95a4-\
1ef31019c9e4"]
}, Open  ]],

Cell["\<\
We do not factor terms in a series, because it is not clear how to handle the \
O terms.\
\>", "Text",ExpressionUUID->"da3b644f-f29b-48af-924f-7e3e5fbae6a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListOfFactors", "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "#", "]"}], "===", "Times"}], ",", 
       RowBox[{"List", "@@", "#"}], ",", 
       RowBox[{"List", "@", "#"}]}], "]"}], "&"}], "@", 
    RowBox[{"Factor", "[", "expr", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dff2237e-1d00-4d3e-908c-400635f24002"],

Cell["Examples:", \
"Text",ExpressionUUID->"aad8e22d-c110-4bdd-b417-48f7ba3e4fb8"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"6d1e57c2-07f0-4bad-94c5-35a0c7ddc78f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfFactors", "[", 
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"3a0a410d-651d-43be-8b8c-7c0ceeee7763"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], 
  "}"}]], "Output",ExpressionUUID->"bc6e50a7-a132-4d32-b020-04f68d14a11a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfFactors", "[", 
  RowBox[{"6", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"40157e92-bc0e-44f2-9df4-a98f3c14ef26"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"4238af0c-5286-4f44-add0-53064f72a6ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfFactors", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], 
    RowBox[{"F", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"831326d1-d76c-4b36-9a72-7f307ccb09b2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"F", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}], ",", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"e3ad2b04-215b-4d2e-b6f0-153c0499240e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfFactors", "[", 
  RowBox[{"6", "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"9f934039-2378-41fb-aea7-ff6f966985f3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}], " ", 
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"873cc2dc-5f3b-46f9-bd4b-ced14d53ebf4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ListOfFactors", "[", 
  RowBox[{
   RowBox[{"x", "^", "2"}], "-", "1"}], 
  "]"}]], "Input",ExpressionUUID->"d0a87c61-13f3-468d-9134-3fcf4114984b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "1"}], "+", "x"}], ",", 
   RowBox[{"1", "+", "x"}]}], 
  "}"}]], "Output",ExpressionUUID->"2b5c2def-90a4-4042-a0a6-c176175e8fae"]
}, Open  ]],

Cell["Factor does not work on series:", \
"Text",ExpressionUUID->"c8b74861-356a-4b78-a090-720ab57d6acd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"x", "-", "1"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"x", "+", "2"}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"59269fec-ff93-450e-ab8a-d877111251c0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", "2"}], "+", "x", "+", 
   SuperscriptBox["x", "2"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {-2, 1, 1}, 0, 3, 1],
  Editable->
   False]], "Output",ExpressionUUID->"948c2b84-c940-479f-8127-440118621cb6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"28a3f34e-cc66-4a4a-bd45-28c8ce5de218"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", "2"}], "+", "x", "+", 
   SuperscriptBox["x", "2"], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {-2, 1, 1}, 0, 3, 1],
  Editable->
   False]], "Output",ExpressionUUID->"27eccf2d-c07c-40a4-bead-4d597f0d7857"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Normal", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"31af3de5-3122-46a0-b67a-c10086889ace"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], "+", "x", "+", 
  SuperscriptBox["x", 
   "2"]}]], "Output",ExpressionUUID->"f9e64ad5-1085-47e9-9150-a6ff38c42978"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"3f5371e6-2e46-4c05-8326-50b4b115d30d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "x"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"2", "+", "x"}], 
   ")"}]}]], "Output",ExpressionUUID->"be2c150a-da86-4f04-b874-dd9e37a8ea53"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"T", ",", "a", ",", "b", ",", "x", ",", "F"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"21c67b81-c94a-4299-b68c-72197266e629"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1.4. Type Product", \
"Subsubsection",ExpressionUUID->"2e5bd95b-2c9e-456a-9f79-d2df067d26bb"],

Cell["\<\
Very many thanks to Alfonso Garc\[IAcute]a-Parrado for suggesting the main \
ideas of this and the next sections, and for testing the first versions of \
the code.\
\>", "Text",ExpressionUUID->"50ef7e21-1899-498f-96a4-66b640b89fc8"],

Cell[TextData[{
 "A product in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is essentially a way to define an ALGEBRA over a ring of scalar \
expressions. We can have associative (vararg) and nonassociative (binary) \
algebras. Products with other number of arguments are currently not possible.\
\n\nAn algebra U over a ring R is a module over R with a binary product that \
distributes over the sum of elements of U and is linear over elements of R.\n\
\nElements of the ring R (of the algebra of the product prod) are called \
\[OpenCurlyDoubleQuote]the scalars of the algebra\[CloseCurlyDoubleQuote], \
and we ask the user to provide a function to identify them, in case \
ambiguities appear (like the double role of Times as product scalar-by-scalar \
and scalar-by-vector). We don\[CloseCurlyQuote]t need to have a function \
identifying the elements of the algebra: whatever appears in one of the \
arguments of the product must be an element of the algebra, and we don\
\[CloseCurlyQuote]t need to check it. If those elements appear somewhere \
else, we don\[CloseCurlyQuote]t care. However, we need to set up definitions \
that extract scalars from the product, so having an identifier of scalars is \
essential.\n\nThere are three products involved in an algebra, and we need to \
be extremely careful with this:\n\t- the product of elements of the algebra. \
This is the main product, identifying the algebra itself. We require no \
particular property of this product.\n\t- the product of scalars. Currently \
we require it to be associative, commutative and with an identity element \
(the \[OpenCurlyDoubleQuote]one\[CloseCurlyDoubleQuote]). In most cases this \
product will be simply Times.\n\t- the product of a scalar by an element of \
the algebra (pbs). This is like a \[OpenCurlyDoubleQuote]group action\
\[CloseCurlyDoubleQuote] and in general it will be a sided product, because \
it needs to distinguish the scalars and the elements of the algebra. In some \
cases it can be made to coincide with the product of scalars, and in \
particular with Times, which makes this product unnaturally commutative and \
associative. Then we will have to encode it with checks for the scalars. In \
other cases, like graded algebras, it is natural to promote the scalars to \
elements of the algebra, and then some algebra products become naturally pbs \
products.\n\nCurrently products can be given a  symmetry, basically \
commutativity (or symmetry +1) or anticommutativity (symmetry -1), the latter \
requiring the use of grades in the associative case. For a graded product we \
need to extend this to supercommutativity and superanticommutativity, such \
that the sign is given by the product of grades. Exterior algebra is \
supercommutative. Actually, currently symmetry -1 in the graded case means \
supercommutativity.\n\nWe provide an option to specify whether there is an \
identity element or not. Associativity is implemented using the Flat and \
OneIdentity attributes of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", which effectively turn prod[] into an identity element. Hence we need to \
have an identity element for the associative products. The behavior of the \
product on the identity element depends on whether the identity element \
(which must obviously be an element of the algebra) is also a scalar of the \
product. If, for the associative case, we declare ScalarsOfProduct -> scQ and \
IdentityElementOfProduct -> id, then scQ[id] will be evaluated and it must \
return the appropriate answer. This may require defining scQ in advance of \
evaluating DefProduct.\n\nNote that the function scQ must be compatible with \
pos. That is, if a, b are scalars then pos[a, b] must also be a scalar."
}], "Text",ExpressionUUID->"3fe1f9e9-df80-44a1-808f-4dcbdebcff3d"],

Cell["\<\
For a product prod and tensors T1 and T2 the indices of the expression prod[ \
T1[a, b], T2[-b, -c] ] are {a, b, -b, -c}. For example we may want to \
implement a Lie algebra using lie[ v[], w[] ] for two elements v, w of the \
algebra. This is very different from the Bracket[ v[a], w[a] ][a] notation. \
Note again that there is no need to specify what belongs or not to the \
algebra, but we need to specify what are the scalars, to pull them out by \
linearity.\
\>", "Text",ExpressionUUID->"d29eee9e-dd05-4d9a-90be-ccfafe2a5d26"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DefProduct"}]], \
"Input",ExpressionUUID->"84c00ff0-8dda-4c67-bc9b-46902eac5571"],

Cell[BoxData[
 StyleBox["\<\"DefProduct[prod] defines prod to be a product of indexed \
objects.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672362-5338953",ExpressionUUID->"00156b4d-9e3f-4732-b564-\
0b0526f1f223"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$MathematicaProductSymbols", "=", 
   RowBox[{"{", 
    RowBox[{
    "Square", ",", "CircleTimes", ",", "CircleMinus", ",", "CircleDot", ",", 
     "Diamond", ",", "CenterDot", ",", "Star", ",", "VerticalTilde", ",", 
     "Backslash", ",", "Wedge", ",", "Vee", ",", "Cap", ",", "Cup"}], "}"}]}],
   ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6e28ec8b-3eb4-40ad-8cd0-5fc486cc22c7"],

Cell["\<\
TODO: We need a simpler way to change formatting, for example to given \
\[OpenCurlyDoubleQuote]bracket form\[CloseCurlyDoubleQuote], or perhaps \
\[OpenCurlyDoubleQuote]bra-ket form\[CloseCurlyDoubleQuote].\
\>", "Text",ExpressionUUID->"9fa3c4c6-6800-4a18-9fa0-59c733e873a7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefProduct", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AssociativeProductQ", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"IdentityElementOfProduct", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"CommutativityOfProduct", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GradedProductQ", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GradeOfProduct", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ScalarsOfProduct", "\[Rule]", "NumericQ"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"DefineCommutator", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"xSortOrder", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PrintAs", "\[Rule]", "\"\<\[Diamond]\>\""}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<product\>\"", ",", "\"\<\>\""}], "}"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProduct", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefProduct", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProduct", "[", 
    RowBox[{"prod_", ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"DefProduct", "[", 
    RowBox[{"prod", ",", "Times", ",", "Times", ",", "options"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProduct", "[", 
    RowBox[{"prod_", ",", "epbs_", ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"DefProduct", "[", 
    RowBox[{"prod", ",", "epbs", ",", "Times", ",", "options"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProduct", "[", 
    RowBox[{"prod_", ",", "epbs_", ",", "pos_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "asQ", ",", "ie", ",", "com", ",", "gp", ",", "gop", ",", "scQ", ",", 
        "dc", ",", "xso", ",", "master", ",", "pa", ",", "pns", ",", "info", 
        ",", "systemQ", ",", "pbs", ",", "pbsside", ",", "isQ"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "asQ", ",", "ie", ",", "com", ",", "gp", ",", "gop", ",", "scQ", ",",
           "dc", ",", "xso", ",", "master", ",", "pa", ",", "pns", ",", 
          "info"}], "}"}], "=", 
        RowBox[{"OptionValue", "[", 
         RowBox[{"{", 
          RowBox[{
          "AssociativeProductQ", ",", "IdentityElementOfProduct", ",", 
           "CommutativityOfProduct", ",", "GradedProductQ", ",", 
           "GradeOfProduct", ",", "ScalarsOfProduct", ",", "DefineCommutator",
            ",", "xSortOrder", ",", "Master", ",", "PrintAs", ",", 
           "ProtectNewSymbol", ",", "DefInfo"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Validate", " ", "symbol", " ", "prod"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"systemQ", "=", 
        RowBox[{"MemberQ", "[", 
         RowBox[{"$MathematicaProductSymbols", ",", "prod"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", "systemQ"}], ",", 
         RowBox[{"ValidateSymbol", "[", "prod", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ValidateSymbolInSession", "[", "prod", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "The", " ", "product", " ", "of", " ", "scalars", " ", "must", " ", 
          "be", " ", "already", " ", "a", " ", "product"}], ",", " ", 
         RowBox[{
         "and", " ", "it", " ", "must", " ", "be", " ", "associative"}], ",", 
         " ", 
         RowBox[{"unital", " ", "and", " ", "commutative"}], ",", " ", 
         RowBox[{
          RowBox[{"i", ".", "e", ".", " ", "a"}], " ", "commutative", " ", 
          "monoid"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"ProductQ", "[", "pos", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefProduct", "::", "unknown"}], ",", "pos", ",", 
            "\"\<product\>\""}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"AssociativeProductQ", "[", "pos", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefProduct", "::", "error1"}], ",", "pos", ",", 
            "\"\<is not associative\>\""}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"CommutativityOfProduct", "[", "pos", "]"}], "=!=", 
          "\"\<Commutative\>\""}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefProduct", "::", "error1"}], ",", "pos", ",", 
            "\"\<is not commutative\>\""}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"IdentityElementOfProduct", "[", "pos", "]"}], "===", 
          "None"}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefProduct", "::", "error1"}], ",", "pos", ",", 
            "\"\<dos not have an identity element\>\""}], "]"}]}]}], "]"}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "Check", " ", "structure", " ", "of", " ", "the", " ", "product"}], 
         "-", "by", "-", 
         RowBox[{"scalar", " ", "argument"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ListQ", "[", "epbs", "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", "epbs", "]"}], "===", "2"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"pbsside", "=", 
           RowBox[{"First", "[", "epbs", "]"}]}], ";", "\[IndentingNewLine]", 
          
          RowBox[{"pbs", "=", 
           RowBox[{"Last", "[", "epbs", "]"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"pbsside", "=", "All"}], ";", "\[IndentingNewLine]", 
          RowBox[{"pbs", "=", "epbs"}]}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"pbsside", "=!=", "Left"}], "&&", 
          RowBox[{"pbsside", "=!=", "Right"}], "&&", 
          RowBox[{"pbsside", "=!=", "All"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Throw", "[", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefProduct", "::", "invalid"}], ",", "pbsside", ",", 
            "\"\<sideness of the product by scalars\>\""}], "]"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"pbsside", "===", "All"}], "&&", 
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"Attributes", "@@", 
             RowBox[{"{", "pbs", "}"}]}], ",", "Flat"}], "]"}]}], ",", 
         RowBox[{"pbsside", "=", "Left"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"MakeDefInfo", "[", 
        RowBox[{"DefProduct", ",", "prod", ",", "info"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{
        "DefProduct", ",", "\"\<Beginning\>\"", ",", "prod", ",", "options"}],
         "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"AppendToUnevaluated", "[", 
        RowBox[{"$Products", ",", "prod"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"SymbolRelations", "[", 
        RowBox[{"prod", ",", "master", ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefInfo", "[", "prod", "]"}], "^=", "info"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ProductQ", "[", "prod", "]"}], "^=", "True"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"GradedProductQ", "[", "prod", "]"}], "^=", "gp"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"gp", ",", 
         RowBox[{
          RowBox[{"GradeOfProduct", "[", 
           RowBox[{"prod", ",", "prod"}], "]"}], "^=", "gop"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ScalarsOfProduct", "[", "prod", "]"}], "^=", "scQ"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ProductByScalar", "[", "prod", "]"}], "^=", "epbs"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ProductOfScalars", "[", "prod", "]"}], "^=", "pos"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Formatting", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"systemQ", ",", "\[IndentingNewLine]", 
         RowBox[{"SetPrintAs", "[", 
          RowBox[{"prod", ",", 
           RowBox[{"ToExpression", "[", 
            RowBox[{"\"\<\\\"\\\\[\>\"", "<>", 
             RowBox[{"ToString", "[", "prod", "]"}], "<>", "\"\<]\\\"\>\""}], 
            "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SetPrintAs", "[", 
           RowBox[{"prod", ",", 
            RowBox[{"PrintAsString", "[", 
             RowBox[{"prod", ",", "pa"}], "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"TODO", ":", " ", 
            RowBox[{
            "add", " ", "parentheses", " ", "for", " ", "nested", " ", 
             "nonassociative", " ", "cases"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MakeBoxes", "[", 
            RowBox[{
             RowBox[{"prod", "[", "factors__", "]"}], ",", "StandardForm"}], 
            "]"}], ":=", 
           RowBox[{"interpretbox", "[", 
            RowBox[{
             RowBox[{"prod", "[", "factors", "]"}], ",", 
             RowBox[{"MakeSequenceBox", "[", 
              RowBox[{
               RowBox[{"{", "factors", "}"}], ",", "pa", ",", 
               "StandardForm"}], "]"}]}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Symmetry", ".", " ", "Currently"}], " ", "we", " ", 
         "define", " ", "no", " ", "automatic", " ", 
         RowBox[{"simplification", ".", " ", "ToCanonical"}], " ", "will", 
         " ", "do", " ", "that"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CommutativityOfProduct", "[", "prod", "]"}], "^=", "com"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"!", 
           RowBox[{"GradedProductQ", "[", "prod", "]"}]}], "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"com", "===", "\"\<SuperCommutative\>\""}], "||", 
            "\"\<SuperAnticommutative\>\""}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefProduct", "::", "error"}], ",", 
            "\"\<Only graded products can be supercommutative or \
superanticommutative.\>\""}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"xso", "=!=", "Automatic"}], ",", "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"order", "=", "xso"}], "}"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{
            RowBox[{"ObjectOrder", "[", 
             RowBox[{"prod", ",", "freesQ_"}], "]"}], "=", 
            RowBox[{"Function", "[", 
             RowBox[{"xso", "[", 
              RowBox[{
               RowBox[{"UxSort", "[", 
                RowBox[{"First", "[", "#1", "]"}], "]"}], ",", 
               RowBox[{"UxSort", "[", 
                RowBox[{"First", "[", "#2", "]"}], "]"}]}], "]"}], "]"}]}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Distributivity", " ", "of", " ", "prod", " ", 
         RowBox[{"(", 
          RowBox[{"ADL", "/", "R"}], ")"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"MakeDistributiveProduct", "[", 
        RowBox[{"prod", ",", "asQ", ",", "0"}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Linearity", " ", "of", " ", "prod", " ", "with", " ", "respect", " ",
          "to", " ", "pbs", " ", 
         RowBox[{"(", 
          RowBox[{"LINL", "/", "R"}], ")"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"MakeLinearProduct", "[", 
        RowBox[{"prod", ",", "asQ", ",", "scQ", ",", "pbs", ",", "pbsside"}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "If", " ", "pbs", " ", "is", " ", "not", " ", "yet", " ", "a", " ", 
          "product"}], ",", " ", 
         RowBox[{"add", " ", "its", " ", "properties"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"ProductQ", "[", "pbs", "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"ProductQ", "[", "pbs", "]"}], "^=", "True"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"one", "=", 
               RowBox[{"IdentityElementOfProduct", "[", "pos", "]"}]}], ",", 
              RowBox[{"zero", "=", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"pbsside", "===", "Left"}], "||", 
                RowBox[{"pbsside", "===", "All"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"pbs", "[", 
                  RowBox[{"one", ",", "x_"}], "]"}], ":=", "x"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"pbs", "[", 
                  RowBox[{"zero", ",", "x_"}], "]"}], ":=", "zero"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"MP", " ", "Left"}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"pbs", "[", 
                  RowBox[{"n_", ",", 
                   RowBox[{"pbs", "[", 
                    RowBox[{"m_", ",", "x_"}], "]"}]}], "]"}], ":=", 
                 RowBox[{"pbs", "[", 
                  RowBox[{
                   RowBox[{"pos", "[", 
                    RowBox[{"n", ",", "m"}], "]"}], ",", "x"}], "]"}]}], 
                ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"pbsside", "===", "Right"}], "||", 
                RowBox[{"pbsside", "===", "All"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"pbs", "[", 
                  RowBox[{"x_", ",", "one_"}], "]"}], ":=", "x"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"pbs", "[", 
                  RowBox[{"x_", ",", "zero"}], "]"}], ":=", "zero"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"MP", " ", "Right"}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"pbs", "[", 
                  RowBox[{
                   RowBox[{"pbs", "[", 
                    RowBox[{"x_", ",", "n_"}], "]"}], ",", "m_"}], "]"}], ":=", 
                 RowBox[{"pbs", "[", 
                  RowBox[{"x", ",", 
                   RowBox[{"pos", "[", 
                    RowBox[{"n", ",", "m"}], "]"}]}], "]"}]}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Distributivity", " ", "of", " ", "pbs", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"MDL", "/", "R"}], ")"}], ".", " ", "Slight"}], " ",
                 "abuse", " ", "of", " ", "notation"}], ",", " ", 
               RowBox[{
               "not", " ", "using", " ", "pbsside", " ", "and", " ", "the", 
                " ", "same", " ", "zero"}]}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"MakeDistributiveProduct", "[", 
              RowBox[{"pbs", ",", "False", ",", "zero"}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Associated", " ", "commutator", " ", "product"}], " ", 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"dc", ",", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"TODO", ":", " ", 
           RowBox[{
           "This", " ", "check", " ", "should", " ", "be", " ", "either", " ",
             "removed", " ", "or", " ", "extended", " ", "to", " ", "all", 
            " ", "commutators"}]}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"com", "===", "\"\<Commutative\>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<** DefProduct: Commutator of a commutative product \
vanishes identically.\>\"", "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Commutator", "[", "prod", "]"}], "[", "__", "]"}], ":=",
               "0"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"MakeLinearProduct", "[", 
           RowBox[{
            RowBox[{"Commutator", "[", "prod", "]"}], ",", "False", ",", 
            "scQ", ",", "pbs", ",", "pbsside"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"MakeLinearProduct", "[", 
           RowBox[{
            RowBox[{"Anticommutator", "[", "prod", "]"}], ",", "False", ",", 
            "scQ", ",", "pbs", ",", "pbsside"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"MakeLinearProduct", "[", 
           RowBox[{
            RowBox[{"Supercommutator", "[", "prod", "]"}], ",", "False", ",", 
            "scQ", ",", "pbs", ",", "pbsside"}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Associativity", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AssociativeProductQ", "[", "prod", "]"}], "^=", "asQ"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"asQ", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SetAttributes", "[", 
           RowBox[{"prod", ",", 
            RowBox[{"{", 
             RowBox[{"Flat", ",", "OneIdentity"}], "}"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Verbatim", "[", "prod", "]"}], "[", "expr_", "]"}], ":=",
            "expr"}], ";"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"prod", "[", "]"}], ":=", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"prod", "::", "error"}], ",", 
              RowBox[{"\"\<Found expression \>\"", "<>", 
               RowBox[{"ToString", "[", "prod", "]"}], "<>", 
               "\"\<[].\>\""}]}], "]"}]}]}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Identity", " ", "element"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"IdentityElementOfProduct", "[", "prod", "]"}], "^=", "ie"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"ie", "===", "None"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"asQ", ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefProduct", "::", "error"}], ",", 
              "\"\<An associative product must be defined with an identity \
element.\>\""}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"gp", "&&", 
             RowBox[{
              RowBox[{"Grade", "[", 
               RowBox[{"ie", ",", "prod"}], "]"}], "=!=", "0"}]}], ",", 
            RowBox[{"Throw", "@", 
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{"DefProduct", "::", "error1"}], ",", 
               "\"\<The identity element of a graded algebra must have grade \
0, instead of\>\"", ",", 
               RowBox[{"Grade", "[", 
                RowBox[{"ie", ",", "prod"}], "]"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Is", " ", "the", " ", "identity", " ", "also", " ", "a", " ", 
             RowBox[{"scalar", "?", " ", "If"}], " ", 
             RowBox[{"scQ", "[", "ie", "]"}], " ", "stays", " ", 
             "unevaluated"}], ",", " ", 
            RowBox[{"we", " ", "assume", " ", "it", " ", "is", " ", "not"}]}],
            " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"isQ", "=", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"scQ", "[", "ie", "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"asQ", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Verbatim", "[", "prod", "]"}], "[", "]"}], ":=", 
              "ie"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"isQ", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"Verbatim", "[", "prod", "]"}], "[", 
                 RowBox[{"left___", ",", 
                  RowBox[{"x_", "?", "scQ"}], ",", "right___"}], "]"}], ":=", 
                
                RowBox[{"pbs", "[", 
                 RowBox[{"x", ",", 
                  RowBox[{"prod", "[", 
                   RowBox[{"left", ",", "right"}], "]"}]}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"Verbatim", "[", "prod", "]"}], "[", 
                 RowBox[{"left___", ",", "ie", ",", "right___"}], "]"}], ":=", 
                RowBox[{"prod", "[", 
                 RowBox[{"left", ",", "right"}], "]"}]}]}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{"isQ", ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Verbatim", "[", "prod", "]"}], "[", 
                 RowBox[{"expr_", ",", 
                  RowBox[{"x_", "?", "scQ"}]}], "]"}], ":=", 
                RowBox[{"pbs", "[", 
                 RowBox[{"x", ",", "expr"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"Verbatim", "[", "prod", "]"}], "[", 
                 RowBox[{
                  RowBox[{"x_", "?", "scQ"}], ",", "expr_"}], "]"}], ":=", 
                RowBox[{"pbs", "[", 
                 RowBox[{"x", ",", "expr"}], "]"}]}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Verbatim", "[", "prod", "]"}], "[", 
                 RowBox[{"expr_", ",", "ie"}], "]"}], ":=", "expr"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"Verbatim", "[", "prod", "]"}], "[", 
                 RowBox[{"ie", ",", "expr_"}], "]"}], ":=", "expr"}], ";"}]}],
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"dc", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Commutator", "[", "prod", "]"}], "[", 
               RowBox[{"x_", ",", "ie"}], "]"}], ":=", "0"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Commutator", "[", "prod", "]"}], "[", 
               RowBox[{"ie", ",", "x_"}], "]"}], ":=", "0"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "Products", " ", "are", " ", "declared", " ", "to", " ", "be", " ", 
          "listable", " ", "by", " ", "default"}], ",", " ", 
         RowBox[{
         "mainly", " ", "to", " ", "allow", " ", "automatic", " ", 
          "threading", " ", "through", " ", "Equal"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"SetAttributes", "[", 
        RowBox[{"prod", ",", "Listable"}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Finalize", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{
        "DefProduct", ",", "\"\<End\>\"", ",", "prod", ",", "options"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"pns", ",", 
         RowBox[{"Protect", "[", "prod", "]"}]}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefProduct", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "DefProduct", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7138a3ac-2350-4d91-9ac6-67a685abb028"],

Cell["\<\
These are the distributivity and linearity rules for the algebra product, \
both for associative and nonassociative products, and both for left- and \
right-products by scalars. This assumes that the properties of the product by \
scalars and of the product of scalars have been already properly given.\
\>", "Text",ExpressionUUID->"289f28d7-f05f-4a76-9c6a-a5bb98b736b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Distributivity", " ", 
    RowBox[{"(", 
     RowBox[{"automatic", " ", "expansion"}], ")"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MakeDistributiveProduct", "[", 
      RowBox[{"prod_", ",", "True", ",", "zero_"}], "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"left___", ",", "zero", ",", "right___"}], "]"}], ":=", 
        "zero"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"left___", ",", "sum_Plus", ",", "right___"}], "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{"prod", "[", 
           RowBox[{"left", ",", "#", ",", "right"}], "]"}], "&"}], "/@", 
         "sum"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"This", " ", "is", " ", 
         RowBox[{"incorrect", ".", " ", "It"}], " ", "needs", " ", "a", " ", 
         "generalization", " ", "of", " ", "SeriesDataMap"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"left___", ",", "sum_SeriesData", ",", "right___"}], "]"}], ":=", 
        RowBox[{"SeriesDataMap", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"prod", "[", 
            RowBox[{"left", ",", "#", ",", "right"}], "]"}], "&"}], ",", 
          "sum"}], "]"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeDistributiveProduct", "[", 
      RowBox[{"prod_", ",", "False", ",", "zero_"}], "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"zero", ",", "x_"}], "]"}], ":=", "zero"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"x_", ",", "zero"}], "]"}], ":=", "zero"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"sum_Plus", ",", "x_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{"prod", "[", 
           RowBox[{"#", ",", "x"}], "]"}], "&"}], "/@", "sum"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"x_", ",", "sum_Plus"}], "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{"prod", "[", 
           RowBox[{"x", ",", "#"}], "]"}], "&"}], "/@", "sum"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"These", " ", "are", " ", 
         RowBox[{"incorrect", ".", " ", "They"}], " ", "need", " ", "a", " ", 
         "generalization", " ", "of", " ", "SeriesDataMap"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"sum_SeriesData", ",", "x_"}], "]"}], ":=", 
        RowBox[{"SeriesDataMap", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"prod", "[", 
            RowBox[{"#", ",", "x"}], "]"}], "&"}], ",", "sum"}], "]"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"x_", ",", "sum_SeriesData"}], "]"}], ":=", 
        RowBox[{"SeriesDataMap", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"prod", "[", 
            RowBox[{"x", ",", "#"}], "]"}], "&"}], ",", "sum"}], "]"}]}], 
       ";"}], "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Linearity", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeLinearProduct", "[", 
      RowBox[{"prod_", ",", "True", ",", "scQ_", ",", "pbs_", ",", "Left"}], 
      "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"left___", ",", 
          RowBox[{"pbs", "[", 
           RowBox[{
            RowBox[{"number_", "?", "scQ"}], ",", "x_"}], "]"}], ",", 
          "right___"}], "]"}], ":=", 
        RowBox[{"pbs", "[", 
         RowBox[{"number", ",", 
          RowBox[{"prod", "[", 
           RowBox[{"left", ",", "x", ",", "right"}], "]"}]}], "]"}]}], ";"}], 
      "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeLinearProduct", "[", 
      RowBox[{"prod_", ",", "True", ",", "scQ_", ",", "pbs_", ",", "Right"}], 
      "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"left___", ",", 
          RowBox[{"pbs", "[", 
           RowBox[{"x_", ",", 
            RowBox[{"number_", "?", "scQ"}]}], "]"}], ",", "right___"}], 
         "]"}], ":=", 
        RowBox[{"pbs", "[", 
         RowBox[{
          RowBox[{"prod", "[", 
           RowBox[{"left", ",", "x", ",", "right"}], "]"}], ",", "number"}], 
         "]"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeLinearProduct", "[", 
      RowBox[{"prod_", ",", "False", ",", "scQ_", ",", "pbs_", ",", "Left"}], 
      "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{
          RowBox[{"pbs", "[", 
           RowBox[{
            RowBox[{"number_", "?", "scQ"}], ",", "x_"}], "]"}], ",", "y_"}], 
         "]"}], ":=", 
        RowBox[{"pbs", "[", 
         RowBox[{"number", ",", 
          RowBox[{"prod", "[", 
           RowBox[{"x", ",", "y"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"x_", ",", 
          RowBox[{"pbs", "[", 
           RowBox[{
            RowBox[{"number_", "?", "scQ"}], ",", "y_"}], "]"}]}], "]"}], ":=", 
        RowBox[{"pbs", "[", 
         RowBox[{"number", ",", 
          RowBox[{"prod", "[", 
           RowBox[{"x", ",", "y"}], "]"}]}], "]"}]}], ";"}], 
      "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeLinearProduct", "[", 
      RowBox[{"prod_", ",", "False", ",", "scQ_", ",", "pbs_", ",", "Right"}],
       "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{
          RowBox[{"pbs", "[", 
           RowBox[{"x_", ",", 
            RowBox[{"number_", "?", "scQ"}]}], "]"}], ",", "y_"}], "]"}], ":=", 
        RowBox[{"pbs", "[", 
         RowBox[{
          RowBox[{"prod", "[", 
           RowBox[{"x", ",", "y"}], "]"}], ",", "number"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prod", "[", 
         RowBox[{"x_", ",", 
          RowBox[{"pbs", "[", 
           RowBox[{"y_", ",", 
            RowBox[{"number_", "?", "scQ"}]}], "]"}]}], "]"}], ":=", 
        RowBox[{"pbs", "[", 
         RowBox[{
          RowBox[{"prod", "[", 
           RowBox[{"x", ",", "y"}], "]"}], ",", "number"}], "]"}]}], ";"}], 
      "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeLinearProduct", "[", 
      RowBox[{"prod_", ",", "asQ_", ",", "scQ_", ",", "pbs_", ",", "All"}], 
      "]"}], ":=", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MakeLinearProduct", "[", 
        RowBox[{"prod", ",", "asQ", ",", "scQ", ",", "pbs", ",", "Left"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"MakeLinearProduct", "[", 
        RowBox[{"prod", ",", "asQ", ",", "scQ", ",", "pbs", ",", "Right"}], 
        "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bac62b8e-2ab7-45d0-8746-103d2f0fabb8"],

Cell["Undefinition:", \
"Text",ExpressionUUID->"eabbdabb-1f2a-49cb-9ff2-910f66a20433"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefProduct"}]], \
"Input",ExpressionUUID->"7146484b-2f0f-4f7c-acd4-3645e43df760"],

Cell[BoxData[
 StyleBox["\<\"UndefProduct[prod] undefines the product prod.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672363-5338953",ExpressionUUID->"9a445ed4-bbcf-45ec-b804-\
d9bdb3cc600f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefProduct", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "ProductQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefProduct", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefProduct", "[", "prod_Symbol", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"servants", "=", 
        RowBox[{"ServantsOf", "[", "prod", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"ProductQ", "[", "prod", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefInertHead", "::", "unknown"}], ",", 
            "\"\<product\>\"", ",", "prod"}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "prod", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefProduct", ",", "\"\<Beginning\>\"", ",", "prod"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "prod", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "prod", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$Products", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$Products", ",", "prod"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefProduct", ",", "\"\<End\>\"", ",", "prod"}], "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"MakeUndefInfo", "[", 
        RowBox[{"UndefProduct", ",", "prod"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{"$MathematicaProductSymbols", ",", "prod"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Clear", "[", "prod", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"RemoveSymbol", "[", "prod", "]"}]}], "\[IndentingNewLine]", 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefProduct", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefProduct", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c70d94ba-adba-4f3c-8503-097f4aac0036"],

Cell["\<\
Identification of scalars of the product (elements of the ring of scalars of \
the algebra associated to the product):\
\>", "Text",ExpressionUUID->"950b0d74-f213-4f4e-8ccc-f492b33a2941"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ScalarsOfProduct", "[", "prod_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ScalarsOfProduct", "::", "unknown"}], ",", "\"\<product\>\"", 
      ",", "prod"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ScalarsOfProduct", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ScalarsOfProduct", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ac937041-a4bb-4eb3-a1d2-830e7d045196"],

Cell["\<\
This allows a product by scalars other than Times. This is an experimental \
feature. Note that here we are referring only to the product of an element of \
the algebra by a scalar, and not to the product of two scalars. The fact that \
Times is used for both purposes is a standard overloading of Times.\
\>", "Text",ExpressionUUID->"500cc6f2-0dd1-4dd6-a8d8-d3f3a757c8af"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ProductByScalar", "[", "prod_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ProductByScalar", "::", "unknown"}], ",", "\"\<product\>\"", 
      ",", "prod"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ProductByScalar", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ProductByScalar", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e2e7d603-4a28-487f-94b9-df128ee633c7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GradedProductQ", "[", "prod_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"GradedProductQ", "::", "unknown"}], ",", "\"\<product\>\"", 
      ",", "prod"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"GradedProductQ", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "GradedProductQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"355ef55f-8b09-497e-bd5d-761265e05c82"],

Cell["\<\
We consider only the case in which there are both left and right neutral \
elements. Then the theory says that they must be unique and equal (consider \
the element prod[leftne, rightne]; it is obviously equal to both leftne and \
rightne).\
\>", "Text",ExpressionUUID->"f4c3c764-8217-42be-a53f-6b8e3bd5719b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IdentityElementOfProduct", "[", "prod_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"IdentityElementOfProduct", "::", "unknown"}], ",", 
      "\"\<product\>\"", ",", "prod"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IdentityElementOfProduct", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IdentityElementOfProduct", "]"}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"6da71d11-db3b-4801-bf5b-b867d2c4b69f"],

Cell["Commutativity properties:", \
"Text",ExpressionUUID->"643b19b1-8723-4680-beab-9b51f3602f3d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CommutativityOfProduct", "[", "prod_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CommutativityOfProduct", "::", "unknown"}], ",", 
      "\"\<product\>\"", ",", "prod"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"CommutativityOfProduct", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "CommutativityOfProduct", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c97f2002-6421-4556-9de5-f5b3c2744ca3"],

Cell["\<\
\[OpenCurlyDoubleQuote]SuperCommutative\[CloseCurlyDoubleQuote] is defined as \
follows:

\tprod[a, b] \[Equal] (-1)^(Grade[a,prod] Grade[b,prod]) prod[b, a]

\[OpenCurlyDoubleQuote]SuperAnticommutative\[CloseCurlyDoubleQuote]:

\tbracket[a, b] \[Equal] -(-1)^(Grade[a,prod] Grade[b,prod]) bracket[b, a]

{\[OpenCurlyDoubleQuote]Super(Anti)Commutative\[CloseCurlyDoubleQuote], p} \
for the generalized case:

\tprod[a, b] \[Equal] s (-1)^((Grade[a,prod]-p) (Grade[b,prod]-p)) prod[b, a]\
\
\>", "Text",ExpressionUUID->"729411fd-4695-42d4-837e-566bfcb26b15"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Compute", " ", "flipping", " ", "signs", " ", "for", " ", "the", " ", 
    "various", " ", "possibilities"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySign", "[", 
       RowBox[{"prod_", ",", 
        RowBox[{"sym", ":", 
         RowBox[{"(", 
          RowBox[{"_String", "|", "_List"}], ")"}]}]}], "]"}], "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod", ",", "sym"}], "]"}], "[", 
      RowBox[{
       RowBox[{"Grade", "[", 
        RowBox[{"x", ",", "prod"}], "]"}], ",", 
       RowBox[{"Grade", "[", 
        RowBox[{"y", ",", "prod"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySign", "[", 
       RowBox[{"prod_", ",", "f_"}], "]"}], "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"f", "[", 
      RowBox[{"x", ",", "y"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Formulas", " ", "based", " ", "on", " ", "grades", " ", "only"}],
     " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", "\"\<Commutative\>\""}], "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", "1"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", "\"\<Anticommutative\>\""}], "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", "\"\<SuperCommutative\>\""}], "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"gx", " ", "gy"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", "\"\<SuperAnticommutative\>\""}], "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"gx", " ", "gy"}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", 
        RowBox[{"{", 
         RowBox[{"\"\<SuperCommutative\>\"", ",", "p_Integer"}], "}"}]}], 
       "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"gx", "-", "p"}], ")"}], 
        RowBox[{"(", 
         RowBox[{"gy", "-", "p"}], ")"}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", 
        RowBox[{"{", 
         RowBox[{"\"\<SuperAnticommutative\>\"", ",", "p_Integer"}], "}"}]}], 
       "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"gx", "-", "p"}], ")"}], 
         RowBox[{"(", 
          RowBox[{"gy", "-", "p"}], ")"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CommutativitySignGrade", "[", 
       RowBox[{"prod_", ",", "com_"}], "]"}], "[", 
      RowBox[{"gx_", ",", "gy_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"prod", "::", "error1"}], ",", 
        "\"\<xTensor not yet ready to handle symmetry \>\"", ",", "com"}], 
       "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fc4a421f-0740-4bea-ae8a-70611c75c613"],

Cell["\<\
We always write specific rules for Times, but we include Times in the \
framework of products. We consider it associated to a nongraded algebra:\
\>", "Text",ExpressionUUID->"0be818b1-0b1b-4386-a3c3-4b1e4eca5acc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Times", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ProductQ", "[", "Times", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AssociativeProductQ", "[", "Times", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CommutativityOfProduct", "[", "Times", "]"}], "^=", 
   "\"\<Commutative\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IdentityElementOfProduct", "[", "Times", "]"}], "^=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GradedProductQ", "[", "Times", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ProductByScalar", "[", "Times", "]"}], "^=", "Times"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Times", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9d0de09d-58ec-4029-bb15-98a4b7d2dc82"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1.5. Commutators and anticommutators. Associator", \
"Subsubsection",ExpressionUUID->"e81b96fd-52b4-4a1a-b984-a3a414c9f0c8"],

Cell["\<\
For every product prod it is possible to define a Commutator[prod][a_, b_] := \
prod[a,b]-prod[b,a]. Then we have:

Com[Com[a,b],c] + Com[Com[b,c],a] + Com[Com[c,a],b] = Com[a,b]**c - \
c**Com[a,b] + Com[b,c]**a -a**Com[b,c] + Com[c,a]**b - b**Com[c,a] =
\t= (a**b - b**a)**c - c**(a**b - b**a) + (b**c - c**b)**a - a**(b**c - c**b) \
+ (c**a - a**c)**b - b**(c**a - a**c) =
\t= (a**b)**c - a**(b**c) - (b**a)**c + b**(a**c) + (b**c)**a - b**(c**a) - \
(c**b)**a + c**(b**a) - (a**c)**b + a**(c**b) + (c**a)**b - c**(a**b)
\t
which is zero for an associative product. Hence the commutator of an \
associative product obeys the Jacobi identity. Commutator[prod] is another \
product.

TODO: What is the relation between these commutators and Bracket?\
\>", "Text",ExpressionUUID->"a1556080-c26a-4ef8-bf61-4df0789e9203"],

Cell["\<\
Jose. We should merge this MakeDistributiveProduct with the previous one.\
\>", "Text",ExpressionUUID->"9882691c-5850-4405-a9dc-c32b8b183f54"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"This", " ", "is", " ", "a", " ", "modified", " ", "version"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"MakeDistributiveProduct", "[", 
     RowBox[{"prodL_", ",", "prodR_", ",", "True", ",", "zero_"}], "]"}], ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"prodL", "[", 
        RowBox[{"left___", ",", "zero", ",", "right___"}], "]"}], ":=", 
       "zero"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"prodL", "[", 
        RowBox[{"left___", ",", "sum_Plus", ",", "right___"}], "]"}], ":=", 
       RowBox[{
        RowBox[{
         RowBox[{"prodR", "[", 
          RowBox[{"left", ",", "#", ",", "right"}], "]"}], "&"}], "/@", 
        "sum"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"This", " ", "is", " ", 
        RowBox[{"incorrect", ".", " ", "It"}], " ", "needs", " ", "a", " ", 
        "generalization", " ", "of", " ", "SeriesDataMap"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"prodL", "[", 
        RowBox[{"left___", ",", "sum_SeriesData", ",", "right___"}], "]"}], ":=", 
       RowBox[{"SeriesDataMap", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"prodR", "[", 
           RowBox[{"left", ",", "#", ",", "right"}], "]"}], "&"}], ",", 
         "sum"}], "]"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4ef87a0b-7c02-450f-ae49-42475b3723b6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DeclareCommutator", "[", 
    RowBox[{"commutator_", ",", "commutativity_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"ProductQ", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", 
      RowBox[{"ProductQ", "[", "prod", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ScalarsOfProduct", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", 
      RowBox[{"ScalarsOfProduct", "[", "prod", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ProductByScalar", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", 
      RowBox[{"ProductByScalar", "[", "prod", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CommutativityOfProduct", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", 
      "commutativity"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"AssociativeProductQ", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", "False"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"IdentityElementOfProduct", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", "None"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Commutator", " ", "inherits", " ", "gradation", " ", "from", " ", 
       "prod"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"GradedProductQ", "[", 
       RowBox[{"commutator", "[", "prod_", "]"}], "]"}], "^:=", 
      RowBox[{"GradedProductQ", "[", "prod", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"MakeDistributiveProduct", "[", 
      RowBox[{
       RowBox[{"commutator", "[", "prod_", "]"}], ",", 
       RowBox[{"commutator", "[", "prod", "]"}], ",", "True", ",", "0"}], 
      "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareCommutator", "[", 
   RowBox[{"Commutator", ",", "\"\<Anticommutative\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareCommutator", "[", 
   RowBox[{"Anticommutator", ",", "\"\<Commutative\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareCommutator", "[", 
   RowBox[{"Supercommutator", ",", "\"\<SuperAnticommutative\>\""}], "]"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"686c618f-0e89-4e71-a6b3-bcc40feaa318"],

Cell["TODO: Make the Poisson identity automatic.", \
"Text",ExpressionUUID->"f23d97bd-2ee2-4029-bec3-6562df6c01af"],

Cell["\<\
[Leo: Question: Should we set by default
  Grade[expr_,Commutator[prod_]]:= Grade[expr,prod]
and similarly for Anticommutator, Supercommutator? ]\
\>", "Text",ExpressionUUID->"b3e9d089-9ee8-4d55-bafb-52b004906bc1"],

Cell["\<\
Commutator cannot be protected, because most definitions will be loaded on \
it, due to prod being too deep.\
\>", "Text",ExpressionUUID->"0c8dd30a-31b8-4588-82b1-d8a1139fd632"],

Cell["Formatting:", \
"Text",ExpressionUUID->"5bef9881-5668-4cb9-8ad1-d9926b1279f4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Commutator", "[", "prod_", "]"}], "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
   RowBox[{"interpretbox", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Commutator", "[", "prod", "]"}], "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", 
     RowBox[{"SubscriptBox", "[", 
      RowBox[{
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<[\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"a", ",", "StandardForm"}], "]"}], ",", "\"\<,\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"b", ",", "StandardForm"}], "]"}], ",", "\"\<]\>\""}], 
         "}"}], "]"}], ",", 
       RowBox[{"PrintAs", "[", "prod", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Anticommutator", "[", "prod_", "]"}], "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
   RowBox[{"interpretbox", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Anticommutator", "[", "prod", "]"}], "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", 
     RowBox[{"SubscriptBox", "[", 
      RowBox[{
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<{\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"a", ",", "StandardForm"}], "]"}], ",", "\"\<,\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"b", ",", "StandardForm"}], "]"}], ",", "\"\<}\>\""}], 
         "}"}], "]"}], ",", 
       RowBox[{"PrintAs", "[", "prod", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Supercommutator", "[", "prod_", "]"}], "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
   RowBox[{"interpretbox", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Supercommutator", "[", "prod", "]"}], "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", 
     RowBox[{"SubscriptBox", "[", 
      RowBox[{
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<\[LeftDoubleBracket]\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"a", ",", "StandardForm"}], "]"}], ",", "\"\<,\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"b", ",", "StandardForm"}], "]"}], ",", 
          "\"\<\[RightDoubleBracket]\>\""}], "}"}], "]"}], ",", 
       RowBox[{"PrintAs", "[", "prod", "]"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d4fc57ba-b897-4a9a-bac7-ee909530f8cf"],

Cell["Expanding a (anti,super)commutator", \
"Text",ExpressionUUID->"32e4c5a3-6ca6-486a-83eb-e57bebc78640"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ExpandCommutatorRule", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Commutator", "[", "prod_", "]"}], "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"prod", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "-", 
      RowBox[{"prod", "[", 
       RowBox[{"b", ",", "a"}], "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ExpandAnticommutatorRule", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Anticommutator", "[", "prod_", "]"}], "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"prod", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"prod", "[", 
       RowBox[{"b", ",", "a"}], "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ExpandSupercommutatorRule", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Supercommutator", "[", "prod_", "]"}], "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"prod", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "-", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Grade", "[", 
           RowBox[{"a", ",", "prod"}], "]"}], 
          RowBox[{"Grade", "[", 
           RowBox[{"b", ",", "prod"}], "]"}]}], ")"}]}], 
       RowBox[{"prod", "[", 
        RowBox[{"b", ",", "a"}], "]"}]}]}]}], "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cef8c812-fa73-4bcb-aed0-a0f47f14aaae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandCommutator", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"Join", "[", 
     RowBox[{
     "ExpandCommutatorRule", ",", "ExpandAnticommutatorRule", ",", 
      "ExpandSupercommutatorRule"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e6821359-f10f-4731-848a-a97d53b93e96"],

Cell["\<\
[Leo: Currently there is no automatic Poisson identity for any of the above \
over an associative algebra, i.e. we should expect
  [a,bc] = [a,b]c + b[a,c]
and related identities for the others. This might be nice.]\
\>", "Text",ExpressionUUID->"c4136900-07e9-4f9f-96eb-9afe149b7451"],

Cell["TODO: Associator.", \
"Text",ExpressionUUID->"4c543024-a759-464e-a5f6-a4d5f698c5ad"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.1.6. Grades", \
"Subsubsection",ExpressionUUID->"a1531710-12be-4b5e-a61a-df095b9fcb52"],

Cell[TextData[{
 "Products can be graded or not (even in the nonassociative case [",
 ButtonBox["article",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://link.springer.com/chapter/10.1007%2F978-94-011-0990-1_42"], 
    None},
  ButtonNote->
   "http://link.springer.com/chapter/10.1007%2F978-94-011-0990-1_42"],
 "]). Grades are computed using a function Grade[expr, prod] that returns an \
integer grade for the expression in the algebra associated to prod. We might \
want to extend this to filtered algebras. We want to prepare the arena to \
deal with general algebras, as AVF does.\n\nIn principle we assume that \
grades are integer (possibly negative) numbers, though nowhere we make use of \
that.\n\nBy default Grade assigns 0 grade to everything not a sum.\n\nGrades \
behave very much like density weights. We could perhaps use the same idea of \
\[OpenCurlyDoubleQuote]an integer linear combination of product\
\[CloseCurlyDoubleQuote]. It seems less natural here, because there are no \
\[OpenCurlyDoubleQuote]changes of product\[CloseCurlyDoubleQuote]. That\
\[CloseCurlyQuote]s why use use Grade[expr, prod1] = 2, Grade[expr, prod2] = \
3, instead of Grade[expr] =2 prod1 + 3 prod2."
}], "Text",ExpressionUUID->"d7bf64bb-8f7e-4098-b211-09e4507216f4"],

Cell["\<\
1) Computation of the grade of a sum must be uniquely defined. This does not \
mean that we do not accept sums of objects of different grades. It means that \
the code must have known what to do with that sum before computing the sum \
grade.\
\>", "Text",ExpressionUUID->"cc7c4ee2-49a2-4350-8c3a-8f2a7d063229"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkLengthOneGrade", "[", 
    RowBox[{"{", "x_", "}"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkLengthOneGrade", "[", 
    RowBox[{"x", ":", 
     RowBox[{"{", 
      RowBox[{"_", ",", "__"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Validate", "::", "inhom"}], ",", "\"\<grades\>\"", ",", 
      RowBox[{"ToString", "[", "x", "]"}]}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4999b836-6fc9-4b89-9e64-0bdbfa4c4668"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Grade", "[", 
    RowBox[{"sum_Plus", ",", 
     RowBox[{"prod_Symbol", "?", "ProductQ"}]}], "]"}], ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"glist", "=", 
       RowBox[{"Union", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Grade", "[", 
           RowBox[{"#", ",", "prod"}], "]"}], "&"}], "/@", 
         RowBox[{"List", "@@", "sum"}]}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"checkLengthOneGrade", "[", "glist", "]"}], ",", 
       RowBox[{"First", "[", "glist", "]"}]}], "]"}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a1fb1adf-0bba-43a0-8e28-ec1df439eb38"],

Cell["\<\
2) The grade of a product in a different product must be manually specified \
by the user. Recall that GradeOfProduct[prod, prod] is set to an integer by \
DefProduct for a graded product, with default 0.\
\>", "Text",ExpressionUUID->"89e30dbe-0596-4e13-b948-c261d74ddb57"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Grade", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"prod1_", "?", "ProductQ"}], "[", "factors___", "]"}], ",", 
     RowBox[{"prod2_Symbol", "?", "ProductQ"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ppgrade", "=", 
       RowBox[{"GradeOfProduct", "[", 
        RowBox[{"prod1", ",", "prod2"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Grade", "[", 
            RowBox[{"#", ",", "prod2"}], "]"}], "&"}], "/@", 
          RowBox[{"{", "factors", "}"}]}]}], "]"}], "+", "ppgrade"}], "/;", 
      RowBox[{"IntegerQ", "[", "ppgrade", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"GradeOfProduct", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "GradeOfProduct", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4cd534a6-1e7c-493c-af6a-7e00ecab2331"],

Cell["3) Elementary expressions:", \
"Text",ExpressionUUID->"545fa6f4-0253-4a6e-8196-3d8ea3d7f775"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Definitions", " ", "for", " ", 
    RowBox[{"Grade", ".", " ", "Check"}], " ", "that", " ", "the", " ", 
    "product", " ", "is", " ", "graded"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{"c_", "?", "ConstantQ"}], ",", 
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{"p_", "?", "ParameterQ"}], ",", 
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", 
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", 
     RowBox[{"Grade", "[", 
      RowBox[{"expr", ",", "prod"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"GradeOfTensor", "[", 
       RowBox[{"tensor", ",", "prod"}], "]"}], "+", 
      RowBox[{"Plus", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"GradeOfIndex", "[", 
           RowBox[{"#", ",", "prod"}], "]"}], "&"}], "/@", 
         RowBox[{"{", "inds", "}"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "?", "FirstDerQ"}], "[", "expr_", "]"}], ",", 
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Grade", "[", 
       RowBox[{"expr", ",", "prod"}], "]"}], "+", 
      RowBox[{"GradeOfDer", "[", 
       RowBox[{"der", ",", "prod"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "::", "sfg0"}], "=", 
     "\"\<Arguments `1` of scalar function `2` must all have grade 0, but \
have `3` instead.\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{"sf", ":", 
        RowBox[{
         RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}]}], ",", 
       
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"glist", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Grade", "[", 
            RowBox[{"#", ",", "prod"}], "]"}], "&"}], "/@", 
          RowBox[{"{", "args", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Union", "[", "glist", "]"}], "===", 
          RowBox[{"{", "0", "}"}]}], ",", "\[IndentingNewLine]", "0", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"Grade", "::", "sfg0"}], ",", 
            RowBox[{"{", "args", "}"}], ",", "sf", ",", "glist"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Grades", " ", "of", " ", "inert"}], "-", 
     RowBox[{
     "head", " ", "expressions", " ", "must", " ", "be", " ", "provided", " ",
       "by", " ", "the", " ", "user"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{
       RowBox[{"ih", ":", 
        RowBox[{
         RowBox[{"_", "?", "InertHeadQ"}], "[", "__", "]"}]}], ",", 
       RowBox[{"prod_", "?", "GradedProductQ"}]}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Grade", "::", "unknown"}], ",", 
        "\"\<grade of inert-head expression\>\"", ",", "ih"}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Default", ":", " ", 
     RowBox[{
      RowBox[{"grades", " ", "for", " ", "non"}], "-", 
      RowBox[{
      "graded", " ", "products", " ", "are", " ", "defined", " ", "as", " ", 
       "0"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"prod_", "?", "ProductQ"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Grade", "[", 
      RowBox[{"expr_", ",", "prod_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Grade", "::", "unknown"}], ",", "\"\<product\>\"", ",", 
        "prod"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Secondary", " ", 
     RowBox[{"definitions", ".", " ", "We"}], " ", "have", " ", "already", 
     " ", "checked", " ", "that", " ", "the", " ", "product", " ", "is", " ", 
     "graded"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfTensor", "[", 
      RowBox[{
       RowBox[{"TensorDerivative", "[", 
        RowBox[{"tensor_", ",", "ders__"}], "]"}], ",", "prod_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"GradeOfTensor", "[", 
       RowBox[{"tensor", ",", "prod"}], "]"}], "+", 
      RowBox[{"Plus", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"GradeOfDer", "[", 
           RowBox[{"#", ",", "prod"}], "]"}], "&"}], "/@", 
         RowBox[{"{", "ders", "}"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfTensor", "[", 
      RowBox[{
       RowBox[{"Bracket", "[", 
        RowBox[{"v1_", ",", "v2_"}], "]"}], ",", "prod_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Grade", "[", 
       RowBox[{"v1", ",", "prod"}], "]"}], "+", 
      RowBox[{"Grade", "[", 
       RowBox[{"v2", ",", "prod"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfDer", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], ",", "prod_"}],
       "]"}], ":=", 
     RowBox[{
      RowBox[{"GradeOfCovD", "[", 
       RowBox[{"covd", ",", "prod"}], "]"}], "+", 
      RowBox[{"Plus", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"GradeOfIndex", "[", 
           RowBox[{"#", ",", "prod"}], "]"}], "&"}], "/@", 
         RowBox[{"{", "inds", "}"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfDer", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v_", "]"}], ",", "prod_"}], "]"}], ":=", 
     RowBox[{"Grade", "[", 
      RowBox[{"v", ",", "prod"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfIndex", "[", 
      RowBox[{
       RowBox[{"Dir", "[", "v_", "]"}], ",", "prod_"}], "]"}], ":=", 
     RowBox[{"Grade", "[", 
      RowBox[{"v", ",", "prod"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfIndex", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i_", ",", "basis_"}], "}"}], ",", "prod_"}], "]"}], ":=", 
     RowBox[{"GradeOfBIndex", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "basis"}], "}"}], ",", "prod"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Zero", " ", "defaults", " ", "for", " ", "the", " ", "secondary", " ", 
     "definitions"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfTensor", "[", 
      RowBox[{"tensor_", ",", "prod_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfDer", "[", 
      RowBox[{"der_", ",", "prod_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfCovD", "[", 
      RowBox[{"covd_", ",", "prod_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfIndex", "[", 
      RowBox[{"i_", ",", "prod_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradeOfBIndex", "[", 
      RowBox[{"bi_", ",", "prod_"}], "]"}], ":=", "0"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b56a3263-b3af-4c29-8863-209296b9c13a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Grade", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Grade", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"22113ec7-2405-42f2-9360-a62fdb6d0abb"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"1b3c193b-b7f6-4276-af12-f5b930b2477f"],

Cell[TextData[{
 "A ",
 ButtonBox["Gerstenhaber",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://en.wikipedia.org/wiki/Gerstenhaber_algebra"], None},
  ButtonNote->"http://en.wikipedia.org/wiki/Gerstenhaber_algebra"],
 " algebra has two products: pr and br"
}], "Text",ExpressionUUID->"04b10f68-28dd-420b-a8d8-767e8ff3c21b"],

Cell["\<\
The pr product is associative and multilinear, with neutral element 1 and \
zero element 0. It has a \[DoubleStruckCapitalZ]-grade in which the product \
has grade 0. It is supercommutative, which I interpret as antisymmetric \
(using Grade[#, pr]):\
\>", "Text",ExpressionUUID->"e3048946-8a4a-4ece-80f0-0aa44bd67b11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefProduct", "[", 
  RowBox[{"pr", ",", 
   RowBox[{
   "CommutativityOfProduct", "\[Rule]", "\"\<SuperCommutative\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"aef6c89c-4810-4b2c-9a6d-1f19519a0a8b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefProduct", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"product \"\>", "\[InvisibleSpace]", "pr", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefProduct, ": Defining ", "product ", $CellContext`pr, 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5381d174-bba1-4f63-b0b9-605c7abbb75d"]
}, Open  ]],

Cell["\<\
The br product is a bracket (not associative, but still bilinear) with no \
neutral element and zero element 0. It has pr-grade -1:\
\>", "Text",ExpressionUUID->"7361cc71-1e26-4a5b-8225-a60214a1458e"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefProduct", "[", 
   RowBox[{"br", ",", 
    RowBox[{"AssociativeProductQ", "\[Rule]", "False"}], ",", 
    RowBox[{"IdentityElementOfProduct", "\[Rule]", "None"}], ",", 
    RowBox[{"CommutativityOfProduct", "\[Rule]", "\"\<Anticommutative\>\""}], 
    ",", 
    RowBox[{"GradeOfProduct", "\[Rule]", 
     RowBox[{"-", "1"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Unprotect", "[", "br", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"br", "/:", 
   RowBox[{"GradeOfProduct", "[", 
    RowBox[{"br", ",", "pr"}], "]"}], "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "br", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"8c487b0c-fd46-44a4-a887-03f5eaf84eb6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefProduct", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"product \"\>", "\[InvisibleSpace]", "br", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefProduct, ": Defining ", "product ", $CellContext`br, 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"29197a5a-c7ba-436f-a0c7-6aa671ee1774"]
}, Open  ]],

Cell["\<\
Poisson identity in the Gerstenhaber algebra:

\tbr[ a, pr[b, c] ] == pr[ br[a, b], c ] + (-1)^( (Grade[a, pr]-1) Grade[b, \
pr] ) pr[ b, br[a, c] ]

In a Poisson superalgebra it would be instead:

\tbr[ a, pr[b, c] ] == pr[ br[a, b], c ] + (-1)^( Grade[a, pr] Grade[b, pr] ) \
pr[ b, br[a, c] ]

Unrelated to that, there is a concept of \
\[OpenCurlyDoubleQuote]supercommutator\[CloseCurlyDoubleQuote]:

\tbr[ a, b ] := pr[ a, b ] - (-1)^( Grade[a, pr] Grade[b, pr] ) pr[ b, a ]

and the previous concept of \[OpenCurlyDoubleQuote]supercommutation\
\[CloseCurlyDoubleQuote] comes from the vanishing of this. In the context of \
superalgebras sometimes it is understood that the grade can only be 0 or 1.\
\>", "Text",ExpressionUUID->"e6b08065-2ee0-42ad-9beb-e0628a902a88"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"UndefProduct", "[", "br", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UndefProduct", "[", "pr", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"1022a63a-d9bf-481a-bde3-2523b4122317"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefProduct", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"product\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "br"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefProduct, ": Undefined ", "product", 
   " ", $CellContext`br],
  Editable->
   False]], "Print",ExpressionUUID->"7aebc3d9-a3d8-4334-b346-176fdc2a0383"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefProduct", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"product\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "pr"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefProduct, ": Undefined ", "product", 
   " ", $CellContext`pr],
  Editable->
   False]], "Print",ExpressionUUID->"ea47601b-f02d-4edb-9cee-baf62cbc7773"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"52cbe630-76c8-4ce1-a26a-975692762d64"]
}, Closed]],

Cell[CellGroupData[{

Cell["TODISCUSS", \
"Subsubsection",ExpressionUUID->"803ca551-d6c2-4b20-9b2a-26981067189c"],

Cell["\<\
1) Is is better to ask for a function detecting scalars or detecting algebra \
elements? Is there any simple relation between those two?\
\>", "Text",ExpressionUUID->"5a0bf169-5c5f-424f-8fa6-2445a3001641"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
4.1.7. An antisymmetric product. OLD and INCOMPLETE. Not in the package\
\>", "Subsubsection",ExpressionUUID->"be01ff58-691a-42cc-8186-ccbf6c3137a3"],

Cell["1) Use the attributes of a product:", \
"Text",ExpressionUUID->"79cdd885-2d34-4afb-a730-1199231e949f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "Times", 
  "]"}]], "Input",ExpressionUUID->"66d6d2f5-3712-43c9-9f86-14d4e45ee0ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Flat", ",", "Listable", ",", "NumericFunction", ",", "OneIdentity", ",", 
   "Orderless", ",", "Protected"}], 
  "}"}]], "Output",ExpressionUUID->"0dfc0e08-9c24-45f3-a493-72b205e64598"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Wedge", ",", 
   RowBox[{"{", 
    RowBox[{"Flat", ",", "Listable", ",", "OneIdentity"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ba109000-87b6-4bcb-80d2-4863efd0eb8e"],

Cell["\<\
Very annoyingly, the OneIdentity attribute does not include this:\
\>", "Text",ExpressionUUID->"f4562ead-2a79-4599-bc37-56605fb20dc1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Wedge", "[", "x", 
  "]"}]], "Input",ExpressionUUID->"7478d0ec-83b9-4b1c-ba48-de6eaa1f84ad"],

Cell[BoxData[
 RowBox[{"Wedge", "[", "x", 
  "]"}]], "Output",ExpressionUUID->"c8977999-63d8-4972-b72a-14c55d621c68"]
}, Open  ]],

Cell["\<\
So we add it. Note that we need to use Verbatim to avoid infinite iteration. \
Really bad:\
\>", "Text",ExpressionUUID->"ee154246-cf20-48a3-abe8-1c016bd0f72a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Verbatim", "[", "Wedge", "]"}], "[", "x_", "]"}], ":=", 
  "x"}]], "Input",ExpressionUUID->"82afbd63-066f-484a-8ffa-0f4146e24e01"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Wedge", "[", "x", 
  "]"}]], "Input",ExpressionUUID->"f861a805-4ecb-4c8b-bcbb-52c5c3f8d2b4"],

Cell[BoxData["x"], \
"Output",ExpressionUUID->"c8200177-9ed6-42a9-a986-7ab5d6395187"]
}, Open  ]],

Cell["\<\
We could declare this to be 1, but in principle we should not need it:\
\>", "Text",ExpressionUUID->"be127f02-de6f-4a29-8e30-24e0acc5ec98"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Wedge", "[", 
  "]"}]], "Input",ExpressionUUID->"10ca71d9-8cd7-4344-a77f-94f4cb6d45dc"],

Cell[BoxData[
 RowBox[{"Wedge", "[", 
  "]"}]], "Output",ExpressionUUID->"ee2a8cc1-becd-4cdd-8209-5f911af1c931"]
}, Open  ]],

Cell["\<\
We also add automatic distributivity, like an automatic Expand:\
\>", "Text",ExpressionUUID->"c930b3a8-6dd7-4f5d-af34-3119c9a3212e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Wedge", "[", 
    RowBox[{"x1___", ",", "x_Plus", ",", "x2___"}], "]"}], ":=", 
   RowBox[{"Distribute", "[", 
    RowBox[{"Unevaluated", "@", 
     RowBox[{"Wedge", "[", 
      RowBox[{"x1", ",", "x", ",", "x2"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Wedge", "[", 
    RowBox[{"x1___", ",", "x_SeriesData", ",", "x2___"}], "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Wedge", "[", 
       RowBox[{"x1", ",", "#", ",", "x2"}], "]"}], "&"}], ",", "x"}], "]"}]}],
   ";"}]}], "Input",ExpressionUUID->"f4a86d2c-163e-4ad6-8a82-3c6b168000b5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Wedge", "[", 
  RowBox[{
   RowBox[{"A", "+", "B"}], ",", "C", ",", 
   RowBox[{"D", "+", "F"}]}], 
  "]"}]], "Input",ExpressionUUID->"df14b0d9-d68e-409b-8560-da28aa1492ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"A", "\[Wedge]", "C", "\[Wedge]", "D"}], "+", 
  RowBox[{"A", "\[Wedge]", "C", "\[Wedge]", "F"}], "+", 
  RowBox[{"B", "\[Wedge]", "C", "\[Wedge]", "D"}], "+", 
  RowBox[{
  "B", "\[Wedge]", "C", "\[Wedge]", 
   "F"}]}]], "Output",ExpressionUUID->"005e5105-379f-4c05-a9c2-10467ab437ae"]
}, Open  ]],

Cell["\<\
2) Relation between Times and Wedge. We need a function detecting the \
Grasmann variables:\
\>", "Text",ExpressionUUID->"9d05a68c-e84c-4abf-b9ec-e63c2841e557"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "A", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "B", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "F", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "G", "]"}], "^=", "True"}], 
  ";"}]}], "Input",ExpressionUUID->"38fd7c5b-1a8e-4a76-972a-943a3a744b6c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "expr_Wedge", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"And", ",", 
     RowBox[{"GrassmannQ", "/@", 
      RowBox[{"List", "@@", "expr"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "expr_Times", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Or", ",", 
     RowBox[{"GrassmannQ", "/@", 
      RowBox[{"List", "@@", "expr"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"And", ",", 
     RowBox[{"GrassmannQ", "/@", 
      RowBox[{"List", "@@", "expr"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], "]"}], 
     "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Apply", "[", 
     RowBox[{"And", ",", 
      RowBox[{"GrassmannQ", "/@", "coeffs"}]}], "]"}], "&&", 
    RowBox[{"Not", "[", 
     RowBox[{"GrassmannQ", "[", "var", "]"}], "]"}], "&&", 
    RowBox[{"Not", "[", 
     RowBox[{"GrassmannQ", "[", "orig", "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrassmannQ", "[", "expr_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NotGrassmannQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"Not", "@", 
    RowBox[{"GrassmannQ", "[", "expr", "]"}]}]}], 
  ";"}]}], "Input",ExpressionUUID->"6263d71c-f6ea-4f5e-bb60-bb118c2e88cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Wedge", "[", 
    RowBox[{"x1___", ",", 
     RowBox[{
      RowBox[{"coeff_", "?", "NotGrassmannQ"}], " ", "expr_"}], ",", 
     "x2___"}], "]"}], ":=", 
   RowBox[{"coeff", " ", 
    RowBox[{"Wedge", "[", 
     RowBox[{"x1", ",", "expr", ",", "x2"}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"e1df8d29-71c0-4d02-add2-cb0b40280a89"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Wedge", "[", 
  RowBox[{
   RowBox[{"2", "B"}], ",", 
   RowBox[{"x", " ", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"6bf4d1b7-56c8-47d3-83e6-89c9f95b86e4"],

Cell[BoxData[
 RowBox[{"2", " ", "x", " ", 
  RowBox[{
  "B", "\[Wedge]", 
   "A"}]}]], "Output",ExpressionUUID->"07ccee39-0796-4be8-802d-6ca7bae87aed"]
}, Open  ]],

Cell["3) We could automate sorting with ", \
"Text",ExpressionUUID->"68a035d3-f3d0-4382-a1d1-35a550383230"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Wedge", "[", "exprs___", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sort", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{"{", "exprs", "}"}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Signature", "[", 
       RowBox[{"{", "exprs", "}"}], "]"}], 
      RowBox[{"Wedge", "@@", "sort"}]}], "/;", 
     RowBox[{"sort", "=!=", 
      RowBox[{"{", "exprs", "}"}]}]}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"535e96ef-6e62-42b0-b343-200dc132b9ae"],

Cell["\<\
but then we see that the resulting expression tries to sort itself again:\
\>", "Text",ExpressionUUID->"d4649a86-ec6b-4c99-8bb7-48de1d640e2d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Wedge", "[", 
   RowBox[{"B", ",", "A", ",", "C"}], "]"}], "//", "Trace"}]], "Input",
 Evaluatable->False,ExpressionUUID->"5a8f53bb-d196-4741-857f-e5988b16f37c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"B", "\[Wedge]", "A", "\[Wedge]", "C"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sort$", "=", 
          RowBox[{"Sort", "[", 
           RowBox[{"{", 
            RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}]}], "}"}], ",", 
        RowBox[{"RuleCondition", "[", 
         RowBox[{
          RowBox[{"$ConditionHold", "[", 
           RowBox[{"$ConditionHold", "[", 
            RowBox[{
             RowBox[{"Signature", "[", 
              RowBox[{"{", 
               RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}], " ", 
             RowBox[{"Wedge", "@@", "sort$"}]}], "]"}], "]"}], ",", 
          RowBox[{"sort$", "=!=", 
           RowBox[{"{", 
            RowBox[{"B", ",", "A", ",", "C"}], "}"}]}]}], "]"}]}], "]"}],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"Sort", "[", 
         RowBox[{"{", 
          RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"{", 
         RowBox[{"A", ",", "B", ",", "C"}], "}"}],
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"RuleCondition", "[", 
       RowBox[{
        RowBox[{"$ConditionHold", "[", 
         RowBox[{"$ConditionHold", "[", 
          RowBox[{
           RowBox[{"Signature", "[", 
            RowBox[{"{", 
             RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}], " ", 
           RowBox[{"Wedge", "@@", 
            RowBox[{"{", 
             RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}], "]"}], ",", 
        
        RowBox[{
         RowBox[{"{", 
          RowBox[{"A", ",", "B", ",", "C"}], "}"}], "=!=", 
         RowBox[{"{", 
          RowBox[{"B", ",", "A", ",", "C"}], "}"}]}]}], "]"}],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{
         RowBox[{"{", 
          RowBox[{"A", ",", "B", ",", "C"}], "}"}], "=!=", 
         RowBox[{"{", 
          RowBox[{"B", ",", "A", ",", "C"}], "}"}]}],
        HoldForm], ",", 
       TagBox["True",
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"RuleCondition", "[", 
       RowBox[{
        RowBox[{"$ConditionHold", "[", 
         RowBox[{"$ConditionHold", "[", 
          RowBox[{
           RowBox[{"Signature", "[", 
            RowBox[{"{", 
             RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}], " ", 
           RowBox[{"Wedge", "@@", 
            RowBox[{"{", 
             RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}], "]"}], ",", 
        "True"}], "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"$ConditionHold", "[", 
       RowBox[{"$ConditionHold", "[", 
        RowBox[{
         RowBox[{"Signature", "[", 
          RowBox[{"{", 
           RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}], " ", 
         RowBox[{"Wedge", "@@", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}], "]"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{
     RowBox[{"Signature", "[", 
      RowBox[{"{", 
       RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}], " ", 
     RowBox[{"Wedge", "@@", 
      RowBox[{"{", 
       RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"Signature", "[", 
       RowBox[{"{", 
        RowBox[{"B", ",", "A", ",", "C"}], "}"}], "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"-", "1"}],
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"Wedge", "@@", 
       RowBox[{"{", 
        RowBox[{"A", ",", "B", ",", "C"}], "}"}]}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"A", "\[Wedge]", "B", "\[Wedge]", "C"}],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"sort$", "=", 
            RowBox[{"Sort", "[", 
             RowBox[{"{", 
              RowBox[{"A", ",", "B", ",", "C"}], "}"}], "]"}]}], "}"}], ",", 
          RowBox[{"RuleCondition", "[", 
           RowBox[{
            RowBox[{"$ConditionHold", "[", 
             RowBox[{"$ConditionHold", "[", 
              RowBox[{
               RowBox[{"Signature", "[", 
                RowBox[{"{", 
                 RowBox[{"A", ",", "B", ",", "C"}], "}"}], "]"}], " ", 
               RowBox[{"Wedge", "@@", "sort$"}]}], "]"}], "]"}], ",", 
            RowBox[{"sort$", "=!=", 
             RowBox[{"{", 
              RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}]}], "]"}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Sort", "[", 
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C"}], "}"}], "]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"{", 
           RowBox[{"A", ",", "B", ",", "C"}], "}"}],
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"RuleCondition", "[", 
         RowBox[{
          RowBox[{"$ConditionHold", "[", 
           RowBox[{"$ConditionHold", "[", 
            RowBox[{
             RowBox[{"Signature", "[", 
              RowBox[{"{", 
               RowBox[{"A", ",", "B", ",", "C"}], "}"}], "]"}], " ", 
             RowBox[{"Wedge", "@@", 
              RowBox[{"{", 
               RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}], "]"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C"}], "}"}], "=!=", 
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C"}], "}"}], "=!=", 
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C"}], "}"}]}],
          HoldForm], ",", 
         TagBox["False",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"RuleCondition", "[", 
         RowBox[{
          RowBox[{"$ConditionHold", "[", 
           RowBox[{"$ConditionHold", "[", 
            RowBox[{
             RowBox[{"Signature", "[", 
              RowBox[{"{", 
               RowBox[{"A", ",", "B", ",", "C"}], "}"}], "]"}], " ", 
             RowBox[{"Wedge", "@@", 
              RowBox[{"{", 
               RowBox[{"A", ",", "B", ",", "C"}], "}"}]}]}], "]"}], "]"}], 
          ",", "False"}], "]"}],
        HoldForm], ",", 
       TagBox["Fail",
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"A", "\[Wedge]", "B", "\[Wedge]", "C"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{"A", "\[Wedge]", "B", "\[Wedge]", "C"}], ")"}]}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"1685e0f5-c7d4-4a8c-aa06-69a4f0ce72d8"]
}, Open  ]],

Cell["\<\
I think it is better to define a sorting function, to be used when required:\
\>", "Text",ExpressionUUID->"a19040bd-e1c8-4026-a455-942e71848d3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ASort", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"wedge_Wedge", "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"Signature", "[", "wedge", "]"}], 
      RowBox[{"Sort", "[", "wedge", "]"}]}]}]}]}], 
  ";"}]], "Input",ExpressionUUID->"d7d82f6a-c19f-4bf6-85c1-5662260766c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"3", 
   RowBox[{"Wedge", "[", 
    RowBox[{
     RowBox[{"2", "B"}], ",", 
     RowBox[{"y", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", " ", "A"}], "+", "F"}], ")"}]}]}], "]"}]}], "//", 
  "ASort"}]], "Input",ExpressionUUID->"36e70dc6-a926-4718-ae3a-e877b8b55ae9"],

Cell[BoxData[
 RowBox[{"6", " ", "y", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "x"}], " ", 
     RowBox[{"A", "\[Wedge]", "B"}]}], "+", 
    RowBox[{"B", "\[Wedge]", "F"}]}], 
   ")"}]}]], "Output",ExpressionUUID->"2fbe30bc-8224-4feb-b417-367544e7b78c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "Expand"}]], "Input",ExpressionUUID->"6acebbb7-0ac9-4ef2-81a7-c716a7063ed8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "6"}], " ", "x", " ", "y", " ", 
   RowBox[{"A", "\[Wedge]", "B"}]}], "+", 
  RowBox[{"6", " ", "y", " ", 
   RowBox[{
   "B", "\[Wedge]", 
    "F"}]}]}]], \
"Output",ExpressionUUID->"6b720e5e-0dca-43df-9d3e-3318194cadc2"]
}, Open  ]],

Cell["Repeated Grassmann objects give zero:", \
"Text",ExpressionUUID->"1bad95b0-7878-4ac4-862b-a94e523ee841"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Wedge", "[", 
   RowBox[{"A", ",", "B", ",", "A"}], "]"}], "//", 
  "ASort"}]], "Input",ExpressionUUID->"3129b31d-8a62-4855-a275-beebf362a292"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"54f43a04-a299-4bb2-a7e5-0ce26d7f6672"]
}, Open  ]],

Cell["\<\
We need a Rank function, following Alfonso\[CloseCurlyQuote]s ideas, instead \
of the GrassmannQ function. We also need some way to return zero for ranks \
beyond the dimension.\
\>", "Text",ExpressionUUID->"14e304c2-3466-4cca-afff-e4df84270a27"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4.2. Conventions", \
"Subsection",ExpressionUUID->"8fcff206-171c-457b-932c-4c8e91973c93"],

Cell[CellGroupData[{

Cell["4.2.1. Six signs", \
"Subsubsection",ExpressionUUID->"a9cd5e2d-e578-4ecf-8223-15c216c527f8"],

Cell["\<\
We follow the sign and index-position conventions of Wald's book. Note that \
in this notebook we unset those signs to check their position.\
\>", "Text",ExpressionUUID->"7e202342-b976-45a5-bb5a-c357d623d66e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefSign", "[", 
    RowBox[{"sign_", ",", "printas_", ",", "default_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"DefConstantSymbol", "[", 
      RowBox[{"sign", ",", 
       RowBox[{"PrintAs", "\[Rule]", "printas"}], ",", 
       RowBox[{"Validate", "\[Rule]", "False"}], ",", 
       RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
       RowBox[{"DefInfo", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sign", "/:", 
      RowBox[{"Power", "[", 
       RowBox[{"sign", ",", "n_Integer"}], "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"EvenQ", "[", "n", "]"}], ",", "1", ",", "sign"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"sign", "=", "default"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c2d7403a-c25e-4089-a815-e6b22ca0c8b4"],

Cell["1) $epsilonSign. Default value for epsilonOrientation.", \
"Text",ExpressionUUID->"f818f5c1-0cdc-4966-a8de-4c824ad7b6c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefSign", "[", 
  RowBox[{
  "$epsilonSign", ",", "\"\<\!\(\*SubscriptBox[\(s\), \(\[Epsilon]\)]\)\>\"", 
   ",", "1"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5c7c19fc-62f4-4f19-897b-22d2e66e5ead"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"7292f497-ffff-4dc3-8823-7f758fd4b688"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "epsilonSign"}]], \
"Input",ExpressionUUID->"4977f661-9230-4059-a4a3-2b1613420dfc"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"epsilonSign\\\"\\)\[NoBreak] not \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/notfound\\\", ButtonNote -> \
\\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c0bceddc-01f3-4a94-a587-9f1bba61f6e0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"$epsilonSign", 
  "=."}]], "Input",ExpressionUUID->"0d022a6d-2d69-4824-9325-07d36fb00e38"],

Cell["TODO: This seems wrongly documented now...", \
"Text",ExpressionUUID->"55df0ce2-57a8-4d8e-9721-7cde91c8c86f"],

Cell["\<\
2) Riemann[-a, -b, -c, d] = $RiemannSign ( PD[ -b ][ Gamma[d, -a, -c] ] + ... \
).\
\>", "Text",ExpressionUUID->"a0d9d408-a6ed-404d-babe-c11b19efa946"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefSign", "[", 
  RowBox[{
  "$RiemannSign", ",", "\"\<\!\(\*SubscriptBox[\(s\), \(R\)]\)\>\"", ",", 
   "1"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c7e7233d-e9ff-40dc-8a66-923e5268d27c"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"08e11d04-bc42-443a-857b-b1d6cd4f06dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$RiemannSign"}]], \
"Input",ExpressionUUID->"58435a5b-2e14-4e5e-97cb-0c194a5c14c9"],

Cell[BoxData[
 StyleBox["\<\"$RiemannSign defines the global sign of the Riemann tensor \
from derivatives of a connection: Riemann[-a,-b,-c,d] = $RiemannSign * ( \
PD[-b][Christoffel[d,-a,-c] + ...)\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672367-5338953",ExpressionUUID->"54f82588-2241-472b-a963-\
92be1a7f4ac8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"$RiemannSign", 
  "=."}]], "Input",ExpressionUUID->"728a3d3c-9d86-4352-8c56-e0b3b5ed386c"],

Cell["3) Ricci[-a, -b] = $RicciSign Riemann[c, -a, -c, -b]", \
"Text",ExpressionUUID->"cb69303a-c363-43e2-9a80-1bc679076194"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefSign", "[", 
  RowBox[{
  "$RicciSign", ",", "\"\<\!\(\*SubscriptBox[\(s\), \(r\)]\)\>\"", ",", "1"}],
   "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"aee33a59-db7d-4614-878a-535ecc50ada1"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"5c6f49bf-1e23-4907-8363-c223f873b768"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$RicciSign"}]], \
"Input",ExpressionUUID->"bb1b2d8f-1417-40f5-99c7-ead14a259c16"],

Cell[BoxData[
 StyleBox["\<\"$RicciSign defines the global sign of the Ricci tensor from \
contraction of the Riemann tensor: Ricci[-a,-b] = $RicciSign * \
Riemman[-a,-c,-b,c]\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672368-5338953",ExpressionUUID->"bb641d37-c85b-4294-a1c2-\
8fa066eb84a4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$RicciSign", "=", "1"}], 
  ";"}]], "Input",ExpressionUUID->"2965f9d2-3736-47d3-97c6-d1abb98d728e"],

Cell[BoxData[
 RowBox[{"$RicciSign", 
  "=."}]], "Input",ExpressionUUID->"cac09fb8-9128-4965-8f3b-28262292fe8e"],

Cell["No conventions required here:", \
"Text",ExpressionUUID->"6876649d-bacf-4a46-a3a5-ee2344da4be7"],

Cell["\tRicciScalar[] = Invg[a, b] Ricci[-a, -b]", \
"Text",ExpressionUUID->"31e1b687-1f50-4f70-9cdc-4698ba0b6fca"],

Cell["\<\
\tEinstein[-a, -b] = Ricci[-a, -b] - g[-a,-b] RicciScalar[] / 2\
\>", "Text",ExpressionUUID->"c4736a9e-e4b8-40e2-8c7a-a01bc2d8b322"],

Cell["\tWeyl[-a, -b, -c, -d] = RiemannDown[-a, -b, -c, -d] +...", \
"Text",ExpressionUUID->"56d8031c-ae47-40cc-bae2-5067320e14a5"],

Cell["4) $TorsionSign", \
"Text",ExpressionUUID->"3f17ba2b-c3b2-4574-944e-fcdb7320affd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefSign", "[", 
  RowBox[{
  "$TorsionSign", ",", "\"\<\!\(\*SubscriptBox[\(s\), \(T\)]\)\>\"", ",", 
   "1"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"955aeca3-5ea6-49b4-99ac-89b13885bd20"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"e5a5f746-3da8-413d-936a-653625bbd0d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$TorsionSign"}]], \
"Input",ExpressionUUID->"eb2521e9-233f-45f7-819a-982dcd84a4b8"],

Cell[BoxData[
 StyleBox["\<\"$TorsionSign defines the global sign of the torsion tensor of \
a covariant derivative: cd[-a]@cd[-b]@f[] - cd[-b]@cd[-a]@f[] = - \
$TorsionSign Torsioncd[c,-a,-b] cd[-c]@f[].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672370-5338953",ExpressionUUID->"3fb4670f-a6e6-465a-a673-\
83ace1b74bb9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"$TorsionSign", 
  "=."}]], "Input",ExpressionUUID->"f0b64280-a30b-40b3-9692-abdf4b4d3b22"],

Cell["Later we shall define two more signs:", \
"Text",ExpressionUUID->"1910260c-969a-459b-ae32-20b12bb0135b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$ExtrinsicKSign"}]], \
"Input",ExpressionUUID->"55c076f9-6d5a-4aee-8a9b-2f99ee247afa"],

Cell[BoxData[
 StyleBox["\<\"$ExtrinsicKSign defines the global sign of the extrisic \
curvature tensor in terms of the derivative of a vector field: \
ExtrinsicK[-a,-b] = $ExtrinsicKSign Projector[ cd[-a][ n[-b] ] ].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672371-5338953",ExpressionUUID->"d8f55a06-6792-4a3c-a583-\
c244ed3d0fe4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$AccelerationSign"}]], \
"Input",ExpressionUUID->"8aa21f50-3370-4614-80bd-b56798a69dd5"],

Cell[BoxData[
 StyleBox["\<\"$AccelerationSign defines the global sign of the acceleration \
vector in terms of the derivative of a vector field: Acceleration[-a] = \
$AccelerationSign n[b] cd[-b][ n[-a] ] / norm.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672372-5338953",ExpressionUUID->"3bb5b610-019d-41cc-a172-\
1951bf8e2a62"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["4.2.2. Constants...", \
"Subsubsection",ExpressionUUID->"95e75be2-32fa-4bdd-9fea-2bd825a2a970"],

Cell["\<\
Many of these are already define in the package \
Miscellaneous`PhysicalConstants, but there only as definitions for their \
values in a particular unit system.\
\>", "Text",ExpressionUUID->"870825eb-42ae-4a41-a927-40c0960447fe"],

Cell["\<\
Maxwellk1, Maxwellk3. See Jackson's book.
Eps0, Mu0. Permitivity and permeability of vacuum in MKS units.
Lightc, hbar, NewtonG.\
\>", "Text",ExpressionUUID->"399d8f35-f29b-4113-b603-8fa1420bce3e"],

Cell["\<\
These constants would be required if we hardwired important equations in \
Physics (like Maxwell's equations or Newton's law), but we are not doing \
that, and so we don't really need these constants.\
\>", "Text",ExpressionUUID->"81ecbcb2-08c6-45a8-a1f1-3c8497b07947"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.2.3. ...or unit system", \
"Subsubsection",ExpressionUUID->"e4e7a8ce-ff73-487a-8e28-41bc399ad644"],

Cell["\<\
See the package Miscellaneous`Units for the Convert command. Again, here we \
would just need a consistent way of writing famous equations of Physics.\
\>", "Text",ExpressionUUID->"ffc5be4b-d750-413c-9c51-9664f93c60f9"],

Cell["\<\
emuUnits. Electromagnetic system
esuUnits. Electrostatic system
GaussianUnits.
HeavisideLorentzUnits.
RationalizedMKSUnits.
SIUnits.
GravitationalUnits. Lightc=NewtonG=1.
NaturalUnits. Lightc=hbar=1.\
\>", "Text",ExpressionUUID->"5e515e36-5e99-4df2-a5fb-272e944f5cc4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3. Constants: ConstantQ", \
"Subsection",ExpressionUUID->"2b1ce3a4-e35d-4ab4-bf29-93a15e1eb2e1"],

Cell["\<\
We introduce a function that identifies constants, both constant-symbols and \
numbers or numeric symbols. Do not confuse it with ConstantSymbolQ. It also \
checks whether the arguments of scalar functions are all constants. \
\>", "Text",ExpressionUUID->"70706583-543c-4954-9ba3-6c3ddeb9bd7f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ConstantQ"}]], \
"Input",ExpressionUUID->"2014c06d-bd3d-48e6-b40e-896ce9d01cb4"],

Cell[BoxData[
 StyleBox["\<\"ConstantQ[x] gives True if x is a number or a numeric symbol \
or a constant symbol. Otherwise it gives False.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672373-5338953",ExpressionUUID->"f9655268-5d21-4e29-b7df-\
d583dd401611"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ConstantQ", "[", 
    RowBox[{"_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
    "]"}], ":=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConstantQ", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"AllTrue", "[", 
    RowBox[{"expr", ",", "ConstantQ"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ConstantQ", "[", "expr_Times", "]"}], ":=", 
   RowBox[{"AllTrue", "[", 
    RowBox[{"expr", ",", "ConstantQ"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ConstantQ", "[", 
    RowBox[{
     RowBox[{"_", "?", "ScalarFunctionQ"}], "[", 
     RowBox[{"___", "?", "ConstantQ"}], "]"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConstantQ", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"NumericQ", "[", "x", "]"}], "||", 
    RowBox[{"ConstantSymbolQ", "[", "x", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ConstantQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ConstantQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"580683e1-49f9-466a-bbd6-ce623c2ecd2a"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4. Scalars: ScalarQ and Scalar", \
"Subsection",ExpressionUUID->"2daceb57-9dd2-4465-ae93-bc9a4de58ba8"],

Cell[CellGroupData[{

Cell["4.4.1. ScalarQ", \
"Subsubsection",ExpressionUUID->"c41dfe49-669c-4e20-827d-92c1741dbd02"],

Cell["\<\
First we define a function which detects scalars. There is an important \
problem here: consider the expression v[{a, basis}]v[{-a, -basis}]; are these \
two objects scalars? Would it be reasonable to separate Scalar[v[{a, \
basis}]w[{-a, -basis}, b, -b]] into v[{a, basis}] Scalar[w[{-a, \
-basis},b,-b]] ? I don't think so. In the past the generic definition had \
Select[FFI[expr], AIndexQ] instead of the current FFI[expr].\
\>", "Text",ExpressionUUID->"dab7e76a-a12c-431e-a46d-6d5f7a7dc1bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "NonIndexedScalarQ"}]], \
"Input",ExpressionUUID->"c9275cd6-e48c-43d1-9576-fee775ef58de"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`NonIndexedScalarQ[expr] returns True if expr \
is an explicit scalar: Scalar[x], tensor[], constant, parameter, \
scalar-function[x].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672375-5338953",ExpressionUUID->"4c9cc6b8-8f59-402e-8e6c-\
7b8e87c98985"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ScalarQ"}]], \
"Input",ExpressionUUID->"490f47d2-97b1-4f48-bd61-64e986214f5d"],

Cell[BoxData[
 StyleBox["\<\"ScalarQ[expr] gives true if expr is a scalar, that is, it has \
no free index.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672376-5338953",ExpressionUUID->"bc84b953-28b2-4ede-ae3e-\
ba8f99ffca21"]
}, Open  ]],

Cell["\<\
We separate part of the action of ScalarQ into the private NonIndexedScalarQ \
to make use only of the latter below, when detecting scalars which can be \
extracted from the Scalar head. That is, we do not want to waste time using \
FindFreeIndices when checking if some part of the Scalar expression can be \
extracted. Note the difference between these two functions: ScalarQ gives \
True if the expression is a scalar (no free indices), while NonIndexedScalarQ \
gives True if the expression does not have indices at all.\
\>", "Text",ExpressionUUID->"7e9c32a4-027b-4184-88a1-7c0e244ebe62"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Shortcuts", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", "expr_Plus", "]"}], ":=", 
     RowBox[{"AllTrue", "[", 
      RowBox[{"expr", ",", "NonIndexedScalarQ"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", "expr_Times", "]"}], ":=", 
     RowBox[{"AllTrue", "[", 
      RowBox[{"expr", ",", "NonIndexedScalarQ"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{"Scalar", "[", "_", "]"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{
       RowBox[{"_", "?", "xTensorQ"}], "[", "]"}], "]"}], ":=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{
       RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "__", "]"}], "]"}], ":=", 
     "True"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{"_Symbol", "?", "ParameterQ"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{"_", "?", "ConstantQ"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{
       RowBox[{"prod_", "?", "ProductQ"}], "[", "factors___", "]"}], "]"}], ":=", 
     RowBox[{"AllTrue", "[", 
      RowBox[{
       RowBox[{"{", "factors", "}"}], ",", "NonIndexedScalarQ"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"SeriesData", "[", 
        RowBox[{"var_", ",", "origin_", ",", "coeffs_", ",", "__"}], "]"}]}], 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"AllTrue", "[", 
       RowBox[{"coeffs", ",", "NonIndexedScalarQ"}], "]"}], "&&", 
      RowBox[{"NonIndexedScalarQ", "[", "var", "]"}], "&&", 
      RowBox[{"NonIndexedScalarQ", "[", "origin", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NonIndexedScalarQ", "[", "expr_", "]"}], ":=", "False"}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Pattern", " ", "or", " ", "Slot", " ", "expressions", " ", "are", " ", 
     "not", " ", 
     RowBox[{"scalars", "!"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarQ", "[", 
      RowBox[{
      "_Blank", "|", "_Pattern", "|", "_PatternTest", "|", "_Condition", "|", 
       "_Slot"}], "]"}], ":=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Identify", " ", "objects", " ", "are", " ", "not", " ", "scalars"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarQ", "[", "_Object", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarQ", "[", 
      RowBox[{
       RowBox[{"VerbatimProduct", "[", "_", "]"}], "[", "___", "]"}], "]"}], ":=",
      "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarQ", "[", 
      RowBox[{
       RowBox[{"CommutingObjects", "[", "_", "]"}], "[", "___", "]"}], "]"}], 
     ":=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Generic", " ", "definition"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarQ", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{"NonIndexedScalarQ", "[", "expr", "]"}], "||", 
      RowBox[{
       RowBox[{"FindFreeIndices", "[", "expr", "]"}], "===", 
       RowBox[{"IndexList", "[", "]"}]}]}]}], " ", ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"ScalarQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "ScalarQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"145883e2-73f7-4a02-b3eb-591e5783da1d"],

Cell["\<\
Dim1: With 1-dim vector spaces we can have repeated indices and so it is not \
obvious how to define \"dummy\" and \"free\" indices. However we shall do it \
in such a way that this function does not require changes.\
\>", "Text",ExpressionUUID->"9a86e258-9e88-4366-a909-b4eae55d5e76"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4.2. Scalar", \
"Subsubsection",ExpressionUUID->"c179b111-317b-43ff-9e83-63cf177ae85c"],

Cell["\<\
The head Scalar has several properties. In particular, Scalar evaluates its \
argument.\
\>", "Text",ExpressionUUID->"23e20bbe-e8cf-428b-b847-0f5c2c97cfbf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Scalar"}]], "Input",ExpressionUUID->"4f410c20-37e0-45c7-a5ff-2203284ee57d"],

Cell[BoxData[
 StyleBox["\<\"Scalar[expr] denotes that expr is a scalar (no free indices) \
expression. The expression is simplified as much as possible extracting \
scalars and constants.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672378-5338953",ExpressionUUID->"11238dae-5e40-4527-ad9c-\
4c72494ff0ab"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Scalar", "[", "x_Plus", "]"}], ":=", 
   RowBox[{"Scalar", "/@", "x"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Scalar", "[", "x_SeriesData", "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{"Scalar", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"x_", "?", "ConstantQ"}], " ", "y_."}], "]"}], ":=", 
   RowBox[{"x", " ", 
    RowBox[{"Scalar", "[", "y", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Scalar", "[", 
    RowBox[{"x_", "?", "NonIndexedScalarQ"}], "]"}], ":=", 
   RowBox[{"x", "/;", "$SeparateScalarsFromScalar"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"x_", "?", "NonIndexedScalarQ"}], " ", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Scalar", "[", "x", "]"}], " ", 
    RowBox[{"Scalar", "[", "y", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Scalar", "[", "1", "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Scalar", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Scalar", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a57ccae7-30d5-4f8c-853a-0a5993da61a0"],

Cell["\<\
Scalar is logically a special case of an inert-head. However I do not see the \
point in defining it as such because we still need to give very special \
definitions for it.\
\>", "Text",ExpressionUUID->"71208605-358e-449d-9f90-445c134baa6d"],

Cell["\<\
Deactivate this variable to avoid Scalar[x] being converted into x for a \
non-indexed scalar x:\
\>", "Text",ExpressionUUID->"c378c384-38e6-4d78-86d7-9c2258aa6c44"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$SeparateScalarsFromScalar", "=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a220d74d-c963-40ee-a133-1ba8b7e4a43f"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4.3. Formatting", \
"Subsubsection",ExpressionUUID->"b537e556-1122-4886-ad78-10e60319fe99"],

Cell["\<\
I have tried to color the background of Scalar expressions, but nobody likes \
that, and so I deactivate it:\
\>", "Text",ExpressionUUID->"d96a1dc0-e257-4685-bfe0-cfaafc52790f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"$ScalarColor", "=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0.9", ",", "1.", ",", "0.5"}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"a1b73f64-f88c-4116-bce4-c50b7d613c9d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"$ScalarColor\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "$ScalarColor", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"27f4a8fa-9dbe-44da-8a1b-c17a3d1aaae2"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "Scalar", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "StandardForm"}], "]"}], ":=", 
     RowBox[{"interpretboxcolor", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr", "]"}], ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"expr", ",", "StandardForm"}], "]"}], ",", "\"\<)\>\""}], 
         "}"}], "]"}], ",", "$ScalarColor"}], "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "Scalar", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "StandardForm"}], "]"}], 
     "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "Scalar", "]"}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"b3b4a340-bdc4-46a7-825f-1d66921c5763"],

Cell["\<\
Following Guillaume, now we color the parentheses, by default in red :\
\>", "Text",ExpressionUUID->"a73badd1-dd66-44ee-a5f8-b3467f970bba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$ScalarColor"}]], \
"Input",ExpressionUUID->"0ca3f6c1-2190-4194-84b7-f2ac9b44af00"],

Cell[BoxData[
 StyleBox["\<\"$ScalarColor is a global variable specifying the color of the \
parentheses surrounding the formatting of a Scalar expression.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672379-5338953",ExpressionUUID->"9f84fb01-019f-496d-8d83-\
fad716f458ff"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$ScalarColor", "=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "Scalar", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "StandardForm"}], "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr", "]"}], ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"StyleBox", "[", 
           RowBox[{"\"\<(\>\"", ",", 
            RowBox[{"FontColor", "\[Rule]", "$ScalarColor"}]}], "]"}], ",", 
          RowBox[{"MakeBoxes", "[", 
           RowBox[{"expr", ",", "StandardForm"}], "]"}], ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{"\"\<)\>\"", ",", 
            RowBox[{"FontColor", "\[Rule]", "$ScalarColor"}]}], "]"}]}], 
         "}"}], "]"}]}], "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "Scalar", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "StandardForm"}], "]"}], 
     "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "Scalar", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"edc2dc2e-8b4c-4537-a569-442c7deb7d2b"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4.4. Examples", \
"Subsubsection",ExpressionUUID->"b643b3f4-2b49-49f3-a8dd-dfbd20501127"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"fb553124-b5be-4a0e-8fbc-6e32bbe26d4d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarQ", "[", "aa_", 
  "]"}]], "Input",ExpressionUUID->"b88a8c60-a1fe-416a-9408-89546f183063"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"3cb75e4f-5a8f-4b94-b76c-cc69c01006bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarQ", "[", "Pi", 
  "]"}]], "Input",ExpressionUUID->"b9462fcb-f2ef-4cef-aefa-0cf9d0f68726"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"bfafae33-06d6-4701-87c0-27a66272cad1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Scalar", "[", 
  RowBox[{"2", "Pi", " ", 
   RowBox[{"E", "^", 
    RowBox[{"(", 
     RowBox[{"-", "3"}], ")"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"b9d37c6a-dbfe-446b-b48e-51329c76deac"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", "\[Pi]"}], 
  SuperscriptBox["\[ExponentialE]", 
   "3"]]], "Output",ExpressionUUID->"d73afff8-a938-401f-8e67-81c6cf9463de"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Scalar", "[", 
  RowBox[{
   RowBox[{"aa", "[", "]"}], "^", 
   RowBox[{"bb", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"7343ccdb-82b4-46a3-a689-f84da8a304de"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"aa", "[", "]"}], 
  RowBox[{
  "bb", "[", 
   "]"}]]], "Output",ExpressionUUID->"0529ae19-e752-4f92-b99c-8ff177666a6f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Scalar", "[", 
  RowBox[{"2", "Pi", " ", 
   RowBox[{"ff", "[", "]"}], 
   RowBox[{"E", "^", 
    RowBox[{"(", 
     RowBox[{"-", "3"}], ")"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"3fdcd65c-e73b-4a15-9218-85478a0e02fb"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", "\[Pi]", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"ff", "[", "]"}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[
     $CellContext`ff[]],
    Editable->False]}], 
  SuperscriptBox["\[ExponentialE]", 
   "3"]]], "Output",ExpressionUUID->"1c516399-d0c0-4973-bf2f-8678bee08f91"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"ef6529b7-2af7-45bf-92d8-ab31bf7ece6e"],

Cell["(2*Pi*Scalar[ff[]])/E^3", \
"Output",ExpressionUUID->"f7fa01d1-a1c3-4de8-8624-b35fa6952f42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", "\[Pi]", " ", 
    RowBox[{"Scalar", "[", 
     RowBox[{"ff", "[", "]"}], "]"}]}], 
   SuperscriptBox["\[ExponentialE]", "3"]], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"5b49dbf7-1bb3-40ba-8f90-d43659b86fd3"],

Cell["(2*Pi*Scalar[ff[]])/E^3", \
"Output",ExpressionUUID->"0cd75aaa-1ec0-4949-80a4-ba2bf9fe2cea"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"aa", ",", "bb", ",", "ff"}], 
  "]"}]], "Input",ExpressionUUID->"d4abc782-b66d-4b22-819e-79b37bf4a755"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e5009fd8-3438-4a8e-9f43-01233219f2cd"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4.5. Derivatives: FirstDerQ", \
"Subsection",ExpressionUUID->"a7222584-3556-48b0-a08f-9ef7df462de9"],

Cell["\<\
It is interesting to identify all kinds of derivatives with a single \
Q-function. Note that FirstDerQ gives True on single derivatives, but not on \
multiple derivatives (for instance ParamD[t1,t2]) because it will be \
frequently used to detect when the Leibnitz rule must be used, and that rule \
only works for single derivatives.\
\>", "Text",ExpressionUUID->"06c2b813-ab08-4bb7-a63b-9f1233ae1124"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FirstDerQ"}]], \
"Input",ExpressionUUID->"cb80fc64-9919-4df0-80d2-1e4fc131ac24"],

Cell[BoxData[
 StyleBox["\<\"FirstDerQ[expr] gives True if expr is of the form covd[i], \
LieD[v], ParamD[par] or OverDot, or False otherwise. In particular it gives \
False on multiple (nested) derivatives like ParamD[par1, par2].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672381-5338953",ExpressionUUID->"453a5bc5-efc8-467b-9d20-\
18ad0fe5f128"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FirstDerQ", "[", 
    RowBox[{
     RowBox[{"_", "?", "CovDQ"}], "[", "_", "]"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstDerQ", "[", 
    RowBox[{"LieD", "[", "_", "]"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstDerQ", "[", 
    RowBox[{"ParamD", "[", "_", "]"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstDerQ", "[", "OverDot", "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstDerQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FirstDerQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FirstDerQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9259e016-112b-41bd-bac7-9caae1192fbf"],

Cell["\<\
Note that a covariant derivative with multiple indices is not interpreted \
here as a first derivative. If this is required it must be added as a special \
rule. This is because somebody could want to use the multiple indices case as \
a high-order derivative. Perhaps that should be added by default in Spinors, \
as suggested by Thomas. Note also that the notations CovD[expr, derind] or \
TensorDerivative[T, der][ inds ] cannot be included here.\
\>", "Text",ExpressionUUID->"41e9a85b-93b7-4b8b-8b44-e8d57c5b1b40"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.6. Cartesian products", \
"Subsection",ExpressionUUID->"11ed2c95-18a1-467d-9a85-014496a4f0c5"],

Cell["\<\
This is a generic representation for Cartesian products. The global type of \
the object is the same of the type of its arguments (which must be all of the \
same type). There is no natural unity here, so CartesianProduct[] will stay \
unevaluated.\
\>", "Text",ExpressionUUID->"e12eba4c-6f92-40ad-8a14-a6c5f2447594"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"CartesianProduct", ",", 
    RowBox[{"{", 
     RowBox[{"Flat", ",", "OneIdentity"}], "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"38265624-1a7f-4806-b3c5-01fac9313b1e"],

Cell["The standard missing definition:", \
"Text",ExpressionUUID->"4856c4bb-1ab0-4d64-a9a7-7a55f1859c39"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Verbatim", "[", "CartesianProduct", "]"}], "[", "x_", "]"}], ":=",
    "x"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"65cd2b5c-4668-4454-82f4-1dfb1403e120"],

Cell["General properties:", \
"Text",ExpressionUUID->"081b3d32-a7c9-48b8-9992-35599bbb6730"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", "x_CartesianProduct", "]"}], "^:=", 
   RowBox[{"Dagger", "/@", "x"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"296b8522-21c4-429a-a8ee-90c61a3e2f95"],

Cell["Generic operations:", \
"Text",ExpressionUUID->"40bd8cae-c515-42f9-91db-44296693e5df"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CartesianProduct", "::", "len"}], "=", 
   "\"\<Incompatible lengths `1` of Cartesian products.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ThreadCartesianProduct", "[", 
    RowBox[{"prod_", ",", 
     RowBox[{"{", "cprods__", "}"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lengths", "=", 
       RowBox[{"Length", "/@", 
        RowBox[{"{", "cprods", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CartesianProduct", "@@", 
       RowBox[{"MapThread", "[", 
        RowBox[{"prod", ",", 
         RowBox[{"List", "@@@", 
          RowBox[{"{", "cprods", "}"}]}], ",", "1"}], "]"}]}], "/;", 
      RowBox[{
       RowBox[{"SameQ", "@@", "lengths"}], "||", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"CartesianProduct", "::", "len"}], ",", "lengths"}], 
         "]"}]}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dcead010-e6b7-489d-a2fd-a96dab425b03"],

Cell["Formatting:", \
"Text",ExpressionUUID->"e91c99f3-42c7-49bb-9489-0b7900bcb3b6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "x_CartesianProduct", "]"}], "^:=", 
   RowBox[{"StringJoin", "@@", 
    RowBox[{"Riffle", "[", 
     RowBox[{
      RowBox[{"PrintAs", "/@", 
       RowBox[{"List", "@@", "x"}]}], ",", "\"\<\[Times]\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"CartesianProduct", "[", "x__", "]"}], ",", "StandardForm"}], 
    "]"}], ":=", 
   RowBox[{"MakeSequenceBox", "[", 
    RowBox[{
     RowBox[{"{", "x", "}"}], ",", "\"\<\[Times]\>\"", ",", "StandardForm"}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0086cae9-b0d3-404b-90b5-2748b99fa2dc"],

Cell["Note that we assume that:", \
"Text",ExpressionUUID->"9c834073-7141-42b7-8967-e6bfa09486b5"],

Cell[BoxData[
 RowBox[{"c_CartesianProduct", "[", "y_", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"3c260335-6813-4c09-9df1-be1f2109fa3e"],

Cell["\<\
means that c is a mapping (could be a chart in particular). Then\
\>", "Text",ExpressionUUID->"a34c69de-df88-4c7a-a508-0d36827063d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"phi_", "?", "MappingQ"}], "[", "c_CartesianProduct", 
  "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"82bdd69d-f7b0-4b3a-9e1f-defe150dcd90"],

Cell["means that c is a point (a 0-dim manifold).", \
"Text",ExpressionUUID->"49ce3a2a-efc3-4909-aee0-b3fb97949f23"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["5. Indices",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"ca7b5e48-b9d9-4970-8c9c-902a76d9718c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "*********************************************************************)"}\
], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
      "**", " ", "5."}], " ", "Indices"}], " ", 
   "*****************************)"}], "\[IndentingNewLine]", 
  RowBox[{
  "(*", "*********************************************************************)"}\
]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ca7926c6-0c6c-494b-8d32-fec3049c5535"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"b450de2f-bb6e-4ebe-ba62-e8de3a9151bc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "7.806232`", ",", "112.840351`8.504009421893219", ",", 
   "0.06917971392456443`"}], 
  "}"}]], "Output",ExpressionUUID->"a98fbce2-7bdb-4111-bb5a-6af2254188e9"]
}, Open  ]],

Cell[CellGroupData[{

Cell["5.0. Comments", \
"Subsection",ExpressionUUID->"758f1c25-01c6-409c-8c17-80aaa93ed1e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"$ReadingVerbose", ",", 
    RowBox[{"Print", "[", "\"\<Reading section 5: Indices.\>\"", "]"}], ",", 
    "Null", ",", "Null"}], "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"819b3b80-6be4-4a31-871d-c0ac51bc7b39"],

Cell[TextData[{
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is mainly an index manipulator, and hence it is essential to discuss which \
types of indices are allowed. The basic index type is the ",
 StyleBox["abstract index",
  FontSlant->"Italic"],
 ", a carrier of information on the slot of a tensor. Then there are \
basis/component indices, directional indices (vectorial arguments) and labels \
(a general, non-tensorial, concept of index). In version 1.0 ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " introduces a general concept of index-modifier M, such that if x is \
interpreted as an index then M[x] is also an index. Index-modifiers return \
True under IModQ. Perhaps index-modifiers should be a type in the future, but \
currently they are not.\n\nReading all this, years after the first design of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", I think ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is too strict on what indices are, for example requiring that abstract \
indices are symbols. That might be an advantage sometimes for pattern \
matching but makes generalizations quite difficult. The choice a, -a is also \
rather asymmetric and does not go well with basis indices."
}], "Text",ExpressionUUID->"007a1f95-3017-422e-b8ca-7b45bee25b03"],

Cell[TextData[{
 "0) This section contains the index notations, but not the routines to \
handle index simplifications. In principle this section should be applicable \
to (the indices of) all data-types.\n\n1) Many of these functions should not \
be directly used by the user. Perhaps they should be even grouped in a \
special subcontext xTensor`Index` .\n\n2) The main decision here is how to \
represent indices. Essentially we find again the same two opposite choices \
that we found when choosing the representation for a tensor: simplicity \
suggests using indices like a, -b, but pattern matching suggests using \
indices like Index[a, Up] or Index[b, Down]. Given that the fraction of \
patterns to be introduced is small in comparison to the total number of \
indices to use, we decide to use the former. That's also simpler for the \
user, though it complicates my life as a programmer...\n\n3) There is then \
the problem of basis indices. They need to be \"marked\" indices, that is, \
having a basis-name argument. I have changed my mind several times in this \
regard, and currently the system allows two possibilities:\n\t- My original \
choice (with the slight variation since 0.9.2 of moving the sign of the basis \
instead of that of the index) is {a, basis} or {2, -basis}.\n\t- Now (since \
0.9.4) it is also possible to use basis[a] and -basis[2]. This has been \
consistently implemented in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", but not yet in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ".\n\t- Another  alternative could be using U[0, basis] and L[0, basis], \
which has the problem of needing two different heads but is much more \
symmetric.\n\t- My impression is that we should use something more flexible, \
like arbitrary nested expressions basis[metric[projector[a]]], though \
flexible always means slower...\n\n4) In 0.9.4 I have decided to relax the \
strict requirements on the indices that can be manipulated and allow anything \
at index-slots. Anytime the indices are manipulated a few functions like \
UpIndex, EIndexQ, etc. must know what to do with any type of index they find. \
Many functions still expect abstract indices to be symbols, and that hasn't \
been generalized at all yet.\n\n5) Currently, in a tensor we can find these \
five types of \"generalized indices\" (GIndex):\n\t- abstract indices \
(AIndex) like a, -a, a$12, ...\n\t- basis indices (BIndex): lists {i, basis} \
or {-i, -basis} (BASIS1 notation), or expressions basis[i] or -basis[i] \
(BASIS2 notation), where i is an abstract index.\n\t- component indices \
(CIndex): lists {i, basis} or {i, -basis} (BASIS1 notation), or expressions \
basis[i] or -basis[i] (BASIS2 notation), where i is a \"cnumber\" (component \
or coordinate number) integer. The integer can be positive, negative or zero.\
\n\t- directional indices (DIndex): 1-tensor expressions with head Dir.\n\t- \
label indices (LIndex): any expression with head LI, perhaps multiplied by \
-1.\nAdditionally we can have:\n\t- pattern indices (PIndex): blanks, \
patterns and patterntests. Conditions are not allowed.\n\t- numerical indices \
(NIndex): integers, with the sign representing the character. Not yet \
developed.\n\t- \"modified indices\". This generalizes the BASIS2 \
construction, in such a way that we have \"index-modifiers\", responding to \
IModQ. In particular bases are possible index-modifiers.\nAll functions in \
this section should know what to do in all those cases. Or at least we should \
say why we do not need to specify what to do in some of them. In the past we \
were very strict on the types of indices, throwing errors if the index type \
was not recognized. Now I have changed my mind and prefer to allow any type \
of structure in index-slots, as long as the user has worried about \
consistency.\n\nIt is also convenient to define combined types. The first \
five types of indices (A, B, C, D, L) are generically called generalized \
indices (GIndex). Abstract and basis indices are the only types of indices \
which can be contracted right now: type ABIndex.  Basis and component indices \
are those associated to basis and charts: type BCIndex. Component indices and \
directions are those which represent directions: type CDIndex.\n\n6) Another \
important decision is how to represent \"index contraction\" and the Einstein \
convention. Those indices obeying the Einstein convention are said to be \
contractible, traceable or of Einstein type (EIndex). Currently only indices \
of types A and B are contractible and hence, unless other indices are added \
to the system types AB and E are equivalent. (QUESTION: can basis indices be \
actually repeated three or more times? Can they be non-contracted, in the \
sense of being repeated but not representing a range, as it is often said in \
many books? Currently that is not possible in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". That would require indices of type B not being of type E.). Indices which \
are not of type E are called \"blocked indices\".\n\n7) Starting version \
0.9.8 we allow abstract indices in 1-dim vector spaces to be repeated. We \
must be careful with the definition of free and dummy indices: T[o,o,-o,-o] \
is a scalar, but T[o,o,-o] is a vector.\n\n8) An index can have a state: \
free, contracted (or dummy) and blocked. Indices of types C, D, L are always \
blocked. It is difficult to define the state of a pattern index because the \
pattern may stand for different things. This is an unsolved (and probably \
unsolvable) problem; we simply try to not find this case.\n\n9) Finally there \
is a third classification of indices, by their character, which can be \
contravariant (UpIndices) or covariant (DownIndices). Again it is not simple \
to associate a character to a pattern index. An index like i_ could match \
anything, including another pattern. Perhaps this is want we really want, but \
in general it will not be the case. Once the pattern has a head (Blank[head]) \
there is no problem with characters, but an index without a head could \
generate problems. Therefore the recommendation is using heads when possible. \
Other solution is using Q-functions (PatternTest).\n\n10) We assume indices \
can be evaluated at any stage of the calculation. We advise against the use \
of indices that change their character during the evaluation process. For \
instance, do not define a={1, polar} if a is an abstract index.\n\n11) The \
indices of a Lie derivative    LieD[ v ][ expr ]    are those of expr and not \
the index of the vector field v. The same thing happens with Lie brackets: \
the index of Bracket[v1, v2][a] is just a, and not the indices of v1, v2. \
Directional indices of the form Dir[v] do not add the indices of v to the \
expression they are in.\n\n12) We have introduced a symbol type called \
AbstractIndex for the indices. This means that we cannot have a tensor \
sharing a name with an index. This is an important restriction and sometimes \
it is a pity not being able to define a tensor A[a] because A is already an \
index on some other vector bundle. The reason is mainly safety: it would be \
dangerous to have situations like these:"
}], "Text",ExpressionUUID->"9a9e3557-76e3-4756-9486-2ab290516c83"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"775f6738-787c-450f-a47c-1aace46dc8f3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"B", "[", "C", "]"}], "/.", 
  RowBox[{
   RowBox[{"B", "[", "A_", "]"}], "\[Rule]", 
   RowBox[{
   "A", "[", "A", 
    "]"}]}]}]], \
"Input",ExpressionUUID->"ed07231d-258c-4dba-8b14-2573488fa482"],

Cell[BoxData[
 RowBox[{"C", "[", "C", 
  "]"}]], "Output",ExpressionUUID->"0b341b99-a267-42a6-8019-52bc5a717ec2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"B", "[", "C", "]"}], "/.", 
  RowBox[{
   RowBox[{"B", "[", "D_", "]"}], "\[Rule]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "A", "}"}], ",", 
     RowBox[{
      RowBox[{"A", "[", 
       RowBox[{"D", ",", "A"}], "]"}], 
      RowBox[{"B", "[", 
       RowBox[{"-", "A"}], "]"}]}]}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"7fa58084-9a4d-4bcf-8d61-38c936486334"],

Cell[BoxData[
 RowBox[{
  RowBox[{"A$23479", "[", 
   RowBox[{"C", ",", "A$23479"}], "]"}], " ", 
  RowBox[{"B", "[", 
   RowBox[{"-", "A$23479"}], 
   "]"}]}]], "Output",ExpressionUUID->"72331ed0-f32a-43fe-9ed6-b3a7eb1936a8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"A", ",", "B", ",", "\"\<A$*\>\""}], 
  "]"}]], "Input",ExpressionUUID->"d8c52143-0f60-4a74-b0f1-2824ff05f9b0"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"94717e62-2488-41cb-a6b9-c275f944848d"],

Cell[TextData[{
 "In order to avoid them we should check all rules for conflicts, and that \
would be difficult and slow. On the other hand there is the possibility of \
having any output name for a given tensor (because that name is a string, not \
a symbol), and one reason more in favour of our decision is the \
recommendation of using meaningful names for tensors, like Riemann or \
MaxwellF, etc, and leave one-letter symbols as indices.\n\n12) There is the \
issue of declaring different index types for a single vbundle, like ",
 StyleBox["MathTensor ",
  FontSlant->"Italic"],
 "does with its four kinds of indices: ui, aui, bui, cui, with different \
outputs as i, i', i'', i'''. I'm not sure what this would be useful for. \
Perhaps we could use a second type of indices to denote projection, along the \
lines of the AB notation in my bssn papers, even though the right way to do \
it would be to decompose the M3 manifold into a local product of a 2-manifold \
and a 1-manifold. This is a project for the future."
}], "Text",ExpressionUUID->"7add0464-c351-43f4-a7fb-97aba80710af"],

Cell["\<\
13) There is an important point of possible conflict: lists of indices and \
indices which are lists (basis indices; BASIS1). We introduce the head \
IndexList to identify lists of indices. There are some exceptions: those \
cases where the user interacts with or sees lists of indices: the output of \
IndicesOfVBundle and the lists in Module constructions. Using lists to denote \
indices was a bad idea...\
\>", "Text",ExpressionUUID->"3812a782-2228-4c15-81fe-1a3a7f2c754c"],

Cell["\<\
Formatting for IndexList. Following the formatting of Scalar, we print braces \
of the list in blue.\
\>", "Text",ExpressionUUID->"ee028a55-3682-4b0b-9c29-0102fc74c29d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexList"}]], \
"Input",ExpressionUUID->"0eff34fa-a4ee-4198-993a-97323d684c26"],

Cell[BoxData[
 StyleBox["\<\"IndexList[i1, i2, ...] is a list of g-indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672383-5338953",ExpressionUUID->"a008b3c0-8713-465a-8bfa-\
cdd4da768b51"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$IndexListColor"}]], \
"Input",ExpressionUUID->"abb05746-bbc8-4283-b291-0c57beec6462"],

Cell[BoxData[
 StyleBox["\<\"$IndexListColor is a global variable specifying the color to \
format the braces of IndexList expressions in StandardForm. The default color \
is blue, RGBColor[0,0,1].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672384-5338953",ExpressionUUID->"db8e173b-0203-4484-86b4-\
fe7cf440323d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$IndexListColor", "=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6d0f2771-d797-4202-9f65-e92b49a22c37"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", "inds___", "]"}], ",", "StandardForm"}], "]"}], 
  ":=", 
  RowBox[{"interpretbox", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", "inds", "]"}], ",", 
    RowBox[{"RowBox", "[", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"StyleBox", "[", 
         RowBox[{"\"\<{\>\"", ",", 
          RowBox[{"FontColor", "\[Rule]", "$IndexListColor"}]}], "]"}], ",", 
        RowBox[{"MakeSequenceBox", "[", 
         RowBox[{
          RowBox[{"{", "inds", "}"}], ",", "\"\<,\[ThinSpace]\>\"", ",", 
          "StandardForm"}], "]"}], ",", 
        RowBox[{"StyleBox", "[", 
         RowBox[{"\"\<}\>\"", ",", 
          RowBox[{"FontColor", "\[Rule]", "$IndexListColor"}]}], "]"}]}], 
       "}"}], "]"}], "]"}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5d5e744a-3ca4-4ba2-b56e-52df7df8286c"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"4a0cca43-1757-495e-8261-f4810e54e031"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"List", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "]"}]], "Input",ExpressionUUID->"84304d3f-a068-4ad7-90ad-cb030821f0db"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "}"}]], "Output",ExpressionUUID->"de5bd885-c5c9-493b-8267-0fbdeb378d5c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"dd4086ca-935f-4d5e-b84c-332de1456d53"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"List", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"90a80ccd-5ccc-4629-ae7a-fb1f705a0f80"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexList", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "]"}]], "Input",ExpressionUUID->"e5f91c94-67d9-42d7-bdcb-95ae37818eee"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"a", ",", "\[ThinSpace]", "b", ",", "\[ThinSpace]", "c"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b, $CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"3ec83fc1-1cce-4812-b120-6eb59b658878"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"cce7afff-8322-4b43-8486-b53540003dc8"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"59503e60-a299-4261-ac08-378619e90fe7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], 
  "]"}]], "Input",ExpressionUUID->"d152716a-a419-4322-a234-af10f2fd9e8e"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"7619b323-dad4-4580-bd9b-1c09e17fcfb6"],

Cell["\<\
IndexList is used by:
\t- TakeEPairs and TakeOrderedEPairs: both as input and output.
\t- TakeFrees: both as input and output.
\t- IndexPosition: only as input.
\t- IndexOrderedQ: only as input. User-function: it also allows List.
\t- IndexSort: only as input. User-function: it also allows List.
\t- CheckRepeated: both as input and output.
\t- CheckHomogeneity: both as input and output.
\t- CheckIndexType: both as input and output.
\t- FindIndices: only as output.
\t- FindDummyIndices: only as output.
\t- FindFreeIndices: only as output.
\t- ReplaceIndexList: both as input and output.
\t- ReplaceDummies: only as input.
\t- SameVBundleRules: only as input.
\t- screenrules: only as input.
\t- PermuteIndices: only as input.
\t- symperms: only as input.
\t- SymmetryEquivalentsOfTensor: only as input.
\t- ToSlotRules: only as input.
Functions that expect (or give) a List of indices, and not IndexList:
\t- SSSBinds: only as input.
\t- GetIndicesOfVBundle: both as input and output.
\t- ImposeSymmetry: only as input.\
\>", "Text",ExpressionUUID->"03ac4e3e-7902-46fe-8f49-8140991ee396"],

Cell["14) A note on the plural of \"Index\":", \
"Text",ExpressionUUID->"b9f8ee93-4ec6-4172-ab46-33c453856702"],

Cell["\<\
Taken from somewhere in the internet:

\tThe plural of \"index\" for books, journals and newspapers is \"indexes\"; \
the plural of \"index\" for graphs and benchmarks for economics for example, \
is \"indices\"; but the plural of \"appendix\" is always \"appendices\".
\t
I think the \"index\" of a tensor must follow the rule for the second group, \
and hence its plural will be \"indices\". In Spanish we only have \
\"\[IAcute]ndice\" in singular and \"\[IAcute]ndices\" in plural, and so \
\"indices\" is also nicer for me.\
\>", "Text",ExpressionUUID->"7136c4ea-5ccd-4c8d-be67-dec73bd582dc"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.1. DefAbstractIndex", \
"Subsection",ExpressionUUID->"05628969-9968-4537-b89e-a448115020b3"],

Cell[CellGroupData[{

Cell["5.1.0. Comments", \
"Subsubsection",ExpressionUUID->"24d3e59a-c3ad-4974-a5bd-afae2090c80f"],

Cell["\<\
This function just checks that the symbol is not already in use and registers \
it. We do not append the symbol to $AbstractIndices because this list is \
constructed from IndicesOfVBundle. At this level there is no association of \
an index to any vector bundle. This will be done when the vector bundle is \
defined, below.\
\>", "Text",ExpressionUUID->"967f059e-1986-4154-82b3-2856812024eb"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.1.1. ValidateIndex", \
"Subsubsection",ExpressionUUID->"56f58357-f8ad-4722-a25d-5d4c33150fa5"],

Cell["\<\
DefAbstractIndex gives a warning if the symbol is one of the capitals used by \
Mathematica: (C,D,K,N,O). Recall that E, I have numeric value and therefore \
can never be used as indices.\
\>", "Text",ExpressionUUID->"2bdf4840-4f8f-4561-98db-f922b3921539"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidateSymbol", "::", "capital"}], "=", 
   "\"\<System name `1` is overloaded as an abstract index.\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"41f75f5b-e6e3-4524-b515-b3ecc88bca3e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ValidateIndex"}]], \
"Input",ExpressionUUID->"9af6af87-9eb3-421f-b5c6-a08e5ba2c69e"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`ValidateIndex[i] checks that i is a valid \
symbol, that it does not have an associated type, and gives a warning message \
if it is one of the capitals that Mathematica uses. \
xTensor`Private`ValidateIndex[i, False] does not give that warning message.\"\
\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672386-5338953",ExpressionUUID->"86d2eff7-f169-4660-9953-\
cb1633bb7c20"]
}, Open  ]],

Cell["\<\
The function ValidateIndex is assumed to be used only at definition time. \
That is, it cannot be used during the computations to check that a given \
index is correct. Use GIndexQ for that.\
\>", "Text",ExpressionUUID->"e61f4184-fce7-4e66-9f66-e8732bad529e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidateIndex", "[", 
    RowBox[{"symbol_", ",", 
     RowBox[{"capitalmessage_", ":", "True"}]}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ValidateSymbol", "[", "symbol", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ValidateSymbolInSession", "[", "symbol", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"capitalmessage", "&&", 
        RowBox[{"xAct`xCore`Private`SystemCapitalQ", "[", "symbol", "]"}]}], 
       ",", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"ValidateSymbol", "::", "capital"}], ",", 
         RowBox[{"ToString", "[", "symbol", "]"}]}], "]"}]}], "]"}], ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"01f47313-f87a-49e2-bc92-1c0a7383cf02"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.1.2. Definition", \
"Subsubsection",ExpressionUUID->"7d71ed2c-d072-4e16-8891-9c69ce53785d"],

Cell[TextData[{
 "The function DefAbstractIndex could be private, but it is left public for \
the sake of coherence with the rest of types of symbols. Note that even \
though DefAbstractIndex has an option PrintAs, it actually cannot be used \
from DefVBundle. Unless we invent some new notational device, the user must \
declare separately the PrintAs form of the indices. Given that any ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " symbol can be an abstract index, this is not typically required, though \
indices associate to pullback vbundles could be quite large."
}], "Text",ExpressionUUID->"801aab62-1342-429b-878a-ca4af44aaa0c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "DefAbstractIndex"}]], \
"Input",ExpressionUUID->"80d8fe6b-8ee0-4681-a31a-33686d94b367"],

Cell[BoxData[
 StyleBox["\<\"DefAbstractIndex[symbol] defines symbol to be an abstract \
index without associating it to a vector bundle yet.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672387-5338953",ExpressionUUID->"cbfe4ea4-5f93-46cb-aa15-\
aada93a149de"]
}, Open  ]],

Cell["\<\
We use xUpSet because symbol could be already protected. There is nothing \
here related to the complex character of the indices. That is exceptionally \
handled through the specific function DaggerIndex. Same thing happens with \
pullbacks and PullBackIndex. There is no MakeDefInfo message.\
\>", "Text",ExpressionUUID->"37e66b53-3235-479b-9efe-f2223de97a90"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefAbstractIndex", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefAbstractIndex", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefAbstractIndex", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefAbstractIndex", "[", 
   RowBox[{"symbol_Symbol", ",", 
    RowBox[{"options", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pa", ",", "pns"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"pa", ",", "pns"}], "}"}], "=", 
      RowBox[{"OptionValue", "[", 
       RowBox[{"{", 
        RowBox[{"PrintAs", ",", "ProtectNewSymbol"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Validate", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{"ValidateIndex", "[", "symbol", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"Value", " ", "for", " ", 
        RowBox[{"NoDollar", ".", " ", "Store"}], " ", "$ModuleNumber", " ", 
        "to", " ", "remove", " ", "associated", " ", "dollar"}], "-", 
       "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"xAct`xCore`Private`SystemCapitalQ", "[", "symbol", "]"}], ",", 
       RowBox[{
        RowBox[{"NoDollar", "[", "symbol", "]"}], "=", "symbol"}], ",", 
       RowBox[{
        RowBox[{"NoDollar", "[", "symbol", "]"}], "^=", "symbol"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ModuleNumberOfIndex", "[", "symbol", "]"}], "=", 
      "$ModuleNumber"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Register", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{"xUpSet", "[", 
      RowBox[{
       RowBox[{"AbstractIndexQ", "[", "symbol", "]"}], ",", "True"}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"SetPrintAs", "[", 
      RowBox[{"symbol", ",", 
       RowBox[{"PrintAsString", "[", 
        RowBox[{"symbol", ",", "pa"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"pns", ",", 
       RowBox[{"Protect", "[", "symbol", "]"}]}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefAbstractIndex", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefAbstractIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"beaea1d6-600b-486b-a44c-6bd6cf755353"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.1.3. Undefinition", \
"Subsubsection",ExpressionUUID->"b5413f4b-b724-49f7-823a-094ae4b9eb45"],

Cell["\<\
Corresponding Undef function. We remove on the fly all associated \
dollar-indices:\
\>", "Text",ExpressionUUID->"3e63deed-343a-409b-a721-c9b450c816e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpValues", "/@", 
  RowBox[{"{", 
   RowBox[{
   "System`C", ",", "System`D", ",", "System`K", ",", "System`N", ",", 
    "System`O"}], 
   "}"}]}]], "Input",ExpressionUUID->"def78666-9329-46a6-bb54-4705c2291c0a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"14ab4345-4554-4c02-a1f6-042466ce62a5"]
}, Open  ]],

Cell["\<\
Note that there are no visitors or servants here (the dollar indices could be \
considered as servants, but they are dealt with in a different way). There is \
no undefinition message either.\
\>", "Text",ExpressionUUID->"63d569ba-335a-4208-ae5f-684fb1bc2f8c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefAbstractIndex", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "AbstractIndexQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefAbstractIndex", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefAbstractIndex", "[", "symbol_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"AbstractIndexQ", "[", "symbol", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"UndefAbstractIndex", "::", "unknown"}], ",", 
           "\"\<index\>\"", ",", "symbol"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"xAct`xCore`Private`SystemCapitalQ", "[", "symbol", "]"}], 
        ",", 
        RowBox[{
         RowBox[{"xUpSet", "[", 
          RowBox[{
           RowBox[{"UpValues", "[", "symbol", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"CheckRemoveSymbol", "[", "symbol", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RemoveDollarIndices", "[", 
       RowBox[{
        RowBox[{"ModuleNumberOfIndex", "[", "symbol", "]"}], ",", "symbol"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"RemoveSymbol", "[", "symbol", "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefAbstractIndex", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefAbstractIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"baece2d0-2150-4aff-801f-97a816817ee8"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.1.4. Removing dollar indices", \
"Subsubsection",ExpressionUUID->"6d01d55e-e698-42bc-a45d-d1bc5e1b5530"],

Cell["\<\
Dollar indices are removed starting from a give ModuleNumber:\
\>", "Text",ExpressionUUID->"bdcf186c-055b-437d-bbd0-26c7f61fc81e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RemoveDollarIndices", "[", "number_Integer", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"RemoveDollarIndices", "[", 
       RowBox[{"number", ",", "#"}], "]"}], "&"}], ",", "$AbstractIndices"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RemoveDollarIndices", "[", 
    RowBox[{"number_Integer", ",", "index_Symbol"}], "]"}], ":=", 
   RowBox[{"Remove", "/@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"numberpair", "/@", 
       RowBox[{"Names", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{
          RowBox[{"ToString", "[", "index", "]"}], ",", "\"\<$*\>\""}], "]"}],
         "]"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x_", ",", "n_"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"x", "/;", 
        RowBox[{"n", "\[GreaterEqual]", "number"}]}]}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"numberpair", "[", "string_String", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"string", ",", 
     RowBox[{"ToExpression", "@", 
      RowBox[{"StringJoin", "[", 
       RowBox[{
        RowBox[{"Characters", "[", "string", "]"}], "//.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"___", ",", "\"\<$\>\""}], "}"}], "\[Rule]", 
           RowBox[{"{", "\"\<0\>\"", "}"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"___", ",", "\"\<$\>\"", ",", "n__"}], "}"}], "\[Rule]", 
           RowBox[{"{", "n", "}"}]}]}], "}"}]}], "]"}]}]}], "}"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"874887e4-436d-4bf5-8da3-c6eec1757eae"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3268b967-e92a-486b-9396-6e6c7d04c9b1"],

Cell[BoxData[
 RowBox[{"DefAbstractIndex", "[", "a", 
  "]"}]], "Input",ExpressionUUID->"e8c314cc-26eb-44d0-849f-d47cf6f8b833"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a"}]], "Input",ExpressionUUID->"2a992b48-8221-4d65-8b37-ed7794046d4c"],

Cell[CellGroupData[{

Cell["Global`a", "Print", "PrintUsage",
 CellTags->
  "Info3578672389-5338953",ExpressionUUID->"e032e4af-e877-4e99-b99f-\
3bf57fb8740a"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "a", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "a", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "a", "]"}], "^=", 
         "a"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "a", "]"}], "^=", "\<\"a\"\>"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`a],
  Editable->False]], "Print",
 CellTags->
  "Info3578672389-5338953",ExpressionUUID->"2e95b16b-cc59-4893-8195-\
800b7ee711bf"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", "a", "}"}], ",", "a"}], 
  "]"}]], "Input",ExpressionUUID->"d0f223db-4062-446d-b3a6-280807a982db"],

Cell[BoxData["a$25138"], \
"Output",ExpressionUUID->"0cefcb48-29d5-4e78-950f-e5eb52586aed"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xATP`NoDollar", "[", "%", "]"}], "^=", "a"}], 
  ";"}]], "Input",ExpressionUUID->"0e59caeb-66f5-4f24-ae6b-c4a0003c4f55"],

Cell[BoxData[
 RowBox[{"UndefAbstractIndex", "[", "a", 
  "]"}]], "Input",ExpressionUUID->"d6c14905-bf52-417c-b3ba-fef12f64c04a"],

Cell["The index a is not there:", \
"Text",ExpressionUUID->"e454e204-da32-4189-8707-9b3550d9bc99"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a"}]], "Input",ExpressionUUID->"25e75a85-2f44-49e6-9c4d-7ef23e081a18"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"a\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"73a0c6e6-377b-4ae0-be6c-97cb794a5f55"]
}, Open  ]],

Cell["\<\
nor the dollar-index which was associated to the index through NoDollar:\
\>", "Text",ExpressionUUID->"ab99b8e1-0442-43d6-95f2-085984aeffee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a$*"}]], "Input",ExpressionUUID->"ee51b68a-0492-4ac2-86f9-9d0933eb5484"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"a$*\\\"\\)\[NoBreak] \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"41913568-07b4-48e2-94ef-85a01b22bc84"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"db76cdf2-8a4a-4c2f-bf21-c87f85f148e8"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.1.5. Used symbols. Deactivated", \
"Subsubsection",ExpressionUUID->"c36ca11c-4538-44a3-97ca-6c2cc4b10519"],

Cell["\<\
We will see that indices can be removed, not only the dollar-indices. This \
can be a problem if some expressions stored in memory still contain that \
symbol. Mathematica does not provide us with a function checking whether a \
symbol is still in use, apart from the use of the attribute Temporary (for \
Module only) in an indirect way (a symbol with Temporary attribute is still \
in use if it still exists). A typical problem is that lots of symbols are \
used in the stored values for In or Out. I have tried to define a set of \
functions taking care of this point, but the result were rather bad. Example:\
\
\>", "Text",ExpressionUUID->"435a7b67-cb94-4fd5-98bf-52e7032cdf6a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Values", "[", "name_", "]"}], ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"Through", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "Attributes", ",", "DefaultValues", ",", "DownValues", ",", 
       "FormatValues", ",", "Messages", ",", "NValues", ",", "Options", ",", 
       "OwnValues", ",", "UpValues", ",", "SubValues"}], "}"}], "[", 
     RowBox[{"ToExpression", "[", "name", "]"}], "]"}], "]"}]}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"0070dd23-7b46-49c8-9bdc-3fbf0b015539"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"Values\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "Values", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"e706b732-5aba-4444-a53a-40703094cb44"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"UsedSymbolQ", "[", 
   RowBox[{"symbol_Symbol", ",", 
    RowBox[{"context_", ":", "$Context"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"TF", "=", "False"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "symbol"}], "]"}], "=!=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{
          RowBox[{"TF", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefAbstractIndex", "::", "noundef"}], ",", 
            "\"\<Symbol\>\"", ",", "symbol", ",", 
            RowBox[{"\"\<it is used in a value of \>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], "]"}]}]}], "]"}], 
       "&"}], "/@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#", ",", 
           RowBox[{"Values", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
        "$AllObjects"}], ")"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"#", ",", "symbol"}], "]"}], "=!=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{
          RowBox[{"TF", "=", "True"}], ";", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefAbstractIndex", "::", "noundef"}], ",", 
            "\"\<Symbol\>\"", ",", "symbol", ",", 
            RowBox[{"\"\<it is used in In[\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
             "\"\<]\>\""}]}], "]"}]}]}], "]"}], "&"}], "/@", 
      RowBox[{"Drop", "[", 
       RowBox[{
        RowBox[{"DownValues", "[", "In", "]"}], ",", 
        RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"#", ",", "symbol"}], "]"}], "=!=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{
          RowBox[{"TF", "=", "True"}], ";", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefAbstractIndex", "::", "noundef"}], ",", 
            "\"\<Symbol\>\"", ",", "symbol", ",", 
            RowBox[{"\"\<it is used in In[\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
             "\"\<]\>\""}]}], "]"}]}]}], "]"}], "&"}], "/@", 
      RowBox[{"DownValues", "[", "Out", "]"}]}], ";", "\[IndentingNewLine]", 
     "TF"}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"1e1acae0-a419-4f95-bba4-f971eff1903f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"1b6a453a-b974-4ac3-8d78-a3512d972fc7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`UsedSymbolQ", "[", "A", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"0e016f0f-014a-49c8-8afb-af16e4ca6c3b"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"40913147-e9d9-4480-8e05-429e33f38a39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`UsedSymbolQ", "[", "xATP`TF", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"bcf47382-72b9-4588-965d-9231f3e19c3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefAbstractIndex", "::", "\<\"noundef\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"Symbol\\\"\\) \\!\\(xAct`xTensor`Private`TF\\) cannot \
be undefined because \\!\\(\\\"it is used in In[1195]\\\"\\).\"\>"}]], \
"Message",ExpressionUUID->"14cef957-e7a0-4faa-b3ea-ab32dd88f884"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"d690e2e8-00dc-471b-8bde-f8576fd61ef9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "A", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"f26bcb5b-a0e0-40a2-812a-faaaf2cf86ed"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"48c71bbb-4aa3-4df0-aea4-11581ea60e3f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2. Notations", \
"Subsection",ExpressionUUID->"5905c280-996b-4d17-b528-eac21455b944"],

Cell[CellGroupData[{

Cell["5.2.0. Comments", \
"Subsubsection",ExpressionUUID->"3811ab86-a5eb-4f4f-8daf-0171d375e8a4"],

Cell["\<\
Note the difference between an AbstractIndex (symbol a, for example) and an \
AIndex (either a or -a, or a$10). AIndex is
\ta) any symbol in $AbstractIndices modulo UpIndex/DownIndex and dollar
\tb) which is at one of the expected positions for a g-index (in particular, \
never a head)

Comments:
\t- The functions defined in this subsection 5.2. act directly on the \
indices, and not on the objects having indices.
\t- None of the functions in this section holds its arguments; that is, all \
arguments are evaluated before the function is applied.
\t- There is no ERROR[...] output. ERROR only wraps whole mathinput \
expressions.
\t
Given a vector space V with abstract indices a, b, c, ... then we have its \
dual V* with indices -a, -b, -c, ..., its complex conjugate V\[Dagger] with \
indices a\[Dagger], b\[Dagger], c\[Dagger], ..., and the dual of the latter V\
\[Dagger]* with indices -a\[Dagger], -b\[Dagger], -c\[Dagger], ... We need to \
be able to manipulate those four cases simultaneously. Note that even though \
there is a close relation between indices a, -a or between a\[Dagger], -a\
\[Dagger], there is no relation whatsoever between indices a, a\[Dagger]. \
Frequently Hermitain pairs of indices are represented using  something like \
a, a\[Dagger], but this is not necessary, and we will not assume that a pair \
like that is always a Hermitian pair. To change from V to V* use ChangeIndex, \
and to change from V to V\[Dagger] use DaggerIndex.

The functions in the following four subsections have been defined to minimize \
interferences among them. They have also been designed to be as little \
restrictive as possible:
\t- UpIndex/DownIndex/ChangeIndex essentially play with the minus sign
\t- EIndexQ/BlockedQ define which indices can be contracted and then use \
ChangeIndex to find pairs.
\t- NoDollar removes a $ sign from an index, independently of its up/down \
character of its contractibility.
\t- DaggerIndex adds a \[Dagger] sign to an abstract index, with the \
convention that \[Dagger] always comes before $.

In version 1.0 we add index-modifiers. It would be nice if those modifiers \
didn't change the type of index, but because the type is hardwired in the \
expression pattern, this is not possible. Hence, we consider a new type of \
indices, called \"modified indices\", say of type MIndex (not defined yet), \
of the form mod[aindex]. Index-modifiers give True under IModQ. Right now we \
have only bases.\
\>", "Text",ExpressionUUID->"3816784d-6cd2-4b4d-9276-2a6d4437f6a2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IModQ", "[", 
    RowBox[{"_Symbol", "?", "BasisQ"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IModQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IModQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IModQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"321a33e1-7f2c-470d-8bd3-dd4e92a47bb7"],

Cell["\<\
A very important issue is that of indices in a 1D vector space. The key point \
is that we only need one index, say O. Then a tensor we will have scalars T[] \
or T[O,-O], T[O, -O, -O, O], etc, vectors T[O], T[O, O, -O], etc. In order to \
know the free indices and the component indices we need to know how many \
there are.\
\>", "Text",ExpressionUUID->"6d74097d-f0df-4133-b4e4-a90e776771ae"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
5.2.1. Up/Down: UpIndex, DownIndex, ChangeIndex, UpIndexQ, DownIndexQ. Also \
private upQ, downQ\
\>", "Subsubsection",ExpressionUUID->"8e8285ef-2eb8-46af-9bd2-9c0bd4bf6dc8"],

Cell["\<\
0) There are many ways of representing upstairs/downstairs indices. They all \
boil down to the introduction of three concepts:
\tindices: a, b, c,...
\tupindices: up[a], up[b], up[c],...
\tdownindices: down[a], down[b], down[c],...
where up, down represent some notational actions obeying 7 properties:
\tup[up[a]] = up[a]
\tup[down[a]] = up[a]
\tdown[up[a]] = down[a]
\tdown[down[a]] = down[a]
\tnoupdown[up[a]] = a
\tnoupdown[down[a]] = a
\tnoupdown[a] = a
It would be very nice to implement some easy way to change from one notation \
to another, but I think that it would slow down the computations.

Here I choose the simplest representation of the up/down, which identifies \
indices and upindices. (There is a clear asymmetry here.) It is also used as \
a check on g-indices. Note that the sign on integers must be dealt with \
separately because the -_ pattern does not match a negative integer:\
\>", "Text",ExpressionUUID->"3b87ca43-ad7b-4a72-a644-9cf563e48adc"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"a5fd7af5-8856-4599-94a7-adf6117183d0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"List", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}], ",", "1", ",", 
    RowBox[{"-", "1"}], ",", 
    RowBox[{"-", 
     RowBox[{"{", "1", "}"}]}]}], "]"}], "/.", 
  RowBox[{
   RowBox[{"-", "x_"}], "\[Rule]", 
   "xATP`down"}]}]], \
"Input",ExpressionUUID->"fb494f3e-dbe5-44a8-842c-7d62f735ad56"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "xAct`xTensor`Private`down", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"b419a68b-50b0-420f-8454-9e96990befad"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "x"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"1a4dc634-e0bb-4738-a6c2-ba2cdad9c8ac"],

Cell["\<\
1) UpIndex / DownIndex / ChangeIndex on g-indices and patterns.\
\>", "Text",ExpressionUUID->"cba82ce1-617e-462f-89fc-3d5b08a361df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UpIndex"}]], \
"Input",ExpressionUUID->"740ef11b-19bb-4df2-a0eb-b292209548a0"],

Cell[BoxData[
 StyleBox["\<\"UpIndex[ind] converts ind into an up-index: On expressions of \
the form -expr it returns expr. On basis- and component-indices UpIndex[{1, \
basis}] and UpIndex[{1, -basis}] return {1, basis}. On directions Dir[...] \
the function UpIndex returns a covector. On other cases it returns the input \
expr.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672391-5338953",ExpressionUUID->"6f8f73ad-2e09-457e-b779-\
637192e23692"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DownIndex"}]], \
"Input",ExpressionUUID->"6f158524-15e9-4ac0-9f96-80867d3cc889"],

Cell[BoxData[
 StyleBox["\<\"DownIndex[ind] converts ind into a down-index, returning \
opposite results to UpIndex.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672392-5338953",ExpressionUUID->"abcd0c09-7a38-4ffc-9069-\
9cf852dc2b06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChangeIndex"}]], \
"Input",ExpressionUUID->"dba0c2b0-5316-4bc9-9da1-f41a5adeecc4"],

Cell[BoxData[
 StyleBox["\<\"ChangeIndex[ind] converts up-indices to down-indices and \
viceversa.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672393-5338953",ExpressionUUID->"de8a42da-4070-4cd3-9961-\
45089114fde7"]
}, Open  ]],

Cell["Indices of types B, C, D require special handling:", \
"Text",ExpressionUUID->"ebe65430-f129-4248-8e0b-434fdd41ecdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Exception", ":", " ", 
    RowBox[{"D", "-", "indices"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UpIndex", "[", 
      RowBox[{"Dir", "[", "v_", "]"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", "=", 
         RowBox[{"UltraindexOf", "[", "v", "]"}]}], "}"}], ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"ReplaceIndex", "[", 
         RowBox[{"v", ",", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"DownIndex", "[", "u", "]"}]}]}], "]"}], "]"}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndex", "[", 
      RowBox[{"Dir", "[", "v_", "]"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", "=", 
         RowBox[{"UltraindexOf", "[", "v", "]"}]}], "}"}], ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"ReplaceIndex", "[", 
         RowBox[{"v", ",", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"UpIndex", "[", "u", "]"}]}]}], "]"}], "]"}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeIndex", "[", 
      RowBox[{"Dir", "[", "v_", "]"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", "=", 
         RowBox[{"UltraindexOf", "[", "v", "]"}]}], "}"}], ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"ReplaceIndex", "[", 
         RowBox[{"v", ",", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"ChangeIndex", "[", "u", "]"}]}]}], "]"}], "]"}]}], 
      "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"abb21141-8cbf-4b21-b761-91add9627d57"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Exception", ":", " ", 
    RowBox[{"C", "-", 
     RowBox[{"indices", ".", " ", "BASIS1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UpIndex", "[", 
      RowBox[{"{", 
       RowBox[{"a_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"UpIndex", "[", "basis", "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndex", "[", 
      RowBox[{"{", 
       RowBox[{"a_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"DownIndex", "[", "basis", "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeIndex", "[", 
      RowBox[{"{", 
       RowBox[{"a_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"-", "basis"}]}], "}"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"777000be-b88e-4576-8c70-2c369e0d8b24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Exception", ":", " ", 
    RowBox[{"B", "-", 
     RowBox[{"Indices", ".", " ", "BASIS1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"UpIndex", "[", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "basis_"}], "}"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"UpIndex", "[", "a", "]"}], ",", 
      RowBox[{"UpIndex", "[", "basis", "]"}]}], "}"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6e87b9ff-5f6e-4d86-8449-2394e918e7ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"New", " ", 
    RowBox[{"exception", ":", " ", "integers"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"UpIndex", "[", 
     RowBox[{"a_Integer", "?", "Negative"}], "]"}], ":=", 
    RowBox[{"-", "a"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"49dcecd9-7b12-4a2e-afd5-53ee037925b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Main", " ", "definitions"}], ",", " ", 
    RowBox[{"handling", " ", "all", " ", "other", " ", "cases"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UpIndex", "[", 
      RowBox[{"-", "a_"}], "]"}], ":=", "a"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndex", "[", "a_", "]"}], ":=", "a"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndex", "[", "a_", "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"UpIndex", "[", "a", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChangeIndex", "[", "a_", "]"}], ":=", 
     RowBox[{"-", "a"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"eef6d310-513f-4dba-b8b3-1ee7d5ebf0d2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"UpIndex", ",", "DownIndex", ",", "ChangeIndex"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"UpIndex", ",", "DownIndex", ",", "ChangeIndex"}], "]"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0da74358-1318-450c-b0be-011a8cbe43ef"],

Cell["\<\
Note that by definition, nearly everything without a minus in front, \
including Blank[] or some other patterns for downindices, is an upper index. \
The way to avoid problems is giving heads (that is, the argument of Blank) to \
the patterns. Non-head patterns with a minus in front are not problematic.\
\>", "Text",ExpressionUUID->"3c57bcbe-5b19-40dc-8ccb-83dc638df805"],

Cell["\<\
It is not interesting to set the attribute HoldAll to UpIndex because that \
could prevent many expected evaluations. For example the evaluation of \
temporary indices in Module. We have already said that we assume that \
g-indices can be evaluated at any stage.\
\>", "Text",ExpressionUUID->"763dda05-9112-43bc-9c1e-8a12d6bed7d0"],

Cell["Examples:", \
"Text",ExpressionUUID->"cb95ff21-434b-48d8-9e63-48cf5b4d6903"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"d1e86dae-0714-4891-80dc-47667d958119"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpIndex", "[", "_", 
  "]"}]], "Input",ExpressionUUID->"ba2bf276-17ae-4cb0-b180-ad0576a5e7e5"],

Cell[BoxData["_"], \
"Output",ExpressionUUID->"cde480d3-460d-493c-97cf-af333f09568a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpIndex", "[", 
  RowBox[{"-", "_"}], 
  "]"}]], "Input",ExpressionUUID->"05217e69-1c78-41d5-aa8d-902775a4d2f6"],

Cell[BoxData["_"], \
"Output",ExpressionUUID->"34cf9023-314a-49ad-b3ca-cf17df2e10ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpIndex", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "b"}], ",", "ab", ",", "a1", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "k_"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", "1", ",", 
    RowBox[{"-", "1"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"77a0354b-18f7-4591-aa24-1b035378f55d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "b", ",", "ab", ",", "a1", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k_", ",", "Polar"}], "}"}], ",", "1", ",", "1"}], 
  "}"}]], "Output",ExpressionUUID->"ea52b81d-0e6e-4348-a4d7-0723b9341d9c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpIndex", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", "_", ",", 
    RowBox[{"-", "_"}], ",", "a_", ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"a_", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"a_", "?", "Q"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"4adfd690-6bb3-469a-ae82-56f0e797ac45"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "a", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "Polar"}], "}"}], ",", "_", ",", "_", ",", "a_",
    ",", "a_", ",", 
   RowBox[{"a_", "?", "Q"}], ",", 
   RowBox[{"a_", "?", "Q"}]}], 
  "}"}]], "Output",ExpressionUUID->"f9bc9d91-59f3-4abe-9854-bd939fe0df24"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DownIndex", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", "_", ",", 
    RowBox[{"-", "_"}], ",", "a_", ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"a_", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"a_", "?", "Q"}]}], ",", "1", ",", 
    RowBox[{"-", "1"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"f6b514e3-cfd1-4a5c-8df2-4b16af518372"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "a"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"-", "_"}], ",", 
   RowBox[{"-", "_"}], ",", 
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"-", 
    RowBox[{"a_", "?", "Q"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"a_", "?", "Q"}]}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}]}], 
  "}"}]], "Output",ExpressionUUID->"99f7311a-2eb6-49b1-90a0-2c698022f38e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpIndex", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Polar", "[", "a", "]"}], ",", 
    RowBox[{"Polar", "[", "1", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "1", "]"}]}], ",", 
    RowBox[{"Polar", "[", 
     RowBox[{"-", "1"}], "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", 
      RowBox[{"-", "1"}], "]"}]}]}], 
   "}"}]}]], "Input",ExpressionUUID->"dd60d632-f83e-4d74-a652-8467e132753d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"Polar", "[", "1", "]"}], ",", 
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"Polar", "[", "1", "]"}], ",", 
   RowBox[{"Polar", "[", 
    RowBox[{"-", "1"}], "]"}], ",", 
   RowBox[{"Polar", "[", 
    RowBox[{"-", "1"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"6860131e-d476-43f1-959f-7d388deeae27"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DownIndex", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Polar", "[", "a", "]"}], ",", 
    RowBox[{"Polar", "[", "1", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "1", "]"}]}], ",", 
    RowBox[{"Polar", "[", 
     RowBox[{"-", "1"}], "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", 
      RowBox[{"-", "1"}], "]"}]}]}], 
   "}"}]}]], "Input",ExpressionUUID->"3b6e7114-24c8-44c4-a7bd-2dcb3b6d2b81"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "1", "]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "1", "]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", 
     RowBox[{"-", "1"}], "]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", 
     RowBox[{"-", "1"}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"c5d09261-6b98-4e9f-bf48-d02dfa2f1237"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "+", 
  "%%"}]], "Input",ExpressionUUID->"f3831e7a-3e57-4534-adc7-c1d30c4a8bfd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"83b31064-9a35-4146-bea6-4d5cfc99ed89"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"UpIndex", "[", 
   RowBox[{"-", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"b3196482-6b60-431c-91e6-47ae25a80869"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"UpIndex", "[", 
     RowBox[{"-", "b"}], "]"}],
    HoldForm], ",", 
   TagBox["b",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"e925b64c-3d9d-4cd2-9638-58b88ca3cb82"]
}, Open  ]],

Cell["Examples with ChangeIndex:", \
"Text",ExpressionUUID->"65e344e8-8218-482f-91a4-fd2ef25a9ae3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeIndex", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", "a_", ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"a_", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"a_", "?", "Q"}]}], ",", 
    RowBox[{"Polar", "[", "a", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], ",", "1", ",", 
    RowBox[{"-", "1"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"e492c35f-ec75-4e80-8809-49881d5bfe44"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "a"}], ",", "a", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "Polar"}], "}"}], ",", 
   RowBox[{"-", "a_"}], ",", "a_", ",", 
   RowBox[{"-", 
    RowBox[{"a_", "?", "Q"}]}], ",", 
   RowBox[{"a_", "?", "Q"}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"-", "1"}], ",", "1"}], 
  "}"}]], "Output",ExpressionUUID->"acc8bcc6-b0ed-492f-af6f-cb178cbc2625"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "a1", ",", "ab", ",", "b", ",", "k", ",", "Polar", ",", "Q"}], 
  "]"}]], "Input",ExpressionUUID->"70f7694c-06a9-42db-a1a8-8d63c03119fb"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5b673b46-bd44-400e-a5b2-800f14259dad"],

Cell["\<\
2) We implement two types of UpQ functions. The first one is purely based on \
UpIndex and it is as general as UpIndex and perfectly consistent with it. \
Everything which is not recognized returns True under upQ and False under \
downQ. There are no errors, perhaps except those coming from D-indices. This \
is a function to be used only in programming, in those places in which we \
could be working with patterns:\
\>", "Text",ExpressionUUID->"e4f6ca00-3bf1-4a52-aa70-9b4598b3e2ea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "upQ"}]], "Input",ExpressionUUID->"3a9fe236-283a-416c-a1bc-4ce29f2f5329"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`upQ[ind] gives True if ind is an up-index and \
False otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672395-5338953",ExpressionUUID->"b6d1cecb-7887-433d-b23c-\
5af0a832265c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "downQ"}]], "Input",ExpressionUUID->"f64a7f00-ff79-4d89-8f7c-49e90bff33e5"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`downQ[ind] gives True if ind is a down-index \
and False otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672397-5338953",ExpressionUUID->"c6abad30-2e75-4b24-9ef9-\
6a7cb15bc768"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"upQ", "[", "a_", "]"}], ":=", 
  RowBox[{"a", "===", 
   RowBox[{"UpIndex", "[", "a", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"downQ", "[", "a_", "]"}], ":=", 
  RowBox[{"a", "===", 
   RowBox[{"DownIndex", "[", "a", "]"}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"38f01308-36dd-4f3c-83e8-ba1f1676821d"],

Cell["\<\
Secondly, these are the user functions, which give always False on patterns. \
That is the only difference with upQ and downQ.  Note that there is no \
AbstractIndexQ check nor BasisQ, but we include an IModQ check. This is more \
a plausibility check than a real check. That is, we are checking the \
notations for up-indices and down-indices, not the fact that the indices are \
proper g-indices. Note also that they are constructed independently of \
UpIndex and DownIndex.\
\>", "Text",ExpressionUUID->"5f9b58b6-d6a7-4adc-b4f6-8dbc9cdce02f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Accepted", " ", "notations", " ", "for", " ", "up"}], "-", 
    "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", "a_Symbol", "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", "a_LI", "]"}], ":=", "True"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", "a_Dir", "]"}], ":=", 
     RowBox[{"DownIndexQ", "[", 
      RowBox[{"UltraindexOf", "[", "a", "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", "a_Integer", "]"}], ":=", 
     RowBox[{"Positive", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", "b_Symbol"}], "}"}], "]"}], ":=", "True"}], ";", 
    " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b_", "?", "IModQ"}], ")"}], "[", "a_", "]"}], "]"}], ":=", 
     "True"}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIndexQ", "[", "a_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"UpIndexQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "UpIndexQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"aecddd34-c89c-4a0b-b956-449f9c171cfc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Accepted", " ", "notations", " ", "for", " ", "down"}], "-", 
    "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", 
      RowBox[{"-", "a_Symbol"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", 
      RowBox[{"-", "a_LI"}], "]"}], ":=", "True"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", "a_Dir", "]"}], ":=", 
     RowBox[{"UpIndexQ", "[", 
      RowBox[{"UltraindexOf", "[", "a", "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", "a_Integer", "]"}], ":=", 
     RowBox[{"Negative", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", 
        RowBox[{"-", "b_Symbol"}]}], "}"}], "]"}], ":=", "True"}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b_", "?", "IModQ"}], ")"}], "[", "a_", "]"}]}], "]"}], ":=",
      "True"}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DownIndexQ", "[", "a_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"DownIndexQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "DownIndexQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"771bdf77-554b-48e9-b410-216fa76028e0"],

Cell["\<\
Those two functions are stricter than upQ and downQ. Therefore, if a new type \
of index is introduced, even if it follows the plus/minus rules, new \
definitions will be needed here.\
\>", "Text",ExpressionUUID->"74887b1b-e9a3-4751-9df2-a3486ced0c14"],

Cell["\<\
UpIndexQ is used in all cases except the following five, in which we use upQ:
\t- TakeUp: for generality. We get the up-patterns as well.
\t- IndexSort: to sort patterns
\t- DummyAs
\t- addChristoffel
\t- xTensorFormStart: to format patterns
Then downQ is used only in
\t- IndexSort: to sort patterns
\t- MakeBoxesCovD\
\>", "Text",ExpressionUUID->"c5ba3fbc-4191-47d0-bb4e-b996e5761ccf"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"21888fd5-0c51-415e-bd29-ead8d61b90d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"list", "=", 
   RowBox[{"List", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", "_", ",", "a_", ",", 
     RowBox[{"-", "a_"}], ",", 
     RowBox[{"a_", "?", "Q"}], ",", 
     RowBox[{"-", 
      RowBox[{"a_", "?", "Q"}]}], ",", "1", ",", 
     RowBox[{"-", "1"}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"dfe4ad71-d14e-41f3-a3e0-f30e614e1b58"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"upQlist", "=", 
  RowBox[{
  "xATP`upQ", "/@", 
   "list"}]}]], \
"Input",ExpressionUUID->"c3c7d409-6b3c-4e72-8ad7-23472e364d04"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "False", ",", "False", ",", "True", ",", "True", ",", "True", 
   ",", "False", ",", "True", ",", "False", ",", "True", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"1fda1f75-d373-454b-b46b-570c0e5e232d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"downQlist", "=", 
  RowBox[{
  "xATP`downQ", "/@", 
   "list"}]}]], \
"Input",ExpressionUUID->"dba6e587-b142-4d39-a5c3-77664e792358"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "False", ",", "True", ",", "True", ",", "False", ",", "False", ",", "False",
    ",", "True", ",", "False", ",", "True", ",", "False", ",", "True"}], 
  "}"}]], "Output",ExpressionUUID->"e2ea3456-5b9d-4b4a-962f-3194db073398"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpIndexQlist", "=", 
  RowBox[{
  "UpIndexQ", "/@", 
   "list"}]}]], \
"Input",ExpressionUUID->"578b47cb-f3ba-403b-9551-5e85df1b4fea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "False", ",", "False", ",", "True", ",", "False", ",", "False",
    ",", "False", ",", "False", ",", "False", ",", "True", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"8af375a1-f3d5-48ed-9581-788787ac5fae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DownIndexQlist", "=", 
  RowBox[{
  "DownIndexQ", "/@", 
   "list"}]}]], \
"Input",ExpressionUUID->"97389ab5-b33d-47a2-9f77-0f185ba42cfa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "False", ",", "True", ",", "True", ",", "False", ",", "False", ",", "False",
    ",", "False", ",", "False", ",", "False", ",", "False", ",", "True"}], 
  "}"}]], "Output",ExpressionUUID->"53f68851-4c2a-43c2-a8ca-ae7bee2d46d8"]
}, Open  ]],

Cell[TextData[{
 "Note that upQ and downQ are always different, while UpIndexQ and DownIndexQ \
always coincide on non-recognized indices and patterns, giving False. I don't \
know why ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " generates so many OutputFormDump` variables here:"
}], "Text",ExpressionUUID->"71ae2219-c072-4bc9-8356-52bf307a69b8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ToString", "/@", "list"}], ",", "upQlist", ",", "downQlist", 
      ",", "UpIndexQlist", ",", "DownIndexQlist"}], "}"}], "]"}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Index\>\"", ",", "\"\<upQ\>\"", ",", "\"\<downQ\>\"", ",", 
        "\"\<UpIndexQ\>\"", ",", "\"\<DownIndexQ\>\""}], "}"}]}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"b0ec4e52-0b56-4455-8806-d84c3d8bbe67"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"Index\"\>",
       HoldForm], 
      TagBox["\<\"upQ\"\>",
       HoldForm], 
      TagBox["\<\"downQ\"\>",
       HoldForm], 
      TagBox["\<\"UpIndexQ\"\>",
       HoldForm], 
      TagBox["\<\"DownIndexQ\"\>",
       HoldForm]},
     {"1", "\<\"a\"\>", "True", "False", "True", "False"},
     {"2", "\<\"-a\"\>", "False", "True", "False", "True"},
     {"3", "\<\"{1, -Polar}\"\>", "False", "True", "False", "True"},
     {"4", "\<\"{1, Polar}\"\>", "True", "False", "True", "False"},
     {"5", "\<\"_\"\>", "True", "False", "False", "False"},
     {"6", "\<\"a_\"\>", "True", "False", "False", "False"},
     {"7", "\<\"-(a_)\"\>", "False", "True", "False", "False"},
     {"8", "\<\"(a_)?Q\"\>", "True", "False", "False", "False"},
     {"9", "\<\"-(a_)?Q\"\>", "False", "True", "False", "False"},
     {"10", "\<\"1\"\>", "True", "False", "True", "False"},
     {"11", "\<\"-1\"\>", "False", "True", "False", "True"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[2.0999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "Index", "upQ", "downQ", "UpIndexQ", 
       "DownIndexQ"}}]]]], \
"Output",ExpressionUUID->"1b74daff-3a00-451f-b94f-8ab71ec11fd3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "Polar", ",", "Q", ",", "list", ",", "upQlist", ",", "downQlist", 
   ",", "UpIndexQlist", ",", "DownIndexQlist"}], 
  "]"}]], "Input",ExpressionUUID->"25772f14-2e53-4546-95b2-6a37160ad255"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5f18fe5e-a033-402d-8615-6042f27efb29"],

Cell["\<\
Again, it would be nice to define everything in terms of UpIndex, DownIndex \
and ChangeIndex, without using signs anymore. That would allow us to easily \
change notation of up/down indices. However it would be rather slow.\
\>", "Text",ExpressionUUID->"1f83e884-ce2e-4959-aa1a-63e694d85b12"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.2. Contraction", \
"Subsubsection",ExpressionUUID->"5f6cf892-1966-4351-8668-3763bc8c539a"],

Cell["\<\
0) First of all we need to specify which indices can be considered as \
representing a contraction and which cannot. Abstract indices are always \
contractible:\
\>", "Text",ExpressionUUID->"53e87b8d-cd0d-4094-b882-ebc35df73b0c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "EIndexQ"}]], \
"Input",ExpressionUUID->"ee0a86f9-af92-4dd1-acec-1dbf70047a76"],

Cell[BoxData[
 StyleBox["\<\"EIndexQ[ind] identifies indices which can obey the Einstein \
convention, returning opposite results to BlockedQ. We call them Einstein, \
contractible or traceable indices.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672399-5338953",ExpressionUUID->"83e0cdfc-b9e4-4ca6-a124-\
2f8e34bcec0a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "BlockedQ"}]], \
"Input",ExpressionUUID->"8ae2f097-a6d6-49ef-8435-f8f6c2c773eb"],

Cell[BoxData[
 StyleBox["\<\"BlockedQ[ind] returns True on blocked indices: types C, D and \
L. On other cases (traceable indices) it returns False, including indices of \
types A, B and patterns.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672400-5338953",ExpressionUUID->"15d641e4-4a5f-4087-a374-\
9ded46cca290"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Signs", " ", "are", " ", "irrelevant", " ", "for", " ", 
    "contractibility"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "[", 
      RowBox[{"-", "a_"}], "]"}], ":=", 
     RowBox[{"EIndexQ", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BlockedQ", "[", 
      RowBox[{"-", "a_"}], "]"}], ":=", 
     RowBox[{"BlockedQ", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Abstract", " ", "indices", " ", "are", " ", "always", " ", 
     "contractible"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "[", "_Symbol", "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Blocked", "[", "_Symbol", "]"}], ":=", "False"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f2ed6f26-e2c2-4f83-a45e-7b9b3a9d0cc0"],

Cell["\<\
We can define these two functions specifying which types (A, B) are \
contractible and defining everything else to be blocked, including patterns \
(now deactivated):\
\>", "Text",ExpressionUUID->"fe6969c0-7196-4833-8480-d159b04fbd0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Priority", " ", "to", " ", "EIndexQ"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", "_"}], "}"}], "]"}], ":=", 
     RowBox[{"EIndexQ", "[", "a", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "[", 
      RowBox[{
       RowBox[{"_", "?", "IModQ"}], "[", "a_", "]"}], "]"}], ":=", 
     RowBox[{"EIndexQ", "[", "a", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "[", "_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BlockedQ", "[", "a_", "]"}], ":=", 
     RowBox[{"Not", "@", 
      RowBox[{"EIndexQ", "[", "a", "]"}]}]}], ";"}]}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"97b55fba-1b8f-4619-9f7d-33c1cbf82ce6"],

Cell["\<\
We proceed in the reverse way, removing blocked indices of types C, D, L. \
This is to allow contraction in the general case, for example with patterns \
or modified indices (note that imod[integer] is considered here a e-index, \
unless the imod is a basis) :\
\>", "Text",ExpressionUUID->"3e450b31-d984-4a99-9386-237cdc142cdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Priority", " ", "to", " ", "BlockedQ"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"BlockedQ", "[", 
       RowBox[{"{", 
        RowBox[{"_Integer", ",", "_"}], "}"}], "]"}], ":=", "True"}], ";"}], 
    " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"BlockedQ", "[", 
       RowBox[{
        RowBox[{"_Symbol", "?", "BasisQ"}], "[", "_Integer", "]"}], "]"}], ":=",
       "True"}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BlockedQ", "[", "_LI", "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BlockedQ", "[", "_Dir", "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BlockedQ", "[", "_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EIndexQ", "[", "a_", "]"}], ":=", 
     RowBox[{"Not", "@", 
      RowBox[{"BlockedQ", "[", "a", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SetNumberOfArguments", "[", 
       RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", 
     RowBox[{"{", 
      RowBox[{"EIndexQ", ",", "BlockedQ"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", 
     RowBox[{"EIndexQ", ",", "BlockedQ"}], "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"606d08d2-067b-4d10-9b7b-4860c19f9ed3"],

Cell["\<\
1) Contractible indices can be in two different states: contracted (or dummy) \
or non-contracted (or free). Now we need functions to select free and dummy \
indices from a list of g-indices and patterns. Note that they are defined in \
terms of EIndexQ and ChangeIndex, and do not use UpIndex or DownIndex. Note \
also that there is no assumption on the head of the lists of indices: the \
final list will have the same head of the input.\
\>", "Text",ExpressionUUID->"68d02463-b165-44e0-8828-dc3427743cac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Separate", " ", "E"}], "-", 
    RowBox[{"indices", " ", "from", " ", "blocked", " ", "indices"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TakeEIndices", "[", "list_", "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "EIndexQ"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeBlocked", "[", "list_", "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "BlockedQ"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Take", " ", "or", " ", "drop", " ", "pairs"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakePairs", "[", 
      RowBox[{"list1_", ",", "list2_"}], "]"}], ":=", 
     RowBox[{"Intersection", "[", 
      RowBox[{"list1", ",", 
       RowBox[{"ChangeIndex", "/@", "list2"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DropPairs", "[", 
      RowBox[{"list1_", ",", "list2_"}], "]"}], ":=", 
     RowBox[{"Complement", "[", 
      RowBox[{"list1", ",", 
       RowBox[{"ChangeIndex", "/@", "list2"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakePairs", "[", "list_", "]"}], ":=", 
     RowBox[{"TakePairs", "[", 
      RowBox[{"list", ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DropPairs", "[", "list_", "]"}], ":=", 
     RowBox[{"DropPairs", "[", 
      RowBox[{"list", ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Take", " ", "or", " ", "drop", " ", "E"}], "-", "pairs"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeEPairs", "[", "list_", "]"}], ":=", 
     RowBox[{"TakePairs", "[", 
      RowBox[{"list", ",", 
       RowBox[{"TakeEIndices", "[", "list", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DropEPairs", "[", "list_", "]"}], ":=", 
     RowBox[{"DropPairs", "[", 
      RowBox[{"list", ",", 
       RowBox[{"TakeEIndices", "[", "list", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeFrees", "[", "list_", "]"}], ":=", 
     RowBox[{"DropPairs", "[", 
      RowBox[{"TakeEIndices", "[", "list", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TakeOrderedEPairs", "[", "list_", "]"}], ":=", 
     RowBox[{"DeleteCases", "[", 
      RowBox[{"list", ",", 
       RowBox[{"Alternatives", "@@", 
        RowBox[{"Verbatim", "/@", 
         RowBox[{"DropEPairs", "[", "list", "]"}]}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"238b914f-3f62-4730-ab65-158c8623f807"],

Cell["\<\
Summarizing: given a list of indices, we can separate:
\t- blocked indices: TakeBlocked
\t- free indices: TakeFrees
\t- dummy pairs: TakePairs or TakeOrderedEPairs\
\>", "Text",ExpressionUUID->"4faa61d8-ba17-4cda-b2a9-05e1167df0c4"],

Cell["Examples:", \
"Text",ExpressionUUID->"64967026-62c8-4564-9043-1d70dca418ca"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"20fa4316-9940-44b0-be9d-3f94f4c4f3a6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "c"}], ",", 
    RowBox[{"-", "a"}], ",", "c", ",", 
    RowBox[{"-", "c"}], ",", "a", ",", 
    RowBox[{"-", "a"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"681db7a1-8e6b-4877-8f55-b5e23c570bea"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a"}], "\<\",\"\>", "a", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "c", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`a, $CellContext`a, -$CellContext`c, \
$CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"9d6a0f33-3633-4083-ba89-00c69e872877"]
}, Open  ]],

Cell["\<\
This motivates the complicated structure of the function TakeOrderedEPairs:\
\>", "Text",ExpressionUUID->"9733e09e-c037-4549-9d4b-4f1b100be377"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeOrderedEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "c"}], ",", 
    RowBox[{"-", "a"}], ",", "c", ",", 
    RowBox[{"-", "c"}], ",", "a", ",", 
    RowBox[{"-", "a"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c9aa79ae-a48e-4e78-bae2-5f2e187bd313"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", 
    RowBox[{"-", "a"}], "\<\",\"\>", "c", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "a", "\<\",\"\>", 
    RowBox[{"-", "a"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, -$CellContext`c, -$CellContext`a, \
$CellContext`c, -$CellContext`c, $CellContext`a, -$CellContext`a],
  Editable->
   False]], "Output",ExpressionUUID->"8cf168ec-49e1-4f3b-9d65-c4916607879c"]
}, Open  ]],

Cell["Study these cases:", \
"Text",ExpressionUUID->"f15836a5-f7a8-44d0-b5d7-67f6ec178360"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "a"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a", "]"}], "]"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a", "]"}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5ccedccf-19a8-4d6a-b791-4688e7f828b1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a"}], "\<\",\"\>", "a", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`a, $CellContext`a],
  Editable->
   False]], "Output",ExpressionUUID->"16ae5e3d-ea71-4750-8505-96a1f3dc66a2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisQ", "[", "Polar", "]"}], "^=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"2b07132b-55e3-45ae-b393-2d8035d0f3d8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakePairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "c"}], ",", 
    RowBox[{"-", "a"}], ",", "c", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"Polar", "[", "1", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "1", "]"}]}], ",", 
    RowBox[{"Pr", "[", "a", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Pr", "[", "a", "]"}]}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"d8deb19e-4edd-414a-a7f9-083e01c7f63b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a"}], "\<\",\"\>", "a", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "c", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"b", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "1", "]"}]}], "\<\",\"\>", 
    RowBox[{"Polar", "[", "1", "]"}], "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"Pr", "[", "a", "]"}]}], "\<\",\"\>", 
    RowBox[{"Pr", "[", "a", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`a, $CellContext`a, -$CellContext`c, \
$CellContext`c, {-$CellContext`b, -$CellContext`Polar}, {$CellContext`b, \
$CellContext`Polar}, -$CellContext`Polar[1], 
   $CellContext`Polar[1], -$CellContext`Pr[$CellContext`a], 
   $CellContext`Pr[$CellContext`a]],
  Editable->
   False]], "Output",ExpressionUUID->"7e0557cc-9295-4722-ab66-45dc5d7eb6da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "c"}], ",", 
    RowBox[{"-", "a"}], ",", "c", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"Polar", "[", "1", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "1", "]"}]}], ",", 
    RowBox[{"Pr", "[", "a", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Pr", "[", "a", "]"}]}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"75296991-6c69-4591-94db-939d54df6691"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a"}], "\<\",\"\>", "a", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "c", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"b", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"Pr", "[", "a", "]"}]}], "\<\",\"\>", 
    RowBox[{"Pr", "[", "a", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`a, $CellContext`a, -$CellContext`c, \
$CellContext`c, {-$CellContext`b, -$CellContext`Polar}, {$CellContext`b, \
$CellContext`Polar}, -$CellContext`Pr[$CellContext`a], 
   $CellContext`Pr[$CellContext`a]],
  Editable->
   False]], "Output",ExpressionUUID->"10bf7297-a4b4-4bb2-b05d-ac9ccc55d73c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "c"}], ",", 
    RowBox[{"-", "a"}], ",", "c", ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], ",", 
    RowBox[{"Polar", "[", "b", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "b", "]"}]}], ",", 
    RowBox[{"Pr", "[", "a", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Pr", "[", "a", "]"}]}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"26e1c3bb-3668-42ee-a354-4973f02289b0"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a"}], "\<\",\"\>", "a", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "c", "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "b", "]"}]}], "\<\",\"\>", 
    RowBox[{"Polar", "[", "b", "]"}], "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"Pr", "[", "a", "]"}]}], "\<\",\"\>", 
    RowBox[{"Pr", "[", "a", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`a, $CellContext`a, -$CellContext`c, \
$CellContext`c, -$CellContext`Polar[$CellContext`b], 
   $CellContext`Polar[$CellContext`b], -$CellContext`Pr[$CellContext`a], 
   $CellContext`Pr[$CellContext`a]],
  Editable->
   False]], "Output",ExpressionUUID->"d26a5a79-842c-43f1-8612-4f7aa8dd8afa"]
}, Open  ]],

Cell["\<\
Note that non-head patterns are not a problem here because in order to be \
paired we need to have a minus in front of one of the patterns. Here the \
problem are the non-named patterns, because there is no reason to assume that \
_ is paired with -_.\
\>", "Text",ExpressionUUID->"5a90c418-6dfd-463d-8ee4-eb9f4fff56ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a", "]"}], "]"}], ",", "a_", ",", 
    RowBox[{"b_", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"b_", "?", "Q"}]}], ",", 
    RowBox[{"b_", "?", "Q1"}], ",", "_", ",", 
    RowBox[{"-", "_"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"63656611-ccfc-4eab-a6dc-99e55cf701fb"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "_"}], "\<\",\"\>", "_", "\<\",\"\>", 
    RowBox[{"-", "a_"}], "\<\",\"\>", "a_", "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"b_", "?", "Q"}]}], "\<\",\"\>", 
    RowBox[{"b_", "?", "Q"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-Blank[], 
   Blank[], -Pattern[$CellContext`a, 
     Blank[]], 
   Pattern[$CellContext`a, 
    Blank[]], -PatternTest[
     Pattern[$CellContext`b, 
      Blank[]], $CellContext`Q], 
   PatternTest[
    Pattern[$CellContext`b, 
     Blank[]], $CellContext`Q]],
  Editable->
   False]], "Output",ExpressionUUID->"27597900-42c5-4643-aa5a-7449c6c676c5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeOrderedEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a", "]"}], "]"}], ",", "a_", ",", 
    RowBox[{"b_", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"b_", "?", "Q"}]}], ",", 
    RowBox[{"b_", "?", "Q1"}], ",", "_", ",", 
    RowBox[{"-", "_"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"889786a8-2f1b-4dc4-923a-2c2b5281d7f5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a_"}], "\<\",\"\>", "a_", "\<\",\"\>", 
    RowBox[{"b_", "?", "Q"}], "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"b_", "?", "Q"}]}], "\<\",\"\>", "_", "\<\",\"\>", 
    RowBox[{"-", "_"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-Pattern[$CellContext`a, 
     Blank[]], 
   Pattern[$CellContext`a, 
    Blank[]], 
   PatternTest[
    Pattern[$CellContext`b, 
     Blank[]], $CellContext`Q], -PatternTest[
     Pattern[$CellContext`b, 
      Blank[]], $CellContext`Q], 
   Blank[], -Blank[]],
  Editable->
   False]], "Output",ExpressionUUID->"e192ebea-bbef-4901-8162-0b7a6b2fb4ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"a_", "?", "Q"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"f486d82b-a804-483a-b2de-1a70dac01fca"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"e4140fcf-4df2-4849-b70d-6c5afada729a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "a_"}], ",", 
    RowBox[{"a_", "?", "Q"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"287d0d2a-3b8b-4965-bae1-7ce4cb1b4680"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"404d7208-e837-499b-8d29-6f2fdaaa782e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`TakeEPairs", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], ",", "_"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e8bfa822-8156-470a-81ac-5dda1f94b26f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"032e3872-7a80-4594-97ca-7f019a9140a4"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "b", ",", "c", ",", "Polar", ",", "Pr", ",", "Q", ",", "Q1", ",", 
   "v"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"f11dcdd4-29ed-4797-a331-516b6ec6c110"],

Cell["\<\
2) Imitate MathTensor's function PairQ. We could perhaps avoid it by removing \
the BASIS1 notation altogether.\
\>", "Text",ExpressionUUID->"1019dc7b-3c77-44db-8a05-c4e7f477c7c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "PairQ"}]], "Input",ExpressionUUID->"198bd6d3-1e3a-465b-ada5-5d7ec4c755ae"],

Cell[BoxData[
 StyleBox["\<\"PairQ[a, b] returns True if indices a, b form an Einstein pair \
of contracted indices. Currently this is only possible for a pair a, -a of \
abstract indices or a pair {a, B}, {-a,-B} of basis indices of the same basis \
B.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672402-5338953",ExpressionUUID->"a28ba8b2-aec7-4303-919b-\
a04f3bc5ad3a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Contracted", " ", "B"}], "-", "indices"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PairQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_Symbol", ",", "basis_Symbol"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "a_Symbol"}], ",", 
          RowBox[{"-", "basis_Symbol"}]}], "}"}]}], "]"}], ":=", "True"}], 
     ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PairQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "a_Symbol"}], ",", 
          RowBox[{"-", "basis_Symbol"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"a_Symbol", ",", "basis_Symbol"}], "}"}]}], "]"}], ":=", 
      "True"}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Contracted", " ", "AB"}], "-", "indices"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"including", " ", "BASIS2"}], " ", "&"}], " ", "IMOD"}]}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PairQ", "[", 
      RowBox[{"a_", ",", 
       RowBox[{"-", 
        RowBox[{"a_", "?", "EIndexQ"}]}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PairQ", "[", 
      RowBox[{
       RowBox[{"-", "a_"}], ",", 
       RowBox[{"a_", "?", "EIndexQ"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PairQ", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"PairQ", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "PairQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b5203fd4-d081-414d-b137-d50581fdd1ce"],

Cell["Examples:", \
"Text",ExpressionUUID->"6a8c4be6-020c-444c-a1ad-b1948fe4d671"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"29df8eb2-f29e-4004-8c08-757a35c59e02"],

Cell[BoxData[
 RowBox[{"rule", ":=", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
   RowBox[{
    RowBox[{"g", "[", "a", "]"}], "/;", 
    RowBox[{"PairQ", "[", 
     RowBox[{"b", ",", "a"}], 
     "]"}]}]}]}]], \
"Input",ExpressionUUID->"d9f779fa-8529-478f-8e4a-57c8c4e4a369"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", "a"}], "]"}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"4a78b3e8-59cc-4756-9f1a-0efa2009b33b"],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"-", "a"}], 
  "]"}]], "Output",ExpressionUUID->"ff79affa-89bb-4bd2-8523-8fe99704d318"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisQ", "[", "Polar", "]"}], "^=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"871230cd-b343-4e01-a8a3-27f490305bc3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "Polar"}], "}"}]}], "]"}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"da3d74fd-e0fd-41eb-b3cd-d675af3906ba"],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "Polar"}]}], "}"}], 
  "]"}]], "Output",ExpressionUUID->"d01997c1-8323-4f13-83bc-36654b360399"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", "a"}], "]"}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"39d4a2c7-6f5e-46ed-aef5-def6b7abcba9"],

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", "a"}], 
  "]"}]], "Output",ExpressionUUID->"1a77b060-f976-482d-98a5-e75ae324befe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], ",", 
    RowBox[{"Polar", "[", "a", "]"}]}], "]"}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"b75c1054-951b-4949-9fc2-ab65c69a41b7"],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"-", 
   RowBox[{"Polar", "[", "a", "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"9a2cfde5-f395-4a08-a9e8-ccc6e59fbcba"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "f", ",", "g", ",", "Polar", ",", "rule"}], 
  "]"}]], "Input",ExpressionUUID->"359fb1c9-b02d-4ccf-8133-34b5d818b127"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5c9bd49e-f119-4e03-beab-862185bf2ad9"],

Cell["\<\
3) This simple function returns an IndexList of the repeated indices in a \
given IndexList. Only one index per repeated set is returned. This function \
has nothing to do with Take(Ordered)EPairs. It looks for actually repeated \
g-indices (labels, directions and components). It is only used in \
ToCanonicalOne to look for the repes indices.\
\>", "Text",ExpressionUUID->"08f6d1c2-caca-477a-b96e-9711e0b4fbe7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TakeRepeated", "[", "list_IndexList", "]"}], ":=", 
  RowBox[{"First", "/@", 
   RowBox[{"DeleteCases", "[", 
    RowBox[{
     RowBox[{"Split", "@", 
      RowBox[{"Sort", "[", "list", "]"}]}], ",", 
     RowBox[{"IndexList", "[", "_", "]"}]}], "]"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"82698479-c53a-41ea-a544-2c1f8e83799d"],

Cell["\<\
This function is used to extract the up-indices of the (order-kept) lists of \
pairs of dummies:\
\>", "Text",ExpressionUUID->"e55b62ec-f9aa-46e0-a9d2-81c5bcace91a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TakeUp", "[", "list_", "]"}], ":=", 
   RowBox[{"DeleteDuplicates", "[", 
    RowBox[{"UpIndex", "/@", "list"}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"a056b25a-a530-4065-a4dd-dab84f25c158"],

Cell["That has been deactivated. Right now we use instead:", \
"Text",ExpressionUUID->"2dddf428-9bfc-4053-ad1f-0ef9140d6b9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TakeUp", "[", "list_", "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{"list", ",", "upQ"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3711abd0-6cf8-4ecb-8f4a-7a8d8b6a1ff1"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.3. Dummies: NoDollar, DollarQ", \
"Subsubsection",ExpressionUUID->"7e0f7ce3-dda7-462a-a1e9-a328b5f957a6"],

Cell[TextData[{
 "Dummy indices are those that are contracted in an expression. It is useful \
to use unique names for dummies, to avoid index collisions. Here I follow ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " convention of unique variables denoted with a dollar. Note that \n\ta) \
because I don't think this point will be changed, I introduce 'dollar' in the \
name of the function,\n\tb) dollars ARE eliminated from patterns (in the past \
this was not true),\n\tc) the definition on blanks must be in the first place \
to avoid confusion with the definition on a_\n\td) the ",
 "NoDollar",
 " index is generated by ToExpression rather than Symbol because it could \
contain a minus sign,\n\te) there are no problems with unheaded patterns.\nIt \
is important to see that the unique variables $nnn trick is only safe within \
a session. If you save a result and then read it in a different session, \
there could be collisions. In that case, don't forget to use ReplaceDummies \
first on the read expression."
}], "Text",ExpressionUUID->"4d63e29a-088f-4093-bcfe-ca86df59fc47"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "NoDollar"}]], \
"Input",ExpressionUUID->"91a056f0-8d30-4f4e-9f15-a35a0de6e2f7"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`NoDollar[ind] returns the symbol ind (possibly \
including a sign) removing all characters starting from the first $. Values \
are stored as upvalues of the index ind.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellTags->
  "Info3578672404-5338953",ExpressionUUID->"f07c0e3b-9ff2-4d07-ba60-\
d8382071fa82"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Patterns", ".", " ", "PINDEX"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "a_Blank", "]"}], ":=", "a"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", 
      RowBox[{"a", ":", 
       RowBox[{"(", 
        RowBox[{"_Pattern", "|", "_PatternTest"}], ")"}]}], "]"}], ":=", 
     RowBox[{"ReplacePart", "[", 
      RowBox[{"a", ",", 
       RowBox[{"NoDollar", "[", 
        RowBox[{"First", "[", "a", "]"}], "]"}], ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Symbols", ".", " ", "Use"}], " ", "remembered", " ", "values", 
     " ", "as", " ", "upvalues", " ", "of", " ", "the", " ", 
     RowBox[{"index", ".", " ", "Remove"}], " ", "from", " ", "the", " ", 
     "first", " ", "dollar"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "a_Symbol", "]"}], ":=", 
     RowBox[{
      RowBox[{"NoDollar", "[", "a", "]"}], "^=", 
      RowBox[{"ToExpression", "[", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{"Characters", "[", 
          RowBox[{"ToString", "[", "a", "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i___", ",", "\"\<$\>\"", ",", "___"}], "}"}], 
          "\[RuleDelayed]", 
          RowBox[{"{", "i", "}"}]}]}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Signs", ":", " ", 
     RowBox[{"anything", " ", "but", " ", "integers"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", 
      RowBox[{"-", "a_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"NoDollar", "[", "a", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Integers", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "a_Integer", "]"}], ":=", "a"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Directions", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "v_Dir", "]"}], ":=", "v"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", 
      RowBox[{"a", ":", 
       RowBox[{"-", "_Dir"}]}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "nouse"}], ",", "\"\<NoDollar\>\"", ",", 
        RowBox[{"ToString", "[", "a", "]"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Labels", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "a_LI", "]"}], ":=", "a"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Component", " ", "and", " ", "basis", " ", "indices"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"NoDollar", "[", 
       RowBox[{"{", 
        RowBox[{"a_", ",", "basis_"}], "}"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NoDollar", "[", "a", "]"}], ",", "basis"}], "}"}]}], ";"}], 
    " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", 
      RowBox[{
       RowBox[{"imod_", "?", "IModQ"}], "[", "a_", "]"}], "]"}], ":=", 
     RowBox[{"imod", "[", 
      RowBox[{"NoDollar", "[", "a", "]"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Other", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "nouse"}], ",", "\"\<NoDollar\>\"", ",", 
        "\"\<0 arguments\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", 
      RowBox[{"_", ",", "__"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "nouse"}], ",", "\"\<NoDollar\>\"", ",", 
        "\"\<more than 1 arguments\>\""}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoDollar", "[", "a_", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"General", "::", "warning"}], ",", 
         RowBox[{"\"\<NoDollar has been used on \>\"", "<>", 
          RowBox[{"ToString", "[", "a", "]"}]}], ",", "$WarningFrom"}], "]"}],
        ";", "a"}], ")"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f8c446bb-2a9b-42e0-a282-8b068cee3075"],

Cell[TextData[{
 "It takes some time to convert a dollar-index to an index. That's why we \
define the function with \"remembered values\" on symbols. The special \
capital symbols cannot store those values because they are protected. We give \
them explicitly. Note that ",
 "NoDollar",
 " is defined completely from scratch, without use of any other ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " function. It is very safe. The remembered values generate a \"memory \
leak\" with the variables produced by Unique (see the comments below for the \
function DummyIn).\n\nAn important point to worry about is the context in \
which the symbol is created."
}], "Text",ExpressionUUID->"07c108eb-788c-4b5b-9edd-28ea77cc167f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"61761cc5-79ea-4c7d-b0cd-87d898364a11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`NoDollar", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"a$b$1", ",", 
    RowBox[{"-", "a$$"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a$", "]"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"976c029d-756a-4f06-a95e-4aad6656780a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", 
   RowBox[{"-", "a"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a$", "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"0727505b-a8eb-4d18-bd93-4383a49d1cf3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`NoDollar", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"x$", ",", "x$_", ",", "_", ",", 
    RowBox[{"x$_", "?", "Q"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"de7900e4-2ee8-4de1-8337-2701f9a1b570"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "x_", ",", "_", ",", 
   RowBox[{"x_", "?", "Q"}]}], 
  "}"}]], "Output",ExpressionUUID->"cea361f6-7eb0-4760-b510-c3c668e37695"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`NoDollar", "[", "b$", "]"}], 
  "]"}]], "Input",ExpressionUUID->"7fce4f4b-2e94-4974-b37f-0562c3b43a90"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`NoDollar", "[", "b$", "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{
     RowBox[{"xAct`xTensor`Private`NoDollar", "[", "b$", "]"}], "^=", 
     RowBox[{"ToExpression", "[", 
      RowBox[{"StringJoin", "[", 
       RowBox[{
        RowBox[{"Characters", "[", 
         RowBox[{"ToString", "[", "b$", "]"}], "]"}], "/.", 
        "\[VeryThinSpace]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}],
           "}"}], "\[RuleDelayed]", 
         RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}]}], "]"}], "]"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             TagBox[
              RowBox[{"ToString", "[", "b$", "]"}],
              HoldForm], ",", 
             TagBox["\<\"b$\"\>",
              HoldForm]}], "}"}], ",", 
           TagBox[
            RowBox[{"Characters", "[", "\<\"b$\"\>", "]"}],
            HoldForm], ",", 
           TagBox[
            RowBox[{"{", 
             RowBox[{"\<\"b\"\>", ",", "\<\"$\"\>"}], "}"}],
            HoldForm]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           TagBox[
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
              "}"}], "\[RuleDelayed]", 
             RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}],
            HoldForm], ",", 
           TagBox[
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
              "}"}], "\[RuleDelayed]", 
             RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}],
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\<\"b\"\>", ",", "\<\"$\"\>"}], "}"}], "/.", 
           "\[VeryThinSpace]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
             "}"}], "\[RuleDelayed]", 
            RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}]}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"{", "\<\"b\"\>", "}"}],
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"StringJoin", "[", 
         RowBox[{"{", "\<\"b\"\>", "}"}], "]"}],
        HoldForm], ",", 
       TagBox["\<\"b\"\>",
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"ToExpression", "[", "\<\"b\"\>", "]"}],
      HoldForm], ",", 
     TagBox["b",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{
     RowBox[{"xAct`xTensor`Private`NoDollar", "[", "b$", "]"}], "^=", "b"}],
    HoldForm], ",", 
   TagBox["b",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"f5b5d63f-e809-44bc-8fb9-e6664b0cdfae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`NoDollar", "[", "b$", "]"}], 
  "]"}]], "Input",ExpressionUUID->"2311ff0b-e097-4144-a5c1-f57703400cab"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`NoDollar", "[", "b$", "]"}],
    HoldForm], ",", 
   TagBox["b",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"196f730c-a143-4af9-9740-b781c4eb63eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "xATP`NoDollar", "[", 
   "]"}]}]], "Input",ExpressionUUID->"ec8fe51d-3012-4d70-aad1-c59bda3c2902"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \[NoBreak]\\!\\(\\\"NoDollar\\\"\\)\[NoBreak] \
on \[NoBreak]\\!\\(\\\"0 arguments\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4c1bdd2e-862f-4447-a36f-8e11382d31e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`NoDollar", "[", 
  RowBox[{"a", "[", "b", "]"}], 
  "]"}]], "Input",ExpressionUUID->"d6f0bceb-a619-4870-8858-a4260fd1f412"],

Cell[BoxData[
 RowBox[{"a", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"9644bc50-1e60-4d97-864a-522fc66ab474"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`NoDollar", "[", 
  RowBox[{"a", "+", "b"}], 
  "]"}]], "Input",ExpressionUUID->"df7e0fa2-2ef6-48e4-a9b2-9c319370bdbf"],

Cell[BoxData[
 RowBox[{"a", "+", 
  "b"}]], "Output",ExpressionUUID->"d65f5305-dd3f-4ba3-91c2-dadbe9cee704"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`NoDollar", "[", 
   RowBox[{"a", ",", "b"}], 
   "]"}]}]], "Input",ExpressionUUID->"136d20de-e5a1-4b3e-8fc1-04858a0f927e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \[NoBreak]\\!\\(\\\"NoDollar\\\"\\)\[NoBreak] \
on \[NoBreak]\\!\\(\\\"more than 1 arguments\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"601212e9-7193-493b-aec3-d92ef06fe7c5"]
}, Open  ]],

Cell["\<\
NoDollar is not a very efficient function, but I do not see how it could be \
improved:\
\>", "Text",ExpressionUUID->"0bb2129b-9883-4b87-8893-fcbcd2ebd462"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`NoDollar", "[", 
   RowBox[{"-", "c$"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"543ee3b4-8e90-441e-984d-b129ab1c36ed"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`NoDollar", "[", 
     RowBox[{"-", "c$"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"-", 
     RowBox[{"xAct`xTensor`Private`NoDollar", "[", "c$", "]"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xAct`xTensor`Private`NoDollar", "[", "c$", "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{
       RowBox[{"xAct`xTensor`Private`NoDollar", "[", "c$", "]"}], "^=", 
       RowBox[{"ToExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{
          RowBox[{"Characters", "[", 
           RowBox[{"ToString", "[", "c$", "]"}], "]"}], "/.", 
          "\[VeryThinSpace]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
            "}"}], "\[RuleDelayed]", 
           RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}]}], "]"}], "]"}]}],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               TagBox[
                RowBox[{"ToString", "[", "c$", "]"}],
                HoldForm], ",", 
               TagBox["\<\"c$\"\>",
                HoldForm]}], "}"}], ",", 
             TagBox[
              RowBox[{"Characters", "[", "\<\"c$\"\>", "]"}],
              HoldForm], ",", 
             TagBox[
              RowBox[{"{", 
               RowBox[{"\<\"c\"\>", ",", "\<\"$\"\>"}], "}"}],
              HoldForm]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             TagBox[
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
                "}"}], "\[RuleDelayed]", 
               RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}],
              HoldForm], ",", 
             TagBox[
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
                "}"}], "\[RuleDelayed]", 
               RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}],
              HoldForm]}], "}"}], ",", 
           TagBox[
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\<\"c\"\>", ",", "\<\"$\"\>"}], "}"}], "/.", 
             "\[VeryThinSpace]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
               "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
               "}"}], "\[RuleDelayed]", 
              RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}]}],
            HoldForm], ",", 
           TagBox[
            RowBox[{"{", "\<\"c\"\>", "}"}],
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{"StringJoin", "[", 
           RowBox[{"{", "\<\"c\"\>", "}"}], "]"}],
          HoldForm], ",", 
         TagBox["\<\"c\"\>",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"ToExpression", "[", "\<\"c\"\>", "]"}],
        HoldForm], ",", 
       TagBox["c",
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{
       RowBox[{"xAct`xTensor`Private`NoDollar", "[", "c$", "]"}], "^=", "c"}],
      
      HoldForm], ",", 
     TagBox["c",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"-", "c"}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"74ada330-0fde-460a-a739-6f3da1e7ff10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`NoDollar", "[", 
   RowBox[{"-", "c$"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"2c9e07c2-2dcb-48ce-bbb9-4703bd0c2504"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`NoDollar", "[", 
     RowBox[{"-", "c$"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"-", 
     RowBox[{"xAct`xTensor`Private`NoDollar", "[", "c$", "]"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xAct`xTensor`Private`NoDollar", "[", "c$", "]"}],
      HoldForm], ",", 
     TagBox["c",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"-", "c"}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"ab95b6f0-4a46-41fe-9f5a-95e5f57a9a87"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`NoDollar", "[", 
  RowBox[{"{", 
   RowBox[{"c$", ",", "Polar"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"f00569c8-21f5-4e8a-8523-8562f07d0efe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"c", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"012b01ee-a653-4221-8a8d-9124dfd53d82"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`NoDollar", "[", 
  RowBox[{"Polar", "[", "c$", "]"}], 
  "]"}]], "Input",ExpressionUUID->"1f9da5fc-547e-43e0-97aa-26579a73297b"],

Cell[BoxData[
 RowBox[{"Polar", "[", "c$", 
  "]"}]], "Output",ExpressionUUID->"d721e025-8032-4cc5-ba41-1b1246936a39"]
}, Open  ]],

Cell["An alternative (not better) way could be:", \
"Text",ExpressionUUID->"a0fc19ef-e3d3-4227-8fca-3154811fbd6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`NoDollar2", "[", "xATP`a_", "]"}], ":=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringDrop", "[", 
      RowBox[{"#", ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"StringLength", "[", "#", "]"}]}], "+", 
        RowBox[{
         RowBox[{"StringPosition", "[", 
          RowBox[{"#", ",", "\"\<$\>\""}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "1"}]}], "]"}], "&"}], 
    "@", 
    RowBox[{"ToString", "[", "xATP`a", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"86f12dc1-fbe5-4670-b4b2-f5ec5f9ec897"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`NoDollar2", "[", 
   RowBox[{"-", "c$"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"fe316e69-ddd0-4984-bf3c-f41e0e3d3f2a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`NoDollar2", "[", 
     RowBox[{"-", "c$"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"ToExpression", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"StringDrop", "[", 
         RowBox[{"#1", ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"StringLength", "[", "#1", "]"}]}], "+", 
           RowBox[{
            RowBox[{"StringPosition", "[", 
             RowBox[{"#1", ",", "\<\"$\"\>"}], "]"}], "\[LeftDoubleBracket]", 
            
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}]}], 
         "]"}], "&"}], ")"}], "[", 
      RowBox[{"ToString", "[", 
       RowBox[{"-", "c$"}], "]"}], "]"}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"ToString", "[", 
         RowBox[{"-", "c$"}], "]"}],
        HoldForm], ",", 
       TagBox["\<\"-c$\"\>",
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"StringDrop", "[", 
          RowBox[{"#1", ",", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"StringLength", "[", "#1", "]"}]}], "+", 
            RowBox[{
             RowBox[{"StringPosition", "[", 
              RowBox[{"#1", ",", "\<\"$\"\>"}], "]"}], "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}]}],
           "]"}], "&"}], ")"}], "[", "\<\"-c$\"\>", "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"StringDrop", "[", 
       RowBox[{"\<\"-c$\"\>", ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"StringLength", "[", "\<\"-c$\"\>", "]"}]}], "+", 
         RowBox[{
          RowBox[{"StringPosition", "[", 
           RowBox[{"\<\"-c$\"\>", ",", "\<\"$\"\>"}], "]"}], 
          "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}]}], 
       "]"}],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           TagBox[
            RowBox[{"StringLength", "[", "\<\"-c$\"\>", "]"}],
            HoldForm], ",", 
           TagBox["3",
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{"-", "3"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"-", "3"}],
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           TagBox[
            RowBox[{"StringPosition", "[", 
             RowBox[{"\<\"-c$\"\>", ",", "\<\"$\"\>"}], "]"}],
            HoldForm], ",", 
           TagBox[
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"3", ",", "3"}], "}"}], "}"}],
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"3", ",", "3"}], "}"}], "}"}], "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}],
          HoldForm], ",", 
         TagBox["3",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{
         RowBox[{"-", "3"}], "+", "3", "-", "1"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"-", "1"}],
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"StringDrop", "[", 
       RowBox[{"\<\"-c$\"\>", ",", 
        RowBox[{"-", "1"}]}], "]"}],
      HoldForm], ",", 
     TagBox["\<\"-c\"\>",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"ToExpression", "[", "\<\"-c\"\>", "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"-", "c"}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"c7442dd0-3d9e-45ab-a2fd-ef04e1402e0b"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "a$", ",", "a$b$1", ",", "a$$", ",", "b", ",", "b$", ",", "c", 
   ",", "c$", ",", "Polar", ",", "Q", ",", "x", ",", "x$", ",", 
   "xATP`NoDollar2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"3df34d42-2187-4692-a75c-69f4a6aadce2"],

Cell["\<\
Now we define the function DollarQ, independently of NoDollar, and again \
totally from scratch:\
\>", "Text",ExpressionUUID->"5d65402e-5b86-4b32-8f01-455c5dae4d58"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DollarQ"}]], \
"Input",ExpressionUUID->"258e1fb3-6e23-44f9-9c68-1952e53673b1"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`DollarQ[ind] and DollarQ[-ind] give True if \
ind contains the character $ and False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672407-5338953",ExpressionUUID->"2edcb02f-ad0a-41cb-85fc-\
a2875155e2ba"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Detect", " ", "dollar", " ", "indices"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DollarQ", "[", 
      RowBox[{"_LI", "|", "_Dir", "|", "_Blank", "|", "_Integer"}], "]"}], ":=",
      "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DollarQ", "[", 
      RowBox[{"-", "a_"}], "]"}], ":=", 
     RowBox[{"DollarQ", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DollarQ", "[", "symbol_Symbol", "]"}], ":=", 
     RowBox[{"StringMatchQ", "[", 
      RowBox[{
       RowBox[{"SymbolName", "[", "symbol", "]"}], ",", "\"\<*$*\>\""}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DollarQ", "[", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"_Pattern", "|", "_PatternTest"}], ")"}]}], "]"}], ":=", 
      RowBox[{"DollarQ", "[", 
       RowBox[{"First", "[", "x", "]"}], "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "PINDEX", " ", "*)"}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DollarQ", "[", 
       RowBox[{"{", 
        RowBox[{"a_", ",", "_"}], "}"}], "]"}], ":=", 
      RowBox[{"DollarQ", "[", "a", "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DollarQ", "[", 
      RowBox[{
       RowBox[{"imod_", "?", "IModQ"}], "[", "a_", "]"}], "]"}], ":=", 
     RowBox[{"DollarQ", "[", "a", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8db8c2b3-c847-4c38-bee9-3359bd22f755"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"ea21c49b-9437-4832-9719-8c67cf8b0628"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`DollarQ", "[", 
   RowBox[{"-", "d$"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"9d74ca72-727e-4e7b-9818-70ce808b67b2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`DollarQ", "[", 
     RowBox[{"-", "d$"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`DollarQ", "[", "d$", "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"StringMatchQ", "[", 
     RowBox[{
      RowBox[{"SymbolName", "[", "d$", "]"}], ",", "\<\"*$*\"\>"}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"SymbolName", "[", "d$", "]"}],
      HoldForm], ",", 
     TagBox["\<\"d$\"\>",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"StringMatchQ", "[", 
     RowBox[{"\<\"d$\"\>", ",", "\<\"*$*\"\>"}], "]"}],
    HoldForm], ",", 
   TagBox["True",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"83569c92-77ec-467f-b0c3-3c1ac9effd9c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`DollarQ", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "d$"}], ",", "Polar"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"9fc1351b-fbbe-45a2-a0c7-eed00221c54f"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"e73221c9-0d95-4dec-b8f3-2047395b00a3"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"d$", ",", "Polar"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"315e57b2-5b57-4c9e-b978-9d113987d885"],

Cell["Compare to the old definition, given in terms of NoDollar:", \
"Text",ExpressionUUID->"6f487be3-f43e-49a2-a5bb-796786d7bcb8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DollarQ2", "[", "a_", "]"}], ":=", 
  RowBox[{"a", "=!=", 
   RowBox[{
   "NoDollar", "[", "a", 
    "]"}]}]}]], \
"Input",ExpressionUUID->"b6fcd50f-65f1-4766-9553-4353be54e443"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"23b221b9-4ed0-4d4b-9cdf-79455750e0ab"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`DollarQ2", "/@", 
  RowBox[{"List", "[", 
   RowBox[{"a$", ",", 
    RowBox[{"-", "a$"}], ",", "a", ",", 
    RowBox[{"-", "a"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"b93122ae-086a-4a7c-a4eb-8cbd18458079"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "True", ",", "False", ",", "False", ",", "False", ",", 
   "False"}], 
  "}"}]], "Output",ExpressionUUID->"c9be03f5-e09e-43fc-8f2e-a46bce7594c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`DollarQ", "[", "d$", "]"}], 
  "]"}]], "Input",ExpressionUUID->"cbdb9237-f140-4c34-aa24-ad0b63eaaa8e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`DollarQ", "[", "d$", "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"StringMatchQ", "[", 
     RowBox[{
      RowBox[{"SymbolName", "[", "d$", "]"}], ",", "\<\"*$*\"\>"}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"SymbolName", "[", "d$", "]"}],
      HoldForm], ",", 
     TagBox["\<\"d$\"\>",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"StringMatchQ", "[", 
     RowBox[{"\<\"d$\"\>", ",", "\<\"*$*\"\>"}], "]"}],
    HoldForm], ",", 
   TagBox["True",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"72bbbfcc-56c1-4704-a409-4020b1dae9d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`DollarQ2", "[", "d$", "]"}], 
  "]"}]], "Input",ExpressionUUID->"30306593-4a73-4ed4-bab4-53a3a1ab6127"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`DollarQ2", "[", "d$", "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"d$", "=!=", 
     RowBox[{"xAct`xTensor`Private`NoDollar", "[", "d$", "]"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xAct`xTensor`Private`NoDollar", "[", "d$", "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{
       RowBox[{"xAct`xTensor`Private`NoDollar", "[", "d$", "]"}], "^=", 
       RowBox[{"ToExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{
          RowBox[{"Characters", "[", 
           RowBox[{"ToString", "[", "d$", "]"}], "]"}], "/.", 
          "\[VeryThinSpace]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
            "}"}], "\[RuleDelayed]", 
           RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}]}], "]"}], "]"}]}],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               TagBox[
                RowBox[{"ToString", "[", "d$", "]"}],
                HoldForm], ",", 
               TagBox["\<\"d$\"\>",
                HoldForm]}], "}"}], ",", 
             TagBox[
              RowBox[{"Characters", "[", "\<\"d$\"\>", "]"}],
              HoldForm], ",", 
             TagBox[
              RowBox[{"{", 
               RowBox[{"\<\"d\"\>", ",", "\<\"$\"\>"}], "}"}],
              HoldForm]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             TagBox[
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
                "}"}], "\[RuleDelayed]", 
               RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}],
              HoldForm], ",", 
             TagBox[
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
                "}"}], "\[RuleDelayed]", 
               RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}],
              HoldForm]}], "}"}], ",", 
           TagBox[
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\<\"d\"\>", ",", "\<\"$\"\>"}], "}"}], "/.", 
             "\[VeryThinSpace]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
               "xAct`xTensor`Private`i___", ",", "\<\"$\"\>", ",", "___"}], 
               "}"}], "\[RuleDelayed]", 
              RowBox[{"{", "xAct`xTensor`Private`i", "}"}]}]}],
            HoldForm], ",", 
           TagBox[
            RowBox[{"{", "\<\"d\"\>", "}"}],
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{"StringJoin", "[", 
           RowBox[{"{", "\<\"d\"\>", "}"}], "]"}],
          HoldForm], ",", 
         TagBox["\<\"d\"\>",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"ToExpression", "[", "\<\"d\"\>", "]"}],
        HoldForm], ",", 
       TagBox["d",
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{
       RowBox[{"xAct`xTensor`Private`NoDollar", "[", "d$", "]"}], "^=", "d"}],
      
      HoldForm], ",", 
     TagBox["d",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"d$", "=!=", "d"}],
    HoldForm], ",", 
   TagBox["True",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"366e2e32-353a-4f46-8b03-f05b392e88e2"]
}, Open  ]],

Cell["\<\
Functions NoDollar and UpIndex commute on their common domain:\
\>", "Text",ExpressionUUID->"40e762a9-ab93-463c-8788-a804cc4eeec9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`NoDollar", "[", 
   RowBox[{"UpIndex", "[", 
    RowBox[{"-", "a$"}], "]"}], "]"}], "===", 
  RowBox[{"UpIndex", "[", 
   RowBox[{"xATP`NoDollar", "[", 
    RowBox[{"-", "a$"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"9356d42b-eae8-4f69-9ae5-b720ef5e5bf2"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"c1102f93-ef2d-4562-9062-172248ccd57a"]
}, Open  ]],

Cell["\<\
With our new definitions for UpIndex, they commute even in wrong cases:\
\>", "Text",ExpressionUUID->"6e447f44-d85d-4768-a908-1f1560b0410f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "[", 
  RowBox[{
   RowBox[{"xATP`NoDollar", "[", 
    RowBox[{"UpIndex", "[", 
     RowBox[{"a", "+", "b"}], "]"}], "]"}], "===", 
   RowBox[{"UpIndex", "[", 
    RowBox[{"xATP`NoDollar", "[", 
     RowBox[{"a", "+", "b"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e4ab86dc-4983-4728-9621-f1ecc02ce04c"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"521dfc04-5b59-4831-80cd-ccc3b6010afe"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "a$", ",", "b", ",", "d", ",", "d$", ",", "Polar"}], 
  "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"2fb91504-fe9d-4587-815e-6f9091f45bde"],

Cell[BoxData[
 RowBox[{"Remove", "[", "DollarQ2", 
  "]"}]], "Input",ExpressionUUID->"50d1d4b6-1a55-46ff-adb2-1208e35bd2c7"],

Cell[TextData[{
 "There is no conflict at all between ",
 "NoDollar",
 " and patterns or blocked indices. The only point is whether it is really \
necessary to drop dollars from pattern indices. ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " often introduces those dollar patterns to avoid conflicts and we could be \
interfereing with that. I think the removing of dollars in patterns only \
happens at formatting time."
}], "Text",ExpressionUUID->"1b4a37f6-7da0-4bd0-98bd-ebeb4ce49b41"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.4. DaggerIndex", \
"Subsubsection",ExpressionUUID->"842745af-0def-4d69-9f66-fbc5e10abf40"],

Cell["\<\
We need to avoid interferences with the dollar indices. The convention (to \
avoid changing the dollar functions) is to have always the dollars after the \
dagger-character. Note that we only create the association pair (with \
remembered definitions); currently we do not give any other information for \
the newly created index. A new index is created only when we act on a \
dollar-index; otherwise the remembered pair of definitions already exists. \
For those indices we do not need to register additional information because \
they inherit it from the corresponding no-dollar-index.\
\>", "Text",ExpressionUUID->"9af4b0fe-0c48-4516-90f2-da4d0e62a058"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DaggerIndex"}]], \
"Input",ExpressionUUID->"9d39792d-2a97-499a-93d4-bf3d7b9e70bc"],

Cell[BoxData[
 StyleBox["\<\"DaggerIndex[ind] returns the conjugated index to ind. \
DaggerIndex[IndexList[i1, ..., in]] returns the list (also with head \
IndexList) of respective conjugated indices. Label indices are considered \
real by default.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672409-5338953",ExpressionUUID->"966fa1f7-22dc-4649-bd2e-\
8d993174e240"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Thread", " ", "over", " ", "IndexList"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", "list_IndexList", "]"}], ":=", 
     RowBox[{"DaggerIndex", "/@", "list"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Abstract", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"-", "x_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"DaggerIndex", "[", "x", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", "x_Symbol", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"DaggerQ", "@", 
        RowBox[{"VBundleOfIndex", "[", "x", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"dgx", "=", 
           RowBox[{"MakeDaggerSymbol", "[", "x", "]"}]}], "}"}], ",", 
         RowBox[{
          RowBox[{"xUpSet", "[", 
           RowBox[{
            RowBox[{"DaggerIndex", "[", "dgx", "]"}], ",", "x"}], "]"}], ";", 
          
          RowBox[{"xUpSet", "[", 
           RowBox[{
            RowBox[{"DaggerIndex", "[", "x", "]"}], ",", "dgx"}], "]"}]}]}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"DaggerIndex", "[", "x", "]"}], ",", "x"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Formal", " ", "sequence", " ", "of", " ", "abstract", " ", "indices"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"AnyIndices", "[", 
       RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], "]"}], ":=", 
     RowBox[{"AnyIndices", "[", 
      RowBox[{"Dagger", "[", "vbundle", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "By", " ", "default", " ", "labels", " ", "are", " ", "considered", " ", 
     "real"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", "x_LI", "]"}], ":=", "x"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Directional", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"Dir", "[", "v_", "]"}], "]"}], ":=", 
     RowBox[{"Dir", "[", 
      RowBox[{"Dagger", "[", "v", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Component", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"ind", ":", 
       RowBox[{"{", 
        RowBox[{"a_Integer", ",", "basis_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"xAct`xCoba`DaggerCIndex", "[", 
      RowBox[{"basis", ",", "ind"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"ind", ":", 
       RowBox[{
        RowBox[{"basis_Symbol", "?", "BasisQ"}], "[", "a_Integer", "]"}]}], 
      "]"}], ":=", 
     RowBox[{"xAct`xCoba`DaggerCIndex", "[", 
      RowBox[{"basis", ",", "ind"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Basis", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"ind", ":", 
       RowBox[{"{", 
        RowBox[{"a_", ",", "basis_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"xAct`xCoba`Private`DaggerBIndex", "[", 
      RowBox[{"basis", ",", "ind"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DaggerIndex", "[", 
       RowBox[{"ind", ":", 
        RowBox[{
         RowBox[{"basis_Symbol", "?", "BasisQ"}], "[", "a_", "]"}]}], "]"}], ":=", 
      RowBox[{"xAct`xCoba`Private`DaggerBIndex", "[", 
       RowBox[{"basis", ",", "ind"}], "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Index", " ", "modifiers"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", 
      RowBox[{"ind", ":", 
       RowBox[{
        RowBox[{"imod_", "?", "IModQ"}], "[", "a_", "]"}]}], "]"}], ":=", 
     RowBox[{"DaggerIMod", "[", 
      RowBox[{"imod", ",", "ind"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", " ", "IMOD", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Integers", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", "ind_Integer", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DaggerIndex", "::", "error"}], ",", 
         "\"\<DaggerIndex on an integer. Assuming everything is real.\>\""}], 
        "]"}], ";", "ind"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DaggerIndex", "[", "x_", "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DaggerIndex", "::", "unknown"}], ",", "\"\<index\>\"", ",", 
        "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"DaggerIndex", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "DaggerIndex", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3fc30901-b4df-4f53-b51d-b10e43547c4a"],

Cell["\<\
The private function DaggerIndexQ relates to DaggerIndex in the same way that \
DaggerQ relates to Dagger:\
\>", "Text",ExpressionUUID->"666b939c-8ba6-4e61-a9cb-b0f618c50b00"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", 
    RowBox[{"-", "x_"}], "]"}], ":=", 
   RowBox[{"DaggerIndexQ", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", "x_Symbol", "]"}], ":=", 
   RowBox[{"HasDaggerCharacterQ", "[", "x", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", "v_Dir", "]"}], ":=", 
   RowBox[{"DaggerIndexQ", "[", 
    RowBox[{"UltraindexOf", "[", "v", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", "x_LI", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", "x_Integer", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", 
    RowBox[{"{", 
     RowBox[{"x_", ",", "basis_"}], "}"}], "]"}], ":=", 
   RowBox[{"HasDaggerCharacterQ", "[", "basis", "]"}]}], ";", " ", 
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DaggerIndexQ", "[", 
     RowBox[{
      RowBox[{"basis_Symbol", "?", "BasisQ"}], "[", "x_", "]"}], "]"}], ":=", 
    
    RowBox[{"HasDaggerCharacterQ", "[", "basis", "]"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DaggerIndexQ", "[", 
     RowBox[{
      RowBox[{"imod_", "?", "IModQ"}], "[", "x_", "]"}], "]"}], ":=", 
    RowBox[{"HasDaggerCharacterQ", "[", "x", "]"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "IMOD", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DaggerIndexQ", "[", "list_IndexList", "]"}], ":=", 
    RowBox[{"UnsameQ", "[", 
     RowBox[{
      RowBox[{"DaggerIndex", "[", "list", "]"}], ",", "list"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"The", " ", "default", " ", "is", " ", 
    RowBox[{"False", ".", " ", 
     RowBox[{"True", "?"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DaggerIndexQ", "[", "x_", "]"}], ":=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0685d53b-b962-4aed-9f49-d8b427c438ab"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2.5. PullBackIndex", \
"Subsubsection",ExpressionUUID->"5983eb82-5986-43a0-a452-7c9158e2153f"],

Cell["\<\
Convert indices of a vbundle into indices of the pullback bundle. The \
convention here is to prepend the map, to avoid messing up with daggers, \
dollars and numbers. This function does not register the index. We assume \
that the (non-dollar) pullback indices have been already registered, \
including their typesetting.\
\>", "Text",ExpressionUUID->"e0e32204-11c3-4c8c-ac14-865f338dc73a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PullBackIndex", "[", 
    RowBox[{"x_", ",", "_IdentityMapping"}], "]"}], ":=", "x"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackIndex", "[", 
    RowBox[{
     RowBox[{"-", "x_"}], ",", "phi_"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"PullBackIndex", "[", 
     RowBox[{"x", ",", "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackIndex", "[", 
    RowBox[{"x_Symbol", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"xTagSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"PullBackIndex", "[", 
        RowBox[{"x", ",", "phi"}], "]"}]}], "}"}], ",", 
     RowBox[{"RegisterPullBackIndex", "[", 
      RowBox[{
       RowBox[{"MakePullBackIndex", "[", 
        RowBox[{"x", ",", "phi"}], "]"}], ",", 
       RowBox[{"PullBackVBundle", "[", 
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "x", "]"}], ",", "phi"}], "]"}]}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackIndex", "[", 
    RowBox[{
     RowBox[{"AnyIndices", "[", 
      RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], ",", "phi_"}], "]"}], ":=", 
   RowBox[{"AnyIndices", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{"vbundle", ",", "phi"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBackIndex", "[", 
     RowBox[{"x_LI", ",", "phi_"}], "]"}], ":=", "x"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"We", " ", 
    RowBox[{"don", "'"}], "t", " ", "give", " ", "freeindex", " ", 
    RowBox[{"rules", ".", " ", "We"}], " ", "let", " ", "the", " ", "system", 
    " ", "choose", " ", "the", " ", "indices"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBackIndex", "[", 
     RowBox[{
      RowBox[{"Dir", "[", "v_", "]"}], ",", "phi_"}], "]"}], ":=", 
    RowBox[{"Dir", "[", 
     RowBox[{"PullBack", "[", 
      RowBox[{"v", ",", "phi"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "We", " ", "assume", " ", "that", " ", "a", " ", "basis", " ", "and", " ",
      "its", " ", "pullback", " ", "have", " ", "the", " ", "same", " ", 
     "cnumbers"}], ",", " ", 
    RowBox[{"and", " ", "in", " ", "the", " ", "same", " ", "order"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackIndex", "[", 
    RowBox[{"a_Integer", ",", "phi_"}], "]"}], ":=", "a"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBackIndex", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a_", ",", "basis_"}], "}"}], ",", "phi_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"PullBackIndex", "[", 
       RowBox[{"a", ",", "phi"}], "]"}], ",", 
      RowBox[{"PullBackBasis", "[", 
       RowBox[{"basis", ",", "phi"}], "]"}]}], "}"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBackIndex", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"basis_Symbol", "?", "BasisQ"}], "[", "a_", "]"}], ",", 
      "phi_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"PullBackBasis", "[", 
      RowBox[{"basis", ",", "phi"}], "]"}], "[", 
     RowBox[{"PullBackIndex", "[", 
      RowBox[{"a", ",", "phi"}], "]"}], "]"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "BASIS2", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBackIndex", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"imod_", "?", "IModQ"}], "[", "a_", "]"}], ",", "phi_"}], 
     "]"}], ":=", 
    RowBox[{
     RowBox[{"PullBackIMod", "[", 
      RowBox[{"imod", ",", "phi"}], "]"}], "[", 
     RowBox[{"PullBackIndex", "[", 
      RowBox[{"a", ",", "phi"}], "]"}], "]"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "IMOD", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackIndex", "[", 
    RowBox[{"x_", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"PullBack", "::", "unknown"}], ",", "\"\<index\>\"", ",", "x"}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"PullBackIndex", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "PullBackIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5dc55b0c-0cc9-48db-9254-c394f676d833"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PullBackCharacter", "[", "phi_Symbol", "]"}], ":=", 
   "$StarCharacter"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackCharacter", "[", 
    RowBox[{"SmallCircle", "[", "phis__", "]"}], "]"}], ":=", 
   RowBox[{"ConstantArray", "[", 
    RowBox[{"$StarCharacter", ",", 
     RowBox[{"Length", "[", 
      RowBox[{"{", "phis", "}"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"761decf7-005a-431c-9401-3a35c3c3c181"],

Cell["\<\
This function does the actual construction of the index name (JoinCharacters) \
and sets the PrintAs form, by appending a star to the PrintAs form of the \
original index (which may already have other stars):\
\>", "Text",ExpressionUUID->"12360108-3580-43be-b66b-262a5dbd1f3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakePullBackIndex", "[", 
    RowBox[{"x_Symbol", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pbx", "=", 
       RowBox[{"JoinCharacters", "[", 
        RowBox[{"phi", ",", "x"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SetPrintAs", "[", 
       RowBox[{"pbx", ",", 
        RowBox[{"\"\<\\!\\(\>\"", "<>", 
         RowBox[{"PrintAs", "[", "x", "]"}], "<>", "\"\<\\^\>\"", "<>", 
         RowBox[{"PullBackCharacter", "[", "phi", "]"}], "<>", 
         "\"\<\\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", "pbx"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ded62cfd-3876-4ed4-ae2c-77f3f04b39f4"],

Cell["\<\
If we have a composition of maps phi2\[SmallCircle]phi1 then the index will \
be phi1phi2index\
\>", "Text",ExpressionUUID->"637844cb-4218-4d7d-ab85-5584dda966d4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"CharacterList", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CharacterList", "[", "phi_Symbol", "]"}], ":=", 
   RowBox[{"Characters", "[", 
    RowBox[{"ToString", "[", "phi", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CharacterList", "[", 
    RowBox[{"SmallCircle", "[", "phis__Symbol", "]"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"CharacterList", "/@", 
     RowBox[{"Reverse", "[", 
      RowBox[{"{", "phis", "}"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CharacterList", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"PullBack", "::", "error1"}], ",", 
      "\"\<Cannot handle pullback of index under map\>\"", ",", "phi"}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"JoinCharacters", "[", 
    RowBox[{"phi_", ",", "index_"}], "]"}], ":=", 
   RowBox[{"ToExpression", "[", 
    RowBox[{"StringJoin", "[", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"CharacterList", "[", "phi", "]"}], ",", 
       RowBox[{"CharacterList", "[", "index", "]"}]}], "]"}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e2ce30f2-b7a2-4034-b6c4-a6f29f064bdb"],

Cell["\<\
Now we register the index in the corresponding vbundle. QUESTION: Do we need \
to register some relation involving the inverse mapping?\
\>", "Text",ExpressionUUID->"ad2d7125-011a-4910-a3b3-cd5b71ec2c9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RegisterPullBackIndex", "[", 
    RowBox[{"index_", ",", "vbundle_PullBackVBundle"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"Flatten", "@", "inds"}], ",", "index"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"xUpSet", "[", 
          RowBox[{
           RowBox[{"AbstractIndexQ", "[", "index", "]"}], ",", "True"}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"DollarQ", "[", "index", "]"}]}], ",", 
           RowBox[{"AddIndexInSecondList", "[", 
            RowBox[{"vbundle", ",", "index"}], "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "index"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"08c7c9ef-bfbc-4844-ab42-a59921347145"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3. Identification", \
"Subsection",ExpressionUUID->"c54e17c6-d253-47b9-9b3f-c39b0cd085e9"],

Cell[CellGroupData[{

Cell["5.3.0. Comments", \
"Subsubsection",ExpressionUUID->"6b726541-a25b-4f37-9ddb-97c5529ab561"],

Cell[TextData[{
 "The functions defined in this section are very basic and are defined mostly \
in terms of elementary ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " functions. In particular they do not depend on \
UpIndex/DownIndex/ChangeIndex. Functions used internally:\n\t- AIndexQ: \
NoDollar, AbstractIndexQ, VBundleOfIndex\n\t- BIndexQ: AIndexQ, \
VBundleOfIndex\n\t- CIndexQ: xAct`xCoba`CNumbersOf\n\t- DIndexQ: ValidateDir, \
UltraindexOf\n\t- LIndexQ:\n\t- MIndexQ:\n\t- PIndexQ: AIndexQ"
}], "Text",ExpressionUUID->"bacc99f8-5789-43f4-bfed-eda87a89b914"],

Cell["\<\
There could be many different checks to make on a given index:
    \t- type: A, B, C, D, L, AB, BC, CD, G, E
\t- character: up, down
\t- vector bundle: ...
The recommended way of testing them all is by constructing a user-defined \
checking function. We shall not try to write a generic testing function. This \
is because the pattern a_?f[x] is understood as (a_f?)[x] and not as \
a_?(f[x]), so it is better to define y=f[x] and use a_?y.\
\>", "Text",ExpressionUUID->"945a10ce-422e-4bae-acd3-590d2282964b"],

Cell["\<\
In this section we construct the type-checking functions. The character is \
checked with UpIndexQ and DownIndexQ.\
\>", "Text",ExpressionUUID->"a070f610-d1bc-4bfe-ae9e-4c85356ed087"],

Cell[TextData[{
 "Then there are \"fast patterns\" (low-level ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ") for certain combinations of type and character (the vector bundle is \
always checked through Q-functions):\n\n\t\t\t\t\tabstract indices\tbasis \
indices\t\t\t\tcomponent indices\t\t\tdirections\t\tlabels\n\t\tup-indices\t\t\
a_Symbol\t{a_Symbol, basis_Symbol}\t{a_Integer, basis_Symbol}\t\t\t\t\t_LI\n\t\
\tdown-indices\t\t-a_Symbol\t{-a_Symbol, -basis_Symbol}\t{a_Integer, \
-basis_Symbol}\t\t\t\t\t-_LI\n\t\tboth characters\t\t\t\t{a_Integer, basis_}\t\
\t\t\t\t\t\t\t\t_Dir\n\nNote that there are no fast-patterns for both \
abstract and basis (or component) indices. That is a drawback of our \
notation, and could be why MathTensor uses la_ as a pattern, because it still \
accepts anything, while our pattern -i_ only accepts lower abstract indices. \
The pattern la_ is bad for other reasons, like the fact that it seems a \
pattern for lower indices but it actually accepts any pattern."
}], "Text",ExpressionUUID->"d1593174-4e6e-4ba7-8a7d-c6342928c560"],

Cell["\<\
Patterns which would work nicely would be something like Index[a, Up, \
Abstract] and Index[a, Up, Basis[polar]], but those are only possible using a \
parser. An intermediate situation would be U[a], L[a] for abstract indices, \
U[a, polar], L[a, polar] for basis indices, and U[1, polar], L[a, polar] for \
component indices. Patterns would be:

\t\t\t\t\t\tabstract indices\tbasis indices\t\t\tcomponent indices\t\t\t\
directions\tlabels
\t\tup-indices\t\tU[a_Symbol]\t\tU[a_Symbol, basis_]\tU[a_Integer, basis_]\t\t\
?\t\t\t?
\t\tdown-indices\t\tL[a_Symbol]\t\tL[a_Symbol, basis_]\tL[a_Integer, basis_]\t\
\t\t?\t\t\t?
\t\tboth characters\t(U|L)[a_Symbol]\t(U|L)[a_Symbol, basis_]\t\
(U|L)[a_Integer, basis_]\t\t?\t\t\t?

Nice features of this notation would be that it would be possible to change \
indices in a simple way. For example:
\ta->b\t\t\twould change U[a], L[a], U[a, basis] and L[a, basis] at the same \
time
\ta->{1, basis}\twould change U[a] to U[{1, basis}], which would be \
automatically replaced by U[1, basis]
\ta->1\t\t\twould change U[a, basis] to U[1, basis] and L[a, basis] to L[1, \
basis] simultaneously

We could define U[1] to be automatically converted into U[1, basis] for some \
preferred basis.

In order to keep backward compatibility with the index notation a, -a we \
would need a parser changing all indices. This would match smoothly with \
additional parsers for other systems, like MathTensor. The problem with the \
parser is whether it would be simple or not to change the patterns in the old \
notation to the new patterns.

I'm not sure what could be good choices for directions and labels. It is not \
simple to deduce the character of a direction in general, but directions are \
not so often used, so probably the best option would be to keep the Dir \
symbol and compute the character on real time. Concerning labels, I think \
there should be a predefined \"character\" for their output, but U@ and L@ \
could still be used to modify it. In this way we mostly avoid the problems \
with signs.\
\>", "Text",ExpressionUUID->"e842cd1c-716e-474e-abc6-e59691a38bcf"],

Cell["\<\
Another idea, which is closer in spirit to what we have right now, in \
particular still keeping the asymmetry, is the following: given a basis \
polar, use polar[a], -polar[a], polar[1], -polar[1] as bc-indices. An  \
advantage is that it follows the pattern -x_. The main problem is that we \
would need to include many basis_?BasisQ[ind_] patterns instead of \
{ind_,basis_}. We must study whether this is worth or not. We could declare \
the following types of indices:
\t* Abstract indices: symbol, -symbol
\t* Marked indices: symbol[ expr ], -symbol[ expr ]:
\t\t* Basis indices: basis[ symbol ]
\t\t* Component indices: basis[ integer ]
\t\t* Labels: LI[ exprs ]
\t\t* Directions: Dir[ expr ]
The question is whether we can avoid the question ?BasisQ. We can if we \
declare that basis is any symbol which is not LI or Dir.

Fast patterns:
\t\t\t\t\t\tabstract indices\tbasis indices\t\t\t\tcomponent indices\t\t\t\
directions\t\tlabels
\t\tup-indices\t\ta_Symbol\t\tbasis_Symbol[a_Symbol]\tbasis_Symbol[a_Integer]\
\t\t\t\t\t_LI
\t\tdown-indices\t\t-a_Symbol\t\t-basis_Symbol[a_Symbol]\t\
-basis_Symbol[a_Integer]\t\t\t\t\t-_LI
\t\tboth characters\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t_Dir

with definitions for LI and Dir before those for bc-indices.\
\>", "Text",ExpressionUUID->"9b8e0208-de46-4d0b-bb55-92b31a9074d7"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.1. IndexOnQ. The vbundle`Q and vbundle`pmQ functions", \
"Subsubsection",ExpressionUUID->"a291b928-2653-4433-8b36-552996e1265b"],

Cell["\<\
This is the function that tests all indices (not only abstract indices) for \
membership of a given vector bundle:\
\>", "Text",ExpressionUUID->"59e17040-d627-4200-90bf-0b0602899b10"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexOnQ"}]], \
"Input",ExpressionUUID->"caa6494a-6569-4caa-889b-589b1a0cbe1f"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`IndexOnQ[i, vbundle] gives True if index i \
belongs to the bundle vbundle (or to a subvbundle of vbundle) and False \
otherwise. xTensor`Private`IndexQ[i, {vb1, vb2, ...}] gives True if index i \
belongs to one of the bundles (or their subvbundles) in the list {vb1, vb2, \
...}.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672410-5338953",ExpressionUUID->"d8cfde7c-1076-42d2-8a57-\
0b0169fceff7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IndexOnQ", "[", 
    RowBox[{"index_", ",", "vbundle_"}], "]"}], ":=", 
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"VBundleOfIndex", "[", "index", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"516eadcd-0945-4d6a-b052-6c83e1f7ded1"],

Cell[TextData[{
 "I have tried to use SameQ instead of SubvbundleQ but we need the latter in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ". This is a tricky issue.\n\nThe functions vbundle`Q and vbundle`pmQ check \
only for abstract indices, and so they are not equivalent to IndexOnQ. They \
are also defined with remembered values, and hence are faster. "
}], "Text",ExpressionUUID->"79b00c3b-e2b1-42b4-8235-f8693229299d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"VBundleIndexQ", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"SymbolJoin", "@@", 
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"VBundleNameList", "[", "vbundle", "]"}], ",", "\"\<`Q\>\""}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleIndexPMQ", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"SymbolJoin", "@@", 
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"VBundleNameList", "[", "vbundle", "]"}], ",", "\"\<`pmQ\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleNameList", "[", "vbundle_Symbol", "]"}], ":=", 
   RowBox[{"{", "vbundle", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleNameList", "[", 
    RowBox[{"xAct`xCoba`TangentReals", "[", "dim_", "]"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"\"\<TR\>\"", ",", 
     RowBox[{"ToString", "[", "dim", "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingNameList", "[", "phi_Symbol", "]"}], ":=", 
   RowBox[{"{", "phi", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingNameList", "[", 
    RowBox[{"SmallCircle", "[", "phis__Symbol", "]"}], "]"}], ":=", 
   RowBox[{"Reverse", "[", 
    RowBox[{"{", "phis", "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleNameList", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{"vbundle_", ",", "phi_"}], "]"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"MappingNameList", "[", "phi", "]"}], ",", 
     RowBox[{"VBundleNameList", "[", "vbundle", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleNameList", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"VBundleIndexQ", "::", "error1"}], ",", 
      "\"\<TODO: Don't know yet how to construct the `Q and `pmQ functions of \
vbundle \>\"", ",", "vbundle"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9a76309d-b88e-4e8e-aaa6-fe4c190233f1"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.2. Abstract Indices: AIndexQ", \
"Subsubsection",ExpressionUUID->"2e6d3a18-b426-4fc1-884d-60bdd7fb0a21"],

Cell["Identification of abstract indices:", \
"Text",ExpressionUUID->"6cffdcd6-a285-4506-9da4-7189bee7f292"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "AIndexQ"}]], \
"Input",ExpressionUUID->"7f2ce5e7-daca-4132-9383-02dc7f215f40"],

Cell[BoxData[
 StyleBox["\<\"AIndexQ[x] gives True if x is recognized as a valid abstract \
index, and False otherwise. AIndexQ[x, vbundle] gives True if x is a valid \
abstract index belonging to the vector bundle vbundle.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672412-5338953",ExpressionUUID->"ea0d374f-1745-4c30-8f0c-\
e5f61be50c6b"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AIndexQ", "[", 
    RowBox[{"-", "i_Symbol"}], "]"}], ":=", 
   RowBox[{"AIndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AIndexQ", "[", "i_Symbol", "]"}], ":=", 
   RowBox[{"AbstractIndexQ", "[", 
    RowBox[{"NoDollar", "[", "i", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AIndexQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"AIndexQ", "[", 
     RowBox[{"i_", ",", "vbundle_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"AIndexQ", "[", "i", "]"}], "&&", 
     RowBox[{"IndexOnQ", "[", 
      RowBox[{"i", ",", "vbundle"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  
  RowBox[{"(*", " ", 
   RowBox[{
   "Special", " ", "definition", " ", "for", " ", "a", " ", "formal", " ", 
    "sequence", " ", "of", " ", "abstract", " ", "indices"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AIndexQ", "[", 
    RowBox[{"AnyIndices", "[", "vbundle_", "]"}], "]"}], ":=", 
   RowBox[{"VBundleQ", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"AIndexQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "AIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6699db47-84ac-4b55-955a-b30d5770688a"],

Cell["\<\
Note that we need to use NoDollar because AbstractIndexQ does not recognize \
those dollar indices which have been not registered. There was a previous \
different coding using first DollarQ and then NoDollar only in those \
DollarQ=True cases. I'm not sure how much faster that was. The new coding is \
simply simpler.\
\>", "Text",ExpressionUUID->"a95b66c7-9755-440d-be0b-e520f9e58c13"],

Cell["\<\
This function gives False on a pattern for an abstract index:\
\>", "Text",ExpressionUUID->"803803a3-0b1b-4eed-9fbe-7fbd7564133d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AIndexQ", "/@", 
  RowBox[{"{", 
   RowBox[{"i_Symbol", ",", 
    RowBox[{"-", "i_Symbol"}], ",", "i_"}], 
   "}"}]}]], "Input",ExpressionUUID->"4a0de907-2b06-48b0-84db-096515ffe087"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"False", ",", "False", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"f09d98f5-6b30-49c0-be5e-f5e1cdb43fe3"]
}, Open  ]],

Cell["\<\
We introduce a formal basis for the abstract indices, called AIndex.\
\>", "Text",ExpressionUUID->"6480a411-3b24-4564-87c5-7f57c218ca22"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "AIndex"}]], "Input",ExpressionUUID->"c2fd6f52-46cf-4875-80ec-74a220c72267"],

Cell[BoxData[
 StyleBox["\<\"AIndex represents the logic type for abstract indices. It also \
represents the abstract basis corresponding to abstract indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672413-5338953",ExpressionUUID->"827390d1-edc8-498c-855c-\
fd4989336c0f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"A", " ", "funny", " ", 
    RowBox[{"trick", ":", " ", 
     RowBox[{"AIndex", " ", "is", " ", "a", " ", "basis"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"BasisQ", "[", "AIndex", "]"}], "^=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xCoba`BasisColor", "[", "AIndex", "]"}], "^=", 
     RowBox[{"RGBColor", "[", 
      RowBox[{"0", ",", "0", ",", "0"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xCoba`PDOfBasis", "[", "AIndex", "]"}], "^=", "PD"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xCoba`DependenciesOfBasis", "[", "AIndex", "]"}], "^=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "AIndex", "]"}], "^=", "AIndex"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ffb9a1ba-2031-4e56-87a7-3776a4926e9a"],

Cell["\<\
 Note the funny rule converting -AIndex into AIndex inmediately. This is to \
allow conversion of {-a, -AIndex} into {-a, AIndex} and then into -a. This is \
dangerous (now deactivated):\
\>", "Text",ExpressionUUID->"205fa693-5a0a-4ee5-b052-1cf9871aed3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"This", " ", "is", " ", "dangerous"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AIndex", "/:", 
     RowBox[{"-", "AIndex"}], ":=", "AIndex"}], ";"}], " ", 
   RowBox[{"(*", " ", "BASIS1", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AIndex", "/:", 
      RowBox[{"{", 
       RowBox[{"a_Integer", ",", "AIndex"}], "}"}], ":=", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"AIndex", "::", "invalid"}], ",", "a", ",", 
         "\"\<abstract index\>\""}], "]"}]}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AIndex", "/:", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a_", "?", "AIndexQ"}], ",", "AIndex"}], "}"}], ":=", "a"}], 
    ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AIndex", "[", "a_Integer", "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"AIndex", "::", "invalid"}], ",", "a", ",", 
        "\"\<abstract index\>\""}], "]"}]}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AIndex", "[", 
      RowBox[{"a_", "?", "AIndexQ"}], "]"}], ":=", "a"}], ";", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}]}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"486b7ef5-8bec-4f55-a093-e21c022fbee1"],

Cell["\<\
Note that, even though -AIndex is converted into AIndex, we have that \
-AIndex[a] is not converted into AIndex[a].\
\>", "Text",ExpressionUUID->"e777a17f-e0b5-4f0f-9a55-3227702c6a57"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.3. Basis Indices: BIndexQ", \
"Subsubsection",ExpressionUUID->"41af91ca-4004-4ec7-a259-4cd9c26f5092"],

Cell["Identification of basis indices:", \
"Text",ExpressionUUID->"43cc7a0a-6af1-4b7c-906e-b95b1f819fb4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "BIndexQ"}]], \
"Input",ExpressionUUID->"3f879b89-38de-4485-b612-9c01522d1672"],

Cell[BoxData[
 StyleBox["\<\"BIndexQ[x] gives True if x is a valid basis index: {i, basis}, \
where i is an abstract index. BIndexQ[x, basis] gives True if x is a valid \
basis index belonging to basis. BIndexQ[x, vbundle] gives True if x is a \
valid basis index belonging to the vector bundle vbundle.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672415-5338953",ExpressionUUID->"851e2424-41f5-4e89-9db3-\
a3fb80bcb33c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", 
    RowBox[{"argument", ":", " ", 
     RowBox[{
     "check", " ", "consistency", " ", "of", " ", "abstract", " ", "index", 
      " ", "and", " ", "basis"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{"-", "i_"}], "]"}], ":=", 
     RowBox[{"BIndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"BIndexQ", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", 
         RowBox[{"basis_", "?", "BasisQ"}]}], "}"}], "]"}], ":=", "True"}], 
     ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i_", "?", "AIndexQ"}], ",", 
        RowBox[{"-", 
         RowBox[{"basis_", "?", "BasisQ"}]}]}], "}"}], "]"}], ":=", "True"}], 
    ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{
       RowBox[{"basis_", "?", "BasisQ"}], "[", 
       RowBox[{"i_", "?", "AIndexQ"}], "]"}], "]"}], ":=", "True"}], ";", " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", "i_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Two", " ", 
     RowBox[{"arguments", ":", " ", 
      RowBox[{"index", " ", "and", " ", 
       RowBox[{"basis", "/", "vbundle"}]}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{
       RowBox[{"-", "i_"}], ",", "x_"}], "]"}], ":=", 
     RowBox[{"BIndexQ", "[", 
      RowBox[{"i", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"{", 
         RowBox[{"_", ",", "basis_"}], "}"}]}], ",", "basis_"}], "]"}], ":=", 
     
     RowBox[{"BIndexQ", "[", "i", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"BIndexQ", "[", 
       RowBox[{
        RowBox[{"i", ":", 
         RowBox[{"{", 
          RowBox[{"_", ",", 
           RowBox[{"-", "basis_"}]}], "}"}]}], ",", "basis_"}], "]"}], ":=", 
      RowBox[{"BIndexQ", "[", "i", "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"basis_", "[", "_", "]"}]}], ",", "basis_"}], "]"}], ":=", 
     RowBox[{"BIndexQ", "[", "i", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{"i_", ",", 
       RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"BIndexQ", "[", "i", "]"}], "&&", 
      RowBox[{"IndexOnQ", "[", 
       RowBox[{"i", ",", "vbundle"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BIndexQ", "[", 
      RowBox[{"i_", ",", "_"}], "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"BIndexQ", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Protect", "[", "BIndexQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d46b3615-e30a-47fd-bffd-e15384efbc8f"],

Cell["This function gives False on a pattern for a basis index:", \
"Text",ExpressionUUID->"9c56529e-d835-41ec-8701-5b8961bdfa43"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BIndexQ", "/@", 
  RowBox[{"{", 
   RowBox[{"i_List", ",", 
    RowBox[{"{", 
     RowBox[{"i_", ",", "basis"}], "}"}], ",", 
    RowBox[{"{", "i_", "}"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"5d0c01c1-115e-44a1-b813-d04775168098"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"False", ",", "False", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"67fa0fbc-1e5d-428a-b159-1d70ce3ff640"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.4. Component Indices: CIndexQ", \
"Subsubsection",ExpressionUUID->"c2148d3a-df5e-48eb-aa80-ba16649e8e94"],

Cell["Identification of component indices:", \
"Text",ExpressionUUID->"f59ff978-3d33-4e7b-9f33-d79792b1009f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CIndexQ"}]], \
"Input",ExpressionUUID->"eea3a7a1-b094-45e2-a0ce-16c40714cce4"],

Cell[BoxData[
 StyleBox["\<\"CIndexQ[x] gives True if x is a valid component index: {i, \
basis}, where i is an integer cnumber compatible with basis. CIndexQ[x, \
basis] gives True if x is a valid component index belonging to basis. \
CIndexQ[x, vbundle] gives True if x is a valid component index belonging to \
some basis of the vector bundle vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellTags->
  "Info3578672416-5338953",ExpressionUUID->"3e9e3dc0-d8e9-406b-bc2a-\
bdc7937c750f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", 
    RowBox[{"argument", ":", " ", 
     RowBox[{
     "check", " ", "consistency", " ", "of", " ", "integer", " ", "and", " ", 
      "basis"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{"-", "i_"}], "]"}], ":=", 
     RowBox[{"CIndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{"{", 
       RowBox[{"i_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"xAct`xCoba`CNumbersOf", "[", "basis", "]"}], ",", "i"}], 
      "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CIndexQ", "[", 
       RowBox[{"basis_", "[", "i_Integer", "]"}], "]"}], ":=", " ", 
      RowBox[{"MemberQ", "[", 
       RowBox[{
        RowBox[{"xAct`xCoba`CNumbersOf", "[", "basis", "]"}], ",", "i"}], 
       "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", "i_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Two", " ", 
     RowBox[{"arguments", ":", " ", 
      RowBox[{"index", " ", "and", " ", 
       RowBox[{"basis", "/", "vbundle"}]}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{
       RowBox[{"-", "i_"}], ",", "x_"}], "]"}], ":=", 
     RowBox[{"CIndexQ", "[", 
      RowBox[{"i", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"{", 
         RowBox[{"_Integer", ",", "basis_"}], "}"}]}], ",", "basis_"}], "]"}],
      ":=", 
     RowBox[{"CIndexQ", "[", "i", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CIndexQ", "[", 
       RowBox[{
        RowBox[{"i", ":", 
         RowBox[{"{", 
          RowBox[{"_Integer", ",", 
           RowBox[{"-", "basis_"}]}], "}"}]}], ",", "basis_"}], "]"}], ":=", 
      RowBox[{"CIndexQ", "[", "i", "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"basis_", "[", "_Integer", "]"}]}], ",", "basis_"}], "]"}], ":=", 
     RowBox[{"CIndexQ", "[", "i", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{"i_", ",", 
       RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CIndexQ", "[", "i", "]"}], "&&", 
      RowBox[{"IndexOnQ", "[", 
       RowBox[{"i", ",", "vbundle"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CIndexQ", "[", 
      RowBox[{"i_", ",", "_"}], "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"CIndexQ", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Protect", "[", "CIndexQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"88b4b4b3-838e-439d-89af-6c1dcadfaefb"],

Cell["\<\
It might seem surprising that we do not use BasisQ here but effectively it is \
hidden in CNumbersOf.\
\>", "Text",ExpressionUUID->"e62b52bc-caf9-4a4b-aeeb-2333df13b79f"],

Cell["\<\
This function gives False on a pattern for a component index:\
\>", "Text",ExpressionUUID->"56edad92-8920-4a74-83c1-8999a84bc2dc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CIndexQ", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i_Integer", ",", "basis"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i_", ",", "basis"}], "}"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"0a2b54ff-655d-4e89-b35a-784ccd1cb4d2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"False", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"8ea214c9-a9dc-46c8-aa84-a600039d0a20"]
}, Open  ]],

Cell["\<\
Currently CIndexQ is only used in the conversion from delta to Basis, apart \
from the definitions of BCIndexQ, CDIndexQ and GIndexQ.\
\>", "Text",ExpressionUUID->"7dea367c-914f-41b7-b49b-bb8e39a008c5"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.5. Labels: LIndexQ", \
"Subsubsection",ExpressionUUID->"67570810-5877-4b6c-80e7-1abfca81c1b0"],

Cell["Identification of label indices:", \
"Text",ExpressionUUID->"bfd6aaa8-d32d-457a-bfec-465ebebb5425"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "LIndexQ"}]], \
"Input",ExpressionUUID->"abf27dba-f978-4af9-bfa7-6b30183a5dfe"],

Cell[BoxData[
 StyleBox["\<\"LIndexQ[x] gives True if x is a label (an expression with head \
LI, perhaps multiplied by -1), and False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672417-5338953",ExpressionUUID->"8fcabe47-2e6f-415e-94d7-\
9c8eacdf5a2b"]
}, Open  ]],

Cell["It cannot be simpler", \
"Text",ExpressionUUID->"909355f5-c0da-4b5d-955c-f06151e884e4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LIndexQ", "[", 
    RowBox[{"-", "_LI"}], "]"}], ":=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LIndexQ", "[", "_LI", "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LIndexQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"LIndexQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "LIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b7a0a57e-d7a5-4d0b-a460-3d151e051de6"],

Cell["This function gives False on a pattern for a label index:", \
"Text",ExpressionUUID->"9ecf6f47-a52a-4807-9cf9-f29ef6f914d3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LIndexQ", "/@", 
  RowBox[{"{", 
   RowBox[{"_LI", ",", 
    RowBox[{"-", "_LI"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"993b6faa-49bf-4218-af99-0a36a6ddb27b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"False", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"9aded3b6-1d2a-489e-b03d-4f1773b8046d"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.6. Directions: DIndexQ", \
"Subsubsection",ExpressionUUID->"c7d48c61-4417-4261-a09b-8daea5b0e900"],

Cell["Identification of directional indices:", \
"Text",ExpressionUUID->"23a0882b-1190-4b4e-82bb-5132df66f5c5"],

Cell["\<\
In the definition with two arguments we are calling UltraindexOf[dir] twice \
because DIndexQ[dir] calls it again through ValidateDir. There is probably \
much redundancy among DIndexQ, ValidateDir and UltraindexOf, though they are \
clearly different.\
\>", "Text",ExpressionUUID->"98462e4e-a49c-49a5-b824-010ad19fe941"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DIndexQ"}]], \
"Input",ExpressionUUID->"8db48509-2ced-4040-894c-4635d7080c9b"],

Cell[BoxData[
 StyleBox["\<\"DIndexQ[x] gives True if x is a valid directional index of the \
form Dir[v], where v is a covariant or contravariant vector. DIndexQ[x, \
vbundle] gives True if x is a valid directional index belonging to the vector \
bundle vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672419-5338953",ExpressionUUID->"4cd6fdaf-8932-4647-9927-\
debeb7afd4cc"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DIndexQ", "[", "dir_Dir", "]"}], ":=", 
   RowBox[{"dir", "===", 
    RowBox[{"ValidateDir", "[", "dir", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DIndexQ", "[", "x_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DIndexQ", "[", 
   RowBox[{"dir_", ",", "vbundle_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"DIndexQ", "[", "dir", "]"}], "&&", 
   RowBox[{"IndexOnQ", "[", 
    RowBox[{
     RowBox[{"UltraindexOf", "[", "dir", "]"}], ",", "vbundle"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DIndexQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5e366bbb-05d5-4246-abb3-f4823c0b34d5"],

Cell["\<\
This function gives False on a pattern for a directional index.\
\>", "Text",ExpressionUUID->"540eba4d-74e9-451c-95c0-7d1a3dab9ed4"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.7. Modified indices: MIndexQ", \
"Subsubsection",ExpressionUUID->"382beb00-faef-4113-8e7a-0749f0506ffc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MIndexQ", "[", 
    RowBox[{
     RowBox[{"_", "?", "IModQ"}], "[", "i_", "]"}], "]"}], ":=", 
   RowBox[{"GIndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MIndexQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"MIndexQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "MIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5f6351db-a47b-4a83-ab01-89f8883d3ee9"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.8. Contractible indices: ABIndexQ", \
"Subsubsection",ExpressionUUID->"764b02a1-b01b-4b65-a08b-5181827d19e4"],

Cell["\<\
This function identifies those indices which currently could be contracted: \
abstract-indices and basis-indices.\
\>", "Text",ExpressionUUID->"d570efdc-f95f-4510-a595-9f0d0cccff06"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ABIndexQ"}]], \
"Input",ExpressionUUID->"ddafb7d3-af14-4e12-bfb5-10eb8611eada"],

Cell[BoxData[
 StyleBox["\<\"ABIndexQ[x] gives True if x is an ABIndex (abstract index or \
basis index) and False otherwise. ABIndexQ[x, basis] gives True if x is an \
ABIndex belonging to basis and False otherwise. ABIndexQ[x, vbundle] gives \
True if x is an ABIndex belonging to the vector bundle vbundle and False \
otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672420-5338953",ExpressionUUID->"826a8e0f-c331-40bd-8d69-\
cc8be448e6cd"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ABIndexQ", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"AIndexQ", "[", "i", "]"}], "||", 
    RowBox[{"BIndexQ", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ABIndexQ", "[", 
    RowBox[{"i_", ",", "master_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"AIndexQ", "[", 
     RowBox[{"i", ",", "master"}], "]"}], "||", 
    RowBox[{"BIndexQ", "[", 
     RowBox[{"i", ",", "master"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ABIndexQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ABIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4ac27294-bce9-4288-907c-7b0766161a4d"],

Cell["This function is more careful than EIndexQ, but also slower.", \
"Text",ExpressionUUID->"f1bcd9b9-9993-41e5-a4b9-4b7a48149ff0"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.9. Basis and component indices: BCIndexQ", \
"Subsubsection",ExpressionUUID->"9a97f0a3-8bf5-4dc2-a461-79587f20121c"],

Cell["\<\
This function identifies those indices which are associated to bases or \
charts:\
\>", "Text",ExpressionUUID->"f9528bf2-e0b8-4e07-ba39-968365f1dc8a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "BCIndexQ"}]], \
"Input",ExpressionUUID->"0bfd0687-a40b-4297-a4db-708c93408c56"],

Cell[BoxData[
 StyleBox["\<\"BCIndexQ[x] gives True if x is a BCIndex (basis index or \
component index), and False otherwise. BCIndexQ[x, basis] gives True if x is \
a BCIndex belonging to basis and False otherwise. BCIndexQ[x, vbundle] gives \
True if x is an BCIndex belonging to the vector bundle vbundle and False \
otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672422-5338953",ExpressionUUID->"b56109a9-9855-4ec0-b691-\
bda2e9d3e420"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BCIndexQ", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"BIndexQ", "[", "i", "]"}], "||", 
    RowBox[{"CIndexQ", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BCIndexQ", "[", 
    RowBox[{"i_", ",", "master_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BIndexQ", "[", 
     RowBox[{"i", ",", "master"}], "]"}], "||", 
    RowBox[{"CIndexQ", "[", 
     RowBox[{"i", ",", "master"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"BCIndexQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "BCIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1396a3c4-c0da-468d-83bb-fbbbda056c40"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.10. Component and directional indices: CDIndexQ", \
"Subsubsection",ExpressionUUID->"246a84af-d411-48b0-b137-ef95de96b665"],

Cell["\<\
This function identifies those indices which are associated to components or \
directions:\
\>", "Text",ExpressionUUID->"dd829d04-265e-473f-be24-662bb8a9b94c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CDIndexQ"}]], \
"Input",ExpressionUUID->"2aef4767-8053-457b-833b-0edb55b54621"],

Cell[BoxData[
 StyleBox["\<\"CDIndexQ[x] gives True if x is a CDIndex (component index or \
directional index), and False otherwise. CDIndexQ[x, basis] gives True if x \
is a CDIndex belonging to basis and False otherwise. CDIndexQ[x, vbundle] \
gives True if x is an CDIndex belonging to the vector bundle vbundle and \
False otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672423-5338953",ExpressionUUID->"6f977a59-aace-4b8b-9077-\
82c5f3b506d6"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CDIndexQ", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"CIndexQ", "[", "i", "]"}], "||", 
    RowBox[{"DIndexQ", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CDIndexQ", "[", 
    RowBox[{"i_", ",", "master_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CIndexQ", "[", 
     RowBox[{"i", ",", "master"}], "]"}], "||", 
    RowBox[{"DIndexQ", "[", 
     RowBox[{"i", ",", "master"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"CDIndexQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "CDIndexQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d32ec9b9-deb1-4ca0-9ffb-c31466838396"],

Cell[TextData[{
 "Currently this function is only used (in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ") in the code of ZeroDerOnMetricQ."
}], "Text",ExpressionUUID->"9aaf0467-8e0a-4f02-a301-1100bee5f8c6"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.11. Generalized Indices: GIndexQ", \
"Subsubsection",ExpressionUUID->"727307df-c724-4f01-b441-54f0d3ce020a"],

Cell["Identification of generalized indices:", \
"Text",ExpressionUUID->"839d88ae-bbfd-464e-b8a9-877d021447f1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "GIndexQ"}]], \
"Input",ExpressionUUID->"6c2c6098-1dbd-4135-9fc9-99148c119777"],

Cell[BoxData[
 StyleBox["\<\"GIndexQ[x] gives True if x is a valid generalized index (an \
abstract index, a label index, a valid basis index, or a valid direction). \
Patterns are not accepted. Otherwise it gives False. GIndexQ[x, vbundle] \
gives True if x is a valid generalized index belonging to the vector bundle \
vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672424-5338953",ExpressionUUID->"106a9b7e-b1d9-4b03-a4fe-\
1e92414367de"]
}, Open  ]],

Cell["\<\
This function accepted patterns in version 0.7, but now it doesn't. This is a \
public function, and that could confuse the user, mainly because the \
functions UpIndexQ and DownIndexQ do not accept patterns.\
\>", "Text",ExpressionUUID->"c1878d3e-3ea6-4660-b3b5-92bc1d7d4a29"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Signs", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", 
      RowBox[{"-", "_Dir"}], "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", 
      RowBox[{"-", "x_"}], "]"}], ":=", 
     RowBox[{"GIndexQ", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Patterns", ".", " ", "Dropped"}], " ", "in", " ", "version", 
     " ", "0.8"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"GIndexQ", "[", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{"_Blank", "|", "_Pattern", "|", "_PatternTest"}], ")"}]}], 
      "]"}], ":=", 
     RowBox[{"PIndexQ", "[", "x", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Known", " ", "heads"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", "i_Symbol", "]"}], ":=", 
     RowBox[{"AIndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"GIndexQ", "[", "x_List", "]"}], ":=", 
      RowBox[{"BCIndexQ", "[", "x", "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", 
      RowBox[{"x", ":", 
       RowBox[{
        RowBox[{"_Symbol", "?", "BasisQ"}], "[", "_", "]"}]}], "]"}], ":=", 
     RowBox[{"BCIndexQ", "[", "x", "]"}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", "x_Dir", "]"}], ":=", 
     RowBox[{"DIndexQ", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", "x_LI", "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", 
      RowBox[{
       RowBox[{"_", "?", "IModQ"}], "[", "i_", "]"}], "]"}], ":=", 
     RowBox[{"GIndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"VBundle", " ", "check"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", 
      RowBox[{"i_", ",", "vbundle_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"GIndexQ", "[", "i", "]"}], "&&", 
      RowBox[{"IndexOnQ", "[", 
       RowBox[{"i", ",", "vbundle"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Other", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GIndexQ", "[", "_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"GIndexQ", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "GIndexQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4352a940-6ccc-486b-8f14-da89eb03cff5"],

Cell["\<\
Note that the definition GIndexQ[i_Symbol] must be given in terms of AIndexQ \
and not of AbstractIndexQ because the former admits the dollar-indices, but \
the latter doesn't.\
\>", "Text",ExpressionUUID->"c1c65d50-27bf-478f-b607-efd28b26e7d7"],

Cell["\<\
These two functions check a list of indices, with any head, and return a list \
with head IndexList:\
\>", "Text",ExpressionUUID->"06b8e31c-8eca-4b67-acb5-f041cd6bab71"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ValidateGIndex"}]], \
"Input",ExpressionUUID->"c600c3b9-fcb8-4897-8b36-55333bc71b51"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672426-5338953",ExpressionUUID->"1fc6c268-0f00-4212-b46d-\
a4a13a4c241f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidateGIndex", "[", "i_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"GIndexQ", "[", "i", "]"}], ",", "i", ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"GIndexQ", "::", "unknown"}], ",", "\"\<GIndex\>\"", ",", 
        "i"}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"39c1d527-1b98-4ecc-b6a4-139c23f2add6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ValidateIndexList"}]], \
"Input",ExpressionUUID->"8dc44b0c-bc29-4058-a257-d6ca9276f7cf"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672427-5338953",ExpressionUUID->"08d3ebc8-0e1d-45f0-a0ac-\
3f247eb56e68"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidateIndexList", "[", 
    RowBox[{"head_", "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{"ValidateGIndex", "/@", 
    RowBox[{"IndexList", "[", "inds", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1fe884d2-5ae5-4365-a795-8f743a75f383"],

Cell["\<\
The function ValidateGIndex (fully based on GIndexQ) is only used by \
ValidateIndexList. The latter is only used by IndexOrderedQ, which is \
currently not used. Essentially, it is a way to change a List of indices to \
an IndexList of indices. Perhaps we should remove those three functions \
altogether.\
\>", "Text",ExpressionUUID->"1c318779-3b3c-481d-8afb-d91da3a28699"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.12. Patterns: PIndexQ, PatternToIndex", \
"Subsubsection",ExpressionUUID->"9eec13c9-9268-4d99-8f3b-02f2aae44cc3"],

Cell[TextData[{
 "General comments on ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " patterns:\n\nThe heads that we must consider are: Blank, BlankSequence, \
BlankNullSequence, Alternatives, Pattern, PatternTest, Condition, Optional, \
Repeated, RepeatedNull, Verbatim, HoldPattern (See section Built-in Functions \
/ Programming / Pattern Matching).\n\nAs an example, this is the most \
complicated pattern I can think of (with a single Blank and a single \
Repeated):"
}], "Text",ExpressionUUID->"a26d4611-b6b2-49ac-a650-49b71bd099c8"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"a3deae0e-e52b-4dfc-b14f-f283fad5454b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x___h", "?", "Q"}], ")"}], ":", "v"}]}], "/;", "P"}], ")"}], 
   "..."}], "]"}]], \
"Input",ExpressionUUID->"e313edac-503f-40db-8bfa-23fc00247e1f"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"RepeatedNull", "[", 
    RowBox[{"Condition", "[", 
     RowBox[{
      RowBox[{"Optional", "[", 
       RowBox[{
        RowBox[{"Pattern", "[", 
         RowBox[{"a", ",", 
          RowBox[{"PatternTest", "[", 
           RowBox[{
            RowBox[{"Pattern", "[", 
             RowBox[{"x", ",", 
              RowBox[{"BlankNullSequence", "[", "h", "]"}]}], "]"}], ",", 
            "Q"}], "]"}]}], "]"}], ",", "v"}], "]"}], ",", "P"}], "]"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"e0a89744-b347-4bab-944c-e10abdd34be6"]
}, Open  ]],

Cell["\<\
This pattern could be also wrapped with HoldPattern or Verbatim and/or could \
be combined with other patterns using Alternatives. Therefore it is clear \
that the treatment of the general case of pattern is something rather \
involved.\
\>", "Text",ExpressionUUID->"ba0cd9f2-4e13-4cf3-8ee7-3bd2a59fc3d0"],

Cell["\<\
Note that there are two ways of naming a pattern. They are identical only if \
there are no patterntests:\
\>", "Text",ExpressionUUID->"4c0ef22e-8426-4b17-9d22-1f183cf5521b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "/@", 
  RowBox[{"{", 
   RowBox[{"x_h", ",", 
    RowBox[{"x", ":", "_h"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"c4b08ded-ee2d-4fd2-9338-2145adf99bd7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    StyleBox[
     RowBox[{"Pattern", "[", 
      RowBox[{"x", ",", 
       RowBox[{"Blank", "[", "h", "]"}]}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm], ",", 
   TagBox[
    StyleBox[
     RowBox[{"Pattern", "[", 
      RowBox[{"x", ",", 
       RowBox[{"Blank", "[", "h", "]"}]}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm]}], 
  "}"}]], "Output",ExpressionUUID->"30f34a37-2389-40d0-b691-fc712032e574"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x_h", "?", "Q"}], ",", 
    RowBox[{"x", ":", 
     RowBox[{"_h", "?", "Q"}]}]}], 
   "}"}]}]], "Input",ExpressionUUID->"2c91a990-934b-41d7-995d-f00432e2b622"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    StyleBox[
     RowBox[{"PatternTest", "[", 
      RowBox[{
       RowBox[{"Pattern", "[", 
        RowBox[{"x", ",", 
         RowBox[{"Blank", "[", "h", "]"}]}], "]"}], ",", "Q"}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm], ",", 
   TagBox[
    StyleBox[
     RowBox[{"Pattern", "[", 
      RowBox[{"x", ",", 
       RowBox[{"PatternTest", "[", 
        RowBox[{
         RowBox[{"Blank", "[", "h", "]"}], ",", "Q"}], "]"}]}], "]"}],
     ShowSpecialCharacters->False,
     ShowStringCharacters->True,
     NumberMarks->True],
    FullForm]}], 
  "}"}]], "Output",ExpressionUUID->"454d16f9-f407-484f-9c53-ea2f22d2fab7"]
}, Open  ]],

Cell["\<\
In any case, note that the name of a pattern or a patterntest is always in \
their first element. That is used several times in xTensor. In particular, \
the function PatternToIndex gives x in both cases.\
\>", "Text",ExpressionUUID->"2a85a487-34bd-44ba-a335-99a176d8b9b6"],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "h", ",", "P", ",", "Q", ",", "v", ",", "x"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"f0df8e4c-123a-4e2a-b0f9-a3297761bb8f"],

Cell["\<\
We consider pattern indices involving these heads: Blank, Pattern and \
PatternTest. Comments on the other heads:
\t- We do not accept BlankSequence, BlankNullSequence, Repeated or \
RepeatedNull because it is not possible to count indices.
\t- We do not accept Alternatives or Optional, but they could be easily added \
if there is a good reason to do it.
\t- The Condition construct is too difficult because the condition could be \
arbitrarily complicated.
\t- Verbatim is too harsh and could interfere with internal Verbatim \
expressions.
\t- HoldPattern is not accepted because the control of evaluation cannot be \
left to the user.
Do not use the pattern a:x_, with FullForm Pattern[a, Pattern[x, Blank[]]. \
xTensor expects to have the name of the pattern as first argument of Pattern. \
That means that the name x would be simply left untouched.
\t
It is important to see that a generic expression can contain generic \
patterns. The previous restrictions are only on *pattern indices*.\
\>", "Text",ExpressionUUID->"37702bea-edfb-45df-b5f5-e0056f90d5b2"],

Cell[TextData[{
 "We introduce these two functions to detect patterns indices, but they must \
be seldom used. Note that we do not need to use dollar indices for patterns \
because ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " already introduces unique symbols for them. These are also very basic \
functions that do not depend on any other xTensor function."
}], "Text",ExpressionUUID->"3913fe40-2290-4606-8a9f-22d5c794b1de"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "PIndexQ"}]], \
"Input",ExpressionUUID->"ce0539ac-a58f-4578-a05e-06d658bcf5c1"],

Cell[BoxData[
 StyleBox["\<\"PIndexQ[ind] gives True if ind is a valid pattern for an \
index: _, _h, a_h, a_h?Q where a must be a valid abstract index and h must be \
one of Symbol, Dir, LI, List, Blank, Pattern, PatternTest. Other kinds of \
pattern, in particular Condition, are not accepted.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672429-5338953",ExpressionUUID->"2a60ab00-ce46-4faf-805e-\
e46912b5b336"]
}, Open  ]],

Cell["\<\
We check the head h in Blank[h]. Allowed heads are Dir, List, LI, Symbol, \
Pattern, PatternTest, Blank, and no one else.\
\>", "Text",ExpressionUUID->"d3e4fddb-ac18-473b-8b34-314c6a64a602"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Pattern", " ", 
    RowBox[{"recognition", ".", " ", "BASIS1", ".", " ", "PINDEX"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"-", "x_"}], "]"}], ":=", 
     RowBox[{"PIndexQ", "[", "x", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"{", 
       RowBox[{"x_", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"PIndexQ", "[", "x", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "]"}], "]"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"General", "::", "warning"}], ",", 
         "\"\<PIndexQ used on an empty Blank.\>\"", ",", "$WarningFrom"}], 
        "]"}], ";", "True"}], ")"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "Symbol", "]"}], "]"}], "]"}], ":=", "True"}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "List", "]"}], "]"}], "]"}], ":=", "True"}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "Dir", "]"}], "]"}], "]"}], ":=", "True"}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "LI", "]"}], "]"}], "]"}], ":=", "True"}], ";"}],
    "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "Blank", "]"}], "]"}], "]"}], ":=", "True"}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "Pattern", "]"}], "]"}], "]"}], ":=", "True"}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{"Verbatim", "[", 
       RowBox[{"Blank", "[", "PatternTest", "]"}], "]"}], "]"}], ":=", 
     "True"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", "x_Blank", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Validate", "::", "nouse"}], ",", "\"\<PIndexQ\>\"", ",", 
         RowBox[{"ToString", "[", "x", "]"}]}], "]"}], ";", "False"}], 
      ")"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", "x_Pattern", "]"}], ":=", 
     RowBox[{
      RowBox[{"PIndexQ", "[", 
       RowBox[{"x", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "]"}], "&&", 
      RowBox[{"AIndexQ", "[", 
       RowBox[{"First", "[", "x", "]"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", "x_PatternTest", "]"}], ":=", 
     RowBox[{"PIndexQ", "[", 
      RowBox[{"First", "[", "x", "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", 
      RowBox[{
      "_Condition", "|", "_Optional", "|", "_Alternatives", "|", 
       "_BlankSequence", "|", "_BlankNullSequence", "|", "_Repeated", "|", 
       "_RepeatedNull"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"General", "::", "nouse"}], ",", "\"\<PIndexQ\>\"", ",", 
        "\"\<a forbidden pattern\>\""}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"PIndexQ", "[", "_", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"PIndexQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "PIndexQ", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a536ee34-f812-49b8-a656-a04e915cd3c8"],

Cell["\<\
Then we need a function to translate patterns to indices (note that it is \
private). We throw an error when we try to translate a Blank. What else could \
we do?\
\>", "Text",ExpressionUUID->"c86f2ed6-3fd8-43e0-a3de-2210c5e8cdcd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "PatternToIndex"}]], \
"Input",ExpressionUUID->"b10e8f00-8336-4b45-8aad-be8f6d879102"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`PatternToIndex[expr] changes every pattern, \
patterntest or condition in expr to the name of the pattern, patterntest or \
condition.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672430-5338953",ExpressionUUID->"84fe3fb8-d5e4-4498-bcb3-\
6f2953d1a5ab"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Translate", " ", "pattern", " ", "to", " ", 
     RowBox[{"index", ".", " ", "Note"}], " ", "that", " ", "Blank", " ", 
     "patterns", " ", "ARE", " ", "accepted"}], ",", " ", 
    RowBox[{"but", " ", "not", " ", 
     RowBox[{"converted", ".", " ", "PINDEX"}]}]}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", 
      RowBox[{"-", "x_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"PatternToIndex", "[", "x", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", "x_Blank", "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "nouse"}], ",", "\"\<PatternToIndex\>\"", 
        ",", 
        RowBox[{"\"\<a Blank pattern \>\"", "<>", 
         RowBox[{"ToString", "[", "x", "]"}]}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", "x_Pattern", "]"}], ":=", 
     RowBox[{"PatternToIndex", "[", 
      RowBox[{"First", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", "x_PatternTest", "]"}], ":=", 
     RowBox[{"PatternToIndex", "[", 
      RowBox[{"First", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PatternToIndex", "[", 
       RowBox[{"{", 
        RowBox[{"x_", ",", "basis_"}], "}"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PatternToIndex", "[", "x", "]"}], ",", "basis"}], "}"}]}], 
     ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", 
      RowBox[{
       RowBox[{"imod_", "?", "IModQ"}], "[", "x_", "]"}], "]"}], ":=", 
     RowBox[{"imod", "[", 
      RowBox[{"PatternToIndex", "[", "x", "]"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", "x_Integer", "]"}], ":=", "x"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", 
      RowBox[{
      "_Condition", "|", "_Optional", "|", "_Alternatives", "|", 
       "_BlankSequence", "|", "_BlankNullSequence", "|", "_Repeated", "|", 
       "_RepeatedNull"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "nouse"}], ",", "\"\<PatternToIndex\>\"", 
        ",", "\"\<a forbidden pattern\>\""}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PatternToIndex", "[", "x_", "]"}], ":=", "x"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"53230009-3786-49cc-bfb2-2da47f97a713"],

Cell["\<\
Note that PIndexQ does not make any attempt to analyze the structure of a Dir \
index. Only something like a_Dir is recognized as a pattern, if a is a valid \
abstract index.\
\>", "Text",ExpressionUUID->"13fc7553-abbd-4f33-b186-44309ededd14"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"45f7ae84-e5ef-47fc-87fe-4e5d47331e64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AbstractIndexQ", "[", "a", "]"}], "^=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"300673b9-deaf-4d65-9e6a-3a359db52302"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PIndexQ", "/@", 
  RowBox[{"List", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", "a", ",", 
    RowBox[{"-", "a_"}], ",", "a_Symbol", ",", "a_h", ",", 
    RowBox[{"a_", "?", "Q"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a_", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "Polar"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"3f5555ff-cae5-4f46-9a7d-f790bc3d0ed8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \[NoBreak]\\!\\(\\\"PIndexQ\\\"\\)\[NoBreak] \
on \[NoBreak]\\!\\(\\\"_h\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"09f013ef-2af4-4319-9e97-55cb2a9d92f3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "False", ",", "False", ",", "False", ",", "True", ",", "True", ",", "False",
    ",", "True", ",", "False", ",", "True"}], 
  "}"}]], "Output",ExpressionUUID->"54bff74b-0894-4ff0-b431-fd08e0bb95a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "[", 
  RowBox[{"xATP`PatternToIndex", "/@", 
   RowBox[{"{", 
    RowBox[{"a", ",", "a_", ",", "_a"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"12e3d2d5-af01-4e78-ae38-a370c1f2e35f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \[NoBreak]\\!\\(\\\"PatternToIndex\\\"\\)\
\[NoBreak] on \[NoBreak]\\!\\(\\\"a Blank pattern \
_a\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7f297be6-3efa-43f4-b879-989ceca08804"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`PatternToIndex", "/@", 
  RowBox[{"List", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", "a", ",", 
    RowBox[{"-", "a_"}], ",", "a_Symbol", ",", "a_h", ",", 
    RowBox[{"a_", "?", "Q"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a_", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "Polar"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"6678c609-c431-47b7-8fb4-356f60f07a0f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Polar"}], "}"}], ",", "a", ",", 
   RowBox[{"-", "a"}], ",", "a", ",", "a", ",", "a", ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"v", "[", "a_", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "Polar"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"ba74e1f1-5e5f-401b-abf1-90019a28d95c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PIndexQ", "[", "_", 
  "]"}]], "Input",ExpressionUUID->"b7e65455-6ffa-4749-9abc-5ac934e00e8c"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"4562c70c-79f2-4163-87e5-0369f784ba97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "xATP`PatternToIndex", "[", "_", 
   "]"}]}]], "Input",ExpressionUUID->"95a3acce-20d4-4849-9d67-120e5f182796"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \[NoBreak]\\!\\(\\\"PatternToIndex\\\"\\)\
\[NoBreak] on \[NoBreak]\\!\\(\\\"a Blank pattern \
_\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"47ddbcdd-f072-4be7-a6d4-3480f3df9b07"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "Q", ",", "v", ",", "h", ",", "Polar"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"9e914302-d5f5-41c2-b085-96a25125af6c"],

Cell["\<\
Note that pattern indices in a Dir structure are dealt with during the \
analysis of indices of the vector of the Dir structure, and not during the \
analysis of the indices of the tensor having the Dir structure as an index.\
\>", "Text",ExpressionUUID->"a5c2498f-f0e3-4ddc-90a0-e0bb0879279f"],

Cell["\<\
PatternToIndex is only used by IndexSort: patterns are sorted according to \
their names.
PIndexQ is only used by MakeRule: we need to know which indices are patterns.\
\
\>", "Text",ExpressionUUID->"b62c1f9a-3c46-4e5d-87ad-7a5cabaa448b"],

Cell["\<\
PIndexQ is considered as the equivalent of the functions like AIndexQ, \
BIndexQ, DIndexQ and LIndexQ. That is why it is public, even though it could \
be perfectly private.\
\>", "Text",ExpressionUUID->"7e6bfa48-4167-403a-8bd2-0070b9b11671"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3.13. Construction of patterns: PatternIndex", \
"Subsubsection",ExpressionUUID->"4431c1b5-f026-4a4c-80d0-321627076598"],

Cell["\<\
Currently we give definitions for abstract, directional and label indices, \
only. PINDEX\
\>", "Text",ExpressionUUID->"09bcb180-09ad-42aa-8cf3-3f205d761a18"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Off", "[", 
    RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Abstract", " ", "indices"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "AIndex", ",", 
     RowBox[{"_", ":", "Null"}]}], "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "]"}]}], "]"}], ",", "AIndexQ"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "AIndex", ",", "xAct`xTensor`Up"}], "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "Symbol", "]"}]}], "]"}], ",", "AIndexQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "AIndex", ",", "xAct`xTensor`Down"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"PatternTest", "[", 
     RowBox[{
      RowBox[{"Pattern", "[", 
       RowBox[{"name", ",", 
        RowBox[{"Blank", "[", "Symbol", "]"}]}], "]"}], ",", "AIndexQ"}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "AIndex", ",", "Null", ",", "vbundle_"}], 
    "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pmQ", "=", 
       RowBox[{"VBundleIndexPMQ", "[", "vbundle", "]"}]}], "}"}], ",", 
     RowBox[{"PatternTest", "[", 
      RowBox[{
       RowBox[{"Pattern", "[", 
        RowBox[{"name", ",", 
         RowBox[{"Blank", "[", "]"}]}], "]"}], ",", "pmQ"}], "]"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{
    "name_Symbol", ",", "AIndex", ",", "xAct`xTensor`Up", ",", "vbundle_"}], 
    "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"mQ", "=", 
       RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
     RowBox[{"PatternTest", "[", 
      RowBox[{
       RowBox[{"Pattern", "[", 
        RowBox[{"name", ",", 
         RowBox[{"Blank", "[", "Symbol", "]"}]}], "]"}], ",", "mQ"}], "]"}]}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PatternIndex", "[", 
     RowBox[{
     "name_Symbol", ",", "AIndex", ",", "xAct`xTensor`Down", ",", 
      "vbundle_"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mQ", "=", 
        RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
      RowBox[{"-", 
       RowBox[{"PatternTest", "[", 
        RowBox[{
         RowBox[{"Pattern", "[", 
          RowBox[{"name", ",", 
           RowBox[{"Blank", "[", "Symbol", "]"}]}], "]"}], ",", "mQ"}], 
        "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Directional", " ", "indices"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "DIndex", ",", 
     RowBox[{"_", ":", "Null"}]}], "]"}], ":=", 
   RowBox[{"Pattern", "[", 
    RowBox[{"name", ",", 
     RowBox[{"Blank", "[", "Dir", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "DIndex", ",", "xAct`xTensor`Up"}], "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "Dir", "]"}]}], "]"}], ",", "UpIndexQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "DIndex", ",", "xAct`xTensor`Down"}], "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "Dir", "]"}]}], "]"}], ",", "DownIndexQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "DIndex", ",", "Null", ",", "vbundle_"}], 
    "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "Dir", "]"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"DIndexQ", "[", 
        RowBox[{"#", ",", "vbundle"}], "]"}], ")"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{
    "name_Symbol", ",", "DIndex", ",", "xAct`xTensor`Up", ",", "vbundle_"}], 
    "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "Dir", "]"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"UpIndexQ", "[", "#", "]"}], "&&", 
        RowBox[{"DIndexQ", "[", 
         RowBox[{"#", ",", "vbundle"}], "]"}]}], ")"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PatternIndex", "[", 
     RowBox[{
     "name_Symbol", ",", "DIndex", ",", "xAct`xTensor`Down", ",", 
      "vbundle_"}], "]"}], ":=", 
    RowBox[{"PatternTest", "[", 
     RowBox[{
      RowBox[{"Pattern", "[", 
       RowBox[{"name", ",", 
        RowBox[{"Blank", "[", "Dir", "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"DownIndexQ", "[", "#", "]"}], "&&", 
         RowBox[{"DIndexQ", "[", 
          RowBox[{"#", ",", "vbundle"}], "]"}]}], ")"}], "&"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Label", " ", "indices"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "LIndex", ",", 
     RowBox[{"_", ":", "Null"}]}], "]"}], ":=", 
   RowBox[{"PatternTest", "[", 
    RowBox[{
     RowBox[{"Pattern", "[", 
      RowBox[{"name", ",", 
       RowBox[{"Blank", "[", "]"}]}], "]"}], ",", "LIndexQ"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "LIndex", ",", "xAct`xTensor`Up"}], "]"}], ":=", 
   RowBox[{"Pattern", "[", 
    RowBox[{"name", ",", 
     RowBox[{"Blank", "[", "LI", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PatternIndex", "[", 
    RowBox[{"name_Symbol", ",", "LIndex", ",", "xAct`xTensor`Down"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"Pattern", "[", 
     RowBox[{"name", ",", 
      RowBox[{"Blank", "[", "LI", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"On", "[", 
    RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"PatternIndex", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "4"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "PatternIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d2b1d535-243d-457a-b7ae-d9af75f7544a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.4. IndexSort", \
"Subsection",ExpressionUUID->"7431c249-c928-425d-be89-fb2932be8679"],

Cell[CellGroupData[{

Cell["5.4.1. IndexOrdereQ and DisorderedPairQ", \
"Subsubsection",ExpressionUUID->"0a48309d-dc3e-4db5-8a52-ace17ed95e80"],

Cell["\<\
The main function IndexSort cannot be defined in terms of an IndexOrderedQ \
function because the sorting process depends on all indices, and not just on \
their pairs. This is due to the use of dummies. Actually we proceed in the \
opposite way: we define IndexOrderedQ in terms of IndexSort:\
\>", "Text",ExpressionUUID->"944f4dad-625b-413d-921e-3b833f688a3d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexOrderedQ"}]], \
"Input",ExpressionUUID->"1fb5a2e7-9768-4bbe-818a-9d7343efe432"],

Cell[BoxData[
 StyleBox["\<\"IndexOrderedQ[{i1, i2, ...}] gives True if the list of \
g-indices is sorted according to IndexSort and False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672432-5338953",ExpressionUUID->"68540304-a44b-445c-a6b7-\
bb18437e1e10"]
}, Open  ]],

Cell[TextData[{
 "This function is currently not being used in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", but we still include it in the package."
}], "Text",ExpressionUUID->"079f5bbf-010d-4899-8d7d-53c1799b8764"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexOrderedQ", "[", "list_List", "]"}], ":=", 
   RowBox[{"IndexOrderedQ", "[", 
    RowBox[{"ValidateIndexList", "[", "list", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexOrderedQ", "[", "list_IndexList", "]"}], ":=", 
   RowBox[{"list", "===", 
    RowBox[{"IndexSort", "[", "list", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndexOrderedQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexOrderedQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ff18665f-e7f0-4f61-ae8a-fcc5053524d8"],

Cell["\<\
This is a special version, with two indices, specially useful when ordering \
derivatives. It can only use the information supplied by the pair of indices. \
QUESTION: Should we generalize it to accept the rest of the information \
needed to fully sort the indices? I don't think so.\
\>", "Text",ExpressionUUID->"882846e1-6a51-4935-826a-136d8b9c52cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DisorderedPairQ"}]], \
"Input",ExpressionUUID->"dbb463e2-aaf3-4550-b293-99c9a14cf71e"],

Cell[BoxData[
 StyleBox["\<\"DisorderedPairQ[i1, i2] gives True if the list of indices {i1, \
i2} is not in canonical order according to IndexSort, and False \
otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672434-5338953",ExpressionUUID->"23922a95-869a-40f7-b7b9-\
923ef2b647b7"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DisorderedPairQ", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"IndexSort", "[", 
     RowBox[{"IndexList", "[", 
      RowBox[{"a", ",", "b"}], "]"}], "]"}], "===", 
    RowBox[{"IndexList", "[", 
     RowBox[{"b", ",", "a"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DisorderedPairQ", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DisorderedPairQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"48a41678-cc02-4097-86fd-9293c9e0ba97"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.4.2. Discussion of priorities for index sorting", \
"Subsubsection",ExpressionUUID->"e43eef0c-d898-4f5b-84ad-67f53085fa63"],

Cell["\<\
First, we need to define a sorting order among different types of g-indices. \
The default lexicographic order of Mathematica already acts as an order for \
types, but it is not very convenient:\
\>", "Text",ExpressionUUID->"fb530fd6-6056-49a5-998d-e72670eed64a"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"31d19c9f-366c-407e-b013-f9fd59372e89"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sort", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "z", "]"}], "]"}], ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", 
      RowBox[{"-", "z"}], "]"}], "]"}], ",", "a", ",", 
    RowBox[{"-", "a"}], ",", "b", ",", 
    RowBox[{"-", "b"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"LI", "[", "1", "]"}], ",", 
    RowBox[{"LI", "[", 
     RowBox[{"-", "1"}], "]"}], ",", 
    RowBox[{"LI", "[", "2", "]"}], ",", 
    RowBox[{"LI", "[", 
     RowBox[{"-", "2"}], "]"}], ",", "_", ",", 
    RowBox[{"-", "_"}], ",", "b_", ",", 
    RowBox[{"-", "b_"}], ",", "a_h", ",", 
    RowBox[{"-", "a_h"}], ",", 
    RowBox[{"a_", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"a_", "?", "Q"}]}], ",", 
    RowBox[{"a_h", "?", "Q"}], ",", 
    RowBox[{"-", 
     RowBox[{"a_h", "?", "Q"}]}], ",", 
    RowBox[{"Polar", "[", "a", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], ",", 
    RowBox[{"Polar", "[", "1", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "1", "]"}]}], ",", 
    RowBox[{"Polar", "[", "2", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "2", "]"}]}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"0cec60a3-6e50-4e9c-a76c-d565926ad47f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "a"}], ",", "a", ",", 
   RowBox[{"-", "b"}], ",", "b", ",", 
   RowBox[{"-", "_"}], ",", "_", ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"v", "[", 
     RowBox[{"-", "z"}], "]"}], "]"}], ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"v", "[", "z", "]"}], "]"}], ",", 
   RowBox[{"LI", "[", 
    RowBox[{"-", "2"}], "]"}], ",", 
   RowBox[{"LI", "[", 
    RowBox[{"-", "1"}], "]"}], ",", 
   RowBox[{"LI", "[", "1", "]"}], ",", 
   RowBox[{"LI", "[", "2", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "Polar"}], "}"}], ",", 
   RowBox[{"-", "a_h"}], ",", "a_h", ",", 
   RowBox[{"-", "b_"}], ",", "b_", ",", 
   RowBox[{"-", 
    RowBox[{"a_", "?", "Q"}]}], ",", 
   RowBox[{"a_", "?", "Q"}], ",", 
   RowBox[{"-", 
    RowBox[{"a_h", "?", "Q"}]}], ",", 
   RowBox[{"a_h", "?", "Q"}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "1", "]"}]}], ",", 
   RowBox[{"Polar", "[", "1", "]"}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "2", "]"}]}], ",", 
   RowBox[{"Polar", "[", "2", "]"}], ",", 
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"Polar", "[", "a", "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"1412c949-acde-4cfb-b909-de6e08947874"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "b", ",", "h", ",", "v", ",", "z", ",", "Q", ",", "Polar"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"793c7088-ea1e-458e-bec8-58b06e89854c"],

Cell["\<\
We modify it using the function Sort0. This is fixed and cannot be changed by \
the user. Note that we always want to sort abstract indices before basis or \
component indices because Basis has Orderless attribute and we want to mimic \
that behaviour:\
\>", "Text",ExpressionUUID->"3e69123f-abeb-4583-8814-4ad6c72a0542"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", 
     RowBox[{"-", "x_"}], "]"}], ":=", 
    RowBox[{"Sort0", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Labels", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", "_LI", "]"}], ":=", "1"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Abstract", " ", "indices"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", "_Symbol", "]"}], ":=", "2"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Basis", " ", "indices"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"_Symbol", "|", 
        RowBox[{"-", "_Symbol"}]}], ",", "_"}], "}"}], "]"}], ":=", "3"}], 
   ";"}], " ", 
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Sort0", "[", 
      RowBox[{
       RowBox[{"_", "?", "BasisQ"}], "[", "_Symbol", "]"}], "]"}], ":=", 
     "3.1"}], ";"}], " ", 
   RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Modified", " ", 
     RowBox[{"indices", ".", " ", "We"}], " ", "need", " ", "this", " ", 
     "definition", " ", "after", " ", "that", " ", "for", " ", "bases"}], ",",
     " ", 
    RowBox[{
    "though", " ", "it", " ", "is", " ", "marked", " ", "with", " ", "a", " ",
      "lower", " ", "number"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", 
     RowBox[{
      RowBox[{"_", "?", "IModQ"}], "[", "_", "]"}], "]"}], ":=", "2.5"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Component", " ", "indices"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sort0", "[", 
    RowBox[{"{", 
     RowBox[{"_Integer", ",", "_"}], "}"}], "]"}], ":=", "4"}], ";", " ", 
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sort0", "[", 
    RowBox[{
     RowBox[{"_", "?", "BasisQ"}], "[", "_Integer", "]"}], "]"}], ":=", 
   "4.1"}], ";", " ", 
  RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", "_Integer", "]"}], ":=", "4.2"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Directions", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", "_Dir", "]"}], ":=", "5"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Patterns", ".", " ", "PINDEX"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sort0", "[", "_Blank", "]"}], ":=", "6"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Sort0", "[", "_Pattern", "]"}], ":=", "7"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Sort0", "[", "_PatternTest", "]"}], ":=", "8"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Other", "?"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sort0", "[", "_", "]"}], ":=", "9"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e6ff5796-317a-446c-8dd2-5a70e1d526ad"],

Cell["\<\
The rest of priorities wil be selected by the user. They are defined using \
strings. There are three groups: 
\t\"up\" / \"down\", 
\t\" free\" / \"dummy\", 
\t\"positional\" / \"antipositional\" / lexicographic\" / \"antilexicographic\
\".
The user must choose one per group and set an order for those three chosen. \
In the past the last group (that with 4 options) could only be a third \
priority, but now I don't really see why. It is clear that if we choose one \
of them as a first priority then only up/down is relevant, but not \
free/dummy. This could make sorting of dummies difficult because it would all \
depend on their dollar numbers, but that doesn\.b4t seem terrible. However, \
if we want to imitate Renato's ordering rule (of the kind {a, -a, b, -b, \
...}, which is {\"lexicographic\", \"up\"}) then we need to allow the third \
group as first or second priority.\
\>", "Text",ExpressionUUID->"e601bcd7-7c37-469a-abcd-376c5276bd1e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Set", "[", 
     RowBox[{
      RowBox[{"validpriority", "[", "#", "]"}], ",", "Null"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "\"\<up\>\"", ",", "\"\<down\>\"", ",", "\"\<free\>\"", ",", 
     "\"\<dummy\>\"", ",", "\"\<positional\>\"", ",", 
     "\"\<antipositional\>\"", ",", "\"\<lexicographic\>\"", ",", 
     "\"\<antilexicographic\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"validpriority", "[", "p_", "]"}], ":=", 
  RowBox[{"Throw", "[", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"SetIndexSortPriorities", "::", "invalid"}], ",", "p", ",", 
     "\"\<priority for index sorting\>\""}], "]"}], "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e5555977-9086-436a-9aa5-8de3a3e318f9"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.4.3. IndexSort and IndexSortPriorities", \
"Subsubsection",ExpressionUUID->"a49ff106-3b5b-4cf2-902c-5ef8afe6b9d8"],

Cell["\<\
The public function IndexSort is the main index sorting function. It is \
defined by a different public function: SetIndexSortPriorities:\
\>", "Text",ExpressionUUID->"322709e9-f1d4-4e7c-bd42-f7ebb188aa95"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SetIndexSortPriorities"}]], \
"Input",ExpressionUUID->"967fcb81-a271-41cf-8586-a9876961e763"],

Cell[BoxData[
 StyleBox["\<\"SetIndexSortPriorities[p1, p2, p3] sets the three priorities \
for g-index sorting. The pi are strings among these: priorities p1 and p2 are \
chosen from two of the pairs `up\.b4/`down\.b4 and `free\.b4/`dummy\.b4. \
Priority 3 can be chosen from one of the pairs \
`lexicographic\.b4/`antilexicographic\.b4 and `positional\.b4/`antipositional\
\.b4.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672435-5338953",ExpressionUUID->"2cd0d4f6-07d8-4452-9d14-\
19d216c1fc8c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexSort"}]], \
"Input",ExpressionUUID->"d6fa8c9e-e1e9-4468-bf41-7fbac67514c0"],

Cell[BoxData[
 StyleBox["\<\"IndexSort[list] sorts the elements of list (assumed to be \
g-indices) according to three priorities set up by SetIndexSortPriorities. \
Currently: \"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672436-5338953",ExpressionUUID->"ea363c03-0db1-493e-b1da-\
205e719972ce"]
}, Open  ]],

Cell["The three priorities are implemented using the functions", \
"Text",ExpressionUUID->"05c18788-45fa-4903-b1d7-5ee444491f07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Sort1"}]], "Input",ExpressionUUID->"067fc788-0170-4a35-8588-32f0accddd0f"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`Sort1 is an internal function specifying the \
first priority for sorting indices.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672438-5338953",ExpressionUUID->"14ed3bc5-1b04-45e9-a1be-\
3e4406ddf80a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Sort2"}]], "Input",ExpressionUUID->"41f45bf1-a867-4ead-8ee8-2d9330704f3d"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`Sort2 is an internal function specifying the \
second priority for sorting indices.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672439-5338953",ExpressionUUID->"2be35d4b-c78c-4644-99e4-\
3cd9afaca8d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Sort3"}]], "Input",ExpressionUUID->"f46f39e6-f7e7-42aa-aca1-229d04d3faaa"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`Sort3 is an internal function specifying the \
third priority for sorting indices.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672440-5338953",ExpressionUUID->"27bf2f92-a6d3-4535-ba69-\
e038e4d842a5"]
}, Open  ]],

Cell["\<\
The main point we use for sorting is the fact that False is sorted before \
True.\
\>", "Text",ExpressionUUID->"6fb3c1fd-7dbc-4139-a1ef-3a30c63bc7f3"],

Cell["\<\
These 8 functions implement the different priorities for index sorting. \
Comments:
\t- IndexSort handles patterns and therefore we need to use
\t\t- upQ instead of UpIndexQ and downQ instead of DownIndexQ.
\t\t- Verbatim when searching DummySorted, which must be constructed keeping \
the patterns.
\t\t- PatternToIndex when searching LexicSorted or $AbstractIndices.\
\>", "Text",ExpressionUUID->"1807310d-c760-4efe-bcf3-2083e3a7adc5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Two", " ", "variables", " ", "which", " ", "are", " ", "blocked", " ", 
    "in", " ", "IndexSort", " ", "and", " ", "hence", " ", "can", " ", "be", 
    " ", "used", " ", "here"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DummySorted", ";"}], "\n", 
   RowBox[{"LexicSorted", ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Recall", " ", "that", " ", "False", " ", "is", " ", "sorted", " ", 
     "before", " ", "True"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<up\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"downQ", "[", "#", "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<down\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"upQ", "[", "#", "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<free\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"DummySorted", ",", 
         RowBox[{"Verbatim", "[", "#", "]"}]}], "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<dummy\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"FreeQ", "[", 
        RowBox[{"DummySorted", ",", 
         RowBox[{"Verbatim", "[", "#", "]"}]}], "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<lexicographic\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{"LexicSorted", ",", 
         RowBox[{"UpIndex", "@", 
          RowBox[{"PatternToIndex", "[", "#", "]"}]}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<antilexicographic\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Reverse", "@", "LexicSorted"}], ",", 
         RowBox[{"UpIndex", "@", 
          RowBox[{"PatternToIndex", "[", "#", "]"}]}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<positional\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{"$AbstractIndices", ",", 
         RowBox[{"NoDollar", "@", 
          RowBox[{"UpIndex", "@", 
           RowBox[{"PatternToIndex", "@", "#"}]}]}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], "&"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortPriority", "[", "\"\<antipositional\>\"", "]"}], "=", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Reverse", "@", "$AbstractIndices"}], ",", 
         RowBox[{"NoDollar", "@", 
          RowBox[{"UpIndex", "@", 
           RowBox[{"PatternToIndex", "@", "#"}]}]}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], "&"}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"730d6985-92fd-4d0e-b80b-b10ce28633ae"],

Cell["Specification of priorities:", \
"Text",ExpressionUUID->"1e585058-eddb-4408-bc47-6c0d2869a9b4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetIndexSortPriorities", "[", 
   RowBox[{"p1_String", ",", "p2_String", ",", "p3_String"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "f", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"validpriority", "/@", 
      RowBox[{"{", 
       RowBox[{"p1", ",", "p2", ",", "p3"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Sort1", "=", 
      RowBox[{"SortPriority", "[", "p1", "]"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"Sort2", "=", 
      RowBox[{"SortPriority", "[", "p2", "]"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"Sort3", "=", 
      RowBox[{"SortPriority", "[", "p3", "]"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"IndexSort", "::", "usage"}], "=", 
      RowBox[{
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{"IndexSort", "::", "usage"}], ",", "144"}], "]"}], "<>", 
       "\"\<first: \>\"", "<>", "p1", "<>", "\"\<; second: \>\"", "<>", "p2", 
       "<>", "\"\<; third: \>\"", "<>", "p3", "<>", "\"\<.\>\""}]}], ";"}]}], 
   "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"SetIndexSortPriorities", "[", 
   RowBox[{
    RowBox[{"x_", "/;", 
     RowBox[{
      RowBox[{"Head", "[", "x", "]"}], "=!=", "String"}]}], ",", "_", ",", 
    "_"}], "]"}], ":=", 
  RowBox[{"Message", "[", 
   RowBox[{
    RowBox[{"SetIndexSortPriorities", "::", "invalid"}], ",", "x", ",", 
    "\"\<string\>\""}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"SetIndexSortPriorities", "[", 
   RowBox[{"_", ",", 
    RowBox[{"x_", "/;", 
     RowBox[{
      RowBox[{"Head", "[", "x", "]"}], "=!=", "String"}]}], ",", "_"}], "]"}],
   ":=", 
  RowBox[{"Message", "[", 
   RowBox[{
    RowBox[{"SetIndexSortPriorities", "::", "invalid"}], ",", "x", ",", 
    "\"\<string\>\""}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"SetIndexSortPriorities", "[", 
   RowBox[{"_", ",", "_", ",", 
    RowBox[{"x_", "/;", 
     RowBox[{
      RowBox[{"Head", "[", "x", "]"}], "=!=", "String"}]}]}], "]"}], ":=", 
  RowBox[{"Message", "[", 
   RowBox[{
    RowBox[{"SetIndexSortPriorities", "::", "invalid"}], ",", "x", ",", 
    "\"\<string\>\""}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SetIndexSortPriorities", ",", "3"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "SetIndexSortPriorities", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b448950c-ad64-4477-80b7-f81f1438b6c2"],

Cell["Main function:", \
"Text",ExpressionUUID->"199b4d24-f1e7-48f8-942b-edd8d296d762"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "IndexSort"}]], \
"Input",ExpressionUUID->"11505fbf-f6ed-42e3-92df-5a56e017c469"],

Cell[BoxData[
 StyleBox["\<\"IndexSort[list] sorts the elements of list (assumed to be \
g-indices) according to three priorities set up by SetIndexSortPriorities. \
Currently: \"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672442-5338953",ExpressionUUID->"a0af2305-88e4-4c90-8b74-\
9e95ed38a1c8"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexSort", "[", 
    RowBox[{"IndexList", "[", "]"}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexSort", "[", 
    RowBox[{"IndexList", "[", "ind_", "]"}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "ind", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexSort", "[", "list_List", "]"}], ":=", 
   RowBox[{"IndexSort", "[", 
    RowBox[{"Apply", "[", 
     RowBox[{"IndexList", ",", "list"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexSort", "[", "list_IndexList", "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"DummySorted", "=", 
        RowBox[{"TakeEIndices", "@", 
         RowBox[{"TakeEPairs", "[", "list", "]"}]}]}], ",", 
       RowBox[{"LexicSorted", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"UpIndex", "/@", 
          RowBox[{"PatternToIndex", "/@", "list"}]}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Last", "/@", 
      RowBox[{"Sort", "@", 
       RowBox[{"ReleaseHold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Sort0", "[", "#", "]"}], ",", 
             RowBox[{"Sort1", "[", "#", "]"}], ",", 
             RowBox[{"Sort2", "[", "#", "]"}], ",", 
             RowBox[{"Sort3", "[", "#", "]"}], ",", "#"}], "}"}], "&"}], 
          ")"}], "/@", "list"}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndexSort", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexSort", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"88277abc-089f-419c-beb1-f675ce2cb842"],

Cell["\<\
Comments:
\t- IndexSort does not need Catch because there is no error detection.
\t- IndexSort is rather complicated. Perhaps it is possible to define a \
simpler function which we take as default.
\t- When $AbstractIndices is very long, index-sorting could be very slow
\t- Is it possible to sort the numbers of dollar-indices in a proper way? Do \
we need it?\
\>", "Text",ExpressionUUID->"99519787-c129-460d-bbcf-69ea6fd2ca05"],

Cell["\<\
There is a problem indeed with the sorting of numbers in the dollar-indices \
when using the \"positional\" priority. We give examples below. It seems the \
use of \"lexicographic\" instead is safer.\
\>", "Text",ExpressionUUID->"492cafd6-69de-4bdc-b0d4-e868f5ee7128"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.4.5. Default sorting priorities", \
"Subsubsection",ExpressionUUID->"2669f5f5-0f34-4319-a276-972407efbfc6"],

Cell["\<\
This is the default ordering for indices, which seems to be more efficient \
than others, and coincide with Renato's choice in having the pair \
\"free/dummy\" before \"up/down\":\
\>", "Text",ExpressionUUID->"5ec8b15d-902f-4768-8966-f22c2e8ec965"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetIndexSortPriorities", "[", 
   RowBox[{"\"\<free\>\"", ",", "\"\<lexicographic\>\"", ",", "\"\<up\>\""}], 
   "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"db22b32c-0897-4f84-87dc-32fe7c33850a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.5. IndexPosition", \
"Subsection",ExpressionUUID->"809247cd-5964-4ed4-9952-d544949caf39"],

Cell["\<\
The problem with the function Position is that it finds -A when we are \
looking for just A. In the following we use an arbitrary head, which could be \
for example either List or IndexList.\
\>", "Text",ExpressionUUID->"17a7c0f1-6600-4af9-b223-6476b9bb961e"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9ae3dd80-db71-4b2a-9c8e-a907feb393d2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"head", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"ce04ff47-840e-4383-a1bc-f84592fadcd7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "5", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "2"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"700f8316-5ebc-4131-8011-ecb86dc62be7"]
}, Open  ]],

Cell["but using the function at level 1:", \
"Text",ExpressionUUID->"b300871a-270e-4cca-906c-1626adbd20a6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"head", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", "A", ",", 
   RowBox[{"{", "1", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"64580be2-ccde-41f2-bfb6-07cae5b5af8b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "5", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"d72112f5-49bd-4909-ba22-26028c00a8ed"]
}, Open  ]],

Cell["Vice versa, there is no problem:", \
"Text",ExpressionUUID->"2a3962ea-c99b-432f-8e70-056a9d826672"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"head", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"a5d432bd-5c97-458f-a0d5-29c1f5a96224"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", "6", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"6c9846c6-261a-4436-b04a-c00b796a5032"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"head", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"-", "A"}], ",", 
   RowBox[{"{", "1", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ebb7f71e-db5d-48c5-9cd3-e282ae4c93eb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", "6", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"fa3a7a8d-e031-4ba6-8ac6-af55e55cf633"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"head", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", "E"}], 
  "]"}]], "Input",ExpressionUUID->"0a72b56a-5279-43a2-823e-53159a79a4b4"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"9e59bdef-a60d-4bd4-ade8-4fe7a3c0b6a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"head", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", "E", ",", 
   RowBox[{"{", "1", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c9fd58fb-2859-4d74-9a34-b8b297ab4f4c"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"b1bfb8f9-b032-4d9d-ae17-e857f3086565"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"A", ",", "B", ",", "head"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"a1e176c9-9f00-40d8-bc05-30ae55d6e65b"],

Cell["\<\
New function. It is only used by symperms and ToCanonicalOne. We add the \
Verbatim construct to manipulate patterns:\
\>", "Text",ExpressionUUID->"ab98b4eb-52a9-4be5-aaf4-e958f98e830b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexPosition"}]], \
"Input",ExpressionUUID->"c3f01537-95bd-4ab8-9dc0-32aec5cbcc37"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`IndexPosition[list, ind] gives the positions \
of index ind in list. The index ind can be an up/down-index and the list can \
have any head.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672444-5338953",ExpressionUUID->"edb4ad41-c892-4d39-ba1a-\
6d7410e2b756"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IndexPosition", "[", 
   RowBox[{"list_", ",", "index_"}], "]"}], ":=", 
  RowBox[{"Position", "[", 
   RowBox[{"list", ",", 
    RowBox[{"Verbatim", "[", "index", "]"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9668aeca-b2ef-4181-b01e-4b2160beeb7b"],

Cell["Up / Down:", \
"Text",ExpressionUUID->"a0a81c64-f2b1-498f-b3e1-08a0fb4cd0eb"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"da6f02d5-05b5-4957-9a7a-20a2392801f5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"ea89dd32-c969-405a-a498-27ff043e5081"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], 
  "}"}]], "Output",ExpressionUUID->"2c4ac607-a609-4c40-b5f8-bdfe03506a5a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"8d6334ac-5536-44f2-94f5-44879c85b4ff"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "2", "}"}], 
  "}"}]], "Output",ExpressionUUID->"327c7bb6-7d37-4160-9988-e49443f90643"]
}, Open  ]],

Cell["Other:", "Text",ExpressionUUID->"c6f5464a-4d23-41fe-8ec9-718a8f75dca9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "A_E"}], ",", 
     RowBox[{"-", 
      RowBox[{"A_", "?", "E"}]}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"v", "[", "E", "]"}], "]"}]}], "]"}], ",", "E"}], 
  "]"}]], "Input",ExpressionUUID->"d46c76e2-046d-48bc-ae40-afc2f537679c"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"8548cc97-fd7d-4971-9d35-da8edfaafce1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "C", ",", "C_", ",", 
     RowBox[{"-", "C_"}]}], "]"}], ",", "C_"}], 
  "]"}]], "Input",ExpressionUUID->"b36d6b21-2774-4356-bec9-78f42644dae3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "4", "}"}], 
  "}"}]], "Output",ExpressionUUID->"1cb75e27-3603-4935-83cc-224168714d13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "C", ",", "C_", ",", 
     RowBox[{"-", "C_"}]}], "]"}], ",", 
   RowBox[{"-", "C_"}]}], 
  "]"}]], "Input",ExpressionUUID->"cf665f8c-14fc-4b8f-bb7f-9ef7089854e7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "5", "}"}], 
  "}"}]], "Output",ExpressionUUID->"dc9521dd-cbd7-4c53-bf0c-df28cdf5e366"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "C", ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"v", "[", "A", "]"}], "]"}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"v", "[", "A", "]"}], "]"}]}], "]"}], ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"v", "[", "A", "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"41eccd1f-27e2-42b6-b10e-b76769106902"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", "5", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"6d078157-bde5-4c29-a2b2-7f95f6d90170"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "C", ",", "C_", ",", 
     RowBox[{"-", "C_"}], ",", "_", ",", 
     RowBox[{"-", "_"}], ",", "_"}], "]"}], ",", "_"}], 
  "]"}]], "Input",ExpressionUUID->"e3783e9b-17c9-4228-b915-15abe782b89f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "6", "}"}], ",", 
   RowBox[{"{", "8", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"029c20d5-c066-489e-b28e-7f7b809c01bb"]
}, Open  ]],

Cell["Basis indices:", \
"Text",ExpressionUUID->"6e32065e-c281-47a9-8505-58572c8dd16d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"c0036512-5c36-4756-8a2f-d0e45793f346"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], 
  "}"}]], "Output",ExpressionUUID->"b79ac3f7-18df-4f2d-82e8-b900ab5f26d9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b397ccd7-0cda-4719-bd78-b2582806937c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "2", "}"}], 
  "}"}]], "Output",ExpressionUUID->"ac0f2144-4d76-4747-a335-d8249bfc6af7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"620fe1d3-c535-46d2-a67c-314e1ac828e1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "3", "}"}], 
  "}"}]], "Output",ExpressionUUID->"66c4647e-3e81-48be-baa7-2ecf20d07533"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPosition", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"04ecb339-0d40-422b-a04b-9518da840540"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "4", "}"}], 
  "}"}]], "Output",ExpressionUUID->"f90a738f-c76d-42b3-b9b0-4ef725a669c5"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"A", ",", "B", ",", "Polar", ",", "v"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"5422e15b-4131-45d3-86f1-8635581e3d36"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6. FindIndices", \
"Subsection",ExpressionUUID->"da0eb140-ae7b-4322-881f-9681877138cf"],

Cell[CellGroupData[{

Cell["5.6.0. Comments", \
"Subsubsection",ExpressionUUID->"d756586c-3303-48c7-8955-5f1b325173a3"],

Cell[TextData[{
 "FindIndices finds all g-indices of a given expression, with two exceptions: \
\n\t1) It does not find the g-indices of its subexpressions with free \
ultradummies because those are not needed in the main computations \
(directional indices and the vector arguments of Lie derivatives and Lie \
brackets).\n\t2) It does not find the g-indices of Scalar subexpressions or \
scalar functions.\nFindIndices must be able to get those g-indices without \
evaluating the expression. For example, in a Module expression it must get \
the indices of the expression before allowing the indices to be replaced by \
unique variables.\n\nThis is one of the most important functions in ",
 StyleBox["xTensor,",
  FontSlant->"Italic"],
 " and it has already been coded up in different ways. Essentially we have \
these problems:\n\t- FindIndices checks that indices are not repeated in \
\"Times\" expressions, and\n\t- checks that free indices are homogeneous in \
\"Plus\" expressions, and\n\t- should check that there are not abstract \
indices, basis indices or pattern indices having the same name, though this \
is not finished.\n This takes some time, but it seems very important to me. \
The functions CheckRepeated and CheckHomogeneity could probably be more \
efficient."
}], "Text",ExpressionUUID->"a4c06baa-40c3-41a0-9620-0b3271b2cb52"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.1. CheckRepeated, CheckHomogeneity and CheckIndexType", \
"Subsubsection",ExpressionUUID->"2d0d8fae-f83d-4ec4-ab06-b40b5fa7a763"],

Cell[TextData[StyleBox["1) CheckRepeated",
 FontWeight->
  "Bold"]], "Text",ExpressionUUID->"0ca2bedb-3123-4cc6-808a-827817430409"],

Cell["\<\
First we define a function that checks whether there are repeated indices in \
a sequence of lists of indices, and then returns a single list with all \
indices. We need to define the concept of repeated indices: they are indices \
with the same name, what turns the problem into the definition of the name of \
an index. The answer is given by the function IndexName, which is very \
similar in structure to PatternToIndex. The main difference is that it gives \
name 0 to blocked indices and blanks, and gives name i to the basis index {i, \
basis}. This means that blocked indices can be repeated because CheckRepeated \
below checks for repeated names which are symbols, or -symbols. If blanks or \
patterns are present it really doesn't make sense to check much, given that \
they may stand for many different things. Definition for BlankSequence and \
BlankNullSequence added as suggested by Leo.\
\>", "Text",ExpressionUUID->"03b838aa-8c84-4eec-bb77-fe7aa86478ba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexName"}]], \
"Input",ExpressionUUID->"22cd4283-0a62-4bb3-b820-143651b52566"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`IndexName[i] returns the so-called name of the \
g-index i. For abstract indices, the name equals the index. For basis \
indices, it returns the corresponding abstract index or 0 for a component \
index. For directional indices, labels and Blanks the name is also defined as \
0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672446-5338953",ExpressionUUID->"67393c3e-ce50-436f-86bb-\
89038da3ad2e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Names", " ", "of", " ", 
     RowBox[{"indices", ".", " ", "Sign"}], " ", "is", " ", 
     RowBox[{"kept", ".", " ", "Single"}]}], "-", 
    RowBox[{
    "index", " ", "of", " ", "a", " ", "Dim1", " ", "spaces", " ", "should", 
     " ", "also", " ", "be", " ", "declared", " ", "with", " ", "name", " ", 
     "0"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexName", "[", 
      RowBox[{"-", "i_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"IndexName", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"IndexName", "[", "i_Symbol", "]"}], ":=", "i"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Blocked", " ", "indices", " ", "and", " ", "blanks", " ", "get", " ", 
     "name", " ", "0"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexName", "[", 
      RowBox[{"i", ":", 
       RowBox[{"(", 
        RowBox[{
        "_Dir", "|", "_LI", "|", "_Blank", "|", "_BlankSequence", "|", 
         "_BlankNullSequence", "|", "_Integer"}], ")"}]}], "]"}], ":=", "0"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"These", " ", "cases", " ", "should", " ", "never", " ", 
     RowBox[{"happen", ".", " ", "This"}], " ", "is", " ", "a", " ", "safety",
      " ", "feature"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexName", "[", 
      RowBox[{"i", ":", 
       RowBox[{"(", 
        RowBox[{"_String", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
        ")"}]}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Found index \>\"", ",", "i"}], "]"}], ";", "0"}], 
      ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Basis", " ", "indices", " ", "and", " ", "headed", " ", 
       RowBox[{"patterns", ".", " ", "BASIS1"}], " ", "and", " ", "BASIS2"}], 
      " ", "&"}], " ", "IMOD"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexName", "[", "i_", "]"}], ":=", 
     RowBox[{"IndexName", "[", 
      RowBox[{"First", "[", "i", "]"}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"752b22a5-61da-4740-b947-7de2e18a70a0"],

Cell["\<\
IndexName uses a lucky fact. In all cases: {i, basis}, imod[i], Pattern[i,*], \
PatternTest[i,*] what we need is simply computing the IndexName of the first \
element.\
\>", "Text",ExpressionUUID->"17c3d8e7-f636-4587-87f5-fdf09548e018"],

Cell["\<\
With that function we define CheckRepeated. Strategy:
0) The initial input is a sequence of lists of indices with head IndexList. \
With IndexList[AnyIndices] stop check
1) We join the lists and construct a list of pairs Index[index, \
IndexName[index]]
2) Check that no name is repeated. If there are repeated names throw an error
4) Give the list of indices, with the original order.\
\>", "Text",ExpressionUUID->"34f1e7a9-b023-438e-ac95-6bdcd8b7db62"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckRepeated"}]], \
"Input",ExpressionUUID->"a71a237d-2dd4-4f4d-8a52-35c1aaa37029"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672447-5338953",ExpressionUUID->"8dbcab87-c02a-41ee-8a5c-\
c9e6d2c000f0"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Validate", "::", "repeated"}], "=", 
    "\"\<Found indices with the same name `1`.\>\""}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Driver", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckRepeated", "[", "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckRepeated", "[", 
    RowBox[{
     RowBox[{"IndexList", "[", "]"}], ".."}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckRepeated", "[", 
    RowBox[{"___", ",", 
     RowBox[{"IndexList", "[", "AnyIndices", "]"}], ",", "___"}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "AnyIndices", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CheckRepeated", "[", "lists__IndexList", "]"}], ":=", 
    RowBox[{"CheckRepeated1", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Index", "[", 
        RowBox[{"#", ",", 
         RowBox[{"IndexName", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
      RowBox[{"Join", "[", "lists", "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Give", " ", "error", " ", "or", " ", "return", " ", "original", " ", 
    "list"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckRepeated1", "[", 
    RowBox[{"list", ":", 
     RowBox[{"IndexList", "[", 
      RowBox[{"___Index", ",", 
       RowBox[{"Index", "[", 
        RowBox[{"_", ",", 
         RowBox[{"i", ":", 
          RowBox[{"(", 
           RowBox[{"_Symbol", "|", 
            RowBox[{"-", "_Symbol"}]}], ")"}]}]}], "]"}], ",", "___Index", 
       ",", 
       RowBox[{"Index", "[", 
        RowBox[{"_", ",", "i_"}], "]"}], ",", "___Index"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Validate", "::", "repeated"}], ",", 
      RowBox[{"ToString", "[", "i", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckRepeated1", "[", 
    RowBox[{"list", ":", 
     RowBox[{"IndexList", "[", "__Index", "]"}]}], "]"}], ":=", 
   RowBox[{"First", "/@", "list"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dd6ab7a9-bd8c-4f21-a063-c7743256c274"],

Cell["\<\
A possible alternative form dealing with Dim1 spaces. Now deactivated.\
\>", "Text",ExpressionUUID->"44b1795a-b538-4356-a4cd-9e039d22cf47"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Remove", " ", "indices", " ", "in", " ", "Dim1", " ", 
    RowBox[{"spaces", ".", " ", "Give"}], " ", "error", " ", "or", " ", 
    "return", " ", "original", " ", 
    RowBox[{"list", ".", " ", "$Dim1Indices"}], " ", "is", " ", "of", " ", 
    "the", " ", "form", " ", 
    RowBox[{"Alternatives", "[", 
     RowBox[{"o", ",", 
      RowBox[{"-", "o"}], ",", "O", ",", 
      RowBox[{"-", "O"}]}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"$VersionNumber", "<", "6.0"}], ",", 
      RowBox[{
       RowBox[{"Tally", "[", "list_List", "]"}], ":=", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"First", "[", "#", "]"}], ",", 
           RowBox[{"Length", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
        RowBox[{"Split", "[", 
         RowBox[{"Sort", "[", "list", "]"}], "]"}]}]}]}], "]"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CheckRepeated1", "[", "list_IndexList", "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"check", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{
          RowBox[{"Tally", "[", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Last", "/@", 
              RowBox[{"List", "@@", "list"}]}], ",", 
             RowBox[{"0", "|", "$Dim1Indices"}]}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"_", ",", "1"}], "}"}]}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"check", "=!=", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Validate", "::", "repeated"}], ",", 
           RowBox[{"First", "/@", "check"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"First", "/@", "list"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"$Dim1Indices", "=", 
    RowBox[{"Alternatives", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
  "*)"}]], "Input",
 Evaluatable->False,ExpressionUUID->"dface208-2adf-4022-9cfa-b6aa76bf8cdc"],

Cell["Examples:", \
"Text",ExpressionUUID->"665a87a9-bb80-48b7-9687-4dbd11c00039"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f995518e-40e0-488a-be95-6a5230f9f039"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", "]"}], ",", 
   RowBox[{"IndexList", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"dcee6636-3f76-4407-acea-0f2e9d5918e0"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"610c37b1-1d1d-4279-b3a7-e9b687488ba7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", "AnyIndices", "]"}], ",", 
   RowBox[{"IndexList", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c3e67b09-390a-4df0-87e6-9b2fd0a5aa2b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "AnyIndices", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[xAct`xTensor`AnyIndices],
  Editable->
   False]], "Output",ExpressionUUID->"98c97dad-3d6e-47a2-bb02-527aa86a48c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "_", ",", "c", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"v", "[", "a", "]"}], "]"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"Dir", "[", 
      RowBox[{"v", "[", "a", "]"}], "]"}], ",", "d_", ",", "_"}], "]"}], ",", 
   
   RowBox[{"IndexList", "[", "AnyIndices", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c7dfafc4-1577-4a9c-8f9b-a88764add663"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "AnyIndices", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[xAct`xTensor`AnyIndices],
  Editable->
   False]], "Output",ExpressionUUID->"d324e61f-f3e8-4017-be63-f77e71e343f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "a_"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"eab3b248-1570-4f45-8fcd-0c3c689f9dec"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"-a\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d2480edc-836a-40aa-a569-13158ba7167d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", 
     RowBox[{"_", ",", "a", ",", "b", ",", "c"}], "]"}], ",", 
    RowBox[{"IndexList", "[", "c", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"e85d5bbf-2784-44c8-8d93-f261807e08f7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"c\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"cf8e83e2-91cc-4bc2-987e-e3233c6779e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", 
     RowBox[{"_", ",", "a", ",", "b", ",", "c"}], "]"}], ",", 
    RowBox[{"IndexList", "[", "c_", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"1a2d1833-b51c-4075-9505-8c5970cca8a1"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"c\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"df5ce6cb-7971-4c89-b661-44fa5be920b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", 
     RowBox[{"a", ",", "b", ",", 
      RowBox[{"c_h", "?", "Q"}]}], "]"}], ",", 
    RowBox[{"IndexList", "[", "c_", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"ed13e391-760b-4a19-9704-3f961d6a2a2b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"c\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"46e878f3-5e8e-4a8f-aecb-3d6ce43be3d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"_", ",", "a", ",", "b", ",", "c"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"_", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"f9a6cc5d-a427-4e8d-8c7f-3bf4903f7af7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "_", "\<\",\"\>", "a", "\<\",\"\>", 
    "b", "\<\",\"\>", "c", "\<\",\"\>", "_", "\<\",\"\>", "d", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Blank[], $CellContext`a, $CellContext`b, $CellContext`c, 
   Blank[], $CellContext`d],
  Editable->
   False]], "Output",ExpressionUUID->"4ad903a1-85f9-4772-bda8-dc733d3e7376"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", "d_", ",", 
    RowBox[{"Polar", "[", "1", "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"06b02e2f-2160-4b17-9967-adfdd5144142"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", "\<\",\"\>", 
    "c", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", "d_", "\<\",\"\>", 
    RowBox[{"Polar", "[", "1", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b, $CellContext`c, {
   1, $CellContext`Polar}, 
   Pattern[$CellContext`d, 
    Blank[]], 
   $CellContext`Polar[1]],
  Editable->
   False]], "Output",ExpressionUUID->"173d32d2-9eb6-45ed-8779-c869d7dfa052"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", "d_", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], ",", 
    RowBox[{"Polar", "[", "2", "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"4d1b806c-c5fa-47ec-a6ad-543f3959ef8e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", "\<\",\"\>", 
    "c", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", "d_", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"Polar", "[", "2", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b, $CellContext`c, {
   1, $CellContext`Polar}, {1, $CellContext`Polar}, 
   Pattern[$CellContext`d, 
    Blank[]], {2, $CellContext`Polar}, 
   $CellContext`Polar[2]],
  Editable->
   False]], "Output",ExpressionUUID->"e1167f36-66a3-45bc-9015-9c7a8318e8e7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"Dir", "[", "v", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], ",", 
    RowBox[{"Polar", "[", "2", "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"58b5f302-b5d1-4fdb-8088-8bdc6b098af2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", "\<\",\"\>", 
    "c", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", "v", "]"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"Polar", "[", "2", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b, $CellContext`c, {
   1, $CellContext`Polar}, 
   xAct`xTensor`Dir[$CellContext`v], {1, $CellContext`Polar}, {
   2, $CellContext`Polar}, 
   $CellContext`Polar[2]],
  Editable->
   False]], "Output",ExpressionUUID->"554d72a7-543e-4538-b519-9d48dc2a9066"]
}, Open  ]],

Cell["\<\
Note that there is no check of type. There is only check of name:\
\>", "Text",ExpressionUUID->"4a62cc9d-4afd-4638-a830-1554e2f05731"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "Polar"}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e9ce055c-b8c1-4942-9ee8-b55d00f3084f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "a"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"a", ",", "Polar"}], "}"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`a, {$CellContext`a, \
$CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"becdae06-57be-4146-8fab-fcb2c1328fb1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckRepeated", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"0527f453-f932-4986-801a-c20ee3c48585"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, -$CellContext`Polar[$CellContext`a]],
  
  Editable->
   False]], "Output",ExpressionUUID->"e46264c8-252c-44c4-9a8d-0643a4f73429"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "Polar"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"6e4ecf87-bd07-4b60-8ae0-b1d546e9d153"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"a\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c6d41f3c-1980-4adc-9402-430dfecdbc57"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Polar", "[", "a", "]"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"1d804ce5-fbc6-4ee6-9218-b84a6f05eff1"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"a\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"96fbd1f3-5234-4bc4-99b1-5c39b7513dce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "Polar"}], "}"}], ",", 
     RowBox[{"Polar", "[", "a", "]"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"eb6d93d4-3fd2-4748-95d2-0974caae52d4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"a\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2422bde9-b2b6-407b-b148-46dd603d3056"]
}, Open  ]],

Cell["\<\
It is not possible to have two basis indices with the same name:\
\>", "Text",ExpressionUUID->"1cab0bc3-6165-4b53-95a8-696a848bbe20"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "Cartesian"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "Polar"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"101f42e2-ca77-41f9-b461-cc4af7db0c67"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"a\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6ac68129-b1e8-40c9-a990-68f2de0d9e72"]
}, Open  ]],

Cell["\<\
The function is not very efficient for low numbers of indices:\
\>", "Text",ExpressionUUID->"4c598ffd-a4f4-42f4-bbfd-9176681fb042"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`CheckRepeated", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5dc45937-d2f6-4b0a-9945-d25cbbd4ec19"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`CheckRepeated", "[", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
      Editable->False], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`CheckRepeated1", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"#1", ",", 
          RowBox[{"xAct`xTensor`Private`IndexName", "[", "#1", "]"}]}], "]"}],
         "&"}], ")"}], "/@", 
      RowBox[{"Join", "[", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          StyleBox["{",
           FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
          StyleBox["}",
           FontColor->RGBColor[0, 0, 1]]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
        Editable->False], "]"}]}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"Join", "[", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            StyleBox["{",
             FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
            StyleBox["}",
             FontColor->RGBColor[0, 0, 1]]}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
          Editable->False], "]"}],
        HoldForm], ",", 
       TagBox[
        InterpretationBox[
         StyleBox[
          RowBox[{
           StyleBox["{",
            FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
           StyleBox["}",
            FontColor->RGBColor[0, 0, 1]]}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
         Editable->False],
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"xAct`xTensor`Private`Index", "[", 
          RowBox[{"#1", ",", 
           RowBox[{"xAct`xTensor`Private`IndexName", "[", "#1", "]"}]}], 
          "]"}], "&"}], ")"}], "/@", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          StyleBox["{",
           FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
          StyleBox["}",
           FontColor->RGBColor[0, 0, 1]]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
        Editable->False]}],
      HoldForm], ",", 
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["{",
          FontColor->RGBColor[0, 0, 1]], 
         RowBox[{"xAct`xTensor`Private`Index", "[", 
          RowBox[{"a", ",", "a"}], "]"}], "\<\",\"\>", 
         RowBox[{"xAct`xTensor`Private`Index", "[", 
          RowBox[{"b", ",", "b"}], "]"}], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`IndexList[
        (xAct`xTensor`Private`Index[#, 
         xAct`xTensor`Private`IndexName[#]]& )[$CellContext`a], 
        (xAct`xTensor`Private`Index[#, 
         xAct`xTensor`Private`IndexName[#]]& )[$CellContext`b]],
       Editable->False],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`Index", "[", 
            RowBox[{"#1", ",", 
             RowBox[{"xAct`xTensor`Private`IndexName", "[", "#1", "]"}]}], 
            "]"}], "&"}], ")"}], "[", "a", "]"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"a", ",", 
          RowBox[{"xAct`xTensor`Private`IndexName", "[", "a", "]"}]}], "]"}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"xAct`xTensor`Private`IndexName", "[", "a", "]"}],
          HoldForm], ",", 
         TagBox["a",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"a", ",", "a"}], "]"}],
        HoldForm]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`Index", "[", 
            RowBox[{"#1", ",", 
             RowBox[{"xAct`xTensor`Private`IndexName", "[", "#1", "]"}]}], 
            "]"}], "&"}], ")"}], "[", "b", "]"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"b", ",", 
          RowBox[{"xAct`xTensor`Private`IndexName", "[", "b", "]"}]}], "]"}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"xAct`xTensor`Private`IndexName", "[", "b", "]"}],
          HoldForm], ",", 
         TagBox["b",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"b", ",", "b"}], "]"}],
        HoldForm]}], "}"}], ",", 
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["{",
          FontColor->RGBColor[0, 0, 1]], 
         RowBox[{"xAct`xTensor`Private`Index", "[", 
          RowBox[{"a", ",", "a"}], "]"}], "\<\",\"\>", 
         RowBox[{"xAct`xTensor`Private`Index", "[", 
          RowBox[{"b", ",", "b"}], "]"}], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`IndexList[
        xAct`xTensor`Private`Index[$CellContext`a, $CellContext`a], 
        xAct`xTensor`Private`Index[$CellContext`b, $CellContext`b]],
       Editable->False],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`CheckRepeated1", "[", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], 
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"a", ",", "a"}], "]"}], "\<\",\"\>", 
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"b", ",", "b"}], "]"}], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[
       xAct`xTensor`Private`Index[$CellContext`a, $CellContext`a], 
       xAct`xTensor`Private`Index[$CellContext`b, $CellContext`b]],
      Editable->False], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"First", "/@", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], 
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"a", ",", "a"}], "]"}], "\<\",\"\>", 
        RowBox[{"xAct`xTensor`Private`Index", "[", 
         RowBox[{"b", ",", "b"}], "]"}], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[
       xAct`xTensor`Private`Index[$CellContext`a, $CellContext`a], 
       xAct`xTensor`Private`Index[$CellContext`b, $CellContext`b]],
      Editable->False]}],
    HoldForm], ",", 
   TagBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["{",
        FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
       StyleBox["}",
        FontColor->RGBColor[0, 0, 1]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`IndexList[
      First[
       xAct`xTensor`Private`Index[$CellContext`a, $CellContext`a]], 
      First[
       xAct`xTensor`Private`Index[$CellContext`b, $CellContext`b]]],
     Editable->False],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"First", "[", 
       RowBox[{"xAct`xTensor`Private`Index", "[", 
        RowBox[{"a", ",", "a"}], "]"}], "]"}],
      HoldForm], ",", 
     TagBox["a",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"First", "[", 
       RowBox[{"xAct`xTensor`Private`Index", "[", 
        RowBox[{"b", ",", "b"}], "]"}], "]"}],
      HoldForm], ",", 
     TagBox["b",
      HoldForm]}], "}"}], ",", 
   TagBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["{",
        FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
       StyleBox["}",
        FontColor->RGBColor[0, 0, 1]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
     Editable->False],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"a6d1df48-0d61-4ffc-8aa8-f43958adf24d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "b", ",", "c", ",", "d", ",", "h", ",", "Polar", ",", "Cartesian",
    ",", "Q", ",", "v"}], 
  "]"}]], "Input",ExpressionUUID->"9f7357aa-4a1a-4204-b1fc-de59decf45a5"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"d1446515-33e7-4e94-b84b-a974cc839f03"],

Cell["2) CheckHomogeneity", "Text",
 FontWeight->"Bold",ExpressionUUID->"54ab7426-d533-4ba1-9f4e-aac143df5524"],

Cell["\<\
We define CheckHomogeneity as follows. Again, inhomogeneous sets of indices \
are those sets of different names of indices. In other words, a and a_ are \
indices with the same name, and therefore they do not count as different \
indices. This is useful when considering rules, where a_ can be present on \
the LHS, but not in the RHS, where we will find a, instead.\
\>", "Text",ExpressionUUID->"a5c003e7-3982-44e5-9810-9dc42e7a01f8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckHomogeneity"}]], \
"Input",ExpressionUUID->"22e4cf85-6cb3-471d-a34a-b635c5ff23cd"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672451-5338953",ExpressionUUID->"093d3f74-83cc-4449-961f-\
aefd076840e7"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"General", "::", "inhom"}], "=", 
   "\"\<Found inhomogeneous `1`: `2`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkLengthOne", "[", 
    RowBox[{"{", "x_", "}"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkLengthOne", "[", 
    RowBox[{"x", ":", 
     RowBox[{"{", 
      RowBox[{"_", ",", "__"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Validate", "::", "inhom"}], ",", "\"\<indices\>\"", ",", 
      RowBox[{"ToString", "[", "x", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckHomogeneity", "[", 
    RowBox[{"x___", ",", 
     RowBox[{"IndexList", "[", "AnyIndices", "]"}], ",", "y___"}], "]"}], ":=", 
   RowBox[{"CheckHomogeneity", "[", 
    RowBox[{"x", ",", "y"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckHomogeneity", "[", "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckHomogeneity", "[", 
    RowBox[{
     RowBox[{"IndexList", "[", "]"}], ".."}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CheckHomogeneity", "[", "lists__IndexList", "]"}], ":=", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"checkLengthOne", "@", 
      RowBox[{"Union", "@", 
       RowBox[{"Map", "[", 
        RowBox[{"TakeFrees", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"DeleteCases", "[", 
             RowBox[{"#", ",", "0"}], "]"}], "&"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{"IndexName", ",", 
             RowBox[{"{", "lists", "}"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}]}], "]"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"DeleteDuplicates", "[", 
      RowBox[{"Join", "[", "lists", "]"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"123a35b2-73d2-4739-af7d-ed09164efd66"],

Cell["\<\
There is a very important point here: the concept of \"g-indices of a sum of \
expressions\". Currently we return the (unsorted) union of all indices and \
therefore all repeated g-indices (components, directions, labels and blanks) \
appear just once. Compare the use of Join in CheckRepeated with the use of \
DeleteDuplicates in CheckHomogeneity.\
\>", "Text",ExpressionUUID->"af44dc13-3214-4dcd-80fc-14376b62c934"],

Cell["We return all indices, both patterns and not patterns:", \
"Text",ExpressionUUID->"3270f99f-7eb7-409f-8261-58188b50bfad"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"421db9d7-6970-4217-a26c-2b332a893622"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckHomogeneity", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"-", "b_"}], ",", "c", ",", 
     RowBox[{"Dir", "[", "v", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", "c", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", "AnyIndices", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e3713abb-24ea-4a4f-ab37-bfd50efc672c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a_", "\<\",\"\>", 
    RowBox[{"-", "b_"}], "\<\",\"\>", "c", "\<\",\"\>", 
    RowBox[{"Dir", "[", "v", "]"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\<\",\"\>", "a", "\<\",\"\>", 
    RowBox[{"-", "b"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Pattern[$CellContext`a, 
    Blank[]], -Pattern[$CellContext`b, 
     Blank[]], $CellContext`c, 
   xAct`xTensor`Dir[$CellContext`v], {
   1, -$CellContext`Polar}, $CellContext`a, -$CellContext`b, {
   1, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"4838f87f-4995-4a54-9923-48c14aefa709"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckHomogeneity", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", 
     RowBox[{"a_", ",", 
      RowBox[{"-", "b_"}], ",", "c"}], "]"}], ",", 
    RowBox[{"IndexList", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "b"}], ",", "c"}], "]"}], ",", 
    RowBox[{"IndexList", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "b"}], ",", "d"}], "]"}], ",", 
    RowBox[{"IndexList", "[", "AnyIndices", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"56d61c79-ce8a-4852-92d5-96f44ddce3b9"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "inhom"}], "MessageName"], ":", 
  " ", "\<\"Found inhomogeneous \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak]: \
\[NoBreak]\\!\\(\\\"{IndexList[a, -b, c], IndexList[a, -b, d]}\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"35fffaab-ff73-45af-89e2-39a57288a732"]
}, Open  ]],

Cell["Trivial case:", \
"Text",ExpressionUUID->"530d92bd-615e-4b74-b9e3-91621cd09ee9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`CheckHomogeneity", "[", 
   RowBox[{
    RowBox[{"IndexList", "[", "]"}], ",", 
    RowBox[{"IndexList", "[", "]"}], ",", 
    RowBox[{"IndexList", "[", "]"}]}], "]"}], "//", 
  "Trace"}]], "Input",ExpressionUUID->"e96e8632-72fe-4933-90d9-b3b964a68739"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"xAct`xTensor`Private`CheckHomogeneity", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[
        RowBox[{"{", "}"}],
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0, 0, 1]],
       xAct`xTensor`IndexList[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[
        RowBox[{"{", "}"}],
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0, 0, 1]],
       xAct`xTensor`IndexList[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[
        RowBox[{"{", "}"}],
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0, 0, 1]],
       xAct`xTensor`IndexList[],
       Editable->False]}], "]"}],
    HoldForm], ",", 
   TagBox[
    InterpretationBox[
     StyleBox[
      RowBox[{"{", "}"}],
      ShowAutoStyles->False,
      AutoSpacing->False,
      FontColor->RGBColor[0, 0, 1]],
     xAct`xTensor`IndexList[],
     Editable->False],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"d1954a0f-1957-4359-9b3a-0c277723af98"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "v", ",", "Polar"}], 
  "]"}]], "Input",ExpressionUUID->"acbdcd13-a03c-4406-b095-f8b962e0ccaf"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"cdcbbfa8-ac00-4afa-b903-d9fa05a2a312"],

Cell["3) CheckIndexType", "Text",
 FontWeight->"Bold",ExpressionUUID->"ba0af5ee-deed-4109-9f5a-0d03dd7edf3b"],

Cell["\<\
And now we define a function that checks the types of indices. We need to \
worry about: Index/Basis, Index/Pattern and different bases. It is defined, \
but we currently do not use it. In fact, we do not include it in the package.\
\
\>", "Text",ExpressionUUID->"5edb3e6d-350e-4cf9-9348-90e738491907"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexType"}]], \
"Input",ExpressionUUID->"8e2c6c71-d66c-4121-a392-98fb7da11939"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672453-5338953",ExpressionUUID->"d3ca5fb4-3110-45db-866f-\
6bc252c0b3f6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Type", " ", "of", " ", 
    RowBox[{"indices", ".", " ", "PINDEX"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", 
      RowBox[{"-", "i_"}], "]"}], ":=", 
     RowBox[{"IndexType", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", "_Symbol", "]"}], ":=", "\"\<Index\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", 
      RowBox[{"_Blank", "|", "_Pattern", "|", "_PatternTest"}], "]"}], ":=", 
     "\"\<Pattern\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", "_Integer", "]"}], ":=", "\"\<Integer\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", 
      RowBox[{"{", 
       RowBox[{"i_", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"\"\<Basis\>\"", "<>", 
      RowBox[{"IndexType", "[", "i", "]"}], "<>", "\"\<_\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"UpIndex", "@", "basis"}], "]"}]}]}], ";", " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"IndexType", "[", 
       RowBox[{
        RowBox[{"basis_Symbol", "?", "BasisQ"}], "[", "i_", "]"}], "]"}], ":=", 
      RowBox[{"\"\<Basis\>\"", "<>", 
       RowBox[{"IndexType", "[", "i", "]"}], "<>", "\"\<_\>\"", "<>", 
       RowBox[{"ToString", "[", "basis", "]"}]}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", 
      RowBox[{
       RowBox[{"imod_", "?", "IModQ"}], "[", "i_", "]"}], "]"}], ":=", 
     RowBox[{"\"\<IMod\>\"", "<>", 
      RowBox[{"IndexType", "[", "i", "]"}], "<>", "\"\<_\>\"", "<>", 
      RowBox[{"ToString", "[", "imod", "]"}]}]}], ";", " ", 
    RowBox[{"(*", " ", "IMOD", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexType", "[", "_", "]"}], ":=", "\"\<Other\>\""}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"9e7a215b-3f7d-4213-b8cf-acece6fb4a71"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckIndexType"}]], \
"Input",ExpressionUUID->"5060a8e3-176d-4612-bdd2-c33209c6e0df"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672454-5338953",ExpressionUUID->"08afeb6b-69b2-40cc-9d9d-\
9e3f7fcd3af4"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Validate", "::", "type"}], "=", 
   "\"\<Found index named `1` with incompatible types `2` and `3`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"check2", "[", 
   RowBox[{"{", 
    RowBox[{"___", ",", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "type1_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "type2_"}], "}"}], ",", "___"}], "}"}], "]"}], ":=", 
  
  RowBox[{"Throw", "@", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"Validate", "::", "type"}], ",", "x", ",", "type1", ",", 
     "type2"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CheckIndexType", "[", 
   RowBox[{"IndexList", "[", "]"}], "]"}], ":=", 
  RowBox[{"IndexList", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CheckIndexType", "[", "list_IndexList", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"check2", "@", 
     RowBox[{"Union", "[", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"IndexName", "[", "#", "]"}], ",", 
            RowBox[{"IndexType", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
         RowBox[{"UpIndex", "/@", "list"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"_Symbol", ",", "_"}], "}"}]}], "]"}], "]"}]}], ";", 
    "list"}], 
   ")"}]}]}], "Input",ExpressionUUID->"c3b25a27-b165-4fb9-a169-5696c92d6027"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5c5a1fec-36fa-42f5-82c5-c2c5e4296c5e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`CheckIndexType", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"a_", ",", 
    RowBox[{"{", 
     RowBox[{"b_", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"78eca189-1984-4fdc-a6cf-06497469c2b2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a_", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"b_", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Pattern[$CellContext`a, 
    Blank[]], {
    Pattern[$CellContext`b, 
     Blank[]], $CellContext`Polar}, {1, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"2d9bb160-bba8-4cea-9e82-cb037dcb8226"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckIndexType", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", "_", ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "Polar"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"f2884dd4-a68c-4e44-9621-6f93bd9d746f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "type"}], "MessageName"], ":", 
  " ", "\<\"Found index named \[NoBreak]\\!\\(a\\)\[NoBreak] with \
incompatible types \[NoBreak]\\!\\(\\\"Index\\\"\\)\[NoBreak] and \
\[NoBreak]\\!\\(\\\"Pattern\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a41c48ff-f15b-4977-9838-7a8e7fcd2eb8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckIndexType", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", "_"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"ee21b3ea-b90d-4c0c-90db-49489206c553"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "type"}], "MessageName"], ":", 
  " ", "\<\"Found index named \[NoBreak]\\!\\(a\\)\[NoBreak] with \
incompatible types \[NoBreak]\\!\\(\\\"BasisIndex_Polar\\\"\\)\[NoBreak] and \
\[NoBreak]\\!\\(\\\"Index\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"44b44f7e-3b2b-44ae-be8b-c4420f5f8e7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckIndexType", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", "_", ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "Polar"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"88c977a4-fa96-4823-878f-88396912d7ba"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "type"}], "MessageName"], ":", 
  " ", "\<\"Found index named \[NoBreak]\\!\\(a\\)\[NoBreak] with \
incompatible types \[NoBreak]\\!\\(\\\"BasisIndex_Polar\\\"\\)\[NoBreak] and \
\[NoBreak]\\!\\(\\\"BasisPattern_Polar\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"05b50129-fa86-43a1-adb9-83a8006aae3d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`CheckIndexType", "[", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "Cartesian"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", "_", ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "Polar"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"9ffe57f4-2034-4256-969b-af9f20e15d9f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "type"}], "MessageName"], ":", 
  " ", "\<\"Found index named \[NoBreak]\\!\\(a\\)\[NoBreak] with \
incompatible types \[NoBreak]\\!\\(\\\"BasisIndex_Cartesian\\\"\\)\[NoBreak] \
and \[NoBreak]\\!\\(\\\"BasisIndex_Polar\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"a5dd66ad-2691-4d5e-8d55-277e603acc36"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "Cartesian", ",", "Polar"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"43d17557-ee51-4e75-bfb9-fe8c9d11cf6a"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.2. FindIndices", \
"Subsubsection",ExpressionUUID->"12fa00e3-3a00-4d73-9061-a81c2652aa4c"],

Cell["\<\
Basic function. Comments:
\t1. We do not check that the indices have been already registered in \
$AbstractIndices; they are just at the expected positions and have one of  \
the expected types for a g-index.
\t2. The function is threaded over known heads (Plus, Times, Module, Rule, \
RuleDelayed, inertheads, etc.). It throws an error in other cases.
\t3. FindIndices always returns a (possibly empty) list of g-indices.

In version 0.7 this function was private, but now it is public. Therefore we \
separate the user driver (one argument) from the internal function \
FindIndices1 (two arguments).\
\>", "Text",ExpressionUUID->"0b06da24-83c4-43bd-b44f-f34ce25238c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FindIndices"}]], \
"Input",ExpressionUUID->"21bf8ccb-724b-4fed-9d91-18bd109a653f"],

Cell[BoxData[
 StyleBox["\<\"FindIndices[expr] returns an IndexList with the (order kept) \
union of all-gindices of expr. Indices in directional arguments, Scalar \
expressions or scalar-functions are not found. FindIndices has attribute \
HoldFirst, and hence requires very often the use of Evaluate.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672457-5338953",ExpressionUUID->"aded3d5f-c3ab-479e-ad74-\
271a6e191450"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FindIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FindIndices1", ",", "HoldFirst"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c8dd944e-faf0-4b5a-938a-051d723fcbcb"],

Cell["\<\
Atomic objects (note that this rule includes the constant-symbols and \
parameters):\
\>", "Text",ExpressionUUID->"020dcf6b-b978-4a49-9821-04a85b41d220"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "0", "]"}], ":=", 
   RowBox[{"IndexList", "[", "AnyIndices", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{
    "_Symbol", "|", "_String", "|", "_Integer", "|", "_Rational", "|", 
     "_Real", "|", "_Complex"}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"61d9317b-f0da-4650-8c1b-0a86ba3a8327"],

Cell["Simple case:", \
"Text",ExpressionUUID->"eb95d8c1-738c-4d61-9629-a32fa8e0db96"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"_", "[", "]"}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"67a2d114-d1c6-44cb-979b-fb8f2bc32080"],

Cell["\<\
Homogeneity types. There are four possibilities: Times (indices cannot be \
repeated), Plus (homogeneous free indices), None (no relation at all) or an \
integer number (ignore all indices but those of element n):\
\>", "Text",ExpressionUUID->"a0658952-a8c1-4fad-b4d7-c81aea27ea45"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FindIndices", "[", "expr_Times", "]"}], ":=", 
    RowBox[{"FindIndices1", "[", 
     RowBox[{"expr", ",", "Times"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "These", " ", "two", " ", "should", " ", "not", " ", "be", " ", 
     "needed"}], ",", " ", 
    RowBox[{
    "but", " ", "they", " ", "can", " ", "correct", " ", "evaluation", " ", 
     "leaks", " ", "in", " ", "canonicalization"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"expr", ":", 
     RowBox[{
      RowBox[{"VerbatimProduct", "[", "_", "]"}], "[", "___", "]"}]}], "]"}], 
   ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "Times"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"expr", ":", 
     RowBox[{
      RowBox[{"CommutingObjects", "[", "_", "]"}], "[", "___", "]"}]}], "]"}],
    ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "Times"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"76d2616e-d084-4ed9-a24d-eb0ca245023a"],

Cell["\<\
Note that the LHS of rules (both Rule and RuleDelayed) is evaluated, but here \
we do not do it. It saves some time.\
\>", "Text",ExpressionUUID->"3a906ce5-4dbe-49df-82c2-b740c7d7e2a0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "Plus"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_List", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "Plus"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_Equal", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "Plus"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"lhs", ",", 
       RowBox[{"Evaluate", "[", "rhs", "]"}]}], "]"}], ",", "Plus"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"RuleDelayed", "[", 
     RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs", ",", "rhs"}], "]"}], ",", "Plus"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Set", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"Set", "[", 
      RowBox[{"lhs", ",", "rhs"}], "]"}], ",", "Plus"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"SetDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"SetDelayed", "[", 
      RowBox[{"lhs", ",", "rhs"}], "]"}], ",", "Plus"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"01c2337c-9473-42f3-bf0b-13c5985ba946"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_Module", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_Monomial", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_Condition", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "1"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cbccf752-39bd-4e9c-8f36-2ed94bf62220"],

Cell["\<\
Series must have scalar origin and variable, but the coefficients can be \
tensors, all with the same indices as in a sum. A lonely O[x]^n term is not \
assumed to be a scalar, but returns AnyIndices.\
\>", "Text",ExpressionUUID->"98239a5a-8fd4-457f-836c-090bf3135945"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"{", 
        RowBox[{"RepeatedNull", "[", "0", "]"}], "}"}], ",", "__"}], "]"}], 
     "]"}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "AnyIndices", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", "expr_SeriesData", "]"}], ":=", 
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "3"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"815bc31f-7cbd-469c-a36d-3d3e759604e1"],

Cell["Here we define the actions on those four cases", \
"Text",ExpressionUUID->"ecda69bc-58cc-4de0-96d7-da1e1fd71a32"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"_", "[", "elements__", "]"}]}], ",", "Times"}], "]"}], ":=", 
   RowBox[{"CheckRepeated", "@@", 
    RowBox[{"(", 
     RowBox[{"FindIndices", "/@", 
      RowBox[{"Hold", "[", "elements", "]"}]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"_", "[", "elements__", "]"}]}], ",", "Plus"}], "]"}], ":=", 
   RowBox[{"CheckHomogeneity", "@@", 
    RowBox[{"(", 
     RowBox[{"FindIndices", "/@", 
      RowBox[{"Hold", "[", "elements", "]"}]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices1", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"_", "[", "elements__", "]"}]}], ",", "None"}], "]"}], ":=", 
   RowBox[{"Join", "@@", 
    RowBox[{"(", 
     RowBox[{"FindIndices", "/@", 
      RowBox[{"Hold", "[", "elements", "]"}]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr_", ",", "n_Integer"}], "]"}], ":=", 
   RowBox[{"FindIndices", "@@", 
    RowBox[{"Extract", "[", 
     RowBox[{
      RowBox[{"Unevaluated", "[", "expr", "]"}], ",", "n", ",", "xHold"}], 
     "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d060d021-81b1-49a7-b843-8aa1df082eef"],

Cell["\<\
Note that in the last definition the head xHold is eliminated (actually \
replaced) by FindIndices.\
\>", "Text",ExpressionUUID->"a4941682-4115-4bf4-a7f2-007f907ef2a7"],

Cell["\<\
Complex conjugation (in case some expression is not evaluated). This is a \
dangerous definition because, even though it is perfectly correct from the \
mathematical point of view, it is not true from the syntactic point of view: \
the returned indices are not really present in the expression. Note that it \
is an exception with respect to the behaviour of other inert heads. We will \
find the same problem below with IsIndexOf.\
\>", "Text",ExpressionUUID->"2b115734-030d-40f1-bc44-b6a30618c868"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"Dagger", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"DaggerIndex", "/@", 
    RowBox[{"FindIndices", "[", "expr", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3f36af4f-9301-4743-ae7b-72f91e4a13ac"],

Cell["Basic objects:", \
"Text",ExpressionUUID->"67d2e2ff-6fee-4cf8-b4b9-2fd67346d5ac"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDIndices", "[", 
    RowBox[{
     RowBox[{"_", "?", "CovDQ"}], "[", "inds__", "]"}], "]"}], ":=", 
   RowBox[{"Sequence", "[", "inds", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDIndices", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"FindIndices", "::", "invalid"}], ",", "x", ",", 
      "\"\<derivative\>\""}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f4931384-5509-4849-966e-6254466c41db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Basic", " ", "objects"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{"_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
     RowBox[{"CheckRepeated", "[", 
      RowBox[{"IndexList", "[", "inds", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", 
       "]"}], "]"}], ":=", 
     RowBox[{"CheckRepeated", "[", 
      RowBox[{
       RowBox[{"FindIndices", "[", "expr", "]"}], ",", 
       RowBox[{"IndexList", "[", "inds", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{"CovD", "[", 
       RowBox[{"expr_", ",", "ders__"}], "]"}], "]"}], ":=", 
     RowBox[{"CheckRepeated", "[", 
      RowBox[{
       RowBox[{"FindIndices", "[", "expr", "]"}], ",", 
       RowBox[{"CovDIndices", "/@", 
        RowBox[{"IndexList", "[", "ders", "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{"ParamD", "[", "__", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"FindIndices", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{"OverDot", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"FindIndices", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "_", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"FindIndices", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{"_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
     RowBox[{"DeleteDuplicates", "[", 
      RowBox[{"Join", "@@", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"FindIndices", "[", "expr", "]"}], "}"}], ",", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"{", "z", "}"}], ",", "_IndexList"}], "]"}]}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"_", "?", "ProductQ"}], "[", "___", "]"}]}], "]"}], ":=", 
     RowBox[{"FindIndices1", "[", 
      RowBox[{"expr", ",", "Times"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Scalar", " ", "shields", " ", 
     RowBox[{"indices", "!"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", "_Scalar", "]"}], ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "___", "]"}], "]"}], ":=", 
     
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindIndices", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Derivative", "[", "__Integer", "]"}], "[", 
        RowBox[{"_", "?", "ScalarFunctionQ"}], "]"}], "[", "__", "]"}], "]"}],
      ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f93f9a2b-36c1-4490-8ea8-710b9842595b"],

Cell["\<\
Indices of patterned objects (currently only tensors and connections):\
\>", "Text",ExpressionUUID->"2cfa9697-e468-4db4-b5b9-db3996f51bd2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"pattern_PatternTest", "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CheckRepeated", "[", 
     RowBox[{"IndexList", "[", "inds", "]"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Last", "[", "pattern", "]"}], "===", "xTensorQ"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{
     RowBox[{"pattern_PatternTest", "[", "inds__", "]"}], "[", "expr_", "]"}],
     "]"}], ":=", 
   RowBox[{
    RowBox[{"CheckRepeated", "[", 
     RowBox[{
      RowBox[{"FindIndices", "[", "expr", "]"}], ",", 
      RowBox[{"IndexList", "[", "inds", "]"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Last", "[", "pattern", "]"}], "===", "CovDQ"}]}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"24c2869a-a13a-4a93-873d-1fb69a39dc42"],

Cell["\<\
There are additional heads that typically form part of the input:\
\>", "Text",ExpressionUUID->"55cb9711-1214-4851-b271-d881686dbbd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"expr", ":", 
     RowBox[{"(", 
      RowBox[{"_HoldPattern", "|", "_ReplaceDummies"}], ")"}]}], "]"}], ":=", 
   
   RowBox[{"FindIndices1", "[", 
    RowBox[{"expr", ",", "1"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8f74570b-7b9c-45a3-9635-f28f93477329"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Again", ",", " ", 
    RowBox[{"this", " ", "should", " ", "not", " ", "be", " ", "needed"}], 
    ",", " ", 
    RowBox[{
    "but", " ", "it", " ", "may", " ", "fix", " ", "evaluation", " ", 
     "leaks"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FindIndices", "[", 
     RowBox[{"Object", "[", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"{", 
        RowBox[{"allinds_", ",", "__"}], "}"}]}], "]"}], "]"}], ":=", 
    "allinds"}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"36dfce71-9ffa-4925-b4db-b4d0cae2bf32"],

Cell["\<\
Detection of other heads. The global variable $FindIndicesAcceptedHeads is \
public, but not protected.\
\>", "Text",ExpressionUUID->"d4a8204e-86ea-4934-81ff-1204435c33d7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$FindIndicesAcceptedHeads", "=", 
   RowBox[{"{", 
    RowBox[{"Hold", ",", "HoldForm"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindIndices", "[", 
    RowBox[{"expr", ":", 
     RowBox[{"head_", "[", "__", "]"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{"$FindIndicesAcceptedHeads", ",", "head"}], "]"}], ",", 
     RowBox[{"FindIndices1", "[", 
      RowBox[{"expr", ",", "None"}], "]"}], ",", 
     RowBox[{"IndexList", "[", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"83f825fd-ed84-4c45-85fb-1aa373864b94"],

Cell["Final definitions:", \
"Text",ExpressionUUID->"e11837eb-ecef-4687-9a12-7bdd46a073d7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FindIndices", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FindIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2cb9678b-2b59-4c7e-b031-462732cc5efb"],

Cell["\<\
This function could be generalized in many ways, but I prefer it to be as \
simple as possible.\
\>", "Text",ExpressionUUID->"600d4b6f-5e4f-4f28-bba1-c40753972e26"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.3. FindFreeIndices, FindDummyIndices, FindBlockedIndices", \
"Subsubsection",ExpressionUUID->"4a3fd329-09d6-45f4-968b-75d3c90eb74b"],

Cell["Three simple extensions of FindIndices:", \
"Text",ExpressionUUID->"b8acd144-9662-4027-8e9e-00f4d9af059d"],

Cell["1) FindFreeIndices:", \
"Text",ExpressionUUID->"b852dd89-afb3-44d5-8cff-2a0785c7fc83"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FindFreeIndices"}]], \
"Input",ExpressionUUID->"7d891710-f6ed-4b3f-9f32-8f6f1308c3b4"],

Cell[BoxData[
 StyleBox["\<\"FindFreeIndices[expr] gives an IndexList with the (order not \
kept) free indices of expr, throwing an error if they are not homogeneous in \
all terms of expr. FindFreeIndices[expr, selector] uses SelectIndices on \
FindFreeIndices[expr] with the given selector. FindFreeIndices has attribute \
HoldFirst, and hence requires very often the use of Evaluate.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672458-5338953",ExpressionUUID->"3e388111-4756-439d-9a4d-\
2731169d8742"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FindFreeIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindFreeIndices", "[", 
    RowBox[{"expr_", ",", "selector_"}], "]"}], ":=", 
   RowBox[{"SelectIndices", "[", 
    RowBox[{
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "selector"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindFreeIndices", "[", "expr_", "]"}], ":=", 
   RowBox[{"TakeFrees", "@", 
    RowBox[{"FindIndices", "[", "expr", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FindFreeIndices", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FindFreeIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8b5bd531-6f69-4259-a8b3-824ae2a66e00"],

Cell["\<\
2) FindDummyIndices. We assume that we already now that there are no repeated \
or inhomogeneous indices. Therefore both members of each pair of dummies must \
be on the same object:\
\>", "Text",ExpressionUUID->"3b020b8a-13a8-4a5a-adc1-0d73c78aaac7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FindDummyIndices"}]], \
"Input",ExpressionUUID->"9b720b8c-649a-4850-859d-c7dd57485ebe"],

Cell[BoxData[
 StyleBox["\<\"FindDummyIndices[expr] gives an IndexList with the (up-) \
indices wich are contracted in expr. FindDummyIndices[expr, selector] uses \
SelectIndices on FindDummyIndices[expr] with the given selector. \
FindDummyIndices has attribute HoldFirst, and hence requires very often the \
use of Evaluate.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672460-5338953",ExpressionUUID->"0d51b6f5-82f3-4bcb-a598-\
bf2327af85e5"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FindDummyIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindDummyIndices", "[", 
    RowBox[{"expr_", ",", "selector_"}], "]"}], ":=", 
   RowBox[{"SelectIndices", "[", 
    RowBox[{
     RowBox[{"FindDummyIndices", "[", "expr", "]"}], ",", "selector"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindDummyIndices", "[", "expr_", "]"}], ":=", 
   RowBox[{"TakeUp", "@", 
    RowBox[{"TakeOrderedEPairs", "@", 
     RowBox[{"FindIndices", "[", "expr", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FindDummyIndices", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FindDummyIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cc78487d-c329-47a1-bb4a-7df6675194d4"],

Cell["3) FindBlockedIndices", \
"Text",ExpressionUUID->"34ceaeda-0f24-4954-93c6-c0075e9856fd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FindBlockedIndices"}]], \
"Input",ExpressionUUID->"18f54057-11d7-47ce-8a04-c03c5aba508f"],

Cell[BoxData[
 StyleBox["\<\"FindBlockedIndices[expr] gives an IndexList with the (order \
not kept) blocked indices of expr. FindBlockedIndices[expr, selector] uses \
SelectIndices on FindBlockedIndices[expr] with the given selector. \
FindBlockedIndices has attribute HoldFirst, and hence requires very often the \
use of Evaluate.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672461-5338953",ExpressionUUID->"e029c72c-b924-4e59-b31e-\
268e21a35090"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FindBlockedIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindBlockedIndices", "[", 
    RowBox[{"expr_", ",", "selector_"}], "]"}], ":=", 
   RowBox[{"SelectIndices", "[", 
    RowBox[{
     RowBox[{"FindBlockedIndices", "[", "expr", "]"}], ",", "selector"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindBlockedIndices", "[", "expr_", "]"}], ":=", 
   RowBox[{"TakeBlocked", "@", 
    RowBox[{"FindIndices", "[", "expr", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FindBlockedIndices", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FindBlockedIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"247ede87-92c5-426a-8b71-d29245f7d534"],

Cell["\<\
4) FindFreeAndDummyIndices. We assume that we already now that there are no \
repeated or inhomogeneous indices. Therefore both members of each pair of \
dummies must be on the same object.\
\>", "Text",ExpressionUUID->"571c60dc-e178-4b8f-96f3-63f8e1f9f9e8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FindFreeAndDummyIndices"}]], \
"Input",ExpressionUUID->"c7e68b26-0e9f-45a9-a9ce-800814e65de7"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`FindFreeAndDummyIndices[expr] gives a list \
containing FindFreeIndices[expr] and FindDummyIndices[expr] respectively. See \
notes for those functions.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672462-5338953",ExpressionUUID->"ecc36698-e0f7-445f-8932-\
aab354ccb9c5"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FindFreeAndDummyIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindFreeAndDummyIndices", "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"TakeFrees", "[", "#", "]"}], ",", 
       RowBox[{"TakeUp", "@", 
        RowBox[{"TakeOrderedEPairs", "[", "#", "]"}]}]}], "}"}], "&"}], "@", 
    RowBox[{"FindIndices", "[", "expr", "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f68f08c6-f698-4b2d-b8f8-7e8722af8c72"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.4. IsIndexOf", \
"Subsubsection",ExpressionUUID->"41d5910f-44ec-4504-87ef-11698e394ca6"],

Cell["\<\
This function is mostly used to find out when contraction of delta, Basis, \
metric or projector tensors must be done. There is a third argument which \
specifies the tensor that we are actually trying to contract, to be checked \
with ContractThroughQ against inert-heads (perhaps against other structures \
in the future). QUESTION: The contraction through derivatives works in a \
different way. Is it possible to use the same ideas to treat both cases?

Currently IsIndexOf is used by:
\t- delta contraction
\t- metric contraction
\t- projector contraction
\t- MakeOrthogonalDerivative
\t- MakeProjectedDerivative
\t- ObjectWithIndices

Note the definition on scalar functions: the indices (dummies) of the tensors \
in a scalar function are shielded.

It is not clear if the definition on Dagger expressions is fully general. \
QUESTION.\
\>", "Text",ExpressionUUID->"04d9971b-ffd3-4219-aa6c-6ce25c4e2079"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IsIndexOf"}]], \
"Input",ExpressionUUID->"92f1a2da-89f4-46d3-a6df-91387daa9389"],

Cell[BoxData[
 StyleBox["\<\"IsIndexOf[object, index] gives True if (Verbatim) index is one \
of the indices of object, and False otherwise. IsIndexOf[object, index, \
tensor] gives IndexOf[object, index] unless object is an inert head \
expression with head IH; in that case there is the further check \
ContractThroughQ[IH, tensor].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672464-5338953",ExpressionUUID->"adedea7b-5470-4668-88e4-\
42ade6d7e1f3"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", 
    RowBox[{"IsIndexOf", ",", "HoldFirst"}], "]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "In", " ", "general", " ", "we", " ", "are", " ", "not", " ", "trying", 
    " ", "to", " ", "contract", " ", 
    RowBox[{"anything", ":", " ", 
     RowBox[{"use", " ", "delta"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"expr", ",", "index", ",", "delta"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Compound", " ", 
     RowBox[{"expressions", ".", " ", "Or"}], " ", "in", " ", "Times", " ", 
     RowBox[{"(", 
      RowBox[{"any", " ", "index"}], ")"}]}], ",", " ", 
    RowBox[{"And", " ", "in", " ", "Plus", " ", 
     RowBox[{"(", 
      RowBox[{"only", " ", "free", " ", "indices", " ", "ensured"}], 
      ")"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"(", 
       RowBox[{"_Times", "|", 
        RowBox[{
         RowBox[{"CommutingObjects", "[", "_", "]"}], "[", "___", "]"}], "|", 
        
        RowBox[{
         RowBox[{"VerbatimProduct", "[", "_", "]"}], "[", "___", "]"}], "|", 
        RowBox[{
         RowBox[{"_", "?", "ProductQ"}], "[", "___", "]"}]}], ")"}]}], ",", 
     "index_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Or", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"IsIndexOf", "[", 
        RowBox[{"#", ",", "index", ",", "f"}], "]"}], "&"}], "/@", 
      RowBox[{"Hold", "@@", 
       RowBox[{"Unevaluated", "[", "expr", "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "index_", ",", "f_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"(", 
       RowBox[{"_Plus", "|", "_List"}], ")"}]}], ",", "index_", ",", "f_"}], 
    "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"IsIndexOf", "[", 
        RowBox[{"#", ",", "index", ",", "f"}], "]"}], "&"}], "/@", 
      RowBox[{"Hold", "@@", 
       RowBox[{"Unevaluated", "[", "expr", "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{"SeriesData", "[", 
        RowBox[{"_", ",", "_", ",", "coeffs_", ",", "__"}], "]"}], "]"}], ",",
       "index_", ",", "f_"}], "]"}], ":=", 
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"coeffs", ",", "index", ",", "f"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Dagger", ":", " ", 
    RowBox[{"temptative", " ", "definition"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{
      RowBox[{"Dagger", "[", "expr_", "]"}], ",", "index_", ",", "f_"}], 
     "]"}], ":=", 
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"DaggerIndex", "[", "index", "]"}], ",", "f"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Tensors", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", "index_", 
      ",", "f_"}], "]"}], ":=", 
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"IndexList", "[", "inds", "]"}], ",", "index"}], "]"}]}], ";"}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Inert", " ", "heads"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{"list_IndexList", ",", "index_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"MemberQ", "[", 
    RowBox[{"list", ",", "index"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"list", ":", 
      RowBox[{"{", "___IndexList", "}"}]}], ",", "index_", ",", "f_"}], "]"}],
    ":=", 
   RowBox[{"Or", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"IsIndexOf", "[", 
        RowBox[{"#", ",", "index", ",", "f"}], "]"}], "&"}], "/@", "list"}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"head_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], ",", "index_", ",", "f_"}], 
     "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ContractThroughQ", "[", 
       RowBox[{"head", ",", "f"}], "]"}], ",", 
      RowBox[{
       RowBox[{"IsIndexOf", "[", 
        RowBox[{"expr", ",", "index", ",", "f"}], "]"}], "||", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cases", "=", 
           RowBox[{"Cases", "[", 
            RowBox[{
             RowBox[{"{", "z", "}"}], ",", "_IndexList"}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"IsIndexOf", "[", 
          RowBox[{"cases", ",", "index", ",", "f"}], "]"}]}], "]"}]}], ",", 
      "False"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Derivatives", ":", " ", 
    RowBox[{
    "no", " ", "check", " ", "of", " ", "compatibility", " ", "of", " ", 
     "derivative", " ", "and", " ", "tensor", " ", "f"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", "]"}],
      ",", "index_", ",", "f_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"IndexList", "[", "inds", "]"}], ",", "index"}], "]"}], "||", 
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"expr", ",", "index", ",", "f"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", "ders__"}], "]"}], ",", "index_", ",", "f_"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"CovDIndices", "/@", 
       RowBox[{"IndexList", "[", "ders", "]"}]}], ",", "index"}], "]"}], "||", 
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"expr", ",", "index", ",", "f"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ParamD", "[", "__", "]"}], "[", "expr_", "]"}], ",", "index_", 
     ",", "f_"}], "]"}], ":=", 
   RowBox[{"IsIndexOf", "[", 
    RowBox[{"expr", ",", "index", ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"OverDot", "[", "expr_", "]"}], ",", "index_", ",", "f_"}], 
    "]"}], ":=", 
   RowBox[{"IsIndexOf", "[", 
    RowBox[{"expr", ",", "index", ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"LieD", "[", "_", "]"}], "[", "expr_", "]"}], ",", "index_", 
      ",", "f_"}], "]"}], ":=", 
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"expr", ",", "index", ",", "f"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Scalar", " ", 
    RowBox[{"structures", ":", " ", "shield"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "args__", "]"}], ",", 
     "index_", ",", "f_"}], "]"}], ":=", "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Derivative", "[", "__Integer", "]"}], "[", 
       RowBox[{"_", "?", "ScalarFunctionQ"}], "]"}], "[", "args__", "]"}], 
     ",", "index_", ",", "f_"}], "]"}], ":=", "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"_Scalar", ",", "index_", ",", "f_"}], "]"}], ":=", "False"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Atoms", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{"_Symbol", ",", "index_", ",", "f_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{
     RowBox[{"_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
     ",", "index_", ",", "f_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsIndexOf", "[", 
     RowBox[{"_String", ",", "index_", ",", "f_"}], "]"}], ":=", "False"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Other", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IsIndexOf", "[", 
    RowBox[{"expr_", ",", "index_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"IsIndexOf", "::", "nouse"}], ",", "IsIndexOf", ",", "expr"}], 
      "]"}], ";", 
     RowBox[{"ERROR", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IsIndexOf", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IsIndexOf", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e57861df-db62-413f-bd63-3d9ec8c2c5ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.5. Examples", \
"Subsubsection",ExpressionUUID->"3280152c-09f3-4e6c-a0f0-b56e01cbd7f2"],

Cell["Examples:", \
"Text",ExpressionUUID->"518e6c65-2f14-49ac-bf11-7a0855d08661"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"60b2fcba-06ed-47b2-bc39-18548f8bf433"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", "1", 
  "]"}]], "Input",ExpressionUUID->"41fe16c1-3473-4687-8d64-4c9c945de279"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"e9712318-a6e5-4efc-8d01-cba08b6f4c9a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "1"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"a4a48a1a-4724-45b8-a2e4-a72b4e709a1b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"94e2c835-f749-4c3d-9b18-315492622ec9"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "T", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "v", "]"}], "^=", "True"}], 
  ";"}]}], "Input",ExpressionUUID->"fafc3293-12bf-4bd7-8840-6aa5236f9312"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a_", ",", 
    RowBox[{"-", "a_"}], ",", "b_"}], "]"}], ":=", 
  RowBox[{
  "v", "[", "b", 
   "]"}]}]], "Input",ExpressionUUID->"be9e8c9c-ad24-4264-a167-c7265f567540"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "a"}], ",", "b"}], 
  "]"}]], "Input",ExpressionUUID->"643eb6e9-fed1-46ad-9809-79ba7394a74c"],

Cell[BoxData[
 RowBox[{"v", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"6132735d-09bc-4f34-aca3-c1b7983daab7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"T", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}], ",", "b"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"f1b045c1-1b36-4ff5-9e2d-c11d1bc9c3ff"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", 
    RowBox[{"-", "a"}], "\<\",\"\>", "b", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, -$CellContext`a, $CellContext`b],
  Editable->
   False]], "Output",ExpressionUUID->"0e75d490-1831-4a05-a9de-f1e25c33de48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", "0", 
  "]"}]], "Input",ExpressionUUID->"28c8805d-8d6b-426f-95a5-c8c1d5f9d56a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "AnyIndices", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[xAct`xTensor`AnyIndices],
  Editable->
   False]], "Output",ExpressionUUID->"7a1ca56b-f764-474c-8bc6-793e56274827"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"a", ",", "b_", ",", "c", ",", 
       RowBox[{"{", 
        RowBox[{"d", ",", "Polar"}], "}"}], ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"v", "[", "a", "]"}], "]"}]}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "c"}], "]"}]}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"080dc55a-d1f4-4452-8fe3-f561309d0ed7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b_", "\<\",\"\>", 
    "c", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"d", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "a", "]"}], "]"}], "\<\",\"\>", 
    RowBox[{"-", "c"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, 
   Pattern[$CellContext`b, 
    Blank[]], $CellContext`c, {$CellContext`d, $CellContext`Polar}, 
   xAct`xTensor`Dir[
    $CellContext`v[$CellContext`a]], -$CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"8d61304a-9a3b-422d-ada9-f1f76f26450d"]
}, Open  ]],

Cell["Complaint on the type of indices:", \
"Text",ExpressionUUID->"72532773-1d02-42f9-97f0-6389c1f81f5b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"FindIndices", "[", 
   RowBox[{"T", "[", 
    RowBox[{"_", ",", "a_", ",", "b__", ",", "c___", ",", 
     RowBox[{"a_", "/;", "Q"}], ",", "#", ",", "##"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"004277fb-62e1-472e-8c97-9b359c226268"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"a\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"dd91a773-c46e-4cf9-95cd-17e76b6d3636"]
}, Open  ]],

Cell["Homogeneity is always checked:", \
"Text",ExpressionUUID->"2cd2dd3f-d4eb-4bd4-8fc3-d024a39ad801"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"FindIndices", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a_", ",", "_"}], "]"}], "+", 
    RowBox[{"v", "[", "_", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"22a380a7-eb62-4a0d-bb72-635d707dfc06"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "inhom"}], "MessageName"], ":", 
  " ", "\<\"Found inhomogeneous \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak]: \
\[NoBreak]\\!\\(\\\"{IndexList[], IndexList[a]}\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"1f87c098-9759-4667-a20f-de259e37e07d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"_", ",", "#"}], "]"}], "+", 
   RowBox[{"v", "[", 
    RowBox[{"#", ",", "_"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"f20b310b-82f3-411d-9139-66599a33e476"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "_", "\<\",\"\>", "#1", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Blank[], #],
  Editable->
   False]], "Output",ExpressionUUID->"7699d293-289e-4c9d-ab73-31b70a93cce1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefInertHead", "[", "test", 
  "]"}]], "Input",ExpressionUUID->"de41792e-8a86-442d-b9d6-426621b74e6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefInertHead", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"inert head \"\>", "\[InvisibleSpace]", "test", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefInertHead, ": Defining ", 
   "inert head ", $CellContext`test, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4bf3e4b9-eae7-4a67-a5d9-3fc89ff09c66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"test", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"b", ",", "a", ",", "c", ",", 
     RowBox[{"-", "d"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", "e", "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"c", ",", "b", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"9ece29db-f48c-4ca3-a881-8833ebad2bc5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"test", "[", 
    RowBox[{"T", "[", 
     RowBox[{"b", ",", "a", ",", "c", ",", 
      RowBox[{"-", "d"}]}], "]"}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`test[
   $CellContext`T[$CellContext`b, $CellContext`a, $CellContext`c, \
-$CellContext`d], 
   xAct`xTensor`IndexList[$CellContext`e], 
   xAct`xTensor`IndexList[$CellContext`c, $CellContext`b, $CellContext`d]],
  Editable->
   False]], "Output",ExpressionUUID->"de8bffcc-616d-485e-8aa6-eb4f666daa56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Evaluate", "[", "%", "]"}], 
  "]"}]], "Input",ExpressionUUID->"d2a0489b-5d59-4793-a837-0b306f44ecd1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "b", "\<\",\"\>", "a", "\<\",\"\>", 
    "c", "\<\",\"\>", 
    RowBox[{"-", "d"}], "\<\",\"\>", "e", "\<\",\"\>", "d", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`b, $CellContext`a, $CellContext`c, \
-$CellContext`d, $CellContext`e, $CellContext`d],
  Editable->
   False]], "Output",ExpressionUUID->"5992f17e-67e5-406d-af9b-3e263663a80e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefInertHead", "[", "test", 
  "]"}]], "Input",ExpressionUUID->"b359cd1b-1542-4f8b-8e68-477ba2263e95"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefInertHead", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"inert head\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "test"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefInertHead, ": Undefined ", "inert head", 
   " ", $CellContext`test],
  Editable->
   False]], "Print",ExpressionUUID->"fd8ecfd1-5991-4117-9857-2a14160d42bb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}], "x"}], "+", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b"}], "]"}], 
   RowBox[{"x", "^", "2"}]}], "+", 
  RowBox[{
   RowBox[{"O", "[", "x", "]"}], "^", 
   "3"}]}]], "Input",ExpressionUUID->"0209770e-7120-43bf-95aa-5d3b3d4b776f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], " ", "x"}], "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], " ", 
    SuperscriptBox["x", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {
    $CellContext`T[$CellContext`a, $CellContext`b], 
    $CellContext`T[$CellContext`a, $CellContext`b]}, 1, 3, 1],
  Editable->
   False]], "Output",ExpressionUUID->"f3a62c8a-5929-4d76-8b60-846b0c8ddb50"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Evaluate", "[", "%", "]"}], 
  "]"}]], "Input",ExpressionUUID->"7d368d8b-6cb3-450d-9acb-5b28948a7701"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b],
  Editable->
   False]], "Output",ExpressionUUID->"a33473a7-eba0-4c3f-9d39-cc89b8318468"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"O", "[", "x", "]"}], "^", 
  "3"}]], "Input",ExpressionUUID->"8acba37c-d66c-411b-9db9-d8964edde5f6"],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "x", "]"}], "3"],
  SeriesData[$CellContext`x, 0, {}, 3, 3, 1],
  Editable->
   False]], "Output",ExpressionUUID->"1590f7cd-3b8d-4f3e-a5ca-72dee6704043"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Evaluate", "[", "%", "]"}], 
  "]"}]], "Input",ExpressionUUID->"bdf29f9d-f547-4eac-b62d-89e13984a5a5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "AnyIndices", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[xAct`xTensor`AnyIndices],
  Editable->
   False]], "Output",ExpressionUUID->"0272b2db-9c59-4450-a0f7-748d878f557d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "Polar", ",", "Q", ",", 
   "T", ",", "v"}], 
  "]"}]], "Input",ExpressionUUID->"713bc400-350c-4a92-8069-1edeafa6b253"],

Cell["More examples:", \
"Text",ExpressionUUID->"9787fd08-3401-4dcc-8053-80139b13d06d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "T", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "r", "]"}], "^=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "Cd", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "CD", "]"}], "^=", "True"}], 
  ";"}]}], "Input",ExpressionUUID->"eb347bb4-4742-4211-aa86-c07ae1cd24dc"],

Cell["Patterns and basis indices are correctly found:", \
"Text",ExpressionUUID->"bce08dbf-c3b1-45e0-b3a0-d538efe81457"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "c"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Cd", "[", 
       RowBox[{"-", "a"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "]"}], 
     RowBox[{"T", "[", 
      RowBox[{"-", "b"}], "]"}]}], "]"}], "+", 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "c"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"a_", ",", 
      RowBox[{"-", "a_"}]}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d5238209-04ce-40cb-8ac2-26abfb326fac"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", "\<\",\"\>", 
    RowBox[{"-", "a"}], "\<\",\"\>", 
    RowBox[{"-", "b"}], "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "a_", "\<\",\"\>", 
    RowBox[{"-", "a_"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b, -$CellContext`a, \
-$CellContext`b, -$CellContext`c, 
   Pattern[$CellContext`a, 
    Blank[]], -Pattern[$CellContext`a, 
     Blank[]]],
  Editable->
   False]], "Output",ExpressionUUID->"c724929d-fc0d-45b3-a83c-08fb6a547e7d"]
}, Open  ]],

Cell["Note that type checking is still not implemented:", \
"Text",ExpressionUUID->"9b4a1e81-06b4-41b1-bbbf-7c114475129f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "c"}], ",", "Polar"}], "}"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Cd", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "a"}], ",", "Polar"}], "}"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "]"}], 
     RowBox[{"T", "[", 
      RowBox[{"-", "b"}], "]"}]}], "]"}], "+", 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "c"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"a_", ",", 
      RowBox[{"-", "a_"}]}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"a8bfd79d-3004-4a0e-93f8-8e89b575883b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "a", "\<\",\"\>", "b", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"-", "b"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "c"}], ",", "Polar"}], "}"}], "\<\",\"\>", 
    "a_", "\<\",\"\>", 
    RowBox[{"-", "a_"}], "\<\",\"\>", 
    RowBox[{"-", "c"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`a, $CellContext`b, {-$CellContext`a, \
$CellContext`Polar}, -$CellContext`b, {-$CellContext`c, $CellContext`Polar}, 
   Pattern[$CellContext`a, 
    Blank[]], -Pattern[$CellContext`a, 
     Blank[]], -$CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"8986a89c-12c3-4b8d-a236-e5450e0ffda9"]
}, Open  ]],

Cell["\<\
The index of the vector field of the Lie derivative is not found:\
\>", "Text",ExpressionUUID->"ed18abac-ba10-4a6a-a168-5eb223ff6153"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"T", "[", "D", "]"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"3d2fc59f-738b-4b09-a5c8-d3d263ad0980"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", "\<\",\"\>", "C", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
  Editable->
   False]], "Output",ExpressionUUID->"7e144422-c109-4daa-bf0f-766b3556b775"]
}, Open  ]],

Cell["Here we have problems with scalars and ScalarFunctions:", \
"Text",ExpressionUUID->"676466fe-84fa-4a55-9115-1d1439d35b3e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", "A", "]"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", "B", "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"-", "B"}], "]"}]}], "+", 
      RowBox[{"r", "[", "]"}]}], ")"}]}], "+", 
   RowBox[{"T", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"fd5202a2-9604-48d9-b074-9c6441708ebe"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"da45ac8d-89fe-4f6f-8444-0f19d7d887a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", "A", "]"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"T", "[", "B", "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "B"}], "]"}]}], ")"}]}], "+", 
   RowBox[{"T", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"233b21aa-e6ca-4269-ac99-890796669eea"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"3ad67bad-66af-42d7-bdcd-c47e72d54160"]
}, Open  ]],

Cell["Rules and Modules:", \
"Text",ExpressionUUID->"fb5814d7-8282-4661-942d-c3fbff344f54"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], "\[Rule]", 
   RowBox[{"T", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"88b9e7fe-be00-4867-86ab-802111aeae7e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"1b8b48eb-a65a-4732-88aa-77cfad4037d9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], "\[RuleDelayed]", 
   RowBox[{"T", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"18b90936-00bc-4289-867f-f1c339156613"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"efc663a7-2e47-44f8-94cb-f8599bde7ed3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], "\[RuleDelayed]", "0"}], 
  "]"}]], "Input",ExpressionUUID->"b23da0be-5d8c-43da-8120-62d1c7c83922"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"57a99e6a-71db-4865-b568-2b69524bfef9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"A", ",", "B"}], "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", 
      RowBox[{"-", "B"}]}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5f6c263c-062c-4215-92ef-ab48c352debe"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", "\<\",\"\>", 
    RowBox[{"-", "B"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"940e20bd-47d0-4115-8478-c4f20c6495af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindFreeIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "B", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B", ",", 
       RowBox[{"-", "B"}]}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"add79b75-7ae8-4b43-8a30-97a174468045"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"18729903-ef22-4374-bf11-0410a1da545f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindDummyIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "B", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B", ",", 
       RowBox[{"-", "B"}]}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c2f5bd14-1c98-45f0-b7df-72fa1b8c1c37"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "B", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"d87b0edf-f99e-42c8-809f-9697e4dcbbd6"]
}, Open  ]],

Cell["Other heads:", \
"Text",ExpressionUUID->"80a35306-2629-4cc7-ad96-77869459724a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"h", "[", 
   RowBox[{
    RowBox[{"T", "[", "A", "]"}], ",", 
    RowBox[{
     RowBox[{"r", "[", "B", "]"}], "+", 
     RowBox[{"T", "[", "C", "]"}]}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"3d239262-88d0-4a51-a1ab-08adf892b2ad"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"7440264b-2857-4e04-b85f-aa3f4ee72c49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Set", "[", 
   RowBox[{
    RowBox[{"T", "[", "A_", "]"}], ",", 
    RowBox[{"r", "[", 
     RowBox[{"A", ",", "B", ",", 
      RowBox[{"-", "B"}]}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"0d710883-a07c-4275-8c23-1d1877d4ae1a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A_", "\<\",\"\>", "A", "\<\",\"\>", 
    "B", "\<\",\"\>", 
    RowBox[{"-", "B"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Pattern[$CellContext`A, 
    Blank[]], $CellContext`A, $CellContext`B, -$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"7c198dbc-24bd-4177-a2c7-9a084cbcf884"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Hold", "[", 
   RowBox[{"Set", "[", 
    RowBox[{
     RowBox[{"T", "[", "A_", "]"}], ",", 
     RowBox[{"r", "[", 
      RowBox[{"A", ",", "B", ",", 
       RowBox[{"-", "B"}]}], "]"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"79f7795d-315b-4ee5-9505-d90c17a7205d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A_", "\<\",\"\>", "A", "\<\",\"\>", 
    "B", "\<\",\"\>", 
    RowBox[{"-", "B"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Pattern[$CellContext`A, 
    Blank[]], $CellContext`A, $CellContext`B, -$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"831fe428-8bd3-408e-9299-262d53fbd7b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Hold", "[", 
   RowBox[{"Hold", "[", 
    RowBox[{"Set", "[", 
     RowBox[{
      RowBox[{"T", "[", "A_", "]"}], ",", 
      RowBox[{"r", "[", 
       RowBox[{"A", ",", "B", ",", 
        RowBox[{"-", "B"}]}], "]"}]}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8e123c0f-df4c-48d9-92ba-a2b1a582644d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A_", "\<\",\"\>", "A", "\<\",\"\>", 
    "B", "\<\",\"\>", 
    RowBox[{"-", "B"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Pattern[$CellContext`A, 
    Blank[]], $CellContext`A, $CellContext`B, -$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"eeb90c1b-4f12-455d-9e44-84d8fed41404"]
}, Open  ]],

Cell["The constant B is not interpreted as an index:", \
"Text",ExpressionUUID->"f5189b67-288d-492f-8016-85c059423537"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "2"}], "+", "B", "+", "1", "+", 
   RowBox[{
    RowBox[{"T", "[", "A", "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"1ac09806-a1a3-46d1-a22d-39a4afa8625e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", 
    RowBox[{"-", "A"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"b0997c4d-1451-4a67-8cbb-d4cbb31d3283"]
}, Open  ]],

Cell["Internal structures:", \
"Text",ExpressionUUID->"bb69de34-18b4-4ce3-b0ff-ec3c3e921ed5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"1", "+", 
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"T", "[", "B", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"r", "[", "]"}], "+", "1", "+", 
     RowBox[{
      RowBox[{"T", "[", "A", "]"}], 
      RowBox[{
       RowBox[{"Cd", "[", 
        RowBox[{"-", "A"}], "]"}], "[", 
       RowBox[{"r", "[", "]"}], "]"}]}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1590340c-ff7e-4507-bcda-759f2939f376"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", 
    RowBox[{"-", "A"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"671ef8c6-9f4a-4cc9-af9c-0e8f5530c9d4"]
}, Open  ]],

Cell["CovDs:", "Text",ExpressionUUID->"c0edc227-0422-481a-8531-406d2957b46f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindAllOfType", "[", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}], "+", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"r", "[", "]"}], "+", "1", "+", 
      RowBox[{
       RowBox[{"T", "[", "A", "]"}], 
       RowBox[{
        RowBox[{"CD", "[", 
         RowBox[{"-", "B"}], "]"}], "[", 
        RowBox[{
         RowBox[{"Cd", "[", 
          RowBox[{"-", "A"}], "]"}], "[", 
         RowBox[{"r", "[", "]"}], "]"}], "]"}]}]}], "]"}]}], ",", "CovD"}], 
  "]"}]], "Input",ExpressionUUID->"d6b5cc35-43e1-4ac1-9653-eed207db8866"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"r", "[", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"r", "[", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"40236bce-6b89-464a-a443-1e5a36673e74"]
}, Open  ]],

Cell["Dummy pairs are represented by the up-index member:", \
"Text",ExpressionUUID->"2a95d9bd-a1da-41a0-9df6-c20e62772845"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindDummyIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "2"}], "+", "A", "+", "1", "+", 
   RowBox[{
    RowBox[{"T", "[", "A", "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"e2aa8cda-0d0a-4457-be1e-26c8d4f486fe"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"1b16d2ee-5752-4a7f-b1ad-b0ab3d284510"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindDummyIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "2"}], "+", "A", "+", "1", "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "Polar"}]}], "}"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"1bc7903f-d2c3-4cb3-a7f0-891da557c795"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"{", 
     RowBox[{"A", ",", "Polar"}], "}"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[{$CellContext`A, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"3349a5cb-e05f-4861-b714-e2ca7c1f2e57"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"a2e6d2a8-0034-477b-869b-c62a9e6264a8"],

Cell["IndexList[{A, Polar}]", \
"Output",ExpressionUUID->"3dcd75a8-a735-44ca-b198-12509d5e382d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindDummyIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "2"}], "+", "A", "+", "1", "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"Polar", "@", "A"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", 
       RowBox[{"Polar", "@", "A"}]}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"4c5192cc-9027-4c11-890d-55b76bc5a5e5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"Polar", "[", "A", "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   $CellContext`Polar[$CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"7ac03c7e-9e30-4e38-83bb-f63a437806b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"adb86fed-ecc0-41d5-b1f2-08d2b7100b43"],

Cell["IndexList[Polar[A]]", \
"Output",ExpressionUUID->"680ea410-872c-458d-8eb4-6f629f19d234"]
}, Open  ]],

Cell["Other examples:", \
"Text",ExpressionUUID->"862ee552-49b3-4abf-a7bb-8eb6ed31e7bf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", "A$1", "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", "B", "]"}], "[", " ", 
    RowBox[{"T", "[", "C", "]"}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "B"}], "]"}], "[", " ", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "A$1"}]}], "]"}], "]"}], 
   RowBox[{
    RowBox[{"CD", "[", "D", "]"}], "[", 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "F"}], "]"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"30d3e517-16c2-4789-bbb4-0a00718f300c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A$1", "\<\",\"\>", "C", "\<\",\"\>", 
    "B", "\<\",\"\>", 
    RowBox[{"-", "C"}], "\<\",\"\>", 
    RowBox[{"-", "A$1"}], "\<\",\"\>", 
    RowBox[{"-", "B"}], "\<\",\"\>", 
    RowBox[{"-", "F"}], "\<\",\"\>", 
    RowBox[{"-", "D"}], "\<\",\"\>", "D", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A$1, C, $CellContext`B, -
   C, -$CellContext`A$1, -$CellContext`B, -$CellContext`F, -D, D],
  Editable->
   False]], "Output",ExpressionUUID->"68053393-d9fa-4d7f-bdae-34e4188881b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindFreeIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "B"}]}], "]"}], "]"}], "+", 
   RowBox[{"T", "[", 
    RowBox[{"-", "A"}], "]"}], "+", 
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4aaee6b1-0862-4195-8146-afc242bb7a50"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "A"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"90c596df-bb63-4482-803d-feb585c703a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindFreeIndices", "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], "+", 
    RowBox[{"r", "[", 
     RowBox[{"-", "A"}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"98782fe0-f4c6-4044-b51a-1bbea6cd309c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "A"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"dc05d9ba-c146-4900-91f0-b65fa67b1702"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"FindFreeIndices", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B", ",", 
       RowBox[{"-", "B"}]}], "]"}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], "+", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "C"}], "]"}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"8161acda-2fd5-4019-a6dc-9a05729a366a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "inhom"}], "MessageName"], ":", 
  " ", "\<\"Found inhomogeneous \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak]: \
\[NoBreak]\\!\\(\\\"{IndexList[-A], IndexList[-C]}\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"63c0f7ab-c4c1-4965-8b86-bdca4399f860"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"FindFreeIndices", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B", ",", 
       RowBox[{"-", "B"}]}], "]"}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], "+", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "B"}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"12b66164-d082-47c2-94f0-9adb7c17f64d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "inhom"}], "MessageName"], ":", 
  " ", "\<\"Found inhomogeneous \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak]: \
\[NoBreak]\\!\\(\\\"{IndexList[-A], IndexList[-A, \
-B]}\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ea052576-f965-45b4-b14f-cd1fd1ce37e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"FindIndices", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{"-", "C"}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"6a92e986-705a-4a15-ab23-e6b3cd8bfc37"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"-B\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d1cf4b78-dd29-4a7f-a9c1-299a24a06c13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindDummyIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A$1", ",", 
      RowBox[{"-", "a"}]}], "]"}], " ", 
    RowBox[{
     RowBox[{"Cd", "[", "B", "]"}], "[", 
     RowBox[{"T", "[", "C", "]"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "A$1"}], ",", "a"}], "]"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "D", "]"}], "[", 
     RowBox[{
      RowBox[{"Cd", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"-", "F"}], "]"}], "]"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A$1", ",", 
      RowBox[{"-", "a"}]}], "]"}], " ", 
    RowBox[{
     RowBox[{"Cd", "[", "B", "]"}], "[", 
     RowBox[{"T", "[", "C", "]"}], "]"}], " ", 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "A$1"}], ",", "a"}], "]"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "G", "]"}], "[", 
     RowBox[{
      RowBox[{"Cd", "[", 
       RowBox[{"-", "G"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"-", "F"}], "]"}], "]"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"77a131b5-a09c-40a9-ad6e-3b0068b1de91"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A$1", "\<\",\"\>", "C", "\<\",\"\>", 
    "B", "\<\",\"\>", "a", "\<\",\"\>", "D", "\<\",\"\>", "G", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A$1, C, $CellContext`B, $CellContext`a, 
   D, $CellContext`G],
  Editable->
   False]], "Output",ExpressionUUID->"dad34635-f0a2-4ce0-b1fd-79b194e906c4"]
}, Open  ]],

Cell["IsIndexOf:", \
"Text",ExpressionUUID->"236d5571-0ec1-4a87-813f-a02c4ee89d1b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"76116a4d-dd79-4a52-8d64-94e2d6330249"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"cf1c35d0-2440-4691-abb4-e455f773e290"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"37a47667-a490-40bc-83fc-979b54ff6036"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"30ca3317-90d6-4fa0-8b1b-4e5990d4e22c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"5d8efcea-7c3d-40e9-8095-95f13825375f"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"9815ba40-dbdd-4310-be5c-ae54acc82e7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"-", "B"}]}], 
  "]"}]], "Input",ExpressionUUID->"fc352a3e-a8bf-4d27-b232-f4e71dc4798d"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"4b3b024c-7279-4c5b-a7de-7a2817df564d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}]}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"6cb92c68-ea8a-4e63-97c1-5c44e0506486"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"2bcde66d-7185-4bd0-ad87-e6022919ff3e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}]}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "B"}]}], "]"}]}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"b5b9f91d-8961-4095-819f-c49232e08c8f"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"dd0531ef-4777-4160-a127-8e88a25ca31c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", 
      RowBox[{"-", "B"}]}], "]"}], "+", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "C", ",", 
      RowBox[{"-", "B"}]}], "]"}]}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"839b3251-fdc3-4b01-8fb8-8d872addffff"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"e552a782-3c8d-4ab6-ac6d-de77b279e77c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "B"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "]"}]}], ")"}], "^", "2"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"969640d7-4972-4975-b4f2-ac26b5446f0b"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"38f904ae-3ad1-4223-97af-e122a6656b53"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", "B"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"791c57e2-e152-4426-8d9d-24773f0f8716"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"e6d5c8d0-bad9-4379-872c-eab02a21ab69"]
}, Open  ]],

Cell["Patterns don't work. They always give True. PINDEX", \
"Text",ExpressionUUID->"68208575-6e51-4f2f-8ffb-6d642df3c317"],

Cell["Series:", "Text",ExpressionUUID->"85a72cf6-8f13-419a-ad40-dcd0110f3417"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"T", "[", "B", "]"}], ",", "A_"}], 
  "]"}]], "Input",ExpressionUUID->"016c23e2-f98b-4ff5-8257-4497c20252c3"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"6e835053-ff7e-4ee1-b901-c88bd8db5817"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "x"}], "+", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"x", "^", "2"}]}], "+", 
  RowBox[{
   RowBox[{"O", "[", "x", "]"}], "^", 
   "3"}]}]], "Input",ExpressionUUID->"91ca030c-a966-4ff2-b25f-bf18be7f9a66"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], " ", "x"}], "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], " ", 
    SuperscriptBox["x", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {
    $CellContext`T[$CellContext`A, $CellContext`B], 
    $CellContext`T[$CellContext`A, $CellContext`B]}, 1, 3, 1],
  Editable->
   False]], "Output",ExpressionUUID->"205963e9-3334-4c1d-947a-0a8393f60362"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", "%", "]"}], ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"91d94a20-367b-46d9-9fd0-8450d3c49c2e"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"6b8c909a-6f79-42fb-99ea-80a7a9961980"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "x"}], "+", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "C"}], "]"}], 
   RowBox[{"x", "^", "2"}]}], "+", 
  RowBox[{
   RowBox[{"O", "[", "x", "]"}], "^", 
   "3"}]}]], "Input",ExpressionUUID->"198e950d-2ed1-4ec2-8d65-cbbc7fd38990"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], " ", "x"}], "+", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "C"}], "]"}], " ", 
    SuperscriptBox["x", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {
    $CellContext`T[$CellContext`A, $CellContext`B], 
    $CellContext`T[$CellContext`A, C]}, 1, 3, 1],
  Editable->
   False]], "Output",ExpressionUUID->"d8bcef38-e0b7-4ed8-b977-272640b1009e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsIndexOf", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", "%", "]"}], ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"e32ff31a-a083-404c-9008-24aceeec41cb"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"e79e08b4-9ee0-44f2-8b3c-a70c564c588d"]
}, Open  ]],

Cell["Blocked indices:", \
"Text",ExpressionUUID->"659af8a0-94c6-4c1e-a4f0-0a9318c7ff77"],

Cell[BoxData[
 RowBox[{
  RowBox[{"expr", "=", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"LI", "[", "1", "]"}], ",", "A", ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"{", 
      RowBox[{"B", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"T", "[", "Z", "]"}], "]"}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"T", "[", 
       RowBox[{"-", "Z"}], "]"}], "]"}], ",", "C_", ",", "_", ",", 
     RowBox[{"-", "_"}], ",", 
     RowBox[{"D_", "?", "Q"}], ",", "F_", ",", 
     RowBox[{"-", "F_"}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"a355c083-9996-4be5-ac95-d7c96dc809fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindIndices", "[", 
  RowBox[{"Evaluate", "@", "expr"}], 
  "]"}]], "Input",ExpressionUUID->"46197077-5fe3-4814-b4c6-d1561292672e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"LI", "[", "1", "]"}], "\<\",\"\>", "A", "\<\",\"\>", 
    RowBox[{"-", "A"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"B", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", 
     RowBox[{"T", "[", "Z", "]"}], "]"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "Z"}], "]"}], "]"}], "\<\",\"\>", "C_", "\<\",\"\>", 
    "_", "\<\",\"\>", 
    RowBox[{"-", "_"}], "\<\",\"\>", 
    RowBox[{"D_", "?", "Q"}], "\<\",\"\>", "F_", "\<\",\"\>", 
    RowBox[{"-", "F_"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   xAct`xTensor`LI[
   1], $CellContext`A, -$CellContext`A, {$CellContext`B, $CellContext`Polar}, \
{-$CellContext`B, -$CellContext`Polar}, {1, $CellContext`Polar}, {
   1, -$CellContext`Polar}, 
   xAct`xTensor`Dir[
    $CellContext`T[$CellContext`Z]], 
   xAct`xTensor`Dir[
    $CellContext`T[-$CellContext`Z]], 
   Pattern[C, 
    Blank[]], 
   Blank[], -Blank[], 
   PatternTest[
    Pattern[D, 
     Blank[]], $CellContext`Q], 
   Pattern[$CellContext`F, 
    Blank[]], -Pattern[$CellContext`F, 
     Blank[]]],
  Editable->
   False]], "Output",ExpressionUUID->"a10bb20c-1643-48c7-b289-bdcffb752102"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindFreeIndices", "[", 
  RowBox[{"Evaluate", "@", "expr"}], 
  "]"}]], "Input",ExpressionUUID->"347b84cd-efdd-44ed-af6d-7a1642571e5a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "C_", "\<\",\"\>", 
    RowBox[{"D_", "?", "Q"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   Pattern[C, 
    Blank[]], 
   PatternTest[
    Pattern[D, 
     Blank[]], $CellContext`Q]],
  Editable->
   False]], "Output",ExpressionUUID->"62c96090-4385-4b09-a117-6ae3889d272f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindDummyIndices", "[", 
  RowBox[{"Evaluate", "@", "expr"}], 
  "]"}]], "Input",ExpressionUUID->"8645200d-7562-4f4f-a2fc-9ab2ac10131b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"B", ",", "Polar"}], "}"}], "\<\",\"\>", "_", "\<\",\"\>", "F_", 
    
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A, {$CellContext`B, $CellContext`Polar}, 
   Blank[], 
   Pattern[$CellContext`F, 
    Blank[]]],
  Editable->
   False]], "Output",ExpressionUUID->"07d52783-2c39-45e2-b185-6aa44b77ffe6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindBlockedIndices", "[", 
  RowBox[{"Evaluate", "@", "expr"}], 
  "]"}]], "Input",ExpressionUUID->"8e4adfff-c7f2-44be-9031-bc5b2afba455"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"LI", "[", "1", "]"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], "\<\",\"\>", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", 
     RowBox[{"T", "[", "Z", "]"}], "]"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "Z"}], "]"}], "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[
   xAct`xTensor`LI[1], {1, $CellContext`Polar}, {1, -$CellContext`Polar}, 
   xAct`xTensor`Dir[
    $CellContext`T[$CellContext`Z]], 
   xAct`xTensor`Dir[
    $CellContext`T[-$CellContext`Z]]],
  Editable->
   False]], "Output",ExpressionUUID->"015e0381-f257-4e0a-ab45-e526a3b1e46d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{"%%%%", ",", "%%", ",", 
   RowBox[{"ChangeIndex", "/@", "%%"}], ",", "%", ",", "%%%"}], 
  "]"}]], "Input",ExpressionUUID->"c6eee8eb-d6f0-4dec-90c6-4c33f1c3d9de"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"{", "}"}],
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0, 0, 1]],
  xAct`xTensor`IndexList[],
  Editable->
   False]], "Output",ExpressionUUID->"a68df7fc-bb08-400e-b184-93de517a3cfc"]
}, Open  ]],

Cell["\<\
The conclusion is that all patterns qualify either as free or dummy indices. \
That is strange. In particular I think considering Blank[] and -Blank[] a \
dummy pair could be an error. QUESTION.\
\>", "Text",ExpressionUUID->"9c83e830-0802-4abd-b4ef-f933f33d293a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "A", ",", "A$1", ",", "b", ",", "B", ",", "c", ",", "Cd", ",", 
   "CD", ",", "F", ",", "G", ",", "h", ",", "Polar", ",", "r", ",", "T", ",", 
   "Q", ",", "Z", ",", "expr"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"78a22d4b-8c00-4f39-8c1b-ef7af48fc405"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"x\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"x"}],
  Editable->
   False]], "Print",ExpressionUUID->"879633f4-073a-4113-8f73-21ff700d7a74"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.6. UltraindexOf", \
"Subsubsection",ExpressionUUID->"b2ef787c-4496-4917-aa25-71a86b6b5725"],

Cell["\<\
UltraindexOf returns the (abstract) free index of a directional argument, or \
None for pattern expressions. It is not possible to have a pattern index \
instead of the ultraindex. It is a private function.\
\>", "Text",ExpressionUUID->"2a46ec5f-844d-4534-9f4d-fdf247e9898e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "We", " ", "need", " ", "several", " ", "stupid", " ", "special", " ", 
    "cases", " ", "to", " ", "avoid", " ", "messages", " ", "from", " ", 
    "the", " ", "Information", " ", "commands", " ", "from", " ", 
    RowBox[{"covds", ".", " ", "This"}], " ", "is", " ", "ugly"}], " ", 
   "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", 
      RowBox[{"_Pattern", " ", "_."}], "]"}], ":=", "None"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", 
      RowBox[{"x_Pattern", "+", "y_Pattern"}], "]"}], ":=", "None"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", "x_Symbol", "]"}], ":=", "None"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", "x_Slot", "]"}], ":=", "None"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", "0", "]"}], ":=", "None"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Main", " ", 
     RowBox[{"function", ".", " ", "Recall"}], " ", "that", " ", "it", " ", 
     "returns", " ", "the", " ", "free", " ", "ultraindex"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", 
      RowBox[{"Dir", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"UltraindexOf", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"UltraindexOf", "[", "expr_", "]"}], ":=", 
     RowBox[{"checkultraindex", "[", 
      RowBox[{
       RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Internal", " ", 
     RowBox[{"function", ".", " ", "It"}], " ", "returns", " ", "the", " ", 
     "ultraindex", " ", "or", " ", "an", " ", "error"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"checkultraindex", "[", 
      RowBox[{
       RowBox[{"IndexList", "[", "i_", "]"}], ",", "_"}], "]"}], ":=", "i"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"checkultraindex", "[", 
      RowBox[{"_", ",", "expr_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "error"}], ",", 
        "\"\<Invalid or no ultraindex.\>\""}], "]"}]}]}], ";"}]}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"e202956b-9c0e-46b7-b6a7-7d7b866a87c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UltraindexOf", "[", 
  RowBox[{"Dir", "[", "expr", "]"}], 
  "]"}]], "Input",ExpressionUUID->"b91d9445-5856-4ff9-8b99-773cb4ff7f04"],

Cell[BoxData["None"], \
"Output",ExpressionUUID->"69dc2197-bf2f-417c-a66a-20a5507645e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UltraindexOf", "[", 
  RowBox[{"Dir", "[", "expr_", "]"}], 
  "]"}]], "Input",ExpressionUUID->"dfdc5f70-2f0a-4bb3-8013-84915de23920"],

Cell[BoxData["None"], \
"Output",ExpressionUUID->"bff68438-f347-4536-881c-e5155ea26739"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.7. IndicesOf", \
"Subsubsection",ExpressionUUID->"f266bebf-5b7e-4758-8c4a-0b7186ddad33"],

Cell["\<\
The function SelectIndices is in charge of extracting the appropriate indices \
from a list. Not prepared to handle patterns.\
\>", "Text",ExpressionUUID->"d01528a3-5366-441f-a2cc-ff974973013d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Trivial", " ", "case"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"IndexList", "[", "]"}], ",", "selectors_"}], "]"}], ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Threading", " ", "as", " ", "Or"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "selectors_List"}], "]"}], 
     ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"Join", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SelectIndices", "[", 
           RowBox[{"expr", ",", "list", ",", "#"}], "]"}], "&"}], ",", 
         "selectors"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Not", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", 
       RowBox[{"Not", "[", "selector_", "]"}]}], "]"}], ":=", 
     RowBox[{"Complement", "[", 
      RowBox[{"list", ",", 
       RowBox[{"SelectIndices", "[", 
        RowBox[{"expr", ",", "list", ",", "selector"}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Select", " ", "according", " ", "to", " ", "states"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "Free"}], "]"}], ":=", 
     RowBox[{"TakeFrees", "[", "list", "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "Dummy"}], "]"}], ":=", 
     RowBox[{"TakeEPairs", "[", "list", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "Blocked"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "BlockedQ"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Select", " ", "according", " ", "to", " ", "character"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "xAct`xTensor`Up"}], "]"}],
      ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "UpIndexQ"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "xAct`xTensor`Down"}], 
      "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "DownIndexQ"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Select", " ", "according", " ", "to", " ", "type"}], " ", "*)"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "AIndex"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "AIndexQ"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "BIndex"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "BIndexQ"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "CIndex"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "CIndexQ"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "DIndex"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "DIndexQ"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "LIndex"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", "LIndexQ"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Select", " ", "according", " ", "to", " ", 
     RowBox[{"associations", ".", " ", "BASIS1"}], " ", "and", " ", 
     "BASIS2"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", 
       RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"list", ",", 
       RowBox[{
        RowBox[{"IndexOnQ", "[", 
         RowBox[{"#", ",", "vbundle"}], "]"}], "&"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", 
       RowBox[{"basis_Symbol", "?", "BasisQ"}]}], "]"}], ":=", 
     RowBox[{"IndexList", "@@", 
      RowBox[{"Cases", "[", 
       RowBox[{"list", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", 
           RowBox[{"basis", "|", 
            RowBox[{"-", "basis"}]}]}], "}"}], "|", 
         RowBox[{"basis", "[", "_", "]"}], "|", 
         RowBox[{"-", 
          RowBox[{"basis", "[", "_", "]"}]}]}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", 
       RowBox[{"Basis", "[", "basis_", "]"}]}], "]"}], ":=", 
     RowBox[{"Intersection", "[", 
      RowBox[{"list", ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"IndexList", "@@", 
          RowBox[{"Cases", "[", 
           RowBox[{"expr", ",", 
            RowBox[{
             RowBox[{"Basis", "[", 
              RowBox[{"index1___", ",", 
               RowBox[{"index2", ":", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"_", ",", 
                    RowBox[{"basis", "|", 
                    RowBox[{"-", "basis"}]}]}], "}"}], "|", 
                  RowBox[{"basis", "[", "_", "]"}], "|", 
                  RowBox[{"-", 
                   RowBox[{"basis", "[", "_", "]"}]}]}], ")"}]}], ",", 
               "index3___"}], "]"}], "\[Rule]", 
             RowBox[{"IndexList", "[", 
              RowBox[{"index1", ",", "index2", ",", "index3"}], "]"}]}], ",", 
            
            RowBox[{"{", 
             RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}]}], ",", 
         "Infinity", ",", "IndexList"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", 
       RowBox[{"tensor_", "?", "xTensorQ"}]}], "]"}], ":=", 
     RowBox[{"Intersection", "[", 
      RowBox[{"list", ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"IndexList", "@@", 
          RowBox[{"Cases", "[", 
           RowBox[{"expr", ",", 
            RowBox[{
             RowBox[{"tensor", "[", "inds__", "]"}], "\[Rule]", 
             RowBox[{"IndexList", "[", "inds", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}]}], ",", 
         "Infinity", ",", "IndexList"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"Intersection", "[", 
      RowBox[{"list", ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"IndexList", "@@", 
            RowBox[{"Cases", "[", 
             RowBox[{"expr", ",", 
              RowBox[{
               RowBox[{"HoldPattern", "[", 
                RowBox[{
                 RowBox[{"covd", "[", "inds__", "]"}], "[", "_", "]"}], "]"}],
                "\[Rule]", 
               RowBox[{"IndexList", "[", "inds", "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}]}], ",", 
           "Infinity", ",", "IndexList"}], "]"}], ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"IndexList", "@@", 
            RowBox[{"Cases", "[", 
             RowBox[{"expr", ",", 
              RowBox[{
               RowBox[{"HoldPattern", "[", 
                RowBox[{"CovD", "[", 
                 RowBox[{"_", ",", "ders__"}], "]"}], "]"}], "\[RuleDelayed]", 
               RowBox[{"(", 
                RowBox[{"CovDIndices", "/@", 
                 RowBox[{"IndexList", "[", "ders", "]"}]}], ")"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}]}], ",", 
           "Infinity", ",", "IndexList"}], "]"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", 
     RowBox[{"cases", ":", " ", "error"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectIndices", "[", 
      RowBox[{"expr_", ",", "list_IndexList", ",", "x_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"IndicesOf", "::", "invalid"}], ",", "x", ",", 
        "\"\<index selector\>\""}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7c35a9ce-36ea-43a2-929d-69b76012fdba"],

Cell["This function is the user driver for finding indices:", \
"Text",ExpressionUUID->"fde0b8d8-2750-4a54-bd78-a9ea96574850"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndicesOf", "[", "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{"FindIndices", "[", "expr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndicesOf", "[", 
     RowBox[{"selectors___", ",", "selector1_"}], "]"}], "[", "expr_", "]"}], 
   ":=", 
   RowBox[{"SelectIndices", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"IndicesOf", "[", "selectors", "]"}], "[", "expr", "]"}], ",", 
     "selector1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndicesOf", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"beeff201-8fdd-4e06-bbf8-589972ba7154"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6.8. Parsing: IndexExpr", \
"Subsubsection",ExpressionUUID->"f3086816-b605-4a68-9dd9-b746b65b5db1"],

Cell["\<\
Here we introduce a command which rewrites an expression adding the head \
IndexExpr, which gives information on the free and dummy indices inside its \
first argument. This function uses TakeFrees and TakeEPairs, but it is \
completely independent of FindIndices or IsIndexOf, and hence can be \
considered as a third independent implementation of the process of finding \
indices. The function ToIndexExpr introduces this head and has certain \
similarities with the more powerful function Identify used below for \
canonicalization. Both IndexExpr and ToIndexExpr hold their first argument, \
to fully block the process of evaluation during that rewriting of an \
expression:\
\>", "Text",ExpressionUUID->"319e3b28-c93b-4128-9df9-88ead4d419ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ToIndexExpr", ",", "IndexExpr"}], "}"}], ",", "HoldFirst"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6ee3a9aa-a55d-4cb7-afb8-3cceb83cf138"],

Cell["\<\
We add a second argument in ToIndexExpr to perform some action on the \
resulting IndexExpr expression. This will be later used for example to trace \
dummies. It is very important to note that this function acts on the whole \
expression with head IndexExpr, in order to access the free-dummy indices \
information. It must return again an IndexExpr expression because the \
recursive structure of ToIndexExpr works from the deepest level to 0: the \
information at level n+1 is used (by freesof) to compute level n.

The function ToIndexExpr acts differently on different types of expressions. \
Only three cases are nontrivial, those in which free indices can become dummy \
indices: traces in tensors, traces in tensor products and divergences. Note \
that in composite expressions we always return a nested IndexExpr structure, \
except for Plus. This nesting serves no purpose at this moment because \
IndexExpr is not instructed to do anything on IndexExpr subexpressions. Only \
freesof is using that information, to avoid recomputing free indices of \
subexpressions.\
\>", "Text",ExpressionUUID->"9afb4fff-5756-4b6c-829d-eff717bc1436"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", 
    RowBox[{"argument", ":", " ", 
     RowBox[{"default", " ", 
      RowBox[{"function", ":", " ", "Identity"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", "expr_", "]"}], ":=", 
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{"expr", ",", "Identity"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Tensors", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Bracket", "[", 
         RowBox[{"v1_", ",", "v2_"}], "]"}], "[", "inds__", "]"}], ",", 
       "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"iv1", "=", 
          RowBox[{"ToIndexExpr", "[", 
           RowBox[{"v1", ",", "function"}], "]"}]}], ",", 
         RowBox[{"iv2", "=", 
          RowBox[{"ToIndexExpr", "[", 
           RowBox[{"v2", ",", "function"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Bracket", "[", 
            RowBox[{"iv1", ",", "iv2"}], "]"}], "[", "inds", "]"}], ",", 
          RowBox[{"IndexList", "[", "inds", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"_", "?", "xTensorQ"}], "[", "inds___", "]"}]}], ",", 
       "function_"}], "]"}], ":=", 
     RowBox[{"function", "@", 
      RowBox[{"IndexExpr", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"TakeFrees", "[", 
         RowBox[{"IndexList", "[", "inds", "]"}], "]"}], ",", 
        RowBox[{"TakeEPairs", "[", 
         RowBox[{"IndexList", "[", "inds", "]"}], "]"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Tensor", " ", "products"}], ",", " ", 
     RowBox[{"including", " ", 
      RowBox[{"Times", ".", " ", 
       RowBox[{"Note", ":", " ", 
        RowBox[{"iexpr", " ", "is", " ", "a", " ", "List", " ", "of", " ", 
         RowBox[{"IndexExpr", "'"}], "s"}]}]}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"HoldPattern", "[", 
        RowBox[{"Times", "[", "factors__", "]"}], "]"}], ",", "function_"}], 
      "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"ToIndexExpr", "[", 
            RowBox[{"#", ",", "function"}], "]"}], "&"}], "/@", 
          RowBox[{"Unevaluated", "[", 
           RowBox[{"{", "factors", "}"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"all", "=", 
           RowBox[{"Apply", "[", 
            RowBox[{"Join", ",", 
             RowBox[{"freesof", "/@", "iexpr"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"dummies", "=", 
             RowBox[{"TakeEPairs", "[", "all", "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"function", "@", 
            RowBox[{"ReplacePart", "[", 
             RowBox[{
              RowBox[{"IndexExpr", "[", 
               RowBox[{"iexpr", ",", 
                RowBox[{"Complement", "[", 
                 RowBox[{"all", ",", "dummies"}], "]"}], ",", "dummies"}], 
               "]"}], ",", "Times", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}]}], " ", "]"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"HoldPattern", "[", 
        RowBox[{
         RowBox[{"prod_", "?", "ProductQ"}], "[", "factors__", "]"}], "]"}], 
       ",", "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"ToIndexExpr", "[", 
            RowBox[{"#", ",", "function"}], "]"}], "&"}], "/@", 
          RowBox[{"Unevaluated", "[", 
           RowBox[{"{", "factors", "}"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"all", "=", 
           RowBox[{"Apply", "[", 
            RowBox[{"Join", ",", 
             RowBox[{"freesof", "/@", "iexpr"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"dummies", "=", 
             RowBox[{"TakeEPairs", "[", "all", "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"function", "@", 
            RowBox[{"ReplacePart", "[", 
             RowBox[{
              RowBox[{"IndexExpr", "[", 
               RowBox[{"iexpr", ",", 
                RowBox[{"Complement", "[", 
                 RowBox[{"all", ",", "dummies"}], "]"}], ",", "dummies"}], 
               "]"}], ",", "prod", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}]}], " ", "]"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Covariant", " ", "derivatives"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{
          RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", 
         "expr1_", "]"}]}], ",", "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr1", "=", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr1", ",", "function"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"all", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"freesof", "[", "iexpr1", "]"}], ",", 
             RowBox[{"IndexList", "[", "inds", "]"}]}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"dummies", "=", 
             RowBox[{"TakeEPairs", "[", "all", "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"function", "@", 
            RowBox[{"IndexExpr", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"covd", "[", "inds", "]"}], "[", "iexpr1", "]"}], ",", 
              
              RowBox[{"Complement", "[", 
               RowBox[{"all", ",", "dummies"}], "]"}], ",", "dummies"}], 
             "]"}]}]}], " ", "]"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{"CovD", "[", 
         RowBox[{"expr1_", ",", "ders__"}], "]"}]}], ",", "function_"}], 
      "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr1", "=", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr1", ",", "function"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"all", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"freesof", "[", "iexpr1", "]"}], ",", 
             RowBox[{"CovDIndices", "/@", 
              RowBox[{"IndexList", "[", "ders", "]"}]}]}], "]"}]}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"dummies", "=", 
             RowBox[{"TakeEPairs", "[", "all", "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"function", "@", 
            RowBox[{"IndexExpr", "[", 
             RowBox[{
              RowBox[{"CovD", "[", 
               RowBox[{"iexpr1", ",", "ders"}], "]"}], ",", 
              RowBox[{"Complement", "[", 
               RowBox[{"all", ",", "dummies"}], "]"}], ",", "dummies"}], 
             "]"}]}]}], " ", "]"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Thread", " ", "over", " ", 
     RowBox[{"sums", ".", " ", "No"}], " ", "nesting", " ", "of", " ", 
     "IndexExpr"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{"expr_Plus", ",", "function_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"ToIndexExpr", "[", 
        RowBox[{"#", ",", "function"}], "]"}], "&"}], "/@", 
      RowBox[{"Unevaluated", "[", "expr", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Series", ".", " ", "Keep"}], " ", "structure"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"HoldPattern", "[", 
        RowBox[{"SeriesData", "[", 
         RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], "]"}],
         "]"}], ",", "function_"}], "]"}], ":=", 
     RowBox[{"SeriesData", "[", 
      RowBox[{
       RowBox[{"ToIndexExpr", "[", 
        RowBox[{"var", ",", "function"}], "]"}], ",", 
       RowBox[{"ToIndexExpr", "[", 
        RowBox[{"orig", ",", "function"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"#", ",", "function"}], "]"}], "&"}], "/@", 
        RowBox[{"Unevaluated", "[", "coeffs", "]"}]}], ",", "rest"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", 
     RowBox[{"cases", ":", " ", 
      RowBox[{"no", " ", "new", " ", "dummies"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
       "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"iv", "=", 
          RowBox[{"ToIndexExpr", "[", 
           RowBox[{"v", ",", "function"}], "]"}]}], ",", 
         RowBox[{"iexpr", "=", 
          RowBox[{"ToIndexExpr", "[", 
           RowBox[{"expr", ",", "function"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"LieD", "[", "iv", "]"}], "[", "iexpr", "]"}], ",", 
          RowBox[{"freesof", "[", "iexpr", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"OverDot", "[", "expr_", "]"}], ",", "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr", "=", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr", ",", "function"}], "]"}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{"OverDot", "[", "iexpr", "]"}], ",", 
          RowBox[{"freesof", "[", "iexpr", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], ",", 
       "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr", "=", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr", ",", "function"}], "]"}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ParamD", "[", "ps", "]"}], "[", "iexpr", "]"}], ",", 
          RowBox[{"freesof", "[", "iexpr", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{"symbol_Symbol", ",", "function_"}], "]"}], ":=", 
     RowBox[{"function", "@", 
      RowBox[{"IndexExpr", "[", 
       RowBox[{"symbol", ",", 
        RowBox[{"IndexList", "[", "]"}], ",", 
        RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"constant_", "?", "ConstantQ"}], ",", "function_"}], "]"}], ":=", 
     RowBox[{"function", "@", 
      RowBox[{"IndexExpr", "[", 
       RowBox[{"constant", ",", 
        RowBox[{"IndexList", "[", "]"}], ",", 
        RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
        RowBox[{"expr_", ",", "z___"}], "]"}], ",", "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr", "=", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr", ",", "function"}], "]"}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{"ih", "[", 
           RowBox[{"iexpr", ",", "z"}], "]"}], ",", 
          RowBox[{"freesof", "[", "iexpr", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"sf_Symbol", "?", "ScalarFunctionQ"}], "[", "expr_", "]"}], 
       ",", "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"iexpr", "=", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr", ",", "function"}], "]"}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{"sf", "[", "iexpr", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"sf_Symbol", "?", "ScalarFunctionQ"}], "[", 
        RowBox[{"expr1_", ",", "expr2_"}], "]"}], ",", "function_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"iexpr1", "=", 
          RowBox[{"ToIndexExpr", "[", 
           RowBox[{"expr1", ",", "function"}], "]"}]}], ",", 
         RowBox[{"iexpr2", "=", 
          RowBox[{"ToIndexExpr", "[", 
           RowBox[{"expr2", ",", "function"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"function", "@", 
        RowBox[{"IndexExpr", "[", 
         RowBox[{
          RowBox[{"sf", "[", 
           RowBox[{"iexpr1", ",", "iexpr2"}], "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "heads"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{
       RowBox[{"head_", "[", "expr_", "]"}], ",", "function_"}], "]"}], ":=", 
     
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"$FindIndicesAcceptedHeads", ",", "head"}], "]"}], ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{
         RowBox[{"head", "[", "expr", "]"}], ",", 
         RowBox[{"ToIndexExpr", "[", 
          RowBox[{"expr", ",", "function"}], "]"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], ",", 
       RowBox[{"head", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"General", " ", 
     RowBox[{"definition", ":", " ", 
      RowBox[{"do", " ", "nothing"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"ToIndexExpr", "[", 
      RowBox[{"expr_", ",", "function_"}], "]"}], ":=", 
     RowBox[{"function", "@", 
      RowBox[{"IndexExpr", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"IndexList", "[", "]"}], ",", 
        RowBox[{"IndexList", "[", "]"}]}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"883a3a17-30e7-45bc-a3cb-e990bbbcaf9f"],

Cell["Final details:", \
"Text",ExpressionUUID->"7d6696dc-7984-4c7a-809e-0074a493602b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ToIndexExpr", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndexExpr", ",", "3"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"ToIndexExpr", ",", "IndexExpr"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f3d28409-3a20-4933-a2ae-899332b0ec13"],

Cell["\<\
We need this small function to extract the free indices from previously \
computed IndexExpr constructs:\
\>", "Text",ExpressionUUID->"82ba3e5c-9707-4d44-84e7-b012e8e9374e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"freesof", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"freesof", "[", 
    RowBox[{"First", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"freesof", "[", "expr_SeriesData", "]"}], ":=", 
   RowBox[{"freesof", "[", 
    RowBox[{"Normal", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"freesof", "[", 
    RowBox[{"IndexExpr", "[", 
     RowBox[{"_", ",", "frees_", ",", "_"}], "]"}], "]"}], ":=", "frees"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"freesof", "[", "expr_", "]"}], ":=", 
   RowBox[{"IndexList", "[", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1bab0201-b192-402e-970d-a1af97d2e0e2"],

Cell["\<\
There is the question of how to deconstruct the IndexExpr structure. The only \
point is the HoldFirst attribute. We do it using FromIndexExpr (this function \
does not need HoldFirst because we assume that its first argument is always \
an IndexExpr expression). The second argument can be used to introduce a \
holding head which keeps preventing evaluation. The xHold additional wrapper \
has been added (Sept 2011) after discussing with Stephen Green and Leo Stein, \
to avoid an unfortunate interaction between dummy tracing and delta \
contraction:\
\>", "Text",ExpressionUUID->"d6fc5b66-eeb3-42f9-be2a-b2b48ca18b11"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FromIndexExpr", "[", 
    RowBox[{"iexpr_", ",", 
     RowBox[{"wrap_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"Identity", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xHold", "[", 
       RowBox[{"wrap", "[", "iexpr", "]"}], "]"}], "//.", 
      RowBox[{
       RowBox[{"IndexExpr", "[", 
        RowBox[{"expr_", ",", "_", ",", "_"}], "]"}], "\[RuleDelayed]", 
       "expr"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3905de9d-78ff-4145-ae6b-4b5b143836ef"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7. ReplaceIndex", \
"Subsection",ExpressionUUID->"f248e6b1-ff56-4e9d-bf67-5ced21b12780"],

Cell[CellGroupData[{

Cell["5.7.1. ReplaceOneIndex, ReplaceIndexList", \
"Subsubsection",ExpressionUUID->"69257e2f-1fad-42bf-8a81-bd576b8ba8b1"],

Cell["\<\
This function changes indices according to some rules. There is no reference \
to the objects having indices. Comments:
\t0) There is no restriction on the RHS of the index rules. That is, we can \
replace an index by anything we want.
\t1) We can change the up/down character of an index with a rule like a -> \
-b.
\t2) The rule a->b does not change -a to -b. A separate rule is needed.
\t3) Patterns can be replaced, but we send a `Contact JMM\.b4 message. Use \
only up->up or down->down rules. This is not checked.
\t4) Component indices, blanks, labels and directions were left untouched in \
version 0.7. Now since 0.8 they can be changed as well.
\t5) As usual with functions acting on indices, there is no restriction on \
evaluation.
\t6) Basis indices can be changed as a whole. This is also new in 0.8. If a \
basis index cannot be changed as a whole, then we try to change only its name \
using the rules for abstract indices (this was the only behaviour in 0.7). \
The 0.7 rules were safe but too strict for functions like PermuteIndices.
\t7) In version 1.0 we add the general concept of IndexModifier, following \
basis-indices. We first try to change the whole index, and if it does not \
work then we try to change its \"name\", always the first argument of the \
index-modifier.\
\>", "Text",ExpressionUUID->"e1bfa150-111d-42cd-b99a-54ec84c8ff69"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ReplaceOneIndex"}]], \
"Input",ExpressionUUID->"9c1e450d-6201-42f3-8e25-01a17272e9eb"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672471-5338953",ExpressionUUID->"63203ada-d13b-4cdd-89eb-\
0de1303f6ae4"]
}, Open  ]],

Cell["\<\
Patterns can be changed. For instance there can be patterns in \
dollar-indices, and so ScreenDollarIndices will change them:\
\>", "Text",ExpressionUUID->"5b336269-48ee-441b-b140-4b9d9852ae62"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"replacepattern", "[", 
    RowBox[{"i_", ",", "rules_", ",", "sign_"}], "]"}], ":=", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{"i", ",", 
     RowBox[{"sign", " ", 
      RowBox[{"ReplaceOneIndex", "[", 
       RowBox[{
        RowBox[{"sign", " ", 
         RowBox[{"First", "[", "i", "]"}]}], ",", "rules"}], "]"}]}], ",", 
     "1"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e1294d69-6a66-4ce8-a6f8-43f5f4dfba6b"],

Cell["\<\
To avoid Mathematica complaining about having patterns on the RHS we \
deactivate the message\
\>", "Text",ExpressionUUID->"1c0da141-e890-4d35-9b20-dac32ef03619"],

Cell[BoxData[
 RowBox[{"Off", "[", 
  RowBox[{"Rule", "::", "rhs"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3c941483-1d47-4ad3-844a-c0f2f7648ef2"],

Cell[TextData[{
 "Correct replacements. The key idea is the use of Replace (and not \
ReplaceAll), which only tries to replace the whole expression. This is \
because we can never deconstruct the indices; in particular we must always \
keep track of their character. Replace scans lists of rules sequentially \
until it finds the first rule applying. We need special care with basis \
indices because in version 0.7 only its name was replaced, and now we want to \
try first the change of the whole index. That forces us to replace basis \
indices in two steps (this is implemented through the function \
ReplaceBasisIndex): if the whole index is changed then do not try to change \
its name; if the whole index is not changed, then try to change its name. \
This is one of the most critical functions in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " and hence we need to throw an error in case something is not clear:"
}], "Text",ExpressionUUID->"d61bf3be-223b-4ad4-8bc6-30e6687f4611"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Symbols", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"(", 
         RowBox[{"_Symbol", "|", 
          RowBox[{"-", "_Symbol"}]}], ")"}]}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"Replace", "[", 
      RowBox[{"i", ",", "rules"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Directions", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{"i_Dir", ",", "rules_"}], "]"}], ":=", 
     RowBox[{"Replace", "[", 
      RowBox[{"i", ",", "rules"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Labels", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"(", 
         RowBox[{"_LI", "|", 
          RowBox[{"-", "_LI"}]}], ")"}]}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"Replace", "[", 
      RowBox[{"i", ",", "rules"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Components", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ReplaceOneIndex", "[", 
       RowBox[{
        RowBox[{"i", ":", 
         RowBox[{"{", 
          RowBox[{"_Integer", ",", "_"}], "}"}]}], ",", "rules_"}], "]"}], ":=", 
      RowBox[{"Replace", "[", 
       RowBox[{"i", ",", "rules"}], "]"}]}], ";"}], " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"(", 
         RowBox[{"_.", 
          RowBox[{
           RowBox[{"_Symbol", "?", "BasisQ"}], "[", "_Integer", "]"}]}], 
         ")"}]}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"Replace", "[", 
      RowBox[{"i", ",", "rules"}], "]"}]}], ";", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Basis", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ReplaceOneIndex", "[", 
       RowBox[{
        RowBox[{"i", ":", 
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}]}], ",", "rules_"}], "]"}], ":=", 
      RowBox[{"ReplaceBasis1Index", "[", 
       RowBox[{"i", ",", 
        RowBox[{"Replace", "[", 
         RowBox[{"i", ",", "rules"}], "]"}], ",", "rules"}], "]"}]}], ";"}], 
    " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"(", 
         RowBox[{"_.", 
          RowBox[{
           RowBox[{"_", "?", "IModQ"}], "[", "_", "]"}]}], ")"}]}], ",", 
       "rules_"}], "]"}], ":=", 
     RowBox[{"ReplaceBasis2Index", "[", 
      RowBox[{"i", ",", 
       RowBox[{"Replace", "[", 
        RowBox[{"i", ",", "rules"}], "]"}], ",", "rules"}], "]"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"BASIS2", " ", "&"}], " ", "IMOD"}], " ", "*)"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Patterns", ".", " ", "PINDEX"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{"i_Blank", ",", "rules_"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"ReplaceIndex", "::", "nopat"}], ",", "i", ",", 
         "$WarningFrom"}], "]"}], ";", "i"}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{"i_Pattern", ",", "rules_"}], "]"}], ":=", 
     RowBox[{"replacepattern", "[", 
      RowBox[{"i", ",", "rules", ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{"i_PatternTest", ",", "rules_"}], "]"}], ":=", 
     RowBox[{"replacepattern", "[", 
      RowBox[{"i", ",", "rules", ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"-", "i_Pattern"}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"replacepattern", "[", 
       RowBox[{"i", ",", "rules", ",", 
        RowBox[{"-", "1"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"-", "i_PatternTest"}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"replacepattern", "[", 
       RowBox[{"i", ",", "rules", ",", 
        RowBox[{"-", "1"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Slots", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{
       RowBox[{"i", ":", 
        RowBox[{"slot", "[", "_", "]"}]}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"Replace", "[", 
      RowBox[{"i", ",", "rules"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", 
     RowBox[{"cases", ":", " ", 
      RowBox[{"throw", " ", "error"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceOneIndex", "[", 
      RowBox[{"i_", ",", "rules_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ReplaceIndex", "::", "invalid"}], ",", "i", ",", 
        "\"\<index to be replaced\>\""}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3fbfa48a-ff65-4de3-80cf-ba1377989f54"],

Cell["\<\
Manipulation of basis-indices is separated according to their notation. \
QUESTION: Why do we need the CheckBasis?Functions ? :\
\>", "Text",ExpressionUUID->"641477b6-4966-46d4-bd91-23090c4afe59"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceBasis1Index", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"old_", ",", "basis_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"old_", ",", "basis_"}], "}"}], ",", "rules_"}], "]"}], ":=", 
     
     RowBox[{"CheckBasis1Index", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ReplaceOneIndex", "[", 
         RowBox[{"old", ",", "rules"}], "]"}], ",", "basis"}], "}"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceBasis1Index", "[", 
      RowBox[{"old_", ",", "new_", ",", "rules_"}], "]"}], ":=", "new"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis1Index", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "a_"}], ",", "basis_Symbol"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "basis"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis1Index", "[", 
      RowBox[{"{", 
       RowBox[{"a_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"a", ",", "basis"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis1Index", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a_", "?", "UpIndexQ"}], ",", 
        RowBox[{"-", "basis_Symbol"}]}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"a", ",", "basis"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis1Index", "[", "index_", "]"}], ":=", "index"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"38574903-ad24-44f7-b4ab-f011c99df35d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "BASIS2", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceBasis2Index", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"imod_", "[", "old_", "]"}]}], ",", 
       RowBox[{"-", 
        RowBox[{"imod_", "[", "old_", "]"}]}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"CheckBasis2Index", "[", 
      RowBox[{
       RowBox[{"imod", "[", 
        RowBox[{"ReplaceOneIndex", "[", 
         RowBox[{
          RowBox[{"-", "old"}], ",", "rules"}], "]"}], "]"}], ",", 
       RowBox[{"-", "1"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceBasis2Index", "[", 
      RowBox[{
       RowBox[{"imod_", "[", "old_", "]"}], ",", 
       RowBox[{"imod_", "[", "old_", "]"}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"CheckBasis2Index", "[", 
      RowBox[{
       RowBox[{"imod", "[", 
        RowBox[{"ReplaceOneIndex", "[", 
         RowBox[{"old", ",", "rules"}], "]"}], "]"}], ",", "1"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceBasis2Index", "[", 
      RowBox[{"old_", ",", "new_", ",", "rules_"}], "]"}], ":=", "new"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis2Index", "[", 
      RowBox[{
       RowBox[{"basis_", "[", "a_Integer", "]"}], ",", 
       RowBox[{"-", "1"}]}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"basis", "[", "a", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis2Index", "[", 
      RowBox[{
       RowBox[{"imod_", "[", 
        RowBox[{"-", "a_"}], "]"}], ",", "_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"imod", "[", "a", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckBasis2Index", "[", 
      RowBox[{"index_", ",", "_"}], "]"}], ":=", "index"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"475d69a0-1287-46bd-8e1c-15b7719a7d79"],

Cell["Thread over lists of indices:", \
"Text",ExpressionUUID->"bb660150-9d87-46d9-8beb-2c30fc85263d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplaceIndexList", "[", 
   RowBox[{"list_IndexList", ",", "rules_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"ReplaceOneIndex", "[", 
     RowBox[{"#", ",", "rules"}], "]"}], "&"}], "/@", "list"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3b8d6fd1-ac93-41bb-8939-17c4e1714625"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e8dba945-276e-4550-a569-e5046733ea6e"],

Cell["We can change abstract indices:", \
"Text",ExpressionUUID->"331eccde-f293-4815-8919-d8aacc1a4ab8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"xATP`ReplaceOneIndex", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "b"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"18661e96-dc04-4e40-abc1-d109560cf581"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{
       RowBox[{"-", "a"}], "\[Rule]", "b"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{
       RowBox[{"-", "a"}], "\[Rule]", "b"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`ReplaceOneIndex", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{
       RowBox[{"-", "a"}], "\[Rule]", "b"}]}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{
       RowBox[{"-", "a"}], "\[Rule]", "b"}]}], "]"}],
    HoldForm], ",", 
   TagBox["b",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"95198c6d-ba2e-415d-b2bc-40ebbdf38efa"]
}, Open  ]],

Cell["and basis indices:", \
"Text",ExpressionUUID->"03b1f068-f04c-40d3-b298-68a3e42ded35"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisQ", "[", "Polar", "]"}], "^=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"cef08b06-e7c1-4420-8416-fbd061ea4a64"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"c0ef9a2e-c5c6-4202-8b5f-e97bedd6fb2e"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"2fdd6655-b0b5-4d1c-97a2-530937ba4863"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Polar", "[", "a", "]"}]}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"3473b166-2b48-44f5-83a0-a9094a2854ae"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"70172312-fcf2-4ed2-a76d-b68950ff2b99"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"-", "a"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"a9e4bbde-f969-4c7e-a4df-ed8f67108420"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"f79ade83-a9b9-4f65-9cfd-81a9bb7eff28"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "a"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"e9f317e9-8655-4b7b-9891-506846e30de3"],

Cell[BoxData[
 RowBox[{"Polar", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"adec90a2-9cab-492d-9030-297e11d014f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "a"}], ",", 
        RowBox[{"-", "Polar"}]}], "}"}], "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "c"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a1d1d679-60f1-45ea-83a6-da1bfb058dd2"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"3ace281a-da6c-4c00-9c0b-60265ebb80a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Polar", "[", "a", "]"}]}], "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "c"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"f6ddcb18-88a3-41ba-a501-04f33a04ac31"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"2309ba0d-dee4-416b-ab63-55ee2dd5268b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "a"}], ",", 
        RowBox[{"-", "Polar"}]}], "}"}], "\[Rule]", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"3d7a7614-1be1-4ec2-b8d9-4c4b5e1c0eb2"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"e59bc61b-1e57-4327-9860-8e01cba67bf5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Polar", "[", "a", "]"}]}], "\[Rule]", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"6c5d20b1-98ba-4a2f-af8b-972cdce9529e"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"288f79c9-3271-4ddf-be47-8b5b5da23165"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a2c6f3e3-938e-4e45-9eb5-1bb251cad6dd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"e4fbc0bf-e359-46fe-891c-732cdea6de33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c34f668-c2d5-42a7-acc4-b2ce3978b0cf"],

Cell[BoxData[
 RowBox[{"Polar", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"faf59b94-7087-4e98-aaf7-cd68c42096c5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "c"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"95c7aa20-ebd3-465d-9356-0db8d2acdb46"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"a3ea3af6-a707-48c7-8fbf-561a97697ba9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "c"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"445e0b84-8875-4235-bdf2-c520360bebee"],

Cell[BoxData[
 RowBox[{"Polar", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"4a25eeea-93e2-415c-a345-3a6aa86dc4d9"]
}, Open  ]],

Cell["We can change blocked indices:", \
"Text",ExpressionUUID->"465719e3-fd15-400c-88db-1e88808f4f5d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"LI", "[", "1", "]"}], ",", 
   RowBox[{
    RowBox[{"LI", "[", "1", "]"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c27f9ca-0456-4771-b5dd-5c2f8369ab15"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"64d2287c-906c-4583-bb0b-a617c4f9d967"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "Polar"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"5801e211-57cd-4f0c-ac0d-aaf4700a2d74"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"2054c201-a265-442e-85ad-c259f83c2512"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"Polar", "[", "1", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Polar", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"Polar", "[", "3", "]"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"27254112-8d04-4475-90f4-b020aaf9e2fc"],

Cell[BoxData[
 RowBox[{"Polar", "[", "3", 
  "]"}]], "Output",ExpressionUUID->"c8797182-902d-4ae3-a085-6a46e7207c77"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "Polar"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"156e71eb-f6bc-4e39-b558-d3dea006f8ef"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"fbb4a7dd-4aea-469a-a53b-accc268ccae4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Polar", "[", "a", "]"}]}], "\[Rule]", 
     RowBox[{"Polar", "[", "3", "]"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1da260d8-d89b-4aec-8ec3-1b61f582e2a0"],

Cell[BoxData[
 RowBox[{"Polar", "[", "3", 
  "]"}]], "Output",ExpressionUUID->"bbe880de-09b8-4c9a-9cde-7dea815d8136"]
}, Open  ]],

Cell["\<\
Study these changes. Note that both notations give consistent results; in \
particular whenever the rule changes the character of the index then the \
result also changes character with respect to the original:\
\>", "Text",ExpressionUUID->"ac74d3d0-9a10-48c2-afb9-c00f01cfcfab"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"9a066536-d974-4daa-b6ed-9f61474ca3b0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"5fb0dcd8-c932-49f6-8561-dcaab1322a19"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"9cec60f6-54f8-4dfb-981e-70dd6ee59b27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"dd1866d9-4f22-4f08-afbe-e7ad6208b029"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d8ea25f2-ed9e-42f2-9e57-00192c9ceaa5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"e5ea68ce-92c0-4e8b-8ec2-04b65927e032"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"09239397-8682-4ed9-892b-fa85696cf866"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"b89ad253-e5d3-4867-83ca-36e6dfb2b672"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d85bbdb7-0c0f-4dce-81c6-72f576d99afb"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "b", 
   "]"}]}]], "Output",ExpressionUUID->"d1d427c5-1528-4aaf-a3f8-e5859defe4c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"3db818fa-71f6-46cb-a5a9-7dd3ca21eb2a"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "b", 
   "]"}]}]], "Output",ExpressionUUID->"c678e9a5-7dee-4c9d-816b-462cb5febd00"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"6b7d5bea-c22f-483a-82a6-1481316988b9"],

Cell[BoxData[
 RowBox[{"Polar", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"946fdd33-5bb0-411a-b6ab-02280df7e735"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b748c46a-57fe-4eed-bbe1-4b98d9064208"],

Cell[BoxData[
 RowBox[{"Polar", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"c421cba7-2e7f-42bb-b89f-04e110e12b2e"]
}, Open  ]],

Cell["\<\
Rules changing a-indices into integers are always assumed not to change the \
character of the index\
\>", "Text",ExpressionUUID->"d65ab546-3d92-41c9-b142-a5ed51fdf4bf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"20f7458f-959c-417b-b932-cc9eaf8b68e6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"1382ae9f-2067-49d1-a274-a8de6f5ac2ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"cd9ea3fa-42fc-4d8c-b057-2ea778baf490"],

Cell[BoxData[
 RowBox[{"Polar", "[", "3", 
  "]"}]], "Output",ExpressionUUID->"a0b14810-8a13-488d-9e42-837bed6095af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", 
     RowBox[{"-", "3"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8c4f280d-0516-4b41-a9db-bc87e4a4f0aa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "3"}], ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"67121bf0-6ebd-4d95-8122-2420147e25cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"Polar", "[", "a", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", 
     RowBox[{"-", "3"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"cf222db3-e8e4-4310-867c-a5f6b3946cc9"],

Cell[BoxData[
 RowBox[{"Polar", "[", 
  RowBox[{"-", "3"}], 
  "]"}]], "Output",ExpressionUUID->"3e9a2c9d-586b-40bf-9375-bc5ea232095f"]
}, Open  ]],

Cell["\<\
However, the LHS of the rule must have the correct character. In these cases \
we are changing down-indices and therefore we need -a in the rules:\
\>", "Text",ExpressionUUID->"0d8f0a0c-4f40-4657-b140-b3ea804593c5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d6523c17-88c3-4272-b421-79afc8c80477"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"2a9dfc0b-953e-4dcc-aa5a-e041fb262d88"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", "3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"e496fdf5-8202-4a0e-a3de-ff9b750a20fe"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "3", 
   "]"}]}]], "Output",ExpressionUUID->"5ce3ae42-3bbf-45c2-9f4e-5e7fbc3aac5f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "3"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"37c9b1ed-f7ac-42f4-a6fc-c312963430c1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"88d7b145-9089-4c81-905f-e5d4938f1e4f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "3"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ac16b4a8-f570-4fac-be5c-1abdd7c2ea0e"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Polar", "[", 
   RowBox[{"-", "3"}], 
   "]"}]}]], "Output",ExpressionUUID->"73541811-b521-4091-be33-73dc761e927d"]
}, Open  ]],

Cell["Using rules a\[Rule]* does not work, even in the BASIS2 notation:", \
"Text",ExpressionUUID->"58dd6070-e79e-40e2-8963-d6b04a6a124f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"09116eaf-23cb-4592-a6fd-dd0fce097c6b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"a0ed4c3f-6993-44a0-88eb-a8381a1b2656"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"7a13c282-48ab-4794-9b99-161438f37d7d"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "a", 
   "]"}]}]], "Output",ExpressionUUID->"1c9f75ab-2c31-4aff-9def-1e90d2c144e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", 
     RowBox[{"-", "3"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"248c0638-0a19-4206-9384-e6b58b9ee6eb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"4e3173f5-d3bf-46c7-bcf5-fb622d49b496"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", 
     RowBox[{"-", "3"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b53200c6-41ae-4715-8127-e8762999786c"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "a", 
   "]"}]}]], "Output",ExpressionUUID->"f8194c29-0975-46bc-94d6-a73bb4d85d39"]
}, Open  ]],

Cell["That is different from a direct rule:", \
"Text",ExpressionUUID->"9929f4af-8e00-475b-8d68-7f4c8064f0c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"Polar", "[", "a", "]"}]}], "/.", 
  RowBox[{
  "a", "\[Rule]", 
   "3"}]}]], "Input",ExpressionUUID->"3d829fc5-dc7e-44a7-b459-6c7eaeee8e13"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "3", 
   "]"}]}]], "Output",ExpressionUUID->"13deba23-497a-44a1-8dee-3bb98d619902"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"Polar", "[", "a", "]"}]}], "/.", 
  RowBox[{"a", "\[Rule]", 
   RowBox[{
   "-", "3"}]}]}]], \
"Input",ExpressionUUID->"a07af7e0-af69-4394-b4f4-38caa353a923"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Polar", "[", 
   RowBox[{"-", "3"}], 
   "]"}]}]], "Output",ExpressionUUID->"0930da48-c061-4d6b-aa60-049123808ae6"]
}, Open  ]],

Cell[TextData[{
 "Note that the sign of patterns is relevant. It is actually extremely \
important to care about them because the construction Pattern[-a, Blank[]] is \
not valid in ",
 StyleBox["Mathematica:",
  FontSlant->"Italic"]
}], "Text",ExpressionUUID->"19a1ee7c-9538-4109-8c76-d58c1a89f91e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{"a_", ",", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", "b"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"cccd4468-72e9-452b-a9be-4732b32c4487"],

Cell[BoxData[
 RowBox[{"Pattern", "[", 
  RowBox[{
   RowBox[{"-", "b"}], ",", "_"}], 
  "]"}]], "Output",ExpressionUUID->"c6a93779-ce36-4595-8019-0a147d37bfc9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{
    RowBox[{"-", "a"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"29e780df-3d5b-4fee-b407-e06152a92734"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Pattern", "[", 
   RowBox[{
    RowBox[{"-", "b"}], ",", "_"}], 
   "]"}]}]], "Output",ExpressionUUID->"00913e43-d6bb-46ff-99df-bcaec16388fd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{"a_", ",", 
   RowBox[{
    RowBox[{"-", "a"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"d8028a8a-c6ef-420e-9d84-0e035223d91f"],

Cell[BoxData["a_"], \
"Output",ExpressionUUID->"f8fc9a17-c4c4-4f2c-a83c-daa40acf6abb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", "b"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"f5f784d9-84fe-42f5-8b86-eb216a045469"],

Cell[BoxData[
 RowBox[{"-", 
  "a_"}]], "Output",ExpressionUUID->"30bdfd32-5769-4755-a1d0-add780f04e62"]
}, Open  ]],

Cell["Let us now assume that the signs are correct:", \
"Text",ExpressionUUID->"c646a91e-6b56-41d7-8296-41af1cb6ec86"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{"a_", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b0f6117d-9159-4b67-a9a6-8076245fe682"],

Cell[BoxData["b_"], \
"Output",ExpressionUUID->"477a21b2-dfa8-46ef-b20f-cc79d3147f2f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"11ede4fb-f132-40b4-a720-dc5e0be4ba0c"],

Cell[BoxData[
 RowBox[{"-", 
  "c_"}]], "Output",ExpressionUUID->"04dfb710-707d-426e-a96a-d513ab57fb6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"e20788ae-256b-414a-9216-d6b47a90c7f5"],

Cell[BoxData[
 RowBox[{"-", 
  "a_"}]], "Output",ExpressionUUID->"581a0df5-3075-4a4e-8bfa-7d520b602149"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"57ef59c8-e15a-4563-a6db-d5b848b0f423"],

Cell[BoxData[
 RowBox[{"-", 
  "b_"}]], "Output",ExpressionUUID->"e00edf73-8040-4dd2-8293-fbacf7bddfa9"]
}, Open  ]],

Cell["Pattern basis-indices:", \
"Text",ExpressionUUID->"5552b857-c7df-4195-b446-82c56304c58e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a_", ",", "Polar"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"540d6afd-e3b4-47b7-a922-eea9b2499206"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b_", ",", "Polar"}], 
  "}"}]], "Output",ExpressionUUID->"23037506-6433-466f-9452-6829c19c378a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"Polar", "[", "a_", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1ac3a370-d07c-4e2c-ac3c-c735f0c29c6f"],

Cell[BoxData[
 RowBox[{"Polar", "[", "b_", 
  "]"}]], "Output",ExpressionUUID->"6d693507-9c8f-4fe3-a42e-f126479d6d11"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a_"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8c007f91-4df2-4a73-87c6-3ce71ee8f113"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "c_"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"0120eddd-ad73-4410-a1da-f9616dae8a05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a_", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"50a0fd1b-58ca-4bdd-85d1-2568e0fe3c35"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "c_", 
   "]"}]}]], "Output",ExpressionUUID->"23a80ee2-7c1f-49a4-b0db-715693846884"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a_"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1613c546-2f1c-464a-925b-70462940079a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"a267f7bf-70ec-4a4d-9250-269ec12ef44b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a_", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "b"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"789f0496-36ed-44f5-beb6-76bdfe4a4a86"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "a_", 
   "]"}]}]], "Output",ExpressionUUID->"5c67d3db-b6f5-4878-9b55-1cfff916283c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a_"}], ",", 
     RowBox[{"-", "Polar"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b913ae5b-68ce-4fb0-9e67-6a0dab956866"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "b_"}], ",", 
   RowBox[{"-", "Polar"}]}], 
  "}"}]], "Output",ExpressionUUID->"898e678c-c826-4cb4-a982-0b41dc339b14"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Polar", "[", "a_", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "a"}], "\[Rule]", 
     RowBox[{"-", "b"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"aa081fc7-3712-4513-b400-e05bb1cdc8ea"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
  "Polar", "[", "b_", 
   "]"}]}]], "Output",ExpressionUUID->"adfacc5f-ecae-4dc9-9d51-409d48d372fc"]
}, Open  ]],

Cell["\<\
If the rules do not want to change a pattern then there is no message from \
the replacement:\
\>", "Text",ExpressionUUID->"2d1155a9-9967-42d0-acb1-feaa38940045"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{"a_", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"f7974a6c-da6f-4ee6-9f6d-a4b6d9658e33"],

Cell[BoxData["a_"], \
"Output",ExpressionUUID->"6e8f2087-feb4-4e33-8761-15f120a78b43"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceOneIndex", "[", 
  RowBox[{
   RowBox[{"-", "a_"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"f54d64ea-2c38-4240-9295-a0537ae08bfe"],

Cell[BoxData[
 RowBox[{"-", 
  "a_"}]], "Output",ExpressionUUID->"db9d067c-543c-44d2-aa43-0ddacdf624f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceIndexList", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", "a_a", ",", 
     RowBox[{"-", "a_a"}], ",", 
     RowBox[{"a_a", "?", "Q"}], ",", 
     RowBox[{"-", 
      RowBox[{"a_a", "?", "Q"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"-", "a_"}], ")"}], "?", "Q"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b9deb5da-7018-4777-8a3b-9c71b89ce8bd"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "b", "\<\",\"\>", 
    RowBox[{"-", "c"}], "\<\",\"\>", "b_a", "\<\",\"\>", 
    RowBox[{"-", "c_a"}], "\<\",\"\>", 
    RowBox[{"b_a", "?", "Q"}], "\<\",\"\>", 
    RowBox[{"-", 
     RowBox[{"c_a", "?", "Q"}]}], "\<\",\"\>", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "c_"}], ")"}], "?", "Q"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`b, -$CellContext`c, 
   Pattern[$CellContext`b, 
    Blank[$CellContext`a]], -Pattern[$CellContext`c, 
     Blank[$CellContext`a]], 
   PatternTest[
    Pattern[$CellContext`b, 
     Blank[$CellContext`a]], $CellContext`Q], -PatternTest[
     Pattern[$CellContext`c, 
      Blank[$CellContext`a]], $CellContext`Q], 
   PatternTest[-Pattern[$CellContext`c, 
      Blank[]], $CellContext`Q]],
  Editable->
   False]], "Output",ExpressionUUID->"fbe7f46c-55f8-4cda-a5d9-3adfa0084202"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceIndexList", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"a", "[", "a", "]"}], "]"}]}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", "b"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"08717941-5dbb-4b89-acd8-4c6fd1808681"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "b"}], "\<\",\"\>", 
    RowBox[{"-", "a"}], "\<\",\"\>", 
    RowBox[{"Dir", "[", 
     RowBox[{"a", "[", "a", "]"}], "]"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`b, -$CellContext`a, 
   xAct`xTensor`Dir[
    $CellContext`a[$CellContext`a]]],
  Editable->
   False]], "Output",ExpressionUUID->"72b8bf44-53d2-442f-bd59-54f050101537"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "c", ",", "Polar", ",", "Q"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"3b42766f-e712-410c-95b4-a00f0e519aa1"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.2. HoldReplaceIndex", \
"Subsubsection",ExpressionUUID->"6146a1df-5fad-445c-bb7b-913e3ca04b48"],

Cell["\<\
As explained in the subsection HoldMap of section 1, we need to define two \
functions to be able to have full control on the process of evaluation. The \
internal function is called HoldReplaceIndex and returns evaluatable \
expressions wrapped with xHold. The user-function is ReplaceIndex, which is \
just a call to HoldReplaceIndex with a final ReplaceRepeated to eliminate \
xHold. The function HoldReplaceIndex holds its first argument:\
\>", "Text",ExpressionUUID->"384d2284-9c4b-454d-bf61-187cb4dbd3f9"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"HoldReplaceIndex", ",", "HoldFirst"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d12fab7c-b6b1-4c53-9df0-c7db16001428"],

Cell["Simplifying case:", \
"Text",ExpressionUUID->"9ee70e14-822d-49b6-9c76-0ad1366f19b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldReplaceIndex", "[", 
   RowBox[{"expr_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"xHold", "[", "expr", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"27f30bd3-664a-4b16-904d-ba26ea8ca37a"],

Cell["\<\
Action on known cases. It is important to note that the actual replacements \
are performed by ReplaceOneIndex, and this function is only evaluated when a \
tensor, form or covariant derivative is detected, i.e., when an expression \
with one of those heads is detected. The whole process is safe as long as \
there are no conflicts with the identities of heads.\
\>", "Text",ExpressionUUID->"b723295e-06c1-4a9c-abbc-1102075433dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Action", " ", "on", " ", "atoms"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldReplaceIndex", "[", 
     RowBox[{
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{
        "_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex", "|", 
         "_String", "|", "_Symbol"}], ")"}]}], ",", "rules_"}], "]"}], ":=", 
    RowBox[{"xHold", "[", "x", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"44b82266-3778-45f3-a285-430d6bffee71"],

Cell["\<\
We need to use ReplacePart and not just mapping ReplaceOneIndex because \
derivatives and tensors can have a HoldAll attribute, that would prevent its \
evaluation.\
\>", "Text",ExpressionUUID->"f949ed6b-2860-4f22-80e8-67dde476d1aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Action", " ", "on", " ", "derivatives"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", 
        "]"}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newcovd", "=", 
         RowBox[{"Apply", "[", 
          RowBox[{"covd", ",", 
           RowBox[{"ReplaceIndexList", "[", 
            RowBox[{
             RowBox[{"IndexList", "[", "inds", "]"}], ",", "rules"}], "]"}]}],
           "]"}]}], "}"}], ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{
         RowBox[{"xHold", "[", 
          RowBox[{"newcovd", "[", "expr", "]"}], "]"}], ",", 
         RowBox[{"HoldReplaceIndex", "[", 
          RowBox[{"expr", ",", "rules"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{"CovD", "[", 
        RowBox[{"expr_", ",", "ders__"}], "]"}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newders", "=", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ReplaceOneIndex", "[", 
              RowBox[{"#", ",", "rules"}], "]"}], "&"}], ",", 
            RowBox[{"{", "ders", "}"}], ",", 
            RowBox[{"{", "2", "}"}]}], "]"}]}]}], "}"}], ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{
         RowBox[{"xHold", "[", 
          RowBox[{"CovD", "[", 
           RowBox[{"expr", ",", "newders"}], "]"}], "]"}], ",", 
         RowBox[{"HoldReplaceIndex", "[", 
          RowBox[{"expr", ",", "rules"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
       "rules_"}], "]"}], ":=", 
     RowBox[{"ReplacePart", "[", 
      RowBox[{
       RowBox[{"xHold", "[", 
        RowBox[{
         RowBox[{"LieD", "[", "v", "]"}], "[", "expr", "]"}], "]"}], ",", 
       RowBox[{"HoldReplaceIndex", "[", 
        RowBox[{"expr", ",", "rules"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], ",", 
       "rules_"}], "]"}], ":=", 
     RowBox[{"ReplacePart", "[", 
      RowBox[{
       RowBox[{"xHold", "[", 
        RowBox[{
         RowBox[{"ParamD", "[", "ps", "]"}], "[", "expr", "]"}], "]"}], ",", 
       RowBox[{"HoldReplaceIndex", "[", 
        RowBox[{"expr", ",", "rules"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{"OverDot", "[", "expr_", "]"}], ",", "rules_"}], "]"}], ":=", 
     RowBox[{"ReplacePart", "[", 
      RowBox[{
       RowBox[{"xHold", "[", 
        RowBox[{"OverDot", "[", "expr", "]"}], "]"}], ",", 
       RowBox[{"HoldReplaceIndex", "[", 
        RowBox[{"expr", ",", "rules"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "}"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"26544a60-3746-4b03-8c63-233b3c4ffe58"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Action", " ", "on", " ", "elementary", " ", 
    RowBox[{"objects", ".", " ", "Nonindexed"}], " ", "tensors", " ", 
    "considered", " ", "below"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"HoldReplaceIndex", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"head_", "?", "xTensorQ"}], "[", "inds__", "]"}], ",", 
     "rules_"}], "]"}], ":=", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{
     RowBox[{"xHold", "[", 
      RowBox[{"head", "[", "inds", "]"}], "]"}], ",", 
     RowBox[{"ReplaceIndexList", "[", 
      RowBox[{
       RowBox[{"IndexList", "[", "inds", "]"}], ",", "rules"}], "]"}], ",", 
     RowBox[{"Thread", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"Range", "@", 
         RowBox[{"Length", "@", 
          RowBox[{"{", "inds", "}"}]}]}]}], "}"}], "]"}], ",", 
     RowBox[{"Thread", "[", 
      RowBox[{"{", 
       RowBox[{"Range", "@", 
        RowBox[{"Length", "@", 
         RowBox[{"{", "inds", "}"}]}]}], "}"}], "]"}]}], "]"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"da11ee6e-aba2-4738-b084-fe894b9953a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Change", " ", "indices", " ", "in", " ", "additional", " ", "arguments", 
    " ", "of", " ", "an", " ", "inert", " ", "head"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"changez", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{"xHold", "[", 
         RowBox[{"_", "[", "_", "]"}], "]"}]}], ",", "rules_"}], "]"}], ":=", 
     "expr"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"changez", "[", 
      RowBox[{
       RowBox[{"xHold", "[", 
        RowBox[{"ih_", "[", 
         RowBox[{"expr_", ",", "z__"}], "]"}], "]"}], ",", "rules_"}], "]"}], 
     ":=", 
     RowBox[{"changez2", "[", 
      RowBox[{
       RowBox[{"xHold", "[", 
        RowBox[{"ih", "[", 
         RowBox[{"expr", ",", "z"}], "]"}], "]"}], ",", 
       RowBox[{"Replace", "[", 
        RowBox[{
         RowBox[{"{", "z", "}"}], ",", 
         RowBox[{"list_IndexList", "\[RuleDelayed]", 
          RowBox[{"ReplaceIndexList", "[", 
           RowBox[{"list", ",", "rules"}], "]"}]}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"changez2", "[", 
      RowBox[{
       RowBox[{"xHold", "[", 
        RowBox[{"ih_", "[", 
         RowBox[{"expr_", ",", "z__"}], "]"}], "]"}], ",", 
       RowBox[{"{", "z2__", "}"}]}], "]"}], ":=", 
     RowBox[{"xHold", "[", 
      RowBox[{"ih", "[", 
       RowBox[{"expr", ",", "z2"}], "]"}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8364cf40-bac0-4a78-9428-0cb6f4853a23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Action", " ", "on", " ", "inert", " ", "heads"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldReplaceIndex", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], ",", "rules_"}], "]"}], ":=", 
    RowBox[{"changez", "[", 
     RowBox[{
      RowBox[{"ReplacePart", "[", 
       RowBox[{
        RowBox[{"xHold", "[", 
         RowBox[{"ih", "[", 
          RowBox[{"expr", ",", "z"}], "]"}], "]"}], ",", 
        RowBox[{"HoldReplaceIndex", "[", 
         RowBox[{"expr", ",", "rules"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], "}"}]}], "]"}], ",", "rules"}], 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e7ffd8fb-12f7-497c-a11d-c7cd7e302f22"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Shield", " ", "scalars"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "___", "]"}]}], ",", 
       "rules_"}], "]"}], ":=", 
     RowBox[{"xHold", "[", "expr", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{
          RowBox[{"Derivative", "[", "__Integer", "]"}], "[", 
          RowBox[{"_", "?", "ScalarFunctionQ"}], "]"}], "[", "__", "]"}]}], 
       ",", "rules_"}], "]"}], ":=", 
     RowBox[{"xHold", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HoldReplaceIndex", "[", 
      RowBox[{"expr_Scalar", ",", "rules_"}], "]"}], ":=", 
     RowBox[{"xHold", "[", "expr", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6bc3c6ac-f23f-46a3-953b-71c431f149aa"],

Cell["\<\
Now we must define recursion of HoldReplaceIndex on other expressions. First \
we deal with special cases. Note how the list of indices coming from the \
first argument of the Module construct needs to be transformed into an \
IndexList to be replaced and back to a List.\
\>", "Text",ExpressionUUID->"f969b5dc-d0e3-4735-a2d3-703a52e7a735"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Special", " ", "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"HoldReplaceIndex", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"Module", "[", 
       RowBox[{"list_List", ",", "expr_"}], "]"}], "]"}], ",", "rules_"}], 
    "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"xHold", "[", 
       RowBox[{"Module", "[", "##", "]"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"List", "@@", 
        RowBox[{"ReplaceIndexList", "[", 
         RowBox[{
          RowBox[{"IndexList", "@@", "list"}], ",", "rules"}], "]"}]}], ",", 
       RowBox[{"HoldReplaceIndex", "[", 
        RowBox[{"expr", ",", "rules"}], "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"4f289902-a6b0-4796-bdb5-d223252fff2e"],

Cell["\<\
Then we have the generic case. Recall what we said before: only when a \
tensor, form or covd is found the function ReplaceOneIndex does its job. In \
this generic definition we only find recursion towards deeper levels, looking \
for one of those objects. This is equivalent to a definition using HoldMap, \
but a bit faster. It needs some explanations:
\t- ReplacePart does not have any Hold argument, what means that we need to \
care about evaluation.
\t- We always Hold the input expression using xHold, what forces us to use \
the {1, ...} structure in the first thread.
\t- The second argument contains a list of objects where the index \
replacements have been performed.
\t- The list {elements} cannot be evaluated and therefore it must always \
appears as Unevaluated[{elements}].\
\>", "Text",ExpressionUUID->"bf008dc4-9b79-497f-adce-e2bcc71c01ec"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"HoldReplaceIndex", "[", 
   RowBox[{
    RowBox[{"head_", "[", "]"}], ",", "rules_"}], "]"}], ":=", 
  RowBox[{"head", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HoldReplaceIndex", "[", 
   RowBox[{
    RowBox[{"head_", "[", "elements__", "]"}], ",", "rules_"}], "]"}], ":=", 
  RowBox[{"ReplacePart", "[", 
   RowBox[{
    RowBox[{"xHold", "[", 
     RowBox[{"head", "[", "elements", "]"}], "]"}], ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", "x", "}"}], ",", 
        RowBox[{"HoldReplaceIndex", "[", 
         RowBox[{"x", ",", "rules"}], "]"}], ",", 
        RowBox[{"{", "HoldAll", "}"}]}], "]"}], ",", 
      RowBox[{"Unevaluated", "@", 
       RowBox[{"{", "elements", "}"}]}]}], "]"}], ",", 
    RowBox[{"Thread", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"Range", "@", 
        RowBox[{"Length", "@", 
         RowBox[{"Unevaluated", "@", 
          RowBox[{"{", "elements", "}"}]}]}]}]}], "}"}], "]"}], ",", 
    RowBox[{"Thread", "[", 
     RowBox[{"{", 
      RowBox[{"Range", "@", 
       RowBox[{"Length", "@", 
        RowBox[{"Unevaluated", "@", 
         RowBox[{"{", "elements", "}"}]}]}]}], "}"}], "]"}]}], 
   "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9c899c17-2da8-4aad-a6da-0ed2a2710f4f"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.3. ReplaceIndex", \
"Subsubsection",ExpressionUUID->"728dc7ed-d96d-439b-9681-a458acdc7e26"],

Cell["\<\
Finally we define ReplaceIndex. Note the trick: we perform the calculation \
using HoldReplaceIndex, which puts xHold everywhere. Then we wrap the \
resulting expression with Hold and eliminate the xHold heads. Finally we \
replace the Hold head with the head f:\
\>", "Text",ExpressionUUID->"fd7cb12d-52a7-46ab-9cd0-43384fdd6e80"],

Cell["\<\
ReplaceIndex is the function that actually performs the change of indices \
taking into account the type of expression. However, at this level, there is \
no check on whether the rules are consistent with the presence of a metric, \
or the action of derivatives, etc. We do not even check that indices are not \
repeatd. We just assume that the given rules are correct. There is no need to \
distinguish among the five kinds of g-indices.\
\>", "Text",ExpressionUUID->"db836a5a-c139-4dd3-b034-5411f6434c6b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ReplaceIndex"}]], \
"Input",ExpressionUUID->"db4dfae1-1f58-463e-90b9-0682bc759f79"],

Cell[BoxData[
 StyleBox["\<\"ReplaceIndex[expr, rule] replaces indices of objects in expr \
as given by rule (a single rule or a list of rules of the form i1->i2). Note \
that the rules a->b and -a->-b are independent and both must be given if this \
is what we want. ReplaceIndex[expr, {{rule1, ...}, {rule2, ...}, ...}] is \
automatically threaded, giving a list of expressions.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672477-5338953",ExpressionUUID->"32c87f44-f5f7-470d-be25-\
da4e7a3be9ff"]
}, Open  ]],

Cell["The function ReplaceIndex holds its mathinput argument:", \
"Text",ExpressionUUID->"5257d374-fbc8-4161-aa0e-d582a666395f"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ReplaceIndex", ",", "HoldFirst"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5caf092b-6328-4522-9a54-51d39a14872e"],

Cell["\<\
In ReplaceIndex rules can be a rule or a list of rules, that is \
rules:(_Rule|{(_Rule)...}). A list of lists of rules, that is \
rules:{(_List)..}, is threaded. Note that we use Repeated (..) and not \
RepeatedNull (...).\
\>", "Text",ExpressionUUID->"43593783-edbb-48c7-a408-bdc8cc445ddd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceIndex", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"rules", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", "_List", ")"}], ".."}], "}"}]}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceIndex", "[", 
      RowBox[{"expr", ",", "#", ",", "f"}], "]"}], "&"}], "/@", "rules"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"efa7b6e4-f294-410f-b5a1-0ad3333d0e57"],

Cell["Main definition:", \
"Text",ExpressionUUID->"7f246bcf-d359-4ecf-9581-0f3435157572"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplaceIndex", "[", 
   RowBox[{"expr_", ",", "rules_", ",", 
    RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
  RowBox[{"f", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{"Evaluate", "[", 
       RowBox[{"HoldReplaceIndex", "[", 
        RowBox[{"expr", ",", "rules"}], "]"}], "]"}], "]"}], "//.", 
     RowBox[{
      RowBox[{"xHold", "[", "x_", "]"}], "\[Rule]", "x"}]}], 
    ")"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3d4d876b-8668-42a1-8691-cbaba1db8247"],

Cell["\<\
We only hold the input expression, and not the rules among indices:\
\>", "Text",ExpressionUUID->"ed8d3eae-83f6-44a6-9d82-e24d22937f90"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Other", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"ReplaceIndex", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "ReplaceIndex", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"28054120-0211-49a5-95fb-b585eb975a64"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.4. Examples", \
"Subsubsection",ExpressionUUID->"0f211f0d-9561-446a-9ded-5d500e02a29a"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"24f81974-4179-4261-97ab-118b019f7309"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "T", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "a", "]"}], "^=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "CD", "]"}], "^=", "True"}], 
  ";"}]}], "Input",ExpressionUUID->"cc6da623-8689-4d41-a473-9e74ac30c541"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", "1", 
  "]"}]], "Input",ExpressionUUID->"e552d511-b320-4d4e-a60d-81b25643680d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceIndex", "::", "argr"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ReplaceIndex\\)\[NoBreak] called with 1 argument; \
\[NoBreak]\\!\\({2, 3}\\)\[NoBreak] arguments are expected.\"\>"}]], \
"Message", "MSG",ExpressionUUID->"64ce65c1-fc69-4491-91a2-798136466ee2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], 
  "]"}]], "Input",ExpressionUUID->"1e6932d7-9f5d-4138-bece-1583c7976e3d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceIndex", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ReplaceIndex\\)\[NoBreak] called with \
\[NoBreak]\\!\\(4\\)\[NoBreak] arguments; \[NoBreak]\\!\\(2\\)\[NoBreak] or \
\[NoBreak]\\!\\(3\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`ReplaceIndex::argt\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d7317f51-ee6a-4532-a6fd-10a55fde13c5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`HoldReplaceIndex", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "}"}]}], "]"}], "//", 
  "FullForm"}]], \
"Input",ExpressionUUID->"07332832-5a3d-4a64-bea7-d27e5e710e29"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"xHold", "[", "1", "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"c0b18974-6c89-4bbf-8fb6-6b8ff9eba25c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{"1", ",", 
   RowBox[{"{", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"aa0ac7b2-f7d0-470a-b0f2-78a7e3b5dc53"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"55a1c1a1-308b-4ef5-a47c-2aa0d71635b4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "a_", "]"}], ":=", 
  RowBox[{
  "T", "[", "a", 
   "]"}]}]], "Input",ExpressionUUID->"227b04f6-1f74-45b4-b8da-668f0c034467"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`HoldReplaceIndex", "[", 
   RowBox[{
    RowBox[{"a", "[", "a", "]"}], ",", 
    RowBox[{"a", "\[Rule]", "b"}]}], "]"}], "//", 
  "FullForm"}]], \
"Input",ExpressionUUID->"1ab22c80-d085-41b7-b164-f59be05205f2"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"xHold", "[", 
    RowBox[{"a", "[", "b", "]"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"6cc73f0d-afdc-4900-b3d2-fa817c88dc32"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"a", "[", "a", "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"a735c5d9-fb2e-44ed-9cd7-639657f2cb85"],

Cell[BoxData[
 RowBox[{"T", "[", "b", 
  "]"}]], "Output",ExpressionUUID->"24aa533b-21c6-427c-911f-0e696dce70dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"a", "[", "a", "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}], ",", "Hold"}], 
  "]"}]], "Input",ExpressionUUID->"d776a6e9-24a4-4d2e-98d8-13797727427c"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"a", "[", "b", "]"}], 
  "]"}]], "Output",ExpressionUUID->"0f75f336-0088-491f-bb75-be1f951b163a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"ReplaceIndex", "[", 
   RowBox[{
    RowBox[{"a", "[", "a", "]"}], ",", 
    RowBox[{"a", "\[Rule]", "b"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"cb4eb6c5-2090-4693-bf72-4aab3df2d173"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"a", "\[Rule]", "b"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"a", "\[Rule]", "b"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"ReplaceIndex", "[", 
     RowBox[{
      RowBox[{"a", "[", "a", "]"}], ",", 
      RowBox[{"a", "\[Rule]", "b"}]}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"Identity", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"xAct`xTensor`Private`HoldReplaceIndex", "[", 
          RowBox[{
           RowBox[{"a", "[", "a", "]"}], ",", 
           RowBox[{"a", "\[Rule]", "b"}]}], "]"}], "]"}], "]"}], "//.", 
       "\[VeryThinSpace]", 
       RowBox[{
        TagBox["\<\"xAct`xTensor`Private`x_\"\>",
         DisplayForm], "\[Rule]", "xAct`xTensor`Private`x"}]}], ")"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"xAct`xTensor`Private`HoldReplaceIndex", "[", 
           RowBox[{
            RowBox[{"a", "[", "a", "]"}], ",", 
            RowBox[{"a", "\[Rule]", "b"}]}], "]"}],
          HoldForm], ",", 
         RowBox[{"{", 
          RowBox[{
           TagBox[
            RowBox[{"xTensorQ", "[", "a", "]"}],
            HoldForm], ",", 
           TagBox["True",
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            TagBox[
             RowBox[{"a", "[", "a", "]"}],
             DisplayForm], ",", 
            RowBox[{"xAct`xTensor`Private`ReplaceIndexList", "[", 
             RowBox[{
              InterpretationBox[
               StyleBox[
                RowBox[{
                 StyleBox["{",
                  FontColor->RGBColor[0, 0, 1]], "a", 
                 StyleBox["}",
                  FontColor->RGBColor[0, 0, 1]]}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               xAct`xTensor`IndexList[$CellContext`a],
               Editable->False], ",", 
              RowBox[{"a", "\[Rule]", "b"}]}], "]"}], ",", 
            RowBox[{"Thread", "[", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"Range", "[", 
                RowBox[{"Length", "[", 
                 RowBox[{"{", "a", "}"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
            RowBox[{"Thread", "[", 
             RowBox[{"{", 
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", 
                RowBox[{"{", "a", "}"}], "]"}], "]"}], "}"}], "]"}]}], "]"}],
          HoldForm], ",", 
         RowBox[{"{", 
          RowBox[{
           TagBox[
            RowBox[{"xAct`xTensor`Private`ReplaceIndexList", "[", 
             RowBox[{
              InterpretationBox[
               StyleBox[
                RowBox[{
                 StyleBox["{",
                  FontColor->RGBColor[0, 0, 1]], "a", 
                 StyleBox["}",
                  FontColor->RGBColor[0, 0, 1]]}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               xAct`xTensor`IndexList[$CellContext`a],
               Editable->False], ",", 
              RowBox[{"a", "\[Rule]", "b"}]}], "]"}],
            HoldForm], ",", 
           TagBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"xAct`xTensor`Private`ReplaceOneIndex", "[", 
                RowBox[{"#1", ",", 
                 RowBox[{"a", "\[Rule]", "b"}]}], "]"}], "&"}], ")"}], "/@", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                StyleBox["{",
                 FontColor->RGBColor[0, 0, 1]], "a", 
                StyleBox["}",
                 FontColor->RGBColor[0, 0, 1]]}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              xAct`xTensor`IndexList[$CellContext`a],
              Editable->False]}],
            HoldForm], ",", 
           TagBox[
            InterpretationBox[
             StyleBox[
              RowBox[{
               StyleBox["{",
                FontColor->RGBColor[0, 0, 1]], "b", 
               StyleBox["}",
                FontColor->RGBColor[0, 0, 1]]}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xTensor`IndexList[
              (
              xAct`xTensor`Private`ReplaceOneIndex[#, $CellContext`a -> \
$CellContext`b]& )[$CellContext`a]],
             Editable->False],
            HoldForm], ",", 
           RowBox[{"{", 
            RowBox[{
             TagBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"xAct`xTensor`Private`ReplaceOneIndex", "[", 
                  RowBox[{"#1", ",", 
                   RowBox[{"a", "\[Rule]", "b"}]}], "]"}], "&"}], ")"}], "[", 
               "a", "]"}],
              HoldForm], ",", 
             TagBox[
              RowBox[{"xAct`xTensor`Private`ReplaceOneIndex", "[", 
               RowBox[{"a", ",", 
                RowBox[{"a", "\[Rule]", "b"}]}], "]"}],
              HoldForm], ",", 
             TagBox[
              RowBox[{"Replace", "[", 
               RowBox[{"a", ",", 
                RowBox[{"a", "\[Rule]", "b"}]}], "]"}],
              HoldForm], ",", 
             TagBox["b",
              HoldForm]}], "}"}], ",", 
           TagBox[
            InterpretationBox[
             StyleBox[
              RowBox[{
               StyleBox["{",
                FontColor->RGBColor[0, 0, 1]], "b", 
               StyleBox["}",
                FontColor->RGBColor[0, 0, 1]]}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xTensor`IndexList[$CellContext`b],
             Editable->False],
            HoldForm]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 TagBox[
                  RowBox[{"Length", "[", 
                   RowBox[{"{", "a", "}"}], "]"}],
                  HoldForm], ",", 
                 TagBox["1",
                  HoldForm]}], "}"}], ",", 
               TagBox[
                RowBox[{"Range", "[", "1", "]"}],
                HoldForm], ",", 
               TagBox[
                RowBox[{"{", "1", "}"}],
                HoldForm]}], "}"}], ",", 
             TagBox[
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"{", "1", "}"}]}], "}"}],
              HoldForm]}], "}"}], ",", 
           TagBox[
            RowBox[{"Thread", "[", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"{", "1", "}"}]}], "}"}], "]"}],
            HoldForm], ",", 
           TagBox[
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], "}"}],
            HoldForm]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 TagBox[
                  RowBox[{"Length", "[", 
                   RowBox[{"{", "a", "}"}], "]"}],
                  HoldForm], ",", 
                 TagBox["1",
                  HoldForm]}], "}"}], ",", 
               TagBox[
                RowBox[{"Range", "[", "1", "]"}],
                HoldForm], ",", 
               TagBox[
                RowBox[{"{", "1", "}"}],
                HoldForm]}], "}"}], ",", 
             TagBox[
              RowBox[{"{", 
               RowBox[{"{", "1", "}"}], "}"}],
              HoldForm]}], "}"}], ",", 
           TagBox[
            RowBox[{"Thread", "[", 
             RowBox[{"{", 
              RowBox[{"{", "1", "}"}], "}"}], "]"}],
            HoldForm], ",", 
           TagBox[
            RowBox[{"{", 
             RowBox[{"{", "1", "}"}], "}"}],
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            TagBox[
             RowBox[{"a", "[", "a", "]"}],
             DisplayForm], ",", 
            InterpretationBox[
             StyleBox[
              RowBox[{
               StyleBox["{",
                FontColor->RGBColor[0, 0, 1]], "b", 
               StyleBox["}",
                FontColor->RGBColor[0, 0, 1]]}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xTensor`IndexList[$CellContext`b],
             Editable->False], ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", "1", "}"}], "}"}]}], "]"}],
          HoldForm], ",", 
         TagBox[
          TagBox[
           RowBox[{"a", "[", "b", "]"}],
           DisplayForm],
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"Hold", "[", 
         TagBox[
          RowBox[{"a", "[", "b", "]"}],
          DisplayForm], "]"}],
        HoldForm]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{
         TagBox["\<\"xAct`xTensor`Private`x_\"\>",
          DisplayForm], "\[Rule]", "xAct`xTensor`Private`x"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{
         TagBox["\<\"xAct`xTensor`Private`x_\"\>",
          DisplayForm], "\[Rule]", "xAct`xTensor`Private`x"}],
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{
       RowBox[{"Hold", "[", 
        TagBox[
         RowBox[{"a", "[", "b", "]"}],
         DisplayForm], "]"}], "//.", "\[VeryThinSpace]", 
       RowBox[{
        TagBox["\<\"xAct`xTensor`Private`x_\"\>",
         DisplayForm], "\[Rule]", "xAct`xTensor`Private`x"}]}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"Hold", "[", 
       RowBox[{"a", "[", "b", "]"}], "]"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"Identity", "@@", 
     RowBox[{"Hold", "[", 
      RowBox[{"a", "[", "b", "]"}], "]"}]}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"Identity", "[", 
     RowBox[{"a", "[", "b", "]"}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"a", "[", "b", "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"T", "[", "b", "]"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"Identity", "[", 
     RowBox[{"T", "[", "b", "]"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"T", "[", "b", "]"}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"c4510ee2-1602-4ffe-b8d7-8234e1cf262a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{"F", "[", 
   RowBox[{"x", ",", "y"}], 
   "]"}]}]], "Input",ExpressionUUID->"6144df1c-d48f-4df0-b9d1-b59ee9658a21"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "+", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}], ")"}]}], 
   ")"}]}]], "Input",ExpressionUUID->"9ab5e8c3-6410-47c3-b6ad-5a0f44e5298f"],

Cell[BoxData[
 RowBox[{"4", " ", 
  RowBox[{"F", "[", 
   RowBox[{"a", ",", "b"}], 
   "]"}]}]], "Output",ExpressionUUID->"aa2117d8-c8a4-48c3-a1b7-3d03a5f2ac8e"]
}, Open  ]],

Cell["Note that T is a tensor, but F is not:", \
"Text",ExpressionUUID->"474ccb6c-1392-4ab3-944c-40cee9d93090"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"4", 
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "c"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c3c83ee5-aa0e-4a91-b2d1-6a5c8534511f"],

Cell[BoxData[
 RowBox[{"4", " ", 
  RowBox[{"F", "[", 
   RowBox[{"c", ",", "b"}], 
   "]"}]}]], "Output",ExpressionUUID->"ec589dc8-e888-4f56-a7f9-e41b1c646fb3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"4", 
    RowBox[{"F", "[", 
     RowBox[{"a", ",", "b"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "c"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"34e9876d-ef17-4e50-98a4-abda7e01a4fc"],

Cell[BoxData[
 RowBox[{"4", " ", 
  RowBox[{"F", "[", 
   RowBox[{"a", ",", "b"}], 
   "]"}]}]], "Output",ExpressionUUID->"a33ea026-b759-46f6-8762-b6183372c54e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"a", ",", "b"}], "]"}], "+", 
        RowBox[{"T", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "c"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4a527a7c-5785-4071-ba6d-f9632b846e6c"],

Cell[BoxData[
 RowBox[{"4", " ", 
  RowBox[{"F", "[", 
   RowBox[{"c", ",", "b"}], 
   "]"}]}]], "Output",ExpressionUUID->"e526ed8b-85c4-4132-8f72-e6b568fac232"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"a", ",", "b"}], "]"}], "+", 
        RowBox[{"T", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "c"}], "}"}], ",", "Hold"}], 
  "]"}]], "Input",ExpressionUUID->"10ae3a39-985f-4e83-a3a5-f835352ea967"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"c", ",", "b"}], "]"}], "+", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"c", ",", "b"}], "]"}], "+", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"c", ",", "b"}], "]"}], "+", 
       RowBox[{"T", "[", 
        RowBox[{"c", ",", "b"}], "]"}]}], ")"}]}], ")"}]}], 
  "]"}]], "Output",ExpressionUUID->"6875ae5a-e433-4529-8c8e-87cd67a4af8f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"RuleDelayed", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "c"}]}], 
  "]"}]], "Input",ExpressionUUID->"7adb7b08-f1a4-4e0a-9295-e55a5b4d9470"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"F", "[", 
    RowBox[{"c", ",", "b"}], "]"}]}], "\[RuleDelayed]", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"c", ",", "b"}], "]"}], "+", 
   RowBox[{"T", "[", 
    RowBox[{"c", ",", "b"}], 
    "]"}]}]}]], \
"Output",ExpressionUUID->"2a01937e-3f82-417e-92f8-aab44e3edf78"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Rule", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "c"}]}], 
  "]"}]], "Input",ExpressionUUID->"104fc1fe-2918-42f5-814f-afab80bb461a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"F", "[", 
    RowBox[{"c", ",", "b"}], "]"}]}], "\[Rule]", 
  RowBox[{"2", " ", 
   RowBox[{"F", "[", 
    RowBox[{"c", ",", "b"}], 
    "]"}]}]}]], \
"Output",ExpressionUUID->"f890a18a-735a-4997-a95e-93ce939b98c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a_", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"a_", "?", "Q"}]}], ",", "b"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}], ",", "Hold"}], 
  "]"}]], "Input",ExpressionUUID->"2ee0bf80-ada3-4b16-a0bd-2fb2ac753a56"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"c", ",", "b"}], "}"}], ",", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"c_", ",", "b"}], "]"}], "+", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"d_", "?", "Q"}]}], ",", "b"}], "]"}]}]}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"221e38d1-6d60-4cf5-b734-7d69c3d728f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a_", ",", "b"}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"a_", "?", "Q"}]}], ",", "b"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"66fb6a3d-b127-47ae-8a11-ec5fd19e7f37"],

Cell[BoxData[
 RowBox[{
  RowBox[{"F", "[", 
   RowBox[{"c$73316_", ",", "b$73316"}], "]"}], "+", 
  RowBox[{"F", "[", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"d_", "?", "Q"}]}], ",", "b$73316"}], 
   "]"}]}]], "Output",ExpressionUUID->"36afe224-4de8-46f1-a098-d0ad575335a6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`HoldReplaceIndex", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Cd", "[", "a", "]"}], "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "a"}], "]"}], "[", 
      RowBox[{"a", "[", 
       RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
    RowBox[{"a", "\[Rule]", "b"}]}], "]"}], "//", 
  "FullForm"}]], \
"Input",ExpressionUUID->"305af740-9867-485b-acbf-cc3ef689c5b6"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"xHold", "[", 
    RowBox[{
     RowBox[{"Cd", "[", "a", "]"}], "[", 
     RowBox[{"xHold", "[", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "a"}], "]"}], "]"}], "[", 
       RowBox[{"xHold", "[", 
        RowBox[{"a", "[", 
         RowBox[{"b", ",", "c"}], "]"}], "]"}], "]"}], "]"}], "]"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"960b11ee-fd0d-43b6-84d5-b5278c2e612d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cd", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"77c50c72-fd6f-405d-b73c-4eebb53d26b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{"a", ",", "c"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"2fc982d9-b5f1-4962-8cd1-72473375023b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cd", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"32c5e7cb-1dfc-4755-a18e-41e94901901a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{"b", ",", "c"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"9959ca49-8032-4060-a4da-2c4b599a641f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cd", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "b"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"3caf21e1-338f-48d8-9ac7-0c5ceab6222f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "b"}], "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{"b", ",", "c"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"f4e0a76a-c279-439c-9b53-c484afd908c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", "b"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"3713fd48-d795-42cd-84c5-2722fdc28453"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", 
   RowBox[{"-", "b"}], "]"}], "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", "c"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"08fda345-1d5e-45e0-86ec-3808a7f03c39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"-", "a"}], "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"6a9a5169-9d95-474f-ae63-67c1bb6cb1ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", "a", "]"}], "[", 
  RowBox[{
   RowBox[{"CD", "[", "b", "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{"a", ",", "c"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"593e2d01-792c-4a78-a5b4-1825107e19d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"a", " ", 
    RowBox[{
     RowBox[{"CD", "[", "a", "]"}], "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "a"}], "]"}], "[", 
      RowBox[{"a", "[", 
       RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}]}], ",", 
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", "b"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"696895b9-b97f-42f7-8108-451df8903bb9"],

Cell[BoxData[
 RowBox[{"a", " ", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "b"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "a"}], "]"}], "[", 
    RowBox[{"a", "[", 
     RowBox[{
      RowBox[{"-", "b"}], ",", "c"}], "]"}], "]"}], 
   "]"}]}]], "Output",ExpressionUUID->"4f24384d-50cc-4100-94f7-164e614a4ec6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", 
      RowBox[{"-", "b"}]}], ",", 
     RowBox[{"c", "\[Rule]", "a"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c606b917-5e2e-4d6d-971a-7f38d580cf6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", 
   RowBox[{"-", "b"}], "]"}], "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"d93b5ed9-7a10-4436-873a-f723ca211a88"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", "a", "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", ",", "c"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "\[Rule]", 
        RowBox[{"-", "b"}]}], ",", 
       RowBox[{"c", "\[Rule]", "a"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "\[Rule]", 
        RowBox[{"-", "d"}]}], ",", 
       RowBox[{"c", "\[Rule]", "d"}]}], "}"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"08c91165-be89-4892-be13-360acbe0f331"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "b"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "d"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"-", "d"}], ",", "d"}], "]"}], "]"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"b9b5e446-1a7a-405b-a40d-7c20c9990bb8"]
}, Open  ]],

Cell["Multiple-index derivatives:", \
"Text",ExpressionUUID->"ffe0a0ce-dbc9-4a22-8b3d-4a029275ebfa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}], "[", 
    RowBox[{"a", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"e8a8218f-38ad-43c6-9d9c-e5e14d0cd359"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", 
   RowBox[{
    RowBox[{"-", "c"}], ",", 
    RowBox[{"-", "d"}]}], "]"}], "[", 
  RowBox[{"a", "[", 
   RowBox[{"a", ",", "b"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"742c1105-e51d-4f4b-9ba8-ec6334c3b1f5"]
}, Open  ]],

Cell["\<\
We must be careful with Lie derivatives. Indices in the heads are not replaced\
\>", "Text",ExpressionUUID->"5267186e-3a62-46bb-858f-135a5b9fe5b0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"a", "[", "a", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"a", "[", "a", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "a"}], "]"}], "[", 
      RowBox[{"a", "[", "a", "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}], ",", "Hold"}], 
  "]"}]], "Input",ExpressionUUID->"8313bfa8-87de-4056-abc2-9259de45a3e8"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"a", "[", "a", "]"}], "]"}], "[", 
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"a", "[", "a", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"a", "[", "b", "]"}], "]"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"8d50130b-0508-44f9-9f69-6b2032727ada"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"a", "[", "a", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"a", "[", "a", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "a"}], "]"}], "[", 
      RowBox[{"a", "[", "a", "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"11b34b95-89ca-416b-a848-06b84f1cf06e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{"T", "[", "a", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"T", "[", "a", "]"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "a"}], "]"}], "[", 
    RowBox[{"T", "[", "b", "]"}], "]"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"06d8a816-8ec2-4f2c-a8e8-648f431c6009"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "b"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4bcf2591-3059-479a-87d1-5bde6b3d2854"],

Cell[BoxData[
 RowBox[{"a", "[", 
  RowBox[{"b", ",", 
   RowBox[{"-", "b"}]}], 
  "]"}]], "Output",ExpressionUUID->"c9987d59-8686-4007-a725-47f3f1592209"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{
      RowBox[{"a", "[", "a", "]"}], ",", 
      RowBox[{"a", "[", "c", "]"}]}], "]"}], "[", "a", "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"b184b54b-ee5d-4174-834f-6d1df3336f95"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bracket", "[", 
   RowBox[{
    RowBox[{"T", "[", "a", "]"}], ",", 
    RowBox[{"T", "[", "c", "]"}]}], "]"}], "[", "a", 
  "]"}]], "Output",ExpressionUUID->"f8d48225-dacb-4568-a264-a36c02569951"]
}, Open  ]],

Cell["ScalarFunctions (shielding):", \
"Text",ExpressionUUID->"2c95c838-2069-4d45-880f-4fd4c0ad527b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Power", "[", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{"a", ",", 
       RowBox[{"-", "a"}]}], "]"}], ",", "3"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "b"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "b"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"0ed7f5f8-22fe-4919-aaf3-ea313044528d"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"a", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}]}], "]"}], 
  "3"]], "Output",ExpressionUUID->"0350d035-5d4a-4134-a073-a4efd59b1992"]
}, Open  ]],

Cell["Delayed rules:", \
"Text",ExpressionUUID->"8c37ab5f-034e-4384-a77d-61e9ec417b89"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SomeHead", "[", "x__", "]"}], ":=", 
  RowBox[{
  "OtherHead", "[", "x", 
   "]"}]}]], "Input",ExpressionUUID->"68a2641a-04dc-494a-8041-9bfdc3d1f89c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"b", ",", 
      RowBox[{"-", "b"}]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"SomeHead", "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "a"}], "]"}], "[", 
      RowBox[{"a", "[", 
       RowBox[{"b", ",", 
        RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d120ed79-99b3-4f87-b932-298956b874f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "c"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"SomeHead", "[", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "d"}], "]"}], "[", 
    RowBox[{"a", "[", 
     RowBox[{"c", ",", 
      RowBox[{"-", "c"}], ",", "d"}], "]"}], "]"}], 
   "]"}]}]], "Output",ExpressionUUID->"f71f2888-11d4-4b53-acec-16e9a6931a78"]
}, Open  ]],

Cell["with Module constructs:", \
"Text",ExpressionUUID->"59050a6b-6492-4722-9a95-514e0cde09a0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"b", ",", 
      RowBox[{"-", "b"}]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{"a", "[", 
        RowBox[{"b", ",", 
         RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1a61172a-8b6e-4365-bbcb-2fddc69bdc42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "c"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "c", "}"}], ",", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "d"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"c", ",", 
       RowBox[{"-", "c"}], ",", "d"}], "]"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"823aa561-050d-48e7-bca4-e9b0c202cb2e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"a", "[", 
      RowBox[{"b", ",", 
       RowBox[{"-", "b"}]}], "]"}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{"a", "[", 
        RowBox[{"b", ",", 
         RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ef293cb8-2d35-4883-b308-429a6770f0cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   RowBox[{"a", "[", 
    RowBox[{"c", ",", 
     RowBox[{"-", "c"}]}], "]"}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "c", "}"}], ",", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "d"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"c", ",", 
       RowBox[{"-", "c"}], ",", "d"}], "]"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"76a428ef-0baf-4ff6-b06e-c8439b003300"]
}, Open  ]],

Cell["\<\
They are dealt with specifically. Note the list of dummies in the previous \
case and compare with\
\>", "Text",ExpressionUUID->"f8085c5a-21d4-4f52-a6df-fa05d902620b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"b", ",", 
      RowBox[{"-", "b"}]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"SomeHead", "[", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{"a", "[", 
        RowBox[{"b", ",", 
         RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"db2ec07a-3e3a-4da0-ac35-848b0c10f047"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "c"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"SomeHead", "[", 
   RowBox[{
    RowBox[{"{", "b", "}"}], ",", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "d"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"c", ",", 
       RowBox[{"-", "c"}], ",", "d"}], "]"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"f50f8bee-7e51-409e-a6b6-2c2ea8c9b55b"]
}, Open  ]],

Cell["Note the differences between using Rule and RuleDelayed.", \
"Text",ExpressionUUID->"5c4adb29-9195-4db6-a613-56549f235aa9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"b", ",", 
      RowBox[{"-", "b"}]}], "]"}], "\[Rule]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{"a", "[", 
        RowBox[{"b", ",", 
         RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"5b656c13-995f-4d0f-80ae-21c19812bea9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "c"}]}], "]"}], "\[Rule]", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "d"}], "]"}], "[", 
   RowBox[{"a", "[", 
    RowBox[{"c$73319", ",", 
     RowBox[{"-", "c$73319"}], ",", "d"}], "]"}], 
   "]"}]}]], "Output",ExpressionUUID->"d8d70e4c-a78a-4db6-a9de-f3eab1c3310d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"b", ",", 
      RowBox[{"-", "b"}]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{"a", "[", 
        RowBox[{"b", ",", 
         RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"569b267d-471c-4bb3-9866-e5ac0e45b0cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "c"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "c", "}"}], ",", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "d"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"c", ",", 
       RowBox[{"-", "c"}], ",", "d"}], "]"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"2063012d-5e0e-4f24-8ed7-ea2accb88347"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"b", ",", 
      RowBox[{"-", "b"}]}], "]"}], "\[Rule]", 
    RowBox[{"SomeHead", "[", 
     RowBox[{
      RowBox[{"{", "b", "}"}], ",", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{"a", "[", 
        RowBox[{"b", ",", 
         RowBox[{"-", "b"}], ",", "a"}], "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "c"}], ",", 
     RowBox[{
      RowBox[{"-", "b"}], "\[Rule]", 
      RowBox[{"-", "c"}]}], ",", 
     RowBox[{"a", "\[Rule]", "d"}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", 
      RowBox[{"-", "d"}]}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"193f7073-f0f0-451d-ae26-8884cf4dd271"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "c"}]}], "]"}], "\[Rule]", 
  RowBox[{"OtherHead", "[", 
   RowBox[{
    RowBox[{"{", "b", "}"}], ",", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "d"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"c", ",", 
       RowBox[{"-", "c"}], ",", "d"}], "]"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"89c708c9-2af2-4e80-a6f6-3f38620b5b12"]
}, Open  ]],

Cell["\<\
Involved constructions. Even totally forbidden constructions:\
\>", "Text",ExpressionUUID->"f0fa5c45-2685-469d-abc3-e8844cb0c2db"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", "x", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"a", ",", "c_"}], "]"}]}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"59c16119-2bb0-46b3-ab67-16f294c59248"],

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{"T", "[", 
    RowBox[{"b", ",", "c_"}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"cc610799-ebbf-4c33-8fe8-5e07c8679bfe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", "x", "}"}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"a_", ",", "k"}], "]"}], "+", 
      RowBox[{"Hold", "[", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"T", "[", 
          RowBox[{"a", ",", "c_"}], "]"}]}], "]"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"a", "\[Rule]", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"2d2112a0-b784-47d0-bc49-52c59530b1dd"],

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"b_", ",", "k"}], "]"}], "+", 
    RowBox[{"Hold", "[", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"b", ",", "c_"}], "]"}]}], "]"}], "]"}]}]}], 
  "]"}]], "Output",ExpressionUUID->"bb15a94f-ccb9-45a8-a4ce-fab270fefab3"]
}, Open  ]],

Cell["\<\
The replacement of indices can lead to inconsistent situations if the rules \
are not mathematically valid. For example, assume that the defined covariant \
derivative CD is not associated to the metric of a bundle. Then the following \
replacement is invalid:\
\>", "Text",ExpressionUUID->"b0062fc0-fe7a-4ad2-9f4c-58d77283c1d2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", "a", "]"}], 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"a", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", 
      RowBox[{"-", "a"}]}], ",", 
     RowBox[{
      RowBox[{"-", "a"}], "\[Rule]", "a"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"5f19bf82-4a6f-4ce5-abcb-6e8fd7077637"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"-", "a"}], "]"}], " ", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "b"}], "]"}], "[", 
   RowBox[{"T", "[", "a", "]"}], 
   "]"}]}]], "Output",ExpressionUUID->"e3ca39cf-568a-49c4-a89a-18afe4d10cb1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "CD", "]"}], "^=", "False"}], 
  ";"}]], "Input",ExpressionUUID->"1afe83d7-a181-4bd0-a39e-1f8189b43cf1"],

Cell["Series:", "Text",ExpressionUUID->"4728c5fb-886f-4207-bea3-323eb2307a16"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], "x"}], "+", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
   RowBox[{"x", "^", "2"}]}], "+", 
  RowBox[{
   RowBox[{"O", "[", "x", "]"}], "^", 
   "3"}]}]], "Input",ExpressionUUID->"06a3291a-793b-43e3-a265-5eb2ce2381af"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b", ",", "c"}], "]"}], " ", "x"}], "+", 
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"a", ",", "b", ",", "c"}], "]"}], " ", 
    SuperscriptBox["x", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {
    $CellContext`T[$CellContext`a, $CellContext`b, $CellContext`c], 
    $CellContext`a[$CellContext`a, $CellContext`b, $CellContext`c]}, 1, 3, 1],
  
  Editable->
   False]], "Output",ExpressionUUID->"7491c0bd-c11f-470b-9536-3a5064fd2b36"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", "%", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "d"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"77be65a7-74d6-4bed-a5f7-7aceb14fcdde"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"d", ",", "b", ",", "c"}], "]"}], " ", "x"}], "+", 
   RowBox[{
    RowBox[{"a", "[", 
     RowBox[{"d", ",", "b", ",", "c"}], "]"}], " ", 
    SuperscriptBox["x", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "x", "]"}], "3"],
    SeriesData[$CellContext`x, 0, {}, 1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`x, 0, {
    $CellContext`T[$CellContext`d, $CellContext`b, $CellContext`c], 
    $CellContext`a[$CellContext`d, $CellContext`b, $CellContext`c]}, 1, 3, 1],
  
  Editable->
   False]], "Output",ExpressionUUID->"56b61295-bc7d-4483-8672-a2592f62274f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{
  "a", ",", "b", ",", "\"\<b$*\>\"", ",", "c", ",", "Cd", ",", "CD", ",", 
   "\"\<c$*\>\"", ",", "d", ",", "F", ",", "k", ",", "OtherHead", ",", "Q", 
   ",", "SomeHead", ",", "T", ",", "x", ",", "y"}], "]"}], "\n", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"9bb98c04-c059-4695-8a97-512d541b7ed3"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.5. ReplaceDummies, SameDummies", \
"Subsubsection",ExpressionUUID->"fa1cee88-cc45-409c-a857-394ad23346e2"],

Cell["\<\
Here we first find the dummy indices of an expression and construct new \
(dollar) dummies to replace the former. There is an important question: both \
sets must be sorted somehow, so that we replace sorted dummies by sorted \
newdummies. If we have one term the situation is simple and evident. If we \
have several terms we must have the same newdummies for all terms of an \
expression.\
\>", "Text",ExpressionUUID->"8cc6ffd1-0fef-4ce2-a6f7-eaee960b5e7f"],

Cell["\<\
0) We can define a fast replacing function which simply adds new $'s to the \
dummies. This is a private function and right now it is not being used. \
Perhaps this could be used as a faster replacement for ReplaceDummies when \
the second argument is empty.\
\>", "Text",ExpressionUUID->"2a1b501c-6d8e-496c-8706-992a17723ef9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FastReplaceDummies"}]], \
"Input",ExpressionUUID->"1a704b6f-97ec-4a09-ab01-f0fb19d045fe"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672482-5338953",ExpressionUUID->"3dbf8bd2-37d5-4157-a2d2-\
a58756748d00"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FastReplaceDummies", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FastReplaceDummies", "[", "expr_", "]"}], ":=", 
  RowBox[{"Module", "@@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Union", "[", 
      RowBox[{"IndexName", "/@", 
       RowBox[{"FindDummyIndices", "[", "expr", "]"}]}], "]"}], ",", 
     RowBox[{"Unevaluated", "[", "expr", "]"}]}], "}"}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3ecad220-acc6-4922-99d8-d38c78f8af52"],

Cell["\<\
1a) The function ReplaceDummies just generates new indices and distribute \
them among the terms of the expression. It is not defined on Module \
constructs, but a function ReplaceDummiesInModule will be defined below to \
solve that particular point. The list newdummies is always a list of abstract \
up-indices.\
\>", "Text",ExpressionUUID->"c8434c4b-8b5f-437f-ba92-dec3e61c438d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ReplaceDummies"}]], \
"Input",ExpressionUUID->"f70fb453-92ae-4152-8b10-79146cead6f3"],

Cell[BoxData[
 StyleBox["\<\"ReplaceDummies[expr] replaces dummy indices in expr by new \
(dollar-) dummy indices. ReplaceDummies[expr, inds] chooses new indices from \
inds before starting generation of new indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672484-5338953",ExpressionUUID->"159e0300-561e-48b6-8324-\
540ae8a79a23"]
}, Open  ]],

Cell["\<\
QUESTION: On March 4, 2010 I change MathInputExpand[expr] to simply expr in \
the first argument of the call to ReplaceDummies2 in the next two lines, \
because I don't understand why it is there. This is a potentially dangerous \
change, in the sense that it could lead to different-looking results, though \
still correct.\
\>", "Text",ExpressionUUID->"3b8888a7-9f05-4c0f-9889-b2ccd70e9139"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceDummies", "[", 
    RowBox[{
     RowBox[{"expr_", "?", "NonIndexedScalarQ"}], ",", "_"}], "]"}], ":=", 
   "expr"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceDummies", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"newdummies_IndexList", ":", 
      RowBox[{"IndexList", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"ReplaceDummies2", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"dummypool", "[", 
      RowBox[{"newdummies", ",", 
       RowBox[{"FindFreeAndDummyIndices", "[", "expr", "]"}]}], "]"}]}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6c853b96-ef1e-49de-815f-8ba987beb09c"],

Cell["\<\
The function dummypool returns the list of possible dummies to use. It takes \
into account the value of the global variable $ComputeNewDummies and also the \
fact the free indices of the expression cannot be used as dummies.\
\>", "Text",ExpressionUUID->"fbc9e21e-d3df-4d9e-af94-339986cbb97d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$ComputeNewDummies", "=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dummypool", "[", 
    RowBox[{"newdummies_IndexList", ",", 
     RowBox[{"{", 
      RowBox[{"frees_IndexList", ",", "dummies_IndexList"}], "}"}]}], "]"}], ":=", 
   RowBox[{"DeleteDuplicates", "@", 
    RowBox[{"DeleteCases", "[", 
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"IndexName", "/@", "newdummies"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"$ComputeNewDummies", ",", 
          RowBox[{"DummyIn", "/@", 
           RowBox[{"VBundleOfIndex", "/@", "dummies"}]}], ",", 
          RowBox[{"IndexList", "[", "]"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"Alternatives", "@@", 
       RowBox[{"(", 
        RowBox[{"IndexName", "/@", "frees"}], ")"}]}]}], "]"}]}]}], 
  ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"d5de908e-21f0-42c4-bbcc-2524c296b595"],

Cell["\<\
New code for the previous cell. Now we return the result of dummypool sorted \
(with Sort, via Complement). Note that we could have Join[ Complement[ \
newdummies, frees], DummyIn/@dummies], but the way we do it is a bit safer, \
though a bit slower :\
\>", "Text",ExpressionUUID->"7a12cbb8-8910-4f69-9564-d932e630f265"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$ComputeNewDummies", "=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dummypool", "[", 
    RowBox[{"newdummies_IndexList", ",", 
     RowBox[{"{", 
      RowBox[{"frees_IndexList", ",", "dummies_IndexList"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Complement", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"IndexName", "/@", "newdummies"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{"$ComputeNewDummies", ",", 
         RowBox[{"DummyIn", "/@", 
          RowBox[{"VBundleOfIndex", "/@", "dummies"}]}], ",", 
         RowBox[{"IndexList", "[", "]"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"IndexName", "/@", "frees"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a5e28ea3-fa0e-4532-ba72-bbb6113e7cad"],

Cell["\<\
Note that dummypool generates more indices than needed, I mean, more than the \
number of indices in the list dummies.\
\>", "Text",ExpressionUUID->"2a4ebff9-c1ff-4b56-a89b-74a93c96be94"],

Cell["\<\
1b) The function SameDummies sorts (with Union, not \
DeleteDuplicates@*IndexSort) the dummies and reuses them.\
\>", "Text",ExpressionUUID->"16ed5d7d-924a-48dc-be44-98088031a86e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SameDummies"}]], \
"Input",ExpressionUUID->"50e38498-1c33-46d3-924a-efe480b621a0"],

Cell[BoxData[
 StyleBox["\<\"SameDummies[expr] returns expr minimizing the number of \
different dummies used among the summands of the expr. No new dummy is \
introduced.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672485-5338953",ExpressionUUID->"f3c295e3-10b9-4ba3-824a-\
9daf24b1117f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SameDummies", "[", 
    RowBox[{"expr", ":", 
     RowBox[{"(", 
      RowBox[{"_Plus", "|", "_SeriesData", "|", "_Equal", "|", "_List"}], 
      ")"}]}], "]"}], ":=", 
   RowBox[{"ReplaceDummies2", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Union", "[", 
      RowBox[{"IndexName", "/@", 
       RowBox[{"FindDummyIndices", "[", "expr", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameDummies", "[", "expr_", "]"}], ":=", "expr"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a73bffe6-79b8-4957-bf9c-a5f5911ed524"],

Cell["\<\
2) Now we have an internal driver. It cannot be implemented in ReplaceDummies \
to ensure that the DeleteCases structure does its job. Extended to work on \
Equal and List expressions, as suggested by Teake and Thomas.\
\>", "Text",ExpressionUUID->"8ae17ed4-617f-4536-9802-728d78ca1dd2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceDummies2", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"(", 
       RowBox[{"_Plus", "|", "_Equal", "|", "_List"}], ")"}]}], ",", 
     "newdummies_IndexList"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"ReplaceDummies2", "[", 
      RowBox[{"#", ",", "newdummies"}], "]"}], "&"}], "/@", "expr"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceDummies2", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"SeriesData", "[", 
       RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], "]"}], 
      "]"}], ",", "newdummies_IndexList"}], "]"}], ":=", 
   RowBox[{"SeriesData", "[", 
    RowBox[{
     RowBox[{"ReplaceDummies2", "[", 
      RowBox[{"var", ",", "newdummies"}], "]"}], ",", 
     RowBox[{"ReplaceDummies2", "[", 
      RowBox[{"orig", ",", "newdummies"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"ReplaceDummies2", "[", 
        RowBox[{"#", ",", "newdummies"}], "]"}], "&"}], "/@", "coeffs"}], ",",
      "rest"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ReplaceDummies2", "[", 
   RowBox[{"expr_", ",", "newdummies_IndexList"}], "]"}], ":=", 
  RowBox[{"ReplaceIndex", "[", 
   RowBox[{"expr", ",", 
    RowBox[{"SameVBundleRules", "[", 
     RowBox[{
      RowBox[{"Sort", "[", 
       RowBox[{"IndexName", "/@", 
        RowBox[{"FindDummyIndices", "[", "expr", "]"}]}], "]"}], ",", 
      "newdummies"}], "]"}]}], "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d761ddce-edb7-45c0-ab78-ac3bb3ee4f80"],

Cell["\<\
The newdummies are assumed to be sorted, and hence we do not sort them again. \
We need Sort in the first argument of SameVBundleRules. This is to ensure \
that the new indices keep the same ordering as the old indices. We do it via \
Sort, and not IndexSort. That means that there is no guarantee that \
ReplaceDummies on a canonicalized expression returns another canonical \
expression.\
\>", "Text",ExpressionUUID->"69bdfe6a-c82e-498b-88bc-636bf266bedd"],

Cell["\<\
Finally we have the most internal part, which finds the rules to be used in \
the replacement. Note that FindDummyIndices returns the indices in their \
original order, and that order is kept in SameVBundleRules. On the other hand \
SameDummies sorts the dummies to be introduced.\
\>", "Text",ExpressionUUID->"fc6a1a64-f35d-4eca-a195-6510281e459f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"md", "[", "i_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"VBundleOfIndex", "[", "i", "]"}], ",", "i"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleRules", "[", 
    RowBox[{
     RowBox[{"IndexList", "[", "]"}], ",", "_"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleRules", "[", 
    RowBox[{"indices_IndexList", ",", "newindices_IndexList"}], "]"}], ":=", 
   RowBox[{"SameVBundleRules", "[", 
    RowBox[{"indices", ",", "newindices", ",", "$VBundles"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleRules", "[", 
    RowBox[{"indices_", ",", "newindices_", ",", 
     RowBox[{"{", "vbundle_", "}"}]}], "]"}], ":=", 
   RowBox[{"OneVBundleRules", "[", 
    RowBox[{"indices", ",", "newindices"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleRules", "[", 
    RowBox[{"indices_", ",", "newindices_", ",", "vbundles_List"}], "]"}], ":=", 
   RowBox[{"SameVBundleRules2", "[", 
    RowBox[{
     RowBox[{"md", "/@", "indices"}], ",", 
     RowBox[{"md", "/@", "newindices"}], ",", "vbundles"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleRules2", "[", 
    RowBox[{"indices_", ",", "newindices_", ",", "vbundles_"}], "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Join", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"SameVBundleRules", "[", 
        RowBox[{
         RowBox[{"Last", "/@", 
          RowBox[{"IndexList", "@@", 
           RowBox[{"Cases", "[", 
            RowBox[{"indices", ",", 
             RowBox[{"{", 
              RowBox[{"#", ",", "_"}], "}"}]}], "]"}]}]}], ",", 
         RowBox[{"Last", "/@", 
          RowBox[{"IndexList", "@@", 
           RowBox[{"Cases", "[", 
            RowBox[{"newindices", ",", 
             RowBox[{"{", 
              RowBox[{"#", ",", "_"}], "}"}]}], "]"}]}]}], ",", 
         RowBox[{"{", "#", "}"}]}], "]"}], "&"}], "/@", "vbundles"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OneVBundleRules", "[", 
    RowBox[{"indices_", ",", "newindices_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tmp", "=", 
       RowBox[{"newindices", "[", 
        RowBox[{"[", 
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "indices", "]"}], "]"}], "]"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{"Inner", "[", 
       RowBox[{"Rule", ",", "indices", ",", "tmp", ",", "List"}], "]"}], "~", 
      "Join", "~", 
      RowBox[{"Inner", "[", 
       RowBox[{"Rule", ",", 
        RowBox[{"Minus", "/@", "indices"}], ",", 
        RowBox[{"Minus", "/@", "tmp"}], ",", "List"}], "]"}]}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d50e1601-1f79-4374-93e7-8c0a74af419b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ReplaceDummies", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SameDummies", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"ReplaceDummies", ",", "SameDummies"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d35623cd-57ad-422e-8a48-f99f32eddb33"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  "]"}]], "Input",ExpressionUUID->"106119eb-d586-4a1b-82de-9a47ffad1b94"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceDummies", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ReplaceDummies\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(1\\)\[NoBreak] or \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`ReplaceDummies::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"0a14c95b-221e-48d5-8cca-9f9cf30e4dfc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{"1", ",", "2", ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"3e152a7e-267e-47e4-8535-a9c0554277fe"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceDummies", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ReplaceDummies\\)\[NoBreak] called with \
\[NoBreak]\\!\\(3\\)\[NoBreak] arguments; \[NoBreak]\\!\\(1\\)\[NoBreak] or \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`ReplaceDummies::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"8a086356-5579-4327-a79f-08674d5e5d4b"]
}, Open  ]],

Cell["\<\
These functions must be only used for simplification, and not for usual dummy \
replacement on rules. That is done by Module constructs.\
\>", "Text",ExpressionUUID->"fb51248c-8f4d-411b-b031-a8d3cf9e3214"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.6. DuplicateRule", \
"Subsubsection",ExpressionUUID->"2a447423-cc6e-4fb5-952d-7ac8b4f123fd"],

Cell["\<\
Given a rule between indices, very often we also need the same rule for their \
dual indices:\
\>", "Text",ExpressionUUID->"deca1a47-a230-4fd2-b983-839ba1fba293"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DuplicateRule", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Rule", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"Sequence", "[", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", 
     RowBox[{"Rule", "[", 
      RowBox[{
       RowBox[{"ChangeIndex", "[", "a", "]"}], ",", 
       RowBox[{"ChangeIndex", "[", "b", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DuplicateRule", "[", "list_List", "]"}], ":=", 
   RowBox[{"DuplicateRule", "/@", "list"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DuplicateRule", "[", "list_IndexList", "]"}], ":=", 
   RowBox[{"DuplicateRule", "/@", "list"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"68f5b5c1-8034-492a-8e3d-56bbc2c481d2"],

Cell["\<\
QUESTION: There should be a parallel function changing to conjugate indices.\
\>", "Text",ExpressionUUID->"db1b4905-ca68-46d6-8c1e-f1376ac450de"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.7. SplitIndex", \
"Subsubsection",ExpressionUUID->"0a1007b9-ef52-43c4-bc4f-b887f057ba75"],

Cell["\<\
We introduce a command SplitIndex, a generalized version of ReplaceIndex, \
based on rules of the form a -> IndexList[a1, a2, a3, ...] and returning a \
list of expressions with the index a replaced by a1, a2, a3, ... \
respectively. The key idea is that of using ReplaceIndex internally only \
once, and then folding using ReplaceAll, and not ReplaceIndex:\
\>", "Text",ExpressionUUID->"df3050ee-4224-4a19-b3f5-8efa2cd1f5c8"],

Cell[TextData[{
 "1) There basic notation for index splitting is a \"split-rule\":\n\tindex \
-> IndexList[ i1, i2, ... ]\nor a list of them (head List) for several \
different indices splitted. This other notation is also allowed:\n\t\
IndexList[ index1, index2, ... ] -> IndexList[ i1, i2, ... ]\nunderstood as\n\
\t{ index1 -> IndexList[ i1, i2, ... ] ,  index2 -> IndexList[ i1, i2, ... ] \
, ... }\nwhich could be useful when splitting over c-indices in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ". The function ArrangeSplitRules is in charge of converting any of those \
cases into a list of split-rules. Not the use of Reverse to get multiple \
indices in the expected order. The returned list of split-rules has head \
IndexList:"
}], "Text",ExpressionUUID->"84a4e806-801d-4eae-bf6b-028ec164634f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ArrangeSplitRules", "[", 
    RowBox[{"rule", ":", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Rule", "|", "RuleDelayed"}], ")"}], "[", 
      RowBox[{
       RowBox[{"_", "?", "GIndexQ"}], ",", "_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"IndexList", "[", "rule", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ArrangeSplitRules", "[", 
    RowBox[{"rules", ":", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Rule", "|", "RuleDelayed"}], ")"}], "[", 
      RowBox[{"_IndexList", ",", "_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"MapAt", "[", 
      RowBox[{"Reverse", ",", "rules", ",", "1"}], "]"}], ",", "IndexList", 
     ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ArrangeSplitRules", "[", "list_IndexList", "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"ArrangeSplitRules", "/@", 
      RowBox[{"Reverse", "[", "list", "]"}]}], ",", "1", ",", "IndexList"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ArrangeSplitRules", "[", "list_List", "]"}], ":=", 
   RowBox[{"ArrangeSplitRules", "[", 
    RowBox[{"IndexList", "@@", "list"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"288dac99-5d6b-4bc6-b2ca-4f019a8a1aea"],

Cell["\<\
2) Now we have a list of splitrules. We need to transform each of those \
split-rules into a column matrix of rules which can be fed to either \
ReplaceIndex or ReplaceAll. We do that with InterpretSplitRules:\
\>", "Text",ExpressionUUID->"65e45b32-47e5-4c7a-8e95-d50454b9e8ff"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InterpretSplitRules", "[", 
    RowBox[{"rule", ":", 
     RowBox[{"Rule", "[", 
      RowBox[{"_", ",", 
       RowBox[{"IndexList", "[", "]"}]}], "]"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SplitIndex", "::", "invalid"}], ",", "rule", ",", 
      "\"\<replacement rule\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InterpretSplitRules", "[", 
    RowBox[{"rule", ":", 
     RowBox[{"Rule", "[", 
      RowBox[{"_", ",", "_IndexList"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"List", ",", 
     RowBox[{"List", "/@", 
      RowBox[{"Thread", "[", 
       RowBox[{"rule", ",", "IndexList"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InterpretSplitRules", "[", 
    RowBox[{"List", "[", "rules___", "]"}], "]"}], ":=", 
   RowBox[{"InterpretSplitRules", "/@", 
    RowBox[{"IndexList", "[", "rules", "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"933a8306-9696-4309-b6ad-193bea5884a7"],

Cell["\<\
3) And this is the main function (most of the temporary variables could be \
avoided, but the function would be difficult to read then):\
\>", "Text",ExpressionUUID->"48b3ee38-5e74-4379-8c20-ed48c1b3b109"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SplitIndex"}]], \
"Input",ExpressionUUID->"3a06592b-6042-4d1b-a0d6-aff2a56472fe"],

Cell[BoxData[
 StyleBox["\<\"SplitIndex[expr, splitrules] returns an array whose elements \
are expr with certain indices replaced as given by the splitrules. A \
split-rule must be of the form index -> Indexlist[i1, i2, ...], meaning that \
index is to be replaced by i1, i2, ... respectively in each of the terms of \
the array. It is possible to give a list of splitrules or a compacted form \
IndexList[index1, index2, ...] -> IndexList[i1 ,i2, ...], where each of the \
indices indexi is to be splitted as IndexList[i1, i2, ...].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672487-5338953",ExpressionUUID->"b1c43f7d-2564-4a92-921a-\
4995ea600d72"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"changefirst", "[", 
    RowBox[{
     RowBox[{"rule_", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", 
     RowBox[{"Rule", "[", 
      RowBox[{"a_", ",", "c_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"rule", "[", 
    RowBox[{"c", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplitIndex", "[", 
    RowBox[{"expr_", ",", "rules_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "splitrules", ",", "firsts", ",", "dollars", ",", "rules1", ",", 
       "rules2"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"splitrules", "=", 
       RowBox[{"ArrangeSplitRules", "[", "rules", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"firsts", "=", 
       RowBox[{"First", "/@", "splitrules"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"dollars", "=", 
       RowBox[{"DummyAs", "/@", "firsts"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"rules1", "=", 
       RowBox[{"Inner", "[", 
        RowBox[{"Rule", ",", "firsts", ",", "dollars", ",", "List"}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"rules2", "=", 
       RowBox[{"InterpretSplitRules", "[", 
        RowBox[{"Inner", "[", 
         RowBox[{"changefirst", ",", "splitrules", ",", 
          RowBox[{"IndexList", "@@", "rules1"}], ",", "List"}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Fold", "[", 
       RowBox[{"ReplaceAll", ",", 
        RowBox[{"ReplaceIndex", "[", 
         RowBox[{"expr", ",", "rules1"}], "]"}], ",", "rules2"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SplitIndex", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SplitIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"27dd904f-a076-4728-8153-787ea16bef76"],

Cell["\<\
Comments:
\t- This way of working is very safe because, even though most of the \
replacements are done by ReplaceAll, the first function manipulating expr \
inside SplitIndex is ReplaceIndex, which changes the indices to be splitted \
into unique variables, and hence there cannot be any confusion afterwards.
\t- Splitting only makes sense with free indices, and perhaps with blocked \
indices, but never with dummy indices. Not even with both split-rules \
a->IndexList[c,d] and -a->IndexList[-b, -c]. This is because SplitIndex acts \
as Outer, producing all combinations, but we would need something like Inner \
to expand dummies. Use TraceDummy.
\t- The notations for SplitIndex and TraceDummy are very different. That does \
not make much sense.\
\>", "Text",ExpressionUUID->"166ce6a4-438e-408a-ba7f-11385669e330"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7.8. TraceIndex and TraceDummy", \
"Subsubsection",ExpressionUUID->"8dfcae20-e112-4283-bf52-f09dbf84d394"],

Cell["\<\
The function TraceDummy is based on the combination of the private functions \
ToIndexExpr and TraceIndex (do not confuse TraceDummy with TraceIndex, the \
latter being named after SplitIndex). We first call ToIndexExpr, using the \
function TraceDummyExpr as second argument. The third argument is a wrapper \
for those expanded terms. This function does not have attribute HoldFirst, \
that is, we assume that the original expression cannot be further evaluated.\
\>", "Text",ExpressionUUID->"d58aa55a-96da-43ec-af98-730608542669"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TraceDummy", "[", 
    RowBox[{"expr_List", ",", "args__"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"TraceDummy", "[", 
      RowBox[{"#", ",", "args"}], "]"}], "&"}], "/@", "expr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceDummy", "[", 
    RowBox[{"expr_", ",", "rules_", ",", 
     RowBox[{"function_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"FromIndexExpr", "[", 
    RowBox[{"ToIndexExpr", "[", 
     RowBox[{"expr", ",", 
      RowBox[{
       RowBox[{"TraceDummyExpr", "[", 
        RowBox[{"#", ",", "rules", ",", "function"}], "]"}], "&"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"TraceDummy", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TraceDummy", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1700867b-a5c2-4d63-8547-e7d21712b852"],

Cell["\<\
The function TraceDummyExpr interprets the result from ToIndexExpr and checks \
that we always trace indices which are really dummy indices:\
\>", "Text",ExpressionUUID->"99a393b4-7f60-444c-a280-1e7c61df1c08"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"$TraceDummyVerbose", "=", "False"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Always", " ", "a", " ", "list", " ", "of", " ", "rules"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceDummyExpr", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"rule", ":", 
       RowBox[{"(", 
        RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}]}], ",", "function_"}], 
     "]"}], ":=", 
    RowBox[{"TraceDummyExpr", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"{", "rule", "}"}], ",", "function"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"No", " ", "dummies", " ", "or", " ", "no", " ", 
    RowBox[{"rules", ":", " ", 
     RowBox[{"do", " ", "nothing"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceDummyExpr", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"IndexExpr", "[", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"IndexList", "[", "]"}]}], "]"}]}], ",", "_", ",", "_"}], 
    "]"}], ":=", "expr"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceDummyExpr", "[", 
     RowBox[{"expr_IndexExpr", ",", 
      RowBox[{"{", "}"}], ",", "_"}], "]"}], ":=", "expr"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"General", " ", 
    RowBox[{"case", ":", " ", 
     RowBox[{"dummies", " ", "and", " ", "rules"}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceDummyExpr", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"IndexExpr", "[", 
       RowBox[{"expr1_", ",", "frees_", ",", "dummies_"}], "]"}]}], ",", 
     RowBox[{"rules", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Rule", "|", "RuleDelayed"}], ")"}], "[", 
          RowBox[{"_", ",", "_"}], "]"}], ")"}], ".."}], "}"}]}], ",", 
     "function_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tracerules", "=", 
       RowBox[{"ChooseRules", "[", 
        RowBox[{"dummies", ",", "rules"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"traceinds", "=", 
         RowBox[{"First", "/@", "tracerules"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"$TraceDummyVerbose", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Tracing indices \>\"", ",", "traceinds", ",", "\"\< in \>\"", 
            ",", 
            RowBox[{"FromIndexExpr", "@", 
             RowBox[{"HoldForm", "[", "expr1", "]"}]}]}], "]"}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"ReplacePart", "[", 
         RowBox[{
          RowBox[{"IndexExpr", "[", 
           RowBox[{"expr1", ",", "frees", ",", 
            RowBox[{"Complement", "[", 
             RowBox[{"dummies", ",", "traceinds", ",", 
              RowBox[{"ChangeIndex", "/@", "traceinds"}]}], "]"}]}], "]"}], 
          ",", 
          RowBox[{"TraceIndex", "[", 
           RowBox[{"expr1", ",", "tracerules", ",", "function"}], "]"}], ",", 
          
          RowBox[{"{", "1", "}"}], ",", 
          RowBox[{"{", "1", "}"}]}], "]"}]}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"495b730e-ab26-4920-bbd7-559ba9fadd15"],

Cell["\<\
This small function selects the rules which will be used to trace dummies. \
This is where we check that we are actually using rules which match the \
dummies of the subexpression being traced. Note that rules can be rules with \
patterns on the LHS, but tracerules always has normal g-indices on the LHS. \
We temporarily block a global variable HEAD to ensure that the Inner \
construct is performed correctly. The problem comes from the possibility of \
having head List or IndexList in updummies. In this way updummies always has \
head HEAD.\
\>", "Text",ExpressionUUID->"32b4d19a-b4db-463a-b3bb-505c860c2a7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ChooseRules", "[", 
    RowBox[{"dummies_", ",", "rules_"}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", "HEAD", "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"updummies", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"UpIndex", "/@", 
           RowBox[{"HEAD", "@@", "dummies"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"Inner", "[", 
          RowBox[{"Rule", ",", "updummies", ",", 
           RowBox[{"Replace", "[", 
            RowBox[{"updummies", ",", "rules", ",", "1"}], "]"}], ",", 
           "IndexList"}], "]"}], ",", 
         RowBox[{"HoldPattern", "[", 
          RowBox[{"Rule", "[", 
           RowBox[{"x_", ",", "x_"}], "]"}], "]"}]}], "]"}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"feafdae9-9104-4728-904a-992cb6eec4d1"],

Cell["\<\
This private function is almost identical to SplitIndex, simply adding the \
commands DuplicateRule on rules1, rules2 and then the final addition of all \
elements of the list of terms. This function is dangerous for direct tracing \
because it does not check whether the indices of the splitrules are present \
or not in the expression being traced. We assume they are, but this is only \
true when TraceIndex is called from TraceDummy. Note that this function is \
completely independent from IndexExpr.\
\>", "Text",ExpressionUUID->"49ddd668-de0a-4224-a635-2084b42ee0f3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"TraceIndex", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceIndex", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"IndexList", "[", "]"}], ",", 
     RowBox[{"function_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"Hold", "[", 
    RowBox[{"function", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceIndex", "[", 
    RowBox[{"expr_", ",", "rules_", ",", 
     RowBox[{"function_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "splitrules", ",", "firsts", ",", "dollars", ",", "rules1", ",", 
       "rules2", ",", "terms"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"splitrules", "=", 
       RowBox[{"ArrangeSplitRules", "[", "rules", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"firsts", "=", 
       RowBox[{"First", "/@", "splitrules"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"dollars", "=", 
       RowBox[{"DummyAs", "/@", "firsts"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"rules1", "=", 
       RowBox[{"Inner", "[", 
        RowBox[{"Rule", ",", "firsts", ",", "dollars", ",", "List"}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"rules2", "=", 
       RowBox[{"InterpretSplitRules", "[", 
        RowBox[{"Inner", "[", 
         RowBox[{"changefirst", ",", "splitrules", ",", 
          RowBox[{"IndexList", "@@", "rules1"}], ",", "List"}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"rules1", "=", 
       RowBox[{"DuplicateRule", "/@", "rules1"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"rules2", "=", 
       RowBox[{"DuplicateRule", "/@", "rules2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"terms", "=", 
       RowBox[{"Flatten", "@", 
        RowBox[{"Fold", "[", 
         RowBox[{"ReplaceAll", ",", 
          RowBox[{"ReplaceIndex", "[", 
           RowBox[{"expr", ",", "rules1", ",", "Hold"}], "]"}], ",", 
          "rules2"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "function", " ", "is", " ", "mapped", " ", "inside", " ", "a", " ", 
         "Hold", " ", "expression"}], ",", " ", 
        RowBox[{"and", " ", "hence", " ", "not", " ", "yet", " ", 
         RowBox[{"evaluated", ".", " ", "Fixed"}], " ", "after", " ", "Leo", 
         " ", "found", " ", "a", " ", "problem"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"function", "/@", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{
         RowBox[{"Thread", "[", 
          RowBox[{"terms", ",", "Hold"}], "]"}], ",", "Plus", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c1bb02fe-693f-4002-9501-8a8f57f062ba"],

Cell["\<\
We can use interesting constructs like these. Note that only the upindex is \
matched in the rules, but TraceIndex internally duplicates the rules.\
\>", "Text",ExpressionUUID->"a8ea6f00-d715-4a20-bd98-1300fd95a6ad"],

Cell[BoxData[{
 RowBox[{"TraceDummy", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "d", ",", 
      RowBox[{"-", "c"}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"dummy_", "?", "TangentM`Q"}], "\[RuleDelayed]", 
    RowBox[{"IndexList", "[", 
     RowBox[{
      RowBox[{"DummyIn", "[", "TangentM1", "]"}], ",", 
      RowBox[{"DummyIn", "[", "TangentM2", "]"}]}], "]"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"TraceDummy", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_Symbol", ",", "polar"}], "}"}], "\[Rule]", 
    RowBox[{"IndexList", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "polar"}], "}"}]}], "]"}]}]}], "]"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"52a09abc-a45c-4e30-83b7-a81b445f975f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"37dba9f5-62e1-4057-b334-531b59d960ef"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "T", "]"}], "^=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"BasisQ", "[", "polar", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`VBundleOfBasis", "[", "polar", "]"}], "^=", "TM"}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"AbstractIndexQ", "[", "a", "]"}], "^=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", "a", "]"}], "^=", "TM"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"TM", ",", "TM"}], "]"}], "^=", "True"}], 
  ";"}]}], "Input",ExpressionUUID->"90ae5e19-b087-498f-9138-6f49fe890642"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraceDummy", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_Symbol", ",", "polar"}], "}"}], "\[Rule]", 
    RowBox[{"IndexList", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "polar"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"5575431c-5f0f-4633-9cac-7b3b38150013"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"73148840-cca6-4750-bf69-0fa8371eee44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraceDummy", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"polar", "[", "a", "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"polar", "[", "a", "]"}]}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"polar", "[", "a_Symbol", "]"}], "\[Rule]", 
    RowBox[{"IndexList", "[", 
     RowBox[{
      RowBox[{"polar", "[", "0", "]"}], ",", 
      RowBox[{"polar", "[", "1", "]"}], ",", 
      RowBox[{"polar", "[", "2", "]"}], ",", 
      RowBox[{"polar", "[", "3", "]"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"06fc4d86-d03c-4f38-92cd-9b02e1b2b11f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"polar", "[", "0", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"polar", "[", "0", "]"}]}]}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"polar", "[", "1", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"polar", "[", "1", "]"}]}]}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"polar", "[", "2", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"polar", "[", "2", "]"}]}]}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"polar", "[", "3", "]"}], ",", 
    RowBox[{"-", 
     RowBox[{"polar", "[", "3", "]"}]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"1233eb2b-d0b5-4ba7-b122-4e16ea7274ee"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"T", ",", "polar", ",", "a", ",", "TM"}], 
  "]"}]], "Input",ExpressionUUID->"64d53cd0-fc94-41ba-a049-2f0e5ccacf59"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"4d9ce666-969f-420c-baf9-bfc3e5d870e2"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["6. Manifolds and mappings",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"abe21f50-e0a3-48b5-9b96-a0b4a09186f8"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", " ", "6."}], "Manifolds"}], " ", 
  "****************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"36f07ee8-faab-45d3-9908-2a47be441a2e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"93762c04-d4c4-4e00-92ad-54258fbd07f9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "18.230890000000002`", ",", "219.692139`8.793359510817027", ",", 
   "0.0829839345838838`"}], 
  "}"}]], "Output",ExpressionUUID->"d9832614-f8a9-4918-a4d6-066f75ef05c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["6.0. Comments", \
"Subsection",ExpressionUUID->"216b8974-c94c-4ff2-855d-37bf76b18211"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 6: Manifolds.\>\"", "]"}], ",", 
   "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9f9cab58-8f3b-43e1-9a62-1e869b86d31d"],

Cell[TextData[{
 "Manifolds are considered differentiable (C-smooth-enough) manifolds with no \
special properties. In the future we could include discrete \
(differentiability level, topological?) properties of the manifold which \
would be useful in some calculations, but currently there is none. We only \
store the dimension of the manifold, and the vbundles for which it is the \
base. Manifolds are always assumed to be real, in the sense of being locally \
some ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "dim"], TraditionalForm]],
  ExpressionUUID->"243162cc-f17c-466f-8efd-8d9c42ab1f3a"],
 ". There is no complex manifold support in ",
 StyleBox["xTensor;",
  FontSlant->"Italic"],
 " I suggest you define a manifold of real dimension 2*dim. We will see later \
that we support complex vector spaces, but not complex manifolds."
}], "Text",ExpressionUUID->"68bc5796-fcab-476f-94bc-4b22cba59fce"],

Cell[TextData[{
 "Then we have mappings among manifolds. A mapping is a new type of object in \
",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". "
}], "Text",ExpressionUUID->"bf4a9e40-6843-4f3f-ba78-6596c5f2927b"],

Cell["\<\
To allow for description of integration of differential forms, we understand \
that our concept of manifold is actually that of manifold with boundary. We \
could even generalize it to handle corners, but we do not do that for the \
moment.\
\>", "Text",ExpressionUUID->"e0f4254e-68e5-4dd2-8b57-35d98fbb8bd5"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1. DefManifold", \
"Subsection",ExpressionUUID->"df17f98f-5024-4458-9fad-29bec0c321be"],

Cell[CellGroupData[{

Cell["6.1.0. Comments", \
"Subsubsection",ExpressionUUID->"868cb638-5749-4332-a63c-95b83b849312"],

Cell["\<\
Currently the manifold is defined using three sets of objects:
\t- The name of the manifold: a symbol not in use in the current session.
\t- The dimension.
\t- The abstract indices for the tangent bundle.
The indices are essentially used only to define the tangent bundle. The \
dimension is relevant when defining charts on the manifold, and can be either \
a nonnegative integer or a constant-symbol (which has to be already defined).\
\
\>", "Text",ExpressionUUID->"7af89339-e26d-471c-ab7c-ab600647b460"],

Cell["\<\
Compare to Sage:
\t- It is possible to define the manifold over a field:
\t\t- \[OpenCurlyQuote]real\[CloseCurlyQuote] or an object of type RealField \
for a manifold over R.
\t\t- \[OpenCurlyQuote]complex\[CloseCurlyQuote] or an object of type \
ComplexField for a manifold over C.
\t\t- an object in the category of topological fields for other types of \
manifolds.
\t- Manifolds have a structure:
\t\t- \[OpenCurlyQuote]topological\[CloseCurlyQuote] for a topological \
manifold.
\t\t- \[OpenCurlyQuote]differentiable\[CloseCurlyQuote] for a differentiable \
manifold (of a given differentiation degree, say 4 for  C^4).
\t\t- \[OpenCurlyQuote]smooth\[CloseCurlyQuote] for a smooth manifold \
(differentiable of infinite degree).
\t\t- \[OpenCurlyQuote]analytic\[CloseCurlyQuote] for an analytic manifold.
\t- Manifolds have a \[OpenCurlyDoubleQuote]start_index\
\[CloseCurlyDoubleQuote] that specifies how to count coordinates, etc.
\t- A manifold has an atlas, a collection of charts. This is a xCoba concept \
in xAct (function ChartsOfManifold).\
\>", "Text",ExpressionUUID->"34d8e17e-1247-4bd6-8a4d-71a61f6a9081"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.1. Checks", \
"Subsubsection",ExpressionUUID->"653c2014-507f-4945-b845-40f9223ab3e0"],

Cell["\<\
Intermediate function. First we check the input (note that there are no heads \
in the argument patterns). The list of indices must have head List and not \
IndexList, because this is what the user is told to use (they are abstract \
indices, so there is no possible source of confusion). There must be at least \
one index. We use ValidateIndex[#, False] to avoid sending the \
Validate::capital warning message. This is because the indices will be \
checked again in DefVBundle later. The check is already here to avoid \
defining the manifold and then finding out that it is not possible to define \
its tangent bundle. Dimension 0 is special: indices are not required because \
there is no tangent bundle. Dimension 1 is (currently) not special.\
\>", "Text",ExpressionUUID->"b3fba1d0-9f5d-4f5c-b363-f10be6e01f63"],

Cell["\<\
In the past we were rather restrictive with the possible forms for the \
dimension. Now we accept anything, and so there is no validation of dimension:\
\>", "Text",ExpressionUUID->"6f77afcc-0232-4c7e-bd67-f0fa90f2eb3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"checkDefManifold", "[", 
    RowBox[{
    "manifold_", ",", "supermanifold_", ",", "tbundle_", ",", "dim_", ",", 
     "indices_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"1.", "-", " ", 
      RowBox[{"Validate", " ", "manifold"}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ValidateSymbol", "[", "manifold", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ValidateSymbolInSession", "[", "manifold", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"2.", "-", " ", 
       RowBox[{"Validate", " ", "supermanifold"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"supermanifold", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"ManifoldQ", "[", "supermanifold", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefManifold", "::", "unknown"}], ",", 
             "\"\<supermanifold\>\"", ",", "supermanifold"}], "]"}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NumberQ", "[", "dim", "]"}], "&&", 
           RowBox[{"NumberQ", "[", 
            RowBox[{"DimOfManifold", "[", "supermanifold", "]"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"DimOfManifold", "[", "supermanifold", "]"}], "<=", 
            "dim"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefManifold", "::", "error"}], ",", 
             "\"\<Dimension of submanifold cannot be larger than that of its \
supermanifold.\>\""}], "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"3.", "-", " ", 
       RowBox[{"Validate", " ", "tbundle"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", 
      RowBox[{
      "tbundle", ",", "\[IndentingNewLine]", "Automatic", ",", "Null", ",", 
       "\[IndentingNewLine]", "manifold", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefManifold", "::", "error"}], ",", 
          "\"\<A manifold and its tangent bundle cannot share name.\>\""}], 
         "]"}]}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ValidateSymbol", "[", "tbundle", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ValidateSymbolInSession", "[", "tbundle", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"4.", "-", " ", 
       RowBox[{"Validate", " ", "indices"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"dim", "=!=", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "indices", "]"}], "=!=", "List"}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefManifold", "::", "invalid"}], ",", "indices", ",", 
              "\"\<list of indices\>\""}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"indices", "===", 
             RowBox[{"{", "}"}]}], "&&", 
            RowBox[{"dim", "=!=", "0"}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefManifold", "::", "empty"}], ",", "3", ",", 
              "\"\<indices\>\""}], "]"}]}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Dim1", ":", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"dim", "===", "1"}], "&&", 
              RowBox[{
               RowBox[{"Length", "[", "indices", "]"}], "=!=", "1"}]}], ",", 
             RowBox[{"Throw", "@", 
              RowBox[{"Message", "[", 
               RowBox[{
                RowBox[{"DefManifold", "::", "invalid"}], ",", "indices", 
                ",", "\"\<list of indices for a 1-dim manifold\>\""}], 
               "]"}]}]}], "]"}]}], ";"}], "*)"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{
          RowBox[{"ValidateIndex", "[", 
           RowBox[{"#", ",", "False"}], "]"}], "&"}], "/@", "indices"}]}]}], 
      "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d42884b5-d370-4a9d-9199-37216f042ca3"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.2. Tangent", \
"Subsubsection",ExpressionUUID->"4eb89fd9-ae03-4ea1-8d6d-8152ac41e013"],

Cell["\<\
Construction of the name of the tangent vbundle to a given manifold: simply \
join Tangent and the name of the manifold. Note the difference between using \
GiveSymbol[Tangent, manifold] and Tangent[manifold]. The latter checks that \
manifold is ManifoldQ, but not the former, which can hence be used during \
DefManifold, even before manifold has been declared.\
\>", "Text",ExpressionUUID->"25d88191-7bdf-4001-bd3d-77ff24f133b0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Tangent", ",", 
     RowBox[{"manifold_Symbol", "?", "ManifoldQ"}]}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"Tangent", ",", "manifold"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tangent", "[", 
    RowBox[{"manifold_Symbol", "?", "ManifoldQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Tangent", ",", "manifold"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Tangent", "]"}], "=", 
   "\"\<\[DoubleStruckCapitalT]\>\""}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b757bdfb-8c26-4aae-8690-6d8780196178"],

Cell["\<\
If the manifold is not symbolic then Tangent stays unevaluated, still \
interpreted as a vbundle. This actually should never happen.\
\>", "Text",ExpressionUUID->"43501d11-c3c6-48fa-aa94-e423d49b3221"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VBundleQ", "[", 
    RowBox[{"Tangent", "[", 
     RowBox[{"manifold_", "?", "ManifoldQ"}], "]"}], "]"}], "^:=", "True"}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5971cff7-cb46-4910-8d7d-623af600aea8"],

Cell["This is its formatting:", \
"Text",ExpressionUUID->"ce2db49f-4d31-46a4-862f-752a83e54c79"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"Tangent", "[", 
      RowBox[{"manifold_", "?", "HeldManifoldQ"}], "]"}], ",", 
     "StandardForm"}], "]"}], ":=", 
   RowBox[{"interpretbox", "[", 
    RowBox[{
     RowBox[{"Tangent", "[", "manifold", "]"}], ",", 
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<T\>\"", ",", 
        RowBox[{"MakeBoxes", "[", 
         RowBox[{"manifold", ",", "StandardForm"}], "]"}]}], "}"}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1fefa746-0103-429d-b836-c73966dbc0b6"],

Cell["Backward compatibility:", \
"Text",ExpressionUUID->"01d4fa65-991a-4e6a-a504-ff2186de6789"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TangentBundleOfManifold", "=", "Tangent"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0ca49628-9648-4217-9528-ddf5c3b33165"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.3. Cartesian product manifolds", \
"Subsubsection",ExpressionUUID->"33dc2be8-a5a5-49ec-9407-bd86b283c7ac"],

Cell["Define as a manifold:", \
"Text",ExpressionUUID->"5abe9f99-fec4-4d21-a605-aef5619a924c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldQ", "[", "manifold_CartesianProduct", "]"}], "^:=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"ManifoldQ", "/@", 
      RowBox[{"List", "@@", "manifold"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"85bc515c-6f5d-4f45-b7b2-bfc434088612"],

Cell["Properties:", \
"Text",ExpressionUUID->"807d7faf-bda1-4806-b195-39d25ac8925d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimOfManifold", "[", "manifold_CartesianProduct", "]"}], "^:=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"(", 
     RowBox[{"DimOfManifold", "/@", 
      RowBox[{"List", "@@", "manifold"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tangent", "[", "manifold_CartesianProduct", "]"}], "^:=", 
   RowBox[{"CirclePlus", "@@", 
    RowBox[{"(", 
     RowBox[{"Tangent", "/@", 
      RowBox[{"List", "@@", "manifold"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfManifold", "[", "manifold_CartesianProduct", "]"}], "^:=", 
   RowBox[{"{", "manifold", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9b1a3e55-2be5-49c7-aff7-396c6ad7c106"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.4. Main function", \
"Subsubsection",ExpressionUUID->"c1002a5e-e95d-46cb-9c0a-c473cd352e47"],

Cell["\<\
I think Master will never be used with a manifold, because manifolds are the \
most primitive concepts, but I prepare it anyway. There is no Dagger option \
here.\
\>", "Text",ExpressionUUID->"b9f92031-cd11-4675-ad90-b42d2bd2aa44"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DefManifold"}]], \
"Input",ExpressionUUID->"967a0f90-2b13-4d74-b976-bea6eba1f3ad"],

Cell[BoxData[
 StyleBox["\<\"DefManifold[M, dim, {a, b, c,...}] defines M to be an \
n-dimensional differentiable manifold with dimension dim (a positive integer \
or a constant symbol) and tensor abstract indices a, b, c, ... .  \
DefManifold[M, {M1, ..., Mm}, {a, b, c,...}] defines M to be the product \
manifold of previously defined manifolds M1 ... Mm. For backward \
compatibility dim can be a list of positive integers, whose length is \
interpreted as the dimension of the defined manifold.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672489-5338953",ExpressionUUID->"284c50f3-f722-41ab-9c7b-\
462ce850b248"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefManifold", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tangent", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<manifold\>\"", ",", "\"\<\>\""}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefManifold", "[", 
     RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
    RowBox[{"Scan", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DefManifold", "[", 
        RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Backwards", " ", "compatibility", " ", 
    RowBox[{"(", 
     RowBox[{"three", " ", "definitions"}], ")"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefManifold", "[", 
    RowBox[{
    "manifold_", ",", "dim_", ",", "indices_List", ",", "ultraindex_Symbol", 
     ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Print", "[", 
      RowBox[{"\"\<** DefManifold (legacy): Ultraindex \>\"", "<>", 
       RowBox[{"ToString", "[", "ultraindex", "]"}], "<>", 
       "\"\< converted into normal index.\>\""}], "]"}], ";", 
     RowBox[{"DefManifold", "[", 
      RowBox[{"manifold", ",", "dim", ",", 
       RowBox[{"Append", "[", 
        RowBox[{"indices", ",", "ultraindex"}], "]"}], ",", "options"}], 
      "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefManifold", "[", 
    RowBox[{"manifold_", ",", 
     RowBox[{"{", 
      RowBox[{"integers___Integer", "?", "Positive"}], "}"}], ",", 
     "indices_List", ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Print", "[", 
      RowBox[{"\"\<** DefMainfold (legacy): CNumbers \>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"{", "integers", "}"}], "]"}], "<>", 
       "\"\< only used to compute dimension.\>\""}], "]"}], ";", 
     RowBox[{"DefManifold", "[", 
      RowBox[{"manifold", ",", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "integers", "}"}], "]"}], ",", "indices", ",", 
       "options"}], "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefManifold", "[", 
     RowBox[{"supermanifold_", ",", 
      RowBox[{"submanifolds", ":", 
       RowBox[{"(", 
        RowBox[{"_List", "|", "_CartesianProduct"}], ")"}]}], ",", 
      "indices_List", ",", 
      RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"DefManifold", "[", 
       RowBox[{"supermanifold", ",", 
        RowBox[{"Apply", "[", 
         RowBox[{"Plus", ",", 
          RowBox[{"DimOfManifold", "/@", "submanifolds"}]}], "]"}], ",", 
        "indices", ",", "options"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"SplitManifold", "[", 
       RowBox[{"supermanifold", ",", "submanifolds"}], "]"}]}], ")"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Single", " ", "manifold"}], " ", "*)"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefManifold", "[", 
     RowBox[{"manifold_", ",", "dim_", ",", "indices_List", ",", 
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Catch", "@", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "tbundle", ",", "master", ",", "pa", ",", "pns", ",", "info"}], "}"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "tbundle", ",", "master", ",", "pa", ",", "pns", ",", "info"}], 
          "}"}], "=", 
         RowBox[{"OptionValue", "[", 
          RowBox[{"{", 
           RowBox[{
           "Tangent", ",", "Master", ",", "PrintAs", ",", "ProtectNewSymbol", 
            ",", "DefInfo"}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"checkDefManifold", "[", 
         RowBox[{
         "manifold", ",", "Null", ",", "tbundle", ",", "dim", ",", 
          "indices"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Register", " ", "manifold", " ", "structure"}], " ", "*)"}],
         "\[IndentingNewLine]", 
        RowBox[{"MakeDefInfo", "[", 
         RowBox[{"DefManifold", ",", "manifold", ",", "info"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{
         "DefManifold", ",", "\"\<Beginning\>\"", ",", "manifold", ",", "dim",
           ",", "indices", ",", "options"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendToUnevaluated", "[", 
         RowBox[{"$Manifolds", ",", "manifold"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ManifoldQ", "[", "manifold", "]"}], "^=", "True"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DefInfo", "[", "manifold", "]"}], "^=", "info"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetPrintAs", "[", 
         RowBox[{"manifold", ",", 
          RowBox[{"PrintAsString", "[", 
           RowBox[{"manifold", ",", "pa"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SymbolRelations", "[", 
         RowBox[{"manifold", ",", "master", ",", 
          RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DimOfManifold", "[", "manifold", "]"}], "^=", "dim"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "manifold", "]"}], "^=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Define", " ", 
          RowBox[{"(", "co", ")"}], "tangent", " ", 
          RowBox[{"bundle", ".", " ", "DefVBundle"}], " ", "assumes", " ", 
          "that", " ", "the", " ", "manifold", " ", "has", " ", "been", " ", 
          "already", " ", "registered"}], " ", "*)"}], "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"dim", "===", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"$DefInfoQ", ",", 
            RowBox[{
            "Print", "[", 
             "\"\<** DefManifold:  Tangent bundle does not exist for a 0-dim \
manifold\>\"", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"tbundle", "===", "Automatic"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"tbundle", "=", 
              RowBox[{"GiveSymbol", "[", 
               RowBox[{"Tangent", ",", "manifold"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Tangent", "[", "manifold", "]"}], "^=", "tbundle"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"DefVBundle", "[", 
            RowBox[{
            "tbundle", ",", "manifold", ",", "dim", ",", "indices", ",", 
             RowBox[{"Master", "\[Rule]", "manifold"}], ",", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{"Tangent", ",", "manifold"}], "]"}]}], ",", 
             "options"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TangentBundleQ", "[", "tbundle", "]"}], "^=", "True"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"MakexTensions", "[", 
         RowBox[{
         "DefManifold", ",", "\"\<End\>\"", ",", "manifold", ",", "dim", ",", 
          "indices", ",", "options"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"pns", ",", 
          RowBox[{"Protect", "[", "manifold", "]"}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Submanifold", " ", "of", " ", "another", " ", "manifold"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefManifold", "[", 
     RowBox[{"submanifold_", ",", "dim_", ",", 
      RowBox[{"supermanifold_", "?", "ManifoldQ"}], ",", "indices_List", ",", 
      
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Catch", "@", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "tbundle", ",", "master", ",", "pa", ",", "pns", ",", "info"}], "}"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "tbundle", ",", "master", ",", "pa", ",", "pns", ",", "info"}], 
          "}"}], "=", 
         RowBox[{"OptionValue", "[", 
          RowBox[{"DefManifold", ",", 
           RowBox[{"{", 
            RowBox[{"DefInfo", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"\"\<manifold\>\"", ",", 
               RowBox[{"\"\<Submanifold of \>\"", "<>", 
                RowBox[{"ToString", "[", "supermanifold", "]"}], "<>", 
                "\"\<.\>\""}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "Tangent", ",", "Master", ",", "PrintAs", ",", "ProtectNewSymbol",
              ",", "DefInfo"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"checkDefManifold", "[", 
         RowBox[{
         "submanifold", ",", "supermanifold", ",", "tbundle", ",", "dim", ",",
           "indices"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Register", " ", "manifold", " ", "structure"}], " ", "*)"}],
         "\[IndentingNewLine]", 
        RowBox[{"MakeDefInfo", "[", 
         RowBox[{"DefManifold", ",", "submanifold", ",", "info"}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{
         "DefManifold", ",", "\"\<Beginning\>\"", ",", "submanifold", ",", 
          "dim", ",", "supermanifold", ",", "indices", ",", "options"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Append", "[", 
         RowBox[{"$Manifolds", ",", "submanifold"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ManifoldQ", "[", "submanifold", "]"}], "^=", "True"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DefInfo", "[", "submanifold", "]"}], "^=", "info"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetPrintAs", "[", 
         RowBox[{"submanifold", ",", 
          RowBox[{"PrintAsString", "[", 
           RowBox[{"submanifold", ",", "pa"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SymbolRelations", "[", 
         RowBox[{"submanifold", ",", "master", ",", 
          RowBox[{"{", "supermanifold", "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"submanifold", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"supermanifold", ",", "submanifold"}], "]"}], "=", "True"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "submanifold", "]"}], "^=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DimOfManifold", "[", "submanifold", "]"}], "^=", "dim"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Define", " ", 
          RowBox[{"(", "co", ")"}], "tangent", " ", 
          RowBox[{"bundle", ".", " ", "DefVBundle"}], " ", "assumes", " ", 
          "that", " ", "the", " ", "manifold", " ", "has", " ", "been", " ", 
          "already", " ", "registered"}], " ", "*)"}], "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"dim", "===", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"$DefInfoQ", ",", 
            RowBox[{
            "Print", "[", 
             "\"\<** DefManifold:  Tangent bundle does not exist for a 0-dim \
manifold\>\"", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"tbundle", "===", "Automatic"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"tbundle", "=", 
              RowBox[{"GiveSymbol", "[", 
               RowBox[{"Tangent", ",", "submanifold"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Tangent", "[", "submanifold", "]"}], "^=", 
               "tbundle"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"DefVBundle", "[", 
            RowBox[{
            "tbundle", ",", "submanifold", ",", "dim", ",", "indices", ",", 
             RowBox[{"Master", "\[Rule]", "submanifold"}], ",", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{"Tangent", ",", "submanifold"}], "]"}]}], ",", 
             "options"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{
         "DefManifold", ",", "\"\<End\>\"", ",", "submanifold", ",", "dim", 
          ",", "supermanifold", ",", "indices", ",", "options"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "We", " ", "do", " ", "not", " ", "define", " ", "an", " ", 
          "explicit", " ", "restricion", " ", "of", " ", "the", " ", "bundle",
           " ", "Tangentsupermanifold", " ", "to", " ", "submanifold"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"pns", ",", 
          RowBox[{"Protect", "[", "submanifold", "]"}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"A", " ", "zero"}], "-", 
    RowBox[{
    "dimensional", " ", "manifold", " ", "does", " ", "not", " ", "need", " ",
      "indices"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefManifold", "[", 
    RowBox[{"manifold_", ",", "0", ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"DefManifold", "[", 
    RowBox[{"manifold", ",", "0", ",", 
     RowBox[{"{", "}"}], ",", "options"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefManifold", "[", 
     RowBox[{"manifold_", ",", "0", ",", 
      RowBox[{"supermanifold_", "?", "ManifoldQ"}], ",", 
      RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
    RowBox[{"DefManifold", "[", 
     RowBox[{"manifold", ",", "0", ",", "supermanifold", ",", 
      RowBox[{"{", "}"}], ",", "options"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Other", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefManifold", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefManifold", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8c1edee6-44f0-4f4a-a0cf-b69d2d8fb8ea"],

Cell["\<\
Note that the submanifold has its own indices, those of the tangent vbundle \
of the submanifold. Perhaps we should use the same indices of the \
supermanifold, because the tangent vbundle of the submanifold is a subbundle \
of the tangent vbundle of the supermanifold. This must be linked with the \
issue of projectors.\
\>", "Text",ExpressionUUID->"7853387d-caad-4ce8-b2ef-2842ba6a7ed7"],

Cell["\<\
DimOfManifold is only used to pass the dimension of the tangent bundle, and \
to check that the dimensionality of a supermanifold coincides with the sum of \
the dimensions of the submanifolds.\
\>", "Text",ExpressionUUID->"906ceaaa-aa7a-4ba2-b493-e4b5f69861da"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimOfManifold", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DimOfManifold", "::", "unknown"}], ",", "\"\<manifold\>\"", 
      ",", 
      RowBox[{"ToString", "[", "x", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DimOfManifold", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DimOfManifold", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9af83113-f8c5-42b8-9da0-b92fa53120a5"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.5. Submanifold structure", \
"Subsubsection",ExpressionUUID->"5ca5c166-4028-48a8-aa6d-cf791a0790bd"],

Cell["\<\
I'm not happy with the current structure of submanifolds. It is complicated \
and too restrictive. QUESTION.\
\>", "Text",ExpressionUUID->"67d636c3-90cf-486e-8cdc-71e75cc933ee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SplittingsOfManifold"}]], \
"Input",ExpressionUUID->"1c6e0133-9e2d-40ab-a784-2ac6ca32b71d"],

Cell[BoxData[
 StyleBox["\<\"SplittingsOfManifold[M] returns a list of known \
CartesianProduct splittings of the manifold M.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672491-5338953",ExpressionUUID->"ca13d215-74ba-43f3-afed-\
2d2fb9338a38"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfManifold", "[", "manifold_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SplittingsOfManifold", "::", "unknown"}], ",", 
      "\"\<manifold\>\"", ",", " ", "manifold"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SplittingsOfManifold", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SplittingsOfManifold", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ffae06eb-68dd-4b88-904c-6246e29c891a"],

Cell["\<\
The manifold structure is rather limited because currently it only admits one \
level of inclusion, not more. That is submanifolds of submanifolds will not \
be properly treated.\
\>", "Text",ExpressionUUID->"5187c57e-14d9-4be8-aa5b-a5046bc62a40"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SubmanifoldQ"}]], \
"Input",ExpressionUUID->"431cae59-3d07-49d3-b46c-6021628ef558"],

Cell[BoxData[
 StyleBox["\<\"SubmanifoldQ[large, small] gives True if manifold small is \
contained in or equal to manifold large, and False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672492-5338953",ExpressionUUID->"2b367e58-d429-4a94-b110-\
dff90d89a7a4"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SubmanifoldQ", "[", 
    RowBox[{"manifold_", ",", "manifold_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubmanifoldQ", "[", 
    RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SubmanifoldQ", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SubmanifoldQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"82e5b787-0a8b-4c30-9eae-b8589ab8ced4"],

Cell["\<\
Note that currently SubmanifoldQ is only used by DisjointManifoldsQ (which in \
turn is only used by ZeroDerivativeQ).\
\>", "Text",ExpressionUUID->"323d21ba-8c5d-4bf5-94ae-555dfc55b53f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DisjointManifoldsQ"}]], \
"Input",ExpressionUUID->"34693507-8767-426d-86b0-7976716f5816"],

Cell[BoxData[
 StyleBox["\<\"DisjointManifoldsQ[manifolds1, manifolds2] gives True if none \
of the manifolds of the list manifolds1 is a submanifold or a supermanifold \
of the manifolds of the list manifolds2, and False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672494-5338953",ExpressionUUID->"6d2bb05f-08e9-4e88-95c8-\
ffe6aeb384a8"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DisjointManifoldsQ", "[", 
    RowBox[{"manifolds1_List", ",", "manifold2_"}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"DisjointManifoldsQ", "[", 
        RowBox[{"#", ",", "manifold2"}], "]"}], "&"}], "/@", "manifolds1"}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisjointManifoldsQ", "[", 
    RowBox[{"manifold1_", ",", "manifolds2_List"}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"DisjointManifoldsQ", "[", 
        RowBox[{"manifold1", ",", "#"}], "]"}], "&"}], "/@", "manifolds2"}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisjointManifoldsQ", "[", 
    RowBox[{"manifold1_", ",", "manifold2_"}], "]"}], ":=", 
   RowBox[{"Not", "[", 
    RowBox[{
     RowBox[{"SubmanifoldQ", "[", 
      RowBox[{"manifold1", ",", "manifold2"}], "]"}], "||", 
     RowBox[{"SubmanifoldQ", "[", 
      RowBox[{"manifold2", ",", "manifold1"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DisjointManifoldsQ", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DisjointManifoldsQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9b3859fe-f281-4a1c-acb5-ef44a47331df"],

Cell["\<\
Following a suggestion by Guillaume, we shall first declare both the \
supermanifold and its submanifolds, and then we shall create the association, \
with a command SplitManifold, which does more or less what DefManifold does \
right now in the Cartesian product case. This is more flexible, because we \
can declare all manifolds in any order, and then do the association. Using \
DefManifold, right now we can only declare first the submanifolds and then \
the supermanifold.\
\>", "Text",ExpressionUUID->"b60a707b-b7c0-4d1c-86a3-0de42796ad63"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Cartesian", " ", "product", " ", "manifold"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SplitManifold", "[", 
      RowBox[{"supermanifold_", ",", "submanifolds_CartesianProduct"}], "]"}],
      ":=", 
     RowBox[{"SplitManifold", "[", 
      RowBox[{"supermanifold", ",", 
       RowBox[{"List", "@@", "submanifolds"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplitManifold", "[", 
      RowBox[{"supermanifold_", ",", "submanifolds_List"}], "]"}], ":=", 
     "\[IndentingNewLine]", 
     RowBox[{"Catch", "@", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"prot", "=", 
          RowBox[{"Unprotect", "[", "supermanifold", "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"DimOfManifold", "[", "supermanifold", "]"}], "=!=", 
            RowBox[{"Apply", "[", 
             RowBox[{"Plus", ",", 
              RowBox[{"DimOfManifold", "/@", "submanifolds"}]}], "]"}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefManifold", "::", "error"}], ",", 
              "\"\<Invalid dimension of supermanifold.\>\""}], "]"}]}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"xUpAppendTo", "[", 
          RowBox[{
           RowBox[{"SplittingsOfManifold", "[", "supermanifold", "]"}], ",", 
           RowBox[{"CartesianProduct", "@@", "submanifolds"}]}], "]"}], ";", 
         RowBox[{
          RowBox[{
           RowBox[{"TagSet", "[", 
            RowBox[{"supermanifold", ",", 
             RowBox[{"SubmanifoldQ", "[", 
              RowBox[{"supermanifold", ",", "#"}], "]"}], ",", "True"}], 
            "]"}], "&"}], "/@", "submanifolds"}], ";", "\[IndentingNewLine]", 
         
         RowBox[{"AppendToUnevaluated", "[", 
          RowBox[{"$ProductManifolds", ",", "supermanifold"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"SymbolRelations", "[", 
            RowBox[{"supermanifold", ",", "Null", ",", "submanifolds"}], 
            "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Protect", "[", 
          RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Split", " ", "tangent", " ", "bundle"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"SplitVBundle", "[", 
          RowBox[{
           RowBox[{"Tangent", "[", "supermanifold", "]"}], ",", 
           RowBox[{"Tangent", "/@", "submanifolds"}]}], "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7d7caf38-b72f-437a-a234-bf76a1be809c"],

Cell["\<\
It is unclear whether it is better to register the supermanifold as a visitor \
or as a host of the subvbundles. SplitManifold is called by \
DefManifold[supermanifold, {submanifolds}], in which clearly supermanifold is \
a visitor of the (already existing) submanifold. But on the other hand the \
idea of splitting seems to suggest the opposite. I have had problems in both \
cases, so I prefer not to define any SymbolRelations at all in this case.\
\>", "Text",ExpressionUUID->"edfbf0f4-1236-4f9f-99be-39b0e74cd394"],

Cell["\<\
The variable $ProductManifolds is never used in xTensor. The variable \
$SumVBundles below is used only in TraceProductDummy.\
\>", "Text",ExpressionUUID->"75529a7c-a13c-4ba2-8611-50be025c63c4"],

Cell["\<\
The submanifold structure is modelled on the idea of Cartesian product of \
manifolds, and not on the ideas of inmersion or embedding, which require the \
specification of a mapping.\
\>", "Text",ExpressionUUID->"98406aaa-9fba-47ce-b638-e2646f763a89"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.6. Undefinition", \
"Subsubsection",ExpressionUUID->"15a2ea7b-e043-4042-b283-a78fed3421db"],

Cell["\<\
When we undefine a manifold, we also undefine all tensor fields on that \
manifold.\
\>", "Text",ExpressionUUID->"f3732a39-9ba3-41db-93f4-44d7c9db4d20"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefManifold"}]], \
"Input",ExpressionUUID->"5a7a1639-618e-49ac-9087-edf11f6a5e2e"],

Cell[BoxData[
 StyleBox["\<\"UndefManifold[manifold] undefines manifold.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672495-5338953",ExpressionUUID->"3194cd4c-1542-426d-8832-\
439f1cf846e3"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefManifold", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "ManifoldQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefManifold", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefManifold", "[", "manifold_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"servants", "=", 
        RowBox[{"ServantsOf", "[", "manifold", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "@", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"manifold", ",", "_Symbol"}], "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefManifold", "::", "error"}], ",", 
            "\"\<Only symbols can be undefined.\>\""}], "]"}]}]}], "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "@", 
          RowBox[{"ManifoldQ", "[", "manifold", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefManifold", "::", "unknown"}], ",", 
            "\"\<manifold\>\"", ",", "manifold"}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "manifold", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefManifold", ",", "\"\<Beginning\>\"", ",", "manifold"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "manifold", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "manifold", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Undefine", " ", "servants"}], ",", " ", 
         RowBox[{"including", " ", "the", " ", "tangent", " ", "bundle"}]}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$Manifolds", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$Manifolds", ",", "manifold"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$ProductManifolds", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$ProductManifolds", ",", "manifold"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefManifold", ",", "\"\<End\>\"", ",", "manifold"}], "]"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Eliminate", " ", "symbol"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"MakeUndefInfo", "[", 
        RowBox[{"UndefManifold", ",", "manifold"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"RemoveSymbol", "[", "manifold", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefManifold", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefManifold", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1f01769b-7bac-4362-b9d5-8a6ece6a1f09"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.7. Formatting", \
"Subsubsection",ExpressionUUID->"fbec7673-0e1c-4124-af5a-57873f26a5f5"],

Cell["\<\
TODO: Why is it that manifolds do not participate in the PrintAs system?\
\>", "Text",ExpressionUUID->"0797b9b7-9738-4387-b5aa-20b36d46bf85"],

Cell["\<\
Held version of ManifoldQ to avoid evaluation leaks during typesetting:\
\>", "Text",ExpressionUUID->"29715537-6ef8-4dd5-b618-44fcc89cbd43"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldManifoldQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldManifoldQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"ManifoldQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"839f90b8-08ed-442c-984c-b93a07c605c1"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.1.7. Boundaries", \
"Subsubsection",ExpressionUUID->"e554e7df-ba25-409b-b06c-65eb8bf4ecac"],

Cell["\<\
Our concept of manifold is actually that of \[OpenCurlyDoubleQuote]manifold \
with boundary\[CloseCurlyDoubleQuote]. TODO: Propagate this concept through \
the Mapping functionality and other parts of xTensor.\
\>", "Text",ExpressionUUID->"7e7822ee-cd13-4359-a15e-b27e9b6bb736"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "ManifoldBoundary", " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldQ", "[", 
      RowBox[{"ManifoldBoundary", "[", 
       RowBox[{"_", "?", "ManifoldQ"}], "]"}], "]"}], "^:=", "True"}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"DimOfManifold", "[", 
      RowBox[{"ManifoldBoundary", "[", 
       RowBox[{"M_", "?", "ManifoldQ"}], "]"}], "]"}], "^:=", 
     RowBox[{
      RowBox[{"DimOfManifold", "[", "M", "]"}], "-", "1"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"We", " ", "assume", " ", "no", " ", "corners"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldBoundary", "[", 
      RowBox[{"ManifoldBoundary", "[", 
       RowBox[{"M_", "?", "ManifoldQ"}], "]"}], "]"}], ":=", 
     "EmptyManifold"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"ManifoldBoundary", ",", "1"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "ManifoldBoundary", "]"}], ";"}], "\n", 
   RowBox[{"(*", " ", "Formatting", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"ManifoldBoundary", "[", "M_", "]"}], ",", "fmt_"}], "]"}], ":=", 
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<\[PartialD]\>\"", ",", 
        RowBox[{"MakeBoxes", "[", 
         RowBox[{"M", ",", "fmt"}], "]"}]}], "}"}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7084f6cd-c9a7-4782-a34e-769ba4768d07"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Empty", " ", "manifold"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldQ", "[", "EmptyManifold", "]"}], "^:=", "True"}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldBoundary", "[", "EmptyManifold", "]"}], "^:=", 
     "EmptyManifold"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DimOfManifold", "[", "EmptyManifold", "]"}], "^:=", "0"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "EmptyManifold", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Formatting", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{"EmptyManifold", ",", "fmt_"}], "]"}], ":=", 
     "\"\<\[EmptySet]\>\""}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5bd17f02-2e35-467a-8fb8-875bdcf3ae65"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["6.2. Dependencies", \
"Subsection",ExpressionUUID->"3b8fcd78-c98a-4a1e-9f4d-ef7fc4f60394"],

Cell[CellGroupData[{

Cell["6.2.1. DependenciesOf", \
"Subsubsection",ExpressionUUID->"5f673dff-f986-4e76-bbec-340c0c9b0398"],

Cell["\<\
In the end, all objects are functions of parameters and manifolds (functions \
of their coordinates). We call them \"the dependencies\" of those objects. \
The function DependenciesOf returns a list of parameters and manifolds. We \
stress that we are talking about manifolds, and not about vector bundles.\
\>", "Text",ExpressionUUID->"ffb33836-2403-4acc-93c8-76db1e320828"],

Cell["\<\
SortDependencies sorts the dependencies in a \"canonical order\": first we \
have parameters, sorted in alphabetical order, and then we have manifolds, \
also sorted alphabetically. In most cases we do not need to sort the \
dependencies, and that is why DependenciesOf does not sort them. Actually, \
now it is only used when defining a tensor, just for aesthetic reasons.\
\>", "Text",ExpressionUUID->"bfe4cd03-8a65-4ca9-8537-fe6656b96eb8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SortDependencies"}]], \
"Input",ExpressionUUID->"77d98b3b-e867-48ba-a769-c5e244a01951"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`SortDependencies\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672497-5338953",ExpressionUUID->"2fbb66e5-4a08-450b-9611-\
2cb8d7f94aac"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SortDependencies", "[", "list_List", "]"}], ":=", 
   RowBox[{"DeleteDuplicates", "@", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Sort", "@", 
       RowBox[{"Select", "[", 
        RowBox[{"list", ",", "ParameterQ"}], "]"}]}], ",", 
      RowBox[{"Sort", "@", 
       RowBox[{"Select", "[", 
        RowBox[{"list", ",", "ManifoldQ"}], "]"}]}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f0972d25-2eff-4391-a6c0-cc4b95f8b0e2"],

Cell[TextData[{
 "We separate the action of the (private) function DependenciesOfIndex for \
the different types of indices. We shall see that in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " we assume that if an index belongs to a given vbundle, then the tensor \
naturally depends on the corresponding base manifold, unless otherwise \
stated. However, the dependencies of a tensor are given explicitly and are \
not computed from those of its indices. What we are doing here is taking into \
account that the CD-type indices store expressions which can add dependencies \
to those associated to the tensor."
}], "Text",ExpressionUUID->"fabab173-ae45-4ef9-8244-8b4666048d95"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfIndices", "[", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfIndices", "[", "inds__", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Union", ",", 
     RowBox[{"DependenciesOfIndex", "/@", 
      RowBox[{"IndexList", "[", "inds", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DependenciesOfIndex", "[", 
     RowBox[{"Dir", "[", "expr_", "]"}], "]"}], ":=", 
    RowBox[{"DependenciesOf", "[", "expr", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "different", " ", "elements", " ", "of", " ", "the", " ", 
     "basis", " ", "have", " ", "different", " ", "dependencies"}], ",", " ", 
    
    RowBox[{"then", " ", "this", " ", 
     RowBox[{"(", "private", ")"}], " ", "function", " ", "must", " ", "be", 
     " ", "overwritten"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DependenciesOfIndex", "[", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "basis_"}], "}"}], "]"}], ":=", 
    RowBox[{"xAct`xCoba`DependenciesOfBasis", "[", "basis", "]"}]}], ";"}], 
  " ", 
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DependenciesOfIndex", "[", 
     RowBox[{
      RowBox[{"basis_", "?", "BasisQ"}], "[", "a_", "]"}], "]"}], ":=", 
    RowBox[{"xAct`xCoba`DependenciesOfBasis", "[", "basis", "]"}]}], ";"}], 
  " ", 
  RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfIndex", "[", 
    RowBox[{"-", "x_"}], "]"}], ":=", 
   RowBox[{"DependenciesOfIndex", "[", "x", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfIndex", "[", "_Symbol", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DependenciesOfIndex", "[", "_LI", "]"}], ":=", 
    RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Other", " ", "cases"}], ",", " ", 
    RowBox[{"including", " ", "patterns"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfIndex", "[", "_", "]"}], ":=", 
   RowBox[{"{", "AnyDependencies", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"833d3406-3efb-460f-bef3-bbcf3f544bad"],

Cell["\<\
Note the difference between the functions DependenciesOf and \
DependenciesOfTensor. The former expects an expression as input, the latter \
the name of a tensor. That is, v[] could be the argument for the former, but \
v would be the argument for the latter. The same thing happens with \
ManifoldsOf and ManifoldsOfTensor. Perhaps ManifoldsOfTensor should act like \
SymmetryOfTensor, i.e., first on the whole expression with indices, and then, \
if that is not defined, on the tensor name. No, because DependenciesOf is \
already taking care of the indices of the tensor.\
\>", "Text",ExpressionUUID->"3f08387c-2ee7-4898-852c-4bae3a67f51a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DependenciesOf"}]], \
"Input",ExpressionUUID->"8bdf59ef-169b-421a-9e65-59f3fd267c1a"],

Cell[BoxData[
 StyleBox["\<\"DependenciesOf[expr] gives the list of manifolds and \
parameters upon which expr depends.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672498-5338953",ExpressionUUID->"41b83012-292e-4e43-9e65-\
141caf381070"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"expr", ":", 
     RowBox[{"(", 
      RowBox[{"_Plus", "|", "_Times"}], ")"}]}], "]"}], ":=", 
   RowBox[{"Union", "@@", 
    RowBox[{"(", 
     RowBox[{"DependenciesOf", "/@", 
      RowBox[{"List", "@@", "expr"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], "]"}], 
     "]"}], "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "var", "]"}], ",", 
     RowBox[{"DependenciesOf", "[", "orig", "]"}], ",", 
     RowBox[{"DependenciesOf", "/@", "coeffs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}], ",", 
     RowBox[{"DependenciesOfIndices", "[", "inds", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", 
     "]"}], "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
     RowBox[{"DependenciesOf", "[", "expr", "]"}], ",", 
     RowBox[{"DependenciesOfIndices", "[", "inds", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"CovD", "[", 
     RowBox[{"expr_", ",", "ders___", ",", 
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}]}], "]"}], "]"}], 
   ":=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", 
      RowBox[{"CovD", "[", 
       RowBox[{"expr", ",", "ders"}], "]"}], "]"}], ",", 
     RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
     RowBox[{"DependenciesOfIndices", "[", "inds", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "v", "]"}], ",", 
     RowBox[{"DependenciesOf", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "__", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"DependenciesOf", "[", "expr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"OverDot", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"DependenciesOf", "[", "expr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DependenciesOf", "[", 
     RowBox[{"param_Symbol", "?", "ParameterQ"}], "]"}], ":=", 
    RowBox[{"{", "param", "}"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "must", " ", "be", " ", "overwritten", " ", "if", " ", 
    "invalid"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
     RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "expr", "]"}], ",", 
     RowBox[{"DependenciesOfInertHead", "[", "ih", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{"prod_", "?", "ProductQ"}], "[", "exprs___", "]"}], "]"}], ":=", 
   
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"DependenciesOf", "/@", 
      RowBox[{"{", "exprs", "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{"sf_", "?", "ScalarFunctionQ"}], "[", "args__", "]"}], "]"}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"DependenciesOf", "/@", 
      RowBox[{"{", "args", "}"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Derivative", "[", "__Integer", "]"}], "[", 
      RowBox[{"sf_", "?", "ScalarFunctionQ"}], "]"}], "[", "args__", "]"}], 
    "]"}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"DependenciesOf", "/@", 
      RowBox[{"{", "args", "}"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"x_Symbol", "?", "ParameterQ"}], "]"}], ":=", 
   RowBox[{"{", "x", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"x_Symbol", "?", "ConstantSymbolQ"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"expr_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"DependenciesOf", "[", "expr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", "_", "]"}], ":=", 
   RowBox[{"{", "AnyDependencies", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DependenciesOf", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DependenciesOf", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c33addbf-1cf5-41c7-a16f-31528f3505ca"],

Cell["\<\
Note also that ManifoldsOf and ParametersOf are public functions, but \
ManifoldsOfTensor and ParametersOfTensor are private. The functions \
ManifoldsOf and ManifoldsOfTensor are only called by ZeroDerivativeQ. The \
function ParametersOf is used by ParamD.

Dependencies of pullbacks are handled below in section 9.\
\>", "Text",ExpressionUUID->"069f7113-4e9b-4873-84c5-61749c297561"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ManifoldsOf"}]], \
"Input",ExpressionUUID->"25f9f045-15b4-49e0-91a1-a8eb892b8fee"],

Cell[BoxData[
 StyleBox["\<\"ManifoldsOf[expr] gives the list of manifolds on which expr \
lives.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672500-5338953",ExpressionUUID->"1e2df1eb-6a8a-4639-9ae9-\
e38e0dde4942"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ManifoldsOfTensor"}]], \
"Input",ExpressionUUID->"979604d5-23cc-46b3-a85d-428057e900aa"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`ManifoldsOfTensor\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672501-5338953",ExpressionUUID->"9e78af51-6513-471b-9ed6-\
374405fdb14d"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldsOf", "[", "expr_", "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "expr", "]"}], ",", "ManifoldQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldsOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}], ",", "ManifoldQ"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ManifoldsOf", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ManifoldsOf", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6a39131b-1ff7-44e2-9906-bc95c13456b3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ParametersOf"}]], \
"Input",ExpressionUUID->"5bf13bf7-e742-44b2-89fa-52389a602bd9"],

Cell[BoxData[
 StyleBox["\<\"ParametersOf[expr] gives the list of parameters on which expr \
depends.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672503-5338953",ExpressionUUID->"686bcc36-c3b0-4b0d-992b-\
290e08568180"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ParametersOfTensor"}]], \
"Input",ExpressionUUID->"84b765a4-df75-41fe-bf5b-b8efaa17ecb9"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`ParametersOfTensor\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672504-5338953",ExpressionUUID->"cbc679d1-9df0-4963-8674-\
274ef23da22f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ParametersOf", "[", "expr_", "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "expr", "]"}], ",", "ParameterQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ParametersOfTensor", "[", "head_", "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", "head", "]"}], ",", "ParameterQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ParametersOf", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ParametersOf", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"00e348f5-974e-4330-b604-0565d05a8a63"],

Cell["Very dirty trick:", \
"Text",ExpressionUUID->"e2b98228-2a60-4c73-abd8-10840810e81e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "AnyDependencies"}]], \
"Input",ExpressionUUID->"321d0522-d15d-49a7-ac85-75311a0863e0"],

Cell[BoxData[
 StyleBox["\<\"AnyDependencies is an internal symbol of xTensor returned by \
DependenciesOf acting on an unknown expression (unregistered symbols, \
patterns, etc.).\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672505-5338953",ExpressionUUID->"17c9361d-a326-4406-b189-\
29eb308dfe5a"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldQ", "[", "AnyDependencies", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ParameterQ", "[", "AnyDependencies", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "AnyDependencies", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0a7e684d-f549-489d-b6ed-9891513f35a8"],

Cell["\<\
The most important role of DependenciesOf is through ManifoldsOf and \
ZeroDerivativeQ. It is conceivable that it will be relevant as well when \
working with charts.\
\>", "Text",ExpressionUUID->"74b9c30c-4fe0-492f-bb35-78a43a450ed8"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.2.2. Restrictions: At", \
"Subsubsection",ExpressionUUID->"89f735cd-8d17-41e2-ae18-3021bb79d8e1"],

Cell["\<\
At is an inert head. It only restricts to submanifolds, not to values of \
parameters:\
\>", "Text",ExpressionUUID->"28328404-8fed-4e46-a15c-b2bd65886bb8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InertHeadQ", "[", "At", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LinearQ", "[", "At", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"At", "[", 
    RowBox[{"tensor_Plus", ",", "P_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"At", "[", 
      RowBox[{"#", ",", "P"}], "]"}], "&"}], "/@", "tensor"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"At", "[", 
    RowBox[{"tensor_Times", ",", "P_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"At", "[", 
      RowBox[{"#", ",", "P"}], "]"}], "&"}], "/@", "tensor"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"At", "[", 
    RowBox[{"x_", ",", "P_"}], "]"}], ":=", 
   RowBox[{"x", "/;", 
    RowBox[{
     RowBox[{"ManifoldsOf", "[", "x", "]"}], "===", 
     RowBox[{"{", "}"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInfo", "[", "At", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<inert head\>\"", ",", 
     "\"\<Generic head to denote restrictions to submanifolds.\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AppendToUnevaluated", "[", 
   RowBox[{"$InertHeads", ",", "At"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"29a31489-e490-44db-92fd-473fee8e7ed6"],

Cell["The main property is the following:", \
"Text",ExpressionUUID->"83d2985f-a39c-49a6-806a-d2177c695a9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOf", "[", 
    RowBox[{"At", "[", 
     RowBox[{"expr_", ",", "sub_"}], "]"}], "]"}], "^:=", 
   RowBox[{"Replace", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "expr", "]"}], ",", 
     RowBox[{
      RowBox[{"dep_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"#", ",", "sub"}], "]"}], "&"}], ")"}]}], "\[RuleDelayed]", 
      "sub"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f0b20422-21a9-4c38-97ec-f3a0aff753dd"],

Cell["Formatting (YES, the At?InertHeadQ is needed there):", \
"Text",ExpressionUUID->"13556806-5038-43ea-9b67-bf3d0bc44c4f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"At", "?", "HeldInertHeadQ"}], "[", 
      RowBox[{"expr_", ",", "sub_"}], "]"}], ",", "fmt_"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{"expr", ",", "fmt"}], "]"}], ",", 
      RowBox[{"SubscriptBox", "[", 
       RowBox[{"\"\<|\>\"", ",", 
        RowBox[{"MakeBoxes", "[", 
         RowBox[{"sub", ",", "fmt"}], "]"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"85c9bacc-8fe0-4f34-8287-705849c1216f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"At", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "At", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9c0edff0-18e8-4f4e-9912-d4b0a7c2a0f6"],

Cell["\<\
New idea. I now think that we could use At for multiple purposes, not just \
restriction of tensor fields. We can also restrict vbundles, mappings, bases, \
etc.

There are two ways we can do this: either we use At for everything, so that \
the properties of At[e, sub] are basically the properties of e, or we \
introduce different heads, say TensorAt, BasisAt, VSpaceAt, etc. We would need:

\tAt[texpr, sub]
\tTensorAt[T, sub]
\tVBundleAt[vb, sub]
\tBasisAt[vb, sub]\t\tDo we need a ChartAt[chart, sub] ? I don\
\[CloseCurlyQuote]t think so. Recall that charts are also mappings.

\tI think we will not need to use At[index, sub], but it is not fully clear. \
This is related to our handling of starred indices in mappings.
\tIs there such a thing as the restriction of a covariant derivative? I\
\[CloseCurlyQuote]ll start assuming there isn\[CloseCurlyQuote]t.
\tWe don\[CloseCurlyQuote]t need ManifoldAt[M, sub], because that\
\[CloseCurlyQuote]s just sub.
\t
\tThe most difficult case is that of a mapping, because we can have the \
restriction of the domain of a mapping. Note however that the restriction of \
a mapping, even if it is to a point, is still a mapping, and not the \
evaluation of the mapping on that submanifold. So now I\[CloseCurlyQuote]m \
confused: Is really At a restriction or is it an evaluation? I tend to \
believe that we need both concepts separately, and that At as an evaluation \
is more important. We need the At that makes At[TM, p] == TpM in standard \
differential geometry. And for the evaluation case, do we need At[map[], P] \
or At[map, P] ? I think it is the former. The latter does not make much sense.

For tensors and bases we can see At as \[OpenCurlyDoubleQuote]evaluating the \
field character at a point\[CloseCurlyDoubleQuote], but for vbundles we don\
\[CloseCurlyQuote]t have a field, but a disjoint union, so the concept of \
restriction seems better. Well At[vbundle, p] is effectively InverseFunction[\
\[Pi]][p] for the natural projection \[Pi] of the vbundle.

Clarity seems to prefer the use of TensorAt, etc, but probably it is simpler \
and safer to use just At. Speedwise, it would be better to use separate \
symbols, to load each one with less definitions. Actually, I think this last \
argument is the most important one and we should indeed have separate \
symbols. In conclusion, At only acts on tensor field expressions and \
evaluates them at a point. Then we would have

\tTensorAt[tensor, P]  and  MetricAt[metric, P]
\tBasisAt[basis, P]
\tVSpaceAt[vbundle, P]

This VSpace[vbundle, P] seems to be pointing in the direction of an eventual \
FiberAt[fiberbundle, P].\
\>", "Text",ExpressionUUID->"f891798f-3d1d-4d3f-878b-20513de56028"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3. Mappings", \
"Subsection",ExpressionUUID->"7fb323f5-b728-4e18-bcde-dfc6095dc632"],

Cell[CellGroupData[{

Cell["6.3.0. Comments", \
"Subsubsection",ExpressionUUID->"b536ab82-2530-4d8e-a8a0-37cf58ae575d"],

Cell["\<\
Mappings are \[OpenCurlyDoubleQuote]functions\[CloseCurlyDoubleQuote] that \
act on points or subsets of a manifold, returning points or subsets of \
another manifold (which could be the same).\
\>", "Text",ExpressionUUID->"ac53875f-5e11-4b9c-baab-8364b6c33e58"],

Cell["\<\
The main notation is \[Phi] : M -> N, with dom(\[Phi])=M, im(\[Phi])=N and \
range \[Phi](M). \
\>", "Text",ExpressionUUID->"5baef59c-71f9-43bd-aa9b-4dd43c97fe7a"],

Cell["\<\
In principle we could have declared them to be fields, but we want to use \
\[Phi][P] notation for the action of a mapping on a point.\
\>", "Text",ExpressionUUID->"d98389b7-bcdd-499d-9453-c9ac8f117660"],

Cell["\<\
Mappings will be either registered symbols or composition (SmallCircle) of \
those registered symbols. The only mapping which is given in advance is \
IdentityMapping[M], and note that it is not a symbol.\
\>", "Text",ExpressionUUID->"ac16ce24-7569-4b73-8fbe-207280be472b"],

Cell["\<\
All our mappings are assumed to be smooth mappings, and we only declare their \
local properties. As usual the global properties are taken to be the best \
possible compatible with those local assumptions.\
\>", "Text",ExpressionUUID->"dae3e706-5944-4abd-be10-db7147de5297"],

Cell["\<\
We register a domain manifold and an image manifold for each mapping. Then \
there is the range of the mapping, which does not necessarily coincide with \
the image. The range of a mapping is considered a submanifold of the image \
(using our \[OpenCurlyDoubleQuote]local\[CloseCurlyDoubleQuote] concept of \
manifold).\
\>", "Text",ExpressionUUID->"74c35e61-5aca-4387-bb15-66904b605961"],

Cell["\<\
We don\[CloseCurlyQuote]t use properties \
InjectiveMappingQ/SurjectiveMappingQ, because those are global properties of \
the mapping, and xAct should handle only local properties. Local injectivity \
is ImmmersionQ and local surjectivity is SubmersionQ. That is what we use, \
with defaults Automatic, meaning True if dimensions allow, and False otherwise.

If the mapping is only an immersion then there is no full notion of inverse \
mapping, because we cannot define it on all of N. I have tried to define it \
on \[Phi](M) but the programming becomes complicated because we need to \
handle the subvbundle of TN restricted to \[Phi](M), and also because the map \
\[Phi] restricted to the image \[Phi](M) is really a different map, which \
complicates matters. In particular it is difficult to come up with a good \
notation for the indices of the tangent mapping of such inverse of \[Phi]. We \
don\[CloseCurlyQuote]t follow this route. What we currently do instead is to \
assume that there is always a (nonunique) left-inverse map from N to M which \
does the right thing on \[Phi](M) and is arbitrarily extended to the rest of \
N. We can take it to be a submersion from N to M.

Anyway it might be useful to have a way to restrict mappings to submanifolds, \
something like MappingAt[\[Phi], submanifold], or perhaps RestrictedMapping[\
\[Phi], submanifold].

If the mapping is only a submersion then there is a notion of right inverse \
(we actually work as if the mapping was a global submersion). This right \
inverse is not unique in general, but can be chosen to be an immersion. It \
will be unique if we are working with a diffeormorphism.

If the mapping is not an immersion nor a submersion then there is no inverse \
associated.\
\>", "Text",ExpressionUUID->"fd4f2c87-b1a6-492c-bf6e-4aa350a670f1"],

Cell["\<\
Some notes on global properties (this is proper use of the terminology):
\t- Being a diffeomorphism is a global property, but if a map is both an \
immersion and a submersion then it is a local diffeomorphism. To be a \
(global) diffeomorphism it would have to be bijective as well.
\t- Local injectivity (immersion) does not imply global injectivity. Then we \
would talk about injective immersions.
\t- An embedding is an injective immersion which is also a topological \
embedding. Then M is diffeomorphic to \[Phi](M). An immersion is a local \
embedding. If M is compact then an injective immersion is an embedding.\
\>", "Text",ExpressionUUID->"0a29dc35-eb62-4fca-b7cf-bdf1d9bad1c5"],

Cell["Our manifolds are all real, and hence the mappings too.", \
"Text",ExpressionUUID->"e5328fd6-b65c-40d4-99bb-8bdab3085b1c"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.1. IdentityMapping", \
"Subsubsection",ExpressionUUID->"98e2df71-43d9-4075-a32e-81aacc07ac03"],

Cell["\<\
IdentityMapping[M] maps the manifold M into itself. Note that it stays as \
IdentityMapping[M], instead of converting into IdentityMappingM, as we would \
have done in previous versions of xTensor.\
\>", "Text",ExpressionUUID->"d842f515-c41c-4d2f-9256-20757794cbee"],

Cell["Properties:", \
"Text",ExpressionUUID->"15716177-2bc4-4365-8737-2e33e78b6030"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MappingQ", "[", 
    RowBox[{"IdentityMapping", "[", 
     RowBox[{"M_", "?", "ManifoldQ"}], "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseMapping", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", 
   RowBox[{"IdentityMapping", "[", "M", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingDomain", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", "M"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingImage", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", "M"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImmersionQ", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubmersionQ", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TangentTensor", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", "delta"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7db24a1a-9b43-44c5-8f0a-58ed3be0c998"],

Cell["Action:", "Text",ExpressionUUID->"28adedbb-46d4-4521-97de-63bf65d1324f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "[", "point_", "]"}], ":=", 
   RowBox[{"point", "/;", 
    RowBox[{"SubmanifoldQ", "[", 
     RowBox[{"M", ",", "point"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e4cc9c0c-b8cf-430e-af8b-fc33e8e14256"],

Cell["Formatting:", \
"Text",ExpressionUUID->"998b97d1-dbf2-4ddc-adab-c49e40df0227"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"IdentityMapping", "[", "M_", "]"}], "]"}], "^:=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<\\!\\(Id\\_\>\"", ",", 
     RowBox[{"PrintAs", "[", "M", "]"}], ",", "\"\<\\)\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"IdentityMapping", "[", "M_", "]"}], ",", "StandardForm"}], 
    "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<Id\>\"", ",", 
     RowBox[{"MakeBoxes", "[", 
      RowBox[{"M", ",", "StandardForm"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"056cdfed-64a5-46c8-8653-f184a6664935"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.2. Definition", \
"Subsubsection",ExpressionUUID->"4b4c1f49-0d56-496c-9a02-c024f3845617"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DefMapping"}]], \
"Input",ExpressionUUID->"deefaf40-b0dc-4de8-bde2-6d7013e7974b"],

Cell[BoxData[
 StyleBox["\<\"DefMapping[phi, M1->M2] defines phi to be a mapping having \
manifold M1 as domain and manifold M2 as image.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672507-5338953",ExpressionUUID->"c97492d0-d666-4b5a-ab19-\
6d5e895644cf"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefMapping", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ImmersionQ", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SubmersionQ", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InverseMapping", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<mapping\>\"", ",", "\"\<\>\""}], "}"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefMapping", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefMapping", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefMapping", "[", 
     RowBox[{"phi_", ",", 
      RowBox[{"domain_", "\[Rule]", "image_"}], ",", 
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Catch", "@", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "type", ",", "tbundle", ",", "immQ", ",", "subQ", ",", "inv", ",", 
         "master", ",", "pa", ",", "pns", ",", "info", ",", "definvQ", ",", 
         "domdim", ",", "imdim", ",", "tdom", ",", "tim", ",", "tindsQ", ",", 
         "iindsQ"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "immQ", ",", "subQ", ",", "inv", ",", "master", ",", "pa", ",", 
           "pns", ",", "info"}], "}"}], "=", 
         RowBox[{"OptionValue", "[", 
          RowBox[{"{", 
           RowBox[{
           "ImmersionQ", ",", "SubmersionQ", ",", "InverseMapping", ",", 
            "Master", ",", "PrintAs", ",", "ProtectNewSymbol", ",", 
            "DefInfo"}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"1.", " ", "Name", " ", 
          RowBox[{"validation", ":", " ", 
           RowBox[{
           "the", " ", "symbol", " ", "might", " ", "be", " ", "a", " ", 
            "chart", " ", "already"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ChartQ", "[", "phi", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"MappingQ", "[", "phi", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"The", " ", "mapping", " ", "already", " ", 
              RowBox[{"exists", ".", " ", "This"}], " ", "is", " ", "a", " ", 
              "duplicated", " ", 
              RowBox[{"name", ".", " ", "Probably"}], " ", "this", " ", 
              "never", " ", "happens"}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Throw", "@", 
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{"ValidateSymbol", "::", "used"}], ",", "phi", ",", 
               "\"\<as a mapping\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"(*", " ", 
             RowBox[{"Coordinate", " ", "mapping", " ", "being", " ", 
              RowBox[{"defined", ".", " ", "Symbol"}], " ", "validation", " ",
               "already", " ", 
              RowBox[{"performed", ".", " ", "Do"}], " ", "nothing"}], " ", 
             "*)"}], "\[IndentingNewLine]", "Null"}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Noncoordinate", " ", 
            RowBox[{"mapping", ".", " ", "Perform"}], " ", "symbol", " ", 
            "validation"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ValidateSymbol", "[", "phi", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ValidateSymbolInSession", "[", "phi", "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"2.", " ", "Consistency", " ", "checks"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"ManifoldQ", "[", "domain", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefMapping", "::", "unknown"}], ",", "\"\<manifold\>\"",
              ",", "domain"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"ManifoldQ", "[", "image", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefMapping", "::", "unknwon"}], ",", "\"\<manifold\>\"",
              ",", "image"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"domdim", "=", 
         RowBox[{"DimOfManifold", "[", "domain", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"imdim", "=", 
         RowBox[{"DimOfManifold", "[", "image", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"immQ", "===", "Automatic"}], ",", "\[IndentingNewLine]", 
          RowBox[{"immQ", "=", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"domdim", "\[LessEqual]", "imdim"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"TrueOrFalse", "[", "immQ", "]"}]}], ",", 
             RowBox[{"Throw", "@", 
              RowBox[{"Message", "[", 
               RowBox[{
                RowBox[{"DefMapping", "::", "unknown"}], ",", 
                "\"\<value of option ImmersionQ\>\"", ",", "immQ"}], 
               "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"immQ", "&&", 
              RowBox[{"domdim", ">", "imdim"}]}], ",", 
             RowBox[{"Throw", "@", 
              RowBox[{"Message", "[", 
               RowBox[{
                RowBox[{"DefMapping", "::", "error"}], ",", 
                "\"\<Mapping cannot be an immersion because image dimension \
is smaller than domain dimension.\>\""}], "]"}]}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"subQ", "===", "Automatic"}], ",", "\[IndentingNewLine]", 
          RowBox[{"subQ", "=", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"domdim", "\[GreaterEqual]", "imdim"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"TrueOrFalse", "[", "subQ", "]"}]}], ",", 
             RowBox[{"Throw", "@", 
              RowBox[{"Message", "[", 
               RowBox[{
                RowBox[{"DefMapping", "::", "unknown"}], ",", 
                "\"\<value of option SubmersionQ\>\"", ",", "subQ"}], 
               "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"subQ", "&&", 
              RowBox[{"domdim", "<", "imdim"}]}], ",", 
             RowBox[{"Throw", "@", 
              RowBox[{"Message", "[", 
               RowBox[{
                RowBox[{"DefMapping", "::", "error"}], ",", 
                "\"\<Mapping cannot be a submersion because image dimension \
is larger than domain dimension.\>\""}], "]"}]}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Check", " ", "for", " ", "the", " ", "inverse", " ", "mapping"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"definvQ", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"immQ", "||", "subQ"}], ")"}], "&&", 
          RowBox[{
           RowBox[{"Quiet", "[", 
            RowBox[{"Catch", "[", 
             RowBox[{"InverseMapping", "[", "phi", "]"}], "]"}], "]"}], "===",
            "Null"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"definvQ", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"inv", "===", "Automatic"}], ",", 
             RowBox[{"inv", "=", 
              RowBox[{"GiveSymbol", "[", 
               RowBox[{"InverseMapping", ",", "phi"}], "]"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ValidateSymbol", "@@", 
            RowBox[{"{", "inv", "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"ValidateSymbolInSession", "[", "inv", "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"3.", " ", "Register", " ", "mapping", " ", "properties"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"MakeDefInfo", "[", 
         RowBox[{"DefMapping", ",", "phi", ",", "info"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{"DefMapping", ",", "\"\<Beginning\>\"", ",", "phi", ",", 
          RowBox[{"{", 
           RowBox[{"domain", ",", "image"}], "}"}], ",", "options"}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"AppendToUnevaluated", "[", 
         RowBox[{"$Mappings", ",", "phi"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MappingQ", "[", "phi", "]"}], "^=", "True"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DefInfo", "[", "phi", "]"}], "^=", "info"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetPrintAs", "[", 
         RowBox[{"phi", ",", 
          RowBox[{"PrintAsString", "[", 
           RowBox[{"phi", ",", "pa"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SymbolRelations", "[", 
         RowBox[{"phi", ",", "master", ",", 
          RowBox[{"{", 
           RowBox[{"domain", ",", "image"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MappingDomain", "[", "phi", "]"}], "^=", "domain"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MappingImage", "[", "phi", "]"}], "^=", "image"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ImmersionQ", "[", "phi", "]"}], "^=", "immQ"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SubmersionQ", "[", "phi", "]"}], "^=", "subQ"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "This", " ", "is", " ", "the", " ", "main", " ", "consequence", " ", 
          "of", " ", "being", " ", "a", " ", "submersion"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"subQ", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"phi", "[", "domain", "]"}], "=", "image"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"immQ", ",", 
            RowBox[{"phi", "/:", 
             RowBox[{"SubmanifoldQ", "[", 
              RowBox[{"image", ",", 
               RowBox[{"phi", "[", "domain", "]"}]}], "]"}], "=", "True"}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"4.", " ", "Register", " ", "InverseMapping"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"definvQ", ",", "\[IndentingNewLine]", 
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"iphi", "=", "inv"}], "}"}], ",", "\[IndentingNewLine]", 
            
            RowBox[{
             RowBox[{
              RowBox[{"InverseMapping", "[", "phi", "]"}], "^=", "iphi"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"InverseMapping", "[", "iphi", "]"}], "^=", "phi"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
              "Define", " ", "inverse", " ", "mapping", " ", "and", " ", 
               "its", " ", "differential"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"DefMapping", "[", 
              RowBox[{"iphi", ",", 
               RowBox[{"image", "\[Rule]", "domain"}], ",", 
               RowBox[{"ImmersionQ", "\[Rule]", "subQ"}], ",", 
               RowBox[{"SubmersionQ", "\[Rule]", "immQ"}], ",", 
               RowBox[{"Master", "\[Rule]", "phi"}], ",", 
               RowBox[{"PrintAs", "\[RuleDelayed]", 
                RowBox[{"GiveOutputString", "[", 
                 RowBox[{"InverseMapping", ",", "phi"}], "]"}]}], ",", 
               RowBox[{"DefInfo", "\[RuleDelayed]", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"immQ", "&&", "subQ"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"\"\<inverse mapping\>\"", ",", "\"\<\>\""}], 
                   "}"}], ",", "immQ", ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<left-inverse mapping\>\"", ",", 
                    "\"\<Assuming arbitrary extension.\>\""}], "}"}], ",", 
                  "subQ", ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<right-inverse mapping\>\"", ",", 
                    "\"\<Not uniquely defined.\>\""}], "}"}]}], "]"}]}]}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
              "For", " ", "a", " ", "submersion", " ", "there", " ", "is", 
               " ", "a", " ", "right", " ", "inverse"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"subQ", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"phi", "[", 
                  RowBox[{"iphi", "[", "x_", "]"}], "]"}], ":=", 
                 RowBox[{"x", "/;", 
                  RowBox[{"SubmanifoldQ", "[", 
                   RowBox[{
                    RowBox[{"phi", "[", "domain", "]"}], ",", "x"}], 
                   "]"}]}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"phi", "/:", 
                 RowBox[{"SmallCircle", "[", 
                  RowBox[{"phi", ",", "iphi"}], "]"}], "=", 
                 RowBox[{"IdentityMapping", "[", "image", "]"}]}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
              "For", " ", "an", " ", "immersion", " ", "there", " ", "is", 
               " ", "a", " ", "left", " ", "inverse"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"immQ", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"iphi", "[", 
                  RowBox[{"phi", "[", "x_", "]"}], "]"}], "^:=", 
                 RowBox[{"x", "/;", 
                  RowBox[{"SubmanifoldQ", "[", 
                   RowBox[{"domain", ",", "x"}], "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"phi", "/:", 
                 RowBox[{"SmallCircle", "[", 
                  RowBox[{"iphi", ",", "phi"}], "]"}], "=", 
                 RowBox[{"IdentityMapping", "[", "domain", "]"}]}], ";"}]}], 
              "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"Before", " ", "proceeding"}], ",", " ", 
          RowBox[{"if", " ", "the", " ", 
           RowBox[{"domain", "/", "image"}], " ", "is", " ", 
           RowBox[{"Reals", "[", "_", "]"}], " ", "check", " ", "whether", 
           " ", "there", " ", "are", " ", "indices", " ", "already"}]}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"tdom", "=", 
         RowBox[{"Tangent", "[", "domain", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tim", "=", 
         RowBox[{"Tangent", "[", "image", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "domain", "]"}], "===", "Reals"}], " ", "&&",
            " ", 
           RowBox[{
            RowBox[{"Quiet", "[", 
             RowBox[{"Catch", "[", 
              RowBox[{"IndicesOfVBundle", "[", "tdom", "]"}], "]"}], "]"}], "===",
             "Null"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"tindsQ", "=", "True"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Quiet", "@", 
            RowBox[{"RegisterIndices", "[", 
             RowBox[{"tdom", ",", 
              RowBox[{"Take", "[", 
               RowBox[{
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                 "xAct`xCoba`Private`$TangentRealsTemporaryIndices", ",", 
                  RowBox[{"_", "?", "AbstractIndexQ"}]}], "]"}], ",", "4"}], 
               "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "image", "]"}], "===", "Reals"}], "&&", " ", 
           
           RowBox[{
            RowBox[{"Quiet", "[", 
             RowBox[{"Catch", "[", 
              RowBox[{"IndicesOfVBundle", "[", "tim", "]"}], "]"}], "]"}], "===",
             "Null"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"iindsQ", "=", "True"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Quiet", "@", 
            RowBox[{"RegisterIndices", "[", 
             RowBox[{"tim", ",", 
              RowBox[{"Take", "[", 
               RowBox[{
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                 "xAct`xCoba`Private`$TangentRealsTemporaryIndices", ",", 
                  RowBox[{"_", "?", "AbstractIndexQ"}]}], "]"}], ",", "4"}], 
               "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "5.", " ", "Define", " ", "the", " ", "tangent", " ", "mapping", " ",
           "tensor"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"dphi", "=", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"TangentTensor", ",", "phi"}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"index1", ",", "index2"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"{", "index1", "}"}], "=", 
              RowBox[{"GetIndicesOfVBundle", "[", 
               RowBox[{"tdom", ",", "1"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"This", " ", "declares", " ", "the", " ", "pullback"}],
                "-", 
               RowBox[{
               "vundle", " ", "indices", " ", "for", " ", "the", " ", "first",
                 " ", "time"}]}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", "index2", "}"}], "=", 
              RowBox[{"GetIndicesOfVBundle", "[", 
               RowBox[{
                RowBox[{"PullBackVBundle", "[", 
                 RowBox[{"tim", ",", "phi"}], "]"}], ",", "1"}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"DefTensor", "[", 
              RowBox[{
               RowBox[{"dphi", "[", 
                RowBox[{
                 RowBox[{"-", "index1"}], ",", "index2"}], "]"}], ",", 
               RowBox[{"{", "domain", "}"}], ",", 
               RowBox[{"Master", "\[Rule]", "phi"}], ",", 
               RowBox[{"PrintAs", "\[RuleDelayed]", 
                RowBox[{"GiveOutputString", "[", 
                 RowBox[{"TangentTensor", ",", "phi"}], "]"}]}], ",", 
               RowBox[{"DefInfo", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<mapping differential tensor\>\"", ",", "\"\<\>\""}], 
                 "}"}]}]}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "6.", " ", "Relations", " ", "between", " ", "the", " ", "tangent", 
          " ", 
          RowBox[{"mappings", ".", " ", "Both"}], " ", "dphi", " ", "and", 
          " ", "diphi", " ", "are", " ", "declared", " ", "at", " ", "this", 
          " ", "moment"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"definvQ", " ", ",", "\[IndentingNewLine]", 
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"dphi", "=", 
               RowBox[{"TangentTensor", "[", "phi", "]"}]}], ",", 
              RowBox[{"diphi", "=", 
               RowBox[{"TangentTensor", "[", "inv", "]"}]}], ",", 
              RowBox[{"iphi", "=", "inv"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Inv", "[", "dphi", "]"}], "^=", 
              RowBox[{"Precompose", "[", 
               RowBox[{"diphi", ",", "phi"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Inv", "[", "diphi", "]"}], "^=", 
              RowBox[{"Precompose", "[", 
               RowBox[{"dphi", ",", "iphi"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "index1", ",", "index2", ",", "index3", ",", "index4", ",", 
                 "index5", ",", "index6", ",", "index7", ",", "index8"}], 
                "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"index1", ",", "index3"}], "}"}], "=", 
                 RowBox[{"GetIndicesOfVBundle", "[", 
                  RowBox[{"tdom", ",", "2"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"index2", ",", "index4"}], "}"}], "=", 
                 RowBox[{"GetIndicesOfVBundle", "[", 
                  RowBox[{
                   RowBox[{"PullBackVBundle", "[", 
                    RowBox[{"tim", ",", "phi"}], "]"}], ",", "2"}], "]"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"index5", ",", "index7"}], "}"}], "=", 
                 RowBox[{"GetIndicesOfVBundle", "[", 
                  RowBox[{"tim", ",", "2", ",", 
                   RowBox[{"{", 
                    RowBox[{"index1", ",", "index3"}], "}"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"index6", ",", "index8"}], "}"}], "=", 
                 RowBox[{"GetIndicesOfVBundle", "[", 
                  RowBox[{
                   RowBox[{"PullBackVBundle", "[", 
                    RowBox[{"tdom", ",", "iphi"}], "]"}], ",", "2", ",", 
                   RowBox[{"{", 
                    RowBox[{"index2", ",", "index4"}], "}"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"ImmersionQ", "[", "phi", "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"xTagSetDelayed", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dphi", ",", 
                    RowBox[{
                    RowBox[{"dphi", "[", 
                    RowBox[{
                    RowBox[{"-", "index1_"}], ",", "index2_"}], "]"}], 
                    RowBox[{
                    RowBox[{"Precompose", "[", 
                    RowBox[{"diphi", ",", "phi"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "index2_"}], ",", "index3_"}], "]"}]}]}], 
                    "}"}], ",", 
                    RowBox[{"delta", "[", 
                    RowBox[{
                    RowBox[{"-", "index1"}], ",", "index3"}], "]"}]}], "]"}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"xTagSetDelayed", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"diphi", ",", 
                    RowBox[{
                    RowBox[{"diphi", "[", 
                    RowBox[{
                    RowBox[{"-", "index5_"}], ",", "index6_"}], "]"}], 
                    RowBox[{
                    RowBox[{"Precompose", "[", 
                    RowBox[{"dphi", ",", "iphi"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "index8_"}], ",", "index5_"}], "]"}]}]}], 
                    "}"}], ",", 
                    RowBox[{"delta", "[", 
                    RowBox[{
                    RowBox[{"-", "index8"}], ",", "index6"}], "]"}]}], "]"}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"xTagSet", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dphi", ",", 
                    RowBox[{"InvertibleQ", "[", 
                    RowBox[{"dphi", ",", "Right"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"xTagSet", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"diphi", ",", 
                    RowBox[{"InvertibleQ", "[", 
                    RowBox[{"diphi", ",", "Left"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"SubmersionQ", "[", "phi", "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"xTagSetDelayed", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dphi", ",", 
                    RowBox[{
                    RowBox[{"dphi", "[", 
                    RowBox[{
                    RowBox[{"-", "index1_"}], ",", "index2_"}], "]"}], 
                    RowBox[{
                    RowBox[{"Precompose", "[", 
                    RowBox[{"diphi", ",", "phi"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "index4_"}], ",", "index1_"}], "]"}]}]}], 
                    "}"}], ",", 
                    RowBox[{"delta", "[", 
                    RowBox[{
                    RowBox[{"-", "index4"}], ",", "index2"}], "]"}]}], "]"}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"xTagSetDelayed", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"diphi", ",", 
                    RowBox[{
                    RowBox[{"diphi", "[", 
                    RowBox[{
                    RowBox[{"-", "index5_"}], ",", "index6_"}], "]"}], 
                    RowBox[{
                    RowBox[{"Precompose", "[", 
                    RowBox[{"dphi", ",", "iphi"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "index6_"}], ",", "index7_"}], "]"}]}]}], 
                    "}"}], ",", 
                    RowBox[{"delta", "[", 
                    RowBox[{
                    RowBox[{"-", "index5"}], ",", "index7"}], "]"}]}], "]"}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"xTagSet", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dphi", ",", 
                    RowBox[{"InvertibleQ", "[", 
                    RowBox[{"dphi", ",", "Left"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"xTagSet", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"diphi", ",", 
                    RowBox[{"InvertibleQ", "[", 
                    RowBox[{"diphi", ",", "Right"}], "]"}]}], "}"}], ",", 
                    "True"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
                ";"}]}], "\[IndentingNewLine]", "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Remove", " ", "temporary", " ", "indices"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"tindsQ", ",", 
          RowBox[{"RemoveIndices", "[", 
           RowBox[{"tdom", ",", "All"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"iindsQ", ",", 
          RowBox[{"RemoveIndices", "[", 
           RowBox[{"tim", ",", "All"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{"DefMapping", ",", "\"\<End\>\"", ",", "phi", ",", 
          RowBox[{"{", 
           RowBox[{"domain", ",", "image"}], "}"}], ",", "options"}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"pns", ",", 
          RowBox[{"Protect", "[", "phi", "]"}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Other", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefMapping", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefMapping", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e097d353-f84e-484f-8d16-ce50b141048c"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.3. Undefinition", \
"Subsubsection",ExpressionUUID->"33406f0d-f826-4446-a619-41086cbb3521"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefMapping"}]], \
"Input",ExpressionUUID->"62fad891-2e3c-41cf-82b8-e0ce902bb375"],

Cell[BoxData[
 StyleBox["\<\"UndefMapping[phi] undefines the mapping phi.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672509-5338953",ExpressionUUID->"d46c9f4b-ed25-48b8-a7e1-\
0cb17a0fdf95"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefMapping", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "MappingQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefMapping", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefMapping", "[", "phi_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"servants", "=", 
        RowBox[{"ServantsOf", "[", "phi", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "@", 
          RowBox[{"MappingQ", "[", "phi", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefMapping", "::", "unknown"}], ",", "\"\<mapping\>\"",
             ",", "phi"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "phi", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefMapping", ",", "\"\<Beginning\>\"", ",", "phi"}], "]"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "phi", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "phi", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Undefine", " ", "servants"}], ",", " ", 
         RowBox[{"including", " ", "the", " ", "tangent", " ", "map"}]}], " ",
         "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Undefine", " ", "indices", " ", "of", " ", "the", " ", "pullback", 
         " ", "bundle", " ", "tangent", " ", "to", " ", "the", " ", 
         RowBox[{"image", ".", " ", 
          RowBox[{"TODO", ":", " ", 
           RowBox[{
           "Does", " ", "not", " ", "work", " ", "for", " ", 
            "TangentReals"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"UndefAbstractIndex", "/@", 
        RowBox[{"Flatten", "@", 
         RowBox[{"IndicesOfVBundle", "[", 
          RowBox[{"PullBackVBundle", "[", 
           RowBox[{
            RowBox[{"Tangent", "[", 
             RowBox[{"MappingImage", "[", "phi", "]"}], "]"}], ",", "phi"}], 
           "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"$Mappings", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$Mappings", ",", "phi"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefMapping", ",", "\"\<End\>\"", ",", "phi"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Eliminate", " ", "symbol"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"MakeUndefInfo", "[", 
        RowBox[{"UndefMapping", ",", "phi"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"RemoveSymbol", "[", "phi", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefMapping", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefMapping", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"55169c43-1d7d-4553-8af8-e6ed5235ab80"],

Cell["\<\
TODO: The indices of the pullback bundle are not being defined, what \
\>", "Text",ExpressionUUID->"dfe1dc53-95a3-4dd8-a627-2e6136bec35e"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.4. Domain, image and range", \
"Subsubsection",ExpressionUUID->"875c07a0-27d1-494c-bb04-ce364cacb99f"],

Cell[TextData[{
 "As usual in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " we use \[OpenCurlyDoubleQuote]global\[CloseCurlyDoubleQuote] terminology \
but we actually mean local concepts. Here the domain/image/range of a mapping \
are assumed manifolds, while they are just some open sets at best."
}], "Text",ExpressionUUID->"18a75a78-4db6-41c3-8610-a20e08d23d0c"],

Cell["\<\
1) The domain of a mapping is the \[OpenCurlyDoubleQuote]manifold\
\[CloseCurlyDoubleQuote] on which the mapping acts. The mapping is assumed to \
be defined on the whole domain.\
\>", "Text",ExpressionUUID->"384d51d8-7d90-440d-88fe-68a4cb65978e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MappingDomain", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MappingDomain", "::", "unknown"}], ",", "\"\<mapping\>\"", ",",
       "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"MappingDomain", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "MappingDomain", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"32821077-2bdd-4a1a-b137-520c0b1a872c"],

Cell["\<\
2) The image of a mapping is the \[OpenCurlyDoubleQuote]manifold\
\[CloseCurlyDoubleQuote] onto which the mapping maps. We do not assume \
surjectivity, and hence the actual range could be smaller than the image. \
Range and image coincide for submersions.\
\>", "Text",ExpressionUUID->"d3e96687-f4b7-4b7a-86c8-0f5343539eb5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MappingImage", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MappingImage", "::", "unknown"}], ",", "\"\<mapping\>\"", ",", 
      "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"MappingImage", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "MappingImage", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"679232d5-d384-4230-9734-aefec0af6c40"],

Cell["\<\
3) The range of a manifold under a mapping is also considered a \
\[OpenCurlyDoubleQuote]manifold\[CloseCurlyDoubleQuote], if the object being \
mapped is a manifold:\
\>", "Text",ExpressionUUID->"8d865e10-6c17-49fd-8d7c-835599472725"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "ManifoldQ", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldQ", "[", 
    RowBox[{
     RowBox[{"phi_", "?", "MappingQ"}], "[", "x_", "]"}], "]"}], ":=", 
   RowBox[{"ManifoldQ", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ManifoldQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"18dcb8f6-a46d-4e30-a9b0-69aa21034946"],

Cell["\<\
If such mapping is an immersion then the dimension of the range equals the \
dimension of the original manifold:\
\>", "Text",ExpressionUUID->"5db1b067-f5ad-4596-bdbb-eecd4085ede9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "DimOfManifold", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimOfManifold", "[", 
    RowBox[{
     RowBox[{"phi_", "?", "MappingQ"}], "[", 
     RowBox[{"x_", "?", "ManifoldQ"}], "]"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"ImmersionQ", "[", "phi", "]"}], ",", 
     RowBox[{"DimOfManifold", "[", "x", "]"}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DimOfManifold", "::", "error1"}], ",", 
        "\"\<Cannot deduce dimensions of manifold\>\"", ",", 
        RowBox[{"phi", "[", "x", "]"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DimOfManifold", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e5521b4e-c2f8-4ec0-848e-fc73cc7cdca4"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.5. Composition (SmallCircle)", \
"Subsubsection",ExpressionUUID->"a6c9530c-6e49-439c-812c-c43472fe9230"],

Cell["\<\
Explicit compositions. To avoid interferences with Composition, and because \
SmallCircle has already the right typesetting (and even more important, the \
esc-sc-esc alias), we will use the latter. Note that SmallCircle[] stays \
unevaluated because we do not know the manifold to use for IdentityMapping. \
TODO: Perhaps we should use IdentityMapping[] as meaning the identity for any \
manifold.\
\>", "Text",ExpressionUUID->"5e7228a1-3ca7-4677-89da-0a9e6708d24d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SmallCircle", ",", 
    RowBox[{"{", 
     RowBox[{"Flat", ",", "OneIdentity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Verbatim", "[", "SmallCircle", "]"}], "[", 
    RowBox[{"phi_", "?", "MappingQ"}], "]"}], ":=", "phi"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Verbatim", "[", "SmallCircle", "]"}], "[", 
    RowBox[{
     RowBox[{"left___", "?", "MappingQ"}], ",", "_IdentityMapping", ",", 
     RowBox[{"right___", "?", "MappingQ"}]}], "]"}], ":=", 
   RowBox[{"SmallCircle", "[", 
    RowBox[{"left", ",", "right"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"40756a39-1fad-4c4f-a33d-4f6739d76a02"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MappingQ", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{"phis__", "?", "MappingQ"}], "]"}], "]"}], "^:=", "True"}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"30969ab6-a380-4c67-b773-05b1cb7f198d"],

Cell["\<\
We use the standard right-to-left convention, so the domain is that of the \
last map and the image is that of the first map:\
\>", "Text",ExpressionUUID->"5757961d-b716-4170-aa1d-2ec61f805a35"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MappingDomain", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{"__", ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"MappingDomain", "[", "phi", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingImage", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{
      RowBox[{"phi_", "?", "MappingQ"}], ",", "__"}], "]"}], "]"}], "^:=", 
   RowBox[{"MappingImage", "[", "phi", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4c6da6a4-8aea-407f-b8de-d2d05b15ab50"],

Cell["\<\
The composition of immersions is an immersion, but if we know that a \
composition is an immersion then we can only conclude that the rightmost \
mapping (the first one acting) is an immersion. The composition of \
submersions is a submersion, but if we know that a composition is a \
submersion then we can only conclude that the leftmost mapping (the last one \
acting) is a submersion.\
\>", "Text",ExpressionUUID->"345a433e-9c82-45ea-aaf2-ebc91086cba6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImmersionQ", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{"phis__", "?", "MappingQ"}], "]"}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"ImmersionQ", "/@", 
      RowBox[{"{", "phis", "}"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubmersionQ", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{"phis__", "?", "MappingQ"}], "]"}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"SubmersionQ", "/@", 
      RowBox[{"{", "phis", "}"}]}], ")"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ac91850e-67cf-4281-bc62-7e592d5cb779"],

Cell["\<\
QUESTION: The InvertibleMappingQ check is a check of ImmersionQ OR \
SubmersionQ. That\[CloseCurlyQuote]s probably too permissive. What would be \
the right check? Do we need to ask the same properties to the \
\[OpenCurlyDoubleQuote]central\[CloseCurlyDoubleQuote] maps and to the \
first/last maps?\
\>", "Text",ExpressionUUID->"08421086-711a-49d7-b862-5a0975ff43d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InverseMapping", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{"phis__", "?", "InvertibleMappingQ"}], "]"}], "]"}], ":=", 
   RowBox[{"SmallCircle", "@@", 
    RowBox[{"(", 
     RowBox[{"InverseMapping", "/@", 
      RowBox[{"Reverse", "[", 
       RowBox[{"{", "phis", "}"}], "]"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c912002f-6ef3-4eac-8742-f0273b41a1ef"],

Cell["\<\
Recall that SmallCircle can be entered as esc-sc-esc, which is very helpful. \
Note we use parentheses, because the composed map is frequently combined with \
the pullback and pushforward stars.\
\>", "Text",ExpressionUUID->"b7edab46-b317-418d-9168-d7edcf754ce5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"SmallCircle", "[", 
     RowBox[{"phis__", "?", "MappingQ"}], "]"}], "]"}], "^:=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<(\>\"", ",", 
     RowBox[{"Riffle", "[", 
      RowBox[{
       RowBox[{"PrintAs", "/@", 
        RowBox[{"{", "phis", "}"}]}], ",", "$PrecomposeCharacter"}], "]"}], 
     ",", "\"\<)\>\""}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3bae701f-f745-430f-9133-641ecd0f4e2e"],

Cell[TextData[{
 "Following Composition in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", we convert the action of a composition into an explicit nested action of \
the composed maps:"
}], "Text",ExpressionUUID->"fd500c52-9de9-4ed1-ba31-ad4a37a5ebf2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SmallCircle", "[", 
     RowBox[{"phis__", "?", "MappingQ"}], "]"}], "[", "point_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Composition", "[", "phis", "]"}], "[", "point", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1d0f24b3-774b-4c80-b9aa-3201dfc1be74"],

Cell["Keep SmallCircle unprotected, as it was initially.", \
"Text",ExpressionUUID->"34a2e117-9ad5-42d1-a4dd-d25f5729536a"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.6. (Local) invertibility", \
"Subsubsection",ExpressionUUID->"306d2ea1-270b-4f9a-9161-a0b3a7226579"],

Cell["See discussion of local vs global invertibility above.", \
"Text",ExpressionUUID->"02ea73cc-861e-465a-a7dc-f224b428dfcc"],

Cell["1) ImmersionQ (left-invertible map):", \
"Text",ExpressionUUID->"a8031571-55f8-418e-84e5-eee7a55231e3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImmersionQ", "[", 
    RowBox[{"phi_", "?", "MappingQ"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImmersionQ", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ImmersionQ", "::", "unknown"}], ",", "\"\<mapping\>\"", ",", 
      "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ImmersionQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ImmersionQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"44fa5c6a-e62f-4076-bd91-6c9c2b2e17cc"],

Cell["2) SubmersionQ (right-invertible map):", \
"Text",ExpressionUUID->"2a7ce85e-771d-4feb-9359-3622272b5ef8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SubmersionQ", "[", 
    RowBox[{"phi_", "?", "MappingQ"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubmersionQ", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SubmersionQ", "::", "unknown"}], ",", "\"\<mapping\>\"", ",", 
      "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SubmersionQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SubmersionQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1e466371-5e25-47a3-8ba7-6c9ee05ea000"],

Cell[TextData[{
 "3) Inverse mapping: for \[Phi] register i\[Phi], represented as ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Phi]", 
    RowBox[{"-", "1"}]], TraditionalForm]],ExpressionUUID->
  "1ca7f76d-aa84-437a-844b-05d131ae4a18"],
 ". The inverse mapping existis only if the mapping is invertible (that is, \
either an immersion or a submersion). I\[CloseCurlyQuote]m not really sure \
that the -1 superscript is a good idea. The prepended i is usually clear \
enough, and less conflicting with other superscripts."
}], "Text",ExpressionUUID->"4cf5c782-6b50-4ab3-9327-035d193d377d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"InverseMapping", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"\"\<i\>\"", ",", "phi"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GiveOutputString", "[", 
    RowBox[{"InverseMapping", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"\"\<\\!\\(\>\"", "<>", 
    RowBox[{"PrintAs", "[", "phi", "]"}], "<>", "\"\<\\^-1\\)\>\""}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c6c40b0f-fb50-41a2-9458-899533c7e13e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InverseMapping", "::", "noinv"}], "=", 
   "\"\<Mapping `1` is not invertible.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseMapping", "[", 
    RowBox[{"phi_", "?", "MappingQ"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"InverseMapping", "::", "noinv"}], ",", "phi"}], "]"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseMapping", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"InverseMapping", "::", "unknown"}], ",", "\"\<mapping\>\"", 
      ",", "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"InverseMapping", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "InverseMapping", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bcba00e1-7cfb-4140-94cb-6dc2293a5c85"],

Cell["\<\
(Local) invertibility, either from the left or the right, or both. This is a \
private function, so far only used when computing the inverse of a \
composition.\
\>", "Text",ExpressionUUID->"8548122c-2fa5-43ba-8014-ab16bd44d20c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvertibleMappingQ", "[", "phi_", "]"}], ":=", 
   RowBox[{
    RowBox[{"ImmersionQ", "[", "phi", "]"}], "||", 
    RowBox[{"SubmersionQ", "[", "phi", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"558b36a7-e1ea-4ac5-866d-41074c7f1495"],

Cell["4) DiffeomorphismQ (meaning only the local version):", \
"Text",ExpressionUUID->"ae219168-55f8-4fe2-a7c2-ed428c0a29ab"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DiffeomorphismQ", "[", 
    RowBox[{"phi_", "?", "MappingQ"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ImmersionQ", "[", "phi", "]"}], "&&", 
    RowBox[{"SubmersionQ", "[", "phi", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DiffeomorphismQ", "[", "phi_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DiffeomorphismQ", "::", "unknown"}], ",", "\"\<mapping\>\"", 
      ",", "phi"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DiffeomorphismQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DiffeomorphismQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"33b77513-babf-4173-8841-9164748f0c94"]
}, Closed]],

Cell[CellGroupData[{

Cell["6.3.7. Cartesian product of mappings", \
"Subsubsection",ExpressionUUID->"229c9c60-3c47-4aab-9ed5-f1aaeaa507c1"],

Cell["Properties:", \
"Text",ExpressionUUID->"68707c7c-99c9-4139-ac49-6edb08492559"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MappingQ", "[", "phi_CartesianProduct", "]"}], "^:=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"MappingQ", "/@", 
      RowBox[{"List", "@@", "phi"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingDomain", "[", "phi_CartesianProduct", "]"}], "^:=", 
   RowBox[{"MappingDomain", "/@", "phi"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MappingImage", "[", "phi_CartesianProduct", "]"}], "^:=", 
   RowBox[{"MappingImage", "/@", "phi"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseMapping", "[", "phi_CartesianProduct", "]"}], "^:=", 
   RowBox[{"InverseMapping", "/@", "phi"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImmersionQ", "[", "phi_CartesianProduct", "]"}], "^:=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"ImmersionQ", "/@", 
      RowBox[{"List", "@@", "phi"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubmersionQ", "[", "phi_CartesianProduct", "]"}], "^:=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"SubmersionQ", "/@", 
      RowBox[{"List", "@@", "phi"}]}], ")"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"13043ef4-d468-4426-87ea-81a2ca8907f2"],

Cell["Behaviour under composition:", \
"Text",ExpressionUUID->"70b12d08-6fa9-4b78-8d02-5afa6cbe52c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CartesianProduct", "/:", 
   RowBox[{"SmallCircle", "[", 
    RowBox[{"phi1_CartesianProduct", ",", "phi2_CartesianProduct"}], "]"}], ":=", 
   RowBox[{"ThreadCartesianProduct", "[", 
    RowBox[{"SmallCircle", ",", 
     RowBox[{"{", 
      RowBox[{"phi1", ",", "phi2"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6b3f4691-da56-4ea0-a932-f1dc1e89500a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"phi1_CartesianProduct", "[", 
    RowBox[{"phi2_CartesianProduct", "[", "point_", "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ThreadCartesianProduct", "[", 
     RowBox[{"SmallCircle", ",", 
      RowBox[{"{", 
       RowBox[{"phi1", ",", "phi2"}], "}"}]}], "]"}], "[", "point", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"42d30abe-e6b2-44b0-b57b-837f270d23f4"],

Cell["Action on a point:", \
"Text",ExpressionUUID->"88efad65-8d4d-4f79-a13c-8dcfab9da40f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"phi_CartesianProduct", "[", "point_CartesianProduct", "]"}], ":=", 
   RowBox[{"ThreadCartesianProduct", "[", 
    RowBox[{"Compose", ",", 
     RowBox[{"{", 
      RowBox[{"phi", ",", "point"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9bed7354-689c-4464-8eb6-a9fb9f0e5981"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["7. Vector bundles",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"ba737738-8630-442f-95ea-c0ee58870a7c"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", " ", "7."}], "Vector", " ", "bundles"}], " ", 
  "****************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6aeade46-7ad2-419c-9b14-bdc17e373f15"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"f4aef018-e7e5-433f-be1e-41d364389877"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "19.452486`", ",", "240.885044`8.833354829982873", ",", 
   "0.08075436073514758`"}], 
  "}"}]], "Output",ExpressionUUID->"ba43189d-5e7a-477f-b918-b79992a9a00a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["7.0. Comments", \
"Subsection",ExpressionUUID->"45c690d8-e98a-4cc5-b71a-3d6cebf1275d"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 7: Vector bundles.\>\"", "]"}], 
   ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d362cd5f-cd2e-410b-9043-e98b2dc8c030"],

Cell["\<\
Nearly everything in this section is about the algebraic structure of the \
vector space fibers. There is nothing about the differential part, which is \
handled later in the section on covariant derivatives.  Hence having \
\[OpenCurlyDoubleQuote]Vector bundles\[CloseCurlyDoubleQuote] as title might \
be misleading.  An idea is to introduce vector spaces as a derived type, so \
that a vector space is a vector bundle over a trivial 0-dimensional space \
(which we could call None, for example).\
\>", "Text",ExpressionUUID->"ea1c490c-3108-494f-8fe0-5692f97c0e7d"],

Cell[TextData[{
 "Currently the only type of bundle considered in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is a vector bundle (called \"vbundle\" here), without any further \
assumption. We will distinguish tangent bundles and inner vbundles because \
the properties of some objects living on them (like metrics and connections) \
are different. This is general enough to deal with gauge theories, as shown \
by Ashtekar et al, and there is no need to specify from the very beginning a \
gauge group. In case we want to use the gauge group it is important to \
remember that an inner vbundle plays the role of representation space for the \
group, and so its dimension only coincides with the group dimension for the \
fundamental representation. This dimension is called \"the number of internal \
degrees of freedom\" by Ashtekar et al.\n\nThough for convenience we use the \
word bundle everywhere in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", the actual structure of the system is purely algebraic. As pointed out by \
Ashtekar et al this is due to the fact that our basic objects are already \
tensor ",
 StyleBox["fields",
  FontSlant->"Italic"],
 " on manifolds, and not tensors ",
 StyleBox["at a point",
  FontSlant->"Italic"],
 " which have to be later generalized through the bundle idea. This will \
become a problem later in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ", where we will have to define a tensor at a point as a restriction of a \
tensor field.\n\nAs with manifolds, we assume tangent bundles to be real \
(though they can be complexified), but inner vbundles can be natively \
complex.\n\nA very important issue is how to relate vbundles and their duals. \
Sometimes it seems natural for example to say that index a belongs to V and \
-a to -V, but other times this is problematic because it would seem that a, \
-a belong to the same structure V (for example when contracting indices). \
Therefore some of the definitions below keep the signs, but others don't.\n\n\
Another important issue is how to relate the indices of a fiber bundle and \
the indices of a pullback of it. At the moment we insert the name of the \
mapping in the index, so that VBundleOfIndex knows what to return. There is \
then the associated problem of what is the metric of the pullback bundle."
}], "Text",ExpressionUUID->"89068824-cca4-4835-8786-b277c8606b88"],

Cell["\<\
TODO: $VBundles will not contain the pullback bundles. Hence, some operations \
threaded over $VBundles might miss some vbundles, say like SameVBundleRules, \
$FirstMetrics, TransposeDaggerX, SortCovDsStart/Stop, ToCanonical.\
\>", "Text",ExpressionUUID->"b4c3fc62-277e-4f99-af93-d56b1ac25b86"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1. DefVBundle", \
"Subsection",ExpressionUUID->"ff30cb50-a318-41c5-8a50-28350553fce2"],

Cell[CellGroupData[{

Cell["7.1.0. Comments", \
"Subsubsection",ExpressionUUID->"42dae589-46b7-4a64-91e4-d2bc22bfce7c"],

Cell["\<\
Vbundles are always defined being symbolic. We do not allow a defined vbundle \
to be a pullback (as we *do* with tensors).

The algebraic properties attached to the vbundle actually refer to its \
standard fiber.\
\>", "Text",ExpressionUUID->"d790ad4f-bec7-47e7-8940-e89cde1a3f53"],

Cell["\<\
Properties as a vbundle:

\tVBundleQ[vbundle]
\tBaseOfVBundle[vbundle]
\tDimOfVBundle[vbundle]
\tIndicesOfVBundle[vbundle]
\tLastIndex[vbundle]
\tMetricsOfVBundle[vbundle]
\tSplittingsOfVBundle[vbundle]
\tSubvbundleQ[vbundle, sub]

Generic properties:

\tDagger[vbundle]
\tPrintAs[basis]

Properties for a registered basis symbol:
\tDefInfo[vbundle]
\tMasterOf[vbundle]
\tHostsOf[vbundle]
\tServantsOf[vbundle]\t\
\>", "Text",ExpressionUUID->"6091cfe7-a496-4c81-a637-caf21f52a9f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.1. Check of input", \
"Subsubsection",ExpressionUUID->"76d97ab7-8ffa-4283-ae75-574d663f44ec"],

Cell["\<\
First we check the input (note that there are no heads in the argument \
patterns). The list of indices must have head List and not IndexList, because \
this is what the user is told to use (they are abstract indices, and \
therefore the is no possibility of confusion). There must be at least one \
index. Again, we use ValidateIndex with the option False to avoid the message \
Validate::capital. It will be sent, if needed, by DefAbstractIndex below. \
Since 0.9.9 we do not validate the dimension:\
\>", "Text",ExpressionUUID->"4f1e7961-d913-404b-8768-d33f53f4608e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"checkDefVBundle", "[", 
    RowBox[{
    "vbundle_", ",", "manifold_", ",", "dimF_", ",", "indices_", ",", 
     "dag_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"1.", "-", " ", 
      RowBox[{"Validate", " ", "vector", " ", "bundle"}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ValidateSymbol", "[", "vbundle", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ValidateSymbolInSession", "[", "vbundle", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"2.", "-", " ", 
       RowBox[{"Validate", " ", "manifold"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"ManifoldQ", "[", "manifold", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefVBundle", "::", "unknown"}], ",", "\"\<manifold\>\"", 
          ",", "manifold"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"3.", "-", " ", 
       RowBox[{"Validate", " ", "indices"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "indices", "]"}], "=!=", "List"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefVBundle", "::", "invalid"}], ",", "indices", ",", 
          "\"\<list of indices\>\""}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"indices", "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefVBundle", "::", "empty"}], ",", "4", ",", 
          "\"\<indices\>\""}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ValidateIndex", "[", 
        RowBox[{"#", ",", "False"}], "]"}], "&"}], "/@", "indices"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"4.", "-", " ", 
       RowBox[{"Validate", " ", "dag", " ", "option"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"FreeQ", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Real", ",", "Complex", ",", "Conjugate"}], "}"}], ",", 
         "dag"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefVBundle", "::", "invalid"}], ",", "dag", ",", 
          "\"\<value for option Dagger\>\""}], "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a804e1f2-51f1-41ab-bbb4-e41f0f69d6ee"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.2. Register vector bundle structure", \
"Subsubsection",ExpressionUUID->"6afafb33-9b8d-45b4-a11e-e6268c9b8a1e"],

Cell["\<\
We have a list of metrics on the vbundle, the first one being the default \
metric. Note that we do not redefine $VBundles; initially it is an empty list.\
\>", "Text",ExpressionUUID->"0cf2fd51-5652-40fd-8090-81961af80644"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RegisterVBundle", "[", 
    RowBox[{"vbundle_Symbol", ",", "manifold_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"1.", "-", " ", 
      RowBox[{"Register", " ", "symbol"}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AppendToUnevaluated", "[", 
      RowBox[{"$VBundles", ",", "vbundle"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"VBundleQ", "[", "vbundle", "]"}], "^=", "True"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"2.", "-", " ", 
       RowBox[{"Register", " ", "base", " ", "manifold"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}], "^=", "manifold"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"3.", "-", " ", 
       RowBox[{
       "There", " ", "is", " ", "no", " ", "associated", " ", "metric", " ", 
        "by", " ", "default"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], "^=", 
      RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a70985c4-307c-4e98-95bb-7d668da325d4"],

Cell["\<\
Here we need to decide what to do with the co-vbundles. The functions \
BaseOfVBundle, MetricsOfVBundle and SplittingsOfVBundle are trivial, but not \
the function SubvbundleQ. It is not clear either what to do with \
VisitorsOf[-vbundle]. One might even argue that the metrics for the dual are \
the inverses, but we do not follow that.\
\>", "Text",ExpressionUUID->"2ce2745d-c7bd-4d67-9b3b-110f4c0c0524"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BaseOfVBundle", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BaseOfVBundle", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"BaseOfVBundle", "::", "unknown"}], ",", "\"\<vbundle\>\"", ",",
       "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"BaseOfVBundle", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "BaseOfVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"33c9ce8e-ef41-4d30-8e34-98a6a5cb5b11"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MetricsOfVBundle", "::", "unknown"}], ",", "\"\<vbundle\>\"", 
      ",", " ", "x"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"MetricsOfVBundle", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "MetricsOfVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d386a6d6-9058-4440-8716-bc76194c46b6"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.3. Metrics in the vector bundle", \
"Subsubsection",ExpressionUUID->"c8c7c100-3d84-457c-a3f8-f9d86bca30b9"],

Cell["\<\
A vector bundle can have several metrics. They are all stored in \
MetricsOfVBundle, and only the first one can be used to raise and lower \
indices. The functions defined here (FirstMetricOfVBundle, FirstMetricQ, \
$FirstMetrics and MetricEndowedQ) are all defined in terms of \
MetricsOfVBundle and VBundleOfMetric, and both behave trivially under change \
of sign of the vbundles. Null is used in various places to mean \
\[OpenCurlyDoubleQuote]there is no metric\[CloseCurlyDoubleQuote].\
\>", "Text",ExpressionUUID->"cfad1ec1-ce13-4145-afcf-11895c8f6b19"],

Cell["\<\
1) The second argument of FirstMetricOfVBundle says whether we expect to have \
a metric on the bundle or not. If we do then an error is thrown in case there \
is none.\
\>", "Text",ExpressionUUID->"4af1b628-a7c1-4a2d-baeb-8c88fc480347"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FirstMetricOfVBundle"}]], \
"Input",ExpressionUUID->"ee2df31b-98ce-469c-acc8-00e069af4fe4"],

Cell[BoxData[
 StyleBox["\<\"xAct`xTensor`Private`FirstMetricOfVBundle[vbundle] gives the \
first metric of the list MetricsOfVBundle[vbundle]. There is an optional \
Boolean second argument which decides if an error message is thrown in case \
that list is empty. The default is True.\"\>", "MSG"]], "Print", "PrintUsage",
 
 CellTags->
  "Info3578672510-5338953",ExpressionUUID->"ced72eb5-dc13-46e4-ba4f-\
9dd4aa434296"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FirstMetricOfVBundle", "[", 
    RowBox[{"vbundle_", ",", 
     RowBox[{"mess_", ":", "True"}]}], "]"}], ":=", 
   RowBox[{"firstmetricofvbundle", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], ",", "mess"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstmetricofvbundle", "[", 
    RowBox[{"vbundle_", ",", 
     RowBox[{"{", "}"}], ",", "True"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MetricsOfVBundle", "::", "missing"}], ",", "\"\<metric\>\"", 
      ",", "vbundle"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstmetricofvbundle", "[", 
    RowBox[{"vbundle_", ",", 
     RowBox[{"{", "}"}], ",", "False"}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstmetricofvbundle", "[", 
    RowBox[{"vbundle_", ",", "list_List", ",", "_"}], "]"}], ":=", 
   RowBox[{"First", "[", "list", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"firstmetricofvbundle", "[", 
    RowBox[{"vbundle_", ",", "list_", ",", "_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MetricsOfVBundle", "::", "invalid"}], ",", "list", ",", 
      "\"\<list of metrics\>\""}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a7ad0ea3-8f89-439a-801c-491bbcdaf12b"],

Cell["\<\
2) This function says if a metric is the first in its manifold. Note that we \
throw an error on vbundles without metric, because this question is thought \
to be used when we already know that the vbundle has a metric, and we are \
trying to check which one is the first-metric.\
\>", "Text",ExpressionUUID->"4cf8ef45-d662-42f2-8e37-52c08e8279cf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "FirstMetricQ"}]], \
"Input",ExpressionUUID->"17f2056d-5c00-45e4-82e9-3f115cfa28a9"],

Cell[BoxData[
 StyleBox["\<\"xAct`xTensor`Private`FirstMetricQ[metric] returns True if \
metric is the first-metric of some vbundle, and False otherwise. \
xAct`xTensor`Private`FirstMetricQ[metric, vbundle] returns True if metric is \
the first-metric of vbundle, False if it is not, and throws an error if \
vbundle has no metrics.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672512-5338953",ExpressionUUID->"d619ed29-c7d3-43ce-a4a8-\
798228a70a4b"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FirstMetricQ", "[", 
    RowBox[{"Null", ",", "___"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstMetricQ", "[", "metric_", "]"}], ":=", 
   RowBox[{"FirstMetricQ", "[", 
    RowBox[{"metric", ",", 
     RowBox[{"VBundleOfMetric", "[", "metric", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstMetricQ", "[", 
    RowBox[{"metric_", ",", "vbundle_"}], "]"}], ":=", 
   RowBox[{"metric", "===", 
    RowBox[{"FirstMetricOfVBundle", "[", 
     RowBox[{"vbundle", ",", "True"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"24d0435c-9433-4775-811d-e49bd1f4f894"],

Cell["\<\
3) This global variable is computed on the fly giving the first metrics of \
the manifolds with a metric:\
\>", "Text",ExpressionUUID->"9081911b-b4fa-4cf7-9fd5-e44f53ecd065"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$FirstMetrics"}]], \
"Input",ExpressionUUID->"5b783e93-6bd4-40db-b04c-a6cdf738ff10"],

Cell[BoxData[
 StyleBox["\<\"xAct`xTensor`Private`$FirstMetrics is a global variable \
containing the list of all metrics which are first-metric of some \
vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672513-5338953",ExpressionUUID->"5cd4233d-8fd5-4867-9186-\
f0bb80e2ec1f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$FirstMetrics", ":=", 
   RowBox[{"DeleteCases", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"FirstMetricOfVBundle", "[", 
        RowBox[{"#", ",", "False"}], "]"}], "&"}], "/@", "$VBundles"}], ",", 
     "Null"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3c125c39-a00f-4763-aaf5-e5a626947f49"],

Cell["\<\
4) This is a Boolean function giving whether there is a metric (perhaps more) \
or not in a manifold:\
\>", "Text",ExpressionUUID->"0bee4b5f-4dd5-40c2-a9e6-b9b7b5fd3a65"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "MetricEndowedQ"}]], \
"Input",ExpressionUUID->"06650506-35a6-4e1a-a898-005c0f3d5438"],

Cell[BoxData[
 StyleBox["\<\"MetricEndowedQ[vbundle] gives True if the vector bundle \
vbundle has at least one registered metric (which will be contained in \
MetricsOfVBundle[vbundle]) or False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672515-5338953",ExpressionUUID->"41b9b484-6322-4c76-ae50-\
cd195f4d163d"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MetricEndowedQ", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"UnsameQ", "[", 
    RowBox[{
     RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"MetricEndowedQ", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "MetricEndowedQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0e8ca6a1-0a92-4aea-a86a-948d9aad1a62"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.4. IndexRange", \
"Subsubsection",ExpressionUUID->"b5e2136e-f1dc-4ed3-a0af-0548a2ae0e52"],

Cell["\<\
This is a simple function to avoid typing lots of indices at definition time \
of a manifold or vbundle.\
\>", "Text",ExpressionUUID->"e4a6f2f4-e096-4085-939e-837d6489a437"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexRange"}]], \
"Input",ExpressionUUID->"23fb8c46-56fe-4ddb-ab1b-28525605bfbf"],

Cell[BoxData[
 StyleBox["\<\"IndexRange[a, p] and IndexRange[{a, p}] return the list of \
symbols between symbols a and p (using CharacterRange internally). \
IndexRange[{a1, p1}, {a2, p2}, ...] returns the union (using Union, and hence \
sorted) of the ranges defined by the given pairs of indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672516-5338953",ExpressionUUID->"06971639-9efa-4c2e-8b95-\
31c1c6c5fa65"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexRange", "[", 
    RowBox[{"first_String", ",", "last_String"}], "]"}], ":=", 
   RowBox[{"ToExpression", "/@", 
    RowBox[{"CharacterRange", "[", 
     RowBox[{"first", ",", "last"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRange", "[", 
    RowBox[{"first_Symbol", ",", "last_"}], "]"}], ":=", 
   RowBox[{"IndexRange", "[", 
    RowBox[{
     RowBox[{"ToString", "[", "first", "]"}], ",", "last"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRange", "[", 
    RowBox[{"first_", ",", "last_Symbol"}], "]"}], ":=", 
   RowBox[{"IndexRange", "[", 
    RowBox[{"first", ",", 
     RowBox[{"ToString", "[", "last", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRange", "[", "range_List", "]"}], ":=", 
   RowBox[{"IndexRange", "@@", "range"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRange", "[", "ranges__List", "]"}], ":=", 
   RowBox[{"Union", "@@", 
    RowBox[{"(", 
     RowBox[{"IndexRange", "/@", 
      RowBox[{"{", "ranges", "}"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRange", "[", "x___", "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"IndexRange", "::", "invalid"}], ",", 
      RowBox[{"HoldForm", "[", "x", "]"}], ",", 
      "\"\<input for IndexRange\>\""}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexRange", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b7b6ebd4-da41-4848-8e32-b06e6189f43c"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.5. Abstract indices in the vector bundle", \
"Subsubsection",ExpressionUUID->"dc5e0e4c-6c39-494a-a66b-6005cd00e2bc"],

Cell["\<\
1) Note that the function vbQ and vbpmQ only detect abstract indices. The \
notation for those two functions is horrible, due to historical reasons: they \
were probably encoded the first day I started writing a package for tensor \
computations... Now it is too late to change them.\
\>", "Text",ExpressionUUID->"fea08f39-c344-46c8-9e16-44afc8a30370"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RegisterIndexInVBundle"}]], \
"Input",ExpressionUUID->"5ce9e792-9d92-4a0b-bf29-7100a227d187"],

Cell[BoxData[
 StyleBox["\<\"xTensor`Private`RegisterIndexInVBundle[ind, vb] registers the \
abstract index ind (a symbol) in the vbundle vb.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672517-5338953",ExpressionUUID->"07144ddd-c2a1-4112-83d9-\
248a3f5638ad"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RegisterIndexInVBundle", "[", 
    RowBox[{"index_Symbol", ",", "vbundle_", ",", "options___"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vbQ", "=", 
       RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"DefAbstractIndex", "[", 
       RowBox[{"index", ",", "options"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"VBundleOfIndex", "[", "index", "]"}], ",", "vbundle"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"vbQ", "[", "index", "]"}], ",", "True"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5d40f540-5d19-457e-9a76-2337a61456a8"],

Cell["\<\
2) The definition of the bQ function is a bit involved. There was a simpler \
coding with \
bQ[index_Symbol]:=MemberQ[Flatten@IndicesOfVBundle@vbundle,NoDollar@index], \
but it was too slow when the list of computer-generated indices was too long. \
Now this list is not used and the function directly checks NoDollar[index]. \
All indices in the list have upvalue True on the corresponding bQ function, \
so that if the index is not recognized, then the default (False) definition \
is used. The bQ function only recognizes abstract indices. The bQ function is \
a source of memory leaking through the remembered values. Note that an index \
can have a different remembered value for each vbundle in the problem...\
\>", "Text",ExpressionUUID->"135db9f8-8582-42af-aebb-a18a3c7c26c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RegisterIndices"}]], \
"Input",ExpressionUUID->"6f060aab-b5d4-4950-9957-04174ec57580"],

Cell[BoxData[
 StyleBox["\<\"RegisterIndices[vb, inds] associates the given list inds of \
abstract indices to the vbundle vb.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672518-5338953",ExpressionUUID->"605000e5-699c-42d6-90df-\
516e8cae391b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RegisterIndices", "[", 
    RowBox[{
     RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
     RowBox[{"indices", ":", 
      RowBox[{"{", "__Symbol", "}"}]}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vbQ", "=", 
        RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], ",", 
       RowBox[{"vbpmQ", "=", 
        RowBox[{"VBundleIndexPMQ", "[", "vbundle", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"1.", "-", " ", 
       RowBox[{"Properties", " ", "of", " ", "the", " ", "indices"}]}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"RegisterIndexInVBundle", "[", 
         RowBox[{"#", ",", "vbundle", ",", "options"}], "]"}], "&"}], "/@", 
       "indices"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"2.", "-", " ", 
        RowBox[{"Properties", " ", "of", " ", "the", " ", "vector", " ", 
         RowBox[{"bundle", ".", " ", "Separate"}], " ", "the", " ", "case", 
         " ", "of", " ", "pullback", " ", "vbundles"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Head", "[", "vbundle", "]"}], "===", "PullBackVBundle"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"vb", "=", 
             RowBox[{"First", "[", "vbundle", "]"}]}], ",", 
            RowBox[{"map", "=", 
             RowBox[{"Last", "[", "vbundle", "]"}]}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"xTagSet", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"vb", ",", 
              RowBox[{"IndicesOfVBundle", "[", 
               RowBox[{"vb", ",", "map"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"indices", ",", 
              RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}], "^=", 
          RowBox[{"{", 
           RowBox[{"indices", ",", 
            RowBox[{"{", "}"}]}], "}"}]}], ";"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"SetLastIndex", "[", 
       RowBox[{"vbundle", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Last", "[", "indices", "]"}], ",", "1"}], "}"}]}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"3.", "-", " ", "Q", "-", 
        RowBox[{
        "functions", " ", "of", " ", "the", " ", "vector", " ", "bundle"}]}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vbpmQ", "[", 
        RowBox[{"-", "index_"}], "]"}], ":=", 
       RowBox[{"vbQ", "[", "index", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vbpmQ", "[", "index_", "]"}], ":=", 
       RowBox[{"vbQ", "[", "index", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vbQ", "[", 
        RowBox[{"-", "index_"}], "]"}], ":=", "False"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vbQ", "[", 
        RowBox[{"index_Symbol", "?", "DollarQ"}], "]"}], ":=", 
       RowBox[{
        RowBox[{"vbQ", "[", "index", "]"}], "^=", 
        RowBox[{"vbQ", "[", 
         RowBox[{"NoDollar", "@", "index"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vbQ", "[", "_", "]"}], ":=", "False"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"4.", "-", " ", 
        RowBox[{"Complex", " ", "structure"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"DaggerIndex", "/@", "indices"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"5.", "-", " ", 
        RowBox[{"Return", " ", "indices"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"indices", ",", 
        RowBox[{"{", "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"538d559c-438c-4221-9832-e511fb565701"],

Cell["\<\
3) In these three functions there could be a sign on the RHS associating \
down-indices to -vbundle, but this is not clear. It is again a question of \
whether we are referring to the indices or to the up-indices/down-indices.\
\>", "Text",ExpressionUUID->"d0bfccd1-70e4-4855-ae2c-98ca43098e64"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndicesOfVBundle"}]], \
"Input",ExpressionUUID->"04812538-1623-462d-8506-5067716d83e7"],

Cell[BoxData[
 StyleBox["\<\"IndicesOfVBundle[vbundle] returns the abstract indices \
associated to vector bundle vbundle. There are two lists: that of the \
registered indices and that of the internally generated indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672520-5338953",ExpressionUUID->"c18b54f8-c1a3-4fc0-8140-\
b9f020d5a700"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndicesOfVBundle", "[", 
     RowBox[{"-", "vbundle_"}], "]"}], ":=", 
    RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Pullback", " ", 
    RowBox[{"vbundle", ":", " ", 
     RowBox[{
     "switch", " ", "to", " ", "two", " ", "argument", " ", "form"}]}]}], " ",
    "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndicesOfVBundle", "[", 
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{
       RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
       RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
    RowBox[{"IndicesOfVBundle", "[", 
     RowBox[{"vbundle", ",", "phi"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "First", " ", "call", " ", "of", " ", "IndicesOfVBundle", " ", "on", " ", 
    "a", " ", "PullBackVBundle", " ", "does", " ", "this", " ", "and", " ", 
    "gets", " ", 
    RowBox[{"cached", ".", " ", "PrintAs"}], " ", "will", " ", "be", " ", 
    "handled", " ", "somewhere", " ", "else"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndicesOfVBundle", "[", 
     RowBox[{
      RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"RegisterIndices", "[", 
     RowBox[{
      RowBox[{"PullBackVBundle", "[", 
       RowBox[{"vbundle", ",", "phi"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"MakePullBackIndex", "[", 
         RowBox[{"#", ",", "phi"}], "]"}], "&"}], "/@", 
       RowBox[{"First", "[", 
        RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}], "]"}]}], ",", 
      RowBox[{"PrintAs", "\[Rule]", "Null"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Tangent", " ", "of", " ", "a", " ", 
    RowBox[{"submanifold", ":", " ", 
     RowBox[{
     "consider", " ", "as", " ", "a", " ", "pullback", " ", "vbundle"}]}]}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndicesOfVBundle", "[", 
    RowBox[{"Tangent", "[", 
     RowBox[{
      RowBox[{"phi_", "?", "MappingQ"}], "[", 
      RowBox[{"manifold_", "?", "ManifoldQ"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"IndicesOfVBundle", "[", 
    RowBox[{
     RowBox[{"Tangent", "[", 
      RowBox[{"MappingImage", "[", "phi", "]"}], "]"}], ",", "phi"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndicesOfVBundle", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"IndicesOfVBundle", "::", "unknown"}], ",", 
      "\"\<vector bundle\>\"", ",", "vbundle"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndicesOfVBundle", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "IndicesOfVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"61c11f13-f45d-4753-9e89-0bce5614b60b"],

Cell["\<\
Note the following issue: if we find \
IndicesOfVBundle[PullBackVBundle[Tangent[N], phi]] then this returns the \
modified indices IndicesOfVBundle[Tangent[N], phi]. However, if we find \
IndicesOfVBundle[Tangent[psi[M]]], such that psi[M] is a submanifold of N, \
then we have two alternative interpretations: a) We consider Tangent[psi[M]] \
as equivalent to PullBackVBundle[Tangent[N], psi] or b) we consider it as a \
subvbundle of Tangent[N] and then the relevant mapping is the inclusion \
mapping of psi[M] in N. The former approach seems more reasonable, because it \
allows \[OpenCurlyDoubleQuote]parametrizing\[CloseCurlyDoubleQuote] \[Psi][M] \
with M.\
\>", "Text",ExpressionUUID->"c85350ca-3999-44d0-ab9f-922932ebecfe"],

Cell["\<\
This function decides which index must appear as free index in directional \
arguments after canonicalization:\
\>", "Text",ExpressionUUID->"6ae511e4-c91f-4c0a-919c-22d571ac83a4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FirstIndexOfVBundle", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"FirstIndexOfVBundle", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FirstIndexOfVBundle", "[", "vbundle_", "]"}], ":=", 
   RowBox[{
    RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fd8ecd1d-a92b-4fe0-9c58-e61e77f98f04"],

Cell["\<\
The index to be used when new (numeric i76) indices are created:\
\>", "Text",ExpressionUUID->"8a44c7ee-250d-43bc-9ca3-d7d73f003db2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "LastIndex"}]], \
"Input",ExpressionUUID->"8618ffce-2731-4d16-91d5-ed2f4348f9bd"],

Cell[BoxData[
 StyleBox["\<\"LastIndex[vbundle] gives a pair {i, n} such that \
dollar-indices will be formed using the symbol i (see function DummyIn) and \
computer-generated indices will be formed using the symbol i and the integer \
n (see function NewIndexIn). LastIndex[vbundle, map] given the corresponding \
pair for the pullback vbundle PullBackVBundle[vbundle, map].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672521-5338953",ExpressionUUID->"792989a4-ff43-4001-b37d-\
26f8237af230"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LastIndex", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"LastIndex", "[", "vbundle", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LastIndex", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{"vbundle_", ",", " ", "phi_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"LastIndex", "[", 
    RowBox[{"vbundle", ",", " ", "phi"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"LastIndex", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "LastIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ba803429-eb94-4bbd-bfa3-a2b2b9a7d2d6"],

Cell["This is the function to be used to update the LastIndex:", \
"Text",ExpressionUUID->"67861cc6-50ba-4737-8e91-4d5a710b7b0e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetLastIndex", "[", 
    RowBox[{
     RowBox[{"-", "vbundle_"}], ",", "update_"}], "]"}], ":=", 
   RowBox[{"SetLastIndex", "[", 
    RowBox[{"vbundle", ",", "update"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetLastIndex", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{"vb_Symbol", ",", "phi_"}], "]"}], ",", "1"}], "]"}], ":=", 
   RowBox[{"xTagSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vb", ",", 
       RowBox[{"LastIndex", "[", 
        RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"LastIndex", "[", 
       RowBox[{"vb", ",", "phi"}], "]"}], "+", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetLastIndex", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{"vb_Symbol", ",", "phi_"}], "]"}], ",", "new_"}], "]"}], ":=", 
   RowBox[{"xTagSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vb", ",", 
       RowBox[{"LastIndex", "[", 
        RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", "new"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetLastIndex", "[", 
    RowBox[{"vbundle_", ",", "1"}], "]"}], ":=", 
   RowBox[{"xUpSet", "[", 
    RowBox[{
     RowBox[{"LastIndex", "[", "vbundle", "]"}], ",", 
     RowBox[{
      RowBox[{"LastIndex", "[", "vbundle", "]"}], "+", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetLastIndex", "[", 
     RowBox[{"vbundle_", ",", "new_"}], "]"}], ":=", 
    RowBox[{"xUpSet", "[", 
     RowBox[{
      RowBox[{"LastIndex", "[", "vbundle", "]"}], ",", "new"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Remove", " ", "upvalue"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetLastIndex", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"xUpSet", "[", 
    RowBox[{"LastIndex", "[", "vbundle", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6e2664a2-41c9-4952-8c53-ac95bf03f69c"],

Cell["\<\
4) This function returns the vector bundle which a g-index belongs to. VERY \
IMPORTANT QUESTION: Currently we associate vbundle both to x and -x. We could \
drop the definitions for patterns and use PatternToIndex, but we prefer to \
leave it as it is to keep the message VBundleOfIndex::unknown.\
\>", "Text",ExpressionUUID->"21e2fe93-aeef-4a2b-8cf2-504e80d244f6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "VBundleOfIndex"}]], \
"Input",ExpressionUUID->"771d8d54-7b01-47ce-b5cc-40e34d25fa7e"],

Cell[BoxData[
 StyleBox["\<\"VBundleOfIndex[i] gives the vector bundle to which the g-index \
i belongs. Otherwise it throws an error message.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672523-5338953",ExpressionUUID->"7ef27928-13df-43a0-81e9-\
2467b8d65205"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", 
     RowBox[{"x", ":", 
      RowBox[{"-", "_Dir"}]}], "]"}], ":=", 
    RowBox[{"Throw", "@", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"VBundleOfIndex", "::", "invalid"}], ",", "x", ",", 
       "\"\<index\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Note", " ", "that", " ", "there", " ", "is", " ", "no", " ", "minus", " ",
     "sign", " ", "on", " ", "the", " ", "RHS"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", 
    RowBox[{"-", "x_"}], "]"}], ":=", 
   RowBox[{"VBundleOfIndex", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", "_Blank", "]"}], ":=", 
    RowBox[{"Throw", "@", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"VBundleOfIndex", "::", "nouse"}], ",", 
       "\"\<VBundleOfIndex\>\"", ",", "\"\<a Blank pattern index\>\""}], 
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "PINDEX", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", "x_Pattern", "]"}], ":=", 
   RowBox[{"VBundleOfIndex", "[", 
    RowBox[{"First", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", "x_PatternTest", "]"}], ":=", 
   RowBox[{"VBundleOfIndex", "[", 
    RowBox[{"First", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", "v_Dir", "]"}], ":=", 
    RowBox[{"VBundleOfIndex", "[", 
     RowBox[{"UltraindexOf", "[", "v", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"C", " ", "indices"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
    RowBox[{"xAct`xCoba`VBundleOfBasis", "[", "basis", "]"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VBundleOfIndex", "[", 
      RowBox[{
       RowBox[{"basis_Symbol", "?", "BasisQ"}], "[", "_Integer", "]"}], "]"}],
      ":=", 
     RowBox[{"xAct`xCoba`VBundleOfBasis", "[", "basis", "]"}]}], ";"}], " ", 
   RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"B", " ", 
    RowBox[{"indices", ".", " ", "No"}], " ", "check", " ", "of", " ", 
    "consistency", " ", "of", " ", "abstract", " ", "index", " ", "and", " ", 
    "basis"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VBundleOfIndex", "[", 
      RowBox[{"{", 
       RowBox[{"x_", ",", "_"}], "}"}], "]"}], ":=", 
     RowBox[{"VBundleOfIndex", "[", "x", "]"}]}], ";"}], " ", 
   RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Other", " ", "index", " ", "modifiers"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", 
    RowBox[{
     RowBox[{"phi_", "?", "MappingQ"}], "[", "x_", "]"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vb", "=", 
       RowBox[{"VBundleOfIndex", "[", "x", "]"}]}], "}"}], ",", 
     RowBox[{"vb", "/;", 
      RowBox[{"vb", "===", 
       RowBox[{"Tangent", "[", 
        RowBox[{"MappingImage", "[", "phi", "]"}], "]"}]}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", 
     RowBox[{
      RowBox[{"imod_Symbol", "?", "IModQ"}], "[", "x_", "]"}], "]"}], ":=", 
    RowBox[{"VBundleOfIndex", "[", "x", "]"}]}], ";", 
   RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Special", " ", "case", " ", "for", " ", "definition", " ", "of", " ", 
    "tensors", " ", "with", " ", "variable", " ", "rank"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", 
    RowBox[{"AnyIndices", "[", 
     RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], "]"}], ":=", "vbundle"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", 
    RowBox[{"index_Symbol", "?", "AIndexQ"}], "]"}], ":=", 
   RowBox[{"VBundleOfIndex", "@", 
    RowBox[{"NoDollar", "@", "index"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", "x_LI", "]"}], ":=", "Labels"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"VBundleOfIndex", "[", "index_", "]"}], ":=", 
    RowBox[{
     RowBox[{"VBundleOfIndex", "[", 
      RowBox[{"ToExpression", "@", 
       RowBox[{"SymbolName", "@", "index"}]}], "]"}], "/;", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"$ContextPath", ",", 
       RowBox[{"Context", "[", "index", "]"}]}], "]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", "index_", "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"VBundleOfIndex", "::", "unknown"}], ",", "\"\<index\>\"", ",", 
     " ", "index"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"VBundleOfIndex", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "VBundleOfIndex", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"351b83eb-b51e-4d7e-a9c0-42498ad868a7"],

Cell["\<\
Vector bundle of an index, taking care of signs. It is convenient to keep the \
head AnyIndices here, instead of removing it as we do in VBundleOfIndex. This \
function is currently used in DefTensor, SeparateMetric and ToCanonical.\
\>", "Text",ExpressionUUID->"ad870994-9eb5-46b2-8c48-463b3758ef52"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SignedVBundleOfIndex", "[", 
    RowBox[{"AnyIndices", "[", 
     RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], "]"}], ":=", 
   RowBox[{"AnyIndices", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SignedVBundleOfIndex", "[", 
    RowBox[{"index_", "?", "UpIndexQ"}], "]"}], ":=", 
   RowBox[{"VBundleOfIndex", "[", "index", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SignedVBundleOfIndex", "[", 
    RowBox[{"index_", "?", "DownIndexQ"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"VBundleOfIndex", "[", "index", "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2068e496-aabe-412e-9a87-56c5aa5164e2"],

Cell["A common construction:", \
"Text",ExpressionUUID->"cfc04bea-43f4-4e5a-9080-4af121104c96"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VBundleUpQ", "[", "index_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"VBundleOfIndex", "[", "index", "]"}], ",", 
     RowBox[{"UpIndexQ", "[", "index", "]"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fcbfbb7d-3f76-4888-971a-78e231ae1569"],

Cell["\<\
Note that a cnumber does not identify a vector bundle uniquely but the basis \
does it.\
\>", "Text",ExpressionUUID->"f047fb14-47cf-47b7-a685-7f42d2264e22"],

Cell[TextData[{
 "5) We associate all labels to a ficticious manifold/vector bundle called \
Labels. This is a dirty trick to keep the current structure of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". Its properties are:"
}], "Text",ExpressionUUID->"38d54e9f-8338-4b30-b6e4-3d3b136f363a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"These", " ", "upvalues", " ", "are", " ", "used"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VBundleQ", "[", "Labels", "]"}], "^:=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAs", "[", "Labels", "]"}], "^:=", "Labels"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricsOfVBundle", "[", "Labels", "]"}], "^:=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Are", " ", "these", " ", "other", " ", "used", " ", 
     RowBox[{"too", "?", " ", "We"}], " ", "print", " ", "a", " ", "message", 
     " ", "in", " ", "case", " ", "they", " ", "are"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xAct`xCoba`CNumbersOf", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<CNumbersOf[Labels] called. Tell JMM\>\"", "]"}], 
       ";", 
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldQ", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<ManifoldQ[Labels] called. Tell JMM\>\"", "]"}], ";",
        "True"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SplittingsOfManifold", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<SplittingsOfManifold[Labels] called. Tell JMM\>\"", 
        "]"}], ";", 
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DimOfManifold", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<DimOfManifold[Labels] called. Tell JMM\>\"", "]"}], 
       ";", "0"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DimOfVBundle", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<DimOfVBundle[Labels] called. Tell JMM\>\"", "]"}], 
       ";", "0"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VisitorsOf", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<VisitorsOf[Labels] called. Tell JMM\>\"", "]"}], 
       ";", 
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ServantsOf", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<ServantsOf[Labels] called. Tell JMM\>\"", "]"}], 
       ";", 
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndicesOfVBundle", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<IndicesOfVBundle[Labels] called. Tell JMM\>\"", 
        "]"}], ";", 
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BaseOfVBundle", "[", "Labels", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<BaseOfVBundle[Labels] called. Tell JMM\>\"", "]"}], 
       ";", "Null"}], ")"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"60c9bcce-d79c-4b13-abef-299501bfb8b4"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
7.1.6. Special definitions for a 1-dim vbundle. Now deactivated\
\>", "Subsubsection",ExpressionUUID->"b015607b-2cf9-40e5-84e6-0792791190d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RegisterDim1VBundle", "[", 
   RowBox[{"vbundle_Symbol", ",", "index_"}], "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xUpSet", "[", 
     RowBox[{
      RowBox[{"Dim1IndexQ", "[", "index", "]"}], ",", "True"}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"xUpSet", "[", 
     RowBox[{
      RowBox[{"IndexName", "[", "index", "]"}], ",", "0"}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"DummyIn", "[", "vbundle", "]"}], "^=", "index"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"NewIndexIn", "[", "vbundle", "]"}], "^=", "index"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"vbundle", "/:", 
     RowBox[{"GetIndicesOfVBundle", "[", 
      RowBox[{"vbundle", ",", "n_", ",", "_"}], "]"}], ":=", 
     RowBox[{"Table", "[", 
      RowBox[{"index", ",", 
       RowBox[{"{", "n", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"e5ad5938-2409-4e1c-b92f-4a8ec693478e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Dim1IndexQ", "[", 
    RowBox[{"-", "i_"}], "]"}], ":=", 
   RowBox[{"Dim1IndexQ", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dim1IndexQ", "[", "_", "]"}], ":=", "False"}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"253ad6d7-224a-48b0-abda-84c67627277b"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.7. Main function", \
"Subsubsection",ExpressionUUID->"b4ef7d7c-2969-4229-a64e-e4948ecd6215"],

Cell["\<\
There are two possibilities for the third argument:
\t1) a positive integer, the dimension
\t2) a constant-symbol, interpreted as the dimension
In other case we throw an error.\
\>", "Text",ExpressionUUID->"6cf5cee1-639f-4c0d-9cb6-dc7a92ae9a92"],

Cell["\<\
Note that it is not possible to define a 0-dimensional vector bundle. Note \
also that RegisterIndices uses DaggerIndex, which itself uses DaggerQ and \
hence requires the SetDaggerPair already in place. That forces us to break \
the dagger manipulations in two groups.\
\>", "Text",ExpressionUUID->"62e52b34-5749-41cd-9af6-3bb78d918d18"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefVBundle", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Dagger", "\[Rule]", "Real"}], ",", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<vbundle\>\"", ",", "\"\<\>\""}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefVBundle", "[", 
     RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
    RowBox[{"Scan", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DefVBundle", "[", 
        RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Backwards", " ", "compatibility"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefVBundle", "[", 
     RowBox[{
     "vbundle_", ",", "manifold_", ",", "dimF_", ",", "indices_", ",", 
      "ultraindex_Symbol", ",", "options___"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<** DefVBundle (legacy): Ultraindex \>\"", "<>", 
        RowBox[{"ToString", "[", "ultraindex", "]"}], "<>", 
        "\"\< converted into normal index.\>\""}], "]"}], ";", 
      RowBox[{"DefVBundle", "[", 
       RowBox[{"vbundle", ",", "manifold", ",", "dimF", ",", 
        RowBox[{"Append", "[", 
         RowBox[{"indices", ",", "ultraindex"}], "]"}], ",", "options"}], 
       "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Backwards", " ", "compatibility"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefVBundle", "[", 
     RowBox[{
     "vbundle_", ",", "manifold_", ",", "subvbundles_List", ",", "indices_", 
      ",", 
      RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"DefVBundle", "[", 
       RowBox[{"vbundle", ",", "manifold", ",", 
        RowBox[{"Apply", "[", 
         RowBox[{"Plus", ",", 
          RowBox[{"DimOfVBundle", "/@", "subvbundles"}]}], "]"}], ",", 
        "indices", ",", "options"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"SplitVBundle", "[", 
       RowBox[{"vbundle", ",", "subvbundles"}], "]"}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Simple", " ", "vector", " ", "bundle"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefVBundle", "[", 
     RowBox[{"vbundle_", ",", "manifold_", ",", "dimF_", ",", "indices_", ",", 
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Catch", "@", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"dag", ",", "master", ",", "pa", ",", "pns", ",", "info"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"dag", ",", "master", ",", "pa", ",", "pns", ",", "info"}], 
          "}"}], "=", 
         RowBox[{"OptionValue", "[", 
          RowBox[{"{", 
           RowBox[{
           "Dagger", ",", "Master", ",", "PrintAs", ",", "ProtectNewSymbol", 
            ",", "DefInfo"}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"checkDefVBundle", "[", 
         RowBox[{
         "vbundle", ",", "manifold", ",", "dimF", ",", "indices", ",", 
          "dag"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"MakeDefInfo", "[", 
         RowBox[{"DefVBundle", ",", "vbundle", ",", "info"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{
         "DefVBundle", ",", "\"\<Beginning\>\"", ",", "vbundle", ",", 
          "manifold", ",", "dimF", ",", "indices", ",", "ultraindex", ",", 
          "options"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", 
         RowBox[{"dag", ",", "\[IndentingNewLine]", "Real", ",", 
          RowBox[{
           RowBox[{"Dagger", "[", "vbundle", "]"}], "^=", "vbundle"}], ",", 
          "\[IndentingNewLine]", "Complex", ",", 
          RowBox[{"SetDaggerPair", "[", 
           RowBox[{"vbundle", ",", 
            RowBox[{"MakeDaggerSymbol", "[", "vbundle", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", "Conjugate", ",", "Null"}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"RegisterVBundle", "[", 
         RowBox[{"vbundle", ",", "manifold"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"RegisterIndices", "[", 
         RowBox[{"vbundle", ",", "indices"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Dim1", ":", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"dimF", "===", "1"}], ",", 
             RowBox[{"RegisterDim1VBundle", "[", 
              RowBox[{"vbundle", ",", 
               RowBox[{"First", "[", "indices", "]"}]}], "]"}]}], "]"}]}], 
          ";"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"dag", "===", "Complex"}], ",", "\[IndentingNewLine]", 
          RowBox[{"DefVBundle", "[", 
           RowBox[{
            RowBox[{"Dagger", "[", "vbundle", "]"}], ",", "manifold", ",", 
            "dimF", ",", 
            RowBox[{"DaggerIndex", "/@", "indices"}], ",", 
            RowBox[{"Dagger", "\[Rule]", "Conjugate"}], ",", 
            RowBox[{"Master", "\[Rule]", "vbundle"}], ",", "options", ",", 
            RowBox[{"DefInfo", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"\"\<conjugated vbundle\>\"", ",", 
               RowBox[{"\"\<Assuming fixed anti-isomorphism between \>\"", "<>", 
                RowBox[{"ToString", "[", "vbundle", "]"}], "<>", 
                "\"\< and \>\"", "<>", 
                RowBox[{"ToString", "[", 
                 RowBox[{"Dagger", "[", "vbundle", "]"}], "]"}]}]}], 
              "}"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DimOfVBundle", "[", "vbundle", "]"}], "^=", "dimF"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}], "^=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DefInfo", "[", "vbundle", "]"}], "^=", "info"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetPrintAs", "[", 
         RowBox[{"vbundle", ",", 
          RowBox[{"AddDaggerCharacter", "[", 
           RowBox[{
            RowBox[{"PrintAsString", "[", 
             RowBox[{"vbundle", ",", "pa"}], "]"}], ",", "dag"}], "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"SymbolRelations", "[", 
         RowBox[{"vbundle", ",", "master", ",", 
          RowBox[{"{", "manifold", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"MakexTensions", "[", 
         RowBox[{
         "DefVBundle", ",", "\"\<End\>\"", ",", "vbundle", ",", "manifold", 
          ",", "dimF", ",", "indices", ",", "ultraindex", ",", "options"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"pns", ",", 
          RowBox[{"Protect", "[", "vbundle", "]"}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Other", " ", 
    RowBox[{"cases", ".", " ", "Errors"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefVBundle", ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c3468378-9475-4de4-bcca-ecfd3baa8afb"],

Cell["\<\
The dag check is complicated. It uses a particular order: it first checks \
whether any of the vbundles involved is complex. Second, it checks that the \
splitting of the dagger is not already done (to avoid the standard Dagger \
loop). Third, it checks that the supervbundle is actually complex, and throws \
an error if not.\
\>", "Text",ExpressionUUID->"d1ae7335-4ed4-4366-b4fc-df024fa66ce4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SplitVBundle", "[", 
    RowBox[{"vbundle_", ",", "splitting_CirclePlus"}], "]"}], ":=", 
   RowBox[{"SplitVBundle", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"List", "@@", "splitting"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplitVBundle", "[", 
    RowBox[{"vbundle_", ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplitVBundle", "[", 
    RowBox[{"vbundle_", ",", "subvbundles_List"}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prot", "=", 
         RowBox[{"Unprotect", "[", "vbundle", "]"}]}], ",", "dag", ",", 
        "dagsplits"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"Checks", ".", " ", "DimOfVBundle"}], " ", "effectively", " ",
         "checks", " ", "that", " ", "subvbundles", " ", "contains", " ", 
        "vbundles"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"DimOfVBundle", "[", "vbundle", "]"}], "=!=", 
          RowBox[{"Apply", "[", 
           RowBox[{"Plus", ",", 
            RowBox[{"DimOfVBundle", "/@", "subvbundles"}]}], "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefVBundle", "::", "error"}], ",", 
            "\"\<Invalid dimension of subvbundle.\>\""}], "]"}]}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"dagsplits", "=", 
        RowBox[{"SplittingsOfVBundle", "[", 
         RowBox[{"Dagger", "@", "vbundle"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"dag", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{"DaggerQ", "/@", 
             RowBox[{"Prepend", "[", 
              RowBox[{"subvbundles", ",", "vbundle"}], "]"}]}], ")"}]}], 
          ")"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"dagsplits", "===", 
            RowBox[{"{", "}"}]}], "||", 
           RowBox[{
            RowBox[{"List", "@@", 
             RowBox[{"Last", "[", "dagsplits", "]"}]}], "=!=", 
            RowBox[{"Dagger", "/@", "subvbundles"}]}]}], ")"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"DaggerQ", "[", "vbundle", "]"}], "||", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"SplitVBundle", "::", "error"}], ",", 
              "\"\<Real vbundle cannot be splitted in complex \
subvbundles.\>\""}], "]"}]}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"xUpAppendTo", "[", 
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}], ",", 
         RowBox[{"CirclePlus", "@@", "subvbundles"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"TagSet", "[", 
          RowBox[{"vbundle", ",", 
           RowBox[{"SubvbundleQ", "[", 
            RowBox[{"vbundle", ",", "#"}], "]"}], ",", "True"}], "]"}], "&"}],
         "/@", "subvbundles"}], ";", "\[IndentingNewLine]", 
       RowBox[{"AppendToUnevaluated", "[", 
        RowBox[{"$SumVBundles", ",", "vbundle"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"SymbolRelations", "[", 
          RowBox[{"vbundle", ",", "Null", ",", "subvbundles"}], "]"}], ";"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Protect", "[", 
        RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"dag", ",", 
         RowBox[{"SplitVBundle", "[", 
          RowBox[{
           RowBox[{"Dagger", "[", "vbundle", "]"}], ",", 
           RowBox[{"Dagger", "/@", "subvbundles"}]}], "]"}]}], "]"}], ";"}]}],
      "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SplitVBundle", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SplitVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1226dd78-a193-480a-9d2b-e306543dead3"],

Cell["Again, we do not register any SymbolRelations.", \
"Text",ExpressionUUID->"b6210bd1-7f8a-406d-8444-5786af0a2743"],

Cell["Dimensions of vbundle and its dual coincide:", \
"Text",ExpressionUUID->"fe5fd6ab-e06c-45a5-a70a-27466ff3b038"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DimOfVBundle"}]], \
"Input",ExpressionUUID->"002d8bfa-ddf7-4b22-a1ee-93cec4432ee2"],

Cell[BoxData[
 StyleBox["\<\"DimOfVBundle[vbundle] yields the dimension of vector bundle \
vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672524-5338953",ExpressionUUID->"ea49f0a8-6dbc-4fbf-91a7-\
352a0b3bbefa"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimOfVBundle", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"DimOfVBundle", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimOfVBundle", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DimOfVBundle", "::", "unknown"}], ",", "\"\<vbundle\>\"", ",", 
      "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DimOfVBundle", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DimOfVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"14a682a8-cfe1-4270-bc8b-02421db21b04"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TangentBundleQ", "[", 
    RowBox[{"vb_", "?", "VBundleQ"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TangentBundleQ", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"TangentBundleQ", "::", "unknown"}], ",", "\"\<vbundle\>\"", 
      ",", "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"TangentBundleQ", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TangentBundleQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"31515d9b-d744-45a2-b71d-96675593bef9"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.8. Undefinition", \
"Subsubsection",ExpressionUUID->"f8530c1b-fe98-4c76-902a-8abbb4519326"],

Cell["\<\
When we undefine a vector bundle, we also undefine all tensor fields on that \
bundle. If it is complex we also undefine its conjugate, which is a servant.\
\>", "Text",ExpressionUUID->"9a42986e-4a9b-4421-8cc8-7c9baa09c8b4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UndefVBundle"}]], \
"Input",ExpressionUUID->"9426b8ca-a6bc-4ccc-968f-f0e54df8aea5"],

Cell[BoxData[
 StyleBox["\<\"UndefVBundle[vbundle] undefines the vector bundle \
vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672526-5338953",ExpressionUUID->"8d49339b-c57c-4543-b078-\
b14c62620a0f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefVBundle", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "VBundleQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefVBundle", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefVBundle", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"servants", "=", 
         RowBox[{"ServantsOf", "[", "vbundle", "]"}]}], ",", 
        RowBox[{"manifold", "=", 
         RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"VBundleQ", "[", "vbundle", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefVBundle", "::", "unknown"}], ",", "\"\<bundle\>\"", 
            ",", "vbundle"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "vbundle", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefVBundle", ",", "\"\<Beginning\>\"", ",", "vbundle"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "vbundle", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "vbundle", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"UndefAbstractIndex", "/@", 
        RowBox[{"Flatten", "@", 
         RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$VBundles", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$VBundles", ",", "vbundle"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"$SumVBundles", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$SumVBundles", ",", "vbundle"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Remove", "[", 
        RowBox[{
         RowBox[{"Evaluate", "@", 
          RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"VBundleIndexPMQ", "[", "vbundle", "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefVBundle", ",", "\"\<End\>\"", ",", "vbundle"}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"MakeUndefInfo", "[", 
        RowBox[{"UndefVBundle", ",", "vbundle"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"RemoveSymbol", "[", "vbundle", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefVBundle", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"57223530-289a-41b1-9377-fec1ee90b4f3"],

Cell["\<\
Note that the functions vbundle`Q and vbundle`pmQ must be removed explicitly.\
\
\>", "Text",ExpressionUUID->"583d4e3f-3e8c-46e0-832b-6b80ea46722f"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.9. Direct sums and tensor products", \
"Subsubsection",ExpressionUUID->"67315cda-d23b-4101-b294-3f1a8ecfe7c9"],

Cell["\<\
Direct sums. For the addition of vbundles over the same base this is actually \
the Whitney sum, but we extend it to also cover the more general case of \
vbundle over different bases by using DeleteDuplicates below.\
\>", "Text",ExpressionUUID->"1e0e27b2-fade-47b6-964d-0955080f0bf6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"CirclePlus", ",", 
    RowBox[{"{", 
     RowBox[{"Flat", ",", "OneIdentity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Verbatim", "[", "CirclePlus", "]"}], "[", "vbundle_", "]"}], ":=",
    "vbundle"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"43d9af02-ec7d-46d8-bf81-9b4a24ffca6b"],

Cell["Properties of a direct sum vbundle:", \
"Text",ExpressionUUID->"b27e24c1-0fff-42de-9657-82734f07a87e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"VBundleQ", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"VBundleQ", "/@", 
      RowBox[{"List", "@@", "vbundle"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BaseOfVBundle", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"CartesianProduct", "@@", 
    RowBox[{"DeleteDuplicates", "[", 
     RowBox[{"BaseOfVBundle", "/@", 
      RowBox[{"List", "@@", "vbundle"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimOfVBundle", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"(", 
     RowBox[{"DimOfVBundle", "/@", 
      RowBox[{"List", "@@", "vbundle"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndicesOfVBundle", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   "TODO"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LastIndex", "[", "vbundle_CirclePlus", "]"}], "^:=", "TODO"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Metric", " ", "tensors", " ", "by", " ", "blocks", " ", "using", " ", 
    "respective", " ", "members", " ", "of", " ", "the", " ", 
    "MetricsOfVBundle", " ", "lists"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"metrics", ",", "min"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"metrics", "=", 
       RowBox[{"MetricsOfVBundle", "/@", 
        RowBox[{"List", "@@", "vbundle"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"min", "=", 
       RowBox[{"Min", "[", 
        RowBox[{"Length", "/@", "metrics"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"metrics", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"#", ",", "min"}], "]"}], "&"}], "/@", "metrics"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"BlockTensor", "[", 
         RowBox[{"DiagonalArray", "[", 
          RowBox[{"#", ",", "2", ",", "Zero"}], "]"}], "]"}], "&"}], "/@", 
       RowBox[{"Transpose", "[", "metrics", "]"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfVBundle", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"{", "vbundle", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CirclePlus", "/:", 
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"large_CirclePlus", ",", "small_CirclePlus"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "large", "]"}], "===", 
      RowBox[{"Length", "[", "small", "]"}]}], ",", 
     RowBox[{"Inner", "[", 
      RowBox[{"SubvbundleQ", ",", "large", ",", "small", ",", "And"}], "]"}], 
     ",", "False"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"Dagger", "/@", "vbundle"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4df6404c-21c4-4324-b74e-200be6af3342"],

Cell["Formatting:", \
"Text",ExpressionUUID->"15399491-1e38-4911-8d45-99dec13c09a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "vbundle_CirclePlus", "]"}], "^:=", 
   RowBox[{"StringJoin", "@@", 
    RowBox[{"Riffle", "[", 
     RowBox[{
      RowBox[{"PrintAs", "/@", 
       RowBox[{"List", "@@", "vbundle"}]}], ",", "\"\<\[CirclePlus]\>\""}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"775a5d33-acfe-46a6-aa0a-cc1e13cd6e5e"],

Cell["\<\
Tensor products. Currently this is DEACTIVATED, because it is not used and we \
need the symbol CircleTimes for the tensor product of tensors.\
\>", "Text",ExpressionUUID->"8167e6da-9d92-44e2-a419-b621f39df53e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"CircleTimes", ",", 
    RowBox[{"{", 
     RowBox[{"Flat", ",", "OneIdentity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Verbatim", "[", "CircleTimes", "]"}], "[", "vbundle_", "]"}], ":=",
    "vbundle"}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"238ff213-617c-4538-826d-707da56b6d5c"],

Cell["Properties of a tensor product vbundle:", \
"Text",ExpressionUUID->"51e8bf63-2916-49ed-8387-05aaf4e788dd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"VBundleQ", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"VBundleQ", "/@", 
      RowBox[{"List", "@@", "vbundle"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BaseOfVBundle", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   "TODO"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimOfVBundle", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   RowBox[{"Times", "@@", 
    RowBox[{"(", 
     RowBox[{"DimOfVBundle", "/@", 
      RowBox[{"List", "@@", "vbundle"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndicesOfVBundle", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   "TODO"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LastIndex", "[", "vbundle_CircleTimes", "]"}], "^:=", "TODO"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   "TODO"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfVBundle", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   "TODO"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CircleTimes", "/:", 
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"vbundle_CircleTimes", ",", "small_"}], "]"}], ":=", "TODO"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   RowBox[{"Dagger", "/@", "vbundle"}]}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"b6fffc22-f2d5-44e9-91cc-4ef6bd6cc94d"],

Cell["Formatting:", \
"Text",ExpressionUUID->"6ffdaafe-4a0b-43d3-9709-682365d6f840"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "vbundle_CircleTimes", "]"}], "^:=", 
   RowBox[{"StringJoin", "@@", 
    RowBox[{"Riffle", "[", 
     RowBox[{
      RowBox[{"PrintAs", "/@", 
       RowBox[{"List", "@@", "vbundle"}]}], ",", "\"\<\[CircleTimes]\>\""}], 
     "]"}]}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"65d44ec6-914e-4ce3-887d-580add7d4a3b"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.10. The pullback bundle", \
"Subsubsection",ExpressionUUID->"371df599-f142-4f9d-8338-904c8612462f"],

Cell["\<\
This must be the first definition, to avoid the checks in this case:\
\>", "Text",ExpressionUUID->"82a6d746-170c-4302-bef9-9bbea3ba1fb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PullBackVBundle", "[", 
    RowBox[{
     RowBox[{"vbundle_", "?", "VBundleQ"}], ",", "_IdentityMapping"}], "]"}], 
   ":=", "vbundle"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"767d3b24-7916-401e-bcf0-2391772098c7"],

Cell["Ensure consistency of arguments:", \
"Text",ExpressionUUID->"f1a37b12-5007-415d-b4f1-3d5523344e78"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PullBackVBundle", "::", "vbmap"}], "=", 
   "\"\<Base of vbundle `1` does not coincide with the image of mapping \
`2`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PullBackVBundle", "[", 
   RowBox[{
    RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
    RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], ":=", 
  RowBox[{"$Failed", "/;", 
   RowBox[{
    RowBox[{
     RowBox[{"MappingImage", "[", "phi", "]"}], "=!=", 
     RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}], "&&", 
    RowBox[{"Throw", "@", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"PullBackVBundle", "::", "vbmap"}], ",", "vbundle", ",", 
       "phi"}], "]"}]}]}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4903d185-eb06-449b-8332-0fdabe9ca972"],

Cell["Basic definitions:", \
"Text",ExpressionUUID->"b30075b7-ab40-471b-97fc-08c6f85c475c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"VBundleQ", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"-", "vbundle_"}], ",", "phi_"}], "]"}], ":=", 
    RowBox[{"-", 
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{"vbundle", ",", "phi"}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"It", " ", "is", " ", "a", " ", "right"}], "-", 
    RowBox[{
    "action", " ", "with", " ", "respect", " ", "to", " ", "composition"}]}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackVBundle", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{
       RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
       RowBox[{"phi1_", "?", "MappingQ"}]}], "]"}], ",", 
     RowBox[{"phi2_", "?", "MappingQ"}]}], "]"}], ":=", 
   RowBox[{"PullBackVBundle", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"SmallCircle", "[", 
      RowBox[{"phi1", ",", "phi2"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c16b611e-a646-4e04-a649-f008f0ffde65"],

Cell["\<\
IndicesOfVBundle for a PullBackVBundle object was already handled before.\
\>", "Text",ExpressionUUID->"eb15a05b-6cfb-495d-b83a-0e68de4fce63"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "The", " ", "dimension", " ", "of", " ", "a", " ", "bundle", " ", "is", 
     " ", "that", " ", "of", " ", "its", " ", "standard", " ", "fiber"}], ",",
     " ", 
    RowBox[{
    "shared", " ", "by", " ", "a", " ", "bundle", " ", "and", " ", "its", " ",
      "pullbacks"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DimOfVBundle", "[", 
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{
       RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
       RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
    RowBox[{"DimOfVBundle", "[", "vbundle", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9fd2d05f-dc3e-4485-8284-f2a3256d76b2"],

Cell["Field related properties:", \
"Text",ExpressionUUID->"c35c29b1-7c78-4b01-ae4a-3409434b4ef2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BaseOfVBundle", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"MappingDomain", "[", "phi", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"PullBackVBundle", "[", 
    RowBox[{
     RowBox[{"Dagger", "[", "vbundle", "]"}], ",", 
     RowBox[{"Dagger", "[", "phi", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HasDaggerCharacterQ", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"HasDaggerCharacterQ", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{
    RowBox[{
     RowBox[{"Precompose", "[", 
      RowBox[{"#", ",", "phi"}], "]"}], "&"}], "/@", 
    RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfVBundle", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{"vbundle_", ",", "phi_"}], "]"}], "]"}], "^:=", 
   RowBox[{
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{"#", ",", "phi"}], "]"}], "&"}], "/@", 
    RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{"large_", ",", "phi_"}], "]"}], ",", 
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{"small_", ",", "phi_"}], "]"}]}], "]"}], "^:=", 
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"large", ",", "small"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2864b64c-7ba2-4226-b1aa-1adffd5129f9"],

Cell["Formatting.", \
"Text",ExpressionUUID->"e2e646fe-56f8-47b9-8e82-e81883521fd8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{"vbundle_", ",", "phi_"}], "]"}], "]"}], "^:=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"\"\<(\\!\\(\>\"", ",", 
     RowBox[{"PrintAs", "[", "vbundle", "]"}], ",", "\"\<\\^*\\))\>\""}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6cd32d11-5369-46f2-adcd-af33a331d197"],

Cell["Special formatting rule for this case:", \
"Text",ExpressionUUID->"55dba54e-54ed-4b01-a763-6b867c63fea9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{
       RowBox[{"vbundle_", "?", "HeldVBundleQ"}], ",", 
       RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], ",", "StandardForm"}], 
    "]"}], ":=", 
   RowBox[{"PullBackBox", "[", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{"vbundle", ",", "StandardForm"}], "]"}], ",", "phi"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c4d145a4-eab6-44ff-985c-ab4cb9b5d55a"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.11. Formatting", \
"Subsubsection",ExpressionUUID->"a112fb68-963b-43bb-9661-c517bc8b2039"],

Cell["\<\
Held version of VBundleQ to avoid evaluation leaks during typesetting:\
\>", "Text",ExpressionUUID->"1ff0d325-d2a7-488c-b519-51120811851a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldVBundleQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldVBundleQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"VBundleQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"04a08a20-8a1d-4e11-aa79-19637c9e3b88"],

Cell["StandardForm:", \
"Text",ExpressionUUID->"65643814-5f5a-4ec2-a457-6c0a7e042b24"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "VBundle", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"vb_Symbol", "?", "HeldVBundleQ"}], ",", "StandardForm"}], 
      "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{"vb", ",", 
       RowBox[{"PrintAs", "[", 
        RowBox[{"Unevaluated", "[", "vb", "]"}], "]"}]}], "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "VBundle", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{"vb_Symbol", "?", "HeldVBundleQ"}], ",", "StandardForm"}], 
      "]"}], "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"xTensorFormStart", "[", "VBundle", "]"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ab910860-9a9a-49e4-b8be-af06f015a0a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.12. Examples", \
"Subsubsection",ExpressionUUID->"344cdac8-0b55-47f3-892f-595877552802"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"47cd8718-57ad-4df1-8141-25b0189ccc6d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b9406dd8-2afd-47c0-975c-7526448121cf"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"47510b6d-d6a0-4d0d-bbfb-7364f4e3dae3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d4671c7b-2b58-4d73-934f-4ef3a3b85b7c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "S2"}]], "Input",ExpressionUUID->"2ba5f417-195e-44e0-8770-9ff2a9e2f30b"],

Cell[CellGroupData[{

Cell["Global`S2", "Print", "PrintUsage",
 CellTags->
  "Info3578672528-5338953",ExpressionUUID->"5e8ee57a-1431-4271-89d1-\
91edc9c5e40c"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "S2", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "S2", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "S2", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "S2", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "S2", "]"}], "^=", "\<\"S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "S2", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "S2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`S2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672528-5338953",ExpressionUUID->"ed86fd04-6b55-49f5-ac8d-\
c7f05718e02c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2"}]], \
"Input",ExpressionUUID->"9325fd51-d9ff-4059-a474-b73a5f034059"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]S2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentS2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672529-5338953",ExpressionUUID->"277663cb-beca-47c2-83ea-\
66d7d52618c2"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentS2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentS2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
            "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"f", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentS2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672529-5338953",ExpressionUUID->"f557e81d-ca4d-4b70-a3b0-\
7e70edf883d9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a"}]], "Input",ExpressionUUID->"3ba97f0e-a0e9-483d-a154-80a6a97f8e3f"],

Cell[CellGroupData[{

Cell["Global`a", "Print", "PrintUsage",
 CellTags->
  "Info3578672531-5338953",ExpressionUUID->"609b81b0-b37a-4b30-a14d-\
14236661e880"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "a", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "a", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DaggerIndex", "[", "a", "]"}], "^=", "a"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "a", "]"}], "^=", 
         "a"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "a", "]"}], "^=", "\<\"a\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentS2`Q", "[", "a", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "a", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`a],
  Editable->False]], "Print",
 CellTags->
  "Info3578672531-5338953",ExpressionUUID->"2a1e3686-1dfd-4969-b6fd-\
ad9f09bc021c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AIndexQ", "[", 
   RowBox[{"-", "a"}], "]"}], "//", 
  "Trace"}]], "Input",ExpressionUUID->"fc4d3f28-ea2e-403b-ac54-17ae14c8584b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"AIndexQ", "[", 
     RowBox[{"-", "a"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"AIndexQ", "[", "a", "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"AbstractIndexQ", "[", 
     RowBox[{"xAct`xTensor`Private`NoDollar", "[", "a", "]"}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xAct`xTensor`Private`NoDollar", "[", "a", "]"}],
      HoldForm], ",", 
     TagBox["a",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"AbstractIndexQ", "[", "a", "]"}],
    HoldForm], ",", 
   TagBox["True",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"a902768e-d7ae-4bc5-845e-7886a4806c4d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DaggerIndex", "[", "a", 
  "]"}]], "Input",ExpressionUUID->"1d42c249-35db-4335-9f93-902cf476338b"],

Cell[BoxData["a"], \
"Output",ExpressionUUID->"01dcd38b-d2c0-41ab-bce9-5c55a85f4593"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2`Q"}]], \
"Input",ExpressionUUID->"d5f3b709-6b95-42f4-a2fc-f60f4ee7f139"],

Cell[CellGroupData[{

Cell["TangentS2`Q", "Print", "PrintUsage",
 CellTags->
  "Info3578672533-5338953",ExpressionUUID->"aa220392-f896-4c98-bdc8-\
2324234bfea0"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"TangentS2`Q", "[", 
          RowBox[{"-", "xAct`xTensor`Private`index_"}], "]"}], ":=", 
         "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentS2`Q", "[", 
          RowBox[{
          "xAct`xTensor`Private`index$_Symbol", "?", 
           "xAct`xTensor`Private`DollarQ"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"TangentS2`Q", "[", "xAct`xTensor`Private`index$", "]"}], "^=", 
          RowBox[{"TangentS2`Q", "[", 
           RowBox[{
           "xAct`xTensor`Private`NoDollar", "[", 
            "xAct`xTensor`Private`index$", "]"}], "]"}]}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentS2`Q", "[", "_", "]"}], ":=", "False"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[TangentS2`Q],
  Editable->False]], "Print",
 CellTags->
  "Info3578672533-5338953",ExpressionUUID->"9550f3d9-4dcf-4c47-8d4d-\
6e551b673673"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2`pmQ"}]], \
"Input",ExpressionUUID->"444ab61e-e19a-45a5-90a2-c24f2aa887d8"],

Cell[CellGroupData[{

Cell["TangentS2`pmQ", "Print", "PrintUsage",
 CellTags->
  "Info3578672534-5338953",ExpressionUUID->"4230d828-45da-4d18-8bd9-\
076f886176d7"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"TangentS2`pmQ", "[", 
          RowBox[{"-", "xAct`xTensor`Private`index$_"}], "]"}], ":=", 
         RowBox[{"TangentS2`Q", "[", "xAct`xTensor`Private`index$", "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentS2`pmQ", "[", "xAct`xTensor`Private`index$_", "]"}], 
         ":=", 
         RowBox[{"TangentS2`Q", "[", "xAct`xTensor`Private`index$", "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[TangentS2`pmQ],
  Editable->False]], "Print",
 CellTags->
  "Info3578672534-5338953",ExpressionUUID->"f625a356-84b6-4253-8aa6-\
8acc1676bb2c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dagger", "[", "TangentS2", 
  "]"}]], "Input",ExpressionUUID->"17939a7b-a647-4a8e-9596-5bea05d3ea71"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]S2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentS2,
  Editable->
   False]], "Output",ExpressionUUID->"cb4c0322-19ee-4b14-aeff-37ef9caabe09"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"dee7603e-a9ac-4772-9afe-b9b763572b1b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"ee97d870-0341-4879-bbc1-fe5469feefbd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"a332923b-87aa-43c0-99a8-c3f9e9cdb76e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "S2`*"}]], "Input",ExpressionUUID->"d8f27b9d-b89b-4b66-a4f8-db4ea0dba39d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"S2`*\\\"\\)\[NoBreak] \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"550bb6ce-3785-4caa-96c5-005c8c6b2806"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2`*"}]], \
"Input",ExpressionUUID->"1a71a908-aed1-42c6-bb04-f5427f0de4d4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"TangentS2`*\\\"\\)\
\[NoBreak] found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"206143d1-a232-4c7b-8463-9aaf61c2e67a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a"}]], "Input",ExpressionUUID->"3ff1ca56-19b5-4e97-914b-16e7ba697cd1"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"a\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"438e66ae-b0c6-4e51-8a5c-2ca27c0f95d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a$*"}]], "Input",ExpressionUUID->"05654552-1243-464e-abb7-18080dbe09ff"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"a$*\\\"\\)\[NoBreak] \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"04fcff96-89e3-4009-a18d-f6974689eeaf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"6ef598eb-6536-452c-8e10-2b8f1958b405"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0139f0da-f2b8-4e56-8a24-31890ca8f3a7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ad3dd396-dc1b-47f4-960d-529ce93b200b"]
}, Open  ]]
}, Open  ]],

Cell["Here we overload the system capitals:", \
"Text",ExpressionUUID->"c0df1b0a-06be-4d97-9a10-fe0ba267dde6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefVBundle", "[", 
  RowBox[{"Fiber", ",", "S2", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Real"}]}], 
  "]"}]], "Input",ExpressionUUID->"64e58de6-7e70-4fbf-bc31-1743f928576d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "Fiber", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`Fiber, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"30f6170d-6168-40e8-9994-994d61d7db63"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8df74117-9355-4f8c-bb22-dce7a9234b36"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"32f57e4d-6410-483d-8b03-094b05755960"]
}, Open  ]],

Cell["The D still is interpreted as a derivative:", \
"Text",ExpressionUUID->"b9c8a626-192f-49ff-b5cf-b91e817d2221"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", "x"}], 
  "]"}]], "Input",ExpressionUUID->"b9a582f3-e2c5-425d-9f32-371807823ce2"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["f", "\[Prime]",
   MultilineFunction->None], "[", "x", 
  "]"}]], "Output",ExpressionUUID->"9e48ab80-df55-4bd7-aaa6-fcbf8787acbc"]
}, Open  ]],

Cell["but it is also an index:", \
"Text",ExpressionUUID->"15659251-96e8-459c-abac-d241a9b586ae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbstractIndexQ", "[", "D", 
  "]"}]], "Input",ExpressionUUID->"60eb7d9a-d95e-4cf5-a6eb-2cc8fdf6bf3d"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"4f365c65-c810-4ed8-b493-110f6a2cdaaf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VBundleOfIndex", "[", "D", 
  "]"}]], "Input",ExpressionUUID->"624ed97c-8e93-4970-b261-6cb11e142e86"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber,
  Editable->
   False]], "Output",ExpressionUUID->"a9866d80-caf3-4971-b8f3-f67847eb5bdc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber"}]], "Input",ExpressionUUID->"11861783-538a-45b5-8819-4ac8272dbbde"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672538-5338953",ExpressionUUID->"1675c208-5591-4b3f-8581-\
be05cda5c255"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["Fiber",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Fiber,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["Fiber",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Fiber,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Fiber],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "3"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"D", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "\<\"Fiber\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Fiber],
  Editable->False]], "Print",
 CellTags->
  "Info3578672538-5338953",ExpressionUUID->"63eb5438-a588-4aa7-87e0-\
d65f43ccaaa8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber\[Dagger]"}]], \
"Input",ExpressionUUID->"8a8b19e6-7816-4b07-a73e-636ad5cd2418"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"Fiber\\\\[Dagger]\\\"\\)\
\[NoBreak] found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"718b6ea4-c466-4139-ba13-4ef642a92d47"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "A"}]], "Input",ExpressionUUID->"8fe75439-0208-40fe-8f36-3de0fadf66b3"],

Cell[CellGroupData[{

Cell["Global`A", "Print", "PrintUsage",
 CellTags->
  "Info3578672540-5338953",ExpressionUUID->"eaf10d79-732c-49f5-a7d2-\
798aa3d8054e"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "A", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "A", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DaggerIndex", "[", "A", "]"}], "^=", "A"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "A", "]"}], "^=", 
         "A"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "A", "]"}], "^=", "\<\"A\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Fiber`Q", "[", "A", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "A", "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`A],
  Editable->False]], "Print",
 CellTags->
  "Info3578672540-5338953",ExpressionUUID->"542b1d53-7032-4dc7-88b0-\
f9a40bda76ca"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "A\[Dagger]"}]], \
"Input",ExpressionUUID->"a4b53946-509c-44e5-b83a-75ad7d546de7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"A\\\\[Dagger]\\\"\\)\
\[NoBreak] found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b245660a-86ac-4cca-8fa0-417cd31b0d7e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "A\[Dagger]\[Dagger]"}]], \
"Input",ExpressionUUID->"399316a8-6c58-4700-b8c8-fac38cb43859"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"A\\\\[Dagger]\\\\[Dagger]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"5d4ac566-c3f0-4fd5-8ffc-be67c0e51e7d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"d5da9180-d7bf-46e3-b5ee-38fae61a03c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Fiber",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Fiber,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`Fiber],
  Editable->
   False]], "Print",ExpressionUUID->"276c7ed3-b556-4938-9986-45d7494293d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "S2"}]], "Input",ExpressionUUID->"9a306798-db3d-41c5-a521-231dc705506e"],

Cell[CellGroupData[{

Cell["Global`S2", "Print", "PrintUsage",
 CellTags->
  "Info3578672542-5338953",ExpressionUUID->"017f9776-ff7f-46a3-8426-\
5e673bb3c21c"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "S2", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "S2", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "S2", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "S2", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "S2", "]"}], "^=", "\<\"S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "S2", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "S2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VisitorsOf", "[", "S2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`S2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672542-5338953",ExpressionUUID->"b78ee066-dd53-4b08-b657-\
db94cb26fae6"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Though we have undefined the index D, it is still the derivative:\
\>", "Text",ExpressionUUID->"3c5348a3-10d0-40ff-b4b4-202f69a2c6ac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", "x"}], 
  "]"}]], "Input",ExpressionUUID->"07c5d0e6-c271-4fd3-b759-5ec3082f77b3"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["f", "\[Prime]",
   MultilineFunction->None], "[", "x", 
  "]"}]], "Output",ExpressionUUID->"cb3392d9-0f73-4f4d-bb07-284b372b1866"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbstractIndexQ", "[", "D", 
  "]"}]], "Input",ExpressionUUID->"ea27c10e-7b1c-4262-aa54-fe02b5828efa"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"b8f04fce-bf15-4420-b611-1dc8e463056e"]
}, Open  ]],

Cell["Now the vbundle is complex:", \
"Text",ExpressionUUID->"6f10c000-4449-4c98-9f60-719b9dbef09e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefVBundle", "[", 
  RowBox[{"Fiber", ",", "S2", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Complex"}]}], 
  "]"}]], "Input",ExpressionUUID->"a7e62101-4c3a-4a72-9668-5c3ae494f086"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "Fiber", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`Fiber, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cc486c87-ecc4-4ac0-9d2d-0511464a78c3"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9ea4d07a-6446-4eed-8909-1ff25fa28f8e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"fab4d33e-624e-4d27-bc83-dce1bded8dac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"conjugated vbundle \"\>", "\[InvisibleSpace]", 
   "Fiber\[Dagger]", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Assuming fixed anti-isomorphism between Fiber \
and Fiber\[Dagger]\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "conjugated vbundle ", $CellContext`Fiber\[Dagger], ". ", 
   "Assuming fixed anti-isomorphism between Fiber and Fiber\[Dagger]"],
  Editable->
   False]], "Print",ExpressionUUID->"6b2c114a-8fe3-48a9-8b2a-1c60ecf71919"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber"}]], "Input",ExpressionUUID->"bcd3d70b-bbd9-4aa2-a42d-0b1a04e6b267"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672544-5338953",ExpressionUUID->"ee86ed61-1053-4853-a06a-\
f3e0fff49609"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["Fiber",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Fiber,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["Fiber",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Fiber,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Fiber],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["Fiber\[Dagger]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber\[Dagger],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "3"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"D", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "\<\"Fiber\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Fiber],
  Editable->False]], "Print",
 CellTags->
  "Info3578672544-5338953",ExpressionUUID->"d82bf3b3-219e-4796-acaf-\
a4580b36cb85"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber\[Dagger]"}]], \
"Input",ExpressionUUID->"f37db03d-69e5-48cc-915c-9f9615eafdba"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber\[Dagger]",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber\[Dagger],
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672546-5338953",ExpressionUUID->"a413a94a-61e1-4f7d-8669-\
b7881defb106"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["Fiber\[Dagger]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Fiber\[Dagger],
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["Fiber\[Dagger]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Fiber\[Dagger],
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Fiber\[Dagger]],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          
          RowBox[{"\<\"conjugated vbundle\"\>", 
           ",", "\<\"Assuming fixed anti-isomorphism between Fiber and Fiber\
\[Dagger]\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "3"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "A\[Dagger]", ",", "B\[Dagger]", ",", "C\[Dagger]", ",", 
             "D\[Dagger]"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"D\[Dagger]", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "\<\"Fiber\[Dagger]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Fiber\[Dagger]],
  Editable->False]], "Print",
 CellTags->
  "Info3578672546-5338953",ExpressionUUID->"db089ead-9337-427b-aa67-\
0e1aee997316"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"b2a2d8b5-612c-4f8d-a39b-db25f95d8846"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"conjugated vbundle\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Fiber\[Dagger]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Fiber\[Dagger],
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "conjugated vbundle", 
   " ", $CellContext`Fiber\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"c9a29a80-87f3-4809-93af-408cf280cb36"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Fiber",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Fiber,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`Fiber],
  Editable->
   False]], "Print",ExpressionUUID->"15960ab7-ec06-49c6-9943-1b905199a019"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"28f442cc-fc00-49a0-b79d-2357bb86eadc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"b689206a-758d-4181-8ca0-6a89d5e78907"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"6c8ca230-b153-4190-8055-eb564f5375e2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "A"}]], "Input",ExpressionUUID->"b9c445d6-c28a-42f8-9b9e-221308f05982"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"A\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ba8d5062-643c-4f88-879c-55d2119b1c5b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "A\[Dagger]"}]], \
"Input",ExpressionUUID->"dc3c3751-2bb7-4d4d-87fa-7b171ef5a318"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"A\\\\[Dagger]\\\"\\)\
\[NoBreak] found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"415b2aa8-84f4-41da-865c-742d462d5b62"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "x", "]"}], 
  ";"}]], "Input",ExpressionUUID->"cc4ad3a7-2468-41c9-82b6-c60f0cea16bd"],

Cell["Product manifolds:", \
"Text",ExpressionUUID->"4ee1c64a-87f9-4f3e-86b0-96137babe1c6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4b25b601-d6b5-4153-899b-0bf93252d230"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", "manifold ", $CellContext`S,
    ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"439bf6e6-8b85-4d98-9466-cdd803901ea2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c9c6b4bf-7994-4348-8d9a-732d367f0026"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"R", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1bae8ff3-c875-47e9-a51e-3d0ca432f8ed"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "R", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", "manifold ", $CellContext`R,
    ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9e02da71-1f0c-4f92-82b4-25eded6a5420"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentR", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentR, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"200d6901-ae43-4f34-bf74-96571cffa631"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ad6cb07e-f752-4ded-870c-714aace750e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"T", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"e87f3669-28a0-4589-82b6-1167ad623f16"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "T", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", "manifold ", $CellContext`T,
    ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"93bfdd44-4e1f-42cb-973e-d91a94af8b79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentT", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentT, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d49bee04-10a8-4898-9a9d-5c77f3c246ec"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"SRT", ",", 
   RowBox[{"{", 
    RowBox[{"S", ",", "R", ",", "T"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", "\[Beta]", ",", "\[Chi]"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"0ed212a8-b5cc-44e0-bc34-24c24a540e2d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "SRT", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`SRT, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a5954159-2147-419a-9059-a9e298a93fbd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentSRT",
    "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentSRT, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cd3858ee-3d05-49db-a732-6d2cee94852b"]
}, Open  ]]
}, Open  ]],

Cell["SRT is a visitor of S, R and T and must be undefined first:", \
"Text",ExpressionUUID->"05fef3cf-b376-4449-bb2b-e1f412f60fcf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "SRT", 
  "]"}]], "Input",ExpressionUUID->"c10db5c1-c359-46ef-84f6-00838943670b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]SRT",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentSRT,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentSRT],
  Editable->
   False]], "Print",ExpressionUUID->"9854c7eb-48f7-4dec-899c-a55a77f0708f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "SRT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`SRT],
  Editable->
   False]], "Print",ExpressionUUID->"4daf1dd3-1c5d-4f9f-9069-50705b0f17ed"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S", 
  "]"}]], "Input",ExpressionUUID->"1701eabc-c08b-4948-9abe-0ea666a680f4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS],
  Editable->
   False]], "Print",ExpressionUUID->"b2beba25-46b1-4d9a-ae59-be2caf753f24"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"d6342339-4e6f-445b-aae4-5c8970bf64dd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "R", 
  "]"}]], "Input",ExpressionUUID->"4be09165-f1d2-4778-8c40-51d525a9f1dd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]R",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentR,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentR],
  Editable->
   False]], "Print",ExpressionUUID->"a9571f11-b635-4505-ab1f-abbbc7dfccfd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"d8af95a5-3ce8-46ef-a40b-d87dbd841b14"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"f2bb3959-1e83-4923-8962-ce533e13483a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]T",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentT,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentT],
  Editable->
   False]], "Print",ExpressionUUID->"f0e4b226-622f-4aab-9296-3f6ddfb51749"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"3acf82c2-61b2-41f5-b9b0-155550669937"]
}, Open  ]]
}, Open  ]],

Cell["Now we choose the name of the tangent bundle:", \
"Text",ExpressionUUID->"5b09d6a5-b507-4e8f-a766-acf0c9b66864"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
   RowBox[{"Tangent", "\[Rule]", "TS"}]}], 
  "]"}]], "Input",ExpressionUUID->"2b246220-4c0b-41af-9b6e-6f79016e5032"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", "manifold ", $CellContext`S,
    ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a8235d01-c350-4970-9fdd-73c81651f4e8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TS", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", "vbundle ", $CellContext`TS, 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1e2afb00-bb76-4f76-ad61-bd92f5f87b67"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "S"}]], "Input",ExpressionUUID->"3d50c1bc-9e00-4019-b530-aff2ffc2e880"],

Cell[CellGroupData[{

Cell["Global`S", "Print", "PrintUsage",
 CellTags->
  "Info3578672550-5338953",ExpressionUUID->"d123eb39-e9f4-4740-865e-\
a433281f0561"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "S", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "S", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "S", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "S", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "S", "]"}], "^=", "\<\"S\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "S", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "S", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"T", "S"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Tangent[$CellContext`S],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TS,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`S],
  Editable->False]], "Print",
 CellTags->
  "Info3578672550-5338953",ExpressionUUID->"afacb2de-5d42-42fe-ab21-\
35043492525a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TS"}]], "Input",ExpressionUUID->"340947fd-9f79-46fe-9ecf-33a2dccd4a9e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]S",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TS,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672551-5338953",ExpressionUUID->"bb32c849-0976-41e1-911f-\
6848818b8b24"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TS,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", "S"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TS,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TS],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TS,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"e", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", "S"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]S\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TS,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TS],
  Editable->False]], "Print",
 CellTags->
  "Info3578672551-5338953",ExpressionUUID->"b0ef7e3b-2ebb-4508-bac8-\
73dab9e39b13"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Undef", "[", "S", 
  "]"}]], "Input",ExpressionUUID->"add745d1-b617-454b-bf02-ba48c327be7a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TS,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TS],
  Editable->
   False]], "Print",ExpressionUUID->"88f32e02-2d4a-41ce-93c6-2d2ff641f023"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"1a20c4ac-c0f3-4bae-b95f-6f9d85b096ac"]
}, Open  ]]
}, Open  ]],

Cell["\<\
A one-dimensional manifold. Currently we do not use the single index idea.\
\>", "Text",ExpressionUUID->"e3063705-5a78-48ba-b44c-aaa46fcc490a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M1", ",", "1", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"53220bee-d164-4cdf-814e-f79226b68ffb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M1", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M1, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f73cce88-7972-4a04-a719-c0ef2786749f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM1", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM1, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cc6a2ed1-6ea4-497a-89d2-1d86ed78e5dd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "M1"}]], "Input",ExpressionUUID->"41d0bd06-26ed-41e3-9673-a22d5328e479"],

Cell[CellGroupData[{

Cell["Global`M1", "Print", "PrintUsage",
 CellTags->
  "Info3578672553-5338953",ExpressionUUID->"d22b0761-3d5c-491b-b546-\
927653edb5bf"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "M1", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "M1", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "M1", "]"}], "^=", "1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "M1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "M1", "]"}], "^=", "\<\"M1\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "M1", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "M1", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`M1],
  Editable->False]], "Print",
 CellTags->
  "Info3578672553-5338953",ExpressionUUID->"3a0de736-7115-4e7b-a676-\
cb9cc1cc3491"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentM1"}]], \
"Input",ExpressionUUID->"91a8ecbe-f567-4e79-87b9-6b9d55e81940"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]M1",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentM1,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672555-5338953",ExpressionUUID->"b750dee9-c125-4a78-8d7f-\
2d22148e4a4c"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM1,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", "M1"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M1",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM1,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentM1],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM1,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", "1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"d", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", "M1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]M1\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM1,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentM1],
  Editable->False]], "Print",
 CellTags->
  "Info3578672555-5338953",ExpressionUUID->"dbbf9a90-a007-4ecb-a3e5-\
76d0e32032ba"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M1", 
  "]"}]], "Input",ExpressionUUID->"f90c6554-cdbe-4e0d-93b8-de82a4caca9f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M1",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM1,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM1],
  Editable->
   False]], "Print",ExpressionUUID->"8db2b8e0-b6e7-4711-8a5b-e6e26157ba9e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M1"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M1],
  Editable->
   False]], "Print",ExpressionUUID->"c469a1b9-64cf-4358-b10f-d4121c9b8e0e"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"081655c2-5f96-4f23-ad33-799ad18c6d50"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["7.2. Comparing vbundles", \
"Subsection",ExpressionUUID->"51a82584-75ae-4a5e-92f7-ccb3cb3bc00a"],

Cell["\<\
This is a new function which will take into account duality when comparing \
vbundles. It is not currently used or documented, nor included in the package.\
\>", "Text",ExpressionUUID->"d061df97-e6ce-4996-b322-84c25345f418"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleQ", "[", 
    RowBox[{"vbundle1_", ",", "vbundle2_"}], "]"}], ":=", 
   RowBox[{"SameVBundleQ", "[", 
    RowBox[{"vbundle1", ",", "vbundle2", ",", 
     RowBox[{"MetricEndowedQ", "[", "vbundle1", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleQ", "[", 
    RowBox[{"vbundle_", ",", "vbundle_", ",", "_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleQ", "[", 
    RowBox[{"vbundle_", ",", 
     RowBox[{"-", "vbundle_"}], ",", "True"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleQ", "[", 
    RowBox[{
     RowBox[{"-", "vbundle_"}], ",", "vbundle_", ",", "True"}], "]"}], ":=", 
   "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameVBundleQ", "[", 
    RowBox[{"_", ",", "_", ",", "_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SameVBundleQ", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SameVBundleQ", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"20ceb102-3426-4127-b20f-ec9a2f11586f"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.3. Subvbundles", \
"Subsection",ExpressionUUID->"f2217514-9d10-4c5c-b1b0-5eb8402ca9fd"],

Cell["\<\
These are the functions dealing with the relations among vbundles and their \
subvbundles:\
\>", "Text",ExpressionUUID->"be27dfe3-a83a-41af-bff1-f4c06fd37945"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SplittingsOfVBundle"}]], \
"Input",ExpressionUUID->"3c3590d4-a7ac-47b5-aeb0-5c167f476810"],

Cell[BoxData[
 StyleBox["\<\"SplittingsOfVBundle[vb] returns a list of known direct sum \
splittings of the vbundle vb.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672556-5338953",ExpressionUUID->"c87a1f18-9c1e-43fd-bac5-\
0c7b52284b5a"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfVBundle", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplittingsOfVBundle", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SplittingsOfVBundle", "::", "unknown"}], ",", 
      "\"\<vbundle\>\"", ",", " ", "x"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SplittingsOfVBundle", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "SplittingsOfVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"79994eb5-3f5a-4584-8d23-d67a979bb58d"],

Cell["\<\
The function SubvbundleQ is now only used by IndexOnQ and Validate (to check \
the contents of the slots of a tensor).\
\>", "Text",ExpressionUUID->"838b644d-7a5f-43a3-bc05-d72696ec69fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SubvbundleQ"}]], \
"Input",ExpressionUUID->"1563d795-3df9-43e8-8840-9a98d365ce0c"],

Cell[BoxData[
 StyleBox["\<\"SubvbundleQ[large, small] gives True if vector bundle small is \
contained in or equal to vector bundle large, and False otherwise.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672558-5338953",ExpressionUUID->"8ca51ada-82f7-400c-af09-\
3c390356baed"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"vbundle_", ",", "vbundle_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"All", ",", "vbundle_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubvbundleQ", "[", 
    RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SubvbundleQ", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SubvbundleQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"14fb65cb-0e78-4686-8eed-4998cda2579d"],

Cell["\<\
The All definition is there because the tensors delta and Gdelta have \
SlotsOfTensor={All, ...}.\
\>", "Text",ExpressionUUID->"b4de583c-7b6f-48a4-a57a-7f32261fd6a3"],

Cell["\<\
Dummies on the subvbundles of a vbundle. Note that vb gives contravariant \
indices but -vb gives covariant indices.\
\>", "Text",ExpressionUUID->"9b0ee4bb-1c7f-4390-b649-5349ed93bd62"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SubdummiesIn"}]], \
"Input",ExpressionUUID->"0a5d7a59-648f-4169-a47a-29db8714f102"],

Cell[BoxData[
 StyleBox["\<\"SubdummiesIn[vbundle] gives a list of unique (dollar) indices \
on the respective subvbundles of vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672559-5338953",ExpressionUUID->"26afe419-45cb-4ef2-a7d2-\
517ef7f2c572"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SubdummiesIn", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"IndexList", ",", 
     RowBox[{"DummyIn", "/@", 
      RowBox[{"List", "@@", 
       RowBox[{"(", 
        RowBox[{"Last", "@", 
         RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}]}], ")"}]}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SubdummiesIn", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "SubdummiesIn", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f8dd2a9c-2e8e-4108-b994-a1d322a3e3ab"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DisjointVBundlesQ", "[", 
    RowBox[{"vbundles1_List", ",", "vbundle2_"}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"DisjointVBundlesQ", "[", 
        RowBox[{"#", ",", "vbundle2"}], "]"}], "&"}], "/@", "vbundles1"}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisjointVBundlesQ", "[", 
    RowBox[{"vbundle1_", ",", "vbundles2_List"}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"DisjointVBundlesQ", "[", 
        RowBox[{"vbundle1", ",", "#"}], "]"}], "&"}], "/@", "vbundles2"}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisjointVBundlesQ", "[", 
    RowBox[{"vbundle1_", ",", "vbundle2_"}], "]"}], ":=", 
   RowBox[{"Not", "[", 
    RowBox[{
     RowBox[{"SubvbundleQ", "[", 
      RowBox[{"vbundle1", ",", "vbundle2"}], "]"}], "||", 
     RowBox[{"SubvbundleQ", "[", 
      RowBox[{"vbundle2", ",", "vbundle1"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DisjointVBundlesQ", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DisjointVBundlesQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1937c439-bd5b-4319-a04d-28dc056f43fe"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.4. Generation of indices on a vector bundle", \
"Subsection",ExpressionUUID->"bccceaba-eaca-4abb-91e8-322649475c24"],

Cell["We need four different structures:", \
"Text",ExpressionUUID->"7c060603-4fe7-49e7-aac1-189efb3c3f10"],

Cell[CellGroupData[{

Cell["7.4.0. Comments", \
"Subsubsection",ExpressionUUID->"51f1425b-519b-4144-98f5-eacf0d4d2e09"],

Cell["\<\
The command DaggerIndex is able to create and store the complex conjugated \
index when needed. That simplifies the manipulation of indices in complex \
vbundles here.\
\>", "Text",ExpressionUUID->"5bda2218-22b3-4797-a46a-638909c5e05e"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.4.1. DummyIn, DummyAs", \
"Subsubsection",ExpressionUUID->"895c8b7a-9bf5-46b3-879c-b56b9adfcfb7"],

Cell["This function generates new dollar dummies:", \
"Text",ExpressionUUID->"8f5c3dcd-9246-4f51-84c2-e753a7c4c06f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DummyIn"}]], \
"Input",ExpressionUUID->"44f28e31-db42-42e8-b689-b6e0890ce9f6"],

Cell[BoxData[
 StyleBox["\<\"DummyIn[vbundle] gives a unique abstract dollar-index on the \
vector bundle vbundle, using the last of the user-defined indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672561-5338953",ExpressionUUID->"833291d0-b278-4614-9112-\
6230a56433a0"]
}, Open  ]],

Cell["\<\
We do not use DefAbstractIndex or RegisterIndexInVBundle because those do \
symbol validation and that takes much time. Here we just want to get a \
dollar-index.\
\>", "Text",ExpressionUUID->"d15c5811-5b67-4862-aa11-24bf06a50783"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DummyIn", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyIn", "[", "Labels", "]"}], ":=", 
   RowBox[{"LI", "[", "General", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyIn", "[", 
    RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}], "[", "#1", "]"}], "^=",
           "True"}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"NoDollar", "[", "#1", "]"}], "^=", "#2"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AbstractIndexQ", "[", "#1", "]"}], "^=", "True"}], ";", 
         "\[IndentingNewLine]", "#1"}], ")"}], "&"}], "@@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Unique", "[", "#", "]"}], ",", "#"}], "}"}]}], "&"}], "@", 
    RowBox[{"First", "[", 
     RowBox[{"LastIndex", "[", "vbundle", "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyIn", "[", 
    RowBox[{"vbundle_", ",", 
     RowBox[{"AIndex", "|", 
      RowBox[{"-", "AIndex"}]}]}], "]"}], ":=", 
   RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyIn", "[", 
    RowBox[{"vbundle_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummyIn", "[", "vbundle", "]"}], ",", "basis"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyIn", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DummyIn", "::", "unknown"}], ",", "\"\<vector bundle\>\"", ",",
       "vbundle"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DummyIn", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DummyIn", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"539a5fb0-2a4e-47b3-9e52-46853bd12212"],

Cell["\<\
We have introduced a second argument to specify the possibility of a basis. \
Note that the character of vbundle and basis must match.\
\>", "Text",ExpressionUUID->"e4c9d5e1-3e6b-430e-aa2d-b2ab4c1fb967"],

Cell["\<\
DummyAs[i] gives an **abstract** dummy index in the vector bundle of i, even \
if i is a basis index. We use upQ to allow this function acting on named \
patterns (unnamed patterns throw an error in VBundleOfIndex anyway):\
\>", "Text",ExpressionUUID->"13b198e6-0ec4-45f0-8f28-86c256d81933"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DummyAs"}]], \
"Input",ExpressionUUID->"af24b278-368d-4cc9-a178-f3250a301956"],

Cell[BoxData[
 StyleBox["\<\"DummyAs[ind] gives a dummy abstract index in the vector bundle \
of ind, having the same up/down character.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672562-5338953",ExpressionUUID->"b0321d31-0ea8-447c-8263-\
24c826839e8c"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{"i", ":", 
     RowBox[{"(", 
      RowBox[{"_LI", "|", 
       RowBox[{"-", "_LI"}]}], ")"}]}], "]"}], ":=", "i"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"upQ", "[", "i", "]"}], ",", "UpIndex", ",", "DownIndex"}], 
     "]"}], "[", 
    RowBox[{"DummyIn", "[", 
     RowBox[{"VBundleOfIndex", "[", "i", "]"}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bb9cc946-6743-40e9-90fe-87dbe6fa0219"],

Cell["Extension to bases:", \
"Text",ExpressionUUID->"1e20ff80-7f07-4da0-844a-fb87120e9be6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{"i_", ",", "AIndex"}], "]"}], ":=", 
   RowBox[{"DummyAs", "[", "i", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{
     RowBox[{"i", ":", 
      RowBox[{"_Symbol", "|", 
       RowBox[{"-", "_Symbol"}]}]}], ",", "Automatic"}], "]"}], ":=", 
   RowBox[{"DummyAs", "[", 
    RowBox[{"i", ",", "AIndex"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"29c19f9d-842a-42c5-9eb1-a4cf82c2787b"],

Cell["BASIS1 notation:", \
"Text",ExpressionUUID->"b79effa1-fc47-46fe-88d2-cde220f8a984"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{"i_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"f", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"upQ", "[", "i", "]"}], ",", "UpIndex", ",", "DownIndex"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"DummyIn", "[", 
         RowBox[{"VBundleOfIndex", "[", "i", "]"}], "]"}], "]"}], ",", 
       RowBox[{"f", "[", "basis", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{
     RowBox[{"i", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "basis_"}], "}"}]}], ",", "Automatic"}], "]"}], ":=", 
   RowBox[{"DummyAs", "[", 
    RowBox[{"i", ",", "basis"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ab821e1e-91e8-4a1b-b47a-68afe2299afa"],

Cell["BASIS2 notation (now deactivated):", \
"Text",ExpressionUUID->"58a7a0ab-8667-41b1-aa09-81cb2339e0f6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{"i_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"upQ", "[", "i", "]"}], ",", "UpIndex", ",", "DownIndex"}], 
     "]"}], "[", 
    RowBox[{"basis", "[", 
     RowBox[{"DummyIn", "[", 
      RowBox[{"VBundleOfIndex", "[", "i", "]"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"basis_", "?", "BasisQ"}], "[", "i_", "]"}], ",", "Automatic"}],
     "]"}], ":=", 
   RowBox[{"DummyAs", "[", 
    RowBox[{"i", ",", "basis"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DummyAs", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"basis_", "?", "BasisQ"}], "[", "i_", "]"}]}], ",", 
     "Automatic"}], "]"}], ":=", 
   RowBox[{"DummyAs", "[", 
    RowBox[{
     RowBox[{"-", "i"}], ",", "basis"}], "]"}]}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"f04f2bc7-5bd0-4701-8188-09558113a49c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DummyAs", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DummyAs", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"039c43df-4ac9-452f-a85e-33a332e80b33"],

Cell["\<\
There is an important problem concerning memory. Creating an index takes a \
few bytes, but for very long computations that could be important and fill up \
the memory. This has a very difficult solution because we cannot remove all \
symbols containing a dollar, of course. I have tried to use the Temporary \
attribute, but that only works inside a Module construct, and in general we \
need to move indices around arbitrarily. The problem is most important with \
ReplaceDummies, and there we can stop it using the global variable \
$ComputeNewDummies, but I need something more general. I define the function \
RemoveDollarIndices[number], which removes all dollar indices having that \
number at least.\
\>", "Text",ExpressionUUID->"256e36d0-dc0f-4217-99c8-ea4566581bc6"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"97f85435-6be7-45db-b19c-0a8c0709d40d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M3", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1e21db32-e4b1-4660-9d8f-d0e50060b768"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M3", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M3, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"24d1c4f3-576b-424f-80d5-73fbe106051f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM3", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM3, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ad1bc6d5-a78e-46df-9281-245c396e25c5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DummyIn", "[", "TangentM3", 
  "]"}]], "Input",ExpressionUUID->"40122b06-c574-4bc2-9bb9-d46eeecf8d39"],

Cell[BoxData["d$96658"], \
"Output",ExpressionUUID->"e3cd0587-5191-42a1-b618-936c3020eb19"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Information", "[", 
  RowBox[{"Evaluate", "[", "%", "]"}], 
  "]"}]], "Input",ExpressionUUID->"33bf5339-f671-4bb0-9c54-65ee0e409cae"],

Cell[CellGroupData[{

Cell["Global`d$96658", "Print", "PrintUsage",
 CellTags->
  "Info3578672564-5338953",ExpressionUUID->"af6ad237-d39d-4015-a7f4-\
db8889ff455d"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "d$96658", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "d$96658", "]"}], "^=",
          "d"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentM3`Q", "[", "d$96658", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`d$96658],
  Editable->False]], "Print",
 CellTags->
  "Info3578672564-5338953",ExpressionUUID->"502834a5-f428-45d9-bc5c-\
f535e2c446e6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DaggerIndex", "[", "%%", 
  "]"}]], "Input",ExpressionUUID->"2cc38443-881c-4300-8a9f-b645a4f44568"],

Cell[BoxData["d$96658"], \
"Output",ExpressionUUID->"91d1dbed-32c1-492b-9b39-a83c0372a640"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DummyAs", "/@", 
  RowBox[{"{", 
   RowBox[{"a", ",", 
    RowBox[{"-", "a"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"063b43fa-36ab-4170-b5b3-45c9963ac1d2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"d$96667", ",", 
   RowBox[{"-", "d$96668"}], ",", "d$96669", ",", 
   RowBox[{"-", "d$96670"}]}], 
  "}"}]], "Output",ExpressionUUID->"9ec69377-f977-4952-b74d-032f534c2aea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "d"}]], "Input",ExpressionUUID->"0e949be4-ba3c-4f29-aed9-ea10040535c0"],

Cell[CellGroupData[{

Cell["Global`d", "Print", "PrintUsage",
 CellTags->
  "Info3578672566-5338953",ExpressionUUID->"ff7de3d6-d5a3-4904-a65a-\
d120e2b71513"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "d", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "d", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DaggerIndex", "[", "d", "]"}], "^=", "d"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "d", "]"}], "^=", 
         "d"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "d", "]"}], "^=", "\<\"d\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentM3`Q", "[", "d", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "d", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM3,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`d],
  Editable->False]], "Print",
 CellTags->
  "Info3578672566-5338953",ExpressionUUID->"1c3af12a-1738-48ab-9cf4-\
e9ef5f9f2ed1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "d$*"}]], "Input",ExpressionUUID->"cec2aff1-a6e1-448d-ad4c-9525c10ffd78"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["Global`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["Global`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["d$96658",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672567-5338953", {"d$96658", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d$96667",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672567-5338953", {"d$96667", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d$96668",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672567-5338953", {"d$96668", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d$96669",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672567-5338953", {"d$96669", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d$96670",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672567-5338953", {"d$96670", "Global`"}},
          ButtonNote->"Global`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.19]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->
    Automatic]]], "Print", \
"InfoCell",ExpressionUUID->"09c8ed8b-a382-4c25-85f2-28234976a3fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M3", 
  "]"}]], "Input",ExpressionUUID->"87ceb111-138e-46df-bc56-b57e11ff7632"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M3",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM3,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM3],
  Editable->
   False]], "Print",ExpressionUUID->"2804f27b-973c-4fe2-b2bf-4075a87d4e70"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M3"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M3],
  Editable->
   False]], "Print",ExpressionUUID->"cfbd3a23-c47b-426b-9579-b8bb9b6e0e15"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "d$*"}]], "Input",ExpressionUUID->"9ccaa553-eb7e-4f8e-8258-34840396c96b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \[NoBreak]\\!\\(\\\"d$*\\\"\\)\[NoBreak] \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"30d5edce-9e21-48fc-8ed4-612aaf231744"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "polar", 
  "]"}]], "Input",ExpressionUUID->"6740583a-95a9-44a3-8d32-7477a3632664"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"bedfa509-778d-44d3-82c0-83d85edd368b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"$DumpSupported\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"$DumpSupported"}],
  Editable->
   False]], "Print",ExpressionUUID->"649581cd-fb33-47a4-a377-5efa3eeb7b00"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["7.4.2. AddIndices, RemoveIndices (in the first list)", \
"Subsubsection",ExpressionUUID->"48bee112-3885-4e07-8f75-0af7a3d507b2"],

Cell["\<\
1) Register the new indices in the first list of IndicesOfVBundle:\
\>", "Text",ExpressionUUID->"04c646b6-7ef2-414f-906b-ce92b7d51e13"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AddIndicesInFirstList", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{
       RowBox[{"vb_Symbol", "?", "VBundleQ"}], ",", "phi_"}], "]"}], ",", 
     "indices_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", 
        RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xTagSet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vb", ",", 
          RowBox[{"IndicesOfVBundle", "[", 
           RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"First", "@", "inds"}], ",", "indices"}], "]"}], ",", 
          RowBox[{"Last", "@", "inds"}]}], "}"}]}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AddIndicesInFirstList", "[", 
    RowBox[{
     RowBox[{"vbundle_Symbol", "?", "VBundleQ"}], ",", "indices_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"First", "@", "inds"}], ",", "indices"}], "]"}], ",", 
          RowBox[{"Last", "@", "inds"}]}], "}"}]}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b4866da7-2c54-4018-9104-471faf5cea8c"],

Cell["\<\
With this function we can add more user-chosen indices to a given vbundle.\
\>", "Text",ExpressionUUID->"b3388421-90c9-4079-a9ab-41c6db4a3294"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "AddIndices"}]], \
"Input",ExpressionUUID->"d51d65fe-b7fd-4c4a-b86e-f6c931ad84ff"],

Cell[BoxData[
 StyleBox["\<\"AddIndices[vbundle, indlist] adds the abstract indices in \
indlist to the user-defined part of the indices associated to the the vector \
bundle vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672569-5338953",ExpressionUUID->"c7d0b44c-ee55-4aff-bd7b-\
8f8ebcc668ac"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AddIndices", "[", 
    RowBox[{
     RowBox[{"-", "vbundle_"}], ",", "indices_List"}], "]"}], ":=", 
   RowBox[{"AddIndices", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"UpIndex", "/@", "indices"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AddIndices", "[", 
    RowBox[{
     RowBox[{"vbundle_", "?", "VBundleQ"}], ",", "indices_List"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"RegisterIndexInVBundle", "[", 
        RowBox[{"#", ",", "vbundle"}], "]"}], "&"}], "/@", "indices"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"AddIndicesInFirstList", "[", 
      RowBox[{"vbundle", ",", "indices"}], "]"}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"SetLastIndex", "[", 
      RowBox[{"vbundle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Last", "@", "indices"}], ",", 
         RowBox[{"Last", "@", 
          RowBox[{"LastIndex", "[", "vbundle", "]"}]}]}], "}"}]}], "]"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"DaggerQ", "[", "vbundle", "]"}], "&&", 
        RowBox[{"!", 
         RowBox[{"HasDaggerCharacterQ", "[", "vbundle", "]"}]}]}], ",", 
       RowBox[{"AddIndices", "[", 
        RowBox[{
         RowBox[{"Dagger", "[", "vbundle", "]"}], ",", 
         RowBox[{"MakeDaggerSymbol", "/@", "indices"}]}], "]"}]}], "]"}], 
     ";"}], "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AddIndices", "[", 
    RowBox[{"vbundle_", ",", "_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"AddIndices", "::", "unknown"}], ",", "\"\<vector bundle\>\"", 
      ",", "vbundle"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"AddIndices", ",", "2"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "AddIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e441b5d3-1af1-4c6e-9044-e376c54ddf20"],

Cell["2) Remove indices from the first list of IndicesOfVBundle:", \
"Text",ExpressionUUID->"8bacdee2-6f18-4b80-822b-ae76ee74238a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RemoveIndicesInFirstList", "[", 
    RowBox[{
     RowBox[{"PullBackVBundle", "[", 
      RowBox[{
       RowBox[{"vb_Symbol", "?", "VBundleQ"}], ",", "phi_"}], "]"}], ",", 
     "indices_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", 
        RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xTagSet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vb", ",", 
          RowBox[{"IndicesOfVBundle", "[", 
           RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"First", "@", "inds"}], ",", 
            RowBox[{"Alternatives", "@@", "indices"}]}], "]"}], ",", 
          RowBox[{"Last", "@", "inds"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RemoveSymbol", "/@", 
       RowBox[{"Intersection", "[", 
        RowBox[{"indices", ",", 
         RowBox[{"First", "@", "inds"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RemoveIndicesInFirstList", "[", 
    RowBox[{
     RowBox[{"vbundle_Symbol", "?", "VBundleQ"}], ",", "indices_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"First", "@", "inds"}], ",", 
            RowBox[{"Alternatives", "@@", "indices"}]}], "]"}], ",", 
          RowBox[{"Last", "@", "inds"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RemoveSymbol", "/@", 
       RowBox[{"Intersection", "[", 
        RowBox[{"indices", ",", 
         RowBox[{"First", "@", "inds"}]}], "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"84b8d72b-6af7-4bb1-ab0c-62afe34efedf"],

Cell["\<\
This function removes user-chosen indices. This is a dangerous operation. It \
should be generalized to remove indices from the second list.\
\>", "Text",ExpressionUUID->"e60f6a9e-247d-45ae-aa7d-6eee31191782"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RemoveIndices"}]], \
"Input",ExpressionUUID->"db04a992-8790-4d89-95f6-a30ae6a5bfc2"],

Cell[BoxData[
 StyleBox["\<\"RemoveIndices[vbundle, indlist] removes the abstract indices \
in indlist from the user-defined part of the indices associated to the vector \
bundle vbundle.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672570-5338953",ExpressionUUID->"1f880bbf-6e8f-4834-8188-\
63ec79bfd195"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RemoveIndices", "[", 
    RowBox[{"vbundle_", ",", "All"}], "]"}], ":=", 
   RowBox[{"RemoveIndices", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"First", "@", 
      RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RemoveIndices", "[", 
    RowBox[{
     RowBox[{"-", "vbundle_"}], ",", "indices_"}], "]"}], ":=", 
   RowBox[{"RemoveIndices", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"UpIndex", "/@", "indices"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RemoveIndices", "[", 
    RowBox[{
     RowBox[{"vbundle_", "?", "VBundleQ"}], ",", "indices_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "vbinds", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"DaggerQ", "[", "vbundle", "]"}], "&&", 
         RowBox[{"!", 
          RowBox[{"HasDaggerCharacterQ", "[", "vbundle", "]"}]}]}], ",", 
        RowBox[{"RemoveIndices", "[", 
         RowBox[{
          RowBox[{"Dagger", "[", "vbundle", "]"}], ",", 
          RowBox[{"DaggerIndex", "/@", "indices"}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RemoveIndicesInFirstList", "[", 
       RowBox[{"vbundle", ",", "indices"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"vbinds", "=", 
       RowBox[{"IndicesOfVBundle", "@", "vbundle"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"vbinds", "===", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"SetLastIndex", "[", "vbundle", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetLastIndex", "[", 
          RowBox[{"vbundle", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Last", "@", 
              RowBox[{"First", "@", "vbinds"}]}], ",", 
             RowBox[{"Last", "@", 
              RowBox[{"LastIndex", "[", "vbundle", "]"}]}]}], "}"}]}], "]"}], 
         ";"}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RemoveIndices", "[", 
    RowBox[{"vbundle_", ",", "_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"RemoveIndices", "::", "unknown"}], ",", 
      "\"\<vector bundle\>\"", ",", "vbundle"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"RemoveIndices", ",", "2"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "RemoveIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5ab23039-79f7-48cb-9115-fea0e29300a0"],

Cell["3) Examples:", \
"Text",ExpressionUUID->"da5c11f7-cd4d-4e70-b5f7-92fab9228a1e"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c7d94c2f-1509-4cb6-9a2a-bf9c3e41edb1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4c965f7d-b128-4f1c-b176-52915f4ab87a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"aedb1cdf-df8f-4cdd-a252-3a27308ff5a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6903ecb6-499f-49bc-a97e-361494e093ac"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"AddIndices", "[", 
  RowBox[{"TangentS2", ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "e"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"627ce361-f199-4537-9214-21f35c986540"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", "TangentS2", 
  "]"}]], "Input",ExpressionUUID->"1add6255-8913-48f8-9bed-d6770c371e91"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"a9b9dfa4-11fa-494c-be9a-c6db6b56d982"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"RemoveIndices", "[", 
  RowBox[{"TangentS2", ",", 
   RowBox[{"{", "d", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1b249362-1ede-4e1e-ace4-932fe80f84a2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "d"}]], "Input",ExpressionUUID->"43c4b5ba-9d91-44dc-b4d9-e998a695369b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"d\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"530e06bd-f018-4b4e-b2ca-3c3f509f1248"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"cb769fc8-a30c-4df0-8f09-65b90308dfba"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"9c4098c9-5fc9-44f7-b204-7ebecfb50f2b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"b11f974a-f159-45cf-8ac4-b6ae7e2523d5"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"ce449517-1b84-4e6f-b5ff-9f7e1dd1ddba"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.4.3. NewIndexIn (in the second list)", \
"Subsubsection",ExpressionUUID->"07b7a1cf-e808-47da-91a7-e69a680f4964"],

Cell["Add a new index in the second list:", \
"Text",ExpressionUUID->"03c419b2-7504-46ff-934b-405c6eb79f4a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AddIndexInSecondList", "[", 
    RowBox[{
     RowBox[{"vbundle", ":", 
      RowBox[{"PullBackVBundle", "[", 
       RowBox[{
        RowBox[{"vb_Symbol", "?", "VBundleQ"}], ",", "phi_"}], "]"}]}], ",", 
     "ind_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", 
        RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xTagSet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vb", ",", 
          RowBox[{"IndicesOfVBundle", "[", 
           RowBox[{"vb", ",", "phi"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"First", "@", "inds"}], ",", 
          RowBox[{"Append", "[", 
           RowBox[{
            RowBox[{"Last", "@", "inds"}], ",", "ind"}], "]"}]}], "}"}]}], 
       "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AddIndexInSecondList", "[", 
    RowBox[{
     RowBox[{"vbundle_Symbol", "?", "VBundleQ"}], ",", "ind_"}], "]"}], ":=", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"IndicesOfVBundle", "[", "vbundle", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"First", "@", "inds"}], ",", 
          RowBox[{"Append", "[", 
           RowBox[{
            RowBox[{"Last", "@", "inds"}], ",", "ind"}], "]"}]}], "}"}]}], 
       "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"feabcea9-79e9-4999-bffe-9da3b3f002b3"],

Cell["\<\
The function NewIndexIn gives a new (computer-generated) index to be appended \
to the second list of indices of the vbundle. There is no good reason why \
this function is public, because it is used nowhere except for \
GetIndicesOfVBundle, which is the recommended user driver for index \
generation.\
\>", "Text",ExpressionUUID->"fb59e1da-4edc-4226-9a77-2efbbe61a7e8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "NewIndexIn"}]], \
"Input",ExpressionUUID->"2ed57df8-8220-4f6a-af08-fc8f40c632ca"],

Cell[BoxData[
 StyleBox["\<\"NewIndexIn[vbundle] gives and registers a new computer-defined \
abstract index associated to the vector bundle vbundle. The index is \
constructed using the last index of the user-defined part and a sequential \
number starting at 1. This is an internal function, and users are expected to \
use GetIndicesOfVBundle instead.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672572-5338953",ExpressionUUID->"518c308b-98f0-4734-9462-\
a764143462af"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NewIndexIn", "[", 
    RowBox[{"-", "vbundle_"}], "]"}], ":=", 
   RowBox[{"NewIndexIn", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NewIndexIn", "[", 
    RowBox[{"vbundle_", "?", "HasDaggerCharacterQ"}], "]"}], ":=", 
   RowBox[{"NewIndexIn", "[", 
    RowBox[{"Dagger", "[", "vbundle", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NewIndexIn", "[", 
    RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "ind", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Decide", " ", "what", " ", "the", " ", "next", " ", "index", " ", 
       "will", " ", "be"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Label", "[", "trynext", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"ind", "=", 
       RowBox[{"SymbolJoin", "@@", 
        RowBox[{"Prepend", "[", 
         RowBox[{
          RowBox[{"LastIndex", "[", "vbundle", "]"}], ",", 
          RowBox[{"Context", "@@", 
           RowBox[{"{", 
            RowBox[{"First", "@", 
             RowBox[{"LastIndex", "[", "vbundle", "]"}]}], "}"}]}]}], 
         "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Check", "[", 
       RowBox[{
        RowBox[{"Catch", "@", 
         RowBox[{"ValidateIndex", "[", "ind", "]"}]}], ",", 
        RowBox[{
         RowBox[{"SetLastIndex", "[", 
          RowBox[{"vbundle", ",", "1"}], "]"}], ";", 
         RowBox[{"Goto", "[", "trynext", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Register", " ", "new", " ", "index"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"RegisterIndexInVBundle", "[", 
       RowBox[{"ind", ",", "vbundle"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"AddIndexInSecondList", "[", 
       RowBox[{"vbundle", ",", "ind"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"SetLastIndex", "[", 
       RowBox[{"vbundle", ",", "1"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Synchronize", " ", "conjugate", " ", "vbundle"}], " ", "*)"}],
       "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"DaggerQ", "[", "vbundle", "]"}], "&&", 
         RowBox[{"!", 
          RowBox[{"HasDaggerCharacterQ", "[", "vbundle", "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"vbdagger", "=", 
             RowBox[{"Dagger", "[", "vbundle", "]"}]}], ",", 
            RowBox[{"inddagger", "=", 
             RowBox[{"MakeDaggerSymbol", "[", "ind", "]"}]}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"RegisterIndexInVBundle", "[", 
            RowBox[{"inddagger", ",", "vbdagger"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AddIndexInSecondList", "[", 
            RowBox[{"vbdagger", ",", "inddagger"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"SetLastIndex", "[", 
            RowBox[{"vbdagger", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"LastIndex", "[", "vbdagger", "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"LastIndex", "[", "vbundle", "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Return", " ", "new", " ", "index"}], " ", "*)"}], 
      "\[IndentingNewLine]", "ind"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NewIndexIn", "[", "vbundle_", "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"NewIndexIn", "::", "unknown"}], ",", "\"\<vector bundle\>\"", 
     ",", "vbundle"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"NewIndexIn", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "NewIndexIn", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bd88da12-06d8-42c0-9099-aa4b73ad85bf"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"15386292-4f9a-4aa2-9a0f-c91a4dc963c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"44cd5f7b-effb-4ca7-b2c5-3637e97a7787"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2ee568ad-794b-4057-9091-a500003cc00c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cd8355c5-99d6-4762-8cd1-7d148bd5fb8c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NewIndexIn", "[", "TangentS2", 
  "]"}]], "Input",ExpressionUUID->"a82e3d09-8c91-4a38-97ee-c85e10467b34"],

Cell[BoxData["e1"], \
"Output",ExpressionUUID->"4d286c11-55d8-4a78-825c-2fc7f4108e8c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2"}]], \
"Input",ExpressionUUID->"055eef3e-6d78-401a-b324-6dfff16c5d4c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]S2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentS2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672574-5338953",ExpressionUUID->"f80f6a35-0aa2-441d-811d-\
c5fffe02f739"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentS2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentS2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
           RowBox[{"{", "e1", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"e", ",", "2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentS2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672574-5338953",ExpressionUUID->"da6eba97-8c82-45f0-8073-\
c90b7c5c177e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "e1"}]], "Input",ExpressionUUID->"c61438f6-43a2-479a-83e3-2ec140bff202"],

Cell[CellGroupData[{

Cell["Global`e1", "Print", "PrintUsage",
 CellTags->
  "Info3578672576-5338953",ExpressionUUID->"f31a44e4-77a4-4a7e-8641-\
26b15dc887cd"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "e1", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "e1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "e1", "]"}], "^=", 
         "e1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "e1", "]"}], "^=", "\<\"e1\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentS2`Q", "[", "e1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "e1", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`e1],
  Editable->False]], "Print",
 CellTags->
  "Info3578672576-5338953",ExpressionUUID->"7b2863c2-1aed-41c7-aab3-\
d0c02263e6ed"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"a3fb3896-ed92-4c94-ae5c-7d43ec8501fb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"8277a4c4-f83f-4a16-9b8b-fc0d06288ca7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"7e898d7f-256a-40c7-84ad-93ef1fa9d41b"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9470bc82-a421-4b7d-a5be-0d4d60503a4d"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.4.4. GetIndicesOfVBundle", \
"Subsubsection",ExpressionUUID->"95897aba-bcbd-4245-b6a8-352897d58459"],

Cell["\<\
GetIndicesOfManifold gives n indices of a vbundle, checking that they do not \
belong to a given list. This is just a \[OpenCurlyDoubleQuote]multiplicity \
driver\[CloseCurlyDoubleQuote] for NewIndexIn.\
\>", "Text",ExpressionUUID->"269ef353-b008-48a2-a9c3-34a205d17c4c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "GetIndicesOfVBundle"}]], \
"Input",ExpressionUUID->"e41a4356-160d-4e75-8beb-d5de12c29cc3"],

Cell[BoxData[
 StyleBox["\<\"GetIndicesOfVBundle[vbundle, n, list] gives a list of n \
abstract indices on the vector bundle vbundle, checking that they are not in \
list. If there are not enough indices in IndicesOfVBundle[vbundle] then new \
indices are generated using NewIndexIn.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672577-5338953",ExpressionUUID->"9e8a87dc-ed7e-4925-b076-\
cf1db0141962"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"vbundle_", ",", "number_"}], "]"}], ":=", 
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"vbundle", ",", "number", ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"vbundle_", ",", "number_", ",", "list_IndexList"}], "]"}], ":=", 
   
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"vbundle", ",", "number", ",", 
     RowBox[{"List", "@@", "list"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{
     RowBox[{"-", "vbundle_"}], ",", "number_", ",", "list_List"}], "]"}], ":=", 
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"vbundle", ",", "number", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{
     RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
     RowBox[{"number_Integer", "?", "NonNegative"}], ",", "list_List"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ind", ",", "output"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"output", "=", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Flatten", "@", 
          RowBox[{"IndicesOfVBundle", "@", "vbundle"}]}], ",", "list"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "output", "]"}], "<", "number"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ind", "=", 
          RowBox[{"NewIndexIn", "[", "vbundle", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"list", ",", "ind"}], "]"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"output", ",", "ind"}], "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"output", "[", 
       RowBox[{"[", 
        RowBox[{"Range", "[", "number", "]"}], "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"_", ",", "_", ",", 
     RowBox[{"list_", "/;", 
      RowBox[{
       RowBox[{"Head", "[", "list", "]"}], "=!=", "List"}]}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"GetIndicesOfVBundle", "::", "invalid"}], ",", "list", ",", 
      "\"\<list of indices\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{
     RowBox[{"_Symbol", "?", "VBundleQ"}], ",", "number_", ",", "_List"}], 
    "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"GetIndicesOfVBundle", "::", "invalid"}], ",", "number", ",", 
      "\"\<nonnegative integer\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetIndicesOfVBundle", "[", 
    RowBox[{"vbundle_", ",", "_", ",", "_List"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"GetIndicesOfVBundle", "::", "invalid"}], ",", "vbundle", ",", 
      "\"\<vector bundle\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"GetIndicesOfVBundle", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "GetIndicesOfVBundle", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"acabec89-947e-42c1-87ea-da0700d6d550"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"883cf33d-fd96-44f3-8ea7-19e3dcc1b843"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"5f3421e2-2eb1-4e0b-a957-85d8ba2f905e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b2810d2-ce7f-4add-b5af-c7dd20d33fe3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dde42f1b-2e0a-4393-9442-88842aa5bc9e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"TangentS2", ",", "6", ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "e1", ",", "e3"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"15f58d02-c20c-4a21-840e-9e61909a9e5f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "e2", ",", "e4"}], 
  "}"}]], "Output",ExpressionUUID->"8716b868-f255-4a14-b68e-edb7d7396fac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2"}]], \
"Input",ExpressionUUID->"a234db36-3dbe-480d-810d-cee8fbc1b42d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]S2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentS2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672579-5338953",ExpressionUUID->"8a2cf391-f3da-4610-be4b-\
f8b84dd38535"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentS2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentS2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"e1", ",", "e2", ",", "e3", ",", "e4"}], "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"e", ",", "5"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentS2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672579-5338953",ExpressionUUID->"0483b2d0-9278-4d93-8b52-\
ebe7e82bbcd7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"GetIndicesOfVBundle", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{"GetIndicesOfVBundle", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], 
  "]"}]}], "Input",ExpressionUUID->"8a4033fd-6f0f-44c5-8aab-e1015cd46d26"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"GetIndicesOfVBundle", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(GetIndicesOfVBundle\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(2\\)\[NoBreak] or \
\[NoBreak]\\!\\(3\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`GetIndicesOfVBundle::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"a464935e-fe44-477d-a6fd-c6afb7d1d125"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"GetIndicesOfVBundle", "::", "argr"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(GetIndicesOfVBundle\\)\[NoBreak] called with 1 \
argument; \[NoBreak]\\!\\({2, 3}\\)\[NoBreak] arguments are \
expected.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d9185152-33d7-45de-8b68-5ec892aac646"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"GetIndicesOfVBundle", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(GetIndicesOfVBundle\\)\[NoBreak] called with \
\[NoBreak]\\!\\(4\\)\[NoBreak] arguments; \[NoBreak]\\!\\(2\\)\[NoBreak] or \
\[NoBreak]\\!\\(3\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`GetIndicesOfVBundle::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"89628b9e-e7ea-48d8-9f76-ab495dec963b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"c5181ade-814c-4c3d-b827-cf36b0c21bc0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"4a0cd601-c9e5-4171-b120-73e383465efc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"70e30882-37f5-4c47-8835-3786ed45bb53"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "S2"}]], "Input",ExpressionUUID->"e044aae4-caa7-4cf5-96d6-079d03f2513a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"S2\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"26d3df5e-9e99-47cf-bd70-ea2f91e92234"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"67a4f5c9-328c-4a73-b95b-e9af10236ec6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["7.5. Examples", \
"Subsection",ExpressionUUID->"712338d0-63f6-4a8b-a0be-521f177d7bf8"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b716d1d3-fae1-499c-b45e-9c66371006b8"],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"66fedba5-7516-45f8-878d-58c500c96a95"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"dff03317-f5ca-4d97-a6d6-586604879d90"]
}, Open  ]],

Cell["Checks of possible errors:", \
"Text",ExpressionUUID->"615b794c-ba13-42e3-b9c5-8dd9edddaf15"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  "]"}]], "Input",ExpressionUUID->"3baa0979-d11b-4b71-9be0-515562a43b1a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefManifold", "::", "argm"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(DefManifold\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(2\\)\[NoBreak] or \
more arguments are expected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/argm\\\", ButtonNote -> \
\\\"xAct`xTensor`DefManifold::argm\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b9ed1f52-8d80-4357-a3af-7b7be206e34e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", "1", 
  "]"}]], "Input",ExpressionUUID->"3cf86f9f-f2a1-4bcb-bc90-2fd2ef38666d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefManifold", "::", "argr"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(DefManifold\\)\[NoBreak] called with 1 argument; \
\[NoBreak]\\!\\({2, \[Infinity]}\\)\[NoBreak] arguments are \
expected.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ae26c7e2-be4a-4d0e-a08e-1edf7db78c6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{"MM", ",", "2", ",", 
    RowBox[{"{", "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"e996b803-1296-41a0-8f43-3184f3997766"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefManifold", "::", "empty"}], "MessageName"], ":", 
  " ", "\<\"Argument number \[NoBreak]\\!\\(3\\)\[NoBreak] cannot be an empty \
list of \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1ad09cb2-eee3-4e9e-a7e7-1874e0057b4f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{
    RowBox[{"a", "+", "b"}], ",", "3", ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"60c9baa1-bb9f-424e-954f-5204355964b3"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"a + b\\\"\\)\[NoBreak] is invalid \
because it \[NoBreak]\\!\\(\\\"is not atomic\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"812e5e34-1267-4bcf-a77c-5a0fcbca2b0f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{"MM", ",", 
    RowBox[{"{", 
     RowBox[{"a", "+", "b"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"60ce332e-997b-4d6a-a5dd-6918eb7710eb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DimOfManifold", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"manifold\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\\\"a + b\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"71e0a8d7-0a73-4efa-9014-b13101d4cb66"]
}, Open  ]],

Cell["QUESTION: Why are these not errors anymore?", \
"Text",ExpressionUUID->"3161d7d2-7dc4-4c53-a606-3c2431ec1374"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"1", ",", "2"}], 
  "]"}]], "Input",ExpressionUUID->"50807592-4053-467c-9d8b-7c5d58ee6838"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"1", ",", "2"}], 
  "]"}]], "Output",ExpressionUUID->"72b5ded0-ff0c-4073-a78f-121c6557d690"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "}"}], ",", "3"}], 
   "]"}]}]], "Input",ExpressionUUID->"8f14cc39-be96-4f95-91ba-0f66d6414ce6"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"1", ",", 
   RowBox[{"{", "}"}], ",", "3"}], 
  "]"}]], "Output",ExpressionUUID->"bb441b12-296d-4a7b-be0f-8ba3937ef850"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{"MM", ",", "1", ",", "A"}], 
   "]"}]}]], "Input",ExpressionUUID->"b4138132-02be-4bcf-ae4f-094e49d3f5b0"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"MM", ",", "1", ",", "A"}], 
  "]"}]], "Output",ExpressionUUID->"f334eb0b-4595-40ad-bf85-5ccf67e47fba"]
}, Open  ]],

Cell["Valid cases, the first with capital-letter indices:", \
"Text",ExpressionUUID->"46404d62-b810-487c-a687-c601665b736d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{
    "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J",
      ",", "K", ",", "L", ",", "M"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"22ffd42b-a936-45f0-8796-806d57d36fd2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"343446b9-e10f-45b5-8d5d-e957bc7baa6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0582ee48-b61b-41ef-b134-b5b90e331bc0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"f784e4bc-1ef2-407b-8ad4-7077196eaf61"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"059f075b-b452-4d65-89c5-0f4ff120e6e7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"K\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"dc553442-ada1-497a-bb4a-a0707af6f502"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ValidateSymbol \
:: capital\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during \
this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"142f6538-7259-492b-9465-3c4d67e7b8ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$ContextPath"], \
"Input",ExpressionUUID->"60200e8e-817c-4c82-8952-0c4cffb7e00a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`\"\>", ",", "\<\"xAct`xCore`\"\>", 
   ",", "\<\"xAct`xPerm`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"c141ef51-aaaf-4e0b-8252-37ee84991e61"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"2dae616c-3952-40eb-8ee2-807de3a61ee4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"5375dac1-6ee9-4e93-b1ce-fff5d8bcd742"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"4c02b4dd-e56a-4e86-befd-9c735dee6991"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"f", ",", "x"}], 
  "]"}]], "Input",ExpressionUUID->"2d8ecc15-7476-4620-88a0-c661275df491"],

Cell["Reconstruct M2 again:", \
"Text",ExpressionUUID->"9759680e-0569-4314-abc3-3669f16ba990"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{
    "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J",
      ",", "K", ",", "L", ",", "M"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d22448b3-43b3-4a71-a293-52ecde6eeeec"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6101837c-c21c-4269-adc4-7dbc97672e68"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"51c0e3ea-daa5-43b7-884e-d5061b157b6b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9003c92c-1e1e-4d20-ab08-2cdd7a10e407"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"56469f7b-7c97-4655-8315-cee4eef1196d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"K\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"43aa779e-0598-4e05-bea6-c43976a21fbd"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ValidateSymbol \
:: capital\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during \
this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1bec3a2b-32c1-427d-96bf-00e0bc606a2f"]
}, Open  ]],

Cell["All information about M2:", \
"Text",ExpressionUUID->"3ab97822-962e-4be9-88c4-7c34c17bbe07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "M2"}]], "Input",ExpressionUUID->"11f4b6fb-e7ec-41f6-835e-d6b6314f1b24"],

Cell[CellGroupData[{

Cell["Global`M2", "Print", "PrintUsage",
 CellTags->
  "Info3578672586-5338953",ExpressionUUID->"6cd10720-05cc-433f-b1c4-\
a846c225a969"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "M2", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "M2", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "M2", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "M2", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "M2", "]"}], "^=", "\<\"M2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "M2", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "M2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`M2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672586-5338953",ExpressionUUID->"7c9a39c3-adb4-4033-8da6-\
6e330155edd8"]
}, Open  ]]
}, Open  ]],

Cell["and its tangent manifold:", \
"Text",ExpressionUUID->"812027dc-95a1-4fb8-bc05-f57b44706a4c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentM2"}]], \
"Input",ExpressionUUID->"95196957-96e4-4843-974e-2ecd8151722d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]M2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentM2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672587-5338953",ExpressionUUID->"19b69098-d6b9-41d2-bb12-\
42d086995375"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentM2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", 
             ",", "J", ",", "K", ",", "L", ",", "M"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]M2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentM2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672587-5338953",ExpressionUUID->"22bb93a3-49b5-484e-8d8b-\
2120258d2efc"]
}, Open  ]]
}, Open  ]],

Cell["The indices are now stored in $AbstractIndices:", \
"Text",ExpressionUUID->"b6895394-3fea-4d88-96c9-32cb34f98853"],

Cell[CellGroupData[{

Cell[BoxData["$AbstractIndices"], \
"Input",ExpressionUUID->"96a492fe-2799-49b3-b8aa-04b630811732"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J", 
   ",", "K", ",", "L", ",", "M"}], 
  "}"}]], "Output",ExpressionUUID->"ee506a30-83f2-45be-ac72-557eb7daac5c"]
}, Open  ]],

Cell["We generate a new index M1:", \
"Text",ExpressionUUID->"a5ff2359-c0b4-4012-9b3f-2c9d5d50e4b8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LastIndex", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"1cfb907c-6d39-489f-8447-bc42752b4632"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M", ",", "1"}], 
  "}"}]], "Output",ExpressionUUID->"14cfa0cf-5118-4b6d-90f1-b73a153ecfa3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NewIndexIn", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"dcbef4a2-8cba-40e6-83b7-ebc5c403a982"],

Cell[BoxData["M1"], \
"Output",ExpressionUUID->"c5d11ba7-b6fa-4374-9b8d-b62dca269651"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LastIndex", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"c7e14f1a-6847-4ad5-9b99-c23a48af1008"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M", ",", "2"}], 
  "}"}]], "Output",ExpressionUUID->"90de82ae-efea-422c-92ac-a2ac718ea106"]
}, Open  ]],

Cell["\<\
Now we cannot generate index M2 because M2 is a manifold. We get M3:\
\>", "Text",ExpressionUUID->"ae343bd5-9749-466f-a934-d0795eb79332"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NewIndexIn", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"52bb38c0-d459-4397-8253-2b74dfa5d0dc"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "protected"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"M2\\\"\\)\[NoBreak] is \
\[NoBreak]\\!\\(\\\"Protected\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8f08a75b-5331-455a-86e9-0cf14f397f30"],

Cell[BoxData["M3"], \
"Output",ExpressionUUID->"2bc3521f-8b90-4eb5-9c7b-82e04a20e150"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LastIndex", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"5b7b69ee-19a8-4717-b57c-3a4baa1dc85c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M", ",", "4"}], 
  "}"}]], "Output",ExpressionUUID->"3286e1dc-d670-4799-bc9f-02544b2123c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentM2"}]], \
"Input",ExpressionUUID->"7f87d48e-eb31-4c73-90f4-b12e398d7a11"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]M2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentM2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672589-5338953",ExpressionUUID->"914302e2-63ee-4c85-82e1-\
f2fd21584e64"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentM2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", 
             ",", "J", ",", "K", ",", "L", ",", "M"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"M1", ",", "M3"}], "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M", ",", "4"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]M2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentM2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672589-5338953",ExpressionUUID->"6a1cdd54-ed2f-4962-864d-\
86988dad5967"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"TangentM2`Q", "[", "M3", "]"}], 
  "]"}]], "Input",ExpressionUUID->"959b03fb-7c1a-4a0d-a7c8-2bee7e8196a7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"TangentM2`Q", "[", "M3", "]"}],
    HoldForm], ",", 
   TagBox["True",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"3bcecb58-acd9-4327-9851-4032e6236a7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"TangentM2`Q", "[", 
   RowBox[{"-", "M3"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5e128a82-3838-469a-a442-0f52a157ca17"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"TangentM2`Q", "[", 
     RowBox[{"-", "M3"}], "]"}],
    HoldForm], ",", 
   TagBox["False",
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"840dafb9-230d-411b-8fa2-31ca60f0164a"]
}, Open  ]],

Cell["The M`Q functions do not recognize basis indices:", \
"Text",ExpressionUUID->"1ec2e59f-2ea5-46e7-9e50-52d7c765ff6f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentM2`Q", "[", 
  RowBox[{"{", "M3", "}"}], 
  "]"}]], "Input",ExpressionUUID->"c2f6348f-bef6-49b1-86a3-d679c21f6d49"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"0b38e518-27ba-44ed-8e43-3f610365e1fd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"TangentM2", ",", "17"}], 
  "]"}]], "Input",ExpressionUUID->"e64b2684-61fa-4ff0-8e96-b126dd99178b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J", 
   ",", "K", ",", "L", ",", "M", ",", "M1", ",", "M3", ",", "M4", ",", "M5", 
   ",", "M6", ",", "M7"}], 
  "}"}]], "Output",ExpressionUUID->"f044310a-085b-4320-a212-6c15fde53c31"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"d1f9857e-dd30-4b7c-a602-d6521f8cc9f1"],

Cell[BoxData["17"], \
"Output",ExpressionUUID->"95646ef9-d4f4-4c23-9884-1eff9d2cdc4f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentM2"}]], \
"Input",ExpressionUUID->"26c89cfd-5e41-4ff2-817f-6bda9ac4d62a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]M2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentM2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672591-5338953",ExpressionUUID->"d48e58fc-96fe-4711-83d0-\
eac3a7678130"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentM2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", 
             ",", "J", ",", "K", ",", "L", ",", "M"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "M1", ",", "M3", ",", "M4", ",", "M5", ",", "M6", ",", "M7"}], 
            "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M", ",", "8"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]M2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentM2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672591-5338953",ExpressionUUID->"b5e98fab-a3ad-4aa1-96d2-\
711e025ac8b7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NewIndexIn", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"423aaba7-06d5-4ce9-b371-ac05a8ae19ef"],

Cell[BoxData["M8"], \
"Output",ExpressionUUID->"e35c9dfe-6ea6-473d-b471-71f2c8697b38"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentM2"}]], \
"Input",ExpressionUUID->"7956b2ac-0801-45d3-bdfe-6c2491ff7615"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]M2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentM2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672592-5338953",ExpressionUUID->"98a55b41-324b-409c-b5d5-\
7fc33e669246"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentM2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", 
             ",", "J", ",", "K", ",", "L", ",", "M"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
            "M1", ",", "M3", ",", "M4", ",", "M5", ",", "M6", ",", "M7", ",", 
             "M8"}], "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M", ",", "9"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]M2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentM2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672592-5338953",ExpressionUUID->"4d6a81f5-b9f3-4935-aa2d-\
6b6729481c2f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{
    "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", "h",
      ",", "i", ",", "j", ",", "k", ",", "l", ",", "m"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"72ba0b6b-821e-40da-ab79-938474318e42"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d7f3cc01-c06b-4c52-b4bc-32504767ed91"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"69a28536-410e-4262-b1e1-1ef8f40025ea"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "a"}]], "Input",ExpressionUUID->"5b3c873c-928c-4129-8975-9618b14f6fea"],

Cell[CellGroupData[{

Cell["Global`a", "Print", "PrintUsage",
 CellTags->
  "Info3578672594-5338953",ExpressionUUID->"48f125fe-33ac-4bef-9520-\
9873265c8b3f"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "a", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "a", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DaggerIndex", "[", "a", "]"}], "^=", "a"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "a", "]"}], "^=", 
         "a"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "a", "]"}], "^=", "\<\"a\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentS2`Q", "[", "a", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "a", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`a],
  Editable->False]], "Print",
 CellTags->
  "Info3578672594-5338953",ExpressionUUID->"502342cb-11c8-4f1d-ae3e-\
173eb3c97de2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"Mprod", ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "alpha", ",", "beta", ",", "mu", ",", "nu", ",", "sigma", ",", "lambda", 
     ",", "rho", ",", "eta"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"cca56716-a7e0-4ce0-9795-451ad5df47b3"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "Mprod", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`Mprod, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"aac75ec8-ccfc-4211-bb12-0924ec075d5a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", 
   "TangentMprod", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentMprod, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1f3aa0b5-9bf1-4da8-bdb8-fb32c65e6eb6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{"Mother", ",", 
    RowBox[{"{", 
     RowBox[{"M3", ",", "M2", ",", "S2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Alpha", ",", "Beta"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"d7e282f4-b8b6-4ce5-a42d-70e6fb9f6f18"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DimOfManifold", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"manifold\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\\\"M3\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"302ff280-b86e-4347-a5d3-5410c6850900"]
}, Open  ]],

Cell["\<\
Interrogate manifolds as contexts concerning their two associated functions:\
\>", "Text",ExpressionUUID->"09f1cfd7-4920-4816-82f7-73eb9741d66b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentM2`*"}]], \
"Input",ExpressionUUID->"f1b347de-b659-4f1f-808b-db6d83dd0b82"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["TangentM2`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["TangentM2`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["pmQ",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672596-5338953", {"pmQ", "TangentM2`"}},
          ButtonNote->"TangentM2`"], 
         ButtonBox["Q",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672596-5338953", {"Q", "TangentM2`"}},
          ButtonNote->"TangentM2`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.475]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->
    Automatic]]], "Print", \
"InfoCell",ExpressionUUID->"ce3030b0-32ee-4055-a327-397f43ef1cbf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mprod"}]], "Input",ExpressionUUID->"fedaa8ac-ac4b-409b-a3e7-b13c5040ff1d"],

Cell[CellGroupData[{

Cell["Global`Mprod", "Print", "PrintUsage",
 CellTags->
  "Info3578672597-5338953",ExpressionUUID->"e8488f3e-14e8-4c94-a005-\
3d7131f62c95"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Mprod", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "Mprod", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "Mprod", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Mprod", "]"}], "^=", "\<\"Mprod\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", "\[Times]", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "M2"}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "S2"}], "]"}], "=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Mprod],
  Editable->False]], "Print",
 CellTags->
  "Info3578672597-5338953",ExpressionUUID->"d105f99f-ce4b-4569-a389-\
baedf5257b9d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentMprod"}]], \
"Input",ExpressionUUID->"323d9059-f9ce-4ab5-9b77-f53b85b186ad"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]Mprod",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentMprod,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672599-5338953",ExpressionUUID->"9f492576-f894-4323-b8ce-\
fa248bc2a2c9"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "Mprod"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]Mprod",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentMprod,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentMprod],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "alpha", ",", "beta", ",", "mu", ",", "nu", ",", "sigma", ",", 
             "lambda", ",", "rho", ",", "eta"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"eta", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "Mprod"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]Mprod\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], "\[CirclePlus]", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False], "/:", 
         RowBox[{"SubvbundleQ", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]Mprod",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentMprod,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False], "/:", 
         RowBox[{"SubvbundleQ", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]Mprod",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentMprod,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentMprod],
  Editable->False]], "Print",
 CellTags->
  "Info3578672599-5338953",ExpressionUUID->"806e6276-df07-4a1e-a594-\
5d91bf72e44b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "eta"}]], "Input",ExpressionUUID->"65baf454-f530-47ba-a1d6-5666c2b9f996"],

Cell[CellGroupData[{

Cell["Global`eta", "Print", "PrintUsage",
 CellTags->
  "Info3578672600-5338953",ExpressionUUID->"8103ec4f-3381-488e-98e5-\
96fc0edef93b"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "eta", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "eta", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DaggerIndex", "[", "eta", "]"}], "^=", "eta"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xAct`xTensor`Private`NoDollar", "[", "eta", "]"}], "^=", 
         "eta"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "eta", "]"}], "^=", "\<\"eta\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TangentMprod`Q", "[", "eta", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "eta", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`eta],
  Editable->False]], "Print",
 CellTags->
  "Info3578672600-5338953",ExpressionUUID->"2ee227c5-22f3-41ac-9e0a-\
501e729fc137"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$AbstractIndices"], \
"Input",ExpressionUUID->"ba5077f4-2224-4292-bc8e-eeb68786db42"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J", 
   ",", "K", ",", "L", ",", "M", ",", "M1", ",", "M3", ",", "M4", ",", "M5", 
   ",", "M6", ",", "M7", ",", "M8", ",", "a", ",", "b", ",", "c", ",", "d", 
   ",", "e", ",", "f", ",", "g", ",", "h", ",", "i", ",", "j", ",", "k", ",", 
   "l", ",", "m", ",", "alpha", ",", "beta", ",", "mu", ",", "nu", ",", 
   "sigma", ",", "lambda", ",", "rho", ",", "eta"}], 
  "}"}]], "Output",ExpressionUUID->"597f11e7-9a59-4016-8ef1-fb923d650ed1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"1fc87e3d-0201-4b32-8f0b-5830aa8a782e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M2", ",", "S2", ",", "Mprod"}], 
  "}"}]], "Output",ExpressionUUID->"dccfa9f7-32d0-45f1-aab3-344cf4c7f22a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$VBundles"], \
"Input",ExpressionUUID->"35aeee61-5858-4bae-a497-8e2a3d7b0442"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]Mprod",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentMprod,
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"3563a123-9ac8-4041-a805-801de9970343"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DisjointManifoldsQ", "[", 
  RowBox[{"M2", ",", "S2"}], 
  "]"}]], "Input",ExpressionUUID->"25b970ca-dd43-428e-8858-3772cf039fa9"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"69d3ebc1-becf-419f-9ee9-cd196a62f67f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DisjointManifoldsQ", "[", 
  RowBox[{"Mprod", ",", "S2"}], 
  "]"}]], "Input",ExpressionUUID->"6c3b430d-0b0f-463a-b95e-de12a3aca670"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"ae6eb640-786b-48f2-9482-2d0070a104a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DisjointManifoldsQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", "Mprod"}], 
  "]"}]], "Input",ExpressionUUID->"b15b4410-082f-432c-a71f-3e04a08ee214"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"0208da3c-15f7-4178-be68-958aa8fec5b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "Mprod", 
  "]"}]], "Input",ExpressionUUID->"c4f3f150-66e8-4a17-995f-9a64d5762810"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]Mprod",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentMprod,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentMprod],
  Editable->
   False]], "Print",ExpressionUUID->"51179742-ea29-4ea5-a9ff-e4b650d331bb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Mprod"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`Mprod],
  Editable->
   False]], "Print",ExpressionUUID->"e911edb9-b2cf-42a1-9b1e-26243da2a0c2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "TangentMprod"}]], \
"Input",ExpressionUUID->"e15aef86-2d64-4abb-a673-90515df2e4e8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"TangentMprod\\\"\\)\[NoBreak] not \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/notfound\\\", ButtonNote -> \
\\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8f6e74ec-f4f0-4c49-b0e0-47c7d3f03a0a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "Mprod"}]], "Input",ExpressionUUID->"8af79740-64e7-423f-b46d-896f53cd8cb7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"Mprod\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b5b054f9-5301-49b6-b851-1e29abf2a19f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"d9caf5cf-7526-46a8-8286-f4990d512f9d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M2", ",", "S2"}], 
  "}"}]], "Output",ExpressionUUID->"6fcf9efd-dd93-491e-bd1e-6f203ec5102e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$ProductManifolds"], \
"Input",ExpressionUUID->"1e8df186-6781-46bf-b948-28e1530e6771"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"65d00c5e-1c6c-4bc6-a122-b4f15c7e7444"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$VBundles"], \
"Input",ExpressionUUID->"d49d4cb5-0374-498d-a95b-b997ac475022"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"ac4e9115-46dc-4d84-a3a3-1231e59727d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$SumVBundles"], \
"Input",ExpressionUUID->"2e1108d2-eb17-481e-b8af-9e5f3bbeff04"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"84dc5646-714b-436b-864d-56bf060f6559"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "UndefManifold", "[", "Mother", 
   "]"}]}]], "Input",ExpressionUUID->"20e87080-2749-4c17-a563-c31a70d77a18"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"UndefManifold", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"manifold\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(Mother\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"947e6000-f612-45ed-a611-7a4ba012ce03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", 
  RowBox[{"M1", ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"49e2d0aa-6187-441a-94fc-f13726347ae3"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"IndicesOfVBundle", "::", "argx"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(IndicesOfVBundle\\)\[NoBreak] called with \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments; 1 argument is expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argx\\\", \
ButtonNote -> \\\"xAct`xTensor`IndicesOfVBundle::argx\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"b34c1365-f498-47a1-a6d6-160f5c7170ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "IndicesOfVBundle", "[", "M1", 
   "]"}]}]], "Input",ExpressionUUID->"e2416234-2997-4bcf-8145-a55f5a432869"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"IndicesOfVBundle", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"vector bundle\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(M1\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7772f574-a9b7-4deb-b6d6-6e13ee908c7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"N2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"P", ",", "Q"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"10ef8dfe-ed33-4f8a-8819-2ba014ab8192"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "N2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`N2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"57fb0a76-cd8d-43e9-bf7c-0e906995db71"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentN2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentN2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b2f2e55-83e3-433a-808d-6b7898e99206"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"DIM", ",", 
   RowBox[{"PrintAs", "->", "\"\<d\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"8e7040e8-1b47-4236-b739-44f9952adc7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "DIM", "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`DIM, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"13072f99-4d37-4df8-99fb-0dbc73fe0770"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"Ms", ",", "DIM", ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "q"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"9239c9bd-359b-429b-9da2-c5dcc3131715"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "Ms", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`Ms, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a700735c-05f9-4fbe-a981-2b0579997629"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentMs", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentMs, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1617622a-4bc6-4b49-a25f-951d12aa9305"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Ms"}]], "Input",ExpressionUUID->"662147fb-60e1-4f72-b613-9dee93e77050"],

Cell[CellGroupData[{

Cell["Global`Ms", "Print", "PrintUsage",
 CellTags->
  "Info3578672604-5338953",ExpressionUUID->"dc43479a-68d5-4445-833c-\
c23020d529bf"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Ms", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Ms", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "Ms", "]"}], "^=", 
         InterpretationBox[
          StyleBox["d",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`DIM,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "Ms", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Ms", "]"}], "^=", "\<\"Ms\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "Ms", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "Ms", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Ms],
  Editable->False]], "Print",
 CellTags->
  "Info3578672604-5338953",ExpressionUUID->"1e6d768b-c441-4d59-96e1-\
dd4b7e263df2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentMs"}]], \
"Input",ExpressionUUID->"9e1a9d33-b4c8-4731-9453-9609bcef9a01"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]Ms",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentMs,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672606-5338953",ExpressionUUID->"09dc438a-f6a2-4688-a81f-\
d8851f7edb86"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Ms",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMs,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", "Ms"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]Ms",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentMs,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentMs],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Ms",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMs,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", 
         InterpretationBox[
          StyleBox["d",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`DIM,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", "q"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"q", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", "Ms"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]Ms\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Ms",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMs,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentMs],
  Editable->False]], "Print",
 CellTags->
  "Info3578672606-5338953",ExpressionUUID->"1a59c976-2a84-4331-bc7e-\
fb4812c16466"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"MM", ",", "Mother", ",", "Alpha"}], 
  "]"}]], "Input",ExpressionUUID->"d3344a2e-f5ab-4cd8-b1c0-21b4922d049f"],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"5659b7ee-08fd-4d63-8e2d-1c10afcb3ef8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M2", ",", "S2", ",", "N2", ",", "Ms"}], 
  "}"}]], "Output",ExpressionUUID->"b160b987-2cad-49e0-b4f6-1ed0be8e2720"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefManifold", "[", 
   RowBox[{"Mstrings", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<r\>\"", ",", "\"\<theta\>\"", ",", "\"\<phi\>\""}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"as", ",", "bs", ",", "cs", ",", "ds", ",", "es"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"4d8a6310-efb2-47a6-abe2-d274c7d17499"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DimOfManifold", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"manifold\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\\\"r\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ccaa6a32-2c38-4b89-a8b6-5adf24b92d42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mstrings"}]], \
"Input",ExpressionUUID->"75ab3247-1254-4b4d-a88d-753dc0972191"],

Cell["Global`Mstrings", "Print", "PrintUsage",
 CellTags->
  "Info3578672608-5338953",ExpressionUUID->"847dffcd-c519-41e9-afc7-\
c05576d13be3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"Mstrings", ",", "as", ",", "bs", ",", "cs", ",", "ds", ",", "es"}],
   "]"}]], "Input",ExpressionUUID->"8de5a4c2-d744-4f0e-8d12-28c148d2a9f5"],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"511d73d4-18cd-4329-b8b9-2e3f891b394a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M2", ",", "S2", ",", "N2", ",", "Ms"}], 
  "}"}]], "Output",ExpressionUUID->"e3f2dfe2-8e5a-4a23-a12a-24376ac7a818"]
}, Open  ]],

Cell["Now we check the Dagger options:", \
"Text",ExpressionUUID->"2b53ced4-691f-46d7-9bd7-3d8823d9da5b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefVBundle", "[", 
  RowBox[{"Fiber", ",", "S2", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
     ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Real"}]}], 
  "]"}]], "Input",ExpressionUUID->"8e6fc1ed-c38f-4cb6-ab01-6826231af4be"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "Fiber", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`Fiber, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"73dbda13-f0d6-496f-ab82-82611f995ab1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber"}]], "Input",ExpressionUUID->"18a71c70-3df3-429b-8f17-2a821b8d9ddc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672609-5338953",ExpressionUUID->"e2f223c6-e5e4-4c01-ad07-\
8f63aa4d940b"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["Fiber",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Fiber,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["Fiber",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Fiber,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Fiber],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "3"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", 
             "\[GothicCapitalC]", ",", "\[GothicCapitalD]", ",", 
             "\[GothicCapitalE]"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\[GothicCapitalE]", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "\<\"Fiber\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Fiber],
  Editable->False]], "Print",
 CellTags->
  "Info3578672609-5338953",ExpressionUUID->"645b4c9a-824d-4bec-b730-\
e6303ff9b518"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NewIndexIn", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"908847f0-2111-4a28-b735-b191acf5c4df"],

Cell[BoxData["\[GothicCapitalE]1"], \
"Output",ExpressionUUID->"3056e3ca-3077-4e35-8fc2-7d0eade76408"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalE]1"}]], \
"Input",ExpressionUUID->"3e2f3b53-2bf1-4d87-9e88-43083d512d56"],

Cell[CellGroupData[{

Cell["Global`\[GothicCapitalE]1", "Print", "PrintUsage",
 CellTags->
  "Info3578672611-5338953",ExpressionUUID->"27017fb2-1e6b-403a-81db-\
e74ebb281f02"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "\[GothicCapitalE]1", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "\[GothicCapitalE]1", "]"}], "^=", 
         "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "xAct`xTensor`Private`NoDollar", "[", "\[GothicCapitalE]1", "]"}], "^=",
          "\[GothicCapitalE]1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "\[GothicCapitalE]1", "]"}], 
         "^=", "\<\"\[GothicCapitalE]1\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Fiber`Q", "[", "\[GothicCapitalE]1", "]"}], "^=", 
         "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "\[GothicCapitalE]1", "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`\[GothicCapitalE]1],
  Editable->False]], "Print",
 CellTags->
  "Info3578672611-5338953",ExpressionUUID->"2248fdbf-cb55-4b13-95a5-\
86df1905996b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"Fiber", ",", "10"}], 
  "]"}]], "Input",ExpressionUUID->"d42de965-731f-4855-944f-5f11c2c15bcc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
   ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]", ",", 
   "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", "\[GothicCapitalE]3",
    ",", "\[GothicCapitalE]4", ",", "\[GothicCapitalE]5"}], 
  "}"}]], "Output",ExpressionUUID->"e8c90530-04a5-4efa-91f2-2d7664b58b99"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"AddIndices", "[", 
  RowBox[{"Fiber", ",", 
   RowBox[{"{", 
    RowBox[{"\[GothicCapitalF]", ",", "\[GothicCapitalG]"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"6d2bbe5b-3247-4f5a-a5a8-466492a296aa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"Fiber", ",", "20"}], 
  "]"}]], "Input",ExpressionUUID->"a630cf57-80f7-42f8-a787-cdba74ab3a20"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
   ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]", ",", 
   "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", "\[GothicCapitalE]3",
    ",", "\[GothicCapitalE]4", ",", "\[GothicCapitalE]5", ",", 
   "\[GothicCapitalF]", ",", "\[GothicCapitalG]", ",", "\[GothicCapitalG]6", 
   ",", "\[GothicCapitalG]7", ",", "\[GothicCapitalG]8", ",", 
   "\[GothicCapitalG]9", ",", "\[GothicCapitalG]10", ",", 
   "\[GothicCapitalG]11", ",", "\[GothicCapitalG]12", ",", 
   "\[GothicCapitalG]13"}], 
  "}"}]], "Output",ExpressionUUID->"00fdd29b-a191-4ce0-80e7-eddfcf70b043"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"RemoveIndices", "[", 
  RowBox[{"Fiber", ",", 
   RowBox[{"{", 
    RowBox[{"\[GothicCapitalD]", ",", "\[GothicCapitalF]"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1beb9ac6-ff44-4acd-a0a6-73a498d4239c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalD]"}]], \
"Input",ExpressionUUID->"257ce647-6e24-4293-b23a-e06daf524807"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"\\\\[GothicCapitalD]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"68533047-f771-4f17-850c-3d90e4da1869"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalF]"}]], \
"Input",ExpressionUUID->"7aa26cf9-12c2-46ad-b2cc-0a826c22673b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"\\\\[GothicCapitalF]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8f7a08a9-a316-46ee-90d1-073717329325"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"c6806591-b4dd-4c84-9a08-0d85c964713e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
     ",", "\[GothicCapitalE]", ",", "\[GothicCapitalG]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", 
     "\[GothicCapitalE]3", ",", "\[GothicCapitalE]4", ",", 
     "\[GothicCapitalE]5", ",", "\[GothicCapitalG]6", ",", 
     "\[GothicCapitalG]7", ",", "\[GothicCapitalG]8", ",", 
     "\[GothicCapitalG]9", ",", "\[GothicCapitalG]10", ",", 
     "\[GothicCapitalG]11", ",", "\[GothicCapitalG]12", ",", 
     "\[GothicCapitalG]13"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"e7a84ab7-3af7-45ad-a181-0caf73b7012a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"fb9ad188-16d7-4079-b89b-e62369ae9051"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Fiber",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Fiber,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`Fiber],
  Editable->
   False]], "Print",ExpressionUUID->"90485cd5-0449-46d1-b364-37f9242fe97c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefVBundle", "[", 
  RowBox[{"Fiber", ",", "S2", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
     ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Complex"}]}], 
  "]"}]], "Input",ExpressionUUID->"091628c3-37a3-4aa8-8897-e49b478de29b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "Fiber", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`Fiber, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"15abce0c-3ca0-413a-af9a-bb13b06dcfaf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"conjugated vbundle \"\>", "\[InvisibleSpace]", 
   "Fiber\[Dagger]", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Assuming fixed anti-isomorphism between Fiber \
and Fiber\[Dagger]\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "conjugated vbundle ", $CellContext`Fiber\[Dagger], ". ", 
   "Assuming fixed anti-isomorphism between Fiber and Fiber\[Dagger]"],
  Editable->
   False]], "Print",ExpressionUUID->"601ea94d-38fc-452b-86fc-7c4200e0e304"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber"}]], "Input",ExpressionUUID->"4c4ef9fa-5232-40e3-9422-63d704fdf6de"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672613-5338953",ExpressionUUID->"37786eee-5edd-4282-bade-\
c63ef71963fb"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["Fiber",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Fiber,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["Fiber",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Fiber,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Fiber],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["Fiber\[Dagger]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber\[Dagger],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "3"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", 
             "\[GothicCapitalC]", ",", "\[GothicCapitalD]", ",", 
             "\[GothicCapitalE]"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\[GothicCapitalE]", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "\<\"Fiber\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["Fiber",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Fiber],
  Editable->False]], "Print",
 CellTags->
  "Info3578672613-5338953",ExpressionUUID->"96784298-1f4e-4458-b42d-\
c2d93675734c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Fiber\[Dagger]"}]], \
"Input",ExpressionUUID->"02526e38-08b9-434a-a304-96ae71e6ce71"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["Fiber\[Dagger]",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Fiber\[Dagger],
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672615-5338953",ExpressionUUID->"420bde48-bbe5-4782-86f1-\
80a97eab8c51"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["Fiber\[Dagger]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Fiber\[Dagger],
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["Fiber\[Dagger]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Fiber\[Dagger],
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Fiber\[Dagger]],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          
          RowBox[{"\<\"conjugated vbundle\"\>", 
           ",", "\<\"Assuming fixed anti-isomorphism between Fiber and Fiber\
\[Dagger]\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "3"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[GothicCapitalA]\[Dagger]", ",", "\[GothicCapitalB]\[Dagger]", 
             ",", "\[GothicCapitalC]\[Dagger]", ",", 
             "\[GothicCapitalD]\[Dagger]", ",", 
             "\[GothicCapitalE]\[Dagger]"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\[GothicCapitalE]\[Dagger]", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "\<\"Fiber\[Dagger]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["Fiber\[Dagger]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Fiber\[Dagger],
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Fiber\[Dagger]],
  Editable->False]], "Print",
 CellTags->
  "Info3578672615-5338953",ExpressionUUID->"9d7757c9-7c20-4864-a4df-\
5f4c7fc051ab"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NewIndexIn", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"99f88edb-6121-437b-af84-ff48ecc2f8b3"],

Cell[BoxData["\[GothicCapitalE]1"], \
"Output",ExpressionUUID->"631a67e4-6fd4-478a-a7e7-3eca26935f2f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"Fiber", ",", "10"}], 
  "]"}]], "Input",ExpressionUUID->"afa0dae8-f5fd-4501-8826-2fae797927a7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
   ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]", ",", 
   "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", "\[GothicCapitalE]3",
    ",", "\[GothicCapitalE]4", ",", "\[GothicCapitalE]5"}], 
  "}"}]], "Output",ExpressionUUID->"35531387-ebcb-4837-bc2c-c0e9fb17d181"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"3ad92294-cdc5-41b8-892f-d824f684fb68"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
     ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", 
     "\[GothicCapitalE]3", ",", "\[GothicCapitalE]4", ",", 
     "\[GothicCapitalE]5"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"3a76b3d9-81cd-49a3-9824-dda12d90b484"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", "Fiber\[Dagger]", 
  "]"}]], "Input",ExpressionUUID->"aaefae57-a244-4d58-8920-d2863cbfb9b0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]\[Dagger]", ",", "\[GothicCapitalB]\[Dagger]", ",", 
     "\[GothicCapitalC]\[Dagger]", ",", "\[GothicCapitalD]\[Dagger]", ",", 
     "\[GothicCapitalE]\[Dagger]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalE]1\[Dagger]", ",", "\[GothicCapitalE]2\[Dagger]", ",", 
     "\[GothicCapitalE]3\[Dagger]", ",", "\[GothicCapitalE]4\[Dagger]", ",", 
     "\[GothicCapitalE]5\[Dagger]"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"89258da7-7eaa-4480-8955-d4e641d421fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalE]4"}]], \
"Input",ExpressionUUID->"7435db51-a3a5-442e-9cae-7f853941f9e9"],

Cell[CellGroupData[{

Cell["Global`\[GothicCapitalE]4", "Print", "PrintUsage",
 CellTags->
  "Info3578672616-5338953",ExpressionUUID->"c024c25f-31dc-4271-bccb-\
be920ac37b12"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "\[GothicCapitalE]4", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "\[GothicCapitalE]4", "]"}], "^=", 
         "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "xAct`xTensor`Private`NoDollar", "[", "\[GothicCapitalE]4", "]"}], "^=",
          "\[GothicCapitalE]4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "\[GothicCapitalE]4", "]"}], 
         "^=", "\<\"\[GothicCapitalE]4\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Fiber`Q", "[", "\[GothicCapitalE]4", "]"}], "^=", 
         "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "\[GothicCapitalE]4", "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`\[GothicCapitalE]4],
  Editable->False]], "Print",
 CellTags->
  "Info3578672616-5338953",ExpressionUUID->"f6dc173c-1369-425b-bcbb-\
e0f4ff291001"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalE]4\[Dagger]"}]], \
"Input",ExpressionUUID->"588c59cc-ed15-4ee9-a2d0-17f647de000e"],

Cell[CellGroupData[{

Cell["Global`\[GothicCapitalE]4\[Dagger]", "Print", "PrintUsage",
 CellTags->
  "Info3578672618-5338953",ExpressionUUID->"c5a85333-069e-4469-bd59-\
21763ac0f529"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "\[GothicCapitalE]4\[Dagger]", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "\[GothicCapitalE]4\[Dagger]", "]"}], 
         "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "xAct`xTensor`Private`NoDollar", "[", "\[GothicCapitalE]4\[Dagger]", 
          "]"}], "^=", "\[GothicCapitalE]4\[Dagger]"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "\[GothicCapitalE]4\[Dagger]", "]"}], 
         "^=", "\<\"\[GothicCapitalE]4\[Dagger]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "Fiber\[Dagger]`Q", "[", "\[GothicCapitalE]4\[Dagger]", "]"}], "^=", 
         "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "\[GothicCapitalE]4\[Dagger]", "]"}], 
         "^=", 
         InterpretationBox[
          StyleBox["Fiber\[Dagger]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber\[Dagger],
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`\[GothicCapitalE]4\[Dagger]],
  Editable->False]], "Print",
 CellTags->
  "Info3578672618-5338953",ExpressionUUID->"db99e039-6aeb-403b-a6a4-\
b5a32d63e84d"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"AddIndices", "[", 
  RowBox[{"Fiber", ",", 
   RowBox[{"{", 
    RowBox[{"\[GothicCapitalF]", ",", "\[GothicCapitalG]"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ec2def4e-69d1-497e-a35d-ac4dc281e792"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalF]"}]], \
"Input",ExpressionUUID->"7e6a2487-a597-4a22-b3fd-c9b64363bf3d"],

Cell[CellGroupData[{

Cell["Global`\[GothicCapitalF]", "Print", "PrintUsage",
 CellTags->
  "Info3578672619-5338953",ExpressionUUID->"6a63924b-a3f4-4ccd-8235-\
5fcc46702d1d"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "\[GothicCapitalF]", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "\[GothicCapitalF]", "]"}], "^=", 
         "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "xAct`xTensor`Private`NoDollar", "[", "\[GothicCapitalF]", "]"}], "^=",
          "\[GothicCapitalF]"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "\[GothicCapitalF]", "]"}], 
         "^=", "\<\"\[GothicCapitalF]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Fiber`Q", "[", "\[GothicCapitalF]", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "\[GothicCapitalF]", "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber,
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`\[GothicCapitalF]],
  Editable->False]], "Print",
 CellTags->
  "Info3578672619-5338953",ExpressionUUID->"4765a13d-c944-4d36-8a81-\
96bbbd645158"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalF]\[Dagger]"}]], \
"Input",ExpressionUUID->"92341d61-012d-4895-b1bd-e3320b84eb8f"],

Cell[CellGroupData[{

Cell["Global`\[GothicCapitalF]\[Dagger]", "Print", "PrintUsage",
 CellTags->
  "Info3578672620-5338953",ExpressionUUID->"d732afbc-ca19-489f-8c3a-\
8466d49ed679"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "\[GothicCapitalF]\[Dagger]", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"AbstractIndexQ", "[", "\[GothicCapitalF]\[Dagger]", "]"}], "^=",
          "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "xAct`xTensor`Private`NoDollar", "[", "\[GothicCapitalF]\[Dagger]", 
          "]"}], "^=", "\[GothicCapitalF]\[Dagger]"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "\[GothicCapitalF]\[Dagger]", "]"}], 
         "^=", "\<\"\[GothicCapitalF]\[Dagger]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Fiber\[Dagger]`Q", "[", "\[GothicCapitalF]\[Dagger]", "]"}],
          "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfIndex", "[", "\[GothicCapitalF]\[Dagger]", "]"}], "^=", 
         InterpretationBox[
          StyleBox["Fiber\[Dagger]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Fiber\[Dagger],
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`\[GothicCapitalF]\[Dagger]],
  Editable->False]], "Print",
 CellTags->
  "Info3578672620-5338953",ExpressionUUID->"213aec12-a372-4aee-b975-\
621b8f51d6e7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"Fiber", ",", "20"}], 
  "]"}]], "Input",ExpressionUUID->"139b1ecd-103f-40f0-a29b-f95e0cc6d379"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
   ",", "\[GothicCapitalD]", ",", "\[GothicCapitalE]", ",", 
   "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", "\[GothicCapitalE]3",
    ",", "\[GothicCapitalE]4", ",", "\[GothicCapitalE]5", ",", 
   "\[GothicCapitalF]", ",", "\[GothicCapitalG]", ",", "\[GothicCapitalG]6", 
   ",", "\[GothicCapitalG]7", ",", "\[GothicCapitalG]8", ",", 
   "\[GothicCapitalG]9", ",", "\[GothicCapitalG]10", ",", 
   "\[GothicCapitalG]11", ",", "\[GothicCapitalG]12", ",", 
   "\[GothicCapitalG]13"}], 
  "}"}]], "Output",ExpressionUUID->"26cd6aa0-be59-4e37-9eb5-00959dc96f65"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"RemoveIndices", "[", 
  RowBox[{"Fiber", ",", 
   RowBox[{"{", 
    RowBox[{"\[GothicCapitalD]", ",", "\[GothicCapitalF]"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"5c4c538f-9bef-4daf-8d1f-4fdd99ed37f1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"5e7101db-649f-46cb-a00b-2298e94b3c6e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]", ",", "\[GothicCapitalB]", ",", "\[GothicCapitalC]", 
     ",", "\[GothicCapitalE]", ",", "\[GothicCapitalG]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalE]1", ",", "\[GothicCapitalE]2", ",", 
     "\[GothicCapitalE]3", ",", "\[GothicCapitalE]4", ",", 
     "\[GothicCapitalE]5", ",", "\[GothicCapitalG]6", ",", 
     "\[GothicCapitalG]7", ",", "\[GothicCapitalG]8", ",", 
     "\[GothicCapitalG]9", ",", "\[GothicCapitalG]10", ",", 
     "\[GothicCapitalG]11", ",", "\[GothicCapitalG]12", ",", 
     "\[GothicCapitalG]13"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"b56e2b3d-26d0-4bb4-bbe4-d195a7da3082"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndicesOfVBundle", "[", "Fiber\[Dagger]", 
  "]"}]], "Input",ExpressionUUID->"8396eba9-a90c-4ced-b97a-9f1ba2fac591"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalA]\[Dagger]", ",", "\[GothicCapitalB]\[Dagger]", ",", 
     "\[GothicCapitalC]\[Dagger]", ",", "\[GothicCapitalE]\[Dagger]", ",", 
     "\[GothicCapitalG]\[Dagger]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "\[GothicCapitalE]1\[Dagger]", ",", "\[GothicCapitalE]2\[Dagger]", ",", 
     "\[GothicCapitalE]3\[Dagger]", ",", "\[GothicCapitalE]4\[Dagger]", ",", 
     "\[GothicCapitalE]5\[Dagger]", ",", "\[GothicCapitalG]6\[Dagger]", ",", 
     "\[GothicCapitalG]7\[Dagger]", ",", "\[GothicCapitalG]8\[Dagger]", ",", 
     "\[GothicCapitalG]9\[Dagger]", ",", "\[GothicCapitalG]10\[Dagger]", ",", 
     "\[GothicCapitalG]11\[Dagger]", ",", "\[GothicCapitalG]12\[Dagger]", ",",
      "\[GothicCapitalG]13\[Dagger]"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"5b35dec7-0826-42f5-8857-f888912710f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalD]"}]], \
"Input",ExpressionUUID->"9455f22e-c469-4659-888e-71a9c8cc710e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"\\\\[GothicCapitalD]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"79f354a9-a247-4484-92b7-fe543a761a1f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalF]"}]], \
"Input",ExpressionUUID->"93f2a14d-e182-4dc9-95cf-697e2d90c7cb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"\\\\[GothicCapitalF]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d446fb63-19fe-44be-9a4e-7fae829518ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalD]\[Dagger]"}]], \
"Input",ExpressionUUID->"cc69ee03-986d-4e76-aafd-c440e8abb811"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"\\\\[GothicCapitalD]\\\\[Dagger]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a819bd8d-98b5-4d9f-b882-9879feafab32"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "\[GothicCapitalF]\[Dagger]"}]], \
"Input",ExpressionUUID->"fcc3716d-7e58-47b4-874f-47f59b5b5f77"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], ":", 
  " ", "\<\"No symbol matching \
\[NoBreak]\\!\\(\\\"\\\\[GothicCapitalF]\\\\[Dagger]\\\"\\)\[NoBreak] found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"3c9dab3e-47c2-4027-b23c-e41bd7f5e762"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefVBundle", "[", "Fiber", 
  "]"}]], "Input",ExpressionUUID->"7dc7d3fd-a3bb-44bc-85c2-eff51fee8951"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"conjugated vbundle\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Fiber\[Dagger]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Fiber\[Dagger],
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "conjugated vbundle", 
   " ", $CellContext`Fiber\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"6b5235f1-450a-4030-9942-ba59a56686c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Fiber",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Fiber,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`Fiber],
  Editable->
   False]], "Print",ExpressionUUID->"4777508a-f870-43a1-8683-5160b682103b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"46105455-6e5e-44e3-b8ef-d001f0b0f518"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"910f2b96-7e77-422b-b67b-f739bbf143aa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"6381a938-9e1e-43a3-ae3f-f7195deeaf3b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "N2", 
  "]"}]], "Input",ExpressionUUID->"43101a55-b0a9-44ef-ad97-f70468c6359a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]N2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentN2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentN2],
  Editable->
   False]], "Print",ExpressionUUID->"7fd1d5a3-99a9-41c9-8359-c2cb21899c40"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "N2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`N2],
  Editable->
   False]], "Print",ExpressionUUID->"fee6d024-1826-47e8-b1cc-fe483773166a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "Ms", 
  "]"}]], "Input",ExpressionUUID->"23befc8e-8eea-4153-a94c-6bba7529d690"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]Ms",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentMs,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentMs],
  Editable->
   False]], "Print",ExpressionUUID->"fe61f1ab-8bc1-43ef-97fd-f14ef953e58a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Ms"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`Ms],
  Editable->
   False]], "Print",ExpressionUUID->"f8454fa6-3c31-4159-8771-5cd738bc9a02"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"ffd4b51e-8d83-460d-bcfd-41e1f1bfef36"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"10fa505f-4403-4e2d-8c05-3c407dfeb523"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"d6a4e122-aee1-4bfa-b33d-d56f5da5894b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "DIM", 
  "]"}]], "Input",ExpressionUUID->"6650c83c-e5f1-4b20-b320-1183dbd3955f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["d",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`DIM,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`DIM],
  Editable->
   False]], "Print",ExpressionUUID->"ba94d8c1-d386-48a3-a723-1fcd1e008507"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"f3c32609-ee1f-407d-869b-c467dfd866f9"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"8d0925af-7ff4-4179-a3b0-0c3f5a3bfe71"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"7bf04602-d670-4000-9736-5cece0973539"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["8. Index formatting",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"5b721b73-add8-4e9c-9d48-994bafe208b1"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
    "**"}], "*", " ", "8.", "Formatting"}], " ", 
  "****************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6f95834b-1606-4713-b671-d97c3ff20c06"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"d85cb6c8-bdb0-4319-bfda-bbbdd58d3c10"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "29.526909`", ",", "355.000667`9.00177416253458", ",", 
   "0.08317432167280688`"}], 
  "}"}]], "Output",ExpressionUUID->"1c83f63a-22bd-4b71-8335-9df0240b3f06"]
}, Open  ]],

Cell[CellGroupData[{

Cell["8.0. Comments", \
"Subsection",ExpressionUUID->"f31617a4-3961-4f12-9093-3368edd53f84"],

Cell[TextData[{
 "This section is essentially a simple working proposal. There are three \
objectives:\n\t- Conversion to ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"L", 
    StyleBox[
     AdjustmentBox["A",
      BoxBaselineShift->-0.2,
      BoxMargins->{{-0.36, -0.1}, {0, 0}}],
     FontSize->Smaller], "T", 
    AdjustmentBox["E",
     BoxBaselineShift->0.5,
     BoxMargins->{{-0.075, -0.085}, {0, 0}}], "X"}]]],ExpressionUUID->
  "50c7fccf-74d4-4b33-9c6d-0e6ba1050c40"],
 "\n\t- Cut and pasting\n\t- Possibility of walking through the indices of an \
expression with the cursor (this is less important)."
}], "Text",ExpressionUUID->"1689413f-f3a3-41d6-b1ea-fd43be0db89d"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 8: Formatting.\>\"", "]"}], ",",
    "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d4496185-9734-4cbe-ba56-8fb5a3826005"],

Cell[TextData[{
 "Study this (note that several of them are ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " symbols):"
}], "Text",ExpressionUUID->"a649aee1-5b54-407a-9fe9-3b5e1bc074f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "*Form*"}]], "Input",ExpressionUUID->"4045cbaa-f6f3-4e12-a744-b3f9882609bc"],

Cell[BoxData[{
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["System`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["System`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["AccountingForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"AccountingForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["EdgeJoinForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"EdgeJoinForm", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["MatrixForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"MatrixForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["StringForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"StringForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["AutoNumberFormatting",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"AutoNumberFormatting", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["EngineeringForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"EngineeringForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["NumberForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"NumberForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["StringFormat",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"StringFormat", "System`"}},
          
          ButtonNote->"System`"]},
        {
         ButtonBox["BaseForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"BaseForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ExcludedForms",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"ExcludedForms", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["NumberFormat",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"NumberFormat", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["StrokeForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"StrokeForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["BinaryFormat",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"BinaryFormat", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["FaceForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FaceForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OutputForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"OutputForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["StyleForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"StyleForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["BlankForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"BlankForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FileFormat",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FileFormat", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OutputFormData",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"OutputFormData", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["SurdForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"SurdForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["BoxForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"BoxForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FontForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FontForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["PaddedForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"PaddedForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["SyntaxForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"SyntaxForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["BoxFormFormatTypes",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"BoxFormFormatTypes", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Format",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"Format", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ParentForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"ParentForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["TableForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"TableForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["CapForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"CapForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FormatRules",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FormatRules", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["PasteBoxFormInlineCells",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"PasteBoxFormInlineCells", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["TeXForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"TeXForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["CForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"CForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FormatType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["PointForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"PointForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["TextForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"TextForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["ColonForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"ColonForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FormatTypeAutoConvert",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"FormatTypeAutoConvert", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["PolynomialForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"PolynomialForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["TraditionalForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"TraditionalForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["ColumnForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"ColumnForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FormatValues",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FormatValues", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["PrecedenceForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"PrecedenceForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["TreeForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"TreeForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["CommonDefaultFormatTypes",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"CommonDefaultFormatTypes", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["FormBox",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FormBox", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["PrintForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"PrintForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ValueForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"ValueForm", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DateTicksFormat",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DateTicksFormat", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FormBoxOptions",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"FormBoxOptions", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["PromptForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"PromptForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["VerticalForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"VerticalForm", "System`"}},
          
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DefaultFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FortranForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FortranForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["QuantityForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"QuantityForm", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["$BoxForms",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"$BoxForms", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultFormatTypeForStyle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DefaultFormatTypeForStyle", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FullForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"FullForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["RealBlockDiagonalForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"RealBlockDiagonalForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$DateStringFormat",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$DateStringFormat", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultInlineFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DefaultInlineFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["HoldForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"HoldForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["RecurringDigitsForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"RecurringDigitsForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$ExportFormats",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$ExportFormats", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultInputFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DefaultInputFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["HorizontalForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"HorizontalForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ReturnInputFormPacket",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"ReturnInputFormPacket", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$FormatType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"$FormatType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultOutputFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DefaultOutputFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["HornerForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"HornerForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["RuleForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"RuleForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$ImportFormats",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$ImportFormats", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultTextFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"DefaultTextFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["InputForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"InputForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ScientificForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"ScientificForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$OutputForms",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"$OutputForms", "System`"}},
          
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultTextInlineFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {
            "DefaultTextInlineFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["InputToBoxFormPacket",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"InputToBoxFormPacket", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["SequenceForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"SequenceForm", "System`"}},
          
          ButtonNote->"System`"], 
         ButtonBox["$PrintForms",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"$PrintForms", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DisplayForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"DisplayForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["JoinForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"JoinForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["SetBoxFormNamesPacket",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"SetBoxFormNamesPacket", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$SuppressInputFormHeads",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$SuppressInputFormHeads", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DOSTextFormat",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"DOSTextFormat", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["LineForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"LineForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ShowShortBoxForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"ShowShortBoxForm", "System`"}},
          ButtonNote->"System`"], ""},
        {
         ButtonBox["EdgeCapForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"EdgeCapForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["LongForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"LongForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["SpaceForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"SpaceForm", "System`"}},
          ButtonNote->"System`"], ""},
        {
         ButtonBox["EdgeForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"EdgeForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["MathMLForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"MathMLForm", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["StandardForm",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3578672625-5338953", {"StandardForm", "System`"}},
          
          ButtonNote->"System`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.2375]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]], "\n", 
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["xAct`xTensor`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["xAct`xTensor`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["CIndexForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"CIndexForm", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"], 
         ButtonBox["xTensorFormStart",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"xTensorFormStart", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"], 
         ButtonBox["$CIndexForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$CIndexForm", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"], 
         ButtonBox["$ParamDFormat",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$ParamDFormat", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"]},
        {
         ButtonBox["IndexForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"IndexForm", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"], 
         ButtonBox["xTensorFormStop",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"xTensorFormStop", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"], 
         ButtonBox["$CovDFormat",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$CovDFormat", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"], 
         ButtonBox["$ProjectedFormat",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3578672625-5338953", {"$ProjectedFormat", "xAct`xTensor`"}},
          ButtonNote->"xAct`xTensor`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.2375]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->
    Automatic]]}], "Print", \
"InfoCell",ExpressionUUID->"43b3f12e-106e-442f-8325-dca995f3c859"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["8.1. Formatting of a single index", \
"Subsection",ExpressionUUID->"8296eb89-83ec-46ff-946c-1eea2538afa8"],

Cell[CellGroupData[{

Cell["8.1.1. CIndexForm and $CIndexForm", \
"Subsubsection",ExpressionUUID->"12cf86be-a444-48f1-8066-b83d617a6d19"],

Cell["\<\
The global variable $CIndexForm decides whether coordinate-indices are \
written using the corresponding number (the default) or the name of the \
coordinate.\
\>", "Text",ExpressionUUID->"c6eb8ba0-0786-4d64-b050-8f401710b732"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$CIndexForm"}]], \
"Input",ExpressionUUID->"715256ab-d8ee-45c6-8d42-f5981907b077"],

Cell[BoxData[
 StyleBox["\<\"$CIndexForm is a Boolean global variable. If True the \
coordinate indices are represented in tensor slots as the name of the \
associated coordinate. If False (the default) no such replacemente is \
performed.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672626-5338953",ExpressionUUID->"a525f2ac-eb9a-463b-a232-\
d018287c6bfc"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"$CIndexForm", "=", "False"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Treat", " ", "dual", " ", "indices", " ", "in", " ", "the", " ", "same", 
    " ", "way"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CIndexForm", "[", 
    RowBox[{"ind_Integer", ",", 
     RowBox[{"-", "basis_"}]}], "]"}], ":=", 
   RowBox[{"CIndexForm", "[", 
    RowBox[{"ind", ",", "basis"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CIndexForm", "[", 
    RowBox[{"ind_Integer", ",", 
     RowBox[{"chart_", "?", "ChartQ"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{"$CIndexForm", ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"c", "=", 
         RowBox[{"xAct`xCoba`Coordinate", "[", 
          RowBox[{"ind", ",", "chart"}], "]"}]}], "}"}], ",", 
       RowBox[{"PrintAs", "[", "c", "]"}]}], "]"}], ",", 
     RowBox[{"ToString", "[", "ind", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CIndexForm", "[", 
    RowBox[{"ind_Integer", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"ToString", "[", "ind", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c4207c27-77ba-4fb0-8d99-809046e82d21"]
}, Closed]],

Cell[CellGroupData[{

Cell["8.1.2. IndexForm", \
"Subsubsection",ExpressionUUID->"1ff2c444-b840-4892-99ff-f152585a75f6"],

Cell["\<\
IndexForm is an important function because it essentially contains the \
formatting of indices in StandardForm. This means that the functions defined \
here will be used last, when little control can be exerted. In other words, \
errors coming from these functions are very difficult to debug. For the same \
reasons, errors cannot be thrown, only sent. Hence, we must try to make them \
as simple and independent as possible. It is now a public function, but we \
recommend not to interfere with it. If the user wants to change the output of \
a particular *abstract* index, this can be easily and safely done changing \
the PrintAs definition for that index.\
\>", "Text",ExpressionUUID->"c9770a82-f653-4ee7-b731-20e95fda0a57"],

Cell["\<\
This function is the essential driver that gives the string corresponding to \
each kind of index. It is very important to note that we assume that we are \
supplying an index, without any reference to its up/down character: It always \
returns a string, which can have any length.\
\>", "Text",ExpressionUUID->"3ff42326-54db-41e3-9c69-214357037607"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "IndexForm"}]], \
"Input",ExpressionUUID->"a88f49b8-cd3c-457b-a696-20def5bbd33c"],

Cell[BoxData[
 StyleBox["\<\"IndexForm[index] returns the string which will be used to \
format the generalized index (assumed not to have a minus sign in front). By \
default, abstract indices are simply converted into a string, basis and \
component indices are colored according to the basis they belong to, \
directional indices are converted into the name of the vector or into \\\"#\\\
\" when they are composite expressions, and patterns are underlined. \
(Component indices are dealt with through the associated function \
CIndexForm.) If changed, IndexForm must be manipulated with great care.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672627-5338953",ExpressionUUID->"40dd0a29-a252-4025-83dd-\
47cde2b9f0b0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Throw", " ", "error", " ", "if", " ", "a", " ", "minus", " ", "is", " ", 
    RowBox[{"received", ".", " ", "This"}], " ", "should", " ", "never", " ", 
    "happen"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"-", "x_"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"IndexForm", "::", "nouse"}], ",", "\"\<IndexForm\>\"", ",", 
         
         RowBox[{"-", "x"}]}], "]"}], ";", 
       RowBox[{"PrintAs", "[", 
        RowBox[{"-", "x"}], "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Directional", " ", 
     RowBox[{"index", ".", " ", "Long"}], " ", "expressions", " ", "give", 
     " ", "#"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"Dir", "[", 
       RowBox[{
        RowBox[{"v_", "?", "xTensorQ"}], "[", "_", "]"}], "]"}], "]"}], ":=", 
     
     RowBox[{"PrintAs", "[", "v", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"Dir", "[", "v_", "]"}], "]"}], ":=", "\"\<#\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Labels", ".", " ", "Use"}], " ", "PrintAs", " ", "again"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"LI", "[", "]"}], "]"}], ":=", "\"\< \>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"LI", "[", "x_", "]"}], "]"}], ":=", 
     RowBox[{"PrintAs", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"LI", "[", "x__", "]"}], "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"StringJoin", ",", 
       RowBox[{"PrintAs", "/@", 
        RowBox[{"{", "x", "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Component", " ", 
     RowBox[{"index", ".", " ", "Color"}], " ", "according", " ", "to", " ", 
     "basis"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"{", 
       RowBox[{"ind_Integer", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"ColorString", "[", 
      RowBox[{
       RowBox[{"CIndexForm", "[", 
        RowBox[{"ind", ",", "basis"}], "]"}], ",", 
       RowBox[{"xAct`xCoba`BasisColor", "[", "basis", "]"}]}], "]"}]}], ";", 
    " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{
       RowBox[{"basis_", "?", "BasisQ"}], "[", "ind_Integer", "]"}], "]"}], ":=", 
     RowBox[{"ColorString", "[", 
      RowBox[{
       RowBox[{"CIndexForm", "[", 
        RowBox[{"ind", ",", "basis"}], "]"}], ",", 
       RowBox[{"xAct`xCoba`BasisColor", "[", "basis", "]"}]}], "]"}]}], ";", 
    " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Basis", " ", 
     RowBox[{"index", ".", " ", "Color"}], " ", "according", " ", "to", " ", 
     "basis"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"{", 
       RowBox[{"ind_", ",", "basis_"}], "}"}], "]"}], ":=", 
     RowBox[{"ColorString", "[", 
      RowBox[{
       RowBox[{"IndexForm", "[", "ind", "]"}], ",", 
       RowBox[{"xAct`xCoba`BasisColor", "[", "basis", "]"}]}], "]"}]}], ";", 
    " ", 
    RowBox[{"(*", " ", "BASIS1", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"IndexForm", "[", 
       RowBox[{
        RowBox[{"basis_", "?", "BasisQ"}], "[", "ind_", "]"}], "]"}], ":=", 
      RowBox[{"ColorString", "[", 
       RowBox[{
        RowBox[{"IndexForm", "[", "ind", "]"}], ",", 
        RowBox[{"xAct`xCoba`BasisColor", "[", "basis", "]"}]}], "]"}]}], 
     ";"}], " ", 
    RowBox[{"(*", " ", "BASIS2", " ", "*)"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"QUESTION", ":", " ", 
     RowBox[{
     "What", " ", "happens", " ", "for", " ", "general", " ", "index", " ", 
      RowBox[{"modifiers", " ", "?"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Pattern", " ", "or", " ", "PatternTest", " ", 
     RowBox[{"index", ".", " ", "Underline", ".", " ", "PINDEX"}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_PatternTest", "]"}], ":=", 
     RowBox[{"Underline", "[", 
      RowBox[{"IndexForm", "[", 
       RowBox[{"First", "[", "ind", "]"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_Pattern", "]"}], ":=", 
     RowBox[{"Underline", "[", 
      RowBox[{"IndexForm", "[", 
       RowBox[{"First", "[", "ind", "]"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Blank", " ", 
     RowBox[{"family", ".", " ", "Use"}], " ", "an", " ", "underscore", " ", 
     "as", " ", "suggested", " ", "by", " ", "Thomas"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_Blank", "]"}], ":=", "\"\<_\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_BlankSequence", "]"}], ":=", 
     "\"\<_\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_BlankNullSequence", "]"}], ":=", 
     "\"\<_\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Abstract", " ", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_Symbol", "]"}], ":=", 
     RowBox[{"PrintAs", "[", "ind", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Derivative", " ", "in", " ", "Postfix", " ", "notation"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind_", ",", "der_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"First", "[", 
       RowBox[{"SymbolOfCovD", "[", "der", "]"}], "]"}], "<>", 
      RowBox[{"IndexForm", "[", "ind", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Projected", " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind_", ",", "Null"}], "]"}], ":=", 
     RowBox[{"IndexForm", "[", "ind", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind_", ",", "Null", ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "delta"}], "}"}]}], "]"}], ":=", 
     RowBox[{"IndexForm", "[", "ind", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind_", ",", "der_", ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "delta"}], "}"}]}], "]"}], ":=", 
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind", ",", "der"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"IndexForm", "[", 
     RowBox[{"ind_", ",", "Null", ",", 
      RowBox[{"{", 
       RowBox[{"xAct`xTensor`Up", ",", "proj_"}], "}"}]}], "]"}], ":=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{"\"\<\\!\\(\>\"", ",", 
      RowBox[{"IndexForm", "[", "ind", "]"}], ",", "\"\<\\&\>\"", ",", 
      RowBox[{"PrintAsSmaller", "[", "proj", "]"}], ",", "\"\<\\)\>\""}], 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind_", ",", "Null", ",", 
       RowBox[{"{", 
        RowBox[{"xAct`xTensor`Down", ",", "proj_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"\"\<\\!\\(\>\"", ",", 
       RowBox[{"IndexForm", "[", "ind", "]"}], ",", "\"\<\\+\>\"", ",", 
       RowBox[{"PrintAsSmaller", "[", "proj", "]"}], ",", "\"\<\\)\>\""}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", 
      RowBox[{"ind_", ",", "der_", ",", "pr_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"First", "[", 
       RowBox[{"SymbolOfCovD", "[", "der", "]"}], "]"}], "<>", 
      RowBox[{"IndexForm", "[", 
       RowBox[{"ind", ",", "Null", ",", "pr"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"List", " ", "of", " ", "indices", " ", 
     RowBox[{"(", 
      RowBox[{"with", " ", "head", " ", "IndexList"}], ")"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "list_IndexList", "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"StringJoin", ",", 
       RowBox[{"IndexForm", "/@", "list"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Slots", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_Slot", "]"}], ":=", 
     RowBox[{"ToString", "[", "ind", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "ind_SlotSequence", "]"}], ":=", 
     RowBox[{"ToString", "[", "ind", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Any", " ", "other", " ", "case"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexForm", "[", "x_", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"IndexForm", "::", "nouse"}], ",", "\"\<IndexForm\>\"", ",", 
         
         RowBox[{"ToString", "[", "x", "]"}], ",", "$WarningFrom"}], "]"}], 
       ";", 
       RowBox[{"ToString", "[", "x", "]"}]}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"IndexForm", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "IndexForm", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"008d756e-f63f-4e11-82b7-ad5966e8a0bf"]
}, Closed]],

Cell[CellGroupData[{

Cell["8.1.3. Examples", \
"Subsubsection",ExpressionUUID->"d8e90547-fcfc-4a7c-a2a3-9e2cb006559d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"der\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "der", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"ad8e0252-c1dc-4a35-8031-3bdbd0f8ab5f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b169c9eb-7fc2-4400-8136-3d6f98b7c74a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"IndexForm", "[", "i", "]"}], "//", 
  "FullForm"}]], \
"Input",ExpressionUUID->"bbe98c0d-c62d-48b4-bd45-ba9c0368bf4f"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<i\>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"8f158ff9-9da5-4f51-b2a0-6baa6083e835"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", "i_", 
  "]"}]], "Input",ExpressionUUID->"068d8f9d-710f-40d4-ba2d-5c7e70d27909"],

Cell[BoxData["\<\"\\!\\(i\\+_\\)\"\>"], \
"Output",ExpressionUUID->"ba620f38-522d-4c11-a43c-15b9b8f08ba3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"i_", "?", "M3`Q"}], 
  "]"}]], "Input",ExpressionUUID->"7a1040b2-e455-4e9b-b236-b24026a57198"],

Cell[BoxData["\<\"\\!\\(\\!\\(i\\+_\\)\\+_\\)\"\>"], \
"Output",ExpressionUUID->"2eb56670-2217-4685-8bf9-94ad7de347b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"a", "+", "b"}], 
  "]"}]], "Input",ExpressionUUID->"c8cddf8c-efaa-428d-a60d-f2d09148451b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"IndexForm", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \
\[NoBreak]\\!\\(\\\"IndexForm\\\"\\)\[NoBreak] on \[NoBreak]\\!\\(\\\"a + b\\\
\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"75639296-37e4-459f-8f91-f50b26e8873e"],

Cell[BoxData["\<\"a + b\"\>"], \
"Output",ExpressionUUID->"1c6fd755-a637-4448-b628-8a34353337a9"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", 
    RowBox[{"-", "basis_"}], "]"}], "=", 
   RowBox[{"xAct`xCoba`BasisColor", "[", "basis", "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"7abf3ba9-9ff9-4942-a898-2b45c90a1b87"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "polar"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"fb6703ac-8473-411e-9a09-580b0fa46072"],

Cell[BoxData["\<\"\\!\\(\\*StyleBox[\\\"1\\\",FontColor->RGBColor[1., 0., \
0.]]\\)\"\>"], "Output",ExpressionUUID->"1d5277bd-73d2-4011-a4ed-2bc51a26aaf1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"{", 
   RowBox[{"A", ",", "polar"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"c1f120b5-749e-41ef-a725-0c443e645822"],

Cell[BoxData["\<\"\\!\\(\\*StyleBox[\\\"A\\\",FontColor->RGBColor[1., 0., \
0.]]\\)\"\>"], "Output",ExpressionUUID->"f0069255-1c37-41be-b290-248486124e49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"{", 
   RowBox[{"A\[Dagger]", ",", "polar"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"58f20579-d400-4cdd-9c4d-fef39e1cd9fa"],

Cell[BoxData["\<\"\\!\\(\\*StyleBox[\\\"A\[Dagger]\\\",FontColor->RGBColor[1.,\
 0., 0.]]\\)\"\>"], \
"Output",ExpressionUUID->"0f8bf4c0-64e2-4e2f-b57a-aacb702f1a5a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"Dir", "[", 
   RowBox[{"a", "+", "b", "+", "c"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"f9c1e3b9-d53a-4048-ab4e-0b2f6d836986"],

Cell[BoxData["\<\"#\"\>"], \
"Output",ExpressionUUID->"3cf42803-23f2-482e-8c5c-f10ac60cfd6b"]
}, Open  ]],

Cell["Check of CIndexForm:", \
"Text",ExpressionUUID->"cd4ee3f4-c8a0-408f-b83e-0973d580ada3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CIndexForm", "=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"8d06c5ea-05a6-4540-8e17-c0e0fb4095ee"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChartQ", "[", "polar", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`Coordinate", "[", 
    RowBox[{"1", ",", "polar"}], "]"}], "=", "\"\<h\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"edfd8e82-d271-4c33-8046-da8dac03fe0e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexForm", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "polar"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"a07dc363-f13b-4fb7-814e-4e2cea3f93ac"],

Cell[BoxData["\<\"\\!\\(\\*StyleBox[\\\"h\\\",FontColor->RGBColor[1., 0., \
0.]]\\)\"\>"], "Output",ExpressionUUID->"a167a94b-b958-426d-899d-d54e1d3bd8d0"]
}, Open  ]],

Cell["Clear up:", \
"Text",ExpressionUUID->"c368efa6-4fb2-467a-be1f-cf0db0b1e60a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xAct`xCoba`Coordinate", "[", 
   RowBox[{"1", ",", "polar"}], "]"}], 
  "=."}]], "Input",ExpressionUUID->"8f69feb8-efdc-4c07-a1d4-08d6cfe3b43c"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"polar", ",", "A\[Dagger]", ",", "basis"}], 
  "]"}]], "Input",ExpressionUUID->"c842347f-6ad2-4e75-8530-24af6e9a3bf8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CIndexForm", "=", "False"}], 
  ";"}]], "Input",ExpressionUUID->"543bd5fb-2d00-46f3-808d-5f9c4fb11e34"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "A", ",", "b", ",", "c", ",", "i"}], 
  "]"}]], "Input",ExpressionUUID->"98cb92d1-3330-4ccd-8f83-33d2be955886"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0bdd4667-d30c-445f-b793-aec8d5d3b444"]
}, Closed]],

Cell[CellGroupData[{

Cell["8.1.4. Special formattings", \
"Subsubsection",ExpressionUUID->"0ea967f7-892b-4422-a4bf-abea1eaff1e6"],

Cell["\<\
This function has been provided by Thomas, to have daggered indices formatted \
with primes instead of daggers, using SetOptions[DefAbstractIndex, PrintAs -> \
PrimeDagger]:\
\>", "Text",ExpressionUUID->"554d1e67-bfa8-4a4e-a060-13192c0bbbc1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrimeDagger", "[", "ind_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"DaggerIndexQ", "@", "ind"}], ",", 
     RowBox[{"StringJoin", "[", 
      RowBox[{
       RowBox[{"StringDrop", "[", 
        RowBox[{
         RowBox[{"ToString", "@", "ind"}], ",", 
         RowBox[{"-", 
          RowBox[{"StringLength", "@", "$DaggerCharacter"}]}]}], "]"}], ",", 
       "\"\<'\>\""}], "]"}], ",", "ind"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ec1b1969-aef6-4e65-9a0c-4078fbb11e54"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["8.2. Formatting of a sequence of indices", \
"Subsection",ExpressionUUID->"5cc3ccd3-1f97-4561-a93c-c10ea67a970d"],

Cell[CellGroupData[{

Cell["8.2.1. IndexPair", \
"Subsubsection",ExpressionUUID->"85bbd888-6034-4c48-b72c-2a6bccf56456"],

Cell["\<\
This function controls the horizontal space that is given to each index: one \
space to normal indices and two spaces to derivatives (Postfix) indices. It \
uses UpIndex, what could be a source of problems (that is why we mark the \
$WarningFrom global variable). The pair IndexPair / UpIndexPair is introduced \
to avoid using UpIndex twice:\
\>", "Text",ExpressionUUID->"25e38864-1162-4d97-a9bf-d71e35812e31"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndexPair", "[", 
     RowBox[{"ind_", ",", "other___"}], "]"}], ":=", 
    RowBox[{"Block", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"$WarningFrom", "=", "\"\<Index Formatting\>\""}], "}"}], ",", 
      
      RowBox[{"UpIndexPair", "[", 
       RowBox[{"ind", ",", 
        RowBox[{"UpIndex", "[", "ind", "]"}], ",", "other"}], "]"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Standard", " ", "index"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpIndexPair", "[", 
    RowBox[{"upind_", ",", "upind_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"blanks", "[", 
      RowBox[{"IndexLength", "[", "upind", "]"}], "]"}], ",", 
     RowBox[{"IndexForm", "[", "upind", "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UpIndexPair", "[", 
     RowBox[{"downind_", ",", "upind_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"IndexForm", "[", "upind", "]"}], ",", 
      RowBox[{"blanks", "[", 
       RowBox[{"IndexLength", "[", "upind", "]"}], "]"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Derivative", " ", "index", " ", "in", " ", "Postfix", " ", "notation"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpIndexPair", "[", 
    RowBox[{"upind_", ",", "upind_", ",", "der_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"blanks", "[", 
      RowBox[{"IndexLength", "[", 
       RowBox[{"upind", ",", "der"}], "]"}], "]"}], ",", 
     RowBox[{"IndexForm", "[", 
      RowBox[{"upind", ",", "der"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UpIndexPair", "[", 
     RowBox[{"downind_", ",", "upind_", ",", "der_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"IndexForm", "[", 
       RowBox[{"upind", ",", "der"}], "]"}], ",", 
      RowBox[{"blanks", "[", 
       RowBox[{"IndexLength", "[", 
        RowBox[{"upind", ",", "der"}], "]"}], "]"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Projected", " ", "index"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$ProjectedFormat", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpIndexPair", "[", 
    RowBox[{"upind_", ",", "upind_", ",", "der_", ",", "proj_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"$ProjectedFormat", "||", 
      RowBox[{"proj", "===", "delta"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"blanks", "[", 
        RowBox[{"IndexLength", "[", 
         RowBox[{"upind", ",", "der"}], "]"}], "]"}], ",", 
       RowBox[{"IndexForm", "[", 
        RowBox[{"upind", ",", "der", ",", 
         RowBox[{"{", 
          RowBox[{"xAct`xTensor`Up", ",", "proj"}], "}"}]}], "]"}]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ColorString", "[", 
        RowBox[{
         RowBox[{"PrintAs", "[", "proj", "]"}], ",", 
         RowBox[{"GrayLevel", "[", "0.6", "]"}]}], "]"}], ",", 
       RowBox[{"IndexForm", "[", 
        RowBox[{"upind", ",", "der"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UpIndexPair", "[", 
     RowBox[{"downind_", ",", "upind_", ",", "der_", ",", "proj_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"$ProjectedFormat", "||", 
       RowBox[{"proj", "===", "delta"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"IndexForm", "[", 
         RowBox[{"upind", ",", "der", ",", 
          RowBox[{"{", 
           RowBox[{"xAct`xTensor`Down", ",", "proj"}], "}"}]}], "]"}], ",", 
        RowBox[{"blanks", "[", 
         RowBox[{"IndexLength", "[", 
          RowBox[{"upind", ",", "der"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"IndexForm", "[", 
         RowBox[{"upind", ",", "der"}], "]"}], ",", 
        RowBox[{"ColorString", "[", 
         RowBox[{
          RowBox[{"PrintAs", "[", "proj", "]"}], ",", 
          RowBox[{"GrayLevel", "[", "0.6", "]"}]}], "]"}]}], "}"}]}], "]"}]}],
    ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Printing", " ", "length", " ", "of", " ", "an", " ", "index"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexLength", "[", "upind_BlankSequence", "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndexLength", "[", "upind_BlankNullSequence", "]"}], ":=", "1"}],
    ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "This", " ", "is", " ", "inconvenient", " ", "with", " ", "indices", " ", 
     "containing", " ", "linear", " ", "syntax"}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
      "like", " ", "pullback", " ", "indices", "\[IndentingNewLine]", 
       RowBox[{"IndexLength", "[", "upind_", "]"}]}], ":=", 
      RowBox[{"Length", "@", 
       RowBox[{"Characters", "@", 
        RowBox[{"ToString", "@", 
         RowBox[{"PrintAs", "@", 
          RowBox[{"IndexName", "[", "upind", "]"}]}]}]}]}]}], ";"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexLength", "[", "upind_", "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IndexLength", "[", 
     RowBox[{"upind_", ",", "Null"}], "]"}], ":=", 
    RowBox[{"IndexLength", "[", "upind", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"This", " ", "is", " ", "inconvenient", " ", "with", " ", 
     RowBox[{"StyleBox", "[", "...", "]"}], "\[IndentingNewLine]", 
     RowBox[{"DerSymbolLength", "[", "symbol_String", "]"}]}], ":=", 
    RowBox[{"Length", "@", 
     RowBox[{"Characters", "[", "symbol", "]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DerSymbolLength", "[", "symbol_String", "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexLength", "[", 
    RowBox[{"upind_", ",", "der_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"IndexLength", "[", "upind", "]"}], "+", 
    RowBox[{"DerSymbolLength", "[", 
     RowBox[{"First", "@", 
      RowBox[{"SymbolOfCovD", "[", "der", "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"blanks", "[", "length_", "]"}], ":=", 
   RowBox[{"StringJoin", "@@", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "length", "}"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "New", " ", "simpler", " ", "formatting", "\[IndentingNewLine]", 
      RowBox[{"blanks", "[", "__", "]"}]}], ":=", "\"\< \>\""}], ";"}], 
   "\[IndentingNewLine]", "*)"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e787694c-9f04-481c-8cc5-d5043d1a629c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["8.2.2. AddIndex", \
"Subsubsection",ExpressionUUID->"ff36c831-c411-4151-a121-0268e3891d10"],

Cell["\<\
The function AddIndex gets the couple {downstring,upstring} and adds an index \
to the corresponding string and space(s) to the other.\
\>", "Text",ExpressionUUID->"bc3c0134-df23-4647-8584-8ba8e47da71c"],

Cell["\<\
Special case for multiple-index derivatives. Put derivative sign together \
with the first index only :\
\>", "Text",ExpressionUUID->"38225fc2-2a01-47fd-9d10-b1f0d71f2433"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddIndex", "[", 
    RowBox[{"strings_List", ",", 
     RowBox[{"IndexList", "[", 
      RowBox[{"a_", ",", "b___"}], "]"}], ",", "der_"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"AddIndex", ",", 
     RowBox[{"AddIndex", "[", 
      RowBox[{"strings", ",", "a", ",", "der"}], "]"}], ",", 
     RowBox[{"IndexList", "[", "b", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8dc69141-b172-4313-8e30-c0dd2ff85407"],

Cell["General case:", \
"Text",ExpressionUUID->"8e9f03b2-3431-47ec-a89f-d418827c7f8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddIndex", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"downstring_String", ",", "upstring_String"}], "}"}], ",", 
     "ind__"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"downstring", "<>", "#1"}], ",", 
       RowBox[{"upstring", "<>", "#2"}]}], "}"}], "&"}], "@@", 
    RowBox[{"IndexPair", "[", "ind", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8deac69d-f65f-4512-a663-cbc47d8933b3"]
}, Closed]],

Cell[CellGroupData[{

Cell["8.2.3. Examples", \
"Subsubsection",ExpressionUUID->"17cc2504-1fd7-4396-8511-8c713a507251"],

Cell["Examples:", \
"Text",ExpressionUUID->"0e23e75b-41f5-4026-bad0-516aa325111b"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"732ab937-d5f2-4406-9151-6889582f8ea7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPair", "[", "A", 
  "]"}]], "Input",ExpressionUUID->"cda7f291-35d2-4d99-8c19-f843e41a9438"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\" \"\>", ",", "\<\"A\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"bb46affa-3041-4d9a-a37f-20014b84a9cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPair", "[", 
  RowBox[{"-", "A"}], 
  "]"}]], "Input",ExpressionUUID->"fab278c2-c395-4cbc-8073-9e10e47bd076"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A\"\>", ",", "\<\" \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"06d60deb-22f8-4a5f-8172-b3b2566df798"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPair", "[", "A$10", 
  "]"}]], "Input",ExpressionUUID->"b2a928b8-bf46-4512-933b-7eccf6e08bd1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\" \"\>", ",", "\<\"A$10\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"c9b566c7-56ae-447f-82fa-46be0479bedf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPair", "[", 
  RowBox[{"-", "A$10"}], 
  "]"}]], "Input",ExpressionUUID->"5c3f4ff7-a8a9-4115-bae3-a229b50dfcbe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A$10\"\>", ",", "\<\" \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"62cd92e8-8e0a-405b-9068-84eddbf04dd4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`IndexPair", "[", 
  RowBox[{"-", "C_"}], 
  "]"}]], "Input",ExpressionUUID->"a7a9b0a6-bdae-4940-863f-2ff55ed30ff0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"\\!\\(C\\+_\\)\"\>", ",", "\<\" \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"6c294f2a-2e9e-4a99-98d2-30e4b7894d4c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A \>\"", ",", "\"\< B\>\""}], "}"}], ",", 
   RowBox[{"-", "C_"}]}], 
  "]"}]], "Input",ExpressionUUID->"dfa50fe4-8979-476e-9775-a23ee9140880"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A \\!\\(C\\+_\\)\"\>", ",", "\<\" B \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"0a2df46e-0b94-4a25-ae3c-9f7b44c23654"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A \>\"", ",", "\"\< B\>\""}], "}"}], ",", 
   RowBox[{"-", "C_"}]}], 
  "]"}]], "Input",ExpressionUUID->"9eab552c-b563-4cf4-a7a1-f414abbcc625"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A \\!\\(C\\+_\\)\"\>", ",", "\<\" B \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"93c5847a-e84c-4fb6-a00a-d1c4580bafc6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"8d910a58-494f-43da-ac43-aff99c6184bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A  \>\"", ",", "\"\< BC\>\""}], "}"}], ",", "D_", ",", 
   "Cd"}], "]"}]], \
"Input",ExpressionUUID->"0ce06982-c2c6-485a-9ec3-6f514c49569a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A    \"\>", ",", "\<\" BC;\\!\\(D\\+_\\)\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"165ed7cf-5d3b-4300-8586-c8aa307eef7d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"194406c0-24bc-41e7-b32d-4adb42add66b"],

Cell["{\"A    \", \" BC;\\!\\(D\\+_\\)\"}", \
"Output",ExpressionUUID->"8b53b920-fae6-4278-a8b7-47439e56de7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A  \>\"", ",", "\"\< BC\>\""}], "}"}], ",", "D_", ",", 
   "Cd"}], "]"}]], \
"Input",ExpressionUUID->"61905a90-fe43-4300-b372-c61c6476c1aa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A    \"\>", ",", "\<\" BC;\\!\\(D\\+_\\)\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"43ebd4f7-02c3-4196-9666-c8430bdb101e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"48807aea-4447-4e35-9f24-7931ca9ffbde"],

Cell["{\"A    \", \" BC;\\!\\(D\\+_\\)\"}", \
"Output",ExpressionUUID->"d930364a-1b1a-42bc-ada4-03a595472e70"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A  \>\"", ",", "\"\< BC\>\""}], "}"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"D", ",", "F", ",", "G"}], "]"}], ",", "Cd"}], 
  "]"}]], "Input",ExpressionUUID->"ed3e8d82-3463-4ca6-8eec-fdd2a35b69fa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A      \"\>", ",", "\<\" BC;DFG\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"d4628128-859e-493d-baab-2179283c0584"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", "Null"}], 
  ";"}]], "Input",ExpressionUUID->"64583f5f-dc54-4648-8430-158e790e3950"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "v", "]"}], "^=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"30238950-45ab-4d7b-960b-29f8a6737ef0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A \>\"", ",", "\"\< B\>\""}], "}"}], ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"v", "[", "A", "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8736163f-5b35-49ad-a7b5-98755e7b6f7e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A v\"\>", ",", "\<\" B \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"85af78db-4549-4dd4-b451-c6aa786ab355"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A \>\"", ",", "\"\< B\>\""}], "}"}], ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"12809ae8-e655-4aae-be93-09bbdbd0ba59"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A  \"\>", ",", "\<\" Bv\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"38daa32b-813e-412c-b984-c6d65f206c52"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ColorString", "[", 
     RowBox[{"\"\<\[Cedilla]\>\"", ",", 
      RowBox[{"Hue", "[", "0", "]"}]}], "]"}], ",", 
    RowBox[{"ColorString", "[", 
     RowBox[{"\"\<\[EmptyDownTriangle]\>\"", ",", 
      RowBox[{"Hue", "[", "0", "]"}]}], "]"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"7291cb2d-a40b-4864-9e68-200a6eca0cba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"\\!\\(\\*StyleBox[\\\"\[Cedilla]\\\",FontColor->Hue[0.]]\\)\"\>\
", ",", "\<\"\\!\\(\\*StyleBox[\\\"\[EmptyDownTriangle]\\\",FontColor->Hue[0.]\
]\\)\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"5f5d6615-4569-4ee8-b708-640e40d470d0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"d4aa6c9a-3cb2-4028-95e7-6760aaac7864"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A \>\"", ",", "\"\< B\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"C", ",", "polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"f798c107-cf9d-4b03-b9ce-0212a121ec25"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A  \"\>", 
   ",", "\<\" B\\!\\(\\*StyleBox[\\\"C\\\",FontColor->RGBColor[0., 1., \
0.]]\\)\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"b521104f-b5a7-4889-8ea0-bd2f275a3ab4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A \>\"", ",", "\"\< B\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "polar"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a520186b-0511-4cd7-8c7a-540a40839a81"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A \\!\\(\\*StyleBox[\\\"2\\\",FontColor->RGBColor[0., 1., 0.]]\
\\)\"\>", ",", "\<\" B \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"1be81a33-ee01-4467-8d3e-69fff1e50176"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A  \>\"", ",", "\"\< BC\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"D", ",", "polar"}], "}"}], ",", "Cd"}], 
  "]"}]], "Input",ExpressionUUID->"0d133f6a-3084-40bc-ad30-566ebf8bb824"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A    \"\>", 
   ",", "\<\" \
BC\\!\\(\\*StyleBox[\\\"\[Cedilla]\\\",FontColor->Hue[0.]]\\)\\!\\(\\*\
StyleBox[\\\"D\\\",FontColor->RGBColor[0., 1., 0.]]\\)\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"c0ad8a04-a338-4c5c-b15f-6df3c2d46ed7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`AddIndex", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A  \>\"", ",", "\"\< BC\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"D_", ",", "polar"}], "}"}], ",", "Cd"}], 
  "]"}]], "Input",ExpressionUUID->"86297f1d-6035-419a-af68-d286e72ae47c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A    \"\>", 
   ",", "\<\" \
BC\\!\\(\\*StyleBox[\\\"\[Cedilla]\\\",FontColor->Hue[0.]]\\)\\!\\(\\*\
StyleBox[\\\"\\!\\(D\\+_\\)\\\",FontColor->RGBColor[0., 1., 0.]]\\)\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"d0ea91b4-769b-472a-b105-f019d7fcbcef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Remove", "[", 
  RowBox[{"polar", ",", "Cd", ",", "v", ",", "A$10", ",", "F", ",", "G"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"EndExamples", "[", 
  "]"}]}], "Input",ExpressionUUID->"965c84cb-ba12-468e-83c2-a3797b7a7161"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"A\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"A"}],
  Editable->
   False]], "Print",ExpressionUUID->"5d9a17d5-7181-403e-be55-a5fe5a5387eb"]
}, Open  ]],

Cell["\<\
In summary, the only problem that (I think) there could be here is a problem \
coming from UpIndex/DownIndex acting on patterns without a definite height \
(for instance x_); we issue a warning in that case.\
\>", "Text",ExpressionUUID->"280a74a2-8315-4b33-b99b-512aa92ac1be"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["8.3. Screening of dollar-indices", \
"Subsection",ExpressionUUID->"81e2ecf3-92a6-4ace-a6d1-b16c2c3fac25"],

Cell[CellGroupData[{

Cell["8.3.1. Definitions", \
"Subsubsection",ExpressionUUID->"6f81b425-7874-426a-b72e-4d5a481d2600"],

Cell["\<\
Indices do not change their up/down character.

We separate the process in several steps. This should be simplified somehow:\
\>", "Text",ExpressionUUID->"ae389c83-1506-4b83-ade3-26eb9d2b7848"],

Cell["\<\
1. This function gives all indices (actually their names) involved in the \
original expression, after eliminating their up/down character and their \
Pattern character. We eliminate labels, blanks, integer-basis indices and \
directions (g-indices with name 0). All other indices must be kept in order \
to make sure that we do not introduce new indices with names already in use. \
Note that the argument has a BlankSequence. This is to make sure that the \
same dollar-index in different expressions is mapped to the same index. \
Expressions are held. Indices are sorted lexicographically (using Sort \
through Union). Flatten is there to eliminate braces in {exprs}. IndexName \
gives only 0s and symbols or -symbols; then the 0s are deleted and therefore \
there are no problems using UpIndex. Recall that IndexName on {a,basis} gives \
a: and on a_ gives a.\
\>", "Text",ExpressionUUID->"78938b5e-5f3e-4e96-8c42-d9d17c4fbdd3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"screenindices", ",", "HoldAll"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"screenindices", "[", "exprs__", "]"}], ":=", 
  RowBox[{"Union", "[", 
   RowBox[{"UpIndex", "/@", 
    RowBox[{"DeleteCases", "[", 
     RowBox[{
      RowBox[{"IndexName", "/@", 
       RowBox[{"Join", "@@", 
        RowBox[{"(", 
         RowBox[{"FindIndices", "/@", 
          RowBox[{"Unevaluated", "[", 
           RowBox[{"{", "exprs", "}"}], "]"}]}], ")"}]}]}], ",", "0"}], 
     "]"}]}], "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"45ccde6e-b14c-40b5-896e-73bef13f1a72"],

Cell["\<\
2. This function gives the replacing rules for the dollar-indices of the \
list, both up/down cases. At this point we assume that the list of indices \
only contains abstract up-indices (no patterns, basis indices, labels or \
directions) and therefore there are no problems coming from DollarQ. This \
function is highly recursive. Probably it can be rewritten without recursion.\
\
\>", "Text",ExpressionUUID->"871541fc-6c25-4289-9578-dd6c4a749b4b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"screenrules", "[", "indices_IndexList", "]"}], ":=", 
   RowBox[{"screenrules", "[", 
    RowBox[{"indices", ",", 
     RowBox[{"Select", "[", 
      RowBox[{"indices", ",", "DollarQ"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"screenrules", "[", 
    RowBox[{"indices_", ",", "dollarindices_"}], "]"}], ":=", 
   RowBox[{"screenrules", "[", 
    RowBox[{
     RowBox[{"Complement", "[", 
      RowBox[{"indices", ",", "dollarindices"}], "]"}], ",", "dollarindices", 
     ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"screenrules", "[", 
    RowBox[{"used_", ",", 
     RowBox[{"IndexList", "[", "]"}], ",", "rules_"}], "]"}], ":=", "rules"}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"getindex", "[", 
    RowBox[{"index_", ",", "used_"}], "]"}], ":=", 
   RowBox[{"First", "@", 
    RowBox[{"GetIndicesOfVBundle", "[", 
     RowBox[{
      RowBox[{"VBundleOfIndex", "[", "index", "]"}], ",", "1", ",", 
      RowBox[{"List", "@@", "used"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"screenrules", "[", 
    RowBox[{"used_", ",", 
     RowBox[{"IndexList", "[", 
      RowBox[{"index_", ",", "indices___"}], "]"}], ",", "rules_"}], "]"}], ":=", 
   RowBox[{"screenrules", "[", 
    RowBox[{"used", ",", 
     RowBox[{"IndexList", "[", "indices", "]"}], ",", "rules", ",", "index", 
     ",", 
     RowBox[{"getindex", "[", 
      RowBox[{"index", ",", "used"}], "]"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"screenrules", "[", 
    RowBox[{
    "used_", ",", "indices_", ",", "rules_", ",", "index_", ",", 
     "newindex_"}], "]"}], ":=", 
   RowBox[{"screenrules", "[", 
    RowBox[{
     RowBox[{"Append", "[", 
      RowBox[{"used", ",", "newindex"}], "]"}], ",", "indices", ",", 
     RowBox[{"Join", "[", 
      RowBox[{"rules", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"index", "\[Rule]", "newindex"}], ",", 
         RowBox[{
          RowBox[{"-", "index"}], "\[Rule]", 
          RowBox[{"-", "newindex"}]}]}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"15ce6313-b27b-4793-b07c-ea08d121acd1"],

Cell["\<\
3. Recursion on isolated expressions  (QUESTION: what can we do with the \
ScalarFunctions?):\
\>", "Text",ExpressionUUID->"a3519414-2648-4471-82c6-8d0c5355f401"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MapOnIsolated", "[", 
    RowBox[{"expr_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"EvaluateHeld", "[", 
    RowBox[{
     RowBox[{"EvaluateHeld", "[", 
      RowBox[{
       RowBox[{"RecursiveIsolated", "[", 
        RowBox[{"expr", ",", "f"}], "]"}], ",", "RecursiveIsolated"}], "]"}], 
     ",", "f"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"51167576-1767-495d-b9bb-a06082a403e6"],

Cell["\<\
The Unevalutated here is useless because the expression has been already \
evaluated by RecursiveIsolated.\
\>", "Text",ExpressionUUID->"83aa43a3-134b-47db-b63f-d320a0a0d341"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RecursiveIsolated", "[", 
    RowBox[{"expr_", ",", "f_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Unevaluated", "[", "expr", "]"}], "/.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "x_", "]"}], "\[RuleDelayed]", 
       
       RowBox[{
        RowBox[{"LieD", "[", 
         RowBox[{"RecursiveIsolated", "[", 
          RowBox[{
           RowBox[{"f", "[", "v", "]"}], ",", "f"}], "]"}], "]"}], "[", 
        RowBox[{"RecursiveIsolated", "[", 
         RowBox[{"x", ",", "f"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"Scalar", "[", "v_", "]"}], "\[RuleDelayed]", 
       RowBox[{"Scalar", "[", 
        RowBox[{"RecursiveIsolated", "[", 
         RowBox[{
          RowBox[{"f", "[", "v", "]"}], ",", "f"}], "]"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Dir", "[", "v_", "]"}], "\[RuleDelayed]", 
       RowBox[{"Dir", "[", 
        RowBox[{"RecursiveIsolated", "[", 
         RowBox[{
          RowBox[{"f", "[", "v", "]"}], ",", "f"}], "]"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Bracket", "[", 
        RowBox[{"v1_", ",", "v2_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"Bracket", "[", 
        RowBox[{
         RowBox[{"RecursiveIsolated", "[", 
          RowBox[{
           RowBox[{"f", "[", "v1", "]"}], ",", "f"}], "]"}], ",", 
         RowBox[{"RecursiveIsolated", "[", 
          RowBox[{
           RowBox[{"f", "[", "v2", "]"}], ",", "f"}], "]"}]}], "]"}]}]}], 
     "}"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"68521459-03da-4a36-ae92-1ca65f258c80"],

Cell["\<\
It might happen that the mapped function f gets into some held arguments and \
does not evaluate. We force evaluation with the function\
\>", "Text",ExpressionUUID->"5bbf57b8-14e4-4e91-b4a7-2390b324da08"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EvaluateHeld", "[", 
    RowBox[{"expr_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"xEvaluateAt", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{"#", ",", 
         RowBox[{"-", "1"}]}], "]"}], "&"}], "/@", 
      RowBox[{"Position", "[", 
       RowBox[{"expr", ",", "f"}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4ad9e953-3546-40ac-b057-9c567094b5fd"],

Cell["\<\
A similar function to collect all isolated expressions (again, not arguments \
of ScalarFunctions). Using the argument f we can avoid evaluation:\
\>", "Text",ExpressionUUID->"eb79bf4c-a0dd-4161-8014-22984fb6aaff"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ExtractIsolated", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtractIsolated", "[", 
    RowBox[{"expr_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"ExtractIsolated", "[", 
      RowBox[{"expr", ",", "f", ",", "LieD"}], "]"}], ",", 
     RowBox[{"ExtractIsolated", "[", 
      RowBox[{"expr", ",", "f", ",", "Dir"}], "]"}], ",", 
     RowBox[{"ExtractIsolated", "[", 
      RowBox[{"expr", ",", "f", ",", "Scalar"}], "]"}], ",", 
     RowBox[{"ExtractIsolated", "[", 
      RowBox[{"expr", ",", "f", ",", "Bracket"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"next", "[", 
    RowBox[{"{", 
     RowBox[{"list___", ",", "0"}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"list", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtractIsolated", "[", 
    RowBox[{"expr_", ",", "f_", ",", 
     RowBox[{"head", ":", 
      RowBox[{"(", 
       RowBox[{"LieD", "|", "Dir", "|", "Scalar"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Extract", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "expr", "]"}], ",", 
     RowBox[{"next", "/@", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"Hold", "[", "expr", "]"}], ",", "head"}], "]"}]}], ",", 
     "f"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"next2", "[", 
    RowBox[{"{", 
     RowBox[{"list___", ",", "0", ",", "0"}], "}"}], "]"}], ":=", 
   RowBox[{"Sequence", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"list", ",", "0", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtractIsolated", "[", 
    RowBox[{"expr_", ",", "f_", ",", "Bracket"}], "]"}], ":=", 
   RowBox[{"Extract", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "expr", "]"}], ",", 
     RowBox[{"next2", "/@", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"Hold", "[", "expr", "]"}], ",", "Bracket"}], "]"}]}], ",", 
     "f"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4d6ec741-cf1c-4d97-a919-20d95a2d6988"],

Cell["\<\
4. Final function. It is listable and threaded over Plus, to avoid generating \
lots of new indices with long expressions, and also Equal (as required by \
Alfonso). That assumes that free indices are never dollar-indices!\
\>", "Text",ExpressionUUID->"6ddcf077-2823-404f-94ac-675ea33bc76d"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ScreenDollarIndices", ",", "Listable"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"afbbf1c3-c8cf-4ac8-b94c-8fb01828945a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ScreenDollarIndices", "[", "ScreenDollarIndices", "]"}], ":=", 
   "ScreenDollarIndices"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dd07ea5e-54c9-46e1-a004-c7cb84aa6011"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ScreenDollarIndices", "[", 
    RowBox[{"InformationData", "[", 
     RowBox[{"assoc_", ",", "rest___"}], "]"}], "]"}], ":=", 
   RowBox[{"InformationData", "[", 
    RowBox[{
     RowBox[{"ScreenDollarIndices", "[", "assoc", "]"}], ",", "rest"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a9bf772e-c55b-4d9f-9925-f6afc67ec68d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ScreenDollarIndices", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"ScreenDollarIndices", "/@", "expr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ScreenDollarIndices", "[", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], "]"}], 
     "]"}], "]"}], ":=", 
   RowBox[{"SeriesData", "[", 
    RowBox[{
     RowBox[{"ScreenDollarIndices", "[", "var", "]"}], ",", 
     RowBox[{"ScreenDollarIndices", "[", "orig", "]"}], ",", 
     RowBox[{"ScreenDollarIndices", "/@", "coeffs"}], ",", "rest"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ScreenDollarIndices", "[", 
    RowBox[{"Equal", "[", 
     RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
   RowBox[{"Equal", "[", 
    RowBox[{
     RowBox[{"ScreenDollarIndices", "[", "lhs", "]"}], ",", 
     RowBox[{"ScreenDollarIndices", "[", "rhs", "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7e3c0d32-53b2-4b6c-abc5-c7b200aa5403"],

Cell["\<\
We include this particular case to avoid screening of the output of Trace:\
\>", "Text",ExpressionUUID->"6b1e610b-d552-4452-9ed0-0e92d8f69343"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ScreenDollarIndices", "[", "x_HoldForm", "]"}], ":=", 
  "x"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fcf7daa0-31a8-44f1-b5fc-3bca8dec980b"],

Cell["\<\
Note that the argument of ScreenDollarIndices is assumed to be already \
evaluated. Note also that ScreenDollarIndices does not use SameDummies at the \
beginning: it is just a 1-1 translation of dollar-indices to \
nondollar-indices.\
\>", "Text",ExpressionUUID->"1a38cb5d-0c76-41af-8c91-958420b29edb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ScreenDollarIndices", "[", "expr_", "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$WarningFrom", "=", "\"\<ScreenDollarIndices\>\""}], "}"}], 
     ",", 
     RowBox[{"MapOnIsolated", "[", 
      RowBox[{
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"screenrules", "@", 
          RowBox[{"screenindices", "[", "expr", "]"}]}]}], "]"}], ",", 
       "ScreenDollarIndices"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"be4009b0-50b6-4bd4-b3c4-82587affbfdd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ScreenDollarIndices", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "ScreenDollarIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ad78163a-f975-40c9-8303-658b1f0c3a3d"],

Cell["\<\
It is not convenient to set a Hold attribute for ScreenDollarIndices because \
it would not evaluate its argument. ScreenDollarIndices is always used on the \
final (already evaluated) output, and therefore it is reasonable to assume \
that the input cannot be further evaluated.\
\>", "Text",ExpressionUUID->"24660647-c944-47a1-91e8-4fcfce6e30ec"],

Cell["\<\
QUESTION: Is it more natural to assing ScreenDollarIndices to $PrePrint or to \
$PostPrint? Currently we recommend the use of $PrePrint.\
\>", "Text",ExpressionUUID->"bfb53305-1920-403a-a684-1d45808d82fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"3259adcd-84a2-43e8-9136-3e972aeb1dba"],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"ScreenDollarIndices[expr] replaces internal dummies \
(dollar-indices) by new non-dollar dummies for output.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672632-5338953",ExpressionUUID->"1130cd86-e9a0-4af7-9f13-\
ef3002212b35"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ScreenDollarIndices", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"Listable", ",", "Protected"}], "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", "]"}], ":=", 
         RowBox[{"Message", "[", 
          RowBox[{
           StyleBox[
            RowBox[{"ScreenDollarIndices", "::", "argx"}], "MessageName"], 
           ",", "ScreenDollarIndices", ",", "0"}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", "ScreenDollarIndices", "]"}], ":=",
          "ScreenDollarIndices"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", "expr_Plus", "]"}], ":=", 
         RowBox[{"ScreenDollarIndices", "/@", "expr"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", 
          RowBox[{"HoldPattern", "[", 
           RowBox[{"SeriesData", "[", 
            RowBox[{"var_", ",", "orig_", ",", "coeffs_", ",", "rest__"}], 
            "]"}], "]"}], "]"}], ":=", 
         RowBox[{"SeriesData", "[", 
          RowBox[{
           RowBox[{"ScreenDollarIndices", "[", "var", "]"}], ",", 
           RowBox[{"ScreenDollarIndices", "[", "orig", "]"}], ",", 
           RowBox[{"ScreenDollarIndices", "/@", "coeffs"}], ",", "rest"}], 
          "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", 
          RowBox[{"lhs_", "\[Equal]", "rhs_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"ScreenDollarIndices", "[", "lhs", "]"}], "\[Equal]", 
          RowBox[{"ScreenDollarIndices", "[", "rhs", "]"}]}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", 
          RowBox[{"x", ":", 
           RowBox[{"Blank", "[", "\<\"HoldForm\"\>", "]"}]}], "]"}], ":=", 
         "x"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", "expr_", "]"}], ":=", 
         RowBox[{"Block", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"$WarningFrom", "=", "\<\"ScreenDollarIndices\"\>"}], 
            "}"}], ",", 
           RowBox[{"MapOnIsolated", "[", 
            RowBox[{
             RowBox[{"ReplaceIndex", "[", 
              RowBox[{"expr", ",", 
               RowBox[{"screenrules", "[", 
                RowBox[{"screenindices", "[", "expr", "]"}], "]"}]}], "]"}], 
             ",", "ScreenDollarIndices"}], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScreenDollarIndices", "[", 
          RowBox[{"_", ",", "xAct`xCore`Private`x$__"}], "]"}], ":=", 
         RowBox[{"Message", "[", 
          RowBox[{
           StyleBox[
            RowBox[{"ScreenDollarIndices", "::", "argx"}], "MessageName"], 
           ",", "ScreenDollarIndices", ",", 
           RowBox[{"1", "+", 
            RowBox[{"Length", "[", 
             RowBox[{"{", "xAct`xCore`Private`x$", "}"}], "]"}]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[xAct`xTensor`ScreenDollarIndices],
  Editable->False]], "Print",
 CellTags->
  "Info3578672632-5338953",ExpressionUUID->"8673fa80-7a69-4422-b326-\
a8ed472f9f62"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Something which can happen is that after screening of dollar-indices the \
expression can be further evaluated. This is annoying, but I can't help it.\
\>", "Text",ExpressionUUID->"d03294a0-1aa3-4228-8b98-b900bc47f0a8"]
}, Closed]],

Cell[CellGroupData[{

Cell["8.3.2. Examples", \
"Subsubsection",ExpressionUUID->"b7a992d9-d3cc-434c-a184-8d63f8ecbe37"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"05446610-5074-42b8-ba66-6ee9909c6d0e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{
    "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", 
     "J"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"63f77527-ef20-4ec7-bb03-5d2d7687e86d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", "manifold ", $CellContext`M,
    ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d21f5832-dd39-4593-82c3-09dbd1c3e9ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"577126a7-28f9-4ad4-856c-a531969f5d74"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"aeae88ae-aafe-42f5-9dbd-f27c07da9553"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"34d7ff0b-5c41-4c30-b51e-9709efa81bbe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`screenrules", "[", 
  RowBox[{"IndexList", "[", 
   RowBox[{"A", ",", "B", ",", "F$", ",", "H$", ",", "J", ",", "F"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"71e94b42-61ac-4bb7-9de1-c5d7844950ba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"F$", "\[Rule]", "C"}], ",", 
   RowBox[{
    RowBox[{"-", "F$"}], "\[Rule]", 
    RowBox[{"-", "C"}]}], ",", 
   RowBox[{"H$", "\[Rule]", "D"}], ",", 
   RowBox[{
    RowBox[{"-", "H$"}], "\[Rule]", 
    RowBox[{"-", "D"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"ab9496fa-4eef-459e-bf38-9e3050c7ff21"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  "]"}]], "Input",ExpressionUUID->"dfbab40e-b38d-46dd-9e5e-ccb95e65596c"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ScreenDollarIndices", "::", "argx"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ScreenDollarIndices\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; 1 argument is expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argx\\\", \
ButtonNote -> \\\"xAct`xTensor`ScreenDollarIndices::argx\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"37b9e0ea-a009-491d-82c2-66812d474b6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{"1", ",", "2"}], 
  "]"}]], "Input",ExpressionUUID->"f8d91fa9-e717-4482-bd50-7c3fc52fdc39"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ScreenDollarIndices", "::", "argx"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ScreenDollarIndices\\)\[NoBreak] called with \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments; 1 argument is expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argx\\\", \
ButtonNote -> \\\"xAct`xTensor`ScreenDollarIndices::argx\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"35071ba9-db72-41e8-94c0-d97fbb572025"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", "1", 
  "]"}]], "Input",ExpressionUUID->"17ca549d-4772-44db-b37c-8d284b046193"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"fcb7a49e-39e2-43bf-a4e6-1f561da9116a"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "T", "]"}], "^=", "True"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "Cd", "]"}], "^=", "True"}], 
  ";"}]}], "Input",ExpressionUUID->"fc19300b-107c-4214-a35a-8121bf6a6d8e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"MM", ",", "3", ",", 
   RowBox[{"IndexRange", "[", 
    RowBox[{"a", ",", "q"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"f4379911-a25e-4a5b-ac21-41df7617b36a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "MM", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`MM, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5cb5a721-71cc-4988-9ff8-f365058b6341"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentMM", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentMM, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e19c2c5a-8d05-4e4d-b3ed-9fed7d9e95ae"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$AbstractIndices"], \
"Input",ExpressionUUID->"a280e564-167e-4198-8af7-3a0708770ef1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J", 
   ",", "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
   "h", ",", "i", ",", "j", ",", "k", ",", "l", ",", "m", ",", "n", ",", "o", 
   ",", "p", ",", "q"}], 
  "}"}]], "Output",ExpressionUUID->"3c5759ab-e204-4b3f-92b9-a471c2ce7577"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i$", ",", "k$", ",", "l$", ",", 
     RowBox[{"-", "l$"}]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "j$", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"i$", ",", "j$", ",", 
       RowBox[{"-", "j$"}], ",", "k$"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"3e4aa117-73ea-41f6-b239-e557d242d963"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "c", ",", "d", ",", 
    RowBox[{"-", "d"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "b", "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b", ",", 
      RowBox[{"-", "b"}], ",", "c"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"44e2ea1c-a285-4be6-83c9-8ac2866c9156"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"Dir", "[", 
      RowBox[{"T", "[", 
       RowBox[{"i$", ",", 
        RowBox[{"-", "i$"}], ",", "z"}], "]"}], "]"}], ",", "i$", ",", "k$", 
     ",", 
     RowBox[{"{", 
      RowBox[{"l$", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "l$"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "j$", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"i$", ",", 
       RowBox[{"{", 
        RowBox[{"j$", ",", "polar"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "j$"}], ",", 
         RowBox[{"-", "polar"}]}], "}"}], ",", "k$"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"15d5a3dd-ea4f-43e8-a81d-6a3a72c31d9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"Dir", "[", 
     RowBox[{"T", "[", 
      RowBox[{"a", ",", 
       RowBox[{"-", "a"}], ",", "z"}], "]"}], "]"}], ",", "a", ",", "c", ",", 
    
    RowBox[{"{", 
     RowBox[{"d", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "b", "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"a", ",", 
      RowBox[{"{", 
       RowBox[{"b", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "b"}], ",", 
        RowBox[{"-", "polar"}]}], "}"}], ",", "c"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"6798abe4-c1f0-4e58-b8cf-c2869279a537"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i$", ",", "k$", ",", "l$", ",", 
     RowBox[{"-", "l$"}]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "j$", "}"}], ",", 
     RowBox[{
      RowBox[{"LieD", "[", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"z", ",", "a$"}], "]"}], 
        RowBox[{"T", "[", 
         RowBox[{"-", "a$"}], "]"}]}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"i$", ",", "j$", ",", 
        RowBox[{"-", "j$"}], ",", "k$"}], "]"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"45ec9df0-eac6-4250-9252-a31d4354b232"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "c", ",", "d", ",", 
    RowBox[{"-", "d"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "b", "}"}], ",", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"-", "a"}], "]"}], " ", 
       RowBox[{"T", "[", 
        RowBox[{"z", ",", "a"}], "]"}]}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"a", ",", "b", ",", 
       RowBox[{"-", "b"}], ",", "c"}], "]"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"ac3e3e5d-68e5-49de-9f8e-8a81a76428cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"T", "[", 
     RowBox[{"B$1_", ",", 
      RowBox[{"-", "B$1_"}], ",", "B$"}], "]"}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "A$", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"A$", ",", 
       RowBox[{"-", "A$"}], ",", "B$"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"0f797bac-ef3c-409a-8d02-6a9501d20dbe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   RowBox[{"T", "[", 
    RowBox[{"C_", ",", 
     RowBox[{"-", "C_"}], ",", "B"}], "]"}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "A", "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}], ",", "B"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"3052baf7-4db4-4052-9c64-0a5bb3be21e7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"B$1_", ",", "basis_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "B$1_"}], ",", 
        RowBox[{"-", "basis_"}]}], "}"}], ",", "B$"}], "]"}], "]"}], 
   "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "A$", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"A$", ",", 
       RowBox[{"-", "A$"}], ",", "B$"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"359f3ed5-ca2f-49f6-b59c-09494f04941f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"C_", ",", "basis_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "C_"}], ",", 
       RowBox[{"-", "basis_"}]}], "}"}], ",", "B"}], "]"}], "]"}], 
  "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "A", "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}], ",", "B"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"91fef975-c5c7-4fbd-a064-7dac38e5eca7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"T", "[", 
     RowBox[{"i$", ",", "k$", ",", "l$", ",", 
      RowBox[{"-", "l$"}]}], "]"}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "j$", "}"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"i$", ",", "j$", ",", 
       RowBox[{"-", "j$"}], ",", "k$"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b8c6e1ba-9672-4c5b-8d48-a1b5714fac3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", 
     RowBox[{"-", "d"}]}], "]"}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "b", "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"a", ",", "b", ",", 
      RowBox[{"-", "b"}], ",", "c"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"a8668c18-9738-4126-af6a-a8cbd2049ed7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i$", ",", "k$", ",", "l$", ",", 
     RowBox[{"-", "l$"}]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"ReplaceDummies", "[", 
    RowBox[{"T", "[", 
     RowBox[{"i$", ",", "j$", ",", 
      RowBox[{"-", "j$"}], ",", "k$"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"960bcf70-a349-479a-a481-49da02fcaf86"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "c", ",", "d", ",", 
    RowBox[{"-", "d"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"ReplaceDummies", "[", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b", ",", 
     RowBox[{"-", "b"}], ",", "c"}], "]"}], 
   "]"}]}]], "Output",ExpressionUUID->"7354b3ff-8c52-42f8-9116-28c8f46f1737"]
}, Open  ]],

Cell["\<\
Note that the new indices in the first and second elements are completely \
independent:\
\>", "Text",ExpressionUUID->"4c037766-5ab6-43f8-bfce-198c0ff95ac0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "f$"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B$101", ",", 
       RowBox[{"-", "A$1"}], ",", 
       RowBox[{"-", "A$0"}], ",", "a$", ",", "b", ",", "c$"}], "]"}], "]"}], 
    ",", 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "f$"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A$1"}], ",", 
       RowBox[{"-", "A$2"}], ",", 
       RowBox[{"-", "B$"}]}], "]"}], "]"}]}], "}"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"9069afcb-e540-48be-bab5-2937bf36a174"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "d"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"C", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "A"}], ",", "a", ",", "b", ",", "c"}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "a"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"96bf57e4-f201-4da9-8bf5-5f18c8f1c3b5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RuleDelayed", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B101", ",", "a", ",", "c$", ",", 
      RowBox[{"-", "c$"}], ",", 
      RowBox[{"-", "a"}]}], "]"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"C$", ",", "D$"}], "}"}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"B101", ",", 
        RowBox[{"-", "D$"}], ",", 
        RowBox[{"-", "C$"}], ",", "D$", ",", "C$"}], "]"}]}], "]"}]}], "]"}], 
  "//", "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"044d4f54-8566-4637-afed-5e9b3d7d7188"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"B101", ",", "a", ",", "b", ",", 
    RowBox[{"-", "b"}], ",", 
    RowBox[{"-", "a"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"A", ",", "B"}], "}"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"B101", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "A"}], ",", "B", ",", "A"}], "]"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"54f1cf2b-750f-419e-b128-304549c18984"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RuleDelayed", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B101", ",", "a", ",", "c$", ",", 
      RowBox[{"-", "c$"}], ",", 
      RowBox[{"-", "a"}]}], "]"}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"B101", ",", 
      RowBox[{"-", "C$"}], ",", 
      RowBox[{"-", "B$"}], ",", "C$", ",", "B$"}], "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"88ff6de6-7f6d-45a0-9e3e-aea03c683a80"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"B101", ",", "a", ",", "b", ",", 
    RowBox[{"-", "b"}], ",", 
    RowBox[{"-", "a"}]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"T", "[", 
   RowBox[{"B101", ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}], ",", "B", ",", "A"}], 
   "]"}]}]], "Output",ExpressionUUID->"28030fd0-c587-421a-a68e-3abebad0aa38"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"N2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"P", ",", "Q"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"941b2c90-226f-4fc2-88bc-af64769a9d90"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "N2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`N2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c87fd822-ee0a-4aff-8fef-561b931a35b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentN2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentN2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"42abea9c-635a-4aa6-a0c2-83e61e11f19c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "N2"}]], "Input",ExpressionUUID->"050b48d8-38f5-4ae5-999b-0e2fb1068cf6"],

Cell[CellGroupData[{

Cell["Global`N2", "Print", "PrintUsage",
 CellTags->
  "Info3578672637-5338953",ExpressionUUID->"7b0257d0-6c3f-4caa-a0f9-\
4179bf170668"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "N2", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "N2", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "N2", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "N2", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "N2", "]"}], "^=", "\<\"N2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "N2", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]N2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentN2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "N2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`N2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672637-5338953",ExpressionUUID->"52696ac3-b3a7-4b98-8b18-\
3d54f2a10e47"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"P$1", ",", 
    RowBox[{"-", "P$1"}], ",", "P$2", ",", 
    RowBox[{"-", "P$2"}], ",", "P$3", ",", 
    RowBox[{"-", "P$3"}], ",", "P$4", ",", 
    RowBox[{"-", "P$4"}], ",", "P$5", ",", 
    RowBox[{"-", "P$5"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"faf42931-46f6-4813-a52e-ecb884864de0"],

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"P", ",", 
   RowBox[{"-", "P"}], ",", "Q", ",", 
   RowBox[{"-", "Q"}], ",", "Q1", ",", 
   RowBox[{"-", "Q1"}], ",", "Q2", ",", 
   RowBox[{"-", "Q2"}], ",", "Q3", ",", 
   RowBox[{"-", "Q3"}]}], 
  "]"}]], "Output",ExpressionUUID->"a7bf1d1b-6228-4306-9404-ab9f018b8454"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$AbstractIndices"], \
"Input",ExpressionUUID->"090287c7-5704-4fe0-b276-091692bf7725"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "J", 
   ",", "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
   "h", ",", "i", ",", "j", ",", "k", ",", "l", ",", "m", ",", "n", ",", "o", 
   ",", "p", ",", "q", ",", "P", ",", "Q", ",", "Q1", ",", "Q2", ",", "Q3"}], 
  "}"}]], "Output",ExpressionUUID->"73293bb3-c7d6-4d37-b905-4933e9dc3e9a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefManifold", "/@", 
   RowBox[{"{", 
    RowBox[{"N2", ",", "MM", ",", "M"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"056dbbf2-40c8-4c53-a626-2a6ed1c8987c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]N2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentN2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentN2],
  Editable->
   False]], "Print",ExpressionUUID->"7ada1821-3141-4600-8d7f-1f1c0befc8d9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "N2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`N2],
  Editable->
   False]], "Print",ExpressionUUID->"38ea9fb3-7440-4784-a151-458af573db63"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]MM",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentMM,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentMM],
  Editable->
   False]], "Print",ExpressionUUID->"f3637d2a-7127-4b10-908b-753bcf528086"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "MM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`MM],
  Editable->
   False]], "Print",ExpressionUUID->"08ac1a89-9424-4b86-a693-302a81ec28af"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM],
  Editable->
   False]], "Print",ExpressionUUID->"29d04a61-0d31-422f-9168-45acd6411dd9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M],
  Editable->
   False]], "Print",ExpressionUUID->"467809e9-97b8-46de-bb0b-707abd3be09c"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"B101", ",", "Cd", ",", "polar", ",", "T", ",", "basis"}], 
  "]"}]], "Input",ExpressionUUID->"d19b8226-42c2-402b-9088-fcbda5a2b951"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "a$", ",", "A$", ",", "A$0", ",", "A$1", ",", "A$2", ",", "B$", ",", "B$1", 
   ",", "B$101", ",", "c$", ",", "C$", ",", "D$", ",", "f$", ",", "F$", ",", 
   "H$", ",", "i$", ",", "j$", ",", "k$", ",", "l$", ",", "P$1", ",", "P$2", 
   ",", "P$3", ",", "P$4", ",", "P$5", ",", "z", ",", "Z"}], 
  "]"}]], "Input",ExpressionUUID->"41cc935b-6bcb-46e4-9f4c-8f6a211677f5"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b82eee6c-3d5a-4a10-a145-e8d7d06d244a"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["9. Tensors",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"cb5f31b1-62ab-4aec-9fd6-8585c1b9b196"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**"}], "*", " ", "9.", "Tensors"}], " ", 
  "*****************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7be2a1df-a8f5-4bf9-989d-92179b0d82f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"10713567-cd7d-4f8b-9ba8-fc86c5fa7a00"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "31.192996`", ",", "369.92293`9.019656245773314", ",", 
   "0.08432304212015435`"}], 
  "}"}]], "Output",ExpressionUUID->"ec01a101-8659-4feb-bbd6-8c681ad352cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell["9.0. Comments", \
"Subsection",ExpressionUUID->"b115f43b-16be-44ab-bdcd-011994121222"],

Cell[TextData[{
 "Currently in ",
 StyleBox["xTensor ",
  FontSlant->"Italic"],
 "we are trying to manipulate simultaneously five orthogonal generalizations \
of normal tensors on a manifold:\n\t- Gauge inner vbundles,\n\t- Complex \
tensors,\n\t- Product vbundles,\n\t- Induced vbundles,\n\t- Pullback \
vbundles.\nI'm not sure any combination of those is correctly implemented. \
Probably not."
}], "Text",ExpressionUUID->"e5f68953-9530-40f2-84d0-8fc92479ca9a"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 9: Tensors.\>\"", "]"}], ",", 
   "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cb1311e1-253e-4398-beba-8ed5414ef621"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.1. Orthogonality with respect to a vector", \
"Subsection",ExpressionUUID->"49e315cd-84e5-469d-bc57-856377ee14e5"],

Cell[CellGroupData[{

Cell["9.1.1. Explicit orthogonality to a vector: SetOrthogonal", \
"Subsubsection",ExpressionUUID->"ec8c28d4-017d-421d-b536-ebc6a9fc2f5b"],

Cell["\<\
With SetOrthogonal (a public function) we create an orthogonality rule (or \
several of them). Note that we use the option MetricOn on all indices and not \
only on the contracted index. This option will only have effect if there is a \
metric in the vbundle of index, because MakeRule has a MetricEndowedQ check. \
There are four checks in this function:
\t1.- The rule is not already defined (do nothing otherwise).
\t2.- The index of vector[index] is an abstract index (throw an error \
otherwise).
\t3.- The index can be contracted (throw an error otherwise).
\t4.- The rule has been correctly implemented (send a message otherwise).
Checks 2 and 3 are performed with checkSetOrthogonal.
When the orthogonality is on all indices, we store the information in \
OrthogonalToVectorQ, which is a totally independent function.\
\>", "Text",ExpressionUUID->"311eb4c9-c6a0-4fb2-9962-de119a86b34b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"checkSetOrthogonal", "[", 
    RowBox[{"list_", ",", "index_"}], "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"AIndexQ", "[", "index", "]"}]}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefTensor", "::", "error"}], ",", 
        "\"\<Index of orthogonal vector must be abstract.\>\""}], "]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"list", ",", 
       RowBox[{"ChangeIndex", "@", "index"}]}], "]"}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefTensor", "::", "error"}], ",", 
        "\"\<Index of orthogonal vector cannot be contracted.\>\""}], "]"}]}],
      ",", "\[IndentingNewLine]", "True", ",", "Null"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"522b4025-9288-47b2-a284-562cf5b6cf46"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SetOrthogonal"}]], \
"Input",ExpressionUUID->"f77db36e-8daf-4d1f-a00a-2cd5dbb17396"],

Cell[BoxData[
 StyleBox["\<\"SetOrthogonal[tensor[inds], vector[ind]] defines automatic \
rules for tensor such that tensor[inds]*vector[ind] is zero. \
SetOrthogonal[tensor[inds], vector] defines those rules for all abstract \
indices of tensor[inds].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672640-5338953",ExpressionUUID->"989c3dbb-100d-440e-ba09-\
20b2f750c40e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefTensor", "::", "noorth"}], "=", 
   "\"\<Tensor `1` could not be made orthogonal to vector `2`.\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"54fa2321-6cb4-453a-a430-a6088868f691"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Orthogonality", " ", "in", " ", "all", " ", "indices", " ", "of", " ", 
    RowBox[{"tensor", ".", " ", "Assume"}], " ", "there", " ", "is", " ", "a",
     " ", "metric"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetOrthogonal", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
        RowBox[{"AnyIndices", "[", 
         RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], "]"}], ",", 
       RowBox[{"vector_", "?", "xTensorQ"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vbQ", "=", 
          RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], ",", 
         RowBox[{"i", "=", 
          RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"xTagSetDelayed", "@@", 
         RowBox[{"Hold", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"tensor", ",", " ", 
             RowBox[{
              RowBox[{"tensor", "[", 
               RowBox[{"___", ",", "i_", ",", "___"}], "]"}], 
              RowBox[{"vector", "[", 
               RowBox[{"-", 
                RowBox[{"i_", "?", "vbQ"}]}], "]"}]}]}], "}"}], ",", "0"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"xTagSetDelayed", "@@", 
         RowBox[{"Hold", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"tensor", ",", " ", 
             RowBox[{
              RowBox[{"tensor", "[", 
               RowBox[{"___", ",", 
                RowBox[{"-", 
                 RowBox[{"i_", "?", "vbQ"}]}], ",", "___"}], "]"}], 
              RowBox[{"vector", "[", "i_", "]"}]}]}], "}"}], ",", "0"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"xUpSet", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "tensor",
            "]"}], ",", "True"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetOrthogonal", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
       RowBox[{"vector_", "?", "xTensorQ"}]}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SetOrthogonal", "[", 
           RowBox[{
            RowBox[{"tensor", "[", "inds", "]"}], ",", 
            RowBox[{"vector", "[", "#", "]"}]}], "]"}], "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{"ChangeIndex", ",", 
           RowBox[{"Select", "[", 
            RowBox[{
             RowBox[{"IndexList", "[", "inds", "]"}], ",", "AIndexQ"}], 
            "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "tensor", 
          "]"}], ",", "True"}], "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Orthogonality", " ", "in", " ", "a", " ", "given", " ", "index"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SetOrthogonal", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
       RowBox[{
        RowBox[{"vector_", "?", "xTensorQ"}], "[", "index_", "]"}]}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"tensor", "[", "inds", "]"}], " ", 
         RowBox[{"vector", "[", "index", "]"}]}], "=!=", "0"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"checkSetOrthogonal", "[", 
         RowBox[{
          RowBox[{"IndexList", "[", "inds", "]"}], ",", "index"}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"AutomaticRules", "[", 
         RowBox[{"tensor", ",", 
          RowBox[{"MakeRule", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"tensor", "[", "inds", "]"}], 
               RowBox[{"vector", "[", "index", "]"}]}], ",", "0"}], "}"}], 
            ",", 
            RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
            RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"tensor", "[", "inds", "]"}], 
            RowBox[{"vector", "[", "index", "]"}]}], "=!=", "0"}], ",", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefTensor", "::", "noorth"}], ",", 
            RowBox[{"tensor", "[", "inds", "]"}], ",", 
            RowBox[{"vector", "[", "index", "]"}]}], "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"SetOrthogonal", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "SetOrthogonal", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d79e239c-ee79-4f30-9f6a-3cd710b20e33"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.1.2. Explicit projections with a projector: SetProjected", \
"Subsubsection",ExpressionUUID->"31df4b41-95b4-4e4a-88c6-e593f9123de6"],

Cell["\<\
This is a parallel function SetProjected to set projection rules. Note that \
MakeRule has a HoldFirst attribute and hence we need Evaluate in order to get \
the computed value of newtensor. Note also that Evaluate must be directly \
under MakeRule and not deeper because otherwise it wouldn't get evaluated. \
Note the strange If condition; this is to ensure that the product \
tensor[inds]projector[i1,i2] does not evaluate already to something else. We \
also need to consider both possibilities of ordering the projector and the \
tensor.\
\>", "Text",ExpressionUUID->"8f6fa0d8-ddd4-4cde-a614-c7b7186e8301"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"checkSetProjected", "[", 
    RowBox[{"list_", ",", 
     RowBox[{"IndexList", "[", 
      RowBox[{"i1_", ",", "i2_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"!", 
       RowBox[{"AIndexQ", "[", "i1", "]"}]}], "||", 
      RowBox[{"!", 
       RowBox[{"AIndexQ", "[", "i2", "]"}]}]}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefTensor", "::", "error"}], ",", 
        "\"\<Indices of projector must be abstract.\>\""}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Sort", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Length", "@", 
          RowBox[{"TakeEPairs", "@", 
           RowBox[{"Append", "[", 
            RowBox[{"list", ",", "i1"}], "]"}]}]}], ",", 
         RowBox[{"Length", "@", 
          RowBox[{"TakeEPairs", "@", 
           RowBox[{"Append", "[", 
            RowBox[{"list", ",", "i2"}], "]"}]}]}]}], "}"}], "]"}], "=!=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "2"}], "}"}]}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefTensor", "::", "error"}], ",", 
        "\"\<One and only one pair of indices must be contracted to project a \
tensor.\>\""}], "]"}]}], ",", "\[IndentingNewLine]", "True", ",", "Null"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"96f3f254-9017-4fac-9e94-597b467b6aed"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SetProjected"}]], \
"Input",ExpressionUUID->"20bea9b1-d786-4d2c-906f-9b5e662ecede"],

Cell[BoxData[
 StyleBox["\<\"SetProjected[tensor[inds], proj[i1, i2]] defines automatic \
rules for tensor such that tensor[inds]*proj[i1, i2] returns tensor again, \
but with new indices. SetProjected[tensor[inds], proj] defines those rules \
for all abstract indices of tensor[inds].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672641-5338953",ExpressionUUID->"e2eafe8b-5b9a-41e6-872b-\
ab1f7637c519"]
}, Open  ]],

Cell["\<\
Here we are assuming that we can attach definitions to the main head of the \
tensor.\
\>", "Text",ExpressionUUID->"82e511bd-e315-4c46-a52e-f3f800feeb30"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetProjected", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
      RowBox[{"AnyIndices", "[", 
       RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], "]"}], ",", 
     RowBox[{"projector_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vbQ", "=", 
        RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], ",", 
       RowBox[{"i", "=", 
        RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
       RowBox[{"j", "=", 
        RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xTagSetDelayed", "@@", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tensor", ",", 
           RowBox[{
            RowBox[{"tensor", "[", 
             RowBox[{"left___", ",", "i_", ",", "right___"}], "]"}], 
            RowBox[{"projector", "[", 
             RowBox[{
              RowBox[{"-", "i_"}], ",", "j_"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"tensor", "[", 
          RowBox[{"left", ",", "j", ",", "right"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"xTagSetDelayed", "@@", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tensor", ",", 
           RowBox[{
            RowBox[{"tensor", "[", 
             RowBox[{"left___", ",", 
              RowBox[{"-", "i_"}], ",", "right___"}], "]"}], 
            RowBox[{"projector", "[", 
             RowBox[{"i_", ",", "j_"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"tensor", "[", 
          RowBox[{"left", ",", "j", ",", "right"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"xTagSetDelayed", "@@", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tensor", ",", 
           RowBox[{
            RowBox[{"tensor", "[", 
             RowBox[{"left___", ",", "i_", ",", "right___"}], "]"}], 
            RowBox[{"projector", "[", 
             RowBox[{"j_", ",", 
              RowBox[{"-", "i_"}]}], "]"}]}]}], "}"}], ",", 
         RowBox[{"tensor", "[", 
          RowBox[{"left", ",", "j", ",", "right"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"xTagSetDelayed", "@@", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tensor", ",", 
           RowBox[{
            RowBox[{"tensor", "[", 
             RowBox[{"left___", ",", 
              RowBox[{"-", "i_"}], ",", "right___"}], "]"}], 
            RowBox[{"projector", "[", 
             RowBox[{"j_", ",", "i_"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"tensor", "[", 
          RowBox[{"left", ",", "j", ",", "right"}], "]"}]}], "]"}]}], ";"}]}],
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetProjected", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds__", "]"}], ",", 
     RowBox[{"projector_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SetProjected", "[", 
      RowBox[{
       RowBox[{"tensor", "[", "inds", "]"}], ",", 
       RowBox[{"projector", "[", 
        RowBox[{
         RowBox[{"DummyAs", "[", "#", "]"}], ",", 
         RowBox[{"ChangeIndex", "[", "#", "]"}]}], "]"}]}], "]"}], "&"}], "/@", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"IndexList", "[", "inds", "]"}], ",", "AIndexQ"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetProjected", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds__", "]"}], ",", 
     RowBox[{
      RowBox[{"projector_", "?", "xTensorQ"}], "[", 
      RowBox[{"i1_", ",", "i2_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"product", "=", 
        RowBox[{
         RowBox[{"tensor", "[", "inds", "]"}], 
         RowBox[{"projector", "[", 
          RowBox[{"i1", ",", "i2"}], "]"}]}]}], ",", "newtensor"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"checkSetProjected", "[", 
       RowBox[{
        RowBox[{"IndexList", "[", "inds", "]"}], ",", 
        RowBox[{"IndexList", "[", 
         RowBox[{"i1", ",", "i2"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"product", "===", 
          RowBox[{"Unevaluated", "[", 
           RowBox[{
            RowBox[{"tensor", "[", "inds", "]"}], 
            RowBox[{"projector", "[", 
             RowBox[{"i1", ",", "i2"}], "]"}]}], "]"}]}], "||", 
         RowBox[{"product", "===", 
          RowBox[{"Unevaluated", "[", 
           RowBox[{
            RowBox[{"projector", "[", 
             RowBox[{"i1", ",", "i2"}], "]"}], 
            RowBox[{"tensor", "[", "inds", "]"}]}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"newtensor", "=", 
          RowBox[{"ReplaceIndex", "[", 
           RowBox[{
            RowBox[{"tensor", "[", "inds", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "i1"}], "\[Rule]", "i2"}], ",", 
              RowBox[{
               RowBox[{"-", "i2"}], "\[Rule]", "i1"}]}], "}"}]}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"AutomaticRules", "[", 
          RowBox[{"tensor", ",", 
           RowBox[{"MakeRule", "[", 
            RowBox[{
             RowBox[{"Evaluate", "@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"tensor", "[", "inds", "]"}], 
                 RowBox[{"projector", "[", 
                  RowBox[{"i1", ",", "i2"}], "]"}]}], ",", "newtensor"}], 
               "}"}]}], ",", 
             RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
             RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
           RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SetProjected", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SetProjected", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5e6747e4-14bd-4a7b-979e-cdff6c437f53"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
9.1.3. Implicit orthogonality to a vector: OrthogonalToVectorQ\
\>", "Subsubsection",ExpressionUUID->"987462c7-532a-47ea-84c2-0bea1373098b"],

Cell["\<\
Orthogonality to vectors. This private function is used with two different \
notations. First on tensor names: we use remembered values (but not \
upvalues). Then we can have it acting on general expressions. It checks that \
tensor is orthogonal to vector in ALL its indices (of tensor or expression). \
The same double notation is possible in SetOrthogonal, and hence \
SetOrthogonal sets OrthogonalToVectorQ if there is orthogonality in all \
indices. I thank Cyril and Thomas for various improvements in this function. \
Cyril has suggested implementing some sort of linearity, which might \
accelerate checks, but it feels unnecessary and strictly speaking it is not \
general because v could be orthogonal to w1+w2 without being orthogonal to \
any of them.\
\>", "Text",ExpressionUUID->"e0eb0e3b-4f54-48b5-ac33-881ad04ddd49"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Tensor", " ", 
     RowBox[{"names", ".", " ", "Incompatible"}], " ", "with", " ", "the", 
     " ", "use", " ", "of", " ", "variable"}], "-", 
    RowBox[{"rank", " ", "tensors"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", 
      RowBox[{"tensor", ":", 
       RowBox[{"(", 
        RowBox[{"delta", "|", "Gdelta", "|", "Basis"}], ")"}]}], "]"}], ":=", 
     
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefTensor", "::", "nouse"}], ",", 
        "\"\<OrthogonalToVectorQ\>\"", ",", "tensor"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", 
      RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], ":=", 
     RowBox[{"xUpSet", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "tensor", 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"inds", "=", 
           RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{"inds", ",", 
             RowBox[{"AnyIndices", "[", "_", "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"OrthogonalToVectoQ", "::", "error"}], ",", 
              RowBox[{
              "\"\<Cannot decide orthogonality to the variable-rank tensor \>\
\"", "<>", 
               RowBox[{"ToString", "[", "tensor", "]"}]}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"inds", " ", "=", 
             RowBox[{"DummyIn", "/@", "inds"}]}], ";", "\[IndentingNewLine]", 
            
            RowBox[{"OToVcheck", "[", 
             RowBox[{"vector", ",", 
              RowBox[{"tensor", "@@", "inds"}], ",", 
              RowBox[{"Select", "[", 
               RowBox[{"inds", ",", "EIndexQ"}], "]"}]}], "]"}]}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"TensorDerivative", " ", "with", " ", "induced", " ", 
     RowBox[{"derivatives", ".", " ", "Contributed"}], " ", "by", " ", 
     "Cyril"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", 
      RowBox[{
       RowBox[{"TensorDerivative", "[", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], ",", "ders___", ",", 
         RowBox[{"covd_Symbol", "?", "InducedCovDQ"}]}], "]"}], "[", 
       RowBox[{"inds___", ",", "ind_"}], "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"Last", "@", 
        RowBox[{"InducedFrom", "@", 
         RowBox[{"MetricOfCovD", "@", "covd"}]}]}], "===", "vector"}], "&&", 
      RowBox[{
       RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
       RowBox[{
        RowBox[{"TensorDerivative", "[", 
         RowBox[{"tensor", ",", "ders"}], "]"}], "[", "inds", "]"}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", 
      RowBox[{
       RowBox[{"TensorDerivative", "[", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], ",", "ders___", ",", 
         RowBox[{"LieD", "[", 
          RowBox[{"vector_", "[", "i_", "]"}], "]"}]}], "]"}], "[", "inds___",
        "]"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tensor1", "=", 
         RowBox[{"TensorDerivative", "[", 
          RowBox[{"tensor", ",", "ders"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
         RowBox[{"tensor1", "[", "inds", "]"}], "]"}], "&&", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"IndicesOf", "[", 
             RowBox[{"Free", ",", "xAct`xTensor`Up"}], "]"}], "[", 
            RowBox[{"tensor1", "@@", 
             RowBox[{"(", 
              RowBox[{"DummyIn", "/@", 
               RowBox[{"SlotsOfTensor", "[", "tensor1", "]"}]}], ")"}]}], 
            "]"}], "===", 
           RowBox[{"IndexList", "[", "]"}]}], " ", "||", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"LieD", "[", 
             RowBox[{"vector", "[", "i", "]"}], "]"}], "[", 
            RowBox[{"vector", "[", 
             RowBox[{"-", "i"}], "]"}], "]"}], "===", "0"}]}], ")"}]}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"General", " ", 
     RowBox[{"expressions", ".", " ", 
      RowBox[{"QUESTION", ":", " ", 
       RowBox[{
       "Why", " ", "does", " ", "the", " ", "general", " ", "definition", " ",
         "look", " ", "only", " ", "at", " ", "the", " ", "free", " ", 
        RowBox[{"indices", "?"}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "tensor", 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", 
      RowBox[{
       RowBox[{"LieD", "[", 
        RowBox[{
         RowBox[{"vector_", "?", "xTensorQ"}], "[", "i_", "]"}], "]"}], "[", 
       "expr_", "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "expr", 
       "]"}], "&&", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"IndicesOf", "[", 
           RowBox[{"Free", ",", "xAct`xTensor`Up"}], "]"}], "[", "expr", 
          "]"}], "===", 
         RowBox[{"IndexList", "[", "]"}]}], "||", 
        RowBox[{
         RowBox[{
          RowBox[{"LieD", "[", 
           RowBox[{"vector", "[", "i", "]"}], "]"}], "[", 
          RowBox[{"vector", "[", 
           RowBox[{"-", "i"}], "]"}], "]"}], "===", "0"}]}], ")"}]}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "vector_", "]"}], "[", "expr_", 
      "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"uexpr", "=", 
         RowBox[{"UxSort", "[", "expr", "]"}]}], "}"}], ",", 
       RowBox[{"OToVcheck", "[", 
        RowBox[{"vector", ",", "uexpr", ",", " ", 
         RowBox[{"List", "@@", 
          RowBox[{"FindFreeIndices", "[", "uexpr", "]"}]}]}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Actual", " ", "check"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OToVcheck", "[", 
      RowBox[{"vector_", ",", "expr_", ",", "inds_List"}], "]"}], ":=", 
     RowBox[{"And", "@@", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"ContractMetric", "@", 
           RowBox[{"GradNormalToExtrinsicK", "[", "#", "]"}]}], "===", "0"}], 
         "&"}], ",", 
        RowBox[{"expr", " ", 
         RowBox[{"(", 
          RowBox[{"vector", "/@", 
           RowBox[{"ChangeIndex", "/@", 
            RowBox[{"Select", "[", 
             RowBox[{"inds", ",", "EIndexQ"}], "]"}]}]}], ")"}]}]}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Variant", " ", "added", " ", "by", " ", "Thomas"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HasOrthogonalIndexQ", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"vector_", "[", "ind_", "]"}]}], "]"}], ":=", 
    RowBox[{"And", "[", 
     RowBox[{
      RowBox[{"MemberQ", "[", 
       RowBox[{
        RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", 
        RowBox[{"-", "ind"}], ",", "1"}], "]"}], ",", 
      RowBox[{"OToVcheck", "[", 
       RowBox[{"vector", ",", "expr", ",", 
        RowBox[{"{", 
         RowBox[{"-", "ind"}], "}"}]}], "]"}]}], "]"}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ca3be9fe-83c6-42d2-b088-70abc5390fa8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "OrthogonalToVectorQ", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"52afc7cc-287f-493c-945f-f5deeca2133f"],

Cell["\<\
QUESTION: How do we know that the list of indices in the OToV check only has \
abstract indices? What would happen otherwise?\
\>", "Text",ExpressionUUID->"4cf7348a-de81-4738-8dea-0c42e0395009"],

Cell["\<\
Some comments from Cyril. I'm not sure they are still applicable:

I only had to add these rules to xTensor.m so that it could work fine:

OrthogonalToVectorQ[vector_][expr1_  expr2_] := \
OrthogonalToVectorQ[vector][expr1] && OrthogonalToVectorQ[vector][expr2];
OrthogonalToVectorQ[vector_][expr1_  + expr2_] := \
OrthogonalToVectorQ[vector][expr1] && OrthogonalToVectorQ[vector][expr2];

Indeed, when you have an expression of the type T[a,b,c] S[-b,d], the current \
OrthogonalToVectorQ will not know how to deal with it
and will use OtoVCheck, which basically contracts with the vector n normal to \
the hypersurfaces. If the tensor T is not orthogonal in its c index, but only \
in its a,b indices then OrthogonalToVectorCheck will say \
\[OpenCurlyDoubleQuote]True\[CloseCurlyDoubleQuote]. But then it will apply \
Leibniz rule, and the projecetd derivative will act directly on T[a,b,c], \
leading to an error \[OpenCurlyDoubleQuote]Error : Indices derivative acts on \
non projected expression\[CloseCurlyDoubleQuote]. I must say this happens to \
me when my tensor is a Lie derivative, but still, I think that is the way \
OrthogonalTOVectorCheck should work. Protect for Leibniz rule and linearity.\
\>", "Text",ExpressionUUID->"126f484f-fbdc-48d4-bae1-5b37f16d0252"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2. Definition", \
"Subsection",ExpressionUUID->"001c8286-405a-43af-95a0-6b9c2b10a506"],

Cell[CellGroupData[{

Cell["9.2.1. Tensor checks", \
"Subsubsection",ExpressionUUID->"2e545234-4562-4a7d-802c-262e0a4a8ee2"],

Cell["0) Temporal definition for this notebook, just for checking:", \
"Text",ExpressionUUID->"1352ff7b-e0e8-42ba-be5f-22203f41ba77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AutomaticRules", "[", "x___", "]"}], ":=", 
   RowBox[{"Print", "[", 
    RowBox[{"ToString", "[", 
     RowBox[{"{", "x", "}"}], "]"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"0a4b2355-f305-4a2e-bbe6-f2e339bce354"],

Cell["\<\
1) This function is used when the tensor is vanishing. We temporarily \
eliminate the RuleDelayed::rhs message because it complains about having a \
pattern on the rhs. This is not an error, it is just a warning message.\
\>", "Text",ExpressionUUID->"48580638-3073-4acc-8bef-fa5cd962012a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Off", "[", 
    RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "PINDEX", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"makepattern", "[", "a_Symbol", "]"}], ":=", 
   RowBox[{"Pattern", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Blank", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"makepattern", "[", 
    RowBox[{"-", "a_Symbol"}], "]"}], ":=", 
   RowBox[{"makepattern", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"makepattern", "[", "a_", "]"}], ":=", "a"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"On", "[", 
   RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b0a7f433-74f6-4ca4-b782-ce537ca6c2bd"],

Cell["\<\
2) A simple function which converts bundles into their base manifolds. It is \
also a filter of the possible dependencies a tensor can have:\
\>", "Text",ExpressionUUID->"e4feb355-ed34-41a1-967f-a156a9e20e33"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"baseifbundle", "[", 
    RowBox[{"manifold_", "?", "ManifoldQ"}], "]"}], ":=", "manifold"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"baseifbundle", "[", 
    RowBox[{"param_Symbol", "?", "ParameterQ"}], "]"}], ":=", "param"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"baseifbundle", "[", 
    RowBox[{"vbundle_", "?", "VBundleQ"}], "]"}], ":=", 
   RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"baseifbundle", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefTensor", "::", "unknown"}], ",", "\"\<dependency\>\"", ",", 
      "x"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"66f21c32-b8b0-4bd2-b405-1402d3da8377"],

Cell["3) Three particular error messages:", \
"Text",ExpressionUUID->"b821b58f-6dfd-40ad-a853-335582bf0c54"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefTensor", "::", "wrongsym"}], "=", 
   "\"\<Symmetry properties are inconsistent with indices of tensor.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefTensor", "::", "nodummy"}], "=", 
   "\"\<Tensor cannot be defined with dummy indices.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefTensor", "::", "zero"}], "=", 
   "\"\<Symmetry makes tensor zero. Use VanishingQ instead.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1ec0cec7-48a9-4612-9347-001452b69e7e"],

Cell["4) Check indices:", \
"Text",ExpressionUUID->"d4e73302-f779-494e-bd71-d13381896c36"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefTensorCheckIndices", "[", "indices___", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Only", " ", "types", " ", "A", " ", "and", " ", "L", " ", "are", " ", 
       "accepted"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Not", "[", 
           RowBox[{
            RowBox[{"AIndexQ", "[", "#", "]"}], "||", 
            RowBox[{"LIndexQ", "[", "#", "]"}]}], "]"}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefTensor", "::", "invalid"}], ",", "#", ",", 
             "\"\<index at definition\>\""}], "]"}]}]}], "]"}], "&"}], "/@", 
       RowBox[{"{", "indices", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "If", " ", "we", " ", "accept", " ", "a", " ", "single", " ", "index", 
        " ", "for", " ", "Dim1", " ", "spaces", " ", "then", " ", "we", " ", 
        "need", " ", "to", " ", "delete", " ", "that", " ", "index", " ", 
        "from", " ", "the", " ", "list", " ", "in", " ", "this", " ", 
        "check"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TakeEPairs", "@", 
          RowBox[{"IndexList", "[", "indices", "]"}]}], "=!=", 
         RowBox[{"IndexList", "[", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{"DefTensor", "::", "nodummy"}], "]"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bbc10d2c-3b42-47a1-aa1c-36217030bc12"],

Cell["\<\
4) Main checks. Comments:
\t- There is a check of type A or L for the input indices. Therefore we can \
use either of upQ or UpIndexQ.
\t- Dagger->Complex is valid independently of whether all indices are real or \
not, but it has different meanings: if all indices are real we are \
complexifying the tensor space, but if they are not we are constructing a \
tensor on the conjugated vector space. Perhaps we should use different names \
(Complexified and Complex respectively, for example), but there is no \
possible confusion right now.
\t- If the tensor has variable rank then we do not implement the \
orthogonality relations. That seems dangerous to me. Hence, we also skip the \
corresponding check.
\t- In the past we have always included as dependencies the base manifolds of \
the vbundles of the indices, but now we do not do that. The argument was that \
there is no sense of a constant tensor. That might be true for tangent \
vbundles, but probably not for inner vbundles. \
\>", "Text",ExpressionUUID->"c2c3b397-0142-4280-a67f-c90c64e1a3da"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefTensorChecks", "[", 
    RowBox[{
     RowBox[{"head_", "[", "indices___", "]"}], ",", "dependencies_", ",", 
     "sym_", ",", 
     RowBox[{"{", 
      RowBox[{
      "dag_", ",", "forcesym_", ",", "weight_", ",", "grade_", ",", 
       "frobeniusQ_", ",", "ot_", ",", "pw_", ",", "anynumberQ_"}], "}"}]}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "alldependencies", ",", "manifolds", ",", "parameters", ",", "vbundles",
        ",", "SGS", ",", "tableaux"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"1.", " ", "Validate", " ", "name"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ValidateSymbol", "[", "head", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ValidateSymbolInSession", "[", "head", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "2.", " ", "Check", " ", "indices", " ", "and", " ", "consistency", 
        " ", "with", " ", "the", " ", "vbundles"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"DefTensorCheckIndices", "[", "indices", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"vbundles", "=", 
       RowBox[{"SignedVBundleOfIndex", "/@", 
        RowBox[{"{", "indices", "}"}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"3.", " ", "Check", " ", 
        RowBox[{"dependencies", ":", " ", 
         RowBox[{"manifolds", " ", "and", " ", "parameters"}]}]}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"alldependencies", "=", 
       RowBox[{"SortDependencies", "[", 
        RowBox[{"baseifbundle", "/@", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", "dependencies", "}"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"manifolds", "=", 
       RowBox[{"Select", "[", 
        RowBox[{"alldependencies", ",", "ManifoldQ"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"parameters", "=", 
       RowBox[{"Select", "[", 
        RowBox[{"alldependencies", ",", "ParameterQ"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Throw", "[", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefTensor", "::", "unknown"}], ",", 
           "\"\<manifold or parameter\>\"", ",", "#"}], "]"}], "]"}], "&"}], "/@", 
       RowBox[{"Complement", "[", 
        RowBox[{"alldependencies", ",", "manifolds", ",", "parameters"}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "4.", " ", "Check", " ", "Dagger", " ", "option", " ", "and", " ", 
        "decide", " ", "whether", " ", "it", " ", "is", " ", "compatible", 
        " ", "with", " ", "the", " ", "indices", " ", "of", " ", "the", " ", 
        "tensor"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"FreeQ", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "Real", ",", "Imaginary", ",", "Complex", ",", "Conjugate", ",", 
            "Hermitian", ",", "Antihermitian"}], "}"}], ",", "dag"}], "]"}], 
        ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefTensor", "::", "invalid"}], ",", "dag", ",", 
           "\"\<value for option Dagger\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"DaggerIndex", "@", 
          RowBox[{"IndexList", "[", "indices", "]"}]}], "===", 
         RowBox[{"IndexList", "[", "indices", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Hermitian", ",", "Antihermitian"}], "}"}], ",", "dag"}],
            "]"}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefTensor", "::", "invalid"}], ",", "dag", ",", 
             "\"\<value for Dagger: only real indices\>\""}], "]"}]}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Real", ",", "Imaginary"}], "}"}], ",", "dag"}], "]"}], 
           ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefTensor", "::", "invalid"}], ",", "dag", ",", 
              "\"\<value for Dagger: complex indices\>\""}], "]"}]}]}], "]"}],
          ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Hermitian", ",", "Antihermitian"}], "}"}], ",", 
             "dag"}], "]"}], ",", 
           RowBox[{"TransposeDaggerRules", "[", 
            RowBox[{
             RowBox[{"IndexList", "[", "indices", "]"}], ",", "$VBundles"}], 
            "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"5.", " ", "Check", " ", "weight"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"checkweight", "[", 
       RowBox[{"head", ",", "weight"}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"6.", " ", "Check", " ", "grades"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"checkgrade", "[", "grade", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "If", " ", "tensor", " ", "has", " ", "a", " ", "variable", " ", 
         "number", " ", "of", " ", "slots", " ", "we", " ", "cannot", " ", 
         "check", " ", "much", " ", "more"}], "..."}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
       "anynumberQ", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Print", "[", 
          "\"\<** DefTensor: No checks on indices for a variable-rank tensor.\
\>\"", "]"}], " ", "*)"}], "\[IndentingNewLine]", "Null", ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"7.", " ", "Check", " ", "symmetries"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"SGS", ",", "tableaux"}], "}"}], "=", 
          RowBox[{"DefTensorSymmetryChecks", "[", 
           RowBox[{
            RowBox[{"head", "[", "indices", "]"}], ",", "sym", ",", 
            "forcesym", ",", "vbundles"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "8.", " ", "Check", " ", "orthogonal", " ", "vectors", " ", "and", 
           " ", "projectors"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ot", "=!=", 
             RowBox[{"{", "}"}]}], "&&", 
            RowBox[{
             RowBox[{"TakeEIndices", "[", 
              RowBox[{"{", "indices", "}"}], "]"}], "===", 
             RowBox[{"{", "}"}]}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefTensor", "::", "error"}], ",", 
              "\"\<A scalar cannot be orthogonal to a vector\>\""}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", 
               RowBox[{"xTensorQ", "[", 
                RowBox[{"Head", "[", "#", "]"}], "]"}]}], ",", 
              RowBox[{"Throw", "@", 
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"DefTensor", "::", "unknown"}], ",", 
                 "\"\<vector\>\"", ",", "#"}], "]"}]}]}], "]"}], "&"}], ",", 
           "ot"}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"pw", "=!=", 
             RowBox[{"{", "}"}]}], "&&", 
            RowBox[{
             RowBox[{"TakeEIndices", "[", 
              RowBox[{"{", "indices", "}"}], "]"}], "===", 
             RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefTensor", "::", "error"}], ",", 
              "\"\<A scalar cannot be projected\>\""}], "]"}]}]}], "]"}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", 
               RowBox[{"xTensorQ", "[", 
                RowBox[{"Head", "[", "#", "]"}], "]"}]}], ",", 
              RowBox[{"Throw", "@", 
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"DefTensor", "::", "unknown"}], ",", 
                 "\"\<projector\>\"", ",", "#"}], "]"}]}]}], "]"}], "&"}], 
           ",", "pw"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"SortDependencies", "[", "alldependencies", "]"}], ",", 
        "vbundles", ",", "SGS", ",", "tableaux"}], "}"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"35e79676-ea88-4fe4-8ce7-be01794b5ade"],

Cell["5) Check the weight option:", \
"Text",ExpressionUUID->"27808aea-07ce-4e1a-89e1-c1fcbaf368f2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkweight", "[", "0", "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkweight", "[", "weight_Plus", "]"}], ":=", 
   RowBox[{"checkweight", "/@", "weight"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkweight", "[", 
    RowBox[{"basis_Symbol", "?", "BasisQ"}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkweight", "[", 
    RowBox[{
     RowBox[{"n_", "?", "ConstantQ"}], " ", "basis_"}], "]"}], ":=", 
   RowBox[{"checkweight", "[", "basis", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkweight", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefTensor", "::", "invalid"}], ",", "x", ",", 
      "\"\<weight for tensor\>\""}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8d086f9d-3f0e-478c-b33e-04bf8156679c"],

Cell["6) Check the grade option:", \
"Text",ExpressionUUID->"b6941c09-8b29-4cd1-ba11-9dc2ed8bb321"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkgrade", "[", "0", "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkgrade", "[", "list_List", "]"}], ":=", 
   RowBox[{"checkgrade", "/@", "list"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkgrade", "[", 
    RowBox[{
     RowBox[{"prod_", "?", "ProductQ"}], "\[Rule]", "grade_Integer"}], "]"}], 
   ":=", "Null"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkgrade", "[", "graderule_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefTensor", "::", "invalid"}], ",", "graderule", ",", 
      "\"\<grade specification\>\""}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ca7af06e-75cc-4778-81f2-f8b0d75783c4"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2.2. Symmetry checks", \
"Subsubsection",ExpressionUUID->"0b0737fd-80ce-4baf-87a0-93419e4b2447"],

Cell["\<\
1) The symmetry argument is given either as a symmetry group (with head \
GenSet or StrongGenSet, or the v9-inert Symmetric/Antisymmetric) or as a \
tableau or list of tableaux. The input can be given in terms of numeric slots \
or their indices at definition time, but it is inmediately converted into \
slots. First, check the heads:\
\>", "Text",ExpressionUUID->"d3f4ab50-81ca-47e2-b207-70d051b01a41"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"validsymmetryhead", "[", 
    RowBox[{
    "_GenSet", "|", "_StrongGenSet", "|", "_xAct`xTableau`Tableau", "|", 
     "_Symmetric", "|", "_Antisymmetric"}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"validsymmetryhead", "[", "list_List", "]"}], ":=", 
   RowBox[{"validsymmetryhead", "/@", "list"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"validsymmetryhead", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefTensor", "::", "invalid"}], ",", "x", ",", 
      "\"\<symmetry specification\>\""}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7c0deff7-1bcd-47ff-a61d-d81b60da5216"],

Cell["\<\
2) This function finds all moved points in a given (strong or not) generating \
set or list of tableaux:\
\>", "Text",ExpressionUUID->"19224ea7-3712-440e-87b5-e0ad0ae1d5d8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"StrongGenSet", "[", 
     RowBox[{"base_", ",", "GS_"}], "]"}], "]"}], ":=", 
   RowBox[{"symslots", "[", "GS", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"Symmetric", "[", "list_", "]"}], "]"}], ":=", "list"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"Antisymmetric", "[", "list_", "]"}], "]"}], ":=", "list"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"GenSet", "[", "]"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"GenSet", "[", "cycs__", "]"}], "]"}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"symslots", "/@", 
      RowBox[{"{", "cycs", "}"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"-", 
     RowBox[{"xAct`xPerm`Cycles", "[", "cycs___", "]"}]}], "]"}], ":=", 
   RowBox[{"{", "cycs", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"xAct`xPerm`Cycles", "[", "cycs___", "]"}], "]"}], ":=", 
   RowBox[{"{", "cycs", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", 
    RowBox[{"xAct`xTableau`Tableau", "[", "lists___", "]"}], "]"}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", "lists", "}"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symslots", "[", "list_List", "]"}], ":=", 
   RowBox[{"symslots", "/@", "list"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3924290d-5cef-47da-bce7-dcaaa5f80fa0"],

Cell["3) Compute the SGS of the symmetry:", \
"Text",ExpressionUUID->"6b5f02ca-afc6-40aa-9521-cb7cee37180d"],

Cell["\<\
As pointed out by Thomas, it is important that the base contains all moved \
points in the tensor, even though many of them might be irrelevant. It is \
also important, for later compatibility with the option OrderedBase->True, \
that the points in the base are sorted.\
\>", "Text",ExpressionUUID->"75814c27-be59-48be-bcff-f0ed0130a8fc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"movedpoints", "[", 
    RowBox[{"-", "perm_"}], "]"}], ":=", 
   RowBox[{"movedpoints", "[", "perm", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"movedpoints", "[", 
    RowBox[{"xAct`xPerm`Cycles", "[", "cycs___", "]"}], "]"}], ":=", 
   RowBox[{"Join", "[", "cycs", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"movedpoints", "[", "perm_", "]"}], ":=", 
   RowBox[{"movedpoints", "[", 
    RowBox[{"TranslatePerm", "[", 
     RowBox[{"perm", ",", "xAct`xPerm`Cycles"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"support", "[", "GS_", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Union", ",", 
    RowBox[{"movedpoints", "/@", "GS"}]}], "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3bdb9a10-b0e4-4dc7-a25e-791b0c448a71"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SGSofsym", "[", 
    RowBox[{"GenSet", "[", "]"}], "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SGSofsym", "[", "SGS_StrongGenSet", "]"}], ":=", "SGS"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SGSofsym", "[", 
    RowBox[{"sym", ":", 
     RowBox[{"(", 
      RowBox[{"_Symmetric", "|", "_Antisymmetric"}], ")"}]}], "]"}], ":=", 
   RowBox[{"SchreierSims", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "sym"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SGSofsym", "[", "GS_GenSet", "]"}], ":=", 
   RowBox[{"Check", "[", 
    RowBox[{
     RowBox[{"Catch", "@", 
      RowBox[{"SchreierSims", "[", 
       RowBox[{
        RowBox[{"support", "[", "GS", "]"}], ",", "GS"}], "]"}]}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefTensor", "::", "invalid"}], ",", "GS", ",", 
        "\"\<symmetry identification\>\""}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SGSofsym", "[", "tab_xAct`xTableau`Tableau", "]"}], ":=", 
   RowBox[{"xAct`xTableau`StrongGenSetOfTableau", "[", "tab", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SGSofsym", "[", "x_", "]"}], ":=", 
  RowBox[{"Throw", "@", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"DefTensor", "::", "unknown"}], ",", "\"\<symmetry\>\"", ",", 
     "x"}], "]"}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"232060e5-4210-4ab9-bdfe-62fef7337101"],

Cell["4) Main checks:", \
"Text",ExpressionUUID->"6e6d2b64-8984-4187-b9c1-367051c75f99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefTensorSymmetryChecks", "[", 
    RowBox[{
     RowBox[{"head_", "[", "indices___", "]"}], ",", "sym_", ",", "forcesym_",
      ",", "slots_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "rules", ",", "numsym", ",", "symnumslots", ",", "tableaux", ",", "SGS",
        ",", "order", ",", "group"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Check", " ", "structure", " ", "of", " ", "sym", " ", "argument"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"validsymmetryhead", "[", "sym", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Transform", " ", "indices", " ", "to", " ", "numeric", " ", 
         "slots"}], ";", " ", 
        RowBox[{"permutations", " ", "in", " ", "Cycles", " ", "notation"}]}],
        " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"rules", "=", 
       RowBox[{"Thread", "@", 
        RowBox[{"Rule", "[", 
         RowBox[{
          RowBox[{"{", "indices", "}"}], ",", 
          RowBox[{"Range", "@", 
           RowBox[{"Length", "@", 
            RowBox[{"{", "indices", "}"}]}]}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"numsym", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{"{", "sym", "}"}], "]"}], "/.", "rules"}], "/.", 
        RowBox[{"gs_GenSet", "\[RuleDelayed]", 
         RowBox[{"TranslatePerm", "[", 
          RowBox[{"gs", ",", "xAct`xPerm`Cycles"}], "]"}]}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Check", " ", "that", " ", "different", " ", "symmetry", " ", 
        "arguments", " ", "are", " ", "disjoint"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"symnumslots", "=", 
       RowBox[{"Flatten", "@", 
        RowBox[{"symslots", "[", "numsym", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Union", "@", "symnumslots"}], "=!=", 
         RowBox[{"Sort", "@", "symnumslots"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefTensor", "::", "error"}], ",", 
           "\"\<Repeated slots in symmetry.\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Select", " ", "tableaux", " ", "and", " ", "construct", " ", "SGS"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tableaux", "=", 
       RowBox[{"Cases", "[", 
        RowBox[{"numsym", ",", "_xAct`xTableau`Tableau"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SGS", "=", 
       RowBox[{"Apply", "[", 
        RowBox[{"JoinSGS", ",", 
         RowBox[{"SGSofsym", "/@", "numsym"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "First", " ", "consistency", " ", "check", " ", "only", " ", "on", " ",
         "small", " ", "groups", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"up", " ", "to", " ", "6", " ", "symmetry"}], "-", 
          "slots"}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "symnumslots", "]"}], "\[LessEqual]", "6"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"group", "=", 
          RowBox[{"Dimino", "[", 
           RowBox[{"GenSet", "@", "SGS"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Intersection", "[", 
             RowBox[{"group", ",", 
              RowBox[{"Map", "[", 
               RowBox[{"Minus", ",", "group"}], "]"}]}], "]"}], "=!=", 
            RowBox[{"Group", "[", "]"}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{"DefTensor", "::", "zero"}], "]"}]}]}], "]"}]}]}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Consistency", " ", "check", " ", "on", " ", "all", " ", "groups"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"PermMemberQ", "[", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"xAct`xPerm`Cycles", "[", "]"}]}], ",", "SGS"}], "]"}], 
        ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{"DefTensor", "::", "zero"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "ForceSymmetries", " ", "check", " ", "only", " ", "on", " ", "small", 
        " ", "groups", " ", "if", " ", "there", " ", "are", " ", "indices", 
        " ", "with", " ", "different", " ", "character", " ", "or", " ", 
        "vbundle"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", "forcesym"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "@", 
            RowBox[{"Union", "@", 
             RowBox[{"slots", "[", 
              RowBox[{"[", "symnumslots", "]"}], "]"}]}]}], ">", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"order", "=", 
               RowBox[{"OrderOfGroup", "[", "SGS", "]"}]}], ")"}], ">", 
             "10000"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<  Order of group of symmetry: \>\"", ",", "order", ",", 
              "\"\< > 10000. ForceSymmetry check not performed.\>\""}], "]"}],
             ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Head", "[", "group", "]"}], "===", "Symbol"}], ",", 
               RowBox[{"group", "=", 
                RowBox[{"Dimino", "[", 
                 RowBox[{"GenSet", "@", "SGS"}], "]"}]}]}], "]"}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "@", 
                 RowBox[{"Union", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"PermuteList", "[", 
                    RowBox[{"slots", ",", "#"}], "]"}], "&"}], "/@", 
                   RowBox[{"List", "@@", "group"}]}], "]"}]}], "=!=", "1"}], 
               ",", 
               RowBox[{"Throw", "@", 
                RowBox[{"Message", "[", 
                 RowBox[{"DefTensor", "::", "wrongsym"}], "]"}]}]}], 
              "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"SGS", ",", "tableaux"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"31fc2b23-f011-4442-900c-2949cf50c70c"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2.3. Definition", \
"Subsubsection",ExpressionUUID->"9a76b8b7-7411-466a-be71-52d969487b4d"],

Cell["\<\
DefTensor requires two arguments, but the third (the symmetry) is optional, \
and must not be confused with the first option:\
\>", "Text",ExpressionUUID->"a16ffba7-839f-43da-9a12-a0a3c09a4ff3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "OptionQ"}]], \
"Input",ExpressionUUID->"43bf7f48-2749-4e36-96f7-2483e7e08828"],

Cell[BoxData[
 StyleBox["\<\"\!\(\*RowBox[{\\\"OptionQ\\\", \\\"[\\\", StyleBox[\\\"e\\\", \
\\\"TI\\\"], \\\"]\\\"}]\) returns True if \!\(\*StyleBox[\\\"e\\\", \\\"TI\\\
\"]\) can be considered an option or list of options, and False \
otherwise.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672643-5338953",ExpressionUUID->"270104b9-c4ec-425c-97a7-\
9f48609876fb"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefTensor", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Dagger", "\[Rule]", "Real"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", "\[IndentingNewLine]", 
     RowBox[{"VanishingQ", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ForceSymmetries", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WeightOfTensor", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"GradeOfTensor", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FrobeniusQ", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"OrthogonalTo", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"ProjectedWith", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TensorID", "\[Rule]", 
      RowBox[{"{", "}"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefTensor", "[", 
     RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
    RowBox[{"Scan", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DefTensor", "[", 
        RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"No", " ", "symmetry"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefTensor", "[", 
     RowBox[{"tensor_", ",", "dependencies_", ",", 
      RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
    RowBox[{"DefTensor", "[", 
     RowBox[{"tensor", ",", "dependencies", ",", 
      RowBox[{"GenSet", "[", "]"}], ",", "options"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"General", " ", "definition"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefTensor", "[", 
    RowBox[{
     RowBox[{"head_", "[", "indices___", "]"}], ",", "dependencies_", ",", 
     "sym_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
       "dag", ",", "pa", ",", "van", ",", "forcesym", ",", "weight", ",", 
        "grade", ",", "frobeniusQ", ",", "ot", ",", "pw", ",", "pns", ",", 
        "master", ",", "info", ",", "tensorID", ",", "\[IndentingNewLine]", 
        "anynumberQ", ",", "alldependencies", ",", "vbundles", ",", 
        "uniqueslots", ",", "SGS", ",", "tableaux"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Options", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "dag", ",", "pa", ",", "van", ",", "forcesym", ",", "weight", ",", 
          "grade", ",", "frobeniusQ", ",", "ot", ",", "pw", ",", "pns", ",", 
          "master", ",", "info", ",", "tensorID"}], "}"}], "=", 
        RowBox[{"OptionValue", "[", 
         RowBox[{"{", 
          RowBox[{
          "Dagger", ",", "PrintAs", ",", "VanishingQ", ",", "ForceSymmetries",
            ",", "WeightOfTensor", ",", "GradeOfTensor", ",", "FrobeniusQ", 
           ",", "OrthogonalTo", ",", "ProjectedWith", ",", "ProtectNewSymbol",
            ",", "Master", ",", "DefInfo", ",", "TensorID"}], "}"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"ot", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", "ot", "}"}], ",", "1"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pw", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"{", "pw", "}"}], ",", "1"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"anynumberQ", "=", 
        RowBox[{"MemberQ", "[", 
         RowBox[{
          RowBox[{"{", "indices", "}"}], ",", 
          RowBox[{"AnyIndices", "[", 
           RowBox[{"_", "?", "VBundleQ"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"van", " ", "&&", "anynumberQ"}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefTensor", "::", "error"}], ",", 
            "\"\<Cannot define orthogonal tensor with variable rank.\>\""}], 
           "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "alldependencies", ",", "vbundles", ",", "SGS", ",", "tableaux"}], 
         "}"}], "=", 
        RowBox[{"DefTensorChecks", "[", 
         RowBox[{
          RowBox[{"head", "[", "indices", "]"}], ",", "dependencies", ",", 
          "sym", ",", 
          RowBox[{"{", 
           RowBox[{
           "dag", ",", "forcesym", ",", "weight", ",", "grade", ",", 
            "frobeniusQ", ",", "ot", ",", "pw", ",", "anynumberQ"}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "DefInfo", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "info", "]"}], ">", "2"}], ",", 
         RowBox[{"info", "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"dag", "===", "Conjugate"}], ",", 
            RowBox[{"info", "[", 
             RowBox[{"[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "3"}], "}"}], "]"}], "]"}], ",", 
            RowBox[{"info", "[", 
             RowBox[{"[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "]"}], "]"}]}], "]"}]}]}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"MakeDefInfo", "[", 
        RowBox[{"DefTensor", ",", 
         RowBox[{"head", "[", "indices", "]"}], ",", "info", ",", "van"}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"DefTensor", ",", "\"\<Beginning\>\"", ",", 
         RowBox[{"head", "[", "indices", "]"}], ",", "dependencies", ",", 
         "sym", ",", "options"}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Register", " ", "tensor", " ", 
         RowBox[{"symmetries", ".", " ", "Not"}], " ", "possible", " ", "for",
          " ", "a", " ", "variable", " ", "rank", " ", "tensor"}], " ", 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", "anynumberQ"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"SymmetryGroupOfTensor", "[", "head", "]"}], "^=", "SGS"}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"tableaux", "=!=", 
             RowBox[{"{", "}"}]}], ",", 
            RowBox[{
             RowBox[{"SymmetryTableauxOfTensor", "[", "head", "]"}], "^=", 
             "tableaux"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Register", " ", "tensor", " ", "name"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"AppendToUnevaluated", "[", 
        RowBox[{"$Tensors", ",", "head"}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"xTensorQ", "[", "head", "]"}], "^=", "True"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Vbundles", " ", "and", " ", "dependencies"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SlotsOfTensor", "[", "head", "]"}], "^=", "vbundles"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DependenciesOfTensor", "[", "head", "]"}], "^=", 
        "alldependencies"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Other", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"uniqueslots", "=", 
        RowBox[{"Union", "@", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"UpIndex", "/@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"vbundles", "/.", 
               RowBox[{"AnyIndices", "\[Rule]", "Identity"}]}], "/.", 
              RowBox[{
               RowBox[{"PullBackVBundle", "[", 
                RowBox[{"vb_", ",", "phi_"}], "]"}], "\[RuleDelayed]", 
               RowBox[{"Sequence", "[", 
                RowBox[{"vb", ",", "phi"}], "]"}]}]}], ")"}]}], ",", 
           "Labels"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"SymbolRelations", "[", 
        RowBox[{"head", ",", "master", ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Union", "[", 
            RowBox[{"alldependencies", ",", "uniqueslots"}], "]"}], ",", 
           "AnyDependencies"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"frobeniusQ", ",", 
         RowBox[{
          RowBox[{"FrobeniusQ", "[", "head", "]"}], "^=", "frobeniusQ"}]}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefInfo", "[", "head", "]"}], "^=", "info"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TensorID", "[", "head", "]"}], "^=", "tensorID"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetPrintAs", "[", 
        RowBox[{"head", ",", 
         RowBox[{"AddDaggerCharacter", "[", 
          RowBox[{
           RowBox[{"PrintAsString", "[", 
            RowBox[{"head", ",", "pa"}], "]"}], ",", "dag"}], "]"}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"weight", "=!=", "0"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"WeightOfTensor", "[", "head", "]"}], "^=", "weight"}], 
          ";", 
          RowBox[{
           RowBox[{"PrintAs", "[", "head", "]"}], "^=", 
           RowBox[{"addweight", "[", 
            RowBox[{
             RowBox[{"PrintAs", "[", "head", "]"}], ",", "weight"}], 
            "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"grade", "=!=", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"grade", "=", 
           RowBox[{"Flatten", "[", 
            RowBox[{"{", "grade", "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
          
          RowBox[{
           RowBox[{
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"prod", "=", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                RowBox[{"int", "=", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], ",", 
              RowBox[{"TagSet", "[", 
               RowBox[{"head", ",", 
                RowBox[{"GradeOfTensor", "[", 
                 RowBox[{"head", ",", "prod"}], "]"}], ",", "int"}], "]"}]}], 
             "]"}], "&"}], "/@", "grade"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Complex", " ", "conjugation"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", 
        RowBox[{
        "dag", ",", "\[IndentingNewLine]", "Conjugate", ",", "Null", ",", 
         "\[IndentingNewLine]", "Real", ",", 
         RowBox[{
          RowBox[{"Dagger", "[", "head", "]"}], "^=", "head"}], ",", 
         "\[IndentingNewLine]", "Imaginary", ",", 
         RowBox[{
          RowBox[{"Dagger", "[", "head", "]"}], "^=", 
          RowBox[{"MultiplyHead", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "head"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"daghead", "=", 
             RowBox[{"MakeDaggerSymbol", "[", "head", "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"SetDaggerPair", "[", 
             RowBox[{"head", ",", "daghead"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DefTensor", "[", 
             RowBox[{
              RowBox[{"Apply", "[", 
               RowBox[{"daghead", ",", 
                RowBox[{"DaggerIndex", "@", 
                 RowBox[{"IndexList", "[", "indices", "]"}]}]}], "]"}], ",", 
              "dependencies", ",", "SGS", ",", 
              RowBox[{"Dagger", "\[Rule]", "Conjugate"}], ",", 
              RowBox[{"Master", "\[Rule]", "head"}], ",", "options"}], "]"}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"prot", "=", 
                RowBox[{"Unprotect", "[", "daghead", "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Switch", "[", 
                RowBox[{"dag", ",", "\[IndentingNewLine]", "Hermitian", ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"daghead", "[", "inds___", "]"}], ":=", 
                   RowBox[{"TransposeDagger", "[", 
                    RowBox[{"head", "[", "inds", "]"}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"HermitianQ", "[", "head", "]"}], "^=", "True"}]}],
                  ",", "\[IndentingNewLine]", "Antihermitian", ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"daghead", "[", "inds___", "]"}], ":=", 
                   RowBox[{"-", 
                    RowBox[{"TransposeDagger", "[", 
                    RowBox[{"head", "[", "inds", "]"}], "]"}]}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"AntihermitianQ", "[", "head", "]"}], "^=", 
                   "True"}]}], ",", "\[IndentingNewLine]", "Complex", ",", 
                 "Null"}], "\[IndentingNewLine]", "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Protect", "[", "prot", "]"}], ";"}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Vanishing", " ", "and", " ", "projections"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"van", ",", "\[IndentingNewLine]", 
         RowBox[{"SetDelayed", "[", 
          RowBox[{
           RowBox[{"Evaluate", "[", 
            RowBox[{"makepattern", "/@", 
             RowBox[{"head", "[", "indices", "]"}]}], "]"}], ",", "0"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"SetOrthogonal", "[", 
              RowBox[{
               RowBox[{"head", "[", "indices", "]"}], ",", "#"}], "]"}], 
             "&"}], ",", "ot"}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"SetProjected", "[", 
              RowBox[{
               RowBox[{"head", "[", "indices", "]"}], ",", "#"}], "]"}], 
             "&"}], ",", "pw"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"DefTensor", ",", "\"\<End\>\"", ",", 
         RowBox[{"head", "[", "indices", "]"}], ",", "dependencies", ",", 
         "sym", ",", "options"}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Protection", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"pns", ",", 
         RowBox[{"Protect", "[", "head", "]"}]}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefTensor", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefTensor", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"deb184c7-e0aa-446f-acd9-b1fce6458f79"],

Cell["\<\
Functions to detect Hermitian and antihermitian tensors. Note that for a \
Hermitian tensor we have an upvalue True for HermitianQ[tensor], but not for \
its Dagger conjugate. I think this is not a problem because the dagger tensor \
(**on indices**) is automatically converted into the original tensor.\
\>", "Text",ExpressionUUID->"6ad7bdde-4472-40c7-9383-1f9f6a6f25be"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"HermitianQ", "[", "tensor_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntihermitianQ", "[", "tensor_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"HermitianQ", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"AntihermitianQ", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"HermitianQ", ",", "AntihermitianQ"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d798a98f-85c1-4e1a-8daf-1afe2c1a56ab"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"addweight", "[", 
    RowBox[{"string_String", ",", "weight_Plus"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"addweight", ",", "string", ",", 
     RowBox[{"List", "@@", "weight"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addweight", "[", 
    RowBox[{"string_String", ",", 
     RowBox[{"n_.", 
      RowBox[{"basis_Symbol", "?", "BasisQ"}]}]}], "]"}], ":=", 
   RowBox[{"TildeString", "[", 
    RowBox[{"string", ",", "n", ",", 
     RowBox[{"xAct`xCoba`BasisColor", "[", "basis", "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f3eae5f1-8ab8-4952-b291-fcb5eb00a591"],

Cell["Other definitions:", \
"Text",ExpressionUUID->"368aef9b-709a-459e-b0cb-28a79b0bdaa5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", "0", "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{"-", 
       RowBox[{"xAct`xPerm`Cycles", "[", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SymmetryGroupOfTensor", "::", "unknown"}], ",", 
      "\"\<tensor\>\"", ",", "tensor"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryTableauxOfTensor", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{"SymmetryTableauxOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryTableauxOfTensor", "[", 
    RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryTableauxOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SymmetryTableauxOfTensor", "::", "unknown"}], ",", 
      "\"\<tensor\>\"", ",", "tensor"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SlotsOfTensor", "::", "unknown"}], ",", "\"\<tensor\>\"", ",", 
      "tensor"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DependenciesOfTensor", "::", "unknown"}], ",", 
      "\"\<tensor\>\"", ",", "tensor"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorID", "[", "tensor_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FrobeniusQ", "[", 
    RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FrobeniusQ", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"FrobeniusQ", "::", "unknown"}], ",", "\"\<tensor\>\"", ",", 
      "tensor"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOfTensor", "[", 
    RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"WeightOfTensor", "::", "unknown"}], ",", "\"\<tensor\>\"", ",",
       "tensor"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"{", 
    RowBox[{
    "SymmetryGroupOfTensor", ",", "SymmetryTableauxOfTensor", ",", 
     "SlotsOfTensor", ",", "DependenciesOfTensor", ",", "TensorID", ",", 
     "FrobeniusQ", ",", "WeightOfTensor"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", "tmp"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", "tmp", "]"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8e96aa66-4384-43a7-b91d-e9df072aae5f"],

Cell["\<\
This function is now not being used (hence deactivated and not included in \
the package):\
\>", "Text",ExpressionUUID->"e871936c-29fa-41e7-b9b8-be615a7e9f68"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymmetrySlotsOfTensor", "[", 
    RowBox[{"head_", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Complement", "[", 
      RowBox[{
       RowBox[{"Range", "@", "#"}], ",", 
       RowBox[{"StablePoints", "[", 
        RowBox[{
         RowBox[{"GenSet", "@", 
          RowBox[{"SymmetryGroupOfTensor", "[", "head", "]"}]}], ",", "#"}], 
        "]"}]}], "]"}], "&"}], "@", 
    RowBox[{"Length", "[", 
     RowBox[{"SlotsOfTensor", "[", "head", "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetrySlotsOfTensor", "[", "tensor_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SymmetrySlotsOfTensor", "::", "unknown"}], ",", 
      "\"\<tensor\>\"", ",", "tensor"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SymmetrySlotsOfTensor", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SymmetrySlotsOfTensor", "]"}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"8a8d3763-2d97-429d-9e55-5d6c48ca0e3f"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2.4. Undefinition", \
"Subsubsection",ExpressionUUID->"eb648204-4465-46bb-bb2f-4978951b5007"],

Cell["\<\
Note that if the tensor is a metric then we use UndefMetric, which undefines \
a number of associated objects, unsets MetricQ and calls back UndefTensor. To \
avoid using UndefTensor twice on the same tensor we need to add the Return[] \
call.\
\>", "Text",ExpressionUUID->"1ebf9b54-11ae-4378-a51e-b48882fe4966"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefTensor", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "xTensorQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefTensor", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UndefTensor", "[", "tensor_", "]"}], ":=", 
  RowBox[{"Catch", "@", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"servants", "=", 
       RowBox[{"ServantsOf", "[", "tensor", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"xTensorQ", "[", "tensor", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"UndefTensor", "::", "unknown"}], ",", "\"\<tensor\>\"", 
           ",", "tensor"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"MetricQ", "[", "tensor", "]"}], ",", 
        RowBox[{
         RowBox[{"UndefMetric", "[", "tensor", "]"}], ";", 
         RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"CheckRemoveSymbol", "[", "tensor", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"MakexTensions", "[", 
       RowBox[{"UndefTensor", ",", "\"\<Beginning\>\"", ",", "tensor"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"xUpSet", "[", 
       RowBox[{
        RowBox[{"ServantsOf", "[", "tensor", "]"}], ",", 
        RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"DropFromHosts", "[", "tensor", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Undef", "/@", 
       RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"$Tensors", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"$Tensors", ",", "tensor"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"MakexTensions", "[", 
       RowBox[{"UndefTensor", ",", "\"\<End\>\"", ",", "tensor"}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"MakeUndefInfo", "[", 
       RowBox[{"UndefTensor", ",", "tensor"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RemoveSymbol", "[", "tensor", "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefTensor", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefTensor", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2ea20065-e76c-4833-a100-db0332c4e9e9"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2.5. The tensor Zero, and MultiplyHead", \
"Subsubsection",ExpressionUUID->"2d717b3b-1e77-4a07-baf8-a4d5985d4301"],

Cell["It cannot be simpler:", \
"Text",ExpressionUUID->"1aa471be-3e61-40f8-8efa-7ea476ad7a13"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Zero"}]], "Input",ExpressionUUID->"728ef241-173f-41cf-8b0a-eb4cc244b51c"],

Cell[BoxData[
 StyleBox["\<\"Zero[e1, ..., en] is 0 no matter what the arguments are.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672644-5338953",ExpressionUUID->"44da7052-add8-482d-94a8-\
d481b052d541"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "Zero", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", "Zero", "]"}], "^:=", "AnyVBundles"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", "Zero", "]"}], "^:=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{"-", 
       RowBox[{"xAct`xPerm`Cycles", "[", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", "Zero", "]"}], "^:=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", "Zero", "]"}], "^:=", "Zero"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Zero", "[", "___", "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Zero", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyHead", "[", 
     RowBox[{"k_", ",", "tensor_Symbol"}], "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{"k", " ", 
    RowBox[{"tensor", "[", "inds", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeadOfTensor", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
     RowBox[{"{", "inds___", "}"}]}], "]"}], ":=", "tensor"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeadOfTensor", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"k_", "?", "ConstantQ"}], " ", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}]}], ",", 
     RowBox[{"{", "inds___", "}"}]}], "]"}], ":=", 
   RowBox[{"MultiplyHead", "[", 
    RowBox[{"k", ",", "tensor"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeadOfTensor", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", "___", "}"}]}], "]"}], ":=", "Zero"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorPlus", "[", "tensors__", "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"Through", "[", 
     RowBox[{
      RowBox[{"{", "tensors", "}"}], "[", "inds", "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorPlus", "[", "]"}], "[", "___", "]"}], ":=", "0"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a7102e1d-8140-4aba-adc9-f8664cadcc1b"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2.6. Examples", \
"Subsubsection",ExpressionUUID->"81eda3c5-7078-4e52-90cc-e83cbd5058fe"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c9aa349e-ef1b-4a8e-995a-12b35c5add4d"],

Cell["Let us create an inner complex bundle:", \
"Text",ExpressionUUID->"8845dd60-3d8f-4897-b250-578298eccb72"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a8484155-b259-495d-92b8-46ea000b10e5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"637fc4fb-93cb-463a-a415-c0f058806bf1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b29a9df-ba10-4748-9429-a63326a083f3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d22ca6be-9283-41fb-bc35-29b207f22b06"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"08b2da8b-0032-462b-89c2-2b5504aa5965"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{
    "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
     "h"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c1c5404-7666-44bb-91a8-d9570726cae2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"095dcd82-af86-4415-a3ff-01282382d289"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a1c5d1a2-e1cc-4318-94e3-0c44cbd71889"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefVBundle", "[", 
  RowBox[{"InnerC", ",", "M2", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{"U", ",", "W"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Complex"}]}], 
  "]"}]], "Input",ExpressionUUID->"1d27796a-0e85-4184-89fa-38f4ebccc72a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "InnerC", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`InnerC, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"73024662-06fb-43f2-8e8a-72220429cd05"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"conjugated vbundle \"\>", "\[InvisibleSpace]", 
   "InnerC\[Dagger]", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Assuming fixed anti-isomorphism between InnerC \
and InnerC\[Dagger]\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "conjugated vbundle ", $CellContext`InnerC\[Dagger], ". ", 
   "Assuming fixed anti-isomorphism between InnerC and InnerC\[Dagger]"],
  Editable->
   False]], "Print",ExpressionUUID->"a5d3dc8b-1f7f-4a1b-a63e-3a5b069da07d"]
}, Open  ]]
}, Open  ]],

Cell["Errors:", "Text",ExpressionUUID->"d5c35cc1-803f-4987-b408-bb401074786e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  "]"}]], "Input",ExpressionUUID->"ac8f02b3-c9ae-436c-9bca-492aec911ab5"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "argm"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(DefTensor\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(2\\)\[NoBreak] or \
more arguments are expected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/argm\\\", ButtonNote -> \
\\\"xAct`xTensor`DefTensor::argm\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"945d6298-d511-496a-a954-631de2b8df1e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"S", ",", 
      RowBox[{"-", "A"}], ",", "c"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"8e79dc32-4e57-467e-9c90-6a6bca13e37d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(S\\)\[NoBreak] is not a valid \
\[NoBreak]\\!\\(\\\"index at definition\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c26a5f99-5325-45fd-a146-cc7a25669e7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"A", "+", "B"}], ",", 
      RowBox[{"-", "C"}], ",", "c"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"0700443d-0391-4786-9392-dca28f42588b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(A + B\\)\[NoBreak] is not a valid \
\[NoBreak]\\!\\(\\\"index at definition\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4374f5f0-c08e-4a7d-a5a8-500a2e26bc9d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}], ",", "c"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"8cd8da24-a490-414f-8105-8c46bef9698d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "nodummy"}], "MessageName"], ":", 
  " ", "\<\"Tensor cannot be defined with dummy indices.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"766d849c-7c80-4cdf-989d-a78e2f24a007"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefParameter", "[", "time", 
  "]"}]], "Input",ExpressionUUID->"6fc28888-0229-42b3-ad2d-fc7b642109a8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefParameter", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"parameter \"\>", "\[InvisibleSpace]", "time", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefParameter, ": Defining ", 
   "parameter ", $CellContext`time, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"56f42e7d-5ff0-400c-a100-6af56aa9c6d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2", ",", "time"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"16fbe89d-ef93-4cb2-82a0-b4fd6c27395d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"77223772-47e4-4eb5-a2a5-b81fc6b83970"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "T"}]], "Input",ExpressionUUID->"439a2285-e832-4158-a874-354338b632a8"],

Cell[CellGroupData[{

Cell["Global`T", "Print", "PrintUsage",
 CellTags->
  "Info3578672648-5338953",ExpressionUUID->"ef4c5811-f4e4-4f91-a046-\
93f0fbd806dd"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "T", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "T", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`T],
          Editable->False], "^=", "T"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "T", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "T", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["time",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`time,
            Editable->False], ",", "M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "T", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["time",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`time,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "T", "]"}], "^=", "\<\"T\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "T", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "T", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "T", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "T", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`T],
  Editable->False]], "Print",
 CellTags->
  "Info3578672648-5338953",ExpressionUUID->"1f797f1b-d73d-4680-b5f9-\
ec26b62416e1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", "c"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"49bee568-b307-4199-95db-193d144f389c"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "protected"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"T\\\"\\)\[NoBreak] is \[NoBreak]\\!\\(\
\\\"Protected\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1449e797-59d0-4bc1-abaa-f4f42a04b460"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[GothicCapitalT]\>\""}], ",", 
   RowBox[{"OrthogonalTo", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"2d8b2c46-0e0c-4d37-8f37-eafa5406bd5c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TT[$CellContext`A, -$CellContext`B, $CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d0a1deca-8a7d-4179-b9d5-27ae3a1057a6"],

Cell[BoxData["\<\"{TT, MakeRule[{T[-A] TT[A, -B, c], 0}, MetricOn -> All, \
ContractMetrics -> True], Verbose -> False}\"\>"], \
"Print",ExpressionUUID->"9bb7ff30-c9b4-4045-8111-a6ad1b82e8a3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "noorth"}], "MessageName"], ":", 
  " ", "\<\"Tensor \[NoBreak]\\!\\(TT[\\(\\(A, \\(\\(-B\\)\\), c\\)\\)]\\)\
\[NoBreak] could not be made orthogonal to vector \
\[NoBreak]\\!\\(T[\\(\\(-A\\)\\)]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"806e0ac6-41ca-4a6e-b369-326c11683215"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TTT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[GothicCapitalT]\>\""}], ",", 
   RowBox[{"OrthogonalTo", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}], "}"}]}], ",", 
   RowBox[{"ProjectedWith", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", "C"}], "]"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"2982a0c3-3335-4cef-a239-6ff285dcc8cf"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TTT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TTT[$CellContext`A, -$CellContext`B, $CellContext`c], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"396f01df-4b97-4416-84a7-ed6515009bc6"],

Cell[BoxData["\<\"{TTT, MakeRule[{T[-A] TTT[A, -B, c], 0}, MetricOn -> All, \
ContractMetrics -> True], Verbose -> False}\"\>"], \
"Print",ExpressionUUID->"49a28e65-1414-4d66-835a-a27d202df2c1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "noorth"}], "MessageName"], ":", 
  " ", "\<\"Tensor \[NoBreak]\\!\\(TTT[\\(\\(A, \\(\\(-B\\)\\), c\\)\\)]\\)\
\[NoBreak] could not be made orthogonal to vector \
\[NoBreak]\\!\\(T[\\(\\(-A\\)\\)]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"901bc3b3-9d95-46ac-8611-da86d9d9ab87"],

Cell[BoxData["\<\"{TTT, MakeRule[{T[-A, C] TTT[A, -B, c], TTT[C, -B, c]}, \
MetricOn -> All, ContractMetrics -> True], Verbose -> False}\"\>"], \
"Print",ExpressionUUID->"d12e39a5-461b-47c2-92fe-7c0a07860d51"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"14e22bc3-abb8-4ab1-8c8c-83c95ef9baab"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", ",", "TT", ",", "TTT"}], 
  "}"}]], "Output",ExpressionUUID->"125514a8-4a66-484c-894e-48fbb17549d2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TT"}]], "Input",ExpressionUUID->"3f54e884-3fd3-4375-a58e-2d1bef7b9b67"],

Cell[CellGroupData[{

Cell["Global`TT", "Print", "PrintUsage",
 CellTags->
  "Info3578672651-5338953",ExpressionUUID->"3f4d9740-1af4-4386-9ea3-\
1dfd0c26c30f"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "TT", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "TT", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TT],
          Editable->False], "^=", "TT"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "TT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "TT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "TT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "TT", "]"}], 
         "^=", "\<\"\[GothicCapitalT]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "TT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "TT", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "TT", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "TT", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TT],
  Editable->False]], "Print",
 CellTags->
  "Info3578672651-5338953",ExpressionUUID->"1bc2c959-8627-4dac-8d9d-\
e9ded1e6a8b0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TTTT", "[", "A", "]"}], ",", "M2", ",", 
   RowBox[{"VanishingQ", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"0608445e-7f8c-4178-bfca-dff93a62eb6f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TTTT", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing tensor ", 
   $CellContext`TTTT[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4a223f0b-a74c-4675-ab61-4ef43bcc2729"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TTTT", "[", 
  RowBox[{"-", "A"}], 
  "]"}]], "Input",ExpressionUUID->"5b77945a-827a-49df-bc39-2af979486295"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"0b6b8a6f-e049-431f-a176-d79c6b4abd7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CdS", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"TT", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "B"}], ",", "c"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2b90738c-4852-42b2-a860-fee07a56c46d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"CdS[-a]\\\"\\)\[NoBreak] is invalid \
because it \[NoBreak]\\!\\(\\\"is not atomic\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"95173ccd-bb92-4d04-91d0-dea99fd63c23"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "CdS", 
  "]"}]], "Input",ExpressionUUID->"4d0fab64-863a-42fd-bfa8-dcf130a9e6c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"TC", "[", 
     RowBox[{"W", ",", 
      RowBox[{"-", "A"}], ",", "c"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"dc1002eb-8c23-48ea-a1bf-57904851293e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(Real\\)\[NoBreak] is not a valid \[NoBreak]\\!\\(\
\\\"value for Dagger: complex indices\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8b93519e-be4e-42eb-9fad-fc3bb92e3eea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TC", "[", 
    RowBox[{"W", ",", 
     RowBox[{"-", "A"}], ",", "c"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Complex"}]}], 
  "]"}]], "Input",ExpressionUUID->"26166bd7-0587-4f01-bf0e-8a893c4eab79"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TC", "[", 
    RowBox[{"W", ",", 
     RowBox[{"-", "A"}], ",", "c"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TC[$CellContext`W, -$CellContext`A, $CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"52afea4a-edb9-4d58-b504-c925698add89"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TC\[Dagger]", "[", 
    RowBox[{"W\[Dagger]", ",", 
     RowBox[{"-", "A"}], ",", "c"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TC\[Dagger][$CellContext`W\[Dagger], -$CellContext`A, \
$CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e33049f2-be07-4483-9488-6349c0a6da5d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TC"}]], "Input",ExpressionUUID->"852e2cb1-fae2-4b62-b3f0-94751e3fc0b6"],

Cell[CellGroupData[{

Cell["Global`TC", "Print", "PrintUsage",
 CellTags->
  "Info3578672654-5338953",ExpressionUUID->"d937c59f-4139-46b1-b8b8-\
a9966b0f33d3"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "TC", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "TC", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TC],
          Editable->False], "^=", "TC\[Dagger]"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "TC", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "TC", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "TC", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["InnerC",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`InnerC,
            Editable->False], ",", "M2", ",", "S2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "TC", "]"}], "^=", "\<\"TC\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "TC", "]"}], "^=", 
         RowBox[{"{", "TC\[Dagger]", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "TC", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["InnerC",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`InnerC,
            Editable->False], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "TC", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "TC", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "TC", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TC],
  Editable->False]], "Print",
 CellTags->
  "Info3578672654-5338953",ExpressionUUID->"705488d5-a97d-44df-8095-\
c84c2f909de1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TC\[Dagger]"}]], \
"Input",ExpressionUUID->"523bc275-0673-4cd1-80b0-75cdce708866"],

Cell[CellGroupData[{

Cell["Global`TC\[Dagger]", "Print", "PrintUsage",
 CellTags->
  "Info3578672655-5338953",ExpressionUUID->"d57eabf8-c97b-4c06-a6da-\
27b30d30c7b6"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "TC\[Dagger]", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "TC\[Dagger]", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TC\[Dagger]],
          Editable->False], "^=", "TC"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "TC\[Dagger]", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "TC\[Dagger]", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "TC\[Dagger]", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["InnerC\[Dagger]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`InnerC\[Dagger],
            Editable->False], ",", "M2", ",", "S2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", "TC\[Dagger]", "]"}], "^=", "TC"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "TC\[Dagger]", "]"}], 
         "^=", "\<\"TC\[Dagger]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "TC\[Dagger]", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["InnerC\[Dagger]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`InnerC\[Dagger],
            Editable->False], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "TC\[Dagger]", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "TC\[Dagger]", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "TC\[Dagger]", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TC\[Dagger]],
  Editable->False]], "Print",
 CellTags->
  "Info3578672655-5338953",ExpressionUUID->"887b86d1-2631-4977-a010-\
11cd38c651d6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Dagger", "[", 
   RowBox[{"TC", "[", 
    RowBox[{"U", ",", 
     RowBox[{"-", "A"}], ",", "b"}], "]"}], "]"}], "//", 
  "Trace"}]], "Input",ExpressionUUID->"4f57ac0d-9fb0-458f-b366-9310b4e769e6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     StyleBox[
      RowBox[{"Dagger", "[", 
       RowBox[{"TC", "[", 
        RowBox[{"U", ",", 
         RowBox[{"-", "A"}], ",", "b"}], "]"}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Dagger[
      $CellContext`TC[$CellContext`U, -$CellContext`A, $CellContext`b]],
     Editable->False],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"NumericQ", "[", 
       RowBox[{"TC", "[", 
        RowBox[{"U", ",", 
         RowBox[{"-", "A"}], ",", "b"}], "]"}], "]"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xTensorQ", "[", "TC", "]"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"Dagger", "[", "TC", "]"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`Dagger[$CellContext`TC],
      Editable->False], "@@", 
     RowBox[{"DaggerIndex", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["{",
          FontColor->RGBColor[0, 0, 1]], "U", "\<\",\"\>", 
         RowBox[{"-", "A"}], "\<\",\"\>", "b", 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`IndexList[$CellContext`U, -$CellContext`A, $CellContext`b],
       Editable->False], "]"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{"Dagger", "[", "TC", "]"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Dagger[$CellContext`TC],
       Editable->False],
      HoldForm], ",", 
     TagBox["TC\[Dagger]",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"DaggerIndex", "[", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          StyleBox["{",
           FontColor->RGBColor[0, 0, 1]], "U", "\<\",\"\>", 
          RowBox[{"-", "A"}], "\<\",\"\>", "b", 
          StyleBox["}",
           FontColor->RGBColor[0, 0, 1]]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`IndexList[$CellContext`U, -$CellContext`A, \
$CellContext`b],
        Editable->False], "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"DaggerIndex", "/@", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          StyleBox["{",
           FontColor->RGBColor[0, 0, 1]], "U", "\<\",\"\>", 
          RowBox[{"-", "A"}], "\<\",\"\>", "b", 
          StyleBox["}",
           FontColor->RGBColor[0, 0, 1]]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`IndexList[$CellContext`U, -$CellContext`A, \
$CellContext`b],
        Editable->False]}],
      HoldForm], ",", 
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["{",
          FontColor->RGBColor[0, 0, 1]], "U\[Dagger]", "\<\",\"\>", 
         RowBox[{"-", "A"}], "\<\",\"\>", "b", 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`IndexList[
        xAct`xTensor`DaggerIndex[$CellContext`U], 
        xAct`xTensor`DaggerIndex[-$CellContext`A], 
        xAct`xTensor`DaggerIndex[$CellContext`b]],
       Editable->False],
      HoldForm], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"DaggerIndex", "[", "U", "]"}],
        HoldForm], ",", 
       TagBox["U\[Dagger]",
        HoldForm]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"DaggerIndex", "[", 
         RowBox[{"-", "A"}], "]"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"-", 
         RowBox[{"DaggerIndex", "[", "A", "]"}]}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"DaggerIndex", "[", "A", "]"}],
          HoldForm], ",", 
         TagBox["A",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"-", "A"}],
        HoldForm]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"DaggerIndex", "[", "b", "]"}],
        HoldForm], ",", 
       TagBox["b",
        HoldForm]}], "}"}], ",", 
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["{",
          FontColor->RGBColor[0, 0, 1]], "U\[Dagger]", "\<\",\"\>", 
         RowBox[{"-", "A"}], "\<\",\"\>", "b", 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`IndexList[$CellContext`U\[Dagger], -$CellContext`A, \
$CellContext`b],
       Editable->False],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"TC\[Dagger]", "@@", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], "U\[Dagger]", "\<\",\"\>", 
        RowBox[{"-", "A"}], "\<\",\"\>", "b", 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[$CellContext`U\[Dagger], -$CellContext`A, \
$CellContext`b],
      Editable->False]}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"TC\[Dagger]", "[", 
     RowBox[{"U\[Dagger]", ",", 
      RowBox[{"-", "A"}], ",", "b"}], "]"}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"5d89c7e7-29d8-4a8c-8d69-0fb063cca9e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "TC", 
  "]"}]], "Input",ExpressionUUID->"33fc16c0-66be-4c2b-a94b-a6adc9ab1448"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TC\[Dagger]"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TC\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"92e7867a-125c-4845-90f1-268e4471b14a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TC"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TC],
  Editable->
   False]], "Print",ExpressionUUID->"3d6196b6-8066-4fd2-a80e-b3dd233df044"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TCC", "[", 
    RowBox[{"U", ",", "W\[Dagger]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"Dagger", "\[Rule]", "Hermitian"}]}], 
  "]"}]], "Input",ExpressionUUID->"dc63b410-9b81-4b53-b41b-b7d03a1e4a01"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TCC", "[", 
    RowBox[{"U", ",", "W\[Dagger]"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TCC[$CellContext`U, $CellContext`W\[Dagger]], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"523e7ed6-729b-4dde-823f-6c673c25510d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TCC\[Dagger]", "[", 
    RowBox[{"U\[Dagger]", ",", "W"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TCC\[Dagger][$CellContext`U\[Dagger], $CellContext`W], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"b220a734-c3aa-47bc-ac4a-6e6687fbd91f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TCC", "[", 
  RowBox[{"U", ",", "W\[Dagger]"}], 
  "]"}]], "Input",ExpressionUUID->"68702262-d6bd-4f41-bb6a-30aff5d82a20"],

Cell[BoxData[
 RowBox[{"TCC", "[", 
  RowBox[{"U", ",", "W\[Dagger]"}], 
  "]"}]], "Output",ExpressionUUID->"1d71cddb-fd0f-4b8e-b4fc-ab3914b82463"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dagger", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"179d00a8-f289-4e0f-9027-9534f5497974"],

Cell[BoxData[
 RowBox[{"TransposeDagger", "[", 
  RowBox[{"TCC", "[", 
   RowBox[{"U\[Dagger]", ",", "W"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"69c454c0-81f5-4cfd-8c6f-313dbb71721f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "TCC", 
  "]"}]], "Input",ExpressionUUID->"1adc977d-5f8f-4f2e-bb71-467043725f03"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TCC\[Dagger]"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TCC\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"2e971f1c-b53a-4ff4-8b76-1025f1aed421"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TCC"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TCC],
  Editable->
   False]], "Print",ExpressionUUID->"562d279a-687c-4fc1-8644-7d0d829b8ff8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"C", "[", "A", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"M2", ",", "S2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"446cb296-cd69-476f-b076-06ecc1f9d60d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "used"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is already used \
\[NoBreak]\\!\\(\\\"as an abstract index\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"38d52fcf-f7be-4281-b451-aadcacec692e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", "A", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c06cdec2-5f7f-468b-a8aa-f01437cac7e9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a1a385d1-b3d9-41aa-a3a0-d1c0d4609495"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"r", "[", "]"}], ",", 
    RowBox[{"{", "M2", "}"}], ",", 
    RowBox[{"OrthogonalTo", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"T", "[", "A", "]"}], "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"074573c4-9aea-4ebf-814a-1970fcad8d0e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"A scalar cannot be orthogonal to a vector\\\"\
\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"f1805989-466e-4964-9984-b163291e7ac9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", 
   RowBox[{"{", "M2", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"afcd0a26-b595-4576-9926-734965e5b543"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7a2e166e-d0c5-442a-a7c4-8508e67d6b66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "r"}]], "Input",ExpressionUUID->"156b5251-424d-4e5f-aca5-2f20ca05399c"],

Cell[CellGroupData[{

Cell["Global`r", "Print", "PrintUsage",
 CellTags->
  "Info3578672658-5338953",ExpressionUUID->"828fa17d-8586-4e07-aeb3-\
f7fb501b736f"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "r", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "r", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`r],
          Editable->False], "^=", "r"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "r", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "r", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "r", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "r", "]"}], "^=", "\<\"r\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "r", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "r", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "r", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "r", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`r],
  Editable->False]], "Print",
 CellTags->
  "Info3578672658-5338953",ExpressionUUID->"be996715-9f6d-4241-91f4-\
523e345d94f7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Dagger", "[", 
   RowBox[{"r", "[", "]"}], "]"}], "//", 
  "Trace"}]], "Input",ExpressionUUID->"e35703a4-f550-4086-8005-98144b286d65"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     StyleBox[
      RowBox[{"Dagger", "[", 
       RowBox[{"r", "[", "]"}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Dagger[
      $CellContext`r[]],
     Editable->False],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"NumericQ", "[", 
       RowBox[{"r", "[", "]"}], "]"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xTensorQ", "[", "r", "]"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"Dagger", "[", "r", "]"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`Dagger[$CellContext`r],
      Editable->False], "@@", 
     RowBox[{"DaggerIndex", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{"{", "}"}],
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0, 0, 1]],
       xAct`xTensor`IndexList[],
       Editable->False], "]"}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{"Dagger", "[", "r", "]"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Dagger[$CellContext`r],
       Editable->False],
      HoldForm], ",", 
     TagBox["r",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"DaggerIndex", "[", 
       InterpretationBox[
        StyleBox[
         RowBox[{"{", "}"}],
         ShowAutoStyles->False,
         AutoSpacing->False,
         FontColor->RGBColor[0, 0, 1]],
        xAct`xTensor`IndexList[],
        Editable->False], "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"DaggerIndex", "/@", 
       InterpretationBox[
        StyleBox[
         RowBox[{"{", "}"}],
         ShowAutoStyles->False,
         AutoSpacing->False,
         FontColor->RGBColor[0, 0, 1]],
        xAct`xTensor`IndexList[],
        Editable->False]}],
      HoldForm], ",", 
     TagBox[
      InterpretationBox[
       StyleBox[
        RowBox[{"{", "}"}],
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0, 0, 1]],
       xAct`xTensor`IndexList[],
       Editable->False],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"r", "@@", 
     InterpretationBox[
      StyleBox[
       RowBox[{"{", "}"}],
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0, 0, 1]],
      xAct`xTensor`IndexList[],
      Editable->False]}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"r", "[", "]"}],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"fbeb9f0f-7f14-4e6e-a48a-5e62c641f8f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"R", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "B"}], "]"}], ",", 
    RowBox[{"{", "M2", "}"}], ",", 
    RowBox[{"Symmetric", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"21bb5f18-cd35-4776-9d0b-c84c9fbf5b4f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "wrongsym"}], "MessageName"], ":", 
  " ", "\<\"Symmetry properties are inconsistent with indices of \
tensor.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d62e0e7d-c23a-48ad-8680-b7659099525a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"5f6eaac1-4b34-4cb9-8766-4f033a89955b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ae011b56-d9c3-4bfd-a4b6-552ff0eab8f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "R"}]], "Input",ExpressionUUID->"435c3d31-3f20-4709-97ab-da8e01134b64"],

Cell[CellGroupData[{

Cell["Global`R", "Print", "PrintUsage",
 CellTags->
  "Info3578672660-5338953",ExpressionUUID->"5f9c2362-69da-4a94-8035-\
b628541e1003"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "R", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "R", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`R],
          Editable->False], "^=", "R"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "R", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "R", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "R", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "R", "]"}], "^=", "\<\"R\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "R", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "R", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "1", ",", "2", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{1, 2}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "R", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "R", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`R],
  Editable->False]], "Print",
 CellTags->
  "Info3578672660-5338953",ExpressionUUID->"bc93275a-3c69-4a78-a458-\
31830adc872c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"RR", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "A"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"71af4bef-2bc1-4dc3-93b8-a3fb87ae9af0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RR", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`RR[-C, -$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4b0d39aa-7eda-4b30-8b6b-513db64b30ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RR"}]], "Input",ExpressionUUID->"a0d40a20-2b40-4b26-b489-2add934989ef"],

Cell[CellGroupData[{

Cell["Global`RR", "Print", "PrintUsage",
 CellTags->
  "Info3578672662-5338953",ExpressionUUID->"51d6ad2b-182a-4d9f-b9da-\
00ea88a745be"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "RR", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "RR", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`RR],
          Editable->False], "^=", "RR"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "RR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "RR", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "RR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "RR", "]"}], "^=", "\<\"RR\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "RR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "RR", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "2", ",", "3", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{2, 3}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "RR", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "RR", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`RR],
  Editable->False]], "Print",
 CellTags->
  "Info3578672662-5338953",ExpressionUUID->"1f60b6bf-1140-4b9c-b2a0-\
583939c9ba8a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"RRR", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Perm", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "}"}], "]"}]}], ",", 
     RowBox[{"-", 
      RowBox[{"Perm", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "B"}]}], "}"}], "]"}]}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1b4e0cd0-b4cf-4c02-8fee-ae0c0b9930c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RRR", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`RRR[-C, -$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f3842e01-113a-47db-8d0c-2f7513fd3630"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RRR"}]], "Input",ExpressionUUID->"a754a392-8ef1-44cd-904e-6f3c6d89581f"],

Cell[CellGroupData[{

Cell["Global`RRR", "Print", "PrintUsage",
 CellTags->
  "Info3578672663-5338953",ExpressionUUID->"b484e88e-f7b0-4833-baf8-\
b605936fcf1e"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "RRR", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "RRR", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`RRR],
          Editable->False], "^=", "RRR"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "RRR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "RRR", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "RRR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "RRR", "]"}], "^=", "\<\"RRR\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "RRR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "RRR", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            RowBox[{
             InterpretationBox[
              StyleBox[
               RowBox[{"-", 
                RowBox[{"(", "1", ",", "2", ")"}]}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              -xAct`xPerm`Cycles[{1, 2}],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{"-", 
                RowBox[{"(", "2", ",", "3", ")"}]}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              -xAct`xPerm`Cycles[{2, 3}],
              Editable->False]}], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "RRR", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "RRR", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`RRR],
  Editable->False]], "Print",
 CellTags->
  "Info3578672663-5338953",ExpressionUUID->"bbf8ecf6-49cb-4572-b892-\
5d3b5e4f72d4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"RRRR", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{"-", 
     RowBox[{"Perm", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "C"}], ",", 
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "A"}]}], "}"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8f553b9c-2238-446f-8e09-4200f0edb2d7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RRRR", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`RRRR[-C, -$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"eeb6fbf3-492f-4038-b652-413eed91040d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RRRR"}]], "Input",ExpressionUUID->"27201032-97c8-4c03-a4e3-f2811211a593"],

Cell[CellGroupData[{

Cell["Global`RRRR", "Print", "PrintUsage",
 CellTags->
  "Info3578672665-5338953",ExpressionUUID->"0e93394b-a4d1-484c-bf28-\
31c1caa46937"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "RRRR", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "RRRR", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`RRRR],
          Editable->False], "^=", "RRRR"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "RRRR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "RRRR", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "RRRR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "RRRR", "]"}], "^=", "\<\"RRRR\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "RRRR", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "RRRR", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"-", 
               RowBox[{"(", "2", ",", "3", ")"}]}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             -xAct`xPerm`Cycles[{2, 3}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "RRRR", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "RRRR", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`RRRR],
  Editable->False]], "Print",
 CellTags->
  "Info3578672665-5338953",ExpressionUUID->"a22ad76c-98f8-4e82-8ef5-\
89b15412ef7f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", "$Tensors"}], 
  ";"}]], "Input",ExpressionUUID->"c1077f7d-e2f8-4de6-98e9-2a485b970143"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"17efedf2-a870-44ad-9687-4b126ec1eb30"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TT],
  Editable->
   False]], "Print",ExpressionUUID->"000a5282-fd7a-4aa6-b4eb-4d021acba8a2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TTT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TTT],
  Editable->
   False]], "Print",ExpressionUUID->"241ba81f-d41f-43ad-9958-e5eeb6ba0d2a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TTTT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TTTT],
  Editable->
   False]], "Print",ExpressionUUID->"48d4a4b5-6c33-46cf-8370-2e930752a1ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"61f0efb1-789c-4cfb-a7d1-7eae0fac846e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"f2c7e572-246d-46fe-84ee-f25b553ca77b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"e664759f-c14a-46aa-ac5a-49f056d27d8d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "RR"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`RR],
  Editable->
   False]], "Print",ExpressionUUID->"7dd1fc8c-ce81-479a-89a0-86694225deef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "RRR"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`RRR],
  Editable->
   False]], "Print",ExpressionUUID->"191edce5-5772-4610-875a-be3d6f21af24"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "RRRR"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`RRRR],
  Editable->
   False]], "Print",ExpressionUUID->"55da1bf6-0165-4fea-8466-ac0536a6a334"]
}, Open  ]]
}, Open  ]],

Cell["Check of ManifoldsOf:", \
"Text",ExpressionUUID->"75a9111b-a28f-4dc7-8488-9fab7c9b6a22"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"5e9908a4-ad9a-4470-b713-af26c181ace8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"17822a12-9b88-43c8-bb45-a1603bc34a7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"9ef7d0ca-45a2-491d-ab45-c9e37804ba6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7b1dade5-fc25-4c91-bf82-b4553d614283"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "a", "]"}], ",", "S2"}], 
  "]"}]], "Input",ExpressionUUID->"c290d545-c602-4cb3-bd5a-596cb9428116"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "a", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a7cb619a-93bb-4a29-951f-980405abe487"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManifoldsOf", "[", 
  RowBox[{"r", "[", "]"}], 
  "]"}]], "Input",ExpressionUUID->"fc2b718c-3783-4526-a4e5-24ea146701b1"],

Cell[BoxData[
 RowBox[{"{", "M2", 
  "}"}]], "Output",ExpressionUUID->"d09578c2-78e3-4cc1-9d08-03921ac6e779"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManifoldsOf", "[", "1", 
  "]"}]], "Input",ExpressionUUID->"844c44b1-c9d2-47e6-85cc-35d0144ad328"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"6122611d-fda3-4b6e-bb74-911ccf32b9c2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManifoldsOf", "[", 
  RowBox[{"1", "+", 
   RowBox[{"r", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6c1c8ddf-88cf-4d7f-a29f-0d1d049f763e"],

Cell[BoxData[
 RowBox[{"{", "M2", 
  "}"}]], "Output",ExpressionUUID->"bdcbd112-4439-4093-8888-a6deac812e55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManifoldsOf", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], "+", 
   RowBox[{
    RowBox[{"w", "[", "a", "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "a"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"06f6d44a-fdf7-4c40-9cac-5d5e6b1f5361"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M2", ",", "S2"}], 
  "}"}]], "Output",ExpressionUUID->"85bbf6c5-af13-4bc8-a600-e971b98d9fe0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "x", 
  "]"}]], "Input",ExpressionUUID->"0cde8861-0828-42e7-9cbd-5c89e469e102"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`x, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0249f946-9b3b-47d2-b8ee-07176184a85b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManifoldsOf", "[", 
  RowBox[{"1", "+", 
   RowBox[{
    RowBox[{"r", "[", "]"}], "x"}]}], 
  "]"}]], "Input",ExpressionUUID->"5f638e51-a3e9-4e55-9c6d-df2849fbe671"],

Cell[BoxData[
 RowBox[{"{", "M2", 
  "}"}]], "Output",ExpressionUUID->"86c7cc89-88f2-46d0-b985-a2003b2be389"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManifoldsOf", "[", 
  RowBox[{"1", "+", 
   RowBox[{
    RowBox[{"r", "[", "]"}], "x"}], "+", 
   RowBox[{
    RowBox[{"O", "[", "x", "]"}], "^", "2"}]}], 
  "]"}]], "Input",ExpressionUUID->"e8c59ff0-18e7-4da0-bad1-a94cd357479e"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"9ccb6697-c16a-4b9d-9a5d-126a7bed7ca2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", "$Tensors"}], 
  ";"}]], "Input",ExpressionUUID->"b8c28a1f-5c51-487e-9340-b50606400f7d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"864eccac-a1db-4f85-8d6b-ef1e00f0f844"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"baa6fd35-bbfb-4419-842e-39ff9c5be05b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"8cf42fd2-69c2-47ae-b19d-f1e54ea9ff87"]
}, Open  ]]
}, Open  ]],

Cell["Check of ReplaceDummies:", \
"Text",ExpressionUUID->"e1263320-90af-475d-9742-edbef0726d36"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"dfd5c157-ffaf-4a17-87c7-bcffaec7e2d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"61c44921-8e3e-4621-9802-08bf9e58f96e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"t", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", "W"}], "]"}], ",", "S2", ",", 
   RowBox[{"Dagger", "\[Rule]", "Complex"}]}], 
  "]"}]], "Input",ExpressionUUID->"c1ae6b00-1a24-429c-9c07-a65175cc60b4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"t", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", "W"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`t[-$CellContext`a, -$CellContext`b, $CellContext`W], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3e32567b-7ba9-4f93-8a7a-8dacd2ec3785"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"t\[Dagger]", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", "W\[Dagger]"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`t\[Dagger][-$CellContext`a, -$CellContext`b, $CellContext`W\
\[Dagger]], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"15682c19-2ae8-4afd-a9f3-a2edf50e0958"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B"}], "]"}], 
   RowBox[{"t", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", "b"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d9322f23-3659-4a25-9771-a5d3c71e2fbb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "[", 
   RowBox[{"h$145216", ",", 
    RowBox[{"-", "h$145216"}], ",", "b"}], "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{"H$145217", ",", 
    RowBox[{"-", "H$145217"}], ",", "B"}], 
   "]"}]}]], "Output",ExpressionUUID->"59454ef1-8e89-4f90-a44e-e298186f3f95"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B", ",", "W"}], "]"}], 
   RowBox[{"t", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", "b", ",", 
     RowBox[{"-", "W"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c6f3b9c-99d6-4cdb-846d-402521a7ad64"],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "[", 
   RowBox[{"h$145218", ",", 
    RowBox[{"-", "h$145218"}], ",", "b", ",", 
    RowBox[{"-", "W$145220"}]}], "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{"H$145219", ",", 
    RowBox[{"-", "H$145219"}], ",", "B", ",", "W$145220"}], 
   "]"}]}]], "Output",ExpressionUUID->"64dcbd25-31b7-42e8-aecf-119f583bb7cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B", ",", "W\[Dagger]"}], "]"}], 
   RowBox[{"t\[Dagger]", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", "b", ",", 
     RowBox[{"-", "W\[Dagger]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6caf0144-39e3-473f-9715-fcf5fd949907"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"H$145222", ",", 
    RowBox[{"-", "H$145222"}], ",", "B", ",", "W\[Dagger]$145223"}], "]"}], 
  " ", 
  RowBox[{"t\[Dagger]", "[", 
   RowBox[{"h$145224", ",", 
    RowBox[{"-", "h$145224"}], ",", "b", ",", 
    RowBox[{"-", "W\[Dagger]$145223"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"b9a4f47a-c856-4149-be6f-57a05aba13ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", "B"}], "]"}], 
   RowBox[{"t", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "a"}], ",", "b"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6f9cc435-00ef-4ade-991d-1cc17aeef293"],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "[", 
   RowBox[{"h$145225", ",", 
    RowBox[{"-", "h$145225"}], ",", "b"}], "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"H$145226", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "H$145226"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", "B"}], 
   "]"}]}]], "Output",ExpressionUUID->"c0abb0b2-26b7-4867-a817-b0fdaf52e2fa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}], ",", "B"}], "]"}], 
    RowBox[{"t", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "Polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "a"}], ",", 
        RowBox[{"-", "Polar"}]}], "}"}], ",", "b"}], "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a$", ",", "b$", ",", "A$", ",", "B$"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e3dc3043-e489-4533-bc50-e32f8e8f422f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a$", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "a$"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", "b"}], "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{"A$", ",", 
    RowBox[{"-", "A$"}], ",", "B"}], 
   "]"}]}]], "Output",ExpressionUUID->"551089ab-43e3-4dda-9b26-7b8e9343b390"]
}, Open  ]],

Cell["\<\
The problem here is simply that we could be trying to undefine t and t\
\[Dagger] twice:\
\>", "Text",ExpressionUUID->"14994bbc-0f90-4602-8b4c-c9ff52fee952"],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"d4f4af25-9cca-4d48-bf81-8fb4c59d77d8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", ",", "t", ",", "t\[Dagger]"}], 
  "}"}]], "Output",ExpressionUUID->"fcabcbc9-a582-462f-a78d-d935bd7aaca7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"Drop", "[", 
    RowBox[{"$Tensors", ",", 
     RowBox[{"-", "1"}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"03bf4e70-b7d5-4a4d-b603-35c1836aa7bb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"402c5fd5-7947-492a-97fb-b92dd588496c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "t\[Dagger]"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`t\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"c937a7f2-018d-464c-a20a-481350b0e6b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "t"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`t],
  Editable->
   False]], "Print",ExpressionUUID->"1ec799dc-02d7-4b2f-b9bc-aed28c56c189"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"c1cf1936-9940-4f3b-8108-550088a16a18"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"263b7b67-9436-4ba6-a822-3633f470797d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefParameter", "[", "time", 
  "]"}]], "Input",ExpressionUUID->"d9fa61d3-bbab-4e50-9905-e75b90a099e9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefParameter", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"parameter\"\>", "\[InvisibleSpace]", "\<\" \"\>",
    "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["time",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`time,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefParameter, ": Undefined ", "parameter", 
   " ", $CellContext`time],
  Editable->
   False]], "Print",ExpressionUUID->"d0b7e665-8103-4ba3-a8b8-48a13371adac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$AbstractIndices"], \
"Input",ExpressionUUID->"1ab332f7-7091-4c9d-abc6-d2ed579ae787"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "H", ",", "a", 
   ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", "h", ",", 
   "U", ",", "W", ",", "U\[Dagger]", ",", "W\[Dagger]"}], 
  "}"}]], "Output",ExpressionUUID->"8f6f1596-e1c4-42c2-8899-95dc3fda1c12"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefVBundle", "[", "InnerC", 
  "]"}]], "Input",ExpressionUUID->"2e151cbc-6217-4e32-87bd-279dd9e84112"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"conjugated vbundle\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["InnerC\[Dagger]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`InnerC\[Dagger],
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "conjugated vbundle", 
   " ", $CellContext`InnerC\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"b17b73eb-b4ce-4b9c-a714-78f3fd53d78a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["InnerC",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`InnerC,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`InnerC],
  Editable->
   False]], "Print",ExpressionUUID->"0fe540a8-8cd3-4ab8-b34b-86394800703e"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "Polar", 
  "]"}]], "Input",ExpressionUUID->"04a194e4-a63d-4a2e-bd01-7330972b3cbe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefManifold", "/@", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"de406061-458d-4d55-b9bf-789ba2b86ae2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"b66cece7-702f-47a5-bc19-d58c12e59126"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"c224a392-579c-4602-b5c0-cad024bb1a5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"a1b949df-4bbc-4440-ad4d-5cdeeb7a7e62"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"a6f92b26-e312-4aab-8f4c-c13228ef0113"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"9e09a05d-a540-487c-9bfc-af57764fc23e"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"f43a82ef-00bb-4e16-b791-003fd3624656"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a$", ",", "A$", ",", "b$", ",", "B$", ",", "x"}], 
  "]"}]], "Input",ExpressionUUID->"2e612cff-6db1-40c8-baa5-0a5d2eb76c4e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Remove", "::", "rmptc"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\(x\\), \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x, Rule[Editable, \
False]]\\)\[NoBreak] is Protected and cannot be removed. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Remove/rmptc\\\", \
ButtonNote -> \\\"Remove::rmptc\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"3699f774-e87b-4e52-ad0e-f94c4e1c8d03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"d23695b9-6dd4-443b-994d-5363c6f7bfaa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"x\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"x"}],
  Editable->
   False]], "Print",ExpressionUUID->"91bb6236-645e-48e6-8bf1-f21cfc247ca1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.2.7. Explicit tensors", \
"Subsubsection",ExpressionUUID->"fe3121e7-28f1-4c89-a4e3-972ab83fdfcd"],

Cell["\<\
We introduce a new way of working with a tensor:

\tATensor[name, slots, deps, sym]

We don\[CloseCurlyQuote]t yet handle Daggering information.\
\>", "Text",ExpressionUUID->"782be3ee-516e-4e67-98fe-d11bec6ae07c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ATensor", "[", 
    RowBox[{"name_", ",", "slots_"}], "]"}], ":=", 
   RowBox[{"ATensor", "[", 
    RowBox[{"name", ",", "slots", ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ATensor", "[", 
    RowBox[{"name_", ",", "slots_", ",", "deps_"}], "]"}], ":=", 
   RowBox[{"ATensor", "[", 
    RowBox[{"name", ",", "slots", ",", "deps", ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"GenSet", "[", "]"}]}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7f78b122-ee8d-4e8e-8fb7-35d1e4a995cf"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"ATensor", "[", 
     RowBox[{"name_", ",", "slots_", ",", "deps_", ",", "sym_"}], "]"}], 
    "]"}], "^:=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"ATensor", "[", 
     RowBox[{"name_", ",", "slots_", ",", "deps_", ",", "sym_"}], "]"}], 
    "]"}], "^:=", "name"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"ATensor", "[", 
     RowBox[{"name_", ",", "slots_", ",", "deps_", ",", "sym_"}], "]"}], 
    "]"}], "^:=", "slots"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", 
    RowBox[{"ATensor", "[", 
     RowBox[{"name_", ",", "slots_", ",", "deps_", ",", "sym_"}], "]"}], 
    "]"}], "^:=", "deps"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"ATensor", "[", 
     RowBox[{"name_", ",", "slots_", ",", "deps_", ",", "sym_"}], "]"}], 
    "]"}], "^:=", "sym"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HostsOf", "[", 
    RowBox[{"ATensor", "[", 
     RowBox[{"name_", ",", "slots_", ",", "deps_", ",", "sym_"}], "]"}], 
    "]"}], "^:=", 
   RowBox[{"DeleteDuplicates", "[", 
    RowBox[{"Join", "[", 
     RowBox[{"slots", ",", "deps"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", "tensor_ATensor", "]"}], "^:=", "tensor"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorID", "[", "tensor_ATensor", "]"}], "^:=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInfo", "[", "tensor_ATensor", "]"}], "^:=", 
   RowBox[{"{", 
    RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d4190898-70b9-4b29-ac53-091a8d72fd82"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "ATensor", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7cc64a36-9a2c-43de-9d52-b65c16b39099"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.3. delta tensors", \
"Subsection",ExpressionUUID->"59de5e80-bae6-4cd3-b74d-f1c6a28e4c1a"],

Cell[CellGroupData[{

Cell["9.3.1. delta", \
"Subsubsection",ExpressionUUID->"056c3196-e0d4-492f-991b-0b6cad803162"],

Cell["\<\
In the past there was a delta object for each vector bundle, but this is not \
needed, so now there is a single delta function, which is much simpler.\
\>", "Text",ExpressionUUID->"094ff8c8-9439-479b-90a8-f28f72f6d4ca"],

Cell[TextData[{
 "A problem with the delta objects is the position of the indices. Working \
with the ",
 StyleBox["Spinors",
  FontSlant->"Italic"],
 " package has shown that the problem was bigger than I had thought (I thank \
Alfonso for pointing this out). In the absence of a metric we have the \
delta[-a, b] tensor as identity in the tangent bundle when it acts on its \
first index, and as identity in the cotangent bundle when it acts on its \
second index (this is a trick to avoid using delta[-a, b] and codelta[b, -a], \
which are equal). That is, in the absence of a metric it is syntactically \
incorrect to have delta[a, -b]. When we add a metric we can define such \
object:\n\t\tdelta[a, -b] = g[a, c] delta[-c, d] g[-d, -b]\nwith index \
positions following the see-saw convention in spinor theory. When the metric \
has symmetries the delta tensor inherits those symmetries: if the metric is \
symmetric then delta is symmetric; if the metric is antisymmetric then delta \
is antisymmetric. Basis has the same behaviour because we formally have \
metric = delta = Basis, all three being tensors."
}], "Text",ExpressionUUID->"16b62b08-99c7-49db-badf-e4345df5f9c0"],

Cell[TextData[{
 "The rules to change among them are the following:\n\t- Indices with the \
same height: use metric.\n\t- Indices with mixed positions:\n\t\t- abstract \
indices: use delta.\n\t\t- at least one basis-index: use Basis.\nIt is clear \
that Basis and delta are totally redundant, and actually many authors (for \
example Penrose and Rindler) only use delta, but I find it ugly. It is also \
simpler from the point of view of the distinction between ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " and ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ", and avoids excesive overloading of delta. "
}], "Text",ExpressionUUID->"004c897c-eaa5-425b-9694-37d832c71023"],

Cell[TextData[{
 "Properties of delta. The SlotsOfTensor[delta] value is only used in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " to compute the number of indices, and therefore it is not important what \
we write inside. DependenciesOf is only used by derivatives, and hence it \
doesn't matter what we say about delta. We actually say nothing because all \
derivatives anhililate delta."
}], "Text",ExpressionUUID->"e87afc38-89f6-404d-b7c9-8ae9be3bbe72"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Register", " ", "delta"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xTensorQ", "[", "delta", "]"}], "^=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", "delta", "]"}], "^=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAs", "[", "delta", "]"}], "^=", "\"\<\[Delta]\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", "delta", "]"}], "^=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "All"}], ",", "All"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MasterOf", "[", "delta", "]"}], "^=", "Symbol"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "delta", "]"}], "^=", "delta"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"838f116c-a123-4dc8-8cbf-fee2e3dd4e5b"],

Cell["\<\
Additional properties of delta:
\t- Dimension of vector bundle
\t- Automatic contraction of abstract indices of delta: first try to contract \
second index. Assume both indices of delta belong to same manifold.
\t- Conversion into Basis if there is at least one basis index.
\t- Vanishing derivative in true delta cases (i.e. mixed abstract indices)\
\>", "Text",ExpressionUUID->"37db8aee-ca28-4699-adde-b9e6dae1d821"],

Cell["\<\
We use the technique of \"hiding attributes\", suggested by Michael Trott, to \
avoid an exponential explosion in the number of checks for delta contraction. \
Now there is a single check per index of delta.\
\>", "Text",ExpressionUUID->"28dcb593-77f1-4bea-9045-ee8efc18c6ac"],

Cell["delta in the priviledged DU configuration:", \
"Text",ExpressionUUID->"55c8a47d-d7bb-414a-9c3d-9bb319718a70"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"DU", " ", "delta"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"-", "a_Symbol"}], ",", "a_Symbol"}], "]"}], ":=", 
     RowBox[{"DimOfVBundle", "@", 
      RowBox[{"VBundleOfIndex", "[", "a", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"delta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f_Symbol", "/;", 
        RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
      RowBox[{"expr1___", ",", 
       RowBox[{"delta", "[", 
        RowBox[{
         RowBox[{"-", "a_Symbol"}], ",", "b_Symbol"}], "]"}], ",", 
       "expr2___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"ReplaceIndex", "[", 
       RowBox[{
        RowBox[{"expr1", " ", "expr2"}], ",", 
        RowBox[{
         RowBox[{"-", "b"}], "\[Rule]", 
         RowBox[{"-", "a"}]}]}], "]"}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{
        RowBox[{"expr1", " ", "expr2"}], ",", 
        RowBox[{"-", "b"}], ",", "delta"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"delta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f_Symbol", "/;", 
        RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
      RowBox[{"expr1___", ",", 
       RowBox[{"delta", "[", 
        RowBox[{
         RowBox[{"-", "a_Symbol"}], ",", "b_Symbol"}], "]"}], ",", 
       "expr2___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"ReplaceIndex", "[", 
       RowBox[{
        RowBox[{"expr1", " ", "expr2"}], ",", 
        RowBox[{"a", "\[Rule]", "b"}]}], "]"}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{
        RowBox[{"expr1", " ", "expr2"}], ",", "a", ",", "delta"}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{"a_", ",", 
       RowBox[{"b", ":", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_Symbol"}], "}"}]}]}], "]"}], ":=", 
     RowBox[{"Basis", "[", 
      RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"a", ":", 
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"-", "_Symbol"}]}], "}"}]}], ",", "b_"}], "]"}], ":=", 
     RowBox[{"Basis", "[", 
      RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{"a", ",", 
       RowBox[{"b", ":", 
        RowBox[{
         RowBox[{"_", "?", "BasisQ"}], "[", "_", "]"}]}]}], "]"}], ":=", 
     RowBox[{"Basis", "[", 
      RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"a", ":", 
        RowBox[{"-", 
         RowBox[{
          RowBox[{"_", "?", "BasisQ"}], "[", "_", "]"}]}]}], ",", "b_"}], 
      "]"}], ":=", 
     RowBox[{"Basis", "[", 
      RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"delta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"_", "?", "FirstDerQ"}], ")"}], "[", 
      RowBox[{"delta", "[", 
       RowBox[{
        RowBox[{"-", "_Symbol"}], ",", "_Symbol"}], "]"}], "]"}], ":=", "0"}],
     ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ParamD", "[", "__", "]"}], "[", 
      RowBox[{"delta", "[", 
       RowBox[{
        RowBox[{"-", "_Symbol"}], ",", "_Symbol"}], "]"}], "]"}], ":=", "0"}],
     ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9cc1a981-e6d8-4d76-a807-bce35038aabd"],

Cell["\<\
delta in the opposite UD configuration. There might be a sign, controlled by \
the function SymmetryOfIndex.\
\>", "Text",ExpressionUUID->"62fa5a17-8951-4a76-8026-8d8ca7cbe394"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"UD", " ", 
    RowBox[{"delta", ".", " ", "Use"}], " ", "SymmetryOfIndex"}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{"a_Symbol", ",", 
       RowBox[{"-", "a_Symbol"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SymmetryOfIndex", "[", "a", "]"}], 
      RowBox[{"DimOfVBundle", "@", 
       RowBox[{"VBundleOfIndex", "[", "a", "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"delta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f_Symbol", "/;", 
        RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
      RowBox[{"expr1___", ",", 
       RowBox[{"delta", "[", 
        RowBox[{"a_Symbol", ",", 
         RowBox[{"-", "b_Symbol"}]}], "]"}], ",", "expr2___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SymmetryOfIndex", "[", "a", "]"}], 
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{
         RowBox[{"expr1", " ", "expr2"}], ",", 
         RowBox[{"b", "\[Rule]", "a"}]}], "]"}]}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{
        RowBox[{"expr1", " ", "expr2"}], ",", "b", ",", "delta"}], "]"}]}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"delta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f_Symbol", "/;", 
        RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
      RowBox[{"expr1___", ",", 
       RowBox[{"delta", "[", 
        RowBox[{"a_Symbol", ",", 
         RowBox[{"-", "b_Symbol"}]}], "]"}], ",", "expr2___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SymmetryOfIndex", "[", "a", "]"}], 
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{
         RowBox[{"expr1", " ", "expr2"}], ",", 
         RowBox[{
          RowBox[{"-", "a"}], "\[Rule]", 
          RowBox[{"-", "b"}]}]}], "]"}]}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{
        RowBox[{"expr1", " ", "expr2"}], ",", 
        RowBox[{"-", "a"}], ",", "delta"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{"a_", ",", 
       RowBox[{"b", ":", 
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"-", "_Symbol"}]}], "}"}]}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SymmetryOfIndex", "[", "a", "]"}], 
      RowBox[{"Basis", "[", 
       RowBox[{"b", ",", "a"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"a", ":", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_Symbol"}], "}"}]}], ",", "b_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SymmetryOfIndex", "[", "b", "]"}], 
      RowBox[{"Basis", "[", 
       RowBox[{"b", ",", "a"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{"a_", ",", 
       RowBox[{"b", ":", 
        RowBox[{"-", 
         RowBox[{
          RowBox[{"_", "?", "BasisQ"}], "[", "_", "]"}]}]}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SymmetryOfIndex", "[", "a", "]"}], 
      RowBox[{"Basis", "[", 
       RowBox[{"b", ",", "a"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"a", ":", 
        RowBox[{
         RowBox[{"_", "?", "BasisQ"}], "[", "_", "]"}]}], ",", "b_"}], "]"}], 
     ":=", 
     RowBox[{
      RowBox[{"SymmetryOfIndex", "[", "b", "]"}], 
      RowBox[{"Basis", "[", 
       RowBox[{"b", ",", "a"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"delta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"_", "?", "FirstDerQ"}], ")"}], "[", 
      RowBox[{"delta", "[", 
       RowBox[{"_Symbol", ",", 
        RowBox[{"-", "_Symbol"}]}], "]"}], "]"}], ":=", "0"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ParamD", "[", "__", "]"}], "[", 
      RowBox[{"delta", "[", 
       RowBox[{"_Symbol", ",", 
        RowBox[{"-", "_Symbol"}]}], "]"}], "]"}], ":=", "0"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0cfb7912-c86b-40eb-87e3-e2979cc302a3"],

Cell["\<\
The symmetry of delta is given by the symmetry of the metricof the vbundle of \
its indices:\
\>", "Text",ExpressionUUID->"b8206e58-6a92-45a0-a5ca-5bbe971aabf1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Symmetry", " ", "of", " ", "delta", " ", "is", " ", "symmetry", " ", "of",
     " ", "metric"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SymmetryGroupOfTensor", "[", 
     RowBox[{"delta", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "]"}], "^:=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"metric", "=", 
        RowBox[{"FirstMetricOfVBundle", "[", 
         RowBox[{
          RowBox[{"VBundleOfIndex", "[", "a", "]"}], ",", "False"}], "]"}]}], 
       "}"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"metric", "===", "Null"}], ",", 
        RowBox[{"StrongGenSet", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", 
        RowBox[{"SymmetryGroupOfTensor", "[", "metric", "]"}]}], "]"}]}], 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"732b15fa-fa53-4a93-b43d-88a6bd428b71"],

Cell["\<\
The trick converting delta into a metric is used in RHS of rules sometimes. \
With non-symmetric metrics we print a message:\
\>", "Text",ExpressionUUID->"3819d4a5-f241-4120-89bb-d916eed61916"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Conversion", " ", "to", " ", "metric", " ", "if", " ", "both", " ", 
    "indices", " ", "are", " ", "abstract", " ", "and", " ", "have", " ", 
    "same", " ", "height"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{"a_Symbol", ",", "b_Symbol"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", "=", 
         RowBox[{"FirstMetricOfVBundle", "[", 
          RowBox[{
           RowBox[{"VBundleOfIndex", "[", "a", "]"}], ",", "True"}], "]"}]}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SymmetryOfMetric", "[", "metric", "]"}], "=!=", "1"}], 
          ",", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"delta", "::", "warning"}], ",", 
            RowBox[{"\"\<delta converted into non-symmetric \>\"", "<>", 
             RowBox[{"ToString", "[", "metric", "]"}]}]}], "]"}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"metric", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"-", "a_Symbol"}], ",", 
       RowBox[{"-", "b_Symbol"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", "=", 
         RowBox[{"FirstMetricOfVBundle", "[", 
          RowBox[{
           RowBox[{"VBundleOfIndex", "[", "a", "]"}], ",", "True"}], "]"}]}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SymmetryOfMetric", "[", "metric", "]"}], "=!=", "1"}], 
          ",", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"delta", "::", "warning"}], ",", 
            RowBox[{"\"\<delta converted into non-symmetric \>\"", "<>", 
             RowBox[{"ToString", "[", "metric", "]"}]}]}], "]"}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"metric", "[", 
         RowBox[{
          RowBox[{"-", "a"}], ",", 
          RowBox[{"-", "b"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Protection", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"delta", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetAttributes", "[", 
     RowBox[{"delta", ",", 
      RowBox[{"{", 
       RowBox[{"ReadProtected", ",", "Protected"}], "}"}]}], "]"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"95edf736-30b2-445e-8ceb-0f1120ef661a"],

Cell["\<\
It is important to note that we are not checking that the indices of delta \
belong to the same vector space. In principle, if they didn't, we should \
transform delta into Zero.\
\>", "Text",ExpressionUUID->"b93419d2-8700-4d1d-9c16-418d0866f801"],

Cell["\<\
We have introduced for the first time the tensor Basis, and hence we need to \
identify it as a tensor:\
\>", "Text",ExpressionUUID->"f89d1572-226b-4b2c-b12b-a83b6e50112d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"xTensorQ", "[", "Basis", "]"}], ",", "True"}], "]"}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"acacc1b6-8f39-4f62-892f-b4f34000ba99"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "Basis"}]], "Input",ExpressionUUID->"8056bdbb-1a8b-4cec-af9d-586a2dd6ca6a"],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"Basis represents both the type and the tensor head for a basis \
vector/covector field.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672671-5338953",ExpressionUUID->"b56f6803-c034-4318-b306-\
26200af341ae"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Basis", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "Basis", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[xAct`xTensor`Basis],
  Editable->False]], "Print",
 CellTags->
  "Info3578672671-5338953",ExpressionUUID->"f356460c-2973-46a8-8e63-\
dd954d0a795b"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.3.2. Generalized delta: Gdelta", \
"Subsubsection",ExpressionUUID->"0f29fa98-2277-4d2e-b6bd-800c91623c27"],

Cell["\<\
This is the generalized delta tensor with two antisymmetric sets of indices. \
We closely follow Lovelock and Rund:\
\>", "Text",ExpressionUUID->"e802cbf5-e2de-49de-999d-c33e0d406ffe"],

Cell["1) Tensorial properties:", \
"Text",ExpressionUUID->"803d3dca-7c66-4c83-be26-106aeb74526e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Register", " ", "Gdelta"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xTensorQ", "[", "Gdelta", "]"}], "^=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", "Gdelta", "]"}], "^=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAs", "[", "Gdelta", "]"}], "^=", "\"\<\[Delta]\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", "Gdelta", "]"}], "^=", 
     RowBox[{"{", 
      RowBox[{"AnyIndices", "[", "All", "]"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MasterOf", "[", "Gdelta", "]"}], "^=", "Symbol"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", "Gdelta", "]"}], "^=", "Gdelta"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Two", " ", "basic", " ", "cases"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Gdelta", "[", "]"}], ":=", "1"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"Gdelta", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
     RowBox[{"delta", "[", 
      RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "The", " ", "symmetry", " ", "is", " ", "computed", " ", "from", " ", 
     "the", " ", "number", " ", "of", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfTensor", "[", "Gdelta", "]"}], "^:=", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfTensor", "[", 
      RowBox[{"Gdelta", "[", "inds__", "]"}], "]"}], "^:=", 
     RowBox[{"Gdeltasym", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"{", "inds", "}"}], "]"}], "/", "2"}], ",", 
       RowBox[{"SymmetryOfIndex", "[", 
        RowBox[{
         RowBox[{"First", "[", 
          RowBox[{"{", "inds", "}"}], "]"}], ",", "False"}], "]"}]}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Derivatives", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Gdelta", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "FirstDerQ"}], ")"}], "[", 
       RowBox[{"Gdelta", "[", 
        RowBox[{
         RowBox[{"l", ":", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", "_Symbol"}], ")"}], ".."}]}], ",", 
         RowBox[{"r", ":", 
          RowBox[{
           RowBox[{"(", "_Symbol", ")"}], ".."}]}]}], "]"}], "]"}], "]"}], ":=", 
     RowBox[{"0", "/;", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"{", "l", "}"}], "]"}], "===", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "r", "}"}], "]"}]}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"84ec1958-cce5-4e7b-98f0-6c5814422096"],

Cell["\<\
Actual computation of the strong generating set:
(Fixed sign in xTensor 1.1.0, reported by David Cassani.)\
\>", "Text",ExpressionUUID->"6a4dff2f-d870-4e6a-9e4b-0cc2f403a593"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Gdeltasym", "[", 
    RowBox[{"n_Integer", ",", "sym_Integer"}], "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"Range", "[", 
      RowBox[{"2", "n"}], "]"}], ",", 
     RowBox[{"GenSet", "@@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Minus", "/@", 
         RowBox[{"xAct`xPerm`Cycles", "/@", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Range", "[", "n", "]"}], ",", "2", ",", "1"}], "]"}]}]}],
         ",", 
        RowBox[{"Minus", "/@", 
         RowBox[{"xAct`xPerm`Cycles", "/@", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Range", "[", 
             RowBox[{
              RowBox[{"n", "+", "1"}], ",", 
              RowBox[{"2", "n"}]}], "]"}], ",", "2", ",", "1"}], "]"}]}]}], 
        ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"sym", "=!=", "0"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"sym", "^", "n"}], " ", 
            RowBox[{"xAct`xPerm`Cycles", "@@", 
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Range", "[", "n", "]"}], ",", 
                RowBox[{"Range", "[", 
                 RowBox[{
                  RowBox[{"n", "+", "1"}], ",", 
                  RowBox[{"2", "n"}]}], "]"}]}], "}"}], "]"}]}]}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Gdeltasym", "[", "_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Gdelta", "::", "error"}], ",", 
      "\"\<Found Gdelta with odd number of arguments.\>\""}], "]"}]}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fba92494-e578-406c-a4ab-ef975d9693e6"],

Cell["\<\
2) Contractions inside the generalized delta. In this function we use \
DimOfVBundle@VBundleOfIndex[b], and so this means that we assume that we are \
not working with an induced metric.\
\>", "Text",ExpressionUUID->"5e0ca151-d58f-4fd9-b4fb-fef1ed0d9a0d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Gdelta", "[", 
    RowBox[{"a___", ",", 
     RowBox[{"-", "b_Symbol"}], ",", "c___", ",", "b_Symbol", ",", "d___"}], 
    "]"}], ":=", 
   RowBox[{"contractGdelta", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "c", ",", "d"}], "}"}], ",", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", 
         RowBox[{"-", "b"}], ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
      "/", "2"}], ",", 
     RowBox[{"Length", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", 
        RowBox[{"-", "b"}]}], "}"}], "]"}], ",", 
     RowBox[{"Length", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", 
        RowBox[{"-", "b"}], ",", "c", ",", "b"}], "}"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Gdelta", "[", 
    RowBox[{"a___", ",", "b_Symbol", ",", "c___", ",", 
     RowBox[{"-", "b_Symbol"}], ",", "d___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SymmetryOfIndex", "[", "b", "]"}], 
    RowBox[{"contractGdelta", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "c", ",", "d"}], "}"}], ",", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", 
          RowBox[{"-", "b"}], ",", "d"}], "}"}], "]"}], "/", "2"}], ",", 
      RowBox[{"Length", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], "]"}], ",", 
      RowBox[{"Length", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", 
         RowBox[{"-", "b"}]}], "}"}], "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"contractGdelta", "[", 
    RowBox[{"list2_", ",", "semil_", ",", "p1_", ",", "p2_"}], "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"IntegerQ", "[", "semil", "]"}]}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Gdelta", "::", "error"}], ",", 
        "\"\<Found Gdelta with odd number of arguments.\>\""}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[LessEqual]", "p1", "\[LessEqual]", "semil"}], "&&", 
      RowBox[{"1", "\[LessEqual]", "p2", "\[LessEqual]", "semil"}]}], ",", 
     "0", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[LessEqual]", 
       RowBox[{"p1", "-", "semil"}], "\[LessEqual]", "semil"}], "&&", 
      RowBox[{"1", "\[LessEqual]", 
       RowBox[{"p2", "-", "semil"}], "\[LessEqual]", "semil"}]}], ",", "0", 
     ",", "\[IndentingNewLine]", "True", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p1", "+", "p2", "-", "semil"}], ")"}]}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"DimOfVBundle", "[", 
         RowBox[{"VBundleOfIndex", "[", 
          RowBox[{"First", "[", "list2", "]"}], "]"}], "]"}], "-", "semil", 
        "+", "1"}], ")"}], 
      RowBox[{"Apply", "[", 
       RowBox[{"Gdelta", ",", "list2"}], "]"}]}]}], "]"}]}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"17408762-c900-49ab-a676-92dcc6da5fe4"],

Cell[TextData[{
 "3) UNDER DEVELOPMENT. In fact, the algorithm below is incorrect right now \
(see [",
 ButtonBox["post",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["https://groups.google.com/forum/#!topic/xAct/8t5gQIXtKrc"], None},
  ButtonNote->"https://groups.google.com/forum/#!topic/xAct/8t5gQIXtKrc"],
 "] in the xAct forum), so I deactivate it and go back to Gdelta expansion. \
The algorithm was copied from GAMMA, and I probably copied it incorrectly. I \
don\[CloseCurlyQuote]t understand it well enough to fix my copy.\n\n\
Contractions of the generalized delta with other tensors. It performs all \
contractions in a \[OpenCurlyDoubleQuote]half-delta\[CloseCurlyDoubleQuote] \
simultaneously, but if there are contractions in the two halves then it needs \
two iterations. Note the standard issues of signs and factorials, which are \
more difficult in our case because we do not automatically sort the indices."
}], "Text",ExpressionUUID->"022fde41-d847-4aa5-9aa8-288c5efb9fdb"],

Cell["\<\
This function detects contractions, without worrying about their structure. \
That will be sorted out later.\
\>", "Text",ExpressionUUID->"5dd6dc60-1ac1-4ca2-a144-669598582f17"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Gdelta", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f_", "/;", 
        RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
      RowBox[{"expr1___", ",", "gdelta_Gdelta", ",", "expr2___"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tinds", "=", 
         RowBox[{"ChangeIndex", "/@", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"FindIndices", "[", 
             RowBox[{"Times", "[", 
              RowBox[{"expr1", ",", "expr2"}], "]"}], "]"}], ",", 
            "ABIndexQ"}], "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"System`Echo", "[", 
         RowBox[{"contractGdeltaTimes", "[", 
          RowBox[{
           RowBox[{"IndexList", "@@", "gdelta"}], ",", "tinds", ",", 
           RowBox[{
            RowBox[{"Length", "[", "gdelta", "]"}], "/", "2"}], ",", 
           RowBox[{"Expand", "@", 
            RowBox[{"Times", "[", 
             RowBox[{"expr1", ",", "expr2"}], "]"}]}]}], "]"}], "]"}], "/;", 
        RowBox[{
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"IndexList", "@@", "gdelta"}], ",", "tinds"}], "]"}], "=!=", 
         RowBox[{"IndexList", "[", "]"}]}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Gdelta", "/:", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"f_", "/;", 
       RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
     RowBox[{"expr1___", ",", "gdelta_Gdelta", ",", "expr2___"}], "]"}], ":=", 
    RowBox[{"Expand", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"expr1", ",", 
       RowBox[{"ExpandGdelta", "[", "gdelta", "]"}], ",", "expr2"}], "]"}], 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f64bd9ea-ce60-459f-8321-563b3d518d99"],

Cell["\<\
QUESTION: Is it worth spending time finding out which factor of the product \
is actually contracted with the Gdelta? The computation would then be \
simpler...
QUESTION: contractGdeltaTimes uses AntisymmetricBlocksOf[Times[expr1, expr2]] \
which can potentially be a sum. Hence we have introduced a Expand. This means \
that multiplying by Gdelta automatically expands expressions. Is that OK?\
\>", "Text",ExpressionUUID->"4f38ed9a-b08b-405e-96e7-43796ca6779f"],

Cell[TextData[{
 "The algorithm that follows is incorrect. See this [",
 ButtonBox["post",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["https://groups.google.com/forum/#!topic/xAct/6YoufE0zqpg"], None},
  ButtonNote->"https://groups.google.com/forum/#!topic/xAct/6YoufE0zqpg"],
 "]. I\[CloseCurlyQuote]ve deactivated it above and forced a call to \
ExpandGdelta. A pity, but difficult to fix."
}], "Text",ExpressionUUID->"711e5721-04d3-4406-8f53-d8fb7d4a6de3"],

Cell["\<\
This intermediate driver decides in which antisymmetric block of Gdelta and \
in which antisymmetric block of the expr the contraction will be performed:\
\>", "Text",ExpressionUUID->"733c290e-2353-479d-80a8-314cf5b5be01"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"contractGdeltaTimes", "[", 
    RowBox[{
    "ginds_IndexList", ",", "tinds_IndexList", ",", "semil_Integer", ",", 
     "sum_Plus"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"contractGdeltaTimes", "[", 
      RowBox[{"ginds", ",", "tinds", ",", "semil", ",", "#"}], "]"}], "&"}], "/@",
     "sum"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"contractGdeltaTimes", "[", 
    RowBox[{
    "ginds_IndexList", ",", "tinds_IndexList", ",", "semil_Integer", ",", 
     "0"}], "]"}], ":=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"contractGdeltaTimes", "[", 
    RowBox[{
    "ginds_IndexList", ",", "tinds_IndexList", ",", "semil_Integer", ",", 
     "expr_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "linds", ",", "rinds", ",", "ablocks", ",", "blocks", ",", "ctr"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Separate", " ", "two", " ", "subsets", " ", "of", " ", "indices", " ", 
       "of", " ", "delta", " ", 
       RowBox[{"(", 
        RowBox[{"both", " ", "antisymmetric", " ", "blocks"}], ")"}]}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"IntegerQ", "[", "semil", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Gdelta", "::", "error"}], ",", 
           "\"\<Found Gdelta with odd number of arguments.\>\""}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"linds", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"ginds", ",", "semil"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"rinds", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"ginds", ",", 
         RowBox[{"-", "semil"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Separate", " ", "the", " ", "antisymmetric", " ", "blocks", " ", "of",
         " ", "the", " ", "expression", " ", "expr"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"ablocks", "=", 
       RowBox[{"AntisymmetricBlocksOf", "[", "expr", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Find", " ", "block", " ", "pairs", " ", "containing", " ", "a", " ", 
        RowBox[{"contraction", ".", " ", "Select"}], " ", "one", " ", "of", 
        " ", "longest", " ", "length"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"ctr", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Outer", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#1", ",", "#2", ",", 
              RowBox[{"Intersection", "[", 
               RowBox[{"#1", ",", "#2"}], "]"}]}], "}"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"linds", ",", "rinds"}], "}"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{"ChangeIndex", ",", "ablocks", ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}], ",", "1"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"ctr", "=", 
       RowBox[{"First", "@", 
        RowBox[{"SortBy", "[", 
         RowBox[{"ctr", ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Length", "[", 
             RowBox[{"Last", "[", "#", "]"}], "]"}]}], "&"}]}], "]"}]}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "If", " ", "the", " ", "result", " ", "will", " ", "not", " ", 
         "contain", " ", "Gdelta", " ", "and", " ", "there", " ", "is", " ", 
         "just", " ", "one", " ", "contraction", " ", "then", " ", "change", 
         " ", "to", " ", "ExpandGdelta"}], ",", " ", 
        RowBox[{
         RowBox[{"which", " ", "is", " ", "faster", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"ctr", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[LessEqual]", "2"}], 
             "&&", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"ctr", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[LessEqual]", "2"}], 
             "&&", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"ctr", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[Equal]", "1"}]}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Return", "[", 
             RowBox[{"Expand", "[", 
              RowBox[{
               RowBox[{"ExpandGdelta", "[", 
                RowBox[{"Gdelta", "@@", "ginds"}], "]"}], " ", "expr"}], 
              "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "*)"}],
       "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"As", " ", "usual"}], ",", " ", 
        RowBox[{
        "try", " ", "to", " ", "contract", " ", "first", " ", "the", " ", 
         "second", " ", "half", " ", "of", " ", "the", " ", "indices", " ", 
         "of", " ", "delta"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ctr", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "===", "rinds"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"contractGdeltaExpansion", "[", 
         RowBox[{"Right", ",", "linds", ",", "rinds", ",", 
          RowBox[{"ctr", "[", 
           RowBox[{"[", "3", "]"}], "]"}], ",", "expr"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"contractGdeltaExpansion", "[", 
         RowBox[{"Left", ",", "rinds", ",", "linds", ",", 
          RowBox[{"ctr", "[", 
           RowBox[{"[", "3", "]"}], "]"}], ",", "expr"}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1545f976-6e7d-4588-9a34-1f7484385421"],

Cell["\<\
This is an important function in this algorithm. Supplying its actual values \
by hand can speed up enormously the computations for cases with many indices. \
In the general case it falls of to the general group-theoretical computation \
implemented in AntisymmetricBlocks.\
\>", "Text",ExpressionUUID->"ab171418-ec97-4434-ae57-b5e47632315e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocksOf", "[", 
    RowBox[{"Gdelta", "[", "inds__", "]"}], "]"}], ":=", 
   RowBox[{"IndexList", "@@@", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"{", "inds", "}"}], ",", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"{", "inds", "}"}], "]"}], "/", "2"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocksOf", "[", 
    RowBox[{"Times", "[", 
     RowBox[{"gdelta_Gdelta", ",", "rest__"}], "]"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"AntisymmetricBlocksOf", "[", "gdelta", "]"}], ",", 
     RowBox[{"AntisymmetricBlocksOf", "[", 
      RowBox[{"Times", "[", "rest", "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocksOf", "[", "expr_", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sym", "=", 
       RowBox[{"SymmetryOf", "[", "expr", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Extract", "[", 
      RowBox[{
       RowBox[{"IndexList", "@@", 
        RowBox[{"(", 
         RowBox[{"Last", "/@", 
          RowBox[{"sym", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}], ",", 
       RowBox[{"List", "/@", 
        RowBox[{"AntisymmetricBlocks", "[", 
         RowBox[{
          RowBox[{"sym", "[", 
           RowBox[{"[", "4", "]"}], "]"}], ",", 
          RowBox[{"Length", "[", 
           RowBox[{"sym", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ce96bdcb-03c2-4207-a3e7-35cc7be0358d"],

Cell["\<\
Find the antisymmetric blocks of a SGS. This algorithm is quadratic, and it \
can probably be made linear. It should be moved to xPerm:\
\>", "Text",ExpressionUUID->"494f5bf8-660a-4495-a421-26ff8ccbac98"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocks", "[", "sgs_", "]"}], ":=", 
   RowBox[{"AntisymmetricBlocks", "[", 
    RowBox[{"sgs", ",", 
     RowBox[{"PermDeg", "[", "sgs", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocks", "[", 
    RowBox[{
     RowBox[{"Antisymmetric", "[", "range_", "]"}], ",", "n_"}], "]"}], ":=", 
   
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "range", "}"}], ",", 
     RowBox[{"List", "/@", 
      RowBox[{"Complement", "[", 
       RowBox[{
        RowBox[{"Range", "[", "n", "]"}], ",", "range"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocks", "[", 
    RowBox[{
     RowBox[{"Symmetric", "[", "range_", "]"}], ",", "n_"}], "]"}], ":=", 
   RowBox[{"List", "/@", 
    RowBox[{"Range", "[", "n", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntisymmetricBlocks", "[", 
    RowBox[{"sgs_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{"#", ",", 
       RowBox[{"List", "/@", 
        RowBox[{"Complement", "[", 
         RowBox[{
          RowBox[{"Range", "[", "n", "]"}], ",", 
          RowBox[{"Sequence", "@@", "#"}]}], "]"}]}]}], "]"}], "&"}], "@", 
    RowBox[{"(", 
     RowBox[{"Sort", "/@", 
      RowBox[{"ConnectedComponents", "[", 
       RowBox[{"Graph", "[", 
        RowBox[{"UndirectedEdge", "@@@", 
         RowBox[{"Identity", "@@@", 
          RowBox[{"(", 
           RowBox[{"Minus", "/@", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"Minus", "/@", 
               RowBox[{"xAct`xPerm`Cycles", "/@", 
                RowBox[{"Subsets", "[", 
                 RowBox[{
                  RowBox[{"Range", "[", "n", "]"}], ",", 
                  RowBox[{"{", "2", "}"}]}], "]"}]}]}], ",", 
              RowBox[{
               RowBox[{"PermMemberQ", "[", 
                RowBox[{"#", ",", "sgs"}], "]"}], "&"}]}], "]"}]}], ")"}]}]}],
         "]"}], "]"}]}], ")"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b5e0fde8-8538-4a41-ad3c-4cd22a357e27"],

Cell["\<\
This function is essentially taken from the package GAMMA`, by Ulf Gran. I\
\[CloseCurlyQuote]ve copied the signs, though I must admit I don\
\[CloseCurlyQuote]t understand them:\
\>", "Text",ExpressionUUID->"61230c8d-0581-482e-a5bb-f87f81a5547c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"contractGdeltaExpansion", "[", 
    RowBox[{
    "side_", ",", "oinds_", ",", "cinds_", ",", "ictrs_", ",", "expr_"}], 
    "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"crest", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"cinds", ",", 
          RowBox[{"Alternatives", "@@", "ictrs"}]}], "]"}]}], ",", 
       RowBox[{"len", "=", 
        RowBox[{"Length", "[", "ictrs", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"len", "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Position", "[", 
            RowBox[{"cinds", ",", 
             RowBox[{"Alternatives", "@@", "ictrs"}]}], "]"}], "]"}]}], "+", 
         RowBox[{"len", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"len", "+", "1"}], ")"}], "/", "2"}]}]}], ")"}]}], 
      RowBox[{"Total", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"orest", "=", 
             RowBox[{"DeleteCases", "[", 
              RowBox[{"oinds", ",", 
               RowBox[{"Alternatives", "@@", "#"}]}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Times", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Signature", "[", 
              RowBox[{"Join", "[", 
               RowBox[{"#", ",", "orest"}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Gdelta", "@@", 
              RowBox[{"join", "[", 
               RowBox[{"orest", ",", "crest", ",", "side"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ReplaceIndex", "[", 
              RowBox[{"expr", ",", 
               RowBox[{"Thread", "[", 
                RowBox[{
                 RowBox[{"List", "@@", 
                  RowBox[{"(", 
                   RowBox[{"ChangeIndex", "/@", "ictrs"}], ")"}]}], "\[Rule]", 
                 RowBox[{"List", "@@", "#"}]}], "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
         "&"}], "/@", 
        RowBox[{"Subsets", "[", 
         RowBox[{"oinds", ",", 
          RowBox[{"{", "len", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"join", "[", 
    RowBox[{"list1_", ",", "list2_", ",", "Right"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{"list1", ",", "list2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"join", "[", 
    RowBox[{"list1_", ",", "list2_", ",", "Left"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{"list2", ",", "list1"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"008caf63-6985-47d9-aeab-8f7601bd48ce"],

Cell["\<\
This is Gran\[CloseCurlyQuote]s code, for reference, slightly edited. \
Important comment: Any of the v lists is an antisymmetric group of indices of \
the tensor z. Why is this only contracting in the first argument (x) of \
GAMMAdelta? Do we need a separate definition for the second (y) argument?\
\>", "Text",ExpressionUUID->"52cd2517-7d75-4553-b70d-ecc580baf55a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PositionList", "[", 
   RowBox[{"lis_", ",", "find_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{"lis", ",", "#"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], "&"}], ",", "find"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"GAMMAdelta", "/:", 
   RowBox[{
    RowBox[{"GAMMAdelta", "[", 
     RowBox[{"x_List", ",", "y_List"}], "]"}], 
    RowBox[{"z_", "[", 
     RowBox[{"w___List", ",", "v_List", ",", "s___List"}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"same", "=", 
         RowBox[{"ReplaceList", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "v"}], "}"}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"___", ",", "t_", ",", "___"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"___", ",", "t_", ",", "___"}], "}"}]}], "}"}], 
            "\[RuleDelayed]", "t"}]}], "]"}]}], ",", "poslist1", ",", 
        "poslist2", ",", "xxleft", ",", "lensame", ",", "yycomb", ",", 
        "lenyycomb", ",", "actyycomb", ",", "actyycompo", ",", "i"}], 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lensame", "=", 
        RowBox[{"Length", "[", "same", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"poslist1", "=", 
        RowBox[{"PositionList", "[", 
         RowBox[{"x", ",", "same"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"xxleft", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{"x", ",", "poslist1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"poslist2", "=", 
        RowBox[{"PositionList", "[", 
         RowBox[{"v", ",", "same"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"yycomb", "=", 
        RowBox[{"Subsets", "[", 
         RowBox[{"y", ",", 
          RowBox[{"{", "lensame", "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"lenyycomb", "=", 
        RowBox[{"Length", "[", "yycomb", "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{
         RowBox[{"Power", "[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"Evaluate", "[", 
            RowBox[{
             RowBox[{"Plus", "@@", 
              RowBox[{"Flatten", "[", "poslist1", "]"}]}], "-", 
             RowBox[{"lensame", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"lensame", "+", "1"}], ")"}], "/", "2"}]}]}], "]"}]}],
           "]"}], "/", "lenyycomb"}], " ", 
        RowBox[{"Sum", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"actyycomb", "=", 
            RowBox[{"yycomb", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"actyycompo", "=", 
            RowBox[{"Complement", "[", 
             RowBox[{"y", ",", "actyycomb"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Signature", "@", 
             RowBox[{"Join", "[", 
              RowBox[{"actyycomb", ",", "actyycompo"}], "]"}]}], 
            RowBox[{"GAMMAdelta", "[", 
             RowBox[{"xxleft", ",", "actyycompo"}], "]"}], 
            RowBox[{"z", "[", 
             RowBox[{"w", ",", 
              RowBox[{"ReplacePart", "[", 
               RowBox[{"v", ",", "actyycomb", ",", "poslist2", ",", 
                RowBox[{"List", "/@", 
                 RowBox[{"Range", "@", 
                  RowBox[{"Length", "@", "poslist2"}]}]}]}], "]"}], ",", 
              "s"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"i", ",", "lenyycomb"}], "}"}]}], "\[IndentingNewLine]", 
         "]"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"Intersection", "[", 
      RowBox[{"x", ",", "v"}], "]"}], "=!=", 
     RowBox[{"{", "}"}]}]}]}], 
  ";"}]}], "Input",ExpressionUUID->"561e92a9-54f6-41ec-bca5-7935eea447cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"4", "!"}], "/", "2"}], 
  RowBox[{"GAMMAdelta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3", ",", "x4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y1", ",", "y2", ",", "y3", ",", "y4"}], "}"}]}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "z2"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"cdc4cc73-b07a-4683-b739-4a848b027817"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x3", ",", "x4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y3", ",", "y4"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y1", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x3", ",", "x4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y2", ",", "y4"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y1", ",", "y3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x3", ",", "x4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y2", ",", "y3"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y1", ",", "y4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x3", ",", "x4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y1", ",", "y4"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y2", ",", "y3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x3", ",", "x4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y1", ",", "y3"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y2", ",", "y4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x3", ",", "x4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y1", ",", "y2"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y3", ",", "y4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}]}]}], 
   ")"}]}]], "Output",ExpressionUUID->"189d16e0-0a34-4d7e-9c95-2f5e5629f692"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"4", "!"}], "/", "2"}], 
  RowBox[{"GAMMAdelta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", ",", "y1", ",", "x2", ",", "y2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "w1", ",", "z2", ",", "w2"}], "}"}]}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", ",", "y1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "w1"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"cb079029-e98d-4509-9758-8a088ab071b4"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x2", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"w1", ",", "w2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x2", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"w2", ",", "z1"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"w1", ",", "z2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x2", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"w2", ",", "z2"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}]}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x2", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"w1", ",", "z2"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"z1", ",", "w2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x2", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"w1", ",", "w2"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"z1", ",", "z2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"GAMMAdelta", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x2", ",", "y2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"w1", ",", "z1"}], "}"}]}], "]"}], " ", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"z2", ",", "w2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z1", ",", "w1"}], "}"}]}], "]"}]}]}], 
   ")"}]}]], "Output",ExpressionUUID->"a6df2da1-68f2-4832-b7e1-6bea65ccb369"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"GAMMAdelta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x2", ",", "y2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w1", ",", "w2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "w1"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"3606b527-6ca7-43fa-b4b8-b0fbf4a313ea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  TagBox["\<\"Pair:\"\>",
   "EchoLabel"], " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x2", ",", "y2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"w1", ",", "w2"}], "}"}]}], 
   "}"}]}]], "Echo",ExpressionUUID->"5040c5bc-d637-4f85-9e83-1fb8af085663"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Echo",ExpressionUUID->"0e22bd28-1baa-422f-95fb-22fe72839b77"],

Cell[BoxData[
 RowBox[{
  TagBox["\<\"Pair:\"\>",
   "EchoLabel"], " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x2", ",", "y2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "w1"}], "}"}]}], 
   "}"}]}]], "Echo",ExpressionUUID->"8f8d505e-3974-460a-8ff3-abc20f9c7fb0"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Echo",ExpressionUUID->"dec95197-d9b8-42c3-bb96-e75c2baaa452"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"GAMMAdelta", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x2", ",", "y2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "z2"}], "}"}]}], "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w1", ",", "w2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", "w1"}], "}"}]}], 
   "]"}]}]], "Output",ExpressionUUID->"3dc9b9d0-7c95-497c-8fcd-9d4c574c21c8"]
}, Open  ]],

Cell["\<\
4) This function expands the generalized delta into normal deltas. The \
function ExpandGdelta acts only on those Gdelta's for the delta tensor (or \
first-metric of the vbundle), and not with induced metrics.\
\>", "Text",ExpressionUUID->"e25115db-d336-443d-9bcb-8c0c2cda10aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandGdelta", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"Gdelta", "[", "inds__", "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"expandGdelta", "[", "delta", "]"}], "[", "inds", "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f6642bea-ab24-40fa-ad3d-80d1d9784042"],

Cell["\<\
We need this additional function to expand the product of two epsilons using \
other metric, for instance an induced metric:\
\>", "Text",ExpressionUUID->"bdcebd1f-eb2a-4782-960e-a265018858f7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"expandGdelta", "[", "metric_", "]"}], "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"metric", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"expandGdelta", "[", "metric_", "]"}], "[", "indices___", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"semil", "=", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"{", "indices", "}"}], "]"}], "/", "2"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"IntegerQ", "[", "semil", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Gdelta", "::", "error"}], ",", 
           "\"\<Found Gdelta with odd number of indices.\>\""}], "]"}]}]}], 
       "]"}], ";", 
      RowBox[{"Det", "@", 
       RowBox[{"Outer", "[", 
        RowBox[{"metric", ",", 
         RowBox[{
          RowBox[{"{", "indices", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{"Range", "[", "semil", "]"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", "indices", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"semil", "+", "1"}], ",", 
             RowBox[{"2", "semil"}]}], "]"}], "]"}], "]"}], ",", "1"}], 
        "]"}]}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f60bdc59-a1fd-4b31-85a5-1e78bbb628ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.3.3. Examples", \
"Subsubsection",ExpressionUUID->"0b8cad33-4396-4d91-92f3-742629dfdab0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"8771dc05-cbcb-4842-a805-95e1b767e700"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M4", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"47fadca6-9dea-45c5-b69e-b945d543f58a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M4", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M4, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"de511c11-0a98-4b88-bb1f-d1f5a3728244"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM4", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM4, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"01a97c25-b675-46bb-a2ec-b615f9598bd9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"42548a16-e965-45bc-80b0-7d8bdb33965c"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0a8ce972-157e-4d93-bab9-5f3558252d05"]
}, Open  ]],

Cell["Working with delta:", \
"Text",ExpressionUUID->"e9c83a79-b3bd-4903-a41f-048ed0db726f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"delta", "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"74fb376a-b2a8-41e1-a57f-515649005510"],

Cell[BoxData[
 RowBox[{"4", " ", 
  RowBox[{
  "xAct`xTensor`Private`SymmetryOfIndex", "[", "A", 
   "]"}]}]], "Output",ExpressionUUID->"a15cb21f-edee-4c0e-9451-3cdc773db073"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"delta", "[", 
  RowBox[{
   RowBox[{"-", "A"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"ce6a77c5-3c4f-45fa-b37f-278ade9a7c9a"],

Cell[BoxData["4"], \
"Output",ExpressionUUID->"1aaedcc3-de61-44b2-a059-39bdf1f043f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], "]"}], 
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", "C"}], 
   "]"}]}]], "Input",ExpressionUUID->"068984ce-e883-4275-a234-29685dbdb1c9"],

Cell[BoxData[
 RowBox[{"delta", "[", 
  RowBox[{
   RowBox[{"-", "A"}], ",", "C"}], 
  "]"}]], "Output",ExpressionUUID->"edfb47c3-35b0-4738-b578-a4b18b327bf2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"59bdb905-8bfb-4034-bfdb-32724acc2bed"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"MetricsOfVBundle", "::", "missing"}], "MessageName"], ":", 
  " ", "\<\"There is no \[NoBreak]\\!\\(\\\"metric\\\"\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\[DoubleStruckCapitalT]M4\\\
\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], TangentM4, \
Rule[Editable, False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1bde7e76-d07e-4e89-9e3d-3468b0eeaa6e"]
}, Open  ]],

Cell["\<\
Note that when both indices of delta can be contracted, then the second one \
is contracted:\
\>", "Text",ExpressionUUID->"d9222590-149e-4943-a75f-dfba107d2bf1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M4"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"aa", "[", "A", "]"}], ",", "M4"}], 
  "]"}]}], "Input",ExpressionUUID->"84c2fe68-68d9-4a7b-94c7-365d384761a1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"85e7d054-c34b-4f7c-8c27-e518524940ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"aa", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`aa[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ffffc449-c1ae-4485-bc2b-fd5422181a28"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"c7d82284-05a4-4af2-baa5-63d446de35ec"],

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Output",ExpressionUUID->"08081a55-8a8b-4081-87ea-cbd0da130432"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"delta", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], 
   "]"}]}]], "Input",ExpressionUUID->"4029aff2-c9ed-4673-b678-accd477b3110"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xAct`xTensor`Private`SymmetryOfIndex", "[", "A", "]"}], " ", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "A"}], 
   "]"}]}]], "Output",ExpressionUUID->"fa0520ab-6d45-45dc-8052-36d290bfa66d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], "]"}], 
  RowBox[{"aa", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"50dc3a7c-6c10-42ce-bf39-cdf144f3bd1c"],

Cell[BoxData[
 RowBox[{"aa", "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Output",ExpressionUUID->"92e39cf0-eea0-4540-af62-cd04e19a1360"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"delta", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], "]"}], 
  RowBox[{"aa", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], 
   "]"}]}]], "Input",ExpressionUUID->"83e0c106-274f-4401-97d4-b9092e4e269f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"aa", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "A"}], "]"}], " ", 
  RowBox[{
  "xAct`xTensor`Private`SymmetryOfIndex", "[", "A", 
   "]"}]}]], "Output",ExpressionUUID->"4ef4baad-c972-43cd-b46e-17d7d7262117"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "aa"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"9b5997f2-f2d3-46c6-b2aa-65c990df08bf"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"4931d70f-2e9d-4c7c-aefc-fb8983fa5974"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "aa"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`aa],
  Editable->
   False]], "Print",ExpressionUUID->"b450bcbf-38b8-41e8-ac6e-8e3c27e78a02"]
}, Open  ]]
}, Open  ]],

Cell["Generalized delta:", \
"Text",ExpressionUUID->"c67d1de8-acbd-4077-acd0-320fe912e65b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Gdelta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}], ",", "C", ",", "D"}], "]"}], "//", 
  "ExpandGdelta"}]], \
"Input",ExpressionUUID->"9ead0a1f-fb05-4bb3-808e-5b53a11d2e4b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"delta", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "D"}], "]"}]}], " ", 
   RowBox[{"delta", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "C"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"delta", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "C"}], "]"}], " ", 
   RowBox[{"delta", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "D"}], 
    "]"}]}]}]], \
"Output",ExpressionUUID->"e79f5827-8855-49f8-b85c-e01a62bded5f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"delta", "[", 
    RowBox[{
     RowBox[{"-", "D"}], ",", "A"}], "]"}], "%"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"b031eadf-85bd-4a2a-8371-3529896fff4d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "3"}], " ", 
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", "C"}], 
   "]"}]}]], "Output",ExpressionUUID->"909c054b-d2c1-4333-9901-03f1f7eb2b82"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "UndefTensor", "[", "delta", 
   "]"}]}]], "Input",ExpressionUUID->"a1dccb23-d362-42fa-856c-ca1d2b0b03c4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "noundef"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Symbol\\\"\\)\[NoBreak] \[NoBreak]\\!\\(delta\
\\)\[NoBreak] cannot be undefined because \[NoBreak]\\!\\(\\\"its master is \
still alive\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7c61d95b-5213-4a30-a5fd-aed1f6de8f46"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Gdelta", "[", 
  RowBox[{
   RowBox[{"-", "A"}], ",", 
   RowBox[{"-", "B"}], ",", "C", ",", "D"}], 
  "]"}]], "Input",ExpressionUUID->"aa31b71d-5acb-4b56-875a-ae0c658c1e37"],

Cell[BoxData[
 RowBox[{"Gdelta", "[", 
  RowBox[{
   RowBox[{"-", "A"}], ",", 
   RowBox[{"-", "B"}], ",", "C", ",", "D"}], 
  "]"}]], "Output",ExpressionUUID->"7cf7e9b0-0f31-4554-9859-26e1adc52f7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "D"}], ",", "B"}], "]"}], 
  "%"}]], "Input",ExpressionUUID->"831af192-5d4d-4f59-9aeb-9b0688373c41"],

Cell[BoxData[
 RowBox[{"3", " ", 
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "C"}], 
   "]"}]}]], "Output",ExpressionUUID->"6d262820-e7b4-4f60-997b-341b9f31d10e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M4", 
  "]"}]], "Input",ExpressionUUID->"be2bbb88-fe7f-4efc-9f3b-e9a6ebf74100"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M4",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM4,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM4],
  Editable->
   False]], "Print",ExpressionUUID->"d4568fe3-026c-4b1d-90a1-fe98ad974af6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M4],
  Editable->
   False]], "Print",ExpressionUUID->"8bf9d186-7233-4d7c-b8e4-d1bcfc398907"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"217c39ad-21c6-4b22-9e2d-8888ff480d47"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.3.4. An even more general delta, the super-delta: Sdelta", \
"Subsubsection",ExpressionUUID->"eab2563f-8a06-4d93-91d2-2ab4c1b216bd"],

Cell["\<\
We generalize Gdelta, which is always antisymmetric, to a general concept of \
delta with two sets of indices with any symmetry group. This acts as a \
projector onto the tensors with the given symmetry.\
\>", "Text",ExpressionUUID->"80f36da6-50c7-49c7-a423-b03fda2e0e41"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"General", " ", "info"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xTensorQ", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAs", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^=", "\"\<\[Delta]\>\""}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", 
     RowBox[{"{", 
      RowBox[{"AnyIndices", "[", "All", "]"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Symmetry", " ", "info"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Sdelta", "[", "sym_GenSet", "]"}], "[", "inds___", "]"}], ":=", 
     RowBox[{
      RowBox[{"Sdelta", "[", 
       RowBox[{"SchreierSims", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "sym"}], "]"}], "]"}], "[", "inds", "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfTensor", "[", 
      RowBox[{
       RowBox[{"Sdelta", "[", "sym_", "]"}], "[", "inds___", "]"}], "]"}], "^:=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"{", "inds", "}"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"JoinSGS", "[", 
         RowBox[{"sym", ",", 
          RowBox[{"sym", "/.", 
           RowBox[{
            RowBox[{"p_Integer", "?", "Positive"}], "\[RuleDelayed]", 
            RowBox[{"p", "+", 
             RowBox[{"n", "/", "2"}]}]}]}]}], "]"}], "/;", 
        RowBox[{"Or", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", "n", "]"}], ",", 
          RowBox[{"Throw", "[", "]"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "info"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", 
     RowBox[{"Sdelta", "[", "sym", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefInfo", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<tensor\>\"", ",", "\"\<super delta of adjustable symmetry\>\""}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HostsOf", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorID", "[", 
      RowBox[{"Sdelta", "[", "sym_", "]"}], "]"}], "^:=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "Sdelta", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8b33a48e-3e35-4396-9aa4-a9d30921e69a"],

Cell["\<\
This function converts Sdelta into a linear combination of products of delta \
with the same effect:\
\>", "Text",ExpressionUUID->"027c94a3-644b-43fa-a97c-79d66e29c43c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExpandSdelta", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"Sdelta", "[", "sym_", "]"}], "[", "inds___", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"expandSdelta", "[", 
       RowBox[{"sym", ",", "delta"}], "]"}], "[", "inds", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"oneSterm", "[", 
     RowBox[{"metric_", ",", "first_List", ",", "last_List"}], "]"}], "[", 
    RowBox[{"-", "perm_"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{
     RowBox[{"oneSterm", "[", 
      RowBox[{"metric", ",", "first", ",", "last"}], "]"}], "[", "perm", 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"oneSterm", "[", 
     RowBox[{"metric_", ",", "first_List", ",", "last_List"}], "]"}], "[", 
    "perm_", "]"}], ":=", 
   RowBox[{"Inner", "[", 
    RowBox[{"metric", ",", "first", ",", 
     RowBox[{"PermuteList", "[", 
      RowBox[{"last", ",", "perm"}], "]"}], ",", "Times"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"expandSdelta", "[", 
     RowBox[{"sym_", ",", "metric_"}], "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"first", "=", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"{", "inds", "}"}], ",", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"{", "inds", "}"}], "]"}], "/", "2"}]}], "]"}]}], ",", 
       RowBox[{"last", "=", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"{", "inds", "}"}], ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Length", "[", 
             RowBox[{"{", "inds", "}"}], "]"}]}], "/", "2"}]}], "]"}]}], ",", 
       
       RowBox[{"grouplist", "=", 
        RowBox[{"Dimino", "[", "sym", "]"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"Apply", "[", 
       RowBox[{"Plus", ",", 
        RowBox[{
         RowBox[{"oneSterm", "[", 
          RowBox[{"metric", ",", "first", ",", "last"}], "]"}], "/@", 
         "grouplist"}]}], "]"}], "/", 
      RowBox[{"Length", "[", "grouplist", "]"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c28133e3-cda4-49e5-ba02-fb537e623a10"],

Cell["\<\
This is a private function that we use to remove the Sdelta after using it \
for canonicalization:\
\>", "Text",ExpressionUUID->"5cc18292-26ee-4fc7-82db-c102af579b44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RemoveSdelta", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"Sdelta", "[", "_", "]"}], "[", "inds___", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", "=", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"{", "inds", "}"}], "]"}], "/", "2"}]}], "}"}], ",", 
       RowBox[{"Inner", "[", 
        RowBox[{"delta", ",", 
         RowBox[{"Take", "[", 
          RowBox[{
           RowBox[{"{", "inds", "}"}], ",", "n"}], "]"}], ",", 
         RowBox[{"Take", "[", 
          RowBox[{
           RowBox[{"{", "inds", "}"}], ",", 
           RowBox[{"-", "n"}]}], "]"}], ",", "Times"}], "]"}]}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1c319a11-23bf-4655-be39-a3d307866d55"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.4. Formatting", \
"Subsection",ExpressionUUID->"3316f061-7cd4-4a88-b25d-57aa4e6b18df"],

Cell["\<\
Tensor formatting. The old formatting mechanism is recovered using here \
\"ScriptBox\" instead of \"GridBox\".\
\>", "Text",ExpressionUUID->"7d4c4173-b8cb-4c79-a4af-4406fd339a11"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$TensorBoxes", "=", "\"\<GridBox\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f0895d4e-f75a-49f9-aa47-aa8c9682f6bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorBox", "[", 
    RowBox[{
     RowBox[{"Projected", "[", 
      RowBox[{"tensor_", ",", "projs_List"}], "]"}], ",", "inds_List"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"MakeTensorBoxes", "[", "$TensorBoxes", "]"}], "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "tensor", "]"}], ",", 
     RowBox[{
      RowBox[{"IndexArray", "[", "$TensorBoxes", "]"}], "[", 
      RowBox[{"inds", ",", "projs"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"200b0a34-6cb2-43d4-a4b9-34d03e8c35ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorBox", "[", 
    RowBox[{"tensor_", ",", "inds_List"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"MakeTensorBoxes", "[", "$TensorBoxes", "]"}], "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "tensor", "]"}], ",", 
     RowBox[{
      RowBox[{"IndexArray", "[", "$TensorBoxes", "]"}], "[", "inds", "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"289792ba-431a-4702-abfc-0e2c02e1fbb4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorBoxes", "[", "\"\<ScriptBox\>\"", "]"}], "=", 
   "MakeTensorScriptBoxes"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorBoxes", "[", "\"\<GridBox\>\"", "]"}], "=", 
   "MakeTensorGridBoxes"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c2650663-da60-4e17-b90a-5ad0cddc31c1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexArray", "[", "\"\<ScriptBox\>\"", "]"}], "=", "SSSBinds"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexArray", "[", "\"\<GridBox\>\"", "]"}], "=", "IndexGrid"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"11b16644-7fcb-46ec-92a2-616108883927"],

Cell["\<\
1) This is the old formatting for tensors, based on SubsuperscriptBox.\
\>", "Text",ExpressionUUID->"4366d82b-6fb2-45cb-97f9-e885ce450309"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorScriptBoxes", "[", 
    RowBox[{"stem_String", ",", 
     RowBox[{"{", 
      RowBox[{"downstring_String", ",", "upstring_String"}], "}"}]}], "]"}], ":=", 
   RowBox[{"SubsuperscriptBox", "[", 
    RowBox[{"stem", ",", "downstring", ",", "upstring"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e1db2cd0-06c0-4392-b847-4452f158b229"],

Cell["\<\
Note that SSSBinds only accepts lists of indices with head List, and not \
IndexList. This is because it is much more natural within the Fold construct. \
This function is also used in the construction of Projected tensors and \
derivatives with multi-indices.\
\>", "Text",ExpressionUUID->"d890eb2e-bf4e-4f84-8dcd-4abcd103c1e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SSSBinds", "[", "inds_List", "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"AddIndex", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", "inds"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3c43a0cd-a82c-46fa-9df0-4266e106534e"],

Cell["A generalization for projected indices:", \
"Text",ExpressionUUID->"e218d35c-440f-43a6-8a3b-4e06c63ca768"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SSSBinds", "[", 
    RowBox[{"inds_List", ",", "projs_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"AddIndex", "[", 
       RowBox[{"#1", ",", 
        RowBox[{"#2", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "Null", ",", 
        RowBox[{"#2", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"inds", ",", "projs"}], "}"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4ab6dacd-6e12-4c5b-a2d0-ede25cf72c57"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"4a3f6dd5-c21e-4038-9bd3-344d77707175"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SSSBinds", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B", ",", "C"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"67068ae6-2443-41a1-a05d-3c96527c4ae8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A  \"\>", ",", "\<\" BC\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"2c9cedd5-a5b7-4104-a86d-4b741e48dde4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0a985f77-0a44-4895-84a4-ea24f6e9b379"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>"}], "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"A", "B"}],
  Editable->
   False]], "Print",ExpressionUUID->"01615c8c-f31c-4252-bdc6-78a8faf3a7f1"]
}, Open  ]],

Cell["\<\
2) And this is our new formatting, base on the more flexible GridBox. In \
particular note how many parameters we can play with, including a global \
fontsize parameter for all indices. Both the tensor and the index grid are \
constructed with GridBox.\
\>", "Text",ExpressionUUID->"3db6644f-8a82-4961-b3b2-5a85b75df78a"],

Cell["\<\
We need this exception because GridBox complains with empty grids.\
\>", "Text",ExpressionUUID->"79c8ae60-ea61-4550-ae39-a1fe1086b78b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorGridBoxes", "[", 
    RowBox[{"stem_", ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "stem"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3c51df16-4517-49d0-8016-805dae3d0076"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorGridBoxes", "[", 
    RowBox[{"stem_", ",", "indexgrid_List"}], "]"}], ":=", 
   RowBox[{"GridBox", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"stem", ",", "\[IndentingNewLine]", 
        RowBox[{"StyleBox", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"GridBox", "[", "\[IndentingNewLine]", 
           RowBox[{"indexgrid", ",", "\[IndentingNewLine]", 
            RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
            RowBox[{"ColumnSpacings", "\[Rule]", "0.05"}], ",", 
            RowBox[{"GridFrameMargins", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", 
          RowBox[{"FontSize", "\[Rule]", 
           RowBox[{
            RowBox[{"3", "/", "4"}], 
            RowBox[{"CurrentValue", "[", "FontSize", "]"}]}]}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.05"}], ",", 
     RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b4f26d21-ea84-4af6-aee7-51d9aacfef34"],

Cell["With or without projectors:", \
"Text",ExpressionUUID->"402e7983-ea32-4d96-a742-ba5376fad5fa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexGrid", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "projs_"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexGrid", "[", 
    RowBox[{"{", "}"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexGrid", "[", 
    RowBox[{"inds_List", ",", "projs_"}], "]"}], ":=", 
   RowBox[{"Reverse", "@", 
    RowBox[{"Transpose", "@", 
     RowBox[{"Inner", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"IndexPair", "[", 
         RowBox[{"#1", ",", "Null", ",", "#2"}], "]"}], "&"}], ",", "inds", 
       ",", "projs", ",", "List"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexGrid", "[", "inds_List", "]"}], ":=", 
   RowBox[{"Reverse", "@", 
    RowBox[{"Transpose", "[", 
     RowBox[{"IndexPair", "/@", "inds"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b893d310-c94c-45a3-8ab7-ded903939057"],

Cell["3) Main drivers:", \
"Text",ExpressionUUID->"999f6bec-8274-459d-a0b2-7fea4bd2b725"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldxTensorQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldxTensorQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"xTensorQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"67efa932-ef0a-4a91-b0a1-bc1cd74abf19"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "Tensor", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "HeldxTensorQ"}], "[", "inds___", "]"}], ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<Tensor Formatting\>\""}], "}"}], 
       ",", 
       RowBox[{"interpretbox", "[", 
        RowBox[{
         RowBox[{"tensor", "[", "inds", "]"}], ",", 
         RowBox[{"xTensorBox", "[", 
          RowBox[{"tensor", ",", 
           RowBox[{"{", "inds", "}"}]}], "]"}]}], "]"}]}], "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "Tensor", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "HeldxTensorQ"}], "[", "inds___", "]"}], ",", 
       "StandardForm"}], "]"}], "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "Tensor", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7a245a5d-f957-4f3f-a9e9-b67a9e1d49a5"],

Cell["Examples:", \
"Text",ExpressionUUID->"afcbdf7b-a53e-4d76-bc8c-8f85372184b1"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0b5b2312-754b-4d4b-9b3e-2a35a56ec738"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"19e13787-db48-4591-ae98-bcf2e8753c0c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1eb81392-f1a7-415d-975f-7b0abc792e7a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"62640b2f-6a1c-424a-a494-5099e8144e6a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"68c68aa8-bbbb-469b-9ccf-6cb09ae56eac"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"bc1ccd80-f226-49fc-be77-0eda6f9fca88"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"0575c8ae-5320-4bf6-a79a-98b7691e9d89"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6581fc6e-40a6-43ad-8d4f-0b4d83843fbf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"B", ",", "A", ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"383a176a-9f33-42ff-a0cb-be333f94ddb0"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"B", "A", " "},
         {" ", " ", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`B, $CellContext`A, -C],
  Editable->
   False]], "Output",ExpressionUUID->"16013244-a7d3-4a0c-ba45-594f16540330"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToBoxes", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"4d833e03-0844-468b-a057-7be0dc0ee4df"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"GridBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"\<\"T\"\>", ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\<\"B\"\>", ",", "\<\"A\"\>", ",", "\<\" \"\>"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\<\" \"\>", ",", "\<\" \"\>", ",", "\<\"C\"\>"}], 
                 "}"}]}], "}"}], ",", 
              RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
              RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
              RowBox[{"GridFrameMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "A", " "},
           {" ", " ", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, $CellContext`A, -C],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"e9426a5d-25f6-48cc-b5b0-ef7e65fea189"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%%", 
  "]"}]], "Input",ExpressionUUID->"1d58dec1-a206-4feb-8867-a4546a89b339"],

Cell["T[B, A, -C]", \
"Output",ExpressionUUID->"eb8bcbba-6a9a-4ba4-a31a-ca26dafd7d49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A$", ",", 
   RowBox[{"-", "A$"}], ",", "C$101"}], 
  "]"}]], "Input",ExpressionUUID->"a48ca80d-f8b5-415f-923c-0ae45daa4337"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A$", " ", "C$101"},
         {" ", "A$", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A$, -$CellContext`A$, $CellContext`C$101],
  Editable->
   False]], "Output",ExpressionUUID->"d84c6489-0e5d-49bc-bef3-233ca8a51675"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"A$", ",", 
    RowBox[{"-", "A$"}], ",", "C$101"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"205a7a3f-8a89-458f-a312-6bd108fd448f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", " ", "B"},
         {" ", "A", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, -$CellContext`A, $CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"18455250-a775-4bc4-a9e1-72489a00c3da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"B_", ",", "A_", ",", 
   RowBox[{"-", "C_"}]}], 
  "]"}]], "Input",ExpressionUUID->"84f394d2-2591-42f3-aa79-a8445d35c4ff"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {
          UnderscriptBox["B", "_"], 
          UnderscriptBox["A", "_"], " "},
         {" ", " ", 
          UnderscriptBox["C", "_"]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[
   Pattern[$CellContext`B, 
    Blank[]], 
   Pattern[$CellContext`A, 
    Blank[]], -Pattern[C, 
     Blank[]]],
  Editable->
   False]], "Output",ExpressionUUID->"d3738278-2c3b-4d4c-8310-714010ab20c2"]
}, Open  ]],

Cell["Cut and paste:", \
"Text",ExpressionUUID->"504c18cb-f8a9-4955-8fac-2a84a07d6250"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   SubsuperscriptBox["T", 
    RowBox[{"  ", "C"}], 
    RowBox[{"BA", " "}]],
   AutoSpacing->False],
  T[B, A, -C],
  Editable->
   False]], "Input",ExpressionUUID->"5640b5a5-7ae4-4f71-9096-4967e8eea35b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"B", "A", " "},
         {" ", " ", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`B, $CellContext`A, -C],
  Editable->
   False]], "Output",ExpressionUUID->"14235619-0723-464e-9b5c-bd5c18a99d7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"504a9c35-2a86-47c4-b2fa-d6fb9af8e600"],

Cell["T[B, A, -C]", \
"Output",ExpressionUUID->"461b4766-85c9-43cf-b583-1b16a8e41520"]
}, Open  ]],

Cell["\<\
Note that for patterns (in the second case) the index A is slightly displaced \
to the right. I don't know why:\
\>", "Text",ExpressionUUID->"82480b7c-d82a-4227-91b6-d24bf4c8da77"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubsuperscriptBox["T", 
     RowBox[{"  ", "C"}], 
     RowBox[{"BA", " "}]],
    AutoSpacing->False],
   T[B, A, -C],
   Editable->False], "//", 
  "ToBoxes"}]], \
"Input",ExpressionUUID->"263ea748-6a35-420b-a562-3445f3387808"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"GridBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"\<\"T\"\>", ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\<\"B\"\>", ",", "\<\"A\"\>", ",", "\<\" \"\>"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\<\" \"\>", ",", "\<\" \"\>", ",", "\<\"C\"\>"}], 
                 "}"}]}], "}"}], ",", 
              RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
              RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
              RowBox[{"GridFrameMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "A", " "},
           {" ", " ", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, $CellContext`A, -C],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"5ce293e4-6904-4180-98e5-485e3435244a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubsuperscriptBox["T", 
     RowBox[{"  ", 
      UnderscriptBox["C", "_"]}], 
     RowBox[{
      UnderscriptBox["B", "_"], 
      UnderscriptBox["A", "_"], " "}]],
    AutoSpacing->False],
   T[
    Pattern[B, 
     Blank[]], 
    Pattern[A, 
     Blank[]], -Pattern[C, 
      Blank[]]],
   Editable->False], "//", 
  "ToBoxes"}]], \
"Input",ExpressionUUID->"dafb78a7-fb91-4208-97ff-03a195cda61f"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"GridBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"\<\"T\"\>", ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 
                 RowBox[{"\<\"\\!\\(B\\+_\\)\"\>", 
                  ",", "\<\"\\!\\(A\\+_\\)\"\>", ",", "\<\" \"\>"}], "}"}], 
                ",", 
                RowBox[{"{", 
                 
                 RowBox[{"\<\" \"\>", ",", "\<\" \"\>", 
                  ",", "\<\"\\!\\(C\\+_\\)\"\>"}], "}"}]}], "}"}], ",", 
              RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
              RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
              RowBox[{"GridFrameMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {
            UnderscriptBox["B", "_"], 
            UnderscriptBox["A", "_"], " "},
           {" ", " ", 
            UnderscriptBox["C", "_"]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[
     Pattern[$CellContext`B, 
      Blank[]], 
     Pattern[$CellContext`A, 
      Blank[]], -Pattern[C, 
       Blank[]]],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"fa2832d2-38ce-4dea-a449-e10b796c2fdf"]
}, Open  ]],

Cell["\<\
This is not related to AutoSpacing. It is a problem related to the fact that \
we have removed the explicit quotes:\
\>", "Text",ExpressionUUID->"6d01eb32-2704-4969-820b-e4c04115b27f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"InterpretationBox", "[", 
   RowBox[{
    RowBox[{"StyleBox", "[", 
     RowBox[{
      RowBox[{"SubsuperscriptBox", "[", 
       RowBox[{
       "\"\<T\>\"", ",", "\"\<\\\"  \\!\\(C\\+_\\)\\\"\>\"", ",", 
        "\"\<\\\"\\!\\(B\\+_\\)\\!\\(A\\+_\\) \\\"\>\""}], "]"}], ",", 
      RowBox[{"AutoSpacing", "\[Rule]", "False"}]}], "]"}], ",", 
    InterpretationBox[
     StyleBox[
      SubsuperscriptBox["T", 
       RowBox[{"  ", 
        UnderscriptBox["C", "_"]}], 
       RowBox[{
        UnderscriptBox["B", "_"], 
        UnderscriptBox["A", "_"], " "}]],
      AutoSpacing->False],
     T[
      Pattern[B, 
       Blank[]], 
      Pattern[A, 
       Blank[]], -Pattern[C, 
        Blank[]]],
     Editable->False], ",", 
    RowBox[{"Editable", "\[Rule]", "False"}]}], "]"}], "//", 
  "DisplayForm"}]], \
"Input",ExpressionUUID->"9df39551-25de-41d4-bed0-3684b5453350"],

Cell[BoxData[
 TagBox[
  InterpretationBox[
   StyleBox[
    SubsuperscriptBox[
     "T", "\<\"  \!\(C\+_\)\"\>", "\<\"\!\(B\+_\)\!\(A\+_\) \"\>"],
    AutoSpacing->False],
   $CellContext`T[
    Pattern[$CellContext`B, 
     Blank[]], 
    Pattern[$CellContext`A, 
     Blank[]], -Pattern[C, 
      Blank[]]],
   Editable->False],
  DisplayForm]], \
"Output",ExpressionUUID->"61357e3d-2058-48e0-948e-136fb784e13c"]
}, Open  ]],

Cell["\<\
But then we can't have a nice looking cut-and-pasted expression:\
\>", "Text",ExpressionUUID->"fea758bb-bf51-4ece-9b96-107c9b83d1d5"],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  InterpretationBox[
   StyleBox[
    SubsuperscriptBox["T", "\"\<  \!\(\*UnderscriptBox[\(C\), \(_\)]\)\>\"", 
     "\"\<\!\(\*UnderscriptBox[\(B\), \(_\)]\)\!\(\*UnderscriptBox[\(A\), \(_\
\)]\) \>\""],
    AutoSpacing->False],
   T[
    Pattern[B, 
     Blank[]], 
    Pattern[A, 
     Blank[]], -Pattern[C, 
      Blank[]]],
   Editable->False],
  DisplayForm]], \
"Input",ExpressionUUID->"46c5d7f8-9d35-4d48-a454-d320de168c48"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {
          UnderscriptBox["B", "_"], 
          UnderscriptBox["A", "_"], " "},
         {" ", " ", 
          UnderscriptBox["C", "_"]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[
   Pattern[$CellContext`B, 
    Blank[]], 
   Pattern[$CellContext`A, 
    Blank[]], -Pattern[C, 
     Blank[]]],
  Editable->
   False]], "Output",ExpressionUUID->"e84247ef-8850-45a4-9d52-ce43d308c2a8"]
}, Open  ]],

Cell["\<\
We can also try removing the quotes, but then we do not have strings anymore:\
\
\>", "Text",ExpressionUUID->"4834d3c1-1683-4268-944c-01c36067bc56"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\\!", 
  RowBox[{"\\(", 
   RowBox[{"C", "\\+", "_"}], 
   "\\)"}]}]], "Input",ExpressionUUID->"cafc7765-03d0-4dd7-9787-a9a2043cd949"],

Cell[BoxData[
 UnderscriptBox["C", 
  "_"]], "Output",ExpressionUUID->"43c8be2c-ed32-49af-8ad8-cb70c3739484"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{
  "C", "\[Rule]", 
   "1"}]}]], "Input",ExpressionUUID->"36775bba-7770-4b5b-b54f-65227b903cb6"],

Cell[BoxData[
 UnderscriptBox["1", 
  "_"]], "Output",ExpressionUUID->"9b40d207-04f1-46d4-9841-1a1c16aa8d6b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"3a0dc879-6004-42b2-9af4-2e492a96ccc9"],

Cell["UnderBar[1]", \
"Output",ExpressionUUID->"0854b670-6743-4be9-8ea7-97cf556d3d0e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"xTensorFormStop", "[", "Tensor", 
  "]"}]], "Input",ExpressionUUID->"40fc2819-0777-4dc4-95e5-ae9939618763"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   SubsuperscriptBox["T", 
    RowBox[{"  ", "C"}], 
    RowBox[{"AB", " "}]],
   AutoSpacing->False],
  T[A, B, -C],
  Editable->
   False]], "Input",ExpressionUUID->"55339013-61c9-4209-b1ad-63e3d42bc9c5"],

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", "B", ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Output",ExpressionUUID->"b83da388-c3e1-45b8-8fdf-d6e9a60947f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", "B", ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"299c50e5-736b-4d89-91d3-bec2e0dfab64"],

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", "B", ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Output",ExpressionUUID->"6a1713d6-7267-49cc-9be2-53d9117ab1c4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"xTensorFormStart", "[", "Tensor", 
  "]"}]], "Input",ExpressionUUID->"0edcc493-0d57-4867-9237-08a0e8b1ee66"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", "B", ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"d04f6e15-cf93-4a2c-9875-f1d1652b4f0c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", " "},
         {" ", " ", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, $CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"cb2d97a7-2d59-4477-bcb5-df751f508421"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"63b563a5-779b-49ce-b6fd-8e68c207e5d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"ed0cc78c-931d-4e5a-bb20-934bf7573b0c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"A$", ",", "C$101"}], 
  "]"}]], "Input",ExpressionUUID->"2a9841ab-bc82-490b-bc8b-eee7543b4e58"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"c718b795-8a1c-4b0d-8aa7-3043130bc3e9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"7cf14c43-41b7-475c-92a8-eb4726f419cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"edd3f86b-fea1-4ea6-8067-4347620627e7"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"51aa93a1-694e-4377-b310-c3ed77087271"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.5. Directional slots", \
"Subsection",ExpressionUUID->"fad5c1ad-a5b3-4d7d-8f22-e4459ea23b11"],

Cell["\<\
Implement linearity. Note the importance of having Dir at the first level of \
the tensor expression. If we used the notation -Dir[v[z]] for a covariant \
d-index that wouldn't be possible.\
\>", "Text",ExpressionUUID->"622c309f-31f4-4022-8229-99974a1be243"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{"f_", ",", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{"SeriesData", "[", 
       RowBox[{"var_", ",", "orig_", ",", "coeffs_List", ",", "rest__"}], 
       "]"}], "]"}]}], "]"}], ":=", 
   RowBox[{"SeriesData", "[", 
    RowBox[{"var", ",", "orig", ",", 
     RowBox[{"Map", "[", 
      RowBox[{"f", ",", "coeffs"}], "]"}], ",", "rest"}], "]"}]}], 
  ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"5a9889ce-bada-40c0-83db-dea2329746ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"SeriesDataMap\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "SeriesDataMap", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"0bd5575b-a64d-434c-9ca7-96dcc02389fc"]
}, Open  ]],

Cell["\<\
Improved version, after discussions with Teake in the group :\
\>", "Text",ExpressionUUID->"e2717ce2-21fe-4e62-be6d-d9e3180da2a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{"f_", "?", "FirstDerQ"}], ",", 
     RowBox[{"sd", ":", 
      RowBox[{"HoldPattern", "[", 
       RowBox[{"SeriesData", "[", 
        RowBox[{"var_", ",", "orig_", ",", "coeffs_List", ",", "rest__"}], 
        "]"}], "]"}]}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "var", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"SeriesData", "[", 
      RowBox[{"var", ",", "orig", ",", 
       RowBox[{"Map", "[", 
        RowBox[{"f", ",", "coeffs"}], "]"}], ",", "rest"}], "]"}], ",", 
     RowBox[{
      RowBox[{"f", "[", "var", "]"}], " ", 
      RowBox[{"D", "[", 
       RowBox[{"sd", ",", "var"}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"70d03063-777b-4c68-8880-720358db8645"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dir", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"tensor_", "?", "xTensorQ"}], ")"}], "[", 
    RowBox[{"x___", ",", 
     RowBox[{"Dir", "[", "v_Plus", "]"}], ",", "y___"}], "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor", "[", 
       RowBox[{"x", ",", 
        RowBox[{"Dir", "[", "#", "]"}], ",", "y"}], "]"}], "&"}], ",", "v"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Dir", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"tensor_", "?", "xTensorQ"}], ")"}], "[", 
    RowBox[{"x___", ",", 
     RowBox[{"Dir", "[", "v_SeriesData", "]"}], ",", "y___"}], "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor", "[", 
       RowBox[{"x", ",", 
        RowBox[{"Dir", "[", "#", "]"}], ",", "y"}], "]"}], "&"}], ",", "v"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Dir", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"tensor_", "?", "xTensorQ"}], ")"}], "[", 
    RowBox[{"x___", ",", 
     RowBox[{"Dir", "[", 
      RowBox[{
       RowBox[{"scalar_", "?", "ScalarQ"}], " ", "v_"}], "]"}], ",", "y___"}],
     "]"}], ":=", 
   RowBox[{"scalar", " ", 
    RowBox[{"tensor", "[", 
     RowBox[{"x", ",", 
      RowBox[{"Dir", "[", "v", "]"}], ",", "y"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Dir", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"tensor_", "?", "xTensorQ"}], ")"}], "[", 
    RowBox[{"___", ",", 
     RowBox[{"Dir", "[", "0", "]"}], ",", "___"}], "]"}], ":=", "0"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d5ce5e21-45ac-4284-8627-dbd23e0a1cf0"],

Cell["\<\
Note that we validate expr below. We use certain definitions containing Dir \
expresions with patterns; we need to consider those cases. Given that our \
definitions only use patterns at the first and second levels of Dir, we only \
need those two cases.\
\>", "Text",ExpressionUUID->"a04ff717-7a51-4612-89c8-8b8a7af59530"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ValidateDir"}]], \
"Input",ExpressionUUID->"ab08fb53-f488-4541-a209-685d71de1dd1"],

Cell[BoxData[
 StyleBox["\<\"\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672679-5338953",ExpressionUUID->"654f704b-63f4-46d6-889d-\
26a4bea64108"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ValidateDir", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateDir", "[", 
    RowBox[{"x", ":", 
     RowBox[{"Dir", "[", 
      RowBox[{"_Blank", "|", "_Pattern", "|", "_PatternTest"}], "]"}]}], 
    "]"}], ":=", "x"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateDir", "[", 
    RowBox[{"x", ":", 
     RowBox[{"Dir", "[", 
      RowBox[{"_", "[", 
       RowBox[{"___", ",", 
        RowBox[{"_Blank", "|", "_Pattern", "|", "_PatternTest"}], ",", 
        "___"}], "]"}], "]"}]}], "]"}], ":=", "x"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateDir", "[", 
    RowBox[{"x", ":", 
     RowBox[{"Dir", "[", "0", "]"}]}], "]"}], ":=", "x"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateDir", "[", 
    RowBox[{"x", ":", 
     RowBox[{"Dir", "[", "expr_", "]"}]}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$WarningFrom", "=", "\"\<Dir Validation\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Check", " ", "expression"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"UncatchedValidate", "[", "expr", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Check", " ", "free", " ", "ultraindex"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"UltraindexOf", "[", "expr", "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"(*", " ", 
       RowBox[{
       "Return", " ", "index", " ", "if", " ", "everything", " ", "OK"}], " ",
        "*)"}], "\[IndentingNewLine]", "x"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateDir", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"Validate", "::", "invalid"}], ",", "x", ",", 
       "\"\<directional index\>\""}], "]"}], ";", 
     RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"42f0a437-47b6-4559-ab5d-d88883fb8a05"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5025419d-2073-441f-8786-b6ea47c1d85d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "Z"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"158b16b8-1de8-4b13-a13a-1dba46bd6aaa"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e46eb1d6-4e27-409b-86ea-6dde95269fd2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5dab861e-9369-47a0-8f5b-ea5c416eb734"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"43b2abc4-fd65-44ec-a01b-19c6f28ab446"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b5f5baa0-4c6c-418d-90b8-13ab973c4c5d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"a1fd5901-96e5-4c15-b127-889d0ad4b61a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c59d8d40-d8b7-47d3-bd89-8e53b1777c9d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"897639ab-999e-401e-bc5e-098ba30f4768"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5bf622ee-6830-4271-9320-2b9032afe7cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4efede1a-0e33-45f7-bb4d-1060812b8a0a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", 
   RowBox[{"Dir", "[", 
    RowBox[{
     RowBox[{"3", 
      RowBox[{"v", "[", "Z", "]"}]}], "+", 
     RowBox[{"w", "[", "Z", "]"}]}], "]"}], ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"f30d3521-2ccd-40b2-9b7f-1cb2aaa86573"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "B"},
           {" ", "v", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, 
     xAct`xTensor`Dir[
      $CellContext`v[$CellContext`Z]], $CellContext`B],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", " ", "B"},
          {" ", "w", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, 
    xAct`xTensor`Dir[
     $CellContext`w[$CellContext`Z]], $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"fd8b91b2-c6d2-4c90-8e2a-0732d5a2cdd8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", 
   RowBox[{"Dir", "[", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "Z"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], 
     RowBox[{"v", "[", "B", "]"}], 
     RowBox[{"w", "[", "C", "]"}]}], "]"}], ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"2872e909-8e20-4048-b60e-cdf029dffba9"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "#", "B"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, 
   xAct`xTensor`Dir[($CellContext`T[-$CellContext`Z, -$CellContext`B, -
       C] $CellContext`v[$CellContext`B]) $CellContext`w[C]], $CellContext`B],
  
  Editable->
   False]], "Output",ExpressionUUID->"756bafb4-2c20-43a0-adb8-6b95fb8a7feb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateDir", "[", 
   RowBox[{"Dir", "[", 
    RowBox[{
     RowBox[{"3", 
      RowBox[{"v", "[", 
       RowBox[{"-", "A"}], "]"}]}], "+", 
     RowBox[{"w", "[", "A", "]"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"ad170505-c2c3-47e0-9841-328083c8906a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "inhom"}], "MessageName"], ":", 
  " ", "\<\"Found inhomogeneous \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak]: \
\[NoBreak]\\!\\(\\\"{IndexList[-A], IndexList[A]}\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",ExpressionUUID->"fbbeab2d-f0d4-41d6-8312-68052f833f5f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateDir", "[", 
   RowBox[{"Dir", "[", 
    RowBox[{"3", 
     RowBox[{"v", "[", 
      RowBox[{"A", ",", "B"}], "]"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"fc305acf-0b36-40cd-970c-fa5c35dddf47"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid or no \
ultraindex.\\\"\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a4b72870-8c79-4006-8065-026ad00b2906"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateDir", "[", 
   RowBox[{"Dir", "[", 
    RowBox[{"3", 
     RowBox[{"v", "[", "A", "]"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"cbc1b41b-118e-4d1f-a2b4-61537a497deb"],

Cell[BoxData[
 RowBox[{"Dir", "[", 
  RowBox[{"3", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"0ca668d1-9e4a-497b-a70a-d7e0cc205dbe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ValidateDir", "[", 
  RowBox[{"Dir", "[", 
   RowBox[{"3", 
    RowBox[{"v", "[", "Z", "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"04d31f81-0a5a-44e2-9e77-539808512ec6"],

Cell[BoxData[
 RowBox[{"Dir", "[", 
  RowBox[{"3", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"Z"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`Z],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"2aa6e193-de08-40fd-9985-bfea82587a6c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v", ",", "w"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"cc427a2d-e438-4cdd-bd5d-11ddbd997181"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"b3e38e6d-6945-4544-836a-ac10dc9d8bfc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"f2dde5ca-45b3-4590-a4de-0a840aec4a80"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"c178b65e-3ead-4bdd-b986-19642e2f55c1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"df09ce0a-c20a-4132-8406-327fab4080cc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"a53c1973-4dc6-4134-90b5-bd7651752aab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"1105ea8f-723c-4d3a-8af0-bb9387010e8d"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0ee2aa39-712f-4754-ace0-ea68d0c46cae"],

Cell["This function separates all directional indices:", \
"Text",ExpressionUUID->"9fadb6df-1b61-498c-814d-62cae51ae95a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SeparateDir"}]], \
"Input",ExpressionUUID->"e83fd7b3-c951-4076-81ae-b2438c37d972"],

Cell[BoxData[
 StyleBox["\<\"SeparateDir[expr] converts all directional indices \
(expressions Dir[v]) in expr into products of the direction v and the \
corresponding tensor.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672684-5338953",ExpressionUUID->"28189350-70eb-4ecd-aa0e-\
17318031fe75"]
}, Open  ]],

Cell["\<\
We have not yet generalized this for multiple-indices derivatives:\
\>", "Text",ExpressionUUID->"a674539c-6806-49c9-8d66-71bae68f4e93"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SeparateDir", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"tensor", ":", 
        RowBox[{
         RowBox[{"_", "?", "xTensorQ"}], "[", 
         RowBox[{"___", ",", "dir_Dir", ",", "___"}], "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{"separateDir", "[", 
        RowBox[{"tensor", ",", "dir"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"covd", ":", 
        RowBox[{
         RowBox[{
          RowBox[{"_", "?", "CovDQ"}], "[", "dir_Dir", "]"}], "[", "_", 
         "]"}]}], "\[RuleDelayed]", 
       RowBox[{"separateDir", "[", 
        RowBox[{"covd", ",", "dir"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"covd", ":", 
        RowBox[{"CovD", "[", 
         RowBox[{"_", ",", "___", ",", 
          RowBox[{
           RowBox[{"_", "?", "CovDQ"}], "[", "dir_Dir", "]"}], ",", 
          "dersR___"}], "]"}]}], "\[RuleDelayed]", 
       RowBox[{"CovD", "[", 
        RowBox[{
         RowBox[{"separateDir", "[", 
          RowBox[{"covd", ",", "dir"}], "]"}], ",", "dersR"}], "]"}]}]}], 
     "\[IndentingNewLine]", "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SeparateDir", "[", 
    RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"SeparateDir", ",", "expr", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SeparateDir", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"v_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"tensor", ":", 
        RowBox[{
         RowBox[{"_", "?", "xTensorQ"}], "[", 
         RowBox[{"___", ",", 
          RowBox[{"dir", ":", 
           RowBox[{"Dir", "[", "_v", "]"}]}], ",", "___"}], "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{"separateDir", "[", 
        RowBox[{"tensor", ",", "dir"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"covd", ":", 
        RowBox[{
         RowBox[{
          RowBox[{"_", "?", "CovDQ"}], "[", 
          RowBox[{"dir", ":", 
           RowBox[{"Dir", "[", "_v", "]"}]}], "]"}], "[", "_", "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{"separateDir", "[", 
        RowBox[{"covd", ",", "dir"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"covd", ":", 
        RowBox[{"CovD", "[", 
         RowBox[{"_", ",", "___", ",", 
          RowBox[{
           RowBox[{"_", "?", "CovDQ"}], "[", 
           RowBox[{"dir", ":", 
            RowBox[{"Dir", "[", "_v", "]"}]}], "]"}], ",", "dersR___"}], 
         "]"}]}], "\[RuleDelayed]", 
       RowBox[{"CovD", "[", 
        RowBox[{
         RowBox[{"separateDir", "[", 
          RowBox[{"covd", ",", "dir"}], "]"}], ",", "dersR"}], "]"}]}]}], 
     "\[IndentingNewLine]", "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SeparateDir", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SeparateDir", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"separateDir", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"Dir", "[", "v_", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ultraindex", "=", 
        RowBox[{"UltraindexOf", "[", "v", "]"}]}], ",", "dummy"}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dummy", "=", 
       RowBox[{"DummyAs", "[", "ultraindex", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"changeDir", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"-", "dummy"}]}], "]"}], 
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{"v", ",", 
         RowBox[{"ultraindex", "\[Rule]", "dummy"}]}], "]"}]}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changeDir", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
      RowBox[{"indsL___", ",", "_Dir", ",", "indsR___"}], "]"}], ",", 
     "mdummy_"}], "]"}], ":=", 
   RowBox[{"tensor", "[", 
    RowBox[{"indsL", ",", "mdummy", ",", "indsR"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changeDir", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_Symbol", "[", "_Dir", "]"}], "[", "expr_", "]"}], ",", 
     "mdummy_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"covd", "[", "mdummy", "]"}], "[", "expr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changeDir", "[", 
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", "ders___", ",", 
       RowBox[{"covd_Symbol", "[", "_Dir", "]"}]}], "]"}], ",", "mdummy_"}], 
    "]"}], ":=", 
   RowBox[{"CovD", "[", 
    RowBox[{"expr", ",", "ders", ",", 
     RowBox[{"covd", "[", "mdummy", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5eb01bc6-1fe5-4544-bd37-ff774b1f282c"],

Cell["\<\
And this is the inverse function, which contracts expressions into Dir slots:\
\
\>", "Text",ExpressionUUID->"61170c48-d59a-45f7-9e51-8e9497157c0c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "ContractDir", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{"OverDerivatives", "\[Rule]", "True"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "IsIndexOf", " ", "used", " ", "without", " ", "third", " ", "argument"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractDir", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"vector_", "?", "xTensorQ"}], ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"vector", "[", 
       RowBox[{"a_", "?", "AIndexQ"}], "]"}], "expr1_"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       RowBox[{"ContractDir1", "[", 
        RowBox[{"vector", ",", 
         RowBox[{"OptionValue", "[", "OverDerivatives", "]"}]}], "]"}], "[", 
       RowBox[{"expr1", " ", 
        RowBox[{"vector", "[", "a", "]"}]}], "]"}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{"expr1", ",", 
        RowBox[{"-", "a"}]}], "]"}]}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ContractDir", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ContractDir", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8cee37f1-6738-4a4e-84e0-2b1bd8e84a72"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Main", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractDir1", "[", 
         RowBox[{"vector_", ",", "od_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
        RowBox[{"indsL___", ",", "b_", ",", "indsR___"}], "]"}], 
       RowBox[{"vector_", "[", "a_", "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CM", "[", 
       RowBox[{"rest", " ", 
        RowBox[{"tensor", "[", 
         RowBox[{"indsL", ",", 
          RowBox[{"Dir", "[", 
           RowBox[{"vector", "[", "a", "]"}], "]"}], ",", "indsR"}], "]"}]}], 
       "]"}], "/;", 
      RowBox[{"PairQ", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractDir1", "[", 
         RowBox[{"vector_", ",", "od_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", 
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", 
         RowBox[{"indsL___", ",", "b_", ",", "indsR___"}], "]"}], "[", 
        "expr1_", "]"}], 
       RowBox[{"vector_", "[", "a_", "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CM", "[", 
       RowBox[{"rest", " ", 
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"indsL", ",", 
           RowBox[{"Dir", "[", 
            RowBox[{"vector", "[", "a", "]"}], "]"}], ",", "indsR"}], "]"}], 
         "[", "expr1", "]"}]}], "]"}], "/;", 
      RowBox[{"PairQ", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"First", "-", "derivatives"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractDir1", "[", 
         RowBox[{"vector_", ",", "od_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"der_", "?", "FirstDerQ"}], "[", "expr_", "]"}], 
       RowBox[{"vector_", "[", "a_", "]"}]}], "]"}], ":=", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dv", "=", 
           RowBox[{"der", "[", 
            RowBox[{"vector", "[", "a", "]"}], "]"}]}], ",", "result"}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"dv", "===", "0"}], "||", "od"}], ")"}], "&&", 
           RowBox[{"differentexpressionsQ", "[", 
            RowBox[{
             RowBox[{"result", "=", 
              RowBox[{"CM", "[", 
               RowBox[{"expr", " ", 
                RowBox[{"vector", "[", "a", "]"}]}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"expr", ",", 
               RowBox[{"vector", "[", "a", "]"}]}], "}"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"CM", "[", 
            RowBox[{"rest", " ", 
             RowBox[{"der", "[", "result", "]"}]}], "]"}], "-", 
           RowBox[{"CM", "[", 
            RowBox[{"rest", " ", "dv", " ", "expr"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"CM", "[", 
            RowBox[{"rest", " ", 
             RowBox[{"vector", "[", "a", "]"}]}], "]"}], 
           RowBox[{"der", "[", "expr", "]"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"IsIndexOf", "[", 
         RowBox[{"expr", ",", 
          RowBox[{"-", "a"}]}], "]"}], "&&", 
        RowBox[{
         RowBox[{"Head", "[", "expr", "]"}], "=!=", "vector"}]}], ")"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractDir1", "[", 
       RowBox[{"vector_", ",", "od_"}], "]"}], "[", "expr_", "]"}], ":=", 
     "expr"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4c83dcb8-9553-4ea8-ba66-ddfec6a93a9c"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"03fbfe2b-87e3-40a3-a8d2-3b6ee2052279"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8647855b-e47c-4962-b2fa-5bc6f5f24720"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"09b67d36-9a37-4beb-8e5d-c89e0a685476"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3f40e1e0-5755-4b90-ae10-7d9b9beabd75"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e33d510b-aef9-4f25-8232-d49cfd68afb4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"42e76e3d-568e-49bf-ac98-7c88b78aa65a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"8fdfa0e6-f70d-4c86-82ac-02085d365a19"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e22ed8ff-ea80-4491-985a-1f2a46a7b8f9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"854621bc-6e59-4a52-830b-7f1883ce7985"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"v", "[", 
         RowBox[{"-", "A"}], "]"}], "]"}], ",", "C"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"A", ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"v", "[", "A", "]"}], "]"}], ",", "C"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"Dir", "[", 
        RowBox[{"v", "[", "A", "]"}], "]"}], ",", 
       RowBox[{"Dir", "[", 
        RowBox[{"v", "[", "A", "]"}], "]"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"A", ",", 
        RowBox[{"Dir", "[", 
         RowBox[{"v", "[", "A", "]"}], "]"}]}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"B", ",", 
        RowBox[{"Dir", "[", 
         RowBox[{"v", "[", "A", "]"}], "]"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Scalar", "[", 
       RowBox[{"T", "[", 
        RowBox[{"Dir", "[", 
         RowBox[{"v", "[", "A", "]"}], "]"}], "]"}], "]"}], "^", "2"}]}], 
    "}"}], "//", "SeparateDir"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"fabca6ab-1c8f-47dd-aef7-62d1dfdb376e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B", "C"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`B, C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {" "},
            {"B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[-$CellContext`B],
     Editable->False]}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " ", "C"},
            {" ", "B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, -$CellContext`B, C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[$CellContext`B],
     Editable->False]}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[$CellContext`B],
     Editable->False]}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " "},
            {" ", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, -C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", " "},
            {" ", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B, -D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"D"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[D],
     Editable->False]}], ",", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[-$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {"A"},
                {" "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[$CellContext`A],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
     Editable->False], "2"]}], 
  "}"}]], "Output",ExpressionUUID->"d36c246a-924f-4ad4-b290-db803512caf9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractDir", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}]}], ",", "v"}], 
  "]"}]], "Input",ExpressionUUID->"701ef124-e77e-4489-9da6-2fe69e43da06"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"v", "B", "C"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[
   xAct`xTensor`Dir[
    $CellContext`v[-$CellContext`A]], $CellContext`B, C],
  Editable->
   False]], "Output",ExpressionUUID->"a768ae4b-1950-4187-9bf6-f0131dddfb39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ContractDir", "[", 
    RowBox[{"#", ",", "v"}], "]"}], "&"}], "/@", 
  "%"}]], "Input",ExpressionUUID->"b8421752-227a-4a69-947e-abec0d3be191"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"v", "B", "C"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[
   xAct`xTensor`Dir[
    $CellContext`v[-$CellContext`A]], $CellContext`B, C],
  Editable->
   False]], "Output",ExpressionUUID->"d7522475-7c4a-4934-a2aa-6a731aa67444"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ContractDir", "[", 
    RowBox[{"#", ",", "v"}], "]"}], "&"}], "/@", 
  "%"}]], "Input",ExpressionUUID->"0720747b-683d-4774-9ca1-44bc0d658547"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"v", "B", "C"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[
   xAct`xTensor`Dir[
    $CellContext`v[-$CellContext`A]], $CellContext`B, C],
  Editable->
   False]], "Output",ExpressionUUID->"6ccb4f94-e5bf-4639-9153-5ff2f76c9691"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"4c86e90e-eb6d-4af3-b5dc-6785900604dd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"d9e4b042-ba3b-4cc0-8cd3-716353327b83"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"7a85f694-e304-41b7-85aa-f9e63ef0bec8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"f0a73490-9cea-40a2-97e3-65ac9d0a9c80"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"32bc7a33-2a4a-4593-a82d-036dd6a4f1cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"a73899f5-eac0-46f8-b5dc-61f21400e3d4"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"884f44e3-026a-4e24-bc5f-954c62db283b"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.6. Validation", \
"Subsection",ExpressionUUID->"cb9b1ef1-0981-4e8d-a894-4cc4a1fd65a6"],

Cell["This function validates single tensors.", \
"Text",ExpressionUUID->"f48504f5-3d7c-46af-959d-3ac9eca1e208"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ValidateTensor"}]], \
"Input",ExpressionUUID->"a44713d7-1ac8-42e3-9b17-e1183720d92b"],

Cell[BoxData[
 StyleBox["\<\"xAct`xTensor`Private`ValidateTensor[tensor[inds]] validates \
the name, indices and index-structure of the given tensor.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672688-5338953",ExpressionUUID->"b9dbc5fc-f625-4ae1-9cfb-\
255073ab514e"]
}, Open  ]],

Cell["If a pattern index is found there are no further checks:", \
"Text",ExpressionUUID->"89c5532a-d22c-4341-ac1d-f24ad43b252d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Validate", "::", "pat"}], "=", 
   "\"\<Found pattern index `1` . Cannot validate.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ValidateTensor", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ValidateTensor", "[", 
   RowBox[{"x", ":", 
    RowBox[{"tensor_", "[", "inds___", "]"}]}], "]"}], ":=", 
  RowBox[{"Catch", "@", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$WarningFrom", "=", "\"\<Tensor Validation\>\""}], "}"}], ",", 
     
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "newinds", ",", "bundles", ",", "rightbundles", ",", "metricsQ", ",", 
         "ups", ",", "rightups", ",", "strtensor", ",", "valid", ",", 
         "anynumberQ"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", " ", "Recognize"}], " ", "tensor", " ", "name"}], " ", 
        "***)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"xTensorQ", "[", "tensor", "]"}]}], ",", 
          RowBox[{"Throw", "[", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"Validate", "::", "unknown"}], ",", "\"\<tensor\>\"", 
              ",", "tensor"}], "]"}], ";", 
            RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"**", " ", "Discard"}], " ", "patterns", " ", "and", " ", 
           "validate", " ", "g"}], "-", "indices"}], " ", "***)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"PIndexQ", "[", "#", "]"}], ",", 
            RowBox[{
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{"Validate", "::", "pat"}], ",", "#"}], "]"}], ";", 
             RowBox[{"Return", "[", "x", "]"}]}]}], "]"}], "&"}], "/@", 
         RowBox[{"IndexList", "[", "inds", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"GIndexQ", "[", "#", "]"}]}], ",", 
            RowBox[{"Throw", "[", 
             RowBox[{
              RowBox[{"Message", "[", 
               RowBox[{
                RowBox[{"Validate", "::", "unknown"}], ",", "\"\<index\>\"", 
                ",", "#"}], "]"}], ";", 
              RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], "&"}], "/@", 
         RowBox[{"IndexList", "[", "inds", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"**", " ", "Validate"}], " ", "index"}], "-", 
          RowBox[{
           RowBox[{"structure", ".", " ", "Not"}], " ", "possible", " ", 
           "for", " ", "a", " ", "variable", " ", "rank", " ", "tensor"}]}], 
         " ", "***)"}], "\[IndentingNewLine]", 
        RowBox[{"anynumberQ", "=", 
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", 
           RowBox[{"AnyIndices", "[", "_", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", "anynumberQ"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", "Definitions", " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"rightbundles", "=", 
            RowBox[{"UpIndex", "/@", 
             RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"newinds", "=", 
            RowBox[{
             RowBox[{"{", "inds", "}"}], "/.", 
             RowBox[{"d_Dir", "\[RuleDelayed]", 
              RowBox[{"ChangeIndex", "@", 
               RowBox[{"UltraindexOf", "[", "d", "]"}]}]}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"bundles", "=", 
            RowBox[{"VBundleOfIndex", "/@", "newinds"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"rightups", "=", 
            RowBox[{"UpIndexQ", "/@", 
             RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ups", "=", 
            RowBox[{"UpIndexQ", "/@", "newinds"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"metricsQ", "=", 
            RowBox[{"MetricEndowedQ", "/@", "bundles"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Validate", " ", "number", " ", "of", " ", "indices"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", "bundles", "]"}], "=!=", 
              RowBox[{"Length", "[", "rightbundles", "]"}]}], ",", 
             RowBox[{"Throw", "[", 
              RowBox[{
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"Validate", "::", "error"}], ",", 
                 RowBox[{"\"\<Invalid number of indices of tensor \>\"", "<>", 
                  RowBox[{"ToString", "[", "tensor", "]"}]}]}], "]"}], ";", 
               RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Validate", " ", "indices", " ", "at", " ", "slots"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"Not", "@", 
              RowBox[{"Inner", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"SubvbundleQ", "[", 
                  RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
                "rightbundles", ",", "bundles", ",", "And"}], "]"}]}], ",", 
             RowBox[{"Throw", "[", 
              RowBox[{
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"Validate", "::", "error"}], ",", 
                 RowBox[{"\"\<Invalid index at slot of tensor \>\"", "<>", 
                  RowBox[{"ToString", "[", "tensor", "]"}]}]}], "]"}], ";", 
               RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Validate", " ", 
             RowBox[{"up", "/", "down"}], " ", "character", " ", "of", " ", 
             "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"Not", "@", 
              RowBox[{"Inner", "[", 
               RowBox[{"Or", ",", "metricsQ", ",", 
                RowBox[{"Inner", "[", 
                 RowBox[{"Equal", ",", "ups", ",", "rightups", ",", "List"}], 
                 "]"}], ",", "And"}], "]"}]}], ",", 
             RowBox[{"Throw", "[", 
              RowBox[{
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"Validate", "::", "error"}], ",", 
                 RowBox[{"\"\<Invalid character of index in tensor \>\"", "<>", 
                  RowBox[{"ToString", "[", "tensor", "]"}]}]}], "]"}], ";", 
               RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "Validate", " ", "EIndices", " ", "are", " ", "not", " ", 
             "repeated"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Check", "[", 
            RowBox[{
             RowBox[{"CheckRepeated", "[", 
              RowBox[{"IndexList", "[", "inds", "]"}], "]"}], ",", 
             RowBox[{"Throw", "[", 
              RowBox[{
               RowBox[{"Print", "[", "\"\<Sending error\>\"", "]"}], ";", 
               RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Else", ",", " ", 
          RowBox[{"return", " ", "tensor"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", "x"}]}], "\[IndentingNewLine]", "]"}]}], 
    "]"}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9fee760a-e0a6-4e30-ba00-1e00764fa9c6"],

Cell["Examples:", \
"Text",ExpressionUUID->"78f05190-8cfb-43a4-b3c6-d0652d5160f9"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"1fc3c10d-77f1-444f-ba47-7b5de3c63fbd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d09be054-7b2c-4c92-adaa-7d2d830761d9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ca2459ea-bc69-495f-922d-485e2dbe4831"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"52df51b5-0bef-48cb-bf87-7af2098d5d59"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c9687633-e7a3-4e8b-a956-02c63a6c876a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"25fdc847-02a8-4d7b-80f5-5d9be12c8aa9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"16582a73-68b2-4e04-9f8e-689f2bd7b5a1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ea9e04d4-15a9-4918-9a5e-94660bf2dbfb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f296812a-089d-46c0-a13c-2d8b3d2110b2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], ",", "M2"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"29530be8-00e7-4478-b2ca-ebe420b06f9e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"1d2bc674-0751-43e1-a8ee-830aef7cb208"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"174b24d3-80ee-4c3f-ae2a-ee9cadfba9e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c48b3d47-302b-41b7-aa36-7e4c6c7b7cde"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindAllOfType", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "B"}], ",", "c"}], "]"}], 
     RowBox[{"R", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "C"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{
       RowBox[{"-", "D"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], 
     RowBox[{"TT", "[", 
      RowBox[{"D", ",", 
       RowBox[{"-", "B"}], ",", "c"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"v", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "B"}], ",", "c"}], "]"}], "]"}]}], ",", "Tensor"}], 
  "]"}]], "Input",ExpressionUUID->"05dbca7f-10c5-446a-bf01-ef35f30cf3a9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"R", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`R[-$CellContext`A, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "c"},
           {" ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "c"},
           {" ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"6118f020-7670-4b21-8156-0e34201f1738"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ValidateTensor", "/@", 
  "%"}]], "Input",ExpressionUUID->"3c8ffab0-e20d-4b5b-a07e-e1ae4e85dd04"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"R", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`R[-$CellContext`A, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "c"},
           {" ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "c"},
           {" ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"c5d0150a-4559-4cfd-98f1-b4c63544f483"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "c"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"abd8e298-8dad-454a-970e-79f83c032ab0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid character of index in tensor T\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4d94d036-01c2-40b3-bb5c-51447c2b4b5f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B", "c"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`B, $CellContext`c],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`T[$CellContext`A, $CellContext`B, $CellContext`c]],
  Editable->
   False]], "Output",ExpressionUUID->"1eb5eee2-691c-4e2b-9b31-71c7fab28bd1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "b", ",", "c"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"24fd4d81-cc94-47f4-a2b2-0def412d4278"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid index at slot of tensor T\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b31c752a-6b34-4214-89bb-92cb459c2a2b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "b", "c"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`b, $CellContext`c],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`T[$CellContext`A, $CellContext`b, $CellContext`c]],
  Editable->
   False]], "Output",ExpressionUUID->"66d4b265-f22e-4f7f-962f-a14048895dc6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "[", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", "c", ",", "d"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"671d3367-dd5d-4bec-903a-0c9e76cf467e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid number of indices of tensor T\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e6df2572-a62b-4f0a-8622-d474871dd145"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " ", "c", "d"},
            {" ", "B", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c, \
$CellContext`d],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`c, \
$CellContext`d]],
  Editable->
   False]], "Output",ExpressionUUID->"059a888d-7797-4f21-b5db-9406b199a0cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ValidateTensor", "[", 
  RowBox[{"T", "[", 
   RowBox[{"D", ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "A", "]"}], "]"}], ",", "c"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c4038d9e-0b55-4ab0-b070-117c39204d49"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"D", " ", "c"},
         {" ", "v", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[D, 
   xAct`xTensor`Dir[
    $CellContext`v[$CellContext`A]], $CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"7e91fddb-fa2e-4244-ae9a-a89a275c9c7d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ValidateTensor", "[", 
  RowBox[{"T", "[", 
   RowBox[{"D", ",", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "C", "]"}], "]"}], ",", "c"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"96e68ae6-223c-4425-bf7c-d64616cc40bc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"D", " ", "c"},
         {" ", "v", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[D, 
   xAct`xTensor`Dir[
    $CellContext`v[C]], $CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"8fb238da-560e-48d5-9552-08083ff82e54"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"T", "[", 
    RowBox[{"D", ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"v", "[", 
       RowBox[{"-", "C"}], "]"}], "]"}], ",", "c"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"7adf6eea-1309-4d22-914a-9db973cac7eb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid character of index in tensor T\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ec3b9b19-5f1a-4811-b94a-ad5168ca996f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"D", "v", "c"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[D, 
      xAct`xTensor`Dir[
       $CellContext`v[-C]], $CellContext`c],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`T[D, 
    xAct`xTensor`Dir[
     $CellContext`v[-C]], $CellContext`c]],
  Editable->
   False]], "Output",ExpressionUUID->"a2951b4b-8c11-4567-b77e-63183c191515"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"6be56da2-77ad-4cfc-9c95-06c792a97fe3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", ",", "R", ",", "v"}], 
  "}"}]], "Output",ExpressionUUID->"f6614e1b-dd5a-40ac-bd46-8b4dee770341"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"v", "[", "E", "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"239072fb-1a49-47b2-988c-45dfca2aaf37"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"UpSet", "::", "write"}], "MessageName"], ":", 
  " ", "\<\"Tag \[NoBreak]\\!\\(\[ExponentialE]\\)\[NoBreak] in \[NoBreak]\\!\
\\(xAct`xTensor`Private`NoDollar[\[ExponentialE]]\\)\[NoBreak] is Protected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/write\\\", \
ButtonNote -> \\\"UpSet::write\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"bb6ece62-b67f-4879-b4de-e3b466af7118"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"index\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\[ExponentialE]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"dcf2ba28-962d-4aef-82dc-355c06a3ae38"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"E"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[E],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`v[E]],
  Editable->
   False]], "Output",ExpressionUUID->"ddba349d-6de3-45fb-816b-a4389a96ff58"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"v", "[", "A_", "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"2060ceb4-e13d-421d-819a-52e845174bc1"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "pat"}], "MessageName"], ":", 
  " ", "\<\"Found pattern index \[NoBreak]\\!\\(A_\\)\[NoBreak] . Cannot \
validate.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"27522d43-fa1f-45fb-afd6-d992f11f3887"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"index\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(A_\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ca1f5069-38e0-4b3f-924f-93f4b20acc35"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {
             UnderscriptBox["A", "_"]},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[
      Pattern[$CellContext`A, 
       Blank[]]],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`v[
    Pattern[$CellContext`A, 
     Blank[]]]],
  Editable->
   False]], "Output",ExpressionUUID->"5d0cdec1-cde8-4236-9fb3-749ab69de05a"]
}, Open  ]],

Cell["\<\
For some reason, Mathematica forgets the interpretation rule for this from \
one session to another. Note that the $Line number is not increased! This \
seems to be a bug:\
\>", "Text",ExpressionUUID->"22626327-94d7-4fc2-a654-8164ca50d5ca"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["ERROR",
      FontColor->RGBColor[1, 0, 0]], "[", 
     InterpretationBox[
      StyleBox[
       SubsuperscriptBox["v", " ", 
        UnderscriptBox["A", "_"]],
       AutoSpacing->False],
      v[
       Pattern[A, 
        Blank[]]],
      Editable->False], "]"}],
    AutoSpacing->False],
   ERROR[
    v[
     Pattern[A, 
      Blank[]]]],
   Editable->False], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"571ffc76-be36-4634-92e2-e878eed0e1b2"],

Cell["ERROR[v[A_]]", \
"Output",ExpressionUUID->"ba87b0a6-12c2-4c8c-97da-abf1f87ca318"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "v", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"-", "A_"}], "]"}], ":=", "1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "v", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"84f5c8d1-2ef1-4f59-8dc4-0e22163fc0fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", 
  RowBox[{"-", "A"}], 
  "]"}]], "Input",ExpressionUUID->"36c5253c-9b77-4071-8874-c8956183663b"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"f3e395d3-2179-4902-ae6b-da26f19cc39d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"66ef99df-d6b3-42af-af11-c2ed3cf85808"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid character of index in tensor v\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b02632c1-ca71-401d-868b-ce5e719bc3ce"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[-$CellContext`A],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`v[-$CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"265cca10-80da-4de4-903c-25f33c0fda84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"01092fa3-0a4e-40ce-97df-fc3a1dbc197c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", ",", "R", ",", "v"}], 
  "}"}]], "Output",ExpressionUUID->"07eef9cc-340b-4589-ad33-f330542ed42e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", "$Tensors"}], 
  ";"}]], "Input",ExpressionUUID->"c3092526-f5ed-4012-89bb-eb949584b88e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"0cbe68e8-05bc-4424-aa4d-ce739f421bfd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"b8280f41-e46b-42df-be7e-a8828b40bdc9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"86f88a19-4364-4f84-afb9-0960c39cfa6c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"e363c325-ccc1-4a59-8c94-747b8cb3a39b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"45a0b099-5154-499d-bcab-24d337f9d4c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"e724f709-def3-4209-8871-c2a418cba964"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"bc7cb1cf-f04c-4045-a002-f0bce3583615"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"8749474a-1832-44b3-9299-2a55d876d3c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"4c86c107-49bc-4822-b7b9-ddf304659966"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "TT", "]"}], 
  ";"}]], "Input",ExpressionUUID->"e073479a-34f7-4e28-9697-40bce524f9a2"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"bfdae0f3-c04d-4fea-a729-c7eaaf9d65f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.7. Weights", \
"Subsection",ExpressionUUID->"7b1aaa6b-4b64-472f-bef3-1b30308d1e14"],

Cell[TextData[{
 "Tensorial weights can only be defined once a basis has been introduced. \
Therefore this function could be defined in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ". However, several functions in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " need to worry about densities, and therefore we prefer to keep the pair \
{WeightOf, WeightOfTensor} here in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". For instante WeightOfTensor is an option to DefTensor. It would make no \
sense to define it with context xAct`xCoba`. ",
 "Determinant",
 " for the determinant of the metric is still here, but the general concept \
of determinant is defined in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 "."
}], "Text",ExpressionUUID->"b8b174f1-dd57-4a63-b1dd-c02c36dc2c04"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "WeightOf"}]], \
"Input",ExpressionUUID->"4dde60d9-3017-4150-878a-9fba86cd7846"],

Cell[BoxData[
 StyleBox["\<\"WeightOf[expr] returns the density weight of the expression. \
The weight of the basis-determinant of the metric is defined to be 2*basis.\"\
\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672695-5338953",ExpressionUUID->"a3fba00c-b687-4014-94ae-\
3b046b71201d"]
}, Open  ]],

Cell["\<\
The definitions on indexed objects are dangerous because there could be Dir \
expressions containing densities. Perhaps even in basis objects.\
\>", "Text",ExpressionUUID->"3a9ef505-54ba-4deb-ad45-3c80a26454f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", "argument"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{"_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
      "]"}], ":=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{"_Symbol", "?", "ConstantSymbolQ"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Indices", " ", "assumed", " ", "not", " ", "to", " ", "change", " ", 
     "weights"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "___", "]"}], "]"}], ":=", 
     RowBox[{"WeightOfTensor", "[", "tensor", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Derivatives", " ", "assumed", " ", "not", " ", "to", " ", "change", " ", 
     "weights"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{"_", "?", "FirstDerQ"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"WeightOf", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{"ParamD", "[", "__", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"WeightOf", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", "expr_Times", "]"}], ":=", 
     RowBox[{"Plus", "@@", 
      RowBox[{"(", 
       RowBox[{"WeightOf", "/@", 
        RowBox[{"List", "@@", "expr"}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{"_", "?", "ProductQ"}], "[", "exprs___", "]"}], "]"}], ":=", 
     RowBox[{"Plus", "@@", 
      RowBox[{"(", 
       RowBox[{"WeightOf", "/@", 
        RowBox[{"{", "exprs", "}"}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", "expr_Plus", "]"}], ":=", 
     RowBox[{"Check", "[", 
      RowBox[{
       RowBox[{"JustOne", "@", 
        RowBox[{"Union", "[", 
         RowBox[{"Expand", "/@", 
          RowBox[{"WeightOf", "/@", 
           RowBox[{"List", "@@", "expr"}]}]}], "]"}]}], ",", 
       RowBox[{"Throw", "[", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"WeightOf", "::", "error"}], ",", 
           "\"\<Inhomogeneous sum of densities.\>\""}], "]"}], ";", 
         RowBox[{"ERROR", "[", "expr", "]"}]}], "]"}], ",", 
       RowBox[{"Validate", "::", "notone"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", "expr_SeriesData", "]"}], ":=", 
     RowBox[{"WeightOf", "[", 
      RowBox[{"Normal", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{"Power", "[", 
       RowBox[{"expr_", ",", "n_"}], "]"}], "]"}], ":=", 
     RowBox[{"n", " ", 
      RowBox[{"WeightOf", "[", "expr", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{"Dagger", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"WeightOf", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Weight", " ", "not", " ", "defined", " ", "on", " ", "inertheads", " ", 
     "and", " ", "other", " ", "scalar", " ", "functions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{"ih_", "?", "InertHeadQ"}], "[", "__", "]"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"WeightOf", "::", "error"}], ",", 
        "\"\<WeightOf is generically undefined on inert heads.\>\""}], "]"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{"sf_", "?", "ScalarFunctionQ"}], "[", "x___", "]"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MemberQ", "[", 
         RowBox[{
          RowBox[{"Attributes", "[", "sf", "]"}], ",", "NumericFunction"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"{", "x", "}"}], "]"}], "===", "1"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"WeightOf", "[", "x", "]"}], "===", "0"}], ",", 
         "\[IndentingNewLine]", "0", ",", "\[IndentingNewLine]", 
         RowBox[{"Throw", "[", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"WeightOf", "::", "error"}], ",", 
            "\"\<A numeric scalar function must have a zero-weight \
argument.\>\""}], "]"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"WeightOf", "::", "error"}], ",", 
          "\"\<WeightOf is generically undefined on scalar functions.\>\""}], 
         "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Derivative", "[", "__Integer", "]"}], "[", 
        RowBox[{"sf_", "?", "ScalarFunctionQ"}], "]"}], "[", "__", "]"}], 
      "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"WeightOf", "::", "error"}], ",", 
        "\"\<WeightOf is generically undefined on scalar functions.\>\""}], 
       "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Two", " ", "arguments"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{"expr_", ",", "Null"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOf", "[", 
      RowBox[{"expr_", ",", "basis_"}], "]"}], ":=", 
     RowBox[{"Coefficient", "[", 
      RowBox[{
       RowBox[{"WeightOf", "[", "expr", "]"}], ",", "basis"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"WeightOf", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "WeightOf", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c90217fb-c3a4-4ae0-b94c-0270e026840d"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"99701aa1-d1f1-449b-b214-fa2b02d0c4ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightOf", "[", 
  RowBox[{"Sqrt", "[", "hello", "]"}], 
  "]"}]], "Input",ExpressionUUID->"ce5bfadc-1cb2-4450-899d-49e9fb4190c3"],

Cell[BoxData[
 FractionBox[
  RowBox[{"WeightOf", "[", "hello", "]"}], 
  "2"]], "Output",ExpressionUUID->"bde0d1f0-9af0-4c68-b1b5-a7f7a51ff66c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightOf", "[", 
  RowBox[{"hello", "^", "5"}], 
  "]"}]], "Input",ExpressionUUID->"6c5370e6-987f-4a32-9768-a50359f28aaf"],

Cell[BoxData[
 RowBox[{"5", " ", 
  RowBox[{
  "WeightOf", "[", "hello", 
   "]"}]}]], "Output",ExpressionUUID->"5573b682-5ea3-4991-8583-ae538aac4b24"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "hello", 
  "]"}]], "Input",ExpressionUUID->"1c6f0a6d-9e2e-4c4c-a034-fc984009f151"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b7372f11-6d32-48ae-b7fa-a2b4f87cd7f5"],

Cell["\<\
QUESTIONs: is it possible to define the weight of the logarithm of a density?\
\
\>", "Text",ExpressionUUID->"8e0c3ba5-7fb8-4b71-aa1a-764699e6e038"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.8. UpVectors and DownVectors", \
"Subsection",ExpressionUUID->"e78e737b-9fd7-4a8f-81c2-0c7d28f336e6"],

Cell["\<\
These are a collection of functions that detect the tensor character of a \
expression. In the future there must be a function considering all possible \
cases, with a generalized (to arbitrary expressions) function.\
\>", "Text",ExpressionUUID->"2d4ba22f-fe95-4863-b28b-98c2f7514f88"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UpVectorQ"}]], \
"Input",ExpressionUUID->"0bfe152c-acf4-453e-9431-00b0c5f125d9"],

Cell[BoxData[
 StyleBox["\<\"UpVectorQ[expr] gives True if expr has only one free up-index, \
and False otherwise. UpVectorQ[expr, vbundle] gives True if also the free \
index of expr belongs to the vector bundle vbundle.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672697-5338953",ExpressionUUID->"106cf387-e240-4a79-b0d5-\
b43a6eed2ff8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "DownVectorQ"}]], \
"Input",ExpressionUUID->"e1e07f5b-81c4-41a8-857c-8a8c321a20a8"],

Cell[BoxData[
 StyleBox["\<\"DownVectorQ[expr] gives True if expr has only one free \
down-index, and False otherwise. DownVectorQ[expr, vbundle] gives True if \
also the free index of expr belongs to the vector bundle vbundle.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672699-5338953",ExpressionUUID->"df4a6f0f-cb3b-4ef8-83e6-\
5f7a669a51c1"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkoneindex", "[", 
    RowBox[{
     RowBox[{"IndexList", "[", "a_", "]"}], ",", "f_"}], "]"}], ":=", 
   RowBox[{"f", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkoneindex", "[", 
    RowBox[{
     RowBox[{"IndexList", "[", "a_", "]"}], ",", "f_", ",", "vb_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"f", "[", "a", "]"}], "&&", 
    RowBox[{
     RowBox[{"VBundleOfIndex", "[", "a", "]"}], "===", "vb"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkoneindex", "[", "__", "]"}], ":=", "False"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e3b82e5b-1022-43b9-815a-8487557d8464"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpVectorQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"checkoneindex", "[", 
    RowBox[{
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "UpIndexQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpVectorQ", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
   RowBox[{"checkoneindex", "[", 
    RowBox[{
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "UpIndexQ", ",", 
     "vbundle"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DownVectorQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"checkoneindex", "[", 
    RowBox[{
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "DownIndexQ"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DownVectorQ", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
   RowBox[{"checkoneindex", "[", 
    RowBox[{
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "DownIndexQ", ",", 
     "vbundle"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"UpVectorQ", ",", "DownVectorQ"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"UpVectorQ", ",", "DownVectorQ"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"06d836f6-f733-4dd0-b45b-f21dd9cfb783"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"eabbddcf-0afd-479e-9d44-703bda270f87"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8d5ac7b4-3ca0-4a2c-87ee-19fe9a168695"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e455387d-921a-45ae-b304-65ffab901fbf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8e8d6b85-c363-4371-8a06-05bab78a8adf"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0bdc41f2-6f9a-4a2c-9cc5-f49382caeb56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"a3029fcb-d2b0-48fd-87c7-d2face9887b5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"01c42f21-e648-41d0-afab-2efcc42589a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarQ", "[", 
  RowBox[{"a", " ", 
   RowBox[{"r", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6951045f-a5ec-4f27-8369-5448aed31db3"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"a14889c9-0336-49f0-8747-3f1273c7f345"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "r", 
  "]"}]], "Input",ExpressionUUID->"3a0a1505-a031-4714-baca-e1132067df69"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"0327861a-bd87-46b7-906e-eb2c0687a5ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"3972f8f4-2bdf-468c-b4fc-60b196806c5a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"6a805d64-0061-4dd3-a338-5d46db345410"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"fd58cb68-1d24-4c90-9fc1-e169507d696f"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "a", 
  "]"}]], "Input",ExpressionUUID->"41b3c57b-e2cb-439c-92da-d61ed4f337b1"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"229249c6-d284-4ccd-908b-2f3d114b5070"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.9. TransposeDagger", \
"Subsection",ExpressionUUID->"3b8b315b-d44a-4156-a829-55ebdc5498bc"],

Cell["\<\
This function only works on tensors. QUESTION: Do we need anything else?\
\>", "Text",ExpressionUUID->"dd814775-bfbb-4841-9ae0-c2e8965f5c33"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TransposeDagger"}]], \
"Input",ExpressionUUID->"70bf46b6-74c5-4acf-9ada-6ca943e05191"],

Cell[BoxData[
 StyleBox["\<\"TransposeDagger[tensor[inds]] exchange the positions of the \
complex conjugated indices following this rule: the n-th index of the complex \
vbundle C is exchanged with the n-th index of the vbundle Dagger[C]. If the \
number of indices in tensor belonging to C and Dagger[C] is not the same, an \
error is thrown. There is no conjugation in this process, simply swapping of \
indices. TransposeDagger[tensor[inds], vbs] only transposes indices of vbs (a \
vbundle or a list of them).\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672701-5338953",ExpressionUUID->"0f10ca66-e68e-411e-a413-\
3377da84729a"]
}, Open  ]],

Cell["\<\
The name of this function could be misleading because it could suggest that \
it is a combination of Dagger *and* Transpose, and it is not. Perhaps a \
better name for it could be TransposeDaggerIndices in the sense of \
\"transpose only the complex indices\".\
\>", "Text",ExpressionUUID->"406fcad0-1610-4bcb-b61e-f21074abc6b5"],

Cell["This function works in several steps:", \
"Text",ExpressionUUID->"6bf9bfcd-d174-4790-a3e8-be20ca651a1a"],

Cell["\<\
1) Construct pairs in a list. We choose the convention of pairing indices by \
order, as given by vinds and vdinds. The tf says whether we want equal \
numbers of indices in VB and its conjugate. In case we don't we simply \
shorten one of the lists, dropping indices at the end. We do not worry about \
indices being dummies or not. There is no need of having indices of a pair as \
neighbours.\
\>", "Text",ExpressionUUID->"39fcc969-0855-48b8-aef7-10d09d72c42d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Separate", " ", "pairs", " ", "in", " ", "a", " ", 
    RowBox[{"vbundle", ".", " ", "Always"}], " ", "three", " ", "arguments"}],
    " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TransposeDaggerPairsOneVBundle", "[", 
     RowBox[{"inds_IndexList", ",", 
      RowBox[{"{", 
       RowBox[{"vbundle_", ",", "vbundledag_"}], "}"}], ",", "tf_"}], "]"}], ":=",
     "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rules", ",", "\[IndentingNewLine]", 
        RowBox[{"vinds", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"inds", ",", 
           RowBox[{
            RowBox[{"GIndexQ", "[", 
             RowBox[{"#", ",", "vbundle"}], "]"}], "&"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"vdinds", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"inds", ",", 
           RowBox[{
            RowBox[{"GIndexQ", "[", 
             RowBox[{"#", ",", "vbundledag"}], "]"}], "&"}]}], "]"}]}]}], 
       "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Different", " ", "numbers", " ", "of", " ", "indices"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "vinds", "]"}], "=!=", 
          RowBox[{"Length", "[", "vdinds", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"tf", ",", "\[IndentingNewLine]", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"TransposeDagger", "::", "error3"}], ",", 
              "\"\<Different number of indices of\>\"", ",", "vbundle", ",", 
              "\"\<and its conjugate\>\"", ",", "vbundledag"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "@", "vinds"}], ">", 
              RowBox[{"Length", "@", "vdinds"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"vinds", "=", 
              RowBox[{"vinds", "[", 
               RowBox[{"[", 
                RowBox[{"Range", "@", 
                 RowBox[{"Length", "@", "vdinds"}]}], "]"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"vdinds", "=", 
              RowBox[{"vdinds", "[", 
               RowBox[{"[", 
                RowBox[{"Range", "@", 
                 RowBox[{"Length", "@", "vinds"}]}], "]"}], "]"}]}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Thread", " ", "over", " ", 
         RowBox[{"IndexList", ".", " ", "Return"}], " ", "an", " ", 
         "IndexList", " ", "of", " ", "Pair", " ", "pairs"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Sort", "[", "vinds", "]"}], "===", 
          RowBox[{"Sort", "[", "vdinds", "]"}]}], ",", 
         RowBox[{"IndexList", "[", "]"}], ",", 
         RowBox[{"Thread", "[", 
          RowBox[{
           RowBox[{"Pair", "[", 
            RowBox[{"vinds", ",", "vdinds"}], "]"}], ",", "IndexList"}], 
          "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3036c623-19d7-476b-adbd-1a6ab60a180a"],

Cell["\<\
2) Separate pairs of different vbundles. We get an IndexList of Pair pairs.\
\>", "Text",ExpressionUUID->"91b0d71b-6301-4ad6-b26c-c8261c6ab4e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Detect", " ", "reordering", " ", 
     RowBox[{"pairs", ".", " ", "One"}]}], ",", " ", 
    RowBox[{"two", " ", "or", " ", "three", " ", "arguments"}]}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDaggerPairs", "[", "x_", "]"}], ":=", 
     RowBox[{"TransposeDaggerPairs", "[", 
      RowBox[{"x", ",", "$VBundles"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDaggerPairs", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
       "vbs_", ",", 
       RowBox[{"tf_", ":", "True"}]}], "]"}], ":=", 
     RowBox[{"TransposeDaggerPairs", "[", 
      RowBox[{
       RowBox[{"IndexList", "[", "inds", "]"}], ",", "vbs", ",", "tf"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDaggerPairs", "[", 
      RowBox[{"inds_IndexList", ",", 
       RowBox[{"vbundle_", "?", "VBundleQ"}], ",", 
       RowBox[{"tf_", ":", "True"}]}], "]"}], ":=", 
     RowBox[{"TransposeDaggerPairs", "[", 
      RowBox[{"inds", ",", 
       RowBox[{"{", "vbundle", "}"}], ",", "tf"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDaggerPairs", "[", 
      RowBox[{"inds_IndexList", ",", "vbundles_List", ",", 
       RowBox[{"tf_", ":", "True"}]}], "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Apply", "[", 
      RowBox[{"Join", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"TransposeDaggerPairsOneVBundle", "[", 
          RowBox[{"inds", ",", "#", ",", "tf"}], "]"}], "&"}], "/@", 
        RowBox[{"MakeVBundlePairs", "[", "vbundles", "]"}]}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "List", " ", "of", " ", "pairs", " ", "of", " ", "complex", " ", 
     "conjugated", " ", 
     RowBox[{"vbundles", ".", " ", 
      RowBox[{"Trick", ":", " ", 
       RowBox[{
       "VB", " ", "always", " ", "sorted", " ", "before", " ", 
        "VB\[Dagger]"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeVBundlePairs", "[", "vbundles_List", "]"}], ":=", 
     RowBox[{"Union", "@", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{"MakeVBundlePair", "/@", "vbundles"}], ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeVBundlePair", "[", 
      RowBox[{"-", "vbundle_"}], "]"}], ":=", 
     RowBox[{"MakeVBundlePair", "[", "vbundle", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MakeVBundlePair", "[", "vbundle_", "]"}], ":=", 
    RowBox[{"Union", "[", 
     RowBox[{"{", 
      RowBox[{"vbundle", ",", 
       RowBox[{"Dagger", "[", "vbundle", "]"}]}], "}"}], "]"}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c89c5460-6dce-4a8b-9b58-690fa621e546"],

Cell["3) Construct rules exchanging indices:", \
"Text",ExpressionUUID->"d81f9a38-117f-445e-9121-5bcf4cf92e41"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Construct", " ", "rules", " ", "for", " ", "index", " ", 
    RowBox[{"reordering", ".", " ", "Always"}], " ", "two", " ", 
    "arguments"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TransposeDaggerRules", "[", 
     RowBox[{"x_", ",", "vbundles_List"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"pairs", "=", 
         RowBox[{"TransposeDaggerPairs", "[", 
          RowBox[{"x", ",", "vbundles"}], "]"}]}], ",", "rules"}], "}"}], ",",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"rules", "=", 
        RowBox[{"Apply", "[", 
         RowBox[{"Rule", ",", "pairs", ",", "1"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"List", "@@", 
        RowBox[{"Join", "[", 
         RowBox[{"rules", ",", 
          RowBox[{"Reverse", "/@", "rules"}]}], "]"}]}]}]}], "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"20da4405-61ce-4355-b6a4-3f5e107d24a8"],

Cell["4) Main (public) function:", \
"Text",ExpressionUUID->"a92ef53d-3729-44c8-b7b4-1eece5ce3749"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Main", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDagger", "[", "expr_", "]"}], ":=", 
     RowBox[{"TransposeDagger", "[", 
      RowBox[{"expr", ",", "$VBundles"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"On", " ", 
     RowBox[{"tensors", ".", " ", "Complicated"}], " ", "construction", " ", 
     "to", " ", "avoid", " ", "confusing", " ", "repeated", " ", "indices"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDagger", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}]}], ",", 
       "vbs_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"DaggerQ", "[", "tensor", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"tensor", "@@", 
        RowBox[{"TransposeDagger", "[", 
         RowBox[{"IndexList", "[", "inds", "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", "expr"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDagger", "[", 
      RowBox[{"inds_IndexList", ",", "vbs_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"dummies", "=", 
         RowBox[{"DummyAs", "/@", "inds"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"dummies", "/.", 
         RowBox[{"TransposeDaggerRules", "[", 
          RowBox[{"dummies", ",", "vbs"}], "]"}]}], "/.", 
        RowBox[{"Inner", "[", 
         RowBox[{"Rule", ",", "dummies", ",", "inds", ",", "List"}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Error", " ", "on", " ", "any", " ", "other", " ", "type", " ", "of", " ",
      "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TransposeDagger", "[", 
      RowBox[{"expr_", ",", "vbs_"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"TransposeDagger", "::", "notyet"}], ",", 
         "\"\<TransposeDagger on objects other than tensors\>\""}], "]"}], 
       ";", 
       RowBox[{"ERROR", "[", 
        RowBox[{"TransposeDagger", "[", 
         RowBox[{"expr", ",", "vbs"}], "]"}], "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"TransposeDagger", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Protect", "[", "TransposeDagger", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a31818cd-b48c-4ef7-a225-0131271dd0c0"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.10. Tensors without DefTensor", \
"Subsection",ExpressionUUID->"7267b8c0-414a-498c-b51e-57c31d15846a"],

Cell["\<\
Let us make use of the head Tensor in a different way. We supply the \
information about the tensor as different arguments for the tensor\
\>", "Text",ExpressionUUID->"f591a9ad-dfca-4775-8217-9cab971f42a1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Unprotect", "[", "Tensor", "]"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Objects", " ", "with", " ", "a", " ", "head", " ", "Tensor", " ", "are", 
    " ", "tensor", " ", "heads"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xTensorQ", "[", 
     RowBox[{"Tensor", "[", "__", "]"}], "]"}], "^:=", "True"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Tensor", " ", "info"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"Tensor", "[", 
     RowBox[{"pa_", ",", "__"}], "]"}], "]"}], "^:=", "pa"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"Tensor", "[", 
     RowBox[{"pa_", ",", "slots_", ",", "__"}], "]"}], "]"}], "^:=", 
   "slots"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DependenciesOfTensor", "[", 
     RowBox[{"Tensor", "[", 
      RowBox[{"pa_", ",", "slots_", ",", "deps_", ",", "___"}], "]"}], "]"}], 
    "^:=", "deps"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Tensor", " ", "symmetry", " ", "info"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tensor", "[", 
    RowBox[{"pa_", ",", "slots_", ",", "deps_", ",", 
     RowBox[{"other___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Tensor", "[", 
    RowBox[{"pa", ",", "slots", ",", "deps", ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", "other"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tensor", "[", 
    RowBox[{
    "pa_", ",", "slots_", ",", "deps_", ",", "sym_GenSet", ",", "other___"}], 
    "]"}], ":=", 
   RowBox[{"Tensor", "[", 
    RowBox[{"pa", ",", "slots", ",", "deps", ",", 
     RowBox[{"SchreierSims", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "sym"}], "]"}], ",", "other"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{
     RowBox[{"Tensor", "[", "args__", "]"}], "[", "inds___", "]"}], "]"}], "^:=", 
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"Tensor", "[", "args", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"Tensor", "[", 
     RowBox[{"pa_", ",", "slots_", ",", "deps_", ",", "sym_", ",", "___"}], 
     "]"}], "]"}], "^:=", "sym"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SymmetryGroupOfTensor", "[", 
     RowBox[{"Tensor", "[", 
      RowBox[{"pa_", ",", "slots_", ",", "deps_"}], "]"}], "]"}], "^:=", 
    RowBox[{"StrongGenSet", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Other", " ", 
    RowBox[{"info", ".", " ", 
     RowBox[{"TODO", ":", " ", 
      RowBox[{
       RowBox[{"I", "'"}], "m", " ", "not", " ", "sure", " ", "these", " ", 
       "defaults", " ", "are", " ", "the", " ", "good", " ", "ones"}]}]}]}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"tensor", ":", 
     RowBox[{"Tensor", "[", 
      RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "other___"}], "]"}]}], 
    "]"}], "^:=", 
   RowBox[{
    RowBox[{"Dagger", "/.", 
     RowBox[{"CheckOptions", "[", "other", "]"}]}], "/.", 
    RowBox[{"Dagger", "\[Rule]", "tensor"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefInfo", "[", 
    RowBox[{"Tensor", "[", 
     RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "other___"}], "]"}], 
    "]"}], "^:=", 
   RowBox[{
    RowBox[{"DefInfo", "/.", 
     RowBox[{"CheckOptions", "[", "other", "]"}]}], "/.", 
    RowBox[{"DefInfo", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HostsOf", "[", 
    RowBox[{"Tensor", "[", 
     RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "other___"}], "]"}], 
    "]"}], "^:=", 
   RowBox[{
    RowBox[{"HostsOf", "/.", 
     RowBox[{"CheckOptions", "[", "other", "]"}]}], "/.", 
    RowBox[{"HostsOf", "\[Rule]", 
     RowBox[{"{", "}"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorID", "[", 
     RowBox[{"Tensor", "[", 
      RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "other___"}], "]"}], 
     "]"}], "^:=", 
    RowBox[{
     RowBox[{"TensorID", "/.", 
      RowBox[{"CheckOptions", "[", "other", "]"}]}], "/.", 
     RowBox[{"TensorID", "\[Rule]", 
      RowBox[{"{", "}"}]}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Protect", " ", "again"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Tensor", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4bf50f46-808f-49cb-bd88-910335123d3d"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11. Tensors and mappings", \
"Subsection",ExpressionUUID->"5c59ed33-e71f-4998-927c-7f587245b847"],

Cell[CellGroupData[{

Cell["9.11.0. Comments", \
"Subsubsection",ExpressionUUID->"f9bacc1f-fe24-4393-820b-dfbf69afd0c6"],

Cell[TextData[{
 "In ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " we rely on the idea that indices are associated to a unique vbundle, and \
hence in many cases we use the function VBundleOfIndex to extract vbundle \
information, instead of looking at the tensor heads. Pullback vbundles have \
their own indices, constructed from normal indices by prepending the name of \
the map. Hence in this section we always need to be careful about which \
indices we are using."
}], "Text",ExpressionUUID->"cba48c1e-4c21-4684-8e85-55eb5c02531c"],

Cell["\<\
PullBack and PushForward are combined constructions based on two elementary \
actions: precomposition and contraction with the tangent mappings.  If they \
appear together in the right combinations then it is better to use \
PullBackTensor/PushForwardTensor notation, which avoids starred indices, but \
these elementary operations may appear in isolation as well (mainly dealing \
with non-diffeomorphic mappings), so we need to analyze them. The standard \
names for these things are terrible.\
\>", "Text",ExpressionUUID->"00884025-374f-4ab4-8718-4c0e000d5c6c"],

Cell["\<\
Suppose we have a general mapping \[Phi] : M->N, with tangent map d\[Phi] : \
TM->\[Phi]*TN. That means that d\[Phi] has indices d\[Phi][-a, \[Phi]A]. Take \
fields v[a] and \[Omega][-a] on M and fields V[A] and \[CapitalOmega][-A] on N.

1) We can construct these objects:

\tLinearPush[v, d\[Phi]][ \[Phi]A ] = v[a] d\[Phi][-a, \[Phi]A]\ta vector \
field along a map on the pullback bundle \[Phi]*TN over M
\t
\tPrecompose[V, \[Phi]][\[Phi]A]\t\t\t\ta pullback section on the pullback \
bundle \[Phi]*TN over M

    If those two objects coincide everywhere on M, then we say that v and V \
are \[Phi]-related, but in general it will not happen.

2) Then we can construct:
\t
\tPrecompose[\[CapitalOmega], \[Phi]][-\[Phi]A]\t\t\ta pullback section on \
the pullback bundle \[Phi]*T*N over M
\t
\tPullBackTensor[\[CapitalOmega], \[Phi]][-a] = LinearPush[ Precompose[\
\[CapitalOmega], \[Phi]], d\[Phi] ][-a] = d\[Phi][-a, \[Phi]A] Precompose[\
\[CapitalOmega], \[Phi]][-\[Phi]A]
\t\t\t\t\t\t\ta covector field on T*M over M

3) Now assume that the mapping \[Phi] is a diffeomorphism, with inverse i\
\[Phi] and tangent mapping di\[Phi][-A, i\[Phi]a]. Then we can construct many \
more objects:

\tPrecompose[v, i\[Phi]][i\[Phi]a]\t\t\t\ta pullback section on the pullback \
bundle i\[Phi]*TM over N

\tPushForwardTensor[v, \[Phi]][A] = Precompose[ LinearPush[v, d\[Phi]], i\
\[Phi]][A] = Precompose[v, i\[Phi]][i\[Phi]a] Precompose[d\[Phi], i\[Phi]][-i\
\[Phi]a, A]
\t\t\t\t\t\t\t\t= Precompose[v, i\[Phi]][i\[Phi]a] \
Inverse[di\[Phi]][i\[Phi]a] = LinearPush[ Precompose[v, i\[Phi]], Inverse[di\
\[Phi]] ][A]
\t\t\t\t\t\t\ta vector field on TN over N

\tLinearPush[V, di\[Phi]][ i\[Phi]a ] = V[A] di\[Phi][-A, i\[Phi]a]\ta vector \
field along a map on the pullback bundle i\[Phi]*TM over N
\t
\tPushForwardTensor[V, i\[Phi]][a] = Precompose[ LinearPush[V, di\[Phi]], \
\[Phi] ][a] = Precompose[V, \[Phi]][\[Phi]A] Precompose[di\[Phi], \[Phi]][-\
\[Phi]A, a]
\t\t\t\t\t\t\ta vector field on TM over M

\tPrecompose[\[Omega], i\[Phi]][-i\[Phi]a]\t\t\ta pullback section on the \
pullback bundle i\[Phi]*T*M over N
\t
\tPullBackTensor[\[Omega], i\[Phi]][-A] = LinearPush[ Precompose[\[Omega], i\
\[Phi]], di\[Phi] ][-A] = di\[Phi][-A, i\[Phi]a] Precompose[\[Omega], \
i\[Phi]][-i\[Phi]a]
\t\t\t\t\t\t\ta covector field on T*N over N

Then it is interesting to note that, as inverses of linear operators,

\tInverse[ d\[Phi] ] = Precompose[ di\[Phi], \[Phi] ]
\t
\tInverse[ di\[Phi] ] = Precompose[ d\[Phi], i\[Phi] ]

Note the index configurations

\td\[Phi][-a, \[Phi]A]\tPrecompose[ di\[Phi], \[Phi] ][-\[Phi]A, a]\t\tboth \
on M

\tdi\[Phi][-A, i\[Phi]a]\tPrecompose[ d\[Phi], i\[Phi] ][-i\[Phi]a, A]\t\t\
both on N

Finally we address the question of how to write the pushforward and pullback \
of tensors with mixed indices. Take t[a, -b] on M and T[A, -B] on N. Then we \
can construct

\tPushForwardTensor[t, \[Phi]][A, -B] = LinearPush[ Precompose[t, i\[Phi]], \
di\[Phi]][A, -B] = Precompose[t, i\[Phi]][i\[Phi]a, -i\[Phi]b] Inverse[di\
\[Phi]][-i\[Phi]a, A] di\[Phi][-B, i\[Phi]b]
\t\t= PullBackTensor[t, i\[Phi]][A, -B]
\t
\tPullBackTensor[T, \[Phi]][a, -b] = LinearPush[ Precompose[T, \[Phi]], d\
\[Phi] ][a, -b] =Precompose[T, \[Phi]][\[Phi]A, -\[Phi]B] Inverse[d\[Phi]][-\
\[Phi]A, a] d\[Phi][-b, \[Phi]B]
\t\t= PushForwardTensor[T, i\[Phi]][a, -b]

Is it true that

\tPrecompose[ LinearPush[T, Inverse[di\[Phi]]], \[Phi] ] == LinearPush[ \
Precompose[T, \[Phi]], d\[Phi] ]

We still have a problem deciding when to write d\[Phi] or Inverse[d\[Phi]], \
or even their transposes, in the second argument of Linear. Somehow it seems \
that we need to put the transformation matrix for covectors and use its \
inverse for vectors. Is that acceptable?

We need four scenarios:

\tContravariant field along a map: \tLinearPush[t, d\[Phi]][\[Phi]A, \[Phi]B]

\tPullback of a covariant field:\t\tLinearPush[ Precompose[\[CapitalOmega], \
\[Phi]], d\[Phi] ][-a, -b]

\tPushforward tensor field:\t\tPushForwardTensor[t, \[Phi]][A, -B]
\t\t\t\t\t\t= LinearPush[ Precompose[t, i\[Phi]], di\[Phi]][A, -B] = \
Precompose[t, i\[Phi]][i\[Phi]a, -i\[Phi]b] Inverse[di\[Phi]][-i\[Phi]a, A] \
di\[Phi][-B, i\[Phi]b]

\tPullback tensor field:\t\t\tPullBackTensor[T, \[Phi]][a, -b]
\t\t\t\t\t\t= LinearPush[ Precompose[T, \[Phi]], d\[Phi] ][a, -b] \
=Precompose[T, \[Phi]][\[Phi]A, -\[Phi]B] Inverse[d\[Phi]][-\[Phi]A, a] d\
\[Phi][-b, \[Phi]B]

I have the impression that we need LinearPush[T, L] to figure out whether it \
needs L or Inverse[L] (or they transposes). Specifying all of them as \
additional arguments would be a pain. Perhaps the idea could be that we give \
one of them and let Linear find the rest. The important thing is that it must \
be a field with the correct dependencies, which determines uniquely whether \
we need d\[Phi] or di\[Phi]. That is, Linear should never need to call \
Precompose. If Inverse is needed we will check if L is invertible, and abort \
if it is not. For actual computations we will prefer to precompute a Jacobian \
with \[Phi] to computing inverses of Jacobians.

Note that in the special case in which \[Phi]=IdentityMapping[M] then the \
starred indices coincide with the normal indices, and that is way we can \
write that the differential of IdentityMapping[M] is the delta.\
\>", "Text",ExpressionUUID->"f50fdbb3-35a3-4e1c-883c-ddf21a1f4da5"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11.1. Precomposition with a map", \
"Subsubsection",ExpressionUUID->"dd6f7fd5-bdf9-4061-9ca0-98ad40121494"],

Cell["\<\
Given a tensor field T (of any character) on a bundle vb with base N and a \
map \[Phi] : M->N, we can precompose T with \[Phi], denoted Precompose[T, \
\[Phi]]. This will be a \[OpenCurlyDoubleQuote]tensor field along a map\
\[CloseCurlyDoubleQuote], a section of a pullback bundle, and hence it will \
have \[OpenCurlyDoubleQuote]starred\[CloseCurlyDoubleQuote] indices. We could \
leave this as SmallCircle[tensor, phis] but it seems simpler to have a \
function that distinguishes both types of arguments. Actually the SmallCircle \
notation is accepted in input, but autoconverts to Precompose:\
\>", "Text",ExpressionUUID->"0139ea69-5b2f-473f-8f2e-f7fa8c82e19e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SmallCircle", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
     RowBox[{"phis__", "?", "MappingQ"}]}], "]"}], ":=", 
   RowBox[{"Precompose", "[", 
    RowBox[{"tensor", ",", 
     RowBox[{"SmallCircle", "[", "phis", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b98dd5a0-e2c2-4ec4-8823-0717c74b4028"],

Cell["Basic downvalues:", \
"Text",ExpressionUUID->"b60e55b5-1183-481b-ae76-e858d67dedf0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Precompose", "[", 
     RowBox[{"tensor_", ",", "_IdentityMapping"}], "]"}], ":=", "tensor"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Precompose", " ", "and", " ", "SmallCircle", " ", "are", " ", 
     "essentially", " ", "the", " ", "same", " ", "function"}], ",", " ", 
    RowBox[{"so", " ", "we", " ", "keep", " ", "the", " ", "order"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Precompose", "[", 
    RowBox[{
     RowBox[{"Precompose", "[", 
      RowBox[{"tensor_", ",", "phi1_"}], "]"}], ",", "phi2_"}], "]"}], ":=", 
   RowBox[{"Precompose", "[", 
    RowBox[{"tensor", ",", 
     RowBox[{"SmallCircle", "[", 
      RowBox[{"phi1", ",", "phi2"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7ada1642-188d-4b6a-867a-523f166c5704"],

Cell["Special tensors:", \
"Text",ExpressionUUID->"c7075ef1-f003-4368-b7c9-5157fdc827e6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Precompose", "[", 
     RowBox[{"Null", ",", "phi_"}], "]"}], ":=", "Null"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Null", " ", "is", " ", "returned", " ", "by", " ", "MetricOfX", " ", 
    "functions"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Precompose", "[", 
    RowBox[{"Zero", ",", "phi_"}], "]"}], ":=", "Zero"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Precompose", "[", 
    RowBox[{"delta", ",", "phi_"}], "]"}], ":=", "delta"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3233b247-5236-4656-b489-4038e4dd9a37"],

Cell["\<\
Note that Precompose requires two arguments. If there are several mappings \
then we compose them with SmallCircle.\
\>", "Text",ExpressionUUID->"7a1a5297-6612-4591-a28a-28c5f255a8dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Essential", " ", "tensor", " ", "properties"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xTensorQ", "[", 
      RowBox[{"Precompose", "[", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", 
      RowBox[{"Precompose", "[", 
       RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeVBundles", "[", 
      RowBox[{
       RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", 
      RowBox[{"Precompose", "[", 
       RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeDependencies", "[", 
      RowBox[{
       RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}], ",", "phi"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfTensor", "[", 
      RowBox[{"Precompose", "[", 
       RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
     RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dagger", "[", 
      RowBox[{"Precompose", "[", 
       RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"Dagger", "[", "tensor", "]"}], ",", 
       RowBox[{"Dagger", "[", "phi", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightOfTensor", "[", 
      RowBox[{"Precompose", "[", 
       RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeWeight", "[", 
      RowBox[{
       RowBox[{"WeightOfTensor", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9676aa10-643e-4cf0-8550-d62e981b20b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Particular", " ", "case"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfMetric", "[", 
     RowBox[{"Precompose", "[", 
      RowBox[{"metric_", ",", "phi_"}], "]"}], "]"}], "^:=", 
    RowBox[{"PullBackVBundle", "[", 
     RowBox[{
      RowBox[{"VBundleOfMetric", "[", "metric", "]"}], ",", "phi"}], "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"53749dde-0015-4cca-bd0e-99c18c4233e6"],

Cell["\<\
The first argument of pullmanifold could be a parameter, but a parameter is \
never the image of a mapping, and hence nothing bad can happen:\
\>", "Text",ExpressionUUID->"c96a1239-5464-4715-9d90-935b1cf84f81"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"List", " ", "of", " ", "pullback", " ", 
     RowBox[{"vbundles", ".", " ", "Beware"}], " ", "there", " ", "is", " ", 
     "also", " ", "PullBackVBundles"}], ",", " ", 
    RowBox[{"which", " ", "is", " ", "different"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PrecomposeVBundles", "[", 
      RowBox[{"vbs_List", ",", "phi_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"im", "=", 
         RowBox[{"MappingImage", "[", "phi", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"SubmanifoldQ", "[", 
            RowBox[{
             RowBox[{"BaseOfVBundle", "[", "#", "]"}], ",", "im"}], "]"}], 
           ",", 
           RowBox[{"PullBackVBundle", "[", 
            RowBox[{"#", ",", "phi"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
        "vbs"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Pull", " ", "back", " ", "dependencies"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrecomposeDependency", "[", 
      RowBox[{"dep_", ",", "phi_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"SubmanifoldQ", "[", 
        RowBox[{"dep", ",", 
         RowBox[{"MappingImage", "[", "phi", "]"}]}], "]"}], ",", 
       RowBox[{"MappingDomain", "[", "phi", "]"}], ",", "dep"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrecomposeDependencies", "[", 
      RowBox[{"deps_List", ",", "phi_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dom", "=", 
          RowBox[{"MappingDomain", "[", "phi", "]"}]}], ",", 
         RowBox[{"im", "=", 
          RowBox[{"MappingImage", "[", "phi", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"SubmanifoldQ", "[", 
            RowBox[{"#", ",", "im"}], "]"}], ",", "dom", ",", "#"}], "]"}], 
         "&"}], "/@", "deps"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"593b3a92-7bb3-4834-9f0a-8a80fcbc7ebc"],

Cell["Formatting.", \
"Text",ExpressionUUID->"772c15f6-cf5e-43f9-a762-9eb3ab586a6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"Precompose", "[", 
     RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
   RowBox[{"PrecomposeString", "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"98476dd0-f461-4dc8-9fb3-394fa06bcaf5"],

Cell["Protect:", \
"Text",ExpressionUUID->"707032fa-01e3-473e-9475-8a89305f3419"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Precompose", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Precompose", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9555dfa8-fb03-4516-a08a-1a93dd73204d"],

Cell["\<\
Definitions for weights. Eventually call PrecomposeBasis in xCoba:\
\>", "Text",ExpressionUUID->"b537bcbd-4434-4714-97e4-8e52a8c9e02e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrecomposeWeight", "[", 
    RowBox[{"sum_Plus", ",", "phi_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"PrecomposeWeight", "[", 
      RowBox[{"#", ",", "phi"}], "]"}], "&"}], "/@", "sum"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrecomposeWeight", "[", 
    RowBox[{"prod_Times", ",", "phi_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"PrecomposeWeight", "[", 
      RowBox[{"#", ",", "phi"}], "]"}], "&"}], "/@", "prod"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrecomposeWeight", "[", 
    RowBox[{
     RowBox[{"n", ":", 
      RowBox[{"(", 
       RowBox[{"_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
       ")"}]}], ",", "phi_"}], "]"}], ":=", "n"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrecomposeWeight", "[", 
    RowBox[{
     RowBox[{"basis_", "?", "BasisQ"}], ",", "phi_"}], "]"}], ":=", 
   RowBox[{"xAct`xCoba`PrecomposeBasis", "[", 
    RowBox[{"basis", ",", "phi"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"733345a4-b65b-4f6f-a972-7f6a6d89eb66"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11.2. PullBackTensor", \
"Subsubsection",ExpressionUUID->"9c4c8732-6a20-4913-b716-d50bfd8d1639"],

Cell["\<\
PullBackTensor[T, \[Phi]], for T with base N and \[Phi] : M -> N, represents \
a tensor field on M, with indices of TM and -TM, and not a pullback section. \
If T has contravariant indices then this only makes sense for invertible \
mappings \[Phi].\
\>", "Text",ExpressionUUID->"d1875370-3947-4424-a024-36912a986d75"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PullBackTensor", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], ",", "_IdentityMapping"}], "]"}], ":=",
    "tensor"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBackTensor", "[", 
    RowBox[{"delta", ",", 
     RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], ":=", "delta"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"08334579-1f0b-4064-b569-7236cfbec270"],

Cell["\<\
We could have a consistency check between the arguments of PullBackTensor. \
And we should also check invertibility of \[Phi] when needing to pull back a \
contravariant index.\
\>", "Text",ExpressionUUID->"f9c39a68-7ae9-4e1b-85ed-d1e255e49896"],

Cell["Note that this is not equal to PrecomposeVBundles:", \
"Text",ExpressionUUID->"80aa8155-591d-4aa6-bf4c-1b14ffd6de9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PullBackVBundles", "[", 
    RowBox[{"vbs_List", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tdom", "=", 
        RowBox[{"Tangent", "[", 
         RowBox[{"MappingDomain", "[", "phi", "]"}], "]"}]}], ",", 
       RowBox[{"tim", "=", 
        RowBox[{"Tangent", "[", 
         RowBox[{"MappingImage", "[", "phi", "]"}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Which", "[", 
        RowBox[{
         RowBox[{"SameQ", "[", 
          RowBox[{"#", ",", "tim"}], "]"}], ",", "tdom", ",", 
         RowBox[{"SameQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"-", "tim"}]}], "]"}], ",", 
         RowBox[{"-", "tdom"}], ",", "True", ",", "#"}], "]"}], "&"}], "/@", 
      "vbs"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5bf4ccce-d70e-43ad-867a-65c5980bd4fc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"PullBackTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SlotsOfTensor", "[", 
     RowBox[{"PullBackTensor", "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
       RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
    RowBox[{"PullBackVBundles", "[", 
     RowBox[{
      RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
   ";"}], 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "We", " ", "could", " ", "generalize", " ", "this", " ", "by", " ", 
     "using", " ", "SubmanifoldQ"}], ",", " ", 
    RowBox[{"instead", " ", "of", " ", "equality"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", 
    RowBox[{"PullBackTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"PrecomposeDependencies", "[", 
    RowBox[{
     RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}], ",", "phi"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"PullBackTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"PullBackTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"PullBackTensor", "[", 
    RowBox[{
     RowBox[{"Dagger", "[", "tensor", "]"}], ",", 
     RowBox[{"Dagger", "[", "phi", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"13ec2c36-c25a-4460-a407-3a6175c6b209"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Particular", " ", "case"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"VBundleOfMetric", "[", 
     RowBox[{"PullBackTensor", "[", 
      RowBox[{"metric_", ",", "phi_"}], "]"}], "]"}], "^:=", 
    RowBox[{
     RowBox[{"Tangent", "[", 
      RowBox[{"MappingDomain", "[", "phi", "]"}], "]"}], "/;", 
     RowBox[{
      RowBox[{"VBundleOfMetric", "[", "metric", "]"}], "===", 
      RowBox[{"Tangent", "[", 
       RowBox[{"MappingImage", "[", "phi", "]"}], "]"}]}]}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2dc3bcb8-f2db-43de-969b-4373c6760c9b"],

Cell["Formatting.", \
"Text",ExpressionUUID->"e007da87-72ad-4b13-9662-3a6255d9251c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"PullBackTensor", "[", 
     RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
   RowBox[{"PullBackString", "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"44d74be8-21ec-4717-8c01-62a9be54e45d"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11.3. LinearPush", \
"Subsubsection",ExpressionUUID->"f2d9b8f9-5ef5-4424-8a91-b6b33f1f5ad5"],

Cell["\<\
LinearPush[T, d\[Phi]] for \[Phi] : M->N represents a section of the pullback \
vbundle \[Phi]*TN. This is constructed by linear contraction with d\[Phi], \
the tangent mapping of \[Phi], for contravariant slots of T, and with its \
inverse for covariant slots of T. Hence this operation is not well defined \
for covariant slots if the mapping is not locally invertible (both sides? Or \
is it possible to define it with a one-sided derivative? QUESTION. I guess \
the one-sided cases is also valid, but probably only for immersions or only \
for submersions, and I don\[CloseCurlyQuote]t know which one. For the moment \
I do both and see what happens).\
\>", "Text",ExpressionUUID->"5c15fdb5-2da1-4866-9de8-ebb5d23f778a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"TODO", ":", " ", 
    RowBox[{
    "Will", " ", "the", " ", "delta", " ", "have", " ", "a", " ", "starred", 
     " ", 
     RowBox[{"index", "?"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", "delta"}], "]"}], ":=", 
    "tensor"}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3540bab1-ca6f-4a84-9ff9-250e52b2fb18"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"LinearPushVBundles", "[", 
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", "dphi"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"LinearPush", "[", 
    RowBox[{
     RowBox[{"Dagger", "[", "tensor", "]"}], ",", 
     RowBox[{"Dagger", "[", "dphi", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOfTensor", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"Throw", "@", 
    RowBox[{
    "Print", "[", "\"\<TODO: WeightOfTensor[LinearPush[tensor,dphi]]\>\"", 
     "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c2d7b0bc-385d-43b6-a39c-3063cec65ebc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LinearPush", "::", "cova"}], "=", 
   "\"\<Cannot push covariant slot `1` with differential `2` because the \
latter is not invertible.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2ec05d72-ece3-4f92-8afd-964c844dbf5b"],

Cell["\<\
TODO: Probably here we only need either left-invertibility or \
right-invertibility, but I\[CloseCurlyQuote]m not sure which one:\
\>", "Text",ExpressionUUID->"0fc4e240-0b02-4843-85b2-62fafe558440"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"List", " ", "of", " ", "pullback", " ", "vbundles"}], ",", " ", 
    RowBox[{"by", " ", "pushing"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LinearPushVBundles", "[", 
     RowBox[{"vbs_List", ",", "dphi_"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tdom", "=", 
         RowBox[{"-", 
          RowBox[{
           RowBox[{"SlotsOfTensor", "[", "dphi", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
        RowBox[{"ptim", "=", 
         RowBox[{
          RowBox[{"SlotsOfTensor", "[", "dphi", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"SameQ", "[", 
           RowBox[{"tdom", ",", 
            RowBox[{"UpIndex", "[", "#", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"UpIndexQ", "[", "#", "]"}], ",", "ptim", ",", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"InvertibleQ", "[", "dphi", "]"}], ",", 
              RowBox[{"-", "ptim"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Throw", "@", 
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"LinearPush", "::", "cova"}], ",", "#", ",", 
                 "dphi"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "#"}], 
         "]"}], "&"}], "/@", "vbs"}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dd9b4345-f585-4d4c-bccd-6460fd3997d0"],

Cell["Formatting.", \
"Text",ExpressionUUID->"25ee6054-a214-40aa-bbd3-c0d99bfdb18e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"LinearPush", "[", 
     RowBox[{"tensor_", ",", "dphi_"}], "]"}], "]"}], "^:=", 
   RowBox[{"LinearPushString", "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "tensor", "]"}], ",", "dphi"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8e9b9989-8b23-47cc-b326-089ed307178d"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11.4. PushForwardTensor", \
"Subsubsection",ExpressionUUID->"ed857eef-dd60-40ad-bcaa-fbba60c5d6b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PushForwardTensor", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], ",", "_IdentityMapping"}], "]"}], ":=",
    "tensor"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"738f3ed2-91b9-40f2-aa37-1dcd95c7cd2f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"PushVBundles", "[", 
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"PushForwardTensor", "[", 
    RowBox[{
     RowBox[{"Dagger", "[", "tensor", "]"}], ",", 
     RowBox[{"Dagger", "[", "phi", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOfTensor", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
      RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
   RowBox[{"PushForwardBasis", "[", 
    RowBox[{
     RowBox[{"WeightOfTensor", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d7142dc7-4c6e-4cbf-ab34-f6f7ca422aff"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Change", " ", "tangent", " ", "bundle", " ", "of", " ", "the", " ", 
    "domain", " ", "to", " ", "tangent", " ", "bundle", " ", "of", " ", "the",
     " ", "image"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"PushVBundles", "[", 
     RowBox[{"vbs_List", ",", "phi_"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tdom", "=", 
         RowBox[{"Tangent", "[", 
          RowBox[{"MappingDomain", "[", "phi", "]"}], "]"}]}], ",", 
        RowBox[{"tim", "=", 
         RowBox[{"Tangent", "[", 
          RowBox[{"MappingImage", "[", "phi", "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{"SameQ", "[", 
           RowBox[{"tdom", ",", "#"}], "]"}], ",", "tim", ",", 
          RowBox[{"SameQ", "[", 
           RowBox[{
            RowBox[{"-", "tdom"}], ",", "#"}], "]"}], ",", 
          RowBox[{"-", "tim"}], ",", "True", ",", "#"}], "]"}], "&"}], "/@", 
       "vbs"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"db8378e2-7f45-4e42-b6fd-7782e3413242"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PushForwardBasis", "[", 
    RowBox[{"basisorweight_", ",", "phi_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{
    "Print", "[", "\"\<TODO: PushForwardBasis[basis-or-weight, phi]\>\"", 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"57576187-c4b4-400f-bdc7-0f20c15016ef"],

Cell["Formatting.", \
"Text",ExpressionUUID->"bdc063db-f756-4e0c-9144-e0a35d749fb5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"PushForwardTensor", "[", 
     RowBox[{"tensor_", ",", "phi_"}], "]"}], "]"}], "^:=", 
   RowBox[{"PushForwardString", "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "tensor", "]"}], ",", "phi"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0b3d9aef-6df0-4276-a80a-62a7ed740c53"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11.5. The tangent map", \
"Subsubsection",ExpressionUUID->"0c212089-196d-4cfc-8341-c0b3d3e4420f"],

Cell["\<\
I\[CloseCurlyQuote]m not sure whether TangentTensor is the best name. Perhaps \
it should be DMapping or DMappingTensor.\
\>", "Text",ExpressionUUID->"596321fc-a89f-460f-8e61-517a4c815693"],

Cell[TextData[{
 "TangentTensor: for \[Phi] register d\[Phi], represented as \[DifferentialD]\
\[Phi]. Note that we use ToString instead of PrintAs to construct the output \
string of the mapping. This is to avoid the confusing \[DifferentialD]",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Phi]", 
    RowBox[{"-", "1"}]], TraditionalForm]],ExpressionUUID->
  "0559160f-c55b-4eb6-ab3d-8841fd493b87"],
 ", which looks like the inverse of \[DifferentialD]\[Phi], while we mean the \
\[DifferentialD] of ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Phi]", 
    RowBox[{"-", "1"}]], TraditionalForm]],ExpressionUUID->
  "b540f204-73e5-4b18-8780-9f9447bfb389"],
 ". We prefer to have \[DifferentialD]i\[Phi]."
}], "Text",ExpressionUUID->"dd908a30-6536-4de0-9fcf-ccab1677adc4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TangentTensor", "[", 
    RowBox[{"phi_Symbol", "?", "MappingQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"TangentTensor", ",", "phi"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"TangentTensor", ",", 
     RowBox[{"phi_Symbol", "?", "MappingQ"}]}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"\"\<d\>\"", ",", "phi"}], "]"}]}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PrintAsCharacter", "[", "TangentTensor", "]"}], "=", 
    "\"\<\[DifferentialD]\>\""}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Exception", " ", "to", " ", "general", " ", "GiveOutputString", " ", "to",
     " ", "use", " ", "ToString", " ", "instead", " ", "of", " ", "PrintAs"}],
    " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GiveOutputString", "[", 
    RowBox[{"TangentTensor", ",", 
     RowBox[{"phi_Symbol", "?", "MappingQ"}]}], "]"}], ":=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{
     RowBox[{"PrintAsCharacter", "[", "TangentTensor", "]"}], ",", 
     RowBox[{"ToString", "[", "phi", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7d4c46d7-362b-4661-b167-9c7a8c49b4d6"],

Cell["\<\
The tangent map of a composition can only be expanded if we know the indices, \
because otherwise we would need index-free contractions. We do not check that \
the indices belong to the expected vbundles. That\[CloseCurlyQuote]s the user \
responsibility:\
\>", "Text",ExpressionUUID->"60d16512-61ef-4540-8e44-8fecdff0a6f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TangentTensor", "[", 
     RowBox[{"SmallCircle", "[", 
      RowBox[{"phirest__", ",", "phi_"}], "]"}], "]"}], "[", 
    RowBox[{"ind1_", ",", "ind2_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dummy", "=", 
       RowBox[{"DummyIn", "[", 
        RowBox[{"PullBackVBundle", "[", 
         RowBox[{
          RowBox[{"Tangent", "[", 
           RowBox[{"MappingImage", "[", "phi", "]"}], "]"}], ",", "phi"}], 
         "]"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"TangentTensor", "[", "phi", "]"}], "[", 
       RowBox[{"ind1", ",", "dummy"}], "]"}], 
      RowBox[{
       RowBox[{"Precompose", "[", 
        RowBox[{
         RowBox[{"TangentTensor", "[", 
          RowBox[{"SmallCircle", "[", "phirest", "]"}], "]"}], ",", "phi"}], 
        "]"}], "[", 
       RowBox[{
        RowBox[{"-", "dummy"}], ",", "ind2"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e8baf6c5-8c3c-49cc-b21c-31daf7117c40"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.11.6. Invertibility", \
"Subsubsection",ExpressionUUID->"3073a808-3c1d-4ebe-bd1d-1029f87a2235"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InvertibleQ", "[", 
    RowBox[{"op_", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"InvertibleQ", "[", 
     RowBox[{"op", ",", "Left"}], "]"}], "&&", 
    RowBox[{"InvertibleQ", "[", 
     RowBox[{"op", ",", "Right"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InvertibleQ", "[", 
    RowBox[{
     RowBox[{"op_", "?", "xTensorQ"}], ",", 
     RowBox[{"Left", "|", "Right"}]}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InvertibleQ", "[", 
    RowBox[{"op_", ",", 
     RowBox[{"Left", "|", "Right"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"InvertibleQ", "::", "unknown"}], ",", "\"\<2-tensor\>\"", ",", 
      "op"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"InvertibleQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "InvertibleQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7e6e974f-1234-4976-b74d-e8ef0c869990"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.12. Tensors by blocks", \
"Subsection",ExpressionUUID->"1e15d841-09aa-44d8-bac2-ce3fd0cee109"],

Cell[CellGroupData[{

Cell["9.12.0. Comments", \
"Subsubsection",ExpressionUUID->"6b5e4781-86a5-49de-b6b3-2c081e310ade"],

Cell["\<\
The main idea is to generalize the CTensor construction to have full \
tensorial instead of just scalar components. It could be something like

\tBlockTensor[ { v[i], w[a] }, { {X[-i], Y[-a]} } ][ \[Mu] ]

and that would be a representation of

\tv[i] X[-i, \[Mu]] + w[a] Y[-a, \[Mu]]

From that point of view

\tCTensor[ { v1, v2 }, { B } ]

means

\tBlockTensor[ { v1, v2 }, { {Basis[{1, -B}], Basis[{2, -B}]} } ]

That is, the basis B represents the list of its vectors, in index-free form. \
This is quite reasonable. Why in index-free form? Shouldn\[CloseCurlyQuote]t \
we do that in full indexed form for generality? There would not be any \
ambiguity because the objects in the list of \
\[OpenCurlyDoubleQuote]projectors\[CloseCurlyDoubleQuote] would all have 2 \
indices. One is either a c-index or an index contracted with the array. The \
other one would be a free ultraindex, and it must be common to all elements \
of the list.

This notation naturally suggests to use the outer projectors X, Y, and not \
the inner projectors P, Q. What could be a good notation in which the latter \
are natural? What about something like this?

\tBlockTensor[ { V[\[Alpha]], W[\[Tau]] }, { {P[-\[Alpha]], Q[-\[Tau]] } }][ \
\[Mu] ]

We see that we still need some way to communicate v[i] with V[\[Alpha]]. For \
instance V = Projected[ v, {P} ] and v = Projected[ V, {dualX} ], where I don\
\[CloseCurlyQuote]t remember the name we were using for dualX. I\
\[CloseCurlyQuote]m not sure about this use of BlockTensor because the \
tensors in the array could still be fully general, with no clear meaning of \
\[OpenCurlyDoubleQuote]block\[CloseCurlyDoubleQuote] before they are actually \
projected with the projectors.

Here we are about to find our old problem of how to canonicalize expressions \
with projected expressions, because it is difficult to do it with the \
notation Projected[T, {P1, P2, ...}]. Perhaps we need to switch to a \
\[OpenCurlyDoubleQuote]projected indices\[CloseCurlyDoubleQuote] notation \
temporarily to use ToCanonical and then go back. Somehow I have the feeling \
that what we need is some theory of projected vbundles, or subvbundles, that \
we were trying to avoid...\
\>", "Text",ExpressionUUID->"8f6f9883-faf0-4700-925b-249f75112e8d"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.12.1. Main definitions", \
"Subsubsection",ExpressionUUID->"265e8201-7940-4d4f-96c9-7fdf15e1e28a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"BlockTensor", "[", "array_", "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"BlockTensor", "[", "array_", "]"}], "]"}], "^:=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"slotarray", "=", 
       RowBox[{"Map", "[", 
        RowBox[{"SlotsOfTensor", ",", "array", ",", 
         RowBox[{"{", 
          RowBox[{"ArrayDepth", "[", "array", "]"}], "}"}]}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", "TODO"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fe0b5b41-eee3-40c5-b829-4824b9d39894"],

Cell["Formatting:", \
"Text",ExpressionUUID->"8619b81d-7d85-4d0a-a804-88b747834cd7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BlockGridBox", "[", 
    RowBox[{"vector_", "?", "VectorQ"}], "]"}], ":=", 
   RowBox[{"GridBox", "[", 
    RowBox[{
     RowBox[{"List", "/@", "vector"}], ",", 
     RowBox[{"RowLines", "\[Rule]", "True"}], ",", 
     RowBox[{"ColumnLines", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BlockGridBox", "[", 
    RowBox[{"matrix_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"GridBox", "[", 
    RowBox[{"matrix", ",", 
     RowBox[{"RowLines", "\[Rule]", "True"}], ",", 
     RowBox[{"ColumnLines", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BlockGridBox", "[", 
    RowBox[{"array_", "?", "ArrayQ"}], "]"}], ":=", 
   RowBox[{"BlockGridBox", "[", 
    RowBox[{"Map", "[", 
     RowBox[{"BlockGridBox", ",", "array", ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"224a1f69-8301-4563-b9f4-8bfb870c9661"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"BlockTensor", "[", "array_", "]"}], "]"}], "^:=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<(\>\"", ",", 
      RowBox[{"BlockGridBox", "[", 
       RowBox[{"Map", "[", 
        RowBox[{"PrintAs", ",", "array", ",", 
         RowBox[{"{", 
          RowBox[{"ArrayDepth", "[", "array", "]"}], "}"}]}], "]"}], "]"}], 
      ",", "\"\<)\>\""}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d46a154c-2707-4af6-b2a3-71b766f14815"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.12.2. Special cases", \
"Subsubsection",ExpressionUUID->"521b2299-3858-403e-80be-2833ee739faf"],

Cell["Construct a superdiagonal tensor of a given rank:", \
"Text",ExpressionUUID->"0a4c037e-59e8-4b44-8c9c-c13f0d176038"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DiagonalArray", "[", 
    RowBox[{"diagonal_List", ",", "rank_", ",", 
     RowBox[{"zero_", ":", "Zero"}]}], "]"}], ":=", 
   RowBox[{"Normal", "@", 
    RowBox[{"SparseArray", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Band", "@", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{"1", ",", "rank"}], "]"}]}], "\[Rule]", "diagonal"}], ",", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{
        RowBox[{"Length", "[", "diagonal", "]"}], ",", "rank"}], "]"}], ",", 
      "zero"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7bb4149e-d2bc-4883-9723-9f03a717f628"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.12.3. Direct sum indices (an idea, not in the package)", \
"Subsubsection",ExpressionUUID->"33d1adc5-993d-4a6d-9eb5-f9530c48ffb1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfIndex", "[", "ind_CirclePlus", "]"}], "^:=", 
   RowBox[{"VBundleOfIndex", "/@", "ind"}]}], 
  ";"}]], "Input",ExpressionUUID->"dc034c02-9c90-4083-bfa4-f24731879a08"],

Cell["\<\
Main property. This is problematic because if there are several CirclePlus \
indices, the resulting arrays may be transposed depending on the order in \
which the various indices are expanded.\
\>", "Text",ExpressionUUID->"c7956782-3d5e-491b-9be9-98135c7280c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CirclePlus", "/:", 
   RowBox[{
    RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
    RowBox[{"il___", ",", "ind_CirclePlus", ",", "ir___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"tensor", "[", 
      RowBox[{"il", ",", "#", ",", "ir"}], "]"}], "&"}], "/@", 
    RowBox[{"List", "@@", "ind"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"45dec009-00c9-4c7d-bffe-aa3d71ba1e6b"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13. Projectors", \
"Subsection",ExpressionUUID->"6ac99725-3018-43b3-9f28-248d3b105e16"],

Cell[CellGroupData[{

Cell["9.13.0. Comments", \
"Subsubsection",ExpressionUUID->"1880923b-4b8b-47a6-905d-9b50d8b6f6d2"],

Cell[TextData[{
 "This is a project in collaboration with Guillaume Faye. We try to \
incorporate in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " a subsystem which allows defining a decomposition of the delta tensor into \
a sum of (currently two) projectors and then let the system compute \
everything related to that decomposition. This could have multiple \
applications. Comments:\n\n1) There is a major problem to solve: the notation \
for a projected tensor. If P,Q are the projectors, a simple and natural \
option would be to store the projection in the indices, something like T[ \
P[a], -Q[b] ]. However there are serious problems with that choice. The most \
important is that contractions like T[a, b] T[ -P[a], -c ] would be difficult \
to handle in general. From the point of view of free indices, an expression \
like T[ P[a] ] + T[ Q[a] ] would be difficult to accept in the current ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", because we would be reporting inhomogeneous indices { P[a], Q[a] }. The \
problem is that P in T[ P[a] ] actually is part of the tensor T[ P[#] ] with \
index a, and not the tensor T[#] with index P[a]. This change of philosophy \
would need a major rewriting of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ".\n\nFor the moment we shall work with explicit projectors, as in P[-a, b] \
v[-b], instead of trying v[ -P[a] ]. It would not be difficult to develop a \
ContractProjector function, storing the information as Projected[ v, {P} \
][-a].\n\n2) Another issue is whether we want to work with \"inner\" \
projectors P[-a, b], Q[-a, b] or with \"outer\" projectors X[-i, a], etc. In \
principle we want both things.\n\n3) Canonicalization with the \
Projected[...][...] notation would be difficult, and hence it would be \
simpler to switch temporarily to explicit expressions and then contract the \
projectors again.\n\n4) The programming needs several steps:\n\ta) The \
algebra of inner projectors in a vector space.\n\tb) Metrics and orthogonal \
projectors.\n\tc) The algebra of mixing inner and outer projectors in several \
vector spaces.\n\td) Projector fields and their derivatives.\n\te) \
Integrability of projector fields and relation to vbundle splitting.\n\tf) \
Canonicalization of expressions with projectors.\nHere we handle the \
algebraic aspects of projection, deferring the analytical aspects to the \
section on derivatives."
}], "Text",ExpressionUUID->"9738a26f-127f-4d7d-9a3b-6d0885e9f9de"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.1. MakeProjectors", \
"Subsubsection",ExpressionUUID->"f3be7050-6c59-4802-a7f7-085157d93041"],

Cell["\<\
We start by defining a set of complementary inner projectors on a vbundle. \
The vbundle is read from the indices of the tensors. Checking syntax for all \
tensors in the list of projectors is complicated. Hence, it is simpler to \
require that all those projectors already exist as tensors, and use this \
function to set them as projectors. This also allows more freedom in \
specifying individual properties for the tensors, like dependencies, the \
PrintAs form, etc. At input time we need to specify the dimensions of the \
subspaces, and optionally the metric with respect to which they are \
orthogonal. It is important to note that with projectors in the presence of a \
metric we must first define the metric and then use MakeProjectors, and not \
viceversa, because otherwise not all appropriate definitions are loaded.\
\>", "Text",ExpressionUUID->"7125ad37-cd1e-407a-a6c5-91009d903997"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Projectors", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1d3b643a-bf79-48d2-9bb0-a11eabda172b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"General", "::", "nomet"}], "=", 
   "\"\<Invalid index configuration of  `1`.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"77c67dc7-70c0-4121-97e1-011b82fff7f7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MakeProjectors", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"OrthogonalWithMetric", "\[Rule]", "Null"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeProjectors", "[", 
    RowBox[{"projectors_", ",", "dims_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "complementary", ",", "heads", ",", "vbundle", ",", "inds", ",", "owm", 
       ",", "fm"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", "owm", "}"}], "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"{", "OrthogonalWithMetric", "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"heads", ",", "vbundle"}], "}"}], "=", 
       RowBox[{"CheckMakeProjectors", "[", 
        RowBox[{"projectors", ",", "dims", ",", "owm"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"xUpSet", "[", 
         RowBox[{
          RowBox[{"ProjectorQ", "[", "#", "]"}], ",", "True"}], "]"}], "&"}], 
       "/@", "heads"}], ";", "\[IndentingNewLine]", 
      RowBox[{"$Projectors", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"$Projectors", ",", "heads"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"owm", "=!=", "Null"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Set", "[", 
           RowBox[{
            RowBox[{"OrthogonalWithMetricQ", "[", 
             RowBox[{"#", ",", "owm"}], "]"}], ",", "True"}], "]"}], "&"}], "/@",
          "heads"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"inds", "=", 
       RowBox[{"GetIndicesOfVBundle", "[", 
        RowBox[{"vbundle", ",", "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"fm", "=", 
       RowBox[{"FirstMetricOfVBundle", "[", 
        RowBox[{"vbundle", ",", "False"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Orthogonal", " ", "projectors", " ", "are", " ", "symmetric"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"fm", "=!=", "Null"}], "&&", 
         RowBox[{"fm", "===", "owm"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"xUpSet", "[", 
           RowBox[{
            RowBox[{"SymmetryGroupOfTensor", "[", "#", "]"}], ",", 
            RowBox[{"Symmetric", "[", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2"}], "}"}], "]"}]}], "]"}], "&"}], "/@", 
         "heads"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"mu", "=", 
           RowBox[{"inds", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ",", 
          RowBox[{"nu", "=", 
           RowBox[{"inds", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ",", 
          RowBox[{"lambda", "=", 
           RowBox[{"inds", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], ",", 
          RowBox[{"metric", "=", "fm"}]}], "}"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Properties", " ", "of", " ", "a", " ", "single", " ", "projector"}],
          " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"complementary", "[", 
           RowBox[{"head_", ",", "head_"}], "]"}], ":=", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"xTagSet", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"head", ",", 
                RowBox[{
                 RowBox[{"head", "[", 
                  RowBox[{"mu_", ",", "lambda_"}], "]"}], 
                 RowBox[{"head", "[", 
                  RowBox[{
                   RowBox[{"-", "lambda_"}], ",", "nu_"}], "]"}]}]}], "}"}], 
              ",", 
              RowBox[{"head", "[", 
               RowBox[{"mu", ",", "nu"}], "]"}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"metric", "===", "Null"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"head", "[", 
                 RowBox[{"a_Symbol", ",", "b_Symbol"}], "]"}], ":=", 
                RowBox[{"$Failed", "/;", 
                 RowBox[{"Message", "[", 
                  RowBox[{
                   RowBox[{"Validate", "::", "nomet"}], ",", 
                   RowBox[{"Unevaluated", "[", 
                    RowBox[{"head", "[", 
                    RowBox[{"a", ",", "b"}], "]"}], "]"}]}], "]"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"head", "[", 
                 RowBox[{
                  RowBox[{"-", "a_Symbol"}], ",", 
                  RowBox[{"-", "b_Symbol"}]}], "]"}], ":=", 
                RowBox[{"$Failed", "/;", 
                 RowBox[{"Message", "[", 
                  RowBox[{
                   RowBox[{"Validate", "::", "nomet"}], ",", 
                   RowBox[{"Unevaluated", "[", 
                    RowBox[{"head", "[", 
                    RowBox[{
                    RowBox[{"-", "a"}], ",", 
                    RowBox[{"-", "b"}]}], "]"}], "]"}]}], "]"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"head", "[", 
                 RowBox[{"a_Symbol", ",", 
                  RowBox[{"-", "b_Symbol"}]}], "]"}], ":=", 
                RowBox[{"$Failed", "/;", 
                 RowBox[{"Message", "[", 
                  RowBox[{
                   RowBox[{"Validate", "::", "nomet"}], ",", 
                   RowBox[{"Unevaluated", "[", 
                    RowBox[{"head", "[", 
                    RowBox[{"a", ",", 
                    RowBox[{"-", "b"}]}], "]"}], "]"}]}], "]"}]}]}], ";"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"xTagSet", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"head", ",", 
                   RowBox[{
                    RowBox[{"head", "[", 
                    RowBox[{"mu_", ",", 
                    RowBox[{"-", "lambda_"}]}], "]"}], 
                    RowBox[{"head", "[", 
                    RowBox[{"lambda_", ",", "nu_"}], "]"}]}]}], "}"}], ",", 
                 RowBox[{"head", "[", 
                  RowBox[{"mu", ",", "nu"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"metric", "===", "owm"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"xTagSet", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"head", ",", 
                    RowBox[{
                    RowBox[{"head", "[", 
                    RowBox[{"lambda_", ",", "mu_"}], "]"}], 
                    RowBox[{"head", "[", 
                    RowBox[{
                    RowBox[{"-", "lambda_"}], ",", "nu_"}], "]"}]}]}], "}"}], 
                    ",", 
                    RowBox[{"head", "[", 
                    RowBox[{"mu", ",", "nu"}], "]"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"xTagSet", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"head", ",", 
                    RowBox[{
                    RowBox[{"head", "[", 
                    RowBox[{"mu_", ",", "lambda_"}], "]"}], 
                    RowBox[{"head", "[", 
                    RowBox[{"nu_", ",", 
                    RowBox[{"-", "lambda_"}]}], "]"}]}]}], "}"}], ",", 
                    RowBox[{"head", "[", 
                    RowBox[{"mu", ",", "nu"}], "]"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"xTagSet", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"metric", ",", 
                    RowBox[{"Projected", "[", 
                    RowBox[{"metric", ",", 
                    RowBox[{"{", 
                    RowBox[{"head", ",", "head"}], "}"}]}], "]"}]}], "}"}], 
                    ",", "head"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
                "]"}]}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Properties", " ", "of", " ", "pairs", " ", "of", " ", 
           "projectors"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"complementary", "[", 
           RowBox[{"head1_", ",", "head2_"}], "]"}], ":=", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"ComplementaryProjectorsQ", "[", 
              RowBox[{"head1", ",", "head2"}], "]"}], "=", "True"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ComplementaryProjectorsQ", "[", 
              RowBox[{"head2", ",", "head1"}], "]"}], "=", "True"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"xTagSet", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"head1", ",", 
                RowBox[{
                 RowBox[{"head1", "[", 
                  RowBox[{"mu_", ",", "lambda_"}], "]"}], 
                 RowBox[{"head2", "[", 
                  RowBox[{
                   RowBox[{"-", "lambda_"}], ",", "nu_"}], "]"}]}]}], "}"}], 
              ",", "0"}], "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"fm", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"xTagSet", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"head1", ",", 
                   RowBox[{
                    RowBox[{"head1", "[", 
                    RowBox[{"mu_", ",", 
                    RowBox[{"-", "lambda_"}]}], "]"}], 
                    RowBox[{"head2", "[", 
                    RowBox[{"lambda_", ",", "nu_"}], "]"}]}]}], "}"}], ",", 
                 "0"}], "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"fm", "===", "owm"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"xTagSet", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"head1", ",", 
                    RowBox[{
                    RowBox[{"head1", "[", 
                    RowBox[{"lambda_", ",", "mu_"}], "]"}], 
                    RowBox[{"head2", "[", 
                    RowBox[{
                    RowBox[{"-", "lambda_"}], ",", "nu_"}], "]"}]}]}], "}"}], 
                    ",", "0"}], "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"xTagSet", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"head1", ",", 
                    RowBox[{
                    RowBox[{"head1", "[", 
                    RowBox[{"mu_", ",", "lambda_"}], "]"}], 
                    RowBox[{"head2", "[", 
                    RowBox[{"nu_", ",", 
                    RowBox[{"-", "lambda_"}]}], "]"}]}]}], "}"}], ",", "0"}], 
                   "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"xTagSet", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"metric", ",", 
                    RowBox[{"Projected", "[", 
                    RowBox[{"metric", ",", 
                    RowBox[{"{", 
                    RowBox[{"head1", ",", "head2"}], "}"}]}], "]"}]}], "}"}], 
                    ",", "Zero"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
                "]"}]}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Outer", "[", 
          RowBox[{"complementary", ",", "heads", ",", "heads"}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Set", " ", "dimensions"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Inner", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xTagSet", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"#1", ",", 
                RowBox[{"#1", "[", 
                 RowBox[{
                  RowBox[{"-", "mu_"}], ",", "mu_"}], "]"}]}], "}"}], ",", 
              "#2"}], "]"}], "&"}], ",", "heads", ",", "dims", ",", "List"}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"metric", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Inner", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"xTagSet", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"#1", ",", 
                  RowBox[{"#1", "[", 
                   RowBox[{"mu_", ",", 
                    RowBox[{"-", "mu_"}]}], "]"}]}], "}"}], ",", "#2"}], 
               "]"}], "&"}], ",", "heads", ",", "dims", ",", "List"}], 
            "]"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7555b083-1cab-4f1b-8772-938067f29f2b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ComplementaryProjectorsQ", "[", 
    RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OrthogonalWithMetricQ", "[", 
    RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3cbd44e1-1580-41ea-ab84-d5cfca5452e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckMakeProjectors", "[", 
    RowBox[{"projectors_", ",", "dims_", ",", "owm_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"heads", ",", "vbundle"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Check", " ", "we", " ", "have", " ", "a", " ", "list", " ", "of", " ", 
       "at", " ", "least", " ", "two", " ", "elements"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Head", "[", "projectors", "]"}], "=!=", "List"}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "invalid"}], ",", "projectors", 
           ",", "\"\<list of projectors\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "projectors", "]"}], "<", "2"}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "error"}], ",", 
           "\"\<A list of projectors must have at least two elements.\>\""}], 
          "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Check", " ", "that", " ", "the", " ", "heads", " ", "are", " ", 
        "tensors"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"heads", "=", 
       RowBox[{"Head", "/@", "projectors"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"xTensorQ", "[", "#", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeProjectors", "::", "invalid"}], ",", "#", ",", 
             "\"\< is not a tensor.\>\""}], "]"}]}]}], "]"}], "&"}], "/@", 
       "heads"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Check", " ", "that", " ", "the", " ", "indices", " ", "belong", " ", 
         "to", " ", "the", " ", "same", " ", 
         RowBox[{"vbundle", ".", " ", "We"}], " ", "require", " ", "down"}], 
        "-", 
        RowBox[{"up", " ", "objects"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      
      RowBox[{"vbundle", "=", 
       RowBox[{"VBundleOfIndex", "[", 
        RowBox[{"projectors", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Check", " ", "we", " ", "have", " ", "a", " ", "list", " ", "of", " ",
         "dimensions", " ", "of", " ", "correct", " ", "length"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Head", "[", "dims", "]"}], "=!=", "List"}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "invalid"}], ",", "dims", ",", 
           "\"\<list of dimensions\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "dims", "]"}], "=!=", 
         RowBox[{"Length", "[", "projectors", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "error"}], ",", 
           "\"\<List of dimensions has wrong length.\>\""}], "]"}]}]}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "@", 
         RowBox[{"Apply", "[", 
          RowBox[{"And", ",", 
           RowBox[{"ConstantQ", "/@", "dims"}]}], "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "invalid"}], ",", "dims", ",", 
           "\"\<list of constants\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Plus", "@@", "dims"}], "=!=", 
         RowBox[{"DimOfVBundle", "[", "vbundle", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "error"}], ",", 
           "\"\<Dimensions do not add up to the dimension of the complete \
vbundle.\>\""}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Check", " ", "metric"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"owm", "=!=", "Null"}], " ", "&&", " ", 
         RowBox[{"!", 
          RowBox[{"FirstMetricQ", "[", 
           RowBox[{"owm", ",", "vbundle"}], "]"}]}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MakeProjectors", "::", "invalid"}], ",", "owm", ",", 
           "\"\<first metric\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Return", " ", "heads", " ", "and", " ", "vbundle"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"heads", ",", "vbundle"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"32dd5693-6cd9-4f63-9529-2102bfbbc98a"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3c338554-0f8a-4236-bad2-86becb38b93b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b3b62dc3-2805-4c5b-a534-04899436f539"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"95971ef4-fbfb-43a1-bb36-6b4b0aebf194"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7ba242b9-a324-4368-8f7f-5c8fa3e548ab"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"ProjP", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", "S2", ",", 
   RowBox[{"PrintAs", "->", "\"\<P\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"f5eb4710-c3d4-4baf-812c-2185dd927927"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ProjP", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ProjP[-$CellContext`a, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0ecf12d8-2bfe-44d3-aaa3-1d797fc6bc93"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"ProjQ", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", "S2", ",", 
   RowBox[{"PrintAs", "->", "\"\<Q\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"005f63c7-a099-498e-9084-434cf71070d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ProjQ", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ProjQ[-$CellContext`a, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"465b4537-b7d5-4d6c-a9d9-d55f47cd7ea3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeProjectors", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ProjP", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", 
    RowBox[{"ProjQ", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "b"}], "]"}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"ef393cc4-348d-4e2b-9711-6c230bca4fe6"],

Cell[BoxData[
 RowBox[{"MakeProjectors", "[", 
  RowBox[{"{", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"P", 
         StyleBox[GridBox[{
            {" ", "b"},
            {"a", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ProjP[-$CellContext`a, $CellContext`b],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Q", 
         StyleBox[GridBox[{
            {" ", "b"},
            {"a", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ProjQ[-$CellContext`a, $CellContext`b],
     Editable->False]}], "}"}], 
  "]"}]], "Output",ExpressionUUID->"e11dfa04-b0a9-468a-bbc4-ca9fb3f7a5b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Outer", "[", 
   RowBox[{"Times", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ProjP", "[", 
       RowBox[{
        RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", 
      RowBox[{"ProjQ", "[", 
       RowBox[{
        RowBox[{"-", "a"}], ",", "b"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ProjP", "[", 
       RowBox[{
        RowBox[{"-", "b"}], ",", "c"}], "]"}], ",", 
      RowBox[{"ProjQ", "[", 
       RowBox[{
        RowBox[{"-", "b"}], ",", "c"}], "]"}]}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], \
"Input",ExpressionUUID->"f8ca299f-1d2a-4bdd-9aab-8a1c66b43ae3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"P", 
            StyleBox[GridBox[{
               {" ", "b"},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjP[-$CellContext`a, $CellContext`b],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"P", 
            StyleBox[GridBox[{
               {" ", "c"},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjP[-$CellContext`b, $CellContext`c],
        Editable->False]}], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"P", 
            StyleBox[GridBox[{
               {" ", "b"},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjP[-$CellContext`a, $CellContext`b],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Q", 
            StyleBox[GridBox[{
               {" ", "c"},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjQ[-$CellContext`b, $CellContext`c],
        Editable->False]}]},
     {
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"P", 
            StyleBox[GridBox[{
               {" ", "c"},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjP[-$CellContext`b, $CellContext`c],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Q", 
            StyleBox[GridBox[{
               {" ", "b"},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjQ[-$CellContext`a, $CellContext`b],
        Editable->False]}], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"Q", 
            StyleBox[GridBox[{
               {" ", "b"},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjQ[-$CellContext`a, $CellContext`b],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Q", 
            StyleBox[GridBox[{
               {" ", "c"},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ProjQ[-$CellContext`b, $CellContext`c],
        Editable->False]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$]]]], \
"Output",ExpressionUUID->"e7673718-a226-4b4a-9c34-d93873b78243"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProjectorQ", "[", "ProjP", 
  "]"}]], "Input",ExpressionUUID->"7c6142bb-7342-4f14-af15-0149454f3c34"],

Cell[BoxData[
 RowBox[{"ProjectorQ", "[", "ProjP", 
  "]"}]], "Output",ExpressionUUID->"8d292731-0798-4c26-8551-eb86bb9b1cb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"ProjP", ",", "ProjQ"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"b810fe39-0342-4433-8f69-16ced5a6b651"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ProjP"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ProjP],
  Editable->
   False]], "Print",ExpressionUUID->"3c239bf7-6734-4744-8a8a-49ffc8ae16ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ProjQ"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ProjQ],
  Editable->
   False]], "Print",ExpressionUUID->"03bf6830-ada5-4207-8383-50576e678c1a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"54955ddf-1be5-4968-9539-6c61b636bbd5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"fddd1093-740f-4065-90b0-8d3844b1a4d5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"f932542a-9c79-491c-a6aa-8745d3cdea75"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"2bb3d802-669d-4988-bd60-2ad51fb57e85"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.2. The Projected head", \
"Subsubsection",ExpressionUUID->"5ed24dfe-6372-407a-a9c2-ede2ba212a94"],

Cell["\<\
We shall admit tensors of the form Projected[T,{P,Q,delta}][a,b,c]. We need \
functions ToProjected / FromProjected. It is not convenient to use \
ContractProjector / SeparateProjector because not every index can be \
separated; only those of Projected expressions. Properties of the projected \
head:\
\>", "Text",ExpressionUUID->"1c21753c-cc1f-4d5b-b6d5-702f3d9b458b"],

Cell["1) Projected expressions are tensors:", \
"Text",ExpressionUUID->"a1ca1aac-99db-4440-858c-456b3d1a8ab4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", "projs_"}], "]"}], "]"}], "^:=", 
   RowBox[{"xTensorQ", "[", "tensor", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b5648bee-30c6-4b1c-98dc-7ef2f955fda1"],

Cell["\<\
QUESTION: Perhaps we should map the projectors onto the vbundles of the \
tensor?\
\>", "Text",ExpressionUUID->"3bbc9555-2534-4b8a-9715-80162ec3383d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", "projs_"}], "]"}], "]"}], "^:=", 
   RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ace03dc6-152a-4433-8f08-183309fe04d2"],

Cell["\<\
By default, projected heads are printed as the original tensor, because the \
projected character is represented in the indices.\
\>", "Text",ExpressionUUID->"01a54d22-b856-47af-9485-626745ce3158"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", "projs_"}], "]"}], "]"}], "^:=", 
   RowBox[{"PrintAs", "[", "tensor", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cb4aaa2a-7ed7-4f7c-a99b-fafbd9cc0ee6"],

Cell["2) Full delta projection returns the tensor:", \
"Text",ExpressionUUID->"ae0886a5-9d15-416f-981d-8b97eb377e5b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", 
      RowBox[{"{", 
       RowBox[{"delta", "..."}], "}"}]}], "]"}], "[", "inds___", "]"}], ":=", 
   
   RowBox[{"tensor", "[", "inds", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d649b821-e2b3-4b44-a3fe-d2f3991063ad"],

Cell["Any Zero (by composition of projectors) gives zero:", \
"Text",ExpressionUUID->"f863afeb-b39b-40e4-a59e-4557ac92ad23"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"_", ",", 
      RowBox[{"{", 
       RowBox[{"___", ",", "Zero", ",", "___"}], "}"}]}], "]"}], "[", "___", 
    "]"}], ":=", "0"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7a7dc435-72e7-4bf3-ad2b-0a16dce2dcc0"],

Cell["3) The Projected head on delta gives back the projectors.", \
"Text",ExpressionUUID->"0ef143ec-9d0f-4d72-b87f-45356a975b19"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"delta", ",", 
      RowBox[{"{", 
       RowBox[{"proj_", ",", "proj_"}], "}"}]}], "]"}], "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"proj", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"delta", ",", 
      RowBox[{"{", 
       RowBox[{"delta", ",", "proj_"}], "}"}]}], "]"}], "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"proj", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"delta", ",", 
      RowBox[{"{", 
       RowBox[{"proj_", ",", "delta"}], "}"}]}], "]"}], "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"proj", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"delta", ",", 
      RowBox[{"{", 
       RowBox[{"proj1_", ",", "proj2_"}], "}"}]}], "]"}], "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"0", "/;", 
    RowBox[{"ComplementaryProjectorsQ", "[", 
     RowBox[{"proj1", ",", "proj2"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"163fa26d-bcf9-4abc-9362-cd920eb0a41f"],

Cell["Thread over sums of projectors:", \
"Text",ExpressionUUID->"4ff7e61f-4978-4748-ad84-41124d3bd243"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", 
      RowBox[{"{", 
       RowBox[{"projsL___", ",", "sum_Plus", ",", "projsR___"}], "}"}]}], 
     "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Projected", "[", 
       RowBox[{"tensor", ",", 
        RowBox[{"{", 
         RowBox[{"projsL", ",", "#", ",", "projsR"}], "}"}]}], "]"}], "[", 
      "inds", "]"}], "&"}], "/@", "sum"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", 
      RowBox[{"{", 
       RowBox[{"projsL___", ",", "sum_SeriesData", ",", "projsR___"}], 
       "}"}]}], "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor", ",", 
         RowBox[{"{", 
          RowBox[{"projsL", ",", "#", ",", "projsR"}], "}"}]}], "]"}], "[", 
       "inds", "]"}], "&"}], ",", "sum"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"929d681c-8237-4b8c-a6cf-83dccc634fa4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"tensor_", ",", 
      RowBox[{"expr", ":", 
       RowBox[{"(", 
        RowBox[{"_Plus", "|", 
         RowBox[{"_", "?", "ProjectorQ"}]}], ")"}]}]}], "]"}], "[", "inds___",
     "]"}], ":=", 
   RowBox[{
    RowBox[{"Projected", "[", 
     RowBox[{"tensor", ",", 
      RowBox[{
       RowBox[{"expr", "&"}], "/@", 
       RowBox[{"{", "inds", "}"}]}]}], "]"}], "[", "inds", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2b71c2d7-1216-469f-a628-ef4b67118e68"],

Cell["\<\
4) Contractions in the same Projected head. Currently we assume there is just \
one set of projectors.\
\>", "Text",ExpressionUUID->"bd60d932-85ab-47f3-9cca-adc7ff74d09b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"up", "-", 
    RowBox[{"down", " ", "contraction"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"Projected", "[", 
         RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", 
        RowBox[{"left___", ",", "a_", ",", "center___", ",", 
         RowBox[{"-", "a_"}], ",", "right___"}], "]"}]}], ")"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"lproj", "=", 
          RowBox[{"projs", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left", ",", "a"}], "}"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"rproj", "=", 
          RowBox[{"projs", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left", ",", "a", ",", "center", ",", 
               RowBox[{"-", "a"}]}], "}"}], "]"}], "]"}], "]"}]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ComplementaryProjectorsQ", "[", 
           RowBox[{"lproj", ",", "rproj"}], "]"}], ",", "0", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"lproj", "===", "delta"}], ",", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Hold", "[", "expr", "]"}], ",", "rproj", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "2", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"{", 
                 RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "}"}]}], "]"}]}],
           ",", "\[IndentingNewLine]", 
          RowBox[{"rproj", "===", "delta"}], ",", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Hold", "[", "expr", "]"}], ",", "lproj", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "2", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"{", 
                 RowBox[{"left", ",", "a", ",", "center", ",", 
                  RowBox[{"-", "a"}]}], "}"}], "]"}]}], "}"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], "/;", 
        RowBox[{"lproj", "=!=", "rproj"}]}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"down", "-", 
     RowBox[{"up", " ", "contraction"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"Projected", "[", 
         RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", 
        RowBox[{"left___", ",", 
         RowBox[{"-", "a_"}], ",", "center___", ",", "a_", ",", "right___"}], 
        "]"}]}], ")"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"lproj", "=", 
          RowBox[{"projs", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left", ",", "a"}], "}"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"rproj", "=", 
          RowBox[{"projs", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left", ",", "a", ",", "center", ",", 
               RowBox[{"-", "a"}]}], "}"}], "]"}], "]"}], "]"}]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ComplementaryProjectorsQ", "[", 
           RowBox[{"lproj", ",", "rproj"}], "]"}], ",", "0", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"lproj", "===", "delta"}], ",", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Hold", "[", "expr", "]"}], ",", "rproj", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "2", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"{", 
                 RowBox[{"left", ",", 
                  RowBox[{"-", "a"}]}], "}"}], "]"}]}], "}"}]}], "]"}]}], ",",
           "\[IndentingNewLine]", 
          RowBox[{"rproj", "===", "delta"}], ",", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Hold", "[", "expr", "]"}], ",", "lproj", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "2", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"{", 
                 RowBox[{"left", ",", 
                  RowBox[{"-", "a"}], ",", "center", ",", "a"}], "}"}], 
                "]"}]}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
        RowBox[{"lproj", "=!=", "rproj"}]}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"89643414-1668-42bc-bc49-7289aea4202a"],

Cell["\<\
5) Contraction of two Projected expressions, again assuming that there is a \
single set of projectors.\
\>", "Text",ExpressionUUID->"00a8799e-f0fe-41f1-835a-25d447101f64"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Projected", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"expr1", ":", 
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor1_", ",", "projs1_"}], "]"}], "[", 
       RowBox[{"left1___", ",", "a_", ",", "___"}], "]"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"expr2", ":", 
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor2_", ",", "projs2_"}], "]"}], "[", 
       RowBox[{"left2___", ",", 
        RowBox[{"-", "a_"}], ",", "___"}], "]"}]}], ")"}]}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"proj1", "=", 
        RowBox[{"projs1", "[", 
         RowBox[{"[", 
          RowBox[{"Length", "[", 
           RowBox[{"{", 
            RowBox[{"left1", ",", "a"}], "}"}], "]"}], "]"}], "]"}]}], ",", 
       RowBox[{"proj2", "=", 
        RowBox[{"projs2", "[", 
         RowBox[{"[", 
          RowBox[{"Length", "[", 
           RowBox[{"{", 
            RowBox[{"left2", ",", 
             RowBox[{"-", "a"}]}], "}"}], "]"}], "]"}], "]"}]}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ComplementaryProjectorsQ", "[", 
         RowBox[{"proj1", ",", "proj2"}], "]"}], ",", "0", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"proj1", "===", "delta"}], ",", 
        RowBox[{
         RowBox[{"ReleaseHold", "@", 
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            RowBox[{"Hold", "[", "expr1", "]"}], ",", "proj2", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "2", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"{", 
                RowBox[{"left1", ",", "a"}], "}"}], "]"}]}], "}"}]}], "]"}]}],
          "expr2"}], ",", "\[IndentingNewLine]", 
        RowBox[{"proj2", "===", "delta"}], ",", 
        RowBox[{
         RowBox[{"ReleaseHold", "@", 
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            RowBox[{"Hold", "[", "expr2", "]"}], ",", "proj1", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "2", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"{", 
                RowBox[{"left2", ",", 
                 RowBox[{"-", "a"}]}], "}"}], "]"}]}], "}"}]}], "]"}]}], 
         "expr1"}]}], "\[IndentingNewLine]", "]"}], "/;", 
      RowBox[{"proj1", "=!=", "proj2"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7d6f2832-530e-4872-9afa-33ff479f9523"],

Cell["\<\
6) Contractions of products of Projected expressions and projectors. Note \
once again that this assumes there is only one set of projectors. It is not \
completely clear that this is an operation which we want to happen \
automatically.\
\>", "Text",ExpressionUUID->"50ec6a14-7e91-411a-9a26-8a5eadf93254"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Upper", " ", "index", " ", "in", " ", "the", " ", "Projected", " ", 
    "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "/:", 
     RowBox[{
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", 
       RowBox[{"left___", ",", "a_", ",", "right___"}], "]"}], 
      RowBox[{
       RowBox[{"projector_", "?", "ProjectorQ"}], "[", 
       RowBox[{
        RowBox[{"-", "a_"}], ",", "b_"}], "]"}]}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"proj", "=", 
         RowBox[{"projs", "[", 
          RowBox[{"[", 
           RowBox[{"Length", "[", 
            RowBox[{"{", 
             RowBox[{"left", ",", "a"}], "}"}], "]"}], "]"}], "]"}]}], "}"}], 
       ",", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ComplementaryProjectorsQ", "[", 
          RowBox[{"proj", ",", "projector"}], "]"}], ",", "0", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"proj", "===", "projector"}], ",", 
         RowBox[{
          RowBox[{"Projected", "[", 
           RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
          RowBox[{"left", ",", "b", ",", "right"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"proj", "===", "delta"}], ",", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Projected", "[", 
             RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
            RowBox[{"left", ",", "b", ",", "right"}], "]"}], ",", "projector",
            ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "2", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", 
               RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
    "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Lower", " ", "index", " ", "in", " ", "the", " ", "Projected", " ", 
     "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Projected", "/:", 
     RowBox[{
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", 
       RowBox[{"left___", ",", 
        RowBox[{"-", "b_"}], ",", "right___"}], "]"}], 
      RowBox[{
       RowBox[{"projector_", "?", "ProjectorQ"}], "[", 
       RowBox[{
        RowBox[{"-", "a_"}], ",", "b_"}], "]"}]}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"proj", "=", 
         RowBox[{"projs", "[", 
          RowBox[{"[", 
           RowBox[{"Length", "[", 
            RowBox[{"{", 
             RowBox[{"left", ",", 
              RowBox[{"-", "b"}]}], "}"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
       
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ComplementaryProjectorsQ", "[", 
          RowBox[{"proj", ",", "projector"}], "]"}], ",", "0", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"proj", "===", "projector"}], ",", 
         RowBox[{
          RowBox[{"Projected", "[", 
           RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
          RowBox[{"left", ",", 
           RowBox[{"-", "a"}], ",", "right"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"proj", "===", "delta"}], ",", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Projected", "[", 
             RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
            RowBox[{"left", ",", 
             RowBox[{"-", "a"}], ",", "right"}], "]"}], ",", "projector", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "2", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", 
               RowBox[{"left", ",", 
                RowBox[{"-", "b"}]}], "}"}], "]"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"db151624-aa4a-44d1-9743-7da235f47ae9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Upper", " ", "index", " ", "in", " ", "the", " ", "Projected", " ", 
    "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Projected", "/:", 
     RowBox[{
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", 
       RowBox[{"left___", ",", "a_", ",", "right___"}], "]"}], 
      RowBox[{
       RowBox[{"projector_", "?", "ProjectorQ"}], "[", 
       RowBox[{"b_", ",", 
        RowBox[{"-", "a_"}]}], "]"}]}], ":=", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"proj", "=", 
          RowBox[{"projs", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left", ",", "a"}], "}"}], "]"}], "]"}], "]"}]}], "}"}],
         ",", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ComplementaryProjectorsQ", "[", 
           RowBox[{"proj", ",", "projector"}], "]"}], ",", "0", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"proj", "===", "projector"}], ",", 
          RowBox[{
           RowBox[{"Projected", "[", 
            RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
           RowBox[{"left", ",", "b", ",", "right"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"proj", "===", "delta"}], ",", 
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Projected", "[", 
              RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
             RowBox[{"left", ",", "b", ",", "right"}], "]"}], ",", 
            "projector", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"{", 
                RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "/;", 
      RowBox[{"orthoQ", "[", 
       RowBox[{"projector", ",", "a"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Lower", " ", "index", " ", "in", " ", "the", " ", "Projected", " ", 
     "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Projected", "/:", 
     RowBox[{
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", 
       RowBox[{"left___", ",", 
        RowBox[{"-", "b_"}], ",", "right___"}], "]"}], 
      RowBox[{
       RowBox[{"projector_", "?", "ProjectorQ"}], "[", 
       RowBox[{"b_", ",", 
        RowBox[{"-", "a_"}]}], "]"}]}], ":=", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"proj", "=", 
          RowBox[{"projs", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left", ",", 
               RowBox[{"-", "b"}]}], "}"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ComplementaryProjectorsQ", "[", 
           RowBox[{"proj", ",", "projector"}], "]"}], ",", "0", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"proj", "===", "projector"}], ",", 
          RowBox[{
           RowBox[{"Projected", "[", 
            RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
           RowBox[{"left", ",", 
            RowBox[{"-", "a"}], ",", "right"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"proj", "===", "delta"}], ",", 
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Projected", "[", 
              RowBox[{"tensor", ",", "projs"}], "]"}], "[", 
             RowBox[{"left", ",", 
              RowBox[{"-", "a"}], ",", "right"}], "]"}], ",", "projector", 
            ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"{", 
                RowBox[{"left", ",", 
                 RowBox[{"-", "b"}]}], "}"}], "]"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "/;", 
      RowBox[{"orthoQ", "[", 
       RowBox[{"projector", ",", "a"}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"aa8fc783-71bf-4c61-a5f5-8ea0649b69bb"],

Cell["\<\
7) Projected automatically introduces Projected in other expressions it is \
contracted with, if they do not already have the Projected head.\
\>", "Text",ExpressionUUID->"e447ad9e-86ee-4ca5-a835-554dcf30d992"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Projected", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"expr1", ":", 
      RowBox[{
       RowBox[{"Projected", "[", 
        RowBox[{"tensor1_", ",", "projs1_"}], "]"}], "[", 
       RowBox[{"left1___", ",", "a_", ",", "right1___"}], "]"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"expr2", ":", 
      RowBox[{
       RowBox[{"tensor2_", "?", "xTensorQ"}], "[", 
       RowBox[{"left2___", ",", 
        RowBox[{"-", "a_"}], ",", "right2___"}], "]"}]}], ")"}]}], ":=", 
   RowBox[{
    RowBox[{"expr1", " ", 
     RowBox[{
      RowBox[{"Projected", "[", 
       RowBox[{"tensor2", ",", 
        RowBox[{"ReplacePart", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"delta", ",", 
            RowBox[{"{", 
             RowBox[{"Length", "[", "expr2", "]"}], "}"}]}], "]"}], ",", 
          RowBox[{"projs1", "[", 
           RowBox[{"[", 
            RowBox[{"Length", "[", 
             RowBox[{"{", 
              RowBox[{"left1", ",", "a"}], "}"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"Length", "[", 
           RowBox[{"{", 
            RowBox[{"left2", ",", 
             RowBox[{"-", "a"}]}], "}"}], "]"}]}], "]"}]}], "]"}], "[", 
      RowBox[{"left2", ",", 
       RowBox[{"-", "a"}], ",", "right2"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"Head", "[", "tensor2", "]"}], "=!=", "Projected"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a9f0f334-f538-46f8-9393-fa272a1a6de6"],

Cell["8) Composition of two Projected heads:", \
"Text",ExpressionUUID->"b188e144-38e5-4511-97c5-740fa91d188f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ComposeProjectors", "[", 
    RowBox[{"proj_", ",", "proj_"}], "]"}], ":=", "proj"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ComposeProjectors", "[", 
    RowBox[{"delta", ",", "proj_"}], "]"}], ":=", "proj"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ComposeProjectors", "[", 
    RowBox[{"proj_", ",", "delta"}], "]"}], ":=", "proj"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ComposeProjectors", "[", 
    RowBox[{"proj1_", ",", "proj2_"}], "]"}], ":=", 
   RowBox[{"Zero", "/;", 
    RowBox[{"ComplementaryProjectorsQ", "[", 
     RowBox[{"proj1", ",", "proj2"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ComposeProjectors", "[", 
    RowBox[{"projs1___", ",", 
     RowBox[{"ComposeProjectors", "[", "projs2__", "]"}], ",", "projs3___"}], 
    "]"}], ":=", 
   RowBox[{"ComposeProjectors", "[", 
    RowBox[{"projs1", ",", "projs2", ",", "projs3"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"65e5c68f-81de-4d96-ab49-6cb0bb0895a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{
     RowBox[{"Projected", "[", 
      RowBox[{"tensor_", ",", "projs1_"}], "]"}], ",", "projs2_"}], "]"}], ":=", 
   RowBox[{"Projected", "[", 
    RowBox[{"tensor", ",", 
     RowBox[{"Inner", "[", 
      RowBox[{
      "ComposeProjectors", ",", "projs1", ",", "projs2", ",", "List"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"835c3026-b4a7-45f5-9804-139e9447e6ea"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f071acd5-c8a1-4318-9f75-c9a7bbd32203"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b6e1017b-6d76-4008-bcd2-e4aa20793928"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b966aacc-f1a0-4992-8adc-51ed1716d88f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3d514e2f-5f81-40af-b8c9-5830a76e67cb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"ProjP", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", "S2", ",", 
   RowBox[{"PrintAs", "->", "\"\<P\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"c4435c85-bac8-49e9-b367-d8676d94fca7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ProjP", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ProjP[-$CellContext`a, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a935fc16-a6b5-45e2-a90a-db36323ef068"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"ProjQ", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", "S2", ",", 
   RowBox[{"PrintAs", "->", "\"\<Q\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"0944985b-2e44-4672-99a7-65c27058aa23"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ProjQ", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ProjQ[-$CellContext`a, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e738557f-def6-4e90-b222-31e6cc30a79d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`MakeProjectors", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ProjP", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", 
    RowBox[{"ProjQ", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", "b"}], "]"}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"e7c58689-4ca6-4c2c-847b-45fbb9dfe315"],

Cell[BoxData[
 RowBox[{"xAct`xTensor`Private`MakeProjectors", "[", 
  RowBox[{"{", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"P", 
         StyleBox[GridBox[{
            {" ", "b"},
            {"a", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ProjP[-$CellContext`a, $CellContext`b],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Q", 
         StyleBox[GridBox[{
            {" ", "b"},
            {"a", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ProjQ[-$CellContext`a, $CellContext`b],
     Editable->False]}], "}"}], 
  "]"}]], "Output",ExpressionUUID->"04d87a5d-03d3-4919-abcb-655c9b370ccd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], ",", "S2"}], 
  "]"}]], "Input",ExpressionUUID->"38c186bb-a516-4754-99a8-909c8c4d2785"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`a, $CellContext`b, $CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"537233f8-311d-4712-8bb8-06969ce97b39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SSSBinds", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", 
     RowBox[{"-", "c"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ProjP", ",", "delta", ",", "ProjQ"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"6b43bda4-7d02-47ce-9034-be94775bc671"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"  \\!\\(c\\+\\*StyleBox[\\\"Q\\\",FontSize->Tiny]\\)\"\>", 
   ",", "\<\"\\!\\(a\\&\\*StyleBox[\\\"P\\\",FontSize->Tiny]\\)b \"\>"}], 
  "}"}]], "Output",ExpressionUUID->"63d9bb53-3bfc-4611-9d82-ce3ab99152e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Projected", "[", 
   RowBox[{"T", ",", 
    RowBox[{"{", 
     RowBox[{"ProjP", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
  RowBox[{"a", ",", "b", ",", 
   RowBox[{"-", "c"}]}], 
  "]"}]], "Input",ExpressionUUID->"8a265ba6-a3db-4d92-9b24-7e6779740a58"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {
          OverscriptBox["a", 
           StyleBox["P",
            FontSize->Tiny]], "b", " "},
         {" ", " ", 
          UnderscriptBox["c", 
           StyleBox["Q",
            FontSize->Tiny]]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Projected[$CellContext`T, {$CellContext`ProjP, 
    xAct`xTensor`delta, $CellContext`ProjQ}][$CellContext`a, $CellContext`b, \
-$CellContext`c],
  Editable->
   False]], "Output",ExpressionUUID->"5ea9bf40-5e85-4b06-9724-ba1d8773f6e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", 
      RowBox[{"ProjP", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", 
      RowBox[{"ProjP", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "d"}], ",", 
    RowBox[{"-", "e"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2240b1e6-7d50-41d4-a1f7-52f2373dc0ea"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", " "},
          {
           UnderscriptBox["a", 
            StyleBox["P",
             FontSize->Tiny]], "d", 
           UnderscriptBox["e", 
            StyleBox["Q",
             FontSize->Tiny]]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Projected[$CellContext`T, {$CellContext`ProjP, 
     xAct`xTensor`delta, $CellContext`ProjQ}][-$CellContext`a, \
-$CellContext`d, -$CellContext`e],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           OverscriptBox["a", 
            StyleBox["P",
             FontSize->Tiny]], "b", 
           OverscriptBox["c", 
            StyleBox["Q",
             FontSize->Tiny]]},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Projected[$CellContext`T, {$CellContext`ProjP, 
     xAct`xTensor`delta, $CellContext`ProjQ}][$CellContext`a, $CellContext`b, \
$CellContext`c],
   Editable->
    False]}]], "Output",ExpressionUUID->"97063a3d-86b4-4058-bb40-33fa47f63e5b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", 
      RowBox[{"ProjP", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", 
      RowBox[{"ProjQ", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "d"}], ",", 
    RowBox[{"-", "e"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"a04da3d0-ae85-44b4-abe6-f1e207292076"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", 
      RowBox[{"ProjP", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
  RowBox[{
   RowBox[{"Projected", "[", 
    RowBox[{"T", ",", 
     RowBox[{"{", 
      RowBox[{"delta", ",", "delta", ",", "ProjQ"}], "}"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "d"}], ",", 
    RowBox[{"-", "e"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"ce468ee0-e579-4f1a-8293-a44c5d815737"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", " "},
          {
           UnderscriptBox["a", 
            StyleBox["P",
             FontSize->Tiny]], "d", 
           UnderscriptBox["e", 
            StyleBox["Q",
             FontSize->Tiny]]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Projected[$CellContext`T, {$CellContext`ProjP, 
     xAct`xTensor`delta, $CellContext`ProjQ}][-$CellContext`a, \
-$CellContext`d, -$CellContext`e],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           OverscriptBox["a", 
            StyleBox["P",
             FontSize->Tiny]], "b", 
           OverscriptBox["c", 
            StyleBox["Q",
             FontSize->Tiny]]},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Projected[$CellContext`T, {$CellContext`ProjP, 
     xAct`xTensor`delta, $CellContext`ProjQ}][$CellContext`a, $CellContext`b, \
$CellContext`c],
   Editable->
    False]}]], "Output",ExpressionUUID->"4378a70c-4aa8-44e8-a1e9-a4dee9907f05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"ProjP", ",", "ProjQ", ",", "T"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"b8c5beaa-e8a8-4264-b6cf-1c15b9cd997b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ProjP"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ProjP],
  Editable->
   False]], "Print",ExpressionUUID->"7475d755-2a51-4236-b62b-e847a115b013"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ProjQ"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ProjQ],
  Editable->
   False]], "Print",ExpressionUUID->"70110fc4-28a3-4740-a879-76989b128c9b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"a6e553ef-01aa-4763-ae68-ab515b760658"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"f6a23547-fac3-4c2d-acb4-21a97b357ad4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"93982a33-2da2-4776-abe0-52595688fb64"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"3700c9fd-ac34-485f-9c5b-2f5b36277ec5"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"28dbe953-1167-4320-b6b4-7cef5dc0e6e1"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.3. Project", \
"Subsubsection",ExpressionUUID->"9bafe8ca-6ec6-4d38-90af-f7ce994b1a48"],

Cell["\<\
There are two ways in which this function could be programmed. The first one \
is through explicit multiplication with projectors. The second one is through \
the use of Projected. A second issue is what to do with dummy indices.\
\>", "Text",ExpressionUUID->"c23dc0da-abae-4e78-befe-ce913b6bb92e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_", ",", "proj_"}], "]"}], ":=", 
   RowBox[{"Project", "[", 
    RowBox[{"expr", ",", "proj", ",", 
     RowBox[{"IndicesOf", "[", "Free", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_", ",", "proj_", ",", "f_IndicesOf"}], "]"}], ":=", 
   RowBox[{"Project", "[", 
    RowBox[{"expr", ",", "proj", ",", 
     RowBox[{"f", "[", "expr", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_", ",", "proj_", ",", "inds_IndexList"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Project", "[", 
       RowBox[{"#1", ",", "proj", ",", "#2"}], "]"}], "&"}], ",", "expr", ",",
      "inds"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_Plus", ",", "args__"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Project", "[", 
      RowBox[{"#", ",", "args"}], "]"}], "&"}], "/@", "expr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_SeriesData", ",", "args__"}], "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Project", "[", 
       RowBox[{"#", ",", "args"}], "]"}], "&"}], ",", "expr"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"proj_", "?", "ProjectorQ"}], ",", 
     RowBox[{"ind_", "?", "GIndexQ"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
      RowBox[{"left___", ",", "ind", ",", "right___"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyAs", "[", "ind", "]"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"tensor", "[", 
          RowBox[{"left", ",", "dummy", ",", "right"}], "]"}], 
         RowBox[{"proj", "@@", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"UpIndexQ", "[", "ind", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "dummy"}], ",", "ind"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"ind", ",", 
              RowBox[{"-", "dummy"}]}], "}"}]}], "]"}]}]}]}], "]"}], "/;", 
      RowBox[{
       RowBox[{"VBundleOfIndex", "[", "ind", "]"}], "===", 
       RowBox[{
        RowBox[{"SlotsOfTensor", "[", "proj", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Project", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"projs", ":", 
      RowBox[{"{", 
       RowBox[{"___", "?", "ProjectorQ"}], "}"}]}], ",", 
     RowBox[{"ind_", "?", "GIndexQ"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
      RowBox[{"left___", ",", "ind", ",", "right___"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyAs", "[", "ind", "]"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"tensor", "[", 
          RowBox[{"left", ",", "dummy", ",", "right"}], "]"}], 
         RowBox[{"Through", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Plus", "@@", "projs"}], ")"}], "@@", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"UpIndexQ", "[", "ind", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "dummy"}], ",", "ind"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"ind", ",", 
               RowBox[{"-", "dummy"}]}], "}"}]}], "]"}]}], "]"}]}]}], "]"}], "/;", 
      RowBox[{
       RowBox[{"VBundleOfIndex", "[", "ind", "]"}], "===", 
       RowBox[{
        RowBox[{"Union", "[", 
         RowBox[{"SlotsOfTensor", "/@", "projs"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}]}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e98a9ea9-648e-4072-8562-6764fa50378d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Project", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Project", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"153713f4-62d8-4a13-a37f-78938b8354c1"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.4. ContractProjector", \
"Subsubsection",ExpressionUUID->"39031f8c-2a3f-4bd5-a8e4-fabb4a899cd1"],

Cell["0) Main driver:", \
"Text",ExpressionUUID->"dab2e44f-5227-4b61-815d-f0d2524641ea"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ContractProjector", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"OverDerivatives", "\[Rule]", "False"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractProjector", "[", 
    RowBox[{"expr_", ",", "projs_List", ",", "options___"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ContractProjector", "[", 
       RowBox[{"#1", ",", "#2", ",", "options"}], "]"}], "&"}], ",", "expr", 
     ",", "projs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractProjector", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"proj_Symbol", "?", "ProjectorQ"}], ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ContractProjector0", "[", 
     RowBox[{
      RowBox[{"OptionValue", "[", "OverDerivatives", "]"}], ",", "proj"}], 
     "]"}], "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractProjector", "[", 
    RowBox[{"expr_", ",", "proj_Symbol", ",", "options___"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ContractProjector", "::", "unknown"}], ",", 
      "\"\<projector\>\"", ",", "proj"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractProjector", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"ContractProjector", "[", 
    RowBox[{"expr", ",", "$Projectors", ",", "options"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ContractProjector", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "ContractProjector", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"842e30ac-6e09-4fc6-b3f3-108a34dbb68e"],

Cell["1) Expand products. QUESTION: is this really needed?", \
"Text",ExpressionUUID->"1810b87a-f5c5-4bab-80f0-c119eb7bc951"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ContractProjector0", "[", "case__", "]"}], "[", "expr_Times", 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"ContractProjector1", "[", "case", "]"}], "[", 
    RowBox[{"MathInputExpand", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ContractProjector0", "[", "case__", "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{"ContractProjector1", "[", "case", "]"}], "[", "expr", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"83e48980-7228-40be-a57c-e4ce235c6f0e"],

Cell["\<\
2) First we have some definitions which do not perform any actual \
contraction, but refer to themselves recursively:\
\>", "Text",ExpressionUUID->"31a65b7b-15db-4ee8-80b1-05e1a39c68d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Automatic", " ", "threading"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractProjector1", "[", "case__", "]"}], "[", "expr_Plus", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractProjector0", "[", "case", "]"}], "/@", "expr"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractProjector1", "[", "case__", "]"}], "[", 
      "expr_SeriesData", "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{"ContractProjector0", "[", "case", "]"}], ",", "expr"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractProjector1", "[", "case__", "]"}], "[", "list_List", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractProjector0", "[", "case", "]"}], "/@", "list"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractProjector1", "[", "case__", "]"}], "[", "eq_Equal", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractProjector0", "[", "case", "]"}], "/@", "eq"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"693fd630-e9ce-4358-996b-ba907230e0f0"],

Cell["\<\
3) Contractions with tensors. If the projector is orthogonal with respect to \
the first metric then we do not have to worry about index positions. However, \
if the projector is not orthogonal then we need to ensure that Projected acts \
on the original tensor. Generalize to PairQ to have contractions under all \
types of indices.\
\>", "Text",ExpressionUUID->"53350664-4062-457c-a332-03c50a1effd6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"orthoQ", "[", 
    RowBox[{"proj_", ",", "ind_"}], "]"}], ":=", 
   RowBox[{"OrthogonalWithMetricQ", "[", 
    RowBox[{"proj", ",", 
     RowBox[{"FirstMetricOfVBundle", "[", 
      RowBox[{
       RowBox[{"VBundleOfIndex", "[", "ind", "]"}], ",", "False"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"originalQ", "[", 
    RowBox[{"tensor_", ",", "slot_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SignedVBundleOfIndex", "[", 
     RowBox[{"tensor", "[", 
      RowBox[{"[", "slot", "]"}], "]"}], "]"}], "===", 
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", 
      RowBox[{"Head", "[", "tensor", "]"}], "]"}], "[", 
     RowBox[{"[", "slot", "]"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a5a05616-51ec-4330-b44a-5663ce97f8d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Original", " ", 
    RowBox[{"projectors", ":", " ", 
     RowBox[{
     "Orthogonal", " ", "projectors", " ", "or", " ", "original", " ", 
      "tensors"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CP", ":", 
        RowBox[{"ContractProjector1", "[", 
         RowBox[{"od_", ",", "proj_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{"proj_", "[", 
        RowBox[{"a_", ",", "b_"}], "]"}], " ", 
       RowBox[{"T", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
          RowBox[{"left___", ",", 
           RowBox[{"-", "b_"}], ",", "right___"}], "]"}], ")"}]}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CP", "[", 
       RowBox[{"rest", " ", 
        RowBox[{
         RowBox[{"Projected", "[", 
          RowBox[{"tensor", ",", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"delta", ",", 
               RowBox[{"{", 
                RowBox[{"Length", "[", "T", "]"}], "}"}]}], "]"}], ",", 
             "proj", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", 
               RowBox[{"left", ",", 
                RowBox[{"-", "b"}]}], "}"}], "]"}]}], "]"}]}], "]"}], "[", 
         RowBox[{"left", ",", "a", ",", "right"}], "]"}]}], "]"}], "/;", 
      RowBox[{
       RowBox[{"orthoQ", "[", 
        RowBox[{"proj", ",", "b"}], "]"}], "||", 
       RowBox[{"originalQ", "[", 
        RowBox[{"T", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"{", 
           RowBox[{"left", ",", 
            RowBox[{"-", "b"}]}], "}"}], "]"}]}], "]"}]}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CP", ":", 
        RowBox[{"ContractProjector1", "[", 
         RowBox[{"od_", ",", "proj_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{"proj_", "[", 
        RowBox[{
         RowBox[{"-", "a_"}], ",", "b_"}], "]"}], " ", 
       RowBox[{"T", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
          RowBox[{"left___", ",", "a_", ",", "right___"}], "]"}], ")"}]}]}], 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"CP", "[", 
       RowBox[{"rest", " ", 
        RowBox[{
         RowBox[{"Projected", "[", 
          RowBox[{"tensor", ",", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"delta", ",", 
               RowBox[{"{", 
                RowBox[{"Length", "[", "T", "]"}], "}"}]}], "]"}], ",", 
             "proj", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", 
               RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "]"}]}], "]"}], 
         "[", 
         RowBox[{"left", ",", "b", ",", "right"}], "]"}]}], "]"}], "/;", 
      RowBox[{
       RowBox[{"orthoQ", "[", 
        RowBox[{"proj", ",", "a"}], "]"}], "||", 
       RowBox[{"originalQ", "[", 
        RowBox[{"T", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"{", 
           RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "]"}]}]}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e13bd5ac-db5b-4cc4-b885-e51bed8c7917"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Non", "-", 
    RowBox[{"original", " ", 
     RowBox[{"projectors", ":", " ", 
      RowBox[{
      "Orthogonal", " ", "projectors", " ", "or", " ", "not", " ", "original",
        " ", "tensors"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CP", ":", 
        RowBox[{"ContractProjector1", "[", 
         RowBox[{"od_", ",", "proj_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{"proj_", "[", 
        RowBox[{"b_", ",", "a_"}], "]"}], " ", 
       RowBox[{"T", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
          RowBox[{"left___", ",", 
           RowBox[{"-", "b_"}], ",", "right___"}], "]"}], ")"}]}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CP", "[", 
       RowBox[{"rest", " ", 
        RowBox[{
         RowBox[{"Projected", "[", 
          RowBox[{"tensor", ",", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"delta", ",", 
               RowBox[{"{", 
                RowBox[{"Length", "[", "T", "]"}], "}"}]}], "]"}], ",", 
             "proj", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", 
               RowBox[{"left", ",", 
                RowBox[{"-", "b"}]}], "}"}], "]"}]}], "]"}]}], "]"}], "[", 
         RowBox[{"left", ",", "a", ",", "right"}], "]"}]}], "]"}], "/;", 
      RowBox[{
       RowBox[{"orthoQ", "[", 
        RowBox[{"proj", ",", "b"}], "]"}], "||", " ", 
       RowBox[{"!", 
        RowBox[{"originalQ", "[", 
         RowBox[{"T", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"{", 
            RowBox[{"left", ",", 
             RowBox[{"-", "b"}]}], "}"}], "]"}]}], "]"}]}]}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CP", ":", 
        RowBox[{"ContractProjector1", "[", 
         RowBox[{"od_", ",", "proj_"}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{"proj_", "[", 
        RowBox[{"b_", ",", 
         RowBox[{"-", "a_"}]}], "]"}], " ", 
       RowBox[{"T", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
          RowBox[{"left___", ",", "a_", ",", "right___"}], "]"}], ")"}]}]}], 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"CP", "[", 
       RowBox[{"rest", " ", 
        RowBox[{
         RowBox[{"Projected", "[", 
          RowBox[{"tensor", ",", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"delta", ",", 
               RowBox[{"{", 
                RowBox[{"Length", "[", "T", "]"}], "}"}]}], "]"}], ",", 
             "proj", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", 
               RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "]"}]}], "]"}], 
         "[", 
         RowBox[{"left", ",", "b", ",", "right"}], "]"}]}], "]"}], "/;", 
      RowBox[{
       RowBox[{"orthoQ", "[", 
        RowBox[{"proj", ",", "a"}], "]"}], "||", 
       RowBox[{"!", 
        RowBox[{"originalQ", "[", 
         RowBox[{"T", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"{", 
            RowBox[{"left", ",", "a"}], "}"}], "]"}]}], "]"}]}]}]}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b65861a9-96cd-4bc6-b214-35560734208d"],

Cell["\<\
There are two more cases to solve, in which it is not clear what to do: \
non-orthogonal projects with a contraction between either an original tensor \
and a non-original projector or viceversa a non-original tensor with an \
original projector. The idea is that if there is a metric between the \
original tensor and the original projector then the notation Projected[T,{P}] \
cannot accommodate the situation.\
\>", "Text",ExpressionUUID->"9076c752-77db-4482-bbb2-46d49c509339"],

Cell["Fall back definition, used when none of the above holds :", \
"Text",ExpressionUUID->"36e17fb1-1ae9-49f7-8a70-31b78b65be32"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ContractProjector1", "[", 
     RowBox[{"_", ",", "_"}], "]"}], "[", "expr_", "]"}], ":=", "expr"}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d4dbd1e1-abcf-4293-837a-b03414cb7166"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.5. FromProjected", \
"Subsubsection",ExpressionUUID->"6ab89207-34e1-4c5f-84cb-9f5c699b528c"],

Cell["\<\
This is the opposite action to ContractProjector. We want to extract \
projector from Projected expressions, and hence changing the character of the \
index on the tensor. We need to introduce a new index, which could be an \
abstract index or a basis index for a given basis. The syntax is complicated \
because we need three pieces of information on top of the expression: \
SeparateMetric[metric, basis][expr, indices]\
\>", "Text",ExpressionUUID->"fe0883b9-b91d-4e48-9933-4fe9d21867c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FromProjected", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"Projected", "[", 
       RowBox[{"tensor_", ",", "projs_List"}], "]"}], "[", "inds___", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"BreakProjected", "[", 
       RowBox[{"tensor", ",", "projs"}], "]"}], "[", "inds", "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3734e85c-8b1c-49e4-bd19-add3e44f7f75"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BreakProjected", "[", 
     RowBox[{"tensor_", ",", "projs_"}], "]"}], "[", "inds___", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"Times", "@@", "#1"}], ",", 
       RowBox[{"tensor", "@@", "#2"}]}], "]"}], "&"}], "@@", 
    RowBox[{"Transpose", "[", 
     RowBox[{"ArrangeProjector", "/@", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"projs", ",", 
         RowBox[{"{", "inds", "}"}], ",", 
         RowBox[{"DummyAs", "/@", 
          RowBox[{"{", "inds", "}"}]}]}], "}"}], "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ArrangeProjector", "[", 
    RowBox[{"{", 
     RowBox[{"proj_", ",", "ind_Symbol", ",", "dummy_"}], "}"}], "]"}], ":=", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"proj", "[", 
      RowBox[{
       RowBox[{"-", "dummy"}], ",", "ind"}], "]"}], ",", "dummy"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ArrangeProjector", "[", 
    RowBox[{"{", 
     RowBox[{"proj_", ",", 
      RowBox[{"-", "ind_Symbol"}], ",", "dummy_"}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"proj", "[", 
      RowBox[{
       RowBox[{"-", "ind"}], ",", 
       RowBox[{"-", "dummy"}]}], "]"}], ",", "dummy"}], "}"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"30c90709-4c37-40c4-a283-bce2fc4e6c15"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FromProjected", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FromProjected", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"988920f7-432e-4817-a3d3-b1943cf8cdb9"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.1. SetSplitTensors. Old, but still functional", \
"Subsubsection",ExpressionUUID->"3b35348b-c4b4-44a1-af73-11f6c3aac741"],

Cell["\<\
Now that we can decompose a vbundle on subvbundles, we introduce the \
\"split-tensors\" relating them. We shall use special tensors called \
\"split-tensors\", with an index in the \"ambient\" vbundle and another index \
in the subvbundle. In order to reuse the same split-tensors in different \
projections, the tensors must have been defined before. We do not name the \
whole set, and work (currently) with a single one. A split-tensor is called \
upspt if its index on the projected subvbundle is an upper index, and subspt \
if it is a lower index.\
\>", "Text",ExpressionUUID->"6a599896-d58f-4df6-beb8-4cd3272a7c8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Main", " ", "function"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetSplitTensors", "[", 
      RowBox[{"vbundle_", ",", "spts_List"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"structure", "=", 
          RowBox[{"checksplittensors", "[", 
           RowBox[{"vbundle", ",", "spts"}], "]"}]}], ",", "upspts", ",", 
         "downspts", ",", "projs"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"upspts", "=", 
         RowBox[{"Cases", "[", 
          RowBox[{"structure", ",", 
           RowBox[{"{", 
            RowBox[{"_Symbol", ",", "_"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"downspts", "=", 
         RowBox[{"Cases", "[", 
          RowBox[{"structure", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "_Symbol"}], ",", "_"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Construct", " ", "relations", " ", "among", " ", "projectors"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"projs", "=", 
         RowBox[{"Diagonal", "@", 
          RowBox[{"Outer", "[", 
           RowBox[{
            RowBox[{"defproj", "[", "vbundle", "]"}], ",", "upspts", ",", 
            "downspts", ",", "1"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Construct", " ", "relations", " ", "among", " ", "ambient", " ", 
          "projectors"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Outer", "[", 
         RowBox[{
          RowBox[{"defproj2", "[", "vbundle", "]"}], ",", "projs", ",", 
          "projs"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Same", " ", "subspace"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"defproj", "[", "vbundle_", "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vb_", ",", "upspt_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "vb_"}], ",", "downspt_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vbundleQ", "=", 
          RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], ",", 
         RowBox[{"vbQ", "=", 
          RowBox[{"VBundleIndexQ", "[", "vb", "]"}]}], ",", 
         RowBox[{"proj", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Projector", ",", "upspt", ",", "downspt"}], "]"}]}]}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"mu", ",", "nu"}], "}"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Define", " ", "inner", " ", "projector"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"mu", ",", "nu"}], "}"}], "=", 
           RowBox[{"GetIndicesOfVBundle", "[", 
            RowBox[{"vbundle", ",", "2"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"DefTensor", "[", 
           RowBox[{
            RowBox[{"proj", "[", 
             RowBox[{
              RowBox[{"-", "mu"}], ",", "nu"}], "]"}], ",", 
            RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Products", " ", "of", " ", "split"}], "-", "tensors"}], 
           " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"TagSet", "[", 
           RowBox[{"downspt", ",", 
            RowBox[{
             RowBox[{"downspt", "[", 
              RowBox[{
               RowBox[{"-", "b_"}], ",", "mu_"}], "]"}], 
             RowBox[{"upspt", "[", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"mu_", "?", "vbundleQ"}]}], ",", "a_"}], "]"}]}], ",", 
            RowBox[{"delta", "[", 
             RowBox[{
              RowBox[{"-", "b"}], ",", "a"}], "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"TagSet", "[", 
           RowBox[{"upspt", ",", 
            RowBox[{
             RowBox[{"upspt", "[", 
              RowBox[{
               RowBox[{"-", "mu_"}], ",", "a_"}], "]"}], 
             RowBox[{"downspt", "[", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"a_", "?", "vbQ"}]}], ",", "nu_"}], "]"}]}], ",", 
            RowBox[{"proj", "[", 
             RowBox[{
              RowBox[{"-", "mu"}], ",", "nu"}], "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Store", " ", "split"}], "-", 
            RowBox[{
            "tensors", " ", "and", " ", "projectors", " ", "in", " ", "a", 
             " ", "private", " ", "function"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"VBundleProjector", "[", 
            RowBox[{"vbundle", ",", "vb", ",", "xAct`xTensor`Down"}], "]"}], 
           "=", "downspt"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"VBundleProjector", "[", 
            RowBox[{"vbundle", ",", "vb", ",", "xAct`xTensor`Up"}], "]"}], 
           "=", "upspt"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"VBundleProjector", "[", 
            RowBox[{"vbundle", ",", "vb", ",", "Inner"}], "]"}], "=", 
           "proj"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Return", " ", "inner", " ", "projector"}], " ", "*)"}], 
          "\[IndentingNewLine]", "proj"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundleProjector", "[", 
      RowBox[{"vb_", ",", "vb_", ",", "Inner"}], "]"}], ":=", "delta"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundleProjector", "[", 
      RowBox[{"vbundle_", ",", "vb_", ",", "_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"SplitTensor", "::", "error"}], ",", 
        RowBox[{"\"\<Unknown projector from \>\"", "<>", 
         RowBox[{"ToString", "[", "vbundle", "]"}], "<>", "\"\< to \>\"", "<>", 
         RowBox[{"ToString", "[", "vb", "]"}], "<>", "\"\<.\>\""}]}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Different", " ", "subspaces"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"defproj", "[", "vbundle_", "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "upspt_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "_"}], ",", "downspt_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbundleQ", "=", 
         RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TagSet", "[", 
        RowBox[{"downspt", ",", 
         RowBox[{
          RowBox[{"downspt", "[", 
           RowBox[{
            RowBox[{"-", "b_"}], ",", "mu_"}], "]"}], 
          RowBox[{"upspt", "[", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"mu_", "?", "vbundleQ"}]}], ",", "a_"}], "]"}]}], ",", 
         "0"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Ambient", " ", 
     RowBox[{"projectors", ":", " ", 
      RowBox[{"same", " ", "subspace"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"defproj2", "[", "vbundle_", "]"}], "[", 
      RowBox[{"proj_", ",", "proj_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbundleQ", "=", 
         RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TagSet", "[", 
        RowBox[{"proj", ",", 
         RowBox[{
          RowBox[{"proj", "[", 
           RowBox[{
            RowBox[{"-", "mu_"}], ",", "lambda_"}], "]"}], 
          RowBox[{"proj", "[", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"lambda_", "?", "vbundleQ"}]}], ",", "nu_"}], "]"}]}], 
         ",", 
         RowBox[{"proj", "[", 
          RowBox[{
           RowBox[{"-", "mu"}], ",", "nu"}], "]"}]}], "]"}]}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Ambient", " ", 
     RowBox[{"projectors", ":", " ", 
      RowBox[{"different", " ", "subspace"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"defproj2", "[", "vbundle_", "]"}], "[", 
      RowBox[{"proj1_", ",", "proj2_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbundleQ", "=", 
         RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TagSet", "[", 
         RowBox[{"proj1", ",", 
          RowBox[{
           RowBox[{"proj1", "[", 
            RowBox[{
             RowBox[{"-", "mu_"}], ",", "lambda_"}], "]"}], 
           RowBox[{"proj2", "[", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"lambda_", "?", "vbundleQ"}]}], ",", "nu_"}], "]"}]}], 
          ",", "0"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"TagSet", "[", 
         RowBox[{"proj2", ",", 
          RowBox[{
           RowBox[{"proj2", "[", 
            RowBox[{
             RowBox[{"-", "mu_"}], ",", "lambda_"}], "]"}], 
           RowBox[{"proj1", "[", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"lambda_", "?", "vbundleQ"}]}], ",", "nu_"}], "]"}]}], 
          ",", "0"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a70ee863-867b-45a6-8e1f-f721260c0769"],

Cell["\<\
The name of the inner projector associated to the up-split-tensor Y and the \
down-split-tensor X is given by:\
\>", "Text",ExpressionUUID->"d17420ba-a85c-4350-a922-56bc2956c267"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Projector", ",", "Y_", ",", "X_"}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"Y", ",", "X"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c787feec-3386-4417-9f7e-c0677b544681"],

Cell["\<\
This checks that the given list of split-tensors is consistent, and \
compatible with the splitting, previously defined, of the ambient vbundle.\
\>", "Text",ExpressionUUID->"58c1b179-cc4d-4df4-bd25-f4b2bff7f0ea"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"checksplittensor", "[", "vbundle_", "]"}], "[", 
    RowBox[{"spt_", "[", 
     RowBox[{
      RowBox[{"-", "a_Symbol"}], ",", "b_Symbol"}], "]"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vba", "=", 
        RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", 
       RowBox[{"vbb", "=", 
        RowBox[{"VBundleOfIndex", "[", "b", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"xTensorQ", "[", "spt", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefSplitTensors", "::", "unknown"}], ",", "\"\<tensor\>\"",
           ",", "spt"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vba", "===", "vbundle"}], "&&", 
        RowBox[{"SubvbundleQ", "[", 
         RowBox[{"vbundle", ",", "vbb"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"vbb", ",", "spt"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vbb", "===", "vbundle"}], "&&", 
        RowBox[{"SubvbundleQ", "[", 
         RowBox[{"vbundle", ",", "vba"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "vba"}], ",", "spt"}], "}"}], ",", 
       "\[IndentingNewLine]", "True", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefSplitTensors", "::", "invalid"}], ",", 
          "\"\<split-tensor\>\"", ",", 
          RowBox[{"spt", "[", 
           RowBox[{
            RowBox[{"-", "a"}], ",", "b"}], "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"checksplittensor", "[", "_", "]"}], "[", "spt_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefSplitTensors", "::", "invalid"}], ",", "spt", ",", 
      "\"\<split-tensor\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checksplittensors", "[", 
    RowBox[{"vbundle_", ",", "spts_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"subvbs", ",", "structure"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"VBundleQ", "[", "vbundle", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefProjection", "::", "unknown"}], ",", "\"\<vbundle\>\"",
            ",", "vbundle"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"subvbs", "=", 
           RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}]}], ")"}], "===", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefProjection", "::", "error"}], ",", 
           "\"\<VBundle has not yet been decomposed.\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"subvbs", "=", 
         RowBox[{"Last", "[", "subvbs", "]"}]}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"structure", "=", 
       RowBox[{
        RowBox[{"checksplittensor", "[", "vbundle", "]"}], "/@", "spts"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{"First", "/@", "structure"}], "]"}], "=!=", 
         RowBox[{"Sort", "@", 
          RowBox[{"Join", "[", 
           RowBox[{"subvbs", ",", 
            RowBox[{"-", "subvbs"}]}], "]"}]}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefProjection", "::", "error"}], ",", 
           "\"\<Invalid subvbundles.\>\""}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", "structure"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9c73534f-6840-4d2c-af98-c2a7ec3a3f2a"]
}, Closed]],

Cell[CellGroupData[{

Cell["9.13.2. SplitTensor. Old, but still functional", \
"Subsubsection",ExpressionUUID->"094f3f34-1aca-4c29-afaf-b8d4f30b7fd7"],

Cell["\<\
Now we decompose tensors. There are two ways of decomposing a tensor: with \
projectors and without projectors. This function will handle both cases at \
the same time. In the latter case we shall use delta's, though this will \
require further definitions on delta.\
\>", "Text",ExpressionUUID->"69fe01c4-760b-4f7c-b16e-21b646220fc9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SplitTensor", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "]"}], "]"}], ":=", 
   RowBox[{"tensor", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplitTensor", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "indices__", "]"}], "]"}], ":=", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"Outer", "[", 
      RowBox[{
       RowBox[{"SplitTensor1", "[", "tensor", "]"}], ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"SplitTensorIndex", "[", 
            RowBox[{"#", ",", 
             RowBox[{"VBundleOfIndex", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
          
          RowBox[{"{", "indices", "}"}]}], ")"}]}], ",", "1"}], "]"}], ",", 
     "3"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SplitTensor1", "[", "tensor_", "]"}], "[", "trios__List", "]"}], 
   ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ProjectTensor", "[", 
         RowBox[{"tensor", ",", "#2"}], "]"}], "@@", "#1"}], ",", 
       RowBox[{"Sequence", "@@", "#3"}]}], "]"}], "&"}], "@@", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", "trios", "}"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"84c849e8-3987-45c5-ac24-c874642c2ff2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SplitTensorIndex", "[", 
    RowBox[{"a_", ",", "Labels"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"a", ",", "LI", ",", "1"}], "}"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SplitTensorIndex", "[", 
    RowBox[{"a_", ",", "vbundle_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vbs", "=", 
       RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}]}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"vbs", "===", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"a", ",", "delta", ",", "1"}], "}"}], "}"}], ",", 
       RowBox[{
        RowBox[{"vbs", "=", 
         RowBox[{"Last", "[", "vbs", "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"projectindex", "[", 
           RowBox[{"a", ",", "vbundle", ",", "#"}], "]"}], "&"}], "/@", 
         "vbs"}]}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"projectindex", "[", 
    RowBox[{"a_Symbol", ",", "vbundle_", ",", "vb_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dummy", "=", 
       RowBox[{"DummyIn", "[", "vb", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"dummy", ",", 
       RowBox[{"VBundleProjector", "[", 
        RowBox[{"vbundle", ",", "vb", ",", "xAct`xTensor`Up"}], "]"}], ",", 
       RowBox[{
        RowBox[{"VBundleProjector", "[", 
         RowBox[{"vbundle", ",", "vb", ",", "xAct`xTensor`Down"}], "]"}], "[", 
        RowBox[{
         RowBox[{"-", "dummy"}], ",", "a"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"projectindex", "[", 
    RowBox[{
     RowBox[{"-", "a_Symbol"}], ",", "vbundle_", ",", "vb_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dummy", "=", 
       RowBox[{"DummyIn", "[", "vb", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "dummy"}], ",", 
       RowBox[{"VBundleProjector", "[", 
        RowBox[{"vbundle", ",", "vb", ",", "xAct`xTensor`Down"}], "]"}], ",", 
       
       RowBox[{
        RowBox[{"VBundleProjector", "[", 
         RowBox[{"vbundle", ",", "vb", ",", "xAct`xTensor`Up"}], "]"}], "[", 
        RowBox[{
         RowBox[{"-", "a"}], ",", "dummy"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0c503680-efe9-4b35-a1ee-83d7016c876e"],

Cell["Finally we have to specify how to denote parts of tensors:", \
"Text",ExpressionUUID->"7a4ba092-cd24-457b-938f-9b0f4aa787c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProjectTensor", "[", 
     RowBox[{"tensor_", ",", "projs_List"}], "]"}], "[", "inds__", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"symbol", "=", 
       RowBox[{"SymbolJoin", "[", 
        RowBox[{"tensor", ",", 
         RowBox[{"Sequence", "@@", "projs"}]}], "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"xTensorQ", "[", "symbol", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"symbol", "[", "inds", "]"}], ",", 
          RowBox[{"DependenciesOf", "[", "tensor", "]"}], ",", 
          RowBox[{"PrintAs", "\[RuleDelayed]", 
           RowBox[{"StringJoin", "[", 
            RowBox[{"\"\<\\!\\((\>\"", ",", 
             RowBox[{"PrintAs", "[", "tensor", "]"}], ",", "\"\<\\_\>\"", ",", 
             RowBox[{"StringJoin", "@@", 
              RowBox[{"(", 
               RowBox[{"PrintAs", "/@", "projs"}], ")"}]}], ",", 
             "\"\<)\\)\>\""}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"symbol", "[", "inds", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"62ee51a2-3a01-48e5-b4ad-1ca9f9beedbb"]
}, Closed]],

Cell[CellGroupData[{

Cell["7.1.10. (Moved) Rigging", \
"Subsubsection",ExpressionUUID->"97f7f012-199c-4223-b500-3c4f26f56c1a"],

Cell["\<\
For sum vbundles we can add an additional structure called a rigging. This is \
a system of projectors from the total vbundle onto the subvbundles. For a \
rigging Rig we define three structures: the projectors URig[-a, mu] and \
DRig[a, -mu], and then the object Rig[ LI[subvb], mu, -nu ]. I think we \
really need to work with these three structures, and not just one, as \
Schouten suggests, because if we move up and down the indices of URig and \
DRig with a metric, I don't see why they should coincide.\
\>", "Text",ExpressionUUID->"61a339d4-e905-47c3-8069-5a8af089a743"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefRigging", "[", 
    RowBox[{"Null", ",", "_"}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefRigging", "[", 
    RowBox[{"rigging_Symbol", ",", "vbundle_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"base", "=", 
        RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Uname", "=", 
        RowBox[{"SymbolJoin", "[", 
         RowBox[{"\"\<U\>\"", ",", "rigging"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Dname", "=", 
        RowBox[{"SymbolJoin", "[", 
         RowBox[{"\"\<D\>\"", ",", "rigging"}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}], "=", 
         RowBox[{"GetIndicesOfVBundle", "[", 
          RowBox[{"vbundle", ",", "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"Uname", "[", 
           RowBox[{
            RowBox[{"-", "i1"}], ",", "i2"}], "]"}], ",", "base", ",", 
          RowBox[{"Master", "\[Rule]", "vbundle"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"Dname", "[", 
           RowBox[{"i1", ",", 
            RowBox[{"-", "i2"}]}], "]"}], ",", "base", ",", 
          RowBox[{"Master", "\[Rule]", "vbundle"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"rigging", "[", 
           RowBox[{
            RowBox[{"LI", "[", "vbundle", "]"}], ",", "i1", ",", 
            RowBox[{"-", "i2"}]}], "]"}], ",", "base", ",", 
          RowBox[{"Master", "\[Rule]", "vbundle"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TagSetDelayed", "[", 
         RowBox[{"Uname", ",", 
          RowBox[{
           RowBox[{"Uname", "[", 
            RowBox[{
             RowBox[{"-", "i1_"}], ",", "i3_"}], "]"}], 
           RowBox[{"Dname", "[", 
            RowBox[{"i2_", ",", 
             RowBox[{"-", "i3_"}]}], "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"VBundleOfIndex", "[", "i1", "]"}], "===", 
             RowBox[{"VBundleOfIndex", "[", "i2", "]"}]}], ",", 
            RowBox[{"delta", "[", 
             RowBox[{
              RowBox[{"-", "i1"}], ",", "i2"}], "]"}], ",", "0"}], "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"TagSetDelayed", "[", 
         RowBox[{"Uname", ",", 
          RowBox[{
           RowBox[{"Uname", "[", 
            RowBox[{
             RowBox[{"-", "i3_"}], ",", "i1_"}], "]"}], 
           RowBox[{"Dname", "[", 
            RowBox[{"i3_", ",", 
             RowBox[{"-", "i2_"}]}], "]"}]}], ",", 
          RowBox[{"rigging", "[", 
           RowBox[{
            RowBox[{"LI", "[", 
             RowBox[{"VBundleOfIndex", "[", "i3", "]"}], "]"}], ",", "i1", 
            ",", 
            RowBox[{"-", "i2"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"TagSetDelayed", "[", 
         RowBox[{"rigging", ",", 
          RowBox[{
           RowBox[{"rigging", "[", 
            RowBox[{
             RowBox[{"LI", "[", "vb1_", "]"}], ",", "i1_", ",", 
             RowBox[{"-", "i3_"}]}], "]"}], 
           RowBox[{"rigging", "[", 
            RowBox[{
             RowBox[{"LI", "[", "vb2_", "]"}], ",", "i3_", ",", 
             RowBox[{"-", "i2_"}]}], "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"vb1", "===", "vb2"}], ",", 
            RowBox[{"rigging", "[", 
             RowBox[{
              RowBox[{"LI", "[", "vb1", "]"}], ",", "i1", ",", 
              RowBox[{"-", "i2"}]}], "]"}], ",", "0"}], "]"}]}], "]"}], 
        ";"}]}], "\[IndentingNewLine]", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c34bd614-3886-4ae1-9f74-2553b02a4587"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["10. Rules",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"09a51441-284f-4c45-a0e8-d8cb42433c45"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**"}], "*", " ", "10.", "Rules"}], " ", 
  "******************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c43b6c3c-1fcc-4800-8705-11b2fcd00ca1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"978cac5a-b78a-49dc-9ae3-32dc04d5c89a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "41.324577`", ",", "439.967983`9.094966066999548", ",", 
   "0.09392640139012289`"}], 
  "}"}]], "Output",ExpressionUUID->"b31ddc8d-856b-4981-98ff-e242825b7677"]
}, Open  ]],

Cell[CellGroupData[{

Cell["10.0. Comments", \
"Subsection",ExpressionUUID->"5547b556-b97f-4e2b-8287-bbcafd59b643"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 10: Rules.\>\"", "]"}], ",", 
   "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dd6a7cc3-7e7d-47ba-bd4b-1974ac220063"],

Cell["\<\
We can only construct rules with very simple LHSs: they are either a single \
object or a product of objects. Previously, rules were always rules among \
tensors with abstract indices. In version 0.8 MakeRule has been generalized \
to work with component indices. However I'm not sure it is safe. There are \
two problems:
\t- Moving indices up and down could conflict with the use of derivatives \
which are not associated to the first-metric. We shall use careQ as a warning \
for the user.
\t- The use of basis-indices is an additional problem.
We cannot handle patterns for tensors on the LHS. That is, we cannot have \
something like tensor_?xTensorQ[a,b] on the LHS (actually neither on the RHS).\
\>", "Text",ExpressionUUID->"895f5bba-eda5-4ed2-b363-12f6c7fc5de7"],

Cell["\<\
QUESTION: An important unsolved issue is the generation of the complex \
conjugated rules.\
\>", "Text",ExpressionUUID->"edd0b508-c99b-41c3-bf38-d578d7ef9754"],

Cell["\<\
Cyril has pointed out that by having a Hold attribute we might be creating a \
rule for a LHS that already evaluates to zero. That is both inefficient an \
dangerous because we might end up replacing zeros by something else.\
\>", "Text",ExpressionUUID->"08438224-9e68-48c4-97c3-ae569080b51b"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.1. PermuteIndices", \
"Subsection",ExpressionUUID->"d47098e6-0195-4230-92c6-20b377ea4ecf"],

Cell["\<\
This function permutes indices (not slots!) in a generic expression. The \
permutation is given in numeric form and the numbers refer to positions in \
the list of indices (and not slots!). Note that we need to supply the list of \
indices we are referring to, for safety reasons and to avoid using \
FindIndices. The responsibility in this case is all in ReplaceIndex:\
\>", "Text",ExpressionUUID->"86dc0d74-0a2d-4f34-aa3b-1a8d4ce8fa88"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "PermuteIndices"}]], \
"Input",ExpressionUUID->"0bbb617b-2d11-403c-b1fc-80c6eee72cb3"],

Cell[BoxData[
 StyleBox["\<\"PermuteIndices[expr, indices, perm] permutes the indices of \
expr given by the list indices (head IndexList) with the permutation perm, in \
general a linear combination of permutations.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672710-5338953",ExpressionUUID->"94385031-881f-46e6-bf5e-\
b13e145f3017"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Identity", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{"expr_", ",", "indices_IndexList", ",", "ID"}], "]"}], ":=", 
     "expr"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{"expr_", ",", "indices_IndexList", ",", 
       RowBox[{"_", "[", "]"}]}], "]"}], ":=", "expr"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"IndexList", "[", "]"}], ",", "_"}], "]"}], ":=", "expr"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Linear", " ", "combination", " ", "of", " ", "permutations"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{"expr_", ",", "indices_IndexList", ",", "perm_Plus"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"PermuteIndices", "[", 
        RowBox[{"expr", ",", "indices", ",", "#"}], "]"}], "&"}], "/@", 
      "perm"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{"expr_", ",", "indices_IndexList", ",", 
       RowBox[{"k_", " ", 
        RowBox[{"perm_", "?", "PermQ"}]}]}], "]"}], ":=", 
     RowBox[{"k", " ", 
      RowBox[{"PermuteIndices", "[", 
       RowBox[{"expr", ",", "indices", ",", "perm"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Generic", " ", "permutation"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{"expr_", ",", "indices_IndexList", ",", 
       RowBox[{"perm_", "?", "PermQ"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"iperm", "=", 
          RowBox[{"InversePerm", "[", "perm", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"points", "=", 
          RowBox[{"Complement", "[", 
           RowBox[{
            RowBox[{"Range", "@", 
             RowBox[{"PermDeg", "@", "perm"}]}], ",", 
            RowBox[{"StablePoints", "@", "perm"}]}], "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"Inner", "[", 
          RowBox[{"Rule", ",", 
           RowBox[{"indices", "[", 
            RowBox[{"[", "points", "]"}], "]"}], ",", 
           RowBox[{"indices", "[", 
            RowBox[{"[", 
             RowBox[{"OnPoints", "[", 
              RowBox[{"points", ",", "iperm"}], "]"}], "]"}], "]"}], ",", 
           "List"}], "]"}]}], "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6a357b22-679f-4425-b213-c22fbc144f41"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"edee85f3-fcc0-4adb-96f9-9963f47f1ecd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"3fd3fbb0-fff6-4aa1-874f-ab8b274e5794"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ccfe47d2-8103-4423-be80-6059d093f439"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ebdf7ffa-3d2d-4bfd-94ec-466a62762747"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"06b3bb2b-ed49-4c1f-b6f5-ccc1bb23e728"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"fd9dd78e-82b6-4648-9a45-00db47eab11a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"RR", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"eabe90ae-7444-4431-b868-dc7c16d2016c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RR", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`RR[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6886182d-6513-474c-9f57-8d70f42c0cb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"60323a2d-bea2-4818-bde4-071391aba438"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TT[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"01e37372-e316-40e6-a6d2-717a424ad7e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RR", "[", 
   RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
  RowBox[{"TT", "[", 
   RowBox[{
    RowBox[{"-", "F"}], ",", 
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"eadcef88-3283-4320-b9bd-315ee321f0e8"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"F", "A", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, -$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"71f80b40-9db4-4e15-8042-61f3a5d4d357"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PermuteIndices", "[", 
  RowBox[{"%", ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], ",", 
   RowBox[{"xAct`xPerm`Cycles", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c0b01e0b-afd0-4ad8-b0fc-f21da9410b27"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {" ", "B", "C", " "},
          {"A", " ", " ", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[-$CellContext`A, $CellContext`B, C, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", "A", " ", "D"},
          {"F", " ", "B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, $CellContext`A, -$CellContext`B, D],
   Editable->
    False]}]], "Output",ExpressionUUID->"1c0f0c27-1c59-4f82-81ba-392669426ead"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"590be720-0bde-4a7e-9318-c8d7714fe424"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{
   RowBox[{"RR", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"B", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"C", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "polar"}], "}"}]}], "]"}], 
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"e466faad-787f-486d-862e-04528dbdb81e"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {
           StyleBox["A",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["B",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["C",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["D",
            FontColor->RGBColor[1., 0., 0.]]},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[{$CellContext`A, $CellContext`polar}, {$CellContext`B, \
$CellContext`polar}, {C, $CellContext`polar}, {D, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"F", "A", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, -$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"48388f88-f235-4d35-aea2-cf9bc3348543"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PermuteIndices", "[", 
  RowBox[{"expr", ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "polar"}], "}"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "polar"}], "}"}]}], "]"}], ",", 
   RowBox[{"xAct`xPerm`Cycles", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"903c6a35-6fea-4f5d-bf51-7d67d1819530"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["B",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["C",
            FontColor->RGBColor[1., 0., 0.]], " "},
          {"A", " ", " ", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[-$CellContext`A, {$CellContext`B, $CellContext`polar}, {
    C, $CellContext`polar}, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["A",
            FontColor->RGBColor[1., 0., 0.]], " ", 
           StyleBox["D",
            FontColor->RGBColor[1., 0., 0.]]},
          {"F", " ", "B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, {$CellContext`A, $CellContext`polar}, \
-$CellContext`B, {D, $CellContext`polar}],
   Editable->
    False]}]], "Output",ExpressionUUID->"e5c66203-6fca-4ee3-9c54-32b1758e156e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{
   RowBox[{"RR", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"B", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"C", ",", "polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "polar"}], "}"}]}], "]"}], 
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"1d3294c9-9d0e-4ea9-8724-f04e5b188309"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {
           StyleBox["1",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["B",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["C",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["2",
            FontColor->RGBColor[1., 0., 0.]]},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[{
    1, $CellContext`polar}, {$CellContext`B, $CellContext`polar}, {
    C, $CellContext`polar}, {2, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"F", "A", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, -$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"9ef1dcb8-d1d0-42e5-98cf-44770eb0e8b2"]
}, Open  ]],

Cell["\<\
Note how we read it: the first index goes to the position of the second \
index, the second goes to the position of the third, etc:\
\>", "Text",ExpressionUUID->"07b1115b-a9aa-4a12-b64c-328abb79bd78"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PermuteIndices", "[", 
  RowBox[{"expr", ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "polar"}], "}"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{"xAct`xPerm`Cycles", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8b5cbcdf-5cec-46c7-98dd-c447fe7dfedc"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["B",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["C",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["2",
            FontColor->RGBColor[1., 0., 0.]]},
          {"C", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[-C, {$CellContext`B, $CellContext`polar}, {
    C, $CellContext`polar}, {2, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["1",
            FontColor->RGBColor[1., 0., 0.]], " ", " "},
          {"F", " ", "B", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, {
    1, $CellContext`polar}, -$CellContext`B, -$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"06a423be-d137-45b2-b5be-a49a0111e1c0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PermuteIndices", "[", 
  RowBox[{"expr", ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "polar"}], "}"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{"xAct`xPerm`Cycles", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"485638ec-6c4c-4c35-aa8b-35db8e4a6455"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"RR", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["B",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["C",
            FontColor->RGBColor[1., 0., 0.]], 
           StyleBox["2",
            FontColor->RGBColor[1., 0., 0.]]},
          {"A", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RR[-$CellContext`A, {$CellContext`B, $CellContext`polar}, {
    C, $CellContext`polar}, {2, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", " ", " ", 
           StyleBox["1",
            FontColor->RGBColor[1., 0., 0.]]},
          {"F", "C", "B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[-$CellContext`F, -C, -$CellContext`B, {
    1, $CellContext`polar}],
   Editable->
    False]}]], "Output",ExpressionUUID->"77a3a0f1-2a98-467c-ac98-ed71564c256d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PermuteIndices", "[", 
  RowBox[{"expr", ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "polar"}], "}"}], ",", 
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "/", "3"}], 
     RowBox[{"xAct`xPerm`Cycles", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3", ",", "2"}], "}"}], "]"}]}], "+", 
    RowBox[{"3", 
     RowBox[{"xAct`xPerm`Cycles", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}]}]}], 
  "]"}]], "Input",ExpressionUUID->"6063aa88-6925-45cf-88a3-5109b1f5a92a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "3"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"RR", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["B",
             FontColor->RGBColor[1., 0., 0.]], 
            StyleBox["C",
             FontColor->RGBColor[1., 0., 0.]], 
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]]},
           {"A", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RR[-$CellContext`A, {$CellContext`B, $CellContext`polar}, {
     C, $CellContext`polar}, {2, $CellContext`polar}],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"TT", 
        StyleBox[GridBox[{
           {" ", " ", " ", 
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]]},
           {"F", "C", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TT[-$CellContext`F, -C, -$CellContext`B, {
     1, $CellContext`polar}],
    Editable->False]}], "+", 
  RowBox[{"3", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"RR", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["B",
             FontColor->RGBColor[1., 0., 0.]], 
            StyleBox["C",
             FontColor->RGBColor[1., 0., 0.]], 
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]]},
           {"C", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RR[-C, {$CellContext`B, $CellContext`polar}, {
     C, $CellContext`polar}, {2, $CellContext`polar}],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"TT", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]], " ", " "},
           {"F", " ", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TT[-$CellContext`F, {
     1, $CellContext`polar}, -$CellContext`B, -$CellContext`A],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"a9f8e36e-c205-4042-99b9-9406585c83eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"RR", ",", "TT"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"296e8f61-8825-4919-bbd3-563ce28f1e18"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "RR"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`RR],
  Editable->
   False]], "Print",ExpressionUUID->"354f8175-7aac-4bc7-97ff-a091c663acb0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TT],
  Editable->
   False]], "Print",ExpressionUUID->"bd8922e2-e238-4a59-a2aa-03b7c6aadca6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"418b2076-f061-45c0-acf1-84f8607fe48f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"1dd15d10-0d63-4332-aef2-b6805abf801d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"405d48bd-efd3-4632-9c85-a2532569044b"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"polar", ",", "expr"}], 
  "]"}]], "Input",ExpressionUUID->"2818c667-ee72-4d4b-9f06-dc0e873110f3"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e9e8582e-09b5-4528-9cd6-fc726a6e8ac7"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.2. Symmetry equivalents", \
"Subsection",ExpressionUUID->"41c82c84-5928-4e8a-881c-b4e067efa9a4"],

Cell["\<\
SymmetryEquivalentsOfTensor gives the list of tensors which are equivalent to \
the tensor given modulo its slot-symmetries, and taking the quotient by a \
subgroup of the symmetry.\
\>", "Text",ExpressionUUID->"d97d168b-43eb-499d-b3f0-2f0022c2d14d"],

Cell["\<\
The function symperms gives a GS for the symmetric group of indices syminds \
within the bigger set inds.\
\>", "Text",ExpressionUUID->"22998a02-1c53-4c64-9604-e88cda5fdda4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"symperms", "[", 
    RowBox[{"inds_IndexList", ",", "syminds_IndexList"}], "]"}], ":=", 
   RowBox[{"Last", "@", 
    RowBox[{"SGSofsym", "@", 
     RowBox[{"Symmetric", "@", 
      RowBox[{"Flatten", "[", 
       RowBox[{"symperms1", "[", 
        RowBox[{"inds", ",", 
         RowBox[{"Union", "@", "syminds"}]}], "]"}], "]"}]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symperms1", "[", 
    RowBox[{"inds_", ",", 
     RowBox[{"IndexList", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symperms1", "[", 
    RowBox[{"inds_", ",", 
     RowBox[{"IndexList", "[", 
      RowBox[{"a_", ",", "other___"}], "]"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pos", "=", 
       RowBox[{"IndexPosition", "[", 
        RowBox[{"inds", ",", "a"}], "]"}]}], "}"}], ",", 
     RowBox[{"Prepend", "[", 
      RowBox[{
       RowBox[{"symperms1", "[", 
        RowBox[{
         RowBox[{"ReplacePart", "[", 
          RowBox[{"inds", ",", "Null", ",", "pos"}], "]"}], ",", 
         RowBox[{"IndexList", "[", "other", "]"}]}], "]"}], ",", "pos"}], 
      "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5b04b711-b0a4-4981-a242-ae62bc587ad0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"7e816225-1947-4785-a590-53c16f62a2f6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d23f6adf-98e4-47e4-a248-ec81c5522bf0"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  "]"}]], "Output",ExpressionUUID->"fdfdc19a-c867-4c46-addf-e52cbe53b131"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", "a", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c96c8115-5948-4a3f-ae77-bff2d3b30eb3"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  "]"}]], "Output",ExpressionUUID->"de6a9d52-62ab-4770-8c0e-ccafd3a991b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"a5139ec8-cc98-4fe7-8fb6-25c2b71cce7e"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  InterpretationBox[
   StyleBox[
    RowBox[{"(", "1", ",", "2", ")"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xPerm`Cycles[{1, 2}],
   Editable->False], 
  "]"}]], "Output",ExpressionUUID->"e4bd895a-6af1-4924-b8cb-2b2ed4a6fb93"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"b", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e1782a74-a121-45e7-b45c-55a193576150"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  InterpretationBox[
   StyleBox[
    RowBox[{"(", "2", ",", "4", ")"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xPerm`Cycles[{2, 4}],
   Editable->False], 
  "]"}]], "Output",ExpressionUUID->"1d850a29-e98f-4ee1-ba26-c6495a27a70b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"3d4d8fb1-bc12-4463-97fe-77c0845df930"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "1", ",", "2", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{1, 2}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "2", ",", "3", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{2, 3}],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"825a2f4d-bf08-46e0-b483-9d8e6249c51b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"21f4738d-5408-4847-9aa4-d801cfb62da7"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "1", ",", "2", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{1, 2}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "2", ",", "3", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{2, 3}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "3", ",", "4", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{3, 4}],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"4a68095e-eff5-47b8-9471-882039c774fb"]
}, Open  ]],

Cell["It works even for repeated or missing indices:", \
"Text",ExpressionUUID->"fb19d275-74e7-48b6-87b4-fdc206f8bc23"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "a"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"9e0cec77-2356-4b2d-85c2-68700480fcbd"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  "]"}]], "Output",ExpressionUUID->"d6863b85-014a-4c6e-a439-5a72d404483e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "a"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "a"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6374b389-041f-4294-a1a7-89122b4c9658"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  InterpretationBox[
   StyleBox[
    RowBox[{"(", "1", ",", "5", ")"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xPerm`Cycles[{1, 5}],
   Editable->False], 
  "]"}]], "Output",ExpressionUUID->"e0b7a9cc-49dd-4bd8-a50b-9fc79906b88c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "a"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "a", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b9dfa3bb-2112-4268-87b1-6912c8974caf"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "1", ",", "4", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{1, 4}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "4", ",", "5", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{4, 5}],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"a3694440-df16-4c57-88ce-925bbb1b2aed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"e", ",", "f"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"da57423b-0708-4feb-b234-105d72fc51e2"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  "]"}]], "Output",ExpressionUUID->"e0f832a0-3d7b-477a-a7cf-c1f433659532"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", "a", "]"}], ",", 
   RowBox[{"IndexList", "[", "b", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"f307ef74-a125-4256-b1c4-1152e8177455"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  "]"}]], "Output",ExpressionUUID->"f58381e8-9566-48f1-bbd4-01d267580e2d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`symperms", "[", 
  RowBox[{
   RowBox[{"IndexList", "[", "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"9a05404d-0f23-4d93-8826-77be4123602c"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  "]"}]], "Output",ExpressionUUID->"cc0d9680-9f62-4719-a75c-251d27727052"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
  "]"}]], "Input",ExpressionUUID->"365a13fe-eb93-44a2-beef-2dd26cc1dea6"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3e294e12-7379-4b67-b946-c327afbf53e2"],

Cell[TextData[{
 "biggroup contains all elements of the group of symmetry of the tensor; \
smallgroup is a subgroup of biggroup. The variable result contains a list of \
coset-representatives of the quotient biggroup / smallgroup. This computation \
is done using brute force. There is a ",
 "Transversal",
 " function in ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 ", but it only computes transversals in the full symmetric group."
}], "Text",ExpressionUUID->"236e0bed-1dba-4cab-92d7-6e7fd76a6b7c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "SymmetryEquivalentsOfTensor"}]], \
"Input",ExpressionUUID->"b0ebd9b1-43e5-4950-89c9-3d3851499d85"],

Cell[BoxData[
 StyleBox["\<\"xAct`xTensor`Private`SymmetryEquivalentsOfTensor[tensor[\
indices], freeinds] gives a list of tensors which are equivalent to the given \
tensor (with free indices freeinds) from the symmetry point of view, but are \
not equal from the pattern point of view.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672716-5338953",ExpressionUUID->"0ef12b77-44ee-4d44-998e-\
4f655aee295d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Corner", " ", "case", " ", "added"}], ",", " ", 
    RowBox[{"as", " ", "suggested", " ", "by", " ", "Thomas"}]}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryPerms", "[", 
      RowBox[{
       RowBox[{"GenSet", "[", "]"}], ",", "inds_IndexList", ",", 
       "subsets___IndexList"}], "]"}], ":=", 
     RowBox[{"{", "ID", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryPerms", "[", 
      RowBox[{"GS_", ",", "inds_IndexList", ",", "subsets___IndexList"}], 
      "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"g", ",", "biggroup", ",", "smallgroup", ",", "coset", ",", 
         RowBox[{"result", "=", 
          RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"biggroup", "=", 
         RowBox[{"Dimino", "[", 
          RowBox[{"TranslatePerm", "[", 
           RowBox[{"GS", ",", "xAct`xPerm`Cycles"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"smallgroup", "=", 
         RowBox[{"Dimino", "[", 
          RowBox[{"GenSet", "@@", 
           RowBox[{"Union", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"symperms", "[", 
               RowBox[{"inds", ",", "#"}], "]"}], "&"}], "/@", 
             RowBox[{"{", "subsets", "}"}]}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "smallgroup", "]"}], ">", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "biggroup", "]"}], ">", "0"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"g", "=", 
              RowBox[{"First", "@", "biggroup"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"result", ",", "g"}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"coset", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"PermProduct", "[", 
                 RowBox[{"#", ",", "g"}], "]"}], "&"}], "/@", 
               "smallgroup"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"biggroup", "=", 
              RowBox[{"DeleteCases", "[", 
               RowBox[{"biggroup", ",", 
                RowBox[{"Alternatives", "@@", 
                 RowBox[{"Join", "[", 
                  RowBox[{"coset", ",", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"PermProduct", "[", 
                    RowBox[{
                    RowBox[{"-", "ID"}], ",", "#"}], "]"}], "&"}], "/@", 
                    "coset"}]}], "]"}]}]}], "]"}]}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"result", "=", 
           RowBox[{"List", "@@", "biggroup"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "result"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e38717eb-8636-42c6-945a-6a45775e08a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryEquivalentsOfTensor", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"head_", "?", "xTensorQ"}], "[", "inds__", "]"}], ",", 
     "subsets___IndexList"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"PermuteIndices", "[", 
      RowBox[{
       RowBox[{"head", "[", "inds", "]"}], ",", 
       RowBox[{"IndexList", "[", "inds", "]"}], ",", "#"}], "]"}], "&"}], "/@", 
    RowBox[{"SymmetryPerms", "[", 
     RowBox[{
      RowBox[{"SymmetryGroupOfTensor", "[", 
       RowBox[{"head", "[", "inds", "]"}], "]"}], ",", 
      RowBox[{"IndexList", "[", "inds", "]"}], ",", "subsets"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"14cd65f6-76a8-4f77-8c86-618ea1e90f94"],

Cell["\<\
The case of products is particularly interesting. Given a prod[t1, t2, ..., \
tn], with each tensor ti having a grade in the given product prod, and this \
product having a general commutativity sign (say \
\[OpenCurlyDoubleQuote]Anticommutative\[CloseCurlyDoubleQuote]), how do we \
find the sign of any arbitrary reordering of the tensors in that product? Of \
course, if the tensors have indices, then those symmetries will also have to \
be taken into account, but that seems easier, given the technology we already \
have.\
\>", "Text",ExpressionUUID->"deda0683-beab-4b8a-8c56-c69be6ec5ac6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"permute1", "[", 
     RowBox[{"prod_", ",", "comm_"}], "]"}], "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s_", ",", "grades_"}], "}"}], ",", 
     RowBox[{"perm", ":", 
      RowBox[{"System`Cycles", "[", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"n1_", ",", "n2_"}], "}"}], "}"}], "]"}]}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"s", " ", 
      RowBox[{
       RowBox[{"CommutativitySignGrade", "[", 
        RowBox[{"prod", ",", "comm"}], "]"}], "[", 
       RowBox[{
        RowBox[{"grades", "[", 
         RowBox[{"[", "n1", "]"}], "]"}], ",", 
        RowBox[{"grades", "[", 
         RowBox[{"[", "n2", "]"}], "]"}]}], "]"}]}], ",", 
     RowBox[{"System`Permute", "[", 
      RowBox[{"grades", ",", "perm"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"gradeSigns", "[", 
    RowBox[{"grades_List", ",", "prod_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "grades", "]"}]}], ",", 
       RowBox[{"comm", "=", 
        RowBox[{"CommutativityOfProduct", "[", "prod", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"group", ",", "perms", ",", "lists", ",", "signs"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"perms", "=", 
         RowBox[{"Permutations", "[", 
          RowBox[{"Range", "[", "n", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", 
         RowBox[{
         "comm", ",", "\[IndentingNewLine]", "\"\<Commutative\>\"", ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"signs", "=", 
           RowBox[{"ConstantArray", "[", 
            RowBox[{"1", ",", 
             RowBox[{"n", "!"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
          "\"\<Anticommutative\>\"", ",", "\[IndentingNewLine]", "\t", 
          RowBox[{"signs", "=", 
           RowBox[{"Signature", "/@", "perms"}]}], ",", "\[IndentingNewLine]",
           "_", ",", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"group", "=", 
            RowBox[{"PermutationGroup", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"System`Cycles", "[", 
                RowBox[{"{", "#", "}"}], "]"}], "&"}], "/@", 
              RowBox[{"Subsequences", "[", 
               RowBox[{
                RowBox[{"Range", "[", "n", "]"}], ",", 
                RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{"lists", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"Extract", "[", 
               RowBox[{
                RowBox[{"group", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"List", "/@", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"GroupElementToWord", "[", 
                   RowBox[{"group", ",", "#"}], "]"}], "]"}]}]}], "]"}], 
              "&"}], "/@", "perms"}]}], ";", "\[IndentingNewLine]", "\t", 
           RowBox[{"signs", "=", 
            RowBox[{"Part", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Fold", "[", 
                 RowBox[{
                  RowBox[{"permute1", "[", 
                   RowBox[{"prod", ",", "comm"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "grades"}], "}"}], ",", "#"}], "]"}], 
                "&"}], "/@", "lists"}], ",", "All", ",", "1"}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"Thread", "[", 
         RowBox[{"perms", "\[Rule]", "signs"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"77f0fc20-d280-4fa5-b98c-697f24fab7ab"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"permuteSymmetries", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{"s1_Integer", ",", "prodT_"}], "]"}], ",", "rule_"}], "]"}], ":=", 
   RowBox[{"Times", "[", 
    RowBox[{"s1", ",", 
     RowBox[{"permuteSymmetries", "[", 
      RowBox[{"prodT", ",", "rule"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"permuteSymmetries", "[", 
    RowBox[{"prodT_", ",", 
     RowBox[{"Rule", "[", 
      RowBox[{"perm_", ",", "s_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Times", "[", 
    RowBox[{"s", ",", 
     RowBox[{"System`Permute", "[", 
      RowBox[{"prodT", ",", "perm"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryEquivalentsOf", "[", 
    RowBox[{
     RowBox[{"prod_", "?", "ProductQ"}], "[", "tensors___", "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"permsigns", ",", "outer"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Compute", " ", "the", " ", "signs", " ", "derived", " ", "from", " ", 
        "permuting", " ", "objects", " ", "with", " ", "grades"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"permsigns", "=", 
        RowBox[{"gradeSigns", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Grade", "[", 
             RowBox[{"#", ",", "prod"}], "]"}], "&"}], "/@", 
           RowBox[{"{", "tensors", "}"}]}], ",", "prod"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Compute", " ", "all", " ", "symmetry", " ", "equivalents", " ", "by",
          " ", "the", " ", "internal", " ", "symmetries", " ", "of", " ", 
         "the", " ", "factors"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"outer", "=", 
        RowBox[{"Flatten", "@", 
         RowBox[{"Outer", "[", 
          RowBox[{"prod", ",", 
           RowBox[{"Apply", "[", 
            RowBox[{"Sequence", ",", 
             RowBox[{"SymmetryEquivalentsOf", "/@", 
              RowBox[{"{", "tensors", "}"}]}]}], "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Combine", " ", "both", " ", "results"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"Flatten", "@", 
        RowBox[{"Outer", "[", 
         RowBox[{
         "permuteSymmetries", ",", "outer", ",", "permsigns", ",", "1"}], 
         "]"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"prod", "=!=", "Times"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6cff26c1-d34b-423f-9878-b41e2705da86"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryEquivalentsOf", "[", 
    RowBox[{"expr_", ",", "subsets___IndexList"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"FindIndices", "[", "expr", "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"PermuteIndices", "[", 
        RowBox[{"expr", ",", "inds", ",", "#"}], "]"}], "&"}], "/@", 
      RowBox[{"SymmetryPerms", "[", 
       RowBox[{
        RowBox[{"Last", "@", 
         RowBox[{"SymmetryOf", "[", "expr", "]"}]}], ",", "inds", ",", 
        "subsets"}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dfabf42c-dba2-4ac7-8b98-7c78ef5ff458"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SymmetryEquivalentsOfTensor", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"head_", "?", "xTensorQ"}], "[", "inds__", "]"}], ",", 
    "subsets___IndexList"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", "biggroup", ",", "smallgroup", ",", 
      RowBox[{"result", "=", 
       RowBox[{"{", "}"}]}], ",", "coset"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"biggroup", "=", 
      RowBox[{"Dimino", "[", 
       RowBox[{
        RowBox[{"SymmetryGroupOfTensor", "[", 
         RowBox[{"head", "[", "inds", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"smallgroup", "=", 
      RowBox[{"Dimino", "[", 
       RowBox[{"GenSet", "@@", 
        RowBox[{"Union", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"symperms", "[", 
            RowBox[{
             RowBox[{"IndexList", "[", "inds", "]"}], ",", "#"}], "]"}], 
           "&"}], "/@", 
          RowBox[{"{", "subsets", "}"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "smallgroup", "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "biggroup", "]"}], ">", "0"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"g", "=", 
           RowBox[{"First", "@", "biggroup"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"result", ",", "g"}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"coset", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"PermProduct", "[", 
              RowBox[{"#", ",", "g"}], "]"}], "&"}], "/@", "smallgroup"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"biggroup", "=", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{"biggroup", ",", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"Join", "[", 
               RowBox[{"coset", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"PermProduct", "[", 
                   RowBox[{
                    RowBox[{"-", "ID"}], ",", "#"}], "]"}], "&"}], "/@", 
                 "coset"}]}], "]"}]}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"result", "=", 
        RowBox[{"List", "@@", "biggroup"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"PermuteIndices", "[", 
        RowBox[{
         RowBox[{"head", "[", "inds", "]"}], ",", 
         RowBox[{"IndexList", "[", "inds", "]"}], ",", "#"}], "]"}], "&"}], "/@",
       "result"}]}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"3b0167cd-4179-4bf7-a676-427cd2f14135"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"subsets\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "subsets", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"cb5ff05b-94db-430c-abaa-be925c9f9fbf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"g\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "g", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"63261200-e990-4748-9813-4d0ff2fa1c64"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"biggroup\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "biggroup", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->
   False]], "Print",ExpressionUUID->"e770a4fc-4d8f-4f59-93f4-8b30d245fc55"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"smallgroup\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "smallgroup", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"8bb7efd2-29c6-498c-8191-5092e7cddb9e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"coset\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "coset", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"6e578d48-b98c-413e-90a3-b0ca3f403e26"]
}, Open  ]]
}, Open  ]],

Cell["\<\
It would be very simple to generalize this function to arbitrary expressions \
(change SymmetryGroupOfTensor to SymmetryOf and compute indices with \
FindIndices), but right now we only use this function in MakeRule, and there \
we only need it for tensors.\
\>", "Text",ExpressionUUID->"ec33cae0-2c77-45f3-9ec0-6025218b3efa"],

Cell["Examples:", \
"Text",ExpressionUUID->"9cd1ccbb-0624-4048-974e-8e10449dd239"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"275c5736-52ae-49b8-825d-1a3278b0393b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"20d5e5dc-6be6-4eb6-9911-0d5578ad4de9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"17224e3e-eb44-4aa5-8fed-0c8f3089327a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1edbe896-fbfd-44ec-9afb-f456d57a0d79"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"54cec98c-4525-4543-aa36-e28db4c16cbc"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"5ba53aae-7bc9-431c-b4bb-5da8f75d1631"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c0fe3207-1a2d-4465-afd4-8006d436d8a2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f1b81a47-1f9e-407e-b19a-cb5865165ab8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1e7938e9-dc8f-4143-abba-e6796331577f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", " "},
           {" ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`B, -C],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, -C, -$CellContext`B],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"99689016-dd26-4837-a756-61d637e37a67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"6e86fcdf-3da2-49c4-b155-25556e79c84c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"5ce28da6-cd13-4758-b420-072397979fc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"c94d13e9-35c3-4c6b-b854-b42cfa56bda1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d90c4be1-682d-4351-ba0f-3607c70722eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}], ",", 
    RowBox[{"-", "D"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"9a1214bf-4a94-45ee-8df7-0cd14e6c8300"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"B", "A", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"9497da08-f5e7-4450-9d6c-ae0c8e9b14bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"875f5cdb-1c3a-4007-8d43-03ec50e7bcc1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"B", "A", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"0126ddc1-8a19-4726-9199-3c636a70610a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"-", "B"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"9dc40f5c-a221-4fa2-b20f-53609c367902"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"B", "A", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"461de835-7e70-466f-8574-e54b5c8e187c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e7de2d2b-7686-4bcf-a256-c7b239b1bb98"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"b5397d92-33d0-41d3-8f0c-fcefe44dba67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"fe23c6d6-145d-4572-8daa-563435d80973"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"e2f58525-3676-456d-9446-6e37b3e9110a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4e9a3e1b-8af3-4cc5-afc6-df739da49acc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"8e326d0e-16b6-4662-a6a7-cd56d75831a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8e9d9fb6-f668-42a8-b19c-c2ffffc5ad93"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"A", "B", "C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"3872bfaf-fbe1-4d8b-bd03-bbf3f62a529c"]
}, Open  ]],

Cell["There is no check on the up/down character:", \
"Text",ExpressionUUID->"050c0bfe-9e8a-4bac-8e31-c1de5fd3847d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", "A", ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e7f3fe96-88fe-47d6-a8af-fb0dd231d286"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "A", " "},
           {"A", "B", " ", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, $CellContext`A, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", "A", " "},
            {"B", "A", " ", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, $CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", "A"},
            {"A", "B", "D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, $CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", "A"},
           {"B", "A", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, $CellContext`A],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", " ", " "},
           {" ", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " ", " ", " "},
            {" ", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "A", " ", " "},
            {"D", " ", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, $CellContext`A, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", " "},
           {"D", " ", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, $CellContext`A, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"56727c96-ec1c-4022-addb-abce7619193c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", "A", ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4b5f2b33-6487-4bfe-89c6-9d02a3cce47e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "A", " "},
           {"A", "B", " ", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, $CellContext`A, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", "A", " "},
            {"B", "A", " ", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, $CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", "A"},
            {"A", "B", "D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, $CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", "A"},
           {"B", "A", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, $CellContext`A],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", " ", " "},
           {" ", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " ", " ", " "},
            {" ", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "A", " ", " "},
            {"D", " ", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, $CellContext`A, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", " "},
           {"D", " ", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, $CellContext`A, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"25709a87-7bff-49f5-8b6b-c24141b4f557"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "A", ",", "B", ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d23d35cc-a1ea-4264-8fd0-c96d692f931d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", "B", " "},
           {"A", " ", " ", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, $CellContext`B, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "A", " ", "B"},
            {"A", " ", "D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, $CellContext`A, -D, $CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", " ", "B"},
           {" ", "A", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`A, -D, $CellContext`B],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", " ", "A"},
           {" ", "D", "A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, -D, -$CellContext`A, $CellContext`A],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", " ", "A", " "},
            {" ", "D", " ", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B, -D, $CellContext`A, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "B", " ", "A"},
            {"D", " ", "A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, $CellContext`B, -$CellContext`A, $CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B", "A", " "},
           {"D", " ", " ", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, $CellContext`B, $CellContext`A, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"aa5adb9d-e4a1-435e-b5e0-cd73fae99a19"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8ced4620-2bdc-4215-a167-3d04d43693e1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"B", "A", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B],
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"3e44658e-007e-45fc-8ccd-07b9222ebaaa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"ab10a4fa-08b8-49a6-a328-20437c159698"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"fa6f0cc3-4426-4485-aad7-aa744a467819"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b2cbde71-6e8a-4a25-b7e4-c210aa8ef9e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D, -$CellContext`F], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"af3cf013-de38-4f5c-a474-752f86214877"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "F"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"0fe6cf62-f80c-4f49-b440-5d20f487c057"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "B", "C", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "C", "B", "D", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -C, -$CellContext`B, -D, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "C", "A", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -C, -$CellContext`A, -D, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "A", "B", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`A, -$CellContext`B, -D, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "B", "A", "D", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`B, -$CellContext`A, -D, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "B", "D", "C", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "A", "D", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "C", "D", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -C, -D, -$CellContext`B, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "C", "D", "A", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -C, -D, -$CellContext`A, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "A", "D", "B", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`A, -D, -$CellContext`B, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "B", "D", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`B, -D, -$CellContext`A, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "D", "B", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -D, -$CellContext`B, -C, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "D", "A", "C", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -D, -$CellContext`A, -C, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "D", "C", "B", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -D, -C, -$CellContext`B, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "D", "C", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -D, -C, -$CellContext`A, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "D", "A", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "D", "B", "A", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "A", "B", "C", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`A, -$CellContext`B, -C, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "B", "A", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`B, -$CellContext`A, -C, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "A", "C", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`A, -C, -$CellContext`B, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "B", "C", "A", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`B, -C, -$CellContext`A, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "C", "A", "B", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "C", "B", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "B", "C", "F", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -$CellContext`F, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "A", "C", "F", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -C, -$CellContext`F, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "C", "B", "F", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -C, -$CellContext`B, -$CellContext`F, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "C", "A", "F", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -C, -$CellContext`A, -$CellContext`F, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "A", "B", "F", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`A, -$CellContext`B, -$CellContext`F, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "B", "A", "F", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`B, -$CellContext`A, -$CellContext`F, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "B", "D", "F", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -$CellContext`F, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "A", "D", "F", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -$CellContext`F, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "C", "D", "F", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -C, -D, -$CellContext`F, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "C", "D", "F", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -C, -D, -$CellContext`F, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "A", "D", "F", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`A, -D, -$CellContext`F, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "B", "D", "F", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`B, -D, -$CellContext`F, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "D", "B", "F", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -D, -$CellContext`B, -$CellContext`F, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "D", "A", "F", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -D, -$CellContext`A, -$CellContext`F, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "D", "C", "F", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -D, -C, -$CellContext`F, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "D", "C", "F", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -D, -C, -$CellContext`F, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "D", "A", "F", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`F, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "D", "B", "F", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`F, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "A", "B", "F", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`A, -$CellContext`B, -$CellContext`F, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "B", "A", "F", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`B, -$CellContext`A, -$CellContext`F, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "A", "C", "F", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`A, -C, -$CellContext`F, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "B", "C", "F", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`B, -C, -$CellContext`F, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "C", "A", "F", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`F, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "C", "B", "F", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`F, -$CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "B", "F", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -$CellContext`F, -C, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "A", "F", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -$CellContext`F, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "C", "F", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -C, -$CellContext`F, -$CellContext`B, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "C", "F", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -C, -$CellContext`F, -$CellContext`A, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "A", "F", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`A, -$CellContext`F, -$CellContext`B, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "B", "F", "A", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`B, -$CellContext`F, -$CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "B", "F", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -$CellContext`F, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "A", "F", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -$CellContext`F, -D, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "C", "F", "D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -C, -$CellContext`F, -D, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "C", "F", "D", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -C, -$CellContext`F, -D, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "A", "F", "D", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`A, -$CellContext`F, -D, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "B", "F", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`B, -$CellContext`F, -D, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "D", "F", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -D, -$CellContext`F, -$CellContext`B, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "D", "F", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -D, -$CellContext`F, -$CellContext`A, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "D", "F", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -D, -$CellContext`F, -C, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "D", "F", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -D, -$CellContext`F, -C, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "D", "F", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`F, -$CellContext`A, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "D", "F", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`F, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "A", "F", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`A, -$CellContext`F, -$CellContext`B, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "B", "F", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`B, -$CellContext`F, -$CellContext`A, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "A", "F", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`A, -$CellContext`F, -C, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "B", "F", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`B, -$CellContext`F, -C, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "C", "F", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`F, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "C", "F", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`F, -$CellContext`B, -$CellContext`A],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "F", "B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`F, -$CellContext`B, -C, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "F", "A", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`F, -$CellContext`A, -C, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "F", "C", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`F, -C, -$CellContext`B, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "F", "C", "A", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`F, -C, -$CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "F", "A", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`F, -$CellContext`A, -$CellContext`B, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "F", "B", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`F, -$CellContext`B, -$CellContext`A, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "F", "B", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`F, -$CellContext`B, -D, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "F", "A", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`F, -$CellContext`A, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "F", "A", "D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`F, -$CellContext`A, -D, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "F", "B", "D", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`F, -$CellContext`B, -D, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "F", "D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`F, -D, -$CellContext`B, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "F", "D", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`F, -D, -$CellContext`A, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "F", "D", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`F, -D, -C, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "F", "D", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`F, -D, -C, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "F", "D", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`F, -D, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "F", "D", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`F, -D, -$CellContext`B, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "F", "A", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`F, -$CellContext`A, -$CellContext`B, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "F", "B", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`F, -$CellContext`B, -$CellContext`A, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "F", "A", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`F, -$CellContext`A, -C, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "F", "B", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`F, -$CellContext`B, -C, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "F", "C", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`F, -C, -$CellContext`A, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "F", "C", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`F, -C, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`A, -$CellContext`B, -C, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "B", "A", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`B, -$CellContext`A, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "A", "C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`A, -C, -$CellContext`B, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "B", "C", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`B, -C, -$CellContext`A, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "C", "A", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -C, -$CellContext`A, -$CellContext`B, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "C", "B", "A", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -C, -$CellContext`B, -$CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`B, -$CellContext`A, -D, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "C", "A", "D", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -C, -$CellContext`A, -D, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "C", "B", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -C, -$CellContext`B, -D, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "A", "D", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`A, -D, -$CellContext`B, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "B", "D", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`B, -D, -$CellContext`A, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "A", "D", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`A, -D, -C, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "B", "D", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`B, -D, -C, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -C, -D, -$CellContext`A, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "D", "A", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -D, -$CellContext`A, -$CellContext`B, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "D", "B", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -D, -$CellContext`B, -$CellContext`A, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "D", "A", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -D, -$CellContext`A, -C, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "D", "B", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -D, -$CellContext`B, -C, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -D, -C, -$CellContext`B, -$CellContext`A],
    
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"b9f9940c-4a95-4a35-af2d-aba8e173e7f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"249d322e-3434-47a0-968f-d3e3026a7c9c"],

Cell[BoxData["115"], \
"Output",ExpressionUUID->"8a29c17f-aff4-4381-aaa8-a37ce226cbb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"5", "!"}], "/", 
  RowBox[{
  "3", "!"}]}]], \
"Input",ExpressionUUID->"96af39f0-0895-45b6-afeb-b75113e60394"],

Cell[BoxData["20"], \
"Output",ExpressionUUID->"aa43d8d0-9108-41be-8b8a-d77fe75a164d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryEquivalentsOfTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "D"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"757ee4a2-81cf-49ea-8f94-0900e63858d9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "B", "C", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -C, -D, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "C", "B", "D", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -C, -$CellContext`B, -D, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "C", "A", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -C, -$CellContext`A, -D, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "A", "B", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`A, -$CellContext`B, -D, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "B", "A", "D", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`B, -$CellContext`A, -D, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "B", "D", "C", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -C, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "A", "D", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -C, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "C", "D", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -C, -D, -$CellContext`B, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "C", "D", "A", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -C, -D, -$CellContext`A, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "A", "D", "B", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`A, -D, -$CellContext`B, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "B", "D", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`B, -D, -$CellContext`A, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "D", "B", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -D, -$CellContext`B, -C, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "D", "A", "C", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -D, -$CellContext`A, -C, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "D", "C", "B", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -D, -C, -$CellContext`B, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "D", "C", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -D, -C, -$CellContext`A, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "D", "A", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`B, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "D", "B", "A", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`A, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "A", "B", "C", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`A, -$CellContext`B, -C, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "B", "A", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`B, -$CellContext`A, -C, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "A", "C", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`A, -C, -$CellContext`B, -$CellContext`F],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "B", "C", "A", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`B, -C, -$CellContext`A, -$CellContext`F],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "C", "A", "B", "F"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`B, -$CellContext`F],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "C", "B", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`A, -$CellContext`F],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "C", "B", "F", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -C, -$CellContext`B, -$CellContext`F, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "C", "A", "F", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -C, -$CellContext`A, -$CellContext`F, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "A", "B", "F", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`A, -$CellContext`B, -$CellContext`F, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "B", "A", "F", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`B, -$CellContext`A, -$CellContext`F, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "B", "D", "F", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -D, -$CellContext`F, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "A", "D", "F", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -D, -$CellContext`F, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "C", "D", "F", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -C, -D, -$CellContext`F, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "C", "D", "F", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -C, -D, -$CellContext`F, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "A", "D", "F", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`A, -D, -$CellContext`F, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "B", "D", "F", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`B, -D, -$CellContext`F, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "D", "B", "F", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -D, -$CellContext`B, -$CellContext`F, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "D", "A", "F", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -D, -$CellContext`A, -$CellContext`F, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "D", "C", "F", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -D, -C, -$CellContext`F, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "D", "C", "F", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -D, -C, -$CellContext`F, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "D", "A", "F", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`A, -$CellContext`F, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "D", "B", "F", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`B, -$CellContext`F, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "A", "B", "F", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`A, -$CellContext`B, -$CellContext`F, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "B", "A", "F", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`B, -$CellContext`A, -$CellContext`F, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "A", "C", "F", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`A, -C, -$CellContext`F, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "B", "C", "F", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`B, -C, -$CellContext`F, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "C", "A", "F", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`A, -$CellContext`F, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "C", "B", "F", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`B, -$CellContext`F, -$CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "B", "F", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B, -$CellContext`F, -C, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "A", "F", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`A, -$CellContext`F, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "C", "F", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -C, -$CellContext`F, -$CellContext`B, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "C", "F", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -C, -$CellContext`F, -$CellContext`A, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "A", "F", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`A, -$CellContext`F, -$CellContext`B, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "B", "F", "A", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`B, -$CellContext`F, -$CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "B", "F", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B, -$CellContext`F, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "A", "F", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A, -$CellContext`F, -D, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "C", "F", "D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -C, -$CellContext`F, -D, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "C", "F", "D", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -C, -$CellContext`F, -D, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "A", "F", "D", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`A, -$CellContext`F, -D, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "B", "F", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`B, -$CellContext`F, -D, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "D", "F", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -D, -$CellContext`F, -$CellContext`B, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "D", "F", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -D, -$CellContext`F, -$CellContext`A, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "D", "F", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -D, -$CellContext`F, -C, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "D", "F", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -D, -$CellContext`F, -C, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "D", "F", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D, -$CellContext`F, -$CellContext`A, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "D", "F", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -D, -$CellContext`F, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "A", "F", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`A, -$CellContext`F, -$CellContext`B, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "B", "F", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`B, -$CellContext`F, -$CellContext`A, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "A", "F", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`A, -$CellContext`F, -C, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "B", "F", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`B, -$CellContext`F, -C, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "C", "F", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -C, -$CellContext`F, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "C", "F", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -C, -$CellContext`F, -$CellContext`B, -$CellContext`A],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "F", "B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`F, -$CellContext`B, -C, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "F", "A", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`F, -$CellContext`A, -C, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "F", "C", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`F, -C, -$CellContext`B, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "F", "C", "A", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`F, -C, -$CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "F", "A", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`F, -$CellContext`A, -$CellContext`B, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "F", "B", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`F, -$CellContext`B, -$CellContext`A, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "F", "B", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`F, -$CellContext`B, -D, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "F", "A", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`F, -$CellContext`A, -D, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "F", "C", "D", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`F, -C, -D, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "F", "C", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`F, -C, -D, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "F", "A", "D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`F, -$CellContext`A, -D, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "F", "B", "D", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`F, -$CellContext`B, -D, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"A", "F", "D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`F, -D, -$CellContext`B, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"B", "F", "D", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`F, -D, -$CellContext`A, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"A", "F", "D", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`F, -D, -C, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"B", "F", "D", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, -$CellContext`F, -D, -C, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"C", "F", "D", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C, -$CellContext`F, -D, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"C", "F", "D", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`F, -D, -$CellContext`B, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "F", "A", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`F, -$CellContext`A, -$CellContext`B, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "F", "B", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`F, -$CellContext`B, -$CellContext`A, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "F", "A", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`F, -$CellContext`A, -C, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "F", "B", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`F, -$CellContext`B, -C, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"D", "F", "C", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, -$CellContext`F, -C, -$CellContext`A, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"D", "F", "C", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D, -$CellContext`F, -C, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "A", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`A, -$CellContext`B, -C, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "B", "A", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`B, -$CellContext`A, -C, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "A", "C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`A, -C, -$CellContext`B, -D],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "B", "C", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`B, -C, -$CellContext`A, -D],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "C", "A", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -C, -$CellContext`A, -$CellContext`B, -D],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "C", "B", "A", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -C, -$CellContext`B, -$CellContext`A, -D],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "A", "B", "D", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`A, -$CellContext`B, -D, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "B", "A", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`B, -$CellContext`A, -D, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "A", "C", "D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`A, -C, -D, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "B", "C", "D", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`B, -C, -D, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "C", "A", "D", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -C, -$CellContext`A, -D, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "C", "B", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -C, -$CellContext`B, -D, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "A", "D", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`A, -D, -$CellContext`B, -C],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "B", "D", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`B, -D, -$CellContext`A, -C],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "A", "D", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -$CellContext`A, -D, -C, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "B", "D", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`B, -D, -C, -$CellContext`A],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "C", "D", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -C, -D, -$CellContext`A, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "C", "D", "B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -C, -D, -$CellContext`B, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "D", "A", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -D, -$CellContext`A, -$CellContext`B, -C],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "D", "B", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -D, -$CellContext`B, -$CellContext`A, -C],
    
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "D", "A", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -D, -$CellContext`A, -C, -$CellContext`B],
    
    Editable->False], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "D", "B", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -D, -$CellContext`B, -C, -$CellContext`A],
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " ", " ", " "},
            {"F", "D", "C", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`F, -D, -C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", " "},
           {"F", "D", "C", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -D, -C, -$CellContext`B, -$CellContext`A],
    
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"22775ab0-5994-4811-b518-cd56287b183d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"4fbdedb6-0a97-4ce5-9fb4-af370ff22d47"],

Cell[BoxData["117"], \
"Output",ExpressionUUID->"601242f8-8082-4f4b-a5a2-6a68a7dd13f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"5", "!"}], "/", 
   RowBox[{"2", "!"}]}], "/", 
  RowBox[{
  "2", "!"}]}]], \
"Input",ExpressionUUID->"691a2bcf-7acc-4c76-912e-79eb8173ddbb"],

Cell[BoxData["30"], \
"Output",ExpressionUUID->"f3a893c5-8a02-421c-bcfb-671d7c0bdf36"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"1862ff4c-cac1-46b8-9214-50d8540fd64e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"51ddfb8d-d7b8-49d3-8c1e-51311db77223"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"ccc73fbe-ee62-49de-82b6-3390db3f7d99"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"2f3a7507-4c3a-4a6d-ab0b-cc319255acb2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"d8cbb30a-b41b-4b79-a995-f4f46ba76c00"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"58093c08-ed94-466d-abd7-66a880b34c41"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.3. (Index) Set, Rule, SetDelayed and RuleDelayed", \
"Subsection",ExpressionUUID->"19a6a570-8cf5-43a5-9d29-3a3d0f06c5fe"],

Cell[CellGroupData[{

Cell["10.3.0. Comments", \
"Subsubsection",ExpressionUUID->"64adabc9-a979-466c-80df-907e560682b7"],

Cell[TextData[{
 "Here we define functions that take care of the low level definition of \
rules and settings. There are two issues to worry about:\n\t- Consistency of \
indices between the LHS and RHS of the expressions.\n\t- Automatic change of \
dummies on the RHS, to avoid dummy conflicts, introducing a Module construct, \
as recommended by ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "."
}], "Text",ExpressionUUID->"fcd36bbb-25f5-42d1-9907-63b9adebc0d2"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.3.1. Hold attributes", \
"Subsubsection",ExpressionUUID->"d94be56e-206a-4d2c-83c1-410f85370fbc"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"01e1f2f8-fd55-4b54-a3eb-8c87981b7377"],

Cell[TextData[{
 "Before starting note that all values associated to a given symbol are \
internally defined using ",
 StyleBox["DelayedRule",
  FontWeight->"Bold"],
 " and ",
 StyleBox["HoldPattern",
  FontWeight->"Bold"],
 ":"
}], "Text",ExpressionUUID->"b4a287bf-0174-4a62-8e31-73e44d412f3c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"yyy", "=", "zzz"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xxx", "=", "yyy"}], 
  ";"}]}], "Input",ExpressionUUID->"a093855a-879b-47b8-b22d-29747d82e975"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OwnValues", "[", "xxx", 
  "]"}]], "Input",ExpressionUUID->"ef817a48-4748-4200-86c3-6c78e01aeffe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", "xxx", "]"}], "\[RuleDelayed]", "zzz"}], 
  "}"}]], "Output",ExpressionUUID->"ce5f15e0-1a7f-4ec2-a4fc-2bc46a7b9097"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"xxx", "=."}], "\[IndentingNewLine]", 
 RowBox[{"xxx", ":=", 
  "yyy"}]}], "Input",ExpressionUUID->"36931cba-dbd4-4a6e-924b-08a271686132"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OwnValues", "[", "xxx", 
  "]"}]], "Input",ExpressionUUID->"737b70fc-06b9-4ff2-bacf-221a7380de50"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", "xxx", "]"}], "\[RuleDelayed]", "yyy"}], 
  "}"}]], "Output",ExpressionUUID->"beab86c2-7a8e-465d-a1d3-73b0043e9cbb"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"xxx", "=."}], "\[IndentingNewLine]", 
 RowBox[{"yyy", "=."}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xxx", "[", "_", "]"}], "=", "yyy"}], 
  ";"}]}], "Input",ExpressionUUID->"466a3a3b-75ef-45a4-9f74-962e3a3dc517"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DownValues", "[", "xxx", 
  "]"}]], "Input",ExpressionUUID->"a8b4961b-5098-413f-b127-37fab57e433f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"xxx", "[", "_", "]"}], "]"}], "\[RuleDelayed]", "yyy"}], 
  "}"}]], "Output",ExpressionUUID->"8804b26f-819a-4cf0-acd5-6cc1b01e7825"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"xxx", "=."}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"yyy", "[", "xxx", "]"}], "^=", "zzz"}], 
  ";"}]}], "Input",ExpressionUUID->"a10aecf1-554a-4b72-b075-cd8c44bf888a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpValues", "[", "xxx", 
  "]"}]], "Input",ExpressionUUID->"8ac8d5e8-c094-42dc-afd7-d4a5a2d825a5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"yyy", "[", "xxx", "]"}], "]"}], "\[RuleDelayed]", "zzz"}], 
  "}"}]], "Output",ExpressionUUID->"97f03eee-8ea1-4ac2-8e29-b7a9463378ca"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"xxx", ",", "yyy", ",", "zzz"}], 
  "]"}]], "Input",ExpressionUUID->"b0303b8e-495d-4934-ba19-02fff55145a9"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"01a8dc80-1230-4dc4-915b-32207eaf536e"],

Cell["\<\
We shall follow that rule defining everything using delayed constructs. This \
is also very useful to arrange the replacement of dummy indices.\
\>", "Text",ExpressionUUID->"0ea78c6f-766f-4770-ad4b-cfc92973e260"],

Cell[TextData[{
 "Note also that ",
 StyleBox["Set",
  FontWeight->"Bold"],
 " and ",
 StyleBox["SetDelayed",
  FontWeight->"Bold"],
 " hold their first argument:"
}], "Text",ExpressionUUID->"70b8c9ae-7138-46b8-ab64-a0fee07143b5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "Set", 
  "]"}]], "Input",ExpressionUUID->"a6af6fc6-03ac-4a56-a836-42021bd9b23e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldFirst", ",", "Protected", ",", "SequenceHold"}], 
  "}"}]], "Output",ExpressionUUID->"177ee701-59dc-48c6-9c82-aec588fd1b7f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "SetDelayed", 
  "]"}]], "Input",ExpressionUUID->"7fc05e26-6a6f-4db2-ad98-49bbd21a1980"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldAll", ",", "Protected", ",", "SequenceHold"}], 
  "}"}]], "Output",ExpressionUUID->"b07fe9d7-a5ea-4e01-92ae-dbb3cf677d70"]
}, Open  ]],

Cell[TextData[{
 "but ",
 StyleBox["Rule",
  FontWeight->"Bold"],
 " and ",
 StyleBox["RuleDelayed",
  FontWeight->"Bold"],
 " do not hold their first argument:"
}], "Text",ExpressionUUID->"3fcbe37d-70d2-4f9a-a769-2ada0da56435"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "Rule", 
  "]"}]], "Input",ExpressionUUID->"06adfd35-ebaf-44f7-a3f8-0f05a4c0c99c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Protected", ",", "SequenceHold"}], 
  "}"}]], "Output",ExpressionUUID->"e527e81d-dc05-4dd0-9d69-09cfe0be955a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "RuleDelayed", 
  "]"}]], "Input",ExpressionUUID->"f291a639-14a4-4781-b488-9d11b0fa2239"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldRest", ",", "Protected", ",", "SequenceHold"}], 
  "}"}]], "Output",ExpressionUUID->"d1bc2c33-843c-4d75-89da-419d27411836"]
}, Open  ]],

Cell[TextData[{
 "That's why we must use ",
 StyleBox["HoldPattern",
  FontWeight->"Bold"],
 ":"
}], "Text",ExpressionUUID->"f989ce5c-d6fe-4709-ba5d-6c8fbae5788d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "HoldPattern", 
  "]"}]], "Input",ExpressionUUID->"00d2b74d-0378-48ec-a278-2a55638f2555"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldAll", ",", "Protected"}], 
  "}"}]], "Output",ExpressionUUID->"4c3c36ce-82dd-4a4b-a599-1e1b67efd6a3"]
}, Open  ]],

Cell["Note finally:", \
"Text",ExpressionUUID->"3286fc13-b15f-4c38-ab79-c21cc9b8c500"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "Block", 
  "]"}]], "Input",ExpressionUUID->"fcfc56d7-5b82-4894-a4cf-48e733f1bf5c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldAll", ",", "Protected"}], 
  "}"}]], "Output",ExpressionUUID->"16bc44a4-7dcb-43ee-9bed-be1153fda6a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "Module", 
  "]"}]], "Input",ExpressionUUID->"fc74f90d-82a7-4854-a7e6-262765f635d7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldAll", ",", "Protected"}], 
  "}"}]], "Output",ExpressionUUID->"af07cd69-6dc0-4c37-9174-091867ae16a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "With", 
  "]"}]], "Input",ExpressionUUID->"20eb11ec-dcbe-48e9-b5b7-2a16249dfa6f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldAll", ",", "Protected"}], 
  "}"}]], "Output",ExpressionUUID->"11b2ddf1-a292-4f64-a2a2-5684fa991db0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "RuleDelayed", 
  "]"}]], "Input",ExpressionUUID->"1cec45f9-712e-49c1-82cb-d366ae41a858"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"HoldRest", ",", "Protected", ",", "SequenceHold"}], 
  "}"}]], "Output",ExpressionUUID->"0cbf557e-4327-4f8d-b090-7253e36bb532"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["10.3.2. Three basic problems with tensor rules", \
"Subsubsection",ExpressionUUID->"59d4f70f-96a2-4eb2-a685-05cec7931aa4"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0642092c-63ab-4636-a0ab-4f14300311db"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"9dffe9d8-2dfb-4230-9608-f78422703156"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9091a3d7-db9c-4715-afb7-55c591c7ed1c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6be84555-ec41-4abd-8596-6bade3bc27a2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8511b630-e793-4aa5-b8df-83798f00e841"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0d45d7eb-497d-4817-952f-f5a162c75260"]
}, Open  ]],

Cell["\<\
Let us try to define rules among tensors from scratch. We shall use the \
example rule v^A goes to T^AB w_B.\
\>", "Text",ExpressionUUID->"0e25aab9-311d-4376-9128-45d724fae4ef"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"66586b65-796b-4995-b3cf-34e2d69b7bf3"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4c99375f-0555-4487-ba7b-cc18d9de5ccb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c07549b4-b181-44e6-8cee-ca45823dc414"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"540bbb80-2f3b-4909-aec4-a116de8b8385"]
}, Open  ]]
}, Open  ]],

Cell["First try:", \
"Text",ExpressionUUID->"b3608c53-0524-4513-9e55-867098d3b0ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rule1", "=", 
   RowBox[{
    RowBox[{"v", "[", "A_", "]"}], "\[RuleDelayed]", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"w", "[", 
      RowBox[{"-", "B"}], "]"}]}]}]}], 
  ";"}]], "Input",ExpressionUUID->"3fc7438e-fc6d-4e79-b0bc-ccd953ca80b6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "B", "]"}], "/.", 
  "rule1"}]], "Input",ExpressionUUID->"1dc2fe9a-73c9-4255-afb2-d4074e120f1d"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[-$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"2436da11-9da2-4d13-a66a-5bd357601982"]
}, Open  ]],

Cell[TextData[{
 "First problem: indices are repeated. Following ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " we use a ",
 StyleBox["Module",
  FontWeight->"Bold"],
 " construct. Second try:"
}], "Text",ExpressionUUID->"7cdcb9ac-2630-4a3f-b2d5-7d356ea3ccea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rule2", "=", 
   RowBox[{
    RowBox[{"v", "[", "A_", "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "B", "}"}], ",", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"A", ",", "B"}], "]"}], 
       RowBox[{"w", "[", 
        RowBox[{"-", "B"}], "]"}]}]}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"323b8647-fde0-49c9-8af5-ebf8e869bcda"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "B", "]"}], "/.", 
  "rule2"}]], "Input",ExpressionUUID->"6f41f068-07c7-4aa1-8334-5cc772094726"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "B$182765"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`B$182765],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {" "},
          {"B$182765"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[-$CellContext`B$182765],
   Editable->
    False]}]], "Output",ExpressionUUID->"99501119-0253-4eb0-90c4-fcd9a64654fa"]
}, Open  ]],

Cell["\<\
Dummy patterns on the left and dummies on the right must be different to \
avoid this problem:\
\>", "Text",ExpressionUUID->"3ae56d03-d1a8-487e-87c1-d2a839faeb14"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rule3", "=", 
   RowBox[{
    RowBox[{"v", "[", 
     RowBox[{"A_", ",", 
      RowBox[{"-", "A_"}]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "B"}], "}"}], ",", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"A", ",", 
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}]}], "]"}], 
       RowBox[{"w", "[", "B", "]"}]}]}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"ee5934ea-873a-4587-afad-b5d64a5e5bac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"C", ",", 
    RowBox[{"-", "C"}]}], "]"}], "/.", 
  "rule3"}]], "Input",ExpressionUUID->"fffcb0d6-7842-41c3-9027-123b14eb2f77"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"C$182766", " ", " "},
          {" ", "C$182766", "B$182766"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[C$182766, -C$182766, -$CellContext`B$182766],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {"B$182766"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[$CellContext`B$182766],
   Editable->
    False]}]], "Output",ExpressionUUID->"d9f4a5ee-9ce8-4af6-a2c9-cbcbd2ab79bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"B", ",", 
    RowBox[{"-", "B"}]}], "]"}], "/.", 
  "rule3"}]], "Input",ExpressionUUID->"7d5696f6-0709-457c-849f-a37dce73db9a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Module", "::", "dups"}], "MessageName"], ":", 
  " ", "\<\"Conflicting local variables \[NoBreak]\\!\\(B\\)\[NoBreak] and \
\[NoBreak]\\!\\(B$\\)\[NoBreak] found in local variable specification \
\[NoBreak]\\!\\({B, B$}\\)\[NoBreak]. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\
\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Module/dups\\\", ButtonNote -> \
\\\"Module::dups\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7249430c-c04e-4ef9-982d-57a475c4095a"],

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"B", ",", "B$"}], "}"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", " ", " "},
            {" ", "B", "B$"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B, -$CellContext`B, -$CellContext`B$],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"w", 
         StyleBox[GridBox[{
            {"B$"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[$CellContext`B$],
     Editable->False]}]}], 
  "]"}]], "Output",ExpressionUUID->"f05b091c-c160-43c3-a303-a0ee00844f3b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"v", ",", "T", ",", "w"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"0eee9df8-8680-4cad-acc9-ef5db97e1b8c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"c9cba2f2-f7f3-456e-abd3-28b813dacef0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"2328dc01-8ad6-4048-bf33-226442965c19"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"e20dd20f-6c45-434f-a400-0badb7ce4f72"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"a3581452-6239-486b-b403-8ac3595ac4a3"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"505074fa-b5ea-449b-b771-f1b3b99382a3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"0194b9fe-3799-4b45-af5e-603cf41b79bf"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"rule1", ",", "rule2", ",", "rule3"}], 
  "]"}]], "Input",ExpressionUUID->"20b72f75-935e-4c7b-b6ea-5f1b7e8c5962"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c9ff4dd5-daea-4531-b827-a28abb7d3579"],

Cell["\<\
---------------  Legacy code follows. Those two problems have been avoided \
simply by disallowing symbols having several different types. \
-----------------\
\>", "Text",ExpressionUUID->"43956e1e-60c7-433e-85b6-90b6e84a047a"],

Cell["\<\
Second problem: the same symbol can represent a tensor and an index. Let us \
replace v and w by A:\
\>", "Text",ExpressionUUID->"333e3fa4-0008-4af5-8496-64acde78c409"],

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"A", "[", "A", "]"}], ",", "M2"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"a2a0e607-7186-4c15-bcdb-e8d68836eae6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"rule4", "=", 
   RowBox[{
    RowBox[{"A", "[", "A_", "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "B", "}"}], ",", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"A", ",", "B"}], "]"}], 
       RowBox[{"A", "[", 
        RowBox[{"-", "B"}], "]"}]}]}], "]"}]}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"77b9ced1-f1cd-484d-bce4-ecce5cf39743"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"rule3\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "rule3", ", Context: ", "xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"e5ec744a-e42d-4dbc-91b8-b8ac57b0f048"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"A", "[", "B", "]"}], "/.", "rule4"}]], "Input",
 Evaluatable->False,ExpressionUUID->"e438ffe9-90b0-420b-a27e-3dea3914702e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"B", "[", 
   RowBox[{"-", "B$2014"}], "]"}], " ", 
  TagBox[
   SubsuperscriptBox["T", "\<\"  \"\>", "\<\"BB$2014\"\>"],
   Tensor]}]], "Output",ExpressionUUID->"93a28da0-d260-45b5-bfd0-3e539e785390"]
}, Open  ]],

Cell["\<\
That means that patterns cannot share symbols with anything else. We solve it \
using the function ReplacePatterns:\
\>", "Text",ExpressionUUID->"c2c7f447-a383-47ec-92f3-668fdfde6e3f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule5", "=", 
  RowBox[{"ReplacePatterns", "[", 
   RowBox[{
    RowBox[{"A", "[", "A_", "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "B", "}"}], ",", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"A", ",", "B"}], "]"}], 
       RowBox[{"A", "[", 
        RowBox[{"-", "B"}], "]"}]}]}], "]"}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"ef5d18dc-0aa7-458d-a456-cec0cd38863d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"rule4\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "rule4", ", Context: ", "xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"977da0f7-9aef-45d6-808a-0591a3b1c0b7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"A$P\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "A$P", ", Context: ", "xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"7eedf739-00db-4906-b376-9c522612b3f0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on \
Blank[].\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"3cdfaf33-2288-40bd-881b-8a8b3eece409"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on a \
pattern.\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"94a77125-109b-40d3-859d-d9250fe790cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on \
Blank[].\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"9be79469-fe56-43c5-b0ed-b9ac6a0bfc25"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(Validate :: \\\"warning\\\"\\) will be \
suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",ExpressionUUID->"7cb1857f-9b35-4df0-83b8-0a1281b031c5"],

Cell[BoxData[
 RowBox[{
  TagBox[
   SubsuperscriptBox["A", "\<\" \"\>", "\<\"\\!\\(A$P\\+_\\)\"\>"],
   Tensor], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "B", "}"}], ",", 
    RowBox[{
     TagBox[
      SubsuperscriptBox["T", "\<\"  \"\>", "\<\"A$PB\"\>"],
      Tensor], " ", 
     TagBox[
      SubsuperscriptBox["A", "\<\"B\"\>", "\<\" \"\>"],
      Tensor]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"403b9602-9e76-4133-b513-5f1f9988b77c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"A", "[", "B", "]"}], "/.", "rule5"}]], "Input",
 Evaluatable->False,ExpressionUUID->"8092e28c-ee5b-4227-8b6c-9ca99a67d5d0"],

Cell[BoxData[
 RowBox[{
  TagBox[
   SubsuperscriptBox["A", "\<\"B$2020\"\>", "\<\" \"\>"],
   Tensor], " ", 
  TagBox[
   SubsuperscriptBox["T", "\<\"  \"\>", "\<\"BB$2020\"\>"],
   Tensor]}]], "Output",ExpressionUUID->"df0410f3-cfc1-4b54-b8d2-716b2e9dfbbd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"A", "[", "B", "]"}], 
   RowBox[{"A", "[", 
    RowBox[{"-", "B"}], "]"}]}], "/.", "rule5"}]], "Input",
 Evaluatable->False,ExpressionUUID->"672f9845-b8b1-4b6f-ab0a-48c4aaf8f1ab"],

Cell[BoxData[
 RowBox[{
  TagBox[
   SubsuperscriptBox["A", "\<\"B$2021\"\>", "\<\" \"\>"],
   Tensor], " ", 
  TagBox[
   SubsuperscriptBox["A", "\<\"B$2022\"\>", "\<\" \"\>"],
   Tensor], " ", 
  TagBox[
   SubsuperscriptBox["T", "\<\"B \"\>", "\<\" B$2021\"\>"],
   Tensor], " ", 
  TagBox[
   SubsuperscriptBox["T", "\<\"  \"\>", "\<\"BB$2022\"\>"],
   Tensor]}]], "Output",ExpressionUUID->"76146a16-daf8-4a7e-896b-d8c76a93f74c"]
}, Open  ]],

Cell["\<\
Third problem: tensors and indices can share a symbol on the RHS:\
\>", "Text",ExpressionUUID->"d641d0c7-4f71-4a08-a787-3670b4ab0e54"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule6", "=", 
  RowBox[{"ReplacePatterns", "[", 
   RowBox[{
    RowBox[{"v", "[", "B_", "]"}], ":>", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "A", "}"}], ",", 
      RowBox[{"A", "[", 
       RowBox[{"B", ",", "A", ",", 
        RowBox[{"-", "A"}]}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"825cb9e8-5bb5-4442-9064-79e16c2c3883"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"rule5\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "rule5", ", Context: ", "xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"a93237e3-9ebf-4828-8bd5-62e0ee7140fb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"B$P\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "B$P", ", Context: ", "xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"e74acb21-6710-40a0-adcd-09ddf37eb941"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on \
Blank[].\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"ae82ffa6-7fa0-4252-b599-70811e0c40a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on a \
pattern.\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"63bf23d2-829f-46b2-ab8b-d94e23628683"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on \
Blank[].\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"574eb8f7-207e-47d1-9eef-a2a9fa8358aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(Validate :: \\\"warning\\\"\\) will be \
suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",ExpressionUUID->"3ebce1fe-44cf-4d27-b328-0c548fceda19"],

Cell[BoxData[
 RowBox[{
  TagBox[
   SubsuperscriptBox["v", "\<\" \"\>", "\<\"\\!\\(B$P\\+_\\)\"\>"],
   Tensor], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "A", "}"}], ",", 
    TagBox[
     SubsuperscriptBox["A", "\<\"  A\"\>", "\<\"B$PA \"\>"],
     Tensor]}], 
   "]"}]}]], "Output",ExpressionUUID->"0a4b28da-1373-45ec-8f1a-b552b9149abd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "C", "]"}], "/.", "rule6"}]], "Input",
 Evaluatable->False,ExpressionUUID->"bd884b22-eba0-4db5-ad53-c99bbf4184b7"],

Cell[BoxData[
 RowBox[{"A$2028", "[", 
  RowBox[{"C", ",", "A$2028", ",", 
   RowBox[{"-", "A$2028"}]}], 
  "]"}]], "Output",ExpressionUUID->"05e08bac-7922-4bcc-a77c-1d084d880c35"]
}, Open  ]],

Cell["We solve it using the function ReplaceDummiesInModule:", \
"Text",ExpressionUUID->"e28ec01a-15cb-4d00-808a-5e535950729f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule7", "=", 
  RowBox[{"ReplaceDummiesInModule", "[", 
   RowBox[{"ReplacePatterns", "[", 
    RowBox[{
     RowBox[{"v", "[", "B_", "]"}], ":>", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "A", "}"}], ",", 
       RowBox[{"A", "[", 
        RowBox[{"B", ",", "A", ",", 
         RowBox[{"-", "A"}]}], "]"}]}], "]"}]}], "]"}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"3ad0d818-1b63-488c-b603-9ac0204985e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"rule6\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "rule6", ", Context: ", "xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"0b22a8d4-6c32-457f-b148-43a0aca1554c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on \
Blank[].\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"77f99f2c-b3f6-41af-8179-7ac5c80a4df6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on a \
pattern.\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"f9fb7d7f-89ba-4623-af27-4475f01ab6b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "\<\"warning\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\!\\(\\\"up has been used on \
Blank[].\\\"\\),FontColor->RGBColor[0,0,1]]\\)\"\>"}]], \
"Message",ExpressionUUID->"b301a1a1-4968-48e7-a34e-cdd6ce3a3859"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], ":", 
  " ", "\<\"Further output of \\!\\(Validate :: \\\"warning\\\"\\) will be \
suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",ExpressionUUID->"1d2373aa-415d-4d51-aea5-cf8d2475364c"],

Cell[BoxData[
 RowBox[{
  TagBox[
   SubsuperscriptBox["v", "\<\" \"\>", "\<\"\\!\\(B$P\\+_\\)\"\>"],
   Tensor], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "A$D", "}"}], ",", 
    TagBox[
     SubsuperscriptBox["A", "\<\"  A$D\"\>", "\<\"B$PA$D \"\>"],
     Tensor]}], 
   "]"}]}]], "Output",ExpressionUUID->"f6ed43f9-3e5a-482d-af18-2a4e6eb60ced"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "C", "]"}], "/.", "rule7"}]], "Input",
 Evaluatable->False,ExpressionUUID->"3769f160-1a4f-428f-81c1-04e3a7554f75"],

Cell[BoxData[
 TagBox[
  SubsuperscriptBox["A", "\<\"  A$D$2035\"\>", "\<\"CA$D$2035 \"\>"],
  Tensor]], "Output",ExpressionUUID->"a4cd6efc-0d79-4f58-b1de-0f371ae5547a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "A", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"094a3f26-1aab-49c0-a247-885a5c685050"],

Cell["\<\
--------------------  Legacy code ends. ----------------------\
\>", "Text",ExpressionUUID->"86b4857d-dfaf-47e3-9288-8ce334fb2a2d"],

Cell["\<\
By elimination of the possibility of an index and an object sharing a symbol, \
we do not have to worry about problems 2 and 3. In particular, and this is \
very important, we do not have to introduce dollar-patterns.\
\>", "Text",ExpressionUUID->"e01e2932-7ba4-45e8-966f-6d5b8fa51ab7"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.3.3. New functions", \
"Subsubsection",ExpressionUUID->"3c540e99-66e2-45eb-96cc-766efacb5c50"],

Cell["\<\
Note that the four functions in this subsubsection work in very similar ways. \
Essentially we construct a temporal Module expression with the right rhs but \
an empty list of indices, and then replace the empty list with the list of \
dummies (the head must be changed from IndexList to List). We need to ensure \
that there are no pattern dummies on the LHS with the same name as dummies in \
the list of indices of the Module.\
\>", "Text",ExpressionUUID->"3ecfb9ad-dde3-4072-a0f9-72a33a118b0a"],

Cell["\<\
We need these short functions to detect conflicting dummies (those which are \
present both in the LHS and the RHS of the rules, and are patterns on the \
LHS), replacing them on the RHS. Note that we return the RHS wrapped in Hold \
to avoid evaluation.\
\>", "Text",ExpressionUUID->"64e92745-c5e7-4bb0-a0ff-735c6bbc37b6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", 
    RowBox[{"ConflictingDummies", ",", 
     RowBox[{"{", 
      RowBox[{"HoldAll", ",", "SequenceHold"}], "}"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "PINDEX", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConflictingDummies", "[", 
    RowBox[{"lhs_", ",", "rhs_"}], "]"}], ":=", 
   RowBox[{"Intersection", "[", 
    RowBox[{
     RowBox[{"PatternToIndex", "/@", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"FindDummyIndices", "[", "lhs", "]"}], ",", "PIndexQ"}], 
       "]"}]}], ",", 
     RowBox[{"FindDummyIndices", "[", "rhs", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ReplaceConflictingDummies", ",", 
    RowBox[{"{", 
     RowBox[{"HoldFirst", ",", "SequenceHold"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceConflictingDummies", "[", 
    RowBox[{"{", 
     RowBox[{"lhs_", ",", "rhs_"}], "}"}], "]"}], ":=", 
   RowBox[{"ReleaseHold", "@", 
    RowBox[{"ReplacePart", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"ReplaceConflictingDummies", "[", 
        RowBox[{"rhs", ",", 
         RowBox[{"ConflictingDummies", "[", 
          RowBox[{"lhs", ",", "rhs"}], "]"}]}], "]"}], "]"}], ",", 
      RowBox[{"ReplaceIsolated", "[", 
       RowBox[{"Hold", "[", "rhs", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", "1"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceConflictingDummies", "[", 
    RowBox[{"rhs_", ",", 
     RowBox[{"IndexList", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Hold", "[", "rhs", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceConflictingDummies", "[", 
    RowBox[{"rhs_", ",", "cdummies_IndexList"}], "]"}], ":=", 
   RowBox[{"ReplaceIndex", "[", 
    RowBox[{"rhs", ",", 
     RowBox[{"DuplicateRule", "@", 
      RowBox[{"Inner", "[", 
       RowBox[{"Rule", ",", "cdummies", ",", 
        RowBox[{"DummyAs", "/@", "cdummies"}], ",", "List"}], "]"}]}], ",", 
     "Hold"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d9d4eb34-6d14-41a8-b6a2-9112a88e6cfc"],

Cell["\<\
We also need to replace those indices on the rhs being isolated. Those are \
all indices in directions (Dir-indices, the direction of a Lie derivative and \
the vectors of Lie brackets) and scalars. Currently we act on those scalars \
inside Scalar, but not those in the arguments of scalar-functions.\
\>", "Text",ExpressionUUID->"8edbee63-6c5d-4246-9714-037e920d025b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ReplaceIsolated", ",", "replall"}], "}"}], ",", "HoldFirst"}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceIsolated", "[", "expr_", "]"}], ":=", 
   RowBox[{"MapOnIsolated", "[", 
    RowBox[{"expr", ",", "replall"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"replall", "[", "expr_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"inds", "=", 
        RowBox[{"FindFreeAndDummyIndices", "[", "expr", "]"}]}], ",", "frees",
        ",", "dummies"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"frees", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Rule", "[", 
          RowBox[{"#", ",", 
           RowBox[{"DummyAs", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
        RowBox[{"First", "[", "inds", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"dummies", "=", 
       RowBox[{"DuplicateRule", "/@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Rule", "[", 
            RowBox[{"#", ",", 
             RowBox[{"DummyAs", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
          RowBox[{"Last", "[", "inds", "]"}]}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ReplaceIndex", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"List", "@@", 
         RowBox[{"Join", "[", 
          RowBox[{"frees", ",", "dummies"}], "]"}]}]}], "]"}]}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bb08be73-7743-48c1-8d23-65ba397efab2"],

Cell["\<\
Once we have both sides of the equation in a safe state, then we construct a \
Module with the rhs and the list of new dummies. Note that we never evaluate \
the rhs expression. As pointed out by Thomas, we need to move into the Module \
list only abstract indices.\
\>", "Text",ExpressionUUID->"2253a097-ae4e-45e3-9e13-991c560bbae5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DropIndexBasis", "[", 
    RowBox[{"{", 
     RowBox[{"index_", ",", "basis_"}], "}"}], "]"}], ":=", "index"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DropIndexBasis", "[", "index_", "]"}], ":=", "index"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConstructModule", "[", 
    RowBox[{"Hold", "[", "rhs_", "]"}], "]"}], ":=", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", "}"}], ",", "rhs"}], "]"}], "]"}], ",", 
     RowBox[{"DropIndexBasis", "/@", 
      RowBox[{"(", 
       RowBox[{"List", "@@", 
        RowBox[{"FindDummyIndices", "[", "rhs", "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7cb7291e-6f08-43e7-9259-163fe4b2f024"],

Cell["\<\
Note finally that there are two calls to FindDummyIndices[rhs], but they are \
different. The first one happens in ConflictingDummies and gives the indices \
before replacement. The second one is in the final ConstructModule and gives \
the list of indices after being replaced. We could avoid the second one, but \
the code is safer this way.\
\>", "Text",ExpressionUUID->"934b9ae6-3b01-4e47-8096-05b7ae044315"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9073a48b-e262-47e0-b84f-a4ca90f6c8cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"2b7f838e-ceef-4776-b99b-2a4a9f859ba2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"97570b38-2767-413f-9dfc-4a427e280747"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f17ebabf-6eb3-406e-a644-a89cae7c41c6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6b4d426b-7bb6-4064-9b1b-d0923ebc3a84"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"026b6135-bd88-4a47-8399-debe2ff75827"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"5bc6961d-ad88-41f7-af64-bd1b371e1411"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b4ce4cde-588d-4a14-bae9-2ea5b2047b91"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"7844bfec-4336-409c-a737-dd3e03afe9a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"39d4665d-b40e-4762-8a13-ba2282057824"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "T", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", "[", "A_", "]"}], ":=", 
  RowBox[{"V", "[", "A", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "T", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"7496cb96-e0ab-4dd7-a253-1dcc934882d7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], ",", 
   RowBox[{"A", "\[Rule]", "B"}]}], 
  "]"}]], "Input",ExpressionUUID->"12beabf8-2da5-4d7c-baaa-b077fdacab5a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"V", 
      StyleBox[GridBox[{
         {"B"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`V[$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"004a570c-fee1-4aa3-8667-f4906fb9dfc4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceIndex", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], ",", 
   RowBox[{"A", "\[Rule]", "B"}], ",", "Hold"}], 
  "]"}]], "Input",ExpressionUUID->"a0c783ed-bc68-4eb9-9527-a18d9d474df9"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B],
   Editable->False], 
  "]"}]], "Output",ExpressionUUID->"3f282601-8ed7-48c4-a986-4addfd51c9fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ConflictingDummies", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A_Symbol", ",", 
     RowBox[{"-", "A_Symbol"}], ",", "B_Symbol"}], "]"}], ",", 
   RowBox[{
    RowBox[{"V", "[", 
     RowBox[{"A", ",", "C"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"V", "[", "B", "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"87222a7e-3f1b-4b41-a3f6-389082a40b92"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], "A", 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"9457c6b9-7de1-4108-85d7-95b52fe42e2f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ReplaceConflictingDummies", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A_Symbol", ",", 
      RowBox[{"-", "A_Symbol"}], ",", "B_Symbol"}], "]"}], ",", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"V", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], 
     RowBox[{"V", "[", "B", "]"}]}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"677e9809-9dff-47bc-9086-b4f341cb9147"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"G$185235", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`G$185235, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" ", " "},
           {"G$185235", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[-$CellContext`G$185235, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`B],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"0168f54e-6cf3-4ee0-9b8f-83e436b12ac1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ConstructModule", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"13d8596b-25a2-4091-a1ff-dad8c578f458"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"G$185235", ",", "C"}], "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"G$185235", "C"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[$CellContext`G$185235, C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {" ", " "},
             {"G$185235", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[-$CellContext`G$185235, -C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"B"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[$CellContext`B],
      Editable->False]}]}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"5a0e8c8b-1027-4921-99a8-72ae539f596f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "V"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"2c28a900-27fc-4d91-b295-9e49b0e4a518"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"3fef6f8c-59c8-4340-99d0-e656790a790e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"5332566f-b1bb-4792-b0d9-7b5172dac684"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"594c4e05-1c5a-4364-a075-3ee8903e17d9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"30890739-dc8f-4afe-a146-7b6569e23f5f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"c5939044-6e30-4199-8f0d-86e90e438419"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"76c0d9f1-2086-41ac-bcf1-1177dc5726e7"],

Cell[TextData[{
 StyleBox["IndexSetDelayed",
  FontWeight->"Bold"],
 " holds both LHS and RHS. Both go directly into the ",
 StyleBox["SetDelayed",
  FontWeight->"Bold"],
 " expression. We simply need to replace the RHS with the corresponding \
module:"
}], "Text",ExpressionUUID->"7b92c006-cc85-4d33-be36-91cc5dd8e216"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"IndexSetDelayed", ",", 
    RowBox[{"{", 
     RowBox[{"HoldAll", ",", "SequenceHold"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IndexSetDelayed", "[", 
   RowBox[{"lhs_", ",", "rhs_"}], "]"}], ":=", 
  RowBox[{"ReleaseHold", "@", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{"SetDelayed", "[", 
       RowBox[{"lhs", ",", "rhs"}], "]"}], "]"}], ",", 
     RowBox[{"ConstructModule", "[", 
      RowBox[{"ReplaceConflictingDummies", "[", 
       RowBox[{"{", 
        RowBox[{"lhs", ",", "rhs"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"686c1d56-8cd8-4cb1-98be-1e602d256c65"],

Cell[TextData[{
 StyleBox["IndexSet",
  FontWeight->"Bold"],
 " is identical to ",
 StyleBox["IndexSetDelayed",
  FontWeight->"Bold"],
 ", but the RHS is initially evaluated and returned:"
}], "Text",ExpressionUUID->"6b2b4f34-2b79-4849-ab6b-d3e3bbf8fcd1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"IndexSet", ",", 
    RowBox[{"{", 
     RowBox[{"HoldFirst", ",", "SequenceHold"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexSet", "[", 
    RowBox[{"lhs_", ",", "rhs_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"IndexSetDelayed", "[", 
      RowBox[{"lhs", ",", "rhs"}], "]"}], ";", "rhs"}], ")"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dedf4237-edcf-42df-a549-599883e19c17"],

Cell[TextData[{
 StyleBox["IndexRuleDelayed",
  FontWeight->"Bold"],
 " evaluates rhs at evaluation time. In the case that new dummies appear \
during the evaluation of the RHS, we shall assume that the objects being \
evaluated will worry about the new indices."
}], "Text",ExpressionUUID->"c9d17c3d-dafe-4bb2-aacd-1b4aa1447ee9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"IndexRuleDelayed", ",", 
    RowBox[{"{", 
     RowBox[{"HoldRest", ",", "SequenceHold"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRuleDelayed", "[", 
    RowBox[{"lhs_", ",", "rhs_"}], "]"}], ":=", 
   RowBox[{"ReleaseHold", "@", 
    RowBox[{"ReplacePart", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"RuleDelayed", "[", 
        RowBox[{
         RowBox[{"HoldPattern", "[", "lhs", "]"}], ",", "rhs"}], "]"}], "]"}],
       ",", 
      RowBox[{"ConstructModule", "[", 
       RowBox[{"ReplaceConflictingDummies", "[", 
        RowBox[{"{", 
         RowBox[{"lhs", ",", "rhs"}], "}"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f5ad0df9-77a4-4b8f-9216-19c7df478844"],

Cell[TextData[{
 StyleBox["IndexRule",
  FontWeight->"Bold"],
 " is identical to ",
 StyleBox["IndexRuleDelayed",
  FontWeight->"Bold"],
 " but evaluates its arguments initially:"
}], "Text",ExpressionUUID->"1c99d1b9-0915-45f0-a9ad-c39677494977"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"IndexRule", ",", "SequenceHold"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexRule", "[", 
    RowBox[{"lhs_", ",", "rhs_"}], "]"}], ":=", 
   RowBox[{"IndexRuleDelayed", "[", 
    RowBox[{"lhs", ",", "rhs"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cd666dad-9c43-4f45-b1d6-509e56755ebc"],

Cell["Graphical shortcuts:", \
"Text",ExpressionUUID->"b47ce499-2b24-458c-bf67-19b2748b09c6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DoubleRightTee", "=", "IndexSet"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RightTeeArrow", "=", "IndexRule"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d31dd601-da74-4746-b86f-02e7be1c2728"],

Cell[TextData[{
 "Precedences of ",
 StyleBox["DoubleRightTee",
  FontWeight->"Bold"],
 " and ",
 StyleBox["RightTeeArrow",
  FontWeight->"Bold"],
 " are too high. QUESTION: I do not know how to change this. Changing the \
output of the function Precedence does not work. Study the package Notation."
}], "Text",ExpressionUUID->"90f3299f-ea91-49f3-829c-64d15ec59ff9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precedence", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Unevaluated", "[", "DoubleRightTee", "]"}], ",", "IndexSet", ",",
     "Set"}], 
   "}"}]}]], "Input",ExpressionUUID->"8bbbcb69-0467-471c-af24-9c47f4b94fe0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"190.`", ",", "670.`", ",", "40.`"}], 
  "}"}]], "Output",ExpressionUUID->"417d87e8-20dd-407c-8671-8f0602167b67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precedence", "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Unevaluated", "[", "RightTeeArrow", "]"}], ",", "IndexRule", ",",
     "Rule"}], 
   "}"}]}]], "Input",ExpressionUUID->"eadefb89-ec3b-4de8-9372-7862864a8e8d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"270.`", ",", "670.`", ",", "120.`"}], 
  "}"}]], "Output",ExpressionUUID->"425fc19c-c38b-40d1-8d9a-2d4109862c7f"]
}, Open  ]],

Cell["\<\
Recall these precedences, and in particular note that Postfix has precedence \
80 in Math4 or 70 in Math5, just above that of Set. In Math4:\
\>", "Text",ExpressionUUID->"d43a49e7-1dda-4246-8cae-159d2d9b3228"],

Cell[BoxData[GridBox[{
   {
    RowBox[{"{", 
     RowBox[{
     "70.`", ",", "\"\<Set\>\"", ",", "\"\<SetDelayed\>\"", ",", 
      "\"\<UpSet\>\"", ",", "\"\<UpSetDelayed\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"80.`", ",", "\"\<Postfix\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"90.`", ",", "\"\<Function\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{
     "100.`", ",", "\"\<AddTo\>\"", ",", "\"\<DivideBy\>\"", ",", 
      "\"\<SubtractFrom\>\"", ",", "\"\<TimesBy\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{
     "110.`", ",", "\"\<ReplaceAll\>\"", ",", "\"\<ReplaceRepeated\>\""}], 
     "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"120.`", ",", "\"\<Rule\>\"", ",", "\"\<RuleDelayed\>\""}], 
     "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"130.`", ",", "\"\<Condition\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"140.`", ",", "\"\<Optional\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"160.`", ",", "\"\<Alternatives\>\""}], "}"}]},
   {
    RowBox[{"{", 
     RowBox[{"170.`", ",", "\"\<Repeated\>\"", ",", "\"\<RepeatedNull\>\""}], 
     "}"}]}
  },
  BaselinePosition->{Baseline, {1, 1}},
  GridBoxAlignment->{
   "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
    "RowsIndexed" -> {}}]], \
"Text",ExpressionUUID->"3270a083-dd93-4608-afab-0d2863e77abe"],

Cell["\<\
Now the symbols of equality and rules represent IndexSet, etc. Note that it \
is done only for StandarForm. Not used now:\
\>", "Text",ExpressionUUID->"1cdba131-fb81-481f-9775-2678dcdfbd09"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "\"\<=\>\"", ",", "y_"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}], ":=", 
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<IndexSet\>\"", ",", "\"\<[\>\"", ",", "x", ",", "\"\<,\>\"", ",", 
       "y", ",", "\"\<]\>\""}], "}"}], "]"}], ",", "StandardForm"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "\"\<:=\>\"", ",", "y_"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}], ":=", 
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<IndexSetDelayed\>\"", ",", "\"\<[\>\"", ",", "x", ",", "\"\<,\>\"",
        ",", "y", ",", "\"\<]\>\""}], "}"}], "]"}], ",", "StandardForm"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"x_", ",", 
       RowBox[{"\"\<->\>\"", "|", "\"\<\[Rule]\>\""}], ",", "y_"}], "}"}], 
     "]"}], ",", "StandardForm"}], "]"}], ":=", 
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<IndexRule\>\"", ",", "\"\<[\>\"", ",", "x", ",", "\"\<,\>\"", ",", 
       "y", ",", "\"\<]\>\""}], "}"}], "]"}], ",", "StandardForm"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"x_", ",", 
       RowBox[{"\"\<:>\>\"", "|", "\"\<\[RuleDelayed]\>\""}], ",", "y_"}], 
      "}"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<IndexRuleDelayed\>\"", ",", "\"\<[\>\"", ",", "x", ",", 
       "\"\<,\>\"", ",", "y", ",", "\"\<]\>\""}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]}], "Input",
 Evaluatable->False,ExpressionUUID->"77cc2643-60fc-45d3-b14a-38c3b81de77f"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.3.4. Examples", \
"Subsubsection",ExpressionUUID->"9c4072ec-52be-4c4b-9fcf-5b6dde56eef0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b9a19006-7acd-4b07-bc10-68b2c5d23400"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"44d859da-8a51-4a3a-98c7-c02300d9092f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f6f77a15-b920-48cd-8a49-fc827bd97e86"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f9ac89fe-8ec1-4738-98cc-a1fdfefc1155"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"3223bf3e-1dc3-441f-bd1e-059599fd6e14"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"52398aae-b96e-43fc-92f7-d4b4a70f5781"]
}, Open  ]],

Cell["Examples:", \
"Text",ExpressionUUID->"5d93b902-6334-40e1-8d54-a071916c9f07"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"6d6b1da9-e051-4831-92d5-33d56d6586da"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0b51812e-7e25-476c-8558-a030935fa052"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f384dc71-07cc-476d-bd61-7ac119846b65"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3d1fe069-c43a-4aa9-93a0-77cd9327c47d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"612a5a78-87cb-4190-9667-02f19bf15792"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Unprotect", "[", 
  RowBox[{"v", ",", "w"}], 
  "]"}]], "Input",ExpressionUUID->"82b552f1-2522-4920-b566-009825ffe939"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"v\"\>", ",", "\<\"w\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"c435bde6-d113-4c26-a5d5-133276ff0d57"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", 
   RowBox[{"-", "B_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "C", "}"}], ",", 
    RowBox[{"R", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}], ",", "C"}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"07ed6299-3f74-4fdd-809d-ea95112a1c88"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexRule", "[", 
  RowBox[{
   RowBox[{"v", "[", "A_", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"5e147137-dc42-4c66-a146-214e73874d73"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {
            UnderscriptBox["A", "_"]},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[
     Pattern[$CellContext`A, 
      Blank[]]],
    Editable->False], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"C$187543", ",", "B"}], "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"R", 
          StyleBox[GridBox[{
             {" ", " ", "C$187543"},
             {"B", "C$187543", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`R[-$CellContext`B, -C$187543, C$187543],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B],
      Editable->False]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"54ccd6bd-4344-48a5-9856-1f323e3add24"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"60da5e73-824a-4e37-be5f-9a7599528acf"],

Cell["\<\
HoldPattern[v[A_]] :> Module[{C$187543, B}, R[-B, -C$187543, C$187543]*T[A, \
B]]\
\>", "Output",ExpressionUUID->"af79a59d-e8f9-4253-920d-c79e8524fd6d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "B", "]"}], "/.", 
  "%"}]], "Input",ExpressionUUID->"ec3b11f7-8c69-4008-b9b8-489a04156c0a"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "C$187543$187544"},
          {"B$187544", "C$187543$187544", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B$187544, -C$187543$187544, C$187543$187544],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "B$187544"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`B$187544],
   Editable->
    False]}]], "Output",ExpressionUUID->"54b387bc-e563-4755-a2c3-cdf1a8a33745"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"5dca3b0f-6687-4a5d-8af4-f3a090a4888c"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "C"},
          {"A", "C", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`A, -C, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"aec0955c-5a14-42ad-8c19-fab69fc8630f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexRuleDelayed", "[", 
  RowBox[{
   RowBox[{"v", "[", "A_", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"7334d8bc-b3f0-4ee2-8d43-378b2bbf9a6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {
            UnderscriptBox["A", "_"]},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[
     Pattern[$CellContext`A, 
      Blank[]]],
    Editable->False], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "B", "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"w", 
          StyleBox[GridBox[{
             {" "},
             {"B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[-$CellContext`B],
      Editable->False]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"81983c48-8aab-474a-bb56-fcb38d8d92a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"b7e329f6-043d-4d12-bd98-4345ebe33412"],

Cell["HoldPattern[v[A_]] :> Module[{B}, T[A, B]*w[-B]]", \
"Output",ExpressionUUID->"5f6d7acb-2187-40b6-b52a-73db6d465dd8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "B", "]"}], "/.", 
  "%"}]], "Input",ExpressionUUID->"f238115a-4e87-4f18-b707-557316b3d757"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "C$187549"},
          {"B$187548", "C$187549", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B$187548, -C$187549, C$187549],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "B$187548"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`B$187548],
   Editable->
    False]}]], "Output",ExpressionUUID->"45cafc92-af6c-4e60-a137-65c770840912"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"8ffb1edc-eb40-45a6-9427-0877b4165899"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "C"},
          {"A", "C", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`A, -C, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"d94bbbfb-b186-4ba4-a279-01260ef8526c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexSet", "[", 
  RowBox[{
   RowBox[{"v", "[", "A_", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"867856b5-df4f-49e0-b23e-d3e38a375344"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "C$187552"},
          {"B", "C$187552", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B, -C$187552, C$187552],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"9d5d04bd-3f3c-47ff-a89a-cacbd9238ea3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}]}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"f0a70a0b-57b9-4613-9e2e-6571d8cacadb"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "D"},
          {"B", "D", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B, -D, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "F"},
          {"C", "F", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-C, -$CellContext`F, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"c49cec93-56f6-43a0-b636-495226b40a65"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"IndexSetDelayed", "[", 
  RowBox[{
   RowBox[{"v", "[", "A_", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"11de8907-d223-4b91-8962-de8dac7f333a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}]}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"a1ea3e0a-560b-4438-9c40-60937a0b6a67"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "D"},
          {"B", "D", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B, -D, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", "F"},
          {"C", "F", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-C, -$CellContext`F, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"a354ae37-c5a1-4ffd-9ee5-4fc59a1aaed8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "v"}]], "Input",ExpressionUUID->"88b47d2c-cfad-4595-b868-6a16cdf663a3"],

Cell[CellGroupData[{

Cell["Global`v", "Print", "PrintUsage",
 CellTags->
  "Info3578672733-5338953",ExpressionUUID->"2e4c9f3b-37df-49c6-b129-\
a3cfc1bd1e5c"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "v", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`v],
          Editable->False], "^=", "v"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "v", "]"}], "^=", "\<\"v\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "v", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "v", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["A", "_"]},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`v[
           Pattern[$CellContext`A, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "B", "}"}], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox[GridBox[{
                {"T", 
                 StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T[$CellContext`A, $CellContext`B],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"w", 
                 StyleBox[GridBox[{
                    {" "},
                    {"B"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`w[-$CellContext`B],
             Editable->False]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`v],
  Editable->False]], "Print",
 CellTags->
  "Info3578672733-5338953",ExpressionUUID->"49fc986c-9b3b-4e20-a4e3-\
e750bd344fa8"]
}, Open  ]]
}, Open  ]],

Cell["Conflicting dummies are repeated on the rhs:", \
"Text",ExpressionUUID->"adafbd2a-1c34-4afd-9997-861188a8f268"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexRule", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"A_", ",", 
     RowBox[{"-", "A_"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"w", "[", "B", "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"273efe2e-d6bd-4015-885c-b8fd9f21db98"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {
            UnderscriptBox["A", "_"], " "},
           {" ", 
            UnderscriptBox["A", "_"]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[
     Pattern[$CellContext`A, 
      Blank[]], -Pattern[$CellContext`A, 
       Blank[]]],
    Editable->False], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"G$187575", ",", "B"}], "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"G$187575", " ", " "},
             {" ", "G$187575", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`G$187575, -$CellContext`G$187575, \
-$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"w", 
          StyleBox[GridBox[{
             {"B"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[$CellContext`B],
      Editable->False]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"7f137267-232d-4cfc-ac00-191b507d32c8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexSet", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"A_", ",", 
     RowBox[{"-", "A_"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"w", "[", "B", "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"0b0f0b4a-9340-4576-a6b7-d0d72b1371e1"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, -$CellContext`A, -$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"294f7327-f752-43c1-9d62-8df995d8237a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", 
  RowBox[{"B", ",", 
   RowBox[{"-", "B"}]}], 
  "]"}]], "Input",ExpressionUUID->"f3a00eab-8b72-4a62-a45d-ac69e56dc091"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"G$187576$187577", " ", " "},
          {" ", "G$187576$187577", "B$187577"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`G$187576$187577, \
-$CellContext`G$187576$187577, -$CellContext`B$187577],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {"B$187577"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[$CellContext`B$187577],
   Editable->
    False]}]], "Output",ExpressionUUID->"115ea7d1-32bb-4a32-95c5-fa92be675c0f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"e51e28e2-ce87-4be7-ae59-9d1451756c52"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", " ", " "},
          {" ", "B", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, -$CellContext`B, -$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"fe29df68-9f9c-4e1d-adb8-d33bd713659e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"v", ",", "w", ",", "T", ",", "R"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"2953924a-9d1d-448d-957a-911ed88b8b01"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"0b967710-307f-46fe-94e4-e7ee8a8c2d03"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"8453fd42-90a3-4426-a22b-a8a7f53e3508"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"75f58a2a-036a-4025-931f-adfd4ae78b3e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"e384b755-5896-4f51-9a61-9ba529b73f7b"]
}, Open  ]]
}, Open  ]],

Cell["More examples:", \
"Text",ExpressionUUID->"9bc64825-6fce-4502-b503-740534bb961d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"15c7ea09-3cde-4ac6-a002-08a4c7581487"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"94cd194e-d18e-464b-bb39-fc770a95c307"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"08e1bb2d-9987-4e79-808d-ca04de0216d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3d1bab1a-9b72-4d25-814d-3e34180e1c71"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3a4653c2-58df-4df5-9ac1-37aebb512fa1"]
}, Open  ]]
}, Open  ]],

Cell["IndexSet:", \
"Text",ExpressionUUID->"5ac9beae-9616-4bc9-b324-9dc1f9c5e718"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Unprotect", "[", "w", 
  "]"}]], "Input",ExpressionUUID->"e94bd797-1bb5-4e20-bdb0-ddbdb9715e84"],

Cell[BoxData[
 RowBox[{"{", "\<\"w\"\>", 
  "}"}]], "Output",ExpressionUUID->"c924de71-fd12-45ea-a9ec-6bb6b7cee413"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", "A_", "]"}], "\[DoubleRightTee]", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"R", "[", 
    RowBox[{"-", "B"}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"282bf2f1-5bd0-42e9-903f-ed88e11740e5"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"044cfd65-1e5d-4e50-9698-c973693ae0b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "w"}]], "Input",ExpressionUUID->"72388029-0073-45f4-b3d8-7a76131e31b7"],

Cell[CellGroupData[{

Cell["Global`w", "Print", "PrintUsage",
 CellTags->
  "Info3578672736-5338953",ExpressionUUID->"884f9f8c-551e-41a5-b58a-\
a67e2c0a04e9"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "w", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`w],
          Editable->False], "^=", "w"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "w", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "w", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "w", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "w", "]"}], "^=", "\<\"w\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "w", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "w", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "w", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "w", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"w", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["A", "_"]},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`w[
           Pattern[$CellContext`A, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "B", "}"}], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox[GridBox[{
                {"R", 
                 StyleBox[GridBox[{
                    {" "},
                    {"B"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`R[-$CellContext`B],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"T", 
                 StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T[$CellContext`A, $CellContext`B],
             Editable->False]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`w],
  Editable->False]], "Print",
 CellTags->
  "Info3578672736-5338953",ExpressionUUID->"b52f80ce-11e4-42a8-8e63-\
f7dba178f814"]
}, Open  ]]
}, Open  ]],

Cell["\<\
If we define it again the rule gets replaced (even though it is exactly the \
same rule)\
\>", "Text",ExpressionUUID->"39f93ead-c0ac-4c09-92c9-e66c03253a1e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", "A_", "]"}], "\[DoubleRightTee]", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"R", "[", 
    RowBox[{"-", "B"}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"53d68f0a-9e74-4e5a-b314-6f54caefe12a"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"063241b5-69b3-4e31-be93-d1c5950ef6c6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "w"}]], "Input",ExpressionUUID->"b8336e19-11f2-46bf-8ce8-83f2aace0ec8"],

Cell[CellGroupData[{

Cell["Global`w", "Print", "PrintUsage",
 CellTags->
  "Info3578672738-5338953",ExpressionUUID->"85cc28cb-22cc-48d4-bb43-\
6ad5021609c1"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "w", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`w],
          Editable->False], "^=", "w"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "w", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "w", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "w", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "w", "]"}], "^=", "\<\"w\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "w", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "w", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "w", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "w", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"w", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["A", "_"]},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`w[
           Pattern[$CellContext`A, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "B", "}"}], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox[GridBox[{
                {"R", 
                 StyleBox[GridBox[{
                    {" "},
                    {"B"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`R[-$CellContext`B],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"T", 
                 StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T[$CellContext`A, $CellContext`B],
             Editable->False]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`w],
  Editable->False]], "Print",
 CellTags->
  "Info3578672738-5338953",ExpressionUUID->"e580285f-4a05-4bc8-b0f0-\
cda69b2a0a3a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"w", "[", "A", 
  "]"}]], "Input",ExpressionUUID->"43e15a8b-fa6b-419b-a074-9f19f5f8be3f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" "},
          {"B$187613"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B$187613],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B$187613"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B$187613],
   Editable->
    False]}]], "Output",ExpressionUUID->"bd9d5413-c02b-4e57-8dd4-450aad79abb2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"w", "[", "B", 
  "]"}]], "Input",ExpressionUUID->"df437e0c-3c54-4d00-b64d-3d8dd553caac"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" "},
          {"B$187614"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B$187614],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "B$187614"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`B$187614],
   Editable->
    False]}]], "Output",ExpressionUUID->"3d58b1fb-a6e9-4130-8564-b7d239c9565b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "v", "]"}], 
  ";"}]], "Input",ExpressionUUID->"ca6baeee-7100-4d72-8961-f1c6a8bb9669"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "A_", "]"}], "\[DoubleRightTee]", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"w", "[", 
    RowBox[{"-", "B"}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"50e8c69d-21fd-46cf-9d08-d8b590d44afd"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" "},
          {"B$187615"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B$187615],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B$187615"},
          {"B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, $CellContext`B$187615],
   Editable->
    False]}]], "Output",ExpressionUUID->"f02614fe-cd03-4d49-a54d-df9e99249ec7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "v"}]], "Input",ExpressionUUID->"9da5f6db-85cd-46f2-bf69-c18929c61539"],

Cell[CellGroupData[{

Cell["Global`v", "Print", "PrintUsage",
 CellTags->
  "Info3578672740-5338953",ExpressionUUID->"4fa0a371-b076-473b-a77b-\
9a7296f985d7"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "v", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`v],
          Editable->False], "^=", "v"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "v", "]"}], "^=", "\<\"v\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "v", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "v", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["A", "_"]},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`v[
           Pattern[$CellContext`A, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"B", ",", "B$187615"}], "}"}], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox[GridBox[{
                {"R", 
                 StyleBox[GridBox[{
                    {" "},
                    {"B$187615"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`R[-$CellContext`B$187615],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"T", 
                 StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T[$CellContext`A, $CellContext`B],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"T", 
                 StyleBox[GridBox[{
                    {" ", "B$187615"},
                    {"B", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T[-$CellContext`B, $CellContext`B$187615],
             Editable->False]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`v],
  Editable->False]], "Print",
 CellTags->
  "Info3578672740-5338953",ExpressionUUID->"5483e5f1-8382-4a51-af62-\
d700cc36fb1c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "A", "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"875ddaae-535a-467e-8347-b0a3ced975e1"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B"},
          {"C", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"a3073c17-5e7d-4b2f-a5aa-86b08383b1b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"aa", "\[DoubleRightTee]", 
  "b"}]], "Input",ExpressionUUID->"aca09f5c-3990-4b58-be9b-a674ce86377b"],

Cell[BoxData["b"], \
"Output",ExpressionUUID->"a5734600-9b66-4cfd-a39c-ee49a7e4e57b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "aa"}]], "Input",ExpressionUUID->"68a09048-c1d2-4ee3-b571-142213e95327"],

Cell[CellGroupData[{

Cell["Global`aa", "Print", "PrintUsage",
 CellTags->
  "Info3578672742-5338953",ExpressionUUID->"5ec2e3be-ef57-4908-940e-\
3ddd0d78122a"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{"aa", ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", "b"}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`aa],
  Editable->False]], "Print",
 CellTags->
  "Info3578672742-5338953",ExpressionUUID->"f8ad53ae-cd2a-46de-ae49-\
8b86c26f7d53"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", "aa", 
  "]"}]], "Input",ExpressionUUID->"1f53cb78-c9ac-43e4-b145-a376ec06bc9d"],

Cell["IndexRule:", \
"Text",ExpressionUUID->"72f4662a-e1d5-4d49-8d5d-ed30c2207e4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", "A_", "]"}], 
  "=."}]], "Input",ExpressionUUID->"9ac53855-999f-4feb-9330-6f05c35637af"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "[", "A_", "]"}], "\[RightTeeArrow]", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"w", "[", 
    RowBox[{"-", "B"}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"e8a69e8d-35bd-4472-b191-4acb2cc49217"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {
            UnderscriptBox["A", "_"]},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[
     Pattern[$CellContext`A, 
      Blank[]]],
    Editable->False], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "B", "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"w", 
          StyleBox[GridBox[{
             {" "},
             {"B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[-$CellContext`B],
      Editable->False]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"44e4dd82-83b6-41a3-ad3e-371c3c6efb19"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"aa", "\[RightTeeArrow]", 
  "b"}]], "Input",ExpressionUUID->"0c87444c-9f56-4290-a021-da7e7116886e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", "aa", "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "b"}], 
   "]"}]}]], "Output",ExpressionUUID->"63c5ff56-a887-42cf-ab14-9a1a168d34d2"]
}, Open  ]],

Cell["IndexSetDelayed:", \
"Text",ExpressionUUID->"2261a344-5c02-4c65-be11-2127a7bb1eac"],

Cell[BoxData[
 RowBox[{"IndexSetDelayed", "[", 
  RowBox[{
   RowBox[{"v", "[", "A_", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"84e812c7-a0ae-42b7-a5c4-075cfd2d4c6b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "v"}]], "Input",ExpressionUUID->"f9009d7c-655a-4168-ba63-f7983d0de4aa"],

Cell[CellGroupData[{

Cell["Global`v", "Print", "PrintUsage",
 CellTags->
  "Info3578672744-5338953",ExpressionUUID->"6ad5cf4c-8c12-44c2-82e3-\
9535c134e329"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "v", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`v],
          Editable->False], "^=", "v"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "v", "]"}], "^=", "\<\"v\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "v", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "v", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "v", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["A", "_"]},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`v[
           Pattern[$CellContext`A, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "B", "}"}], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox[GridBox[{
                {"T", 
                 StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T[$CellContext`A, $CellContext`B],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"w", 
                 StyleBox[GridBox[{
                    {" "},
                    {"B"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`w[-$CellContext`B],
             Editable->False]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`v],
  Editable->False]], "Print",
 CellTags->
  "Info3578672744-5338953",ExpressionUUID->"01025a93-c8a4-4c81-8482-\
b3a22ebba86f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "B", "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"503fa3fa-1cf1-4d0d-a41c-d4d6591257f5"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[-$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"044e9941-74df-4252-9528-f58afdd8eca6"]
}, Open  ]],

Cell["IndexRuleDelayed:", \
"Text",ExpressionUUID->"cd34132b-666a-49b1-96f6-0d1a4c681b53"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexRuleDelayed", "[", 
  RowBox[{
   RowBox[{"v", "[", "A_", "]"}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"7501ef15-cb4c-4119-8bb2-7dbb7a703ae0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {
             UnderscriptBox["A", "_"], "B$187653"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[
      Pattern[$CellContext`A, 
       Blank[]], $CellContext`B$187653],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"w", 
         StyleBox[GridBox[{
            {" "},
            {"B$187653"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[-$CellContext`B$187653],
     Editable->False]}], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "B", "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"w", 
          StyleBox[GridBox[{
             {" "},
             {"B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[-$CellContext`B],
      Editable->False]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"f4b98fd8-bec3-4d3b-b1ed-1dbbf3603b48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], "/.", "%"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"82b93459-515a-4c4a-8d99-bdbf51c77f9f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"w", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`w[-$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"d104a4bb-cf22-4447-abf5-88693abd29cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"295ac7a1-da58-4e7c-8c81-05b03704f694"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", ",", "w", ",", "v", ",", "R"}], 
  "}"}]], "Output",ExpressionUUID->"db632f23-3fbf-4030-ad8d-3db2e47924ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "w", ",", "v", ",", "R"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"653382b7-efdb-4308-85db-0a4ebc2139b7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"dc231c30-41e1-4b9d-9335-c8fe42afa12e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"8270634d-2679-4d01-a295-9bbbd6ede2db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"5e612d14-ce67-411b-ac72-b2e216c32c20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"d4390de1-23b2-4f42-bc3d-0d12705ff959"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"fde5c988-39d7-4490-899a-04a260340594"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"4f3b9a7a-e166-4f8c-b802-b8a298164f31"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"2bfe960d-4e34-4546-87b4-a7c26d1591eb"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"aa", ",", "b"}], 
  "]"}]], "Input",ExpressionUUID->"df665cd3-153b-4524-9aac-edecde3ab32a"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3c056f3e-a877-40a9-875f-65825acf63bb"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4. MakeRule", \
"Subsection",ExpressionUUID->"c6c7ab06-0c3e-4cc1-a516-18e50a58bbfb"],

Cell[CellGroupData[{

Cell["10.4.0. Comments", \
"Subsubsection",ExpressionUUID->"921bcf31-da9c-4c2b-80ca-0e91934ed4cc"],

Cell["\<\
Given a rule of the form {LHS, RHS} we proceed as follows:
\t0. We assume that there are no pattern-indices (neither indices nor heads), \
and this is checked.
\t    There can be dollar-indices. If they are to be patterns they will be \
replaced. Only pattern-indices are
\t    changed. On the RHS only free pattern-indices are changed, but not all \
dollar-indices for example.
\t1.- Analysis of LHS:
\t\t* indsLHS: all indices on the LHS. There can be up/down indices and \
dollars, but all ABSTRACT indices.
\t\t   Both members of pairs.
\t\t* indsRHS: all indices on the RHS. Idem.
\t\t* freesLHS: free indices on the LHS. There can be up/down indices and \
dollars.
\t\t* freesRHS: free indices on the RHS. Idem.
\t\t* symtensorsLHS: all tensors in the LHS whose symmetry is not trivial.
\t2.- Options:
\t\t* UseSymmetries: If True several rules will be generated, considering all \
possible equivalent
\t\t    configurations of indices. MakeRule is threaded over all \
possibilities using MakeRule1. Perhaps
\t\t    many rules are redundant.
\t\t* MetricOn: All, None or a list of indices on which we expect to be able \
to use a metric. There
\t\t    are two possibilities. If the index is free then on the LHS we accept \
both up/down indices and
\t\t    on the RHS we introduce an explicit metric tensor. If the index is a \
dummy on the LHS then we
\t\t    duplicate the rule with both up/down and down/up possibilities. The \
dummy can be identified
\t\t    both as A or -A.
\t\t* TestIndices: (currently Boolean)

In principle a rule involves certain indices in certain positions. If we want \
to have a rule that considers both up/down free cases we need to replace \
a_Symbol?VB`Q by a_?VB`pmQ on the LHS and then we need to add a metric g[a, \
a$] on the RHS. For dummies we need to introduce a PairQ pair, or either, \
duplicate the rule.\
\>", "Text",ExpressionUUID->"4aa7e3bc-1ad6-4501-8566-c621a6d4ca06"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeRule", "::", "terms"}], "=", 
   "\"\<There is more than one term on the LHS of rule.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeRule", "::", "inhom"}], "=", 
   "\"\<Inhomogeneous indices in rule: `1`, `2`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeRule", "::", "pats"}], "=", 
   "\"\<Patterns are not accepted on the `1` hand side of rule.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d0ee9508-a052-4aaa-a089-fcb5cee7e629"],

Cell["\<\
Recall the slots {index, free, metric, testindex, pattern, name}. There are \
four Booleans and hence five cases. We asumme at this point that index and \
name have the same up/down character:\
\>", "Text",ExpressionUUID->"20ec6fe6-c5fc-44d1-b9af-aa6d24acfbba"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4.1. Construction of patterns and manipulation of metrics", \
"Subsubsection",ExpressionUUID->"262c0b04-297f-4eb2-b27c-808e805cb054"],

Cell["\<\
1) Recall that given a rule between indices, DuplicateRule gives two rules \
with the second one being the the same rule for the opposite-character \
indices. This is only prepared for abstract indices because we change the \
name of a basis index using a rule for the corresponding abstract index:\
\>", "Text",ExpressionUUID->"872941c0-19f4-414c-bd7c-6586dd7dc6b1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "DuplicateRule"}]], \
"Input",ExpressionUUID->"f6f37884-ed57-468f-bf4e-a950debe04da"],

Cell[CellGroupData[{

Cell["xAct`xTensor`Private`DuplicateRule", "Print", "PrintUsage",
 CellTags->
  "Info3578672747-5338953",ExpressionUUID->"b8f01a07-d62b-4bf6-af40-\
ebe48f94780e"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DuplicateRule", "[", 
          RowBox[{"HoldPattern", "[", 
           RowBox[{"a_", "\[Rule]", "b_"}], "]"}], "]"}], ":=", 
         RowBox[{"Sequence", "[", 
          RowBox[{
           RowBox[{"a", "\[Rule]", "b"}], ",", 
           RowBox[{
            RowBox[{"ChangeIndex", "[", "a", "]"}], "\[Rule]", 
            RowBox[{"ChangeIndex", "[", "b", "]"}]}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DuplicateRule", "[", "list_List", "]"}], ":=", 
         RowBox[{"DuplicateRule", "/@", "list"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DuplicateRule", "[", "list_IndexList", "]"}], ":=", 
         RowBox[{"DuplicateRule", "/@", "list"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[xAct`xTensor`Private`DuplicateRule],
  Editable->False]], "Print",
 CellTags->
  "Info3578672747-5338953",ExpressionUUID->"32dc2681-24c8-4ed0-aa02-\
338f336194f1"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"344771e1-5038-4642-8266-8c0eb7e3e638"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`DuplicateRule", "[", 
  RowBox[{"a", "\[Rule]", 
   RowBox[{"-", "b"}]}], 
  "]"}]], "Input",ExpressionUUID->"04560ff1-b3ec-43a1-b721-f01560290539"],

Cell[BoxData[
 RowBox[{"Sequence", "[", 
  RowBox[{
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", "b"}]}], ",", 
   RowBox[{
    RowBox[{"-", "a"}], "\[Rule]", "b"}]}], 
  "]"}]], "Output",ExpressionUUID->"b398272e-3b67-4320-bcff-8ef0e3f5b4a4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f895e82d-1094-49a7-9b00-6448675c09ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", "\<\"b\"\>"}], "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"a", "b"}],
  Editable->
   False]], "Print",ExpressionUUID->"c2827446-e972-42ed-ad48-16c2b814ce31"]
}, Open  ]],

Cell[TextData[{
 "2) The function FormatIndexRule gives the form of the g-index in the final \
rule, depending on a number of options. Note that we use pattern and \
patternTest instead of Pattern and PatternTest to avoid ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " complaining about having patterns on the rhs of rules. Perhaps it would be \
possible to do this more elegantly using PatternIndex, but I'm not sure that \
is possible. The tests use the functions vbundle`Q and vbundle`pmQ and so \
they are valid only for abstract indices."
}], "Text",ExpressionUUID->"64c0ddad-a6b5-4fcf-b990-17a2ec95b54c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"A", " ", "non"}], "-", 
    RowBox[{"pattern", " ", "index", " ", "is", " ", "just", " ", "kept", " ", 
     RowBox[{"(", 
      RowBox[{"possibly", " ", "changing", " ", "name"}], ")"}]}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{
       "index_Symbol", ",", "_", ",", "_", ",", "_", ",", "False", ",", 
        "name_Symbol"}], "}"}], "]"}], ":=", 
     RowBox[{"DuplicateRule", "[", 
      RowBox[{"index", "\[Rule]", "name"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Non", "-", 
     RowBox[{"tested", " ", "pattern"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{
       "index_Symbol", ",", "_", ",", "_", ",", "False", ",", "True", ",", 
        "name_Symbol"}], "}"}], "]"}], ":=", 
     RowBox[{"DuplicateRule", "[", 
      RowBox[{"index", "\[Rule]", 
       RowBox[{"pattern", "[", 
        RowBox[{"name", ",", 
         RowBox[{"Blank", "[", "Symbol", "]"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Tested", " ", 
     RowBox[{
     "pattern", ".", " ", "Free", ".", " ", "Metric", ".", " ", 
      "DuplicateRule"}], " ", "not", " ", "needed"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{
       "index_Symbol", ",", "True", ",", "True", ",", "True", ",", "True", 
        ",", "name_Symbol"}], "}"}], "]"}], ":=", 
     RowBox[{"index", "\[Rule]", 
      RowBox[{"patternTest", "[", 
       RowBox[{
        RowBox[{"pattern", "[", 
         RowBox[{"name", ",", 
          RowBox[{"Blank", "[", "]"}]}], "]"}], ",", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"VBundleIndexPMQ", "[", 
          RowBox[{"VBundleOfIndex", "@", "index"}], "]"}]}]}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Tested", " ", 
      RowBox[{"pattern", ".", " ", "Dummy"}]}], ",", " ", 
     RowBox[{
      RowBox[{"or", " ", "free"}], "+", "nometric"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{
       "index_Symbol", ",", "_", ",", "_", ",", "True", ",", "True", ",", 
        "name_Symbol"}], "}"}], "]"}], ":=", 
     RowBox[{"DuplicateRule", "[", 
      RowBox[{"index", "\[Rule]", 
       RowBox[{"patternTest", "[", 
        RowBox[{
         RowBox[{"pattern", "[", 
          RowBox[{"name", ",", 
           RowBox[{"Blank", "[", "Symbol", "]"}]}], "]"}], ",", 
         RowBox[{"VBundleIndexQ", "[", 
          RowBox[{"VBundleOfIndex", "@", "index"}], "]"}]}], "]"}]}], "]"}]}],
     ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3ca20e0e-b2ac-42e3-85f5-7e971de86457"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"We", " ", "always", " ", "get", " ", "up"}], " ", "\[Rule]", " ", 
    RowBox[{"up", " ", "rules"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "index_"}], ",", "f_", ",", "m_", ",", "t_", ",", "p_", 
        ",", 
        RowBox[{"-", "name_Symbol"}]}], "}"}], "]"}], ":=", 
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{"index", ",", "f", ",", "m", ",", "t", ",", "p", ",", "name"}],
        "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Blocked", " ", "indices", " ", "get", " ", "name", " ", "0.", " ", 
     "Throw", " ", "error"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{"0", ",", "other__"}], "}"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"MakeRule", "::", "nouse"}], ",", "\"\<FormatIndexRule\>\"", 
        ",", "\"\<a blocked index\>\""}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Basis", " ", "indices", " ", "converted", " ", "to", " ", "basis", " ", 
     "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{"index_", ",", "other__"}], "}"}], "]"}], ":=", 
     RowBox[{"FormatIndexRule", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"IndexName", "[", "index", "]"}], ",", "other"}], "}"}], 
      "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f21701ab-0517-43d3-8a3b-502b4c293bda"],

Cell["The rules have been saved in the same order of definition.", \
"Text",ExpressionUUID->"ce03bfd4-30a6-4e57-b5f4-24c7294f90f6"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"6c1e4ce5-38b9-4cc6-8b84-c03d4a6b9174"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"9dc3f3f7-1d89-4564-8564-a1637c02737b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7a3d1f3d-02af-4b89-ba5a-4e67a41caafe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9e9a15f8-dc2a-4742-9074-6f01e2cbf15e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"3ac44262-27fb-4149-abcc-ac87e2cace54"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d11cc2cf-434e-4434-bbfb-4906e9a1acee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"f0ae3744-9d66-4786-a601-1e3f84d6ed03"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8bd5e159-d3ac-4a05-992f-ff7624dd8ccc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"749d14d2-6524-420c-924c-f18299f3b472"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
    RowBox[{"Symmetric", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
    RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"b0714e0f-0d63-43be-8ed3-4a921b8dc520"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f5a38a43-e327-4648-955a-9b6e534a704b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xUpSet", "[", 
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
   RowBox[{"{", "metricg", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"14246c63-6e4a-49c5-a6dc-3072a5bb6d05"],

Cell[BoxData[
 RowBox[{"{", "metricg", 
  "}"}]], "Output",ExpressionUUID->"79bbc493-82e3-4a68-9148-206da8e75ec8"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "metricg", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"metricg", "[", 
   RowBox[{"A_Symbol", ",", 
    RowBox[{"-", "B_Symbol"}]}], "]"}], ":=", 
  RowBox[{"delta", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"-", "A_Symbol"}], ",", "B_Symbol"}], "]"}], ":=", 
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "metricg", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"829597c6-effb-40f8-88a1-3aab0b0544e6"],

Cell["PINDEX.", "Text",ExpressionUUID->"9be93b82-736d-4dc5-a7bc-70c3bfca4509"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"xATP`FormatIndexRule", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", "True", ",", "True", ",", "True", ",", "True",
        ",", 
       RowBox[{"-", "B"}]}], "}"}], "]"}], "}"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"xATP`patternTest", "\[Rule]", "PatternTest"}], ",", 
     RowBox[{"xATP`pattern", "\[Rule]", "Pattern"}]}], "}"}]}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"bb7e2cd5-da96-4654-add4-3a5ee941d200"],

Cell["{A -> (B_)?TangentM2`pmQ}", \
"Output",ExpressionUUID->"4e00ef81-49fd-43f1-9ee0-ff39fa8f0e0e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"xATP`FormatIndexRule", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", "False", ",", "True", ",", "True", ",", 
       "True", ",", 
       RowBox[{"-", "B"}]}], "}"}], "]"}], "}"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"xATP`patternTest", "\[Rule]", "PatternTest"}], ",", 
     RowBox[{"xATP`pattern", "\[Rule]", "Pattern"}]}], "}"}]}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"064a63c1-5d1a-4e57-b1b8-a24185e61089"],

Cell["{A -> (B_Symbol)?TangentM2`Q, -A -> -(B_Symbol)?TangentM2`Q}", \
"Output",ExpressionUUID->"cbcdf045-6e33-4420-970c-4d3a3b5e0c4b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"xATP`FormatIndexRule", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "Polar"}]}], "}"}], ",", "True", ",", "True", ",", 
       "True", ",", "True", ",", 
       RowBox[{"-", "B"}]}], "}"}], "]"}], "}"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"xATP`patternTest", "\[Rule]", "PatternTest"}], ",", 
     RowBox[{"xATP`pattern", "\[Rule]", "Pattern"}]}], "}"}]}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"06254763-637f-4d59-be99-a0061ce55798"],

Cell["{A -> (B_)?TangentM2`pmQ}", \
"Output",ExpressionUUID->"c5b25017-f532-49d9-95f0-6f611d31dfb7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"xATP`FormatIndexRule", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "Polar"}]}], "}"}], ",", "False", ",", "True", ",", 
       "True", ",", "True", ",", 
       RowBox[{"-", "B"}]}], "}"}], "]"}], "}"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"xATP`patternTest", "\[Rule]", "PatternTest"}], ",", 
     RowBox[{"xATP`pattern", "\[Rule]", "Pattern"}]}], "}"}]}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"7713f75c-2637-4087-9fce-9a469dcab64f"],

Cell["{A -> (B_Symbol)?TangentM2`Q, -A -> -(B_Symbol)?TangentM2`Q}", \
"Output",ExpressionUUID->"bf0e3e76-8a34-4b6d-99c3-d90a55165ffb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "Polar", "]"}], 
  ";"}]], "Input",ExpressionUUID->"9f47c552-388f-4917-8d3c-a261c8bbb9fc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"131e6c85-194e-489f-8123-0741308b0cae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>", ",", "\<\"F\"\>", ",", "\<\"G\"\>",
      ",", "\<\"M2\"\>", ",", "\<\"metricg\"\>", ",", "\<\"T\"\>", 
     ",", "\<\"TangentM2\"\>", ",", "\<\"v\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "A", "B", "F", "G", "M2", "metricg", "T", "TangentM2", "v"}],
  Editable->
   False]], "Print",ExpressionUUID->"67aecea4-2c0e-420f-8fa6-3cf802978bef"]
}, Open  ]],

Cell["\<\
3) Duplication of rules for a free index. It is very important to see that \
the second argument (index) must have the correct up/down character. The \
metric factors that are added are always g[up, up] or g[down, down]. This \
function could be problematic on the LHS if there are indices which cannot be \
moved due to the action of non-firstmetric derivatives. That is, we are being \
careful on the RHS, but not on the LHS! The responsibility is here left to \
the user. The LHS and RHS of the rule are not held, though note that in those \
two cases in which the index is replaced in LHS and RHS, the expressions are \
evaluated only after replacement, and not before.\
\>", "Text",ExpressionUUID->"d0b4662e-27a0-466a-a01a-c7b19a174b6d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"HoldTimes", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "0", "]"}], ",", 
     RowBox[{"Hold", "[", "expr2_", "]"}]}], "]"}], ":=", 
   RowBox[{"Hold", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HoldTimes", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "expr1_", "]"}], ",", 
     RowBox[{"Hold", "[", "expr2_", "]"}]}], "]"}], ":=", 
   RowBox[{"Hold", "[", 
    RowBox[{"Times", "[", 
     RowBox[{"expr1", ",", "expr2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HoldTimes", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "expr1_", "]"}], ",", "1"}], "]"}], ":=", 
   RowBox[{"Hold", "[", "expr1", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldTimes", "[", 
     RowBox[{
      RowBox[{"Hold", "[", "expr1_", "]"}], ",", "expr2_"}], "]"}], ":=", 
    RowBox[{"Hold", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"expr1", ",", " ", "expr2"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"SPINOR", ".", " ", "free"}], " ", "and", " ", "dummy", " ", 
     "do", " ", "not", " ", "always", " ", "coincide", " ", "in", " ", 
     "character"}], ";", " ", 
    RowBox[{"hence", " ", "use", " ", "Hold"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"putmetric", "[", 
    RowBox[{"expr_Hold", ",", "metric_", ",", 
     RowBox[{"{", 
      RowBox[{"free_", ",", "dummy_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"HoldTimes", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"UpIndexQ", "[", "dummy", "]"}], ",", 
       RowBox[{"Hold", "[", 
        RowBox[{"metric", "[", 
         RowBox[{"free", ",", "dummy"}], "]"}], "]"}], ",", 
       RowBox[{"Hold", "[", 
        RowBox[{"metric", "[", 
         RowBox[{"dummy", ",", "free"}], "]"}], "]"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"36994fcf-a4d3-472d-aac8-24a53815734f"],

Cell["\<\
The If in putmetric cares about index positioning for antisymmetric metrics \
(spinor theory). It is irrelevant for symmetric metrics.\
\>", "Text",ExpressionUUID->"d21a6ed2-17be-4273-ab01-9021f3561021"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"duplicateRuleforfree", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"LHS_Hold", "\[Rule]", "RHS_Hold"}], "]"}], ",", "index_"}], 
    "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LHS", "\[Rule]", "RHS"}], ",", 
     RowBox[{
      RowBox[{"ReplaceIndex", "[", 
       RowBox[{"LHS", ",", 
        RowBox[{"index", "\[Rule]", 
         RowBox[{"-", "index"}]}]}], "]"}], "\[Rule]", " ", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyAs", "[", "index", "]"}]}], "}"}], ",", 
        RowBox[{"putmetric", "[", 
         RowBox[{
          RowBox[{"ReplaceIndex", "[", 
           RowBox[{"RHS", ",", 
            RowBox[{"index", "\[Rule]", "dummy"}]}], "]"}], ",", 
          RowBox[{"FirstMetricOfVBundle", "[", 
           RowBox[{
            RowBox[{"VBundleOfIndex", "[", "index", "]"}], ",", "True"}], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "index"}], ",", 
            RowBox[{"-", "dummy"}]}], "}"}]}], "]"}]}], "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"duplicateRuleforfree", "[", 
   RowBox[{"list_List", ",", "index_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"duplicateRuleforfree", "[", 
      RowBox[{"#", ",", "index"}], "]"}], "&"}], "/@", "list"}], 
   "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0611b1e5-d93a-418f-8f3c-254e019f60b8"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"06d390ee-4f34-4178-8c6a-738a87d7aa5f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`duplicateRuleforfree", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", "D"}], "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], "]"}], "\[Rule]", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}], " ", 
       RowBox[{"v", "[", "C$", "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", "D"}], "]"}]}], "]"}]}], ",", "D"}], "]"}],
   "//", "InputForm"}]], \
"Input",ExpressionUUID->"d455ff78-19ed-4525-8ba3-a63ca4bc444a"],

Cell["\<\
{Hold[T[F, -F, -A$, C$, D]*v[-C$]] -> Hold[v[-C$]*v[C$]*v[-A$, D]], Hold[T[F, \
-F, -A$, C$, -D]*v[-C$]] -> 
  Hold[(v[-C$]*v[C$]*v[-A$, G$189971])*metricg[-G$189971, -D]]}\
\>", "Output",ExpressionUUID->"b23152d5-0075-4ee7-ab8e-4cdaf22a1ee1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`duplicateRuleforfree", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], "]"}], "\[Rule]", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}], " ", 
       RowBox[{"v", "[", "C$", "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"-", "D"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"a2a359f4-dda7-468a-9091-07dc60930658"],

Cell["\<\
{Hold[T[F, -F, -A$, C$, -D]*v[-C$]] -> Hold[v[-C$]*v[C$]*v[-A$, -D]], 
 Hold[T[F, -F, -A$, C$, D]*v[-C$]] -> Hold[(v[-C$]*v[C$]*v[-A$, \
-G$189972])*metricg[D, G$189972]]}\
\>", "Output",ExpressionUUID->"e52a1f87-abca-4b5d-b4c9-da22485254be"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"04f1991f-fcba-4cb1-a7b2-2d5f6b4c5a06"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"A$\"\>", ",", "\<\"G$189971\"\>", ",", "\<\"G$189972\"\>"}], 
    "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {"A$", "G$189971", "G$189972"}],
  Editable->
   False]], "Print",ExpressionUUID->"27bfbcb8-f5c5-4123-9686-f69cea731af0"]
}, Open  ]],

Cell["\<\
4) The function duplicateRulefordummy changes an up-down pair of dummies by \
the corresponding down-up pair. The change on the LHS could produce undesired \
evaluations, or even wrong expressions if we have non-firstmetric \
derivatives. David has detected a problem when the LHS is a metric because \
under the index shift it is converted into a delta. Much time later... Cyril \
has found again the same problem.\
\>", "Text",ExpressionUUID->"e0ee73d7-e045-4cbb-b6d9-cf09dfc36f9d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"duplicateRulefordummy", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"LHS_Hold", "\[Rule]", "RHS_Hold"}], "]"}], ",", "index_"}], 
    "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sign", "=", 
       RowBox[{"SymmetryOfMetric", "@", 
        RowBox[{"FirstMetricOfVBundle", "[", 
         RowBox[{
          RowBox[{"VBundleOfIndex", "[", "index", "]"}], ",", "True"}], 
         "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"LHS", "\[Rule]", "RHS"}], ",", 
       RowBox[{
        RowBox[{"ReplaceIndex", "[", 
         RowBox[{"LHS", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"index", "\[Rule]", 
             RowBox[{"-", "index"}]}], ",", 
            RowBox[{
             RowBox[{"-", "index"}], "\[Rule]", "index"}]}], "}"}]}], "]"}], 
        "\[Rule]", 
        RowBox[{"HoldTimes", "[", 
         RowBox[{"RHS", ",", "sign"}], "]"}]}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"duplicateRulefordummy", "[", 
   RowBox[{"list_List", ",", "index_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"duplicateRulefordummy", "[", 
      RowBox[{"#", ",", "index"}], "]"}], "&"}], "/@", "list"}], 
   "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"181f3a7d-490d-4463-adf6-58a3666e816b"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0135e72a-bf07-4994-bb70-24f25f8accd0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"xATP`SymmetryOfMetric", "[", "metricg", "]"}], ",", "1"}], "]"}],
   ";"}]], "Input",ExpressionUUID->"7fd175e7-cad2-418d-a0b0-34cf8427de33"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`duplicateRulefordummy", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"T", "[", 
        RowBox[{"A", ",", 
         RowBox[{"-", "A"}]}], "]"}], "]"}], "\[Rule]", 
      RowBox[{"Hold", "[", 
       RowBox[{
        RowBox[{"T", "[", "A", "]"}], 
        RowBox[{"v", "[", 
         RowBox[{"-", "A"}], "]"}]}], "]"}]}], "}"}], ",", "A"}], "]"}], "//",
   "InputForm"}]], \
"Input",ExpressionUUID->"f903d4b5-5d3a-4304-b7af-7b521eb54e69"],

Cell["\<\
{Hold[T[A, -A]] -> Hold[T[A]*v[-A]], Hold[T[-A, A]] -> Hold[T[A]*v[-A]]}\
\>", "Output",ExpressionUUID->"cd723bc0-f3c2-464e-9718-13cb6302a500"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9bd9a275-2f13-4c3d-beab-5ea5d8ca7782"],

Cell["\<\
5) Here we introduce metric factors with one up-index and then another index \
that can be up or down. This can be problematic because an up-down or down-up \
metric factor will be automatically transformed into a delta factor! We avoid \
that by temporarily wrapping the metric with Hold. Its content must be \
constructed using With:\
\>", "Text",ExpressionUUID->"5a7ef0f5-11fd-4f0b-9fe6-471b0e267015"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"changeRuleforfreepmQ", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"LHS_Hold", "\[Rule]", "RHS_Hold"}], "]"}], ",", "index_"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"ReplaceIndex", "[", 
     RowBox[{"LHS", ",", 
      RowBox[{"index", "\[Rule]", 
       RowBox[{"UpIndex", "[", "index", "]"}]}]}], "]"}], "\[Rule]", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dummy", "=", 
        RowBox[{"DummyAs", "[", "index", "]"}]}], "}"}], ",", 
      RowBox[{"putmetric", "[", 
       RowBox[{
        RowBox[{"ReplaceIndex", "[", 
         RowBox[{"RHS", ",", 
          RowBox[{"index", "\[Rule]", "dummy"}]}], "]"}], ",", 
        RowBox[{"FirstMetricOfVBundle", "[", 
         RowBox[{
          RowBox[{"VBundleOfIndex", "[", "index", "]"}], ",", "True"}], "]"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"UpIndex", "[", "index", "]"}], ",", 
          RowBox[{"-", "dummy"}]}], "}"}]}], "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changeRuleforfreepmQ", "[", 
    RowBox[{"list_List", ",", "index_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"changeRuleforfreepmQ", "[", 
       RowBox[{"#", ",", "index"}], "]"}], "&"}], "/@", "list"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7754db83-1684-492c-9d70-49af734d64a2"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"1cf8b40c-635c-4867-916b-8d2ec0337c73"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`changeRuleforfreepmQ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", "D"}], "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], "]"}], "\[Rule]", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}], " ", 
       RowBox[{"v", "[", "C$", "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", "D"}], "]"}]}], "]"}]}], ",", "D"}], "]"}],
   "//", "InputForm"}]], \
"Input",ExpressionUUID->"dbba84a9-c4f3-48cd-afa1-3a993d5edd61"],

Cell["\<\
Hold[T[F, -F, -A$, C$, D]*v[-C$]] -> Hold[(v[-C$]*v[C$]*v[-A$, \
G$189974])*metricg[-G$189974, D]]\
\>", "Output",ExpressionUUID->"cb18021e-02b5-4796-93a8-4fe509a6ca10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`changeRuleforfreepmQ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], "]"}], "\[Rule]", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}], " ", 
       RowBox[{"v", "[", "C$", "]"}], " ", 
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"-", "D"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"bd4c0b20-b154-4ee6-ad3a-aa1a6a1ea779"],

Cell["\<\
Hold[T[F, -F, -A$, C$, D]*v[-C$]] -> Hold[(v[-C$]*v[C$]*v[-A$, \
-G$189975])*metricg[D, G$189975]]\
\>", "Output",ExpressionUUID->"432c9d04-fb2a-4399-93ae-bd5487ba17ca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "/@", 
  "$Tensors"}]], \
"Input",ExpressionUUID->"c4e7c848-9a5f-4e8e-9ed9-c9bacbe5df6c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"bceaa112-f6a3-4414-9422-e59c13cebe48"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"04f202e4-956d-4a59-8ab2-47cd078d1da2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"07a69aa7-89dc-4e5d-bda5-04fc932320f0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Null", ",", "Null", ",", "Null"}], 
  "}"}]], "Output",ExpressionUUID->"111287fc-593e-4660-a42d-64a9ca6d7711"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"a0e5ebe8-0b8a-4b20-a0d1-796c0244d630"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"06ef4b78-76cb-4a2b-90dd-fc74215f9fb2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"e7bf5659-5a64-4c35-8a4e-afec4fa02833"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0ba62e4f-21d0-4620-8c1f-a5a92544bdf3"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4.2. MakeRule", \
"Subsubsection",ExpressionUUID->"abe54c51-cada-47b2-8c65-dbcedf723df2"],

Cell[TextData[{
 "This is probably the most complicated function in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", at least after ToCanonical. Currently we do not use IndexList in this \
function: it is immediately removed from the output of the FindIndices \
functions and later reintroduced to fit the input format of ",
 "TakeEPairs",
 " and SymmetryEquivalentsOfTensor. The function works in two steps: first \
(part B) we manipulate the indices of the LHS and RHS of the rule, creating a \
number of replacement rules for the indices; then (part C) we apply those \
replacement rules to the indices and construct the final rules. The former \
seems pretty safe, but not the latter. Essentially we should ensure that the \
expressions are never evaluated."
}], "Text",ExpressionUUID->"18013813-99f9-4d72-8bf2-0b7cbffa17b4"],

Cell["\<\
Problems:
\t- Though the function has attribute HoldFirst, this is not kept during the \
construction of the rule. For instance, there are several functions which \
evaluate the LHS, like  ReplaceDummies, ListOfTerms. The list symtensorsLHS \
is also evaluated after construction. Problems:
\t\t- Checks LHS === 0 and RHS===0
\t\t- Check ListOfTerms[LHS] > 1
\t\t- The ouptut of FindAllOfType gives tensors which are evaluated. This \
propagates through symtensorsLHS
\t- The rhs can be very complicated, but the lhs cannot be complicated \
because the same trick of multiplying metric factors doesn't work on the lhs. \
For example if we have a partial derivative on the lhs then it is not \
possible to move indices inside.
\t- There are three important things which are difficult to implement here: \
daggers, basis-indices and non-metric derivatives.\
\>", "Text",ExpressionUUID->"14cf72da-a767-4b56-bd3f-b3ecb13d269f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MakeRule", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"PatternIndices", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TestIndices", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MetricOn", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
     RowBox[{"UseSymmetries", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Verbose", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ContractMetrics", "\[Rule]", "False"}]}], "\[IndentingNewLine]",
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"MakeRule", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"LHS_", ",", "RHS_", ",", "conditions___"}], "}"}], ",", 
    RowBox[{"options", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"HeldLHS", "=", 
       RowBox[{"Hold", "[", "LHS", "]"}]}], ",", 
      RowBox[{"HeldRHS", "=", 
       RowBox[{"Hold", "[", "RHS", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Unblocked", " ", "indices"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"indsLHS", "=", 
         RowBox[{"List", "@@", 
          RowBox[{"TakeEIndices", "[", 
           RowBox[{"FindIndices", "[", "HeldLHS", "]"}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"freesLHS", "=", 
         RowBox[{"List", "@@", 
          RowBox[{"TakeEIndices", "[", 
           RowBox[{"FindFreeIndices", "[", "HeldLHS", "]"}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"indsRHS", "=", 
         RowBox[{"List", "@@", 
          RowBox[{"TakeEIndices", "[", 
           RowBox[{"FindIndices", "[", "HeldRHS", "]"}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"freesRHS", "=", 
         RowBox[{"List", "@@", 
          RowBox[{"TakeEIndices", "[", 
           RowBox[{"FindFreeIndices", "[", "HeldRHS", "]"}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", "patindsLHS", ",", "ti", ",", "mo", ",", "us", 
        ",", "verb", ",", "contr", ",", "\[IndentingNewLine]", "indsLHSinfo", 
        ",", "\[IndentingNewLine]", "oldinds", ",", "newinds", ",", "pmQinds",
         ",", "pairs", ",", "\[IndentingNewLine]", "dupfreemetric", ",", 
        "\[IndentingNewLine]", "rulesLHS", ",", "\[IndentingNewLine]", 
        "symtensorsLHS", ",", "\[IndentingNewLine]", 
        RowBox[{"newHeldLHS", "=", 
         RowBox[{"ReplaceIsolated", "[", "HeldLHS", "]"}]}], ",", "newLHSs", 
        ",", "\[IndentingNewLine]", 
        RowBox[{"newHeldRHS", "=", 
         RowBox[{"ReplaceDummies", "[", "HeldRHS", "]"}]}], ",", "newRHSs", 
        ",", "\[IndentingNewLine]", "rules", ",", "conds"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Options", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "patindsLHS", ",", "ti", ",", "mo", ",", "us", ",", "verb", ",", 
          "contr"}], "}"}], "=", 
        RowBox[{"OptionValue", "[", 
         RowBox[{"{", 
          RowBox[{
          "PatternIndices", ",", "TestIndices", ",", "MetricOn", ",", 
           "UseSymmetries", ",", "Verbose", ",", "ContractMetrics"}], "}"}], 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"**", 
         RowBox[{"*", " ", 
          RowBox[{"A", ".", " ", "Checks"}]}]}], " ", "****)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Or", "@@", 
          RowBox[{"(", 
           RowBox[{"PIndexQ", "/@", "indsLHS"}], ")"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MakeRule", "::", "pats"}], ",", "\"\<left\>\""}], 
           "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Or", "@@", 
          RowBox[{"(", 
           RowBox[{"PIndexQ", "/@", "indsRHS"}], ")"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MakeRule", "::", "pats"}], ",", "\"\<right\>\""}], 
           "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"LHS", "===", "0"}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MakeRule", "::", "error"}], ",", 
            "\"\<LHS of rule evaluates to zero.\>\""}], "]"}], "]"}]}], "]"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Sort", "@", "freesLHS"}], ")"}], "=!=", 
           RowBox[{"(", 
            RowBox[{"Sort", "@", "freesRHS"}], ")"}]}], "&&", 
          RowBox[{"RHS", "=!=", "0"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MakeRule", "::", "inhom"}], ",", "freesLHS", ",", 
            "freesRHS"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "@", 
           RowBox[{"ListOfTerms", "[", "LHS", "]"}]}], ">", "1"}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{"MakeRule", "::", "terms"}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"**", 
         RowBox[{"*", " ", 
          RowBox[{"B", ".", " ", "Construct"}], " ", "indsLHSinfo"}]}], " ", 
        "****)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "0.", " ", "Convert", " ", "LHS", " ", "inds", " ", "to", " ", 
         "names"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"indsLHS", "=", 
        RowBox[{"IndexName", "/@", "indsLHS"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"freesLHS", "=", 
        RowBox[{"IndexName", "/@", "freesLHS"}]}], ";", "\[IndentingNewLine]",
        "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "1.", " ", "Name", " ", "of", " ", "index", " ", "in", " ", "input", 
         " ", "rule"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"indsLHSinfo", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"indsLHS", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"2.", " ", "Free", " ", "character"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"indsLHSinfo", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"freesLHS", ",", 
              RowBox[{"First", "@", "#"}]}], "]"}]}], "]"}], "&"}], "/@", 
         "indsLHSinfo"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"3.", " ", 
         RowBox[{
          RowBox[{"MetricOn", ".", " ", "up"}], "/", "down"}], " ", 
         "character", " ", "in", " ", "mo", " ", "is", " ", "corrected"}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"mo", "=", 
        RowBox[{"Switch", "[", 
         RowBox[{"mo", ",", "\[IndentingNewLine]", "None", ",", 
          RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "All", ",", 
          "indsLHS", ",", "\[IndentingNewLine]", "_List", ",", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"mo", "~", "Join", "~", 
             RowBox[{"(", 
              RowBox[{"ChangeIndex", "/@", "mo"}], ")"}]}], ",", "indsLHS"}], 
           "]"}], ",", "\[IndentingNewLine]", "_", ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeRule", "::", "unknown"}], ",", "\"\<indices\>\"", 
             ",", "mo"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"indsLHSinfo", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{"mo", ",", 
               RowBox[{"First", "@", "#"}]}], "]"}], "&&", 
             RowBox[{"MetricEndowedQ", "@", 
              RowBox[{"VBundleOfIndex", "@", 
               RowBox[{"First", "@", "#"}]}]}]}]}], "]"}], "&"}], "/@", 
         "indsLHSinfo"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Warning", " ", "if", " ", "there", " ", "are", " ", "non"}],
          "-", 
         RowBox[{
         "metric", " ", "derivatives", " ", "on", " ", "the", " ", "LHS"}]}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mo", "=!=", 
           RowBox[{"{", "}"}]}], "&&", 
          RowBox[{"careQ", "[", 
           RowBox[{"Identify", "[", "LHS", "]"}], "]"}]}], ",", 
         RowBox[{
         "Print", "[", 
          "\"\<** MakeRule: Potential problems moving indices on the \
LHS.\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       
       RowBox[{"(*", " ", 
        RowBox[{"4.", " ", "TestIndices"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"indsLHSinfo", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", "ti"}], "]"}], "&"}], "/@", "indsLHSinfo"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "5.", " ", "Pattern", " ", "character", " ", "in", " ", "final", " ", 
         
         RowBox[{
          RowBox[{"rule", ".", " ", "up"}], "/", "down"}], " ", "character", 
         " ", "in", " ", "patindsLHS", " ", "is", " ", "corrected"}], " ", 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"patindsLHS", "=", 
        RowBox[{"Switch", "[", 
         RowBox[{"patindsLHS", ",", "\[IndentingNewLine]", "None", ",", 
          RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "All", ",", 
          "indsLHS", ",", "\[IndentingNewLine]", "_List", ",", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"patindsLHS", "~", "Join", "~", 
             RowBox[{"(", 
              RowBox[{"ChangeIndex", "/@", "patindsLHS"}], ")"}]}], ",", 
            "indsLHS"}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeRule", "::", "unknown"}], ",", "\"\<indices\>\"", 
             ",", "patindsLHS"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"indsLHSinfo", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"patindsLHS", ",", 
              RowBox[{"First", "@", "#"}]}], "]"}]}], "]"}], "&"}], "/@", 
         "indsLHSinfo"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"6.", " ", "Name", " ", "in", " ", "final", " ", 
         RowBox[{"rule", ".", " ", "Currently"}], " ", "we", " ", "do", " ", 
         "not", " ", "change", " ", "names"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"indsLHSinfo", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", 
            RowBox[{"First", "@", "#"}]}], "]"}], "&"}], "/@", 
         "indsLHSinfo"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<indsLHSinfo: \>\"", ",", "indsLHSinfo"}], "]"}]}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "7.", " ", "Final", " ", "rules", " ", "for", " ", "LHS", " ", 
         "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"rulesLHS", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"FormatIndexRule", "/@", "indsLHSinfo"}], ")"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"patternTest", "\[Rule]", "PatternTest"}], ",", 
           RowBox[{"pattern", "\[Rule]", "Pattern"}]}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<rulesLHS: \>\"", ",", "rulesLHS"}], "]"}]}], "]"}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"**", 
         RowBox[{"*", " ", 
          RowBox[{"C", ".", " ", "Construct"}], " ", "newLHSs", " ", "and", 
          " ", "newRHS"}]}], " ", "****)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"1.", " ", "MetricOn"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Indices", " ", "that", " ", "give", " ", "pmQ", " ", "patterns", " ", 
         RowBox[{"(", 
          RowBox[{"always", " ", "converted", " ", "to", " ", "upindices"}], 
          ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"pmQinds", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{"indsLHSinfo", ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "index_", ",", "True", ",", "True", ",", "True", ",", "True", ",",
              "_"}], "}"}], "\[RuleDelayed]", "index"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Pairs", " ", "of", " ", "contracted", " ", 
         RowBox[{"indices", ".", " ", "They"}], " ", "do", " ", "not", " ", 
         "need", " ", "duplication", " ", "by", " ", "symmetry"}], " ", 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"pairs", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"List", "@@", 
           RowBox[{"TakeEPairs", "[", 
            RowBox[{"IndexList", "@@", 
             RowBox[{"Cases", "[", 
              RowBox[{"indsLHSinfo", ",", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "index_", ",", "False", ",", "True", ",", "_", ",", "_", ",",
                   "_"}], "}"}], "\[RuleDelayed]", "index"}]}], "]"}]}], 
            "]"}]}], ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Free", " ", "indices", " ", "that", " ", "give", " ", 
         "duplicatefree", " ", "rules"}], " ", "*)"}], "\[IndentingNewLine]", 
       
       RowBox[{"dupfreemetric", "=", 
        RowBox[{"Complement", "[", 
         RowBox[{
          RowBox[{"Cases", "[", 
           RowBox[{"indsLHSinfo", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "index_", ",", "True", ",", "True", ",", "_", ",", "_", ",", 
               "_"}], "}"}], "\[RuleDelayed]", "index"}]}], "]"}], ",", 
          "pmQinds"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<dupfreemetric: \>\"", ",", "dupfreemetric"}], "]"}]}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"2.", " ", "UseSymmetries"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "Create", " ", "a", " ", "list", " ", "of", " ", "equivalents", " ", 
          "to", " ", "symtensorsLHS", " ", "due", " ", "to", " ", "the", " ", 
          "symmetries", " ", "of", " ", "tensors"}], ",", " ", 
         RowBox[{
         "with", " ", "metric", " ", "pairs", " ", "eliminated", " ", 
          "because", " ", "they", " ", "will", " ", "give", " ", "duplicated",
           " ", "rules", " ", "below"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"symtensorsLHS", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{
          RowBox[{"FindAllOfType", "[", 
           RowBox[{"HeldLHS", ",", "Tensor"}], "]"}], ",", 
          RowBox[{"tensor_", "/;", 
           RowBox[{
            RowBox[{"OrderOfGroup", "[", 
             RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}], "]"}], "=!=",
             "1"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"!", "us"}], "||", 
          RowBox[{"symtensorsLHS", "===", 
           RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newLHSs", "=", 
          RowBox[{"{", "newHeldLHS", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{"verb", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<symtensorsLHS: \>\"", ",", "symtensorsLHS"}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<freesLHS: \>\"", ",", "freesLHS"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<pairs: \>\"", ",", "pairs"}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "groups", ",", "newtensors", ",", "tmp", ",", "equivalents"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"groups", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"IndexList", "@@", "freesLHS"}], "}"}], ",", 
                RowBox[{"Apply", "[", 
                 RowBox[{"IndexList", ",", "pairs", ",", 
                  RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"newtensors", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"SymmetryEquivalentsOfTensor", "[", 
                 RowBox[{"#", ",", 
                  RowBox[{"Sequence", "@@", "groups"}]}], "]"}], "&"}], "/@", 
               "symtensorsLHS"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"verb", ",", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<newtensors: \>\"", ",", "newtensors"}], "]"}]}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"equivalents", "=", 
              RowBox[{
               RowBox[{"Flatten", "[", 
                RowBox[{"Outer", "[", 
                 RowBox[{"tmp", ",", 
                  RowBox[{"Sequence", "@@", "newtensors"}]}], "]"}], "]"}], "/.", 
               RowBox[{"tmp", "\[Rule]", "List"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"verb", ",", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<equivalents: \>\"", ",", "equivalents"}], 
                "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"The", " ", "strange", " ", 
                 RowBox[{"Rule", "[", 
                  RowBox[{"#2", ",", "#1"}], "]"}]}], "&"}], " ", 
               "construction", " ", "below", " ", "is", " ", "needed", " ", 
               "because", " ", "Inner", " ", "is", " ", "asymmetric", " ", 
               "when", " ", "the", " ", "lists", " ", "have", " ", 
               "different", " ", "depths"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"newLHSs", "=", 
              RowBox[{
               RowBox[{"newHeldLHS", "/.", 
                RowBox[{"Inner", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Rule", "[", 
                    RowBox[{"#2", ",", "#1"}], "]"}], "&"}], ",", 
                  "equivalents", ",", "symtensorsLHS", ",", "List"}], "]"}]}],
                "//.", 
               RowBox[{
                RowBox[{"HoldPattern", "[", 
                 RowBox[{
                  RowBox[{"der_", "?", "FirstDerQ"}], "[", 
                  RowBox[{"-", "expr_"}], "]"}], "]"}], "\[RuleDelayed]", 
                RowBox[{"-", 
                 RowBox[{"der", "[", "expr", "]"}]}]}]}]}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<newLHSs: \>\"", ",", "newLHSs"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Repeat", " ", "RHS", " ", "as", " ", "many", " ", "times"}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"newRHSs", "=", 
        RowBox[{
         RowBox[{"newHeldRHS", "&"}], "/@", "newLHSs"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<newRHSs: \>\"", ",", "newRHSs"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"3.", " ", "Construct", " ", "rules"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"Inner", "[", 
         RowBox[{"Rule", ",", "newLHSs", ",", "newRHSs", ",", "List"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<rules before duplication: \>\"", ",", 
           RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"Fold", "[", 
         RowBox[{"changeRuleforfreepmQ", ",", "rules", ",", "pmQinds"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<rules after changRuleforfreepmQ: \>\"", ",", 
           RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"Fold", "[", 
         RowBox[{"duplicateRuleforfree", ",", "rules", ",", "dupfreemetric"}],
          "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<rules after duplicateRuleforfree: \>\"", ",", 
           RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pairs", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"UpIndex", "/@", 
          RowBox[{"Flatten", "[", 
           RowBox[{"pairs", ",", "1"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"Fold", "[", 
         RowBox[{"duplicateRulefordummy", ",", "rules", ",", "pairs"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<rules after duplication: \>\"", ",", 
           RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"contr", ",", 
         RowBox[{
          RowBox[{"rules", "=", 
           RowBox[{"rules", "/.", 
            RowBox[{
             RowBox[{"Rule", "[", 
              RowBox[{"lhs_Hold", ",", 
               RowBox[{"Hold", "[", "rhs_", "]"}]}], "]"}], "\[RuleDelayed]", 
             
             RowBox[{"Rule", "[", 
              RowBox[{"lhs", ",", 
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"contrrhs", "=", 
                   RowBox[{"ContractMetric", "[", "rhs", "]"}]}], "}"}], ",", 
                 
                 RowBox[{"Hold", "[", "contrrhs", "]"}]}], "]"}]}], 
              "]"}]}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"verb", ",", 
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<rules after metric contraction: \>\"", ",", "rules"}], 
             "]"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"rules", "/.", 
         RowBox[{
          RowBox[{"Rule", "[", 
           RowBox[{"lhs_Hold", ",", "rhs_Hold"}], "]"}], "\[RuleDelayed]", 
          RowBox[{"FlattenTimes", "[", 
           RowBox[{"Rule", "[", 
            RowBox[{"lhs", ",", "rhs"}], "]"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<rules after arranging minus signs: \>\"", ",", "rules"}], 
          "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"4.", " ", "Replace", " ", "indices"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"rules", "/.", 
         RowBox[{
          RowBox[{"Rule", "[", 
           RowBox[{"lhs_Hold", ",", "rhs_Hold"}], "]"}], "\[RuleDelayed]", 
          RowBox[{"Rule", "[", 
           RowBox[{
            RowBox[{"ReplaceIndex", "[", 
             RowBox[{"lhs", ",", "rulesLHS"}], "]"}], ",", "rhs"}], 
           "]"}]}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<rules after pattern: \>\"", ",", "rules"}], "]"}]}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "5.", " ", "Add", " ", "Module", " ", "on", " ", "the", " ", "RHS"}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"rules", "/.", 
         RowBox[{"Rule", "\[Rule]", "IndexRule"}]}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"6.", " ", "Add", " ", "conditions"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"conds", "=", 
        RowBox[{"Hold", "[", "conditions", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"verb", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<Conditions: \>\"", ",", "conds"}], "]"}]}], "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"addconditions", "[", 
             RowBox[{"#", ",", "conds"}], "]"}], "&"}], "/@", "rules"}], 
          ")"}], "/.", 
         RowBox[{
          RowBox[{"Hold", "[", "cond_", "]"}], "\[RuleDelayed]", "cond"}]}]}],
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"7.", " ", "Return", " ", "rules"}], " ", "*)"}], 
       "\[IndentingNewLine]", "rules"}]}], "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 Evaluatable->False,ExpressionUUID->"212990e7-949f-4cbd-886c-a38a35217ff7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"conditions\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "conditions", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"18b8fcbb-6c64-450a-8206-c9c13f81824c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"HeldLHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "HeldLHS", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"56461c5d-4d06-44cc-b65e-101c1044d776"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"HeldRHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "HeldRHS", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"e0a64113-fce5-4f71-9536-27d64937856b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"patindsLHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "patindsLHS", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"73dd507e-8ae7-4686-a590-dd704aaaed38"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"ti\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "ti", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"6a2d337d-68bd-4813-88db-e88c481ccabc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"mo\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "mo", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"74d7eeef-ba5a-403f-8062-a797c2280e57"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"us\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "us", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"6971040d-64d0-474e-9ead-084650642480"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"contr\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "contr", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"6385ef39-ed4c-41af-a4cd-0991f15eb9ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"indsLHSinfo\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "indsLHSinfo", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"77811413-c4db-4ca9-81de-03d96c1ef20d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"oldinds\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "oldinds", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"9c01f03e-60f5-4a5b-a794-4be305682f28"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"dupfreemetric\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "dupfreemetric", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"14ee01af-3994-495c-8cf2-cc527e5ea8c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"rulesLHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "rulesLHS", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"03176525-d3be-4bdf-8c15-5edd1dedc0ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"newLHSs\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "newLHSs", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"8ae4ed0e-714a-426e-a509-d74c2e8acede"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"newRHSs\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "newRHSs", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"6272375f-f1c1-4c92-928a-d3fd3af4ef9d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"equivalents\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "equivalents", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"818d4acd-f7e1-4759-8d6d-9edff54bb273"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"newtensors\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "newtensors", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"bdca84ac-df11-4368-af7a-be4ecde9f82e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"groups\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "groups", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"ded6451a-48e3-4678-b9ad-c0715353bdda"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"indsLHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "indsLHS", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"bf7aa010-f22d-495f-9c67-7c5912cc5fa4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"freesLHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "freesLHS", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"1f013a09-aebb-4c9f-94a3-989f47d049eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"indsRHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "indsRHS", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"50aca3f1-432d-46c0-bd98-0a2fab76f45b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"freesRHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "freesRHS", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"5307cb45-ff53-4cb5-ab8e-235163e4695b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"symtensorsLHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "symtensorsLHS", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"cfd08894-264b-42c0-bf47-4f2c9e53b4ce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"newHeldRHS\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "newHeldRHS", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"ae88e15e-0341-4885-83a7-7c7a805dab63"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"conds\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "conds", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"b59a2cd6-0ef4-43a7-8076-a3870abd2961"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"careQ\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "careQ", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"f5b32460-4bc0-4fad-8beb-957d3cee6067"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"Identify\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "Identify", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"8d4f5ac9-61a0-421a-9aa9-fa4044590868"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"pmQinds\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "pmQinds", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"227d84b7-274f-4b60-bd7f-a4aaa0c502a3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"contrrhs\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "contrrhs", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"7bc5f12c-1cad-448f-8dfc-44b72a6df8fb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"FlattenTimes\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "FlattenTimes", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"986022f6-a207-427c-a464-bf7f88f3a87e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"addconditions\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "addconditions", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"13b001bb-c6bb-4aeb-b0bb-bb3db99be4e3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"cond\"\>",
    "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "cond", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"9c89a3cc-5f39-4165-9f0c-0a442ee1d6fd"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Because the lhs is held, we need to flatten the possible -1's that could have \
been generated by the symmetry-equivalent tensors:\
\>", "Text",ExpressionUUID->"3ecd7ae8-11e5-4c56-8add-71e039fb6128"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FlattenTimes", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "x_"}], "]"}], "]"}], ",", 
      RowBox[{"Hold", "[", "rhs_", "]"}]}], "]"}], "]"}], ":=", 
   RowBox[{"Rule", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "x", "]"}], ",", 
     RowBox[{"Hold", "[", 
      RowBox[{"-", "rhs"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FlattenTimes", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"Times", "[", 
        RowBox[{"x___", ",", 
         RowBox[{"Times", "[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "y__"}], "]"}], ",", "z___"}], "]"}], 
       "]"}], ",", 
      RowBox[{"Hold", "[", "rhs_", "]"}]}], "]"}], "]"}], ":=", 
   RowBox[{"FlattenTimes", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"Times", "[", 
        RowBox[{"x", ",", "y", ",", "z"}], "]"}], "]"}], ",", 
      RowBox[{"Hold", "[", 
       RowBox[{"-", "rhs"}], "]"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FlattenTimes", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{"lhs_Hold", ",", "rhs_Hold"}], "]"}], "]"}], ":=", 
   RowBox[{"Rule", "[", 
    RowBox[{"lhs", ",", "rhs"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9718db5a-0e30-4b07-8a9b-e23d94938924"],

Cell[BoxData[
 RowBox[{
  RowBox[{"addconditions", "[", 
   RowBox[{"rule_RuleDelayed", ",", "conds_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"conds", "===", 
     RowBox[{"Hold", "[", "]"}]}], ",", "rule", ",", 
    RowBox[{"rule", "/.", 
     RowBox[{
      RowBox[{"RuleDelayed", "[", 
       RowBox[{"lhs_", ",", "rhs_"}], "]"}], "\[RuleDelayed]", 
      RowBox[{"RuleDelayed", "[", 
       RowBox[{"lhs", ",", 
        RowBox[{"Condition", "[", 
         RowBox[{"rhs", ",", "conds"}], "]"}]}], "]"}]}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ba347777-f338-4df4-aca9-8ed9df0c5224"],

Cell["\<\
Construct a table of data with the indices and their properties:\
\>", "Text",ExpressionUUID->"db0cc7c8-1799-4d0c-b903-8703b5f675f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructLHSinfo", "[", 
    RowBox[{"indsLHS_List", ",", "freesLHS_List", ",", 
     RowBox[{"{", 
      RowBox[{"mo_", ",", "ti_", ",", "patindsLHS_"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"LHSinfo", ",", "tmp"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "1.", " ", "Name", " ", "of", " ", "index", " ", "in", " ", "input", 
       " ", "rule"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LHSinfo", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"indsLHS", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"2.", " ", "Free", " ", "character"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"LHSinfo", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", 
           RowBox[{"MemberQ", "[", 
            RowBox[{"freesLHS", ",", 
             RowBox[{"First", "@", "#"}]}], "]"}]}], "]"}], "&"}], "/@", 
        "LHSinfo"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"3.", " ", 
        RowBox[{
         RowBox[{"MetricOn", ".", " ", "up"}], "/", "down"}], " ", 
        "character", " ", "in", " ", "mo", " ", "is", " ", "corrected"}], " ",
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tmp", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{"mo", ",", "\[IndentingNewLine]", "None", ",", 
         RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "All", ",", 
         "indsLHS", ",", "\[IndentingNewLine]", "_List", ",", 
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"mo", "~", "Join", "~", 
            RowBox[{"(", 
             RowBox[{"ChangeIndex", "/@", "mo"}], ")"}]}], ",", "indsLHS"}], 
          "]"}], ",", "\[IndentingNewLine]", "_", ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MakeRule", "::", "unknown"}], ",", "\"\<indices\>\"", 
            ",", "mo"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LHSinfo", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", 
           RowBox[{
            RowBox[{"MemberQ", "[", 
             RowBox[{"tmp", ",", 
              RowBox[{"First", "@", "#"}]}], "]"}], "&&", 
            RowBox[{"MetricEndowedQ", "@", 
             RowBox[{"VBundleOfIndex", "@", 
              RowBox[{"First", "@", "#"}]}]}]}]}], "]"}], "&"}], "/@", 
        "LHSinfo"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"4.", " ", "TestIndices"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"LHSinfo", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", "ti"}], "]"}], "&"}], "/@", "LHSinfo"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "5.", " ", "Pattern", " ", "character", " ", "in", " ", "final", " ", 
        RowBox[{
         RowBox[{"rule", ".", " ", "up"}], "/", "down"}], " ", "character", 
        " ", "in", " ", "patindsLHS", " ", "is", " ", "corrected"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tmp", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{"patindsLHS", ",", "\[IndentingNewLine]", "None", ",", 
         RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "All", ",", 
         "indsLHS", ",", "\[IndentingNewLine]", "_List", ",", 
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"patindsLHS", "~", "Join", "~", 
            RowBox[{"(", 
             RowBox[{"ChangeIndex", "/@", "patindsLHS"}], ")"}]}], ",", 
           "indsLHS"}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MakeRule", "::", "unknown"}], ",", "\"\<indices\>\"", 
            ",", "patindsLHS"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"LHSinfo", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", 
           RowBox[{"MemberQ", "[", 
            RowBox[{"tmp", ",", 
             RowBox[{"First", "@", "#"}]}], "]"}]}], "]"}], "&"}], "/@", 
        "LHSinfo"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"6.", " ", "Name", " ", "in", " ", "final", " ", 
        RowBox[{"rule", ".", " ", "Currently"}], " ", "we", " ", "do", " ", 
        "not", " ", "change", " ", "names"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"LHSinfo", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", 
           RowBox[{"First", "@", "#"}]}], "]"}], "&"}], "/@", "LHSinfo"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"7.", " ", "Return", " ", "LHSinfo"}], " ", "*)"}], 
      "\[IndentingNewLine]", "LHSinfo"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"97d92d3c-066c-4ca9-b6b4-937acc6b5140"],

Cell["The new function:", \
"Text",ExpressionUUID->"442ef720-06fe-47e1-b71b-d70ba8bfee54"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MakeRule", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PatternIndices", "\[Rule]", "All"}], ",", 
     RowBox[{"TestIndices", "\[Rule]", "True"}], ",", 
     RowBox[{"MetricOn", "\[Rule]", "None"}], ",", 
     RowBox[{"UseSymmetries", "\[Rule]", "True"}], ",", 
     RowBox[{"Verbose", "\[Rule]", "False"}], ",", 
     RowBox[{"ContractMetrics", "\[Rule]", "False"}], ",", 
     RowBox[{"Evaluate", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"MakeRule", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeRule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"LHS_", ",", "RHS_", ",", "conditions___"}], "}"}], ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"HeldLHS", "=", 
        RowBox[{"ReplaceIsolated", "[", 
         RowBox[{"Hold", "[", "LHS", "]"}], "]"}]}], ",", 
       RowBox[{"HeldRHS", "=", 
        RowBox[{"ReplaceDummies", "[", 
         RowBox[{"Hold", "[", "RHS", "]"}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Contractible", " ", "indices"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"indsLHS", "=", 
          RowBox[{"List", "@@", 
           RowBox[{"TakeEIndices", "[", 
            RowBox[{"FindIndices", "[", "LHS", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"freesLHS", "=", 
          RowBox[{"List", "@@", 
           RowBox[{"TakeEIndices", "[", 
            RowBox[{"FindFreeIndices", "[", "LHS", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"indsRHS", "=", 
          RowBox[{"List", "@@", 
           RowBox[{"TakeEIndices", "[", 
            RowBox[{"FindIndices", "[", "RHS", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"freesRHS", "=", 
          RowBox[{"List", "@@", 
           RowBox[{"TakeEIndices", "[", 
            RowBox[{"FindFreeIndices", "[", "RHS", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"isolated", "=", 
          RowBox[{"ExtractIsolated", "[", 
           RowBox[{"HeldLHS", ",", "Hold"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "patindsLHS", ",", "ti", ",", "mo", ",", "us",
          ",", "verb", ",", "contr", ",", "ev", ",", "\[IndentingNewLine]", 
         "dupfreemetric", ",", "pmQinds", ",", "pairs", ",", "rulesLHS", ",", 
         "\[IndentingNewLine]", "symtensorsLHS", ",", "\[IndentingNewLine]", 
         "newLHSs", ",", "\[IndentingNewLine]", "rules", ",", "conds"}], 
        "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Options", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "patindsLHS", ",", "ti", ",", "mo", ",", "us", ",", "verb", ",", 
           "contr", ",", "ev"}], "}"}], "=", 
         RowBox[{"OptionValue", "[", 
          RowBox[{"{", 
           RowBox[{
           "PatternIndices", ",", "TestIndices", ",", "MetricOn", ",", 
            "UseSymmetries", ",", "Verbose", ",", "ContractMetrics", ",", 
            "Evaluate"}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"**", 
          RowBox[{"*", " ", 
           RowBox[{"A", ".", " ", "Checks"}]}]}], " ", "****)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{"PIndexQ", "/@", "indsLHS"}], ")"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeRule", "::", "pats"}], ",", "\"\<left\>\""}], 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{"PIndexQ", "/@", "indsRHS"}], ")"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeRule", "::", "pats"}], ",", "\"\<right\>\""}], 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"LHS", "===", "0"}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeRule", "::", "error"}], ",", 
             "\"\<LHS of rule evaluates to zero.\>\""}], "]"}]}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Sort", "@", "freesLHS"}], ")"}], "=!=", 
            RowBox[{"(", 
             RowBox[{"Sort", "@", "freesRHS"}], ")"}]}], "&&", 
           RowBox[{"RHS", "=!=", "0"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"MakeRule", "::", "inhom"}], ",", "freesLHS", ",", 
             "freesRHS"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "@", 
            RowBox[{"ListOfTerms", "[", "LHS", "]"}]}], ">", "1"}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{"MakeRule", "::", "terms"}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"mo", "=!=", "None"}], "&&", 
           RowBox[{"careQ", "[", 
            RowBox[{"Identify", "[", "LHS", "]"}], "]"}]}], ",", 
          RowBox[{
          "Print", "[", 
           "\"\<** MakeRule: Potential problems moving indices on the \
LHS.\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"(*", 
         RowBox[{"**", 
          RowBox[{"*", " ", 
           RowBox[{"B", ".", " ", "Construct"}], " ", "and", " ", "interpret",
            " ", "LHSinfo"}]}], " ", "****)"}], "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"LHSinfo", "=", 
            RowBox[{"ConstructLHSinfo", "[", 
             RowBox[{
              RowBox[{"IndexName", "/@", "indsLHS"}], ",", 
              RowBox[{"IndexName", "/@", "freesLHS"}], ",", 
              RowBox[{"{", 
               RowBox[{"mo", ",", "ti", ",", "patindsLHS"}], "}"}]}], "]"}]}],
            "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{"verb", ",", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<LHSinfo: \>\"", ",", "LHSinfo"}], "]"}]}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Index", " ", "replacement", " ", "rules"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"rulesLHS", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"FormatIndexRule", "/@", "LHSinfo"}], ")"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"patternTest", "\[Rule]", "PatternTest"}], ",", 
               RowBox[{"pattern", "\[Rule]", "Pattern"}]}], "}"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"verb", ",", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<rulesLHS: \>\"", ",", "rulesLHS"}], "]"}]}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "Indices", " ", "that", " ", "give", " ", "pmQ", " ", "patterns", 
             " ", 
             RowBox[{"(", 
              RowBox[{
              "always", " ", "converted", " ", "to", " ", "upindices"}], 
              ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"pmQinds", "=", 
            RowBox[{"Cases", "[", 
             RowBox[{"LHSinfo", ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "index_", ",", "True", ",", "True", ",", "True", ",", "True", 
                 ",", "_"}], "}"}], "\[Rule]", "index"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Pairs", " ", "of", " ", "contracted", " ", 
             RowBox[{"indices", ".", " ", "They"}], " ", "do", " ", "not", 
             " ", "need", " ", "duplication", " ", "by", " ", "symmetry"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"pairs", "=", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"List", "@@", 
               RowBox[{"TakeEPairs", "[", 
                RowBox[{"IndexList", "@@", 
                 RowBox[{"Cases", "[", 
                  RowBox[{"LHSinfo", ",", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "index_", ",", "False", ",", "True", ",", "_", ",", "_", 
                    ",", "_"}], "}"}], "\[Rule]", "index"}]}], "]"}]}], 
                "]"}]}], ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "Free", " ", "indices", " ", "that", " ", "give", " ", 
             "duplicatefree", " ", "rules"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"dupfreemetric", "=", 
            RowBox[{"Complement", "[", 
             RowBox[{
              RowBox[{"Cases", "[", 
               RowBox[{"LHSinfo", ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "index_", ",", "True", ",", "True", ",", "_", ",", "_", ",",
                    "_"}], "}"}], "\[Rule]", "index"}]}], "]"}], ",", 
              "pmQinds"}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"**", 
          RowBox[{"*", " ", 
           RowBox[{"C", ".", " ", "Symmetries"}], " ", "on", " ", "the", " ", 
           "LHS"}]}], " ", "****)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"Detect", " ", "non"}], "-", 
          RowBox[{
          "isolated", " ", "tensors", " ", "with", " ", "symmetries"}]}], " ",
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{"symtensorsLHS", "=", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"Complement", "[", 
            RowBox[{
             RowBox[{"FindAllOfType", "[", 
              RowBox[{"HeldLHS", ",", "Tensor"}], "]"}], ",", 
             RowBox[{"FindAllOfType", "[", 
              RowBox[{"isolated", ",", "Tensor"}], "]"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{"tensor_", "/;", 
             RowBox[{"OrderOfGroup", "[", 
              RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}], "]"}]}], 
            "=!=", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<symtensorsLHS: \>\"", ",", "symtensorsLHS"}], "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"!", "us"}], "||", 
           RowBox[{"symtensorsLHS", "===", 
            RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"newLHSs", "=", 
           RowBox[{"{", "HeldLHS", "}"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Create", " ", "a", " ", "list", " ", "of", " ", "equivalents", 
             " ", "to", " ", "symtensorsLHS", " ", "due", " ", "to", " ", 
             "the", " ", "symmetries", " ", "of", " ", "tensors"}], ",", " ", 
            
            RowBox[{
            "with", " ", "metric", " ", "pairs", " ", "eliminated", " ", 
             "because", " ", "they", " ", "will", " ", "give", " ", 
             "duplicated", " ", "rules", " ", "below"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "groups", ",", "newtensors", ",", "tmp", ",", "equivalents"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"groups", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"IndexList", "@@", "freesLHS"}], "}"}], ",", 
                RowBox[{"Apply", "[", 
                 RowBox[{"IndexList", ",", "pairs", ",", 
                  RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"newtensors", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"SymmetryEquivalentsOfTensor", "[", 
                 RowBox[{"#", ",", 
                  RowBox[{"Sequence", "@@", "groups"}]}], "]"}], "&"}], "/@", 
               "symtensorsLHS"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"verb", ",", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<newtensors: \>\"", ",", "newtensors"}], "]"}]}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"equivalents", "=", 
              RowBox[{
               RowBox[{"Flatten", "[", 
                RowBox[{"Outer", "[", 
                 RowBox[{"tmp", ",", 
                  RowBox[{"Sequence", "@@", "newtensors"}]}], "]"}], "]"}], "/.", 
               RowBox[{"tmp", "\[Rule]", "List"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"verb", ",", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<equivalents: \>\"", ",", "equivalents"}], 
                "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"The", " ", "strange", " ", 
                 RowBox[{"Rule", "[", 
                  RowBox[{"#2", ",", "#1"}], "]"}]}], "&"}], " ", 
               "construction", " ", "below", " ", "is", " ", "needed", " ", 
               "because", " ", "Inner", " ", "is", " ", "asymmetric", " ", 
               "when", " ", "the", " ", "lists", " ", "have", " ", 
               "different", " ", "depths"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"newLHSs", "=", 
              RowBox[{
               RowBox[{"HeldLHS", "/.", 
                RowBox[{"Inner", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Rule", "[", 
                    RowBox[{"#2", ",", "#1"}], "]"}], "&"}], ",", 
                  "equivalents", ",", "symtensorsLHS", ",", "List"}], "]"}]}],
                "//.", 
               RowBox[{
                RowBox[{"HoldPattern", "[", 
                 RowBox[{
                  RowBox[{"der_", "?", "FirstDerQ"}], "[", 
                  RowBox[{"-", "expr_"}], "]"}], "]"}], "\[Rule]", 
                RowBox[{"-", 
                 RowBox[{"der", "[", "expr", "]"}]}]}]}]}], ";"}]}], 
           "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<newLHS after symmetry handling: \>\"", ",", "newLHSs"}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Isolated", " ", "expressions", " ", "are", " ", "handled", " ", 
          "through", " ", "a", " ", "recursive", " ", "call", " ", "to", " ", 
          "MakeRule"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"isolated2", ",", "isorules"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{"verb", ",", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<isolated: \>\"", ",", "isolated"}], "]"}]}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"isolated", "=!=", 
              RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Block", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"FlattenTimes", "=", "Identity"}], "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"isolated2", "=", 
                 RowBox[{"Transpose", "[", 
                  RowBox[{
                   RowBox[{"Flatten", "[", 
                    RowBox[{"Apply", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"IndexList", ",", "##"}], "]"}], "&"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"patternisolated", "[", 
                    RowBox[{"#", ",", "options"}], "]"}], "&"}], "/@", 
                    "isolated"}]}], "]"}], "]"}], "/.", 
                   RowBox[{"IndexList", "\[Rule]", "List"}]}], "]"}]}]}], 
               "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{"verb", ",", 
                RowBox[{"Print", "[", 
                 RowBox[{"\"\<isolated2: \>\"", ",", "isolated2"}], "]"}]}], 
               "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"isorules", "=", 
               RowBox[{"Inner", "[", 
                RowBox[{
                "makerule", ",", "isolated", ",", "isolated2", ",", "List"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{"verb", ",", 
                RowBox[{"Print", "[", 
                 RowBox[{"\"\<isorules: \>\"", ",", "isorules"}], "]"}]}], 
               "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"newLHSs", "=", 
               RowBox[{"Flatten", "[", 
                RowBox[{"newLHSs", "/.", "isorules"}], "]"}]}], ";"}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<newLHSs after handling of isolated expressions: \>\"", ",", 
            "newLHSs"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"**", 
          RowBox[{"*", " ", 
           RowBox[{"D", ".", " ", "Construct"}], " ", "rules"}]}], " ", 
         "****)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"1.", " ", "Duplication"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"Inner", "[", 
          RowBox[{"Rule", ",", "newLHSs", ",", 
           RowBox[{
            RowBox[{"HeldRHS", "&"}], "/@", "newLHSs"}], ",", "List"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Optional", " ", "evaluation", " ", "at", " ", "this", " ", "point", 
          " ", "only"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"ev", ",", 
          RowBox[{"rules", "=", 
           RowBox[{"Map", "[", 
            RowBox[{"Evaluate", ",", "rules", ",", 
             RowBox[{"{", "3", "}"}]}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<Initial rules: \>\"", ",", 
            RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"rules", "/.", 
          RowBox[{
           RowBox[{"Rule", "[", 
            RowBox[{"lhs_Hold", ",", "rhs_Hold"}], "]"}], "\[RuleDelayed]", 
           RowBox[{"FlattenTimes", "[", 
            RowBox[{"Rule", "[", 
             RowBox[{"lhs", ",", "rhs"}], "]"}], "]"}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<rules after arranging minus signs: \>\"", ",", "rules"}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"Fold", "[", 
          RowBox[{"changeRuleforfreepmQ", ",", "rules", ",", "pmQinds"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<rules after changRuleforfreepmQ: \>\"", ",", 
            RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"Fold", "[", 
          RowBox[{
          "duplicateRuleforfree", ",", "rules", ",", "dupfreemetric"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<rules after duplicateRuleforfree: \>\"", ",", 
            RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pairs", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"UpIndex", "/@", 
           RowBox[{"Flatten", "[", 
            RowBox[{"pairs", ",", "1"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"Fold", "[", 
          RowBox[{"duplicateRulefordummy", ",", "rules", ",", "pairs"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<rules after duplication: \>\"", ",", 
            RowBox[{"InputForm", "[", "rules", "]"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"contr", ",", 
          RowBox[{
           RowBox[{"rules", "=", 
            RowBox[{"rules", "/.", 
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"lhs_Hold", ",", 
                RowBox[{"Hold", "[", "rhs_", "]"}]}], "]"}], "\[RuleDelayed]", 
              RowBox[{"Rule", "[", 
               RowBox[{"lhs", ",", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"contrrhs", "=", 
                    RowBox[{"ContractMetric", "[", "rhs", "]"}]}], "}"}], ",", 
                  RowBox[{"Hold", "[", "contrrhs", "]"}]}], "]"}]}], 
               "]"}]}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"verb", ",", 
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<rules after metric contraction: \>\"", ",", "rules"}], 
              "]"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"2.", " ", "Replace", " ", "indices"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"rules", "/.", 
          RowBox[{
           RowBox[{"Rule", "[", 
            RowBox[{"lhs_Hold", ",", "rhs_Hold"}], "]"}], "\[RuleDelayed]", 
           RowBox[{"Rule", "[", 
            RowBox[{
             RowBox[{"ReplaceIndex", "[", 
              RowBox[{"lhs", ",", "rulesLHS"}], "]"}], ",", "rhs"}], 
            "]"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<rules after introducing patterns: \>\"", ",", "rules"}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"(*", " ", 
         RowBox[{
         "3.", " ", "Add", " ", "Module", " ", "on", " ", "the", " ", "RHS"}],
          " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{"rules", "/.", 
          RowBox[{"Rule", "\[Rule]", "IndexRule"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"4.", " ", "Add", " ", "conditions"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"conds", "=", 
         RowBox[{"Hold", "[", "conditions", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"verb", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<Conditions: \>\"", ",", "conds"}], "]"}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"rules", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"addconditions", "[", 
              RowBox[{"#", ",", "conds"}], "]"}], "&"}], "/@", "rules"}], 
           ")"}], "/.", 
          RowBox[{
           RowBox[{"Hold", "[", "cond_", "]"}], "\[Rule]", "cond"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"5.", " ", "Return", " ", "rules"}], " ", "*)"}], 
        "\[IndentingNewLine]", "rules"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"aa4230b8-9fd2-4e13-a440-2d099ff02f03"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"patternisolated", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "expr_", "]"}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"First", "/@", 
    RowBox[{"MakeRule", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"expr", ",", "expr"}], "}"}], ",", "options"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"makerule", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "lhs_", "]"}], ",", "rhs_HoldPattern"}], "]"}], ":=", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{
     RowBox[{"RuleDelayed", "[", 
      RowBox[{
       RowBox[{"HoldPattern", "[", "lhs", "]"}], ",", "rhs"}], "]"}], ",", 
     "rhs", ",", "2", ",", "1"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cedfa73b-c7a3-44de-afbb-e6b5c41625a6"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4.3. Examples 1", \
"Subsubsection",ExpressionUUID->"3c415186-f555-4018-a00b-ef0dfefb0555"],

Cell["Check cases:", \
"Text",ExpressionUUID->"096de759-6373-453e-a651-06ac9b248380"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"83c4b33f-2463-4baf-8ff4-21670d09218a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"0aaa88b1-2a3e-4f94-a044-7603dc6fb090"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"76e00e7e-d733-4169-b847-a91c3ffb809f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"305180d8-097d-4d1b-9e0b-50c29d0578f7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"18e5308d-922c-4693-ae2b-0811a87feb0c"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ec796299-addb-4c0c-b785-c92790fc6ad5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"557d915a-1ecc-47f3-a2a4-902c1a7e699e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"94137b0f-8bbe-45ce-b66e-67af3bfd8a41"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"ceaa40e8-e476-49b4-8958-2562552e353f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"fef40f49-824e-4e54-b08b-41a590fef10d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DefTensor", "[", 
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
    RowBox[{"Symmetric", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
    RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"ce6590da-8219-4268-b1f1-3168d68f1f72"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c210005a-4650-49e5-b716-e5aa30fb31ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xUpSet", "[", 
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
   RowBox[{"{", "metricg", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"33fdff8a-81bd-4d55-8541-a36217b52370"],

Cell[BoxData[
 RowBox[{"{", "metricg", 
  "}"}]], "Output",ExpressionUUID->"5bd46f52-7911-43ff-bd16-cdffb13784ac"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "metricg", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"metricg", "[", 
   RowBox[{"A_Symbol", ",", 
    RowBox[{"-", "B_Symbol"}]}], "]"}], ":=", 
  RowBox[{"delta", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"-", "A_Symbol"}], ",", "B_Symbol"}], "]"}], ":=", 
  RowBox[{"delta", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "metricg", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"3a3a889c-a472-4617-90a8-2d3bf4b8578a"],

Cell["1) Nothing to do:", \
"Text",ExpressionUUID->"81560f9e-33e0-45d4-ab03-33f28d91aaa3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"2552a3d9-4260-4c03-aa14-ba90362065fc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", "a", "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "b"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"f1dbfb70-ac2a-42c1-bd17-53b2fd9ebfae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", "None"}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"d4086d30-d142-4a31-b87b-bce81f9a9ee2"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192286}, v[-A$, \
-D]*v[G$192286]*v[-G$192286]]}\
\>", "Output",ExpressionUUID->"c6296a7f-bc46-4644-8439-36f72d305037"]
}, Open  ]],

Cell["2) Not patterns. Metric indices. Free:", \
"Text",ExpressionUUID->"c7392ad8-1d54-476e-a422-2d27b0ed0072"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", "D"}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", "D"}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"97f1dca1-45e5-4bac-a66e-38a0f4090c85"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, D]*v[-C$]] :> Module[{G$192290}, v[-A$, \
D]*v[G$192290]*v[-G$192290]], 
 HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192294, G$192290}, \
(v[-A$, G$192294]*v[G$192290]*v[-G$192290])*
    metricg[-G$192294, -D]]}\
\>", "Output",ExpressionUUID->"c259031b-52d1-4ef3-baac-45bb10960a42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "D"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"ad0e8466-9bcc-4df9-9853-49550c880d05"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192295}, v[-A$, \
-D]*v[G$192295]*v[-G$192295]], 
 HoldPattern[T[F, -F, -A$, C$, D]*v[-C$]] :> Module[{G$192295, G$192299}, \
(v[-A$, -G$192299]*v[G$192295]*v[-G$192295])*
    metricg[D, G$192299]]}\
\>", "Output",ExpressionUUID->"38349806-8143-49ea-b192-3dc5577afe4c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"b2b3f090-d7d2-42f9-8431-1590b17205d2"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192300}, v[-A$, \
-D]*v[G$192300]*v[-G$192300]], 
 HoldPattern[T[F, -F, -A$, C$, D]*v[-C$]] :> Module[{G$192300, G$192304}, \
(v[-A$, -G$192304]*v[G$192300]*v[-G$192300])*
    metricg[D, G$192304]]}\
\>", "Output",ExpressionUUID->"2cd3e902-f412-45b8-8797-d1cc977ee145"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", "A$", ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"A$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "A$"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"3baef361-a372-48c0-947b-a2b8e4d65348"],

Cell["\<\
{HoldPattern[T[F, -F, A$, C$, -D]*v[-C$]] :> Module[{G$192305}, v[A$, \
-D]*v[G$192305]*v[-G$192305]], 
 HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192309, G$192305}, \
(v[G$192309, -D]*v[G$192305]*v[-G$192305])*
    metricg[-G$192309, -A$]]}\
\>", "Output",ExpressionUUID->"3accd0e0-0dcc-4b4d-8c01-b6635765c3ac"]
}, Open  ]],

Cell["3) Not patterns. Metric indices. Dummy:", \
"Text",ExpressionUUID->"97f2277a-5b59-4063-903b-02a5f80943b8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "F", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"50b47d39-9045-4390-a8b7-a7bd1d6d06ac"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192310}, v[-A$, \
-D]*v[G$192310]*v[-G$192310]], 
 HoldPattern[T[-F, F, -A$, C$, -D]*v[-C$]] :> Module[{G$192310}, (v[-A$, \
-D]*v[G$192310]*v[-G$192310])*
    xAct`xTensor`Private`SymmetryOfMetric[metricg]]}\
\>", "Output",ExpressionUUID->"aa0c82f7-4baa-4880-9992-f5a91fc30ae0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", "None"}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"9770624d-166f-4790-8268-10c4afb87def"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -D]*v[-C$]] :> Module[{G$192314}, v[-A$, \
-D]*v[G$192314]*v[-G$192314]], 
 HoldPattern[T[-F, F, -A$, C$, -D]*v[-C$]] :> Module[{G$192314}, (v[-A$, \
-D]*v[G$192314]*v[-G$192314])*
    xAct`xTensor`Private`SymmetryOfMetric[metricg]]}\
\>", "Output",ExpressionUUID->"27097830-9255-447d-b2a4-d054b2775f99"]
}, Open  ]],

Cell["4) Patterns. Not metric indices. Free. No test:", \
"Text",ExpressionUUID->"4c0c1c8e-3211-4aa2-995f-1431845ee56f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", "D"}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", "D"}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"6b104fdb-97eb-4a81-ad4f-ac594a316921"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, D_Symbol]*v[-C$]] :> Module[{G$192318}, v[-A$, \
D]*v[G$192318]*v[-G$192318]]}\
\>", "Output",ExpressionUUID->"7cd317ad-3fc9-417d-9c11-c5fb8262d789"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "D"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"0906b3bd-ed5e-4a2a-a0bd-f347b9906371"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -(D_Symbol)]*v[-C$]] :> Module[{G$192322}, \
v[-A$, -D]*v[G$192322]*v[-G$192322]]}\
\>", "Output",ExpressionUUID->"6407b2dd-9112-426d-854e-3e20b4ef6f18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", "A$", ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"A$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "A$", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"3e255a7c-e58b-47d6-a661-21c16fec2fbe"],

Cell["\<\
{HoldPattern[T[F, -F, A$_Symbol, C$, -D]*v[-C$]] :> Module[{G$192326}, v[A$, \
-D]*v[G$192326]*v[-G$192326]]}\
\>", "Output",ExpressionUUID->"809845c1-75d2-48e0-bde5-1dcf7ca457f3"]
}, Open  ]],

Cell["5) Patterns. Not metric indices. Free. Test:", \
"Text",ExpressionUUID->"cd2fa99c-1f0f-4a09-9a52-7d6c2468ffe0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"dac38810-7a59-4868-b887-75bcd5d7ee55"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -(D_Symbol)?TangentM2`Q]*v[-C$]] :> 
  Module[{G$192330}, v[-A$, -D]*v[G$192330]*v[-G$192330]]}\
\>", "Output",ExpressionUUID->"160a539f-c3c2-4f04-8689-a13ecfa0ce31"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", "A$", ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"A$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "A$"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"a5be3d41-3f7d-4142-a5cc-2b5800e3d586"],

Cell["\<\
{HoldPattern[T[F, -F, (A$_Symbol)?TangentM2`Q, C$, -D]*v[-C$]] :> 
  Module[{G$192334}, v[A$, -D]*v[G$192334]*v[-G$192334]]}\
\>", "Output",ExpressionUUID->"5da9059c-d82b-4a6e-bff1-cc35d7916ce7"]
}, Open  ]],

Cell["6) Patterns. Not metric indices. Dummy. No test:", \
"Text",ExpressionUUID->"6b068979-0a03-4177-abcc-9006e7df4897"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "F", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"20d6f706-299a-4b28-813c-ef9b4922616e"],

Cell["\<\
{HoldPattern[T[F_Symbol, -(F_Symbol), -A$, C$, -D]*v[-C$]] :> \
Module[{G$192338}, v[-A$, -D]*v[G$192338]*v[-G$192338]]}\
\>", "Output",ExpressionUUID->"72d8b2c0-932c-47ca-a5ab-8eb480a0f32c"]
}, Open  ]],

Cell["7) Patterns. Not metric indices. Dummy. Test:", \
"Text",ExpressionUUID->"8a0fc3db-44e6-4120-8d0f-ea76a458653e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"2268baf4-98f8-4d51-be49-bdaa4191d090"],

Cell["\<\
{HoldPattern[T[(F_Symbol)?TangentM2`Q, -(F_Symbol)?TangentM2`Q, -A$, C$, \
-D]*v[-C$]] :> 
  Module[{G$192342}, v[-A$, -D]*v[G$192342]*v[-G$192342]]}\
\>", "Output",ExpressionUUID->"8382659a-0ff2-4e33-82f2-9f13940360d8"]
}, Open  ]],

Cell["8) Patterns. Metric indices. Free. No test:", \
"Text",ExpressionUUID->"6c447d43-f19a-41e5-8fb3-d99fbc59f505"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "D"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "D"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"28135fe3-bd0b-4da7-965b-59bcc01009c4"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, -(D_Symbol)]*v[-C$]] :> Module[{G$192347}, \
v[-A$, -D]*v[G$192347]*v[-G$192347]], 
 HoldPattern[T[F, -F, -A$, C$, D_Symbol]*v[-C$]] :> Module[{G$192347, \
G$192351}, 
   (v[-A$, -G$192351]*v[G$192347]*v[-G$192347])*metricg[D, G$192351]]}\
\>", "Output",ExpressionUUID->"1230fb4b-8320-4fa3-93b9-193f41505738"]
}, Open  ]],

Cell["9) Patterns. Metric indices. Free. Test:", \
"Text",ExpressionUUID->"569acbb2-682a-44cf-8e37-06334371e6f0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "D"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "D"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"aa628bb4-68de-4966-94b2-0b0ec659d2fd"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, (D_)?TangentM2`pmQ]*v[-C$]] :> \
Module[{G$192352, G$192356}, 
   (v[-A$, -G$192356]*v[G$192352]*v[-G$192352])*metricg[D, G$192356]]}\
\>", "Output",ExpressionUUID->"7e1d3735-464d-49fc-8f57-0a474ca69132"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", "D"}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", "D"}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"80ef5cfa-a27e-487e-99b0-b2e4f0945df1"],

Cell["\<\
{HoldPattern[T[F, -F, -A$, C$, (D_)?TangentM2`pmQ]*v[-C$]] :> \
Module[{G$192361, G$192357}, 
   (v[-A$, G$192361]*v[G$192357]*v[-G$192357])*metricg[-G$192361, D]]}\
\>", "Output",ExpressionUUID->"b25e4bcb-7114-431b-a687-fcfe14611550"]
}, Open  ]],

Cell["10) Patterns. Metric indices. Dummy. No test:", \
"Text",ExpressionUUID->"95d6a424-15a6-4905-9fe6-04a1fda8fad2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "F", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "F", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"7bef15ee-5d21-4c88-a589-25ec373709c4"],

Cell["\<\
{HoldPattern[T[F_Symbol, -(F_Symbol), -A$, C$, -D]*v[-C$]] :> \
Module[{G$192362}, v[-A$, -D]*v[G$192362]*v[-G$192362]], 
 HoldPattern[T[-(F_Symbol), F_Symbol, -A$, C$, -D]*v[-C$]] :> 
  Module[{G$192362}, (v[-A$, \
-D]*v[G$192362]*v[-G$192362])*xAct`xTensor`Private`SymmetryOfMetric[metricg]]}\
\>", "Output",ExpressionUUID->"8f6396c9-3b76-4932-88b0-3b2669dc1dac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "False"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"7baf80a1-9ac6-4d97-bfce-4cc706e6a7cb"],

Cell["\<\
{HoldPattern[T[F_Symbol, -(F_Symbol), -A$, C$, -D]*v[-C$]] :> \
Module[{G$192366}, v[-A$, -D]*v[G$192366]*v[-G$192366]], 
 HoldPattern[T[-(F_Symbol), F_Symbol, -A$, C$, -D]*v[-C$]] :> 
  Module[{G$192366}, (v[-A$, \
-D]*v[G$192366]*v[-G$192366])*xAct`xTensor`Private`SymmetryOfMetric[metricg]]}\
\>", "Output",ExpressionUUID->"009fd475-f9ef-42b3-97e8-8ed8cde00d1e"]
}, Open  ]],

Cell["11) Patterns. Metric indices. Dummy. Test:", \
"Text",ExpressionUUID->"4792ad6b-471b-4842-913c-a77e6e8b2541"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "F", "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", "F", "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"b78acd05-eef8-42eb-9fa7-60fce055911e"],

Cell["\<\
{HoldPattern[T[(F_Symbol)?TangentM2`Q, -(F_Symbol)?TangentM2`Q, -A$, C$, \
-D]*v[-C$]] :> 
  Module[{G$192370}, v[-A$, -D]*v[G$192370]*v[-G$192370]], 
 HoldPattern[T[-(F_Symbol)?TangentM2`Q, (F_Symbol)?TangentM2`Q, -A$, C$, \
-D]*v[-C$]] :> 
  Module[{G$192370}, (v[-A$, \
-D]*v[G$192370]*v[-G$192370])*xAct`xTensor`Private`SymmetryOfMetric[metricg]]}\
\>", "Output",ExpressionUUID->"d76675e5-bf75-431e-ae5d-e662aa9d5de4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"F", ",", 
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"4713eb9c-1e64-4714-8d96-9fe97be0e708"],

Cell["\<\
{HoldPattern[T[(F_Symbol)?TangentM2`Q, -(F_Symbol)?TangentM2`Q, -A$, C$, \
-D]*v[-C$]] :> 
  Module[{G$192374}, v[-A$, -D]*v[G$192374]*v[-G$192374]], 
 HoldPattern[T[-(F_Symbol)?TangentM2`Q, (F_Symbol)?TangentM2`Q, -A$, C$, \
-D]*v[-C$]] :> 
  Module[{G$192374}, (v[-A$, \
-D]*v[G$192374]*v[-G$192374])*xAct`xTensor`Private`SymmetryOfMetric[metricg]]}\
\>", "Output",ExpressionUUID->"9c343be9-c4fe-4ef3-b28a-1496d94914b2"]
}, Open  ]],

Cell["12) Patterns. Metric indices. Free. Test:", \
"Text",ExpressionUUID->"40f344e9-abcc-4980-9363-a69272d39adc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"e172cee5-a1d0-4e48-a6c9-2331f13e70cd"],

Cell["\<\
{HoldPattern[T[(F_)?TangentM2`pmQ, -A$, C$, -D]*v[-C$]] :> Module[{G$192378, \
G$192382}, 
   (v[-G$192382, -A$, -D]*v[G$192378]*v[-G$192378])*metricg[F, G$192382]]}\
\>", "Output",ExpressionUUID->"34d2bd66-a4cc-4a1c-8324-3abe9d9537aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", "C$", ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "A$"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"v", "[", "C$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "C$"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"-", "F"}], "}"}]}], ",", 
    RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
    RowBox[{"TestIndices", "\[Rule]", "True"}], ",", 
    RowBox[{"Verbose", "\[Rule]", "True"}]}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"9bd93e6c-9d00-4542-830b-7a3cee3b27a5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LHSinfo: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "F"}], ",", "True", ",", "True", ",", "True", ",", "True",
        ",", 
       RowBox[{"-", "F"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A$"}], ",", "True", ",", "False", ",", "True", ",", 
       "False", ",", 
       RowBox[{"-", "A$"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "C$", ",", "False", ",", "False", ",", "True", ",", "False", ",", 
       "C$"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "D"}], ",", "True", ",", "False", ",", "True", ",", 
       "False", ",", 
       RowBox[{"-", "D"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "C$"}], ",", "False", ",", "False", ",", "True", ",", 
       "False", ",", 
       RowBox[{"-", "C$"}]}], "}"}]}], "}"}]}],
  SequenceForm[
  "LHSinfo: ", {{-$CellContext`F, True, True, True, 
     True, -$CellContext`F}, {-$CellContext`A$, True, False, True, 
     False, -$CellContext`A$}, {
    C$, False, False, True, False, C$}, {-D, True, False, True, False, -D}, {-
     C$, False, False, True, False, -C$}}],
  Editable->
   False]], "Print",ExpressionUUID->"0bc8be41-2bcc-48ce-a1f5-d1678b55c4f2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"rulesLHS: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"F", "\[Rule]", 
      RowBox[{"F_", "?", "TangentM2`pmQ"}]}], ",", 
     RowBox[{"A$", "\[Rule]", "A$"}], ",", 
     RowBox[{
      RowBox[{"-", "A$"}], "\[Rule]", 
      RowBox[{"-", "A$"}]}], ",", 
     RowBox[{"C$", "\[Rule]", "C$"}], ",", 
     RowBox[{
      RowBox[{"-", "C$"}], "\[Rule]", 
      RowBox[{"-", "C$"}]}], ",", 
     RowBox[{"D", "\[Rule]", "D"}], ",", 
     RowBox[{
      RowBox[{"-", "D"}], "\[Rule]", 
      RowBox[{"-", "D"}]}], ",", 
     RowBox[{"C$", "\[Rule]", "C$"}], ",", 
     RowBox[{
      RowBox[{"-", "C$"}], "\[Rule]", 
      RowBox[{"-", "C$"}]}]}], "}"}]}],
  SequenceForm["rulesLHS: ", {$CellContext`F -> PatternTest[
      Pattern[$CellContext`F, 
       Blank[]], 
      TangentM2`pmQ], $CellContext`A$ -> $CellContext`A$, -$CellContext`A$ -> \
-$CellContext`A$, C$ -> C$, -C$ -> -C$, D -> D, -D -> -D, C$ -> 
    C$, -C$ -> -C$}],
  Editable->
   False]], "Print",ExpressionUUID->"b9d7183f-1a0c-49f8-bf7b-0695ebbaa0d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"symtensorsLHS: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["symtensorsLHS: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"35aea73f-a6d4-4fab-bdec-94f04c8c330c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"newLHS after symmetry handling: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"Hold", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "C$", " "},
              {"F", "A$", " ", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"C$"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-C$],
       Editable->False]}], "]"}], "}"}]}],
  SequenceForm["newLHS after symmetry handling: ", {
    Hold[$CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -
       D] $CellContext`v[-C$]]}],
  Editable->
   False]], "Print",ExpressionUUID->"b83f159f-6eb4-4654-8aff-33adabca02ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"isolated: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["isolated: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"6e3744a9-32dd-4eec-9feb-8d1004b24059"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"newLHSs after handling of isolated expressions: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"Hold", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "C$", " "},
              {"F", "A$", " ", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"C$"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-C$],
       Editable->False]}], "]"}], "}"}]}],
  SequenceForm["newLHSs after handling of isolated expressions: ", {
    Hold[$CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -
       D] $CellContext`v[-C$]]}],
  Editable->
   False]], "Print",ExpressionUUID->"89ffb569-e987-4ab0-9297-53ae25323990"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Initial rules: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{
           RowBox[{"-", "F"}], ",", " ", 
           RowBox[{"-", "A$"}], ",", " ", "C$", ",", " ", 
           RowBox[{"-", "D"}]}], "]"}], "*", 
         RowBox[{"v", "[", 
          RowBox[{"-", "C$"}], "]"}]}], "]"}], " ", "->", " ", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"v", "[", 
          RowBox[{
           RowBox[{"-", "F"}], ",", " ", 
           RowBox[{"-", "A$"}], ",", " ", 
           RowBox[{"-", "D"}]}], "]"}], "*", 
         RowBox[{"v", "[", "G$192383", "]"}], "*", 
         RowBox[{"v", "[", 
          RowBox[{"-", "G$192383"}], "]"}]}], "]"}]}], "}"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[{
     Hold[$CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -
          D] $CellContext`v[-C$]] -> 
      Hold[($CellContext`v[-$CellContext`F, -$CellContext`A$, -
           D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]]}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["Initial rules: ", 
   InputForm[{
    Hold[$CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -
         D] $CellContext`v[-C$]] -> 
     Hold[($CellContext`v[-$CellContext`F, -$CellContext`A$, -
          D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]]}]],
  Editable->
   False]], "Print",ExpressionUUID->"20f6411d-87ed-458d-a508-3c6b472eee8d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"rules after arranging minus signs: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " ", "C$", " "},
               {"F", "A$", " ", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"C$"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-C$],
        Editable->False]}], "]"}], "\[Rule]", 
     RowBox[{"Hold", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"F", "A$", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-$CellContext`F, -$CellContext`A$, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"G$192383"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`G$192383],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"G$192383"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-$CellContext`G$192383],
        Editable->False]}], "]"}]}], "}"}]}],
  SequenceForm[
  "rules after arranging minus signs: ", {
   Hold[$CellContext`T[-$CellContext`F, -$CellContext`A$, C$, -
        D] $CellContext`v[-C$]] -> 
    Hold[($CellContext`v[-$CellContext`F, -$CellContext`A$, -
         D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]]}],
  Editable->
   False]], "Print",ExpressionUUID->"703f237b-b11b-4657-bc73-14b8db7d5d2f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"rules after changRuleforfreepmQ: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"F", ",", " ", 
           RowBox[{"-", "A$"}], ",", " ", "C$", ",", " ", 
           RowBox[{"-", "D"}]}], "]"}], "*", 
         RowBox[{"v", "[", 
          RowBox[{"-", "C$"}], "]"}]}], "]"}], " ", "->", " ", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"v", "[", 
            RowBox[{
             RowBox[{"-", "G$192387"}], ",", " ", 
             RowBox[{"-", "A$"}], ",", " ", 
             RowBox[{"-", "D"}]}], "]"}], "*", 
           RowBox[{"v", "[", "G$192383", "]"}], "*", 
           RowBox[{"v", "[", 
            RowBox[{"-", "G$192383"}], "]"}]}], ")"}], "*", 
         RowBox[{"metricg", "[", 
          RowBox[{"F", ",", " ", "G$192387"}], "]"}]}], "]"}]}], "}"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[{
     Hold[$CellContext`T[$CellContext`F, -$CellContext`A$, C$, -
          D] $CellContext`v[-C$]] -> 
      Hold[(($CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -
            D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["rules after changRuleforfreepmQ: ", 
   InputForm[{
    Hold[$CellContext`T[$CellContext`F, -$CellContext`A$, C$, -
         D] $CellContext`v[-C$]] -> 
     Hold[(($CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -
           
           D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}]],
  Editable->
   False]], "Print",ExpressionUUID->"5699e0ff-36b6-4396-b838-6390b8c23588"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"rules after duplicateRuleforfree: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"F", ",", " ", 
           RowBox[{"-", "A$"}], ",", " ", "C$", ",", " ", 
           RowBox[{"-", "D"}]}], "]"}], "*", 
         RowBox[{"v", "[", 
          RowBox[{"-", "C$"}], "]"}]}], "]"}], " ", "->", " ", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"v", "[", 
            RowBox[{
             RowBox[{"-", "G$192387"}], ",", " ", 
             RowBox[{"-", "A$"}], ",", " ", 
             RowBox[{"-", "D"}]}], "]"}], "*", 
           RowBox[{"v", "[", "G$192383", "]"}], "*", 
           RowBox[{"v", "[", 
            RowBox[{"-", "G$192383"}], "]"}]}], ")"}], "*", 
         RowBox[{"metricg", "[", 
          RowBox[{"F", ",", " ", "G$192387"}], "]"}]}], "]"}]}], "}"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[{
     Hold[$CellContext`T[$CellContext`F, -$CellContext`A$, C$, -
          D] $CellContext`v[-C$]] -> 
      Hold[(($CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -
            D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["rules after duplicateRuleforfree: ", 
   InputForm[{
    Hold[$CellContext`T[$CellContext`F, -$CellContext`A$, C$, -
         D] $CellContext`v[-C$]] -> 
     Hold[(($CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -
           
           D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}]],
  Editable->
   False]], "Print",ExpressionUUID->"04de47d1-0816-434a-8537-4c8a64d955a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"rules after duplication: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"F", ",", " ", 
           RowBox[{"-", "A$"}], ",", " ", "C$", ",", " ", 
           RowBox[{"-", "D"}]}], "]"}], "*", 
         RowBox[{"v", "[", 
          RowBox[{"-", "C$"}], "]"}]}], "]"}], " ", "->", " ", 
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"v", "[", 
            RowBox[{
             RowBox[{"-", "G$192387"}], ",", " ", 
             RowBox[{"-", "A$"}], ",", " ", 
             RowBox[{"-", "D"}]}], "]"}], "*", 
           RowBox[{"v", "[", "G$192383", "]"}], "*", 
           RowBox[{"v", "[", 
            RowBox[{"-", "G$192383"}], "]"}]}], ")"}], "*", 
         RowBox[{"metricg", "[", 
          RowBox[{"F", ",", " ", "G$192387"}], "]"}]}], "]"}]}], "}"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[{
     Hold[$CellContext`T[$CellContext`F, -$CellContext`A$, C$, -
          D] $CellContext`v[-C$]] -> 
      Hold[(($CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -
            D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}],
    AutoDelete->True,
    Editable->True]}],
  SequenceForm["rules after duplication: ", 
   InputForm[{
    Hold[$CellContext`T[$CellContext`F, -$CellContext`A$, C$, -
         D] $CellContext`v[-C$]] -> 
     Hold[(($CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -
           
           D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}]],
  Editable->
   False]], "Print",ExpressionUUID->"62866f8d-eb79-4891-b5e1-f65fcaf5b441"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"rules after introducing patterns: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {
                UnderscriptBox[
                 UnderscriptBox["F", "_"], "_"], " ", "C$", " "},
               {" ", "A$", " ", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[
         PatternTest[
          Pattern[$CellContext`F, 
           Blank[]], TangentM2`pmQ], -$CellContext`A$, C$, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"C$"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-C$],
        Editable->False]}], "]"}], "\[Rule]", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {" ", " ", " "},
                 {"G$192387", "A$", "D"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`v[-$CellContext`G$192387, -$CellContext`A$, -D],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {"G$192383"},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`v[$CellContext`G$192383],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {" "},
                 {"G$192383"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`v[-$CellContext`G$192383],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"F", "G$192387"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`F, $CellContext`G$192387],
        Editable->False]}], "]"}]}], "}"}]}],
  SequenceForm["rules after introducing patterns: ", {Hold[$CellContext`T[
        PatternTest[
         Pattern[$CellContext`F, 
          Blank[]], TangentM2`pmQ], -$CellContext`A$, C$, -D] $CellContext`v[-
        C$]] -> Hold[(($CellContext`v[-$CellContext`G$192387, \
-$CellContext`A$, -
          D] $CellContext`v[$CellContext`G$192383]) \
$CellContext`v[-$CellContext`G$192383]) $CellContext`metricg[$CellContext`F, \
$CellContext`G$192387]]}],
  Editable->
   False]], "Print",ExpressionUUID->"2ff56102-394b-46d9-ac83-c055fd8e9fbf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Conditions: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Hold", "[", "]"}]}],
  SequenceForm["Conditions: ", 
   Hold[]],
  Editable->
   False]], "Print",ExpressionUUID->"1c9b9a25-23f7-40d8-a17f-a8d63f264470"]
}, Open  ]],

Cell["\<\
{HoldPattern[T[(F_)?TangentM2`pmQ, -A$, C$, -D]*v[-C$]] :> Module[{G$192383, \
G$192387}, 
   (v[-G$192387, -A$, -D]*v[G$192383]*v[-G$192383])*metricg[F, G$192387]]}\
\>", "Output",ExpressionUUID->"b74d7b23-5889-45be-9ddb-513e04236b19"]
}, Open  ]],

Cell["13) Conditions:", \
"Text",ExpressionUUID->"563a198a-131f-4169-8d4a-e4db438c6d93"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"v", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "A"}], ",", "B", ",", 
       RowBox[{"-", "B"}]}], "]"}], ",", 
     RowBox[{"v", "[", 
      RowBox[{"B", ",", 
       RowBox[{"-", "B"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"UpIndexQ", "[", "A", "]"}], "&&", 
      RowBox[{"DownIndexQ", "[", 
       RowBox[{"-", "B"}], "]"}], "&&", 
      RowBox[{"PairQ", "[", 
       RowBox[{"A", ",", 
        RowBox[{"-", "B"}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"TestIndices", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"927d7999-fd70-43f8-b7f7-3b34bff0f360"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {
             UnderscriptBox["A", "_"], " ", 
             UnderscriptBox["B", "_"], " "},
            {" ", 
             UnderscriptBox["A", "_"], " ", 
             UnderscriptBox["B", "_"]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[
      Pattern[$CellContext`A, 
       Blank[Symbol]], -Pattern[$CellContext`A, 
        Blank[Symbol]], 
      Pattern[$CellContext`B, 
       Blank[Symbol]], -Pattern[$CellContext`B, 
        Blank[Symbol]]],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$192389", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"G$192389", " "},
              {" ", "G$192389"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`G$192389, -$CellContext`G$192389],
       Editable->False]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"UpIndexQ", "[", "A", "]"}], "&&", 
     RowBox[{"DownIndexQ", "[", 
      RowBox[{"-", "B"}], "]"}], "&&", 
     RowBox[{"PairQ", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "B"}]}], "]"}]}]}]}], 
  "}"}]], "Output",ExpressionUUID->"fd967a48-9b00-4b02-a274-cb6db0b3fc80"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"53bd7fac-f86b-431b-8995-375c1c81df68"],

Cell["\<\
{HoldPattern[v[A_Symbol, -(A_Symbol), B_Symbol, -(B_Symbol)]] :> \
Module[{G$192389}, v[G$192389, -G$192389]] /; 
   UpIndexQ[A] && DownIndexQ[-B] && PairQ[A, -B]}\
\>", "Output",ExpressionUUID->"2e4da874-2de0-4228-8a1a-160ab9ef3227"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v", ",", "metricg"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"79636398-b4a8-4286-bbd9-85dcceab6c0d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"fabc36a3-6970-40af-8c01-a531849fa6c0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"4810b7a1-ac96-4c04-8d03-e8d6a06e9a31"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"7ca3e238-9732-4a79-b76b-389ae30f0459"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"b8e085f5-b580-468b-b96f-3a6ce6272da1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"f1185369-d0a3-40c6-a8b8-5eaa8d642ca8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"49e1c2e8-0e1a-4e26-998c-e690f6e55d2e"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c52f88e9-79cb-402d-b8cc-e7822d07f10c"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4.4. Examples 2. Symmetries", \
"Subsubsection",ExpressionUUID->"8b3764ea-f843-4d62-9ec5-12be6e2e0875"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"98a1e6bb-c245-4c61-a88d-1a5009cbe951"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"3b40dcd8-0850-4161-831c-c7aa87674c21"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"734b33cd-9e43-43ac-a2d1-c69982c3207a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a5fb5dd5-c640-4904-bd51-63c5c54ff87b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"47abf5e6-186f-4c9c-96e8-d9fa077bb86d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"551ae316-d1a2-46d7-b33b-5c43c294197c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"94ee5c40-56fc-405c-8ed7-434b402ef966"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c9b6f1c8-b3ed-442e-9de1-1292a132d931"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"725e0806-fa3c-4b92-ac5d-bcda846c6152"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"380be20e-d10a-47a8-b737-ecdd974e283f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"34e50227-7dc9-43ca-a118-c996b3769d0f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f3344f7c-ecff-4971-abd4-bbab39382114"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d255392e-f1c5-429f-b605-dced026ab756"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Rie[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9231b70f-52dc-4fc1-8b15-cb0d28404261"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Ric", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e254dce1-159f-4aeb-a0c2-1efcfe8d6b6b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Ric", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Ric[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"83b878d6-de11-4625-9a3c-9be27d021e54"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"RS", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"0a528c32-4ac8-4163-8dfa-176d6968d73a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`RS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1b215516-b057-4e88-ba77-72228ad8afe4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Anti", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"fc73c9f9-82b9-417a-9f92-817e3cd0a880"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Anti", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Anti[-$CellContext`A, -$CellContext`B, -C, -
    D, -$CellContext`F], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2e63b65f-afa7-40c5-9314-2877a9b22862"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"7c374598-fdf6-44fb-b0b6-e08fd2958168"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"29cab350-53dd-4e85-b5a6-dbb124030dbc"]
}, Open  ]],

Cell["Simplest case:", \
"Text",ExpressionUUID->"92aea9b6-1cc9-4143-97e4-678b70de43fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "]"}], 
      RowBox[{"S", "[", 
       RowBox[{"B", ",", "C"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "C"}], "]"}]}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
   RowBox[{"UseSymmetries", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"ff3b9b76-e467-4042-adb1-7822cdbc51ec"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {" ", " "},
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[-PatternTest[
         Pattern[$CellContext`A, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[Symbol]], TangentM2`Q]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A],
      Editable->False]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"8249a3c4-f66a-4610-8b08-d233d6c42471"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"30e9f0b3-96a7-41cf-8daa-e64e2c98e5f6"],

Cell["\<\
{HoldPattern[S[-(A_Symbol)?TangentM2`Q, \
-(B_Symbol)?TangentM2`Q]*S[(B_Symbol)?TangentM2`Q, (C_Symbol)?TangentM2`Q]*
    T[-(C_Symbol)?TangentM2`Q]] :> Module[{}, T[-A]]}\
\>", "Output",ExpressionUUID->"15fa1039-cc01-4ee0-82c6-157a1cb60d95"]
}, Open  ]],

Cell["Note the minus sign in front:", \
"Text",ExpressionUUID->"fb9262aa-eb34-4404-930d-40d986220880"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"S", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}]}], "]"}]}], 
      RowBox[{"S", "[", 
       RowBox[{"B", ",", "C"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "C"}], "]"}]}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
   RowBox[{"UseSymmetries", "\[Rule]", "False"}], ",", 
   RowBox[{"TestIndices", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"d88afe86-7ca5-4f15-bf78-c602d948432b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {" ", " "},
             {
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[-Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {
              UnderscriptBox["B", "_"], 
              UnderscriptBox["C", "_"]},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[
       Pattern[$CellContext`B, 
        Blank[Symbol]], 
       Pattern[C, 
        Blank[Symbol]]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {
              UnderscriptBox["C", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-Pattern[C, 
         Blank[Symbol]]],
      Editable->False]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"-", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"62517e0f-046e-4d0c-9fd1-1a0476e5e14a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"4a7b97fc-81c6-4e75-8436-1eb46d7abf30"],

Cell["\<\
{HoldPattern[S[-(A_Symbol), -(B_Symbol)]*S[B_Symbol, \
C_Symbol]*T[-(C_Symbol)]] :> Module[{}, -T[-A]]}\
\>", "Output",ExpressionUUID->"afb6c50c-ff60-4bd1-b1fb-44cb864a924c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "]"}], 
      RowBox[{"S", "[", 
       RowBox[{"B", ",", "C"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "C"}], "]"}]}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
   RowBox[{"TestIndices", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"e18fecc8-f906-41af-b286-21fbe3c68717"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox["A", "_"], 
               UnderscriptBox["B", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-Pattern[$CellContext`A, 
          Blank[Symbol]], -Pattern[$CellContext`B, 
          Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox["B", "_"], 
               UnderscriptBox["C", "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        Pattern[$CellContext`B, 
         Blank[Symbol]], 
        Pattern[C, 
         Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox["C", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-Pattern[C, 
          Blank[Symbol]]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox["A", "_"], 
               UnderscriptBox["B", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-Pattern[$CellContext`A, 
          Blank[Symbol]], -Pattern[$CellContext`B, 
          Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox["C", "_"], 
               UnderscriptBox["B", "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        Pattern[C, 
         Blank[Symbol]], 
        Pattern[$CellContext`B, 
         Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox["C", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-Pattern[C, 
          Blank[Symbol]]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox["B", "_"], 
               UnderscriptBox["A", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-Pattern[$CellContext`B, 
          Blank[Symbol]], -Pattern[$CellContext`A, 
          Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox["B", "_"], 
               UnderscriptBox["C", "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        Pattern[$CellContext`B, 
         Blank[Symbol]], 
        Pattern[C, 
         Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox["C", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-Pattern[C, 
          Blank[Symbol]]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox["B", "_"], 
               UnderscriptBox["A", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-Pattern[$CellContext`B, 
          Blank[Symbol]], -Pattern[$CellContext`A, 
          Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox["C", "_"], 
               UnderscriptBox["B", "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        Pattern[C, 
         Blank[Symbol]], 
        Pattern[$CellContext`B, 
         Blank[Symbol]]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox["C", "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-Pattern[C, 
          Blank[Symbol]]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"266badeb-cc09-4914-8e61-30d49343b6c7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"d4f17121-3ad2-43d1-83d1-6fe1d3733953"],

Cell["\<\
{HoldPattern[S[-(A_Symbol), -(B_Symbol)]*S[B_Symbol, \
C_Symbol]*T[-(C_Symbol)]] :> Module[{}, T[-A]], 
 HoldPattern[S[-(A_Symbol), -(B_Symbol)]*S[C_Symbol, \
B_Symbol]*T[-(C_Symbol)]] :> Module[{}, T[-A]], 
 HoldPattern[S[-(B_Symbol), -(A_Symbol)]*S[B_Symbol, \
C_Symbol]*T[-(C_Symbol)]] :> Module[{}, T[-A]], 
 HoldPattern[S[-(B_Symbol), -(A_Symbol)]*S[C_Symbol, \
B_Symbol]*T[-(C_Symbol)]] :> Module[{}, T[-A]]}\
\>", "Output",ExpressionUUID->"88485b41-9e75-435e-934f-5d5fde23cfa8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"eb03be91-f894-4e5d-98ef-94afc539cb3a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}]}], "]"}], 
       RowBox[{"S", "[", 
        RowBox[{"B", ",", "C"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"-", "C"}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", "All"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"e0f92ba3-de1f-45a0-8234-4e54bfef5d06"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"37f57b7b-58d6-45c6-b975-a6b1f7019b20"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "metricg", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"cd1edf8f-5211-4568-887d-7900c029ecf0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"xATP`SymmetryOfMetric", "[", "metricg", "]"}], ",", "1"}], "]"}],
   ";"}]], "Input",ExpressionUUID->"0e8cb1bd-5d5a-4557-a961-34a0762f1fa1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}]}], "]"}], 
       RowBox[{"S", "[", 
        RowBox[{"B", ",", "C"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"-", "C"}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", "All"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"b8f714d7-1939-4c33-8e3d-52e83f1c6f71"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194782", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194782"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194782],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194782"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194782],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194782", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194782"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194782],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194782"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194782],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194782", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194782"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194782],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194782"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194782],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194782", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194782"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194782],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194782"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194782],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194783", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194783"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194783],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194783"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194783],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194783", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194783"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194783],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194783"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194783],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194783", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194783"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194783],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194783"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194783],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194783", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194783"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194783],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194783"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194783],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194784", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194784"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194784],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194784"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194784],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194784", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194784"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194784],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194784"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194784],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194784", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194784"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194784],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194784"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194784],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194784", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194784"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194784],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194784"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194784],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194785", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194785"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194785],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194785"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194785],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194785", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194785"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194785],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194785"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194785],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194785", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194785"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194785],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194785"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194785],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$194785", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$194785"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$194785],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$194785"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$194785],
        Editable->False]}]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"e0d711b2-9bcc-469f-9500-46f3d567d56c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScreenDollarIndices", "[", "rule", 
  "]"}]], "Input",ExpressionUUID->"c43a5c72-ed2a-437e-b04e-14872a40043c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "D", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, D],
        Editable->False]}]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"f7d4f66f-cc8a-40e0-8faa-888f39928800"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"T", "[", "C", "]"}]}], "/.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"6488d3dc-7235-47e8-bc8d-04bc9512a033"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"7e3806e2-7e51-4e42-ac01-df2208769306"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rule", "=", 
   RowBox[{"MakeRule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Rie", "[", 
         RowBox[{
          RowBox[{"-", "A"}], ",", 
          RowBox[{"-", "B"}], ",", 
          RowBox[{"-", "C"}], ",", 
          RowBox[{"-", "D"}]}], "]"}], 
        RowBox[{"T", "[", "B", "]"}], 
        RowBox[{"V", "[", "D", "]"}]}], ",", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"-", "A"}], "]"}], 
        RowBox[{"V", "[", 
         RowBox[{"-", "C"}], "]"}]}]}], "}"}], ",", 
     RowBox[{"MetricOn", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"B", ",", "D"}], "}"}]}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"543a1bc9-52ed-4547-841c-15dc434114d0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", "B", "]"}], 
      RowBox[{"V", "[", "D", "]"}]}], ",", 
     RowBox[{
      RowBox[{"T", "[", "B", "]"}], 
      RowBox[{"V", "[", "C", "]"}]}], ",", 
     RowBox[{
      RowBox[{"V", "[", "A", "]"}], 
      RowBox[{"T", "[", "D", "]"}]}], ",", 
     RowBox[{
      RowBox[{"T", "[", "C", "]"}], 
      RowBox[{"V", "[", "A", "]"}]}], ",", 
     RowBox[{
      RowBox[{"V", "[", "B", "]"}], 
      RowBox[{"T", "[", "D", "]"}]}]}], "}"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"41062105-aab3-4782-a439-e03832af7ccc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-C],
     Editable->False]}], ",", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A],
      Editable->False]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-D],
     Editable->False]}], ",", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {"C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-C],
      Editable->False]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`B],
     Editable->False]}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" "},
            {"D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`B],
     Editable->False]}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" "},
            {"C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"1179aed0-1a08-4ff7-862b-ba593ff3bd2d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"-", "B"}], "]"}], 
   RowBox[{"V", "[", "D", "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"10e02843-8869-49f4-99bc-6180be856e7a"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[-C],
   Editable->
    False]}]], "Output",ExpressionUUID->"d4e77b44-28bd-4387-bde7-24d04411e103"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", "C", ",", "D"}], "]"}], 
   RowBox[{"T", "[", "A", "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "D"}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"7093f5ae-b126-488f-94ad-c7fe5307acbd"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", "C", "D"},
          {"A", "B", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`A, -$CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" "},
          {"D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[-D],
   Editable->
    False]}]], "Output",ExpressionUUID->"710a3b7c-376e-479f-9bf3-55bb0a1850d6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rule", "=", 
   RowBox[{"MakeRule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Rie", "[", 
         RowBox[{"A", ",", 
          RowBox[{"-", "B"}], ",", "C", ",", 
          RowBox[{"-", "D"}]}], "]"}], 
        RowBox[{"T", "[", "B", "]"}], 
        RowBox[{"V", "[", "D", "]"}]}], ",", 
       RowBox[{
        RowBox[{"T", "[", "A", "]"}], 
        RowBox[{"V", "[", "C", "]"}]}]}], "}"}], ",", 
     RowBox[{"MetricOn", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"B", ",", "D"}], "}"}]}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"d77c5e50-9432-489a-8471-6560ee47059b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", "C", ",", "D"}], "]"}], 
   RowBox[{"T", "[", "B", "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "D"}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"d10dbcf5-9dce-4239-a634-cb0146e62aa1"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", "C", "D"},
          {"A", "B", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`A, -$CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" "},
          {"D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[-D],
   Editable->
    False]}]], "Output",ExpressionUUID->"a079fbe6-0180-4a7e-959f-55b164bc0351"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rule", "=", 
   RowBox[{"MakeRule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"S", "[", 
         RowBox[{
          RowBox[{"-", "A"}], ",", 
          RowBox[{"-", "B"}]}], "]"}], 
        RowBox[{"T", "[", "B", "]"}]}], ",", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"-", "A"}], "]"}], 
        RowBox[{"T", "[", "B", "]"}], 
        RowBox[{"T", "[", 
         RowBox[{"-", "B"}], "]"}]}]}], "}"}], ",", 
     RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"c92e10c3-1446-41ef-b49d-8762881cc9b7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"-", "B"}], "]"}]}], "/.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"7ce0c0ed-0889-475c-93cf-b496793e5fe6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C],
   Editable->
    False]}]], "Output",ExpressionUUID->"54d7a620-6d7e-43d9-b896-df086988cbef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"T", "[", "C", "]"}]}], "/.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"cbf14387-115d-43ff-8f01-7f3bfd81d51f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "C"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C],
   Editable->
    False]}]], "Output",ExpressionUUID->"fd558bf9-d7d4-45a8-868a-0bc873c9d096"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"-", "B"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"T", "[", "C", "]"}]}], "/.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"46041ec8-b2b4-4400-b324-7ccd19d8ff9e"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "D"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"B", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[$CellContext`B, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"C"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-D],
   Editable->
    False]}]], "Output",ExpressionUUID->"81d037e5-08f5-4506-948b-1155974c181b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"-", "B"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"T", "[", "C", "]"}]}], "//.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"17830bc1-b25f-429b-b3f4-2368bbf95544"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "D"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "F"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"C"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"F"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`F],
   Editable->
    False]}]], "Output",ExpressionUUID->"dbf7cd84-70f6-4213-b249-bbd637961433"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", "B", ",", 
         RowBox[{"-", "C"}]}], "]"}], "+", 
       RowBox[{"T", "[", 
        RowBox[{"D", ",", 
         RowBox[{"-", "D"}], ",", 
         RowBox[{"-", "C"}]}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "C"}], ",", "B", ",", 
        RowBox[{"-", "B"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"B", ",", "C", ",", "A"}], "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"67b4b958-9cae-4c65-9632-a21e43b38efb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"MakeRule", "::", "terms"}], "MessageName"], ":", 
  " ", "\<\"There is more than one term on the LHS of rule.\"\>"}]], \
"Message", "MSG",ExpressionUUID->"1763f841-a335-4c99-9275-790f26cdcbaa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "D"}], ",", "C"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"B", ",", "D", ",", 
         RowBox[{"-", "C"}]}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", "False"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"03bbb896-605e-4137-bd08-1e430fc9094a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"MakeRule", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"indices\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(False\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a94b5c4e-3634-4ebb-b7ff-26e2eb5823e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "D"}], ",", "C"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"B", ",", "D", ",", 
        RowBox[{"-", "C"}]}], "]"}]}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
   RowBox[{"MetricOn", "\[Rule]", "None"}]}], 
  "]"}]], "Input",ExpressionUUID->"3a62b9b0-5000-478a-8ec4-0f403eecc95a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " ", " ", 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]},
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["D", "_"], "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-PatternTest[
         Pattern[$CellContext`A, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[Symbol]], TangentM2`Q]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["D", "_"], "_"], " "},
             {" ", " ", 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[D, 
         Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A],
      Editable->False]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"26bb82df-807d-4aa7-8095-68658571af41"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "D"}], ",", "C"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"B", ",", "D", ",", 
        RowBox[{"-", "C"}]}], "]"}]}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
   RowBox[{"MetricOn", "\[Rule]", 
    RowBox[{"{", "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"6e380884-ad86-4b68-9c12-2e8bd0bb7f62"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " ", " ", 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]},
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["D", "_"], "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-PatternTest[
         Pattern[$CellContext`A, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[Symbol]], TangentM2`Q]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["D", "_"], "_"], " "},
             {" ", " ", 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[D, 
         Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False]}], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A],
      Editable->False]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"a35c1372-5434-43ca-b90b-58802cf54a6b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "D"}], ",", "C"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"B", ",", "D", ",", 
         RowBox[{"-", "C"}]}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", "D", "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"65ae9549-2c4a-4e80-9b89-e522188479df"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", " ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[C, 
          Blank[Symbol]], TangentM2`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["C", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[C, 
           Blank[Symbol]], TangentM2`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"5b3ec218-c518-4600-ae81-1aae061dec0a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"9ce106ec-33d9-4240-aa0c-ea4a350aee6e"],

Cell["\<\
{HoldPattern[T[-(A_Symbol)?TangentM2`Q, -(B_Symbol)?TangentM2`Q, \
-(D_Symbol)?TangentM2`Q, (C_Symbol)?TangentM2`Q]*
    T[(B_Symbol)?TangentM2`Q, (D_Symbol)?TangentM2`Q, \
-(C_Symbol)?TangentM2`Q]] :> Module[{}, T[-A]], 
 HoldPattern[T[-(A_Symbol)?TangentM2`Q, -(B_Symbol)?TangentM2`Q, \
(D_Symbol)?TangentM2`Q, (C_Symbol)?TangentM2`Q]*
    T[(B_Symbol)?TangentM2`Q, -(D_Symbol)?TangentM2`Q, \
-(C_Symbol)?TangentM2`Q]] :> Module[{}, T[-A]]}\
\>", "Output",ExpressionUUID->"99207cf7-81fe-48ae-adf0-f9007fe7dd23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "D"}], ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "D", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"5f068dd0-26b2-4823-ac62-0f7137e68c32"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" "},
         {"A"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[-$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"26ab82c7-ece5-4926-828f-0014788177e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", 
     RowBox[{"-", "D"}], ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "D", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"36eb834a-5ff8-47e4-b243-8919873ebdbf"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "D", " "},
          {"B", " ", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, D, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B", " ", "C"},
          {"A", " ", "D", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, $CellContext`B, -D, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"f11787e3-3dbe-4b65-9f6b-09f5732ca29c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "D"}], ",", "C"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"B", ",", "D", ",", 
         RowBox[{"-", "C"}]}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"D", ",", "C"}], "}"}]}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"A", ",", "B", ",", "D"}], "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2d8e0f34-a7c9-4883-b3ec-198abcc77563"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", " ", "C"},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", " ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`A, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A],
       Editable->False]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"31df548f-fd64-4310-893d-0c26e03cdf8c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "D"}], ",", "C"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"B", ",", "D", ",", 
         RowBox[{"-", "C"}]}], "]"}]}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
    RowBox[{"PatternIndices", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"A", ",", "B", ",", "D"}], "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"287bf875-de34-4d07-8ddb-8fb56f32ccf9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", " ", "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", " ", " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"},
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "},
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", " ", " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "C"},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "G$197165", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"G$197165"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G$197165],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "G$197165"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`G$197165],
        Editable->False]}]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"c1df6e39-cc08-4cbd-a96e-72cf109c0dc3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"2b3caae4-b8d3-47d6-a028-01321466f08a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", " ", "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", " ", " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], -PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"},
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", " "},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "},
              {" ", " ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], "C"},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["A", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "},
              {" ", " ", " ", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        PatternTest[
         Pattern[$CellContext`A, 
          Blank[]], TangentM2`pmQ], 
        PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
        PatternTest[
         Pattern[D, 
          Blank[Symbol]], TangentM2`Q], -C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "C"},
              {
               UnderscriptBox[
                UnderscriptBox["B", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["D", "_"], "_"], " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-PatternTest[
          Pattern[$CellContext`B, 
           Blank[Symbol]], TangentM2`Q], -PatternTest[
          Pattern[D, 
           Blank[Symbol]], TangentM2`Q], C],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "F", "}"}], ",", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`F],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"A", "F"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[$CellContext`A, $CellContext`F],
        Editable->False]}]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"761544c9-ab97-4dea-99f5-48ca4a36c681"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"f2c14ded-c37a-4c86-bf29-1c7a7fb7b754"],

Cell["\<\
{HoldPattern[T[(A_)?TangentM2`pmQ, -(B_Symbol)?TangentM2`Q, \
-(D_Symbol)?TangentM2`Q, C]*
    T[(B_Symbol)?TangentM2`Q, (D_Symbol)?TangentM2`Q, -C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, -(B_Symbol)?TangentM2`Q, \
(D_Symbol)?TangentM2`Q, C]*
    T[(B_Symbol)?TangentM2`Q, -(D_Symbol)?TangentM2`Q, -C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, -(B_Symbol)?TangentM2`Q, \
-(D_Symbol)?TangentM2`Q, -C]*
    T[(B_Symbol)?TangentM2`Q, (D_Symbol)?TangentM2`Q, C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, -(B_Symbol)?TangentM2`Q, \
(D_Symbol)?TangentM2`Q, -C]*
    T[(B_Symbol)?TangentM2`Q, -(D_Symbol)?TangentM2`Q, C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, (B_Symbol)?TangentM2`Q, \
-(D_Symbol)?TangentM2`Q, C]*
    T[-(B_Symbol)?TangentM2`Q, (D_Symbol)?TangentM2`Q, -C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, (B_Symbol)?TangentM2`Q, \
(D_Symbol)?TangentM2`Q, C]*
    T[-(B_Symbol)?TangentM2`Q, -(D_Symbol)?TangentM2`Q, -C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, (B_Symbol)?TangentM2`Q, \
-(D_Symbol)?TangentM2`Q, -C]*
    T[-(B_Symbol)?TangentM2`Q, (D_Symbol)?TangentM2`Q, C]] :> Module[{F}, \
T[-F]*metricg[A, F]], 
 HoldPattern[T[(A_)?TangentM2`pmQ, (B_Symbol)?TangentM2`Q, \
(D_Symbol)?TangentM2`Q, -C]*
    T[-(B_Symbol)?TangentM2`Q, -(D_Symbol)?TangentM2`Q, C]] :> Module[{F}, \
T[-F]*metricg[A, F]]}\
\>", "Output",ExpressionUUID->"207e5adc-50a0-4b29-b5bc-675211debc39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "D"}], ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "D", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"4eb122f3-e457-4214-8950-67c497a03cab"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "G$197165$197175"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, $CellContext`G$197165$197175],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"G$197165$197175"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`G$197165$197175],
   Editable->
    False]}]], "Output",ExpressionUUID->"cb189eb6-5a4a-4011-920f-fffb2459e1e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", 
     RowBox[{"-", "D"}], ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "D", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"caf4a8c3-f509-48d4-b3f7-2f9158bd1f52"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "G$197165$197176"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, $CellContext`G$197165$197176],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"G$197165$197176"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`G$197165$197176],
   Editable->
    False]}]], "Output",ExpressionUUID->"0688e309-17c4-4ba7-b37e-693103d44def"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "D", ",", "C"}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"33e3f1d4-9f9e-4463-87a2-a9eb4e37d6d2"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "G$197165$197177"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, $CellContext`G$197165$197177],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"G$197165$197177"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`G$197165$197177],
   Editable->
    False]}]], "Output",ExpressionUUID->"c12bcf9b-3d65-4e4f-b354-faedbb567497"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "D", ",", "C"}], "]"}]}], "/.", 
  "rule"}]], "Input",ExpressionUUID->"f9f0b521-62e0-4e19-bb09-39c9b86c11fa"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "G$197165$197178"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, $CellContext`G$197165$197178],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" "},
          {"G$197165$197178"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`G$197165$197178],
   Editable->
    False]}]], "Output",ExpressionUUID->"b3d14d29-312f-4349-b235-db86dffeb836"]
}, Open  ]],

Cell["\<\
Note that here we do not need to use MetricOn on index b because the \
symmetries of the Riemann tensor automatically account for that. There is no \
danger, however, in using MetricOn->All: we will just get every rule twice.\
\>", "Text",ExpressionUUID->"70318af5-1b03-41f8-8f4c-6c51b3c9839f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Rie", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}], ",", "B"}], "]"}], ",", 
     RowBox[{"Ric", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "C"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
   RowBox[{"MetricOn", "\[Rule]", "None"}]}], 
  "]"}]], "Input",ExpressionUUID->"cdc141e2-da77-4328-aa4d-4c4512e7a2e7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", " ", " ", 
              UnderscriptBox["B", "_"]},
             {
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"], 
              UnderscriptBox["C", "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]], -Pattern[C, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Ric", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Ric[-$CellContext`A, -C],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", " ", " ", 
              UnderscriptBox["B", "_"]},
             {
              UnderscriptBox["B", "_"], 
              UnderscriptBox["A", "_"], 
              UnderscriptBox["C", "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-Pattern[$CellContext`B, 
         Blank[Symbol]], -Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[C, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Ric", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Ric[-$CellContext`A, -C],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", " ", 
              UnderscriptBox["B", "_"], " "},
             {
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"], " ", 
              UnderscriptBox["C", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]], -Pattern[C, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Ric", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Ric[-$CellContext`A, -C],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", " ", 
              UnderscriptBox["B", "_"], " "},
             {
              UnderscriptBox["B", "_"], 
              UnderscriptBox["A", "_"], " ", 
              UnderscriptBox["C", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-Pattern[$CellContext`B, 
         Blank[Symbol]], -Pattern[$CellContext`A, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]], -Pattern[C, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Ric", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Ric[-$CellContext`A, -C],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", 
              UnderscriptBox["B", "_"], " ", " "},
             {
              UnderscriptBox["C", "_"], " ", 
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-Pattern[C, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]], -Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Ric", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Ric[-$CellContext`A, -C],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", 
              UnderscriptBox["B", "_"], " ", " "},
             {
              UnderscriptBox["C", "_"], " ", 
              UnderscriptBox["B", "_"], 
              UnderscriptBox["A", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-Pattern[C, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]], -Pattern[$CellContext`A, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Ric", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Ric[-$CellContext`A, -C],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox["B", "_"], " ", " ", " "},
             {" ", 
              UnderscriptBox["C", "_"], 
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       Pattern[$CellContext`B, 
        Blank[Symbol]], -Pattern[C, 
         Blank[Symbol]], -Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Ric", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Ric[-$CellContext`A, -C],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox["B", "_"], " ", " ", " "},
             {" ", 
              UnderscriptBox["C", "_"], 
              UnderscriptBox["B", "_"], 
              UnderscriptBox["A", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       Pattern[$CellContext`B, 
        Blank[Symbol]], -Pattern[C, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]], -Pattern[$CellContext`A, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Ric", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Ric[-$CellContext`A, -C],
       Editable->False]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"a314ed7f-a2c7-4b71-b924-296cc2172e04"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Ric", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "A"}], "]"}], ",", 
    RowBox[{"RS", "[", "]"}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"79d7469d-3562-461c-8d29-69d313a7c39d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Ric", 
          StyleBox[GridBox[{
             {" ", 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"]},
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Ric[-PatternTest[
         Pattern[$CellContext`A, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[Symbol]], TangentM2`Q]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox["RS",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RS[],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Ric", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], " "},
             {" ", 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Ric[
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[$CellContext`A, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox["RS",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RS[],
       Editable->False]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"2009c2d5-d8a6-4024-adf4-5f0640a24bd1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"MakeRule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Rie", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "C"}], ",", "B"}], "]"}], ",", 
      RowBox[{"Ric", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "C"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"A", ",", "C"}], "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2e1d0759-8e64-4214-b599-01eb872bb2ac"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], " ", 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"]},
             {" ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197218", ",", "G$197226"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"Ric", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"G$197218", "G$197226"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Ric[-$CellContext`G$197218, -$CellContext`G$197226],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197218"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197218],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197226"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197226],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"]},
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197219", ",", "G$197227"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"Ric", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"G$197219", "G$197227"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Ric[-$CellContext`G$197219, -$CellContext`G$197227],
           Editable->False]}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197219"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197219],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197227"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197227],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], " ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]},
             {" ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197220", ",", "G$197228"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"Ric", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"G$197220", "G$197228"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Ric[-$CellContext`G$197220, -$CellContext`G$197228],
           Editable->False]}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197220"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197220],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197228"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197228],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {" ", 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"]},
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[-PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197221", ",", "G$197229"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"Ric", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"G$197221", "G$197229"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Ric[-$CellContext`G$197221, -$CellContext`G$197229],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197221"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197221],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197229"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197229],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], " "},
             {" ", " ", " ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197222", ",", "G$197230"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"Ric", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"G$197222", "G$197230"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Ric[-$CellContext`G$197222, -$CellContext`G$197230],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197222"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197222],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197230"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197230],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " ", 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"]},
             {" ", " ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197223", ",", "G$197231"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"Ric", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"G$197223", "G$197231"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Ric[-$CellContext`G$197223, -$CellContext`G$197231],
           Editable->False]}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197223"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197223],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197231"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197231],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"], " "},
             {" ", " ", " ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197224", ",", "G$197232"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"Ric", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"G$197224", "G$197232"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Ric[-$CellContext`G$197224, -$CellContext`G$197232],
           Editable->False]}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197224"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197224],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197232"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197232],
        Editable->False]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"Rie", 
          StyleBox[GridBox[{
             {
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], 
              UnderscriptBox[
               UnderscriptBox["C", "_"], "_"], " ", 
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"]},
             {" ", " ", 
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Rie[
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[C, 
         Blank[]], TangentM2`pmQ], -PatternTest[
         Pattern[$CellContext`B, 
          Blank[Symbol]], TangentM2`Q], 
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[]], TangentM2`pmQ]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"G$197225", ",", "G$197233"}], "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"Ric", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"G$197225", "G$197233"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Ric[-$CellContext`G$197225, -$CellContext`G$197233],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"g", 
              StyleBox[GridBox[{
                 {"A", "G$197225"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metricg[$CellContext`A, $CellContext`G$197225],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {"C", "G$197233"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[C, $CellContext`G$197233],
        Editable->False]}]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"01eff287-54bd-4148-951e-721121b03da1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "rule", 
  "]"}]], "Input",ExpressionUUID->"dfb4568c-feda-41f4-9e51-71dab0914c94"],

Cell[BoxData["8"], \
"Output",ExpressionUUID->"1f308182-7231-435d-95c9-18053662b5f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", "A", ",", "C"}], "]"}], "/.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"6c2f73e4-69da-4ce3-8e42-1d25abf2e8c8"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "A"},
          {"B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`B, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"C", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Ric", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Ric[-$CellContext`A, -D],
   Editable->
    False]}]], "Output",ExpressionUUID->"6892d462-a646-4a7d-afae-a15b659c91a0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "M2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"f41c6afa-9532-4816-b082-56b8b1f36511"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "/@", 
  "$Tensors"}]], \
"Input",ExpressionUUID->"b56159e5-be73-4041-b3cc-c952f8dcdd0d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"511c9f8a-11b0-4b96-bafb-17241c6ca42d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"0735e889-b5a6-463f-b617-b8c199bc1937"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"7106ae86-09fe-4da2-9db1-9220aa9685ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Rie"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`Rie],
  Editable->
   False]], "Print",ExpressionUUID->"a0a42d9e-c3a1-41ba-b1f7-3c8e20b011db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Ric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`Ric],
  Editable->
   False]], "Print",ExpressionUUID->"59ded2c9-fda3-442f-b816-264e1e833e48"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "RS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`RS],
  Editable->
   False]], "Print",ExpressionUUID->"4a305d49-448b-43d8-86ab-39a60697195e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Anti"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`Anti],
  Editable->
   False]], "Print",ExpressionUUID->"b9821cc4-1137-4f9d-9bd5-26edb38c42dc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"d3b9caff-280e-47ba-9174-293225878bbb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", 
   ",", "Null", ",", "Null"}], 
  "}"}]], "Output",ExpressionUUID->"84636a7d-9058-4cd6-b019-d07ccd55aced"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"26eec369-ec17-41e4-896a-df40a7cb5fd8"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"247ba144-c4ad-4962-8621-920436568ce4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"f662a978-1174-482b-b3f5-469070a28162"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "rule", 
  "]"}]], "Input",ExpressionUUID->"f02c7f13-f410-487d-b5eb-c50c3bb97032"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"74a3d53e-762c-4284-8509-d4f059c78f56"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4.5. Examples 3. Basis indices", \
"Subsubsection",ExpressionUUID->"1b5af2fa-df65-4bd7-a9b8-9390c67e71f7"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"a73e1922-24d5-4d25-86f5-b535c66cbaba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "MakeRule", 
  "]"}]], "Input",ExpressionUUID->"01ba7744-8b76-4d8f-9c10-553399be67b6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"PatternIndices", "\[Rule]", "All"}], ",", 
   RowBox[{"TestIndices", "\[Rule]", "True"}], ",", 
   RowBox[{"MetricOn", "\[Rule]", "None"}], ",", 
   RowBox[{"UseSymmetries", "\[Rule]", "True"}], ",", 
   RowBox[{"Verbose", "\[Rule]", "False"}], ",", 
   RowBox[{"ContractMetrics", "\[Rule]", "False"}], ",", 
   RowBox[{"Evaluate", "\[Rule]", "False"}]}], 
  "}"}]], "Output",ExpressionUUID->"c26de7c2-e85a-4039-b9bf-93b1dd6e98ae"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"294262f7-69f5-4b69-9faf-c007122f2567"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8bde74c1-d391-4131-8ba1-d5a225c6b293"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"15bfca57-7bac-4bd5-8d96-62b88eebc963"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9f780a4f-521c-418e-b5f1-d1a4ab28e900"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6f99e92c-8c3d-4ba7-b450-c955a9442fcb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"312b1107-6e7f-4037-b24d-b996442ee17a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"d15efe00-8f03-4aed-9e64-0609f1aa70c6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4614a794-1308-4d00-8e28-0b52d94974b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"389ee92b-159e-4c0e-b343-bfd3d56a7744"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b140397d-8c54-465c-bef7-8470081e35f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule2", "=", 
  RowBox[{"IndexRule", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A_", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "B_"}], ",", "polar"}], "}"}], ",", "C_"}], "]"}], ",", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"{", 
       RowBox[{"A", ",", "polar"}], "}"}], "]"}], 
     RowBox[{"V", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "B"}], ",", "polar"}], "}"}], "]"}], 
     RowBox[{"V", "[", "C", "]"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2e8cccfc-1f15-4fa4-9ce7-18632e831730"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {
            StyleBox[
             UnderscriptBox["A", "_"],
             FontColor->RGBColor[0., 1., 0.]], " ", 
            UnderscriptBox["C", "_"]},
           {" ", 
            StyleBox[
             UnderscriptBox["B", "_"],
             FontColor->RGBColor[0., 1., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[{
      Pattern[$CellContext`A, 
       Blank[]], $CellContext`polar}, {-Pattern[$CellContext`B, 
        Blank[]], $CellContext`polar}, 
     Pattern[C, 
      Blank[]]],
    Editable->False], "]"}], "\[RuleDelayed]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"C"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {
              StyleBox["A",
               FontColor->RGBColor[0., 1., 0.]]},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[{$CellContext`A, $CellContext`polar}],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {" "},
             {
              StyleBox["B",
               FontColor->RGBColor[0., 1., 0.]]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[{-$CellContext`B, $CellContext`polar}],
      Editable->False]}]}], 
   "]"}]}]], "Output",ExpressionUUID->"7f5b75c2-8c4d-4cdc-8e2e-b651b7eafd36"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule2", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"2c48ae79-5a99-486a-8da1-d7f7602ec35c"],

Cell["\<\
HoldPattern[S[{A_, polar}, {-(B_), polar}, C_]] :> Module[{}, V[C]*V[{A, \
polar}]*V[{-B, polar}]]\
\>", "Output",ExpressionUUID->"91108985-a33a-4eb1-a8a6-564df65e40d9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"C", ",", "polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "polar"}], "}"}], ",", "F"}], "]"}], "/.", 
  "rule2"}]], "Input",ExpressionUUID->"5d59d87a-5f5a-4903-a31a-c35224f2a3e4"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {"F"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[$CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" "},
          {
           StyleBox["C",
            FontColor->RGBColor[0., 1., 0.]]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[{-C, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {
           StyleBox["C",
            FontColor->RGBColor[0., 1., 0.]]},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[{C, $CellContext`polar}],
   Editable->
    False]}]], "Output",ExpressionUUID->"8613a088-f5b1-4e15-bfb8-d45338cf3eed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRule", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"B", ",", "polar"}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"{", 
       RowBox[{"A", ",", "polar"}], "}"}], "]"}], 
     RowBox[{"V", "[", 
      RowBox[{"{", 
       RowBox[{"B", ",", "polar"}], "}"}], "]"}]}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"0512bbbc-922a-4425-989b-95a2e3558124"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {
             StyleBox[
              UnderscriptBox[
               UnderscriptBox["A", "_"], "_"],
              FontColor->RGBColor[0., 1., 0.]], 
             StyleBox[
              UnderscriptBox[
               UnderscriptBox["B", "_"], "_"],
              FontColor->RGBColor[0., 1., 0.]]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[{
       PatternTest[
        Pattern[$CellContext`A, 
         Blank[Symbol]], TangentM2`Q], $CellContext`polar}, {
       PatternTest[
        Pattern[$CellContext`B, 
         Blank[Symbol]], TangentM2`Q], $CellContext`polar}],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {
               StyleBox["A",
                FontColor->RGBColor[0., 1., 0.]]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[{$CellContext`A, $CellContext`polar}],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {
               StyleBox["B",
                FontColor->RGBColor[0., 1., 0.]]},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[{$CellContext`B, $CellContext`polar}],
       Editable->False]}]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"165712f5-21bd-459f-94a7-cffa1bc59d66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "V", 
  "]"}]], "Input",ExpressionUUID->"9e41a0a4-7b79-4a1b-95e1-d59799306d87"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"8a90412e-132d-461c-8711-f4d3fecbb50b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "S", 
  "]"}]], "Input",ExpressionUUID->"c0634c43-7880-479c-a8d9-8db501bdc84c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"3a230567-9bb7-4c74-b3e8-4d7048aa0c90"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"52338a7a-003e-45cf-95c5-a1e6c93827e1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"e63cb497-40c1-4974-8dda-fe344a97925f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"45e0d5b3-ce19-4072-9f6e-be1d4da9ecb4"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"polar", ",", "rule2"}], 
  "]"}]], "Input",ExpressionUUID->"6b1c2711-233d-474b-b529-16fb92d64fc8"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9ddadb0e-6c66-48e3-9f2f-009b9f7fe065"]
}, Closed]],

Cell[CellGroupData[{

Cell["10.4.6. ToRule", \
"Subsubsection",ExpressionUUID->"3cf05bcc-fec2-44ad-ad47-2f942485184f"],

Cell["\<\
The design of MakeRule is not very good. Its use of List in the first \
argument and its Hold attribute make users of xAct to create their own \
drivers to it, like Alfonso\[CloseCurlyQuote]s function\
\>", "Text",ExpressionUUID->"0a57df1f-5069-4a06-9070-3739c0084a11"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ApplyRuleN", "[", "expr_", "]"}], ":=", 
   RowBox[{"MakeRule", "[", 
    RowBox[{"Evaluate", "[", 
     RowBox[{"List", "@@", "expr"}], "]"}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.412482735569118*^9, 3.4124827572186728`*^9}, 
   3.517656138175105*^9},ExpressionUUID->"e2f2c587-398f-4bb0-952c-\
7d2b7db87408"],

Cell["We introduce the function ToRule, a driver for MakeRule:", \
"Text",ExpressionUUID->"5988e01f-c8e0-49a5-b530-ee9e19d32278"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ToRule", "]"}], "=", 
   RowBox[{"Options", "[", "MakeRule", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToRule", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{"(", 
       RowBox[{"_Equal", "|", "_Rule", "|", "_RuleDelayed"}], ")"}]}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"list", "=", 
       RowBox[{"List", "@@", "expr"}]}], "}"}], ",", 
     RowBox[{"MakeRule", "[", 
      RowBox[{"list", ",", "options"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToRule", "[", 
    RowBox[{"{", "}"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToRule", "[", 
    RowBox[{
     RowBox[{"list", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_Equal", "|", "_Rule", "|", "_RuleDelayed", "|", "_List"}], 
         ")"}], ".."}], "}"}]}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"Join", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"ToRule", "[", 
        RowBox[{"#", ",", "options"}], "]"}], "&"}], "/@", "list"}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToRule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lhs_", ",", "rhs_", ",", "cond___"}], "}"}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{"MakeRule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lhs", ",", "rhs", ",", "cond"}], "}"}], ",", "options"}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9f3efff1-f512-44cc-ae67-b964e5209e87"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["10.5. AutomaticRules", \
"Subsection",ExpressionUUID->"037037e5-b7ec-42e3-95ab-10968e3fb63e"],

Cell["\<\
This function gives the minimum depth of symbol in expr. If the depth is 0 we \
can define a downvalue for symbol. If it is 1, we define an upvalue. If it is \
more than 1, then a generic rule is defined. Note that we need to eliminate \
HoldPattern from the expressions.\
\>", "Text",ExpressionUUID->"680061ed-3685-4935-bebd-0d2a2b1e994a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"minimumdepth", "[", 
   RowBox[{"expr_", ",", "symbol_"}], "]"}], ":=", 
  RowBox[{"Min", "[", 
   RowBox[{"Length", "/@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"expr", "/.", 
         RowBox[{"HoldPattern", "\[Rule]", "Identity"}]}], ",", "symbol"}], 
       "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "x___", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", "x", "}"}]}]}], "]"}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a9a3327d-87f6-4cb2-8cf8-c3ced6e5ab01"],

Cell[BoxData[
 RowBox[{"Clear", "[", "AutomaticRules", 
  "]"}]], "Input",ExpressionUUID->"c14ed42d-7299-43a9-bdab-a83a537aa1ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "AutomaticRules"}]], \
"Input",ExpressionUUID->"64a25976-aad6-4bc8-b6d7-017e1fcb5047"],

Cell[BoxData[
 StyleBox["\<\"AutomaticRules[symbol, {rule1, rule2, ...}] declares the rules \
as upvalues or downvalues for symbol, or append them to $Rules if symbol is \
too deep in the rules.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672768-5338953",ExpressionUUID->"bd55abdb-6d81-4275-8d5f-\
690ea9477739"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "$Rules"}]], "Input",ExpressionUUID->"71bdec6f-8c2b-4562-ab57-67a515943859"],

Cell[BoxData[
 StyleBox["\<\"$Rules is a global variable storing the list of all rules \
registered as global rules.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672770-5338953",ExpressionUUID->"b22af181-90f9-4911-b247-\
1931ddca1361"]
}, Open  ]],

Cell["\<\
QUESTION: The function minimumdepth is evaluating the symbol. Can we avoid \
this?\
\>", "Text",ExpressionUUID->"52e14f0b-ad9b-4fc1-8ae3-6fc728519d0f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"AutomaticRules", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "AutomaticRules", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Verbose", "\[Rule]", "True"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AutomaticRules", "[", 
    RowBox[{"symbol_Symbol", ",", "rules_List", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"pos", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"minimumdepth", "[", 
           RowBox[{"#", ",", "symbol"}], "]"}], "&"}], "/@", "rules"}]}], ",",
        "\[IndentingNewLine]", "upvs", ",", "downvs", ",", "othervs", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"verbose", "=", 
        RowBox[{"OptionValue", "[", "Verbose", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Select", " ", "downvalues", " ", "and", " ", "upvalues"}], " ",
       "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"upvs", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"pos", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"downvs", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"pos", ",", "0"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"othervs", "=", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "rules", "]"}], "]"}], ",", "upvs", ",", 
         "downvs"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "downvs", "]"}], ">", "0"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"DownValues", "[", "symbol", "]"}], ",", "#"}], "]"}], 
           "&"}], "/@", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "downvs", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         
         RowBox[{"If", "[", 
          RowBox[{"verbose", ",", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<   Rules \>\"", ",", 
             RowBox[{"Shallow", "[", "downvs", "]"}], ",", 
             "\"\< have been declared as DownValues for \>\"", ",", "symbol", 
             ",", "\"\<.\>\""}], "]"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "upvs", "]"}], ">", "0"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{
             RowBox[{"UpValues", "[", "symbol", "]"}], ",", "#"}], "]"}], 
           "&"}], "/@", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "upvs", "]"}], "]"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{"verbose", ",", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<   Rules \>\"", ",", 
             RowBox[{"Shallow", "[", "upvs", "]"}], ",", 
             "\"\< have been declared as UpValues for \>\"", ",", "symbol", 
             ",", "\"\<.\>\""}], "]"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "othervs", "]"}], ">", "0"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"$Rules", ",", "#"}], "]"}], "&"}], "/@", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "othervs", "]"}], "]"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{"verbose", ",", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<   Rules \>\"", ",", 
             RowBox[{"Shallow", "[", "othervs", "]"}], ",", 
             "\"\< have been declared as generic Rules.\>\""}], "]"}]}], 
          "]"}]}]}], "]"}], ";"}]}], " ", "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3445c632-5caf-4210-bc07-1ec163f25484"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"AutomaticRules", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"AutomaticRules", ",", "Verbose"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1b0a8e18-11c1-4080-be58-635f02a8711a"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f721b99a-eea5-4ca6-9197-8cd46e03cea0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"736bc2c0-0552-4403-b537-3c714d253114"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c8310554-bf7a-46a5-b268-f22c4a988c0f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3d027588-1d56-4485-b230-4c985ebf153a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"60a65a1f-7b05-4cdd-be74-e1df8720d779"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2c8319b4-b5f4-450a-a82e-0c904abd6bca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"14f0558a-89ed-44ed-9470-4deca0fb2563"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7eebd4bf-b098-494a-b268-f6349b3a5f82"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"8d0be75f-03ac-41c6-b619-bcb2d9b99572"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"53a8cd55-80e6-428f-9fed-7b2c37d3f10d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "T", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"AutomaticRules", "[", 
  RowBox[{"T", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"B", ",", "D"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{"A", ",", 
         RowBox[{"-", "B"}]}], "]"}]}], "\[RuleDelayed]", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "D"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"B", ",", "D"}], "]"}], "\[RuleDelayed]", 
      RowBox[{"S", "[", 
       RowBox[{"B", ",", "D"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"F", "[", 
       RowBox[{"F", "[", 
        RowBox[{"T", "[", 
         RowBox[{"B", ",", "D"}], "]"}], "]"}], "]"}], "\[RuleDelayed]", 
      RowBox[{"S", "[", 
       RowBox[{"B", ",", "D"}], "]"}]}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "T", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"cfdafd9d-9ab0-44a0-b858-ee2d7e763368"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Rules \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2", "}"}], 
   "\[InvisibleSpace]", "\<\" have been declared as DownValues for \"\>", 
   "\[InvisibleSpace]", "T", "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["   Rules ", 
   Shallow[{2}], " have been declared as DownValues for ", $CellContext`T, 
   "."],
  Editable->
   False]], "Print",ExpressionUUID->"649e8f83-553d-42bf-a770-34a616e905b6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Rules \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}], 
   "\[InvisibleSpace]", "\<\" have been declared as UpValues for \"\>", 
   "\[InvisibleSpace]", "T", "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["   Rules ", 
   Shallow[{1}], " have been declared as UpValues for ", $CellContext`T, "."],
  
  Editable->
   False]], "Print",ExpressionUUID->"a93a5ee4-49c0-44a4-b179-4f8fa97e2c11"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Rules \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3", "}"}], 
   "\[InvisibleSpace]", "\<\" have been declared as generic Rules.\"\>"}],
  SequenceForm["   Rules ", 
   Shallow[{3}], " have been declared as generic Rules."],
  Editable->
   False]], "Print",ExpressionUUID->"747a547b-2e69-43df-bfe2-5e7fdf9a62af"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"B", ",", "D"}], 
  "]"}]], "Input",ExpressionUUID->"b5f57bcf-405d-4686-891f-6d9599f097cd"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {"B", "D"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`S[$CellContext`B, D],
  Editable->
   False]], "Output",ExpressionUUID->"9330d978-18b6-4250-83e3-1fee4cdbf4bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"B", ",", "D"}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"201283de-2302-4c25-98d8-42566856ed32"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "D"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, D],
  Editable->
   False]], "Output",ExpressionUUID->"a08c0156-cfc8-45e2-80e8-d193e079163c"]
}, Open  ]],

Cell["\<\
Note that the downvalue for T is replaced in the upvalue before registering \
it. Use HoldPattern to avoid these kind of things:\
\>", "Text",ExpressionUUID->"a6450b70-749f-47e8-89f3-9a3dd2b18b56"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", 
  "T"}]], "Input",ExpressionUUID->"a1fa91ae-b437-45a5-8c77-7a1fbcc4d6e3"],

Cell[CellGroupData[{

Cell["Global`T", "Print", "PrintUsage",
 CellTags->
  "Info3578672772-5338953",ExpressionUUID->"1d4a9e03-931b-40dd-a267-\
7453df2b66ba"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "T", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "T", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`T],
          Editable->False], "^:=", "T"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "T", "]"}], "^:=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "T", "]"}], "^:=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "T", "]"}], "^:=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "T", "]"}], "^:=", "\<\"T\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "T", "]"}], "^:=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "T", "]"}], "^:=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "T", "]"}], "^:=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "T", "]"}], "^:=", "True"}]},
       {" "},
       {
        RowBox[{"T", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {"B", "D"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[$CellContext`B, D],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"T", 
               StyleBox[GridBox[{
                  {"A", " "},
                  {" ", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T[$CellContext`A, -$CellContext`B],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"A", "D"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`A, D],
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"B", "D"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`B, D],
          Editable->False], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"B", "D"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`B, D],
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`T],
  Editable->False]], "Print",
 CellTags->
  "Info3578672772-5338953",ExpressionUUID->"761b7a6c-9340-4750-8856-\
c7e174e60580"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xUpSet", "[", 
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
   RowBox[{"{", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"853baa52-c793-4308-8648-9f30016d4065"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"808a42bd-589e-4b72-9ef5-bfbd743ced6d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", "$Tensors"}], 
  ";"}]], "Input",ExpressionUUID->"6c2c4bf3-2976-4216-a771-1eee6d98c2e9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"b91c3980-58ca-4b2f-b9c4-da54f83ef313"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"a8cfc473-9f72-422b-a960-84d8c77fb8f8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"487c20a1-2591-481a-9813-874e594e3f06"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"a45d5631-ba6c-4b40-9295-356507fcbbbc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"3fa0c553-3376-4281-b3d0-4ff8b6bdb5d5"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"4f60007f-bc62-42b0-a69b-dfd0015ab43a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["11. Covariant and parameter derivatives",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"d8f7d7fb-2710-4cbf-a07d-e95c93805eaf"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
    RowBox[{"**", " ", "11."}]}], "Covariant", " ", "derivatives"}], " ", 
  "*********************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"64ad7045-7224-4ea4-ae67-be7d8a291dd4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"4ce7ca7d-5bce-41b6-89af-52df7c681189"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "48.877741`", ",", "504.23393`9.154177059580508", ",", 
   "0.09693470979544548`"}], 
  "}"}]], "Output",ExpressionUUID->"5db614aa-5fa5-4422-bb94-35c916f6c380"]
}, Open  ]],

Cell[CellGroupData[{

Cell["11.0. Comments", \
"Subsection",ExpressionUUID->"5e46b133-88ab-4b36-b56b-c482038ddc57"],

Cell[CellGroupData[{

Cell["11.0.1. Notations", \
"Subsubsection",ExpressionUUID->"a757e230-6ca3-403f-a655-e9d2db975eaf"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{
   "Print", "[", "\"\<Reading section 11: Covariant derivatives.\>\"", "]"}], 
   ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9c5ea5b1-5493-4497-b69e-a3c411327f73"],

Cell[TextData[{
 "It is difficult to choose the notation for covariant derivatives. There are \
four main possibilities, with advantages and disadvantages, depending on what \
you want to stress:\n\t1) The operator character of the derivative: cd[-a][ \
v[b] ]\n\t2) The fact that the result is another abstract tensor field: \
TensorDerivative[v, cd][b, -a]\n\t3) The indexed representation of the \
covariant derivatives: v[b, cd[-a]]\n\t4) More symmetric roles played between \
vectors and derivatives: TensorD[v[b], cd[-a]]\nThe notation for a derivative \
f'[x] in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " is actually Derivative[1][f][x], which reflects quite properly the \
operator character of the derivative, while keeping the function structure \
head[args] at the same time. That is very similar to the TensorDerivative \
option above, and right now it is my preferred choice. However, my original \
choice was cd[-a][ expr ]:\n\t- The main advantage is that cd[-a][ T[-b,-c] ] \
behaves properly under the rule T[-b,-c] -> A[-b,-c] + C[-b,-c], while the \
other notation need to include the derivatives in the rule, or use a \
pure-tensor language.\n\t- The main disadvantage is that it is not possible \
to associate a rule containing second derivatives to the object being \
differentiated. Another disadvantage is the larger number of brackets to use, \
but you get easily used to that.\nCurrently xTensor supports both  options 1) \
and 2). Options 2 is not supported (it was for some time long ago), because \
it is rather ambiguous when the index of cd is a basis index, and option 4 is \
automatically converted into notation 2), imitating ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "\[CloseCurlyQuote]s pair D/Derivative."
}], "Text",ExpressionUUID->"6aa1c7c5-d404-4341-891e-ab63b3adba91"],

Cell[TextData[{
 "Covariant derivatives are operators. As pointed out by Eduardo the most \
general kind of derivative is that of the form\n\t\t\tcovd[ v[a] ][ expr ]\n\
where covd is tensorial in its first argument, that is\n\t\t\tcovd[ f[] v[a] \
][ expr ] = f[] covd[ v[a] ][ expr ] .\nWe have the notation\n\t\t\tcovd[ \
Dir[v[a]] ][ expr ]\nUsing abstract indices, this can be represented as\n\t\t\
\tv[a] covd[-a][ expr ] .\nOnly if the manifold is parallelizable we can \
choose a basis of vector fields and define the usual covariant derivative\n\t\
\t\tcovd[ -{a, B} ][ expr ]\nwhere now -{a, B} is the index in the collection \
B of basis vectors. We shall assume that this is always the case. As pointed \
out by Penrose and Rindler, it is physically reasonable to assume that \
spacetime manifolds are parallelizable. Anyway, the only obstruction could be \
of global origin, and ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " only does local computations."
}], "Text",ExpressionUUID->"cff74c68-97cd-4cb9-a773-23e8ab24f6a6"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.0.2. Gauge connections", \
"Subsubsection",ExpressionUUID->"a2092fc1-7aa5-4fae-ad68-28c1300925d2"],

Cell[TextData[{
 "Starting version 0.9 of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " we have introduced general vector bundles, that is, bundles different from \
the tangent bundles that we were using in previous versions 0.7 and 0.8. This \
is not a big change in sections 1-10, but it is a big change concerning \
covariant derivatives. The main reason is the fact that now there are two \
curvatures associated to each covd, as well as two types of Christoffels (but \
still just one type of Torsion tensor). In this issue we closely follow the \
paper by Asthekar et al, General Relativity and Gravitation 14 (1982), 411. I \
thank Alfonso Garcia-Parrado for much help and guidance in  implementing this \
change.\n\nMain ideas of the change:\n\t1. We shall distinguish the symbols \
Christoffel and AChristoffel, the former with the typical use it always had, \
and the latter with identical use on the fiber space.\n\t2. In parallel, we \
shall distinguish the symbols Riemann and FRiemann, respectively.\n\t3. There \
is still just Torsion on the tangent manifold, but not on other types of \
fibers.\n\t4. Covariant derivatives are defined on the base manifolds, but \
they can act either in the tangent manifold, or in a more general fiber, or \
in both, and this must be explicitly stated at definition time of the \
derivative. It is possible to have several connections, acting on both the \
tangent and the inner vbundles, whose restriction to the tangent bundle \
coincide.\n\t5. In order to avoid duplicity of code we need to develop some \
algorithms being able to use either Christoffel or AChristoffel, and either \
Riemann or FRiemann, as arguments. Many operations will use them with either \
one of them or both.\n\t6. We shall use PD as the origin of the affine space \
of derivatives. By definition, PD has no curvature (neither Riemann or \
FRiemann) nor torsion. Effectively PD fakes the presence of a coordinate \
chart in xTensor, avoiding loading xCoba, but for actual computations with \
charts the full power of xCoba is needed."
}], "Text",ExpressionUUID->"970efb52-c400-4f81-bf44-98151c052c59"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.0.3. Manifold and vbundles of a connection", \
"Subsubsection",ExpressionUUID->"99ff7cde-aa26-46aa-960c-5aad62751f46"],

Cell["\<\
Connections are always associated to a manifold M in the sense that every \
field having M as dependency will have (by default) non-zero derivative under \
that connection. Then, independently, they can act on the indices of \
different vector bundles (all having M as base manifold). Therefore we will \
associate two upvalues to any connection: ManifoldOfCovD and VBundlesOfCovD. \
To avoid defining values for the PD derivative the input can be both CD or \
CD[-a], such that PD[-a] will provide the vbundle information through its \
index.\
\>", "Text",ExpressionUUID->"66f90a23-8e8e-413e-bc9c-d715a6fd1642"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"VBundlesOfCovD", "[", 
    RowBox[{"covd_", "[", "__", "]"}], "]"}], ":=", 
   RowBox[{"VBundlesOfCovD", "[", "covd", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ManifoldOfCovD", "[", 
    RowBox[{"covd_", "[", "__", "]"}], "]"}], ":=", 
   RowBox[{"ManifoldOfCovD", "[", "covd", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"VBundlesOfCovD", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ManifoldOfCovD", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"VBundlesOfCovD", ",", "ManifoldOfCovD"}], "]"}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"564463d6-a463-49ab-89b2-fb805cf124eb"],

Cell["\<\
This private function can be constructed from both of those two, and I choose \
VBundlesOfCovD to ensure that we keep the convention of having the tangent \
vbundle as first member of the list:\
\>", "Text",ExpressionUUID->"8d79fa08-6e4c-4740-b3e3-90924b6fd554"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TangentBundleOfCovD", "[", "covd_", "]"}], ":=", 
   RowBox[{"First", "@", 
    RowBox[{"VBundlesOfCovD", "[", "covd", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"63f31d70-e4bc-4b79-bb57-b014132862ae"],

Cell["\<\
QUESTION: In order to incorporate additional dependencies and parameters \
there is also DependenciesOfCovD. It is not clear that the relation between \
ManifoldOfCovD and DependenciesOfCovD is correct. We should perhaps do as \
with tensors and define the former in terms of the latter.\
\>", "Text",ExpressionUUID->"3320e675-c5bd-4306-908f-46c5e533fe75"],

Cell["\<\
QUESTION: An interesting question is the following: there are \"direct-sum \
derivatives\" in which the derivatives acting on different tangent vbundles \
Bi add up to form the derivative of the direct-sum vbundle BS of those \
(tangent) subvbundles Bi. On the other hand we have the generalized \"fiber\" \
derivatives which, even though they always have an index on a tangent bundle \
B, they also act on objects having indices on inner vbundles F having B as \
tangent bundle of their base manifold. They are clearly two independent \
problems, but the question is whether it is possible to implement both \
simultaneously (currently not done, I think ;). A related practical question \
is whether it is possible to use some parts of the code in solving both \
issues. In some sense, it is the question of teaching a derivative that, even \
if its index belongs to some vbundle, there are other vbundles on whose \
indices it must act as well.\
\>", "Text",ExpressionUUID->"c1761684-6a14-471c-bc39-4b163742e587"],

Cell["\<\
Choice of index positions. As usual, we follow Wald's book as much as \
possible, though I must admit I don't understand why the Riemann tensor has \
the upper index at the end, but the Christoffel tensor has the upper index at \
the beginning:
\tRiemann[-a, -b, -c, d]
\tChristoffel[a, -b, -c]. Note that for non-symmetric covariant derivatives \
(not considered in Wald), the \"derivative\" index will be the middle index.\
\>", "Text",ExpressionUUID->"e4ab939d-8f11-427c-8558-59ce90a5017c"],

Cell[TextData[{
 "A problematic issue in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is that of induced derivatives, which is very important in General \
Relativity. All definitions must take this case into account."
}], "Text",ExpressionUUID->"b6c618f2-fc98-4e22-afb0-58f11b92a2ac"],

Cell["\<\
Configuration global variables concerning derivatives:
    \t$CheckZeroDerivativeVerbose\
\>", "Text",ExpressionUUID->"4c13c8b2-d02d-4d1f-8b8a-eca0244902fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.0.4. Pullback connection", \
"Subsubsection",ExpressionUUID->"9c86fd7e-69fb-4017-b582-81b71d4a81c7"],

Cell["\<\
In xTensor 1.1.0 we introduce tensor fields along a map and other \
\[OpenCurlyDoubleQuote]mapped\[CloseCurlyDoubleQuote] objects, in particular \
connections. This requires a careful analysis of what VBundle properties are \
of purely vectorial-algebraic nature and hence only depend on the properties \
of the fiber (say dimension) and which properties are of differential nature \
and involve also the vbundle base. Clearly everything related to covariant \
differentiation is of the later type. The most important functions to think \
about are:

(Suppose CD has been defined with base N and we have a mapping \[Phi] : M -> \
N.)

- ManifoldOfCovD. PullBackCovD[ CD, \[Phi] ] has now base M, instead of N.

- VBundlesOfCovD. PullBackCovD[ CD, \[Phi] ] has now vbundles \
{PullBackVBundle[ TangentN, \[Phi] ], ... }

- BaseOfVBundle. PullBackVBundle[ TangentN, \[Phi] ] has now base M, instead \
of N.

The main question is: do we load the map on the names of the modified objects \
(say the vbundles) or do we create an additional property MappingOfCovD?

Note that, unlike tensors, we are not planning to allow the definition of a \
mapped connection in DefCovD. The elementary connections must all belong to \
elementary vbundles and then be mapped with mappings. Tensors, however, can \
be declared along a map at definition time.\
\>", "Text",ExpressionUUID->"7c83093e-3ead-44cb-8e1a-6137017dc957"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.0.5. The Leibnitz operator", \
"Subsubsection",ExpressionUUID->"ab5d45d0-1be2-41fb-956f-a1e53cf2f18c"],

Cell["\<\
This is a simple way of coding up the long lists of terms associated to the \
changes of derivatives. The name comes from the fact that this is an \
\"algebraic derivative\", in the sense that Leibnitz[A B][-a,b] = \
Leibnitz[A][-a,b]B+A Leibnitz[B][-a,b].\
\>", "Text",ExpressionUUID->"9103da9d-166b-499b-8aeb-4e4792a79cf2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Leibnitz", "[", "expr_", "]"}], "[", 
    RowBox[{
     RowBox[{"-", "a_"}], ",", "b_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"frees", "=", 
        RowBox[{"FindFreeIndices", "[", "expr", "]"}]}], ",", 
       RowBox[{"vbQ", "=", 
        RowBox[{"VBundleIndexQ", "[", 
         RowBox[{"VBundleOfIndex", "[", "a", "]"}], "]"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"Plus", "@@", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"delta", "[", 
             RowBox[{
              RowBox[{"-", "a"}], ",", "#"}], "]"}], 
            RowBox[{"ReplaceIndex", "[", 
             RowBox[{"expr", ",", 
              RowBox[{"#", "\[Rule]", "b"}]}], "]"}]}], ")"}], "&"}], ",", 
         RowBox[{"Select", "[", 
          RowBox[{"frees", ",", "vbQ"}], "]"}]}], "]"}]}], "-", 
      RowBox[{"Plus", "@@", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"delta", "[", 
             RowBox[{
              RowBox[{"-", "#"}], ",", "b"}], "]"}], 
            RowBox[{"ReplaceIndex", "[", 
             RowBox[{"expr", ",", 
              RowBox[{
               RowBox[{"-", "#"}], "\[Rule]", 
               RowBox[{"-", "a"}]}]}], "]"}]}], ")"}], "&"}], ",", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"ChangeIndex", "/@", "frees"}], ",", "vbQ"}], "]"}]}], 
        "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Leibnitz", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a74e8145-68b2-48bb-95ff-b9efed52296a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1. Christoffel tensors", \
"Subsection",ExpressionUUID->"178ade88-ff47-4612-b9ff-e3e5a7085b0f"],

Cell[CellGroupData[{

Cell["11.1.0. Comments", \
"Subsubsection",ExpressionUUID->"1a7e60e0-fd88-47c3-9f24-241a23cebf31"],

Cell[TextData[{
 "A Christoffel tensor depends on two derivatives. This is a complication in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 "'s scheme because it doesn't follow the normal rule Riemanncovd, for \
example. We need Christoffel tensors of the form Christoffelcd1cd2 but that \
means n(n-1)/2 tensors if there are n derivatives.\n\nWe shall do the \
following: there is a command Christoffel[cd1,cd2][i1, i2, i3] which \
constructs Christoffelcd1cd2[i1, i2, i3]. This command must check whether \
that tensor already exists or not, and if it doesn't then it has to be \
defined. There exists a similar command AChristoffel[cd1, cd2][i1, i2, i3] \
for the covariant derivatives on inner fiber bundles, which is actually a \
call to Christoffel, which is able to handle both cases, because the \
information required is stored in the indices provided. That means in \
particular that Christoffel[cd1, cd2] does not evaluate, what is another \
exception with respect to Riemann[cd] and the like.\n\nThen we define \
commands which change the objects associated to a covd: ChangeCovD, \
ChangeTorsion and ChangeCurvature. We also need BreakChristoffel.\n\n\
Simultaneous problems to take into account:\n\t- The two-ders dependencies of \
Christoffels.\n\t- Some formulas involve derivatives and therefore are \
different for basis-indices.\n\t- There can be derivatives belonging to \
different manifolds. I'm not sure we can allow Christoffel tensor between a \
manifold and one of its submanifolds. Currently I forbid that. QUESTION.\n\t- \
Again, the problem of induced derivatives."
}], "Text",ExpressionUUID->"c83a6927-4202-434d-97d1-ca36e275ccdd"],

Cell["\<\
We shall list all Christoffels, including the AChristoffel objects, with the \
private global variable\
\>", "Text",ExpressionUUID->"0405c036-6fab-424f-bcef-58ea00a2e0ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Christoffels", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6e1bfb20-939d-4f22-944c-d8811bc28352"],

Cell["\<\
The format for each element of that list is {christoffelname, \
{christoffeltype, cd1, cd2}, vbundles}, where christoffeltype is one of \
Christoffel or AChristoffel, and vbundles is a list with either a tangent \
bundle (all indices of the christoffel belong to that bundle) or a tangent \
bundle and other inner bundles.\
\>", "Text",ExpressionUUID->"97c201e6-2e34-4939-a58e-de9da9e8b211"],

Cell["\<\
To alleviate the problem of naming two derivatives we shall define an \
ordinary derivative PD defined on all manifolds, and which will be used as \
default in many cases. It is a fiducial derivative with no torsion and no \
curvature. This is effectively a trick to work with **a single** chart \
without having to load xCoba.\
\>", "Text",ExpressionUUID->"634090e9-8b01-429c-8680-4bb83ca2ddba"],

Cell["\<\
Covariant derivatives are associated to full vbundles, and not only to \
manifolds, because we need to know the indices they act upon. The structure \
of indices will be the following: In AChristoffel[A,-b,-C] the indices A, -C \
belong to the generic vector bundle, while -b belongs to the tangent bundle \
of the manifold.\
\>", "Text",ExpressionUUID->"616a835c-ceb2-46c6-8a23-f008f93f3f34"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.1. CovD compatibility", \
"Subsubsection",ExpressionUUID->"e69c47eb-806b-4553-8ddf-a486a9383457"],

Cell["\<\
It is not possible to use any two derivatives to construct a Christoffel \
tensor. We define the following function to check whether two derivatives can \
be related via Christoffel tensors or not: Two derivatives are compatible \
iff:
\t- one of them (or both) is PD, or
\t- both act on the same base manifold and
\t\t- one of them (or both) does not act on any internal vector bundle, or
\t\t- both act on the same internal vector bundle.\
\>", "Text",ExpressionUUID->"0b3de606-ff3f-478b-a738-8637d5e30ced"],

Cell["\<\
In this function VBundlesOfCovD is assumed to return a list with at least one \
element, but no upper limit, though currently we only work with up to three \
bundles. Note also that there is no reference to the indices of the \
derivatives. That means that for \"direct-sum derivatives\" we will be \
comparing the large vbundles.\
\>", "Text",ExpressionUUID->"7e70c228-66bc-4ae3-9986-4aa5549a28dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Main", " ", "driver"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{"covd_", ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{"PD", ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], ",", "PD"}], "]"}], ":=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{
       RowBox[{"covd1_", "?", "CovDQ"}], ",", 
       RowBox[{"covd2_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"compareCovDs", "[", 
      RowBox[{
       RowBox[{"VBundlesOfCovD", "[", "covd1", "]"}], ",", 
       RowBox[{"VBundlesOfCovD", "[", "covd2", "]"}], ",", "False"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{"covd1_", ",", 
       RowBox[{"covd2_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Christoffel", "::", "unknown"}], ",", 
        "\"\<covariant derivative\>\"", ",", "covd1"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{"covd1_", ",", "covd2_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Christoffel", "::", "unknown"}], ",", 
        "\"\<covariant derivative\>\"", ",", "covd2"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Actual", " ", 
     RowBox[{"decision", ".", " ", "The"}], " ", "third", " ", "argument", 
     " ", "throws", " ", "an", " ", "error", " ", "if", " ", "the", " ", 
     "covds", " ", "are", " ", "incompatible"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDs", "[", 
      RowBox[{
       RowBox[{"{", "tb_", "}"}], ",", 
       RowBox[{"{", "tb_", "}"}], ",", "_"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDs", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tb_", ",", "__"}], "}"}], ",", 
       RowBox[{"{", "tb_", "}"}], ",", "_"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDs", "[", 
      RowBox[{
       RowBox[{"{", "tb_", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"tb_", ",", "__"}], "}"}], ",", "_"}], "]"}], ":=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDs", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tb_", ",", "vb1__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"tb_", ",", "vb2__"}], "}"}], ",", "mess_"}], "]"}], ":=", 
     RowBox[{"compareCovDserror", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"{", "vb1", "}"}], ",", 
           RowBox[{"{", "vb2", "}"}]}], "]"}], "===", 
         RowBox[{"{", "}"}]}], "||", 
        RowBox[{
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"{", "vb2", "}"}], ",", 
           RowBox[{"{", "vb1", "}"}]}], "]"}], "===", 
         RowBox[{"{", "}"}]}]}], ",", "mess"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDs", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tb1_", ",", "___"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"tb2_", ",", "___"}], "}"}], ",", "mess_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{"mess", ",", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Christoffel", "::", "base"}], ",", "tb1", ",", "tb2"}], 
         "]"}], ";", "Zero"}], ",", "False"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDserror", "[", 
      RowBox[{"True", ",", "_"}], "]"}], ":=", "True"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"compareCovDserror", "[", 
      RowBox[{"False", ",", "mess_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{"mess", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Christoffel", "::", "error"}], ",", 
          "\"\<Incompatible vector bundles.\>\""}], "]"}]}], ",", "False"}], 
      "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e3515341-9513-446b-b7c8-1e7d3c1786cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Christoffel", "::", "base"}], "=", 
   "\"\<Connections have different base manifolds `1` and `2`. Assuming their \
Christoffel vanishes.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6df0ed36-9787-4cfe-a2b3-e2e4cce5d17c"],

Cell["\<\
In the general case in which there are inner vbundles {vb1__} and {vb2__} on \
the same base manifold the compatibility condition is that one of them is a \
subset of the other. That is, either both derivatives act on the same \
vbundles or one extends the other.

Nov 2012: it has been discussed in the group whether the Christoffel between \
two connections with different base manifold should be Zero. I find that a \
bit dangerous because we might end up converting derivatives on one manifold \
into derivatives of the other manifold with zero Christoffels. Now when \
mess=True we accept that case, with the message Christtofel::base. This only \
happens when using Christoffel directly. The ChangeX functions will use \
CompatibleCovDsQ, with mess=False, because it is impossible to change between \
derivatives of different base manifolds. With mess=True the function \
compareCovDs can only return True, Zero (with the ::base message) or throw an \
::error message, but never False.

Note that this function is perfectly symmetric in its two covd arguments.

There is the important issue now of dependencies of derivatives. Compability \
only checks for the same base manifold, but not for dependencies. In \
principle this is taken care of by the Christoffel relating the derivatives, \
which will have the union of the dependencies. It could happen for instance \
that two derivatives depend on time but their Christoffel difference doesn't. \
There is no way we can handle that and the user must add this information by \
hand.\
\>", "Text",ExpressionUUID->"54cf9b30-e43b-499b-a57d-30c19a077f4d"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.2. ChangeCovD", \
"Subsubsection",ExpressionUUID->"1925471e-f671-48ab-930b-4433cd0a6887"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChangeCovD"}]], \
"Input",ExpressionUUID->"daa3a666-c24e-412a-ba37-310512530f6e"],

Cell[BoxData[
 StyleBox["\<\"ChangeCovD[expr, covd1, covd2] changes any instance of the \
covariant derivative covd1 in expr into a covariant derivative covd2 and \
Christoffel tensors relating both connections. The second argument is \
listable. ChangeCovD[expr, covd1] is converted into ChangeCovD[expr, covd1, \
PD]. ChangeCovD[expr] is converted into ChangeCovD[expr, $CovDs].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672774-5338953",ExpressionUUID->"a7beeace-fac2-47d4-89a5-\
1c8460d092bc"]
}, Open  ]],

Cell["\<\
This function changes the derivative of an object by other derivative of the \
same object plus (A)Christoffel tensors. If a metric has not been defined \
then covariant derivative operators can only have a down-index . We do not \
check that here. Do it with Validate. There is a third argument expressing \
the new derivative to be used (default is PD). Remember the essential rule \
for index positioning in the Christoffel: the derivative index always in the \
middle position. This function works with any kind of index (i.e., including \
basis-indices), even though the dummies introduced are always \
abstract-indices.\
\>", "Text",ExpressionUUID->"712a8dff-a2ce-4e3b-8928-9f8414017b68"],

Cell["\<\
We break its implementation in three steps: the user driver, a recursive \
function and the actual change:\
\>", "Text",ExpressionUUID->"fc6b793e-6119-4d6f-8add-6b2cbce5cd6f"],

Cell["\<\
1) User driver. Translate to changeCovD, which specifies two heads to add: \
the first one on the new derivative object; the second one on the added \
Christoffel objects. This is because this function is used in the process of \
canonicalization of derivatives, in which we need to mark temporarily the \
changed derivatives. Note that we check that the first given covd is actually \
a derivative, and throw an error if it is not. We do not check the second one \
because I haven't found the correct way of mixing Optional and PatternTest. \
We also check that derivatives covd and covd2 are compatible; if they are not \
we simply return the input, without any message being sent (this is because \
this will be a frequent case when threading over $CovDs below).\
\>", "Text",ExpressionUUID->"a8e385d7-cf8e-4969-8ece-ef1499cf08cd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr_", ",", "All", ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr", ",", "$CovDs", ",", "covd2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr_", ",", "None", ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"{", "}"}], ",", "covd2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_", "?", "CovDQ"}], ",", "covd_"}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_", "?", "CovDQ"}], ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{"covd", ",", "covd2"}], "]"}], ",", 
     RowBox[{"changeCovD", "[", 
      RowBox[{"expr", ",", "covd", ",", "covd2"}], "]"}], ",", "expr"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr_", ",", "list_List", ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ChangeCovD", "[", 
       RowBox[{"#1", ",", "#2", ",", "covd2"}], "]"}], "&"}], ",", "expr", 
     ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr_", ",", "x_", ",", 
     RowBox[{"_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ChangeCovD", "::", "unknown"}], ",", 
      "\"\<covariant derivative\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCovD", "[", "expr_", "]"}], ":=", 
   RowBox[{"ChangeCovD", "[", 
    RowBox[{"expr", ",", "$CovDs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ChangeCovD", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ChangeCovD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dccb0bca-8876-4afd-b5d1-2ed48b9aebe7"],

Cell["\<\
2) Internal recursion, keeping the same covd, covd2 pair. Now we check the \
second derivative. The derivative PD is problematic in this function as covd \
because it is not clear how we should choose the checking function tbpmQ.\
\>", "Text",ExpressionUUID->"5e63c709-8f70-4bbb-80e7-58a330c88efa"],

Cell["\<\
If the derivatives are compatible then we know that they share the same \
tangent bundle, and hence we can get it from any of them. Even though the \
covd-covd case has been already handled by the first definition for \
ChangeCovD above, we include it here because there are functions below \
calling changeCovD directly. Note that we use the IndexOnQ function to check \
the vbundle of the indices. This is really only needed when covd is PD \
because we do not want to change all PD's in an expression: we want to change \
only those belonging to the same tangent vbundle of covd2. Any type of index \
is allowed, and so we use IndexOnQ instead of the tb`Q function.\
\>", "Text",ExpressionUUID->"c0a92e51-5455-4e24-ba6f-322b4ae367da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defaults", " ", "for", " ", "the", " ", "fourth", " ", "and", " ", 
    "fifth", " ", "arguments"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"changeCovD", "[", 
      RowBox[{"expr_", ",", "covd_", ",", "covd2_"}], "]"}], ":=", 
     RowBox[{"changeCovD", "[", 
      RowBox[{
      "expr", ",", "covd", ",", "covd2", ",", "Identity1", ",", "Identity"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"changeCovD", "[", 
      RowBox[{"expr_", ",", "covd_", ",", "covd_", ",", "_", ",", "_"}], 
      "]"}], ":=", "expr"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"changeCovD", "[", 
      RowBox[{"expr_", ",", "covd_", ",", 
       RowBox[{"covd2_", "?", "CovDQ"}], ",", "tmpcovdhead_", ",", 
       "tmpchrhead_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"tb", "=", 
         RowBox[{"TangentBundleOfCovD", "[", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"covd", "===", "PD"}], ",", "covd2", ",", "covd"}], "]"}],
           "]"}]}], "}"}], ",", 
       RowBox[{"expr", "/.", 
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"ind_", "?", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"IndexOnQ", "[", 
                RowBox[{"#", ",", "tb"}], "]"}], "&"}], ")"}]}], "]"}], "[", 
           "expr1_", "]"}], "]"}], "\[RuleDelayed]", 
         RowBox[{"makechangeCovD", "[", 
          RowBox[{
           RowBox[{"changeCovD", "[", 
            RowBox[{
            "expr1", ",", "covd", ",", "covd2", ",", "tmpcovdhead", ",", 
             "tmpchrhead"}], "]"}], ",", "covd", ",", "covd2", ",", "ind", 
           ",", "tmpcovdhead", ",", "tmpchrhead"}], "]"}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"changeCovD", "[", 
      RowBox[{"expr_", ",", "_", ",", "x_", ",", "_", ",", "_"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"ChangeCovD", "::", "unknown"}], ",", 
         "\"\<covariant derivative\>\"", ",", "x"}], "]"}], ";", 
       RowBox[{"ERROR", "[", "expr", "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"83481d56-e52f-4f48-b4a7-ac49495a6e5b"],

Cell["A trivial head:", \
"Text",ExpressionUUID->"d6b4eadd-181b-4e19-8a20-6c8fd647873a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Identity1", "[", 
    RowBox[{"a_", ",", "b___"}], "]"}], ":=", "a"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"86c24581-cd80-4dc7-b6ee-4d44d681d014"],

Cell["\<\
3) Actual change. Now we need to worry about the possibility of having \
several types of \"differentiated\" indices, corresponding to the different \
elements of VBundlesOfCovD (there is no check on the length of this list). \
The symbol CHR is not local to this function. It is used to transfer the \
responsibility for Christoffel construction and Christoffel index check to \
the command Christoffel. Again, covd and covd2 cannot be simultaneously PD, \
and this time we do not need a special definition because makechangeCovD is \
only called from changeCovD. The roles of covd and covd2 are clearly not \
symmetric in this function; however, it must always be possible to reverse \
the action of this function by simply reversing the ordering of covd and \
covd2:\
\>", "Text",ExpressionUUID->"9859678f-22ec-4f2d-9740-1e6ed03868d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "CHR", "]"}], "^=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a02aa57c-b20e-41ab-b3a4-de0c69a8fd86"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Convert", " ", 
     RowBox[{
      RowBox[{"covd", "[", "ind", "]"}], "[", "expr", "]"}], " ", "into", " ", 
     RowBox[{
      RowBox[{"covd2", "[", "ind", "]"}], "[", "expr", "]"}]}], "+", 
    RowBox[{"stuff", ".", " ", "CovDTODO"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"makechangeCovD", "[", 
     RowBox[{
     "expr_", ",", "covd_", ",", "covd2_", ",", "ind_", ",", "tmpcovdhead_", 
      ",", "tmpchrhead_"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"vbundles", "=", 
        RowBox[{"Apply", "[", 
         RowBox[{"Union", ",", 
          RowBox[{"VBundlesOfCovD", "/@", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"covd", ",", "covd2"}], "}"}], ",", "PD"}], "]"}]}]}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tmpcovdhead", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"covd2", "[", "ind", "]"}], "[", "expr", "]"}], ",", 
         "covd"}], "]"}], "+", "\[IndentingNewLine]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Plus", "@@", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"addChristoffel", "[", 
              RowBox[{"expr", ",", "ind"}], "]"}], ",", 
             RowBox[{"selecton", "[", 
              RowBox[{
               RowBox[{"Select", "[", 
                RowBox[{
                 RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", 
                 "AIndexQ"}], "]"}], ",", "vbundles"}], "]"}]}], "]"}]}], "-", 
          RowBox[{"addChristoffelDensity", "[", 
           RowBox[{"expr", ",", "covd", ",", "ind", ",", "tmpchrhead"}], 
           "]"}], "+", 
          RowBox[{"addChristoffelDensity", "[", 
           RowBox[{"expr", ",", "covd2", ",", "ind", ",", "tmpchrhead"}], 
           "]"}]}], "/.", 
         RowBox[{
          RowBox[{"CHR", "[", "indices__", "]"}], "\[RuleDelayed]", 
          RowBox[{"tmpchrhead", "[", 
           RowBox[{
            RowBox[{"Christoffel", "[", 
             RowBox[{"covd", ",", "covd2"}], "]"}], "[", "indices", "]"}], 
           "]"}]}]}], ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"87d4b5da-11f0-46e3-bc40-22b6389c321f"],

Cell["\<\
Note that we select only abstract indices because those are the only indices \
producing Christoffel terms.\
\>", "Text",ExpressionUUID->"e3f78fcc-137c-4538-bb61-a90a5d84a5a1"],

Cell["\<\
This small function returns an IndexList of pairs of indices: the first in \
each pair is an index in the original list belonging to one of the vbundles; \
the second is a dummy in that vbundle. Note that we are using IndexOnQ and \
hence we accept indices in subvbundles of vbundle, even though the dummy \
always belongs to the full vbundle. QUESTION. Is this always what we want?\
\>", "Text",ExpressionUUID->"dd48c6b8-5b28-4ac4-8b35-41daf7fce52d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"selecton", "[", 
    RowBox[{"indices_IndexList", ",", "vbundles_List"}], "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Union", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"selecton", "[", 
        RowBox[{"indices", ",", "#"}], "]"}], "&"}], "/@", "vbundles"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"selecton", "[", 
    RowBox[{"indices_IndexList", ",", 
     RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], "&"}], "/@", 
    RowBox[{"Select", "[", 
     RowBox[{"indices", ",", 
      RowBox[{
       RowBox[{"IndexOnQ", "[", 
        RowBox[{"#", ",", "vbundle"}], "]"}], "&"}]}], "]"}]}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7a32d9c7-8b79-49ff-9cef-0901fbf5ccf7"],

Cell["\<\
Now we can create the Christoffel term. Note the use of the global variable \
CHR, to be later transformed into Christoffel with both derivatives. Indices \
are always introduced with the configuration {up, ?, down}, where the middle \
index is simply given with its original character.\
\>", "Text",ExpressionUUID->"fad343f4-90b1-4ee8-884c-b4bc6688b687"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"addChristoffel", "[", 
     RowBox[{"expr_", ",", "ind_"}], "]"}], "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"oldind_", "?", "upQ"}], ",", "dummy_"}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CHR", "[", 
     RowBox[{"oldind", ",", "ind", ",", 
      RowBox[{"-", "dummy"}]}], "]"}], 
    RowBox[{"ReplaceIndex", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"oldind", "\[Rule]", "dummy"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"addChristoffel", "[", 
     RowBox[{"expr_", ",", "ind_"}], "]"}], "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"oldind_", "?", "downQ"}], ",", "dummy_"}], "}"}], "]"}], ":=", 
   
   RowBox[{
    RowBox[{"-", 
     RowBox[{"CHR", "[", 
      RowBox[{"dummy", ",", "ind", ",", "oldind"}], "]"}]}], 
    RowBox[{"ReplaceIndex", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"oldind", "\[Rule]", 
       RowBox[{"-", "dummy"}]}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addChristoffelDensity", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_", "?", "WeightedCovDQ"}], ",", "ind_", ",", 
     "tmpchrhead_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"WeightedWithBasis", "[", "covd", "]"}]}], ",", 
       RowBox[{"dummy", "=", 
        RowBox[{"DummyIn", "@", 
         RowBox[{"VBundleOfIndex", "[", "ind", "]"}]}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"WeightOf", "[", 
       RowBox[{"expr", ",", "basis"}], "]"}], 
      RowBox[{"tmpchrhead", "[", 
       RowBox[{
        RowBox[{"Christoffel", "[", 
         RowBox[{"covd", ",", 
          RowBox[{"xAct`xCoba`PDOfBasis", "[", "basis", "]"}]}], "]"}], "[", 
        RowBox[{"dummy", ",", "ind", ",", 
         RowBox[{"-", "dummy"}]}], "]"}], "]"}], "expr"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addChristoffelDensity", "[", 
    RowBox[{"_", ",", "_", ",", "_", ",", "_"}], "]"}], ":=", "0"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7e466180-6284-4a85-9194-b1f8a5656354"],

Cell["\<\
QUESTION: Why do we use a specific Christoffel in the density term instead of \
usins CHR as well?\
\>", "Text",ExpressionUUID->"01afea34-5846-41ac-aaf5-82d28f204a47"],

Cell["Backwards compatibility:", \
"Text",ExpressionUUID->"ab9f85db-fa43-4748-9d9e-af615b1be6be"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CovDToChristoffel"}]], \
"Input",ExpressionUUID->"8160a867-e5a9-4a0f-bedb-6512e8cc041e"],

Cell[BoxData[
 StyleBox["\<\"CovDToChristoffel = ChangeCovD. Kept for backwards \
compatibility.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672775-5338953",ExpressionUUID->"bb74bca7-74c1-465f-937d-\
645c75fcea2d"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CovDToChristoffel", "=", "ChangeCovD"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "CovDToChristoffel", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"637134c6-fef1-47db-a60e-975861f46be4"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.3. Christoffel", \
"Subsubsection",ExpressionUUID->"6465b0ad-84b5-4793-a2a1-de53447d2b14"],

Cell["\<\
This function is defined with indices to check that they are correct with \
respect to the derivatives cd1, cd2. That also allows manipulating \
AChristoffel and Christoffel with the same code. This is an exception with \
respect to Riemann[cd] and similar constructs.\
\>", "Text",ExpressionUUID->"965269ea-2912-4137-8314-7c7c3c727101"],

Cell["\<\
1) This is the user driver, that must be used to ensure that Christoffels are \
correctly dealt with. Those Christoffels having PD as one of the derivatives \
are abbreviated to ChristoffelCD, without PD appearing explicitly in the name.\
\>", "Text",ExpressionUUID->"3cb9537c-340b-4305-b264-a7be7eefb0cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Christoffel"}]], \
"Input",ExpressionUUID->"f1346b59-72d2-4494-8607-2c454e23109b"],

Cell[BoxData[
 StyleBox["\<\"Christoffel[covd1, covd2][a, -b, -c] returns the Christoffel \
tensor relating the connections covd1 and covd2, and defines it if it does \
not exist yet. Christoffel[covd][a, -b, -c] is equivalent to \
Christoffel[covd, PD][a, -b, -c].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672777-5338953",ExpressionUUID->"f31b99e4-45db-4276-b3e5-\
9901380e6b7c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", "argument"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", "covd_", "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{"covd", ",", "PD"}], "]"}], "[", 
      RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Check", " ", "of", " ", "Dagger", " ", "for", " ", 
      RowBox[{"indices", ".", " ", "Assume"}], " ", "both", " ", "i1"}], ",", 
     " ", 
     RowBox[{
      RowBox[{"i3", " ", "have", " ", "same", " ", "dagger"}], "-", 
      "character"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{"covd1_", ",", "covd2_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"i1_", "?", "DaggerIndexQ"}], ",", "i2_", ",", "i3_"}], "]"}], 
     ":=", 
     RowBox[{"Dagger", "[", 
      RowBox[{
       RowBox[{"Christoffel", "[", 
        RowBox[{"covd1", ",", "covd2"}], "]"}], "[", 
       RowBox[{
        RowBox[{"DaggerIndex", "[", "i1", "]"}], ",", "i2", ",", 
        RowBox[{"DaggerIndex", "[", "i3", "]"}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Three", " ", "special", " ", "cases"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", "covd_"}], "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", "PD"}], "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"makeChristoffel", "[", 
       RowBox[{"{", 
        RowBox[{"covd", ",", "PD"}], "}"}], "]"}], "[", 
      RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{"PD", ",", 
        RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"makeChristoffel", "[", 
        RowBox[{"{", 
         RowBox[{"covd", ",", "PD"}], "}"}], "]"}], "[", 
       RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"General", " ", "case"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{
        RowBox[{"covd1_", "?", "CovDQ"}], ",", 
        RowBox[{"covd2_", "?", "CovDQ"}]}], "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Order", "[", 
       RowBox[{"covd1", ",", "covd2"}], "]"}], 
      RowBox[{
       RowBox[{"makeChristoffel", "[", 
        RowBox[{"Sort", "[", 
         RowBox[{"{", 
          RowBox[{"covd1", ",", "covd2"}], "}"}], "]"}], "]"}], "[", 
       RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Errors", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{
        RowBox[{"_", "?", "CovDQ"}], ",", "covd_"}], "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Christoffel", "::", "unknown"}], ",", 
        "\"\<covariant derivative\>\"", ",", "covd"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Christoffel", "[", 
       RowBox[{"covd_", ",", "_"}], "]"}], "[", 
      RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Christoffel", "::", "unknown"}], ",", 
        "\"\<covariant derivative\>\"", ",", "covd"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"Christoffel", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "Christoffel", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"eb916904-62f5-4159-8ab8-cf696ba5b6ed"],

Cell["\<\
The head AChristoffel acting on two pairs of brackets is inmediately \
converted into Christoffel, to avoid repeating the whole code of Christoffel:\
\
\>", "Text",ExpressionUUID->"a4b44d03-19b2-404c-bb93-a87f509fd521"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"AChristoffel", "[", 
     RowBox[{"covd1_", ",", 
      RowBox[{"covd2_", ":", "PD"}]}], "]"}], "[", 
    RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Christoffel", "[", 
     RowBox[{"covd1", ",", "covd2"}], "]"}], "[", 
    RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"AChristoffel", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "AChristoffel", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b34770bc-6758-4c2f-a3c6-09783b1343d3"],

Cell["\<\
We could add another head called AChristoffelDagger or similar to allow for \
the construction of the complex conjugate Christoffel. Instead, we prefer to \
force the use of the construction Dagger[Christoffel[_,_][_,_,_]], which is \
clearer with respect to the indices to use. Hence if Christoffel detects a \
Dagger index then it changes itself to that form, as we have seen.\
\>", "Text",ExpressionUUID->"23b255c4-8c31-49d2-926f-3e3152c24224"],

Cell["\<\
2) Now we check that the derivatives and the indices are compatible, and at \
the same time (if everything is OK) decide whether to use Christoffel or \
AChristoffel. In this function covd is never PD. The derivatives are already \
sorted.\
\>", "Text",ExpressionUUID->"d3eb7d30-54de-43b9-ab14-52fb311b7d3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"(", "A", ")"}], "Christoffel", " ", "with", " ", "covd", " ", 
    "and", " ", 
    RowBox[{"PD", ".", " ", "No"}], " ", "compatibility", " ", "check", " ", 
    RowBox[{"needed", ".", " ", "The"}], " ", "tensor", " ", "has", " ", 
    "already", " ", "been", " ", "defined"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"makeChristoffel", "[", 
      RowBox[{"{", 
       RowBox[{"covd_", ",", "PD"}], "}"}], "]"}], "[", 
     RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"chrtype", ",", "tbundle", ",", "vbundle"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"chrtype", ",", "tbundle", ",", "vbundle"}], "}"}], "=", 
        RowBox[{"checkChristoffelIndices", "[", 
         RowBox[{
          RowBox[{"VBundlesOfCovD", "[", "covd", "]"}], ",", 
          RowBox[{"VBundleOfIndex", "/@", 
           RowBox[{"IndexList", "[", 
            RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"GiveSymbol", "[", 
         RowBox[{"chrtype", ",", "covd"}], "]"}], "[", 
        RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9829169f-663b-406d-8b66-d8e43d178cf0"],

Cell["\<\
Now covd1 and covd2 are both different from PD, and are already sorted. Note \
that the call to compareCovDs is equivalent to a call to CompatibleCovDsQ, \
but now with the verbose switch on which will send a message if the tbundles \
of covd1, covd2 differ (and return Zero) or throw an error if they are the \
same but the inner vbundles are incompatible:\
\>", "Text",ExpressionUUID->"af9a8444-5fa3-4fbb-9152-910db92d8000"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChristoffel", "[", 
     RowBox[{"{", 
      RowBox[{"covd1_", ",", "covd2_"}], "}"}], "]"}], "[", 
    RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chrtype", ",", "chrname", ",", 
       RowBox[{"vbundles1", "=", 
        RowBox[{"VBundlesOfCovD", "[", "covd1", "]"}]}], ",", 
       RowBox[{"vbundles2", "=", 
        RowBox[{"VBundlesOfCovD", "[", "covd2", "]"}]}], ",", "tbundle", ",", 
       "vbundle"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"compareCovDs", "[", 
         RowBox[{"vbundles1", ",", "vbundles2", ",", "True"}], "]"}], "===", 
        "Zero"}], ",", "\[IndentingNewLine]", "0", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"chrtype", ",", "tbundle", ",", "vbundle"}], "}"}], "=", 
         RowBox[{"checkChristoffelIndices", "[", 
          RowBox[{
           RowBox[{"DeleteDuplicates", "@", 
            RowBox[{"Flatten", "[", 
             RowBox[{"{", 
              RowBox[{"vbundles1", ",", "vbundles2"}], "}"}], "]"}]}], ",", 
           RowBox[{"VBundleOfIndex", "/@", 
            RowBox[{"IndexList", "[", 
             RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"chrname", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"chrtype", ",", "covd1", ",", "covd2"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"xTensorQ", "[", "chrname", "]"}]}], ",", 
          RowBox[{"defChristoffel", "[", 
           RowBox[{"chrname", ",", 
            RowBox[{"{", 
             RowBox[{"tbundle", ",", "vbundle"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"chrtype", ",", "covd1", ",", "covd2"}], "}"}]}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"chrname", "[", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0fdfe0f2-84a2-4a2a-98e8-25b47302c205"],

Cell["\<\
3) Checking function. Note that the IndexList contains vbundles and not \
indices. The input has the vbundles of the covds being related, and then the \
vbundles of the three indices of the Christoffel tensor. The derivatives have \
already been tested for compatibility, and hence the list vbundles contains a \
single tangent vbundle, and it is at the first place in the list (perhaps \
repeated at a later place as well).\
\>", "Text",ExpressionUUID->"62d12b6d-33a8-4e9a-bad8-e63897c65753"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Christoffel", "::", "ind"}], "=", 
   "\"\<Index `1` of (A)Christoffel is not compatible with derivative.\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Christoffel", "::", "inds13"}], "=", 
   "\"\<Indices 1 and 3 of (A)Christoffel must belong to the same \
vbundle.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkChristoffelIndices", "[", 
    RowBox[{"vbundles_List", ",", 
     RowBox[{"IndexList", "[", 
      RowBox[{"vb1_", ",", "vb2_", ",", "vb3_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tb", "=", 
        RowBox[{"First", "[", "vbundles", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"svb1", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{"vbundles", ",", 
          RowBox[{"vb_", "/;", 
           RowBox[{"SubvbundleQ", "[", 
            RowBox[{"vb", ",", "vb1"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"svb2", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{"vbundles", ",", 
          RowBox[{"vb_", "/;", 
           RowBox[{"SubvbundleQ", "[", 
            RowBox[{"vb", ",", "vb2"}], "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"svb3", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{"vbundles", ",", 
          RowBox[{"vb_", "/;", 
           RowBox[{"SubvbundleQ", "[", 
            RowBox[{"vb", ",", "vb3"}], "]"}]}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"svb2", "=!=", 
        RowBox[{"{", "tb", "}"}]}], ",", 
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Christoffel", "::", "ind"}], ",", "2"}], "]"}], "]"}], ",",
        "\[IndentingNewLine]", 
       RowBox[{"svb1", "===", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Christoffel", "::", "ind"}], ",", "1"}], "]"}], "]"}], ",",
        "\[IndentingNewLine]", 
       RowBox[{"svb3", "===", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Christoffel", "::", "ind"}], ",", "3"}], "]"}], "]"}], ",",
        "\[IndentingNewLine]", 
       RowBox[{"svb1", "=!=", "svb3"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{"Christoffel", "::", "inds13"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"svb1", "===", "svb2"}], ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "tb", ",", "tb"}], "}"}], ",", 
       "\[IndentingNewLine]", "True", ",", 
       RowBox[{"{", 
        RowBox[{"AChristoffel", ",", "tb", ",", 
         RowBox[{"First", "[", "svb1", "]"}]}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"76e57166-843b-41ca-b274-ce4009157a36"],

Cell["\<\
4) Define the Christoffel tensor if it does not exist yet. None of covd1 or \
covd2 in this function is ever PD. We assume that {covd1,covd2} are already \
sorted. There is no need to store complex conjugates of the Christoffel \
tensors, due to the i1_?DaggerIndexQ construction above. We create indices \
here instead of taking the previous {i1, i2, i3} because there is no \
guarantee that the latter are abstract. Note that tb and vb could coincide \
and that is why we need to extract excessive indices from both.\
\>", "Text",ExpressionUUID->"824c7c44-f72b-4d76-9135-8ccad168a66f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"defChristoffel", "[", 
    RowBox[{"chrname_", ",", 
     RowBox[{"{", 
      RowBox[{"tb_", ",", "vb_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"chrtype_", ",", "covd1_", ",", "covd2_"}], "}"}], ",", 
     "options___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", ",", 
       RowBox[{"vbinds", "=", 
        RowBox[{"GetIndicesOfVBundle", "[", 
         RowBox[{"vb", ",", "3"}], "]"}]}], ",", 
       RowBox[{"tbinds", "=", 
        RowBox[{"GetIndicesOfVBundle", "[", 
         RowBox[{"tb", ",", "2"}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"inds", "=", 
       RowBox[{"Sequence", "[", 
        RowBox[{
         RowBox[{"vbinds", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"tbinds", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"vbinds", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"DefTensor", "[", 
       RowBox[{
        RowBox[{"chrname", "[", "inds", "]"}], ",", 
        RowBox[{"Union", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"tb", ",", "vb"}], "}"}], ",", 
          RowBox[{"DependenciesOfCovD", "[", "covd1", "]"}], ",", 
          RowBox[{"DependenciesOfCovD", "[", "covd2", "]"}]}], "]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tb", "===", "vb"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"Torsion", "[", "covd1", "]"}], "[", "inds", "]"}], "===", 
            RowBox[{
             RowBox[{"Torsion", "[", "covd2", "]"}], "[", "inds", "]"}]}]}], 
          ",", 
          RowBox[{"Symmetric", "[", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], "]"}], ",", 
          RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", 
        RowBox[{"PrintAs", "\[RuleDelayed]", 
         RowBox[{"GiveOutputString", "[", 
          RowBox[{"chrtype", ",", "covd1", ",", "covd2"}], "]"}]}], ",", 
        RowBox[{"TensorID", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"chrtype", ",", "covd1", ",", "covd2"}], "}"}]}], ",", 
        RowBox[{"Dagger", "\[RuleDelayed]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"DaggerIndexQ", "@", 
            RowBox[{"IndexList", "[", "inds", "]"}]}], ",", "Complex", ",", 
           "Real"}], "]"}]}], ",", "options"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"$Christoffels", ",", 
        RowBox[{"{", 
         RowBox[{"chrname", ",", 
          RowBox[{"{", 
           RowBox[{"chrtype", ",", "covd1", ",", "covd2"}], "}"}], ",", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"{", 
            RowBox[{"tb", ",", "vb"}], "}"}], "]"}]}], "}"}]}], "]"}], 
      ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5268eeaf-8011-4ce5-9cbd-39130b0a9a9d"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.4. BreakChristoffel", \
"Subsubsection",ExpressionUUID->"c2337ef2-e6a3-41d0-90cc-73fac489035f"],

Cell["\<\
This function separates Christoffel tensors using an intermeadiate \
derivative, which is PD by default. Internal part:\
\>", "Text",ExpressionUUID->"079c29f0-a724-43c1-a3ad-6aca483abd39"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "BreakChristoffel"}]], \
"Input",ExpressionUUID->"bed05c62-621a-4a47-ae17-86b95d02d987"],

Cell[BoxData[
 StyleBox["\<\"BreakChristoffel[expr, chr, covd] transforms all instances of \
chr[inds] (from covd1 to covd2) in expr into Christoffel[covd1, \
covd][inds]-Christoffel[covd2, covd][inds]. BreakChristoffel[expr, chr] is \
converted into BreakChristoffel[expr, chr, PD]. BreakChristoffel[expr, covd] \
breaks all Christoffel tensors using covd as intermediate connection. \
BreakChristoffel[expr] is converted into BreakChristoffel[expr, PD].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672778-5338953",ExpressionUUID->"2c0dfb0d-3904-4805-b5bf-\
8b5dd815322f"]
}, Open  ]],

Cell["\<\
Public function. Note that we cannot use Fold; we must use all \
breakChristoffel rules simultaneously. It is ugly to have a second argument \
accepting both covariant derivatives and christoffel tensors, but I guess it \
is late to change that.\
\>", "Text",ExpressionUUID->"4fa59bdf-0644-4286-a3d9-539f55c226fe"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BreakChristoffel", "[", "expr_", "]"}], ":=", 
   RowBox[{"BreakChristoffel", "[", 
    RowBox[{"expr", ",", "PD"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BreakChristoffel", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{"makeChristoffelRule", "[", "covd", "]"}], ",", 
      "$Christoffels"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BreakChristoffel", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"chr_", "?", "xTensorQ"}], ",", 
     RowBox[{"covd_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"makeChristoffelRule", "[", "covd", "]"}], "[", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Cases", "[", 
        RowBox[{"$Christoffels", ",", 
         RowBox[{"{", 
          RowBox[{"chr", ",", "_", ",", "_"}], "}"}]}], "]"}], ",", "1"}], 
      "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"BreakChristoffel", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "BreakChristoffel", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"894ae8e2-b905-4b35-bd6b-775d42fb1e1e"],

Cell["\<\
Private functions. The derivative in the first bracket of makeChristoffelRule \
is the intermediate derivative.\
\>", "Text",ExpressionUUID->"d4cd965e-71df-47c5-896d-d1e856f68f8d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChristoffelRule", "[", "PD", "]"}], "[", 
    RowBox[{"{", 
     RowBox[{"chrname_", ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "covd1_", ",", "covd2_"}], "}"}], ",", "_"}], "}"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"chrname", "[", "inds__", "]"}], "\[RuleDelayed]", 
    RowBox[{
     RowBox[{"breakChristoffel", "[", 
      RowBox[{"covd1", ",", "covd2", ",", "PD"}], "]"}], "[", "inds", 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChristoffelRule", "[", "covd_", "]"}], "[", 
    RowBox[{"{", 
     RowBox[{"chrname_", ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "covd1_", ",", "covd2_"}], "}"}], ",", "_"}], "}"}], 
    "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CompatibleCovDsQ", "[", 
       RowBox[{"covd", ",", "covd1"}], "]"}], "&&", 
      RowBox[{"CompatibleCovDsQ", "[", 
       RowBox[{"covd", ",", "covd2"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"chrname", "[", "inds__", "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"breakChristoffel", "[", 
        RowBox[{"covd1", ",", "covd2", ",", "covd"}], "]"}], "[", "inds", 
       "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChristoffelRule", "[", "_", "]"}], "[", 
    RowBox[{"{", "}"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"55dfd0b9-0eb9-4fa9-8e09-3744c2876748"],

Cell["\<\
Finally (note that Christoffel will change itself into AChristoffel if \
needed, and the Dagger head will be used when needed as well):\
\>", "Text",ExpressionUUID->"6777b3be-812e-4fda-b205-99c783e2c37a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"breakChristoffel", "[", 
     RowBox[{"covd1_", ",", "covd2_", ",", "covd_"}], "]"}], "[", "inds__", 
    "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Christoffel", "[", 
      RowBox[{"covd1", ",", "covd"}], "]"}], "[", "inds", "]"}], "-", 
    RowBox[{
     RowBox[{"Christoffel", "[", 
      RowBox[{"covd2", ",", "covd"}], "]"}], "[", "inds", "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1b7b15e8-5fc0-484c-b5fd-24a1e622fc8f"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.5. ChangeTorsion", \
"Subsubsection",ExpressionUUID->"8d5b45e6-31ec-4cdc-8ad0-60ce8becb951"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChangeTorsion"}]], \
"Input",ExpressionUUID->"506883ac-e4cb-4760-9fae-dad6d935da02"],

Cell[BoxData[
 StyleBox["\<\"ChangeTorsion[expr, covd1, covd2] changes the torsion tensor \
of covd1 by the torsion tensor of covd2 using the antisymmetric part of the \
Christoffel relating covd1 and covd2. The second argument is listable. \
ChangeTorsion[expr, covd1] is converted into ChangeTorsion[expr, covd1, PD]. \
ChangeTorsion[expr] is converted into ChangeTorsion[expr, $CovDs].\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672780-5338953",ExpressionUUID->"fdfd7a30-286f-48c7-a146-\
0332a3eb81c5"]
}, Open  ]],

Cell["Public part:", \
"Text",ExpressionUUID->"8b75ad90-3c57-4f76-ac7c-b95b5fd8383d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChangeTorsion", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd1_Symbol", "?", "TorsionQ"}], ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"makeChangeTorsionRule", "[", "covd2", "]"}], "[", "covd1", 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeTorsion", "[", 
    RowBox[{"expr_", ",", "list_List", ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ChangeTorsion", "[", 
       RowBox[{"#1", ",", "#2", ",", "covd2"}], "]"}], "&"}], ",", "expr", 
     ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeTorsion", "[", 
    RowBox[{"expr_", ",", "_", ",", 
     RowBox[{"_", ":", "PD"}]}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeTorsion", "[", "expr_", "]"}], ":=", 
   RowBox[{"ChangeTorsion", "[", 
    RowBox[{"expr", ",", "$CovDs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ChangeTorsion", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ChangeTorsion", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b025bb8a-4832-4b68-ae3e-c59239c86fcb"],

Cell["\<\
This function changes the torsion tensor of a derivative to the torsion \
tensor of another derivative, with a couple of Christoffel tensors in \
between. If the second derivative is torsionless then only the Christoffel \
appear. Note that these rules are valid for all kinds of indices and \
therefore we do not need checks of index types. Recall that HeadOfTensor \
returns either a tensor symbol or MultiplyTensor[k, symbol] or Zero.\
\>", "Text",ExpressionUUID->"6d2d133d-a3f0-4131-8ece-b91406f24d8c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"changeTorsion", "[", 
     RowBox[{"covd1_", ",", "covd2_"}], "]"}], "[", 
    RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chr", "=", 
       RowBox[{"HeadOfTensor", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Christoffel", "[", 
           RowBox[{"covd1", ",", "covd2"}], "]"}], "[", 
          RowBox[{"a", ",", "b", ",", "c"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Torsion", "[", "covd2", "]"}], "[", 
       RowBox[{"a", ",", "b", ",", "c"}], "]"}], "+", 
      RowBox[{"$TorsionSign", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"chr", "[", 
          RowBox[{"a", ",", "b", ",", "c"}], "]"}], "-", 
         RowBox[{"chr", "[", 
          RowBox[{"a", ",", "c", ",", "b"}], "]"}]}], ")"}]}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChangeTorsionRule", "[", "covd2_", "]"}], "[", "covd1_", 
    "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"TorsionQ", "[", "covd1", "]"}], "&&", 
      RowBox[{"CompatibleCovDsQ", "[", 
       RowBox[{"covd1", ",", "covd2"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Torsion", "[", "covd1", "]"}], "[", "inds__", "]"}], 
      "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"changeTorsion", "[", 
        RowBox[{"covd1", ",", "covd2"}], "]"}], "[", "inds", "]"}]}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"318662b9-b6c8-44c6-9eb2-c0ddde69fd98"],

Cell["Backwards compatibility:", \
"Text",ExpressionUUID->"9c6ce79d-e095-46ed-b183-c12d8ca97d54"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TorsionToChristoffel"}]], \
"Input",ExpressionUUID->"3e0b41ec-4bf3-41fe-a9c4-1ac682ec23ed"],

Cell[BoxData[
 StyleBox["\<\"TorsionToChristoffel = ChangeTorsion. Kept for backwards \
compatibility.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672781-5338953",ExpressionUUID->"141cfaf2-db23-42c0-bf1e-\
938bb381ca4f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"TorsionToChristoffel", "=", "ChangeTorsion"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TorsionToChristoffel", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c1b102d2-9209-4b58-959d-5ba096b07a27"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.6. ChangeCurvature", \
"Subsubsection",ExpressionUUID->"a6a62382-ec04-4554-8bb8-ca95aff7fa00"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChangeCurvature"}]], \
"Input",ExpressionUUID->"ae4734c8-48d3-4e10-82f0-c2eb3d22d6ed"],

Cell[BoxData[
 StyleBox["\<\"ChangeCurvature[expr, covd1, covd2] changes the curvature \
tensors (Riemann, Ricci, RicciScalar and FRiemann) of covd1 into the \
curvature tensors of covd2 using the Christoffels relating covd1 and covd2. \
The second argument is listable. ChangeCurvature[expr, covd1] is converted \
into ChangeCurvature[expr, covd1, PD]. ChangeCurvature[expr] is converted \
into ChangeCurvature[expr, $CovDs].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672782-5338953",ExpressionUUID->"ce3d7042-0f4e-43cd-9a25-\
a71421abec6f"]
}, Open  ]],

Cell["\<\
1) User function. Note that we require that the first derivative has \
curvature (either on the tangent bundle or on the internal vector bundle):\
\>", "Text",ExpressionUUID->"0cacaf5b-6434-44af-a4fc-cf80ddc7b0b4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCurvature", "[", 
    RowBox[{"expr_", ",", "covd_", ",", "covd_"}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCurvature", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd1_Symbol", "?", "CurvatureQ"}], ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"CompatibleCovDsQ", "[", 
      RowBox[{"covd1", ",", "covd2"}], "]"}], ",", 
     RowBox[{"expr", "/.", 
      RowBox[{
       RowBox[{"makeChangeCurvatureRules", "[", 
        RowBox[{"covd2", ",", 
         RowBox[{"metricsof", "[", "covd1", "]"}]}], "]"}], "[", "covd1", 
       "]"}]}], ",", "expr"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCurvature", "[", 
    RowBox[{"expr_", ",", "list_List", ",", 
     RowBox[{"covd2_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ChangeCurvature", "[", 
       RowBox[{"#1", ",", "#2", ",", "covd2"}], "]"}], "&"}], ",", "expr", 
     ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCurvature", "[", 
    RowBox[{"expr_", ",", "_", ",", 
     RowBox[{"_", ":", "PD"}]}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeCurvature", "[", "expr_", "]"}], ":=", 
   RowBox[{"ChangeCurvature", "[", 
    RowBox[{"expr", ",", "$CovDs"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ChangeCurvature", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "ChangeCurvature", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ed4ccacc-3a40-4dea-9be9-43933faf9d3c"],

Cell["\<\
Only compatible pairs of derivatives go through makeChangeCurvatureRules.\
\>", "Text",ExpressionUUID->"d5f086b5-14dd-4a35-a9ce-3f2ab4bfbbde"],

Cell["\<\
2) Intermediate function. It detects the metrics of the vbundles of a covd \
(this is to move the indices up and down, and not to construct Riemanns or \
Christoffels from the metrics). If there is no metric there we simply use \
delta. Note that the order of metrics has nothing to do with the order of \
indices:\
\>", "Text",ExpressionUUID->"66d7262f-c893-432d-a54c-b4305a8e0429"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Return", " ", "the", " ", "first"}], "-", "metric"}], ",", " ", 
    
    RowBox[{
    "or", " ", "delta", " ", "if", " ", "there", " ", "is", " ", "none"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"metricof", "[", "vb_", "]"}], ":=", 
     RowBox[{
      RowBox[{"FirstMetricOfVBundle", "[", 
       RowBox[{"vb", ",", "False"}], "]"}], "/.", 
      RowBox[{"Null", "\[Rule]", "delta"}]}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"List", " ", "of", " ", 
      RowBox[{"metrics", ".", " ", "We"}], " ", "assume", " ", 
      "VBundlesOfCovD", " ", "return", " ", "1"}], ",", " ", 
     RowBox[{"2", " ", "or", " ", "3", " ", "vbundles"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsof", "[", "covd_Symbol", "]"}], ":=", 
     RowBox[{"metricsof", "[", 
      RowBox[{"VBundlesOfCovD", "[", "covd", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsof", "[", 
      RowBox[{"{", "tb_", "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"metricof", "[", "tb", "]"}], ",", "delta", ",", "delta"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsof", "[", 
      RowBox[{"{", 
       RowBox[{"tb_", ",", "vb_"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"metricof", "[", "tb", "]"}], ",", 
       RowBox[{"metricof", "[", "vb", "]"}], ",", "delta"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsof", "[", 
      RowBox[{"{", 
       RowBox[{"tb_", ",", "vb_", ",", "vbdag_"}], "}"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"metricof", "[", "tb", "]"}], ",", 
       RowBox[{"metricof", "[", "vb", "]"}], ",", 
       RowBox[{"metricof", "[", "vbdag", "]"}]}], "}"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"52dd5348-63f8-4d42-85bb-b2009a5106ba"],

Cell["\<\
3) The rules actually involve using Riemann, Ricci, RicciScalar (if covd1 has \
a metric) and FRiemann. Recall we are changing the curvature tensors of covd1 \
into those of covd2. We have checked before that covd1 has curvature of some \
type and hence covd1 here cannot be PD. Change Sept 2011: In \
makeChangeRicciRule we now use delta instead of MetricOfCovD[covd1] because \
what we need is to raise and lower indices, even if covd1 is not a first \
metric. Thanks to Stephen Green and Leo Stein for their help in fixing this.\
\>", "Text",ExpressionUUID->"4ea051be-d7f3-40f5-ab2e-28f76bd34c15"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"makeChangeCurvatureRules", "[", 
    RowBox[{"covd2_", ",", "metrics_"}], "]"}], "[", "covd1_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vbundles", "=", 
      RowBox[{"VBundlesOfCovD", "[", "covd1", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Join", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"CurvatureQ", "[", 
         RowBox[{"covd1", ",", 
          RowBox[{"First", "[", "vbundles", "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"makeChangeRiemannRule", "[", 
             RowBox[{"covd2", ",", "metrics", ",", "Riemann"}], "]"}], "[", 
            "covd1", "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"makeChangeRicciRule", "[", 
             RowBox[{"covd2", ",", "delta"}], "]"}], "[", "covd1", "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"makeChangeRicciScalarRule", "[", 
             RowBox[{"covd2", ",", 
              RowBox[{"MetricOfCovD", "[", "covd1", "]"}]}], "]"}], "[", 
            "covd1", "]"}]}], "}"}], "\[IndentingNewLine]", "]"}], ",", 
        RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "vbundles", "]"}], ">", "1"}], "&&", 
         RowBox[{"CurvatureQ", "[", 
          RowBox[{"covd1", ",", 
           RowBox[{"Last", "[", "vbundles", "]"}]}], "]"}]}], ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"makeChangeRiemannRule", "[", 
            RowBox[{"covd2", ",", "metrics", ",", "FRiemann"}], "]"}], "[", 
           "covd1", "]"}], "}"}], "]"}], ",", 
        RowBox[{"{", "}"}]}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c4cea31f-af67-43fe-87e0-d5add0277247"],

Cell["\<\
4a) Change of Riemann or FRiemann. Note that in all these formulas we need \
Riemann, and not RiemannDown. We separate two cases:
\t1) if all indices are abstract and have the right positions then use the \
formula directly. Note that there is no check of vbundles
\t2) in all other cases multiply by metric or delta factors. This includes \
the cases with basis indices. Note that the metric is that of the vbundle and \
not necessarily that of the covariant derivative.\
\>", "Text",ExpressionUUID->"7450f211-9f61-48af-b6ce-aaea8cffe655"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"With", " ", "no", " ", "need", " ", "of", " ", "a", " ", 
    RowBox[{"metric", ".", " ", "riemann"}], " ", "can", " ", "be", " ", 
    "either", " ", "Riemann", " ", "or", " ", "FRiemann"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"changeRiemann", "[", 
       RowBox[{"covd1_", ",", "covd2_", ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "riemann_"}], "]"}], 
      "[", 
      RowBox[{
       RowBox[{"-", "c_Symbol"}], ",", 
       RowBox[{"-", "d_Symbol"}], ",", 
       RowBox[{"-", "b_Symbol"}], ",", "a_Symbol"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"chr", "=", 
         RowBox[{"HeadOfTensor", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Christoffel", "[", 
             RowBox[{"covd1", ",", "covd2"}], "]"}], "[", 
            RowBox[{"a", ",", 
             RowBox[{"-", "c"}], ",", 
             RowBox[{"-", "b"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"a", ",", 
             RowBox[{"-", "c"}], ",", 
             RowBox[{"-", "b"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"e", "=", 
           RowBox[{"DummyAs", "[", "a", "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"riemann", "[", "covd2", "]"}], "[", 
           RowBox[{
            RowBox[{"-", "c"}], ",", 
            RowBox[{"-", "d"}], ",", 
            RowBox[{"-", "b"}], ",", "a"}], "]"}], "+", 
          RowBox[{"$RiemannSign", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{
               RowBox[{"covd2", "[", 
                RowBox[{"-", "c"}], "]"}], "[", 
               RowBox[{"chr", "[", 
                RowBox[{"a", ",", 
                 RowBox[{"-", "d"}], ",", 
                 RowBox[{"-", "b"}]}], "]"}], "]"}]}], "+", 
             RowBox[{
              RowBox[{"covd2", "[", 
               RowBox[{"-", "d"}], "]"}], "[", 
              RowBox[{"chr", "[", 
               RowBox[{"a", ",", 
                RowBox[{"-", "c"}], ",", 
                RowBox[{"-", "b"}]}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"chr", "[", 
               RowBox[{"a", ",", 
                RowBox[{"-", "c"}], ",", 
                RowBox[{"-", "e"}]}], "]"}], 
              RowBox[{"chr", "[", 
               RowBox[{"e", ",", 
                RowBox[{"-", "d"}], ",", 
                RowBox[{"-", "b"}]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{"chr", "[", 
               RowBox[{"a", ",", 
                RowBox[{"-", "d"}], ",", 
                RowBox[{"-", "e"}]}], "]"}], 
              RowBox[{"chr", "[", 
               RowBox[{"e", ",", 
                RowBox[{"-", "c"}], ",", 
                RowBox[{"-", "b"}]}], "]"}]}], "+", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"riemann", "===", "Riemann"}], ",", 
               RowBox[{
                RowBox[{"-", "$TorsionSign"}], " ", 
                RowBox[{
                 RowBox[{"Torsion", "[", "covd2", "]"}], "[", 
                 RowBox[{"e", ",", 
                  RowBox[{"-", "c"}], ",", 
                  RowBox[{"-", "d"}]}], "]"}], 
                RowBox[{"chr", "[", 
                 RowBox[{"a", ",", 
                  RowBox[{"-", "e"}], ",", 
                  RowBox[{"-", "b"}]}], "]"}]}], ",", "0"}], "]"}]}], 
            ")"}]}]}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"All", " ", "other", " ", "cases"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"changeRiemann", "[", 
       RowBox[{"covd1_", ",", "covd2_", ",", 
        RowBox[{"{", 
         RowBox[{"tmetric_", ",", "vmetric_", ",", "vdagmetric_"}], "}"}], 
        ",", "riemann_"}], "]"}], "[", 
      RowBox[{"c_", ",", "d_", ",", "b_", ",", "a_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vbundle", "=", 
          RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", 
         RowBox[{"tbundle", "=", 
          RowBox[{"VBundleOfIndex", "[", "c", "]"}]}], ",", 
         RowBox[{"vdmetric", "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"HasDaggerCharacterQ", "[", "riemann", "]"}], ",", 
            "vdagmetric", ",", "vmetric"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"c1", "=", 
            RowBox[{"DummyIn", "[", "tbundle", "]"}]}], ",", 
           RowBox[{"d1", "=", 
            RowBox[{"DummyIn", "[", "tbundle", "]"}]}], ",", 
           RowBox[{"b1", "=", 
            RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
           RowBox[{"a1", "=", 
            RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
         RowBox[{
          RowBox[{"tmetric", "[", 
           RowBox[{"c", ",", "c1"}], "]"}], 
          RowBox[{"tmetric", "[", 
           RowBox[{"d", ",", "d1"}], "]"}], 
          RowBox[{"vdmetric", "[", 
           RowBox[{"b", ",", "b1"}], "]"}], 
          RowBox[{"vdmetric", "[", 
           RowBox[{"a", ",", 
            RowBox[{"-", "a1"}]}], "]"}], 
          RowBox[{
           RowBox[{"changeRiemann", "[", 
            RowBox[{"covd1", ",", "covd2", ",", 
             RowBox[{"{", 
              RowBox[{"delta", ",", "delta", ",", "delta"}], "}"}], ",", 
             "riemann"}], "]"}], "[", 
           RowBox[{
            RowBox[{"-", "c1"}], ",", 
            RowBox[{"-", "d1"}], ",", 
            RowBox[{"-", "b1"}], ",", "a1"}], "]"}]}]}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Construct", " ", "rule"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"makeChangeRiemannRule", "[", 
       RowBox[{"covd2_", ",", 
        RowBox[{"{", 
         RowBox[{"tmetric_", ",", "vmetric_", ",", "vdagmetric_"}], "}"}], 
        ",", "riemann_"}], "]"}], "[", "covd1_", "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"riemann1", "=", 
         RowBox[{"riemann", "[", "covd1", "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"HoldPattern", "[", 
         RowBox[{"riemann1", "[", 
          RowBox[{"c_", ",", "d_", ",", "b_", ",", "a_"}], "]"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{
         RowBox[{"changeRiemann", "[", 
          RowBox[{"covd1", ",", "covd2", ",", 
           RowBox[{"{", 
            RowBox[{"tmetric", ",", "vmetric", ",", "vdagmetric"}], "}"}], 
           ",", "riemann"}], "]"}], "[", 
         RowBox[{"c", ",", "d", ",", "b", ",", "a"}], "]"}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"168ac734-e413-4194-b7bc-7a8dc2f3c1e7"],

Cell["\<\
4b) Change of Ricci, in terms of change of Riemann (always Riemann, never \
FRiemann and never RiemannDown). We have already checked that covd1 has \
curvature on the tangent manifold:\
\>", "Text",ExpressionUUID->"1601c19c-447e-4237-8e14-8520a232a382"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"changeRicci", "[", 
     RowBox[{"covd1_", ",", "covd2_", ",", "_"}], "]"}], "[", 
    RowBox[{
     RowBox[{"-", "c_Symbol"}], ",", 
     RowBox[{"-", "b_Symbol"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", "=", 
       RowBox[{"DummyAs", "[", "c", "]"}]}], "}"}], ",", 
     RowBox[{"$RicciSign", " ", 
      RowBox[{
       RowBox[{"changeRiemann", "[", 
        RowBox[{"covd1", ",", "covd2", ",", 
         RowBox[{"{", 
          RowBox[{"delta", ",", "delta", ",", "delta"}], "}"}], ",", 
         "Riemann"}], "]"}], "[", 
       RowBox[{
        RowBox[{"-", "c"}], ",", 
        RowBox[{"-", "a"}], ",", 
        RowBox[{"-", "b"}], ",", "a"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"changeRicci", "[", 
     RowBox[{"covd1_", ",", "covd2_", ",", "tmetric_"}], "]"}], "[", 
    RowBox[{"c_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vbundle", "=", 
       RowBox[{"VBundleOfIndex", "[", "c", "]"}]}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"c1", "=", 
          RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
         RowBox[{"b1", "=", 
          RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"tmetric", "[", 
         RowBox[{"c", ",", "c1"}], "]"}], 
        RowBox[{"tmetric", "[", 
         RowBox[{"b", ",", "b1"}], "]"}], 
        RowBox[{
         RowBox[{"changeRicci", "[", 
          RowBox[{"covd1", ",", "covd2", ",", "HELLO"}], "]"}], "[", 
         RowBox[{
          RowBox[{"-", "c1"}], ",", 
          RowBox[{"-", "b1"}]}], "]"}]}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChangeRicciRule", "[", 
     RowBox[{"covd2_", ",", "metric_"}], "]"}], "[", "covd1_", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ricci", "=", 
       RowBox[{"Ricci", "[", "covd1", "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{"ricci", "[", "inds__", "]"}], "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"changeRicci", "[", 
        RowBox[{"covd1", ",", "covd2", ",", "metric"}], "]"}], "[", "inds", 
       "]"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b054f03e-cd7b-4d5a-9ca2-6b02efcf9876"],

Cell["\<\
4c) Change of RicciScalar, in terms of change of Ricci. Note that the metric \
to use is the metric of covd1 and not necessarily the (first-) metric of the \
manifold. If covd1 does not have an associated metric then metricofcovd1 is \
Null and we simply return {}.\
\>", "Text",ExpressionUUID->"2f23d2a4-46c4-468f-bdfc-0970cd733255"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"changeRicciScalar", "[", 
     RowBox[{"covd1_", ",", "covd2_", ",", "metricofcovd1_"}], "]"}], "[", 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "=", 
        RowBox[{"DummyIn", "[", 
         RowBox[{"TangentBundleOfCovD", "[", "covd1", "]"}], "]"}]}], ",", 
       RowBox[{"b", "=", 
        RowBox[{"DummyIn", "[", 
         RowBox[{"TangentBundleOfCovD", "[", "covd1", "]"}], "]"}]}]}], "}"}],
      ",", 
     RowBox[{"Scalar", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Inv", "[", "metricofcovd1", "]"}], "[", 
        RowBox[{"a", ",", "b"}], "]"}], 
       RowBox[{
        RowBox[{"changeRicci", "[", 
         RowBox[{"covd1", ",", "covd2", ",", "HELLO"}], "]"}], "[", 
        RowBox[{
         RowBox[{"-", "a"}], ",", 
         RowBox[{"-", "b"}]}], "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChangeRicciScalarRule", "[", 
     RowBox[{"covd2_", ",", "Null"}], "]"}], "[", "covd1_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"makeChangeRicciScalarRule", "[", 
     RowBox[{"covd2_", ",", "metricofcovd1_"}], "]"}], "[", "covd1_", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ricciscalar", "=", 
       RowBox[{"RicciScalar", "[", "covd1", "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{"ricciscalar", "[", "]"}], "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"changeRicciScalar", "[", 
        RowBox[{"covd1", ",", "covd2", ",", "metricofcovd1"}], "]"}], "[", 
       "]"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bb4870eb-7234-4045-8a0e-1c96a5af8f6b"],

Cell["Note that there are no rules for Einstein, TFRicci or Weyl.", \
"Text",ExpressionUUID->"fe7ce630-b58c-4d57-be79-7b4df5fc9d22"],

Cell["5) Backwards compatibility:", \
"Text",ExpressionUUID->"ea001b53-240e-4379-bfba-6d9a83b924e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "RiemannToChristoffel"}]], \
"Input",ExpressionUUID->"77d82f9c-d686-4113-98c9-bf70fe4d2048"],

Cell[BoxData[
 StyleBox["\<\"RiemannToChristoffel = ChangeCurvature. Kept for backwards \
compatibility.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672784-5338953",ExpressionUUID->"c106d872-3634-4bfb-8186-\
8ecf0e48433e"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RiemannToChristoffel", "=", "ChangeCurvature"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "RiemannToChristoffel", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"088f689e-b133-4ace-9320-57a96f769b29"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.7. CommuteCovDs", \
"Subsubsection",ExpressionUUID->"30032131-f817-4a57-a916-89964b5789c1"],

Cell["\<\
With this function we commute two instances of the same covariant derivative. \
Note that we introduce both Riemann tensors and Torsion tensors as required. \
The use of the indices a, b is a bit confusing: they must appear in \
CommuteCovDs as they would appear in the original expression in \"Postfix\" \
notation. By the way, indices a, b are clearly always indices of a tangent \
bundle, though they can be indices of types A, B, C or D, and they can have \
any character.\
\>", "Text",ExpressionUUID->"e1aed4c8-2f1c-44b4-9856-7e05d8f194d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CommuteCovDs", "[", 
     RowBox[{"expr_", ",", "covd_", ",", 
      RowBox[{"{", 
       RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
    RowBox[{"expr", "/.", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{
        RowBox[{"covd", "[", "b", "]"}], "[", 
        RowBox[{
         RowBox[{"covd", "[", "a", "]"}], "[", "expr1_", "]"}], "]"}], "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"makeCommuteCovDs", "[", 
       RowBox[{"expr1", ",", "covd", ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}]}], "]"}]}]}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9544ece8-92b0-4726-b298-1f20daabf537"],

Cell[TextData[{
 "All nontrivial commutations of derivatives in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " are controlled by this function. Here, only CommuteCovDs (which is public) \
is used outside this subsection. We assume that all required checks on the \
indices have already been performed. Note that only free *abstract* indices \
add curvature tensors."
}], "Text",ExpressionUUID->"db926836-2cbd-4fc4-bb41-92fac1d33d24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetAttributes", "[", 
     RowBox[{"makeCommuteCovDs", ",", "HoldFirst"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"makeCommuteCovDs", "[", 
      RowBox[{"expr_", ",", "covd_", ",", 
       RowBox[{"{", 
        RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "a", "]"}], "[", 
       RowBox[{
        RowBox[{"covd", "[", "b", "]"}], "[", "expr", "]"}], "]"}], "+", 
      RowBox[{"addCurvature", "[", 
       RowBox[{"expr", ",", "covd", ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}], ",", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "AIndexQ"}], 
         "]"}], ",", 
        RowBox[{"VBundlesOfCovD", "[", "covd", "]"}]}], "]"}], "+", 
      RowBox[{"addTorsion", "[", 
       RowBox[{"expr", ",", "covd", ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}]}], "]"}], "+", 
      RowBox[{"addOther", "[", 
       RowBox[{"expr", ",", "covd", ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}]}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"442c916e-a898-433e-92e0-f29a99992759"],

Cell["\<\
This should go before protection of Riemann,  Curvature and Torsion. We can \
interpret that vbundle is the vector bundle of the upper index in the torsion \
and curvature tensors. The antisymmetric pair of indices always belongs to \
the tangent bundle of the manifold of the covd.\
\>", "Text",ExpressionUUID->"69f8cb3c-1da3-43bc-98f9-446daa342d60"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "addCurvature", ",", "addCurvature1", ",", "addTorsion", ",", "addOther",
       ",", "addOther1"}], "}"}], ",", "HoldFirst"}], "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bf20bb73-6577-4185-86bd-e865b6f7c36e"],

Cell["\<\
1) Add Curvature. Use Riemann or FRiemann, but never RiemannDown.\
\>", "Text",ExpressionUUID->"5e759de5-d279-4f3a-9de5-6a3db289003f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"addCurvature", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addCurvature", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"{", "tb_", "}"}]}], "]"}], ":=", 
   RowBox[{"addCurvature1", "[", 
    RowBox[{"args", ",", "tb", ",", "Riemann"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addCurvature", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"{", 
      RowBox[{"tb_", ",", "vb_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"addCurvature1", "[", 
     RowBox[{"args", ",", "tb", ",", "Riemann"}], "]"}], "+", 
    RowBox[{"addCurvature1", "[", 
     RowBox[{"args", ",", "vb", ",", "FRiemann"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addCurvature", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"{", 
      RowBox[{"tb_", ",", "vb_", ",", "vbdag_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"addCurvature1", "[", 
     RowBox[{"args", ",", "tb", ",", "Riemann"}], "]"}], "+", 
    RowBox[{"addCurvature1", "[", 
     RowBox[{"args", ",", "vb", ",", "FRiemann"}], "]"}], "+", 
    RowBox[{"addCurvature1", "[", 
     RowBox[{"args", ",", "vbdag", ",", "FRiemann"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addCurvature1", "[", 
    RowBox[{"expr_", ",", "covd_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}], ",", "frees_", ",", "vb_", ",", 
     "riemann_"}], "]"}], ":=", 
   RowBox[{"$RiemannSign", " ", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"dummy", "=", 
         RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
        RowBox[{"vbQ", "=", 
         RowBox[{"VBundleIndexQ", "[", "vb", "]"}]}], ",", 
        RowBox[{"curv", "=", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"HasDaggerCharacterQ", "[", "vb", "]"}], ",", "Dagger", 
            ",", "Identity"}], "]"}], "[", 
          RowBox[{"riemann", "[", "covd", "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Plus", "@@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"curv", "[", 
              RowBox[{"a", ",", "b", ",", 
               RowBox[{"-", "dummy"}], ",", "#"}], "]"}], 
             RowBox[{"ReplaceIndex", "[", 
              RowBox[{"expr", ",", 
               RowBox[{"#", "\[Rule]", "dummy"}]}], "]"}]}], ")"}], "&"}], 
          ",", 
          RowBox[{"Select", "[", 
           RowBox[{"frees", ",", "vbQ"}], "]"}]}], "]"}]}], "-", 
       RowBox[{"Plus", "@@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"curv", "[", 
              RowBox[{"a", ",", "b", ",", 
               RowBox[{"-", "#"}], ",", "dummy"}], "]"}], 
             RowBox[{"ReplaceIndex", "[", 
              RowBox[{"expr", ",", 
               RowBox[{
                RowBox[{"-", "#"}], "\[Rule]", 
                RowBox[{"-", "dummy"}]}]}], "]"}]}], ")"}], "&"}], ",", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"ChangeIndex", "/@", "frees"}], ",", "vbQ"}], "]"}]}], 
         "]"}]}]}]}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"53f08df0-2e42-4c84-9511-13a2b9fca9ed"],

Cell["\<\
We are assuming that Riemann and FRiemann use the same convention for \
$RiemannSign.\
\>", "Text",ExpressionUUID->"c82b8877-9829-4e4b-9659-0891133fac87"],

Cell["2) Add Torsion:", \
"Text",ExpressionUUID->"c49d9369-b6ff-4850-9d4f-9cc1960a1df8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"addTorsion", "[", 
    RowBox[{"expr_", ",", "covd_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"$TorsionSign", " ", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dummy", "=", 
        RowBox[{"DummyIn", "[", 
         RowBox[{"VBundleOfIndex", "[", "a", "]"}], "]"}]}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Torsion", "[", "covd", "]"}], "[", 
        RowBox[{"dummy", ",", "a", ",", "b"}], "]"}], 
       RowBox[{
        RowBox[{"covd", "[", 
         RowBox[{"-", "dummy"}], "]"}], "[", "expr", "]"}]}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4d58da58-1a07-4a05-8ae5-2730552d4757"],

Cell["\<\
Addition of curvature and torsion is perfectly compatible with the induced \
derivatives because we always handle \"spatial\" objects.\
\>", "Text",ExpressionUUID->"ecc971a8-e54f-4eb2-9f01-3de31ba3ce5b"],

Cell["\<\
3) This part is in charge of adding terms corresponding to b,c,d indices and \
metric-raised indices:\
\>", "Text",ExpressionUUID->"96e37ea8-3046-44f8-bae5-665935d4c650"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"addOther", "[", 
    RowBox[{"expr_", ",", "covd_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"proj", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"InducedCovDQ", "[", "covd", "]"}], ",", 
         RowBox[{"MetricOfCovD", "[", "covd", "]"}], ",", "delta"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{"addOther1", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"{", 
         RowBox[{"covd", ",", "proj"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}]}], "]"}], "-", 
      RowBox[{"addOther1", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"{", 
         RowBox[{"covd", ",", "proj"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "a"}], "}"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"addOther1", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"{", 
       RowBox[{"covd_", ",", "proj_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "_Symbol"}], ",", "_"}], "}"}]}], "]"}], ":=", "0"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addOther1", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"covd_", ",", "proj_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vb", "=", 
       RowBox[{"TangentBundleOfCovD", "[", "covd", "]"}]}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"dummy", "=", 
         RowBox[{"DummyIn", "[", "vb", "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"covd", "[", "b", "]"}], "[", 
         RowBox[{"proj", "[", 
          RowBox[{"a", ",", "dummy"}], "]"}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"-", "dummy"}], "]"}], "[", "expr", "]"}]}]}], "]"}]}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"adb49060-92c1-42d2-9aae-6fa2ba3a0e59"],

Cell["4) QUESTION: Do we have to worry about densities here?", \
"Text",ExpressionUUID->"12783539-0fed-42a1-89b9-c2efa43d4465"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.8. Implode and Explode", \
"Subsubsection",ExpressionUUID->"2ba670a8-1a75-4c89-9306-a4cbb9dff0e3"],

Cell["\<\
We introduce the new concept of \"implosion\": given the covariant derivative \
of a tensor we define a new tensor which represents that covariant derivative \
with the indices of the tensor having their original characters. The \
character of the added indices is always taken to be covariant. The opposite \
process will be called \"explosion\".\
\>", "Text",ExpressionUUID->"861f2f2b-a009-48f1-bda9-8bf15d235b42"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$MultiIndexCovDs", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$ImplodeInfoQ", "=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1d489e6f-02c5-4098-ab05-c62cb43797be"],

Cell["\<\
In order to reactivate the Info messages from Implode use $ImplodeInfoQ=True.\
\
\>", "Text",ExpressionUUID->"86f0eb11-7dc2-4dd1-a233-d7882313b5a7"],

Cell["\<\
First we worry about the names for the new tensors. The structure of the \
tensor is stored in its TensorID field.\
\>", "Text",ExpressionUUID->"967cafac-fe1d-49de-9915-2a7c2d610ec1"],

Cell["\<\
Covariant derivatives. Note that we assume that the indices are abstract \
indices and hence they do not add new nontrivial dependencies. Before 1.1.0 \
we were using DependenciesOf[cd[inds]], which produces a list containing \
AnyDependencies. Now we use only DependenciesOfCovD[cd], which is better \
behaved.\
\>", "Text",ExpressionUUID->"6b5b3d0c-2c76-4357-b4c7-b593b01b41aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"niceindices", "[", "list_List", "]"}], ":=", 
   RowBox[{"Replace", "[", 
    RowBox[{"list", ",", 
     RowBox[{"screenrules", "[", 
      RowBox[{"UpIndex", "/@", 
       RowBox[{"IndexList", "@@", "list"}]}], "]"}], ",", "1"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ff332480-fa7b-4792-944b-0fe856b7b2f5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedName", "[", 
    RowBox[{
     RowBox[{"PD", "[", "inds__", "]"}], ",", "manifold_", ",", 
     RowBox[{"tensor_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "@", 
       RowBox[{"ManifoldsOfTensor", "[", "tensor", "]"}]}], "===", "1"}], ",", 
     RowBox[{"SymbolJoin", "[", 
      RowBox[{"PD", ",", "tensor"}], "]"}], ",", 
     RowBox[{"SymbolJoin", "[", 
      RowBox[{"PD", ",", "manifold", ",", "tensor"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedName", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"cd_Symbol", "?", "CovDQ"}], "[", "__", "]"}], ",", "manifold_",
      ",", 
     RowBox[{"tensor_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"cd", ",", "tensor"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f6e809cc-0af9-44c3-82bd-2433786c0b13"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDTensor", "[", 
    RowBox[{
     RowBox[{"cd_Symbol", "[", "inds__", "]"}], ",", "manifold_", ",", 
     RowBox[{"tensor_Symbol", "[", "tinds___", "]"}], ",", "ltinds_Integer"}],
     "]"}], ":=", 
   RowBox[{"CovDTensor1", "[", 
    RowBox[{
     RowBox[{"cd", "[", "inds", "]"}], ",", "manifold", ",", 
     RowBox[{"tensor", "[", "tinds", "]"}], ",", 
     RowBox[{"niceindices", "@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"DummyAs", "/@", 
         RowBox[{"{", "tinds", "}"}]}], ",", 
        RowBox[{"DownIndex", "/@", 
         RowBox[{"DummyAs", "/@", 
          RowBox[{"{", "inds", "}"}]}]}]}], "]"}]}], ",", 
     RowBox[{"Union", "[", 
      RowBox[{
       RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}], ",", 
       RowBox[{"DependenciesOfCovD", "[", "cd", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDTensor1", "[", 
    RowBox[{
     RowBox[{"cd_Symbol", "[", "inds__", "]"}], ",", "manifold_", ",", 
     RowBox[{"tensor_Symbol", "[", "tinds___", "]"}], ",", 
     RowBox[{"{", "indices___", "}"}], ",", "dependencies_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cdtensor", "=", 
        RowBox[{"ImplodedName", "[", 
         RowBox[{
          RowBox[{"cd", "[", "inds", "]"}], ",", "manifold", ",", "tensor"}], 
         "]"}]}], ",", 
       RowBox[{"linds", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"{", "inds", "}"}], "]"}]}], ",", 
       RowBox[{"vector", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"InducedCovDQ", "[", "cd", "]"}], ",", 
          RowBox[{"Last", "@", 
           RowBox[{"InducedFrom", "@", 
            RowBox[{"MetricOfCovD", "[", "cd", "]"}]}]}], ",", "Null"}], 
         "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"xTensorQ", "[", "cdtensor", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DefTensor", "[", 
          RowBox[{
           RowBox[{"cdtensor", "[", "indices", "]"}], ",", "dependencies", 
           ",", 
           RowBox[{"CovDTensorSym", "[", 
            RowBox[{
             RowBox[{"cd", "[", "inds", "]"}], ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", "inds", "}"}], "]"}], ",", 
             RowBox[{"tensor", "[", "tinds", "]"}], ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", "tinds", "}"}], "]"}]}], "]"}], ",", 
           RowBox[{"PrintAs", "\[RuleDelayed]", 
            RowBox[{"StringJoin", "[", 
             RowBox[{
              RowBox[{"Last", "[", 
               RowBox[{"SymbolOfCovD", "[", "cd", "]"}], "]"}], ",", 
              RowBox[{"PrintAs", "[", "tensor", "]"}]}], "]"}]}], ",", 
           RowBox[{"Dagger", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"DaggerQ", "[", "tensor", "]"}], ",", "Complex", ",", 
              "Real"}], "]"}]}], ",", 
           RowBox[{"TensorID", "\[RuleDelayed]", 
            RowBox[{"{", 
             RowBox[{"CovD", ",", "cd", ",", "linds", ",", "tensor"}], 
             "}"}]}], ",", 
           RowBox[{"DefInfo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"$ImplodeInfoQ", ",", 
              RowBox[{"{", 
               RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}], ",", 
              "False"}], "]"}]}], ",", 
           RowBox[{"Master", "\[Rule]", "tensor"}], ",", 
           RowBox[{"ForceSymmetries", "\[RuleDelayed]", 
            RowBox[{"SameQ", "[", 
             RowBox[{"cd", ",", "PD"}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"DaggerQ", "[", "tensor", "]"}], ",", 
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"dag", "=", 
               RowBox[{"Dagger", "[", "cdtensor", "]"}]}], "}"}], ",", 
             RowBox[{
              RowBox[{"TensorID", "[", "dag", "]"}], "^=", 
              RowBox[{"{", 
               RowBox[{"CovD", ",", "cd", ",", "linds", ",", 
                RowBox[{"Dagger", "[", "tensor", "]"}]}], "}"}]}]}], "]"}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"cd", "=!=", "PD"}], " ", "&&", 
            RowBox[{"!", 
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"FixedPointList", "[", 
                RowBox[{"MasterOf", ",", "cdtensor"}], "]"}], ",", "cd"}], 
              "]"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"xUpAppendTo", "[", 
             RowBox[{
              RowBox[{"VisitorsOf", "[", "cd", "]"}], ",", "cdtensor"}], 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"xUpAppendTo", "[", 
             RowBox[{
              RowBox[{"HostsOf", "[", "cdtensor", "]"}], ",", "cd"}], "]"}], 
            ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"vector", "=!=", "Null"}], "&&", 
         RowBox[{
          RowBox[{"OrthogonalToVector", "[", "vector", "]"}], "[", "tensor", 
          "]"}]}], ",", 
        RowBox[{"xUpSet", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"OrthogonalToVector", "[", "vector", "]"}], "[", 
           "cdtensor", "]"}], ",", "True"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Remember", " ", "associated", " ", "tensor"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"CovDTensor", "[", 
          RowBox[{
           RowBox[{"cd", "[", "__", "]"}], ",", "manifold", ",", 
           RowBox[{"tensor", "[", "___", "]"}], ",", 
           RowBox[{"Length", "[", 
            RowBox[{"{", "tinds", "}"}], "]"}]}], "]"}], "=", "cdtensor"}], 
        ";"}], " ", "*)"}], "\[IndentingNewLine]", "cdtensor"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"209f0d00-b900-4bc9-8c93-22c91b0619ca"],

Cell["\<\
QUESTION: Do we need to store the manifold of the covd in the TensorID \
information?\
\>", "Text",ExpressionUUID->"aa22abfe-c020-48d2-8d66-ac4590b69b4d"],

Cell["\<\
Here we construct the symmetry of the new tensor. This is valid even for \
variable-rank tensors, because the function CovDTensor has a third argument \
storing the number of indices of the internal tensor. The difficult part in \
CovDTensorSym is introducing the additional symmetries coming from \
commutation of derivatives. We introduce those additional symmetries only if \
the derivative is torsionless, and has no curvature or we are dealing with a \
double derivative of a scalar. We do not worry about metrics here because \
this is treated somewhere else further down.\
\>", "Text",ExpressionUUID->"da9a6754-796f-47fc-9f0b-0227bad54e8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CovDTensorSym", "[", 
    RowBox[{
     RowBox[{"cd_", "[", "inds__", "]"}], ",", "linds_", ",", 
     RowBox[{"tensor_", "[", "tinds___", "]"}], ",", "ltinds_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"SGS", "=", 
       RowBox[{"JoinSGS", "[", 
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", 
          RowBox[{"tensor", "[", "tinds", "]"}], "]"}], ",", 
         RowBox[{"DisplaceSlots", "[", 
          RowBox[{
           RowBox[{"SymmetryGroupOfCovD", "[", 
            RowBox[{"cd", "[", "inds", "]"}], "]"}], ",", "ltinds"}], "]"}]}],
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"TensorID", "[", "tensor", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"CovD", ",", "cd", ",", "linds", ",", "__"}], "}"}]}], 
          "]"}], "&&", " ", 
         RowBox[{"Not", "@", 
          RowBox[{"TorsionQ", "[", "cd", "]"}]}], "&&", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Not", "@", 
            RowBox[{"CurvatureQ", "[", "cd", "]"}]}], "||", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"DeleteCases", "[", 
              RowBox[{
               RowBox[{"{", "tinds", "}"}], ",", 
               RowBox[{"_LI", "|", 
                RowBox[{"-", "_LI"}]}]}], "]"}], "]"}], "===", "1"}]}], 
          ")"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"SGS", "=", 
         RowBox[{"JoinSGSoverlap", "[", 
          RowBox[{"SGS", ",", 
           RowBox[{"StrongGenSet", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"ltinds", "-", "linds", "+", "1"}], "}"}], ",", 
             RowBox[{"GenSet", "[", 
              RowBox[{"Inner", "[", 
               RowBox[{"List", ",", 
                RowBox[{"ltinds", "+", 
                 RowBox[{"Range", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "linds"}], "+", "1"}], ",", "0"}], "]"}]}], 
                ",", 
                RowBox[{"ltinds", "+", 
                 RowBox[{"Range", "[", 
                  RowBox[{"1", ",", "linds"}], "]"}]}], ",", 
                "xAct`xPerm`Cycles"}], "]"}], "]"}]}], "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "SGS"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2ddba604-62af-4232-82ce-73ce0e7d4637"],

Cell["QUESTION: How can we handle imaginay and Hermitian tensors?", \
"Text",ExpressionUUID->"4aa055c9-1543-4973-9ab5-6b4922ceb102"],

Cell["Parametric derivatives:", \
"Text",ExpressionUUID->"df0802f4-12f2-4e29-93e3-11fda90fc2b0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ParamDTensor", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "ps__", "]"}], ",", "tensor_Symbol"}], "]"}], ":=", 
   RowBox[{"ParamDTensor", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "ps", "]"}], ",", "tensor", ",", 
     RowBox[{"niceindices", "[", 
      RowBox[{"DummyIn", "/@", 
       RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], "]"}], ",", 
     RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ParamDTensor", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "ps__", "]"}], ",", "tensor_Symbol", ",", 
     RowBox[{"{", "indices___", "}"}], ",", "dependencies_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pdtensor", "=", 
       RowBox[{"SymbolJoin", "[", 
        RowBox[{"\"\<ParamD\>\"", ",", "ps", ",", "tensor"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"xTensorQ", "[", "pdtensor", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"pdtensor", "[", "indices", "]"}], ",", "dependencies", ",", 
          RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}], ",", 
          RowBox[{"PrintAs", "\[RuleDelayed]", 
           RowBox[{"StringJoin", "[", 
            RowBox[{"\"\<ParamD\>\"", ",", 
             RowBox[{"PrintAs", "[", "ps", "]"}], ",", 
             RowBox[{"PrintAs", "[", "tensor", "]"}]}], "]"}]}], ",", 
          RowBox[{"Dagger", "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DaggerQ", "[", "tensor", "]"}], ",", "Complex", ",", 
             "Real"}], "]"}]}], ",", 
          RowBox[{"TensorID", "\[RuleDelayed]", 
           RowBox[{"{", 
            RowBox[{"ParamD", ",", "ps", ",", "tensor"}], "}"}]}], ",", 
          RowBox[{"DefInfo", "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{"$ImplodeInfoQ", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}]}], "]"}]}]}],
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ParamDTensor", "[", 
        RowBox[{
         RowBox[{"ParamD", "[", "ps", "]"}], ",", "tensor"}], "]"}], "=", 
       "pdtensor"}], ";", "\[IndentingNewLine]", "pdtensor"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cafc8fd6-ccb9-4d19-9ba9-e4a2f0e579b1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OverDotTensor", "[", 
    RowBox[{"OverDot", ",", "tensor_Symbol"}], "]"}], ":=", 
   RowBox[{"OverDotTensor", "[", 
    RowBox[{"OverDot", ",", "tensor", ",", 
     RowBox[{"niceindices", "[", 
      RowBox[{"DummyIn", "/@", 
       RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], "]"}], ",", 
     RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OverDotTensor", "[", 
    RowBox[{"OverDot", ",", "tensor_Symbol", ",", 
     RowBox[{"{", "indices___", "}"}], ",", "dependencies_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pdtensor", "=", 
       RowBox[{"SymbolJoin", "[", 
        RowBox[{"\"\<OverDot\>\"", ",", "tensor"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"xTensorQ", "[", "pdtensor", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"pdtensor", "[", "indices", "]"}], ",", "dependencies", ",", 
          RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}], ",", 
          RowBox[{"PrintAs", "\[RuleDelayed]", 
           RowBox[{"StringJoin", "[", 
            RowBox[{"\"\<OverDot\>\"", ",", 
             RowBox[{"PrintAs", "[", "tensor", "]"}]}], "]"}]}], ",", 
          RowBox[{"Dagger", "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DaggerQ", "[", "tensor", "]"}], ",", "Complex", ",", 
             "Real"}], "]"}]}], ",", 
          RowBox[{"TensorID", "\[RuleDelayed]", 
           RowBox[{"{", 
            RowBox[{"OverDot", ",", "tensor"}], "}"}]}], ",", 
          RowBox[{"DefInfo", "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{"$ImplodeInfoQ", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}]}], "]"}]}]}],
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OverDotTensor", "[", 
        RowBox[{"OverDot", ",", "tensor"}], "]"}], "=", "pdtensor"}], ";", 
      "\[IndentingNewLine]", "pdtensor"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e1df3a26-2c7c-49c0-b8e4-d2bc05ede0ad"],

Cell["Lie derivatives:", \
"Text",ExpressionUUID->"f438cfa9-434d-4d5d-9615-84abedf4cfcc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LieDTensor", "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"v_Symbol", "[", "a_", "]"}], "]"}], ",", "tensor_Symbol"}], 
    "]"}], ":=", 
   RowBox[{"LieDTensor", "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"v", "[", "a", "]"}], "]"}], ",", "tensor", ",", 
     RowBox[{"niceindices", "[", 
      RowBox[{"DummyIn", "/@", 
       RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], "]"}], ",", 
     RowBox[{"Union", "[", 
      RowBox[{
       RowBox[{"DependenciesOfTensor", "[", "tensor", "]"}], ",", 
       RowBox[{"DependenciesOfTensor", "[", "v", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LieDTensor", "[", 
    RowBox[{
     RowBox[{"LieD", "[", "v_", "]"}], ",", "tensor_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Implode", "::", "invalid"}], ",", "v", ",", 
      "\"\<contravariant vector field\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LieDTensor", "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"v_Symbol", "[", "_", "]"}], "]"}], ",", "tensor_Symbol", ",", 
     RowBox[{"{", "indices___", "}"}], ",", "dependencies_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lietensor", "=", 
       RowBox[{"SymbolJoin", "[", 
        RowBox[{"\"\<LieD\>\"", ",", "v", ",", "tensor"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"xTensorQ", "[", "lietensor", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"lietensor", "[", "indices", "]"}], ",", "dependencies", 
          ",", 
          RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}], ",", 
          RowBox[{"PrintAs", "\[RuleDelayed]", 
           RowBox[{"StringJoin", "[", 
            RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
             RowBox[{"PrintAs", "[", "v", "]"}], ",", 
             RowBox[{"PrintAs", "[", "tensor", "]"}]}], "]"}]}], ",", 
          RowBox[{"Dagger", "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DaggerQ", "[", "tensor", "]"}], ",", "Complex", ",", 
             "Real"}], "]"}]}], ",", 
          RowBox[{"TensorID", "\[RuleDelayed]", 
           RowBox[{"{", 
            RowBox[{"LieD", ",", "v", ",", "tensor"}], "}"}]}], ",", 
          RowBox[{"DefInfo", "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{"$ImplodeInfoQ", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<tensor\>\"", ",", "\"\<\>\""}], "}"}]}], "]"}]}]}],
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"LieDTensor", "[", 
        RowBox[{
         RowBox[{"LieD", "[", "v", "]"}], ",", "tensor"}], "]"}], "=", 
       "lietensor"}], ";", "\[IndentingNewLine]", "lietensor"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3c56de9f-f278-462c-8577-430f6d0ea27a"],

Cell["Fake xCoba functions if xCoba is not loaded:", \
"Text",ExpressionUUID->"b9f33944-68d9-4a8f-bbae-02c4eb8ea57a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", 
      RowBox[{"$Packages", ",", "\"\<xAct`xCoba`\>\""}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", "expr_", "]"}], ":=",
       "expr"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xAct`xCoba`ContractBasis", "[", "expr_", "]"}], ":=", "expr"}],
      ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b49f9807-0c25-471f-9ed0-f3e60b28e479"],

Cell["Implosion:", \
"Text",ExpressionUUID->"76f9ae65-98d7-49c3-8d36-97f0e7d55bc2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Implode", "[", "expr_", "]"}], ":=", 
   RowBox[{"Implode", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"{", 
      RowBox[{
      "$CovDs", ",", "$MultiIndexCovDs", ",", "ParamD", ",", "OverDot", ",", 
       "LieD"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Implode", "[", 
     RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
    RowBox[{"Fold", "[", 
     RowBox[{"Implode", ",", "expr", ",", "list"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Implode", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_Symbol", "?", "CovDQ"}]}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "inds__", "]"}], "[", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "indices___", "]"}], "]"}],
       "\[RuleDelayed]", 
      RowBox[{"xAct`xCoba`ContractBasis", "@", 
       RowBox[{"ContractMetric", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", "inds", "]"}], "[", 
          RowBox[{
           RowBox[{"SeparateMetric", "[", "]"}], "[", 
           RowBox[{
            RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
            RowBox[{"tensor", "[", "indices", "]"}], "]"}], "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{
           RowBox[{"covd", "[", "inds1__", "]"}], "[", 
           RowBox[{
            RowBox[{"tensor1_", "?", "xTensorQ"}], "[", "indices1___", "]"}], 
           "]"}], "\[RuleDelayed]", 
          RowBox[{
           RowBox[{"CovDTensor", "[", 
            RowBox[{
             RowBox[{"covd", "[", "inds1", "]"}], ",", 
             RowBox[{"ManifoldOfCovD", "[", 
              RowBox[{"covd", "[", "inds1", "]"}], "]"}], ",", 
             RowBox[{"tensor1", "[", "indices1", "]"}], ",", 
             RowBox[{"Length", "[", 
              RowBox[{"{", "indices1", "}"}], "]"}]}], "]"}], "[", 
           RowBox[{"indices1", ",", "inds1"}], "]"}]}]}], "]"}]}]}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Implode", "[", 
    RowBox[{"expr_", ",", "ParamD"}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"ParamD", "[", "ps__", "]"}], "[", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"xAct`xCoba`ContractBasis", "@", 
       RowBox[{"ContractMetric", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ParamD", "[", "ps", "]"}], "[", 
          RowBox[{
           RowBox[{"SeparateMetric", "[", "]"}], "[", 
           RowBox[{
            RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
            RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{
           RowBox[{"ParamD", "[", "ps1__", "]"}], "[", 
           RowBox[{
            RowBox[{"tensor1_", "?", "xTensorQ"}], "[", "inds1___", "]"}], 
           "]"}], "\[RuleDelayed]", 
          RowBox[{
           RowBox[{"ParamDTensor", "[", 
            RowBox[{
             RowBox[{"ParamD", "[", "ps1", "]"}], ",", "tensor1"}], "]"}], 
           "[", "inds1", "]"}]}]}], "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Implode", "[", 
    RowBox[{"expr_", ",", "OverDot"}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"OverDot", "[", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"xAct`xCoba`ContractBasis", "@", 
       RowBox[{"ContractMetric", "[", 
        RowBox[{
         RowBox[{"OverDot", "[", 
          RowBox[{
           RowBox[{"SeparateMetric", "[", "]"}], "[", 
           RowBox[{
            RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
            RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{"OverDot", "[", 
           RowBox[{
            RowBox[{"tensor1_", "?", "xTensorQ"}], "[", "inds1___", "]"}], 
           "]"}], "\[RuleDelayed]", 
          RowBox[{
           RowBox[{"OverDotTensor", "[", 
            RowBox[{"OverDot", ",", "tensor1"}], "]"}], "[", "inds1", 
           "]"}]}]}], "]"}]}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Implode", "[", 
    RowBox[{"expr_", ",", "LieD"}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"LieD", "[", "v_", "]"}], "[", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"xAct`xCoba`ContractBasis", "@", 
       RowBox[{"ContractMetric", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"LieD", "[", "v", "]"}], "[", 
          RowBox[{
           RowBox[{"SeparateMetric", "[", "]"}], "[", 
           RowBox[{
            RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
            RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{
           RowBox[{"LieD", "[", "v", "]"}], "[", 
           RowBox[{
            RowBox[{"tensor1_", "?", "xTensorQ"}], "[", "inds1___", "]"}], 
           "]"}], "\[RuleDelayed]", 
          RowBox[{
           RowBox[{"LieDTensor", "[", 
            RowBox[{
             RowBox[{"LieD", "[", "v", "]"}], ",", "tensor1"}], "]"}], "[", 
           "inds1", "]"}]}]}], "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Implode", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Implode", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"30778332-b1d9-4070-85c4-08880ae59505"],

Cell["Explosion:", \
"Text",ExpressionUUID->"aca4e318-f8a0-4d68-b1eb-1b5f5d20057b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{"{", "}"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", "delta", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "___", "]"}], "]"}], ":=", 
   RowBox[{"ImplodedQ", "[", "tensor", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ImplodedQ", "[", "tensor", "]"}], "=", 
    RowBox[{"ImplodedQ", "[", 
     RowBox[{"TensorID", "[", "tensor", "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{"{", 
     RowBox[{"CovD", ",", "__"}], "}"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{"{", 
     RowBox[{"ParamD", ",", "__"}], "}"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{"{", 
     RowBox[{"OverDot", ",", "__"}], "}"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", 
    RowBox[{"{", 
     RowBox[{"LieD", ",", "__"}], "}"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplodedQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Explode", "[", "expr_", "]"}], ":=", 
   RowBox[{"Explode", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Head", "/@", 
        RowBox[{"FindAllOfType", "[", 
         RowBox[{"expr", ",", "Tensor"}], "]"}]}], ",", "ImplodedQ"}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Explode", "[", 
    RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"Explode", ",", "expr", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Explode", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"tensor_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"tensor", "[", "inds___", "]"}], "\[RuleDelayed]", 
     RowBox[{"ExplodeTensor", "[", 
      RowBox[{"tensor", "[", "inds", "]"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Explode", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Explode", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d77cb68d-80e6-4043-9903-813c37d2dddf"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{"tensor_Symbol", "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{
     RowBox[{"tensor", "[", "inds", "]"}], ",", 
     RowBox[{"TensorID", "[", "tensor", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{
     RowBox[{"tensor_Symbol", "[", "inds___", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"CovD", ",", "covd_", ",", "linds_Integer", ",", "intensor_"}], 
      "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric", "[", "]"}], "[", 
     RowBox[{
      RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
      RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"tensor", "[", "inds1___", "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"covd", "@@", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"{", "inds1", "}"}], ",", 
          RowBox[{"-", "linds"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"intensor", "@@", 
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"{", "inds1", "}"}], ",", 
         RowBox[{"-", "linds"}]}], "]"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{
     RowBox[{"tensor_Symbol", "[", "inds___", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ParamD", ",", "ps__", ",", "intensor_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric", "[", "]"}], "[", 
     RowBox[{
      RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
      RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"tensor", "[", "inds1___", "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"ParamD", "[", "ps", "]"}], "[", 
      RowBox[{"intensor", "[", "inds1", "]"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{
     RowBox[{"tensor_Symbol", "[", "inds___", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"OverDot", ",", "intensor_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric", "[", "]"}], "[", 
     RowBox[{
      RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
      RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"tensor", "[", "inds1___", "]"}], "\[RuleDelayed]", 
     RowBox[{"OverDot", "[", 
      RowBox[{"intensor", "[", "inds1", "]"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{
     RowBox[{"tensor_Symbol", "[", "inds___", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"LieD", ",", "v_", ",", "intensor_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric", "[", "]"}], "[", 
     RowBox[{
      RowBox[{"xAct`xCoba`SeparateBasis", "[", "]"}], "[", 
      RowBox[{"tensor", "[", "inds", "]"}], "]"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"tensor", "[", "inds1___", "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"LieD", "[", 
       RowBox[{"v", "[", 
        RowBox[{"UpIndex", "@", 
         RowBox[{"DummyIn", "[", 
          RowBox[{"First", "@", 
           RowBox[{"SlotsOfTensor", "[", "v", "]"}]}], "]"}]}], "]"}], "]"}], 
      "[", 
      RowBox[{"intensor", "[", "inds1", "]"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExplodeTensor", "[", 
    RowBox[{
     RowBox[{"tensor_Symbol", "[", "inds___", "]"}], ",", "_"}], "]"}], ":=", 
   
   RowBox[{"tensor", "[", "inds", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"41fb11ee-c438-4e90-aa51-8e70df0b0c08"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.1.9 CommuteCovDLieD", \
"Subsubsection",ExpressionUUID->"3b8f7c68-8152-464d-94e3-903740874043"],

Cell["\<\
\[Bullet] The code of this function was provided by Alfonso \
Garc\[IAcute]a-Parrado.\
\>", "Text",ExpressionUUID->"5505eca1-9477-429a-bfb0-0b938a98010d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CommuteCovDLieD", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"LieD", "|", 
      RowBox[{"LieD", "[", "_", "]"}]}], ",", "covd_"}], "]"}], ":=", 
   RowBox[{"ReplaceAll", "[", 
    RowBox[{"expr", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{
        RowBox[{"covd", "[", "a_", "]"}], "[", 
        RowBox[{
         RowBox[{"LieD", "[", "v_", "]"}], "[", "expr1_", "]"}], "]"}], "]"}],
       ":>", 
      RowBox[{"makeCommuteCovDLieD", "[", 
       RowBox[{"expr1", ",", "covd", ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", 
          RowBox[{"LieD", "[", "v", "]"}]}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CommuteCovDLieD", "[", 
    RowBox[{"expr_", ",", "covd_", ",", 
     RowBox[{"LieD", "|", 
      RowBox[{"LieD", "[", "_", "]"}]}]}], "]"}], ":=", 
   RowBox[{"ReplaceAll", "[", 
    RowBox[{"expr", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"HoldPattern", "[", 
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", 
        RowBox[{
         RowBox[{"covd", "[", "a_", "]"}], "[", "expr1_", "]"}], "]"}], "]"}],
       ":>", 
      RowBox[{"makeCommuteCovDLieD", "[", 
       RowBox[{"expr1", ",", 
        RowBox[{"LieD", "[", "v", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "covd"}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"CommuteCovDLieD", ",", "3"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "CommuteCovDLieD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fec18a14-d428-4a8e-a733-10ea900a944a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"makeCommuteCovDLieD", "[", 
    RowBox[{"expr_", ",", "covd_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", 
       RowBox[{"LieD", "[", "v_", "]"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{"Plus", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v", "]"}], "[", 
      RowBox[{
       RowBox[{"covd", "[", "a", "]"}], "[", "expr", "]"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Plus", "[", "\[IndentingNewLine]", 
      RowBox[{"addLieDConnection", "[", 
       RowBox[{
       "expr", ",", "\[IndentingNewLine]", "covd", ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"a", ",", 
          RowBox[{"LieD", "[", "v", "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"FindFreeIndices", "@", " ", "expr"}], ",", " ", 
          "AIndexQ"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"VBundlesOfCovD", "@", "covd"}]}], "\[IndentingNewLine]", 
       "]"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9cb6b59b-7372-4af8-9dd8-fe7b9925e721"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"makeCommuteCovDLieD", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"LieD", "[", "v_", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "covd_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Plus", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"covd", "[", "a", "]"}], "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v", "]"}], "[", "expr", "]"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"-", 
      RowBox[{"Plus", "[", "\[IndentingNewLine]", 
       RowBox[{"addLieDConnection", "[", 
        RowBox[{
        "expr", ",", "\[IndentingNewLine]", "covd", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"a", ",", 
           RowBox[{"LieD", "[", "v", "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"FindFreeIndices", "@", " ", "expr"}], ",", " ", 
           "AIndexQ"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"VBundlesOfCovD", "@", "covd"}]}], "\[IndentingNewLine]", 
        "]"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"93a26a88-efb2-4d54-bb80-757b0c5407e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Attributes", "[", "makeCommuteCovDLieD", "]"}], ":=", 
   RowBox[{"{", "HoldFirst", "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"041c333f-a5d3-46ba-af47-cc63109326da"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefLieDCovD", "[", 
    RowBox[{"symbol_Symbol", ",", "covd_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "idx", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"idx", "=", 
       RowBox[{"GetIndicesOfVBundle", "[", 
        RowBox[{
         RowBox[{"Tangent", "@", 
          RowBox[{"ManifoldOfCovD", "[", "covd", "]"}]}], ",", "3"}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"idx", "=", 
       RowBox[{"MapAt", "[", 
        RowBox[{"ChangeIndex", ",", "idx", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"-", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"-", "1"}], "}"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MetricOfCovD", "[", "covd", "]"}], "===", "Null"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"symbol", "@@", "idx"}], ",", 
          RowBox[{"ManifoldOfCovD", "[", "covd", "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "If", " ", "there", " ", "is", " ", "a", " ", "metric", " ", "then", 
          " ", "the", " ", "Lie", " ", "derivative", " ", "of", " ", "the", 
          " ", "affine", " ", "connection", " ", "is", " ", "symmetric", " ", 
          "in", " ", "the", " ", "last", " ", "two", " ", "indices"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"DefTensor", "[", 
         RowBox[{
          RowBox[{"symbol", "@@", "idx"}], ",", 
          RowBox[{"ManifoldOfCovD", "[", "covd", "]"}], ",", 
          RowBox[{"Symmetric", "[", 
           RowBox[{"Rest", "@", "idx"}], "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d38ad205-5df3-4be6-bde9-01c6ef546a1f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"addLieDConnection", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "0"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.803466673455851*^9, 3.803466846667848*^9}, {
  3.808456835107346*^9, 3.808456845010372*^9}, {3.8084568956023493`*^9, 
  3.80845689636919*^9}, {3.808459542037017*^9, 
  3.8084595438040953`*^9}},ExpressionUUID->"56ff65b5-e95d-4171-8630-\
2d3df1b4e3cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"addLieDConnection", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"{", "tb_", "}"}]}], "]"}], ":=", 
   RowBox[{"addLieDConnection1", "[", 
    RowBox[{"args", ",", "tb", ",", "LieD"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8084583752802753`*^9, 
  3.80845837770306*^9}},ExpressionUUID->"8c97ba78-f996-4aa4-89ca-\
a6a0f0d17630"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"addLieDConnection1", "[", 
    RowBox[{"expr_", ",", "covd_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", 
       RowBox[{"LieD", "[", "v_", "]"}]}], "}"}], ",", "frees_", ",", "vb_", 
     ",", "LieD"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dummy", " ", "=", " ", 
        RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"vbQ", "=", 
        RowBox[{"xAct`xTensor`Private`VBundleIndexQ", "[", "vb", "]"}]}], ",",
        "\[IndentingNewLine]", 
       RowBox[{"liedcd", "=", 
        RowBox[{"GiveSymbol", "[", 
         RowBox[{"LieD", ",", 
          RowBox[{"Head", "[", "v", "]"}], ",", "covd"}], "]"}]}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"xTensorQ", "[", "liedcd", "]"}], ",", "Null", ",", 
        RowBox[{"DefLieDCovD", "[", 
         RowBox[{"liedcd", ",", "covd"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Plus", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Apply", "[", 
          RowBox[{"Plus", ",", "\[IndentingNewLine]", 
           RowBox[{"Map", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Function", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"liedcd", "[", 
                RowBox[{"#", ",", "a", ",", 
                 RowBox[{"-", "dummy"}]}], "]"}], 
               RowBox[{"ReplaceIndex", "[", 
                RowBox[{"expr", ",", 
                 RowBox[{"#", "\[Rule]", "dummy"}]}], "]"}]}], 
              "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Select", "[", 
              RowBox[{"frees", ",", "vbQ"}], "]"}]}], "\[IndentingNewLine]", 
            "]"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Apply", "[", 
         RowBox[{"Plus", ",", "\[IndentingNewLine]", 
          RowBox[{"Map", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Function", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"liedcd", "[", 
               RowBox[{"dummy", ",", "a", ",", 
                RowBox[{"-", "#"}]}], "]"}], 
              RowBox[{"ReplaceIndex", "[", 
               RowBox[{"expr", ",", 
                RowBox[{
                 RowBox[{"Times", "[", 
                  RowBox[{
                   RowBox[{"-", "1"}], ",", "#"}], "]"}], "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"-", "dummy"}], ")"}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"ChangeIndex", ",", "frees"}], "]"}], ",", "vbQ"}], 
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6f60963b-e685-4a9c-b1d7-be3520eab0a9"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2. Definition", \
"Subsection",ExpressionUUID->"b4d2ba0a-06e0-44bb-b93e-fc8aa46156ae"],

Cell[CellGroupData[{

Cell["11.2.0. Comments", \
"Subsubsection",ExpressionUUID->"3b42e646-294d-4278-a52f-250beaef0e1f"],

Cell["\<\
We define covariant derivative operators (connections), as defined by Wald, \
but generalized to work on generic vector bundles, and not only tangent \
vector bundles.\
\>", "Text",ExpressionUUID->"2bca033d-f773-4850-9a99-248cc1cc89b7"],

Cell["\<\
- We do not check that indices and derivatives are in correspondence. We \
assume that this has been already done by the validation routines.
- At definition time, if the derivative is to be associated to a metric, we \
check whether that metric exists or not. This is not intended to be a feature \
to be used by the user to define derivatives associated to previously defined \
metrics. The derivative associated to a metric will be defined below when the \
metric is defined.\
\>", "Text",ExpressionUUID->"f7030b9e-5699-4169-a98b-471984eddca7"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2.1. Generic properties of a derivative", \
"Subsubsection",ExpressionUUID->"cca52324-6a75-4c07-98b6-491d2fb808f3"],

Cell["\<\
Comments:
  - The argument of a covariant derivative is always assumed to be fully \
evaluated or at least fully evaluatable. QUESTION: Can we use Hold/HoldForm?
  - The covariant derivatives are always threaded over Plus, even if all \
arguments are incorrect.
  - Linearity with respect to constants (constant-symbols or numeric objects) \
is implemented as a two step process: first we use the Leibnitz rule; then we \
find that the covariant derivative of a constant is 0.
  - Note that even though Power is a scalar function, it has its own rule \
because the rule for scalar functions only considers those functions with a \
single argument and Power has two.
  - There are quite a few checks (NumericQ, ConstantSymbolQ, check, xTensorQ, \
ScalarFunctionQ), what certainly introduces delays... QUESTION: Can we \
improve this?
  - Currently, this function only works for tensors. Eventually, it needs to \
be generalized to other types.\
\>", "Text",ExpressionUUID->"18e68dae-d666-4e20-841d-6801725ef10e"],

Cell["\<\
1) multiD implements the chain rule for a function of several arguments. We \
use ReplaceDummies to avoid repeating a dummy in a term. In principle the \
dummy inside an argument of the function is shielded from the dummy of the \
differentiated argument. However it could happen that there are definitions \
which bring the term into an inconsistent state.\
\>", "Text",ExpressionUUID->"7964d06c-9e94-4b34-84c1-221927ec92cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"multiD", "[", 
   RowBox[{"der_", ",", 
    RowBox[{"f_", "[", "args__", "]"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Derivative", "[", 
         RowBox[{"Sequence", "@@", "#"}], "]"}], "[", "f", "]"}], "[", "args",
        "]"}], "&"}], "/@", 
     RowBox[{"IdentityMatrix", "[", 
      RowBox[{"Length", "[", 
       RowBox[{"{", "args", "}"}], "]"}], "]"}]}], ")"}], ".", 
   RowBox[{"(", 
    RowBox[{"der", "/@", 
     RowBox[{"ReplaceDummies", "/@", 
      RowBox[{"{", "args", "}"}]}]}], ")"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6e8c3d6b-628d-421e-bbb5-3a17e56a2530"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"multiD", "[", 
  RowBox[{"der", ",", 
   RowBox[{"f", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"06160fcb-a886-4590-bc7d-365c30a5a620"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"der", "[", "c", "]"}], " ", 
   RowBox[{
    SuperscriptBox["f", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"der", "[", "b", "]"}], " ", 
   RowBox[{
    SuperscriptBox["f", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"der", "[", "a", "]"}], " ", 
   RowBox[{
    SuperscriptBox["f", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], 
    "]"}]}]}]], \
"Output",ExpressionUUID->"44536bb9-299c-4b48-bdf0-f5fbde28f6f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Derivative", "[", 
   RowBox[{"0", ",", "1"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Derivative", "[", 
    RowBox[{"1", ",", "1"}], "]"}], "[", "f", "]"}], 
  "]"}]], "Input",ExpressionUUID->"8ae26051-7b7e-482c-9614-c443fcaa6ebb"],

Cell[BoxData[
 SuperscriptBox["f", 
  TagBox[
   RowBox[{"(", 
    RowBox[{"1", ",", "2"}], ")"}],
   Derivative],
  MultilineFunction->
   None]], "Output",ExpressionUUID->"f04e2b7c-248a-4f24-8f77-1ed2ddd8ef80"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"multiD", "[", 
  RowBox[{"der", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Derivative", "[", 
      RowBox[{"0", ",", "1", ",", "1"}], "]"}], "[", "f", "]"}], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"886a5ae5-e281-4521-ae6d-80b4c6fd9d98"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"der", "[", "c", "]"}], " ", 
   RowBox[{
    SuperscriptBox["f", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "2"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"der", "[", "b", "]"}], " ", 
   RowBox[{
    SuperscriptBox["f", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "2", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"der", "[", "a", "]"}], " ", 
   RowBox[{
    SuperscriptBox["f", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "1", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], 
    "]"}]}]}]], \
"Output",ExpressionUUID->"62d4d894-699f-48e5-8294-ff96792d3e50"]
}, Open  ]],

Cell["\<\
2) If there are several manifolds we could have derivatives which are zero \
simply because the derivative and the derived object belong to different \
manifolds. The function CheckZeroDerivative controls that point. It is \
important to stress that this is a question of dependencies and not of \
indices. This is the user-driver:\
\>", "Text",ExpressionUUID->"8a92e3c7-c109-4304-bdcf-f960ded52486"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckZeroDerivative"}]], \
"Input",ExpressionUUID->"81086ad5-eb9a-4b97-b9f2-e6cbb16d9bd2"],

Cell[BoxData[
 StyleBox["\<\"CheckZeroDerivative[expr] performs some checks on expr to see \
if there are derivatives of some manifolds acting on fields on other \
manifolds, which hence can be removed.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672786-5338953",ExpressionUUID->"43ad925e-e0e8-4fb4-b368-\
4265285638a1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CheckZeroDerivative", "[", "expr_", "]"}], ":=", 
     RowBox[{"expr", "/.", 
      RowBox[{
       RowBox[{"HoldPattern", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"covd_", "?", "CovDQ"}], "[", "i__", "]"}], "[", "expr1_", 
         "]"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"0", "/;", 
        RowBox[{"ZeroDerivativeQ", "[", 
         RowBox[{
          RowBox[{"covd", "[", "i", "]"}], ",", "expr1"}], "]"}]}]}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"CheckZeroDerivative", ",", "1"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "CheckZeroDerivative", "]"}], ";"}]}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"4e93364b-cc30-429e-83fa-70546cb76d10"],

Cell["\<\
In the past there was a check function in the pattern i_. It was ?GIndexQ for \
PD and the corresponding pmQ function for other derivatives. I don't remember \
why it was there, and therefore I have removed it. I guess it was just a \
safety feature. The index inside the derivative is not relevant, as long as \
it is valid.\
\>", "Text",ExpressionUUID->"df46ef65-cc8c-4510-9478-d099c273cc65"],

Cell["\<\
The function ZeroDerivativeQ actually decides whether a given covariant \
derivative of an object is zero or not. This is not simple because it depends \
very much on the allowed structures of submanifolds and supermanifolds. This \
is a slow function and must be used many times if the zero checking is \
automated. Hence, we define it with remembered values when applied on \
tensors, which is the most common situation. The nontrivial part of this \
function is hidden in ManifoldsOf. In principle, the test should be performed \
in the uncontracted version of expr (with respect to both basis-indices and \
directions). Note that we also pass the index a to ManifoldOfCovD to include \
the case of covd being PD. For the same reason, we need to store the result \
with a pm`Q check. Note also that we use ManifoldOfCovD and not all manifolds \
in DependenciesOfCovD, which wouldn't make sense.\
\>", "Text",ExpressionUUID->"4febdc4e-f9ea-4663-99ea-d8d90d2072d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Avoid", " ", "checking", " ", "slotted", " ", "indices"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerivativeQ", "[", 
      RowBox[{
       RowBox[{"covd_", "[", "__slot", "]"}], ",", "_"}], "]"}], ":=", 
     "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Tensors", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerivativeQ", "[", 
      RowBox[{
       RowBox[{"covd_", "[", "a__", "]"}], ",", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
        RowBox[{"inds___", "?", "AIndexQ"}], "]"}]}], "]"}], ":=", 
     RowBox[{"ZeroDerivativeQ", "[", 
      RowBox[{
       RowBox[{"covd", "[", "a", "]"}], ",", "tensor"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerivativeQ", "[", 
      RowBox[{
       RowBox[{"covd_", "[", "a__", "]"}], ",", 
       RowBox[{"tensor_", "?", "xTensorQ"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbQ", "=", 
         RowBox[{"VBundleIndexPMQ", "[", 
          RowBox[{"VBundleOfIndex", "[", 
           RowBox[{"First", "[", 
            RowBox[{"{", "a", "}"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"prot", "=", 
            RowBox[{"Unprotect", "[", "tensor", "]"}]}], ",", "result"}], 
          "}"}], ",", 
         RowBox[{
          RowBox[{"TagSet", "[", 
           RowBox[{"tensor", ",", 
            RowBox[{"ZeroDerivativeQ", "[", 
             RowBox[{
              RowBox[{"covd", "[", 
               RowBox[{"PatternTest", "[", 
                RowBox[{"__", ",", "vbQ"}], "]"}], "]"}], ",", "tensor"}], 
             "]"}], ",", 
            RowBox[{"result", "=", 
             RowBox[{"DisjointManifoldsQ", "[", 
              RowBox[{
               RowBox[{"ManifoldsOfTensor", "[", "tensor", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ManifoldOfCovD", "[", 
                  RowBox[{"covd", "[", "a", "]"}], "]"}], ",", 
                 "AnyDependencies"}], "}"}]}], "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Protect", "[", 
           RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";", 
          "\[IndentingNewLine]", "result"}]}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "expressions"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerivativeQ", "[", 
      RowBox[{
       RowBox[{"covd_", "[", "a__", "]"}], ",", "expr_"}], "]"}], ":=", 
     RowBox[{"DisjointManifoldsQ", "[", 
      RowBox[{
       RowBox[{"ManifoldsOf", "[", "expr", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ManifoldOfCovD", "[", 
          RowBox[{"covd", "[", "a", "]"}], "]"}], ",", "AnyDependencies"}], 
        "}"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ce04a2d6-02f7-491d-b334-defaf43f10fd"],

Cell["It can be automated:", \
"Text",ExpressionUUID->"9898de3a-f50c-4bc1-88fd-5635881a6be5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckZeroDerivativeStart"}]], \
"Input",ExpressionUUID->"d67e46a3-d494-4b24-bc1b-cfb45705d9b1"],

Cell[BoxData[
 StyleBox["\<\"CheckZeroDerivativeStart[covd] starts automatic zero checking \
of derivative covd.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672787-5338953",ExpressionUUID->"a643a3d5-2f5b-4e6e-a162-\
8abf41cf3e64"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CheckZeroDerivativeStop"}]], \
"Input",ExpressionUUID->"3041543f-325b-4a9a-b367-b3ca3f3079f3"],

Cell[BoxData[
 StyleBox["\<\"CheckZeroDerivativeStop[covd] stops automatic zero checking of \
derivative covd.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672788-5338953",ExpressionUUID->"2efe73e0-cd84-41b3-94fe-\
b20bc9ff1610"]
}, Open  ]],

Cell["\<\
Note the ?AIndexQ check in the tensor definition. This avoids the possibility \
of missing dependencies provided by non-abstract indices.\
\>", "Text",ExpressionUUID->"ce819163-2b9d-448c-b029-208a480e304c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"$CheckZeroDerivativeVerbose", "=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckZeroDerivativeStart", "[", "covd_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"prot", "=", 
         RowBox[{"Unprotect", "[", "covd", "]"}]}], "}"}], ",", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "$Manifolds", "]"}], "<", "2"}], ",", 
           RowBox[{"Throw", "[", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"CheckZeroDerivativeStart", "::", "error"}], ",", 
              "\"\<With less than two manifolds there is no need for \
CheckZeroDerivative.\>\""}], "]"}], "]"}]}], "]"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"a__", "?", "GIndexQ"}], "]"}], "[", 
          RowBox[{
           RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
           RowBox[{"___", "?", "AIndexQ"}], "]"}], "]"}], ":=", 
         RowBox[{"Condition", "[", 
          RowBox[{"0", ",", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{"$CheckZeroDerivativeVerbose", ",", 
              RowBox[{"Print", "[", 
               RowBox[{
               "\"\<Checking \>\"", ",", "covd", ",", "\"\< on \>\"", ",", 
                "tensor"}], "]"}]}], "]"}], ";", 
            RowBox[{"ZeroDerivativeQ", "[", 
             RowBox[{
              RowBox[{"covd", "[", "a", "]"}], ",", "tensor"}], "]"}]}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"a__", "?", "GIndexQ"}], "]"}], "[", "expr_", "]"}], ":=", 
         
         RowBox[{"Condition", "[", 
          RowBox[{"0", ",", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{"$CheckZeroDerivativeVerbose", ",", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<Checking \>\"", ",", 
                RowBox[{"covd", "[", "a", "]"}], ",", "\"\< on \>\"", ",", 
                "expr"}], "]"}]}], "]"}], ";", 
            RowBox[{"ZeroDerivativeQ", "[", 
             RowBox[{
              RowBox[{"covd", "[", "a", "]"}], ",", "expr"}], "]"}]}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Protect", "[", 
         RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CheckZeroDerivativeStop", "[", "covd_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"prot", "=", 
         RowBox[{"Unprotect", "[", "covd", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"a__", "?", "GIndexQ"}], "]"}], "[", 
          RowBox[{
           RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
           RowBox[{"___", "?", "AIndexQ"}], "]"}], "]"}], "=."}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"a__", "?", "GIndexQ"}], "]"}], "[", "expr_", "]"}], 
         "=."}], ";", "\[IndentingNewLine]", 
        RowBox[{"Protect", "[", 
         RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"CheckZeroDerivativeStart", ",", "1"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"CheckZeroDerivativeStop", ",", "1"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", 
     RowBox[{"CheckZeroDerivativeStart", ",", "CheckZeroDerivativeStop"}], 
     "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"58372429-80d0-42b4-a96d-dc9ad1493671"],

Cell["\<\
The fact that the check is not automatic has several advantages, but mainly \
two: first a gain in speed; secondly, the user can control and check which \
derivatives must be annihilated.\
\>", "Text",ExpressionUUID->"8ff585d0-e06c-4a69-87b6-46061798cd8d"],

Cell["\<\
We shall define later ZeroDerOnMetricQ, which is rather redundant with \
ZeroDerivativeQ.\
\>", "Text",ExpressionUUID->"ccbd9f43-03fb-4501-bcd3-8f342cc30565"],

Cell["\<\
3) Now we define two functions implementing the general properties of the two \
arguments of a connection:\
\>", "Text",ExpressionUUID->"42b27bfd-cbc2-419d-b0ef-3eff18de4e66"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"MakeLinearDerivative", ",", "MakeTensorialDerivative"}], "}"}], 
   ",", "HoldFirst"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8ba05047-fe1f-428d-be40-17d570ae5439"],

Cell["\<\
MakeLinearDerivative implements some properties of the connection on its \
expression-argument\
\>", "Text",ExpressionUUID->"3f65bacc-8c9a-459f-b5e8-547abeffc972"],

Cell["\<\
Right now, every time xTensor finds a covariant derivative, it performs two \
checks, in this order:
\t1. Is the argument a constant? Use ConstantQ.
\t2. Is the argument a scalar function? Use ScalarFunctionQ
(If we have automated CheckZeroDerivative then we have a third check). This \
takes some time, but I think it is unavoidable: this is an essential part of \
automatic simplification. The Leibnitz rule is optional because induced \
derivatives do not obey it. We remove the Scalar head because in general the \
result is not a scalar. (Note however that this conversion leads to infinite \
recursion with induced derivatives of scalars of the form Scalar[n[-a]V[a]] \
where n is the orthogonal vector and V is not orthogonal to n. FIXME)\
\>", "Text",ExpressionUUID->"d0c06d2b-f702-4261-82ae-7d40bcaaaed8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeLinearDerivative", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"covdL_", ",", "covdR_"}], "}"}], ",", "leibnitz_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"covdL", "[", "expr_Plus", "]"}], ":=", 
      RowBox[{"Map", "[", 
       RowBox[{"covdR", ",", "expr"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"covdL", "[", "expr_SeriesData", "]"}], ":=", 
      RowBox[{"SeriesDataMap", "[", 
       RowBox[{"covdR", ",", "expr"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"leibnitz", ",", 
       RowBox[{
        RowBox[{"covdL", "[", 
         RowBox[{"x_", " ", "y_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{"covdR", "[", "x", "]"}], "y"}], "+", 
         RowBox[{"x", " ", 
          RowBox[{"covdR", "[", "y", "]"}]}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"covdL", "[", 
       RowBox[{"_", "?", "ConstantQ"}], "]"}], ":=", "0"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"covdL", "[", 
       RowBox[{
        RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], 
      ":=", 
      RowBox[{"multiD", "[", 
       RowBox[{"covdR", ",", 
        RowBox[{"f", "[", "args", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"covdL", "[", 
       RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
      RowBox[{"covdR", "[", 
       RowBox[{"ReplaceDummies", "[", "expr", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"covdL", "[", "list_List", "]"}], ":=", 
      RowBox[{"Map", "[", 
       RowBox[{"covdR", ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeLinearDerivative", "[", 
    RowBox[{"covd_Symbol", ",", "leibnitz_"}], "]"}], ":=", 
   RowBox[{"MakeLinearDerivative", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"covd", "[", "a_", "]"}], ",", 
       RowBox[{"covd", "[", "a", "]"}]}], "}"}], ",", "leibnitz"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d42ace0d-6b96-41af-9e52-d9bf7775234e"],

Cell["Properties of the new derivative head:", \
"Text",ExpressionUUID->"0b461c3a-7b72-40f1-a94c-09f98760d2e7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Special", " ", "properties"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "CovD", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", "expr_", "]"}], ":=", "expr"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"CovD", "[", 
        RowBox[{"expr_", ",", "ders1__"}], "]"}], ",", "ders2__"}], "]"}], ":=", 
     RowBox[{"CovD", "[", 
      RowBox[{"expr", ",", "ders1", ",", "ders2"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", "l___", ",", "a_Symbol", ",", "r___"}], "]"}], ":=", 
     RowBox[{"CovD", "[", 
      RowBox[{"expr", ",", "l", ",", 
       RowBox[{"PD", "[", "a", "]"}], ",", "r"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", "l___", ",", 
       RowBox[{"-", "a_Symbol"}], ",", "r___"}], "]"}], ":=", 
     RowBox[{"CovD", "[", 
      RowBox[{"expr", ",", "l", ",", 
       RowBox[{"PD", "[", 
        RowBox[{"-", "a"}], "]"}], ",", "r"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Derivative", " ", "properties"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_Plus", ",", "ders__"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"CovD", "[", 
        RowBox[{"#", ",", "ders"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_SeriesData", ",", "ders___"}], "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CovD", "[", 
         RowBox[{"#", ",", "ders"}], "]"}], "&"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"x_", " ", "y_"}], ",", "der_", ",", "ders___"}], "]"}], ":=", 
     
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"CovD", "[", 
          RowBox[{"x", ",", "der"}], "]"}], "y"}], "+", 
        RowBox[{"x", " ", 
         RowBox[{"CovD", "[", 
          RowBox[{"y", ",", "der"}], "]"}]}]}], ",", "ders"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"_", "?", "ConstantQ"}], ",", "___"}], "]"}], ":=", "0"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"f_", "?", "ScalarFunction"}], "[", "args___", "]"}], ",", 
       "der_", ",", "ders___"}], "]"}], ":=", 
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"multiD", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"CovD", "[", 
           RowBox[{"#", ",", "der"}], "]"}], "&"}], ",", 
         RowBox[{"f", "[", "args", "]"}]}], "]"}], ",", "ders"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "ders__"}], "]"}], ":=", 
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"ReplaceDummies", "[", "expr", "]"}], ",", "ders"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"list_List", ",", "ders__"}], "]"}], ":=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CovD", "[", 
         RowBox[{"#", ",", "list"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", 
        RowBox[{"Dir", "[", 
         RowBox[{"v_", "+", "w_"}], "]"}], "]"}], ",", "ders___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CovD", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"covd", "[", 
         RowBox[{"Dir", "[", "v", "]"}], "]"}], ",", "ders"}], "]"}], "+", 
      RowBox[{"CovD", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"covd", "[", 
         RowBox[{"Dir", "[", "w", "]"}], "]"}], ",", "ders"}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", 
        RowBox[{"Dir", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x_", "?", "ScalarQ"}], ")"}], "v_"}], "]"}], "]"}], ",", 
       "ders___"}], "]"}], ":=", 
     RowBox[{"CovD", "[", 
      RowBox[{
       RowBox[{"x", " ", 
        RowBox[{"CovD", "[", 
         RowBox[{"expr", ",", 
          RowBox[{"covd", "[", 
           RowBox[{"Dir", "[", "v", "]"}], "]"}]}], "]"}]}], ",", "ders"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovD", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", 
        RowBox[{"Dir", "[", "0", "]"}], "]"}], ",", "ders___"}], "]"}], ":=", 
     "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "CovD", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cf2f3120-801d-4452-bbc2-7f2e7864bad2"],

Cell["Old code:", \
"Text",ExpressionUUID->"5c4a4ef7-4c8f-4747-83e6-4ec2400aab38"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeLinearDerivative", "[", 
    RowBox[{"covd_", ",", "leibnitz_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "a_", "]"}], "[", 
       RowBox[{"x_", "+", "y_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{
        RowBox[{"covd", "[", "a", "]"}], "[", "x", "]"}], "+", 
       RowBox[{
        RowBox[{"covd", "[", "a", "]"}], "[", "y", "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"leibnitz", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"covd", "[", "a_", "]"}], "[", 
         RowBox[{"x_", " ", "y_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"covd", "[", "a", "]"}], "[", "x", "]"}], "y"}], "+", 
         RowBox[{"x", " ", 
          RowBox[{
           RowBox[{"covd", "[", "a", "]"}], "[", "y", "]"}]}]}]}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "a_", "]"}], "[", 
       RowBox[{"_", "?", "ConstantQ"}], "]"}], ":=", "0"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "a_", "]"}], "[", 
       RowBox[{
        RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], 
      ":=", 
      RowBox[{"multiD", "[", 
       RowBox[{
        RowBox[{"covd", "[", "a", "]"}], ",", 
        RowBox[{"f", "[", "args", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "a_", "]"}], "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Derivative", "[", "ders__Integer", "]"}], "[", 
         RowBox[{"f_", "?", "ScalarFunctionQ"}], "]"}], "[", "args___", "]"}],
        "]"}], ":=", 
      RowBox[{"multiD", "[", 
       RowBox[{
        RowBox[{"covd", "[", "a", "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Derivative", "[", "ders", "]"}], "[", "f", "]"}], "[", 
         "args", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covd", "[", "a_", "]"}], "[", "list_List", "]"}], ":=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"covd", "[", "a", "]"}], ",", "list"}], "]"}]}], ";"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"c9ad896d-c15d-4046-a8da-11311819b8c0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"leibnitz\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "leibnitz", ", Context: ", "xAct`xTensor`Private`"],
  
  Editable->
   False]], "Print",ExpressionUUID->"54ffa1dd-7d86-42f7-a20c-95f1b2693c54"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"ders\"\>",
    "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "ders", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"5878e5a8-c5f2-4273-9c9d-dff691d4a29a"]
}, Open  ]]
}, Open  ]],

Cell["\<\
MakeTensorialDerivative implements the properties of the connection on its \
index-argument, in case we find there a direction.\
\>", "Text",ExpressionUUID->"c5358f5a-952b-458c-a8e3-be4127e1c515"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorialDerivative", "[", 
    RowBox[{"{", 
     RowBox[{"covdL_", ",", "covdR_"}], "}"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"covdR", "[", 
        RowBox[{"Dir", "[", "v_Plus", "]"}], "]"}], "[", "expr_", "]"}], ":=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covdL", "[", 
           RowBox[{"Dir", "[", "#", "]"}], "]"}], "[", "expr", "]"}], "&"}], 
        ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covdR", "[", 
        RowBox[{"Dir", "[", "v_SeriesData", "]"}], "]"}], "[", "expr_", "]"}],
       ":=", 
      RowBox[{"SeriesDataMap", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covdL", "[", 
           RowBox[{"Dir", "[", "#", "]"}], "]"}], "[", "expr", "]"}], "&"}], 
        ",", "v"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covdR", "[", 
        RowBox[{"Dir", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x_", "?", "ScalarQ"}], ")"}], "v_"}], "]"}], "]"}], "[", 
       "expr_", "]"}], ":=", 
      RowBox[{"x", " ", 
       RowBox[{
        RowBox[{"covdL", "[", 
         RowBox[{"Dir", "[", "v", "]"}], "]"}], "[", "expr", "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"covdR", "[", 
        RowBox[{"Dir", "[", "0", "]"}], "]"}], "[", "expr_", "]"}], ":=", 
      "0"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeTensorialDerivative", "[", "covd_", "]"}], ":=", 
   RowBox[{"MakeTensorialDerivative", "[", 
    RowBox[{"{", 
     RowBox[{"covd", ",", "covd"}], "}"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3147592b-3d68-4b63-945a-f98c98b5d2e0"],

Cell["\<\
4) Concerning the orthogonality properties of a projected derivative, we \
shall use the same option OrthogonalTo for DefTensor. There are two issues: \
first, the tensors associated with the derivative will be just defined \
orthogonal to the vector; second, the derivative itself must be orthogonal, \
but not only in the derivative index, but in all indices of the expression \
being differentiated. Note that we implement the rule for both a covariant \
and a contravariant index in the derivative. The point is that the offending \
rule will be defined but not used if there are no derivatives with a \
contravariant index in the calculations.\
\>", "Text",ExpressionUUID->"878a9c95-38ff-45c2-98c1-fffe96f8b94b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MakeOrthogonalDerivative", "[", 
    RowBox[{"covd_", ",", 
     RowBox[{"projector_", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ",", 
     RowBox[{"vector_", "[", "_", "]"}]}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TagSet", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"vector", "[", "i_Symbol", "]"}], 
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"-", "i_Symbol"}], "]"}], "[", "expr_", "]"}]}], ",", "0"}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"TagSet", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"vector", "[", 
         RowBox[{"-", "i_Symbol"}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", "i_Symbol", "]"}], "[", "expr_", "]"}]}], ",", 
       "0"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"TagSetDelayed", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"vector", "[", 
         RowBox[{"i_", "?", "AIndexQ"}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", "_", "]"}], "[", "expr_", "]"}]}], ",", 
       RowBox[{"Condition", "[", 
        RowBox[{"0", ",", 
         RowBox[{"IsIndexOf", "[", 
          RowBox[{"expr", ",", 
           RowBox[{"-", "i"}], ",", "projector"}], "]"}]}], "]"}]}], "]"}], 
     ";"}], "\[IndentingNewLine]", ")"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"42f3db91-ec86-4211-b1d1-a716317fb136"],

Cell["\<\
The three objects is this and the previous definitions are assumed to form a \
consistent set. That is covd must be the Levi-Civita connection of the \
projector, which must itself be orthogonal with respect to the vector:\
\>", "Text",ExpressionUUID->"9cb90745-6a4f-4a0a-85d2-281217a2d998"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MakeProjectedDerivative", "[", 
    RowBox[{"covd_", ",", 
     RowBox[{"projector_", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ",", 
     RowBox[{"vector_", "[", "_", "]"}]}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TagSetDelayed", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"projector", "[", 
         RowBox[{"i_Symbol", ",", 
          RowBox[{"-", "j_Symbol"}]}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", "k_", "]"}], "[", "expr_", "]"}]}], ",", 
       RowBox[{"Condition", "[", 
        RowBox[{
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", 
           RowBox[{
            RowBox[{"-", "i"}], "\[Rule]", 
            RowBox[{"-", "j"}]}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"IsIndexOf", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", 
            RowBox[{"-", "i"}], ",", "projector"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "expr", 
           "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"TagSetDelayed", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"projector", "[", 
         RowBox[{"i_Symbol", ",", 
          RowBox[{"-", "j_Symbol"}]}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", "k_", "]"}], "[", "expr_", "]"}]}], ",", 
       RowBox[{"Condition", "[", 
        RowBox[{
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", 
           RowBox[{"j", "\[Rule]", "i"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"IsIndexOf", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", "j", 
            ",", "projector"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "expr", 
           "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"TagSetDelayed", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"projector", "[", 
         RowBox[{
          RowBox[{"-", "i_Symbol"}], ",", "j_Symbol"}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", "k_", "]"}], "[", "expr_", "]"}]}], ",", 
       RowBox[{"Condition", "[", 
        RowBox[{
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", 
           RowBox[{
            RowBox[{"-", "j"}], "\[Rule]", 
            RowBox[{"-", "i"}]}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"IsIndexOf", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", 
            RowBox[{"-", "j"}], ",", "projector"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "expr", 
           "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"TagSetDelayed", "[", 
      RowBox[{"covd", ",", 
       RowBox[{
        RowBox[{"projector", "[", 
         RowBox[{
          RowBox[{"-", "i_Symbol"}], ",", "j_Symbol"}], "]"}], 
        RowBox[{
         RowBox[{"covd", "[", "k_", "]"}], "[", "expr_", "]"}]}], ",", 
       RowBox[{"Condition", "[", 
        RowBox[{
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", 
           RowBox[{"i", "\[Rule]", "j"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"IsIndexOf", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}], ",", "i", 
            ",", "projector"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", "expr", 
           "]"}]}]}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
    ")"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"750d883c-550a-477c-88c9-4e73bf21d67a"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
11.2.2. Origin in the affine space of connections: the fiducial PD\
\>", "Subsubsection",ExpressionUUID->"4542db19-e841-414a-9736-eec99c4f8311"],

Cell["\<\
Note that by default only covariant partial derivatives commute. However if \
the metric is flat and PD is its associated covariant derivative, then all \
kinds of partial derivatives commute. That is defined below, with the metric \
definition.\
\>", "Text",ExpressionUUID->"ed0fd0b9-a988-4a95-be27-846d148ea136"],

Cell["Currently we assume that PD is never a projected derivative.", \
"Text",ExpressionUUID->"a4374b36-35b7-4f88-a182-7b44c0f1140a"],

Cell["\<\
We define PD separately because it has very special properties:\
\>", "Text",ExpressionUUID->"24c90b16-9ffe-45d8-be8f-5961674b46f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AppendToUnevaluated", "[", 
     RowBox[{"$CovDs", ",", "PD"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CovDQ", "[", "PD", "]"}], "^=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymbolOfCovD", "[", "PD", "]"}], "^=", 
     RowBox[{"{", 
      RowBox[{"\"\<,\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CurvatureQ", "[", "PD", "]"}], "^=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CurvatureQ", "[", 
      RowBox[{"PD", ",", "vbundle_"}], "]"}], "^=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TorsionQ", "[", "PD", "]"}], "^=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfCovD", "[", "PD", "]"}], "^:=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightedWithBasis", "[", "PD", "]"}], "^:=", "AIndex"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldOfCovD", "[", 
      RowBox[{"PD", "[", "a_", "]"}], "]"}], "^:=", 
     RowBox[{"BaseOfVBundle", "@", 
      RowBox[{"VBundleOfIndex", "[", "a", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldOfCovD", "[", "PD", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<ManifoldOfCovD[PD] has been used.\>\"", "]"}], ";", 
       
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundlesOfCovD", "[", 
      RowBox[{"PD", "[", "a_", "]"}], "]"}], "^:=", 
     RowBox[{"{", 
      RowBox[{"VBundleOfIndex", "[", "a", "]"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundlesOfCovD", "[", "PD", "]"}], "^:=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<VBundlesOfCovD[PD] has been used.\>\"", "]"}], ";", 
       
       RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricOfCovD", "[", "PD", "]"}], "^=", "Null"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MasterOf", "[", "PD", "]"}], "^=", "Symbol"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Define", " ", "derivative"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MakeLinearDerivative", "[", 
     RowBox[{"PD", ",", "True"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MakeTensorialDerivative", "[", "PD", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Commutativity", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SortCovDs", "[", 
      RowBox[{"expr_", ",", "PD"}], "]"}], ":=", 
     RowBox[{"expr", "//.", "$SortPDsRules"}]}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "No", " ", "associated", " ", "curvature", " ", "or", " ", "torsion", " ",
      "tensors"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannToWeylRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeylToRiemannRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciToTFRicciRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TFRicciToRicciRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciToEinsteinRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"EinsteinToRicciRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannToRiemannDownRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannDownToRiemannRules", "[", "PD", "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "All", " ", "associated", " ", "tensors", " ", "are", " ", "Zero"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TagSet", "[", 
     RowBox[{"PD", ",", 
      RowBox[{"GiveSymbol", "[", 
       RowBox[{
        RowBox[{
        "Riemann", "|", "RiemannDown", "|", "Ricci", "|", "TFRicci", "|", 
         "RicciScalar", "|", "Einstein", "|", "Weyl", "|", "Kretschmann", "|",
          "Torsion", "|", "FRiemann"}], ",", "PD"}], "]"}], ",", "Zero"}], 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "We", " ", "do", " ", "not", " ", "add", " ", "definitions", " ", "for", 
     " ", "numbers", " ", "of", " ", "arguments", " ", "other", " ", "than", 
     " ", "one"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "PD", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"04be08bf-f763-48ad-a9dd-abf5c61c73e4"],

Cell["\<\
QUESTION: I don't like the SortCovDs command. The problem is that \
IndexSorting is a nonlocal operation, and DisorderedPairQ[a,b] could be \
missing important information needed to sort the derivatives. On the other \
hand commutativity is currently only defined for covariant abstract indices \
(not including patterns or basis-indices); how do we deal with those other \
cases? In principle we have to resort to CommuteCovDs, which is more general.\
\
\>", "Text",ExpressionUUID->"a42ea916-651c-44ae-98a1-984caa134791"],

Cell["\<\
Motivated by an email from Manuel Hohmann (April 2019). These are the rules \
for sorting PD derivatives. If needed (for example with flat first metrics) \
we will add more rules to this list:\
\>", "Text",ExpressionUUID->"a8f8ff6a-c6c4-4573-aca2-f949b7277685"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$SortPDsRules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "b_Symbol"}], "]"}], "[", 
      RowBox[{
       RowBox[{"PD", "[", 
        RowBox[{"-", "a_Symbol"}], "]"}], "[", "expr1_", "]"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       RowBox[{"PD", "[", 
        RowBox[{"-", "a"}], "]"}], "[", 
       RowBox[{
        RowBox[{"PD", "[", 
         RowBox[{"-", "b"}], "]"}], "[", "expr1", "]"}], "]"}], "/;", 
      RowBox[{"DisorderedPairQ", "[", 
       RowBox[{
        RowBox[{"-", "a"}], ",", 
        RowBox[{"-", "b"}]}], "]"}]}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"10df04c2-7f5e-4505-8953-0e023a961716"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2.3. DefCovD", \
"Subsubsection",ExpressionUUID->"32260680-740a-4cf3-9f50-37317d473d96"],

Cell["\<\
This command is very long so that we break it into several steps, which are \
analyzed in the following subsubsections.\
\>", "Text",ExpressionUUID->"a39d6eb5-1086-41d0-910e-6530d5e725c9"],

Cell["\<\
1) Check the input and the the options. The analysis of the Curvature options \
is separated for clarity of reading. Possibilities: True, False, Riemann, \
FRiemann, a vbundle or a list of vbundles. This function does some checking \
and then returns the list of vbundles on which the covd has nonzero curvature:\
\>", "Text",ExpressionUUID->"1cd95bfe-614a-4529-bf93-0b2482246705"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"True", ",", "vbundles_List"}], "]"}], ":=", "vbundles"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"False", ",", "vbundles_List"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"Riemann", ",", 
     RowBox[{"{", 
      RowBox[{"tb_", ",", "___"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", "tb", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"FRiemann", ",", 
     RowBox[{"{", 
      RowBox[{"tb_", ",", "vb__"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", "vb", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"FRiemann", ",", 
     RowBox[{"{", "tb_", "}"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefCovD", "::", "error"}], ",", 
      "\"\<Cannot define inner vbundle curvature only having the tangent \
bundle.\>\""}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{
     RowBox[{"vb_", "?", "VBundleQ"}], ",", "vbundles_List"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{"vbundles", ",", "vb"}], "]"}], ",", 
     RowBox[{"{", "vb", "}"}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefCovD", "::", "error"}], ",", 
        RowBox[{"\"\<Cannot define curvature on vbundle \>\"", "<>", 
         RowBox[{"ToString", "[", "vb", "]"}], "<>", "\"\<.\>\""}]}], 
       "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"list_List", ",", "vbundles_List"}], "]"}], ":=", 
   RowBox[{"DeleteDuplicates", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"checkcovdcurvature", "[", 
        RowBox[{"#", ",", "vbundles"}], "]"}], "&"}], "/@", "list"}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"checkcovdcurvature", "[", 
    RowBox[{"x_", ",", "vbundles_List"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DefCovD", "::", "unknown"}], ",", 
      "\"\<value of Curvature option\>\"", ",", "x"}], "]"}]}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6472b7f0-1c83-438d-9d16-a60158a8a8e7"],

Cell["\<\
Some of the checks are not necessary when the derivative is an extension of a \
previously defined external derivative. We need an If construction to control \
that issue. TODO.\
\>", "Text",ExpressionUUID->"d055fdca-31d1-428c-813d-27be5208cb96"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefCovDCheck", "[", 
   RowBox[{"covd_", ",", "manifold_", ",", "vbundles_", ",", "symbol_", ",", 
    RowBox[{"{", 
     RowBox[{
     "torsion_", ",", "curvature_", ",", "metric_", ",", "curvrels_", ",", 
      "ef_", ",", "odeps_", ",", "wwb_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "CovD", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"covd", "===", "PD"}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "error"}], ",", 
         "\"\<CovD PD denotes the fiducial ordinary derivative.\>\""}], 
        "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"ValidateSymbol", "[", "covd", "]"}], ";", "\[IndentingNewLine]", 
    
    RowBox[{"ValidateSymbolInSession", "[", "covd", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Vector", " ", "bundles"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"VBundleQ", "[", "#", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefCovD", "::", "invalid"}], ",", "#", ",", 
           "\"\<vbundle\>\""}], "]"}]}]}], "]"}], "&"}], "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", "vbundles", "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Tangent", "[", "manifold", "]"}], "=!=", 
       RowBox[{"First", "@", "vbundles"}]}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "error"}], ",", 
         "\"\<Index of non-tangent vbundle.\>\""}], "]"}]}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Symbol", " ", "of", " ", "derivative"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "symbol", "]"}], "=!=", "List"}], "||", 
       RowBox[{
        RowBox[{"Length", "@", "symbol"}], "=!=", "2"}]}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "invalid"}], ",", "symbol", ",", 
         "\"\<pair of strings for derivative output\>\""}], "]"}]}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", 
         RowBox[{"First", "@", "symbol"}], "]"}], "=!=", "String"}], " ", "||", 
       RowBox[{
        RowBox[{"Length", "@", 
         RowBox[{"Characters", "@", 
          RowBox[{"ToString", "@", 
           RowBox[{"First", "@", "symbol"}]}]}]}], "=!=", "1"}]}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "invalid"}], ",", 
         RowBox[{"First", "@", "symbol"}], ",", 
         "\"\<Postfix symbol for a derivative\>\""}], "]"}]}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Head", "[", 
        RowBox[{"Last", "@", "symbol"}], "]"}], "=!=", "String"}], " ", ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "invalid"}], ",", 
         RowBox[{"Last", "@", "symbol"}], ",", 
         "\"\<Prefix symbol for a derivative\>\""}], "]"}]}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Additional", " ", "dependencies"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"Or", "[", 
          RowBox[{
           RowBox[{"ManifoldQ", "[", "#", "]"}], ",", 
           RowBox[{"ParameterQ", "[", "#", "]"}]}], "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefCovD", "::", "unknown"}], ",", "\"\<dependency\>\"", 
           ",", "#"}], "]"}]}]}], "]"}], "&"}], "/@", "odeps"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "Metric", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"metric", "=!=", "Null"}], "&&", 
       RowBox[{"!", 
        RowBox[{"MetricQ", "[", "metric", "]"}]}]}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "unknown"}], ",", "\"\<metric\>\"", ",", 
         "metric"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Weight", " ", "extension"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"wwb", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"BasisQ", "[", "wwb", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefCovD", "::", "unknown"}], ",", "\"\<basis\>\"", ",", 
            "wwb"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"metric", "===", "Null"}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefCovD", "::", "error"}], ",", 
            "\"\<Only Levi-Civita connections can be weight-extended.\>\""}], 
           "]"}]}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "Torsion", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"TrueOrFalse", "[", "torsion", "]"}]}], ",", 
      RowBox[{"Throw", "[", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "invalid"}], ",", "torsion", ",", 
         "\"\<value for option Torsion\>\""}], "]"}], "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"torsion", " ", "&&", 
         RowBox[{"metric", "=!=", "Null"}], "&&", 
         RowBox[{"!", 
          RowBox[{"FirstMetricQ", "[", "metric", "]"}]}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefCovD", "::", "error"}], ",", 
           "\"\<Connections with torsion can only be associated to a \
first-metric.\>\""}], "]"}]}]}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
    
    RowBox[{"(*", " ", "CurvatureRelations", " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"TrueOrFalse", "[", "curvrels", "]"}]}], ",", 
      RowBox[{"Throw", "[", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "invalid"}], ",", "curvrels", ",", 
         "\"\<value for option CurvatureRelations\>\""}], "]"}], "]"}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Extended", " ", "derivative"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ef", "=!=", "Null"}], "&&", 
       RowBox[{"!", 
        RowBox[{"CovDQ", "[", "ef", "]"}]}]}], ",", 
      RowBox[{"Throw", "[", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefCovD", "::", "invalid"}], ",", "ef", ",", 
         "\"\< covariant derivative to extend\>\""}], "]"}], "]"}]}], "]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Curvature", ".", " ", "Return"}], " ", "bundles", " ", "with", 
      " ", "curvature"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"checkcovdcurvature", "[", 
     RowBox[{"curvature", ",", "vbundles"}], "]"}]}], "\[IndentingNewLine]", 
   ")"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"017ae278-ed94-4d20-9b1f-336f0711bbfb"],

Cell["\<\
2) Special rules for special tensors for the tensors formatting. In most \
cases we just take the first character of the name:\
\>", "Text",ExpressionUUID->"8c4d0702-1897-4e3f-9674-5d29b1100db2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Set", "[", 
     RowBox[{
      RowBox[{"CovDTensorQ", "[", "#", "]"}], ",", "True"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "Torsion", ",", "Christoffel", ",", "AChristoffel", ",", "Riemann", ",", 
     "FRiemann", ",", "Ricci", ",", "RicciScalar", ",", "RiemannDown", ",", 
     "Einstein", ",", "TFRicci", ",", "Weyl", ",", "Kretschmann"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDTensorQ", "[", "_", "]"}], "=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dc5c6086-dfe6-4d79-9a6b-22c0568cbdf5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Torsion", "]"}], "=", "\"\<T\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Christoffel", "]"}], "=", 
   "\"\<\[CapitalGamma]\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "AChristoffel", "]"}], "=", "\"\<A\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Riemann", "]"}], "=", "\"\<R\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "FRiemann", "]"}], "=", "\"\<F\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Ricci", "]"}], "=", "\"\<R\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "RicciScalar", "]"}], "=", "\"\<R\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "RiemannDown", "]"}], "=", 
   "\"\<\[ScriptCapitalR]\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Einstein", "]"}], "=", "\"\<G\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "TFRicci", "]"}], "=", "\"\<S\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Weyl", "]"}], "=", "\"\<W\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Kretschmann", "]"}], "=", "\"\<K\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1b09bee1-9367-4670-ba0a-99844eac9437"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Special", " ", "formatting", " ", "of", " ", "tensors", " ", "associated",
     " ", "to", " ", "connections"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"GiveOutputString", "[", 
      RowBox[{
       RowBox[{"tensor_Symbol", "?", "CovDTensorQ"}], ",", "covd_"}], "]"}], ":=", 
     RowBox[{"StringJoin", "[", 
      RowBox[{
       RowBox[{"PrintAsCharacter", "[", "tensor", "]"}], ",", "\"\<[\>\"", 
       ",", 
       RowBox[{
        RowBox[{"SymbolOfCovD", "[", "covd", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<]\>\""}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GiveOutputString", "[", 
      RowBox[{
       RowBox[{"tensor_Symbol", "?", "CovDTensorQ"}], ",", "covd1_", ",", 
       "covd2_"}], "]"}], ":=", 
     RowBox[{"StringJoin", "[", 
      RowBox[{
       RowBox[{"PrintAsCharacter", "[", "tensor", "]"}], ",", "\"\<[\>\"", 
       ",", 
       RowBox[{
        RowBox[{"SymbolOfCovD", "[", "covd1", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<,\>\"", ",", 
       RowBox[{
        RowBox[{"SymbolOfCovD", "[", "covd2", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<]\>\""}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"990ec8f0-2c7b-4b0a-8e78-5a4036ba9091"],

Cell["3) Backwards compatibility:", \
"Text",ExpressionUUID->"ef25e975-a6a7-42c0-b690-602dde1176e3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "ind_", "]"}], ",", 
     RowBox[{"symbol", ":", 
      RowBox[{"{", 
       RowBox[{"_String", ",", "_String"}], "}"}]}], ",", "options___"}], 
    "]"}], ":=", 
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd", "[", "ind", "]"}], ",", 
     RowBox[{"VBundleOfIndex", "[", "ind", "]"}], ",", 
     RowBox[{"SymbolOfCovD", "\[Rule]", "symbol"}], ",", "options"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "ind_", "]"}], ",", "vbundles_", ",", 
     RowBox[{"symbol", ":", 
      RowBox[{"{", 
       RowBox[{"_String", ",", "_String"}], "}"}]}], ",", "options___"}], 
    "]"}], ":=", 
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd", "[", "ind", "]"}], ",", "vbundles", ",", 
     RowBox[{"SymbolOfCovD", "\[Rule]", "symbol"}], ",", "options"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "ind_", "]"}], ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd", "[", "ind", "]"}], ",", 
     RowBox[{"VBundleOfIndex", "[", "ind", "]"}], ",", "options"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"46d1181c-b0bd-445a-b637-31b188936c7b"],

Cell["4) This is the main command.", \
"Text",ExpressionUUID->"a013da2e-ac48-445b-899a-fa051a07b818"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefCovD", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SymbolOfCovD", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Torsion", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Curvature", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FromMetric", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     RowBox[{"CurvatureRelations", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ExtendedFrom", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"OtherDependencies", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"OrthogonalTo", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"ProjectedWith", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"WeightedWithBasis", "\[Rule]", "Null"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Master", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
     RowBox[{"DefInfo", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<covariant derivative\>\"", ",", "\"\<\>\""}], "}"}]}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefCovD", "[", 
    RowBox[{"list_List", ",", "rest___"}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DefCovD", "[", 
       RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefCovD", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "ind_", "]"}], ",", "vbundles_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Catch", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{
          RowBox[{"AIndexQ", "[", "ind", "]"}], "&&", 
          RowBox[{"DownIndexQ", "[", "ind", "]"}]}], "]"}], ",", 
        RowBox[{"Throw", "[", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefCovD", "::", "invalid"}], ",", 
           "\"\<covariant abstract-index\>\"", ",", "ind"}], "]"}], "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tbundle", "=", 
           RowBox[{"VBundleOfIndex", "[", "ind", "]"}]}], ",", 
          RowBox[{"manifold", "=", 
           RowBox[{"BaseOfVBundle", "@", 
            RowBox[{"VBundleOfIndex", "[", "ind", "]"}]}]}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "allbundles", ",", "symbol", ",", "torsion", ",", "curvature", ",",
             "metric", ",", "curvrels", ",", "ef", ",", "odeps", ",", "wwb", 
            ",", "pns", ",", "master", ",", "info", ",", "ot", ",", "pw", ",",
             "curvedbundles"}], "}"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", "Options", " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "symbol", ",", "torsion", ",", "curvature", ",", "metric", ",", 
              "curvrels", ",", "ot", ",", "pw", ",", "ef", ",", "odeps", ",", 
              "wwb", ",", "pns", ",", "master", ",", "info"}], "}"}], "=", 
            RowBox[{"OptionValue", "[", 
             RowBox[{"{", 
              RowBox[{
              "SymbolOfCovD", ",", "Torsion", ",", "Curvature", ",", 
               "FromMetric", ",", "CurvatureRelations", ",", "OrthogonalTo", 
               ",", "ProjectedWith", ",", "ExtendedFrom", ",", 
               "OtherDependencies", ",", "WeightedWithBasis", ",", 
               "ProtectNewSymbol", ",", "Master", ",", "DefInfo"}], "}"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"ot", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"{", "ot", "}"}], ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"pw", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"{", "pw", "}"}], ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"allbundles", "=", 
            RowBox[{"DeleteDuplicates", "@", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{"tbundle", ",", "vbundles", ",", 
                RowBox[{"Dagger", "/@", 
                 RowBox[{"{", "vbundles", "}"}]}]}], "}"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"curvedbundles", "=", 
            RowBox[{"DefCovDCheck", "[", 
             RowBox[{
             "covd", ",", "manifold", ",", "allbundles", ",", "symbol", ",", 
              RowBox[{"{", 
               RowBox[{
               "torsion", ",", "curvature", ",", "metric", ",", "curvrels", 
                ",", "ef", ",", "odeps", ",", "wwb"}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "Register", " ", "*)"}], "\[IndentingNewLine]", 
           
           RowBox[{"MakeDefInfo", "[", 
            RowBox[{"DefCovD", ",", 
             RowBox[{"covd", "[", "ind", "]"}], ",", "info"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"MakexTensions", "[", 
            RowBox[{"DefCovD", ",", "\"\<Beginning\>\"", ",", 
             RowBox[{"covd", "[", "ind", "]"}], ",", "vbundles", ",", 
             "options"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"CovDQ", "[", "covd", "]"}], "^=", "True"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"AppendToUnevaluated", "[", 
            RowBox[{"$CovDs", ",", "covd"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"SymbolOfCovD", "[", "covd", "]"}], "^=", "symbol"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ManifoldOfCovD", "[", "covd", "]"}], "^=", "manifold"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"VBundlesOfCovD", "[", "covd", "]"}], "^=", 
            "allbundles"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], "^=", 
            RowBox[{"SortDependencies", "@", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "manifold", "}"}], ",", "odeps"}], "]"}]}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TorsionQ", "[", "covd", "]"}], "^=", "torsion"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"TagSet", "[", 
              RowBox[{"covd", ",", 
               RowBox[{"CurvatureQ", "[", 
                RowBox[{"covd", ",", "#"}], "]"}], ",", "True"}], "]"}], 
             "&"}], "/@", "curvedbundles"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"TagSet", "[", 
              RowBox[{"covd", ",", 
               RowBox[{"CurvatureQ", "[", 
                RowBox[{"covd", ",", "#"}], "]"}], ",", "False"}], "]"}], 
             "&"}], "/@", 
            RowBox[{"Complement", "[", 
             RowBox[{"allbundles", ",", "curvedbundles"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MetricOfCovD", "[", "covd", "]"}], "^=", "metric"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"WeightedWithBasis", "[", "covd", "]"}], "^=", "wwb"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"SymbolRelations", "[", 
            RowBox[{"covd", ",", "master", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ef", "===", "Null"}], ",", 
               RowBox[{"{", "manifold", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"manifold", ",", "ef"}], "}"}]}], "]"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DefInfo", "[", "covd", "]"}], "^=", "info"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Define", " ", "derivative", " ", "operator"}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"MakeLinearDerivative", "[", 
            RowBox[{"covd", ",", 
             RowBox[{"ot", "===", 
              RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"MakeTensorialDerivative", "[", "covd", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ot", "=!=", 
              RowBox[{"{", "}"}]}], ",", 
             RowBox[{"MakeOrthogonalDerivative", "[", 
              RowBox[{"covd", ",", 
               RowBox[{"First", "[", "pw", "]"}], ",", 
               RowBox[{"First", "[", "ot", "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"pw", "=!=", 
              RowBox[{"{", "}"}]}], ",", 
             RowBox[{"MakeProjectedDerivative", "[", 
              RowBox[{"covd", ",", 
               RowBox[{"First", "[", "pw", "]"}], ",", 
               RowBox[{"First", "[", "ot", "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "Define", " ", "curvature", " ", "tensors", " ", "and", " ", 
             "other", " ", "properties"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"info", "=!=", "False"}], ",", 
             RowBox[{"info", "=", "$DefInfoQ"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ef", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"ExtendedFrom", "[", "covd", "]"}], "^=", "ef"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"defcovdTangent", "[", 
               RowBox[{"covd", ",", "tbundle", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"MetricOfCovD", "[", "ef", "]"}], ",", "ef"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"ot", ",", "pw", ",", "info"}], "}"}]}], "]"}]}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"defcovdTangent", "[", 
              RowBox[{"covd", ",", "tbundle", ",", 
               RowBox[{"{", 
                RowBox[{"torsion", ",", 
                 RowBox[{"CurvatureQ", "[", 
                  RowBox[{"covd", ",", "tbundle"}], "]"}], ",", "metric", ",",
                  "curvrels"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"ot", ",", "pw", ",", "info"}], "}"}]}], "]"}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", "allbundles", "]"}], ">", "1"}], ",", 
             RowBox[{"defcovdFiber", "[", 
              RowBox[{"covd", ",", "tbundle", ",", 
               RowBox[{"allbundles", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"MemberQ", "[", 
                RowBox[{"curvedbundles", ",", 
                 RowBox[{"allbundles", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "info"}], 
              "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"MakexTensions", "[", 
            RowBox[{"DefCovD", ",", "\"\<End\>\"", ",", 
             RowBox[{"covd", "[", "ind", "]"}], ",", "vbundles", ",", 
             "options"}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"pns", ",", 
             RowBox[{"Protect", "[", "covd", "]"}]}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefCovD", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefCovD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"aaffa12f-e086-432f-aa3f-e30ffe4c7d0d"],

Cell["5) Default definitions:", \
"Text",ExpressionUUID->"8cc178fe-a42c-447c-8a44-444d4430a933"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureQ", "[", 
    RowBox[{
     RowBox[{"covd_Symbol", "?", "CovDQ"}], ",", 
     RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureQ", "[", 
    RowBox[{"x_", ",", 
     RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CurvatureQ", "::", "unknown"}], ",", 
      "\"\<covariant derivative\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureQ", "[", 
    RowBox[{
     RowBox[{"covd_Symbol", "?", "CovDQ_"}], ",", "x_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CurvatureQ", "::", "unknown"}], ",", "\"\<vector bundle\>\"", 
      ",", "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureQ", "[", "covd_", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Or", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CurvatureQ", "[", 
         RowBox[{"covd", ",", "#"}], "]"}], "&"}], ",", 
       RowBox[{"VBundlesOfCovD", "[", "covd", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TorsionQ", "[", 
    RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TorsionQ", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"TorsionQ", "::", "unknown"}], ",", 
      "\"\<covariant derivative\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricOfCovD", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"MetricOfCovD", "::", "unknown"}], ",", 
      "\"\<covariant derivative\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfCovD", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"DependenciesOfCovD", "::", "unknown"}], ",", 
      "\"\<covariant derivative\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedFrom", "[", "x_", "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightedWithBasis", "[", 
    RowBox[{"covd_", "?", "CovDQ"}], "]"}], ":=", "Null"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightedWithBasis", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"WeightedWithBasis", "::", "unknown"}], ",", 
      "\"\<covariant derivative\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightedCovDQ", "[", "covd_", "]"}], ":=", 
   RowBox[{
    RowBox[{"WeightedWithBasis", "[", "covd", "]"}], "=!=", "Null"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricCovDQ", "[", "covd_", "]"}], ":=", 
   RowBox[{
    RowBox[{"MetricOfCovD", "[", "covd", "]"}], "=!=", "Null"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1e09ea35-e968-448d-bbef-9a2aca5fa979"],

Cell["\<\
6) Construct associated tensors. These tensors are created by DefCovD, but we \
do not register their names (we could do it either explicitly there or with \
remembered values here). Hence, that assumes that the user will not tamper \
with GiveSymbol in the middle of a session. Recall that for PD there are \
special definitions giving always the Zero tensor.\
\>", "Text",ExpressionUUID->"77259a6f-2388-4cca-86a3-0a6e10266087"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"General", "::", "nomet"}], "=", 
   "\"\<Found nonmetric connection `1`.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"083532d5-4fd3-4b44-bdbb-6bcd2f8a5a70"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Always", " ", "defined"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Torsion", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"GiveSymbol", "[", 
      RowBox[{"Torsion", ",", "covd"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Riemann", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"GiveSymbol", "[", 
      RowBox[{"Riemann", ",", "covd"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FRiemann", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"GiveSymbol", "[", 
      RowBox[{"FRiemann", ",", "covd"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Ricci", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"GiveSymbol", "[", 
      RowBox[{"Ricci", ",", "covd"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Defined", " ", "only", " ", "for", " ", "metric"}], "-", 
     RowBox[{"derived", " ", "connections"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciScalar", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricCovDQ", "[", "covd", "]"}], ",", 
       RowBox[{"GiveSymbol", "[", 
        RowBox[{"RicciScalar", ",", "covd"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"RicciScalar", "::", "nomet"}], ",", "covd"}], "]"}]}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Einstein", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricCovDQ", "[", "covd", "]"}], ",", 
       RowBox[{"GiveSymbol", "[", 
        RowBox[{"Einstein", ",", "covd"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Einstein", "::", "nomet"}], ",", "covd"}], "]"}]}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TFRicci", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricCovDQ", "[", "covd", "]"}], ",", 
       RowBox[{"GiveSymbol", "[", 
        RowBox[{"TFRicci", ",", "covd"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"TFRicci", "::", "nomet"}], ",", "covd"}], "]"}]}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Weyl", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricCovDQ", "[", "covd", "]"}], ",", 
       RowBox[{"GiveSymbol", "[", 
        RowBox[{"Weyl", ",", "covd"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Weyl", "::", "nomet"}], ",", "covd"}], "]"}]}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Kretschmann", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricCovDQ", "[", "covd", "]"}], ",", 
       RowBox[{"GiveSymbol", "[", 
        RowBox[{"Kretschmann", ",", "covd"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Kretschmann", "::", "nomet"}], ",", "covd"}], "]"}]}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Defined", " ", "only", " ", "for", " ", "connections", " ", "associated",
      " ", "to", " ", "a", " ", "frozen", " ", "metric"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RiemannDown", "[", 
      RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricCovDQ", "[", "covd", "]"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"FrozenMetricQ", "[", 
          RowBox[{"MetricOfCovD", "[", "covd", "]"}], "]"}], ",", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"RiemannDown", ",", "covd"}], "]"}], ",", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Riemann", ",", "covd"}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"RiemannDown", "::", "nomet"}], ",", "covd"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1cc4432f-b3aa-4176-85b0-33904b3aad61"],

Cell["Set a default:", \
"Text",ExpressionUUID->"abd8f2cf-21c4-47f6-bdd7-7446024034cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetDelayed", "[", 
     RowBox[{
      RowBox[{"#1", "[", "x_", "]"}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"#", "::", "unknown"}], ",", "\"\<connection\>\"", ",", 
         "x"}], "]"}]}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "Torsion", ",", "Riemann", ",", "FRiemann", ",", "Ricci", ",", 
     "RiemannDown", ",", "RicciScalar", ",", "Einstein", ",", "TFRicci", ",", 
     "Weyl", ",", "Kretschmann"}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"495ec2b8-8e54-4000-b79d-de9c7cd887ac"],

Cell["\<\
7) There is a second use for CurvatureRelations. Note that there is no \
equivalent for FRiemann because there is no inner vbundle Weyl, Ricci, \
TFRicci or RicciScalar.\
\>", "Text",ExpressionUUID->"1f67e44c-5b15-4406-a1eb-be9813ca9fdb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureRelations", "[", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Join", ",", 
     RowBox[{"Map", "[", 
      RowBox[{"CurvatureRelations", ",", "$CovDs"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureRelations", "[", 
    RowBox[{"covd_Symbol", "?", "CovDQ"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"CurvatureRelations", "[", 
      RowBox[{"covd", ",", "Riemann"}], "]"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MetricOfCovD", "[", "covd", "]"}], "=!=", "Null"}], ",", 
       RowBox[{"CurvatureRelations", "[", 
        RowBox[{"covd", ",", "Ricci"}], "]"}], ",", 
       RowBox[{"{", "}"}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvatureRelations", "[", "___", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"46334b50-ed62-4a2e-9b32-38bbd8c76624"],

Cell["This is a simple driver for CurvatureRelations:", \
"Text",ExpressionUUID->"18550d1b-a586-48f7-999f-7d4759152ea6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ContractCurvature", "[", 
    RowBox[{"expr_", ",", "args___"}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"CurvatureRelations", "[", "args", "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fe92d8dc-c5c9-4d4b-aa55-8cdbe466fd30"],

Cell["8) Finalize commands:", \
"Text",ExpressionUUID->"620945b7-7d64-40fa-b676-fb1d56debca6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "TorsionQ", ",", "MetricOfCovD", ",", "SymbolOfCovD", ",", "ExtendedFrom",
      ",", "DependenciesOfCovD", ",", "WeightedWithBasis"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"CurvatureQ", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{
   "FRiemann", ",", "Curvature", ",", "Torsion", ",", "FromMetric", ",", 
    "CurvatureRelations", ",", "CurvatureQ", ",", "TorsionQ", ",", 
    "MetricOfCovD", ",", "SymbolOfCovD", ",", "ContractCurvature", ",", 
    "ExtendedFrom", ",", "DependenciesOfCovD", ",", "WeightedWithBasis"}], 
   "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"07c65685-5f12-4e08-90b0-0c2d96002522"],

Cell["\<\
9) Motivated by the package Spinors`, we introduce the concept of symmetry of \
a derivative. Sometimes we shall be working with multi-index derivatives, and \
that requires handling possible symmetries in those indices. We shall \
completely follow the structure of SymmetryGroupOfTensor.\
\>", "Text",ExpressionUUID->"7bca2e6c-746c-476a-af53-96a7a8b4f28e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "By", " ", "default", " ", "the", " ", "symmetry", " ", "group", " ", "of",
     " ", "a", " ", "derivative", " ", "is", " ", "trivial"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfCovD", "[", 
      RowBox[{"covd_", "[", "___", "]"}], "]"}], ":=", 
     RowBox[{"SymmetryGroupOfCovD", "[", "covd", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryGroupOfCovD", "[", "covd_Symbol", "]"}], ":=", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"98ffb088-3ced-486c-a6a9-72e860b7c4f5"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2.4. UndefCovD", \
"Subsubsection",ExpressionUUID->"3f17b149-7d67-4acc-a7d9-e70bbb81ebf4"],

Cell["\<\
This function is too complicated in comparison with other UndefType \
functions. QUESTION: Can it be simplified?\
\>", "Text",ExpressionUUID->"565d4541-f5d7-4a8e-ab3c-73fbc47c05f6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefCovD", "[", "PD", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"UndefCovD", "::", "noundef"}], ",", "\"\<CovD\>\"", ",", "PD", 
      ",", "\"\<it is the fiducial origin of derivatives\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefCovD", "[", "covd_", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"$MultiIndexCovDs", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"$MultiIndexCovDs", ",", "covd"}], "]"}]}], ";", 
      RowBox[{"RemoveSymbol", "[", "covd", "]"}]}], ")"}], "/;", 
    RowBox[{"MemberQ", "[", 
     RowBox[{"$MultiIndexCovDs", ",", "covd"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefCovD", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "CovDQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefCovD", ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefCovD", "[", "covd_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"manifold", "=", 
         RowBox[{"ManifoldOfCovD", "[", "covd", "]"}]}], ",", 
        RowBox[{"ef", "=", 
         RowBox[{"ExtendedFrom", "[", "covd", "]"}]}]}], "}"}], ",", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"servants", "=", 
           RowBox[{"ServantsOf", "[", "covd", "]"}]}], ",", "christoffels"}], 
         "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"CovDQ", "[", "covd", "]"}]}], ",", 
           RowBox[{"Throw", "[", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"UndefCovD", "::", "unknown"}], ",", 
              "\"\<covariant derivative\>\"", ",", "covd"}], "]"}], "]"}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"CheckRemoveSymbol", "[", "covd", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakexTensions", "[", 
          RowBox[{"UndefCovD", ",", "\"\<Beginning\>\"", ",", "covd"}], "]"}],
          ";", "\[IndentingNewLine]", 
         RowBox[{"xUpSet", "[", 
          RowBox[{
           RowBox[{"ServantsOf", "[", "covd", "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"christoffels", "=", 
          RowBox[{"Cases", "[", 
           RowBox[{"$Christoffels", ",", 
            RowBox[{"{", 
             RowBox[{"_", ",", 
              RowBox[{"{", 
               RowBox[{"___", ",", "covd", ",", "___"}], "}"}], ",", "_"}], 
             "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"$Christoffels", "=", 
          RowBox[{"Complement", "[", 
           RowBox[{"$Christoffels", ",", "christoffels"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DropFromHosts", "[", "covd", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Undef", "/@", 
          RowBox[{"Union", "[", 
           RowBox[{
            RowBox[{"First", "/@", "christoffels"}], ",", "servants"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ef", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"xUpDeleteCasesTo", "[", 
             RowBox[{
              RowBox[{"VisitorsOf", "[", "ef", "]"}], ",", "covd"}], "]"}], 
            ";", 
            RowBox[{"RemoveSymbol", "/@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"StringJoin", "[", 
                 RowBox[{"#", ",", 
                  RowBox[{"ToString", "[", "covd", "]"}]}], "]"}], "&"}], "/@", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<Christoffel\>\"", ",", "\"\<Riemann\>\"", ",", 
                   "\"\<Ricci\>\"", ",", "\"\<Torsion\>\""}], "}"}], ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"MetricOfCovD", "[", "ef", "]"}], "=!=", "Null"}],
                    ",", 
                   RowBox[{"{", 
                    RowBox[{
                    "\"\<RicciScalar\>\"", ",", "\"\<Weyl\>\"", ",", 
                    "\"\<TFRicci\>\"", ",", "\"\<Einstein\>\"", ",", 
                    "\"\<Kretschmann\>\""}], "}"}], ",", 
                   RowBox[{"{", "}"}]}], "]"}]}], "]"}]}], ")"}]}]}]}], "]"}],
          ";", "\[IndentingNewLine]", 
         RowBox[{"$CovDs", "=", 
          RowBox[{"DeleteCases", "[", 
           RowBox[{"$CovDs", ",", "covd"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"MetricOfCovD", "[", "covd", "]"}], "=!=", "Null"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Unset", "[", 
             RowBox[{"RiemannToWeylRules", "[", "covd", "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Unset", "[", 
             RowBox[{"WeylToRiemannRules", "[", "covd", "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Unset", "[", 
             RowBox[{"RicciToTFRicciRules", "[", "covd", "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Unset", "[", 
             RowBox[{"TFRicciToRicciRules", "[", "covd", "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Unset", "[", 
             RowBox[{"RicciToEinsteinRules", "[", "covd", "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Unset", "[", 
             RowBox[{"EinsteinToRicciRules", "[", "covd", "]"}], "]"}], 
            ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Unset", "[", 
          RowBox[{"SortCovDs", "[", 
           RowBox[{"expr_", ",", "covd"}], "]"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakexTensions", "[", 
          RowBox[{"UndefCovD", ",", "\"\<End\>\"", ",", "covd"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MakeUndefInfo", "[", 
          RowBox[{"UndefCovD", ",", "covd"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"RemoveSymbol", "[", "covd", "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefCovD", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefCovD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9d8ff287-305a-40ce-8616-65c5b6faf3f4"],

Cell["Listable functions:", \
"Text",ExpressionUUID->"b39bf8f1-783c-4aea-a86f-a3c1d17ad4e9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SortCovDs", "[", "expr_", "]"}], ":=", 
   RowBox[{"SortCovDs", "[", 
    RowBox[{"expr", ",", "$CovDs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SortCovDs", "[", 
    RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"SortCovDs", ",", "expr", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SortCovDs", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4b46f5a7-ebdb-4b10-830d-e719f6556915"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"deflistableCovDs", "[", "function_", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rules", "=", 
       RowBox[{"SymbolJoin", "[", 
        RowBox[{"function", ",", "\"\<Rules\>\""}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"function", "[", "expr_", "]"}], ":=", 
       RowBox[{"function", "[", 
        RowBox[{"expr", ",", "$CovDs"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"function", "[", 
        RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
       RowBox[{"Fold", "[", 
        RowBox[{"function", ",", "expr", ",", "list"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"function", "[", 
        RowBox[{"expr_", ",", 
         RowBox[{"covd_Symbol", "?", "CovDQ"}]}], "]"}], ":=", 
       RowBox[{"expr", "/.", 
        RowBox[{"rules", "[", "covd", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SetNumberOfArguments", "[", 
       RowBox[{"function", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"Protect", "[", "function", "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8a459bcb-3c2e-49b1-bbcb-d89fa431f19d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"deflistableCovDs", "/@", 
   RowBox[{"{", 
    RowBox[{
    "RiemannToWeyl", ",", "WeylToRiemann", ",", "RicciToTFRicci", ",", 
     "TFRicciToRicci", ",", "RicciToEinstein", ",", "EinsteinToRicci", ",", 
     "RiemannToRiemannDown", ",", "RiemannDownToRiemann"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8bc19a7b-36cd-4acc-9974-2302ad245531"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2.5. Torsion, curvature and metric", \
"Subsubsection",ExpressionUUID->"375a652c-c1f8-431d-841b-de4b3a60dec8"],

Cell["\<\
This is a trivial function in charge of the many messages that DefCovD outputs\
\>", "Text",ExpressionUUID->"3bb9bd37-b8ef-46a4-ad7a-6b064395ae5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"defmessage", "[", 
   RowBox[{"adjective_String", " ", ",", "tensor_String", ",", "output_", ",", 
    RowBox[{"comment_", ":", "\"\<\>\""}]}], "]"}], ":=", 
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"\"\<** DefCovD:  Defining \>\"", "<>", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"adjective", "===", "\"\<\>\""}], ",", "\"\<\>\"", ",", 
       RowBox[{"adjective", "<>", "\"\< \>\""}]}], "]"}], "<>", "tensor", 
     "<>", "\"\< tensor \>\""}], ",", "output", ",", "comment"}], 
   "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d0c78932-0742-48f6-abe1-dc6fc0536f22"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"defmessage", "[", 
  RowBox[{"\"\<vanishing\>\"", ",", "\"\<Riemann\>\"", ",", 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"61845ee0-25d6-4ad7-bba0-4dc3339a703e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Defining vanishing Riemann tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** DefCovD:  Defining vanishing Riemann tensor ", 
   xAct`xTensor`Private`R[-xAct`xTensor`Private`a, -xAct`xTensor`Private`b, -
    xAct`xTensor`Private`c, -xAct`xTensor`Private`d], ""],
  Editable->
   False]], "Print",ExpressionUUID->"ce666190-ace0-47d0-a56e-29ce90cc4a9f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CovD", "::", "noleib"}], "=", 
  "\"\<Cannot apply Leibnitz rule for `1` on `2`.\>\""}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d170faef-07ec-4122-b4f0-7e7b95e32350"],

Cell[BoxData["\<\"Cannot apply Leibnitz rule for `1` on `2`.\"\>"], \
"Output",ExpressionUUID->"525a3e8c-fa65-47b4-8390-41622baeac6a"]
}, Open  ]],

Cell["\<\
This simple function with arguments metricQ, torsionQ decides the symmetry of \
the Riemann tensor:\
\>", "Text",ExpressionUUID->"8d8f6263-197b-4791-9e93-9f65dc70a7cb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"riemannsymmetric", "[", 
    RowBox[{"True", ",", "False"}], "]"}], ":=", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"riemannsymmetric", "[", 
    RowBox[{"True", ",", "True"}], "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"xAct`xPerm`Cycles", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], "]"}]}], ",", 
       RowBox[{"-", 
        RowBox[{"xAct`xPerm`Cycles", "[", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}], "]"}]}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"3f9e5fe2-f19e-4f4c-b148-1981bf3aa2a3"],

Cell["\<\
Here we define all the properties of the tensors associated with the \
connection, depending on the properties of the connection. Concerning induced \
(projected) derivatives, the only consideration here is constructing objects \
which are projected along the corresponding vectors and projectors.\
\>", "Text",ExpressionUUID->"9911d487-09db-49d1-9c79-d7414a687a4a"],

Cell["\<\
Thanks to Thomas for pointing out that the dimension dim was not correct in \
the projected case. Fixed in August 2013.\
\>", "Text",ExpressionUUID->"86aa7ec6-88f4-4564-bffc-dea6883b51c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"defcovdTangent", "[", 
   RowBox[{"covd_", ",", "tbundle_", ",", 
    RowBox[{"{", 
     RowBox[{"torQ_", ",", "curvQ_", ",", "metric_", ",", "curvrels_"}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ov_", ",", "pw_", ",", "info_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"With", "[", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Reinterpretation", " ", "of", " ", "input"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"indexlist", "=", 
       RowBox[{"GetIndicesOfVBundle", "[", 
        RowBox[{"tbundle", ",", "9"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"dim", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"pw", "===", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"DimOfVBundle", "[", "tbundle", "]"}], ",", 
         RowBox[{
          RowBox[{"DimOfVBundle", "[", "tbundle", "]"}], "-", "1"}]}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"metricQ", "=", 
       RowBox[{"(", 
        RowBox[{"metric", "=!=", "Null"}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"orthogonalQ", "=", 
       RowBox[{"(", 
        RowBox[{"ov", "=!=", 
         RowBox[{"{", "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"projectedQ", "=", 
       RowBox[{"(", 
        RowBox[{"pw", "=!=", 
         RowBox[{"{", "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"endowedQ", "=", 
       RowBox[{"MetricEndowedQ", "[", "tbundle", "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"frozenQ", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"metric", "=!=", "Null"}], ",", 
         RowBox[{"FrozenMetricQ", "[", "metric", "]"}], ",", "False"}], 
        "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"With", "[", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Secondary", " ", "definitions"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tbQ", "=", 
         RowBox[{"VBundleIndexQ", "[", "tbundle", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"tbpmQ", "=", 
         RowBox[{"VBundleIndexPMQ", "[", "tbundle", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"invmetric", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"If", "[", 
            RowBox[{"frozenQ", ",", 
             RowBox[{"GiveSymbol", "[", 
              RowBox[{"Inv", ",", "metric"}], "]"}], ",", "metric"}], "]"}], 
           ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"TorsionName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Torsion", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ChristoffelName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Christoffel", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"RiemannName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Riemann", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"RiemannDownName", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"frozenQ", ",", "RiemannDown", ",", "Riemann"}], "]"}], 
             ",", "covd"}], "]"}], ",", "$Failed"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"RicciName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Ricci", ",", "covd"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"WeylName", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"Weyl", ",", "covd"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"TFRicciName", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"TFRicci", ",", "covd"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"EinsteinName", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"Einstein", ",", "covd"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"RicciScalarName", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"RicciScalar", ",", "covd"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"KretschmannName", "=", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"Kretschmann", ",", "covd"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"i1", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i2", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i3", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i4", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i5", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i1d", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i2d", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i3d", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "8", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i4d", "=", 
         RowBox[{"indexlist", "[", 
          RowBox[{"[", "9", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"integerdimQ", "=", 
         RowBox[{"IntegerQ", "[", "dim", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "prot", ",", "vector", ",", "projector", ",", "tmp", ",", 
          "vanishQ"}], "}"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "0.", " ", "Check", " ", "orthogonality", " ", "and", " ", 
          "projections"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"!", "endowedQ"}], "&&", 
            RowBox[{"(", 
             RowBox[{"projectedQ", "||", "orthogonalQ"}], ")"}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefCovD", "::", "error"}], ",", 
              "\"\<xTensor cannot yet project in a vector bundle without \
metric.\>\""}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"orthogonalQ", ",", 
           RowBox[{"vector", "=", 
            RowBox[{"ov", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "0"}], "]"}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"projectedQ", ",", 
           RowBox[{"projector", "=", 
            RowBox[{"pw", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "0"}], "]"}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"1.", " ", "Define", " ", "torsion", " ", "tensor"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"vanishQ", "=", 
          RowBox[{"!", "torQ"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"DefTensor", "[", 
          RowBox[{
           RowBox[{"TorsionName", "[", 
            RowBox[{"i1", ",", 
             RowBox[{"-", "i2"}], ",", 
             RowBox[{"-", "i3"}]}], "]"}], ",", 
           RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
           RowBox[{"Antisymmetric", "[", 
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PrintAs", "\[RuleDelayed]", 
            RowBox[{"GiveOutputString", "[", 
             RowBox[{"Torsion", ",", "covd"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Master", "\[Rule]", "covd"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"orthogonalQ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"vector", "[", 
                 RowBox[{"-", "i1"}], "]"}], ",", 
                RowBox[{"vector", "[", "i2", "]"}], ",", 
                RowBox[{"vector", "[", "i3", "]"}]}], "}"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"ProjectedWith", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"projectedQ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"projector", "[", 
                 RowBox[{
                  RowBox[{"-", "i1"}], ",", "i1d"}], "]"}], ",", 
                RowBox[{"projector", "[", 
                 RowBox[{"i2", ",", 
                  RowBox[{"-", "i2d"}]}], "]"}], ",", 
                RowBox[{"projector", "[", 
                 RowBox[{"i3", ",", 
                  RowBox[{"-", "i3d"}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"DefInfo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"info", ",", 
              RowBox[{"{", 
               RowBox[{"\"\<torsion tensor\>\"", ",", "\"\<\>\""}], "}"}], 
              ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TensorID", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Torsion", ",", "covd"}], "}"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "2.", " ", "Define", " ", "Christoffel", " ", "tensor", " ", 
           "relating", " ", "covd", " ", "to", " ", 
           RowBox[{"PD", ".", " ", "Always"}], " ", "nonzero"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"DefTensor", "[", 
          RowBox[{
           RowBox[{"ChristoffelName", "[", 
            RowBox[{"i1", ",", 
             RowBox[{"-", "i2"}], ",", 
             RowBox[{"-", "i3"}]}], "]"}], ",", 
           RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{"torQ", ",", 
             RowBox[{"StrongGenSet", "[", 
              RowBox[{
               RowBox[{"{", "}"}], ",", 
               RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", 
             RowBox[{"Symmetric", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PrintAs", "\[RuleDelayed]", 
            RowBox[{"GiveOutputString", "[", 
             RowBox[{"Christoffel", ",", "covd"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Master", "\[Rule]", "covd"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"orthogonalQ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"vector", "[", 
                 RowBox[{"-", "i1"}], "]"}], ",", 
                RowBox[{"vector", "[", "i2", "]"}], ",", 
                RowBox[{"vector", "[", "i3", "]"}]}], "}"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"ProjectedWith", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"projectedQ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"projector", "[", 
                 RowBox[{
                  RowBox[{"-", "i1"}], ",", "i1d"}], "]"}], ",", 
                RowBox[{"projector", "[", 
                 RowBox[{"i2", ",", 
                  RowBox[{"-", "i2d"}]}], "]"}], ",", 
                RowBox[{"projector", "[", 
                 RowBox[{"i3", ",", 
                  RowBox[{"-", "i3d"}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"DefInfo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"info", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                  "torQ", ",", "\"\<non-symmetric \>\"", ",", 
                   "\"\<symmetric \>\""}], "]"}], "<>", 
                 "\"\<Christoffel tensor\>\""}], ",", "\"\<\>\""}], "}"}], 
              ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TensorID", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Christoffel", ",", "covd", ",", "PD"}], "}"}]}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"$Christoffels", ",", 
           RowBox[{"{", 
            RowBox[{"ChristoffelName", ",", 
             RowBox[{"{", 
              RowBox[{"Christoffel", ",", "covd", ",", "PD"}], "}"}], ",", 
             RowBox[{"{", "tbundle", "}"}]}], "}"}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "3.", " ", "Automatic", " ", "commutativity", " ", "of", " ", 
            "scalars"}], ",", " ", 
           RowBox[{"even", " ", "if", " ", "there", " ", "is", " ", 
            RowBox[{"torsion", ".", " ", "Only"}], " ", "for", " ", 
            "covariant", " ", "derivatives", " ", "with", " ", "abstract", 
            " ", "indices"}]}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"-", 
             RowBox[{"b_", "?", "tbQ"}]}], "]"}], "[", 
           RowBox[{
            RowBox[{"covd", "[", 
             RowBox[{"-", 
              RowBox[{"a_", "?", "tbQ"}]}], "]"}], "[", 
            RowBox[{
             RowBox[{"scalar_", "?", "xTensorQ"}], "[", "]"}], "]"}], "]"}], ":=", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"covd", "[", 
              RowBox[{"-", "a"}], "]"}], "[", 
             RowBox[{
              RowBox[{"covd", "[", 
               RowBox[{"-", "b"}], "]"}], "[", 
              RowBox[{"scalar", "[", "]"}], "]"}], "]"}], "+", 
            RowBox[{"$TorsionSign", " ", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"dummy", "=", 
                 RowBox[{"DummyIn", "[", "tbundle", "]"}]}], "}"}], ",", 
               RowBox[{
                RowBox[{"TorsionName", "[", 
                 RowBox[{"dummy", ",", 
                  RowBox[{"-", "a"}], ",", 
                  RowBox[{"-", "b"}]}], "]"}], 
                RowBox[{
                 RowBox[{"covd", "[", 
                  RowBox[{"-", "dummy"}], "]"}], "[", 
                 RowBox[{"scalar", "[", "]"}], "]"}]}]}], "]"}]}]}], "/;", 
           RowBox[{"$CommuteCovDsOnScalars", "&&", 
            RowBox[{"DisorderedPairQ", "[", 
             RowBox[{"a", ",", "b"}], "]"}]}]}]}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"4.", " ", "Metric", " ", "compatibility"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"frozenQ", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "a_", "]"}], "[", 
                RowBox[{"invmetric", "[", 
                 RowBox[{
                  RowBox[{"b_Symbol", "?", "tbQ"}], ",", 
                  RowBox[{"c_Symbol", "?", "tbQ"}]}], "]"}], "]"}], ":=", 
               "0"}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "a_", "]"}], "[", 
                RowBox[{"metric", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"b_Symbol", "?", "tbQ"}]}], ",", 
                  RowBox[{"-", 
                   RowBox[{"c_Symbol", "?", "tbQ"}]}]}], "]"}], "]"}], ":=", 
               "0"}], ";", "\[IndentingNewLine]", 
              RowBox[{"covd", "/:", 
               RowBox[{"TensorDerivative", "[", 
                RowBox[{"invmetric", ",", "covd", ",", "___"}], "]"}], ":=", 
               "Zero"}], ";", "\[IndentingNewLine]", 
              RowBox[{"covd", "/:", 
               RowBox[{"TensorDerivative", "[", 
                RowBox[{"metric", ",", "covd", ",", "___"}], "]"}], ":=", 
               "Zero"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "a_", "]"}], "[", 
                RowBox[{"metric", "[", 
                 RowBox[{
                  RowBox[{"b_", "?", "tbpmQ"}], ",", 
                  RowBox[{"c_", "?", "tbpmQ"}]}], "]"}], "]"}], ":=", "0"}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{"covd", "/:", 
               RowBox[{"TensorDerivative", "[", 
                RowBox[{"metric", ",", "covd", ",", "___"}], "]"}], ":=", 
               "Zero"}]}]}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "5.", " ", "Only", " ", "if", " ", "there", " ", "is", " ", "a", 
           " ", "metric", " ", "and", " ", "no", " ", "torsion", " ", "the", 
           " ", "RiemannDown", " ", "tensor", " ", "has", " ", "its", " ", 
           "full", " ", "symmetries"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"vanishQ", "=", 
          RowBox[{
           RowBox[{"!", "curvQ"}], "||", 
           RowBox[{"If", "[", 
            RowBox[{"integerdimQ", ",", 
             RowBox[{"dim", "<", "2"}], ",", "False"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{"DefTensor", "[", 
            RowBox[{
             RowBox[{"RiemannDownName", "[", 
              RowBox[{
               RowBox[{"-", "i1"}], ",", 
               RowBox[{"-", "i2"}], ",", 
               RowBox[{"-", "i3"}], ",", 
               RowBox[{"-", "i4"}]}], "]"}], ",", 
             RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{"torQ", ",", 
               RowBox[{"JoinSGS", "[", 
                RowBox[{
                 RowBox[{"Antisymmetric", "[", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
                 RowBox[{"Antisymmetric", "[", 
                  RowBox[{"{", 
                   RowBox[{"3", ",", "4"}], "}"}], "]"}]}], "]"}], ",", 
               RowBox[{"RiemannSymmetric", "[", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{"frozenQ", ",", "RiemannDown", ",", "Riemann"}], 
                 "]"}], ",", "covd"}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Master", "\[Rule]", "covd"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{"orthogonalQ", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"vector", "[", "i1", "]"}], ",", 
                  RowBox[{"vector", "[", "i2", "]"}], ",", 
                  RowBox[{"vector", "[", "i3", "]"}], ",", 
                  RowBox[{"vector", "[", "i4", "]"}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"ProjectedWith", "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{"projectedQ", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"projector", "[", 
                   RowBox[{"i1", ",", 
                    RowBox[{"-", "i1d"}]}], "]"}], ",", 
                  RowBox[{"projector", "[", 
                   RowBox[{"i2", ",", 
                    RowBox[{"-", "i2d"}]}], "]"}], ",", 
                  RowBox[{"projector", "[", 
                   RowBox[{"i3", ",", 
                    RowBox[{"-", "i3d"}]}], "]"}], ",", 
                  RowBox[{"projector", "[", 
                   RowBox[{"i4", ",", 
                    RowBox[{"-", "i4d"}]}], "]"}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"DefInfo", "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{"info", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<Riemann tensor\>\"", ",", 
                  RowBox[{"If", "[", 
                   RowBox[{
                   "torQ", ",", 
                    "\"\<Antisymmetric pairs cannot be exchanged.\>\"", ",", 
                    "\"\<\>\""}], "]"}]}], "}"}], ",", "False"}], "]"}]}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TensorID", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Riemann", ",", "covd"}], "}"}]}]}], "]"}]}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"!", "metricQ"}], "||", 
            RowBox[{"(", 
             RowBox[{"metricQ", "&&", "frozenQ"}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"DefTensor", "[", 
            RowBox[{
             RowBox[{"RiemannName", "[", 
              RowBox[{
               RowBox[{"-", "i1"}], ",", 
               RowBox[{"-", "i2"}], ",", 
               RowBox[{"-", "i3"}], ",", "i4"}], "]"}], ",", 
             RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
             RowBox[{"Antisymmetric", "[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{"Riemann", ",", "covd"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Master", "\[Rule]", "covd"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{"orthogonalQ", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"vector", "[", "i1", "]"}], ",", 
                  RowBox[{"vector", "[", "i2", "]"}], ",", 
                  RowBox[{"vector", "[", "i3", "]"}], ",", 
                  RowBox[{"vector", "[", 
                   RowBox[{"-", "i4"}], "]"}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"ProjectedWith", "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{"projectedQ", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"projector", "[", 
                   RowBox[{"i1", ",", 
                    RowBox[{"-", "i1d"}]}], "]"}], ",", 
                  RowBox[{"projector", "[", 
                   RowBox[{"i2", ",", 
                    RowBox[{"-", "i2d"}]}], "]"}], ",", 
                  RowBox[{"projector", "[", 
                   RowBox[{"i3", ",", 
                    RowBox[{"-", "i3d"}]}], "]"}], ",", 
                  RowBox[{"projector", "[", 
                   RowBox[{
                    RowBox[{"-", "i4"}], ",", "i4d"}], "]"}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"DefInfo", "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{"info", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<Riemann tensor\>\"", ",", 
                  RowBox[{"If", "[", 
                   RowBox[{
                   "curvQ", ",", 
                    "\"\<Antisymmetric only in the first pair.\>\"", ",", 
                    "\"\<\>\""}], "]"}]}], "}"}], ",", "False"}], "]"}]}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"TensorID", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Riemann", ",", "covd"}], "}"}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "6.", " ", "Only", " ", "if", " ", "there", " ", "is", " ", "a", 
           " ", "metric", " ", "and", " ", "no", " ", "torsion", " ", "the", 
           " ", "Ricci", " ", "tensor", " ", "is", " ", "symmetric"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{"vanishQ", "=", 
          RowBox[{
           RowBox[{"!", "curvQ"}], "||", 
           RowBox[{"If", "[", 
            RowBox[{"integerdimQ", ",", 
             RowBox[{"dim", "<", "2"}], ",", "False"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"DefTensor", "[", 
          RowBox[{
           RowBox[{"RicciName", "[", 
            RowBox[{
             RowBox[{"-", "i1"}], ",", 
             RowBox[{"-", "i2"}]}], "]"}], ",", 
           RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"metricQ", "&&", 
              RowBox[{"!", "torQ"}]}], ",", 
             RowBox[{"Symmetric", "[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
             RowBox[{"StrongGenSet", "[", 
              RowBox[{
               RowBox[{"{", "}"}], ",", 
               RowBox[{"GenSet", "[", "]"}]}], "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PrintAs", "\[RuleDelayed]", 
            RowBox[{"GiveOutputString", "[", 
             RowBox[{"Ricci", ",", "covd"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Master", "\[Rule]", "covd"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"orthogonalQ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"vector", "[", "i1", "]"}], ",", 
                RowBox[{"vector", "[", "i2", "]"}]}], "}"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"ProjectedWith", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"projectedQ", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"projector", "[", 
                 RowBox[{"i1", ",", 
                  RowBox[{"-", "i1d"}]}], "]"}], ",", 
                RowBox[{"projector", "[", 
                 RowBox[{"i2", ",", 
                  RowBox[{"-", "i2d"}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"DefInfo", "\[RuleDelayed]", 
            RowBox[{"If", "[", 
             RowBox[{"info", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{"vanishQ", ",", "\"\<\>\"", ",", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"metricQ", "&&", 
                    RowBox[{"!", "torQ"}]}], ",", "\"\<symmetric \>\"", ",", 
                    "\"\<non-symmetric \>\""}], "]"}]}], "]"}], "<>", 
                 "\"\<Ricci tensor\>\""}], ",", "\"\<\>\""}], "}"}], ",", 
              "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"TensorID", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Ricci", ",", "covd"}], "}"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"!", "vanishQ"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"covd", "/:", 
             RowBox[{"CurvatureRelations", "[", 
              RowBox[{"covd", ",", "Riemann"}], "]"}], "=", 
             RowBox[{"MakeRule", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"RiemannName", "[", 
                  RowBox[{
                   RowBox[{"-", "i1"}], ",", 
                   RowBox[{"-", "i2"}], ",", 
                   RowBox[{"-", "i3"}], ",", "i2"}], "]"}], ",", 
                 RowBox[{"$RicciSign", " ", 
                  RowBox[{"RicciName", "[", 
                   RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i3"}]}], "]"}]}]}], "}"}], ",", 
               RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{"curvrels", ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{"info", ",", 
                 RowBox[{
                 "Print", "[", 
                  "\"\<** DefCovD:  Contractions of Riemann automatically \
replaced by Ricci.\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"prot", "=", 
                RowBox[{"Unprotect", "[", "RiemannName", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AutomaticRules", "[", 
                RowBox[{"RiemannName", ",", 
                 RowBox[{"CurvatureRelations", "[", 
                  RowBox[{"covd", ",", "Riemann"}], "]"}], ",", 
                 RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Protect", "[", 
                RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "7.", " ", "The", " ", "Ricci", " ", "scalar", " ", "only", " ", 
            "exists", " ", "for", " ", "a", " ", "metric", " ", 
            "connection"}], ",", " ", 
           RowBox[{
           "even", " ", "if", " ", "there", " ", "is", " ", "torsion"}]}], 
          " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"vanishQ", "=", 
             RowBox[{
              RowBox[{"!", "curvQ"}], "||", 
              RowBox[{"If", "[", 
               RowBox[{"integerdimQ", ",", 
                RowBox[{"dim", "<", "2"}], ",", "False"}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DefTensor", "[", 
             RowBox[{
              RowBox[{"RicciScalarName", "[", "]"}], ",", 
              RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PrintAs", "\[RuleDelayed]", 
               RowBox[{"GiveOutputString", "[", 
                RowBox[{"Ricci", ",", "covd"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Master", "\[Rule]", "covd"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DefInfo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"info", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Ricci scalar\>\"", ",", "\"\<\>\""}], "}"}], 
                 ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"TensorID", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"RicciScalar", ",", "covd"}], "}"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", "vanishQ"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"covd", "/:", 
                RowBox[{"CurvatureRelations", "[", 
                 RowBox[{"covd", ",", "Ricci"}], "]"}], "=", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"MakeRule", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"invmetric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i2"}]}], "]"}]}], ",", 
                    RowBox[{"RicciScalarName", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"!", "frozenQ"}], ",", 
                    RowBox[{"MakeRule", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RicciName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", "i1"}], "]"}], ",", 
                    RowBox[{"RicciScalarName", "[", "]"}]}], "}"}], ",", 
                    RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{"curvrels", ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{"info", ",", 
                    RowBox[{
                    "Print", "[", 
                    "\"\<** DefCovD:  Contractions of Ricci automatically \
replaced by RicciScalar.\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"prot", "=", 
                   RowBox[{"Unprotect", "[", "RicciName", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AutomaticRules", "[", 
                   RowBox[{"RicciName", ",", 
                    RowBox[{"CurvatureRelations", "[", 
                    RowBox[{"covd", ",", "Ricci"}], "]"}], ",", 
                    RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Protect", "[", 
                   RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
                "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
             "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "8.", " ", "The", " ", "Einstein", " ", "tensor", " ", "only", " ",
             "exists", " ", "for", " ", "a", " ", "metric", " ", 
            "connection"}], ",", " ", 
           RowBox[{
           "even", " ", "if", " ", "there", " ", "is", " ", "torsion"}]}], 
          " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"vanishQ", "=", 
             RowBox[{
              RowBox[{"!", "curvQ"}], "||", 
              RowBox[{"If", "[", 
               RowBox[{"integerdimQ", ",", 
                RowBox[{"dim", "<", "3"}], ",", "False"}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DefTensor", "[", 
             RowBox[{
              RowBox[{"EinsteinName", "[", 
               RowBox[{
                RowBox[{"-", "i1"}], ",", 
                RowBox[{"-", "i2"}]}], "]"}], ",", 
              RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{"torQ", ",", 
                RowBox[{"StrongGenSet", "[", 
                 RowBox[{
                  RowBox[{"{", "}"}], ",", 
                  RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", 
                RowBox[{"Symmetric", "[", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PrintAs", "\[RuleDelayed]", 
               RowBox[{"GiveOutputString", "[", 
                RowBox[{"Einstein", ",", "covd"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Master", "\[Rule]", "covd"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"orthogonalQ", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"vector", "[", "i1", "]"}], ",", 
                   RowBox[{"vector", "[", "i2", "]"}]}], "}"}], ",", 
                 RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"ProjectedWith", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"projectedQ", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"projector", "[", 
                    RowBox[{"i1", ",", 
                    RowBox[{"-", "i1d"}]}], "]"}], ",", 
                   RowBox[{"projector", "[", 
                    RowBox[{"i2", ",", 
                    RowBox[{"-", "i2d"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"DefInfo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"info", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"vanishQ", ",", "\"\<\>\"", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    "torQ", ",", "\"\<non-symmetric \>\"", ",", 
                    "\"\<symmetric \>\""}], "]"}]}], "]"}], "<>", 
                    "\"\<Einstein tensor\>\""}], ",", "\"\<\>\""}], "}"}], 
                 ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"TensorID", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Einstein", ",", "covd"}], "}"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", "vanishQ"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"prot", "=", 
                RowBox[{"Unprotect", "[", "invmetric", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AutomaticRules", "[", 
                RowBox[{"invmetric", ",", 
                 RowBox[{"MakeRule", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"invmetric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "i3"}], "]"}], "[", 
                    RowBox[{"EinsteinName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i2"}]}], "]"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"$TorsionSign", " ", 
                    RowBox[{"invmetric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{
                    RowBox[{"-", "i4"}], ",", 
                    RowBox[{"-", "i2"}]}], "]"}], 
                    RowBox[{"TorsionName", "[", 
                    RowBox[{"i4", ",", 
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i3"}]}], "]"}]}], "-", 
                    RowBox[{"$TorsionSign", " ", 
                    RowBox[{"$RicciSign", "/", "2"}], " ", 
                    RowBox[{"invmetric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RiemannName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i4"}], ",", 
                    RowBox[{"-", "i2"}], ",", "i5"}], "]"}], 
                    RowBox[{"TorsionName", "[", 
                    RowBox[{"i4", ",", 
                    RowBox[{"-", "i3"}], ",", 
                    RowBox[{"-", "i5"}]}], "]"}]}]}]}], "}"}], "]"}], ",", 
                 RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Protect", "[", 
                RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"!", "frozenQ"}], " ", ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"prot", "=", 
                   RowBox[{"Unprotect", "[", "EinsteinName", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AutomaticRules", "[", 
                   RowBox[{"EinsteinName", ",", 
                    RowBox[{"MakeRule", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "i2"}], "]"}], "[", 
                    RowBox[{"EinsteinName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", "i2"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"$TorsionSign", " ", 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{
                    RowBox[{"-", "i4"}], ",", 
                    RowBox[{"-", "i2"}]}], "]"}], 
                    RowBox[{"TorsionName", "[", 
                    RowBox[{"i4", ",", 
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i3"}]}], "]"}]}], "-", 
                    RowBox[{"$TorsionSign", " ", 
                    RowBox[{"$RicciSign", "/", "2"}], " ", 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RiemannName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i4"}], ",", 
                    RowBox[{"-", "i2"}], ",", "i5"}], "]"}], 
                    RowBox[{"TorsionName", "[", 
                    RowBox[{"i4", ",", 
                    RowBox[{"-", "i3"}], ",", 
                    RowBox[{"-", "i5"}]}], "]"}]}]}]}], "}"}], ",", 
                    RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                    RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Protect", "[", 
                   RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
                "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
             "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "9.", " ", "We", " ", "define", " ", "the", " ", "Weyl", " ", 
            "tensor", " ", "only", " ", "for", " ", "a", " ", "metric", " ", 
            "connection"}], ",", " ", 
           RowBox[{"even", " ", "with", " ", "torsion"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "Weyl", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"vanishQ", "=", 
             RowBox[{
              RowBox[{"!", "curvQ"}], "||", 
              RowBox[{"If", "[", 
               RowBox[{"integerdimQ", ",", 
                RowBox[{"dim", "<", "4"}], ",", "False"}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DefTensor", "[", 
             RowBox[{
              RowBox[{"WeylName", "[", 
               RowBox[{
                RowBox[{"-", "i1"}], ",", 
                RowBox[{"-", "i2"}], ",", 
                RowBox[{"-", "i3"}], ",", 
                RowBox[{"-", "i4"}]}], "]"}], ",", 
              RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{"torQ", ",", 
                RowBox[{"JoinSGS", "[", 
                 RowBox[{
                  RowBox[{"Antisymmetric", "[", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
                  RowBox[{"Antisymmetric", "[", 
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4"}], "}"}], "]"}]}], "]"}], ",", 
                RowBox[{"RiemannSymmetric", "[", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}],
                "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PrintAs", "\[RuleDelayed]", 
               RowBox[{"GiveOutputString", "[", 
                RowBox[{"Weyl", ",", "covd"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Master", "\[Rule]", "covd"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"orthogonalQ", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"vector", "[", "i1", "]"}], ",", 
                   RowBox[{"vector", "[", "i2", "]"}], ",", 
                   RowBox[{"vector", "[", "i3", "]"}], ",", 
                   RowBox[{"vector", "[", "i4", "]"}]}], "}"}], ",", 
                 RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"ProjectedWith", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"projectedQ", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"projector", "[", 
                    RowBox[{"i1", ",", 
                    RowBox[{"-", "i1d"}]}], "]"}], ",", 
                   RowBox[{"projector", "[", 
                    RowBox[{"i2", ",", 
                    RowBox[{"-", "i2d"}]}], "]"}], ",", 
                   RowBox[{"projector", "[", 
                    RowBox[{"i3", ",", 
                    RowBox[{"-", "i3d"}]}], "]"}], ",", 
                   RowBox[{"projector", "[", 
                    RowBox[{"i4", ",", 
                    RowBox[{"-", "i4d"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"DefInfo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"info", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Weyl tensor\>\"", ",", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    "torQ", ",", 
                    "\"\<Antisymmetric pairs cannot be exchanged.\>\"", ",", 
                    "\"\<\>\""}], "]"}]}], "}"}], ",", "False"}], "]"}]}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"TensorID", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Weyl", ",", "covd"}], "}"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", "vanishQ"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"prot", "=", 
                RowBox[{"Unprotect", "[", "WeylName", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AutomaticRules", "[", 
                RowBox[{"WeylName", ",", 
                 RowBox[{"MakeRule", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"invmetric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}], 
                    RowBox[{"WeylName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i2"}], ",", 
                    RowBox[{"-", "i3"}], ",", 
                    RowBox[{"-", "i4"}]}], "]"}]}], ",", "0"}], "}"}], ",", 
                   RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                 RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"!", "frozenQ"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"AutomaticRules", "[", 
                   RowBox[{"WeylName", ",", 
                    RowBox[{"MakeRule", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"WeylName", "[", 
                    RowBox[{"i1", ",", 
                    RowBox[{"-", "i2"}], ",", 
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i3"}]}], "]"}], ",", "0"}], "}"}], ",", 
                    RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                    RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";"}]}],
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"Protect", "[", 
                RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "10.", " ", "TFRicci", " ", "for", " ", "metric", " ", 
            "connections"}], ",", " ", 
           RowBox[{"even", " ", "with", " ", "torsion"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"vanishQ", "=", 
             RowBox[{
              RowBox[{"!", "curvQ"}], "||", 
              RowBox[{"If", "[", 
               RowBox[{"integerdimQ", ",", 
                RowBox[{"dim", "<", "3"}], ",", "False"}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DefTensor", "[", 
             RowBox[{
              RowBox[{"TFRicciName", "[", 
               RowBox[{
                RowBox[{"-", "i1"}], ",", 
                RowBox[{"-", "i2"}]}], "]"}], ",", 
              RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{"torQ", ",", 
                RowBox[{"StrongGenSet", "[", 
                 RowBox[{
                  RowBox[{"{", "}"}], ",", 
                  RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", 
                RowBox[{"Symmetric", "[", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PrintAs", "\[RuleDelayed]", 
               RowBox[{"GiveOutputString", "[", 
                RowBox[{"TFRicci", ",", "covd"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Master", "\[Rule]", "covd"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"orthogonalQ", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"vector", "[", "i1", "]"}], ",", 
                   RowBox[{"vector", "[", "i2", "]"}]}], "}"}], ",", 
                 RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"ProjectedWith", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"projectedQ", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"projector", "[", 
                    RowBox[{"i1", ",", 
                    RowBox[{"-", "i1d"}]}], "]"}], ",", 
                   RowBox[{"projector", "[", 
                    RowBox[{"i2", ",", 
                    RowBox[{"-", "i2d"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"DefInfo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"info", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"vanishQ", ",", "\"\<\>\"", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    "torQ", ",", "\"\<non-symmetric \>\"", ",", 
                    "\"\<symmetric \>\""}], "]"}]}], "]"}], "<>", 
                    "\"\<TFRicci tensor\>\""}], ",", "\"\<\>\""}], "}"}], ",",
                  "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"TensorID", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"TFRicci", ",", "covd"}], "}"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", "vanishQ"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"prot", "=", 
                RowBox[{"Unprotect", "[", "TFRicciName", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AutomaticRules", "[", 
                RowBox[{"TFRicciName", ",", 
                 RowBox[{"MakeRule", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"invmetric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], 
                    RowBox[{"TFRicciName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i2"}]}], "]"}]}], ",", "0"}], "}"}], ",", 
                   RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                 RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"!", "frozenQ"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"AutomaticRules", "[", 
                   RowBox[{"TFRicciName", ",", 
                    RowBox[{"MakeRule", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"TFRicciName", "[", 
                    RowBox[{"i1", ",", 
                    RowBox[{"-", "i1"}]}], "]"}], ",", "0"}], "}"}], ",", 
                    RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], ",", 
                    RowBox[{"Verbose", "\[Rule]", "False"}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Protect", "[", 
                   RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
                "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
             "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"10", 
            RowBox[{"b", ".", " ", "Kretschmann"}], " ", "for", " ", "metric",
             " ", "connections"}], ",", " ", 
           RowBox[{"even", " ", "with", " ", "torsion"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"vanishQ", "=", 
             RowBox[{"!", "curvQ"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"DefTensor", "[", 
             RowBox[{
              RowBox[{"KretschmannName", "[", "]"}], ",", 
              RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PrintAs", "\[RuleDelayed]", 
               RowBox[{"GiveOutputString", "[", 
                RowBox[{"Kretschmann", ",", "covd"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"VanishingQ", "\[Rule]", "vanishQ"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Master", "\[Rule]", "covd"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DefInfo", "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{"info", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Kretschmann scalar\>\"", ",", "\"\<\>\""}], 
                  "}"}], ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
              
              RowBox[{"TensorID", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Kretschmann", ",", "covd"}], "}"}]}]}], "]"}], 
            ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "11.", " ", "Commutation", " ", "of", " ", "derivatives", " ", 
           "with", " ", "abstract", " ", "indices"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"metricQ", " ", "&&", 
            RowBox[{"!", "frozenQ"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"SortCovDs", "[", 
             RowBox[{"expr_", ",", "covd"}], "]"}], ":=", 
            RowBox[{"(", 
             RowBox[{"expr", "//.", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"HoldPattern", "[", 
                RowBox[{
                 RowBox[{"covd", "[", 
                  RowBox[{"b_", "?", "tbpmQ"}], "]"}], "[", 
                 RowBox[{
                  RowBox[{"covd", "[", 
                   RowBox[{"a_", "?", "tbpmQ"}], "]"}], "[", "expr1_", "]"}], 
                 "]"}], "]"}], "\[RuleDelayed]", 
               RowBox[{
                RowBox[{"makeCommuteCovDs", "[", 
                 RowBox[{"expr1", ",", "covd", ",", 
                  RowBox[{"{", 
                   RowBox[{"a", ",", "b"}], "}"}]}], "]"}], "/;", 
                RowBox[{"DisorderedPairQ", "[", 
                 RowBox[{"a", ",", "b"}], "]"}]}]}]}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"SortCovDs", "[", 
             RowBox[{"expr_", ",", "covd"}], "]"}], ":=", 
            RowBox[{"(", 
             RowBox[{"expr", "//.", 
              RowBox[{
               RowBox[{"HoldPattern", "[", 
                RowBox[{
                 RowBox[{"covd", "[", 
                  RowBox[{"-", 
                   RowBox[{"b_", "?", "tbQ"}]}], "]"}], "[", 
                 RowBox[{
                  RowBox[{"covd", "[", 
                   RowBox[{"-", 
                    RowBox[{"a_", "?", "tbQ"}]}], "]"}], "[", "expr1_", "]"}],
                  "]"}], "]"}], "\[RuleDelayed]", 
               RowBox[{
                RowBox[{"makeCommuteCovDs", "[", 
                 RowBox[{"expr1", ",", "covd", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "a"}], ",", 
                    RowBox[{"-", "b"}]}], "}"}]}], "]"}], "/;", 
                RowBox[{"DisorderedPairQ", "[", 
                 RowBox[{
                  RowBox[{"-", "a"}], ",", 
                  RowBox[{"-", "b"}]}], "]"}]}]}]}], ")"}]}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"12.", " ", "Riemann", " ", "versus", " ", "Weyl"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"RiemannToWeylRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"curvQ", "&&", "metricQ", "&&", 
             RowBox[{"If", "[", 
              RowBox[{"integerdimQ", ",", 
               RowBox[{"dim", ">", "1"}], ",", "True"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"info", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<** DefCovD:  Computing RiemannToWeylRules for dim \>\"", 
                 ",", "dim"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Which", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"dim", "===", "2"}], ",", "\[IndentingNewLine]", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RiemannDownName", "[", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], 
                   ",", 
                   RowBox[{"$RicciSign", " ", 
                    RowBox[{"RicciScalarName", "[", "]"}], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}]}], ")"}], "/", 
                    "2"}]}]}], "}"}], ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",",
                "\[IndentingNewLine]", 
               RowBox[{"dim", "===", "3"}], ",", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RiemannDownName", "[", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], 
                   ",", 
                   RowBox[{
                    RowBox[{"$RicciSign", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "2"}], ")"}]}]}], "-", 
                    RowBox[{"$RicciSign", " ", 
                    RowBox[{"RicciScalarName", "[", "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "1"}], ")"}]}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "2"}], ")"}]}]}]}]}], "}"}], ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",",
                "\[IndentingNewLine]", "True", ",", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RiemannDownName", "[", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], 
                   ",", 
                   RowBox[{
                    RowBox[{"WeylName", "[", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], 
                    "+", 
                    RowBox[{"$RicciSign", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "2"}], ")"}]}]}], "-", 
                    RowBox[{"$RicciSign", " ", 
                    RowBox[{"RicciScalarName", "[", "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "1"}], ")"}]}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "2"}], ")"}]}]}]}]}], "}"}], ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}]}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"WeylToRiemannRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"integerdimQ", ",", 
               RowBox[{"dim", "\[GreaterEqual]", "4"}], ",", "True"}], "]"}], 
             "&&", "metricQ", "&&", "curvQ"}], ",", 
            RowBox[{"MakeRule", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"WeylName", "[", 
                 RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], ",", 
                
                RowBox[{
                 RowBox[{"RiemannDownName", "[", 
                  RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], "-", 
                 RowBox[{"$RicciSign", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], 
                    RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"dim", "-", "2"}], ")"}]}]}], "+", 
                 RowBox[{"$RicciSign", " ", 
                  RowBox[{"RicciScalarName", "[", "]"}], 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}]}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"dim", "-", "1"}], ")"}]}], "/", 
                   RowBox[{"(", 
                    RowBox[{"dim", "-", "2"}], ")"}]}]}]}]}], "}"}], ",", 
              RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
              RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
              RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"RiemannToRiemannDownRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"metricQ", "&&", "frozenQ", "&&", "curvQ"}], ",", 
            RowBox[{"MakeRule", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RiemannName", "[", 
                 RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], ",", 
                
                RowBox[{
                 RowBox[{"RiemannDownName", "[", 
                  RowBox[{"i1", ",", "i2", ",", "i3", ",", 
                   RowBox[{"-", "i1d"}]}], "]"}], 
                 RowBox[{"invmetric", "[", 
                  RowBox[{"i1d", ",", "i4"}], "]"}]}]}], "}"}], ",", 
              RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
              RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
              RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"RiemannDownToRiemannRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"metricQ", "&&", "frozenQ", "&&", "curvQ"}], ",", 
            RowBox[{"MakeRule", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RiemannDownName", "[", 
                 RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], ",", 
                
                RowBox[{
                 RowBox[{"RiemannName", "[", 
                  RowBox[{"i1", ",", "i2", ",", "i3", ",", "i1d"}], "]"}], 
                 RowBox[{"metric", "[", 
                  RowBox[{
                   RowBox[{"-", "i1d"}], ",", "i4"}], "]"}]}]}], "}"}], ",", 
              RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
              RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
              RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"13.", " ", "Ricci", " ", "versus", " ", 
           RowBox[{"TFRicci", ".", " ", 
            RowBox[{"QUESTION", ":", " ", 
             RowBox[{
             "Are", " ", "dimensions", " ", "right", " ", "when", " ", 
              "orthogonalQ", " ", "or", " ", 
              RowBox[{"projectedQ", "?"}]}]}]}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"RicciToTFRicciRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"curvQ", "&&", "metricQ", "&&", 
             RowBox[{"If", "[", 
              RowBox[{"integerdimQ", ",", 
               RowBox[{"dim", ">", "1"}], ",", "True"}], "]"}], "&&", 
             RowBox[{"!", "frozenQ"}]}], ",", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"info", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<** DefCovD:  Computing RicciToTFRicci for dim \>\"", ",",
                  "dim"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Which", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"dim", "===", "2"}], ",", "\[IndentingNewLine]", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"RicciScalarName", "[", "]"}], 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "/", "2"}]}]}], "}"}], 
                 ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",",
                "\[IndentingNewLine]", "True", ",", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"TFRicciName", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "+", " ", 
                    RowBox[{
                    RowBox[{"RicciScalarName", "[", "]"}], 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "/", "dim"}]}]}]}], 
                  "}"}], ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}]}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TFRicciToRicciRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"integerdimQ", ",", 
               RowBox[{"dim", "\[GreaterEqual]", "3"}], ",", "True"}], "]"}], 
             "&&", "metricQ", "&&", "curvQ", "&&", 
             RowBox[{"!", "frozenQ"}]}], ",", 
            RowBox[{"MakeRule", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"TFRicciName", "[", 
                 RowBox[{"i1", ",", "i2"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"RicciName", "[", 
                  RowBox[{"i1", ",", "i2"}], "]"}], "-", " ", 
                 RowBox[{
                  RowBox[{"RicciScalarName", "[", "]"}], 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "/", "dim"}]}]}]}], 
               "}"}], ",", 
              RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
              RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
              RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"14.", " ", "Ricci", " ", "versus", " ", "Einstein"}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"RicciToEinsteinRules", "[", "covd", "]"}], "=", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"curvQ", "&&", "metricQ", "&&", 
             RowBox[{"If", "[", 
              RowBox[{"integerdimQ", ",", 
               RowBox[{"dim", ">", "1"}], ",", "True"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"info", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<** DefCovD:  Computing RicciToEinsteinRules for dim \
\>\"", ",", "dim"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Which", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"dim", "===", "2"}], ",", "\[IndentingNewLine]", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "/", "2"}], 
                    RowBox[{"RicciScalarName", "[", "]"}]}]}], "}"}], ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",",
                "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", 
               RowBox[{"MakeRule", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RicciName", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"EinsteinName", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "/", "2"}], 
                    RowBox[{"RicciScalarName", "[", "]"}]}]}]}], "}"}], ",", 
                 RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
                 RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
                 RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}]}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"EinsteinToRicciRules", "[", "covd", "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"integerdimQ", ",", 
               RowBox[{"dim", "\[GreaterEqual]", "3"}], ",", "True"}], "]"}], 
             "&&", "metricQ", "&&", "curvQ"}], ",", 
            RowBox[{"MakeRule", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"EinsteinName", "[", 
                 RowBox[{"i1", ",", "i2"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"RicciName", "[", 
                  RowBox[{"i1", ",", "i2"}], "]"}], "-", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], "/", "2"}], 
                  RowBox[{"RicciScalarName", "[", "]"}]}]}]}], "}"}], ",", 
              RowBox[{"MetricOn", "\[Rule]", "All"}], ",", 
              RowBox[{"TestIndices", "\[Rule]", "False"}], ",", 
              RowBox[{"ContractMetrics", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", "}"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"296ac1e2-e543-438f-b2a9-ec115a134ea8"],

Cell["\<\
This function adds further definitions for those cases in which a derivative \
is defined as extension of another one:\
\>", "Text",ExpressionUUID->"56b13e6f-f5c7-431c-b40e-27a4669054fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"defcovdTangent", "[", 
    RowBox[{"covd_", ",", "tbundle_", ",", 
     RowBox[{"{", 
      RowBox[{"metric_", ",", "covd2_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ov_", ",", "pw_", ",", "info_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Reinterpretation", " ", "of", " ", "input"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"metricQ", "=", 
        RowBox[{"(", 
         RowBox[{"metric", "=!=", "Null"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"orthogonalQ", "=", 
        RowBox[{"(", 
         RowBox[{"ov", "=!=", 
          RowBox[{"{", "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"projectedQ", "=", 
        RowBox[{"(", 
         RowBox[{"pw", "=!=", 
          RowBox[{"{", "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"endowedQ", "=", 
        RowBox[{"MetricEndowedQ", "[", "tbundle", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"frozenQ", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"metric", "=!=", "Null"}], ",", 
          RowBox[{"FrozenMetricQ", "[", "metric", "]"}], ",", "False"}], 
         "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Secondary", " ", "definitions"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tbQ", "=", 
          RowBox[{"VBundleIndexQ", "[", "tbundle", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"tbpmQ", "=", 
          RowBox[{"VBundleIndexPMQ", "[", "tbundle", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TorsionName", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Torsion", ",", "covd"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ChristoffelName", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Christoffel", ",", "covd"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Christoffel12Name", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"Christoffel", ",", "##"}], "]"}], "&"}], "@@", 
           RowBox[{"Sort", "[", 
            RowBox[{"{", 
             RowBox[{"covd", ",", "covd2"}], "}"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"RiemannName", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Riemann", ",", "covd"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"RiemannDownName", "=", 
          RowBox[{"If", "[", 
           RowBox[{"metricQ", ",", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{"frozenQ", ",", "RiemannDown", ",", "Riemann"}], "]"}],
               ",", "covd"}], "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"RicciName", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Ricci", ",", "covd"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"WeylName", "=", 
          RowBox[{"If", "[", 
           RowBox[{"metricQ", ",", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"Weyl", ",", "covd"}], "]"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TFRicciName", "=", 
          RowBox[{"If", "[", 
           RowBox[{"metricQ", ",", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"TFRicci", ",", "covd"}], "]"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"EinsteinName", "=", 
          RowBox[{"If", "[", 
           RowBox[{"metricQ", ",", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"Einstein", ",", "covd"}], "]"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"RicciScalarName", "=", 
          RowBox[{"If", "[", 
           RowBox[{"metricQ", ",", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"RicciScalar", ",", "covd"}], "]"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"KretschmannName", "=", 
          RowBox[{"If", "[", 
           RowBox[{"metricQ", ",", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"Kretschmann", ",", "covd"}], "]"}]}], "]"}]}]}], "}"}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "0.", " ", "Check", " ", "orthogonality", " ", "and", " ", 
         "projections"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"!", "endowedQ"}], "&&", 
           RowBox[{"(", 
            RowBox[{"projectedQ", "||", "orthogonalQ"}], ")"}]}], ",", 
          RowBox[{"Throw", "[", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefCovD", "::", "error"}], ",", 
             "\"\<xTensor cannot yet project in a vector bundle without \
metric.\>\""}], "]"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"1.", " ", "Define", " ", "torsion", " ", "tensor"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TorsionQ", "[", "covd", "]"}], "^=", 
         RowBox[{"TorsionQ", "[", "covd2", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TorsionName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Torsion", ",", "covd2"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "2.", " ", "Define", " ", "Christoffel", " ", "tensor", " ", 
          "relating", " ", "covd", " ", "to", " ", 
          RowBox[{"PD", ".", " ", "Always"}], " ", "nonzero"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"ChristoffelName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Christoffel", ",", "covd2"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "The", " ", "Christoffel", " ", "relating", " ", "a", " ", 
           "derivative", " ", "and", " ", "its", " ", "extension", " ", "is", 
           " ", "zero"}], ",", " ", 
          RowBox[{"but", " ", "not", " ", "the", " ", "AChristoffel"}]}], " ",
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{"defChristoffel", "[", 
         RowBox[{"Christoffel12Name", ",", 
          RowBox[{"{", 
           RowBox[{"tbundle", ",", "tbundle"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Christoffel", ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"Sort", "[", 
              RowBox[{"{", 
               RowBox[{"covd", ",", "covd2"}], "}"}], "]"}]}]}], "}"}], ",", 
          RowBox[{"VanishingQ", "\[Rule]", "True"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Christoffel12Name", "[", 
            RowBox[{"_", ",", "_", ",", "_"}], "]"}], ":=", "0"}], ";"}], 
         "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "3.", " ", "Automatic", " ", "commutativity", " ", "of", " ", 
           "scalars"}], ",", " ", 
          RowBox[{"even", " ", "if", " ", "there", " ", "is", " ", 
           RowBox[{"torsion", ".", " ", "Only"}], " ", "for", " ", 
           "covariant", " ", "derivatives", " ", "with", " ", "abstract", " ",
            "indices"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"-", 
            RowBox[{"b_", "?", "tbQ"}]}], "]"}], "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"-", 
             RowBox[{"a_", "?", "tbQ"}]}], "]"}], "[", 
           RowBox[{
            RowBox[{"scalar_", "?", "xTensorQ"}], "[", "]"}], "]"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"covd", "[", 
             RowBox[{"-", "a"}], "]"}], "[", 
            RowBox[{
             RowBox[{"covd", "[", 
              RowBox[{"-", "b"}], "]"}], "[", 
             RowBox[{"scalar", "[", "]"}], "]"}], "]"}], "+", 
           RowBox[{"$TorsionSign", " ", 
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"dummy", "=", 
                RowBox[{"DummyIn", "[", "tbundle", "]"}]}], "}"}], ",", 
              RowBox[{
               RowBox[{"TorsionName", "[", 
                RowBox[{"dummy", ",", 
                 RowBox[{"-", "a"}], ",", 
                 RowBox[{"-", "b"}]}], "]"}], 
               RowBox[{
                RowBox[{"covd", "[", 
                 RowBox[{"-", "dummy"}], "]"}], "[", 
                RowBox[{"scalar", "[", "]"}], "]"}]}]}], "]"}]}]}], "/;", 
          RowBox[{"$CommuteCovDsOnScalars", "&&", 
           RowBox[{"DisorderedPairQ", "[", 
            RowBox[{"a", ",", "b"}], "]"}]}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "4.", " ", "Only", " ", "if", " ", "there", " ", "is", " ", "a", " ",
           "metric", " ", "the", " ", "Riemann", " ", "tensor", " ", "has", 
          " ", "its", " ", "full", " ", "symmetries"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"RiemannName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Riemann", ",", "covd2"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"frozenQ", ",", 
          RowBox[{"RiemannDownName", "=", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"RiemannDown", ",", "covd2"}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "5.", " ", "Only", " ", "if", " ", "there", " ", "is", " ", "a", " ",
           "metric", " ", "the", " ", "Ricci", " ", "tensor", " ", "is", " ", 
          "symmetric"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"RicciName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Ricci", ",", "covd2"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "6.", " ", "The", " ", "Ricci", " ", "scalar", " ", "only", " ", 
          "exists", " ", "for", " ", "a", " ", "metric", " ", "connection"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"metricQ", ",", 
          RowBox[{"RicciScalarName", "=", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"RicciScalar", ",", "covd2"}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "7.", " ", "Metric", " ", "compatibility", " ", "is", " ", 
          "automatically", " ", "extended"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"metricQ", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"covd", "[", "_", "]"}], "[", 
            RowBox[{"metric", "[", 
             RowBox[{
              RowBox[{"_", "?", "AIndexQ"}], ",", 
              RowBox[{"_", "?", "AIndexQ"}]}], "]"}], "]"}], ":=", "0"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "8.", " ", "The", " ", "Einstein", " ", "tensor", " ", "only", " ", 
          "exists", " ", "for", " ", "a", " ", "metric", " ", "connection"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"metricQ", ",", 
          RowBox[{"EinsteinName", "=", 
           RowBox[{"GiveSymbol", "[", 
            RowBox[{"Einstein", ",", "covd2"}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "9.", " ", "The", " ", "Weyl", " ", "and", " ", "TFRicci", " ", 
          "tensors", " ", "only", " ", "exist", " ", "for", " ", "a", " ", 
          "metric", " ", "connection"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"WeylName", "=", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"Weyl", ",", "covd2"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"TFRicciName", "=", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"TFRicci", ",", "covd2"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"KretschmannName", "=", 
            RowBox[{"GiveSymbol", "[", 
             RowBox[{"Kretschmann", ",", "covd2"}], "]"}]}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "10.", " ", "Commutation", " ", "of", " ", "derivatives", " ", 
          "with", " ", "abstract", " ", "indices"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"metricQ", " ", "&&", 
           RowBox[{"!", "frozenQ"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SortCovDs", "[", 
            RowBox[{"expr_", ",", "covd"}], "]"}], ":=", 
           RowBox[{"(", 
            RowBox[{"expr", "//.", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"HoldPattern", "[", 
               RowBox[{
                RowBox[{"covd", "[", 
                 RowBox[{"b_", "?", "tbpmQ"}], "]"}], "[", 
                RowBox[{
                 RowBox[{"covd", "[", 
                  RowBox[{"a_", "?", "tbpmQ"}], "]"}], "[", "expr1_", "]"}], 
                "]"}], "]"}], "\[RuleDelayed]", 
              RowBox[{
               RowBox[{"makeCommuteCovDs", "[", 
                RowBox[{"expr1", ",", "covd", ",", 
                 RowBox[{"{", 
                  RowBox[{"a", ",", "b"}], "}"}]}], "]"}], "/;", 
               RowBox[{"DisorderedPairQ", "[", 
                RowBox[{"a", ",", "b"}], "]"}]}]}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SortCovDs", "[", 
            RowBox[{"expr_", ",", "covd"}], "]"}], ":=", 
           RowBox[{"(", 
            RowBox[{"expr", "//.", 
             RowBox[{
              RowBox[{"HoldPattern", "[", 
               RowBox[{
                RowBox[{"covd", "[", 
                 RowBox[{"-", 
                  RowBox[{"b_", "?", "tbQ"}]}], "]"}], "[", 
                RowBox[{
                 RowBox[{"covd", "[", 
                  RowBox[{"-", 
                   RowBox[{"a_", "?", "tbQ"}]}], "]"}], "[", "expr1_", "]"}], 
                "]"}], "]"}], "\[RuleDelayed]", 
              RowBox[{
               RowBox[{"makeCommuteCovDs", "[", 
                RowBox[{"expr1", ",", "covd", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "a"}], ",", 
                   RowBox[{"-", "b"}]}], "}"}]}], "]"}], "/;", 
               RowBox[{"DisorderedPairQ", "[", 
                RowBox[{
                 RowBox[{"-", "a"}], ",", 
                 RowBox[{"-", "b"}]}], "]"}]}]}]}], ")"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"metricQ", ",", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"11.", " ", "Riemann", " ", "versus", " ", 
            RowBox[{"Weyl", ".", " ", "Are"}], " ", "dimensions", " ", 
            "right", " ", "when", " ", "orthogonalQ", " ", "or", " ", 
            RowBox[{"projectedQ", "?"}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"RiemannToWeylRules", "[", "covd", "]"}], "=", 
            RowBox[{"RiemannToWeylRules", "[", "covd2", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"WeylToRiemannRules", "[", "covd", "]"}], "=", 
            RowBox[{"WeylToRiemannRules", "[", "covd2", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"12.", " ", "Ricci", " ", "versus", " ", 
             RowBox[{"TFRicci", ".", " ", "Are"}], " ", "dimensions", " ", 
             "right", " ", "when", " ", "orthogonalQ", " ", "or", " ", 
             RowBox[{"projectedQ", "?"}]}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"RicciToTFRicciRules", "[", "covd", "]"}], "=", 
            RowBox[{"RicciToTFRicciRules", "[", "covd2", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TFRicciToRicciRules", "[", "covd", "]"}], "=", 
            RowBox[{"TFRicciToRicciRules", "[", "covd2", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"13.", " ", "Ricci", " ", "versus", " ", "Einstein"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"RicciToEinsteinRules", "[", "covd", "]"}], "=", 
            RowBox[{"RicciToEinsteinRules", "[", "covd2", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"EinsteinToRicciRules", "[", "covd", "]"}], "=", 
            RowBox[{"EinsteinToRicciRules", "[", "covd2", "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{
         "14.", " ", "Conversion", " ", "to", " ", "derivative", " ", "on", 
          " ", "the", " ", "tangent", " ", 
          RowBox[{
          "bundle", ".", " ", "Deactivated", ".", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"covd", "[", "a_", "]"}], "[", "expr_", "]"}]}]}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"covd2", "[", "a", "]"}], "[", "expr", "]"}], "/;", 
          RowBox[{
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"FindIndices", "[", "expr", "]"}], ",", 
             RowBox[{"x_", "/;", 
              RowBox[{"GIndexQ", "[", 
               RowBox[{"x", ",", "tbundle"}], "]"}]}]}], "]"}], "===", 
           RowBox[{"IndexList", "[", "]"}]}]}]}], ";"}], 
       "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"18ba878a-41fc-4fd9-a01f-e3db842dddea"],

Cell["\<\
Finally, these are the definitions associated to the inner part of the \
derivative:\
\>", "Text",ExpressionUUID->"c2d74485-5960-40e5-bd78-b0d652d650e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"defcovdFiber", "[", 
   RowBox[{
   "covd_", ",", "tbundle_", ",", "fbundle_", ",", "curvQ_", ",", "info_"}], 
   "]"}], ":=", 
  RowBox[{"With", "[", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Reinterpretation", " ", "of", " ", "input"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"tindexlist", "=", 
       RowBox[{"GetIndicesOfVBundle", "[", 
        RowBox[{"tbundle", ",", "2"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"findexlist", "=", 
       RowBox[{"GetIndicesOfVBundle", "[", 
        RowBox[{"fbundle", ",", "4"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"With", "[", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Secondary", " ", "definitions"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AChristoffelName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"AChristoffel", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FRiemannName", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"FRiemann", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"i1", "=", 
         RowBox[{"tindexlist", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"i2", "=", 
         RowBox[{"tindexlist", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"fi1", "=", 
         RowBox[{"findexlist", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"fi2", "=", 
         RowBox[{"findexlist", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"fi3", "=", 
         RowBox[{"findexlist", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"fi4", "=", 
         RowBox[{"findexlist", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "1.", " ", "Define", " ", "Christoffel", " ", "tensor", " ", 
        "relating", " ", "covd", " ", "to", " ", 
        RowBox[{"PD", ".", " ", "Always"}], " ", "nonzero"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DefTensor", "[", 
        RowBox[{
         RowBox[{"AChristoffelName", "[", 
          RowBox[{"fi1", ",", 
           RowBox[{"-", "i2"}], ",", 
           RowBox[{"-", "fi3"}]}], "]"}], ",", 
         RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"PrintAs", "\[RuleDelayed]", 
          RowBox[{"GiveOutputString", "[", 
           RowBox[{"AChristoffel", ",", "covd"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Dagger", "\[RuleDelayed]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"DaggerQ", "[", "fbundle", "]"}], ",", "Complex", ",", 
            "Real"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Master", "\[Rule]", "covd"}], ",", "\[IndentingNewLine]", 
         RowBox[{"DefInfo", "\[RuleDelayed]", 
          RowBox[{"If", "[", 
           RowBox[{"info", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<nonsymmetric AChristoffel tensor\>\"", ",", "\"\<\>\""}], 
             "}"}], ",", "False"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"TensorID", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"AChristoffel", ",", "covd", ",", "PD"}], "}"}]}]}], "]"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"$Christoffels", ",", 
         RowBox[{"{", 
          RowBox[{"AChristoffelName", ",", 
           RowBox[{"{", 
            RowBox[{"AChristoffel", ",", "covd", ",", "PD"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"tbundle", ",", "fbundle"}], "}"}]}], "}"}]}], "]"}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"2.", " ", "Define", " ", "FRiemann", " ", "tensor"}], " ", 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"DefTensor", "[", 
        RowBox[{
         RowBox[{"FRiemannName", "[", 
          RowBox[{
           RowBox[{"-", "i1"}], ",", 
           RowBox[{"-", "i2"}], ",", 
           RowBox[{"-", "fi3"}], ",", "fi4"}], "]"}], ",", 
         RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", 
         RowBox[{"Antisymmetric", "[", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"PrintAs", "\[RuleDelayed]", 
          RowBox[{"GiveOutputString", "[", 
           RowBox[{"FRiemann", ",", "covd"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Dagger", "\[RuleDelayed]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"DaggerQ", "[", "fbundle", "]"}], ",", "Complex", ",", 
            "Real"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"VanishingQ", "\[RuleDelayed]", 
          RowBox[{"!", "curvQ"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Master", "\[Rule]", "covd"}], ",", "\[IndentingNewLine]", 
         RowBox[{"DefInfo", "\[RuleDelayed]", 
          RowBox[{"If", "[", 
           RowBox[{"info", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<FRiemann tensor\>\"", ",", 
              RowBox[{"If", "[", 
               RowBox[{
               "curvQ", ",", "\"\<Antisymmetric only in the first pair.\>\"", 
                ",", "\"\<\>\""}], "]"}]}], "}"}], ",", "False"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"TensorID", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"FRiemann", ",", "covd"}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"ffff5508-9f6d-4671-b118-0bafd2b375b2"],

Cell["\<\
We need a small function which will be set to True in particular cases by \
DefMetric. In general:\
\>", "Text",ExpressionUUID->"688bd7e0-f260-4af4-a57c-848c2be7777d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InducedCovDQ", "[", "covd_", "]"}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ed55c889-aef2-4064-a536-9c6df6311415"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
11.2.6. Automatic SortCovDs for derivatives with abstract indices\
\>", "Subsubsection",ExpressionUUID->"1e9ff142-1c87-4ea3-81b5-5a0ca045d8cd"],

Cell["\<\
These functions automatize the commutation of covariant derivatives. By \
default even PD is not automatically commutative. Recall that default \
commutation only happens on *nonindexed* scalars, and that can be switched \
off using $CommuteCovDsOnScalars. Covariant derivatives on Scalar objects \
replace the Scalar head by ReplaceDummies.\
\>", "Text",ExpressionUUID->"a1704710-9b4f-4bc6-8e27-c5f7ecf34a5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SortCovDsStart", "[", "PD", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "@", "$CommuteCovDsOnScalars"}], ",", 
         RowBox[{
         "Print", "[", 
          "\"\<Note that $CommuteCovDsOnScalars is still False.\>\"", "]"}]}],
         "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Unprotect", "[", "PD", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"PD", "[", 
          RowBox[{"-", "b_Symbol"}], "]"}], "[", 
         RowBox[{
          RowBox[{"PD", "[", 
           RowBox[{"-", "a_Symbol"}], "]"}], "[", "expr1_", "]"}], "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{"PD", "[", 
           RowBox[{"-", "a"}], "]"}], "[", 
          RowBox[{
           RowBox[{"PD", "[", 
            RowBox[{"-", "b"}], "]"}], "[", "expr1", "]"}], "]"}], "/;", 
         RowBox[{"DisorderedPairQ", "[", 
          RowBox[{
           RowBox[{"-", "a"}], ",", 
           RowBox[{"-", "b"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"PD", "===", 
            RowBox[{"CovDOfMetric", "@", 
             RowBox[{"FirstMetricOfVBundle", "[", 
              RowBox[{"#", ",", "False"}], "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"vbQ", "=", 
               RowBox[{"VBundleIndexPMQ", "[", "#", "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"PD", "[", 
                RowBox[{"b_", "?", "vbQ"}], "]"}], "[", 
               RowBox[{
                RowBox[{"PD", "[", 
                 RowBox[{"a_", "?", "vbQ"}], "]"}], "[", "expr1_", "]"}], 
               "]"}], ":=", 
              RowBox[{
               RowBox[{
                RowBox[{"PD", "[", "a", "]"}], "[", 
                RowBox[{
                 RowBox[{"PD", "[", "b", "]"}], "[", "expr1", "]"}], "]"}], "/;", 
               RowBox[{"DisorderedPairQ", "[", 
                RowBox[{
                 RowBox[{"-", "a"}], ",", 
                 RowBox[{"-", "b"}]}], "]"}]}]}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "&"}], "/@", 
        RowBox[{"Select", "[", 
         RowBox[{"$VBundles", ",", "MetricEndowedQ"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Protect", "[", "PD", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"555b2178-9e59-4225-ae6a-7e711db25643"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SortCovDsStart", "[", 
    RowBox[{"covd_", "?", "CovDQ"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tbQ", "=", 
        RowBox[{"VBundleIndexQ", "[", 
         RowBox[{"TangentBundleOfCovD", "[", "covd", "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"tbpmQ", "=", 
        RowBox[{"VBundleIndexPMQ", "[", 
         RowBox[{"TangentBundleOfCovD", "[", "covd", "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"metric", "=", 
        RowBox[{"MetricOfCovD", "[", "covd", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "@", "$CommuteCovDsOnScalars"}], ",", 
        RowBox[{
        "Print", "[", 
         "\"\<Note that $CommuteCovDsOnScalars is still False.\>\"", "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"metric", "=!=", "Null"}], "&&", 
         RowBox[{"!", 
          RowBox[{"FrozenMetricQ", "[", "metric", "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"b_", "?", "tbpmQ"}], "]"}], "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"a_", "?", "tbpmQ"}], "]"}], "[", "expr1_", "]"}], "]"}], 
         ":=", 
         RowBox[{
          RowBox[{"makeCommuteCovDs", "[", 
           RowBox[{"expr1", ",", "covd", ",", 
            RowBox[{"{", 
             RowBox[{"a", ",", "b"}], "}"}]}], "]"}], "/;", 
          RowBox[{"DisorderedPairQ", "[", 
           RowBox[{"a", ",", "b"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"-", 
            RowBox[{"b_", "?", "tbQ"}]}], "]"}], "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"-", 
             RowBox[{"a_", "?", "tbQ"}]}], "]"}], "[", "expr1_", "]"}], "]"}],
          ":=", 
         RowBox[{
          RowBox[{"makeCommuteCovDs", "[", 
           RowBox[{"expr1", ",", "covd", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "a"}], ",", 
              RowBox[{"-", "b"}]}], "}"}]}], "]"}], "/;", 
          RowBox[{"DisorderedPairQ", "[", 
           RowBox[{
            RowBox[{"-", "a"}], ",", 
            RowBox[{"-", "b"}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2a5a4310-e118-47db-a059-7b8f31086fc6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SortCovDsStart", "[", "list_List", "]"}], ":=", 
  RowBox[{"SortCovDsStart", "/@", "list"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SortCovDsStart", "[", "covd_", "]"}], ":=", 
  RowBox[{"Message", "[", 
   RowBox[{
    RowBox[{"SortCovDsStart", "::", "unknown"}], ",", 
    "\"\<covariant derivative\>\"", ",", "covd"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SortCovDsStart", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SortCovDsStart", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0c4cc581-9cd5-4fc7-819b-ac9482aef01b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SortCovDsStop", "[", "PD", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{"$CommuteCovDsOnScalars", ",", 
         RowBox[{
         "Print", "[", 
          "\"\<Note that $CommuteCovDsOnScalars is still True.\>\"", "]"}]}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Unprotect", "[", "PD", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"PD", "/:", 
        RowBox[{
         RowBox[{
          RowBox[{"PD", "[", 
           RowBox[{"-", "b_Symbol"}], "]"}], "[", 
          RowBox[{
           RowBox[{"PD", "[", 
            RowBox[{"-", "a_Symbol"}], "]"}], "[", "expr1_", "]"}], "]"}], 
         "=."}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"PD", "===", 
            RowBox[{"CovDOfMetric", "@", 
             RowBox[{"FirstMetricOfVBundle", "[", 
              RowBox[{"#", ",", "False"}], "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"vbQ", "=", 
               RowBox[{"VBundleIndexPMQ", "[", "#", "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PD", "/:", 
              RowBox[{
               RowBox[{
                RowBox[{"PD", "[", 
                 RowBox[{"b_", "?", "vbQ"}], "]"}], "[", 
                RowBox[{
                 RowBox[{"PD", "[", 
                  RowBox[{"a_", "?", "vbQ"}], "]"}], "[", "expr1_", "]"}], 
                "]"}], "=."}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
         "&"}], "/@", 
        RowBox[{"Select", "[", 
         RowBox[{"$VBundles", ",", "MetricEndowedQ"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Protect", "[", "PD", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cd907eb3-2ca4-4d5f-99d8-ec5f3c465920"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SortCovDsStop", "[", 
    RowBox[{"covd_", "?", "CovDQ"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tbQ", "=", 
        RowBox[{"VBundleIndexQ", "[", 
         RowBox[{"TangentBundleOfCovD", "[", "covd", "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"tbpmQ", "=", 
        RowBox[{"VBundleIndexPMQ", "[", 
         RowBox[{"TangentBundleOfCovD", "[", "covd", "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"metric", "=", 
        RowBox[{"MetricOfCovD", "[", "covd", "]"}]}]}], "\[IndentingNewLine]",
       "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{"$CommuteCovDsOnScalars", ",", 
        RowBox[{
        "Print", "[", 
         "\"\<Note that $CommuteCovDsOnScalars is still True.\>\"", "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"metric", "=!=", "Null"}], "&&", 
         RowBox[{"!", 
          RowBox[{"FrozenMetricQ", "[", "metric", "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"b_", "?", "tbpmQ"}], "]"}], "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"a_", "?", "tbpmQ"}], "]"}], "[", "expr1_", "]"}], "]"}], 
         "=."}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"-", 
            RowBox[{"b_", "?", "tbQ"}]}], "]"}], "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"-", 
             RowBox[{"a_", "?", "tbQ"}]}], "]"}], "[", "expr1_", "]"}], "]"}],
          "=."}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"814ab4f1-d6b1-40de-a005-6c3adfcea22b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SortCovDsStop", "[", "covd_", "]"}], ":=", 
  RowBox[{"Message", "[", 
   RowBox[{
    RowBox[{"SortCovDsStop", "::", "unknown"}], ",", 
    "\"\<covariant derivative\>\"", ",", "covd"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SortCovDsStop", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SortCovDsStop", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a65e3239-e3b8-4f65-aa91-7500ec1c4899"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5c90ec17-5b23-4ad6-88b2-d4c6f435cb65"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"51ef9bf5-f083-4a86-befb-def74f4da7e2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9dd6be06-e2fa-4b91-ac90-5281ea54506c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"fcd3d8c2-8bc0-4be9-87bb-ac15c58fc3fc"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7e48b0fb-ca8f-4ad0-b972-d3a710641485"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"72a55565-6923-4953-b609-9da4287fb899"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"2fa675f8-a39e-4fcc-9e98-bd96b2cbac76"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"39b1cbe7-bb60-4584-a5ca-eb93d42fcd4a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{"v", "[", "C", "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"6251f319-f721-48b1-8497-ebd8f7814242"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], "]"}], 
  "]"}]], "Output",ExpressionUUID->"17425fa5-b693-42d3-8f33-bccf68f2d029"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SortCovDs", "[", 
  RowBox[{"%", ",", "PD"}], 
  "]"}]], "Input",ExpressionUUID->"9a4e24b8-50c8-43f8-ae52-4d077e1b383c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "B"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], "]"}], 
  "]"}]], "Output",ExpressionUUID->"b159625a-6b06-4efd-baa8-3dc78fd3d09b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SortCovDsStart", "[", "PD", "]"}], 
  ";"}]], "Input",ExpressionUUID->"6ee30fc4-c366-4e7b-ac21-54e218a8735a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{"v", "[", "C", "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"9e172f1b-53c8-44de-b004-92ab24972e3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "B"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], "]"}], 
  "]"}]], "Output",ExpressionUUID->"d6b96914-5ad0-43d1-987c-17345cd7b0d4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SortCovDsStop", "[", "PD", 
  "]"}]], "Input",ExpressionUUID->"4672e5be-5304-4d16-a803-1cb5d227ab4e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{"v", "[", "C", "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"2ffbc714-1cd5-4879-8a95-c14f540b1155"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], "]"}], 
  "]"}]], "Output",ExpressionUUID->"d37f9b00-7683-4c7b-975f-87189c6833f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "v", 
  "]"}]], "Input",ExpressionUUID->"9010978f-3129-4cb8-97f0-d6650ee588de"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"819e5e9a-9e58-4dd6-9b3b-fe1117eb9638"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"839af16c-64cf-4c4a-9433-e3ad8ac4ceaf"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"1635a4ba-d401-404c-856c-db7c69dbef4c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"8b6d7fca-8287-4a01-90be-6f06315dc1ee"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"28456378-a38c-4025-9a47-aad2de1d6850"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2.7. TensorD and TensorDerivative", \
"Subsubsection",ExpressionUUID->"dcb5988f-4573-4174-8dc9-7c2dd4a6c628"],

Cell["\<\
We introduce another form of derivative, this time index-free based.\
\>", "Text",ExpressionUUID->"f75089ee-c7a1-46e0-868a-3716b79457ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor_", ",", "ders___"}], "]"}], "]"}], "^:=", 
   RowBox[{"And", "[", 
    RowBox[{
     RowBox[{"xTensorQ", "[", "tensor", "]"}], ",", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{"TensorDerQ", "/@", 
        RowBox[{"{", "ders", "}"}]}], ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5f65e02f-68d4-42b0-8799-4076e4b08355"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TensorDerQ", "[", 
    RowBox[{"covd_", "?", "CovDQ"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorDerQ", "[", 
    RowBox[{"LieD", "[", 
     RowBox[{
      RowBox[{"v_", "?", "xTensorQ"}], "[", "_", "]"}], "]"}], "]"}], ":=", 
   "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorDerQ", "[", 
    RowBox[{"ParamD", "[", 
     RowBox[{"_Symbol", "?", "ParameterQ"}], "]"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorDerQ", "[", "OverDot", "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorDerQ", "[", "_", "]"}], ":=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"63f18b59-9dcd-4bd7-ac7c-5cb244ae18bc"],

Cell["\<\
A tensor derivative object has the following associated slots. Note that \
connections are always naturally covariant, and that the derivative slots are \
added at the end, in the order given by the ders arguments.\
\>", "Text",ExpressionUUID->"229458ff-9b1e-40e2-b063-61422fe692d6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SlotOfDerivative", "[", "PD", "]"}], ":=", 
    RowBox[{"-", "All"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Recall", " ", "that", " ", "the", " ", "first", " ", "vbundle", " ", "of",
     " ", "a", " ", "covd", " ", "is", " ", "the", " ", "tangent", " ", 
    "covd"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotOfDerivative", "[", 
    RowBox[{"covd_", "?", "CovDQ"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"First", "@", 
     RowBox[{"VBundlesOfCovD", "[", "covd", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotOfDerivative", "[", 
    RowBox[{"_ParamD", "|", "OverDot", "|", "_LieD"}], "]"}], ":=", 
   RowBox[{"Sequence", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor_", ",", "ders__"}], "]"}], "]"}], "^:=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", 
     RowBox[{"SlotOfDerivative", "/@", 
      RowBox[{"{", "ders", "}"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f0f13ba0-ed7a-465b-9e89-ba2cf140e18c"],

Cell["Formatting:", \
"Text",ExpressionUUID->"fabddcbd-10da-4501-a041-cb365ed393b8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrefixFormatDer", "[", 
    RowBox[{"ParamD", "[", "par_", "]"}], "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<\[PartialD]\>\"", ",", 
     RowBox[{"PrintAs", "[", "par", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrefixFormatDer", "[", "OverDot", "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<\[PartialD]\>\"", ",", "\"\<#\>\""}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"76330745-b619-4a63-9c63-0f73bb2b1a77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrefixFormatDer", "[", 
    RowBox[{"covd_", "?", "HeldCovDQ"}], "]"}], ":=", 
   RowBox[{"Last", "[", 
    RowBox[{"SymbolOfCovD", "[", "covd", "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d9e36ef2-b49c-4ef7-9ee4-7d54ac869cb2"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Commented", " ", 
    RowBox[{"out", ".", " ", "We"}], " ", "typeset", " ", "with", " ", 
    "boxes", " ", "now"}], ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"rather", " ", "than", " ", "with", " ", 
      RowBox[{"strings", ".", "\[IndentingNewLine]", 
       RowBox[{"PrefixFormatDerString", "[", "der_", "]"}]}]}], ":=", 
     RowBox[{"\"\<\\!\\(\\*\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"PrefixFormatDer", "[", "der", "]"}], "]"}], "<>", 
      "\"\<\\)\>\""}]}], ";"}]}], 
  "*)"}]], "Input",ExpressionUUID->"25e9fa2c-5bc7-4f38-869f-d49ed97823cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor_", ",", "ders___"}], "]"}], "]"}], "^:=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"PrefixFormatDer", "/@", 
       RowBox[{"Reverse", "[", 
        RowBox[{"{", "ders", "}"}], "]"}]}], ",", 
      RowBox[{"PrintAs", "[", "tensor", "]"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"85b35187-facf-4eb6-b2e1-fe1fabb141a3"],

Cell["\<\
Other properties.
TODO: Dagger on all derivatives (Lie derivatives for instance).\
\>", "Text",ExpressionUUID->"062d9674-338e-45fb-b873-4b49d9aae81a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor_", ",", "ders__"}], "]"}], "]"}], "^:=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{
     RowBox[{"Dagger", "[", "tensor", "]"}], ",", "ders"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2b5fc9a9-4fcf-4266-848e-7b160abe7d57"],

Cell["\<\
TODO: I now don\[CloseCurlyQuote]t understand what follows. This could \
perhaps be done without going through SymmetryOf, using directly \
CovDSymmetryOf. This is actually wrong, because FromTensorDerivative in \
general will return a sum of objects, and SymmetryOf does not know how to \
find the symmetry of a sum.\
\>", "Text",ExpressionUUID->"2574e175-5a87-43ff-a792-a50f692698ca"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{
     RowBox[{"TensorDerivative", "[", 
      RowBox[{"tensor_", ",", "ders__"}], "]"}], "[", "inds___", "]"}], "]"}],
    "^:=", 
   RowBox[{"JoinSGS", "[", 
    RowBox[{
     RowBox[{"SymmetryGroupOfTensor", "[", "tensor", "]"}], ",", 
     RowBox[{"Apply", "[", 
      RowBox[{"Sequence", ",", 
       RowBox[{"SymDers", "/@", 
        RowBox[{"Split", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "ders", "}"}], ",", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", 
                RowBox[{"{", "ders", "}"}], "]"}], "]"}], "+", 
              RowBox[{"Length", "[", 
               RowBox[{"{", "inds", "}"}], "]"}], "-", 
              RowBox[{"Length", "[", 
               RowBox[{"{", "ders", "}"}], "]"}]}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"First", "[", "#1", "]"}], "===", 
            RowBox[{"First", "[", "#2", "]"}]}], "&"}]}], "]"}]}]}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymDers", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"PD", ",", "n1_"}], "}"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"PD", ",", "_"}], "}"}], "..."}], ",", 
      RowBox[{"{", 
       RowBox[{"PD", ",", "nl_"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"SGSofsym", "@", 
    RowBox[{"Symmetric", "[", 
     RowBox[{"Range", "[", 
      RowBox[{"n1", ",", "nl"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymDers", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", "n1_"}], "}"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"covd_", ",", "_"}], "}"}], "..."}], ",", 
      RowBox[{"{", 
       RowBox[{"covd_", ",", "nl_"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SGSofsym", "@", 
     RowBox[{"Symmetric", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"n1", ",", "nl"}], "]"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"CurvatureQ", "[", "covd", "]"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"TorsionQ", "[", "covd", "]"}]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymDers", "[", "list_", "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1dc5b6a1-a54b-4851-a559-e4cfebb568d2"],

Cell["\<\
Now we define basic properties of a derivative. Note the postfix order.\
\>", "Text",ExpressionUUID->"6cb4be56-b9e5-4da2-a174-8c1dd6709620"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor_", "?", "xTensorQ"}], "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{"tensor", "[", "inds", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{
      RowBox[{"TensorDerivative", "[", 
       RowBox[{"tensor_", ",", "ders1___"}], "]"}], ",", "ders2___"}], "]"}], 
    "[", "inds___", "]"}], ":=", 
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor", ",", "ders1", ",", "ders2"}], "]"}], "[", "inds", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"expr_Plus", ",", "ders___"}], "]"}], "[", "inds___", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"TensorDerivative", "[", 
       RowBox[{"#", ",", "ders"}], "]"}], "[", "inds", "]"}], "&"}], "/@", 
    "expr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"expr_SeriesData", ",", "ders___"}], "]"}], "[", "inds___", 
    "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"TensorDerivative", "[", 
        RowBox[{"#", ",", "ders"}], "]"}], "[", "inds", "]"}], "&"}], ",", 
     "expr"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"036d1351-abfb-4ac2-8691-e61c8f431412"],

Cell["\<\
Conversion to TensorDerivative. This is fast enough to use ReplaceRepeated.\
\>", "Text",ExpressionUUID->"57376116-2247-4703-b615-6ec7d9cf5081"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToTensorDerivative", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", "index_", "]"}], "[", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], "[", "indices___", "]"}], 
        "]"}], "\[RuleDelayed]", 
       RowBox[{"ToTensorDerivative1", "[", 
        RowBox[{
         RowBox[{"covd", "[", "index", "]"}], ",", 
         RowBox[{"tensor", "[", "indices", "]"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], "[", "indices___", "]"}], 
        "]"}], "\[RuleDelayed]", 
       RowBox[{"ToTensorDerivative1", "[", 
        RowBox[{
         RowBox[{"LieD", "[", "v", "]"}], ",", 
         RowBox[{"tensor", "[", "indices", "]"}]}], "]"}]}]}], 
     "\[IndentingNewLine]", "}"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"93a6341a-a0eb-4d2a-9aaa-9acaef6d5770"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToTensorDerivative1", "[", 
    RowBox[{"der_", ",", 
     RowBox[{"tensor_", "[", "indices___", "]"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tslots", "=", 
        RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], ",", 
       RowBox[{"islots", "=", 
        RowBox[{"SignedVBundleOfIndex", "/@", 
         RowBox[{"{", "indices", "}"}]}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "tslots", "]"}], "=!=", 
         RowBox[{"Length", "[", "islots", "]"}]}], ",", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"ToTensorDerivative", "::", "error"}], ",", 
           "\"\<Incompatible number of indices.\>\""}], "]"}]}]}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"TDI", "[", 
         RowBox[{"der", ",", "tensor"}], "]"}], "[", "indices", "]"}], "+", 
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{"MapIndexed", "[", 
          RowBox[{
           RowBox[{"ToTensorDerivativeIndex", "[", 
            RowBox[{"der", ",", 
             RowBox[{"tensor", "[", "indices", "]"}]}], "]"}], ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", "indices", "}"}], ",", "tslots", ",", "islots"}], 
             "}"}], "]"}]}], "]"}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2985d983-3285-4a81-abb2-c670b243ef3a"],

Cell["\<\
The construction of TensorDerivative expressions is funneled through TDI, so \
that the derivative ant the tensor do not see each other before this point:\
\>", "Text",ExpressionUUID->"d1d191d4-68db-49d6-bf1c-57f0035730e1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TDI", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "index_", "]"}], ",", 
      "tensor_"}], "]"}], "[", "indices___", "]"}], ":=", 
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor", ",", "covd"}], "]"}], "[", 
    RowBox[{"indices", ",", "index"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TDI", "[", 
     RowBox[{"der_", ",", "tensor_"}], "]"}], "[", "indices___", "]"}], ":=", 
   
   RowBox[{
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"tensor", ",", "der"}], "]"}], "[", "indices", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dfe5ca72-c332-403b-bb7a-b66146597fc7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"On", " ", "abstract", " ", 
    RowBox[{"indices", ":", " ", 
     RowBox[{"{", 
      RowBox[{"index", ",", " ", 
       RowBox[{"vb", "-", "should", "-", "be"}], ",", " ", 
       RowBox[{"vb", "-", "it", "-", "is"}]}], "}"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_LI", "|", 
          RowBox[{"-", "_LI"}]}], ",", "_", ",", "_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "All", ",", "_Symbol"}], "}"}], 
       ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", 
         RowBox[{"-", "All"}], ",", 
         RowBox[{"-", "_Symbol"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "vb_", ",", "vb_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "All", ",", 
         RowBox[{"-", 
          RowBox[{"vb_", "?", "VBundleQ"}]}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", "dummy"}]}], "]"}], 
        RowBox[{
         RowBox[{"TDI", "[", 
          RowBox[{"der", ",", "metric"}], "]"}], "[", 
         RowBox[{
          RowBox[{"-", "dummy"}], ",", "i"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "vb_", ",", 
         RowBox[{"-", "vb_"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", "dummy"}]}], "]"}], 
        RowBox[{
         RowBox[{"TDI", "[", 
          RowBox[{"der", ",", "metric"}], "]"}], "[", 
         RowBox[{
          RowBox[{"-", "dummy"}], ",", "i"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", 
         RowBox[{"-", "All"}], ",", 
         RowBox[{"vb_", "?", "VBundleQ"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", 
            RowBox[{"-", "dummy"}]}]}], "]"}]}], 
        RowBox[{
         RowBox[{"TDI", "[", 
          RowBox[{"der", ",", "metric"}], "]"}], "[", 
         RowBox[{"dummy", ",", "i"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", 
         RowBox[{"-", "vb_"}], ",", "vb_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", 
            RowBox[{"-", "dummy"}]}]}], "]"}]}], 
        RowBox[{
         RowBox[{"TDI", "[", 
          RowBox[{"der", ",", "metric"}], "]"}], "[", 
         RowBox[{"dummy", ",", "i"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"On", " ", "basis", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"basis_", "?", "BasisQ"}]}], "}"}]}], ",", "vb_", ",", 
         RowBox[{"vb_", "?", "VBundleQ"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", "dummyb"}]}], "]"}], 
        RowBox[{"ReplaceAll", "[", 
         RowBox[{
          RowBox[{"der", "[", 
           RowBox[{"Basis", "[", 
            RowBox[{
             RowBox[{"-", "dummy"}], ",", "i"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"-", "dummy"}], "\[Rule]", 
           RowBox[{"-", "dummyb"}]}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"-", 
             RowBox[{"basis_", "?", "BasisQ"}]}]}], "}"}]}], ",", 
         RowBox[{"-", "vb_"}], ",", 
         RowBox[{"-", 
          RowBox[{"vb_", "?", "VBundleQ"}]}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", 
           RowBox[{"-", "dummyb"}]}]}], "]"}], 
        RowBox[{"ReplaceAll", "[", 
         RowBox[{
          RowBox[{"der", "[", 
           RowBox[{"Basis", "[", 
            RowBox[{"i", ",", "dummy"}], "]"}], "]"}], ",", 
          RowBox[{"dummy", "\[Rule]", "dummyb"}]}], "]"}]}]}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"basis_", "?", "BasisQ"}]}], "}"}]}], ",", 
         RowBox[{"-", "vb_"}], ",", 
         RowBox[{"vb_", "?", "VBundleQ"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", 
           RowBox[{"-", "dummyb"}]}]}], "]"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"TDI", "[", 
             RowBox[{"der", ",", "metric"}], "]"}], "[", 
            RowBox[{"dummyb", ",", "i"}], "]"}]}], "+", 
          RowBox[{"ReplaceAll", "[", 
           RowBox[{
            RowBox[{"der", "[", 
             RowBox[{"Basis", "[", 
              RowBox[{
               RowBox[{"-", "dummy"}], ",", "i"}], "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"-", "dummy"}], "\[Rule]", "dummyb"}]}], "]"}]}], 
         ")"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ToTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"-", 
             RowBox[{"basis_", "?", "BasisQ"}]}]}], "}"}]}], ",", "vb_", ",", 
         
         RowBox[{"-", 
          RowBox[{"vb_", "?", "VBundleQ"}]}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", "dummyb"}]}], "]"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"TDI", "[", 
            RowBox[{"der", ",", "metric"}], "]"}], "[", 
           RowBox[{
            RowBox[{"-", "dummyb"}], ",", "i"}], "]"}], "+", 
          RowBox[{"ReplaceAll", "[", 
           RowBox[{
            RowBox[{"der", "[", 
             RowBox[{"Basis", "[", 
              RowBox[{"i", ",", "dummy"}], "]"}], "]"}], ",", 
            RowBox[{"dummy", "\[Rule]", 
             RowBox[{"-", "dummyb"}]}]}], "]"}]}], ")"}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e9d540e7-a0c2-4605-aa7e-61a7d3136c59"],

Cell["\<\
TODO: When extracting a basis index which is not in its natural position, the \
Christoffel tensor has an index not in its natural position, and that is odd. \
I think this should be changed so that the indices are kept in their original \
positions. The priority must be having \[OpenCurlyDoubleQuote]neat \
Christoffels\[CloseCurlyDoubleQuote].\
\>", "Text",ExpressionUUID->"bc2fe449-e039-4bde-a991-368056387ff9"],

Cell["\<\
Opposite conversion, from TensorDerivative. Again this is fast enough to use \
ReplaceRepeated.\
\>", "Text",ExpressionUUID->"535f53d9-c50a-4abb-86e3-60b6f522c516"],

Cell["\<\
This is wrong. We cannot put together tensor and the indices. We first need \
to construct the ??? TODO\
\>", "Text",ExpressionUUID->"a33a97b9-8be0-44c1-9d1f-32e4c2b409bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FromTensorDerivative", "[", "expr_", "]"}], ":=", 
   RowBox[{"SameDummies", "@", 
    RowBox[{"Expand", "[", 
     RowBox[{"expr", "//.", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"TensorDerivative", "[", 
           RowBox[{"tensor_", ",", "ders___", ",", 
            RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], "[", 
          RowBox[{"inds___", ",", "ind_"}], "]"}], "\[RuleDelayed]", 
         RowBox[{"FromTensorDerivative1", "[", 
          RowBox[{
           RowBox[{"covd", "[", "ind", "]"}], ",", 
           RowBox[{
            RowBox[{"TensorDerivative", "[", 
             RowBox[{"tensor", ",", "ders"}], "]"}], "[", "inds", "]"}]}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"TensorDerivative", "[", 
           RowBox[{"tensor_", ",", "ders___", ",", 
            RowBox[{"LieD", "[", "v_", "]"}]}], "]"}], "[", "inds___", "]"}], 
         "\[RuleDelayed]", 
         RowBox[{"FromTensorDerivative1", "[", 
          RowBox[{
           RowBox[{"LieD", "[", "v", "]"}], ",", 
           RowBox[{
            RowBox[{"TensorDerivative", "[", 
             RowBox[{"tensor", ",", "ders"}], "]"}], "[", "inds", "]"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d23c0870-fba6-43f5-a0b3-c97729c2c8d9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FromTensorDerivative1", "[", 
    RowBox[{"der_", ",", 
     RowBox[{"tensor_", "[", "indices___", "]"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tslots", "=", 
        RowBox[{"SlotsOfTensor", "[", "tensor", "]"}]}], ",", 
       RowBox[{"islots", "=", 
        RowBox[{"SignedVBundleOfIndex", "/@", 
         RowBox[{"{", "indices", "}"}]}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"der", "[", 
       RowBox[{"tensor", "[", "indices", "]"}], "]"}], "+", 
      RowBox[{"Apply", "[", 
       RowBox[{"Plus", ",", 
        RowBox[{"MapIndexed", "[", 
         RowBox[{
          RowBox[{"FromTensorDerivativeIndex", "[", 
           RowBox[{"der", ",", 
            RowBox[{"tensor", "[", "indices", "]"}]}], "]"}], ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "indices", "}"}], ",", "tslots", ",", "islots"}], 
            "}"}], "]"}]}], "]"}]}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"019ff7a6-0a89-484c-afcf-202fdaafb733"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"On", " ", "abstract", " ", "indices"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "vb_", ",", "vb_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "All", ",", "_Symbol"}], "}"}], 
       ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", 
         RowBox[{"-", "All"}], ",", 
         RowBox[{"-", "_Symbol"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", "vb_", ",", 
         RowBox[{"-", "vb_"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", "dummy"}]}], "]"}]}], 
        RowBox[{"der", "[", 
         RowBox[{"metric", "[", 
          RowBox[{
           RowBox[{"-", "dummy"}], ",", "i"}], "]"}], "]"}]}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i_", "?", "AIndexQ"}], ",", 
         RowBox[{"-", "vb_"}], ",", "vb_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"t", ",", 
          RowBox[{"n", "\[RuleDelayed]", 
           RowBox[{"-", "dummy"}]}]}], "]"}], 
        RowBox[{"der", "[", 
         RowBox[{"metric", "[", 
          RowBox[{"dummy", ",", "i"}], "]"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"On", " ", "basis", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"basis_", "?", "BasisQ"}]}], "}"}]}], ",", 
         RowBox[{"vb_", "?", "VBundleQ"}], ",", "vb_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", "dummyb"}]}], "]"}]}], 
        RowBox[{"ReplaceAll", "[", 
         RowBox[{
          RowBox[{"der", "[", 
           RowBox[{"Basis", "[", 
            RowBox[{
             RowBox[{"-", "dummy"}], ",", "i"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"-", "dummy"}], "\[Rule]", 
           RowBox[{"-", "dummyb"}]}]}], "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"-", 
             RowBox[{"basis_", "?", "BasisQ"}]}]}], "}"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"vb_", "?", "VBundleQ"}]}], ",", 
         RowBox[{"-", "vb_"}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", 
            RowBox[{"-", "dummyb"}]}]}], "]"}]}], 
        RowBox[{"ReplaceAll", "[", 
         RowBox[{
          RowBox[{"der", "[", 
           RowBox[{"Basis", "[", 
            RowBox[{"i", ",", "dummy"}], "]"}], "]"}], ",", 
          RowBox[{"dummy", "\[Rule]", "dummyb"}]}], "]"}]}]}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"basis_", "?", "BasisQ"}]}], "}"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"vb_", "?", "VBundleQ"}]}], ",", "vb_"}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}], ",", 
         RowBox[{"dummyc", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", 
            RowBox[{"-", "dummyb"}]}]}], "]"}]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"metric", "[", 
             RowBox[{"dummyb", ",", "dummy"}], "]"}]}], 
           RowBox[{"metric", "[", 
            RowBox[{"i", ",", "dummyc"}], "]"}], 
           RowBox[{"FromTensorDerivative1", "[", 
            RowBox[{"der", ",", 
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"-", "dummy"}], ",", 
               RowBox[{"-", "dummyc"}]}], "]"}]}], "]"}]}], "+", 
          RowBox[{"ReplaceAll", "[", 
           RowBox[{
            RowBox[{"der", "[", 
             RowBox[{"Basis", "[", 
              RowBox[{
               RowBox[{"-", "dummy"}], ",", "i"}], "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"-", "dummy"}], "\[Rule]", "dummyb"}]}], "]"}]}], 
         ")"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FromTensorDerivativeIndex", "[", 
       RowBox[{"der_", ",", "t_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", ":", 
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"-", 
             RowBox[{"basis_", "?", "BasisQ"}]}]}], "}"}]}], ",", "vb_", ",", 
         
         RowBox[{"-", 
          RowBox[{"vb_", "?", "VBundleQ"}]}]}], "}"}], ",", 
       RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"metric", "=", 
          RowBox[{"FirstMetricOfVBundle", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummy", "=", 
          RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
         RowBox[{"dummyb", "=", 
          RowBox[{"DummyIn", "[", 
           RowBox[{"vb", ",", "basis"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"t", ",", 
           RowBox[{"n", "\[RuleDelayed]", "dummyb"}]}], "]"}]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"FromTensorDerivative1", "[", 
           RowBox[{"der", ",", 
            RowBox[{"metric", "[", 
             RowBox[{
              RowBox[{"-", "dummyb"}], ",", "i"}], "]"}]}], "]"}], "+", 
          RowBox[{"ReplaceAll", "[", 
           RowBox[{
            RowBox[{"der", "[", 
             RowBox[{"Basis", "[", 
              RowBox[{"i", ",", "dummy"}], "]"}], "]"}], ",", 
            RowBox[{"dummy", "\[Rule]", 
             RowBox[{"-", "dummyb"}]}]}], "]"}]}], ")"}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"285f04e7-08b9-4b8e-9d74-b1c6bdb6a4fa"],

Cell["\<\
We need a generalization to encode the number of indices of each first \
derivative (recall the 2-index spinor derivatives).\
\>", "Text",ExpressionUUID->"03ba71c4-db84-43ac-b1c9-2856b63ea22f"],

Cell["\<\
TensorD is the action of taking a derivative. It has to be very careful with \
the presence of metrics and bases.\
\>", "Text",ExpressionUUID->"9542b473-a529-4d4c-ba54-7e50792aaa71"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Derivative", " ", "properties"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{"expr_", ",", "der1_", ",", "ders__"}], "]"}], ":=", 
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{"TensorD", "[", 
        RowBox[{"expr", ",", "der1"}], "]"}], ",", "ders"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{"expr_Plus", ",", "der_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"TensorD", "[", 
        RowBox[{"#", ",", "der"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{"expr_SeriesData", ",", "der_"}], "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TensorD", "[", 
         RowBox[{"#", ",", "der"}], "]"}], "&"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Assumes", " ", 
     RowBox[{"Leibnitz", ".", " ", "This"}], " ", "could", " ", "be", " ", 
     "wrong", " ", "for", " ", "induced", " ", "derivatives"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{"expr1_", " ", "expr2_"}], ",", "der_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"TensorD", "[", 
        RowBox[{"expr1", ",", "der"}], "]"}], "expr2"}], "+", 
      RowBox[{"expr1", " ", 
       RowBox[{"TensorD", "[", 
        RowBox[{"expr2", ",", "der"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{"_", "?", "ConstantQ"}], ",", "der_"}], "]"}], ":=", "0"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], ",", 
       "der_"}], "]"}], ":=", 
     RowBox[{"multiD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TensorD", "[", 
         RowBox[{"#", ",", "der"}], "]"}], "&"}], ",", 
       RowBox[{"f", "[", "args", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "der_"}], "]"}], ":=", 
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{"ReplaceDummies", "[", "expr", "]"}], ",", "der"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{"list_List", ",", "der_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"TensorD", "[", 
        RowBox[{"#", ",", "der"}], "]"}], "&"}], "/@", "list"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"On", " ", "particular", " ", "tensors"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TensorD", "[", 
      RowBox[{
       RowBox[{"t", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_", "?", "xTensorQ"}], "[", "__", "]"}], ")"}]}], ",", 
       "der_"}], "]"}], ":=", 
     RowBox[{"ToTensorDerivative1", "[", 
      RowBox[{"der", ",", "t"}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bdf0d073-6d1a-4a88-8a4c-cdf28fdc37c4"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.2.8. PullBackCovD", \
"Subsubsection",ExpressionUUID->"741734de-d2e8-4b4d-98b5-11ae12451423"],

Cell["\<\
This is the pullback connection, and is actually closer to PrecomposeTensor \
than to PullBackTensor, but we follow the standard naming squeme and call \
this a \[OpenCurlyDoubleQuote]pullback connection\[CloseCurlyDoubleQuote]. I \
don\[CloseCurlyQuote]t think there is a concept of pulling back a connection \
CD[-A] on TN to a connection cd[-a] on TM. Only to a connection \
PullBackCovD[CD, phi][-a] on PullBackVBundle[TN, phi].\
\>", "Text",ExpressionUUID->"68333239-ce77-45cd-b9fb-c055810efb42"],

Cell["\<\
The pullback connection allows differentiation of pullback sections, but it \
is not clear to me how to relate that to differentiation of pushforward fields.

With \[Phi]: M -> N and a tensor field T[A, -B] on TN\[TensorProduct]T*N and \
a connection CD[-A] on TN:

\tPullBackCovD[CD, \[Phi]][-a][ Precompose[T, \[Phi]][A*, -B*] ]
\t\t== TensorDerivative[ Precompose[T, \[Phi]], PullBackCovD[CD, \[Phi]] \
][A*, -B*, -a]
\t\t== d\[Phi][-a, C*] Precompose[ TensorDerivative[T, CD], \[Phi] ][A*, -B*, \
-C*]

Hence CD[-A], a connection with vbundles {TN} is pulled back to \
PullBackCovD[CD, \[Phi]][-a], a connection with vbundles {PullBackVBundle[TN, \
\[Phi]]}.

That is exactly the last equation of \
http://en.wikipedia.org/wiki/Pullback_(differential_geometry)#Pullback_of_\
connections_covariant_derivatives . We see that the last step must be given \
in index-free (TensorDerivative) notation.\
\>", "Text",ExpressionUUID->"852b31ac-99af-45aa-8558-d521d0be3f2c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PullBackCovD", "[", 
    RowBox[{
     RowBox[{"covd_", "?", "CovDQ"}], ",", "_IdentityMapping"}], "]"}], ":=", 
   "covd"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1aa01e83-aa24-48a2-83ae-1ebdfb589ae7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Basic", " ", "definitions"}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CovDQ", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VBundlesOfCovD", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeVBundles", "[", 
      RowBox[{
       RowBox[{"BundlesOfCovD", "[", "covd", "]"}], ",", "phi"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DependenciesOfCovD", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeDependencies", "[", 
      RowBox[{
       RowBox[{"DependenciesOfCovD", "[", "covd", "]"}], ",", "phi"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ManifoldOfCovD", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeDependency", "[", 
      RowBox[{
       RowBox[{"ManifoldOfCovD", "[", "covd", "]"}], ",", "phi"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MetricOfCovD", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"MetricOfCovD", "[", "covd", "]"}], ",", "phi"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymbolOfCovD", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#1", ",", 
         RowBox[{"PullBackString", "[", 
          RowBox[{"#2", ",", "phi"}], "]"}]}], "}"}], "&"}], "@@", 
      RowBox[{"SymbolOfCovD", "[", "covd", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"WeightedWithBasis", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"PrecomposeWeight", "[", 
      RowBox[{
       RowBox[{"WeightedWithBasis", "[", "covd", "]"}], ",", "phi"}], "]"}]}],
     ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3d95a54a-1af1-4904-a19c-2d7b355f51da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Declare", " ", "as", " ", "a", " ", "covariant", " ", "derivative"}], " ",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"MakeLinearDerivative", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"PullBackCovD", "[", 
          RowBox[{
           RowBox[{"covd_", "?", "CovDQ"}], ",", 
           RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "[", "a_", "]"}], ",", 
        
        RowBox[{
         RowBox[{"PullBackCovD", "[", 
          RowBox[{"covd", ",", "phi"}], "]"}], "[", "a", "]"}]}], "}"}], ",", 
      "True"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MakeTensorialDerivative", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"PullBackCovD", "[", 
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], ",", 
         RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], ",", 
       RowBox[{"PullBackCovD", "[", 
        RowBox[{"covd", ",", "phi"}], "]"}]}], "}"}], "]"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"33b1c802-b96d-4e39-827f-310e31b8765c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Curvature", ":", " ", 
    RowBox[{"we", " ", "assume", " ", "it", " ", "is", " ", "preserved"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CurvatureQ", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"CurvatureQ", "[", "covd", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TorsionQ", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"TorsionQ", "[", "covd", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Associated", " ", "tensors"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Riemann", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"Riemann", "[", "covd", "]"}], ",", "phi"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Ricci", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"Ricci", "[", "covd", "]"}], ",", "phi"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RicciScalar", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"RicciScalar", "[", "covd", "]"}], ",", "phi"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Einstein", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"Einstein", "[", "covd", "]"}], ",", "phi"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Weyl", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"Weyl", "[", "covd", "]"}], ",", "phi"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TFRicci", "[", 
      RowBox[{"PullBackCovD", "[", 
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], ",", 
        RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "]"}], "^:=", 
     RowBox[{"Precompose", "[", 
      RowBox[{
       RowBox[{"TFRicci", "[", "covd", "]"}], ",", "phi"}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a264042b-391c-4067-99c1-92781564c25c"],

Cell["Formatting.", \
"Text",ExpressionUUID->"8a91984e-0f2e-446c-a2ef-de30da589108"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"PullBackCovD", "[", 
     RowBox[{"covd_", ",", "phi_"}], "]"}], "]"}], "^:=", 
   RowBox[{"PullBackString", "[", 
    RowBox[{
     RowBox[{"PrintAs", "[", "covd", "]"}], ",", "phi"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"87c91020-a472-4f05-88da-2846ac47a140"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["11.3. Validation", \
"Subsection",ExpressionUUID->"235d75a5-598f-47af-9429-c5db5773f9d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ValidateCovD", ",", "HoldFirst"}], "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fba359ab-4ed8-4167-9b65-4d4a4b4c71b9"],

Cell["\<\
Validation of covariant derivatives. When ind is a direction there are \
several functions here using UltraindexOf. I don't think it is worth \
programming a second version of this function only for directions.\
\>", "Text",ExpressionUUID->"1a537a8c-a9cd-497d-ba93-48c6e6f3ce45"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ValidateCovD", "[", 
     RowBox[{"x", ":", 
      RowBox[{
       RowBox[{"der_", "[", "ind_", "]"}], "[", "expr_", "]"}]}], "]"}], ":=", 
    RowBox[{"Catch", "[", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Check", " ", "derivative", " ", "name"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"CovDQ", "[", "der", "]"}]}], ",", 
        RowBox[{"Throw", "[", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"Validate", "::", "unknown"}], ",", 
            "\"\<covariant derivative\>\"", ",", "der"}], "]"}], ";", 
          RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Check", " ", 
        RowBox[{"index", ".", " ", "Patterns"}], " ", "are", " ", "not", " ", 
        "accepted"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"GIndexQ", "[", "ind", "]"}]}], ",", 
        RowBox[{"Throw", "[", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"Validate", "::", "unknown"}], ",", "\"\<g-index\>\"", 
            ",", "ind"}], "]"}], ";", 
          RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Check", " ", "expression"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"UncatchedValidate", "[", 
       RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Check", " ", "that", " ", "derivative", " ", "and", " ", "index", " ",
         "are", " ", "compatible"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"IndexOnQ", "[", 
          RowBox[{"ind", ",", 
           RowBox[{"TangentBundleOfCovD", "[", 
            RowBox[{"der", "[", "ind", "]"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Throw", "[", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"Validate", "::", "invalid"}], ",", "ind", ",", 
            RowBox[{"\"\<index for derivative\>\"", "<>", 
             RowBox[{"ToString", "[", "der", "]"}]}]}], "]"}], ";", 
          RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Check", " ", "that", " ", "there", " ", "is", " ", "a", " ", 
         "metric", " ", "if", " ", "index", " ", "is", " ", "an", " ", "up"}],
         "-", "index"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"UpIndexQ", "[", "ind", "]"}], "&&", 
         RowBox[{"!", 
          RowBox[{"MetricEndowedQ", "[", 
           RowBox[{"VBundleOfIndex", "[", "ind", "]"}], "]"}]}]}], ",", 
        RowBox[{"Throw", "[", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"Validate", "::", "invalid"}], ",", "ind", ",", 
            "\"\<index for a derivative because ther is no metric in its \
vector bundle\>\""}], "]"}], ";", 
          RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "x"}], "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b0b1df7a-c9f7-45d0-a0f1-ae112f742fc6"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.4. Formatting", \
"Subsection",ExpressionUUID->"0e2f8627-2e32-40a8-ac84-f54375b85d33"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"HeldCovDQ", ",", "HoldAllComplete"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeldCovDQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"CovDQ", "[", 
    RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f3213e91-61e5-4267-812b-3b01955d95c8"],

Cell["Driver for the three needed cases.", \
"Text",ExpressionUUID->"62112a64-0d33-4d25-96b8-45fb66efddc7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Prefix\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "CovD", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covd_Symbol", "?", "HeldCovDQ"}], "[", "inds__", "]"}], 
         "[", "expr_", "]"}], ",", "StandardForm"}], "]"}], ":=", 
      RowBox[{"Block", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
        RowBox[{"interpretbox", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"covd", "[", "inds", "]"}], "[", "expr", "]"}], ",", 
          RowBox[{"MakeBoxesCovD", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Unevaluated", "[", "covd", "]"}], "[", "inds", "]"}], 
             "[", 
             RowBox[{"boxof", "@", 
              RowBox[{"BracketizedBoxesIfTimes", "[", 
               RowBox[{"expr", ",", "StandardForm"}], "]"}]}], "]"}], ",", 
            "$CovDFormat"}], "]"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{"CovD", "[", 
         RowBox[{"expr_", ",", "ders__", ",", 
          RowBox[{
           RowBox[{"covd_", "?", "HeldCovDQ"}], "[", "inds__", "]"}]}], "]"}],
         ",", "StandardForm"}], "]"}], ":=", 
      RowBox[{"Block", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
        RowBox[{"interpretbox", "[", 
         RowBox[{
          RowBox[{"CovD", "[", 
           RowBox[{"expr", ",", "ders", ",", 
            RowBox[{"covd", "[", "inds", "]"}]}], "]"}], ",", 
          RowBox[{"MakeBoxesCovD", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Unevaluated", "[", "covd", "]"}], "[", "inds", "]"}], 
             "[", 
             RowBox[{"boxof", "@", 
              RowBox[{"MakeBoxes", "[", 
               RowBox[{
                RowBox[{"CovD", "[", 
                 RowBox[{"expr", ",", "ders"}], "]"}], ",", "StandardForm"}], 
               "]"}]}], "]"}], ",", "$CovDFormat"}], "]"}]}], "]"}]}], 
       "]"}]}], ";", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{"CovD", "[", 
         RowBox[{"expr_", ",", 
          RowBox[{
           RowBox[{"covd_", "?", "HeldCovDQ"}], "[", "inds__", "]"}]}], "]"}],
         ",", "StandardForm"}], "]"}], ":=", 
      RowBox[{"Block", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
        RowBox[{"interpretbox", "[", 
         RowBox[{
          RowBox[{"CovD", "[", 
           RowBox[{"expr", ",", 
            RowBox[{"covd", "[", "inds", "]"}]}], "]"}], ",", 
          RowBox[{"MakeBoxesCovD", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Unevaluated", "[", "covd", "]"}], "[", "inds", "]"}], 
             "[", 
             RowBox[{"boxof", "@", 
              RowBox[{"MakeBoxes", "[", 
               RowBox[{"expr", ",", "StandardForm"}], "]"}]}], "]"}], ",", 
            "$CovDFormat"}], "]"}]}], "]"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "CovD", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covd_Symbol", "?", "HeldCovDQ"}], "[", "inds__", "]"}], 
         "[", "expr_", "]"}], ",", "StandardForm"}], "]"}], "=."}], ";", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{"CovD", "[", 
         RowBox[{"expr_", ",", "ders__", ",", 
          RowBox[{
           RowBox[{"covd_", "?", "HeldCovDQ"}], "[", "inds__", "]"}]}], "]"}],
         ",", "StandardForm"}], "]"}], "=."}], ";", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{"CovD", "[", 
         RowBox[{"expr_", ",", 
          RowBox[{
           RowBox[{"covd_", "?", "HeldCovDQ"}], "[", "inds__", "]"}]}], "]"}],
         ",", "StandardForm"}], "]"}], "=."}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"xTensorFormStart", "[", "CovD", "]"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ec0b0bd9-176b-447f-b713-5b7c481da8c2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"BracketizedBoxesIfTimes", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BracketizedBoxesIfTimes", "[", 
    RowBox[{"expr_Times", ",", "format_"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<[\>\"", ",", 
      RowBox[{"MakeBoxes", "[", 
       RowBox[{"expr", ",", "format"}], "]"}], ",", "\"\<]\>\""}], "}"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BracketizedBoxesIfTimes", "[", 
    RowBox[{"expr_", ",", "format_"}], "]"}], ":=", 
   RowBox[{"MakeBoxes", "[", 
    RowBox[{"expr", ",", "format"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"69ebb3fd-4334-4f72-ad0b-bde6362475f0"],

Cell["\<\
There are two possibilities: Prefix and Postfix notation. Directional \
derivatives are always given in Prefix notation.\
\>", "Text",ExpressionUUID->"b05b2e6e-4aec-4b3d-b8ed-8dffe1d99339"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Non", "-", 
    RowBox[{"directional", " ", "derivatives", " ", "in", " ", "Postfix", " ", 
     RowBox[{"notation", ".", " ", "Handle"}], " ", "both", " ", 
     "SubsuperscriptBox", " ", "and", " ", "GridBox"}]}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "[", 
         RowBox[{"i_", "/;", 
          RowBox[{
           RowBox[{"Head", "[", "i", "]"}], "=!=", "Dir"}]}], "]"}], "[", 
        RowBox[{"SubsuperscriptBox", "[", 
         RowBox[{"head_", ",", "downstr_", ",", "upstr_"}], "]"}], "]"}], 
       ",", "\"\<Postfix\>\""}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
       
       RowBox[{
        RowBox[{
         RowBox[{"SubsuperscriptBox", "[", 
          RowBox[{"head", ",", "#1", ",", "#2"}], "]"}], "&"}], "@@", 
        RowBox[{"AddIndex", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"downstr", ",", "upstr"}], "}"}], ",", "i", ",", "der"}], 
         "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "[", 
         RowBox[{"i_", "/;", 
          RowBox[{
           RowBox[{"Head", "[", "i", "]"}], "=!=", "Dir"}]}], "]"}], "[", 
        "gridbox_GridBox", "]"}], ",", "\"\<Postfix\>\""}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
       
       RowBox[{"ReplacePart", "[", 
        RowBox[{"gridbox", ",", 
         RowBox[{"AppendIndexPair", "[", 
          RowBox[{
           RowBox[{"gridbox", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "]"}], 
            "]"}], ",", 
           RowBox[{"Reverse", "@", 
            RowBox[{"IndexPair", "[", 
             RowBox[{"i", ",", "der"}], "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "}"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", 
     RowBox[{"cases", ":", " ", 
      RowBox[{"Prefix", " ", "notation"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "[", "i_", "]"}], "[", "MBexpr_", "]"}], ",", 
       "str_String"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"FlattenRowBox", "@", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"downQ", "[", "i", "]"}], ",", "SubscriptBox", ",", 
              "SuperscriptBox"}], "]"}], "[", 
            RowBox[{
             RowBox[{"Last", "@", 
              RowBox[{"SymbolOfCovD", "@", "der"}]}], ",", 
             RowBox[{"IndexForm", "@", 
              RowBox[{"UpIndex", "[", "i", "]"}]}]}], "]"}], ",", "MBexpr"}], 
          "}"}], "]"}]}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8d74bc86-714d-4c17-a493-61528a32aaa7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AppendIndexPair", "[", 
    RowBox[{"grid_", ",", "pair_List"}], "]"}], ":=", 
   RowBox[{"Transpose", "@", 
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "grid", "]"}], ",", "pair"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AppendIndexPair", "[", 
    RowBox[{"grid_", ",", "pairs_IndexList"}], "]"}], ":=", 
   RowBox[{"Transpose", "@", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "grid", "]"}], ",", 
      RowBox[{"List", "@@", "pairs"}]}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"144d2f4b-bd83-4635-b6ca-b14f1a430588"],

Cell["\<\
Additional definitions for multiple-indices derivatives. These two lines are \
the only place in this CovD section which allow multiple-index derivatives!\
\>", "Text",ExpressionUUID->"6d0b553d-95dc-4cb9-80c4-85bdfd3ed591"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Postfix", " ", "notation"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "[", "inds__", "]"}], "[", 
        RowBox[{"SubsuperscriptBox", "[", 
         RowBox[{"head_", ",", "downstr_", ",", "upstr_"}], "]"}], "]"}], 
       ",", "\"\<Postfix\>\""}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
       
       RowBox[{
        RowBox[{
         RowBox[{"SubsuperscriptBox", "[", 
          RowBox[{"head", ",", "#1", ",", "#2"}], "]"}], "&"}], "@@", 
        RowBox[{"AddIndex", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"downstr", ",", "upstr"}], "}"}], ",", 
          RowBox[{"IndexList", "[", "inds", "]"}], ",", "der"}], "]"}]}]}], 
      "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "[", 
         RowBox[{"ind_", ",", "inds__"}], "]"}], "[", "gridbox_GridBox", 
        "]"}], ",", "\"\<Postfix\>\""}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"gridbox", ",", 
         RowBox[{"AppendIndexPair", "[", 
          RowBox[{
           RowBox[{"AppendIndexPair", "[", 
            RowBox[{
             RowBox[{"gridbox", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "]"}], 
              "]"}], ",", 
             RowBox[{"Reverse", "@", 
              RowBox[{"IndexPair", "[", 
               RowBox[{"ind", ",", "der"}], "]"}]}]}], "]"}], ",", 
           RowBox[{"Reverse", "/@", 
            RowBox[{"IndexPair", "/@", 
             RowBox[{"IndexList", "[", "inds", "]"}]}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "}"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Prefix", " ", "notation"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "[", "inds__", "]"}], "[", "MBexpr_", "]"}], ",", 
       "\"\<Prefix\>\""}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"FlattenRowBox", "@", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"SubsuperscriptBox", "[", 
              RowBox[{
               RowBox[{"Last", "@", 
                RowBox[{"SymbolOfCovD", "@", "der"}]}], ",", "#1", ",", 
               "#2"}], "]"}], "&"}], "@@", 
            RowBox[{"SSSBinds", "[", 
             RowBox[{"{", "inds", "}"}], "]"}]}], ",", "MBexpr"}], "}"}], 
         "]"}]}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c49ce608-74ab-421e-8d1a-f7cde1061215"],

Cell["\<\
The function FlattenRowBox simply removes one level of RowBox:\
\>", "Text",ExpressionUUID->"c1b4ce3d-8ed5-4543-a8f8-fce328f20828"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FlattenRowBox", "[", 
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"box1_", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", "boxes___", "}"}], "]"}]}], "}"}], "]"}], "]"}], ":=", 
   RowBox[{"RowBox", "[", 
    RowBox[{"{", 
     RowBox[{"box1", ",", "boxes"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FlattenRowBox", "[", "expr_", "]"}], ":=", "expr"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"aa54372e-92cb-4ffe-b5c7-82429d14aaf5"],

Cell["\<\
Note that MakeBoxesCovD returns a box-expression, but Makeboxes returns an \
InterpretationBox expression. That is why there is the First@MakeBoxes in the \
first definition: we want to get the box out of the interpretation-box.\
\>", "Text",ExpressionUUID->"40c654fd-922f-441b-b758-3e4a5aba66ab"],

Cell["\<\
Teake's code (deactivated and not initialized) to typeset with parentheses \
the covariant derivative of a product, if the Leibnitz expansion is \
deactivated:\
\>", "Text",ExpressionUUID->"b82a6472-693b-4812-8138-7c1b05d20506"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"covd_Symbol", "?", "HeldCovDQ"}], "[", "inds__", "]"}], "[", 
      "expr_Times", "]"}], ",", "StandardForm"}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$WarningFrom", "=", "\"\<CovD Formatting\>\""}], "}"}], ",", 
     RowBox[{"xAct`xTensor`Private`interpretbox", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd", "[", "inds", "]"}], "[", "expr", "]"}], ",", 
       RowBox[{"xAct`xTensor`Private`MakeBoxesCovD", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Unevaluated", "[", "covd", "]"}], "[", "inds", "]"}], "[", 
          RowBox[{"xAct`xTensor`Private`boxof", "[", 
           RowBox[{"RowBox", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"StyleBox", "[", "\"\<(\>\"", "]"}], ",", 
              RowBox[{"MakeBoxes", "[", 
               RowBox[{"expr", ",", "StandardForm"}], "]"}], ",", 
              RowBox[{"StyleBox", "[", "\"\<)\>\"", "]"}]}], "}"}], "]"}], 
           "]"}], "]"}], ",", 
         RowBox[{"(*", 
          RowBox[{"Always", " ", "prefix", " ", 
           RowBox[{"notation", ".", "Postfix"}], " ", 
           RowBox[{"doesn", "'"}], "t", " ", "make", " ", "sense", " ", "on", 
           " ", 
           RowBox[{"products", "."}]}], "*)"}], "\"\<Prefix\>\""}], "]"}]}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"f6c0e447-9c59-47fa-bb50-0843df73060f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"cdfe1a6f-f008-439e-9649-3d83489e821f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{"SubscriptBox", "[", 
     RowBox[{
      RowBox[{"ColorString", "[", 
       RowBox[{"\"\<\[EmptyDownTriangle]\>\"", ",", 
        RowBox[{"Hue", "[", "0", "]"}]}], "]"}], ",", 
      RowBox[{"ColorString", "[", 
       RowBox[{"\"\<a\>\"", ",", 
        RowBox[{"Hue", "[", "0.6", "]"}]}], "]"}]}], "]"}], "}"}], "]"}], "//",
   "DisplayForm"}]], \
"Input",ExpressionUUID->"b940780d-55c4-42fe-9e9e-cd821b7863a6"],

Cell[BoxData[
 TagBox[
  SubscriptBox[
   StyleBox["\[EmptyDownTriangle]",
    FontColor->Hue[0.]], 
   StyleBox["a",
    FontColor->Hue[0.6]]],
  DisplayForm]], \
"Output",ExpressionUUID->"8e093630-50d6-4905-b6b2-2f8cb16d74a6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"84c6e4a0-f3bb-4971-ac71-4cc07576f60e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e46b7995-48e8-432f-85d5-3685e1cf9cf7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"95401176-495c-446a-88d0-9f4afb98af71"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"165d887d-09bc-4cc2-bb74-9454159c7b9e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"cf37da5d-ac1b-4c94-81ce-032e1340bdcd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"071a385b-edf4-40a1-9a84-3c54f88372b4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"28eaeabf-dd69-4781-8c9e-0334eee039de"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "Cd", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], 
  ";"}]}], "Input",ExpressionUUID->"82499ad8-73ca-44ff-8d2b-582ec1c7b59a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Postfix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"8e79c8af-3507-4416-8b7b-005f5a18a2ea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"A", ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"1b373aeb-a83e-4f87-a044-3c7eeb67fc5b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, $CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"db46e797-b492-48d9-acc4-a45627a4d95e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToBoxes", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"0ed8ebf8-9fd3-4c0b-985e-21d90072268e"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"GridBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"\<\"T\"\>", ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\<\" \"\>", ",", "\<\" \"\>"}], "}"}]}], "}"}], ",", 
              RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
              RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
              RowBox[{"GridFrameMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"383ed02b-4dd2-46ce-9a8a-7e4513f796e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"First", "[", 
  RowBox[{"First", "[", "%", "]"}], 
  "]"}]], "Input",ExpressionUUID->"7ae41050-9a3d-446a-a720-883898e2bf82"],

Cell[BoxData[
 RowBox[{"GridBox", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"\<\"T\"\>", ",", 
      RowBox[{"StyleBox", "[", 
       RowBox[{
        RowBox[{"GridBox", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\<\" \"\>", ",", "\<\" \"\>"}], "}"}]}], "}"}], ",", 
          RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
          RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
          RowBox[{"GridFrameMargins", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
   RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
   RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], 
  "]"}]], "Output",ExpressionUUID->"5b6b60f3-00ff-401b-8f3b-35e708f041c6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "D"}], "]"}], "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", "B"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"ddef1b3d-b83e-45a0-90f3-09a3ead6014f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", "  "},
         {" ", " ", 
          RowBox[{";", "D"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-D][
   $CellContext`T[$CellContext`A, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"2e115a59-8763-458c-b6a0-4099a0f3fd92"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", "F", "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7c7656f6-c835-4847-9fa3-921932329ccd"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", "  ", 
          RowBox[{";", "F"}]},
         {" ", " ", 
          RowBox[{";", "D"}], "  "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[$CellContext`F][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"7b490a59-a53b-425e-889c-29a772e33740"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ToBoxes"}]], \
"Input",ExpressionUUID->"c2c01801-b81d-41fd-8ea4-9615a00e372c"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"GridBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"\<\"T\"\>", ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 
                 RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>", ",", "\<\"  \"\>", 
                  ",", "\<\";F\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 
                 RowBox[{"\<\" \"\>", ",", "\<\" \"\>", ",", "\<\";D\"\>", 
                  ",", "\<\"  \"\>"}], "}"}]}], "}"}], ",", 
              RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
              RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
              RowBox[{"GridFrameMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B", "  ", 
            RowBox[{";", "F"}]},
           {" ", " ", 
            RowBox[{";", "D"}], "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Cd[$CellContext`F][
     $CellContext`Cd[-D][
      $CellContext`T[$CellContext`A, $CellContext`B]]],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"39a7367f-baf9-44a2-a253-45b719cd29b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "F"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8c3fdcc9-e476-4b7d-803f-45645d840535"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", "  ", "  "},
         {" ", " ", 
          RowBox[{";", "D"}], 
          RowBox[{";", "F"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`F][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"9c6e53f1-ca63-4f1f-9ded-571a9cba349b"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BasisQ", "[", "polar", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"3bb820e8-c3a4-4f03-ac2f-402f625256c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"{", 
    RowBox[{"F", ",", "polar"}], "}"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"a1333861-5966-469e-bc9a-b0db35e19831"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", "  ", 
          RowBox[{";", 
           StyleBox["F",
            FontColor->RGBColor[0., 0., 1.]]}]},
         {" ", " ", 
          RowBox[{";", "D"}], "  "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[{$CellContext`F, $CellContext`polar}][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"f8582ff5-8e76-4f20-a6b5-eee4ac335b18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ToBoxes"}]], \
"Input",ExpressionUUID->"d453c642-6db4-40ac-ba2d-a4539d6e4606"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"GridBox", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"\<\"T\"\>", ",", 
          RowBox[{"StyleBox", "[", 
           RowBox[{
            RowBox[{"GridBox", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 
                 RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>", ",", "\<\"  \"\>", 
                  ",", "\<\";\\!\\(\\*StyleBox[\\\"F\\\",FontColor->RGBColor[\
0., 0., 1.]]\\)\"\>"}], "}"}], ",", 
                RowBox[{"{", 
                 
                 RowBox[{"\<\" \"\>", ",", "\<\" \"\>", ",", "\<\";D\"\>", 
                  ",", "\<\"  \"\>"}], "}"}]}], "}"}], ",", 
              RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
              RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
              RowBox[{"GridFrameMargins", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B", "  ", 
            RowBox[{";", 
             StyleBox["F",
              FontColor->RGBColor[0., 0., 1.]]}]},
           {" ", " ", 
            RowBox[{";", "D"}], "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Cd[{$CellContext`F, $CellContext`polar}][
     $CellContext`Cd[-D][
      $CellContext`T[$CellContext`A, $CellContext`B]]],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"37b4dc0e-ba64-4529-b75d-79e8c349a7ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "polar"}]}], "}"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"cc1fefb9-e6c9-41d4-af89-ed3075b41ccc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", "  ", "  "},
         {" ", " ", 
          RowBox[{";", "D"}], 
          RowBox[{";", 
           StyleBox["F",
            FontColor->RGBColor[0., 0., 1.]]}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[{-$CellContext`F, -$CellContext`polar}][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"0be165c9-adc3-47dd-be23-6b7f76da6b3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"Dir", "[", 
    RowBox[{"T", "[", "Z", "]"}], "]"}], "]"}], "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", "B"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8e9b7329-9a76-4a8c-b9d3-2592a58bdd8b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[PartialD]", "T"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[
   xAct`xTensor`Dir[
    $CellContext`T[$CellContext`Z]]][
   $CellContext`T[$CellContext`A, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"baac54bb-0ae7-4e90-8a87-9ea9bebc770e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ToBoxes"}]], \
"Input",ExpressionUUID->"641d212b-26a8-4779-8fd4-d570c9b9e6a7"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"SubscriptBox", "[", 
         RowBox[{"\<\"\[PartialD]\"\>", ",", "\<\"T\"\>"}], "]"}], ",", 
        RowBox[{"GridBox", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"\<\"T\"\>", ",", 
             RowBox[{"StyleBox", "[", 
              RowBox[{
               RowBox[{"GridBox", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\<\" \"\>", ",", "\<\" \"\>"}], "}"}]}], "}"}], 
                 ",", 
                 RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
                 RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
                 RowBox[{"GridFrameMargins", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
               RowBox[{"FontSize", "\[Rule]", 
                FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
          RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
          RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "T"], GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Cd[
     xAct`xTensor`Dir[
      $CellContext`T[$CellContext`Z]]][
     $CellContext`T[$CellContext`A, $CellContext`B]],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"cc1510d9-2ae0-4bbf-833f-ae0450832dd7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"Dir", "[", 
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], "]"}], "]"}], "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", "B"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"87d652e6-9dad-46d1-ba50-12b3416bdcb0"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SuperscriptBox["\[PartialD]", "T"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[
   xAct`xTensor`Dir[
    $CellContext`T[-$CellContext`A]]][
   $CellContext`T[$CellContext`A, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"a4e3b173-de16-4347-b780-4df425b3e255"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Prefix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"7c7ec8cc-b369-4cd6-a464-0705d542f0d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "F"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e39573a8-1f7b-4da5-9f16-ecacc06cb9fc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[PartialD]", "F"], 
    SubscriptBox["\[PartialD]", "D"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`F][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"97ae3b77-cf18-4f12-9fc8-785f7e375174"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"a99e9e39-aafe-4ec9-898b-bbe0360d9a6f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", "F", "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"35835e7d-c078-44ba-bced-5f9eff4acf0d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SuperscriptBox["\[EmptyDownTriangle]", "F"], 
    SubscriptBox["\[EmptyDownTriangle]", "D"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[$CellContext`F][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"3962d8b5-9c26-41fe-a4db-cfa51ded1df0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"Dir", "[", 
    RowBox[{"T", "[", "Z", "]"}], "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"Dir", "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "Z"}], "]"}], "]"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"47688b6d-4c79-4465-8b83-add7fc5b7e37"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[EmptyDownTriangle]", "T"], 
    SuperscriptBox["\[EmptyDownTriangle]", "T"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[
   xAct`xTensor`Dir[
    $CellContext`T[$CellContext`Z]]][
   $CellContext`Cd[
    xAct`xTensor`Dir[
     $CellContext`T[-$CellContext`Z]]][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"329afbb7-7ce9-4651-adfc-d0636e88a15c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToBoxes", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"196135d4-5e08-4589-b920-2fac03da204b"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"SubscriptBox", "[", 
         RowBox[{"\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"T\"\>"}], "]"}], 
        ",", 
        RowBox[{"SuperscriptBox", "[", 
         RowBox[{"\<\"\[EmptyDownTriangle]\"\>", ",", "\<\"T\"\>"}], "]"}], 
        ",", 
        RowBox[{"GridBox", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"\<\"T\"\>", ",", 
             RowBox[{"StyleBox", "[", 
              RowBox[{
               RowBox[{"GridBox", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\<\" \"\>", ",", "\<\" \"\>"}], "}"}]}], "}"}], 
                 ",", 
                 RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
                 RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
                 RowBox[{"GridFrameMargins", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
               RowBox[{"FontSize", "\[Rule]", 
                FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
          RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
          RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[EmptyDownTriangle]", "T"], 
      SuperscriptBox["\[EmptyDownTriangle]", "T"], GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Cd[
     xAct`xTensor`Dir[
      $CellContext`T[$CellContext`Z]]][
     $CellContext`Cd[
      xAct`xTensor`Dir[
       $CellContext`T[-$CellContext`Z]]][
      $CellContext`T[$CellContext`A, $CellContext`B]]],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"236293a5-fb02-447c-944c-baee27a1adb6"]
}, Open  ]],

Cell["Multiple-index derivative:", \
"Text",ExpressionUUID->"0215ffbc-d168-48ad-82a7-c69a11a5a100"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Prefix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"f6e8b97b-09f3-46c5-9252-98af2dd8ec0b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "F"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", "D"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c32c010b-bac8-4175-b145-2f79b6ac3f66"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[EmptyDownTriangle]", "F"], 
    SubsuperscriptBox["\[EmptyDownTriangle]", "ABC", "   "], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"C", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`F][
   $CellContext`Cd[-$CellContext`A, -$CellContext`B, -C][
    $CellContext`T[C, D]]],
  Editable->
   False]], "Output",ExpressionUUID->"6aac5666-5677-43ca-b448-b0e004316441"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Postfix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"f4cf28e3-78e5-4ca1-84ab-6de82f9719dc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "F"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B", ",", 
     RowBox[{"-", "C"}]}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", "D"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"aa9091b6-7766-4695-8bb1-8ad622222440"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"C", "D", "  ", "B", " ", "  "},
         {" ", " ", 
          RowBox[{";", "A"}], " ", "C", 
          RowBox[{";", "F"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`F][
   $CellContext`Cd[-$CellContext`A, $CellContext`B, -C][
    $CellContext`T[C, D]]],
  Editable->
   False]], "Output",ExpressionUUID->"eca24cac-22a4-4775-91a1-0880780590e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "Cd", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]}], "Input",ExpressionUUID->"19cd5ca4-7dc2-4cb4-9d0e-3a57038f4eb5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"0c37671e-1082-4925-9908-43bb45f84042"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"57de31ac-e567-490a-bee9-346c6f356352"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dd10193d-bdfe-40d0-a47c-097bec73df64"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "Cd", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColorString", "[", 
      RowBox[{"\"\<\[Cedilla]\>\"", ",", 
       RowBox[{"Hue", "[", "0", "]"}]}], "]"}], ",", 
     RowBox[{"ColorString", "[", 
      RowBox[{"\"\<\[EmptyDownTriangle]\>\"", ",", 
       RowBox[{"Hue", "[", "0", "]"}]}], "]"}]}], "}"}]}], 
  ";"}]}], "Input",ExpressionUUID->"44e77298-8f7b-43c7-886f-ffcb89f4e30c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Prefix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"aa9ad1dc-cd5f-457a-87b6-cb3fd5a91ea7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", "F", "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"15a2894c-6878-4038-a3c9-1923a0985465"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SuperscriptBox[
     StyleBox["\[EmptyDownTriangle]",
      FontColor->Hue[0.]], "F"], 
    SubscriptBox[
     StyleBox["\[EmptyDownTriangle]",
      FontColor->Hue[0.]], "D"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[$CellContext`F][
   $CellContext`Cd[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"68005945-d903-4ccf-aad5-310abb3216f9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"{", 
    RowBox[{"F", ",", "polar"}], "}"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "polar"}]}], "}"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"0f7125fe-0864-404e-a3cb-a7539ef15b1d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SuperscriptBox[
     StyleBox["\[EmptyDownTriangle]",
      FontColor->Hue[0.]], 
     StyleBox["F",
      FontColor->RGBColor[0., 0., 1.]]], 
    SubscriptBox[
     StyleBox["\[EmptyDownTriangle]",
      FontColor->Hue[0.]], 
     StyleBox["D",
      FontColor->RGBColor[0., 0., 1.]]], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[{$CellContext`F, $CellContext`polar}][
   $CellContext`Cd[{-D, -$CellContext`polar}][
    $CellContext`T[$CellContext`A, $CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"cb317852-baf7-402d-9325-617b7d522939"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ToBoxes"}]], \
"Input",ExpressionUUID->"804e5fdd-f9c1-4ab3-83e2-c140808af11e"],

Cell[BoxData[
 RowBox[{"InterpretationBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"SuperscriptBox", "[", 
         RowBox[{"\<\"\\!\\(\\*StyleBox[\\\"\[EmptyDownTriangle]\\\",\
FontColor->Hue[0.]]\\)\"\>", 
          ",", "\<\"\\!\\(\\*StyleBox[\\\"F\\\",FontColor->RGBColor[0., 0., \
1.]]\\)\"\>"}], "]"}], ",", 
        RowBox[{"SubscriptBox", "[", 
         RowBox[{"\<\"\\!\\(\\*StyleBox[\\\"\[EmptyDownTriangle]\\\",\
FontColor->Hue[0.]]\\)\"\>", 
          ",", "\<\"\\!\\(\\*StyleBox[\\\"D\\\",FontColor->RGBColor[0., 0., \
1.]]\\)\"\>"}], "]"}], ",", 
        RowBox[{"GridBox", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"\<\"T\"\>", ",", 
             RowBox[{"StyleBox", "[", 
              RowBox[{
               RowBox[{"GridBox", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\<\" \"\>", ",", "\<\" \"\>"}], "}"}]}], "}"}], 
                 ",", 
                 RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
                 RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
                 RowBox[{"GridFrameMargins", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", 
               RowBox[{"FontSize", "\[Rule]", 
                FractionBox["39", "4"]}]}], "]"}]}], "}"}], "}"}], ",", 
          RowBox[{"ColumnSpacings", "\[Rule]", "0.05`"}], ",", 
          RowBox[{"RowAlignments", "\[Rule]", "Center"}]}], "]"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"AutoSpacing", "\[Rule]", "False"}], ",", 
     RowBox[{"ShowAutoStyles", "\[Rule]", "False"}]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[EmptyDownTriangle]",
        FontColor->Hue[0.]], 
       StyleBox["F",
        FontColor->RGBColor[0., 0., 1.]]], 
      SubscriptBox[
       StyleBox["\[EmptyDownTriangle]",
        FontColor->Hue[0.]], 
       StyleBox["D",
        FontColor->RGBColor[0., 0., 1.]]], GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Cd[{$CellContext`F, $CellContext`polar}][
     $CellContext`Cd[{-D, -$CellContext`polar}][
      $CellContext`T[$CellContext`A, $CellContext`B]]],
    Editable->False], ",", 
   RowBox[{"Editable", "\[Rule]", "False"}]}], 
  "]"}]], "Output",ExpressionUUID->"47299ba7-025f-4dda-aca1-b8240ddebf06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"50aeb421-10d6-4de6-a471-ec55754272c2"],

Cell["Cd[{F, polar}][Cd[{-D, -polar}][T[A, B]]]", \
"Output",ExpressionUUID->"7b3bc58b-ad2a-4a82-95ab-09dc6e567947"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Postfix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"596ce08f-c181-4e1e-b2e9-a972ad01a616"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "G"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", "F", "]"}], "[", 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"709ca49e-3e4c-4357-92c0-5f63adcf344c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "B", "  ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], "F"}], "  "},
         {" ", " ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], "D"}], "  ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], "G"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`G][
   $CellContext`Cd[$CellContext`F][
    $CellContext`Cd[-D][
     $CellContext`T[$CellContext`A, $CellContext`B]]]],
  Editable->
   False]], "Output",ExpressionUUID->"ecf1fffb-2f33-4432-8984-c25ce72950f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "polar"}]}], "}"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"{", 
     RowBox[{"D", ",", "polar"}], "}"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"6938cc92-e0ce-4d3a-86db-f5da40199d5a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", " ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], 
           StyleBox["D",
            FontColor->RGBColor[0., 0., 1.]]}], "  "},
         {" ", "B", "  ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], 
           StyleBox["F",
            FontColor->RGBColor[0., 0., 1.]]}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[{-$CellContext`F, -$CellContext`polar}][
   $CellContext`Cd[{D, $CellContext`polar}][
    $CellContext`T[$CellContext`A, -$CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"5ff3b785-61b8-41de-8a1e-26684ec4d139"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "polar"}]}], "}"}], "]"}], "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"{", 
     RowBox[{"D", ",", "polar"}], "}"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A$101", ",", 
     RowBox[{"-", "B"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"2b46c546-5fa5-4ff8-9524-f87ed54af602"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A$101", " ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], 
           StyleBox["D",
            FontColor->RGBColor[0., 0., 1.]]}], "  "},
         {" ", "B", "  ", 
          RowBox[{
           StyleBox["\[Cedilla]",
            FontColor->Hue[0.]], 
           StyleBox["F",
            FontColor->RGBColor[0., 0., 1.]]}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[{-$CellContext`F, -$CellContext`polar}][
   $CellContext`Cd[{D, $CellContext`polar}][
    $CellContext`T[$CellContext`A$101, -$CellContext`B]]],
  Editable->
   False]], "Output",ExpressionUUID->"b6c63528-d527-4dae-b034-06aea4bc7048"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Remove", "[", "polar", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDQ", "[", "Cd", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "Cd", "]"}], "^=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"UndefTensor", "[", "T", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Remove", "[", "Cd", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"8ffa9ea3-6eb7-43d4-9ff1-f28fdf53bc4f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"89d1bb18-d0af-4639-b9f8-dedbea6fe289"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"5404959f-3aa9-42ec-bcf1-fac8ecde4f28"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"1d85cb21-2376-4dfb-8891-cd8c68bfd09a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"52c78c48-0525-4bcd-87c3-449ddde4de2e"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"A$101", ",", "Z"}], 
  "]"}]], "Input",ExpressionUUID->"957ebd5f-40bb-43ee-a81b-ecc36a844555"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"cf8df920-eb0e-4d04-b692-82bf3b72b8c3"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.5. Examples", \
"Subsection",ExpressionUUID->"e6f00683-9661-4335-ab10-4f01b3d77301"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f4ff740b-528d-4b62-be83-8e38c09aa912"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c99fc28a-6835-49d1-9b87-c0ed6dc027bb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b07a10c8-de31-44d9-9c4a-ff98f200edbc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e5c894dd-e4cd-4705-8ad1-149c0f5c1720"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"64444d4b-e1e3-48b2-a31a-10af7ad4d483"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"27453b27-ea47-41c3-a2bf-f022e8813600"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}],
     "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"7a4564f6-5401-493b-adfb-fd3748382641"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7a5a6a93-ed3e-4174-945e-f11413b20020"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dea99478-2f2d-4143-9b2d-d31cc6268feb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"s", "[", "]"}], ",", "S2"}], 
  "]"}]}], "Input",ExpressionUUID->"f29837d6-0d9d-43d6-9a3a-f64695082cc7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1f42fa90-2dae-4103-8fac-893ebbee84ad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"s", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`s[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4407ba3b-7891-4b85-aa84-d674230e7e52"]
}, Open  ]]
}, Open  ]],

Cell["Covariant derivative not associated to any metric:", \
"Text",ExpressionUUID->"9a228952-8e23-4ce8-801b-063329706c7c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}], ",", 
   RowBox[{"Torsion", "\[Rule]", "True"}], ",", 
   RowBox[{"Curvature", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"bd8c4784-7575-49fa-8086-1b8dc62360b0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDT[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"03ca2c89-f6b1-4efa-9386-f66c907867f4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TorsionCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "torsion tensor ", 
   $CellContext`TorsionCDT[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0688c835-dd02-4df4-9302-9a3c40f8db15"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "non-symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDT[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b0e43da4-e4d6-4f84-8236-819db714a588"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Riemann tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RiemannCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Riemann tensor ", 
   $CellContext`RiemannCDT[-$CellContext`A, -$CellContext`B, -C, D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ec535e66-2446-4a79-932d-b68f185a7511"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Ricci tensor ", 
   $CellContext`RicciCDT[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7b4be30b-3079-444d-8667-a2085d84f337"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CDT"}]], "Input",ExpressionUUID->"1ee80c87-e3a6-4dc8-a988-afb43ada3da4"],

Cell[CellGroupData[{

Cell["Global`CDT", "Print", "PrintUsage",
 CellTags->
  "Info3578672798-5338953",ExpressionUUID->"be921866-cf4b-4c28-83ec-\
6c888d4aa6ee"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "CDT", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], 
            "xAct`xTensor`Private`expr$_Plus"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][
           Pattern[xAct`xTensor`Private`expr$, 
            Blank[Plus]]],
          Editable->False], ":=", 
         RowBox[{
          RowBox[{"CDT", "[", "xAct`xTensor`Private`a", "]"}], "/@", 
          "xAct`xTensor`Private`expr$"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], 
            "xAct`xTensor`Private`expr$_SeriesData"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][
           Pattern[xAct`xTensor`Private`expr$, 
            Blank[SeriesData]]],
          Editable->False], ":=", 
         RowBox[{"xAct`xTensor`Private`SeriesDataMap", "[", 
          RowBox[{
           RowBox[{"CDT", "[", "xAct`xTensor`Private`a", "]"}], ",", 
           "xAct`xTensor`Private`expr$"}], "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], "[", 
            RowBox[{
            "xAct`xTensor`Private`x$_", " ", "xAct`xTensor`Private`y$_"}], 
            "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][Pattern[xAct`xTensor`Private`x$, 
             Blank[]] Pattern[xAct`xTensor`Private`y$, 
             Blank[]]],
          Editable->False], ":=", 
         RowBox[{
          RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
              SuperscriptBox["\[PartialD]", "xAct`xTensor`Private`a"], 
              "xAct`xTensor`Private`x$"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CDT[xAct`xTensor`Private`a][xAct`xTensor`Private`x$],
            
            Editable->False], " ", "xAct`xTensor`Private`y$"}], "+", 
          RowBox[{"xAct`xTensor`Private`x$", " ", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SuperscriptBox["\[PartialD]", "xAct`xTensor`Private`a"], 
              "xAct`xTensor`Private`y$"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CDT[xAct`xTensor`Private`a][xAct`xTensor`Private`y$],
            
            Editable->False]}]}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], "_", "?", 
            "ConstantQ"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][
           PatternTest[
            Blank[], xAct`xTensor`ConstantQ]],
          Editable->False], ":=", "0"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], 
            RowBox[{"xAct`xTensor`Private`f$_", "?", "ScalarFunctionQ"}], "[",
             "xAct`xTensor`Private`args$___", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][
           PatternTest[
            Pattern[xAct`xTensor`Private`f$, 
             Blank[]], xAct`xTensor`ScalarFunctionQ][
            Pattern[xAct`xTensor`Private`args$, 
             BlankNullSequence[]]]],
          Editable->False], ":=", 
         RowBox[{"xAct`xTensor`Private`multiD", "[", 
          RowBox[{
           RowBox[{"CDT", "[", "xAct`xTensor`Private`a", "]"}], ",", 
           RowBox[{
           "xAct`xTensor`Private`f$", "[", "xAct`xTensor`Private`args$", 
            "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], 
            StyleBox["(",
             FontColor->RGBColor[1, 0, 0]], "xAct`xTensor`Private`expr$_", 
            StyleBox[")",
             FontColor->RGBColor[1, 0, 0]]}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][
           xAct`xTensor`Scalar[
            Pattern[xAct`xTensor`Private`expr$, 
             Blank[]]]],
          Editable->False], ":=", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", "xAct`xTensor`Private`a"], 
            "ReplaceDummies", "[", "xAct`xTensor`Private`expr$", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[xAct`xTensor`Private`a][
           xAct`xTensor`ReplaceDummies[xAct`xTensor`Private`expr$]],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SuperscriptBox["\[PartialD]", 
             UnderscriptBox["xAct`xTensor`Private`a", "_"]], 
            "xAct`xTensor`Private`list$_List"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]]][
           Pattern[xAct`xTensor`Private`list$, 
            Blank[List]]],
          Editable->False], ":=", 
         RowBox[{
          RowBox[{"CDT", "[", "xAct`xTensor`Private`a", "]"}], "/@", 
          "xAct`xTensor`Private`list$"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[PartialD]", "#"], "xAct`xTensor`Private`expr$_"}],
           
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           xAct`xTensor`Dir[
            Pattern[xAct`xTensor`Private`v$, 
             Blank[Plus]]]][
           Pattern[xAct`xTensor`Private`expr$, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            InterpretationBox[
             StyleBox[
              RowBox[{
               SubscriptBox["\[PartialD]", "#"], 
               "xAct`xTensor`Private`expr$"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CDT[
              xAct`xTensor`Dir[#]][xAct`xTensor`Private`expr$],
             Editable->False], "&"}], ")"}], "/@", 
          "xAct`xTensor`Private`v$"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[PartialD]", "#"], "xAct`xTensor`Private`expr$_"}],
           
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           xAct`xTensor`Dir[
            Pattern[xAct`xTensor`Private`v$, 
             Blank[SeriesData]]]][
           Pattern[xAct`xTensor`Private`expr$, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"xAct`xTensor`Private`SeriesDataMap", "[", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox[
              RowBox[{
               SubscriptBox["\[PartialD]", "#"], 
               "xAct`xTensor`Private`expr$"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CDT[
              xAct`xTensor`Dir[#]][xAct`xTensor`Private`expr$],
             Editable->False], "&"}], ",", "xAct`xTensor`Private`v$"}], 
          "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[PartialD]", "#"], "xAct`xTensor`Private`expr$_"}],
           
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           xAct`xTensor`Dir[Pattern[xAct`xTensor`Private`v$, 
              Blank[]] PatternTest[
              Pattern[xAct`xTensor`Private`x$, 
               Blank[]], xAct`xTensor`ScalarQ]]][
           Pattern[xAct`xTensor`Private`expr$, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"xAct`xTensor`Private`x$", " ", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[PartialD]", "#"], "xAct`xTensor`Private`expr$"}],
            
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CDT[
            xAct`xTensor`Dir[xAct`xTensor`Private`v$]][
           xAct`xTensor`Private`expr$],
           Editable->False]}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[PartialD]", "#"], "xAct`xTensor`Private`expr_"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[
           xAct`xTensor`Dir[0]][
           Pattern[xAct`xTensor`Private`expr, 
            Blank[]]],
          Editable->False], ":=", "0"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[PartialD]", 
             UnderscriptBox[
              UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]], 
            SubscriptBox["\[PartialD]", 
             UnderscriptBox[
              UnderscriptBox["xAct`xTensor`Private`a$", "_"], "_"]], 
            RowBox[{"xAct`xTensor`Private`scalar$_", "?", "xTensorQ"}], "[", 
            "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CDT[-PatternTest[
             Pattern[xAct`xTensor`Private`b$, 
              Blank[]], TangentM2`Q]][
           $CellContext`CDT[-PatternTest[
              Pattern[xAct`xTensor`Private`a$, 
               Blank[]], TangentM2`Q]][
            PatternTest[
             Pattern[xAct`xTensor`Private`scalar$, 
              Blank[]], xAct`xTensor`xTensorQ][]]],
          Editable->False], ":=", 
         RowBox[{
          RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
              SubscriptBox["\[PartialD]", "xAct`xTensor`Private`a$"], 
              SubscriptBox["\[PartialD]", "xAct`xTensor`Private`b$"], 
              "xAct`xTensor`Private`scalar$", "[", "]"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CDT[-xAct`xTensor`Private`a$][
             $CellContext`CDT[-xAct`xTensor`Private`b$][
              xAct`xTensor`Private`scalar$[]]],
            Editable->False], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox[
              SubscriptBox["s", "T"],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xTensor`$TorsionSign,
             Editable->False], " ", 
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"xAct`xTensor`Private`dummy$", "=", 
                RowBox[{"DummyIn", "[", 
                 InterpretationBox[
                  StyleBox["\[DoubleStruckCapitalT]M2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`TangentM2,
                  Editable->False], "]"}]}], "}"}], ",", 
              RowBox[{
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"T", "[", "\[PartialD]", "]"}], 
                    StyleBox[GridBox[{
                    {"xAct`xTensor`Private`dummy$", " ", " "},
                    {" ", "xAct`xTensor`Private`a$", "xAct`xTensor`Private`b$"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TorsionCDT[
                xAct`xTensor`Private`dummy$, -xAct`xTensor`Private`a$, -
                 xAct`xTensor`Private`b$],
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[PartialD]", "xAct`xTensor`Private`dummy$"], 
                  "xAct`xTensor`Private`scalar$", "[", "]"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CDT[-xAct`xTensor`Private`dummy$][
                 xAct`xTensor`Private`scalar$[]],
                Editable->False]}]}], "]"}]}]}], "/;", 
          RowBox[{"$CommuteCovDsOnScalars", "&&", 
           RowBox[{"DisorderedPairQ", "[", 
            RowBox[{
            "xAct`xTensor`Private`a$", ",", "xAct`xTensor`Private`b$"}], 
            "]"}]}]}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"CovDQ", "[", "CDT", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{"CDT", "/:", 
         RowBox[{"CurvatureQ", "[", 
          RowBox[{"CDT", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "]"}], "=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "CDT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"covariant derivative\"\>", ",", "\<\"\"\>"}], 
          "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfCovD", "[", "CDT", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "CDT", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldOfCovD", "[", "CDT", "]"}], "^=", "M2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricOfCovD", "[", "CDT", "]"}], "^=", "Null"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "CDT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
          "TorsionCDT", ",", "ChristoffelCDT", ",", "RiemannCDT", ",", 
           "RicciCDT"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymbolOfCovD", "[", "CDT", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"|\"\>", ",", "\<\"\[PartialD]\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TorsionQ", "[", "CDT", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundlesOfCovD", "[", "CDT", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"WeightedWithBasis", "[", "CDT", "]"}], "^=", "Null"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`CDT],
  Editable->False]], "Print",
 CellTags->
  "Info3578672798-5338953",ExpressionUUID->"c78d514f-6ded-4b88-b994-\
b9b4900e9129"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "CDT", 
  "]"}]], "Input",ExpressionUUID->"c08a545f-8e34-4d0f-aa43-14372580f7da"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDT],
  Editable->
   False]], "Print",ExpressionUUID->"c4465bd9-7718-4b2b-8fc0-b6b17586e8c5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci tensor", 
   " ", $CellContext`RicciCDT],
  Editable->
   False]], "Print",ExpressionUUID->"ed29fe32-1bbb-4748-a049-0e4c906c5643"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDT],
  Editable->
   False]], "Print",ExpressionUUID->"114fea1d-553b-4847-949b-907302e1887f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDT],
  Editable->
   False]], "Print",ExpressionUUID->"f9c70b19-fa5d-4f2d-bca1-bd0585ec29d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDT],
  Editable->
   False]], "Print",ExpressionUUID->"7042e108-cebd-44ea-ab64-11f6d8839c1a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}], ",", 
   RowBox[{"Torsion", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"96c0a6ab-0a18-4594-8782-7e7cb4b486ae"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDT[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"367b108d-a03a-4382-84bd-1f8b433f1e53"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TorsionCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "torsion tensor ", 
   $CellContext`TorsionCDT[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0c2290bb-c306-4983-aea6-fce096245351"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "non-symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDT[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6cdcc8a6-988f-4eb3-b7a0-f9a88db87e8d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDT[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"c6e3258a-001b-4b41-ba67-5773416e0cd4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCDT[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c7a21cbb-8172-4568-aa4a-7c5ef316e02c"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"aa456173-a9df-4441-8f6f-c0529aefdcd8"]
}, Open  ]]
}, Open  ]],

Cell["Covariant derivative not associated to any metric:", \
"Text",ExpressionUUID->"c07e0a27-80c6-4412-a2db-8666ffeba940"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"e274e5f6-b55f-4bcf-bdae-59245e288849"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d08510b8-53c2-45b9-9a43-c3e59765295c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0c3c95c3-8126-44f7-8656-fca6b8b89409"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d152a7bc-5596-4d01-a162-4f779a45af5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDM[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"aacf3291-8ed7-4367-aeb4-4c7fbc8f8aa3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e05b973c-a346-4116-bbf0-9daa9e4588b8"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"7a79d2d4-cab0-4f3f-81ac-a085681d398d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCurvature", "[", 
   RowBox[{
    RowBox[{"RiemannCDM", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}], ",", "D"}], "]"}], ",", "CDM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"fac51182-445d-4471-bf75-2a9d706685c1"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "R"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RiemannSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "B", "F"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDM[D, -$CellContext`B, -$CellContext`F],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
          StyleBox[GridBox[{
             {"F", " ", " "},
             {" ", "A", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "A", "F"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDM[D, -$CellContext`A, -$CellContext`F],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
          StyleBox[GridBox[{
             {"F", " ", " "},
             {" ", "B", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -C],
      Editable->False]}], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
         StyleBox[GridBox[{
            {"D", " ", " ", "  "},
            {" ", "B", "C", 
             RowBox[{",", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`A][
      $CellContext`ChristoffelCDM[D, -$CellContext`B, -C]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
         StyleBox[GridBox[{
            {"D", " ", " ", "  "},
            {" ", "A", "C", 
             RowBox[{",", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`B][
      $CellContext`ChristoffelCDM[D, -$CellContext`A, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"53e34216-8af4-466f-8947-6311c91fd078"]
}, Open  ]],

Cell["\<\
Covariant derivative associated to a metric g. Note that because the manifold \
has dimension 2 the Einstein and Weyl tensors vanish:\
\>", "Text",ExpressionUUID->"47cb3ce7-bc8e-4855-99c4-b37d672c2a9e"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"TangentM2", ",", "metricg"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], "^=", 
   RowBox[{"{", "metricg", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricQ", "[", "metricg", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xATP`FrozenMetricQ", "[", "metricg", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InducedFrom", "[", "metricg", "]"}], "^=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"TangentM2", ",", "metricg"}], "]"}], 
  ";"}]}], "Input",ExpressionUUID->"3b50ed35-99af-4897-90f0-163ce62ef9b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"15e8547b-6bff-4c88-8b39-d0d68a641d76"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDN", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<#\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"FromMetric", "\[Rule]", "metricg"}]}], 
  "]"}]], "Input",ExpressionUUID->"eae4bb7a-191d-4575-bf2e-56c8f493f9cf"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDN", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDN[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4cef0179-59f8-4764-842c-bfe631312ebe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDN", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDN[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"beda2160-d4a9-402c-a5d1-af54d8088129"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDN", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDN[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0d4cf45c-b150-44f3-b794-693f2c64e83c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDN", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDN[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"f17729d0-cfa0-4bcd-a66c-3b4cd9230816"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDN", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCDN[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c6911453-9d28-487f-ba01-c1f4ba0dc435"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"5fcd9555-bff4-445b-8f52-1c9e32303193"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCDN", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCDN[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6286a11c-c18a-4c56-954b-fc6997dd0322"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"13953c78-9235-4613-9416-a7e42bd972a2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCDN", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCDN[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f17584dd-2fd0-413c-9192-90825479241d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCDN", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCDN[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6176e04b-0fe8-44af-8d8a-200fa3eb1227"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCDN", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCDN[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"076d589d-db07-4e8e-b7b2-446b2cd1ce96"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCDN", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCDN[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"200dafa1-dff4-4b45-b0f5-58dd4a9ec64a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"5c3b9cf8-8da5-4160-987c-98daaddcc12c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"fb9dfaac-199f-4cc8-bbdf-2676b821bc70"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"b17495f2-90c6-490a-bc25-eff3c4f34a2e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EinsteinCDN", "[", 
  RowBox[{"A", ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"c0ff6744-5780-4a65-a3f7-56c07319e25e"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"bb7da531-2923-4511-9164-3734d404f5f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeylCDN", "[", 
  RowBox[{"A", ",", "B", ",", "C", ",", "D"}], 
  "]"}]], "Input",ExpressionUUID->"3456507f-2560-4708-a585-1e4976cd6e28"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"3caffda8-0045-4bae-b7d3-839f3a284cdb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RiemannCDN", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}], ",", "A", ",", 
    RowBox[{"-", "C"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"f6976961-19f7-4535-8a3b-43fa029492e9"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "r"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RicciSign,
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "A"},
          {"B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`B, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "D"},
          {"C", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RicciCDN[-$CellContext`A, -D],
   Editable->
    False]}]], "Output",ExpressionUUID->"35b40e5a-d52d-4f67-8505-be2f37545a43"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RiemannCDN", "[", 
   RowBox[{"A", ",", "B", ",", 
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"c9f37c47-ff2a-470c-a014-ab7a5e331d74"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "r"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RicciSign,
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", "C"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`RicciCDN[-$CellContext`B, -C],
   Editable->False], " ", 
  RowBox[{
  "xAct`xTensor`Private`SymmetryOfMetric", "[", "metricg", 
   "]"}]}]], "Output",ExpressionUUID->"797aaa22-9d7c-4442-8e3b-2637a87236e9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`RicciToEinsteinRules", "[", "CDN", 
  "]"}]], "Input",ExpressionUUID->"a4553a75-d9dd-4d58-b011-e60be871c43a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
          StyleBox[GridBox[{
             {
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"]},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`RicciCDN[
       Pattern[$CellContext`A, 
        Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"ContractMetric", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {"A", "B"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[$CellContext`A, $CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`RicciScalarCDN[],
         Editable->False]}], "]"}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
          StyleBox[GridBox[{
             {
              UnderscriptBox["A", "_"], " "},
             {" ", 
              UnderscriptBox["B", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`RicciCDN[
       Pattern[$CellContext`A, 
        Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"ContractMetric", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {"A", "G$214396"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[$CellContext`A, $CellContext`G$214396],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {" ", " "},
                {"G$214396", "B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[-$CellContext`G$214396, -$CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`RicciScalarCDN[],
         Editable->False]}], "]"}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
          StyleBox[GridBox[{
             {" ", 
              UnderscriptBox["B", "_"]},
             {
              UnderscriptBox["A", "_"], " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`RicciCDN[-Pattern[$CellContext`A, 
         Blank[Symbol]], 
       Pattern[$CellContext`B, 
        Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"ContractMetric", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {" ", " "},
                {"G$214395", "A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[-$CellContext`G$214395, -$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {"G$214395", "B"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[$CellContext`G$214395, $CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`RicciScalarCDN[],
         Editable->False]}], "]"}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
          StyleBox[GridBox[{
             {" ", " "},
             {
              UnderscriptBox["A", "_"], 
              UnderscriptBox["B", "_"]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`RicciCDN[-Pattern[$CellContext`A, 
         Blank[Symbol]], -Pattern[$CellContext`B, 
         Blank[Symbol]]],
      Editable->False], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"ContractMetric", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {" ", " "},
                {"G$214395", "A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[-$CellContext`G$214395, -$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {"G$214395", "G$214397"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[$CellContext`G$214395, $CellContext`G$214397],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {" ", " "},
                {"G$214397", "B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`metricg[-$CellContext`G$214397, -$CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[
          RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`RicciScalarCDN[],
         Editable->False]}], "]"}]}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"f4fdc1d6-af52-4ef7-abdd-762a0dadb2b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`RiemannToWeylRules", "[", "CDN", 
  "]"}]], "Input",ExpressionUUID->"e487461f-5cb1-4f4e-bfba-9f6ca6149592"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
         StyleBox[GridBox[{
            {
             UnderscriptBox[
              UnderscriptBox["A", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["B", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["C", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["D", "_"], "_"]},
            {" ", " ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RiemannCDN[
      PatternTest[
       Pattern[$CellContext`A, 
        Blank[]], TangentM2`pmQ], 
      PatternTest[
       Pattern[$CellContext`B, 
        Blank[]], TangentM2`pmQ], 
      PatternTest[
       Pattern[C, 
        Blank[]], TangentM2`pmQ], 
      PatternTest[
       Pattern[D, 
        Blank[]], TangentM2`pmQ]],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"ContractMetric", "[", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       InterpretationBox[
        StyleBox[
         SubscriptBox["s", "r"],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`$RicciSign,
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", "A"},
               {"G$214375", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`G$214375, $CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", "B"},
               {"G$214376", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`G$214376, $CellContext`B],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"g", 
                StyleBox[GridBox[{
                   {"G$214375", "G$214378"},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metricg[$CellContext`G$214375, $CellContext`G$214378],
            Editable->False]}], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {"G$214376", "G$214377"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`metricg[$CellContext`G$214376, $CellContext`G$214377],
           
           Editable->False]}], "+", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {"G$214375", "G$214377"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`metricg[$CellContext`G$214375, $CellContext`G$214377],
           
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {"G$214376", "G$214378"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`metricg[$CellContext`G$214376, $CellContext`G$214378],
           
           Editable->False]}]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", "C"},
               {"G$214377", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`G$214377, C],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", "D"},
               {"G$214378", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`G$214378, D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[
         RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`RicciScalarCDN[],
        Editable->False]}], "]"}]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"1a9b3b77-dbc7-41bc-98e8-8dc1cb555484"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RicciCDN", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], "]"}], "//", 
  "RicciToEinstein"}]], \
"Input",ExpressionUUID->"9b7d15cd-d144-4110-a709-2fbec301d5b3"],

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " "},
           {"G$214395", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[-$CellContext`G$214395, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"G$214395", "G$214397"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[$CellContext`G$214395, $CellContext`G$214397],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " "},
           {"G$214397", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[-$CellContext`G$214397, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciScalarCDN[],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"742a71e4-4243-430a-8e86-4c3ddd0ad0e6"]
}, Open  ]],

Cell[TextData[{
 "Note that ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " detects that the index of the derivative does not belong to the manifold \
of the metric:"
}], "Text",ExpressionUUID->"2aaf26a7-a3a8-405a-b325-adad0de8d061"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CCD", "[", 
    RowBox[{"-", "p"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<#\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"FromMetric", "\[Rule]", "metricg"}]}], 
  "]"}]], "Input",ExpressionUUID->"d7de59cb-d821-4007-a5c4-affdcf500528"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"VBundleOfIndex", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"index\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(p\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"14dfa874-3c11-42c7-9c0d-318e8c5fe4a3"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefCovD", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"covariant abstract-index\\\"\\)\[NoBreak] is \
not a valid \[NoBreak]\\!\\(-p\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"73a6b82c-717f-445c-b199-c4287a764037"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"CCD", ",", "p"}], 
  "]"}]], "Input",ExpressionUUID->"dc614caf-4b0c-4ed4-95ee-f60583a78f39"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"Com", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<%\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}], ",", 
   RowBox[{"Curvature", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"75612ba1-6b37-4fa3-854d-1b7c8a4f6437"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"Com", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`Com[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0496c57a-8727-41ae-80ae-35a2a38c728f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCom", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCom[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9ae315ea-c1ed-4d70-95d0-116e22ab63e9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCom", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCom[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c91ef045-eaf0-4bb9-bc5a-93c17af3c9fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Riemann tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RiemannCom", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Riemann tensor ", 
   $CellContext`RiemannCom[-$CellContext`A, -$CellContext`B, -C, D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"fe9bcf26-26af-43f7-b784-3a656002eb11"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCom", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Ricci tensor ", 
   $CellContext`RicciCom[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b3bffa12-9bf7-4515-9594-978f61225df1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDS", "[", 
    RowBox[{"-", "a"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<:\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"92b63eed-6d52-469a-a634-37f91195f542"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDS", "[", 
    RowBox[{"-", "a"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDS[-$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"59f11365-cae3-45a0-8226-424fcaac2a52"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDS[$CellContext`a, -$CellContext`b, -$CellContext`c], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1af9a38f-09ee-4701-a12a-d7c9ccf954cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDS[$CellContext`a, -$CellContext`b, \
-$CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8de0b763-eb7b-4b93-a9f0-bac252bbb5d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", "d"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
$CellContext`d], ". ", "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"dea85df9-d1b3-4a8e-b799-e84fd7337ed9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCDS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bc890f04-67d8-4807-83b3-6992ce40b399"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"a4f29b93-fdf6-4df1-905f-d80889f43ff6"]
}, Open  ]]
}, Open  ]],

Cell["\<\
The issue of commutativity of derivatives. Is it working? What happens here \
with s[]?\
\>", "Text",ExpressionUUID->"56b423da-4405-4ebd-a175-f990a14ed7dc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "B"}], "]"}], "[", 
  RowBox[{
   RowBox[{"r", "[", "C", "]"}], "+", 
   RowBox[{"s", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"95b5648c-a124-4a7f-879f-3a98adbafaf6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"r", 
       StyleBox[GridBox[{
          {"C", "  "},
          {" ", 
           RowBox[{"|", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`B][
    $CellContext`r[C]],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "B"], "s"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`B][
    $CellContext`s[]],
   Editable->
    False]}]], "Output",ExpressionUUID->"e7a15234-48d0-4ff6-aa36-e14add15c1b5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "A"}], "]"}], "[", "%", 
  "]"}]], "Input",ExpressionUUID->"d3e6188d-658c-477f-961e-a71cbd57dc4f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"r", 
       StyleBox[GridBox[{
          {"C", "  ", "  "},
          {" ", 
           RowBox[{"|", "B"}], 
           RowBox[{"|", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`A][
    $CellContext`CDM[-$CellContext`B][
     $CellContext`r[C]]],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "A"], 
     SubscriptBox["\[PartialD]", "B"], "s"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`A][
    $CellContext`CDM[-$CellContext`B][
     $CellContext`s[]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"a9b725fa-6dd1-409e-b57c-4e2c27adb2ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{
  "CDM", "\[Rule]", 
   "Com"}]}]], "Input",ExpressionUUID->"c7be3a23-cd58-466c-8867-4b25d2a91555"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"r", 
       StyleBox[GridBox[{
          {"C", "  ", "  "},
          {" ", 
           RowBox[{"%", "B"}], 
           RowBox[{"%", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Com[-$CellContext`A][
    $CellContext`Com[-$CellContext`B][
     $CellContext`r[C]]],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "A"], 
     SubscriptBox["\[PartialD]", "B"], "s"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Com[-$CellContext`A][
    $CellContext`Com[-$CellContext`B][
     $CellContext`s[]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"89f0144a-661b-4007-8550-9526bc8904cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SortCovDs", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"314624c2-58f8-41e5-aa01-a6e7c54193f0"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"r", 
       StyleBox[GridBox[{
          {"C", "  ", "  "},
          {" ", 
           RowBox[{"%", "A"}], 
           RowBox[{"%", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Com[-$CellContext`B][
    $CellContext`Com[-$CellContext`A][
     $CellContext`r[C]]],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "B"], 
     SubscriptBox["\[PartialD]", "A"], "s"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Com[-$CellContext`B][
    $CellContext`Com[-$CellContext`A][
     $CellContext`s[]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"31c24a28-7c76-464c-a21e-19bbf0bae57a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckZeroDerivative", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"0c77e209-70ca-4be2-a2c7-4b9b26d452f3"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"r", 
      StyleBox[GridBox[{
         {"C", "  ", "  "},
         {" ", 
          RowBox[{"%", "A"}], 
          RowBox[{"%", "B"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Com[-$CellContext`B][
   $CellContext`Com[-$CellContext`A][
    $CellContext`r[C]]],
  Editable->
   False]], "Output",ExpressionUUID->"8f56c5b7-bb04-4537-8382-507c3f7dfc34"]
}, Open  ]],

Cell["More general:", \
"Text",ExpressionUUID->"452404d8-850d-402f-a71e-cdb0758deb30"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"3e846301-3c2d-4048-8b46-2ad14d0a3b71"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b89d0b3e-f5da-423d-8dd9-fa0e64b9232a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDT", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{"T", "[", "]"}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"695a287d-491a-4ab2-b4ed-485db14ca90e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[PartialD]", "A"], 
    SubscriptBox["\[PartialD]", "B"], "T"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDT[-$CellContext`A][
   $CellContext`CDT[-$CellContext`B][
    $CellContext`T[]]],
  Editable->
   False]], "Output",ExpressionUUID->"5d003e53-f8e4-44f5-a364-5b8104c5553f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CDT", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDT", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", "D"}], "]"}], "]"}], "]"}], "//", 
   "SortCovDs"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"3a8062f2-e761-4440-9104-a5587e379308"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "D"},
              {"B", "A", "F", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDT[-$CellContext`B, -$CellContext`A, \
-$CellContext`F, D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", "F"},
              {"C", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, $CellContext`F],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "F"},
              {"B", "A", "C", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDT[-$CellContext`B, -$CellContext`A, -
        C, $CellContext`F],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", "D"},
              {"F", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`F, D],
       Editable->False]}]}], ")"}]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "D", "  ", "  "},
          {"C", " ", 
           RowBox[{"|", "A"}], 
           RowBox[{"|", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDT[-$CellContext`B][
    $CellContext`CDT[-$CellContext`A][
     $CellContext`T[-C, D]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "T"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$TorsionSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"T", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionCDT[$CellContext`F, -$CellContext`B, -$CellContext`A],
    
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "D", "  "},
           {"C", " ", 
            RowBox[{"|", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDT[-$CellContext`F][
     $CellContext`T[-C, D]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"18f09729-3474-4b48-8650-e10824181c30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CDT", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDT", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"T", "[", "A", "]"}], "]"}], "]"}], "-", 
    RowBox[{
     RowBox[{"CDT", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDT", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"T", "[", "A", "]"}], "]"}], "]"}]}], "//", "SortCovDs"}], "//",
   "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"ff7ded74-fb02-4771-a432-5fcf2a4f4199"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " ", "A"},
           {"D", "C", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDT[-D, -C, -$CellContext`B, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "T"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$TorsionSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"T", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionCDT[$CellContext`B, -D, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{"|", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDT[-$CellContext`B][
     $CellContext`T[$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"5b182838-ee45-4897-a623-75ccdfe66750"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Postfix\>\""}], 
  ";"}]], "Input",ExpressionUUID->"335f2714-084c-4aec-a507-421ce6e22c6f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", 
     RowBox[{"-", "D"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"58e36a82-8575-44b4-a6d6-faf3629d8a65"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"C", " ", "  ", "  "},
         {" ", "D", 
          RowBox[{"|", "B"}], 
          RowBox[{"|", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDM[-$CellContext`A][
   $CellContext`CDM[-$CellContext`B][
    $CellContext`T[C, -D]]],
  Editable->
   False]], "Output",ExpressionUUID->"fbc64ba6-3149-4e65-943c-ad32ae87561f"]
}, Open  ]],

Cell["\<\
Note that the first index cannot be reversed because it is upstairs:\
\>", "Text",ExpressionUUID->"466399e4-4ea3-436a-a1c4-9a2fcc617ad1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", "A", "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "C"}], "]"}], "[", 
    RowBox[{"T", "[", "C", "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"2db20c63-c3bc-42bf-8147-d6de592e2d4e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"C", "  ", "  ", 
          RowBox[{",", "A"}]},
         {" ", 
          RowBox[{",", "C"}], 
          RowBox[{",", "A"}], "  "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[$CellContext`A][
   xAct`xTensor`PD[-$CellContext`A][
    xAct`xTensor`PD[-C][
     $CellContext`T[C]]]],
  Editable->
   False]], "Output",ExpressionUUID->"72265cbd-de17-40d8-8d2c-2e9a8b85004f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "c"}], "]"}], "[", 
    RowBox[{"T", "[", "C", "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"53082ffb-9da7-4bfa-b02d-9290176349ed"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"C", "  ", "  ", "  "},
         {" ", 
          RowBox[{",", "c"}], 
          RowBox[{",", "a"}], 
          RowBox[{",", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[-$CellContext`A][
   xAct`xTensor`PD[-$CellContext`a][
    xAct`xTensor`PD[-$CellContext`c][
     $CellContext`T[C]]]],
  Editable->
   False]], "Output",ExpressionUUID->"f5d878c1-90db-425c-b878-ddc7707bf9f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "C"}], "]"}], "[", 
  RowBox[{"Cos", "[", 
   RowBox[{
    RowBox[{"Sin", "[", 
     RowBox[{"r", "[", "]"}], "]"}], "^", "2"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"bec44283-9593-4853-9a63-82774627612d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", 
  RowBox[{
   InterpretationBox[
    StyleBox["Cos",
     ShowAutoStyles->False,
     AutoSpacing->False],
    Cos,
    Editable->False], "[", 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "]"}], " ", 
  RowBox[{
   InterpretationBox[
    StyleBox["Sin",
     ShowAutoStyles->False,
     AutoSpacing->False],
    Sin,
    Editable->False], "[", 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "]"}], " ", 
  RowBox[{
   InterpretationBox[
    StyleBox["Sin",
     ShowAutoStyles->False,
     AutoSpacing->False],
    Sin,
    Editable->False], "[", 
   SuperscriptBox[
    RowBox[{
     InterpretationBox[
      StyleBox["Sin",
       ShowAutoStyles->False,
       AutoSpacing->False],
      Sin,
      Editable->False], "[", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "]"}], "2"], "]"}], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "C"], "r"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-C][
    $CellContext`r[]],
   Editable->
    False]}]], "Output",ExpressionUUID->"c2a408c0-66d0-46b0-9a3f-195a117197cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", "ff", 
  "]"}]], "Input",ExpressionUUID->"c46636fd-a74c-4d00-be3d-f4ea82124c37"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefScalarFunction", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"scalar function \"\>", "\[InvisibleSpace]", "ff",
    "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefScalarFunction, ": Defining ", 
   "scalar function ", $CellContext`ff, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"28ab019b-2a51-4409-a44c-9b9a93c3147b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "C"}], "]"}], "[", 
  RowBox[{"ff", "[", 
   RowBox[{
    RowBox[{"r", "[", "]"}], ",", 
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], ",", 
    RowBox[{"T", "[", "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c5096e02-5e15-4f3f-935c-9754bb36536e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "C"], "T"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`T[]],
    Editable->False], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["ff",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ff,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox["T",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "C"], "r"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`r[]],
    Editable->False], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["ff",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ff,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox["T",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "C"], "r"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`r[]],
    Editable->False], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["ff",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ff,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox["T",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[],
      Editable->False]}], 
    "]"}]}]}]], \
"Output",ExpressionUUID->"e541885d-7ec6-427f-b48e-581a253750a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", "ff", 
  "]"}]], "Input",ExpressionUUID->"3ce87349-064c-43ec-b812-2ba1021c8909"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefScalarFunction", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"scalar function\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["ff",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ff,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefScalarFunction, ": Undefined ", "scalar function", 
   " ", $CellContext`ff],
  Editable->
   False]], "Print",ExpressionUUID->"722fc56a-7dce-450a-a7df-8016554e5959"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "C"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}], "]"}], "]"}], "-", 
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "C"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"r", "[", "]"}], "]"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"c8982c93-851f-4363-b810-0b20b8436384"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "C"], 
     SubscriptBox["\[PartialD]", "A"], 
     SubscriptBox["\[PartialD]", "B"], "r"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-C][
    $CellContext`CDM[-$CellContext`A][
     $CellContext`CDM[-$CellContext`B][
      $CellContext`r[]]]],
   Editable->False], "-", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "C"], 
     SubscriptBox["\[PartialD]", "B"], 
     SubscriptBox["\[PartialD]", "A"], "r"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-C][
    $CellContext`CDM[-$CellContext`B][
     $CellContext`CDM[-$CellContext`A][
      $CellContext`r[]]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"de8976cd-ba1e-4046-bab8-458c199c1a3e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDS", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"T", "[", "A", "]"}], 
  "]"}]], "Input",ExpressionUUID->"f03d5d1e-e27a-49ae-8707-b30f453e4300"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "  "},
         {" ", 
          RowBox[{":", "a"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDS[-$CellContext`a][
   $CellContext`T[$CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"a18d5b71-7466-4c41-817f-769f7586f01e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckZeroDerivative", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"839262a6-edc7-4f40-b2b7-2862c3ec445d"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"b6249303-a5e2-4450-97e5-51e1950602bd"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"CheckZeroDerivativeStart", "[", "CDS", 
  "]"}]], "Input",ExpressionUUID->"fde365dd-cafb-4051-9779-5a5add208903"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDS", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"T", "[", "A", "]"}], 
  "]"}]], "Input",ExpressionUUID->"50c442bb-7716-4525-bb74-b36d5beeffde"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"cb76fe58-d625-4794-af92-69b3fa591258"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"CheckZeroDerivativeStop", "[", "CDS", 
  "]"}]], "Input",ExpressionUUID->"4ac10336-1fe6-4386-ae6b-e20bcb0fb65d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDS", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"T", "[", "A", "]"}], 
  "]"}]], "Input",ExpressionUUID->"8d4a08b0-86a4-4044-bfbb-181eda214b29"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", "  "},
         {" ", 
          RowBox[{":", "a"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDS[-$CellContext`a][
   $CellContext`T[$CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"f8ea957b-57f3-47ba-a3fe-3bcba17475ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7a068230-f655-4979-ab80-b55eab273d53"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", " ", "  ", "  "},
         {"C", "D", 
          RowBox[{"|", "B"}], 
          RowBox[{"|", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDM[-$CellContext`A][
   $CellContext`CDM[-$CellContext`B][
    $CellContext`T[-C, -D]]],
  Editable->
   False]], "Output",ExpressionUUID->"c0043bd8-f086-469a-8380-42598801cda4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SortCovDs", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "B"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "C"}], ",", 
        RowBox[{"-", "D"}]}], "]"}], "]"}], "]"}], ",", "CDM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"325e1c05-34c4-4850-ba22-3074e5ee6673"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"R", "[", "\[PartialD]", "]"}], 
            StyleBox[GridBox[{
               {" ", " ", " ", "F"},
               {"B", "A", "D", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`RiemannCDM[-$CellContext`B, -$CellContext`A, -
         D, $CellContext`F],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "F"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -$CellContext`F],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "F"},
              {"B", "A", "C", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-$CellContext`B, -$CellContext`A, -
        C, $CellContext`F],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"F", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`F, -D],
       Editable->False]}]}], ")"}]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", "  ", "  "},
          {"C", "D", 
           RowBox[{"|", "A"}], 
           RowBox[{"|", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`B][
    $CellContext`CDM[-$CellContext`A][
     $CellContext`T[-C, -D]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"da7733ed-1baa-4b9a-86c1-cf76a5eea102"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "D"}], ",", 
        RowBox[{"-", "F"}]}], "]"}], "]"}], "]"}], "]"}], "//", "SortCovDs"}],
   "//", "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"b7707527-214e-4527-a0e7-1c20db78740e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " "},
               {"G", "F"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`G, -$CellContext`F],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G", "  "},
              {"C", "A", "D", " ", 
               RowBox[{"|", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`B][
        $CellContext`RiemannCDM[-C, -$CellContext`A, -D, $CellContext`G]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"D", "G"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-D, -$CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G", "  "},
              {"C", "A", "F", " ", 
               RowBox[{"|", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`B][
        $CellContext`RiemannCDM[-
         C, -$CellContext`A, -$CellContext`F, $CellContext`G]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G"},
              {"C", "A", "F", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-
        C, -$CellContext`A, -$CellContext`F, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"D", "G", 
               RowBox[{"|", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`B][
        $CellContext`T[-D, -$CellContext`G]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G"},
              {"C", "A", "D", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-C, -$CellContext`A, -D, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"G", "F", 
               RowBox[{"|", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`B][
        $CellContext`T[-$CellContext`G, -$CellContext`F]],
       Editable->False]}]}], ")"}]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", "  ", "  ", "  "},
          {"D", "F", 
           RowBox[{"|", "A"}], 
           RowBox[{"|", "B"}], 
           RowBox[{"|", "C"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-C][
    $CellContext`CDM[-$CellContext`B][
     $CellContext`CDM[-$CellContext`A][
      $CellContext`T[-D, -$CellContext`F]]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"R", "[", "\[PartialD]", "]"}], 
            StyleBox[GridBox[{
               {" ", " ", " ", "G"},
               {"B", "A", "F", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`RiemannCDM[-$CellContext`B, -$CellContext`A, \
-$CellContext`F, $CellContext`G],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"D", "G", 
               RowBox[{"|", "C"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-C][
        $CellContext`T[-D, -$CellContext`G]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G"},
              {"B", "A", "D", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-$CellContext`B, -$CellContext`A, -
        D, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"G", "F", 
               RowBox[{"|", "C"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-C][
        $CellContext`T[-$CellContext`G, -$CellContext`F]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G"},
              {"B", "A", "C", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-$CellContext`B, -$CellContext`A, -
        C, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"D", "F", 
               RowBox[{"|", "G"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`G][
        $CellContext`T[-D, -$CellContext`F]],
       Editable->False]}]}], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"R", "[", "\[PartialD]", "]"}], 
            StyleBox[GridBox[{
               {" ", " ", " ", "G"},
               {"C", "B", "F", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`RiemannCDM[-
         C, -$CellContext`B, -$CellContext`F, $CellContext`G],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"D", "G", 
               RowBox[{"|", "A"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`A][
        $CellContext`T[-D, -$CellContext`G]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G"},
              {"C", "B", "D", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-C, -$CellContext`B, -D, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"G", "F", 
               RowBox[{"|", "A"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`A][
        $CellContext`T[-$CellContext`G, -$CellContext`F]],
       Editable->False]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"R", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {" ", " ", " ", "G"},
              {"C", "B", "A", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`RiemannCDM[-
        C, -$CellContext`B, -$CellContext`A, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"D", "F", 
               RowBox[{"|", "G"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`G][
        $CellContext`T[-D, -$CellContext`F]],
       Editable->False]}]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"df89dafc-0a50-4fff-b04e-c2a391a728e0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RiemannToChristoffel", "[", 
   RowBox[{
    RowBox[{"SortCovDs", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"CDM", "[", 
        RowBox[{"-", "A"}], "]"}], "[", 
       RowBox[{
        RowBox[{"CDM", "[", 
         RowBox[{"-", "B"}], "]"}], "[", 
        RowBox[{"T", "[", 
         RowBox[{
          RowBox[{"-", "C"}], ",", 
          RowBox[{"-", "D"}]}], "]"}], "]"}], "]"}], ",", "CDM"}], "]"}], ",",
     "CDM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"452807bf-4dba-4926-b736-448795f14775"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", "  ", "  "},
          {"C", "D", 
           RowBox[{"|", "A"}], 
           RowBox[{"|", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`B][
    $CellContext`CDM[-$CellContext`A][
     $CellContext`T[-C, -D]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[
         SubscriptBox["s", "R"],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`$RiemannSign,
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"F", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`F, -D],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox[GridBox[{
              {
               RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
               StyleBox[GridBox[{
                  {"F", " ", " "},
                  {" ", "B", "G1"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, \
-$CellContext`G1],
           Editable->False]}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {
              RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
              StyleBox[GridBox[{
                 {"G1", " ", " "},
                 {" ", "A", "C"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`ChristoffelCDM[$CellContext`G1, -$CellContext`A, -C],
          Editable->False]}], "+", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {
              RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
              StyleBox[GridBox[{
                 {"F", " ", " "},
                 {" ", "A", "G1"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`G1],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {
              RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
              StyleBox[GridBox[{
                 {"G1", " ", " "},
                 {" ", "B", "C"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`ChristoffelCDM[$CellContext`G1, -$CellContext`B, -C],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
             StyleBox[GridBox[{
                {"F", " ", " ", "  "},
                {" ", "B", "C", 
                 RowBox[{",", "A"}]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xTensor`PD[-$CellContext`A][
          $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -C]],
         Editable->False], "-", 
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
             StyleBox[GridBox[{
                {"F", " ", " ", "  "},
                {" ", "A", "C", 
                 RowBox[{",", "B"}]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xTensor`PD[-$CellContext`B][
          $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C]],
         Editable->False]}], ")"}]}], "-", 
     RowBox[{
      InterpretationBox[
       StyleBox[
        SubscriptBox["s", "R"],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`$RiemannSign,
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "F"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -$CellContext`F],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox[GridBox[{
              {
               RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
               StyleBox[GridBox[{
                  {"F", " ", " "},
                  {" ", "B", "G"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, \
-$CellContext`G],
           Editable->False]}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {
              RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
              StyleBox[GridBox[{
                 {"G", " ", " "},
                 {" ", "A", "D"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`ChristoffelCDM[$CellContext`G, -$CellContext`A, -D],
          Editable->False]}], "+", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {
              RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
              StyleBox[GridBox[{
                 {"F", " ", " "},
                 {" ", "A", "G"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`G],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {
              RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
              StyleBox[GridBox[{
                 {"G", " ", " "},
                 {" ", "B", "D"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`ChristoffelCDM[$CellContext`G, -$CellContext`B, -D],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
             StyleBox[GridBox[{
                {"F", " ", " ", "  "},
                {" ", "B", "D", 
                 RowBox[{",", "A"}]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xTensor`PD[-$CellContext`A][
          $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -D]],
         Editable->False], "-", 
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
             StyleBox[GridBox[{
                {"F", " ", " ", "  "},
                {" ", "A", "D", 
                 RowBox[{",", "B"}]}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xTensor`PD[-$CellContext`B][
          $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -D]],
         Editable->False]}], ")"}]}]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"f9fe14bd-98d6-4a1e-8b59-af3107aed0cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"-", "a"}], "]"}], ",", "S2"}], 
  "]"}]], "Input",ExpressionUUID->"93b9ce95-a12d-4232-b9ad-c5f0c5ce06c1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"-", "a"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[-$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ce90b5be-a213-4b4a-ad22-1b6b0801da5c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDN", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"S", "[", 
   RowBox[{"-", "a"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"71e08057-25dc-4409-ae0f-47c20a440b89"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {" ", "  "},
         {"a", 
          RowBox[{"#", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDN[-$CellContext`A][
   $CellContext`S[-$CellContext`a]],
  Editable->
   False]], "Output",ExpressionUUID->"c2412a7d-16bf-4c2b-a676-37357722c6cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckZeroDerivative", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"64518827-17e5-4cc7-b0a2-481db6d5ce16"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"a3d6d0bb-52b9-45dc-aaaa-380d8eb9533a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"9151490d-da4f-4076-8279-519e1a3f2910"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "r", ",", "s", ",", "TorsionCDT", ",", "ChristoffelCDT", ",", "RiemannCDT", 
   ",", "RicciCDT", ",", "TorsionCDM", ",", "ChristoffelCDM", ",", 
   "RiemannCDM", ",", "RicciCDM", ",", "metricg", ",", "TorsionCDN", ",", 
   "ChristoffelCDN", ",", "RiemannCDN", ",", "RicciCDN", ",", 
   "RicciScalarCDN", ",", "EinsteinCDN", ",", "WeylCDN", ",", "TFRicciCDN", 
   ",", "KretschmannCDN", ",", "TorsionCom", ",", "ChristoffelCom", ",", 
   "RiemannCom", ",", "RicciCom", ",", "TorsionCDS", ",", "ChristoffelCDS", 
   ",", "RiemannCDS", ",", "RicciCDS", ",", "T", ",", "S"}], 
  "}"}]], "Output",ExpressionUUID->"1b577fbd-c987-4b3c-aa27-18c6f57f989f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"5852592a-723b-4277-bf4c-8c956917e215"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b08bdd72-8c4b-473f-9512-8123e54ed137"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TracePrint", "[", 
  RowBox[{
   RowBox[{"xATP`ValidateCovD", "[", 
    RowBox[{
     RowBox[{"CDN", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"A", ",", 
        RowBox[{"-", "B"}]}], "]"}], "+", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", 
        RowBox[{"-", "B"}]}], "]"}]}], "]"}], "]"}], ",", 
   RowBox[{"xATP`UncatchedValidate", "[", "_", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"dc3f847f-d4f8-49c3-84c1-e5ddc42ee9d5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"   ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{"Unevaluated", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", " "},
               {" ", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, -$CellContext`B],
        Editable->False], "+", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", " "},
               {" ", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, -$CellContext`B],
        Editable->False]}], "]"}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[3], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     Unevaluated[$CellContext`T[$CellContext`A, -$CellContext`B] + \
$CellContext`T[$CellContext`A, -$CellContext`B]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"39caf1f0-e92e-4a29-9483-c34e23fb4202"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"   ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"A", " "},
              {" ", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`A, -$CellContext`B],
       Editable->False], "+", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"A", " "},
              {" ", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`A, -$CellContext`B],
       Editable->False]}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[3], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[$CellContext`T[$CellContext`A, \
-$CellContext`B] + $CellContext`T[$CellContext`A, -$CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"b217267d-07f0-4729-aaf7-40665d3cbe48"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"   ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{"Unevaluated", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", " "},
               {" ", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, -$CellContext`B],
        Editable->False], "+", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", " "},
               {" ", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, -$CellContext`B],
        Editable->False]}], "]"}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[3], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     Unevaluated[$CellContext`T[$CellContext`A, -$CellContext`B] + \
$CellContext`T[$CellContext`A, -$CellContext`B]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"d7a24fda-5e65-4205-8377-f10914a52b9a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"2", " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", " ", "  "},
          {" ", "B", 
           RowBox[{"#", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDN[-$CellContext`A][
    $CellContext`T[$CellContext`A, -$CellContext`B]],
   Editable->
    False]}]], "Output",ExpressionUUID->"6524aa18-f4b0-41a0-9d96-d912499b9775"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"u", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"efcea8d2-3d0b-4f98-b091-690136534be2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"u", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`u[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"96bb0511-2cc6-4cef-ad3f-df7ee363b9ad"]
}, Open  ]],

Cell["\<\
The messages here are spurious, due to the fact the ContractMetric has not \
been defined yet, and so ContractMetric[0] and 0 are not recognized as equal.\
\
\>", "Text",ExpressionUUID->"121f0263-97f2-46bb-ae7c-8852befa35d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefCovD", "[", 
   RowBox[{
    RowBox[{"cd", "[", 
     RowBox[{"-", "A"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<*\>\"", ",", "\"\<D\>\""}], "}"}], ",", 
    RowBox[{"OrthogonalTo", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"u", "[", "A", "]"}], "}"}]}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2d8ae96b-50e3-4db1-bbae-cd498996f6d5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7b7f4870-4e01-47c9-974c-1898c3020627"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"First", "::", "first"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\({}\\)\[NoBreak] has a length of zero and no first \
element. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\
\", ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/First/first\\\", \
ButtonNote -> \\\"First::first\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"79d4d593-6c97-46e8-9c66-243496aa4568"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Torsioncd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`Torsioncd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dad61a07-918c-4bbf-80e1-c4f16f03c94d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Christoffelcd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`Christoffelcd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"b882ca48-0da3-468f-b98a-9948cee55fc0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "noorth"}], "MessageName"], ":", 
  " ", "\<\"Tensor \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\\\
\"\[CapitalGamma][D]\\\", StyleBox[GridBox[{{\\\"A\\\", \\\" \\\", \\\" \
\\\"}, {\\\" \\\", \\\"B\\\", \\\"C\\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], Christoffelcd[A, Times[-1, B], \
Times[-1, C]], Rule[Editable, False]]\\)\[NoBreak] could not be made \
orthogonal to vector \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\
\\\"u\\\", StyleBox[GridBox[{{\\\" \\\"}, {\\\"A\\\"}}, RowSpacings -> 0, \
ColumnSpacings -> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, \
Rational[39, 4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], u[Times[-1, A]], \
Rule[Editable, False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"11bc01d3-d54d-4480-b689-554e4a5be208"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "noorth"}], "MessageName"], ":", 
  " ", "\<\"Tensor \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\\\
\"\[CapitalGamma][D]\\\", StyleBox[GridBox[{{\\\"A\\\", \\\" \\\", \\\" \
\\\"}, {\\\" \\\", \\\"B\\\", \\\"C\\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], Christoffelcd[A, Times[-1, B], \
Times[-1, C]], Rule[Editable, False]]\\)\[NoBreak] could not be made \
orthogonal to vector \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\
\\\"u\\\", StyleBox[GridBox[{{\\\"B\\\"}, {\\\" \\\"}}, RowSpacings -> 0, \
ColumnSpacings -> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, \
Rational[39, 4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], u[B], Rule[Editable, \
False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"3f5c7788-1ab8-4f84-87ba-caa25c7b3214"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefTensor", "::", "noorth"}], "MessageName"], ":", 
  " ", "\<\"Tensor \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\\\
\"\[CapitalGamma][D]\\\", StyleBox[GridBox[{{\\\"A\\\", \\\" \\\", \\\" \
\\\"}, {\\\" \\\", \\\"B\\\", \\\"C\\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], Christoffelcd[A, Times[-1, B], \
Times[-1, C]], Rule[Editable, False]]\\)\[NoBreak] could not be made \
orthogonal to vector \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\
\\\"u\\\", StyleBox[GridBox[{{\\\"C\\\"}, {\\\" \\\"}}, RowSpacings -> 0, \
ColumnSpacings -> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, \
Rational[39, 4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], u[C], Rule[Editable, \
False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"de76a042-7bcc-4549-82a4-3a8e174919ed"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(DefTensor :: \
noorth\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"00a07428-acb2-4445-b2f8-ce01e296fa67"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Riemanncd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`Riemanncd[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"abed40c9-c3c6-46d8-99c1-e2d7ba223ac5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Riccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`Riccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e8c7841b-4e39-4866-b59e-8359797b7ca2"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"24f67d94-d90d-4071-bbb3-d00ee7dc4797"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefCovD", "/@", 
   RowBox[{"{", 
    RowBox[{"cd", ",", "CDT", ",", "CDN"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"e5de08c0-77e5-44c6-b223-a0d862621e4a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Christoffelcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`Christoffelcd],
  Editable->
   False]], "Print",ExpressionUUID->"14dcf1b4-46d6-4841-9727-f3b28fb3cd5a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`Riccicd],
  Editable->
   False]], "Print",ExpressionUUID->"7d5065e9-07d8-4a79-bd08-06be2ef72db4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riemanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`Riemanncd],
  Editable->
   False]], "Print",ExpressionUUID->"47d3d4f5-b2c6-4aa6-b660-bb901b5356dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Torsioncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`Torsioncd],
  Editable->
   False]], "Print",ExpressionUUID->"3ce29b04-1bb9-4cf3-8fd5-a10690071328"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`cd],
  Editable->
   False]], "Print",ExpressionUUID->"f196c277-e092-413b-b45b-82e7875994eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDT],
  Editable->
   False]], "Print",ExpressionUUID->"e803ac32-0ae3-46cf-b7cc-9bc87699b54e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCDT],
  Editable->
   False]], "Print",ExpressionUUID->"842aff92-2466-4536-9009-92f07097454b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDT],
  Editable->
   False]], "Print",ExpressionUUID->"64065eae-fe92-434f-aa4f-3c35f39687c5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDT],
  Editable->
   False]], "Print",ExpressionUUID->"afb2b7ef-85f3-4d8a-9978-8fbfdae32ecb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDT],
  Editable->
   False]], "Print",ExpressionUUID->"9e30aafa-f4f3-4064-80c9-7f954fffb44f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDN],
  Editable->
   False]], "Print",ExpressionUUID->"f90afbc2-f8be-4ac9-aafe-958d7e365ac1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCDN],
  Editable->
   False]], "Print",ExpressionUUID->"eed4ad6e-077d-466a-8f12-521d5b0d0a1e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCDN],
  Editable->
   False]], "Print",ExpressionUUID->"867b4369-6ac5-4572-98b9-34e36bb79216"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCDN],
  Editable->
   False]], "Print",ExpressionUUID->"5a058b79-e547-404e-8626-bd05460ee25a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCDN],
  Editable->
   False]], "Print",ExpressionUUID->"c470d887-b3e9-4289-b561-390771f91023"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDN],
  Editable->
   False]], "Print",ExpressionUUID->"b045a23b-2a81-45c1-97e2-017cb02f9fef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCDN],
  Editable->
   False]], "Print",ExpressionUUID->"f7d73713-8276-44b7-badd-8ea5db4832c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDN],
  Editable->
   False]], "Print",ExpressionUUID->"da6381cd-29bd-409a-aa12-86cf754c4c6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCDN],
  Editable->
   False]], "Print",ExpressionUUID->"bbeccc93-bd87-4907-b0fb-e8458e729108"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDN"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDN],
  Editable->
   False]], "Print",ExpressionUUID->"8718941e-26a2-453d-b014-355a6cf47f6d"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "TangentM2", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], "^=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TangentM2", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"27557a26-ea39-4c08-8ada-2e3fd5563a98"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "metricg", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricQ", "[", "metricg", "]"}], "^=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"UndefTensor", "[", "metricg", 
  "]"}]}], "Input",ExpressionUUID->"44008a87-6a94-4bdc-8e49-e519c5d40548"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"84581db2-3a01-43c6-870c-1434c5b6ab3a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"S", ",", "u", ",", "v", ",", "s", ",", "T", ",", "r"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"56393eec-93b9-43c3-84f8-850a06730992"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"23170272-387d-4597-a0e5-208b998706e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "u"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`u],
  Editable->
   False]], "Print",ExpressionUUID->"4ba9de0c-70a8-4119-9785-b9735d304d4a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"0b2d1de7-7031-427d-9392-75c17bd51926"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "s"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`s],
  Editable->
   False]], "Print",ExpressionUUID->"8c46afc2-95f1-43f7-8023-bffe6e117b1e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"0ff856a8-f554-4558-ba8c-f14bd8666032"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"e0a73d47-c389-47d3-807f-28df28ffedd8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$CovDs"], \
"Input",ExpressionUUID->"95714b40-4719-4c1b-ac88-5dd31dca977e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"PD", ",", "CDM", ",", "Com", ",", "CDS"}], 
  "}"}]], "Output",ExpressionUUID->"cf859e0b-ae76-45fd-a03d-4e2a20a0d224"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"65b6e317-2ba8-40b5-a3da-cd6dcef113a0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Mass", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Mass, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"694d8e1a-f4fc-4237-ba96-e911f5f2c142"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"3", "Mass"}], 
  "]"}]], "Input",ExpressionUUID->"fbfa6cfb-f548-49c9-921d-8696673fd59f"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"898cb983-a75e-4aff-9fa8-7c5fa4a6047c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDM", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"5", "+", "Mass"}], 
  "]"}]], "Input",ExpressionUUID->"692314ca-50de-4a4c-a7fa-e8a09df58848"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"fe07a9bd-d1ba-4f2a-8547-d9fcc3283b7f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"0b39ef35-102c-4ecd-83f2-228abef960d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Mass",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Mass],
  Editable->
   False]], "Print",ExpressionUUID->"01ee7516-79ad-4770-8274-420f7bd83bb3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "c"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4d202fa2-7f1a-409c-9921-c35d9f301258"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "c"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, $CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"084f1037-c2e7-4faa-9a3c-b37dfb1720bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", "B"}], "]"}], "]"}], ",", "CDM"}], "]"}], "//",
   "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"0ffffc98-64c3-41bb-a704-81b5ec2fa73d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`B, -C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "D"},
           {"A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, D],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"D", " ", " "},
           {" ", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[D, -C, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B"},
           {"D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-D, $CellContext`B],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B", "  "},
          {"A", " ", 
           RowBox[{",", "C"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-C][
    $CellContext`T[-$CellContext`A, $CellContext`B]],
   Editable->
    False]}]], "Output",ExpressionUUID->"5a4c82fb-e5cf-4a73-905a-c30f4d18a344"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CDM", "[", "A", "]"}], "[", 
      RowBox[{"T", "[", "]"}], "]"}], 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "A"}], "]"}], "[", 
      RowBox[{"T", "[", "B", "]"}], "]"}]}], ",", "CDM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"8812b287-688c-4a3e-849a-70616beb7e6a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
          StyleBox[GridBox[{
             {"B", " ", " "},
             {" ", "A", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDM[$CellContext`B, -$CellContext`A, -C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"C"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[C],
      Editable->False]}], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "  "},
            {" ", 
             RowBox[{",", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`A][
      $CellContext`T[$CellContext`B]],
     Editable->False]}], ")"}], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SuperscriptBox["\[PartialD]", "A"], "T"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[$CellContext`A][
    $CellContext`T[]],
   Editable->
    False]}]], "Output",ExpressionUUID->"e08d162a-31e1-4f61-8650-fc89e69194b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CDM", "[", "A", "]"}], "[", 
      RowBox[{"T", "[", "]"}], "]"}], 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "A"}], "]"}], "[", 
      RowBox[{"T", "[", "B", "]"}], "]"}]}], ",", "CDM", ",", "Com"}], "]"}], 
  "//", "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"8c9f675b-2aa5-48ba-a9ee-dd5a068170df"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDMCom", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ChristoffelCDMCom[$CellContext`A, -$CellContext`B, -C], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"38ede588-c65f-4576-811d-25816f2b7c3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           RowBox[{"\[PartialD]", 
            RowBox[{",", "\[PartialD]"}]}], "]"}], 
          StyleBox[GridBox[{
             {"B", " ", " "},
             {" ", "A", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDMCom[$CellContext`B, -$CellContext`A, -C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"C"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[C],
      Editable->False]}], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "  "},
            {" ", 
             RowBox[{"%", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Com[-$CellContext`A][
      $CellContext`T[$CellContext`B]],
     Editable->False]}], ")"}], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SuperscriptBox["\[PartialD]", "A"], "T"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Com[$CellContext`A][
    $CellContext`T[]],
   Editable->
    False]}]], "Output",ExpressionUUID->"20e37ceb-a6be-4355-a716-acb61cea3db6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "A"}], "]"}], "[", 
      RowBox[{"T", "[", "B", "]"}], "]"}], "]"}], ",", "CDM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"73c3de1b-79b1-4a4b-9c7a-9b2880d777d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`F],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {"F", " ", " "},
              {" ", "A", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"D"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[D],
       Editable->False]}], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"F", "  "},
             {" ", 
              RowBox[{",", "A"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`A][
       $CellContext`T[$CellContext`F]],
      Editable->False]}], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " ", "  "},
           {" ", "A", "D", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`ChristoffelCDM[$CellContext`B, -$CellContext`A, -D]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`B, -$CellContext`A, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D", "  "},
           {" ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`T[D]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "  ", "  "},
          {" ", 
           RowBox[{",", "A"}], 
           RowBox[{",", "C"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-C][
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[$CellContext`B]]],
   Editable->False], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -C, -$CellContext`A],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
           StyleBox[GridBox[{
              {"B", " ", " "},
              {" ", "F", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDM[$CellContext`B, -$CellContext`F, -D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"D"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[D],
       Editable->False]}], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"B", "  "},
             {" ", 
              RowBox[{",", "F"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`F][
       $CellContext`T[$CellContext`B]],
      Editable->False]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"8a5a167d-6cf5-4cac-b1f5-6fc64cad5eb6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", "A"}], "]"}], "]"}], ",", "CDM"}], "]"}], "//",
   "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"906db651-ce15-43e6-a235-dd842d4c597a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", "A", "  "},
         {"A", " ", 
          RowBox[{",", "C"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[-C][
   $CellContext`T[-$CellContext`A, $CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"cf57d47a-0a6f-44d7-8cf3-0bc29b0c1ac2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CDS", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", "a"}], "]"}], "]"}], "]"}], ",", "CDM"}], 
   "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"7ff79b2e-ef5a-4932-ab48-5cbdcfb48e03"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "a"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, $CellContext`a],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " ", "  "},
           {" ", "C", "A", 
            RowBox[{":", "b"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDS[-$CellContext`b][
     $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "a", "  "},
           {"B", " ", 
            RowBox[{":", "b"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDS[-$CellContext`b][
     $CellContext`T[-$CellContext`B, $CellContext`a]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "a", "  ", "  "},
          {"A", " ", 
           RowBox[{",", "C"}], 
           RowBox[{":", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDS[-$CellContext`b][
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, $CellContext`a]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"3b3530c0-7b62-478f-970c-0297f56d85a3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckZeroDerivative", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"c603b6fa-4747-4438-9068-0c7ec34e60a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
         StyleBox[GridBox[{
            {"B", " ", " "},
            {" ", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`A],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "a", "  "},
           {"B", " ", 
            RowBox[{":", "b"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDS[-$CellContext`b][
     $CellContext`T[-$CellContext`B, $CellContext`a]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "a", "  ", "  "},
          {"A", " ", 
           RowBox[{",", "C"}], 
           RowBox[{":", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDS[-$CellContext`b][
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, $CellContext`a]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"09d22304-c6d6-451f-b30a-c825d7871300"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CDS", "[", 
     RowBox[{"-", "b"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", "a"}], "]"}], "]"}], "]"}], "//", 
   "ChangeCovD"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"39ce8ee9-e02c-46cb-84e9-546d53f653a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "a"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`B, $CellContext`a],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " ", "  "},
           {" ", "C", "A", 
            RowBox[{",", "b"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`b][
     $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "C", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`A],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
           StyleBox[GridBox[{
              {"a", " ", " "},
              {" ", "b", "c"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", "c"},
              {"B", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, $CellContext`c],
       Editable->False]}], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "a", "  "},
             {"B", " ", 
              RowBox[{",", "b"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`b][
       $CellContext`T[-$CellContext`B, $CellContext`a]],
      Editable->False]}], ")"}]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "a", "  ", "  "},
          {"A", " ", 
           RowBox[{",", "C"}], 
           RowBox[{",", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`b][
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, $CellContext`a]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"a", " ", " "},
           {" ", "b", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "c", "  "},
           {"A", " ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, $CellContext`c]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"6b4cca98-a501-40f1-9f36-318f9d08513e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckZeroDerivative", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"83921d27-fcdb-4232-8f7d-b2644290f315"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
         StyleBox[GridBox[{
            {"B", " ", " "},
            {" ", "C", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDM[$CellContext`B, -C, -$CellContext`A],
     Editable->False]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
           StyleBox[GridBox[{
              {"a", " ", " "},
              {" ", "b", "c"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", "c"},
              {"B", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, $CellContext`c],
       Editable->False]}], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "a", "  "},
             {"B", " ", 
              RowBox[{",", "b"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`b][
       $CellContext`T[-$CellContext`B, $CellContext`a]],
      Editable->False]}], ")"}]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "a", "  ", "  "},
          {"A", " ", 
           RowBox[{",", "C"}], 
           RowBox[{",", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`b][
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, $CellContext`a]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"a", " ", " "},
           {" ", "b", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "c", "  "},
           {"A", " ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, $CellContext`c]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"12129a88-02fa-4541-9cf2-7bd7b26ad837"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Christoffel", "[", 
   RowBox[{"PD", ",", "PD"}], "]"}], "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "B"}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"feda649b-1c0c-4648-a96c-46b91cbd287e"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"d9822265-6f3e-4042-bd82-c14c313cf5a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Christoffel", "[", 
   RowBox[{"CDM", ",", "PD"}], "]"}], "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "B"}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"8c615ac4-532c-4de4-b213-ccabb92bf4d9"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
      StyleBox[GridBox[{
         {"A", " ", " "},
         {" ", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"13d2c953-4775-4922-978c-dd0e72d0c155"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Christoffel", "[", 
   RowBox[{"PD", ",", "CDM"}], "]"}], "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "B"}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"66a23ca3-02d0-40f1-948c-9c177ac40eb5"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"cd24f239-c875-42d3-bef3-604bd4f1c9f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Christoffel", "[", 
   RowBox[{"CDM", ",", "Com"}], "]"}], "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "B"}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"73a12237-6d26-43a2-bbcf-1e9077830eb8"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"\[PartialD]", 
        RowBox[{",", "\[PartialD]"}]}], "]"}], 
      StyleBox[GridBox[{
         {"A", " ", " "},
         {" ", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ChristoffelCDMCom[$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"5b8936bd-94ed-467d-8d7c-5f686e46f955"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Christoffel", "[", 
   RowBox[{"Com", ",", "CDM"}], "]"}], "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "B"}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"a93ac3fa-cfa6-4387-82c2-23a3466a7ab2"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", 
        RowBox[{"\[PartialD]", 
         RowBox[{",", "\[PartialD]"}]}], "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCDMCom[$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"3a64d440-e9b6-4f19-bccc-a481a5a61cb7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChristoffelCDMCom"}]], \
"Input",ExpressionUUID->"18459e7b-ce66-4590-a3b4-71329cfbd685"],

Cell[CellGroupData[{

Cell["Global`ChristoffelCDMCom", "Print", "PrintUsage",
 CellTags->
  "Info3578672813-5338953",ExpressionUUID->"6ba7bc5f-ce9a-4c08-8e2f-\
b5aba96f1120"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ChristoffelCDMCom", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "ChristoffelCDMCom", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`ChristoffelCDMCom],
          Editable->False], "^=", "ChristoffelCDMCom"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "ChristoffelCDMCom", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "ChristoffelCDMCom", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "ChristoffelCDMCom", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "ChristoffelCDMCom", "]"}], 
         "^=", "\<\"\[CapitalGamma][\[PartialD],\[PartialD]]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "ChristoffelCDMCom", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "ChristoffelCDMCom", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "2", ",", "3", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{2, 3}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "ChristoffelCDMCom", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"Christoffel", ",", "CDM", ",", "Com"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "ChristoffelCDMCom", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`ChristoffelCDMCom],
  Editable->False]], "Print",
 CellTags->
  "Info3578672813-5338953",ExpressionUUID->"56ec8191-fcf9-4c9b-a9cc-\
95e91212ee9f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BreakChristoffel", "[", 
  RowBox[{
   RowBox[{"ChristoffelCDMCom", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "ChristoffelCDMCom", ",", "PD"}], 
  "]"}]], "Input",ExpressionUUID->"a4a3719c-c549-4d4e-8e28-726579667fef"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C],
   Editable->False], "-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCom[$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"b0cc4d36-75f6-42b8-a7d7-c40cd665187b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BreakChristoffel", "[", 
  RowBox[{
   RowBox[{"ChristoffelCDMCom", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "ChristoffelCDMCom"}], 
  "]"}]], "Input",ExpressionUUID->"e1ee717c-f46e-46fb-a65e-b423d93d0317"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C],
   Editable->False], "-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCom[$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"888f5719-a712-4181-bf24-f8dd9c9fecfb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BreakChristoffel", "[", 
  RowBox[{
   RowBox[{"ChristoffelCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "ChristoffelCDM", ",", "Com"}], 
  "]"}]], "Input",ExpressionUUID->"3de104ea-8bc1-439f-a807-59edc7cc8891"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", 
        RowBox[{"\[PartialD]", 
         RowBox[{",", "\[PartialD]"}]}], "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCDMCom[$CellContext`A, -$CellContext`B, -C],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
       StyleBox[GridBox[{
          {"A", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ChristoffelCom[$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"85afb4dc-5614-4fe8-9cb9-fed9eadc92d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}], ",", 
   RowBox[{"Torsion", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"99e1b5ef-1e1d-4e1d-99e1-1edd94bf9161"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDT", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDT[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"247f2ea4-6cb2-4adb-97ee-58f276f40020"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TorsionCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "torsion tensor ", 
   $CellContext`TorsionCDT[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"95507a45-c69b-457d-be69-32be1e2819e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "non-symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDT[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dceee254-989f-4ef3-9a0c-5381ab89c9e3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDT[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"054009f4-f51b-4002-94a2-c58d0f9b4098"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCDT[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"683b3950-7876-4aa9-86d5-1a7d72b52bef"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"16664336-1137-4ac1-b05e-e2282911bd05"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TorsionCDT", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}]}], "]"}], "//", 
  "ChangeTorsion"}]], \
"Input",ExpressionUUID->"010f1d12-2a4c-458b-902f-e258992ff89a"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "T"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$TorsionSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDT[$CellContext`A, -$CellContext`B, -C],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDT[$CellContext`A, -C, -$CellContext`B],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"da340d56-5853-41fc-b0a4-c3c9375387a4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeTorsion", "[", 
  RowBox[{
   RowBox[{"TorsionCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "CDT"}], 
  "]"}]], "Input",ExpressionUUID->"ff4c3896-7b4e-40bb-9fff-a7b2391ce5b5"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "T"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$TorsionSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDT[$CellContext`A, -$CellContext`B, -C],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDT[$CellContext`A, -C, -$CellContext`B],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"fc299666-a792-4313-90cc-ed1c4b802ca2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeTorsion", "[", 
  RowBox[{
   RowBox[{"TorsionCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "CDT", ",", "Com"}], 
  "]"}]], "Input",ExpressionUUID->"80d8212a-d285-4c68-8722-fe176cf8ad29"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDTCom", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ChristoffelCDTCom[$CellContext`A, -$CellContext`B, -C], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"5cfd24c4-0b43-4fdc-b4e3-bdfe13a167cf"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "T"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$TorsionSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"D", ",", "\[PartialD]"}], "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDTCom[$CellContext`A, -$CellContext`B, -C],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"D", ",", "\[PartialD]"}], "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " "},
            {" ", "C", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDTCom[$CellContext`A, -C, -$CellContext`B],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"3df68ced-be0d-4feb-bfcb-26b3e536fbb4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RiemannCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "//", "ChangeCurvature"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"d1da349e-1755-4318-8ce9-bdd53d65023b"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "R"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RiemannSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "B", "F"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[D, -$CellContext`B, -$CellContext`F],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"F", " ", " "},
             {" ", "A", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[$CellContext`F, -$CellContext`A, -C],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "A", "F"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[D, -$CellContext`A, -$CellContext`F],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"F", " ", " "},
             {" ", "B", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[$CellContext`F, -$CellContext`B, -C],
      Editable->False]}], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"D", " ", " ", "  "},
            {" ", "B", "C", 
             RowBox[{",", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`A][
      $CellContext`ChristoffelCDT[D, -$CellContext`B, -C]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"D", " ", " ", "  "},
            {" ", "A", "C", 
             RowBox[{",", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`B][
      $CellContext`ChristoffelCDT[D, -$CellContext`A, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"a65736c8-40cc-41f7-938c-ccd2912a5acb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RicciCDT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "//", "ChangeCurvature"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"241bf6c2-134a-4ee9-80c5-e50c90d23a8d"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "r"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RicciSign,
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "R"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RiemannSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"C", " ", " "},
             {" ", "C", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[C, -C, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[D, -$CellContext`A, -$CellContext`B],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"C", " ", " "},
             {" ", "A", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[C, -$CellContext`A, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "C", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[D, -C, -$CellContext`B],
      Editable->False]}], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"C", " ", " ", "  "},
            {" ", "C", "B", 
             RowBox[{",", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`A][
      $CellContext`ChristoffelCDT[C, -C, -$CellContext`B]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"C", " ", " ", "  "},
            {" ", "A", "B", 
             RowBox[{",", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-C][
      $CellContext`ChristoffelCDT[C, -$CellContext`A, -$CellContext`B]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"29ebfb1a-8e21-41cd-99a6-0349619f0e8d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCurvature", "[", 
   RowBox[{
    RowBox[{"RicciCDT", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], ",", "CDT"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"29a230f8-8686-4862-a6ad-69192c451876"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "r"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RicciSign,
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    SubscriptBox["s", "R"],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`$RiemannSign,
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"C", " ", " "},
             {" ", "C", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[C, -C, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[D, -$CellContext`A, -$CellContext`B],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"C", " ", " "},
             {" ", "A", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[C, -$CellContext`A, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
          StyleBox[GridBox[{
             {"D", " ", " "},
             {" ", "C", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDT[D, -C, -$CellContext`B],
      Editable->False]}], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"C", " ", " ", "  "},
            {" ", "C", "B", 
             RowBox[{",", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`A][
      $CellContext`ChristoffelCDT[C, -C, -$CellContext`B]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {"C", " ", " ", "  "},
            {" ", "A", "B", 
             RowBox[{",", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-C][
      $CellContext`ChristoffelCDT[C, -$CellContext`A, -$CellContext`B]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"b32af417-acff-4239-a354-3c4d496dc631"]
}, Open  ]],

Cell["If we need \"metrics\":", \
"Text",ExpressionUUID->"bf833d9c-eb06-4c48-8870-f930642c5b36"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BasisQ", "[", "polar", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`VBundleOfBasis", "[", "polar", "]"}], "^=", 
   "TangentM2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"7346b0b5-393a-49c6-ab7b-df2cab32429c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeCurvature", "[", 
   RowBox[{
    RowBox[{"RiemannCDT", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "polar"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "polar"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"C", ",", "polar"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"D", ",", "polar"}], "}"}]}], "]"}], ",", "CDT", ",", "CDM"}], 
   "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"85c389b2-c0bb-4a8d-8072-dcabd3c7ec45"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDMCDT", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ChristoffelCDMCDT[$CellContext`A, -$CellContext`B, -C], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"39c68030-7d21-4897-8e46-445ac7952061"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"Basis", 
       StyleBox[GridBox[{
          {"G1", 
           StyleBox["C",
            FontColor->RGBColor[0., 0., 1.]]},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[$CellContext`G1, {C, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Basis", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["D",
            FontColor->RGBColor[0., 0., 1.]]},
          {"G2", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[-$CellContext`G2, {D, $CellContext`polar}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Basis", 
       StyleBox[GridBox[{
          {" ", "F"},
          {
           StyleBox["A",
            FontColor->RGBColor[0., 0., 1.]], " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[{-$CellContext`A, -$CellContext`polar}, $CellContext`F],
   
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Basis", 
       StyleBox[GridBox[{
          {" ", "G"},
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[{-$CellContext`B, -$CellContext`polar}, $CellContext`G],
   
   Editable->False], " ", 
  RowBox[{"xAct`xTensor`Private`SymmetryOfIndex", "[", "G$220903", "]"}], " ", 
  RowBox[{"xAct`xTensor`Private`SymmetryOfIndex", "[", 
   RowBox[{"-", "G$220904"}], "]"}], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"R", "[", "\[PartialD]", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " ", "G2"},
            {"F", "G", "G1", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RiemannCDM[-$CellContext`F, -$CellContext`G, \
-$CellContext`G1, $CellContext`G2],
     Editable->False], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       SubscriptBox["s", "R"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`$RiemannSign,
      Editable->False], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", 
              RowBox[{"\[PartialD]", 
               RowBox[{",", "D"}]}], "]"}], 
             StyleBox[GridBox[{
                {"G2", " ", " "},
                {" ", "G", "G3"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`ChristoffelCDMCDT[$CellContext`G2, -$CellContext`G, \
-$CellContext`G3],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", 
              RowBox[{"\[PartialD]", 
               RowBox[{",", "D"}]}], "]"}], 
             StyleBox[GridBox[{
                {"G3", " ", " "},
                {" ", "F", "G1"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`ChristoffelCDMCDT[$CellContext`G3, -$CellContext`F, \
-$CellContext`G1],
         Editable->False]}], "-", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", 
              RowBox[{"\[PartialD]", 
               RowBox[{",", "D"}]}], "]"}], 
             StyleBox[GridBox[{
                {"G2", " ", " "},
                {" ", "F", "G3"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`ChristoffelCDMCDT[$CellContext`G2, -$CellContext`F, \
-$CellContext`G3],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {
             RowBox[{"\[CapitalGamma]", "[", 
              RowBox[{"\[PartialD]", 
               RowBox[{",", "D"}]}], "]"}], 
             StyleBox[GridBox[{
                {"G3", " ", " "},
                {" ", "G", "G1"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`ChristoffelCDMCDT[$CellContext`G3, -$CellContext`G, \
-$CellContext`G1],
         Editable->False]}], "+", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", 
             RowBox[{"\[PartialD]", 
              RowBox[{",", "D"}]}], "]"}], 
            StyleBox[GridBox[{
               {"G2", " ", " ", "  "},
               {" ", "G", "G1", 
                RowBox[{"|", "F"}]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`CDM[-$CellContext`F][
         $CellContext`ChristoffelCDMCDT[$CellContext`G2, -$CellContext`G, \
-$CellContext`G1]],
        Editable->False], "-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", 
             RowBox[{"\[PartialD]", 
              RowBox[{",", "D"}]}], "]"}], 
            StyleBox[GridBox[{
               {"G2", " ", " ", "  "},
               {" ", "F", "G1", 
                RowBox[{"|", "G"}]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`CDM[-$CellContext`G][
         $CellContext`ChristoffelCDMCDT[$CellContext`G2, -$CellContext`F, \
-$CellContext`G1]],
        Editable->False]}], ")"}]}]}], 
   ")"}]}]], "Output",ExpressionUUID->"741613a4-b0eb-442b-8f39-b04a9a282460"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`$Christoffels", "//", 
  "ColumnForm"}]], \
"Input",ExpressionUUID->"f541c6b0-5fef-441f-a16f-505f91fd17fe"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDM", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDM", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDS", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDS", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]S2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentS2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCom", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "Com", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDMCom", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDM", ",", "Com"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDT", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDT", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDTCom", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDT", ",", "Com"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDMCDT", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDM", ",", "CDT"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{$CellContext`ChristoffelCDM, {
     xAct`xTensor`Christoffel, $CellContext`CDM, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}, \
{$CellContext`ChristoffelCDS, {
     xAct`xTensor`Christoffel, $CellContext`CDS, 
      xAct`xTensor`PD}, {$CellContext`TangentS2}}, \
{$CellContext`ChristoffelCom, {
     xAct`xTensor`Christoffel, $CellContext`Com, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}, \
{$CellContext`ChristoffelCDMCom, {
     xAct`xTensor`Christoffel, $CellContext`CDM, $CellContext`Com}, \
{$CellContext`TangentM2}}, {$CellContext`ChristoffelCDT, {
     xAct`xTensor`Christoffel, $CellContext`CDT, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}, \
{$CellContext`ChristoffelCDTCom, {
     xAct`xTensor`Christoffel, $CellContext`CDT, $CellContext`Com}, \
{$CellContext`TangentM2}}, {$CellContext`ChristoffelCDMCDT, {
     xAct`xTensor`Christoffel, $CellContext`CDM, $CellContext`CDT}, \
{$CellContext`TangentM2}}}],
  Editable->
   False]], "Output",ExpressionUUID->"ebf240d4-170c-4cf1-bc18-f7f7906778d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "CDT", 
  "]"}]], "Input",ExpressionUUID->"1cfa3d58-7e10-4f24-bf5d-6fd14d07b83f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ChristoffelCDMCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ChristoffelCDMCDT],
  Editable->
   False]], "Print",ExpressionUUID->"3a64074e-f282-431c-86b7-19d56fb8ed8f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDT],
  Editable->
   False]], "Print",ExpressionUUID->"688ef298-90b5-4869-bc25-cd7c03bc4945"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ChristoffelCDTCom"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ChristoffelCDTCom],
  Editable->
   False]], "Print",ExpressionUUID->"9fcd0a1f-13d3-429f-a7f9-288e9a4e9810"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCDT],
  Editable->
   False]], "Print",ExpressionUUID->"92105298-ff15-4d8e-8c71-907f42caecff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDT],
  Editable->
   False]], "Print",ExpressionUUID->"4fa0c8a3-78ea-4e5b-b0e9-41e3ec825546"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDT],
  Editable->
   False]], "Print",ExpressionUUID->"ffdab7a3-a298-44c0-b59a-2bd1a1203c4a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDT],
  Editable->
   False]], "Print",ExpressionUUID->"d0df6376-4bdd-43a6-98d2-e366aa6eafbb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`$Christoffels", "//", 
  "ColumnForm"}]], \
"Input",ExpressionUUID->"3f5c5eec-6a73-4997-825c-bb79963a8323"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDM", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDM", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDMCom", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDM", ",", "Com"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDS", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CDS", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]S2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentS2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCom", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "Com", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{$CellContext`ChristoffelCDM, {
     xAct`xTensor`Christoffel, $CellContext`CDM, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}, \
{$CellContext`ChristoffelCDMCom, {
     xAct`xTensor`Christoffel, $CellContext`CDM, $CellContext`Com}, \
{$CellContext`TangentM2}}, {$CellContext`ChristoffelCDS, {
     xAct`xTensor`Christoffel, $CellContext`CDS, 
      xAct`xTensor`PD}, {$CellContext`TangentS2}}, \
{$CellContext`ChristoffelCom, {
     xAct`xTensor`Christoffel, $CellContext`Com, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}}],
  Editable->
   False]], "Output",ExpressionUUID->"ee6aba3c-6cd8-43aa-8d3d-d9a360b06bef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"UndefCovD", "[", "Com", "]"}], "\n", 
 RowBox[{"UndefCovD", "[", "CDM", "]"}], "\n", 
 RowBox[{"UndefCovD", "[", "CDS", "]"}], "\n", 
 RowBox[{
  RowBox[{"UndefTensor", "[", "T", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"11fcd22f-b528-4b31-9826-3db77ef44950"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ChristoffelCDMCom"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ChristoffelCDMCom],
  Editable->
   False]], "Print",ExpressionUUID->"b5f205bc-1a36-41dc-924d-27bed147561f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCom"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCom],
  Editable->
   False]], "Print",ExpressionUUID->"5b7377e0-97b9-4d68-a773-85c731e72ff4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCom"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci tensor", 
   " ", $CellContext`RicciCom],
  Editable->
   False]], "Print",ExpressionUUID->"cbc4729d-92c8-4127-b15e-f1c53064b03c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCom"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCom],
  Editable->
   False]], "Print",ExpressionUUID->"096af30b-1b25-41f0-bf56-1e01f1b4b4d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCom"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCom],
  Editable->
   False]], "Print",ExpressionUUID->"6ddec357-b292-43f6-ae80-f661385d89ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Com"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`Com],
  Editable->
   False]], "Print",ExpressionUUID->"982b7125-e992-4228-8a10-bc8d82a544e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDM],
  Editable->
   False]], "Print",ExpressionUUID->"1c5d0c60-4856-4cb0-8a9f-0bf7bdf67149"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCDM],
  Editable->
   False]], "Print",ExpressionUUID->"62464208-5cb1-4c5c-823f-639f3d19578f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDM],
  Editable->
   False]], "Print",ExpressionUUID->"0f6ec43d-9fc1-4ef9-9866-c246c40eae81"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDM],
  Editable->
   False]], "Print",ExpressionUUID->"a77d79fb-9a4f-4ed4-a86d-63c9e8e3b3ec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDM],
  Editable->
   False]], "Print",ExpressionUUID->"5ef571c7-2374-4a35-8cfa-cafe1c3d9b2f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDS],
  Editable->
   False]], "Print",ExpressionUUID->"4ff15af4-9733-4d66-92b4-82c46c5b3feb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCDS],
  Editable->
   False]], "Print",ExpressionUUID->"c9bf42ca-eb3a-4a61-bb9b-0c5d3db9906f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDS],
  Editable->
   False]], "Print",ExpressionUUID->"3fe7fdfc-41bf-4702-a13c-81f43f792859"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDS],
  Editable->
   False]], "Print",ExpressionUUID->"59cde373-5bc2-4914-9d7a-e00c3dfd12e9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDS],
  Editable->
   False]], "Print",ExpressionUUID->"7ca5bdff-d85b-4a96-808c-682550704fc8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"23f3e3c2-f4de-4bc7-aa62-086f7251921f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["xATP`$Christoffels"], \
"Input",ExpressionUUID->"db96e0b0-041c-4ba8-9635-a7a985b058e7"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"2c07d720-0454-4970-a46a-14442fe97801"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "polar", 
  "]"}]], "Input",ExpressionUUID->"8f1c0e08-d5f7-47e4-a1d9-d50ce2688e50"],

Cell[CellGroupData[{

Cell[BoxData["$CovDs"], \
"Input",ExpressionUUID->"6833f4b7-c21f-49d4-aae2-bf062ecb5e32"],

Cell[BoxData[
 RowBox[{"{", "PD", 
  "}"}]], "Output",ExpressionUUID->"19140b15-2fb3-4a19-b673-8b56fbe9ab8f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"9bf9e24f-637d-4fe1-8e2d-de925337978a"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"d7ba3f81-09c7-4b37-a989-7e2b38e3f7cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"3f39e47b-1d7f-44a5-a4be-41325e1b99d0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"8f7d2da4-7999-4494-a111-1fbbbc8a002b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"8fa9cfdf-e820-4fd7-bd74-02e1f8d2a657"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", 
  "]"}]], "Input",ExpressionUUID->"d649fd13-3588-48d0-9b35-f126e327c016"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"ae0a4de9-26e4-466a-8ca6-b5da5f3d70b5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"a979babb-4855-414a-8b78-0fbb0068fa91"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"586976f4-2568-4da2-857e-d22013e8e57c"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.6. OverDot derivative", \
"Subsection",ExpressionUUID->"69b40174-f5cd-42e1-a6a0-cbb422838f7d"],

Cell["\<\
We need a generic derivative with respect to a parameter. We will use \
OverDot. OverDot of an expression is never zero unless explicitly stated.\
\>", "Text",ExpressionUUID->"9dd89845-447d-4658-a71b-db771bcf4426"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Unprotect", "[", "OverDot", "]"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Nest", " ", "high"}], "-", 
    RowBox[{"order", " ", "derivatives"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"OverDot", "[", 
     RowBox[{"expr_", ",", "1"}], "]"}], "]"}], ":=", 
   RowBox[{"OverDot", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OverDot", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"n_Integer", "?", "Positive"}]}], "]"}], ":=", 
    RowBox[{"OverDot", "[", 
     RowBox[{"OverDot", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"n", "-", "1"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Derivative", " ", "properties"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OverDot", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"OverDot", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OverDot", "[", "expr_SeriesData", "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{"OverDot", ",", "expr"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OverDot", "[", 
    RowBox[{"x_", " ", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"OverDot", "[", "x", "]"}], "y"}], "+", 
    RowBox[{"x", " ", 
     RowBox[{"OverDot", "[", "y", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OverDot", "[", 
     RowBox[{"x_", "?", "ConstantQ"}], "]"}], ":=", "0"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Scalar", " ", "functions"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OverDot", "[", 
     RowBox[{
      RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], ":=", 
    RowBox[{"multiD", "[", 
     RowBox[{"OverDot", ",", 
      RowBox[{"f", "[", "args", "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "No", " ", "need", " ", "to", " ", "replace", " ", "dummies", " ", 
    "internally"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OverDot", "[", 
     RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
    RowBox[{"Scalar", "[", 
     RowBox[{"OverDot", "[", "expr", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Listability", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OverDot", "[", "list_List", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{"OverDot", ",", "list"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3fcfe1da-ad29-43a0-adff-9533cc1e98d2"],

Cell["\<\
We assume that it commutes with partial derivatives, but only for \
covariant-index derivatives. Note that the generalization to the directional \
case contains two terms:\
\>", "Text",ExpressionUUID->"61901036-ac58-4fd6-b67a-450b40f717b3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"OverDot", "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "ind_"}], "]"}], "[", "expr_", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "ind"}], "]"}], "[", 
   RowBox[{"OverDot", "[", "expr", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OverDot", "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"Dir", "[", "v_", "]"}], "]"}], "[", "expr_", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"Dir", "[", "v", "]"}], "]"}], "[", 
    RowBox[{"OverDot", "[", "expr", "]"}], "]"}], "+", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"Dir", "[", 
      RowBox[{"OverDot", "[", "v", "]"}], "]"}], "]"}], "[", "expr", 
    "]"}]}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"dbee8380-a5c0-4e97-b3e9-7dbed4acf0c6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"OverDot", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "OverDot", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"460a18c6-cbf5-4618-866c-5af340617c3a"],

Cell["\<\
QUESTION: It is not clear how to expand the time-derivative of a tensor (not \
a derivative) with a directional slot.\
\>", "Text",ExpressionUUID->"491616ac-57dd-457b-a4b6-7ec72a209461"],

Cell["QUESTION: What about Lie derivatives? And brackets?", \
"Text",ExpressionUUID->"b0bb2c50-a0e0-4cad-acbd-e88edb170013"],

Cell["\<\
QUESTION: As pointed out by David Yllanes, the formatting of OverDot is quite \
bad, because it places the dot over the whole tensor, and not over its head.\
\>", "Text",ExpressionUUID->"6c8fda15-d30b-4eef-98a9-21bba25dfa25"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"02e01352-a685-45bd-b9c4-93efc51f11d1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"9c1bcaba-3514-4eda-87d6-3f90c0af22ee"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4ba8cb8b-d1a3-47bc-8cc7-6a36ba2fc06b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"024cacec-1e9d-41c4-b66f-cd5bbbf6d848"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"57e587b2-1dde-49b7-9411-9473618a8b6d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"46afa961-0c2f-4fca-885e-d70a6263ac26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"d66e8a0a-e02b-4d17-8452-fbd6e739d479"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"db5563d5-1195-4413-8b5d-b5c3255c473f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OverDot", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], "^", "2"}], 
  "]"}]], "Input",ExpressionUUID->"dc31f550-b375-4e7d-98c4-aba41f0ac0dc"],

Cell[BoxData[
 RowBox[{"2", " ", 
  OverscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "."], " ", 
  InterpretationBox[
   StyleBox["r",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`r[],
   Editable->
    False]}]], "Output",ExpressionUUID->"899725e2-3392-42fc-8fff-5042a3a99b91"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OverDot", "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "3"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"6fc57670-90ad-46b6-95b9-443d022e9d5c"],

Cell[BoxData[
 RowBox[{"3", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], " ", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[PartialD]", "A"], 
        OverscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "."]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`A][
       OverDot[
        $CellContext`r[]]],
      Editable->False]}], "+", 
    RowBox[{"2", " ", 
     OverscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "."], " ", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[PartialD]", "A"], "r"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`A][
       $CellContext`r[]],
      Editable->False]}]}], 
   ")"}]}]], "Output",ExpressionUUID->"48854659-c621-49af-b775-eec39bffd375"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], "^", "3"}], 
  "]"}]], "Input",ExpressionUUID->"18b2438b-331a-44f2-86bf-028d2d37b254"],

Cell[BoxData[
 RowBox[{"3", " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "2"], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "A"], "r"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`r[]],
   Editable->
    False]}]], "Output",ExpressionUUID->"ae82cec8-a495-4ddc-a841-d127c939244f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OverDot", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"e3ef1527-588f-48d2-a081-8c920f432624"],

Cell[BoxData[
 RowBox[{"3", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], " ", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[PartialD]", "A"], 
        OverscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "."]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`A][
       OverDot[
        $CellContext`r[]]],
      Editable->False]}], "+", 
    RowBox[{"2", " ", 
     OverscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "."], " ", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[PartialD]", "A"], "r"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`A][
       $CellContext`r[]],
      Editable->False]}]}], 
   ")"}]}]], "Output",ExpressionUUID->"9660e109-0ac4-41e4-b0af-d7b00316c623"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "FullForm"}]], \
"Input",ExpressionUUID->"71359696-c02c-4976-a859-3c3f784d10d8"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Times", "[", 
    RowBox[{"3", ",", 
     RowBox[{"Plus", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"Power", "[", 
          RowBox[{
           RowBox[{"r", "[", "]"}], ",", "2"}], "]"}], ",", 
         RowBox[{
          RowBox[{"PD", "[", 
           RowBox[{"Times", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "A"}], "]"}], "]"}], "[", 
          RowBox[{"OverDot", "[", 
           RowBox[{"r", "[", "]"}], "]"}], "]"}]}], "]"}], ",", 
       RowBox[{"Times", "[", 
        RowBox[{"2", ",", 
         RowBox[{"OverDot", "[", 
          RowBox[{"r", "[", "]"}], "]"}], ",", 
         RowBox[{"r", "[", "]"}], ",", 
         RowBox[{
          RowBox[{"PD", "[", 
           RowBox[{"Times", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "A"}], "]"}], "]"}], "[", 
          RowBox[{"r", "[", "]"}], "]"}]}], "]"}]}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], \
"Output",ExpressionUUID->"148bbf4c-7c7d-4994-9e2a-6bc35dffecdb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"be37b467-2c13-42e9-b7bf-528c5eebb2b5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"abe06524-a3eb-4346-8bf3-106385cc19e4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OverDot", "[", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"40df3df8-15a7-416f-baa4-43e469de1ab3"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`B],
     Editable->False]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     OverscriptBox[
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"G$223238", "G$223239"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`G$223238, $CellContext`G$223239],
       Editable->False], "."], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"G$223238", "G$223239"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`G$223238, -$CellContext`G$223239],
      Editable->False]}], "+", 
    RowBox[{
     OverscriptBox[
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"G$223238", "G$223239"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`G$223238, -$CellContext`G$223239],
       Editable->False], "."], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"G$223238", "G$223239"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`G$223238, $CellContext`G$223239],
      Editable->False]}]}], 
   ")"}]}]], "Output",ExpressionUUID->"f17d55e2-040c-487a-9c05-97b17e29a0a3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OverDot", "[", 
  RowBox[{"Log", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"0081e483-c727-465c-ad70-ce3f6ff3167e"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    OverscriptBox[
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"G$223240", "G$223241"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`G$223240, $CellContext`G$223241],
      Editable->False], "."], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " "},
            {"G$223240", "G$223241"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`G$223240, -$CellContext`G$223241],
     Editable->False]}], "+", 
   RowBox[{
    OverscriptBox[
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"G$223240", "G$223241"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`G$223240, -$CellContext`G$223241],
      Editable->False], "."], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"G$223240", "G$223241"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`G$223240, $CellContext`G$223241],
     Editable->False]}]}], 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->
     False]}]]], \
"Output",ExpressionUUID->"3136ada7-7184-4b8d-a5be-326539905069"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"2abc4463-2d54-4d92-a668-35f012d2c4b9"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    OverscriptBox[
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B],
      Editable->False], "."], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`A, -$CellContext`B],
     Editable->False]}], "+", 
   RowBox[{
    OverscriptBox[
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A, -$CellContext`B],
      Editable->False], "."], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`B],
     Editable->False]}]}], 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->
     False]}]]], \
"Output",ExpressionUUID->"79c53c48-e65f-4a75-ba55-4c3556acfc75"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"r", ",", "T"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"5f5e518d-6aa4-4615-9679-e89c60cba3a9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"1375d51f-a5be-4d38-a78e-c7270942cc78"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"30ccab78-0fda-45b0-8c9d-93a6586b2af1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"938af2ba-7d66-4082-a51b-ac20c38b0e2a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"700bbf5c-0316-4f2a-9b0b-fc3857ba9b4c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"fcb14df2-8283-4d9a-8ffa-324a0f98e4f4"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"7cb560a3-7870-49f5-b5c9-7eb53f6af4ae"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.7. ParamD", \
"Subsection",ExpressionUUID->"53cd0a1b-a7fc-406b-91f4-4e9e2763edc3"],

Cell[CellGroupData[{

Cell["11.7.1. Definitions", \
"Subsubsection",ExpressionUUID->"1f8af86b-ac4f-4b81-b120-5e8517ec13d9"],

Cell["Parameter derivatives commute by definition:", \
"Text",ExpressionUUID->"2217edf0-77a6-4066-9514-c18e8bc6d98a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ParamD", "[", "]"}], "[", "expr_", "]"}], ":=", "expr"}], ";"}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Unnest", " ", "parametric", " ", "derivatives"}], ",", " ", 
    RowBox[{"contrary", " ", "to", " ", 
     RowBox[{"OverDot", ".", " ", "Sort"}], " ", "parameters"}], ",", " ", 
    RowBox[{"always", " ", "assumed", " ", "to", " ", "commute"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", "p1__", "]"}], "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "p2__", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"ParamD", "@@", 
      RowBox[{"Sort", "[", 
       RowBox[{"{", 
        RowBox[{"p1", ",", "p2"}], "}"}], "]"}]}], ")"}], "[", "expr", 
    "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Properties", " ", "of", " ", "a", " ", "derivative"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", "p__", "]"}], "[", "expr_Plus", "]"}], ":=", 
   RowBox[{
    RowBox[{"ParamD", "[", "p", "]"}], "/@", "expr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", "p__", "]"}], "[", "expr_SeriesData", "]"}], ":=", 
   
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "p", "]"}], ",", "expr"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", 
     RowBox[{"p___", ",", "p1_"}], "]"}], "[", 
    RowBox[{"x_", " ", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ParamD", "[", "p", "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ParamD", "[", "p1", "]"}], "[", "x", "]"}], "y"}], "+", 
     RowBox[{"x", " ", 
      RowBox[{
       RowBox[{"ParamD", "[", "p1", "]"}], "[", "y", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", 
     RowBox[{"p___", ",", "p1_"}], "]"}], "[", "p1_", "]"}], ":=", 
   RowBox[{
    RowBox[{"ParamD", "[", "p", "]"}], "[", "1", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", "p__", "]"}], "[", 
    RowBox[{"_", "?", "ConstantQ"}], "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ParamD", "[", "p__", "]"}], "[", "expr_", "]"}], ":=", 
    RowBox[{"0", "/;", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"ParametersOf", "[", "expr", "]"}], ",", 
       RowBox[{"Alternatives", "[", 
        RowBox[{"p", ",", "AnyDependencies"}], "]"}]}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Scalar", " ", 
    RowBox[{"functions", ":", " ", 
     RowBox[{"sequentially", " ", "apply", " ", "chain", " ", "rule"}]}]}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ParamD", "[", 
      RowBox[{"p___", ",", "p1_"}], "]"}], "[", 
     RowBox[{
      RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"ParamD", "[", "p", "]"}], "[", 
     RowBox[{"multiD", "[", 
      RowBox[{
       RowBox[{"ParamD", "[", "p1", "]"}], ",", 
       RowBox[{"f", "[", "args", "]"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"On", " ", 
    RowBox[{"Scalar", ".", " ", "No"}], " ", "need", " ", "to", " ", 
    "replace", " ", "internal", " ", "dummies"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ParamD", "[", "p__", "]"}], "[", 
     RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"ParamD", "[", "p", "]"}], "[", "expr", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Listability", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ParamD", "[", "p__", "]"}], "[", "list_List", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "p", "]"}], ",", "list"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"aa97b12a-4d0a-4e3e-9542-9edfa1e01714"],

Cell["\<\
QUESTION: Again, what about directions, Lie ders and brackets?\
\>", "Text",ExpressionUUID->"9b4424cf-9b21-46f5-8548-0849dbe76996"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.7.2. Formatting", \
"Subsubsection",ExpressionUUID->"6907c240-4866-4057-a7c2-9514529bfc36"],

Cell["Code copied from Leo's email in the group on 22 June 2011:", \
"Text",ExpressionUUID->"dee0fe60-61f8-4bb2-aa16-6157554d26f8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoxes", "[", 
     RowBox[{
      RowBox[{"expr", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], ")"}]}], 
      ",", "form_"}], "]"}], ":=", 
    RowBox[{"interpretbox", "[", 
     RowBox[{"expr", ",", 
      RowBox[{
       RowBox[{"MakeBoxesParamD", "[", "ps", "]"}], "[", 
       RowBox[{
        RowBox[{"MakeBoxes", "[", 
         RowBox[{"expr", ",", "form"}], "]"}], ",", "form"}], "]"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoxesParamD", "[", "]"}], "[", 
    RowBox[{"boxes_", ",", "form_"}], "]"}], ":=", "boxes"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoxesParamD", "[", 
     RowBox[{"rest___", ",", "p_"}], "]"}], "[", 
    RowBox[{"boxes_", ",", "form_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"MakeBoxesParamD", "[", "rest", "]"}], "[", 
    RowBox[{
     RowBox[{"FlattenRowBox", "@", 
      RowBox[{"RowBox", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"SubscriptBox", "[", 
          RowBox[{"\"\<\[PartialD]\>\"", ",", 
           RowBox[{"PrintAs", "[", "p", "]"}]}], "]"}], ",", "boxes"}], "}"}],
        "]"}]}], ",", "form"}], "]"}]}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"bb5eed41-cbb9-4bf6-b350-1cf6d3457add"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOfCovD", "[", "ParamD", "]"}], "^=", 
   RowBox[{"{", 
    RowBox[{"\"\<,\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"55356cb6-e1e9-410a-8d76-157f1ee6ca7a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$ParamDFormat", "=", "\"\<Prefix\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "ParamD", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<ParamD Formatting\>\""}], "}"}], 
       ",", 
       RowBox[{"interpretbox", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ParamD", "[", "ps", "]"}], "[", "expr", "]"}], ",", 
         RowBox[{"MakeBoxesParamD", "[", 
          RowBox[{
           RowBox[{"{", "ps", "}"}], ",", 
           RowBox[{"boxof", "@", 
            RowBox[{"MakeBoxes", "[", 
             RowBox[{"expr", ",", "StandardForm"}], "]"}]}], ",", 
           "$ParamDFormat", ",", "StandardForm"}], "]"}]}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "ParamD", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], ",", 
       "StandardForm"}], "]"}], "=."}], "\[IndentingNewLine]", ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "ParamD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c40db91e-9072-40d8-a613-6b90abfc7c94"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Postfix", " ", "notation"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesParamD", "[", 
      RowBox[{"pslist_List", ",", 
       RowBox[{"SubsuperscriptBox", "[", 
        RowBox[{"head_", ",", "downstr_", ",", "upstr_"}], "]"}], ",", 
       "\"\<Postfix\>\"", ",", "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<ParamD Formatting\>\""}], "}"}], 
       ",", 
       RowBox[{
        RowBox[{
         RowBox[{"SubsuperscriptBox", "[", 
          RowBox[{"head", ",", "#1", ",", "#2"}], "]"}], "&"}], "@@", 
        RowBox[{"AddIndex", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"downstr", ",", "upstr"}], "}"}], ",", 
          RowBox[{"Minus", "/@", 
           RowBox[{"IndexList", "@@", "pslist"}]}], ",", "ParamD"}], 
         "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesParamD", "[", 
      RowBox[{
      "pslist_List", ",", "gridbox_GridBox", ",", "\"\<Postfix\>\"", ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<ParamD Formatting\>\""}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"gridbox", ",", 
         RowBox[{"AppendIndexPair", "[", 
          RowBox[{
           RowBox[{"AppendIndexPair", "[", 
            RowBox[{
             RowBox[{"gridbox", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "]"}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"\"\<\>\"", ",", 
               RowBox[{"First", "@", 
                RowBox[{"SymbolOfCovD", "[", "ParamD", "]"}]}]}], "}"}]}], 
            "]"}], ",", 
           RowBox[{"IndexPair", "/@", 
            RowBox[{"IndexList", "@@", "pslist"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "}"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesParamD", "[", 
      RowBox[{
      "pslist_List", ",", "boxes_", ",", "\"\<Postfix\>\"", ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<ParamD Formatting\>\""}], "}"}], 
       ",", 
       RowBox[{"SubscriptBox", "[", 
        RowBox[{"boxes", ",", 
         RowBox[{"StringJoin", "[", 
          RowBox[{
           RowBox[{"First", "@", 
            RowBox[{"SymbolOfCovD", "[", "ParamD", "]"}]}], ",", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"(", 
             RowBox[{"PrintAs", "/@", "pslist"}], ")"}]}]}], "]"}]}], "]"}]}],
       "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"SinglePrefix", " ", "notation"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesParamD", "[", 
      RowBox[{
      "pslist_List", ",", "boxes_", ",", "\"\<SinglePrefix\>\"", ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<ParamD Formatting\>\""}], "}"}], 
       ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"SubscriptBox", "[", 
           RowBox[{
            RowBox[{"Last", "@", 
             RowBox[{"SymbolOfCovD", "[", "ParamD", "]"}]}], ",", 
            RowBox[{"StringJoin", "@@", 
             RowBox[{"(", 
              RowBox[{"PrintAs", "/@", "pslist"}], ")"}]}]}], "]"}], ",", 
          "boxes"}], "}"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Prefix", " ", "notation"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesParamD", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "boxes_", ",", "\"\<Prefix\>\"", ",", 
       "StandardForm"}], "]"}], ":=", "boxes"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxesParamD", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"rest___", ",", "p_"}], "}"}], ",", "boxes_", ",", 
       "\"\<Prefix\>\"", ",", "StandardForm"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$WarningFrom", "=", "\"\<ParamD Formatting\>\""}], "}"}], 
       ",", 
       RowBox[{"MakeBoxesParamD", "[", 
        RowBox[{
         RowBox[{"{", "rest", "}"}], ",", 
         RowBox[{"FlattenRowBox", "@", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"SubscriptBox", "[", 
              RowBox[{
               RowBox[{"Last", "@", 
                RowBox[{"SymbolOfCovD", "[", "ParamD", "]"}]}], ",", 
               RowBox[{"PrintAs", "[", "p", "]"}]}], "]"}], ",", "boxes"}], 
            "}"}], "]"}]}], ",", "\"\<Prefix\>\"", ",", "StandardForm"}], 
        "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"184904eb-e13f-40d4-8886-2de256cc54a4"]
}, Closed]],

Cell[CellGroupData[{

Cell["11.7.3. Examples", \
"Subsubsection",ExpressionUUID->"482a7399-e39a-45e2-8783-0bdeb66925e0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3a63b6c3-1045-4932-810b-b1fe3d2f1906"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefParameter", "[", "time", 
  "]"}]], "Input",ExpressionUUID->"f472c0d1-bba6-43f8-86f8-0c46ee9e7c78"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefParameter", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"parameter \"\>", "\[InvisibleSpace]", "time", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefParameter, ": Defining ", 
   "parameter ", $CellContext`time, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ffb894d9-496b-43dd-a0c0-3c69b55e80c8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefParameter", "[", "space", 
  "]"}]], "Input",ExpressionUUID->"12368ca2-f9a4-4972-9360-fb6c33c3422f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefParameter", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"parameter \"\>", "\[InvisibleSpace]", "space", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefParameter, ": Defining ", 
   "parameter ", $CellContext`space, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"be4736b6-9200-49e9-abe3-aa769ac913b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "time"}]], "Input",ExpressionUUID->"01601ca7-46d0-4e39-85d9-8cff5056261b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["time",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`time,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672821-5338953",ExpressionUUID->"29352e58-d00d-45ad-82e6-\
aa35555dd544"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["time",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`time,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["time",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`time,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"parameter\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ParameterQ", "[", 
          InterpretationBox[
           StyleBox["time",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`time,
           Editable->False], "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["time",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`time,
           Editable->False], "]"}], "^=", "\<\"time\"\>"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`time],
  Editable->False]], "Print",
 CellTags->
  "Info3578672821-5338953",ExpressionUUID->"4dd1fe90-3ee8-40ec-9a8c-\
ee2edc23c692"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"98540b82-75b3-44bc-b72c-76d2c0d25942"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"905fbbeb-496b-4d48-827c-9560e790f24b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"99ccd3fb-0e02-4c1a-8dac-03e177b0fddd"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d7a88b31-29e9-45d1-90e2-76bcdaca15a0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1feb439a-ad55-4e9a-81a8-0bb16b2e81d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "time"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"bba5a378-9179-4bed-b00d-56583dcfbab6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6ef37d5d-95ff-4a3a-be45-272a665f1c05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "A", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "space"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"951d875d-3b10-4da6-8fc9-1a34d3a7621f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"297ce181-3d2d-447c-bd3f-ac791421f977"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ParamD", "[", "time", "]"}], "[", 
  RowBox[{"2", 
   RowBox[{"v", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"54081479-8e5d-4fd3-a39f-2e738b4b1bdf"],

Cell[BoxData[
 RowBox[{"2", " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "time"], GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`ParamD[$CellContext`time][
    $CellContext`v[$CellContext`A]],
   Editable->
    False]}]], "Output",ExpressionUUID->"54c06263-c9bc-41ea-a612-a3d11d8dcd74"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ParamD", "[", "space", "]"}], "[", 
  RowBox[{
   RowBox[{"4", 
    RowBox[{"v", "[", "A", "]"}]}], "+", 
   RowBox[{"3", 
    RowBox[{"w", "[", "A", "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"61d50e77-0ceb-45d9-aa7e-17bc10d32ae6"],

Cell[BoxData[
 RowBox[{"3", " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "space"], GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`ParamD[$CellContext`space][
    $CellContext`w[$CellContext`A]],
   Editable->
    False]}]], "Output",ExpressionUUID->"294877aa-0910-4acc-a538-9366b69bc5df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ParamD", "[", 
   RowBox[{"time", ",", "space"}], "]"}], "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], 
   RowBox[{"w", "[", 
    RowBox[{"-", "A"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d6403dff-d7f9-4889-9bbc-f78eb95c8be7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "space"], GridBox[{
        {"w", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ParamD[$CellContext`space][
     $CellContext`w[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "time"], GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ParamD[$CellContext`time][
     $CellContext`v[$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "space"], 
      SubscriptBox["\[PartialD]", "time"], GridBox[{
        {"w", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ParamD[$CellContext`space, $CellContext`time][
     $CellContext`w[-$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"2af36d2e-1271-4fe5-bece-4a0707252c18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
  "UndefParameter", "[", "time", 
   "]"}]}]], "Input",ExpressionUUID->"ef430293-31f4-4dbf-9fbe-de84919d6ddb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "noundef"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Symbol\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\(time\\), Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], time, Rule[Editable, False]]\\)\
\[NoBreak] cannot be undefined because \[NoBreak]\\!\\(\\\"it has \
visitors\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"770ff022-0db4-4814-9719-85285e5ebad8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"UndefTensor", "[", "v", "]"}], "\[IndentingNewLine]", 
 RowBox[{"UndefTensor", "[", "w", 
  "]"}]}], "Input",ExpressionUUID->"03f86663-9ed4-4b79-b094-804c12507a40"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"11b0300b-d5d8-4327-8fba-0678569f4448"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"4c4b937c-6f58-4565-8c00-ac995e10c8c1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VisitorsOf", "[", "time", 
  "]"}]], "Input",ExpressionUUID->"90dfee3d-f68d-4f31-9b59-84c7d75633cd"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"e770f70a-02c8-4dff-9dc4-e7c0e463fabe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"UndefParameter", "[", "time", "]"}], "\[IndentingNewLine]", 
 RowBox[{"UndefParameter", "[", "space", 
  "]"}]}], "Input",ExpressionUUID->"73bc7d03-9c53-4be8-9474-af61c68024eb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefParameter", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"parameter\"\>", "\[InvisibleSpace]", "\<\" \"\>",
    "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["time",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`time,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefParameter, ": Undefined ", "parameter", 
   " ", $CellContext`time],
  Editable->
   False]], "Print",ExpressionUUID->"7cd2fa2a-67d9-49f7-a37b-b754f439edd2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefParameter", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"parameter\"\>", "\[InvisibleSpace]", "\<\" \"\>",
    "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["space",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`space,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefParameter, ": Undefined ", "parameter", 
   " ", $CellContext`space],
  Editable->
   False]], "Print",ExpressionUUID->"609f6ec2-07a6-4f90-ad5b-8db6dec7fbc3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"11519c55-ad6d-4a67-8a76-bee382e66ded"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"b2330d45-c444-4ed4-852b-a49a6a873f5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"6bfddffa-1a1f-4a64-b3af-bbb005ae5511"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "M2"}]], "Input",ExpressionUUID->"5ae267a7-ac43-4668-9378-c3d823a03896"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"M2\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"49dcc6eb-b34b-4852-ab60-1213a7373f1d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"2ff99530-17cc-41f4-a02b-984d683ca3c8"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["12. Lie derivatives and brackets",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"c5cda8c1-b368-4492-84db-cbc6443e5797"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"**", "**", "**", "**", "**", "**", "**", "**", "**", " ", "12."}],
    "Lie", " ", "derivatives", " ", "and", " ", "brackets"}], " ", 
  "******************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d1cbe546-0ac7-49c2-9737-fa012f620d2c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"6309f190-f614-483e-b660-257229575d27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "55.131609`", ",", "556.001393`9.19662087315619", ",", 
   "0.09915737967151707`"}], 
  "}"}]], "Output",ExpressionUUID->"7d48fb70-cfd3-4e5b-9653-374d97f01c03"]
}, Open  ]],

Cell[CellGroupData[{

Cell["12.0. Comments", \
"Subsection",ExpressionUUID->"5b44526d-a493-464f-93d5-d03d506907dc"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{
   "Print", "[", "\"\<Reading section 12: Lie derivatives.\>\"", "]"}], ",", 
   "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8cc2143e-6604-4114-ba6d-df877b86717b"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.1. Definition", \
"Subsection",ExpressionUUID->"466e3e54-f552-4d26-b839-dfd04c384b3a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "LieD"}]], "Input",ExpressionUUID->"6eee551d-f9a2-4332-826c-990a6f462e0e"],

Cell[BoxData[
 StyleBox["\<\"LieD[v][expr] represents the Lie derivative of expr along the \
contravariant vector field v. LieD[v, covd][expr] computes the Lie derivative \
of expr using the covariant derivative covd.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672826-5338953",ExpressionUUID->"28a077d7-397f-473a-a91d-\
81ce054f7167"]
}, Open  ]],

Cell["\<\
There are two forms of a Lie derivative: a formal derivative and a computing \
function in terms of a connection.\
\>", "Text",ExpressionUUID->"ace7397b-f4bc-45d6-a899-33ff4a930446"],

Cell["1) Properties of a Lie derivative", \
"Text",ExpressionUUID->"06ac49ee-3fe9-46fb-891b-dbc5529cfbd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Properties", " ", "of", " ", "a", " ", "derivative"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_Plus", "]"}], ":=", 
     RowBox[{
      RowBox[{"LieD", "[", "v", "]"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_SeriesData", "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v", "]"}], ",", "expr"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", 
      RowBox[{"expr1_", " ", "expr2_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v", "]"}], "[", "expr1", "]"}], "expr2"}], "+", 
      
      RowBox[{"expr1", " ", 
       RowBox[{
        RowBox[{"LieD", "[", "v", "]"}], "[", "expr2", "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", 
      RowBox[{"_", "?", "ConstantQ"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", 
      RowBox[{
       RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], ":=", 
     RowBox[{"multiD", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v", "]"}], ",", 
       RowBox[{"f", "[", "args", "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"On", " ", 
     RowBox[{"Scalar", ".", " ", "No"}], " ", "need", " ", "to", " ", 
     "replace", " ", "internal", " ", "dummies"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", 
      RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"Scalar", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v", "]"}], "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Listability", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "list_List", "]"}], ":=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "v", "]"}], ",", "list"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Vector", " ", "field", " ", 
     RowBox[{"argument", ".", " ", "Not"}], " ", 
     RowBox[{"tensorial", "!"}], " ", "Just", " ", "linear"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_Plus", "]"}], "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "#", "]"}], "[", "expr", "]"}], "&"}], "/@", 
      "v"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_SeriesData", "]"}], "[", "expr_", "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", "#", "]"}], "[", "expr", "]"}], "&"}], ",", 
       "v"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x_", "?", "ConstantQ"}], ")"}], "v_"}], "]"}], "[", "expr_",
       "]"}], ":=", 
     RowBox[{"x", " ", 
      RowBox[{
       RowBox[{"LieD", "[", "v", "]"}], "[", "expr", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "0", "]"}], "[", "expr_", "]"}], ":=", "0"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Two", " ", "special", " ", "useful", " ", "cases"}], " ", "*)"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", 
       RowBox[{
        RowBox[{"v_", "?", "xTensorQ"}], "[", "_Symbol", "]"}], "]"}], "[", 
      RowBox[{"v_", "[", "_Symbol", "]"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LieD", "/:", 
     RowBox[{
      RowBox[{
       RowBox[{"v_", "?", "xTensorQ"}], "[", "i_Symbol", "]"}], 
      RowBox[{
       RowBox[{"LieD", "[", 
        RowBox[{"v_", "[", "_Symbol", "]"}], "]"}], "[", "expr_", "]"}]}], ":=", 
     RowBox[{"0", "/;", 
      RowBox[{"HasOrthogonalIndexQ", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"v", "[", "i", "]"}]}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"62ed3cfc-c24d-44b1-94ea-f10d619fd4e1"],

Cell["\<\
2) If a second argument is supplied then the Lie derivative is expanded. \
QUESTION: Is it correct for the density case? Somehow the result should \
depend on the basis associated to the density, and not only to the metric of \
the Levi-Civita connection. I'm not even sure whether the Lie derivative must \
see the density character of an expression... QUESTION: And what happens with \
basis indices? Currently we are only expanding abstract indices, through the \
use of vb`Q functions.\
\>", "Text",ExpressionUUID->"4a835052-d2fc-4bbc-abfb-9f4c7a04fcab"],

Cell["\<\
Note of 18 Mar 2011: for the case of weighted tensors, we now replace (where \
metric is the LeviCivita of covd).\
\>", "Text",ExpressionUUID->"5377440d-091a-4adf-b0d4-750d44798f93"],

Cell[BoxData[
 RowBox[{
  RowBox[{"1", "/", "2"}], " ", "expr", " ", 
  RowBox[{"metric", "[", 
   RowBox[{"i1", ",", "i2"}], "]"}], 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"vector", ",", "covd"}], "]"}], "[", 
   RowBox[{"metric", "[", 
    RowBox[{
     RowBox[{"-", "i1"}], ",", 
     RowBox[{"-", "i2"}]}], "]"}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"b2d7bdd5-c16d-405e-8131-0b2b1204b756"],

Cell["by the simplest form", \
"Text",ExpressionUUID->"f5ec6c4b-728f-44eb-b76f-8e892166854f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"covd", "[", 
   RowBox[{"-", "i1"}], "]"}], "[", 
  RowBox[{"vector", "/.", 
   RowBox[{"indv", "\[Rule]", "i1"}]}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"b26343e8-2c22-4d9c-83c0-df3f66008f9f"],

Cell["\<\
Note of 22 Aug 2015: Alfonso has added previously-missing torsion terms.\
\>", "Text",ExpressionUUID->"4f864c27-32a9-4764-92b3-134382257c84"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"vector_", ",", "covd_"}], "]"}], "[", 
    RowBox[{
     RowBox[{"f_", "?", "ScalarFunctionQ"}], "[", "args___", "]"}], "]"}], ":=", 
   RowBox[{"multiD", "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"vector", ",", "covd"}], "]"}], ",", 
     RowBox[{"f", "[", "args", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"vector_", ",", "covd_"}], "]"}], "[", 
    RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"vector", ",", "covd"}], "]"}], "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"vector_", ",", "covd_"}], "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{"ExpandLieD", "[", 
     RowBox[{
      RowBox[{"ReplaceDummies", "[", "vector", "]"}], ",", "covd", ",", 
      "False", ",", "Identity1"}], "]"}], "[", "expr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExpandLieD", "[", 
     RowBox[{"vector_", ",", "covd_", ",", "dirQ_", ",", "tmpcovdhead_"}], 
     "]"}], "[", "expr_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Expand", "[", 
    RowBox[{
     RowBox[{"tmpcovdhead", "[", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{"dirQ", ",", "Identity", ",", "SeparateDir"}], "]"}], "[", 
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"Dir", "[", "vector", "]"}], "]"}], "[", "expr", "]"}], 
        "]"}], ",", "LieD"}], " ", "]"}], "+", 
     RowBox[{"lieDcovDdiff", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"ReplaceDummies", "[", "vector", "]"}], ",", "covd", ",", 
       RowBox[{"VBundleOfIndex", "@", 
        RowBox[{"UltraindexOf", "[", "vector", "]"}]}], ",", "Identity"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDToLieD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "[", 
       RowBox[{"Dir", "[", "vector_", "]"}], "]"}], "[", "expr_", "]"}], ",", 
     "tmpchrhead_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"LieD", "[", "vector", "]"}], "[", "expr", "]"}], "-", 
    RowBox[{"lieDcovDdiff", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"ReplaceDummies", "[", "vector", "]"}], ",", "covd", ",", 
      RowBox[{"VBundleOfIndex", "[", 
       RowBox[{"Dir", "[", "vector", "]"}], "]"}], ",", "tmpchrhead"}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"lieDcovDdiff", "[", 
     RowBox[{
     "expr_", ",", "vector_", ",", "covd_", ",", "vb_", ",", "tmpchrhead_"}], 
     "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"indv", "=", 
         RowBox[{"UltraindexOf", "[", "vector", "]"}]}], ",", 
        RowBox[{"vbQ", "=", 
         RowBox[{"VBundleIndexQ", "[", "vb", "]"}]}], ",", 
        RowBox[{"inds", "=", 
         RowBox[{"FindFreeIndices", "[", "expr", "]"}]}], ",", 
        RowBox[{"dummy", "=", 
         RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
        RowBox[{"dummy2", "=", 
         RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Checks", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"CovDQ", "[", "covd", "]"}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"LieD", "::", "unknown"}], ",", "\"\<derivative\>\"", 
             ",", "covd"}], "]"}], ";", 
           RowBox[{"ERROR", "[", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", ",", "covd"}], "]"}], "[", "expr", "]"}], 
            "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"ValidateDir", "[", 
        RowBox[{"Dir", "[", "vector", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "=!=", "PD"}], "&&", 
          RowBox[{
           RowBox[{"ManifoldOfCovD", "[", "covd", "]"}], "=!=", 
           RowBox[{"BaseOfVBundle", "[", "vb", "]"}]}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"LieD", "::", "error"}], ",", 
             "\"\<Invalid derivative in Lie Derivative.\>\""}], "]"}], ";", 
           RowBox[{"ERROR", "[", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", ",", "covd"}], "]"}], "[", "expr", "]"}], 
            "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "CovDTODO", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Additional", " ", "terms"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"torsion", "=", 
            RowBox[{"Torsion", "[", "covd", "]"}]}], ",", 
           RowBox[{"newv", "=", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"TorsionQ", "[", "covd", "]"}], ",", 
              RowBox[{"ReplaceIndex", "[", 
               RowBox[{"vector", ",", 
                RowBox[{"indv", "\[Rule]", "dummy2"}]}], "]"}], ",", "0"}], 
             "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Expand", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Plus", "@@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"tmpchrhead", "[", 
                   RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "#"}], "]"}], "[", 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"vector", ",", 
                    RowBox[{"indv", "\[Rule]", "dummy"}]}], "]"}], "]"}], 
                   "]"}], "+", 
                  RowBox[{"$TorsionSign", " ", "newv", " ", 
                   RowBox[{"torsion", "[", 
                    RowBox[{"dummy", ",", 
                    RowBox[{"-", "dummy2"}], ",", 
                    RowBox[{"-", "#"}]}], "]"}]}]}], ")"}], 
                RowBox[{"ReplaceIndex", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{
                   RowBox[{"-", "#"}], "\[Rule]", 
                   RowBox[{"-", "dummy"}]}]}], "]"}]}], "&"}], ",", 
              RowBox[{"Select", "[", 
               RowBox[{
                RowBox[{"ChangeIndex", "/@", "inds"}], ",", "vbQ"}], "]"}]}], 
             " ", "]"}]}], "-", 
           RowBox[{"Plus", "@@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"tmpchrhead", "[", 
                   RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dummy"}], "]"}], "[", 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"vector", ",", 
                    RowBox[{"indv", "\[Rule]", "#"}]}], "]"}], "]"}], "]"}], 
                  "+", 
                  RowBox[{"$TorsionSign", " ", "newv", " ", 
                   RowBox[{"torsion", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"-", "dummy2"}], ",", 
                    RowBox[{"-", "dummy"}]}], "]"}]}]}], ")"}], 
                RowBox[{"ReplaceIndex", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"#", "\[Rule]", "dummy"}]}], "]"}]}], "&"}], ",", 
              RowBox[{"Select", "[", 
               RowBox[{"inds", ",", "vbQ"}], "]"}]}], " ", "]"}]}], "+", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"WeightedCovDQ", "[", "covd", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"weight", "=", 
                 RowBox[{"WeightOf", "[", 
                  RowBox[{"expr", ",", 
                   RowBox[{"WeightedWithBasis", "[", "covd", "]"}]}], "]"}]}],
                 "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"weight", "=!=", "0"}], ",", 
                 RowBox[{"weight", " ", "expr", " ", 
                  RowBox[{
                   RowBox[{"covd", "[", 
                    RowBox[{"-", "indv"}], "]"}], "[", "vector", "]"}]}], ",",
                  "0"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
             "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Messages", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LieD", "[", "_", "]"}], "[", "]"}], ":=", 
  RowBox[{"Throw", "@", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"LieD", "::", "argx"}], ",", "LieD", ",", "0"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LieD", "[", "]"}], "[", 
   RowBox[{"_", ",", "x__"}], "]"}], ":=", 
  RowBox[{"Throw", "@", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"LieD", "::", "argx"}], ",", "LieD", ",", 
     RowBox[{"1", "+", 
      RowBox[{"Length", "[", 
       RowBox[{"{", "x", "}"}], "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LieD", "[", "]"}], "[", "_", "]"}], ":=", 
  RowBox[{"Throw", "@", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"LieD", "::", "error"}], ",", 
     "\"\<There is no contravariant vector\>\""}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"_", ",", "_", ",", "__"}], "]"}], "[", "_", "]"}], ":=", 
  RowBox[{"Throw", "@", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"LieD", "::", "error"}], ",", 
     "\"\<Too many arguments for LieD.\>\""}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "LieD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"454e3bd2-49cd-4e0e-b932-0dd4c67b5424"],

Cell["\<\
The function LieDToCovD converts from the former to the latter:\
\>", "Text",ExpressionUUID->"b8911271-751b-44d4-921f-5245b3223786"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "LieDToCovD"}]], \
"Input",ExpressionUUID->"9b4a9bd4-20cb-43e8-b74a-d859287abc0d"],

Cell[BoxData[
 StyleBox["\<\"LieDToCovD[expr, covd] transforms LieD[v][expr1] into LieD[v, \
covd][expr1] so that the Lie derivative of expr1 along v is computed in terms \
of the covariant derivative covd.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672827-5338953",ExpressionUUID->"47a08c21-1e96-4f0d-badd-\
929bba58e4ce"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LieDToCovD", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"expr", "//.", 
    RowBox[{
     RowBox[{"LieD", "[", "vector_", "]"}], "\[RuleDelayed]", 
     RowBox[{"LieD", "[", 
      RowBox[{"vector", ",", "covd"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"LieDToCovD", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "LieDToCovD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"75116732-bc93-4554-8475-0bc3823a66c3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DirCovDToLieD", "[", 
    RowBox[{"expr_", ",", "vector_"}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"rest_.", " ", 
        RowBox[{"vector", "[", "a_", "]"}], 
        RowBox[{
         RowBox[{
          RowBox[{"covd_", "?", "CovDQ"}], "[", 
          RowBox[{"-", "a_"}], "]"}], "[", "expr1_", "]"}]}], "|", 
       RowBox[{"rest_.", " ", 
        RowBox[{"vector", "[", 
         RowBox[{"-", "a_"}], "]"}], 
        RowBox[{
         RowBox[{
          RowBox[{"covd_", "?", "CovDQ"}], "[", "a_", "]"}], "[", "expr1_", 
         "]"}]}], "|", 
       RowBox[{"rest_.", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"covd_", "?", "CovDQ"}], "[", 
          RowBox[{"Dir", "[", 
           RowBox[{"vector", "[", "a_", "]"}], "]"}], "]"}], "[", "expr1_", 
         "]"}]}]}], ")"}], "\[RuleDelayed]", 
     RowBox[{"rest", " ", 
      RowBox[{"CovDToLieD", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"Dir", "[", 
           RowBox[{"vector", "[", "a", "]"}], "]"}], "]"}], "[", "expr1", 
         "]"}], ",", "Identity"}], "]"}]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DirCovDToLieD", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DirCovDToLieD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"585305cb-3dae-4fd1-932e-53b9f683b666"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.2. Validation", \
"Subsection",ExpressionUUID->"0beb4c4d-ba49-4397-8120-5d7519c8d93c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ValidateLieD", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateLieD", "[", 
    RowBox[{"x", ":", 
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}]}], "]"}], ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ValidateDir", "[", 
      RowBox[{"Dir", "[", "v", "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"UncatchedValidate", "[", 
      RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}], ";", 
     "\[IndentingNewLine]", "x"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ValidateLieD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"99fe3057-4aa4-484f-a086-9c3006ef814d"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.3. Formatting", \
"Subsection",ExpressionUUID->"cac0e4de-b2c7-4dfc-9e30-fcd66b610ced"],

Cell["\<\
Formatting of a Lie derivative in prefix form. There is no postfix formatting.\
\>", "Text",ExpressionUUID->"bfa710ec-fa0e-435b-ba9a-019823c32950"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrefixFormatDer", "[", 
    RowBox[{"LieD", "[", 
     RowBox[{
      RowBox[{"v_", "?", "HeldxTensorQ"}], "[", "i_", "]"}], "]"}], "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
     RowBox[{"PrintAs", "[", "v", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrefixFormatDer", "[", 
    RowBox[{"LieD", "[", 
     RowBox[{
      RowBox[{"v_", "?", "HeldxTensorQ"}], "[", 
      RowBox[{"label_LI", ",", "i_"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
     RowBox[{"boxof", "@", 
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{"v", "[", "label", "]"}], ",", "StandardForm"}], "]"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrefixFormatDer", "[", 
    RowBox[{"LieD", "[", "v_", "]"}], "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
     RowBox[{"boxof", "@", 
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{"Short", "[", "v", "]"}], ",", "StandardForm"}], "]"}]}]}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"aabd6d38-d97b-47d5-987f-6eb8777bb2e6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "LieD", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
       "StandardForm"}], "]"}], ":=", 
     RowBox[{"interpretbox", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v", "]"}], "[", "expr", "]"}], ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PrefixFormatDer", "[", 
           RowBox[{"LieD", "[", "v", "]"}], "]"}], ",", 
          RowBox[{"boxof", "@", 
           RowBox[{"MakeBoxes", "[", 
            RowBox[{"expr", ",", "StandardForm"}], "]"}]}]}], "}"}], "]"}]}], 
      "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStop", "[", "LieD", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
       "StandardForm"}], "]"}], "=."}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStart", "[", "LieD", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0f2116ae-2058-4521-afb0-acc680b6f65a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorFormStart", "[", "LieD", "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", 
          RowBox[{
           RowBox[{"v_", "?", "HeldxTensorQ"}], "[", "i_", "]"}], "]"}], "[", 
         "expr_", "]"}], ",", "StandardForm"}], "]"}], ":=", 
      RowBox[{"interpretbox", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", 
          RowBox[{"v", "[", "i", "]"}], "]"}], "[", "expr", "]"}], ",", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"SubscriptBox", "[", 
            RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
             RowBox[{"PrintAs", "[", "v", "]"}]}], "]"}], ",", 
           RowBox[{"boxof", "@", 
            RowBox[{"MakeBoxes", "[", 
             RowBox[{"expr", ",", "StandardForm"}], "]"}]}]}], "}"}], "]"}]}],
        "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", 
          RowBox[{
           RowBox[{"v_", "?", "HeldxTensorQ"}], "[", 
           RowBox[{"label_LI", ",", "i_"}], "]"}], "]"}], "[", "expr_", "]"}],
         ",", "StandardForm"}], "]"}], ":=", 
      RowBox[{"interpretbox", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", 
          RowBox[{"v", "[", 
           RowBox[{"label", ",", "i"}], "]"}], "]"}], "[", "expr", "]"}], ",", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"SubscriptBox", "[", 
            RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
             RowBox[{"boxof", "@", 
              RowBox[{"MakeBoxes", "[", 
               RowBox[{
                RowBox[{"v", "[", "label", "]"}], ",", "StandardForm"}], 
               "]"}]}]}], "]"}], ",", 
           RowBox[{"boxof", "@", 
            RowBox[{"MakeBoxes", "[", 
             RowBox[{"expr", ",", "StandardForm"}], "]"}]}]}], "}"}], "]"}]}],
        "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MakeBoxes", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
        "StandardForm"}], "]"}], ":=", 
      RowBox[{"interpretbox", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LieD", "[", "v", "]"}], "[", "expr", "]"}], ",", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"SubscriptBox", "[", 
            RowBox[{"\"\<\[ScriptCapitalL]\>\"", ",", 
             RowBox[{"boxof", "@", 
              RowBox[{"MakeBoxes", "[", 
               RowBox[{
                RowBox[{"Short", "[", "v", "]"}], ",", "StandardForm"}], 
               "]"}]}]}], "]"}], ",", 
           RowBox[{"boxof", "@", 
            RowBox[{"MakeBoxes", "[", 
             RowBox[{"expr", ",", "StandardForm"}], "]"}]}]}], "}"}], "]"}]}],
        "]"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xTensorFormStop", "[", "LieD", "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", 
         RowBox[{
          RowBox[{"v_", "?", "HeldxTensorQ"}], "[", "i_", "]"}], "]"}], "[", 
        "expr_", "]"}], ",", "StandardForm"}], "]"}], "=."}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", 
         RowBox[{
          RowBox[{"v_", "?", "HeldxTensorQ"}], "[", 
          RowBox[{"label_LI", ",", "i_"}], "]"}], "]"}], "[", "expr_", "]"}], 
       ",", "StandardForm"}], "]"}], "=."}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MakeBoxes", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
       "StandardForm"}], "]"}], "=."}], ";"}], "\[IndentingNewLine]", 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"xTensorFormStart", "[", "LieD", "]"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"0c029708-3c9c-457a-8e74-636b236f1624"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.4. Examples", \
"Subsection",ExpressionUUID->"28e1633e-446b-487a-a7cf-4c2f47a5ac80"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e8035196-faca-419e-b04e-405b3b92f8f0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"41bd9a2d-58c3-4bd9-a5a7-b54dfbaa35d4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c42a64d4-5a6c-465c-a21f-5acf775946a3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c6bb3234-0790-4e71-bab9-0be112ba89a1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"fab60394-f05d-4a57-a44a-a2ad35597ea8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6fab7aad-db89-4051-8c3a-7e89db99efff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"60173cf0-62e5-481e-ade4-a0086bba6c7a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"fef78154-97b5-4740-9e59-be15fa6b41bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"xi", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", "]"}], ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[Xi]\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"cfe8231f-46c0-48dc-8910-731c5b837c1e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"xi", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`xi[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9be68a75-edf2-4b9e-bae8-2f1c344ed677"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "xi"}]], "Input",ExpressionUUID->"650905de-3bb0-4d3c-b2c2-22241caaea72"],

Cell[CellGroupData[{

Cell["Global`xi", "Print", "PrintUsage",
 CellTags->
  "Info3578672830-5338953",ExpressionUUID->"9873919b-3b56-4d46-a878-\
3717383c36b8"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "xi", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "xi", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`xi],
          Editable->False], "^=", "xi"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "xi", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "xi", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "xi", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "xi", "]"}], "^=", "\<\"\[Xi]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "xi", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"-", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "xi", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "xi", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "xi", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`xi],
  Editable->False]], "Print",
 CellTags->
  "Info3578672830-5338953",ExpressionUUID->"edf7dc60-e2d6-4a46-84fd-\
ea5fb5845d3a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8ecd26ae-89d8-466c-ad9f-78ead23842b2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"264124ea-6c88-4f55-a82c-4427ef0bcdb0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7c3351d6-ab84-4e37-9cca-858b954919b8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d3ac3e70-f92a-41f1-99a0-67305ddf995e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDM[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"43d00ba4-34e4-4c02-8e56-4795413ef4f9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5136c58a-4d33-4b3c-9baf-632612ca5091"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"9dcfff54-14f4-42ab-ad06-3196fd2e8d7f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{"xi", "[", "A", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"xi", "[", 
    RowBox[{"-", "A"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"ea4a348e-321b-43fe-bf23-4a14e08ffa09"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-$CellContext`A],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      $CellContext`T[$CellContext`A, $CellContext`B]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
         {"\[Xi]", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      $CellContext`xi[-$CellContext`A]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"ed33b442-77bd-4ca8-a275-032ef3b0d5b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{
     RowBox[{"xi", "[", "A", "]"}], ",", "PD"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"2e09fd97-158c-43fe-9ee9-b0b8831b279a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", " ", "  "},
            {" ", "C", 
             RowBox[{"|", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CDM[-D][
      $CellContext`T[$CellContext`A, -C]],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"B", "  "},
           {" ", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`xi[$CellContext`B]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}], 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`CDM[-D][
      $CellContext`T[$CellContext`B, -C]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "A", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`B, -$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`xi[$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`A][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`xi[$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"ffd079c5-6347-4c0b-b966-e0d9adc34060"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieDToCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"xi", "[", "A", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"B", ",", 
        RowBox[{"-", "C"}]}], "]"}], "]"}], "]"}], ",", "CDM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"052d3202-29e8-448d-ab75-e7272e7024a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}], 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`A][
     $CellContext`CDM[-D][
      $CellContext`T[$CellContext`B, -C]]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"B", "  "},
           {" ", 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`A][
     $CellContext`xi[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`A, -C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{"|", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`xi[$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "A", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`B, -$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`A][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`xi[$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"f6dd9241-72d5-4a52-98cf-3d2ecfbee4d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{"xi", "[", "A", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", "D"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"5c4dd667-4e0e-435a-912c-ce1546e2cff1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"C", "D"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      $CellContext`T[C, D]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "D"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[C, D],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"B", " ", "  "},
             {" ", "C", 
              RowBox[{"|", "D"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      $CellContext`CDM[-D][
       $CellContext`T[$CellContext`B, -C]]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"1a727761-a38f-4b98-bc1c-4dee0f88c0b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{"xi", "[", "A", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{"xi", "[", "A", "]"}], "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B", ",", 
       RowBox[{"-", "C"}]}], "]"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"C", ",", "D"}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c0a10599-3621-43df-859e-e0267bf5bc2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"C", "D"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      $CellContext`T[C, D]],
     Editable->False], ")"}], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"B", " ", "  "},
             {" ", "C", 
              RowBox[{"|", "D"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      $CellContext`CDM[-D][
       $CellContext`T[$CellContext`B, -C]]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], 
       RowBox[{
        SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"C", "D"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      xAct`xTensor`LieD[
       $CellContext`xi[$CellContext`A]][
       $CellContext`T[C, D]]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "D"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[C, D],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], 
       RowBox[{
        SubscriptBox["\[ScriptCapitalL]", "\[Xi]"], GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"B", " ", "  "},
              {" ", "C", 
               RowBox[{"|", "D"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`xi[$CellContext`A]][
      xAct`xTensor`LieD[
       $CellContext`xi[$CellContext`A]][
       $CellContext`CDM[-D][
        $CellContext`T[$CellContext`B, -C]]]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"c5285c5f-ff24-4b14-9d55-03af403ebc7e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ValidateLieD", "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"xi", "[", 
      RowBox[{"-", "B"}], "]"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e0852136-e739-48fb-aec0-b2b1b7a55d19"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[ScriptCapitalL]", 
     TagBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"\[Xi]", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`xi[-$CellContext`B],
        Editable->False]}],
      Short]], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", " ", "  "},
          {" ", "C", 
           RowBox[{"|", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`LieD[$CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`xi[-$CellContext`B]][
   $CellContext`CDM[-D][
    $CellContext`T[$CellContext`B, -C]]],
  Editable->
   False]], "Output",ExpressionUUID->"fd5ed3a8-7378-41db-a277-e98341afdbc8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"xi", "[", 
     RowBox[{"-", "B"}], "]"}]}], "]"}], "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", "D"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1003bcf9-06b5-4a1d-9a75-45d17638e4ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", 
        TagBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"T", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T[$CellContext`A, $CellContext`B],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Xi]", 
               StyleBox[GridBox[{
                  {" "},
                  {"B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`xi[-$CellContext`B],
           Editable->False]}],
         Short]], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"C", "D"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[$CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`xi[-$CellContext`B]][
      $CellContext`T[C, D]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "D"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[C, D],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", 
        TagBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"T", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T[$CellContext`A, $CellContext`B],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Xi]", 
               StyleBox[GridBox[{
                  {" "},
                  {"B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`xi[-$CellContext`B],
           Editable->False]}],
         Short]], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"B", " ", "  "},
             {" ", "C", 
              RowBox[{"|", "D"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[$CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`xi[-$CellContext`B]][
      $CellContext`CDM[-D][
       $CellContext`T[$CellContext`B, -C]]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"1caeff6c-84b5-4182-889c-de571af8d5d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"127b017b-e855-4449-8274-8adc67e4a36e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Mass", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Mass, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d89b8880-08f4-4886-acc8-6acfd6639a66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{"xi", "[", "A", "]"}], "]"}], "[", 
  RowBox[{"3", "+", "Mass"}], 
  "]"}]], "Input",ExpressionUUID->"83dae2d5-aeb1-407e-8b30-a8774323d937"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"401d0a39-999d-4388-ad50-fe5a53b18dcf"]
}, Open  ]],

Cell["\<\
We can use any kind of indices in the vector argument because they are \
isolated from the indices of the differentiated expression:\
\>", "Text",ExpressionUUID->"8a21e23e-eeae-46bc-ad75-27918acea398"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"xi", "[", 
     RowBox[{"-", "A"}], "]"}]}], "]"}], "[", 
  RowBox[{"RicciCDM", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"0c58bf26-f9d2-4be1-ab48-80d4d1a5382e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[ScriptCapitalL]", 
     TagBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"B", "A"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`B, $CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"\[Xi]", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`xi[-$CellContext`A],
        Editable->False]}],
      Short]], GridBox[{
      {
       RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`LieD[$CellContext`T[$CellContext`B, $CellContext`A] \
$CellContext`xi[-$CellContext`A]][
   $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"3a7675fd-aeb4-4178-9b55-dd3bdf198799"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "LieDToCovD"}]], \
"Input",ExpressionUUID->"ad742164-af3a-4e04-92dd-4631da4164a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"G$229405", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-$CellContext`G$229405, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"G$229404"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-$CellContext`G$229404],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$229405", "G$229404", "  "},
           {" ", " ", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[$CellContext`G$229405, $CellContext`G$229404]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"G$229405", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-$CellContext`G$229405, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$229405", "G$229404"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`G$229405, $CellContext`G$229404],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G$229404", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`xi[-$CellContext`G$229404]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "G$229405"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-$CellContext`A, -$CellContext`G$229405],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"G$229404"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-$CellContext`G$229404],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$229405", "G$229404", "  "},
           {" ", " ", 
            RowBox[{",", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`B][
     $CellContext`T[$CellContext`G$229405, $CellContext`G$229404]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "G$229405"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-$CellContext`A, -$CellContext`G$229405],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$229405", "G$229404"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`G$229405, $CellContext`G$229404],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G$229404", 
            RowBox[{",", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`B][
     $CellContext`xi[-$CellContext`G$229404]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$229403", "G$229401"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`G$229403, $CellContext`G$229401],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"G$229401"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-$CellContext`G$229401],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "B", 
            RowBox[{",", "G$229403"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`G$229403][
     $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"7d00bb12-bafc-4c32-9feb-96ecbef430c0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"aa284a9a-86ae-472b-a073-fcf9f06c7c89"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-D, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D", "C", "  "},
           {" ", " ", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[D, C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-D, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"C", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`xi[-C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-$CellContext`A, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D", "C", "  "},
           {" ", " ", 
            RowBox[{",", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`B][
     $CellContext`T[D, C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RicciCDM[-$CellContext`A, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"C", 
            RowBox[{",", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`B][
     $CellContext`xi[-C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"D", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Xi]", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`xi[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "B", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"8ea3f2fc-5666-408e-8906-19ecdb35dcda"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"e59df898-a8cf-45ae-96f7-529170d4074c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Mass",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Mass],
  Editable->
   False]], "Print",ExpressionUUID->"1e8cd1e8-f7a8-4db2-9b41-505a9db4bb02"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "CDM", 
  "]"}]], "Input",ExpressionUUID->"d1a8e20c-cbd4-4bed-808d-8201830eb231"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDM],
  Editable->
   False]], "Print",ExpressionUUID->"6b0fbc67-9227-410c-b0b4-735351e278f0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCDM],
  Editable->
   False]], "Print",ExpressionUUID->"03f4fdc7-3fbe-46f6-851e-0704fbb9304a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDM],
  Editable->
   False]], "Print",ExpressionUUID->"6efdaeed-d948-4253-b9fd-2c9fc69ea887"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDM],
  Editable->
   False]], "Print",ExpressionUUID->"8940783a-11a1-4875-8962-9da412c6ec8e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDM],
  Editable->
   False]], "Print",ExpressionUUID->"d58cc4ec-cc80-4bf7-9695-ef2993873767"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "xi"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"0eb80b9b-3305-42fc-9b37-471903bfbd6f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"b4070650-c554-411a-908a-b3f81a12d6bc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "xi"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`xi],
  Editable->
   False]], "Print",ExpressionUUID->"50b0ff0b-bbfd-4bfb-9d52-063bc80bf9b2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"1a1dd4bd-11de-4e42-89e8-3ae040cee068"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"7d9b0aa2-51dc-4ce1-8528-cd696b512a88"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"3a36a243-376d-4169-93cc-2adc5e818e6a"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"d0b79ab8-8e61-4223-914f-bf266aca242a"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.5. Lie brackets", \
"Subsection",ExpressionUUID->"d276f4f9-2de0-4ed5-8487-b644caea2902"],

Cell["Properties as a tensor:", \
"Text",ExpressionUUID->"f857b657-eab6-454d-b9ca-37640049bd8a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SlotsOfTensor", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", 
   RowBox[{"{", 
    RowBox[{"VBundleOfIndex", "[", 
     RowBox[{"First", "@", 
      RowBox[{"FindFreeIndices", "[", "v1", "]"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DependenciesOfTensor", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", 
   RowBox[{"Union", "[", 
    RowBox[{
     RowBox[{"DependenciesOf", "[", "v1", "]"}], ",", 
     RowBox[{"DependenciesOf", "[", "v2", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOfTensor", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", 
   RowBox[{
    RowBox[{"WeightOf", "[", "v1", "]"}], "+", 
    RowBox[{"WeightOf", "[", "v2", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Dagger", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", 
   RowBox[{"Bracket", "[", 
    RowBox[{
     RowBox[{"Dagger", "[", "v1", "]"}], ",", 
     RowBox[{"Dagger", "[", "v2", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b3df52a7-8539-4062-8ea8-2dfd4258af7d"],

Cell["\<\
Recall that UltraindexOf returns either the (abstract) ultraindex or None or \
throws an error.\
\>", "Text",ExpressionUUID->"dd37c814-5225-4244-918b-626a87ee2caa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ValidateBracket", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateBracket", "[", 
    RowBox[{"x", ":", 
     RowBox[{
      RowBox[{"Bracket", "[", 
       RowBox[{"v1_", ",", "v2_"}], "]"}], "[", "i_", "]"}]}], "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vb", "=", 
         RowBox[{"VBundleOfIndex", "[", "i", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"i1", "=", 
         RowBox[{"UltraindexOf", "[", "v1", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"i2", "=", 
         RowBox[{"UltraindexOf", "[", "v2", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"DownIndexQ", "[", "i1", "]"}], "||", 
          RowBox[{"DownIndexQ", "[", "i2", "]"}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"Validate", "::", "error"}], ",", 
             "\"\<Indices in the vectors of Bracket must be all contravariant\
\>\""}], "]"}], ";", 
           RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"VBundleOfIndex", "[", "i1", "]"}], "=!=", 
          RowBox[{"VBundleOfIndex", "[", "i2", "]"}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"Validate", "::", "error"}], ",", 
             "\"\<Vectors in Bracket belong to different manifolds\>\""}], 
            "]"}], ";", 
           RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"VBundleOfIndex", "[", "i1", "]"}], "=!=", "vb"}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"Validate", "::", "error"}], ",", 
             "\"\<Index in Bracket is incompatible with indices of \
vectors\>\""}], "]"}], ";", 
           RowBox[{"ERROR", "[", "x", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ValidateDir", "[", 
        RowBox[{"Dir", "[", "v1", "]"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"ValidateDir", "[", 
        RowBox[{"Dir", "[", "v2", "]"}], "]"}], ";", "\[IndentingNewLine]", 
       "x"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ValidateBracket", "[", "0", "]"}], ":=", "0"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"35f858c3-5668-42f6-bd66-ce4f7d96cbab"],

Cell["Antisymmetry:", \
"Text",ExpressionUUID->"d1a2c2e5-022d-4aac-aa54-59da8bb434ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{"v_", ",", "v_"}], "]"}], ":=", "Zero"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6043a18c-0c76-4438-b782-e2dd3d2fb32d"],

Cell["Bilinearity of Bracket:", \
"Text",ExpressionUUID->"5334eddf-27d1-405c-97c2-c784a6ad3171"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{"0", ",", "v2_"}], "]"}], ":=", "Zero"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{"v1_", ",", "0"}], "]"}], ":=", "Zero"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_Plus", ",", "v2_"}], "]"}], "[", "a__", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Bracket", "[", 
       RowBox[{"#", ",", "v2"}], "]"}], "[", "a", "]"}], "&"}], "/@", 
    "v1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_SeriesData", ",", "v2_"}], "]"}], "[", "a__", "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Bracket", "[", 
        RowBox[{"#", ",", "v2"}], "]"}], "[", "a", "]"}], "&"}], ",", "v1"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_Plus"}], "]"}], "[", "a__", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Bracket", "[", 
       RowBox[{"v1", ",", "#"}], "]"}], "[", "a", "]"}], "&"}], "/@", 
    "v2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_SeriesData"}], "]"}], "[", "a__", "]"}], ":=", 
   RowBox[{"SeriesDataMap", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Bracket", "[", 
        RowBox[{"v1", ",", "#"}], "]"}], "[", "a", "]"}], "&"}], ",", "v2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"c_", "?", "ConstantQ"}], " ", "v1_"}], ",", "v2_"}], "]"}], 
    "[", "a__", "]"}], ":=", 
   RowBox[{"c", " ", 
    RowBox[{
     RowBox[{"Bracket", "[", 
      RowBox[{"v1", ",", "v2"}], "]"}], "[", "a", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", 
      RowBox[{
       RowBox[{"c_", "?", "ConstantQ"}], " ", "v2_"}]}], "]"}], "[", "a__", 
    "]"}], ":=", 
   RowBox[{"c", " ", 
    RowBox[{
     RowBox[{"Bracket", "[", 
      RowBox[{"v1", ",", "v2"}], "]"}], "[", "a", "]"}]}]}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"dae5b47d-8aeb-4525-b9fc-715cc7c1e8a8"],

Cell["Derivations:", \
"Text",ExpressionUUID->"45d561be-b792-4b6b-98e6-c7d7bf0c0d4e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"s_", "?", "ScalarQ"}], " ", "v1_"}], ",", "v2_"}], "]"}], "[",
     "a_", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rs", "=", 
       RowBox[{"ReplaceDummies", "[", "s", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rs", " ", 
       RowBox[{
        RowBox[{"Bracket", "[", 
         RowBox[{"v1", ",", "v2"}], "]"}], "[", "a", "]"}]}], "-", 
      RowBox[{
       RowBox[{
        RowBox[{"PD", "[", 
         RowBox[{"Dir", "[", "v2", "]"}], "]"}], "[", "rs", "]"}], 
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{"v1", ",", 
         RowBox[{
          RowBox[{"UltraindexOf", "[", "v1", "]"}], "\[Rule]", "a"}]}], 
        "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", 
      RowBox[{
       RowBox[{"s_", "?", "ScalarQ"}], " ", "v2_"}]}], "]"}], "[", "a_", 
    "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rs", "=", 
       RowBox[{"ReplaceDummies", "[", "s", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rs", " ", 
       RowBox[{
        RowBox[{"Bracket", "[", 
         RowBox[{"v1", ",", "v2"}], "]"}], "[", "a", "]"}]}], "+", 
      RowBox[{
       RowBox[{
        RowBox[{"PD", "[", 
         RowBox[{"Dir", "[", "v1", "]"}], "]"}], "[", "rs", "]"}], 
       RowBox[{"ReplaceIndex", "[", 
        RowBox[{"v2", ",", 
         RowBox[{
          RowBox[{"UltraindexOf", "[", "v2", "]"}], "\[Rule]", "a"}]}], 
        "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8fe24089-946a-4313-ad73-a4c8df856712"],

Cell["\<\
Brackets to covariant derivatives. We need to worry about different manifolds:\
\>", "Text",ExpressionUUID->"e63a9e68-8baa-4831-9928-3db5f6781809"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BracketToCovD", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"covd_", ":", "PD"}]}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"Bracket", "[", 
       RowBox[{"v1_", ",", "v2_"}], "]"}], "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"u1", "=", 
          RowBox[{"UltraindexOf", "[", "v1", "]"}]}], ",", 
         RowBox[{"u2", "=", 
          RowBox[{"UltraindexOf", "[", "v2", "]"}]}]}], "}"}], ",", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"b", "=", 
            RowBox[{"DummyAs", "[", "u1", "]"}]}], ",", 
           RowBox[{"c", "=", 
            RowBox[{"DummyAs", "[", "u2", "]"}]}], ",", 
           RowBox[{"rv1", "=", 
            RowBox[{"ReplaceDummies", "[", "v1", "]"}]}], ",", 
           RowBox[{"rv2", "=", 
            RowBox[{"ReplaceDummies", "[", "v2", "]"}]}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"ReplaceIndex", "[", 
            RowBox[{"rv1", ",", 
             RowBox[{"u1", "\[Rule]", "b"}]}], "]"}], 
           RowBox[{
            RowBox[{"covd", "[", 
             RowBox[{"-", "b"}], "]"}], "[", 
            RowBox[{"ReplaceIndex", "[", 
             RowBox[{"rv2", ",", 
              RowBox[{"u2", "\[Rule]", "a"}]}], "]"}], "]"}]}], "-", 
          RowBox[{
           RowBox[{"ReplaceIndex", "[", 
            RowBox[{"rv2", ",", 
             RowBox[{"u2", "\[Rule]", "b"}]}], "]"}], 
           RowBox[{
            RowBox[{"covd", "[", 
             RowBox[{"-", "b"}], "]"}], "[", 
            RowBox[{"ReplaceIndex", "[", 
             RowBox[{"rv1", ",", 
              RowBox[{"u1", "\[Rule]", "a"}]}], "]"}], "]"}]}], "-", 
          RowBox[{"$TorsionSign", " ", 
           RowBox[{
            RowBox[{"Torsion", "[", "covd", "]"}], "[", 
            RowBox[{"a", ",", 
             RowBox[{"-", "b"}], ",", 
             RowBox[{"-", "c"}]}], "]"}], 
           RowBox[{"ReplaceIndex", "[", 
            RowBox[{"rv1", ",", 
             RowBox[{"u1", "\[Rule]", "b"}]}], "]"}], 
           RowBox[{"ReplaceIndex", "[", 
            RowBox[{"rv2", ",", 
             RowBox[{"u2", "\[Rule]", "c"}]}], "]"}]}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3feeb704-e9b1-405e-8a46-1b1700673f01"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e6ed0b42-88be-484c-90a9-05ba7732fbc1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"fc8b4979-7c09-43c3-a00e-cc628ff927ee"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"10a813bb-74b9-4761-94f3-31206cf7fa81"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ec994e5c-7b33-4de4-8c59-a8c330d7217c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6a4766ea-e217-460b-9789-ef144199147c"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"cbcdfeb7-4cd4-48d6-8941-a869b9867099"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"6a647569-2e5d-4705-9fa5-dcf845111690"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7b4a9dcc-1808-4a6a-8535-f4018aa912d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b8fb291a-6b3e-433e-b8c8-f9d455b919f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b74caaf6-ee8a-4932-a472-fd487246c8ef"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Bracket", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], 
      RowBox[{"v", "[", "A", "]"}]}], "+", 
     RowBox[{"w", "[", "A", "]"}]}], ",", 
    RowBox[{"4", 
     RowBox[{"w", "[", "A", "]"}]}]}], "]"}], "[", "A", 
  "]"}]], "Input",ExpressionUUID->"abaf1498-4b7b-4690-af70-9b6187b58519"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "12"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"Bracket", "[", 
        RowBox[{
         RowBox[{"v", "[", "A", "]"}], ",", " ", 
         RowBox[{"w", "[", "A", "]"}]}], "]"}], 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Bracket[
    $CellContext`v[$CellContext`A], 
    $CellContext`w[$CellContext`A]][$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"cd160592-6f8e-426f-ac1e-3551942b71ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ValidateBracket", "[", 
  RowBox[{"Evaluate", "[", 
   RowBox[{"%", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c816edbd-d208-4fe4-8ee2-7a5f358f8661"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"Bracket", "[", 
       RowBox[{
        RowBox[{"v", "[", "A", "]"}], ",", " ", 
        RowBox[{"w", "[", "A", "]"}]}], "]"}], 
      StyleBox[GridBox[{
         {"A"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Bracket[
   $CellContext`v[$CellContext`A], 
   $CellContext`w[$CellContext`A]][$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"a1e8153d-84a6-42b0-b2f9-bc52e589362b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Bracket", "[", 
   RowBox[{"0", ",", 
    RowBox[{"v", "[", "A", "]"}]}], "]"}], "[", "A", 
  "]"}]], "Input",ExpressionUUID->"b012bcb0-6964-4a13-9d86-cf3782a9093f"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"f37c3f85-c641-4a2b-a740-66238047c5df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"ca6fbb86-b607-43b1-ac1e-0935913fde9d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"A\"\>", ",", "\<\"B\"\>", ",", "\<\"F\"\>", ",", "\<\"G\"\>",
      ",", "\<\"M2\"\>", ",", "\<\"T\"\>", ",", "\<\"TangentM2\"\>", 
     ",", "\<\"v\"\>", ",", "\<\"w\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "A", "B", "F", "G", "M2", "T", "TangentM2", "v", "w"}],
  Editable->
   False]], "Print",ExpressionUUID->"0fd95a44-faa1-4e9f-a1b6-82a9d4ecee19"]
}, Open  ]],

Cell["Formatting:", \
"Text",ExpressionUUID->"455493eb-aa62-4251-b689-dc0a9f2f7dd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"Bracket", "[", 
     RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], "^:=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$WarningFrom", "=", "\"\<Bracket Formatting\>\""}], "}"}], ",", 
     RowBox[{"RowBox", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<[\>\"", ",", 
        RowBox[{"boxof", "@", 
         RowBox[{"MakeBoxes", "[", 
          RowBox[{"v1", ",", "StandardForm"}], "]"}]}], ",", "\"\<,\>\"", ",", 
        RowBox[{"boxof", "@", 
         RowBox[{"MakeBoxes", "[", 
          RowBox[{"v2", ",", "StandardForm"}], "]"}]}], ",", "\"\<]\>\""}], 
       "}"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4e711282-666d-4d16-9ed0-88dc27b76367"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"cb51a52b-ab21-4ff1-889a-c0807e333d0f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Bracket", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "B"}], "]"}]}], ",", 
    RowBox[{"w", "[", "A", "]"}]}], "]"}], "[", 
  RowBox[{"-", "A"}], 
  "]"}]], "Input",ExpressionUUID->"1f619f61-a320-47f3-ab13-139ce4e7896d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "B"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, $CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {" "},
                {"B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[-$CellContext`B],
         Editable->False]}], ",", GridBox[{
         {"w", 
          StyleBox[GridBox[{
             {"A"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "]"}], 
      StyleBox[GridBox[{
         {" "},
         {"A"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Bracket[$CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`v[-$CellContext`B], 
   $CellContext`w[$CellContext`A]][-$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"f42dd05d-9e4e-4880-bbfc-430ae91d191b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Bracket", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", "]"}], 
     RowBox[{"v", "[", "A", "]"}]}], ",", 
    RowBox[{"w", "[", "A", "]"}]}], "]"}], "[", "A", 
  "]"}]], "Input",ExpressionUUID->"1362ec69-8ba3-400f-a4fb-368778307cb0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox["T",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"[", GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], ",", GridBox[{
           {"w", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "]"}], 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Bracket[
     $CellContext`v[$CellContext`A], 
     $CellContext`w[$CellContext`A]][$CellContext`A],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "w"], "T"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Dir[
      $CellContext`w[$CellContext`A]]][
     $CellContext`T[]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"31080360-5484-41a2-9a05-3220144a64a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Bracket", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", "]"}], 
     RowBox[{"v", "[", "A", "]"}]}], ",", 
    RowBox[{
     RowBox[{"T", "[", "]"}], 
     RowBox[{"w", "[", "A", "]"}]}]}], "]"}], "[", "A", 
  "]"}]], "Input",ExpressionUUID->"e30b8d0e-3707-43d0-9786-6802d7b2b462"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox["T",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["T",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"[", GridBox[{
              {"v", 
               StyleBox[GridBox[{
                  {"A"},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}], ",", GridBox[{
              {"w", 
               StyleBox[GridBox[{
                  {"A"},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}], "]"}], 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Bracket[
        $CellContext`v[$CellContext`A], 
        $CellContext`w[$CellContext`A]][$CellContext`A],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[PartialD]", "v"], "T"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`PD[
        xAct`xTensor`Dir[
         $CellContext`v[$CellContext`A]]][
        $CellContext`T[]],
       Editable->False]}]}], ")"}]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox["T",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "w"], "T"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Dir[
      $CellContext`w[$CellContext`A]]][
     $CellContext`T[]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"175c5b6c-d5c3-4b8c-b0fe-ed0334f102fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}], ",", 
   RowBox[{"Torsion", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"0dbb9e69-0bc6-4b80-854c-8bdda3b3d4e7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"059f8cb6-acf8-4c5b-90a7-4bb8b82acc06"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5d6af1a7-df08-4789-9bb6-853ffab6fe5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "non-symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"2981d7b3-0fbd-4b60-8aa0-369b86f162eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"f5f594f6-baa9-420b-b6c9-23867932c52a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4e5e6109-e662-400b-af6b-0925306464d3"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"2bfa9865-1b5a-4f99-9b14-28c670e33b88"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BracketToCovD", "[", 
   RowBox[{
    RowBox[{"Bracket", "[", 
     RowBox[{
      RowBox[{"v", "[", "A", "]"}], ",", 
      RowBox[{"w", "[", "A", "]"}]}], "]"}], "[", "A", "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"2c9e3f66-1165-432c-a678-dfb8668b37ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"w", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{",", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`B][
     $CellContext`v[$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{",", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`B][
     $CellContext`w[$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"b399c5ef-55a0-44b8-8ad5-1eb28b925665"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BracketToCovD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Bracket", "[", 
      RowBox[{
       RowBox[{"v", "[", "A", "]"}], ",", 
       RowBox[{"w", "[", "A", "]"}]}], "]"}], "[", "A", "]"}], ",", "CD"}], 
   "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"76afbbf3-6116-403a-8475-69f9776037d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[
      SubscriptBox["s", "T"],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`$TorsionSign,
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"T", "[", "D", "]"}], 
        StyleBox[GridBox[{
           {"A", " ", " "},
           {" ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[C],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{";", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`B][
     $CellContext`v[$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{";", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`B][
     $CellContext`w[$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"ca0fe17e-ec1f-4cbe-b2ea-74ff90426c9c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "CD", 
  "]"}]], "Input",ExpressionUUID->"90fcf5f8-6ee2-4251-baea-39887213dc4a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"ab451ded-e50f-4b84-9232-18953e1ad577"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"1b4d973d-0c27-46a8-adc4-371c6e3be9f6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"fd1e52ae-d618-4c38-80fa-7cd72b57eb3f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"1d15d036-3999-475f-9eca-a167a978e875"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"d9551057-1784-4e1a-b468-1a115861332a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"747624ea-9c6c-4eac-ace6-ba860fc641cf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"A$\"\>", ",", "\<\"B$\"\>", ",", "\<\"G1\"\>", 
     ",", "\<\"G2\"\>", ",", "\<\"G3\"\>", ",", "\<\"G$231771\"\>", 
     ",", "\<\"G$231772\"\>", ",", "\<\"G$231776\"\>", 
     ",", "\<\"G$231777\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "A$", "B$", "G1", "G2", "G3", "G$231771", "G$231772", "G$231776", 
    "G$231777"}],
  Editable->
   False]], "Print",ExpressionUUID->"0c24539d-2e6f-44bd-a31f-e19fde25eec7"]
}, Open  ]],

Cell["Implement skewsymmetry:", \
"Text",ExpressionUUID->"b2814de5-1bf4-4572-b13b-a165fcc134d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{"expr1_", ",", "expr2_"}], "]"}], "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{
     RowBox[{"Bracket", "[", 
      RowBox[{"expr2", ",", "expr1"}], "]"}], "[", "i", "]"}]}], "/;", 
   RowBox[{"OrderedQ", "[", 
    RowBox[{"{", 
     RowBox[{"expr2", ",", "expr1"}], "}"}], "]"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1c6871df-0895-4d2a-a56c-f010104b791f"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c6db4efa-ae3d-4bf8-b5ae-8ea8735bebf8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{
     RowBox[{"v", "[", "A", "]"}], ",", 
     RowBox[{"w", "[", "A", "]"}]}], "]"}], "[", "A", "]"}], "+", 
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{
     RowBox[{"w", "[", "A", "]"}], ",", 
     RowBox[{"v", "[", "A", "]"}]}], "]"}], "[", "A", 
   "]"}]}]], "Input",ExpressionUUID->"75466f6a-508b-4e16-8fce-7cd23ddc78ec"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"1d2d1d4c-b0b1-44de-9a85-7352448e69e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", "$Tensors"}], 
  ";"}]], "Input",ExpressionUUID->"25fdb6e0-8d21-4565-a579-5ead55a6ea93"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"f867aaed-1258-4831-b6f0-c4566e47a839"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"ad998ab6-bf0b-4a77-9eb7-ab088c422d6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"723618f8-e68f-4385-aa52-2872797a029b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"202d0ad5-6620-4345-8efd-5be03db651ef"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"e6ab2490-f730-430d-9f25-61f366bce3a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"85f46c1a-a608-4d62-a6f8-2dd0d27fe87d"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"86f6bcd8-0e0f-4c30-90b5-7aa7ff948250"],

Cell["QUESTION: Can we implement the Jacobi identity?", \
"Text",ExpressionUUID->"a7dd8c92-f1bd-4d6f-b857-f671a24ef1f9"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.6. PullBack and PushForward", \
"Subsection",ExpressionUUID->"cd67aa66-24b9-4210-9a25-45f4fde6579b"],

Cell[CellGroupData[{

Cell["12.6.1 PullBack", \
"Subsubsection",ExpressionUUID->"ebf0d49a-a8a4-4b94-acda-7ba2d1df3cac"],

Cell["\<\
A pullback under \[Phi] : M->N is a combined operation: a precomposition (to \
change dependencies from N to M) and then a linear transformation using the \
transpose of d\[Phi]. The result is a tensor with different dependencies and \
with different indices (the new indices are starred if and only if the \
original indices are starred). We require from the user to specify explicitly \
the change of free indices, but not for dummies. There should be a default, \
because that is problematic for Dir-type arguments (ultraindices).\
\>", "Text",ExpressionUUID->"34e2d39a-fbd0-4137-92d3-c0d9f701e3ec"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PullBack", "[", 
    RowBox[{"expr_Plus", ",", "phi_", ",", "firules_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"PullBack", "[", 
      RowBox[{"#", ",", "phi", ",", "firules"}], "]"}], "&"}], "/@", 
    "expr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBack", "[", 
    RowBox[{"expr_", ",", "phi_", ",", "firules_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dom", "=", 
        RowBox[{"MappingDomain", "[", "phi", "]"}]}], ",", 
       RowBox[{"im", "=", 
        RowBox[{"MappingImage", "[", "phi", "]"}]}], ",", 
       RowBox[{"fdindices", "=", 
        RowBox[{"FindFreeAndDummyIndices", "[", "expr", "]"}]}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"allirules", "=", 
         RowBox[{"PBIndexRules", "[", 
          RowBox[{"fdindices", ",", "firules", ",", 
           RowBox[{"Tangent", "[", "dom", "]"}], ",", 
           RowBox[{"Tangent", "[", "im", "]"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Apply", "[", 
        RowBox[{"Times", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"PullBack1", "[", 
            RowBox[{"#", ",", "phi", ",", "allirules"}], "]"}], "&"}], "/@", 
          RowBox[{"ListOfFactors", "[", "expr", "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"55eddb0e-b3d6-4e26-93ec-b5724ee9e310"],

Cell["\<\
This could be made safer by using DuplicateRule and Replace only. TODO: check \
invertibility for the lower indices.\
\>", "Text",ExpressionUUID->"81c142bd-f5c4-4af7-a165-f53315690610"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBack1", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
      "phi_", ",", "allirules_List"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"newinds", "=", 
        RowBox[{"ReplaceIndexList", "[", 
         RowBox[{
          RowBox[{"IndexList", "[", "inds", "]"}], ",", "allirules"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"newinds", "===", 
         RowBox[{"IndexList", "[", "inds", "]"}]}], ",", 
        RowBox[{"tensor", "[", "inds", "]"}], ",", 
        RowBox[{
         RowBox[{"PullBackTensor", "[", 
          RowBox[{"tensor", ",", "phi"}], "]"}], "@@", "newinds"}]}], "]"}]}],
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TODO", ":", " ", 
    RowBox[{"What", " ", "happens", " ", "if", " ", 
     RowBox[{
      RowBox[{"covd", "[", "_", "]"}], "[", "dphi", "]"}], " ", "is", " ", 
     "not", " ", 
     RowBox[{"zero", "?"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PullBack1", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", 
       "]"}], ",", "phi_", ",", "allirules_List"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{"PullBackCovD", "[", 
        RowBox[{"covd", ",", "phi"}], "]"}], ",", 
       RowBox[{"ReplaceIndexList", "[", 
        RowBox[{
         RowBox[{"IndexList", "[", "inds", "]"}], ",", "allirules"}], "]"}]}],
       "]"}], "[", 
     RowBox[{"PullBack1", "[", 
      RowBox[{"expr", ",", "phi", ",", "allirules"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TODO", ":", " ", 
    RowBox[{
    "We", " ", "need", " ", "something", " ", "special", " ", "for", " ", 
     "the", " ", "ultraindex"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBack1", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", "phi_", ",",
      "allirules_List"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"PullBack1", "[", 
      RowBox[{"v", ",", "phi", ",", "allirules"}], "]"}], "]"}], "[", 
    RowBox[{"PullBack1", "[", 
     RowBox[{"expr", ",", "phi", ",", "allirules"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PullBack1", "[", 
    RowBox[{
     RowBox[{"c_", "?", "ConstantQ"}], ",", "phi_", ",", "allirules_List"}], 
    "]"}], ":=", "c"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3df4098c-8d84-49e8-9ca3-4deb94c8064c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PullBack", "::", "frees"}], "=", 
   "\"\<Missing pull-back rules for free indices `1` of tangent bundle `2`.\>\
\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b2fcbff0-e9aa-4cd1-841a-070c9fe48364"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PBIndexRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"frees_IndexList", ",", "dummies_IndexList"}], "}"}], ",", 
     "firules_List", ",", "tdom_", ",", "tim_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"timpmQ", "=", 
       RowBox[{"VBundleIndexPMQ", "[", "tim", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"#", "=!=", 
           RowBox[{"{", "}"}]}], ",", 
          RowBox[{"Throw", "[", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"PullBack", "::", "frees"}], ",", "#", ",", "tim"}], 
            "]"}], "]"}]}], "]"}], "&"}], "@", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"List", "@@", "frees"}], ",", "timpmQ"}], "]"}], ",", 
         RowBox[{"First", "/@", "firules"}]}], "]"}]}], ";", 
      RowBox[{"Join", "[", 
       RowBox[{"firules", ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Rule", "@@", "#"}], ",", 
             RowBox[{"Rule", "@@", 
              RowBox[{"(", 
               RowBox[{"-", "#"}], ")"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#", ",", 
               RowBox[{"DummyIn", "[", "tdom", "]"}]}], "}"}], "&"}], "/@", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"List", "@@", "dummies"}], ",", "timpmQ"}], "]"}]}], 
           ")"}]}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"119d50b6-e72f-49d9-9027-a48fc5c54b2d"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.6.2. ExpandPullBack", \
"Subsubsection",ExpressionUUID->"0752103e-645a-48aa-b5d4-e327701ae061"],

Cell["\<\
Expand a PullBackTensor or a PullBackCovD expression into a precomposition \
contracted with tangent-map factors.\
\>", "Text",ExpressionUUID->"0f838329-0766-4700-8159-c10d3e15150c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandPullBack", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"PullBackTensor", "[", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
          RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "[", "inds___", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"ExpandPullBackTensor", "[", 
        RowBox[{"tensor", ",", "phi", ",", 
         RowBox[{"{", "inds", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"PullBackCovD", "[", 
          RowBox[{
           RowBox[{"covd_", "?", "CovDQ"}], ",", 
           RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "[", "ind_", "]"}], 
        "[", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"ExpandPullBackCovD", "[", 
        RowBox[{"covd", ",", "phi", ",", 
         RowBox[{"{", "ind", "}"}], ",", "tensor", ",", 
         RowBox[{"{", "inds", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"TensorDerivative", "[", 
         RowBox[{
          RowBox[{"Precompose", "[", 
           RowBox[{
            RowBox[{"tensor_", "?", "xTensorQ"}], ",", "phi_"}], "]"}], ",", 
          RowBox[{"PullBackCovD", "[", 
           RowBox[{
            RowBox[{"covd_", "?", "CovDQ"}], ",", 
            RowBox[{"phi_", "?", "MappingQ"}]}], "]"}]}], "]"}], "[", 
        RowBox[{"inds___", ",", "ind_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"ExpandPullBackCovD", "[", 
        RowBox[{"covd", ",", "phi", ",", 
         RowBox[{"{", "ind", "}"}], ",", "tensor", ",", 
         RowBox[{"{", "inds", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
     "}"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ff649c3f-f10d-4c1f-bd70-f667ffec4b93"],

Cell["Tensors:", \
"Text",ExpressionUUID->"7b1a5ec8-8534-4aa5-b671-264f93feabac"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExpandPullBackTensor", "[", 
    RowBox[{"tensor_", ",", "phi_", ",", "inds_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dphi", "=", 
        RowBox[{"TangentTensor", "[", "phi", "]"}]}], ",", 
       RowBox[{"tim", "=", 
        RowBox[{"Tangent", "[", 
         RowBox[{"MappingImage", "[", "phi", "]"}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ilist", "=", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"pullfactor1", "[", 
             RowBox[{"#", ",", "dphi", ",", "tim", ",", 
              RowBox[{"PullBackVBundle", "[", 
               RowBox[{"tim", ",", "phi"}], "]"}]}], "]"}], "&"}], "/@", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", "inds"}], 
             "}"}], "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Precompose", "[", 
          RowBox[{"tensor", ",", "phi"}], "]"}], "@@", 
         RowBox[{"First", "[", "ilist", "]"}]}], 
        RowBox[{"Times", "@@", 
         RowBox[{"Last", "[", "ilist", "]"}]}]}]}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pullfactor1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "tim_"}], ",", 
       RowBox[{"ind_", "?", "DownIndexQ"}]}], "}"}], ",", "dphi_", ",", 
     "tim_", ",", "ptim_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"new", "=", 
       RowBox[{"DummyIn", "[", "ptim", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "new"}], ",", 
       RowBox[{"dphi", "[", 
        RowBox[{"ind", ",", "new"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pullfactor1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tim_", ",", 
       RowBox[{"ind_", "?", "UpIndexQ"}]}], "}"}], ",", "dphi_", ",", "tim_", 
     ",", "ptim_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"new", "=", 
       RowBox[{"DummyIn", "[", "ptim", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"new", ",", 
       RowBox[{
        RowBox[{"Inv", "[", "dphi", "]"}], "[", 
        RowBox[{
         RowBox[{"-", "new"}], ",", "ind"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pullfactor1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "ind_"}], "}"}], ",", "dphi_", ",", "tim_", ",", 
     "ptim_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"ind", ",", "1"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d302d7d0-b246-4099-852e-e05faf090bb7"],

Cell["Covariant derivatives:", \
"Text",ExpressionUUID->"37806ca6-f40f-4c0c-a5f5-8cb9c384b816"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandPullBackCovD", "[", 
    RowBox[{"covd_", ",", "phi_", ",", 
     RowBox[{"{", "ind_", "}"}], ",", "tensor_", ",", "inds_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dphi", "=", 
        RowBox[{"TangentTensor", "[", "phi", "]"}]}], ",", 
       RowBox[{"new", "=", 
        RowBox[{"DummyIn", "[", 
         RowBox[{"PullBackVBundle", "[", 
          RowBox[{
           RowBox[{"VBundleOfIndex", "[", "ind", "]"}], ",", "phi"}], "]"}], 
         "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dphi", "[", 
       RowBox[{"ind", ",", "new"}], "]"}], 
      RowBox[{
       RowBox[{"Precompose", "[", 
        RowBox[{
         RowBox[{"TensorDerivative", "[", 
          RowBox[{"tensor", ",", "covd"}], "]"}], ",", "phi"}], "]"}], "@@", 
       RowBox[{"Join", "[", 
        RowBox[{"inds", ",", 
         RowBox[{"{", 
          RowBox[{"-", "new"}], "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f0983520-2d9b-49db-ab9b-69524cfaa615"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.6.3. PushForward", \
"Subsubsection",ExpressionUUID->"f8d19644-0913-4669-abbb-c0750fcd3f01"],

Cell["First handle the abstract indices and generalize later.", \
"Text",ExpressionUUID->"b10eaf14-388e-489c-956b-a01761e0913a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PushForward", "[", 
    RowBox[{"expr_Plus", ",", "phi_", ",", "firules_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"PushForward", "[", 
      RowBox[{"#", ",", "phi", ",", "firules"}], "]"}], "&"}], "/@", 
    "expr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PushForward", "[", 
    RowBox[{"expr_", ",", "phi_", ",", "firules_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dom", "=", 
        RowBox[{"MappingDomain", "[", "phi", "]"}]}], ",", 
       RowBox[{"im", "=", 
        RowBox[{"MappingImage", "[", "phi", "]"}]}], ",", 
       RowBox[{"fdindices", "=", 
        RowBox[{"FindFreeAndDummyIndices", "[", "expr", "]"}]}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"allirules", "=", 
         RowBox[{"PFIndexRules", "[", 
          RowBox[{"fdindices", ",", "firules", ",", 
           RowBox[{"Tangent", "[", "dom", "]"}], ",", 
           RowBox[{"Tangent", "[", "im", "]"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Apply", "[", 
        RowBox[{"Times", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"PushForward1", "[", 
            RowBox[{"#", ",", "phi", ",", "allirules"}], "]"}], "&"}], "/@", 
          RowBox[{"ListOfFactors", "[", "expr", "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3f3525d1-b658-4de8-9fad-30daf34cbb00"],

Cell["\<\
This could be made safer by using DuplicateRule and Replace only. TODO: check \
invertibility for the lower indices.\
\>", "Text",ExpressionUUID->"a02a3a34-8b64-4950-93c3-c2efabf92dfd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PushForward1", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], ",", 
      "phi_", ",", "allirules_List"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"newinds", "=", 
        RowBox[{"ReplaceIndexList", "[", 
         RowBox[{
          RowBox[{"IndexList", "[", "inds", "]"}], ",", "allirules"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"newinds", "===", 
         RowBox[{"IndexList", "[", "inds", "]"}]}], ",", 
        RowBox[{"tensor", "[", "inds", "]"}], ",", 
        RowBox[{
         RowBox[{"PushForwardTensor", "[", 
          RowBox[{"tensor", ",", "phi"}], "]"}], "@@", "newinds"}]}], "]"}]}],
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"What", " ", "is", " ", "the", " ", "push"}], "-", 
    RowBox[{"forward", " ", "of", " ", "a", " ", "covariant", " ", 
     RowBox[{"derivative", "?"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PushForward1", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], "[", "expr_", 
      "]"}], "]"}], ":=", "TODO"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TODO", ":", " ", 
    RowBox[{
    "We", " ", "need", " ", "something", " ", "special", " ", "for", " ", 
     "the", " ", "ultraindices"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PushForward1", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", "phi_", ",",
      "allirules_List"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"PushForward1", "[", 
      RowBox[{"v", ",", "phi", ",", "allirules"}], "]"}], "]"}], "[", 
    RowBox[{"PushForward1", "[", 
     RowBox[{"expr", ",", "phi", ",", "allirules"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PushForward1", "[", 
    RowBox[{
     RowBox[{"c_", "?", "ConstantQ"}], ",", "phi_", ",", "allirules_List"}], 
    "]"}], ":=", "c"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8a3ae913-74af-488d-ba20-1171b27845d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PushForward", "::", "frees"}], "=", 
   "\"\<Missing push-forward rules for free indices `1` of tangent bundle \
`2`.\>\""}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c5a80ef1-de33-4822-bad2-cbd813fd5512"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PFIndexRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"frees_IndexList", ",", "dummies_IndexList"}], "}"}], ",", 
     "firules_List", ",", "tdom_", ",", "tim_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tdompmQ", "=", 
       RowBox[{"VBundleIndexPMQ", "[", "tdom", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"#", "=!=", 
           RowBox[{"{", "}"}]}], ",", 
          RowBox[{"Throw", "[", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"PushForward", "::", "frees"}], ",", "#", ",", "tdom"}], 
            "]"}], "]"}]}], "]"}], "&"}], "@", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"List", "@@", "frees"}], ",", "tdompmQ"}], "]"}], ",", 
         RowBox[{"First", "/@", "firules"}]}], "]"}]}], ";", 
      RowBox[{"Join", "[", 
       RowBox[{"firules", ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Rule", "@@", "#"}], ",", 
             RowBox[{"Rule", "@@", 
              RowBox[{"(", 
               RowBox[{"-", "#"}], ")"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#", ",", 
               RowBox[{"DummyIn", "[", "tim", "]"}]}], "}"}], "&"}], "/@", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"List", "@@", "dummies"}], ",", "tdompmQ"}], "]"}]}], 
           ")"}]}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"08b002cf-edf3-4c6f-91da-964cdef39d34"]
}, Closed]],

Cell[CellGroupData[{

Cell["12.6.4. ExpandPushForward", \
"Subsubsection",ExpressionUUID->"b60d987f-2bec-4992-9528-6384bf7b2ccc"],

Cell["\<\
This function converts a PushForwardTensor object into a product of the \
original tensor and a bunch of tangent mappings.\
\>", "Text",ExpressionUUID->"e094033f-cb5e-484f-9fd1-53c2fb63a84f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandPushForward", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"LinearPush", "[", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
          RowBox[{"dphi_", "?", "xTensorQ"}]}], "]"}], "[", "inds___", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"ExpandLinearPush", "[", 
        RowBox[{"tensor", ",", "dphi", ",", 
         RowBox[{"{", "inds", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"PushForwardTensor", "[", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], ",", 
          RowBox[{"phi_", "?", "MappingQ"}]}], "]"}], "[", "inds___", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"ExpandPushForwardTensor", "[", 
        RowBox[{"tensor", ",", "phi", ",", 
         RowBox[{"{", "inds", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
     "}"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"df5173b0-5fd3-477f-bc3d-7ab29fc27449"],

Cell["Linear push of a tensor:", \
"Text",ExpressionUUID->"64bb53e3-99c7-494a-b906-653395032c2f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExpandLinearPush", "[", 
    RowBox[{"tensor_", ",", "dphi_", ",", "inds_List"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tdom", "=", 
       RowBox[{"-", 
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "dphi", "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ilist", "=", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"pushfactor1", "[", 
             RowBox[{"#", ",", "dphi", ",", "tdom"}], "]"}], "&"}], "/@", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", "inds"}], 
             "}"}], "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"tensor", "@@", 
         RowBox[{"First", "[", "ilist", "]"}]}], 
        RowBox[{"Times", "@@", 
         RowBox[{"Last", "[", "ilist", "]"}]}]}]}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pushfactor1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tdom_", ",", 
       RowBox[{"ind_", "?", "UpIndexQ"}]}], "}"}], ",", "dphi_", ",", 
     "tdom_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"new", "=", 
       RowBox[{"DummyIn", "[", "tdom", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"new", ",", 
       RowBox[{"dphi", "[", 
        RowBox[{
         RowBox[{"-", "new"}], ",", "ind"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pushfactor1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "tdom_"}], ",", 
       RowBox[{"ind_", "?", "DownIndexQ"}]}], "}"}], ",", "dphi_", ",", 
     "tdom_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"new", "=", 
       RowBox[{"DummyIn", "[", "tdom", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "new"}], ",", 
       RowBox[{
        RowBox[{"Inv", "[", "dphi", "]"}], "[", 
        RowBox[{"ind", ",", "new"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pushfactor1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "ind_"}], "}"}], ",", "dphi_", ",", "tdom_"}], "]"}], 
   ":=", 
   RowBox[{"{", 
    RowBox[{"ind", ",", "1"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a39a45ba-b894-4305-82dc-e71352d7ce93"],

Cell["Push forward of a tensor field:", \
"Text",ExpressionUUID->"22c31657-e6e3-4b87-abaf-e303650d25e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandPushForwardTensor", "[", 
    RowBox[{"tensor_", ",", "phi_", ",", "inds_List"}], "]"}], ":=", 
   RowBox[{"ExpandPullBackTensor", "[", 
    RowBox[{"tensor", ",", 
     RowBox[{"InverseMapping", "[", "phi", "]"}], ",", "inds"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d6fbcf1f-4609-43e6-bae2-997e2dc60ca5"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["13. Variational derivatives",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"061526d0-36b8-45eb-9a02-7c0613e4d2da"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
   RowBox[{"*", " ", "13.", "Variational", " ", "derivatives"}]}], " ", 
  "********************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"efad8d1e-b853-4f40-8653-9996ad111903"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"0a5ab8c6-cf6b-4c4e-a0d8-969e27b425aa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "56.806728`", ",", "573.228601`9.209872844702431", ",", 
   "0.0990996550460124`"}], 
  "}"}]], "Output",ExpressionUUID->"2a7d0bc4-1f6a-478b-a8b8-3cdcd1ed85cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell["13.0. Comments", \
"Subsection",ExpressionUUID->"6b8f6dee-7364-44e8-a09a-63162a7d56b4"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{
   "Print", "[", "\"\<Reading section 13: Variational derivatives.\>\"", 
    "]"}], ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"22d14802-4f60-458b-8181-4dbd66e57d90"]
}, Closed]],

Cell[CellGroupData[{

Cell["13.1. Code", \
"Subsection",ExpressionUUID->"922e8fc7-65ee-465c-91f6-1e4f9988faf9"],

Cell["Public function:", \
"Text",ExpressionUUID->"3398d90b-929b-4846-884a-2fef50a120c9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImplicitTensorDepQ", "[", 
    RowBox[{"tensor_", ",", "tensor_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ImplicitTensorDepQ", "[", 
     RowBox[{"list_List", ",", "tensor_"}], "]"}], ":=", 
    RowBox[{"Apply", "[", 
     RowBox[{"Or", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"ImplicitTensorDepQ", "[", 
         RowBox[{"#", ",", "tensor"}], "]"}], "&"}], "/@", "list"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Default", " ", "behaviour"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImplicitTensorDepQ", "[", 
    RowBox[{"tensor1_", ",", "tensor2_"}], "]"}], ":=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ImplicitTensorDepQ", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ImplicitTensorDepQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d1730db8-bb94-45d1-94e0-0cb5811c9da8"],

Cell[TextData[{
 "Currently we only allow variational derivatives of scalar expressions. \
Other cases seem problematic: for instance, the delta we generate in VarD[ \
v[a], PD ][ v[b] ] is actually a Kronecker and not a tensor, because \
VarD[v[a], PD][ v[a] ] is 1 and not dim. We replace initially all dummies and \
so we will never find such delta[-a, a] case.\n\nVariational derivatives \
should differentiate functionals, and not their integrands. However, ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " does not yet have a concept of integration and hence we develop an \
alternative notation: we work with the derivative which would be compatible \
with the given volume form."
}], "Text",ExpressionUUID->"0a194318-addf-40ef-afe4-e64dc1f1c1bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Assume", " ", "PD", " ", "derivative"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", "tensor_", "]"}], "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor", ",", "PD"}], "]"}], "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Generate", " ", 
     RowBox[{"rest", ".", " ", "Replace"}], " ", "dummies", " ", "in", " ", 
     RowBox[{"expr", ".", " ", "This"}], " ", "does", " ", "not", " ", "act", 
     " ", "on", " ", "scalar", " ", "arguments", " ", "of", " ", 
     "functions"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", "expr_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ScalarQ", "[", "expr", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{"tensor", ",", "der"}], "]"}], "[", 
        RowBox[{
         RowBox[{"ReplaceDummies", "[", "expr", "]"}], ",", "1"}], "]"}], ",",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"VarD", "::", "nouse"}], ",", "\"\<VarD\>\"", ",", 
          "\"\<a non-scalar expression\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NonScalarVarD", "[", 
          RowBox[{"tensor", ",", "der"}], "]"}], "[", "expr", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Thread", " ", "over", " ", "Plus"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
      RowBox[{"expr_Plus", ",", "rest_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{"tensor", ",", "der"}], "]"}], "[", 
        RowBox[{"#", ",", "rest"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
      RowBox[{"expr_SeriesData", ",", "rest_"}], "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"VarD", "[", 
          RowBox[{"tensor", ",", "der"}], "]"}], "[", 
         RowBox[{"#", ",", "rest"}], "]"}], "&"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"VarD", " ", "on", " ", 
     RowBox[{"products", ":", " ", 
      RowBox[{"sum", " ", "of", " ", 
       RowBox[{"VarDtake", "'"}], "s", " ", "of", " ", "elements"}]}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
      RowBox[{"expr_Times", ",", "rest_"}], "]"}], ":=", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"VarDtake", "[", 
        RowBox[{"tensor", ",", "der", ",", "rest", ",", 
         RowBox[{"List", "@@", "expr"}], ",", "count"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"count", ",", 
         RowBox[{"Length", "@", "expr"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "VarD", " ", "element", " ", "n", " ", "of", " ", "a", " ", "list", " ", 
     "of", " ", "factors"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"VarDtake", "[", 
      RowBox[{
      "tensor_", ",", "der_", ",", "rest_", ",", "list_List", ",", 
       "n_Integer"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor", ",", "der"}], "]"}], "[", 
      RowBox[{
       RowBox[{"list", "[", 
        RowBox[{"[", "n", "]"}], "]"}], ",", 
       RowBox[{"Times", "@@", 
        RowBox[{"ReplacePart", "[", 
         RowBox[{"list", ",", "rest", ",", "n"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Scalar", " ", "functions", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
        RowBox[{
         RowBox[{
          RowBox[{"func_", "?", "ScalarFunctionQ"}], "[", "expr_", "]"}], ",",
          "rest_"}], "]"}]}], ":=", 
      RowBox[{
       RowBox[{"VarD", "[", 
        RowBox[{"tensor", ",", "der"}], "]"}], "[", 
       RowBox[{
        RowBox[{"ReplaceDummies", "[", "expr", "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"func", "'"}], "[", "expr", "]"}], "rest"}]}], "]"}]}], 
     ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
      "Leo", " ", "suggested", " ", "the", " ", "exponent", " ", "term", " ", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
        RowBox[{
         RowBox[{"Power", "[", 
          RowBox[{"base_", ",", "exponent_"}], "]"}], ",", "rest_"}], "]"}]}],
       ":=", 
      RowBox[{
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{"tensor", ",", "der"}], "]"}], "[", 
        RowBox[{
         RowBox[{"ReplaceDummies", "[", "base", "]"}], ",", 
         RowBox[{"exponent", " ", 
          RowBox[{"Power", "[", 
           RowBox[{"base", ",", 
            RowBox[{"exponent", "-", "1"}]}], "]"}], "rest"}]}], "]"}], "+", 
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{"tensor", ",", "der"}], "]"}], "[", 
        RowBox[{
         RowBox[{"ReplaceDummies", "[", "exponent", "]"}], ",", 
         RowBox[{
          RowBox[{"Power", "[", 
           RowBox[{"base", ",", "exponent"}], "]"}], 
          RowBox[{"Log", "[", "base", "]"}], "rest"}]}], "]"}]}]}], ";"}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Scalar", " ", 
     RowBox[{"functions", ".", " ", "Multiargument"}], " ", "generalization", 
     " ", "contributed", " ", "by", " ", 
     RowBox[{"Leo", ".", " ", "multiD"}], " ", "is", " ", "not", " ", 
     "enough", " ", "here"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"func_", "?", "ScalarFunctionQ"}], "[", "args__", "]"}], ",", 
       "rest_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"repargs", "=", 
         RowBox[{"ReplaceDummies", "/@", 
          RowBox[{"{", "args", "}"}]}]}], "}"}], ",", 
       RowBox[{"Plus", "@@", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"VarD", "[", 
             RowBox[{"tensor", ",", "der"}], "]"}], "[", 
            RowBox[{"#1", ",", 
             RowBox[{"rest", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Derivative", "@@", "#2"}], ")"}], "@", "func"}], "@@",
                "repargs"}]}]}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"repargs", ",", 
            RowBox[{"IdentityMatrix", "@", 
             RowBox[{"Length", "@", "repargs"}]}]}], "}"}]}], "]"}]}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Remove", " ", "Scalar", " ", "head", " ", "because", " ", "in", " ", 
     "general", " ", "the", " ", "result", " ", "is", " ", "not", " ", "a", 
     " ", "scalar"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"Scalar", "[", "expr_", "]"}], ",", "rest_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor", ",", "der"}], "]"}], "[", 
      RowBox[{
       RowBox[{"ReplaceDummies", "[", "expr", "]"}], ",", "rest"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Constants", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "der_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"x_", "?", "ConstantQ"}], ",", "rest_"}], "]"}], ":=", "0"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Same", " ", 
      RowBox[{"tensor", ":", " ", 
       RowBox[{
        RowBox[{"metric", ".", " ", "Do"}], " ", "not", " ", "use", " ", 
        "ContractMetric"}]}]}], ",", " ", 
     RowBox[{"which", " ", "hides", " ", "the", " ", "metric"}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{
        RowBox[{"metric_", "[", 
         RowBox[{"a_", ",", "b_"}], "]"}], ",", "der_"}], "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"metric_Symbol", "?", "MetricQ"}], "[", 
        RowBox[{"c_", ",", "d_"}], "]"}], ",", "rest_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"metricsign", "[", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], 
      RowBox[{"ToCanonical", "[", 
       RowBox[{
        RowBox[{"rest", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"ChangeIndex", "@", "a"}], ",", "c"}], "]"}], 
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"ChangeIndex", "@", "b"}], ",", "d"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"ChangeIndex", "@", "a"}], ",", "d"}], "]"}], 
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"ChangeIndex", "@", "b"}], ",", "c"}], "]"}]}]}], 
           ")"}], "/", "2"}]}], ",", 
        RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], "]"}]}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsign", "[", 
      RowBox[{"_Symbol", ",", "_Symbol", ",", "_Symbol", ",", "_Symbol"}], 
      "]"}], ":=", "1"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsign", "[", 
      RowBox[{
       RowBox[{"-", "_Symbol"}], ",", 
       RowBox[{"-", "_Symbol"}], ",", 
       RowBox[{"-", "_Symbol"}], ",", 
       RowBox[{"-", "_Symbol"}]}], "]"}], ":=", "1"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsign", "[", 
      RowBox[{
       RowBox[{"-", "_Symbol"}], ",", 
       RowBox[{"-", "_Symbol"}], ",", "_Symbol", ",", "_Symbol"}], "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsign", "[", 
      RowBox[{"_Symbol", ",", "_Symbol", ",", 
       RowBox[{"-", "_Symbol"}], ",", 
       RowBox[{"-", "_Symbol"}]}], "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"metricsign", "[", 
      RowBox[{"_", ",", "_", ",", "_", ",", "_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Same", " ", 
     RowBox[{"tensor", ".", " ", "Place"}], " ", "indices", " ", "in", " ", 
     "proper", " ", "delta", " ", 
     RowBox[{"positions", ".", " ", 
      RowBox[{"QUESTION", ":", " ", 
       RowBox[{
       "could", " ", "this", " ", "be", " ", "problematic", " ", "for", " ", 
        RowBox[{"spinors", "?"}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"varddelta", "[", 
      RowBox[{
       RowBox[{"ind1_", "?", "UpIndexQ"}], ",", 
       RowBox[{"ind2_", "?", "DownIndexQ"}]}], "]"}], ":=", 
     RowBox[{"delta", "[", 
      RowBox[{"ind2", ",", "ind1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"varddelta", "[", 
      RowBox[{"ind1_", ",", "ind2_"}], "]"}], ":=", 
     RowBox[{"delta", "[", 
      RowBox[{"ind1", ",", "ind2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{
        RowBox[{"tensor_", "[", "inds1___", "]"}], ",", "der_"}], "]"}], "[", 
      
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds2___", "]"}], ",", 
       "rest_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"clist", "=", 
         RowBox[{"ChangeIndex", "/@", 
          RowBox[{"IndexList", "[", "inds1", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ToCanonical", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ImposeSymmetry", "[", 
           RowBox[{
            RowBox[{"Inner", "[", 
             RowBox[{"varddelta", ",", "clist", ",", 
              RowBox[{"IndexList", "[", "inds2", "]"}], ",", "Times"}], "]"}],
             ",", "clist", ",", 
            RowBox[{"SymmetryGroupOfTensor", "[", 
             RowBox[{"tensor", "[", "inds1", "]"}], "]"}]}], "]"}], "rest"}], 
         ",", 
         RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"A", " ", "different", " ", "tensor"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{
        RowBox[{"tensor1_", "[", "inds1___", "]"}], ",", "der_"}], "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor2_", "?", "xTensorQ"}], "[", "inds2___", "]"}], ",", 
       "rest_"}], "]"}], ":=", 
     RowBox[{"0", "/;", 
      RowBox[{"!", 
       RowBox[{"ImplicitTensorDepQ", "[", 
        RowBox[{"tensor2", ",", "tensor1"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Same", " ", 
     RowBox[{"connection", ":", " ", 
      RowBox[{"integration", " ", "by", " ", "parts"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "covd_"}], "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], "[", "expr_", 
        "]"}], ",", "rest_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"VarD", "[", 
        RowBox[{"tensor", ",", "covd"}], "]"}], "[", 
       RowBox[{"expr", ",", 
        RowBox[{
         RowBox[{"covd", "[", "ind", "]"}], "[", "rest", "]"}]}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Different", " ", 
     RowBox[{"connection", ":", " ", "ChangeCovD"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", 
        RowBox[{"covd1_", "?", "CovDQ"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{
          RowBox[{"covd2_", "?", "CovDQ"}], "[", "_", "]"}], "[", "_", 
         "]"}]}], ",", "rest_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"VarD", "[", 
        RowBox[{"tensor", ",", "covd1"}], "]"}], "[", 
       RowBox[{
        RowBox[{"ChangeCovD", "[", 
         RowBox[{"expr", ",", "covd2", ",", "covd1"}], "]"}], ",", "rest"}], 
       "]"}], "/;", 
      RowBox[{"CompatibleCovDsQ", "[", 
       RowBox[{"covd1", ",", "covd2"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Support", " ", "for", " ", "parametric", " ", "derivatives"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", "OverDot"}], "]"}], "[", 
      RowBox[{
       RowBox[{"OverDot", "[", "expr_", "]"}], ",", "rest_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"VarD", "[", 
        RowBox[{"tensor", ",", "OverDot"}], "]"}], "[", 
       RowBox[{"expr", ",", 
        RowBox[{"OverDot", "[", "rest", "]"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"VarD", "[", 
       RowBox[{"tensor_", ",", 
        RowBox[{"ParamD", "[", "p_", "]"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ParamD", "[", 
         RowBox[{"pl___", ",", "p_", ",", "pr___"}], "]"}], "[", "expr_", 
        "]"}], ",", "rest_"}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"VarD", "[", 
        RowBox[{"tensor", ",", 
         RowBox[{"ParamD", "[", "p", "]"}]}], "]"}], "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ParamD", "[", 
          RowBox[{"pl", ",", "pr"}], "]"}], "[", "expr", "]"}], ",", 
        RowBox[{
         RowBox[{"ParamD", "[", "p", "]"}], "[", "rest", "]"}]}], "]"}]}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c1f88363-eef6-4f79-a8c1-a51bb727e676"],

Cell["\<\
An extension for nonscalar objects, that has been requested several times in \
the group. I'm not sure it is safe, for the reasons stated above. It \
certainly does not work in those cases in which the differentiation tensor is \
itself part of a derivative.\
\>", "Text",ExpressionUUID->"152c86d5-2606-4b12-95b5-4ede313acf6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NonScalarVarD", "[", 
     RowBox[{"tensor_", ",", "der_"}], "]"}], "[", "expr_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inds", "=", 
       RowBox[{"ChangeIndex", "/@", 
        RowBox[{"FindFreeIndices", "[", "expr", "]"}]}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tmp", "=", 
         RowBox[{
          RowBox[{"Tensor", "[", 
           RowBox[{"\"\<TMP\>\"", ",", 
            RowBox[{"SignedVBundleOfIndex", "/@", "inds"}], ",", 
            RowBox[{"DependenciesOf", "[", "expr", "]"}]}], "]"}], "@@", 
          "inds"}]}], "}"}], ",", 
       RowBox[{"IndexCoefficient", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"VarD", "[", 
           RowBox[{"tensor", ",", "der"}], "]"}], "[", 
          RowBox[{"tmp", " ", "expr"}], "]"}], ",", "tmp"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4fc00159-666b-44d7-bf32-be5d4f41a29e"]
}, Closed]],

Cell[CellGroupData[{

Cell["13.2. Examples", \
"Subsection",ExpressionUUID->"68676b03-d67b-4a21-9f02-20cee431113f"],

Cell["See xTensorDoc.nb.", \
"Text",ExpressionUUID->"379be5ca-907a-458c-8dce-d0149fa4d7aa"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["14. Metric",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox[". Continue here with general review",
  FontColor->RGBColor[1, 0, 0]]
}], "Section",
 FontSize->24,ExpressionUUID->"5ed8c60a-a60a-474d-89b5-05a2ca008676"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**"}], "*", " ", "14.", "Metric"}], " ", 
  "*****************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1fe3d4e3-fc19-4d27-a4b0-fcd68a3b3e94"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"29fd89f4-16d9-44db-bb88-968b8268a71a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "56.849002999999996`", ",", "573.459376`9.210047651297469", ",", 
   "0.0991334922751288`"}], 
  "}"}]], "Output",ExpressionUUID->"3522efad-e422-4e39-9438-325322416e65"]
}, Open  ]],

Cell[CellGroupData[{

Cell["14.0. Comments", \
"Subsection",ExpressionUUID->"52e3ddd9-ae38-4cbb-a1c9-32128675dbb7"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 14: Metrics.\>\"", "]"}], ",", 
   "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cd89d646-3a6d-4a1c-97bf-b466373ab5f8"],

Cell[TextData[{
 "The signature of the metric, and hence the sign of the determinant, are \
invariants under real transformations (though not under complex \
transformations), and therefore are defined here in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". The determinant of the metric depends on the chosen basis to define the \
determinant and hence is defined in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 "."
}], "Text",ExpressionUUID->"7aae8e3b-a05b-4a29-8f41-79ae1301105f"],

Cell[TextData[{
 "It is possible to have metric fields on an inner vbundle, but now their \
properties are different from those of the metric fields on tangent vbundles \
(assume external indices a, b, c, ... and inner indices A, B, C, ...):\n\t- \
There are compatible connections, in the sense of giving zero on the metric \
field, but now they are not unique. If the metric is g_AB and a compatible \
connection is \[GothicCapitalD]_a, so that \[GothicCapitalD]_a g_BC = 0 then \
we can try to construct \[GothicCapitalD]_a from any other derivative D_a. \
The relation would be     \[GothicCapitalD]_a g_BC = D_a g_BC - A^F_aB g_FC - \
A^F_aC g_BF = D_a g_BC - A_CaB - A_BaC = 0 . We see that we can get the \
symmetric part (in the first and third indices) of the \"Christoffel\" A_BaC, \
but not its antisymmetric part, which remains free. That means that there are \
many derivatives \[GothicCapitalD]_a which are compatible with the metric \
field g_AB . By second differentiation of the metric it is simple to see that \
the inner curvature tensor is antisymmetric on the second pair of indices \
when lowering the upper index with any of those compatible metrics. This \
antisymmetry is not implemented in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ".\n\t- It is possible to have a \"complex metric\", that is, a metric which \
gives complex values on artibrary pairs of vectors on a complex vbundle. To \
ensure \"real squares\" it seems natural to have a Hermitian metric, with one \
index on a complex vbundle and the other index on its conjugate vbundle. For \
example, the metric in Quantum Mechanics is actually a Hermitian metric of \
the form deltaQM[-adagger, -b]. What we usually call   < x | y >  is really \
Dagger[ x^a ] deltaQM[ -adagger, b ] y^b . Currently we are assuming in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " that we work with a real metric on a real vbundle. \n\t- It is not clear \
that there is a clear notion of curvature for an inner metric field. In the \
following we shall asume that \"metric\" means a real symmetric 2-tensor \
field on a tangent bundle. It is rather restrictive, but I don't know how to \
generalize it still considering curvature tensors."
}], "Text",ExpressionUUID->"f7f29375-345e-401f-be98-2ce6f4f53504"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.1. Definition", \
"Subsection",ExpressionUUID->"269dd5b6-b573-4b4d-a912-c9468556e1e6"],

Cell[CellGroupData[{

Cell["14.1.1. Definition", \
"Subsubsection",ExpressionUUID->"528a6ea7-8853-4cd4-ae3e-cb501d2b076f"],

Cell["\<\
1) Metrics can be flat (FlatMetric->True) or not (FlatMetric->False, the \
default). This is a stupid name: it should be Curvature->False/True. They \
have an associated derivative (the corresponding Levi-Civita connection), \
which is flat or not, respectively. It is possible to have torsion as well. \
If a metric is flat, its torsionless derivative will be what Wald calls an \
ordinary derivative, but not necessarily PD. If you ask for PD then you must \
supply the correct symbols for PD. Note that at that moment the generic chart \
associated to PD would get a meaning: it would be a chart where the \
components of that flat metric are constants.

QUESTION: Right now we only accept metrics on the tangent vbundle. That is \
clearly a strong limitation, and needs to be generalized.\
\>", "Text",ExpressionUUID->"4a000c55-d23c-416b-8231-b612fdbcf96d"],

Cell["\<\
2) We introduce an option InducedFrom to define the induced metric on a \
hypersurface orthogonal to a normal vector. The option must be given as a \
pair {metric, vector} where vector can be spacelike or timelike with respect \
to metric, but not null, because its norm is computed to construct the \
associated projector. Nontrivial definitions associated to induced metrics \
are given below. The fact that an induced metric is both a projector from the \
point of view of the original vbundle and a metric from the point of view of \
the projected vbundle is a problem that must be handled carefully. I'm not \
sure the current notations are the best option.

Note that the orthogonal vector in the induced case must be a vector, and not \
a generic vectorial expression. This is typically not a limitation, because \
this vector is such an important object that it is always named.\
\>", "Text",ExpressionUUID->"8e536043-a5eb-4ceb-a869-861cb4b2c7e9"],

Cell["\<\
3) Metrics which are not the first-metric *and* are not induced from the \
first-metric are called \"frozen metrics\". Most of the rules that you expect \
for a metric do not work. For example if frozen[-a,-b] is a frozen metric \
then frozen[a,b] is not its inverse because frozen[a,b] is g[a,c] g[b,d] \
frozen[-c,-d], where g[-a,-b] is the first-metric of the manifold of frozen. \
The following function assumes that we already know that the tested symbol \
*is* a metric; otherwise FirstMetricQ will throw an error.\
\>", "Text",ExpressionUUID->"b8374ec8-6838-441e-8f9d-58ea36e3a6a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FrozenMetricQ", "[", "metric_", "]"}], ":=", 
   RowBox[{"And", "[", 
    RowBox[{
     RowBox[{"Not", "@", 
      RowBox[{"FirstMetricQ", "[", "metric", "]"}]}], ",", 
     RowBox[{
      RowBox[{"InducedFrom", "[", "metric", "]"}], "===", "Null"}]}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a0e3a44a-6191-443b-95c2-f4f94ad07c83"],

Cell["4) Messages:", \
"Text",ExpressionUUID->"7e465e46-332b-42a2-bd7c-eeb4c145da66"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefMetric", "::", "old"}], "=", 
   "\"\<There are already metrics `1` in vbundle `2`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefMetric", "::", "inds"}], "=", 
   "\"\<Indices `1` and `2` do not belong to the same vector bundle.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefMetric", "::", "no1smetric"}], "=", 
   "\"\<Metrics can only be induced from the first-metric of a vector bundle.\
\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefMetric", "::", "noicovd"}], "=", 
   "\"\<Metrics in inner vbundles do not support covariant \
derivatives.\>\""}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"09909635-b50e-414c-9617-ccdbdb878fe0"],

Cell["\<\
5) Checks at definition time. Note that there is a first DefCovDCheck[covd, \
covdsymbol, {torsion, curvature, metric, curvrels, ef, wwb}] which send the \
wrog setting metric=Null to do an initial minimal checking. Later DefCovD \
will do the full checking.\
\>", "Text",ExpressionUUID->"69d86e5b-f9d0-48fe-9e6c-c4e186cb670d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefMetricCheck", "[", 
   RowBox[{"signdet_", ",", 
    RowBox[{"metric_", "[", 
     RowBox[{
      RowBox[{"-", "ind1_"}], ",", 
      RowBox[{"-", "ind2_"}]}], "]"}], ",", "covd_", ",", "covdsymbol_", ",", 
    "flat_", ",", "inducedfrom_", ",", "confto_", ",", "odeps_", ",", "wwb_", 
    ",", "eoib_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vb", ",", "supermetric", ",", "vector", ",", "tangentmetricQ"}],
      "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "Indices", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"AbstractIndexQ", "[", "ind1", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "unknown"}], ",", 
          "\"\<abstract index\>\"", ",", "ind1"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"AbstractIndexQ", "[", "ind2", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "unknown"}], ",", 
          "\"\<abstract index\>\"", ",", "ind2"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vb", "=", 
      RowBox[{"VBundleOfIndex", "[", "ind1", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"vb", "=!=", 
        RowBox[{"VBundleOfIndex", "[", "ind2", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "inds"}], ",", "ind1", ",", " ", 
          "ind2"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"tangentmetricQ", "=", 
      RowBox[{"SameQ", "[", 
       RowBox[{
        RowBox[{"Tangent", "[", 
         RowBox[{"BaseOfVBundle", "@", "vb"}], "]"}], ",", "vb"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "Metric", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MetricEndowedQ", "[", "vb", "]"}], ",", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefMetric", "::", "old"}], ",", 
         RowBox[{"MetricsOfVBundle", "[", "vb", "]"}], ",", "vb"}], "]"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"ValidateSymbol", "[", "metric", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ValidateSymbolInSession", "[", "metric", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "Dependencies", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"Or", "[", 
           RowBox[{
            RowBox[{"ManifoldQ", "[", "#", "]"}], ",", 
            RowBox[{"ParameterQ", "[", "#", "]"}]}], "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefMetric", "::", "unknown"}], ",", "\"\<dependency\>\"",
             ",", "#"}], "]"}]}]}], "]"}], "&"}], "/@", "odeps"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Sign", " ", 
       RowBox[{"Det", ".", " ", "A"}], " ", "phase", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"I", " ", "alpha"}], "]"}], " ", "is", " ", "accepted", " ", 
       "if", " ", "Abs", " ", "returns", " ", "1", " ", "on", " ", "it"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", "signdet", "]"}], "===", "1"}], ",", "Null", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"signdet", "===", "0"}], ",", "Null", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"signdet", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_Integer", "?", "NonNegative"}], ",", 
           RowBox[{"_Integer", "?", "NonNegative"}], ",", 
           RowBox[{"_Integer", "?", "NonNegative"}]}], "}"}]}], "]"}], ",", 
       "Null", ",", "\[IndentingNewLine]", "True", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "invalid"}], ",", "signdet", ",", 
          "\"\<signdet of metric\>\""}], "]"}]}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"The", " ", "Levi"}], "-", 
       RowBox[{"Civita", " ", "covd"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{"If", "[", 
      RowBox[{"tangentmetricQ", ",", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"TrueOrFalse", "[", "flat", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefMetric", "::", "invalid"}], ",", "flat", ",", 
            "\"\<value for option FlatMetric\>\""}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"covd", "===", "PD"}], " ", "&&", 
          RowBox[{"!", "flat"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefMetric", "::", "error"}], ",", 
            "\"\<PD can only be associated to a flat metric.\>\""}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"covd", "===", "PD"}], "&&", "flat", "&&", 
          RowBox[{"covdsymbol", "=!=", 
           RowBox[{"SymbolOfCovD", "[", "PD", "]"}]}]}], ",", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"DefMetric", "::", "error"}], ",", 
           RowBox[{"\"\<Using standard \>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"SymbolOfCovD", "[", "PD", "]"}], "]"}], "<>", 
            "\"\< as symbols for PD.\>\""}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"covd", "===", "None"}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"DefMetric", "::", "invalid"}], ",", "covd", ",", 
            "\"\<covd\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"covd", "=!=", "PD"}], ",", 
         RowBox[{"DefCovDCheck", "[", 
          RowBox[{"covd", ",", "covdsymbol", ",", 
           RowBox[{"{", 
            RowBox[{"False", ",", 
             RowBox[{"!", "flat"}], ",", "Null", ",", "False", ",", "False", 
             ",", "wwb"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"covd", "=!=", "None"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{"DefMetric", "::", "noicovd"}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Induced", " ", "metric"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{"Switch", "[", 
      RowBox[{
      "inducedfrom", ",", "\[IndentingNewLine]", "Null", ",", "Null", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"supermetric", ",", "vector"}], "}"}], "=", "inducedfrom"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"MetricQ", "[", "supermetric", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefMetric", "::", "unknown"}], ",", "\"\<metric\>\"", 
             ",", "supermetric"}], "]"}]}]}], "]"}], ";", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"FirstMetricQ", "[", "supermetric", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{"DefMetric", "::", "no1smetric"}], "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"!", 
            RowBox[{"xTensorQ", "[", "vector", "]"}]}], "||", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"SlotsOfTensor", "[", "vector", "]"}], "]"}], "=!=", 
            "1"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefMetric", "::", "unknown"}], ",", "\"\<vector\>\"", 
             ",", "vector"}], "]"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "_", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "invalid"}], ",", "inducedfrom", ",", 
          "\"\<value for option InducedFrom\>\""}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Conformal", " ", "relations"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", 
      RowBox[{
      "confto", ",", "\[IndentingNewLine]", "Null", ",", "Null", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"originalmetric", ",", "confactor"}], "}"}], "=", 
         "confto"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"MetricQ", "[", 
            RowBox[{"Head", "[", "originalmetric", "]"}], "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefMetric", "::", "unknown"}], ",", 
             "\"\<conformally related metric \>\"", ",", 
             RowBox[{"Head", "@", "originalmetric"}]}], "]"}]}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"ScalarQ", "[", "confactor", "]"}]}], ",", 
          RowBox[{"Throw", "@", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefMetric", "::", "invalid"}], ",", "confactor", ",", 
             "\"\<conformal scalar factor\>\""}], "]"}]}]}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "epsilon", " ", "orientation", " ", "in", " ", "a", " ", "basis"}], " ",
       "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Head", "[", "eoib", "]"}], "=!=", "List"}], "||", 
        RowBox[{
         RowBox[{"Length", "[", "eoib", "]"}], "=!=", "2"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "invalid"}], ",", "eoib", ",", 
          "\"\<value for option epsilonOrientationInMetric\>\""}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"!", 
        RowBox[{"BasisQ", "[", 
         RowBox[{"eoib", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"DefMetric", "::", "unknown"}], ",", "\"\<basis\>\"", ",", 
          RowBox[{"eoib", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "_", ",", "Null"}], "\[IndentingNewLine]", 
      "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0e609184-6ccc-458c-8057-74db4b448a9b"],

Cell["6) Output of the tensors associated to a metric.", \
"Text",ExpressionUUID->"910f0f70-9e2d-4b9e-9d51-9e612a35cca6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Set", "[", 
     RowBox[{
      RowBox[{"MetricTensorQ", "[", "#", "]"}], ",", "True"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "epsilon", ",", "ExtrinsicK", ",", "Acceleration", ",", "Projector", ",", 
     "Inv", ",", "Tetra"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricTensorQ", "[", "_", "]"}], "=", "False"}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"737c8c40-2c68-4475-9da3-c209db7757cb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "epsilon", "]"}], "=", 
   "\"\<\[Epsilon]\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "ExtrinsicK", "]"}], "=", "\"\<K\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Acceleration", "]"}], "=", "\"\<A\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Projector", "]"}], "=", "\"\<P\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Inv", "]"}], "=", "\"\<i\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAsCharacter", "[", "Tetra", "]"}], "=", "\"\<G\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1d0652c9-952c-4f6c-a2e3-55ea5825b826"],

Cell["\<\
Formatting of tensors associated to a metric follow the general SymbolJoin \
approach, and not the tensor[covd][inds] notation of covds. Hence we do not \
need a special GiveOutputString definition for MetricTensorQ objects. There \
is an exceptional case, though:\
\>", "Text",ExpressionUUID->"35bb651c-50ee-44ab-b052-8d7f6aef2fc9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Exception", " ", "to", " ", "general", " ", "GiveOutputString", " ", "to",
     " ", "have", " ", "a", " ", "subscript"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"GiveOutputString", "[", 
     RowBox[{"Projector", ",", "metric_"}], "]"}], ":=", 
    RowBox[{"StringJoin", "[", 
     RowBox[{"\"\<\\!\\(\>\"", ",", 
      RowBox[{"PrintAsCharacter", "[", "Projector", "]"}], ",", "\"\<\\+\>\"",
       ",", 
      RowBox[{"PrintAs", "[", "metric", "]"}], ",", "\"\<\\)\>\""}], "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"44c8fa88-d55d-4c46-86b1-f8192a28aabe"],

Cell["7) Objects associated to a metric field:", \
"Text",ExpressionUUID->"a25b3b84-6b2d-4524-8106-65a54f537535"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LC", "[", 
    RowBox[{"metric_", "?", "MetricQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"LC", ",", "metric"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"epsilon", "[", 
    RowBox[{"metric_", "?", "MetricQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"epsilon", ",", "metric"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtrinsicK", "[", 
    RowBox[{"metric_", "?", "MetricQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"ExtrinsicK", ",", "metric"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Acceleration", "[", 
    RowBox[{"vector_", "?", "xTensorQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Acceleration", ",", "vector"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Projector", "[", 
    RowBox[{"metric_", "?", "MetricQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Projector", ",", "metric"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Inv", "[", 
    RowBox[{"metric_", "?", "MetricQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Inv", ",", "metric"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tetra", "[", 
    RowBox[{"metric_", "?", "MetricQ"}], "]"}], ":=", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Tetra", ",", "metric"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"46b998bc-c198-40b2-a3e2-235e3cd0309e"],

Cell["Defaults:", \
"Text",ExpressionUUID->"d7f3913f-55aa-4a74-b1e9-c70911020a51"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetDelayed", "[", 
     RowBox[{
      RowBox[{"#", "[", "x_", "]"}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"#", "::", "unknown"}], ",", "\"\<metric\>\"", ",", "x"}], 
        "]"}]}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"LC", ",", "epsilon", ",", "Tetra"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetDelayed", "[", 
     RowBox[{
      RowBox[{"#", "[", "x_", "]"}], ",", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"#", "::", "unknown"}], ",", "\"\<induced metric\>\"", ",", 
         "x"}], "]"}]}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"ExtrinsicK", ",", "Projector"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Inv", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Inv", "::", "unknown"}], ",", 
      "\"\<metric or linear operator\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Acceleration", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Acceleration", "::", "unknown"}], ",", 
      "\"\<metric-orthogonal vector\>\"", ",", "x"}], "]"}]}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6e0e0583-6fc0-4395-967a-a2fd5b0b27b8"],

Cell["\<\
8) Main. There are a few things concerning induced metrics which are not \
solved in the following definition. QUESTION. For example the issues of \
determinants, signatures, etc. Recall that we assume that this is a metric on \
a tangent bundle. (EINDEX: many hardwired minus signs). Note that we cannot \
use threading over a list in the first argument here.\
\>", "Text",ExpressionUUID->"39473128-bae8-4a07-9cd4-93fcd622b9d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Backwards", " ", "compatibility"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DefMetric", "[", 
     RowBox[{"signdet_", ",", "metric_", ",", "covd_", ",", 
      RowBox[{"covdsymbol", ":", 
       RowBox[{"{", 
        RowBox[{"_String", ",", "_String"}], "}"}]}], ",", 
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    RowBox[{"DefMetric", "[", 
     RowBox[{"signdet", ",", "metric", ",", "covd", ",", 
      RowBox[{"SymbolOfCovD", "\[Rule]", "covdsymbol"}], ",", "options"}], 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1ff22a6e-82b9-45b3-97c4-2f94bb8405f3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Options", "[", "DefMetric", "]"}], ":=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FlatMetric", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
    RowBox[{"InducedFrom", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
    RowBox[{"ConformalTo", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
    RowBox[{"OtherDependencies", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"WeightedWithBasis", "\[Rule]", "Null"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"epsilonOrientationInBasis", "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"AIndex", ",", "$epsilonSign"}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Master", "\[Rule]", "Null"}], ",", "\[IndentingNewLine]", 
    RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{"DefInfo", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefMetric", "[", 
     RowBox[{"signdet_", ",", 
      RowBox[{"metric_", "[", 
       RowBox[{
        RowBox[{"-", "ind1_"}], ",", 
        RowBox[{"-", "ind2_"}]}], "]"}], ",", "covd_", ",", 
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Catch", "@", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"vbundle", "=", 
         RowBox[{"VBundleOfIndex", "[", "ind1", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "tangentmetricQ", ",", "covdsymbol", ",", "flat", ",", 
           "inducedfrom", ",", "confto", ",", "odeps", ",", "wwb", ",", 
           "eoib", ",", "pns", ",", "info", ",", "flatPD", ",", "inducedQ", 
           ",", "dim", ",", "integerdimQ", ",", "frozenQ", ",", "firstQ", ",",
            "invertQ", ",", "firstmetric", ",", "supermetric", ",", "vector", 
           ",", "LCmetric"}], "}"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Options", " ", "and", " ", "checks"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "covdsymbol", ",", "flat", ",", "inducedfrom", ",", "confto", ",",
              "odeps", ",", "wwb", ",", "eoib", ",", "pns", ",", "info"}], 
            "}"}], "=", 
           RowBox[{"OptionValue", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"DefMetric", ",", "DefCovD"}], "}"}], ",", 
             RowBox[{"{", "options", "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "SymbolOfCovD", ",", "FlatMetric", ",", "InducedFrom", ",", 
               "ConformalTo", ",", "OtherDependencies", ",", 
               "WeightedWithBasis", ",", "epsilonOrientationInBasis", ",", 
               "ProtectNewSymbol", ",", "DefInfo"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"DefMetricCheck", "[", 
           RowBox[{"signdet", ",", 
            RowBox[{"metric", "[", 
             RowBox[{
              RowBox[{"-", "ind1"}], ",", 
              RowBox[{"-", "ind2"}]}], "]"}], ",", "covd", ",", "covdsymbol", 
            ",", "flat", ",", "inducedfrom", ",", "confto", ",", "odeps", ",",
             "wwb", ",", "eoib"}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", "Explore", " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"tangentmetricQ", "=", 
           RowBox[{"SameQ", "[", 
            RowBox[{
             RowBox[{"Tangent", "[", 
              RowBox[{"BaseOfVBundle", "@", "vbundle"}], "]"}], ",", 
             "vbundle"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"flatPD", "=", 
           RowBox[{"flat", "&&", 
            RowBox[{"(", 
             RowBox[{"covd", "===", "PD"}], ")"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"dim", "=", 
           RowBox[{"DimOfVBundle", "[", "vbundle", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"integerdimQ", "=", 
           RowBox[{"IntegerQ", "[", "dim", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "One", " ", "and", " ", "only", " ", "one", " ", "of", " ", 
             "firstQ"}], ",", " ", "inducedQ", ",", " ", 
            RowBox[{"frozenQ", " ", "is", " ", "True"}], ",", " ", 
            RowBox[{
            "and", " ", "the", " ", "other", " ", "two", " ", "are", " ", 
             "False"}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"firstQ", "=", 
           RowBox[{
            RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], "===", 
            RowBox[{"{", "}"}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"inducedQ", "=", 
           RowBox[{"And", "[", 
            RowBox[{
             RowBox[{"!", "firstQ"}], ",", 
             RowBox[{"inducedfrom", "=!=", "Null"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"frozenQ", "=", 
           RowBox[{"And", "[", 
            RowBox[{
             RowBox[{"!", "firstQ"}], ",", 
             RowBox[{"!", "inducedQ"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"inducedQ", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"supermetric", ",", "vector"}], "}"}], "=", 
             "inducedfrom"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"frozenQ", ",", 
            RowBox[{"firstmetric", "=", 
             RowBox[{"First", "[", 
              RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], "]"}]}]}], 
           "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"manifold", "=", 
               RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"deps", "=", 
               RowBox[{"Union", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"BaseOfVBundle", "[", "vbundle", "]"}], "}"}], ",", 
                 "odeps"}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"vbQ", "=", 
               RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"vbpmQ", "=", 
               RowBox[{"VBundleIndexPMQ", "[", "vbundle", "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"invmetric", "=", 
               RowBox[{"If", "[", 
                RowBox[{"frozenQ", ",", 
                 RowBox[{"GiveSymbol", "[", 
                  RowBox[{"Inv", ",", "metric"}], "]"}], ",", "metric"}], 
                "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "Avoid", " ", "messages", " ", "from", " ", "options", " ", "of",
               " ", "DefMetric", " ", "not", " ", "accepted", " ", "in", " ", 
              "DefTensor", " ", "or", " ", "DefCovD"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Off", "[", 
              RowBox[{"OptionValue", "::", "nodef"}], "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Define", " ", "metric", " ", 
               RowBox[{"tensor", ".", " ", "Do"}], " ", "not", " ", "protect",
                " ", 
               RowBox[{"symbol", ".", " ", "Do"}], " ", "not", " ", "use", 
               " ", 
               RowBox[{"ProjectedWith", ".", " ", "It"}], " ", "is", " ", 
               "always", " ", "symmetric"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"DefTensor", "[", 
              RowBox[{
               RowBox[{"metric", "[", 
                RowBox[{
                 RowBox[{"-", "ind1"}], ",", 
                 RowBox[{"-", "ind2"}]}], "]"}], ",", "deps", ",", 
               RowBox[{"Symmetric", "[", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
                RowBox[{"If", "[", 
                 RowBox[{"inducedQ", ",", 
                  RowBox[{"{", 
                   RowBox[{"vector", "[", "ind1", "]"}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"DefInfo", "\[RuleDelayed]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"info", "===", "False"}], ",", "False", ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<symmetric metric tensor\>\"", ",", "\"\<\>\""}], 
                   "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", "options"}], 
              "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"MakexTensions", "[", 
              RowBox[{
              "DefMetric", ",", "\"\<Beginning\>\"", ",", "signdet", ",", 
               RowBox[{"metric", "[", 
                RowBox[{
                 RowBox[{"-", "ind1"}], ",", 
                 RowBox[{"-", "ind2"}]}], "]"}], ",", "covd", ",", 
               "options"}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Register", " ", "structure"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"AppendToUnevaluated", "[", 
              RowBox[{"$Metrics", ",", "metric"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"MetricQ", "[", "metric", "]"}], "^=", "True"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"CovDOfMetric", "[", "metric", "]"}], "^=", "covd"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"VBundleOfMetric", "[", "metric", "]"}], "^=", 
              "vbundle"}], ";", "\[IndentingNewLine]", 
             RowBox[{"xUpAppendTo", "[", 
              RowBox[{
               RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], ",", 
               "metric"}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"FlatMetricQ", "[", "metric", "]"}], "^=", "flat"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"InducedFrom", "[", "metric", "]"}], "^=", 
              "inducedfrom"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", "Signature", " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Head", "[", "signdet", "]"}], "===", "List"}], " ", 
                "&&", 
                RowBox[{
                 RowBox[{"Length", "[", "signdet", "]"}], "===", "3"}]}], ",",
                "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"SignatureOfMetric", "[", "metric", "]"}], "^=", 
                 "signdet"}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"SignDetOfMetric", "[", "metric", "]"}], "^=", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"signdet", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "===", "0"}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"signdet", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", "0"}], "]"}]}]}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"SignDetOfMetric", "[", "metric", "]"}], "^=", 
                 "signdet"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", "Invertibility", " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"invertQ", "=", 
              RowBox[{
               RowBox[{"SignDetOfMetric", "[", "metric", "]"}], "=!=", 
               "0"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Define", " ", "inverse", " ", 
               RowBox[{"metric", ".", " ", 
                RowBox[{"TODO", ":", " ", 
                 RowBox[{"Orthogonal", " ", "and", " ", 
                  RowBox[{"Projected", "?"}]}]}]}]}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"invertQ", ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{"frozenQ", " ", ",", "\[IndentingNewLine]", 
                 RowBox[{"DefTensor", "[", 
                  RowBox[{
                   RowBox[{"invmetric", "[", 
                    RowBox[{"ind1", ",", "ind2"}], "]"}], ",", "deps", ",", 
                   RowBox[{"Symmetric", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Master", "\[Rule]", "metric"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"DefInfo", "\[RuleDelayed]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"info", "===", "False"}], ",", "False", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<inverse metric tensor\>\"", ",", 
                    "\"\<Metric is frozen!\>\""}], "}"}]}], "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"TensorID", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"InvMetric", ",", "metric"}], "}"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"PrintAs", "\[RuleDelayed]", 
                    RowBox[{"GiveOutputString", "[", 
                    RowBox[{"Inv", ",", "metric"}], "]"}]}], ",", 
                   "\[IndentingNewLine]", "options"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Inv", "[", "metric", "]"}], "^=", "metric"}]}], 
                "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
               "Print", "[", 
                "\"\<** DefMetric: non-invertible metric being defined! \
Dangerous!\>\"", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
              "Directional", " ", "indices", " ", "are", " ", "not", " ", 
               "allowed", " ", "in", " ", 
               RowBox[{"metrics", ".", " ", "Why"}], " ", "only", " ", "for", 
               " ", "first", " ", 
               RowBox[{"metrics", "?"}]}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"firstQ", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"metric", "[", 
                  RowBox[{
                   RowBox[{"Dir", "[", "expr_", "]"}], ",", "b_"}], "]"}], ":=", 
                 RowBox[{"ReplaceIndex", "[", 
                  RowBox[{"expr", ",", 
                   RowBox[{
                    RowBox[{"UltraindexOf", "[", "expr", "]"}], "\[Rule]", 
                    "b"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"metric", "[", 
                  RowBox[{"a_", ",", 
                   RowBox[{"Dir", "[", "expr_", "]"}]}], "]"}], ":=", 
                 RowBox[{"ReplaceIndex", "[", 
                  RowBox[{"expr", ",", 
                   RowBox[{
                    RowBox[{"UltraindexOf", "[", "expr", "]"}], "\[Rule]", 
                    "a"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Define", " ", "epsilon", " ", "tensor"}], ",", " ", 
               RowBox[{"with", " ", "covariant", " ", 
                RowBox[{"indices", ".", " ", "Do"}], " ", "not", " ", 
                "protect", " ", "symbol"}]}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"metric", "/:", 
              RowBox[{"epsilonOrientation", "[", 
               RowBox[{"metric", ",", 
                RowBox[{"eoib", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "=", 
              RowBox[{"eoib", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"epsilonname", "=", 
                  RowBox[{"GiveSymbol", "[", 
                   RowBox[{"epsilon", ",", "metric"}], "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"inds", "=", 
                  RowBox[{"GetIndicesOfVBundle", "[", 
                   RowBox[{"vbundle", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{"integerdimQ", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"dim", "-", "1"}], ",", "dim"}], "]"}], ",", 
                    "2"}], "]"}]}], "]"}]}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"DefTensor", "[", 
                 RowBox[{
                  RowBox[{"epsilonname", "@@", 
                   RowBox[{"(", 
                    RowBox[{"ChangeIndex", "/@", "inds"}], ")"}]}], ",", 
                  "deps", ",", 
                  RowBox[{"Antisymmetric", "@", 
                   RowBox[{"Range", "@", 
                    RowBox[{"Length", "@", "inds"}]}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"PrintAs", "\[RuleDelayed]", 
                   RowBox[{"GiveOutputString", "[", 
                    RowBox[{"epsilon", ",", "metric"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Master", "\[Rule]", "metric"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
                   RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"{", 
                    RowBox[{"vector", "[", 
                    RowBox[{"First", "[", "inds", "]"}], "]"}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"ProjectedWith", "\[RuleDelayed]", 
                   RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"{", 
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
                    RowBox[{"First", "[", "inds", "]"}]}], "]"}], "}"}], ",", 
                    
                    RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"DefInfo", "\[RuleDelayed]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"info", "===", "False"}], ",", "False", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<antisymmetric tensor\>\"", ",", "\"\<\>\""}],
                     "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"TensorID", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"epsilon", ",", "metric"}], "}"}]}]}], "]"}], ";",
                 "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Not", "@", "integerdimQ"}], " ", "&&", " ", 
                   RowBox[{"Not", "@", "inducedQ"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"TagSetDelayed", "[", 
                    RowBox[{"epsilonname", ",", 
                    RowBox[{"SymmetryGroupOfTensor", "[", 
                    RowBox[{"epsilonname", "[", "inds1__", "]"}], "]"}], ",", 
                    
                    RowBox[{"Antisymmetric", "[", 
                    RowBox[{"Range", "@", 
                    RowBox[{"Length", "@", 
                    RowBox[{"{", "inds1", "}"}]}]}], "]"}]}], "]"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"TagUnset", "[", 
                    RowBox[{"epsilonname", ",", 
                    RowBox[{
                    "SymmetryGroupOfTensor", "[", "epsilonname", "]"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"TagSetDelayed", "[", 
                    RowBox[{"epsilonname", ",", 
                    RowBox[{
                    "SymmetryGroupOfTensor", "[", "epsilonname", "]"}], ",", 
                    RowBox[{"Antisymmetric", "[", 
                    RowBox[{"Range", "@", 
                    RowBox[{"DimOfVBundle", "@", "vbundle"}]}], "]"}]}], 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"Products", " ", "of", " ", "two", " ", 
                  RowBox[{"epsilons", ".", " ", "In"}], " ", "the", " ", 
                  "induced", " ", "and", " ", "frozen", " ", "cases", " ", 
                  "expansions", " ", "give", " ", "metric", " ", "and", " ", 
                  "not", " ", "delta"}], " ", "*)"}], "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"inducedQ", " ", "||", "frozenQ"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"epsilonname", "/:", 
                   RowBox[{
                    RowBox[{"epsilonname", "[", "inds1__", "]"}], 
                    RowBox[{"epsilonname", "[", "inds2__", "]"}]}], ":=", 
                   RowBox[{
                    RowBox[{"SignDetOfMetric", "[", "metric", "]"}], 
                    RowBox[{
                    RowBox[{"expandGdelta", "[", "metric", "]"}], "[", 
                    RowBox[{"inds1", ",", "inds2"}], "]"}]}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"epsilonname", "/:", 
                   RowBox[{
                    RowBox[{"epsilonname", "[", "inds1__", "]"}], 
                    RowBox[{"epsilonname", "[", "inds2__", "]"}]}], ":=", 
                   RowBox[{
                    RowBox[{"SignDetOfMetric", "[", "metric", "]"}], 
                    RowBox[{"ExpandGdelta", "[", 
                    RowBox[{"Gdelta", "[", 
                    RowBox[{"inds1", ",", "inds2"}], "]"}], "]"}]}]}]}], 
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"Derivatives", " ", "of", " ", 
                  RowBox[{"epsilon", ".", " ", "Note"}], " ", "that", " ", 
                  "we", " ", "have", " ", "not", " ", "yet", " ", "defined", 
                  " ", "covd", " ", 
                  RowBox[{"(", 
                   RowBox[{"!", "?"}], ")"}]}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"tangentmetricQ", ",", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{"frozenQ", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "a_", "]"}], "[", 
                    RowBox[{"epsilonname", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "vbQ"}]}], ")"}], ".."}], "]"}], "]"}],
                     "^=", "0"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "a_", "]"}], "[", 
                    RowBox[{"epsilonname", "[", 
                    RowBox[{"b__", "?", "vbpmQ"}], "]"}], "]"}], "^=", 
                    "0"}]}], "\[IndentingNewLine]", "]"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"TensorDerivative", "[", 
                    RowBox[{"epsilonname", ",", "covd", ",", "___"}], "]"}], ":=",
                     "Zero"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", "inducedQ"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", "frozenQ"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"epsilonname", "/:", 
                    RowBox[{
                    RowBox[{"LieD", "[", "v_", "]"}], "[", 
                    RowBox[{"epsilonname", "[", 
                    RowBox[{"inds1__", "?", "UpIndexQ"}], "]"}], "]"}], ":=", 
                    
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dummy", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dummy"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"v", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"UltraindexOf", "[", "v", "]"}], "\[Rule]", 
                    "dummy"}], "}"}]}], "]"}], 
                    RowBox[{"epsilonname", "[", "inds1", "]"}]}], "]"}]}]}], 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"epsilonname", "/:", 
                    RowBox[{
                    RowBox[{"LieD", "[", "v_", "]"}], "[", 
                    RowBox[{"epsilonname", "[", 
                    RowBox[{"inds1__", "?", "DownIndexQ"}], "]"}], "]"}], ":=", 
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dummy", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dummy"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"v", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"UltraindexOf", "[", "v", "]"}], "\[Rule]", 
                    "dummy"}], "}"}]}], "]"}], 
                    RowBox[{"epsilonname", "[", "inds1", "]"}]}], "]"}]}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"epsilonname", "/:", 
                    RowBox[{"TensorDerivative", "[", 
                    RowBox[{"epsilonname", ",", 
                    RowBox[{"LieD", "[", 
                    RowBox[{
                    RowBox[{"vhead_", "?", "xTensorQ"}], "[", "_", "]"}], 
                    "]"}]}], "]"}], ":=", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dummy", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
                    RowBox[{"MultiplyHead", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"TensorDerivative", "[", 
                    RowBox[{"vhead", ",", "covd"}], "]"}], "[", 
                    RowBox[{"dummy", ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], ",", "epsilonname"}], 
                    "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{
                  RowBox[{
                  "Special", " ", "relation", " ", "in", " ", "2", "d"}], ",",
                   " ", 
                  RowBox[{
                  "valid", " ", "for", " ", "all", " ", "types", " ", "of", 
                   " ", "indices"}]}], " ", "*)"}], "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"dim", "===", "2"}], "&&", "firstQ"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"epsilonname", "[", 
                    RowBox[{"a_", ",", "b_"}], "]"}], 
                    RowBox[{"epsilonname", "[", 
                    RowBox[{"c_", ",", "d_"}], "]"}]}], "^=", 
                    RowBox[{
                    RowBox[{"SignDetOfMetric", "[", "metric", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "d"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "d"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "c"}], "]"}]}]}], ")"}]}]}], ";"}]}], 
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{
                  RowBox[{"Define", " ", "Tetra"}], ",", " ", 
                  RowBox[{
                  "only", " ", "in", " ", "dimension", " ", "4.", " ", "This",
                    " ", "is", " ", "an", " ", "algebraic", " ", 
                   "construction"}], ",", " ", 
                  RowBox[{
                  "hence", " ", "valid", " ", "for", " ", "frozen", " ", 
                   "metrics"}]}], " ", "*)"}], " ", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"dim", "\[Equal]", "4"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"TetraName", "=", 
                    RowBox[{"GiveSymbol", "[", 
                    RowBox[{"Tetra", ",", "metric"}], "]"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "}"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "}"}], 
                    "=", 
                    RowBox[{"GetIndicesOfVBundle", "[", 
                    RowBox[{"vbundle", ",", "4"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DefTensor", "[", 
                    RowBox[{
                    RowBox[{"TetraName", "[", 
                    RowBox[{
                    RowBox[{"-", "i1"}], ",", 
                    RowBox[{"-", "i2"}], ",", 
                    RowBox[{"-", "i3"}], ",", 
                    RowBox[{"-", "i4"}]}], "]"}], ",", "deps", ",", 
                    RowBox[{"GenSet", "[", 
                    RowBox[{
                    RowBox[{"xAct`xPerm`Cycles", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3", ",", "4"}], "}"}]}], "]"}], ",", 
                    RowBox[{"xAct`xPerm`Cycles", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "3"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "4"}], "}"}]}], "]"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Dagger", "\[Rule]", "Complex"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"PrintAs", "\[RuleDelayed]", 
                    RowBox[{"GiveOutputString", "[", 
                    RowBox[{"Tetra", ",", "metric"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Master", "\[Rule]", "metric"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DefInfo", "\[RuleDelayed]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"info", "===", "False"}], ",", "False", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<tetrametric\>\"", ",", "\"\<\>\""}], "}"}]}],
                     "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TetraRule", "[", "metric", "]"}], "^:=", 
                    RowBox[{"MakeRule", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"TetraName", "[", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}], 
                    ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"I", "/", "2"}], 
                    RowBox[{"epsilonOrientation", "[", 
                    RowBox[{"metric", ",", "AIndex"}], "]"}], 
                    RowBox[{"epsilonname", "[", 
                    RowBox[{"i1", ",", "i2", ",", "i3", ",", "i4"}], "]"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i4"}], "]"}], 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i3"}], "]"}], "/", "2"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i3"}], "]"}], 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i2", ",", "i4"}], "]"}], "/", "2"}]}], "+", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i1", ",", "i2"}], "]"}], 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"i3", ",", "i4"}], "]"}], "/", "2"}]}]}]}], "}"}],
                     ",", 
                    RowBox[{"Evaluate", "\[Rule]", "True"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"TetraNamedag", "=", 
                    RowBox[{"Dagger", "[", "TetraName", "]"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"TetraNamedag", "[", 
                    RowBox[{"i1_", ",", "i2_", ",", "i3_", ",", "i4_"}], 
                    "]"}], ":=", 
                    RowBox[{"TetraName", "[", 
                    RowBox[{"i1", ",", "i4", ",", "i3", ",", "i2"}], 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                    
                    RowBox[{"If", "[", 
                    RowBox[{"$ProtectNewSymbols", ",", 
                    RowBox[{"Protect", "[", 
                    RowBox[{"TetraName", ",", 
                    RowBox[{"Evaluate", "[", 
                    RowBox[{"Dagger", "@", "TetraName"}], "]"}]}], "]"}]}], 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"$ProtectNewSymbols", ",", 
                  RowBox[{"Protect", "[", "epsilonname", "]"}]}], "]"}]}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Self", "-", 
               RowBox[{
                RowBox[{"contractions", ".", " ", "Transformation"}], " ", 
                "to", " ", "delta", " ", "or", " ", "metric", " ", "for", " ",
                 "A"}], "-", 
               RowBox[{
               "indices", " ", "contraction", " ", "of", " ", "two", " ", 
                "metrics", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                  "this", " ", "could", " ", "be", " ", "generalized"}], 
                  ")"}], ".", " ", "Projectors"}], " ", "not", " ", 
                "automatically", " ", "converted", " ", "into", " ", 
                "delta"}]}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"frozenQ", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{"a_", ",", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "vbQ"}]}]}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{
                    RowBox[{"b_", "?", "EIndexQ"}], ",", "c_"}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "vbQ"}]}], ",", "a_"}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{
                    RowBox[{"b_", "?", "EIndexQ"}], ",", "c_"}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{"a_", ",", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "vbQ"}]}]}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{"c_", ",", 
                    RowBox[{"b_", "?", "EIndexQ"}]}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "vbQ"}]}], ",", "a_"}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{"c_", ",", 
                    RowBox[{"b_", "?", "EIndexQ"}]}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{"a_", ",", 
                    RowBox[{"b_", "?", "vbQ"}]}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}], ",", "c_"}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"b_", "?", "vbQ"}], ",", "a_"}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}], ",", "c_"}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{"a_", ",", 
                    RowBox[{"b_", "?", "vbQ"}]}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{"c_", ",", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}]}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"invmetric", "/:", 
                 RowBox[{
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"b_", "?", "vbQ"}], ",", "a_"}], "]"}], 
                  RowBox[{"invmetric", "[", 
                   RowBox[{"c_", ",", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}]}], "]"}]}], ":=", 
                 RowBox[{"firstmetric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{"inducedQ", ",", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"a_", "?", "vbQ"}], ",", 
                    RowBox[{"-", 
                    RowBox[{"a_", "?", "EIndexQ"}]}]}], "]"}], ":=", 
                    RowBox[{"dim", "-", "1"}]}], ";", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"a_", "?", "vbQ"}]}], ",", 
                    RowBox[{"a_", "?", "EIndexQ"}]}], "]"}], ":=", 
                    RowBox[{"dim", "-", "1"}]}]}]}], "\[IndentingNewLine]", 
                 "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"firstQ", ",", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"a_", "?", "UpIndexQ"}], ",", 
                    RowBox[{"b_", "?", "DownIndexQ"}]}], "]"}], ":=", 
                    RowBox[{"delta", "[", 
                    RowBox[{"b", ",", "a"}], "]"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"a_", "?", "DownIndexQ"}], ",", 
                    RowBox[{"b_", "?", "UpIndexQ"}]}], "]"}], ":=", 
                    RowBox[{"delta", "[", 
                    RowBox[{"a", ",", "b"}], "]"}]}]}]}], 
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"HoldPattern", "[", 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{"a_", ",", 
                    RowBox[{"b_", "?", "vbQ"}]}], "]"}], 
                   RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}], ",", "c_"}], "]"}]}], 
                  "]"}], "^:=", 
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"HoldPattern", "[", 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{"a_", ",", 
                    RowBox[{"b_", "?", "vbQ"}]}], "]"}], 
                   RowBox[{"metric", "[", 
                    RowBox[{"c_", ",", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}]}], "]"}]}], "]"}], "^:=", 
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"HoldPattern", "[", 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"b_", "?", "vbQ"}], ",", "a_"}], "]"}], 
                   RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}], ",", "c_"}], "]"}]}], 
                  "]"}], "^:=", 
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"HoldPattern", "[", 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"b_", "?", "vbQ"}], ",", "a_"}], "]"}], 
                   RowBox[{"metric", "[", 
                    RowBox[{"c_", ",", 
                    RowBox[{"-", 
                    RowBox[{"b_", "?", "EIndexQ"}]}]}], "]"}]}], "]"}], "^:=", 
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "c"}], "]"}]}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Define", " ", "covariant", " ", "derivative", 
               RowBox[{
                RowBox[{"(", "s", ")"}], ".", " ", "Do"}], " ", "not", " ", 
               "protect", " ", "symbol"}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"tangentmetricQ", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{"flatPD", ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{"Flat", " ", "metric", " ", "with", " ", 
                    RowBox[{"PD", ".", " ", "Derivative"}], " ", "already", 
                    " ", "defined"}], " ", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                   "Print", "[", 
                    "\"\<** DefMetric: Associating fiducial flat derivative \
PD to metric.\>\"", "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"Unprotect", "[", "PD", "]"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"MetricOfCovD", "[", "PD", "]"}], "^=", 
                    "metric"}], ";", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"PD", "[", "c_", "]"}], "[", 
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"a_", "?", "vbpmQ"}], ",", 
                    RowBox[{"b_", "?", "vbpmQ"}]}], "]"}], "]"}], "^=", "0"}],
                    ";", "\[IndentingNewLine]", 
                   RowBox[{"metric", "/:", 
                    RowBox[{"TensorDerivative", "[", 
                    RowBox[{"metric", ",", "PD"}], "]"}], ":=", "Zero"}], ";",
                    "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", "frozenQ"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    RowBox[{
                    "Place", " ", "rule", " ", "for", " ", "this", " ", 
                    "metric", " ", "second"}], ",", " ", 
                    RowBox[{
                    "after", " ", "the", " ", "general", " ", "rule", " ", 
                    "for", " ", "lower", " ", "indices"}]}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"$SortPDsRules", ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"PD", "[", 
                    RowBox[{"b_", "?", "vbpmQ"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"PD", "[", 
                    RowBox[{"a_", "?", "vbpmQ"}], "]"}], "[", "expr1_", "]"}],
                     "]"}], "\[RuleDelayed]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"PD", "[", "a", "]"}], "[", 
                    RowBox[{
                    RowBox[{"PD", "[", "b", "]"}], "[", "expr1", "]"}], "]"}],
                     "/;", 
                    RowBox[{"DisorderedPairQ", "[", 
                    RowBox[{"a", ",", "b"}], "]"}]}]}]}], "]"}]}], 
                    "\[IndentingNewLine]", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{"Other", " ", 
                    RowBox[{"cases", ".", " ", "Define"}], " ", 
                    RowBox[{"derivative", ".", " ", "For"}], " ", "a", " ", 
                    "frozen", " ", "metric", " ", "the", " ", "associated", 
                    " ", "tensors", " ", "are", " ", 
                    RowBox[{"wrong", "!"}], " ", "TODO"}], " ", "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{"DefCovD", "[", 
                   RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "ind1"}], "]"}], ",", "covdsymbol", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"FromMetric", "\[Rule]", "metric"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Curvature", "\[RuleDelayed]", 
                    RowBox[{"Not", "[", "flat", "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OtherDependencies", "\[Rule]", "odeps"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
                    RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"{", 
                    RowBox[{"vector", "[", "ind1", "]"}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"ProjectedWith", "\[RuleDelayed]", 
                    RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"{", 
                    RowBox[{"metric", "[", 
                    RowBox[{"ind1", ",", 
                    RowBox[{"-", "ind2"}]}], "]"}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Master", "\[Rule]", "metric"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"{", "options", "}"}], ",", 
                    RowBox[{"_", "[", 
                    RowBox[{"PrintAs", ",", "_"}], "]"}]}], "]"}]}], 
                   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                 "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"InducedCovDQ", "[", "covd", "]"}], "=", 
                 "inducedQ"}], ";", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"Torsion", ".", " ", 
                  RowBox[{"TODO", ":", " ", 
                   RowBox[{
                   "modify", " ", "the", " ", "covdsymbol", " ", "in", " ", 
                    "the", " ", "LCmetric"}]}]}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"LCmetric", "=", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"TorsionQ", "[", "covd", "]"}], ",", 
                   RowBox[{"LC", "[", "metric", "]"}], ",", "covd"}], "]"}]}],
                 ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"!", 
                   RowBox[{"CovDQ", "[", "LCmetric", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"DefCovD", "[", 
                   RowBox[{
                    RowBox[{"LCmetric", "[", 
                    RowBox[{"-", "ind1"}], "]"}], ",", "covdsymbol", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"FromMetric", "\[Rule]", "metric"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Torsion", "\[Rule]", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Curvature", "\[Rule]", "True"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OtherDependencies", "\[Rule]", "odeps"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OrthogonalTo", "\[RuleDelayed]", 
                    RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"{", 
                    RowBox[{"vector", "[", "ind1", "]"}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"ProjectedWith", "\[RuleDelayed]", 
                    RowBox[{"If", "[", 
                    RowBox[{"inducedQ", ",", 
                    RowBox[{"{", 
                    RowBox[{"metric", "[", 
                    RowBox[{"ind1", ",", 
                    RowBox[{"-", "ind2"}]}], "]"}], "}"}], ",", 
                    RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Master", "\[Rule]", "metric"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"DeleteCases", "[", 
                    RowBox[{
                    RowBox[{"{", "options", "}"}], ",", 
                    RowBox[{"_", "[", 
                    RowBox[{"PrintAs", ",", "_"}], "]"}]}], "]"}]}], 
                   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                 "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"metric", "/:", 
                 RowBox[{"CovDOfMetric", "[", 
                  RowBox[{"metric", ",", 
                   RowBox[{"Torsion", "[", "covd", "]"}]}], "]"}], "=", 
                 "covd"}], ";", "\[IndentingNewLine]", 
                RowBox[{"metric", "/:", 
                 RowBox[{"CovDOfMetric", "[", 
                  RowBox[{"metric", ",", 
                   RowBox[{"Torsion", "[", "LCmetric", "]"}]}], "]"}], "=", 
                 "LCmetric"}], ";", "\[IndentingNewLine]", 
                RowBox[{"metric", "/:", 
                 RowBox[{"CovDOfMetric", "[", 
                  RowBox[{"metric", ",", "Zero"}], "]"}], "=", "LCmetric"}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"metric", "/:", 
                 RowBox[{"LC", "[", "metric", "]"}], "=", "LCmetric"}], ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"flatPD", ",", 
                  RowBox[{"Protect", "[", "PD", "]"}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"$ProtectNewSymbols", ",", 
                  RowBox[{"Protect", "[", "covd", "]"}]}], "]"}], ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{
                 "Derivatives", " ", "of", " ", "the", " ", "metric", " ", 
                  "are", " ", "defined", " ", "in", " ", "DefCovD"}], " ", 
                 "*)"}], "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{
                 "Other", " ", "covariant", " ", "derivatives", " ", "on", 
                  " ", "the", " ", "metric", " ", "with", " ", "upstairs", 
                  " ", "abstract", " ", "indices"}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"!", "inducedQ"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"invmetric", "/:", 
                   RowBox[{"HoldPattern", "[", 
                    RowBox[{
                    RowBox[{"der_", "?", "FirstDerQ"}], "[", 
                    RowBox[{"invmetric", "[", 
                    RowBox[{
                    RowBox[{"b_", "?", "vbQ"}], ",", 
                    RowBox[{"c_", "?", "vbQ"}]}], "]"}], "]"}], "]"}], ":=", 
                   RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"b1", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
                    RowBox[{"c1", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
                    
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"invmetric", "[", 
                    RowBox[{"b", ",", "b1"}], "]"}]}], 
                    RowBox[{"invmetric", "[", 
                    RowBox[{"c", ",", "c1"}], "]"}], 
                    RowBox[{"der", "[", 
                    RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"-", "b1"}], ",", 
                    RowBox[{"-", "c1"}]}], "]"}], "]"}]}]}], "]"}]}]}], "]"}],
                 ";"}]}], "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
               "There", " ", "is", " ", "no", " ", "simple", " ", 
                "generalization", " ", "for", " ", "induced", " ", 
                RowBox[{"metrics", ".", "\[IndentingNewLine]", 
                 RowBox[{"QUESTION", ":", " ", 
                  RowBox[{
                  "Is", " ", "there", " ", "an", " ", "equivalent", " ", 
                   "rule", " ", "for", " ", "the", " ", "epsilon", " ", 
                   RowBox[{"tensor", "?"}]}]}]}]}], "*)"}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Determinant", " ", "in", " ", "the", " ", "basis", " ", 
               RowBox[{"AIndex", ".", " ", "Has"}], " ", "to", " ", "be", " ",
                "defined", " ", "after", " ", "the", " ", "covd", " ", "and", 
               " ", "the", " ", "invmetric"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"info", "===", "False"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Block", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"$DefInfoQ", "=", "False"}], "}"}], ",", 
                 RowBox[{
                  RowBox[{"Determinant", "[", 
                   RowBox[{"metric", ",", "AIndex"}], "]"}], "[", "]"}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Determinant", "[", 
                 RowBox[{"metric", ",", "AIndex"}], "]"}], "[", "]"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Define", " ", "induced", " ", "metric"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"tangentmetricQ", ",", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{"inducedQ", ",", 
                 RowBox[{"DefInducedMetric", "[", 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{
                    RowBox[{"-", "ind1"}], ",", 
                    RowBox[{"-", "ind2"}]}], "]"}], ",", 
                   RowBox[{"{", "manifold", "}"}], ",", "covd", ",", 
                   RowBox[{"{", 
                    RowBox[{"vector", ",", "supermetric", ",", 
                    RowBox[{"CovDOfMetric", "[", "supermetric", "]"}]}], 
                    "}"}], ",", "flat"}], "]"}]}], "]"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Store", " ", "conformal", " ", "relations"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"confto", "=!=", "Null"}], ",", "\[IndentingNewLine]", 
               
               RowBox[{"SetConformalTo", "[", 
                RowBox[{
                 RowBox[{"metric", "[", 
                  RowBox[{
                   RowBox[{"-", "ind1"}], ",", 
                   RowBox[{"-", "ind2"}]}], "]"}], ",", "confto"}], "]"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"MakexTensions", "[", 
              RowBox[{"DefMetric", ",", "\"\<End\>\"", ",", "signdet", ",", 
               RowBox[{"metric", "[", 
                RowBox[{
                 RowBox[{"-", "ind1"}], ",", 
                 RowBox[{"-", "ind2"}]}], "]"}], ",", "covd", ",", 
               "options"}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"On", "[", 
              RowBox[{"OptionValue", "::", "nodef"}], "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"pns", ",", 
               RowBox[{"Protect", "[", "metric", "]"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"For", " ", "metrics", " ", "on", " ", "inner", " ", "vbundles"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefMetric", "[", 
    RowBox[{"signdet_", ",", "metric_", ",", 
     RowBox[{"opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"DefMetric", "[", 
    RowBox[{"signdet", ",", "metric", ",", "None", ",", "opts"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefMetric", "[", 
    RowBox[{"_", ",", "metric_", ",", "_", ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"DefMetric", "::", "invalid"}], ",", "metric", ",", 
     "\"\<metric\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefMetric", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefMetric", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"On", "[", 
   RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8fe924f3-2b7f-4409-8421-cc4eeaa0c6ef"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDOfMetric", "[", "metric_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CovDOfMetric", "::", "unknown"}], ",", "\"\<metric\>\"", ",", 
      "metric"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDOfMetric", "[", 
    RowBox[{"metric_", ",", 
     RowBox[{"torsion_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CovDOfMetric", "::", "unknown"}], ",", "\"\<metric\>\"", ",", 
      "metric"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDOfMetric", "[", 
    RowBox[{
     RowBox[{"metric_", "?", "xTensorQ"}], ",", "torsion_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CovDOfMetric", "::", "unknown"}], ",", "\"\<torsion\>\"", ",", 
      "torsion"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LC", "[", "metric_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"LC", "::", "unknown"}], ",", "\"\<metric\>\"", ",", "metric"}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SignatureOfMetric", "[", "metric_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SignatureOfMetric", "::", "unknown"}], ",", 
      "\"\<(signature of) metric\>\"", ",", "metric"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SignDetOfMetric", "[", "metric_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SignDetOfMetric", "::", "unknown"}], ",", "\"\<metric\>\"", 
      ",", "metric"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"VBundleOfMetric", "[", "metric_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"VBundleOfMetric", "::", "unknown"}], ",", "\"\<metric\>\"", 
      ",", "metric"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InducedFrom", "[", "metric_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"InducedFrom", "::", "unknown"}], ",", "\"\<metric\>\"", ",", 
      "metric"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"#", ",", "1"}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "LC", ",", "SignatureOfMetric", ",", "SignDetOfMetric", ",", 
     "VBundleOfMetric", ",", "InducedFrom"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"CovDOfMetric", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{
   "CovDOfMetric", ",", "SignatureOfMetric", ",", "SignDetOfMetric", ",", 
    "VBundleOfMetric", ",", "FlatMetricQ", ",", "FlatMetric", ",", 
    "InducedFrom"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"65e447f7-6436-4fae-8a97-e4160f5b4306"],

Cell["\<\
The function relating epsilon tensors and eta tensors have a default value, \
equal to the old value of that factor. The difference is that now the factor \
can be set differently for each pair {metric, basis} instead of globally for \
all of them.\
\>", "Text",ExpressionUUID->"b131a2dd-eba8-48c3-9f02-4a43324c8fac"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"epsilonOrientation", "[", 
    RowBox[{
     RowBox[{"_", "?", "MetricQ"}], ",", 
     RowBox[{"_", "?", "BasisQ"}]}], "]"}], ":=", "$epsilonSign"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"epsilonOrientation", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "epsilonOrientation", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7615c46e-4094-4465-9480-ab1e74bf512a"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.1.2. Undefinition", \
"Subsubsection",ExpressionUUID->"5f4dec52-bc7b-43a2-93f6-28fc270479f5"],

Cell["\<\
It could happen that PD is a servant of a metric. To avoid trying to undefine \
PD we drop it from the servants list.\
\>", "Text",ExpressionUUID->"71fe2c1c-d2e0-4b88-916f-cb45c7141842"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UndefMetric", "[", 
    RowBox[{"list", ":", 
     RowBox[{"{", 
      RowBox[{"___", "?", "MetricQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{"UndefMetric", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UndefMetric", "[", "metric_", "]"}], ":=", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"servants", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"ServantsOf", "[", "metric", "]"}], ",", "PD"}], "]"}]}], 
        ",", 
        RowBox[{"vbundle", "=", 
         RowBox[{"VBundleOfMetric", "[", "metric", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Check", " ", "that", " ", "it", " ", "is", " ", "really", " ", "a", 
        " ", "metric"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MetricQ", "[", "metric", "]"}]}], ",", 
         RowBox[{"Throw", "@", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"UndefMetric", "::", "unknown"}], ",", "\"\<metric\>\"", 
            ",", "metric"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"CheckRemoveSymbol", "[", "metric", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefMetric", ",", "\"\<Beginning\>\"", ",", "metric"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xUpSet", "[", 
        RowBox[{
         RowBox[{"ServantsOf", "[", "metric", "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DropFromHosts", "[", "metric", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Undef", "/@", 
        RowBox[{"Reverse", "[", "servants", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "Unregister", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"xUpDeleteCasesTo", "[", 
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", "vbundle", "]"}], ",", "metric"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"$Metrics", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"$Metrics", ",", "metric"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Unprotect", "[", "metric", "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MetricOfCovD", "[", "PD", "]"}], "===", "metric"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"xUpSet", "[", 
           RowBox[{
            RowBox[{"MetricOfCovD", "[", "PD", "]"}], ",", "Null"}], "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"$SortPDsRules", "=", 
           RowBox[{"Take", "[", 
            RowBox[{"$SortPDsRules", ",", "1"}], "]"}]}], ";"}]}], " ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Preserve", " ", "only", " ", "the", " ", "general", " ", "rule"}], 
         " ", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{"$ProductMetrics", ",", "metric"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Unset", "[", 
           RowBox[{"ProductMetricRules", "[", 
            RowBox[{"metric", ",", "Metric"}], "]"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Unset", "[", 
           RowBox[{"ProductMetricRules", "[", 
            RowBox[{"metric", ",", "CovD"}], "]"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Unset", "[", 
           RowBox[{"ProductMetricRules", "[", 
            RowBox[{"metric", ",", "Christoffel"}], "]"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Unset", "[", 
           RowBox[{"ProductMetricRules", "[", 
            RowBox[{"metric", ",", "Riemann"}], "]"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"$ProductMetrics", "=", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{"$ProductMetrics", ",", "metric"}], "]"}]}]}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Remove", " ", "tensor"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"TagUnset", "[", 
        RowBox[{"metric", ",", 
         RowBox[{"MetricQ", "[", "metric", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"MakexTensions", "[", 
        RowBox[{"UndefMetric", ",", "\"\<End\>\"", ",", "metric"}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"UndefTensor", "[", "metric", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UndefMetric", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UndefMetric", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c9169e59-49a6-4033-bc02-82c3aebef562"],

Cell["\<\
Note that we must unset MetricQ before calling UndefTensor to avoid coming \
back here from there!\
\>", "Text",ExpressionUUID->"b968ea29-be2e-41b8-8a0b-52699fcb4d30"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.1.3. GradMetricToChristoffel and ChristoffelToGradMetric", \
"Subsubsection",ExpressionUUID->"17860886-fcdc-4cb0-b80e-bfc177fd5d1f"],

Cell["\<\
This function translates any covariant derivative of a (tangent-bundle) \
metric into the corresponding Christoffel. The derivative can be of any type \
(with or without curvature, with or without torsion). Note that only when we \
find a particular gradient of a metric then we construct the required \
Christoffel tensor, and not all the possible tensors that could be \
constructed with the metrics and covds at hand.

Essentially this is a simpler form of ChangeCurvature, here applied to \
derivatives of metrics, the idea being simply the change from the given \
derivative to the Levi-Civita connection of the metric:\
\>", "Text",ExpressionUUID->"83a03bfe-655b-4b80-a263-64101d467373"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Three", " ", 
     RowBox[{"arguments", ":", " ", "expr"}]}], ",", " ", "metric", ",", " ", 
    
    RowBox[{"covd", ".", " ", "Main"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"metric_Symbol", "?", "MetricQ"}], ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"gradMetricToChristoffel", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"CovDOfMetric", "[", "metric", "]"}], ",", "metric", ",", 
         RowBox[{"Inv", "[", "metric", "]"}]}], "}"}], ",", "covd"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr_", ",", "metric_", ",", "list_List"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"GradMetricToChristoffel", "[", 
         RowBox[{"#1", ",", "metric", ",", "#2"}], "]"}], "&"}], ",", "expr", 
       ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr_", ",", "list_List", ",", "covd_"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"GradMetricToChristoffel", "[", 
         RowBox[{"#1", ",", "#2", ",", "covd"}], "]"}], "&"}], ",", "expr", 
       ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"_", ",", "x_", ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"GradMetricToChristoffel", "::", "unknown"}], ",", 
        "\"\<metric\>\"", ",", "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"_", ",", "_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"GradMetricToChristoffel", "::", "unknown"}], ",", 
        "\"\<covariant derivative\>\"", ",", "y"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Two", " ", 
      RowBox[{"arguments", ":", " ", "expr"}]}], ",", " ", "metric"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{"GradMetricToChristoffel", ",", "expr", ",", "list"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr_", ",", "metric_"}], "]"}], ":=", 
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr", ",", "metric", ",", "$CovDs"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"One", " ", 
     RowBox[{"argument", ":", " ", "expr"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GradMetricToChristoffel", "[", "expr_", "]"}], ":=", 
     RowBox[{"GradMetricToChristoffel", "[", 
      RowBox[{"expr", ",", "$Metrics"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"GradMetricToChristoffel", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "GradMetricToChristoffel", "]"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dfde6e69-f434-4448-9055-c151964aac7e"],

Cell["\<\
Search for appropriate metric derivatives in the expression and introduce a \
Christoffel term per index of the metric (which can be both abstract or \
basis). This is assuming that the metric is symmetric (I have no idea about \
whether Christoffels, etc exist for antisymmetric metrics):\
\>", "Text",ExpressionUUID->"350c28aa-3e48-4753-8da2-1af88d0dc0f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"gradMetricToChristoffel", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"metriccovd_", ",", "metric_", ",", "invmetric_"}], "}"}], ",", 
     "covd_"}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"covd", "[", "i_", "]"}], "[", 
        RowBox[{"metric", "[", 
         RowBox[{
          RowBox[{"i1_", "?", "DownIndexQ"}], ",", 
          RowBox[{"i2_", "?", "DownIndexQ"}]}], "]"}], "]"}], 
       "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"gradMetricTerm", "[", 
         RowBox[{
          RowBox[{"covd", "[", "i", "]"}], ",", "metriccovd", ",", "metric", 
          ",", "i1", ",", "i2"}], "]"}], "+", 
        RowBox[{"gradMetricTerm", "[", 
         RowBox[{
          RowBox[{"covd", "[", "i", "]"}], ",", "metriccovd", ",", "metric", 
          ",", "i2", ",", "i1"}], "]"}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"covd", "[", "i_", "]"}], "[", 
        RowBox[{"invmetric", "[", 
         RowBox[{
          RowBox[{"i1_", "?", "UpIndexQ"}], ",", 
          RowBox[{"i2_", "?", "UpIndexQ"}]}], "]"}], "]"}], "\[RuleDelayed]", 
       
       RowBox[{
        RowBox[{"gradInvMetricTerm", "[", 
         RowBox[{
          RowBox[{"covd", "[", "i", "]"}], ",", "metriccovd", ",", 
          "invmetric", ",", "i1", ",", "i2"}], "]"}], "+", 
        RowBox[{"gradInvMetricTerm", "[", 
         RowBox[{
          RowBox[{"covd", "[", "i", "]"}], ",", "metriccovd", ",", 
          "invmetric", ",", "i2", ",", "i1"}], "]"}]}]}]}], 
     "\[IndentingNewLine]", "}"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e28ed1e1-c1bb-4864-bf17-790128a211c2"],

Cell["\<\
This is valid for frozen metrics, but I'm not sure about induced metrics. It \
is interesting that this formulas do not need torsion terms. Note that the \
second rule (the one for derivatives of the inverse metric) might not be \
needed at all because derivatives of inverse metrics evaluate to derivatives \
of metrics contracted with pairs of inverse metrics.\
\>", "Text",ExpressionUUID->"5648e095-924c-4fec-a42b-1131ac7ded49"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"gradMetricTerm", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "a_", "]"}], ",", "metriccovd_", ",", "metric_", 
     ",", 
     RowBox[{"-", "b_Symbol"}], ",", "c_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"d", "=", 
       RowBox[{"DummyAs", "[", "b", "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"metric", "[", 
       RowBox[{
        RowBox[{"-", "b"}], ",", 
        RowBox[{"-", "d"}]}], "]"}], 
      RowBox[{
       RowBox[{"Christoffel", "[", 
        RowBox[{"metriccovd", ",", "covd"}], "]"}], "[", 
       RowBox[{"d", ",", "a", ",", "c"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"gradInvMetricTerm", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "a_", "]"}], ",", "metriccovd_", ",", "invmetric_",
      ",", "b_Symbol", ",", "c_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"d", "=", 
       RowBox[{"DummyAs", "[", "b", "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"invmetric", "[", 
        RowBox[{"b", ",", "d"}], "]"}]}], 
      RowBox[{
       RowBox[{"Christoffel", "[", 
        RowBox[{"covd", ",", "metriccovd"}], "]"}], "[", 
       RowBox[{"c", ",", "a", ",", 
        RowBox[{"-", "d"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"gradMetricTerm", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "a_", "]"}], ",", "metriccovd_", ",", "metric_", 
     ",", 
     RowBox[{"b", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"-", "basis_Symbol"}]}], "}"}], "|", 
        RowBox[{"-", 
         RowBox[{
          RowBox[{"basis_", "?", "BasisQ"}], "[", "_", "]"}]}]}], ")"}]}], 
     ",", "c_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"d", "=", 
       RowBox[{"-", 
        RowBox[{"DummyAs", "[", "b", "]"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"metric", "[", 
       RowBox[{"b", ",", 
        RowBox[{"-", "d"}]}], "]"}], 
      RowBox[{
       RowBox[{"Christoffel", "[", 
        RowBox[{"metriccovd", ",", 
         RowBox[{"xAct`xCoba`PDOfBasis", "[", "basis", "]"}]}], "]"}], "[", 
       RowBox[{"d", ",", "a", ",", "c"}], "]"}]}]}], "]"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"BASIS1", " ", "and", " ", "BASIS2"}], " ", "*)"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"gradInvMetricTerm", "[", 
    RowBox[{
     RowBox[{"covd_", "[", "a_", "]"}], ",", "metriccovd_", ",", "invmetric_",
      ",", 
     RowBox[{"b", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "basis_Symbol"}], "}"}], "|", 
        RowBox[{
         RowBox[{"basis_", "?", "BasisQ"}], "[", "_", "]"}]}], ")"}]}], ",", 
     "c_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"d", "=", 
       RowBox[{"DummyAs", "[", "b", "]"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"invmetric", "[", 
        RowBox[{"b", ",", "d"}], "]"}]}], 
      RowBox[{
       RowBox[{"Christoffel", "[", 
        RowBox[{
         RowBox[{"xAct`xCoba`PDOfBasis", "[", "basis", "]"}], ",", 
         "metriccovd"}], "]"}], "[", 
       RowBox[{"c", ",", "a", ",", 
        RowBox[{"-", "d"}]}], "]"}]}]}], "]"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"BASIS1", " ", "and", " ", "BASIS2"}], " ", "*)"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e134d802-0ef3-4bfe-8771-b20d0e129bff"],

Cell["\<\
This function performs the opposite operation. The second derivative is also \
generic., except for the fact that it must be one of the two derivatives in \
the Christoffel tensor.\
\>", "Text",ExpressionUUID->"ac123b13-9ab0-4455-a218-d1bc72c59faf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Three", " ", 
     RowBox[{"arguments", ":", " ", "expr"}]}], ",", " ", "metric", ",", " ", 
    
    RowBox[{"covd", ".", " ", "Main"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"metric_Symbol", "?", "MetricQ"}], ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"christoffelToGradMetric", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"CovDOfMetric", "[", "metric", "]"}], ",", "metric", ",", 
         RowBox[{"Inv", "[", "metric", "]"}]}], "}"}], ",", "covd"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", "metric_", ",", "list_List"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ChristoffelToGradMetric", "[", 
         RowBox[{"#1", ",", "metric", ",", "#2"}], "]"}], "&"}], ",", "expr", 
       ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", "list_List", ",", "covd_"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ChristoffelToGradMetric", "[", 
         RowBox[{"#1", ",", "#2", ",", "covd"}], "]"}], "&"}], ",", "expr", 
       ",", "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"_", ",", "x_", ",", 
       RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ChristoffelToGradMetric", "::", "unknown"}], ",", 
        "\"\<metric\>\"", ",", "x"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"_", ",", "_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ChristoffelToGradMetric", "::", "unknown"}], ",", 
        "\"\<covariant derivative\>\"", ",", "y"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Two", " ", 
      RowBox[{"arguments", ":", " ", "expr"}]}], ",", " ", "metric"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{"ChristoffelToGradMetric", ",", "expr", ",", "list"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", "metric_"}], "]"}], ":=", 
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr", ",", "metric", ",", "$CovDs"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"One", " ", 
     RowBox[{"argument", ":", " ", "expr"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ChristoffelToGradMetric", "[", "expr_", "]"}], ":=", 
     RowBox[{"ChristoffelToGradMetric", "[", 
      RowBox[{"expr", ",", "$Metrics"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"ChristoffelToGradMetric", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"Protect", "[", "ChristoffelToGradMetric", "]"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f7a4a7a3-9ee7-4b02-a9d0-4ff901032f67"],

Cell["Our convention on how to sort Christoffels in an expression.", \
"Text",ExpressionUUID->"a93a8055-42d1-496c-b670-7124b3a52be4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"orderChristoffels", "[", 
    RowBox[{"PD", ",", "covd_"}], "]"}], ":=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"orderChristoffels", "[", 
    RowBox[{"covd_", ",", "PD"}], "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"orderChristoffels", "[", 
    RowBox[{"covd1_", ",", "covd2_"}], "]"}], ":=", 
   RowBox[{"Order", "[", 
    RowBox[{"covd1", ",", "covd2"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"82088c9c-135b-4120-916a-87b7997b4927"],

Cell["\<\
The hard work is done by this function, which is valid for frozen metrics, \
but I'm not sure about induced metrics. Torsion terms have been fixed for \
1.1.0 after Teake reported a bug in the group on August 15, 2013.\
\>", "Text",ExpressionUUID->"84783c93-b7f9-4c21-81fd-c03fb5c23874"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "the", " ", "metricovd", " ", "is", " ", "PD", " ", "then", 
     " ", "we", " ", "have", " ", "a", " ", "Cartesian", " ", "metric"}], ",",
     " ", 
    RowBox[{
    "and", " ", "it", " ", "makes", " ", "no", " ", "sense", " ", "to", " ", 
     "differentiate", " ", "it"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"christoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"{", 
        RowBox[{"PD", ",", "_", ",", "_"}], "}"}], ",", "_"}], "]"}], ":=", 
     "expr"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"christoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"{", 
        RowBox[{"metriccovd_", ",", "_", ",", "_"}], "}"}], ",", 
       "metriccovd_"}], "]"}], ":=", "expr"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"christoffelToGradMetric", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"{", 
        RowBox[{"metriccovd_", ",", "metric_", ",", "invmetric_"}], "}"}], 
       ",", "covd_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vbundle", "=", 
          RowBox[{"VBundleOfMetric", "[", "metric", "]"}]}], ",", 
         RowBox[{"name", "=", 
          RowBox[{"Cases", "[", 
           RowBox[{"$Christoffels", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"chr_", ",", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"_", ",", "metriccovd", ",", "covd"}], "}"}], "|", 
                RowBox[{"{", 
                 RowBox[{"_", ",", "covd", ",", "metriccovd"}], "}"}]}], ",", 
               "_"}], "}"}], "\[RuleDelayed]", "chr"}]}], "]"}]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"name", "===", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "expr", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"expr", "/.", 
          RowBox[{
           RowBox[{
            RowBox[{"First", "[", "name", "]"}], "[", 
            RowBox[{"i1_", ",", "i2_", ",", "i3_"}], "]"}], "\[RuleDelayed]", 
           
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ii1", "=", 
                RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
               RowBox[{"ii2", "=", 
                RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
               RowBox[{"ii3", "=", 
                RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
             RowBox[{
              RowBox[{"invmetric", "[", 
               RowBox[{"i1", ",", "ii1"}], "]"}], 
              RowBox[{"delta", "[", 
               RowBox[{"i2", ",", "ii2"}], "]"}], 
              RowBox[{"delta", "[", 
               RowBox[{"i3", ",", "ii3"}], "]"}], 
              RowBox[{"orderChristoffels", "[", 
               RowBox[{"metriccovd", ",", "covd"}], "]"}], 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"covd", "[", 
                   RowBox[{"-", "ii2"}], "]"}], "[", 
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"-", "ii3"}], ",", 
                    RowBox[{"-", "ii1"}]}], "]"}], "]"}], "+", 
                 RowBox[{
                  RowBox[{"covd", "[", 
                   RowBox[{"-", "ii3"}], "]"}], "[", 
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii1"}]}], "]"}], "]"}], "-", 
                 RowBox[{
                  RowBox[{"covd", "[", 
                   RowBox[{"-", "ii1"}], "]"}], "[", 
                  RowBox[{"metric", "[", 
                   RowBox[{
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii3"}]}], "]"}], "]"}], "+", 
                 RowBox[{"$TorsionSign", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Torsion", "[", "covd", "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii3"}], ",", 
                    RowBox[{"-", "ii1"}]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"Torsion", "[", "covd", "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "ii3"}], ",", 
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii1"}]}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"Torsion", "[", "covd", "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "ii1"}], ",", 
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii3"}]}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"Torsion", "[", "metriccovd", "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii3"}], ",", 
                    RowBox[{"-", "ii1"}]}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"Torsion", "[", "metriccovd", "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "ii3"}], ",", 
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii1"}]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"Torsion", "[", "metriccovd", "]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "ii1"}], ",", 
                    RowBox[{"-", "ii2"}], ",", 
                    RowBox[{"-", "ii3"}]}], "]"}]}], ")"}]}]}], ")"}], "/", 
               "2"}]}]}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bc5dd0c1-62bc-4df0-8f33-24e17ed682fa"],

Cell["Backwards compatibility:", \
"Text",ExpressionUUID->"03b9033c-c1a9-4692-a3fd-c7351f74d9fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChristoffelToMetric"}]], \
"Input",ExpressionUUID->"acc267e2-2076-4969-93ce-3858210ce897"],

Cell[BoxData[
 StyleBox["\<\"ChristoffelToMetric = ChristoffelToGradMetric. Kept for \
backwards compatibility.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672844-5338953",ExpressionUUID->"b6d4291d-59d0-4300-9778-\
8365051325f7"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ChristoffelToMetric", "=", "ChristoffelToGradMetric"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ChristoffelToMetric", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"28d1898d-1fda-427e-a026-f489e56ec678"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.1.4. ChristoffelToGradConformal", \
"Subsubsection",ExpressionUUID->"6231c7e8-1102-4d79-becb-1d0c1d926018"],

Cell["\<\
This simple function changes Christoffel tensors between the LeviCivita \
connections of two conformally related metrics by their expression in terms \
of derivatives of the conformal factor. We are not currently considering the \
possibility of having torsion.\
\>", "Text",ExpressionUUID->"6bc87737-e5d9-4015-a281-798a7db7d56c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelToGradConformal", "::", "nomet"}], "=", 
   "\"\<Covariant derivative `1` does not have an associated metric.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelToGradConformal", "[", 
    RowBox[{"expr_", ",", "list_List", ",", "new_"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ChristoffelToGradConformal", "[", 
       RowBox[{"#1", ",", "#2", ",", "new"}], "]"}], "&"}], ",", "expr", ",", 
     "list"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelToGradConformal", "[", 
    RowBox[{"expr_", ",", "old_", ",", "old_"}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelToGradConformal", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"old_", "?", "CovDQ"}], ",", "new_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"metric", "=", 
       RowBox[{"MetricOfCovD", "[", "old", "]"}]}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"metric", "=!=", "Null"}], ",", 
       RowBox[{"ChristoffelToGradConformal", "[", 
        RowBox[{"expr", ",", "metric", ",", "new"}], "]"}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ChristoffelToGradConformal", "::", "nomet"}], ",", "old"}],
          "]"}]}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelToGradConformal", "[", 
    RowBox[{"expr_", ",", "old_", ",", 
     RowBox[{"new_", "?", "CovDQ"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"metric", "=", 
       RowBox[{"MetricOfCovD", "[", "new", "]"}]}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"metric", "=!=", "Null"}], ",", 
       RowBox[{"ChristoffelToGradConformal", "[", 
        RowBox[{"expr", ",", "old", ",", "metric"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ChristoffelToGradConformal", "::", "nomet"}], ",", "new"}],
          "]"}]}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelToGradConformal", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"old_", "?", "MetricQ"}], ",", 
     RowBox[{"new_", "?", "MetricQ"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vb", "=", 
        RowBox[{"-", 
         RowBox[{"First", "[", 
          RowBox[{"SlotsOfTensor", "[", "new", "]"}], "]"}]}]}], ",", 
       RowBox[{"oldcovd", "=", 
        RowBox[{"CovDOfMetric", "[", "old", "]"}]}], ",", 
       RowBox[{"newcovd", "=", 
        RowBox[{"CovDOfMetric", "[", "new", "]"}]}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"confactor", "=", 
          RowBox[{"ConformalFactor", "[", 
           RowBox[{"old", ",", "new"}], "]"}]}], ",", 
         RowBox[{"invnew", "=", 
          RowBox[{"Inv", "[", "new", "]"}]}], ",", 
         RowBox[{"chr", "=", 
          RowBox[{"Head", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Christoffel", "@@", 
              RowBox[{"Sort", "[", 
               RowBox[{"{", 
                RowBox[{"oldcovd", ",", "newcovd"}], "}"}], "]"}]}], ")"}], 
            "[", 
            RowBox[{
             RowBox[{"DummyIn", "[", "vb", "]"}], ",", 
             RowBox[{"-", 
              RowBox[{"DummyIn", "[", "vb", "]"}]}], ",", 
             RowBox[{"-", 
              RowBox[{"DummyIn", "[", "vb", "]"}]}]}], "]"}], "]"}]}], ",", 
         RowBox[{"sign", "=", 
          RowBox[{"Order", "[", 
           RowBox[{"oldcovd", ",", "newcovd"}], "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"confactor", "===", "Null"}], ",", "\[IndentingNewLine]", 
         "expr", ",", "\[IndentingNewLine]", 
         RowBox[{"expr", "/.", 
          RowBox[{
           RowBox[{"chr", "[", 
            RowBox[{"c_", ",", "a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"d", "=", 
               RowBox[{"DummyIn", "[", "vb", "]"}]}], "}"}], ",", 
             RowBox[{"Expand", "[", 
              RowBox[{
               RowBox[{"sign", "/", "2"}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"delta", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                   RowBox[{
                    RowBox[{"newcovd", "[", "b", "]"}], "[", "confactor", 
                    "]"}]}], "+", 
                  RowBox[{
                   RowBox[{"delta", "[", 
                    RowBox[{"b", ",", "c"}], "]"}], 
                   RowBox[{
                    RowBox[{"newcovd", "[", "a", "]"}], "[", "confactor", 
                    "]"}]}], "-", 
                  RowBox[{
                   RowBox[{"new", "[", 
                    RowBox[{"a", ",", "b"}], "]"}], 
                   RowBox[{"invnew", "[", 
                    RowBox[{"c", ",", "d"}], "]"}], 
                   RowBox[{
                    RowBox[{"newcovd", "[", 
                    RowBox[{"-", "d"}], "]"}], "[", "confactor", "]"}]}]}], 
                 ")"}], "/", "confactor"}]}], "]"}]}], "]"}]}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ChristoffelToGradConformal", ",", "3"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ChristoffelToGradConformal", "]"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a32a1579-70f5-48bd-8317-d4ced9396cab"],

Cell["\<\
Storage of the conformal factor and the full conformal relation:\
\>", "Text",ExpressionUUID->"4c454e7c-8142-4edc-b0d5-9269e3610f5d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ConformalFactor", "[", 
    RowBox[{"x_", ",", 
     RowBox[{"x_", "?", "MetricQ"}]}], "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConformalFactor", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Switch", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"MetricQ", "[", "x", "]"}], ",", 
       RowBox[{"MetricQ", "[", "y", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True"}], "}"}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ConformalFactor", "::", "unknown"}], ",", 
        "\"\<conformal relation of metric\>\"", ",", "x"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ConformalFactor", "::", "unknown"}], ",", "\"\<metric\>\"", 
        ",", "y"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"False", ",", "_"}], "}"}], ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ConformalFactor", "::", "unknown"}], ",", "\"\<metric\>\"", 
        ",", "x"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ConformalFactor", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ConformalFactor", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e37deabc-6401-4dfa-bcb4-f037a859f2e1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ConformalRules", "[", 
    RowBox[{"x_List", ",", "y_List"}], "]"}], ":=", 
   RowBox[{"Inner", "[", 
    RowBox[{"ConformalRules", ",", "x", ",", "y", ",", "Join"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConformalRules", "[", 
    RowBox[{"x_", ",", "x_"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ConformalRules", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ConformalRules", "::", "unknown"}], ",", 
      "\"\<conformal relation of\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ConformalRules", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ConformalRules", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"68565744-bc8c-468e-9cf3-4e63fc430e30"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetConformalTo", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"metric_", "?", "MetricQ"}], "[", 
      RowBox[{
       RowBox[{"-", "i1_"}], ",", 
       RowBox[{"-", "i2_"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"originalmetric_", "?", "MetricQ"}], "[", 
        RowBox[{
         RowBox[{"-", "i1_"}], ",", 
         RowBox[{"-", "i2_"}]}], "]"}], ",", "confactor_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prot", "=", 
       RowBox[{"Unprotect", "[", "metric", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"metric", "/:", 
       RowBox[{"ConformalFactor", "[", 
        RowBox[{"metric", ",", "originalmetric"}], "]"}], "=", "confactor"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"metric", "/:", 
       RowBox[{"ConformalFactor", "[", 
        RowBox[{"originalmetric", ",", "metric"}], "]"}], "=", 
       RowBox[{"1", "/", "confactor"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"metric", "/:", 
       RowBox[{"ConformalRules", "[", 
        RowBox[{"metric", ",", "originalmetric"}], "]"}], "=", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"metric", "[", 
           RowBox[{"i1_", ",", "i2_"}], "]"}], "\[Rule]", 
          RowBox[{"confactor", " ", 
           RowBox[{"originalmetric", "[", 
            RowBox[{"i1", ",", "i2"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{
           RowBox[{"Inv", "[", "metric", "]"}], "[", 
           RowBox[{"i1_", ",", "i2_"}], "]"}], "\[Rule]", 
          RowBox[{
           RowBox[{"1", "/", "confactor"}], " ", 
           RowBox[{
            RowBox[{"Inv", "[", "originalmetric", "]"}], "[", 
            RowBox[{"i1", ",", "i2"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{
           RowBox[{"Determinant", "[", "metric", "]"}], "[", "]"}], "\[Rule]", 
          RowBox[{
           RowBox[{"confactor", "^", 
            RowBox[{"DimOfVBundle", "[", 
             RowBox[{"VBundleOfMetric", "[", "metric", "]"}], "]"}]}], " ", 
           RowBox[{
            RowBox[{"Determinant", "[", "originalmetric", "]"}], "[", 
            "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"metric", "/:", 
       RowBox[{"ConformalRules", "[", 
        RowBox[{"originalmetric", ",", "metric"}], "]"}], "=", 
       "\[IndentingNewLine]", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FirstMetricQ", "[", "originalmetric", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"originalmetric", "[", 
               RowBox[{
                RowBox[{"i1_", "?", "DownIndexQ"}], ",", 
                RowBox[{"i2_", "?", "DownIndexQ"}]}], "]"}], "\[Rule]", 
              RowBox[{
               RowBox[{"1", "/", "confactor"}], " ", 
               RowBox[{"metric", "[", 
                RowBox[{"i1", ",", "i2"}], "]"}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"originalmetric", "[", 
               RowBox[{
                RowBox[{"i1_", "?", "UpIndexQ"}], ",", 
                RowBox[{"i2_", "?", "UpIndexQ"}]}], "]"}], "\[Rule]", 
              RowBox[{"confactor", " ", 
               RowBox[{
                RowBox[{"Inv", "[", "metric", "]"}], "[", 
                RowBox[{"i1", ",", "i2"}], "]"}]}]}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"originalmetric", "[", 
               RowBox[{"i1_", ",", "i2_"}], "]"}], "\[Rule]", 
              RowBox[{
               RowBox[{"1", "/", "confactor"}], " ", 
               RowBox[{"metric", "[", 
                RowBox[{"i1", ",", "i2"}], "]"}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Inv", "[", "originalmetric", "]"}], "[", 
               RowBox[{"i1_", ",", "i2_"}], "]"}], "\[Rule]", 
              RowBox[{"confactor", " ", 
               RowBox[{
                RowBox[{"Inv", "[", "metric", "]"}], "[", 
                RowBox[{"i1", ",", "i2"}], "]"}]}]}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Determinant", "[", "originalmetric", "]"}], "[", "]"}], 
           "\[Rule]", 
           RowBox[{
            RowBox[{
             RowBox[{"Determinant", "[", "metric", "]"}], "[", "]"}], "/", 
            RowBox[{"confactor", "^", 
             RowBox[{"DimOfVBundle", "[", 
              RowBox[{"VBundleOfMetric", "[", "metric", "]"}], "]"}]}]}]}], 
          "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Protect", "[", 
       RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"On", "[", 
   RowBox[{"RuleDelayed", "::", "rhs"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5bacc4c6-ceb0-4f73-81a4-20ab9c8cb0f0"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.1.5. Determinant of metric in a given basis", \
"Subsubsection",ExpressionUUID->"9e1ce3a4-47a0-4d69-9109-3e54a6b068ad"],

Cell["\<\
Construct determinant of the metric on the fly, if it does not exit yet, \
defining its properties under derivations:\
\>", "Text",ExpressionUUID->"318447ef-337e-4857-9eae-ddf8ab4ebda7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Determinant"}]], \
"Input",ExpressionUUID->"9e40ad12-7c25-4cbb-b42b-6c9d38d91104"],

Cell[BoxData[
 StyleBox["\<\"Determinant[metric, basis][] returns the scalar density tensor \
(with weight +2 in basis) representing the determinant of metric in the given \
basis. The tensor is defined if it does not exist yet. The default value for \
basis is AIndex.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672845-5338953",ExpressionUUID->"3049a859-dc83-4e7c-b70b-\
440902339f48"]
}, Open  ]],

Cell["\<\
Formatting. We do not need to include the name of the basis in the output \
string of Determinant because the color of the basis will be indicated in the \
density tildes.\
\>", "Text",ExpressionUUID->"2208ee96-f5a4-4b8d-8ebf-f3c0221132ea"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Determinant", "/:", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Determinant", ",", "metric_", ",", "AIndex"}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"\"\<Det\>\"", ",", "metric"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Determinant", "/:", 
   RowBox[{"GiveSymbol", "[", 
    RowBox[{"Determinant", ",", "metric_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"SymbolJoin", "[", 
    RowBox[{"\"\<Det\>\"", ",", "metric", ",", "basis"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GiveOutputString", "[", 
    RowBox[{"Determinant", ",", "metric_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"PrintAs", "[", "metric", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ac8f68b2-e652-4eb4-b1a5-b361e3d5b1ef"],

Cell["\<\
Definition of the metric determinant (not of its inverse!). Note that we \
check that we are passing a single basis object. This definition will be \
later generalized in xCoba to take a list of two bases, so that each index of \
the tensor can be in a different basis. This is needed to take determinants \
of Jacobian matrices.\
\>", "Text",ExpressionUUID->"49104117-ed41-41e2-af49-f496049c9299"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Determinant", "[", "metric_", "]"}], "[", "]"}], ":=", 
   RowBox[{
    RowBox[{"Determinant", "[", 
     RowBox[{"metric", ",", "AIndex"}], "]"}], "[", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Determinant", "[", 
     RowBox[{"metric_", ",", 
      RowBox[{"basis_", "?", "BasisQ"}]}], "]"}], "[", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cd", "=", 
        RowBox[{"CovDOfMetric", "[", "metric", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dmb", "=", 
        RowBox[{"GiveSymbol", "[", 
         RowBox[{"Determinant", ",", "metric", ",", "basis"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"vbundle", "=", 
        RowBox[{"VBundleOfMetric", "[", "metric", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"invmetric", "=", 
        RowBox[{"Inv", "[", "metric", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Define", " ", "tensor"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"DefTensor", "[", 
       RowBox[{
        RowBox[{"dmb", "[", "]"}], ",", 
        RowBox[{"Union", "[", 
         RowBox[{
          RowBox[{"DependenciesOfTensor", "[", "metric", "]"}], ",", 
          RowBox[{"xAct`xCoba`DependenciesOfBasis", "[", "basis", "]"}]}], 
         "]"}], ",", 
        RowBox[{"WeightOfTensor", "\[Rule]", 
         RowBox[{"2", "basis"}]}], ",", 
        RowBox[{"Master", "\[Rule]", "metric"}], ",", 
        RowBox[{"PrintAs", "\[RuleDelayed]", 
         RowBox[{"GiveOutputString", "[", 
          RowBox[{"Determinant", ",", "metric", ",", "basis"}], "]"}]}], ",", 
        
        RowBox[{"DefInfo", "\[RuleDelayed]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"$DefInfoQ", "===", "False"}], ",", "False", ",", 
           RowBox[{"{", 
            RowBox[{
            "\"\<weight +2 density\>\"", ",", "\"\<Determinant.\>\""}], 
            "}"}]}], "]"}]}], ",", 
        RowBox[{"TensorID", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Determinant", ",", "metric", ",", "basis"}], "}"}]}], ",", 
        
        RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Derivatives", " ", "of", " ", "the", " ", "determinant"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"TangentBundleQ", "[", "vbundle", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"WeightedWithBasis", "[", "cd", "]"}], "===", "basis"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"cd", "[", "a_", "]"}], "[", 
             RowBox[{"dmb", "[", "]"}], "]"}], "^:=", "0"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"dmb", "/:", 
            RowBox[{"TensorDerivative", "[", 
             RowBox[{"dmb", ",", "cd", ",", "___"}], "]"}], ":=", 
            "Zero"}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"der_", "?", "FirstDerQ"}], "[", 
        RowBox[{"dmb", "[", "]"}], "]"}], "^:=", 
       RowBox[{
        RowBox[{"dmb", "[", "]"}], 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"b1", "=", 
             RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
            RowBox[{"c1", "=", 
             RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"invmetric", "[", 
            RowBox[{"b1", ",", "c1"}], "]"}], 
           RowBox[{"der", "[", 
            RowBox[{"metric", "[", 
             RowBox[{
              RowBox[{"-", "b1"}], ",", 
              RowBox[{"-", "c1"}]}], "]"}], "]"}]}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dmb", "/:", 
       RowBox[{"TensorDerivative", "[", 
        RowBox[{"dmb", ",", 
         RowBox[{"covd_", "?", "CovDQ"}]}], "]"}], ":=", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "ind", "}"}], ",", 
         RowBox[{
          RowBox[{"dmb", "[", "]"}], 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"b1", "=", 
               RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
              RowBox[{"c1", "=", 
               RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
            RowBox[{
             RowBox[{"invmetric", "[", 
              RowBox[{"b1", ",", "c1"}], "]"}], 
             RowBox[{
              RowBox[{"TensorDerivative", "[", 
               RowBox[{"metric", ",", "covd"}], "]"}], "[", 
              RowBox[{
               RowBox[{"-", "b1"}], ",", 
               RowBox[{"-", "c1"}], ",", "ind"}], "]"}]}]}], "]"}]}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Variational", " ", "derivatives", " ", "of", " ", "the", " ", 
        "determinant"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"dmb", "/:", 
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{
          RowBox[{"invmetric", "[", 
           RowBox[{"a_Symbol", ",", "b_Symbol"}], "]"}], ",", "PD"}], "]"}], 
        "[", 
        RowBox[{
         RowBox[{"dmb", "[", "]"}], ",", "rest_"}], "]"}], ":=", 
       RowBox[{
        RowBox[{"-", "rest"}], " ", 
        RowBox[{"metric", "[", 
         RowBox[{
          RowBox[{"-", "a"}], ",", 
          RowBox[{"-", "b"}]}], "]"}], 
        RowBox[{"dmb", "[", "]"}]}]}], ";", 
      RowBox[{"dmb", "/:", 
       RowBox[{
        RowBox[{"VarD", "[", 
         RowBox[{
          RowBox[{"metric", "[", 
           RowBox[{
            RowBox[{"-", "a_Symbol"}], ",", 
            RowBox[{"-", "b_Symbol"}]}], "]"}], ",", "PD"}], "]"}], "[", 
        RowBox[{
         RowBox[{"dmb", "[", "]"}], ",", "rest_"}], "]"}], ":=", 
       RowBox[{"rest", " ", 
        RowBox[{"invmetric", "[", 
         RowBox[{"a", ",", "b"}], "]"}], 
        RowBox[{"dmb", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Remember", " ", "result"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"xTagSet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"metric", ",", 
          RowBox[{"Determinant", "[", 
           RowBox[{"metric", ",", "basis"}], "]"}]}], "}"}], ",", "dmb"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"dmb", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Determinant", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b0dd2f57-1779-4b63-909d-39e68ed78ac0"],

Cell["\<\
Extracted code, because it is redundant with the definition already given. \
Note that we use the derivative of the metric, and not the trace Christoffel.\
\
\>", "Text",ExpressionUUID->"81146436-c36f-4148-9182-467f9e27227a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", "a_", "]"}], "[", 
    RowBox[{"dmb", "[", "]"}], "]"}], "^:=", 
   RowBox[{
    RowBox[{"dmb", "[", "]"}], 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c", "=", 
         RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
        RowBox[{"d", "=", 
         RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Inv", "[", "metric", "]"}], "[", 
        RowBox[{"c", ",", "d"}], "]"}], 
       RowBox[{
        RowBox[{"PD", "[", "a", "]"}], "[", 
        RowBox[{"metric", "[", 
         RowBox[{
          RowBox[{"-", "c"}], ",", 
          RowBox[{"-", "d"}]}], "]"}], "]"}]}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"covd_", "?", "CovDQ"}], "[", "a_", "]"}], "[", 
    RowBox[{"dmb", "[", "]"}], "]"}], "^:=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"b", "=", 
       RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
     RowBox[{"2", 
      RowBox[{"dmb", "[", "]"}], 
      RowBox[{
       RowBox[{"Christoffel", "[", 
        RowBox[{
         RowBox[{"CovDOfMetric", "[", "metric", "]"}], ",", 
         RowBox[{"xAct`xCoba`PDOfBasis", "[", "basis", "]"}]}], "]"}], "[", 
       RowBox[{"b", ",", "a", ",", 
        RowBox[{"-", "b"}]}], "]"}]}]}], "]"}]}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"d0312b15-bcac-4e2d-898f-8369418c6467"],

Cell["\<\
Note that the determinant is constructed when we supply the empty pair of \
brackets [] and not simply with Determinant[metric,basis].\
\>", "Text",ExpressionUUID->"3947f2ed-ee60-4f51-bd9c-4f9829df871a"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.1.6. Examples", \
"Subsubsection",ExpressionUUID->"f6b38a33-3bc7-47e2-a5a8-28b879a07646"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"303b5544-c8d1-41f6-b5c7-93868a0750ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d7c8cdfe-a12d-4bb8-b748-f4951e471df1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "M2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`M2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dec646dc-dd31-4e7a-b698-8dc26dc57ab0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentM2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentM2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"16188252-a652-4bfe-9581-a04a8360e036"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"C\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"35088cd6-43ab-4746-a86e-8e94e916d7a0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "capital"}], "MessageName"], ":", 
  " ", "\<\"System name \[NoBreak]\\!\\(\\\"D\\\"\\)\[NoBreak] is overloaded \
as an abstract index.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7808d100-3ddb-4cdb-baa8-5195b0e135aa"]
}, Open  ]],

Cell["First we define a flat metric on M2:", \
"Text",ExpressionUUID->"c2447c1b-ac8e-4155-b870-cc79890eeb7a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"gflat", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CdF", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}], ",", 
   RowBox[{"FlatMetric", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"533e5d72-f795-4d8a-a66b-fae71918f786"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gflat", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gflat[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"989f25cd-3465-4484-ab34-1668287c09cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilongflat", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilongflat[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8806fb7c-7b91-48d5-80e5-65c157011990"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdF", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdF[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ae289c23-b3b7-44d0-b0ab-042df8f03e32"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdF", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdF[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"22712422-13b1-462e-aa46-d1e26a1a0330"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdF", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdF[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0d77e38d-5eea-468c-b429-81d3df62b2fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Riemann tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RiemannCdF", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Riemann tensor ", 
   $CellContext`RiemannCdF[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"21a6db80-43fe-4447-ae3b-82eab699bee1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdF", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Ricci tensor ", 
   $CellContext`RicciCdF[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"505961f4-a44f-4096-a457-a562f8b0498b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Ricci scalar \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdF", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Ricci scalar ", 
   $CellContext`RicciScalarCdF[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8c0238d8-51c6-4e4b-a1cd-951ad113f6c1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdF", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdF[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c55570a3-d17a-43b3-b845-baed60919e9a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdF", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdF[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"af3effe5-b559-4aec-b1a3-c12d51707e80"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdF", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdF[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"045193d2-cd69-416f-a66a-f1b55780c816"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Kretschmann scalar \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdF", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Kretschmann scalar ", 
   $CellContext`KretschmannCdF[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c9d10084-709a-4234-8112-73a8e1640755"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgflat", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgflat[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"4c97aae4-fba0-4ca1-a138-284274887fe6"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "Polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"300e4021-4b88-4f39-9030-e23fcd205a57"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gflat", "[", 
  RowBox[{"A", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8fb1c956-befe-4633-9da1-ce9ef9d224ec"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"gflat", 
      StyleBox[GridBox[{
         {"A", 
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]]},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`gflat[$CellContext`A, {1, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"20890e05-7f4a-4489-9a48-e487b85268ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gflat", "[", 
  RowBox[{"A", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "Polar"}]}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"f9d4733b-7be5-4724-94b4-3ee4b2105e20"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"Basis", 
      StyleBox[GridBox[{
         {" ", "A"},
         {
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]], " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Basis[{1, -$CellContext`Polar}, $CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"cd13f942-69f6-4401-a687-cf458a86ec0e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CdF", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{
   RowBox[{"CdF", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{"ChristoffelCdF", "[", 
    RowBox[{"C", ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "E"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"d1d950ae-d516-427b-a057-696bd2e14a45"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", "\[PartialD]", "]"}], 
      StyleBox[GridBox[{
         {"C", " ", " ", "  ", "  "},
         {" ", "D", "E", 
          RowBox[{"|", "B"}], 
          RowBox[{"|", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CdF[-$CellContext`A][
   $CellContext`CdF[-$CellContext`B][
    $CellContext`ChristoffelCdF[C, -D, -E]]],
  Editable->
   False]], "Output",ExpressionUUID->"e1143a00-5403-4b15-8f2a-15f8f1f3ff7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "gflat", 
  "]"}]], "Input",ExpressionUUID->"e8966bf2-c734-4374-984e-14fba1dc9cfc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgflat"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgflat],
  Editable->
   False]], "Print",ExpressionUUID->"e5aee91a-9bb5-42bf-8e26-0e0555cdfe1f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdF],
  Editable->
   False]], "Print",ExpressionUUID->"21544895-062e-489e-9ca1-398d65fc8e44"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdF],
  Editable->
   False]], "Print",ExpressionUUID->"21ae0c79-f2e5-445b-90f5-53adf6f977a2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdF],
  Editable->
   False]], "Print",ExpressionUUID->"31ea47b4-571b-4107-b824-78c475490cf6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci tensor", 
   " ", $CellContext`RicciCdF],
  Editable->
   False]], "Print",ExpressionUUID->"87a727e6-df1d-4b9f-9550-193794ed3555"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdF],
  Editable->
   False]], "Print",ExpressionUUID->"02de4fa0-98a3-4ffc-b2fd-004deb2d594f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdF],
  Editable->
   False]], "Print",ExpressionUUID->"d0d5abd7-bdcc-4ee4-9485-c41004821df9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdF],
  Editable->
   False]], "Print",ExpressionUUID->"7e421a70-b51e-4ddb-a4af-3a9294ba6aed"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdF],
  Editable->
   False]], "Print",ExpressionUUID->"ade0ab43-18e9-4267-91e4-3b52778c9b83"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdF],
  Editable->
   False]], "Print",ExpressionUUID->"cde47da0-0f63-4519-899e-4009433f9ea6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdF"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdF],
  Editable->
   False]], "Print",ExpressionUUID->"92a5b1b5-8c48-45a3-ab36-bdbed6f9d401"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilongflat"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilongflat],
  Editable->
   False]], "Print",ExpressionUUID->"2e724a3d-0fbf-4435-94d3-e53d07038b23"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gflat"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gflat],
  Editable->
   False]], "Print",ExpressionUUID->"6a9f192f-09d6-43d7-bdce-8e7b93b8fc75"]
}, Open  ]]
}, Open  ]],

Cell["\<\
We can define a flat metric using a \"Cartesian\" coordinate system:\
\>", "Text",ExpressionUUID->"0a9a14b9-8e4d-4fb9-85e9-60b56c6210d5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefMetric", "[", 
   RowBox[{
    RowBox[{"-", "1"}], ",", 
    RowBox[{"gflat", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], ",", "PD", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"4096b8eb-c943-4711-a040-a66a0e68628f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"PD can only be associated to a flat metric.\\\
\"\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7cbaeb03-efa4-48f5-a282-336f603ed3de"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefMetric", "[", 
   RowBox[{
    RowBox[{"-", "1"}], ",", 
    RowBox[{"gflat", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], ",", "PD", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}], ",", 
    RowBox[{"FlatMetric", "\[Rule]", "True"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"25135426-6907-4946-b7f5-1f15d2bbb665"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Please use {,, \\\\[PartialD]} as symbols for \
PD.\\\"\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"60dfc085-6865-4637-87d8-9a1d06495441"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"gflat", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "PD", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<,\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}], ",", 
   RowBox[{"FlatMetric", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"e9bcbbdf-cd45-415d-8bd3-d9167daf14ba"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gflat", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gflat[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f0cbc598-737b-49cc-a7bf-58b651bd3bd7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilongflat", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilongflat[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dc366807-8dce-480b-8556-98bc1ea9031d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgflat", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgflat[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"65513141-da64-4dab-bf26-12613e766c50"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "gflat", 
  "]"}]], "Input",ExpressionUUID->"205ca3dc-1bd9-4066-b087-5fdfa84b3111"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgflat"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgflat],
  Editable->
   False]], "Print",ExpressionUUID->"c4a1331b-5dd8-4098-82ba-dfe2284f30e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilongflat"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilongflat],
  Editable->
   False]], "Print",ExpressionUUID->"20ad7494-279c-4e7d-b4b6-14b3c76f78a6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gflat"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gflat],
  Editable->
   False]], "Print",ExpressionUUID->"3ab713c1-1fb1-49e0-bd45-905edc24978a"]
}, Open  ]]
}, Open  ]],

Cell["Generic metric:", \
"Text",ExpressionUUID->"1d33b157-1298-4f7d-9e32-20531e223920"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "metricg", 
  "]"}]], "Input",ExpressionUUID->"b9139550-7074-428d-aa70-b4eb8517fdb2"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"VBundleOfMetric", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"metric\\\"\\)\[NoBreak] \[NoBreak]\\!\
\\(metricg\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"5e44f73a-67a1-446a-9d7e-a09715053c7d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CdM", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"c06781d1-0106-4d2a-a3fb-9f8794c27b51"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5c1b6f90-6e0e-4033-8998-699ca639a8e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"94bbdc93-ebf6-4174-99a5-0a81d2838ff8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6c9c883e-c0cf-4db9-9f0c-77e343985ab0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d9e010f5-1445-4b6b-84a0-53800aa08ff5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0cd7b738-4c96-4989-9deb-ca726f4c57cd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"ce472aae-b029-47e0-aecd-569700b5df5f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6290ebed-f06e-4f07-a551-2f0dd3f54689"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"30da9d28-7ee4-484b-ac50-8bb04a1813a4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7f57a5dc-1535-4bc3-ba31-e1f9ad5ed8b9"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"2d794dd3-a9d3-4ad4-8a9c-df18ae72542e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2cba8ee3-dac5-4fa2-ac3a-45296fb832ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"24bbad91-da8f-4c50-92f2-10f52038cc40"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"203766c5-08db-469f-b9a4-fc7f00268689"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6b59d3c1-17e1-468d-9a08-bb12a5048bb6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"9df5144f-a08c-42fc-b90d-5b15c7f70228"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"dbbc191f-b4ed-4284-aaf7-3902c93e572a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"44c61c4f-90c0-495c-9423-87c183f34b72"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetricg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetricg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"6295e9eb-fdfc-4714-9316-b7bcb9606e8b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EinsteinCdM", "[", 
  RowBox[{
   RowBox[{"-", "A"}], ",", 
   RowBox[{"-", "B"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c5d968c-1747-4038-b4dc-1144a6e2c414"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"31191394-5d98-4d11-a3e6-a16617f829e7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"4560abc1-b84c-4e87-8876-f575d73dc563"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"839c851b-e0bd-4310-81a3-6a2585ad5ab3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CdM", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"def03158-c498-422b-b667-a989f4f5374f"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"bea0925c-af5f-49f8-b8dc-3ffa54524de8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<#\>\"", ",", "\"\<D\>\""}], "}"}], ",", 
   RowBox[{"Torsion", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"8d749738-c8be-4c9f-a91b-981ef3df67a9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"675654fb-5e39-49ec-88dd-2a75e6098799"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"44dad3d7-2ebb-4485-a726-753bfdb9b86e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "non-symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"6c83f93d-be84-4442-b5b6-38b1d5bc5a0a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"7c7d1555-389c-496c-a162-676094933dd9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6d2dfac5-00a3-472f-94a4-abcd71de3b11"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"dbdc6ef0-446c-4abc-af23-84bf7c167388"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Christoffel", "[", 
   RowBox[{"CD", ",", "CdM"}], "]"}], "[", 
  RowBox[{"A", ",", 
   RowBox[{"-", "B"}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"522e53b2-9a6d-401f-a28e-74c0a07c62ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ChristoffelCDCdM[$CellContext`A, -$CellContext`B, -C], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"84f5863f-6c8a-4266-9134-86f4546b9f48"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
      StyleBox[GridBox[{
         {"A", " ", " "},
         {" ", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ChristoffelCDCdM[$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"a7ddd891-5b37-46b5-83da-7e731f24b150"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`$Christoffels", "//", 
  "ColumnForm"}]], \
"Input",ExpressionUUID->"45ada719-544c-426d-b5ba-fa4e2ba442dd"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCdM", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CdM", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCD", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CD", ",", "PD"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"ChristoffelCDCdM", ",", 
       RowBox[{"{", 
        RowBox[{"Christoffel", ",", "CD", ",", "CdM"}], "}"}], ",", 
       RowBox[{"{", 
        InterpretationBox[
         StyleBox["\[DoubleStruckCapitalT]M2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`TangentM2,
         Editable->False], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{$CellContext`ChristoffelCdM, {
     xAct`xTensor`Christoffel, $CellContext`CdM, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}, \
{$CellContext`ChristoffelCD, {
     xAct`xTensor`Christoffel, $CellContext`CD, 
      xAct`xTensor`PD}, {$CellContext`TangentM2}}, \
{$CellContext`ChristoffelCDCdM, {
     xAct`xTensor`Christoffel, $CellContext`CD, $CellContext`CdM}, \
{$CellContext`TangentM2}}}],
  Editable->
   False]], "Output",ExpressionUUID->"87d01f8b-1953-4baa-9a73-a8068cb5a841"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ChristoffelCDCdM"}]], \
"Input",ExpressionUUID->"87a84240-6094-4358-b5bf-d5511e28018d"],

Cell[CellGroupData[{

Cell["Global`ChristoffelCDCdM", "Print", "PrintUsage",
 CellTags->
  "Info3578672855-5338953",ExpressionUUID->"38b5c9bb-0088-4023-8965-\
b3d8a783e710"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ChristoffelCDCdM", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "ChristoffelCDCdM", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`ChristoffelCDCdM],
          Editable->False], "^=", "ChristoffelCDCdM"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "ChristoffelCDCdM", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "ChristoffelCDCdM", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "ChristoffelCDCdM", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "ChristoffelCDCdM", "]"}], 
         "^=", "\<\"\[CapitalGamma][D,\[EmptyDownTriangle]]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "ChristoffelCDCdM", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "ChristoffelCDCdM", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "ChristoffelCDCdM", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"Christoffel", ",", "CD", ",", "CdM"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "ChristoffelCDCdM", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`ChristoffelCDCdM],
  Editable->False]], "Print",
 CellTags->
  "Info3578672855-5338953",ExpressionUUID->"e4a80028-6945-4de9-a755-\
5814e2aba759"]
}, Open  ]]
}, Open  ]],

Cell["ChristoffelToGradMetric:", \
"Text",ExpressionUUID->"9a112f36-ab94-4678-83ef-b486810c32a5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCdM", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg", ",", "PD"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"16a0335e-1e0d-44fd-8b68-222342db870e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{",", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`B][
      $CellContext`metricg[-C, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "D", 
             RowBox[{",", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-C][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{",", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-D][
      $CellContext`metricg[-$CellContext`B, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"a6d367ef-17ed-4ee8-aa79-2a45ff7138a8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCdM", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg", ",", "CdM"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"0c225734-8e30-47a5-961a-5665e4ecf23a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
      StyleBox[GridBox[{
         {"A", " ", " "},
         {" ", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"457e7e55-a6dd-4fe1-8f0f-54dcf89a8252"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChristoffelToGradMetric", "[", 
  RowBox[{
   RowBox[{"ChristoffelCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "metricg", ",", "CD"}], 
  "]"}]], "Input",ExpressionUUID->"a791dce8-28ff-4cbf-b3d0-a9112fed808c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
      StyleBox[GridBox[{
         {"A", " ", " "},
         {" ", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"c59a1561-7c67-410b-9070-8741e74999f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCdM", "[", 
     RowBox[{"A", ",", "B", ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"dff0cdf2-cb5e-4986-8fd9-288a3e18c3c0"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"B", "F"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`B, $CellContext`F],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"F", "D", 
             RowBox[{",", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-C][
      $CellContext`metricg[-$CellContext`F, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"F", "C", 
             RowBox[{",", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-D][
      $CellContext`metricg[-$CellContext`F, -C]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{",", "F"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`F][
      $CellContext`metricg[-C, -D]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"8fd78b6c-21c4-4b85-8fb8-0cfb0f11a73c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{"ChristoffelCdM", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"275ae3a6-3ff2-47f3-96ad-3c6b4ce58d5b"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"B", "F"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`B, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"C", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[C, $CellContext`G],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"F", "G", 
              RowBox[{",", "D"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-D][
       $CellContext`metricg[-$CellContext`F, -$CellContext`G]],
      Editable->False]}], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"G", "D", 
             RowBox[{",", "F"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`F][
      $CellContext`metricg[-$CellContext`G, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"F", "D", 
             RowBox[{",", "G"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`G][
      $CellContext`metricg[-$CellContext`F, -D]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"74a1979c-543c-4e5b-8c55-da1e65c9a89e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCDCdM", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg", ",", "PD"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"ddac0370-d9bc-402b-886e-0a9b9f62ee91"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
      StyleBox[GridBox[{
         {"A", " ", " "},
         {" ", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ChristoffelCDCdM[$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"9c0aba1a-8f6b-457d-adae-b2c0fff6cd58"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCDCdM", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg", ",", "CD"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"3dcaefa2-69f7-45de-a235-aaced46173ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-$CellContext`B, -C, -D],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-C, -$CellContext`B, -D],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-D, -$CellContext`B, -C],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{"#", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`B][
      $CellContext`metricg[-C, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "D", 
             RowBox[{"#", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-C][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{"#", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-D][
      $CellContext`metricg[-$CellContext`B, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"ad95bb20-6646-49af-aa11-ccce047557b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCDCdM", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"ad0ceb1a-79fb-404b-baa6-72ce40c603b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-$CellContext`B, -C, -D],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-C, -$CellContext`B, -D],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-D, -$CellContext`B, -C],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{"#", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`B][
      $CellContext`metricg[-C, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "D", 
             RowBox[{"#", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-C][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{"#", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-D][
      $CellContext`metricg[-$CellContext`B, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"22809a24-45ba-460b-b386-2eb18b0b164d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{"ChristoffelCDCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"5123cd75-06bf-4514-82d9-68bff265c92a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-$CellContext`B, -C, -D],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-C, -$CellContext`B, -D],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-D, -$CellContext`B, -C],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{"#", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`B][
      $CellContext`metricg[-C, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "D", 
             RowBox[{"#", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-C][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{"#", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-D][
      $CellContext`metricg[-$CellContext`B, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"6baf7eb5-e49d-48a6-8129-ec338c760ba9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChristoffelToGradMetric", "[", 
   RowBox[{
    RowBox[{"ChristoffelCdM", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], ",", "metricg"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"3b961b67-3404-4ab7-ad2c-052146f84b1a"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{",", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`B][
      $CellContext`metricg[-C, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "D", 
             RowBox[{",", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-C][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{",", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-D][
      $CellContext`metricg[-$CellContext`B, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"36042e71-e666-419a-907a-0fd81ad18069"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ChristoffelCdM", "[", 
     RowBox[{"A", ",", "B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "//", "ChristoffelToGradMetric"}], "//", 
   "Simplify"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"6acb1f08-33b7-4f52-baae-c25e5f3abf2e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"B", "F"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`B, $CellContext`F],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"F", "D", 
             RowBox[{",", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-C][
      $CellContext`metricg[-$CellContext`F, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"F", "C", 
             RowBox[{",", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-D][
      $CellContext`metricg[-$CellContext`F, -C]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{",", "F"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`F][
      $CellContext`metricg[-C, -D]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"a5e4e194-74df-4902-8617-c8734d05a2b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ChristoffelCdM", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], "//", 
    "ChristoffelToGradMetric"}], "//", "Simplify"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"334efe9c-8a5b-4ba7-b0be-a399cb177f94"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"B", "F"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`B, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"C", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[C, $CellContext`G],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"F", "G", 
              RowBox[{",", "D"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-D][
       $CellContext`metricg[-$CellContext`F, -$CellContext`G]],
      Editable->False]}], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"G", "D", 
             RowBox[{",", "F"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`F][
      $CellContext`metricg[-$CellContext`G, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"F", "D", 
             RowBox[{",", "G"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-$CellContext`G][
      $CellContext`metricg[-$CellContext`F, -D]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"7427e889-7183-4cb0-9449-843032edcac2"]
}, Open  ]],

Cell["GradMetricToChristoffel:", \
"Text",ExpressionUUID->"9e158b08-6144-4fdd-8d6f-f689036d06ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GradMetricToChristoffel", "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"fdb382f3-05c4-43b5-981b-cf4f23989bc9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G$238763", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCdM[$CellContext`G$238763, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "G$238763"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[-$CellContext`B, -$CellContext`G$238763],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G$238766", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCdM[$CellContext`G$238766, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "G$238766"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[-C, -$CellContext`G$238766],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"ead11e2f-b94d-4d2a-a7a3-2f602d623c28"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "ChristoffelToGradMetric"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"bff163be-93aa-466a-a2e0-15bad9ea0e1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "C", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`metricg[-$CellContext`B, -C]],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"C", "B", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`metricg[-C, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"d4eb7637-d61b-4482-98be-d88d893643fd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GradMetricToChristoffel", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e382dc1b-aded-4ea0-8ddf-05e846e0d8d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
         StyleBox[GridBox[{
            {"G$238777", " ", " "},
            {" ", "A", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCDCdM[$CellContext`G$238777, -$CellContext`A, -C],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "G$238777"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[-$CellContext`B, -$CellContext`G$238777],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
        StyleBox[GridBox[{
           {"G$238780", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDCdM[$CellContext`G$238780, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "G$238780"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[-C, -$CellContext`G$238780],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"f14689cb-5495-4c15-b45e-1763b631fdc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "ChristoffelToGradMetric"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"33096054-7a52-4324-ba91-ac64713014d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"T", "[", "D", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"A", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionCD[-$CellContext`A, -$CellContext`B, -C],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"T", "[", "D", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"A", "C", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionCD[-$CellContext`A, -C, -$CellContext`B],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "C", 
            RowBox[{"#", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`metricg[-$CellContext`B, -C]],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"C", "B", 
            RowBox[{"#", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`metricg[-C, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"6ebb50bb-a9a0-47ae-afc6-f4d61756b004"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ChristoffelCDCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "//", "ChristoffelToGradMetric"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"bdcda855-45d0-4748-9cd7-93c254f95c9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-$CellContext`B, -C, -D],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-C, -$CellContext`B, -D],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-D, -$CellContext`B, -C],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"C", "D", 
             RowBox[{"#", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`B][
      $CellContext`metricg[-C, -D]],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "D", 
             RowBox[{"#", "C"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-C][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{"#", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-D][
      $CellContext`metricg[-$CellContext`B, -C]],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"32a6a10d-bb53-431b-9e36-16119dc7bd46"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "GradMetricToChristoffel"}]], \
"Input",ExpressionUUID->"9abfd669-fb8c-4299-8af8-1e1db8b0e847"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", "2"]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "D"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, D],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", 
            RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
           StyleBox[GridBox[{
              {"G$238802", " ", " "},
              {" ", "C", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDCdM[$CellContext`G$238802, -C, -D],
       Editable->False]}], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"B", "G$238802"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[-$CellContext`B, -$CellContext`G$238802],
      Editable->False]}], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
          StyleBox[GridBox[{
             {"G$238808", " ", " "},
             {" ", "D", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDCdM[$CellContext`G$238808, -D, -C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"B", "G$238808"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[-$CellContext`B, -$CellContext`G$238808],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
          StyleBox[GridBox[{
             {"G$238796", " ", " "},
             {" ", "B", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDCdM[$CellContext`G$238796, -$CellContext`B, -
       D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"C", "G$238796"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[-C, -$CellContext`G$238796],
      Editable->False]}], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
          StyleBox[GridBox[{
             {"G$238811", " ", " "},
             {" ", "D", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDCdM[$CellContext`G$238811, -
       D, -$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"C", "G$238811"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[-C, -$CellContext`G$238811],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
          StyleBox[GridBox[{
             {"G$238799", " ", " "},
             {" ", "B", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDCdM[$CellContext`G$238799, -$CellContext`B, -
       C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"D", "G$238799"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[-D, -$CellContext`G$238799],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           RowBox[{"D", ",", "\[EmptyDownTriangle]"}], "]"}], 
          StyleBox[GridBox[{
             {"G$238805", " ", " "},
             {" ", "C", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelCDCdM[$CellContext`G$238805, -
       C, -$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"D", "G$238805"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[-D, -$CellContext`G$238805],
      Editable->False]}], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-$CellContext`B, -C, -D],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"C", "B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-C, -$CellContext`B, -D],
     Editable->False], "-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"T", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"D", "B", "C"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionCD[-D, -$CellContext`B, -C],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"4cd48985-4b2a-49c5-b895-e067a96f0d88"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricsOfVBundle", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"29dab58a-2b09-4e54-9047-5db8b13b8c2a"],

Cell[BoxData[
 RowBox[{"{", "metricg", 
  "}"}]], "Output",ExpressionUUID->"802f40db-2b62-4f1b-8afb-3941b9bdf475"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"metricg", "[", 
    RowBox[{"B", ",", "C"}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"9aa62a55-a284-4d7e-a548-eb75ab4988c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"B", "D"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`metricg[$CellContext`B, D],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"C", "F"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[C, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " ", "  "},
          {"D", "F", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`metricg[-D, -$CellContext`F]],
   Editable->
    False]}]], "Output",ExpressionUUID->"523fa89e-40c9-4d9d-b329-784cef282026"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"gg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CDM", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b2d85593-6767-49cb-be16-bb2360e16f3b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "old"}], "MessageName"], ":", 
  " ", "\<\"There are already metrics \[NoBreak]\\!\\({metricg}\\)\[NoBreak] \
in vbundle \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]M2\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], TangentM2, Rule[Editable, False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0a253602-1783-44cf-bb73-821f73b51353"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8646e2ad-ea7c-4301-8f7e-40f914a7bc5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"inverse metric tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Invgg", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Metric is frozen!\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "inverse metric tensor ", 
   $CellContext`Invgg[$CellContext`A, $CellContext`B], ". ", 
   "Metric is frozen!"],
  Editable->
   False]], "Print",ExpressionUUID->"466a6fb4-6cee-4263-85e1-75e5ec7c2754"],

Cell[BoxData["\<\"** DefMetric: Don't know yet how to define epsilon for a \
frozen metric.\"\>"], \
"Print",ExpressionUUID->"1df54d37-c3a5-49f2-85a0-d2d337f079e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7497c319-04cf-4769-b97a-f11d6d3d7ef2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7cb9d604-1c4f-42ca-a317-ac5c5be95c7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"78863784-e013-4371-b7f1-c7d0a8298a90"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannDownCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannDownCDM[-$CellContext`A, -$CellContext`B, -C, -D], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c09b80f9-f21c-4e0b-a0c4-4b3f24cbca63"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDM[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"fa162165-da65-49a3-bd6f-334e477d0458"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f7375a9d-4334-437b-883f-96538032d743"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"6b5e7f3f-12f1-4d3d-8872-96ff1df8978f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCDM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCDM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e6abca48-07e6-420e-a36c-d5789a852393"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"a5260b8f-5211-410e-ba12-7015063c0217"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bea418af-5f93-4e56-8169-a035040d2297"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCDM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"367c7177-bac1-406c-b770-ac3bcbe9043c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8c3017e3-1fae-4053-be7f-74d016a648cf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCDM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCDM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7337a1c5-39a6-4f93-897e-73cf1c6068b0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"79db8f1c-5108-444c-ba22-0d141661f3e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"baa02187-4d59-4823-bf96-8f280e44322e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"d91e787b-f95e-403b-9539-4e03f221f0e8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Invgg"}]], "Input",ExpressionUUID->"caf5d2e9-12e9-4188-8fbe-0958fda5ad66"],

Cell[CellGroupData[{

Cell["Global`Invgg", "Print", "PrintUsage",
 CellTags->
  "Info3578672861-5338953",ExpressionUUID->"9c66eff5-4ce2-4e67-8634-\
cac1cfa2e6c3"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "Invgg", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Invgg],
          Editable->False], "^=", "Invgg"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          
          RowBox[{"\<\"inverse metric tensor\"\>", 
           ",", "\<\"Metric is frozen!\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", "Invgg", "]"}], "^=", "gg"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Invgg", "]"}], "^=", "\<\"igg\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "Invgg", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "1", ",", "2", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{1, 2}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"xAct`xTensor`Private`InvMetric", ",", "gg"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "Invgg", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-Pattern[xAct`xTensor`Private`a, 
              Blank[]], -PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`c", "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ], 
            Pattern[xAct`xTensor`Private`c, 
             Blank[]]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`a", "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q], -Pattern[xAct`xTensor`Private`a, 
              Blank[]]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`c", "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ], 
            Pattern[xAct`xTensor`Private`c, 
             Blank[]]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-Pattern[xAct`xTensor`Private`a, 
              Blank[]], -PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox["xAct`xTensor`Private`c", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            Pattern[xAct`xTensor`Private`c, 
             Blank[]], 
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`a", "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q], -Pattern[xAct`xTensor`Private`a, 
              Blank[]]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox["xAct`xTensor`Private`c", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            Pattern[xAct`xTensor`Private`c, 
             Blank[]], 
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`der$_", "?", "FirstDerQ"}], "[", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"igg", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Invgg[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q], 
             PatternTest[
              Pattern[xAct`xTensor`Private`c$, 
               Blank[]], TangentM2`Q]],
            Editable->False], "]"}], "]"}], "^:=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xAct`xTensor`Private`b1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]M2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentM2,
                Editable->False], "]"}]}], ",", 
             RowBox[{"xAct`xTensor`Private`c1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]M2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentM2,
                Editable->False], "]"}]}]}], "}"}], ",", 
           RowBox[{
            RowBox[{"-", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"igg", 
                  StyleBox[GridBox[{
                    {"xAct`xTensor`Private`b$", "xAct`xTensor`Private`b1$"},
                    {" ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Invgg[
              xAct`xTensor`Private`b$, xAct`xTensor`Private`b1$],
              Editable->False]}], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"igg", 
                 StyleBox[GridBox[{
                    {"xAct`xTensor`Private`c$", "xAct`xTensor`Private`c1$"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Invgg[
             xAct`xTensor`Private`c$, xAct`xTensor`Private`c1$],
             Editable->False], " ", 
            RowBox[{"xAct`xTensor`Private`der$", "[", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"gg", 
                  StyleBox[GridBox[{
                    {" ", " "},
                    {"xAct`xTensor`Private`b1$", "xAct`xTensor`Private`c1$"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gg[-xAct`xTensor`Private`b1$, -
               xAct`xTensor`Private`c1$],
              Editable->False], "]"}]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Invgg],
  Editable->False]], "Print",
 CellTags->
  "Info3578672861-5338953",ExpressionUUID->"200e8b28-95fd-4034-ae84-\
8edce7b0fba0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricsOfVBundle", "[", "TangentM2", 
  "]"}]], "Input",ExpressionUUID->"20ae3048-4f4a-44c6-8db7-ca941966cb61"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"metricg", ",", "gg"}], 
  "}"}]], "Output",ExpressionUUID->"633986cf-5b92-4be3-81ae-3ddf52437c45"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"893eaf4e-ccb1-4cdb-807e-117a42e25386"],

Cell[CellGroupData[{

Cell[BoxData["\<\"** DefMainfold (legacy): CNumbers {2, 3} only used to \
compute dimension.\"\>"], \
"Print",ExpressionUUID->"276b1ea9-56e5-4630-b3f7-9cfa76776ca6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "S2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`S2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"77dc3722-2111-4c74-8b3e-94f325485d7a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", "TangentS2", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentS2, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"841f7f12-944f-4e47-92f1-69309504b6bd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "S2"}]], "Input",ExpressionUUID->"7e5a2992-0cea-4dba-9132-7618a4be13f5"],

Cell[CellGroupData[{

Cell["Global`S2", "Print", "PrintUsage",
 CellTags->
  "Info3578672863-5338953",ExpressionUUID->"1a98930a-6cef-4009-9f47-\
44f9d056e1b3"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "S2", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "S2", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "S2", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "S2", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "S2", "]"}], "^=", "\<\"S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "S2", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "S2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`S2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672863-5338953",ExpressionUUID->"8042e688-2c99-4bca-ac89-\
7c7549e3535f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentS2"}]], \
"Input",ExpressionUUID->"4ebdcb49-5bc7-4f03-83f7-afeb5ced3557"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]S2",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentS2,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578672865-5338953",ExpressionUUID->"88aa3368-76a4-4ecd-9d37-\
8c07b917765e"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentS2,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentS2],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
            "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"f", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "S2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]S2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]S2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentS2,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentS2],
  Editable->False]], "Print",
 CellTags->
  "Info3578672865-5338953",ExpressionUUID->"1dcf3ca0-279f-4fea-bacf-\
ef3fb941d100"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"gamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], ",", "CdS", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<:\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[Gamma]\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"ac118226-e84d-4045-bb56-24cdf0c297dd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gamma[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a311d818-4a7b-4782-ad15-3ffac829c169"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilongamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilongamma[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"54f7c351-6a2b-4b29-927b-ec5a5c575e04"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdS", "[", 
    RowBox[{"-", "a"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdS[-$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3dc1cab0-c49e-40d9-ad0e-99b82141675b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdS[$CellContext`a, -$CellContext`b, -$CellContext`c], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b3730bb-fa37-4bcf-9bf4-aecddc7a5008"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdS[$CellContext`a, -$CellContext`b, \
-$CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0d87013f-fbb7-4a5d-b937-ba98997fa6e8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCdS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"acfc09af-bb42-40bd-acda-17c6d730dff0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCdS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6ec30ab4-ea07-4ea5-84ef-baa75528bd1d"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"aa3d7d2d-9c40-49f0-8a73-c1c573a0977a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCdS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4ac095e2-b1b0-437e-82ad-ba01bcac5876"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"67705576-69da-47c4-90ab-0ee40ee7dd1f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b71e513b-0705-4c58-826a-b0b15e6a7728"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2f5c7558-08da-44ce-8433-38d0521379b8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e68bb6cb-9875-46fa-8461-9896e074ebc9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCdS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a4685eac-2c3d-4955-8f60-51d8c65590fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"63930fad-4a51-4412-9565-09b962a2c0cf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"e040fb0b-3a5d-48b1-8f21-0409fa954149"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"dfdcb5e3-d2ba-4ceb-9818-3739ff2b63df"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgamma", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgamma[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"bd077033-f1a5-43fb-9b57-a4a0b353f5ed"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "gamma"}]], "Input",ExpressionUUID->"ccda3799-24bc-4119-86bb-7651c93bb49c"],

Cell[CellGroupData[{

Cell["Global`gamma", "Print", "PrintUsage",
 CellTags->
  "Info3578672867-5338953",ExpressionUUID->"e9c9126d-46d8-45e8-afc4-\
1cc9b8ec6920"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "gamma", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"CovDOfMetric", "[", "gamma", "]"}], "^=", "CdS"}]},
       {" "},
       {
        RowBox[{"gamma", "/:", 
         RowBox[{"CovDOfMetric", "[", 
          RowBox[{"gamma", ",", "TorsionCdS"}], "]"}], "=", "CdS"}]},
       {" "},
       {
        RowBox[{"gamma", "/:", 
         RowBox[{"CovDOfMetric", "[", 
          RowBox[{"gamma", ",", "Zero"}], "]"}], "=", "CdS"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "gamma", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`gamma],
          Editable->False], "^=", "gamma"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "gamma", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"symmetric metric tensor\"\>", ",", "\<\"\"\>"}], 
          "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "gamma", "]"}], "^=", 
         RowBox[{"{", "S2", "}"}]}]},
       {" "},
       {
        RowBox[{"gamma", "/:", 
         RowBox[{"Determinant", "[", 
          RowBox[{"gamma", ",", "AIndex"}], "]"}], "=", "Detgamma"}]},
       {" "},
       {
        RowBox[{"gamma", "/:", 
         RowBox[{"epsilonOrientation", "[", 
          RowBox[{"gamma", ",", "AIndex"}], "]"}], "=", 
         InterpretationBox[
          StyleBox[
           SubscriptBox["s", "\[Epsilon]"],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`$epsilonSign,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"FlatMetricQ", "[", "gamma", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "gamma", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"S2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"InducedFrom", "[", "gamma", "]"}], "^=", "Null"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Inv", "[", "gamma", "]"}], "^=", "gamma"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LC", "[", "gamma", "]"}], "^=", "CdS"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricQ", "[", "gamma", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "gamma", "]"}], "^=", "\<\"\[Gamma]\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "gamma", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"epsilongamma", ",", "CdS", ",", "Detgamma"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SignDetOfMetric", "[", "gamma", "]"}], "^=", "1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "gamma", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentS2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]S2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentS2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "gamma", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "1", ",", "2", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{1, 2}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "gamma", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfMetric", "[", "gamma", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]S2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentS2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "gamma", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]], 
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentS2`Q]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {" ", 
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"]},
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[-PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ], 
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]], 
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentS2`Q]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], " "},
                   {" ", 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]], -PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentS2`Q], 
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {" ", 
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"]},
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[-PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ], 
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentS2`Q], 
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], " "},
                   {" ", 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]], -PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`der$_", "?", "FirstDerQ"}], "[", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentS2`Q], 
             PatternTest[
              Pattern[xAct`xTensor`Private`c$, 
               Blank[]], TangentS2`Q]],
            Editable->False], "]"}], "]"}], "^:=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xAct`xTensor`Private`b1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]S2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentS2,
                Editable->False], "]"}]}], ",", 
             RowBox[{"xAct`xTensor`Private`c1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]S2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentS2,
                Editable->False], "]"}]}]}], "}"}], ",", 
           RowBox[{
            RowBox[{"-", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"\[Gamma]", 
                  StyleBox[GridBox[{
                    {"xAct`xTensor`Private`b$", "xAct`xTensor`Private`b1$"},
                    {" ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gamma[
              xAct`xTensor`Private`b$, xAct`xTensor`Private`b1$],
              Editable->False]}], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"\[Gamma]", 
                 StyleBox[GridBox[{
                    {"xAct`xTensor`Private`c$", "xAct`xTensor`Private`c1$"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gamma[
             xAct`xTensor`Private`c$, xAct`xTensor`Private`c1$],
             Editable->False], " ", 
            RowBox[{"xAct`xTensor`Private`der$", "[", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"\[Gamma]", 
                  StyleBox[GridBox[{
                    {" ", " "},
                    {"xAct`xTensor`Private`b1$", "xAct`xTensor`Private`c1$"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gamma[-xAct`xTensor`Private`b1$, -
               xAct`xTensor`Private`c1$],
              Editable->False], "]"}]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {"#", 
                  UnderscriptBox["xAct`xTensor`Private`b", "_"]},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[
           xAct`xTensor`Dir[
            Pattern[xAct`xTensor`Private`expr, 
             Blank[]]], 
           Pattern[xAct`xTensor`Private`b, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{"xAct`xTensor`Private`expr", ",", 
           RowBox[{
            RowBox[{
            "xAct`xTensor`Private`UltraindexOf", "[", 
             "xAct`xTensor`Private`expr", "]"}], "\[Rule]", 
            "xAct`xTensor`Private`b"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["xAct`xTensor`Private`a", "_"], "#"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]], 
           xAct`xTensor`Dir[
            Pattern[xAct`xTensor`Private`expr, 
             Blank[]]]],
          Editable->False], ":=", 
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{"xAct`xTensor`Private`expr", ",", 
           RowBox[{
            RowBox[{
            "xAct`xTensor`Private`UltraindexOf", "[", 
             "xAct`xTensor`Private`expr", "]"}], "\[Rule]", 
            "xAct`xTensor`Private`a"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], "_"], 
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[
           PatternTest[
            Pattern[xAct`xTensor`Private`a, 
             Blank[]], xAct`xTensor`UpIndexQ], 
           PatternTest[
            Pattern[xAct`xTensor`Private`b, 
             Blank[]], xAct`xTensor`DownIndexQ]],
          Editable->False], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`b", "xAct`xTensor`Private`a"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[xAct`xTensor`Private`b, xAct`xTensor`Private`a],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Gamma]", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], "_"], 
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gamma[
           PatternTest[
            Pattern[xAct`xTensor`Private`a, 
             Blank[]], xAct`xTensor`DownIndexQ], 
           PatternTest[
            Pattern[xAct`xTensor`Private`b, 
             Blank[]], xAct`xTensor`UpIndexQ]],
          Editable->False], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a", "xAct`xTensor`Private`b"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[xAct`xTensor`Private`a, xAct`xTensor`Private`b],
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`gamma],
  Editable->False]], "Print",
 CellTags->
  "Info3578672867-5338953",ExpressionUUID->"6a665ea7-6904-446a-b75a-\
4a46b4bd1186"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "gamma", 
  "]"}]], "Input",ExpressionUUID->"5a619b48-156e-4484-8c72-8d3a9a1d364c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgamma],
  Editable->
   False]], "Print",ExpressionUUID->"5ddaf9ec-8f38-4a03-85b0-8c3545b11db2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdS],
  Editable->
   False]], "Print",ExpressionUUID->"5be600f6-8571-46d7-ba7d-16a31d895ce4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdS],
  Editable->
   False]], "Print",ExpressionUUID->"f23559fc-8c70-4b11-9a7e-4a24e9222da3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdS],
  Editable->
   False]], "Print",ExpressionUUID->"2cb98e1c-e77b-4ab9-b9f6-3c7f6eb35669"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCdS],
  Editable->
   False]], "Print",ExpressionUUID->"a740089a-7d6a-4586-962a-9996a4ed1bc7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdS],
  Editable->
   False]], "Print",ExpressionUUID->"609bce7d-84ce-4cee-a025-5dd765120951"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdS],
  Editable->
   False]], "Print",ExpressionUUID->"fce4fc0b-be9d-4938-a1b1-db1eb30f0ad5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdS],
  Editable->
   False]], "Print",ExpressionUUID->"66e1980e-faa7-40da-b85e-4013b58e3eab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdS],
  Editable->
   False]], "Print",ExpressionUUID->"8dd12171-0c1c-4846-96a8-766544ddf606"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdS],
  Editable->
   False]], "Print",ExpressionUUID->"bc014afb-382c-4787-9dab-9983cf53232d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdS],
  Editable->
   False]], "Print",ExpressionUUID->"3b54367c-fc16-46f8-93a9-183a23c3a56a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilongamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilongamma],
  Editable->
   False]], "Print",ExpressionUUID->"e03f4730-8da5-45d5-a249-89a8844596f9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gamma],
  Editable->
   False]], "Print",ExpressionUUID->"9b3f931c-4233-49b6-bfaf-87d81353f740"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "gamma"}]], "Input",ExpressionUUID->"8f21ebef-4b2b-4ae8-8776-1c11a8b8d122"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"gamma\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"593daf34-5702-4149-a21b-fed25e92952f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "CdS"}]], "Input",ExpressionUUID->"caaa0151-391a-4521-967f-f1da75b927b1"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"CdS\\\"\\)\[NoBreak] not found. \\!\\(\
\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b7b3ac36-134b-4020-8792-c31c9b9bbd79"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "gg", 
  "]"}]], "Input",ExpressionUUID->"9d6985d2-ee2c-4eb8-aa03-c7719b9417a7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgg],
  Editable->
   False]], "Print",ExpressionUUID->"e3d4b23e-7090-4b63-88fe-95bb8cb56f4e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDM],
  Editable->
   False]], "Print",ExpressionUUID->"d4bc0229-f71c-4db9-89e5-a1bac18e1502"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCDM],
  Editable->
   False]], "Print",ExpressionUUID->"480cc87c-c894-4f10-b0e9-9b0282ce665c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCDM],
  Editable->
   False]], "Print",ExpressionUUID->"5c877499-93ca-45bd-bb7c-149ef9a0c8f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCDM],
  Editable->
   False]], "Print",ExpressionUUID->"a70a787e-1b17-4ddc-8cc7-a8357f774b0a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCDM],
  Editable->
   False]], "Print",ExpressionUUID->"ce02c358-d2b8-46f2-8f34-382bd3046ddf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDM],
  Editable->
   False]], "Print",ExpressionUUID->"ed014beb-97b2-4ae4-a34a-06bc4ebec64d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannDownCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannDownCDM],
  Editable->
   False]], "Print",ExpressionUUID->"ac87d547-bcec-4cb5-9678-f204edf6724a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCDM],
  Editable->
   False]], "Print",ExpressionUUID->"01c689b6-9e11-47d5-9cfb-915bea2d85d9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDM],
  Editable->
   False]], "Print",ExpressionUUID->"97d30398-11cf-4f7a-9de6-b48d383c62ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCDM],
  Editable->
   False]], "Print",ExpressionUUID->"d7a4c620-2408-4241-b013-a578b134b2c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDM],
  Editable->
   False]], "Print",ExpressionUUID->"4a219ceb-1af5-46bb-a281-48a99b35af7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"inverse metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Invgg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "inverse metric tensor", 
   " ", $CellContext`Invgg],
  Editable->
   False]], "Print",ExpressionUUID->"52da9a81-c1b9-43ba-a96c-20eed071be5e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gg],
  Editable->
   False]], "Print",ExpressionUUID->"605a2133-4e08-4698-af1e-b3dd880798a3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "gg"}]], "Input",ExpressionUUID->"b8ee124e-2e47-4681-bc6e-ddb37acccebc"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"gg\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0829b904-72c0-4d8e-acc4-6867eaec2206"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "metricg", 
  "]"}]], "Input",ExpressionUUID->"b41cf0bd-a3a7-4c19-979f-79ded1065fe1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"8b68991c-5524-4a32-bad7-ef1ed18b627c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ChristoffelCDCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ChristoffelCDCdM],
  Editable->
   False]], "Print",ExpressionUUID->"710cca3f-af96-4197-a088-f9139c89f9ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdM],
  Editable->
   False]], "Print",ExpressionUUID->"19fabca6-a524-4d77-bea8-4f6acd9a4ea8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdM],
  Editable->
   False]], "Print",ExpressionUUID->"c9cda3c1-d510-4bdb-b5b4-428f7c2a0eae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"bee7cec8-4cfd-44fb-8467-ef15a76b5e3a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"c7596a64-b017-4e86-ace2-5585be92eb7f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdM],
  Editable->
   False]], "Print",ExpressionUUID->"bc943447-5abd-4bba-a165-0512ecfce830"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"69acf63b-4274-4bc1-98a5-7d1c995827a0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"b504fe04-bdb1-432c-b6b8-e09a56721710"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdM],
  Editable->
   False]], "Print",ExpressionUUID->"e0f1192e-f88e-4887-9855-702c86fb326d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdM],
  Editable->
   False]], "Print",ExpressionUUID->"c5f897d3-0a33-40a7-8d0b-57d9548419e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdM],
  Editable->
   False]], "Print",ExpressionUUID->"ddf244c8-c09e-4aef-a26c-6ab4fc2d9f6f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"ddffe262-1e80-4a92-9a4a-a1081a778ebf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"fab2b14a-0ed5-47ed-a25b-a624b1623982"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VisitorsOf", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"32d58d9e-db79-4a43-929e-7ce9e5c9ee4b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "T", ",", "CD", ",", "TorsionCD", ",", "ChristoffelCD", ",", "RiemannCD", 
   ",", "RicciCD"}], 
  "}"}]], "Output",ExpressionUUID->"762a54e8-2eaf-46f6-8428-45c3bb3f1a9a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "metricg"}]], \
"Input",ExpressionUUID->"1cef904a-b7ff-4c99-b15f-8c136a17422d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"metricg\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8368bdec-dfde-4b87-9487-53fcbbcb0023"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"8d8c2bc3-49b6-45d5-9403-2dd2cdd053a8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"d31261e6-92a8-498d-ad08-b707cabc5543"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "CD", 
  "]"}]], "Input",ExpressionUUID->"1f26a906-d02b-4391-ba62-98a8817df8ca"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"9fb3fb54-31ad-46f5-8276-4776e5e260d9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"8c825446-a66f-4abb-8464-0877b365d514"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"7c7dc0c4-310b-456a-aec2-16c4e5ada9d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"b6394beb-d567-42eb-99ff-87a9cc9a4c68"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"936b4f3d-81f9-48a9-8a7b-b305ef1b23ef"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"8a9e1c98-f9a7-4e74-8f8d-d7d0068781ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", "\<\"A\"\>", ",", "\<\"a$\"\>", 
     ",", "\<\"A$\"\>", ",", "\<\"b\"\>", ",", "\<\"B\"\>", ",", "\<\"b$\"\>",
      ",", "\<\"B$\"\>", ",", "\<\"c\"\>", ",", "\<\"c$\"\>", 
     ",", "\<\"d\"\>", ",", "\<\"e\"\>", ",", "\<\"f\"\>", ",", "\<\"F\"\>", 
     ",", "\<\"f1\"\>", ",", "\<\"f2\"\>", ",", "\<\"f3\"\>", 
     ",", "\<\"f$240286\"\>", ",", "\<\"f$240286$\"\>", 
     ",", "\<\"f$240287\"\>", ",", "\<\"f$240287$\"\>", 
     ",", "\<\"f$240288\"\>", ",", "\<\"f$240288$\"\>", 
     ",", "\<\"f$240289\"\>", ",", "\<\"f$240289$\"\>", 
     ",", "\<\"f$240290\"\>", ",", "\<\"f$240290$\"\>", 
     ",", "\<\"f$240291\"\>", ",", "\<\"f$240291$\"\>", 
     ",", "\<\"f$240292\"\>", ",", "\<\"f$240292$\"\>", 
     ",", "\<\"f$240293\"\>", ",", "\<\"f$240293$\"\>", 
     ",", "\<\"f$240294\"\>", ",", "\<\"f$240294$\"\>", 
     ",", "\<\"f$240295\"\>", ",", "\<\"f$240295$\"\>", 
     ",", "\<\"f$240296\"\>", ",", "\<\"f$240296$\"\>", 
     ",", "\<\"f$240297\"\>", ",", "\<\"f$240297$\"\>", 
     ",", "\<\"f$240298\"\>", ",", "\<\"f$240298$\"\>", 
     ",", "\<\"f$240299\"\>", ",", "\<\"f$240299$\"\>", 
     ",", "\<\"f$240368\"\>", ",", "\<\"f$240369\"\>", 
     ",", "\<\"f$240370\"\>", ",", "\<\"f$240371\"\>", 
     ",", "\<\"f$240379\"\>", ",", "\<\"f$240380\"\>", 
     ",", "\<\"f$240388\"\>", ",", "\<\"f$240389\"\>", 
     ",", "\<\"f$240390\"\>", ",", "\<\"G\"\>", ",", "\<\"G1\"\>", 
     ",", "\<\"G2\"\>", ",", "\<\"G3\"\>", ",", "\<\"G$238536\"\>", 
     ",", "\<\"G$238536$\"\>", ",", "\<\"G$238537\"\>", 
     ",", "\<\"G$238537$\"\>", ",", "\<\"G$238538\"\>", 
     ",", "\<\"G$238538$\"\>", ",", "\<\"G$238539\"\>", 
     ",", "\<\"G$238539$\"\>", ",", "\<\"G$238540\"\>", 
     ",", "\<\"G$238540$\"\>", ",", "\<\"G$238541\"\>", 
     ",", "\<\"G$238541$\"\>", ",", "\<\"G$238542\"\>", 
     ",", "\<\"G$238542$\"\>", ",", "\<\"G$238543\"\>", 
     ",", "\<\"G$238543$\"\>", ",", "\<\"G$238544\"\>", 
     ",", "\<\"G$238544$\"\>", ",", "\<\"G$238545\"\>", 
     ",", "\<\"G$238545$\"\>", ",", "\<\"G$238546\"\>", 
     ",", "\<\"G$238546$\"\>", ",", "\<\"G$238547\"\>", 
     ",", "\<\"G$238547$\"\>", ",", "\<\"G$238548\"\>", 
     ",", "\<\"G$238548$\"\>", ",", "\<\"G$238549\"\>", 
     ",", "\<\"G$238549$\"\>", ",", "\<\"G$238618\"\>", 
     ",", "\<\"G$238619\"\>", ",", "\<\"G$238620\"\>", 
     ",", "\<\"G$238621\"\>", ",", "\<\"G$238629\"\>", 
     ",", "\<\"G$238630\"\>", ",", "\<\"G$238638\"\>", 
     ",", "\<\"G$238639\"\>", ",", "\<\"G$238640\"\>", 
     ",", "\<\"G$238687\"\>", ",", "\<\"G$238687$\"\>", 
     ",", "\<\"G$238688\"\>", ",", "\<\"G$238688$\"\>", 
     ",", "\<\"G$238689\"\>", ",", "\<\"G$238689$\"\>", 
     ",", "\<\"G$238690\"\>", ",", "\<\"G$238690$\"\>", 
     ",", "\<\"G$238709\"\>", ",", "\<\"G$238710\"\>", 
     ",", "\<\"G$238711\"\>", ",", "\<\"G$238714\"\>", 
     ",", "\<\"G$238715\"\>", ",", "\<\"G$238716\"\>", 
     ",", "\<\"G$238722\"\>", ",", "\<\"G$238723\"\>", 
     ",", "\<\"G$238724\"\>", ",", "\<\"G$238729\"\>", 
     ",", "\<\"G$238730\"\>", ",", "\<\"G$238731\"\>", 
     ",", "\<\"G$238734\"\>", ",", "\<\"G$238735\"\>", 
     ",", "\<\"G$238736\"\>", ",", "\<\"G$238739\"\>", 
     ",", "\<\"G$238740\"\>", ",", "\<\"G$238741\"\>", 
     ",", "\<\"G$238745\"\>", ",", "\<\"G$238746\"\>", 
     ",", "\<\"G$238747\"\>", ",", "\<\"G$238750\"\>", 
     ",", "\<\"G$238751\"\>", ",", "\<\"G$238752\"\>", 
     ",", "\<\"G$238756\"\>", ",", "\<\"G$238757\"\>", 
     ",", "\<\"G$238758\"\>", ",", "\<\"G$238763\"\>", 
     ",", "\<\"G$238766\"\>", ",", "\<\"G$238769\"\>", 
     ",", "\<\"G$238770\"\>", ",", "\<\"G$238771\"\>", 
     ",", "\<\"G$238773\"\>", ",", "\<\"G$238774\"\>", 
     ",", "\<\"G$238775\"\>", ",", "\<\"G$238777\"\>", 
     ",", "\<\"G$238780\"\>", ",", "\<\"G$238783\"\>", 
     ",", "\<\"G$238784\"\>", ",", "\<\"G$238785\"\>", 
     ",", "\<\"G$238787\"\>", ",", "\<\"G$238788\"\>", 
     ",", "\<\"G$238789\"\>", ",", "\<\"G$238791\"\>", 
     ",", "\<\"G$238792\"\>", ",", "\<\"G$238793\"\>", 
     ",", "\<\"G$238796\"\>", ",", "\<\"G$238799\"\>", 
     ",", "\<\"G$238802\"\>", ",", "\<\"G$238805\"\>", 
     ",", "\<\"G$238808\"\>", ",", "\<\"G$238811\"\>", 
     ",", "\<\"G$238815\"\>", ",", "\<\"G$238816\"\>", 
     ",", "\<\"G$240033\"\>", ",", "\<\"G$240033$\"\>", 
     ",", "\<\"G$240034\"\>", ",", "\<\"G$240034$\"\>", 
     ",", "\<\"G$240035\"\>", ",", "\<\"G$240035$\"\>", 
     ",", "\<\"G$240036\"\>", ",", "\<\"G$240036$\"\>", 
     ",", "\<\"G$240098\"\>", ",", "\<\"G$240099\"\>", 
     ",", "\<\"G$240100\"\>", ",", "\<\"G$240101\"\>", 
     ",", "\<\"G$240102\"\>", ",", "\<\"G$240112\"\>", 
     ",", "\<\"G$240113\"\>", ",", "\<\"G$240114\"\>", 
     ",", "\<\"G$240115\"\>", ",", "\<\"G$240116\"\>", 
     ",", "\<\"G$240117\"\>", ",", "\<\"G$240118\"\>", 
     ",", "\<\"G$240119\"\>", ",", "\<\"G$240120\"\>", 
     ",", "\<\"G$240121\"\>", ",", "\<\"G$240122\"\>", 
     ",", "\<\"G$240123\"\>", ",", "\<\"G$240124\"\>", 
     ",", "\<\"G$240125\"\>", ",", "\<\"G$240126\"\>", 
     ",", "\<\"G$240127\"\>", ",", "\<\"G$240139\"\>", 
     ",", "\<\"G$240140\"\>", ",", "\<\"G$240141\"\>", 
     ",", "\<\"G$240142\"\>", ",", "\<\"G$240143\"\>", 
     ",", "\<\"G$240144\"\>", ",", "\<\"G$240145\"\>", 
     ",", "\<\"G$240146\"\>", ",", "\<\"G$240147\"\>", 
     ",", "\<\"G$240148\"\>", ",", "\<\"G$240149\"\>", 
     ",", "\<\"G$240150\"\>", ",", "\<\"G$240151\"\>", 
     ",", "\<\"G$240152\"\>", ",", "\<\"G$240153\"\>", 
     ",", "\<\"G$240161\"\>", ",", "\<\"G$240162\"\>", 
     ",", "\<\"G$240163\"\>", ",", "\<\"M2\"\>", ",", "\<\"Polar\"\>", 
     ",", "\<\"S2\"\>", ",", "\<\"TangentM2\"\>", ",", "\<\"TangentS2\"\>"}], 
    "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "a", "A", "a$", "A$", "b", "B", "b$", "B$", "c", "c$", "d", "e", "f", "F", 
    "f1", "f2", "f3", "f$240286", "f$240286$", "f$240287", "f$240287$", 
    "f$240288", "f$240288$", "f$240289", "f$240289$", "f$240290", "f$240290$",
     "f$240291", "f$240291$", "f$240292", "f$240292$", "f$240293", 
    "f$240293$", "f$240294", "f$240294$", "f$240295", "f$240295$", "f$240296",
     "f$240296$", "f$240297", "f$240297$", "f$240298", "f$240298$", 
    "f$240299", "f$240299$", "f$240368", "f$240369", "f$240370", "f$240371", 
    "f$240379", "f$240380", "f$240388", "f$240389", "f$240390", "G", "G1", 
    "G2", "G3", "G$238536", "G$238536$", "G$238537", "G$238537$", "G$238538", 
    "G$238538$", "G$238539", "G$238539$", "G$238540", "G$238540$", "G$238541",
     "G$238541$", "G$238542", "G$238542$", "G$238543", "G$238543$", 
    "G$238544", "G$238544$", "G$238545", "G$238545$", "G$238546", "G$238546$",
     "G$238547", "G$238547$", "G$238548", "G$238548$", "G$238549", 
    "G$238549$", "G$238618", "G$238619", "G$238620", "G$238621", "G$238629", 
    "G$238630", "G$238638", "G$238639", "G$238640", "G$238687", "G$238687$", 
    "G$238688", "G$238688$", "G$238689", "G$238689$", "G$238690", "G$238690$",
     "G$238709", "G$238710", "G$238711", "G$238714", "G$238715", "G$238716", 
    "G$238722", "G$238723", "G$238724", "G$238729", "G$238730", "G$238731", 
    "G$238734", "G$238735", "G$238736", "G$238739", "G$238740", "G$238741", 
    "G$238745", "G$238746", "G$238747", "G$238750", "G$238751", "G$238752", 
    "G$238756", "G$238757", "G$238758", "G$238763", "G$238766", "G$238769", 
    "G$238770", "G$238771", "G$238773", "G$238774", "G$238775", "G$238777", 
    "G$238780", "G$238783", "G$238784", "G$238785", "G$238787", "G$238788", 
    "G$238789", "G$238791", "G$238792", "G$238793", "G$238796", "G$238799", 
    "G$238802", "G$238805", "G$238808", "G$238811", "G$238815", "G$238816", 
    "G$240033", "G$240033$", "G$240034", "G$240034$", "G$240035", "G$240035$",
     "G$240036", "G$240036$", "G$240098", "G$240099", "G$240100", "G$240101", 
    "G$240102", "G$240112", "G$240113", "G$240114", "G$240115", "G$240116", 
    "G$240117", "G$240118", "G$240119", "G$240120", "G$240121", "G$240122", 
    "G$240123", "G$240124", "G$240125", "G$240126", "G$240127", "G$240139", 
    "G$240140", "G$240141", "G$240142", "G$240143", "G$240144", "G$240145", 
    "G$240146", "G$240147", "G$240148", "G$240149", "G$240150", "G$240151", 
    "G$240152", "G$240153", "G$240161", "G$240162", "G$240163", "M2", "Polar",
     "S2", "TangentM2", "TangentS2"}],
  Editable->
   False]], "Print",ExpressionUUID->"b1458691-87ae-40e2-ba4d-762bb7c5fb39"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2. Metric contraction and separation", \
"Subsection",ExpressionUUID->"94bc6fef-8eee-430b-a5dd-67884799061e"],

Cell[CellGroupData[{

Cell["14.2.0. Comments", \
"Subsubsection",ExpressionUUID->"4e6db66c-d1ab-47b0-8344-0ca47eff09aa"],

Cell["\<\
Contraction with the deltas is automatic, but contraction with metrics is \
not. It must be explicitly executed by the user using the function \
ContractMetric.

ContractMetric works with basis-indices, even if there are derivatives.\
\>", "Text",ExpressionUUID->"f3eb91b0-eb55-4889-89cb-ee57a61e127b"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2.1. SymmetryOfMetric and SMP", \
"Subsubsection",ExpressionUUID->"114ae45a-cdf0-455b-b474-676b229884ad"],

Cell["\<\
Now that when we work with spinors we need to manipulate antisymmetric \
metrics. The function SymmetryOfMetric returns a sign +1 if the metric is \
symmetric and -1 if the metric is antisymmetric. We assume that the metric is \
one of those. It could be a public function, but the information is already \
in SymmetryGroupOfTensor.\
\>", "Text",ExpressionUUID->"0c94a26c-469c-4163-8d9d-d602808d39f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "SymmetryOfMetric", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryOfMetric", "[", "Null", "]"}], "=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryOfMetric", "[", "metric_", "]"}], ":=", 
     RowBox[{"xUpSet", "[", 
      RowBox[{
       RowBox[{"SymmetryOfMetric", "[", "metric", "]"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"Last", "@", 
            RowBox[{"SymmetryGroupOfTensor", "[", "metric", "]"}]}], ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"{", "2", "}"}]}], "]"}], ",", 
         RowBox[{"-", "1"}], ",", "1"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Important", " ", "convention", " ", "on", " ", "the", " ", "index", " ", 
     "positioning", " ", "of", " ", "an", " ", "antisymmetric", " ", 
     "metric"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SMP", "[", 
      RowBox[{"metric_", ",", 
       RowBox[{"_", "?", "UpIndexQ"}], ",", 
       RowBox[{"_", "?", "DownIndexQ"}]}], "]"}], ":=", "1"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SMP", "[", 
      RowBox[{"metric_", ",", 
       RowBox[{"_", "?", "DownIndexQ"}], ",", 
       RowBox[{"_", "?", "UpIndexQ"}]}], "]"}], ":=", 
     RowBox[{"SymmetryOfMetric", "[", "metric", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SMP", "[", 
      RowBox[{"metric_", ",", "a_", ",", "b_"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"SymmetryOfMetric", "::", "unknown"}], ",", 
         "\"\<symmetry of metric\>\"", ",", 
         RowBox[{"metric", "[", 
          RowBox[{"a", ",", "b"}], "]"}]}], "]"}], ";", "1"}], ")"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"819f084f-df56-4425-bb42-2377f944cce8"],

Cell["\<\
It is very important to understand the convention in SMP:
\tg[-b, -a] T[a]   ->   SMP[g, -a, a] T[-b]
\tg[b, a] T[-a]    ->   SMP[g, a, -a] T[b]
\tT[a] g[-a, -b]   ->   SMP[g, a, -a] T[-b]
\tT[-a] g[a, b]    ->   SMP[g, -a, a] T[b]
This is consistent with the choice of delta[-a, b] as original identity and \
delta[a, -b] as \"metric-derived\" identity.\
\>", "Text",ExpressionUUID->"0733a73d-5f3a-46a8-900f-ceea0b33cc69"],

Cell["\<\
QUESTION: Perhaps we should introduce a global variable controlling this \
convention, but this issue would probably get even more confusing than it is \
right now.\
\>", "Text",ExpressionUUID->"ec8f4c52-78d6-401c-b0c5-bb00fa71b9be"],

Cell["\<\
This function checks whether there is a metric on the vbundle of an index, \
and which type of symmetry it has. Note that it throws an error if there is \
no metric. This is because SymmetryOfIndex is always called from \
\"non-standard\" deltas, which only exist when a metric has been introduced. \
It is used in delta and Gdelta definitions only, and so it can be considered \
to be a \"SymmetryOfdelta\" function.\
\>", "Text",ExpressionUUID->"5e38d20e-5520-429e-b2e9-8c0bd84a4bfa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOfIndex", "[", 
    RowBox[{"ind_", ",", 
     RowBox[{"tf_", ":", "True"}]}], "]"}], ":=", 
   RowBox[{"SymmetryOfMetric", "@", 
    RowBox[{"FirstMetricOfVBundle", "[", 
     RowBox[{
      RowBox[{"VBundleOfIndex", "[", "ind", "]"}], ",", "tf"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7f2678b6-f1a1-498e-a4a6-254382bc497c"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2.3. ContractMetric", \
"Subsubsection",ExpressionUUID->"6cc3bf07-bb0d-4be3-911c-13ceff6d5d33"],

Cell["\<\
ContractMetric is the user function that expands the argument and then calls \
ContractMetric0 / ContractMetric1 (checking that metric is actually a \
metric). When no metric is specified we call $NonFrozenMetrics and not the \
whole list $Metrics because if there are several metrics in a vbundle only \
the first one and its induced metrics are allowed to move up and down the \
indices. Frozen metrics cannot be contracted, and a message is thrown. \
Induced metrics are projectors and therefore their contraction on an \
already-projected tensor is trivial, but not on other tensors.\
\>", "Text",ExpressionUUID->"10035e77-9159-44a5-92f6-aacafb347883"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$NonFrozenMetrics", ":=", 
   RowBox[{"DeleteCases", "[", 
    RowBox[{"$Metrics", ",", 
     RowBox[{"_", "?", "FrozenMetricQ"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0a17cc04-210f-4bff-8b70-320908d43857"],

Cell["\<\
This curious function detects induced metrics and returns the normal vector. \
If a frozen metric is given then it throws an error:\
\>", "Text",ExpressionUUID->"db0fb046-1850-40a7-9d0c-ec5377fc8d99"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ContractMetric", "::", "frozen"}], "=", 
   "\"\<Cannot contract frozen metric `1`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NormalVectorOf", "[", "metric_", "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FirstMetricQ", "[", "metric", "]"}], ",", "Null", ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InducedFrom", "[", "metric", "]"}], "=!=", "Null"}], ",", 
     RowBox[{"VectorOfInducedMetric", "[", "metric", "]"}], ",", 
     "\[IndentingNewLine]", "True", ",", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"ContractMetric", "::", "frozen"}], ",", "metric"}], 
       "]"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2c133f25-53a7-4814-93a5-74d8e5d4805f"],

Cell["Main driver:", \
"Text",ExpressionUUID->"94b96e25-f6dd-4450-9eae-3c63eaa6237e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ContractMetric", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AllowUpperDerivatives", "\[Rule]", "False"}], ",", 
     RowBox[{"OverDerivatives", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractMetric", "[", 
    RowBox[{"expr_", ",", "metrics_List", ",", "options___"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric", "[", 
       RowBox[{"#1", ",", "#2", ",", "options"}], "]"}], "&"}], ",", "expr", 
     ",", "metrics"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractMetric", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"metric_Symbol", "?", "MetricQ"}], ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ContractMetric0", "[", 
     RowBox[{
      RowBox[{"OptionValue", "[", 
       RowBox[{"{", 
        RowBox[{"OverDerivatives", ",", "AllowUpperDerivatives"}], "}"}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"metric", ",", 
        RowBox[{"NormalVectorOf", "[", "metric", "]"}]}], "}"}]}], "]"}], "[",
     "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractMetric", "[", 
    RowBox[{"expr_", ",", "metric_Symbol", ",", "options___"}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ContractMetric", "::", "unknown"}], ",", "\"\<metric\>\"", ",",
       "metric"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ContractMetric", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"options___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"ContractMetric", "[", 
    RowBox[{"expr", ",", "$NonFrozenMetrics", ",", "options"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ContractMetric", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "ContractMetric", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"51387779-a18e-4578-b0ee-594befcc8fff"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2.4. ContractMetric1", \
"Subsubsection",ExpressionUUID->"00a83545-e073-4a5a-a613-2dead95224c6"],

Cell["\<\
This section seems to be dangerous with respect to basis-indices.\
\>", "Text",ExpressionUUID->"be3e45a4-2564-4a0b-9e61-ce688713b835"],

Cell["\<\
The first pair of brackets of ContractMetric1 contains:
\t- od: OverDerivatives Boolean
\t- aud: AllowUpperDerivatives Boolean. It acts on covariant derivatives to \
allow upper derivative-indices.
\t- metric: the metric to be contracted (either a first-metric or an induced \
metric).
\t- nv: normal vector of metric, if it is induced, or Null if it is a \
first-metric.
It is natural to put od, aud in a list because they come from the options, \
and it is natural to put metric, nv in another list because nv is a property \
of metric.\
\>", "Text",ExpressionUUID->"fccd4f29-d09c-4b93-be80-9823baebe8c4"],

Cell["\<\
ContractMetric1 is the internal function that performs metric contraction. It \
must be defined on the different types. Before that we introduce a step \
expanding Times products (other products distribute automatically):\
\>", "Text",ExpressionUUID->"f49f46f0-3247-4cf1-94fb-90bf1cdac047"],

Cell["0) Expand products:", \
"Text",ExpressionUUID->"9f9c2108-8bbe-4986-8469-4fafbd35d2ea"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ContractMetric0", "[", "case__", "]"}], "[", "expr_Times", "]"}],
    ":=", 
   RowBox[{
    RowBox[{"ContractMetric1", "[", "case", "]"}], "[", 
    RowBox[{"MathInputExpand", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ContractMetric0", "[", "case__", "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{"ContractMetric1", "[", "case", "]"}], "[", "expr", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9dc6fdf5-bce5-4ac1-a044-e0d3729941d3"],

Cell["\<\
1) First we have some definitions which do not perform any actual \
contraction, but refer to itself recursively:\
\>", "Text",ExpressionUUID->"47d91a1d-dd85-4f8a-9adb-2c32cf0c8268"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Automatic", " ", "threading"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric1", "[", "case__", "]"}], "[", "expr_Plus", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractMetric0", "[", "case", "]"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric1", "[", "case__", "]"}], "[", "expr_SeriesData",
       "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{"ContractMetric0", "[", "case", "]"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric1", "[", "case__", "]"}], "[", "list_List", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractMetric0", "[", "case", "]"}], "/@", "list"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric1", "[", "case__", "]"}], "[", "eq_Equal", "]"}],
      ":=", 
     RowBox[{
      RowBox[{"ContractMetric0", "[", "case", "]"}], "/@", "eq"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"96f9ed38-9a54-4a24-b2be-4b50564e1e63"],

Cell["2) Contraction through derivatives:", \
"Text",ExpressionUUID->"381f55f4-56e0-4dd8-9173-d981d52fba24"],

Cell["\<\
The function differentexpressionsQ does the following: when contracting \
through a derivative we want to know if the metric outside can be contracted \
with the expression inside the metric. What we do is comparing two lists: \
expr1 is the list of the metric and the expression inside and expr2 is the \
expression after trying to contract the metric. We shall only continue if \
these two (sorted!) lists are different.\
\>", "Text",ExpressionUUID->"29a433d9-4ca1-41a3-bd5e-daf71dc1a3b7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"differentexpressionsQ", "[", 
     RowBox[{"expr1_Times", ",", "expr2_List"}], "]"}], ":=", 
    RowBox[{"differentexpressionsQ", "[", 
     RowBox[{
      RowBox[{"List", "@@", "expr1"}], ",", "expr2"}], "]"}]}], ";", 
   RowBox[{
    RowBox[{"differentexpressionsQ", "[", 
     RowBox[{"expr1_List", ",", "expr2_List"}], "]"}], ":=", 
    RowBox[{"UnsameQ", "[", 
     RowBox[{
      RowBox[{"Sort", "[", "expr1", "]"}], ",", 
      RowBox[{"Sort", "[", "expr2", "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "All", " ", "other", " ", "cases", " ", "in", " ", "which", " ", "the", 
    " ", "LHS", " ", "is", " ", "a", " ", "single", " ", "object"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"differentexpressionsQ", "[", 
    RowBox[{"expr1_", ",", "expr2_"}], "]"}], ":=", "True"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"9af5a61c-2511-4ee2-8108-01ec2453e010"],

Cell["\<\
As noted by Guillaume, the definitions based on the use of FirstDerQ do not \
work with multiple parametric derivatives.  This is because we use a \
different (compacted) notation for multiple parametric derivatives, instead \
of the usual (expanded) notation for other types of derivatives. I don't see \
a simple way to solve this, except removing the compacted notation for \
parametric derivatives; need to think more. \
\>", "Text",ExpressionUUID->"786376ad-7676-433c-a9f3-f44fcb20d046"],

Cell["\<\
We cannot allow recursion on products of the form g*D(g^-1) because they \
would give (g^-1)*Dg, which can be processed again with the same rule giving \
the original expression again, leading to infinite recursion. The following \
defintion simply prevents this particular case on first order derivatives of \
the (first or induced) metric. Recall that derivatives of first metrics with \
upper indices are automatically converted into derivatives of their \
lower-indices counterparts. That means that there is a canonical form for \
first-order derivatives of first-metrics, but not in other cases (like higher \
derivatives or any derivative of induced metrics).\
\>", "Text",ExpressionUUID->"4ff17ed7-eea0-48a4-a8ea-f0732ba08f89"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Contraction", " ", "metric", "*", 
    RowBox[{"der", "[", "metric", "]"}], " ", "is", " ", "left", " ", 
    "untouched", " ", "to", " ", "avoid", " ", "infinite", " ", "recursion"}],
    " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"CM", ":", 
       RowBox[{"ContractMetric1", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
     RowBox[{"rest_.", " ", 
      RowBox[{
       RowBox[{"der_", "?", "FirstDerQ"}], "[", 
       RowBox[{"metric_", "[", 
        RowBox[{"a_", ",", "b_"}], "]"}], "]"}], 
      RowBox[{"metric_", "[", 
       RowBox[{"c_", ",", "d_"}], "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"CM", "[", 
       RowBox[{"rest", " ", 
        RowBox[{"metric", "[", 
         RowBox[{"c", ",", "d"}], "]"}]}], "]"}], 
      RowBox[{"der", "[", 
       RowBox[{"metric", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "]"}]}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"a", ",", "d"}], "]"}], "||", 
       RowBox[{"PairQ", "[", 
        RowBox[{"b", ",", "d"}], "]"}], "||", 
       RowBox[{"PairQ", "[", 
        RowBox[{"a", ",", "c"}], "]"}], "||", 
       RowBox[{"pair", "[", 
        RowBox[{"b", ",", "c"}], "]"}]}], ")"}]}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2f8c1ae6-8787-4bcb-86e7-6de14d2d6bc6"],

Cell["\<\
Note that in the following expression we only make use of the Leibnitz rule \
and therefore it is valid even if there are basis-indices in the expression. \
However, it could be wrong for an induced derivative if we try to contract a \
non-spatial index. However that would mean that the projected derivative is \
acting on an object with a non-projected index, and that is forbidden in our \
system. So, as long as that rule is kept, the following definition is correct:\
\>", "Text",ExpressionUUID->"fb8b4879-8c55-4fd8-9289-a5bfbfdf9045"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Contractions", " ", "inside", " ", "first"}], "-", 
    RowBox[{
     RowBox[{"derivatives", ".", " ", "This"}], " ", "is", " ", "a", " ", 
     "complicated", " ", "definition"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"CM", ":", 
       RowBox[{"ContractMetric1", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
     RowBox[{"rest_.", " ", 
      RowBox[{
       RowBox[{"der_", "?", "FirstDerQ"}], "[", "expr_", "]"}], 
      RowBox[{"met", ":", 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dm", "=", 
          RowBox[{"der", "[", "met", "]"}]}], ",", "result"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"od", "||", 
            RowBox[{"dm", "===", "0"}]}], ")"}], "&&", 
          RowBox[{"differentexpressionsQ", "[", 
           RowBox[{
            RowBox[{"result", "=", 
             RowBox[{"CM", "[", 
              RowBox[{"expr", " ", "met"}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"expr", ",", "met"}], "}"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CM", "[", 
           RowBox[{"rest", " ", 
            RowBox[{"der", "[", "result", "]"}]}], "]"}], "-", 
          RowBox[{"CM", "[", 
           RowBox[{"rest", " ", "dm", " ", "expr"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CM", "[", 
           RowBox[{"rest", " ", "met"}], "]"}], 
          RowBox[{"der", "[", "expr", "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", 
         RowBox[{
          RowBox[{"ChangeIndex", "[", "c", "]"}], "|", 
          RowBox[{"ChangeIndex", "[", "b", "]"}]}]}], "]"}], "&&", 
       RowBox[{
        RowBox[{"Head", "[", "expr", "]"}], "=!=", "metric"}]}], ")"}]}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"200bdc90-82a2-486c-9c47-15412aa31df2"],

Cell["\<\
There is one doubt: it could happen that the contraction is not possible and \
then we pass to the reduced case CM[rest met]. But, what if something else in \
rest could still be contracted with expr? This is a very special case, and \
perhaps that is why we have never seen it, but it is clearly a possibility. \
Perhaps there should be a condition check that CM[rest met] is actually \
different from rest met. Note that there is no danger because the result is \
still correct; it just fails to perform a possible contraction.\
\>", "Text",ExpressionUUID->"b2e89084-e599-42d5-ac0f-30e74e28f061"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Code", " ", "provided", " ", "by", " ", "Guillaume", " ", "to", " ", 
    "contract", " ", "through", " ", "multiple", " ", "parametric", " ", 
    "derivatives"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"CM", ":", 
       RowBox[{"ContractMetric1", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
     RowBox[{"rest_.", " ", 
      RowBox[{
       RowBox[{"ParamD", "[", 
        RowBox[{"param1_", ",", "params__"}], "]"}], "[", "expr_", "]"}], " ", 
      RowBox[{"met", ":", 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dm", "=", 
          RowBox[{
           RowBox[{"ParamD", "[", "param1", "]"}], "[", "met", "]"}]}], ",", 
         "result"}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"od", "||", 
            RowBox[{"dm", "===", "0"}]}], ")"}], "&&", 
          RowBox[{"differentexpressionsQ", "[", 
           RowBox[{
            RowBox[{"result", "=", 
             RowBox[{"CM", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ParamD", "[", "params", "]"}], "[", "expr", "]"}], 
               " ", "met"}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"ParamD", "[", "params", "]"}], "[", "expr", "]"}], 
              ",", "met"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"CM", "[", 
           RowBox[{"rest", " ", 
            RowBox[{
             RowBox[{"ParamD", "[", "param1", "]"}], "[", "result", "]"}]}], 
           "]"}], "-", 
          RowBox[{"CM", "[", 
           RowBox[{"rest", " ", "dm", " ", 
            RowBox[{
             RowBox[{"ParamD", "[", "params", "]"}], "[", "expr", "]"}]}], 
           "]"}]}], ",", 
         RowBox[{
          RowBox[{"CM", "[", 
           RowBox[{"rest", " ", "met"}], "]"}], " ", 
          RowBox[{
           RowBox[{"ParamD", "[", 
            RowBox[{"param1", ",", "params"}], "]"}], "[", "expr", "]"}]}]}], 
        "]"}]}], "]"}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", 
         RowBox[{
          RowBox[{"ChangeIndex", "[", "c", "]"}], "|", 
          RowBox[{"ChangeIndex", "[", "b", "]"}]}]}], "]"}], "&&", 
       RowBox[{
        RowBox[{"Head", "[", "expr", "]"}], "=!=", "metric"}]}], ")"}]}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6b37f42a-482c-4605-abfb-93a8e993d2e8"],

Cell["\<\
3) Induced metrics: If the switch nv (projection) is different from Null then \
contraction is allowed only if the tensor to be contracted is orthogonal to \
nv or if the derivative is the induced derivative:\
\>", "Text",ExpressionUUID->"8af5007b-adc5-4b07-832e-4cbad193977f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"nv", "=", 
    RowBox[{"Null", ":", " ", 
     RowBox[{"allow", " ", "contraction"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PRJ", "[", 
      RowBox[{"Null", ",", "__"}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"nv", "=!=", 
     RowBox[{"Null", ":", " ", 
      RowBox[{"allow", " ", "only", " ", "valid", " ", 
       RowBox[{"cases", ":"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "          ", 
    RowBox[{
    "Contraction", " ", "of", " ", "projector", " ", "on", " ", "an", " ", 
     "spatial", " ", "tensor"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PRJ", "[", 
      RowBox[{"nv_", ",", 
       RowBox[{"tensor_", "?", "xTensorQ"}], ",", "indumetric_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"OrthogonalToVectorQ", "[", "nv", "]"}], "[", "tensor", "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "          ", 
    RowBox[{
     RowBox[{
     "Contraction", " ", "of", " ", "projector", " ", "through", " ", "its", 
      " ", "Levi"}], "-", 
     RowBox[{"Civita", " ", "connection"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PRJ", "[", 
      RowBox[{"nv_", ",", 
       RowBox[{"covd_", "?", "CovDQ"}], ",", "indumetric_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CovDOfMetric", "[", "indumetric", "]"}], "===", "covd"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ca859c6c-3ef6-4ed4-98f5-61f1b6ecbdda"],

Cell["\<\
Note the particular case of passing an induced metric inside their associated \
projectors as full metrics. Example:   h[-a,-b] Projh[ T[b,c] ] = Projh[ \
g[-a,-b] T[b,c] ]  ,  where we have converted h into g when going inside. \
However, this cannot be done if both indices of the metric h are contracted, \
as in   h[-a,-b] Projh[ T[a,b] ].  I think this is a property of induced \
metrics and projectors, and not a generic property of induced metrics and \
inert-heads. Think about this!\
\>", "Text",ExpressionUUID->"ea90086d-aa90-4cd3-850a-3908c9aa641f"],

Cell["\<\
Which metric we contract inside the inert-head depends on the type of metric \
and whether only one or both indices are contracted:\
\>", "Text",ExpressionUUID->"1c7a9e02-8dae-4356-89d9-f4c9b445e2fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Non", "-", 
    RowBox[{"induced", " ", 
     RowBox[{"metric", ":", " ", 
      RowBox[{"nothing", " ", "to", " ", "do"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric2", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"metric_", ",", "Null", ",", "_"}], "}"}]}], "]"}], "[", 
      RowBox[{"expr_", ",", "met_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractMetric1", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"od", ",", "aud"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"metric", ",", "Null"}], "}"}]}], "]"}], "[", 
      RowBox[{"expr", " ", "met"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Induced", " ", 
     RowBox[{"metric", ".", " ", "Both"}], " ", "indices", " ", "are", " ", 
     RowBox[{"contracted", ":", " ", 
      RowBox[{"nothing", " ", "to", " ", "do"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric2", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"metric_", ",", "nv_", ",", "True"}], "}"}]}], "]"}], "[", 
      RowBox[{"expr_", ",", "met_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"ContractMetric1", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"od", ",", "aud"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"metric", ",", "nv"}], "}"}]}], "]"}], "[", 
      RowBox[{"expr", " ", "met"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Induced", " ", 
     RowBox[{"metric", ".", " ", "Other"}], " ", "index", " ", "not", " ", 
     RowBox[{"contracted", ":", " ", 
      RowBox[{"pass", " ", "supermetric", " ", "inside"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ContractMetric2", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"metric_", ",", "nv_", ",", "False"}], "}"}]}], "]"}], "[", 
      RowBox[{"expr_", ",", "met_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"supermetric", "=", 
         RowBox[{"First", "@", 
          RowBox[{"InducedFrom", "[", "metric", "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od", ",", "aud"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"supermetric", ",", "Null"}], "}"}]}], "]"}], "[", 
        RowBox[{"expr", " ", 
         RowBox[{"supermetric", "@@", "met"}]}], "]"}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"eda191ac-2e3e-4d01-a4eb-1333b8ef4cd9"],

Cell[TextData[{
 "4) Now we have the function which perform the actual contraction. There are \
four cases: tensors, covariant derivatives, brackets (the only three things \
in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " having abstract indices)and then inert-heads. We give two definitions per \
case, the first contracting the second index of the metric, and the second \
contracting the first index of the metric. This is to have full control on \
the order the indices are tried."
}], "Text",ExpressionUUID->"9a95cd6d-9088-4117-8da9-9d4899627312"],

Cell["\<\
Comments:
\t- There is external recursion in all cases, but there is no recursion in \
the internal expr of a covariant derivative. In those cases in which the \
Leibnitz derivative holds there is no problem, but in those cases in which it \
doesn't such recursion could be actually needed.\
\>", "Text",ExpressionUUID->"98918f37-aea6-42a7-8789-6857b313d6c6"],

Cell["\<\
I don't like the use of Condition, but here there are so many things to check \
that any other type of coding would be much longer.\
\>", "Text",ExpressionUUID->"270532e5-5a24-473b-b5a0-75c2655bd2fe"],

Cell["\<\
Explicit assumptions:
\t- The \"other index in the metric\" is never a pattern, and that is why we \
use UpIndexQ and DownIndexQ instead upQ and downQ. Patterns could be \
dangerous here.\
\>", "Text",ExpressionUUID->"fd25948a-7cec-405f-b449-d7f9f18e9690"],

Cell["Tensors, covariant derivatives and products:", \
"Text",ExpressionUUID->"c4b4690f-d948-449d-9c8d-3012db46421c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Second", " ", "index", " ", "of", " ", "metric"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
        RowBox[{"i1___", ",", "a_", ",", "i2___"}], "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SMP", "[", 
        RowBox[{"metric", ",", "c", ",", "a"}], "]"}], 
       RowBox[{"CM", "[", 
        RowBox[{"rest", " ", 
         RowBox[{"tensor", "[", 
          RowBox[{"i1", ",", "b", ",", "i2"}], "]"}]}], "]"}]}], "/;", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"c", ",", "a"}], "]"}], "&&", 
       RowBox[{"PRJ", "[", 
        RowBox[{"nv", ",", "tensor", ",", "metric"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", 
         RowBox[{"i1___", ",", "a_", ",", "i2___"}], "]"}], "[", "expr_", 
        "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SMP", "[", 
        RowBox[{"metric", ",", "c", ",", "a"}], "]"}], 
       RowBox[{"CM", "[", 
        RowBox[{"rest", " ", 
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"i1", ",", "b", ",", "i2"}], "]"}], "[", "expr", "]"}]}], 
        "]"}]}], "/;", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"c", ",", "a"}], "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"aud", "||", 
         RowBox[{"DownIndexQ", "[", "b", "]"}]}], ")"}], "&&", 
       RowBox[{"PRJ", "[", 
        RowBox[{"nv", ",", "covd", ",", "metric"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"prod_", "?", "ProductQ"}], "[", 
        RowBox[{"left___", ",", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
          RowBox[{"i1___", ",", "a_", ",", "i2___"}], "]"}], ",", 
         "right___"}], "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SMP", "[", 
        RowBox[{"metric", ",", "c", ",", "a"}], "]"}], 
       RowBox[{"CM", "[", 
        RowBox[{"rest", " ", 
         RowBox[{"prod", "[", 
          RowBox[{"left", ",", 
           RowBox[{"tensor", "[", 
            RowBox[{"i1", ",", "b", ",", "i2"}], "]"}], ",", "right"}], 
          "]"}]}], "]"}]}], "/;", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"c", ",", "a"}], "]"}], "&&", 
       RowBox[{"PRJ", "[", 
        RowBox[{"nv", ",", "tensor", ",", "metric"}], "]"}], " ", "&&", 
       RowBox[{
        RowBox[{"ScalarsOfProduct", "[", "prod", "]"}], "[", 
        RowBox[{"metric", "[", 
         RowBox[{"b", ",", "c"}], "]"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"First", " ", "index", " ", "of", " ", "metric"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
        RowBox[{"i1___", ",", "a_", ",", "i2___"}], "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SMP", "[", 
        RowBox[{"metric", ",", "a", ",", "b"}], "]"}], 
       RowBox[{"CM", "[", 
        RowBox[{"rest", " ", 
         RowBox[{"tensor", "[", 
          RowBox[{"i1", ",", "c", ",", "i2"}], "]"}]}], "]"}]}], "/;", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "&&", 
       RowBox[{"PRJ", "[", 
        RowBox[{"nv", ",", "tensor", ",", "metric"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", 
         RowBox[{"i1___", ",", "a_", ",", "i2___"}], "]"}], "[", "expr_", 
        "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SMP", "[", 
        RowBox[{"metric", ",", "a", ",", "b"}], "]"}], 
       RowBox[{"CM", "[", 
        RowBox[{"rest", " ", 
         RowBox[{
          RowBox[{"covd", "[", 
           RowBox[{"i1", ",", "c", ",", "i2"}], "]"}], "[", "expr", "]"}]}], 
        "]"}]}], "/;", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"aud", "||", 
         RowBox[{"DownIndexQ", "[", "c", "]"}]}], ")"}], "&&", 
       RowBox[{"PRJ", "[", 
        RowBox[{"nv", ",", "covd", ",", "metric"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"prod_", "?", "ProductQ"}], "[", 
        RowBox[{"left___", ",", 
         RowBox[{
          RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
          RowBox[{"i1___", ",", "a_", ",", "i2___"}], "]"}], ",", 
         "right___"}], "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"SMP", "[", 
        RowBox[{"metric", ",", "a", ",", "b"}], "]"}], 
       RowBox[{"CM", "[", 
        RowBox[{"rest", " ", 
         RowBox[{"prod", "[", 
          RowBox[{"left", ",", 
           RowBox[{"tensor", "[", 
            RowBox[{"i1", ",", "c", ",", "i2"}], "]"}], ",", "right"}], 
          "]"}]}], "]"}]}], "/;", 
      RowBox[{
       RowBox[{"PairQ", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "&&", 
       RowBox[{"PRJ", "[", 
        RowBox[{"nv", ",", "tensor", ",", "metric"}], "]"}], " ", "&&", 
       RowBox[{
        RowBox[{"ScalarsOfProduct", "[", "prod", "]"}], "[", 
        RowBox[{"metric", "[", 
         RowBox[{"b", ",", "c"}], "]"}], "]"}]}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b3a09983-a66d-4c58-a82b-46899c43970a"],

Cell["\<\
We are assuming that the metric factors are outside the prod[...] expression \
and multiplied by Times. Only in that case we will absorb the metric.\
\>", "Text",ExpressionUUID->"f3b970be-62ad-4881-b3a1-e68bd3af695a"],

Cell["\<\
Inert heads. I think this must be converted into some better notation for \
contraction of induced derivatives. Note that we pass the control to another \
function called ContractMetric2, defined before. April 2012: Removed \
SMP[metric, c, -c] from first definition and SMP[metric, -b, b] from the \
second one, because the sign is handled by ContractMetric2. Thanks to Thomas \
for catching the problem.\
\>", "Text",ExpressionUUID->"d519ac93-2138-4e1b-a8bd-2ab63ca6275b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Second", " ", "index", " ", "of", " ", "metric"}], " ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"head_", "?", "InertHeadQ"}], "[", 
        RowBox[{"expr_", ",", "z___"}], "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CM", "[", 
       RowBox[{"rest", " ", 
        RowBox[{"head", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ContractMetric2", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"od", ",", "aud"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"metric", ",", "nv", ",", 
               RowBox[{"IsIndexOf", "[", 
                RowBox[{"expr", ",", 
                 RowBox[{"-", "b"}], ",", "metric"}], "]"}]}], "}"}]}], "]"}],
            "[", 
           RowBox[{"expr", ",", 
            RowBox[{"metric", "[", 
             RowBox[{"b", ",", "c"}], "]"}]}], "]"}], ",", 
          RowBox[{"contractz", "[", 
           RowBox[{
            RowBox[{"{", "z", "}"}], ",", 
            RowBox[{"-", "c"}], ",", "b"}], "]"}]}], "]"}]}], "]"}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{
        RowBox[{"head", "[", 
         RowBox[{"expr", ",", "z"}], "]"}], ",", 
        RowBox[{"-", "c"}], ",", "metric"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"First", " ", "index", " ", "of", " ", "metric"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"CM", ":", 
        RowBox[{"ContractMetric1", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"od_", ",", "aud_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"metric_", ",", "nv_"}], "}"}]}], "]"}]}], ")"}], "[", 
      RowBox[{"rest_.", " ", 
       RowBox[{
        RowBox[{"head_", "?", "InertHeadQ"}], "[", 
        RowBox[{"expr_", ",", "z___"}], "]"}], 
       RowBox[{"metric_", "[", 
        RowBox[{"b_", ",", "c_"}], "]"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"CM", "[", 
       RowBox[{"rest", " ", 
        RowBox[{"head", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ContractMetric2", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"od", ",", "aud"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"metric", ",", "nv", ",", 
               RowBox[{"IsIndexOf", "[", 
                RowBox[{"expr", ",", 
                 RowBox[{"-", "c"}], ",", "metric"}], "]"}]}], "}"}]}], "]"}],
            "[", 
           RowBox[{"expr", ",", 
            RowBox[{"metric", "[", 
             RowBox[{"b", ",", "c"}], "]"}]}], "]"}], ",", 
          RowBox[{"contractz", "[", 
           RowBox[{
            RowBox[{"{", "z", "}"}], ",", 
            RowBox[{"-", "b"}], ",", "c"}], "]"}]}], "]"}]}], "]"}], "/;", 
      RowBox[{"IsIndexOf", "[", 
       RowBox[{
        RowBox[{"head", "[", 
         RowBox[{"expr", ",", "z"}], "]"}], ",", 
        RowBox[{"-", "b"}], ",", "metric"}], "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d5e24bb9-2823-4c05-a312-338f1a3548ca"],

Cell["\<\
Contraction in the indexed arguments (marked with IndexList):\
\>", "Text",ExpressionUUID->"7d83f9fc-b3c2-43cb-ae5e-da9d1d16d1e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Arrange", " ", "change", " ", "of", " ", "indices", " ", "in", " ", "the",
     " ", "additional", " ", "z", " ", "arguments"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"contractz", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "_", ",", "_"}], "]"}], ":=", 
     RowBox[{"Sequence", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"contractz", "[", 
      RowBox[{"zlist_List", ",", "index1_", ",", "index2_"}], "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"Sequence", ",", 
       RowBox[{"zlist", "/.", 
        RowBox[{
         RowBox[{"IndexList", "[", 
          RowBox[{"i1___", ",", "index1", ",", "i2___"}], "]"}], "\[Rule]", 
         RowBox[{"IndexList", "[", 
          RowBox[{"i1", ",", "index2", ",", "i2"}], "]"}]}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d2f747ae-8976-414c-84ae-ed14b8dadffa"],

Cell["\<\
Finally we have the default case, which is used when none of the above \
definitions holds:\
\>", "Text",ExpressionUUID->"00456723-96d3-4ea9-a690-907f214fa35c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Default", " ", "case"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ContractMetric1", "[", "__", "]"}], "[", "expr_", "]"}], ":=", 
    "expr"}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"921998fa-1807-4d45-9773-ce722e314b35"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2.5. SeparateMetric. Old code", \
"Subsubsection",ExpressionUUID->"7386552c-f0ee-4d1e-898b-218486b93bfe"],

Cell["\<\
This is the opposite action to ContractMetric. We want to extract indices \
from tensor expressions using a metric, and hence changing the character of \
the index on the tensor. We need to introduce a new index, which could be an \
abstract index or a basis index for a given basis. The syntax is complicated \
because we need three pieces of information on top of the expression: \
SeparateMetric[metric, basis][expr, indices]\
\>", "Text",ExpressionUUID->"f185d49a-0ebe-4255-ba30-3c14d5e47ae3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Shortcuts", " ", "to", " ", "2"}], "+", 
    RowBox[{"2", " ", "arguments", " ", "and", " ", "errors"}]}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "]"}], "[", "]"}], ":=", 
     RowBox[{"Throw", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "]"}], "[", "args__", "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"Automatic", ",", "AIndex"}], "]"}], "[", "args", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "metric_", "]"}], "[", "args__", "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "AIndex"}], "]"}], "[", "args", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "All"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{"IndicesOf", "[", "]"}], "[", "expr", "]"}]}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"vb_", "?", "VBundleQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{
       RowBox[{"IndicesOf", "[", "vb", "]"}], "[", "expr", "]"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"basis2_Symbol", "?", "BasisQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{"IndicesOf", "[", "basis2", "]"}], "[", "expr", "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"_", ",", "_", ",", "__"}], "]"}], "[", "__", "]"}], ":=", 
     RowBox[{"Throw", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Thread", " ", "over", " ", "sums"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_Plus", ",", "indices_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"SeparateMetric", "[", 
         RowBox[{"metric", ",", "basis"}], "]"}], "[", 
        RowBox[{"#", ",", "indices"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "IndicesOf", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "f_IndicesOf"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", 
       RowBox[{"f", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Indices", " ", "not", " ", "in", " ", "their", " ", "original", " ", 
     "character"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", "Automatic"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "Automatic"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tensors", "=", 
          RowBox[{"FindAllOfType", "[", 
           RowBox[{"expr", ",", "Tensor"}], "]"}]}], ",", 
         RowBox[{"covds", "=", 
          RowBox[{"FindAllOfType", "[", 
           RowBox[{"expr", ",", "CovD"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"SeparateMetric", "[", 
         RowBox[{"metric", ",", "basis"}], "]"}], "[", 
        RowBox[{"expr", ",", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Apply", "[", 
           RowBox[{"IndexList", ",", 
            RowBox[{"movedindices", "/@", 
             RowBox[{"Join", "[", 
              RowBox[{"tensors", ",", "covds"}], "]"}]}]}], "]"}]}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Expand", " ", "list", " ", "of", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "list_IndexList"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{"SeparateMetric", "[", 
        RowBox[{"metric", ",", "basis"}], "]"}], ",", "expr", ",", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"list", ",", 
         RowBox[{"_LI", "|", 
          RowBox[{"-", "_LI"}]}]}], "]"}]}], "]"}]}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"1d2f5f92-d101-4efc-9412-45de2d113521"],

Cell["\<\
Note: Apply[Join,somelist] replaced by Flatten@Apply[IndexList,somelist] \
because if somelist is empty then we get List[], instead of the expected \
IndexList[]. This is because Join[] gives List[]. Thanks to Torsten for \
reporting this problem in the xAct group.\
\>", "Text",ExpressionUUID->"e2feea92-29c6-415d-8c4f-241423a950fc"],

Cell["\<\
The function movedindices selects the indices which are not in their original \
character (given at definition time):\
\>", "Text",ExpressionUUID->"7914acc5-5f85-423e-b868-e732aa248249"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tensors", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"Basis", "[", 
       RowBox[{"_", ",", "_"}], "]"}], "]"}], ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"delta", "[", 
       RowBox[{"_", ",", "_"}], "]"}], "]"}], ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor", ",", 
       RowBox[{"IndexList", "[", "inds", "]"}], ",", 
       RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", 
       RowBox[{"SignedVBundleOfIndex", "/@", 
        RowBox[{"{", "inds", "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{
       RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
     RowBox[{"movedindices", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor_", ",", "inds_", ",", "slots1_", ",", "slots2_"}], 
      "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "slots1", "]"}], "=!=", 
        RowBox[{"Length", "[", "slots2", "]"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Validate", "::", "error"}], ",", 
          RowBox[{"\"\<Wrong number of indices of tensor \>\"", "<>", 
           RowBox[{"ToString", "[", "tensor", "]"}]}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"inds", "[", 
        RowBox[{"[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"Apply", "[", 
             RowBox[{"samevbQ", ",", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"slots1", ",", "slots2"}], "}"}], "]"}], ",", "1"}], 
             "]"}], ",", "False"}], "]"}], "]"}], "]"}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"samevbQ", "[", 
     RowBox[{"vb_", ",", "vb_"}], "]"}], ":=", "True"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{
       RowBox[{"vb_", "?", "VBundleQ"}], ",", "All"}], "]"}], ":=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{"All", ",", 
       RowBox[{"vb_", "?", "VBundleQ"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"vb_", "?", "VBundleQ"}]}], ",", 
       RowBox[{"-", "All"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{
       RowBox[{"-", "All"}], ",", 
       RowBox[{"-", 
        RowBox[{"vb_", "?", "VBundleQ"}]}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "CovDs", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", "inds___", "]"}], "[", "_", 
       "]"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"IndexList", "[", "inds", "]"}], ",", "UpIndexQ"}], "]"}]}], 
    ";"}]}]}]], \
"Input",ExpressionUUID->"77a21351-a916-4a85-84f2-779b8cdb396c"],

Cell["\<\
From now on we always have an elementary situation of the form \
SeparateMetric[metric, basis][expr, index] , which means that in the \
expression expr we want to separate the given index using the given metric \
and introducing a new dummy index belonging to the given basis (by default it \
is AIndex, understood as the \"basis\" for abstract indices).
If the metric is Automatic then the first-metric of the vbundle of the index \
is used. In other cases we check consistency between the index and the \
metric. This is all done by the subsidiary function SeparateBasis1 with three \
arguments in the first bracket:\
\>", "Text",ExpressionUUID->"d3256723-d79d-4996-92e9-759ef319eee0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric", "[", 
     RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"index_", "?", "GIndexQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis", ",", "metric", ",", 
      RowBox[{"FirstMetricOfVBundle", "[", 
       RowBox[{"VBundleOfIndex", "[", "index", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"expr", ",", "index"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"fc1e908f-2f41-48db-87a4-a373f7ae7231"],

Cell["\<\
As noticed by Thomas, this does not work with induced metrics, and it should \
work.\
\>", "Text",ExpressionUUID->"14dcee6f-68e3-48cb-a83b-ec885eb28492"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", "Automatic", ",", "metric1_"}], "]"}], "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SeparateMetric2", "[", 
     RowBox[{"basis", ",", "metric1"}], "]"}], "[", 
    RowBox[{"expr", ",", "index"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", "metric1_", ",", "metric1_"}], "]"}], "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SeparateMetric2", "[", 
     RowBox[{"basis", ",", "metric1"}], "]"}], "[", 
    RowBox[{"expr", ",", "index"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", 
      RowBox[{"frozen_", "?", "FrozenMetricQ"}], ",", "metric1_"}], "]"}], 
    "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric2", "[", 
      RowBox[{"basis", ",", "frozen"}], "]"}], "[", 
     RowBox[{"expr", ",", "index"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"VBundleOfMetric", "[", "frozen", "]"}], "===", 
     RowBox[{"VBundleOfMetric", "[", "metric1", "]"}]}]}]}], 
  ";"}]}], "Input",ExpressionUUID->"e7c9e5d3-ed99-49dd-b059-a5d2e99247aa"],

Cell["\<\
Now we know that the metric and the index are consistent. We pass to the \
function SeparateMetric2:\
\>", "Text",ExpressionUUID->"c2a5626e-a2e8-4a64-b82a-e84f4ed71e75"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "SeparateMetric", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric2", "[", 
     RowBox[{"basis_", ",", "metric_"}], "]"}], "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
        RowBox[{"i1___", ",", "index", ",", "i2___"}], "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"dummy", "=", 
           RowBox[{"DummyAs", "[", 
            RowBox[{"index", ",", "basis"}], "]"}]}], "}"}], ",", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"UpIndexQ", "[", "index", "]"}], ",", 
            RowBox[{"metric", "[", 
             RowBox[{"index", ",", "dummy"}], "]"}], ",", 
            RowBox[{"metric", "[", 
             RowBox[{"dummy", ",", "index"}], "]"}]}], "]"}], 
          RowBox[{"tensor", "[", 
           RowBox[{"i1", ",", 
            RowBox[{"ChangeIndex", "[", "dummy", "]"}], ",", "i2"}], 
           "]"}]}]}], "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", 
         RowBox[{"i1___", ",", "index", ",", "i2___"}], "]"}], "[", "expr1_", 
        "]"}], "\[RuleDelayed]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"dummy", "=", 
           RowBox[{"DummyAs", "[", 
            RowBox[{"index", ",", "basis"}], "]"}]}], "}"}], ",", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"UpIndexQ", "[", "index", "]"}], ",", 
            RowBox[{"metric", "[", 
             RowBox[{"index", ",", "dummy"}], "]"}], ",", 
            RowBox[{"metric", "[", 
             RowBox[{"dummy", ",", "index"}], "]"}]}], "]"}], 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"i1", ",", 
             RowBox[{"ChangeIndex", "[", "dummy", "]"}], ",", "i2"}], "]"}], 
           "[", "expr1", "]"}]}]}], "]"}]}]}], 
     "}"}]}]}]}]], \
"Input",ExpressionUUID->"5c295324-1827-4e91-b03e-bbb58f0af754"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2.5. SeparateMetric. New code", \
"Subsubsection",ExpressionUUID->"bd466f4b-5c83-4aef-81f7-7ffba4ad22ca"],

Cell["\<\
This is the opposite action to ContractMetric. We want to extract indices \
from tensor expressions using a metric, and hence changing the character of \
the index on the tensor. We need to introduce a new index, which could be an \
abstract index or a basis index for a given basis. The syntax is complicated \
because we need three pieces of information on top of the expression: \
SeparateMetric[metric, basis][expr, indices].

If we specify an index, the metric will be separated in that index, even if \
the action changes a slot from its natural character to its dual. If we do \
not specify indices, the default action is bringing all tensor slots to their \
natural characters.

SeparateMetric is a function that acts directly on individual objects, and \
hence the first thing we need to do is localizing its action on those objects.\
\>", "Text",ExpressionUUID->"86e50d32-50c3-4e4f-8b30-00b82c61fb53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Locate", " ", "individual", " ", "tensors"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "args1___", "]"}], "[", 
      RowBox[{"expr_Plus", ",", "args2___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"SeparateMetric", "[", "args1", "]"}], "[", 
        RowBox[{"#", ",", "args2"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "args1___", "]"}], "[", 
      RowBox[{"expr_SeriesData", ",", "args2___"}], "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"SeparateMetric", "[", "args1", "]"}], "[", 
         RowBox[{"#", ",", "args2"}], "]"}], "&"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "args1___", "]"}], "[", 
      RowBox[{"expr_Times", ",", "args2___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"SeparateMetric", "[", "args1", "]"}], "[", 
        RowBox[{"#", ",", "args2"}], "]"}], "&"}], "/@", "expr"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5e6f6791-01a3-4592-a652-40ed9ff4245e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Shortcuts", " ", "to", " ", "2", " ", "arguments", " ", "in", " ", "the", 
    " ", "first", " ", "pair", " ", "of", " ", "brackets"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "]"}], "[", "args__", "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"Automatic", ",", "AIndex"}], "]"}], "[", "args", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "metric_", "]"}], "[", "args__", "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "AIndex"}], "]"}], "[", "args", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Second", " ", "argument", " ", "of", " ", "the", " ", "second", " ", 
     "pair", " ", "of", " ", "brackets"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "All"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{"IndicesOf", "[", "]"}], "[", "expr", "]"}]}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"vb_", "?", "VBundleQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{
       RowBox[{"IndicesOf", "[", "vb", "]"}], "[", "expr", "]"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"basis2_Symbol", "?", "BasisQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{"IndicesOf", "[", "basis2", "]"}], "[", "expr", "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "f_IndicesOf"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", 
       RowBox[{"f", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Default", " ", "action", " ", "of", " ", "the", " ", "second", " ", 
     RowBox[{"argument", ":", " ", 
      RowBox[{
      "Indices", " ", "not", " ", "in", " ", "their", " ", "original", " ", 
       "character"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric", ",", "basis"}], "]"}], "[", 
      RowBox[{"expr", ",", "Automatic"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "Automatic"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tensors", "=", 
          RowBox[{"FindAllOfType", "[", 
           RowBox[{"expr", ",", "Tensor"}], "]"}]}], ",", 
         RowBox[{"covds", "=", 
          RowBox[{"FindAllOfType", "[", 
           RowBox[{"expr", ",", "CovD"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"SeparateMetric", "[", 
         RowBox[{"metric", ",", "basis"}], "]"}], "[", 
        RowBox[{"expr", ",", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Apply", "[", 
           RowBox[{"IndexList", ",", 
            RowBox[{"movedindices", "/@", 
             RowBox[{"Join", "[", 
              RowBox[{"tensors", ",", "covds"}], "]"}]}]}], "]"}]}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Expand", " ", "list", " ", "of", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
      RowBox[{"expr_", ",", "list_IndexList"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{"SeparateMetric", "[", 
        RowBox[{"metric", ",", "basis"}], "]"}], ",", "expr", ",", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"list", ",", 
         RowBox[{"_LI", "|", 
          RowBox[{"-", "_LI"}]}]}], "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8f5bff77-0072-4999-b02d-0a8ba5982b95"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Errors", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "___", "]"}], "[", "]"}], ":=", 
     RowBox[{"Throw", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", 
       RowBox[{"_", ",", "_", ",", "__"}], "]"}], "[", "__", "]"}], ":=", 
     RowBox[{"Throw", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric", "[", "___", "]"}], "[", 
      RowBox[{"_", ",", "_", ",", "__"}], "]"}], ":=", 
     RowBox[{"Throw", "[", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"64d8eddd-3584-41c1-8f87-a1c18438e505"],

Cell["\<\
Note: Apply[Join,somelist] replaced by Flatten@Apply[IndexList,somelist] \
because if somelist is empty then we get List[], instead of the expected \
IndexList[]. This is because Join[] gives List[]. Thanks to Torsten for \
reporting this problem in the xAct group.\
\>", "Text",ExpressionUUID->"dd6a6565-d5d6-4208-b4d8-5349d28d59d3"],

Cell["\<\
The function movedindices selects the indices which are not in their original \
character (given at definition time):\
\>", "Text",ExpressionUUID->"d18ba88c-2260-448e-935e-a2a977979b7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Tensors", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"Basis", "[", 
       RowBox[{"_", ",", "_"}], "]"}], "]"}], ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"delta", "[", 
       RowBox[{"_", ",", "_"}], "]"}], "]"}], ":=", 
     RowBox[{"IndexList", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor", ",", 
       RowBox[{"IndexList", "[", "inds", "]"}], ",", 
       RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], ",", 
       RowBox[{"SignedVBundleOfIndex", "/@", 
        RowBox[{"{", "inds", "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"TODO", ":", " ", 
     RowBox[{"I", " ", 
      RowBox[{"don", "'"}], "t", " ", "think", " ", "we", " ", "need", " ", 
      "this", " ", "definition"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{
       RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
     RowBox[{"movedindices", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor_", ",", "inds_", ",", 
       RowBox[{"slots1", ":", 
        RowBox[{"{", 
         RowBox[{"AnyIndices", "[", "vb_", "]"}], "}"}]}], ",", "slots2_"}], 
      "]"}], ":=", 
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor", ",", "inds", ",", 
       RowBox[{"Table", "[", 
        RowBox[{"vb", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "slots2", "]"}], "}"}]}], "]"}], ",", 
       "slots2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor_", ",", "inds_", ",", 
       RowBox[{"slots1", ":", 
        RowBox[{"{", 
         RowBox[{"l___", ",", "a_AnyIndices", ",", "r___"}], "}"}]}], ",", 
       "slots2_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ll", "=", 
          RowBox[{"Length", "[", 
           RowBox[{"{", "l", "}"}], "]"}]}], ",", 
         RowBox[{"rl", "=", 
          RowBox[{"Length", "[", 
           RowBox[{"{", "r", "}"}], "]"}]}], ",", 
         RowBox[{"sl", "=", 
          RowBox[{"Length", "[", "slots2", "]"}]}]}], "}"}], ",", " ", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"movedindices", "[", 
          RowBox[{"tensor", ",", "inds", ",", 
           RowBox[{"{", "l", "}"}], ",", 
           RowBox[{"Take", "[", 
            RowBox[{"slots2", ",", "ll"}], "]"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"movedindices", "[", 
          RowBox[{"tensor", ",", "inds", ",", 
           RowBox[{"{", "a", "}"}], ",", 
           RowBox[{"Take", "[", 
            RowBox[{"slots2", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"ll", "+", "1"}], ",", 
               RowBox[{"sl", "-", "rl"}]}], "}"}]}], "]"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"movedindices", "[", 
          RowBox[{"tensor", ",", "inds", ",", 
           RowBox[{"{", "r", "}"}], ",", 
           RowBox[{"Take", "[", 
            RowBox[{"slots2", ",", 
             RowBox[{"rl", "-", "sl"}]}], "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{"tensor_", ",", "inds_", ",", "slots1_", ",", "slots2_"}], 
      "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "slots1", "]"}], "=!=", 
        RowBox[{"Length", "[", "slots2", "]"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Validate", "::", "error"}], ",", 
          RowBox[{"\"\<Wrong number of indices of tensor \>\"", "<>", 
           RowBox[{"ToString", "[", "tensor", "]"}]}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"inds", "[", 
        RowBox[{"[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"Apply", "[", 
             RowBox[{"samevbQ", ",", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"slots1", ",", "slots2"}], "}"}], "]"}], ",", "1"}], 
             "]"}], ",", "False"}], "]"}], "]"}], "]"}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Special", " ", "definition", " ", "for", " ", "Gdelta"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Gdelta", "/:", 
     RowBox[{"movedindices", "[", "gd_Gdelta", "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"il", "=", 
          RowBox[{"IndexList", "@@", "gd"}]}], ",", 
         RowBox[{"n", "=", 
          RowBox[{
           RowBox[{"Length", "[", "gd", "]"}], "/", "2"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Take", "[", 
            RowBox[{"il", ",", "n"}], "]"}], ",", "UpIndexQ"}], "]"}], ",", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{"il", ",", "n"}], "]"}], ",", "DownIndexQ"}], "]"}]}], 
        "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "CovDs", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"movedindices", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", "inds___", "]"}], "[", "expr_", 
       "]"}], "]"}], ":=", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"IndexList", "[", "inds", "]"}], ",", "UpIndexQ"}], "]"}], 
       ",", 
       RowBox[{"movedindices", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Individual", " ", "vbundles"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"samevbQ", "[", 
     RowBox[{"vb_", ",", "vb_"}], "]"}], ":=", "True"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{
       RowBox[{"vb_", "?", "VBundleQ"}], ",", "All"}], "]"}], ":=", "True"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{"All", ",", 
       RowBox[{"vb_", "?", "VBundleQ"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"vb_", "?", "VBundleQ"}]}], ",", 
       RowBox[{"-", "All"}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{
       RowBox[{"-", "All"}], ",", 
       RowBox[{"-", 
        RowBox[{"vb_", "?", "VBundleQ"}]}]}], "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"samevbQ", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"35639a4e-0ec8-4d69-bd6d-a4636133fd14"],

Cell["\<\
From now on we always have an elementary situation of the form \
SeparateMetric[metric, basis][expr, index] , which means that in the \
expression expr we want to separate the given index using the given metric \
and introducing a new dummy index belonging to the given basis (by default it \
is AIndex, understood as the \"basis\" for abstract indices).
If the metric is Automatic then the first-metric of the vbundle of the index \
is used. In other cases we check consistency between the index and the \
metric. This is all done by the subsidiary function SeparateBasis1 with three \
arguments in the first bracket:\
\>", "Text",ExpressionUUID->"17397f4b-eb95-45e6-9fce-6e1d86a79846"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric", "[", 
     RowBox[{"metric_", ",", "basis_"}], "]"}], "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"index_", "?", "GIndexQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis", ",", "metric", ",", 
      RowBox[{"FirstMetricOfVBundle", "[", 
       RowBox[{"VBundleOfIndex", "[", "index", "]"}], "]"}]}], "]"}], "[", 
    RowBox[{"expr", ",", "index"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"15977ccb-e4a2-48c5-b9bd-1b40f03b3edf"],

Cell["\<\
As noticed by Thomas, this does not work with induced metrics, and it should \
work.\
\>", "Text",ExpressionUUID->"816e7c90-de40-410a-b91a-c52357673cfb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", "Automatic", ",", "metric1_"}], "]"}], "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SeparateMetric2", "[", 
     RowBox[{"basis", ",", "metric1"}], "]"}], "[", 
    RowBox[{"expr", ",", "index"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", "metric1_", ",", "metric1_"}], "]"}], "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric2", "[", 
      RowBox[{"basis", ",", "metric1"}], "]"}], "[", 
     RowBox[{"expr", ",", "index"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"VBundleOfMetric", "[", "metric1", "]"}], "===", 
     RowBox[{"VBundleOfIndex", "[", "index", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", "metric_", ",", "metric1_"}], "]"}], "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", "expr"}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"323153d1-bfdf-4c56-be0e-9e6fa3ef26a2"],

Cell["\<\
These two definitions have created much confusion. They now seem too \
dangerous to me, so I remove them from the package (Jose, 21 Feb 2021):\
\>", "Text",ExpressionUUID->"fbc70c69-669c-4c58-8d70-09ea9d246938"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SeparateMetric1", "[", 
    RowBox[{"basis_", ",", "metric_", ",", "metric1_"}], "]"}], "[", 
   RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
  RowBox[{"SeparateMetric2", "[", 
   RowBox[{"basis", ",", "metric"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SeparateMetric1", "[", 
     RowBox[{"basis_", ",", 
      RowBox[{"frozen_", "?", "FrozenMetricQ"}], ",", "metric1_"}], "]"}], 
    "[", 
    RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric2", "[", 
      RowBox[{"basis", ",", "frozen"}], "]"}], "[", 
     RowBox[{"expr", ",", "index"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"VBundleOfMetric", "[", "frozen", "]"}], "===", 
     RowBox[{"VBundleOfMetric", "[", "metric1", "]"}]}]}]}], ";"}]}], "Input",
 
 Evaluatable->False,ExpressionUUID->"12f37968-2bf8-47d9-96f7-318912c79609"],

Cell["\<\
Now we know that the metric and the index are consistent. We pass to the \
function SeparateMetric2:\
\>", "Text",ExpressionUUID->"e3c75301-62de-4161-892f-3b76a3db244f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "SeparateMetric", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeparateMetric2", "[", 
       RowBox[{"AIndex", ",", "metric_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"metric_", "[", 
        RowBox[{"i1_", ",", "i2_"}], "]"}], ",", "index_"}], "]"}], ":=", 
     RowBox[{"metric", "[", 
      RowBox[{"i1", ",", "i2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SeparateMetric2", "[", 
      RowBox[{"basis_", ",", "metric_"}], "]"}], "[", 
     RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
    RowBox[{"expr", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], "[", 
         RowBox[{"i1___", ",", "index", ",", "i2___"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"dummy", "=", 
            RowBox[{"DummyAs", "[", 
             RowBox[{"index", ",", "basis"}], "]"}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"UpIndexQ", "[", "index", "]"}], ",", 
             RowBox[{"metric", "[", 
              RowBox[{"index", ",", "dummy"}], "]"}], ",", 
             RowBox[{"metric", "[", 
              RowBox[{"dummy", ",", "index"}], "]"}]}], "]"}], 
           RowBox[{"tensor", "[", 
            RowBox[{"i1", ",", 
             RowBox[{"ChangeIndex", "[", "dummy", "]"}], ",", "i2"}], 
            "]"}]}]}], "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"covd_", "?", "CovDQ"}], "[", 
          RowBox[{"i1___", ",", "index", ",", "i2___"}], "]"}], "[", "expr1_",
          "]"}], "\[RuleDelayed]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"dummy", "=", 
            RowBox[{"DummyAs", "[", 
             RowBox[{"index", ",", "basis"}], "]"}]}], "}"}], ",", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"UpIndexQ", "[", "index", "]"}], ",", 
             RowBox[{"metric", "[", 
              RowBox[{"index", ",", "dummy"}], "]"}], ",", 
             RowBox[{"metric", "[", 
              RowBox[{"dummy", ",", "index"}], "]"}]}], "]"}], 
           RowBox[{
            RowBox[{"covd", "[", 
             RowBox[{"i1", ",", 
              RowBox[{"ChangeIndex", "[", "dummy", "]"}], ",", "i2"}], "]"}], 
            "[", "expr1", "]"}]}]}], "]"}]}]}], "}"}]}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"be07195e-ac77-4117-9e3e-9da21733140f"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.2.6. Examples", \
"Subsubsection",ExpressionUUID->"c95f11e4-5a4b-412a-9662-827ed3783f8c"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"ea715af6-5a25-4c69-86ae-1d734db25fd1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CdM", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"7dd300e3-b9f5-4d2a-8525-59ea902507c9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a81b0fda-195c-4763-840b-619bce6aca9f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"68d6ad3a-bb8b-4ef7-9264-3064c70e6433"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"051a7581-0a63-4c6f-bae6-e70f9a9c8bf9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ea263df4-f6b5-4e8a-b915-f326b7b237e8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"15fa2c35-cdc2-4feb-922a-aa0e03c2d6b8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"386fd79a-8580-450a-8a4c-f3c2f3af7861"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6f218279-b40c-4890-bd36-a7bd0d1d705e"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"2e5df33c-12d3-4065-aaf0-65483935fb36"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3a725b95-c875-4865-97b2-7e1ff07e7090"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"50612aae-06ee-4327-9873-53715871c2de"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e118f541-f179-4020-9237-f3435eb32ed5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6ac60c86-d366-44f9-84a3-9e5cad9b7431"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7998864e-3dc3-4e63-9c1d-2e3877a79efe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b1a16c87-6443-40e4-a320-bf03c5842dbd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"8cada8bd-f1e6-4f93-9201-75f873663b78"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"db165c49-a1db-49fc-99e8-2262ec3929d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"a5c875c4-a39f-4e73-9a8b-c1428c99eda2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetricg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetricg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"19e11dd3-7d42-4fc1-863b-8c2ba9dde68b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"72df5e04-6568-45a2-abf0-c3e74101e172"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d93defa5-71eb-413f-97e7-f252cdd315ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "B"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"be3ae52a-5214-4f52-8b44-e2d5a8c158a1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", "A"},
         {"C", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[-C, $CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"39120c72-541a-4566-a172-73641e8b2e37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "Polar"}]}], "}"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"C", ",", "Polar"}], "}"}]}], "]"}]}], "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"1d3531be-a07b-41de-978b-4d60c957e524"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", 
          StyleBox["C",
           FontColor->RGBColor[0., 0., 1.]]},
         {"B", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[-$CellContext`B, {C, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"c031f2ae-c42f-49f4-9c08-25e1a4847f36"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], 
   RowBox[{
    RowBox[{"CdM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"{", 
       RowBox[{"C", ",", "Polar"}], "}"}]}], "]"}], "]"}]}], "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"e79100f1-f6ca-4a92-8111-e150fa8cd3e7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", 
          StyleBox["C",
           FontColor->RGBColor[0., 0., 1.]], "  "},
         {"B", " ", 
          RowBox[{"|", "D"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CdM[-D][
   $CellContext`T[-$CellContext`B, {C, $CellContext`Polar}]],
  Editable->
   False]], "Output",ExpressionUUID->"2c57cd98-b99c-4cba-a005-f4fe25c48fe2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "F"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CdM", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "H"}]}], "]"}], "]"}], "]"}], 
    RowBox[{"metricg", "[", 
     RowBox[{"C", ",", "G"}], "]"}]}], ",", "metricg"}], 
  "]"}]], "Input",ExpressionUUID->"1b5eaf17-9fd9-4a2d-819c-2f74c9e198ff"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"C", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[C, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", "  ", "  "},
          {"B", "H", 
           RowBox[{"|", "C"}], 
           RowBox[{"|", "F"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`F][
    $CellContext`CdM[-C][
     $CellContext`T[-$CellContext`B, -$CellContext`H]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"f8f4fdb5-4348-47c5-b5de-56aa2d962063"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "F"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CdM", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "H"}]}], "]"}], "]"}], "]"}], 
    RowBox[{"metricg", "[", 
     RowBox[{"C", ",", "G"}], "]"}]}], ",", "metricg", ",", 
   RowBox[{"AllowUpperDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"bcd7811c-a92f-42f4-900b-f992e191be8d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", " ", 
          RowBox[{"|", "G"}], "  "},
         {"B", "H", "  ", 
          RowBox[{"|", "F"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CdM[-$CellContext`F][
   $CellContext`CdM[$CellContext`G][
    $CellContext`T[-$CellContext`B, -$CellContext`H]]],
  Editable->
   False]], "Output",ExpressionUUID->"41a280fc-08f5-40c3-8cdb-dbb4a828ebfb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ContractMetric", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CdM", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "B"}], "]"}], "]"}], 
     RowBox[{
      RowBox[{"CdM", "[", 
       RowBox[{"-", "F"}], "]"}], "[", 
      RowBox[{
       RowBox[{"CdM", "[", 
        RowBox[{"-", "C"}], "]"}], "[", 
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "H"}]}], "]"}], "]"}], "]"}], 
     RowBox[{"metricg", "[", 
      RowBox[{"C", ",", "G"}], "]"}]}], ",", "metricg"}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"11359a8f-582d-4251-96b3-142fd2eb4a8a"],

Cell["metricg[C, G]*CdM[-D][T[A, B]]*CdM[-F][CdM[-C][T[-B, -H]]]", \
"Output",ExpressionUUID->"3e2bbaa7-383a-48f1-ae36-c7d51175ae12"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{"F", ",", "G"}], "]"}], 
    RowBox[{"metricg", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "A"}]}], "]"}], 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "F"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B", ",", "A"}], "]"}], "]"}]}], ",", "metricg"}], 
  "]"}]], "Input",ExpressionUUID->"d8d3f8b4-ce94-441b-9165-11d89575a3f9"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {"D", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-D, -$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"F", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`F, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "A", "  "},
          {" ", " ", 
           RowBox[{",", "F"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`F][
    $CellContext`T[$CellContext`B, $CellContext`A]],
   Editable->
    False]}]], "Output",ExpressionUUID->"b6c7c4ec-b303-4e3d-aea6-0a4eed8172d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{"F", ",", "G"}], "]"}], 
    RowBox[{"metricg", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "A"}]}], "]"}], 
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "F"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B", ",", "A"}], "]"}], "]"}]}], ",", "metricg"}], 
  "]"}]], "Input",ExpressionUUID->"c05367de-3643-4eee-b01a-1157d703b190"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"F", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`F, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", " ", "  "},
          {" ", "D", 
           RowBox[{"|", "F"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`F][
    $CellContext`T[$CellContext`B, -D]],
   Editable->
    False]}]], "Output",ExpressionUUID->"7d12858e-41e8-46a4-a4d6-75f1a9895233"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`ContractMetric1", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"False", ",", "False"}], "}"}], ",", "False", ",", "metricg"}], 
   "]"}], "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
    RowBox[{"T", "[", "B", "]"}], "]"}], 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"21ee37c6-8dd8-415d-b332-0a2db7d05765"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"59e9da4b-b646-44a6-b4e0-1c39c65d0ad9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CdM", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "]"}], 
  RowBox[{
   RowBox[{"CdM", "[", 
    RowBox[{"-", "F"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CdM", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "H"}]}], "]"}], "]"}], "]"}], 
  RowBox[{"metricg", "[", 
   RowBox[{"C", ",", "G"}], 
   "]"}]}]], "Input",ExpressionUUID->"ead4ec1c-b077-47e4-bcd1-97c7c8c134b7"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"C", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[C, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B", "  "},
          {" ", " ", 
           RowBox[{"|", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", "  ", "  "},
          {"C", "H", 
           RowBox[{"|", "B"}], 
           RowBox[{"|", "F"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`F][
    $CellContext`CdM[-$CellContext`B][
     $CellContext`T[-C, -$CellContext`H]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"4e4ec6c9-f210-493b-b8a5-a1171301f8b5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", "metricg"}], 
  "]"}]], "Input",ExpressionUUID->"16674719-7d75-486d-aa60-6d65d82c535d"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B", "  "},
          {" ", " ", 
           RowBox[{"|", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-D][
    $CellContext`T[$CellContext`A, $CellContext`B]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"G", " ", "  ", "  "},
          {" ", "H", 
           RowBox[{"|", "B"}], 
           RowBox[{"|", "F"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`F][
    $CellContext`CdM[-$CellContext`B][
     $CellContext`T[$CellContext`G, -$CellContext`H]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"fced7cf1-eee3-4d87-b096-edfefc101821"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ContractMetric", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"metricg", "[", 
      RowBox[{"C", ",", 
       RowBox[{"-", "B"}]}], "]"}]}], ",", "metricg"}], "]"}], "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"c6c863a1-decf-431b-b2d9-900e4cbcc097"],

Cell["T[A, C]", \
"Output",ExpressionUUID->"0a806858-55bb-49e7-bfc9-ddfc102261ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "C"}], "]"}], "]"}], 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "D"}]}], "]"}]}], "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"a2c78c7b-2ab5-4d68-9a6e-12b45821ef04"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`B, -D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "C", "  "},
          {" ", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[$CellContext`B, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"dc3e37b2-92b5-411e-bc2f-b482f6ced653"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", 
   RowBox[{"OverDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"e3894ab9-d984-4d4e-81a0-a627ca52d21b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "C"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B, C],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "D", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`metricg[-$CellContext`B, -D]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", "  "},
          {"D", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[-D, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"2cbe62be-4ef5-4e87-b12d-4afb1069435a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"B", ",", "C"}], "]"}], "]"}], "]"}], 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "D"}]}], "]"}]}], "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"a3f056f9-afa6-401e-89f7-34c006efc664"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`B, -D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "A"], 
     SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    xAct`xTensor`LieD[
     $CellContext`T[$CellContext`A]][
     $CellContext`T[$CellContext`B, C]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"3aa0b649-6aa1-4c4c-b176-8485fd9e3251"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", 
   RowBox[{"OverDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"242a1a87-b325-4939-ae7b-bd93f8b25996"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"B", "C"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`LieD[
       $CellContext`T[$CellContext`A]][
       $CellContext`T[$CellContext`B, C]],
      Editable->False], ")"}]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "D", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`metricg[-$CellContext`B, -D]],
    Editable->False]}], "-", 
  RowBox[{
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " "},
             {"B", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`T[$CellContext`A]][
      $CellContext`metricg[-$CellContext`B, -D]],
     Editable->False], ")"}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C", "  "},
           {" ", " ", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[$CellContext`B, C]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "A"], 
      SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " "},
            {"B", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     xAct`xTensor`LieD[
      $CellContext`T[$CellContext`A]][
      $CellContext`metricg[-$CellContext`B, -D]]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "A"], 
     SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "C"},
           {"D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    xAct`xTensor`LieD[
     $CellContext`T[$CellContext`A]][
     $CellContext`T[-D, C]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"b718bad9-01bc-433b-bade-347ea6844252"]
}, Open  ]],

Cell["With bases. Do many more tests:", \
"Text",ExpressionUUID->"64ab6955-581b-427b-8109-8c3d8933e170"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"B", ",", "Polar"}], "}"}], ",", "C"}], "]"}], "]"}], 
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"-", "D"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"d97a1dd0-a84e-49f2-a8e3-192472ef7005"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[{-$CellContext`B, -$CellContext`Polar}, -D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], "C", "  "},
          {" ", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[{$CellContext`B, $CellContext`Polar}, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"40776573-723d-4af5-9e83-2b0862821811"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"3f07a79b-6556-4d65-9fb6-8b223265863f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[{-$CellContext`B, -$CellContext`Polar}, -D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], "C", "  "},
          {" ", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[{$CellContext`B, $CellContext`Polar}, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"c870e17d-6825-460e-9a87-54ae43a46ba8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", 
   RowBox[{"OverDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"1ebd0b4c-960d-4e7c-ba64-4b65054f595c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {
             StyleBox["B",
              FontColor->RGBColor[0., 0., 1.]], "C"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[{$CellContext`B, $CellContext`Polar}, C],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {
            StyleBox["B",
             FontColor->RGBColor[0., 0., 1.]], "D", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`metricg[{-$CellContext`B, -$CellContext`Polar}, -D]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", "  "},
          {"D", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[-D, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"32586a3e-303f-49f9-96a7-4954cb596851"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"B", ",", "Polar"}], "}"}], ",", "C"}], "]"}], "]"}], 
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"-", "C"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"e1a80158-c67d-4fb2-86cf-b46ba69a1fd6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {
           StyleBox["D",
            FontColor->RGBColor[0., 0., 1.]], "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[{-D, -$CellContext`Polar}, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], "C", "  "},
          {" ", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[{$CellContext`B, $CellContext`Polar}, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"c812c09e-de33-4229-8ec0-4beca7e9f6f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"6c07aa8a-bd4b-41f2-aa76-23419e6e375b"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {
           StyleBox["D",
            FontColor->RGBColor[0., 0., 1.]], "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[{-D, -$CellContext`Polar}, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], "C", "  "},
          {" ", " ", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[{$CellContext`B, $CellContext`Polar}, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"3d56f6bc-a731-47f6-b020-a6b00da85e94"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", 
   RowBox[{"OverDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"d7588a4f-70d3-47c8-ace2-dd7370244819"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {
             StyleBox["B",
              FontColor->RGBColor[0., 0., 1.]], "C"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[{$CellContext`B, $CellContext`Polar}, C],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {
            StyleBox["D",
             FontColor->RGBColor[0., 0., 1.]], "C", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`metricg[{-D, -$CellContext`Polar}, -C]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["B",
            FontColor->RGBColor[0., 0., 1.]], " ", "  "},
          {" ", 
           StyleBox["D",
            FontColor->RGBColor[0., 0., 1.]], 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[{$CellContext`B, $CellContext`Polar}, {-
      D, -$CellContext`Polar}]],
   Editable->
    False]}]], "Output",ExpressionUUID->"410edfa2-0161-4856-be80-e9322bfc383a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$CovDs"], \
"Input",ExpressionUUID->"03ec1366-1af8-48a4-87ed-c42ae94b87fc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"PD", ",", "CdM"}], 
  "}"}]], "Output",ExpressionUUID->"1824fbde-abba-4fc8-9dfa-4caacf5b155f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"gg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CD", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"11bb1d30-2aaf-48fe-b45b-4cb1dc983c37"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "old"}], "MessageName"], ":", 
  " ", "\<\"There are already metrics \[NoBreak]\\!\\({metricg}\\)\[NoBreak] \
in vbundle \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]M2\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], TangentM2, Rule[Editable, False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8b7ce9c4-7f02-4a19-8df4-90794fbd2ccb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bfeff2ee-629e-49f1-a032-abd5fd2a2fd0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"inverse metric tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Invgg", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Metric is frozen!\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "inverse metric tensor ", 
   $CellContext`Invgg[$CellContext`A, $CellContext`B], ". ", 
   "Metric is frozen!"],
  Editable->
   False]], "Print",ExpressionUUID->"a7564f67-b4ef-42f5-848e-043fdef00178"],

Cell[BoxData["\<\"** DefMetric: Don't know yet how to define epsilon for a \
frozen metric.\"\>"], \
"Print",ExpressionUUID->"27dafd0d-b83f-45e4-9436-eec3ca331281"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"547bd21f-5c52-4756-ad32-d7614c796f50"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"06303bf7-803a-47b6-9472-ab4175256c53"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"a11c8f5a-82af-4f51-abe6-b1eb56b9ffcd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannDownCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannDownCD[-$CellContext`A, -$CellContext`B, -C, -D], ". ",
    ""],
  Editable->
   False]], "Print",ExpressionUUID->"ce742914-24e1-4d4f-a29f-ce7c63481207"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"a43022b7-cde0-4b11-91a2-b2996eb84260"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ae1fba14-48fc-4a5a-b580-140490771210"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"63d1c324-3aef-466f-b4e7-cc0efd1802a5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d3e9c44c-3a75-4d95-9758-a410cae6d9ca"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"b3224d8d-6787-44be-8b1f-012e08e99db6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c2febcb0-6517-4c0d-bc5a-bdb73b40e34d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCD[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"654ccbad-5fce-41eb-8731-b45d4b592a2e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a08a203b-ba27-42a1-a3c1-d8b21f07abbf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d61bb112-bb38-4da3-ad7e-3619ef0e4628"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"6dfaf76e-944b-431e-802f-dcc7fcb25068"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"124b328f-1446-4b1f-b6d4-366da7aa3d9d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"f329d852-a462-4fd5-8976-9cb72b357f99"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Invgg"}]], "Input",ExpressionUUID->"cbef50d7-e665-469b-9ee5-ab0162d89ebc"],

Cell[CellGroupData[{

Cell["Global`Invgg", "Print", "PrintUsage",
 CellTags->
  "Info3578672879-5338953",ExpressionUUID->"871c60ca-9aba-40fa-a618-\
c46dd128106a"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "Invgg", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Invgg],
          Editable->False], "^=", "Invgg"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          
          RowBox[{"\<\"inverse metric tensor\"\>", 
           ",", "\<\"Metric is frozen!\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", "Invgg", "]"}], "^=", "gg"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Invgg", "]"}], "^=", "\<\"igg\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "Invgg", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "1", ",", "2", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{1, 2}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "Invgg", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"xAct`xTensor`Private`InvMetric", ",", "gg"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "Invgg", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-Pattern[xAct`xTensor`Private`a, 
              Blank[]], -PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`c", "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ], 
            Pattern[xAct`xTensor`Private`c, 
             Blank[]]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`a", "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q], -Pattern[xAct`xTensor`Private`a, 
              Blank[]]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`c", "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ], 
            Pattern[xAct`xTensor`Private`c, 
             Blank[]]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-Pattern[xAct`xTensor`Private`a, 
              Blank[]], -PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox["xAct`xTensor`Private`c", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            Pattern[xAct`xTensor`Private`c, 
             Blank[]], 
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{"Invgg", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"gg", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"], 
                   UnderscriptBox["xAct`xTensor`Private`a", "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gg[-PatternTest[
              Pattern[xAct`xTensor`Private`b, 
               Blank[]], TangentM2`Q], -Pattern[xAct`xTensor`Private`a, 
              Blank[]]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"igg", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox["xAct`xTensor`Private`c", "_"], 
                   UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Invgg[
            Pattern[xAct`xTensor`Private`c, 
             Blank[]], 
            PatternTest[
             Pattern[xAct`xTensor`Private`b, 
              Blank[]], xAct`xTensor`EIndexQ]],
           Editable->False]}], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "xAct`xTensor`Private`c"},
                 {"xAct`xTensor`Private`a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-xAct`xTensor`Private`a, xAct`xTensor`Private`c],
          
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`der$_", "?", "FirstDerQ"}], "[", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"igg", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Invgg[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q], 
             PatternTest[
              Pattern[xAct`xTensor`Private`c$, 
               Blank[]], TangentM2`Q]],
            Editable->False], "]"}], "]"}], "^:=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xAct`xTensor`Private`b1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]M2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentM2,
                Editable->False], "]"}]}], ",", 
             RowBox[{"xAct`xTensor`Private`c1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]M2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentM2,
                Editable->False], "]"}]}]}], "}"}], ",", 
           RowBox[{
            RowBox[{"-", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"igg", 
                  StyleBox[GridBox[{
                    {"xAct`xTensor`Private`b$", "xAct`xTensor`Private`b1$"},
                    {" ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Invgg[
              xAct`xTensor`Private`b$, xAct`xTensor`Private`b1$],
              Editable->False]}], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"igg", 
                 StyleBox[GridBox[{
                    {"xAct`xTensor`Private`c$", "xAct`xTensor`Private`c1$"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Invgg[
             xAct`xTensor`Private`c$, xAct`xTensor`Private`c1$],
             Editable->False], " ", 
            RowBox[{"xAct`xTensor`Private`der$", "[", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"gg", 
                  StyleBox[GridBox[{
                    {" ", " "},
                    {"xAct`xTensor`Private`b1$", "xAct`xTensor`Private`c1$"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gg[-xAct`xTensor`Private`b1$, -
               xAct`xTensor`Private`c1$],
              Editable->False], "]"}]}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Invgg],
  Editable->False]], "Print",
 CellTags->
  "Info3578672879-5338953",ExpressionUUID->"21ef2443-6f55-4850-a8e6-\
0682703b7c5a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}]}], ",", "metricg"}], 
  "]"}]], "Input",ExpressionUUID->"95f7ba58-b00c-4a5e-b2e7-188c3c31f6a6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", " "},
         {" ", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, -C],
  Editable->
   False]], "Output",ExpressionUUID->"708c9bec-c830-4108-a8e1-ae0d9eb8240d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"ContractMetric", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"gg", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}]}], ",", "gg"}], 
   "]"}]}]], "Input",ExpressionUUID->"2d24c73e-c68c-40d9-b982-3dff4743c367"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ContractMetric", "::", "frozen"}], "MessageName"], ":", 
  " ", "\<\"Cannot contract frozen metric \
\[NoBreak]\\!\\(gg\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6550b7e5-e3bb-4be9-a4d1-284647ba505f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], "]"}], 
  RowBox[{"metricg", "[", 
   RowBox[{"A", ",", "C"}], 
   "]"}]}]], "Input",ExpressionUUID->"1340be14-d0b9-42ba-9b9a-77bf232b3b93"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"\[Delta]", 
      StyleBox[GridBox[{
         {" ", "C"},
         {"B", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`delta[-$CellContext`B, C],
  Editable->
   False]], "Output",ExpressionUUID->"767ee161-25d3-4d41-bb51-5c7765ec5951"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"gg", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], "]"}], 
  RowBox[{"gg", "[", 
   RowBox[{"A", ",", "C"}], 
   "]"}]}]], "Input",ExpressionUUID->"dd6722a4-edd1-4bd8-b306-6915a10e33c2"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"gg", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`gg[-$CellContext`A, -$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"gg", 
       StyleBox[GridBox[{
          {"A", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`gg[$CellContext`A, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"cdadbc18-262a-4c7f-8849-bf1dcfe40445"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"39cd84dd-d87f-4a18-a3b1-608e1bbe5668"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"gg", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`gg[-$CellContext`A, -$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"gg", 
       StyleBox[GridBox[{
          {"A", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`gg[$CellContext`A, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"0ca5f1f8-35f6-4b15-97b6-d2a3f15a5c70"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"gg", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], "]"}], 
  RowBox[{"metricg", "[", 
   RowBox[{"A", ",", "C"}], 
   "]"}]}]], "Input",ExpressionUUID->"0b3cbe08-f404-4d9f-9549-e23c80042fde"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"gg", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`gg[-$CellContext`A, -$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"3b99a5b7-9bc7-4647-8c93-3b773274ec89"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"0ffb9abc-5c4c-4357-aad8-e497c51517d2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"gg", 
      StyleBox[GridBox[{
         {"C", " "},
         {" ", "B"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`gg[C, -$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"d83f480d-64a3-4fa0-b1f2-7c0d5706ca98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefMetric", "/@", 
   RowBox[{"{", 
    RowBox[{"gg", ",", "metricg"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"5f60d9ad-2d68-4fa6-b3dc-aadafeb1f5b6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgg],
  Editable->
   False]], "Print",ExpressionUUID->"de04cbf9-9397-4d60-aa5d-f81af22633ce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"0ccd065a-f462-4f69-ae15-985c93157676"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCD],
  Editable->
   False]], "Print",ExpressionUUID->"b80b3059-991b-4f73-a7b5-a8afddb6a71c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCD],
  Editable->
   False]], "Print",ExpressionUUID->"c6761af0-0a0c-44fd-9f11-65ceabb44ecd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"94b20e7a-f4d8-418c-b72d-f8fbf63ffc99"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCD],
  Editable->
   False]], "Print",ExpressionUUID->"59514c2f-563e-4b9d-b711-af27b98ace53"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"2dc2c409-4b15-4368-a8ca-676b3bf9ead2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannDownCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannDownCD],
  Editable->
   False]], "Print",ExpressionUUID->"e1508390-ad72-4a0a-a42a-9d071f950517"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"a77f88b6-58eb-4415-ada7-4495fd2d5bfc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"367a98d4-dd91-40c6-8ad7-b2249112457a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCD],
  Editable->
   False]], "Print",ExpressionUUID->"201b2d92-137a-4db8-9c4c-8c4b6b55abcd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"a565bea0-01e1-4c9e-9e50-2dbf213d4074"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"inverse metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Invgg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "inverse metric tensor", 
   " ", $CellContext`Invgg],
  Editable->
   False]], "Print",ExpressionUUID->"820c47ca-2e9f-4dbd-bdb0-efda9c3aa09d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gg],
  Editable->
   False]], "Print",ExpressionUUID->"c44223e5-5e89-4482-894e-4916c8850e39"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"ba1d05ae-092f-4a43-b7bb-a90a97f7074b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdM],
  Editable->
   False]], "Print",ExpressionUUID->"0f20f139-1ba1-4dde-a2ab-e06439c13c5e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdM],
  Editable->
   False]], "Print",ExpressionUUID->"f78a68d9-947a-49fb-bfc8-8bc98c63bdfd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"b5dc1b08-374c-4a66-b6bf-05fb156f3e37"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"31525905-e8b6-4f03-ab9c-c8bbd09de34c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdM],
  Editable->
   False]], "Print",ExpressionUUID->"6fdf5526-f341-4330-b168-666b6a648513"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"333fe242-7232-499f-9dbf-a4174fae2289"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"bc0a5262-d637-4bdf-aeec-f514c21baeed"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdM],
  Editable->
   False]], "Print",ExpressionUUID->"3650cc7b-0067-4248-bdf6-258bb18fdae2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdM],
  Editable->
   False]], "Print",ExpressionUUID->"90f4e17c-9e9f-4540-b390-5522a453a349"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdM],
  Editable->
   False]], "Print",ExpressionUUID->"8455b1de-272e-4f17-ae32-dcc97e2d12ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"80601840-7c6a-460a-b723-818b720a333a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"122d203b-afad-470f-9300-a1da5095d5c2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"17e3d0a7-85aa-4add-85ab-e0eae9655550"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"7ca1c4fc-ee51-4aa5-bffb-60191fb3607a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"df0c7ec5-6c16-41a6-a17e-747f1a9584d4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$241807\"\>", ",", "\<\"G$241807$\"\>", 
     ",", "\<\"G$241808\"\>", ",", "\<\"G$241808$\"\>", 
     ",", "\<\"G$241809\"\>", ",", "\<\"G$241809$\"\>", 
     ",", "\<\"G$241810\"\>", ",", "\<\"G$241810$\"\>", 
     ",", "\<\"G$241811\"\>", ",", "\<\"G$241811$\"\>", 
     ",", "\<\"G$241812\"\>", ",", "\<\"G$241812$\"\>", 
     ",", "\<\"G$241813\"\>", ",", "\<\"G$241813$\"\>", 
     ",", "\<\"G$241814\"\>", ",", "\<\"G$241814$\"\>", 
     ",", "\<\"G$241815\"\>", ",", "\<\"G$241815$\"\>", 
     ",", "\<\"G$241816\"\>", ",", "\<\"G$241816$\"\>", 
     ",", "\<\"G$241817\"\>", ",", "\<\"G$241817$\"\>", 
     ",", "\<\"G$241818\"\>", ",", "\<\"G$241818$\"\>", 
     ",", "\<\"G$241819\"\>", ",", "\<\"G$241819$\"\>", 
     ",", "\<\"G$241820\"\>", ",", "\<\"G$241820$\"\>", 
     ",", "\<\"G$241889\"\>", ",", "\<\"G$241890\"\>", 
     ",", "\<\"G$241891\"\>", ",", "\<\"G$241892\"\>", 
     ",", "\<\"G$241900\"\>", ",", "\<\"G$241901\"\>", 
     ",", "\<\"G$241909\"\>", ",", "\<\"G$241910\"\>", 
     ",", "\<\"G$241911\"\>", ",", "\<\"G$241922\"\>", 
     ",", "\<\"G$241923\"\>", ",", "\<\"G$241926\"\>", 
     ",", "\<\"G$241927\"\>", ",", "\<\"G$241930\"\>", 
     ",", "\<\"G$241931\"\>", ",", "\<\"G$241937\"\>", 
     ",", "\<\"G$241938\"\>", ",", "\<\"G$241941\"\>", 
     ",", "\<\"G$241942\"\>", ",", "\<\"G$243168\"\>", 
     ",", "\<\"G$243168$\"\>", ",", "\<\"G$243169\"\>", 
     ",", "\<\"G$243169$\"\>", ",", "\<\"G$243170\"\>", 
     ",", "\<\"G$243170$\"\>", ",", "\<\"G$243171\"\>", 
     ",", "\<\"G$243171$\"\>", ",", "\<\"G$243233\"\>", 
     ",", "\<\"G$243234\"\>", ",", "\<\"G$243235\"\>", 
     ",", "\<\"G$243236\"\>", ",", "\<\"G$243237\"\>", 
     ",", "\<\"G$243237$\"\>", ",", "\<\"G$243247\"\>", 
     ",", "\<\"G$243248\"\>", ",", "\<\"G$243249\"\>", 
     ",", "\<\"G$243250\"\>", ",", "\<\"G$243251\"\>", 
     ",", "\<\"G$243252\"\>", ",", "\<\"G$243253\"\>", 
     ",", "\<\"G$243254\"\>", ",", "\<\"G$243255\"\>", 
     ",", "\<\"G$243256\"\>", ",", "\<\"G$243257\"\>", 
     ",", "\<\"G$243258\"\>", ",", "\<\"G$243259\"\>", 
     ",", "\<\"G$243260\"\>", ",", "\<\"G$243261\"\>", 
     ",", "\<\"G$243262\"\>", ",", "\<\"G$243262$\"\>", 
     ",", "\<\"G$243274\"\>", ",", "\<\"G$243275\"\>", 
     ",", "\<\"G$243276\"\>", ",", "\<\"G$243277\"\>", 
     ",", "\<\"G$243278\"\>", ",", "\<\"G$243279\"\>", 
     ",", "\<\"G$243280\"\>", ",", "\<\"G$243281\"\>", 
     ",", "\<\"G$243282\"\>", ",", "\<\"G$243283\"\>", 
     ",", "\<\"G$243284\"\>", ",", "\<\"G$243285\"\>", 
     ",", "\<\"G$243286\"\>", ",", "\<\"G$243287\"\>", 
     ",", "\<\"G$243288\"\>", ",", "\<\"G$243296\"\>", 
     ",", "\<\"G$243297\"\>", ",", "\<\"G$243298\"\>", ",", "\<\"H\"\>"}], 
    "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$241807", "G$241807$", "G$241808", "G$241808$", "G$241809", "G$241809$", 
    "G$241810", "G$241810$", "G$241811", "G$241811$", "G$241812", "G$241812$",
     "G$241813", "G$241813$", "G$241814", "G$241814$", "G$241815", 
    "G$241815$", "G$241816", "G$241816$", "G$241817", "G$241817$", "G$241818",
     "G$241818$", "G$241819", "G$241819$", "G$241820", "G$241820$", 
    "G$241889", "G$241890", "G$241891", "G$241892", "G$241900", "G$241901", 
    "G$241909", "G$241910", "G$241911", "G$241922", "G$241923", "G$241926", 
    "G$241927", "G$241930", "G$241931", "G$241937", "G$241938", "G$241941", 
    "G$241942", "G$243168", "G$243168$", "G$243169", "G$243169$", "G$243170", 
    "G$243170$", "G$243171", "G$243171$", "G$243233", "G$243234", "G$243235", 
    "G$243236", "G$243237", "G$243237$", "G$243247", "G$243248", "G$243249", 
    "G$243250", "G$243251", "G$243252", "G$243253", "G$243254", "G$243255", 
    "G$243256", "G$243257", "G$243258", "G$243259", "G$243260", "G$243261", 
    "G$243262", "G$243262$", "G$243274", "G$243275", "G$243276", "G$243277", 
    "G$243278", "G$243279", "G$243280", "G$243281", "G$243282", "G$243283", 
    "G$243284", "G$243285", "G$243286", "G$243287", "G$243288", "G$243296", 
    "G$243297", "G$243298", "H"}],
  Editable->
   False]], "Print",ExpressionUUID->"b81f8caa-8a75-4999-a4be-54641a0af70a"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["14.3. Induced metrics", \
"Subsection",ExpressionUUID->"09141234-6b31-45cb-bf33-0f5a552afc9d"],

Cell[CellGroupData[{

Cell["14.3.0. Comments", \
"Subsubsection",ExpressionUUID->"f977f95c-0dea-4399-a2c3-08d549768f3e"],

Cell[TextData[{
 "This is an important and nontrivial part of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", and perhaps it could even merit promotion to a separate package. I don't \
do it because I don't have a good name for it yet!\n\nI thank much input and \
feedback on this area from Guillaume Faye, Alfonso Garcia-Parrado and Cyril \
Pitrou.\n\nThere are two different ways of doing ADM-type decomposition. We \
follow here Wald, as usual, in choosing expressions with indices on the \
ambient vbundles always, and using projectors into the subvbundles. The \
opposite choice would be using index splitting, which I think would be easier \
to use, and more powerful. I guess that in the future ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " will handle both formalisms.\n\nThere are two index conventions here:"
}], "Text",ExpressionUUID->"ad72055d-c27c-4865-a16b-47369c294913"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefSign", "[", 
   RowBox[{
   "$ExtrinsicKSign", ",", "\"\<\!\(\*SubscriptBox[\(s\), \(K\)]\)\>\"", ",", 
    "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefSign", "[", 
   RowBox[{
   "$AccelerationSign", ",", "\"\<\!\(\*SubscriptBox[\(s\), \(A\)]\)\>\"", 
    ",", "1"}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"419b427a-9406-4822-8893-0a4bef0c2bff"],

Cell["\<\
Note: derivatives of inverse induced metrics are not automatically converted \
into derivatives of the induced metrics. QUESTION: is that a problem in the \
process of canonicalization of derivatives of metrics?\
\>", "Text",ExpressionUUID->"c2c92dbe-3c17-4a95-987e-d85b39787cf1"],

Cell["\<\
Note: a projector h[a,-b] is automatically contracted with projected tensors \
and projected derivatives, but not with objects surrounded by the Projectorh. \
That seems a bit inconsistent. That is also an exception to the rule of \
non-automatic metric contraction.\
\>", "Text",ExpressionUUID->"e107659e-6d31-4a48-99d4-70e9f4edb61f"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.3.1. Definitions", \
"Subsubsection",ExpressionUUID->"df0e321a-a22b-4687-8c8a-5eb4ab174bb3"],

Cell["\<\
This command is in charge of most of the definitions concerning induced \
metrics. It is called from DefMetric, and hence we assume that the tensor \
metric has already been defined.\
\>", "Text",ExpressionUUID->"8355063e-8a7a-4ac3-9218-60ac5af4b4ac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Validate", "::", "nonproj"}], "=", 
  "\"\<Induced derivative acting on the non-projected expression \
`1`.\>\""}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c439d327-456d-4e9d-9a02-32ba90837e51"],

Cell[BoxData["\<\"Induced derivative acting on the non-projected expression \
`1`.\"\>"], "Output",ExpressionUUID->"9565d339-81d9-483a-8103-49f575205bc4"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefInducedMetric", "[", 
    RowBox[{
     RowBox[{"metric_", "[", 
      RowBox[{
       RowBox[{"-", "ind1_"}], ",", 
       RowBox[{"-", "ind2_"}]}], "]"}], ",", "dependencies_", ",", "covd_", 
     ",", 
     RowBox[{"{", 
      RowBox[{"vector_", ",", "supermetric_", ",", "superCD_"}], "}"}], ",", 
     "flat_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vbundle", "=", 
       RowBox[{"VBundleOfIndex", "[", "ind1", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"extrinsicKname", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"ExtrinsicK", ",", "metric"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"accelerationname", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Acceleration", ",", "vector"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"projectorname", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"Projector", ",", "metric"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"epsilonname", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"epsilon", ",", "metric"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"superepsilonname", "=", 
          RowBox[{"GiveSymbol", "[", 
           RowBox[{"epsilon", ",", "supermetric"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"proj", "=", 
          RowBox[{"ProjectWith", "[", "metric", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"norm", "=", 
          RowBox[{"Scalar", "@", 
           RowBox[{"Simplify", "@", 
            RowBox[{"ContractMetric", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"supermetric", "[", 
                RowBox[{
                 RowBox[{"-", "ind1"}], ",", 
                 RowBox[{"-", "ind2"}]}], "]"}], 
               RowBox[{"vector", "[", "ind1", "]"}], 
               RowBox[{"vector", "[", "ind2", "]"}]}], ",", "supermetric"}], 
             "]"}]}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"indexlist", "=", 
          RowBox[{"GetIndicesOfVBundle", "[", 
           RowBox[{"vbundle", ",", "3"}], "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"i1", "=", 
             RowBox[{"indexlist", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ",", 
            RowBox[{"i2", "=", 
             RowBox[{"indexlist", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ",", 
            RowBox[{"i3", "=", 
             RowBox[{"indexlist", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Register", " ", "pair", " ", 
            RowBox[{"metric", "/", "vector"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"xUpSet", "[", 
            RowBox[{
             RowBox[{"VectorOfInducedMetric", "[", "metric", "]"}], ",", 
             "vector"}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Define", " ", "associated", " ", "tensors"}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"DefTensor", "[", 
            RowBox[{
             RowBox[{"extrinsicKname", "[", 
              RowBox[{"i1", ",", "i2"}], "]"}], ",", "dependencies", ",", 
             RowBox[{"Symmetric", "[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{"ExtrinsicK", ",", "metric"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"OrthogonalTo", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"vector", "[", 
                RowBox[{"-", "i1"}], "]"}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ProjectedWith", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"metric", "[", 
                RowBox[{"i3", ",", 
                 RowBox[{"-", "i2"}]}], "]"}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Master", "\[Rule]", "metric"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DefInfo", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<extrinsic curvature tensor\>\"", ",", 
                RowBox[{"\"\<Associated to vector \>\"", "<>", 
                 RowBox[{"ToString", "[", "vector", "]"}]}]}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"TensorID", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"ExtrinsicK", ",", "metric"}], "}"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"DefTensor", "[", 
            RowBox[{
             RowBox[{"accelerationname", "[", "i1", "]"}], ",", 
             "dependencies", ",", "\[IndentingNewLine]", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{"Acceleration", ",", "vector"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"OrthogonalTo", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"vector", "[", 
                RowBox[{"-", "i1"}], "]"}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ProjectedWith", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"metric", "[", 
                RowBox[{"i2", ",", 
                 RowBox[{"-", "i1"}]}], "]"}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Master", "\[Rule]", "metric"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DefInfo", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<acceleration vector\>\"", ",", 
                RowBox[{"\"\<Associated to vector \>\"", "<>", 
                 RowBox[{"ToString", "[", "vector", "]"}]}]}], "}"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"TensorID", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Acceleration", ",", "vector"}], "}"}]}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
             "Relations", " ", "among", " ", "them", " ", "and", " ", "the", 
              " ", 
              RowBox[{"derivatives", ".", " ", "Improved"}], " ", "by", " ", 
              "Thomas"}], ",", " ", 
             RowBox[{"to", " ", "use", " ", "HasOrthogonalIndexQ"}]}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"GradNormalToExtrinsicKRules", "[", "metric", "]"}], "=", 
            
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"superCD", "[", "a_", "]"}], "[", 
                RowBox[{"vector", "[", "b_", "]"}], "]"}], "\[RuleDelayed]", 
               RowBox[{
                RowBox[{"$ExtrinsicKSign", " ", 
                 RowBox[{"extrinsicKname", "[", 
                  RowBox[{"a", ",", "b"}], "]"}]}], "+", 
                RowBox[{"$AccelerationSign", " ", 
                 RowBox[{"vector", "[", "a", "]"}], 
                 RowBox[{"accelerationname", "[", "b", "]"}]}]}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"vector", "[", 
                 RowBox[{"-", "a_"}], "]"}], 
                RowBox[{
                 RowBox[{"superCD", "[", "b_", "]"}], "[", "expr_", "]"}]}], 
               "\[RuleDelayed]", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{
                   RowBox[{"superCD", "[", "b", "]"}], "[", 
                   RowBox[{"vector", "[", 
                    RowBox[{"-", "a"}], "]"}], "]"}]}], "expr"}], "/;", 
                RowBox[{"HasOrthogonalIndexQ", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"vector", "[", 
                   RowBox[{"-", "a"}], "]"}]}], "]"}]}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"vector", "[", "a_", "]"}], 
                RowBox[{
                 RowBox[{"superCD", "[", "b_", "]"}], "[", "expr_", "]"}]}], 
               "\[RuleDelayed]", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{
                   RowBox[{"superCD", "[", "b", "]"}], "[", 
                   RowBox[{"vector", "[", "a", "]"}], "]"}]}], "expr"}], "/;", 
                RowBox[{"HasOrthogonalIndexQ", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"vector", "[", "a", "]"}]}], "]"}]}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"LieD", "[", 
                  RowBox[{"vector", "[", "_", "]"}], "]"}], "[", "expr_", 
                 "]"}], 
                RowBox[{"vector", "[", 
                 RowBox[{"-", "a_"}], "]"}]}], "\[RuleDelayed]", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "$AccelerationSign"}], " ", "norm", " ", 
                 RowBox[{"accelerationname", "[", 
                  RowBox[{"-", "a"}], "]"}], "expr"}], "/;", 
                RowBox[{"HasOrthogonalIndexQ", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"vector", "[", 
                   RowBox[{"-", "a"}], "]"}]}], "]"}]}]}]}], 
             RowBox[{"(*", 
              RowBox[{",", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"LieD", "[", 
                   RowBox[{"vector", "[", "_", "]"}], "]"}], "[", "expr_", 
                  "]"}], 
                 RowBox[{"vector", "[", "a_", "]"}]}], "\[RuleDelayed]", 
                RowBox[{"0", "/;", 
                 RowBox[{"HasOrthogonalIndexQ", "[", 
                  RowBox[{"expr", ",", 
                   RowBox[{"vector", "[", "a", "]"}]}], "]"}]}]}]}], "*)"}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ExtrinsicKToGradNormalRules", "[", "metric", "]"}], "=", 
            
            RowBox[{
             RowBox[{"extrinsicKname", "[", 
              RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"c", "=", 
                 RowBox[{"DummyIn", "@", "vbundle"}]}], "}"}], ",", 
               RowBox[{"$ExtrinsicKSign", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"supermetric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                   RowBox[{
                    RowBox[{"superCD", "[", 
                    RowBox[{"-", "c"}], "]"}], "[", 
                    RowBox[{"vector", "[", "b", "]"}], "]"}]}], "-", 
                  RowBox[{"$AccelerationSign", " ", 
                   RowBox[{"vector", "[", "a", "]"}], 
                   RowBox[{"accelerationname", "[", "b", "]"}]}]}], ")"}]}]}],
               "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Projectors", " ", "and", " ", "metrics"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ProjectorToMetricRules", "[", "metric", "]"}], "=", 
            RowBox[{
             RowBox[{"metric", "[", 
              RowBox[{"i1_", ",", "i2_"}], "]"}], "\[Rule]", 
             RowBox[{
              RowBox[{"supermetric", "[", 
               RowBox[{"i1", ",", "i2"}], "]"}], "-", 
              RowBox[{
               RowBox[{"vector", "[", "i1", "]"}], 
               RowBox[{
                RowBox[{"vector", "[", "i2", "]"}], "/", "norm"}]}]}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MetricToProjectorRules", "[", "metric", "]"}], "=", 
            RowBox[{
             RowBox[{"supermetric", "[", 
              RowBox[{"i1_", ",", "i2_"}], "]"}], "\[Rule]", 
             RowBox[{
              RowBox[{"metric", "[", 
               RowBox[{"i1", ",", "i2"}], "]"}], "+", 
              RowBox[{
               RowBox[{"vector", "[", "i1", "]"}], 
               RowBox[{
                RowBox[{"vector", "[", "i2", "]"}], "/", "norm"}]}]}]}]}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Define", " ", "projector", " ", "inert"}], "-", 
             "head"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"DefInertHead", "[", 
            RowBox[{"projectorname", ",", "\[IndentingNewLine]", 
             RowBox[{"LinearQ", "\[Rule]", "True"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Master", "\[Rule]", "metric"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"PrintAs", "\[RuleDelayed]", 
              RowBox[{"GiveOutputString", "[", 
               RowBox[{"Projector", ",", "metric"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"DefInfo", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<projector inert-head\>\"", ",", "\"\<\>\""}], 
               "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", 
             RowBox[{"supermetric", "[", 
              RowBox[{"a_", ",", "b_"}], "]"}], "]"}], ":=", 
            RowBox[{"metric", "[", 
             RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"The", " ", "metric"}], ",", " ", 
             RowBox[{"but", " ", "not", " ", "the", " ", "supermetric"}], ",",
              " ", 
             RowBox[{
             "can", " ", "be", " ", "contracted", " ", "through", " ", "the", 
              " ", "projector"}]}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"xTagSet", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"projectorname", ",", 
               RowBox[{"ContractThroughQ", "[", 
                RowBox[{"projectorname", ",", "metric"}], "]"}]}], "}"}], ",",
              "True"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "The", " ", "supermetric", " ", "is", " ", "converted", " ", 
             "into", " ", "metric", " ", "when", " ", "contracted", " ", 
             "with", " ", "the", " ", "projector", " ", "or", " ", "covd"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"xTagSetDelayed", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"projectorname", ",", 
               RowBox[{
                RowBox[{"supermetric", "[", 
                 RowBox[{"i1_", ",", "i2_"}], "]"}], 
                RowBox[{"projectorname", "[", "expr_", "]"}]}]}], "}"}], ",", 
             
             RowBox[{
              RowBox[{
               RowBox[{"metric", "[", 
                RowBox[{"i1", ",", "i2"}], "]"}], 
               RowBox[{"projectorname", "[", "expr", "]"}]}], "/;", 
              RowBox[{"Or", "[", 
               RowBox[{
                RowBox[{"IsIndexOf", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"-", "i1"}], ",", "metric"}], "]"}], ",", 
                RowBox[{"IsIndexOf", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"-", "i2"}], ",", "metric"}], "]"}]}], "]"}]}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"xTagSetDelayed", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"covd", ",", 
               RowBox[{
                RowBox[{"supermetric", "[", 
                 RowBox[{"i1_", ",", "i2_"}], "]"}], 
                RowBox[{
                 RowBox[{"covd", "[", "i3_", "]"}], "[", "expr_", "]"}]}]}], 
              "}"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"metric", "[", 
                RowBox[{"i1", ",", "i2"}], "]"}], 
               RowBox[{
                RowBox[{"covd", "[", "i3", "]"}], "[", "expr", "]"}]}], "/;", 
              
              RowBox[{"Or", "[", 
               RowBox[{
                RowBox[{"IsIndexOf", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"covd", "[", "i3", "]"}], "[", "expr", "]"}], ",", 
                  
                  RowBox[{"-", "i1"}], ",", "metric"}], "]"}], ",", 
                RowBox[{"IsIndexOf", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"covd", "[", "i3", "]"}], "[", "expr", "]"}], ",", 
                  
                  RowBox[{"-", "i2"}], ",", "metric"}], "]"}]}], "]"}]}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Projection", " ", "rule", " ", "with", " ", "vector"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"xTagSetDelayed", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"projectorname", ",", 
               RowBox[{
                RowBox[{"vector", "[", "i_", "]"}], 
                RowBox[{"projectorname", "[", "expr_", "]"}]}]}], "}"}], ",", 
             
             RowBox[{"0", "/;", 
              RowBox[{"IsIndexOf", "[", 
               RowBox[{"expr", ",", 
                RowBox[{"-", "i"}], ",", "metric"}], "]"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Particular", " ", "cases"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", "1", "]"}], ":=", "1"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", 
             RowBox[{"rest_.", " ", 
              RowBox[{"x_", "?", "ScalarQ"}]}], "]"}], ":=", 
            RowBox[{
             RowBox[{"Scalar", "[", "x", "]"}], 
             RowBox[{"projectorname", "[", "rest", "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", 
             RowBox[{
              RowBox[{"vector", "[", "i_", "]"}], "expr_."}], "]"}], ":=", 
            RowBox[{"0", "/;", 
             RowBox[{"Not", "@", 
              RowBox[{"IsIndexOf", "[", 
               RowBox[{"expr", ",", 
                RowBox[{"-", "i"}], ",", "supermetric"}], "]"}]}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", 
             RowBox[{"projectorname", "[", "expr_", "]"}], "]"}], ":=", 
            RowBox[{"projectorname", "[", "expr", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", 
             RowBox[{
              RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds__", "]"}], 
             "]"}], ":=", 
            RowBox[{
             RowBox[{"tensor", "[", "inds", "]"}], "/;", 
             RowBox[{
              RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
              "tensor", "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"projectorname", "[", 
             RowBox[{
              RowBox[{"covd", "[", "k_", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
            RowBox[{
             RowBox[{"covd", "[", "k", "]"}], "[", "expr", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ProjectDerivativeRules", "[", "covd", "]"}], "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"covd", "[", "i_", "]"}], "[", "expr_", "]"}], 
              "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"IsIndexOf", "[", 
                 RowBox[{"expr", ",", 
                  RowBox[{"-", "i"}]}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"dummy", "=", 
                    RowBox[{"DummyAs", "[", "i", "]"}]}], "}"}], ",", 
                  RowBox[{
                   RowBox[{"metric", "[", 
                    RowBox[{"i", ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], 
                   RowBox[{"projectorname", "[", 
                    RowBox[{
                    RowBox[{"superCD", "[", "dummy", "]"}], "[", "expr", 
                    "]"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"projectorname", "[", 
                 RowBox[{
                  RowBox[{"superCD", "[", "i", "]"}], "[", "expr", "]"}], 
                 "]"}]}], "\[IndentingNewLine]", "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"prot", "=", 
               RowBox[{"Unprotect", "[", "covd", "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Leibnitz", " ", 
               RowBox[{"rule", ".", " ", "Three"}], " ", "cases", " ", 
               "considered"}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "i1_", "]"}], "[", 
                RowBox[{"x_Scalar", " ", "y_Scalar"}], "]"}], ":=", 
               RowBox[{
                RowBox[{"x", " ", 
                 RowBox[{
                  RowBox[{"covd", "[", "i1", "]"}], "[", "y", "]"}]}], "+", 
                RowBox[{"y", " ", 
                 RowBox[{
                  RowBox[{"covd", "[", "i1", "]"}], "[", "x", "]"}]}]}]}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
               "Special", " ", "definitions", " ", "suggested", " ", "by", 
                " ", "Cyril"}], " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "i1_", "]"}], "[", 
                RowBox[{"supermetric", "[", 
                 RowBox[{
                  RowBox[{"a_", "?", "AIndexQ"}], ",", 
                  RowBox[{"b_", "?", "AIndexQ"}]}], "]"}], "]"}], ":=", "0"}],
               ";", "\[IndentingNewLine]", 
              RowBox[{"(*", "    ", 
               RowBox[{
                RowBox[{
                "Cyril", " ", "suggests", " ", "removing", " ", "the", " ", 
                 "OrthogonalToVectorQ", " ", "check", " ", "to", " ", 
                 "handle", " ", "the", " ", "many"}], "-", 
                RowBox[{"supermetrics", " ", "case"}]}], " ", "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "i1_", "]"}], "[", 
                RowBox[{"x_", " ", 
                 RowBox[{"supermetric", "[", 
                  RowBox[{
                   RowBox[{"a_", "?", "AIndexQ"}], ",", 
                   RowBox[{"b_", "?", "AIndexQ"}]}], "]"}]}], "]"}], ":=", 
               RowBox[{
                RowBox[{
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "b"}], "]"}], 
                 RowBox[{
                  RowBox[{"covd", "[", "i1", "]"}], "[", "x", "]"}]}], "/;", 
                RowBox[{
                 RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
                 "x", "]"}]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "i1_", "]"}], "[", 
                RowBox[{"x_", " ", 
                 RowBox[{"delta", "[", 
                  RowBox[{
                   RowBox[{"a_", "?", "AIndexQ"}], ",", 
                   RowBox[{"b_", "?", "AIndexQ"}]}], "]"}]}], "]"}], ":=", 
               RowBox[{
                RowBox[{
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "b"}], "]"}], 
                 RowBox[{
                  RowBox[{"covd", "[", "i1", "]"}], "[", "x", "]"}]}], "/;", 
                RowBox[{
                 RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
                 "x", "]"}]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "i1_", "]"}], "[", 
                RowBox[{
                 RowBox[{"vector", "[", 
                  RowBox[{"a_", "?", "AIndexQ"}], "]"}], 
                 RowBox[{"vector", "[", 
                  RowBox[{"b_", "?", "AIndexQ"}], "]"}], "x_."}], "]"}], ":=", 
               RowBox[{"0", "/;", 
                RowBox[{"And", "[", 
                 RowBox[{
                  RowBox[{"!", 
                   RowBox[{"IsIndexOf", "[", 
                    RowBox[{"x", ",", 
                    RowBox[{"ChangeIndex", "@", "a"}]}], "]"}]}], ",", 
                  RowBox[{"!", 
                   RowBox[{"IsIndexOf", "[", 
                    RowBox[{"x", ",", 
                    RowBox[{"ChangeIndex", "@", "b"}]}], "]"}]}], ",", 
                  RowBox[{"!", 
                   RowBox[{"PairQ", "[", 
                    RowBox[{"a", ",", "b"}], "]"}]}]}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Product", " ", "of", " ", "two"}], ",", " ", 
                RowBox[{"perhaps", " ", "contracted"}], ",", " ", 
                "expressions"}], " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", "i1_", "]"}], "[", 
                RowBox[{"x_", " ", "y_"}], "]"}], ":=", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"res", "=", 
                   RowBox[{"Which", "[", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "Both", " ", "are", " ", "orthogonal", " ", "in", " ", 
                    "all", " ", "their", " ", 
                    RowBox[{"indices", ".", " ", "We"}], " ", "can", " ", 
                    "use", " ", "the", " ", "Leibnitz", " ", "rule"}], " ", 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
                    "x", "]"}], "&&", 
                    RowBox[{
                    RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
                    "y", "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "i1", "]"}], "[", "x", "]"}], "y"}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "i1", "]"}], "[", "y", "]"}], 
                    "x"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "The", " ", "expression", " ", "is", " ", "not", " ", 
                    "globally", " ", 
                    RowBox[{"orthogonal", ":", " ", 
                    RowBox[{
                    "complain", " ", "and", " ", "return", " ", 
                    "unevaluated"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"Not", "@", 
                    RowBox[{
                    RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
                    
                    RowBox[{"x", " ", "y"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Message", "[", 
                    RowBox[{
                    RowBox[{"Validate", "::", "nonproj"}], ",", 
                    RowBox[{"x", " ", "y"}]}], "]"}], ";", "$Failed"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    RowBox[{"Expression", " ", "is", " ", "orthogonal"}], ",",
                     " ", 
                    RowBox[{"but", " ", "factors", " ", "are", " ", 
                    RowBox[{"not", ".", " ", "Avoid"}], " ", "infinite", " ", 
                    "recursion", " ", "with", " ", "this", " ", "hack"}]}], 
                    " ", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"FreeQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", "y"}], "}"}], ",", "vector"}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"covd", "[", "i1", "]"}], "[", 
                    RowBox[{"Expand", "@", 
                    RowBox[{"GradNormalToExtrinsicK", "@", 
                    RowBox[{"Expand", "[", 
                    RowBox[{
                    RowBox[{"InducedDecomposition", "[", 
                    RowBox[{"x", ",", 
                    RowBox[{"{", 
                    RowBox[{"metric", ",", "vector"}], "}"}]}], "]"}], 
                    RowBox[{"InducedDecomposition", "[", 
                    RowBox[{"y", ",", 
                    RowBox[{"{", 
                    RowBox[{"metric", ",", "vector"}], "}"}]}], "]"}]}], 
                    "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "This", " ", "should", " ", "never", " ", "happen"}], " ",
                     "*)"}], "\[IndentingNewLine]", "True", ",", 
                    "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]",
                     "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"res", "/;", 
                   RowBox[{"res", "=!=", "$Failed"}]}]}]}], 
                "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{
                 "Induced", " ", "derivatives", " ", "of", " ", "non"}], "-", 
                 
                 RowBox[{
                 "spatial", " ", "objects", " ", "are", " ", "not", " ", 
                  "accepted"}]}], ",", " ", 
                RowBox[{"not", " ", "even", " ", "divergencies"}]}], " ", 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"covd", "[", 
                 RowBox[{"_", "?", "GIndexQ"}], "]"}], "[", "expr_", "]"}], ":=", 
               RowBox[{"$Failed", "/;", 
                RowBox[{
                 RowBox[{"Not", "@", 
                  RowBox[{"isProductQ", "[", 
                   RowBox[{
                    RowBox[{"Head", "[", "expr", "]"}], ",", "Times"}], 
                   "]"}]}], "&&", 
                 RowBox[{"Not", "@", 
                  RowBox[{
                   RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
                   "expr", "]"}]}], "&&", 
                 RowBox[{"Message", "[", 
                  RowBox[{
                   RowBox[{"Validate", "::", "nonproj"}], ",", "expr"}], 
                  "]"}]}]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"Protect", "[", 
               RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Special", " ", "definitions"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"metric", "/:", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"-", "a_Symbol"}], ",", 
               RowBox[{"-", "b_Symbol"}]}], "]"}], "]"}], ":=", 
            RowBox[{"$ExtrinsicKSign", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"extrinsicKname", "[", 
                RowBox[{
                 RowBox[{"-", "a"}], ",", 
                 RowBox[{"-", "b"}]}], "]"}], "+", 
               RowBox[{"extrinsicKname", "[", 
                RowBox[{
                 RowBox[{"-", "b"}], ",", 
                 RowBox[{"-", "a"}]}], "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"metric", "/:", " ", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
             RowBox[{"metric", "[", 
              RowBox[{"a_Symbol", ",", 
               RowBox[{"-", "b_Symbol"}]}], "]"}], "]"}], ":=", 
            RowBox[{
             RowBox[{"-", "$AccelerationSign"}], " ", 
             RowBox[{"accelerationname", "[", 
              RowBox[{"-", "b"}], "]"}], 
             RowBox[{"vector", "[", "a", "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"metric", "/:", " ", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
             RowBox[{"metric", "[", 
              RowBox[{
               RowBox[{"-", "a_Symbol"}], ",", "b_Symbol"}], "]"}], "]"}], ":=", 
            RowBox[{
             RowBox[{"-", "$AccelerationSign"}], " ", 
             RowBox[{"accelerationname", "[", 
              RowBox[{"-", "a"}], "]"}], 
             RowBox[{"vector", "[", "b", "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"metric", "/:", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
             RowBox[{"metric", "[", 
              RowBox[{"a_Symbol", ",", "b_Symbol"}], "]"}], "]"}], ":=", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "$ExtrinsicKSign"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"extrinsicKname", "[", 
                 RowBox[{"a", ",", "b"}], "]"}], "+", 
                RowBox[{"extrinsicKname", "[", 
                 RowBox[{"b", ",", "a"}], "]"}]}], ")"}]}], "-", 
             RowBox[{"$AccelerationSign", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"vector", "[", "a", "]"}], 
                 RowBox[{"accelerationname", "[", "b", "]"}]}], "+", 
                RowBox[{
                 RowBox[{"vector", "[", "b", "]"}], 
                 RowBox[{"accelerationname", "[", "a", "]"}]}]}], ")"}]}]}]}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"vector", "/:", " ", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
             RowBox[{"vector", "[", "a_Symbol", "]"}], "]"}], ":=", "0"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"vector", "/:", " ", 
            RowBox[{
             RowBox[{"LieD", "[", 
              RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
             RowBox[{"vector", "[", 
              RowBox[{"-", "a_Symbol"}], "]"}], "]"}], ":=", 
            RowBox[{"$AccelerationSign", " ", "norm", " ", 
             RowBox[{"accelerationname", "[", 
              RowBox[{"-", "a"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"prot", "=", 
               RowBox[{"Unprotect", "[", 
                RowBox[{"{", 
                 RowBox[{"superepsilonname", ",", "epsilonname"}], "}"}], 
                "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"superepsilonname", "/:", " ", 
               RowBox[{
                RowBox[{"LieD", "[", 
                 RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
                RowBox[{"superepsilonname", "[", 
                 RowBox[{"inds__", "?", "DownIndexQ"}], "]"}], "]"}], ":=", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"dummy", "=", 
                   RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
                 RowBox[{"$ExtrinsicKSign", " ", 
                  RowBox[{"extrinsicKname", "[", 
                   RowBox[{"dummy", ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], 
                  RowBox[{"superepsilonname", "[", "inds", "]"}]}]}], "]"}]}],
               ";", "\[IndentingNewLine]", 
              RowBox[{"superepsilonname", "/:", " ", 
               RowBox[{
                RowBox[{"LieD", "[", 
                 RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
                RowBox[{"superepsilonname", "[", 
                 RowBox[{"inds__", "?", "UpIndexQ"}], "]"}], "]"}], ":=", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"dummy", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
                   RowBox[{"first", "=", 
                    RowBox[{"First", "[", 
                    RowBox[{"{", "inds", "}"}], "]"}]}]}], "}"}], ",", 
                 RowBox[{
                  RowBox[{"-", "$ExtrinsicKSign"}], " ", 
                  RowBox[{"extrinsicKname", "[", 
                   RowBox[{"dummy", ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], 
                  RowBox[{"superepsilonname", "[", "inds", "]"}]}]}], "]"}]}],
               ";", "\[IndentingNewLine]", 
              RowBox[{"epsilonname", "/:", " ", 
               RowBox[{
                RowBox[{"LieD", "[", 
                 RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
                RowBox[{"epsilonname", "[", 
                 RowBox[{"inds__", "?", "DownIndexQ"}], "]"}], "]"}], ":=", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"dummy", "=", 
                   RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
                 RowBox[{"$ExtrinsicKSign", " ", 
                  RowBox[{"extrinsicKname", "[", 
                   RowBox[{"dummy", ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], 
                  RowBox[{"epsilonname", "[", "inds", "]"}]}]}], "]"}]}], ";",
               "\[IndentingNewLine]", 
              RowBox[{"epsilonname", "/:", " ", 
               RowBox[{
                RowBox[{"LieD", "[", 
                 RowBox[{"vector", "[", "_", "]"}], "]"}], "[", 
                RowBox[{"epsilonname", "[", 
                 RowBox[{"inds__", "?", "UpIndexQ"}], "]"}], "]"}], ":=", 
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"dummy", "=", 
                    RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
                   RowBox[{"first", "=", 
                    RowBox[{"First", "[", 
                    RowBox[{"{", "inds", "}"}], "]"}]}]}], "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "$ExtrinsicKSign"}], " ", 
                   RowBox[{"extrinsicKname", "[", 
                    RowBox[{"dummy", ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], 
                   RowBox[{"epsilonname", "[", "inds", "]"}]}], "+", 
                  RowBox[{"$AccelerationSign", " ", "norm", " ", 
                   RowBox[{"accelerationname", "[", 
                    RowBox[{"-", "dummy"}], "]"}], 
                   RowBox[{"superepsilonname", "[", 
                    RowBox[{"dummy", ",", "inds"}], "]"}]}]}]}], "]"}]}], ";",
               "\[IndentingNewLine]", 
              RowBox[{"Protect", "[", 
               RowBox[{"Evaluate", "[", "prot", "]"}], "]"}]}]}], 
            "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"Gauss", " ", "Codazzi", " ", "rule"}], ",", " ", 
          RowBox[{"for", " ", "abstract", " ", 
           RowBox[{"indices", ".", " ", "Only"}], " ", "for", " ", 
           RowBox[{"Riemann", ".", " ", "Norms"}], " ", "are", " ", 
           "wrong"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"riemann", "=", 
             RowBox[{"Riemann", "[", "covd", "]"}]}], ",", 
            RowBox[{"superRiemann", "=", 
             RowBox[{"Riemann", "[", "superCD", "]"}]}], ",", 
            RowBox[{"superRicci", "=", 
             RowBox[{"Ricci", "[", "superCD", "]"}]}], ",", 
            RowBox[{"superRicciScalar", "=", 
             RowBox[{"RicciScalar", "[", "superCD", "]"}]}], ",", 
            RowBox[{"K", "=", "extrinsicKname"}], ",", 
            RowBox[{"AA", "=", "accelerationname"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"GaussCodazziRules", "[", "metric", "]"}], ":=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"superRiemann", "[", 
               RowBox[{
                RowBox[{"a_", "?", "AIndexQ"}], ",", 
                RowBox[{"b_", "?", "AIndexQ"}], ",", 
                RowBox[{"c_", "?", "AIndexQ"}], ",", 
                RowBox[{"d_", "?", "AIndexQ"}]}], "]"}], "\[RuleDelayed]", 
              RowBox[{"Module", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"e", "=", 
                   RowBox[{"DummyIn", "@", "vbundle"}]}], ",", "PDK"}], "}"}],
                 ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"PDK", "[", 
                   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
                  RowBox[{"projectorname", "[", 
                   RowBox[{
                    RowBox[{"vector", "[", "e", "]"}], " ", 
                    RowBox[{
                    RowBox[{"superCD", "[", 
                    RowBox[{"-", "e"}], "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"x", ",", "y"}], "]"}]}]}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"riemann", "[", 
                   RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], "+", 
                  RowBox[{"$RiemannSign", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "c"}], "]"}]}], " ", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "d"}], "]"}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "d"}], "]"}], " ", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "c"}], "]"}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"AA", "[", "b", "]"}], " ", 
                    RowBox[{"AA", "[", "d", "]"}], " ", 
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "c", "]"}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "e"}], "]"}], " ", 
                    RowBox[{"K", "[", 
                    RowBox[{"d", ",", 
                    RowBox[{"-", "e"}]}], "]"}], " ", 
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "c", "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "+", 
                    RowBox[{
                    RowBox[{"AA", "[", "a", "]"}], " ", 
                    RowBox[{"AA", "[", "d", "]"}], " ", 
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "c", "]"}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "e"}], "]"}], " ", 
                    RowBox[{"K", "[", 
                    RowBox[{"d", ",", 
                    RowBox[{"-", "e"}]}], "]"}], " ", 
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "c", "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "+", 
                    RowBox[{
                    RowBox[{"AA", "[", "b", "]"}], " ", 
                    RowBox[{"AA", "[", "c", "]"}], " ", 
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "d", "]"}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "e"}], "]"}], " ", 
                    RowBox[{"K", "[", 
                    RowBox[{"c", ",", 
                    RowBox[{"-", "e"}]}], "]"}], " ", 
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "d", "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "-", 
                    RowBox[{
                    RowBox[{"AA", "[", "a", "]"}], " ", 
                    RowBox[{"AA", "[", "c", "]"}], " ", 
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{
                    RowBox[{"vector", "[", "d", "]"}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "e"}], "]"}], " ", 
                    RowBox[{"K", "[", 
                    RowBox[{"c", ",", 
                    RowBox[{"-", "e"}]}], "]"}], " ", 
                    RowBox[{"vector", "[", "b", "]"}], 
                    RowBox[{
                    RowBox[{"vector", "[", "d", "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "+", 
                    RowBox[{"$ExtrinsicKSign", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{"vector", "[", "c", "]"}], 
                    RowBox[{
                    RowBox[{"PDK", "[", 
                    RowBox[{"a", ",", "d"}], "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{"vector", "[", "d", "]"}], 
                    RowBox[{
                    RowBox[{"PDK", "[", 
                    RowBox[{"b", ",", "c"}], "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{"vector", "[", "c", "]"}], 
                    RowBox[{
                    RowBox[{"PDK", "[", 
                    RowBox[{"b", ",", "d"}], "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{"vector", "[", "d", "]"}], 
                    RowBox[{
                    RowBox[{"PDK", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], "/", 
                    RowBox[{"norm", "^", "2"}]}]}], " ", "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "d", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "a", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "c"}], "]"}]}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "c", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "a", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "d"}], "]"}]}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "d", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "b", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "c"}], "]"}]}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "c", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "b", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "d"}], "]"}]}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "c", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "d"}], "]"}]}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "c", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "d"}], "]"}]}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "d", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"a", ",", "c"}], "]"}]}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "d", "]"}], "@", 
                    RowBox[{"K", "[", 
                    RowBox[{"b", ",", "c"}], "]"}]}], "/", "norm"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"$AccelerationSign", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{"vector", "[", "d", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "c", "]"}], "@", 
                    RowBox[{"AA", "[", "a", "]"}]}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{"vector", "[", "d", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "c", "]"}], "@", 
                    RowBox[{"AA", "[", "b", "]"}]}], "/", "norm"}]}], "-", 
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], " ", 
                    RowBox[{"vector", "[", "c", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "d", "]"}], "@", 
                    RowBox[{"AA", "[", "a", "]"}]}], "/", "norm"}]}], "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], " ", 
                    RowBox[{"vector", "[", "c", "]"}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"covd", "[", "d", "]"}], "@", 
                    RowBox[{"AA", "[", "b", "]"}]}], "/", "norm"}]}]}], 
                    ")"}]}]}], ")"}]}]}]}]}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"superRicci", "[", 
               RowBox[{
                RowBox[{"a_", "?", "AIndexQ"}], ",", 
                RowBox[{"b_", "?", "AIndexQ"}]}], "]"}], "\[RuleDelayed]", 
              RowBox[{"Module", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"c", "=", 
                  RowBox[{"DummyIn", "@", "vbundle"}]}], "}"}], ",", 
                RowBox[{"ReleaseHold", "[", 
                 RowBox[{
                  RowBox[{"Hold", "[", 
                   RowBox[{"superRiemann", "[", 
                    RowBox[{"a", ",", 
                    RowBox[{"-", "c"}], ",", "b", ",", "c"}], "]"}], "]"}], "/.", 
                  RowBox[{"GaussCodazziRules", "[", "metric", "]"}]}], 
                 "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"superRicciScalar", "[", "]"}], "\[RuleDelayed]", 
              RowBox[{"Module", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "=", 
                   RowBox[{"DummyIn", "@", "vbundle"}]}], ",", 
                  RowBox[{"b", "=", 
                   RowBox[{"DummyIn", "@", "vbundle"}]}]}], "}"}], ",", 
                RowBox[{"Expand", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "b"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"vector", "[", "a", "]"}], 
                    RowBox[{
                    RowBox[{"vector", "[", "b", "]"}], "/", "norm"}]}]}], 
                   ")"}], 
                  RowBox[{"ReleaseHold", "[", 
                   RowBox[{
                    RowBox[{"Hold", "[", 
                    RowBox[{"superRicci", "[", 
                    RowBox[{
                    RowBox[{"-", "a"}], ",", 
                    RowBox[{"-", "b"}]}], "]"}], "]"}], "/.", 
                    RowBox[{"GaussCodazziRules", "[", "metric", "]"}]}], 
                   "]"}]}], "]"}]}], "]"}]}]}], "}"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"$ProtectNewSymbols", ",", 
          RowBox[{"Protect", "[", 
           RowBox[{
           "extrinsicKname", ",", "accelerationname", ",", "projectorname"}], 
           "]"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VectorOfInducedMetric", "[", 
    RowBox[{"metric_Symbol", "?", "MetricQ"}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VectorOfInducedMetric", "[", "x_", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"VectorOfInducedMetric", "::", "unknown"}], ",", 
      "\"\<induced metric\>\"", ",", "x"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"VectorOfInducedMetric", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "VectorOfInducedMetric", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6553108d-c3e4-4384-8f07-76c589db0ce8"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.3.3. More on induced metrics", \
"Subsubsection",ExpressionUUID->"7d41c189-56f8-4791-aa67-6a9308883d61"],

Cell[BoxData[
 RowBox[{
  RowBox[{"deflistableCovDs", "[", "ProjectDerivative", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cc7beaf5-46e5-40c2-b2a7-6b358035d9c4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"deflistableMetrics", "[", "function_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", "=", 
      RowBox[{"SymbolJoin", "[", 
       RowBox[{"function", ",", "\"\<Rules\>\""}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"function", "[", "expr_", "]"}], ":=", 
      RowBox[{"function", "[", 
       RowBox[{"expr", ",", "$Metrics"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"function", "[", 
       RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
      RowBox[{"Fold", "[", 
       RowBox[{"function", ",", "expr", ",", "list"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"function", "[", 
       RowBox[{"expr_", ",", 
        RowBox[{"metric_Symbol", "?", "MetricQ"}]}], "]"}], ":=", 
      RowBox[{"expr", "/.", 
       RowBox[{"rules", "[", "metric", "]"}]}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"SetNumberOfArguments", "[", 
      RowBox[{"function", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Protect", "[", "function", "]"}], ";"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"deflistableMetrics", "/@", 
   RowBox[{"{", "MetricToProjector", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b8c8c24c-4a07-4c41-aaf8-d3dcccf6e924"],

Cell[BoxData[
 RowBox[{"$Projectors", ":=", 
  RowBox[{"Select", "[", 
   RowBox[{"$Metrics", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"InducedFrom", "[", "#", "]"}], "=!=", "Null"}], ")"}], 
     "&"}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7ca1cbd7-d13f-47d4-b760-2d7bb0622e38"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"deflistableProjectors", "[", "function_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", "=", 
      RowBox[{"SymbolJoin", "[", 
       RowBox[{"function", ",", "\"\<Rules\>\""}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"function", "[", "expr_", "]"}], ":=", 
      RowBox[{"function", "[", 
       RowBox[{"expr", ",", "$Projectors"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"function", "[", 
       RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
      RowBox[{"Fold", "[", 
       RowBox[{"function", ",", "expr", ",", "list"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"function", "[", 
       RowBox[{"expr_", ",", 
        RowBox[{"metric_Symbol", "?", "MetricQ"}]}], "]"}], ":=", 
      RowBox[{"expr", "//.", 
       RowBox[{"rules", "[", "metric", "]"}]}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"SetNumberOfArguments", "[", 
      RowBox[{"function", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Protect", "[", "function", "]"}], ";"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"deflistableProjectors", "/@", 
   RowBox[{"{", 
    RowBox[{
    "ExtrinsicKToGradNormal", ",", "GradNormalToExtrinsicK", ",", 
     "ProjectorToMetric", ",", "GaussCodazzi"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"0cddcb18-d86e-4c73-a43d-84a0b9083465"],

Cell["\<\
Note that deflistableProjects uses //. while deflistableMetrics and \
deflistableCovDs use /.\
\>", "Text",ExpressionUUID->"ded36203-a283-423f-8322-bf1b36f99cad"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MetricToProjectorRules", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ProjectorToMetricRules", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtrinsicKToGradNormalRules", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GradNormalToExtrinsicKRules", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ProjectDerivativeRules", "[", "_", "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1c26a9f7-0f3a-4923-a169-a70480c27181"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"project", "[", "projector_", "]"}], "[", 
   RowBox[{"expr_", ",", "index_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"dummy", "=", 
      RowBox[{"DummyAs", "[", "index", "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"projector", "[", 
      RowBox[{"index", ",", 
       RowBox[{"-", "dummy"}]}], "]"}], 
     RowBox[{"ReplaceIndex", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"index", "\[Rule]", "dummy"}]}], "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"846911a3-4b5c-45da-9598-64166aa63811"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProjectWith", "[", "projector_", "]"}], "[", "0", "]"}], ":=", 
   "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProjectWith", "[", "projector_", "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{"Expand", "@", 
    RowBox[{"Fold", "[", 
     RowBox[{
      RowBox[{"project", "[", "projector", "]"}], ",", "expr", ",", 
      RowBox[{"List", "@@", 
       RowBox[{"FindFreeIndices", "[", "expr", "]"}]}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ProjectWith", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d46b49f5-0d2e-45e1-991c-d1a4de69f7a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.3.4. InducedDecomposition", \
"Subsubsection",ExpressionUUID->"d6573af7-e0cd-48e1-bb03-2db7237211f8"],

Cell["\<\
This rather complicated construction decomposes all tensors in a given \
expression in their projected and orthogonal parts. The main idea is that in \
the pairs n[a]n[b] one of the vectors will be finally inside a projector and \
the other one will be outside the projector. The inout constructs contain two \
indices: the index of n inside the projector and the index of n outside the \
projector.\
\>", "Text",ExpressionUUID->"4414d99d-0275-48db-932e-53da1a096f3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Pair", " ", "of", " ", "indices", " ", "for", " ", "the", " ", "pair", 
    " ", 
    RowBox[{"vector", "[", ".", "]"}], 
    RowBox[{"vector", "[", ".", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"pair", "[", "index_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"inout", "[", 
        RowBox[{"index", ",", 
         RowBox[{"DummyAs", "[", "index", "]"}]}], "]"}]}], "}"}]}], ";"}], 
   "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"vectors", " ", "inside", " ", "the", " ", "projector"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inside", "[", 
      RowBox[{"inouts_", ",", "vector_"}], "]"}], ":=", 
     RowBox[{"inouts", "/.", 
      RowBox[{
       RowBox[{"inout", "[", 
        RowBox[{"_", ",", "index_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"vector", "[", 
        RowBox[{"ChangeIndex", "@", "index"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"vectors", " ", "outside", " ", "the", " ", "projector"}], " ", 
    "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"outside", "[", 
      RowBox[{"inouts_", ",", "vector_"}], "]"}], ":=", 
     RowBox[{"inouts", "/.", 
      RowBox[{
       RowBox[{"inout", "[", 
        RowBox[{"index_", ",", "_"}], "]"}], "\[Rule]", 
       RowBox[{"vector", "[", "index", "]"}]}]}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Index", " ", "rules", " ", "to", " ", "change", " ", "indices", " ", 
     "of", " ", "expr"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inoutrules", "[", "1", "]"}], ":=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inoutrules", "[", "inouts_", "]"}], ":=", 
     RowBox[{
      RowBox[{"ListOfFactors", "[", "inouts", "]"}], "/.", 
      RowBox[{"inout", "\[Rule]", "Rule"}]}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Construct", " ", "expression", " ", "inside", " ", "the", " ", 
     "projector"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"inoutproject", "[", 
     RowBox[{"expr_", ",", "inouts_", ",", "vector_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"ReplaceIndex", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"inoutrules", "[", "inouts", "]"}]}], "]"}], 
     RowBox[{"inside", "[", 
      RowBox[{"inouts", ",", "vector"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Construct", " ", "a", " ", "term", " ", "v", "*", "v", "*"}], 
      "..."}], "*", 
     RowBox[{"projector", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "*", "v", "*"}], "..."}], "*", "expr"}], "]"}]}], " ", 
    "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"inoutlength", "[", "1", "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inoutlength", "[", "_inout", "]"}], ":=", "1"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inoutlength", "[", "list__Times", "]"}], ":=", 
     RowBox[{"Length", "[", "list", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inoutall", "[", 
      RowBox[{"expr_", ",", "projector_", ",", "vector_", ",", "norm_"}], 
      "]"}], "[", "inouts_", "]"}], ":=", 
    RowBox[{
     RowBox[{"projector", "[", 
      RowBox[{"inoutproject", "[", 
       RowBox[{"expr", ",", "inouts", ",", "vector"}], "]"}], "]"}], 
     RowBox[{
      RowBox[{"outside", "[", 
       RowBox[{"inouts", ",", "vector"}], "]"}], "/", 
      RowBox[{"norm", "^", 
       RowBox[{"(", 
        RowBox[{"inoutlength", "[", "inouts", "]"}], 
        ")"}]}]}]}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"36ef8182-cdbc-4a79-99fe-992e00810ac2"],

Cell["User driver (metric is the induced metric):", \
"Text",ExpressionUUID->"de86b4f0-1000-4db5-b144-a0625a0db6e1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InducedDecomposition", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"metric_", ",", "vector_"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"inducedDecomposition", "[", 
    RowBox[{
     RowBox[{"Expand", "[", "expr", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Projector", "[", "metric", "]"}], ",", "vector", ",", 
       RowBox[{"normofvector", "[", 
        RowBox[{"vector", ",", "metric"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"InducedDecomposition", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "InducedDecomposition", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3796fcb4-0a66-4853-afff-0be2cb1e7b80"],

Cell["Internal functions for decomposition:", \
"Text",ExpressionUUID->"ecdacbff-52d4-4f7a-be3a-37c7108014dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"normofvector", "[", 
    RowBox[{"vector_", ",", "metric_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vbundle", "=", 
       RowBox[{"VBundleOfMetric", "[", "metric", "]"}]}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dummy1", "=", 
          RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
         RowBox[{"dummy2", "=", 
          RowBox[{"DummyIn", "[", "vbundle", "]"}]}]}], "}"}], ",", 
       RowBox[{"Scalar", "[", 
        RowBox[{"ContractMetric", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FirstMetricOfVBundle", "[", "vbundle", "]"}], "[", 
           RowBox[{
            RowBox[{"-", "dummy1"}], ",", 
            RowBox[{"-", "dummy2"}]}], "]"}], 
          RowBox[{"vector", "[", "dummy1", "]"}], 
          RowBox[{"vector", "[", "dummy2", "]"}]}], "]"}], "]"}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"77432756-228d-45ed-8da5-9a7a13eb0969"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Recursive", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{"expr_Plus", ",", "struct_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"inducedDecomposition", "[", 
        RowBox[{"#", ",", "struct"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{"expr_SeriesData", ",", "struct_"}], "]"}], ":=", 
     RowBox[{"SeriesDataMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"inducedDecomposition", "[", 
         RowBox[{"#", ",", "struct"}], "]"}], "&"}], ",", "expr"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{"expr_Times", ",", "struct_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"inducedDecomposition", "[", 
        RowBox[{"#", ",", "struct"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"_", "?", "ProductQ"}], "[", "___", "]"}]}], ",", 
       "struct_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"inducedDecomposition", "[", 
        RowBox[{"#", ",", "struct"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Perform", " ", "actual", " ", "decomposition"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"_", "?", "xTensorQ"}], "[", "__", "]"}]}], ",", "struct_"}],
       "]"}], ":=", 
     RowBox[{"inducedDecompositionObject", "[", 
      RowBox[{"expr", ",", "struct"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"_", "?", "InertHeadQ"}], "[", 
         RowBox[{"_", ",", "z___"}], "]"}]}], ",", "struct_"}], "]"}], ":=", 
     RowBox[{"inducedDecompositionObject", "[", 
      RowBox[{"expr", ",", "struct"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"_", "?", "FirstDerQ"}], "[", "_", "]"}]}], ",", "struct_"}],
       "]"}], ":=", 
     RowBox[{"inducedDecompositionObject", "[", 
      RowBox[{"expr", ",", "struct"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"inducedDecomposition", "[", 
      RowBox[{"expr_", ",", "struct_"}], "]"}], ":=", "expr"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7f0a1d51-f0c0-4991-9ebe-fe3f81d0e95a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"inducedDecompositionObject", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"projector_", ",", "vector_", ",", "norm_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"frees", "=", 
       RowBox[{"FindFreeIndices", "[", "expr", "]"}]}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"frees", "===", 
        RowBox[{"IndexList", "[", "]"}]}], ",", "expr", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Plus", "@@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"inoutall", "[", 
           RowBox[{"expr", ",", "projector", ",", "vector", ",", "norm"}], 
           "]"}], ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"Outer", "[", 
            RowBox[{"Times", ",", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"(", 
               RowBox[{"pair", "/@", "frees"}], ")"}]}]}], "]"}]}]}], 
         "]"}]}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"eddb82c9-3b2a-4c3a-ad28-c7ee7738eddc"],

Cell["\<\
It is not clear how to use this function on subexpressions (Apr 2011, added \
LieD as suggested by Cyril):\
\>", "Text",ExpressionUUID->"fbacc7a3-b352-45c1-83f6-db4d96fb35e4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ToInducedDerivative", "[", 
    RowBox[{"expr_", ",", "supercd_", ",", "cd_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"indmetric", "=", 
       RowBox[{"MetricOfCovD", "[", "cd", "]"}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vector", "=", 
         RowBox[{"Last", "@", 
          RowBox[{"InducedFrom", "[", "indmetric", "]"}]}]}], "}"}], ",", 
       RowBox[{"expr", "/.", 
        RowBox[{
         RowBox[{
          RowBox[{"supercd", "[", "ind_", "]"}], "[", 
          RowBox[{"expr1", ":", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"_", "?", "xTensorQ"}], "[", "___", "]"}], "|", 
             RowBox[{
              RowBox[{"_", "?", "InertHeadQ"}], "[", "___", "]"}], "|", 
             RowBox[{
              RowBox[{"cd", "[", "_", "]"}], "[", "_", "]"}], "|", 
             RowBox[{
              RowBox[{"LieD", "[", "_", "]"}], "[", "_", "]"}]}], ")"}]}], 
          "]"}], "\[RuleDelayed]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"frees", "=", 
              RowBox[{"FindFreeIndices", "[", "expr1", "]"}]}], ",", 
             RowBox[{"norm", "=", 
              RowBox[{"normofvector", "[", 
               RowBox[{"vector", ",", 
                RowBox[{"MetricOfCovD", "[", "supercd", "]"}]}], "]"}]}]}], 
            "}"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"cd", "[", "ind", "]"}], "[", "expr1", "]"}], "+", 
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"dummy", "=", 
                 RowBox[{"DummyAs", "[", "ind", "]"}]}], "}"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"vector", "[", "ind", "]"}], "/", "norm"}], " ", 
                RowBox[{"DirCovDToLieD", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"vector", "[", 
                    RowBox[{"-", "dummy"}], "]"}], " ", 
                   RowBox[{
                    RowBox[{"supercd", "[", "dummy", "]"}], "[", "expr1", 
                    "]"}]}], ",", "vector"}], "]"}]}]}], "]"}], "-", 
             RowBox[{
              RowBox[{"$ExtrinsicKSign", "/", "norm"}], " ", 
              RowBox[{"Plus", "@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"With", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"dummy2", "=", 
                    RowBox[{"DummyAs", "[", "#", "]"}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"vector", "[", "#", "]"}], 
                    RowBox[{
                    RowBox[{"ExtrinsicK", "[", "indmetric", "]"}], "[", 
                    RowBox[{"ind", ",", 
                    RowBox[{"-", "dummy2"}]}], "]"}], 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"expr1", ",", 
                    RowBox[{"#", "\[Rule]", "dummy2"}]}], "]"}]}]}], "]"}], 
                  "&"}], "/@", "frees"}], ")"}]}]}]}], "/;", 
            RowBox[{
             RowBox[{"OrthogonalToVectorQ", "[", "vector", "]"}], "[", 
             "expr1", "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ToInducedDerivative", ",", "3"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ToInducedDerivative", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"12d69f9e-a207-4f57-a5f9-25be45698365"]
}, Closed]],

Cell[CellGroupData[{

Cell["14.3.5. Examples", \
"Subsubsection",ExpressionUUID->"dbf4ac56-aec7-4fe9-ba5f-ff66ad2c90f0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9660df37-bf40-4e83-8116-bf351ae481f5"],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"abe0e724-d25f-40c8-bbe9-850b7f2394b4"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"38208820-047f-4cb4-b72a-2b5fd54d36a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"8479dcf6-bd2a-44a1-bd1f-d6f560cb71b7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7b740ce5-6047-45ef-8f2c-d948a7c8c448"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CD", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"056912ee-3137-44b6-bdb6-9c8ca71d4944"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4db25c2c-1261-4d92-a83b-17e458424392"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"aa18cdca-f75e-4cfa-bfdd-7813d0e9550d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"02ef1c72-a1ec-423d-8381-96bc70705d5e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"757b99eb-1600-4541-bc4f-d0de493f2022"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"45ee7d5e-e03f-4793-91ac-2574ac7230f7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bc10857b-a16f-4223-9810-26d82695d858"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cec74a52-132e-4d02-8c9d-365295d5d597"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"21c7b95c-a8a0-44dc-b6f8-171665ddb4ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"554acfe5-b4ca-4f05-9d81-bd89e527b9d2"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"3953e53c-7150-4ef6-8603-f2e698c11c65"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"711fd699-3386-4626-bba6-11239d16634f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCD[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d36c78db-1e75-4e71-b502-d76648e23e77"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ef369692-ae87-4ea2-8180-425586f398aa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"49946b8c-2a37-4062-9c24-263905726609"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"da1137ae-4a2b-4ec6-a3e4-fe8a9ec78ada"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"88f2cd5e-8813-40bd-b1d0-27414d7ee724"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"1825408b-ad54-4716-aed4-1f81af8cdc8f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetricg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetricg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"44543ec1-8da9-4066-b120-b9564a42c2fd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"u", "[", "A", "]"}], ",", "M2", ",", 
   RowBox[{"FrobeniusQ", "\[Rule]", "True"}], ",", 
   RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"a14d3409-d783-4a05-9f4e-873932e3df34"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"u", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`u[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d2e26a0a-0890-4cc4-89c4-5b3510be2707"]
}, Open  ]],

Cell["Normalization:", \
"Text",ExpressionUUID->"24cb2b34-353a-4e4e-9d3e-b1b8c30998bb"],

Cell[BoxData[
 RowBox[{"u", "/:", 
  RowBox[{
   RowBox[{"u", "[", "A_", "]"}], 
   RowBox[{"u", "[", 
    RowBox[{"-", "A_"}], "]"}]}], ":=", 
  "hello"}]], "Input",ExpressionUUID->"4d873e04-804c-42c9-b4c7-2cdebb930970"],

Cell[BoxData[
 RowBox[{"u", "/:", 
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A_"}], ",", 
     RowBox[{"-", "B_"}]}], "]"}], 
   RowBox[{"u", "[", "A_", "]"}], 
   RowBox[{"u", "[", "B_", "]"}]}], ":=", 
  "hello"}]], "Input",ExpressionUUID->"c48be59f-d187-4943-ac10-e7cfce5caf2b"],

Cell["Induced metric:", \
"Text",ExpressionUUID->"341816db-300e-4c8d-b6ad-72e47789884f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "cd", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<D\>\""}], "}"}], ",", 
   RowBox[{"InducedFrom", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"metricg", ",", "u"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"0cf458b2-bb2c-4665-a1f6-aa4a04dab7ef"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "old"}], "MessageName"], ":", 
  " ", "\<\"There are already metrics \[NoBreak]\\!\\({metricg}\\)\[NoBreak] \
in vbundle \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]M2\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], TangentM2, Rule[Editable, False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e9d73efe-7562-4ad7-aab1-bc8655b3ee50"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`h[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"121d814b-6e5f-49ee-b5e1-c9a37b73bdae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonh", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonh[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e6c4faf0-79af-4a35-9a24-05387fc1970d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"868a7f0e-b78b-4b0f-87da-f0a5600c03d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Torsioncd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`Torsioncd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"324daae8-84ac-4868-97f7-b61883bc899a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Christoffelcd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`Christoffelcd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"04db86e8-90b6-449b-a1b9-c9d37d94aa14"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Riemanncd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`Riemanncd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a3fcb328-9f53-4e78-9270-5e1f147f29aa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Riccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`Riccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4818a202-c03b-4507-a176-6adf5e164e4d"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"c7ce7699-1509-446f-aefd-72b902452a92"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarcd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarcd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b992a739-77ef-43bb-bf91-25ab41d7d37e"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"ba896e3e-7ff3-45b1-bf27-1ced8c0f6fa1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Einsteincd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`Einsteincd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f11bcc36-0889-4ee9-a28c-dc7455579f43"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Weylcd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`Weylcd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"205017a2-322f-4cfb-9314-76fc5e38c339"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRiccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRiccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a1732902-9a8c-4714-8914-ad3477eb684a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"Kretschmanncd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`Kretschmanncd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a203540c-fc24-4885-a2ad-2835343a3ac9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"8544b56d-af39-48dc-8a79-1cfe10e901be"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"fa5e8aac-26cc-4d9b-91df-853b7132b053"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"e31af516-b7c6-4938-8e6a-6501d29a821a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Deth", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Deth[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"37820472-0d66-4bc2-88d2-ad40fc3df539"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"extrinsic curvature tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ExtrinsicKh", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Associated to vector u\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "extrinsic curvature tensor ", 
   $CellContext`ExtrinsicKh[$CellContext`A, $CellContext`B], ". ", 
   "Associated to vector u"],
  Editable->
   False]], "Print",ExpressionUUID->"ce2625c3-373a-44e0-bfff-cb5251707c97"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"acceleration vector \"\>", "\[InvisibleSpace]", 
   RowBox[{"Accelerationu", "[", "A", "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Associated to vector u\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "acceleration vector ", 
   $CellContext`Accelerationu[$CellContext`A], ". ", "Associated to vector u"],
  Editable->
   False]], "Print",ExpressionUUID->"e430573e-7f6a-44f4-aa1a-6fd976ca6cc8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefInertHead", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"projector inert-head \"\>", "\[InvisibleSpace]", 
   "Projectorh", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefInertHead, ": Defining ", 
   "projector inert-head ", $CellContext`Projectorh, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2870443a-4741-4126-bba0-620958b18d51"]
}, Open  ]]
}, Open  ]],

Cell["Decompositions:", \
"Text",ExpressionUUID->"926412e3-a8e0-4aaa-9bb0-7449cdd9fc02"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"InducedDecomposition", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"h", ",", "u"}], "}"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"91214ba8-4760-4947-9c98-d9037abd49bc"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    RowBox[{
     UnderscriptBox["P", "h"], "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B", "C"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B, C],
      Editable->False], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Projectorh[
    $CellContext`T[$CellContext`A, $CellContext`B, C]],
   Editable->False], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "B", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`B, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[$CellContext`T[
       D, $CellContext`B, C] $CellContext`u[-D]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`A],
     Editable->False]}], 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], "hello", 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`hello],
    Editable->False]], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "D", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, D, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[$CellContext`T[$CellContext`A, D, 
        C] $CellContext`u[-D]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`B],
     Editable->False]}], 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], "hello", 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`hello],
    Editable->False]], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "F", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`F, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"F"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`F],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[($CellContext`T[
        D, $CellContext`F, C] $CellContext`u[-
         D]) $CellContext`u[-$CellContext`F]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`B],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], "2"]], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "B", "D"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, $CellContext`B, D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[$CellContext`T[$CellContext`A, $CellContext`B, 
        D] $CellContext`u[-D]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], "hello", 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`hello],
    Editable->False]], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "B", "F"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`B, $CellContext`F],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"F"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`F],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[($CellContext`T[
        D, $CellContext`B, $CellContext`F] $CellContext`u[-
         D]) $CellContext`u[-$CellContext`F]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], "2"]], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "D", "F"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, D, $CellContext`F],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"F"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`F],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[($CellContext`T[$CellContext`A, 
         D, $CellContext`F] $CellContext`u[-
         D]) $CellContext`u[-$CellContext`F]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], "2"]], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "B", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, $CellContext`B, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"C"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-C],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[(($CellContext`T[$CellContext`A, $CellContext`B, 
          C] $CellContext`u[-$CellContext`A]) \
$CellContext`u[-$CellContext`B]) $CellContext`u[-C]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], 
    "3"]]}]], \
"Output",ExpressionUUID->"e492d655-7438-4838-bdd9-d1aeaa1decbd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"-", "A"}], "]"}], "%"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"c3dc443f-7c32-4693-8a4d-9376f5ff28c8"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"hello", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "B", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`B, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[$CellContext`T[
       D, $CellContext`B, C] $CellContext`u[-D]],
     Editable->False]}], 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], "hello", 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`hello],
    Editable->False]], "+", 
  FractionBox[
   RowBox[{"hello", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "F", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`F, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"F"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`F],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[($CellContext`T[
        D, $CellContext`F, C] $CellContext`u[-
         D]) $CellContext`u[-$CellContext`F]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`B],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], "2"]], "+", 
  FractionBox[
   RowBox[{"hello", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "B", "F"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`B, $CellContext`F],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"F"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`F],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[($CellContext`T[
        D, $CellContext`B, $CellContext`F] $CellContext`u[-
         D]) $CellContext`u[-$CellContext`F]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], "2"]], "+", 
  FractionBox[
   RowBox[{"hello", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "B", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, $CellContext`B, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"C"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-C],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[(($CellContext`T[$CellContext`A, $CellContext`B, 
          C] $CellContext`u[-$CellContext`A]) \
$CellContext`u[-$CellContext`B]) $CellContext`u[-C]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], 
    "3"]]}]], \
"Output",ExpressionUUID->"c876d980-3dcf-47d4-9980-9d609e0bee8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"-", "B"}], "]"}], "%"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"83a9b5e2-4190-441c-b38e-928288379c5f"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox["hello", "2"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       UnderscriptBox["P", "h"], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"D", "F", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[D, $CellContext`F, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"F"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`F],
         Editable->False]}], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Projectorh[($CellContext`T[
        D, $CellContext`F, C] $CellContext`u[-
         D]) $CellContext`u[-$CellContext`F]],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], "2"]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["hello", "2"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "B", "C"},
                {" ", " ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, $CellContext`B, C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-$CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"u", 
             StyleBox[GridBox[{
                {" "},
                {"C"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[-C],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[(($CellContext`T[$CellContext`A, $CellContext`B, 
          C] $CellContext`u[-$CellContext`A]) \
$CellContext`u[-$CellContext`B]) $CellContext`u[-C]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[C],
     Editable->False]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], "hello", 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`hello],
     Editable->False], 
    "3"]]}]], \
"Output",ExpressionUUID->"fafb3baa-fa3d-4fc2-83a2-57bd8bb6c106"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"-", "C"}], "]"}], "%"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"35a43d2b-a61c-4b49-b5cb-cafdc6f441b7"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["hello", "3"], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "B", "C"},
               {" ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`B, C],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-C],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[(($CellContext`T[$CellContext`A, $CellContext`B, 
         C] $CellContext`u[-$CellContext`A]) $CellContext`u[-$CellContext`B]) \
$CellContext`u[-C]],
    Editable->False]}], 
  SuperscriptBox[
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], "hello", 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`hello],
    Editable->False], 
   "3"]]], "Output",ExpressionUUID->"01c2ff17-b456-4d73-8662-c742f032ef02"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{
  "hello", "\[Rule]", 
   "1"}]}]], "Input",ExpressionUUID->"081611a5-0e24-434e-9d8b-dabde9853324"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["(",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B", "C"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B, C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[-$CellContext`A],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {" "},
             {"B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[-$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {" "},
             {"C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[-C],
      Editable->False]}], 
    StyleBox[")",
     FontColor->RGBColor[1, 0, 0]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Scalar[(($CellContext`T[$CellContext`A, $CellContext`B, 
       C] $CellContext`u[-$CellContext`A]) $CellContext`u[-$CellContext`B]) \
$CellContext`u[-C]],
  Editable->
   False]], "Output",ExpressionUUID->"0f2e4893-e06c-4d5f-86ab-d7df7b870864"]
}, Open  ]],

Cell["\<\
However, this is not terribly smart (though the expression is syntactically \
incorrect):\
\>", "Text",ExpressionUUID->"67bca252-21d9-4f84-a2ba-cb6825ec6561"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Projectorh", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"u", "[", 
     RowBox[{"-", "A"}], "]"}]}], "]"}], 
  RowBox[{"u", "[", 
   RowBox[{"-", "A"}], 
   "]"}]}]], "Input",ExpressionUUID->"7a18fd45-164a-458a-bc56-9ee83eb04b78"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"e9bf79e8-ac28-4c3d-a57c-a1e21e59e71b"]
}, Open  ]],

Cell["\<\
Any product is decomposed into a sum of products of vectors and projected \
objects. Note that scalars are wrapped with Scalar and not with the projector \
inert-head:\
\>", "Text",ExpressionUUID->"16ce1597-8381-4df0-8a15-87a03b4f6ccd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"InducedDecomposition", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{
          RowBox[{"-", "B"}], ",", 
          RowBox[{"-", "A"}]}], "]"}], 
        RowBox[{"T", "[", "B", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "u"}], "}"}]}], "]"}], "//", "Expand"}], "//", 
    "ScreenDollarIndices"}], ")"}], "/.", 
  RowBox[{
  "hello", "\[Rule]", 
   "1"}]}]], "Input",ExpressionUUID->"2989791f-9d8d-4d47-ba8b-cbd756d9c1fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"B"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`B],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`T[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"B", "A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, -$CellContext`A],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`T[-$CellContext`B, -$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`B, -$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"B"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[$CellContext`B],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[$CellContext`T[-$CellContext`B, -$CellContext`A] \
$CellContext`u[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`A],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`T[$CellContext`A] \
$CellContext`u[-$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"B"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`B],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`T[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`B, -C],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"C"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[C],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[$CellContext`T[-$CellContext`B, -
       C] $CellContext`u[C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`A],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`T[$CellContext`A] \
$CellContext`u[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`B, -$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"B"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[$CellContext`B],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[($CellContext`T[-$CellContext`B, -$CellContext`A] \
$CellContext`u[$CellContext`A]) $CellContext`u[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"b3c7f92f-9727-4b9f-974d-315da931b06c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"InducedDecomposition", "[", 
      RowBox[{
       RowBox[{"u", "[", "A", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "u"}], "}"}]}], "]"}], "//", "Expand"}], "//", 
    "ScreenDollarIndices"}], ")"}], "/.", 
  RowBox[{
  "hello", "\[Rule]", 
   "1"}]}]], "Input",ExpressionUUID->"069b94fc-5172-4f4d-a49e-a62728bfc374"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"u", 
      StyleBox[GridBox[{
         {"A"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`u[$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"300fb68b-883c-40f9-99f7-c82bc76e213e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"InducedDecomposition", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"A", ",", "C"}], "]"}], 
        RowBox[{"u", "[", "B", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "u"}], "}"}]}], "]"}], "//", "Expand"}], "//", 
    "ScreenDollarIndices"}], ")"}], "/.", 
  RowBox[{
  "hello", "\[Rule]", 
   "1"}]}]], "Input",ExpressionUUID->"b1f29cc0-7b17-4b5b-b703-0cd234788ef9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"A", "C"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`A, C],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`T[$CellContext`A, C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`B],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"D", "C"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[D, C],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-D],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[$CellContext`T[D, C] $CellContext`u[-D]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`B],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-D],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[$CellContext`T[$CellContext`A, D] $CellContext`u[-
       D]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[C],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`B],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[($CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`u[-$CellContext`A]) $CellContext`u[-$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[C],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"8fd063f7-bc47-4491-b02a-f776121d3b24"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
   RowBox[{"cd", "[", 
    RowBox[{"-", "B"}], "]"}], "[", "%", 
   "]"}]}]], "Input",ExpressionUUID->"9913f487-7c3e-453b-a139-9c0a264ce939"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nonproj"}], "MessageName"], ":", 
  " ", "\<\"Induced derivative acting on the non-projected expression \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\(P[\\(\\(\\*InterpretationBox[\
StyleBox[GridBox[{{\\\"T\\\", StyleBox[GridBox[{{\\\"A\\\", \\\"C\\\"}, {\\\" \
\\\", \\\" \\\"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, GridFrameMargins \
-> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, 4]]]}}, ColumnSpacings -> \
0.05, RowAlignments -> Center], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], T[A, C], Rule[Editable, False]]\\)\\)]\\), \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], Projectorh[T[A, C]], \
Rule[Editable, False]]\\\\ \\*InterpretationBox[StyleBox[GridBox[{{\\\"u\\\", \
StyleBox[GridBox[{{\\\"B\\\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], u[B], Rule[Editable, False]]\\)\\n      \
                        h\\n\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"567cbf91-e44e-458b-9d95-818fe2bb54ed"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nonproj"}], "MessageName"], ":", 
  " ", "\<\"Induced derivative acting on the non-projected expression \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\(P[\\(\\(\\*InterpretationBox[\
StyleBox[GridBox[{{\\\"T\\\", StyleBox[GridBox[{{\\\"A\\\", \\\"C\\\"}, {\\\" \
\\\", \\\" \\\"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, GridFrameMargins \
-> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, 4]]]}}, ColumnSpacings -> \
0.05, RowAlignments -> Center], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], T[A, C], Rule[Editable, False]]\\)\\)]\\), \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], Projectorh[T[A, C]], \
Rule[Editable, False]]\\\\ \\*InterpretationBox[StyleBox[GridBox[{{\\\"u\\\", \
StyleBox[GridBox[{{\\\"B\\\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], u[B], Rule[Editable, False]]\\)\\n      \
                        h\\n\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"3e6345e4-3b68-4606-9759-cd426b0c108b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nonproj"}], "MessageName"], ":", 
  " ", "\<\"Induced derivative acting on the non-projected expression \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\(P[\\(\\(\\*InterpretationBox[\
StyleBox[GridBox[{{\\\"T\\\", StyleBox[GridBox[{{\\\"A\\\", \\\"C\\\"}, {\\\" \
\\\", \\\" \\\"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, GridFrameMargins \
-> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, 4]]]}}, ColumnSpacings -> \
0.05, RowAlignments -> Center], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], T[A, C], Rule[Editable, False]]\\)\\)]\\), \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], Projectorh[T[A, C]], \
Rule[Editable, False]]\\\\ \\*InterpretationBox[StyleBox[GridBox[{{\\\"u\\\", \
StyleBox[GridBox[{{\\\"B\\\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], u[B], Rule[Editable, False]]\\)\\n      \
                        h\\n\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"84ea8967-8985-428f-b150-8d7120ba0e44"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Validate :: \
nonproj\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e920c3cb-7e2d-4df5-a58b-10fa60008edf"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["D", "B"], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{
        UnderscriptBox["P", "h"], "[", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"T", 
             StyleBox[GridBox[{
                {"A", "C"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`T[$CellContext`A, C],
         Editable->False], "]"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Projectorh[
       $CellContext`T[$CellContext`A, C]],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {"B"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[$CellContext`B],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`cd[-$CellContext`B][$CellContext`Projectorh[
     $CellContext`T[$CellContext`A, C]] $CellContext`u[$CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"005e10b0-8204-4a15-a3ab-c03d14cf1c4f"]
}, Open  ]],

Cell["Note this:", \
"Text",ExpressionUUID->"e3d30887-7fa2-4c08-8e3a-4912bfe7da54"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"T", "[", "B", "]"}], 
    RowBox[{"T", "[", "C", "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"1b3c890d-31c3-407e-9d09-706bec4125b0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nonproj"}], "MessageName"], ":", 
  " ", "\<\"Induced derivative acting on the non-projected expression \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\\\"T\\\", \
StyleBox[GridBox[{{\\\"B\\\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], T[B], Rule[Editable, False]]\\\\ \
\\*InterpretationBox[StyleBox[GridBox[{{\\\"T\\\", StyleBox[GridBox[{{\\\"C\\\
\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, GridFrameMargins \
-> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, 4]]]}}, ColumnSpacings -> \
0.05, RowAlignments -> Center], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], T[C], Rule[Editable, \
False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"73dcf40f-85f5-48c5-8ce9-1c77c65e37dd"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "nonproj"}], "MessageName"], ":", 
  " ", "\<\"Induced derivative acting on the non-projected expression \
\[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[GridBox[{{\\\"T\\\", \
StyleBox[GridBox[{{\\\"B\\\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings \
-> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, \
4]]]}}, ColumnSpacings -> 0.05, RowAlignments -> Center], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], T[B], Rule[Editable, False]]\\\\ \
\\*InterpretationBox[StyleBox[GridBox[{{\\\"T\\\", StyleBox[GridBox[{{\\\"C\\\
\"}, {\\\" \\\"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, GridFrameMargins \
-> {{0, 0}, {0, 0}}], Rule[FontSize, Rational[39, 4]]]}}, ColumnSpacings -> \
0.05, RowAlignments -> Center], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], T[C], Rule[Editable, \
False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0361047a-6a78-4446-9387-e9d70397c10b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["D", "A"], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"B"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"C"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[C],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`cd[-$CellContext`A][$CellContext`T[$CellContext`B] \
$CellContext`T[C]],
  Editable->
   False]], "Output",ExpressionUUID->"721080ed-9513-4b3c-8b59-ae39e5d031c7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"hello", "=", "1"}], 
  ";"}]], "Input",ExpressionUUID->"8272baa6-2574-4b3a-9940-611f168a0b13"],

Cell["TODO: Solve this recursion problem:", \
"Text",ExpressionUUID->"70151efa-65c3-483d-8335-5ece25241eb4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"T", "[", "B", "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"-", "B"}], "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"621de98f-05b6-4ca2-b96f-12e8c8e084bb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"B"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`B],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`T[$CellContext`B]],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["D", "A"], 
       UnderscriptBox["P", "h"], "[", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`B],
        Editable->False], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`cd[-$CellContext`A][
      $CellContext`Projectorh[
       $CellContext`T[-$CellContext`B]]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" "},
              {"B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`T[-$CellContext`B]],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["D", "A"], 
       UnderscriptBox["P", "h"], "[", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"B"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`B],
        Editable->False], "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`cd[-$CellContext`A][
      $CellContext`Projectorh[
       $CellContext`T[$CellContext`B]]],
     Editable->False], ")"}]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[$CellContext`A],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`u[$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["D", "A"], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"B"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`B],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-$CellContext`A][$CellContext`T[$CellContext`B] \
$CellContext`u[-$CellContext`B]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[-$CellContext`A],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`T[$CellContext`A] \
$CellContext`u[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["D", "A"], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"B"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[$CellContext`B],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-$CellContext`A][$CellContext`T[-$CellContext`B] \
$CellContext`u[$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"53fafc2d-e001-4027-8548-7ebfec2ad32b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ServantsOf", "[", "h", 
  "]"}]], "Input",ExpressionUUID->"b1b2e058-bb76-4c6b-ab48-f266a92434f4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "epsilonh", ",", "cd", ",", "Deth", ",", "ExtrinsicKh", ",", 
   "Accelerationu", ",", "Projectorh"}], 
  "}"}]], "Output",ExpressionUUID->"4b0ef7e5-28fc-44b6-83d4-68906c4a2014"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "h", 
  "]"}]], "Input",ExpressionUUID->"0f9c03e5-2004-44a5-a45d-5c817bea6bf4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefInertHead", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"projector inert-head\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Projectorh"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefInertHead, ": Undefined ", "projector inert-head", 
   " ", $CellContext`Projectorh],
  Editable->
   False]], "Print",ExpressionUUID->"25a8e820-d37d-436f-9079-07e9603078dc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"acceleration vector\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Accelerationu"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "acceleration vector", 
   " ", $CellContext`Accelerationu],
  Editable->
   False]], "Print",ExpressionUUID->"4e21e664-3cdc-4bc3-a7af-7b117f461447"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"extrinsic curvature tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ExtrinsicKh"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "extrinsic curvature tensor", " ", $CellContext`ExtrinsicKh],
  Editable->
   False]], "Print",ExpressionUUID->"78a35cb8-a4b0-4c6a-ad56-f34e56b11ac9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Deth"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Deth],
  Editable->
   False]], "Print",ExpressionUUID->"c21372eb-cdcd-4aa6-a031-0ca6bb02e51d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Christoffelcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`Christoffelcd],
  Editable->
   False]], "Print",ExpressionUUID->"6e7358da-4c29-408b-8e4e-3131df73016b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Einsteincd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`Einsteincd],
  Editable->
   False]], "Print",ExpressionUUID->"3d217c0f-ce9c-42cc-8c80-78b5dac93ff7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Kretschmanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`Kretschmanncd],
  Editable->
   False]], "Print",ExpressionUUID->"6538bc9d-3eeb-4c23-b91b-d0c594f0b883"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`Riccicd],
  Editable->
   False]], "Print",ExpressionUUID->"3e2fa33c-c557-4f9e-97b4-bd55b3cbd67b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarcd],
  Editable->
   False]], "Print",ExpressionUUID->"fca7a8f6-8a47-4c74-a91b-83a39dba5da2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riemanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`Riemanncd],
  Editable->
   False]], "Print",ExpressionUUID->"1cebc3b5-4a2b-4cfe-86c7-eeaa5290be6b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRiccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRiccicd],
  Editable->
   False]], "Print",ExpressionUUID->"68ce5bc2-dd1f-4cc2-84ab-0930d5adba20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Torsioncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`Torsioncd],
  Editable->
   False]], "Print",ExpressionUUID->"003a09e1-3887-4603-89c4-c18b904ec29c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Weylcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`Weylcd],
  Editable->
   False]], "Print",ExpressionUUID->"f238ce6e-b7dd-4a91-92e5-17d473284f19"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`cd],
  Editable->
   False]], "Print",ExpressionUUID->"ec3e1ea0-38c6-447b-b5b7-45e5295a71a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonh"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonh],
  Editable->
   False]], "Print",ExpressionUUID->"9688c61a-0bb1-49c1-9a99-ccc2fca75f45"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "h"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`h],
  Editable->
   False]], "Print",ExpressionUUID->"08e876ba-ba14-41f7-a60b-217412a7d27b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "metricg", 
  "]"}]], "Input",ExpressionUUID->"a8131fd2-bd57-4247-a9c1-2229736aee15"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"4afba506-d66b-4136-95be-406d8a110c17"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"964c70c6-964f-4e58-9581-1009293b0e70"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCD],
  Editable->
   False]], "Print",ExpressionUUID->"31cd2b8b-602e-4fe4-b812-ea046478ca42"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCD],
  Editable->
   False]], "Print",ExpressionUUID->"070d3ad1-c4c7-40eb-bc9c-2db2ecfd8329"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"69158c45-48af-4721-924f-b49394ac7773"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCD],
  Editable->
   False]], "Print",ExpressionUUID->"410990d5-07c2-435f-8d31-e5648ba8eb04"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"ce11d977-6174-46be-8f80-99857a4b19ae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"6b5a2fee-ec12-4566-881a-713fa6f05306"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"9d06e51a-6c99-46f3-9b7c-346de3d26656"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCD],
  Editable->
   False]], "Print",ExpressionUUID->"8aeaaf41-101b-4ef0-b26a-39f0b61a1e2f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"f6a8af68-dec6-4948-a572-988c8f23e6dc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"5b4d18ec-591f-4280-b639-54468fc93e07"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"8f97d37e-5d8e-491d-856b-db84dfdeb059"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "u"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"97f324a6-162d-4ddc-b47a-ffb431617a6d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"e8137aeb-92aa-4c29-bcfc-9821c4795a99"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "u"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`u],
  Editable->
   False]], "Print",ExpressionUUID->"682a2767-89cb-4b70-a3b7-889dd16f7f6d"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "hello", "]"}], 
  ";"}]], "Input",ExpressionUUID->"9c8f441c-ced3-46a8-91a9-e116acfa4bf7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c07f97a6-7a68-4d8f-9dd8-9e05141ca9ec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G1$\"\>", ",", "\<\"G$\"\>", ",", "\<\"G$244535\"\>", 
     ",", "\<\"G$244535$\"\>", ",", "\<\"G$244536\"\>", 
     ",", "\<\"G$244536$\"\>", ",", "\<\"G$244537\"\>", 
     ",", "\<\"G$244537$\"\>", ",", "\<\"G$244538\"\>", 
     ",", "\<\"G$244538$\"\>", ",", "\<\"G$244539\"\>", 
     ",", "\<\"G$244539$\"\>", ",", "\<\"G$244540\"\>", 
     ",", "\<\"G$244540$\"\>", ",", "\<\"G$244541\"\>", 
     ",", "\<\"G$244541$\"\>", ",", "\<\"G$244542\"\>", 
     ",", "\<\"G$244542$\"\>", ",", "\<\"G$244543\"\>", 
     ",", "\<\"G$244543$\"\>", ",", "\<\"G$244544\"\>", 
     ",", "\<\"G$244544$\"\>", ",", "\<\"G$244545\"\>", 
     ",", "\<\"G$244545$\"\>", ",", "\<\"G$244546\"\>", 
     ",", "\<\"G$244546$\"\>", ",", "\<\"G$244547\"\>", 
     ",", "\<\"G$244547$\"\>", ",", "\<\"G$244548\"\>", 
     ",", "\<\"G$244548$\"\>", ",", "\<\"G$244617\"\>", 
     ",", "\<\"G$244618\"\>", ",", "\<\"G$244619\"\>", 
     ",", "\<\"G$244620\"\>", ",", "\<\"G$244628\"\>", 
     ",", "\<\"G$244629\"\>", ",", "\<\"G$244637\"\>", 
     ",", "\<\"G$244638\"\>", ",", "\<\"G$244639\"\>", 
     ",", "\<\"G$245803\"\>", ",", "\<\"G$245804\"\>", 
     ",", "\<\"G$245809\"\>", ",", "\<\"G$245809$\"\>", 
     ",", "\<\"G$245830\"\>", ",", "\<\"G$245831\"\>", 
     ",", "\<\"G$245859\"\>", ",", "\<\"G$245860\"\>", 
     ",", "\<\"G$245871\"\>", ",", "\<\"G$245872\"\>", 
     ",", "\<\"G$245873\"\>", ",", "\<\"G$245874\"\>", 
     ",", "\<\"G$245889\"\>", ",", "\<\"G$245890\"\>", 
     ",", "\<\"G$245891\"\>", ",", "\<\"G$245892\"\>", 
     ",", "\<\"G$245893\"\>", ",", "\<\"G$245894\"\>", 
     ",", "\<\"G$245908\"\>", ",", "\<\"G$245909\"\>", 
     ",", "\<\"G$245910\"\>", ",", "\<\"G$245911\"\>", 
     ",", "\<\"G$245912\"\>", ",", "\<\"G$245913\"\>", 
     ",", "\<\"G$245914\"\>", ",", "\<\"G$245915\"\>", 
     ",", "\<\"G$245916\"\>", ",", "\<\"G$245917\"\>", 
     ",", "\<\"G$245918\"\>", ",", "\<\"G$245919\"\>", 
     ",", "\<\"G$245953\"\>", ",", "\<\"G$245954\"\>", 
     ",", "\<\"G$245955\"\>", ",", "\<\"G$245956\"\>", 
     ",", "\<\"G$245957\"\>", ",", "\<\"G$245958\"\>", 
     ",", "\<\"G$245959\"\>", ",", "\<\"G$245960\"\>", 
     ",", "\<\"G$245961\"\>", ",", "\<\"G$245962\"\>", 
     ",", "\<\"G$245963\"\>", ",", "\<\"G$245964\"\>", 
     ",", "\<\"G$245965\"\>", ",", "\<\"G$245966\"\>", 
     ",", "\<\"G$245967\"\>", ",", "\<\"G$245968\"\>", 
     ",", "\<\"G$245969\"\>", ",", "\<\"G$245970\"\>", 
     ",", "\<\"G$245971\"\>", ",", "\<\"G$245972\"\>", 
     ",", "\<\"G$245973\"\>", ",", "\<\"G$245999\"\>", 
     ",", "\<\"G$246000\"\>", ",", "\<\"G$246001\"\>", 
     ",", "\<\"G$246002\"\>", ",", "\<\"G$246003\"\>", 
     ",", "\<\"G$246004\"\>", ",", "\<\"G$246005\"\>", 
     ",", "\<\"G$246006\"\>", ",", "\<\"G$246007\"\>", 
     ",", "\<\"G$246008\"\>", ",", "\<\"G$246009\"\>", 
     ",", "\<\"G$246010\"\>", ",", "\<\"G$246011\"\>", 
     ",", "\<\"G$246012\"\>", ",", "\<\"G$246013\"\>", 
     ",", "\<\"G$246014\"\>", ",", "\<\"G$246015\"\>", 
     ",", "\<\"G$246016\"\>", ",", "\<\"G$246017\"\>", 
     ",", "\<\"G$246018\"\>", ",", "\<\"G$246019\"\>", 
     ",", "\<\"G$246020\"\>", ",", "\<\"G$246021\"\>", 
     ",", "\<\"G$246022\"\>", ",", "\<\"G$246023\"\>", 
     ",", "\<\"G$246024\"\>", ",", "\<\"G$246025\"\>", 
     ",", "\<\"G$246026\"\>", ",", "\<\"G$246027\"\>", 
     ",", "\<\"G$246028\"\>", ",", "\<\"G$246029\"\>", 
     ",", "\<\"G$246030\"\>", ",", "\<\"G$246031\"\>", 
     ",", "\<\"G$246032\"\>", ",", "\<\"G$246033\"\>", 
     ",", "\<\"G$246034\"\>", ",", "\<\"G$246035\"\>", 
     ",", "\<\"G$246036\"\>", ",", "\<\"G$246037\"\>", 
     ",", "\<\"G$246038\"\>", ",", "\<\"G$246039\"\>", 
     ",", "\<\"G$246040\"\>", ",", "\<\"G$246041\"\>", 
     ",", "\<\"G$246042\"\>", ",", "\<\"G$246043\"\>", 
     ",", "\<\"G$246044\"\>", ",", "\<\"G$246045\"\>", 
     ",", "\<\"G$246046\"\>", ",", "\<\"G$246047\"\>", 
     ",", "\<\"G$246048\"\>", ",", "\<\"G$246049\"\>", 
     ",", "\<\"G$246050\"\>", ",", "\<\"G$246051\"\>", 
     ",", "\<\"G$246052\"\>", ",", "\<\"G$246053\"\>", 
     ",", "\<\"G$246054\"\>", ",", "\<\"G$246077\"\>", 
     ",", "\<\"G$246078\"\>", ",", "\<\"G$246093\"\>", 
     ",", "\<\"G$246094\"\>", ",", "\<\"G$246095\"\>", 
     ",", "\<\"G$246096\"\>", ",", "\<\"G$246097\"\>", 
     ",", "\<\"G$246098\"\>", ",", "\<\"G$246099\"\>", 
     ",", "\<\"G$246100\"\>", ",", "\<\"G$246120\"\>", 
     ",", "\<\"G$246120$\"\>", ",", "\<\"G$246121\"\>", 
     ",", "\<\"G$246121$\"\>", ",", "\<\"G$246122\"\>", 
     ",", "\<\"G$246122$\"\>", ",", "\<\"G$246123\"\>", 
     ",", "\<\"G$246123$\"\>", ",", "\<\"G$246124\"\>", 
     ",", "\<\"G$246124$\"\>", ",", "\<\"G$246125\"\>", 
     ",", "\<\"G$246125$\"\>", ",", "\<\"G$246126\"\>", 
     ",", "\<\"G$246126$\"\>", ",", "\<\"G$246127\"\>", 
     ",", "\<\"G$246127$\"\>", ",", "\<\"G$246128\"\>", 
     ",", "\<\"G$246128$\"\>", ",", "\<\"G$246129\"\>", 
     ",", "\<\"G$246129$\"\>", ",", "\<\"G$246130\"\>", 
     ",", "\<\"G$246130$\"\>", ",", "\<\"G$246131\"\>", 
     ",", "\<\"G$246131$\"\>", ",", "\<\"G$246132\"\>", 
     ",", "\<\"G$246132$\"\>", ",", "\<\"G$246133\"\>", 
     ",", "\<\"G$246133$\"\>", ",", "\<\"G$246205\"\>", 
     ",", "\<\"G$246206\"\>", ",", "\<\"G$246207\"\>", 
     ",", "\<\"G$246208\"\>", ",", "\<\"G$246216\"\>", 
     ",", "\<\"G$246217\"\>", ",", "\<\"G$246225\"\>", 
     ",", "\<\"G$246226\"\>", ",", "\<\"G$246227\"\>", 
     ",", "\<\"G$246248\"\>", ",", "\<\"G$246249\"\>", 
     ",", "\<\"G$246263\"\>", ",", "\<\"G$246264\"\>", 
     ",", "\<\"G$246265\"\>", ",", "\<\"G$246266\"\>", 
     ",", "\<\"G$246267\"\>", ",", "\<\"G$246268\"\>", 
     ",", "\<\"G$246269\"\>", ",", "\<\"G$246270\"\>", 
     ",", "\<\"G$246289\"\>", ",", "\<\"G$246290\"\>", 
     ",", "\<\"G$246296\"\>", ",", "\<\"G$246297\"\>", 
     ",", "\<\"G$246300\"\>", ",", "\<\"G$246301\"\>", 
     ",", "\<\"G$246302\"\>", ",", "\<\"G$246304\"\>", 
     ",", "\<\"G$246305\"\>", ",", "\<\"G$246319\"\>", 
     ",", "\<\"G$246320\"\>", ",", "\<\"G$246323\"\>", 
     ",", "\<\"G$246325\"\>", ",", "\<\"G$246326\"\>", 
     ",", "\<\"G$246333\"\>", ",", "\<\"G$246334\"\>", 
     ",", "\<\"G$246337\"\>", ",", "\<\"G$246338\"\>", 
     ",", "\<\"G$246339\"\>", ",", "\<\"G$246342\"\>", 
     ",", "\<\"G$246343\"\>", ",", "\<\"G$246345\"\>", 
     ",", "\<\"G$246352\"\>", ",", "\<\"G$252214\"\>", 
     ",", "\<\"G$252215\"\>", ",", "\<\"G$252218\"\>", 
     ",", "\<\"G$252219\"\>", ",", "\<\"G$252220\"\>", 
     ",", "\<\"G$252223\"\>", ",", "\<\"G$252225\"\>", 
     ",", "\<\"G$252228\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G1$", "G$", "G$244535", "G$244535$", "G$244536", "G$244536$", "G$244537", 
    "G$244537$", "G$244538", "G$244538$", "G$244539", "G$244539$", "G$244540",
     "G$244540$", "G$244541", "G$244541$", "G$244542", "G$244542$", 
    "G$244543", "G$244543$", "G$244544", "G$244544$", "G$244545", "G$244545$",
     "G$244546", "G$244546$", "G$244547", "G$244547$", "G$244548", 
    "G$244548$", "G$244617", "G$244618", "G$244619", "G$244620", "G$244628", 
    "G$244629", "G$244637", "G$244638", "G$244639", "G$245803", "G$245804", 
    "G$245809", "G$245809$", "G$245830", "G$245831", "G$245859", "G$245860", 
    "G$245871", "G$245872", "G$245873", "G$245874", "G$245889", "G$245890", 
    "G$245891", "G$245892", "G$245893", "G$245894", "G$245908", "G$245909", 
    "G$245910", "G$245911", "G$245912", "G$245913", "G$245914", "G$245915", 
    "G$245916", "G$245917", "G$245918", "G$245919", "G$245953", "G$245954", 
    "G$245955", "G$245956", "G$245957", "G$245958", "G$245959", "G$245960", 
    "G$245961", "G$245962", "G$245963", "G$245964", "G$245965", "G$245966", 
    "G$245967", "G$245968", "G$245969", "G$245970", "G$245971", "G$245972", 
    "G$245973", "G$245999", "G$246000", "G$246001", "G$246002", "G$246003", 
    "G$246004", "G$246005", "G$246006", "G$246007", "G$246008", "G$246009", 
    "G$246010", "G$246011", "G$246012", "G$246013", "G$246014", "G$246015", 
    "G$246016", "G$246017", "G$246018", "G$246019", "G$246020", "G$246021", 
    "G$246022", "G$246023", "G$246024", "G$246025", "G$246026", "G$246027", 
    "G$246028", "G$246029", "G$246030", "G$246031", "G$246032", "G$246033", 
    "G$246034", "G$246035", "G$246036", "G$246037", "G$246038", "G$246039", 
    "G$246040", "G$246041", "G$246042", "G$246043", "G$246044", "G$246045", 
    "G$246046", "G$246047", "G$246048", "G$246049", "G$246050", "G$246051", 
    "G$246052", "G$246053", "G$246054", "G$246077", "G$246078", "G$246093", 
    "G$246094", "G$246095", "G$246096", "G$246097", "G$246098", "G$246099", 
    "G$246100", "G$246120", "G$246120$", "G$246121", "G$246121$", "G$246122", 
    "G$246122$", "G$246123", "G$246123$", "G$246124", "G$246124$", "G$246125",
     "G$246125$", "G$246126", "G$246126$", "G$246127", "G$246127$", 
    "G$246128", "G$246128$", "G$246129", "G$246129$", "G$246130", "G$246130$",
     "G$246131", "G$246131$", "G$246132", "G$246132$", "G$246133", 
    "G$246133$", "G$246205", "G$246206", "G$246207", "G$246208", "G$246216", 
    "G$246217", "G$246225", "G$246226", "G$246227", "G$246248", "G$246249", 
    "G$246263", "G$246264", "G$246265", "G$246266", "G$246267", "G$246268", 
    "G$246269", "G$246270", "G$246289", "G$246290", "G$246296", "G$246297", 
    "G$246300", "G$246301", "G$246302", "G$246304", "G$246305", "G$246319", 
    "G$246320", "G$246323", "G$246325", "G$246326", "G$246333", "G$246334", 
    "G$246337", "G$246338", "G$246339", "G$246342", "G$246343", "G$246345", 
    "G$246352", "G$252214", "G$252215", "G$252218", "G$252219", "G$252220", 
    "G$252223", "G$252225", "G$252228"}],
  Editable->
   False]], "Print",ExpressionUUID->"43044dbd-ec59-418c-acf3-ed36eabee3b2"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["14.3.7. Contraction with induced metrics", \
"Subsubsection",ExpressionUUID->"ff7dc94c-a1ac-4c85-a933-25689db4d9b7"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"df223902-a51a-4427-8ffd-32f4080ccb99"],

Cell["Use Choptuik's conventions:", \
"Text",ExpressionUUID->"f32299b9-dec4-489a-b57f-8a23f43eb18a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$ExtrinsicKSign", "=", 
   RowBox[{"+", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$AccelerationSign", "=", 
   RowBox[{"-", "1"}]}], 
  ";"}]}], "Input",ExpressionUUID->"70c7a9a4-a063-444a-a8f7-eb431805c87b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CD", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"e91c9592-6a73-42a2-a133-97e935835223"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1b4ee789-563b-4425-868a-14e10a2ed7ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ff69f88b-31d5-43ca-abbd-0f78ece39b2f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"57e39b5e-a078-41f2-a328-1e92b207f1d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"138e278a-44a9-4e40-8f43-06f0a4b68132"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"61c20d49-2d93-411d-b3a8-d5aa6e280ddc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dd933f1e-8bc9-4f6d-a9f8-7fa237e17770"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d6f69168-9cfd-471c-9ce0-6cde700ad8e2"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"6d6e5930-72a3-4c08-8ee3-1647383335fb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d8527817-82e9-4dc1-9f5b-4a89c4b7fe4e"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"5dadb2a5-e753-4b2b-8257-15343bf01019"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"48870f81-47f1-4f86-8a06-683a85dec46d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCD[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e340534a-6543-4606-ae70-40490009dc5a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d78dca6c-772c-454e-8bed-e7ac4ab11dbe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b12d6b08-b503-40ae-a94f-f4423ff37eef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"61e9387c-2acc-4524-aeee-e23c87bcf7a2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"acbf7c5a-16ef-4fd5-b3e3-262dd209c253"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"0c4f7c16-fe20-4f5d-b552-cac9a7271dae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetricg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetricg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"04dacc72-995d-48af-9179-f59db997ff6a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"u", "[", "A", "]"}], ",", "M2", ",", 
   RowBox[{"FrobeniusQ", "\[Rule]", "True"}], ",", 
   RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"282f6f80-c137-4039-96c3-928df2180db6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"u", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`u[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4275b0ad-973f-4596-9c7a-14d825e94873"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AutomaticRules", "[", 
  RowBox[{"u", ",", 
   RowBox[{"MakeRule", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"metricg", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}]}], "]"}], 
       RowBox[{"u", "[", "A", "]"}], 
       RowBox[{"u", "[", "B", "]"}]}], ",", 
      RowBox[{"-", "1"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d3901d4f-f70d-4398-b7be-bb426fba05ce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Rules \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], 
   "\[InvisibleSpace]", "\<\" have been declared as UpValues for \"\>", 
   "\[InvisibleSpace]", "u", "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["   Rules ", 
   Shallow[{1, 2}], " have been declared as UpValues for ", $CellContext`u, 
   "."],
  Editable->
   False]], "Print",ExpressionUUID->"e3226b3e-4724-4afd-a747-eec5c6945463"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"u", "/:", 
  RowBox[{
   RowBox[{"u", "[", "A_", "]"}], 
   RowBox[{"u", "[", 
    RowBox[{"-", "A_"}], "]"}]}], ":=", 
  RowBox[{
  "-", "1"}]}]], \
"Input",ExpressionUUID->"e70fc4fd-f497-4744-acc4-698e2824f35f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "cd", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<D\>\""}], "}"}], ",", 
   RowBox[{"InducedFrom", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"metricg", ",", "u"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"ed5af169-2874-4461-bc4d-9f48fdc0082f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "old"}], "MessageName"], ":", 
  " ", "\<\"There are already metrics \[NoBreak]\\!\\({metricg}\\)\[NoBreak] \
in vbundle \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]M2\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], TangentM2, Rule[Editable, False]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2cf75bb8-a2c5-4c3c-82db-bec534ed9a30"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`h[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1da9b167-7511-4679-b4af-d84502126b36"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonh", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonh[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c1895dc6-40f8-42ba-84ee-85dc10f0114f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5dd2add8-67c5-469f-bf75-86d7d5b7cd7c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Torsioncd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`Torsioncd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"263a7078-5c8f-4a94-976e-e1f7a157c0e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Christoffelcd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`Christoffelcd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"e5bda7a0-e14d-4b70-822b-853d7fd2f556"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Riemanncd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`Riemanncd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e5792a55-51fa-46ac-b89d-0b748d24961d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Riccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`Riccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9f0a53a1-3290-48c2-801d-73a9d82baaba"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"ee6aa64e-e5f9-4aa7-9dee-8748bd63b6ea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarcd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarcd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"eeaf1cec-dfc0-4b8b-8673-2d65a7b1e116"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"0df563be-3cd2-45ee-903a-337c69677bd8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Einsteincd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`Einsteincd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"17048993-757b-4e24-b168-bbcf5cb284ae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Weylcd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`Weylcd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7d21ae35-7617-4ef5-83fc-c0d4a99567ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRiccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRiccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"039a93d9-25cc-42d8-bee5-aa6ef3399f29"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"Kretschmanncd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`Kretschmanncd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8f3c9059-875f-4ab2-a6cf-8b2e2bb05af3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"24d87a0b-5ef1-4cf4-a99e-2d9894cf5150"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"c7662e87-a637-4bbd-b3c2-dcf94b43882a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"cf7ce4a4-fa4b-49be-9ff7-d701328a321c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Deth", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Deth[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"64dbb2d4-b3c2-4f23-926b-86569cd49a1f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"extrinsic curvature tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ExtrinsicKh", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Associated to vector u\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "extrinsic curvature tensor ", 
   $CellContext`ExtrinsicKh[$CellContext`A, $CellContext`B], ". ", 
   "Associated to vector u"],
  Editable->
   False]], "Print",ExpressionUUID->"fe14c1fb-68fc-4c67-9d9a-3917a42fb1e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"acceleration vector \"\>", "\[InvisibleSpace]", 
   RowBox[{"Accelerationu", "[", "A", "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Associated to vector u\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "acceleration vector ", 
   $CellContext`Accelerationu[$CellContext`A], ". ", "Associated to vector u"],
  Editable->
   False]], "Print",ExpressionUUID->"70bd9e7a-4903-4181-9ca8-f9fd4de09984"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefInertHead", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"projector inert-head \"\>", "\[InvisibleSpace]", 
   "Projectorh", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefInertHead, ": Defining ", 
   "projector inert-head ", $CellContext`Projectorh, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ab675b84-6d2c-4066-b355-d9ddeae16663"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Accelerationu"}]], \
"Input",ExpressionUUID->"61c587c7-28b8-45e6-b14d-655778e78971"],

Cell[CellGroupData[{

Cell["Global`Accelerationu", "Print", "PrintUsage",
 CellTags->
  "Info3578672897-5338953",ExpressionUUID->"e2ecfb30-0474-4d94-8440-\
37a643e5cc5a"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Accelerationu", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "Accelerationu", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Accelerationu],
          Editable->False], "^:=", "Accelerationu"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Accelerationu", "]"}], "^:=", 
         RowBox[{"{", 
          RowBox[{"\<\"acceleration vector\"\>", 
           ",", "\<\"Associated to vector u\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "Accelerationu", "]"}], "^:=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Accelerationu", "]"}], "^:=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", "Accelerationu", "]"}], "^:=", "h"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Accelerationu", "]"}], 
         "^:=", "\<\"Au\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "Accelerationu", "]"}], "^:=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "Accelerationu", "]"}], "^:=", 
         
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GenSet", "[", "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "Accelerationu", "]"}], "^:=", 
         RowBox[{"{", 
          RowBox[{"Acceleration", ",", "u"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "Accelerationu", "]"}], "^:=", "True"}]},
       {" "},
       {
        RowBox[{"Accelerationu", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"Au", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Accelerationu[
            PatternTest[
             Pattern[$CellContext`A, 
              Blank[Symbol]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"u", 
               StyleBox[GridBox[{
                  {" "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`u[-PatternTest[
              Pattern[$CellContext`A, 
               Blank[Symbol]], TangentM2`Q]],
           Editable->False]}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", "0"}], "]"}]}]},
       {" "},
       {
        RowBox[{"Accelerationu", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"Au", 
               StyleBox[GridBox[{
                  {" "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Accelerationu[-PatternTest[
              Pattern[$CellContext`A, 
               Blank[Symbol]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"u", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`u[
            PatternTest[
             Pattern[$CellContext`A, 
              Blank[Symbol]], TangentM2`Q]],
           Editable->False]}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", "0"}], "]"}]}]},
       {" "},
       {
        RowBox[{"Accelerationu", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"Au", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Accelerationu[
            PatternTest[
             Pattern[$CellContext`A, 
              Blank[Symbol]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"h", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["B", "_"], "_"], " "},
                  {" ", 
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`h[
            PatternTest[
             Pattern[$CellContext`B, 
              Blank[]], TangentM2`pmQ], -PatternTest[
              Pattern[$CellContext`A, 
               Blank[Symbol]], TangentM2`Q]],
           Editable->False]}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"Au", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Accelerationu[$CellContext`B],
            Editable->False]}], "]"}]}]},
       {" "},
       {
        RowBox[{"Accelerationu", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"Au", 
               StyleBox[GridBox[{
                  {" "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Accelerationu[-PatternTest[
              Pattern[$CellContext`A, 
               Blank[Symbol]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"h", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["B", "_"], "_"], 
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`h[
            PatternTest[
             Pattern[$CellContext`B, 
              Blank[]], TangentM2`pmQ], 
            PatternTest[
             Pattern[$CellContext`A, 
              Blank[Symbol]], TangentM2`Q]],
           Editable->False]}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"Au", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Accelerationu[$CellContext`B],
            Editable->False]}], "]"}]}]},
       {" "},
       {
        RowBox[{"Accelerationu", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"Au", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Accelerationu[
            PatternTest[
             Pattern[$CellContext`A, 
              Blank[Symbol]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"h", 
               StyleBox[GridBox[{
                  {" ", 
                   UnderscriptBox[
                    UnderscriptBox["B", "_"], "_"]},
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"], " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`h[-PatternTest[
              Pattern[$CellContext`A, 
               Blank[Symbol]], TangentM2`Q], 
            PatternTest[
             Pattern[$CellContext`B, 
              Blank[]], TangentM2`pmQ]],
           Editable->False]}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"Au", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Accelerationu[$CellContext`B],
            Editable->False]}], "]"}]}]},
       {" "},
       {
        RowBox[{"Accelerationu", "/:", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"Au", 
               StyleBox[GridBox[{
                  {" "},
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"]}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Accelerationu[-PatternTest[
              Pattern[$CellContext`A, 
               Blank[Symbol]], TangentM2`Q]],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"h", 
               StyleBox[GridBox[{
                  {
                   UnderscriptBox[
                    UnderscriptBox["A", "_"], "_"], 
                   UnderscriptBox[
                    UnderscriptBox["B", "_"], "_"]},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`h[
            PatternTest[
             Pattern[$CellContext`A, 
              Blank[Symbol]], TangentM2`Q], 
            PatternTest[
             Pattern[$CellContext`B, 
              Blank[]], TangentM2`pmQ]],
           Editable->False]}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"Au", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Accelerationu[$CellContext`B],
            Editable->False]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Accelerationu],
  Editable->False]], "Print",
 CellTags->
  "Info3578672897-5338953",ExpressionUUID->"63c67196-864e-4824-a651-\
c9668b522b0e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Riemanncd", "[", 
   RowBox[{"A", ",", "B", ",", "C", ",", 
    RowBox[{"-", "A"}]}], "]"}], "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"0fc70aad-db2b-454b-8398-41f96942f0c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "r"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RicciSign,
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"R", "[", "D", "]"}], 
       StyleBox[GridBox[{
          {"B", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Riccicd[$CellContext`B, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"9dfcd815-ab14-40df-bad3-7ca7a288f478"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"h", "[", 
  RowBox[{
   RowBox[{"-", "A"}], ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"36cd9510-93dc-4302-acdc-c9e6e0d3ef7d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"h", 
      StyleBox[GridBox[{
         {" ", "B"},
         {"A", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`h[-$CellContext`A, $CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"9f48bfca-eef6-46a5-9931-dddc652ee255"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ExtrinsicKh", "[", 
   RowBox[{"A", ",", "B"}], "]"}], 
  RowBox[{"u", "[", 
   RowBox[{"-", "B"}], 
   "]"}]}]], "Input",ExpressionUUID->"a7782acd-7f7a-419c-b0da-494b863249cd"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"cfe6ba45-d76e-4cb3-a5f1-405b86eaabb7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Riemanncd", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}], ",", 
    RowBox[{"-", "D"}]}], "]"}], 
  RowBox[{
  "u", "[", "D", 
   "]"}]}]], "Input",ExpressionUUID->"86b42350-ed05-4413-8ced-772bc6a60a3a"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"ec6cd60b-19cc-442e-85ed-9d8f11b58bbd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"u", "[", "B", "]"}], 
  "]"}]], "Input",ExpressionUUID->"09dec89d-1d7c-4e77-92b0-f3812a5cb7a3"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"u", 
      StyleBox[GridBox[{
         {"B", "  "},
         {" ", 
          RowBox[{";", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CD[-$CellContext`A][
   $CellContext`u[$CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"22871f41-6e02-4424-9df8-7e0751b81dc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "GradNormalToExtrinsicK"}]], \
"Input",ExpressionUUID->"c4f8810b-f3c5-4a66-b8b0-1dab015474a2"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"Kh", 
       StyleBox[GridBox[{
          {" ", "B"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ExtrinsicKh[-$CellContext`A, $CellContext`B],
   Editable->False], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"9fdb0393-85b6-4ac4-abc7-f37c4d5e472c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", "A"}], "]"}], "%"}], "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"5766c779-c1b2-4e70-a36c-454848e6de1e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"Kh", 
      StyleBox[GridBox[{
         {" ", " "},
         {"D", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`ExtrinsicKh[-D, -C],
  Editable->
   False]], "Output",ExpressionUUID->"817c48a4-7da4-43ac-ac91-8b460fc40037"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "ExtrinsicKToGradNormal"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"67280efd-e00a-40d6-9044-a7222f0730a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"u", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"C", 
           RowBox[{";", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-D][
    $CellContext`u[-C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"ae83afdf-627d-4a2d-b0e1-4a6d627cfdca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"f132e7eb-04ff-4a86-b844-e9393c1bf7c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"u", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"C", 
           RowBox[{";", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-D][
    $CellContext`u[-C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"de70c12a-a5e0-4660-a06d-8e79d2e0f7f2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"h", "[", 
  RowBox[{"A", ",", "B"}], 
  "]"}]], "Input",ExpressionUUID->"bd96b776-2e3b-4026-a825-f3219cac122c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"h", 
      StyleBox[GridBox[{
         {"A", "B"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`h[$CellContext`A, $CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"c0491f1c-bb74-42d0-843b-22b5cab7e8fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProjectorToMetric", "[", 
  RowBox[{"%", ",", "h"}], 
  "]"}]], "Input",ExpressionUUID->"11e51802-d0a7-47ad-b9ce-b67b8666aad0"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[$CellContext`A, $CellContext`B],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`B],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"6f1ab7b8-aea4-42c8-b73a-410899623bb1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricToProjector", "[", 
  RowBox[{"%", ",", "h"}], 
  "]"}]], "Input",ExpressionUUID->"b5e98db5-d904-4606-90b6-822df45bc2e3"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"h", 
      StyleBox[GridBox[{
         {"A", "B"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`h[$CellContext`A, $CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"d59964f3-d6ed-48b0-a98a-3f0db787915e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"ExtrinsicKh", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8a9ec20d-ab66-4fb0-bb56-b50878fabfe2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"Kh", 
      StyleBox[GridBox[{
         {" ", " ", "  "},
         {"B", "C", 
          RowBox[{"|", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`cd[-$CellContext`A][
   $CellContext`ExtrinsicKh[-$CellContext`B, -C]],
  Editable->
   False]], "Output",ExpressionUUID->"5311d0ea-2096-4cd4-8b44-01446409b252"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProjectDerivative", "[", 
  RowBox[{"%", ",", "cd"}], 
  "]"}]], "Input",ExpressionUUID->"2fe70a28-b20a-4ef3-b1ce-2d7d34696e44"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    UnderscriptBox["P", "h"], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Kh", 
         StyleBox[GridBox[{
            {" ", " ", "  "},
            {"B", "C", 
             RowBox[{";", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`A][
      $CellContext`ExtrinsicKh[-$CellContext`B, -C]],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Projectorh[
   $CellContext`CD[-$CellContext`A][
    $CellContext`ExtrinsicKh[-$CellContext`B, -C]]],
  Editable->
   False]], "Output",ExpressionUUID->"700d22dd-20fe-4c46-9701-14b5b416d85e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", 
   RowBox[{"Projectorh", "\[Rule]", 
    RowBox[{"ProjectWith", "[", "h", "]"}]}]}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"80d4c724-631a-48f2-bdab-17ef4b0b8672"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"h", 
       StyleBox[GridBox[{
          {" ", "D"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`h[-$CellContext`A, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"h", 
       StyleBox[GridBox[{
          {" ", "F"},
          {"B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`h[-$CellContext`B, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"h", 
       StyleBox[GridBox[{
          {" ", "G"},
          {"C", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`h[-C, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Kh", 
       StyleBox[GridBox[{
          {" ", " ", "  "},
          {"F", "G", 
           RowBox[{";", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-D][
    $CellContext`ExtrinsicKh[-$CellContext`F, -$CellContext`G]],
   Editable->
    False]}]], "Output",ExpressionUUID->"77021ccb-12b7-453e-9bd0-54f0cf4304f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ProjectorToMetric"}]], \
"Input",ExpressionUUID->"1a87378b-ba78-423b-8a9f-fdca77fa65f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[-$CellContext`A, D],
     Editable->False], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[-$CellContext`A],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {"D"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[D],
      Editable->False]}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {" ", "F"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[-$CellContext`B, $CellContext`F],
     Editable->False], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {" "},
             {"B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[-$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {"F"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[$CellContext`F],
      Editable->False]}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {" ", "G"},
            {"C", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[-C, $CellContext`G],
     Editable->False], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {" "},
             {"C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[-C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"u", 
          StyleBox[GridBox[{
             {"G"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[$CellContext`G],
      Editable->False]}]}], ")"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Kh", 
       StyleBox[GridBox[{
          {" ", " ", "  "},
          {"F", "G", 
           RowBox[{";", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-D][
    $CellContext`ExtrinsicKh[-$CellContext`F, -$CellContext`G]],
   Editable->
    False]}]], "Output",ExpressionUUID->"883b376a-e9e0-43c1-bbb6-ea5fdc028a36"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "Expand"}]], "Input",ExpressionUUID->"35fa22dc-19b4-4413-a046-894a50bca0b3"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"Kh", 
       StyleBox[GridBox[{
          {" ", " ", "  "},
          {"B", "C", 
           RowBox[{";", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-$CellContext`A][
    $CellContext`ExtrinsicKh[-$CellContext`B, -C]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "G", 
            RowBox[{";", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`ExtrinsicKh[-$CellContext`B, -$CellContext`G]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"F", "C", 
            RowBox[{";", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`ExtrinsicKh[-$CellContext`F, -C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"F", "G", 
            RowBox[{";", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`ExtrinsicKh[-$CellContext`F, -$CellContext`G]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "C", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`ExtrinsicKh[-$CellContext`B, -C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "G", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`ExtrinsicKh[-$CellContext`B, -$CellContext`G]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"F", "C", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`ExtrinsicKh[-$CellContext`F, -C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"F", "G", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`ExtrinsicKh[-$CellContext`F, -$CellContext`G]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"b413c007-f588-4cdd-84ff-9851d1c275b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InducedDecomposition", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"cd", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"ExtrinsicKh", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"h", ",", "u"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"58383f33-20f3-4837-a374-ac06c34a2c6f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"Kh", 
      StyleBox[GridBox[{
         {" ", " ", "  "},
         {"B", "C", 
          RowBox[{"|", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`cd[-$CellContext`A][
   $CellContext`ExtrinsicKh[-$CellContext`B, -C]],
  Editable->
   False]], "Output",ExpressionUUID->"06a9c0a6-eca6-4c9a-996a-b7ea622d304e"]
}, Open  ]],

Cell["We define two spatial vectors:", \
"Text",ExpressionUUID->"d4a214ae-2525-4771-bbaf-711fd1378527"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2", ",", 
   RowBox[{"OrthogonalTo", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"u", "[", "A", "]"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"bb0abaa1-4a05-43f4-b208-21de846b52f7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"510047bf-493d-4602-ad10-afc327f2b653"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2", ",", 
   RowBox[{"OrthogonalTo", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"u", "[", "A", "]"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"90e9b700-2c99-4a5f-b774-942a661ceb74"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d210c8d4-4ca6-43d2-9d9f-f9cab8dbeb44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "A", "]"}], 
  RowBox[{"u", "[", 
   RowBox[{"-", "A"}], 
   "]"}]}]], "Input",ExpressionUUID->"5891e3a3-0296-425b-a1a0-fdacf2b518dd"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"c1f88bca-e461-4ef9-ac30-e1ff5e5ab28e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"-", "A"}], "]"}], 
  RowBox[{
  "u", "[", "A", 
   "]"}]}]], "Input",ExpressionUUID->"e772d6a6-247c-486b-86ad-e4084c82d719"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"0266be45-a69c-4203-9b98-4170b136834f"]
}, Open  ]],

Cell["First derivatives:", \
"Text",ExpressionUUID->"c65ad3eb-0616-436d-82d8-d6fba9d010c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ProjectWith", "[", "h", "]"}], "[", 
       RowBox[{
        RowBox[{"CD", "[", 
         RowBox[{"-", "A"}], "]"}], "[", 
        RowBox[{"v", "[", 
         RowBox[{"-", "B"}], "]"}], "]"}], "]"}], "//", "ProjectorToMetric"}],
      "//", "Expand"}], "//", "GradNormalToExtrinsicK"}], "//", "Expand"}], "//",
   "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"08525242-a84b-4c3e-8aff-3f3906e5295e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Kh", 
         StyleBox[GridBox[{
            {" ", "C"},
            {"A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ExtrinsicKh[-$CellContext`A, C],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-C],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"B", 
           RowBox[{";", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-$CellContext`A][
    $CellContext`v[-$CellContext`B]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-C][
     $CellContext`v[-$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"f706dd13-da1d-4d20-bc3d-aecdfe66c7f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", "%"}], "+", 
    RowBox[{
     RowBox[{"CD", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"v", "[", 
      RowBox[{"-", "B"}], "]"}], "]"}], "-", 
    RowBox[{
     RowBox[{"u", "[", 
      RowBox[{"-", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "A"}], "]"}], "[", 
      RowBox[{"u", "[", "C", "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"u", "[", 
      RowBox[{"-", "A"}], "]"}], 
     RowBox[{"u", "[", "C", "]"}], 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"v", "[", 
       RowBox[{"-", "B"}], "]"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"u", "[", 
      RowBox[{"-", "A"}], "]"}], 
     RowBox[{"u", "[", 
      RowBox[{"-", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{"Accelerationu", "[", "C", "]"}]}]}], "//", 
   "GradNormalToExtrinsicK"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"964435db-10e9-4905-8f30-c31456870b29"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"9af82492-0acf-4689-9b85-1bf6a0278f95"]
}, Open  ]],

Cell["Second derivatives:", \
"Text",ExpressionUUID->"6d0be1fc-d630-4499-9db1-f86df6aea96d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Projectorh", "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{
       RowBox[{"CD", "[", 
        RowBox[{"-", "C"}], "]"}], "[", 
       RowBox[{"v", "[", 
        RowBox[{"-", "B"}], "]"}], "]"}], "]"}], "]"}], "-", 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{
      RowBox[{"cd", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"v", "[", 
       RowBox[{"-", "B"}], "]"}], "]"}], "]"}]}], "//", "ProjectDerivative"}],
   "//", "ProjectDerivative"}]], \
"Input",ExpressionUUID->"b3cf1784-de02-43bc-a43d-deaa8b32ae06"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "D"], 
         UnderscriptBox["P", "h"], "[", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"v", 
              StyleBox[GridBox[{
                 {" ", "  "},
                 {"B", 
                  RowBox[{";", "C"}]}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CD[-C][
           $CellContext`v[-$CellContext`B]],
          Editable->False], "]"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[-D][
        $CellContext`Projectorh[
         $CellContext`CD[-C][
          $CellContext`v[-$CellContext`B]]]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`CD[-D][
      $CellContext`Projectorh[
       $CellContext`CD[-C][
        $CellContext`v[-$CellContext`B]]]]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     UnderscriptBox["P", "h"], "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {" ", "  ", "  "},
             {"B", 
              RowBox[{";", "C"}], 
              RowBox[{";", "D"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-D][
       $CellContext`CD[-C][
        $CellContext`v[-$CellContext`B]]],
      Editable->False], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Projectorh[
    $CellContext`CD[-D][
     $CellContext`CD[-C][
      $CellContext`v[-$CellContext`B]]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"b48f9f56-a0a8-4aa7-ae7a-058a366ad213"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", 
   RowBox[{"Projectorh", "\[Rule]", 
    RowBox[{"ProjectWith", "[", "h", "]"}]}]}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"7e245e26-dc0d-4f8f-842f-30f769dfaef0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"h", 
         StyleBox[GridBox[{
            {" ", "G"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`h[-$CellContext`B, $CellContext`G],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "F"},
           {"C", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[-C, $CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "G1"},
           {"D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[-D, $CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "A", "  "},
           {"G", " ", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`h[-$CellContext`G, $CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "A"},
           {"B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[-$CellContext`B, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "G"},
           {"C", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[-C, $CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "G1"},
           {"D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[-D, $CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "F", "  "},
           {"G", " ", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`h[-$CellContext`G, $CellContext`F]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"516ab94c-06ad-4c20-95a7-56603ae5af92"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "ProjectorToMetric"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"f0101110-5f72-4e51-bcb1-5d848f4e976f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"u", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[$CellContext`A],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-C][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-C][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-$CellContext`G]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"C", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-$CellContext`G]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"C", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`u[-$CellContext`G]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-C][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"C", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-C]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"C", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-C]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-C][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-$CellContext`G]],
    Editable->False]}], "-", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-$CellContext`G]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"G1"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`G1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"G", 
            RowBox[{";", "G1"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G1][
     $CellContext`u[-$CellContext`G]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"6546fc33-6739-4c3c-8f88-88e4498e0427"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"%", "//", "GradNormalToExtrinsicK"}], "//", "Expand"}], "//", 
   "ContractMetric"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"954753f8-f596-44e7-accb-e6162929e9d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", "A"},
           {"C", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " "},
           {"D", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-D, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`A],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " "},
           {"D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-D, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`A],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " "},
           {"D", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-D, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`F][
     $CellContext`v[-$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"3d9652eb-afac-459f-9e6c-e0b52d200283"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "h", 
  "]"}]], "Input",ExpressionUUID->"810ac960-7811-4fe9-8059-d9070168b1d5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefInertHead", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"projector inert-head\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Projectorh"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefInertHead, ": Undefined ", "projector inert-head", 
   " ", $CellContext`Projectorh],
  Editable->
   False]], "Print",ExpressionUUID->"a6e38254-c07c-4b55-a8e9-6b6a3cb08f67"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"acceleration vector\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Accelerationu"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "acceleration vector", 
   " ", $CellContext`Accelerationu],
  Editable->
   False]], "Print",ExpressionUUID->"33fa117b-0c8c-4d51-9095-2a930c575439"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"extrinsic curvature tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ExtrinsicKh"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "extrinsic curvature tensor", " ", $CellContext`ExtrinsicKh],
  Editable->
   False]], "Print",ExpressionUUID->"b0cf1502-5f3e-4161-9a90-6b62c3125654"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Deth"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Deth],
  Editable->
   False]], "Print",ExpressionUUID->"5dd90ebf-e91a-4fca-9a05-a35d5828b81d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Christoffelcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`Christoffelcd],
  Editable->
   False]], "Print",ExpressionUUID->"c3f800ed-cca2-45c5-bafc-c8e7432080ea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Einsteincd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`Einsteincd],
  Editable->
   False]], "Print",ExpressionUUID->"06e9b903-d267-4510-88bb-5dc904b910ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Kretschmanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`Kretschmanncd],
  Editable->
   False]], "Print",ExpressionUUID->"aab74650-a3dc-45ba-b74b-db1bc27db30c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`Riccicd],
  Editable->
   False]], "Print",ExpressionUUID->"3ea46f7a-bcee-4142-8609-842ee597447a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarcd],
  Editable->
   False]], "Print",ExpressionUUID->"0af958c0-34f5-4df5-8823-189f7935d291"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riemanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`Riemanncd],
  Editable->
   False]], "Print",ExpressionUUID->"769b4538-8760-4393-ba9d-6d6f5818a606"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRiccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRiccicd],
  Editable->
   False]], "Print",ExpressionUUID->"4c7ce5b2-a7ce-461a-8c9d-dd7701189aeb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Torsioncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`Torsioncd],
  Editable->
   False]], "Print",ExpressionUUID->"4bd4298b-0f33-43da-98fa-512163e9afdd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Weylcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`Weylcd],
  Editable->
   False]], "Print",ExpressionUUID->"87f0da92-364a-4860-994c-fe0be9a8ef3b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`cd],
  Editable->
   False]], "Print",ExpressionUUID->"02552793-5d7e-4d3b-9ed7-fb2e7b44b4a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonh"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonh],
  Editable->
   False]], "Print",ExpressionUUID->"5cd27cdb-c357-49b7-8965-6fbee7af520a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "h"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`h],
  Editable->
   False]], "Print",ExpressionUUID->"a7829989-0516-421f-966d-8bdd391dcf30"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"u", ",", "v", ",", "w"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"c8f19e08-a51c-4980-90fa-7ad929e17102"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "u"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`u],
  Editable->
   False]], "Print",ExpressionUUID->"28c850a6-111d-495a-b4c7-142dba757a9f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"d75260cb-e9d3-446b-925f-fc1ec977a9e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"a66ce919-9fc3-451e-bf40-b2d0434fd451"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "metricg", 
  "]"}]], "Input",ExpressionUUID->"76f7eb11-e840-49ca-95e7-646ea096d04a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"86002710-58d3-4bdb-baad-125cdf51e8e4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"81cf5905-5bdc-488b-a6d0-b7b593ab4c83"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCD],
  Editable->
   False]], "Print",ExpressionUUID->"94c361fc-50fb-47c0-aab0-e30c291d74db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCD],
  Editable->
   False]], "Print",ExpressionUUID->"aeea8896-441c-4f5b-a4d2-38da566ad07c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"4888e1ed-2b2c-4cd0-84a5-052aef1a4d0e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCD],
  Editable->
   False]], "Print",ExpressionUUID->"05049f8b-daba-4d1b-99fa-b4e2c5622b50"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"e50f9039-d835-4384-a6cd-26c153e62569"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"f6a5bd36-07b3-44ac-9f91-a13f6966cb87"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"fde51410-9647-4a6d-ae2f-4095455f4108"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCD],
  Editable->
   False]], "Print",ExpressionUUID->"e8152877-dbc1-46ee-9ed6-dd768f2bd277"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"b416a847-2fe6-41f2-834f-103c9762fa0d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"03223ae6-2e43-42c8-8414-f24fbac438d7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"19fbb5a2-99dd-4bd9-ba12-5ba1a7413c18"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"dc66130b-2b12-40c9-9336-7b917f472cc5"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"f9dde17e-a416-40ce-bed1-6618e64f2b6a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"fca4efa2-da3c-4440-b337-3a14af7d1fb6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$252323\"\>", ",", "\<\"G$252323$\"\>", 
     ",", "\<\"G$252324\"\>", ",", "\<\"G$252324$\"\>", 
     ",", "\<\"G$252325\"\>", ",", "\<\"G$252325$\"\>", 
     ",", "\<\"G$252326\"\>", ",", "\<\"G$252326$\"\>", 
     ",", "\<\"G$252327\"\>", ",", "\<\"G$252327$\"\>", 
     ",", "\<\"G$252328\"\>", ",", "\<\"G$252328$\"\>", 
     ",", "\<\"G$252329\"\>", ",", "\<\"G$252329$\"\>", 
     ",", "\<\"G$252330\"\>", ",", "\<\"G$252330$\"\>", 
     ",", "\<\"G$252331\"\>", ",", "\<\"G$252331$\"\>", 
     ",", "\<\"G$252332\"\>", ",", "\<\"G$252332$\"\>", 
     ",", "\<\"G$252333\"\>", ",", "\<\"G$252333$\"\>", 
     ",", "\<\"G$252334\"\>", ",", "\<\"G$252334$\"\>", 
     ",", "\<\"G$252335\"\>", ",", "\<\"G$252335$\"\>", 
     ",", "\<\"G$252336\"\>", ",", "\<\"G$252336$\"\>", 
     ",", "\<\"G$252405\"\>", ",", "\<\"G$252406\"\>", 
     ",", "\<\"G$252407\"\>", ",", "\<\"G$252408\"\>", 
     ",", "\<\"G$252416\"\>", ",", "\<\"G$252417\"\>", 
     ",", "\<\"G$252425\"\>", ",", "\<\"G$252426\"\>", 
     ",", "\<\"G$252427\"\>", ",", "\<\"G$253599\"\>", 
     ",", "\<\"G$253600\"\>", ",", "\<\"G$253605\"\>", 
     ",", "\<\"G$253605$\"\>", ",", "\<\"G$253626\"\>", 
     ",", "\<\"G$253627\"\>", ",", "\<\"G$253655\"\>", 
     ",", "\<\"G$253656\"\>", ",", "\<\"G$253667\"\>", 
     ",", "\<\"G$253668\"\>", ",", "\<\"G$253669\"\>", 
     ",", "\<\"G$253670\"\>", ",", "\<\"G$253685\"\>", 
     ",", "\<\"G$253686\"\>", ",", "\<\"G$253687\"\>", 
     ",", "\<\"G$253688\"\>", ",", "\<\"G$253689\"\>", 
     ",", "\<\"G$253690\"\>", ",", "\<\"G$253704\"\>", 
     ",", "\<\"G$253705\"\>", ",", "\<\"G$253706\"\>", 
     ",", "\<\"G$253707\"\>", ",", "\<\"G$253708\"\>", 
     ",", "\<\"G$253709\"\>", ",", "\<\"G$253710\"\>", 
     ",", "\<\"G$253711\"\>", ",", "\<\"G$253712\"\>", 
     ",", "\<\"G$253713\"\>", ",", "\<\"G$253714\"\>", 
     ",", "\<\"G$253715\"\>", ",", "\<\"G$253749\"\>", 
     ",", "\<\"G$253750\"\>", ",", "\<\"G$253751\"\>", 
     ",", "\<\"G$253752\"\>", ",", "\<\"G$253753\"\>", 
     ",", "\<\"G$253754\"\>", ",", "\<\"G$253755\"\>", 
     ",", "\<\"G$253756\"\>", ",", "\<\"G$253757\"\>", 
     ",", "\<\"G$253758\"\>", ",", "\<\"G$253759\"\>", 
     ",", "\<\"G$253760\"\>", ",", "\<\"G$253761\"\>", 
     ",", "\<\"G$253762\"\>", ",", "\<\"G$253763\"\>", 
     ",", "\<\"G$253764\"\>", ",", "\<\"G$253765\"\>", 
     ",", "\<\"G$253766\"\>", ",", "\<\"G$253767\"\>", 
     ",", "\<\"G$253768\"\>", ",", "\<\"G$253769\"\>", 
     ",", "\<\"G$253795\"\>", ",", "\<\"G$253796\"\>", 
     ",", "\<\"G$253797\"\>", ",", "\<\"G$253798\"\>", 
     ",", "\<\"G$253799\"\>", ",", "\<\"G$253800\"\>", 
     ",", "\<\"G$253801\"\>", ",", "\<\"G$253802\"\>", 
     ",", "\<\"G$253803\"\>", ",", "\<\"G$253804\"\>", 
     ",", "\<\"G$253805\"\>", ",", "\<\"G$253806\"\>", 
     ",", "\<\"G$253807\"\>", ",", "\<\"G$253808\"\>", 
     ",", "\<\"G$253809\"\>", ",", "\<\"G$253810\"\>", 
     ",", "\<\"G$253811\"\>", ",", "\<\"G$253812\"\>", 
     ",", "\<\"G$253813\"\>", ",", "\<\"G$253814\"\>", 
     ",", "\<\"G$253815\"\>", ",", "\<\"G$253816\"\>", 
     ",", "\<\"G$253817\"\>", ",", "\<\"G$253818\"\>", 
     ",", "\<\"G$253819\"\>", ",", "\<\"G$253820\"\>", 
     ",", "\<\"G$253821\"\>", ",", "\<\"G$253822\"\>", 
     ",", "\<\"G$253823\"\>", ",", "\<\"G$253824\"\>", 
     ",", "\<\"G$253825\"\>", ",", "\<\"G$253826\"\>", 
     ",", "\<\"G$253827\"\>", ",", "\<\"G$253828\"\>", 
     ",", "\<\"G$253829\"\>", ",", "\<\"G$253830\"\>", 
     ",", "\<\"G$253831\"\>", ",", "\<\"G$253832\"\>", 
     ",", "\<\"G$253833\"\>", ",", "\<\"G$253834\"\>", 
     ",", "\<\"G$253835\"\>", ",", "\<\"G$253836\"\>", 
     ",", "\<\"G$253837\"\>", ",", "\<\"G$253838\"\>", 
     ",", "\<\"G$253839\"\>", ",", "\<\"G$253840\"\>", 
     ",", "\<\"G$253841\"\>", ",", "\<\"G$253842\"\>", 
     ",", "\<\"G$253843\"\>", ",", "\<\"G$253844\"\>", 
     ",", "\<\"G$253845\"\>", ",", "\<\"G$253846\"\>", 
     ",", "\<\"G$253847\"\>", ",", "\<\"G$253848\"\>", 
     ",", "\<\"G$253849\"\>", ",", "\<\"G$253850\"\>", 
     ",", "\<\"G$253873\"\>", ",", "\<\"G$253874\"\>", 
     ",", "\<\"G$253889\"\>", ",", "\<\"G$253890\"\>", 
     ",", "\<\"G$253891\"\>", ",", "\<\"G$253892\"\>", 
     ",", "\<\"G$253893\"\>", ",", "\<\"G$253894\"\>", 
     ",", "\<\"G$253895\"\>", ",", "\<\"G$253896\"\>", 
     ",", "\<\"G$253916\"\>", ",", "\<\"G$253916$\"\>", 
     ",", "\<\"G$253917\"\>", ",", "\<\"G$253917$\"\>", 
     ",", "\<\"G$253917$254101\"\>", ",", "\<\"G$253918\"\>", 
     ",", "\<\"G$253918$\"\>", ",", "\<\"G$253919\"\>", 
     ",", "\<\"G$253919$\"\>", ",", "\<\"G$253920\"\>", 
     ",", "\<\"G$253920$\"\>", ",", "\<\"G$253921\"\>", 
     ",", "\<\"G$253921$\"\>", ",", "\<\"G$253922\"\>", 
     ",", "\<\"G$253922$\"\>", ",", "\<\"G$253923\"\>", 
     ",", "\<\"G$253923$\"\>", ",", "\<\"G$253924\"\>", 
     ",", "\<\"G$253924$\"\>", ",", "\<\"G$253925\"\>", 
     ",", "\<\"G$253925$\"\>", ",", "\<\"G$253926\"\>", 
     ",", "\<\"G$253926$\"\>", ",", "\<\"G$253927\"\>", 
     ",", "\<\"G$253927$\"\>", ",", "\<\"G$253928\"\>", 
     ",", "\<\"G$253928$\"\>", ",", "\<\"G$253929\"\>", 
     ",", "\<\"G$253929$\"\>", ",", "\<\"G$254001\"\>", 
     ",", "\<\"G$254002\"\>", ",", "\<\"G$254003\"\>", 
     ",", "\<\"G$254004\"\>", ",", "\<\"G$254012\"\>", 
     ",", "\<\"G$254013\"\>", ",", "\<\"G$254021\"\>", 
     ",", "\<\"G$254022\"\>", ",", "\<\"G$254023\"\>", 
     ",", "\<\"G$254045\"\>", ",", "\<\"G$254046\"\>", 
     ",", "\<\"G$254060\"\>", ",", "\<\"G$254061\"\>", 
     ",", "\<\"G$254062\"\>", ",", "\<\"G$254063\"\>", 
     ",", "\<\"G$254064\"\>", ",", "\<\"G$254065\"\>", 
     ",", "\<\"G$254066\"\>", ",", "\<\"G$254067\"\>", 
     ",", "\<\"G$254086\"\>", ",", "\<\"G$254087\"\>", 
     ",", "\<\"G$254108\"\>", ",", "\<\"G$254112\"\>", 
     ",", "\<\"G$254113\"\>", ",", "\<\"G$254116\"\>", 
     ",", "\<\"G$254118\"\>", ",", "\<\"G$254120\"\>", 
     ",", "\<\"G$254125\"\>", ",", "\<\"G$254126\"\>", 
     ",", "\<\"G$254130\"\>", ",", "\<\"G$254131\"\>", 
     ",", "\<\"G$254132\"\>", ",", "\<\"G$254154\"\>", 
     ",", "\<\"G$254156\"\>", ",", "\<\"G$254164\"\>", 
     ",", "\<\"G$254166\"\>", ",", "\<\"G$254168\"\>", 
     ",", "\<\"G$254170\"\>", ",", "\<\"G$254172\"\>", 
     ",", "\<\"G$254174\"\>", ",", "\<\"G$254176\"\>", 
     ",", "\<\"G$254178\"\>", ",", "\<\"G$254180\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$252323", "G$252323$", "G$252324", "G$252324$", "G$252325", "G$252325$", 
    "G$252326", "G$252326$", "G$252327", "G$252327$", "G$252328", "G$252328$",
     "G$252329", "G$252329$", "G$252330", "G$252330$", "G$252331", 
    "G$252331$", "G$252332", "G$252332$", "G$252333", "G$252333$", "G$252334",
     "G$252334$", "G$252335", "G$252335$", "G$252336", "G$252336$", 
    "G$252405", "G$252406", "G$252407", "G$252408", "G$252416", "G$252417", 
    "G$252425", "G$252426", "G$252427", "G$253599", "G$253600", "G$253605", 
    "G$253605$", "G$253626", "G$253627", "G$253655", "G$253656", "G$253667", 
    "G$253668", "G$253669", "G$253670", "G$253685", "G$253686", "G$253687", 
    "G$253688", "G$253689", "G$253690", "G$253704", "G$253705", "G$253706", 
    "G$253707", "G$253708", "G$253709", "G$253710", "G$253711", "G$253712", 
    "G$253713", "G$253714", "G$253715", "G$253749", "G$253750", "G$253751", 
    "G$253752", "G$253753", "G$253754", "G$253755", "G$253756", "G$253757", 
    "G$253758", "G$253759", "G$253760", "G$253761", "G$253762", "G$253763", 
    "G$253764", "G$253765", "G$253766", "G$253767", "G$253768", "G$253769", 
    "G$253795", "G$253796", "G$253797", "G$253798", "G$253799", "G$253800", 
    "G$253801", "G$253802", "G$253803", "G$253804", "G$253805", "G$253806", 
    "G$253807", "G$253808", "G$253809", "G$253810", "G$253811", "G$253812", 
    "G$253813", "G$253814", "G$253815", "G$253816", "G$253817", "G$253818", 
    "G$253819", "G$253820", "G$253821", "G$253822", "G$253823", "G$253824", 
    "G$253825", "G$253826", "G$253827", "G$253828", "G$253829", "G$253830", 
    "G$253831", "G$253832", "G$253833", "G$253834", "G$253835", "G$253836", 
    "G$253837", "G$253838", "G$253839", "G$253840", "G$253841", "G$253842", 
    "G$253843", "G$253844", "G$253845", "G$253846", "G$253847", "G$253848", 
    "G$253849", "G$253850", "G$253873", "G$253874", "G$253889", "G$253890", 
    "G$253891", "G$253892", "G$253893", "G$253894", "G$253895", "G$253896", 
    "G$253916", "G$253916$", "G$253917", "G$253917$", "G$253917$254101", 
    "G$253918", "G$253918$", "G$253919", "G$253919$", "G$253920", "G$253920$",
     "G$253921", "G$253921$", "G$253922", "G$253922$", "G$253923", 
    "G$253923$", "G$253924", "G$253924$", "G$253925", "G$253925$", "G$253926",
     "G$253926$", "G$253927", "G$253927$", "G$253928", "G$253928$", 
    "G$253929", "G$253929$", "G$254001", "G$254002", "G$254003", "G$254004", 
    "G$254012", "G$254013", "G$254021", "G$254022", "G$254023", "G$254045", 
    "G$254046", "G$254060", "G$254061", "G$254062", "G$254063", "G$254064", 
    "G$254065", "G$254066", "G$254067", "G$254086", "G$254087", "G$254108", 
    "G$254112", "G$254113", "G$254116", "G$254118", "G$254120", "G$254125", 
    "G$254126", "G$254130", "G$254131", "G$254132", "G$254154", "G$254156", 
    "G$254164", "G$254166", "G$254168", "G$254170", "G$254172", "G$254174", 
    "G$254176", "G$254178", "G$254180"}],
  Editable->
   False]], "Print",ExpressionUUID->"8473f045-3428-4f22-8265-9d2a1c0e11e1"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["14.4. Derivatives on metrics", \
"Subsection",ExpressionUUID->"e5ace861-870c-467f-a71b-3327b9b392bd"],

Cell[CellGroupData[{

Cell["14.4.1. ZeroDerOnMetricQ", \
"Subsubsection",ExpressionUUID->"41a03733-0e0a-40e0-b58b-6daf2f657eda"],

Cell["Construct a metric tensor:", \
"Text",ExpressionUUID->"8caa1da3-33ab-44e1-af3c-7e27156d33fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"buildmetric", "[", "metric_", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"metric", ",", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"IndicesOfVBundle", "[", 
        RowBox[{"VBundleOfMetric", "@", "metric"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d5288a24-e9b9-4819-badf-77f1ce0677f9"],

Cell["\<\
First we need a function which tells us if a derivative anihilates a metric \
or not. We define it with remembered values (upvalues for the metric). This \
function seems redundant with ZeroDerivativeQ and hence should be eliminated, \
leaving only an adequate mixture, but seems quite some work.\
\>", "Text",ExpressionUUID->"13ec4cea-dab7-4bda-8e46-0e1a558fe067"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Safety", " ", "definition"}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{"der_", ",", "Null"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<Checking \>\"", ",", "der", ",", "\"\< on metric Null\>\""}], 
        "]"}], ";", "True"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Parametric", " ", 
     RowBox[{"derivatives", ".", " ", "Different"}], " ", "parameters", " ", 
     "commute"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{"OverDot", ",", "metric_"}], "]"}], ":=", 
     RowBox[{"xTagSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", ",", 
         RowBox[{"ZeroDerOnMetricQ", "[", 
          RowBox[{"OverDot", ",", "metric"}], "]"}]}], "}"}], ",", 
       RowBox[{"SameQ", "[", 
        RowBox[{
         RowBox[{"OverDot", "[", 
          RowBox[{"buildmetric", "[", "metric", "]"}], "]"}], ",", "0"}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"ParamD", "[", "par_", "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"xTagSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", ",", 
         RowBox[{"ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"ParamD", "[", "par", "]"}], ",", "metric"}], "]"}]}], 
        "}"}], ",", 
       RowBox[{"SameQ", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ParamD", "[", "par", "]"}], "[", 
          RowBox[{"buildmetric", "[", "metric", "]"}], "]"}], ",", "0"}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"ParamD", "[", "pars__", "]"}], ",", "metric_"}], "]"}], ":=", 
     
     RowBox[{"Apply", "[", 
      RowBox[{"Or", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"ParamD", "[", "#", "]"}], ",", "metric"}], "]"}], "&"}], "/@", 
        RowBox[{"{", "pars", "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Lie", " ", "derivatives"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"LieD", "[", "canv_", "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"xTagSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", ",", 
         RowBox[{"ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"LieD", "[", "canv", "]"}], ",", "metric"}], "]"}]}], 
        "}"}], ",", 
       RowBox[{"SameQ", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"LieD", "[", "canv", "]"}], "[", 
          RowBox[{"buildmetric", "[", "metric", "]"}], "]"}], ",", "0"}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Covariant", " ", "derivatives", " ", "with", " ", "CD"}], "-", 
     RowBox[{"indices", ":", " ", 
      RowBox[{"store", " ", "index"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", 
        RowBox[{"ind__", "?", "CDIndexQ"}], "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"derwithindex", "[", 
        RowBox[{"covd", ",", "ind"}], "]"}], ",", "metric"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"derwithindex", "[", 
        RowBox[{"covd_", ",", "ind__"}], "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"xTagSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", ",", 
         RowBox[{"ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"derwithindex", "[", 
            RowBox[{"covd", ",", "ind"}], "]"}], ",", "metric"}], "]"}]}], 
        "}"}], ",", 
       RowBox[{"SameQ", "[", 
        RowBox[{
         RowBox[{"CheckZeroDerivative", "[", 
          RowBox[{
           RowBox[{"covd", "[", "ind", "]"}], "[", 
           RowBox[{"buildmetric", "[", "metric", "]"}], "]"}], "]"}], ",", 
         "0"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "covariant", " ", 
     RowBox[{"derivatives", ":", " ", 
      RowBox[{"store", " ", "vbundle"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", 
        RowBox[{"ind_", "?", "ABIndexQ"}], "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"deronvbundle", "[", 
        RowBox[{"covd", ",", 
         RowBox[{"VBundleOfIndex", "[", "ind", "]"}]}], "]"}], ",", 
       "metric"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"deronvbundle", "[", 
        RowBox[{"covd_", ",", "vbundle_"}], "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"xTagSet", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"metric", ",", 
          RowBox[{"ZeroDerOnMetricQ", "[", 
           RowBox[{
            RowBox[{"deronvbundle", "[", 
             RowBox[{"covd", ",", "vbundle"}], "]"}], ",", "metric"}], 
           "]"}]}], "}"}], ",", "True"}], "]"}], "/;", 
      RowBox[{"SameQ", "[", 
       RowBox[{
        RowBox[{"CovDOfMetric", "[", "metric", "]"}], ",", "covd"}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"deronvbundle", "[", 
        RowBox[{"covd_", ",", "vbundle_"}], "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"tmpmetric", "=", 
         RowBox[{"changetoinducedmetric", "[", 
          RowBox[{"covd", ",", "metric"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"xTagSet", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"metric", ",", 
            RowBox[{"ZeroDerOnMetricQ", "[", 
             RowBox[{
              RowBox[{"deronvbundle", "[", 
               RowBox[{"covd", ",", "vbundle"}], "]"}], ",", "metric"}], 
             "]"}]}], "}"}], ",", 
          RowBox[{"ZeroDerOnMetricQ", "[", 
           RowBox[{
            RowBox[{"deronvbundle", "[", 
             RowBox[{"covd", ",", "vbundle"}], "]"}], ",", "tmpmetric"}], 
           "]"}]}], "]"}], "/;", 
        RowBox[{"tmpmetric", "=!=", "metric"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"deronvbundle", "[", 
        RowBox[{"covd_", ",", "vbundle_"}], "]"}], ",", "metric_"}], "]"}], ":=", 
     RowBox[{"xTagSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"metric", ",", 
         RowBox[{"ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"deronvbundle", "[", 
            RowBox[{"covd", ",", "vbundle"}], "]"}], ",", "metric"}], "]"}]}],
         "}"}], ",", 
       RowBox[{"SameQ", "[", 
        RowBox[{
         RowBox[{"CheckZeroDerivative", "[", 
          RowBox[{
           RowBox[{"covd", "[", 
            RowBox[{"-", 
             RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "]"}], "[", 
           RowBox[{"buildmetric", "[", "metric", "]"}], "]"}], "]"}], ",", 
         "0"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Multi", "-", 
     RowBox[{"index", " ", "derivative"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd_", "?", "CovDQ"}], "[", "inds__", "]"}], ",", 
       "metric_"}], "]"}], ":=", 
     RowBox[{"SameQ", "[", 
      RowBox[{
       RowBox[{"CheckZeroDerivative", "[", 
        RowBox[{
         RowBox[{"covd", "[", "inds", "]"}], "[", 
         RowBox[{"buildmetric", "[", "metric", "]"}], "]"}], "]"}], ",", 
       "0"}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8b89f847-c398-4052-96cb-2038985b7913"],

Cell["\<\
It might happen that we are comparing an induced derivative with the \
corresponding ambient metric. In that case we change to the induced metric. I \
don't remember why we do this.\
\>", "Text",ExpressionUUID->"6392eaad-f9dd-4248-8ce5-034113e28131"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd_", ",", "metric_"}], "]"}], ":=", 
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd", ",", "metric", ",", 
     RowBox[{"MetricOfCovD", "[", "covd", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd_", ",", "metric_", ",", "Null"}], "]"}], ":=", "metric"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd_", ",", "metric_", ",", "metric2_"}], "]"}], ":=", 
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd", ",", "metric", ",", "metric2", ",", 
     RowBox[{"InducedFrom", "[", "metric2", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd_", ",", "metric_", ",", "metric2_", ",", 
     RowBox[{"{", 
      RowBox[{"metric_", ",", "_"}], "}"}]}], "]"}], ":=", "metric2"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changetoinducedmetric", "[", 
    RowBox[{"covd_", ",", "metric_", ",", "metric2_", ",", "_"}], "]"}], ":=",
    "metric"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"36277f5f-f8a5-4cf1-9333-6fd2a6909e41"],

Cell["Internal notation for the downvalues of ZeroDerOnMetricQ:", \
"Text",ExpressionUUID->"52d4b601-3234-4f4d-8949-14715a7ca162"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sortder", "[", "OverDot", "]"}], ":=", "OverDot"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sortder", "[", 
    RowBox[{"ParamD", "[", "pars__", "]"}], "]"}], ":=", 
   RowBox[{"ParamD", "[", "pars", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sortder", "[", 
    RowBox[{"LieD", "[", "v_", "]"}], "]"}], ":=", 
   RowBox[{"LieD", "[", 
    RowBox[{"ToCanonicalDir", "[", "v", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sortder", "[", 
    RowBox[{
     RowBox[{"covd_", "?", "CovDQ"}], "[", 
     RowBox[{"ind_", "?", "CDIndexQ"}], "]"}], "]"}], ":=", 
   RowBox[{"derwithindex", "[", 
    RowBox[{"covd", ",", "ind"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"sortder", "[", 
    RowBox[{
     RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], "]"}], ":=", 
   RowBox[{"deronvbundle", "[", 
    RowBox[{"covd", ",", 
     RowBox[{"VBundleOfIndex", "[", "ind", "]"}]}], "]"}]}], ";"}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"7fad6f22-923e-45b2-9db1-96f49bb4f80e"],

Cell["\<\
This is the main function, which decides whether we must be careful with \
derivatives when canonicalizing an expression. There are currently no \
options. With $MixedDers=False the careQ check is not done.\
\>", "Text",ExpressionUUID->"098859ca-ce49-4352-9a0f-ec29e2163fd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$MixedDers", "=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"df28ed2b-d741-4a26-bc85-c15903ebc7cd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DersIn", "[", "sortedexpr_Object", "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{"sortder", "/@", 
     RowBox[{"Cases", "[", 
      RowBox[{"sortedexpr", ",", 
       RowBox[{
        RowBox[{"MyDer", "[", "der_", "]"}], "\[Rule]", "der"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsIn", "[", "sortedexpr_Object", "]"}], ":=", 
   RowBox[{"FirstMetricOfVBundle", "/@", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"Union", "[", 
       RowBox[{"VBundleOfIndex", "/@", 
        RowBox[{"Apply", "[", 
         RowBox[{"List", ",", 
          RowBox[{"First", "@", 
           RowBox[{"Last", "[", "sortedexpr", "]"}]}]}], "]"}]}], "]"}], ",", 
      "MetricEndowedQ"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"riskydermetricQ", "[", 
    RowBox[{"der_", ",", "metric_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"ZeroDerOnMetricQ", "[", 
      RowBox[{"der", ",", "metric"}], "]"}], ",", "Null", ",", 
     RowBox[{"risk", "[", 
      RowBox[{"der", ",", "metric"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BasesIn", "[", "sortedexpr_Object", "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{"Cases", "[", 
     RowBox[{"sortedexpr", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"_.", 
           RowBox[{"basis_", "?", "BasisQ"}]}]}], "}"}], ")"}], 
       "\[RuleDelayed]", "basis"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "Infinity"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"riskyderbasisQ", "[", 
    RowBox[{
     RowBox[{"derwithindex", "[", 
      RowBox[{"der_", ",", "_"}], "]"}], ",", "basis_"}], "]"}], ":=", 
   RowBox[{"riskyderbasisQ", "[", 
    RowBox[{"der", ",", "basis"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"riskyderbasisQ", "[", 
    RowBox[{"der_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"der", "===", 
      RowBox[{"xAct`xCoba`PDOfBasis", "[", "basis", "]"}]}], ",", "Null", ",", 
     RowBox[{"risk", "[", 
      RowBox[{"der", ",", "basis"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RiskyDers", "[", "sortedexpr_Object", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dersin", "=", 
       RowBox[{"DersIn", "[", "sortedexpr", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"Union", "@", 
        RowBox[{"Join", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Flatten", "@", 
           RowBox[{"Outer", "[", 
            RowBox[{"riskydermetricQ", ",", "dersin", ",", 
             RowBox[{"MetricsIn", "[", "sortedexpr", "]"}]}], "]"}]}], ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"Outer", "[", 
            RowBox[{"riskyderbasisQ", ",", "dersin", ",", 
             RowBox[{"BasesIn", "[", "sortedexpr", "]"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}]}], ",", "_risk"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"be32790c-586f-455b-8ebf-b38bc00cb67b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"careQ", "[", 
    RowBox[{"sortedexpr_Object", ",", "options___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"RiskyDers", "[", "sortedexpr", "]"}], "=!=", 
    RowBox[{"{", "}"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"588a0a97-6c97-4073-a224-14a5273348d9"],

Cell["\<\
Feb 2013. Dietmar Theiss has reported this problem. I extend RiskyDers to \
handle bases, but it is not enough. This needs a deeper fix in the \
canonicalizer.\
\>", "Text",ExpressionUUID->"ca54db51-c722-49f9-b446-96de6952d1f5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], ",", "M"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"0030cd06-9143-40ab-a17c-45c80fc579c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`a, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c1137279-88a4-4afc-8a06-20a7b4ebde3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "e"}], ",", 
    RowBox[{"{", 
     RowBox[{"f", ",", "chart"}], "}"}]}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "f"}], ",", 
      RowBox[{"-", "chart"}]}], "}"}], ",", "i"}], "]"}], 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "g"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "h"}], ",", 
     RowBox[{"-", "i"}]}], "]"}], "]"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"b5b094b2-1db6-4778-a3c8-31dfc644c15f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["f",
            FontColor->RGBColor[1., 0., 0.]]},
          {"e", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->9]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`e, {$CellContext`f, $CellContext`chart}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "i"},
          {
           StyleBox["f",
            FontColor->RGBColor[1., 0., 0.]], " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->9]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[{-$CellContext`f, -$CellContext`chart}, $CellContext`i],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "g"], GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"h", "i"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->9]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`g][
    $CellContext`T[-$CellContext`h, -$CellContext`i]],
   Editable->
    False]}]], "Output",ExpressionUUID->"3962ddf1-9292-47d4-b5df-2383aa7ef118"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"1faf21a0-b337-4a0f-a266-3b432a6d766f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "i"},
          {"e", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->9]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`e, $CellContext`i],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["f",
            FontColor->RGBColor[1., 0., 0.]]},
          {"i", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->9]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`i, {$CellContext`f, $CellContext`chart}],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "g"], GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"h", 
            StyleBox["f",
             FontColor->RGBColor[1., 0., 0.]]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->9]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`g][
    $CellContext`T[-$CellContext`h, {-$CellContext`f, -$CellContext`chart}]],
   Editable->
    False]}]], "Output",ExpressionUUID->"b748a2c9-82f9-4514-a8e3-e562847aee1f"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["14.5. Correcting characters", \
"Subsection",ExpressionUUID->"76b9f362-c5fb-4028-a7d6-a85552056d6f"],

Cell["\<\
A simpler form of SeparateMetric is SetCharacters, which corrects the \
characters of the indices of a tensor:\
\>", "Text",ExpressionUUID->"ef8e0a8b-6ba2-4b7f-9322-e5c80b837e84"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SetCharacters", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"tensor_", "?", "xTensorQ"}], ",", "chars_List"}], "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"rest_.", " ", 
      RowBox[{"tensor", "[", "inds__", "]"}]}], "\[RuleDelayed]", 
     RowBox[{"setcharacters", "[", 
      RowBox[{"rest", ",", 
       RowBox[{"tensor", "[", "inds", "]"}], ",", 
       RowBox[{"chars", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Up", "\[Rule]", "1"}], ",", 
          RowBox[{"Down", "\[Rule]", 
           RowBox[{"-", "1"}]}]}], "}"}]}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetCharacters", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"tensor_", "?", "xTensorQ"}]}], "]"}], ":=", 
   RowBox[{"SetCharacters", "[", 
    RowBox[{"expr", ",", "tensor", ",", 
     RowBox[{
      RowBox[{"SlotsOfTensor", "[", "tensor", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "_Symbol"}], "\[Rule]", 
         RowBox[{"-", "1"}]}], ",", 
        RowBox[{"_Symbol", "\[Rule]", "1"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetCharacters", "[", 
    RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"SetCharacters", ",", "expr", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetCharacters", "[", "expr_", "]"}], ":=", 
   RowBox[{"SetCharacters", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Head", "/@", 
      RowBox[{"FindAllOfType", "[", 
       RowBox[{"expr", ",", "Tensor"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SetCharacters", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SetCharacters", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"226758ee-7960-4aca-a36c-7e499268bda1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"setcharacters", "[", 
   RowBox[{"rest_", ",", 
    RowBox[{"tensor_", "[", "inds__", "]"}], ",", "chars_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"deltas", ",", 
      RowBox[{"newinds", "=", 
       RowBox[{"chars", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"DummyIn", "[", 
            RowBox[{"VBundleOfIndex", "[", "#", "]"}], "]"}], "&"}], "/@", 
          RowBox[{"{", "inds", "}"}]}], ")"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"deltas", "=", 
      RowBox[{"Inner", "[", 
       RowBox[{"delta", ",", 
        RowBox[{"IndexList", "[", "inds", "]"}], ",", 
        RowBox[{"ChangeIndex", "/@", 
         RowBox[{"IndexList", "@@", "newinds"}]}], ",", "Times"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ContractMetric", "[", 
       RowBox[{"rest", " ", "deltas"}], "]"}], 
      RowBox[{"tensor", "@@", "newinds"}]}]}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"53bf3666-212f-4709-99cb-5b99963b26cd"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["15. Symmetries and canonicalization",
  FontColor->RGBColor[0, 0, 1]],
 StyleBox[". Continue here with SeriesData",
  FontColor->RGBColor[1, 0, 0]]
}], "Section",
 FontSize->24,ExpressionUUID->"77e42395-e9a4-49c9-913d-ef91d5a51d7c"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"**", "**", "**", "**", "**", "**", "**", "**"}], "*", " ", "15.", 
   "Symmetries", " ", "and", " ", "canonicalization"}], " ", 
  "****************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"10f554f9-a7b3-4d4e-9649-b07a3152baaf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"69f3f645-cc4e-4a96-998c-775320012262"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "64.79537799999999`", ",", "636.311121`9.255214507093235", ",", 
   "0.10182975516141518`"}], 
  "}"}]], "Output",ExpressionUUID->"37c12cf5-3f0b-4727-8f09-01fbd5d8588c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["15.0. Comments", \
"Subsection",ExpressionUUID->"d21baf4f-762c-4dad-8731-a87de81827d7"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{
   "Print", "[", 
    "\"\<Reading section 15: Symmetries and canonicalization.\>\"", "]"}], 
   ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dcc8208f-a501-41c1-81b5-2112abbaad91"],

Cell[TextData[StyleBox["Main ideas:",
 FontWeight->
  "Bold"]], "Text",ExpressionUUID->"48b23b9a-5270-4e6c-91f8-a6b1424a6359"],

Cell[TextData[{
 "As usual, it is important to distinguish between the processes of \
canonicalization and simplification. The former is well defined once a \
canonical form has been decided for a generic expression, while the latter is \
largely subjective. There is no distinction, however, in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", which only gives the command Simplify. In ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " we construct ToCanonical, adding the canonicalization algorithms for \
tensors, and then construct \n\tSimplification[ expr ] := Simplify[ \
ToCanonical[ expr ] ].\nThe main objective of this section is actually \
constructing ToCanonical, by far the most powerful and complex function in \
the system. That will be done in three steps, whose combination forms the \
basic structure of ToCanonical:"
}], "Text",ExpressionUUID->"4727ae0b-dfa2-4972-a044-7406c5023e9b"],

Cell["\<\
1) First, we have to define some ordering for general expressions, regardless \
of the indices in that expression. That requires defining the most general \
expression we shall work with:
\t- An expression is assumed to be formed by a sum of (maybe one) terms, each \
one to be canonicalized independently, but sharing first the same dummies.
\t- Each term is assumed to be a product of (maybe one) monomials, each one \
to be canonicalized independently.
\t- A monomial is assumed to be a product of (maybe one) objects (tensors, \
forms, covariant derivatives, Lie derivatives, variational derivatives or \
inert heads), which can be contracted among them. Of course, scalar \
functions, Scalar expressions, constant symbols and parameters cannot be \
contracted and hence they form monomials. Objects can be \"commuting\" if \
they are \"equal\" under the sorting algorithm.

Since version 1.1.0 we can have several different products, and we need to \
sort them and their factors following the properties of those products.

A question pointed out by Bernd Br\[UDoubleDot]gmann is whether it is \
possible to canonicalize an expression without expanding it first. I don't \
really know. My impression is that it wouldn't be possible to canonicalize a \
whole expression, but perhaps it is possible to ensure canonicalization at \
some lower local level.

The function responsible for expression sorting is called xSort.\
\>", "Text",ExpressionUUID->"b9f2cd55-5817-45f3-8183-fb9a43e3976e"],

Cell["\<\
2) Once we have sorted the expression, we number its slots and construct a \
strong generating set for the slot-symmetries of the expression. This is done \
by the function SymmetryOf. There is still the big problem of the meaning of \
the symmetry of a sum of expressions.\
\>", "Text",ExpressionUUID->"7fe4b583-4220-4ddb-bfce-c3709c470b4d"],

Cell[TextData[{
 "3) Finally, given the actual configuration of indices, the canonical order \
for those indices (use IndexSort) and the slot-symmetries and \
dummy-symmetries of the expression, we can reorder the indices to construct \
the canonical form of that expression under the monoterm symmetries. This is \
done by the function ToCanonicalOne, which calls CanonicalPerm in ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 ", the hard part of the index canonicalization."
}], "Text",ExpressionUUID->"eb693626-e330-4b0f-975a-162b4885dd1c"],

Cell["\<\
There is a final minor step reducing the number of different dummy indices in \
the (sum) expression to a minimum (with SameDummies).\
\>", "Text",ExpressionUUID->"86070cda-5c56-4b9f-bea5-00a4852a2639"],

Cell[TextData[StyleBox["Comments:",
 FontWeight->
  "Bold"]], "Text",ExpressionUUID->"5133dca0-c8b3-45d9-a12e-5913ce959984"],

Cell[TextData[{
 "1) One of the most confusing things here is the order of application of \
permutations. We shall assume the following convention. Given a set of \
indices, we shall assume that IndexSort gives the Canonical Configuration \
(CC) of indices. Those indices can be the indices of a tensor, ordered in \
some particular way, that we shall call the Actual Configuration (AC). There \
is a permutation g such that\n\t\t\t\t\tCC . g = AC\n(Note that the \
permutation acts on the right of CC). We can think of two different sets: the \
set of indices (names) and the set of slots (numbers). A given permutation g \
gives how the indices must be assigned to the set of slots. In this sense CC \
lives in the world of indices, while AC lives in the world of slots. We could \
assign g dimensions of slots / indices. The group of symmetries of slots \
(what we usually call S) is a mapping from slots to slots and the group of \
symmetries of indices (what we usually call D) is a mapping from indices to \
indices. That means that the right way to order permutations is DgS, which is \
precisely the opposite to that used by Renato. Bad luck! This used to be also \
the convention in ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 ", but starting version 0.6 ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 " has changed to Renato's convention. This has several advantages (the \
documentation of ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 " is now easier to read, the comparison with the papers is simpler, and the \
code in ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 " is actually simpler). There are simply two InversePerm at the input and \
the output of the only call to CanonicalPerm in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " to correct this point."
}], "Text",ExpressionUUID->"38cb95d3-6447-4b31-ae95-91166c609474"],

Cell["\<\
2) A generic expression may involve many objects with indices in several \
vbundles, with several metrics and different derivatives. It may also have \
bases on those vbundles, or directions. It is clear that canonicalizing the \
whole thing is a tough task. General comments:
\t- Having several metrics on the same vbundle is not a problem. All but the \
first metrics are frozen and can be considered as any other tensor. Hence, \
from the point of view of canonicalization, having more metrics is not a \
problem, as long as we follow the rules for frozen metrics.
\t- Concerning bases and directions, we should be able to detect when there \
are potential problems. In those cases we shall separate bases and \
directions, letting the expression to expand. Still, there are basis or \
component indices in Basis expressions, but I guess those will not be \
problematic because they will be multiplying expressions, and the \
canonicalizer will not want to move them to objects other than Basis. Note \
that if there are multiple derivatives of a Basis object, we will need to \
separate basis indices several times.
\t- It is not clear to me whether we can let a metric of a vbundle to be a \
scalar field on other vbundles. Currently this is not allowed.
\t- The main problem is then that of derivatives which do not anihilate a \
metric. The function ZeroDerOnMetricQ has been introduced to handle that point.
\t- In general this section works with all types of indices. There could be \
problems with basis-indices and the symmetries of derivatives. The function \
STFPart does not worry about basis-indices (there is an AIndexQ selection) or \
non-metric derivatives.\
\>", "Text",ExpressionUUID->"a9f9c5ee-4d46-405b-af09-3b8cc1b024b2"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1. Sorting objects", \
"Subsection",ExpressionUUID->"8053386f-f8e0-4b3a-aeec-61a0c175b13a"],

Cell[CellGroupData[{

Cell["15.1.0. Comments", \
"Subsubsection",ExpressionUUID->"73f4d2b7-6949-44de-ab2e-9e8ec35881b7"],

Cell["\<\
We start by defining a parser from the user notation to the internal notation \
which will be used for canonicalization. Most of this is actually redundant \
with previous parts of the code (for example the recollection of indices is \
not done using FindIndices, etc). This serves a double purpose: first, we \
want to immediately deconstruct the expressions into symbols so that the user \
cannot access them anymore, to avoid interferences during the \
canonicalization process. Second, we want to have something efficient, and \
this new type of coding avoids recomputation of the internal structure of the \
objects involved. Note that Identify is also acting as a validation routine \
and actually we throw some messages, associating them to Validate.\
\>", "Text",ExpressionUUID->"3c30aef1-6dde-4ac0-a92e-88ef89a06fe9"],

Cell["\<\
The parser produces two types of descriptions:
\t- a characterization for object ordering independent of indices,
\t- a characterization of the index structure of the object.
The Object structure is
\tObject[object, {type, symorder, name}, {allindices, frees, dummies, \
blocked, metricstates}]\
\>", "Text",ExpressionUUID->"c5e4ed2a-d242-4e38-a144-1da2601bef4a"],

Cell["\<\
There are these types, sorted alphabetically:
\tConstant
\tConstantSymbol
\tParameter
\tScalar
\tTensor
The integer symorder gives the order of the group of slot-symmetries, and \
name is a unique name for the expression, not containing indices.\
\>", "Text",ExpressionUUID->"8bda0e63-a0de-4874-8df7-a7c3a14457c8"],

Cell["\<\
Concerning indices, we need this information on the slots of the tensor \
(called the \"metric-state\" of the index):
\t- The vbundle of the index in the slot.
\t- Whether there is a metric in that vbundle.
\t- Whether there is a derivative (or an inert-head) blocking the action of \
that metric.
The vbundle will be, say, -TangentM4. Then we store the metric: {-TangentM4, \
g} or {-TangentM4, Null} if there is no metric. Then we have to store the \
blocking derivative: {-TangentM4, g, PD[-i]}. This information will be used \
to check whether two objects are really commuting or not, and to check \
whether we can freely move indices up and down, or else we need to use a more \
cautious algorithm for canonicalization.\
\>", "Text",ExpressionUUID->"ab305733-ccb0-4b08-afde-543f0182b2da"],

Cell["\<\
There are elements which must be canonicalized at some point. These are \
either scalars (in Scalar expressions or scalar-functions) or directions \
(Dir-indices or directions in Lie-derivatives or Lie-brackets):\
\>", "Text",ExpressionUUID->"3447c3f1-4817-406f-934d-96809fb8dbe8"],

Cell["\<\
Products can have different commutativity properties. This is important for \
two reasons:

1) Factors must be reordered into a canonical form. Exchanging pairs may lead \
to a sign. We need a function that is able to determine those signs.

2) The presence of commutativiy properties in the products of indexed \
quantities induces new index symmetries in the expressions.\
\>", "Text",ExpressionUUID->"f263e3c7-6064-433a-9df4-54f14a3ec4f1"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.1. Scalars, vectors and Dir indices", \
"Subsubsection",ExpressionUUID->"6b5248b4-1020-4e70-a435-ba0e46043d02"],

Cell["\<\
These are three private special forms of ToCanonical, to canonicalize \
isolated indexed expressions. The functions ToCanonicalScalar and \
ToCanonicalDir functions require options, and to avoid having options in \
Identify we pass them through a blocked global variable $TCOptions from \
xSort. Note that these three special cases replace the dummy indices by \
proper user-defined indices. The ultraindex is always replaced by the first \
of the user-defined indices (considered the \[OpenCurlyDoubleQuote]nicest\
\[CloseCurlyDoubleQuote] index).\
\>", "Text",ExpressionUUID->"7a6f06c6-fa2f-48d5-8c68-dfcdb5578fd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Default", " ", "for", " ", "$TCOptions"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"$TCOptions", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Canonical", " ", "form", " ", "for", " ", "a", " ", "scalar", " ", 
     RowBox[{"(", 
      RowBox[{"with", " ", "or", " ", "without", " ", "Scalar", " ", "head"}],
       ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalScalar", "[", 
      RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"Scalar", "[", 
      RowBox[{"ToCanonicalScalar", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalScalar", "[", "expr_", "]"}], ":=", 
     RowBox[{"ReplaceDummies", "[", 
      RowBox[{
       RowBox[{"ToCanonical", "[", 
        RowBox[{"expr", ",", "$TCOptions"}], "]"}], ",", 
       RowBox[{"IndexList", "@@", "$AbstractIndices"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Canonical", " ", "form", " ", "for", " ", "a", " ", "direction", " ", 
     RowBox[{"(", 
      RowBox[{"with", " ", "or", " ", "without", " ", "Dir", " ", "head"}], 
      ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalDir", "[", 
      RowBox[{"Dir", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"Dir", "[", 
      RowBox[{"ToCanonicalDir", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalDir", "[", "expr_", "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"indices", "=", 
          RowBox[{"IndexList", "@@", "$AbstractIndices"}]}], ",", 
         RowBox[{"index", "=", 
          RowBox[{"UltraindexOf", "[", "expr", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Simplify", "@", 
        RowBox[{"ReplaceIndex", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ReplaceDummies", "[", 
           RowBox[{
            RowBox[{"ToCanonical", "[", 
             RowBox[{"expr", ",", "$TCOptions"}], "]"}], ",", 
            RowBox[{"Rest", "[", "indices", "]"}]}], "]"}], ",", 
          RowBox[{"index", "\[RuleDelayed]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"UpIndexQ", "[", "index", "]"}], ",", "UpIndex", ",", 
              "DownIndex"}], "]"}], "[", 
            RowBox[{"First", "[", "indices", "]"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Canonicalize", " ", "Dir", " ", "indices", " ", "in", " ", "the", " ", 
     "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalIndex", "[", "expr_", "]"}], ":=", 
     RowBox[{"expr", "/.", 
      RowBox[{"v_Dir", "\[RuleDelayed]", 
       RowBox[{"ToCanonicalDir", "[", "v", "]"}]}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c4b5f6ad-e677-4845-9213-b372b19ac453"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.2. Identify elementary objects", \
"Subsubsection",ExpressionUUID->"f5b593ab-a1de-42d1-bafb-8dec638966d4"],

Cell["\<\
The key idea is to convert expr into Object[expr, info] were the info will be \
later used to give the expr a canonical form. More precisely an Object has \
the form:

\tObject[ expr, {type, sym, name}, index-info ]\
\>", "Text",ExpressionUUID->"e3dfda20-265e-48c3-a7d6-7012a5f00915"],

Cell["\<\
The function Identify accepts any input and returns an Object. The expr in \
the first argument of Object has the products deactivated using \
VerbatimProduct[prod][ exprs ] instead of prod[ exprs ], in order to hide the \
attributes and definitions of the product. Factors that can commute are also \
marked with CommutingObjects[prod][ exprs ]. Identify replaces Plus by \
VerbatimPlus sum of those, again to avoid Plus to work too early.\
\>", "Text",ExpressionUUID->"0346e50c-0f25-4a00-b24e-2411c5ea3f6e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"isProductQ", "[", 
    RowBox[{"prod_", ",", "prod_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"isProductQ", "[", 
    RowBox[{
     RowBox[{"VerbatimProduct", "[", "prod_", "]"}], ",", "prod_"}], "]"}], ":=",
    "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"isProductQ", "[", 
    RowBox[{
     RowBox[{"CommutingObjects", "[", "prod_", "]"}], ",", "prod_"}], "]"}], ":=",
    "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"isProductQ", "[", 
    RowBox[{"_", ",", "prod_"}], "]"}], ":=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b76ebb99-76c6-4c79-b738-906816e4b49e"],

Cell[TextData[{
 "0) \"Metric-state\" of indices. This function returns the (signed) vbundle \
of the slot of the index, with the metric which could make it change \
character, or Null if there is no metric. Derivatives that may block the \
action of the metric are appended. Inert heads (like Perturbation in ",
 StyleBox["xPert",
  FontSlant->"Italic"],
 ") can also block the action of a metric."
}], "Text",ExpressionUUID->"4d757fdc-7e54-49f0-8bd0-a958fc639651"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Metric", " ", "state", " ", "of", " ", "an", " ", "index"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"metricstate", "[", "index_", "]"}], ":=", 
     RowBox[{"metricstate1", "[", 
      RowBox[{"SignedVBundleOfIndex", "[", "index", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricstate1", "[", "vbundle_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"vbundle", ",", 
       RowBox[{"FirstMetricOfVBundle", "[", 
        RowBox[{"vbundle", ",", "False"}], "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Modification", " ", "induced", " ", "by", " ", "a", " ", "derivative"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricderstate", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbundle_", ",", "Null"}], "}"}], ",", "der_"}], "]"}], ":=", 
     
     RowBox[{"{", 
      RowBox[{"vbundle", ",", "Null"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricderstate", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbundle_", ",", "metric_"}], "}"}], ",", "der_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ZeroDerOnMetricQ", "[", 
        RowBox[{"der", ",", "metric"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"vbundle", ",", "metric"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"vbundle", ",", "metric", ",", "der"}], "}"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"metricderstate", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vbundle_", ",", "metric_", ",", "other__"}], "}"}], ",", 
       "der_"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{"vbundle", ",", "metric", ",", "other", ",", "der"}], "}"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3c040584-1108-44d8-8957-cada00c433af"],

Cell["\<\
As a result we can get:
\t- {vbundle, Null}: there is no metric. Index cannot be moved.
\t- {vbundle, metric}: there is a metric. Index can be moved.
\t- {vbundle, metric, der1, ...}: there is a metric, but the index cannot be \
moved because a derivative is blocking the expression. der1 can also be an \
inert head.\
\>", "Text",ExpressionUUID->"466bb344-7055-4c0d-9834-0379f529fed2"],

Cell["\<\
Shortcut. Recall the notation for lists of indices { all, frees, dummies, \
blocked, all_states }\
\>", "Text",ExpressionUUID->"4fae27fc-d313-4333-8603-117124369dd7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EmptyILs", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"IndexList", "[", "]"}], ",", 
     RowBox[{"IndexList", "[", "]"}], ",", 
     RowBox[{"IndexList", "[", "]"}], ",", 
     RowBox[{"IndexList", "[", "]"}], ",", 
     RowBox[{"IndexList", "[", "]"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9c468f87-391b-4fe6-942d-7d8e207be58a"],

Cell["1) Numeric quantities and strings:", \
"Text",ExpressionUUID->"2b4164a3-8754-4008-81fa-3efc9307d83d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Object", "[", 
    RowBox[{"x", ",", 
     RowBox[{"{", 
      RowBox[{"Constant", ",", "1", ",", "x"}], "}"}], ",", "EmptyILs"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", "x_String", "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"Validate", "::", "nouse"}], ",", "\"\<Identify\>\"", ",", 
      "x"}], "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c6ab5abe-242e-499a-b14e-ee2a60732810"],

Cell["Identify threads over lists:", \
"Text",ExpressionUUID->"719597fc-c2e6-47d1-8651-8a2bb968d442"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", "list_List", "]"}], ":=", 
   RowBox[{"Identify", "/@", "list"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"934bd5c4-e618-4b72-a025-cd27a2898076"],

Cell["\<\
2) Basic structures to identify: tensors, constants, parameters. We already \
canonicalize D-indices, and the tensor heads, which could contain arbitrarily \
complicated expressions. Currently we pay no attention to the index-free (say \
grade) properties.\
\>", "Text",ExpressionUUID->"99e30fc8-0ea5-47c8-a6d5-4583cd61d159"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "]"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", "=", 
       RowBox[{"ToCanonicalTensorHead", "[", "tensor", "]"}]}], "}"}], ",", 
     RowBox[{"Object", "[", 
      RowBox[{
       RowBox[{"t", "[", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"Tensor", ",", "1", ",", "t"}], "}"}], ",", "EmptyILs"}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{
     RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds__", "]"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ilist", "=", 
        RowBox[{"ToCanonicalIndex", "[", 
         RowBox[{"IndexList", "[", "inds", "]"}], "]"}]}], ",", 
       RowBox[{"t", "=", 
        RowBox[{"ToCanonicalTensorHead", "[", "tensor", "]"}]}]}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"free", "=", 
          RowBox[{"TakeFrees", "[", "ilist", "]"}]}], ",", 
         RowBox[{"dum", "=", 
          RowBox[{"TakeEPairs", "[", "ilist", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Object", "[", 
        RowBox[{
         RowBox[{"t", "@@", "ilist"}], ",", 
         RowBox[{"{", 
          RowBox[{"Tensor", ",", 
           RowBox[{"OrderOfGroup", "@", 
            RowBox[{"SymmetryGroupOfTensor", "[", 
             RowBox[{"t", "[", "inds", "]"}], "]"}]}], ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"ilist", ",", "free", ",", "dum", ",", 
           RowBox[{"Complement", "[", 
            RowBox[{"ilist", ",", "free", ",", "dum"}], "]"}], ",", 
           RowBox[{"metricstate", "/@", "ilist"}]}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{"cs_Symbol", "?", "ConstantSymbolQ"}], "]"}], ":=", 
   RowBox[{"Object", "[", 
    RowBox[{"cs", ",", 
     RowBox[{"{", 
      RowBox[{"ConstantSymbol", ",", "1", ",", "cs"}], "}"}], ",", 
     "EmptyILs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{"p_Symbol", "?", "ParameterQ"}], "]"}], ":=", 
   RowBox[{"Object", "[", 
    RowBox[{"p", ",", 
     RowBox[{"{", 
      RowBox[{"Parameter", ",", "1", ",", "p"}], "}"}], ",", "EmptyILs"}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c240cab8-1e0a-4f44-b879-9d0a5c164a2a"],

Cell["\<\
3) Derivatives (first part). Even though the derivatives obey the Leibnitz \
rule, it is reasonable to assume that Identify[expr] in the following lines \
could return a generic expression (with heads Object, VerbatimProduct[prod] \
or Plus), and so we must use Identify as well. We canonicalize the direction \
of the Lie derivative and the possible directional index in the covariant \
derivative:\
\>", "Text",ExpressionUUID->"ea712435-c767-4de8-9436-6a2a213f96f9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "?", "CovDQ"}], "[", "ind__", "]"}], "[", "expr_", 
     "]"}], "]"}], ":=", 
   RowBox[{"addderivative", "[", 
    RowBox[{
     RowBox[{"ToCanonicalIndex", "[", 
      RowBox[{"covd", "[", "ind", "]"}], "]"}], ",", 
     RowBox[{"Identify", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{"OverDot", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"addderivative", "[", 
    RowBox[{"OverDot", ",", 
     RowBox[{"Identify", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"addderivative", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "ps", "]"}], ",", 
     RowBox[{"Identify", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", 
    RowBox[{
     RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"addderivative", "[", 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"ToCanonicalDir", "[", "v", "]"}], "]"}], ",", 
     RowBox[{"Identify", "[", "expr", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"36a592bb-0a72-4286-adf5-c6a75129b0b0"],

Cell["\<\
4) Manipulation of indices. There is no canonicalization here. This function \
appends a single index to the lists of indices:\
\>", "Text",ExpressionUUID->"f77d46dc-8b6c-4110-9a30-978a0fc1c50f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"appendindex", "[", 
    RowBox[{"ind_", ",", 
     RowBox[{"{", 
      RowBox[{
      "allinds_", ",", "frees_", ",", "dummies_", ",", "blocked_", ",", 
       "mstates_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"cind", "=", 
       RowBox[{"ChangeIndex", "[", "ind", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Pair", " ", "in", " ", "free", " ", 
        RowBox[{"indices", ":", " ", 
         RowBox[{"add", " ", "to", " ", "dummies"}]}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"frees", ",", "cind"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"allinds", ",", "ind"}], "]"}], ",", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{"frees", ",", "cind"}], "]"}], ",", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"dummies", ",", "cind"}], "]"}], ",", "ind"}], "]"}], ",",
          "blocked", ",", 
         RowBox[{"Append", "[", 
          RowBox[{"mstates", ",", 
           RowBox[{"metricstate", "[", "ind", "]"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Traceable", " ", 
         RowBox[{"index", ":", " ", 
          RowBox[{"add", " ", "to", " ", "frees"}]}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"EIndexQ", "[", "ind", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"allinds", ",", "ind"}], "]"}], ",", 
         RowBox[{"Append", "[", 
          RowBox[{"frees", ",", "ind"}], "]"}], ",", "dummies", ",", 
         "blocked", ",", 
         RowBox[{"Append", "[", 
          RowBox[{"mstates", ",", 
           RowBox[{"metricstate", "[", "ind", "]"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Blocked", " ", 
         RowBox[{"index", ":", " ", 
          RowBox[{"add", " ", "to", " ", "blocked"}]}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"BlockedQ", "[", "ind", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"allinds", ",", "ind"}], "]"}], ",", "frees", ",", 
         "dummies", ",", 
         RowBox[{"Append", "[", 
          RowBox[{"blocked", ",", "ind"}], "]"}], ",", 
         RowBox[{"Append", "[", 
          RowBox[{"mstates", ",", 
           RowBox[{"metricstate", "[", "ind", "]"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ToCanonical", "::", "nouse"}], ",", "\"\<appendindex\>\"", 
          ",", "ind"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7a0ba85c-6fff-44f0-b89d-90d7e66195d2"],

Cell["\<\
Combine indices in products and sums. Note that we say that the indices of \
T[a,b,-b]+V[a,c,-c] are {a,b,-b,c,-c}.\
\>", "Text",ExpressionUUID->"916615cb-3f52-440f-b81a-01bd8a50cedb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Combine", " ", "indices", " ", "in", " ", "products"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TimesIndices", "[", 
     RowBox[{"{", 
      RowBox[{
      "alls_", ",", "frees_", ",", "dums_", ",", "bls_", ",", "mss_"}], "}"}],
      "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"free", "=", 
        RowBox[{"Join", "@@", "frees"}]}], "}"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"DuplicateFreeQ", "[", "free", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"all", "=", 
             RowBox[{"Join", "@@", "alls"}]}], ",", 
            RowBox[{"newfree", "=", 
             RowBox[{"TakeFrees", "[", "free", "]"}]}], ",", 
            RowBox[{"blocked", "=", 
             RowBox[{"Join", "@@", "bls"}]}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"all", ",", "newfree", ",", 
            RowBox[{"Complement", "[", 
             RowBox[{"all", ",", "newfree", ",", "blocked"}], "]"}], ",", 
            "blocked", ",", 
            RowBox[{"Union", "@@", "mss"}]}], "}"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Throw", "@", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Validate", "::", "repeated"}], ",", 
           RowBox[{"Complement", "[", 
            RowBox[{"free", ",", 
             RowBox[{"DeleteDuplicates", "[", "free", "]"}]}], "]"}]}], 
          "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4de2b16e-7858-4fc7-94d5-d0ef23d3a001"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Combine", " ", "indices", " ", "in", " ", "sums"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"PlusIndices", "[", 
     RowBox[{"{", 
      RowBox[{
      "alls_", ",", "frees_", ",", "dums_", ",", "bls_", ",", "mss_"}], "}"}],
      "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SameQ", "@@", 
       RowBox[{"(", 
        RowBox[{"Sort", "/@", "frees"}], ")"}]}], ",", "\[IndentingNewLine]", 
      
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Union", "@@", "alls"}], ",", 
        RowBox[{"First", "@", "frees"}], ",", 
        RowBox[{"Union", "@@", "dums"}], ",", 
        RowBox[{"Union", "@@", "bls"}], ",", 
        RowBox[{"Union", "@@", "mss"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Throw", "@", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Validate", "::", "inhom"}], ",", "\"\<indices\>\"", ",", 
         "frees"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6ac81868-27a0-4eef-a97a-6b122b5a1018"],

Cell["\<\
This function finds all free indices of an expression returned by xSort. It \
is only used by ObjectSort, to compute the $FreesForSorting. There we cannot \
use the corresponding argument of Object because we need to sort before the \
Object is constructed!\
\>", "Text",ExpressionUUID->"0c197460-3a22-4563-a898-93c1ecad79c1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"freeindices", "[", 
    RowBox[{"Object", "[", 
     RowBox[{"_", ",", "_", ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "frees_", ",", "_", ",", "_", ",", "_"}], "}"}]}], 
     "]"}], "]"}], ":=", "frees"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"freeindices", "[", 
    RowBox[{
     RowBox[{"CommutingObjects", "[", "_", "]"}], "[", "exprs___", "]"}], 
    "]"}], ":=", 
   RowBox[{"TakeFrees", "[", 
    RowBox[{"Join", "@@", 
     RowBox[{"(", 
      RowBox[{"freeindices", "/@", 
       RowBox[{"{", "exprs", "}"}]}], ")"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"freeindices", "[", 
    RowBox[{
     RowBox[{"VerbatimProduct", "[", "_", "]"}], "[", "exprs___", "]"}], 
    "]"}], ":=", 
   RowBox[{"TakeFrees", "[", 
    RowBox[{"Join", "@@", 
     RowBox[{"(", 
      RowBox[{"freeindices", "/@", 
       RowBox[{"{", "exprs", "}"}]}], ")"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"freeindices", "[", "expr_VerbatimPlus", "]"}], ":=", 
   RowBox[{"freeindices", "[", 
    RowBox[{"First", "[", "expr", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fc72efc9-a330-4cd4-a9ab-f01a9a8c9d33"],

Cell["\<\
5) Derivatives (second part). Note that we do not change the symmetry order \
of the objects when adding derivatives. Now that has been changed, after the \
bug found by Cyril. The previous sym has been replaced by Flatten@..., which \
now gives a list of orders instead of an order only. This complicates things \
for products, sums and Lie brackets below.\
\>", "Text",ExpressionUUID->"233616d7-36d2-4821-8f2a-9d72537bf17a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dername", "[", 
    RowBox[{
     RowBox[{"covd_", "?", "CovDQ"}], "[", "ind__", "]"}], "]"}], ":=", 
   "covd"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dername", "[", "der_LieD", "]"}], ":=", "der"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dername", "[", "der_ParamD", "]"}], ":=", "der"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dername", "[", "OverDot", "]"}], ":=", "OverDot"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"addderivative", "[", 
    RowBox[{"der_", ",", 
     RowBox[{"Object", "[", 
      RowBox[{"object_", ",", 
       RowBox[{"{", 
        RowBox[{"type_", ",", "sym_", ",", "name_"}], "}"}], ",", "inds_"}], 
      "]"}]}], "]"}], ":=", 
   RowBox[{"Object", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"der", "[", "object", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"type", ",", "\[IndentingNewLine]", 
       RowBox[{"Flatten", "@", 
        RowBox[{"{", 
         RowBox[{"sym", ",", 
          RowBox[{"OrderOfGroup", "@", 
           RowBox[{"Last", "@", 
            RowBox[{"SymmetryOf", "[", 
             RowBox[{"der", "[", "object", "]"}], "]"}]}]}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dername", "[", "der", "]"}], ",", "name", ",", 
         RowBox[{"MyDer", "[", "der", "]"}]}], "}"}]}], "\[IndentingNewLine]",
       "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"appendderindex", "[", 
      RowBox[{"der", ",", 
       RowBox[{"recheckmetricstates", "[", 
        RowBox[{"der", ",", "inds"}], "]"}]}], "]"}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"09b6480c-53b7-4e59-b405-15bfd4b902c2"],

Cell["\<\
When appending a derivative we also need to check whether the metric-states \
of the indices have changed:\
\>", "Text",ExpressionUUID->"a2281fb1-c550-496a-a314-7cc7f21b6752"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"recheckmetricstates", "[", 
    RowBox[{"der_", ",", 
     RowBox[{"{", 
      RowBox[{
      "allinds_", ",", "frees_", ",", "dummies_", ",", "blocked_", ",", 
       "mstates_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"allinds", ",", "frees", ",", "dummies", ",", "blocked", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"metricderstate", "[", 
        RowBox[{"#", ",", "der"}], "]"}], "&"}], "/@", "mstates"}]}], "}"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"appendderindex", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], ",", "inds_"}], 
    "]"}], ":=", 
   RowBox[{"appendindex", "[", 
    RowBox[{"ind", ",", "inds"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"appendderindex", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "?", "CovDQ"}], "[", 
      RowBox[{"ind_", ",", "other__"}], "]"}], ",", "inds_"}], "]"}], ":=", 
   RowBox[{"appendderindex", "[", 
    RowBox[{
     RowBox[{"covd", "[", "other", "]"}], ",", 
     RowBox[{"appendindex", "[", 
      RowBox[{"ind", ",", "inds"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"appendderindex", "[", 
    RowBox[{"der_", ",", "inds_"}], "]"}], ":=", "inds"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"21d337d1-4e2d-4812-bbe6-116a6e22e1ed"],

Cell["\<\
6) Inert-heads and scalar-functions. We add the head Scalar. We consider the \
possibility of inert-heads with any number of arguments, but only the first \
one is tensorial. The expression is broken into pieces and therefore if the \
inerthead has a hold attribute then its argument is allowed to evaluate here \
(very bad... QUESTION: How can we solve this?). That is why we need to keep \
the whole expression all along (the first argument, x). But then the scalars \
of the scalarfunctions are not canonicalized... Right now we do not seem to \
use the x argument anyway.\
\>", "Text",ExpressionUUID->"791dd478-9000-4f7c-a02d-7f6794611c2e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "addhead1A", ",", "addhead1B", ",", "addheadnA", ",", "addheadnB"}], 
     "}"}], ",", "HoldFirst"}], "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"1ad1acb2-9a46-4401-9251-7f9ccf084ee7"],

Cell["\<\
The additional arguments of an inert-head could have IndexList elements, \
which must be canonicalized.\
\>", "Text",ExpressionUUID->"37ef7c81-19a4-4bdd-9f61-de3773f7cde4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Inert", "-", "head"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
         RowBox[{"expr_", ",", "z___"}], "]"}], ")"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"canonz", "=", 
          RowBox[{
           RowBox[{"{", "z", "}"}], "/.", 
           RowBox[{"list_IndexList", "\[RuleDelayed]", 
            RowBox[{"ToCanonicalIndex", "[", "list", "]"}]}]}]}], ",", 
         "head"}], "}"}], ",", 
       RowBox[{"addhead1A", "[", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"Function", "@@", 
           RowBox[{"{", 
            RowBox[{"head", "[", 
             RowBox[{"#", ",", 
              RowBox[{"Sequence", "@@", "canonz"}]}], "]"}], "}"}]}], "/.", 
          RowBox[{"head", "\[Rule]", "ih"}]}], ",", "expr"}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Scalar", "-", 
     RowBox[{
     "function", " ", "of", " ", "a", " ", "single", " ", "argument"}]}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"sf_", "?", "ScalarFunctionQ"}], "[", "expr_", "]"}], 
        ")"}]}], "]"}], ":=", 
     RowBox[{"addhead1A", "[", 
      RowBox[{"x", ",", "sf", ",", 
       RowBox[{"Scalar", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Derivative", "[", "der_Integer", "]"}], "[", 
          RowBox[{"sf_", "?", "ScalarFunctionQ"}], "]"}], "[", "expr_", "]"}],
         ")"}]}], "]"}], ":=", 
     RowBox[{"addhead1A", "[", 
      RowBox[{"x", ",", 
       RowBox[{
        RowBox[{"Derivative", "[", "der", "]"}], "[", "sf", "]"}], ",", 
       RowBox[{"Scalar", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Scalar", "-", 
     RowBox[{"function", " ", "of", " ", "several", " ", "arguments"}]}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"sf_", "?", "ScalarFunctionQ"}], "[", "exprs___", "]"}], 
        ")"}]}], "]"}], ":=", 
     RowBox[{"addheadnA", "[", 
      RowBox[{"x", ",", "sf", ",", 
       RowBox[{"Scalar", "/@", 
        RowBox[{"{", "exprs", "}"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"s", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Derivative", "[", "ders__Integer", "]"}], "[", 
          RowBox[{"sf_", "?", "ScalarFunctionQ"}], "]"}], "[", "exprs__", 
         "]"}], ")"}]}], "]"}], ":=", 
     RowBox[{"addheadnA", "[", 
      RowBox[{"x", ",", 
       RowBox[{
        RowBox[{"Derivative", "[", "ders", "]"}], "[", "sf", "]"}], ",", 
       RowBox[{"Scalar", "/@", 
        RowBox[{"{", "exprs", "}"}]}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8a49c520-1388-4fef-aa44-2a0fd0e155cd"],

Cell["\<\
The metric-states of the indices of an inert-head could change due to the \
inert-head. That is not taken into account right now. TODO. This must be done \
using the ContractThrough option of the inert-head.\
\>", "Text",ExpressionUUID->"afcfc911-6ea0-479c-9629-e01e23547788"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", 
    RowBox[{"argument", ".", " ", "Note"}], " ", "that", " ", "the", " ", "x",
     " ", "expressions", " ", "are", " ", "ignored", " ", "in", " ", "the", 
    " ", "B", " ", "step"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"addhead1A", "[", 
      RowBox[{"x_", ",", "head_", ",", "expr_"}], "]"}], ":=", 
     RowBox[{"addhead1B", "[", 
      RowBox[{"x", ",", "head", ",", 
       RowBox[{"Identify", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"addhead1B", "[", 
      RowBox[{"x_", ",", "head_", ",", 
       RowBox[{"Object", "[", 
        RowBox[{"object_", ",", 
         RowBox[{"{", 
          RowBox[{"type_", ",", "sym_", ",", "name_"}], "}"}], ",", "inds_"}],
         "]"}]}], "]"}], ":=", 
     RowBox[{"Object", "[", 
      RowBox[{
       RowBox[{"head", "[", "object", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"type", ",", "sym", ",", 
         RowBox[{"{", 
          RowBox[{"head", ",", "name"}], "}"}]}], "}"}], ",", "inds"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Several", " ", 
     RowBox[{"arguments", ".", " ", "The"}], " ", "result", " ", "has", " ", 
     "type1", " ", "and", " ", "inds1"}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"addheadnA", "[", 
      RowBox[{"x_", ",", "head_", ",", "exprs_List"}], "]"}], ":=", 
     RowBox[{"addheadnB", "[", 
      RowBox[{"x", ",", "head", ",", 
       RowBox[{"Identify", "/@", "exprs"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"addheadnB", "[", 
      RowBox[{"x_", ",", "head_", ",", 
       RowBox[{"objects", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Object", "[", 
           RowBox[{"_", ",", 
            RowBox[{"{", 
             RowBox[{"type1_", ",", "sym1_", ",", "_"}], "}"}], ",", 
            "inds1_"}], "]"}], ",", "__"}], "}"}]}]}], "]"}], ":=", 
     RowBox[{"Object", "[", 
      RowBox[{
       RowBox[{"head", "@@", 
        RowBox[{"(", 
         RowBox[{"First", "/@", "objects"}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"type1", ",", "sym1", ",", 
         RowBox[{"{", 
          RowBox[{"head", ",", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"(", 
             RowBox[{"objects", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2", ",", 
                RowBox[{"-", "1"}]}], "]"}], "]"}], ")"}]}]}], "}"}]}], "}"}],
        ",", "inds1"}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e3909783-6210-460b-8abd-a4ed41940d50"],

Cell["\<\
7) Scalar structures. Note that Scalar has type Scalar and not the type of \
its expression inside.\
\>", "Text",ExpressionUUID->"f2bebadc-005b-4d67-9edb-d808f47146d9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", "expr_Scalar", "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"expr1", "=", 
       RowBox[{"ToCanonicalScalar", "[", "expr", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Object", "[", 
      RowBox[{"expr1", ",", 
       RowBox[{"{", 
        RowBox[{"Scalar", ",", "1", ",", "expr1"}], "}"}], ",", "EmptyILs"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6eb69558-2fdd-4a9a-b89f-e1f8a545b550"],

Cell["8) Definitions on compound expressions.", \
"Text",ExpressionUUID->"fd047452-109b-41db-9477-72e99670e8ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"ToObject", "[", 
    RowBox[{"Identify", "/@", 
     RowBox[{"VerbatimPlus", "@@", "expr"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"92532150-f7b5-430a-9418-b2b6baf0dd23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Products", ".", " ", "Identify"}], " ", "always", " ", "acts", 
     " ", "on", " ", "original", " ", "expressions"}], ",", " ", 
    RowBox[{
    "never", " ", "on", " ", "Object", " ", "or", " ", "VP", " ", 
     "expressions"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", "expr_Times", "]"}], ":=", 
     RowBox[{"ToObject", "[", 
      RowBox[{"ObjectSort", "[", 
       RowBox[{"Identify", "/@", 
        RowBox[{
         RowBox[{"VerbatimProduct", "[", "Times", "]"}], "@@", "expr"}]}], 
       "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"prod_", "?", "ProductQ"}], "[", "__", "]"}]}], "]"}], ":=", 
     RowBox[{"ToObject", "[", 
      RowBox[{"ObjectSort", "[", 
       RowBox[{"Identify", "/@", 
        RowBox[{
         RowBox[{"VerbatimProduct", "[", "prod", "]"}], "@@", "expr"}]}], 
       "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Identify", "[", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "___", "]"}]}], 
      "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"xSort", "::", "error"}], ",", 
        "\"\<Identify on a VP. This should not happen.\>\""}], "]"}]}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7955dcfc-4cb9-4cd2-a940-bcdad2264fb3"],

Cell["\<\
9) Default definition. Note that the error message is not thrown:\
\>", "Text",ExpressionUUID->"7e65544b-76a7-42f6-940f-0ba6b12f6d83"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "::", "noident"}], "=", 
   "\"\<Unknown expression not canonicalized: `1` .\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Identify", "[", "expr_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"ToCanonical", "::", "noident"}], ",", "expr"}], "]"}], ";", 
     RowBox[{"Object", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"{", 
        RowBox[{"ABBA", ",", "1", ",", "expr"}], "}"}], ",", "EmptyILs"}], 
      "]"}]}], ")"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a1c3dc86-d3b4-4df9-9c55-52a39fc9a8d1"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.3. ToObject: combine objects", \
"Subsubsection",ExpressionUUID->"f1d4897c-9d5c-45bf-b328-4b1ff18397e0"],

Cell["\<\
The function ToObject is in charge of converting products and sums of objects \
into an Object expression.\
\>", "Text",ExpressionUUID->"f60d3b73-54f1-489e-97a2-5374bd234654"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Combine", " ", "symmetry", " ", "orders", " ", "using", " ", "the", " ", 
     "*", "flat", "*", " ", "operator", " ", "op"}], ",", " ", 
    RowBox[{
    "Times", " ", "for", " ", "products", " ", "or", " ", "GCD", " ", "for", 
     " ", "sums"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"makeList", "[", "list_List", "]"}], ":=", "list"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"makeList", "[", "x_", "]"}], ":=", 
     RowBox[{"{", "x", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"symListCombine", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "op_"}], "]"}], ":=", 
     RowBox[{"Throw", "[", "\"\<Error in symListCombine\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"symListCombine", "[", 
      RowBox[{
       RowBox[{"{", "a_", "}"}], ",", "op_"}], "]"}], ":=", "a"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"symListCombine", "[", 
      RowBox[{"list_List", ",", "op_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"llist", "=", 
         RowBox[{"makeList", "/@", "list"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"length", "=", 
           RowBox[{"Max", "[", 
            RowBox[{"Length", "/@", "llist"}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"op", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"PadRight", "[", 
              RowBox[{"#", ",", "length", ",", "1"}], "]"}], "&"}], "/@", 
            "llist"}], ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fd2843b3-b784-4edd-b3bc-47ed4db1ac5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Handle", " ", "signs"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", 
      RowBox[{"AddedSign", "[", 
       RowBox[{"1", ",", "expr_"}], "]"}], "]"}], ":=", 
     RowBox[{"ToObject", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", 
      RowBox[{"AddedSign", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "expr_"}], "]"}], "]"}], ":=", 
     RowBox[{"MapAt", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"VerbatimProduct", "[", "Times", "]"}], "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "#"}], "]"}], "&"}], ",", 
       RowBox[{"ToObject", "[", "expr", "]"}], ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", 
      RowBox[{"AddedSign", "[", 
       RowBox[{"0", ",", "expr_"}], "]"}], "]"}], ":=", 
     RowBox[{"Identify", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Products", " ", "of", " ", "objects"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", 
      RowBox[{"vprod", ":", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"VerbatimProduct", "|", "CommutingObjects"}], ")"}], "[", 
         "prod_", "]"}], "[", "objects__Object", "]"}]}], "]"}], ":=", 
     RowBox[{"Object", "[", "\[IndentingNewLine]", 
      RowBox[{"vprod", ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"list", "=", 
           RowBox[{"Transpose", "[", 
            RowBox[{
             RowBox[{"{", "objects", "}"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prod", ",", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"symListCombine", "[", 
            RowBox[{
             RowBox[{"list", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", "Times"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"prod", ",", 
             RowBox[{"list", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"TimesIndices", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"{", "objects", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "3"}], "]"}], "]"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"VerbatimProduct", "|", "CommutingObjects"}], ")"}], "[", 
         "prod_", "]"}], "[", "___", "]"}]}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", 
        "\"\<INFO: ToObject acting on a VP with not all Objects.\>\"", "]"}], 
       ";", 
       RowBox[{"ToObject", "[", 
        RowBox[{"ToObject", "/@", "expr"}], "]"}]}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Sum", " ", 
     RowBox[{"(", "VerbatimPlus", ")"}], " ", "of", " ", 
     RowBox[{"objects", ".", " ", "Note"}], " ", "that", " ", "the", " ", 
     "first", " ", "argument", " ", "contain", " ", "full", " ", "objects"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", 
      RowBox[{"expr", ":", 
       RowBox[{"VerbatimPlus", "[", "objects__Object", "]"}]}], "]"}], ":=", 
     RowBox[{"Object", "[", "\[IndentingNewLine]", 
      RowBox[{"expr", ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"list", "=", 
           RowBox[{"Transpose", "[", 
            RowBox[{
             RowBox[{"{", "objects", "}"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Plus", ",", 
             RowBox[{"list", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"symListCombine", "[", 
            RowBox[{
             RowBox[{"list", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", "GCD"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Plus", ",", 
             RowBox[{"list", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlusIndices", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"{", "objects", "}"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "3"}], "]"}], "]"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", "expr_VerbatimPlus", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "Print", "[", 
        "\"\<INFO: ToObject acting on a VPlus with not all Objects.\>\"", 
        "]"}], ";", 
       RowBox[{"ToObject", "[", 
        RowBox[{"ToObject", "/@", "expr"}], "]"}]}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Other", " ", "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToObject", "[", "expr_", "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"xSort", "::", "error1"}], ",", 
        "\"\<INFO: ToObject: I don't know what to do with\>\"", ",", "expr"}],
        "]"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7c9a529c-4e0a-4a2f-9939-d0072c6a2f0d"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.4. ObjectOrder", \
"Subsubsection",ExpressionUUID->"9519cf7a-09d3-47a5-bb73-ab3fc7c790d8"],

Cell["\<\
ObjectOrder decides whether two consecutive arguments in a product are sorted \
or not. In principle this operation is independent of the actual product we \
are using, but it is conceivable that we might want to have different \
ordering rules in different products. In any case, this subsection describes \
the default option for ObjectOrder, called AutomaticObjectOrder, which is \
indeed independent of the product. The user can define his/her own ordering \
using the option xSortOrder of DefProduct.

The rules for the AutomaticObjectOrder are:
\t- we first sort the types
\t- then we sort the symorder, having less symmetric objects first
\t- then we sort objects by names
\t- then lengths of all indices, having less indices first
\t- then lengths of free indices (of the whole expression), having more free \
indices first
Note the need to specify the free indices, to avoid for example saying that \
lie[v[a], v[b]] is zero for a lie bracket.

There are two uses of ObjectOrder, and they must treat the indices \
differently. I need to discuss this in more detail.\
\>", "Text",ExpressionUUID->"547aa575-36d8-4841-b830-652e85aa57ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"symnds", "[", 
   RowBox[{"sym_", ",", "nds_"}], "]"}], ":=", 
  RowBox[{"Reverse", "@", 
   RowBox[{"PadLeft", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"{", "sym", "}"}], "]"}], ",", "nds", ",", "1"}], 
    "]"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cd263201-0d57-4f74-a7c8-d7e18502ae87"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Information", " ", "used", " ", "to", " ", "sort", " ", "with", " ", 
    "the", " ", "AutomaticObjectOrder"}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ObjectOrderItems", "[", "False", "]"}], "[", 
      RowBox[{
       RowBox[{"Object", "[", 
        RowBox[{"object_", ",", 
         RowBox[{"{", 
          RowBox[{"type_", ",", "sym_", ",", "name_"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"all_", ",", "free_", ",", "dum_", ",", "bl_", ",", "ms_"}],
           "}"}]}], "]"}], ",", "nds_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"frees", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{"free", ",", "$FreesForSorting"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xSortPrecedence", "[", "name", "]"}], ",", "type", ",", 
         RowBox[{"symnds", "[", 
          RowBox[{"sym", ",", "nds"}], "]"}], ",", 
         RowBox[{"SortingName", "[", "name", "]"}], ",", 
         RowBox[{"Length", "[", "all", "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"Length", "[", "frees", "]"}]}], ",", 
         RowBox[{"mstate", "/@", "ms"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ObjectOrderItems", "[", "True", "]"}], "[", 
      RowBox[{
       RowBox[{"Object", "[", 
        RowBox[{"object_", ",", 
         RowBox[{"{", 
          RowBox[{"type_", ",", "sym_", ",", "name_"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"all_", ",", "free_", ",", "dum_", ",", "bl_", ",", "ms_"}],
           "}"}]}], "]"}], ",", "nds_"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"frees", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{"free", ",", "$FreesForSorting"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xSortPrecedence", "[", "name", "]"}], ",", "type", ",", 
         RowBox[{"symnds", "[", 
          RowBox[{"sym", ",", "nds"}], "]"}], ",", 
         RowBox[{"SortingName", "[", "name", "]"}], ",", 
         RowBox[{"Length", "[", "all", "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"Length", "[", "frees", "]"}]}], ",", 
         RowBox[{"mstate", "/@", "ms"}], ",", "bl", ",", 
         RowBox[{"IndexSort", "[", "free", "]"}]}], "}"}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"31722fcd-9715-49fa-a80d-40c1fa5c0991"],

Cell["\<\
As suggested by Thomas, we introduce a function overwriting precedences if \
needed. By default all expressions have the same precedence:\
\>", "Text",ExpressionUUID->"0482c058-b17f-4c11-95f5-f943fcc6afcc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sort", "[", 
  RowBox[{"{", 
   RowBox[{"10000", ",", 
    RowBox[{"{", 
     RowBox[{"1000", ",", "10"}], "}"}], ",", 
    RowBox[{"{", "1000000", "}"}]}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"d5eafb36-2e81-47c2-b2c5-c0f631fbad51"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"10000", ",", 
   RowBox[{"{", "1000000", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1000", ",", "10"}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"47338aaa-222d-41ee-a89a-a93549671744"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xSortPrecedence", "[", "_", "]"}], ":=", "100"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"xSortPrecedence", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "xSortPrecedence", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6d91d209-8b19-4a34-aa0b-b28e1ae8ea07"],

Cell["\<\
Name for sorting. It must be uniquely defined, and without indices. Ideally, \
this would be an index-free representation of the tensor. There is work to do \
here, improving the name argument of the Objects.\
\>", "Text",ExpressionUUID->"3ca6b4b4-6cf8-4664-a71c-3f6720671aee"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SortingName", "[", "name_List", "]"}], ":=", 
   RowBox[{"name", "/.", 
    RowBox[{
     RowBox[{"MyDer", "[", 
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "_", "]"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"MyDer", "[", "covd", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SortingName", "[", "name_Symbol", "]"}], ":=", "name"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d8ceba1f-05de-400c-a006-952fa9586068"],

Cell["\<\
The function mstate decides the information that must be extracted from the \
metric-state expression of a given index. QUESTION: Why \
didn\[CloseCurlyQuote]t we have this from the very beginning?\
\>", "Text",ExpressionUUID->"56760996-e7e6-4183-aa2b-0f1566634161"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Final", " ", "metric"}], "-", "state"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"mstate", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "vbundle_"}], ",", "__"}], "}"}], "]"}], ":=", 
     "vbundle"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"mstate", "[", 
      RowBox[{"{", 
       RowBox[{"vbundle_", ",", "__"}], "}"}], "]"}], ":=", "vbundle"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"bcd98fd2-796e-4de3-92e8-221c62199349"],

Cell["Main definitions:", \
"Text",ExpressionUUID->"a3ddf5da-b901-4b88-946d-355b74f525d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"AutomaticObjectOrder", "[", "freesQ_", "]"}], "[", 
    RowBox[{"object1_Object", ",", "object2_Object"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nds", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"1", ",", 
         RowBox[{"Length", "[", 
          RowBox[{"object1", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "2"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"Length", "[", 
          RowBox[{"object2", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Order", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ObjectOrderItems", "[", "freesQ", "]"}], "[", 
        RowBox[{"object1", ",", "nds"}], "]"}], ",", 
       RowBox[{
        RowBox[{"ObjectOrderItems", "[", "freesQ", "]"}], "[", 
        RowBox[{"object2", ",", "nds"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c644d1b6-d552-49b0-aa4b-8debc24c3125"],

Cell["\<\
Default choice of ObjectOrder, which is independent of the product. Users can \
define their own ObjectOrder functions using the xSortOrder option of \
DefProduct.\
\>", "Text",ExpressionUUID->"255b66e6-c608-495a-a470-6a2a8151a495"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ObjectOrder", "[", 
    RowBox[{"prod_", ",", "freesQ_"}], "]"}], ":=", 
   RowBox[{"AutomaticObjectOrder", "[", "freesQ", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e4f4ad41-aed5-4b02-a29f-1b81df7df4a6"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.5. ObjectSort", \
"Subsubsection",ExpressionUUID->"7f3f36f9-25eb-4956-bf4c-539f8b118b64"],

Cell["\<\
ObjectSort sorts the Object expressions in a VerbatimProduct[prod][ objects \
], paying much attention to the properties of the product prod. It may add \
CommutingObjects[prod] heads: it will be the head of the result if the \
product has two arguments, and it will be the head of one of the final \
arguments if the product has more than two arguments and is associative. If \
it has more than two arguments and is not associative then commutation adds \
nothing. Think of CircleTimes[ v[a], v[b] ] epsilon[-a, -b] for a \
vector-valued form v. That is CircleTimes[ v[1], v[2] ] - CircleTimes[ v[2], \
v[1] ], which is not zero in general.\
\>", "Text",ExpressionUUID->"bbcb0eaa-3632-4adc-8173-b5973d34b743"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ObjectSort", "[", 
    RowBox[{"expr", ":", 
     RowBox[{
      RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "__Object", 
      "]"}]}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$FreesForSorting", "=", 
       RowBox[{"freeindices", "[", "expr", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"com", "=", 
         RowBox[{"CommutativityOfProduct", "[", "prod", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ProductSplit", "[", "com", "]"}], "[", 
        RowBox[{"ProductSort", "[", 
         RowBox[{"expr", ",", "com"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0ac30730-a7a7-4bff-ae6d-5f8d60d275d0"],

Cell["\<\
Perform the actual sorting, depending on the properties of the product. The \
job is separated in two parts: first ProductSort will put factors in order, \
wrapping the expression with AddedSign, in case a sign has been produced \
during the reordering. Then ProductSplit will detect symmetries and add the \
information, to be used later by SymmetryOf. The next three ObjectOrder \
commands had True before, but I\[CloseCurlyQuote]ve put False now.\
\>", "Text",ExpressionUUID->"b55c1d19-97e1-406b-8063-ed9e9db15717"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"No", " ", 
    RowBox[{"symmetry", ".", " ", "Nothing"}], " ", "to", " ", "do"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ProductSort", "[", 
     RowBox[{
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "__Object", 
        "]"}]}], ",", "None"}], "]"}], ":=", 
    RowBox[{"AddedSign", "[", 
     RowBox[{"1", ",", "expr"}], "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5785d698-23e9-4c7d-a283-5052fc8112f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Commutative", " ", 
    RowBox[{"product", ".", " ", "Move"}], " ", "everything", " ", "freely"}],
    " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ProductSort", "[", 
     RowBox[{
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "__Object", 
        "]"}]}], ",", "\"\<Commutative\>\""}], "]"}], ":=", 
    RowBox[{"AddedSign", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Sort", "[", 
       RowBox[{"expr", ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"ObjectOrder", "[", 
            RowBox[{"prod", ",", "False"}], "]"}], "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "\[GreaterEqual]", "0"}], 
         "&"}]}], "]"}]}], "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"636c1ae0-3942-4d2c-a3f3-d0be408c7221"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Two", " ", "arguments"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ProductSort", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", 
         RowBox[{"x_Object", ",", 
          RowBox[{"y_Object", "_"}]}], "]"}]}], ",", "com_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"order", ",", "sign"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"order", "=", 
           RowBox[{
            RowBox[{"ObjectOrder", "[", 
             RowBox[{"prod", ",", 
              RowBox[{"com", "=!=", "\"\<Commutative\>\""}]}], "]"}], "[", 
            RowBox[{"x", ",", "y"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"order", "===", "1"}]}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{"x", " ", "and", " ", "y", " ", "correctly", " ", 
           RowBox[{"sorted", ".", " ", "Do"}], " ", "nothing"}], " ", "*)"}], 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"AddedSign", "[", 
          RowBox[{"1", ",", "expr"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"sign", "=", 
           RowBox[{
            RowBox[{"CommutativitySign", "[", 
             RowBox[{"prod", ",", "com"}], "]"}], "[", 
            RowBox[{
             RowBox[{"UxSort", "[", "x", "]"}], ",", 
             RowBox[{"UxSort", "[", "y", "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"order", "===", 
           RowBox[{"-", "1"}]}]}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{"x", " ", "and", " ", "y", " ", "incorrectly", " ", 
           RowBox[{"sorted", ".", " ", "Reverse"}], " ", "them", " ", "and", 
           " ", "add", " ", "the", " ", "sign"}], " ", "*)"}], 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"AddedSign", "[", 
          RowBox[{"sign", ",", 
           RowBox[{"Reverse", "[", "expr", "]"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"order", "===", "0"}], "&&", 
          RowBox[{"sign", "===", "1"}]}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"x", " ", "and", " ", "y", " ", "identical"}], ",", " ", 
           RowBox[{"but", " ", "product", " ", "is", " ", 
            RowBox[{"commutative", ".", " ", "Do"}], " ", "nothing"}]}], " ", 
          "*)"}], "\[IndentingNewLine]", "\t", 
         RowBox[{"AddedSign", "[", 
          RowBox[{"1", ",", "expr"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"order", "===", "0"}], "&&", 
          RowBox[{"sign", "===", 
           RowBox[{"-", "1"}]}]}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "x", " ", "and", " ", "y", " ", "identical", " ", "and", " ", 
           "produc", " ", "is", " ", 
           RowBox[{"anticommutative", ".", " ", "Expression"}], " ", "is", 
           " ", "0"}], " ", "*)"}], "\[IndentingNewLine]", "\t", 
         RowBox[{"AddedSign", "[", 
          RowBox[{"0", ",", "expr"}], "]"}]}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Associative", " ", "case"}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"nonzeroQ", "[", "0", "]"}], ":=", "False"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"nonzeroQ", "[", "_", "]"}], ":=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProductSort", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "__Object", 
         "]"}]}], ",", "com_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "uxsort", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"uxsort", "[", "object_", "]"}], ":=", 
         RowBox[{
          RowBox[{"uxsort", "[", "object", "]"}], "=", 
          RowBox[{"UxSort", "@", 
           RowBox[{"First", "[", "object", "]"}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ReplaceRepeated", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddedSign", "[", 
           RowBox[{"1", ",", "expr"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"AddedSign", "[", 
            RowBox[{
             RowBox[{"s_", "?", "nonzeroQ"}], ",", 
             RowBox[{"head_", "[", 
              RowBox[{
              "left___Object", ",", "x_Object", ",", "y_Object", ",", 
               "right___Object"}], "]"}]}], "]"}], "\[RuleDelayed]", 
           RowBox[{"Module", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"order", ",", "sign"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"order", "=", 
               RowBox[{
                RowBox[{"ObjectOrder", "[", 
                 RowBox[{"prod", ",", 
                  RowBox[{"com", "=!=", "\"\<Commutative\>\""}]}], "]"}], "[", 
                RowBox[{"x", ",", "y"}], "]"}]}], ";", "\[IndentingNewLine]", 
              
              RowBox[{"sign", "=", 
               RowBox[{
                RowBox[{"CommutativitySign", "[", 
                 RowBox[{"prod", ",", "com"}], "]"}], "[", 
                RowBox[{
                 RowBox[{"uxsort", "[", "x", "]"}], ",", 
                 RowBox[{"uxsort", "[", "y", "]"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AddedSign", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"order", "===", "0"}], "&&", 
                    RowBox[{"sign", "\[Equal]", 
                    RowBox[{"-", "1"}]}]}], ",", "0", ",", 
                   RowBox[{"s", " ", "sign"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"head", "[", 
                  RowBox[{"left", ",", "y", ",", "x", ",", "right"}], "]"}]}],
                 "\[IndentingNewLine]", "]"}], "/;", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"order", "<", "0"}], "||", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"order", "===", "0"}], "&&", 
                   RowBox[{"sign", "===", 
                    RowBox[{"-", "1"}]}]}], ")"}]}], ")"}]}]}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dfb23cd9-e76e-4c58-89f8-634991477876"],

Cell["\<\
This function introduces the head CommutingObjects[prod]. Note that it is \
actually independent of com, except for the fact that when com==None there is \
nothing to do:\
\>", "Text",ExpressionUUID->"1b5509c6-a87e-41b3-9a05-ea2c90fe3151"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductSplit", "[", "None", "]"}], "[", "expr_", "]"}], ":=", 
   "expr"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductSplit", "[", "com_", "]"}], "[", 
    RowBox[{"AddedSign", "[", 
     RowBox[{"sign_", ",", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", 
        RowBox[{"x_Object", ",", "y_Object"}], "]"}]}]}], "]"}], "]"}], ":=", 
   
   RowBox[{"AddedSign", "[", 
    RowBox[{"sign", ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ObjectOrder", "[", 
          RowBox[{"prod", ",", "False"}], "]"}], "[", 
         RowBox[{"x", ",", "y"}], "]"}], "===", "0"}], ",", 
       RowBox[{
        RowBox[{"CommutingObjects", "[", "prod", "]"}], "[", 
        RowBox[{"x", ",", "y"}], "]"}], ",", "expr"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductSplit", "[", "com_", "]"}], "[", 
    RowBox[{"AddedSign", "[", 
     RowBox[{"sign_", ",", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "__Object", 
        "]"}]}]}], "]"}], "]"}], ":=", 
   RowBox[{"AddedSign", "[", 
    RowBox[{"sign", ",", 
     RowBox[{"ApplyCommutingObjects", "/@", 
      RowBox[{"Split", "[", 
       RowBox[{"expr", ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"ObjectOrder", "[", 
            RowBox[{"prod", ",", "False"}], "]"}], "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "===", "0"}], "&"}]}], "]"}]}]}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ApplyCommutingObjects", "[", 
    RowBox[{
     RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "x_Object", "]"}], 
    "]"}], ":=", "x"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ApplyCommutingObjects", "[", 
    RowBox[{
     RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "x__Object", "]"}], 
    "]"}], ":=", 
   RowBox[{"ToObject", "[", 
    RowBox[{
     RowBox[{"CommutingObjects", "[", "prod", "]"}], "[", "x", "]"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"99a8f94d-2ae4-4649-a21e-8417037fcbe8"],

Cell["\<\
Signs will be placed at intermediate places, and then the products will have \
to extract those signs to more external expressions. Can we avoid that? \
\>", "Text",ExpressionUUID->"8a569a78-119a-4fc2-9c81-b23336ecbf87"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.6. xSort, UxSort", \
"Subsubsection",ExpressionUUID->"9a5e1c35-6894-4b88-9fb1-533f3e3b59a3"],

Cell["\<\
Global driver in charge of sorting tensors in products in a unique way. The \
main idea is that Identify will convert a given elementary expr into an \
Object[expr, info], where info will be used for sorting, and then a product \
prod are replaced by VerbatimProduct[prod], so hide its attributes or any \
other automatic action. It may happen that the product is an argument of some \
other construction, like an inert head or another product. Then we need to \
recurse and convert that product into another Object[prodexpr, info], using \
the function ToObject. It is then when the properties of the combined object \
are computed.\
\>", "Text",ExpressionUUID->"7ff643fc-3307-40f5-bb80-3764b75e3d0e"],

Cell["\<\
xSort inmediately changes to the internal function Identify. It just prepare \
the global options variable $TCOptions for ToCanonicalDir and \
ToCanonicalScalar in Identify. That is, xSort and Identify are essentially \
the same function, except for this little detail.\
\>", "Text",ExpressionUUID->"901df809-af2e-4361-bac2-9a9dd7cb911a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "xSort"}]], "Input",ExpressionUUID->"55e0dfd2-a7fe-4269-93e6-8ab7ef6dba9f"],

Cell[BoxData[
 StyleBox["\<\"xSort[expr] returns a unique sorted form of the expression \
expr\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672908-5338953",ExpressionUUID->"fb044aaa-ca5c-4111-b227-\
855b31dc7945"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xSort", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"$TCOptions", "=", 
       RowBox[{"CheckOptions", "[", "options", "]"}]}], "}"}], ",", 
     RowBox[{"Identify", "[", "expr", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"xSort", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "xSort", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1d88c49a-87dd-47df-b121-036e0ad79919"],

Cell["Inverse function.", \
"Text",ExpressionUUID->"9b5a8613-bcaa-42a1-b06d-e564acd3aee2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UxSort", "[", "expr_", "]"}], ":=", 
   RowBox[{"ReleaseHold", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "expr", "]"}], "//.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Object", "[", 
         RowBox[{"expr1_", ",", "__"}], "]"}], "\[RuleDelayed]", "expr1"}], 
       ",", 
       RowBox[{
        RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "\[RuleDelayed]", 
        "prod"}], ",", 
       RowBox[{
        RowBox[{"CommutingObjects", "[", "prod_", "]"}], "\[RuleDelayed]", 
        "prod"}], ",", 
       RowBox[{"VerbatimPlus", "\[Rule]", "Plus"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UxSort", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "UxSort", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e668a98b-361a-494b-8bc1-225a29746aa2"],

Cell["Format the Object expressions:", \
"Text",ExpressionUUID->"e39f64c9-9e92-408b-8142-59eddf94eb4e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"Object", "[", 
      RowBox[{"expr_", ",", "rest__"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
   RowBox[{"TagBox", "[", 
    RowBox[{
     RowBox[{"TooltipBox", "[", 
      RowBox[{
       RowBox[{"UnderscriptBox", "[", 
        RowBox[{
         RowBox[{"MakeBoxes", "[", 
          RowBox[{"expr", ",", "StandardForm"}], "]"}], ",", "\"\<_\>\""}], 
        "]"}], ",", 
       RowBox[{"MakeBoxes", "[", 
        RowBox[{
         RowBox[{"\"\<Object\>\"", "[", 
          RowBox[{"expr", ",", "rest"}], "]"}], ",", "StandardForm"}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"#", "&"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"VerbatimProduct", "[", "prod_", "]"}], ",", "StandardForm"}], 
    "]"}], ":=", 
   RowBox[{"TagBox", "[", 
    RowBox[{
     RowBox[{"TooltipBox", "[", 
      RowBox[{
       RowBox[{"UnderscriptBox", "[", 
        RowBox[{
         RowBox[{"MakeBoxes", "[", 
          RowBox[{"prod", ",", "StandardForm"}], "]"}], ",", "\"\<_\>\""}], 
        "]"}], ",", 
       RowBox[{"MakeBoxes", "[", 
        RowBox[{
         RowBox[{"\"\<VerbatimProduct\>\"", "[", "prod", "]"}], ",", 
         "StandardForm"}], "]"}]}], "]"}], ",", 
     RowBox[{"#", "&"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"CommutingObjects", "[", "prod_", "]"}], ",", "StandardForm"}], 
    "]"}], ":=", 
   RowBox[{"TagBox", "[", 
    RowBox[{
     RowBox[{"TooltipBox", "[", 
      RowBox[{
       RowBox[{"UnderscriptBox", "[", 
        RowBox[{
         RowBox[{"MakeBoxes", "[", 
          RowBox[{"prod", ",", "StandardForm"}], "]"}], ",", "\"\<_\>\""}], 
        "]"}], ",", 
       RowBox[{"MakeBoxes", "[", 
        RowBox[{
         RowBox[{"\"\<CommutingObjects\>\"", "[", "prod", "]"}], ",", 
         "StandardForm"}], "]"}]}], "]"}], ",", 
     RowBox[{"#", "&"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"VerbatimPlus", "[", "exprs___", "]"}], ",", "StandardForm"}], 
    "]"}], ":=", 
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"\"\<VerbatimPlus\>\"", "[", "exprs", "]"}], ",", 
     "StandardForm"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"MyDer", "[", "der_", "]"}], ",", "StandardForm"}], "]"}], ":=", 
   
   RowBox[{"MakeBoxes", "[", 
    RowBox[{
     RowBox[{"\"\<MyDer\>\"", "[", "der", "]"}], ",", "StandardForm"}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ac85813f-0b7b-411c-a3b9-675906f5054f"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.1.7. Examples", \
"Subsubsection",ExpressionUUID->"f43b047a-4888-4a29-9e02-ea4e18ce33e0"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5387efed-c415-433f-83c4-334e053748c7"],

Cell["We need this definition for the examples:", \
"Text",ExpressionUUID->"10baec39-1f62-47a0-8702-6672c5dd5402"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xTensor`Private`ToCanonicalTensorHead", "[", "head_", "]"}], 
   ":=", "head"}], 
  ";"}]], "Input",ExpressionUUID->"6dfc444f-fbd4-4127-b97f-ad337c288d11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"4eb0b38c-8147-4f1c-96ed-1aeb7f8c6b3d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c3538c8a-92ac-48e6-998b-b9efaf9e60ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8729d729-0e9f-4360-a382-672f3606da96"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e4ecf5f5-ef22-4be4-85dd-14fda6329241"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c4a498c7-a913-4b05-a3f2-8ba697eb3e85"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"be1432da-11b0-46ba-be3d-59fbe9097180"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"35a9e84e-6359-41e2-bbc9-1ccf5ac7a13b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d2e1d589-1a20-4ea5-8900-f35433861f31"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"79c4c528-54ca-48f5-b7cb-a7539adcca2c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", "5", 
  "]"}]], "Input",ExpressionUUID->"16a3d102-609c-4aa8-8e14-71854a1787d4"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox["5", "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{"5", ",", 
       RowBox[{"{", 
         RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"f8235f49-5f65-4a14-b544-62a6b7440eb5"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`VBundleOfBasis", "[", "Polar", "]"}], "^=", 
   "TangentM2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`VBundleOfBasis", "[", 
    RowBox[{"-", "x_"}], "]"}], "=", 
   RowBox[{"xAct`xCoba`VBundleOfBasis", "[", "x", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "Polar", "]"}], "^=", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$CovDFormat", "=", "\"\<Postfix\>\""}], 
  ";"}]}], "Input",ExpressionUUID->"81786cac-3afe-4038-b869-cf935d1d277b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", "B", ",", "C", ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"4f11dc30-d1a2-4e0c-bec2-a79aff95949c"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "B", "C", " ", 
             StyleBox["1",
              FontColor->RGBColor[0., 0., 1.]], " "},
            {" ", " ", " ", "B", " ", 
             StyleBox["1",
              FontColor->RGBColor[0., 0., 1.]]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`B, C, -$CellContext`B, {
      1, $CellContext`Polar}, {1, -$CellContext`Polar}],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{"T", 
            StyleBox[
             
             GridBox[{{
               "A", "B", "C", " ", 
                "\!\(\*StyleBox[\"1\",FontColor->RGBColor[0., 0., 1.]]\)", 
                " "}, {
               " ", " ", " ", "B", " ", 
                "\!\(\*StyleBox[\"1\",FontColor->RGBColor[0., 0., 1.]]\)"}}, 
              RowSpacings -> 0, ColumnSpacings -> 0.05, 
              GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
             Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
          Center], AutoSpacing -> False, ShowAutoStyles -> False], 
        $CellContext`T[$CellContext`A, $CellContext`B, C, -$CellContext`B, {
         1, $CellContext`Polar}, {1, -$CellContext`Polar}], Editable -> 
        False], ",", 
       RowBox[{"{", 
         RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{"1", ",", "Polar"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{"1", ",", 
                   RowBox[{"-", "Polar"}]}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, 
             C, -$CellContext`B, {1, $CellContext`Polar}, {
             1, -$CellContext`Polar}], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, C], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", "B", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{"1", ",", 
                   RowBox[{"-", "Polar"}]}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{"1", ",", "Polar"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{1, -$CellContext`Polar}, {
             1, $CellContext`Polar}], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}, {$CellContext`TangentM2, 
              Null}, {-$CellContext`TangentM2, Null}, {$CellContext`TangentM2,
               Null}, {-$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"072f5bba-2b3e-400b-bbd5-634676112154"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "C"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"a3b02fac-d5e4-4315-814f-37a3a676a131"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "C", "  "},
            {" ", " ", 
             RowBox[{";", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`A][
      $CellContext`T[$CellContext`B, C]],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{"T", 
            StyleBox[
             
             GridBox[{{"B", "C", "  "}, {" ", " ", ";A"}}, RowSpacings -> 0, 
              ColumnSpacings -> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], 
             FontSize -> Rational[39, 4]]}}, ColumnSpacings -> 0.05, 
          RowAlignments -> Center], AutoSpacing -> False, ShowAutoStyles -> 
         False], 
        $CellContext`CD[-$CellContext`A][
         $CellContext`T[$CellContext`B, C]], Editable -> False], ",", 
       RowBox[{"{", 
         RowBox[{"Tensor", ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"CD", ",", "T", ",", 
               RowBox[{"\"MyDer\"", "[", 
                 RowBox[{"CD", "[", 
                   RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "C", "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`B, C, -$CellContext`A], 
            Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "C", "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`B, C, -$CellContext`A], 
            Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}, {-$CellContext`TangentM2,
               Null}], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"ceb29f40-5245-455d-8916-468880f61342"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "A"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e301f5ef-784f-4021-abe5-b629565598ea"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "A", "  "},
            {" ", " ", 
             RowBox[{";", "A"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`A][
      $CellContext`T[$CellContext`B, $CellContext`A]],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{"T", 
            StyleBox[
             
             GridBox[{{"B", "A", "  "}, {" ", " ", ";A"}}, RowSpacings -> 0, 
              ColumnSpacings -> 0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], 
             FontSize -> Rational[39, 4]]}}, ColumnSpacings -> 0.05, 
          RowAlignments -> Center], AutoSpacing -> False, ShowAutoStyles -> 
         False], 
        $CellContext`CD[-$CellContext`A][
         $CellContext`T[$CellContext`B, $CellContext`A]], Editable -> False], 
       ",", 
       RowBox[{"{", 
         RowBox[{"Tensor", ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"CD", ",", "T", ",", 
               RowBox[{"\"MyDer\"", "[", 
                 RowBox[{"CD", "[", 
                   RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "A", "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`B, $CellContext`A, \
-$CellContext`A], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`B], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}, {-$CellContext`TangentM2,
               Null}], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"39cb1ab8-47ea-4b0b-a089-21533481eb3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "B"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7ff4afd8-2f8f-4b5e-b120-8106a91e54b8"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "A", "  ", "  "},
            {" ", " ", 
             RowBox[{";", "A"}], 
             RowBox[{";", "B"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[-$CellContext`B][
      $CellContext`CD[-$CellContext`A][
       $CellContext`T[$CellContext`B, $CellContext`A]]],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{"T", 
            StyleBox[
             
             GridBox[{{"B", "A", "  ", "  "}, {" ", " ", ";A", ";B"}}, 
              RowSpacings -> 0, ColumnSpacings -> 0.05, 
              GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
             Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
          Center], AutoSpacing -> False, ShowAutoStyles -> False], 
        $CellContext`CD[-$CellContext`B][
         $CellContext`CD[-$CellContext`A][
          $CellContext`T[$CellContext`B, $CellContext`A]]], Editable -> 
        False], ",", 
       RowBox[{"{", 
         RowBox[{"Tensor", ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"CD", ",", 
               RowBox[{"{", 
                 RowBox[{"CD", ",", "T", ",", 
                   RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"\"MyDer\"", "[", 
                 RowBox[{"CD", "[", 
                   RowBox[{"-", "B"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "A", "\",\"", 
               RowBox[{"-", "A"}], "\",\"", 
               RowBox[{"-", "B"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`B, $CellContext`A, \
-$CellContext`A, -$CellContext`B], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               RowBox[{"-", "A"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "B"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A, \
$CellContext`B, -$CellContext`B], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}, {-$CellContext`TangentM2,
               Null}, {-$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"587f3778-5025-4994-b548-3640c10a1fe5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "Polar"}]}], "}"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "A"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"b9f2b371-4cd3-427f-9365-d2f68f9472a6"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B", "A", "  "},
            {" ", " ", 
             RowBox[{";", 
              StyleBox["D",
               FontColor->RGBColor[0., 0., 1.]]}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CD[{-D, -$CellContext`Polar}][
      $CellContext`T[$CellContext`B, $CellContext`A]],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{"T", 
            StyleBox[
             
             GridBox[{{"B", "A", "  "}, {
               " ", " ", 
                ";\!\(\*StyleBox[\"D\",FontColor->RGBColor[0., 0., 1.]]\)"}}, 
              RowSpacings -> 0, ColumnSpacings -> 0.05, 
              GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
             Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
          Center], AutoSpacing -> False, ShowAutoStyles -> False], 
        $CellContext`CD[{-D, -$CellContext`Polar}][
         $CellContext`T[$CellContext`B, $CellContext`A]], Editable -> False], 
       ",", 
       RowBox[{"{", 
         RowBox[{"Tensor", ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"CD", ",", "T", ",", 
               RowBox[{"\"MyDer\"", "[", 
                 RowBox[{"CD", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "D"}], ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], "]"}], "]"}]}], "}"}]}], 
         "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "A", "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "D"}], ",", 
                   RowBox[{"-", "Polar"}]}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`B, $CellContext`A, {-
              D, -$CellContext`Polar}], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "D"}], ",", 
                   RowBox[{"-", "Polar"}]}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, {-
              D, -$CellContext`Polar}], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}, {-$CellContext`TangentM2,
               Null}], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"691cfac5-240a-43c9-a4a4-5d6b2739575f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{"-", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "Polar"}]}], "}"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b614890f-23bf-4f00-baf6-5b6b3f3a3d86"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{"-", "1"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"{", 
              RowBox[{"Constant", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"B", "A", "  "},
                 {" ", " ", 
                  RowBox[{";", 
                   StyleBox["1",
                    FontColor->RGBColor[0., 0., 1.]]}]}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CD[{1, -$CellContext`Polar}][
           $CellContext`T[$CellContext`B, $CellContext`A]],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"B", "A", "  "}, {
                    " ", " ", 
                    ";\!\(\*StyleBox[\"1\",FontColor->RGBColor[0., 0., \
1.]]\)"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`CD[{1, -$CellContext`Polar}][
              $CellContext`T[$CellContext`B, $CellContext`A]], Editable -> 
             False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], "]"}], "]"}]}], "}"}]}], 
              "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "A", "\",\"", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[$CellContext`B, $CellContext`A, {
                  1, -$CellContext`Polar}], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{1, -$CellContext`Polar}], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{"-", "1"}], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{"-", "1"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"B", "A", "  "}, {
                    " ", " ", 
                    ";\!\(\*StyleBox[\"1\",FontColor->RGBColor[0., 0., \
1.]]\)"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`CD[{1, -$CellContext`Polar}][
                $CellContext`T[$CellContext`B, $CellContext`A]], Editable -> 
               False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"B", "A", "  "}, {
                    " ", " ", 
                    ";\!\(\*StyleBox[\"1\",FontColor->RGBColor[0., 0., \
1.]]\)"}}, RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`CD[{1, -$CellContext`Polar}][
                   $CellContext`T[$CellContext`B, $CellContext`A]], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], "]"}], "]"}]}], "}"}]}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "A", "\",\"", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[$CellContext`B, $CellContext`A, {
                    1, -$CellContext`Polar}], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{1, -$CellContext`Polar}], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Constant", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "Polar"}]}], "}"}], "]"}], "]"}]}], "}"}]}], 
                 "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "A", "\",\"", 
               RowBox[{"{", 
                 RowBox[{"1", ",", 
                   RowBox[{"-", "Polar"}]}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`B, $CellContext`A, {
             1, -$CellContext`Polar}], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{"1", ",", 
                   RowBox[{"-", "Polar"}]}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[{1, -$CellContext`Polar}], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"eedc3b5a-2969-484e-8020-5d467ba5421b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{
   RowBox[{"Bracket", "[", 
    RowBox[{
     RowBox[{"T", "[", "B", "]"}], ",", 
     RowBox[{"T", "[", "C", "]"}]}], "]"}], "[", "A", "]"}], 
  "]"}]], "Input",ExpressionUUID->"9042bd8a-2304-494e-97dd-50ebaed4bab7"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"[", 
          RowBox[{"T", "[", "B", "]"}], ",", 
          RowBox[{"T", "[", "C", "]"}], "]"}], 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Bracket[
      xAct`xTensor`Private`T[$CellContext`B], 
      xAct`xTensor`Private`T[C]][$CellContext`A],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{
            RowBox[{"[", 
              RowBox[{"T", "[", "B", "]"}], ",", 
              RowBox[{"T", "[", "C", "]"}], "]"}], 
            StyleBox[
             
             GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 0.05,
               GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
             Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
          Center], AutoSpacing -> False, ShowAutoStyles -> False], 
        xAct`xTensor`Bracket[
         xAct`xTensor`Private`T[$CellContext`B], 
         xAct`xTensor`Private`T[C]][$CellContext`A], Editable -> False], ",", 
       
       RowBox[{"{", 
         RowBox[{"Tensor", ",", "1", ",", 
           RowBox[{"Bracket", "[", 
             RowBox[{
               RowBox[{"T", "[", "B", "]"}], ",", 
               RowBox[{"T", "[", "C", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], Editable -> 
            False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"d82eb4ac-a6f7-43a2-b901-4f2ae694fd88"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"fc3d7487-70aa-4feb-8768-b8855b0b7ec3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Mass", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Mass, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"30cd2040-968b-43d9-8855-eb309d53c615"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{
   RowBox[{"Mass", "^", "2"}], "+", 
   RowBox[{"4", "Mass"}], "+", "5"}], 
  "]"}]], "Input",ExpressionUUID->"bde4d74e-88aa-4fe6-89af-b7e3ca81e06a"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{"\<\"VerbatimPlus\"\>", "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox["5", "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{"5", ",", 
            RowBox[{"{", 
              RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox["4", "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{"4", ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`Mass, Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox["4", "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                  "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                  "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Mass",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False], "2"], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox[
               RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
               False], $CellContext`Mass, Editable -> False], "2"], ",", 
            RowBox[{"{", 
              RowBox[{"ConstantSymbol", ",", "1", ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                   "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{"\"VerbatimPlus\"", "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox["5", "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{"5", ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                   ")"}], "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                    "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                    "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                 RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                 False], $CellContext`Mass, Editable -> False], "2"], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                 
                 RowBox[{"{", 
                   RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{"Constant", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                    "}"}], ",", "ConstantSymbol"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{"5", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                    "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"6293bcb3-5983-443a-82e6-c9c18b78cb4d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{"1", "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Mass", "^", "2"}], "+", 
     RowBox[{"4", "Mass"}], "+", "5"}], ")"}]}], 
  "]"}]], "Input",ExpressionUUID->"1ea23c7f-b243-4b87-87b2-263a0019498e"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    FractionBox["1", 
     RowBox[{"\<\"VerbatimPlus\"\>", "[", 
      RowBox[{
       TagBox[
        TooltipBox[
         UnderscriptBox["5", "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{"5", ",", 
             RowBox[{"{", 
               RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["4", "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{"4", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               InterpretationBox[
                StyleBox["Mass",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                  RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["4", "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                   "}"}], ",", 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                   "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Mass",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], "2"], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox[
                RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                False], $CellContext`Mass, Editable -> False], "2"], ",", 
             RowBox[{"{", 
               RowBox[{"ConstantSymbol", ",", "1", ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                    "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ]}], "]"}]], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       FractionBox["1", 
        RowBox[{"\"VerbatimPlus\"", "[", 
          RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["5", "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{"5", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                    "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                    "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox[
                  RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`Mass, Editable -> False], "2"], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ]}], "]"}]], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{"Constant", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                    "}"}], ",", "ConstantSymbol"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                StyleBox[
                 RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                 False], Power, Editable -> False], ",", 
               RowBox[{"{", 
                 RowBox[{"Plus", ",", 
                   RowBox[{"{", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"37fbca27-860a-4e3e-ba79-78adf9599057"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{"1", "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Mass", "^", "2"}], "+", 
     RowBox[{"4", "Mass"}], "+", 
     RowBox[{"5", 
      RowBox[{"T", "[", "A", "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}]}], ")"}]}], 
  "]"}]], "Input",ExpressionUUID->"67bfaee9-3b39-44d5-b812-c2c3e5e82d0b"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    FractionBox["1", 
     RowBox[{"\<\"VerbatimPlus\"\>", "[", 
      RowBox[{
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["4", "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{"4", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               InterpretationBox[
                StyleBox["Mass",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                  RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["4", "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                   "}"}], ",", 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                   "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Mass",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], "2"], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox[
                RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                False], $CellContext`Mass, Editable -> False], "2"], ",", 
             RowBox[{"{", 
               RowBox[{"ConstantSymbol", ",", "1", ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                    "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["5", "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{"5", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  StyleBox["(",
                   FontColor->RGBColor[1, 0, 0]], 
                  RowBox[{
                   InterpretationBox[
                    StyleBox[GridBox[{
                    {"T", 
                    StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                    },
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T[-$CellContext`A],
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox[GridBox[{
                    {"T", 
                    StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                    },
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T[$CellContext`A],
                    Editable->False]}], 
                  StyleBox[")",
                   FontColor->RGBColor[1, 0, 0]]}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                
                xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]],
                Editable->False], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                  RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["5", "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Scalar"}], "}"}]}], "}"}], ",", 
                 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}]}], "}"}]}], 
               "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ]}], "]"}]], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       FractionBox["1", 
        RowBox[{"\"VerbatimPlus\"", "[", 
          RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                    "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                    "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox[
                  RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`Mass, Editable -> False], "2"], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["5", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["5", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Scalar"}], "}"}]}], "}"}], ",", 
                    
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}]}], "}"}]}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ]}], "]"}]], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "ConstantSymbol"}], "}"}]}], 
                    "}"}], ",", "ConstantSymbol", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Scalar"}], "}"}]}], "}"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                StyleBox[
                 RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                 False], Power, Editable -> False], ",", 
               RowBox[{"{", 
                 RowBox[{"Plus", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}]}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}]}], "}"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"67014f19-fef3-476c-bc83-08e8c6b3ee87"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`Identify", "[", 
  RowBox[{"1", "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Mass", "^", "2"}], "+", 
     RowBox[{"4", 
      RowBox[{"(", 
       RowBox[{"Mass", "+", 
        RowBox[{"Mass", "^", "2"}]}], ")"}]}], "+", 
     RowBox[{"5", 
      RowBox[{"T", "[", "A", "]"}], 
      RowBox[{"T", "[", 
       RowBox[{"-", "A"}], "]"}]}]}], ")"}]}], 
  "]"}]], "Input",ExpressionUUID->"6c321b98-3b07-4bc3-b993-36b2114d3e4c"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    FractionBox["1", 
     RowBox[{"\<\"VerbatimPlus\"\>", "[", 
      RowBox[{
       TagBox[
        TooltipBox[
         UnderscriptBox[
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Mass",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], "2"], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox[
                RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                False], $CellContext`Mass, Editable -> False], "2"], ",", 
             RowBox[{"{", 
               RowBox[{"ConstantSymbol", ",", "1", ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                    "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["4", "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{"4", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{"\<\"VerbatimPlus\"\>", "[", 
                RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox["Mass",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], "_"],
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]],
                  #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Mass",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], "2"], "_"],
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]],
                  #& ]}], "]"}], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["4", "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
             
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["5", "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{"5", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  StyleBox["(",
                   FontColor->RGBColor[1, 0, 0]], 
                  RowBox[{
                   InterpretationBox[
                    StyleBox[GridBox[{
                    {"T", 
                    StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                    },
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T[-$CellContext`A],
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox[GridBox[{
                    {"T", 
                    StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                    },
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T[$CellContext`A],
                    Editable->False]}], 
                  StyleBox[")",
                   FontColor->RGBColor[1, 0, 0]]}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                
                xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]],
                Editable->False], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                  RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["5", "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Scalar"}], "}"}]}], "}"}], ",", 
                 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}]}], "}"}]}], 
               "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ]}], "]"}]], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       FractionBox["1", 
        RowBox[{"\"VerbatimPlus\"", "[", 
          RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox[
                  RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`Mass, Editable -> False], "2"], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["4", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{"\"VerbatimPlus\"", "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "2"], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                  
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["5", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["5", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "5"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Scalar", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Scalar"}], "}"}]}], "}"}], ",", 
                    
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}]}], "}"}]}], 
                    "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ]}], "]"}]], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{"ConstantSymbol", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "ConstantSymbol"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Scalar"}], "}"}]}], "}"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                StyleBox[
                 RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                 False], Power, Editable -> False], ",", 
               RowBox[{"{", 
                 RowBox[{"Plus", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", 
                    RowBox[{"{", 
                    RowBox[{"Plus", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "2"}],
                     "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"5", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["(", FontColor -> RGBColor[1, 0, 0]], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A], Editable -> False], " ", 
                    
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A], Editable -> False]}], 
                    StyleBox[")", FontColor -> RGBColor[1, 0, 0]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`Scalar[$CellContext`T[-$CellContext`A] \
$CellContext`T[$CellContext`A]], Editable -> False]}], "}"}]}], "}"}]}], 
                    "}"}]}], "}"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"f5695735-b437-4fb5-a31b-0bfba284f046"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"UndefConstantSymbol", "[", "Mass", "]"}], "\[IndentingNewLine]", 
 RowBox[{"UndefTensor", "[", "T", "]"}], "\[IndentingNewLine]", 
 RowBox[{"UndefCovD", "[", "CD", 
  "]"}]}], "Input",ExpressionUUID->"05c3f644-64b9-4a62-b812-886cd08859d0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Mass",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Mass],
  Editable->
   False]], "Print",ExpressionUUID->"a3662ca7-72bb-4fad-9cb0-df5d29071b2b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"dd3fcba8-69a2-4a47-93e6-8998f1e4cf08"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"ed21434f-f4ad-4333-8f99-ef2e8b46c1dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"5d691061-4efb-4e83-9302-3252744317e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"3823bc25-7df8-4733-ac8a-daee84c864fd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"211c1c79-a325-45cb-9265-e842aac2a95c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"132f5757-d19e-4486-8f19-075fe896871d"]
}, Open  ]]
}, Open  ]],

Cell["More examples:", \
"Text",ExpressionUUID->"7799f13a-5a4a-402a-9cd0-59b7703c2742"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}]}], "Input",ExpressionUUID->"dbfafa60-47f8-4fb8-8efe-9c3eeec8c0ee"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bd4624eb-f878-42b8-b2d7-28e42da28cc7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"12fccb65-6cab-4ef0-9342-96c9723d5e1d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"51531168-c9b0-4bb2-acc1-bd40c9e10ee7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Mass", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Mass, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2512d8f8-7335-4f0f-8c8f-ed8f9a8f1418"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", "1", 
  "]"}]], "Input",ExpressionUUID->"8651c630-86a7-4c63-b79c-bdbed7e3acfc"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox["1", "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{"1", ",", 
       RowBox[{"{", 
         RowBox[{"Constant", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"4108f106-2d77-478d-a7eb-c08988451550"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{"v", "[", "A", "]"}], 
  "]"}]], "Input",ExpressionUUID->"44c3f4e3-6d12-4f43-ac00-0e5e2f944fcd"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[$CellContext`A],
     Editable->False], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       InterpretationBox[
        StyleBox[
         GridBox[{{"v", 
            StyleBox[
             
             GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 0.05,
               GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
             Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
          Center], AutoSpacing -> False, ShowAutoStyles -> False], 
        $CellContext`v[$CellContext`A], Editable -> False], ",", 
       RowBox[{"{", 
         RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], Editable -> 
            False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"ab2f398b-a3a3-4cde-8268-f786418aa824"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{"1", "+", 
   RowBox[{
    RowBox[{"v", "[", "A", "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"74f0a30a-da5b-4fe6-acc2-cc039872ed31"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{"\<\"VerbatimPlus\"\>", "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox["1", "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{"1", ",", 
            RowBox[{"{", 
              RowBox[{"Constant", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          TagBox[
           TooltipBox[
            UnderscriptBox[
             RowBox[{
              RowBox[{"(", 
               TagBox[
                TooltipBox[
                 UnderscriptBox["Times", "_"],
                 RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
                #& ], ")"}], "[", 
              RowBox[{
               TagBox[
                TooltipBox[
                 UnderscriptBox[
                  InterpretationBox[
                   StyleBox[GridBox[{
                    {"v", 
                    StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                    },
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`v[-$CellContext`A],
                   Editable->False], "_"],
                 RowBox[{"\"Object\"", "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
                #& ], ",", 
               TagBox[
                TooltipBox[
                 UnderscriptBox[
                  InterpretationBox[
                   StyleBox[GridBox[{
                    {"v", 
                    StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                    },
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`v[$CellContext`A],
                   Editable->False], "_"],
                 RowBox[{"\"Object\"", "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
                #& ]}], "]"}], "_"],
            RowBox[{"\"Object\"", "[", 
              RowBox[{
                RowBox[{
                  RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                   "[", 
                  RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]],
           #& ], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              TagBox[
               TooltipBox[
                UnderscriptBox[
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
                 "_"], 
                RowBox[{"\"Object\"", "[", 
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                     "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], 
                    "}"}]}], "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}], "}"}]}], "}"}]}],
               "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{"\"VerbatimPlus\"", "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox["1", "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{"1", ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "1", ",", "1"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                   ")"}], "[", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                     "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
                   "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{"\"CommutingObjects\"", "[", "Times", 
                    "]"}]], #& ], ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], "]"}], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{"\"CommutingObjects\"", "[", "Times", 
                    "]"}]], #& ], ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
                    "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{"\"CommutingObjects\"", "[", "Times", 
                    "]"}]], #& ], ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"A"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`A], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}], "}"}]}], "}"}]}],
                    "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{"Constant", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{"1", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}], "}"}]}], "}"}]}],
                  "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"521b51a7-a78d-4d15-99ab-0ee510c4ddb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "B"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"980ae8b7-5b3b-4a88-8c8b-b7151dd4232d"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"v", 
                   StyleBox[GridBox[{
                    {" "},
                    {"B"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v[-$CellContext`B],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`v[-$CellContext`B], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"v", 
                   StyleBox[GridBox[{
                    {" "},
                    {"C"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v[-C],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`v[-C], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`B], Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`B], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-C], Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-C], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                 Editable -> False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"A", "B", "C"},
                 {" ", " ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`A, $CellContext`B, C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
             False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                 "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`B], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`B], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-C], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-C], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`B], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-$CellContext`B], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-C], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"C"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[-C], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
               False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                   "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "6", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}], ",", "T"}], 
                 "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "A", "\",\"", "B", "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`B, -
             C, $CellContext`A, $CellContext`B, C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -C, C], 
            Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"1d0b8469-cda3-40b8-a88e-c3e891cef80e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"D", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"2af92c08-2c41-4fda-91ce-981ee704a329"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     TagBox[
      TooltipBox[
       UnderscriptBox[
        RowBox[{
         RowBox[{"(", 
          TagBox[
           TooltipBox[
            UnderscriptBox["Times", "_"],
            RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
           #& ], ")"}], "[", 
         RowBox[{
          TagBox[
           TooltipBox[
            UnderscriptBox[
             InterpretationBox[
              StyleBox[GridBox[{
                 {"T", 
                  StyleBox[GridBox[{
                    {"A", "B", "C"},
                    {" ", " ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T[$CellContext`A, $CellContext`B, C],
              Editable->False], "_"],
            RowBox[{"\"Object\"", "[", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                 False], ",", 
                RowBox[{"{", 
                  RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]],
           #& ], ",", 
          TagBox[
           TooltipBox[
            UnderscriptBox[
             InterpretationBox[
              StyleBox[GridBox[{
                 {"T", 
                  StyleBox[GridBox[{
                    {"D", " ", " "},
                    {" ", "B", "C"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T[D, -$CellContext`B, -C],
              Editable->False], "_"],
            RowBox[{"\"Object\"", "[", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[D, -$CellContext`B, -C], Editable -> False], 
                ",", 
                RowBox[{"{", 
                  RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]],
           #& ]}], "]"}], "_"],
       RowBox[{"\"Object\"", "[", 
         RowBox[{
           RowBox[{
             RowBox[{"(", 
               TagBox[
                TooltipBox[
                 UnderscriptBox["Times", "_"], 
                 RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
               ")"}], "[", 
             RowBox[{
               TagBox[
                TooltipBox[
                 UnderscriptBox[
                  InterpretationBox[
                   StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`T[$CellContext`A, $CellContext`B, C], 
                   Editable -> False], "_"], 
                 RowBox[{"\"Object\"", "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
               TagBox[
                TooltipBox[
                 UnderscriptBox[
                  InterpretationBox[
                   StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`T[D, -$CellContext`B, -C], Editable -> False],
                   "_"], 
                 RowBox[{"\"Object\"", "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"Times", ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", "36", "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"Times", ",", 
                   RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                   "\",\"", "B", "\",\"", "C", "\",\"", "D", "\",\"", 
                   RowBox[{"-", "B"}], "\",\"", 
                   RowBox[{"-", "C"}], 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                
                xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
                 D, -$CellContext`B, -C], Editable -> False], ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                   "\",\"", "D", 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                xAct`xTensor`IndexList[$CellContext`A, D], Editable -> False],
                ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                   RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
                   RowBox[{"-", "C"}], "\",\"", "C", 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                
                xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -C, 
                 C], Editable -> False], ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                xAct`xTensor`IndexList[], Editable -> False], ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                
                xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                  Null}, {$CellContext`TangentM2, Null}], Editable -> 
                False]}], "}"}]}], "]"}]],
      #& ], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         TagBox[
          TooltipBox[
           UnderscriptBox[
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], "_"], 
           RowBox[{"\"Object\"", "[", 
             RowBox[{
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                  "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                   RowBox[{"{", "36", "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", "\",\"", "D", "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
                    D, -$CellContext`B, -C], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, D], Editable -> 
                    False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -
                    C, C], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", "36", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}], "}"}]}], "}"}]}],
          "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", "D", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
             D, -$CellContext`B, -C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "D", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, D], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -C, C], 
            Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"4adb2932-0c4c-4a47-88ee-42c97760b668"]
}, Open  ]],

Cell["Note the influence of the presence of a metric:", \
"Text",ExpressionUUID->"d25175a0-b375-4e62-9e12-3f8ef9519368"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "metricg", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"abfc3b4f-79b0-4d6b-b5b4-cae69647287e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"D", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6b74bbb5-5a1c-40a0-8d6f-5de4dbe1a3d1"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     TagBox[
      TooltipBox[
       UnderscriptBox[
        RowBox[{
         RowBox[{"(", 
          TagBox[
           TooltipBox[
            UnderscriptBox["Times", "_"],
            RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
           #& ], ")"}], "[", 
         RowBox[{
          TagBox[
           TooltipBox[
            UnderscriptBox[
             InterpretationBox[
              StyleBox[GridBox[{
                 {"T", 
                  StyleBox[GridBox[{
                    {"A", "B", "C"},
                    {" ", " ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T[$CellContext`A, $CellContext`B, C],
              Editable->False], "_"],
            RowBox[{"\"Object\"", "[", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                 False], ",", 
                RowBox[{"{", 
                  RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                  "}"}]}], "]"}]],
           #& ], ",", 
          TagBox[
           TooltipBox[
            UnderscriptBox[
             InterpretationBox[
              StyleBox[GridBox[{
                 {"T", 
                  StyleBox[GridBox[{
                    {"D", " ", " "},
                    {" ", "B", "C"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T[D, -$CellContext`B, -C],
              Editable->False], "_"],
            RowBox[{"\"Object\"", "[", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[D, -$CellContext`B, -C], Editable -> False], 
                ",", 
                RowBox[{"{", 
                  RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}, \
{-$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                  "}"}]}], "]"}]],
           #& ]}], "]"}], "_"],
       RowBox[{"\"Object\"", "[", 
         RowBox[{
           RowBox[{
             RowBox[{"(", 
               TagBox[
                TooltipBox[
                 UnderscriptBox["Times", "_"], 
                 RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
               ")"}], "[", 
             RowBox[{
               TagBox[
                TooltipBox[
                 UnderscriptBox[
                  InterpretationBox[
                   StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`T[$CellContext`A, $CellContext`B, C], 
                   Editable -> False], "_"], 
                 RowBox[{"\"Object\"", "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                    "}"}]}], "]"}]], #& ], ",", 
               TagBox[
                TooltipBox[
                 UnderscriptBox[
                  InterpretationBox[
                   StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`T[D, -$CellContext`B, -C], Editable -> False],
                   "_"], 
                 RowBox[{"\"Object\"", "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}, \
{-$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                    "}"}]}], "]"}]], #& ]}], "]"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"Times", ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
               RowBox[{"{", "36", "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"Times", ",", 
                   RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                   "\",\"", "B", "\",\"", "C", "\",\"", "D", "\",\"", 
                   RowBox[{"-", "B"}], "\",\"", 
                   RowBox[{"-", "C"}], 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                
                xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
                 D, -$CellContext`B, -C], Editable -> False], ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                   "\",\"", "D", 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                xAct`xTensor`IndexList[$CellContext`A, D], Editable -> False],
                ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                   RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
                   RowBox[{"-", "C"}], "\",\"", "C", 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                
                xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -C, 
                 C], Editable -> False], ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                xAct`xTensor`IndexList[], Editable -> False], ",", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                   StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                   StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                 AutoSpacing -> False, ShowAutoStyles -> False], 
                
                xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                Editable -> False]}], "}"}]}], "]"}]],
      #& ], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         TagBox[
          TooltipBox[
           UnderscriptBox[
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                    "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}, \
{-$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                    "}"}]}], "]"}]], #& ]}], "]"}], "_"], 
           RowBox[{"\"Object\"", "[", 
             RowBox[{
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                  "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B, C], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                    "}"}]}], "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}, \
{-$CellContext`TangentM2, $CellContext`metricg}], Editable -> False]}], 
                    "}"}]}], "]"}]], #& ]}], "]"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                   RowBox[{"{", "36", "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", "\",\"", "D", "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
                    D, -$CellContext`B, -C], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, D], Editable -> 
                    False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -
                    C, C], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", "36", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}], "}"}]}], "}"}]}],
          "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", "D", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
             D, -$CellContext`B, -C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "D", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, D], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -C, C], 
            Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
            Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"bf8d3000-4568-4ab1-9bdc-de76705acc2f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"9279bca0-fa42-4b81-98c9-9d98e1ef19fa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{"7", "Mass", " ", 
   RowBox[{"v", "[", "A", "]"}], 
   RowBox[{"v", "[", "B", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"36230d32-e391-4217-aa95-e0be8e840ceb"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox["7", "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{"7", ",", 
            RowBox[{"{", 
              RowBox[{"Constant", ",", "1", ",", "7"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox["Mass",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Mass,
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
              False], $CellContext`Mass, Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"ConstantSymbol", ",", "1", ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`Mass, Editable -> False]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"v", 
                   StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v[$CellContext`A],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`v[$CellContext`A], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"v", 
                   StyleBox[GridBox[{
                    {"B"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v[$CellContext`B],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`v[$CellContext`B], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                  
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`B], Editable -> False], "_"], 
                  
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`B], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                 Editable -> False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox["7", "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{"7", ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "1", ",", "7"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                False], $CellContext`Mass, Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`Mass, Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                 "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`B], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`B], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`B], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`B], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Constant", ",", "ConstantSymbol", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"7", ",", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"v", ",", "v"}], "}"}]}], "}"}]}], "}"}]}], 
             "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], Editable -> 
            False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"4ce57ff7-15c4-499c-8224-f46db142a48a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$CommuteFreeIndices", "=", 
  "False"}]], "Input",ExpressionUUID->"29414b19-8506-4157-9477-b101bea8dbda"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"86efb9c6-70ed-4798-a2e4-be3b1d57822b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"D", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"ed45ab59-c36d-4d90-94e9-18be29cc159a"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"A", "B", "C"},
                 {" ", " ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`A, $CellContext`B, C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
             False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"D", " ", " "},
                 {" ", "B", "C"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[D, -$CellContext`B, -C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`T[D, -$CellContext`B, -C], Editable -> False], ",", 
            
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
               False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[D, -$CellContext`B, -C], Editable -> False], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"D", " ", " "}, {" ", "B", "C"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[D, -$CellContext`B, -C], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "6", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D, -$CellContext`B, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -C, D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "36", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", "D", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
             D, -$CellContext`B, -C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "D", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[$CellContext`A, D], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[-$CellContext`B, $CellContext`B, -C, C], 
            Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"bfda0b85-ebce-41cb-b0eb-049b8fa93238"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$CommuteFreeIndices", "=", 
  "True"}]], "Input",ExpressionUUID->"85279523-2a3f-4fd0-a4ba-d7fd00ac53d8"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"235dd297-3c17-4baa-95b2-553dc9b01092"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{"1", "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "Mass", " ", 
      RowBox[{"v", "[", "]"}]}], "-", 
     RowBox[{
      RowBox[{"v", "[", "]"}], "^", "2"}]}], ")"}]}], 
  "]"}]], "Input",ExpressionUUID->"74a115a2-a6f5-4e91-a4e8-b9d0c5d13e9d"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    FractionBox["1", 
     RowBox[{"\<\"VerbatimPlus\"\>", "[", 
      RowBox[{
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox["2", "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{"2", ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "2"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               InterpretationBox[
                StyleBox["Mass",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                  RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               InterpretationBox[
                StyleBox["v",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`v[],
                Editable->False], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`v[], Editable -> False], ",", 
                  RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["2", "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{"2", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "2"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "Constant", ",", "ConstantSymbol", ",", "Tensor"}], 
                    "}"}]}], "}"}], ",", 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "v"}],
                     "}"}]}], "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ], ",", 
       TagBox[
        TooltipBox[
         UnderscriptBox[
          RowBox[{
           RowBox[{"(", 
            TagBox[
             TooltipBox[
              UnderscriptBox["Times", "_"],
              RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
             #& ], ")"}], "[", 
           RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{"-", "1"}], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{"-", "1"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["v",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`v[],
                 Editable->False], "2"], "_"],
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], ",", 
                  RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]],
             #& ]}], "]"}], "_"],
         RowBox[{"\"Object\"", "[", 
           RowBox[{
             RowBox[{
               RowBox[{"(", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox["Times", "_"], 
                   RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
                 ")"}], "[", 
               RowBox[{
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    RowBox[{"-", "1"}], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                 TagBox[
                  TooltipBox[
                   UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], "_"], 
                   RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                 
                 RowBox[{"{", "1", "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False], ",", 
                 InterpretationBox[
                  StyleBox[
                   RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                   AutoSpacing -> False, ShowAutoStyles -> False], 
                  xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
           "]"}]],
        #& ]}], "]"}]], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       FractionBox["1", 
        RowBox[{"\"VerbatimPlus\"", "[", 
          RowBox[{
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["2", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"2", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "2"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["2", "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{"2", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "2"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"ConstantSymbol", ",", "1", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    
                    RowBox[{"Constant", ",", "ConstantSymbol", ",", 
                    "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "v"}],
                     "}"}]}], "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ], ",", 
            TagBox[
             TooltipBox[
              UnderscriptBox[
               RowBox[{
                 RowBox[{"(", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                    ")"}], "[", 
                 RowBox[{
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    RowBox[{"-", "1"}], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                   TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], "_"], 
              RowBox[{"\"Object\"", "[", 
                RowBox[{
                  RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ],
                     ")"}], "[", 
                    RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    RowBox[{"-", "1"}], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "v", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[], Editable -> False], "2"], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                    "]"}]], #& ]}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                "]"}]], #& ]}], "]"}]], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Plus", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "Constant", ",", "ConstantSymbol", ",", "Tensor"}], 
                    "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Constant", ",", "Tensor"}], "}"}]}], "}"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               InterpretationBox[
                StyleBox[
                 RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                 False], Power, Editable -> False], ",", 
               RowBox[{"{", 
                 RowBox[{"Plus", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Mass"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], ",", "v"}],
                     "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "v", ",", "2"}], 
                    "}"}]}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"53f4adda-96c3-43f5-9766-74ae345abb99"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"12d316d7-6208-427a-854b-8d07ec8dc6fc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Mass",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Mass],
  Editable->
   False]], "Print",ExpressionUUID->"deef587e-edf4-4d67-9e99-32110e930f57"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"v", ",", "T"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"f3e47eaf-f145-462d-91af-b635ab298418"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"b9bd6a62-ca34-4f64-9c89-4aaa43d7b394"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"d44e61a6-0108-4f64-bc3e-80a18e53c87a"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "metricg", "]"}], 
  ";"}]], "Input",ExpressionUUID->"ec7021a6-d075-45f7-8cbc-0caa159ad720"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"59914a34-2395-4940-b1b6-ec03f35046ed"],

Cell["Examples with derivatives and metrics:", \
"Text",ExpressionUUID->"32c30218-59c4-4dc8-a07b-2a7204947523"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e814c09a-feb2-4433-818a-2bde535d428b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"0bf3e1b4-7c82-46e0-ac84-48c22f754625"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0667f9ef-7f48-4546-8e29-b0c278a01613"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ab34b43f-d34f-4647-b9ca-7a62d600c4c6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"948e61f1-d055-47f0-b4a6-3b800fa84d76"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cca35b77-6b06-4a7c-a44c-811910480882"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"32a98465-807e-47a2-8991-9ea902f279d4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"992bf79c-b2da-4576-b1b3-d75215f63d01"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d833082a-ef91-494a-819a-20fd343267ba"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"b26c4c50-ace0-4ee9-a412-7b9a0443f7e3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"857b8ce7-4866-4444-ad88-dae6462b9cbb"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"A", "B", "C"},
                 {" ", " ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`A, $CellContext`B, C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
             False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {" ", " ", "  "},
                 {"B", "C", 
                  RowBox[{";", "A"}]}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CD[-$CellContext`A][
           $CellContext`T[-$CellContext`B, -C]],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{" ", " ", "  "}, {"B", "C", ";A"}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`CD[-$CellContext`A][
              $CellContext`T[-$CellContext`B, -C]], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
               False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", ";A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`CD[-$CellContext`A][
                $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", ";A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`CD[-$CellContext`A][
                   $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"T", ",", 
                   RowBox[{"{", 
                    RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}]}], 
             "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, 
             C, -$CellContext`B, -C, -$CellContext`A], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B, -C, C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"a2dc24d4-069d-4c3d-a691-38c9279cfd33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`careQ", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"4ed0e581-00ac-44e7-ae79-3403ffd6464d"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"19a654bc-6f97-4a92-b383-08134577fc1f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metric", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "cd", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<#\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"cd1fb009-f93a-46d2-aa23-543171741bfd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metric", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metric[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"211f5c98-62fd-471d-9879-263bb3a74ec1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetric", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetric[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5cba6a0f-ccde-4532-9659-56935c66f002"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e2de9983-4cb8-4412-bcc6-33be066e89d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Torsioncd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`Torsioncd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"500cc4a2-b847-4483-9fdd-4b18942e84fb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Christoffelcd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`Christoffelcd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"e023ce4c-6ffd-4437-b13b-98e77ea93886"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Riemanncd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`Riemanncd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0136902b-a130-44a7-991b-4a3109962aa3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Riccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`Riccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"df8cd734-37b9-439a-8515-38d2d1c5c49a"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"e48549c4-c69c-4442-827b-a2879cfbf734"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarcd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarcd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"77062617-549b-4dba-b380-f9a4f33cb3d4"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"032b262f-bb26-40c3-9c1e-4f753fcf5508"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Einsteincd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`Einsteincd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a1077609-e81b-4f2d-88b1-83c9db55f38c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Weylcd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`Weylcd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3dff51af-955c-45cd-9c6d-f6e0f185c42f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRiccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRiccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"60d2b242-b7b3-4496-b5fa-17c88ac11dad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"Kretschmanncd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`Kretschmanncd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2f27205e-45f0-441d-851d-21c98996f983"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"bf6b5dc2-75d0-4c42-8b7f-c1278bcb8fdb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"3776a367-509e-43a5-98d6-bdbc6c000ab6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"4328cbf9-b0dc-43a3-b13e-8a23c9621573"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetric", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetric[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"bb519228-3c17-4fa6-8438-370541a821ef"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1daf2605-47f9-4201-a7f5-66da85f93197"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"A", "B", "C"},
                 {" ", " ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`A, $CellContext`B, C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
             False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric}, \
{$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], "}"}]}],
           "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {" ", " ", "  "},
                 {"B", "C", 
                  RowBox[{";", "A"}]}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CD[-$CellContext`A][
           $CellContext`T[-$CellContext`B, -C]],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{" ", " ", "  "}, {"B", "C", ";A"}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`CD[-$CellContext`A][
              $CellContext`T[-$CellContext`B, -C]], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric", ",", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}]}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric", ",", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}]}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric, 
                   $CellContext`CD[-$CellContext`A]}, \
{-$CellContext`TangentM2, $CellContext`metric, 
                   $CellContext`CD[-$CellContext`A]}, \
{-$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], 
              "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
               False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric}, \
{$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], "}"}]}],
                "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", ";A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`CD[-$CellContext`A][
                $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", ";A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`CD[-$CellContext`A][
                   $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric", ",", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}]}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric", ",", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}]}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric, 
                    $CellContext`CD[-$CellContext`A]}, \
{-$CellContext`TangentM2, $CellContext`metric, 
                    $CellContext`CD[-$CellContext`A]}, \
{-$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], 
                   "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"T", ",", 
                   RowBox[{"{", 
                    RowBox[{"CD", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}]}], 
             "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, 
             C, -$CellContext`B, -C, -$CellContext`A], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B, -C, C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric", ",", 
                   RowBox[{"CD", "[", 
                    RowBox[{"-", "A"}], "]"}]}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric}, \
{-$CellContext`TangentM2, $CellContext`metric, 
              $CellContext`CD[-$CellContext`A]}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"f385844d-9159-42e2-8f4b-93b66747d477"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`careQ", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"fba5da9d-78ab-4ac7-9e5d-edba37e3ca05"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"ab6ea82e-f2de-4068-8a02-a94c156b01cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{
    RowBox[{"cd", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"23c18a3e-fce1-4118-bea2-106503a7e88b"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {"A", "B", "C"},
                 {" ", " ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[$CellContext`A, $CellContext`B, C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
             False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric}, \
{$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], "}"}]}],
           "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {" ", " ", "  "},
                 {"B", "C", 
                  RowBox[{"#", "A"}]}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`cd[-$CellContext`A][
           $CellContext`T[-$CellContext`B, -C]],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{" ", " ", "  "}, {"B", "C", "#A"}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`cd[-$CellContext`A][
              $CellContext`T[-$CellContext`B, -C]], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"cd", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"cd", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {-$CellContext`TangentM2, $CellContext`metric}, \
{-$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], 
              "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
               False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric}, \
{$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], "}"}]}],
                "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", "#A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`cd[-$CellContext`A][
                $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", "#A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`cd[-$CellContext`A][
                   $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"cd", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"cd", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {-$CellContext`TangentM2, $CellContext`metric}, \
{-$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], 
                   "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"T", ",", 
                   RowBox[{"{", 
                    RowBox[{"cd", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"cd", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}]}], 
             "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], "\",\"", 
               RowBox[{"-", "A"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, 
             C, -$CellContext`B, -C, -$CellContext`A], Editable -> False], 
           ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B, -C, C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric}], 
            Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"e09b411d-c8fb-441a-af39-a9dc9348a96f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`careQ", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"7b1dd469-dee8-4904-93b6-30e260229325"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"c3cfa07c-b8f5-4829-8c86-a3a77a1b1136"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"OverDot", "[", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], "]"}], 
   RowBox[{
    RowBox[{"cd", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4a15736e-42e4-4392-a620-1b50b122a9d8"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {" ", " ", "  "},
                 {"B", "C", 
                  RowBox[{"#", "A"}]}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`cd[-$CellContext`A][
           $CellContext`T[-$CellContext`B, -C]],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"T", 
                 StyleBox[
                  
                  GridBox[{{" ", " ", "  "}, {"B", "C", "#A"}}, RowSpacings -> 
                   0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`cd[-$CellContext`A][
              $CellContext`T[-$CellContext`B, -C]], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"cd", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"cd", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -C, -$CellContext`A],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {-$CellContext`TangentM2, $CellContext`metric}, \
{-$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], 
              "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         OverscriptBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"T", 
               StyleBox[GridBox[{
                  {"A", "B", "C"},
                  {" ", " ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T[$CellContext`A, $CellContext`B, C],
           Editable->False], "."], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            OverscriptBox[
             InterpretationBox[
              StyleBox[
               GridBox[{{"T", 
                  StyleBox[
                   
                   GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                   Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                Center], AutoSpacing -> False, ShowAutoStyles -> False], 
              $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
              False], "."], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"OverDot", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", "OverDot", "]"}]}], "}"}]}], 
              "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                    "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                    "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                    "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metric, OverDot}, {$CellContext`TangentM2, $CellContext`metric, 
                   OverDot}, {$CellContext`TangentM2, $CellContext`metric, 
                   OverDot}], Editable -> False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", "#A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`cd[-$CellContext`A][
                $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " ", "  "}, {"B", "C", "#A"}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`cd[-$CellContext`A][
                   $CellContext`T[-$CellContext`B, -C]], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"cd", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"cd", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "C"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`B, -
                    C, -$CellContext`A], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {-$CellContext`TangentM2, $CellContext`metric}, \
{-$CellContext`TangentM2, $CellContext`metric}], Editable -> False]}], 
                   "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              OverscriptBox[
               InterpretationBox[
                StyleBox[
                 GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                  Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`T[$CellContext`A, $CellContext`B, C], Editable -> 
                False], "."], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 OverscriptBox[
                  InterpretationBox[
                   StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B", "C"}, {" ", " ", " "}}, RowSpacings -> 
                    0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`T[$CellContext`A, $CellContext`B, C], 
                   Editable -> False], "."], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"OverDot", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", "OverDot", "]"}]}], "}"}]}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                    "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                    "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                    "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metric, OverDot}, {$CellContext`TangentM2, $CellContext`metric, 
                    OverDot}, {$CellContext`TangentM2, $CellContext`metric, 
                    OverDot}], Editable -> False]}], "}"}]}], "]"}]], #& ]}], 
         "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"cd", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", 
                    RowBox[{"cd", "[", 
                    RowBox[{"-", "A"}], "]"}], "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"OverDot", ",", "T", ",", 
                    RowBox[{"\"MyDer\"", "[", "OverDot", "]"}]}], "}"}]}], 
                 "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "C"}], "\",\"", 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", "B", "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`B, -
             C, -$CellContext`A, $CellContext`A, $CellContext`B, C], Editable -> 
            False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B, -C, C], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metric"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metric", ",", "OverDot"}], 
                 "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metric}, {$CellContext`TangentM2, $CellContext`metric, OverDot}],
             Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"1fd37469-365c-4b4e-b537-3939d764af9b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`careQ", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"a4ed9c6c-f924-43ef-b081-f1d6e146ea07"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"e3b6cf67-8559-4529-a0ea-aa2f06b4cb7f"]
}, Open  ]],

Cell["Note that we use strange patterns in the metric definitions:", \
"Text",ExpressionUUID->"cf596eb7-c5ef-457a-b561-414fcd672d5e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "metric"}]], "Input",ExpressionUUID->"938c5639-3204-4a33-bab6-26323cbef04f"],

Cell[CellGroupData[{

Cell["Global`metric", "Print", "PrintUsage",
 CellTags->
  "Info3578678603-7517086",ExpressionUUID->"d87ae701-6917-401d-9d03-\
fa5199660b21"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"CovDOfMetric", "[", "metric", "]"}], "^=", "cd"}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"CovDOfMetric", "[", 
          RowBox[{"metric", ",", "Torsioncd"}], "]"}], "=", "cd"}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"CovDOfMetric", "[", 
          RowBox[{"metric", ",", "Zero"}], "]"}], "=", "cd"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "metric", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`metric],
          Editable->False], "^=", "metric"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "metric", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"symmetric metric tensor\"\>", ",", "\<\"\"\>"}], 
          "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "metric", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"Determinant", "[", 
          RowBox[{"metric", ",", "AIndex"}], "]"}], "=", "Detmetric"}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"epsilonOrientation", "[", 
          RowBox[{"metric", ",", "AIndex"}], "]"}], "=", "1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"FlatMetricQ", "[", "metric", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "metric", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"InducedFrom", "[", "metric", "]"}], "^=", "Null"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Inv", "[", "metric", "]"}], "^=", "metric"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LC", "[", "metric", "]"}], "^=", "cd"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricQ", "[", "metric", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "metric", "]"}], "^=", "\<\"metric\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "metric", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"epsilonmetric", ",", "cd", ",", "Detmetric"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SignDetOfMetric", "[", "metric", "]"}], "^=", 
         RowBox[{"-", "1"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "metric", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "metric", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"(", "1", ",", "2", ")"}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             xAct`xPerm`Cycles[{1, 2}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{
         "xAct`xTensor`Private`SymmetryOfMetric", "[", "metric", "]"}], "^=", 
         "1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "metric", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleOfMetric", "[", "metric", "]"}], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "metric", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"xAct`xTensor`Private`ZeroDerOnMetricQ", "[", 
          RowBox[{"OverDot", ",", "metric"}], "]"}], "=", "False"}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"xAct`xTensor`Private`ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`deronvbundle", "[", 
            RowBox[{"cd", ",", 
             InterpretationBox[
              StyleBox["\[DoubleStruckCapitalT]M2",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`TangentM2,
              Editable->False]}], "]"}], ",", "metric"}], "]"}], "=", 
         "True"}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"xAct`xTensor`Private`ZeroDerOnMetricQ", "[", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`deronvbundle", "[", 
            RowBox[{"CD", ",", 
             InterpretationBox[
              StyleBox["\[DoubleStruckCapitalT]M2",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`TangentM2,
              Editable->False]}], "]"}], ",", "metric"}], "]"}], "=", 
         "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]], 
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {" ", 
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"]},
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[-PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ], 
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
          xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]], 
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], " "},
                   {" ", 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]], -PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
          xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q], 
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {" ", 
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"]},
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[-PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ], 
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
          xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox["xAct`xTensor`Private`a$", "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q], 
             Pattern[xAct`xTensor`Private`a$, 
              Blank[]]],
            Editable->False], " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], " "},
                   {" ", 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"]}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             Pattern[xAct`xTensor`Private`c$, 
              Blank[]], -PatternTest[
               Pattern[xAct`xTensor`Private`b$, 
                Blank[]], xAct`xTensor`EIndexQ]],
            Editable->False]}], "]"}], "^:=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a$", "xAct`xTensor`Private`c$"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
          xAct`xTensor`Private`a$, xAct`xTensor`Private`c$],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{
           RowBox[{"xAct`xTensor`Private`der$_", "?", "FirstDerQ"}], "[", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"metric", 
                StyleBox[GridBox[{
                   {
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`b$", "_"], "_"], 
                    UnderscriptBox[
                    UnderscriptBox["xAct`xTensor`Private`c$", "_"], "_"]},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`metric[
             PatternTest[
              Pattern[xAct`xTensor`Private`b$, 
               Blank[]], TangentM2`Q], 
             PatternTest[
              Pattern[xAct`xTensor`Private`c$, 
               Blank[]], TangentM2`Q]],
            Editable->False], "]"}], "]"}], "^:=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xAct`xTensor`Private`b1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]M2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentM2,
                Editable->False], "]"}]}], ",", 
             RowBox[{"xAct`xTensor`Private`c1$", "=", 
              RowBox[{"DummyIn", "[", 
               InterpretationBox[
                StyleBox["\[DoubleStruckCapitalT]M2",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`TangentM2,
                Editable->False], "]"}]}]}], "}"}], ",", 
           RowBox[{
            RowBox[{"-", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"metric", 
                  StyleBox[GridBox[{
                    {"xAct`xTensor`Private`b$", "xAct`xTensor`Private`b1$"},
                    {" ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`metric[
              xAct`xTensor`Private`b$, xAct`xTensor`Private`b1$],
              Editable->False]}], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"metric", 
                 StyleBox[GridBox[{
                    {"xAct`xTensor`Private`c$", "xAct`xTensor`Private`c1$"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`metric[
             xAct`xTensor`Private`c$, xAct`xTensor`Private`c1$],
             Editable->False], " ", 
            RowBox[{"xAct`xTensor`Private`der$", "[", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"metric", 
                  StyleBox[GridBox[{
                    {" ", " "},
                    {"xAct`xTensor`Private`b1$", "xAct`xTensor`Private`c1$"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`metric[-xAct`xTensor`Private`b1$, -
               xAct`xTensor`Private`c1$],
              Editable->False], "]"}]}]}], "]"}]}]},
       {" "},
       {
        RowBox[{"metric", "/:", 
         RowBox[{"xAct`xTensor`Private`ZeroDerivativeQ", "[", 
          RowBox[{
           RowBox[{"CD", "[", 
            RowBox[{"__", "?", "TangentM2`pmQ"}], "]"}], ",", "metric"}], 
          "]"}], "=", "False"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {"#", 
                  UnderscriptBox["xAct`xTensor`Private`b", "_"]},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
           xAct`xTensor`Dir[
            Pattern[xAct`xTensor`Private`expr, 
             Blank[]]], 
           Pattern[xAct`xTensor`Private`b, 
            Blank[]]],
          Editable->False], ":=", 
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{"xAct`xTensor`Private`expr", ",", 
           RowBox[{
            RowBox[{
            "xAct`xTensor`Private`UltraindexOf", "[", 
             "xAct`xTensor`Private`expr", "]"}], "\[Rule]", 
            "xAct`xTensor`Private`b"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox["xAct`xTensor`Private`a", "_"], "#"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
           Pattern[xAct`xTensor`Private`a, 
            Blank[]], 
           xAct`xTensor`Dir[
            Pattern[xAct`xTensor`Private`expr, 
             Blank[]]]],
          Editable->False], ":=", 
         RowBox[{"ReplaceIndex", "[", 
          RowBox[{"xAct`xTensor`Private`expr", ",", 
           RowBox[{
            RowBox[{
            "xAct`xTensor`Private`UltraindexOf", "[", 
             "xAct`xTensor`Private`expr", "]"}], "\[Rule]", 
            "xAct`xTensor`Private`a"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], "_"], 
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
           PatternTest[
            Pattern[xAct`xTensor`Private`a, 
             Blank[]], xAct`xTensor`UpIndexQ], 
           PatternTest[
            Pattern[xAct`xTensor`Private`b, 
             Blank[]], xAct`xTensor`DownIndexQ]],
          Editable->False], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`b", "xAct`xTensor`Private`a"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[xAct`xTensor`Private`b, xAct`xTensor`Private`a],
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"metric", 
              StyleBox[GridBox[{
                 {
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`a", "_"], "_"], 
                  UnderscriptBox[
                   UnderscriptBox["xAct`xTensor`Private`b", "_"], "_"]},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`metric[
           PatternTest[
            Pattern[xAct`xTensor`Private`a, 
             Blank[]], xAct`xTensor`DownIndexQ], 
           PatternTest[
            Pattern[xAct`xTensor`Private`b, 
             Blank[]], xAct`xTensor`UpIndexQ]],
          Editable->False], ":=", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {"xAct`xTensor`Private`a", "xAct`xTensor`Private`b"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[xAct`xTensor`Private`a, xAct`xTensor`Private`b],
          Editable->False]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`metric],
  Editable->False]], "Print",
 CellTags->
  "Info3578678603-7517086",ExpressionUUID->"97423c65-4065-4289-b307-\
ca0632179c02"]
}, Open  ]]
}, Open  ]],

Cell["These definitions seem redundant, as we said:", \
"Text",ExpressionUUID->"bfdf25f5-877a-4485-a8c3-ef3c983679b6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UpValues", "[", "metric", "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"First", "/@", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"UpValues", "[", "metric", "]"}], ",", 
      "xAct`xTensor`Private`ZeroDerOnMetricQ"}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8e938e62-38b8-4fb5-b37f-3690be85939b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"xAct`xTensor`Private`ZeroDerOnMetricQ", "[", 
      RowBox[{"OverDot", ",", "metric"}], "]"}], "]"}], "\[RuleDelayed]", 
    "False"}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"xAct`xTensor`Private`ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"xAct`xTensor`Private`deronvbundle", "[", 
        RowBox[{"cd", ",", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}], "]"}], ",", "metric"}], "]"}], "]"}], 
    "\[RuleDelayed]", "True"}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"xAct`xTensor`Private`ZeroDerOnMetricQ", "[", 
      RowBox[{
       RowBox[{"xAct`xTensor`Private`deronvbundle", "[", 
        RowBox[{"CD", ",", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]M2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentM2,
          Editable->False]}], "]"}], ",", "metric"}], "]"}], "]"}], 
    "\[RuleDelayed]", "False"}]}], 
  "}"}]], "Output",ExpressionUUID->"09d859df-068a-4111-a0d7-2ee639e1bbad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UpValues", "[", "metric", "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"First", "/@", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"UpValues", "[", "metric", "]"}], ",", 
      "xAct`xTensor`Private`ZeroDerivativeQ"}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8a5874bf-b1c0-481d-bf0d-d0f1875e8280"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{"xAct`xTensor`Private`ZeroDerivativeQ", "[", 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"__", "?", "TangentM2`pmQ"}], "]"}], ",", "metric"}], "]"}], 
    "]"}], "\[RuleDelayed]", "False"}], 
  "}"}]], "Output",ExpressionUUID->"507e877d-26f3-4a01-929e-f9d141c8948e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "metric"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"634c1e0c-dfb4-473b-ac28-fb324095fb09"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"ee89946f-a06b-4e02-a6aa-e53d08cea855"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetric],
  Editable->
   False]], "Print",ExpressionUUID->"829972b0-49d0-4ce0-a5cb-c3df84adff4b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Christoffelcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`Christoffelcd],
  Editable->
   False]], "Print",ExpressionUUID->"9182f4ac-bf99-42db-965c-38306a9ba256"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Einsteincd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`Einsteincd],
  Editable->
   False]], "Print",ExpressionUUID->"887b68d6-d11b-4baf-a9f0-b2d4ebcbb649"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Kretschmanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`Kretschmanncd],
  Editable->
   False]], "Print",ExpressionUUID->"26de4d07-1b43-46d6-bc16-efb0d34c3768"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`Riccicd],
  Editable->
   False]], "Print",ExpressionUUID->"abbb8b74-4bda-4644-9418-b6d233ba6160"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarcd],
  Editable->
   False]], "Print",ExpressionUUID->"7bcbea39-7547-4f3f-aa48-e013fb836bcb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riemanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`Riemanncd],
  Editable->
   False]], "Print",ExpressionUUID->"4540366f-be1d-4c00-bcf7-8283de0a5aad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRiccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRiccicd],
  Editable->
   False]], "Print",ExpressionUUID->"8d8d429d-e38f-433a-9bac-adbf4a3e4b33"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Torsioncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`Torsioncd],
  Editable->
   False]], "Print",ExpressionUUID->"432c13d1-5f2a-44eb-b4ab-ff8581ee45c7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Weylcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`Weylcd],
  Editable->
   False]], "Print",ExpressionUUID->"f896ead1-85ed-4d5a-b1e0-0e62b82ba812"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`cd],
  Editable->
   False]], "Print",ExpressionUUID->"d14f6339-dabd-4ae2-a4b2-77af68791016"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetric],
  Editable->
   False]], "Print",ExpressionUUID->"8b4508a3-38bd-4f68-8fae-ea7139db0fa5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metric],
  Editable->
   False]], "Print",ExpressionUUID->"cb39c51f-c6fd-4352-8bb8-73d8e8e7935c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "CD", 
  "]"}]], "Input",ExpressionUUID->"0f38eb70-2f57-41c8-bd92-2e825fdbde8b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"8e378f5d-fe21-41b0-bf9f-03736d8ed82c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"84846c30-d448-4440-bb8c-04fb62a66495"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"11ac9684-9b6a-4da0-bbb8-0728ba6e3f6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"afbe4e26-c788-4d33-8197-5b4ed2d04d13"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"7cdbcbd0-ba77-4936-8dbb-a34bb6f3602e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"edae6ac0-bdf7-4d9f-8b72-39c1c1ab8293"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$261456\"\>", ",", "\<\"G$261456$\"\>", 
     ",", "\<\"G$261457\"\>", ",", "\<\"G$261457$\"\>", 
     ",", "\<\"G$261458\"\>", ",", "\<\"G$261458$\"\>", 
     ",", "\<\"G$261459\"\>", ",", "\<\"G$261459$\"\>", 
     ",", "\<\"G$261460\"\>", ",", "\<\"G$261460$\"\>", 
     ",", "\<\"G$261461\"\>", ",", "\<\"G$261461$\"\>", 
     ",", "\<\"G$261462\"\>", ",", "\<\"G$261462$\"\>", 
     ",", "\<\"G$261463\"\>", ",", "\<\"G$261463$\"\>", 
     ",", "\<\"G$261464\"\>", ",", "\<\"G$261464$\"\>", 
     ",", "\<\"G$261465\"\>", ",", "\<\"G$261465$\"\>", 
     ",", "\<\"G$261466\"\>", ",", "\<\"G$261466$\"\>", 
     ",", "\<\"G$261467\"\>", ",", "\<\"G$261467$\"\>", 
     ",", "\<\"G$261468\"\>", ",", "\<\"G$261468$\"\>", 
     ",", "\<\"G$261469\"\>", ",", "\<\"G$261469$\"\>", 
     ",", "\<\"G$261538\"\>", ",", "\<\"G$261539\"\>", 
     ",", "\<\"G$261540\"\>", ",", "\<\"G$261541\"\>", 
     ",", "\<\"G$261549\"\>", ",", "\<\"G$261550\"\>", 
     ",", "\<\"G$261558\"\>", ",", "\<\"G$261559\"\>", 
     ",", "\<\"G$261560\"\>", ",", "\<\"G$261566\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$261456", "G$261456$", "G$261457", "G$261457$", "G$261458", "G$261458$", 
    "G$261459", "G$261459$", "G$261460", "G$261460$", "G$261461", "G$261461$",
     "G$261462", "G$261462$", "G$261463", "G$261463$", "G$261464", 
    "G$261464$", "G$261465", "G$261465$", "G$261466", "G$261466$", "G$261467",
     "G$261467$", "G$261468", "G$261468$", "G$261469", "G$261469$", 
    "G$261538", "G$261539", "G$261540", "G$261541", "G$261549", "G$261550", 
    "G$261558", "G$261559", "G$261560", "G$261566"}],
  Editable->
   False]], "Print",ExpressionUUID->"5ddd6ede-229d-4db9-b82c-fae4e02583ff"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2. SymmetryOf", \
"Subsection",ExpressionUUID->"ad14396b-e804-4699-9abb-a5c34825be94"],

Cell[CellGroupData[{

Cell["15.2.0. Comments", \
"Subsubsection",ExpressionUUID->"a8774cfd-8df8-49a8-bc0c-3ce5e9201795"],

Cell["\<\
It would be more reasonable to starting defining xSort. However we need to \
know the symmetries of the objects in order to sort them (see ObjectOrder). \
And then we need xSort to define the symmetry of a product. That is why we \
need to define SymmetryOf in two stages, with the definition of xSort in \
between.\
\>", "Text",ExpressionUUID->"3233e566-9512-4603-8ff8-70d9a0133e04"],

Cell["\<\
The function SymmetryOf will give the SLOT-symmetries of an arbitrary \
expression. The output is a Symmetry expression with four arguments:
\t- an integer with the number of slots in the expression,
\t- the expression with all indices replaced by slot numbers,
\t- a list of rules of the form slot[5]->index,
\t- a STRONG GENERATING SET for the symmetry group of the expression.\
\>", "Text",ExpressionUUID->"bff65463-4f90-443d-82cc-d44d35f82865"],

Cell["\<\
The head Symmetry does not perform any action. It just holds all the \
information required to canonicalize a term. We can protect it already:\
\>", "Text",ExpressionUUID->"e66f2419-42df-4126-952b-faad5f06982f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "Symmetry", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"202336da-3c70-4e95-bab0-1a93d6213662"],

Cell["This is a typical Symmetry structure:", \
"Text",ExpressionUUID->"907174d9-5cf4-4476-b88a-52c066fe4bbc"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"4", ",", 
   TagBox[
    SubsuperscriptBox[
     "Rie", "\<\"    \"\>", "\<\"\[FilledCircle]1\[FilledCircle]2\
\[FilledCircle]3\[FilledCircle]4\"\>"],
    Tensor], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       RowBox[{"Cycles", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "4"}], "}"}]}], "]"}], ",", 
       RowBox[{"-", 
        RowBox[{"Cycles", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], "]"}]}], ",", 
       RowBox[{"-", 
        RowBox[{"Cycles", "[", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}], "]"}]}]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"e7492dc6-57ea-4976-93a7-d1ad1e5abd44"],

Cell["We define the EmptySymmetry structure:", \
"Text",ExpressionUUID->"1d1ef71b-a3af-487e-bab3-12398f4025b5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"EmptySymmetry", "[", "x_", "]"}], ":=", 
   RowBox[{"Symmetry", "[", 
    RowBox[{"0", ",", "x", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"GenSet", "[", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EmptySymmetry", "[", 
    RowBox[{"x_", ",", "inds_List"}], "]"}], ":=", 
   RowBox[{"Symmetry", "[", 
    RowBox[{
     RowBox[{"Length", "[", "inds", "]"}], ",", "x", ",", 
     RowBox[{"MapIndexed", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Rule", "[", 
         RowBox[{
          RowBox[{"slot", "@", 
           RowBox[{"First", "[", "#2", "]"}]}], ",", "#1"}], "]"}], "&"}], 
       ",", "inds"}], "]"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"GenSet", "[", "]"}]}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"1a47bc6b-9c0d-4715-b9dc-6b6930a10337"],

Cell[TextData[{
 "Note that Symmetry and EmptySymmetry are ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " heads, and not ",
 StyleBox["xPerm",
  FontSlant->"Italic"],
 " heads."
}], "Text",ExpressionUUID->"4d8188d0-1661-4439-8454-ee6df95f2d83"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.1. Slots", \
"Subsubsection",ExpressionUUID->"c3767c11-4ea3-4f9e-987e-6eba72193c83"],

Cell["\<\
The expression will have the five kinds of g-indices. Indices (abstract- or \
basis-) and named patterns cannot be repeated, but blanks, label-indices, \
basis-integers and directions can be repeated. Therefore it is not possible \
to identify slots with the g-index which is actually there. We must identify \
slots numerically somehow. That is why we use the slot[5] notation.\
\>", "Text",ExpressionUUID->"4068ddab-8020-46fc-9a44-aa296efdafe3"],

Cell["\<\
The first step is replacing all g-indices by slots. This is the output format \
($slotSymbol has been randomly chosen):\
\>", "Text",ExpressionUUID->"c530c86c-998a-481e-b2a8-7fa7f03a7d0c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$slotSymbol", "=", "\"\<\[FilledCircle]\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Format", "[", 
    RowBox[{"slot", "[", "n_Integer", "]"}], "]"}], ":=", 
   RowBox[{"$slotSymbol", "<>", 
    RowBox[{"ToString", "[", "n", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Unprotect", "[", "IndexForm", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexForm", "[", 
    RowBox[{"slot", "[", "n_Integer", "]"}], "]"}], ":=", 
   RowBox[{"$slotSymbol", "<>", 
    RowBox[{"ToString", "[", "n", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexForm", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"74b5cbf2-c694-41a2-822e-36200b66fd8d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"slot", "[", "4", 
  "]"}]], "Input",ExpressionUUID->"657d2d68-e40e-4101-9488-64eba2e972ac"],

Cell[BoxData["\<\"\[FilledCircle]4\"\>"], \
"Output",ExpressionUUID->"73e75076-b64d-4ad3-aa59-1bd03d6bea35"]
}, Open  ]],

Cell["\<\
We need to update a few functions because, in some sense, slot is another \
kind of g-index:\
\>", "Text",ExpressionUUID->"55bd3c76-1221-406b-b127-442c521e688a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"slot", "/:", 
   RowBox[{"UpIndex", "[", "x_slot", "]"}], ":=", "x"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"slot", "/:", 
   RowBox[{"NoDollar", "[", "x_slot", "]"}], ":=", "x"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"752ec3c0-4c9f-4981-a899-6b7ab89b4439"],

Cell["No more definitions will be associated to slot:", \
"Text",ExpressionUUID->"5a39b00b-b2f9-41b2-9ee3-ce9ed7b8e61d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "slot", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9469daad-b5eb-4af7-b736-2ac0d4b40db7"],

Cell["\<\
This function generates a list (head List, and not IndexList) of rules of the \
form slot[i]\[Rule]index, assuming that there are already n slots (hence, \
starting at n+1). Recall that {}+1 is {}, without getting any warning or \
error.\
\>", "Text",ExpressionUUID->"14715760-e6b2-46c1-89d1-1710e940a6ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToSlotRules", "[", 
    RowBox[{"n_Integer", ",", "indices_IndexList"}], "]"}], ":=", 
   RowBox[{"List", "@@", 
    RowBox[{"MapIndexed", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Rule", "[", 
        RowBox[{
         RowBox[{"slot", "@@", 
          RowBox[{"(", 
           RowBox[{"n", "+", "#2"}], ")"}]}], ",", "#1"}], "]"}], "&"}], ",", 
      "indices"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"41afdd7c-dff5-4e79-91ce-47a4f02c57c5"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"1baa87c6-84cb-4e43-85a5-8cb10301ebee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ToSlotRules", "[", 
  RowBox[{"3", ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", "c_", ",", "_", ",", 
     RowBox[{"Dir", "@", 
      RowBox[{"v", "@", "k"}]}], ",", 
     RowBox[{"Dir", "@", 
      RowBox[{"v", "@", "k"}]}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"967df48e-8b28-4544-957b-833eb7784851"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "a"}], ",", 
   RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
    RowBox[{"-", "b"}]}], ",", 
   RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", "c_"}], ",", 
   RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", "_"}], ",", 
   RowBox[{"\<\"\[FilledCircle]8\"\>", "\[Rule]", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "k", "]"}], "]"}]}], ",", 
   RowBox[{"\<\"\[FilledCircle]9\"\>", "\[Rule]", 
    RowBox[{"Dir", "[", 
     RowBox[{"v", "[", "k", "]"}], "]"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"31179bc0-8143-4a21-b2e8-b1aa6b0e480f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"d1ba8a36-a69f-4fa3-a621-9881db1833cd"],

Cell["\<\
{xAct`xTensor`Private`slot[4] -> a, xAct`xTensor`Private`slot[5] -> -b, \
xAct`xTensor`Private`slot[6] -> c_, 
 xAct`xTensor`Private`slot[7] -> _, xAct`xTensor`Private`slot[8] -> Dir[v[k]], 
 xAct`xTensor`Private`slot[9] -> Dir[v[k]]}\
\>", "Output",ExpressionUUID->"a1a3e91f-df57-4641-a4a9-8b26182b6cc7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ToSlotRules", "[", 
  RowBox[{"3", ",", 
   RowBox[{"IndexList", "[", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"bdff138d-5083-42d1-9ee5-0af4e1f9fe39"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"7748b589-bb5a-4ac0-b8a4-016c8c454267"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"k", ",", "v"}], 
  "]"}]], "Input",ExpressionUUID->"5b326755-570e-4322-a8c0-22f5207a71dd"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"efd9ed4e-44b8-49a5-a61b-f647435dbc1a"],

Cell["\<\
The function DisplaceSlots moves the points of the permutations by an integer \
amount (positive, negative or zero). Note that it only works on Cycles \
notation, and actually converts the generating sets to Cycles notation.\
\>", "Text",ExpressionUUID->"5db060e2-683a-4e89-944a-7c7b812d9b25"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DisplaceSlots", "[", 
    RowBox[{"GS_GenSet", ",", "d_Integer"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"TranslatePerm", "[", 
     RowBox[{"GS", ",", "xAct`xPerm`Cycles"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"xAct`xPerm`Cycles", "[", "cycs__", "]"}], "\[RuleDelayed]", 
     RowBox[{"xAct`xPerm`Cycles", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", "cycs", "}"}], "+", "d"}], ")"}]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisplaceSlots", "[", 
    RowBox[{
     RowBox[{"StrongGenSet", "[", 
      RowBox[{"base_List", ",", "GS_GenSet"}], "]"}], ",", "d_Integer"}], 
    "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"base", "+", "d"}], ",", 
     RowBox[{"DisplaceSlots", "[", 
      RowBox[{"GS", ",", "d"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisplaceSlots", "[", 
    RowBox[{
     RowBox[{"Symmetric", "[", "list_", "]"}], ",", "d_Integer"}], "]"}], ":=", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"list", "+", "d"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisplaceSlots", "[", 
    RowBox[{
     RowBox[{"Antisymmetric", "[", "list_", "]"}], ",", "d_Integer"}], "]"}], 
   ":=", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"list", "+", "d"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8bb9bc82-56d8-40d9-9bf6-0a4db5230382"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DisplaceSlots", "[", 
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{"n_", ",", "expr_", ",", "slotlist_", ",", "SGS_"}], "]"}], ",",
      "d_Integer"}], "]"}], ":=", 
   RowBox[{"Symmetry", "[", 
    RowBox[{
     RowBox[{"n", "+", "d"}], ",", 
     RowBox[{"expr", "/.", 
      RowBox[{
       RowBox[{"slot", "[", "x_", "]"}], "\[Rule]", 
       RowBox[{"slot", "[", 
        RowBox[{"x", "+", "d"}], "]"}]}]}], ",", 
     RowBox[{"slotlist", "/.", 
      RowBox[{
       RowBox[{"slot", "[", "x_", "]"}], "\[Rule]", 
       RowBox[{"slot", "[", 
        RowBox[{"x", "+", "d"}], "]"}]}]}], ",", 
     RowBox[{"DisplaceSlots", "[", 
      RowBox[{"SGS", ",", "d"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ef1475d8-a2e5-4520-82f4-50e8ba58ac6b"],

Cell["\<\
This definition is extremely cautious. It is used on expressions and rules.\
\>", "Text",ExpressionUUID->"454814d6-fd70-4517-a121-d5308a992dac"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"addonetolast", "[", 
    RowBox[{"{", 
     RowBox[{"x___", ",", "0"}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DisplaceSlots", "[", 
    RowBox[{"expr_", ",", "d_Integer"}], "]"}], ":=", 
   RowBox[{"xEvaluateAt", "[", 
    RowBox[{
     RowBox[{"expr", "/.", 
      RowBox[{
       RowBox[{"slot", "[", "x_", "]"}], "\[Rule]", 
       RowBox[{"slot", "[", 
        RowBox[{"x", "+", "d"}], "]"}]}]}], ",", 
     RowBox[{"addonetolast", "/@", 
      RowBox[{"Position", "[", 
       RowBox[{"expr", ",", "slot"}], "]"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c907b5c8-482b-47ff-954f-20341d14af18"],

Cell["Examples:", \
"Text",ExpressionUUID->"6a9b732e-2bfd-4fd2-9c04-e3cc0909cd00"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"61b270b6-b020-4c58-bc66-f725fc96dabb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`DisplaceSlots", "[", 
  RowBox[{
   RowBox[{"GenSet", "[", 
    RowBox[{
     RowBox[{"xAct`xPerm`Cycles", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], ",", 
     RowBox[{"xAct`xPerm`Cycles", "[", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}], "]"}]}], "]"}], ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"633471f8-4b52-4dd2-bf94-f5aa72eeb2a1"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "4", ",", "5", ",", "6", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{4, 5, 6}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"(", "6", ",", "7", ")"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{6, 7}],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"960f5aef-2c05-4a76-9d4f-870b64decac7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`DisplaceSlots", "[", 
  RowBox[{
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       RowBox[{"xAct`xPerm`Cycles", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], ",", 
       RowBox[{"xAct`xPerm`Cycles", "[", 
        RowBox[{"{", 
         RowBox[{"3", ",", "4"}], "}"}], "]"}]}], "]"}]}], "]"}], ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"5c8afed2-3a26-46ca-a236-839c0fa38f36"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"(", "4", ",", "5", ",", "6", ")"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{4, 5, 6}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{"(", "6", ",", "7", ")"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{6, 7}],
      Editable->False]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"e26e8558-80d3-4639-ae58-5be56d19a846"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`DisplaceSlots", "[", 
  RowBox[{
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       RowBox[{"xAct`xPerm`Cycles", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], ",", 
       RowBox[{"xAct`xPerm`Cycles", "[", 
        RowBox[{"{", 
         RowBox[{"3", ",", "4"}], "}"}], "]"}]}], "]"}]}], "]"}], ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"98fb3f24-725c-4788-a95d-675f8f39639d"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"(", "4", ",", "5", ",", "6", ")"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{4, 5, 6}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{"(", "6", ",", "7", ")"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{6, 7}],
      Editable->False]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"bd5dee3a-a8b7-41cf-a37f-56e6aa11994a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f339f6f1-0719-4eb2-9096-1f31e2690715"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.2. 1D vbundles", \
"Subsubsection",ExpressionUUID->"a1079d8c-b7c3-47f5-8588-553046cc9c6d"],

Cell["\<\
For version 0.7.0 the construct Join@@#1 has been replaced by \
DeleteDuplicates@Flatten@#1, which is identical on nonoverlapping bases. Then \
we have introduced (in 0.9.8) MyUnion@@#1. QUESTION: I think this function is \
rather unsafe, but very rarely used. Only in CovDSym and Sym1D.\
\>", "Text",ExpressionUUID->"5e7e2400-07a6-4ff1-bb2c-39494316f0c0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"JoinSGSoverlap", "[", 
    RowBox[{"left___", ",", 
     RowBox[{"sym", ":", 
      RowBox[{"(", 
       RowBox[{"_Symmetric", "|", "_Antisymmetric"}], ")"}]}], ",", 
     "right___"}], "]"}], ":=", 
   RowBox[{"JoinSGSoverlap", "[", 
    RowBox[{"left", ",", 
     RowBox[{"SGSofsym", "[", "sym", "]"}], ",", "right"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"JoinSGSoverlap", "[", "SGSs__StrongGenSet", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"MyUnion", "@@", "#1"}], ",", 
       RowBox[{"Union", "@@", "#2"}]}], "]"}], "&"}], "@@", 
    RowBox[{"Transpose", "[", 
     RowBox[{"Apply", "[", 
      RowBox[{"List", ",", 
       RowBox[{"{", "SGSs", "}"}], ",", "1"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"JoinSGSoverlap", "[", "]"}], ":=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"GenSet", "[", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MyUnion", "[", 
    RowBox[{"base_List", ",", "base1_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"MyUnion1", ",", "base", ",", "base1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MyUnion1", "[", 
    RowBox[{
     RowBox[{"base", ":", 
      RowBox[{"{", 
       RowBox[{"___", ",", "x_", ",", "___"}], "}"}]}], ",", "x_"}], "]"}], ":=",
    "base"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MyUnion1", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x___", ",", "y_", ",", "z___"}], "}"}], ",", "p_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "p", ",", "y", ",", "z"}], "}"}], "/;", 
    RowBox[{"y", ">", "p"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MyUnion1", "[", 
    RowBox[{
     RowBox[{"{", "x___", "}"}], ",", "p_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "p"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c1b50ae5-8760-476e-9161-98d02b812443"],

Cell["\<\
1D vector spaces: in the presence of a metric, tensors on 1D spaces are \
totally symmetric. If there is no metric, then they are totally symmetric in \
the groups of covariant and contravariant indices separately. This needs to \
be computed in real time (because whether or not there is a metric can change \
during a session). This function handles that problem:\
\>", "Text",ExpressionUUID->"e93e20dd-48a1-4ffd-8dd4-23a2ad3c216b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Main", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Symmetry1D", "[", 
      RowBox[{"Symmetry", "[", 
       RowBox[{"n_", ",", "expr_", ",", "inds_", ",", "sym_"}], "]"}], "]"}], 
     ":=", 
     RowBox[{"Symmetry", "[", 
      RowBox[{"n", ",", "expr", ",", "inds", ",", 
       RowBox[{"Symmetry1D", "[", 
        RowBox[{"sym", ",", "inds"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Symmetry1D", "[", 
      RowBox[{
       RowBox[{"sym", ":", 
        RowBox[{"(", 
         RowBox[{"_Symmetric", "|", "_Antisymmetric"}], ")"}]}], ",", 
       "inds_"}], "]"}], ":=", 
     RowBox[{"Symmetry1D", "[", 
      RowBox[{
       RowBox[{"SGSofsym", "[", "sym", "]"}], ",", "inds"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"On", " ", "a", " ", "SGS"}], ",", " ", 
     RowBox[{
      RowBox[{"with", " ", "the", " ", "list", " ", "of", " ", "slot"}], "->",
       "aindex"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Symmetry1D", "[", 
      RowBox[{"sym_StrongGenSet", ",", "inds_"}], "]"}], ":=", 
     "\[IndentingNewLine]", 
     RowBox[{"JoinSGSoverlap", "[", 
      RowBox[{"sym", ",", 
       RowBox[{"Symmetry1D", "[", 
        RowBox[{"Cases", "[", 
         RowBox[{
          RowBox[{"List", "@@", "inds"}], ",", 
          RowBox[{"_", "[", 
           RowBox[{"_slot", ",", 
            RowBox[{"_", "?", "AIndexQ"}]}], "]"}]}], "]"}], "]"}]}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Construct", " ", "objects", " ", 
     RowBox[{"{", 
      RowBox[{"vb", ",", " ", "dim", ",", " ", "upQ", ",", " ", "slot"}], 
      "}"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Symmetry1D", "[", "inds_List", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vbundles", "=", 
          RowBox[{"VBundleOfIndex", "/@", 
           RowBox[{"Last", "/@", "inds"}]}]}], ",", "dims"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"dims", "=", 
         RowBox[{"DimOfVBundle", "/@", "vbundles"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"FreeQ", "[", 
           RowBox[{"dims", ",", "1"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"StrongGenSet", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Apply", "[", 
           RowBox[{"JoinSGS", ",", 
            RowBox[{"sym1vbundle", "/@", 
             RowBox[{"Split", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Sort", "@", 
                RowBox[{"Cases", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"{", 
                    RowBox[{"vbundles", ",", "dims", ",", 
                    RowBox[{"UpIndexQ", "/@", 
                    RowBox[{"Last", "/@", "inds"}]}], ",", 
                    RowBox[{"First", "/@", 
                    RowBox[{"First", "/@", "inds"}]}]}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"_", ",", "1", ",", "_", ",", "_"}], "}"}]}], 
                 "]"}]}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"First", "[", "#1", "]"}], "===", 
                  RowBox[{"First", "[", "#2", "]"}]}], ")"}], "&"}]}], 
              "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"One", " ", 
     RowBox[{"vbundle", ":", " ", 
      RowBox[{
      "check", " ", "whether", " ", "there", " ", "is", " ", "a", " ", 
       "metric"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sym1vbundle", "[", "inds_List", "]"}], ":=", 
     RowBox[{"sym1vbundle", "[", 
      RowBox[{"inds", ",", 
       RowBox[{"MetricEndowedQ", "[", 
        RowBox[{"inds", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"There", " ", "is", " ", "a", " ", 
     RowBox[{"metric", ":", " ", 
      RowBox[{"symmetry", " ", "on", " ", "all", " ", "indices"}]}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sym1vbundle", "[", 
      RowBox[{"inds_List", ",", "True"}], "]"}], ":=", 
     RowBox[{"SGSofsym", "@", 
      RowBox[{"Symmetric", "[", 
       RowBox[{"Last", "/@", "inds"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"There", " ", "is", " ", "no", " ", 
     RowBox[{"metric", ":", " ", 
      RowBox[{
      "separate", " ", "upper", " ", "and", " ", "lower", " ", 
       "indices"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sym1vbundle", "[", 
      RowBox[{"inds_List", ",", "False"}], "]"}], ":=", 
     RowBox[{"MapAt", "[", 
      RowBox[{"Sort", ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"JoinSGS", ",", 
         RowBox[{"SGSofsym", "/@", 
          RowBox[{"Symmetric", "/@", 
           RowBox[{"Map", "[", 
            RowBox[{"Last", ",", 
             RowBox[{"Split", "[", 
              RowBox[{"inds", ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"#1", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "===", 
                  RowBox[{"#2", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "&"}]}], "]"}], 
             ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}]}], "]"}], ",", "1"}], 
      "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f103e372-3b4d-4410-ae95-3c1064822b50"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.3. SymmetryOf", \
"Subsubsection",ExpressionUUID->"dd46a44c-004a-46c6-973e-99ad80842aff"],

Cell["\<\
The function SymmetryOf gives the full Symmetry structure of a generic \
expression. These two options for SymmetryOf are a bit surprising at first. \
Describe them in detail (TODO). Actually they are options for the AD part \
manipulating covariant derivatives:\
\>", "Text",ExpressionUUID->"9434790f-e2c0-4564-a305-73b8a71c5088"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SymmetryOf", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CommutePDs", "\[Rule]", "True"}], ",", 
     RowBox[{"ConstantMetric", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a0fac6ad-369e-416c-9963-0434af9b7ad6"],

Cell["\<\
1.- Main definition on tensors. Note that SymmetryGroupOfTensor acts on the \
full tensor with indices. That allows some useful tricks like giving new \
definitions for tensors with variable number of indices.\
\>", "Text",ExpressionUUID->"c8491704-8d1d-428d-b1a8-961965c54351"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", "indices___", "]"}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"{", "indices", "}"}], "]"}], ",", 
       RowBox[{"tensor", "@@", 
        RowBox[{"(", 
         RowBox[{"First", "/@", "#"}], ")"}]}], ",", "#", ",", 
       RowBox[{"SGSofsym", "@", 
        RowBox[{"SymmetryGroupOfTensor", "[", 
         RowBox[{"tensor", "[", "indices", "]"}], "]"}]}]}], "]"}], "&"}], 
    "@", 
    RowBox[{"ToSlotRules", "[", 
     RowBox[{"0", ",", 
      RowBox[{"IndexList", "[", "indices", "]"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"51ea9e16-dd6d-4bd2-a1ec-65535cc68743"],

Cell["2.- On derivatives:", \
"Text",ExpressionUUID->"bd61a7b6-9307-4f10-8375-66a7755e0f97"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "ind__", "]"}], "[", "expr_", 
      "]"}], ",", "options___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CovDSymmetryOf", "[", 
     RowBox[{"covd", "[", "ind", "]"}], "]"}], "[", 
    RowBox[{"expr", ",", "options"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"29e7779e-1a3f-45c9-a191-e7c9213a64ef"],

Cell["\<\
3.- Other heads are essentially trivial: we just reintroduce the head on the \
argument expression. Only the additional z arguments of the inert heads need \
special treatment. Fix a bug pointed out by Alfonso (Jan 2013): Recall that \
the indices of an inert head expression are the unsorted union \
(DeleteDuplicates) of the indices in the tensor and then the IndexList \
expressions, in the order in which they appear in the expression. The \
symmetry comes exclusively from the tensor in the first argument. The other \
indices cannot have symmetry (unless without tweaking SymmetryOf).\
\>", "Text",ExpressionUUID->"6240567e-7c70-463a-bbae-3392a7016709"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"symmetryz", "[", 
    RowBox[{"symmetry_", ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "symmetry"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symmetryz", "[", 
    RowBox[{
     RowBox[{"symmetry", ":", 
      RowBox[{"Symmetry", "[", 
       RowBox[{"_", ",", "_", ",", "rules_", ",", "_"}], "]"}]}], ",", 
     RowBox[{"{", "z__", "}"}]}], "]"}], ":=", 
   RowBox[{"symmetryz1", "[", 
    RowBox[{"symmetry", ",", 
     RowBox[{"{", "z", "}"}], ",", 
     RowBox[{"appendzrules", "[", 
      RowBox[{"rules", ",", 
       RowBox[{"{", "z", "}"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"appendzrules", "[", 
    RowBox[{"rules_", ",", 
     RowBox[{"{", "z__", "}"}]}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{"rules", ",", 
     RowBox[{"ToSlotRules", "[", 
      RowBox[{
       RowBox[{"Length", "[", "rules", "]"}], ",", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"IndexList", "@@", 
          RowBox[{"Join", "@@", 
           RowBox[{"Cases", "[", 
            RowBox[{
             RowBox[{"{", "z", "}"}], ",", "_IndexList"}], "]"}]}]}], ",", 
         RowBox[{"Alternatives", "@@", 
          RowBox[{"(", 
           RowBox[{"Last", "/@", "rules"}], ")"}]}]}], "]"}]}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symmetryz1", "[", 
    RowBox[{"symmetry_", ",", 
     RowBox[{"{", "z__", "}"}], ",", "rules_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"symmetryz2", "[", 
    RowBox[{"symmetry", ",", 
     RowBox[{
      RowBox[{"{", "z", "}"}], "/.", 
      RowBox[{"list_IndexList", "\[RuleDelayed]", 
       RowBox[{"Replace", "[", 
        RowBox[{"list", ",", 
         RowBox[{"Reverse", "/@", "rules"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}]}], ",", "rules"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"symmetryz2", "[", 
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{"n_", ",", 
       RowBox[{"ih_", "[", 
        RowBox[{"expr_", ",", "z1__"}], "]"}], ",", "rules1_", ",", "sym_"}], 
      "]"}], ",", 
     RowBox[{"{", "z2__", "}"}], ",", "rules2_"}], "]"}], ":=", 
   RowBox[{"Symmetry", "[", 
    RowBox[{
     RowBox[{"Length", "[", "rules2", "]"}], ",", 
     RowBox[{"ih", "[", 
      RowBox[{"expr", ",", "z2"}], "]"}], ",", "rules2", ",", "sym"}], 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"32d8d45d-ad02-4763-8324-e0356a331db8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v_", "]"}], "[", "expr_", "]"}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{"MapAt", "[", 
    RowBox[{
     RowBox[{"LieD", "[", "v", "]"}], ",", 
     RowBox[{"SymmetryOf", "[", 
      RowBox[{"expr", ",", "options"}], "]"}], ",", "2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ParamD", "[", "ps__", "]"}], "[", "expr_", "]"}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{"MapAt", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", "ps", "]"}], ",", 
     RowBox[{"SymmetryOf", "[", 
      RowBox[{"expr", ",", "options"}], "]"}], ",", "2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{"OverDot", "[", "expr_", "]"}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"MapAt", "[", 
    RowBox[{"OverDot", ",", 
     RowBox[{"SymmetryOf", "[", 
      RowBox[{"expr", ",", "options"}], "]"}], ",", "2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
      RowBox[{"expr_", ",", "z___"}], "]"}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"symmetryz", "[", 
    RowBox[{
     RowBox[{"MapAt", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ih", "[", 
         RowBox[{"#", ",", "z"}], "]"}], "&"}], ",", 
       RowBox[{"SymmetryOf", "[", 
        RowBox[{"expr", ",", "options"}], "]"}], ",", "2"}], "]"}], ",", 
     RowBox[{"{", "z", "}"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f86c6f09-7956-47a9-a8d0-552aadc572f0"],

Cell["Even simpler cases with no symmetry:", \
"Text",ExpressionUUID->"60143454-f7ca-49ec-805e-66f701f92830"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{"x_Scalar", ",", "options___"}], "]"}], ":=", 
   RowBox[{"EmptySymmetry", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{"x", ":", 
      RowBox[{
       RowBox[{"_", "?", "ScalarFunctionQ"}], "[", "___", "]"}]}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{"EmptySymmetry", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{"x", ":", 
      RowBox[{
       RowBox[{
        RowBox[{"Derivative", "[", "ders__", "]"}], "[", 
        RowBox[{"_", "?", "ScalarFunctionQ"}], "]"}], "[", "__", "]"}]}], ",",
      "options___"}], "]"}], ":=", 
   RowBox[{"EmptySymmetry", "[", "x", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bbe689df-ea60-46e4-a00f-94a253ed0212"],

Cell["\<\
4.- If we can remove non-indexed-scalars (note that we use NonIndexedScalarQ \
instead of ScalarQ), we do it (I thank Guillaume Faye for detecting that this \
was missing):\
\>", "Text",ExpressionUUID->"62d7798e-d07a-4b5d-b844-e8ab06b4ef25"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f_Symbol", "/;", 
        RowBox[{"f", "===", "Times"}]}], ")"}], "[", 
      RowBox[{"x___", ",", 
       RowBox[{"y_", "?", "NonIndexedScalarQ"}], ",", "z___"}], "]"}], ",", 
     "options___"}], "]"}], ":=", 
   RowBox[{"MapAt", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{"y", ",", "#"}], "]"}], "&"}], ",", 
     RowBox[{"SymmetryOf", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{"x", ",", "z"}], "]"}], ",", "options"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{"x", ":", 
      RowBox[{"Plus", "[", 
       RowBox[{"__", "?", "NonIndexedScalarQ"}], "]"}]}], ",", "options___"}],
     "]"}], ":=", 
   RowBox[{"EmptySymmetry", "[", "x", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4ac66eba-9435-4059-9fc2-10ce81a98667"],

Cell["\<\
Note: I have found that the NonIndexedScalarQ check in products takes very \
long with expressions having many factors (I have seen more than 58000 checks \
in an expression with 10 factors, with 226 Mbytes of Trace). Something must \
be done here.\
\>", "Text",ExpressionUUID->"e99802bd-d920-4d9f-973c-80f0364d7a11"],

Cell["5.- Products:", \
"Text",ExpressionUUID->"55f4861a-321f-4c76-95c2-bea3c40c92e7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"VerbatimProduct", "|", "CommutingObjects"}], ")"}], "[", 
        "prod_", "]"}], "[", "___", "]"}]}], ",", "options___"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"SymmetryOfVerbatimProduct", "[", 
    RowBox[{"expr", ",", "options"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"012026ea-afa8-4fe9-8856-6bf267922f30"],

Cell["6.- Objects", \
"Text",ExpressionUUID->"b98ea9ba-787a-4f51-9c69-30b0f8cacbe3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{"expr_Object", ",", "options___"}], "]"}], ":=", 
   RowBox[{"SymmetryOfObject", "[", 
    RowBox[{"expr", ",", "options"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"785de52c-52a7-4ef9-a79b-899bb2270109"],

Cell["\<\
7.- This is the main definition for SymmetryOf, for product objects. We need \
to sort the tensors first. Note the use of MahtInputExpand before xSort.\
\>", "Text",ExpressionUUID->"64332042-7a4e-457a-b269-a5829e42e19e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{"expr_", ",", "options___"}], "]"}], ":=", 
   RowBox[{"SymmetryOfObject", "[", 
    RowBox[{
     RowBox[{"xSort", "@", 
      RowBox[{"MathInputExpand", "[", "expr", "]"}]}], ",", "options"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9f6aca72-0588-4a83-b1ea-216d18eac165"],

Cell["\<\
If the resulting expression has head Plus, throw an error (QUESTION: what \
else could we do?):\
\>", "Text",ExpressionUUID->"a2e2fba8-989c-414b-8be5-e6f74492e1da"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOf", "[", 
    RowBox[{"expr_Plus", ",", "options___"}], "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SymmetryOf", "::", "nouse"}], ",", "\"\<SymmetryOf\>\"", ",", 
      "expr"}], "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a4ec152e-b899-4fc8-876d-9da962ef5da8"],

Cell["There are no more definitions for SymmetryOf:", \
"Text",ExpressionUUID->"2f2d5ee8-8f9d-47dd-9177-ab473bff0b20"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"SymmetryOf", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "SymmetryOf", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bc8b4959-ae48-4fcc-be55-f49ee2c1d04d"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.4. Symmetry of products. CommutingObjects", \
"Subsubsection",ExpressionUUID->"25cadec9-b60b-4f40-822b-30b7f686d40f"],

Cell["\<\
This function joins two Symmetry objects. Note that slots of the first \
Symmetry are kept and slots of the second are shifted n1 places. The \
resulting second argument of Symmetry has head VerbatimProduct[prod].\
\>", "Text",ExpressionUUID->"bdf713bf-a103-4d75-bd6f-2c738f198208"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"JoinExprs", "[", "prod_", "]"}], "[", 
    RowBox[{"Null", ",", "expr2_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"VerbatimProduct", "[", "prod", "]"}], "[", "expr2", "]"}], ",",
      "1", ",", 
     RowBox[{"VerbatimProduct", "[", "prod", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"JoinExprs", "[", "prod_", "]"}], "[", 
    RowBox[{"expr1_", ",", "expr2_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"VerbatimProduct", "[", "prod", "]"}], "[", 
      RowBox[{"expr1", ",", "expr2"}], "]"}], ",", "1", ",", 
     RowBox[{"VerbatimProduct", "[", "prod", "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7c7963c1-6f8f-4f2d-adb8-a8b03e61ebfd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"JoinSymmetries", "[", "prod_", "]"}], "[", 
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{"n1_", ",", "expr1_", ",", "rules1_", ",", "SGS1_"}], "]"}], 
     ",", 
     RowBox[{"Symmetry", "[", 
      RowBox[{"n2_", ",", "expr2_", ",", "rules2_", ",", "SGS2_"}], "]"}]}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Symmetry", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"n1", "+", "n2"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"JoinExprs", "[", "prod", "]"}], "[", 
      RowBox[{"expr1", ",", 
       RowBox[{"DisplaceSlots", "[", 
        RowBox[{"expr2", ",", "n1"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Join", "[", 
      RowBox[{"rules1", ",", 
       RowBox[{"DisplaceSlots", "[", 
        RowBox[{"rules2", ",", "n1"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"JoinSGS", "[", 
      RowBox[{"SGS1", ",", 
       RowBox[{"DisplaceSlots", "[", 
        RowBox[{"SGS2", ",", "n1"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"62fab47c-3604-40bc-9198-c63e2b664fa5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOfVerbatimProduct", "[", 
    RowBox[{
     RowBox[{"expr", ":", 
      RowBox[{
       RowBox[{"VerbatimProduct", "[", "prod_", "]"}], "[", "___", "]"}]}], 
     ",", "options___"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{"JoinSymmetries", "[", "prod", "]"}], ",", 
     RowBox[{"EmptySymmetry", "[", "Null", "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"SymmetryOf", "[", 
        RowBox[{"#", ",", "options"}], "]"}], "&"}], "/@", 
      RowBox[{"List", "@@", "expr"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ab9f826a-ab6f-4580-865d-7d72dd7b38e8"],

Cell["Example:", \
"Text",ExpressionUUID->"01c6542b-c717-45fd-8592-aa0680010d79"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"JoinSymmetries", "[", "Times", "]"}], "[", 
  RowBox[{
   RowBox[{"Symmetry", "[", 
    RowBox[{"2", ",", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"slot", "[", "1", "]"}], ",", 
       RowBox[{"slot", "[", "2", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"slot", "[", "1", "]"}], "\[Rule]", "A"}], ",", 
       RowBox[{
        RowBox[{"slot", "[", "2", "]"}], "\[Rule]", "B"}]}], "}"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"GenSet", "[", 
        RowBox[{"xAct`xPerm`Cycles", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], "]"}], "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"Symmetry", "[", 
    RowBox[{"3", ",", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"slot", "[", "1", "]"}], ",", 
       RowBox[{"slot", "[", "2", "]"}], ",", 
       RowBox[{"slot", "[", "3", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"slot", "[", "1", "]"}], "\[Rule]", "C"}], ",", 
       RowBox[{
        RowBox[{"slot", "[", "2", "]"}], "\[Rule]", "D"}], ",", 
       RowBox[{
        RowBox[{"slot", "[", "3", "]"}], "\[Rule]", "F"}]}], "}"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"GenSet", "[", 
        RowBox[{"xAct`xPerm`Cycles", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}]}], "]"}]}], 
    "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d941bc6e-3260-414b-9ebf-842f209e141d"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"5", ",", 
   RowBox[{
    RowBox[{"(", 
     TagBox[
      TooltipBox[
       UnderscriptBox["Times", "_"],
       RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
      #& ], ")"}], "[", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"\<\"\[FilledCircle]1\"\>", ",", "\<\"\[FilledCircle]2\"\>"}], 
      "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"\<\"\[FilledCircle]3\"\>", ",", "\<\"\[FilledCircle]4\"\>", 
       ",", "\<\"\[FilledCircle]5\"\>"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "A"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "C"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", "F"}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "1", ",", "2", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "3", ",", "4", ",", "5", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{3, 4, 5}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"98359768-d8f8-4daa-8b10-8dc3332ba8a2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"A", ",", "B", ",", "F", ",", "T"}], 
  "]"}]], "Input",ExpressionUUID->"f9823eb7-002e-4d75-8562-0c6e4f2eb604"],

Cell["\<\
We call commuting tensors to those tensors in a monomial having 
\t1) same name and same derivatives, 
\t2) same number of indices, 
\t3) same number of free indices of the monomial and 
\t4) all free indices at the symmetrizable positions. In particular, if the \
tensor doesn't have symmetries, no free index is allowed. Why? QUESTION.
These tensors can be permuted among them and therefore give new base \
permutations, appart from those coming from the indices of the tensors.

Repair CommutingObjects because only if free indices are in symmetrizable \
positions the tensors are commuting. This is not currently taken into \
account. That means that if a tensor does not have symmetries then we do not \
need to take commuting issues into account. QUESTION: ???\
\>", "Text",ExpressionUUID->"f4c321e5-7883-44e8-8c72-21db583c30fd"],

Cell["\<\
We need to combine both the symmetries of the objects themselves with the \
symmetries obtained by commutation, or any other symmetry of the product. \
There are nstotal indices, with tensors having ns indices (hence ns must be a \
divisor of nstotal):\
\>", "Text",ExpressionUUID->"b082ad3b-283e-47b9-b107-d9da42271628"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CommutingCycles", "[", 
    RowBox[{"sign_", ",", "ns_Integer", ",", "ns_Integer"}], "]"}], ":=", 
   RowBox[{"GenSet", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CommutingCycles", "[", 
    RowBox[{"0", ",", "nstotal_Integer", ",", "ns_Integer"}], "]"}], ":=", 
   RowBox[{"GenSet", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CommutingCycles", "[", 
    RowBox[{"sign_", ",", "nstotal_Integer", ",", "ns_Integer"}], "]"}], ":=", 
   RowBox[{"Join", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CommutingCycles", "[", 
      RowBox[{"sign", ",", 
       RowBox[{"nstotal", "-", "ns"}], ",", "ns"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"GenSet", "[", "\[IndentingNewLine]", 
      RowBox[{"sign", " ", 
       RowBox[{"xAct`xPerm`Cycles", "@@", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"nstotal", "-", 
              RowBox[{"2", "ns"}], "+", "1"}], ",", 
             RowBox[{"nstotal", "-", "ns"}]}], "]"}], ",", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"nstotal", "-", "ns", "+", "1"}], ",", "nstotal"}], 
            "]"}]}], "}"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"7864b399-2bbe-42cc-b9ef-ef62876eda07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CommutingCycles", "[", 
  RowBox[{"1", ",", "2", ",", "1"}], 
  "]"}]], "Input",ExpressionUUID->"df2395b4-6622-4d19-811c-04114c37a65b"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  InterpretationBox[
   StyleBox[
    RowBox[{"(", "1", ",", "2", ")"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xPerm`Cycles[{1, 2}],
   Editable->False], 
  "]"}]], "Output",ExpressionUUID->"46f13a72-2dd9-4dc8-bfe5-91b16e09beb9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CommutingCycles", "[", 
  RowBox[{"1", ",", "6", ",", "2"}], 
  "]"}]], "Input",ExpressionUUID->"0fe9b19a-f94c-4e23-a548-d8a7c731c90b"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      RowBox[{"(", "1", ",", "3", ")"}], 
      RowBox[{"(", "2", ",", "4", ")"}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{1, 3}, {2, 4}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      RowBox[{"(", "3", ",", "5", ")"}], 
      RowBox[{"(", "4", ",", "6", ")"}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xPerm`Cycles[{3, 5}, {4, 6}],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"633a38d4-f69e-4d5b-9d6f-85680bb45a12"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CommutingCycles", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", "6", ",", "2"}], 
  "]"}]], "Input",ExpressionUUID->"78c5cf39-84a9-4397-bb56-1a13aaf0409e"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{"-", 
      RowBox[{"(", "1", ",", "3", ")"}], 
      RowBox[{"(", "2", ",", "4", ")"}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    -xAct`xPerm`Cycles[{1, 3}, {2, 4}],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"-", 
      RowBox[{"(", "3", ",", "5", ")"}], 
      RowBox[{"(", "4", ",", "6", ")"}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    -xAct`xPerm`Cycles[{3, 5}, {4, 6}],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"780dcb72-e608-4f72-84f0-cc54da4bb6c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CommutingCycles", "[", 
  RowBox[{"1", ",", "6", ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"1381b099-f421-4f5e-a3f3-d3f6158f5164"],

Cell[BoxData[
 RowBox[{"GenSet", "[", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     RowBox[{"(", "1", ",", "4", ")"}], 
     RowBox[{"(", "2", ",", "5", ")"}], 
     RowBox[{"(", "3", ",", "6", ")"}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xPerm`Cycles[{1, 4}, {2, 5}, {3, 6}],
   Editable->False], 
  "]"}]], "Output",ExpressionUUID->"ca3ad813-0d62-4ea6-b46b-6ffed17bee47"]
}, Open  ]],

Cell["\<\
Then we have commuting objects: here we need to combine both the symmetries \
of the objects themselves with the symmetries obtained by commutation. We \
need to change the handling of JoinSGS when CommutingObjects is involved. The \
point is that the current command JoinSGS assumes that both sgs are disjoint \
and this is not True in that case. QUESTION: How do we know that this \
produces a SGS?\
\>", "Text",ExpressionUUID->"2e95546f-d3a8-40c1-8620-f76b2c7dd117"],

Cell["\<\
July 2011: As suggested by Thomas, the /@Drop[elements,-1] in this definition \
has been replaced by /@elements, to follow our new convention of having all \
moved points in the base.\
\>", "Text",ExpressionUUID->"391cc613-d75f-40d1-a07f-f6eb04a7bb4c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"JoinSGSCommuting", "[", 
    RowBox[{"sign_", ",", "SGS_", ",", "0", ",", "0"}], "]"}], ":=", "SGS"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"JoinSGSCommuting", "[", 
    RowBox[{"sign_", ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{"base_", ",", "gs_"}], "]"}], ",", "nstotal_", ",", "ns_"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cycles", "=", 
        RowBox[{"CommutingCycles", "[", 
         RowBox[{"sign", ",", "nstotal", ",", "ns"}], "]"}]}], ",", 
       RowBox[{"elements", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Range", "[", "nstotal", "]"}], ",", "ns"}], "]"}]}], ",", 
       RowBox[{"newbase", "=", "base"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"FreeQ", "[", 
           RowBox[{"base", ",", 
            RowBox[{"Alternatives", "@@", "#"}]}], "]"}], ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"newbase", ",", 
            RowBox[{"First", "[", "#", "]"}]}], "]"}]}], "]"}], "&"}], "/@", 
       "elements"}], ";", "\[IndentingNewLine]", 
      RowBox[{"StrongGenSet", "[", 
       RowBox[{"newbase", ",", 
        RowBox[{"Join", "[", 
         RowBox[{"gs", ",", "cycles"}], "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"6af6126d-1f6d-42c1-9b8e-53d3945c9b40"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"JoinSGSCommuting", "[", 
  RowBox[{"1", ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "7"}], "}"}], ",", 
     RowBox[{"GenSet", "[", "]"}]}], "]"}], ",", "12", ",", "2"}], 
  "]"}]], "Input",ExpressionUUID->"66d521fd-3f72-42cb-aa2c-33c7a1949005"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "5", ",", "7", ",", "9", ",", "11"}], "}"}], 
   ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "1", ",", "3", ")"}], 
        RowBox[{"(", "2", ",", "4", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{1, 3}, {2, 4}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "3", ",", "5", ")"}], 
        RowBox[{"(", "4", ",", "6", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{3, 5}, {4, 6}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "5", ",", "7", ")"}], 
        RowBox[{"(", "6", ",", "8", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{5, 7}, {6, 8}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "7", ",", "9", ")"}], 
        RowBox[{"(", "8", ",", "10", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{7, 9}, {8, 10}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "9", ",", "11", ")"}], 
        RowBox[{"(", "10", ",", "12", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{9, 11}, {10, 12}],
      Editable->False]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"a840e208-2cd2-4c48-9ef0-37a393a513f4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOfVerbatimProduct", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CommutingObjects", "[", "prod_", "]"}], "[", "exprs__", "]"}], 
     ",", "options___"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"no", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"{", "exprs", "}"}], "]"}]}], ",", "nstotal", ",", "sym", 
       ",", "SGS", ",", "sign"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "Construct", " ", "Symmetry", " ", "object", " ", "apart", " ", "from", 
       " ", "generating", " ", "set"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sym", "=", 
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{"JoinSymmetries", "[", "prod", "]"}], ",", 
         RowBox[{"EmptySymmetry", "[", "Null", "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"SymmetryOf", "[", 
            RowBox[{"#", ",", "options"}], "]"}], "&"}], "/@", 
          RowBox[{"{", "exprs", "}"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Number", " ", "of", " ", "slots", " ", "in", " ", "the", " ", 
        "expression"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"nstotal", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"sym", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"(*", " ", 
       RowBox[{"New", " ", "generating", " ", "set"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"SGS", "=", 
       RowBox[{"SGSofsym", "[", 
        RowBox[{"Last", "[", "sym", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sign", "=", 
       RowBox[{
        RowBox[{"CommutativitySign", "[", 
         RowBox[{"prod", ",", 
          RowBox[{"CommutativityOfProduct", "[", "prod", "]"}]}], "]"}], "@@", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"{", "exprs", "}"}], ",", "2"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"sign", "=!=", "0"}], ",", 
        RowBox[{"SGS", "=", 
         RowBox[{"JoinSGSCommuting", "[", 
          RowBox[{"sign", ",", "SGS", ",", "nstotal", ",", 
           RowBox[{"nstotal", "/", "no"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"New", " ", "Symmetry", " ", "object"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"ReplacePart", "[", 
       RowBox[{"sym", ",", "SGS", ",", 
        RowBox[{"{", "4", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"dec7bc51-3c74-4cb5-97aa-7e909d8b2521"],

Cell["\<\
We need to worry about \"equal indices\": labels, directions and \
integer-basis indices. We need to add some additional symmetries. TODO.\
\>", "Text",ExpressionUUID->"5d573fef-17e3-4d70-a946-d620cf30c367"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.5. Derivatives", \
"Subsubsection",ExpressionUUID->"18dc0c12-0ce9-4dbb-ab5d-b2fe68af5f52"],

Cell["\<\
SymmetryOf calls CovDSymmetryOf on covds, which appends all covds to the \
Symmetry expression of the internal (non-covd) argument. This is then passed \
to AD.\
\>", "Text",ExpressionUUID->"ec0f709f-46a7-4465-98fb-b85a01bd4a8f"],

Cell["\<\
At this point we assume that covariant derivatives do not add symmetries to \
expressions. It actually happens sometimes (for example CD[-a][v[-b]] is \
symmetric if v[-b] is a gradient). Apart from a single case below (two \
non-torsion derivatives of a scalar) this is left to the user... We simply \
enlarge the list of derivative indices. Note that more internal derivatives \
are prepended, and not appended; that means that more internal derivatives \
come first in the list:\
\>", "Text",ExpressionUUID->"a36f53d9-ee3c-4829-b25e-9db7e6348a6d"],

Cell["\<\
Jul 2008: These functions have been generalized to deal with multi-index \
derivatives.\
\>", "Text",ExpressionUUID->"e98ead08-ec2a-4756-bbd9-82668c6e11a9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CovDSymmetryOf", "[", "cds__", "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "?", "CovDQ"}], "[", "ind__", "]"}], "[", "expr_", 
     "]"}], ",", "options___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"CovDSymmetryOf", "[", 
    RowBox[{
     RowBox[{"covd", "[", "ind", "]"}], ",", "cds"}], "]"}], "[", 
   RowBox[{"expr", ",", "options"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CovDSymmetryOf", "[", "cds__", "]"}], "[", 
   RowBox[{"expr_", ",", "options___"}], "]"}], ":=", 
  RowBox[{"AD", "[", 
   RowBox[{
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"SymmetryOf", "[", 
       RowBox[{"expr", ",", "options"}], "]"}], ",", 
      RowBox[{"CovDTMP", "[", "cds", "]"}]}], "]"}], ",", "options"}], 
   "]"}]}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"e3f1f36c-44e2-400d-b1e1-b9a395f74963"],

Cell[TextData[{
 "Now comes one of the trickiest parts of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ": the handling of the symmetries associated to derivatives. Notes:\n\t- \
Only PDs are commuted. Other derivatives are left untouched, even if they \
have been defined as commuting. In that case the functions CommuteCovDs and \
SortCovDs must be used.\n\t- Only covariant PDs are commuted, unless the \
option ConstantMetric is True. ConstantMetric should be obtained from the \
properties of the first metric and not from a passed option. TODO.\n\t- We \
introduce a preferred order for second derivatives (without torsion) of \
scalars. This order agrees with the **default** ordering of indices, but \
could be inconsistent with a different order.\n\t- Note the frequent check \
AIndexQ. I'm not sure what happens with other types of indices."
}], "Text",ExpressionUUID->"b9ca1bee-ebbb-4adb-a465-97aec5a913d7"],

Cell["0) Rule 0:", \
"Text",ExpressionUUID->"e0d0fb58-e5d9-4663-aae5-7bc9d7eb5908"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "If", " ", "there", " ", "are", " ", "no", " ", "more", " ", "derivatives",
     " ", "return", " ", "the", " ", "symmetry"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"AD", "[", 
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
       RowBox[{"CovDTMP", "[", "]"}]}], "]"}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"Symmetry", "[", 
    RowBox[{"n", ",", "expr", ",", "rules", ",", "SGS"}], "]"}]}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"a701181b-57da-4b95-b5d1-97c2a6532cb3"],

Cell["\<\
1) If the first (most internal) derivative contains a non-abstract index then \
cannot be commuted. Do nothing:\
\>", "Text",ExpressionUUID->"5092b8bb-9c80-478f-83a6-fd87d10acb72"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "the", " ", "first", " ", "covd", " ", "cannot", " ", 
     "commute"}], ",", " ", 
    RowBox[{"remove", " ", "it"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
        RowBox[{"CovDTMP", "[", 
         RowBox[{
          RowBox[{"covd_", "[", 
           RowBox[{"i_", "/;", 
            RowBox[{"Not", "@", 
             RowBox[{"AIndexQ", "[", "i", "]"}]}]}], "]"}], ",", "y___"}], 
         "]"}]}], "]"}], ",", "options___"}], "]"}], ":=", 
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", 
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"slot", "[", 
           RowBox[{"n", "+", "1"}], "]"}], "]"}], "[", "expr", "]"}], ",", 
        RowBox[{"Append", "[", 
         RowBox[{"rules", ",", 
          RowBox[{
           RowBox[{"slot", "[", 
            RowBox[{"n", "+", "1"}], "]"}], "\[Rule]", "i"}]}], "]"}], ",", 
        "SGS", ",", 
        RowBox[{"CovDTMP", "[", "y", "]"}]}], "]"}], ",", "options"}], 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"4baa4c25-b2c1-407c-b70c-249bc79b3017"],

Cell["\<\
    Now we know that the index of the first derivative is abstract.

2) If the first and second derivatives are different, then they cannot be \
commuted: remove the first one:\
\>", "Text",ExpressionUUID->"e5688b99-011c-4661-8e85-7ef3cd3a39c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "the", " ", "first", " ", "and", " ", "second", " ", 
     "derivatives", " ", "are", " ", "different"}], ",", " ", 
    RowBox[{"remove", " ", "the", " ", "first"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
        RowBox[{
         RowBox[{"CovDTMP", "[", 
          RowBox[{
           RowBox[{"covd1_", "[", "i1_", "]"}], ",", 
           RowBox[{"covd2_", "[", "i2_", "]"}], ",", "y___"}], "]"}], "/;", 
         RowBox[{"covd1", "=!=", "covd2"}]}]}], "]"}], ",", "options___"}], 
     "]"}], ":=", 
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", 
        RowBox[{
         RowBox[{"covd1", "[", 
          RowBox[{"slot", "[", 
           RowBox[{"n", "+", "1"}], "]"}], "]"}], "[", "expr", "]"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{"rules", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"slot", "[", 
             RowBox[{"n", "+", "1"}], "]"}], "\[Rule]", "i1"}], "}"}]}], 
         "]"}], ",", "SGS", ",", 
        RowBox[{"CovDTMP", "[", 
         RowBox[{
          RowBox[{"covd2", "[", "i2", "]"}], ",", "y"}], "]"}]}], "]"}], ",", 
      "options"}], "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9bb55297-4ea6-40d6-9f82-9f4128ad7359"],

Cell["\<\
    Now we know that the first and second derivatives are the same and the \
first one has an abstract index.

3) If the first two derivatives coincide, have abstract indices and have \
curvature but no torsion, commute them on scalars.\
\>", "Text",ExpressionUUID->"19071081-05d7-4876-be49-8c52c9c676ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CommuteCovDsOnScalars", "=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f68166d3-754e-4951-824e-8789a23c47d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Two", " ", "equal", " ", "derivatives", " ", "with", " ", "lower", " ", 
     "abstract", " ", "indices", " ", "of", " ", "a", " ", "scalar", " ", 
     "commute", " ", "if", " ", "the", " ", "derivative", " ", "has", " ", 
     "no", " ", 
     RowBox[{"torsion", ".", " ", "We"}], " ", "check", " ", "for", " ", 
     "curvate"}], ";", " ", 
    RowBox[{
     RowBox[{"the", " ", "non"}], "-", 
     RowBox[{
     "curvature", " ", "case", " ", "is", " ", "treated", " ", "below"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
        RowBox[{"CovDTMP", "[", 
         RowBox[{
          RowBox[{"covd_", "[", 
           RowBox[{"i1_", "?", "AIndexQ"}], "]"}], ",", 
          RowBox[{"covd_", "[", 
           RowBox[{"i2_", "?", "AIndexQ"}], "]"}], ",", "y___"}], "]"}]}], 
       "]"}], ",", "options___"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstmetric", "=", 
         RowBox[{"FirstMetricOfVBundle", "[", 
          RowBox[{
           RowBox[{"VBundleOfIndex", "[", "i1", "]"}], ",", "False"}], 
          "]"}]}], ",", 
        RowBox[{"metric", "=", 
         RowBox[{"MetricOfCovD", "[", "covd", "]"}]}]}], "}"}], ",", 
      RowBox[{
       RowBox[{"AD", "[", 
        RowBox[{
         RowBox[{"Symmetry", "[", 
          RowBox[{
           RowBox[{"n", "+", "2"}], ",", 
           RowBox[{
            RowBox[{"covd", "[", 
             RowBox[{"slot", "[", 
              RowBox[{"n", "+", "2"}], "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"covd", "[", 
              RowBox[{"slot", "[", 
               RowBox[{"n", "+", "1"}], "]"}], "]"}], "[", "expr", "]"}], 
            "]"}], ",", 
           RowBox[{"Join", "[", 
            RowBox[{"rules", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"slot", "[", 
                 RowBox[{"n", "+", "1"}], "]"}], "\[Rule]", "i1"}], ",", 
               RowBox[{
                RowBox[{"slot", "[", 
                 RowBox[{"n", "+", "2"}], "]"}], "\[Rule]", "i2"}]}], "}"}]}],
             "]"}], ",", 
           RowBox[{"JoinSGS", "[", 
            RowBox[{"SGS", ",", 
             RowBox[{"SGSofsym", "@", 
              RowBox[{"Symmetric", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"n", "+", "1"}], ",", 
                 RowBox[{"n", "+", "2"}]}], "}"}], "]"}]}]}], "]"}], ",", 
           RowBox[{"CovDTMP", "[", "y", "]"}]}], "]"}], ",", "options"}], 
        "]"}], "/;", 
       RowBox[{"$CommuteCovDsOnScalars", "&&", "\[IndentingNewLine]", 
        RowBox[{"CurvatureQ", "[", "covd", "]"}], "&&", "\[IndentingNewLine]", 
        RowBox[{"Not", "@", 
         RowBox[{"TorsionQ", "[", "covd", "]"}]}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"ScalarQ", "[", 
         RowBox[{"expr", "/.", "rules"}], "]"}], "&&", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"DownIndexQ", "[", "i1", "]"}], "&&", 
           RowBox[{"DownIndexQ", "[", "i2", "]"}]}], "||", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"metric", "=!=", "Null"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"metric", "===", "firstmetric"}], " ", "||", 
              RowBox[{"MatchQ", "[", 
               RowBox[{
                RowBox[{"InducedFrom", "@", "metric"}], ",", 
                RowBox[{"{", 
                 RowBox[{"firstmetric", ",", "_"}], "}"}]}], "]"}]}], ")"}]}],
            ")"}]}], "\[IndentingNewLine]", ")"}]}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"3745656b-30c3-4a31-866a-a3a0a45ab9bc"],

Cell["\<\
    There are five ways the previous rule could be not obeyed:
\tI) the second derivative does not have an abstract index,
\tII) the derivatives do not have curvature,
\tIII) the derivatives have torsion,
\tIV) the argument is not scalar, or
\tV) the indices are contravariant and have been raised with a metric which \
is not the Levi-Civita connection of the derivative.

4) With non-scalar expressions, if the first derivative has curvature or \
torsion, do nothing:\
\>", "Text",ExpressionUUID->"c1326757-4559-4b20-9b8f-1d6df1879f73"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Other", " ", "derivatives", " ", "with", " ", "curvature", " ", "or", 
     " ", "torsion", " ", "are", " ", "not", " ", "commuted"}], ",", " ", 
    RowBox[{
     RowBox[{"even", " ", "if", " ", "they", " ", "do", " ", "commute"}], ";",
      " ", 
     RowBox[{
     "this", " ", "is", " ", "left", " ", "to", " ", "the", " ", "user"}]}]}],
    " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
        RowBox[{"CovDTMP", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"covd_", "[", "i_", "]"}], "/;", 
           RowBox[{"Or", "[", 
            RowBox[{
             RowBox[{"CurvatureQ", "[", "covd", "]"}], ",", 
             RowBox[{"TorsionQ", "[", "covd", "]"}]}], "]"}]}], ",", "y___"}],
          "]"}]}], "]"}], ",", "options___"}], "]"}], ":=", 
    RowBox[{"AD", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", 
        RowBox[{
         RowBox[{"covd", "[", 
          RowBox[{"slot", "[", 
           RowBox[{"n", "+", "1"}], "]"}], "]"}], "[", "expr", "]"}], ",", 
        RowBox[{"Append", "[", 
         RowBox[{"rules", ",", 
          RowBox[{
           RowBox[{"slot", "[", 
            RowBox[{"n", "+", "1"}], "]"}], "\[Rule]", "i"}]}], "]"}], ",", 
        "SGS", ",", 
        RowBox[{"CovDTMP", "[", "y", "]"}]}], "]"}], ",", "options"}], 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"f1b37620-5bf7-41a3-b89d-311c9e7cdeaf"],

Cell["\<\
    Now we know that the first two derivatives are the same ordinary \
derivative (no curvature and no torsion). The first one has an abstract index. 

5) There are more than one commuting derivatives. We need to worry about 3 \
possibilities: we can have several instances of the commuting derivative and \
then:
\ta) a different derivative (starting from the third derivative)
\tb) the same derivative with a non-abstract index (starting from the second \
derivative, to include case I)
\tc) nothing (starting from the second derivative; that is, we need to \
consider the case with a single \"commuting\" derivative)
    We prepare a different rule for those three cases:\
\>", "Text",ExpressionUUID->"3e76bb3a-0249-41fa-8d4f-fc028db0f4e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Drivers", " ", "for", " ", "the", " ", "three", " ", "remaining", " ", 
    "cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"AD", "[", 
      RowBox[{
       RowBox[{"Symmetry", "[", 
        RowBox[{"n_", ",", "expr_", ",", "rules_", ",", 
         RowBox[{"SGS", ":", 
          RowBox[{"StrongGenSet", "[", 
           RowBox[{"base_", ",", "GS_"}], "]"}]}], ",", 
         RowBox[{"CovDTMP", "[", 
          RowBox[{
           RowBox[{"y", ":", 
            RowBox[{
             RowBox[{"covd_", "[", 
              RowBox[{"_", "?", "AIndexQ"}], "]"}], ".."}]}], ",", 
           RowBox[{"covd1_", "[", "i_", "]"}], ",", "z___"}], "]"}]}], "]"}], 
       ",", "options___"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"ADSym", "[", 
       RowBox[{
        RowBox[{"Symmetry", "[", 
         RowBox[{"n", ",", "expr", ",", "rules", ",", "SGS", ",", 
          RowBox[{"CovDTMP", "[", "y", "]"}], ",", 
          RowBox[{"CovDTMP", "[", 
           RowBox[{
            RowBox[{"covd1", "[", "i", "]"}], ",", "z"}], "]"}]}], "]"}], ",",
         "options"}], "]"}], "/;", 
      RowBox[{"covd", "=!=", "covd1"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AD", "[", 
      RowBox[{
       RowBox[{"Symmetry", "[", 
        RowBox[{"n_", ",", "expr_", ",", "rules_", ",", 
         RowBox[{"SGS", ":", 
          RowBox[{"StrongGenSet", "[", 
           RowBox[{"base_", ",", "GS_"}], "]"}]}], ",", 
         RowBox[{"CovDTMP", "[", 
          RowBox[{
           RowBox[{"y", ":", 
            RowBox[{
             RowBox[{"covd_", "[", 
              RowBox[{"_", "?", "AIndexQ"}], "]"}], ".."}]}], ",", 
           RowBox[{"covd_", "[", 
            RowBox[{"i_", "/;", 
             RowBox[{"Not", "@", 
              RowBox[{"AIndexQ", "[", "i", "]"}]}]}], "]"}], ",", "z___"}], 
          "]"}]}], "]"}], ",", "options___"}], "]"}], ":=", 
     RowBox[{"ADSym", "[", 
      RowBox[{
       RowBox[{"Symmetry", "[", 
        RowBox[{"n", ",", "expr", ",", "rules", ",", "SGS", ",", 
         RowBox[{"CovDTMP", "[", "y", "]"}], ",", 
         RowBox[{"CovDTMP", "[", 
          RowBox[{
           RowBox[{"covd", "[", "i", "]"}], ",", "z"}], "]"}]}], "]"}], ",", 
       "options"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AD", "[", 
      RowBox[{
       RowBox[{"Symmetry", "[", 
        RowBox[{"n_", ",", "expr_", ",", "rules_", ",", 
         RowBox[{"SGS", ":", 
          RowBox[{"StrongGenSet", "[", 
           RowBox[{"base_", ",", "GS_"}], "]"}]}], ",", 
         RowBox[{"CovDTMP", "[", 
          RowBox[{"y", ":", 
           RowBox[{
            RowBox[{"covd_", "[", 
             RowBox[{"_", "?", "AIndexQ"}], "]"}], ".."}]}], "]"}]}], "]"}], 
       ",", "options___"}], "]"}], ":=", 
     RowBox[{"ADSym", "[", 
      RowBox[{
       RowBox[{"Symmetry", "[", 
        RowBox[{"n", ",", "expr", ",", "rules", ",", "SGS", ",", 
         RowBox[{"CovDTMP", "[", "y", "]"}], ",", 
         RowBox[{"CovDTMP", "[", "]"}]}], "]"}], ",", "options"}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"51921063-86e9-49e4-acc1-87e816fb721e"],

Cell["6) Multi-index case is treated trivially:", \
"Text",ExpressionUUID->"78fb5ed8-96c3-4f25-b296-f29fae0bee6a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AD", "[", 
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
       RowBox[{"CovDTMP", "[", 
        RowBox[{
         RowBox[{"covd_", "[", 
          RowBox[{"i_", ",", "is__"}], "]"}], ",", "other___"}], "]"}]}], 
      "]"}], ",", "options___"}], "]"}], ":=", 
   RowBox[{"AD", "[", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"length", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"{", 
           RowBox[{"i", ",", "is"}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"Symmetry", "[", 
        RowBox[{
         RowBox[{"n", "+", "length"}], ",", 
         RowBox[{
          RowBox[{"Apply", "[", 
           RowBox[{"covd", ",", 
            RowBox[{"slot", "/@", 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{"n", "+", "1"}], ",", 
               RowBox[{"n", "+", "length"}]}], "]"}]}]}], "]"}], "[", "expr", 
          "]"}], ",", 
         RowBox[{"Join", "[", 
          RowBox[{"rules", ",", 
           RowBox[{"MapThread", "[", 
            RowBox[{"Rule", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"slot", "/@", 
                RowBox[{"Range", "[", 
                 RowBox[{
                  RowBox[{"n", "+", "1"}], ",", 
                  RowBox[{"n", "+", "length"}]}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "is"}], "}"}]}], "}"}], ",", "1"}], "]"}]}],
           "]"}], ",", 
         RowBox[{"JoinSGS", "[", 
          RowBox[{"SGS", ",", 
           RowBox[{"DisplaceSlots", "[", 
            RowBox[{
             RowBox[{"SymmetryGroupOfCovD", "[", 
              RowBox[{"covd", "[", 
               RowBox[{"i", ",", "is"}], "]"}], "]"}], ",", "n"}], "]"}]}], 
          "]"}], ",", 
         RowBox[{"CovDTMP", "[", "other", "]"}]}], "]"}]}], "]"}], ",", 
     "options"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"53083a6a-d7d8-4499-8aea-070494520ceb"],

Cell["7) Finally,", \
"Text",ExpressionUUID->"e4b49130-e7d5-456b-bcef-7329c94c35d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "If", " ", "there", " ", "are", " ", "several", " ", "derivatives", " ", 
     "that", " ", "can", " ", "commute"}], ",", " ", 
    RowBox[{"give", " ", "GS"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ADSym", "[", 
     RowBox[{
      RowBox[{"Symmetry", "[", 
       RowBox[{"n_", ",", "expr_", ",", "rules_", ",", "SGS_", ",", 
        RowBox[{"CovDTMP", "[", "y__", "]"}], ",", 
        RowBox[{"CovDTMP", "[", "z___", "]"}]}], "]"}], ",", 
      RowBox[{"options", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "der", ",", "comPD", ",", "constmet", ",", "inds", ",", "newSGS", ",", 
        "slotrules", ",", "slots"}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"comPD", ",", "constmet"}], "}"}], "=", 
        RowBox[{"OptionValue", "[", 
         RowBox[{"SymmetryOf", ",", 
          RowBox[{"{", "options", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"CommutePDs", ",", "ConstantMetric"}], "}"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"der", "=", 
        RowBox[{"Head", "[", 
         RowBox[{"First", "[", 
          RowBox[{"{", "y", "}"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"inds", "=", 
        RowBox[{"Apply", "[", 
         RowBox[{"Identity", ",", 
          RowBox[{"IndexList", "[", "y", "]"}], ",", 
          RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"slotrules", "=", 
        RowBox[{"ToSlotRules", "[", 
         RowBox[{"n", ",", "inds"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"slots", "=", 
        RowBox[{"First", "/@", 
         RowBox[{"First", "/@", "slotrules"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"newSGS", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"comPD", "&&", 
           RowBox[{"(", 
            RowBox[{"constmet", "||", 
             RowBox[{"(", 
              RowBox[{"And", "@@", 
               RowBox[{"(", 
                RowBox[{"DownIndexQ", "/@", "inds"}], ")"}]}], ")"}]}], 
            ")"}]}], ",", 
          RowBox[{"JoinSGS", "[", 
           RowBox[{"SGS", ",", 
            RowBox[{"SGSofsym", "@", 
             RowBox[{"Symmetric", "[", "slots", "]"}]}]}], "]"}], ",", 
          "SGS"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"AD", "[", 
        RowBox[{"Symmetry", "[", 
         RowBox[{
          RowBox[{"n", "+", 
           RowBox[{"Length", "[", "inds", "]"}]}], ",", 
          RowBox[{"Last", "@", 
           RowBox[{"ComposeList", "[", 
            RowBox[{
             RowBox[{"der", "/@", 
              RowBox[{"slot", "/@", "slots"}]}], ",", "expr"}], "]"}]}], ",", 
          
          RowBox[{"Join", "[", 
           RowBox[{"rules", ",", "slotrules"}], "]"}], ",", "newSGS", ",", 
          RowBox[{"CovDTMP", "[", "z", "]"}]}], "]"}], "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8a108ab9-d732-4304-9c73-4e8b9256da9f"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.6. SymmetryOfObject", \
"Subsubsection",ExpressionUUID->"ffeb8a5d-dd55-4161-9bfc-d8eccf374e75"],

Cell["Main definition on products of objects:", \
"Text",ExpressionUUID->"791c11e4-f2b9-499e-a208-627c65ea54ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOfObject", "[", 
    RowBox[{
     RowBox[{"Object", "[", 
      RowBox[{
       RowBox[{"expr", ":", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"VerbatimProduct", "|", "CommutingObjects"}], ")"}], "[", 
          "_", "]"}], "[", "___", "]"}]}], ",", "__"}], "]"}], ",", 
     "options___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SymmetryOfVerbatimProduct", "[", 
    RowBox[{
     RowBox[{"expr", "//.", 
      RowBox[{
       RowBox[{"Object", "[", 
        RowBox[{"expr1_", ",", "__"}], "]"}], "\[RuleDelayed]", "expr1"}]}], 
     ",", "options"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"45c78e09-0d20-4548-9b27-80909a6e13d0"],

Cell["\<\
The symmetry of elementary objects (non products) is computed with SymmetyOf.\
\
\>", "Text",ExpressionUUID->"b19202c3-c804-481c-a90e-6845163d991b"],

Cell["\<\
We treat in a special way the objects with no free and no dummy indices (they \
might still have blocked indices). This is part of what the former Scalar1 \
head did in the past:\
\>", "Text",ExpressionUUID->"04e31f96-bd95-4634-9516-629e9b5ff3ec"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SimpleObjectQ", "[", 
    RowBox[{"Object", "[", 
     RowBox[{"_", ",", "_", ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"IndexList", "[", "]"}], ",", 
        RowBox[{"IndexList", "[", "]"}], ",", "_", ",", "_"}], "}"}]}], "]"}],
     "]"}], ":=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SimpleObjectQ", "[", "_", "]"}], ":=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"421e9831-96a7-4fad-a5bc-3e774617b391"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOfObject", "[", 
    RowBox[{
     RowBox[{"object", ":", 
      RowBox[{"Object", "[", 
       RowBox[{"expr_", ",", "_", ",", "_"}], "]"}]}], ",", "options___"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"SimpleObjectQ", "[", "object", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EmptySymmetry", "[", "expr", "]"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"SymmetryOf", "[", 
      RowBox[{
       RowBox[{"expr", "//.", 
        RowBox[{
         RowBox[{"Object", "[", 
          RowBox[{"expr1_", ",", "__"}], "]"}], "\[RuleDelayed]", "expr1"}]}],
        ",", "options"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"fd8bae50-77b4-4a5b-b3cd-0483e4288fb7"],

Cell["\<\
Again, we can do nothing on sums. This is needed in case the sum comes as a \
result of MathInputExpand and then xSort. ToCanonicalObject has a dedicated \
threading definition to avoid this.\
\>", "Text",ExpressionUUID->"6ed0d114-c7bb-4549-9cb7-6db3927d26a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryOfObject", "[", 
    RowBox[{
     RowBox[{"Object", "[", 
      RowBox[{"expr_VerbatimPlus", ",", "__"}], "]"}], ",", "options___"}], 
    "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SymmetryOf", "::", "nouse"}], ",", "\"\<SymmetryOf\>\"", ",", 
      RowBox[{"UxSort", "[", "expr", "]"}]}], "]"}], "]"}]}], ";"}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"be684c77-e5f4-40cb-ba9c-e3504edc86f0"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.2.7. Examples", \
"Subsubsection",ExpressionUUID->"4723153d-22fa-47a7-81a8-319f28fdefbf"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5151a54c-1dfb-4957-aafd-71c50ce16c23"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], ",", "M2", ",", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"f5f550c8-f5ef-4afa-9eb3-ae5c675dfcf7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Rie", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Rie[$CellContext`A, $CellContext`B, C, D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"38c54bfa-44cf-4043-aeac-1ff24388ca07"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "Rie", 
  "]"}]], "Input",ExpressionUUID->"2d9fd51c-d946-4e1a-98e1-e0104f3cce38"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "1", ",", "2", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{1, 2}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "3", ",", "4", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{3, 4}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "1", ",", "3", ")"}], 
        RowBox[{"(", "2", ",", "4", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{1, 3}, {2, 4}],
      Editable->False]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"f15fae32-031b-413d-8b71-843fe1d66e3d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{"Rie", "[", 
   RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7abff738-0049-4e6a-86fb-b45fcc418876"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"4", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4"},
           {" ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[
     xAct`xTensor`Private`slot[1], 
     xAct`xTensor`Private`slot[2], 
     xAct`xTensor`Private`slot[3], 
     xAct`xTensor`Private`slot[4]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"96885507-8025-4bf6-b130-ba290a7c4fa1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{"OverDot", "[", 
   RowBox[{"Rie", "[", 
    RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"ea0d6526-41f4-4c9f-813c-e5d6a9728f95"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"4", ",", 
   OverscriptBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"Rie", 
         StyleBox[GridBox[{
            {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
             "\[FilledCircle]4"},
            {" ", " ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Rie[
      xAct`xTensor`Private`slot[1], 
      xAct`xTensor`Private`slot[2], 
      xAct`xTensor`Private`slot[3], 
      xAct`xTensor`Private`slot[4]],
     Editable->False], "."], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"1baa51fc-2cd4-40ab-b0fa-eac2bb8758fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{"Rie", "[", 
      RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], "]"}], "]"}],
   "]"}]], "Input",ExpressionUUID->"1de5ac5d-2d3d-4a70-b6d5-1973fc837ec5"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"7", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4", 
            RowBox[{",", "\[FilledCircle]5"}], 
            RowBox[{",", "\[FilledCircle]6"}], 
            RowBox[{",", "\[FilledCircle]7"}]},
           {" ", " ", " ", " ", "  ", "  ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Private`slot[7]][
     xAct`xTensor`PD[
      xAct`xTensor`Private`slot[6]][
      xAct`xTensor`PD[
       xAct`xTensor`Private`slot[5]][
       $CellContext`Rie[
        xAct`xTensor`Private`slot[1], 
        xAct`xTensor`Private`slot[2], 
        xAct`xTensor`Private`slot[3], 
        xAct`xTensor`Private`slot[4]]]]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7"}], 
      "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "5", ",", "6", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{5, 6}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "6", ",", "7", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{6, 7}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"d021de25-dded-45a4-a1c7-de45bf5329ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"Rie", "[", 
       RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], "]"}], 
    "]"}], ",", 
   RowBox[{"CommutePDs", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"29c9d43f-3358-4950-8f76-372935219869"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"7", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4", 
            RowBox[{",", "\[FilledCircle]5"}], 
            RowBox[{",", "\[FilledCircle]6"}], 
            RowBox[{",", "\[FilledCircle]7"}]},
           {" ", " ", " ", " ", "  ", "  ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Private`slot[7]][
     xAct`xTensor`PD[
      xAct`xTensor`Private`slot[6]][
      xAct`xTensor`PD[
       xAct`xTensor`Private`slot[5]][
       $CellContext`Rie[
        xAct`xTensor`Private`slot[1], 
        xAct`xTensor`Private`slot[2], 
        xAct`xTensor`Private`slot[3], 
        xAct`xTensor`Private`slot[4]]]]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"6ffa90d6-5fd6-4292-b0f2-e3adb8575507"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"Dir", "@", 
     RowBox[{"Rie", "[", "Z", "]"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{"Rie", "[", 
      RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], "]"}], "]"}],
   "]"}]], "Input",ExpressionUUID->"d1a10916-f600-465f-854e-fcb48a88d37b"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"7", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4", 
            RowBox[{",", "\[FilledCircle]5"}], 
            RowBox[{",", "\[FilledCircle]6"}], 
            RowBox[{",", "\[FilledCircle]7"}]},
           {" ", " ", " ", " ", "  ", "  ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Private`slot[7]][
     xAct`xTensor`PD[
      xAct`xTensor`Private`slot[6]][
      xAct`xTensor`PD[
       xAct`xTensor`Private`slot[5]][
       $CellContext`Rie[
        xAct`xTensor`Private`slot[1], 
        xAct`xTensor`Private`slot[2], 
        xAct`xTensor`Private`slot[3], 
        xAct`xTensor`Private`slot[4]]]]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"Dir", "[", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Rie", 
            StyleBox[GridBox[{
               {"Z"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rie[$CellContext`Z],
        Editable->False], "]"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "5", ",", "6", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{5, 6}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"4eb60ebe-2896-408b-87ba-a3a8eac25c00"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "L"}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"Dir", "[", 
       RowBox[{"Rie", "[", "Z", "]"}], "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "B"}], "]"}], "[", 
      RowBox[{
       RowBox[{"PD", "[", 
        RowBox[{"-", "C"}], "]"}], "[", 
       RowBox[{"Rie", "[", 
        RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], "]"}], 
     "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e97624d6-d901-4f09-8882-98dd7a246a0f"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"9", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4", 
            RowBox[{",", "\[FilledCircle]5"}], 
            RowBox[{",", "\[FilledCircle]6"}], 
            RowBox[{",", "\[FilledCircle]7"}], 
            RowBox[{",", "\[FilledCircle]8"}], 
            RowBox[{",", "\[FilledCircle]9"}]},
           {" ", " ", " ", " ", "  ", "  ", "  ", "  ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Private`slot[9]][
     xAct`xTensor`PD[
      xAct`xTensor`Private`slot[8]][
      xAct`xTensor`PD[
       xAct`xTensor`Private`slot[7]][
       xAct`xTensor`PD[
        xAct`xTensor`Private`slot[6]][
        xAct`xTensor`PD[
         xAct`xTensor`Private`slot[5]][
         $CellContext`Rie[
          xAct`xTensor`Private`slot[1], 
          xAct`xTensor`Private`slot[2], 
          xAct`xTensor`Private`slot[3], 
          xAct`xTensor`Private`slot[4]]]]]]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"Dir", "[", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Rie", 
            StyleBox[GridBox[{
               {"Z"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rie[$CellContext`Z],
        Editable->False], "]"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]8\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]9\"\>", "\[Rule]", 
      RowBox[{"-", "L"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "8"}], 
      "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "5", ",", "6", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{5, 6}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"cb117e31-f626-449c-8ab0-f31611352b27"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", "B", "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{"Rie", "[", 
      RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], "]"}], "]"}],
   "]"}]], "Input",ExpressionUUID->"b5c8b00a-efc0-4d5a-a515-e7e4c687ff98"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"7", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4", 
            RowBox[{",", "\[FilledCircle]5"}], 
            RowBox[{",", "\[FilledCircle]6"}], 
            RowBox[{",", "\[FilledCircle]7"}]},
           {" ", " ", " ", " ", "  ", "  ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Private`slot[7]][
     xAct`xTensor`PD[
      xAct`xTensor`Private`slot[6]][
      xAct`xTensor`PD[
       xAct`xTensor`Private`slot[5]][
       $CellContext`Rie[
        xAct`xTensor`Private`slot[1], 
        xAct`xTensor`Private`slot[2], 
        xAct`xTensor`Private`slot[3], 
        xAct`xTensor`Private`slot[4]]]]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"6f06b1be-440b-4d84-a820-49d6b418c202"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", "B", "]"}], "[", 
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{"Rie", "[", 
       RowBox[{"G", ",", "F", ",", "D", ",", "K"}], "]"}], "]"}], "]"}], 
    "]"}], ",", 
   RowBox[{"ConstantMetric", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"3f16e653-9e92-4f0e-b138-0c1ed85e5fd6"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"7", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4", 
            RowBox[{",", "\[FilledCircle]5"}], 
            RowBox[{",", "\[FilledCircle]6"}], 
            RowBox[{",", "\[FilledCircle]7"}]},
           {" ", " ", " ", " ", "  ", "  ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[
     xAct`xTensor`Private`slot[7]][
     xAct`xTensor`PD[
      xAct`xTensor`Private`slot[6]][
      xAct`xTensor`PD[
       xAct`xTensor`Private`slot[5]][
       $CellContext`Rie[
        xAct`xTensor`Private`slot[1], 
        xAct`xTensor`Private`slot[2], 
        xAct`xTensor`Private`slot[3], 
        xAct`xTensor`Private`slot[4]]]]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "K"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7"}], 
      "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "5", ",", "6", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{5, 6}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "6", ",", "7", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{6, 7}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"2318a3a3-bee9-482e-ac79-f277318d84ae"]
}, Open  ]],

Cell["\<\
QUESTION: An important problem is the following: what happens when we have \
two equal Dir indices? I see two possibilities: either we uncontract first \
the directions converting the object into a generic expression, or we include \
more Commuting rules. Both possibilities seem complicated... Even more \
complicated seems what to do with basis directions. There is the same problem \
with labels.

Now I think that we need to introduce more symmetries, but in the D group, \
and not in the S group. This will be taken into account below with the \
concept of RepeatedSet.\
\>", "Text",ExpressionUUID->"ed35d78c-35f1-411d-a96c-8a29e4cfef57"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"76a74bec-16a7-470f-8c43-8fe1a5f03633"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0bfba597-5f06-4764-a0e9-553687462f6d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{"Rie", "[", 
   RowBox[{
    RowBox[{"Dir", "@", 
     RowBox[{"v", "@", "Z"}]}], ",", 
    RowBox[{"Dir", "@", 
     RowBox[{"v", "@", "Z"}]}], ",", "C", ",", "D"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"57e8ce4c-8097-4d7e-9dd2-1541d462416f"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"4", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4"},
           {" ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[
     xAct`xTensor`Private`slot[1], 
     xAct`xTensor`Private`slot[2], 
     xAct`xTensor`Private`slot[3], 
     xAct`xTensor`Private`slot[4]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", 
      RowBox[{"Dir", "[", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"Z"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`Z],
        Editable->False], "]"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", 
      RowBox[{"Dir", "[", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"Z"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`Z],
        Editable->False], "]"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "C"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "D"}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"8986044f-cafb-4c5d-a6bd-dae068620b04"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"Rie", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"a5f0d54a-5f24-449e-8128-de7dca6edddc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Rie"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`Rie],
  Editable->
   False]], "Print",ExpressionUUID->"12df8e49-22e3-4da7-89fc-8b6b0bd29532"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"c00a199c-2de5-4dfe-8208-72519229192f"]
}, Open  ]]
}, Open  ]],

Cell["More examples:", \
"Text",ExpressionUUID->"5f449b26-2bc1-4aa3-92f2-497bbd863730"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"A", ",", "B"}], "}"}], "]"}]}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "}"}], "]"}]}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  "]"}]}], "Input",ExpressionUUID->"bae2b2cd-c622-49a6-997d-ef31294d825b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e60bbec8-aa17-4f56-a6fc-8b72dcd2d3c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`UU[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b40f928-0d42-4bd4-9360-b88fbad462a0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0865ec59-d866-406c-af82-38e02ef41724"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d0ebaba8-9279-438e-a332-ade95e17c633"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ca7e066c-c2e9-4556-a3f7-b35394383534"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"81d7593c-36c1-4c12-aa94-9ce011a1bb28"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8122a803-b74f-49d1-b177-35b6859e2799"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$AbstractIndices"], \
"Input",ExpressionUUID->"8ea7ca8d-4acc-47c7-8cc8-7359f49e1674"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "G1", ",", "G2",
    ",", "G3", ",", "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", 
   ",", "f1", ",", "f2", ",", "f3"}], 
  "}"}]], "Output",ExpressionUUID->"0def2534-a076-4fd3-a678-a1d54ffb9425"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"term", "=", 
   RowBox[{"7", " ", 
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], " ", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{"B", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "G"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "F"}]}], "]"}], 
    RowBox[{"V", "[", "D", "]"}], 
    RowBox[{"V", "[", "F", "]"}], 
    RowBox[{"V", "[", "A", "]"}], 
    RowBox[{"R", "[", 
     RowBox[{
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "G1"}], ",", 
      RowBox[{"-", "G2"}], ",", 
      RowBox[{"-", "G3"}]}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"1665d9f2-98dc-48b8-a3cd-ceae465c49fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindFreeIndices", "[", 
  RowBox[{"Evaluate", "[", "term", "]"}], 
  "]"}]], "Input",ExpressionUUID->"f8afd16e-952d-4972-a683-d75fc1318442"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["{",
     FontColor->RGBColor[0, 0, 1]], 
    RowBox[{"-", "G1"}], "\<\",\"\>", 
    RowBox[{"-", "G2"}], "\<\",\"\>", 
    RowBox[{"-", "G3"}], 
    StyleBox["}",
     FontColor->RGBColor[0, 0, 1]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`IndexList[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3],
  Editable->
   False]], "Output",ExpressionUUID->"c5d1fc4a-6c81-44e3-b456-260d2861b932"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{"R", "[", 
   RowBox[{
    RowBox[{"-", "G"}], ",", 
    RowBox[{"-", "G1"}], ",", 
    RowBox[{"-", "G2"}], ",", 
    RowBox[{"-", "G3"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"b352a430-3eb3-4c63-9e36-e67687b9f52b"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"4", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"R", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4"},
           {" ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`R[
     xAct`xTensor`Private`slot[1], 
     xAct`xTensor`Private`slot[2], 
     xAct`xTensor`Private`slot[3], 
     xAct`xTensor`Private`slot[4]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", 
      RowBox[{"-", "G"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", 
      RowBox[{"-", "G1"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", 
      RowBox[{"-", "G2"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", 
      RowBox[{"-", "G3"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"2cdfc94a-a618-4f07-8350-b96c3cd45df9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{"xATP`CommutingObjects", "[", "Times", "]"}], "[", 
   RowBox[{
    RowBox[{"V", "[", "A", "]"}], ",", 
    RowBox[{"V", "[", "B", "]"}], ",", 
    RowBox[{"V", "[", "C", "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"ee76931e-df0a-43e4-9f62-69b375ce15d2"],

Cell[BoxData[
 RowBox[{"xAct`xTensor`Private`SymmetryOfObject", "[", 
  RowBox[{
   RowBox[{"(", 
    TagBox[
     TooltipBox[
      UnderscriptBox["Times", "_"],
      RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
     #& ], ")"}], "[", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`A],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`B],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[C],
     Editable->False]}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"a72c934e-94ba-475f-b569-03dbe5db080c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", "term", 
  "]"}]], "Input",ExpressionUUID->"2acce871-b130-483a-9073-1acdbedbf574"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox["7", "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{"7", ",", 
            RowBox[{"{", 
              RowBox[{"Constant", ",", "1", ",", "7"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
              $CellContext`r[], Editable -> False], "2"], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "1", ",", 
                RowBox[{"{", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "r", ",", "2"}], 
                  "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
          "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {" ", "G"},
                 {"C", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[-C, $CellContext`G],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"S", 
                 StyleBox[
                  
                  GridBox[{{" ", "G"}, {"C", " "}}, RowSpacings -> 0, 
                   ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`S[-C, $CellContext`G], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "1", ",", "S"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], "\",\"", "G", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-C, $CellContext`G], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], "\",\"", "G", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-C, $CellContext`G], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"V", 
                   StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`V[$CellContext`A],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`V[$CellContext`A], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"V", 
                   StyleBox[GridBox[{
                    {"D"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`V[D],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`V[D], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"V", 
                   StyleBox[GridBox[{
                    {"F"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`V[$CellContext`F],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`V[$CellContext`F], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`A], Editable -> False], "_"], 
                  
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[D], Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`F], Editable -> False], "_"], 
                  
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`F], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor", ",", "Tensor"}], "}"}]}],
                   "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"V", ",", "V", ",", "V"}], "}"}]}], "}"}]}], 
              "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "D", "\",\"", "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, D, $CellContext`F], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "D", "\",\"", "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, D, $CellContext`F], 
                 Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                 Editable -> False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"T", 
                   StyleBox[GridBox[{
                    {" ", " "},
                    {"A", "B"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T[-$CellContext`A, -$CellContext`B],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[-$CellContext`A, -$CellContext`B], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"T", 
                   StyleBox[GridBox[{
                    {" ", " "},
                    {"D", "F"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T[-D, -$CellContext`F],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                   "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", "4", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B, -
                  D, -$CellContext`F], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B, -
                  D, -$CellContext`F], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                 Editable -> False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"UU", 
              StyleBox[GridBox[{
                 {"B", "C"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`UU[$CellContext`B, C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"UU", 
                 StyleBox[
                  
                  GridBox[{{"B", "C"}, {" ", " "}}, RowSpacings -> 0, 
                   ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`UU[$CellContext`B, C], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "2", ",", "UU"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`B, C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`B, C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"R", 
              StyleBox[GridBox[{
                 {" ", " ", " ", " "},
                 {"G", "G1", "G2", "G3"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`R[-$CellContext`G, -$CellContext`G1, -$CellContext`G2, \
-$CellContext`G3],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"R", 
                 StyleBox[
                  
                  GridBox[{{" ", " ", " ", " "}, {"G", "G1", "G2", "G3"}}, 
                   RowSpacings -> 0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`R[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "8", ",", "R"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox["7", "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{"7", ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "1", ",", "7"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], "2"], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "r", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
               "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"S", 
                   StyleBox[
                    
                    GridBox[{{" ", "G"}, {"C", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`S[-C, $CellContext`G], Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"S", 
                    StyleBox[
                    
                    GridBox[{{" ", "G"}, {"C", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`S[-C, $CellContext`G], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "S"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], "\",\"", "G", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C, $CellContext`G], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "C"}], "\",\"", "G", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-C, $CellContext`G], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                 "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[D], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`F], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`F], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`A], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`A], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[D], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"D"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`F], Editable -> False], "_"], 
                    
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"F"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`F], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor", ",", "Tensor"}], "}"}]}],
                     "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"V", ",", "V", ",", "V"}], "}"}]}], "}"}]}], 
                   "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "D", "\",\"", "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, D, $CellContext`F],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "D", "\",\"", "F", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, D, $CellContext`F],
                     Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                 "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                    "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                    "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"D", "F"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-D, -$CellContext`F], Editable -> False], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D, -$CellContext`F], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "4", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B, -
                    D, -$CellContext`F], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], "\",\"", 
                    RowBox[{"-", "F"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B, -
                    D, -$CellContext`F], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"UU", 
                   StyleBox[
                    
                    GridBox[{{"B", "C"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`UU[$CellContext`B, C], Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"UU", 
                    StyleBox[
                    
                    GridBox[{{"B", "C"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`UU[$CellContext`B, C], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "2", ",", "UU"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B, C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B, C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"R", 
                   StyleBox[
                    
                    GridBox[{{" ", " ", " ", " "}, {"G", "G1", "G2", "G3"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`R[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"R", 
                    StyleBox[
                    
                    GridBox[{{" ", " ", " ", " "}, {"G", "G1", "G2", "G3"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`R[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "8", ",", "R"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Constant", ",", "Tensor", ",", "Tensor", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor", ",", "Tensor"}], "}"}]}],
                     "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                   "Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "64", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"7", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "r", ",", "2"}], 
                    "}"}], ",", "S", ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"V", ",", "V", ",", "V"}], "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}], ",", "UU", ",", 
                   "R"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "C"}], "\",\"", "G", "\",\"", "A", "\",\"", "D", 
               "\",\"", "F", "\",\"", 
               RowBox[{"-", "A"}], "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "D"}], "\",\"", 
               RowBox[{"-", "F"}], "\",\"", "B", "\",\"", "C", "\",\"", 
               RowBox[{"-", "G"}], "\",\"", 
               RowBox[{"-", "G1"}], "\",\"", 
               RowBox[{"-", "G2"}], "\",\"", 
               RowBox[{"-", "G3"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-C, $CellContext`G, $CellContext`A, 
             D, $CellContext`F, -$CellContext`A, -$CellContext`B, -
             D, -$CellContext`F, $CellContext`B, 
             C, -$CellContext`G, -$CellContext`G1, -$CellContext`G2, \
-$CellContext`G3], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "G1"}], "\",\"", 
               RowBox[{"-", "G2"}], "\",\"", 
               RowBox[{"-", "G3"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`G1, -$CellContext`G2, \
-$CellContext`G3], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", "\",\"", 
               RowBox[{"-", "D"}], "\",\"", "D", "\",\"", 
               RowBox[{"-", "F"}], "\",\"", "F", "\",\"", 
               RowBox[{"-", "G"}], "\",\"", "G", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B, -C, C, -D, 
             D, -$CellContext`F, $CellContext`F, -$CellContext`G, \
$CellContext`G], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"5879de65-141d-4cf0-ba1a-cbdeb933f4ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`SymmetryOfObject", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"c5e30a6d-9100-4623-8bb0-5c4134c5796e"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"15", ",", 
   RowBox[{
    RowBox[{"(", 
     TagBox[
      TooltipBox[
       UnderscriptBox["Times", "_"],
       RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
      #& ], ")"}], "[", 
    RowBox[{"7", ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {"\[FilledCircle]1", "\[FilledCircle]2"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[
       xAct`xTensor`Private`slot[1], 
       xAct`xTensor`Private`slot[2]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"\[FilledCircle]3"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[
       xAct`xTensor`Private`slot[3]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"\[FilledCircle]4"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[
       xAct`xTensor`Private`slot[4]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"\[FilledCircle]5"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[
       xAct`xTensor`Private`slot[5]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"\[FilledCircle]6", "\[FilledCircle]7"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[
       xAct`xTensor`Private`slot[6], 
       xAct`xTensor`Private`slot[7]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"\[FilledCircle]8", "\[FilledCircle]9"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[
       xAct`xTensor`Private`slot[8], 
       xAct`xTensor`Private`slot[9]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {"\[FilledCircle]10", "\[FilledCircle]11"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[
       xAct`xTensor`Private`slot[10], 
       xAct`xTensor`Private`slot[11]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"R", 
          StyleBox[GridBox[{
             {"\[FilledCircle]12", "\[FilledCircle]13", "\[FilledCircle]14", 
              "\[FilledCircle]15"},
             {" ", " ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`R[
       xAct`xTensor`Private`slot[12], 
       xAct`xTensor`Private`slot[13], 
       xAct`xTensor`Private`slot[14], 
       xAct`xTensor`Private`slot[15]],
      Editable->False]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "A"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "D"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", "F"}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]8\"\>", "\[Rule]", 
      RowBox[{"-", "D"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]9\"\>", "\[Rule]", 
      RowBox[{"-", "F"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]10\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]11\"\>", "\[Rule]", "C"}], ",", 
     RowBox[{"\<\"\[FilledCircle]12\"\>", "\[Rule]", 
      RowBox[{"-", "G"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]13\"\>", "\[Rule]", 
      RowBox[{"-", "G1"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]14\"\>", "\[Rule]", 
      RowBox[{"-", "G2"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]15\"\>", "\[Rule]", 
      RowBox[{"-", "G3"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
       "10", ",", "11", ",", "12", ",", "13", ",", "14", ",", "15"}], "}"}], 
     ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "3", ",", "4", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "4", ",", "5", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{4, 5}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "6", ",", "7", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{6, 7}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "8", ",", "9", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{8, 9}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "10", ",", "11", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{10, 11}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "12", ",", "13", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{12, 13}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "14", ",", "15", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{14, 15}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "6", ",", "8", ")"}], 
          RowBox[{"(", "7", ",", "9", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{6, 8}, {7, 9}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "12", ",", "14", ")"}], 
          RowBox[{"(", "13", ",", "15", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{12, 14}, {13, 15}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"0dff9ad8-d4da-4f40-b3ef-ff7b57bb1165"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xSort", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{"C", ",", "B"}], "]"}], 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "G1"}], ",", 
     RowBox[{"-", "G2"}], ",", 
     RowBox[{"-", "G3"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b4d4a066-f92b-4a4f-b0f2-b5d673f7e47c"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"UU", 
              StyleBox[GridBox[{
                 {"C", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`UU[C, $CellContext`B],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"UU", 
                 StyleBox[
                  
                  GridBox[{{"C", "B"}, {" ", " "}}, RowSpacings -> 0, 
                   ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`UU[C, $CellContext`B], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "2", ",", "UU"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[C, $CellContext`B], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`B, C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                   Null}, {$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"R", 
              StyleBox[GridBox[{
                 {" ", " ", " ", " "},
                 {"G", "G1", "G2", "G3"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`R[-$CellContext`G, -$CellContext`G1, -$CellContext`G2, \
-$CellContext`G3],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"R", 
                 StyleBox[
                  
                  GridBox[{{" ", " ", " ", " "}, {"G", "G1", "G2", "G3"}}, 
                   RowSpacings -> 0, ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`R[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "8", ",", "R"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, 
                   Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                 False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"UU", 
                   StyleBox[
                    
                    GridBox[{{"C", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`UU[C, $CellContext`B], Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"UU", 
                    StyleBox[
                    
                    GridBox[{{"C", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`UU[C, $CellContext`B], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "2", ",", "UU"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, $CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    "\",\"", "C", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B, C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, 
                    Null}, {$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"R", 
                   StyleBox[
                    
                    GridBox[{{" ", " ", " ", " "}, {"G", "G1", "G2", "G3"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`R[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"R", 
                    StyleBox[
                    
                    GridBox[{{" ", " ", " ", " "}, {"G", "G1", "G2", "G3"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`R[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "8", ",", "R"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "G"}], "\",\"", 
                    RowBox[{"-", "G1"}], "\",\"", 
                    RowBox[{"-", "G2"}], "\",\"", 
                    RowBox[{"-", "G3"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[-$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox["\[DoubleStruckCapitalT]M2", AutoSpacing -> 
                    False, ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "16", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{"UU", ",", "R"}], "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", "\",\"", 
               "B", "\",\"", 
               RowBox[{"-", "G"}], "\",\"", 
               RowBox[{"-", "G1"}], "\",\"", 
               RowBox[{"-", "G2"}], "\",\"", 
               RowBox[{"-", "G3"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[
            C, $CellContext`B, -$CellContext`G, -$CellContext`G1, \
-$CellContext`G2, -$CellContext`G3], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", "\",\"", 
               "C", "\",\"", 
               RowBox[{"-", "G"}], "\",\"", 
               RowBox[{"-", "G1"}], "\",\"", 
               RowBox[{"-", "G2"}], "\",\"", 
               RowBox[{"-", "G3"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`B, 
             C, -$CellContext`G, -$CellContext`G1, -$CellContext`G2, \
-$CellContext`G3], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "Null"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
              Null}, {$CellContext`TangentM2, Null}], Editable -> False]}], 
         "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"394770f2-e87b-4a26-9c45-a0d16002bb4d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{"C", ",", "B"}], "]"}], 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "G1"}], ",", 
     RowBox[{"-", "G2"}], ",", 
     RowBox[{"-", "G3"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6af7691d-a30e-46c9-8a49-dcce0737ed7b"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"6", ",", 
   RowBox[{
    RowBox[{"(", 
     TagBox[
      TooltipBox[
       UnderscriptBox["Times", "_"],
       RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
      #& ], ")"}], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {"\[FilledCircle]1", "\[FilledCircle]2"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[
       xAct`xTensor`Private`slot[1], 
       xAct`xTensor`Private`slot[2]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"R", 
          StyleBox[GridBox[{
             {"\[FilledCircle]3", "\[FilledCircle]4", "\[FilledCircle]5", 
              "\[FilledCircle]6"},
             {" ", " ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`R[
       xAct`xTensor`Private`slot[3], 
       xAct`xTensor`Private`slot[4], 
       xAct`xTensor`Private`slot[5], 
       xAct`xTensor`Private`slot[6]],
      Editable->False]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "C"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", 
      RowBox[{"-", "G"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", 
      RowBox[{"-", "G1"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "G2"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", 
      RowBox[{"-", "G3"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "5", ",", "6", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{5, 6}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "3", ",", "5", ")"}], 
          RowBox[{"(", "4", ",", "6", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{3, 5}, {4, 6}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"f52052b3-fc64-4bd7-8d9a-8f94734c4252"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{"7", " ", 
   RowBox[{
    RowBox[{"r", "[", "]"}], "^", "2"}], 
   RowBox[{"UU", "[", 
    RowBox[{"C", ",", "G3"}], "]"}], 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "G1"}], ",", 
     RowBox[{"-", "G2"}], ",", "D"}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", "G"}], "]"}], 
   RowBox[{"V", "[", "A", "]"}], 
   RowBox[{"V", "[", "B", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4cf86f57-ccc2-4b94-a993-4d5e2867b1c2"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"12", ",", 
   RowBox[{"7", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {"\[FilledCircle]1", "\[FilledCircle]2"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[
        xAct`xTensor`Private`slot[1], 
        xAct`xTensor`Private`slot[2]],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {"\[FilledCircle]3"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[
        xAct`xTensor`Private`slot[3]],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {"\[FilledCircle]4"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[
        xAct`xTensor`Private`slot[4]],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"\[FilledCircle]5", "\[FilledCircle]6"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[
        xAct`xTensor`Private`slot[5], 
        xAct`xTensor`Private`slot[6]],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"UU", 
           StyleBox[GridBox[{
              {"\[FilledCircle]7", "\[FilledCircle]8"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`UU[
        xAct`xTensor`Private`slot[7], 
        xAct`xTensor`Private`slot[8]],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"R", 
           StyleBox[GridBox[{
              {"\[FilledCircle]9", "\[FilledCircle]10", "\[FilledCircle]11", 
               "\[FilledCircle]12"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`R[
        xAct`xTensor`Private`slot[9], 
        xAct`xTensor`Private`slot[10], 
        xAct`xTensor`Private`slot[11], 
        xAct`xTensor`Private`slot[12]],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", "A"}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]5\"\>", "\[Rule]", 
      RowBox[{"-", "C"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]6\"\>", "\[Rule]", "G"}], ",", 
     RowBox[{"\<\"\[FilledCircle]7\"\>", "\[Rule]", "C"}], ",", 
     RowBox[{"\<\"\[FilledCircle]8\"\>", "\[Rule]", "G3"}], ",", 
     RowBox[{"\<\"\[FilledCircle]9\"\>", "\[Rule]", 
      RowBox[{"-", "G"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]10\"\>", "\[Rule]", 
      RowBox[{"-", "G1"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]11\"\>", "\[Rule]", 
      RowBox[{"-", "G2"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]12\"\>", "\[Rule]", "D"}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
       "10", ",", "11", ",", "12"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "3", ",", "4", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"(", "5", ",", "6", ")"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{5, 6}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "7", ",", "8", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{7, 8}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "9", ",", "10", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{9, 10}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "11", ",", "12", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{11, 12}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "9", ",", "11", ")"}], 
          RowBox[{"(", "10", ",", "12", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{9, 11}, {10, 12}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"ab997d4f-54d6-429d-8477-92c2d7608743"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{
    "T", ",", "S", ",", "UU", ",", "V", ",", "R", ",", "v", ",", "r"}], 
    "}"}]}], ";"}]], \
"Input",ExpressionUUID->"538961f2-aef8-4f4d-bc1b-0524e7fb9efc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"e133db07-9b58-4af2-a4b2-8f20630d1c3c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"56fb6a43-7b17-43eb-9716-6f386e4fd001"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "UU"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`UU],
  Editable->
   False]], "Print",ExpressionUUID->"84e9732b-6f71-42eb-a89c-d252304e31b8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"ecfea37f-8bf1-4557-9dfb-987240b408aa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"e18ba4e2-4f5f-482f-a675-7415d433113b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"210b0291-e4c9-459b-bb58-96748bab7ce4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"f70a4073-f161-4a97-a6e6-48fbb25e61ad"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"term", ",", "L", ",", "Z"}], 
  "]"}]], "Input",ExpressionUUID->"4c0fbb50-8804-435e-baaf-953f9205e00e"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9c5ab439-7542-4cdb-aaf8-de4e1322147c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3. ToCanonical", \
"Subsection",ExpressionUUID->"4c0eeec4-6fc2-4573-8cc4-1a8656b2ac8f"],

Cell[CellGroupData[{

Cell["15.3.0. Comments", \
"Subsubsection",ExpressionUUID->"c6af7c57-9f38-4e6e-bbfd-d83cdffad4d5"],

Cell["\<\
ToCanonical is a function that the user can use on any kind of object. \
Therefore we must prepare it for any input.

The basic objects are:
\t- \[OpenCurlyDoubleQuote]tensors\[CloseCurlyDoubleQuote] of the form \
head[inds], including the case head[]. Indices are those given.
\t- derivatives cd[inds][expr]. Indices are those of expr and then the inds.
\t- inert heads head[expr, other]. Indices are those of expr and then any \
indices in the IndexList\[CloseCurlyQuote]s of other.
\t- products prod[expr1, expr2, ...]. Indices are those of the exprs.\
\>", "Text",ExpressionUUID->"295b645f-1a77-4b22-86fe-60c6051a8844"],

Cell["\<\
ToCanonical has two fundamental parts:

1) Sort all objects in the expression, without moving their indices. The \
index information may be used to sort them. This is performed by xSort. Now \
that we handle antisymmetric products, we might find that the result is zero. \
Beware of nested products.

2) Move the indices of the expression, without moving the tensors. The result \
may be zero due to the presence of antisymmetries.\
\>", "Text",ExpressionUUID->"8fdda946-89c8-40ae-b53c-26496a6dd9e8"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3.1. ToCanonical", \
"Subsubsection",ExpressionUUID->"6a476f6c-92bf-40b9-bbc6-19bc1b3debde"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"260b530c-c8f3-4305-812a-4a730e4fc0d6"],

Cell[BoxData[
 StyleBox["\<\"ToCanonical[expr] gives a canonical reorganization of the \
tensors and their indices in expr, according to the symmetries of tensors and \
positions of dummies and repeated indices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672931-5338953",ExpressionUUID->"57037ed6-707c-4c9d-9e64-\
06cc7ce3c6de"]
}, Open  ]],

Cell["\<\
In principle the action of ToCanonical should not introduce new dummies. \
However there is the problem of derivatives of metrics, which does introduce \
new dummies.\
\>", "Text",ExpressionUUID->"77d3dff5-4531-407e-b9c3-a5601f04a68b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ToCanonical", "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Verbose", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"UseMetricOnVBundle", "\[Rule]", "All"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"ChangeCovD", ",", 
        RowBox[{"\"\<ExpandChristoffel\>\"", "\[Rule]", "False"}]}], "}"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"MathLink", "\[RuleDelayed]", "$xpermQ"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TimeVerbose", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"647e3380-6dad-47cf-9ea1-ba8cc7805cd8"],

Cell["1.- Simplest types:", \
"Text",ExpressionUUID->"96bb6d0c-b216-49d3-adc4-8cf1fb2dc8ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"1.", " ", "ToCanonical", " ", "on", " ", 
    RowBox[{"atoms", ":", " ", "Identity"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{"x_Symbol", ",", "options___"}], "]"}], ":=", "x"}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{
         "_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
         ")"}]}], ",", "options___"}], "]"}], ":=", "x"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{"x_String", ",", "options___"}], "]"}], ":=", "x"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"50fbccda-5c2a-4cc0-bc8c-96356c9ac00b"],

Cell["\<\
2.- We minimize dummies in equations and sums, but not in lists. SameDummies \
in a sum might eliminate the sum, and so we use MapIfPlus. In order for \
SameDummies to perform its job correctly we need to be sure that the \
expression is fully expanded, and so we need MathInputExpand. For the moment \
we do not use it with equations, in which we might be trying to keep some \
particular structure. MathInputExpand can potentially be very slow so it \
might be good to offer some way to control its behaviour.\
\>", "Text",ExpressionUUID->"b254fe18-ac41-42a3-9cec-c5d41271520a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "2.", " ", "ToCanonical", " ", "is", " ", "threaded", " ", "over", " ", 
     "lists"}], ",", " ", 
    RowBox[{"equations", " ", "and", " ", "sums"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{"list_List", ",", "options___"}], "]"}], ":=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToCanonical", "[", 
         RowBox[{"#", ",", "options"}], "]"}], "&"}], ",", "list"}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{"Equal", "[", 
        RowBox[{"lhs_", ",", "rhs_"}], "]"}], ",", "options___"}], "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"Equal", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToCanonical", "[", 
           RowBox[{"#", ",", "options"}], "]"}], "&"}], ",", 
         RowBox[{"SameDummies", "[", 
          RowBox[{"{", 
           RowBox[{"lhs", ",", "rhs"}], "}"}], "]"}]}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{"expr_Plus", ",", "options___"}], "]"}], ":=", 
     RowBox[{"MapIfPlus", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToCanonical", "[", 
         RowBox[{"#", ",", "options"}], "]"}], "&"}], ",", 
       RowBox[{"SameDummies", "@", 
        RowBox[{"MathInputExpand", "[", "expr", "]"}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"54eed586-af81-4d00-9598-fbb3bbde6c51"],

Cell["\<\
3.- The action of ToCanonical on rules is a tricky point because we could \
change the structure of the LHS of a rule, maybe invalidating it. We prefer \
to leave them untouched:\
\>", "Text",ExpressionUUID->"1b6179ed-97df-438b-a92b-954aa2267833"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"3.", " ", "ToCanonical", " ", "on", " ", 
    RowBox[{"rules", ":", " ", 
     RowBox[{"do", " ", "nothing"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{"expr_Rule", ",", "options___"}], "]"}], ":=", "expr"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{"expr_RuleDelayed", ",", "options___"}], "]"}], ":=", "expr"}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ce37481b-3745-479c-9887-a1ff8686c1f8"],

Cell["\<\
4.- It is convenient to have special definitions for \"frequent and simple \
cases\".\
\>", "Text",ExpressionUUID->"b59edce0-089e-4d36-8482-5870a0d723a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"4.", " ", "Special", " ", "simple", " ", 
    RowBox[{"cases", ".", " ", "These"}], " ", "are", " ", "exceptions", " ", 
    "to", " ", "the", " ", "general", " ", "algorithm"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "]"}], ",", "options___"}],
       "]"}], ":=", 
     RowBox[{
      RowBox[{"ToCanonicalTensorHead", "[", "tensor", "]"}], "[", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "ind_", "]"}], ",", 
       "options___"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$TCOptions", "=", 
         RowBox[{"CheckOptions", "[", "options", "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToCanonicalTensorHead", "[", "tensor", "]"}], "[", 
        RowBox[{"ToCanonicalIndex", "[", "ind", "]"}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], "[", 
        RowBox[{
         RowBox[{"tensor_", "?", "xTensorQ"}], "[", "]"}], "]"}], ",", 
       "options___"}], "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"$TCOptions", "=", 
         RowBox[{"CheckOptions", "[", "options", "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"covd", "[", 
         RowBox[{"ToCanonicalIndex", "[", "ind", "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"ToCanonicalTensorHead", "[", "tensor", "]"}], "[", "]"}], 
        "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0d7606a5-4d81-4ac5-a0ad-141fdc769482"],

Cell["\<\
5.- We also give a definition to canonicalize single tensors with indices. \
Note that it avoids sorting. This calls directly ToCanonicalOne, instead of \
going through the machinery of ToCanonicalObject. When puthead gets sign=0 \
then the indices are exactly those at input and so reconstructing \
tensor@@inds does not pose any danger; it will get inmediately killed by the \
zero.\
\>", "Text",ExpressionUUID->"7489d049-5756-4f91-afd1-0b0ecf73b89d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"5.", " ", "A", " ", "single", " ", 
    RowBox[{"tensor", ".", " ", "An"}], " ", "exception", " ", "to", " ", 
    "the", " ", "general", " ", "algorithm"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds__", "]"}], ",", 
       "options___"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"t", "=", 
          RowBox[{"ToCanonicalTensorHead", "[", "tensor", "]"}]}], ",", 
         RowBox[{"newinds", "=", 
          RowBox[{"ToCanonicalIndex", "[", 
           RowBox[{"IndexList", "[", "inds", "]"}], "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"puthead", "[", "\[IndentingNewLine]", 
        RowBox[{"t", ",", "\[IndentingNewLine]", 
         RowBox[{"Sow", "[", 
          RowBox[{
           RowBox[{"ToCanonicalOne", "[", 
            RowBox[{"newinds", ",", 
             RowBox[{"Union", "[", 
              RowBox[{"UpIndex", "/@", 
               RowBox[{"TakeEPairs", "[", "newinds", "]"}]}], "]"}], ",", 
             RowBox[{"SymmetryGroupOfTensor", "[", 
              RowBox[{"t", "@@", "newinds"}], "]"}], ",", "options"}], "]"}], 
           ",", "\"\<NewIndices\>\""}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"puthead", "[", 
      RowBox[{"tensor_", ",", 
       RowBox[{"{", 
        RowBox[{"sign_", ",", "inds_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"sign", " ", 
      RowBox[{"tensor", "@@", "inds"}]}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"988aa2b6-048e-4b73-8573-e201b4c6ddc7"],

Cell["\<\
6.- All other cases. Note that we send the options to Identify through xSort. \
Once the expression has been xSorted, we shift control to ToCanonicalObject. \
This is actually the only entry point for ToCanonicalObject. Finally we \
remove all intermediate heads used during sorting.\
\>", "Text",ExpressionUUID->"63e1274d-3827-40ef-b499-2364b1b37c53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"6.", " ", "ToCanonical", " ", "on", " ", "unsorted", " ", 
     RowBox[{"expressions", ":", " ", 
      RowBox[{"apply", " ", "xSort"}]}]}], ",", " ", 
    RowBox[{"then", " ", "canonicalize"}], ",", " ", 
    RowBox[{"and", " ", "then", " ", "UxSort"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{"expr_", ",", "options___"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"UxSort", "[", "\[IndentingNewLine]", 
     RowBox[{"ToCanonicalObject", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xSort", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SameDummies", "@", 
          RowBox[{"MathInputExpand", "[", "expr", "]"}]}], ",", 
         "\[IndentingNewLine]", "options"}], "\[IndentingNewLine]", "]"}], 
       ",", "options"}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9fa53c80-3f28-4dc4-8e35-2c50faf45296"],

Cell["7.- Final definitions of ToCanonical:", \
"Text",ExpressionUUID->"cb715d44-6d8c-4186-827f-626132fd72a0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ToCanonical", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ToCanonical", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"054eb2d9-3069-40ce-9af7-f5e156496b36"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3.2. ToCanonicalTensorHead", \
"Subsubsection",ExpressionUUID->"235bc784-7186-4fb6-bed8-9bad4112cdb8"],

Cell["\<\
Now that we can have lots of information in the head of a tensor, we need a \
hook to canonicalize that information:\
\>", "Text",ExpressionUUID->"904a13d6-9a2e-41e0-aa51-bcdf0a6dd34e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Lie", " ", "brackets", " ", "of", " ", "vectors", " ", "with", " ", 
    "ultraindices"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalTensorHead", "[", 
      RowBox[{"Bracket", "[", 
       RowBox[{"v1_", ",", "v2_"}], "]"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cv1", "=", 
          RowBox[{"ToCanonicalDir", "[", "v1", "]"}]}], ",", 
         RowBox[{"cv2", "=", 
          RowBox[{"ToCanonicalDir", "[", "v2", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"v1", "===", "v2"}], ",", "Zero", ",", "\[IndentingNewLine]", 
         RowBox[{"OrderedQ", "[", 
          RowBox[{"{", 
           RowBox[{"cv1", ",", "cv2"}], "}"}], "]"}], ",", 
         RowBox[{"Bracket", "[", 
          RowBox[{"cv1", ",", "cv2"}], "]"}], ",", "\[IndentingNewLine]", 
         "True", ",", 
         RowBox[{"MultiplyHead", "[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"Bracket", "[", 
            RowBox[{"cv2", ",", "cv1"}], "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Other", ".", " ", "Match"}], " ", "the", " ", "behaviour", " ", 
     "of", " ", "ToCanonical", " ", "pre1", ".1"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalTensorHead", "[", "tensor_", "]"}], ":=", "tensor"}],
     ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c95d1523-d80e-412b-8d17-aac330ebe752"],

Cell["\<\
Note how MultiplyHead acts as a (Left) ProductByScalar. This function should \
be given a more important role in the system.\
\>", "Text",ExpressionUUID->"63667cf3-6de7-47f6-9ec8-c3057834a185"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3.3. ToCanonicalObject", \
"Subsubsection",ExpressionUUID->"c57209a9-c346-433d-81f0-6fae156519bc"],

Cell["\<\
ToCanonicalObject takes the result of xSort and returns a standard expression.\
\>", "Text",ExpressionUUID->"1aa11bee-20aa-49f3-8f30-c0d20dd1c2fa"],

Cell["\<\
ToCanonicalObject is also threaded over Plus, but now without sharing dummies \
first (it has been already done). This definition is needed because the sum \
might not be explicit originally (then the rule for ToCanonical would have \
fired), but it might have been generated by the use of MathInputExpand in the \
generic definition of ToCanonical, or because there is a sum in an argument \
of a scalar function, for instance.\
\>", "Text",ExpressionUUID->"f57cbb6a-5dcd-4655-bde7-87267c512100"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonicalObject", "[", 
    RowBox[{
     RowBox[{"Object", "[", 
      RowBox[{"expr_VerbatimPlus", ",", "__"}], "]"}], ",", "options___"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"ToCanonicalObject", "[", 
      RowBox[{"#", ",", "options"}], "]"}], "&"}], "/@", "expr"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a6a76b02-909b-4678-90dd-6c1fc2a42d3c"],

Cell["\<\
Then we have all other objects. This function is more complicated than it \
should be due to the handling of derivatives. The computation of riskyders \
uses UpIndexQ and hence does not see patterns. QUESTION.\
\>", "Text",ExpressionUUID->"2f327729-1219-4eeb-9316-94b8964dc0ea"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonicalObject", "[", 
    RowBox[{"object_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"sym", "=", 
        RowBox[{"SymmetryOfObject", "[", "object", "]"}]}], ",", "verb", ",", 
       "mms", ",", "indices", ",", "dummies", ",", "vbundles", ",", 
       "newindices", ",", "riskyders", ",", "result"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"verb", ",", "mms"}], "}"}], "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"ToCanonical", ",", 
         RowBox[{"{", "options", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Verbose", ",", "UseMetricOnVBundle"}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Print", "[", 
          "\"\<***********************************************************\>\"\
", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<ToCanonical:: object: \>\"", ",", "object"}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<ToCanonical:: sym: \>\"", ",", "sym"}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"0.", " ", 
        RowBox[{"Indices", ".", " ", "Use"}], " ", "sym", " ", "and", " ", 
        "not", " ", "object", " ", "to", " ", "ensure", " ", "the", " ", 
        "right", " ", "ordering", " ", "of", " ", "indices"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"indices", "=", 
       RowBox[{"IndexList", "@@", 
        RowBox[{"(", 
         RowBox[{"Last", "/@", 
          RowBox[{"sym", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dummies", "=", 
       RowBox[{"Union", "[", 
        RowBox[{"UpIndex", "/@", 
         RowBox[{"object", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "3"}], "]"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"vbundles", "=", 
       RowBox[{"Union", "[", 
        RowBox[{"VBundleOfIndex", "/@", 
         RowBox[{"List", "@@", "indices"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"1.", " ", "Group", " ", "theory"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"newindices", "=", 
       RowBox[{"ToCanonicalOne", "[", 
        RowBox[{"indices", ",", "dummies", ",", 
         RowBox[{"sym", "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", "options"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<ToCanonical:: newindices: \>\"", ",", "newindices"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "2.", " ", "List", " ", "of", " ", "risky", " ", "derivatives", " ", 
        "on", " ", 
        RowBox[{"metrics", ".", " ", 
         RowBox[{"QUESTION", ":", " ", 
          RowBox[{"what", " ", "about", " ", 
           RowBox[{"bases", "?", " ", "And"}], " ", "inert", " ", 
           RowBox[{"heads", "?", " ", "Dietmar"}], " ", "Theiss", " ", "has", 
           " ", "reported", " ", "a", " ", "xCoba", " ", "case", " ", "in", 
           " ", "which", " ", "this", " ", "leads", " ", "to", " ", "a", " ", 
           "bug"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", 
       RowBox[{"mms", ",", "\[IndentingNewLine]", "None", ",", 
        RowBox[{"mms", "=", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "All", ",", 
        RowBox[{"mms", "=", "$VBundles"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"riskyders", "=", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Or", "[", 
          RowBox[{
           RowBox[{"!", "$MixedDers"}], ",", "\[IndentingNewLine]", 
           RowBox[{"newindices", "===", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Intersection", "[", 
             RowBox[{"vbundles", ",", "mms"}], "]"}], "===", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"UpIndexQ", "/@", "indices"}], ")"}], "===", 
            RowBox[{"(", 
             RowBox[{"UpIndexQ", "/@", 
              RowBox[{"Last", "@", "newindices"}]}], ")"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Apply", "[", 
           RowBox[{"List", ",", 
            RowBox[{"RiskyDers", "[", "object", "]"}], ",", 
            RowBox[{"{", "1", "}"}]}], "]"}], "/.", 
          RowBox[{"deronvbundle", "\[Rule]", "Sequence"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<ToCanonical:: riskyders: \>\"", ",", "riskyders"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "3.", " ", "Compute", " ", "result", " ", "from", " ", "newindices"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"result", "=", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"newindices", "===", 
          RowBox[{"{", 
           RowBox[{"0", ",", "indices"}], "}"}]}], ",", "\[IndentingNewLine]",
          "0", ",", "\[IndentingNewLine]", 
         RowBox[{"newindices", "===", 
          RowBox[{"{", 
           RowBox[{"1", ",", "indices"}], "}"}]}], ",", "\[IndentingNewLine]",
          "object", ",", "\[IndentingNewLine]", 
         RowBox[{"riskyders", "===", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Reconstruct", "[", 
          RowBox[{"sym", ",", "newindices"}], "]"}], ",", 
         "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"ToCanonical", "::", "cmods"}], ",", 
            RowBox[{"First", "/@", "riskyders"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"ToCanonicalDers", "[", 
           RowBox[{
            RowBox[{"UxSort", "[", 
             RowBox[{"Reconstruct", "[", "sym", "]"}], "]"}], ",", 
            "options"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<ToCanonical:: result: \>\"", ",", "result"}], "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"Final", " ", "result"}], ",", " ", 
        RowBox[{
        "sowing", " ", "the", " ", "list", " ", "of", " ", "indices"}]}], " ",
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Sow", "[", 
       RowBox[{"newindices", ",", "\"\<NewIndices\>\""}], "]"}], ";", 
      "\[IndentingNewLine]", "result"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "::", "cmods"}], "=", 
   "\"\<Detected metric-incompatible derivatives `1`.\>\""}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d04c6a61-6c86-48a8-8706-f3b35a0f9736"],

Cell["\<\
This simple function reconstructs our expression to its original form:\
\>", "Text",ExpressionUUID->"ef380788-ce25-4544-a109-9fef220e53f1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Reconstruct", "[", 
    RowBox[{"Symmetry", "[", 
     RowBox[{"n_", ",", "smt_", ",", "slotrules_", ",", "_"}], "]"}], "]"}], ":=", 
   RowBox[{"smt", "/.", "slotrules"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Reconstruct", "[", 
    RowBox[{
     RowBox[{"Symmetry", "[", 
      RowBox[{"n_", ",", "smt_", ",", "slotrules_", ",", "_"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"sign_", ",", "perm_IndexList"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"sign", " ", "smt"}], "/.", 
    RowBox[{"Inner", "[", 
     RowBox[{"Rule", ",", 
      RowBox[{"slot", "/@", 
       RowBox[{"IndexList", "@@", 
        RowBox[{"Range", "[", "n", "]"}]}]}], ",", "perm", ",", "List"}], 
     "]"}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"502228e8-121e-45bd-a260-757f92916067"],

Cell["\<\
Note that before calling ToCanonicalDers we reconstruct the expression. The \
algorithm in ToCanonicalDers is so different that nothing is gained by \
sending the parsed form.\
\>", "Text",ExpressionUUID->"520b942d-93c0-4d87-b39b-87965e18954c"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3.4. ToCanonicalDers", \
"Subsubsection",ExpressionUUID->"95b4d490-b4e3-43e3-ab58-e70187e1987b"],

Cell["\<\
This is the main algorithm for canonicalization of expressions containing \
derivatives and non-associated metrics. The main idea is transforming all \
derivatives into the Levi-Civita connection of the first-metric of the \
vbundle, canonicalizing, and then coming back to the original derivatives. \
This trick is clearly general for covariant derivatives and Lie derivatives, \
but it's not clear to me if it is valid for parametric derivatives. Comments \
on this:
\t- Now the metrics do not depend on parameters, and therefore the problem \
does not really appear. But we want metrics to depend on parameters.
\t- There is the question of whether a parametric derivative can be converted \
into a Lie derivative along some vector field. I think a Lie derivative can \
be represented as a parametric derivative using the parameter along the \
integral curves of the vector of the Lie derivative. However, in general, a \
parametric derivative is exploring a \"dependence\" which has nothing to do \
with any manifold, and therefore we would need to extend that manifold in one \
additional dimension to construct a vector corresponding to the parametric \
derivative. This explains, for example, why all parametric derivatives are \
assumed to commute, while several Lie derivatives on the same manifold do not \
commute in general.
\t- Therefore I think that the trick of changing to the metric connection \
does not work for parametric derivatives.\
\>", "Text",ExpressionUUID->"4df020c3-cf3e-4a36-8e51-31a33d23896f"],

Cell["\<\
Note that there is an alternative algorithm in those cases in which careQ is \
True: we could transform all indices of tensors into their original heights \
contracting or separating metrics and then canonicalizing without using the \
metric. I prefer the other one because it is closer in spirit to what we do \
in general: moving indices without changing the number of metric factors. The \
problem is that it is less general and does not work for all types of \
derivatives, or even worse, for inert heads.\
\>", "Text",ExpressionUUID->"cc18d563-35bc-4635-be11-7941ec2eff72"],

Cell["\<\
Yet another possibility could be using a temporary decomposition in a frame \
in which the metric has constant coefficients, though I don't know how this \
could be implemented. Perhaps this is the way to proceed with parametric \
derivatives.\
\>", "Text",ExpressionUUID->"06562e81-aa99-41a5-b59f-53f72c8b430e"],

Cell["All functions here are private. Several steps:", \
"Text",ExpressionUUID->"3728472d-9e5a-4272-b58d-f4d76371ce33"],

Cell["\<\
0) Special inert-heads. TMPCovD is not linear to help grouping covariant \
derivatives. It is not a restriction.\
\>", "Text",ExpressionUUID->"3653c096-b1f3-4fb3-b596-1368a8aa8eed"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefInertHead", "[", 
   RowBox[{"TMPChristoffel", ",", 
    RowBox[{"LinearQ", "\[Rule]", "True"}], ",", 
    RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
    RowBox[{"DefInfo", "\[Rule]", "False"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefInertHead", "[", 
   RowBox[{"TMPCovD", ",", 
    RowBox[{"ProtectNewSymbol", "\[Rule]", "False"}], ",", 
    RowBox[{"DefInfo", "\[Rule]", "False"}], ",", 
    RowBox[{"ContractThrough", "\[Rule]", 
     RowBox[{"{", "delta", "}"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TMPCovD", "[", 
     RowBox[{"0", ",", "_"}], "]"}], ":=", "0"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "the", " ", "weight"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOf", "[", 
    RowBox[{"TMPChristoffel", "[", 
     RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], "^:=", 
   RowBox[{"WeightOf", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"WeightOf", "[", 
    RowBox[{"TMPCovD", "[", 
     RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], "^:=", 
   RowBox[{"WeightOf", "[", "expr", "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"14aa37a5-4fca-43db-8246-dd2f90d42b88"],

Cell["\<\
1) addTMPCovD transforms derivatives into metric derivatives and \
Christoffels. In principle there are no options; once we know that the \
transformation of derivatives is required for canonicalization, then we try \
to transform all derivatives.\
\>", "Text",ExpressionUUID->"e8770f7e-851d-44c2-b2c6-4028fd7817e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "One", " ", "argument", " ", "to", " ", "three", " ", "or", " ", "four", 
    " ", 
    RowBox[{"arguments", ".", " ", "Recursion"}], " ", "on", " ", 
    RowBox[{"expr", ".", " ", "Param"}], " ", "ders", " ", "not", " ", 
    "working"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"addTMPCovD", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], "[", "expr1_", 
        "]"}], "\[RuleDelayed]", 
       RowBox[{"addTMPCovD", "[", 
        RowBox[{
         RowBox[{"addTMPCovD", "[", "expr1", "]"}], ",", 
         RowBox[{"covd", "[", "ind", "]"}], ",", "CovD", ",", 
         RowBox[{"VBundleOfIndex", "[", "ind", "]"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"LieD", "[", "v_", "]"}], "[", "expr1_", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"addTMPCovD", "[", 
        RowBox[{
         RowBox[{"addTMPCovD", "[", "expr1", "]"}], ",", 
         RowBox[{"LieD", "[", "v", "]"}], ",", "LieD", ",", 
         RowBox[{"VBundleOfIndex", "[", 
          RowBox[{"Dir", "[", "v", "]"}], "]"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OverDot", "[", "expr1_", "]"}], "\[RuleDelayed]", 
       RowBox[{"addTMPCovD", "[", 
        RowBox[{
         RowBox[{"addTMPCovD", "[", "expr1", "]"}], ",", "OverDot", ",", 
         "OverDot"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"ParamD", "[", "pars__", "]"}], "[", "expr1_", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"addTMPCovD", "[", 
        RowBox[{
         RowBox[{"addTMPCovD", "[", "expr1", "]"}], ",", 
         RowBox[{"ParamD", "[", "pars", "]"}], ",", "ParamD"}], "]"}]}]}], 
     "\[IndentingNewLine]", "}"}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8114a14d-ac6b-4d9a-9e8b-96d726d92658"],

Cell["\<\
This constructs the new object. Several steps. We first add the first-metric \
of the vbundle, if any.\
\>", "Text",ExpressionUUID->"e359f5e7-c9e4-431e-8601-3a0c39b68b54"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Four", " ", "to", " ", "five", " ", 
    RowBox[{"arguments", ".", " ", "Add"}], " ", "vbundle", " ", "metric"}], 
   "  ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"addTMPCovD", "[", 
     RowBox[{"expr_", ",", "der_", ",", "type_", ",", "vbundle_"}], "]"}], ":=", 
    RowBox[{"addTMPCovD", "[", 
     RowBox[{"expr", ",", "der", ",", "type", ",", "vbundle", ",", 
      RowBox[{"FirstMetricOfVBundle", "[", 
       RowBox[{"vbundle", ",", "False"}], "]"}]}], "]"}]}], ";"}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"dbe116c7-d682-40ec-aa54-674d368ab159"],

Cell["\<\
We need to add a mark in the derivatives to pinpoint those cases which must \
be transformed back (there could be metric-derivatives of the user in the \
expression, and those do not have to be transformed back). On the other hand \
we need to store somewhere the name of the old derivative to which we need to \
go back. We use the already defined TMPCovD, which stores as a second \
argument the original derivative.\
\>", "Text",ExpressionUUID->"1965bed3-f7a6-4e64-8d06-e4e32b8e46bc"],

Cell["\<\
The expr here is assumed to have only covdofmetric, and not any other \
covariant derivative, but can be a sum of terms and can have metrics. Note \
that we use changeCovD, which implements its own recursion, different and \
additional to that of addTMPCovD. Note also that we **do not** use the \
TMPChristoffel head at this step.\
\>", "Text",ExpressionUUID->"c1670bf3-be91-4d0d-866d-159dd10d6c34"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "If", " ", "there", " ", "is", " ", "no", " ", "metric", " ", "in", " ", 
    "the", " ", "vbundle", " ", "do", " ", "not", " ", "change", " ", 
    "derivative"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"addTMPCovD", "[", 
      RowBox[{"expr_", ",", "der_", ",", "_", ",", "_", ",", "Null"}], "]"}], 
     ":=", 
     RowBox[{"der", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Covariant", " ", 
     RowBox[{"derivatives", ".", " ", "Use"}], " ", "changeCovD", " ", 
     "adding", " ", "the", " ", "TMPCovD", " ", 
     RowBox[{"head", ".", " ", "Do"}], " ", "not", " ", "mark", " ", 
     "Christoffels"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"addTMPCovD", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"covd_", "[", "ind_", "]"}], ",", "CovD", ",", "vbundle_", ",",
        "metric_"}], "]"}], ":=", 
     RowBox[{"changeCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"covd", "[", "ind", "]"}], "[", "expr", "]"}], ",", "covd", 
       ",", 
       RowBox[{"CovDOfMetric", "[", "metric", "]"}], ",", "TMPCovD", ",", 
       "Identity"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Lie", " ", 
     RowBox[{"derivatives", ".", " ", "Add"}], " ", "the", " ", "TMPCovD", 
     " ", 
     RowBox[{"head", ".", " ", "Do"}], " ", "not", " ", "mark", " ", 
     "derivatives", " ", "of", " ", "vector", " ", "v"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"addTMPCovD", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"LieD", "[", "v_", "]"}], ",", "LieD", ",", "vbundle_", ",", 
       "metric_"}], "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ExpandLieD", "[", 
       RowBox[{"v", ",", 
        RowBox[{"CovDOfMetric", "[", "metric", "]"}], ",", "True", ",", 
        "TMPCovD"}], "]"}], "[", "expr", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9c38562c-1ced-4999-a36b-8e9c52e4e27c"],

Cell["\<\
2) Now that all derivatives are metric-compatible we apply ToCanonical, \
bringing all terms with derivatives into a canonical form.\
\>", "Text",ExpressionUUID->"d701ad9e-d505-4c30-884b-6c4f7c70b8e9"],

Cell["\<\
3) Then we need to transform back to the previous derivative, using the \
derivative stored in the TMPCovD inert-head. Now the result is marked with \
the TMPChristoffel head, pinpointing the terms which still need \
canonicalization.\
\>", "Text",ExpressionUUID->"444f6247-2440-4f71-b2ac-d7a19c17edc8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"removeTMPCovD", "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{"changeTMPCovD", "[", "expr", "]"}], "//.", 
    RowBox[{
     RowBox[{"TMPCovD", "[", 
      RowBox[{"expr1_", ",", "__"}], "]"}], "\[Rule]", "expr1"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changeTMPCovD", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"TMPCovD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], "[", "expr1_", 
        "]"}], ",", "oldcovd_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{"TMPCovD", "[", 
      RowBox[{
       RowBox[{"changeTMPCovD", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"covd", "[", "ind", "]"}], "[", 
          RowBox[{"changeTMPCovD", "@", "expr1"}], "]"}], ",", "oldcovd"}], 
        "]"}], ",", "oldcovd"}], "]"}]}]}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"db98b3ca-ad4d-4a34-8994-758489c4d8dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"changeTMPCovD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "ind_", "]"}], "[", "expr_", 
      "]"}], ",", 
     RowBox[{"oldcovd_", "?", "CovDQ"}]}], "]"}], ":=", 
   RowBox[{"changeCovD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd", "[", "ind", "]"}], "[", "expr", "]"}], ",", "covd", ",",
      "oldcovd", ",", "Identity1", ",", "TMPChristoffel"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"66e87609-aa38-4321-8f58-55899efe7349"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"changeTMPCovD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "dir_", "]"}], "[", "expr_", 
      "]"}], ",", "LieD"}], "]"}], ":=", 
   RowBox[{"CovDToLieD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd", "[", "dir", "]"}], "[", "expr", "]"}], ",", 
     "TMPChristoffel"}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"cfb4323e-606d-43be-9b45-ce61a7b1835f"],

Cell["\<\
4) We expand the expression and canonicalize (with ToCanonical) those terms \
containing a TMPChristoffel head somewhere:\
\>", "Text",ExpressionUUID->"de9b569f-966a-4a8e-9cdd-b5b393a6d07f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SecondToCanonical", "[", "expr_", "]"}], ":=", 
   RowBox[{"secondcan", "[", 
    RowBox[{"Expand", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"secondcan", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"secondcan", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"secondcan", "[", "expr_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{"expr", ",", "TMPChristoffel", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "Infinity"}], "}"}], ",", 
       RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ToCanonical", "[", 
      RowBox[{"expr", "/.", 
       RowBox[{"TMPChristoffel", "\[Rule]", "Identity"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "expr"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"a040d349-52b4-410e-90bc-f55a04ca0486"],

Cell["\<\
5) This is the final function called from ToCanonical. It calls again \
ToCanonical and hence we must be extra careful to avoid infinite recursion.\
\>", "Text",ExpressionUUID->"eb88bbfa-44dd-4731-9fd4-9c154cc28d71"],

Cell["\<\
This is an awfully complicated function, with 3 calls to ToCanonical in the \
worst case:\
\>", "Text",ExpressionUUID->"7c6097f1-e443-4c19-a5f3-cf5ca1628a21"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonicalDersChangeCovD", "[", 
    RowBox[{"expr_", ",", "method_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"verb", ",", "eC", ",", "result"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"verb", "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"ToCanonical", ",", 
         RowBox[{"{", "options", "}"}], ",", "Verbose"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"eC", "=", 
       RowBox[{
        RowBox[{"\"\<ExpandChristoffel\>\"", "/.", "method"}], "/.", 
        RowBox[{"Rest", "[", 
         RowBox[{"Method", "/.", 
          RowBox[{"Options", "[", "ToCanonical", "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"result", "=", 
       RowBox[{
        RowBox[{"Tee", "[", 
         RowBox[{"SameDummies", ",", "verb"}], "]"}], "@", 
        RowBox[{
         RowBox[{"Tee", "[", 
          RowBox[{"SecondToCanonical", ",", "verb"}], "]"}], "@", 
         RowBox[{
          RowBox[{"Tee", "[", 
           RowBox[{"removeTMPCovD", ",", "verb"}], "]"}], "@", 
          RowBox[{
           RowBox[{"Tee", "[", 
            RowBox[{"ToCanonical", ",", "verb"}], "]"}], "@", 
           RowBox[{
            RowBox[{"Tee", "[", 
             RowBox[{"addTMPCovD", ",", "verb"}], "]"}], "[", "expr", 
            "]"}]}]}]}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"eC", ",", 
        RowBox[{"ToCanonical", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"result", "//", "ChristoffelToGradMetric"}], "//", 
           "ContractMetric"}], ",", 
          RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], "]"}], ",", 
        "result"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b80bec54-d767-4d71-af18-277704cd1232"],

Cell["New, simpler function, based in a completely different idea:", \
"Text",ExpressionUUID->"7fd36b5f-3dcb-47bf-b579-183a3af52b8f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonicalDersImplode", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"verb", "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"ToCanonical", ",", 
         RowBox[{"{", "options", "}"}], ",", "Verbose"}], "]"}]}], "}"}], ",",
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ToCanonical", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Tee", "[", 
         RowBox[{"Explode", ",", "verb"}], "]"}], "@", 
        RowBox[{"ToCanonical", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Tee", "[", 
            RowBox[{"Implode", ",", "verb"}], "]"}], "[", "expr", "]"}], ",", 
          "\[IndentingNewLine]", "options"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}], ",", "options"}], 
      "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"99b70133-e36f-4bf7-89b4-05f80d6456f4"],

Cell["\<\
This is a simple tee structure to get verbose output if needed:\
\>", "Text",ExpressionUUID->"37e136fa-adc9-43b6-95e0-fe87c533fc82"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Tee", "[", 
     RowBox[{"command_", ",", "verb_"}], "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"result", "=", 
       RowBox[{"command", "[", "expr", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"command", ",", "\"\<: \>\"", ",", "result"}], "]"}]}], 
       "]"}], ";", "result"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a626d814-ea1a-4454-8bce-8a90d41f9529"],

Cell["\<\
The function ToCanonicalDers is called only by ToCanonicalObject, when the \
situation is complicated enough to require a change of canonicalization \
algorithm.\
\>", "Text",ExpressionUUID->"763fa453-017c-491e-b3da-f7203fea288c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonicalDers", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"method", "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"ToCanonical", ",", 
         RowBox[{"{", "options", "}"}], ",", "Method"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", 
      RowBox[{"method", ",", "\[IndentingNewLine]", 
       RowBox[{"ChangeCovD", "|", 
        RowBox[{"{", 
         RowBox[{"ChangeCovD", ",", "___"}], "}"}]}], ",", 
       RowBox[{"ToCanonicalDersChangeCovD", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"Rest", "@", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", "method", "}"}], "]"}]}], ",", "options"}], "]"}], 
       ",", "\[IndentingNewLine]", "Implode", ",", 
       RowBox[{"ToCanonicalDersImplode", "[", 
        RowBox[{"expr", ",", "options"}], "]"}], ",", "\[IndentingNewLine]", 
       "_", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ToCanonical", "::", "unknown"}], ",", "\"\<method\>\"", 
          ",", "method"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5202fa00-5dc7-48b9-85df-d0f58693aea5"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3.5. ToCanonicalOne: canonicalization of a set of indices", \
"Subsubsection",ExpressionUUID->"ad89e143-575b-49bd-a457-20b831176d74"],

Cell[TextData[{
 "Input:\n\t- indices: list of names of indices as they appear in the tensor. \
That is, the first index corresponds to slot 1, the second to slot 2, etc.\n\t\
- dummies: list of NAMES of dummy indices (only the up-member) in no \
particular order.\n\t- syms: generating set of the group of slot-symmetries.\n\
\t- options\nOutput: IndexList[...] or -IndexList[...] with the sorted \
indices:\n\nIt is very important to note that this is the only function in \
all of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " calling CanonicalPerm."
}], "Text",ExpressionUUID->"68946f61-1fa6-4521-8082-ebcfb41489c7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"posits", "[", "list_List", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Join", ",", 
     RowBox[{"posits", "/@", "list"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"posits", "[", 
    RowBox[{"DummySet", "[", 
     RowBox[{"_", ",", 
      RowBox[{"{", "pairs___", "}"}], ",", "_"}], "]"}], "]"}], ":=", 
   RowBox[{"Join", "[", "pairs", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"posits", "[", 
    RowBox[{"RepeatedSet", "[", "list_", "]"}], "]"}], ":=", "list"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d990d316-acf5-4a22-99b3-bfd724283254"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeDummySet", "[", 
    RowBox[{"dummies_", ",", "fm_", ",", "vbundle_"}], "]"}], ":=", 
   RowBox[{"DummySet", "[", 
    RowBox[{"vbundle", ",", 
     RowBox[{"List", "@@", 
      RowBox[{"Select", "[", 
       RowBox[{"dummies", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"VBundleOfIndex", "[", "#", "]"}], "===", "vbundle"}], 
          ")"}], "&"}]}], "]"}]}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"fm", "&&", 
        RowBox[{"MetricEndowedQ", "[", "vbundle", "]"}]}], ",", 
       RowBox[{"SymmetryOfMetric", "@", 
        RowBox[{"FirstMetricOfVBundle", "[", "vbundle", "]"}]}], ",", "0"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c3d2cca8-924b-4e4c-bdec-803ff72ba4fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$RepeatedSingletonsQ", "=", "True"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"395cbc93-dc6c-4796-8329-b878270eddc9"],

Cell["\<\
ToCanonicalOne is pretty large,even though it has many If[verb,...] \
sentences. QUESTION: When $RepeatedSingleTonsQ = True we take all blocked \
indices, and so we are not allowing for repeted b-indices. Is this a \
limitation? I cannot play for examples with tensors T[a,a], and sometimes \
that would be fine...\
\>", "Text",ExpressionUUID->"50b876e7-02fd-4a60-892c-43feffb4dd45"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonicalOne", "[", 
    RowBox[{
    "indices_IndexList", ",", "dummies_IndexList", ",", "syms_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"order", "=", 
        RowBox[{"Length", "[", "indices", "]"}]}], ",", "sortedindices", ",", 
       "perm", ",", "dummysets", ",", "frees", ",", "verb", ",", "not", ",", 
       "mms", ",", "fm", ",", "repes", ",", "newsyms"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"verb", ",", "mms"}], "}"}], "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"ToCanonical", ",", 
         RowBox[{"{", "options", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Verbose", ",", "UseMetricOnVBundle"}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Actual", " ", "configuration"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: Actual configuration: \>\"", ",", "indices"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Standard", " ", "configuration"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"sortedindices", "=", 
       RowBox[{"IndexSort", "[", "indices", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: Standard configuration: \>\"", ",", 
          "sortedindices"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Look", " ", "for", " ", "repeated", " ", "indices"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"repes", "=", 
       RowBox[{"If", "[", 
        RowBox[{"$RepeatedSingletonsQ", ",", 
         RowBox[{"Union", "@", 
          RowBox[{"TakeBlocked", "[", "indices", "]"}]}], ",", 
         RowBox[{"TakeRepeated", "[", "indices", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: Repeated indices: \>\"", ",", "repes"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"repes", "=", 
       RowBox[{"List", "@@", 
        RowBox[{"Map", "[", 
         RowBox[{"RepeatedSet", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{"IndexPosition", "[", 
              RowBox[{"sortedindices", ",", "#"}], "]"}], "]"}], "&"}], "/@", 
           "repes"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: Repeated indices: \>\"", ",", "repes"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Permutation", " ", "to", " ", "be", " ", "canonicalized"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"perm", "=", 
       RowBox[{"TranslatePerm", "[", 
        RowBox[{
         RowBox[{"PermutationFromTo", "[", 
          RowBox[{
           RowBox[{"List", "@@", "sortedindices"}], ",", 
           RowBox[{"List", "@@", "indices"}]}], "]"}], ",", "Images"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: Permutation to be canonicalized: \>\"", ",", 
          "perm"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Arrange", " ", "metric", " ", "use", " ", "on", " ", "the", " ", 
        "vbundles"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", 
       RowBox[{"mms", ",", "\[IndentingNewLine]", "All", ",", 
        RowBox[{
         RowBox[{"fm", "[", "_", "]"}], ":=", "True"}], ",", 
        "\[IndentingNewLine]", "None", ",", 
        RowBox[{
         RowBox[{"fm", "[", "_", "]"}], ":=", "False"}], ",", 
        "\[IndentingNewLine]", "_List", ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"fm", "[", "#", "]"}], ":=", "True"}], ")"}], "&"}], "/@",
           "mms"}], ";", 
         RowBox[{
          RowBox[{"fm", "[", "_", "]"}], ":=", "False"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Separate", " ", "dummies", " ", "according", " ", "to", " ", "the", 
        " ", "existing", " ", "vbundles"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<dummies: \>\"", ",", "dummies"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dummysets", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"MakeDummySet", "[", 
          RowBox[{"dummies", ",", 
           RowBox[{"fm", "[", "#", "]"}], ",", "#"}], "]"}], "&"}], "/@", 
        "$VBundles"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: dummysets_tmp: \>\"", ",", "dummysets"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Positions", " ", "of", " ", 
        RowBox[{"dummies", ".", " ", "No"}], " ", "spinorial", " ", "case", 
        " ", "considered", " ", "yet"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"dummysets", "=", 
       RowBox[{"dummysets", "/.", 
        RowBox[{
         RowBox[{"DummySet", "[", 
          RowBox[{"man_", ",", "dums_", ",", "metricQ_"}], "]"}], 
         "\[RuleDelayed]", 
         RowBox[{"DummySet", "[", 
          RowBox[{"man", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"IndexPosition", "[", 
                 RowBox[{"sortedindices", ",", "#"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"IndexPosition", "[", 
                 RowBox[{"sortedindices", ",", 
                  RowBox[{"ChangeIndex", "@", "#"}]}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], "&"}], "/@", 
            "dums"}], ",", "metricQ"}], "]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<ToCanonicalOne:: dummysets: \>\"", ",", "dummysets"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Positions", " ", "of", " ", "free", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"here", " ", "all", " ", "non"}], "-", 
          RowBox[{"dummies", " ", "or", " ", "non"}], "-", "repeated"}], 
         ")"}], " ", "indices"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"frees", "=", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Range", "@", "order"}], ",", 
         RowBox[{"posits", "[", "dummysets", "]"}], ",", 
         RowBox[{"posits", "[", "repes", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<ToCanonicalOne:: Free indices: \>\"", ",", "frees"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Add", " ", "symmetries", " ", "coming", " ", "from", " ", "1", "D", 
        " ", "vbundles"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"newsyms", "=", 
       RowBox[{"Symmetry1D", "[", 
        RowBox[{"syms", ",", 
         RowBox[{"Inner", "[", 
          RowBox[{"Rule", ",", 
           RowBox[{"slot", "/@", 
            RowBox[{"Range", "@", 
             RowBox[{"Length", "@", "indices"}]}]}], ",", 
           RowBox[{"List", "@@", "indices"}], ",", "List"}], "]"}]}], "]"}]}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"!", 
        RowBox[{"!", 
         RowBox[{"!", 
          RowBox[{"!", 
           RowBox[{"!", 
            RowBox[{"!", 
             RowBox[{"!", 
              RowBox[{"!", 
               RowBox[{"!", 
                RowBox[{"!", 
                 RowBox[{"!", 
                  RowBox[{"!", 
                   RowBox[{"!", 
                    RowBox[{"!", 
                    RowBox[{"!", 
                    RowBox[{"!", " ", 
                    RowBox[{"Invert", " ", "to", " ", "meet", " ", 
                    RowBox[{"Renato", "'"}], "s", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"notation", " ", "!!"}], "!!"}], "!!"}], "!!"}], 
                    "!!"}], "!!"}], "!!"}], 
                    "!!"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"perm", "=", 
       RowBox[{"InversePerm", "[", "perm", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Canonicalization", " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: calling: \>\"", ",", "\"\<CanonicalPerm[\>\"", 
          ",", "perm", ",", "\"\<,\>\"", ",", "order", ",", "\"\<,\>\"", ",", 
          "newsyms", ",", "\"\<,\>\"", ",", "frees", ",", "\"\<,\>\"", ",", 
          RowBox[{"Join", "[", 
           RowBox[{"dummysets", ",", "repes"}], "]"}], ",", "\"\<,\>\"", ",", 
          "options", ",", "\"\<]\>\""}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"perm", "=", 
       RowBox[{"CanonicalPerm", "[", 
        RowBox[{"perm", ",", "order", ",", "newsyms", ",", "frees", ",", 
         RowBox[{"Join", "[", 
          RowBox[{"dummysets", ",", "repes"}], "]"}], ",", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "options", "}"}], ",", 
           RowBox[{"Options", "[", "CanonicalPerm", "]"}]}], "]"}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<ToCanonicalOne:: Canonical permutation: \>\"", ",", "perm"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"!", 
        RowBox[{"!", 
         RowBox[{"!", 
          RowBox[{"!", 
           RowBox[{"!", 
            RowBox[{"!", 
             RowBox[{"!", 
              RowBox[{"!", 
               RowBox[{"!", 
                RowBox[{"!", 
                 RowBox[{"!", 
                  RowBox[{"!", 
                   RowBox[{"!", 
                    RowBox[{"!", 
                    RowBox[{"!", 
                    RowBox[{"!", " ", 
                    RowBox[{"Invert", " ", "back", " ", "to", " ", "our", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"notation", " ", "!!"}], "!!"}], "!!"}], "!!"}], 
                    "!!"}], "!!"}], "!!"}], 
                    "!!"}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"perm", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"perm", "===", "0"}], ",", "0", ",", 
         RowBox[{"InversePerm", "[", "perm", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Final", " ", 
        RowBox[{"indices", ":", " ", 
         RowBox[{"{", 
          RowBox[{"sign", ",", " ", "indexlist"}], "}"}]}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"perm", "===", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "indices"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "perm", "]"}], "===", "Times"}], ",", 
            RowBox[{"-", "1"}], ",", "1"}], "]"}], ",", 
          RowBox[{"PermuteList", "[", 
           RowBox[{"sortedindices", ",", "perm"}], "]"}]}], "}"}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c89f3777-581c-40a3-a142-6d2d3aa80dfa"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.3.6. Simplification", \
"Subsubsection",ExpressionUUID->"8d525801-040a-422c-b3e6-c6391b304e30"],

Cell["Simplification is simply ToCanonical with a Simplify:", \
"Text",ExpressionUUID->"ea018fe3-aff4-4c0a-961b-7cf6ede243e0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Simplification", "[", 
    RowBox[{"expr_", ",", "options___"}], "]"}], ":=", 
   RowBox[{"Simplify", "@", 
    RowBox[{"ToCanonical", "[", 
     RowBox[{"expr", ",", "options"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Simplification", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"3f207b34-ecfe-45e0-a3ac-3dd0b7725c74"],

Cell["\<\
We do not protect it because it will be given more definitions below.\
\>", "Text",ExpressionUUID->"4f137b39-f843-43de-bef4-f45174d8c7cd"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.4. Examples", \
"Subsection",ExpressionUUID->"26e29d3e-b0cb-45b7-9544-25dd00e2b9af"],

Cell[CellGroupData[{

Cell["15.4.1. Examples with a single tensor", \
"Subsubsection",ExpressionUUID->"e0d0fc2a-b150-4f4b-8c74-9305854cbe9f"],

Cell["Examples. First, there is no metric in M2:", \
"Text",ExpressionUUID->"496e3e61-26a5-422b-b54d-94331edb1ea3"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"ec85a165-f51f-4a77-83af-b14e10fea96f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  "]"}]], "Input",ExpressionUUID->"35eef2af-9ff2-48f1-a963-ad38797e7bfb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "argm"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(ToCanonical\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(1\\)\[NoBreak] or \
more arguments are expected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/argm\\\", ButtonNote -> \
\\\"xAct`xTensor`ToCanonical::argm\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"426e8ba0-4e4c-475c-b01c-812a60042a69"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$ContextPath"], \
"Input",ExpressionUUID->"fb1bc23d-028b-4712-852c-12cc461b453b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"xAct`xTensor`\"\>", ",", "\<\"xAct`xCore`\"\>", 
   ",", "\<\"xAct`xPerm`\"\>", ",", "\<\"System`\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"182d7d41-dd42-4191-ba4c-1780c5304bb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{"-", 
     RowBox[{"Perm", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "C"}], ",", 
        RowBox[{"-", "D"}]}], "}"}], "]"}]}], "]"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<R\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"e8d31191-366e-457a-8aeb-92e3797bfb64"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"riemannR", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`riemannR[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"47eb91fb-d1fc-41db-89c8-4a315f9509ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "D"}], ",", 
    RowBox[{"-", "C"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"1c193e23-48c1-4756-b93f-ff53d3af1103"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"A", "B", "D", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`riemannR[-$CellContext`A, -$CellContext`B, -D, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"2fbccb12-1b65-4317-93eb-ed85ab8d9036"]
}, Open  ]],

Cell["\<\
Note that this tensor is not zero because, not having a metric, the \
expression does not make sense:\
\>", "Text",ExpressionUUID->"bde6ee77-5297-4f5b-8d94-8c7ab0456712"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}], ",", "C", ",", "D"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8ec495fb-b017-4db7-be5e-33397df28c4b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {"A", " ", "C", "D"},
         {" ", "A", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[$CellContext`A, -$CellContext`A, C, D],
  Editable->
   False]], "Output",ExpressionUUID->"84b24dfa-7a58-4cf1-93b6-ae0b59a84b3b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"xATP`ValidateTensor", "[", 
   RowBox[{"riemannR", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "C", ",", "D"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"f9b8230a-c0f3-4a88-a243-17a2acbe38a2"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid character of index in tensor riemannR\
\\\"\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2762ddc3-3728-435e-99d2-1dc107adcc2c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"R", 
         StyleBox[GridBox[{
            {"A", " ", "C", "D"},
            {" ", "A", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`riemannR[$CellContext`A, -$CellContext`A, C, D],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`riemannR[$CellContext`A, -$CellContext`A, C, D]],
  Editable->
   False]], "Output",ExpressionUUID->"010a922a-f805-47ea-980d-19dcd07330e9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "riemannR", 
  "]"}]], "Input",ExpressionUUID->"1c812434-469f-4da3-9b26-ed8af294628c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "riemannR"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`riemannR],
  Editable->
   False]], "Print",ExpressionUUID->"df2058d4-3173-43b1-a434-de9a06598c8a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"8d67b6ae-863b-4465-bf06-45937c20893f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"df01e428-fae0-4fc6-bb53-8d5c6f9296d8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{"r", "[", "]"}], "]"}], "//", 
  "Trace"}]], "Input",ExpressionUUID->"974b7347-3e4e-4e3e-b4a1-0349a46c35bd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"ToCanonical", "[", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xTensorQ", "[", "r", "]"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{
     RowBox[{"xAct`xTensor`Private`ToCanonicalTensorHead", "[", "r", "]"}], 
     "[", "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xAct`xTensor`Private`ToCanonicalTensorHead", "[", "r", "]"}],
      HoldForm], ",", 
     TagBox["r",
      HoldForm]}], "}"}], ",", 
   TagBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"705e2305-87c6-49cf-9f80-bab6a4832bba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{"r", "[", "A", "]"}], "]"}], "//", 
  "Trace"}]], "Input",ExpressionUUID->"26d90878-5347-4dc3-b1a1-077d4101a216"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"ToCanonical", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"r", 
          StyleBox[GridBox[{
             {"A"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[$CellContext`A],
      Editable->False], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xTensorQ", "[", "r", "]"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"Block", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xAct`xTensor`Private`$TCOptions", "=", 
        RowBox[{"CheckOptions", "[", "]"}]}], "}"}], ",", 
      RowBox[{
       RowBox[{"xAct`xTensor`Private`ToCanonicalTensorHead", "[", "r", "]"}], 
       "[", 
       RowBox[{"xAct`xTensor`Private`ToCanonicalIndex", "[", "A", "]"}], 
       "]"}]}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"CheckOptions", "[", "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"{", "}"}],
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"xAct`xTensor`Private`$TCOptions", "=", 
       RowBox[{"{", "}"}]}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"{", "}"}],
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"xAct`xTensor`Private`ToCanonicalTensorHead", "[", "r", "]"}],
        
        HoldForm], ",", 
       TagBox["r",
        HoldForm]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       TagBox[
        RowBox[{"xAct`xTensor`Private`ToCanonicalIndex", "[", "A", "]"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"A", "/.", "\[VeryThinSpace]", 
         RowBox[{"xAct`xTensor`Private`v_Dir", "\[RuleDelayed]", 
          RowBox[{
          "xAct`xTensor`Private`ToCanonicalDir", "[", 
           "xAct`xTensor`Private`v", "]"}]}]}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"xAct`xTensor`Private`v_Dir", "\[RuleDelayed]", 
           RowBox[{
           "xAct`xTensor`Private`ToCanonicalDir", "[", 
            "xAct`xTensor`Private`v", "]"}]}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"xAct`xTensor`Private`v_Dir", "\[RuleDelayed]", 
           RowBox[{
           "xAct`xTensor`Private`ToCanonicalDir", "[", 
            "xAct`xTensor`Private`v", "]"}]}],
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"A", "/.", "\[VeryThinSpace]", 
         RowBox[{"xAct`xTensor`Private`v_Dir", "\[RuleDelayed]", 
          RowBox[{
          "xAct`xTensor`Private`ToCanonicalDir", "[", 
           "xAct`xTensor`Private`v", "]"}]}]}],
        HoldForm], ",", 
       TagBox["A",
        HoldForm]}], "}"}], ",", 
     TagBox[
      InterpretationBox[
       StyleBox[GridBox[{
          {"r", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[$CellContext`A],
       Editable->False],
      HoldForm]}], "}"}], ",", 
   TagBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {"r", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[$CellContext`A],
     Editable->False],
    HoldForm]}], 
  "}"}]], "Output",ExpressionUUID->"7bad61c2-fa04-43f8-a663-7839c3b9c6f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "[", 
    RowBox[{"r", "[", 
     RowBox[{"A", ",", "B"}], "]"}], "]"}], "//", "Trace"}], "//", 
  "ByteCount"}]], \
"Input",ExpressionUUID->"bb204866-668b-42e4-bff5-b18c90d4d607"],

Cell[BoxData["239104"], \
"Output",ExpressionUUID->"7196f3e7-7f05-4ed3-9943-d87a6121d127"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "[", 
    RowBox[{"r", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], "]"}], "//", "Trace"}], "//", 
  "ByteCount"}]], \
"Input",ExpressionUUID->"c448db68-cc51-4348-8178-2fadffa338fe"],

Cell[BoxData["266248"], \
"Output",ExpressionUUID->"d5f65d18-85d7-4b7a-94ed-820be047666b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "[", 
    RowBox[{"r", "[", 
     RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], "]"}], "//", 
   "Trace"}], "//", 
  "ByteCount"}]], \
"Input",ExpressionUUID->"57a24733-6f0a-445a-8d23-ff237e0c80ea"],

Cell[BoxData["293424"], \
"Output",ExpressionUUID->"8463cf4e-f052-402e-b476-873badd962bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "r", 
  "]"}]], "Input",ExpressionUUID->"ac69d943-d031-4e6e-a697-0977083f9573"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"c35922fd-7368-4c55-b77a-75253d6b66b5"]
}, Open  ]],

Cell["\<\
Now we introduce a metric and define the Riemann tensor with the usual \
symmetries:\
\>", "Text",ExpressionUUID->"3a6fc71e-0345-49c4-ba11-5435c155d56c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "metricg", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"xTensorQ", "[", "metricg", "]"}], ",", "True"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"SymmetryGroupOfTensor", "[", "metricg", "]"}], ",", 
    RowBox[{"Symmetric", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], "]"}]}], "]"}], 
  ";"}]}], "Input",ExpressionUUID->"cd93a7dd-b418-457a-977c-a4bf6e6c1fb3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Perm", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "}"}], "]"}]}], ",", 
     RowBox[{"Perm", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "C"}], ",", 
        RowBox[{"-", "D"}], ",", 
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "}"}], "]"}]}], "]"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<R\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"8705696b-d3d7-447b-91c3-c026dbb29f5e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"riemannR", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`riemannR[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"972f65fa-3644-4bfc-8460-43316b39d14d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}], ",", "B"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"c382944a-5ce6-424f-9cf0-4c9a063ccf68"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {"A", "B", " ", " "},
         {" ", " ", "A", "B"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"5f43621a-d04e-445a-bcdc-75248836b910"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7d69fc1c-2f3e-4a0c-bba3-583a26e074b3"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"7faae148-3012-4bd1-88b9-ed1fa41c7778"]
}, Open  ]],

Cell["Use of UseMetricOnVBundle:", \
"Text",ExpressionUUID->"7e614c93-79a7-48eb-8214-addb13c8b24a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "A"}], ",", "B"}], "]"}], ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], 
  "]"}]], "Input",ExpressionUUID->"7e4e10a0-6977-483c-9ab3-9ba6ea3137e7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {"A", " ", " ", "B"},
         {" ", "B", "A", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[$CellContext`A, -$CellContext`B, -$CellContext`A, \
$CellContext`B],
  Editable->
   False]], "Output",ExpressionUUID->"163848ae-c6f9-44de-8f83-91fcadf0ac48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], 
  "]"}]], "Input",ExpressionUUID->"d50dc85e-cdee-423c-8c1c-f46fb47d93b3"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {"B", "C", "A", " "},
         {" ", " ", " ", "A"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[$CellContext`B, C, $CellContext`A, -$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"7a8db239-d6bd-45cc-9d07-e4e26dd69ba1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", 
    RowBox[{"{", "TangentM2", "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"cf729414-dc74-4675-9879-924687d6d6f2"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"95db3db6-f28f-4abd-8e8c-66d9a92df6b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", 
    RowBox[{"{", "TangentS2", "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"a478d1df-da52-44d8-9583-9c5265b909b6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {"B", "C", "A", " "},
         {" ", " ", " ", "A"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[$CellContext`B, C, $CellContext`A, -$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"37c79767-f67c-4545-bea4-10fd2089c636"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"TangentM2", ",", "TangentS2"}], "}"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"967e2a9d-13e8-47bf-ab90-76c48e2cc12c"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"080b384f-6625-491a-a9a5-dfe636d6a069"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{
    RowBox[{"-", "C"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "D"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"bc01dc97-86ba-4300-8324-613b4d57b216"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"A", "D", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`riemannR[-$CellContext`A, -D, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"55e9cec0-dfc1-4db8-bc37-c3775446a2e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{"B", ",", 
    RowBox[{"-", "D"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"3a0bc540-2fa4-498e-ac32-4edfef6386e2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {" ", "B", " ", " "},
         {"A", " ", "D", "B"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[-$CellContext`A, $CellContext`B, -D, -$CellContext`B],
  
  Editable->
   False]], "Output",ExpressionUUID->"7774cc6d-bb61-45a2-9f62-bec50e231e26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryOf", "[", 
  RowBox[{"riemannR", "[", 
   RowBox[{"B", ",", 
    RowBox[{"-", "D"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"0344bf2e-c4e3-40d8-aefb-ee47441710de"],

Cell[BoxData[
 RowBox[{"Symmetry", "[", 
  RowBox[{"4", ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"R", 
        StyleBox[GridBox[{
           {"\[FilledCircle]1", "\[FilledCircle]2", "\[FilledCircle]3", 
            "\[FilledCircle]4"},
           {" ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`riemannR[
     xAct`xTensor`Private`slot[1], 
     xAct`xTensor`Private`slot[2], 
     xAct`xTensor`Private`slot[3], 
     xAct`xTensor`Private`slot[4]],
    Editable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "B"}], ",", 
     RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", 
      RowBox[{"-", "D"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", 
      RowBox[{"-", "B"}]}], ",", 
     RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", 
      RowBox[{"-", "A"}]}]}], "}"}], ",", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}]}], 
  "]"}]], "Output",ExpressionUUID->"9d3f99ee-1aa4-4aac-9405-37bb8a75653d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"riemannR", "[", 
    RowBox[{"B", ",", 
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], ",", 
   RowBox[{"Verbose", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"d2fd0b9f-9866-4e58-9353-bb16bc6a735a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Actual configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "B", "\<\",\"\>", 
      RowBox[{"-", "D"}], "\<\",\"\>", 
      RowBox[{"-", "B"}], "\<\",\"\>", 
      RowBox[{"-", "A"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`B, -
     D, -$CellContext`B, -$CellContext`A],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Actual configuration: ", 
   xAct`xTensor`IndexList[$CellContext`B, -
    D, -$CellContext`B, -$CellContext`A]],
  Editable->
   False]], "Print",ExpressionUUID->"ddba446f-9942-4f74-b432-c9d5d0025c64"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Standard configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], 
      RowBox[{"-", "A"}], "\<\",\"\>", 
      RowBox[{"-", "D"}], "\<\",\"\>", "B", "\<\",\"\>", 
      RowBox[{"-", "B"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[-$CellContext`A, -
     D, $CellContext`B, -$CellContext`B],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Standard configuration: ", 
   xAct`xTensor`IndexList[-$CellContext`A, -
    D, $CellContext`B, -$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"ad2984ef-f25f-4f36-bf69-c47dce132ed5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"c19c9124-ac23-4fd7-a0dc-f2d5c3b179c1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"962aff53-989e-41bc-93b7-da2ccb4c998e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Permutation to be canonicalized: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"4", ",", "2", ",", "1", ",", "3"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Permutation to be canonicalized: ", 
   xAct`xPerm`Images[{4, 2, 1, 3}]],
  Editable->
   False]], "Print",ExpressionUUID->"00f50125-f347-4fbd-ab3a-b708e8a3f23e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dummies: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "B", 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`B],
    Editable->False]}],
  SequenceForm["dummies: ", 
   xAct`xTensor`IndexList[$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"0ad75f3c-edc2-4323-8dd3-0e081ae215d5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets_tmp: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", "B", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets_tmp: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {$CellContext`B}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 0]}],
  Editable->
   False]], "Print",ExpressionUUID->"e049c0a3-cfea-4b2a-b09b-4e4bb8799d08"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"3", ",", "4"}], "}"}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {{3, 4}}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 0]}],
  Editable->
   False]], "Print",ExpressionUUID->"f22985ad-fe69-49cd-993a-4cf77de23f54"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Free indices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: Free indices: ", {1, 2}],
  Editable->
   False]], "Print",ExpressionUUID->"94fd9f51-6c6e-4d11-bdd1-07fba8af5eb8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: calling: \"\>", 
   "\[InvisibleSpace]", "\<\"CanonicalPerm[\"\>", "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}], "]"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "1", ",", "2", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{1, 2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{"-", 
          RowBox[{"(", "3", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        -xAct`xPerm`Cycles[{3, 4}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          RowBox[{"(", "1", ",", "3", ")"}], 
          RowBox[{"(", "2", ",", "4", ")"}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xPerm`Cycles[{1, 3}, {2, 4}],
        Editable->False]}], "]"}]}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"3", ",", "4"}], "}"}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "0"}], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"Verbose", "\[Rule]", "True"}], "\[InvisibleSpace]", "\<\"]\"\>"}],
  
  SequenceForm["ToCanonicalOne:: calling: ", "CanonicalPerm[", 
   xAct`xPerm`Images[{3, 2, 4, 1}], ",", 4, ",", 
   xAct`xPerm`StrongGenSet[{1, 2, 3, 4}, 
    xAct`xPerm`GenSet[-xAct`xPerm`Cycles[{1, 2}], -xAct`xPerm`Cycles[{3, 4}], 
     
     xAct`xPerm`Cycles[{1, 3}, {2, 4}]]], ",", {1, 2}, ",", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {{3, 4}}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 0]}, ",", Verbose -> True,
    "]"],
  Editable->
   False]], "Print",ExpressionUUID->"2bc395a6-c676-41f7-9d70-b57ccf140e27"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Canonical permutation: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Canonical permutation: ", 
   xAct`xPerm`Images[{1, 3, 2, 4}]],
  Editable->
   False]], "Print",ExpressionUUID->"6d3a1861-c1ec-4c56-8ad2-8d93a496c4d5"]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"R", 
      StyleBox[GridBox[{
         {" ", "B", " ", " "},
         {"A", " ", "D", "B"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`riemannR[-$CellContext`A, $CellContext`B, -D, -$CellContext`B],
  
  Editable->
   False]], "Output",ExpressionUUID->"735f02d6-9f83-4ffc-b7d7-be793d85ccb5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "riemannR", 
  "]"}]], "Input",ExpressionUUID->"6a004832-d99f-4a58-bc55-ddd0f134dd52"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "riemannR"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`riemannR],
  Editable->
   False]], "Print",ExpressionUUID->"b7962378-6d6d-4935-a4f4-b2eb5e6de78c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"0c5ea269-5803-4768-a9ec-b9abe902fd4d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"46b90101-398e-45fa-98bb-b7a7908e5df8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "C"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"6f4504e4-10bb-4a4e-a3ea-7f0964e1588c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", " ", " "},
         {"A", "B", "C"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[-$CellContext`A, -$CellContext`B, -C],
  Editable->
   False]], "Output",ExpressionUUID->"4fc587c1-cfd9-4575-8c79-ed25624bb30d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"bf35024b-4f2c-436c-aa9d-ddfe8c3a20b1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"0c6aac6a-f396-49ff-9918-0c5bae2d9c53"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"7c44c795-1414-4f05-b7a2-3bb6e5c27518"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"40187a27-b27b-46ad-9539-547c142e5043"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "C"}], ",", 
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7034f2e5-8fad-43c3-b1e3-d02fcf712bcd"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", " "},
          {"A", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, -$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"78473905-6dd9-4366-abd3-68cb88d4dd90"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"0226fe13-108c-4b6d-9895-b363d3729aa2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"2ea2bb21-707a-452d-b6d0-3e00e213c9d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "]"}], 
   ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     RowBox[{"Perm", "[", 
      RowBox[{"{", 
       RowBox[{"B", ",", "A", ",", "C", ",", "D", ",", "F", ",", "G"}], "}"}],
       "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"Perm", "[", 
       RowBox[{"{", 
        RowBox[{"A", ",", "B", ",", "D", ",", "C", ",", "F", ",", "G"}], 
        "}"}], "]"}]}], ",", 
     RowBox[{"Perm", "[", 
      RowBox[{"{", 
       RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "G", ",", "F"}], "}"}],
       "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b803cb61-62bf-43f1-a667-c8d4fc74b9dc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C, 
    D, $CellContext`F, $CellContext`G], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"265e76e0-22ef-4e2a-af9e-9a8b994903fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}], ",", "B", ",", "C", ",", 
    RowBox[{"-", "D"}], ",", "D"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"e3c482dd-6676-41a9-8562-2544d96c5d11"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", " ", "B", "C", "D", " "},
         {" ", "A", " ", " ", " ", "D"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, -$CellContext`A, $CellContext`B, C, D, -D],
  Editable->
   False]], "Output",ExpressionUUID->"e88c831d-0ad5-4bc4-a57e-26656500576b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "C"}], ",", "C", ",", 
    RowBox[{"-", "D"}], ",", "F"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"25876063-b8f2-4106-b197-b0d9796b9263"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"ca37be86-fa0b-4028-8eeb-340f2f1f21aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"8c3261ed-f33b-4c11-9e94-e6ab2e6e0495"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"a4630524-7d73-4aa1-b06b-e7c7e022ba23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "]"}], 
   ",", 
   RowBox[{"{", "M2", "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     RowBox[{"xAct`xPerm`Cycles", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"xAct`xPerm`Cycles", "[", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}], "]"}]}], ",", 
     RowBox[{"xAct`xPerm`Cycles", "[", 
      RowBox[{"{", 
       RowBox[{"5", ",", "6"}], "}"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"ad9bb191-b09f-4899-9abc-345accbdfe56"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C, 
    D, $CellContext`F, $CellContext`G], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"49afe28e-feba-4585-9069-49b15e8cff0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}], ",", "B", ",", "C", ",", 
    RowBox[{"-", "D"}], ",", "D"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"23af8379-2f5a-47ce-8403-b9181557f40e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", " ", "B", "C", "D", " "},
         {" ", "A", " ", " ", " ", "D"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, -$CellContext`A, $CellContext`B, C, D, -D],
  Editable->
   False]], "Output",ExpressionUUID->"5eb6a2cd-59e5-410a-893c-64505108def4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"T", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "C"}], ",", "C", ",", 
    RowBox[{"-", "D"}], ",", "F"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"d3abde18-e935-461b-9bc2-e91fe30da0dd"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"bc3614d9-d19c-4ae1-824a-67979604a88c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"af5efc4e-a443-4866-a8d5-4be6bb5b7853"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"2cc7be63-85ec-46f7-b226-cc5a1e8fcf74"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"90bc5af9-0a2f-4d93-a556-78607c3a5226"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"metricg\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"metricg"}],
  Editable->
   False]], "Print",ExpressionUUID->"7035be02-17b5-49aa-8201-30ebad313ffa"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.4.2. Examples with several tensors", \
"Subsubsection",ExpressionUUID->"d1b725da-74c5-4cf2-bd2b-bdad20a973dd"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"07f7e0b7-b659-4c37-81b3-152dc1fd6e4d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"A", ",", "B"}], "}"}], "]"}]}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "}"}], "]"}]}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], "]"}], "\n", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  "]"}]}], "Input",ExpressionUUID->"e22a9950-36b2-4be4-9ca2-6045de114c1c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"91092259-5941-4bbd-ac65-05fb2d7140a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`UU[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"97ee7b15-1663-4a1a-8272-4c5697748ea3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"356dc9e1-6ade-4009-813f-518502823a63"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a4a6675e-bf86-49c1-9018-7f012dd4bcca"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c13437cb-ed4a-46f7-b6a8-46741462932f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"07e36178-1bde-463a-ab89-1cf6f70d15ea"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{"C", ",", "B"}], "]"}], 
   RowBox[{"R", "[", 
    RowBox[{
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "G1"}], ",", 
     RowBox[{"-", "G2"}], ",", 
     RowBox[{"-", "G3"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", "G"}], "]"}], 
   RowBox[{"V", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"997ae273-7378-44c3-9221-0bd64503f9b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"R", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"G1", "B", "G2", "G3"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`R[-$CellContext`G1, -$CellContext`B, -$CellContext`G2, \
-$CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {" ", "B"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[-$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "G"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C, -$CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {"A", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`UU[$CellContext`A, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {"C"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[C],
   Editable->
    False]}]], "Output",ExpressionUUID->"2c4c42b1-5e3b-4355-ae3a-21da7a539c44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"UU", "[", 
     RowBox[{"C", ",", "B"}], "]"}], 
    RowBox[{"R", "[", 
     RowBox[{
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "G1"}], ",", 
      RowBox[{"-", "G2"}], ",", 
      RowBox[{"-", "G3"}]}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "G"}], "]"}], 
    RowBox[{"V", "[", "A", "]"}]}], ",", 
   RowBox[{"OrderedBase", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"9fb837de-c3e0-45f3-bdf1-9bee422355b2"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"G1", "A", "G2", "G3"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[-$CellContext`G1, -$CellContext`A, -$CellContext`G2, \
-$CellContext`G3],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {" ", "A"},
          {"G", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[-$CellContext`G, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {"C", "G"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`UU[C, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"e77ae992-c214-48e2-b6af-5e70bfaa01e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "D"}], ",", 
     RowBox[{"-", "F"}]}], "]"}], 
   RowBox[{"V", "[", "D", "]"}], 
   RowBox[{"V", "[", "F", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"75a52051-d58c-424e-aa99-4ee07a09d9ee"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"40d1fb66-f958-4c24-ba84-e533822d1cb9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "A"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6d18586d-8e14-4a81-9aa7-00b28b8cee67"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"64c1fdfd-d8aa-4aeb-ad13-296ebfaeeba7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "A"}]}], "]"}], "+", 
    RowBox[{"3", 
     RowBox[{
      RowBox[{"r", "[", "]"}], "^", "2"}], 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}]}]}], ",", 
   RowBox[{"Verbose", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"117cd70b-db86-469b-b982-06ca8408b5ee"],

Cell[CellGroupData[{

Cell[BoxData["\<\"***********************************************************\
\"\>"], "Print",ExpressionUUID->"6dbe771c-ecf3-423f-bc7d-332e5ad8afa3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: object: \"\>", "\[InvisibleSpace]", 
   TagBox[
    TooltipBox[
     UnderscriptBox[
      RowBox[{
       RowBox[{"(", 
        TagBox[
         TooltipBox[
          UnderscriptBox["Times", "_"],
          RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
         #& ], ")"}], "[", 
       RowBox[{
        TagBox[
         TooltipBox[
          UnderscriptBox["3", "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{"3", ",", 
              RowBox[{"{", 
                RowBox[{"Constant", ",", "1", ",", "3"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
            "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", 
                  RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "r", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
            "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"T", 
                StyleBox[GridBox[{
                   {" ", " "},
                   {"B", "A"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`T[-$CellContext`B, -$CellContext`A],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " "}, {"B", "A"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[-$CellContext`B, -$CellContext`A], Editable -> 
               False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                   False]}], "}"}]}], "]"}]],
         #& ]}], "]"}], "_"],
     RowBox[{"\"Object\"", "[", 
       RowBox[{
         RowBox[{
           RowBox[{"(", 
             TagBox[
              TooltipBox[
               UnderscriptBox["Times", "_"], 
               RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
             ")"}], "[", 
           RowBox[{
             TagBox[
              TooltipBox[
               UnderscriptBox["3", "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{"3", ",", 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", "3"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                 "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "r", ",", "2"}], 
                    "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                 "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"B", "A"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[-$CellContext`B, -$CellContext`A], Editable -> 
                 False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"B", "A"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`B, -$CellContext`A], 
                    Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
                    Null}, {-$CellContext`TangentM2, Null}], Editable -> 
                    False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
         RowBox[{"{", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   RowBox[{"Constant", ",", "Tensor", ",", "Tensor"}], 
                   "}"}]}], "}"}], ",", 
             RowBox[{"{", "2", "}"}], ",", 
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   RowBox[{"3", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Power"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Power, Editable -> False], ",", "r", ",", "2"}], 
                    "}"}], ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
           RowBox[{
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"-", "B"}], "\",\"", 
                 RowBox[{"-", "A"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
              Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"-", "A"}], "\",\"", 
                 RowBox[{"-", "B"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
              Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "Null"}], "}"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}], 
              Editable -> False]}], "}"}]}], "]"}]],
    #& ]}],
  SequenceForm["ToCanonical:: object: ", 
   xAct`xTensor`Private`Object[
    xAct`xTensor`Private`VerbatimProduct[Times][
     xAct`xTensor`Private`Object[3, {Constant, 1, 3}, {
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[]}], 
     xAct`xTensor`Private`Object[$CellContext`r[]^2, {
      xAct`xTensor`Tensor, 1, {Power, $CellContext`r, 2}}, {
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[]}], 
     xAct`xTensor`Private`Object[
      $CellContext`T[-$CellContext`B, -$CellContext`A], {
      xAct`xTensor`Tensor, 2, $CellContext`T}, {
       xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
       xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{-$CellContext`TangentM2, 
         Null}, {-$CellContext`TangentM2, Null}]}]], {{
     Times, {Constant, xAct`xTensor`Tensor, xAct`xTensor`Tensor}}, {2}, {
     Times, {3, {Power, $CellContext`r, 2}, $CellContext`T}}}, {
     xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
     xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[{-$CellContext`TangentM2, Null}]}]],
  Editable->
   False]], "Print",ExpressionUUID->"771e8619-f7b9-4180-9d51-f42b1ad6935d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: sym: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Symmetry", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"(", 
       TagBox[
        TooltipBox[
         UnderscriptBox["Times", "_"],
         RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
        #& ], ")"}], "[", 
      RowBox[{"3", ",", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"\[FilledCircle]1", "\[FilledCircle]2"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[
         xAct`xTensor`Private`slot[1], 
         xAct`xTensor`Private`slot[2]],
        Editable->False]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", 
        RowBox[{"-", "B"}]}], ",", 
       RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", 
        RowBox[{"-", "A"}]}]}], "}"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"GenSet", "[", 
        InterpretationBox[
         StyleBox[
          RowBox[{"(", "1", ",", "2", ")"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xPerm`Cycles[{1, 2}],
         Editable->False], "]"}]}], "]"}]}], "]"}]}],
  SequenceForm["ToCanonical:: sym: ", 
   xAct`xTensor`Symmetry[2, 
    xAct`xTensor`Private`VerbatimProduct[Times][3, $CellContext`r[]^2, 
     $CellContext`T[
      xAct`xTensor`Private`slot[1], 
      xAct`xTensor`Private`slot[2]]], {
    xAct`xTensor`Private`slot[1] -> -$CellContext`B, 
     xAct`xTensor`Private`slot[2] -> -$CellContext`A}, 
    xAct`xPerm`StrongGenSet[{1, 2}, 
     xAct`xPerm`GenSet[
      xAct`xPerm`Cycles[{1, 2}]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"2e9f22ce-5b63-49b4-99ef-d57815ce62ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Actual configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], 
      RowBox[{"-", "B"}], "\<\",\"\>", 
      RowBox[{"-", "A"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Actual configuration: ", 
   xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A]],
  Editable->
   False]], "Print",ExpressionUUID->"988ceba7-bf42-4915-a45e-e046bb89d21c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Standard configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], 
      RowBox[{"-", "A"}], "\<\",\"\>", 
      RowBox[{"-", "B"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Standard configuration: ", 
   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"c8664b89-d50d-4b1e-9fd5-13b7eb1c49b0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"e77a1606-e0da-4436-a19a-431ed4439f60"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"8c677565-4640-4f0c-ab5a-5d741b2e594e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Permutation to be canonicalized: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Permutation to be canonicalized: ", 
   xAct`xPerm`Images[{2, 1}]],
  Editable->
   False]], "Print",ExpressionUUID->"33a5e62b-13d7-4661-9008-0e1f423ea89b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dummies: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["dummies: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"023cdd12-f270-4c72-a7dd-48f8aef55fd8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets_tmp: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"DummySet", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[DoubleStruckCapitalT]M2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`TangentM2,
       Editable->False], ",", 
      RowBox[{"{", "}"}], ",", "0"}], "]"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets_tmp: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {}, 0]}],
  Editable->
   False]], "Print",ExpressionUUID->"a4be9389-cadc-457e-a124-c718cc48c0eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"DummySet", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[DoubleStruckCapitalT]M2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`TangentM2,
       Editable->False], ",", 
      RowBox[{"{", "}"}], ",", "0"}], "]"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {}, 0]}],
  Editable->
   False]], "Print",ExpressionUUID->"54691d59-af35-4bd7-8d0c-dae300b28f33"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Free indices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: Free indices: ", {1, 2}],
  Editable->
   False]], "Print",ExpressionUUID->"02d27067-dc40-429e-b1c8-fd548aebd56f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: calling: \"\>", 
   "\[InvisibleSpace]", "\<\"CanonicalPerm[\"\>", "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{"(", "1", ",", "2", ")"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xPerm`Cycles[{1, 2}],
       Editable->False], "]"}]}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"DummySet", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[DoubleStruckCapitalT]M2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`TangentM2,
       Editable->False], ",", 
      RowBox[{"{", "}"}], ",", "0"}], "]"}], "}"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"Verbose", "\[Rule]", "True"}], "\[InvisibleSpace]", "\<\"]\"\>"}],
  
  SequenceForm["ToCanonicalOne:: calling: ", "CanonicalPerm[", 
   xAct`xPerm`Images[{2, 1}], ",", 2, ",", 
   xAct`xPerm`StrongGenSet[{1, 2}, 
    xAct`xPerm`GenSet[
     xAct`xPerm`Cycles[{1, 2}]]], ",", {1, 2}, ",", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {}, 0]}, ",", Verbose -> True,
    "]"],
  Editable->
   False]], "Print",ExpressionUUID->"4d09cec5-7784-4d49-91e4-a72f2e8c2163"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Canonical permutation: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Canonical permutation: ", 
   xAct`xPerm`Images[{1, 2}]],
  Editable->
   False]], "Print",ExpressionUUID->"f53f8516-9095-431d-971a-8749fcc6822e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: newindices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], 
        RowBox[{"-", "A"}], "\<\",\"\>", 
        RowBox[{"-", "B"}], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B],
      Editable->False]}], "}"}]}],
  SequenceForm["ToCanonical:: newindices: ", {1, 
    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B]}],
  Editable->
   False]], "Print",ExpressionUUID->"54b8fb29-a3f1-4a76-8f6d-9a58e8b52e06"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: riskyders: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonical:: riskyders: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"a63ef616-45ca-4701-be9e-02e7764b242d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: result: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"(", 
     TagBox[
      TooltipBox[
       UnderscriptBox["Times", "_"],
       RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
      #& ], ")"}], "[", 
    RowBox[{"3", ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A, -$CellContext`B],
      Editable->False]}], "]"}]}],
  SequenceForm["ToCanonical:: result: ", 
   xAct`xTensor`Private`VerbatimProduct[Times][3, $CellContext`r[]^2, 
    $CellContext`T[-$CellContext`A, -$CellContext`B]]],
  Editable->
   False]], "Print",ExpressionUUID->"3dfe6d3c-7252-4ee6-a4c2-7c237c73ea5d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Actual configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], 
      RowBox[{"-", "B"}], "\<\",\"\>", 
      RowBox[{"-", "A"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Actual configuration: ", 
   xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A]],
  Editable->
   False]], "Print",ExpressionUUID->"e37b693b-830b-42bb-a7e5-1d47efae5644"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Standard configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], 
      RowBox[{"-", "A"}], "\<\",\"\>", 
      RowBox[{"-", "B"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Standard configuration: ", 
   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"62b11f9d-1faa-4248-8d7f-3e6404072240"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"e3f9ec94-d897-484e-8837-ab7bfcf061dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"c5ebbeca-4f4b-4ec6-a89c-6c817b94c354"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Permutation to be canonicalized: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Permutation to be canonicalized: ", 
   xAct`xPerm`Images[{2, 1}]],
  Editable->
   False]], "Print",ExpressionUUID->"a3d33184-9f5c-4ccf-8269-30095046b453"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dummies: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["dummies: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"ee4f6294-fd28-4ba9-8437-ce5d5bf41654"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets_tmp: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"DummySet", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[DoubleStruckCapitalT]M2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`TangentM2,
       Editable->False], ",", 
      RowBox[{"{", "}"}], ",", "0"}], "]"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets_tmp: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {}, 0]}],
  Editable->
   False]], "Print",ExpressionUUID->"3b5d8a04-286c-4dcd-a4ea-017a1190c8e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"DummySet", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[DoubleStruckCapitalT]M2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`TangentM2,
       Editable->False], ",", 
      RowBox[{"{", "}"}], ",", "0"}], "]"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {}, 0]}],
  Editable->
   False]], "Print",ExpressionUUID->"3af8d966-4bad-4335-89b6-43a0dc3c140e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Free indices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}],
  SequenceForm["ToCanonicalOne:: Free indices: ", {1, 2}],
  Editable->
   False]], "Print",ExpressionUUID->"b7bf2623-0d39-40ad-ac29-7f9c099a4786"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: calling: \"\>", 
   "\[InvisibleSpace]", "\<\"CanonicalPerm[\"\>", "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{"-", 
         RowBox[{"(", "1", ",", "2", ")"}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       -xAct`xPerm`Cycles[{1, 2}],
       Editable->False], "]"}]}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"DummySet", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[DoubleStruckCapitalT]M2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`TangentM2,
       Editable->False], ",", 
      RowBox[{"{", "}"}], ",", "0"}], "]"}], "}"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"Verbose", "\[Rule]", "True"}], "\[InvisibleSpace]", "\<\"]\"\>"}],
  
  SequenceForm["ToCanonicalOne:: calling: ", "CanonicalPerm[", 
   xAct`xPerm`Images[{2, 1}], ",", 2, ",", 
   xAct`xPerm`StrongGenSet[{1, 2}, 
    xAct`xPerm`GenSet[-xAct`xPerm`Cycles[{1, 2}]]], ",", {1, 2}, ",", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {}, 0]}, ",", Verbose -> True,
    "]"],
  Editable->
   False]], "Print",ExpressionUUID->"af5c1a7d-e343-4d04-9240-668877c858fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Canonical permutation: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"-", 
    RowBox[{"Images", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], "]"}]}]}],
  SequenceForm[
  "ToCanonicalOne:: Canonical permutation: ", -xAct`xPerm`Images[{1, 2}]],
  Editable->
   False]], "Print",ExpressionUUID->"a870c496-7430-4707-848e-3dbf5cd97f7f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B],
    Editable->False]}], "-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`UU[-$CellContext`A, -$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"359a7c9b-53a5-48d3-b82f-aa6355491dfb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"Scalar", "[", 
   RowBox[{
    RowBox[{"UU", "[", 
     RowBox[{"C", ",", "D"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "D"}]}], "]"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"7d9177a6-1cf4-4ba5-930c-5f037599b740"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["(",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`A, -$CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[$CellContext`A, $CellContext`B],
      Editable->False]}], 
    StyleBox[")",
     FontColor->RGBColor[1, 0, 0]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"1195056c-ebe8-4bcb-824c-88faf9fd1008"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{"C", ",", "D"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}]}], "]"}], "^", "2"}], 
  "]"}]], "Input",ExpressionUUID->"0da2d9c6-058b-4c1d-b238-7a58836a1576"],

Cell[BoxData[
 SuperscriptBox[
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"UU", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`UU[-$CellContext`A, -$CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"UU", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`UU[$CellContext`A, $CellContext`B],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
   Editable->False], 
  "2"]], "Output",ExpressionUUID->"ab7df2cf-ef6a-4266-8237-cfb6fc94f94a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"UU", "[", 
       RowBox[{"C", ",", "D"}], "]"}], 
      RowBox[{"UU", "[", 
       RowBox[{
        RowBox[{"-", "C"}], ",", 
        RowBox[{"-", "D"}]}], "]"}]}], "]"}], "^", "2"}], 
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"B", ",", "D"}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"ff4267f3-287a-432a-afbd-f7eb1cd43271"],

Cell[BoxData[
 SuperscriptBox[
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"UU", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`UU[-$CellContext`A, -$CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"UU", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`UU[$CellContext`A, $CellContext`B],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
   Editable->False], 
  "3"]], "Output",ExpressionUUID->"4c2807d0-e569-433d-8f64-2e0237841de3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sin", "[", 
   RowBox[{
    RowBox[{"UU", "[", 
     RowBox[{"D", ",", "A"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "A"}]}], "]"}]}], "]"}], 
  RowBox[{
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{"C", ",", "D"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}]}], "]"}], "^", "3"}], 
  RowBox[{
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"B", ",", "D"}], "]"}]}], "]"}], "/", 
   RowBox[{
    RowBox[{"Scalar", "[", 
     RowBox[{"7", 
      RowBox[{"UU", "[", 
       RowBox[{"A", ",", "C"}], "]"}], 
      RowBox[{"UU", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "C"}]}], "]"}]}], "]"}], "^", 
    "2"}]}]}]], \
"Input",ExpressionUUID->"83f6eb0a-29bf-4755-95eb-58460c0ecc68"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`B, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {"B", "D"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[$CellContext`B, D],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`B, -
       D] $CellContext`UU[$CellContext`B, D]],
    Editable->False], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"UU", 
             StyleBox[GridBox[{
                {" ", " "},
                {"C", "D"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`UU[-C, -D],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"UU", 
             StyleBox[GridBox[{
                {"C", "D"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`UU[C, D],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`UU[-C, -D] $CellContext`UU[C, D]],
     Editable->False], "3"], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["Sin",
      ShowAutoStyles->False,
      AutoSpacing->False],
     Sin,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " "},
             {"D", "A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-D, -$CellContext`A],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {"D", "A"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[D, $CellContext`A],
      Editable->False]}], "]"}]}], 
  RowBox[{"49", " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"UU", 
             StyleBox[GridBox[{
                {" ", " "},
                {"A", "C"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`UU[-$CellContext`A, -C],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"UU", 
             StyleBox[GridBox[{
                {"A", "C"},
                {" ", " "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`UU[$CellContext`A, C],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -
        C] $CellContext`UU[$CellContext`A, C]],
     Editable->False], 
    "2"]}]]], \
"Output",ExpressionUUID->"298f4fb0-b8e3-4aa7-9289-e566e0f50e2e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"d699fe59-901f-483f-877b-a9c7d41e801e"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "49"], " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`A, -$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[$CellContext`A, $CellContext`B],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
    Editable->False], "2"], " ", 
  RowBox[{
   InterpretationBox[
    StyleBox["Sin",
     ShowAutoStyles->False,
     AutoSpacing->False],
    Sin,
    Editable->False], "[", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`A, -$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[$CellContext`A, $CellContext`B],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
    Editable->False], 
   "]"}]}]], "Output",ExpressionUUID->"a7d68cfc-d93c-49d4-9557-52b0a042528a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{
  "Sin", "\[Rule]", 
   "Identity"}]}]], \
"Input",ExpressionUUID->"596ec699-e8c1-491a-bc37-81f4fdca240a"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "49"], " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`A, -$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[$CellContext`A, $CellContext`B],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
    Editable->False], 
   "3"]}]], "Output",ExpressionUUID->"3d55a00b-f5cc-4ec4-ada1-d341021f7730"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"832c81f4-bf1d-47ad-bedb-5a7376d92bae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"T", ",", "UU", ",", "S", ",", "V", ",", "r", ",", "R"}], 
  "}"}]], "Output",ExpressionUUID->"53ce48ce-32e6-4806-8bdc-1e9f3948d17d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"Sin", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "B"}]}], "]"}]}], "+", "1"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"6115cc92-b2dc-4a58-8c8a-c5de958d8b34"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox["Sin",
    ShowAutoStyles->False,
    AutoSpacing->False],
   Sin,
   Editable->False], "[", 
  RowBox[{"1", "+", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`A, -$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[$CellContext`A, $CellContext`B],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
    Editable->False]}], 
  "]"}]], "Output",ExpressionUUID->"23107b31-3ccb-4586-8766-0dc26cc0c7ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "S", ",", "UU", ",", "V", ",", "R", ",", "r"}], "}"}]}],
   ";"}]], "Input",ExpressionUUID->"ccfb1d1d-6974-4813-b0ab-a5ba9d0f1fcd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"46f0c48f-c8b4-4905-89cb-571fc60d68ca"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"24a3d981-eab6-4075-92dd-8038a89d6107"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "UU"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`UU],
  Editable->
   False]], "Print",ExpressionUUID->"c70a61a7-d7b7-4ddb-b5c6-5073912d65e4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"af860d6d-2a60-4b86-abeb-41fefc81ff81"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"e4f38a86-8ad9-4119-9a49-f9176ab718fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"daa42de2-6394-461e-ad99-8a44fe21f1d1"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"7b29e68e-b360-4199-8430-367c700c8061"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"8e8ff463-98a7-4649-84fe-47b949c6e664"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"142f6f32-d296-4d74-bdbe-4ee68490d19d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"43f212c1-60c1-40f6-8058-70d10682f131"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7490d8a8-0a66-4792-9493-e844be2b38e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"gg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "Cd", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"aa7ddb17-38e6-4e74-a24e-73279ac63f1e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"37c68144-7551-49f4-b7f1-ac12a554e571"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilongg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilongg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"859b1466-c2b2-4fe4-b03c-b95c6027954a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"Cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`Cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d9722e12-e31d-429e-a085-9086d85d49ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a8dd2204-31f5-4ccc-bcda-4849351e6c34"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"36fab16c-e204-46ce-9bca-07e98dbd1720"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ab55b0c9-e28e-4e87-978a-2745fe8f1957"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2213c893-ea64-40df-9afc-78eb53e0d034"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"3c9bac9e-1fd1-41f2-b873-62dbc10feffe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"451e9700-706a-454f-8921-bc5a40968d24"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"510a3d31-3cba-41c2-8826-2429b7222154"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"edb9b437-e159-4f0b-b61c-91d279150ffb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"21b0418f-6e21-4ec6-9323-5214ac5739a0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"fabc1797-ec16-4acb-9ce6-59c6add99776"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bf6a70c8-b01d-4bc5-8811-10861de4d59c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"8f824d97-709b-4dbf-b03d-34af832e38a4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"b9d1c7b9-e24b-4cf7-a05e-717553a11163"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"2fc58d89-d927-4226-a320-f181675a14db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"80255131-e431-49b7-8d9b-9a83d70a5423"]
}, Open  ]]
}, Open  ]],

Cell["In this case the indices can be moved:", \
"Text",ExpressionUUID->"3c615c01-6b8a-43cb-ab84-7ca875162ed0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cd", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}], ",", "B"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"94aa9b9e-4104-4dd1-b835-7ca20ec73ea5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {" ", " ", "B", "  "},
         {"B", "C", " ", 
          RowBox[{";", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`A][
   $CellContext`S[-$CellContext`B, -C, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"b2e432c1-c64b-4e70-8613-05dbb37ca9f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"aeac28ad-636b-4baf-a9ee-609fa39c1545"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {"B", " ", " ", "  "},
         {" ", "C", "B", 
          RowBox[{";", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`A][
   $CellContext`S[$CellContext`B, -C, -$CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"6a824bcc-d9a4-4e1d-acd6-1a116727abf6"]
}, Open  ]],

Cell["but not in this case:", \
"Text",ExpressionUUID->"15807fa8-ca75-42fb-8505-2329b81c839e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"%%", ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], 
  "]"}]], "Input",ExpressionUUID->"1937eeec-1b53-4098-b24a-d63925a1b96b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {" ", " ", "B", "  "},
         {"B", "C", " ", 
          RowBox[{";", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Cd[-$CellContext`A][
   $CellContext`S[-$CellContext`B, -C, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"9eebadf0-e990-46d4-8e8d-591441e7e4b1"]
}, Open  ]],

Cell["\<\
If we have PD instead of Cd this is done much more carefully. Note that in \
those cases the algorithm does not arrive at the final solution in a single \
step:\
\>", "Text",ExpressionUUID->"32707569-8121-4014-9d75-f19f06261f56"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}], ",", "B"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"dddbd3b0-7bde-40fc-bdbf-f3c17179ea92"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {" ", " ", "B", "  "},
         {"B", "C", " ", 
          RowBox[{",", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[-$CellContext`A][
   $CellContext`S[-$CellContext`B, -C, $CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"7aa04a93-5735-459d-9f19-a2b72be0ef75"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"69d9fb99-e3d1-43ca-aead-4bce18b8258d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4a6a2161-fa76-4316-90a7-519c6e4a126d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"S", 
      StyleBox[GridBox[{
         {"B", " ", " ", "  "},
         {" ", "C", "B", 
          RowBox[{",", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[-$CellContext`A][
   $CellContext`S[$CellContext`B, -C, -$CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"dd4163ac-eb86-4760-9f9d-2e4b58ae1a1f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"C", ",", "A"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], ",", 
   RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], 
  "]"}]], "Input",ExpressionUUID->"c7d1ee97-f6f0-4ff5-b534-51eddcbd66a1"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"C", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[C, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B", " ", "  "},
          {"A", " ", "B", 
           RowBox[{";", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Cd[-D][
    $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
   Editable->
    False]}]], "Output",ExpressionUUID->"5b9d78ea-844a-456d-a6ab-e8f7030b6817"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"C", ",", "A"}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b07b29bf-ced5-4f25-ac47-8860e8882d11"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"C", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[C, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B", " ", "  "},
          {"A", " ", "B", 
           RowBox[{";", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Cd[-D][
    $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
   Editable->
    False]}]], "Output",ExpressionUUID->"692dfca1-8953-4274-adee-fa9c6f8dca1f"]
}, Open  ]],

Cell["Note the difference in timings:", \
"Text",ExpressionUUID->"138bec87-7bcf-4c8b-9297-c74541d8ce46"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"C", ",", "A"}], "]"}], 
      RowBox[{
       RowBox[{"PD", "[", 
        RowBox[{"-", "D"}], "]"}], "[", 
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], ",", 
     RowBox[{"UseMetricOnVBundle", "\[Rule]", "None"}]}], "]"}], "//", 
   "ScreenDollarIndices"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"53e75e1c-21cb-4bad-9d4e-2c4d6d652ac4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.00684099999999999985877963126768008806`3.855719503704174", ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"C", "A"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[C, $CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "B", " ", "  "},
            {"A", " ", "B", 
             RowBox[{",", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-D][
      $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"5fbaea84-3db7-42cc-900d-5e52b45b739c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToCanonical", "[", 
    RowBox[{"Last", "[", "%", "]"}], "]"}], "//", "ScreenDollarIndices"}], "//",
   "Timing"}]], \
"Input",ExpressionUUID->"af9ae5ba-b700-4cf1-b1e1-06f7e2c39fcc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00638100000000000038696823523309831216`3.8254886579020155", ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"C", "A"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[C, $CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", "B", " ", "  "},
            {"A", " ", "B", 
             RowBox[{",", "D"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`PD[-D][
      $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"5f63496a-0ff4-4a85-b61b-d9838c563e92"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"C", ",", 
     RowBox[{"-", "A"}]}], "]"}], 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"C", ",", "A"}], "]"}], 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "B", ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"cb4d3386-6ff4-4ff0-951f-21368a735ba5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"C", "A"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[C, $CellContext`A],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B", " ", "  "},
           {"A", " ", "B", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", " "},
           {" ", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "B", "  "},
           {" ", "B", " ", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[$CellContext`A, -$CellContext`B, $CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"1746bc0d-22d8-44f0-ad56-ded4861cb372"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", "%", "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"18e8dc50-d873-4153-b8a6-b48198f039d8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8ccffe84-c476-4bfc-8080-d7e385b3c992"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", "B"},
            {"A", "D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCd[-$CellContext`A, -D, $CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "F", " "},
           {"B", " ", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, $CellContext`F, -$CellContext`F],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCd[$CellContext`B, -D, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "F", " "},
           {"B", " ", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, $CellContext`F, -$CellContext`F],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"562a3ba7-dcff-442d-9b54-d18d0162388f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{"%%", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"ChangeCovD", ",", 
       RowBox[{"\"\<ExpandChristoffel\>\"", "\[Rule]", "True"}]}], "}"}]}]}], 
   "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"525735d6-aad1-49f1-87d2-4a3b62c28ab0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2b707c45-81ed-4ec7-8d54-71f90016a795"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", " ", "F"},
          {" ", "B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, -$CellContext`B, $CellContext`F],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"gg", 
       StyleBox[GridBox[{
          {" ", " ", "  "},
          {"A", "F", 
           RowBox[{",", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-D][
    $CellContext`gg[-$CellContext`A, -$CellContext`F]],
   Editable->
    False]}]], "Output",ExpressionUUID->"388fa0be-1d29-4f6d-bbdc-b2b195264d73"]
}, Open  ]],

Cell["And canonicalize:", \
"Text",ExpressionUUID->"0a598d6f-961f-4f29-a74b-a5bb2e80dfa6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"C", ",", "A"}], "]"}], 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"f4438270-ae00-4fb8-8c21-56829813d0e7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ff7e7cd6-3507-4e7f-84a6-fc4f0d3a08a6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"C", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[C, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B", " ", "  "},
          {"A", " ", "B", 
           RowBox[{",", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-D][
    $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
   Editable->
    False]}]], "Output",ExpressionUUID->"88595923-c807-43a5-8600-2eeca65af757"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"C", ",", 
      RowBox[{"-", "A"}]}], "]"}], 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"5c45e653-5415-456d-bc54-b29e39d9c402"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"53d85ca6-47ab-4d0c-9957-c55037a07ca5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
         StyleBox[GridBox[{
            {" ", " ", "B"},
            {"A", "D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelCd[-$CellContext`A, -D, $CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "F", " "},
           {"B", " ", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, $CellContext`F, -$CellContext`F],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "D", "]"}], 
        StyleBox[GridBox[{
           {"B", " ", " "},
           {" ", "D", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCd[$CellContext`B, -D, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "F", " "},
           {"B", " ", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, $CellContext`F, -$CellContext`F],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B", " ", "  "},
           {"A", " ", "B", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"d0d004e9-a248-4896-910d-3fea86cb8e09"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"C", ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", 
        RowBox[{"-", "B"}], ",", "B"}], "]"}], "]"}]}], ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"ChangeCovD", ",", 
       RowBox[{"\"\<ExpandChristoffel\>\"", "\[Rule]", "True"}]}], "}"}]}]}], 
   "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"03dcd998-c80e-4b13-bc82-6ec2c12f5c10"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0e03294a-ae18-48c4-958b-a1f36d2ce41a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"C", "A"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[C, $CellContext`A],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "F"},
           {" ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, -$CellContext`B, $CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"gg", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "F", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`gg[-$CellContext`A, -$CellContext`F]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"C", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B", " ", "  "},
           {"A", " ", "B", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[-$CellContext`A, $CellContext`B, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"d43762b7-4e4f-47c2-8c5c-a07c395f17d9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "S"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"c0e39a72-3e3c-4fd9-95d4-6dcdd56cbc0a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"c832f2f4-ab9e-46fb-9cd5-12e56239d0ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"d983b5a6-96a1-4ccb-9ead-b94b694b6082"]
}, Open  ]]
}, Open  ]],

Cell["\<\
A metric can be undefined using either UndefTensor or UndefMetric:\
\>", "Text",ExpressionUUID->"0f50959c-6dfc-4ded-b9b9-c437aee6e57a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "[", "gg", "]"}], 
  ";"}]], "Input",ExpressionUUID->"3a719cd6-1105-43e1-ba7c-ac7fed6d5be7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgg],
  Editable->
   False]], "Print",ExpressionUUID->"9a85f5bf-cf5d-4150-a6c7-531f53de9a6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCd],
  Editable->
   False]], "Print",ExpressionUUID->"8e7a1617-a9d4-4816-833c-249fbda01430"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCd],
  Editable->
   False]], "Print",ExpressionUUID->"65877769-4c2d-455a-85b4-04ec33943e33"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCd],
  Editable->
   False]], "Print",ExpressionUUID->"a6950462-f115-4d54-a66e-8b6f86c3a84e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCd],
  Editable->
   False]], "Print",ExpressionUUID->"0fd62bfb-2826-4aac-93ce-a37b7c6fbd2a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCd],
  Editable->
   False]], "Print",ExpressionUUID->"85aaa830-75b9-48ba-b02e-2423e8b0f4bc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCd],
  Editable->
   False]], "Print",ExpressionUUID->"e7054848-d5e2-4c97-a862-359684757843"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCd],
  Editable->
   False]], "Print",ExpressionUUID->"4b6be519-b1af-4cba-a6a9-34eb1f25bd43"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCd],
  Editable->
   False]], "Print",ExpressionUUID->"7922a504-c6f8-49ad-b375-9d2d34bb222f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCd],
  Editable->
   False]], "Print",ExpressionUUID->"96b3af4d-2487-44a6-b50e-f0b92f03e0c7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`Cd],
  Editable->
   False]], "Print",ExpressionUUID->"8fa072b6-222d-4b15-afdc-e9c92c3e79f8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilongg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilongg],
  Editable->
   False]], "Print",ExpressionUUID->"b24d6486-07e4-42cd-a67c-dbd22b610b72"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gg],
  Editable->
   False]], "Print",ExpressionUUID->"a92a0a9e-4cb2-4d06-8a85-5f12c41f74a1"]
}, Open  ]]
}, Open  ]],

Cell["And with repeated indices:", \
"Text",ExpressionUUID->"392981f5-5275-4c55-9011-1e72e9db4c4d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"95395e2f-2405-4775-8d19-757d6e79eb21"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5dd596e3-d603-4a0c-9727-b55b638e1604"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"B", ",", "A", ",", "C"}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"08b8e40f-f1d9-4c17-b147-ca67ea54055e"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B", "C"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"2911ee21-0d5f-435f-84a3-8531ea89ad95"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "Polar"}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"83ce2776-a59b-4513-adef-e97f35d75e1e"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["1",
            FontColor->RGBColor[0., 0., 1.]], 
           StyleBox["2",
            FontColor->RGBColor[0., 0., 1.]], 
           StyleBox["3",
            FontColor->RGBColor[0., 0., 1.]]},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[{1, $CellContext`Polar}, {2, $CellContext`Polar}, {
    3, $CellContext`Polar}],
   Editable->
    False]}]], "Output",ExpressionUUID->"3e6a6ac6-a70b-4c15-93f0-cfee71c99518"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "Polar"}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"3cefde4c-4992-46fc-a23b-c07156a5d297"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"3adf8ca7-89be-4f25-87fd-cd4a9e07f72c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"3ada3864-24d4-431e-8cfd-a7097702c269"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]], 
          StyleBox["3",
           FontColor->RGBColor[0., 0., 1.]], 
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]]},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[{1, $CellContext`Polar}, {3, $CellContext`Polar}, {
   1, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"41e19b48-1c28-4ecf-87de-d6e74f32cd3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"9e8eeaf0-d666-48f7-b4e5-052399196d28"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", " ", " "},
         {
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]], 
          StyleBox["3",
           FontColor->RGBColor[0., 0., 1.]], 
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[{1, -$CellContext`Polar}, {3, -$CellContext`Polar}, {
   1, -$CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"4d595fe9-0ff0-419a-b7cf-ad0fe07b6884"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"7cf74444-b373-4bd1-b34f-e02d0bf4c2b3"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"64547fd8-e9d0-4d81-84e9-bc236dc90ce3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"3ff633b6-bc28-46ad-866c-3c092639ab27"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]], " ", 
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]]},
         {" ", 
          StyleBox["1",
           FontColor->RGBColor[0., 0., 1.]], " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[{1, $CellContext`Polar}, {1, -$CellContext`Polar}, {
   1, $CellContext`Polar}],
  Editable->
   False]], "Output",ExpressionUUID->"f412942b-aa8e-491a-8fe0-5f538724d51f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "Polar"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Polar"}], "}"}]}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"f6caf1d0-2cd9-4918-b935-6afd9a2b9985"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"6fc278e3-df71-4c8b-af0c-874536b339ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "T", 
  "]"}]], "Input",ExpressionUUID->"381d5cd7-d38a-4dc1-b12a-110161653a4f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"1cec79d9-a374-409b-a7d0-3f042945be87"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f1376c95-c305-4ca3-9fa3-a241e2e25372"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$279987\"\>", ",", "\<\"G$279988\"\>", 
     ",", "\<\"G$279996\"\>", ",", "\<\"G$279997\"\>", 
     ",", "\<\"G$280005\"\>", ",", "\<\"G$280006\"\>", 
     ",", "\<\"G$280014\"\>", ",", "\<\"G$280015\"\>", 
     ",", "\<\"G$280023\"\>", ",", "\<\"G$280024\"\>", 
     ",", "\<\"G$280032\"\>", ",", "\<\"G$280033\"\>", 
     ",", "\<\"G$280041\"\>", ",", "\<\"G$280042\"\>", 
     ",", "\<\"G$280050\"\>", ",", "\<\"G$280051\"\>", 
     ",", "\<\"G$280059\"\>", ",", "\<\"G$280060\"\>", 
     ",", "\<\"G$288652\"\>", ",", "\<\"G$288652$\"\>", 
     ",", "\<\"G$288653\"\>", ",", "\<\"G$288653$\"\>", 
     ",", "\<\"G$288654\"\>", ",", "\<\"G$288654$\"\>", 
     ",", "\<\"G$288655\"\>", ",", "\<\"G$288655$\"\>", 
     ",", "\<\"G$288656\"\>", ",", "\<\"G$288656$\"\>", 
     ",", "\<\"G$288657\"\>", ",", "\<\"G$288657$\"\>", 
     ",", "\<\"G$288658\"\>", ",", "\<\"G$288658$\"\>", 
     ",", "\<\"G$288659\"\>", ",", "\<\"G$288659$\"\>", 
     ",", "\<\"G$288660\"\>", ",", "\<\"G$288660$\"\>", 
     ",", "\<\"G$288661\"\>", ",", "\<\"G$288661$\"\>", 
     ",", "\<\"G$288662\"\>", ",", "\<\"G$288662$\"\>", 
     ",", "\<\"G$288663\"\>", ",", "\<\"G$288663$\"\>", 
     ",", "\<\"G$288664\"\>", ",", "\<\"G$288664$\"\>", 
     ",", "\<\"G$288665\"\>", ",", "\<\"G$288665$\"\>", 
     ",", "\<\"G$288734\"\>", ",", "\<\"G$288735\"\>", 
     ",", "\<\"G$288736\"\>", ",", "\<\"G$288737\"\>", 
     ",", "\<\"G$288745\"\>", ",", "\<\"G$288746\"\>", 
     ",", "\<\"G$288754\"\>", ",", "\<\"G$288755\"\>", 
     ",", "\<\"G$288756\"\>", ",", "\<\"G$288771\"\>", 
     ",", "\<\"G$289916\"\>", ",", "\<\"G$289917\"\>", 
     ",", "\<\"G$289930\"\>", ",", "\<\"G$289931\"\>", 
     ",", "\<\"G$291112\"\>", ",", "\<\"G$291113\"\>", 
     ",", "\<\"G$291126\"\>", ",", "\<\"G$291127\"\>", 
     ",", "\<\"G$292290\"\>", ",", "\<\"G$292291\"\>", 
     ",", "\<\"G$292304\"\>", ",", "\<\"G$292305\"\>", 
     ",", "\<\"G$292315\"\>", ",", "\<\"G$292316\"\>", 
     ",", "\<\"G$292317\"\>", ",", "\<\"G$292319\"\>", 
     ",", "\<\"G$292320\"\>", ",", "\<\"G$292321\"\>", 
     ",", "\<\"G$293486\"\>", ",", "\<\"G$293487\"\>", 
     ",", "\<\"G$293500\"\>", ",", "\<\"G$293501\"\>", 
     ",", "\<\"G$294656\"\>", ",", "\<\"G$294657\"\>", 
     ",", "\<\"G$294670\"\>", ",", "\<\"G$294671\"\>", 
     ",", "\<\"G$295827\"\>", ",", "\<\"G$295828\"\>", 
     ",", "\<\"G$295841\"\>", ",", "\<\"G$295842\"\>", 
     ",", "\<\"G$295852\"\>", ",", "\<\"G$295853\"\>", 
     ",", "\<\"G$295854\"\>", ",", "\<\"G$295856\"\>", 
     ",", "\<\"G$295857\"\>", ",", "\<\"G$295858\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$279987", "G$279988", "G$279996", "G$279997", "G$280005", "G$280006", 
    "G$280014", "G$280015", "G$280023", "G$280024", "G$280032", "G$280033", 
    "G$280041", "G$280042", "G$280050", "G$280051", "G$280059", "G$280060", 
    "G$288652", "G$288652$", "G$288653", "G$288653$", "G$288654", "G$288654$",
     "G$288655", "G$288655$", "G$288656", "G$288656$", "G$288657", 
    "G$288657$", "G$288658", "G$288658$", "G$288659", "G$288659$", "G$288660",
     "G$288660$", "G$288661", "G$288661$", "G$288662", "G$288662$", 
    "G$288663", "G$288663$", "G$288664", "G$288664$", "G$288665", "G$288665$",
     "G$288734", "G$288735", "G$288736", "G$288737", "G$288745", "G$288746", 
    "G$288754", "G$288755", "G$288756", "G$288771", "G$289916", "G$289917", 
    "G$289930", "G$289931", "G$291112", "G$291113", "G$291126", "G$291127", 
    "G$292290", "G$292291", "G$292304", "G$292305", "G$292315", "G$292316", 
    "G$292317", "G$292319", "G$292320", "G$292321", "G$293486", "G$293487", 
    "G$293500", "G$293501", "G$294656", "G$294657", "G$294670", "G$294671", 
    "G$295827", "G$295828", "G$295841", "G$295842", "G$295852", "G$295853", 
    "G$295854", "G$295856", "G$295857", "G$295858"}],
  Editable->
   False]], "Print",ExpressionUUID->"0032a1fb-6b70-4be6-b0ec-50329788f879"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.4.3. Products of an antisymmetric tensor", \
"Subsubsection",ExpressionUUID->"6327c75f-3288-4004-9ffa-e3b418a88385"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"2d3939fa-8ec1-4959-811c-472edc679ee4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e3f05e6f-43f4-4447-b78d-73c459d119a7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`UU[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8b47a31a-fbe7-4d5d-94da-6a5fb3df2a87"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "metricg", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"10bce2ff-b635-47e1-ba63-f3469780f1f9"],

Cell[CellGroupData[{

Cell[BoxData["$xpermQ"], \
"Input",ExpressionUUID->"27a66903-1647-46d2-afa4-d93d492be1f4"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"eacd13d4-0d76-4b10-92c6-a3e458529a1e"]
}, Open  ]],

Cell["Order of S is 2:", \
"Text",ExpressionUUID->"17272b2d-f6e1-4263-a8a0-6888ad6f1185"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "!"}], "/", 
  "2"}]], "Input",ExpressionUUID->"5d7e17a6-8c40-4abd-85e5-2a975eaa6dcf"],

Cell[BoxData["1"], \
"Output",ExpressionUUID->"703b7e66-a014-4c55-b68e-5b3c06738ba3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "B"}], "]"}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"3982d6d9-9884-4915-bdf7-d4ef1addea3f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0004919999999941638`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0004919999999941638, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"e962f2f2-10eb-4ce2-bbff-8b01a6ee7e46"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0034380000000027167`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm[
  "Dummy algorithm applied in ", 0.0034380000000027167`, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"d55e1759-5d9f-46df-87d3-ccd3c5fbd11c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00718599999999999967947861279071730678`3.877087126148255", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"e28676d6-6b81-4371-9864-2047a37bdd52"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{"UU", "[", 
       RowBox[{
        RowBox[{"-", "B"}], ",", "B"}], "]"}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"e134d2fe-28df-4607-9efc-2d9ffdf9af5a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00389300000000000019292900610423657781`3.610884316997786", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"51b33e53-a14e-4969-8880-e94ec2d62b7d"]
}, Open  ]],

Cell["Order of S is 2x4=8:", \
"Text",ExpressionUUID->"4169a3b5-e045-4cd2-a7ac-ace75d596ffb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"4", "!"}], "/", 
  "8"}]], "Input",ExpressionUUID->"a956ffdc-b604-44b1-b4da-209efe73e03d"],

Cell[BoxData["3"], \
"Output",ExpressionUUID->"99a8ac3e-07dd-421d-ab14-05544c30feb6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"bbbe0cfd-883f-48e1-ba99-cd30e6abcb83"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.00047800000000108867`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm[
  "Free algorithm applied in ", 0.00047800000000108867`, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"8b3946bc-bff2-479e-a641-760016dd1ffe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.021624999999986017`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.021624999999986017`, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"4cc8cbc4-1aa1-4bc0-ab95-48333d4d5e17"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.03453099999999999919486626254183647688`4.558809068756022", ",", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`A, -$CellContext`B],
      Editable->False]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"8856d7b6-25fa-4bf3-ae8c-cd21de19b2e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"5baee7a3-cf06-4b1d-b2af-4a7ba87fd25c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.00589000000000000027006175074006932846`3.790715208066726", ",", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`A, -$CellContext`B],
      Editable->False]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"7f8cf7c5-e708-457a-8657-37cabb0c4d48"]
}, Open  ]],

Cell["Order of S is 2x4x6=48:", \
"Text",ExpressionUUID->"225b73bb-2920-4d47-9f48-fd462a60e936"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"6", "!"}], "/", 
  "48"}]], "Input",ExpressionUUID->"0448b2f4-4503-4f56-a42e-0de9f0b1d001"],

Cell[BoxData["15"], \
"Output",ExpressionUUID->"291cf017-4a10-404e-889f-a4286af9e526"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"ff809fbb-5cf3-452b-bfb1-ccfcdf3a25dd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0005570000000005848`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0005570000000005848, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"7f639bc4-86ca-4a19-89ee-cd4091fb0ab3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.04715900000000772`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.04715900000000772, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"05d04988-73e1-4ad8-848a-2980dfd74ba0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.05952099999999999752064994140710041393`4.7952701323704305", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"c73f0f10-2f71-4a58-a00a-153686484133"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"34d9774a-962b-4e3c-a5fb-66c1f9418d5b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00702199999999999959626739709506182407`3.8670607384089566", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"55ef1021-91c9-4d73-9b5d-bb4b57ace03a"]
}, Open  ]],

Cell["Order of S is 2x4x6x8=384:", \
"Text",ExpressionUUID->"bc254386-fc0f-47ef-a9c3-1c7b956836bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"8", "!"}], "/", 
  "384"}]], "Input",ExpressionUUID->"ac5b692b-1c68-4aac-9f48-19a89baaebc8"],

Cell[BoxData["105"], \
"Output",ExpressionUUID->"bdea2d0e-2b8d-4f20-85d1-57a9b3e114d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"D", ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"599a73c8-aa1e-4cdb-bcfe-0a0472495958"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0006620000000054915`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0006620000000054915, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"3b8d648a-e598-4251-be1e-7ce64b15e61a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.11484099999999842`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.11484099999999842`, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"9ca17277-7a81-4261-9c95-8797ae3b09a5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.13235700000000000242650344262074213475`5.142346828172614", ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "C"},
            {"A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`A, C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`B, D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", " "},
            {"C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-C, -D],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"1d3a1e93-5bcc-4607-8c82-4595243d458f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"D", ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c17da58-1eca-46bc-afc8-638a0d7ecdb1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0092230000000000002952083022478291241`3.9854721219173994", ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "C"},
            {"A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`A, C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`B, D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", " "},
            {"C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-C, -D],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"3198f561-d89c-444f-aacf-beabf57b02fe"]
}, Open  ]],

Cell["Order of S is 2x4x6x8x10=3840:", \
"Text",ExpressionUUID->"6113e2f5-eb3f-4ba4-afd4-e5ee42b6b55d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"10", "!"}], "/", 
  "3840"}]], "Input",ExpressionUUID->"9d7eda34-5122-4d09-84b2-befd4769af58"],

Cell[BoxData["945"], \
"Output",ExpressionUUID->"6760736d-035e-48f6-a89e-96bfa83c8414"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"D", ",", "F"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "F"}], ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"a7b9286c-e6fa-464c-92d2-2daadb8d4739"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0007809999999892625`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0007809999999892625, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"4f18937b-fe9c-46a7-8cac-e8750cb2957e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.1907989999999984`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.1907989999999984, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"300b99a5-b5bf-47e3-9319-f83b8792e635"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.21280099999999999016431218024081317708`5.348573577755367", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"8d18241e-f57b-48d2-a735-9ce7afb2d389"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"D", ",", "F"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"71c1bdd1-bf49-4081-9ca8-55c86980c8cf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.01031800000000000078204109854596026707`4.034195436816914", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"02a1aec4-d16b-495c-a0c3-3790f0c0addf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"12", "!"}], "/", 
  "46080"}]], "Input",ExpressionUUID->"bebfcbd7-02fe-413d-8d94-8bbc22739eb2"],

Cell[BoxData["10395"], \
"Output",ExpressionUUID->"893957e3-1cd2-47b2-bb8b-8149e7f94e06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"D", ",", "F"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "F"}], ",", 
       RowBox[{"-", "G"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"G", ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"7e66172d-08b4-49ec-a6b6-bd8962a5e3dc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0008739999999960446`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0008739999999960446, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"b7b6b53b-50e4-4d96-b57f-d6e2fa7b8d9f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.36451900000000137`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.36451900000000137`, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"78f11500-538d-406c-ab1f-a4a8428463b7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.39211299999999998933120082256209570915`5.614011154291061", ",", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", "C"},
             {"A", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`A, C],
      Editable->False]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`B, D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "F"},
            {"C", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-C, $CellContext`F],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G"},
            {"D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-D, $CellContext`G],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", " "},
            {"F", "G"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`F, -$CellContext`G],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"a5e852a7-9bf7-4901-99b4-c75a2d06a4eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"D", ",", "F"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "G"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"G", ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"7ca39483-9706-4f2d-b07d-85abb31640ec"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01257699999999999963817831627466148348`4.120176974196332", ",", 
   RowBox[{
    RowBox[{"-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", "C"},
             {"A", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`A, C],
      Editable->False]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`B, D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "F"},
            {"C", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-C, $CellContext`F],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G"},
            {"D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-D, $CellContext`G],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", " "},
            {"F", "G"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`F, -$CellContext`G],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"9a1fc033-1198-4a74-a7fe-c1216b669a34"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"14", "!"}], "/", 
  "645120"}]], "Input",ExpressionUUID->"69bed136-f5b6-4e29-9e3c-528b46688375"],

Cell[BoxData["135135"], \
"Output",ExpressionUUID->"498808e5-0968-4dc3-a1bd-a36a74f628ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"D", ",", "F"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "F"}], ",", 
       RowBox[{"-", "G"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"G", ",", "G1"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "G1"}], ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"9b1fb55c-285a-4869-8cce-f638b2f6a4e1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0009380000000049904`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0009380000000049904, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"57e77112-001d-4d4b-92b5-e2d9f49d5e6f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.5629549999999881`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.5629549999999881, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"4cdf19f3-dbda-4ee2-bbc7-cb370876fa8d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.65226899999999998769339981663506478071`5.835026651837585", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"83fd83b2-d9a4-4412-9529-7dc7bb8f9df8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"D", ",", "F"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "G"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"G", ",", "G1"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "G1"}], ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"6d841adf-7d98-4769-994b-7db20e037d78"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.01445399999999999983424370242346412851`4.180587963661612", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"8f380275-d59d-4f64-a2fd-fc3480a93700"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"16", "!"}], "/", 
  "10321920"}]], \
"Input",ExpressionUUID->"f75b5ade-6e4c-4b0f-9251-11f45ec6c980"],

Cell[BoxData["2027025"], \
"Output",ExpressionUUID->"698e9217-71ae-428d-8c2c-5b46928e7f15"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"D", ",", "F"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "F"}], ",", 
       RowBox[{"-", "G"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"G", ",", "G1"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "G1"}], ",", 
       RowBox[{"-", "G2"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"G2", ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"ab1dc328-4ac0-4780-a4be-995e79c0dde5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.001027999999990925`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.001027999999990925, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"186e48db-2c91-41bb-956b-60c9be21548e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.8898260000000136`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.8898260000000136, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"f299a7d1-6a23-4ab3-8d89-c9c443f4d101"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.94663900000000000822808488010196015239`5.996784306012372", ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "C"},
            {"A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`A, C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`B, D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "F"},
            {"C", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-C, $CellContext`F],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G"},
            {"D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-D, $CellContext`G],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G1"},
            {"F", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`F, $CellContext`G1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G2"},
            {"G", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`G, $CellContext`G2],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", " "},
            {"G1", "G2"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`G1, -$CellContext`G2],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"267b5b59-ac11-4dae-843b-02561aa1fb04"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"D", ",", "F"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "G"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"G", ",", "G1"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "G1"}], ",", 
         RowBox[{"-", "G2"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"G2", ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"103338a5-f05e-4f25-b5ba-60dec3c29b5a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.02555400000000000032551739082009589765`4.428058803737017", ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "C"},
            {"A", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`A, C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "D"},
            {"B", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`B, D],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "F"},
            {"C", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-C, $CellContext`F],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G"},
            {"D", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-D, $CellContext`G],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G1"},
            {"F", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`F, $CellContext`G1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", "G2"},
            {"G", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`G, $CellContext`G2],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"UU", 
         StyleBox[GridBox[{
            {" ", " "},
            {"G1", "G2"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`UU[-$CellContext`G1, -$CellContext`G2],
     Editable->False]}]}], 
  "}"}]], "Output",ExpressionUUID->"a7502bde-bba2-44c0-872e-8f7bd76709c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"A", ",", "C"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"D", ",", "F"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "F"}], ",", 
       RowBox[{"-", "G"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"G", ",", "G1"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "G1"}], ",", 
       RowBox[{"-", "G2"}]}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{"G2", ",", "G3"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "G3"}], ",", "B"}], "]"}]}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"3e2cb074-f469-4822-b356-0f340d7380d8"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0013820000000066557`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0013820000000066557`, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"2264f190-e053-4846-acf0-d2fb160b8586"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "1.2234090000000037`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 1.2234090000000037`, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"8db88230-bf12-48a3-93cb-e44d239d103e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.32414600000000004520472884905757382512`6.142535786222134", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"ec067d36-e0b0-4dbb-85d3-746ea7294be9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "A"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"A", ",", "C"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "D"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"D", ",", "F"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "F"}], ",", 
         RowBox[{"-", "G"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"G", ",", "G1"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "G1"}], ",", 
         RowBox[{"-", "G2"}]}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{"G2", ",", "G3"}], "]"}], 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "G3"}], ",", "B"}], "]"}]}], ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"1a3d2f12-1f95-4414-920d-8fdb85d4e259"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.01879099999999999867639211004188837251`4.294549805829632", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"3dc41d54-3730-4443-84f3-97618e52771c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "UU"}]], "Input",ExpressionUUID->"fb8029be-336e-4d4b-bc69-62c5284a0d6a"],

Cell[CellGroupData[{

Cell["Global`UU", "Print", "PrintUsage",
 CellTags->
  "Info3578672959-5338953",ExpressionUUID->"0f0107ff-43ae-4a5b-9f17-\
fb5add370645"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "UU", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "UU", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`UU],
          Editable->False], "^=", "UU"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "UU", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "UU", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "UU", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "UU", "]"}], "^=", "\<\"UU\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "UU", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "UU", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            InterpretationBox[
             StyleBox[
              RowBox[{"-", 
               RowBox[{"(", "1", ",", "2", ")"}]}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             -xAct`xPerm`Cycles[{1, 2}],
             Editable->False], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "UU", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "UU", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`UU],
  Editable->False]], "Print",
 CellTags->
  "Info3578672959-5338953",ExpressionUUID->"b8c361d9-0a05-45a8-9a1d-\
805f2ab21bc1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "UU", 
  "]"}]], "Input",ExpressionUUID->"1ec18d7f-ce8e-4f41-a43d-7ac048c78cb7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "UU"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`UU],
  Editable->
   False]], "Print",ExpressionUUID->"b673df36-83bc-4065-a71f-c3afa49ebef2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"7c711120-81c5-4291-8f68-d5d42721cc4b"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"54d97365-b1ed-4748-a169-b5d5b8ff4c6f"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.4.4. Products of Riemann tensors", \
"Subsubsection",ExpressionUUID->"4b0afb06-f145-421d-baf5-13d1ef48a350"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"24c2f5fc-7056-45f2-95c7-e8baa40d3ecf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"RiemannSymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1d32aa75-a6aa-4063-99f6-8665d16478c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Rie", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Rie[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b52237cd-ad6c-458d-8d6d-168504ac6ece"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"58e9e702-c6b1-40ae-8c7c-835ee103fb70"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4166261a-9ea7-4f41-bf71-21778b1b19b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"52467771-8bfd-494b-b4ba-9c7b6b64a03d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f7b4737c-f9d5-4f0d-ac71-7a80f9e03c6b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "metricg", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"312799cf-b987-4a07-8c8c-6b2915189c93"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Rie"}]], "Input",ExpressionUUID->"9fdba7d6-5bb2-454c-88b8-49b520af98be"],

Cell[CellGroupData[{

Cell["Global`Rie", "Print", "PrintUsage",
 CellTags->
  "Info3578672961-5338953",ExpressionUUID->"2b85d4be-fcf7-4f22-b51a-\
e8cbb239e34a"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Rie", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", "Rie", "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`Rie],
          Editable->False], "^=", "Rie"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Rie", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"tensor\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DependenciesOfTensor", "[", "Rie", "]"}], "^=", 
         RowBox[{"{", "M2", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Rie", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Rie", "]"}], "^=", "\<\"Rie\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SlotsOfTensor", "[", "Rie", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}], ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]M2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentM2,
             Editable->False]}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SymmetryGroupOfTensor", "[", "Rie", "]"}], "^=", 
         RowBox[{"StrongGenSet", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
           RowBox[{"GenSet", "[", 
            RowBox[{
             InterpretationBox[
              StyleBox[
               RowBox[{"-", 
                RowBox[{"(", "1", ",", "2", ")"}]}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              -xAct`xPerm`Cycles[{1, 2}],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{"-", 
                RowBox[{"(", "3", ",", "4", ")"}]}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              -xAct`xPerm`Cycles[{3, 4}],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                RowBox[{"(", "1", ",", "3", ")"}], 
                RowBox[{"(", "2", ",", "4", ")"}]}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              xAct`xPerm`Cycles[{1, 3}, {2, 4}],
              Editable->False]}], "]"}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"TensorID", "[", "Rie", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"xTensorQ", "[", "Rie", "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Rie],
  Editable->False]], "Print",
 CellTags->
  "Info3578672961-5338953",ExpressionUUID->"3b1db005-7efd-4f9c-a87b-\
463eb5101cb3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetIndicesOfVBundle", "[", 
  RowBox[{"TangentM2", ",", "10"}], 
  "]"}]], "Input",ExpressionUUID->"0c1236dd-07e4-4a40-bbbf-0b5e40df80ad"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "A", ",", "B", ",", "C", ",", "D", ",", "F", ",", "G", ",", "G1", ",", "G2",
    ",", "G3", ",", "G4"}], 
  "}"}]], "Output",ExpressionUUID->"4f1bb6d5-fed0-4af0-af46-044f8cf84125"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"myterm", "=", 
   RowBox[{
    RowBox[{"Rie", "[", 
     RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
    RowBox[{"Rie", "[", 
     RowBox[{"G", ",", "F", ",", "G1", ",", "G2"}], "]"}], 
    RowBox[{"Rie", "[", 
     RowBox[{"G3", ",", 
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "G4"}], ",", 
      RowBox[{"-", "G"}]}], "]"}], 
    RowBox[{"Rie", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "G3"}]}], "]"}], 
    RowBox[{"Rie", "[", 
     RowBox[{
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "G1"}], ",", 
      RowBox[{"-", "G2"}], ",", "G4"}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"96258af2-721a-4c1c-aa69-1e0e4019a267"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", 
   RowBox[{"myterm", ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], \
"Input",ExpressionUUID->"b274c86f-d19e-4753-9afe-4103c794a08e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.0012490000000013879`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.0012490000000013879`, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"aafcef74-e5c4-4605-925f-4a5ede3c7109"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.6311059999999884`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.6311059999999884, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"f2cc711c-2554-4121-8b15-a637f4fe0aad"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.66297099999999997699262621608795598149`5.8420944449793755", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"6b2c819d-e650-4f74-80f1-62700dc24860"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{
    RowBox[{"ToCanonical", "[", 
     RowBox[{"myterm", ",", 
      RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}], "//", 
    "AbsoluteTiming"}]}], 
  "]"}]], "Input",ExpressionUUID->"eb2e3b4c-645b-4e6a-9e0c-4adc9b10e58c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.02025199999999999916910908837053284515`4.327067831994428", ",", "0"}], 
  "}"}]], "Output",ExpressionUUID->"62a07e48-b8f2-4e9f-a9f1-c79c065f40a8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"myterm", "=", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"G1", ",", 
      RowBox[{"-", "G"}], ",", "G2", ",", "G3"}], "]"}], " ", 
    RowBox[{"Rie", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}], ",", "A", ",", "D"}], "]"}], " ", 
    RowBox[{"Rie", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", "C", ",", 
      RowBox[{"-", "A"}], ",", "G"}], "]"}], " ", 
    RowBox[{"Rie", "[", 
     RowBox[{
      RowBox[{"-", "G1"}], ",", "G4", ",", "F", ",", "B"}], "]"}], " ", 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "G2"}], ",", 
      RowBox[{"-", "G3"}]}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"3bd7ecf5-0900-488c-8f4f-bf151bf006fc"],

Cell[TextData[{
 "Depending on the Booleans $CommutingFreeIndices and OrderedBase we have 4 \
possibilities. We also check that we get the same result with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " and with the external executable:"
}], "Text",ExpressionUUID->"9858d9ee-9b21-458e-a6f6-6df95084209b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CommuteFreeIndices", "=", "True"}], 
  ";"}]], "Input",ExpressionUUID->"eeed46da-1bd9-42d5-90dd-758d9fe3ffa0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r1", "=", 
  RowBox[{"ToCanonical", "[", 
   RowBox[{"myterm", ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"45bdda4c-1673-4e68-be60-a56a520fa1c9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.05254399999998327`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.05254399999998327, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"b0cb88a0-a90e-426e-878c-2980c53fc920"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.28883100000001605`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.28883100000001605`, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"7b542998-0148-4e48-b4c6-39a6fc18620d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"B", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-$CellContext`B, $CellContext`G1, $CellContext`G2, \
$CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "G", "G4", " "},
          {" ", " ", " ", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, $CellContext`G, $CellContext`G4, \
-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"G", "G2", "G1", "G3"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C, -D],
   Editable->
    False]}]], "Output",ExpressionUUID->"97c0b3fa-825d-43c4-b079-973e410178ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{"ToCanonical", "[", 
    RowBox[{"myterm", ",", 
     RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"433609c2-fcd9-40e4-b66e-31ef2fce834e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"B", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-$CellContext`B, $CellContext`G1, $CellContext`G2, \
$CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "G", "G4", " "},
          {" ", " ", " ", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, $CellContext`G, $CellContext`G4, \
-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"G", "G2", "G1", "G3"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C, -D],
   Editable->
    False]}]], "Output",ExpressionUUID->"5c6378bc-013b-44f1-b2b5-bae6704d38ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r2", "=", 
  RowBox[{"ToCanonical", "[", 
   RowBox[{"myterm", ",", 
    RowBox[{"OrderedBase", "\[Rule]", "False"}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"3af46607-e6e6-40e7-ba9a-0c695e7fb3cf"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.006834999999981051`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.006834999999981051, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"48ed13e6-7cf5-4d4b-a3c1-c1b73238ca62"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.2566050000000075`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.2566050000000075, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"2ff2d4c3-0406-4b07-8eeb-a4389845e6d9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"D", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-D, $CellContext`G1, $CellContext`G2, $CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "D", "G4", "G"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, D, $CellContext`G4, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", "A"},
          {"G1", "G2", "G3", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {" ", " ", "B", "C"},
          {"G", "A", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[-$CellContext`G, -$CellContext`A, $CellContext`B, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"ab8954e2-55a3-4107-be0d-d97dfb1af8b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{"ToCanonical", "[", 
    RowBox[{"myterm", ",", 
     RowBox[{"OrderedBase", "\[Rule]", "False"}], ",", 
     RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8499e9c7-7a41-4dce-af2d-0646acfdf64f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"D", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-D, $CellContext`G1, $CellContext`G2, $CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "D", "G4", "G"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, D, $CellContext`G4, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", "A"},
          {"G1", "G2", "G3", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {" ", " ", "B", "C"},
          {"G", "A", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[-$CellContext`G, -$CellContext`A, $CellContext`B, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"d939cda8-4378-49ba-b11c-a35564e9ca7f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CommuteFreeIndices", "=", "False"}], 
  ";"}]], "Input",ExpressionUUID->"b966764a-dab1-4c31-b589-00ca10f289ce"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r3", "=", 
  RowBox[{"ToCanonical", "[", 
   RowBox[{"myterm", ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"8545a2c0-10f1-4781-8030-c6124bb82d82"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.05242300000000455`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.05242300000000455, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"373b6ee6-88b5-4b6d-9308-944b8974505e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.28907599999999434`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.28907599999999434`, " secs."],
  
  Editable->
   False]], "Print",ExpressionUUID->"d898fbf3-c894-4729-a4ac-0b64bda02627"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"B", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-$CellContext`B, $CellContext`G1, $CellContext`G2, \
$CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "G", "G4", " "},
          {" ", " ", " ", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, $CellContext`G, $CellContext`G4, \
-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"G", "G2", "G1", "G3"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C, -D],
   Editable->
    False]}]], "Output",ExpressionUUID->"5b39f44f-2990-42d3-9587-5dfe26ee9593"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{"ToCanonical", "[", 
    RowBox[{"myterm", ",", 
     RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4178081b-8f44-4248-885f-e096214cbbe8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"B", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-$CellContext`B, $CellContext`G1, $CellContext`G2, \
$CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "G", "G4", " "},
          {" ", " ", " ", "A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, $CellContext`G, $CellContext`G4, \
-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", " "},
          {"G", "G2", "G1", "G3"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-C, -D],
   Editable->
    False]}]], "Output",ExpressionUUID->"cab5f06d-34ee-47c2-9982-2c8786eefa03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r4", "=", 
  RowBox[{"ToCanonical", "[", 
   RowBox[{"myterm", ",", 
    RowBox[{"OrderedBase", "\[Rule]", "False"}], ",", 
    RowBox[{"TimeVerbose", "\[Rule]", "True"}], ",", 
    RowBox[{"MathLink", "\[Rule]", "False"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"32aa1213-a443-4a47-a0c4-fa84cec6d8eb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Free algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.007122999999992885`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Free algorithm applied in ", 0.007122999999992885, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"114c48a6-54c4-4aed-a596-0ebc2d498002"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Dummy algorithm applied in \"\>", "\[InvisibleSpace]", 
   "0.2566980000000001`", "\[InvisibleSpace]", "\<\" secs.\"\>"}],
  SequenceForm["Dummy algorithm applied in ", 0.2566980000000001, " secs."],
  Editable->
   False]], "Print",ExpressionUUID->"842ae153-afd7-4eb2-be8c-16121a7b3637"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"D", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-D, $CellContext`G1, $CellContext`G2, $CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "D", "G4", "G"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, D, $CellContext`G4, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", "A"},
          {"G1", "G2", "G3", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {" ", " ", "B", "C"},
          {"G", "A", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[-$CellContext`G, -$CellContext`A, $CellContext`B, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"9ba34de7-b936-4e5e-b1f5-856130e825a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{"ToCanonical", "[", 
    RowBox[{"myterm", ",", 
     RowBox[{"OrderedBase", "\[Rule]", "False"}], ",", 
     RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"737d87b0-64e4-4772-b354-b2dcea4eb099"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Rie", 
        StyleBox[GridBox[{
           {" ", "G1", "G2", "G3"},
           {"D", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Rie[-D, $CellContext`G1, $CellContext`G2, $CellContext`G3],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {"F", "D", "G4", "G"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[$CellContext`F, D, $CellContext`G4, $CellContext`G],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Rie", 
       StyleBox[GridBox[{
          {" ", " ", " ", "A"},
          {"G1", "G2", "G3", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"S", 
       StyleBox[GridBox[{
          {" ", " ", "B", "C"},
          {"G", "A", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`S[-$CellContext`G, -$CellContext`A, $CellContext`B, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"87036712-c83e-4bfe-9035-8b71756c3b9c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"r1", ",", "r2", ",", "r3", ",", "r4"}], "}"}], "//", 
  "ColumnForm"}]], \
"Input",ExpressionUUID->"61666683-1fa5-4171-8703-a5d27d478783"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Rie", 
            StyleBox[GridBox[{
               {" ", "G1", "G2", "G3"},
               {"B", " ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rie[-$CellContext`B, $CellContext`G1, $CellContext`G2, \
$CellContext`G3],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {"F", "G", "G4", " "},
              {" ", " ", " ", "A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[$CellContext`F, $CellContext`G, $CellContext`G4, \
-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {" ", " ", " ", " "},
              {"G", "G2", "G1", "G3"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {"A", "B", "C", "D"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[$CellContext`A, $CellContext`B, C, D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -D],
       Editable->False]}]},
    {
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Rie", 
            StyleBox[GridBox[{
               {" ", "G1", "G2", "G3"},
               {"D", " ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rie[-
         D, $CellContext`G1, $CellContext`G2, $CellContext`G3],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {"F", "D", "G4", "G"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[$CellContext`F, D, $CellContext`G4, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {" ", " ", " ", "A"},
              {"G1", "G2", "G3", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " ", "B", "C"},
              {"G", "A", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-$CellContext`G, -$CellContext`A, $CellContext`B, C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"B", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, -C],
       Editable->False]}]},
    {
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Rie", 
            StyleBox[GridBox[{
               {" ", "G1", "G2", "G3"},
               {"B", " ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rie[-$CellContext`B, $CellContext`G1, $CellContext`G2, \
$CellContext`G3],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {"F", "G", "G4", " "},
              {" ", " ", " ", "A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[$CellContext`F, $CellContext`G, $CellContext`G4, \
-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {" ", " ", " ", " "},
              {"G", "G2", "G1", "G3"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {"A", "B", "C", "D"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[$CellContext`A, $CellContext`B, C, D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -D],
       Editable->False]}]},
    {
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"Rie", 
            StyleBox[GridBox[{
               {" ", "G1", "G2", "G3"},
               {"D", " ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rie[-
         D, $CellContext`G1, $CellContext`G2, $CellContext`G3],
        Editable->False]}], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {"F", "D", "G4", "G"},
              {" ", " ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[$CellContext`F, D, $CellContext`G4, $CellContext`G],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"Rie", 
           StyleBox[GridBox[{
              {" ", " ", " ", "A"},
              {"G1", "G2", "G3", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " ", "B", "C"},
              {"G", "A", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-$CellContext`G, -$CellContext`A, $CellContext`B, C],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"B", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, -C],
       Editable->False]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{((((-$CellContext`Rie[-$CellContext`B, $CellContext`G1, \
$CellContext`G2, $CellContext`G3]) $CellContext`Rie[$CellContext`F, \
$CellContext`G, $CellContext`G4, -$CellContext`A]) \
$CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3]) $CellContext`S[$CellContext`A, $CellContext`B, C, 
       D]) $CellContext`T[-C, -
      D], ((((-$CellContext`Rie[-
          D, $CellContext`G1, $CellContext`G2, $CellContext`G3]) \
$CellContext`Rie[$CellContext`F, 
         D, $CellContext`G4, $CellContext`G]) \
$CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A]) $CellContext`S[-$CellContext`G, -$CellContext`A, \
$CellContext`B, C]) $CellContext`T[-$CellContext`B, -
      C], ((((-$CellContext`Rie[-$CellContext`B, $CellContext`G1, \
$CellContext`G2, $CellContext`G3]) $CellContext`Rie[$CellContext`F, \
$CellContext`G, $CellContext`G4, -$CellContext`A]) \
$CellContext`Rie[-$CellContext`G, -$CellContext`G2, -$CellContext`G1, \
-$CellContext`G3]) $CellContext`S[$CellContext`A, $CellContext`B, C, 
       D]) $CellContext`T[-C, -
      D], ((((-$CellContext`Rie[-
          D, $CellContext`G1, $CellContext`G2, $CellContext`G3]) \
$CellContext`Rie[$CellContext`F, 
         D, $CellContext`G4, $CellContext`G]) \
$CellContext`Rie[-$CellContext`G1, -$CellContext`G2, -$CellContext`G3, \
$CellContext`A]) $CellContext`S[-$CellContext`G, -$CellContext`A, \
$CellContext`B, C]) $CellContext`T[-$CellContext`B, -C]}],
  Editable->
   False]], "Output",ExpressionUUID->"623cbbaa-18fb-4189-9596-189fba04f102"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"Rie", ",", "T", ",", "S"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"17c4f94a-7fe4-47a7-81d3-9f0e571f2715"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Rie"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`Rie],
  Editable->
   False]], "Print",ExpressionUUID->"9cf3ac71-9100-4dde-ae57-125aded30803"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"8512f299-7cd4-438b-9b2c-0d55cfa1ff2f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"42ff3dde-6f01-4f2e-bd78-f60733109697"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"A", ",", "B"}], "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"A", ",", "B"}], "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"81fee33b-daa7-42a7-aa8f-818c668a1fb4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9943cb45-46ff-4cda-a5a4-4f62fd0f8fcd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bb897dde-7d5d-4ae1-b788-1a210b9d040a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"UU", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`UU[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2d7685d8-d76d-45f6-b23e-f93e17768a17"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"638566e8-494a-4b5a-8618-5ea460c5b983"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "B"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", "D"}], "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "D"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], "//", 
  "xSort"}]], "Input",ExpressionUUID->"f9d7ff39-234a-4467-8e3e-0b1da8e20e28"],

Cell[BoxData[
 TagBox[
  TooltipBox[
   UnderscriptBox[
    RowBox[{
     RowBox[{"(", 
      TagBox[
       TooltipBox[
        UnderscriptBox["Times", "_"],
        RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
       #& ], ")"}], "[", 
     RowBox[{
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"T", 
                   StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T[$CellContext`A, $CellContext`B],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                  False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"T", 
                   StyleBox[GridBox[{
                    {"C", "D"},
                    {" ", " "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T[C, D],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`T[C, D], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                    False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[C, D], Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[C, D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, D],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, D],
                  Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         RowBox[{
          RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"],
             RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]],
            #& ], ")"}], "[", 
          RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"V", 
                   StyleBox[GridBox[{
                    {" "},
                    {"B"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`V[-$CellContext`B],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`V[-$CellContext`B], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
            #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"V", 
                   StyleBox[GridBox[{
                    {" "},
                    {"D"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`V[-D],
               Editable->False], "_"],
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`V[-D], Editable -> False], ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
            #& ]}], "]"}], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            RowBox[{
              RowBox[{"(", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox["Times", "_"], 
                  RowBox[{"\"CommutingObjects\"", "[", "Times", "]"}]], #& ], 
                ")"}], "[", 
              RowBox[{
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-$CellContext`B], Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-$CellContext`B], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                TagBox[
                 TooltipBox[
                  UnderscriptBox[
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-D], Editable -> False], "_"], 
                  RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
            ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", "1", "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"V", ",", "V"}], "}"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -D], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`B, -D], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
       #& ], ",", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"UU", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "C"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`UU[-$CellContext`A, -C],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              GridBox[{{"UU", 
                 StyleBox[
                  
                  GridBox[{{" ", " "}, {"A", "C"}}, RowSpacings -> 0, 
                   ColumnSpacings -> 0.05, 
                   GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                  Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
               Center], AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`UU[-$CellContext`A, -C], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", "2", ",", "UU"}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`A, -C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`A, -C], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                 Editable -> False]}], "}"}]}], "]"}]],
       #& ]}], "]"}], "_"],
   RowBox[{"\"Object\"", "[", 
     RowBox[{
       RowBox[{
         RowBox[{"(", 
           TagBox[
            TooltipBox[
             UnderscriptBox["Times", "_"], 
             RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], ")"}],
          "[", 
         RowBox[{
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                 "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                    False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[C, D], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[C, D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                    False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"A", "B"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[$CellContext`A, $CellContext`B], Editable -> 
                    False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[C, D], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{"C", "D"}, {" ", " "}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[C, D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "T"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "C", 
                    "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[C, D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
                    D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    "\",\"", "B", "\",\"", "C", "\",\"", "D", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
                    D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              RowBox[{
                RowBox[{"(", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                 "[", 
                RowBox[{
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-$CellContext`B], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-$CellContext`B], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                  TagBox[
                   TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-D], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
              "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox["Times", "_"], 
                    
                    RowBox[{
                    "\"CommutingObjects\"", "[", "Times", "]"}]], #& ], ")"}],
                    "[", 
                   RowBox[{
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-$CellContext`B], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"B"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-$CellContext`B], Editable -> False], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
                    TagBox[
                    TooltipBox[
                    UnderscriptBox[
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-D], Editable -> False], "_"], 
                    RowBox[{"\"Object\"", "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{" "}, {"D"}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[-D], Editable -> False], ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-D], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", "1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"V", ",", "V"}], "}"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "D"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -D], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
           TagBox[
            TooltipBox[
             UnderscriptBox[
              InterpretationBox[
               StyleBox[
                GridBox[{{"UU", 
                   StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "C"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`UU[-$CellContext`A, -C], Editable -> False], "_"], 
             RowBox[{"\"Object\"", "[", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   GridBox[{{"UU", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "C"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`UU[-$CellContext`A, -C], Editable -> False], 
                 ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "2", ",", "UU"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "C"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -C], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
       RowBox[{"{", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"Tensor", ",", "Tensor"}], "}"}]}], "}"}], ",", 
                   "Tensor"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", "2", "}"}], ",", 
           RowBox[{"{", 
             RowBox[{"Times", ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"T", ",", "T"}], "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Times", ",", 
                    RowBox[{"{", 
                    RowBox[{"V", ",", "V"}], "}"}]}], "}"}], ",", "UU"}], 
                 "}"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
               "B", "\",\"", "C", "\",\"", "D", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", 
               RowBox[{"-", "D"}], "\",\"", 
               RowBox[{"-", "A"}], "\",\"", 
               RowBox[{"-", "C"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, C, 
             D, -$CellContext`B, -D, -$CellContext`A, -C], Editable -> False],
            ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
               RowBox[{"-", "B"}], "\",\"", "B", "\",\"", 
               RowBox[{"-", "C"}], "\",\"", "C", "\",\"", 
               RowBox[{"-", "D"}], "\",\"", "D", 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B, -C, C, -D, D], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            xAct`xTensor`IndexList[], Editable -> False], ",", 
           InterpretationBox[
            StyleBox[
             RowBox[{
               StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
               RowBox[{"{", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
               StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
             False, ShowAutoStyles -> False], 
            
            xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
            Editable -> False]}], "}"}]}], "]"}]],
  #& ]], "Output",ExpressionUUID->"b43d475f-daf8-4a1e-94b1-d66902b17880"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "B"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", "D"}], "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "D"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "C"}]}], "]"}]}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"cf5b3387-1cf3-4669-a773-a903b7e06183"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"5ee10196-e52f-4c7d-8a25-32a75e9b7ad6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "S", ",", "UU", ",", "V"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"1c0797c6-186a-431a-8876-df298e570ab2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"24bef978-d137-4283-b290-b159881f1e88"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"4d8b389f-f8d9-49c9-8c54-ed53e30e90f4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "UU"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`UU],
  Editable->
   False]], "Print",ExpressionUUID->"da976f15-4ec8-4718-b8c2-7d98b3c3c9a9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"29e60d7e-a753-4ec9-b2ef-f9bd5cfd0423"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"445bb1d7-3926-401b-94da-79b12dae5db3"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"myterm", ",", "r1", ",", "r2", ",", "r3", ",", "r4"}], 
  "]"}]], "Input",ExpressionUUID->"147cb486-9f64-424c-a71e-fbb8bc2e1383"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"25dbc09b-5741-4ba5-94c3-3ee6a032fa23"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"G4\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"G4"}],
  Editable->
   False]], "Print",ExpressionUUID->"a7f97b55-2aa7-49e5-8511-8138a143a1e8"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.4.5. More examples with derivatives", "Subsubsection",ExpressionUUID->
 "89422322-5210-4926-bafe-96bb44541f49"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"805d7fca-f831-4953-85c7-5330edbebe86"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"632b3386-1bc6-4f1b-b27e-b1206a8d2e5a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a10a1240-5d2b-4050-99f9-85b0b19ad845"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<D\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"2309aae9-e665-43ed-bfc5-ed485ab8cf0e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"85681170-243e-4865-9a65-77c4e2129abe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d3bea7b8-f433-4930-9db8-7a4a6caf70e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"709c9781-3b5e-4510-aff0-2afcb22e5e7f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"7e7ab0df-e8a7-46ac-9ddd-f3516d646aa9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9e23244b-d476-482b-b496-c8c186685d8c"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"764e525a-d7dd-4b10-a85d-2bdc8c0c4cb4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "cd", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"26ef1558-5f68-4764-a4d9-48cbbc46e15e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`g[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9d8394bb-9d88-4f35-bada-6b863d58cdb7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilong", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilong[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8b76305d-fe4f-4083-b48b-37a262b2d93e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"88e8f3bb-2efd-42d5-9b71-5327c496dd98"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Torsioncd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`Torsioncd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7d941013-b85d-4eca-a11d-fe7645bc0c41"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Christoffelcd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`Christoffelcd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"d232a670-8a0a-4f9a-8a8c-51a9ad631780"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Riemanncd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`Riemanncd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"da6a87c9-181a-4dac-9a6b-459af3bfd55e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Riccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`Riccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c4a5fa57-332c-4bc1-9179-666ff4938598"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"31ef8b0f-614d-46e2-9550-7e5eadc09172"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarcd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarcd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"eceb22be-f753-4faf-b295-2e4de1b0c9fe"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"c3b6728c-3617-4c82-8507-9966d601ce20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Einsteincd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`Einsteincd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f2641b8f-537a-44bd-9275-6043993728f0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Weylcd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`Weylcd[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e4dde8cd-9a61-4321-8c10-e05fa7b14ad4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRiccicd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRiccicd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3285b70a-fc67-42b0-ac33-55b699bbe3d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"Kretschmanncd", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`Kretschmanncd[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6fbd8f48-287f-4834-bcd8-be9f0a990615"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"c8131985-4466-46e2-afcb-30f17d91f1db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"7d431ce9-9600-44e9-9900-8cb4c98d7b52"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"46ac7c75-b3e1-443e-919e-aab1c9e9ebd3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"3f9d94cf-012e-414c-af70-9a04f4556e7b"]
}, Open  ]]
}, Open  ]],

Cell["For example we could have this divergence:", \
"Text",ExpressionUUID->"3be0f0b8-f13c-4a11-8b42-3bdc14e20bd4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`addTMPCovD", "[", 
   RowBox[{
    RowBox[{"CD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "C"}], "]"}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"d3431773-a446-4013-9932-b2d5de2fcbde"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"ChristoffelcdCD", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`ChristoffelcdCD[$CellContext`A, -$CellContext`B, -C], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"56bb9735-48d3-4906-b621-141efdb8939b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
         StyleBox[GridBox[{
            {"C", " ", " "},
            {" ", "A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelcdCD[C, -$CellContext`A, -$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
        StyleBox[GridBox[{
           {"A", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelcdCD[$CellContext`A, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{"TMPCovD", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "C", "  "},
             {" ", " ", 
              RowBox[{";", "A"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`cd[-$CellContext`A][
       $CellContext`T[$CellContext`A, C]],
      Editable->False], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Private`TMPCovD[
    $CellContext`cd[-$CellContext`A][
     $CellContext`T[$CellContext`A, C]], $CellContext`CD],
   Editable->
    False]}]], "Output",ExpressionUUID->"bb26b41e-1a8f-40d7-9636-d8c727350626"]
}, Open  ]],

Cell["We fake some canonicalization process:", \
"Text",ExpressionUUID->"c8995da6-63b6-4df3-b9e5-63fe7999d47c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"A", "\[Rule]", 
   RowBox[{
   "-", "A"}]}]}]], \
"Input",ExpressionUUID->"d1fbab40-077a-4de3-9b80-e6fddf690ad3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
         StyleBox[GridBox[{
            {"C", "A", " "},
            {" ", " ", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B"},
           {"A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
        StyleBox[GridBox[{
           {" ", "A", " "},
           {"A", " ", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelcdCD[-$CellContext`A, $CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{"TMPCovD", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "C", 
              RowBox[{";", "A"}]},
             {"A", " ", "  "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`cd[$CellContext`A][
       $CellContext`T[-$CellContext`A, C]],
      Editable->False], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Private`TMPCovD[
    $CellContext`cd[$CellContext`A][
     $CellContext`T[-$CellContext`A, C]], $CellContext`CD],
   Editable->
    False]}]], "Output",ExpressionUUID->"62f94d9d-2bbf-4c67-8c4a-3ae6b6eee9b4"]
}, Open  ]],

Cell["Then remove temporary derivative:", \
"Text",ExpressionUUID->"8405e53a-4621-439e-9854-a4cc88b57c76"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "xATP`removeTMPCovD"}]], \
"Input",ExpressionUUID->"a9c23782-1d32-4e0e-93f4-97045f072179"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
         StyleBox[GridBox[{
            {"C", "A", " "},
            {" ", " ", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B"},
           {"A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
        StyleBox[GridBox[{
           {" ", "A", " "},
           {"A", " ", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelcdCD[-$CellContext`A, $CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "G$300228"},
           {"A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`G$300228],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", 
            RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
           StyleBox[GridBox[{
              {"C", "A", " "},
              {" ", " ", "G$300228"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`G$300228],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`G$300228]],
    
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "C"},
           {"G$300227", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`G$300227, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", 
            RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
           StyleBox[GridBox[{
              {"G$300227", "A", " "},
              {" ", " ", "A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelcdCD[$CellContext`G$300227, $CellContext`A, \
-$CellContext`A],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`ChristoffelcdCD[$CellContext`G$300227, $CellContext`A, \
-$CellContext`A]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", 
           RowBox[{";", "A"}]},
          {"A", " ", "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[$CellContext`A][
    $CellContext`T[-$CellContext`A, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"277786a9-58c4-49f8-b8f6-e1d46e80c6d2"]
}, Open  ]],

Cell["Simplify:", \
"Text",ExpressionUUID->"66ffc666-4578-489f-ae7a-c8358754136b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "SameDummies"}]], \
"Input",ExpressionUUID->"b3ee214c-1c9c-41a9-b2be-f8196cc7f7d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
         StyleBox[GridBox[{
            {"C", "A", " "},
            {" ", " ", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B"},
           {"A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
        StyleBox[GridBox[{
           {" ", "A", " "},
           {"A", " ", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelcdCD[-$CellContext`A, $CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "C"},
           {"B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", 
            RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
           StyleBox[GridBox[{
              {"B", "A", " "},
              {" ", " ", "A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelcdCD[$CellContext`B, $CellContext`A, \
-$CellContext`A],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`ChristoffelcdCD[$CellContext`B, $CellContext`A, \
-$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "B"},
           {"A", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", 
            RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
           StyleBox[GridBox[{
              {"C", "A", " "},
              {" ", " ", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`B],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`ChristoffelcdCD[C, $CellContext`A, -$CellContext`B]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", 
           RowBox[{";", "A"}]},
          {"A", " ", "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[$CellContext`A][
    $CellContext`T[-$CellContext`A, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"38c89fe8-7c65-4ff7-8d4a-9b43551a359f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{
  "xATP`TMPChristoffel", "\[Rule]", 
   "Identity"}]}]], \
"Input",ExpressionUUID->"a8d9c511-b597-460c-8953-82b2ee76deaa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"\[CapitalGamma]", "[", 
          RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
         StyleBox[GridBox[{
            {"B", "A", " "},
            {" ", " ", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ChristoffelcdCD[$CellContext`B, $CellContext`A, \
-$CellContext`A],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "C"},
           {"B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, C],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"\[EmptyDownTriangle]", ",", "D"}], "]"}], 
        StyleBox[GridBox[{
           {" ", "A", " "},
           {"A", " ", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelcdCD[-$CellContext`A, $CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", 
           RowBox[{";", "A"}]},
          {"A", " ", "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[$CellContext`A][
    $CellContext`T[-$CellContext`A, C]],
   Editable->
    False]}]], "Output",ExpressionUUID->"a06d9c98-d900-4ed3-83b5-6513d22c4852"]
}, Open  ]],

Cell["\<\
That requires some additional canonicalization or transformation to \
derivatives of the metric:\
\>", "Text",ExpressionUUID->"fb83fcd5-292b-4932-bfbc-fdf64d7ebacb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ChristoffelToMetric"}]], \
"Input",ExpressionUUID->"ca6bb62c-1e8b-429f-b4fc-b80099604e09"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", 
           RowBox[{";", "A"}]},
          {"A", " ", "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[$CellContext`A][
    $CellContext`T[-$CellContext`A, C]],
   Editable->False], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300233"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300233],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"B", "G$300232"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`B, $CellContext`G$300232],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "C"},
           {"B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, C],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"G$300233", "G$300232", 
              RowBox[{";", "A"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-$CellContext`A][
       $CellContext`g[-$CellContext`G$300233, -$CellContext`G$300232]],
      Editable->False], "-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"G$300233", "A", 
              RowBox[{";", "G$300232"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-$CellContext`G$300232][
       $CellContext`g[-$CellContext`G$300233, -$CellContext`A]],
      Editable->False], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"A", "G$300232", 
              RowBox[{";", "G$300233"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-$CellContext`G$300233][
       $CellContext`g[-$CellContext`A, -$CellContext`G$300232]],
      Editable->False]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300237"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300237],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"g", 
           StyleBox[GridBox[{
              {" ", " ", "  "},
              {"G$300237", "B", 
               RowBox[{";", "A"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[-$CellContext`A][
        $CellContext`g[-$CellContext`G$300237, -$CellContext`B]],
       Editable->False]}], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"G$300237", "A", 
              RowBox[{";", "B"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-$CellContext`B][
       $CellContext`g[-$CellContext`G$300237, -$CellContext`A]],
      Editable->False], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"B", "A", 
              RowBox[{";", "G$300237"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-$CellContext`G$300237][
       $CellContext`g[-$CellContext`B, -$CellContext`A]],
      Editable->False]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"ac95d1ee-f54f-46a0-8fc3-31d648f042ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"ca660274-787b-4068-92ff-62c2fb064dd0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300233"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300233],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$300232", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`G$300232, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"G$300233", "G$300232", 
            RowBox[{";", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`g[-$CellContext`G$300233, -$CellContext`G$300232]],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300237"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300237],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"G$300237", "B", 
            RowBox[{";", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`A][
     $CellContext`g[-$CellContext`G$300237, -$CellContext`B]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", 
           RowBox[{";", "A"}]},
          {"A", " ", "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[$CellContext`A][
    $CellContext`T[-$CellContext`A, C]],
   Editable->False], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300237"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300237],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"G$300237", "A", 
            RowBox[{";", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`B][
     $CellContext`g[-$CellContext`G$300237, -$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300233"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300233],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$300232", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`G$300232, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"G$300233", "A", 
            RowBox[{";", "G$300232"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G$300232][
     $CellContext`g[-$CellContext`G$300233, -$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300233"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300233],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"G$300232", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`G$300232, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "G$300232", 
            RowBox[{";", "G$300233"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G$300233][
     $CellContext`g[-$CellContext`A, -$CellContext`G$300232]],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "G$300237"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, $CellContext`G$300237],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "A", 
            RowBox[{";", "G$300237"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-$CellContext`G$300237][
     $CellContext`g[-$CellContext`B, -$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"919f43ee-6e32-4c0e-b38f-2c2de6e8a8c5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"3a15a3fe-6c2e-44ab-b740-797d202eed89"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "C", 
           RowBox[{";", "A"}]},
          {"A", " ", "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[$CellContext`A][
    $CellContext`T[-$CellContext`A, C]],
   Editable->False], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "D"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`g[-$CellContext`A, -$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {"A", "D"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`g[$CellContext`A, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"g", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "A", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CD[-D][
     $CellContext`g[-$CellContext`B, -$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"38e41d5a-da06-4770-84c3-ebf4404cbdd1"]
}, Open  ]],

Cell["\<\
Similar example with a Lie derivative (this is not working now. TODO):\
\>", "Text",ExpressionUUID->"d988d464-f6f4-4de9-8ad8-557c3f37e237"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xATP`addTMPCovD", "[", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"-", "B"}], "]"}], 
     RowBox[{
      RowBox[{"LieD", "[", 
       RowBox[{"T", "[", "A", "]"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", 
        RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], "]"}]}], "]"}], "//",
    "Expand"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"521dbf97-cb4a-4ae1-b794-2043b48c9ff4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPCovD", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "T"], GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", " ", "B", "C"},
               {" ", "A", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[
        xAct`xTensor`Dir[
         $CellContext`T[$CellContext`A]]][
        $CellContext`T[$CellContext`A, -$CellContext`A, $CellContext`B, C]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPCovD[
     $CellContext`cd[
      xAct`xTensor`Dir[
       $CellContext`T[$CellContext`A]]][
      $CellContext`T[$CellContext`A, -$CellContext`A, $CellContext`B, C]], 
     xAct`xTensor`LieD],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "D", "C"},
           {" ", "A", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`A, D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", " ", "B", "D"},
           {" ", "A", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, -$CellContext`A, $CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[C]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"6742edfd-4a51-46d5-bd76-73a350fe765f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"A", "\[Rule]", 
     RowBox[{"-", "A"}]}], ",", 
    RowBox[{"B", "\[Rule]", 
     RowBox[{"-", "B"}]}]}], 
   "}"}]}]], "Input",ExpressionUUID->"e6216b9f-4bae-4cbc-be99-0d5fe1fded9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPCovD", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SuperscriptBox["\[EmptyDownTriangle]", "T"], GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", "A", " ", "C"},
               {"A", " ", "B", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[
        xAct`xTensor`Dir[
         $CellContext`T[-$CellContext`A]]][
        $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, C]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPCovD[
     $CellContext`cd[
      xAct`xTensor`Dir[
       $CellContext`T[-$CellContext`A]]][
      $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, C]], 
     xAct`xTensor`LieD],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", "D", "C"},
           {"A", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[C]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"a6573d54-8a6f-497a-9aff-9a96abfdeb7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "xATP`removeTMPCovD"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"f1c5dfc5-193d-40a5-95e2-ef2a53736861"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "C"},
           {"A", " ", "G$300252", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`G$300252, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"G$300252", "  "},
              {" ", 
               RowBox[{";", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-$CellContext`B][
        $CellContext`T[$CellContext`G$300252]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-$CellContext`B][
      $CellContext`T[$CellContext`G$300252]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "G$300252"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, \
$CellContext`G$300252],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"C", "  "},
              {" ", 
               RowBox[{";", "G$300252"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-$CellContext`G$300252][
        $CellContext`T[C]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-$CellContext`G$300252][
      $CellContext`T[C]]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", "D", "C"},
           {"A", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "A", " ", "C"},
             {"A", " ", "B", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`T[-$CellContext`A]][
      $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, C]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"1522c83d-c860-4f37-93b6-22c740a9a4b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "SameDummies"}]], \
"Input",ExpressionUUID->"cf59f74b-372b-4402-a1eb-7effc28b0670"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "C"},
           {"A", " ", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"D", "  "},
              {" ", 
               RowBox[{";", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-$CellContext`B][
        $CellContext`T[D]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-$CellContext`B][
      $CellContext`T[D]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"C", "  "},
              {" ", 
               RowBox[{";", "D"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-D][
        $CellContext`T[C]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-D][
      $CellContext`T[C]]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", "D", "C"},
           {"A", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "A", " ", "C"},
             {"A", " ", "B", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`T[-$CellContext`A]][
      $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, C]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"a9bfb136-f8dc-4ec2-9b94-357ebe9bed29"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"expr_xATP`TMPChristoffelLieD", "\[RuleDelayed]", 
   RowBox[{
   "xATP`convertChristoffelTMP", "[", "expr", 
    "]"}]}]}]], \
"Input",ExpressionUUID->"de3ed06e-11e1-4c38-ad95-6ec56a11a269"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "C"},
           {"A", " ", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"D", "  "},
              {" ", 
               RowBox[{";", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-$CellContext`B][
        $CellContext`T[D]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-$CellContext`B][
      $CellContext`T[D]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"C", "  "},
              {" ", 
               RowBox[{";", "D"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-D][
        $CellContext`T[C]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-D][
      $CellContext`T[C]]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", "D", "C"},
           {"A", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "A", " ", "C"},
             {"A", " ", "B", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`T[-$CellContext`A]][
      $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, C]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"0525d1c0-9d9a-4660-80a1-bb9f5ce9d44b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"711691b4-f21b-42f4-8fe7-e4da4c4946c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"B"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`B],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "C"},
           {"A", " ", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"D", "  "},
              {" ", 
               RowBox[{";", "B"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-$CellContext`B][
        $CellContext`T[D]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-$CellContext`B][
      $CellContext`T[D]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{"TMPChristoffel", "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"C", "  "},
              {" ", 
               RowBox[{";", "D"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`cd[-D][
        $CellContext`T[C]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Private`TMPChristoffel[
     $CellContext`cd[-D][
      $CellContext`T[C]]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", "D", "C"},
           {"A", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, D, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "A", " ", "D"},
           {"A", " ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"C", "  "},
           {" ", 
            RowBox[{";", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`cd[-D][
     $CellContext`T[C]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalL]", "T"], GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", "A", " ", "C"},
             {"A", " ", "B", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`LieD[
      $CellContext`T[-$CellContext`A]][
      $CellContext`T[-$CellContext`A, $CellContext`A, -$CellContext`B, C]],
     Editable->False], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"a160876e-367e-4905-818b-3ce502373e55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Undef", "/@", 
   RowBox[{"{", 
    RowBox[{"g", ",", "CD", ",", "T"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"714444be-a85d-4c27-a4d7-0b9934bb68fb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detg],
  Editable->
   False]], "Print",ExpressionUUID->"81b6d124-1d02-408c-84d0-68fbeb081188"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Christoffelcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`Christoffelcd],
  Editable->
   False]], "Print",ExpressionUUID->"097d53d9-7938-4621-bb67-17491d87b7a1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "ChristoffelcdCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`ChristoffelcdCD],
  Editable->
   False]], "Print",ExpressionUUID->"45d34f46-3814-4fc4-98a2-8999f136d51c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Einsteincd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`Einsteincd],
  Editable->
   False]], "Print",ExpressionUUID->"f2c3dc8a-b49d-4952-8589-20c6c0e7d975"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Kretschmanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`Kretschmanncd],
  Editable->
   False]], "Print",ExpressionUUID->"e2c3bd55-083b-4eaf-bfcd-cd493f7dc828"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`Riccicd],
  Editable->
   False]], "Print",ExpressionUUID->"5e718bb4-a088-4645-b304-22b6dccb538b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarcd],
  Editable->
   False]], "Print",ExpressionUUID->"f23f2e14-0f0a-4f58-93d9-3f24069f641b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Riemanncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`Riemanncd],
  Editable->
   False]], "Print",ExpressionUUID->"b0913b4b-58d0-4132-ae6b-eea83fecb249"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRiccicd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRiccicd],
  Editable->
   False]], "Print",ExpressionUUID->"cdfcbb30-c80f-4a1e-a396-bc08e24ef248"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Torsioncd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`Torsioncd],
  Editable->
   False]], "Print",ExpressionUUID->"99e0ef21-e087-4b46-8426-feb47d46cc9c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Weylcd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`Weylcd],
  Editable->
   False]], "Print",ExpressionUUID->"dc2c047b-6a9f-4520-9a4d-e28ac0060382"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`cd],
  Editable->
   False]], "Print",ExpressionUUID->"adf9d40c-4d68-4637-b234-34573f572853"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilong"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilong],
  Editable->
   False]], "Print",ExpressionUUID->"1c7e6dd7-ba9b-44b7-b0cc-0f64374f1f62"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "g"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`g],
  Editable->
   False]], "Print",ExpressionUUID->"bb6c7bac-8897-4b49-a428-528ad809e98d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"ef6cec8a-eb8c-4420-9b90-031988f5aab1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"fad65771-2738-4949-8b69-04d8ddf7256e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"c984e391-cfe2-4b63-a09f-5dc64418b997"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"bfb5ccf9-b388-4349-a11c-3445f5f54671"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"462d6998-f04a-4eea-b8f2-5722119643ba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"a8494cb8-bc00-4f33-ac49-c8eb8bd54e46"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"300ae42d-7ddf-4608-b1a3-274a2985cfe4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"expr\"\>", ",", "\<\"G$300100\"\>", ",", "\<\"G$300100$\"\>",
      ",", "\<\"G$300101\"\>", ",", "\<\"G$300101$\"\>", 
     ",", "\<\"G$300102\"\>", ",", "\<\"G$300102$\"\>", 
     ",", "\<\"G$300103\"\>", ",", "\<\"G$300103$\"\>", 
     ",", "\<\"G$300104\"\>", ",", "\<\"G$300104$\"\>", 
     ",", "\<\"G$300105\"\>", ",", "\<\"G$300105$\"\>", 
     ",", "\<\"G$300106\"\>", ",", "\<\"G$300106$\"\>", 
     ",", "\<\"G$300107\"\>", ",", "\<\"G$300107$\"\>", 
     ",", "\<\"G$300108\"\>", ",", "\<\"G$300108$\"\>", 
     ",", "\<\"G$300109\"\>", ",", "\<\"G$300109$\"\>", 
     ",", "\<\"G$300110\"\>", ",", "\<\"G$300110$\"\>", 
     ",", "\<\"G$300111\"\>", ",", "\<\"G$300111$\"\>", 
     ",", "\<\"G$300112\"\>", ",", "\<\"G$300112$\"\>", 
     ",", "\<\"G$300113\"\>", ",", "\<\"G$300113$\"\>", 
     ",", "\<\"G$300182\"\>", ",", "\<\"G$300183\"\>", 
     ",", "\<\"G$300184\"\>", ",", "\<\"G$300185\"\>", 
     ",", "\<\"G$300193\"\>", ",", "\<\"G$300194\"\>", 
     ",", "\<\"G$300202\"\>", ",", "\<\"G$300203\"\>", 
     ",", "\<\"G$300204\"\>", ",", "\<\"G$300210\"\>", 
     ",", "\<\"G$300211\"\>", ",", "\<\"G$300227\"\>", 
     ",", "\<\"G$300228\"\>", ",", "\<\"G$300232\"\>", 
     ",", "\<\"G$300233\"\>", ",", "\<\"G$300234\"\>", 
     ",", "\<\"G$300236\"\>", ",", "\<\"G$300237\"\>", 
     ",", "\<\"G$300238\"\>", ",", "\<\"G$300249\"\>", 
     ",", "\<\"G$300252\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "expr", "G$300100", "G$300100$", "G$300101", "G$300101$", "G$300102", 
    "G$300102$", "G$300103", "G$300103$", "G$300104", "G$300104$", "G$300105",
     "G$300105$", "G$300106", "G$300106$", "G$300107", "G$300107$", 
    "G$300108", "G$300108$", "G$300109", "G$300109$", "G$300110", "G$300110$",
     "G$300111", "G$300111$", "G$300112", "G$300112$", "G$300113", 
    "G$300113$", "G$300182", "G$300183", "G$300184", "G$300185", "G$300193", 
    "G$300194", "G$300202", "G$300203", "G$300204", "G$300210", "G$300211", 
    "G$300227", "G$300228", "G$300232", "G$300233", "G$300234", "G$300236", 
    "G$300237", "G$300238", "G$300249", "G$300252"}],
  Editable->
   False]], "Print",ExpressionUUID->"8489058c-5c62-47dd-b3af-350b04d9e565"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.4.6. Even more examples", \
"Subsubsection",ExpressionUUID->"ab98a1fb-7eed-41e9-bad3-7c2cc8183c99"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"4f1a986c-2ab0-42d4-9baf-9e41a043b147"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"78aa3195-0abc-4337-a5be-42d22f04a9e5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7536cf6c-ac84-4518-bab4-8d2ef707900d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"93891a0c-bdc9-4862-b0da-234fce56dbdc"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "g", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "g", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", "g", "]"}], "^=", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"57931703-8d39-4e09-a6c8-a272d2f2d5b4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "A"}], "]"}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"835c01f2-e385-4f97-8f49-72670d637e26"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"A", " "},
         {" ", "A"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[$CellContext`A, -$CellContext`A],
  Editable->
   False]], "Output",ExpressionUUID->"0f7b254c-a767-4422-b05d-bb609d630e0d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "A"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "B"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "B"}]}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "A"}]}], "]"}]}]}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"3897c83d-3bfb-42df-9719-70fef2ff63a3"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"186fd9e7-42d5-4ca9-962b-316662aa1430"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "A", ",", 
     RowBox[{"-", "B"}], ",", "B"}], "]"}], "-", 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", 
     RowBox[{"-", "B"}], ",", "A", ",", 
     RowBox[{"-", "A"}]}], "]"}]}], "//", 
  "ToCanonical"}]], \
"Input",ExpressionUUID->"f9cdb916-f356-4b2c-b1c5-9571152b3a74"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"78a5fdff-9129-4871-b750-de1a97464fd8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "S"}], "}"}]}], 
  ";"}]}], "Input",ExpressionUUID->"8d5dbc02-1e79-4c07-99e5-eed7deb5e4d7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"a0e9dddc-38f8-40ef-9646-25056165998b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"f014d325-09b6-4d15-b9eb-51b6b7830b06"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "g", "]"}], 
  ";"}]], "Input",ExpressionUUID->"c054b2f6-2dc0-43ef-b23f-57b0e3ee2803"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"2ee64412-d0d2-4129-b8e9-eb10ab6d6801"],

Cell["Other examples:", \
"Text",ExpressionUUID->"6f0c90de-645d-4178-9e82-dbb488538acd"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"5ee36e06-ee7f-437d-96c1-d9f601b02e7f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"U", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], ",", "S2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"03b57a85-15cf-4ec5-a25e-694577fa7ef6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"U", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`U[$CellContext`a, $CellContext`b, $CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b87bb91-a125-488d-baeb-53dad3c965d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "a", "]"}], ",", "S2"}], 
  "]"}]], "Input",ExpressionUUID->"f9a8f7a4-3fc0-458d-b7c0-563f447a9a18"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "a", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9d980bf0-227c-4420-8d5a-0a609cd98e86"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"metric", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], ",", "CD", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"882e85e9-b0da-4d38-9d82-4436f9e4ea26"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metric", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metric[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"38512fa5-3006-4e5a-b45d-8c55b1de81bf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetric", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetric[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7302d934-6059-4e0b-addf-de23af2f8195"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD", "[", 
    RowBox[{"-", "a"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD[-$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"be496688-a870-4a0d-9ba7-33ce4599fde8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD[$CellContext`a, -$CellContext`b, -$CellContext`c], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"89f75c6c-39c1-4ecf-a999-6c8120ff8328"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD[$CellContext`a, -$CellContext`b, \
-$CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"05dce460-d4b6-467a-8327-d3fd81a93efa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"95c238d5-7f69-4600-b4f0-700ed7871759"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCD[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8fa62724-2234-4116-8fb8-de5ebb097e95"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"97053d61-327b-42da-b60a-6491e622d4eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"84a6c681-06f9-4935-a901-0fc1c2ab4832"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"5426d4ad-9c72-4359-bfa9-c34fe264af46"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCD", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCD[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"171dbe80-c1f9-422d-b98f-cb78d5131e6f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCD", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCD[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5346a837-f263-4395-aec1-cb0bbec6dae9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCD", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCD[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"79fed72e-74b0-45e3-8f6f-b403cb0ce7e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCD", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCD[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b4ab449-896a-4c27-b24c-ece99acc72c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"44a40bfd-729a-40eb-89cd-755efb26fae4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"b65e49a3-3836-4fbd-8fe7-bfc4b6a9195d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"a4e3a503-4ab0-47e7-bcc2-92f264c99492"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetric", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetric[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"7f06c8c0-b2b2-4160-95a4-efdff6801a47"]
}, Open  ]]
}, Open  ]],

Cell["This is correct:", \
"Text",ExpressionUUID->"3040e407-d9d8-4c08-8ea9-b38dd2729fae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"U", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"v", "[", "d", "]"}], "]"}], 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "b"}], "]"}], "[", 
   RowBox[{"v", "[", "e", "]"}], "]"}], 
  RowBox[{"metric", "[", 
   RowBox[{
    RowBox[{"-", "d"}], ",", 
    RowBox[{"-", "e"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"5cc6351b-3f0e-4b50-af66-a5a9bacdefce"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {"d", "e"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metric[-$CellContext`d, -$CellContext`e],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"U", 
       StyleBox[GridBox[{
          {"a", "b", "c"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`U[$CellContext`a, $CellContext`b, $CellContext`c],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"d", "  "},
          {" ", 
           RowBox[{",", "a"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`a][
    $CellContext`v[$CellContext`d]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"e", "  "},
          {" ", 
           RowBox[{",", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`b][
    $CellContext`v[$CellContext`e]],
   Editable->
    False]}]], "Output",ExpressionUUID->"f0f1688b-8d8a-400d-9c52-071c4cc43667"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"2c86e227-1164-4faf-a21f-bce44d911368"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"5ee63d82-7e92-4b9a-9a5d-e09904f51795"]
}, Open  ]],

Cell["and this is also correct:", \
"Text",ExpressionUUID->"9e3e211c-762a-4312-a852-f6163068099f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"U", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"v", "[", 
    RowBox[{"-", "d"}], "]"}], "]"}], 
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "b"}], "]"}], "[", 
   RowBox[{"v", "[", "d", "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"e71edd28-954b-479b-b7b8-4d9e949c48e4"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"U", 
       StyleBox[GridBox[{
          {"a", "b", "c"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`U[$CellContext`a, $CellContext`b, $CellContext`c],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"d", 
           RowBox[{";", "a"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-$CellContext`a][
    $CellContext`v[-$CellContext`d]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"d", "  "},
          {" ", 
           RowBox[{";", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CD[-$CellContext`b][
    $CellContext`v[$CellContext`d]],
   Editable->
    False]}]], "Output",ExpressionUUID->"b2bab139-57fe-45be-8584-4fd2ad80e7ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"0f5091b4-c7dc-4087-87ce-12cec51db6c3"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"2a831b27-d0b9-41ee-a732-9118c8defbb5"]
}, Open  ]],

Cell["\<\
However, here we cannot commute the objects. The system detects that and \
changes the algorithm. Interestingly the cancellation actually happens and we \
end up with a single derivative of the vector v:\
\>", "Text",ExpressionUUID->"69c7fb2b-0219-4193-828e-3e40e1fe5e43"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"U", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}], 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "a"}], "]"}], "[", 
   RowBox[{"v", "[", 
    RowBox[{"-", "d"}], "]"}], "]"}], 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "b"}], "]"}], "[", 
   RowBox[{"v", "[", "d", "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"a6b5293b-8219-43cb-9249-71d71b4744e6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"U", 
       StyleBox[GridBox[{
          {"a", "b", "c"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`U[$CellContext`a, $CellContext`b, $CellContext`c],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"d", 
           RowBox[{",", "a"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`a][
    $CellContext`v[-$CellContext`d]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"d", "  "},
          {" ", 
           RowBox[{",", "b"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`b][
    $CellContext`v[$CellContext`d]],
   Editable->
    False]}]], "Output",ExpressionUUID->"f193a598-74e2-45c1-946e-3686bd1a3b5b"]
}, Open  ]],

Cell["TODO: THIS IS WRONG NOW:", \
"Text",ExpressionUUID->"ab5b395c-a46f-4705-b445-f9a44ea1d9d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCanonical", "[", "%", "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"5b972770-d3f8-4eae-9b69-830fcd74bc16"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"3c0cd7be-c74b-4b93-b0a7-ecfcc996620c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"%", "//", "ChristoffelToMetric"}], "//", "ToCanonical"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"d77dd136-04bc-4609-b08a-f8b78f2116de"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"4fec8e2d-79c3-4932-a22f-bcb7a489c047"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ContractMetric"}]], \
"Input",ExpressionUUID->"0e0edbdc-9628-44f1-ab4b-0220d81e10ab"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"983b0710-3786-4c86-be67-68c5b4549089"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"metric", ",", "U", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"840d1f93-a141-4fd0-b7d9-69d2797587f3"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetric],
  Editable->
   False]], "Print",ExpressionUUID->"29bf926f-1fe7-4ee3-9300-5bcbaed4895e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD],
  Editable->
   False]], "Print",ExpressionUUID->"5e05c062-9583-41ae-9e0f-246bc24265cf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCD],
  Editable->
   False]], "Print",ExpressionUUID->"782a7472-2245-4fc6-8ea5-ee785822aa5b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCD],
  Editable->
   False]], "Print",ExpressionUUID->"63998064-a53c-4063-b648-c4991d146eef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"275d4cc8-6e99-40dd-baf8-e352fa076692"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCD],
  Editable->
   False]], "Print",ExpressionUUID->"0b7f9feb-78e8-448a-b2e7-6d1d3af598ea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD],
  Editable->
   False]], "Print",ExpressionUUID->"ed67e944-e1b1-448c-8f22-a590b472f9b7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCD],
  Editable->
   False]], "Print",ExpressionUUID->"87441fc0-9243-4fe6-aa54-bf2e8c254786"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD],
  Editable->
   False]], "Print",ExpressionUUID->"35b8b4bb-80d7-4cfa-bfa5-f81221137a73"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCD],
  Editable->
   False]], "Print",ExpressionUUID->"952a150d-9db6-4d59-ab64-7f3c9add8abb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD],
  Editable->
   False]], "Print",ExpressionUUID->"2fe97110-fb13-406e-b9cb-a38335550ec6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetric],
  Editable->
   False]], "Print",ExpressionUUID->"1360606f-3f33-41c9-bd8e-a573f45e0e90"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metric"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metric],
  Editable->
   False]], "Print",ExpressionUUID->"6b4d5c01-be62-4308-a4fc-99000349eac1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "U"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`U],
  Editable->
   False]], "Print",ExpressionUUID->"db09fa59-9348-43fc-a65f-3557a6cfa7da"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"bd9e58a4-426c-4030-b860-40139e79e9fc"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"88abda24-c5dd-4f3d-a8c4-d9f70c5aafd9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"f$300375\"\>", ",", "\<\"f$300375$\"\>", 
     ",", "\<\"f$300376\"\>", ",", "\<\"f$300376$\"\>", 
     ",", "\<\"f$300377\"\>", ",", "\<\"f$300377$\"\>", 
     ",", "\<\"f$300378\"\>", ",", "\<\"f$300378$\"\>", 
     ",", "\<\"f$300379\"\>", ",", "\<\"f$300379$\"\>", 
     ",", "\<\"f$300380\"\>", ",", "\<\"f$300380$\"\>", 
     ",", "\<\"f$300381\"\>", ",", "\<\"f$300381$\"\>", 
     ",", "\<\"f$300382\"\>", ",", "\<\"f$300382$\"\>", 
     ",", "\<\"f$300383\"\>", ",", "\<\"f$300383$\"\>", 
     ",", "\<\"f$300384\"\>", ",", "\<\"f$300384$\"\>", 
     ",", "\<\"f$300385\"\>", ",", "\<\"f$300385$\"\>", 
     ",", "\<\"f$300386\"\>", ",", "\<\"f$300386$\"\>", 
     ",", "\<\"f$300387\"\>", ",", "\<\"f$300387$\"\>", 
     ",", "\<\"f$300388\"\>", ",", "\<\"f$300388$\"\>", 
     ",", "\<\"f$300457\"\>", ",", "\<\"f$300458\"\>", 
     ",", "\<\"f$300459\"\>", ",", "\<\"f$300460\"\>", 
     ",", "\<\"f$300468\"\>", ",", "\<\"f$300469\"\>", 
     ",", "\<\"f$300477\"\>", ",", "\<\"f$300478\"\>", 
     ",", "\<\"f$300479\"\>", ",", "\<\"f$300486\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "f$300375", "f$300375$", "f$300376", "f$300376$", "f$300377", "f$300377$", 
    "f$300378", "f$300378$", "f$300379", "f$300379$", "f$300380", "f$300380$",
     "f$300381", "f$300381$", "f$300382", "f$300382$", "f$300383", 
    "f$300383$", "f$300384", "f$300384$", "f$300385", "f$300385$", "f$300386",
     "f$300386$", "f$300387", "f$300387$", "f$300388", "f$300388$", 
    "f$300457", "f$300458", "f$300459", "f$300460", "f$300468", "f$300469", 
    "f$300477", "f$300478", "f$300479", "f$300486"}],
  Editable->
   False]], "Print",ExpressionUUID->"d362f16c-8582-42f2-b94a-0d2242a23a51"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.5. Symmetry-related structures", \
"Subsection",ExpressionUUID->"e9410683-f2df-4275-9bcf-cae4b12f47e7"],

Cell[CellGroupData[{

Cell["15.5.1. ImposeSymmetry", \
"Subsubsection",ExpressionUUID->"5cf53225-a652-440c-bfd8-b764486ddab7"],

Cell["\<\
This is a general function to construct a symmetrized version of an \
expression. From version 0.9.8 of xTensor` we introduce a fourth argument, \
which is a function acting on individual terms sequentially. This is never a \
gain in speed, but it can be a gain in memory.\
\>", "Text",ExpressionUUID->"a049cbba-c083-41eb-be33-f3b35d8c4028"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", "inds___", "}"}], ",", "SGS_", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"IndexList", "[", "inds", "]"}], ",", "SGS", ",", "f"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr_", ",", "inds_IndexList", ",", 
     RowBox[{"sym", ":", 
      RowBox[{"(", 
       RowBox[{"_Symmetric", "|", "_Antisymmetric"}], ")"}]}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", "inds", ",", 
     RowBox[{"SGSofsym", "[", "sym", "]"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr_", ",", "inds_IndexList", ",", "SGS_StrongGenSet", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", "inds", ",", 
     RowBox[{"SGS", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr_", ",", "inds_IndexList", ",", "GS_GenSet", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", "inds", ",", 
     RowBox[{"Dimino", "[", "GS", "]"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{
    "expr_", ",", "inds_IndexList", ",", "group_Group", ",", "Identity"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"Plus", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"PermuteIndices", "[", 
         RowBox[{"expr", ",", "inds", ",", "#"}], "]"}], "&"}], "/@", 
       "group"}], ")"}]}], "/", 
    RowBox[{"Length", "[", "group", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr_", ",", "inds_IndexList", ",", "group_Group", ",", "f_"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tmp", "=", "0"}], ",", "elem"}], "}"}], ",", 
      RowBox[{
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"tmp", "+=", 
          RowBox[{"f", "[", 
           RowBox[{"PermuteIndices", "[", 
            RowBox[{"expr", ",", "inds", ",", 
             RowBox[{"group", "[", 
              RowBox[{"[", "elem", "]"}], "]"}]}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"elem", ",", 
           RowBox[{"Length", "[", "group", "]"}]}], "}"}]}], "]"}], ";", 
       "tmp"}]}], "]"}], "/", 
    RowBox[{"Length", "[", "group", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr_", ",", "inds_", ",", "group_", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"Throw", "@", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"ImposeSymmetry", "::", "error"}], ",", 
      "\"\<Cannot impose symmetry.\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ImposeSymmetry", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ImposeSymmetry", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f68201c1-5201-4651-8ef0-f14c33ddbfb5"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b2471c2c-6113-4ddb-945f-4d4d65886fe1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Test", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8406c029-b39d-437b-9597-7a9fe0e25c9e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "protected"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"HoldForm\\\"\\)\[NoBreak] is \
\[NoBreak]\\!\\(\\\"Protected\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"dbd8e945-0c64-4557-ab48-c8511f939815"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImposeSymmetry", "[", 
  RowBox[{
   RowBox[{"Test", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "}"}], ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"42af1105-bfe2-413f-a637-d87ed3dc9276"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"-", "A"}],
    HoldForm], ",", "2", ",", "False"}], 
  "}"}]], "Output",ExpressionUUID->"24db3f1e-8026-4852-b91f-6df47b46f198"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ImposeSymmetry", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Test", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"Test", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "G"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "D"}]}], "}"}], ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"546eeb76-bc0d-4a58-82b7-e1b3d98f6a0b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    TagBox[
     RowBox[{"-", "A"}],
     HoldForm], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{"-", "D"}],
      HoldForm], ")"}]}], ",", "3", ",", 
   SuperscriptBox["False", "2"]}], 
  "}"}]], "Output",ExpressionUUID->"9667069c-7585-4914-b591-858007eba586"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "Test", 
  "]"}]], "Input",ExpressionUUID->"fc64c40d-90b4-4467-95ca-7f985406e0ec"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"UndefTensor", "::", "unknown"}], "MessageName"], ":", 
  " ", "\<\"Unknown \[NoBreak]\\!\\(\\\"tensor\\\"\\)\[NoBreak] \[NoBreak]\\!\
\\(Test\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"cc103918-cac5-4eaa-9b78-b48543709d3c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"273717fa-bca5-47f7-8c72-195e562bbd02"],

Cell["\<\
Special simple cases. Note that when giving integers the list of indices has \
head List.\
\>", "Text",ExpressionUUID->"d30174d6-58ad-449b-84df-b7f909a8e358"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xTensor`Symmetrize", "[", "expr_", "]"}], ":=", 
   RowBox[{"xAct`xTensor`Symmetrize", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "Identity"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xTensor`Symmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xTensor`Symmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"inds", ":", 
      RowBox[{"{", "__Integer", "}"}]}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"xAct`xTensor`Symmetrize", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"FindIndices", "[", "expr", "]"}], "[", 
      RowBox[{"[", "inds", "]"}], "]"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xTensor`Symmetrize", "[", 
    RowBox[{"expr_", ",", "inds_", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", "inds", ",", 
     RowBox[{"Symmetric", "@", 
      RowBox[{"Range", "@", 
       RowBox[{"Length", "[", "inds", "]"}]}]}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"xAct`xTensor`Symmetrize", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "xAct`xTensor`Symmetrize", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"be78a8dd-0b8a-474e-87f2-42ab97c26008"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Antisymmetrize", "[", "expr_", "]"}], ":=", 
   RowBox[{"Antisymmetrize", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "Identity"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Antisymmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Antisymmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"inds", ":", 
      RowBox[{"{", "__Integer", "}"}]}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"Antisymmetrize", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"FindIndices", "[", "expr", "]"}], "[", 
      RowBox[{"[", "inds", "]"}], "]"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Antisymmetrize", "[", 
    RowBox[{"expr_", ",", "inds_", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", "inds", ",", 
     RowBox[{"Antisymmetric", "@", 
      RowBox[{"Range", "@", 
       RowBox[{"Length", "[", "inds", "]"}]}]}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Antisymmetrize", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Antisymmetrize", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"addf9589-a8d8-4434-957d-c34bb44aa871"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PairSymmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PairSymmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"inds", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "GIndexQ"}], ",", 
          RowBox[{"_", "?", "GIndexQ"}]}], "}"}], ".."}], "}"}]}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Flatten", "[", "inds", "]"}], ",", 
     RowBox[{"GenSet", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"xAct`xPerm`Cycles", "@@", "#"}], "&"}], "/@", 
        RowBox[{"Transpose", "/@", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Range", "[", 
              RowBox[{"2", 
               RowBox[{"Length", "[", "inds", "]"}]}], "]"}], ",", "2"}], 
            "]"}], ",", "2", ",", "1"}], "]"}]}]}], ")"}]}], ",", "f"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"PairSymmetrize", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "PairSymmetrize", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"b0658bc4-121d-4ac6-bbe4-c292a77901fd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PairAntisymmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PairAntisymmetrize", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"inds", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "GIndexQ"}], ",", 
          RowBox[{"_", "?", "GIndexQ"}]}], "}"}], ".."}], "}"}]}], ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{"ImposeSymmetry", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"Flatten", "[", "inds", "]"}], ",", 
     RowBox[{"GenSet", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"xAct`xPerm`Cycles", "@@", "#"}]}], "&"}], "/@", 
        RowBox[{"Transpose", "/@", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Range", "[", 
              RowBox[{"2", 
               RowBox[{"Length", "[", "inds", "]"}]}], "]"}], ",", "2"}], 
            "]"}], ",", "2", ",", "1"}], "]"}]}]}], ")"}]}], ",", "f"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"PairAntisymmetrize", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "PairAntisymmetrize", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"ec986682-ef74-4191-88ee-c17d336e35e2"],

Cell["We perform cyclizing through an independent construct:", \
"Text",ExpressionUUID->"2a95ef5f-b391-4d3b-8f5b-84ca139868c4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Cyclize", "[", 
    RowBox[{"expr_", ",", "inds_List", ",", 
     RowBox[{"f_", ":", "Identity"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Plus", "@@", 
     RowBox[{"Map", "[", 
      RowBox[{"f", ",", 
       RowBox[{"ReplaceAll", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Inner", "[", 
             RowBox[{"Rule", ",", "inds", ",", "#", ",", "List"}], "]"}], 
            "&"}], ",", 
           RowBox[{"NestList", "[", 
            RowBox[{"RotateRight", ",", "inds", ",", 
             RowBox[{
              RowBox[{"Length", "[", "inds", "]"}], "-", "1"}]}], "]"}]}], 
          "]"}]}], "]"}]}], "]"}]}], "/", 
    RowBox[{"Length", "[", "inds", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Cyclize", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Cyclize", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4746a862-9f27-4d0a-99d2-f54941464a3d"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.5.2. Monomials", \
"Subsubsection",ExpressionUUID->"58ed28f1-bab7-43d9-a857-14f415e6eb75"],

Cell["\<\
These three functions identify the objects by the indices they have. An \
important problem is the fact that blocked indices do not identify objects \
because they can be repeatd. The idea is that here we only worry about AB \
indices and those indices cannot be repeated.\
\>", "Text",ExpressionUUID->"289f6da4-049c-4d22-a1ec-04b30cf8f1c0"],

Cell["\<\
These functions could be constructed from the Object structure returned by \
xSort, but for historical reasons they are based on IsIndexOf.\
\>", "Text",ExpressionUUID->"24b98a00-5741-4e08-97ed-73e79fe7a266"],

Cell["\<\
ObjectsWithIndices returns a list with the objects having the given indices \
(upindices or downindices) in a term. Note that ObjectsWithIndices with a \
single index must give a list with zero or one elements, but never more, so \
that we directly ask for a single object:\
\>", "Text",ExpressionUUID->"c29d61eb-76d8-49ab-b56f-7e40a0b8b044"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Plus", " ", 
    RowBox[{"expression", ":", " ", 
     RowBox[{"throw", " ", "an", " ", "error"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ObjectsWithIndices", "[", 
      RowBox[{"expr_Plus", ",", "_"}], "]"}], ":=", 
     RowBox[{"Throw", "[", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"MonomialsOfTerm", "::", "error"}], ",", 
         "\"\<Expression with head Plus cannot be separated in \
monomials.\>\""}], "]"}], ";", 
       RowBox[{"ERROR", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"List", " ", "of", " ", "indices"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ObjectsWithIndices", "[", 
      RowBox[{"term_", ",", "list_IndexList"}], "]"}], ":=", 
     RowBox[{"Union", "@", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ObjectsWithIndices", "[", 
          RowBox[{"term", ",", "#"}], "]"}], "&"}], "/@", 
        RowBox[{"List", "@@", "list"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Single", " ", 
     RowBox[{"index", ".", " ", "IsIndexOf"}], " ", "used", " ", "without", 
     " ", "third", " ", "argument"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ObjectsWithIndices", "[", 
      RowBox[{"term_", ",", "index_"}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"ListOfFactors", "[", "term", "]"}], ",", 
       RowBox[{
        RowBox[{"IsIndexOf", "[", 
         RowBox[{"#", ",", "index"}], "]"}], "&"}], ",", "1"}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"Protect", "[", "ObjectsWithIndices", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"71c60eb6-03cb-45fa-bec1-01eae6f39b07"],

Cell["\<\
This is not a very efficient function, but the coding is very simple.\
\>", "Text",ExpressionUUID->"7c5cf804-1dce-4ef7-b1d1-a889d26ac179"],

Cell["Examples:", \
"Text",ExpressionUUID->"57bc9bbe-8951-4047-be41-ab236acd6eec"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e9ec15fc-0fd1-4008-b2c5-d262e73c0684"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "M2"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefConstantSymbol", "[", "Mass", 
  "]"}]}], "Input",ExpressionUUID->"0e7e294e-0e82-449f-b029-b4c718c8414a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B, C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d1ae1dba-bdf2-4f01-b5e0-dcd8bb6b11af"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`UU[-$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6c79f1e3-0928-4b31-86c2-173a39237553"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[-$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"04be565c-bf81-454e-8d9f-a576c39884e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7e1ff581-251a-48f1-adb9-a657173caccb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "Mass", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`Mass, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a1c753fe-61c0-478e-8e20-25c1295fc940"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefCovD", "[", 
  RowBox[{
   RowBox[{"Cd", "[", 
    RowBox[{"-", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[PartialD]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4e38851b-2ad7-480d-8366-63097b625577"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"Cd", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`Cd[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f037b7d9-2339-49de-a1da-cc07399fdad4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"36a77a62-950e-4dc8-abcc-5309730a2728"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCd", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCd[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  
  Editable->
   False]], "Print",ExpressionUUID->"24cd9554-017d-4b56-bd6e-ed42fef23849"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", "D"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"Antisymmetric only in the first pair.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCd[-$CellContext`A, -$CellContext`B, -C, D], ". ", 
   "Antisymmetric only in the first pair."],
  Editable->
   False]], "Print",ExpressionUUID->"8ba48f6a-a633-4d69-b0cd-10a1fe202940"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCd", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "non-symmetric Ricci tensor ", 
   $CellContext`RicciCd[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a18cc042-a63a-41a4-9e50-c93054d685cc"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"d7448a5e-89f4-4d14-aafd-dfa8a003641f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{"1", ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"36812e0f-2562-4e24-a406-e3a39eec47fe"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"121b3384-9134-4ad0-8a02-08777c8e2d57"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"779e6de7-7cef-4294-9bab-06fdb3d9a7cd"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B", "C"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B, C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"a241549f-8ea9-4156-baee-800fe4931d3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "D"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], "]"}]}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"d36d219b-cb09-4311-98a4-3be82f5ced1f"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B", "C"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B, C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"a7eb3b12-a7a5-4917-8338-62093344f142"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "D"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"73398ad0-7447-4634-a886-24e4f98262fc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B", "C"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B, C],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"UU", 
        StyleBox[GridBox[{
           {" ", " ", " ", "  "},
           {"D", "B", "C", 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Cd[-$CellContext`A][
     $CellContext`UU[-D, -$CellContext`B, -C]],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"f77e017d-9ef6-43bf-86cd-e5f3d28a06cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "D"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A", ",", "B"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e310583d-d482-46ca-926a-892716fe134e"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A", "B", "C"},
          {" ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A, $CellContext`B, C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"74b7aa81-01ce-4b49-b778-65053deabfa4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "D"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], "]"}]}], ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"a848eee4-f0cd-4ed9-a33c-8ab7994def30"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {" ", " ", " ", "  "},
          {"D", "B", "C", 
           RowBox[{"|", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Cd[-$CellContext`A][
    $CellContext`UU[-D, -$CellContext`B, -C]],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"0fa41892-5543-4081-b8aa-32389f82ef58"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "C"}]}], "]"}], "]"}]}], ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"568ee29e-bd53-44cd-afe6-3fb0d88d9e6e"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {" ", " ", " ", "  "},
          {"A", "B", "C", 
           RowBox[{"|", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Cd[-D][
    $CellContext`UU[-$CellContext`A, -$CellContext`B, -C]],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"945abb76-a058-40ea-9bd5-85ceaef9f169"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", 
      RowBox[{"-", "F"}], "]"}], "[", 
     RowBox[{
      RowBox[{"Cd", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"UU", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}], ",", 
        RowBox[{"-", "C"}]}], "]"}], "]"}], "]"}]}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"a3f9d40b-ef3d-4c60-8be8-8294800a4162"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {" ", " ", " ", "  ", "  "},
          {"A", "B", "C", 
           RowBox[{"|", "D"}], 
           RowBox[{"|", "F"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Cd[-$CellContext`F][
    $CellContext`Cd[-D][
     $CellContext`UU[-$CellContext`A, -$CellContext`B, -C]]],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"757c5d4d-adeb-4c02-8a81-f63f1e6bc4e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "V", "]"}], "[", 
     RowBox[{
      RowBox[{"Cd", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{
       RowBox[{"Cd", "[", 
        RowBox[{"-", "D"}], "]"}], "[", 
       RowBox[{"UU", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}], ",", 
         RowBox[{"-", "F"}]}], "]"}], "]"}], "]"}], "]"}]}], ",", 
   RowBox[{"-", "C"}]}], 
  "]"}]], "Input",ExpressionUUID->"55472d98-b0ef-422c-91ba-bcb9d0d606d3"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"UU", 
       StyleBox[GridBox[{
          {" ", " ", " ", "  ", "  ", 
           RowBox[{"|", "V"}]},
          {"A", "B", "F", 
           RowBox[{"|", "D"}], 
           RowBox[{"|", "C"}], "  "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Cd[$CellContext`V][
    $CellContext`Cd[-C][
     $CellContext`Cd[-D][
      $CellContext`UU[-$CellContext`A, -$CellContext`B, -$CellContext`F]]]],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"79c6d7ac-ab67-4c6f-accb-b73fd2f4ee49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"b31ba1d3-63d4-43f4-af38-589e2b741bc6"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"39727910-6de6-417d-a33e-d5a9a7140e28"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "Polar"}], "}"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a21d1093-9b33-4b1e-80da-8aad0a5613c4"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["A",
            FontColor->RGBColor[0., 0., 1.]], " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[{$CellContext`A, $CellContext`Polar}, -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"7beef61a-e3f0-437c-8834-3217d291813f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "Polar"}], "}"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"dd9aa9e0-2fbd-456a-801c-e48d5511b316"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["A",
            FontColor->RGBColor[0., 0., 1.]], " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[{$CellContext`A, $CellContext`Polar}, -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"d513ee93-8d98-4437-a3bd-37c58aab5eba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "Polar"}], "}"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"bd0cd012-57f9-443c-ad81-76f7e8759257"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"5762e8e5-8774-402f-acf3-c3f3137e5fca"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xAct`xCoba`BasisColor", "[", "polar", "]"}], "^=", 
   RowBox[{"Hue", "[", "0", "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"b2c43dc9-2582-4ba1-bc31-b84b4dd11295"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "polar"}], "}"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"18f968fa-a10a-487f-8381-7039ee404ded"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["A",
            FontColor->Hue[0.]], " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[{$CellContext`A, $CellContext`polar}, -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"5eb8c5a4-e99b-44f8-b407-33c14bddad3b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"A", ",", "polar"}], "}"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"97572f30-fb0e-446d-8895-3d88cff8d137"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"6cfc498d-22a0-42b7-b49c-55d2ffe24af2"]
}, Open  ]],

Cell["\<\
ObjectsWithIndices works with directions, integer basis-indices and labels, \
but in principle this should never happen because they cannot be free indices:\
\>", "Text",ExpressionUUID->"c9e1c7e5-e5f6-44fe-b6eb-c364a6c0da64"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"Dir", "[", 
       RowBox[{"V", "[", 
        RowBox[{"-", "Z"}], "]"}], "]"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"Dir", "[", 
    RowBox[{"V", "[", 
     RowBox[{"-", "Z"}], "]"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"37de5a96-ee83-4698-8d1a-2999cfb90385"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"V", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[
    xAct`xTensor`Dir[
     $CellContext`V[-$CellContext`Z]], -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"309359cb-b26f-42e6-9025-c2bc709fee04"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "Polar"}], "}"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Polar"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"92b0a2c4-3078-4cbc-a48c-790f9a6f97a7"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           StyleBox["1",
            FontColor->RGBColor[0., 0., 1.]], " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[{1, $CellContext`Polar}, -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"592c8299-80e0-45c2-a43d-9f590f6ca07c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"LI", "[", "1", "]"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", 
   RowBox[{"LI", "[", "1", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4339620e-939f-41fa-adb9-74ebd5c9aa86"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"1", " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[
    xAct`xTensor`LI[1], -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"a4c29695-ccc5-4351-a211-9dd6fbf29f5c"]
}, Open  ]],

Cell["Patterns do not behave as expected:", \
"Text",ExpressionUUID->"916ace7c-f7de-4ddf-a35d-29eceae2975f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A_", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", "A_"}], 
  "]"}]], "Input",ExpressionUUID->"2932d1ca-72ce-426e-8fe6-687aa8218b9c"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           UnderscriptBox["A", "_"], " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[
    Pattern[$CellContext`A, 
     Blank[]], -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"d12a2c6a-644f-48d6-91aa-2bf945642043"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`ObjectsWithIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A_", ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"V", "[", "A", "]"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"D", ",", "B", ",", "C"}], "]"}], "]"}]}], ",", "B_"}], 
  "]"}]], "Input",ExpressionUUID->"343f9179-3776-46c0-8ac9-35d245e5a700"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {
           UnderscriptBox["A", "_"], " ", " "},
          {" ", "B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[
    Pattern[$CellContext`A, 
     Blank[]], -$CellContext`B, -C],
   Editable->False], 
  "}"}]], "Output",ExpressionUUID->"4fae0180-08f2-4907-bd87-6f6d49625b30"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "polar", "]"}], 
  ";"}]], "Input",ExpressionUUID->"81198196-4264-44fa-9302-32aa6b2a6826"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"1c35eb29-0936-4e46-bd02-33db3325c46f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"Cd\"\>", ",", "\<\"ChristoffelCd\"\>", ",", "\<\"Mass\"\>", 
     ",", "\<\"RicciCd\"\>", ",", "\<\"RiemannCd\"\>", ",", "\<\"S\"\>", 
     ",", "\<\"T\"\>", ",", "\<\"TorsionCd\"\>", ",", "\<\"UU\"\>", 
     ",", "\<\"V\"\>", ",", "\<\"Z\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "Cd", "ChristoffelCd", "Mass", "RicciCd", "RiemannCd", "S", "T", 
    "TorsionCd", "UU", "V", "Z"}],
  Editable->
   False]], "Print",ExpressionUUID->"3648b776-46f8-4d7f-b0f1-842ef146612b"]
}, Open  ]],

Cell["\<\
Given a term, we decompose it in monomials: minimal products of tensors such \
that every free index of the product is a free index of the term. We first \
define the Monomial inert head:\
\>", "Text",ExpressionUUID->"811c2773-29d5-40e6-bc4f-9acaa10f52fb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InertHeadQ", "[", "Monomial", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", "Monomial", "]"}], "^=", "\"\<Monomial\>\""}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f1d1e1e2-9308-4239-b9df-4bab53cd2919"],

Cell["\<\
We first need a function that finds the monomial identified by a given free \
index. We supply the list of all free indices to avoid the repetition of the \
calculations. The Monomial construction saves time when ordering monomials. \
Note that only FindFreeIndices is used here, and not FindIndices; that \
ensures that only abstract indices and noninteger basis indices will appear \
in the list frees. The list inds only contains traceable indices because we \
use TakeEIndices in MonomialsOfTerm. Note also that the indices of the \
Monomial construction are sorted according to Sort.\
\>", "Text",ExpressionUUID->"eb63fbbd-3205-4e3c-8b5a-bed599afa289"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Two", " ", 
    RowBox[{"arguments", ":", " ", 
     RowBox[{
     "Find", " ", "free", " ", "indices", " ", "of", " ", "term", " ", "and", 
      " ", "set", " ", "up", " ", 
      RowBox[{"Monomial", ".", " ", "Convert"}], " ", "to", " ", "four", " ", 
      
      RowBox[{"arguments", ".", " ", "Argument"}], " ", "inds", " ", "can", 
      " ", "be", " ", "an", " ", "index", " ", "or", " ", "an", " ", 
      "IndexList"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FindMonomial", "[", 
      RowBox[{"term_", ",", "inds_"}], "]"}], ":=", 
     RowBox[{"FindMonomial", "[", 
      RowBox[{"term", ",", "inds", ",", 
       RowBox[{"FindFreeIndices", "[", "term", "]"}], ",", 
       RowBox[{"Monomial", "[", 
        RowBox[{"1", ",", 
         RowBox[{"IndexList", "[", "]"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Four", " ", 
     RowBox[{"arguments", ".", " ", "No"}], " ", "more", " ", "indices", " ", 
     "to", " ", "look", " ", 
     RowBox[{"for", ":", " ", 
      RowBox[{"stop", " ", "monomial", " ", "construction"}]}]}], " ", "*)"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FindMonomial", "[", 
      RowBox[{"_", ",", 
       RowBox[{"IndexList", "[", "]"}], ",", "_IndexList", ",", "monomial_"}],
       "]"}], ":=", "monomial"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Four", " ", 
     RowBox[{"arguments", ".", " ", "More"}], " ", "indices", " ", "to", " ", 
     "look", " ", "for"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FindMonomial", "[", 
     RowBox[{"term_", ",", "inds_", ",", "frees_IndexList", ",", 
      RowBox[{"Monomial", "[", 
       RowBox[{"monomial_", ",", "minds_IndexList"}], "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"FindMonomial", "[", 
       RowBox[{"term", ",", 
        RowBox[{"ChangeIndex", "/@", 
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", "frees"}], "]"}]}], ",", 
        "frees", ",", "#"}], "]"}], "&"}], "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Monomial", "[", 
         RowBox[{"#", ",", 
          RowBox[{"FindFreeIndices", "[", "#", "]"}]}], "]"}], "&"}], "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Times", "@@", 
          RowBox[{"ObjectsWithIndices", "[", 
           RowBox[{
            RowBox[{"term", "/", "monomial"}], ",", "inds"}], "]"}]}], 
         "monomial"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "FindMonomial", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"87139118-7e94-486f-878c-c7fc574faf68"],

Cell["\<\
Finally MonomialsOfTerm gives the list of monomials in a term. Note that the \
first element of the list is a special monomial; it is a product of numbers \
and scalars with head ScalarMonomial. ScalarMonomial gives a monomial with no \
traceable indices; Monomial[...,{}] gives a monomial with no free indices.\
\>", "Text",ExpressionUUID->"c1fe9149-57d1-4fb1-9e9a-903652391f7d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Find", " ", "traceable", " ", "indices", " ", "of", " ", "term", " ", 
    "and", " ", "setup", " ", "list", " ", "of", " ", "monomials"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MonomialsOfTerm", "[", "term_", "]"}], ":=", 
     RowBox[{"MonomialsOfTerm", "[", 
      RowBox[{"term", ",", 
       RowBox[{"TakeEIndices", "@", 
        RowBox[{"FindIndices", "[", "term", "]"}]}], ",", 
       RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Select", " ", "monomial", " ", "of", " ", "first", " ", "index", " ", 
     "of", " ", "term"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MonomialsOfTerm", "[", 
      RowBox[{"term_", ",", 
       RowBox[{"IndexList", "[", 
        RowBox[{"i_", ",", "is___"}], "]"}], ",", "monomials_List"}], "]"}], ":=", 
     RowBox[{"MonomialsOfTerm", "[", 
      RowBox[{"term", ",", 
       RowBox[{"IndexList", "[", "is", "]"}], ",", "monomials", ",", 
       RowBox[{"FindMonomial", "[", 
        RowBox[{"term", ",", "i"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"New", " ", 
     RowBox[{"monomial", ":", " ", 
      RowBox[{
      "append", " ", "to", " ", "list", " ", "and", " ", "eliminate", " ", 
       "from", " ", "term"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MonomialsOfTerm", "[", 
     RowBox[{"term_", ",", 
      RowBox[{"IndexList", "[", "is___", "]"}], ",", "monomials_List", ",", 
      RowBox[{"Monomial", "[", 
       RowBox[{"monomial_", ",", "minds_"}], "]"}]}], "]"}], ":=", 
    RowBox[{"MonomialsOfTerm", "[", 
     RowBox[{
      RowBox[{"term", "/", "monomial"}], ",", 
      RowBox[{"Complement", "[", 
       RowBox[{
        RowBox[{"IndexList", "[", "is", "]"}], ",", 
        RowBox[{"FindIndices", "[", "monomial", "]"}]}], "]"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"monomials", ",", 
        RowBox[{"Monomial", "[", 
         RowBox[{"monomial", ",", "minds"}], "]"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Non", "-", 
     RowBox[{"indexed", " ", 
      RowBox[{"monomial", ".", " ", "Prepend"}], " ", "to", " ", "list", " ", 
      "with", " ", "head", " ", "ScalarMonomial"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MonomialsOfTerm", "[", 
     RowBox[{"term_", ",", 
      RowBox[{"IndexList", "[", "]"}], ",", "monomials_List"}], "]"}], ":=", 
    RowBox[{"Prepend", "[", 
     RowBox[{"monomials", ",", 
      RowBox[{"ScalarMonomial", "@@", 
       RowBox[{"ListOfFactors", "[", "term", "]"}]}]}], "]"}]}]}]}]], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"12fbb85a-8347-4bf6-9555-16561baea8d3"],

Cell["\<\
Note that MonomialsOfTerms is also used in the simplification of Scalar \
expressions. See further below. This is the user driver:\
\>", "Text",ExpressionUUID->"195c3ac8-cbaf-4694-a1f3-608ea6d8785c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BreakInMonomials", "[", "expr_Plus", "]"}], ":=", 
   RowBox[{"BreakInMonomials", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BreakInMonomials", "[", "expr_", "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Times", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"MonomialsOfTerm", "[", "expr", "]"}], "/.", 
       RowBox[{"ScalarMonomial", "\[Rule]", "Times"}]}], "/.", 
      RowBox[{
       RowBox[{"Monomial", "[", 
        RowBox[{"mono_", ",", "inds_"}], "]"}], "\[Rule]", 
       RowBox[{"Monomial", "[", "mono", "]"}]}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"BreakInMonomials", ",", "1"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "BreakInMonomials", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"d127337b-0265-4f71-9625-36a051f457bb"],

Cell["Examples:", \
"Text",ExpressionUUID->"90a8832d-a140-4ffd-bb9e-6a56022a9389"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"7ecaac15-77d6-4204-8846-9a5b2416a242"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{"1", ",", 
   RowBox[{"-", "A"}]}], 
  "]"}]], "Input",ExpressionUUID->"9d447efb-7fbd-4fe2-8743-6a93883468f3"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", "1", "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[1, 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Output",ExpressionUUID->"502dc338-dcd8-493b-ac84-c2f63763ae64"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F", ",", "C"}], "]"}], ",", "A"}], 
  "]"}]], "Input",ExpressionUUID->"9d31900f-b611-4039-942b-cbcbb82e6ab1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "F", "C"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`F, C],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[
   $CellContext`T[$CellContext`A, $CellContext`F, C], 
   xAct`xTensor`IndexList[$CellContext`A, C, $CellContext`F]],
  Editable->
   False]], "Output",ExpressionUUID->"8c8f8b2c-fb98-45d4-9f7c-fcb8bb38a6e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"d6bb0392-db25-46f4-9e6a-37a8fb1d11eb"],

Cell["Monomial[T[A, F, C], IndexList[A, C, F]]", \
"Output",ExpressionUUID->"63c98e6c-8dc1-4058-91f5-cddd9a05289a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "H", "]"}], "[", 
     RowBox[{"V", "[", 
      RowBox[{"J", ",", "B"}], "]"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "H"}]}], "]"}]}], ",", 
   RowBox[{"-", "G"}]}], 
  "]"}]], "Input",ExpressionUUID->"b8dc7b9f-7bec-4ed2-8e6b-77b34aee907b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"B", "G", "H"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"J", "B", 
              RowBox[{"|", "H"}]},
             {" ", " ", "  "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
     $CellContext`V[$CellContext`J, $CellContext`B]], 
   xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
  Editable->
   False]], "Output",ExpressionUUID->"6f1a08fa-3c03-4504-8b53-23aeddb0dc87"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "H", "]"}], "[", 
     RowBox[{"V", "[", 
      RowBox[{"J", ",", "B"}], "]"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "H"}]}], "]"}]}], ",", "J"}], 
  "]"}]], "Input",ExpressionUUID->"c176b884-e7bb-4ebd-a588-6dc7ac3d5b85"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"B", "G", "H"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"J", "B", 
              RowBox[{"|", "H"}]},
             {" ", " ", "  "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
     $CellContext`V[$CellContext`J, $CellContext`B]], 
   xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
  Editable->
   False]], "Output",ExpressionUUID->"9bfcaeee-095f-4fc4-a8fb-b1a880fcaecf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "H", "]"}], "[", 
     RowBox[{"V", "[", 
      RowBox[{"J", ",", "B"}], "]"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "H"}]}], "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{
     RowBox[{"-", "D"}], ",", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1de824ee-a448-4a55-9022-fb06f0c03765"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"A", "F", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "F", "C"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`F, C],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
     D] $CellContext`T[$CellContext`A, $CellContext`F, C], 
   xAct`xTensor`IndexList[C, -D]],
  Editable->
   False]], "Output",ExpressionUUID->"5b8a6f5f-b6fd-46dd-b6a0-3292855d15a2"]
}, Open  ]],

Cell["\<\
Note that if we give one of the dummy indices the function returns the \
correct result too:\
\>", "Text",ExpressionUUID->"51eff144-e859-4c30-8c9a-311545743230"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "H", "]"}], "[", 
     RowBox[{"V", "[", 
      RowBox[{"J", ",", "B"}], "]"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "H"}]}], "]"}]}], ",", "F"}], 
  "]"}]], "Input",ExpressionUUID->"df38a446-c00e-48d8-8955-dc6daf4603fb"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"A", "F", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "F", "C"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`F, C],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
     D] $CellContext`T[$CellContext`A, $CellContext`F, C], 
   xAct`xTensor`IndexList[C, -D]],
  Editable->
   False]], "Output",ExpressionUUID->"f47422d3-a10f-4676-b456-3ebd67e708e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "H", "]"}], "[", 
     RowBox[{"V", "[", 
      RowBox[{"J", ",", "B"}], "]"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "H"}]}], "]"}]}], ",", 
   RowBox[{"-", "F"}]}], 
  "]"}]], "Input",ExpressionUUID->"ff470c74-2bc1-41e9-b74a-3e9985939aac"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"A", "F", "D"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "F", "C"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`F, C],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
     D] $CellContext`T[$CellContext`A, $CellContext`F, C], 
   xAct`xTensor`IndexList[C, -D]],
  Editable->
   False]], "Output",ExpressionUUID->"8b54f427-e76c-48fd-9e63-973e302ecf16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`FindMonomial", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{
     RowBox[{"Cd", "[", "H", "]"}], "[", 
     RowBox[{"V", "[", 
      RowBox[{"J", ",", "B"}], "]"}], "]"}], 
    RowBox[{"UU", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "G"}], ",", 
      RowBox[{"-", "H"}]}], "]"}]}], ",", "H"}], 
  "]"}]], "Input",ExpressionUUID->"7710652f-1753-48fe-bfa8-831c602e08d7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{"Monomial", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"UU", 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"B", "G", "H"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"J", "B", 
              RowBox[{"|", "H"}]},
             {" ", " ", "  "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]],
      Editable->False]}], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
     $CellContext`V[$CellContext`J, $CellContext`B]], 
   xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
  Editable->
   False]], "Output",ExpressionUUID->"2b24ea86-8165-4c13-a44c-f04219c507dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`MonomialsOfTerm", "[", 
  RowBox[{"3", " ", 
   RowBox[{"Mass", "^", "2"}], 
   RowBox[{"T", "[", "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", "H", "]"}], "[", 
    RowBox[{"V", "[", 
     RowBox[{"J", ",", "B"}], "]"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "H"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"98c4e34c-dda3-428e-87cb-0aed93aa3cdf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"xAct`xTensor`Private`ScalarMonomial", "[", 
    RowBox[{"3", ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Mass",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Mass,
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox["T",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[],
      Editable->False]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"A", "F", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "F", "C"},
               {" ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`F, C],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
       D] $CellContext`T[$CellContext`A, $CellContext`F, C], 
     xAct`xTensor`IndexList[C, -D]],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"B", "G", "H"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"V", 
            StyleBox[GridBox[{
               {"J", "B", 
                RowBox[{"|", "H"}]},
               {" ", " ", "  "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Cd[$CellContext`H][
         $CellContext`V[$CellContext`J, $CellContext`B]],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]], 
     xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"5dbc0911-6a8e-4e7f-8e95-d4d8d14aa350"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`MonomialsOfTerm", "[", 
  RowBox[{"3", " ", 
   RowBox[{"Mass", "^", "2"}], 
   RowBox[{"T", "[", "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", "H", "]"}], "[", 
    RowBox[{"V", "[", 
     RowBox[{"J", ",", "B"}], "]"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "H"}]}], "]"}], 
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"U", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"UU", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "B"}]}], "]"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"195c67a0-94ac-40ea-90f2-5a782efb325f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"xAct`xTensor`Private`ScalarMonomial", "[", 
    RowBox[{"3", ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Mass",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Mass,
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["(",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{
         RowBox[{"U", "[", 
          RowBox[{"A", ",", "B"}], "]"}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"UU", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`UU[-$CellContext`A, -$CellContext`B],
          Editable->False]}], 
        StyleBox[")",
         FontColor->RGBColor[1, 0, 0]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`Scalar[$CellContext`U[$CellContext`A, $CellContext`B] \
$CellContext`UU[-$CellContext`A, -$CellContext`B]],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["T",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[],
      Editable->False]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"A", "F", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "F", "C"},
               {" ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`F, C],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
       D] $CellContext`T[$CellContext`A, $CellContext`F, C], 
     xAct`xTensor`IndexList[C, -D]],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"B", "G", "H"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"V", 
            StyleBox[GridBox[{
               {"J", "B", 
                RowBox[{"|", "H"}]},
               {" ", " ", "  "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Cd[$CellContext`H][
         $CellContext`V[$CellContext`J, $CellContext`B]],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]], 
     xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"ff441447-c1ba-487c-a3fc-0f5ba79edd62"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`MonomialsOfTerm", "[", 
  RowBox[{"3", " ", 
   RowBox[{"Mass", "^", "2"}], 
   RowBox[{"T", "[", "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", "H", "]"}], "[", 
    RowBox[{"V", "[", 
     RowBox[{"J", ",", "B"}], "]"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "H"}]}], "]"}], 
   RowBox[{
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"UU", "[", 
       RowBox[{"A", ",", "B"}], "]"}], 
      RowBox[{"UU", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "]"}]}], "]"}], "^", "2"}]}], 
  "]"}]], "Input",ExpressionUUID->"0bec5f98-f32d-4e3f-bced-dcdce1ae8228"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"xAct`xTensor`Private`ScalarMonomial", "[", 
    RowBox[{"3", ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Mass",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Mass,
       Editable->False], "2"], ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["(",
          FontColor->RGBColor[1, 0, 0]], 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"UU", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"A", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`UU[-$CellContext`A, -$CellContext`B],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"UU", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`UU[$CellContext`A, $CellContext`B],
           Editable->False]}], 
         StyleBox[")",
          FontColor->RGBColor[1, 0, 0]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox["T",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[],
      Editable->False]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"A", "F", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "F", "C"},
               {" ", " ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`F, C],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
       D] $CellContext`T[$CellContext`A, $CellContext`F, C], 
     xAct`xTensor`IndexList[C, -D]],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"B", "G", "H"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"V", 
            StyleBox[GridBox[{
               {"J", "B", 
                RowBox[{"|", "H"}]},
               {" ", " ", "  "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Cd[$CellContext`H][
         $CellContext`V[$CellContext`J, $CellContext`B]],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]], 
     xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"182df99c-ed2d-4fd1-b1d3-368a4d23c592"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`MonomialsOfTerm", "[", 
  RowBox[{"3", " ", 
   RowBox[{"Mass", "^", "2"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Polar"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "Polar"}], "}"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F", ",", "C", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "Polar"}], "}"}], ",", 
     RowBox[{"Dir", "[", 
      RowBox[{"V", "[", "Z", "]"}], "]"}]}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", "H", "]"}], "[", 
    RowBox[{"V", "[", 
     RowBox[{"J", ",", "B"}], "]"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "H"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "Polar"}], "}"}]}], "]"}], 
   RowBox[{
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"UU", "[", 
       RowBox[{"A", ",", "B"}], "]"}], 
      RowBox[{"UU", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "]"}]}], "]"}], "^", "2"}]}], 
  "]"}]], "Input",ExpressionUUID->"a3541e52-1ae3-47b5-92a2-5e6bc3e7d616"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"xAct`xTensor`Private`ScalarMonomial", "[", 
    RowBox[{"3", ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Mass",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Mass,
       Editable->False], "2"], ",", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox[
        RowBox[{
         StyleBox["(",
          FontColor->RGBColor[1, 0, 0]], 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"UU", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"A", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`UU[-$CellContext`A, -$CellContext`B],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"UU", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`UU[$CellContext`A, $CellContext`B],
           Editable->False]}], 
         StyleBox[")",
          FontColor->RGBColor[1, 0, 0]]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Scalar[$CellContext`UU[-$CellContext`A, -$CellContext`B] \
$CellContext`UU[$CellContext`A, $CellContext`B]],
       Editable->False], "2"], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {
              StyleBox["1",
               FontColor->RGBColor[0., 0., 1.]], 
              StyleBox["1",
               FontColor->RGBColor[0., 0., 1.]], 
              StyleBox[
               RowBox[{"-", "1"}],
               FontColor->RGBColor[0., 0., 1.]]},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[{1, $CellContext`Polar}, {
       1, $CellContext`Polar}, {-1, $CellContext`Polar}],
      Editable->False]}], "]"}], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {" ", " ", " "},
               {"A", "F", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"A", "F", "C", 
                StyleBox[
                 RowBox[{"-", "1"}],
                 FontColor->RGBColor[0., 0., 1.]], " "},
               {" ", " ", " ", " ", "V"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[$CellContext`A, $CellContext`F, 
         C, {-1, $CellContext`Polar}, 
         xAct`xTensor`Dir[
          $CellContext`V[$CellContext`Z]]],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
       D] $CellContext`T[$CellContext`A, $CellContext`F, 
       C, {-1, $CellContext`Polar}, 
       xAct`xTensor`Dir[
        $CellContext`V[$CellContext`Z]]], 
     xAct`xTensor`IndexList[C, -D]],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Monomial", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"UU", 
            StyleBox[GridBox[{
               {" ", " ", " ", 
                StyleBox[
                 RowBox[{"-", "1"}],
                 FontColor->RGBColor[0., 0., 1.]]},
               {"B", "G", "H", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H, \
{-1, $CellContext`Polar}],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"V", 
            StyleBox[GridBox[{
               {"J", "B", 
                RowBox[{"|", "H"}]},
               {" ", " ", "  "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Cd[$CellContext`H][
         $CellContext`V[$CellContext`J, $CellContext`B]],
        Editable->False]}], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H, {-1, $CellContext`Polar}] $CellContext`Cd[$CellContext`H][
       $CellContext`V[$CellContext`J, $CellContext`B]], 
     xAct`xTensor`IndexList[-$CellContext`G, $CellContext`J]],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"829c990d-8b35-43e5-8497-4bfdabbe1c47"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BreakInMonomials", "[", 
  RowBox[{"3", " ", 
   RowBox[{"Mass", "^", "2"}], 
   RowBox[{"T", "[", "]"}], 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F", ",", "C"}], "]"}], 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], 
   RowBox[{
    RowBox[{"Cd", "[", "H", "]"}], "[", 
    RowBox[{"V", "[", 
     RowBox[{"J", ",", "B"}], "]"}], "]"}], 
   RowBox[{"UU", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "G"}], ",", 
     RowBox[{"-", "H"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"3d65e6d7-d7f6-44d2-bce2-979f2441b297"],

Cell[BoxData[
 RowBox[{"3", " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["Mass",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False], "2"], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{"Monomial", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {" ", " ", " "},
              {"A", "F", "D"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[-$CellContext`A, -$CellContext`F, -D],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"A", "F", "C"},
              {" ", " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`A, $CellContext`F, C],
       Editable->False]}], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Monomial[$CellContext`S[-$CellContext`A, -$CellContext`F, -
      D] $CellContext`T[$CellContext`A, $CellContext`F, C]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{"Monomial", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"UU", 
           StyleBox[GridBox[{
              {" ", " ", " "},
              {"B", "G", "H"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`UU[-$CellContext`B, -$CellContext`G, -$CellContext`H],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {"J", "B", 
               RowBox[{"|", "H"}]},
              {" ", " ", "  "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Cd[$CellContext`H][
        $CellContext`V[$CellContext`J, $CellContext`B]],
       Editable->False]}], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Monomial[$CellContext`UU[-$CellContext`B, -$CellContext`G, \
-$CellContext`H] $CellContext`Cd[$CellContext`H][
      $CellContext`V[$CellContext`J, $CellContext`B]]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox["T",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[],
   Editable->
    False]}]], "Output",ExpressionUUID->"a08c0b1d-96ca-4c01-8972-0ddb8c4e9636"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "InputForm"}]], \
"Input",ExpressionUUID->"43026c24-b463-47fb-97bd-138841d42e66"],

Cell["\<\
3*Mass^2*Monomial[S[-A, -F, -D]*T[A, F, C]]*Monomial[UU[-B, -G, \
-H]*Cd[H][V[J, B]]]*T[]\
\>", "Output",ExpressionUUID->"1ba7a4dc-7603-426a-913e-67878dc5642c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefCovD", "[", "Cd", 
  "]"}]], "Input",ExpressionUUID->"10350159-5362-461b-8b8d-fe3caa6d31cb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCd],
  Editable->
   False]], "Print",ExpressionUUID->"d86897fc-8259-4238-82f0-d48ef5e4ead7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"non-symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "non-symmetric Ricci tensor", " ", $CellContext`RicciCd],
  Editable->
   False]], "Print",ExpressionUUID->"6345b7bb-af37-4c94-bad0-9fb658f9228c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCd],
  Editable->
   False]], "Print",ExpressionUUID->"3053b862-a92c-4e7c-9c33-8b53a38a2b98"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCd],
  Editable->
   False]], "Print",ExpressionUUID->"f82e2a98-fe89-4031-b3ff-9633f0a41fa0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Cd"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`Cd],
  Editable->
   False]], "Print",ExpressionUUID->"940f5500-b458-4263-899f-e48db9e24bbe"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", 
  "]"}]], "Input",ExpressionUUID->"dd09e99f-8392-4383-bc52-9e28ab9ee832"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["Mass",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Mass,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefConstantSymbol, ": Undefined ", "constant symbol", 
   " ", $CellContext`Mass],
  Editable->
   False]], "Print",ExpressionUUID->"a0042f67-130b-434a-aa7f-04458351c610"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "UU", ",", "S", ",", "V"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"025a41a0-55af-4a06-a754-68cec13277e2"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"87ff1941-900d-46d3-bd85-88c355f6d254"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "UU"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`UU],
  Editable->
   False]], "Print",ExpressionUUID->"c4025635-6ec2-4188-ba5f-de7471468672"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"77d09d26-7962-4603-91fd-a09d750b6853"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"cf06eff5-8b11-4dfd-9115-f81c5cbe2b57"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"a5b7e6c3-e925-4194-a6fa-bc55174a0745"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"J\"\>", ",", "\<\"U\"\>"}], "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"J", "U"}],
  Editable->
   False]], "Print",ExpressionUUID->"bc73ecce-5de6-4c88-a019-118419d71774"]
}, Open  ]],

Cell["\<\
These three functions work nicely, but they could be more efficient.\
\>", "Text",ExpressionUUID->"8ffcdf73-01d4-475e-bfd3-2027714f2ad7"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.5.2. Manipulation of Scalar expressions", \
"Subsubsection",ExpressionUUID->"fa7f906a-840d-4ae4-9a62-6664a6fa93c2"],

Cell["\<\
Three functions are needed to manipulate expressions containing the head \
Scalar. The functions PutScalar and NoScalar are inverse of each other. We \
could introduce the inverse of BreakScalars (say GroupScalars), but that \
would be difficult, and it is not clear to me that it is really needed.\
\>", "Text",ExpressionUUID->"e7141dbe-575c-441d-9fec-2f0987635f5e"],

Cell["\<\
1) A Scalar expression can be broken in several Scalar expressions:\
\>", "Text",ExpressionUUID->"80d22b4c-763b-44a4-8fb7-9f8d17ad3773"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BreakScalars", "[", "expr_", "]"}], ":=", 
  RowBox[{"expr", "/.", 
   RowBox[{
    RowBox[{"Scalar", "[", "s_", "]"}], "\[RuleDelayed]", 
    RowBox[{"Apply", "[", 
     RowBox[{"Times", ",", 
      RowBox[{
       RowBox[{"MonomialsOfTerm", "[", "s", "]"}], "//.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ScalarMonomial", "\[Rule]", "Times"}], ",", 
         RowBox[{
          RowBox[{"Monomial", "[", 
           RowBox[{"monomial_", ",", 
            RowBox[{"IndexList", "[", "]"}]}], "]"}], "\[Rule]", 
          RowBox[{"Scalar", "[", "monomial", "]"}]}]}], "}"}]}]}], 
     "]"}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"0220843e-85b2-4a23-82bb-eb06ed5c03e3"],

Cell["\<\
2) This function detects the presence of scalars with indexed objects and \
introduces the head Scalar:\
\>", "Text",ExpressionUUID->"c154ea9d-7ba7-42c0-ac91-40e0f9a950f3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"makeScalar", "[", 
   RowBox[{"ScalarMonomial", "[", "expr__", "]"}], "]"}], ":=", 
  RowBox[{"Times", "[", "expr", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"makeScalar", "[", "expr_Scalar", "]"}], ":=", 
  "expr"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"makeScalar", "[", 
   RowBox[{"Monomial", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"IndexList", "[", "]"}]}], "]"}], "]"}], ":=", 
  RowBox[{"Scalar", "[", "expr", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"makeScalar", "[", 
   RowBox[{"Monomial", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"IndexList", "[", "__", "]"}]}], "]"}], "]"}], ":=", 
  "expr"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"cf4b027a-f8e3-4c76-bb50-e6264118ec71"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PutScalar", "[", "expr_", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Plus", ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Times", ",", 
         RowBox[{"makeScalar", "/@", 
          RowBox[{"MonomialsOfTerm", "[", "#", "]"}]}]}], "]"}], "&"}], "/@", 
      
      RowBox[{"ListOfTerms", "[", "expr", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{"ScalarMonomial", "\[Rule]", "Times"}], "}"}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"695feae9-f1cd-484e-bdd1-7f314fa3090f"],

Cell["\<\
3) Scalar expressions are converted into normal tensorial expressions without \
the Scalar head. Dummy indices cannot be repeated. We assume that the only \
dangerous case is the power of a Scalar expression. This is a dangerous \
operation that could easily lead to index collisions if used without care:\
\>", "Text",ExpressionUUID->"3b6cc027-b765-45f2-be9a-78caef63752b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NoScalar", "[", "expr_", "]"}], ":=", 
  RowBox[{
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"Scalar", "[", "x_", "]"}], "^", 
      RowBox[{"n_Integer", "?", "Positive"}]}], "\[RuleDelayed]", 
     RowBox[{"Apply", "[", 
      RowBox[{"Times", ",", 
       RowBox[{"ReplaceDummies", "/@", 
        RowBox[{"Table", "[", 
         RowBox[{"x", ",", 
          RowBox[{"{", "n", "}"}]}], "]"}]}]}], "]"}]}]}], "/.", 
   RowBox[{
    RowBox[{"Scalar", "[", "x_", "]"}], "\[RuleDelayed]", 
    RowBox[{"ReplaceDummies", "[", "x", "]"}]}]}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"d5444e8c-e537-4bec-9a77-026b5d756852"],

Cell["New safer code, developed together with Guillaume Faye:", \
"Text",ExpressionUUID->"c7306022-a7b8-4265-a8c7-3329038ddd21"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Thread", " ", "over", " ", "Plus", " ", "and", " ", "Times"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", "expr_Plus", "]"}], ":=", 
     RowBox[{"NoScalar", "/@", "expr"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", "expr_Times", "]"}], ":=", 
     RowBox[{"NoScalar", "/@", "expr"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Remove", " ", "Scalar", " ", "head", " ", "from", " ", "positive", " ", 
     "powers"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", 
      RowBox[{"Power", "[", 
       RowBox[{"expr_", ",", 
        RowBox[{"n_Integer", "?", "Positive"}]}], "]"}], "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"Times", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"NoScalar", "[", "expr", "]"}], ",", 
         RowBox[{"{", "n", "}"}]}], "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", 
      RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"ReplaceDummies", "[", "expr", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Skip", " ", "inert", " ", "heads"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", 
      RowBox[{
       RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
     RowBox[{"ih", "[", 
      RowBox[{
       RowBox[{"NoScalar", "[", "expr", "]"}], ",", "z"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", 
      RowBox[{"expr", ":", 
       RowBox[{
        RowBox[{"_", "?", "ProductQ"}], "[", "___", "]"}]}], "]"}], ":=", 
     RowBox[{"NoScalar", "/@", "expr"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Derivatives", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", 
      RowBox[{
       RowBox[{"der_", "?", "FirstDerQ"}], "[", "expr_", "]"}], "]"}], ":=", 
     RowBox[{"der", "[", 
      RowBox[{"NoScalar", "[", "expr", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Do", " ", "nothing", " ", "on", " ", "other", " ", "cases"}], 
    " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"NoScalar", "[", "expr_", "]"}], ":=", "expr"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"NoScalar", ",", "1"}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Protect", "[", "NoScalar", "]"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"29857ed8-1947-48e1-b62f-665c772e66de"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.5.3. Examples with Scalar", \
"Subsubsection",ExpressionUUID->"a786ff60-15ca-48bf-a1af-5cdf198956ac"],

Cell["Examples:", \
"Text",ExpressionUUID->"32d30c02-4727-4637-83ee-7fae0fd76695"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"438bb325-bf7b-4d9f-85f8-e35682cdb7ec"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]}], "Input",ExpressionUUID->"1672d3d7-bb82-40b1-8321-0871c19ec9e8"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3aa65d99-9c76-41ff-bdaf-b56e5f41b03b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"95bfaf47-188a-41e7-b309-b467063302b8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Scalar", "[", 
  RowBox[{
   RowBox[{"v", "[", "B$", "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "B$"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c7e8340-a7d2-412a-a21d-738bb81815ea"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["(",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {" "},
             {"B$"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[-$CellContext`B$],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {"B$"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[$CellContext`B$],
      Editable->False]}], 
    StyleBox[")",
     FontColor->RGBColor[1, 0, 0]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Scalar[$CellContext`v[-$CellContext`B$] \
$CellContext`v[$CellContext`B$]],
  Editable->
   False]], "Output",ExpressionUUID->"3234d0f7-8eac-47ab-ae53-6e4039b9556a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"c70fd97a-2c95-4979-a615-c9eb2135ac2a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["(",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[-$CellContext`A],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {"A"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[$CellContext`A],
      Editable->False]}], 
    StyleBox[")",
     FontColor->RGBColor[1, 0, 0]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"6b3eea02-a221-4a09-9616-2dae42f2f0b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"%", "^", "2"}], 
  "]"}]], "Input",ExpressionUUID->"b0d99c91-3862-4feb-a9e9-df7be052a3f6"],

Cell[BoxData[
 SuperscriptBox[
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
   Editable->False], 
  "2"]], "Output",ExpressionUUID->"0c78e915-5424-4557-ad93-53fec0953edf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"v", "[", "A$", "]"}], 
      RowBox[{"v", "[", 
       RowBox[{"-", "A$"}], "]"}]}], "]"}], "^", "2"}], 
   RowBox[{
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"v", "[", "B", "]"}], 
      RowBox[{"v", "[", 
       RowBox[{"-", "B"}], "]"}]}], "]"}], "^", "3"}]}], 
  "]"}]], "Input",ExpressionUUID->"bbdcdf7b-af9f-4326-9c94-d618ff5aa9e7"],

Cell[BoxData[
 SuperscriptBox[
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
   Editable->False], 
  "5"]], "Output",ExpressionUUID->"29afc90c-3c9a-4620-af32-1d3f88e47d4f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"Scalar", "[", 
      RowBox[{
       RowBox[{"v", "[", "A$", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "A$"}], "]"}]}], "]"}], "^", "2"}], 
    RowBox[{
     RowBox[{"Scalar", "[", 
      RowBox[{
       RowBox[{"v", "[", "B", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "B"}], "]"}]}], "]"}], "^", "3"}]}], 
   RowBox[{"Scalar", "[", 
    RowBox[{
     RowBox[{"v", "[", "C", "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}], "]"}]], "//", 
  "Simplification"}]], \
"Input",ExpressionUUID->"574bfd0d-a813-43bb-9f4d-a88581e56340"],

Cell[BoxData[
 SuperscriptBox[
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
   Editable->False], 
  "4"]], "Output",ExpressionUUID->"fbbcb728-f351-4d78-96e1-dd8608ac4bae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{"Scalar", "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"A$", ",", "B$"}], "]"}], 
      RowBox[{"v", "[", 
       RowBox[{"-", "A$"}], "]"}], 
      RowBox[{"v", "[", 
       RowBox[{"-", "B$"}], "]"}]}], "]"}], "]"}], "//", "Simplification"}], "//",
   "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"0a84276b-0f28-4c8d-9706-6ce2af3ad165"],

Cell[BoxData[
 SuperscriptBox["\[ExponentialE]", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[$CellContext`A, $CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`B],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[($CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`v[-$CellContext`A]) $CellContext`v[-$CellContext`B]],
   Editable->
    False]]], \
"Output",ExpressionUUID->"a9d5511a-8a47-41ed-82b1-f6222e1bb018"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Scalar", "[", 
   RowBox[{
    RowBox[{"v", "[", "A$", "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A$"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"C$", ",", "D$"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C$"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "D$"}], "]"}]}], "]"}], "/", 
  RowBox[{"Scalar", "[", 
   RowBox[{
    RowBox[{"v", "[", "A", "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"f9d9c6e4-a8ce-47ff-b8a1-b4418b330319"],

Cell[BoxData[
 FractionBox[
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {"C$", "D$"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[C$, D$],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A$"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A$],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A$"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A$],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"C$"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-C$],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"D$"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-D$],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[((($CellContext`T[
        C$, D$] $CellContext`v[-$CellContext`A$]) \
$CellContext`v[$CellContext`A$]) $CellContext`v[-C$]) $CellContext`v[-D$]],
   Editable->False], 
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
   Editable->
    False]]], \
"Output",ExpressionUUID->"efe807dc-75b8-4d7d-bcca-2321f0417e72"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "BreakScalars"}]], \
"Input",ExpressionUUID->"30cf806b-15d4-4aec-8947-ab21db234011"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"A$"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-$CellContext`A$],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A$"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`A$],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A$] \
$CellContext`v[$CellContext`A$]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"C$", "D$"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[C$, D$],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"C$"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-C$],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"D$"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-D$],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[($CellContext`T[
       C$, D$] $CellContext`v[-C$]) $CellContext`v[-D$]],
    Editable->False]}], 
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["(",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], 
     StyleBox[")",
      FontColor->RGBColor[1, 0, 0]]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
   Editable->
    False]]], \
"Output",ExpressionUUID->"e64edead-aca1-4475-9fec-94fb75d4930f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "Simplification"}]], \
"Input",ExpressionUUID->"8b4c3bcb-931d-4fd4-a9bf-abde69819660"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["(",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[$CellContext`A, $CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[-$CellContext`A],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {" "},
             {"B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[-$CellContext`B],
      Editable->False]}], 
    StyleBox[")",
     FontColor->RGBColor[1, 0, 0]]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`Scalar[($CellContext`T[$CellContext`A, $CellContext`B] \
$CellContext`v[-$CellContext`A]) $CellContext`v[-$CellContext`B]],
  Editable->
   False]], "Output",ExpressionUUID->"4f325682-e02d-41ca-a796-a25f8751ab6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"v", ",", "T"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"2b5f7a58-dbc1-4a97-925d-bdf9e416f342"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"62c1f9a4-9a39-45f2-b2cb-e1ee64429936"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"103d7f70-083a-402c-bcde-dafa125b4f34"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e1a44bd2-2cec-4d09-bd9f-1e1ca0773a63"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$302887\"\>", ",", "\<\"G$302896\"\>", 
     ",", "\<\"G$302904\"\>", ",", "\<\"G$302912\"\>", 
     ",", "\<\"G$302920\"\>", ",", "\<\"G$302928\"\>", 
     ",", "\<\"G$302936\"\>", ",", "\<\"G$302944\"\>", 
     ",", "\<\"G$302945\"\>", ",", "\<\"G$302954\"\>", 
     ",", "\<\"G$302962\"\>", ",", "\<\"G$302970\"\>", 
     ",", "\<\"G$302971\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$302887", "G$302896", "G$302904", "G$302912", "G$302920", "G$302928", 
    "G$302936", "G$302944", "G$302945", "G$302954", "G$302962", "G$302970", 
    "G$302971"}],
  Editable->
   False]], "Print",ExpressionUUID->"4d666e36-ea0c-4c7b-b767-76a7bd300022"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.5.4. STF tensors", \
"Subsubsection",ExpressionUUID->"d804a4bf-bc0d-4c05-a469-aefd653f67a5"],

Cell["\<\
Coefficient to substract the n-th trace of a tensor with l indices in d \
dimensions:\
\>", "Text",ExpressionUUID->"d0cd3604-447e-4de5-b911-af42212ab34a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"asymcoeff", "[", 
   RowBox[{"n_", ",", "l_", ",", "d_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Gamma", "[", 
    RowBox[{"l", "-", "n", "+", 
     RowBox[{"d", "/", "2"}], "-", "1"}], "]"}], 
   RowBox[{
    RowBox[{"Gamma", "[", 
     RowBox[{"l", "+", "1"}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "4"}], ")"}], "^", "n"}], " ", 
      RowBox[{"Gamma", "[", 
       RowBox[{"n", "+", "1"}], "]"}], 
      RowBox[{"Gamma", "[", 
       RowBox[{"l", "+", 
        RowBox[{"d", "/", "2"}], "-", "1"}], "]"}], 
      RowBox[{"Gamma", "[", 
       RowBox[{"l", "+", "1", "-", 
        RowBox[{"2", "n"}]}], "]"}]}], ")"}]}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c749db96-bf83-480c-9a48-0615dbec561e"],

Cell["\<\
Note that it also can be written as (this has been deactivated):\
\>", "Text",ExpressionUUID->"607ef160-1a86-4570-b502-0be0ccb28ef8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[LineSeparator]", 
  RowBox[{
   RowBox[{
    RowBox[{"asymcoeff", "[", 
     RowBox[{"n", ",", "l", ",", "d"}], "]"}], "==", 
    FractionBox[
     RowBox[{" ", 
      RowBox[{
       RowBox[{"Binomial", "[", 
        RowBox[{"l", ",", "n"}], "]"}], " ", 
       RowBox[{"Binomial", "[", 
        RowBox[{
         RowBox[{"l", "-", "n"}], ",", "n"}], "]"}]}]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "4"}], ")"}], "n"], 
      RowBox[{"Binomial", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         FractionBox["d", "2"], "+", "l"}], ",", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         FractionBox["d", "2"], "+", "l", "-", "n"}]}], "]"}]}]]}], "//", 
   "FullSimplify"}]}]], "Input",
 Evaluatable->False,ExpressionUUID->"93b68e44-a49c-4a6d-8927-aab58ae9d38c"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"8e59d6a8-949f-490b-8fb4-bc6d0573316f"]
}, Open  ]],

Cell["\<\
This is the STF command. Note that we select the AIndices only. This function \
does not worry about non-metric derivatives, bases, etc. It needs a more \
careful behaviour:\
\>", "Text",ExpressionUUID->"12b873ee-585e-4c0b-aefc-5d91238a4601"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"STFPart", "::", "wrongsym"}], "=", 
   "\"\<Indices with different height cannot be symmetrized: `1`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"STFPart", "[", 
    RowBox[{"expr_", ",", "metric_", ",", 
     RowBox[{"indices_", ":", "All"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "n", ",", "l", ",", "inds", ",", "symexpr", ",", "pairs", ",", 
       "dummypairs", ",", "dummy", ",", "dim"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "Indices", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"inds", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"FindFreeIndices", "[", "expr", "]"}], ",", "AIndexQ"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"indices", "=!=", "All"}], ",", 
        RowBox[{"inds", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{"inds", ",", 
           RowBox[{"IndexList", "@@", "indices"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"l", "=", 
       RowBox[{"Length", "[", "inds", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pairs", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"inds", ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"dummypairs", "=", 
       RowBox[{"Map", "[", 
        RowBox[{"DummyAs", ",", "pairs", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Dimension", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"dummy", "=", 
       RowBox[{"DummyIn", "[", 
        RowBox[{"VBundleOfMetric", "[", "metric", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dim", "=", 
       RowBox[{"metric", "[", 
        RowBox[{"dummy", ",", 
         RowBox[{"-", "dummy"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Symmetrize", ".", " ", "Sent"}], " ", "message"}], ",", " ", 
        RowBox[{"but", " ", "do", " ", "not", " ", "throw", " ", "it"}]}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"SameQ", "@@", 
          RowBox[{"(", 
           RowBox[{"UpIndexQ", "/@", "inds"}], ")"}]}], "]"}], ",", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"STFPart", "::", "wrongsym"}], ",", "inds"}], "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"symexpr", "=", 
       RowBox[{"xAct`xTensor`Symmetrize", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"List", "@@", "inds"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Remove", " ", "traces"}], " ", "*)"}], "\[IndentingNewLine]", 
      
      RowBox[{"symexpr", "+", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"asymcoeff", "[", 
           RowBox[{"n", ",", "l", ",", "dim"}], "]"}], 
          RowBox[{"xAct`xTensor`Symmetrize", "[", 
           RowBox[{
            RowBox[{"symexpr", "=", 
             RowBox[{
              RowBox[{"metric", "@@", 
               RowBox[{"(", 
                RowBox[{"pairs", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], ")"}]}], 
              RowBox[{"metric", "@@", 
               RowBox[{"(", 
                RowBox[{"ChangeIndex", "/@", 
                 RowBox[{"dummypairs", "[", 
                  RowBox[{"[", "n", "]"}], "]"}]}], ")"}]}], 
              RowBox[{"ReplaceIndex", "[", 
               RowBox[{
                RowBox[{"Evaluate", "[", "symexpr", "]"}], ",", 
                RowBox[{"Inner", "[", 
                 RowBox[{"Rule", ",", 
                  RowBox[{"pairs", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", 
                  RowBox[{"dummypairs", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], ",", "List"}], "]"}]}], 
               "]"}]}]}], " ", ",", 
            RowBox[{"List", "@@", "inds"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "1", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"l", "/", "2"}], "]"}]}], "}"}]}], "]"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"STFPart", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "STFPart", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"51efe631-f2f0-4d14-802b-b7a806f7d1a9"]
}, Closed]],

Cell[CellGroupData[{

Cell["15.5.6. Implicit symmetrization. The Sym head", \
"Subsubsection",ExpressionUUID->"84da6519-da1f-4ea6-aef6-c1a6fd55ce3e"],

Cell["\<\
We introduce a new head which plays the role of Symmetrize, but without \
actually expanding the expression. Thanks toThomas Backdahl for discussions \
on this object.\
\>", "Text",ExpressionUUID->"d58d10d5-7174-48f8-affe-1ae35cde4118"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Definition", " ", "of", " ", "Sym", " ", "as", " ", "an", " ", "inert"}],
     "-", "head"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"InertHeadQ", "[", "Sym", "]"}], "^=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DefInfo", "[", "Sym", "]"}], "^=", 
     RowBox[{"{", 
      RowBox[{"\"\<inert head\>\"", ",", "\"\<\>\""}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LinearQ", "[", "Sym", "]"}], "^=", "True"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PrintAs", "[", "Sym", "]"}], "^=", "\"\<Sym\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Linearity", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sym", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"x_", "?", "ConstantQ"}], " ", "y_"}], ",", "other__"}], 
      "]"}], ":=", 
     RowBox[{"x", " ", 
      RowBox[{"Sym", "[", 
       RowBox[{"y", ",", "other"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sym", "[", 
      RowBox[{"expr_Plus", ",", "other__"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"Sym", "[", 
        RowBox[{"#", ",", "other"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sym", "[", 
      RowBox[{"0", ",", "other__"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Shortcuts", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sym", "[", "expr_", "]"}], ":=", 
     RowBox[{"Sym", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"FindFreeIndices", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sym", "[", 
      RowBox[{"expr_", ",", "inds_"}], "]"}], ":=", 
     RowBox[{"Sym", "[", 
      RowBox[{"expr", ",", "inds", ",", 
       RowBox[{"Symmetric", "[", 
        RowBox[{"Range", "@", 
         RowBox[{"Length", "@", "inds"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Sym", "[", 
      RowBox[{"expr_", ",", "inds_", ",", "GS_GenSet"}], "]"}], ":=", 
     RowBox[{"Sym", "[", 
      RowBox[{"expr", ",", "inds", ",", 
       RowBox[{"SchreierSims", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", "GS"}], "]"}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"07713156-95ce-47e3-8b36-d8ff3d807f48"],

Cell["\<\
Note that the second argument must have head IndexList and the third argument \
is converted into a StrongGenSet structure.\
\>", "Text",ExpressionUUID->"a15241dd-d735-4da0-826b-8cc862334e17"],

Cell["\<\
Unfortunately, we are not able yet to provide a direct definition of \
SymmetryOf[Sym[expr_,__]], but we shall introduce a trick to avoid it. TODO: \
I'm not sure this code is correct.\
\>", "Text",ExpressionUUID->"20ed1018-2f37-4ff6-9f22-c0a23f47d744"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Temporary", " ", "functions", " ", "to", " ", "handle", " ", "spinorial", 
    " ", "metrics"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"symsign", "[", "list_List", "]"}], ":=", 
     RowBox[{"Times", "@@", 
      RowBox[{"(", 
       RowBox[{"symsign1", "/@", "list"}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"symsign1", "[", 
      RowBox[{"-", "x_Symbol"}], "]"}], ":=", 
     RowBox[{"SymmetryOfIndex", "[", "x", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"symsign1", "[", "x_Symbol", "]"}], ":=", "1"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Note", " ", "that", " ", "we", " ", "place", " ", "Sdelta", " ", "after",
      " ", "the", " ", 
     RowBox[{"expression", ".", " ", "This"}], " ", "is", " ", "important", 
     " ", "for", " ", "the", " ", "symsign", " ", "convention", " ", 
     "before"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Sym", "/:", 
     RowBox[{"ToCanonical", "[", 
      RowBox[{
       RowBox[{"Sym", "[", 
        RowBox[{"expr_", ",", "inds_", ",", "sym_"}], "]"}], ",", 
       "options___"}], "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"exprinds", "=", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"FindIndices", "[", "expr", "]"}], ",", 
           RowBox[{"Alternatives", "@@", "inds"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"newinds", "=", 
            RowBox[{"DummyAs", "/@", "exprinds"}]}], ",", "Sexpr"}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Sexpr", "=", 
           RowBox[{
            RowBox[{"symsign", "[", "newinds", "]"}], 
            RowBox[{"ReplaceIndex", "[", 
             RowBox[{"expr", ",", 
              RowBox[{"Thread", "[", 
               RowBox[{"exprinds", "\[Rule]", "newinds"}], "]"}]}], "]"}], 
            RowBox[{
             RowBox[{"Sdelta", "[", "sym", "]"}], "[", 
             RowBox[{
              RowBox[{"Sequence", "@@", 
               RowBox[{"(", 
                RowBox[{"ChangeIndex", "/@", "newinds"}], ")"}]}], ",", 
              RowBox[{"Sequence", "@@", "exprinds"}]}], "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Sym", "[", 
           RowBox[{
            RowBox[{"ContractMetric", "[", 
             RowBox[{"RemoveSdelta", "@", 
              RowBox[{"ToCanonical", "[", 
               RowBox[{"Sexpr", ",", "options"}], "]"}]}], "]"}], ",", "inds",
             ",", "sym"}], "]"}]}]}], "]"}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8fcc40d0-caa0-474b-b946-8b95e78d77eb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Sym", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "Sym", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8ff0d27b-9c2d-41fe-b5b8-7eebabf8a154"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["15.A. Reworking the canonicalizer", \
"Subsection",ExpressionUUID->"0b061c5f-b2cf-46fa-bb28-573668efe949"],

Cell["\<\
Suppose we start with a general standard expression, which is a sum of terms \
prod1[v[a], prod2[w[b,-c, ...], ... ], ... ]. To canonicalize this we should \
proceed in these steps:
\t1) Change all derivatives to TensorDerivative form, and mark those new \
TensorDerivative heads. Hence we only have tensor[inds] objects now.
\t2) Expand, so that we have a sum of products.
\t3) Minimize the number of dummies.
\t4) Hide the external Plus, to avoid early canonicalization and \
reevaluations of Plus.
\t5) Strip off the heads of the products, to hide their attributes.
\t2) reorder the expressions to some canonical form compatible with the \
properties of the products and the grades of the tensors
\t3) convert the expression into a sum of terms xTensor[...][a, b, -c, ...]
\t4) compute the slot symmetries of the xTensor[...] objects
\t5) find canonical reordering of indices, without modifying the xTensor[...] \
object
\t6) reorder the indices according to 5) and reconstruct a standard expression.

We see that we need two natural forms for the expressions. We need names. \
What we have used until now could be called the \
\[OpenCurlyDoubleQuote]standard form\[CloseCurlyDoubleQuote], and the new \
could be the \[OpenCurlyDoubleQuote]non-standard \
form\[CloseCurlyDoubleQuote]. That could work for the moment.\
\>", "Text",ExpressionUUID->"ee8bead0-392e-4d86-a6fe-2c35dd161fc0"],

Cell[CellGroupData[{

Cell["15.A.1. Stripped expressions", \
"Subsubsection",ExpressionUUID->"504a2ada-e416-44e4-9758-139d0ee87b71"],

Cell["\<\
This is a function that converts any standard expression into an inert form \
with stripping wrappers.\
\>", "Text",ExpressionUUID->"6c51ff2f-7b69-4bf1-9a50-604c9652fe71"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ToStripped", "[", "expr_", "]"}], ":=", 
   RowBox[{"Strip", "[", 
    RowBox[{"SameDummies", "@", 
     RowBox[{"MathInputExpand", "[", 
      RowBox[{"ToTMPTensorDerivative", "[", "expr", "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ToStripped", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ToStripped", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"8c60fd90-1b6b-4dac-b46c-b4fca8d58756"],

Cell["\<\
We need to distinguish the TensorDerivative objects we introduce from those \
that the user had originally.\
\>", "Text",ExpressionUUID->"40c8aa2c-ac35-427e-8da2-5514d8d2eeb7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ToTMPTensorDerivative", "[", "expr_", "]"}], ":=", 
   RowBox[{"expr", "/.", 
    RowBox[{
     RowBox[{"dexpr", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"_", "?", "CovDQ"}], "[", "__", "]"}], "[", "_", "]"}], "|", 
        RowBox[{
         RowBox[{"LieD", "[", "_", "]"}], "[", "_", "]"}], "|", 
        RowBox[{
         RowBox[{"ParamD", "[", "__", "]"}], "[", "_", "]"}], "|", 
        "OverDot"}], ")"}]}], "\[RuleDelayed]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ToTensorDerivative", "[", "dexpr", "]"}], "/.", 
       RowBox[{"TensorDerivative", "\[Rule]", "TMPTensorDerivative"}]}], 
      ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"TMPTensorDerivative", "[", "exprs__", "]"}], "]"}], "^:=", 
   RowBox[{"xTensorQ", "[", 
    RowBox[{"TensorDerivative", "[", "exprs", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2ad06753-4743-4601-b99f-f61cb8c68279"],

Cell["\<\
Strip returns expressions with these possible structures:
\tStrippedPlus[strippeds]
\tStripped[type, object][inds]
The key point is that now the canonicalizer will only see tensor[inds] \
objects (note we prepare Stripped to accept future additional arguments):\
\>", "Text",ExpressionUUID->"706c1754-1226-446b-978e-b79ec0e52981"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", 
    RowBox[{"Stripped", "[", 
     RowBox[{"type_", ",", "object_", ",", "props___"}], "]"}], "]"}], "^:=", 
   "True"}], 
  ";"}]], "Input",ExpressionUUID->"d3cd50ad-8004-4ffa-a491-488d182e781a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Hide", " ", "Plus"}], ",", " ", 
    RowBox[{
    "to", " ", "avoid", " ", "unexpected", " ", "early", " ", 
     "canonicalization"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", "expr_Plus", "]"}], ":=", 
     RowBox[{"Strip", "/@", 
      RowBox[{"(", 
       RowBox[{"StrippedPlus", "@@", "expr"}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Hide", " ", "Times"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", "expr_Times", "]"}], ":=", 
     RowBox[{"StripProduct", "[", 
      RowBox[{"Times", ",", 
       RowBox[{"Strip", "/@", 
        RowBox[{"List", "@@", "expr"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Tensors", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", 
      RowBox[{
       RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds___", "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"Tensor", ",", "tensor", ",", 
        RowBox[{"Length", "[", 
         RowBox[{"{", "inds", "}"}], "]"}]}], "]"}], "[", "inds", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Scalars", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", 
      RowBox[{"c_", "?", "ConstantQ"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"Constant", ",", "c", ",", "0"}], "]"}], "[", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", 
      RowBox[{"p_Symbol", "?", "ParameterQ"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"Parameter", ",", "p", ",", "0"}], "]"}], "[", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", "expr_Scalar", "]"}], ":=", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"Scalar", ",", 
        RowBox[{"ToCanonicalScalar", "[", "expr", "]"}], ",", "0"}], "]"}], 
      "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", 
      RowBox[{
       RowBox[{"sf_", "?", "ScalarFuncionQ"}], "[", "args__", "]"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"ScalarFunction", ",", 
        RowBox[{"ToCanonicalScalar", "/@", 
         RowBox[{"sf", "[", "args", "]"}]}], ",", "0"}], "]"}], "[", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Inert", " ", "heads"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", 
      RowBox[{
       RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
       RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
     RowBox[{"StripInertHead", "[", 
      RowBox[{"ih", ",", 
       RowBox[{"Strip", "[", "expr", "]"}], ",", "z"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Hide", " ", "other", " ", "products"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", 
      RowBox[{
       RowBox[{"prod_", "?", "ProductQ"}], "[", "factors___", "]"}], "]"}], ":=", 
     RowBox[{"StripProduct", "[", 
      RowBox[{"prod", ",", 
       RowBox[{"Strip", "/@", 
        RowBox[{"{", "factors", "}"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Default", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Strip", "[", "expr_", "]"}], ":=", "expr"}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"7f559efd-95fd-4b1d-9586-e004891cb3d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Convert", " ", "products", " ", "of", " ", "stripped", " ", "tensors", 
    " ", "into", " ", "a", " ", "single", " ", "stripped", " ", "object"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"StripProduct", "[", 
     RowBox[{"prod_", ",", "factors_"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"heads", "=", 
         RowBox[{"Head", "/@", "factors"}]}], ",", 
        RowBox[{"inds", "=", 
         RowBox[{"IndexList", "@@@", "factors"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Union", "[", 
           RowBox[{"Head", "/@", "heads"}], "]"}], "=!=", 
          RowBox[{"{", "Stripped", "}"}]}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{
           RowBox[{"Validate", "::", "error"}], ",", 
           "\"\<Invalid expression found.\>\""}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"joininds", "=", 
           RowBox[{"Join", "@@", "inds"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Stripped", "[", 
           RowBox[{"Product", ",", 
            RowBox[{"{", 
             RowBox[{"prod", ",", "heads"}], "}"}], ",", 
            RowBox[{"Length", "[", "joininds", "]"}]}], "]"}], "@@", 
          "joininds"}]}], "\[IndentingNewLine]", "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"e4f14087-7cae-4f0e-b079-59536a9b881a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Convert", " ", "an", " ", "inert", " ", "head", " ", "expression", " ", 
    "into", " ", "a", " ", 
    RowBox[{"tensor", ".", " ", "We"}], " ", "need", " ", "to", " ", "store", 
    " ", "the", " ", "initial", " ", "indices", " ", "to", " ", "compare", 
    " ", "heights", " ", "at", " ", "the", " ", "end"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"StripInertHead", "[", 
     RowBox[{"ih_", ",", 
      RowBox[{"stripped_Stripped", "[", "inds___", "]"}], ",", "z___"}], 
     "]"}], ":=", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"InertHead", ",", 
       RowBox[{"{", 
        RowBox[{"ih", ",", "stripped", ",", 
         RowBox[{"{", "inds", "}"}], ",", "z"}], "}"}], ",", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "inds", "}"}], "]"}]}], "]"}], "[", "inds", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"9edb5243-80f9-4caa-b179-48b3a2d9b9b6"],

Cell["Inverse conversion:", \
"Text",ExpressionUUID->"09dd623b-23ef-4927-8f1d-0ed0c4e485f6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", "sexpr_StrippedPlus", "]"}], ":=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"(", 
     RowBox[{"FromStripped", "/@", "sexpr"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"Tensor", ",", 
       RowBox[{"TMPTensorDerivative", "[", "exprs__", "]"}], ",", "n_"}], 
      "]"}], "[", "inds___", "]"}], "]"}], ":=", 
   RowBox[{"FromTensorDerivative", "[", 
    RowBox[{
     RowBox[{"TensorDerivative", "[", "exprs", "]"}], "[", "inds", "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"Tensor", ",", "tensor_", ",", "n_"}], "]"}], "[", "inds___", 
     "]"}], "]"}], ":=", 
   RowBox[{"tensor", "[", "inds", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"Constant", ",", "c_", ",", "0"}], "]"}], "[", "]"}], "]"}], ":=",
    "c"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"Parameter", ",", "p_", ",", "0"}], "]"}], "[", "]"}], "]"}], ":=",
    "p"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"Scalar", ",", "scalar_", ",", "0"}], "]"}], "[", "]"}], "]"}], 
   ":=", "scalar"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", 
    RowBox[{
     RowBox[{"Stripped", "[", 
      RowBox[{"ScalarFunction", ",", "scalar_", ",", "0"}], "]"}], "[", "]"}],
     "]"}], ":=", "scalar"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FromStripped", "[", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"Product", ",", 
        RowBox[{"{", 
         RowBox[{"prod_", ",", "strippeds_List"}], "}"}], ",", "n_"}], "]"}], 
      "[", "inds___", "]"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"prod", "@@", 
     RowBox[{"(", 
      RowBox[{"FromStripped", "/@", 
       RowBox[{"Apply", "@@@", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"strippeds", ",", 
           RowBox[{"Internal`PartitionRagged", "[", 
            RowBox[{
             RowBox[{"{", "inds", "}"}], ",", 
             RowBox[{"strippeds", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "3"}], "]"}], "]"}]}], "]"}]}], "}"}], 
         "]"}]}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Inert", " ", "heads", " ", "may", " ", "be", " ", "problematic", " ", 
    "if", " ", "deltas", " ", "or", " ", "metrics", " ", "cannot", " ", "be", 
    " ", "contracted", " ", "through", " ", "them"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FromStripped", "[", 
     RowBox[{
      RowBox[{"Stripped", "[", 
       RowBox[{"InertHead", ",", 
        RowBox[{"{", 
         RowBox[{"ih_", ",", "stripped_", ",", "initinds_List", ",", "z___"}],
          "}"}], ",", "n_"}], "]"}], "[", "inds___", "]"}], "]"}], ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"needed", "=", 
        RowBox[{"NeededChanges", "[", 
         RowBox[{
          RowBox[{"{", "inds", "}"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"DummyAs", "[", 
             RowBox[{"#", ",", "Automatic"}], "]"}], "&"}], "/@", 
           "initinds"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"And", "@@", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"ContractThroughQ", "[", 
             RowBox[{"ih", ",", "#"}], "]"}], "&"}], "/@", 
           RowBox[{"(", 
            RowBox[{"Head", "/@", "needed"}], ")"}]}], ")"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ih", "[", 
         RowBox[{
          RowBox[{"FromStripped", "[", 
           RowBox[{"stripped", "[", "inds", "]"}], "]"}], ",", "z"}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"ContractMetric", "[", 
         RowBox[{"xAct`xCoba`ContractBasis", "[", 
          RowBox[{
           RowBox[{"ih", "[", 
            RowBox[{
             RowBox[{"FromStripped", "[", 
              RowBox[{"stripped", "@@", "initinds"}], "]"}], ",", "z"}], 
            "]"}], 
           RowBox[{"Times", "@@", "needed"}]}], "]"}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Default", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FromStripped", "[", "expr_", "]"}], ":=", "expr"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"FromStripped", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "FromStripped", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bea09dd2-870a-4053-a1a3-e0fbd0009f51"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"We", " ", "are", " ", "assuming", " ", 
     RowBox[{"(", 
      RowBox[{"do", " ", "not", " ", "check"}], ")"}], " ", "that", " ", 
     "both", " ", "indices", " ", "belong", " ", "to", " ", "the", " ", 
     "same", " ", 
     RowBox[{"space", ".", " ", "Put"}], " ", "dummies", " ", "in", " ", 
     "the", " ", "second", " ", "index", " ", "of", " ", "deltas", " ", "and",
      " ", "metrics"}], ",", " ", 
    RowBox[{
    "so", " ", "that", " ", "their", " ", "contraction", " ", "is", " ", 
     "tried", " ", "first"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NeededChanges", "[", 
      RowBox[{"inds_List", ",", "dummies_List"}], "]"}], ":=", 
     RowBox[{"MapThread", "[", 
      RowBox[{"NeededChange", ",", 
       RowBox[{"{", 
        RowBox[{"inds", ",", "dummies"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NeededChange", "[", 
      RowBox[{"ind1_", ",", "ind2_"}], "]"}], ":=", 
     RowBox[{"Switch", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"UpIndexQ", "[", "ind1", "]"}], ",", 
         RowBox[{"UpIndexQ", "[", "ind2", "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True"}], "}"}], ",", 
       RowBox[{"delta", "[", 
        RowBox[{"ind1", ",", 
         RowBox[{"DownIndex", "@", "ind2"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"False", ",", "False"}], "}"}], ",", 
       RowBox[{"delta", "[", 
        RowBox[{"ind1", ",", 
         RowBox[{"UpIndex", "@", "ind2"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}], ",", 
       RowBox[{
        RowBox[{"FirstMetricOfVBundle", "[", 
         RowBox[{
          RowBox[{"VBundleOfIndex", "[", "ind2", "]"}], ",", "True"}], "]"}], 
        "[", 
        RowBox[{"ind1", ",", 
         RowBox[{"UpIndex", "@", "ind2"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"False", ",", "True"}], "}"}], ",", 
       RowBox[{
        RowBox[{"Inv", "[", 
         RowBox[{"FirstMetricOfVBundle", "[", 
          RowBox[{
           RowBox[{"VBundleOfIndex", "[", "ind2", "]"}], ",", "True"}], "]"}],
          "]"}], "[", 
        RowBox[{"ind1", ",", 
         RowBox[{"DownIndex", "@", "ind2"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "_", ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"FromStripped", "::", "error1"}], ",", 
          "\"\<Found invalid indices:\>\"", ",", 
          RowBox[{"{", 
           RowBox[{"ind1", ",", "ind2"}], "}"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d8c62a0e-42ef-48cc-ae8e-6c029f4d6a35"]
}, Open  ]],

Cell[CellGroupData[{

Cell["15.A.2. Sort stripped expressions", \
"Subsubsection",ExpressionUUID->"c2e74529-240a-4424-bc00-b90513ad7d52"],

Cell["\<\
The idea here is that when we find a product that has some special symmetry \
then we can sort the tensors to some canonical order. This must be done \
before (and independently) of the canonicalization of the order of indices.\
\>", "Text",ExpressionUUID->"50fa48c2-0587-40a1-a7c9-28a1ab6c9b3d"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["16. Computations",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"785b8e77-fa24-4267-811d-b483bc9d7f71"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], "*", 
   
   RowBox[{"**", "**"}], "*", " ", "16.", "Computations"}], " ", 
  "**************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a239e8cf-3611-4119-a8d7-14066248a3fd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"9a77b167-0999-4a4c-9223-9a8dc2302ab3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "81.731524`", ",", "716.603363`9.306823835462986", ",", 
   "0.11405410089137634`"}], 
  "}"}]], "Output",ExpressionUUID->"62c13f85-0c00-4b27-990e-365cd6d6fb9f"]
}, Open  ]],

Cell[CellGroupData[{

Cell["16.0. Comments", \
"Subsection",ExpressionUUID->"6f097eaa-d81e-4afc-a12a-5cd331b56d83"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{"Print", "[", "\"\<Reading section 16: Computations.\>\"", "]"}], 
   ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"d0df19df-b651-4b76-8de4-3fd1958deb76"],

Cell["\<\
There is nothing concerning index notations in this section. Some functions \
only work for abstract indices.\
\>", "Text",ExpressionUUID->"23f6d17d-5b58-4c57-99c6-1d81bbcf4aa6"]
}, Closed]],

Cell[CellGroupData[{

Cell["16.1. Validation", \
"Subsection",ExpressionUUID->"128b54bf-75c4-4504-b3e7-b450a6618b45"],

Cell[CellGroupData[{

Cell["16.1.1. Definitions", \
"Subsubsection",ExpressionUUID->"f9149038-c4c7-4965-83f7-faa655f489d8"],

Cell["\<\
This function validates an expression. Note that we assume that \
ValidateTensor, ValidateCovD, ValidateLieD and ValidateBracket implement some \
kind of recursion (internal calls to UncatchedValidate). The expression is \
assumed to be already evaluated; Validate has attribute HoldFirst.  QUESTION: \
Is really this what we want?\
\>", "Text",ExpressionUUID->"1dfaf425-04d4-40e1-908d-11744045a06b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Validate"}]], \
"Input",ExpressionUUID->"742d47c3-8909-489e-aa58-cac702129ab6"],

Cell[BoxData[
 StyleBox["\<\"Validate[expr] checks that the tensorial expression expr 1) \
does not have unknown heads, 2) does not have objects with invalid index \
structure, 3) does have homogeneous free indices and 4) does not have \
repeated indices. There is a wrapping Catch.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578672986-5338953",ExpressionUUID->"5e52aa51-9325-493a-b0c4-\
df39d358b58c"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Validate", ",", "HoldFirst"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Validate", "[", "expr_", "]"}], ":=", 
   RowBox[{"Catch", "[", 
    RowBox[{"UncatchedValidate", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"Validate", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Validate", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"02ccd585-a738-45a2-9579-23997a007c35"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"UncatchedValidate", ",", "HoldFirst"}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Out", " ", "expressions"}], " ", "*)"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", "x_Out", "]"}], ":=", 
    RowBox[{"UncatchedValidate", "[", 
     RowBox[{"Evaluate", "[", "x", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Held", " ", "expressions"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
       "Hold", "|", "HoldForm", "|", "HoldComplete", "|", "HoldPattern", "|", 
        "xHold"}], ")"}], "[", "expr_", "]"}], "]"}], ":=", 
    RowBox[{"UncatchedValidate", "[", "expr", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Times", " ", "and", " ", "Plus", " ", 
    RowBox[{"expressions", ".", " ", "Check"}], " ", "indices"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", 
     RowBox[{"expr", ":", 
      RowBox[{"(", 
       RowBox[{"_Times", "|", "_Plus", "|", 
        RowBox[{
         RowBox[{"_", "?", "ProductQ"}], "[", "___", "]"}]}], ")"}]}], "]"}], 
    ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"FindIndices", "[", "expr", "]"}], ";", 
      RowBox[{"UncatchedValidate", "/@", 
       RowBox[{"Unevaluated", "[", "expr", "]"}]}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"xTensor", " ", 
    RowBox[{"expressions", ".", " ", "Convert"}], " ", "to", " ", 
    "ValidateType"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"t", ":", 
     RowBox[{
      RowBox[{"_", "?", "xTensorQ"}], "[", "___", "]"}]}], "]"}], ":=", 
   RowBox[{"ValidateTensor", "[", "t", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"covd", ":", 
     RowBox[{
      RowBox[{
       RowBox[{"_", "?", "CovDQ"}], "[", "_", "]"}], "[", "_", "]"}]}], "]"}],
    ":=", 
   RowBox[{"ValidateCovD", "[", "covd", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"lied", ":", 
     RowBox[{
      RowBox[{"LieD", "[", "_", "]"}], "[", "_", "]"}]}], "]"}], ":=", 
   RowBox[{"ValidateLieD", "[", "lied", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", 
     RowBox[{"br", ":", 
      RowBox[{
       RowBox[{"Bracket", "[", 
        RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], "]"}], ":=", 
    RowBox[{"ValidateBracket", "[", "br", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"xTensor", " ", 
    RowBox[{"expressions", ".", " ", "Recursion"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{
     RowBox[{"ParamD", "[", 
      RowBox[{"ps__", "?", "ParameterQ"}], "]"}], "[", "expr_", "]"}], "]"}], 
   ":=", 
   RowBox[{
    RowBox[{"ParamD", "[", "ps", "]"}], "[", 
    RowBox[{"UncatchedValidate", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"OverDot", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"OverDot", "[", 
    RowBox[{"UncatchedValidate", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{
     RowBox[{"ih_", "?", "InertHeadQ"}], "[", 
     RowBox[{"expr_", ",", "z___"}], "]"}], "]"}], ":=", 
   RowBox[{"ih", "[", 
    RowBox[{
     RowBox[{"UncatchedValidate", "[", "expr", "]"}], ",", "z"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"Scalar", "[", "expr_", "]"}], "]"}], ":=", 
   RowBox[{"Scalar", "[", 
    RowBox[{"UncatchedValidate", "[", "expr", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{
     RowBox[{"sf_", "?", "ScalarFunctionQ"}], "[", 
     RowBox[{"sc_", ",", "x___"}], "]"}], "]"}], ":=", 
   RowBox[{"sf", "[", 
    RowBox[{
     RowBox[{"UncatchedValidate", "[", "sc", "]"}], ",", "x"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Derivative", "[", "ders__Integer", "]"}], "[", "f_", "]"}], 
     "[", "args__", "]"}], "]"}], ":=", 
   RowBox[{"MapAt", "[", 
    RowBox[{
     RowBox[{"Derivative", "[", "ders", "]"}], ",", 
     RowBox[{"UncatchedValidate", "[", 
      RowBox[{"f", "[", "args", "]"}], "]"}], ",", "0"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", 
     RowBox[{"c_Symbol", "?", "ConstantSymbolQ"}], "]"}], ":=", "c"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Atoms", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"number", ":", 
     RowBox[{"(", 
      RowBox[{"_Integer", "|", "_Rational", "|", "_Real", "|", "_Complex"}], 
      ")"}]}], "]"}], ":=", "number"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", "string_String", "]"}], ":=", "string"}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", "x_Symbol", "]"}], ":=", "x"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Mathematica", " ", "constructions"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"expr", ":", 
     RowBox[{"(", 
      RowBox[{"_Slot", "|", "_Blank", "|", "_Pattern"}], ")"}]}], "]"}], ":=",
    "expr"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UncatchedValidate", "[", 
     RowBox[{"Function", "[", "expr_", "]"}], "]"}], ":=", 
    RowBox[{"Function", "[", 
     RowBox[{"UncatchedValidate", "[", "expr", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Other", " ", 
    RowBox[{"cases", ".", " ", "Note"}], " ", "that", " ", "if", " ", "h", 
    " ", "IS", " ", "known", " ", "the", " ", "els", " ", "ARE", " ", "NOT", 
    " ", "validated"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UncatchedValidate", "[", 
    RowBox[{"x", ":", 
     RowBox[{"h_", "[", "els___", "]"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{"$SystemNames", ",", "$xActNames"}], "]"}], ",", 
       RowBox[{"ToString", "[", "h", "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Throw", "[", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Validate", "::", "unknown"}], ",", "\"\<head\>\"", ",", 
        "h"}], "]"}], "]"}], ",", "x"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"UncatchedValidate", ",", "1"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "UncatchedValidate", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"5e161161-19ee-4d9c-92f1-62a856f3787b"],

Cell["\<\
Recall that a useful way of tracing problems is turning On[General::warning].\
\
\>", "Text",ExpressionUUID->"21862bfa-c5d1-45b5-b6b1-b4e34bb54efb"]
}, Closed]],

Cell[CellGroupData[{

Cell["16.1.2. Examples", \
"Subsubsection",ExpressionUUID->"5917bfd1-2a74-4a23-85ef-b8b2790faa81"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"9cd6ca70-3ef0-4f25-b64a-75f5230c3374"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"793b0ded-c8b4-4efc-a819-9fa19ddc1b37"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"R", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`R[$CellContext`A, $CellContext`B, C, D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"12c3dce7-d45f-4401-abf8-19de29b12fde"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"141faa8b-201c-4efd-828f-38e5ee42648a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c0216eec-04e5-4279-8a2a-4f980f9be287"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"87619920-354c-4cca-a565-7ea95605e4c6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4ae11c98-0d8e-463f-a4d6-443fe5135bde"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"1e33f2ec-df59-4f45-ad7d-5a349a8ea100"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"41aa534b-a783-4453-b3ed-baa64d850536"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Validate", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], 
   RowBox[{"v", "[", "A", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"75b95477-9626-4c5b-ab1c-934787041861"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid character of index in tensor v\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"55a945c7-3426-4ad6-8bfe-d9b6b87a7777"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[
    RowBox[{
     StyleBox["ERROR",
      FontColor->Hue[0.]], "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[-$CellContext`A],
      Editable->False], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`ERROR[
    $CellContext`v[-$CellContext`A]],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"5cf96c0b-7fec-487d-8b50-53f0b7ee12ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Validate", "[", 
  RowBox[{"v", "[", 
   RowBox[{"-", "A"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"a23b27de-28f6-442d-8e9c-b4935ec4b191"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid character of index in tensor v\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9be32a90-6c22-44c2-b115-3dc7a637806c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    StyleBox["ERROR",
     FontColor->Hue[0.]], "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[-$CellContext`A],
     Editable->False], "]"}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`ERROR[
   $CellContext`v[-$CellContext`A]],
  Editable->
   False]], "Output",ExpressionUUID->"04a0e836-6731-45bc-a4d2-375e2e6c4b92"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Validate", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "B"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e0198d3a-7bb3-4ecd-8fdd-3e2da8d98ae2"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"B\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"5a574a61-6474-4e48-b946-d2e0335ba6b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Validate", "[", 
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"a905d1bf-1f1e-469a-97b4-24127f97fbc6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, -$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"69e1ec42-33b6-484b-8fd8-52559929ed0e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Pre", "=", "Validate"}], 
  ";"}]], "Input",ExpressionUUID->"e99e4cb5-4092-4532-a291-01fd425a0e83"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"R", "[", 
   RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], 
   "]"}]}]], "Input",ExpressionUUID->"b7d9b4fe-3ad4-47ca-9bd6-d1374ac18aa8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"B\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4a237ac8-18b3-4722-b9b7-f582f16afb9b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"R", "[", 
   RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", 
    RowBox[{"-", "B"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"4d7fc2cf-abac-47d9-9462-a42f8250cfd7"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, -$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"138cc9ce-6756-431e-a16e-365f11c04190"]
}, Open  ]],

Cell["\<\
There is something strange here, due to the fact that we have changed the \
generic definition for Validate:\
\>", "Text",ExpressionUUID->"6de0c2e2-1f18-4522-b629-2fbc3ea62b3a"],

Cell[BoxData[
 RowBox[{"Validate", "[", "Null", 
  "]"}]], "Input",ExpressionUUID->"c94520af-1dbc-4c6b-b7a0-1403efa081a8"],

Cell[BoxData[
 RowBox[{"$Pre", 
  "=."}]], "Input",ExpressionUUID->"b2b25d30-b80a-4b12-bf6e-80634d69107e"],

Cell[BoxData[
 RowBox[{"Validate", "[", "Null", 
  "]"}]], "Input",ExpressionUUID->"52339d4c-6154-4f3e-a408-8475f451b741"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"R", "[", 
   RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
  RowBox[{"T", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "B"}], 
   "]"}]}]], "Input",ExpressionUUID->"164bb84f-7796-4352-9a17-24492942d898"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"R", 
       StyleBox[GridBox[{
          {"A", "B", "C", "D"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`R[$CellContext`A, $CellContext`B, C, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "B"},
          {"A", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, $CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"a79ce488-5113-45f3-bc60-4f778484eb5a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Validate", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"04793e7f-9604-4de5-9333-690a5f245a92"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "repeated"}], "MessageName"], ":", 
  " ", "\<\"Found indices with the same name \[NoBreak]\\!\\(\\\"B\\\"\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"343de1df-ba13-4cfc-8382-98e13e6312b1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"92c1c7be-d8a8-473e-9dc0-e6fcfa6c77b6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"R", ",", "S", ",", "T", ",", "v"}], 
  "}"}]], "Output",ExpressionUUID->"aecd0c26-9cf7-45c9-b3f1-469dec3910ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TracePrint", "[", 
  RowBox[{
   RowBox[{"Validate", "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"A", ",", "B"}], "]"}], 
      RowBox[{"T", "[", 
       RowBox[{
        RowBox[{"-", "A"}], ",", 
        RowBox[{"-", "B"}]}], "]"}]}], "]"}], "]"}], ",", 
   RowBox[{"xATP`UncatchedValidate", "[", "_", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"43ccbafe-3c1a-4495-be04-6f8abda5c03b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"  ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[PartialD]", "C"], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[-$CellContext`A, -$CellContext`B],
          Editable->False]}], "]"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-
       C][$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]],
      Editable->False], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[2], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     xAct`xTensor`PD[-
      C][$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"b13a423d-1e28-461a-b344-2d1cfac45611"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"    ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{"Unevaluated", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[$CellContext`A, $CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`A, -$CellContext`B],
        Editable->False]}], "]"}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[4], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     Unevaluated[$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"07bb903a-4619-45f8-bc35-f3e6f32e876f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"    ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[$CellContext`A, $CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A, -$CellContext`B],
       Editable->False]}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[4], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[$CellContext`S[$CellContext`A, \
$CellContext`B] $CellContext`T[-$CellContext`A, -$CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"f5cee850-4bcc-4116-ac9c-d4bdf861ae94"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"      ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[$CellContext`A, $CellContext`B],
      Editable->False], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[6], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     $CellContext`S[$CellContext`A, $CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"af7db103-091b-41d9-a145-636760ff1b38"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"      ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A, -$CellContext`B],
      Editable->False], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[6], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     $CellContext`T[-$CellContext`A, -$CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"b0a727ca-3695-44e4-95d3-0c89ef3e6aea"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B", "  "},
           {" ", " ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`S[$CellContext`A, $CellContext`B]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[$CellContext`A, $CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "B", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"baf8e26e-df2c-4b80-a317-80a7937aca71"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TracePrint", "[", 
  RowBox[{
   RowBox[{"Validate", "[", 
    RowBox[{"Hold", "[", 
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "C"}], "]"}], "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"A", ",", "B"}], "]"}], 
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "A"}], ",", 
         RowBox[{"-", "B"}]}], "]"}]}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"xATP`UncatchedValidate", "[", "_", "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"dc036b84-7a67-4a59-a6c3-426dff964700"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"  ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{"Hold", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[PartialD]", "C"], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[$CellContext`A, $CellContext`B],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"T", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"A", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T[-$CellContext`A, -$CellContext`B],
           Editable->False]}], "]"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`PD[-
        C][$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]],
       Editable->False], "]"}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[2], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     Hold[
      xAct`xTensor`PD[-
       C][$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"0643b3c8-bb38-4cd6-8218-f231de056853"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"  ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[PartialD]", "C"], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"T", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T[-$CellContext`A, -$CellContext`B],
          Editable->False]}], "]"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-
       C][$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]],
      Editable->False], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[2], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     xAct`xTensor`PD[-
      C][$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"97aadc16-0513-4104-98d0-9f88b8440bbf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"    ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{"Unevaluated", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {"A", "B"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[$CellContext`A, $CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {" ", " "},
               {"A", "B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[-$CellContext`A, -$CellContext`B],
        Editable->False]}], "]"}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[4], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     Unevaluated[$CellContext`S[$CellContext`A, $CellContext`B] \
$CellContext`T[-$CellContext`A, -$CellContext`B]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"f2c39b23-6d4e-47ac-a7fe-58c38496435f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"    ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[$CellContext`A, $CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`A, -$CellContext`B],
       Editable->False]}], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[4], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[$CellContext`S[$CellContext`A, \
$CellContext`B] $CellContext`T[-$CellContext`A, -$CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"d6a108a0-d450-4d26-954e-3a42401d5103"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"      ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[$CellContext`A, $CellContext`B],
      Editable->False], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[6], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     $CellContext`S[$CellContext`A, $CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"c6d5b85d-9212-44b6-8dd3-33f6bf6516fd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"      ", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"xAct`xTensor`Private`UncatchedValidate", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A, -$CellContext`B],
      Editable->False], "]"}],
    HoldForm]}],
  SequenceForm[
   Indent[6], 
   HoldForm[
    xAct`xTensor`Private`UncatchedValidate[
     $CellContext`T[-$CellContext`A, -$CellContext`B]]]],
  Editable->
   False]], "Print",ExpressionUUID->"58bb34e9-541c-44c9-ace7-b77f51fbe466"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B", "  "},
           {" ", " ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`S[$CellContext`A, $CellContext`B]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[$CellContext`A, $CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"A", "B", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`T[-$CellContext`A, -$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"529af21d-a987-483d-a189-0076778dbce7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"28f1ae99-9464-4125-8c15-f7c96bfbe3cc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"R", ",", "S", ",", "T", ",", "v"}], 
  "}"}]], "Output",ExpressionUUID->"419d036d-3b5d-4611-9257-86078dc17dd8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"R", ",", "S", ",", "T", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"7700ddac-3134-42d6-b921-4d6d49857cb9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "R"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`R],
  Editable->
   False]], "Print",ExpressionUUID->"cd56a157-6bc7-4c43-b7b4-9a2b83a188de"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"d9cc0586-441f-41c0-8536-81e3b3402f2c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"e6a29988-1109-4565-b846-98cf8919c419"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"0abc9b2e-256c-4edb-ab0e-69c5e549aa85"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f5bcdad4-a69c-4757-9d50-c071699eedf1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.2. Equations", \
"Subsection",ExpressionUUID->"d94c4af7-a139-430a-87aa-1d80fd3a0087"],

Cell[CellGroupData[{

Cell["16.2.1. Equality and unequality", \
"Subsubsection",ExpressionUUID->"c85dad3f-9700-428b-beb1-894ec1a072cd"],

Cell["\<\
Firstly, we must define the concept of equality of indexed expressions. Two \
indexed expressions are equal if they have the same canonical form. They are \
different if they have different free indices. In other cases, the expression \
is left unchanged.\
\>", "Text",ExpressionUUID->"40dd3c43-f74c-40f4-bd84-307b9aecb959"],

Cell["\<\
Note that we use sx, sy temporarily to store the possible dummy indices, \
dropping the free indices:\
\>", "Text",ExpressionUUID->"2c669ce6-f914-4adb-b975-a8e1c557c4ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"action", ":", 
       RowBox[{"Equal", "|", "Unequal"}]}], ")"}], "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], ",", "options___"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fx", "=", 
       RowBox[{"List", "@@", 
        RowBox[{"FindFreeIndices", "[", "x", "]"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"fy", "=", 
       RowBox[{"List", "@@", 
        RowBox[{"FindFreeIndices", "[", "y", "]"}]}]}], ",", 
      "\[IndentingNewLine]", "sx", ",", "sy"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"sx", "=", 
      RowBox[{"Complement", "[", 
       RowBox[{"$AbstractIndices", ",", 
        RowBox[{"UpIndex", "/@", "fx"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sy", "=", 
      RowBox[{"Complement", "[", 
       RowBox[{"$AbstractIndices", ",", 
        RowBox[{"UpIndex", "/@", "fy"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sx", "=", 
      RowBox[{"ReplaceDummies", "[", 
       RowBox[{
        RowBox[{"Simplification", "@", "x"}], ",", 
        RowBox[{"IndexList", "@@", "sx"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sy", "=", 
      RowBox[{"ReplaceDummies", "[", 
       RowBox[{
        RowBox[{"Simplification", "@", "y"}], ",", 
        RowBox[{"IndexList", "@@", "sy"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "@", "fx"}], "=!=", 
         RowBox[{"Sort", "@", "fy"}]}], " ", "&&", " ", 
        RowBox[{"sx", "=!=", "0"}], "&&", 
        RowBox[{"sy", "=!=", "0"}]}], ",", 
       RowBox[{"action", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Equal", "\[Rule]", "False"}], ",", 
          RowBox[{"Unequal", "\[Rule]", "True"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", "True", ",", 
       RowBox[{"action", "[", 
        RowBox[{"sx", ",", "sy"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"10471675-1220-418d-9cf4-6a5d755d9529"],

Cell["Now we can protect Simplification:", \
"Text",ExpressionUUID->"5a1615ec-db09-4883-a8e2-8c03e3a5869f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "Simplification", "]"}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a42d2787-fdc2-4d11-8a7e-8d9a6dba317e"],

Cell["Examples:", \
"Text",ExpressionUUID->"9228e942-fb41-411f-ad2f-f981ff10ac01"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"99b9cc6a-a73b-458c-a75c-82a237f802b0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"d9c117bd-5ba7-42f2-9423-ea685bd09d1c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c8cb41a4-b19b-4dce-8a6b-a0b73480ca0b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"03925a29-02d1-4e02-942c-66b32e280c00"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f9ff89e2-8ce8-403c-ba2f-805397354bb2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "B"}], "]"}]}], "==", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "C"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "C"}], 
    "]"}]}]}]], \
"Input",ExpressionUUID->"2b391380-ba0b-4630-a810-c023eebec7c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`B],
    Editable->False]}], "\[Equal]", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-C],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"c44dcfc9-58fe-4a0b-8581-c754ffdd0160"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplification", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"0b4cd191-0168-44d8-a577-5dd296c6541b"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"0ef2abf6-2cbb-4e91-bbb0-f3d550760f51"]
}, Open  ]],

Cell["Should we issue an error or just give False here?", \
"Text",ExpressionUUID->"99b3a68b-41d6-4d1c-8122-c17cf997f447"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplification", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "B"}], "]"}]}], "==", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"bb88251f-949f-4a8c-aeba-f64b59b8b877"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"c2857732-142a-4cc5-8de2-1efe39f7d918"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplification", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "B"}], "]"}]}], "]"}], "==", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "C"}], "]"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "F"}], "]"}], 
     RowBox[{
      RowBox[{"PD", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"v", "[", 
       RowBox[{"-", "F"}], "]"}], "]"}]}]}]}], 
  "]"}]], "Input",ExpressionUUID->"f9e33ea3-ac48-4295-ac71-140644139603"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"5ae7dba9-8e49-48ec-b1ae-b7ddeb353cf8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"0efdfdd2-b933-42ee-98d1-307e94a4931a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"acd7ef6f-705e-4063-8395-a8d1e8d2ddf7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"09dd673f-55ee-45d4-b969-a9f154963784"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"00a01cf8-cb8e-4712-b7c7-6b471e34fec1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$309128\"\>", ",", "\<\"G$309133\"\>", 
     ",", "\<\"G$309139\"\>", ",", "\<\"G$309144\"\>", 
     ",", "\<\"G$309159\"\>", ",", "\<\"G$309172\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$309128", "G$309133", "G$309139", "G$309144", "G$309159", "G$309172"}],
  Editable->
   False]], "Print",ExpressionUUID->"00167572-46e7-4467-8c55-eb286006ed19"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.2.2. Solving indexed equations", \
"Subsubsection",ExpressionUUID->"fa767faf-bbea-4a8b-8b85-0b58ded9207d"],

Cell["\<\
The concept of a tensor equation is not simple. Here we will only solve for \
linear equations of the form
\tscalar  tensor1[inds] == tensor2[inds]
In general it is not possible to solve an equation with a product of objects. \
For example it is not possible to solve    v[A] w[B] = T[A,B]    for v. In \
the future we will include more general types of equations. IndexSolve is not \
prepared to handle indices other than abstract indices.\
\>", "Text",ExpressionUUID->"2c25fbf0-b62c-4e95-984b-e1a69fffda7b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexSolve", "::", "free"}], "=", 
   "\"\<Cannot solve for tensor with unknown free indices: `1`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IndexSolve", "[", 
   RowBox[{"False", ",", "object_", ",", "options___"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IndexSolve", "[", 
   RowBox[{"True", ",", "object_", ",", "options___"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IndexSolve", "[", 
   RowBox[{
    RowBox[{"lhs_", "\[Equal]", "rhs_"}], ",", "object_", ",", "options___"}],
    "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"seq", "=", 
       RowBox[{"Simplification", "[", 
        RowBox[{"Expand", "[", 
         RowBox[{"lhs", "-", "rhs"}], "]"}], "]"}]}], ",", "frees", ",", 
      "inds", ",", "scalar", ",", "righths", ",", 
      RowBox[{"verb", "=", 
       RowBox[{"OptionValue", "[", 
        RowBox[{"MakeRule", ",", 
         RowBox[{"{", "options", "}"}], ",", "Verbose"}], "]"}]}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"frees", "=", 
      RowBox[{"FindFreeIndices", "[", 
       RowBox[{"Evaluate", "[", "seq", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"inds", "=", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"FindIndices", "[", "object", "]"}], ",", "ABIndexQ"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"verb", ",", 
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<frees: \>\"", ",", "frees", ",", "\"\<, inds: \>\"", ",", 
         "inds"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sort", "@", "frees"}], "=!=", 
        RowBox[{"Sort", "@", "inds"}]}], ",", 
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"IndexSolve", "::", "free"}], ",", "inds"}], "]"}], "]"}]}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"scalar", "=", 
      RowBox[{"ToCanonical", "@", 
       RowBox[{"Scalar", "@", 
        RowBox[{"Coefficient", "[", 
         RowBox[{"seq", ",", 
          RowBox[{"ToCanonical", "@", "object"}]}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"verb", ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<scalar: \>\"", ",", "scalar"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"ScalarQ", "[", "scalar", "]"}]}], ",", 
       RowBox[{"Throw", "[", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"IndexSolve", "::", "error"}], ",", "\"\<\>\""}], "]"}], 
        "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"righths", "=", 
      RowBox[{"Simplification", "[", 
       RowBox[{"NoScalar", "[", 
        RowBox[{"seq", "-", 
         RowBox[{"scalar", " ", "object"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"verb", ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<righths: \>\"", ",", "righths"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MakeRule", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Evaluate", "[", "object", "]"}], ",", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{"-", "righths"}], "/", "scalar"}], "]"}]}], "}"}], ",", 
        RowBox[{"PatternIndices", "\[Rule]", 
         RowBox[{"List", "@@", "frees"}]}], ",", "options"}], "]"}], "//", 
      "Flatten"}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndexSolve", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexSolve", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"c2c53853-0fc9-4a6c-bebb-3285e79bc266"],

Cell["Example:", \
"Text",ExpressionUUID->"304859a1-0f2f-4ba8-909a-170d98e43c11"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"d216c1a8-1216-4bf0-84ce-ef44a9e8c2cc"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "A", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"9ef8941e-c3af-4a0f-ae2d-0eabb082bfcc"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"426b7f5c-bad2-43d1-b73b-059b31fbc163"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b720b92b-31fa-4187-a4f8-307e4295e1e2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"45ee989e-bf93-4af7-8b67-2a8991fc9465"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"156ca21d-a913-4abd-ad32-d56feeccfd3e"]
}, Open  ]]
}, Open  ]],

Cell["\<\
This expression has free indices {A,F} and is not homogeneous in T. Note that \
dummy indices are all internally replaced to avoid confusion:\
\>", "Text",ExpressionUUID->"51ac1f92-45c2-43ff-ba12-6e3a7a863cfb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "=", 
  RowBox[{"IndexSolve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "F"}], "]"}], 
      RowBox[{"v", "[", "B", "]"}], 
      RowBox[{"w", "[", 
       RowBox[{"-", "B"}], "]"}], 
      RowBox[{"r", "[", "]"}]}], "==", 
     RowBox[{
      RowBox[{"3", 
       RowBox[{"T", "[", 
        RowBox[{"A", ",", "F"}], "]"}], 
       RowBox[{"v", "[", "B", "]"}], 
       RowBox[{"w", "[", 
        RowBox[{"-", "B"}], "]"}], 
       RowBox[{
        RowBox[{"r", "[", "]"}], "^", "3"}]}], "+", 
      RowBox[{
       RowBox[{"v", "[", "A", "]"}], 
       RowBox[{"v", "[", "F", "]"}], 
       RowBox[{"v", "[", "B", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "B"}], "]"}]}]}]}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F"}], "]"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"0a582dd3-3c98-4bf9-98a6-91a0fe835510"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {
             UnderscriptBox[
              UnderscriptBox["A", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["F", "_"], "_"]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[
      PatternTest[
       Pattern[$CellContext`A, 
        Blank[Symbol]], TangentM2`Q], 
      PatternTest[
       Pattern[$CellContext`F, 
        Blank[Symbol]], TangentM2`Q]],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "G$309226", "}"}], ",", 
     FractionBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"G$309226"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-$CellContext`G$309226],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"G$309226"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`G$309226],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"F"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`F],
        Editable->False]}], 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            StyleBox["(",
             FontColor->RGBColor[1, 0, 0]], 
            RowBox[{
             InterpretationBox[
              StyleBox[GridBox[{
                 {"v", 
                  StyleBox[GridBox[{
                    {"G$309231"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`v[$CellContext`G$309231],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"w", 
                  StyleBox[GridBox[{
                    {" "},
                    {"G$309231"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`w[-$CellContext`G$309231],
              Editable->False]}], 
            StyleBox[")",
             FontColor->RGBColor[1, 0, 0]]}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          
          xAct`xTensor`Scalar[$CellContext`v[$CellContext`G$309231] \
$CellContext`w[-$CellContext`G$309231]],
          Editable->False], "-", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], " ", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             StyleBox["(",
              FontColor->RGBColor[1, 0, 0]], 
             RowBox[{
              InterpretationBox[
               StyleBox[GridBox[{
                  {"v", 
                   StyleBox[GridBox[{
                    {"G$309233"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v[$CellContext`G$309233],
               Editable->False], " ", 
              InterpretationBox[
               StyleBox[GridBox[{
                  {"w", 
                   StyleBox[GridBox[{
                    {" "},
                    {"G$309233"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`w[-$CellContext`G$309233],
               Editable->False]}], 
             StyleBox[")",
              FontColor->RGBColor[1, 0, 0]]}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           
           xAct`xTensor`Scalar[$CellContext`v[$CellContext`G$309233] \
$CellContext`w[-$CellContext`G$309233]],
           Editable->False]}]}], ")"}]}]]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"e44f4a15-f2e0-4b9f-b5ba-451ea2233d28"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule", "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"05bd62ed-58d8-4e61-9c20-fe13a0a7576a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {
             UnderscriptBox[
              UnderscriptBox["A", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["F", "_"], "_"]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[
      PatternTest[
       Pattern[$CellContext`A, 
        Blank[Symbol]], TangentM2`Q], 
      PatternTest[
       Pattern[$CellContext`F, 
        Blank[Symbol]], TangentM2`Q]],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "B", "}"}], ",", 
     FractionBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"B"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"F"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`F],
        Editable->False]}], 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{
            StyleBox["(",
             FontColor->RGBColor[1, 0, 0]], 
            RowBox[{
             InterpretationBox[
              StyleBox[GridBox[{
                 {"v", 
                  StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`v[$CellContext`A],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox[GridBox[{
                 {"w", 
                  StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                   FontSize->Rational[39, 4]]}
                },
                
                GridBoxAlignment->{
                 "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                  "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`w[-$CellContext`A],
              Editable->False]}], 
            StyleBox[")",
             FontColor->RGBColor[1, 0, 0]]}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          
          xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
          Editable->False], "-", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], " ", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             StyleBox["(",
              FontColor->RGBColor[1, 0, 0]], 
             RowBox[{
              InterpretationBox[
               StyleBox[GridBox[{
                  {"v", 
                   StyleBox[GridBox[{
                    {"A"},
                    {" "}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v[$CellContext`A],
               Editable->False], " ", 
              InterpretationBox[
               StyleBox[GridBox[{
                  {"w", 
                   StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`w[-$CellContext`A],
               Editable->False]}], 
             StyleBox[")",
              FontColor->RGBColor[1, 0, 0]]}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           
           xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
           Editable->False]}]}], ")"}]}]]}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"88fedde9-1213-4c6a-96ce-1d51054f130b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", "B", "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "B"}], "]"}], 
    RowBox[{"r", "[", "]"}]}], "/.", "rule"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"31cc1d28-707e-458a-8af4-bcafa16ae9cb"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[-$CellContext`B],
    Editable->False]}], 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"w", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[-$CellContext`A],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
    Editable->False], "-", 
   RowBox[{"3", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {"A"},
                {" "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"w", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[-$CellContext`A],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
     Editable->
      False]}]}]]], \
"Output",ExpressionUUID->"a8ee6cbd-44f9-41b2-bd21-c693e567936f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "BreakScalars"}]], \
"Input",ExpressionUUID->"4648e66e-7a78-4b31-8662-f0d81d1f19eb"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[-$CellContext`B],
    Editable->False]}], 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"w", 
            StyleBox[GridBox[{
               {" "},
               {"A"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[-$CellContext`A],
        Editable->False]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
    Editable->False], "-", 
   RowBox[{"3", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {"A"},
                {" "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"w", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[-$CellContext`A],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
     Editable->
      False]}]}]]], \
"Output",ExpressionUUID->"2582648f-8567-4099-98af-e60329994749"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "PutScalar"}]], \
"Input",ExpressionUUID->"2a3f944f-1eed-48a6-8ab3-d9d0a103a7f0"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[-$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {"A"},
                {" "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[$CellContext`A],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`v[-$CellContext`A] \
$CellContext`v[$CellContext`A]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {"B"},
                {" "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[$CellContext`B],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"w", 
             StyleBox[GridBox[{
                {" "},
                {"B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[-$CellContext`B],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`v[$CellContext`B] \
$CellContext`w[-$CellContext`B]],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"C"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[C],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"v", 
         StyleBox[GridBox[{
            {"D"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`v[D],
     Editable->False]}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}]}], ")"}], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"v", 
             StyleBox[GridBox[{
                {"A"},
                {" "}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`v[$CellContext`A],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox[GridBox[{
            {"w", 
             StyleBox[GridBox[{
                {" "},
                {"A"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[-$CellContext`A],
         Editable->False]}], 
       StyleBox[")",
        FontColor->RGBColor[1, 0, 0]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`Scalar[$CellContext`v[$CellContext`A] \
$CellContext`w[-$CellContext`A]],
     Editable->
      False]}]]}]], \
"Output",ExpressionUUID->"38e99649-76c5-48ba-9eed-8b9e64a6c784"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplification", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"75cf4cb2-6494-422b-abb4-5405077e5a7b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Join", "::", "heads"}], "MessageName"], ":", 
  " ", "\<\"Heads \[NoBreak]\\!\\(IndexList\\)\[NoBreak] and \
\[NoBreak]\\!\\(xAct`xTensor`Private`freeindices\\)\[NoBreak] at positions \
\[NoBreak]\\!\\(1\\)\[NoBreak] and \[NoBreak]\\!\\(2\\)\[NoBreak] are \
expected to be the same. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/heads\\\", ButtonNote -> \
\\\"Join::heads\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2e01a5f7-755f-4489-b298-d04632173c69"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Join", "::", "heads"}], "MessageName"], ":", 
  " ", "\<\"Heads \[NoBreak]\\!\\(IndexList\\)\[NoBreak] and \
\[NoBreak]\\!\\(xAct`xTensor`Private`freeindices\\)\[NoBreak] at positions \
\[NoBreak]\\!\\(1\\)\[NoBreak] and \[NoBreak]\\!\\(2\\)\[NoBreak] are \
expected to be the same. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/heads\\\", ButtonNote -> \
\\\"Join::heads\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c3167966-a382-4ab5-bf87-9c3d4c22c90d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Complement", "::", "heads"}], "MessageName"], ":", 
  " ", "\<\"Heads \[NoBreak]\\!\\(Times\\)\[NoBreak] and \[NoBreak]\\!\\(Join\
\\)\[NoBreak] at positions \[NoBreak]\\!\\(2\\)\[NoBreak] and \
\[NoBreak]\\!\\(1\\)\[NoBreak] are expected to be the same. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/heads\\\", \
ButtonNote -> \\\"Complement::heads\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"fea2d3ef-6d62-4285-bb3e-378894ea904f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Intersection", "::", "heads"}], "MessageName"], ":", 
  " ", "\<\"Heads \[NoBreak]\\!\\(Complement\\)\[NoBreak] and \
\[NoBreak]\\!\\(IndexList\\)\[NoBreak] at positions \[NoBreak]\\!\\(2\\)\
\[NoBreak] and \[NoBreak]\\!\\(1\\)\[NoBreak] are expected to be the same. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/heads\\\", \
ButtonNote -> \\\"Intersection::heads\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"0715fbe1-a17d-443a-846a-d70c9760e43e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Intersection", "::", "heads"}], "MessageName"], ":", 
  " ", "\<\"Heads \[NoBreak]\\!\\(Complement\\)\[NoBreak] and \
\[NoBreak]\\!\\(IndexList\\)\[NoBreak] at positions \[NoBreak]\\!\\(2\\)\
\[NoBreak] and \[NoBreak]\\!\\(1\\)\[NoBreak] are expected to be the same. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/heads\\\", \
ButtonNote -> \\\"Intersection::heads\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"50a3d267-1662-4442-b042-5881159afe2a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Intersection", "::", "heads"}], "MessageName"], ":", 
  " ", "\<\"Heads \[NoBreak]\\!\\(Complement\\)\[NoBreak] and \
\[NoBreak]\\!\\(IndexList\\)\[NoBreak] at positions \[NoBreak]\\!\\(2\\)\
\[NoBreak] and \[NoBreak]\\!\\(1\\)\[NoBreak] are expected to be the same. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/heads\\\", \
ButtonNote -> \\\"Intersection::heads\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9a2b5647-6a84-4d1c-9d37-7e61ea3d73b3"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Intersection :: \
heads\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a0b80cc1-219f-459b-b490-e8e41af0bf67"],

Cell[BoxData["\<\"INFO: ToObject acting on a VP with not all Objects.\"\>"], \
"Print",ExpressionUUID->"a94e1dad-25ad-48d0-ae15-f0574f8b5b3b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"xSort", "::", "error1"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"INFO: ToObject: I don't know what to do \
with\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\\*TagBox[TooltipBox[\\(\\(-1\\)\\+_\\), RowBox[List[\\\"\\\\\
\\\"Object\\\\\\\"\\\", \\\"[\\\", RowBox[List[RowBox[List[\\\"-\\\", \\\"1\\\
\"]], \\\",\\\", RowBox[List[\\\"{\\\", RowBox[List[\\\"Constant\\\", \\\",\\\
\", \\\"1\\\", \\\",\\\", RowBox[List[\\\"-\\\", \\\"1\\\"]]]], \\\"}\\\"]], \
\\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", \
Rule[FontColor, RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], IndexList[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]]]], \\\"}\\\"]]]], \\\"]\\\"]]], Function[Slot[1]]]\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e7605cbd-547b-455b-96e5-8109ba2244c5"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Throw", "::", "nocatch"}], "MessageName"], ":", 
  " ", "\<\"Uncaught \[NoBreak]\\!\\(Throw[Null]\\)\[NoBreak] returned to top \
level. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Throw/nocatch\\\", ButtonNote -> \
\\\"Throw::nocatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"f69e50b9-6c8b-4992-acda-60051775d3fb"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"Throw", "[", "Null", "]"}], 
  "]"}]], "Output",ExpressionUUID->"42dfd05a-fcc8-4f12-899a-4efbaca0a8db"]
}, Open  ]],

Cell["\<\
Compare with the direct application of Solve. There is no care about scalars, \
and no patterns on the lhs.\
\>", "Text",ExpressionUUID->"144c6c17-5839-42f2-961d-52bd0d97407a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "F"}], "]"}], 
     RowBox[{"v", "[", "B", "]"}], 
     RowBox[{"w", "[", 
      RowBox[{"-", "B"}], "]"}], 
     RowBox[{"r", "[", "]"}]}], "\[Equal]", 
    RowBox[{
     RowBox[{"3", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "F"}], "]"}], 
      RowBox[{"v", "[", "B", "]"}], 
      RowBox[{"w", "[", 
       RowBox[{"-", "B"}], "]"}], 
      RowBox[{
       RowBox[{"r", "[", "]"}], "^", "3"}]}], "+", 
     RowBox[{
      RowBox[{"v", "[", "A", "]"}], 
      RowBox[{"v", "[", "F", "]"}], 
      RowBox[{"v", "[", "B", "]"}], 
      RowBox[{"v", "[", 
       RowBox[{"-", "B"}], "]"}]}]}]}], ",", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "F"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"80839e49-e87d-4c97-8286-36d9098496fa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {"A", "F"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[$CellContext`A, $CellContext`F],
     Editable->False], "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"A"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`A],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[-$CellContext`B],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"F"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[$CellContext`F],
        Editable->False]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "3"]}]}], ")"}], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"w", 
            StyleBox[GridBox[{
               {" "},
               {"B"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[-$CellContext`B],
        Editable->False]}]]}]}], "}"}], 
  "}"}]], "Output",ExpressionUUID->"92aacfa7-ae98-4a42-9fcc-e1e788d67809"]
}, Open  ]],

Cell["A homogeneous case:", \
"Text",ExpressionUUID->"3716aa83-692a-4504-a1da-7117636732bc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"xTensorQ", "[", "metricg", "]"}], "^=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymmetryGroupOfTensor", "[", "metricg", "]"}], "^=", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"GenSet", "[", 
      RowBox[{"Cycles", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "metricg", "}"}]}], "]"}], 
  ";"}]}], "Input",ExpressionUUID->"2d2797e5-764b-4ab8-8f48-ab1c6817c692"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"IndexSolve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "F"}], "]"}], 
      RowBox[{"v", "[", "B", "]"}], 
      RowBox[{"w", "[", 
       RowBox[{"-", "B"}], "]"}], 
      RowBox[{"r", "[", "]"}]}], "\[Equal]", 
     RowBox[{"3", 
      RowBox[{"T", "[", 
       RowBox[{"A", ",", "F"}], "]"}], 
      RowBox[{"v", "[", "C", "]"}], 
      RowBox[{"w", "[", 
       RowBox[{"-", "C"}], "]"}], 
      RowBox[{
       RowBox[{"r", "[", "]"}], "^", "3"}]}]}], ",", 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "F"}], "]"}], ",", 
    RowBox[{"MetricOn", "\[Rule]", "All"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"2f53343f-f1a3-4082-ab86-14f5cf0a0ded"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {
             UnderscriptBox[
              UnderscriptBox["A", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["F", "_"], "_"]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[
      PatternTest[
       Pattern[$CellContext`A, 
        Blank[]], TangentM2`pmQ], 
      PatternTest[
       Pattern[$CellContext`F, 
        Blank[]], TangentM2`pmQ]],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "0"}], "]"}]}], 
  "}"}]], "Output",ExpressionUUID->"2a26eee7-fac1-4c7a-b6a8-1fa25fdcb049"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"xUpSet", "[", 
   RowBox[{
    RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"e1510594-e5d3-441b-baf5-60e0ab96438b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "metricg", "]"}], 
  ";"}]], "Input",ExpressionUUID->"c632f950-e022-4dbc-9612-d49efd2d6b17"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v", ",", "r", ",", "w"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"3b0f27f0-2393-47bf-9007-943cf2c36376"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"832b59c1-02be-4150-a48a-d3bf4b93bc64"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"95ca75af-4555-4aee-9d6d-ca2c06cad736"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"dccc6e08-6fd8-4d7a-84f0-d6f61c5649ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"8cfd5fb8-6be9-49a2-99b7-bdcb3303511d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f275a0c2-e631-45e1-a74e-faac03afa552"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"F$\"\>", ",", "\<\"G$309216\"\>", ",", "\<\"G$309217\"\>", 
     ",", "\<\"G$309218\"\>", ",", "\<\"G$309226\"\>", 
     ",", "\<\"G$309226$\"\>", ",", "\<\"G$309226$309238\"\>", 
     ",", "\<\"G$309231\"\>", ",", "\<\"G$309233\"\>", 
     ",", "\<\"G$309249\"\>", ",", "\<\"G$309254\"\>", 
     ",", "\<\"G$309259\"\>", ",", "\<\"G$312734\"\>", 
     ",", "\<\"G$312735\"\>", ",", "\<\"G$312736\"\>", 
     ",", "\<\"G$312740\"\>", ",", "\<\"G$312741\"\>", ",", "\<\"rule\"\>"}], 
    "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "F$", "G$309216", "G$309217", "G$309218", "G$309226", "G$309226$", 
    "G$309226$309238", "G$309231", "G$309233", "G$309249", "G$309254", 
    "G$309259", "G$312734", "G$312735", "G$312736", "G$312740", "G$312741", 
    "rule"}],
  Editable->
   False]], "Print",ExpressionUUID->"07519c0d-651c-42e0-87e3-b93b6737f707"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.3. IndexCoefficient and IndexCollect", \
"Subsection",ExpressionUUID->"d89934f9-3d7d-4528-8043-f8d39a624734"],

Cell[CellGroupData[{

Cell["16.3.0. Comments", \
"Subsubsection",ExpressionUUID->"cbbfb87b-a9e1-4a63-8e4f-be85f0671a15"],

Cell["\<\
I thank Alfonso Garc\[IAcute]a-Parrado and Juanjo L\[OAcute]pez-Villarejo for \
many discussion on this important pair of functions.\
\>", "Text",ExpressionUUID->"ba4a6a83-4d91-4ef0-b25b-a9b1ced5b892"]
}, Closed]],

Cell[CellGroupData[{

Cell["16.3.1. IndexCoefficient", \
"Subsubsection",ExpressionUUID->"944a776a-4b95-4d4e-aba5-a6f0b04d009b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Shortcut", ":", " ", 
    RowBox[{
    "With", " ", "nonindexed", " ", "form", " ", "change", " ", "to", " ", 
     "Coefficient"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"form_", "?", "NonIndexedScalarQ"}]}], "]"}], ":=", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"expr", ",", "form"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Recursion", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient", "[", 
      RowBox[{"expr_", ",", 
       RowBox[{"form1_", " ", "form2_"}]}], "]"}], ":=", 
     RowBox[{"IndexCoefficient", "[", 
      RowBox[{
       RowBox[{"Expand", "@", 
        RowBox[{"IndexCoefficient", "[", 
         RowBox[{"expr", ",", "form1"}], "]"}]}], ",", "form2"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"General", " ", 
     RowBox[{"case", ":", " ", 
      RowBox[{"Expand", " ", "symmetry", " ", "and", " ", "average"}]}]}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient", "[", 
      RowBox[{"expr_", ",", "form_"}], "]"}], ":=", 
     RowBox[{"average", "@", 
      RowBox[{"SymmetryIndexCoefficient", "[", 
       RowBox[{
        RowBox[{"ReplaceDummies", "[", "expr", "]"}], ",", 
        RowBox[{"SymmetryEquivalentsOf", "[", "form", "]"}]}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetNumberOfArguments", "[", 
     RowBox[{"IndexCoefficient", ",", "2"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "IndexCoefficient", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Secondary", " ", "functions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"average", "[", 
      RowBox[{"{", 
       RowBox[{"0.", ".."}], "}"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"average", "[", "list_List", "]"}], ":=", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nonzero", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{"list", ",", "0"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"Plus", "@@", "nonzero"}], "/", 
        RowBox[{"Length", "[", "nonzero", "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Thread", " ", "over", " ", "symmetry", " ", "equivalents"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SymmetryIndexCoefficient", "[", 
      RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"IndexCoefficient1", "[", 
        RowBox[{"expr", ",", "#"}], "]"}], "&"}], "/@", "list"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Thread", " ", "over", " ", "Plus"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient1", "[", 
      RowBox[{"expr_Plus", ",", "form_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"IndexCoefficient1", "[", 
        RowBox[{"#", ",", "form"}], "]"}], "&"}], "/@", "expr"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Products", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient1", "[", 
      RowBox[{"expr_Times", ",", "form_"}], "]"}], ":=", 
     RowBox[{"average", "@", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"IndexCoefficient2", "[", 
          RowBox[{
           RowBox[{"expr", "/", "#"}], ",", "#", ",", "form"}], "]"}], "&"}], 
        ",", 
        RowBox[{"List", "@@", "expr"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient1", "[", 
      RowBox[{"expr_", ",", "form_"}], "]"}], ":=", 
     RowBox[{"IndexCoefficient2", "[", 
      RowBox[{"1", ",", "expr", ",", "form"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Compare", " ", "expr", " ", "and", " ", "form"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient2", "[", 
      RowBox[{"rest_", ",", "expr_", ",", 
       RowBox[{"-", "form_"}]}], "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"IndexCoefficient2", "[", 
       RowBox[{"rest", ",", "expr", ",", "form"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient2", "[", 
      RowBox[{"rest_", ",", "expr_", ",", "form_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"rest", " ", 
       RowBox[{"IndexCoefficient3", "[", 
        RowBox[{
         RowBox[{"FindIndices", "[", "expr", "]"}], ",", 
         RowBox[{"FindIndices", "[", "form", "]"}]}], "]"}]}], "/;", 
      RowBox[{"SameExpressionsQ", "[", 
       RowBox[{"expr", ",", "form"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient2", "[", 
      RowBox[{"rest_", ",", "expr_", ",", "form_"}], "]"}], ":=", "0"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Compute", " ", 
     RowBox[{"coefficient", ".", " ", "Assume"}], " ", "lists", " ", "have", 
     " ", "same", " ", 
     RowBox[{"length", ".", " ", "inds1"}], " ", "are", " ", "the", " ", 
     "indices", " ", "of", " ", "expr", " ", "and", " ", "inds2", " ", "are", 
     " ", "the", " ", "indices", " ", "of", " ", "form"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient3", "[", 
      RowBox[{"inds1_", ",", "inds1_"}], "]"}], ":=", "1"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient3", "[", 
      RowBox[{"inds1_", ",", "inds2_"}], "]"}], ":=", 
     RowBox[{"IndexCoefficient3", "[", 
      RowBox[{"inds1", ",", "inds2", ",", 
       RowBox[{"TakeEPairs", "[", "inds1", "]"}], ",", 
       RowBox[{"TakeEPairs", "[", "inds2", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"1.", " ", "There", " ", "are", " ", "no", " ", 
      RowBox[{"dummies", ":", " ", 
       RowBox[{"form", " ", "pairs"}]}]}], ",", " ", 
     RowBox[{
     "taking", " ", "care", " ", "of", " ", "repeated", " ", "free", " ", 
      RowBox[{"indices", ".", "\[IndentingNewLine]", "   ", "EXTENDED"}], " ",
       "TO", " ", "THE", " ", "GENERAL", " ", "CASE", " ", "TO", " ", "SEE", 
      " ", "WHAT", " ", "HAPPENS"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient3", "[", 
      RowBox[{"inds1_", ",", "inds2_", ",", "_", ",", "_"}], "]"}], ":=", 
     RowBox[{"IndexCoefficient4", "[", 
      RowBox[{
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"inds1", ",", "inds2"}], "}"}], ",", "IndexList"}], "]"}], 
       ",", 
       RowBox[{"Intersection", "[", 
        RowBox[{"inds1", ",", "inds2"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"todelta", "[", 
      RowBox[{"{", 
       RowBox[{"___", ",", "_LI", ",", "___"}], "}"}], "]"}], ":=", 
     RowBox[{"Throw", "@", 
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"IndexCoefficient", "::", "error"}], ",", 
        "\"\<Cannot collect label indices.\>\""}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"QUESTION", ":", " ", 
     RowBox[{"Is", " ", "this", " ", "OK", " ", "with", " ", 
      RowBox[{"spinors", "?"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"todelta", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", 
        RowBox[{"b_", "?", "DownIndexQ"}]}], "}"}], "]"}], ":=", 
     RowBox[{"delta", "[", 
      RowBox[{"a", ",", 
       RowBox[{"ChangeIndex", "[", "b", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"todelta", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", 
        RowBox[{"b_", "?", "UpIndexQ"}]}], "}"}], "]"}], ":=", 
     RowBox[{"delta", "[", 
      RowBox[{
       RowBox[{"ChangeIndex", "[", "b", "]"}], ",", "a"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient4", "[", 
      RowBox[{"pairs_", ",", 
       RowBox[{"IndexList", "[", "]"}]}], "]"}], ":=", 
     RowBox[{"Apply", "[", 
      RowBox[{"Times", ",", 
       RowBox[{"todelta", "/@", "pairs"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient4", "[", 
      RowBox[{
       RowBox[{"IndexList", "[", 
        RowBox[{"pairs1___", ",", 
         RowBox[{"{", 
          RowBox[{"a_", ",", "a_"}], "}"}], ",", "pairs2___"}], "]"}], ",", 
       RowBox[{"IndexList", "[", 
        RowBox[{"a_", ",", "other___"}], "]"}]}], "]"}], ":=", 
     RowBox[{"IndexCoefficient4", "[", 
      RowBox[{
       RowBox[{"IndexList", "[", 
        RowBox[{"pairs1", ",", "pairs2"}], "]"}], ",", 
       RowBox[{"IndexList", "[", "other", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IndexCoefficient4", "[", 
      RowBox[{"_", ",", "_"}], "]"}], ":=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"2.", " ", "There", " ", "are", " ", 
     RowBox[{"dummies", ".", " ", 
      RowBox[{"??", "?"}]}]}], " ", "*)"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"ca826040-f8a5-4a31-a5c8-602c2d9cd6a0"],

Cell["\<\
This function checks whether two expressions are equal or not up to indices. \
We check equality of length of indices in order to allow for variable-rank \
tensors:\
\>", "Text",ExpressionUUID->"551ec57b-726e-4ab7-ac00-a788dfe1b768"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{"expr_", ",", "expr_"}], "]"}], ":=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{
     RowBox[{"tensor_", "[", "inds1___", "]"}], ",", 
     RowBox[{
      RowBox[{"tensor_", "?", "xTensorQ"}], "[", "inds2___", "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"{", "inds1", "}"}], "]"}], "===", 
    RowBox[{"Length", "[", 
     RowBox[{"{", "inds2", "}"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"covd_", "[", "_", "]"}], "[", "expr1_", "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"covd_", "?", "CovDQ"}], "[", "_", "]"}], "[", "expr2_", 
      "]"}]}], "]"}], ":=", 
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{"expr1", ",", "expr2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ParamD", "[", "ps1__", "]"}], "[", "expr1_", "]"}], ",", 
     RowBox[{
      RowBox[{"ParamD", "[", "ps2__", "]"}], "[", "expr2_", "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", "ps1", "}"}], "===", 
     RowBox[{"{", "ps2", "}"}]}], "&&", 
    RowBox[{"SameExpressionsQ", "[", 
     RowBox[{"expr1", ",", "expr2"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"LieD", "[", "v1_", "]"}], "[", "expr1_", "]"}], ",", 
     RowBox[{
      RowBox[{"LieD", "[", "v2_", "]"}], "[", "expr2_", "]"}]}], "]"}], ":=", 
   
   RowBox[{
    RowBox[{"SameExpressionsQ", "[", 
     RowBox[{"v1", ",", "v2"}], "]"}], "&&", 
    RowBox[{"SameExpressionsQ", "[", 
     RowBox[{"expr1", ",", "expr2"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Bracket", "[", 
       RowBox[{"v1a_", ",", "v1b_"}], "]"}], "[", "_", "]"}], ",", 
     RowBox[{
      RowBox[{"Bracket", "[", 
       RowBox[{"v2a_", ",", "v2b_"}], "]"}], "[", "_", "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SameExpressionsQ", "[", 
     RowBox[{"v1a", ",", "v2a"}], "]"}], "&&", 
    RowBox[{"SameExpressionsQ", "[", 
     RowBox[{"v1b", ",", "v2b"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"prod_", "?", "ProductQ"}], "[", "tensors1___", "]"}], ",", 
     RowBox[{
      RowBox[{"prod_", "?", "ProductQ"}], "[", "tensors2___", "]"}]}], "]"}], 
   ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", 
      RowBox[{"{", "tensors1", "}"}], "]"}], "===", 
     RowBox[{"Length", "[", 
      RowBox[{"{", "tensors2", "}"}], "]"}]}], "&&", 
    RowBox[{"And", "@@", 
     RowBox[{"MapThread", "[", 
      RowBox[{"SameExpressionsQ", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "tensors1", "}"}], ",", 
         RowBox[{"{", "tensors2", "}"}]}], "}"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SameExpressionsQ", "[", 
    RowBox[{"_", ",", "_"}], "]"}], ":=", "False"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"fef7e11e-60db-4d73-82d4-1da98ed00ee6"],

Cell["\<\
Old code. This function only works on form's with free indices, and sometimes \
(due to the ReplaceDummies construction) on form's with dummy indices.\
\>", "Text",ExpressionUUID->"90ba926e-5ede-4b69-95f1-978ba776ab10"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$Coeffindices", ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SymbolJoin", "[", 
      RowBox[{"#", ",", "\"\<$$\>\""}], "]"}], "&"}], "/@", 
    RowBox[{"IndexList", "@@", "$AbstractIndices"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexCoefficient", "[", 
    RowBox[{"expr_", ",", "form_"}], "]"}], ":=", 
   RowBox[{"Coefficient", "[", 
    RowBox[{
     RowBox[{"ReplaceDummies", "[", 
      RowBox[{"expr", ",", "$Coeffindices"}], "]"}], ",", 
     RowBox[{"ReplaceDummies", "[", 
      RowBox[{"form", ",", "$Coeffindices"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndexCoefficient", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexCoefficient", "]"}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"5a3f59dd-b89b-4375-88fa-3dd1b81785e1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"$Coeffindices\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "$Coeffindices", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"794b15d9-4ac7-4047-87ae-ff01a6c20fe3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", "\[InvisibleSpace]", "\<\"form\"\>",
    "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "form", ", Context: ", "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"4d614cef-ebf7-4576-ac53-34d12871c546"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"208f87a1-d383-4f7c-8ae9-d119175ee2ce"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "C", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"ed9cdfb8-0448-4863-95f7-976227d2da8d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c06f74aa-7b7e-46c9-a260-8475269ea4f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "C", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2eb86ce9-37f6-48d2-950c-4b2e39120042"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"aceca493-f9de-4b25-a15f-9dc5229fcf67"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"958e8521-6fde-4844-8cda-592812b8174e"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "TangentM2", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], "^=", 
   RowBox[{"{", "metricg", "}"}]}], 
  ";"}]}], "Input",ExpressionUUID->"9e120bdf-8a6f-46d9-b00e-081230176841"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "A"}], ",", 
       RowBox[{"-", "B"}]}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"v", "[", 
      RowBox[{"-", "A"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}]}], ",", 
   RowBox[{"v", "[", 
    RowBox[{"-", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"3f593df0-8576-49f8-8a26-5a8c4b8bdb37"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`A, -$CellContext`B],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`B],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"ac732a08-9ce7-4779-ad35-ee3a1d931c95"]
}, Open  ]],

Cell["It doesn't work yet with free indices:", \
"Text",ExpressionUUID->"de6b2454-dcb5-4e22-8d87-f28909e9f9a2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexCoefficient", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"B", ",", 
       RowBox[{"-", "B"}]}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}]}], ",", 
   RowBox[{"T", "[", 
    RowBox[{"C", ",", 
     RowBox[{"-", "C"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b923adf5-9bcb-4973-aa9a-77370728e5eb"],

Cell[BoxData[
 RowBox[{"4", " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-C],
   Editable->
    False]}]], "Output",ExpressionUUID->"d57312f0-0279-47a4-86d1-c112543ea9c0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"74084deb-1185-4f7e-9314-f1066bc31df7"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"286b9a5d-0852-4c37-b571-9ed09b1f397c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"8f403edc-94b8-4f00-bcda-9c9476318e64"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "metricg", 
  "]"}]], "Input",ExpressionUUID->"3e53fed8-9bb9-4d3b-8cb1-342ed7a1e962"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"3297aab1-8494-4f1b-9681-3d75f52fca38"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MetricsOfVBundle", "[", "TangentM2", "]"}], "^=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TangentM2", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"efc7bd2f-88ad-42b2-b58d-e61cc0a63e35"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"30980424-6931-4cdd-b505-9489655fdc5d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$312760\"\>", ",", "\<\"G$312761\"\>"}], "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"G$312760", "G$312761"}],
  
  Editable->
   False]], "Print",ExpressionUUID->"2f2dbb65-51c3-4c06-a700-7b5c0a30db61"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.3.2. IndexCollect", \
"Subsubsection",ExpressionUUID->"a2973bc3-b14d-4371-9aff-4b12db8a65aa"],

Cell[TextData[{
 "This is a simple recursive function based on IndexCoefficient. Again, we \
imitate ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s builtin Collect. The recursive part of the code is pretty clear, but the \
\"rest\" part of the code is not that clear. In particular, it is not enough \
to act with the f function because lots of metrics could have been generated. \
That is why we use f@ToCanonical@ContractMetric on that part, though I don't \
really like this because the user does not expect to have that there. That is \
why we define a (currently private) global function to control that point."
}], "Text",ExpressionUUID->"434a0c2f-d68d-4c4e-9f5c-f207ae8221a5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$IndexCollectRest", "=", 
   RowBox[{"Composition", "[", 
    RowBox[{"ToCanonical", ",", "ContractMetric"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr_", ",", "forms_"}], "]"}], ":=", 
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr", ",", "forms", ",", "Identity"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", "}"}], ",", "f_"}], "]"}], ":=", 
   RowBox[{"f", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"form1_", ",", "forms___"}], "}"}], ",", "f_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"coeff", "=", 
       RowBox[{"ReplaceDummies", "@", 
        RowBox[{"IndexCoefficient", "[", 
         RowBox[{"expr", ",", "form1"}], "]"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"form1", " ", 
       RowBox[{"IndexCollect", "[", 
        RowBox[{"coeff", ",", 
         RowBox[{"{", "forms", "}"}], ",", "f"}], "]"}]}], "+", 
      RowBox[{"f", "[", 
       RowBox[{"$IndexCollectRest", "[", 
        RowBox[{"expr", "-", " ", 
         RowBox[{"coeff", " ", "form1"}]}], "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr_", ",", "x_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"{", "x", "}"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"IndexCollect", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "IndexCollect", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"bf8f45b0-c01a-4308-8f94-84435534d94f"],

Cell["Old code:", \
"Text",ExpressionUUID->"7a083c4b-7fda-4481-8137-01175ecfb964"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"tensor_", "[", "]"}], ",", "f_"}], "]"}], ":=", 
   RowBox[{"Collect", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"tensor", "[", "]"}], ",", "f"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IndexCollect", "[", 
    RowBox[{"expr_", ",", "tensor_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"EIndexCollect", "[", 
    RowBox[{
     RowBox[{"Expand", "[", 
      RowBox[{"ReplaceDummies", "[", "expr", "]"}], "]"}], ",", "tensor", ",",
      "f"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EIndexCollect", "[", 
    RowBox[{"expr_Plus", ",", "tensor_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EIndexCollect", "[", 
         RowBox[{"#", ",", "tensor", ",", "f"}], "]"}], "&"}], ",", "expr"}], 
      "]"}], ",", "tensor", ",", "f"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"changerule", "[", 
    RowBox[{"Rule", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], "]"}], ":=", 
   RowBox[{"Rule", "[", 
    RowBox[{
     RowBox[{"ChangeIndex", "[", "x", "]"}], ",", 
     RowBox[{"ChangeIndex", "[", "y", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EIndexCollect", "[", 
   RowBox[{
    RowBox[{"rest_.", " ", 
     RowBox[{"tensor_", "[", "oldinds__", "]"}]}], ",", 
    RowBox[{"tensor_", "[", "newinds__", "]"}], ",", "f_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", "=", 
      RowBox[{"Apply", "[", 
       RowBox[{"Rule", ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "oldinds", "}"}], ",", 
           RowBox[{"{", "newinds", "}"}]}], "}"}], "]"}], ",", "1"}], "]"}]}],
      "}"}], ",", 
    RowBox[{"ReplaceIndex", "[", 
     RowBox[{
      RowBox[{"rest", " ", 
       RowBox[{"tensor", "[", "oldinds", "]"}]}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{"rules", ",", 
        RowBox[{"changerule", "/@", "rules"}]}], "]"}]}], "]"}]}], 
   "]"}]}]}], "Input",
 Evaluatable->False,ExpressionUUID->"54a8f57e-6953-46d5-93bf-faa3e54c0009"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"EIndexCollect\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "EIndexCollect", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"e5bcd023-2723-477c-a1c3-fbb711bdc263"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"changerule\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "changerule", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"ff922236-85f4-465f-b569-9283b7c31111"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"ChangeIndex\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "ChangeIndex", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"72ed02a2-ef76-47b8-a7d3-9d32359ec11c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"ExCollect\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "ExCollect", ", Context: ", "xAct`xTensor`Private`"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"e3c22595-6542-44d3-a550-b984d906b6da"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"changerule\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "changerule", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"7b26a67c-9fe6-4086-a10a-df5114b501f3"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"2bb7298b-86ea-4ff7-9af8-3d7e2b77513c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"Y", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"W", "[", 
    RowBox[{"a", ",", "b"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]}], "Input",ExpressionUUID->"969e8ca9-2ece-4495-a0b8-487d53318893"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`a, -$CellContext`b, -$CellContext`c], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"d723877d-e64b-4fcd-a0ff-9a066155974d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Y", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Y[-$CellContext`a, -$CellContext`b, -$CellContext`c], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"fe0b0885-733e-4edd-a499-b017a266341b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"W", "[", 
    RowBox[{"a", ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`W[$CellContext`a, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4816054d-6269-4d19-b2d9-9a41ad5e19b4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}]}], "]"}], 
    RowBox[{"W", "[", 
     RowBox[{"b", ",", "c"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"Y", "[", 
     RowBox[{
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "f"}]}], "]"}], 
    RowBox[{"W", "[", 
     RowBox[{"d", ",", "f"}], 
     "]"}]}]}]}]], \
"Input",ExpressionUUID->"5f05cb0f-3089-4b3d-b4a1-abb48d3604b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"a", "b", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`a, -$CellContext`b, -$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"W", 
        StyleBox[GridBox[{
           {"b", "c"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`W[$CellContext`b, $CellContext`c],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"W", 
        StyleBox[GridBox[{
           {"d", "f"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`W[$CellContext`d, $CellContext`f],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Y", 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"d", "a", "f"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Y[-$CellContext`d, -$CellContext`a, -$CellContext`f],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"7ae4028d-4ab5-4c0e-9dde-e42807e96b8a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexCollect", "[", 
  RowBox[{"expr", ",", 
   RowBox[{"W", "[", 
    RowBox[{"d", ",", "c"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"9fdcaeea-dc6c-4353-bbeb-5eaf1b78faf3"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"W", 
       StyleBox[GridBox[{
          {"d", "c"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`W[$CellContext`d, $CellContext`c],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"a", "c", "d"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`a, -$CellContext`c, -$CellContext`d],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"a", "d", "c"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`a, -$CellContext`d, -$CellContext`c],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Y", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"c", "a", "d"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Y[-$CellContext`c, -$CellContext`a, -$CellContext`d],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Y", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"d", "a", "c"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Y[-$CellContext`d, -$CellContext`a, -$CellContext`c],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"056306aa-edfc-48f1-887a-719391a8e819"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexCoefficient", "[", 
  RowBox[{"expr", ",", 
   RowBox[{"W", "[", 
    RowBox[{"d", ",", "c"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b06b352c-6015-4435-a4de-172dbfcac122"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"a", "c", "d"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`a, -$CellContext`c, -$CellContext`d],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"T", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"a", "d", "c"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`T[-$CellContext`a, -$CellContext`d, -$CellContext`c],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Y", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"c", "a", "d"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Y[-$CellContext`c, -$CellContext`a, -$CellContext`d],
     Editable->False], "+", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Y", 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"d", "a", "c"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Y[-$CellContext`d, -$CellContext`a, -$CellContext`c],
     Editable->False]}], 
   ")"}]}]], "Output",ExpressionUUID->"2461d3a5-d85e-4e4c-82c1-9947f4ff1d38"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "Y", ",", "W"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"04c1852c-ba8f-4167-aa87-729e189b0df1"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"0844a05c-ed52-44c9-9855-9422c5ea987d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Y"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`Y],
  Editable->
   False]], "Print",ExpressionUUID->"3107ff9c-10c3-43c9-a343-7e451ed2c66e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "W"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`W],
  Editable->
   False]], "Print",ExpressionUUID->"b2977bf4-ed0a-4373-ae55-91acf3a4e171"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"6f6721f5-98a9-4866-b4c9-088d8587c135"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"f$312787\"\>", ",", "\<\"f$312788\"\>", 
     ",", "\<\"f$312789\"\>", ",", "\<\"f$312790\"\>", 
     ",", "\<\"f$312819\"\>", ",", "\<\"f$312820\"\>", 
     ",", "\<\"f$312821\"\>", ",", "\<\"f$312822\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "f$312787", "f$312788", "f$312789", "f$312790", "f$312819", "f$312820", 
    "f$312821", "f$312822"}],
  Editable->
   False]], "Print",ExpressionUUID->"7ed21d3b-68f0-47fd-ae92-89faa97ee978"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.4. calc function", \
"Subsection",ExpressionUUID->"44d416d8-f302-435a-99cd-223e9717f6e2"],

Cell["\<\
This function is now only used for examples in this notebook:\
\>", "Text",ExpressionUUID->"5a6ee329-7e57-428a-bbb5-00b3b8c2a807"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "calc", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ExpandCoordinates", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ExpandProductManifolds", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PrintTimeThreshold", "\[Rule]", "1"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Screen", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"UseMetric", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"UseRiemann", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Verbose", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"calc", "[", 
    RowBox[{"f_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"time", ",", "result", ",", "verb", ",", "tmp"}], "}"}], ",", 
     RowBox[{
      RowBox[{"time", "=", 
       RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"verb", "=", 
       RowBox[{"OptionValue", "[", "Verbose", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Initialize", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"result", "=", "f"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{
        "Print", "[", "\"\<1) Looking for product manifolds...\>\"", "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OptionValue", "[", "ExpandProductManifolds", "]"}], ",", 
        RowBox[{"result", "=", 
         RowBox[{"ExpandProductMetric", "[", 
          RowBox[{
           RowBox[{"TraceProductDummy", "[", "result", "]"}], ",", 
           "$ProductMetrics"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", " ", 
        RowBox[{"Print", "[", "result", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", "\"\<2) Applying global rules\>\"", "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"result", "=", 
       RowBox[{
        RowBox[{"Expand", "[", "result", "]"}], "//.", "$Rules"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", " ", 
        RowBox[{"Print", "[", "result", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", "\"\<3) Using Riemann...\>\"", "]"}]}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OptionValue", "[", "UseRiemann", "]"}], ",", 
        RowBox[{"result", "=", 
         RowBox[{"SortCovDs", "[", "result", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", " ", 
        RowBox[{"Print", "[", "result", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Third", ",", " ", 
        RowBox[{"metric", " ", "contractions"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", "\"\<4) Using metric rules...\>\"", "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OptionValue", "[", "UseMetric", "]"}], ",", 
        RowBox[{"result", "=", 
         RowBox[{"ContractMetric", "[", "result", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", " ", 
        RowBox[{"Print", "[", "result", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Finally", ",", " ", "simplifications"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", "\"\<5) Simplifying...\>\"", "]"}]}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"result", "=", 
       RowBox[{"Simplification", "[", 
        RowBox[{"result", ",", "options"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", " ", 
        RowBox[{"Print", "[", "result", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", "\"\<6) Coordinate expansions...\>\"", "]"}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OptionValue", "[", "ExpandCoordinates", "]"}], ",", 
        RowBox[{"result", "=", 
         RowBox[{"TraceBasisDummy", "[", "result", "]"}]}]}], " ", "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", " ", 
        RowBox[{"Print", "[", "result", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"verb", ",", 
        RowBox[{"Print", "[", "\"\<7) Rules...\>\"", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"result", "=", 
       RowBox[{"result", "//.", "$Rules"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OptionValue", "[", "Screen", "]"}], ",", 
        RowBox[{"result", "=", 
         RowBox[{"ScreenDollarIndices", "[", "result", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"time", "=", 
           RowBox[{
            RowBox[{"TimeUsed", "[", "]"}], "-", "time"}]}], ")"}], ">", 
         RowBox[{"OptionValue", "[", "PrintTimeThreshold", "]"}]}], ",", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Elapsed time: \>\"", ",", "time", ",", " ", 
          "\"\< seconds\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Simplify", "[", "result", "]"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"calc", "[", 
    RowBox[{"f_List", ",", "options___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"calc", "[", 
      RowBox[{"#", ",", "options"}], "]"}], "&"}], "/@", "f"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"calc", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "calc", "]"}], 
  ";"}]}], "Input",ExpressionUUID->"8529c8b9-8ca8-4656-b7e6-6ec6f21ac5cd"]
}, Closed]],

Cell[CellGroupData[{

Cell["16.5. Tracing abstract product dummies", \
"Subsection",ExpressionUUID->"39a6770f-273d-4b3b-9438-ccf9beffaf18"],

Cell["\<\
There are three things to worry about here:
\t1) The expression could be of the form a  (b + c) and therefore we must \
expand the sum before applying TraceProductDummy. TraceProductDummy must be \
always applied on terms. This is handled by TraceDummy.
\t2) We must be able to expand only a few dummies and not the others.  We use \
a list of indices (head IndexList) as second argument.
\t3) We must be able to say that we want to expand all indices of a given \
space.\
\>", "Text",ExpressionUUID->"8b8788d3-881f-47d5-b58e-230d174f1cfe"],

Cell["New code:", \
"Text",ExpressionUUID->"585a7f9b-77e3-4487-bca7-da2aa9face39"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy", "[", "expr_", "]"}], ":=", 
   RowBox[{"TraceProductDummy", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"IndexList", "@@", "$SumVBundles"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy", "[", 
    RowBox[{"expr_", ",", "list_IndexList"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"TraceProductDummy", ",", "expr", ",", "list"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"vbundle_", "?", "VBundleQ"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vbundleQ", "=", 
       RowBox[{"VBundleIndexQ", "[", "vbundle", "]"}]}], "}"}], ",", 
     RowBox[{"TraceDummy", "[", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{"_", "?", "vbundleQ"}], "\[RuleDelayed]", 
        RowBox[{"SubdummiesIn", "[", "vbundle", "]"}]}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"index_Symbol", "?", "AIndexQ"}]}], "]"}], ":=", 
   RowBox[{"TraceDummy", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"index", "\[RuleDelayed]", 
      RowBox[{"SubdummiesIn", "[", 
       RowBox[{"VBundleOfIndex", "[", "index", "]"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"TraceProductDummy", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "TraceProductDummy", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"66ebd16f-8f14-4fc5-85ed-af424889d70c"],

Cell["Old code:", \
"Text",ExpressionUUID->"435fa2da-680c-455e-9981-3fab879f7d86"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy", "::", "noindex"}], "=", 
    "\"\<Cannot trace index `1`.\>\""}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"One", " ", 
    RowBox[{"argument", ":", " ", 
     RowBox[{"convert", " ", "to", " ", "two", " ", "arguments"}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy", "[", "expr_", "]"}], ":=", 
    RowBox[{"TraceProductDummy", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"VBundle", "/@", "$SumVBundles"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Two", " ", 
    RowBox[{"arguments", ":", " ", 
     RowBox[{"convert", " ", "to", " ", "TraceProductDummy1"}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy", "[", 
     RowBox[{"expr_", ",", "x_"}], "]"}], ":=", 
    RowBox[{"TraceProductDummy1", "[", 
     RowBox[{
      RowBox[{"Expand", "[", "expr", "]"}], ",", "x"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TraceProductDummy1", " ", "with", " ", "two", " ", 
    RowBox[{"arguments", ":", " ", 
     RowBox[{"expand", " ", 
      RowBox[{"Plus", "/", "List"}], " ", "and", " ", "convert", " ", "to", 
      " ", "three", " ", "arguments"}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr_Plus", ",", "x_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"TraceProductDummy", "[", 
      RowBox[{"#", ",", "x"}], "]"}], "&"}], "/@", "expr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr_List", ",", "x_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"TraceProductDummy", "[", 
      RowBox[{"#", ",", "x"}], "]"}], "&"}], "/@", "expr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy1", "[", 
     RowBox[{"expr_", ",", "x_"}], "]"}], ":=", 
    RowBox[{"TraceProductDummy1", "[", 
     RowBox[{"expr", ",", "x", ",", 
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{"#1", ",", 
           RowBox[{"VBundleIndexQ", "[", "#2", "]"}]}], "]"}], "&"}], ",", 
        RowBox[{"IndexName", "/@", 
         RowBox[{"FindDummyIndices", "[", "expr", "]"}]}], ",", 
        "$SumVBundles"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TraceProductDummy1", " ", "with", " ", "three", " ", 
    RowBox[{"arguments", ":", " ", "index"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr_", ",", "index_Symbol", ",", "dummies_IndexList"}], "]"}], ":=", 
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr", ",", "index", ",", 
     RowBox[{"MemberQ", "[", 
      RowBox[{"dummies", ",", "index"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr_", ",", "index_Symbol", ",", "False"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"TraceProductDummy", "::", "noindex"}], ",", "index"}], "]"}], 
     ";", "expr"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy1", "[", 
     RowBox[{"expr_", ",", "index_Symbol", ",", "True"}], "]"}], ":=", 
    RowBox[{"Plus", "@@", 
     RowBox[{"ReplaceIndex", "[", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"index", "\[Rule]", "#"}], ",", 
           RowBox[{
            RowBox[{"-", "index"}], "\[Rule]", 
            RowBox[{"-", "#"}]}]}], "}"}], "&"}], "/@", 
        RowBox[{"DummyIn", "/@", 
         RowBox[{"List", "@@", 
          RowBox[{"Last", "[", 
           RowBox[{"SplittingsOfVBundle", "@", 
            RowBox[{"VBundleOfIndex", "@", "index"}]}], "]"}]}]}]}]}], 
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TraceProductDummy1", " ", "with", " ", "three", " ", 
    RowBox[{"arguments", ":", " ", "list"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"VBundle", "[", "vb_", "]"}], ",", "x___"}], "}"}], ",", 
     "dummies_IndexList"}], "]"}], ":=", 
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{"Select", "[", 
       RowBox[{"dummies", ",", 
        RowBox[{"VBundleIndexQ", "[", "vb", "]"}]}], "]"}], "~", "Join", "~", 
      
      RowBox[{"IndexList", "[", "x", "]"}]}], ",", "dummies"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"IndexList", "[", 
      RowBox[{"index_Symbol", ",", "x___"}], "]"}], ",", 
     "dummies_IndexList"}], "]"}], ":=", 
   RowBox[{"TraceProductDummy1", "[", 
    RowBox[{
     RowBox[{"TraceProductDummy1", "[", 
      RowBox[{"expr", ",", "index", ",", "dummies"}], "]"}], ",", 
     RowBox[{"IndexList", "[", "x", "]"}], ",", 
     RowBox[{"DeleteCases", "[", 
      RowBox[{"dummies", ",", "index"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy1", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"IndexList", "[", "]"}], ",", "dummies_IndexList"}], "]"}], ":=", 
    RowBox[{"Expand", "[", "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"TraceProductDummy1", " ", "with", " ", "three", " ", 
    RowBox[{"arguments", ":", " ", 
     RowBox[{"other", " ", "cases"}]}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TraceProductDummy1", "[", 
     RowBox[{"_", ",", "x_", ",", "_"}], "]"}], ":=", 
    RowBox[{"Throw", "[", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"TraceProductDummy", "::", "noindex"}], ",", "x"}], "]"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"TraceProductDummy", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TraceProductDummy", "]"}], ";"}]}], "Input",
 Evaluatable->False,ExpressionUUID->"939cf3fe-ffcd-4a40-b352-ad8b5f20235b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"New symbol created: \"\>", 
   "\[InvisibleSpace]", "\<\"TraceProductDummy1\"\>", 
   "\[InvisibleSpace]", "\<\", Context: \"\>", 
   "\[InvisibleSpace]", "\<\"xAct`xTensor`Private`\"\>"}],
  SequenceForm[
  "New symbol created: ", "TraceProductDummy1", ", Context: ", 
   "xAct`xTensor`Private`"],
  Editable->
   False]], "Print",ExpressionUUID->"48f4ea24-92b4-4245-9f96-2add727706e3"]
}, Open  ]],

Cell["Examples:", \
"Text",ExpressionUUID->"9f242ada-896b-4fe8-8171-9499defe4b6d"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"fbcce4bc-5641-4f93-915c-9c3e1f317641"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraceProductDummy", "[", 
  "]"}]], "Input",ExpressionUUID->"64c0a243-87d3-4094-83e1-2ffe16ec419a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"TraceProductDummy", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(TraceProductDummy\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; \[NoBreak]\\!\\(1\\)\[NoBreak] or \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`TraceProductDummy::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"72523232-761f-4442-9977-e631f29b71fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TraceProductDummy", "[", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], 
  "]"}]], "Input",ExpressionUUID->"40eaf701-ed42-41f5-987a-22683f7ebe6e"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"TraceProductDummy", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(TraceProductDummy\\)\[NoBreak] called with \
\[NoBreak]\\!\\(4\\)\[NoBreak] arguments; \[NoBreak]\\!\\(1\\)\[NoBreak] or \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`TraceProductDummy::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"9ad644e0-72fc-4dd4-819c-b145bbf6cf86"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"UU", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"d3f3fdf8-7641-49cf-93be-5ba5ff0a312e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"UU", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`UU[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"29d91513-8de4-4628-8f1a-a70e57434fec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"Mprod", ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "alpha", ",", "beta", ",", "mu", ",", "nu", ",", "sigma", ",", "lambda", 
     ",", "rho", ",", "eta"}], "}"}], ",", "omega"}], 
  "]"}]], "Input",ExpressionUUID->"6c4f7bf2-2301-4305-915f-8c287f6ec0ea"],

Cell[CellGroupData[{

Cell[BoxData["\<\"** DefManifold (legacy): Ultraindex omega converted into \
normal index.\"\>"], \
"Print",ExpressionUUID->"6a06408a-2e8c-41c5-a581-95287c2c0bc5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "Mprod", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`Mprod, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"143d25c0-352b-4b72-9984-4722d9d70fda"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", 
   "TangentMprod", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentMprod, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3cf34acd-79af-41bb-a69e-01e8962a0529"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mprod"}]], "Input",ExpressionUUID->"1939a736-03c1-467d-9e6c-255414694d0e"],

Cell[CellGroupData[{

Cell["Global`Mprod", "Print", "PrintUsage",
 CellTags->
  "Info3578673001-5338953",ExpressionUUID->"90c5d04b-c41d-48ef-97eb-\
bd8f573be231"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Mprod", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "Mprod", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "Mprod", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Mprod", "]"}], "^=", "\<\"Mprod\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", "\[Times]", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "M2"}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "S2"}], "]"}], "=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Mprod],
  Editable->False]], "Print",
 CellTags->
  "Info3578673001-5338953",ExpressionUUID->"be263781-40de-49d7-81b7-\
3fbf085c75a0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "TangentMprod"}]], \
"Input",ExpressionUUID->"a31423c9-9f05-4736-a048-dc59262673e6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[DoubleStruckCapitalT]Mprod",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TangentMprod,
  Editable->False]], "Print", "PrintUsage",
 CellTags->
  "Info3578673003-5338953",ExpressionUUID->"dc5a4eb2-d2be-4092-8cc3-\
ed8dba162615"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", 
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "Mprod"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox[
           RowBox[{"Dagger", "[", 
            InterpretationBox[
             StyleBox["\[DoubleStruckCapitalT]Mprod",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`TangentMprod,
             Editable->False], "]"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Dagger[$CellContext`TangentMprod],
          Editable->False], "^=", 
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DefInfo", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"vbundle\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IndicesOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "alpha", ",", "beta", ",", "mu", ",", "nu", ",", "sigma", ",", 
             "lambda", ",", "rho", ",", "eta", ",", "omega"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"LastIndex", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"omega", ",", "1"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MasterOf", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "Mprod"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"MetricsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], 
         "^=", "\<\"\[DoubleStruckCapitalT]Mprod\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfVBundle", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False], "\[CirclePlus]", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "}"}]}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False], "/:", 
         RowBox[{"SubvbundleQ", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]Mprod",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentMprod,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]M2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentM2,
            Editable->False]}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{
         InterpretationBox[
          StyleBox["\[DoubleStruckCapitalT]Mprod",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`TangentMprod,
          Editable->False], "/:", 
         RowBox[{"SubvbundleQ", "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]Mprod",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentMprod,
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["\[DoubleStruckCapitalT]S2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`TangentS2,
            Editable->False]}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VBundleQ", "[", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "]"}], "^=", "True"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TangentMprod],
  Editable->False]], "Print",
 CellTags->
  "Info3578673003-5338953",ExpressionUUID->"5979877a-38e1-404a-b576-\
bf84b2c38677"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "mu", "]"}], ",", "Mprod"}], 
  "]"}]], "Input",ExpressionUUID->"ce74ef35-bb28-4e23-9a58-016b97a9b7f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "mu", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`mu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"fcf650da-00c6-49c0-8815-5acb67ee4437"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "mu", "]"}], ",", "Mprod"}], 
  "]"}]], "Input",ExpressionUUID->"3217d310-a77e-4444-a4d7-d19eb7fec843"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "mu", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[$CellContext`mu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"724b1183-9250-4abe-9873-ba6e8a8fcf01"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TraceProductDummy", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"w", "[", "mu", "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "mu"}], "]"}]}], ",", "mu"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"38eb00d5-3907-4c60-8f3a-2020b5a49971"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"a"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"a"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[$CellContext`a],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[$CellContext`A],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"e37f344c-498e-4ae8-8e74-aba9a55a9fa7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TraceProductDummy", "[", 
   RowBox[{
    RowBox[{"v", "[", "mu", "]"}], 
    RowBox[{"w", "[", 
     RowBox[{"-", "mu"}], "]"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"v", "[", "nu", "]"}], 
       RowBox[{"v", "[", 
        RowBox[{"-", "nu"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"w", "[", "lambda", "]"}], 
       RowBox[{"w", "[", 
        RowBox[{"-", "lambda"}], "]"}]}]}], ")"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"ff57ce04-88fe-4150-b735-cbf474382984"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"a"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`a],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"a"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`a],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {" "},
              {"b"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[-$CellContext`b],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {"b"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[$CellContext`b],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {" "},
              {"B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[-$CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {"B"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[$CellContext`B],
       Editable->False]}]}], ")"}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {" "},
           {"c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[-$CellContext`c],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"a"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`a],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"a"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`a],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {" "},
              {"A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[-$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"A"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`v[$CellContext`A],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {" "},
              {"b"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[-$CellContext`b],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {"b"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[$CellContext`b],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {" "},
              {"B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[-$CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"w", 
           StyleBox[GridBox[{
              {"B"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`w[$CellContext`B],
       Editable->False]}]}], ")"}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"w", 
        StyleBox[GridBox[{
           {" "},
           {"C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[-C],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"bc93bb79-5ac8-4b97-ba6c-b7538604fd18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TraceProductDummy", "[", 
   RowBox[{
    RowBox[{"v", "[", 
     RowBox[{"-", "mu"}], "]"}], ",", 
    RowBox[{"w", "[", 
     RowBox[{"mu", ",", "nu"}], "]"}], ",", 
    RowBox[{"v", "[", 
     RowBox[{"-", "nu"}], "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"175f2603-670f-42c0-afff-b5f7561a6237"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"TraceProductDummy", "::", "argt"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(TraceProductDummy\\)\[NoBreak] called with \
\[NoBreak]\\!\\(3\\)\[NoBreak] arguments; \[NoBreak]\\!\\(1\\)\[NoBreak] or \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments are expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argt\\\", \
ButtonNote -> \\\"xAct`xTensor`TraceProductDummy::argt\\\"]\\)\"\>"}]], \
"Message", "MSG",ExpressionUUID->"d151fd10-a552-41c6-b0f7-47eeab747f61"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "w", 
  "]"}]], "Input",ExpressionUUID->"722cf5b3-d5a7-4197-aa13-1504ae8d480b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"cfde746e-1805-4aed-9d47-858d7f2fefaa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "v", 
  "]"}]], "Input",ExpressionUUID->"66a05785-b4f2-40cc-b892-c4dd771638e4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"ce166d3c-f0cc-41a3-ad35-bb9983b83af3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "Mprod", 
  "]"}]], "Input",ExpressionUUID->"af202920-90d6-486c-b7ee-4c7af4283437"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]Mprod",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentMprod,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentMprod],
  Editable->
   False]], "Print",ExpressionUUID->"5c6ac7db-d72a-4887-8565-4afbc4ea5fa9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Mprod"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`Mprod],
  Editable->
   False]], "Print",ExpressionUUID->"0fd43cfe-2a53-4b9f-a6e4-a51c4a7a19b2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mprod"}]], "Input",ExpressionUUID->"4f50c104-42aa-4c3b-b419-1faf52e2f95b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"Mprod\\\"\\)\[NoBreak] not found. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/notfound\\\", \
ButtonNote -> \\\"Information::notfound\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"626c055c-a083-4900-8afd-3e659a185208"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "M2"}]], "Input",ExpressionUUID->"ec5b9371-40ee-42d9-a0a6-248d63203e67"],

Cell[CellGroupData[{

Cell["Global`M2", "Print", "PrintUsage",
 CellTags->
  "Info3578673005-5338953",ExpressionUUID->"f1379b7a-7eef-4807-ac50-\
987760bd50a3"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "M2", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "M2", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "M2", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "M2", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "M2", "]"}], "^=", "\<\"M2\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "M2", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]M2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentM2,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "M2", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VisitorsOf", "[", "M2", "]"}], "^=", 
         RowBox[{"{", "UU", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`M2],
  Editable->False]], "Print",
 CellTags->
  "Info3578673005-5338953",ExpressionUUID->"ff339543-715c-4991-8de7-\
46356dba0ea6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "UU", 
  "]"}]], "Input",ExpressionUUID->"25d4edec-fec3-4f1d-81ef-a6942f1ef078"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "UU"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`UU],
  Editable->
   False]], "Print",ExpressionUUID->"945fb6e0-154d-4a55-b57d-c6f96dcd6e01"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"b4ca1e5d-3023-4d67-ac19-aa8f3a49fe38"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"f$314019\"\>", ",", "\<\"f$314025\"\>", 
     ",", "\<\"f$314029\"\>", ",", "\<\"f$314033\"\>", 
     ",", "\<\"G$314018\"\>", ",", "\<\"G$314024\"\>", 
     ",", "\<\"G$314028\"\>", ",", "\<\"G$314032\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "f$314019", "f$314025", "f$314029", "f$314033", "G$314018", "G$314024", 
    "G$314028", "G$314032"}],
  Editable->
   False]], "Print",ExpressionUUID->"74fdd20c-207e-4da5-b46d-b63714d261e0"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.6. Product metric", \
"Subsection",ExpressionUUID->"d5c0ab7c-68e5-467f-8263-869bfb453f09"],

Cell["\<\
In this case we do not worry about the dimension of the product manifold. \
That is, for example if the product manifold has dimension 3 we do not worry \
about the Weyl tensor, which is 0. We assume that this is consistently \
treated by the submanifolds.\
\>", "Text",ExpressionUUID->"b3afefbc-f3fb-4011-a5c2-fbb24aaeb840"],

Cell["\<\
QUESTION: Do we have to prepare this function for Christoffels not related to \
PD?
QUESTION: I think the treatment of densities is far from general.
Note that we do not check that the indices of the expression to decompose \
belong to submanifolds of the decomposed product manifold. In particular if \
we use indices of the product manifold the rules are repeatedly applied, \
without limit. A possible solution could be to define MetricScalar[metric, \
vbundle]=1 where metric is that of vbundle. These functions are not prepared \
for indices other than abstract indices: \
\>", "Text",ExpressionUUID->"f71aba4f-378a-4b78-b263-f0fb2533a685"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "::", "nonsum"}], "=", 
   "\"\<Non-sum vbundle. Structure: `1`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "::", "need"}], "=", 
   "\"\<Needed vbundles are: `1`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "::", "nometric"}], "=", 
   "\"\<VBundle `1` does not have a metric.\>\""}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"91af172a-e4c1-4432-8e88-9f351cbcfbfa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefProductMetric", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"PrintAs", "\[Rule]", "Identity"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ProtectNewSymbol", "\[RuleDelayed]", "$ProtectNewSymbols"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", "}"}], ",", "_", ",", "___"}], "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"DefProductMetric", "::", "empty"}], ",", "2", ",", 
     "\"\<pairs\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "[", 
    RowBox[{
     RowBox[{"_", "[", 
      RowBox[{
       RowBox[{"-", "_"}], ",", 
       RowBox[{"-", "_"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], "}"}], ",", "_", ",", "___"}], "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"DefProductMetric", "::", "error"}], ",", 
     "\"\<At least two pairs are needed.\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "[", 
    RowBox[{"metric_", ",", "scalars_", ",", "covd_", ",", 
     RowBox[{"covdsymbol", ":", 
      RowBox[{"{", 
       RowBox[{"_String", ",", "_String"}], "}"}]}], ",", "options___"}], 
    "]"}], ":=", 
   RowBox[{"DefProductMetric", "[", 
    RowBox[{"metric", ",", "scalars", ",", "covd", ",", 
     RowBox[{"SymbolOfCovD", "\[Rule]", "covdsymbol"}], ",", "options"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "[", 
    RowBox[{
     RowBox[{"metric_", "[", 
      RowBox[{
       RowBox[{"-", "ind1_"}], ",", 
       RowBox[{"-", "ind2_"}]}], "]"}], ",", 
     RowBox[{"scalars", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", "covd_", ",", 
     RowBox[{"options", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Catch", "@", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vbundle", "=", 
         RowBox[{"VBundleOfIndex", "[", "ind1", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"christoffel", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Christoffel", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"riemann", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Riemann", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ricci", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Ricci", ",", "covd"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"ricciscalar", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"RicciScalar", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"einstein", "=", 
         RowBox[{"GiveSymbol", "[", 
          RowBox[{"Einstein", ",", "covd"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"covdsymbol", "=", 
         RowBox[{"OptionValue", "[", 
          RowBox[{"DefCovD", ",", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"{", "options", "}"}], ",", 
             RowBox[{"rule_", "[", 
              RowBox[{"PrintAs", ",", "_"}], "]"}]}], "]"}], ",", 
           "SymbolOfCovD"}], "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"subvbundles", ",", "signdet", ",", "invD", ",", "prot"}], 
         "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"Generic", " ", "checks"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"subvbundles", "=", 
          RowBox[{"SplittingsOfVBundle", "[", "vbundle", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", " ", "[", 
          RowBox[{
           RowBox[{"subvbundles", "===", 
            RowBox[{"{", "}"}]}], " ", ",", 
           RowBox[{"Throw", "[", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefProductMetric", "::", "nonsum"}], ",", 
              "subvbundles"}], "]"}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"subvbundles", "=", 
          RowBox[{"List", "@@", 
           RowBox[{"Last", "[", "subvbundles", "]"}]}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Checks", " ", "on", " ", "vbundles", " ", "and", " ", "scalars"}], 
          " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{"Transpose", "[", "scalars", "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "=!=", 
            RowBox[{"Sort", "[", "subvbundles", "]"}]}], ",", 
           RowBox[{"Throw", "@", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"DefProductMetric", "::", "need"}], ",", 
              "subvbundles"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", 
               RowBox[{"MetricEndowedQ", "[", "#", "]"}]}], ",", 
              RowBox[{"Throw", "@", 
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"DefProductMetric", "::", "nometric"}], ",", "#"}], 
                "]"}]}]}], "]"}], "&"}], ",", "subvbundles"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"!", 
               RowBox[{"ScalarQ", "[", "#", "]"}]}], ",", 
              RowBox[{"Throw", "@", 
               RowBox[{"Message", "[", 
                RowBox[{
                 RowBox[{"DefProductMetric", "::", "unknown"}], ",", 
                 "\"\<scalar\>\"", ",", "#"}], "]"}]}]}], "]"}], "&"}], ",", 
           RowBox[{
            RowBox[{"Transpose", "[", "scalars", "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Define", " ", "metric"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"AppendToUnevaluated", "[", 
          RowBox[{"$ProductMetrics", ",", "metric"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"signdet", "=", 
          RowBox[{"Times", "@@", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"SignDetOfMetric", "[", 
               RowBox[{"FirstMetricOfVBundle", "[", 
                RowBox[{"#", ",", "True"}], "]"}], "]"}], "&"}], ",", 
             "subvbundles"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"DefMetric", "[", 
          RowBox[{"signdet", ",", 
           RowBox[{"metric", "[", 
            RowBox[{
             RowBox[{"-", "ind1"}], ",", 
             RowBox[{"-", "ind2"}]}], "]"}], ",", "covd", ",", "covdsymbol", 
           ",", "options", ",", 
           RowBox[{"CurvatureRelations", "\[Rule]", "False"}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Add", " ", "rules"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"prot", "=", 
          RowBox[{"Unprotect", "[", "metric", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"vb", "=", 
                RowBox[{"First", "[", "#", "]"}]}], ",", 
               RowBox[{"scal", "=", 
                RowBox[{"Last", "[", "#", "]"}]}]}], "}"}], ",", 
             RowBox[{"TagSet", "[", 
              RowBox[{"metric", ",", 
               RowBox[{"MetricScalar", "[", 
                RowBox[{"metric", ",", "vb"}], "]"}], ",", "scal"}], "]"}]}], 
            "]"}], "&"}], "/@", "scalars"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Protect", "[", 
          RowBox[{"Evaluate", "[", "prot", "]"}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Construct", " ", "rules"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ProductMetricRules", "[", 
           RowBox[{"metric", ",", "delta"}], "]"}], "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"delta", "[", 
             RowBox[{
              RowBox[{"a_", "?", "AIndexQ"}], ",", 
              RowBox[{"b_", "?", "AIndexQ"}]}], "]"}], "\[RuleDelayed]", 
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"aV", "=", 
                 RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", 
                RowBox[{"bV", "=", 
                 RowBox[{"VBundleOfIndex", "[", "b", "]"}]}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Which", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"aV", "===", "bV"}], ",", 
                RowBox[{"delta", "[", 
                 RowBox[{"a", ",", "b"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"aV", "=!=", "bV"}], ",", "0"}], 
               "\[IndentingNewLine]", "]"}]}], "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ProductMetricRules", "[", 
           RowBox[{"metric", ",", "Metric"}], "]"}], "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"metric", "[", 
             RowBox[{
              RowBox[{"a_", "?", "AIndexQ"}], ",", 
              RowBox[{"b_", "?", "AIndexQ"}]}], "]"}], "\[RuleDelayed]", 
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"aV", "=", 
                 RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", 
                RowBox[{"bV", "=", 
                 RowBox[{"VBundleOfIndex", "[", "b", "]"}]}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"aVmet", "=", 
                  RowBox[{"FirstMetricOfVBundle", "[", 
                   RowBox[{"aV", ",", "True"}], "]"}]}], "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Which", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"aV", "===", "bV"}], " ", "&&", " ", 
                   RowBox[{"DownIndexQ", "[", "a", "]"}], "&&", 
                   RowBox[{"DownIndexQ", "[", "b", "]"}]}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"MetricScalar", "[", 
                    RowBox[{"metric", ",", "aV"}], "]"}], "^", "2"}], 
                   RowBox[{"aVmet", "[", 
                    RowBox[{"a", ",", "b"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"aV", "===", "bV"}], " ", "&&", " ", 
                   RowBox[{"UpIndexQ", "[", "a", "]"}], "&&", 
                   RowBox[{"UpIndexQ", "[", "b", "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"1", "/", 
                    RowBox[{
                    RowBox[{"MetricScalar", "[", 
                    RowBox[{"metric", ",", "aV"}], "]"}], "^", "2"}]}], 
                   RowBox[{"aVmet", "[", 
                    RowBox[{"a", ",", "b"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"aV", "===", "bV"}], ",", 
                  RowBox[{"aVmet", "[", 
                   RowBox[{"a", ",", "b"}], "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"aV", "=!=", "bV"}], ",", "0"}], 
                 "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
               "]"}]}], "]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ProductMetricRules", "[", 
           RowBox[{"metric", ",", "Christoffel"}], "]"}], "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"christoffel", "[", 
             RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"With", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"aV", "=", 
                  RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", 
                 RowBox[{"bV", "=", 
                  RowBox[{"VBundleOfIndex", "[", "b", "]"}]}], ",", 
                 RowBox[{"cV", "=", 
                  RowBox[{"VBundleOfIndex", "[", "c", "]"}]}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"aVmet", "=", 
                    RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"aV", ",", "True"}], "]"}]}], ",", 
                   RowBox[{"bVmet", "=", 
                    RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"bV", ",", "True"}], "]"}]}], ",", 
                   RowBox[{"cVmet", "=", 
                    RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"cV", ",", "True"}], "]"}]}]}], "}"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Module", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"chra", ",", "da", ",", "db", ",", "dc", ",", 
                    RowBox[{"sc", "=", 
                    RowBox[{"Function", "[", 
                    RowBox[{"MetricScalar", "[", 
                    RowBox[{"metric", ",", "#"}], "]"}], "]"}]}]}], "}"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"chra", "=", 
                    RowBox[{"Christoffel", "[", 
                    RowBox[{"CovDOfMetric", "@", "aVmet"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"da", "=", 
                    RowBox[{"DummyIn", "[", "aV", "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"db", "=", 
                    RowBox[{"DummyIn", "[", "bV", "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"dc", "=", 
                    RowBox[{"DummyIn", "[", "cV", "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Which", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"aV", "===", "bV"}], " ", "&&", 
                    RowBox[{"bV", "===", "cV"}]}], ",", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", 
                    RowBox[{"-", "da"}]}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "db"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"c", ",", "dc"}], "]"}], 
                    RowBox[{"chra", "[", 
                    RowBox[{"da", ",", 
                    RowBox[{"-", "db"}], ",", 
                    RowBox[{"-", "dc"}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"aV", "=!=", "bV"}], "&&", 
                    RowBox[{"bV", "===", "cV"}]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "c"}], "]"}]}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "da"}], "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"CovDOfMetric", "[", "aVmet", "]"}], "[", 
                    RowBox[{"-", "da"}], "]"}], "[", 
                    RowBox[{"sc", "[", "bV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "bV", "]"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"aV", "===", "bV"}], "&&", 
                    RowBox[{"aV", "=!=", "cV"}]}], ",", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "b"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"c", ",", "dc"}], "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"CovDOfMetric", "[", "cVmet", "]"}], "[", 
                    RowBox[{"-", "dc"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"aV", "===", "cV"}], "&&", 
                    RowBox[{"aV", "=!=", "bV"}]}], ",", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "db"}], "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"CovDOfMetric", "[", "bVmet", "]"}], "[", 
                    RowBox[{"-", "db"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"aV", "=!=", "bV"}], "&&", 
                    RowBox[{"bV", "=!=", "cV"}], "&&", 
                    RowBox[{"aV", "=!=", "cV"}]}], ",", "0"}], 
                    "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
                  "]"}]}], "]"}]}], "]"}], "/;", 
             RowBox[{"FreeQ", "[", 
              RowBox[{
               RowBox[{"VBundleOfIndex", "/@", 
                RowBox[{"{", 
                 RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], ",", "vbundle"}],
               "]"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ProductMetricRules", "[", 
           RowBox[{"metric", ",", "CovD"}], "]"}], "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"covd", "[", "a_", "]"}], "[", "expr1_", "]"}], 
            "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"aV", "=", 
                  RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", "aVQ", 
                 ",", "cda", ",", "chra", ",", "da", ",", "dda", ",", 
                 RowBox[{"dummy", "=", 
                  RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ",", 
                 RowBox[{"inds", "=", 
                  RowBox[{"List", "@@", 
                   RowBox[{"FindFreeIndices", "[", "expr1", "]"}]}]}]}], 
                "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"aVQ", "=", 
                 RowBox[{"VBundleIndexQ", "[", "aV", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"cda", "=", 
                 RowBox[{"CovDOfMetric", "[", 
                  RowBox[{"FirstMetricOfVBundle", "[", 
                   RowBox[{"aV", ",", "True"}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"chra", "=", 
                 RowBox[{"Christoffel", "[", "cda", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"da", "=", 
                 RowBox[{"DummyIn", "[", "aV", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"dda", "=", 
                 RowBox[{"DummyIn", "[", "aV", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"metric", "[", 
                  RowBox[{"a", ",", "dda"}], "]"}], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"cda", "[", 
                    RowBox[{"-", "dda"}], "]"}], "[", "expr1", "]"}], "+", 
                   "\[IndentingNewLine]", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"TraceProductDummy", "[", "\[IndentingNewLine]", 
                    RowBox[{"Plus", "@@", 
                    RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"christoffel", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"-", "dda"}], ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"expr1", ",", 
                    RowBox[{"#", "\[Rule]", "dummy"}]}], "]"}]}], "&"}], ",", 
                    
                    RowBox[{"Select", "[", 
                    RowBox[{"inds", ",", "UpIndexQ"}], "]"}]}], "]"}]}], 
                    "]"}], "-", 
                    RowBox[{"Plus", "@@", 
                    RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"chra", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"-", "dda"}], ",", 
                    RowBox[{"-", "da"}]}], "]"}], 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"expr1", ",", 
                    RowBox[{"#", "\[Rule]", "da"}]}], "]"}]}], "&"}], ",", 
                    RowBox[{"Select", "[", 
                    RowBox[{"inds", ",", "aVQ"}], "]"}]}], "]"}]}]}], ")"}], 
                   "-", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"TraceProductDummy", "[", 
                    RowBox[{"Plus", "@@", 
                    RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"christoffel", "[", 
                    RowBox[{"dummy", ",", 
                    RowBox[{"-", "dda"}], ",", 
                    RowBox[{"-", "#"}]}], "]"}], 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"expr1", ",", 
                    RowBox[{
                    RowBox[{"-", "#"}], "\[Rule]", 
                    RowBox[{"-", "dummy"}]}]}], "]"}]}], "&"}], ",", 
                    RowBox[{"Select", "[", 
                    RowBox[{
                    RowBox[{"-", "inds"}], ",", "UpIndexQ"}], "]"}]}], 
                    "]"}]}], "]"}], "-", 
                    RowBox[{"Plus", "@@", 
                    RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"chra", "[", 
                    RowBox[{"da", ",", 
                    RowBox[{"-", "dda"}], ",", 
                    RowBox[{"-", "#"}]}], "]"}], 
                    RowBox[{"ReplaceIndex", "[", 
                    RowBox[{"expr1", ",", 
                    RowBox[{
                    RowBox[{"-", "#"}], "\[Rule]", 
                    RowBox[{"-", "da"}]}]}], "]"}]}], "&"}], ",", 
                    RowBox[{"Select", "[", 
                    RowBox[{
                    RowBox[{"-", "inds"}], ",", "aVQ"}], "]"}]}], "]"}]}]}], 
                    ")"}], "\[IndentingNewLine]", "-", 
                   RowBox[{
                    RowBox[{"WeightOf", "[", 
                    RowBox[{"expr1", ",", "AIndex"}], "]"}], " ", "expr1", 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{"TraceProductDummy", "[", 
                    RowBox[{
                    RowBox[{"christoffel", "[", 
                    RowBox[{"dummy", ",", 
                    RowBox[{"-", "dda"}], ",", 
                    RowBox[{"-", "dummy"}]}], "]"}], "-", 
                    RowBox[{"chra", "[", 
                    RowBox[{"da", ",", 
                    RowBox[{"-", "dda"}], ",", 
                    RowBox[{"-", "da"}]}], "]"}]}], "]"}], ")"}]}]}], 
                  ")"}]}]}]}], "]"}], "/;", 
             RowBox[{"FreeQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"VBundleOfIndex", "[", "a", "]"}], "}"}], ",", 
               "vbundle"}], "]"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ProductMetricRules", "[", 
           RowBox[{"metric", ",", "Riemann"}], "]"}], "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"riemann", "[", 
              RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], 
             "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"Module", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"aV", "=", 
                   RowBox[{"VBundleOfIndex", "[", "a", "]"}]}], ",", 
                  RowBox[{"bV", "=", 
                   RowBox[{"VBundleOfIndex", "[", "b", "]"}]}], ",", 
                  RowBox[{"cV", "=", 
                   RowBox[{"VBundleOfIndex", "[", "c", "]"}]}], ",", 
                  RowBox[{"dV", "=", 
                   RowBox[{"VBundleOfIndex", "[", "d", "]"}]}], ",", "da", 
                  ",", " ", "db", ",", "dc", ",", "dd", ",", "dalpha", ",", 
                  "dbeta", ",", 
                  RowBox[{"sc", "=", 
                   RowBox[{"Function", "[", 
                    RowBox[{"MetricScalar", "[", 
                    RowBox[{"metric", ",", "#"}], "]"}], "]"}]}], ",", "cda", 
                  ",", "cdb", ",", "cdc", ",", "cdd", ",", "riema"}], "}"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"da", "=", 
                  RowBox[{"DummyIn", "[", "aV", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"db", "=", 
                  RowBox[{"DummyIn", "[", "bV", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"dc", "=", 
                  RowBox[{"DummyIn", "[", "cV", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"dd", "=", 
                  RowBox[{"DummyIn", "[", "dV", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"dalpha", "=", 
                  RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"dbeta", "=", 
                  RowBox[{"DummyIn", "[", "vbundle", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"cda", "=", 
                  RowBox[{"CovDOfMetric", "@", 
                   RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"aV", ",", "True"}], "]"}]}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"cdb", "=", 
                  RowBox[{"CovDOfMetric", "@", 
                   RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"bV", ",", "True"}], "]"}]}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"cdc", "=", 
                  RowBox[{"CovDOfMetric", "@", 
                   RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"cV", ",", "True"}], "]"}]}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"cdd", "=", 
                  RowBox[{"CovDOfMetric", "@", 
                   RowBox[{"FirstMetricOfVBundle", "[", 
                    RowBox[{"dV", ",", "True"}], "]"}]}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"riema", "=", 
                  RowBox[{"Riemann", "[", "cda", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                 "Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{"Riemann", "[", 
                    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], " ", 
                   "*)"}], "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                   "aV", "===", "bV", " ", "===", "cV", " ", "===", "dV"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", 
                    RowBox[{"-", "da"}]}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "db"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"c", ",", "dc"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"d", ",", "dd"}], "]"}], 
                    RowBox[{"riema", "[", 
                    RowBox[{"da", ",", 
                    RowBox[{"-", "db"}], ",", 
                    RowBox[{"-", "dc"}], ",", 
                    RowBox[{"-", "dd"}]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "d"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "d"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "c"}], "]"}]}]}], ")"}], "$RiemannSign",
                     " ", 
                    RowBox[{
                    RowBox[{"TraceProductDummy", "[", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"dalpha", ",", "dbeta"}], "]"}], 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dalpha"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dbeta"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}]}], "]"}], "/", 
                    RowBox[{
                    RowBox[{"sc", "[", "aV", "]"}], "^", "2"}]}]}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", " ", 
                    RowBox[{"Riemann", "[", 
                    RowBox[{"a", ",", "b", ",", "C", ",", "D"}], "]"}], " ", 
                    "*)"}], "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"aV", "===", "bV"}], "&&", 
                    RowBox[{"cV", "===", "dV"}]}], ",", " ", "0", ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", " ", 
                    RowBox[{"Riemann", "[", 
                    RowBox[{"a", ",", "B", ",", "C", ",", "D"}], "]"}], " ", 
                    "*)"}], "\[IndentingNewLine]", 
                   RowBox[{"bV", "===", "cV", "===", "dV"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "da"}], "]"}]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"cda", "[", 
                    RowBox[{"-", "da"}], "]"}], "[", 
                    RowBox[{"sc", "[", "bV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "bV", "]"}]}], "$RiemannSign", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"c", ",", "dc"}], "]"}], 
                    RowBox[{
                    RowBox[{"cdc", "[", 
                    RowBox[{"-", "dc"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "d"}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"d", ",", "dd"}], "]"}], 
                    RowBox[{
                    RowBox[{"cdd", "[", 
                    RowBox[{"-", "dd"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "c"}], "]"}]}]}], ")"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"aV", "===", "cV", "===", "dV"}], ",", 
                   RowBox[{"-", 
                    RowBox[{"riemann", "[", 
                    RowBox[{"b", ",", "a", ",", "c", ",", "d"}], "]"}]}], ",",
                    "\[IndentingNewLine]", 
                   RowBox[{"aV", "===", "bV", "===", "dV"}], ",", 
                   RowBox[{"riemann", "[", 
                    RowBox[{"c", ",", "d", ",", "a", ",", "b"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"aV", "===", "bV", "===", "cV"}], ",", 
                   RowBox[{"-", 
                    RowBox[{"riemann", "[", 
                    RowBox[{"d", ",", "c", ",", "a", ",", "b"}], "]"}]}], ",",
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", " ", 
                    RowBox[{"Riemann", "[", 
                    RowBox[{"a", ",", "B", ",", "c", ",", "D"}], "]"}], " ", 
                    "*)"}], "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"aV", "===", "cV"}], "&&", 
                    RowBox[{"bV", "===", "dV"}]}], ",", 
                   RowBox[{"$RiemannSign", 
                    RowBox[{"(", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "d"}], "]"}]}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "da"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"c", ",", "dc"}], "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdc", "[", 
                    RowBox[{"-", "dc"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"cda", "[", 
                    RowBox[{"-", "da"}], "]"}], "[", 
                    RowBox[{"sc", "[", "bV", "]"}], "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "bV", "]"}]}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "db"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"d", ",", "dd"}], "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdb", "[", 
                    RowBox[{"-", "db"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"cdd", "[", 
                    RowBox[{"-", "dd"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}]}], "-", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "d"}], "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"TraceProductDummy", "[", 
                    RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"dalpha", ",", "dbeta"}], "]"}], 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dalpha"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], 
                    RowBox[{
                    RowBox[{"covd", "[", 
                    RowBox[{"-", "dbeta"}], "]"}], "[", 
                    RowBox[{"sc", "[", "bV", "]"}], "]"}]}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}], "/", 
                    RowBox[{"sc", "[", "bV", "]"}]}]}]}], ")"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"aV", "===", "dV"}], "&&", 
                    RowBox[{"bV", "===", "cV"}]}], ",", 
                   RowBox[{"-", 
                    RowBox[{"riemann", "[", 
                    RowBox[{"a", ",", "b", ",", "d", ",", "c"}], "]"}]}], ",",
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", " ", 
                    RowBox[{"Riemann", "[", 
                    RowBox[{"a", ",", "B", ",", "c", ",", "delta"}], "]"}], 
                    " ", "*)"}], "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"aV", "===", "cV"}], "&&", 
                    RowBox[{"aV", "=!=", "bV"}], "&&", 
                    RowBox[{"aV", "=!=", "dV"}], "&&", 
                    RowBox[{"bV", "=!=", "dV"}]}], ",", 
                   RowBox[{
                    RowBox[{"metric", "[", 
                    RowBox[{"a", ",", "c"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"b", ",", "db"}], "]"}], 
                    RowBox[{"metric", "[", 
                    RowBox[{"d", ",", "dd"}], "]"}], "$RiemannSign", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"cdb", "[", 
                    RowBox[{"-", "db"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"cdd", "[", 
                    RowBox[{"-", "dd"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "]"}]}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdb", "[", 
                    RowBox[{"-", "db"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdd", "[", 
                    RowBox[{"-", "dd"}], "]"}], "[", 
                    RowBox[{"sc", "[", "bV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "bV", "]"}]}]}], "+", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdd", "[", 
                    RowBox[{"-", "dd"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdb", "[", 
                    RowBox[{"-", "db"}], "]"}], "[", 
                    RowBox[{"sc", "[", "dV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "dV", "]"}]}]}], "-", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdd", "[", 
                    RowBox[{"-", "dd"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}], " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"cdb", "[", 
                    RowBox[{"-", "db"}], "]"}], "[", 
                    RowBox[{"sc", "[", "aV", "]"}], "]"}], "/", 
                    RowBox[{"sc", "[", "aV", "]"}]}]}]}], ")"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"aV", "===", "dV"}], "&&", 
                    RowBox[{"aV", "=!=", "bV"}], "&&", 
                    RowBox[{"aV", "=!=", "cV"}], "&&", 
                    RowBox[{"bV", "=!=", "cV"}]}], ",", 
                   RowBox[{"-", 
                    RowBox[{"riemann", "[", 
                    RowBox[{"a", ",", "b", ",", "d", ",", "c"}], "]"}]}], ",",
                    "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"bV", "===", "cV"}], "&&", 
                    RowBox[{"bV", "=!=", "aV"}], "&&", 
                    RowBox[{"bV", "=!=", "dV"}], "&&", 
                    RowBox[{"aV", "=!=", "dV"}]}], ",", 
                   RowBox[{"-", 
                    RowBox[{"riemann", "[", 
                    RowBox[{"b", ",", "a", ",", "c", ",", "d"}], "]"}]}], ",",
                    "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"bV", "===", "dV"}], "&&", 
                    RowBox[{"bV", "=!=", "aV"}], "&&", 
                    RowBox[{"bV", "=!=", "cV"}], "&&", 
                    RowBox[{"aV", "=!=", "cV"}]}], ",", 
                   RowBox[{"riemann", "[", 
                    RowBox[{"b", ",", "a", ",", "d", ",", "c"}], "]"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", " ", 
                    RowBox[{"Other", " ", "cases"}], " ", "*)"}], 
                   "\[IndentingNewLine]", "True", ",", "0"}], "]"}]}]}], 
               "\[IndentingNewLine]", "]"}], "/;", 
              RowBox[{"FreeQ", "[", 
               RowBox[{
                RowBox[{"VBundleOfIndex", "/@", 
                 RowBox[{"{", 
                  RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], ",", 
                "vbundle"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ricci", "[", 
              RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"dummy", "=", 
                 RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
               RowBox[{"$RicciSign", " ", 
                RowBox[{"TraceProductDummy", "[", 
                 RowBox[{"riemann", "[", 
                  RowBox[{"dummy", ",", "a", ",", 
                   RowBox[{"-", "dummy"}], ",", "b"}], "]"}], "]"}]}]}], 
              "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ricciscalar", "[", "]"}], "\[RuleDelayed]", 
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"dummy", "=", 
                 RowBox[{"DummyIn", "[", "vbundle", "]"}]}], "}"}], ",", 
               RowBox[{"TraceProductDummy", "[", 
                RowBox[{"ricci", "[", 
                 RowBox[{"dummy", ",", 
                  RowBox[{"-", "dummy"}]}], "]"}], "]"}]}], "]"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"einstein", "[", 
              RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"ricci", "[", 
               RowBox[{"a", ",", "b"}], "]"}], "-", 
              RowBox[{
               RowBox[{
                RowBox[{"ricciscalar", "[", "]"}], "/", "2"}], 
               RowBox[{"metric", "[", 
                RowBox[{"a", ",", "b"}], "]"}]}]}]}]}], "\[IndentingNewLine]",
            "\[IndentingNewLine]", "}"}]}], ";"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "[", 
    RowBox[{"metric_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}]}], "}"}], ",", "_", ",", "_", 
     ",", "___"}], "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"DefProductMetric", "::", "invalid"}], ",", "metric", ",", 
     "\"\<metric\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefProductMetric", "[", 
    RowBox[{
     RowBox[{"_", "[", 
      RowBox[{
       RowBox[{"-", "_"}], ",", 
       RowBox[{"-", "_"}]}], "]"}], ",", "scalars_", ",", "_", ",", "_", ",", 
     "___"}], "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"DefProductMetric", "::", "invalid"}], ",", "scalars", ",", 
     "\"\<list of pairs\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"DefProductMetric", ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Attributes", "[", "ProductMetricRules", "]"}], "=", 
   RowBox[{"{", "ReadProtected", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "DefProductMetric", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"MetricScalar", ",", "2"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "MetricScalar", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"071010d1-2e1e-4e8d-978d-fd74182de58e"],

Cell["\<\
QUESTION: ExpandProductMetric can only expand expressions with indices on the \
subvbundles, but not with indices on the product vbundle. It would give just \
wrong answers!\
\>", "Text",ExpressionUUID->"96beed18-b617-4d19-9e76-f7a5202a2f99"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ProductMetricRules", "[", "metric_", "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ProductMetricRules", "[", 
        RowBox[{"metric", ",", "#"}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{
       "delta", ",", "Metric", ",", "Christoffel", ",", "CovD", ",", 
        "Riemann"}], "}"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExpandProductMetric1", "[", "rules_", "]"}], "[", "expr_", "]"}],
    ":=", 
   RowBox[{"expr", "/.", "rules"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExpandProductMetric", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"metric_Symbol", "?", "MetricQ"}], ",", "object___"}], "]"}], ":=", 
   RowBox[{"CheckZeroDerivative", "@", 
    RowBox[{"FixedPoint", "[", 
     RowBox[{
      RowBox[{"ExpandProductMetric1", "[", 
       RowBox[{"ProductMetricRules", "[", 
        RowBox[{"metric", ",", "object"}], "]"}], "]"}], ",", "expr"}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExpandProductMetric", "[", 
    RowBox[{"expr_", ",", "list_List"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ExpandProductMetric", "[", 
       RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", "expr", ",", "list"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExpandProductMetric", "[", "expr_", "]"}], ":=", 
   RowBox[{"ExpandProductMetric", "[", 
    RowBox[{"expr", ",", "$ProductMetrics"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ExpandProductMetric", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ExpandProductMetric", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Attributes", "[", "ProductMetricRules", "]"}], "=", 
   RowBox[{"{", "ReadProtected", "}"}]}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"104616cd-29f9-47bd-b0de-1db0e81a30d7"]
}, Closed]],

Cell[CellGroupData[{

Cell["16.7. Examples", \
"Subsection",ExpressionUUID->"e9ea384d-763e-489d-ac1e-5acc45173277"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"be60a1c5-d7db-4c16-8659-fdfe6d4337ac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"Mprod", ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "alpha", ",", "beta", ",", "mu", ",", "nu", ",", "sigma", ",", "lambda", 
     ",", "rho", ",", "eta"}], "}"}], ",", "omega"}], 
  "]"}]], "Input",ExpressionUUID->"95e8318b-c9b3-4e3d-bf72-5b4c1e001dd8"],

Cell[CellGroupData[{

Cell[BoxData["\<\"** DefManifold (legacy): Ultraindex omega converted into \
normal index.\"\>"], \
"Print",ExpressionUUID->"db08c91b-7403-4600-bfbd-ed70916938d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefManifold", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"manifold \"\>", "\[InvisibleSpace]", "Mprod", 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefManifold, ": Defining ", 
   "manifold ", $CellContext`Mprod, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bedf23a0-19e1-417b-9c44-c2497757479d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefVBundle", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle \"\>", "\[InvisibleSpace]", 
   "TangentMprod", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefVBundle, ": Defining ", 
   "vbundle ", $CellContext`TangentMprod, ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d74e25e5-ca21-4abb-b515-88a77f105dcd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefProductMetric", "[", 
   RowBox[{
    RowBox[{"g4", "[", 
     RowBox[{
      RowBox[{"-", "mu"}], ",", 
      RowBox[{"-", "nu"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"TangentM2", ",", 
        RowBox[{"w", "[", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"TangentS2", ",", 
        RowBox[{"r", "[", "]"}]}], "}"}]}], "}"}], ",", "Cd4", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<;\>\"", ",", "\"\<\[CapitalXi]\>\""}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"3fa84ae5-b0c5-49fc-8284-323037683fd8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefProductMetric", "::", "nometric"}], "MessageName"], ":", 
  " ", "\<\"VBundle \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]M2\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], TangentM2, Rule[Editable, False]]\\)\[NoBreak] does not have a \
metric.\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ed48e593-8ae4-4d8b-b827-a8b7453b137f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CdM", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"41b47a1c-c64c-4f6f-b613-ca19085c48bd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`g[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3296c02f-c024-40fb-9f65-eed7ce9ad5fc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilong", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilong[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"6850772a-b125-4177-b6dd-a002bb1a90f0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"89db1c24-5ae8-4578-8f33-3ed6374d8488"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f3782e4e-47cc-413e-b059-41d285abd066"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4bbf0683-fd18-4e8c-8bab-28f17d42e16b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"9ba893f6-462a-4a3b-b1b4-30cf1768b945"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7b5cd7be-d0c1-477c-b482-0ea7df8e6da0"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"09a161f4-6a97-47a6-9e3d-19eb732ae484"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bdb5ad56-adfc-496f-a4a3-34922aade655"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"bf1bf5de-6a57-44b4-86dd-acf0b1714615"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5b9f4e89-9d38-4668-99cf-a79b23427179"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dd45a238-148a-4e46-9eec-2bb2a2e49589"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a98eddce-4e95-490c-9409-23c2e7a00587"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"949b60b4-6227-42eb-92e7-7416d2092057"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"bec0a97f-c33f-4a9a-a63c-e18668a9a539"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"81a0c4ee-00ce-4e74-bacb-625d697c0a3f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"0fbc24b5-ed9a-45e1-b1e0-c4ab5ef341f7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"b0e1893b-d981-44ad-8b34-8bd6abc99679"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"gamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], ",", "CdS", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<:\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[Gamma]\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"b0414650-8e47-49fb-929e-bf57e39c60ef"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gamma[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"59041089-d65d-4ed9-9665-1754240f3984"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilongamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilongamma[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"400ee103-4ed5-42cd-9360-9e525d06d491"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdS", "[", 
    RowBox[{"-", "a"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdS[-$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4be37305-9072-4b66-953e-684efcafb58e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdS[$CellContext`a, -$CellContext`b, -$CellContext`c], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4147eb17-f774-461d-9223-d8c43937c40d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdS[$CellContext`a, -$CellContext`b, \
-$CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b94a71f2-c50d-4399-bc3a-f17146e7250f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCdS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"12011576-d5df-430f-8086-e0cf6d027140"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCdS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ab8bca54-8357-4e13-8e4b-3f5e9da94337"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"14911185-b401-4f44-8c4c-3557399fee6b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCdS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7c928e7c-1386-434c-b075-498c87195e1e"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"7c6a51d7-1e3a-4662-bd93-fe0fc83a036d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d03d5ff7-0600-4070-a6a8-cc62c5e7fd5f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0543a7f4-ab6e-4eee-bef6-1a992eff6d18"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f0675e3b-9e26-4d13-96d0-abb47c0f948a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCdS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1f5a1cac-333d-4de3-a6c4-6415eaef89d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"c3ae3ddd-ffad-4b55-9101-11f4414c5aec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"777030fd-461d-4c88-b1de-26965260f948"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"acd22078-3dcc-4e6a-a110-4ab61946ba4e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgamma", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgamma[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"c1764239-e80c-43df-92c9-43d285ea07bd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefProductMetric", "[", 
   RowBox[{
    RowBox[{"g4", "[", 
     RowBox[{
      RowBox[{"-", "mu"}], ",", 
      RowBox[{"-", "nu"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"TangentM2", ",", 
        RowBox[{"w", "[", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"TangentS2", ",", 
        RowBox[{"r", "[", "]"}]}], "}"}]}], "}"}], ",", "Cd4", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"9e056339-03f6-43d5-82cf-2b92fe0259a9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"g4", "[", 
    RowBox[{
     RowBox[{"-", "mu"}], ",", 
     RowBox[{"-", "nu"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`g4[-$CellContext`mu, -$CellContext`nu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"22c159c9-10ef-4104-ad1b-6f86df676731"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilong4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilong4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"436e47f0-46e3-4748-8da0-8b038d6feabf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric \"\>", "\[InvisibleSpace]", 
   RowBox[{"Tetrag4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tetrametric ", 
   $CellContext`Tetrag4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7aa8a261-20e1-4bb2-8efa-680c183fca8f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric \"\>", "\[InvisibleSpace]", 
   RowBox[{"Tetrag4\[Dagger]", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tetrametric ", 
   $CellContext`Tetrag4\[Dagger][-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f97381c6-7470-4c67-b67d-214f98dd632d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"Cd4", "[", 
    RowBox[{"-", "mu"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`Cd4[-$CellContext`mu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"8855438d-c767-4657-8c0c-344a1a991d52"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCd4", "[", 
    RowBox[{"alpha", ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCd4[$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"47331833-b2fb-4ddb-ad1b-853b4dc27fe3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCd4", "[", 
    RowBox[{"alpha", ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCd4[$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"35e7b8f6-545c-412c-bd81-7c0b098fc206"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCd4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ef063085-3054-44b0-aa85-1a082be27340"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCd4[-$CellContext`alpha, -$CellContext`beta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c581da10-d3c5-40fc-b962-c39102a6eabf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCd4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCd4[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"94033a90-a3b6-4aa7-bcc3-85edf4e6e762"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Einstein tensor ", 
   $CellContext`EinsteinCd4[-$CellContext`alpha, -$CellContext`beta], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"8686759e-4bd5-48e6-93c0-1239577cf7db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "Weyl tensor ", 
   $CellContext`WeylCd4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bd71643e-dc09-4f65-beb6-b6850c676b84"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric TFRicci tensor ", 
   $CellContext`TFRicciCd4[-$CellContext`alpha, -$CellContext`beta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"df3c4bbf-d3be-4a69-9847-2409b6f2e427"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCd4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCd4[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c86b5f3f-81a2-41e6-9292-9c5649481c7f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"9f04f6aa-2247-4546-afba-a566e4bfab84"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"695fa26a-1387-49fd-9a6b-5c37095d9903"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"5c114306-864a-4897-b4f3-e30f52230490"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detg4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detg4[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"7a00104a-9f29-4b74-9d37-63bbe354855e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "g4", 
  "]"}]], "Input",ExpressionUUID->"29392e27-f6c4-408b-a79a-f5d73a668154"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detg4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detg4],
  Editable->
   False]], "Print",ExpressionUUID->"26df6ef5-2d8b-4797-b7a5-8a9668ed8298"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCd4],
  Editable->
   False]], "Print",ExpressionUUID->"b7fe5ef4-de90-4c3d-bf7d-19c1d208f7ad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Einstein tensor", " ", $CellContext`EinsteinCd4],
  Editable->
   False]], "Print",ExpressionUUID->"df4fffc8-8962-4c15-8256-4c12c412d606"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCd4],
  Editable->
   False]], "Print",ExpressionUUID->"894fc3d7-93b2-4777-9e51-bd6e3f8f962f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCd4],
  Editable->
   False]], "Print",ExpressionUUID->"6ae562b4-770d-4d7f-96d4-d4de30d12c77"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCd4],
  Editable->
   False]], "Print",ExpressionUUID->"1aed3ba4-2505-49f0-bdf3-2d4fd6d02844"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCd4],
  Editable->
   False]], "Print",ExpressionUUID->"7c93ffa4-ced5-426c-ac2b-dfedcbb27b01"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric TFRicci tensor",
    " ", $CellContext`TFRicciCd4],
  Editable->
   False]], "Print",ExpressionUUID->"5f048834-1926-4192-aae0-5e52c4828378"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCd4],
  Editable->
   False]], "Print",ExpressionUUID->"49e46a78-ad3f-430c-9e6c-2a863c23935f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCd4],
  Editable->
   False]], "Print",ExpressionUUID->"7a9db184-a293-4e19-b684-8a513e30dd69"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Cd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`Cd4],
  Editable->
   False]], "Print",ExpressionUUID->"287b1918-027d-4921-8c21-80a2baf07d89"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Tetrag4\[Dagger]"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tetrametric", 
   " ", $CellContext`Tetrag4\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"97d4d433-4466-4243-89cc-84cf00f10e48"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Tetrag4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tetrametric", 
   " ", $CellContext`Tetrag4],
  Editable->
   False]], "Print",ExpressionUUID->"d702c954-42c0-4739-bf9b-880f5253401e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilong4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilong4],
  Editable->
   False]], "Print",ExpressionUUID->"a866afa5-5cff-4a8a-8597-24d42164458e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "g4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`g4],
  Editable->
   False]], "Print",ExpressionUUID->"33a2882e-6e5f-412b-b1f7-8ceedd8f2b1d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "]"}], ",", "S2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], 
  "]"}]}], "Input",ExpressionUUID->"490c8375-d2af-416d-9aa3-a984ef352104"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3dd27a2d-aa65-40a0-921f-0ac7e85e3dea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"65593ac3-90a9-4acb-b271-687fd257b5de"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefProductMetric", "[", 
  RowBox[{
   RowBox[{"g4", "[", 
    RowBox[{
     RowBox[{"-", "mu"}], ",", 
     RowBox[{"-", "nu"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TangentM2", ",", 
       RowBox[{"w", "[", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"TangentS2", ",", 
       RowBox[{"r", "[", "]"}]}], "}"}]}], "}"}], ",", "Cd4", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a5c65375-9e14-488c-bc0f-81ad7c2dab2c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"g4", "[", 
    RowBox[{
     RowBox[{"-", "mu"}], ",", 
     RowBox[{"-", "nu"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`g4[-$CellContext`mu, -$CellContext`nu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"68a5c873-5550-4ecf-a2d5-46c04cccd03f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilong4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilong4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d8828467-e4f2-458c-8e83-b85317229b5d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric \"\>", "\[InvisibleSpace]", 
   RowBox[{"Tetrag4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tetrametric ", 
   $CellContext`Tetrag4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"47b18f4c-db29-43d7-bb7d-a9abbf2cbe85"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric \"\>", "\[InvisibleSpace]", 
   RowBox[{"Tetrag4\[Dagger]", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tetrametric ", 
   $CellContext`Tetrag4\[Dagger][-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"739ee3b4-f8a2-40a5-9ea0-63f8e4127e79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"Cd4", "[", 
    RowBox[{"-", "mu"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`Cd4[-$CellContext`mu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"508a4322-689c-4d59-b24d-01a406512f34"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCd4", "[", 
    RowBox[{"alpha", ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCd4[$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"087253af-af79-4afa-ada9-2a9432cc5573"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCd4", "[", 
    RowBox[{"alpha", ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCd4[$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e05bafaa-cfe7-4887-bf0d-99ccc876ac4b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCd4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b3abd46e-192f-4090-a0d7-b4fb10420848"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCd4[-$CellContext`alpha, -$CellContext`beta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"3b94557e-f9cb-4576-baf8-0553acc1e7b4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCd4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCd4[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4ac0b7e3-8c86-44b5-8dc0-fa1a5682104c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Einstein tensor ", 
   $CellContext`EinsteinCd4[-$CellContext`alpha, -$CellContext`beta], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"0be6c01f-c812-40d5-80d5-16271a506431"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "Weyl tensor ", 
   $CellContext`WeylCd4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b42ad5cb-5008-4141-8f8b-e4e0f22503ba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCd4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric TFRicci tensor ", 
   $CellContext`TFRicciCd4[-$CellContext`alpha, -$CellContext`beta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"be78c9e2-614a-4605-922c-51ee50ad52c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCd4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCd4[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9995dfff-5ec9-47e5-8d67-dd822c18d22b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"f9c23676-26d4-4f00-92b4-dd70988268e2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"e3008b13-cdfa-44f3-b519-0972029759ec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"b75a7360-5240-45c7-aaee-78165814b618"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detg4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detg4[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"797d5d4b-e6e6-430c-b621-ef5de228669f"]
}, Open  ]]
}, Open  ]],

Cell["Is this really what we want?", \
"Text",ExpressionUUID->"849278b4-32c3-4b45-bc8f-b4f41b5926db"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"DefProductMetric", "[", 
   RowBox[{
    RowBox[{"g4", "[", 
     RowBox[{
      RowBox[{"-", "mu"}], ",", 
      RowBox[{"-", "nu"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"TangentM2", ",", 
        RowBox[{"w", "[", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"TangentS2", ",", 
        RowBox[{"r", "[", "]"}]}], "}"}]}], "}"}], ",", "Cd4", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"3815bebf-287a-477e-9dab-397caaa56c4d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"DefMetric", "::", "old"}], "MessageName"], ":", 
  " ", "\<\"There are already metrics \[NoBreak]\\!\\({g4}\\)\[NoBreak] in \
vbundle \[NoBreak]\\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]Mprod\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], TangentMprod, Rule[Editable, False]]\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"99840ac4-6c8b-4beb-8161-3d06215bc842"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ValidateSymbol", "::", "protected"}], "MessageName"], ":", 
  " ", "\<\"Symbol \[NoBreak]\\!\\(\\\"g4\\\"\\)\[NoBreak] is \
\[NoBreak]\\!\\(\\\"Protected\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e990c901-3d34-418b-9914-8eaf22866bfc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Metrics"], \
"Input",ExpressionUUID->"6c23adca-aa72-4d39-8aba-896e82980bd3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"g", ",", "gamma", ",", "g4"}], 
  "}"}]], "Output",ExpressionUUID->"1888e4a0-679e-4ce4-bfbd-bb87c31510c0"]
}, Open  ]],

Cell["Examples:", \
"Text",ExpressionUUID->"b84006a9-d94c-408e-ac55-460f7f4b5159"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandProductMetric", "[", 
  RowBox[{"Outer", "[", 
   RowBox[{"delta", ",", 
    RowBox[{"{", 
     RowBox[{"A", ",", "a"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "b"}]}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"eabde725-f393-4df5-b51e-76a7e1620302"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"\[Delta]", 
          StyleBox[GridBox[{
             {"A", " "},
             {" ", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`delta[$CellContext`A, -$CellContext`B],
      Editable->False], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"\[Delta]", 
          StyleBox[GridBox[{
             {"a", " "},
             {" ", "b"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`delta[$CellContext`a, -$CellContext`b],
      Editable->False]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"a70a0cea-08b5-460e-b80b-6da0b8fb7ac6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandProductMetric", "[", 
  RowBox[{"Outer", "[", 
   RowBox[{"g4", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "a"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "b"}]}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"dbbc9621-d62a-4bcf-9749-fd99be7dbe48"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"g", 
           StyleBox[GridBox[{
              {" ", " "},
              {"A", "B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`g[-$CellContext`A, -$CellContext`B],
       Editable->False], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["w",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[],
        Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Gamma]", 
           StyleBox[GridBox[{
              {" ", " "},
              {"a", "b"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`gamma[-$CellContext`a, -$CellContext`b],
       Editable->False], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"]}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"ef98891b-b16a-40d7-b9e6-f99fd0397bde"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandProductMetric", "[", 
  RowBox[{"Outer", "[", 
   RowBox[{"g4", ",", 
    RowBox[{"{", 
     RowBox[{"A", ",", "a"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"B", ",", "b"}], "}"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"99e00671-44cc-4b85-85b1-73a683685330"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      InterpretationBox[
       StyleBox[GridBox[{
          {"g", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`g[$CellContext`A, $CellContext`B],
       Editable->False], 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["w",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[],
        Editable->False], "2"]], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     FractionBox[
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Gamma]", 
           StyleBox[GridBox[{
              {"a", "b"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`gamma[$CellContext`a, $CellContext`b],
       Editable->False], 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"]]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"9a25bb6e-b392-4180-b255-cf99ab24ad4a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ExpandProductMetric", "[", 
   RowBox[{"Outer", "[", 
    RowBox[{"ChristoffelCd4", ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "a"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "b"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "c"}]}], "}"}]}], "]"}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"c06aeae1-3b93-4e1b-9385-6c0d17fe49a4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
            StyleBox[GridBox[{
               {"A", " ", " "},
               {" ", "B", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C],
        Editable->False], ",", 
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "A"},
                 {"B", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`B, $CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "c"], "w"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdS[-$CellContext`c][
            $CellContext`w[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "A"},
                 {"C", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-C, $CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdS[-$CellContext`b][
            $CellContext`w[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]], ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`g[$CellContext`A, $CellContext`B],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Gamma]", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"b", "c"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gamma[-$CellContext`b, -$CellContext`c],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], " ", 
          RowBox[{"(", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CdM[-$CellContext`B][
             $CellContext`r[]],
            Editable->False], ")"}]}], 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["w",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`w[],
           Editable->False], "2"]]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"B", "C"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`g[-$CellContext`B, -C],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Gamma]", 
               StyleBox[GridBox[{
                  {"a", "b"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gamma[$CellContext`a, $CellContext`b],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["w",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`w[],
           Editable->False], " ", 
          RowBox[{"(", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CdS[-$CellContext`b][
             $CellContext`w[]],
            Editable->False], ")"}]}], 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]]}], ",", 
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "a"},
                 {"c", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`c, $CellContext`a],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdM[-$CellContext`B][
            $CellContext`r[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "a"},
                 {"b", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`b, $CellContext`a],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "C"], "r"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdM[-C][
            $CellContext`r[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
            StyleBox[GridBox[{
               {"a", " ", " "},
               {" ", "b", "c"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ChristoffelCdS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
        Editable->False]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"df51eb38-8011-498a-a7e7-e837f8c6d98e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", "g", ",", 
   RowBox[{"AllowUpperDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"048d5ce2-8b22-4a36-bbce-1bb887101a99"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
            StyleBox[GridBox[{
               {"A", " ", " "},
               {" ", "B", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C],
        Editable->False], ",", 
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "A"},
                 {"B", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`B, $CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "c"], "w"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdS[-$CellContext`c][
            $CellContext`w[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "A"},
                 {"C", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-C, $CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdS[-$CellContext`b][
            $CellContext`w[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]], ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Gamma]", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"b", "c"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gamma[-$CellContext`b, -$CellContext`c],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], " ", 
          RowBox[{"(", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SuperscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CdM[$CellContext`A][
             $CellContext`r[]],
            Editable->False], ")"}]}], 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["w",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`w[],
           Editable->False], "2"]]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"B", "C"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`g[-$CellContext`B, -C],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Gamma]", 
               StyleBox[GridBox[{
                  {"a", "b"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gamma[$CellContext`a, $CellContext`b],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["w",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`w[],
           Editable->False], " ", 
          RowBox[{"(", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CdS[-$CellContext`b][
             $CellContext`w[]],
            Editable->False], ")"}]}], 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]]}], ",", 
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "a"},
                 {"c", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`c, $CellContext`a],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdM[-$CellContext`B][
            $CellContext`r[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "a"},
                 {"b", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`b, $CellContext`a],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "C"], "r"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdM[-C][
            $CellContext`r[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
            StyleBox[GridBox[{
               {"a", " ", " "},
               {" ", "b", "c"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ChristoffelCdS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
        Editable->False]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"03448c84-4339-491c-b23a-f14fcf2861e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContractMetric", "[", 
  RowBox[{"%", ",", "gamma", ",", 
   RowBox[{"AllowUpperDerivatives", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"7ce6b362-ab87-4c34-9ad9-49652dd2f42d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
            StyleBox[GridBox[{
               {"A", " ", " "},
               {" ", "B", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C],
        Editable->False], ",", 
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "A"},
                 {"B", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`B, $CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "c"], "w"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdS[-$CellContext`c][
            $CellContext`w[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "A"},
                 {"C", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-C, $CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdS[-$CellContext`b][
            $CellContext`w[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]], ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"\[Gamma]", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"b", "c"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gamma[-$CellContext`b, -$CellContext`c],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], " ", 
          RowBox[{"(", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SuperscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CdM[$CellContext`A][
             $CellContext`r[]],
            Editable->False], ")"}]}], 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["w",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`w[],
           Editable->False], "2"]]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox[GridBox[{
              {"g", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"B", "C"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`g[-$CellContext`B, -C],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["w",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`w[],
           Editable->False], " ", 
          RowBox[{"(", 
           InterpretationBox[
            StyleBox[
             RowBox[{
              SuperscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CdS[$CellContext`a][
             $CellContext`w[]],
            Editable->False], ")"}]}], 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]]}], ",", 
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "a"},
                 {"c", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`c, $CellContext`a],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdM[-$CellContext`B][
            $CellContext`r[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"\[Delta]", 
              StyleBox[GridBox[{
                 {" ", "a"},
                 {"b", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`delta[-$CellContext`b, $CellContext`a],
          Editable->False], " ", 
         RowBox[{"(", 
          InterpretationBox[
           StyleBox[
            RowBox[{
             SubscriptBox["\[EmptyDownTriangle]", "C"], "r"}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CdM[-C][
            $CellContext`r[]],
           Editable->False], ")"}]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {
            RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
            StyleBox[GridBox[{
               {"a", " ", " "},
               {" ", "b", "c"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ChristoffelCdS[$CellContext`a, -$CellContext`b, \
-$CellContext`c],
        Editable->False]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"93e16465-3230-4fd2-81a4-acf610ec94e4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ExpandProductMetric", "[", 
      RowBox[{"Outer", "[", 
       RowBox[{"RiemannCd4", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "A"}], ",", 
          RowBox[{"-", "a"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "B"}], ",", 
          RowBox[{"-", "b"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "C"}], ",", 
          RowBox[{"-", "c"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"D", ",", "d"}], "}"}]}], "]"}], "]"}], "/.", 
     RowBox[{"$RiemannSign", "\[Rule]", "1"}]}], "//", "ContractMetric"}], "//",
    "Simplification"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"2e3c3344-97c8-4dc8-8a37-ecad486c430d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"IsIndexOf", "::", "nouse"}], "MessageName"], ":", 
  " ", "\<\"Attempting to apply \[NoBreak]\\!\\(IsIndexOf\\)\[NoBreak] on \
\[NoBreak]\\!\\(\\*TagBox[TooltipBox[\\(\\(\\*InterpretationBox[StyleBox[\\(\
\[EmptyDownTriangle]\\_f$319608 w\\), Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], CdS[Times[-1, f$319608]][w[]], Rule[Editable, \
False]]\\)\\+_\\), RowBox[List[\\\"\\\\\\\"Object\\\\\\\"\\\", \\\"[\\\", \
RowBox[List[InterpretationBox[StyleBox[RowBox[List[SubscriptBox[\\\"\\\\[\
EmptyDownTriangle]\\\", \\\"f$319608\\\"], \\\"w\\\"]], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], CdS[Times[-1, f$319608]][w[]], \
Rule[Editable, False]], \\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[\\\"Tensor\\\", \\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[\\\"1\\\", \\\",\\\", \\\"1\\\"]], \\\"}\\\"]], \\\",\\\", \
RowBox[List[\\\"{\\\", RowBox[List[\\\"CdS\\\", \\\",\\\", \\\"w\\\", \\\",\\\
\", RowBox[List[\\\"xAct`xTensor`Private`MyDer\\\", \\\"[\\\", RowBox[List[\\\
\"CdS\\\", \\\"[\\\", RowBox[List[\\\"-\\\", \\\"f$319608\\\"]], \\\"]\\\"]], \
\\\"]\\\"]]]], \\\"}\\\"]]]], \\\"}\\\"]], \\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", \
Rule[FontColor, RGBColor[0, 0, 1]]], RowBox[List[\\\"-\\\", \
\\\"f$319608\\\"]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], \
IndexList[Times[-1, f$319608]], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], RowBox[List[\\\"-\\\", \\\"f$319608\\\"]], \
StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, 1]]]]], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], IndexList[Times[-1, f$319608]], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], RowBox[List[\\\"{\\\", \
RowBox[List[RowBox[List[\\\"-\\\", \
InterpretationBox[StyleBox[\\\"\\\\[DoubleStruckCapitalT]S2\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], TangentS2, \
Rule[Editable, False]]]], \\\",\\\", \\\"gamma\\\"]], \\\"}\\\"]], \
StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, 1]]]]], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], IndexList[List[Times[-1, TangentS2], \
gamma]], Rule[Editable, False]]]], \\\"}\\\"]]]], \\\"]\\\"]]], \
Function[Slot[1]]]\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9434d0b8-434e-4826-a2e4-313b12eb389c"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Throw", "::", "nocatch"}], "MessageName"], ":", 
  " ", "\<\"Uncaught \
\[NoBreak]\\!\\(Throw[\\(\\(\\*InterpretationBox[StyleBox[\\(\\(\\(\\*\\\"\\\\\
!\\\\(\\\\*StyleBox[\\\\\\\"ERROR\\\\\\\",FontColor->Hue[0.]]\\\\)\\\"\\)\\)[\
\\(\\(\\*TagBox[TooltipBox[\\(\\(\\*InterpretationBox[StyleBox[\\(\
\[EmptyDownTriangle]\\_f$319608 w\\), Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], CdS[Times[-1, f$319608]][w[]], Rule[Editable, \
False]]\\)\\+_\\), RowBox[List[\\\"\\\\\\\"Object\\\\\\\"\\\", \\\"[\\\", \
RowBox[List[InterpretationBox[StyleBox[RowBox[List[SubscriptBox[\\\"\\\\[\
EmptyDownTriangle]\\\", \\\"f$319608\\\"], \\\"w\\\"]], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], CdS[Times[-1, f$319608]][w[]], \
Rule[Editable, False]], \\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[\\\"Tensor\\\", \\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[\\\"1\\\", \\\",\\\", \\\"1\\\"]], \\\"}\\\"]], \\\",\\\", \
RowBox[List[\\\"{\\\", RowBox[List[\\\"CdS\\\", \\\",\\\", \\\"w\\\", \\\",\\\
\", RowBox[List[\\\"xAct`xTensor`Private`MyDer\\\", \\\"[\\\", RowBox[List[\\\
\"CdS\\\", \\\"[\\\", RowBox[List[\\\"Times\\\", \\\"[\\\", \
RowBox[List[\\\"\\\\[LeftSkeleton]\\\", \\\"2\\\", \
\\\"\\\\[RightSkeleton]\\\"]], \\\"]\\\"]], \\\"]\\\"]], \\\"]\\\"]]]], \\\"}\
\\\"]]]], \\\"}\\\"]], \\\",\\\", RowBox[List[\\\"{\\\", \
RowBox[List[InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", \
Rule[FontColor, RGBColor[0, 0, 1]]], RowBox[List[\\\"-\\\", \
\\\"f$319608\\\"]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], \
IndexList[Times[-1, f$319608]], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], RowBox[List[\\\"-\\\", \\\"f$319608\\\"]], \
StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, 1]]]]], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], IndexList[Times[-1, f$319608]], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, \
1]]]]], Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], IndexList[], \
Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[RowBox[List[StyleBox[\\\"{\\\", Rule[FontColor, \
RGBColor[0, 0, 1]]], RowBox[List[\\\"{\\\", \
RowBox[List[RowBox[List[\\\"-\\\", \
InterpretationBox[StyleBox[\\\"\\\\[DoubleStruckCapitalT]S2\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], TangentS2, \
Rule[Editable, False]]]], \\\",\\\", \\\"gamma\\\"]], \\\"}\\\"]], \
StyleBox[\\\"}\\\", Rule[FontColor, RGBColor[0, 0, 1]]]]], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], IndexList[List[Times[-1, TangentS2], \
gamma]], Rule[Editable, False]]]], \\\"}\\\"]]]], \\\"]\\\"]]], \
Function[Slot[1]]]\\)\\)]\\), Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], ERROR[xAct`xTensor`Private`Object[CdS[Times[-1, f$319608]][w[]], \
List[Tensor, List[1, 1], List[CdS, w, \
xAct`xTensor`Private`MyDer[CdS[Times[Skeleton[2]]]]]], \
List[IndexList[Times[-1, f$319608]], IndexList[Times[-1, f$319608]], \
IndexList[], IndexList[], IndexList[List[Times[-1, TangentS2], gamma]]]]], \
Rule[Editable, False]]\\)\\)]\\)\[NoBreak] returned to top level. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Throw/nocatch\\\", \
ButtonNote -> \\\"Throw::nocatch\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"695b935a-2d63-435f-be3e-18644c83ad35"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"Throw", "[", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["ERROR",
       FontColor->Hue[0.]], "[", 
      TagBox[
       TooltipBox[
        UnderscriptBox[
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "f$319608"], "w"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdS[-$CellContext`f$319608][
           $CellContext`w[]],
          Editable->False], "_"],
        RowBox[{"\"Object\"", "[", 
          RowBox[{
            InterpretationBox[
             StyleBox[
              RowBox[{
                SubscriptBox["\[EmptyDownTriangle]", "f$319608"], "w"}], 
              AutoSpacing -> False, ShowAutoStyles -> False], 
             $CellContext`CdS[-$CellContext`f$319608][
              $CellContext`w[]], Editable -> False], ",", 
            RowBox[{"{", 
              RowBox[{"Tensor", ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"CdS", ",", "w", ",", 
                    RowBox[{"xAct`xTensor`Private`MyDer", "[", 
                    RowBox[{"CdS", "[", 
                    RowBox[{"-", "f$319608"}], "]"}], "]"}]}], "}"}]}], "}"}],
             ",", 
            RowBox[{"{", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "f$319608"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`f$319608], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "f$319608"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[-$CellContext`f$319608], Editable -> 
                 False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 xAct`xTensor`IndexList[], Editable -> False], ",", 
                InterpretationBox[
                 StyleBox[
                  RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]S2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentS2, 
                    Editable -> False]}], ",", "gamma"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                  AutoSpacing -> False, ShowAutoStyles -> False], 
                 
                 xAct`xTensor`IndexList[{-$CellContext`TangentS2, \
$CellContext`gamma}], Editable -> False]}], "}"}]}], "]"}]],
       #& ], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ERROR[
     xAct`xTensor`Private`Object[
      $CellContext`CdS[-$CellContext`f$319608][
       $CellContext`w[]], {
      xAct`xTensor`Tensor, {1, 1}, {$CellContext`CdS, $CellContext`w, 
        xAct`xTensor`Private`MyDer[
         $CellContext`CdS[-$CellContext`f$319608]]}}, {
       xAct`xTensor`IndexList[-$CellContext`f$319608], 
       xAct`xTensor`IndexList[-$CellContext`f$319608], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{-$CellContext`TangentS2, \
$CellContext`gamma}]}]],
    Editable->False], "]"}], 
  "]"}]], "Output",ExpressionUUID->"f6b34097-9715-4a4a-bc9e-355cf57d522c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"ExpandProductMetric", "[", 
         RowBox[{"Outer", "[", 
          RowBox[{"RicciCd4", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "A"}], ",", 
             RowBox[{"-", "a"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "B"}], ",", 
             RowBox[{"-", "b"}]}], "}"}]}], "]"}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
          RowBox[{"$RicciSign", "\[Rule]", "1"}]}], "}"}]}], "//", 
       "ContractMetric"}], "//", "RicciToEinstein"}], "//", "ToCanonical"}], "//",
     "ScreenDollarIndices"}], "//", "ContractMetric"}], "//", 
  "Simplification"}]], \
"Input",ExpressionUUID->"5c2ce68f-f668-4788-87cf-076810910827"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{"(", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "B"], 
            SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdM[-$CellContext`B][
           $CellContext`CdM[-$CellContext`A][
            $CellContext`r[]]],
          Editable->False], ")"}]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"g", 
             StyleBox[GridBox[{
                {" ", " "},
                {"A", "B"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`g[-$CellContext`A, -$CellContext`B],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox[
             RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`RicciScalarCdM[],
            Editable->False]}], "-", 
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"\[Gamma]", 
                StyleBox[GridBox[{
                   {"a", "b"},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gamma[$CellContext`a, $CellContext`b],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CdS[-$CellContext`a][
                 $CellContext`w[]],
                Editable->False], ")"}], " ", 
              RowBox[{"(", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CdS[-$CellContext`b][
                 $CellContext`w[]],
                Editable->False], ")"}]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["w",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`w[],
               Editable->False], " ", 
              RowBox[{"(", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[EmptyDownTriangle]", "b"], 
                  SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CdS[-$CellContext`b][
                 $CellContext`CdS[-$CellContext`a][
                  $CellContext`w[]]],
                Editable->False], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}]], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", 
        RowBox[{"(", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdM[-$CellContext`A][
           $CellContext`r[]],
          Editable->False], ")"}], " ", 
        RowBox[{"(", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdS[-$CellContext`b][
           $CellContext`w[]],
          Editable->False], ")"}]}], 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", 
        RowBox[{"(", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdM[-$CellContext`B][
           $CellContext`r[]],
          Editable->False], ")"}], " ", 
        RowBox[{"(", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdS[-$CellContext`a][
           $CellContext`w[]],
          Editable->False], ")"}]}], 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False]}]]}], ",", 
     FractionBox[
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox[GridBox[{
            {"\[Gamma]", 
             StyleBox[GridBox[{
                {" ", " "},
                {"a", "b"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`gamma[-$CellContext`a, -$CellContext`b],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           InterpretationBox[
            StyleBox[
             RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`RicciScalarCdS[],
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["w",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`w[],
             Editable->False], "2"]}], "-", 
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox[GridBox[{
               {"g", 
                StyleBox[GridBox[{
                   {"A", "B"},
                   {" ", " "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`g[$CellContext`A, $CellContext`B],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CdM[-$CellContext`A][
                 $CellContext`r[]],
                Editable->False], ")"}], " ", 
              RowBox[{"(", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CdM[-$CellContext`B][
                 $CellContext`r[]],
                Editable->False], ")"}]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              RowBox[{"(", 
               InterpretationBox[
                StyleBox[
                 RowBox[{
                  SubscriptBox["\[EmptyDownTriangle]", "B"], 
                  SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`CdM[-$CellContext`B][
                 $CellContext`CdM[-$CellContext`A][
                  $CellContext`r[]]],
                Editable->False], ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
       RowBox[{"4", " ", 
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False], " ", 
        RowBox[{"(", 
         InterpretationBox[
          StyleBox[
           RowBox[{
            SubscriptBox["\[EmptyDownTriangle]", "b"], 
            SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CdS[-$CellContext`b][
           $CellContext`CdS[-$CellContext`a][
            $CellContext`w[]]],
          Editable->False], ")"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["w",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`w[],
         Editable->False], "2"]}]]}], "}"}]}], 
  "}"}]], "Output",ExpressionUUID->"018d8981-0575-4a62-a05a-d638b9479005"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpandProductMetric", "[", 
        RowBox[{"RicciScalarCd4", "[", "]"}], "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
         RowBox[{"$RicciSign", "\[Rule]", "1"}]}], "}"}]}], "//", 
      "ContractMetric"}], "//", "ToCanonical"}], "//", "ReplaceDummies"}], "//",
    "ScreenDollarIndices"}], "//", 
  "Simplify"}]], \
"Input",ExpressionUUID->"468bd271-01a5-460d-b61e-2853241c38de"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RicciScalarCdM[],
     Editable->False]}], "+", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RicciScalarCdS[],
     Editable->False], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["w",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[],
      Editable->False], "2"]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`g[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CdM[-$CellContext`A][
          $CellContext`r[]],
         Editable->False], ")"}], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CdM[-$CellContext`B][
          $CellContext`r[]],
         Editable->False], ")"}]}], "+", 
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "B"], 
           SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CdM[-$CellContext`B][
          $CellContext`CdM[-$CellContext`A][
           $CellContext`r[]]],
         Editable->False], ")"}]}]}], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Gamma]", 
         StyleBox[GridBox[{
            {"a", "b"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`gamma[$CellContext`a, $CellContext`b],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CdS[-$CellContext`a][
          $CellContext`w[]],
         Editable->False], ")"}], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CdS[-$CellContext`b][
          $CellContext`w[]],
         Editable->False], ")"}]}], "+", 
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["w",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "b"], 
           SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CdS[-$CellContext`b][
          $CellContext`CdS[-$CellContext`a][
           $CellContext`w[]]],
         Editable->False], ")"}]}]}], ")"}]}]}], 
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->False], 
    "2"]}]]], \
"Output",ExpressionUUID->"c428cca0-b542-42bf-b46b-0a9dd297a97b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Metrics"], \
"Input",ExpressionUUID->"b8fd9d8c-669f-41a2-99bc-2d650f302bc7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"g", ",", "gamma", ",", "g4"}], 
  "}"}]], "Output",ExpressionUUID->"9bdf907d-b458-484f-bc8d-825f922a5cf1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mprod"}]], "Input",ExpressionUUID->"a07ff461-98d0-4226-8636-36777f1d44f3"],

Cell[CellGroupData[{

Cell["Global`Mprod", "Print", "PrintUsage",
 CellTags->
  "Info3578673017-5338953",ExpressionUUID->"8f3dd3d5-e3ee-4593-aca1-\
1c2e2a0c347b"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Mprod", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "Mprod", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "Mprod", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Mprod", "]"}], "^=", "\<\"Mprod\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", "\[Times]", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "M2"}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "S2"}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VisitorsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{
          "g4", ",", "epsilong4", ",", "Tetrag4", ",", "Tetrag4\[Dagger]", 
           ",", "Cd4", ",", "TorsionCd4", ",", "ChristoffelCd4", ",", 
           "RiemannCd4", ",", "RicciCd4", ",", "RicciScalarCd4", ",", 
           "EinsteinCd4", ",", "WeylCd4", ",", "TFRicciCd4", ",", 
           "KretschmannCd4", ",", "Detg4"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Mprod],
  Editable->False]], "Print",
 CellTags->
  "Info3578673017-5338953",ExpressionUUID->"3be4e4b4-ede8-4897-af91-\
2b7595a851be"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "g4", 
  "]"}]], "Input",ExpressionUUID->"1e0f6eb2-71ec-42b5-b0af-b6873f2c2674"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detg4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detg4],
  Editable->
   False]], "Print",ExpressionUUID->"a1400542-fcee-4952-90f0-b7cb906a573b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCd4],
  Editable->
   False]], "Print",ExpressionUUID->"a9a3ae29-8656-4908-b9b5-b61f491293c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Einstein tensor", " ", $CellContext`EinsteinCd4],
  Editable->
   False]], "Print",ExpressionUUID->"85d46856-a96e-4e1b-b8fe-9b1d8d4a4f55"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCd4],
  Editable->
   False]], "Print",ExpressionUUID->"fe821283-3699-4f6e-8ab1-891f9eee0b8b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCd4],
  Editable->
   False]], "Print",ExpressionUUID->"ddebf74b-e883-40e4-8a78-3937bdfedc92"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCd4],
  Editable->
   False]], "Print",ExpressionUUID->"31d3b02e-8de5-4738-889d-00b2361fc811"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCd4],
  Editable->
   False]], "Print",ExpressionUUID->"ef9b30af-5818-4655-af23-bee46338e84f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric TFRicci tensor",
    " ", $CellContext`TFRicciCd4],
  Editable->
   False]], "Print",ExpressionUUID->"3c431e81-17ab-47e6-8a0d-2a5cdf75688c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCd4],
  Editable->
   False]], "Print",ExpressionUUID->"b160dcc1-115e-4d48-a901-c58711eeee6c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCd4],
  Editable->
   False]], "Print",ExpressionUUID->"b889bb43-1666-443a-b9bb-b3295b6d4060"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Cd4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`Cd4],
  Editable->
   False]], "Print",ExpressionUUID->"acb0aac8-5ba1-40fa-afa3-75253a628538"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Tetrag4\[Dagger]"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tetrametric", 
   " ", $CellContext`Tetrag4\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"7b27e3db-6ac7-4e47-86ab-3a8a764b6e17"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Tetrag4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tetrametric", 
   " ", $CellContext`Tetrag4],
  Editable->
   False]], "Print",ExpressionUUID->"9e71e934-c8de-4a52-a565-c873474d977f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilong4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilong4],
  Editable->
   False]], "Print",ExpressionUUID->"f5bc9a1d-77b1-4a38-80f0-8c4245f8590f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "g4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`g4],
  Editable->
   False]], "Print",ExpressionUUID->"6c69feb3-b36c-425a-ba35-0bdc3bb7b7d4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "Mprod"}]], "Input",ExpressionUUID->"a92930eb-8f0b-48b8-80c2-9a33e92d12c0"],

Cell[CellGroupData[{

Cell["Global`Mprod", "Print", "PrintUsage",
 CellTags->
  "Info3578673019-5338953",ExpressionUUID->"623ce3d3-9738-4312-ad54-\
0feed2c9b58a"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Mprod", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"DefInfo", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"manifold\"\>", ",", "\<\"\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DimOfManifold", "[", "Mprod", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"HostsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", ",", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ManifoldQ", "[", "Mprod", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrintAs", "[", "Mprod", "]"}], "^=", "\<\"Mprod\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ServantsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          InterpretationBox[
           StyleBox["\[DoubleStruckCapitalT]Mprod",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`TangentMprod,
           Editable->False], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SplittingsOfManifold", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"M2", "\[Times]", "S2"}], "}"}]}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "M2"}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{"Mprod", "/:", 
         RowBox[{"SubmanifoldQ", "[", 
          RowBox[{"Mprod", ",", "S2"}], "]"}], "=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"VisitorsOf", "[", "Mprod", "]"}], "^=", 
         RowBox[{"{", "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Mprod],
  Editable->False]], "Print",
 CellTags->
  "Info3578673019-5338953",ExpressionUUID->"55dc3460-7316-4adf-941b-\
b4ef59e2e3d0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefMetric", "/@", "$Metrics"}], 
  ";"}]], "Input",ExpressionUUID->"3e63b4e0-d2d9-4796-88e7-c2df5fd4da7d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detg],
  Editable->
   False]], "Print",ExpressionUUID->"56e5156f-6c19-4dcc-a8a8-7da56a0ada74"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdM],
  Editable->
   False]], "Print",ExpressionUUID->"6fdefe5f-9e65-41e3-8fb9-5289710bdfdd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdM],
  Editable->
   False]], "Print",ExpressionUUID->"4ed9e763-bea9-4955-a41e-3c07a65451e9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"1c387109-8a48-4ff8-967f-35e5f89219c4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"d3d7b8ec-a692-453b-88dc-a9eed10a8182"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdM],
  Editable->
   False]], "Print",ExpressionUUID->"47997b7b-fe0a-4e41-be21-106fde8b54e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"e7abf311-bfd4-4616-aa27-6bbc90cddbdf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"03636f0b-34d7-411b-a84d-62fb9dc825e2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdM],
  Editable->
   False]], "Print",ExpressionUUID->"e4b80c8e-8dfa-4f73-a0dc-d93553f15629"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdM],
  Editable->
   False]], "Print",ExpressionUUID->"b36fc87b-039f-41d7-8f64-26b14d7a0413"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdM],
  Editable->
   False]], "Print",ExpressionUUID->"207b0f21-48fe-459c-b810-9b72f6ffb4d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilong"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilong],
  Editable->
   False]], "Print",ExpressionUUID->"0134e3ac-fe28-4fd1-94e6-f865240bb512"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "g"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`g],
  Editable->
   False]], "Print",ExpressionUUID->"3e9ffce5-4c3c-4af3-b26b-7971cc13e26f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgamma],
  Editable->
   False]], "Print",ExpressionUUID->"6951b774-99af-4220-899f-47bf447a3172"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdS],
  Editable->
   False]], "Print",ExpressionUUID->"c6258399-daee-4a26-8e28-5f1bb7ba93fb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdS],
  Editable->
   False]], "Print",ExpressionUUID->"94493893-033e-4848-b7ae-6468a9f73871"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdS],
  Editable->
   False]], "Print",ExpressionUUID->"288dee0e-5c2a-4e52-be86-945c91f66d36"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCdS],
  Editable->
   False]], "Print",ExpressionUUID->"d8539a9b-63c4-47f4-aca5-a470025660ee"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdS],
  Editable->
   False]], "Print",ExpressionUUID->"e30210ab-ea72-4153-a265-8e8e6efec230"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdS],
  Editable->
   False]], "Print",ExpressionUUID->"b946212b-2dbb-4a4b-898c-9b2f69ec62d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdS],
  Editable->
   False]], "Print",ExpressionUUID->"c39db9a9-2f41-4927-b7bc-63530b6cfde3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdS],
  Editable->
   False]], "Print",ExpressionUUID->"450578ae-87b0-4553-86ac-518742f07a8c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdS],
  Editable->
   False]], "Print",ExpressionUUID->"95a3f027-1525-46c2-ba53-83f9c5880a7d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdS],
  Editable->
   False]], "Print",ExpressionUUID->"1c66f7ef-9fe6-499d-8708-0af6fd64f2a6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilongamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilongamma],
  Editable->
   False]], "Print",ExpressionUUID->"ecd6640c-e68b-45ba-82cf-7fb0aec51a29"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gamma],
  Editable->
   False]], "Print",ExpressionUUID->"94bac27f-b6d2-4052-a5dc-80280684e5b3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Metrics"], \
"Input",ExpressionUUID->"f88b9ef9-c319-458b-ac3d-976622802965"],

Cell[BoxData[
 RowBox[{"{", 
  "}"}]], "Output",ExpressionUUID->"0f399422-a5b7-4a8c-9363-ce865625008f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"a54b26fd-df3d-4d01-9c83-a8ed40c5f8ef"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"w", ",", "r"}], 
  "}"}]], "Output",ExpressionUUID->"a1c16c85-33f0-47b5-b792-e2d03970862c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"r", ",", "w"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"c16e6693-b777-46c0-903c-58196c09140a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"44ce5f76-8d40-4042-9e7c-6d3674399578"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"9bc2fd50-cd28-434d-a104-918e43c31c32"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"e1947f85-1120-401f-a22b-8bfcadfd68d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"alpha\"\>", ",", "\<\"alpha$\"\>", ",", "\<\"beta\"\>", 
     ",", "\<\"beta$\"\>", ",", "\<\"eta\"\>", ",", "\<\"eta$\"\>", 
     ",", "\<\"f$316380\"\>", ",", "\<\"f$316380$\"\>", 
     ",", "\<\"f$316381\"\>", ",", "\<\"f$316381$\"\>", 
     ",", "\<\"f$316382\"\>", ",", "\<\"f$316382$\"\>", 
     ",", "\<\"f$316383\"\>", ",", "\<\"f$316383$\"\>", 
     ",", "\<\"f$316384\"\>", ",", "\<\"f$316384$\"\>", 
     ",", "\<\"f$316385\"\>", ",", "\<\"f$316385$\"\>", 
     ",", "\<\"f$316386\"\>", ",", "\<\"f$316386$\"\>", 
     ",", "\<\"f$316387\"\>", ",", "\<\"f$316387$\"\>", 
     ",", "\<\"f$316388\"\>", ",", "\<\"f$316388$\"\>", 
     ",", "\<\"f$316389\"\>", ",", "\<\"f$316389$\"\>", 
     ",", "\<\"f$316390\"\>", ",", "\<\"f$316390$\"\>", 
     ",", "\<\"f$316391\"\>", ",", "\<\"f$316391$\"\>", 
     ",", "\<\"f$316392\"\>", ",", "\<\"f$316392$\"\>", 
     ",", "\<\"f$316393\"\>", ",", "\<\"f$316393$\"\>", 
     ",", "\<\"f$316462\"\>", ",", "\<\"f$316463\"\>", 
     ",", "\<\"f$316464\"\>", ",", "\<\"f$316465\"\>", 
     ",", "\<\"f$316473\"\>", ",", "\<\"f$316474\"\>", 
     ",", "\<\"f$316482\"\>", ",", "\<\"f$316483\"\>", 
     ",", "\<\"f$316484\"\>", ",", "\<\"f$319570\"\>", 
     ",", "\<\"f$319573\"\>", ",", "\<\"f$319577\"\>", 
     ",", "\<\"f$319578\"\>", ",", "\<\"f$319580\"\>", 
     ",", "\<\"f$319584\"\>", ",", "\<\"f$319586\"\>", 
     ",", "\<\"f$319588\"\>", ",", "\<\"f$319589\"\>", 
     ",", "\<\"f$319592\"\>", ",", "\<\"f$319593\"\>", 
     ",", "\<\"f$319594\"\>", ",", "\<\"f$319608\"\>", 
     ",", "\<\"f$319610\"\>", ",", "\<\"f$319618\"\>", 
     ",", "\<\"f$319624\"\>", ",", "\<\"f$319631\"\>", 
     ",", "\<\"f$319632\"\>", ",", "\<\"f$319637\"\>", 
     ",", "\<\"f$319644\"\>", ",", "\<\"f$319646\"\>", 
     ",", "\<\"f$319649\"\>", ",", "\<\"f$319652\"\>", 
     ",", "\<\"f$319654\"\>", ",", "\<\"f$319660\"\>", 
     ",", "\<\"f$319661\"\>", ",", "\<\"f$319667\"\>", 
     ",", "\<\"f$319668\"\>", ",", "\<\"f$319669\"\>", 
     ",", "\<\"f$319673\"\>", ",", "\<\"f$319680\"\>", 
     ",", "\<\"f$319683\"\>", ",", "\<\"f$319687\"\>", 
     ",", "\<\"f$319689\"\>", ",", "\<\"f$319696\"\>", 
     ",", "\<\"f$319698\"\>", ",", "\<\"f$319703\"\>", 
     ",", "\<\"f$319705\"\>", ",", "\<\"f$319706\"\>", 
     ",", "\<\"f$319710\"\>", ",", "\<\"f$319711\"\>", 
     ",", "\<\"f$319717\"\>", ",", "\<\"f$319718\"\>", 
     ",", "\<\"f$319720\"\>", ",", "\<\"f$319724\"\>", 
     ",", "\<\"f$319725\"\>", ",", "\<\"f$319726\"\>", 
     ",", "\<\"f$319731\"\>", ",", "\<\"f$319732\"\>", 
     ",", "\<\"f$319733\"\>", ",", "\<\"f$319734\"\>", 
     ",", "\<\"f$319738\"\>", ",", "\<\"f$319740\"\>", 
     ",", "\<\"f$319746\"\>", ",", "\<\"f$319747\"\>", 
     ",", "\<\"f$319750\"\>", ",", "\<\"f$319755\"\>", 
     ",", "\<\"f$319756\"\>", ",", "\<\"f$319759\"\>", 
     ",", "\<\"f$319764\"\>", ",", "\<\"f$319765\"\>", 
     ",", "\<\"f$319768\"\>", ",", "\<\"f$319777\"\>", 
     ",", "\<\"f$319782\"\>", ",", "\<\"f$319783\"\>", 
     ",", "\<\"f$319786\"\>", ",", "\<\"f$319795\"\>", 
     ",", "\<\"f$319804\"\>", ",", "\<\"f$319813\"\>", 
     ",", "\<\"f$319817\"\>", ",", "\<\"f$319824\"\>", 
     ",", "\<\"f$319831\"\>", ",", "\<\"f$319839\"\>", 
     ",", "\<\"f$319840\"\>", ",", "\<\"f$319843\"\>", 
     ",", "\<\"f$319848\"\>", ",", "\<\"f$319849\"\>", 
     ",", "\<\"f$319852\"\>", ",", "\<\"f$319857\"\>", 
     ",", "\<\"f$319858\"\>", ",", "\<\"f$319861\"\>", 
     ",", "\<\"f$319870\"\>", ",", "\<\"f$319875\"\>", 
     ",", "\<\"f$319876\"\>", ",", "\<\"f$319879\"\>", 
     ",", "\<\"f$319888\"\>", ",", "\<\"f$319897\"\>", 
     ",", "\<\"f$319906\"\>", ",", "\<\"f$319911\"\>", 
     ",", "\<\"f$319913\"\>", ",", "\<\"f$319916\"\>", 
     ",", "\<\"f$319919\"\>", ",", "\<\"f$319921\"\>", 
     ",", "\<\"f$319926\"\>", ",", "\<\"f$319928\"\>", 
     ",", "\<\"f$319935\"\>", ",", "\<\"f$319937\"\>", 
     ",", "\<\"f$319943\"\>", ",", "\<\"f$319944\"\>", 
     ",", "\<\"f$319947\"\>", ",", "\<\"f$319952\"\>", 
     ",", "\<\"f$319953\"\>", ",", "\<\"f$319956\"\>", 
     ",", "\<\"f$319961\"\>", ",", "\<\"f$319962\"\>", 
     ",", "\<\"f$319965\"\>", ",", "\<\"f$319974\"\>", 
     ",", "\<\"f$319979\"\>", ",", "\<\"f$319980\"\>", 
     ",", "\<\"f$319983\"\>", ",", "\<\"f$319992\"\>", 
     ",", "\<\"f$320001\"\>", ",", "\<\"f$320010\"\>", 
     ",", "\<\"f$320015\"\>", ",", "\<\"f$320016\"\>", 
     ",", "\<\"f$320017\"\>", ",", "\<\"f$320022\"\>", 
     ",", "\<\"f$320023\"\>", ",", "\<\"f$320024\"\>", 
     ",", "\<\"f$320029\"\>", ",", "\<\"f$320030\"\>", 
     ",", "\<\"f$320031\"\>", ",", "\<\"f$320036\"\>", 
     ",", "\<\"f$320037\"\>", ",", "\<\"f$320040\"\>", 
     ",", "\<\"f$320045\"\>", ",", "\<\"f$320046\"\>", 
     ",", "\<\"f$320049\"\>", ",", "\<\"f$320054\"\>", 
     ",", "\<\"f$320055\"\>", ",", "\<\"f$320058\"\>", 
     ",", "\<\"f$320067\"\>", ",", "\<\"f$320072\"\>", 
     ",", "\<\"f$320073\"\>", ",", "\<\"f$320076\"\>", 
     ",", "\<\"f$320085\"\>", ",", "\<\"f$320094\"\>", 
     ",", "\<\"f$320103\"\>", ",", "\<\"f$320108\"\>", 
     ",", "\<\"f$320109\"\>", ",", "\<\"f$320112\"\>", 
     ",", "\<\"f$320117\"\>", ",", "\<\"f$320118\"\>", 
     ",", "\<\"f$320121\"\>", ",", "\<\"f$320126\"\>", 
     ",", "\<\"f$320127\"\>", ",", "\<\"f$320130\"\>", 
     ",", "\<\"f$320139\"\>", ",", "\<\"f$320144\"\>", 
     ",", "\<\"f$320145\"\>", ",", "\<\"f$320148\"\>", 
     ",", "\<\"f$320157\"\>", ",", "\<\"f$320166\"\>", 
     ",", "\<\"f$320175\"\>", ",", "\<\"f$320180\"\>", 
     ",", "\<\"f$320181\"\>", ",", "\<\"f$320184\"\>", 
     ",", "\<\"f$320189\"\>", ",", "\<\"f$320190\"\>", 
     ",", "\<\"f$320193\"\>", ",", "\<\"f$320198\"\>", 
     ",", "\<\"f$320199\"\>", ",", "\<\"f$320202\"\>", 
     ",", "\<\"f$320211\"\>", ",", "\<\"f$320216\"\>", 
     ",", "\<\"f$320217\"\>", ",", "\<\"f$320220\"\>", 
     ",", "\<\"f$320229\"\>", ",", "\<\"f$320238\"\>", 
     ",", "\<\"f$320247\"\>", ",", "\<\"f$321573\"\>", 
     ",", "\<\"f$321579\"\>", ",", "\<\"f$321585\"\>", 
     ",", "\<\"f$321591\"\>", ",", "\<\"f$321595\"\>", 
     ",", "\<\"f$321597\"\>", ",", "\<\"f$321601\"\>", 
     ",", "\<\"f$321606\"\>", ",", "\<\"f$321608\"\>", 
     ",", "\<\"f$321621\"\>", ",", "\<\"f$321623\"\>", 
     ",", "\<\"f$321628\"\>", ",", "\<\"f$321630\"\>", 
     ",", "\<\"f$321631\"\>", ",", "\<\"f$321638\"\>", 
     ",", "\<\"f$321642\"\>", ",", "\<\"f$321643\"\>", 
     ",", "\<\"f$321644\"\>", ",", "\<\"f$321650\"\>", 
     ",", "\<\"f$321656\"\>", ",", "\<\"f$321657\"\>", 
     ",", "\<\"f$321658\"\>", ",", "\<\"f$321659\"\>", 
     ",", "\<\"f$321664\"\>", ",", "\<\"f$321666\"\>", 
     ",", "\<\"f$321672\"\>", ",", "\<\"f$321674\"\>", 
     ",", "\<\"f$321679\"\>", ",", "\<\"f$321682\"\>", 
     ",", "\<\"f$321684\"\>", ",", "\<\"f$321690\"\>", 
     ",", "\<\"f$321691\"\>", ",", "\<\"f$321694\"\>", 
     ",", "\<\"f$321699\"\>", ",", "\<\"f$321700\"\>", 
     ",", "\<\"f$321703\"\>", ",", "\<\"f$321708\"\>", 
     ",", "\<\"f$321709\"\>", ",", "\<\"f$321712\"\>", 
     ",", "\<\"f$321721\"\>", ",", "\<\"f$321726\"\>", 
     ",", "\<\"f$321727\"\>", ",", "\<\"f$321730\"\>", 
     ",", "\<\"f$321739\"\>", ",", "\<\"f$321748\"\>", 
     ",", "\<\"f$321757\"\>", ",", "\<\"f$321762\"\>", 
     ",", "\<\"f$321763\"\>", ",", "\<\"f$321766\"\>", 
     ",", "\<\"f$321771\"\>", ",", "\<\"f$321772\"\>", 
     ",", "\<\"f$321775\"\>", ",", "\<\"f$321780\"\>", 
     ",", "\<\"f$321781\"\>", ",", "\<\"f$321784\"\>", 
     ",", "\<\"f$321793\"\>", ",", "\<\"f$321798\"\>", 
     ",", "\<\"f$321799\"\>", ",", "\<\"f$321802\"\>", 
     ",", "\<\"f$321811\"\>", ",", "\<\"f$321820\"\>", 
     ",", "\<\"f$321829\"\>", ",", "\<\"f$321834\"\>", 
     ",", "\<\"f$321835\"\>", ",", "\<\"f$321836\"\>", 
     ",", "\<\"f$321840\"\>", ",", "\<\"f$321847\"\>", 
     ",", "\<\"f$321855\"\>", ",", "\<\"f$321856\"\>", 
     ",", "\<\"f$321857\"\>", ",", "\<\"f$321862\"\>", 
     ",", "\<\"f$321863\"\>", ",", "\<\"f$321866\"\>", 
     ",", "\<\"f$321871\"\>", ",", "\<\"f$321872\"\>", 
     ",", "\<\"f$321875\"\>", ",", "\<\"f$321880\"\>", 
     ",", "\<\"f$321881\"\>", ",", "\<\"f$321884\"\>", 
     ",", "\<\"f$321893\"\>", ",", "\<\"f$321898\"\>", 
     ",", "\<\"f$321899\"\>", ",", "\<\"f$321902\"\>", 
     ",", "\<\"f$321911\"\>", ",", "\<\"f$321920\"\>", 
     ",", "\<\"f$321929\"\>", ",", "\<\"f$321934\"\>", 
     ",", "\<\"f$321935\"\>", ",", "\<\"f$321938\"\>", 
     ",", "\<\"f$321943\"\>", ",", "\<\"f$321944\"\>", 
     ",", "\<\"f$321947\"\>", ",", "\<\"f$321952\"\>", 
     ",", "\<\"f$321953\"\>", ",", "\<\"f$321956\"\>", 
     ",", "\<\"f$321965\"\>", ",", "\<\"f$321970\"\>", 
     ",", "\<\"f$321971\"\>", ",", "\<\"f$321974\"\>", 
     ",", "\<\"f$321983\"\>", ",", "\<\"f$321992\"\>", 
     ",", "\<\"f$322001\"\>", ",", "\<\"f$322008\"\>", 
     ",", "\<\"f$322009\"\>", ",", "\<\"f$322072\"\>", 
     ",", "\<\"f$322073\"\>", ",", "\<\"f$322125\"\>", 
     ",", "\<\"f$322131\"\>", ",", "\<\"f$322137\"\>", 
     ",", "\<\"f$322141\"\>", ",", "\<\"f$322142\"\>", 
     ",", "\<\"f$322143\"\>", ",", "\<\"f$322144\"\>", 
     ",", "\<\"f$322149\"\>", ",", "\<\"f$322151\"\>", 
     ",", "\<\"f$322157\"\>", ",", "\<\"f$322159\"\>", 
     ",", "\<\"f$322164\"\>", ",", "\<\"f$322166\"\>", 
     ",", "\<\"f$322169\"\>", ",", "\<\"f$322171\"\>", 
     ",", "\<\"f$322176\"\>", ",", "\<\"f$322178\"\>", 
     ",", "\<\"f$322182\"\>", ",", "\<\"f$322189\"\>", 
     ",", "\<\"f$322191\"\>", ",", "\<\"f$322204\"\>", 
     ",", "\<\"f$322206\"\>", ",", "\<\"f$322213\"\>", 
     ",", "\<\"f$322214\"\>", ",", "\<\"f$322217\"\>", 
     ",", "\<\"f$322222\"\>", ",", "\<\"f$322223\"\>", 
     ",", "\<\"f$322226\"\>", ",", "\<\"f$322231\"\>", 
     ",", "\<\"f$322232\"\>", ",", "\<\"f$322235\"\>", 
     ",", "\<\"f$322244\"\>", ",", "\<\"f$322249\"\>", 
     ",", "\<\"f$322250\"\>", ",", "\<\"f$322253\"\>", 
     ",", "\<\"f$322262\"\>", ",", "\<\"f$322271\"\>", 
     ",", "\<\"f$322280\"\>", ",", "\<\"f$322285\"\>", 
     ",", "\<\"f$322286\"\>", ",", "\<\"f$322289\"\>", 
     ",", "\<\"f$322294\"\>", ",", "\<\"f$322295\"\>", 
     ",", "\<\"f$322298\"\>", ",", "\<\"f$322303\"\>", 
     ",", "\<\"f$322304\"\>", ",", "\<\"f$322307\"\>", 
     ",", "\<\"f$322316\"\>", ",", "\<\"f$322321\"\>", 
     ",", "\<\"f$322322\"\>", ",", "\<\"f$322325\"\>", 
     ",", "\<\"f$322334\"\>", ",", "\<\"f$322343\"\>", 
     ",", "\<\"f$322352\"\>", ",", "\<\"f$322358\"\>", 
     ",", "\<\"f$322359\"\>", ",", "\<\"f$322362\"\>", 
     ",", "\<\"f$322367\"\>", ",", "\<\"f$322368\"\>", 
     ",", "\<\"f$322371\"\>", ",", "\<\"f$322376\"\>", 
     ",", "\<\"f$322377\"\>", ",", "\<\"f$322380\"\>", 
     ",", "\<\"f$322389\"\>", ",", "\<\"f$322394\"\>", 
     ",", "\<\"f$322395\"\>", ",", "\<\"f$322398\"\>", 
     ",", "\<\"f$322407\"\>", ",", "\<\"f$322416\"\>", 
     ",", "\<\"f$322425\"\>", ",", "\<\"f$322430\"\>", 
     ",", "\<\"f$322431\"\>", ",", "\<\"f$322434\"\>", 
     ",", "\<\"f$322439\"\>", ",", "\<\"f$322440\"\>", 
     ",", "\<\"f$322443\"\>", ",", "\<\"f$322448\"\>", 
     ",", "\<\"f$322449\"\>", ",", "\<\"f$322452\"\>", 
     ",", "\<\"f$322461\"\>", ",", "\<\"f$322466\"\>", 
     ",", "\<\"f$322467\"\>", ",", "\<\"f$322470\"\>", 
     ",", "\<\"f$322479\"\>", ",", "\<\"f$322488\"\>", 
     ",", "\<\"f$322497\"\>", ",", "\<\"f$322508\"\>", 
     ",", "\<\"f$322509\"\>", ",", "\<\"f$322512\"\>", 
     ",", "\<\"f$322513\"\>", ",", "\<\"f$322540\"\>", 
     ",", "\<\"f$322541\"\>", ",", "\<\"G$316194\"\>", 
     ",", "\<\"G$316194$\"\>", ",", "\<\"G$316195\"\>", 
     ",", "\<\"G$316195$\"\>", ",", "\<\"G$316196\"\>", 
     ",", "\<\"G$316196$\"\>", ",", "\<\"G$316197\"\>", 
     ",", "\<\"G$316197$\"\>", ",", "\<\"G$316198\"\>", 
     ",", "\<\"G$316198$\"\>", ",", "\<\"G$316199\"\>", 
     ",", "\<\"G$316199$\"\>", ",", "\<\"G$316200\"\>", 
     ",", "\<\"G$316200$\"\>", ",", "\<\"G$316201\"\>", 
     ",", "\<\"G$316201$\"\>", ",", "\<\"G$316202\"\>", 
     ",", "\<\"G$316202$\"\>", ",", "\<\"G$316203\"\>", 
     ",", "\<\"G$316203$\"\>", ",", "\<\"G$316204\"\>", 
     ",", "\<\"G$316204$\"\>", ",", "\<\"G$316205\"\>", 
     ",", "\<\"G$316205$\"\>", ",", "\<\"G$316206\"\>", 
     ",", "\<\"G$316206$\"\>", ",", "\<\"G$316207\"\>", 
     ",", "\<\"G$316207$\"\>", ",", "\<\"G$316276\"\>", 
     ",", "\<\"G$316277\"\>", ",", "\<\"G$316278\"\>", 
     ",", "\<\"G$316279\"\>", ",", "\<\"G$316287\"\>", 
     ",", "\<\"G$316288\"\>", ",", "\<\"G$316296\"\>", 
     ",", "\<\"G$316297\"\>", ",", "\<\"G$316298\"\>", 
     ",", "\<\"G$319563\"\>", ",", "\<\"G$319564\"\>", 
     ",", "\<\"G$319565\"\>", ",", "\<\"G$319568\"\>", 
     ",", "\<\"G$319569\"\>", ",", "\<\"G$319572\"\>", 
     ",", "\<\"G$319574\"\>", ",", "\<\"G$319576\"\>", 
     ",", "\<\"G$319581\"\>", ",", "\<\"G$319582\"\>", 
     ",", "\<\"G$319585\"\>", ",", "\<\"G$319590\"\>", 
     ",", "\<\"G$319601\"\>", ",", "\<\"G$319602\"\>", 
     ",", "\<\"G$319603\"\>", ",", "\<\"G$319604\"\>", 
     ",", "\<\"G$319607\"\>", ",", "\<\"G$319609\"\>", 
     ",", "\<\"G$319615\"\>", ",", "\<\"G$319616\"\>", 
     ",", "\<\"G$319617\"\>", ",", "\<\"G$319622\"\>", 
     ",", "\<\"G$319623\"\>", ",", "\<\"G$319625\"\>", 
     ",", "\<\"G$319629\"\>", ",", "\<\"G$319630\"\>", 
     ",", "\<\"G$319636\"\>", ",", "\<\"G$319638\"\>", 
     ",", "\<\"G$319639\"\>", ",", "\<\"G$319643\"\>", 
     ",", "\<\"G$319645\"\>", ",", "\<\"G$319651\"\>", 
     ",", "\<\"G$319653\"\>", ",", "\<\"G$319659\"\>", 
     ",", "\<\"G$319662\"\>", ",", "\<\"G$319666\"\>", 
     ",", "\<\"G$319674\"\>", ",", "\<\"G$319675\"\>", 
     ",", "\<\"G$319676\"\>", ",", "\<\"G$319681\"\>", 
     ",", "\<\"G$319682\"\>", ",", "\<\"G$319688\"\>", 
     ",", "\<\"G$319690\"\>", ",", "\<\"G$319693\"\>", 
     ",", "\<\"G$319695\"\>", ",", "\<\"G$319697\"\>", 
     ",", "\<\"G$319704\"\>", ",", "\<\"G$319712\"\>", 
     ",", "\<\"G$319713\"\>", ",", "\<\"G$319719\"\>", 
     ",", "\<\"G$319727\"\>", ",", "\<\"G$319737\"\>", 
     ",", "\<\"G$319739\"\>", ",", "\<\"G$319749\"\>", 
     ",", "\<\"G$319758\"\>", ",", "\<\"G$319767\"\>", 
     ",", "\<\"G$319773\"\>", ",", "\<\"G$319774\"\>", 
     ",", "\<\"G$319776\"\>", ",", "\<\"G$319785\"\>", 
     ",", "\<\"G$319791\"\>", ",", "\<\"G$319792\"\>", 
     ",", "\<\"G$319794\"\>", ",", "\<\"G$319800\"\>", 
     ",", "\<\"G$319801\"\>", ",", "\<\"G$319803\"\>", 
     ",", "\<\"G$319809\"\>", ",", "\<\"G$319810\"\>", 
     ",", "\<\"G$319812\"\>", ",", "\<\"G$319818\"\>", 
     ",", "\<\"G$319819\"\>", ",", "\<\"G$319820\"\>", 
     ",", "\<\"G$319825\"\>", ",", "\<\"G$319826\"\>", 
     ",", "\<\"G$319827\"\>", ",", "\<\"G$319832\"\>", 
     ",", "\<\"G$319833\"\>", ",", "\<\"G$319834\"\>", 
     ",", "\<\"G$319842\"\>", ",", "\<\"G$319851\"\>", 
     ",", "\<\"G$319860\"\>", ",", "\<\"G$319866\"\>", 
     ",", "\<\"G$319867\"\>", ",", "\<\"G$319869\"\>", 
     ",", "\<\"G$319878\"\>", ",", "\<\"G$319884\"\>", 
     ",", "\<\"G$319885\"\>", ",", "\<\"G$319887\"\>", 
     ",", "\<\"G$319893\"\>", ",", "\<\"G$319894\"\>", 
     ",", "\<\"G$319896\"\>", ",", "\<\"G$319902\"\>", 
     ",", "\<\"G$319903\"\>", ",", "\<\"G$319905\"\>", 
     ",", "\<\"G$319910\"\>", ",", "\<\"G$319912\"\>", 
     ",", "\<\"G$319918\"\>", ",", "\<\"G$319920\"\>", 
     ",", "\<\"G$319927\"\>", ",", "\<\"G$319929\"\>", 
     ",", "\<\"G$319932\"\>", ",", "\<\"G$319934\"\>", 
     ",", "\<\"G$319936\"\>", ",", "\<\"G$319946\"\>", 
     ",", "\<\"G$319955\"\>", ",", "\<\"G$319964\"\>", 
     ",", "\<\"G$319970\"\>", ",", "\<\"G$319971\"\>", 
     ",", "\<\"G$319973\"\>", ",", "\<\"G$319982\"\>", 
     ",", "\<\"G$319988\"\>", ",", "\<\"G$319989\"\>", 
     ",", "\<\"G$319991\"\>", ",", "\<\"G$319997\"\>", 
     ",", "\<\"G$319998\"\>", ",", "\<\"G$320000\"\>", 
     ",", "\<\"G$320006\"\>", ",", "\<\"G$320007\"\>", 
     ",", "\<\"G$320009\"\>", ",", "\<\"G$320014\"\>", 
     ",", "\<\"G$320021\"\>", ",", "\<\"G$320028\"\>", 
     ",", "\<\"G$320039\"\>", ",", "\<\"G$320048\"\>", 
     ",", "\<\"G$320057\"\>", ",", "\<\"G$320063\"\>", 
     ",", "\<\"G$320064\"\>", ",", "\<\"G$320066\"\>", 
     ",", "\<\"G$320075\"\>", ",", "\<\"G$320081\"\>", 
     ",", "\<\"G$320082\"\>", ",", "\<\"G$320084\"\>", 
     ",", "\<\"G$320090\"\>", ",", "\<\"G$320091\"\>", 
     ",", "\<\"G$320093\"\>", ",", "\<\"G$320099\"\>", 
     ",", "\<\"G$320100\"\>", ",", "\<\"G$320102\"\>", 
     ",", "\<\"G$320111\"\>", ",", "\<\"G$320120\"\>", 
     ",", "\<\"G$320129\"\>", ",", "\<\"G$320135\"\>", 
     ",", "\<\"G$320136\"\>", ",", "\<\"G$320138\"\>", 
     ",", "\<\"G$320147\"\>", ",", "\<\"G$320153\"\>", 
     ",", "\<\"G$320154\"\>", ",", "\<\"G$320156\"\>", 
     ",", "\<\"G$320162\"\>", ",", "\<\"G$320163\"\>", 
     ",", "\<\"G$320165\"\>", ",", "\<\"G$320171\"\>", 
     ",", "\<\"G$320172\"\>", ",", "\<\"G$320174\"\>", 
     ",", "\<\"G$320183\"\>", ",", "\<\"G$320192\"\>", 
     ",", "\<\"G$320201\"\>", ",", "\<\"G$320207\"\>", 
     ",", "\<\"G$320208\"\>", ",", "\<\"G$320210\"\>", 
     ",", "\<\"G$320219\"\>", ",", "\<\"G$320225\"\>", 
     ",", "\<\"G$320226\"\>", ",", "\<\"G$320228\"\>", 
     ",", "\<\"G$320234\"\>", ",", "\<\"G$320235\"\>", 
     ",", "\<\"G$320237\"\>", ",", "\<\"G$320243\"\>", 
     ",", "\<\"G$320244\"\>", ",", "\<\"G$320246\"\>", 
     ",", "\<\"G$321572\"\>", ",", "\<\"G$321578\"\>", 
     ",", "\<\"G$321584\"\>", ",", "\<\"G$321590\"\>", 
     ",", "\<\"G$321596\"\>", ",", "\<\"G$321598\"\>", 
     ",", "\<\"G$321603\"\>", ",", "\<\"G$321605\"\>", 
     ",", "\<\"G$321607\"\>", ",", "\<\"G$321613\"\>", 
     ",", "\<\"G$321614\"\>", ",", "\<\"G$321615\"\>", 
     ",", "\<\"G$321616\"\>", ",", "\<\"G$321620\"\>", 
     ",", "\<\"G$321622\"\>", ",", "\<\"G$321629\"\>", 
     ",", "\<\"G$321635\"\>", ",", "\<\"G$321636\"\>", 
     ",", "\<\"G$321637\"\>", ",", "\<\"G$321645\"\>", 
     ",", "\<\"G$321649\"\>", ",", "\<\"G$321651\"\>", 
     ",", "\<\"G$321652\"\>", ",", "\<\"G$321663\"\>", 
     ",", "\<\"G$321665\"\>", ",", "\<\"G$321671\"\>", 
     ",", "\<\"G$321673\"\>", ",", "\<\"G$321677\"\>", 
     ",", "\<\"G$321681\"\>", ",", "\<\"G$321683\"\>", 
     ",", "\<\"G$321693\"\>", ",", "\<\"G$321702\"\>", 
     ",", "\<\"G$321711\"\>", ",", "\<\"G$321717\"\>", 
     ",", "\<\"G$321718\"\>", ",", "\<\"G$321720\"\>", 
     ",", "\<\"G$321729\"\>", ",", "\<\"G$321735\"\>", 
     ",", "\<\"G$321736\"\>", ",", "\<\"G$321738\"\>", 
     ",", "\<\"G$321744\"\>", ",", "\<\"G$321745\"\>", 
     ",", "\<\"G$321747\"\>", ",", "\<\"G$321753\"\>", 
     ",", "\<\"G$321754\"\>", ",", "\<\"G$321756\"\>", 
     ",", "\<\"G$321765\"\>", ",", "\<\"G$321774\"\>", 
     ",", "\<\"G$321783\"\>", ",", "\<\"G$321789\"\>", 
     ",", "\<\"G$321790\"\>", ",", "\<\"G$321792\"\>", 
     ",", "\<\"G$321801\"\>", ",", "\<\"G$321807\"\>", 
     ",", "\<\"G$321808\"\>", ",", "\<\"G$321810\"\>", 
     ",", "\<\"G$321816\"\>", ",", "\<\"G$321817\"\>", 
     ",", "\<\"G$321819\"\>", ",", "\<\"G$321825\"\>", 
     ",", "\<\"G$321826\"\>", ",", "\<\"G$321828\"\>", 
     ",", "\<\"G$321833\"\>", ",", "\<\"G$321841\"\>", 
     ",", "\<\"G$321842\"\>", ",", "\<\"G$321843\"\>", 
     ",", "\<\"G$321848\"\>", ",", "\<\"G$321849\"\>", 
     ",", "\<\"G$321850\"\>", ",", "\<\"G$321854\"\>", 
     ",", "\<\"G$321865\"\>", ",", "\<\"G$321874\"\>", 
     ",", "\<\"G$321883\"\>", ",", "\<\"G$321889\"\>", 
     ",", "\<\"G$321890\"\>", ",", "\<\"G$321892\"\>", 
     ",", "\<\"G$321901\"\>", ",", "\<\"G$321907\"\>", 
     ",", "\<\"G$321908\"\>", ",", "\<\"G$321910\"\>", 
     ",", "\<\"G$321916\"\>", ",", "\<\"G$321917\"\>", 
     ",", "\<\"G$321919\"\>", ",", "\<\"G$321925\"\>", 
     ",", "\<\"G$321926\"\>", ",", "\<\"G$321928\"\>", 
     ",", "\<\"G$321937\"\>", ",", "\<\"G$321946\"\>", 
     ",", "\<\"G$321955\"\>", ",", "\<\"G$321961\"\>", 
     ",", "\<\"G$321962\"\>", ",", "\<\"G$321964\"\>", 
     ",", "\<\"G$321973\"\>", ",", "\<\"G$321979\"\>", 
     ",", "\<\"G$321980\"\>", ",", "\<\"G$321982\"\>", 
     ",", "\<\"G$321988\"\>", ",", "\<\"G$321989\"\>", 
     ",", "\<\"G$321991\"\>", ",", "\<\"G$321997\"\>", 
     ",", "\<\"G$321998\"\>", ",", "\<\"G$322000\"\>", 
     ",", "\<\"G$322004\"\>", ",", "\<\"G$322005\"\>", 
     ",", "\<\"G$322068\"\>", ",", "\<\"G$322069\"\>", 
     ",", "\<\"G$322124\"\>", ",", "\<\"G$322130\"\>", 
     ",", "\<\"G$322136\"\>", ",", "\<\"G$322148\"\>", 
     ",", "\<\"G$322150\"\>", ",", "\<\"G$322156\"\>", 
     ",", "\<\"G$322158\"\>", ",", "\<\"G$322162\"\>", 
     ",", "\<\"G$322168\"\>", ",", "\<\"G$322170\"\>", 
     ",", "\<\"G$322177\"\>", ",", "\<\"G$322179\"\>", 
     ",", "\<\"G$322184\"\>", ",", "\<\"G$322186\"\>", 
     ",", "\<\"G$322188\"\>", ",", "\<\"G$322190\"\>", 
     ",", "\<\"G$322196\"\>", ",", "\<\"G$322197\"\>", 
     ",", "\<\"G$322198\"\>", ",", "\<\"G$322199\"\>", 
     ",", "\<\"G$322203\"\>", ",", "\<\"G$322205\"\>", 
     ",", "\<\"G$322216\"\>", ",", "\<\"G$322225\"\>", 
     ",", "\<\"G$322234\"\>", ",", "\<\"G$322240\"\>", 
     ",", "\<\"G$322241\"\>", ",", "\<\"G$322243\"\>", 
     ",", "\<\"G$322252\"\>", ",", "\<\"G$322258\"\>", 
     ",", "\<\"G$322259\"\>", ",", "\<\"G$322261\"\>", 
     ",", "\<\"G$322267\"\>", ",", "\<\"G$322268\"\>", 
     ",", "\<\"G$322270\"\>", ",", "\<\"G$322276\"\>", 
     ",", "\<\"G$322277\"\>", ",", "\<\"G$322279\"\>", 
     ",", "\<\"G$322288\"\>", ",", "\<\"G$322297\"\>", 
     ",", "\<\"G$322306\"\>", ",", "\<\"G$322312\"\>", 
     ",", "\<\"G$322313\"\>", ",", "\<\"G$322315\"\>", 
     ",", "\<\"G$322324\"\>", ",", "\<\"G$322330\"\>", 
     ",", "\<\"G$322331\"\>", ",", "\<\"G$322333\"\>", 
     ",", "\<\"G$322339\"\>", ",", "\<\"G$322340\"\>", 
     ",", "\<\"G$322342\"\>", ",", "\<\"G$322348\"\>", 
     ",", "\<\"G$322349\"\>", ",", "\<\"G$322351\"\>", 
     ",", "\<\"G$322361\"\>", ",", "\<\"G$322370\"\>", 
     ",", "\<\"G$322379\"\>", ",", "\<\"G$322385\"\>", 
     ",", "\<\"G$322386\"\>", ",", "\<\"G$322388\"\>", 
     ",", "\<\"G$322397\"\>", ",", "\<\"G$322403\"\>", 
     ",", "\<\"G$322404\"\>", ",", "\<\"G$322406\"\>", 
     ",", "\<\"G$322412\"\>", ",", "\<\"G$322413\"\>", 
     ",", "\<\"G$322415\"\>", ",", "\<\"G$322421\"\>", 
     ",", "\<\"G$322422\"\>", ",", "\<\"G$322424\"\>", 
     ",", "\<\"G$322433\"\>", ",", "\<\"G$322442\"\>", 
     ",", "\<\"G$322451\"\>", ",", "\<\"G$322457\"\>", 
     ",", "\<\"G$322458\"\>", ",", "\<\"G$322460\"\>", 
     ",", "\<\"G$322469\"\>", ",", "\<\"G$322475\"\>", 
     ",", "\<\"G$322476\"\>", ",", "\<\"G$322478\"\>", 
     ",", "\<\"G$322484\"\>", ",", "\<\"G$322485\"\>", 
     ",", "\<\"G$322487\"\>", ",", "\<\"G$322493\"\>", 
     ",", "\<\"G$322494\"\>", ",", "\<\"G$322496\"\>", 
     ",", "\<\"G$322500\"\>", ",", "\<\"G$322501\"\>", 
     ",", "\<\"G$322504\"\>", ",", "\<\"G$322505\"\>", 
     ",", "\<\"G$322538\"\>", ",", "\<\"G$322539\"\>", ",", "\<\"lambda\"\>", 
     ",", "\<\"lambda$\"\>", ",", "\<\"Mprod\"\>", ",", "\<\"mu\"\>", 
     ",", "\<\"nu\"\>", ",", "\<\"omega\"\>", ",", "\<\"omega$316597\"\>", 
     ",", "\<\"omega$316597$\"\>", ",", "\<\"omega$316598\"\>", 
     ",", "\<\"omega$316598$\"\>", ",", "\<\"omega$316599\"\>", 
     ",", "\<\"omega$316599$\"\>", ",", "\<\"omega$316600\"\>", 
     ",", "\<\"omega$316600$\"\>", ",", "\<\"omega$316601\"\>", 
     ",", "\<\"omega$316601$\"\>", ",", "\<\"omega$316602\"\>", 
     ",", "\<\"omega$316602$\"\>", ",", "\<\"omega$316603\"\>", 
     ",", "\<\"omega$316603$\"\>", ",", "\<\"omega$316604\"\>", 
     ",", "\<\"omega$316604$\"\>", ",", "\<\"omega$316605\"\>", 
     ",", "\<\"omega$316605$\"\>", ",", "\<\"omega$316606\"\>", 
     ",", "\<\"omega$316606$\"\>", ",", "\<\"omega$316607\"\>", 
     ",", "\<\"omega$316607$\"\>", ",", "\<\"omega$316608\"\>", 
     ",", "\<\"omega$316608$\"\>", ",", "\<\"omega$316609\"\>", 
     ",", "\<\"omega$316609$\"\>", ",", "\<\"omega$316610\"\>", 
     ",", "\<\"omega$316610$\"\>", ",", "\<\"omega$316640\"\>", 
     ",", "\<\"omega$316640$\"\>", ",", "\<\"omega$316641\"\>", 
     ",", "\<\"omega$316641$\"\>", ",", "\<\"omega$316642\"\>", 
     ",", "\<\"omega$316642$\"\>", ",", "\<\"omega$316643\"\>", 
     ",", "\<\"omega$316643$\"\>", ",", "\<\"omega$316655\"\>", 
     ",", "\<\"omega$316655$\"\>", ",", "\<\"omega$316656\"\>", 
     ",", "\<\"omega$316656$\"\>", ",", "\<\"omega$316657\"\>", 
     ",", "\<\"omega$316657$\"\>", ",", "\<\"omega$316658\"\>", 
     ",", "\<\"omega$316658$\"\>", ",", "\<\"omega$316666\"\>", 
     ",", "\<\"omega$316666$\"\>", ",", "\<\"omega$316667\"\>", 
     ",", "\<\"omega$316667$\"\>", ",", "\<\"omega$316702\"\>", 
     ",", "\<\"omega$316703\"\>", ",", "\<\"omega$316704\"\>", 
     ",", "\<\"omega$316705\"\>", ",", "\<\"omega$316706\"\>", 
     ",", "\<\"omega$316707\"\>", ",", "\<\"omega$316708\"\>", 
     ",", "\<\"omega$316709\"\>", ",", "\<\"omega$316710\"\>", 
     ",", "\<\"omega$316711\"\>", ",", "\<\"omega$316712\"\>", 
     ",", "\<\"omega$316713\"\>", ",", "\<\"omega$316714\"\>", 
     ",", "\<\"omega$316715\"\>", ",", "\<\"omega$316716\"\>", 
     ",", "\<\"omega$316717\"\>", ",", "\<\"omega$316718\"\>", 
     ",", "\<\"omega$316719\"\>", ",", "\<\"omega$316720\"\>", 
     ",", "\<\"omega$316721\"\>", ",", "\<\"omega$316722\"\>", 
     ",", "\<\"omega$316723\"\>", ",", "\<\"omega$316724\"\>", 
     ",", "\<\"omega$316725\"\>", ",", "\<\"omega$316726\"\>", 
     ",", "\<\"omega$316727\"\>", ",", "\<\"omega$316728\"\>", 
     ",", "\<\"omega$316729\"\>", ",", "\<\"omega$316730\"\>", 
     ",", "\<\"omega$316731\"\>", ",", "\<\"omega$316732\"\>", 
     ",", "\<\"omega$316733\"\>", ",", "\<\"omega$316751\"\>", 
     ",", "\<\"omega$316752\"\>", ",", "\<\"omega$316753\"\>", 
     ",", "\<\"omega$316754\"\>", ",", "\<\"omega$316755\"\>", 
     ",", "\<\"omega$316756\"\>", ",", "\<\"omega$316757\"\>", 
     ",", "\<\"omega$316758\"\>", ",", "\<\"omega$316759\"\>", 
     ",", "\<\"omega$316760\"\>", ",", "\<\"omega$316761\"\>", 
     ",", "\<\"omega$316762\"\>", ",", "\<\"omega$316763\"\>", 
     ",", "\<\"omega$316764\"\>", ",", "\<\"omega$316808\"\>", 
     ",", "\<\"omega$316809\"\>", ",", "\<\"omega$316810\"\>", 
     ",", "\<\"omega$316811\"\>", ",", "\<\"omega$316823\"\>", 
     ",", "\<\"omega$316824\"\>", ",", "\<\"omega$316825\"\>", 
     ",", "\<\"omega$316826\"\>", ",", "\<\"omega$316827\"\>", 
     ",", "\<\"omega$316828\"\>", ",", "\<\"omega$316829\"\>", 
     ",", "\<\"omega$316830\"\>", ",", "\<\"omega$316831\"\>", 
     ",", "\<\"omega$316832\"\>", ",", "\<\"omega$316833\"\>", 
     ",", "\<\"omega$316834\"\>", ",", "\<\"omega$316835\"\>", 
     ",", "\<\"omega$316836\"\>", ",", "\<\"omega$316837\"\>", 
     ",", "\<\"omega$316845\"\>", ",", "\<\"omega$316846\"\>", 
     ",", "\<\"omega$316854\"\>", ",", "\<\"omega$316855\"\>", 
     ",", "\<\"omega$316856\"\>", ",", "\<\"omega$316864\"\>", 
     ",", "\<\"omega$316865\"\>", ",", "\<\"omega$316866\"\>", 
     ",", "\<\"omega$316874\"\>", ",", "\<\"omega$316875\"\>", 
     ",", "\<\"omega$316876\"\>", ",", "\<\"omega$316999\"\>", 
     ",", "\<\"omega$316999$\"\>", ",", "\<\"omega$317000\"\>", 
     ",", "\<\"omega$317000$\"\>", ",", "\<\"omega$317001\"\>", 
     ",", "\<\"omega$317001$\"\>", ",", "\<\"omega$317002\"\>", 
     ",", "\<\"omega$317002$\"\>", ",", "\<\"omega$317003\"\>", 
     ",", "\<\"omega$317003$\"\>", ",", "\<\"omega$317004\"\>", 
     ",", "\<\"omega$317004$\"\>", ",", "\<\"omega$317005\"\>", 
     ",", "\<\"omega$317005$\"\>", ",", "\<\"omega$317006\"\>", 
     ",", "\<\"omega$317006$\"\>", ",", "\<\"omega$317007\"\>", 
     ",", "\<\"omega$317007$\"\>", ",", "\<\"omega$317008\"\>", 
     ",", "\<\"omega$317008$\"\>", ",", "\<\"omega$317009\"\>", 
     ",", "\<\"omega$317009$\"\>", ",", "\<\"omega$317010\"\>", 
     ",", "\<\"omega$317010$\"\>", ",", "\<\"omega$317011\"\>", 
     ",", "\<\"omega$317011$\"\>", ",", "\<\"omega$317012\"\>", 
     ",", "\<\"omega$317012$\"\>", ",", "\<\"omega$317042\"\>", 
     ",", "\<\"omega$317042$\"\>", ",", "\<\"omega$317043\"\>", 
     ",", "\<\"omega$317043$\"\>", ",", "\<\"omega$317044\"\>", 
     ",", "\<\"omega$317044$\"\>", ",", "\<\"omega$317045\"\>", 
     ",", "\<\"omega$317045$\"\>", ",", "\<\"omega$317057\"\>", 
     ",", "\<\"omega$317057$\"\>", ",", "\<\"omega$317058\"\>", 
     ",", "\<\"omega$317058$\"\>", ",", "\<\"omega$317059\"\>", 
     ",", "\<\"omega$317059$\"\>", ",", "\<\"omega$317060\"\>", 
     ",", "\<\"omega$317060$\"\>", ",", "\<\"omega$317068\"\>", 
     ",", "\<\"omega$317068$\"\>", ",", "\<\"omega$317069\"\>", 
     ",", "\<\"omega$317069$\"\>", ",", "\<\"omega$317104\"\>", 
     ",", "\<\"omega$317105\"\>", ",", "\<\"omega$317106\"\>", 
     ",", "\<\"omega$317107\"\>", ",", "\<\"omega$317108\"\>", 
     ",", "\<\"omega$317109\"\>", ",", "\<\"omega$317110\"\>", 
     ",", "\<\"omega$317111\"\>", ",", "\<\"omega$317112\"\>", 
     ",", "\<\"omega$317113\"\>", ",", "\<\"omega$317114\"\>", 
     ",", "\<\"omega$317115\"\>", ",", "\<\"omega$317116\"\>", 
     ",", "\<\"omega$317117\"\>", ",", "\<\"omega$317118\"\>", 
     ",", "\<\"omega$317119\"\>", ",", "\<\"omega$317120\"\>", 
     ",", "\<\"omega$317121\"\>", ",", "\<\"omega$317122\"\>", 
     ",", "\<\"omega$317123\"\>", ",", "\<\"omega$317124\"\>", 
     ",", "\<\"omega$317125\"\>", ",", "\<\"omega$317126\"\>", 
     ",", "\<\"omega$317127\"\>", ",", "\<\"omega$317128\"\>", 
     ",", "\<\"omega$317129\"\>", ",", "\<\"omega$317130\"\>", 
     ",", "\<\"omega$317131\"\>", ",", "\<\"omega$317132\"\>", 
     ",", "\<\"omega$317133\"\>", ",", "\<\"omega$317134\"\>", 
     ",", "\<\"omega$317135\"\>", ",", "\<\"omega$317153\"\>", 
     ",", "\<\"omega$317154\"\>", ",", "\<\"omega$317155\"\>", 
     ",", "\<\"omega$317156\"\>", ",", "\<\"omega$317157\"\>", 
     ",", "\<\"omega$317158\"\>", ",", "\<\"omega$317159\"\>", 
     ",", "\<\"omega$317160\"\>", ",", "\<\"omega$317161\"\>", 
     ",", "\<\"omega$317162\"\>", ",", "\<\"omega$317163\"\>", 
     ",", "\<\"omega$317164\"\>", ",", "\<\"omega$317165\"\>", 
     ",", "\<\"omega$317166\"\>", ",", "\<\"omega$317210\"\>", 
     ",", "\<\"omega$317211\"\>", ",", "\<\"omega$317212\"\>", 
     ",", "\<\"omega$317213\"\>", ",", "\<\"omega$317225\"\>", 
     ",", "\<\"omega$317226\"\>", ",", "\<\"omega$317227\"\>", 
     ",", "\<\"omega$317228\"\>", ",", "\<\"omega$317229\"\>", 
     ",", "\<\"omega$317230\"\>", ",", "\<\"omega$317231\"\>", 
     ",", "\<\"omega$317232\"\>", ",", "\<\"omega$317233\"\>", 
     ",", "\<\"omega$317234\"\>", ",", "\<\"omega$317235\"\>", 
     ",", "\<\"omega$317236\"\>", ",", "\<\"omega$317237\"\>", 
     ",", "\<\"omega$317238\"\>", ",", "\<\"omega$317239\"\>", 
     ",", "\<\"omega$317247\"\>", ",", "\<\"omega$317248\"\>", 
     ",", "\<\"omega$317256\"\>", ",", "\<\"omega$317257\"\>", 
     ",", "\<\"omega$317258\"\>", ",", "\<\"omega$317266\"\>", 
     ",", "\<\"omega$317267\"\>", ",", "\<\"omega$317268\"\>", 
     ",", "\<\"omega$317276\"\>", ",", "\<\"omega$317277\"\>", 
     ",", "\<\"omega$317278\"\>", ",", "\<\"omega$319605\"\>", 
     ",", "\<\"omega$319606\"\>", ",", "\<\"omega$319612\"\>", 
     ",", "\<\"omega$319613\"\>", ",", "\<\"omega$319619\"\>", 
     ",", "\<\"omega$319620\"\>", ",", "\<\"omega$319626\"\>", 
     ",", "\<\"omega$319627\"\>", ",", "\<\"omega$319633\"\>", 
     ",", "\<\"omega$319634\"\>", ",", "\<\"omega$319640\"\>", 
     ",", "\<\"omega$319641\"\>", ",", "\<\"omega$319647\"\>", 
     ",", "\<\"omega$319648\"\>", ",", "\<\"omega$319656\"\>", 
     ",", "\<\"omega$319657\"\>", ",", "\<\"omega$319663\"\>", 
     ",", "\<\"omega$319664\"\>", ",", "\<\"omega$319670\"\>", 
     ",", "\<\"omega$319671\"\>", ",", "\<\"omega$319677\"\>", 
     ",", "\<\"omega$319678\"\>", ",", "\<\"omega$319684\"\>", 
     ",", "\<\"omega$319685\"\>", ",", "\<\"omega$319691\"\>", 
     ",", "\<\"omega$319692\"\>", ",", "\<\"omega$319700\"\>", 
     ",", "\<\"omega$319701\"\>", ",", "\<\"omega$319707\"\>", 
     ",", "\<\"omega$319708\"\>", ",", "\<\"omega$319714\"\>", 
     ",", "\<\"omega$319715\"\>", ",", "\<\"omega$319721\"\>", 
     ",", "\<\"omega$319722\"\>", ",", "\<\"omega$319728\"\>", 
     ",", "\<\"omega$319729\"\>", ",", "\<\"omega$319735\"\>", 
     ",", "\<\"omega$319736\"\>", ",", "\<\"omega$319742\"\>", 
     ",", "\<\"omega$319743\"\>", ",", "\<\"omega$319744\"\>", 
     ",", "\<\"omega$319752\"\>", ",", "\<\"omega$319753\"\>", 
     ",", "\<\"omega$319761\"\>", ",", "\<\"omega$319762\"\>", 
     ",", "\<\"omega$319770\"\>", ",", "\<\"omega$319771\"\>", 
     ",", "\<\"omega$319779\"\>", ",", "\<\"omega$319780\"\>", 
     ",", "\<\"omega$319788\"\>", ",", "\<\"omega$319789\"\>", 
     ",", "\<\"omega$319797\"\>", ",", "\<\"omega$319798\"\>", 
     ",", "\<\"omega$319806\"\>", ",", "\<\"omega$319807\"\>", 
     ",", "\<\"omega$319815\"\>", ",", "\<\"omega$319821\"\>", 
     ",", "\<\"omega$319822\"\>", ",", "\<\"omega$319828\"\>", 
     ",", "\<\"omega$319829\"\>", ",", "\<\"omega$319835\"\>", 
     ",", "\<\"omega$319836\"\>", ",", "\<\"omega$319837\"\>", 
     ",", "\<\"omega$319845\"\>", ",", "\<\"omega$319846\"\>", 
     ",", "\<\"omega$319854\"\>", ",", "\<\"omega$319855\"\>", 
     ",", "\<\"omega$319863\"\>", ",", "\<\"omega$319864\"\>", 
     ",", "\<\"omega$319872\"\>", ",", "\<\"omega$319873\"\>", 
     ",", "\<\"omega$319881\"\>", ",", "\<\"omega$319882\"\>", 
     ",", "\<\"omega$319890\"\>", ",", "\<\"omega$319891\"\>", 
     ",", "\<\"omega$319899\"\>", ",", "\<\"omega$319900\"\>", 
     ",", "\<\"omega$319908\"\>", ",", "\<\"omega$319914\"\>", 
     ",", "\<\"omega$319915\"\>", ",", "\<\"omega$319923\"\>", 
     ",", "\<\"omega$319924\"\>", ",", "\<\"omega$319930\"\>", 
     ",", "\<\"omega$319931\"\>", ",", "\<\"omega$319939\"\>", 
     ",", "\<\"omega$319940\"\>", ",", "\<\"omega$319941\"\>", 
     ",", "\<\"omega$319949\"\>", ",", "\<\"omega$319950\"\>", 
     ",", "\<\"omega$319958\"\>", ",", "\<\"omega$319959\"\>", 
     ",", "\<\"omega$319967\"\>", ",", "\<\"omega$319968\"\>", 
     ",", "\<\"omega$319976\"\>", ",", "\<\"omega$319977\"\>", 
     ",", "\<\"omega$319985\"\>", ",", "\<\"omega$319986\"\>", 
     ",", "\<\"omega$319994\"\>", ",", "\<\"omega$319995\"\>", 
     ",", "\<\"omega$320003\"\>", ",", "\<\"omega$320004\"\>", 
     ",", "\<\"omega$320012\"\>", ",", "\<\"omega$320018\"\>", 
     ",", "\<\"omega$320019\"\>", ",", "\<\"omega$320025\"\>", 
     ",", "\<\"omega$320026\"\>", ",", "\<\"omega$320032\"\>", 
     ",", "\<\"omega$320033\"\>", ",", "\<\"omega$320034\"\>", 
     ",", "\<\"omega$320042\"\>", ",", "\<\"omega$320043\"\>", 
     ",", "\<\"omega$320051\"\>", ",", "\<\"omega$320052\"\>", 
     ",", "\<\"omega$320060\"\>", ",", "\<\"omega$320061\"\>", 
     ",", "\<\"omega$320069\"\>", ",", "\<\"omega$320070\"\>", 
     ",", "\<\"omega$320078\"\>", ",", "\<\"omega$320079\"\>", 
     ",", "\<\"omega$320087\"\>", ",", "\<\"omega$320088\"\>", 
     ",", "\<\"omega$320096\"\>", ",", "\<\"omega$320097\"\>", 
     ",", "\<\"omega$320105\"\>", ",", "\<\"omega$320106\"\>", 
     ",", "\<\"omega$320114\"\>", ",", "\<\"omega$320115\"\>", 
     ",", "\<\"omega$320123\"\>", ",", "\<\"omega$320124\"\>", 
     ",", "\<\"omega$320132\"\>", ",", "\<\"omega$320133\"\>", 
     ",", "\<\"omega$320141\"\>", ",", "\<\"omega$320142\"\>", 
     ",", "\<\"omega$320150\"\>", ",", "\<\"omega$320151\"\>", 
     ",", "\<\"omega$320159\"\>", ",", "\<\"omega$320160\"\>", 
     ",", "\<\"omega$320168\"\>", ",", "\<\"omega$320169\"\>", 
     ",", "\<\"omega$320177\"\>", ",", "\<\"omega$320178\"\>", 
     ",", "\<\"omega$320186\"\>", ",", "\<\"omega$320187\"\>", 
     ",", "\<\"omega$320195\"\>", ",", "\<\"omega$320196\"\>", 
     ",", "\<\"omega$320204\"\>", ",", "\<\"omega$320205\"\>", 
     ",", "\<\"omega$320213\"\>", ",", "\<\"omega$320214\"\>", 
     ",", "\<\"omega$320222\"\>", ",", "\<\"omega$320223\"\>", 
     ",", "\<\"omega$320231\"\>", ",", "\<\"omega$320232\"\>", 
     ",", "\<\"omega$320240\"\>", ",", "\<\"omega$320241\"\>", 
     ",", "\<\"omega$320249\"\>", ",", "\<\"omega$321570\"\>", 
     ",", "\<\"omega$321575\"\>", ",", "\<\"omega$321576\"\>", 
     ",", "\<\"omega$321581\"\>", ",", "\<\"omega$321582\"\>", 
     ",", "\<\"omega$321587\"\>", ",", "\<\"omega$321588\"\>", 
     ",", "\<\"omega$321593\"\>", ",", "\<\"omega$321599\"\>", 
     ",", "\<\"omega$321600\"\>", ",", "\<\"omega$321610\"\>", 
     ",", "\<\"omega$321611\"\>", ",", "\<\"omega$321617\"\>", 
     ",", "\<\"omega$321618\"\>", ",", "\<\"omega$321625\"\>", 
     ",", "\<\"omega$321626\"\>", ",", "\<\"omega$321632\"\>", 
     ",", "\<\"omega$321633\"\>", ",", "\<\"omega$321639\"\>", 
     ",", "\<\"omega$321640\"\>", ",", "\<\"omega$321646\"\>", 
     ",", "\<\"omega$321647\"\>", ",", "\<\"omega$321653\"\>", 
     ",", "\<\"omega$321654\"\>", ",", "\<\"omega$321660\"\>", 
     ",", "\<\"omega$321661\"\>", ",", "\<\"omega$321668\"\>", 
     ",", "\<\"omega$321669\"\>", ",", "\<\"omega$321675\"\>", 
     ",", "\<\"omega$321676\"\>", ",", "\<\"omega$321686\"\>", 
     ",", "\<\"omega$321687\"\>", ",", "\<\"omega$321688\"\>", 
     ",", "\<\"omega$321696\"\>", ",", "\<\"omega$321697\"\>", 
     ",", "\<\"omega$321705\"\>", ",", "\<\"omega$321706\"\>", 
     ",", "\<\"omega$321714\"\>", ",", "\<\"omega$321715\"\>", 
     ",", "\<\"omega$321723\"\>", ",", "\<\"omega$321724\"\>", 
     ",", "\<\"omega$321732\"\>", ",", "\<\"omega$321733\"\>", 
     ",", "\<\"omega$321741\"\>", ",", "\<\"omega$321742\"\>", 
     ",", "\<\"omega$321750\"\>", ",", "\<\"omega$321751\"\>", 
     ",", "\<\"omega$321759\"\>", ",", "\<\"omega$321760\"\>", 
     ",", "\<\"omega$321768\"\>", ",", "\<\"omega$321769\"\>", 
     ",", "\<\"omega$321777\"\>", ",", "\<\"omega$321778\"\>", 
     ",", "\<\"omega$321786\"\>", ",", "\<\"omega$321787\"\>", 
     ",", "\<\"omega$321795\"\>", ",", "\<\"omega$321796\"\>", 
     ",", "\<\"omega$321804\"\>", ",", "\<\"omega$321805\"\>", 
     ",", "\<\"omega$321813\"\>", ",", "\<\"omega$321814\"\>", 
     ",", "\<\"omega$321822\"\>", ",", "\<\"omega$321823\"\>", 
     ",", "\<\"omega$321831\"\>", ",", "\<\"omega$321837\"\>", 
     ",", "\<\"omega$321838\"\>", ",", "\<\"omega$321844\"\>", 
     ",", "\<\"omega$321845\"\>", ",", "\<\"omega$321851\"\>", 
     ",", "\<\"omega$321852\"\>", ",", "\<\"omega$321858\"\>", 
     ",", "\<\"omega$321859\"\>", ",", "\<\"omega$321860\"\>", 
     ",", "\<\"omega$321868\"\>", ",", "\<\"omega$321869\"\>", 
     ",", "\<\"omega$321877\"\>", ",", "\<\"omega$321878\"\>", 
     ",", "\<\"omega$321886\"\>", ",", "\<\"omega$321887\"\>", 
     ",", "\<\"omega$321895\"\>", ",", "\<\"omega$321896\"\>", 
     ",", "\<\"omega$321904\"\>", ",", "\<\"omega$321905\"\>", 
     ",", "\<\"omega$321913\"\>", ",", "\<\"omega$321914\"\>", 
     ",", "\<\"omega$321922\"\>", ",", "\<\"omega$321923\"\>", 
     ",", "\<\"omega$321931\"\>", ",", "\<\"omega$321932\"\>", 
     ",", "\<\"omega$321940\"\>", ",", "\<\"omega$321941\"\>", 
     ",", "\<\"omega$321949\"\>", ",", "\<\"omega$321950\"\>", 
     ",", "\<\"omega$321958\"\>", ",", "\<\"omega$321959\"\>", 
     ",", "\<\"omega$321967\"\>", ",", "\<\"omega$321968\"\>", 
     ",", "\<\"omega$321976\"\>", ",", "\<\"omega$321977\"\>", 
     ",", "\<\"omega$321985\"\>", ",", "\<\"omega$321986\"\>", 
     ",", "\<\"omega$321994\"\>", ",", "\<\"omega$321995\"\>", 
     ",", "\<\"omega$322003\"\>", ",", "\<\"omega$322122\"\>", 
     ",", "\<\"omega$322127\"\>", ",", "\<\"omega$322128\"\>", 
     ",", "\<\"omega$322133\"\>", ",", "\<\"omega$322134\"\>", 
     ",", "\<\"omega$322139\"\>", ",", "\<\"omega$322145\"\>", 
     ",", "\<\"omega$322146\"\>", ",", "\<\"omega$322153\"\>", 
     ",", "\<\"omega$322154\"\>", ",", "\<\"omega$322160\"\>", 
     ",", "\<\"omega$322161\"\>", ",", "\<\"omega$322173\"\>", 
     ",", "\<\"omega$322174\"\>", ",", "\<\"omega$322180\"\>", 
     ",", "\<\"omega$322181\"\>", ",", "\<\"omega$322193\"\>", 
     ",", "\<\"omega$322194\"\>", ",", "\<\"omega$322200\"\>", 
     ",", "\<\"omega$322201\"\>", ",", "\<\"omega$322208\"\>", 
     ",", "\<\"omega$322209\"\>", ",", "\<\"omega$322211\"\>", 
     ",", "\<\"omega$322219\"\>", ",", "\<\"omega$322220\"\>", 
     ",", "\<\"omega$322228\"\>", ",", "\<\"omega$322229\"\>", 
     ",", "\<\"omega$322237\"\>", ",", "\<\"omega$322238\"\>", 
     ",", "\<\"omega$322246\"\>", ",", "\<\"omega$322247\"\>", 
     ",", "\<\"omega$322255\"\>", ",", "\<\"omega$322256\"\>", 
     ",", "\<\"omega$322264\"\>", ",", "\<\"omega$322265\"\>", 
     ",", "\<\"omega$322273\"\>", ",", "\<\"omega$322274\"\>", 
     ",", "\<\"omega$322282\"\>", ",", "\<\"omega$322283\"\>", 
     ",", "\<\"omega$322291\"\>", ",", "\<\"omega$322292\"\>", 
     ",", "\<\"omega$322300\"\>", ",", "\<\"omega$322301\"\>", 
     ",", "\<\"omega$322309\"\>", ",", "\<\"omega$322310\"\>", 
     ",", "\<\"omega$322318\"\>", ",", "\<\"omega$322319\"\>", 
     ",", "\<\"omega$322327\"\>", ",", "\<\"omega$322328\"\>", 
     ",", "\<\"omega$322336\"\>", ",", "\<\"omega$322337\"\>", 
     ",", "\<\"omega$322345\"\>", ",", "\<\"omega$322346\"\>", 
     ",", "\<\"omega$322354\"\>", ",", "\<\"omega$322356\"\>", 
     ",", "\<\"omega$322364\"\>", ",", "\<\"omega$322365\"\>", 
     ",", "\<\"omega$322373\"\>", ",", "\<\"omega$322374\"\>", 
     ",", "\<\"omega$322382\"\>", ",", "\<\"omega$322383\"\>", 
     ",", "\<\"omega$322391\"\>", ",", "\<\"omega$322392\"\>", 
     ",", "\<\"omega$322400\"\>", ",", "\<\"omega$322401\"\>", 
     ",", "\<\"omega$322409\"\>", ",", "\<\"omega$322410\"\>", 
     ",", "\<\"omega$322418\"\>", ",", "\<\"omega$322419\"\>", 
     ",", "\<\"omega$322427\"\>", ",", "\<\"omega$322428\"\>", 
     ",", "\<\"omega$322436\"\>", ",", "\<\"omega$322437\"\>", 
     ",", "\<\"omega$322445\"\>", ",", "\<\"omega$322446\"\>", 
     ",", "\<\"omega$322454\"\>", ",", "\<\"omega$322455\"\>", 
     ",", "\<\"omega$322463\"\>", ",", "\<\"omega$322464\"\>", 
     ",", "\<\"omega$322472\"\>", ",", "\<\"omega$322473\"\>", 
     ",", "\<\"omega$322481\"\>", ",", "\<\"omega$322482\"\>", 
     ",", "\<\"omega$322490\"\>", ",", "\<\"omega$322491\"\>", 
     ",", "\<\"omega$322499\"\>", ",", "\<\"rho\"\>", ",", "\<\"sigma\"\>", 
     ",", "\<\"TangentMprod\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "alpha", "alpha$", "beta", "beta$", "eta", "eta$", "f$316380", "f$316380$",
     "f$316381", "f$316381$", "f$316382", "f$316382$", "f$316383", 
    "f$316383$", "f$316384", "f$316384$", "f$316385", "f$316385$", "f$316386",
     "f$316386$", "f$316387", "f$316387$", "f$316388", "f$316388$", 
    "f$316389", "f$316389$", "f$316390", "f$316390$", "f$316391", "f$316391$",
     "f$316392", "f$316392$", "f$316393", "f$316393$", "f$316462", "f$316463",
     "f$316464", "f$316465", "f$316473", "f$316474", "f$316482", "f$316483", 
    "f$316484", "f$319570", "f$319573", "f$319577", "f$319578", "f$319580", 
    "f$319584", "f$319586", "f$319588", "f$319589", "f$319592", "f$319593", 
    "f$319594", "f$319608", "f$319610", "f$319618", "f$319624", "f$319631", 
    "f$319632", "f$319637", "f$319644", "f$319646", "f$319649", "f$319652", 
    "f$319654", "f$319660", "f$319661", "f$319667", "f$319668", "f$319669", 
    "f$319673", "f$319680", "f$319683", "f$319687", "f$319689", "f$319696", 
    "f$319698", "f$319703", "f$319705", "f$319706", "f$319710", "f$319711", 
    "f$319717", "f$319718", "f$319720", "f$319724", "f$319725", "f$319726", 
    "f$319731", "f$319732", "f$319733", "f$319734", "f$319738", "f$319740", 
    "f$319746", "f$319747", "f$319750", "f$319755", "f$319756", "f$319759", 
    "f$319764", "f$319765", "f$319768", "f$319777", "f$319782", "f$319783", 
    "f$319786", "f$319795", "f$319804", "f$319813", "f$319817", "f$319824", 
    "f$319831", "f$319839", "f$319840", "f$319843", "f$319848", "f$319849", 
    "f$319852", "f$319857", "f$319858", "f$319861", "f$319870", "f$319875", 
    "f$319876", "f$319879", "f$319888", "f$319897", "f$319906", "f$319911", 
    "f$319913", "f$319916", "f$319919", "f$319921", "f$319926", "f$319928", 
    "f$319935", "f$319937", "f$319943", "f$319944", "f$319947", "f$319952", 
    "f$319953", "f$319956", "f$319961", "f$319962", "f$319965", "f$319974", 
    "f$319979", "f$319980", "f$319983", "f$319992", "f$320001", "f$320010", 
    "f$320015", "f$320016", "f$320017", "f$320022", "f$320023", "f$320024", 
    "f$320029", "f$320030", "f$320031", "f$320036", "f$320037", "f$320040", 
    "f$320045", "f$320046", "f$320049", "f$320054", "f$320055", "f$320058", 
    "f$320067", "f$320072", "f$320073", "f$320076", "f$320085", "f$320094", 
    "f$320103", "f$320108", "f$320109", "f$320112", "f$320117", "f$320118", 
    "f$320121", "f$320126", "f$320127", "f$320130", "f$320139", "f$320144", 
    "f$320145", "f$320148", "f$320157", "f$320166", "f$320175", "f$320180", 
    "f$320181", "f$320184", "f$320189", "f$320190", "f$320193", "f$320198", 
    "f$320199", "f$320202", "f$320211", "f$320216", "f$320217", "f$320220", 
    "f$320229", "f$320238", "f$320247", "f$321573", "f$321579", "f$321585", 
    "f$321591", "f$321595", "f$321597", "f$321601", "f$321606", "f$321608", 
    "f$321621", "f$321623", "f$321628", "f$321630", "f$321631", "f$321638", 
    "f$321642", "f$321643", "f$321644", "f$321650", "f$321656", "f$321657", 
    "f$321658", "f$321659", "f$321664", "f$321666", "f$321672", "f$321674", 
    "f$321679", "f$321682", "f$321684", "f$321690", "f$321691", "f$321694", 
    "f$321699", "f$321700", "f$321703", "f$321708", "f$321709", "f$321712", 
    "f$321721", "f$321726", "f$321727", "f$321730", "f$321739", "f$321748", 
    "f$321757", "f$321762", "f$321763", "f$321766", "f$321771", "f$321772", 
    "f$321775", "f$321780", "f$321781", "f$321784", "f$321793", "f$321798", 
    "f$321799", "f$321802", "f$321811", "f$321820", "f$321829", "f$321834", 
    "f$321835", "f$321836", "f$321840", "f$321847", "f$321855", "f$321856", 
    "f$321857", "f$321862", "f$321863", "f$321866", "f$321871", "f$321872", 
    "f$321875", "f$321880", "f$321881", "f$321884", "f$321893", "f$321898", 
    "f$321899", "f$321902", "f$321911", "f$321920", "f$321929", "f$321934", 
    "f$321935", "f$321938", "f$321943", "f$321944", "f$321947", "f$321952", 
    "f$321953", "f$321956", "f$321965", "f$321970", "f$321971", "f$321974", 
    "f$321983", "f$321992", "f$322001", "f$322008", "f$322009", "f$322072", 
    "f$322073", "f$322125", "f$322131", "f$322137", "f$322141", "f$322142", 
    "f$322143", "f$322144", "f$322149", "f$322151", "f$322157", "f$322159", 
    "f$322164", "f$322166", "f$322169", "f$322171", "f$322176", "f$322178", 
    "f$322182", "f$322189", "f$322191", "f$322204", "f$322206", "f$322213", 
    "f$322214", "f$322217", "f$322222", "f$322223", "f$322226", "f$322231", 
    "f$322232", "f$322235", "f$322244", "f$322249", "f$322250", "f$322253", 
    "f$322262", "f$322271", "f$322280", "f$322285", "f$322286", "f$322289", 
    "f$322294", "f$322295", "f$322298", "f$322303", "f$322304", "f$322307", 
    "f$322316", "f$322321", "f$322322", "f$322325", "f$322334", "f$322343", 
    "f$322352", "f$322358", "f$322359", "f$322362", "f$322367", "f$322368", 
    "f$322371", "f$322376", "f$322377", "f$322380", "f$322389", "f$322394", 
    "f$322395", "f$322398", "f$322407", "f$322416", "f$322425", "f$322430", 
    "f$322431", "f$322434", "f$322439", "f$322440", "f$322443", "f$322448", 
    "f$322449", "f$322452", "f$322461", "f$322466", "f$322467", "f$322470", 
    "f$322479", "f$322488", "f$322497", "f$322508", "f$322509", "f$322512", 
    "f$322513", "f$322540", "f$322541", "G$316194", "G$316194$", "G$316195", 
    "G$316195$", "G$316196", "G$316196$", "G$316197", "G$316197$", "G$316198",
     "G$316198$", "G$316199", "G$316199$", "G$316200", "G$316200$", 
    "G$316201", "G$316201$", "G$316202", "G$316202$", "G$316203", "G$316203$",
     "G$316204", "G$316204$", "G$316205", "G$316205$", "G$316206", 
    "G$316206$", "G$316207", "G$316207$", "G$316276", "G$316277", "G$316278", 
    "G$316279", "G$316287", "G$316288", "G$316296", "G$316297", "G$316298", 
    "G$319563", "G$319564", "G$319565", "G$319568", "G$319569", "G$319572", 
    "G$319574", "G$319576", "G$319581", "G$319582", "G$319585", "G$319590", 
    "G$319601", "G$319602", "G$319603", "G$319604", "G$319607", "G$319609", 
    "G$319615", "G$319616", "G$319617", "G$319622", "G$319623", "G$319625", 
    "G$319629", "G$319630", "G$319636", "G$319638", "G$319639", "G$319643", 
    "G$319645", "G$319651", "G$319653", "G$319659", "G$319662", "G$319666", 
    "G$319674", "G$319675", "G$319676", "G$319681", "G$319682", "G$319688", 
    "G$319690", "G$319693", "G$319695", "G$319697", "G$319704", "G$319712", 
    "G$319713", "G$319719", "G$319727", "G$319737", "G$319739", "G$319749", 
    "G$319758", "G$319767", "G$319773", "G$319774", "G$319776", "G$319785", 
    "G$319791", "G$319792", "G$319794", "G$319800", "G$319801", "G$319803", 
    "G$319809", "G$319810", "G$319812", "G$319818", "G$319819", "G$319820", 
    "G$319825", "G$319826", "G$319827", "G$319832", "G$319833", "G$319834", 
    "G$319842", "G$319851", "G$319860", "G$319866", "G$319867", "G$319869", 
    "G$319878", "G$319884", "G$319885", "G$319887", "G$319893", "G$319894", 
    "G$319896", "G$319902", "G$319903", "G$319905", "G$319910", "G$319912", 
    "G$319918", "G$319920", "G$319927", "G$319929", "G$319932", "G$319934", 
    "G$319936", "G$319946", "G$319955", "G$319964", "G$319970", "G$319971", 
    "G$319973", "G$319982", "G$319988", "G$319989", "G$319991", "G$319997", 
    "G$319998", "G$320000", "G$320006", "G$320007", "G$320009", "G$320014", 
    "G$320021", "G$320028", "G$320039", "G$320048", "G$320057", "G$320063", 
    "G$320064", "G$320066", "G$320075", "G$320081", "G$320082", "G$320084", 
    "G$320090", "G$320091", "G$320093", "G$320099", "G$320100", "G$320102", 
    "G$320111", "G$320120", "G$320129", "G$320135", "G$320136", "G$320138", 
    "G$320147", "G$320153", "G$320154", "G$320156", "G$320162", "G$320163", 
    "G$320165", "G$320171", "G$320172", "G$320174", "G$320183", "G$320192", 
    "G$320201", "G$320207", "G$320208", "G$320210", "G$320219", "G$320225", 
    "G$320226", "G$320228", "G$320234", "G$320235", "G$320237", "G$320243", 
    "G$320244", "G$320246", "G$321572", "G$321578", "G$321584", "G$321590", 
    "G$321596", "G$321598", "G$321603", "G$321605", "G$321607", "G$321613", 
    "G$321614", "G$321615", "G$321616", "G$321620", "G$321622", "G$321629", 
    "G$321635", "G$321636", "G$321637", "G$321645", "G$321649", "G$321651", 
    "G$321652", "G$321663", "G$321665", "G$321671", "G$321673", "G$321677", 
    "G$321681", "G$321683", "G$321693", "G$321702", "G$321711", "G$321717", 
    "G$321718", "G$321720", "G$321729", "G$321735", "G$321736", "G$321738", 
    "G$321744", "G$321745", "G$321747", "G$321753", "G$321754", "G$321756", 
    "G$321765", "G$321774", "G$321783", "G$321789", "G$321790", "G$321792", 
    "G$321801", "G$321807", "G$321808", "G$321810", "G$321816", "G$321817", 
    "G$321819", "G$321825", "G$321826", "G$321828", "G$321833", "G$321841", 
    "G$321842", "G$321843", "G$321848", "G$321849", "G$321850", "G$321854", 
    "G$321865", "G$321874", "G$321883", "G$321889", "G$321890", "G$321892", 
    "G$321901", "G$321907", "G$321908", "G$321910", "G$321916", "G$321917", 
    "G$321919", "G$321925", "G$321926", "G$321928", "G$321937", "G$321946", 
    "G$321955", "G$321961", "G$321962", "G$321964", "G$321973", "G$321979", 
    "G$321980", "G$321982", "G$321988", "G$321989", "G$321991", "G$321997", 
    "G$321998", "G$322000", "G$322004", "G$322005", "G$322068", "G$322069", 
    "G$322124", "G$322130", "G$322136", "G$322148", "G$322150", "G$322156", 
    "G$322158", "G$322162", "G$322168", "G$322170", "G$322177", "G$322179", 
    "G$322184", "G$322186", "G$322188", "G$322190", "G$322196", "G$322197", 
    "G$322198", "G$322199", "G$322203", "G$322205", "G$322216", "G$322225", 
    "G$322234", "G$322240", "G$322241", "G$322243", "G$322252", "G$322258", 
    "G$322259", "G$322261", "G$322267", "G$322268", "G$322270", "G$322276", 
    "G$322277", "G$322279", "G$322288", "G$322297", "G$322306", "G$322312", 
    "G$322313", "G$322315", "G$322324", "G$322330", "G$322331", "G$322333", 
    "G$322339", "G$322340", "G$322342", "G$322348", "G$322349", "G$322351", 
    "G$322361", "G$322370", "G$322379", "G$322385", "G$322386", "G$322388", 
    "G$322397", "G$322403", "G$322404", "G$322406", "G$322412", "G$322413", 
    "G$322415", "G$322421", "G$322422", "G$322424", "G$322433", "G$322442", 
    "G$322451", "G$322457", "G$322458", "G$322460", "G$322469", "G$322475", 
    "G$322476", "G$322478", "G$322484", "G$322485", "G$322487", "G$322493", 
    "G$322494", "G$322496", "G$322500", "G$322501", "G$322504", "G$322505", 
    "G$322538", "G$322539", "lambda", "lambda$", "Mprod", "mu", "nu", "omega",
     "omega$316597", "omega$316597$", "omega$316598", "omega$316598$", 
    "omega$316599", "omega$316599$", "omega$316600", "omega$316600$", 
    "omega$316601", "omega$316601$", "omega$316602", "omega$316602$", 
    "omega$316603", "omega$316603$", "omega$316604", "omega$316604$", 
    "omega$316605", "omega$316605$", "omega$316606", "omega$316606$", 
    "omega$316607", "omega$316607$", "omega$316608", "omega$316608$", 
    "omega$316609", "omega$316609$", "omega$316610", "omega$316610$", 
    "omega$316640", "omega$316640$", "omega$316641", "omega$316641$", 
    "omega$316642", "omega$316642$", "omega$316643", "omega$316643$", 
    "omega$316655", "omega$316655$", "omega$316656", "omega$316656$", 
    "omega$316657", "omega$316657$", "omega$316658", "omega$316658$", 
    "omega$316666", "omega$316666$", "omega$316667", "omega$316667$", 
    "omega$316702", "omega$316703", "omega$316704", "omega$316705", 
    "omega$316706", "omega$316707", "omega$316708", "omega$316709", 
    "omega$316710", "omega$316711", "omega$316712", "omega$316713", 
    "omega$316714", "omega$316715", "omega$316716", "omega$316717", 
    "omega$316718", "omega$316719", "omega$316720", "omega$316721", 
    "omega$316722", "omega$316723", "omega$316724", "omega$316725", 
    "omega$316726", "omega$316727", "omega$316728", "omega$316729", 
    "omega$316730", "omega$316731", "omega$316732", "omega$316733", 
    "omega$316751", "omega$316752", "omega$316753", "omega$316754", 
    "omega$316755", "omega$316756", "omega$316757", "omega$316758", 
    "omega$316759", "omega$316760", "omega$316761", "omega$316762", 
    "omega$316763", "omega$316764", "omega$316808", "omega$316809", 
    "omega$316810", "omega$316811", "omega$316823", "omega$316824", 
    "omega$316825", "omega$316826", "omega$316827", "omega$316828", 
    "omega$316829", "omega$316830", "omega$316831", "omega$316832", 
    "omega$316833", "omega$316834", "omega$316835", "omega$316836", 
    "omega$316837", "omega$316845", "omega$316846", "omega$316854", 
    "omega$316855", "omega$316856", "omega$316864", "omega$316865", 
    "omega$316866", "omega$316874", "omega$316875", "omega$316876", 
    "omega$316999", "omega$316999$", "omega$317000", "omega$317000$", 
    "omega$317001", "omega$317001$", "omega$317002", "omega$317002$", 
    "omega$317003", "omega$317003$", "omega$317004", "omega$317004$", 
    "omega$317005", "omega$317005$", "omega$317006", "omega$317006$", 
    "omega$317007", "omega$317007$", "omega$317008", "omega$317008$", 
    "omega$317009", "omega$317009$", "omega$317010", "omega$317010$", 
    "omega$317011", "omega$317011$", "omega$317012", "omega$317012$", 
    "omega$317042", "omega$317042$", "omega$317043", "omega$317043$", 
    "omega$317044", "omega$317044$", "omega$317045", "omega$317045$", 
    "omega$317057", "omega$317057$", "omega$317058", "omega$317058$", 
    "omega$317059", "omega$317059$", "omega$317060", "omega$317060$", 
    "omega$317068", "omega$317068$", "omega$317069", "omega$317069$", 
    "omega$317104", "omega$317105", "omega$317106", "omega$317107", 
    "omega$317108", "omega$317109", "omega$317110", "omega$317111", 
    "omega$317112", "omega$317113", "omega$317114", "omega$317115", 
    "omega$317116", "omega$317117", "omega$317118", "omega$317119", 
    "omega$317120", "omega$317121", "omega$317122", "omega$317123", 
    "omega$317124", "omega$317125", "omega$317126", "omega$317127", 
    "omega$317128", "omega$317129", "omega$317130", "omega$317131", 
    "omega$317132", "omega$317133", "omega$317134", "omega$317135", 
    "omega$317153", "omega$317154", "omega$317155", "omega$317156", 
    "omega$317157", "omega$317158", "omega$317159", "omega$317160", 
    "omega$317161", "omega$317162", "omega$317163", "omega$317164", 
    "omega$317165", "omega$317166", "omega$317210", "omega$317211", 
    "omega$317212", "omega$317213", "omega$317225", "omega$317226", 
    "omega$317227", "omega$317228", "omega$317229", "omega$317230", 
    "omega$317231", "omega$317232", "omega$317233", "omega$317234", 
    "omega$317235", "omega$317236", "omega$317237", "omega$317238", 
    "omega$317239", "omega$317247", "omega$317248", "omega$317256", 
    "omega$317257", "omega$317258", "omega$317266", "omega$317267", 
    "omega$317268", "omega$317276", "omega$317277", "omega$317278", 
    "omega$319605", "omega$319606", "omega$319612", "omega$319613", 
    "omega$319619", "omega$319620", "omega$319626", "omega$319627", 
    "omega$319633", "omega$319634", "omega$319640", "omega$319641", 
    "omega$319647", "omega$319648", "omega$319656", "omega$319657", 
    "omega$319663", "omega$319664", "omega$319670", "omega$319671", 
    "omega$319677", "omega$319678", "omega$319684", "omega$319685", 
    "omega$319691", "omega$319692", "omega$319700", "omega$319701", 
    "omega$319707", "omega$319708", "omega$319714", "omega$319715", 
    "omega$319721", "omega$319722", "omega$319728", "omega$319729", 
    "omega$319735", "omega$319736", "omega$319742", "omega$319743", 
    "omega$319744", "omega$319752", "omega$319753", "omega$319761", 
    "omega$319762", "omega$319770", "omega$319771", "omega$319779", 
    "omega$319780", "omega$319788", "omega$319789", "omega$319797", 
    "omega$319798", "omega$319806", "omega$319807", "omega$319815", 
    "omega$319821", "omega$319822", "omega$319828", "omega$319829", 
    "omega$319835", "omega$319836", "omega$319837", "omega$319845", 
    "omega$319846", "omega$319854", "omega$319855", "omega$319863", 
    "omega$319864", "omega$319872", "omega$319873", "omega$319881", 
    "omega$319882", "omega$319890", "omega$319891", "omega$319899", 
    "omega$319900", "omega$319908", "omega$319914", "omega$319915", 
    "omega$319923", "omega$319924", "omega$319930", "omega$319931", 
    "omega$319939", "omega$319940", "omega$319941", "omega$319949", 
    "omega$319950", "omega$319958", "omega$319959", "omega$319967", 
    "omega$319968", "omega$319976", "omega$319977", "omega$319985", 
    "omega$319986", "omega$319994", "omega$319995", "omega$320003", 
    "omega$320004", "omega$320012", "omega$320018", "omega$320019", 
    "omega$320025", "omega$320026", "omega$320032", "omega$320033", 
    "omega$320034", "omega$320042", "omega$320043", "omega$320051", 
    "omega$320052", "omega$320060", "omega$320061", "omega$320069", 
    "omega$320070", "omega$320078", "omega$320079", "omega$320087", 
    "omega$320088", "omega$320096", "omega$320097", "omega$320105", 
    "omega$320106", "omega$320114", "omega$320115", "omega$320123", 
    "omega$320124", "omega$320132", "omega$320133", "omega$320141", 
    "omega$320142", "omega$320150", "omega$320151", "omega$320159", 
    "omega$320160", "omega$320168", "omega$320169", "omega$320177", 
    "omega$320178", "omega$320186", "omega$320187", "omega$320195", 
    "omega$320196", "omega$320204", "omega$320205", "omega$320213", 
    "omega$320214", "omega$320222", "omega$320223", "omega$320231", 
    "omega$320232", "omega$320240", "omega$320241", "omega$320249", 
    "omega$321570", "omega$321575", "omega$321576", "omega$321581", 
    "omega$321582", "omega$321587", "omega$321588", "omega$321593", 
    "omega$321599", "omega$321600", "omega$321610", "omega$321611", 
    "omega$321617", "omega$321618", "omega$321625", "omega$321626", 
    "omega$321632", "omega$321633", "omega$321639", "omega$321640", 
    "omega$321646", "omega$321647", "omega$321653", "omega$321654", 
    "omega$321660", "omega$321661", "omega$321668", "omega$321669", 
    "omega$321675", "omega$321676", "omega$321686", "omega$321687", 
    "omega$321688", "omega$321696", "omega$321697", "omega$321705", 
    "omega$321706", "omega$321714", "omega$321715", "omega$321723", 
    "omega$321724", "omega$321732", "omega$321733", "omega$321741", 
    "omega$321742", "omega$321750", "omega$321751", "omega$321759", 
    "omega$321760", "omega$321768", "omega$321769", "omega$321777", 
    "omega$321778", "omega$321786", "omega$321787", "omega$321795", 
    "omega$321796", "omega$321804", "omega$321805", "omega$321813", 
    "omega$321814", "omega$321822", "omega$321823", "omega$321831", 
    "omega$321837", "omega$321838", "omega$321844", "omega$321845", 
    "omega$321851", "omega$321852", "omega$321858", "omega$321859", 
    "omega$321860", "omega$321868", "omega$321869", "omega$321877", 
    "omega$321878", "omega$321886", "omega$321887", "omega$321895", 
    "omega$321896", "omega$321904", "omega$321905", "omega$321913", 
    "omega$321914", "omega$321922", "omega$321923", "omega$321931", 
    "omega$321932", "omega$321940", "omega$321941", "omega$321949", 
    "omega$321950", "omega$321958", "omega$321959", "omega$321967", 
    "omega$321968", "omega$321976", "omega$321977", "omega$321985", 
    "omega$321986", "omega$321994", "omega$321995", "omega$322003", 
    "omega$322122", "omega$322127", "omega$322128", "omega$322133", 
    "omega$322134", "omega$322139", "omega$322145", "omega$322146", 
    "omega$322153", "omega$322154", "omega$322160", "omega$322161", 
    "omega$322173", "omega$322174", "omega$322180", "omega$322181", 
    "omega$322193", "omega$322194", "omega$322200", "omega$322201", 
    "omega$322208", "omega$322209", "omega$322211", "omega$322219", 
    "omega$322220", "omega$322228", "omega$322229", "omega$322237", 
    "omega$322238", "omega$322246", "omega$322247", "omega$322255", 
    "omega$322256", "omega$322264", "omega$322265", "omega$322273", 
    "omega$322274", "omega$322282", "omega$322283", "omega$322291", 
    "omega$322292", "omega$322300", "omega$322301", "omega$322309", 
    "omega$322310", "omega$322318", "omega$322319", "omega$322327", 
    "omega$322328", "omega$322336", "omega$322337", "omega$322345", 
    "omega$322346", "omega$322354", "omega$322356", "omega$322364", 
    "omega$322365", "omega$322373", "omega$322374", "omega$322382", 
    "omega$322383", "omega$322391", "omega$322392", "omega$322400", 
    "omega$322401", "omega$322409", "omega$322410", "omega$322418", 
    "omega$322419", "omega$322427", "omega$322428", "omega$322436", 
    "omega$322437", "omega$322445", "omega$322446", "omega$322454", 
    "omega$322455", "omega$322463", "omega$322464", "omega$322472", 
    "omega$322473", "omega$322481", "omega$322482", "omega$322490", 
    "omega$322491", "omega$322499", "rho", "sigma", "TangentMprod"}],
  Editable->
   False]], "Print",ExpressionUUID->"3dbc3faf-bf9b-4960-a6f8-dcbecfba8ed1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.8. ChangeFreeIndices, EqualExpressionsQ", \
"Subsection",ExpressionUUID->"9fea7177-adac-4400-9d2c-b052db7a40b9"],

Cell["\<\
This function changes the free indices of an expression. Currently we assume, \
and do not check, that all indices belong to the same manifold. This is the \
main driver, which separates the work in three steps:\
\>", "Text",ExpressionUUID->"1dfbe895-13b3-475f-8f14-ce477d9cff42"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ChangeFreeIndices", "[", 
    RowBox[{"0", ",", "newfrees_List"}], "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ChangeFreeIndices", "[", 
    RowBox[{"expr_", ",", "newfrees_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"frees", ",", "dummies", ",", "newexpr"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"frees", ",", "dummies"}], "}"}], "=", 
       RowBox[{"FindFreeAndDummyIndices", "[", "expr", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"checkChangeFreeIndices", "[", 
       RowBox[{
        RowBox[{"List", "@@", "frees"}], ",", "newfrees"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"newexpr", "=", 
       RowBox[{"arrangedummies", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"List", "@@", "dummies"}], ",", "newfrees"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"changeFreeIndices", "[", 
       RowBox[{"newexpr", ",", 
        RowBox[{"List", "@@", 
         RowBox[{"IndexSort", "[", "frees", "]"}]}], ",", "newfrees"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ChangeFreeIndices", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "ChangeFreeIndices", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"2fd6edac-398b-42ca-ad82-7db4da15fdae"],

Cell["\<\
The first step is a series of checks to ensure that the suggested new dummies \
are consistent with the expression. There is the important problem of the \
character of the indices, not solved yet:\
\>", "Text",ExpressionUUID->"27c3ee48-8e85-41b0-82cf-7d42e57e92d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"metricendQ", "[", 
    RowBox[{"{", 
     RowBox[{"vbundle_", ",", "tf_"}], "}"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"MetricEndowedQ", "[", "vbundle", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"vbundle", ",", "Null"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"vbundle", ",", "tf"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5fa19c70-f9ea-4e9c-bb70-e886a3283161"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"checkChangeFreeIndices", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "Null"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"checkChangeFreeIndices", "[", 
   RowBox[{"frees_List", ",", "newfrees_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"manichars", ",", "newmanichars", ",", "ups"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"Check1", ":", " ", 
      RowBox[{
      "Equal", " ", "number", " ", "of", " ", "free", " ", "indices"}]}], " ",
      "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "frees", "]"}], "=!=", 
        RowBox[{"Length", "[", "newfrees", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ChangeFreeIndices", "::", "error"}], ",", 
          "\"\<Inconsistent number of free indices.\>\""}], "]"}]}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Check2", ":", " ", 
       RowBox[{"All", " ", "abstract", " ", "indices"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{"AIndexQ", "[", "#", "]"}], "]"}], ",", 
         RowBox[{"Throw", "[", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"ChangeFreeIndices", "::", "invalid"}], ",", "#", ",", 
            "\"\<abstract index\>\""}], "]"}], "]"}]}], "]"}], "&"}], "/@", 
      RowBox[{"Join", "[", 
       RowBox[{"frees", ",", "newfrees"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Check3", ":", " ", 
       RowBox[{
       "Consistent", " ", "vbundles", " ", "and", " ", "characters", " ", 
        "of", " ", "free", " ", "indices"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"manichars", "=", 
      RowBox[{"metricendQ", "/@", 
       RowBox[{"(", 
        RowBox[{"VBundleUpQ", "/@", "frees"}], ")"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"newmanichars", "=", 
      RowBox[{"metricendQ", "/@", 
       RowBox[{"(", 
        RowBox[{"VBundleUpQ", "/@", "newfrees"}], ")"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sort", "[", "manichars", "]"}], "=!=", 
        RowBox[{"Sort", "[", "newmanichars", "]"}]}], ",", 
       RowBox[{"Throw", "@", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"ChangeFreeIndices", "::", "error"}], ",", 
          "\"\<Inconsistent vbundles or characters of free indices.\>\""}], 
         "]"}]}]}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 
 InitializationCell->
  True,ExpressionUUID->"c7aa886d-bba2-4b96-9f4a-274048c17482"],

Cell["\<\
The second step removes any possible collision between dummies of expr and \
the new free indices:\
\>", "Text",ExpressionUUID->"db734508-5a51-4baf-a52a-955d7aa422ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"arrangedummies", "[", 
    RowBox[{"expr_", ",", "dummies_List", ",", "newfrees_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nodummies", ",", "newdummies"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"nodummies", "=", 
       RowBox[{"Intersection", "[", 
        RowBox[{"dummies", ",", 
         RowBox[{"UpIndex", "/@", "newfrees"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"newdummies", "=", 
       RowBox[{"DummyAs", "/@", "nodummies"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ReplaceIndex", "[", 
       RowBox[{"expr", ",", 
        RowBox[{"DuplicateRule", "/@", 
         RowBox[{"Inner", "[", 
          RowBox[{"Rule", ",", "nodummies", ",", "newdummies", ",", "List"}], 
          "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"451e470c-a5c3-410b-9c12-1ac3cd36f6bf"],

Cell["The third step performs the actual replacement of dummies:", \
"Text",ExpressionUUID->"51dea27d-0b80-46c2-a209-18323660fce5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"changeFreeIndices", "[", 
   RowBox[{"expr_", ",", "sortedfrees_List", ",", "newfrees_List"}], "]"}], ":=", 
  RowBox[{"ReplaceIndex", "[", 
   RowBox[{"expr", ",", 
    RowBox[{"Inner", "[", 
     RowBox[{"Rule", ",", "sortedfrees", ",", "newfrees", ",", "List"}], 
     "]"}]}], "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"5923dc1b-8648-4913-9fac-19f3ba11d70d"],

Cell["\<\
There is a fourth function checking whether the permutation is consistent \
from the point of view of characters and manifolds:\
\>", "Text",ExpressionUUID->"6b2ea932-1408-4553-8a35-b86ed0fb3328"],

Cell[BoxData[
 RowBox[{
  RowBox[{"manicharpermQ", "[", 
   RowBox[{"sortedfrees2_", ",", "frees1_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"metricendQ", "/@", 
     RowBox[{"VBundleUpQ", "/@", "sortedfrees2"}]}], ")"}], "===", 
   RowBox[{"(", 
    RowBox[{"metricendQ", "/@", 
     RowBox[{"VBundleUpQ", "/@", "frees1"}]}], ")"}]}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"c1f5dafa-e0ad-4c7b-a3d6-1c349419cd4f"],

Cell["\<\
Finally, this is the function which performs the comparison between any two \
expressions:\
\>", "Text",ExpressionUUID->"b61b8de9-5bbc-4e8e-b787-5b229e677fc0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"EqualExpressionsQ", "[", 
    RowBox[{"expr1_", ",", "expr2_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "frees1", ",", "frees2", ",", "dummies2", ",", "sortedfrees2", ",", 
       "perms1", ",", "arrexpr2", ",", "newexpr2", ",", "count", ",", 
       RowBox[{"result", "=", "False"}], ",", "perm", ",", "xxx", ",", 
       "equation", ",", "solution"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Indices", " ", "of", " ", "expr1"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"frees1", "=", 
       RowBox[{"List", "@@", 
        RowBox[{"FindFreeIndices", "[", "expr1", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Indices", " ", "of", " ", "expr2"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"frees2", ",", "dummies2"}], "}"}], "=", 
       RowBox[{"FindFreeAndDummyIndices", "[", "expr2", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sortedfrees2", "=", 
       RowBox[{"List", "@@", 
        RowBox[{"IndexSort", "[", "frees2", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dummies2", "=", 
       RowBox[{"List", "@@", "dummies2"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"checkChangeFreeIndices", "[", 
       RowBox[{"frees1", ",", "sortedfrees2"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "All", " ", "permutations", " ", "of", " ", "the", " ", "free", " ", 
        "indices", " ", "of", " ", "expr1"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"perms1", "=", 
       RowBox[{"Permutations", "[", 
        RowBox[{"List", "@@", "frees1"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Remove", " ", "collisions", " ", "between", " ", "frees1", " ", "and",
         " ", "dummies2"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"arrexpr2", "=", 
       RowBox[{"arrangedummies", "[", 
        RowBox[{"expr2", ",", "dummies2", ",", "frees1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"DefConstantSymbol", "[", 
       RowBox[{"xxx", ",", 
        RowBox[{"DefInfo", "\[Rule]", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"newexpr2", "=", 
          RowBox[{"changeFreeIndices", "[", 
           RowBox[{"arrexpr2", ",", "sortedfrees2", ",", 
            RowBox[{"perms1", "[", 
             RowBox[{"[", "count", "]"}], "]"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"equation", "=", 
          RowBox[{"ToCanonical", "[", 
           RowBox[{"expr1", "-", 
            RowBox[{"xxx", " ", "newexpr2"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"solution", "=", 
          RowBox[{"First", "[", 
           RowBox[{"xxx", "/.", 
            RowBox[{"Solve", "[", 
             RowBox[{
              RowBox[{"equation", "\[Equal]", "0"}], ",", "xxx"}], "]"}]}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ConstantQ", "[", "solution", "]"}], ",", 
           RowBox[{
            RowBox[{"result", "=", "True"}], ";", 
            RowBox[{"perm", "=", 
             RowBox[{"Inner", "[", 
              RowBox[{"Rule", ",", 
               RowBox[{"perms1", "[", 
                RowBox[{"[", "count", "]"}], "]"}], ",", "sortedfrees2", ",", 
               "List"}], "]"}]}], ";", 
            RowBox[{"Break", "[", "]"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"count", ",", 
          RowBox[{"Length", "[", "perms1", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"result", ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<LEFT  == \>\"", ",", 
          RowBox[{"Switch", "[", 
           RowBox[{"solution", ",", "1", ",", "\"\<\>\"", ",", 
            RowBox[{"-", "1"}], ",", "\"\<-\>\"", ",", "_", ",", "solution"}],
            "]"}], ",", "\"\< RIGHT   with rules: \>\"", ",", "perm"}], 
         "]"}]}], "]"}], ";", "\[IndentingNewLine]", "result"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"EqualExpressionsQ", ",", "2"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "EqualExpressionsQ", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"361ccac5-f1af-4a31-8aca-e3b8a5a3ecaa"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"c8938d5c-d556-45b5-a113-1bc497fe5771"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"f1b38317-a736-4c3a-8fab-07a35bfa8a29"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"62797c11-8cbd-4488-bf80-dbaf1774e77e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"d223762f-a624-452d-989c-3097657a4a73"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dcf190e1-7b98-4519-9c40-ab2e319650f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"C", ",", "D", ",", "F"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"b1b9155d-b382-406d-921d-f3574646a530"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ChangeFreeIndices", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Inconsistent number of free indices.\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"938a3900-9fac-4998-a032-387565e159e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "D"}]}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"41c2a550-0be4-4d37-9d8a-1c67955c2aa0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ChangeFreeIndices", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Inconsistent vbundles or characters of free \
indices.\\\"\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e98962e1-ad28-4299-9c75-9fbfa868e41f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"{", 
       RowBox[{"D", ",", "Polar"}], "}"}]}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"2a680bd7-c38a-4ff7-9e6d-97c2fe1d5cc7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ChangeFreeIndices", "::", "invalid"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\({D, Polar}\\)\[NoBreak] is not a valid \[NoBreak]\
\\!\\(\\\"abstract index\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4b7bd7ed-5389-4667-81c5-1b5d1e5a5abb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"56b8c2a9-b682-4c84-b7bc-fb72f4a04e91"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ChangeFreeIndices", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Inconsistent vbundles or characters of free \
indices.\\\"\\)\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"2d97bed0-f494-4ef7-97cf-386857eb5f52"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Catch", "@", 
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "A"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"C", ",", 
      RowBox[{"-", "D"}]}], "}"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"02242651-e527-4e56-a581-5db5a8217f7e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {" ", "C"},
         {"D", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[-D, C],
  Editable->
   False]], "Output",ExpressionUUID->"284f4a53-cffa-4391-913f-5ac36dcfd231"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeFreeIndices", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"B", ",", "A"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"C", ",", "D"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"03fc079b-4b6a-424b-93c6-8605cbdb3200"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"D", "C"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`T[D, C],
  Editable->
   False]], "Output",ExpressionUUID->"8a2f7fde-759e-473f-b39d-a3fc14cf473b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeFreeIndices", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "B"}], "]"}]}], ",", 
   RowBox[{"{", "C", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1fb7b5d3-6b5e-42f7-9697-49336494cbbb"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"C", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[C, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"6b8e7dbc-80b5-4264-88e7-82f90a75bef7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "B"}], "]"}]}], ",", 
    RowBox[{"{", "B", "}"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"0e395505-c1a2-4529-ad95-6a60ff7c8519"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "A"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"3ef387a8-c0e2-4caf-87b5-cafb556950c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ChangeFreeIndices", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "B"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "D"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"B", ",", "D"}], "}"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"190f7940-6e89-4e8d-9b05-d5fa315f9889"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", "A", "D", "C"},
          {" ", " ", " ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`B, $CellContext`A, D, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-C],
   Editable->
    False]}]], "Output",ExpressionUUID->"0f6ed2a3-aaf4-4183-9660-19d67b001ffc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EqualExpressionsQ", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "B"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "D"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"79303ef2-9384-4979-a531-24c2deacafb6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LEFT  == \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", "\<\" RIGHT   with rules: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{"A", "\[Rule]", "C"}], "}"}]}],
  SequenceForm[
  "LEFT  == ", "", " RIGHT   with rules: ", {$CellContext`A -> C}],
  Editable->
   False]], "Print",ExpressionUUID->"f54d09a0-0759-48a3-8e8f-3101c02b1930"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"00f03fe3-08df-4927-a6c7-2a5ec0a31b2d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EqualExpressionsQ", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "D"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "D", ",", "A", ",", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"854296cc-667c-4e76-ad77-60837d519d44"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LEFT  == \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", "\<\" RIGHT   with rules: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "B"}], ",", 
     RowBox[{"B", "\[Rule]", "D"}]}], "}"}]}],
  SequenceForm[
  "LEFT  == ", "", 
   " RIGHT   with rules: ", {$CellContext`A -> $CellContext`B, $CellContext`B -> 
    D}],
  Editable->
   False]], "Print",ExpressionUUID->"4bb1e125-827a-4fe4-a7c0-2f844aaa44f2"],

Cell[BoxData["True"], \
"Output",ExpressionUUID->"c2840d1c-7bfe-4df7-a1cd-4e1cb69da7d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EqualExpressionsQ", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "D"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "D", ",", "A", ",", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "D"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"ff4dce88-96ac-42b6-a7cc-37cae4427038"],

Cell[BoxData["False"], \
"Output",ExpressionUUID->"025276b6-cd78-48dc-89b4-f7a44b5d20d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"T", ",", "v"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"a71a9cba-4821-431b-9fc7-7ae1e7b59833"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"59f4ca05-0474-440e-8763-9647041ec6c9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"8f0ff26b-1082-4dc8-b40f-ccd65bd03938"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"69173ba9-2eda-4bfe-b57d-c0ad524d492a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"G$327153\"\>", ",", "\<\"G$327158\"\>", 
     ",", "\<\"G$327159\"\>", ",", "\<\"G$327177\"\>", 
     ",", "\<\"G$327197\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "G$327153", "G$327158", "G$327159", "G$327177", "G$327197"}],
  Editable->
   False]], "Print",ExpressionUUID->"7c0a2984-1447-4536-b7c5-8e77e339963c"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["16.9. Listable functions and equations", \
"Subsection",ExpressionUUID->"583b4a6c-c1c1-4469-8770-1d76098179c2"],

Cell["\<\
A little flexibility using the fact that Equal is essentially a specialized \
2-arg form of List:\
\>", "Text",ExpressionUUID->"8fb8782b-d370-4e4d-ae63-afd247363f4b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ListableQ", "[", 
    RowBox[{"f", ":", 
     RowBox[{"(", 
      RowBox[{"_Symbol", "|", "_String"}], ")"}]}], "]"}], ":=", 
   RowBox[{"MemberQ", "[", 
    RowBox[{
     RowBox[{"Attributes", "[", "f", "]"}], ",", "Listable"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListableQ", "[", "_", "]"}], ":=", "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "Equal", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Equal", "/:", 
   RowBox[{"Plus", "[", 
    RowBox[{
     RowBox[{"Equal", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", 
     RowBox[{"Equal", "[", 
      RowBox[{"c_", ",", "d_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Equal", "[", 
    RowBox[{
     RowBox[{"Plus", "[", 
      RowBox[{"a", ",", "c"}], "]"}], ",", 
     RowBox[{"Plus", "[", 
      RowBox[{"b", ",", "d"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Equal", "/:", 
   RowBox[{"Times", "[", 
    RowBox[{
     RowBox[{"Equal", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", 
     RowBox[{"Equal", "[", 
      RowBox[{"c_", ",", "d_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Equal", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{"a", ",", "c"}], "]"}], ",", 
     RowBox[{"Times", "[", 
      RowBox[{"b", ",", "d"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Equal", "/:", 
   RowBox[{"Power", "[", 
    RowBox[{
     RowBox[{"Equal", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], ",", 
     RowBox[{"Equal", "[", 
      RowBox[{"c_", ",", "d_"}], "]"}]}], "]"}], ":=", 
   RowBox[{"Equal", "[", 
    RowBox[{
     RowBox[{"Power", "[", 
      RowBox[{"a", ",", "c"}], "]"}], ",", 
     RowBox[{"Power", "[", 
      RowBox[{"b", ",", "d"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Equal", "/:", 
   RowBox[{
    RowBox[{"f_", "?", "ListableQ"}], "[", 
    RowBox[{"l___", ",", "eq_Equal", ",", "r___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"l", ",", "#", ",", "r"}], "]"}], "&"}], "/@", "eq"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Equal", "]"}], ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"4bfa3f50-eb2a-4038-91e8-68231a09690b"],

Cell["Examples:", \
"Text",ExpressionUUID->"89784249-3ebe-46c5-b3d9-222d7ac3e6af"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"d120c771-075f-4f5b-8aa4-f14e0ec0f882"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "\[Equal]", "b"}], ")"}], "+", 
  "c"}]], "Input",ExpressionUUID->"968fca09-4bca-4501-b47c-c6f257d88ab8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "+", "c"}], "\[Equal]", 
  RowBox[{
  "b", "+", 
   "c"}]}]], "Output",ExpressionUUID->"36ab2d81-9cc0-4072-9d96-250d6bdb5ad9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "==", "b"}], ")"}], 
  "c"}]], "Input",ExpressionUUID->"27493a81-6309-4945-a904-c977267a0545"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", " ", "c"}], "\[Equal]", 
  RowBox[{
  "b", " ", 
   "c"}]}]], "Output",ExpressionUUID->"2414d530-a8c2-4801-b40e-2dd3d7ec0bed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "\[Equal]", "b"}], ")"}], "^", 
  "2"}]], "Input",ExpressionUUID->"a785a184-2aeb-4ee3-8d04-dbbc3b99f64a"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["a", "2"], "\[Equal]", 
  SuperscriptBox["b", 
   "2"]}]], "Output",ExpressionUUID->"f55ebfe2-af49-4aeb-a943-d257671d8928"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "\[Equal]", "b"}], ")"}], 
  RowBox[{"(", 
   RowBox[{"c", "\[Equal]", "d"}], 
   ")"}]}]], "Input",ExpressionUUID->"c047899b-700f-43bf-8444-8ff03bbde4a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", " ", "c"}], "\[Equal]", 
  RowBox[{
  "b", " ", 
   "d"}]}]], "Output",ExpressionUUID->"71ca5e97-ea29-4c23-a1ac-d7e388c4c889"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "\[Equal]", "b"}], ")"}], "+", 
  RowBox[{"(", 
   RowBox[{"c", "\[Equal]", "d"}], 
   ")"}]}]], "Input",ExpressionUUID->"fcdf0464-018a-44dc-ab88-faf45137d3d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "+", "c"}], "\[Equal]", 
  RowBox[{
  "b", "+", 
   "d"}]}]], "Output",ExpressionUUID->"456c099a-c986-4e56-a6d3-85764d4e92fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "\[Equal]", "b"}], ")"}], "^", 
  RowBox[{"(", 
   RowBox[{"c", "\[Equal]", "d"}], 
   ")"}]}]], "Input",ExpressionUUID->"6bce1312-0a93-4541-87a6-b90a965347ed"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["a", "c"], "\[Equal]", 
  SuperscriptBox["b", 
   "d"]}]], "Output",ExpressionUUID->"ec5e3bc5-09f0-49bc-aaef-c07158e4e1f3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"dc2e289a-f16a-4a7a-a173-e863334bc8e2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["17. Control of evaluation (ExpressionManipulation)",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"fe8f32fd-e38c-4b43-bacb-9cd3e91cfa9c"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
    "**"}], "*", " ", "17.", "Evaluation"}], " ", 
  "***************************)"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"62bf7e99-effc-4322-9426-0eb1e1fd2143"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"cdb7d9a8-6288-49d7-b905-6c1386705945"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "90.029868`", ",", "756.502432`9.330355322025017", ",", 
   "0.11900807566442016`"}], 
  "}"}]], "Output",ExpressionUUID->"866e3895-4d83-4eff-842f-f7c6994377df"]
}, Open  ]],

Cell[CellGroupData[{

Cell["17.0. Comments", \
"Subsection",ExpressionUUID->"0788c559-39c3-463e-af98-6cff68656f6f"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$ReadingVerbose", ",", 
   RowBox[{
   "Print", "[", "\"\<Reading section 17: ExpressionManipulation.\>\"", "]"}],
    ",", "Null", ",", "Null"}], "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6c336ee3-4781-4b43-893e-94fea3f2a06f"],

Cell[BoxData[
 RowBox[{"<<", 
  "xAct`ExpressionManipulation`"}]], \
"Input",ExpressionUUID->"bc438831-0537-4718-a5b5-d3d7b1327ce8"]
}, Closed]],

Cell[CellGroupData[{

Cell["17.1. (Color) Positions of an expression", \
"Subsection",ExpressionUUID->"fd8cab6e-984e-4717-9241-cb0b99a55326"],

Cell["Two new functions defined in terms of ColorPositions:", \
"Text",ExpressionUUID->"02710aa0-c271-40dc-905f-f3516b483e84"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ColorPositionsOfPattern"}]], \
"Input",ExpressionUUID->"b37908e8-679f-49b6-ae8a-58ae84c9edb9"],

Cell[BoxData[
 StyleBox["\<\"ColoPositionsOfPattern[pattern][expr] uses the function \
ColorPositions (from the package ExpressionManipulation) to color the \
occurrences of pattern in expr, tagging them with their respective positions. \
Options can be passed to ColorPositions within the first pair of \
brackets.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578673026-5338953",ExpressionUUID->"72eff1e1-3a83-4e96-bd2a-\
88d82560fad4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "ColorTerms"}]], \
"Input",ExpressionUUID->"111990b2-d5dd-4095-b383-d6b38b409e69"],

Cell[BoxData[
 StyleBox["\<\"ColorTerms[expr] uses the function ColorPositions (from the \
package ExpressionManipulation) to color the elements of the first level of \
expr, tagging them with their respective positions.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578673028-5338953",ExpressionUUID->"2482de83-ab53-4497-9e68-\
184c6699db6f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ColorPositionsOfPattern", "[", 
     RowBox[{"pattern_", ",", "options___"}], "]"}], "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{"xAct`ExpressionManipulation`ColorPositions", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Position", "[", 
        RowBox[{"expr", ",", "pattern"}], "]"}], "}"}], ",", "options"}], 
     "]"}], "[", "expr", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ColorTerms", "[", "expr_", "]"}], ":=", 
   RowBox[{
    RowBox[{"xAct`ExpressionManipulation`ColorPositions", "[", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"Range", "@", 
        RowBox[{"Length", "@", "expr"}]}], ",", "1"}], "]"}], "]"}], "[", 
    "expr", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetNumberOfArguments", "[", 
   RowBox[{"ColorTerms", ",", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"ColorTerms", ",", "ColorPositionsOfPattern"}], "]"}], 
  ";"}]}], "Input",
 InitializationCell->
  True,ExpressionUUID->"f56976d6-5b94-4762-ad24-c0192d74ec9b"],

Cell["Examples:", \
"Text",ExpressionUUID->"55d45545-84e3-4cfc-b131-e05123639bbf"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"437d2501-e6f7-477b-87c2-10412b01c867"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]}], "Input",ExpressionUUID->"fd97b213-807a-4a7a-be12-220ac8854ca3"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0538ac48-704e-450e-9bc0-5d3e6a800a90"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{"A", ",", "B"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[$CellContext`A, $CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d68bd06b-10f4-4c77-b0a7-7c21d15fb9d3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{
   RowBox[{"4", 
    RowBox[{"S", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "B"}], "]"}]}], "+", 
   RowBox[{"2", 
    RowBox[{"V", "[", "A", "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "A"}], "]"}]}], "-", 
   RowBox[{"7", 
    RowBox[{"S", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", 
      RowBox[{"-", "B"}]}], 
     "]"}]}]}]}]], \
"Input",ExpressionUUID->"000cd80c-2aef-424c-a2e7-ac511f7cf1d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "7"}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[$CellContext`A, $CellContext`B],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`A],
    Editable->False]}], "+", 
  RowBox[{"4", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[$CellContext`A, $CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[-$CellContext`B],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"d586b39f-3ef5-4254-843a-7e51d55229d0"]
}, Open  ]],

Cell["\<\
We define a set of positions (a position is given by a list of indices):\
\>", "Text",ExpressionUUID->"8d67a27e-0e39-463b-9f29-a8a76cfd14d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"positions", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}], ",", 
     RowBox[{"{", "3", "}"}]}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"b11683ba-8c86-4abd-9881-94af986b652f"],

Cell["\<\
And we check that they are actually pointing to the objects that we have \
chosen:\
\>", "Text",ExpressionUUID->"2dfbfc21-190d-43e3-af99-e94efb47819a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{"ColorPositions", "[", 
   RowBox[{"positions", ",", 
    RowBox[{"EMPositionTag", "\[Rule]", "None"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"88eedb52-d92a-45ff-a9b7-1ed5ceb46493"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[-$CellContext`A, -$CellContext`B],
          Editable->False],
         HoldForm]],
       Background->Hue[0., 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ],
     DisplayForm], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[$CellContext`A, $CellContext`B],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`A],
     Editable->False]}], "+", 
   TagBox[
    TagBox[
     StyleBox[
      FrameBox[
       TagBox[
        RowBox[{"4", " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False], " ", 
         TagBox[
          TagBox[
           StyleBox[
            FrameBox[
             TagBox[
              InterpretationBox[
               StyleBox[GridBox[{
                  {"V", 
                   StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`V[-$CellContext`A],
               Editable->False],
              HoldForm]],
            Background->Hue[0.35, 0.4, 0.95]],
           StyleForm[#, Background -> Hue[0.35, 0.4, 0.95]]& ],
          DisplayForm], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`B],
          Editable->False]}],
        HoldForm]],
      Background->Hue[0.7, 0.4, 0.95]],
     StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ],
    DisplayForm]}],
  HoldForm]], \
"Output",ExpressionUUID->"08aba4a7-e177-40b5-a736-befe60685d79"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{
  "ColorPositions", "[", "positions", 
   "]"}]}]], "Input",ExpressionUUID->"72361589-d8fe-42ab-9349-96fb9f362e36"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"1", ",", "2"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"A", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[-$CellContext`A, -$CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{1, 2}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`S[-$CellContext`A, -$CellContext`B]]],
        Editable->False],
       Background->Hue[0., 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ], ")"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[$CellContext`A, $CellContext`B],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`A],
     Editable->False]}], "+", 
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox[
         TagBox[
          StyleBox[
           RowBox[{"{", "3", "}"}],
           FontSize->10],
          StyleForm[#, FontSize -> 10]& ]],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{"4", " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False], " ", 
         RowBox[{"(", 
          TagBox[
           StyleBox[
            InterpretationBox[
             RowBox[{
              TagBox[
               FrameBox[
                TagBox[
                 StyleBox[
                  RowBox[{"{", 
                   RowBox[{"3", ",", "3"}], "}"}],
                  FontSize->10],
                 StyleForm[#, FontSize -> 10]& ]],
               DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", 
              "\[InvisibleSpace]", 
              TagBox[
               InterpretationBox[
                StyleBox[GridBox[{
                   {"V", 
                    StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`V[-$CellContext`A],
                Editable->False],
               HoldForm]}],
             SequenceForm[
              DisplayForm[
               FrameBox[
                StyleForm[{3, 3}, FontSize -> 10]]], " ", 
              HoldForm[
               $CellContext`V[-$CellContext`A]]],
             Editable->False],
            Background->Hue[0.35, 0.4, 0.95]],
           StyleForm[#, Background -> Hue[0.35, 0.4, 0.95]]& ], ")"}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`B],
          Editable->False]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[
         StyleForm[{3}, FontSize -> 10]]], " ", 
       HoldForm[((4 $CellContext`S[$CellContext`A, $CellContext`B]) 
         StyleForm[
           SequenceForm[
            DisplayForm[
             FrameBox[
              StyleForm[{3, 3}, FontSize -> 10]]], " ", 
            HoldForm[
             $CellContext`V[-$CellContext`A]]], Background -> 
           Hue[0.35, 0.4, 0.95]]) $CellContext`V[-$CellContext`B]]],
      Editable->False],
     Background->Hue[0.7, 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ]}],
  HoldForm]], \
"Output",ExpressionUUID->"44b5a004-103b-4b6a-8723-8798f9489c6f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{"ColorPositions", "[", 
   RowBox[{"positions", ",", 
    RowBox[{"EMPositionTag", "\[Rule]", "EMIndex"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"ebd86f8a-4d2f-40cf-ac7b-2d78b230f1c6"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox["1"],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"A", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[-$CellContext`A, -$CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[1]], " ", 
         HoldForm[
          $CellContext`S[-$CellContext`A, -$CellContext`B]]],
        Editable->False],
       Background->Hue[0., 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ], ")"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[$CellContext`A, $CellContext`B],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`A],
     Editable->False]}], "+", 
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox["3"],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{"4", " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False], " ", 
         RowBox[{"(", 
          TagBox[
           StyleBox[
            InterpretationBox[
             RowBox[{
              TagBox[
               FrameBox["2"],
               DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", 
              "\[InvisibleSpace]", 
              TagBox[
               InterpretationBox[
                StyleBox[GridBox[{
                   {"V", 
                    StyleBox[GridBox[{
                    {" "},
                    {"A"}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`V[-$CellContext`A],
                Editable->False],
               HoldForm]}],
             SequenceForm[
              DisplayForm[
               FrameBox[2]], " ", 
              HoldForm[
               $CellContext`V[-$CellContext`A]]],
             Editable->False],
            Background->Hue[0.35, 0.4, 0.95]],
           StyleForm[#, Background -> Hue[0.35, 0.4, 0.95]]& ], ")"}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`B],
          Editable->False]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[3]], " ", 
       HoldForm[((4 $CellContext`S[$CellContext`A, $CellContext`B]) 
         StyleForm[
           SequenceForm[
            DisplayForm[
             FrameBox[2]], " ", 
            HoldForm[
             $CellContext`V[-$CellContext`A]]], Background -> 
           Hue[0.35, 0.4, 0.95]]) $CellContext`V[-$CellContext`B]]],
      Editable->False],
     Background->Hue[0.7, 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ]}],
  HoldForm]], \
"Output",ExpressionUUID->"40e47f26-7ef4-49ca-86cd-8b33a4e34fd2"]
}, Open  ]],

Cell["We can map any function on these positions:", \
"Text",ExpressionUUID->"2f745101-58b6-4591-bd36-0a27780711a4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapAt", "[", 
  RowBox[{"f", ",", "expr", ",", "positions"}], 
  "]"}]], "Input",ExpressionUUID->"1f5a0ea3-c977-46d0-8632-5848785bba7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"4", " ", 
    RowBox[{"f", "[", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {" "},
             {"A"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[-$CellContext`A],
      Editable->False], "]"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`B],
     Editable->False]}], "]"}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"f", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[-$CellContext`A, -$CellContext`B],
     Editable->False], "]"}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[$CellContext`A, $CellContext`B],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[-$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`A],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"59b626b8-4728-4889-89b3-762329c0fb50"]
}, Open  ]],

Cell["We can group different positions:", \
"Text",ExpressionUUID->"47075375-ba90-4083-bd76-7da86af84014"],

Cell[BoxData[
 RowBox[{
  RowBox[{"positions", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"4775202a-7269-4ba6-b557-f124115dd589"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{"ColorPositions", "[", 
   RowBox[{"positions", ",", 
    RowBox[{"EMPositionTag", "\[Rule]", "None"}]}], 
   "]"}]}]], "Input",ExpressionUUID->"dd78c81a-6858-436e-a92e-3149febf4efd"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[-$CellContext`A, -$CellContext`B],
          Editable->False],
         HoldForm]],
       Background->Hue[0., 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ],
     DisplayForm], " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False],
         HoldForm]],
       Background->Hue[0., 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ],
     DisplayForm]}], "+", 
   RowBox[{"2", " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"A"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`A],
          Editable->False],
         HoldForm]],
       Background->Hue[0.7, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ],
     DisplayForm], " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {"A"},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[$CellContext`A],
          Editable->False],
         HoldForm]],
       Background->Hue[0.7, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ],
     DisplayForm]}], "+", 
   RowBox[{"4", " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False],
         HoldForm]],
       Background->Hue[0., 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ],
     DisplayForm], " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"A"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`A],
          Editable->False],
         HoldForm]],
       Background->Hue[0.7, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ],
     DisplayForm], " ", 
    TagBox[
     TagBox[
      StyleBox[
       FrameBox[
        TagBox[
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`B],
          Editable->False],
         HoldForm]],
       Background->Hue[0.7, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ],
     DisplayForm]}]}],
  HoldForm]], \
"Output",ExpressionUUID->"ea4b62fc-9e8b-45a2-9c8c-a10fa9fa2c9e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "positions", "]"}], 
  ";"}]], "Input",ExpressionUUID->"5064ff8d-6297-4297-a652-c6e8cb57b214"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{"ColorPositionsOfPattern", "[", 
   RowBox[{"S", "[", 
    RowBox[{"_", ",", "_"}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"a51b97f6-02fb-4305-ba8f-da79e148ef59"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"1", ",", "2"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {" ", " "},
                  {"A", "B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[-$CellContext`A, -$CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{1, 2}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`S[-$CellContext`A, -$CellContext`B]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"1", ",", "3"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[$CellContext`A, $CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{1, 3}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`S[$CellContext`A, $CellContext`B]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`A],
     Editable->False]}], "+", 
   RowBox[{"4", " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"3", ",", "2"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[$CellContext`A, $CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{3, 2}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`S[$CellContext`A, $CellContext`B]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`B],
     Editable->False]}]}],
  HoldForm]], \
"Output",ExpressionUUID->"066112f9-a217-4451-8eac-a46906266c42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{"ColorPositionsOfPattern", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"_", "?", "UpIndexQ"}], ",", 
     RowBox[{"_", "?", "UpIndexQ"}]}], "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"c5fc5ec7-a5fb-4ab1-a11c-f23a6a51d829"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[-$CellContext`A, -$CellContext`B],
     Editable->False], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"1", ",", "3"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[$CellContext`A, $CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{1, 3}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`S[$CellContext`A, $CellContext`B]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {"A"},
            {" "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[$CellContext`A],
     Editable->False]}], "+", 
   RowBox[{"4", " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"3", ",", "2"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"S", 
               StyleBox[GridBox[{
                  {"A", "B"},
                  {" ", " "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`S[$CellContext`A, $CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{3, 2}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`S[$CellContext`A, $CellContext`B]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`A],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"V", 
         StyleBox[GridBox[{
            {" "},
            {"B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`V[-$CellContext`B],
     Editable->False]}]}],
  HoldForm]], \
"Output",ExpressionUUID->"963dacf2-6ad2-4914-8d60-6a6b25211e02"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  RowBox[{"ColorPositionsOfPattern", "[", 
   RowBox[{"V", "[", "_", "]"}], 
   "]"}]}]], "Input",ExpressionUUID->"b486e363-f5bc-40a0-8b4b-174ed4db96db"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "7"}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[-$CellContext`A, -$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[$CellContext`A, $CellContext`B],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"2", ",", "2"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"V", 
               StyleBox[GridBox[{
                  {" "},
                  {"A"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`V[-$CellContext`A],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{2, 2}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`V[-$CellContext`A]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"2", ",", "3"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"V", 
               StyleBox[GridBox[{
                  {"A"},
                  {" "}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`V[$CellContext`A],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{2, 3}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`V[$CellContext`A]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}]}], "+", 
   RowBox[{"4", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"S", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`S[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"3", ",", "3"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"V", 
               StyleBox[GridBox[{
                  {" "},
                  {"A"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`V[-$CellContext`A],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{3, 3}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`V[-$CellContext`A]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}], " ", 
    RowBox[{"(", 
     TagBox[
      StyleBox[
       InterpretationBox[
        RowBox[{
         TagBox[
          FrameBox[
           TagBox[
            StyleBox[
             RowBox[{"{", 
              RowBox[{"3", ",", "4"}], "}"}],
             FontSize->10],
            StyleForm[#, FontSize -> 10]& ]],
          DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
         TagBox[
          InterpretationBox[
           StyleBox[GridBox[{
              {"V", 
               StyleBox[GridBox[{
                  {" "},
                  {"B"}
                 },
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                FontSize->Rational[39, 4]]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Center}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`V[-$CellContext`B],
           Editable->False],
          HoldForm]}],
        SequenceForm[
         DisplayForm[
          FrameBox[
           StyleForm[{3, 4}, FontSize -> 10]]], " ", 
         HoldForm[
          $CellContext`V[-$CellContext`B]]],
        Editable->False],
       Background->Hue[0.5, 0.4, 0.95]],
      StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], ")"}]}]}],
  HoldForm]], \
"Output",ExpressionUUID->"b38b8ad5-af38-4306-9c36-89af528e9c13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "//", 
  "ColorTerms"}]], \
"Input",ExpressionUUID->"7ef8d2c3-505b-4bc3-ac78-5c750faa2bc7"],

Cell[BoxData[
 TagBox[
  RowBox[{
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox[
         TagBox[
          StyleBox[
           RowBox[{"{", "1", "}"}],
           FontSize->10],
          StyleForm[#, FontSize -> 10]& ]],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{
         RowBox[{"-", "7"}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[-$CellContext`A, -$CellContext`B],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[
         StyleForm[{1}, FontSize -> 10]]], " ", 
       HoldForm[((-7) $CellContext`S[-$CellContext`A, -$CellContext`B]) \
$CellContext`S[$CellContext`A, $CellContext`B]]],
      Editable->False],
     Background->Hue[0., 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ], "+", 
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox[
         TagBox[
          StyleBox[
           RowBox[{"{", "2", "}"}],
           FontSize->10],
          StyleForm[#, FontSize -> 10]& ]],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"A"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`A],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {"A"},
                 {" "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[$CellContext`A],
          Editable->False]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[
         StyleForm[{2}, FontSize -> 10]]], " ", 
       HoldForm[(
         2 $CellContext`V[-$CellContext`A]) $CellContext`V[$CellContext`A]]],
      Editable->False],
     Background->Hue[0.35, 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0.35, 0.4, 0.95]]& ], "+", 
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox[
         TagBox[
          StyleBox[
           RowBox[{"{", "3", "}"}],
           FontSize->10],
          StyleForm[#, FontSize -> 10]& ]],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{"4", " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"A"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`A],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`B],
          Editable->False]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[
         StyleForm[{3}, FontSize -> 10]]], " ", 
       HoldForm[((
          4 $CellContext`S[$CellContext`A, $CellContext`B]) \
$CellContext`V[-$CellContext`A]) $CellContext`V[-$CellContext`B]]],
      Editable->False],
     Background->Hue[0.7, 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ]}],
  HoldForm]], \
"Output",ExpressionUUID->"2074c792-2b41-425d-9474-31496fa6cd3d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplification", "[", "expr", 
  "]"}]], "Input",ExpressionUUID->"cb4ed907-69e8-489b-b37c-d686eb7020f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "7"}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"S", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`S[$CellContext`A, $CellContext`B],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" "},
           {"A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[-$CellContext`A],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"A"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[$CellContext`A],
      Editable->False], "+", 
     RowBox[{"2", " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"S", 
           StyleBox[GridBox[{
              {"A", "B"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`S[$CellContext`A, $CellContext`B],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {" "},
              {"B"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[-$CellContext`B],
       Editable->False]}]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"2468187d-42c4-4732-a5bc-5d6e23fd1806"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", 
  "ColorTerms"}]], \
"Input",ExpressionUUID->"e669a010-75ea-45f7-a82d-3ead64a0aa4b"],

Cell[BoxData[
 TagBox[
  RowBox[{
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox[
         TagBox[
          StyleBox[
           RowBox[{"{", "1", "}"}],
           FontSize->10],
          StyleForm[#, FontSize -> 10]& ]],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{
         RowBox[{"-", "7"}], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {" ", " "},
                 {"A", "B"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[-$CellContext`A, -$CellContext`B],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"S", 
              StyleBox[GridBox[{
                 {"A", "B"},
                 {" ", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`S[$CellContext`A, $CellContext`B],
          Editable->False]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[
         StyleForm[{1}, FontSize -> 10]]], " ", 
       HoldForm[((-7) $CellContext`S[-$CellContext`A, -$CellContext`B]) \
$CellContext`S[$CellContext`A, $CellContext`B]]],
      Editable->False],
     Background->Hue[0., 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0., 0.4, 0.95]]& ], "+", 
   TagBox[
    StyleBox[
     InterpretationBox[
      RowBox[{
       TagBox[
        FrameBox[
         TagBox[
          StyleBox[
           RowBox[{"{", "2", "}"}],
           FontSize->10],
          StyleForm[#, FontSize -> 10]& ]],
        DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
       TagBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"V", 
              StyleBox[GridBox[{
                 {" "},
                 {"A"}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`V[-$CellContext`A],
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           InterpretationBox[
            StyleBox[GridBox[{
               {"V", 
                StyleBox[GridBox[{
                   {"A"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`V[$CellContext`A],
            Editable->False], "+", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"S", 
                 StyleBox[GridBox[{
                    {"A", "B"},
                    {" ", " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`S[$CellContext`A, $CellContext`B],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox[GridBox[{
                {"V", 
                 StyleBox[GridBox[{
                    {" "},
                    {"B"}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`V[-$CellContext`B],
             Editable->False]}]}], ")"}]}],
        HoldForm]}],
      SequenceForm[
       DisplayForm[
        FrameBox[
         StyleForm[{2}, FontSize -> 10]]], " ", 
       HoldForm[(
         2 $CellContext`V[-$CellContext`A]) ($CellContext`V[$CellContext`A] + \
(2 $CellContext`S[$CellContext`A, $CellContext`B]) \
$CellContext`V[-$CellContext`B])]],
      Editable->False],
     Background->Hue[0.7, 0.4, 0.95]],
    StyleForm[#, Background -> Hue[0.7, 0.4, 0.95]]& ]}],
  HoldForm]], \
"Output",ExpressionUUID->"eb4fe79e-2bf7-41f7-9859-b0a169a600c1"]
}, Open  ]],

Cell["\<\
Note that the third position in an expression can be indicated both as 3 and \
{3}, even though we always get {3} from Position. I think Position should \
have been called Positions because it returns a list of positions.\
\>", "Text",ExpressionUUID->"cfab3709-9d2c-4657-9ee8-e71cf0461387"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapAt", "[", 
  RowBox[{"f", ",", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "]"}], ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"baaf2017-7ade-424b-b0bd-8fccad32749c"],

Cell[BoxData[
 RowBox[{"h", "[", 
  RowBox[{"1", ",", "2", ",", 
   RowBox[{"f", "[", "3", "]"}], ",", "4", ",", "5"}], 
  "]"}]], "Output",ExpressionUUID->"cd10323e-f03a-4182-8ad5-6106418ab979"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapAt", "[", 
  RowBox[{"f", ",", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "]"}], ",", 
   RowBox[{"{", "3", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c97cef07-52ab-42f1-a13a-c9f79c48bd3c"],

Cell[BoxData[
 RowBox[{"h", "[", 
  RowBox[{"1", ",", "2", ",", 
   RowBox[{"f", "[", "3", "]"}], ",", "4", ",", "5"}], 
  "]"}]], "Output",ExpressionUUID->"3a11b2a8-84c9-448d-912d-d5b20229212e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "]"}], ",", "3"}], 
  "]"}]], "Input",ExpressionUUID->"95a55603-6851-4475-b9e6-f3f0f9fa8fe1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "3", "}"}], 
  "}"}]], "Output",ExpressionUUID->"c92b3464-3d9b-4613-86a7-969c66a21c7d"]
}, Open  ]],

Cell["\<\
It is also possible to use EvaluateAt (from the ExpressionManipulation \
package) instead of MapAt, with equivalent results except for held \
expressions where EvaluateAt not only maps a function (Identity by default), \
but also evaluates the subexpression. Note the very different syntaxes used:\
\>", "Text",ExpressionUUID->"e9075119-3a6f-4550-bb4d-f95cb6ec9c11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapAt", "[", 
  RowBox[{"f", ",", 
   RowBox[{"Hold", "[", 
    RowBox[{"1", "+", "1"}], "]"}], ",", 
   RowBox[{"{", "1", "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"41e867e3-f6f6-4894-98c2-0398c7174714"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"f", "[", 
   RowBox[{"1", "+", "1"}], "]"}], 
  "]"}]], "Output",ExpressionUUID->"84f34e95-4972-474c-8fd8-535f06476dd8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"EvaluateAt", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", "f"}], "]"}], "[", 
  RowBox[{"Hold", "[", 
   RowBox[{"1", "+", "1"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"f10b99c6-0271-4036-be67-6a8740c199dd"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"f", "[", "2", "]"}], 
  "]"}]], "Output",ExpressionUUID->"6b2bda76-996b-4ddb-ac5e-f951202f689b"]
}, Open  ]],

Cell["\<\
Finally one comment: Indices cannot be colored. At least a tensor must be \
included in the expression to color.\
\>", "Text",ExpressionUUID->"881470f6-d018-42bc-bf55-9dfca3c84f44"],

Cell["\<\
It is possible to use ExtendedPosition (from the ExpressionManipulation \
package). Example:\
\>", "Text",ExpressionUUID->"c6faa4e3-a414-42b1-89b8-64c6146f6b8f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", 
  "eP"}]], "Input",ExpressionUUID->"96a170a9-0f44-4aac-806d-85d663473914"],

Cell[BoxData[
 StyleBox["\<\"eP is a wrapper for extended positions. An extended position \
is a subset of level parts in a base position corresponding to a \
subexpression which is Flat and Orderless. eP[base position, list of level \
parts]. For example eP[{1},{2,4}] is an extended position and specifies the \
position of \\n  a+c in f[1+a+b+c].\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->
  "Info3578673031-5338953",ExpressionUUID->"eec26b6e-2636-4121-83bb-\
05553950c208"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExtendedPosition", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"1", "+", "a", "+", "b", "+", "c"}], "]"}], ",", 
   RowBox[{"a", "+", "c"}]}], 
  "]"}]], "Input",ExpressionUUID->"6e036616-80a6-408a-a16b-2dc1814c1d74"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"eP", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "4"}], "}"}]}], "]"}], 
  "}"}]], "Output",ExpressionUUID->"312ba066-ea2d-4e8f-b496-8fbcdff75974"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"1", "+", "a", "+", "b", "+", "c"}], "]"}], "//", 
  RowBox[{
  "ColorPositions", "[", "%", 
   "]"}]}]], "Input",ExpressionUUID->"d1e065bc-a77f-450d-820f-55f157ec8f27"],

Cell[BoxData[
 TagBox[
  RowBox[{"f", "[", 
   RowBox[{"1", "+", 
    TagBox[
     StyleBox[
      InterpretationBox[
       RowBox[{
        TagBox[
         FrameBox[
          TagBox[
           StyleBox[
            RowBox[{"eP", "[", 
             RowBox[{
              RowBox[{"{", "1", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "4"}], "}"}]}], "]"}],
            FontSize->10],
           StyleForm[#, FontSize -> 10]& ]],
         DisplayForm], "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", 
        
        TagBox[
         RowBox[{"a", "+", "c"}],
         HoldForm]}],
       SequenceForm[
        DisplayForm[
         FrameBox[
          StyleForm[
           xAct`ExpressionManipulation`eP[{1}, {2, 4}], FontSize -> 10]]], 
        " ", 
        HoldForm[$CellContext`a + $CellContext`c]],
       Editable->False],
      Background->Hue[0.5, 0.4, 0.95]],
     StyleForm[#, Background -> Hue[0.5, 0.4, 0.95]]& ], "+", "b"}], "]"}],
  HoldForm]], \
"Output",ExpressionUUID->"f9f31e4b-91b2-400e-a131-cbe5022501bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"S", ",", "V"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"53eef5ab-d9a5-4bfa-ad08-544684a8cba9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"9f35334f-3b1b-4b0f-814d-65cd891fb1c7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"e69c291f-6f09-4fc6-9c2b-18096c8c229a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"0016caf6-7e4f-4402-ac84-c25baf211f1d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "\<\"h\"\>", "}"}]}],
  SequenceForm["There are new symbols in Global`:", {"h"}],
  Editable->
   False]], "Print",ExpressionUUID->"3f71512a-2490-4bfb-8b2b-e5a5dfc183ab"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["18. More examples",
 FontColor->RGBColor[0, 0, 1]]], "Section",
 FontSize->24,ExpressionUUID->"6d90ce45-aa6f-41c2-b0ea-38495ea10072"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"af9b02ad-00c0-4c8f-8fb4-a17ad0035a1d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "90.48619`", ",", "763.724693`9.334481826078767", ",", 
   "0.11848015373518393`"}], 
  "}"}]], "Output",ExpressionUUID->"a6e8f83b-10d9-4791-a6ee-8c7ce88ccedf"]
}, Open  ]],

Cell[CellGroupData[{

Cell["18.1. Dummy handling", \
"Subsection",ExpressionUUID->"b5a4fb38-b549-4edd-9e39-03ea67414164"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"f837248a-9239-47b9-b969-0bd244eb5931"],

Cell["For example purposes:", \
"Text",ExpressionUUID->"6ca75c9f-ac62-48e9-b9b6-9656eaf4ecf8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"6122ad19-0556-4a2f-bb6b-d0642eb3f5c3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"20654bde-ee21-4428-bc03-8d093c38efcc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", 
    RowBox[{"-", "A"}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"7fdd4bda-ca0a-4e6f-8e38-a7dca415a1ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0f360e9b-8c11-4b65-9c39-3292645f239d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"8ae848a4-6853-471a-9b2b-bdcbc1de64f9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1eedbf29-a0ee-4078-92cc-17a375b19cf3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"2d081c95-1aff-4ecf-98c8-fd36786bc013"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ca322919-b129-4569-8620-26236bd2833f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CdM", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"d982bfe8-97d2-4b95-907e-fca8740d2a5c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cbca8940-e0af-42d2-866e-99d92acf4c18"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d45514bf-b6a7-4a66-a070-68515779a290"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CdM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CdM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"08494cfe-755a-492e-9ee3-b58158ccfad1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b38195ca-15a6-43ec-8e2e-d338256a357a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCdM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCdM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4a43fbe1-f460-4179-9d3a-33cb1a77221c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"593a0660-2fe9-46f5-a2e5-772448db2f8c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"cd33ca8a-9728-4b30-899f-04f46d57f836"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"639af8f5-b3c1-4afb-95fd-c8e03b2be99f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e15bf75a-5a14-4283-b76f-1a40e50b095b"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"70164db1-cd5c-4ff3-903d-9b0f6c5887e8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b268a882-66ef-43a4-8e2f-c8e90f26c5be"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCdM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d291678b-594d-4a68-bb93-bcbae0481295"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCdM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCdM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7715add0-fc5c-4a0e-a3cd-6ab664145cb1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCdM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCdM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7e99121c-bdab-489a-956d-485473787079"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"fa6faed4-2c2b-4827-a5ed-253288b831dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"c1422ef7-1993-4891-98e2-5c26dc888617"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"bca33e88-a89c-43c4-85db-0de214a1d5a0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetricg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetricg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"3b0ea6be-8409-4813-9b70-8b9b6d9c88ed"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindAllOfType", "[", 
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"r", "[", "]"}], "2"], " ", 
    RowBox[{"v", "[", 
     RowBox[{"-", "J"}], "]"}], " ", 
    RowBox[{"v", "[", "J", "]"}], 
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "B"}], "]"}], "]"}], 
    RowBox[{"T", "[", "B", "]"}]}], ",", "Tensor"}], 
  "]"}]], "Input",ExpressionUUID->"37df31b0-e202-460e-8541-53cab355f52c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`B],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"J"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`J],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"J"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`J],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" "},
           {"B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B],
    Editable->False]}], 
  "}"}]], "Output",ExpressionUUID->"dfc3b81b-3e37-49e9-8c1c-16136cdd4430"]
}, Open  ]],

Cell["ReplaceDummies:", \
"Text",ExpressionUUID->"b33cac33-9345-49fa-84d3-c6f9d3dce25d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"r", "[", "]"}], "2"], " ", 
    RowBox[{"v", "[", 
     RowBox[{"-", "G"}], "]"}], " ", 
    RowBox[{"v", "[", "G", "]"}], 
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "c"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "b$1"}], "]"}], "]"}], 
    RowBox[{"T", "[", "b$1", "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "A", ",", "B", ",", "C", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"80a0068e-b408-403c-a6f1-6ecbccc8813e"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"a"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`a],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"a", 
           RowBox[{"|", "c"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`c][
    $CellContext`T[-$CellContext`a]],
   Editable->
    False]}]], "Output",ExpressionUUID->"249f6b24-6e7b-4340-bf4d-ac3d9576c9d2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"r", "[", "]"}], "2"], " ", 
    RowBox[{"v", "[", 
     RowBox[{"-", "G"}], "]"}], " ", 
    RowBox[{"v", "[", "G", "]"}], 
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "c"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CdM", "[", "c", "]"}], "[", 
      RowBox[{"T", "[", 
       RowBox[{"-", "b$1"}], "]"}], "]"}], "]"}], 
    RowBox[{"T", "[", "b$1", "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"a", ",", "A", ",", "B", ",", "C", ",", "d"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d4e5c969-951b-4a60-be86-e2900bc244c1"],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"a"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`a],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", 
           RowBox[{"|", "d"}], "  "},
          {"a", "  ", 
           RowBox[{"|", "d"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`d][
    $CellContext`CdM[$CellContext`d][
     $CellContext`T[-$CellContext`a]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"32ea570d-b8ae-4cba-ab1d-6cb39676ebf9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ReplaceDummies", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "b$1"}], ",", "C"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"b$1", ",", 
      RowBox[{"-", "C"}]}], "]"}]}], ",", 
   RowBox[{"IndexList", "[", 
    RowBox[{"A$1610", ",", "a$1614"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"80c142d2-0b1e-44c5-b4cb-49a8e13c56c0"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "A$1610"},
          {"a$1614", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`a$1614, $CellContext`A$1610],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"a$1614", " "},
          {" ", "A$1610"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`a$1614, -$CellContext`A$1610],
   Editable->
    False]}]], "Output",ExpressionUUID->"35074fde-511d-4ba9-92f9-a5acbda2388a"]
}, Open  ]],

Cell["DummyHandling:", \
"Text",ExpressionUUID->"28a79405-2531-4d01-b215-24eaed5fa6f2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{"v", "[", 
      RowBox[{"-", "A"}], "]"}], 
     RowBox[{"T", "[", "A", "]"}]}], "-", 
    RowBox[{"b", " ", 
     RowBox[{"v", "[", "B", "]"}], 
     RowBox[{"T", "[", 
      RowBox[{"-", "B"}], "]"}]}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"6e9eee92-3fd5-4577-9e8a-33ba34ab7476"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(a\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7cbf2d89-87ed-44e7-9c1d-aec648705cd5"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(a\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9f9c3828-f312-435e-9e96-3368453abd46"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(b\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4cdfadc7-d168-4a1c-9afa-419a7dfac9e7"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
noident\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"b2407cec-4f23-4fe0-b906-13d8406926ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "-", "b"}], ")"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"357c67a0-c050-4b50-a319-6bbba8cc7ad4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{"v", "[", 
      RowBox[{"-", "a"}], "]"}], 
     RowBox[{"T", "[", "a", "]"}]}], "-", 
    RowBox[{"b", " ", 
     RowBox[{"v", "[", "b", "]"}], 
     RowBox[{"T", "[", 
      RowBox[{"-", "b"}], "]"}]}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"aef294d3-d78e-40de-a959-3d429e6f13b4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(a\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"a1d083fa-3372-4564-ba1e-a32af1ecabb3"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(a\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"bda29f12-a745-4b82-950b-e5b6e83d50f5"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(b\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"8c04788b-6d3d-429c-89cd-99fd59964d33"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
noident\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"50aa109e-3080-4f57-9938-0811ba396404"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"a"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" "},
           {"a"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[-$CellContext`a],
    Editable->False]}], "-", 
  RowBox[{"b", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" "},
           {"a"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"a"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`a],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"9814abfd-6fbb-4c15-b47e-b7305a71e298"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplification", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", "D"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "C"}], ",", "G"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "G"}], ",", "a"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}], ",", "F"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "A"}], ",", "G1"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C", ",", "A"}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "G1"}], ",", "a"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"7e45d790-be87-44dd-879a-947f14471c74"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"18266695-62b1-4885-a394-b7d30811b8b9"]
}, Open  ]],

Cell[TextData[{
 "Cool! (This was the first simplification ever performed with ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ")."
}], "Text",ExpressionUUID->"37b5bdc1-a5e8-430d-911f-de9ee823f978"],

Cell["Note that", \
"Text",ExpressionUUID->"1391fe24-508d-489a-bbd8-f7401f73fff1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"v", "[", "A", "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"3bd7df2d-9f51-4bc8-a98b-42159a86b895"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"8328633d-581c-46c7-bdf9-dc02f9ca0e7c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CdM", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}], "]"}], 
    RowBox[{"v", "[", "A", "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"28ab7172-6c3d-4c49-88f6-c8685230e367"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"A", 
           RowBox[{"|", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CdM[-$CellContext`B][
    $CellContext`T[-$CellContext`A]],
   Editable->
    False]}]], "Output",ExpressionUUID->"61eaba05-5346-44c1-8b1d-e120397c9bdc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "A"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "B"}], "]"}], "]"}], 
    RowBox[{"v", "[", "A", "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"c46435c3-6346-486e-9d02-ca83e621efcf"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"B", 
           RowBox[{",", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[-$CellContext`B]],
   Editable->
    False]}]], "Output",ExpressionUUID->"54b5a7ac-b153-43b8-8e2e-585f17f058e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplification", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"T", "[", 
      RowBox[{"-", "A"}], "]"}], "]"}], 
    RowBox[{"v", "[", "A", "]"}]}], "]"}], "//", 
  "ScreenDollarIndices"}]], \
"Input",ExpressionUUID->"848225e4-6cbc-4f74-b6dc-f42d97bf54d5"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", "  "},
          {"A", 
           RowBox[{",", "B"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`B][
    $CellContext`T[-$CellContext`A]],
   Editable->
    False]}]], "Output",ExpressionUUID->"3d717c37-df56-43b1-aec7-05a323534abd"]
}, Open  ]],

Cell["Check of \"deltas\":", \
"Text",ExpressionUUID->"0d171527-998c-427a-a996-38c02ea16b2d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"metricg", "[", 
   RowBox[{"B", ",", 
    RowBox[{"-", "C"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"fa425e1f-bea0-4a8e-85c7-c3f623228eff"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"9fca53b4-ac46-4262-9c0d-18b10946de07"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PD", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"af44de33-7506-434b-bf79-4c4c1214044f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"g", 
      StyleBox[GridBox[{
         {" ", " ", "  "},
         {"B", "C", 
          RowBox[{",", "A"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[-$CellContext`A][
   $CellContext`metricg[-$CellContext`B, -C]],
  Editable->
   False]], "Output",ExpressionUUID->"ec7dfbef-d46b-4687-b0c2-4df7cae110ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CdM", "[", 
   RowBox[{"-", "A"}], "]"}], "[", 
  RowBox[{"metricg", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "C"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"d7e36267-5d66-46fe-9e15-f4cbd1323c9e"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"2cc77e9a-4d0a-4894-98d3-a3a92cdba875"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefMetric", "[", "metricg", 
  "]"}]], "Input",ExpressionUUID->"6513aa46-5674-451f-ad4e-43e9255ebede"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"62ce74a6-162c-48f4-b116-f8965eae87bf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCdM],
  Editable->
   False]], "Print",ExpressionUUID->"5aa196fc-c65b-470a-94b2-5667af28daad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCdM],
  Editable->
   False]], "Print",ExpressionUUID->"aab5265a-eb1c-40c9-bc67-d4358632eaf0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"0a1c2ab4-d75c-4fd6-835f-55dcd746f0b5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"41c27046-93b2-474d-845f-3087b662b131"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCdM],
  Editable->
   False]], "Print",ExpressionUUID->"276de1eb-bb70-4b94-8a83-e470735e8113"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCdM],
  Editable->
   False]], "Print",ExpressionUUID->"d6482af3-33fe-4450-9fa7-500ec740204b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCdM],
  Editable->
   False]], "Print",ExpressionUUID->"aa8f0ea6-9f19-4732-8130-8a40ed734a7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCdM],
  Editable->
   False]], "Print",ExpressionUUID->"81c74aca-e10e-4cad-80d6-c37aa4f7ddaf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCdM],
  Editable->
   False]], "Print",ExpressionUUID->"c83c9a03-f42b-4b96-8a15-f513a5270a94"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CdM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CdM],
  Editable->
   False]], "Print",ExpressionUUID->"3d0081c2-5882-486e-b785-32e7a304978d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"d3715a1b-ee8a-4f6f-bec2-f43d4e9e9eec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"8defc709-b8ac-400b-9d9d-b4cfd3baab67"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", 
   RowBox[{"{", 
    RowBox[{"v", ",", "V", ",", "T", ",", "r"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"12095d70-ee9b-4a34-9465-866a4eed12f9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"642489e3-d8ef-4d70-9b63-5d3bb5ca7b02"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"cfc10d9b-6a2a-4680-bfb4-a8795f6f5af2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"feac9bbe-b9cd-4411-b0b1-f0c65e7f17f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"2d4e76ac-8b7d-4fde-a8d7-627418c22023"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"3fc8c240-5942-4113-9c2b-3b56f5693222"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"There are new symbols in Global`:\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"A$1610\"\>", ",", "\<\"a$1614\"\>", ",", "\<\"b$1\"\>", 
     ",", "\<\"f$328832\"\>", ",", "\<\"f$328834\"\>", 
     ",", "\<\"f$328836\"\>", ",", "\<\"f$328838\"\>", 
     ",", "\<\"G$328722\"\>", ",", "\<\"G$328722$\"\>", 
     ",", "\<\"G$328723\"\>", ",", "\<\"G$328723$\"\>", 
     ",", "\<\"G$328724\"\>", ",", "\<\"G$328724$\"\>", 
     ",", "\<\"G$328725\"\>", ",", "\<\"G$328725$\"\>", 
     ",", "\<\"G$328726\"\>", ",", "\<\"G$328726$\"\>", 
     ",", "\<\"G$328727\"\>", ",", "\<\"G$328727$\"\>", 
     ",", "\<\"G$328728\"\>", ",", "\<\"G$328728$\"\>", 
     ",", "\<\"G$328729\"\>", ",", "\<\"G$328729$\"\>", 
     ",", "\<\"G$328730\"\>", ",", "\<\"G$328730$\"\>", 
     ",", "\<\"G$328731\"\>", ",", "\<\"G$328731$\"\>", 
     ",", "\<\"G$328732\"\>", ",", "\<\"G$328732$\"\>", 
     ",", "\<\"G$328733\"\>", ",", "\<\"G$328733$\"\>", 
     ",", "\<\"G$328734\"\>", ",", "\<\"G$328734$\"\>", 
     ",", "\<\"G$328735\"\>", ",", "\<\"G$328735$\"\>", 
     ",", "\<\"G$328804\"\>", ",", "\<\"G$328805\"\>", 
     ",", "\<\"G$328806\"\>", ",", "\<\"G$328807\"\>", 
     ",", "\<\"G$328815\"\>", ",", "\<\"G$328816\"\>", 
     ",", "\<\"G$328824\"\>", ",", "\<\"G$328825\"\>", 
     ",", "\<\"G$328826\"\>", ",", "\<\"G$328833\"\>", 
     ",", "\<\"G$328835\"\>", ",", "\<\"G$328837\"\>", 
     ",", "\<\"G$336038\"\>"}], "}"}]}],
  SequenceForm[
  "There are new symbols in Global`:", {
   "A$1610", "a$1614", "b$1", "f$328832", "f$328834", "f$328836", "f$328838", 
    "G$328722", "G$328722$", "G$328723", "G$328723$", "G$328724", "G$328724$",
     "G$328725", "G$328725$", "G$328726", "G$328726$", "G$328727", 
    "G$328727$", "G$328728", "G$328728$", "G$328729", "G$328729$", "G$328730",
     "G$328730$", "G$328731", "G$328731$", "G$328732", "G$328732$", 
    "G$328733", "G$328733$", "G$328734", "G$328734$", "G$328735", "G$328735$",
     "G$328804", "G$328805", "G$328806", "G$328807", "G$328815", "G$328816", 
    "G$328824", "G$328825", "G$328826", "G$328833", "G$328835", "G$328837", 
    "G$336038"}],
  Editable->
   False]], "Print",ExpressionUUID->"13d1f1ea-88ce-4e00-8f2d-e1367312aee8"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["18.2. calc", \
"Subsection",ExpressionUUID->"6601ac32-a355-48e7-afc2-47b1f19f2d20"],

Cell[BoxData[
 RowBox[{"BeginExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"1b46d51c-976b-4647-9fdf-44a844bff387"],

Cell["Simple calculations:", \
"Text",ExpressionUUID->"e78e451e-3237-4668-a5c9-87420a865357"],

Cell[CellGroupData[{

Cell[BoxData["$Manifolds"], \
"Input",ExpressionUUID->"5e7e257c-def1-4e39-9dcb-e810d5cac2b4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"M2", ",", "S2", ",", "Mprod"}], 
  "}"}]], "Output",ExpressionUUID->"509d6895-9500-4c46-8503-7e84aec41f06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "CDM", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<|\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "->", "\"\<g\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"c01075c3-cea6-4757-9bc7-6cd09e3a8ee0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"metricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`metricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"16e4e8ae-c523-4dec-b878-8a6976f05b56"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilonmetricg", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilonmetricg[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a645fe62-47be-4049-9fe0-1a9bf18bc4b0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDM", "[", 
    RowBox[{"-", "A"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDM[-$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bcae746c-f346-496d-8d57-ac86c72b743c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d545bc2b-6dc3-4a9d-a200-537a3a7970be"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDM", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDM[$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7af494d2-c24b-4d2c-9d13-682060d30e1a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"3ecb3666-a37b-4324-b4da-ec1ebad3ce57"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"53636868-8c1d-416f-b3a1-6b3106353062"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"0ce08059-927f-4d20-b3cd-b43ea218cfea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCDM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCDM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"634e710f-630e-4c9c-bf12-3fd00758f9e2"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"e45061f0-f5fc-4c14-8302-82c5bd2a55eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"a922bff6-70e9-4b41-8d83-1056e1be9fb8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCDM[-$CellContext`A, -$CellContext`B, -C, -D], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"455c1fef-8039-4da8-9cdd-bac597dea67a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCDM", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCDM[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"4a19597a-2c38-4f85-a8cd-0dd604627495"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCDM", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCDM[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"1bf5b294-1fe9-49cd-b3da-2fa8ddc96d7a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"3af403c4-5675-45c4-bc4d-d698b369226c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"bd5e7e6e-1028-470f-862d-c21aaebd9f79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"95dc0920-f3dd-4af6-bc99-5274aea3c6e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detmetricg", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detmetricg[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"abe560c5-3725-43c2-9a38-e3e5d0e6483e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"gamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], ",", "CDS", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<:\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}], ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[Gamma]\>\""}]}], 
  "]"}]], "Input",ExpressionUUID->"50afc0cd-b6b1-4f45-ba82-6b1dd089da17"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"gamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`gamma[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0cf1d8f6-e0c8-4a7d-96d2-816231c7bbd2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilongamma", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilongamma[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"42b74bde-f428-4ec5-a3c8-12acd5563bf2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CDS", "[", 
    RowBox[{"-", "a"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CDS[-$CellContext`a], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"d0a16da8-dd7e-4593-899b-1a2e1bb11751"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCDS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCDS[$CellContext`a, -$CellContext`b, -$CellContext`c], 
   ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"588bb36b-3db6-4e25-ad75-75ed5a644462"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCDS", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCDS[$CellContext`a, -$CellContext`b, \
-$CellContext`c], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"9b0e34ec-a4f4-47fa-a04f-a839abe97522"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCDS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c0c1a419-d3c5-4ae4-9765-39fb952df411"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCDS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"477fecb4-cc34-4a49-8d35-23aa42ab394a"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Riemann automatically replaced \
by Ricci.\"\>"], \
"Print",ExpressionUUID->"73bba9ad-fe3c-48fb-a9a6-9f72857d410e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCDS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCDS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c7927e65-e115-4731-a92d-154a2f2de0d9"],

Cell[BoxData["\<\"** DefCovD:  Contractions of Ricci automatically replaced \
by RicciScalar.\"\>"], \
"Print",ExpressionUUID->"368fa9bc-407e-4ae7-ae55-b86db48889a4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "vanishing Einstein tensor ", 
   $CellContext`EinsteinCDS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"0fb47f24-82b9-4418-a4a4-71e90a716e7c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing Weyl tensor ", 
   $CellContext`WeylCDS[-$CellContext`a, -$CellContext`b, -$CellContext`c, \
-$CellContext`d], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"61403c7c-d4e1-4d8a-953e-1474b7fb7cd4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCDS", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing TFRicci tensor ", 
   $CellContext`TFRicciCDS[-$CellContext`a, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"925bb68d-48e2-4b19-8a49-928506bf8c20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCDS", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCDS[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"59850458-44cb-45ee-a309-36d8fa486632"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"526f5133-7f43-4c40-b1c4-58afad1d9a04"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"c4bb50b0-24b6-4c73-97d4-6f04ba5dc0f2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 2],
  Editable->
   False]], "Print",ExpressionUUID->"315401be-2fcf-46ba-b073-af42b15db4b6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detgamma", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detgamma[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"cb0a9702-51b1-4126-9097-51c3cd9ade49"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], ",", "M2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"w", "[", "]"}], ",", "S2"}], 
  "]"}]}], "Input",ExpressionUUID->"15480631-9153-49aa-b381-dd39193a34ad"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"r", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`r[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"938d5cb8-ffa3-4b45-b330-6ed65193973d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"w", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`w[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"488f1335-d2f8-4bb6-b2ac-6345945d2943"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefProductMetric", "[", 
  RowBox[{
   RowBox[{"g4", "[", 
    RowBox[{
     RowBox[{"-", "mu"}], ",", 
     RowBox[{"-", "nu"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TangentM2", ",", 
       RowBox[{"w", "[", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"TangentS2", ",", 
       RowBox[{"r", "[", "]"}]}], "}"}]}], "}"}], ",", "CD4", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<;\>\"", ",", "\"\<\[EmptyDownTriangle]\>\""}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c74e92cd-9ea2-4570-87e6-d992374025b0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"g4", "[", 
    RowBox[{
     RowBox[{"-", "mu"}], ",", 
     RowBox[{"-", "nu"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric metric tensor ", 
   $CellContext`g4[-$CellContext`mu, -$CellContext`nu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"5e3f83a6-f45d-459e-a49a-f588e813378f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"epsilong4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "antisymmetric tensor ", 
   $CellContext`epsilong4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7395d5c4-c58a-4715-9c73-a7b95fd8476b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric \"\>", "\[InvisibleSpace]", 
   RowBox[{"Tetrag4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tetrametric ", 
   $CellContext`Tetrag4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"bde4c7e9-cd35-4a78-9d15-cf6bf69d3cff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric \"\>", "\[InvisibleSpace]", 
   RowBox[{"Tetrag4\[Dagger]", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tetrametric ", 
   $CellContext`Tetrag4\[Dagger][-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c4a3ea12-819b-4516-b183-6d639aaf768e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"CD4", "[", 
    RowBox[{"-", "mu"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefCovD, ": Defining ", "covariant derivative ", 
   $CellContext`CD4[-$CellContext`mu], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"02a1c3fa-5388-402f-aaa3-68bc4de0053f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"vanishing torsion tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TorsionCD4", "[", 
    RowBox[{"alpha", ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "vanishing torsion tensor ", 
   $CellContext`TorsionCD4[$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ad7e6977-59c6-4996-8e69-be7c69dd367c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"ChristoffelCD4", "[", 
    RowBox[{"alpha", ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Christoffel tensor ", 
   $CellContext`ChristoffelCD4[$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"be7a1ced-8abc-4328-8925-f093ffc24984"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"RiemannCD4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Riemann tensor ", 
   $CellContext`RiemannCD4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"2ced8bc4-8cad-412a-a48f-44135990f6ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"RicciCD4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric Ricci tensor ", 
   $CellContext`RicciCD4[-$CellContext`alpha, -$CellContext`beta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"b137750f-45da-4f5b-9169-ff8a24024b50"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"RicciScalarCD4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Ricci scalar ", 
   $CellContext`RicciScalarCD4[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"333232c2-0ff6-4f22-89b2-162187e3bcc8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Einstein tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"EinsteinCD4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", 
   "symmetric Einstein tensor ", 
   $CellContext`EinsteinCD4[-$CellContext`alpha, -$CellContext`beta], ". ", 
   ""],
  Editable->
   False]], "Print",ExpressionUUID->"e2c63d62-a466-41e5-99d1-ce953d677fce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"WeylCD4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}], ",", 
     RowBox[{"-", "eta"}], ",", 
     RowBox[{"-", "lambda"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "Weyl tensor ", 
   $CellContext`WeylCD4[-$CellContext`alpha, -$CellContext`beta, \
-$CellContext`eta, -$CellContext`lambda], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"090f38c5-328e-4e66-842a-32257f547c49"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric TFRicci tensor \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"TFRicciCD4", "[", 
    RowBox[{
     RowBox[{"-", "alpha"}], ",", 
     RowBox[{"-", "beta"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "symmetric TFRicci tensor ", 
   $CellContext`TFRicciCD4[-$CellContext`alpha, -$CellContext`beta], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"58915d7f-3f22-4b05-a541-bc5e862fcaf5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar \"\>", "\[InvisibleSpace]", 
   RowBox[{"KretschmannCD4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "Kretschmann scalar ", 
   $CellContext`KretschmannCD4[], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"f2e31b07-3356-4854-a271-2f5074f0e817"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RiemannToWeylRules for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RiemannToWeylRules for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"50a7a9d7-faf4-4eb0-9302-d1a47ab8566c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToTFRicci for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RicciToTFRicci for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"21aa28e4-dac3-4cbc-8ec5-42a1791d0c8c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** DefCovD:  Computing RicciToEinsteinRules for dim \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["** DefCovD:  Computing RicciToEinsteinRules for dim ", 4],
  Editable->
   False]], "Print",ExpressionUUID->"878d4852-24a0-4817-a0e1-ab012fa71af3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density \"\>", "\[InvisibleSpace]", 
   RowBox[{"Detg4", "[", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"Determinant.\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefTensor, ": Defining ", "weight +2 density ", 
   $CellContext`Detg4[], ". ", "Determinant."],
  Editable->
   False]], "Print",ExpressionUUID->"5af89ca7-ad28-4053-8772-03b4f96f62a8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"V", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"54c7b61b-0e11-403a-a876-a0f4e55a85e7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"V", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`V[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"dc9628ec-9312-4380-8e09-e4581eecc48e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "A", "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"01aa7367-c7f7-415c-8041-94eb270563a0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"v", "[", "A", "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`v[$CellContext`A], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"c25810c9-bec6-4d95-a182-bf2b2e6c0fed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Symmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"b1b8fdb4-a5d0-4fe6-acd3-82af99557856"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`T[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"db00233c-510e-4b64-b773-b03c7d0c193c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"ec803959-da24-4303-b9d6-88bb67abce94"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`BB[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"da242263-cdac-4448-b19d-94731cb3941f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"8d5fbec1-23bd-4d68-a456-ad6da7683953"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TT[-$CellContext`A, -$CellContext`B], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"e51f4efa-46c9-49af-8d66-914f9a145458"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c36632ca-7108-4a34-99d1-8ee2a2cf64c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`S[-$CellContext`A, -$CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"de1fb217-4c34-4bd6-a6d7-1c72a8ef5457"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"GG", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "b"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a28fc906-ae86-45d0-923f-e7eb409cd0e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"GG", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", "b"}], "]"}], "\[InvisibleSpace]", "\<\". \"\>",
    "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`GG[-$CellContext`A, $CellContext`b], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"70cb1951-0475-4009-9e29-d7f79d009781"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"HH", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "M2"}], 
  "]"}]], "Input",ExpressionUUID->"c8aec551-a414-4851-9b55-d792bf1fd589"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"HH", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`HH[-$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"7c3b73d0-3be9-470b-ab59-da3c118e30c9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"AA", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], ",", "M2", ",", 
   RowBox[{"Antisymmetric", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8e1fdf0c-aa88-4a00-8bf9-fe58a40461d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"AA", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`AA[-$CellContext`A, -$CellContext`B, -C], ". ", ""],
  Editable->
   False]], "Print",ExpressionUUID->"ff0e7042-176f-48bb-9c2e-b7a2ce899f45"]
}, Open  ]],

Cell["We have an invalid input:", \
"Text",ExpressionUUID->"3cb00a7d-263a-4f8d-8e57-22229bc173ae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Validate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", "D"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "C"}], ",", "mu"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"-", "mu"}], ",", "a"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"HH", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}], ",", "F"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "A"}], ",", "nu"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C", ",", "A"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"-", "nu"}], ",", "a"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"aab7fc33-6b3a-4315-8a84-f7f5c11c30e4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid index at slot of tensor HH\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e07c1d40-70ab-4c62-985f-48d5e0f154d2"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid number of indices of tensor V\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ac5ac4a1-ec66-4275-aecd-378fdfe4b4dc"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Validate", "::", "error"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(\\\"Invalid index at slot of tensor HH\\\"\\)\
\[NoBreak]\"\>"}]], "Message", \
"MSG",ExpressionUUID->"d8b7f29f-3059-4166-9954-f5201235ea62"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Validate :: \
error\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"7d99514d-9b0d-44c1-ab63-17c1d84c9bbb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["ERROR",
       FontColor->Hue[0.]], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"HH", 
           StyleBox[GridBox[{
              {" ", " ", "mu"},
              {"D", "C", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`HH[-D, -C, $CellContext`mu],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ERROR[
     $CellContext`HH[-D, -C, $CellContext`mu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["ERROR",
       FontColor->Hue[0.]], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {" ", "a"},
              {"mu", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[-$CellContext`mu, $CellContext`a],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ERROR[
     $CellContext`V[-$CellContext`mu, $CellContext`a]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"HH", 
        StyleBox[GridBox[{
           {" ", "B", "C"},
           {"A", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`HH[-$CellContext`A, $CellContext`B, C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"HH", 
        StyleBox[GridBox[{
           {"A", " ", "D"},
           {" ", "B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`HH[$CellContext`A, -$CellContext`B, D],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["ERROR",
       FontColor->Hue[0.]], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"HH", 
           StyleBox[GridBox[{
              {" ", " ", "nu"},
              {"F", "A", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`HH[-$CellContext`F, -$CellContext`A, $CellContext`nu],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ERROR[
     $CellContext`HH[-$CellContext`F, -$CellContext`A, $CellContext`nu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["ERROR",
       FontColor->Hue[0.]], "[", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"V", 
           StyleBox[GridBox[{
              {" ", "a"},
              {"nu", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V[-$CellContext`nu, $CellContext`a],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`ERROR[
     $CellContext`V[-$CellContext`nu, $CellContext`a]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"HH", 
        StyleBox[GridBox[{
           {" ", "C", "A"},
           {"B", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`HH[-$CellContext`B, C, $CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"HH", 
        StyleBox[GridBox[{
           {"B", " ", "F"},
           {" ", "C", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`HH[$CellContext`B, -C, $CellContext`F],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"c63b94d4-3078-4576-9935-f9836257cec9"]
}, Open  ]],

Cell["even though it is possible to calculated with it:", \
"Text",ExpressionUUID->"4dc35a82-ebf2-4c8e-8c29-dfaa02f2eb56"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "A"}], ",", "B", ",", "C"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{"A", ",", 
      RowBox[{"-", "B"}], ",", "D"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "C"}], ",", "mu"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"-", "mu"}], ",", "a"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"HH", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}], ",", "F"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "F"}], ",", 
      RowBox[{"-", "A"}], ",", "nu"}], "]"}], 
    RowBox[{"HH", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C", ",", "A"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"-", "nu"}], ",", "a"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"8829dc3b-c94e-45de-91cf-f27d85adce11"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"99797c18-f9d0-4dba-8ab1-3c159f6ce215"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"TT", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "A"}]}], "]"}], 
    RowBox[{"V", "[", "A", "]"}], 
    RowBox[{"v", "[", "B", "]"}]}], "-", 
   RowBox[{
    RowBox[{"TT", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", 
      RowBox[{"-", "D"}]}], "]"}], 
    RowBox[{"v", "[", "C", "]"}], 
    RowBox[{"V", "[", "D", "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"317d9a89-aa14-48ea-afce-0d3e9f1e877f"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"8c87bf78-6a79-4999-a74a-15b320c444b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "B"}], ",", 
       RowBox[{"-", "A"}]}], "]"}], 
     RowBox[{"v", "[", "A", "]"}], 
     RowBox[{"V", "[", "B", "]"}]}], "-", 
    RowBox[{
     RowBox[{"T", "[", 
      RowBox[{
       RowBox[{"-", "C"}], ",", 
       RowBox[{"-", "D"}]}], "]"}], 
     RowBox[{"v", "[", "C", "]"}], 
     RowBox[{"V", "[", "D", "]"}]}]}], ",", 
   RowBox[{"Verbose", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"854e45cd-2dbf-4e2b-95b5-3419e611e9d4"],

Cell[CellGroupData[{

Cell[BoxData["\<\"1) Looking for product manifolds...\"\>"], \
"Print",ExpressionUUID->"e7ce461e-d769-40e5-a064-59d54aa44c86"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->
     False]}]}]], \
"Print",ExpressionUUID->"0c7b3cd1-8c89-47aa-afe6-472305986a43"],

Cell[BoxData["\<\"2) Applying global rules\"\>"], \
"Print",ExpressionUUID->"a5d65d2b-524e-4eed-b87f-8552ae7eb1fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->
     False]}]}]], \
"Print",ExpressionUUID->"beeafeab-3bfd-4a46-ab21-b417838fc8bc"],

Cell[BoxData["\<\"3) Using Riemann...\"\>"], \
"Print",ExpressionUUID->"e9a53db9-727f-4fbf-903e-2281edb8b282"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->
     False]}]}]], \
"Print",ExpressionUUID->"1c23f054-70c4-43d0-ba4a-508f43dbf765"],

Cell[BoxData["\<\"4) Using metric rules...\"\>"], \
"Print",ExpressionUUID->"7cbb90a0-e508-43be-b0de-6f7fd62b2340"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[$CellContext`B],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"C"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->
     False]}]}]], \
"Print",ExpressionUUID->"fa174dd2-da68-48ab-ae7d-01908194da40"],

Cell[BoxData["\<\"5) Simplifying...\"\>"], \
"Print",ExpressionUUID->"3d932d76-48d1-42d6-8f19-cf24760bad57"],

Cell[BoxData["\<\"***********************************************************\
\"\>"], "Print",ExpressionUUID->"d5e799ae-57c9-410f-9b1c-a7e2f0812ed9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: object: \"\>", "\[InvisibleSpace]", 
   TagBox[
    TooltipBox[
     UnderscriptBox[
      RowBox[{
       RowBox[{"(", 
        TagBox[
         TooltipBox[
          UnderscriptBox["Times", "_"],
          RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
         #& ], ")"}], "[", 
       RowBox[{
        TagBox[
         TooltipBox[
          UnderscriptBox[
           RowBox[{"-", "1"}], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              RowBox[{"-", "1"}], ",", 
              RowBox[{"{", 
                RowBox[{"Constant", ",", "1", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
            "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"v", 
                StyleBox[GridBox[{
                   {"A"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`v[$CellContext`A],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"v", 
                   StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`v[$CellContext`A], Editable -> False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`A], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`A], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"V", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`V[$CellContext`B],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"V", 
                   StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`V[$CellContext`B], Editable -> False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`B], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`B], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"T", 
                StyleBox[GridBox[{
                   {" ", " "},
                   {"A", "B"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`T[-$CellContext`A, -$CellContext`B],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[-$CellContext`A, -$CellContext`B], Editable -> 
               False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                   Editable -> False]}], "}"}]}], "]"}]],
         #& ]}], "]"}], "_"],
     RowBox[{"\"Object\"", "[", 
       RowBox[{
         RowBox[{
           RowBox[{"(", 
             TagBox[
              TooltipBox[
               UnderscriptBox["Times", "_"], 
               RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
             ")"}], "[", 
           RowBox[{
             TagBox[
              TooltipBox[
               UnderscriptBox[
                RowBox[{"-", "1"}], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                 "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`v[$CellContext`A], Editable -> False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`V[$CellContext`B], Editable -> False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`B], Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[-$CellContext`A, -$CellContext`B], Editable -> 
                 False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
         RowBox[{"{", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   
                   RowBox[{
                    "Constant", ",", "Tensor", ",", "Tensor", ",", "Tensor"}],
                    "}"}]}], "}"}], ",", 
             RowBox[{"{", "2", "}"}], ",", 
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "v", ",", "V", ",", "T"}], 
                   "}"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
           RowBox[{
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
                 "B", "\",\"", 
                 RowBox[{"-", "A"}], "\",\"", 
                 RowBox[{"-", "B"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, \
-$CellContext`A, -$CellContext`B], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
                 RowBox[{"-", "B"}], "\",\"", "B", 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
              Editable -> False]}], "}"}]}], "]"}]],
    #& ]}],
  SequenceForm["ToCanonical:: object: ", 
   xAct`xTensor`Private`Object[
    xAct`xTensor`Private`VerbatimProduct[Times][
     xAct`xTensor`Private`Object[-1, {Constant, 1, -1}, {
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[]}], 
     xAct`xTensor`Private`Object[
      $CellContext`v[$CellContext`A], {
      xAct`xTensor`Tensor, 1, $CellContext`v}, {
       xAct`xTensor`IndexList[$CellContext`A], 
       xAct`xTensor`IndexList[$CellContext`A], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}]}], 
     xAct`xTensor`Private`Object[
      $CellContext`V[$CellContext`B], {
      xAct`xTensor`Tensor, 1, $CellContext`V}, {
       xAct`xTensor`IndexList[$CellContext`B], 
       xAct`xTensor`IndexList[$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}]}], 
     xAct`xTensor`Private`Object[
      $CellContext`T[-$CellContext`A, -$CellContext`B], {
      xAct`xTensor`Tensor, 2, $CellContext`T}, {
       xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
       xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}]}]], {{
     Times, {Constant, xAct`xTensor`Tensor, xAct`xTensor`Tensor, 
       xAct`xTensor`Tensor}}, {2}, {
     Times, {-1, $CellContext`v, $CellContext`V, $CellContext`T}}}, {
     xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, -$CellContext`B, \
$CellContext`B], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[{-$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}]}]],
  Editable->
   False]], "Print",ExpressionUUID->"4c246c88-2558-472e-b62e-60a1b7ff6200"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: sym: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Symmetry", "[", 
    RowBox[{"4", ",", 
     RowBox[{
      RowBox[{"(", 
       TagBox[
        TooltipBox[
         UnderscriptBox["Times", "_"],
         RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
        #& ], ")"}], "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"\[FilledCircle]1"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[
         xAct`xTensor`Private`slot[1]],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"V", 
            StyleBox[GridBox[{
               {"\[FilledCircle]2"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`V[
         xAct`xTensor`Private`slot[2]],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"\[FilledCircle]3", "\[FilledCircle]4"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[
         xAct`xTensor`Private`slot[3], 
         xAct`xTensor`Private`slot[4]],
        Editable->False]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "A"}], ",", 
       RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "B"}], ",", 
       RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", 
        RowBox[{"-", "A"}]}], ",", 
       RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", 
        RowBox[{"-", "B"}]}]}], "}"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}], ",", 
       RowBox[{"GenSet", "[", 
        InterpretationBox[
         StyleBox[
          RowBox[{"(", "3", ",", "4", ")"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xPerm`Cycles[{3, 4}],
         Editable->False], "]"}]}], "]"}]}], "]"}]}],
  SequenceForm["ToCanonical:: sym: ", 
   xAct`xTensor`Symmetry[4, 
    xAct`xTensor`Private`VerbatimProduct[Times][-1, 
     $CellContext`v[
      xAct`xTensor`Private`slot[1]], 
     $CellContext`V[
      xAct`xTensor`Private`slot[2]], 
     $CellContext`T[
      xAct`xTensor`Private`slot[3], 
      xAct`xTensor`Private`slot[4]]], {
    xAct`xTensor`Private`slot[1] -> $CellContext`A, 
     xAct`xTensor`Private`slot[2] -> $CellContext`B, 
     xAct`xTensor`Private`slot[3] -> -$CellContext`A, 
     xAct`xTensor`Private`slot[4] -> -$CellContext`B}, 
    xAct`xPerm`StrongGenSet[{3, 4}, 
     xAct`xPerm`GenSet[
      xAct`xPerm`Cycles[{3, 4}]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"27a59b9b-4749-44f2-a221-7649f7ccae87"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Actual configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", "\<\",\"\>", 
      RowBox[{"-", "A"}], "\<\",\"\>", 
      RowBox[{"-", "B"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Actual configuration: ", 
   xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"8c1e8a16-07d4-4269-b4cf-d7c3672a7dfe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Standard configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", 
      RowBox[{"-", "A"}], "\<\",\"\>", "B", "\<\",\"\>", 
      RowBox[{"-", "B"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A, $CellContext`B, \
-$CellContext`B],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Standard configuration: ", 
   xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A, $CellContext`B, \
-$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"971cc170-7827-4293-a9f1-be29f2f91da0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"df0a5006-1d7a-4235-a157-b715953ea141"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"b5a54e4d-35fb-40fc-b06c-aa304afcac10"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Permutation to be canonicalized: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Permutation to be canonicalized: ", 
   xAct`xPerm`Images[{1, 3, 2, 4}]],
  Editable->
   False]], "Print",ExpressionUUID->"7a4d9749-b413-4520-8903-253cc8a327dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dummies: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B],
    Editable->False]}],
  SequenceForm["dummies: ", 
   xAct`xTensor`IndexList[$CellContext`A, $CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"b65dcb92-7d06-4296-9984-dfef95850483"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets_tmp: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{"A", ",", "B"}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets_tmp: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {$CellContext`A, \
$CellContext`B}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentMprod, {}, 1]}],
  Editable->
   False]], "Print",ExpressionUUID->"45b99933-0823-43d4-9260-23cda189c6b5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {{1, 2}, {3, 4}}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentMprod, {}, 1]}],
  Editable->
   False]], "Print",ExpressionUUID->"e164e49e-764e-4638-9f2f-c8c26850f82a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Free indices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Free indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"ab80c95a-ab96-4714-924b-9b71ae064112"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: calling: \"\>", 
   "\[InvisibleSpace]", "\<\"CanonicalPerm[\"\>", "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], "]"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{"(", "3", ",", "4", ")"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xPerm`Cycles[{3, 4}],
       Editable->False], "]"}]}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"Verbose", "\[Rule]", "True"}], "\[InvisibleSpace]", "\<\"]\"\>"}],
  
  SequenceForm["ToCanonicalOne:: calling: ", "CanonicalPerm[", 
   xAct`xPerm`Images[{1, 3, 2, 4}], ",", 4, ",", 
   xAct`xPerm`StrongGenSet[{3, 4}, 
    xAct`xPerm`GenSet[
     xAct`xPerm`Cycles[{3, 4}]]], ",", {}, ",", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {{1, 2}, {3, 4}}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentMprod, {}, 1]}, ",", Verbose -> 
   True, "]"],
  Editable->
   False]], "Print",ExpressionUUID->"7810f7f4-5dfd-4a92-adf2-c87986e8cda7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Canonical permutation: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Canonical permutation: ", 
   xAct`xPerm`Images[{1, 3, 2, 4}]],
  Editable->
   False]], "Print",ExpressionUUID->"a305ca5c-7b46-47e9-a275-c029165dafb5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: newindices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", "\<\",\"\>", 
        RowBox[{"-", "A"}], "\<\",\"\>", 
        RowBox[{"-", "B"}], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B],
      Editable->False]}], "}"}]}],
  SequenceForm["ToCanonical:: newindices: ", {1, 
    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B]}],
  Editable->
   False]], "Print",ExpressionUUID->"4ed13f32-abbe-45e6-8dd7-9d3da7d72a02"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: riskyders: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonical:: riskyders: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"3ceffd70-0607-46ee-a3c7-aa25aa5327fb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: result: \"\>", "\[InvisibleSpace]", 
   TagBox[
    TooltipBox[
     UnderscriptBox[
      RowBox[{
       RowBox[{"(", 
        TagBox[
         TooltipBox[
          UnderscriptBox["Times", "_"],
          RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
         #& ], ")"}], "[", 
       RowBox[{
        TagBox[
         TooltipBox[
          UnderscriptBox[
           RowBox[{"-", "1"}], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              RowBox[{"-", "1"}], ",", 
              RowBox[{"{", 
                RowBox[{"Constant", ",", "1", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
            "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"v", 
                StyleBox[GridBox[{
                   {"A"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`v[$CellContext`A],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"v", 
                   StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`v[$CellContext`A], Editable -> False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`A], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`A], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"V", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`V[$CellContext`B],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"V", 
                   StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`V[$CellContext`B], Editable -> False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`B], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`B], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"T", 
                StyleBox[GridBox[{
                   {" ", " "},
                   {"A", "B"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`T[-$CellContext`A, -$CellContext`B],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[-$CellContext`A, -$CellContext`B], Editable -> 
               False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                   Editable -> False]}], "}"}]}], "]"}]],
         #& ]}], "]"}], "_"],
     RowBox[{"\"Object\"", "[", 
       RowBox[{
         RowBox[{
           RowBox[{"(", 
             TagBox[
              TooltipBox[
               UnderscriptBox["Times", "_"], 
               RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
             ")"}], "[", 
           RowBox[{
             TagBox[
              TooltipBox[
               UnderscriptBox[
                RowBox[{"-", "1"}], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"Constant", ",", "1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False]}], "}"}]}], 
                 "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`v[$CellContext`A], Editable -> False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`V[$CellContext`B], Editable -> False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`B], Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[-$CellContext`A, -$CellContext`B], Editable -> 
                 False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"A", "B"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
         RowBox[{"{", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   
                   RowBox[{
                    "Constant", ",", "Tensor", ",", "Tensor", ",", "Tensor"}],
                    "}"}]}], "}"}], ",", 
             RowBox[{"{", "2", "}"}], ",", 
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "v", ",", "V", ",", "T"}], 
                   "}"}]}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
           RowBox[{
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
                 "B", "\",\"", 
                 RowBox[{"-", "A"}], "\",\"", 
                 RowBox[{"-", "B"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, \
-$CellContext`A, -$CellContext`B], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
                 RowBox[{"-", "B"}], "\",\"", "B", 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
              Editable -> False]}], "}"}]}], "]"}]],
    #& ]}],
  SequenceForm["ToCanonical:: result: ", 
   xAct`xTensor`Private`Object[
    xAct`xTensor`Private`VerbatimProduct[Times][
     xAct`xTensor`Private`Object[-1, {Constant, 1, -1}, {
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[]}], 
     xAct`xTensor`Private`Object[
      $CellContext`v[$CellContext`A], {
      xAct`xTensor`Tensor, 1, $CellContext`v}, {
       xAct`xTensor`IndexList[$CellContext`A], 
       xAct`xTensor`IndexList[$CellContext`A], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}]}], 
     xAct`xTensor`Private`Object[
      $CellContext`V[$CellContext`B], {
      xAct`xTensor`Tensor, 1, $CellContext`V}, {
       xAct`xTensor`IndexList[$CellContext`B], 
       xAct`xTensor`IndexList[$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}]}], 
     xAct`xTensor`Private`Object[
      $CellContext`T[-$CellContext`A, -$CellContext`B], {
      xAct`xTensor`Tensor, 2, $CellContext`T}, {
       xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
       xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}]}]], {{
     Times, {Constant, xAct`xTensor`Tensor, xAct`xTensor`Tensor, 
       xAct`xTensor`Tensor}}, {2}, {
     Times, {-1, $CellContext`v, $CellContext`V, $CellContext`T}}}, {
     xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, -$CellContext`B, \
$CellContext`B], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[{-$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}]}]],
  Editable->
   False]], "Print",ExpressionUUID->"6c3fc72d-d1d6-446a-8a80-708f819127f3"],

Cell[BoxData["\<\"***********************************************************\
\"\>"], "Print",ExpressionUUID->"98245beb-b2b7-4c98-a9b5-57fa84210425"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: object: \"\>", "\[InvisibleSpace]", 
   TagBox[
    TooltipBox[
     UnderscriptBox[
      RowBox[{
       RowBox[{"(", 
        TagBox[
         TooltipBox[
          UnderscriptBox["Times", "_"],
          RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
         #& ], ")"}], "[", 
       RowBox[{
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"v", 
                StyleBox[GridBox[{
                   {"A"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`v[$CellContext`A],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"v", 
                   StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`v[$CellContext`A], Editable -> False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`A], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`A], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"V", 
                StyleBox[GridBox[{
                   {"B"},
                   {" "}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`V[$CellContext`B],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"V", 
                   StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`V[$CellContext`B], Editable -> False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`B], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[$CellContext`B], Editable -> False],
                   ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]],
         #& ], ",", 
        TagBox[
         TooltipBox[
          UnderscriptBox[
           InterpretationBox[
            StyleBox[GridBox[{
               {"T", 
                StyleBox[GridBox[{
                   {" ", " "},
                   {"B", "A"}
                  },
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                 FontSize->Rational[39, 4]]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Center}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`T[-$CellContext`B, -$CellContext`A],
            Editable->False], "_"],
          RowBox[{"\"Object\"", "[", 
            RowBox[{
              InterpretationBox[
               StyleBox[
                GridBox[{{"T", 
                   StyleBox[
                    
                    GridBox[{{" ", " "}, {"B", "A"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               $CellContext`T[-$CellContext`B, -$CellContext`A], Editable -> 
               False], ",", 
              RowBox[{"{", 
                RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
              RowBox[{"{", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                   Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   xAct`xTensor`IndexList[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                   
                   xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                   Editable -> False]}], "}"}]}], "]"}]],
         #& ]}], "]"}], "_"],
     RowBox[{"\"Object\"", "[", 
       RowBox[{
         RowBox[{
           RowBox[{"(", 
             TagBox[
              TooltipBox[
               UnderscriptBox["Times", "_"], 
               RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]], #& ], 
             ")"}], "[", 
           RowBox[{
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`v[$CellContext`A], Editable -> False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"v", 
                    StyleBox[
                    
                    GridBox[{{"A"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`v[$CellContext`A], Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "v"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`A], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`V[$CellContext`B], Editable -> False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"V", 
                    StyleBox[
                    
                    GridBox[{{"B"}, {" "}}, RowSpacings -> 0, ColumnSpacings -> 
                    0.05, GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`V[$CellContext`B], Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "1", ",", "V"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "B", 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[$CellContext`B], Editable -> 
                    False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}], Editable -> False]}], "}"}]}], "]"}]], #& ], ",", 
             TagBox[
              TooltipBox[
               UnderscriptBox[
                InterpretationBox[
                 StyleBox[
                  GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"B", "A"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                   Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`T[-$CellContext`B, -$CellContext`A], Editable -> 
                 False], "_"], 
               RowBox[{"\"Object\"", "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    GridBox[{{"T", 
                    StyleBox[
                    
                    GridBox[{{" ", " "}, {"B", "A"}}, RowSpacings -> 0, 
                    ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`T[-$CellContext`B, -$CellContext`A], 
                    Editable -> False], ",", 
                   RowBox[{"{", 
                    RowBox[{"Tensor", ",", "2", ",", "T"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "B"}], "\",\"", 
                    RowBox[{"-", "A"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"-", "A"}], "\",\"", 
                    RowBox[{"-", "B"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
                    Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    xAct`xTensor`IndexList[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{
                    StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], 
                    StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], 
                    AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}], 
                    Editable -> False]}], "}"}]}], "]"}]], #& ]}], "]"}], ",", 
         RowBox[{"{", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   RowBox[{"Tensor", ",", "Tensor", ",", "Tensor"}], "}"}]}], 
               "}"}], ",", 
             RowBox[{"{", "2", "}"}], ",", 
             RowBox[{"{", 
               RowBox[{"Times", ",", 
                 RowBox[{"{", 
                   RowBox[{"v", ",", "V", ",", "T"}], "}"}]}], "}"}]}], "}"}],
          ",", 
         RowBox[{"{", 
           RowBox[{
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], "A", "\",\"", 
                 "B", "\",\"", 
                 RowBox[{"-", "B"}], "\",\"", 
                 RowBox[{"-", "A"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, \
-$CellContext`B, -$CellContext`A], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"-", "A"}], "\",\"", "A", "\",\"", 
                 RowBox[{"-", "B"}], "\",\"", "B", 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, \
-$CellContext`B, $CellContext`B], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              xAct`xTensor`IndexList[], Editable -> False], ",", 
             InterpretationBox[
              StyleBox[
               RowBox[{
                 StyleBox["{", FontColor -> RGBColor[0, 0, 1]], 
                 RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False]}], ",", "metricg"}], "}"}], "\",\"", 
                 RowBox[{"{", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[DoubleStruckCapitalT]M2", AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`TangentM2, 
                    Editable -> False], ",", "metricg"}], "}"}], 
                 StyleBox["}", FontColor -> RGBColor[0, 0, 1]]}], AutoSpacing -> 
               False, ShowAutoStyles -> False], 
              
              xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {$CellContext`TangentM2, $CellContext`metricg}], 
              Editable -> False]}], "}"}]}], "]"}]],
    #& ]}],
  SequenceForm["ToCanonical:: object: ", 
   xAct`xTensor`Private`Object[
    xAct`xTensor`Private`VerbatimProduct[Times][
     xAct`xTensor`Private`Object[
      $CellContext`v[$CellContext`A], {
      xAct`xTensor`Tensor, 1, $CellContext`v}, {
       xAct`xTensor`IndexList[$CellContext`A], 
       xAct`xTensor`IndexList[$CellContext`A], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}]}], 
     xAct`xTensor`Private`Object[
      $CellContext`V[$CellContext`B], {
      xAct`xTensor`Tensor, 1, $CellContext`V}, {
       xAct`xTensor`IndexList[$CellContext`B], 
       xAct`xTensor`IndexList[$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{$CellContext`TangentM2, \
$CellContext`metricg}]}], 
     xAct`xTensor`Private`Object[
      $CellContext`T[-$CellContext`B, -$CellContext`A], {
      xAct`xTensor`Tensor, 2, $CellContext`T}, {
       xAct`xTensor`IndexList[-$CellContext`B, -$CellContext`A], 
       xAct`xTensor`IndexList[-$CellContext`A, -$CellContext`B], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[], 
       xAct`xTensor`IndexList[{-$CellContext`TangentM2, \
$CellContext`metricg}, {-$CellContext`TangentM2, $CellContext`metricg}]}]], {{
     Times, {xAct`xTensor`Tensor, xAct`xTensor`Tensor, 
       xAct`xTensor`Tensor}}, {2}, {
     Times, {$CellContext`v, $CellContext`V, $CellContext`T}}}, {
     xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`B, \
-$CellContext`A], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[-$CellContext`A, $CellContext`A, -$CellContext`B, \
$CellContext`B], 
     xAct`xTensor`IndexList[], 
     xAct`xTensor`IndexList[{-$CellContext`TangentM2, $CellContext`metricg}, \
{$CellContext`TangentM2, $CellContext`metricg}]}]],
  Editable->
   False]], "Print",ExpressionUUID->"c8cae338-bcc8-42b0-a194-8bee60d91dd1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: sym: \"\>", "\[InvisibleSpace]", 
   RowBox[{"Symmetry", "[", 
    RowBox[{"4", ",", 
     RowBox[{
      RowBox[{"(", 
       TagBox[
        TooltipBox[
         UnderscriptBox["Times", "_"],
         RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
        #& ], ")"}], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"v", 
            StyleBox[GridBox[{
               {"\[FilledCircle]1"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`v[
         xAct`xTensor`Private`slot[1]],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"V", 
            StyleBox[GridBox[{
               {"\[FilledCircle]2"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`V[
         xAct`xTensor`Private`slot[2]],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"T", 
            StyleBox[GridBox[{
               {"\[FilledCircle]3", "\[FilledCircle]4"},
               {" ", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`T[
         xAct`xTensor`Private`slot[3], 
         xAct`xTensor`Private`slot[4]],
        Editable->False]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\<\"\[FilledCircle]1\"\>", "\[Rule]", "A"}], ",", 
       RowBox[{"\<\"\[FilledCircle]2\"\>", "\[Rule]", "B"}], ",", 
       RowBox[{"\<\"\[FilledCircle]3\"\>", "\[Rule]", 
        RowBox[{"-", "B"}]}], ",", 
       RowBox[{"\<\"\[FilledCircle]4\"\>", "\[Rule]", 
        RowBox[{"-", "A"}]}]}], "}"}], ",", 
     RowBox[{"StrongGenSet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}], ",", 
       RowBox[{"GenSet", "[", 
        InterpretationBox[
         StyleBox[
          RowBox[{"(", "3", ",", "4", ")"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         xAct`xPerm`Cycles[{3, 4}],
         Editable->False], "]"}]}], "]"}]}], "]"}]}],
  SequenceForm["ToCanonical:: sym: ", 
   xAct`xTensor`Symmetry[4, 
    xAct`xTensor`Private`VerbatimProduct[Times][
     $CellContext`v[
      xAct`xTensor`Private`slot[1]], 
     $CellContext`V[
      xAct`xTensor`Private`slot[2]], 
     $CellContext`T[
      xAct`xTensor`Private`slot[3], 
      xAct`xTensor`Private`slot[4]]], {
    xAct`xTensor`Private`slot[1] -> $CellContext`A, 
     xAct`xTensor`Private`slot[2] -> $CellContext`B, 
     xAct`xTensor`Private`slot[3] -> -$CellContext`B, 
     xAct`xTensor`Private`slot[4] -> -$CellContext`A}, 
    xAct`xPerm`StrongGenSet[{3, 4}, 
     xAct`xPerm`GenSet[
      xAct`xPerm`Cycles[{3, 4}]]]]],
  Editable->
   False]], "Print",ExpressionUUID->"7758d00e-d54d-494f-a88a-1e95a3127c0d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Actual configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", "\<\",\"\>", 
      RowBox[{"-", "B"}], "\<\",\"\>", 
      RowBox[{"-", "A"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`B, \
-$CellContext`A],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Actual configuration: ", 
   xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`B, \
-$CellContext`A]],
  Editable->
   False]], "Print",ExpressionUUID->"18d6becb-c725-4e33-8367-d06d199df57a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Standard configuration: \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", 
      RowBox[{"-", "A"}], "\<\",\"\>", "B", "\<\",\"\>", 
      RowBox[{"-", "B"}], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A, $CellContext`B, \
-$CellContext`B],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Standard configuration: ", 
   xAct`xTensor`IndexList[$CellContext`A, -$CellContext`A, $CellContext`B, \
-$CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"1d17cb10-d179-4ddd-afec-8ee53478281f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   InterpretationBox[
    StyleBox[
     RowBox[{"{", "}"}],
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0, 0, 1]],
    xAct`xTensor`IndexList[],
    Editable->False]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", 
   xAct`xTensor`IndexList[]],
  Editable->
   False]], "Print",ExpressionUUID->"459e71a9-8c7f-43e5-9a14-4211d35f079e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Repeated indices: \"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Repeated indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"93a9fa8e-2835-480c-8b25-bbc15059ba6d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Permutation to be canonicalized: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "4", ",", "2", ",", "3"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Permutation to be canonicalized: ", 
   xAct`xPerm`Images[{1, 4, 2, 3}]],
  Editable->
   False]], "Print",ExpressionUUID->"7e7e5f59-c86c-4fa1-8fa1-a55cfa98b400"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"dummies: \"\>", "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["{",
       FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B],
    Editable->False]}],
  SequenceForm["dummies: ", 
   xAct`xTensor`IndexList[$CellContext`A, $CellContext`B]],
  Editable->
   False]], "Print",ExpressionUUID->"59899a6c-f561-4235-a959-21eab85c8407"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets_tmp: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{"A", ",", "B"}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets_tmp: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {$CellContext`A, \
$CellContext`B}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentMprod, {}, 1]}],
  Editable->
   False]], "Print",ExpressionUUID->"bde5da7f-c89d-4827-bc95-aa48e150846b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: dummysets: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}]}],
  SequenceForm["ToCanonicalOne:: dummysets: ", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {{1, 2}, {3, 4}}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentMprod, {}, 1]}],
  Editable->
   False]], "Print",ExpressionUUID->"45258fc2-c5b3-4570-874d-8d37cbd54756"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Free indices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonicalOne:: Free indices: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"1d138ad6-0c3b-47c5-897b-b7054b4cf37d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: calling: \"\>", 
   "\[InvisibleSpace]", "\<\"CanonicalPerm[\"\>", "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "4", ",", "2"}], "}"}], "]"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"StrongGenSet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"GenSet", "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{"(", "3", ",", "4", ")"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xPerm`Cycles[{3, 4}],
       Editable->False], "]"}]}], "]"}], "\[InvisibleSpace]", "\<\",\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]M2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentM2,
        Editable->False], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]S2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentS2,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}], ",", 
     RowBox[{"DummySet", "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[DoubleStruckCapitalT]Mprod",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`TangentMprod,
        Editable->False], ",", 
       RowBox[{"{", "}"}], ",", "1"}], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", 
   RowBox[{"Verbose", "\[Rule]", "True"}], "\[InvisibleSpace]", "\<\"]\"\>"}],
  
  SequenceForm["ToCanonicalOne:: calling: ", "CanonicalPerm[", 
   xAct`xPerm`Images[{1, 3, 4, 2}], ",", 4, ",", 
   xAct`xPerm`StrongGenSet[{3, 4}, 
    xAct`xPerm`GenSet[
     xAct`xPerm`Cycles[{3, 4}]]], ",", {}, ",", {
    xAct`xPerm`DummySet[$CellContext`TangentM2, {{1, 2}, {3, 4}}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentS2, {}, 1], 
    xAct`xPerm`DummySet[$CellContext`TangentMprod, {}, 1]}, ",", Verbose -> 
   True, "]"],
  Editable->
   False]], "Print",ExpressionUUID->"3e1a7103-8b45-43a9-b1aa-c584b15929d0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonicalOne:: Canonical permutation: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"Images", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], "]"}]}],
  SequenceForm["ToCanonicalOne:: Canonical permutation: ", 
   xAct`xPerm`Images[{1, 3, 2, 4}]],
  Editable->
   False]], "Print",ExpressionUUID->"830ed002-ea1f-4a13-af08-b264027dfc25"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: newindices: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        StyleBox["{",
         FontColor->RGBColor[0, 0, 1]], "A", "\<\",\"\>", "B", "\<\",\"\>", 
        RowBox[{"-", "A"}], "\<\",\"\>", 
        RowBox[{"-", "B"}], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B],
      Editable->False]}], "}"}]}],
  SequenceForm["ToCanonical:: newindices: ", {1, 
    xAct`xTensor`IndexList[$CellContext`A, $CellContext`B, -$CellContext`A, \
-$CellContext`B]}],
  Editable->
   False]], "Print",ExpressionUUID->"0b79b119-8e1b-41cd-b16a-a53740eef4f9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: riskyders: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}]}],
  SequenceForm["ToCanonical:: riskyders: ", {}],
  Editable->
   False]], "Print",ExpressionUUID->"4d0ca22a-bc99-4418-9ce6-6438bd317a20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"ToCanonical:: result: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"(", 
     TagBox[
      TooltipBox[
       UnderscriptBox["Times", "_"],
       RowBox[{"\"VerbatimProduct\"", "[", "Times", "]"}]],
      #& ], ")"}], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"v", 
          StyleBox[GridBox[{
             {"A"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`v[$CellContext`A],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"V", 
          StyleBox[GridBox[{
             {"B"},
             {" "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V[$CellContext`B],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " "},
             {"A", "B"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`T[-$CellContext`A, -$CellContext`B],
      Editable->False]}], "]"}]}],
  SequenceForm["ToCanonical:: result: ", 
   xAct`xTensor`Private`VerbatimProduct[Times][
    $CellContext`v[$CellContext`A], 
    $CellContext`V[$CellContext`B], 
    $CellContext`T[-$CellContext`A, -$CellContext`B]]],
  Editable->
   False]], "Print",ExpressionUUID->"95c37bf1-0b14-4d6c-949a-4bc9eb03c962"],

Cell[BoxData["0"], \
"Print",ExpressionUUID->"b21f2e96-5a38-425c-b91c-40b65e588cc5"],

Cell[BoxData["\<\"6) Coordinate expansions...\"\>"], \
"Print",ExpressionUUID->"b2e23ed1-86eb-4a56-8dd5-17bd927e1125"],

Cell[BoxData["0"], \
"Print",ExpressionUUID->"2e32106a-e949-4a94-8664-745805031060"],

Cell[BoxData["\<\"7) Rules...\"\>"], \
"Print",ExpressionUUID->"448b5ec1-52ca-4524-9b08-11e7ea3e361d"]
}, Open  ]],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"246a5c0e-3dbe-4366-893f-b69879603b77"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "B"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "D"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "C"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"832a18d8-1176-4964-b75e-42c82373a9c6"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"07391c3b-11b4-417a-962a-c164b161a4b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "B"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "D"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"c82c1f18-00c6-4d95-a194-fbb821008b5e"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"4ad9f7d7-2b50-4303-aa92-f51aa1c73d76"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"metricg", "[", 
      RowBox[{"B", ",", "A"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "A"}], "]"}], 
     RowBox[{"V", "[", 
      RowBox[{"-", "B"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"metricg", "[", 
      RowBox[{"C", ",", "D"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{"V", "[", 
      RowBox[{"-", "D"}], "]"}]}]}], ",", 
   RowBox[{"xATP`UseMetric", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"cfd27f00-d99f-4ae7-b760-515344b2c122"],

Cell[BoxData[
 RowBox[{"2", " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"g", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`metricg[-$CellContext`A, -$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`A],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"a7dc89b3-cab4-416e-b891-8a311f3a2190"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "B"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"metricg", "[", 
     RowBox[{"C", ",", "D"}], "]"}], 
    RowBox[{"v", "[", 
     RowBox[{"-", "C"}], "]"}], 
    RowBox[{"V", "[", 
     RowBox[{"-", "D"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"ab39d749-6e82-4744-8ecb-7590a15f2b47"],

Cell[BoxData[
 RowBox[{"2", " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[-$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"f9abde53-b624-4f8c-91c5-4dac8f9ca423"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"TT", "[", 
    RowBox[{"B", ",", "A"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "B"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"fec1da6a-e192-4e3c-a976-657df3183b87"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TT[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" "},
          {"B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[-$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" "},
          {"A"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[-$CellContext`A],
   Editable->
    False]}]], "Output",ExpressionUUID->"fafc1455-621b-49ca-9cf7-6e7bac32c8d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{"A", ",", "B"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"358c527d-f5e2-46c7-aeff-217bc42c432e"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"a56f2f66-8510-4e8c-8434-ac4e8228c9ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"AA", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "B"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"ee51b4f1-0ce9-4158-90f5-46e6a428c2f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"AA", 
        StyleBox[GridBox[{
           {"A", "C", " "},
           {" ", " ", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AA[$CellContext`A, C, -$CellContext`B],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"a1abf68e-a229-4677-90f2-177ff39b42e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"AA", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"08166787-0cbe-4b46-a982-87d393979642"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"AA", 
       StyleBox[GridBox[{
          {"A", "B", " "},
          {" ", " ", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`AA[$CellContext`A, $CellContext`B, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"C"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[C],
   Editable->
    False]}]], "Output",ExpressionUUID->"01917d89-eded-4f50-9347-0b7d8f7d2cc6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"AA", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "B"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"cf47fedc-54df-43bc-b18f-5b4d5ff5e679"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"f8241e4e-79ed-4efa-8a0c-675425a8aa3a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"AA", "[", 
    RowBox[{"A", ",", "B", ",", "C"}], "]"}], 
   RowBox[{"V", "[", 
    RowBox[{"-", "B"}], "]"}], 
   RowBox[{"v", "[", 
    RowBox[{"-", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"59621946-f56d-4a99-9d38-de06a94e6e42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"AA", 
        StyleBox[GridBox[{
           {"A", " ", " "},
           {" ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AA[$CellContext`A, -$CellContext`B, -C],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"B"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`v[$CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {"C"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`V[C],
   Editable->
    False]}]], "Output",ExpressionUUID->"458d019c-b1c5-43ec-9f96-6a34673c69ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{"%", " ", 
   RowBox[{"v", "[", 
    RowBox[{"-", "A"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"060ee585-8281-4628-ac00-071757463acf"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"bbfaa5f0-55be-478e-9b04-364f6c068eef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{"BB", "[", 
   RowBox[{
    RowBox[{"-", "B"}], ",", 
    RowBox[{"-", "A"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"8b7e8b1a-4acb-404a-9ce4-e593604159e6"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"A", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`A, -$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"e1ef34d5-a50c-4e9c-a2c9-49df172a55da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "C"}]}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{"C", ",", 
     RowBox[{"-", "B"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"4f048aca-3214-41c7-8208-96a70d079190"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"BB", 
        StyleBox[GridBox[{
           {"A", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BB[$CellContext`A, C],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"3610fdad-3864-4a3c-b493-1e1a5e522f32"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "C"}]}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "C"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"d508d688-c261-4b37-b37b-e9b2758eddf8"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"A", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`A, C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"753fb7f4-0265-4115-a237-3a90a849989f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCanonical", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{"C", ",", "A"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"6636c422-71d1-4b19-88b5-0d2267cd5631"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"BB", 
        StyleBox[GridBox[{
           {"A", "C"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BB[$CellContext`A, C],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`B, -C],
   Editable->
    False]}]], "Output",ExpressionUUID->"201cd5d6-24ff-49b5-ba75-60edadaedf40"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "m"}], " ", 
    RowBox[{"BB", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C"}], "]"}]}], "+", 
   RowBox[{"n", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"C", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "A"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"5f3b622c-1dff-4099-9f45-b038e3d1a358"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"537923cd-409c-4dd5-b9d7-fe33007a38bb"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"12b99c8b-b2a5-45eb-99dd-e69add6b761b"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(n\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"45cc05f2-6eaf-475f-93b1-2e5ecb807245"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
noident\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"189c859f-a074-4b6f-bd2b-6317246be1c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"m", "-", "n"}], ")"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"C", " "},
          {" ", "B"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[C, -$CellContext`B],
   Editable->
    False]}]], "Output",ExpressionUUID->"3445a9cd-139e-4427-8356-54b425ac3464"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"m", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "D"}], "]"}]}], "-", 
   RowBox[{"n", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"C", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "A"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{"D", ",", 
      RowBox[{"-", "C"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"4f770510-3d6d-4af3-8d87-a925181120f1"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"07b7ac18-5016-4fff-9a8c-a7e66c4847a4"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"bb88d433-8135-493d-81d0-3d9e00792316"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(n\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"04ea133d-05cc-46e2-99d6-42991244d215"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
noident\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"09bb0edf-0736-4bf5-9b6a-6c0333833387"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"m", "-", "n"}], ")"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"B", "C"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`B, -C],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"D", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[D, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"9b8a5154-bf75-448f-b51a-cc28496c95eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"BB", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{"C", ",", "D"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"BB", "[", 
     RowBox[{"D", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{"C", ",", "A"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"782150fe-1b45-400a-857c-dcf11f53b349"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"b2a00e00-e313-4769-b577-8f2c521e2b23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}]}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{"C", ",", "D"}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "D"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"cc7a3cb7-7293-4266-9672-813f9b6b4d03"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"0094340f-c40a-4653-b29d-d275df510fa9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"m", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"B", ",", "A"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "D"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", "F"}], "]"}]}], "+", 
   RowBox[{"n", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"C", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "A"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", 
      RowBox[{"-", "C"}]}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{"F", ",", "D"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"71a61ba5-7a4b-42f6-af78-69a5cad163cd"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1dfbc8d5-feef-42c3-96c0-f6ebfb7d267a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"191875f1-d579-41ed-9af0-1f0fcfba30ff"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(n\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"82b7b280-77c2-43cb-9932-717d521f45aa"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
noident\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"4b0b8314-2215-4594-8468-0abedc2a7fb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "m"}], "+", "n"}], ")"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", "D"},
          {"B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`B, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-C, -D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"F", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`F, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"b124c29d-7260-4158-acfd-d430b1121bf5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"m", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"A", ",", "B"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "D"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", "F"}], "]"}]}], "-", 
   RowBox[{"n", " ", 
    RowBox[{"BB", "[", 
     RowBox[{"F", ",", "B"}], "]"}], " ", 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "B"}], ",", "C"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "C"}], ",", "D"}], "]"}], 
    RowBox[{"BB", "[", 
     RowBox[{
      RowBox[{"-", "D"}], ",", "A"}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"ad27cc7c-41d8-49ee-983c-2b671a352d33"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9fb3de2c-7175-455c-bf4e-b9c76eb713c0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(m\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c50767ad-8468-48d9-ad94-86306598f8e8"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "noident"}], "MessageName"], ":", 
  " ", "\<\"Unknown expression not canonicalized: \[NoBreak]\\!\\(n\\)\
\[NoBreak] .\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6df029f9-2171-437b-a85c-e52bbc9c04f0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
noident\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e6e922a4-bfaa-4b94-9470-e59aab50cf38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"m", "-", "n"}], ")"}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"A", "B"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`A, $CellContext`B],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", "D"},
          {"B", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-$CellContext`B, D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {" ", " "},
          {"C", "D"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[-C, -D],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"BB", 
       StyleBox[GridBox[{
          {"F", "C"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`BB[$CellContext`F, C],
   Editable->
    False]}]], "Output",ExpressionUUID->"7ce49403-a59d-46f4-8187-c1e93249cc31"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{"BB", "[", 
   RowBox[{"A", ",", 
    RowBox[{"-", "A"}]}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5cd09d02-8f13-4b9b-b22b-5fb98645a119"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"4d94f3e8-ed79-4278-990e-9a52ec496d05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{"BB", "[", 
   RowBox[{
    RowBox[{"-", "A"}], ",", "A"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"20d69d45-c054-4f58-9bc0-a07651e558a2"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"8323b3ac-331d-41ae-a3dd-35d6c02257d2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "C"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "A"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"7f94c93c-b403-4ec6-910b-6fbc8f535f86"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"a61d8c36-382b-4ce7-af61-7ddd9736ba45"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"BB", "[", 
    RowBox[{"A", ",", "B"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", "C"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "C"}], ",", "D"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "D"}], ",", "F"}], "]"}], 
   RowBox[{"BB", "[", 
    RowBox[{
     RowBox[{"-", "F"}], ",", 
     RowBox[{"-", "A"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"e6367603-f6f7-4a90-b7df-2dd7f0456495"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"c021e707-0ebf-4167-9eff-4cc4a7f0b4f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{"$xpermQ", ",", 
   RowBox[{"xATP`calc", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"BB", "[", 
       RowBox[{"A", ",", "B"}], "]"}], 
      RowBox[{"BB", "[", 
       RowBox[{
        RowBox[{"-", "B"}], ",", "C"}], "]"}], 
      RowBox[{"BB", "[", 
       RowBox[{
        RowBox[{"-", "C"}], ",", "D"}], "]"}], 
      RowBox[{"BB", "[", 
       RowBox[{
        RowBox[{"-", "D"}], ",", "F"}], "]"}], 
      RowBox[{"BB", "[", 
       RowBox[{
        RowBox[{"-", "F"}], ",", 
        RowBox[{"-", "G"}]}], "]"}], 
      RowBox[{"BB", "[", 
       RowBox[{"G", ",", "G1"}], "]"}], 
      RowBox[{"BB", "[", 
       RowBox[{
        RowBox[{"-", "G1"}], ",", 
        RowBox[{"-", "A"}]}], "]"}]}], ",", 
     RowBox[{"MathLink", "\[Rule]", "True"}]}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"726e4fc4-027b-408e-9a6b-3e0a7c1dabbc"],

Cell[BoxData["0"], \
"Output",ExpressionUUID->"ea2c8e41-d923-44d2-99d1-7eaafb96eac8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SortCovDs", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "A"}], "]"}], "[", 
    RowBox[{
     RowBox[{"PD", "[", 
      RowBox[{"-", "B"}], "]"}], "[", 
     RowBox[{"T", "[", "C", "]"}], "]"}], "]"}], ",", "PD"}], 
  "]"}]], "Input",ExpressionUUID->"d28e9889-be73-445e-b720-fb98c75bcfd9"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"T", 
      StyleBox[GridBox[{
         {"C", "  ", "  "},
         {" ", 
          RowBox[{",", "A"}], 
          RowBox[{",", "B"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`PD[-$CellContext`B][
   xAct`xTensor`PD[-$CellContext`A][
    $CellContext`T[C]]],
  Editable->
   False]], "Output",ExpressionUUID->"e2c6b3f4-9489-4b3c-a855-3b03be5ac8ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{
       RowBox[{"CDM", "[", 
        RowBox[{"-", "A"}], "]"}], "[", 
       RowBox[{"T", "[", 
        RowBox[{
         RowBox[{"-", "C"}], ",", 
         RowBox[{"-", "B"}]}], "]"}], "]"}], "]"}], ",", "CDM"}], "]"}], ",", 
   
   RowBox[{"xATP`UseMetric", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"37205f3e-a0d1-4a78-a9bf-3185d3922a0d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"1f9a5090-f362-4426-8a5a-7b5831f7dab0"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"ed1a8447-250c-4a1e-95bf-13e57f363454"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", "G"},
           {"F", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[-$CellContext`F, -D, $CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G", " ", " "},
           {" ", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`G, -D, -$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"B", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", "G"},
           {"F", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[-$CellContext`F, -D, $CellContext`G],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G", " ", " "},
           {" ", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`G, -$CellContext`A, \
-$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G", " ", " "},
           {" ", "D", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`G, -D, -$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"C", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G", " ", " "},
           {" ", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`G, -$CellContext`B, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"F", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"G", " ", " "},
           {" ", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`G, -C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"F", "G"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`F, -$CellContext`G],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -C, -D],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
           StyleBox[GridBox[{
              {"G", " ", " "},
              {" ", "A", "F"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDM[$CellContext`G, -$CellContext`A, \
-$CellContext`F],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"B", "G"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, -$CellContext`G],
       Editable->False]}], "-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"B", "F", 
              RowBox[{",", "A"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`A][
       $CellContext`T[-$CellContext`B, -$CellContext`F]],
      Editable->False]}], ")"}]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"C", "F", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[-C, -$CellContext`F]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "F"},
           {"C", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-C, $CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " ", "  "},
           {"F", "A", "B", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`ChristoffelCDM[-$CellContext`F, -$CellContext`A, \
-$CellContext`B]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", "F"},
           {"B", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`B, $CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " ", "  "},
           {"F", "A", "C", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`ChristoffelCDM[-$CellContext`F, -$CellContext`A, -C]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"B", "F", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[-$CellContext`B, -$CellContext`F]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"C", "F", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[-C, -$CellContext`F]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " ", "  ", "  "},
          {"B", "C", 
           RowBox[{",", "A"}], 
           RowBox[{",", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-D][
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[-$CellContext`B, -C]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -D],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
           StyleBox[GridBox[{
              {"G", " ", " "},
              {" ", "C", "F"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDM[$CellContext`G, -C, -$CellContext`F],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"B", "G"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-$CellContext`B, -$CellContext`G],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
           StyleBox[GridBox[{
              {"G", " ", " "},
              {" ", "B", "F"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`ChristoffelCDM[$CellContext`G, -$CellContext`B, \
-$CellContext`F],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "G"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -$CellContext`G],
       Editable->False]}], "-", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"T", 
          StyleBox[GridBox[{
             {" ", " ", "  "},
             {"B", "C", 
              RowBox[{",", "F"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`PD[-$CellContext`F][
       $CellContext`T[-$CellContext`B, -C]],
      Editable->False]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"f83272b1-0ae2-411d-9bf6-ed83e5d297ea"]
}, Open  ]],

Cell["\<\
There are some problems here, involving derivatives... Note that we cannot \
rise and lower indices freely in a Pd derivative.\
\>", "Text",ExpressionUUID->"cfba49e6-607a-4125-8823-80339cd00f0a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"CDM", "[", 
    RowBox[{"-", "C"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"4651f562-919a-4a04-9001-33ff275d9a41"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"v", 
      StyleBox[GridBox[{
         {" ", "  ", "  "},
         {"A", 
          RowBox[{"|", "D"}], 
          RowBox[{"|", "C"}]}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CDM[-C][
   $CellContext`CDM[-D][
    $CellContext`v[-$CellContext`A]]],
  Editable->
   False]], "Output",ExpressionUUID->"7aec79f5-a8d1-4e95-a23f-9c2e7b3f2820"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "C"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "D"}], "]"}], "[", 
     RowBox[{"v", "[", "A", "]"}], "]"}], "]"}], ",", 
   RowBox[{"xATP`UseRiemann", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"a9710592-050b-4791-8a03-d28d406dbbc0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"A", " ", " ", " "},
           {" ", "B", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDM[$CellContext`A, -$CellContext`B, -C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`B],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"A", "  ", "  "},
          {" ", 
           RowBox[{"|", "C"}], 
           RowBox[{"|", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-D][
    $CellContext`CDM[-C][
     $CellContext`v[$CellContext`A]]],
   Editable->
    False]}]], "Output",ExpressionUUID->"dff0848e-0604-4ed3-8e53-0d698efad0f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "B"}], "]"}], "[", 
    RowBox[{
     RowBox[{"CDM", "[", 
      RowBox[{"-", "C"}], "]"}], "[", 
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"v", "[", 
       RowBox[{"-", "A"}], "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"xATP`UseRiemann", "\[Rule]", "True"}]}], 
  "]"}]], "Input",ExpressionUUID->"1d0141e8-5f6c-4640-a6ae-369894a4a696"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", "F", " ", " "},
           {"A", " ", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDM[-$CellContext`A, $CellContext`F, -C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"F", 
            RowBox[{"|", "B"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`B][
     $CellContext`v[-$CellContext`F]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"F"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " ", " ", "  "},
           {"A", "F", "B", "D", 
            RowBox[{"|", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`RiemannCDM[-$CellContext`A, -$CellContext`F, \
-$CellContext`B, -D]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", "F", " ", " "},
           {"A", " ", "B", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDM[-$CellContext`A, $CellContext`F, -$CellContext`B, \
-D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"F", 
            RowBox[{"|", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`v[-$CellContext`F]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", "F", " ", " "},
           {"A", " ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDM[-$CellContext`A, $CellContext`F, -$CellContext`B, \
-C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"F", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`v[-$CellContext`F]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {" ", "  ", "  ", "  "},
          {"A", 
           RowBox[{"|", "B"}], 
           RowBox[{"|", "C"}], 
           RowBox[{"|", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-D][
    $CellContext`CDM[-C][
     $CellContext`CDM[-$CellContext`B][
      $CellContext`v[-$CellContext`A]]]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " ", "F"},
           {"B", "C", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDM[-$CellContext`B, -C, -D, $CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{"|", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     SubscriptBox["s", "R"],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`$RiemannSign,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", "F", " ", " "},
           {"B", " ", "C", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`RiemannCDM[-$CellContext`B, $CellContext`F, -C, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"A", 
            RowBox[{"|", "F"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`F][
     $CellContext`v[-$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"316f6e80-fc33-4ba3-baed-8d678da4c705"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"ChangeCovD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CDM", "[", 
       RowBox[{"-", "A"}], "]"}], "[", 
      RowBox[{
       RowBox[{"CDM", "[", 
        RowBox[{"-", "C"}], "]"}], "[", 
       RowBox[{"V", "[", 
        RowBox[{"-", "B"}], "]"}], "]"}], "]"}], ",", "CDM"}], "]"}], ",", 
   RowBox[{"xATP`UseMetric", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"ddc1256e-acfd-45d3-a315-2f23f0e76447"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"e5b4d97e-8c8b-4d40-92ee-249fd2307a74"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"D", "C", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[-D, -C, -$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, \
-$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"D", "B", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[-D, -$CellContext`B, -$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"D", "A", "F"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[-D, -$CellContext`A, -$CellContext`F],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"F", "A", "D"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[-$CellContext`F, -$CellContext`A, -D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"F", " ", " "},
           {" ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`F, -$CellContext`B, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {"D"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`V[D],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " ", " ", "  "},
           {"D", "B", "C", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`ChristoffelCDM[-D, -$CellContext`B, -C]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"D", " ", " "},
           {" ", "B", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[D, -$CellContext`B, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"D", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`V[-D]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"D", " ", " "},
           {" ", "A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[D, -$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"D", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`V[-D]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"V", 
       StyleBox[GridBox[{
          {" ", "  ", "  "},
          {"B", 
           RowBox[{",", "A"}], 
           RowBox[{",", "C"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-C][
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`V[-$CellContext`B]]],
   Editable->False], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"D", " ", " "},
           {" ", "A", "C"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[D, -$CellContext`A, -C],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"V", 
        StyleBox[GridBox[{
           {" ", "  "},
           {"B", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`V[-$CellContext`B]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"e0544b32-2ae8-4942-abd2-9f5caa8f62ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"mu", ",", 
     RowBox[{"-", "nu"}]}], "]"}], 
   RowBox[{"T", "[", 
    RowBox[{
     RowBox[{"-", "mu"}], ",", "nu"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"8c451db6-9da8-4ddb-ba1d-ba0f60ed9696"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"a", "A"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`a, -$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"a", "A"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`a, $CellContext`A],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"a", "b"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`a, -$CellContext`b],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"a", "b"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`a, $CellContext`b],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " "},
           {"A", "B"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[-$CellContext`A, -$CellContext`B],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"A", "B"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`T[$CellContext`A, $CellContext`B],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"1ab84671-2b4e-4a5a-b816-77aaf899b663"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"mu", ",", 
      RowBox[{"-", "nu"}]}], "]"}], 
    RowBox[{"T", "[", 
     RowBox[{
      RowBox[{"-", "mu"}], ",", "nu"}], "]"}]}], ",", 
   RowBox[{"xATP`ExpandProductManifolds", "\[Rule]", "False"}], ",", 
   RowBox[{"xATP`UseMetric", "\[Rule]", "False"}]}], 
  "]"}]], "Input",ExpressionUUID->"2c363908-39d4-4d49-8adb-52aeba9ff634"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {" ", " "},
          {"mu", "nu"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[-$CellContext`mu, -$CellContext`nu],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"mu", "nu"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`T[$CellContext`mu, $CellContext`nu],
   Editable->
    False]}]], "Output",ExpressionUUID->"e35b7ec4-0e6d-4e58-894a-fc25d1e28ed9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{"v", "[", "A", "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"PD", "[", 
    RowBox[{"-", "D"}], "]"}], "[", 
   RowBox[{"T", "[", 
    RowBox[{"B", ",", 
     RowBox[{"-", "C"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"ac6aa1d4-ded0-471b-a372-06839cb35e3c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[ScriptCapitalL]", "v"], GridBox[{
      {"T", 
       StyleBox[GridBox[{
          {"B", " ", "  "},
          {" ", "C", 
           RowBox[{",", "D"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xTensor`LieD[
   $CellContext`v[$CellContext`A]][
   xAct`xTensor`PD[-D][
    $CellContext`T[$CellContext`B, -C]]],
  Editable->
   False]], "Output",ExpressionUUID->"a60d20f1-08db-437c-b1c1-b2d61738872f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{
     RowBox[{"v", "[", "A", "]"}], ",", "PD"}], "]"}], "[", 
   RowBox[{
    RowBox[{"PD", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"19fca90a-de63-4e21-af1f-6321c51c252a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"6f57faf3-8a15-4825-ab51-1a1998ad51fc"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"c99d84c1-ea39-4c28-8da3-733dac1f759d"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ToCanonical", "::", "cmods"}], "MessageName"], ":", 
  " ", "\<\"Detected metric-incompatible derivatives \[NoBreak]\\!\\({PD}\\)\
\[NoBreak].\"\>"}]], "Message", \
"MSG",ExpressionUUID->"945458db-74ba-4958-8c01-927f6198d74f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(ToCanonical :: \
cmods\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", \
"MSG",ExpressionUUID->"9a6bfad6-dcbe-4e94-a7df-741f1848190e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  ", "  "},
           {" ", "C", 
            RowBox[{",", "D"}], 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     xAct`xTensor`PD[-D][
      $CellContext`T[$CellContext`B, -C]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{",", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-C][
     $CellContext`v[$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "A", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[$CellContext`B, -$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B", 
            RowBox[{",", "A"}]},
           {" ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[$CellContext`A][
     $CellContext`v[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"C", "A", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`T[-C, -$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{",", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-$CellContext`A][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{",", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`PD[-D][
     $CellContext`v[$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"\[CapitalGamma]", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {"A", " ", "F"},
           {" ", "D", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ChristoffelCDM[$CellContext`A, -D, $CellContext`F],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "F"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -$CellContext`F],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"B", "  "},
              {" ", 
               RowBox[{",", "A"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`PD[-$CellContext`A][
        $CellContext`v[$CellContext`B]],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"T", 
           StyleBox[GridBox[{
              {" ", " "},
              {"C", "A"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`T[-C, -$CellContext`A],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"v", 
           StyleBox[GridBox[{
              {"B", "  "},
              {" ", 
               RowBox[{",", "F"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`PD[-$CellContext`F][
        $CellContext`v[$CellContext`B]],
       Editable->False]}]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"21d03b0c-d173-4302-ac88-55c863a2397b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"LieD", "[", 
    RowBox[{
     RowBox[{"v", "[", "A", "]"}], ",", "CDM"}], "]"}], "[", 
   RowBox[{
    RowBox[{"CDM", "[", 
     RowBox[{"-", "D"}], "]"}], "[", 
    RowBox[{"T", "[", 
     RowBox[{"B", ",", 
      RowBox[{"-", "C"}]}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"fd627816-b875-40df-971f-c83089e539d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`A],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  ", "  "},
           {" ", "C", 
            RowBox[{"|", "D"}], 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`A][
     $CellContext`CDM[-D][
      $CellContext`T[$CellContext`B, -C]]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{"|", "C"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-C][
     $CellContext`v[$CellContext`A]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "A", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[$CellContext`B, -$CellContext`A]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"B", 
            RowBox[{"|", "A"}]},
           {" ", "  "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[$CellContext`A][
     $CellContext`v[$CellContext`B]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {" ", " ", "  "},
           {"C", "A", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`T[-C, -$CellContext`A]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"T", 
        StyleBox[GridBox[{
           {"B", " ", "  "},
           {" ", "C", 
            RowBox[{"|", "A"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-$CellContext`A][
     $CellContext`T[$CellContext`B, -C]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"A", "  "},
           {" ", 
            RowBox[{"|", "D"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`CDM[-D][
     $CellContext`v[$CellContext`A]],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"9862afb3-3c4c-483e-ab10-ca17f9c2cc0b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VarD", "[", " ", 
    RowBox[{"HH", "[", 
     RowBox[{"-", "A"}], "]"}], " ", "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "[", "]"}], "^", "2"}], 
     RowBox[{"HH", "[", 
      RowBox[{"-", "C"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"HH", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{"HH", "[", 
      RowBox[{"-", "D"}], "]"}]}]}], " ", "]"}], "/.", "np"}]], "Input",
 Evaluatable->False,ExpressionUUID->"c73a9e04-c94a-494c-805d-31ace891ed3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" D\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " D", "A"],
    Editable->False], " ", 
   InterpretationBox[
    SubsuperscriptBox["H", "\<\"C\"\>", "\<\"\"\>"],
    Subsuperscript[H, "C", ""],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" C\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " C", "A"],
    Editable->False], " ", 
   InterpretationBox[
    SubsuperscriptBox["H", "\<\"D\"\>", "\<\"\"\>"],
    Subsuperscript[H, "D", ""],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" C\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " C", "A"],
    Editable->False], " ", 
   SuperscriptBox[
    InterpretationBox[
     SubsuperscriptBox["r", "\<\"\"\>", "\<\"\"\>"],
     Subsuperscript[r, "", ""],
     Editable->False], "2"]}]}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"57e24193-9124-4467-9bc2-a868966e9222"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VarD", "[", " ", 
    RowBox[{"HH", "[", 
     RowBox[{"-", "A"}], "]"}], " ", "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "[", "]"}], "^", "2"}], 
     RowBox[{
      RowBox[{"Pd", "[", 
       RowBox[{"-", "F"}], "]"}], "[", 
      RowBox[{
       RowBox[{"Pd", "[", 
        RowBox[{"-", "D"}], "]"}], "[", 
       RowBox[{"HH", "[", 
        RowBox[{"-", "C"}], "]"}], "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"HH", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{"HH", "[", 
      RowBox[{"-", "D"}], "]"}]}]}], " ", "]"}], "/.", "np"}]], "Input",
 Evaluatable->False,ExpressionUUID->"b29afb06-0fe0-4f99-ab2e-16cec08e5b4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" D\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " D", "A"],
    Editable->False], " ", 
   InterpretationBox[
    SubsuperscriptBox["H", "\<\"C\"\>", "\<\"\"\>"],
    Subsuperscript[H, "C", ""],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" C\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " C", "A"],
    Editable->False], " ", 
   InterpretationBox[
    SubsuperscriptBox["H", "\<\"D\"\>", "\<\"\"\>"],
    Subsuperscript[H, "D", ""],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" C\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " C", "A"],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       SubsuperscriptBox["r", "\<\"\"\>", "\<\"\"\>"],
       Subsuperscript[r, "", ""],
       Editable->False], " ", 
      InterpretationBox[
       SubsuperscriptBox["r", "\<\",DF\"\>", "\<\"\"\>"],
       Subsuperscript[r, ",DF", ""],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       SubsuperscriptBox["r", "\<\",D\"\>", "\<\"\"\>"],
       Subsuperscript[r, ",D", ""],
       Editable->False], " ", 
      InterpretationBox[
       SubsuperscriptBox["r", "\<\",F\"\>", "\<\"\"\>"],
       Subsuperscript[r, ",F", ""],
       Editable->False]}]}], ")"}]}]}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->
  False,ExpressionUUID->"530abc73-3ede-4492-a33b-6d10096e9e89"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"calc", "[", 
  RowBox[{
   RowBox[{"VarD", "[", " ", 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], " ", "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "[", "]"}], "^", "2"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "D"}], "]"}], " ", 
     RowBox[{"v", "[", "D", "]"}]}]}], "]"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"5483de1e-a6d8-4da3-8a3d-aa19c015bf91"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" C\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " C", "A"],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       SubsuperscriptBox["r", "\<\"\"\>", "\<\"\"\>"],
       Subsuperscript[r, "", ""],
       Editable->False], "2"], "+", 
     RowBox[{
      InterpretationBox[
       SubsuperscriptBox["v", "\<\"\"\>", "\<\"B\"\>"],
       Subsuperscript[v, "", "B"],
       Editable->False], " ", 
      InterpretationBox[
       SubsuperscriptBox["v", "\<\"B\"\>", "\<\"\"\>"],
       Subsuperscript[v, "B", ""],
       Editable->False]}]}], ")"}]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    SubsuperscriptBox["v", "\<\"\"\>", "\<\"A\"\>"],
    Subsuperscript[v, "", "A"],
    Editable->False], " ", 
   InterpretationBox[
    SubsuperscriptBox["v", "\<\"C\"\>", "\<\"\"\>"],
    Subsuperscript[v, "C", ""],
    Editable->
     False]}]}]], \
"Output",ExpressionUUID->"18933616-0624-44da-9f6f-68eeafb41a60"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"calc", "[", 
  RowBox[{
   RowBox[{"VarD", "[", " ", 
    RowBox[{"v", "[", 
     RowBox[{"-", "A"}], "]"}], " ", "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"r", "[", "]"}], "^", "2"}], 
     RowBox[{
      RowBox[{"Pd", "[", 
       RowBox[{"-", "D"}], "]"}], "[", 
      RowBox[{"v", "[", 
       RowBox[{"-", "C"}], "]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"v", "[", 
      RowBox[{"-", "C"}], "]"}], 
     RowBox[{"v", "[", 
      RowBox[{"-", "D"}], "]"}]}]}], " ", "]"}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"5cd0a782-5e07-4f29-ac26-49f02a8c135c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" D\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " D", "A"],
    Editable->False], " ", 
   InterpretationBox[
    SubsuperscriptBox["v", "\<\"C\"\>", "\<\"\"\>"],
    Subsuperscript[v, "C", ""],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    SubsuperscriptBox["g", "\<\" C\"\>", "\<\"A\"\>"],
    Subsuperscript[g, " C", "A"],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       SubsuperscriptBox["r", "\<\"\"\>", "\<\"\"\>"],
       Subsuperscript[r, "", ""],
       Editable->False], " ", 
      InterpretationBox[
       SubsuperscriptBox["r", "\<\",D\"\>", "\<\"\"\>"],
       Subsuperscript[r, ",D", ""],
       Editable->False]}], "+", 
     InterpretationBox[
      SubsuperscriptBox["v", "\<\"D\"\>", "\<\"\"\>"],
      Subsuperscript[v, "D", ""],
      Editable->False]}], 
    ")"}]}]}]], \
"Output",ExpressionUUID->"fb934122-a761-473f-9483-00ae729cf369"]
}, Open  ]],

Cell["Product manifolds", \
"Text",ExpressionUUID->"0fefefef-e288-4963-aae7-db3886e498af"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RiemannCD4", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"4a504b46-8ad8-4f8a-b074-489fcf45b2e2"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
         StyleBox[GridBox[{
            {"A", " ", " ", " "},
            {" ", "B", "C", "D"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RiemannCDM[$CellContext`A, -$CellContext`B, -C, -D],
     Editable->False]}], "+", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Gamma]", 
         StyleBox[GridBox[{
            {"a", "b"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`gamma[$CellContext`a, $CellContext`b],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"\[Delta]", 
            StyleBox[GridBox[{
               {"A", " "},
               {" ", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`delta[$CellContext`A, -D],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`B, -C],
        Editable->False]}], "-", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"\[Delta]", 
            StyleBox[GridBox[{
               {"A", " "},
               {" ", "C"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`delta[$CellContext`A, -C],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`B, -D],
        Editable->False]}]}], ")"}], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`a][
       $CellContext`w[]],
      Editable->False], ")"}], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`b][
       $CellContext`w[]],
      Editable->False], ")"}]}]}], 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], 
   "2"]]], "Output",ExpressionUUID->"7d20a82c-60a9-42b3-9310-c32904174833"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RiemannCD4", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "D"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"153eefe1-5a25-453a-9227-2f3b79a0e559"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Gamma]", 
        StyleBox[GridBox[{
           {"a", "b"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`gamma[$CellContext`a, $CellContext`b],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["w",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"g", 
            StyleBox[GridBox[{
               {" ", " "},
               {"B", "D"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`metricg[-$CellContext`B, -D],
        Editable->False]}], " ", 
      RowBox[{"(", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          SubscriptBox["\[EmptyDownTriangle]", "C"], "r"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`CDM[-C][
         $CellContext`r[]],
        Editable->False], ")"}]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"g", 
           StyleBox[GridBox[{
              {" ", " "},
              {"B", "C"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`metricg[-$CellContext`B, -C],
       Editable->False], " ", 
      RowBox[{"(", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          SubscriptBox["\[EmptyDownTriangle]", "D"], "r"}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`CDM[-D][
         $CellContext`r[]],
        Editable->False], ")"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`CDS[-$CellContext`b][
      $CellContext`w[]],
     Editable->False], ")"}]}], 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], 
   "3"]]], "Output",ExpressionUUID->"dd352ba9-cf8e-4724-a42e-a53760d81628"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RiemannCD4", "[", 
    RowBox[{"A", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "C"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"7c17c1d4-9c6c-429f-88e8-c7f2a03e341b"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"\[Gamma]", 
          StyleBox[GridBox[{
             {" ", " "},
             {"b", "d"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`gamma[-$CellContext`b, -$CellContext`d],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"g", 
          StyleBox[GridBox[{
             {"A", "B"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`metricg[$CellContext`A, $CellContext`B],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], " ", 
     RowBox[{"(", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "C"], 
         SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-C][
        $CellContext`CDM[-$CellContext`B][
         $CellContext`r[]]],
       Editable->False], ")"}]}], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"\[Delta]", 
          StyleBox[GridBox[{
             {"A", " "},
             {" ", "C"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`delta[$CellContext`A, -C],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["w",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[],
      Editable->False], " ", 
     RowBox[{"(", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "d"], 
         SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDS[-$CellContext`d][
        $CellContext`CDS[-$CellContext`b][
         $CellContext`w[]]],
       Editable->False], ")"}]}]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->False], 
    "2"]]}]], \
"Output",ExpressionUUID->"fe853b8e-1a74-437c-86ca-701010261e31"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RicciCD4", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "B"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"a12efae2-f4b8-48ad-9c55-4b10547ea0fc"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RicciCDM[-$CellContext`A, -$CellContext`B],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "B"], 
        SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDM[-$CellContext`B][
       $CellContext`CDM[-$CellContext`A][
        $CellContext`r[]]],
      Editable->False], ")"}]}], "-", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Gamma]", 
         StyleBox[GridBox[{
            {"a", "b"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`gamma[$CellContext`a, $CellContext`b],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`metricg[-$CellContext`A, -$CellContext`B],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDS[-$CellContext`a][
          $CellContext`w[]],
         Editable->False], ")"}], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDS[-$CellContext`b][
          $CellContext`w[]],
         Editable->False], ")"}]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["w",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "b"], 
           SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDS[-$CellContext`b][
          $CellContext`CDS[-$CellContext`a][
           $CellContext`w[]]],
         Editable->False], ")"}]}]}], ")"}]}]}], 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], 
   "2"]]], "Output",ExpressionUUID->"557d53d7-99b0-4a94-98f5-4460857a22b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RicciCD4", "[", 
    RowBox[{
     RowBox[{"-", "A"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"dcb538ba-1e27-40cc-9059-75f677c9c6ab"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDM[-$CellContext`A][
       $CellContext`r[]],
      Editable->False], ")"}], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`b][
       $CellContext`w[]],
      Editable->False], ")"}]}], 
   RowBox[{
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->
      False]}]]}]], \
"Output",ExpressionUUID->"5801349c-a7cb-4395-9095-be8ff1820c6f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RicciCD4", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "A"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"a3f124df-39ee-47f8-9cf5-6df3bb2038f3"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDM[-$CellContext`A][
       $CellContext`r[]],
      Editable->False], ")"}], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`b][
       $CellContext`w[]],
      Editable->False], ")"}]}], 
   RowBox[{
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->
      False]}]]}]], \
"Output",ExpressionUUID->"aa1e357a-84a8-4a79-b1c6-6e10a7558bc7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RicciCD4", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"3b743f17-c159-4970-9df7-cb431a283990"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {
         RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
         StyleBox[GridBox[{
            {" ", " "},
            {"a", "b"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RicciCDS[-$CellContext`a, -$CellContext`b],
     Editable->False], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["w",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[],
      Editable->False], "2"]}], "-", 
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Gamma]", 
         StyleBox[GridBox[{
            {" ", " "},
            {"a", "b"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`gamma[-$CellContext`a, -$CellContext`b],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`metricg[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDM[-$CellContext`A][
          $CellContext`r[]],
         Editable->False], ")"}], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDM[-$CellContext`B][
          $CellContext`r[]],
         Editable->False], ")"}]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "B"], 
           SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDM[-$CellContext`B][
          $CellContext`CDM[-$CellContext`A][
           $CellContext`r[]]],
         Editable->False], ")"}]}]}], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "b"], 
        SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`b][
       $CellContext`CDS[-$CellContext`a][
        $CellContext`w[]]],
      Editable->False], ")"}]}]}], 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["w",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[],
    Editable->False], 
   "2"]]], "Output",ExpressionUUID->"424618df-d26e-4d78-80a8-14584e21048d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"xATP`calc", "[", 
   RowBox[{"RicciScalarCD4", "[", "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"$RiemannSign", "\[Rule]", "1"}], ",", 
    RowBox[{"$RicciSign", "\[Rule]", "1"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"f1062e90-7302-46f2-95b4-19106d16e6a7"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RicciScalarCDM[],
     Editable->False]}], "+", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`RicciScalarCDS[],
     Editable->False], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["w",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`w[],
      Editable->False], "2"]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {"A", "B"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`metricg[$CellContext`A, $CellContext`B],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDM[-$CellContext`A][
          $CellContext`r[]],
         Editable->False], ")"}], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "B"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDM[-$CellContext`B][
          $CellContext`r[]],
         Editable->False], ")"}]}], "+", 
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "B"], 
           SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDM[-$CellContext`B][
          $CellContext`CDM[-$CellContext`A][
           $CellContext`r[]]],
         Editable->False], ")"}]}]}], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Gamma]", 
         StyleBox[GridBox[{
            {"a", "b"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`gamma[$CellContext`a, $CellContext`b],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDS[-$CellContext`a][
          $CellContext`w[]],
         Editable->False], ")"}], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDS[-$CellContext`b][
          $CellContext`w[]],
         Editable->False], ")"}]}], "+", 
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["w",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`w[],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "b"], 
           SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CDS[-$CellContext`b][
          $CellContext`CDS[-$CellContext`a][
           $CellContext`w[]]],
         Editable->False], ")"}]}]}], ")"}]}]}], 
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->False], 
    "2"]}]]], \
"Output",ExpressionUUID->"b53fb563-2a7f-4d09-80ff-ec0f1b46be83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xATP`calc", "[", 
  RowBox[{
   RowBox[{"CD4", "[", 
    RowBox[{"-", "A"}], "]"}], "[", 
   RowBox[{"TT", "[", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "]"}], 
  "]"}]], "Input",ExpressionUUID->"5137be3c-bee9-41c1-a4a7-726993d5705c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"TT", 
          StyleBox[GridBox[{
             {" ", " "},
             {"B", "b"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`TT[-$CellContext`B, -$CellContext`b],
      Editable->False], " ", 
     RowBox[{"(", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "A"], "r"}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CDM[-$CellContext`A][
        $CellContext`r[]],
       Editable->False], ")"}]}], 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False]]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"TT", 
       StyleBox[GridBox[{
          {" ", " ", "  "},
          {"B", "b", 
           RowBox[{"|", "A"}]}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`CDM[-$CellContext`A][
    $CellContext`TT[-$CellContext`B, -$CellContext`b]],
   Editable->False], "+", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"g", 
         StyleBox[GridBox[{
            {" ", " "},
            {"A", "B"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`metricg[-$CellContext`A, -$CellContext`B],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"TT", 
         StyleBox[GridBox[{
            {"a", " "},
            {" ", "b"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TT[$CellContext`a, -$CellContext`b],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox["w",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`w[],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "a"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`a][
       $CellContext`w[]],
      Editable->False], ")"}]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"]], "-", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox[GridBox[{
        {"TT", 
         StyleBox[GridBox[{
            {" ", " "},
            {"B", "A"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TT[-$CellContext`B, -$CellContext`A],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "b"], "w"}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CDS[-$CellContext`b][
       $CellContext`w[]],
      Editable->False], ")"}]}], 
   InterpretationBox[
    StyleBox["w",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`w[],
    Editable->
     False]]}]], \
"Output",ExpressionUUID->"516f8d91-2adf-40f0-9a69-e0ff3b69abd3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VisitorsOf", "[", "M2", 
  "]"}]], "Input",ExpressionUUID->"41cfda5c-ba54-4a19-b2ab-35f949e393a5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Mprod", ",", "metricg", ",", "epsilonmetricg", ",", "CDM", ",", 
   "TorsionCDM", ",", "ChristoffelCDM", ",", "RiemannCDM", ",", "RicciCDM", 
   ",", "RicciScalarCDM", ",", "EinsteinCDM", ",", "WeylCDM", ",", 
   "TFRicciCDM", ",", "KretschmannCDM", ",", "Detmetricg", ",", "r", ",", "V",
    ",", "v", ",", "T", ",", "BB", ",", "TT", ",", "S", ",", "GG", ",", "HH", 
   ",", "AA"}], 
  "}"}]], "Output",ExpressionUUID->"7883a473-8d29-41ab-987d-ec5c6c639d37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Metrics"], \
"Input",ExpressionUUID->"b6b65c75-6b18-4729-ac64-87f7e717ab01"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"metricg", ",", "gamma", ",", "g4"}], 
  "}"}]], "Output",ExpressionUUID->"13cd5720-83c7-4ac6-8f9d-bc4ec9197aab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefMetric", "/@", "%"}], 
  ";"}]], "Input",ExpressionUUID->"6ee46c0e-3cd8-41e3-b1c7-b358b767407b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"084d8d66-237b-456c-9e42-2cab0ca816a2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDM],
  Editable->
   False]], "Print",ExpressionUUID->"935ed181-a859-4004-b30e-255fab7e66c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCDM],
  Editable->
   False]], "Print",ExpressionUUID->"2846af01-e3cb-42d9-ab29-906601d0a195"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCDM],
  Editable->
   False]], "Print",ExpressionUUID->"fcf612fd-ca1c-443a-a536-caad4eebdb25"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCDM],
  Editable->
   False]], "Print",ExpressionUUID->"9d9dc3da-2e05-4d05-bf43-a06bfb95daae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCDM],
  Editable->
   False]], "Print",ExpressionUUID->"66fd4e65-5aa2-4dbf-af08-54598dbe68be"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDM],
  Editable->
   False]], "Print",ExpressionUUID->"7e4ef7d8-0703-4d17-a22a-5b9dc00753a7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCDM],
  Editable->
   False]], "Print",ExpressionUUID->"43e00551-69b3-41e4-ad2d-0dd95f72d095"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDM],
  Editable->
   False]], "Print",ExpressionUUID->"f9ed88e9-a820-41aa-b71a-20878d3d3a9e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCDM],
  Editable->
   False]], "Print",ExpressionUUID->"034aac04-c21b-4f68-af78-a55c7f1452f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDM"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDM],
  Editable->
   False]], "Print",ExpressionUUID->"435c5787-3e7a-4ab5-a5b6-760086e7cc1c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilonmetricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilonmetricg],
  Editable->
   False]], "Print",ExpressionUUID->"8d852f05-2e9e-4c52-848d-7bda2e67b4e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "metricg"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`metricg],
  Editable->
   False]], "Print",ExpressionUUID->"467c8bc8-fa89-4027-aa79-0271c669c7f6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detgamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detgamma],
  Editable->
   False]], "Print",ExpressionUUID->"bc4a7f6d-cf13-4d6f-a34c-5c0ecee47925"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCDS],
  Editable->
   False]], "Print",ExpressionUUID->"eb67161b-2365-4978-80d3-87288e69843a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Einstein tensor", 
   " ", $CellContext`EinsteinCDS],
  Editable->
   False]], "Print",ExpressionUUID->"538f7216-2f8b-482c-b496-ebd9d054871b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCDS],
  Editable->
   False]], "Print",ExpressionUUID->"c2d9d392-6cfd-46b7-aab4-d3780159e63b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCDS],
  Editable->
   False]], "Print",ExpressionUUID->"e10351e9-c6b4-404b-b5a2-9bbb9bf5c906"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCDS],
  Editable->
   False]], "Print",ExpressionUUID->"602d152d-25ce-4009-844d-51274be75463"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCDS],
  Editable->
   False]], "Print",ExpressionUUID->"8e044292-68b8-4b4e-8065-c1aef7899ded"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "TFRicci tensor", 
   " ", $CellContext`TFRicciCDS],
  Editable->
   False]], "Print",ExpressionUUID->"d747881d-2b6f-4931-b35e-84767c3cd33f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCDS],
  Editable->
   False]], "Print",ExpressionUUID->"c0018fd4-fc85-482b-a377-9903d4940cbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCDS],
  Editable->
   False]], "Print",ExpressionUUID->"abe244b2-ed75-4f9f-888c-88cf615b4fba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CDS"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CDS],
  Editable->
   False]], "Print",ExpressionUUID->"4230db8a-98ed-4687-90e8-719098959ce7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilongamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilongamma],
  Editable->
   False]], "Print",ExpressionUUID->"9baf0ada-859a-409f-85b9-e3b3533dd371"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "gamma"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`gamma],
  Editable->
   False]], "Print",ExpressionUUID->"4e02aaa3-276b-422f-ba2f-b5d067283daa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"weight +2 density\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Detg4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "weight +2 density", 
   " ", $CellContext`Detg4],
  Editable->
   False]], "Print",ExpressionUUID->"9e9edc62-d7e5-4ba1-a819-4d225de69227"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Christoffel tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "ChristoffelCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Christoffel tensor", " ", $CellContext`ChristoffelCD4],
  Editable->
   False]], "Print",ExpressionUUID->"55b254b9-a82c-4d23-ad14-c5ca0b669195"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Einstein tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "EinsteinCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", 
   "symmetric Einstein tensor", " ", $CellContext`EinsteinCD4],
  Editable->
   False]], "Print",ExpressionUUID->"79a075b5-f05d-4bb4-81d6-030055b90b91"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Kretschmann scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "KretschmannCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Kretschmann scalar", 
   " ", $CellContext`KretschmannCD4],
  Editable->
   False]], "Print",ExpressionUUID->"370ee8c6-a152-474e-a896-43b96ec5d5f7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric Ricci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric Ricci tensor", 
   " ", $CellContext`RicciCD4],
  Editable->
   False]], "Print",ExpressionUUID->"2c142c43-1a4f-4154-af8d-4ddaea3fc2d0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Ricci scalar\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RicciScalarCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Ricci scalar", 
   " ", $CellContext`RicciScalarCD4],
  Editable->
   False]], "Print",ExpressionUUID->"3a325a2a-1578-4a68-b6ef-9beb69553b8a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Riemann tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "RiemannCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Riemann tensor", 
   " ", $CellContext`RiemannCD4],
  Editable->
   False]], "Print",ExpressionUUID->"2670dc9a-38e7-4b3d-97e9-2eca0efbd560"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric TFRicci tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TFRicciCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric TFRicci tensor",
    " ", $CellContext`TFRicciCD4],
  Editable->
   False]], "Print",ExpressionUUID->"2f18a926-b15b-46e3-a459-c4e2678e9084"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"torsion tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "TorsionCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "torsion tensor", 
   " ", $CellContext`TorsionCD4],
  Editable->
   False]], "Print",ExpressionUUID->"b95fecc0-a0c0-4e5d-ae8c-c100c7c524b0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"Weyl tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "WeylCD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "Weyl tensor", 
   " ", $CellContext`WeylCD4],
  Editable->
   False]], "Print",ExpressionUUID->"272df9f3-789b-4e3f-94e8-da41c4d108aa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefCovD", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"covariant derivative\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "CD4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefCovD, ": Undefined ", "covariant derivative", 
   " ", $CellContext`CD4],
  Editable->
   False]], "Print",ExpressionUUID->"c77aa9d3-a272-4b5a-8bf8-751e34745e5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Tetrag4\[Dagger]"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tetrametric", 
   " ", $CellContext`Tetrag4\[Dagger]],
  Editable->
   False]], "Print",ExpressionUUID->"5cc13bb8-a165-438b-b972-5b5b87f01379"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tetrametric\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "Tetrag4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tetrametric", 
   " ", $CellContext`Tetrag4],
  Editable->
   False]], "Print",ExpressionUUID->"b1954294-b2c4-44ed-9f68-7c7f25cab461"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"antisymmetric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "epsilong4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "antisymmetric tensor", 
   " ", $CellContext`epsilong4],
  Editable->
   False]], "Print",ExpressionUUID->"ccb649cd-70d2-4509-ab39-facca8acb381"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"symmetric metric tensor\"\>", 
   "\[InvisibleSpace]", "\<\" \"\>", "\[InvisibleSpace]", "g4"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "symmetric metric tensor", 
   " ", $CellContext`g4],
  Editable->
   False]], "Print",ExpressionUUID->"874b3470-2818-45cb-ba32-ee3aecc0454f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Tensors"], \
"Input",ExpressionUUID->"b2ca6310-627a-4520-80b4-0f6a729af00e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "r", ",", "w", ",", "V", ",", "v", ",", "T", ",", "BB", ",", "TT", ",", "S",
    ",", "GG", ",", "HH", ",", "AA"}], 
  "}"}]], "Output",ExpressionUUID->"18ae529e-0d86-44ec-a53c-2c794af7850f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefTensor", "/@", "%"}], 
  ";"}]], "Input",ExpressionUUID->"f860ddf1-a4e1-46ad-b662-2d4812a304ea"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "r"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`r],
  Editable->
   False]], "Print",ExpressionUUID->"747a9d08-4e3c-4520-9d59-c099280bb93d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "w"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`w],
  Editable->
   False]], "Print",ExpressionUUID->"cc4e45b8-d030-444c-aa22-5d52a202f6e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "V"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`V],
  Editable->
   False]], "Print",ExpressionUUID->"403f32d2-e66f-4a2a-a0bb-bf8a440e8024"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "v"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`v],
  Editable->
   False]], "Print",ExpressionUUID->"527504f1-edc5-4b4c-a90f-ad411c7da3f6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "T"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`T],
  Editable->
   False]], "Print",ExpressionUUID->"aa0717b1-656c-48e7-b93c-7c4d4df2a027"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "BB"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`BB],
  Editable->
   False]], "Print",ExpressionUUID->"57eb10e7-2335-4f96-adb5-f92a7e783d07"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "TT"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`TT],
  Editable->
   False]], "Print",ExpressionUUID->"e88b8005-f9b3-4213-b3ee-6890a1ca5728"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`S],
  Editable->
   False]], "Print",ExpressionUUID->"23c80a9b-89dc-49ee-a70b-9f255ef5e957"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "GG"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`GG],
  Editable->
   False]], "Print",ExpressionUUID->"5a15da9e-5099-4e4c-926b-dacf1dca289f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "HH"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`HH],
  Editable->
   False]], "Print",ExpressionUUID->"72e8106c-33be-44b6-9728-adf069fc9edc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefTensor", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"tensor\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "AA"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefTensor, ": Undefined ", "tensor", 
   " ", $CellContext`AA],
  Editable->
   False]], "Print",ExpressionUUID->"88cfae98-700c-486f-9d2c-a6890c9cf734"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Undefining manifolds takes some time because we search for all associated \
dollar-dummies:\
\>", "Text",ExpressionUUID->"96611996-80ff-4766-9784-6bfe11b32ec0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "Mprod", 
  "]"}]], "Input",ExpressionUUID->"03bef9a8-de9c-415c-9140-52570a33158d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]Mprod",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentMprod,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentMprod],
  Editable->
   False]], "Print",ExpressionUUID->"051637eb-3787-4d4f-9838-c7520248752c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "Mprod"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`Mprod],
  Editable->
   False]], "Print",ExpressionUUID->"d9cc4362-0582-4763-98f1-735282acae54"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefManifold", "/@", 
   RowBox[{"{", 
    RowBox[{"M2", ",", "S2"}], "}"}]}], 
  ";"}]], "Input",ExpressionUUID->"e9b4207d-afaf-48ec-9c98-ea60e0d10205"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]M2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentM2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentM2],
  Editable->
   False]], "Print",ExpressionUUID->"bf3431da-5ed3-4b04-889b-97e5f5cc8add"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "M2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`M2],
  Editable->
   False]], "Print",ExpressionUUID->"e86bb975-556d-4baa-813b-d1469fbffd11"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefVBundle", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"vbundle\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   InterpretationBox[
    StyleBox["\[DoubleStruckCapitalT]S2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TangentS2,
    Editable->False]}],
  SequenceForm[
  "** ", xAct`xTensor`UndefVBundle, ": Undefined ", "vbundle", 
   " ", $CellContext`TangentS2],
  Editable->
   False]], "Print",ExpressionUUID->"57d1ee25-ffe4-4331-9f26-d294d62f18cd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "UndefManifold", 
   "\[InvisibleSpace]", "\<\": Undefined \"\>", 
   "\[InvisibleSpace]", "\<\"manifold\"\>", "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", "S2"}],
  SequenceForm[
  "** ", xAct`xTensor`UndefManifold, ": Undefined ", "manifold", 
   " ", $CellContext`S2],
  Editable->
   False]], "Print",ExpressionUUID->"82be78da-081c-4c00-869e-264f225794d7"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", 
   RowBox[{"m", ",", "n"}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"9c66393b-0b01-43a0-b1b6-1b2b596d04cb"],

Cell[BoxData[
 RowBox[{"EndExamples", "[", 
  "]"}]], "Input",ExpressionUUID->"8e1d0cc4-e21e-4926-a7c7-7a6903c19649"]
}, Closed]],

Cell[CellGroupData[{

Cell["18.3. EndPackage", \
"Subsection",ExpressionUUID->"442c47e0-2bb0-46d0-ac86-6e677cb89b95"],

Cell["Switch on messages about new symbols:", \
"Text",ExpressionUUID->"f2a65384-7482-4e7a-ae88-1070ffc15c59"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"On", "[", 
   RowBox[{"General", "::", "newsym"}], "]"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"703e0a99-5444-4f56-bacc-a000e732f7e9"],

Cell[CellGroupData[{

Cell[BoxData["$Context"], \
"Input",ExpressionUUID->"62f79d42-5283-4f4e-9a34-9ce66a6c925c"],

Cell[BoxData["\<\"xAct`xTensor`Private`\"\>"], \
"Output",ExpressionUUID->"f5852834-0579-4e03-a8db-8a6b8db7203f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"6697e738-e7d3-4364-ac1e-64e96672f0eb"],

Cell[BoxData["\<\"xAct`xTensor`Private`\"\>"], \
"Output",ExpressionUUID->"fb54c6a9-45c6-4dd3-8832-9a798a825b20"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Context"], \
"Input",ExpressionUUID->"90bdde70-bde6-480e-a711-b15a2c511dac"],

Cell[BoxData["\<\"xAct`xTensor`\"\>"], \
"Output",ExpressionUUID->"fb71fa96-c4e8-41f1-9ae3-483f2e141025"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"8ab776d5-9601-4f08-8d21-ffcb8fcdb63d"],

Cell[CellGroupData[{

Cell[BoxData["$Context"], \
"Input",ExpressionUUID->"ffce0be6-a800-4f69-a9ed-b80559e80304"],

Cell[BoxData["\<\"Global`\"\>"], \
"Output",ExpressionUUID->"10102385-8188-4d8d-adfc-c4743919224a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeUsed", "[", "]"}], ",", 
   RowBox[{"SessionTime", "[", "]"}], ",", 
   RowBox[{
    RowBox[{"TimeUsed", "[", "]"}], "/", 
    RowBox[{"SessionTime", "[", "]"}]}]}], 
  "}"}]], "Input",ExpressionUUID->"4215492b-7cfa-4e0e-8a51-0571135c6339"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "101.554065`", ",", "797.242657`9.35313552136197", ",", 
   "0.12738165967887805`"}], 
  "}"}]], "Output",ExpressionUUID->"71e2e6e1-7e4b-4e85-831c-a679d0d867eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"MaxMemoryUsed", "[", "]"}], ",", 
     RowBox[{"MemoryInUse", "[", "]"}]}], "}"}], "/", "1000"}], "/", 
  "1024."}]], "Input",ExpressionUUID->"d4e57f07-84f3-4b28-b7c3-333fb7ca78f2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"75.693859375`", ",", "67.236375`"}], 
  "}"}]], "Output",ExpressionUUID->"b8337b9a-d995-4096-85e9-83cee2da79db"]
}, Open  ]],

Cell["\<\
Private names that do not contain the dollar sign and have not been \
registered with usage messages in section 1:\
\>", "Text",ExpressionUUID->"52ef467c-1a44-40f0-887a-300f8661ac29"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"StringReplace", "[", 
      RowBox[{"#", ",", 
       RowBox[{"\"\<xAct`xTensor`Private`\>\"", "\[Rule]", "\"\<\>\""}]}], 
      "]"}], "&"}], "/@", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"Names", "[", "\"\<xAct`xTensor`Private`*\>\"", "]"}], ",", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"StringMatchQ", "[", 
         RowBox[{"#", ",", "\"\<*$*\>\""}], "]"}]}], "&"}]}], "]"}]}], ",", 
   "xAct`xTensor`Private`$xTensorPrivateNames"}], "]"}]], "Input",
 PageWidth:>
  WindowWidth,ExpressionUUID->"a55c5721-9951-4610-b587-ff4489bbf507"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"a1\"\>", ",", "\<\"a2\"\>", 
   ",", "\<\"AA\"\>", ",", "\<\"ABBA\"\>", ",", "\<\"AbsorbSign\"\>", 
   ",", "\<\"accelerationname\"\>", ",", "\<\"AChristoffelName\"\>", 
   ",", "\<\"action\"\>", ",", "\<\"AD\"\>", ",", "\<\"addChristoffel\"\>", 
   ",", "\<\"addChristoffelDensity\"\>", ",", "\<\"addconditions\"\>", 
   ",", "\<\"addCurvature\"\>", ",", "\<\"addCurvature1\"\>", 
   ",", "\<\"addderivative\"\>", ",", "\<\"addhead1A\"\>", 
   ",", "\<\"addhead1B\"\>", ",", "\<\"addheadnA\"\>", 
   ",", "\<\"addheadnB\"\>", ",", "\<\"AddIndexInSecondList\"\>", 
   ",", "\<\"AddIndicesInFirstList\"\>", ",", "\<\"addonetolast\"\>", 
   ",", "\<\"addOther\"\>", ",", "\<\"addOther1\"\>", 
   ",", "\<\"addTMPCovD\"\>", ",", "\<\"addTorsion\"\>", 
   ",", "\<\"addweight\"\>", ",", "\<\"adjective\"\>", ",", "\<\"ADSym\"\>", 
   ",", "\<\"all\"\>", ",", "\<\"allbundles\"\>", 
   ",", "\<\"alldependencies\"\>", ",", "\<\"allinds\"\>", 
   ",", "\<\"allirules\"\>", ",", "\<\"alls\"\>", ",", "\<\"anynumberQ\"\>", 
   ",", "\<\"appendderindex\"\>", ",", "\<\"appendindex\"\>", 
   ",", "\<\"AppendIndexPair\"\>", ",", "\<\"appendzrules\"\>", 
   ",", "\<\"args\"\>", ",", "\<\"args1\"\>", ",", "\<\"args2\"\>", 
   ",", "\<\"arrangedummies\"\>", ",", "\<\"ArrangeProjector\"\>", 
   ",", "\<\"ArrangeSplitRules\"\>", ",", "\<\"array\"\>", 
   ",", "\<\"arrexpr2\"\>", ",", "\<\"as\"\>", ",", "\<\"ASort\"\>", 
   ",", "\<\"asymcoeff\"\>", ",", "\<\"aud\"\>", ",", "\<\"aV\"\>", 
   ",", "\<\"average\"\>", ",", "\<\"aVmet\"\>", ",", "\<\"aVQ\"\>", 
   ",", "\<\"b\"\>", ",", "\<\"b1\"\>", ",", "\<\"base\"\>", 
   ",", "\<\"base1\"\>", ",", "\<\"baseifbundle\"\>", ",", "\<\"BasesIn\"\>", 
   ",", "\<\"basis\"\>", ",", "\<\"basis2\"\>", ",", "\<\"basisorweight\"\>", 
   ",", "\<\"bi\"\>", ",", "\<\"biggroup\"\>", ",", "\<\"bl\"\>", 
   ",", "\<\"blanks\"\>", ",", "\<\"blocked\"\>", ",", "\<\"BlockGridBox\"\>",
    ",", "\<\"BlockTensor\"\>", ",", "\<\"bls\"\>", ",", "\<\"box\"\>", 
   ",", "\<\"box1\"\>", ",", "\<\"boxes\"\>", ",", "\<\"br\"\>", 
   ",", "\<\"BracketizedBoxesIfTimes\"\>", ",", "\<\"break\"\>", 
   ",", "\<\"breakChristoffel\"\>", ",", "\<\"BreakProjected\"\>", 
   ",", "\<\"buildmetric\"\>", ",", "\<\"bundles\"\>", 
   ",", "\<\"BundlesOfCovD\"\>", ",", "\<\"bV\"\>", ",", "\<\"bVmet\"\>", 
   ",", "\<\"c\"\>", ",", "\<\"c1\"\>", ",", "\<\"calc\"\>", 
   ",", "\<\"canv\"\>", ",", "\<\"capitalmessage\"\>", ",", "\<\"careQ\"\>", 
   ",", "\<\"case\"\>", ",", "\<\"cases\"\>", ",", "\<\"cd\"\>", 
   ",", "\<\"cda\"\>", ",", "\<\"cdb\"\>", ",", "\<\"cdc\"\>", 
   ",", "\<\"cdd\"\>", ",", "\<\"cds\"\>", ",", "\<\"cdtensor\"\>", 
   ",", "\<\"cdummies\"\>", ",", "\<\"center\"\>", ",", "\<\"changeCovD\"\>", 
   ",", "\<\"changeDir\"\>", ",", "\<\"changefirst\"\>", 
   ",", "\<\"changeFreeIndices\"\>", ",", "\<\"changeRicci\"\>", 
   ",", "\<\"changeRicciScalar\"\>", ",", "\<\"changeRiemann\"\>", 
   ",", "\<\"changeRuleforfreepmQ\"\>", ",", "\<\"changeTMPCovD\"\>", 
   ",", "\<\"changetoinducedmetric\"\>", ",", "\<\"changeTorsion\"\>", 
   ",", "\<\"changez\"\>", ",", "\<\"changez2\"\>", ",", "\<\"char\"\>", 
   ",", "\<\"CharacterList\"\>", ",", "\<\"chars\"\>", ",", "\<\"chart\"\>", 
   ",", "\<\"CheckBasis1Index\"\>", ",", "\<\"CheckBasis2Index\"\>", 
   ",", "\<\"checkChangeFreeIndices\"\>", 
   ",", "\<\"checkChristoffelIndices\"\>", ",", "\<\"checkcovdcurvature\"\>", 
   ",", "\<\"checkgrade\"\>", ",", "\<\"checkLengthOne\"\>", 
   ",", "\<\"checkLengthOneGrade\"\>", ",", "\<\"CheckMakeProjectors\"\>", 
   ",", "\<\"checkoneindex\"\>", ",", "\<\"CheckRepeated1\"\>", 
   ",", "\<\"checksplittensor\"\>", ",", "\<\"checksplittensors\"\>", 
   ",", "\<\"checkweight\"\>", ",", "\<\"ChooseRules\"\>", ",", "\<\"chr\"\>",
    ",", "\<\"CHR\"\>", ",", "\<\"chra\"\>", ",", "\<\"christoffel\"\>", 
   ",", "\<\"Christoffel12Name\"\>", ",", "\<\"ChristoffelName\"\>", 
   ",", "\<\"christoffels\"\>", ",", "\<\"christoffelToGradMetric\"\>", 
   ",", "\<\"chrname\"\>", ",", "\<\"chrtype\"\>", ",", "\<\"cind\"\>", 
   ",", "\<\"clist\"\>", ",", "\<\"CM\"\>", ",", "\<\"coeff\"\>", 
   ",", "\<\"coeffs\"\>", ",", "\<\"color\"\>", ",", "\<\"command\"\>", 
   ",", "\<\"comment\"\>", ",", "\<\"CommutingCycles\"\>", 
   ",", "\<\"compareCovDs\"\>", ",", "\<\"compareCovDserror\"\>", 
   ",", "\<\"CompatibleCovDsQ\"\>", ",", "\<\"comPD\"\>", 
   ",", "\<\"complementary\"\>", ",", "\<\"ComplementaryProjectorsQ\"\>", 
   ",", "\<\"ComposeProjectors\"\>", ",", "\<\"cond\"\>", 
   ",", "\<\"conditions\"\>", ",", "\<\"conds\"\>", ",", "\<\"confactor\"\>", 
   ",", "\<\"ConflictingDummies\"\>", ",", "\<\"confto\"\>", 
   ",", "\<\"constant\"\>", ",", "\<\"constmet\"\>", 
   ",", "\<\"ConstructLHSinfo\"\>", ",", "\<\"ConstructModule\"\>", 
   ",", "\<\"contr\"\>", ",", "\<\"ContractDir1\"\>", 
   ",", "\<\"contractGdelta\"\>", ",", "\<\"ContractMetric0\"\>", 
   ",", "\<\"ContractMetric2\"\>", ",", "\<\"ContractProjector0\"\>", 
   ",", "\<\"ContractProjector1\"\>", ",", "\<\"contractz\"\>", 
   ",", "\<\"contrrhs\"\>", ",", "\<\"convertChristoffelTMP\"\>", 
   ",", "\<\"coset\"\>", ",", "\<\"count\"\>", ",", "\<\"covd\"\>", 
   ",", "\<\"covd1\"\>", ",", "\<\"covd2\"\>", ",", "\<\"CovDIndices\"\>", 
   ",", "\<\"covdinds\"\>", ",", "\<\"covdL\"\>", ",", "\<\"covdR\"\>", 
   ",", "\<\"covds\"\>", ",", "\<\"covdsymbol\"\>", 
   ",", "\<\"CovDSymmetryOf\"\>", ",", "\<\"CovDTensor\"\>", 
   ",", "\<\"CovDTensor1\"\>", ",", "\<\"CovDTensorQ\"\>", 
   ",", "\<\"CovDTensorSym\"\>", ",", "\<\"CovDTMP\"\>", 
   ",", "\<\"CovDToLieD\"\>", ",", "\<\"CP\"\>", ",", "\<\"cprods\"\>", 
   ",", "\<\"cs\"\>", ",", "\<\"cthrough\"\>", ",", "\<\"curv\"\>", 
   ",", "\<\"curvature\"\>", ",", "\<\"curvedbundles\"\>", 
   ",", "\<\"curvQ\"\>", ",", "\<\"curvrels\"\>", ",", "\<\"cV\"\>", 
   ",", "\<\"cv1\"\>", ",", "\<\"cv2\"\>", ",", "\<\"cVmet\"\>", 
   ",", "\<\"cycles\"\>", ",", "\<\"cycs\"\>", ",", "\<\"d\"\>", 
   ",", "\<\"d1\"\>", ",", "\<\"da\"\>", ",", "\<\"dag\"\>", 
   ",", "\<\"DaggerCovD\"\>", ",", "\<\"DaggerIMod\"\>", 
   ",", "\<\"daghead\"\>", ",", "\<\"dalpha\"\>", ",", "\<\"db\"\>", 
   ",", "\<\"dbeta\"\>", ",", "\<\"dc\"\>", ",", "\<\"dd\"\>", 
   ",", "\<\"dda\"\>", ",", "\<\"default\"\>", ",", "\<\"defChristoffel\"\>", 
   ",", "\<\"DefCovDCheck\"\>", ",", "\<\"defcovdFiber\"\>", 
   ",", "\<\"defcovdTangent\"\>", ",", "\<\"DefInducedMetric\"\>", 
   ",", "\<\"definvQ\"\>", ",", "\<\"deflistableCovDs\"\>", 
   ",", "\<\"deflistableMetrics\"\>", ",", "\<\"deflistableProjectors\"\>", 
   ",", "\<\"defmessage\"\>", ",", "\<\"DefMetricCheck\"\>", 
   ",", "\<\"defproj\"\>", ",", "\<\"defproj2\"\>", 
   ",", "\<\"DefProjection\"\>", ",", "\<\"DefRigging\"\>", 
   ",", "\<\"DefSign\"\>", ",", "\<\"DefSplitTensors\"\>", 
   ",", "\<\"DefTensorCheckIndices\"\>", ",", "\<\"DefTensorChecks\"\>", 
   ",", "\<\"DefTensorSymmetryChecks\"\>", ",", "\<\"deltas\"\>", 
   ",", "\<\"dep\"\>", ",", "\<\"dependencies\"\>", ",", "\<\"deps\"\>", 
   ",", "\<\"der\"\>", ",", "\<\"der1\"\>", ",", "\<\"dername\"\>", 
   ",", "\<\"deronvbundle\"\>", ",", "\<\"ders\"\>", ",", "\<\"ders1\"\>", 
   ",", "\<\"ders2\"\>", ",", "\<\"dersin\"\>", ",", "\<\"DersIn\"\>", 
   ",", "\<\"dersR\"\>", ",", "\<\"DerSymbolLength\"\>", 
   ",", "\<\"derwithindex\"\>", ",", "\<\"dexpr\"\>", ",", "\<\"dgx\"\>", 
   ",", "\<\"diagonal\"\>", ",", "\<\"DiagonalArray\"\>", 
   ",", "\<\"differentexpressionsQ\"\>", ",", "\<\"dim\"\>", 
   ",", "\<\"dimF\"\>", ",", "\<\"dims\"\>", ",", "\<\"diphi\"\>", 
   ",", "\<\"dir\"\>", ",", "\<\"dirQ\"\>", ",", "\<\"DisplaceSlots\"\>", 
   ",", "\<\"dm\"\>", ",", "\<\"dmb\"\>", ",", "\<\"Dname\"\>", 
   ",", "\<\"dollarindices\"\>", ",", "\<\"dollars\"\>", ",", "\<\"dom\"\>", 
   ",", "\<\"domain\"\>", ",", "\<\"domdim\"\>", ",", "\<\"down\"\>", 
   ",", "\<\"downind\"\>", ",", "\<\"downspt\"\>", ",", "\<\"downspts\"\>", 
   ",", "\<\"downstr\"\>", ",", "\<\"downstring\"\>", ",", "\<\"downvs\"\>", 
   ",", "\<\"dphi\"\>", ",", "\<\"DropEPairs\"\>", 
   ",", "\<\"DropFromHosts\"\>", ",", "\<\"DropIndexBasis\"\>", 
   ",", "\<\"DropPairs\"\>", ",", "\<\"dum\"\>", ",", "\<\"dummies\"\>", 
   ",", "\<\"dummies2\"\>", ",", "\<\"dummy\"\>", ",", "\<\"dummy1\"\>", 
   ",", "\<\"dummy2\"\>", ",", "\<\"dummyb\"\>", ",", "\<\"dummyc\"\>", 
   ",", "\<\"dummypairs\"\>", ",", "\<\"dummypool\"\>", 
   ",", "\<\"dummysets\"\>", ",", "\<\"DummySorted\"\>", ",", "\<\"dums\"\>", 
   ",", "\<\"dupfreemetric\"\>", ",", "\<\"DuplicateRule\"\>", 
   ",", "\<\"duplicateRulefordummy\"\>", ",", "\<\"duplicateRuleforfree\"\>", 
   ",", "\<\"dv\"\>", ",", "\<\"dV\"\>", ",", "\<\"e\"\>", ",", "\<\"eC\"\>", 
   ",", "\<\"ef\"\>", ",", "\<\"einstein\"\>", ",", "\<\"EinsteinName\"\>", 
   ",", "\<\"elem\"\>", ",", "\<\"elements\"\>", ",", "\<\"els\"\>", 
   ",", "\<\"empty\"\>", ",", "\<\"EmptyILs\"\>", 
   ",", "\<\"EmptySymmetry\"\>", ",", "\<\"endowedQ\"\>", ",", "\<\"eoib\"\>",
    ",", "\<\"epsilonname\"\>", ",", "\<\"eq\"\>", ",", "\<\"equation\"\>", 
   ",", "\<\"equivalents\"\>", ",", "\<\"ev\"\>", ",", "\<\"EvaluateHeld\"\>",
    ",", "\<\"ExpandCoordinates\"\>", ",", "\<\"expandGdelta\"\>", 
   ",", "\<\"ExpandLieD\"\>", ",", "\<\"ExpandLinearPush\"\>", 
   ",", "\<\"ExpandProductManifolds\"\>", ",", "\<\"ExpandProductMetric1\"\>",
    ",", "\<\"ExpandPullBackCovD\"\>", ",", "\<\"ExpandPullBackTensor\"\>", 
   ",", "\<\"ExpandPushForwardTensor\"\>", ",", "\<\"expandSdelta\"\>", 
   ",", "\<\"ExplodeTensor\"\>", ",", "\<\"expr1\"\>", ",", "\<\"expr2\"\>", 
   ",", "\<\"exprinds\"\>", ",", "\<\"exprs\"\>", 
   ",", "\<\"ExtractIsolated\"\>", ",", "\<\"extrinsicKname\"\>", 
   ",", "\<\"ExtrinsicKToGradNormalRules\"\>", ",", "\<\"f\"\>", 
   ",", "\<\"factors\"\>", ",", "\<\"fbundle\"\>", ",", "\<\"fdindices\"\>", 
   ",", "\<\"fi1\"\>", ",", "\<\"fi2\"\>", ",", "\<\"fi3\"\>", 
   ",", "\<\"fi4\"\>", ",", "\<\"findexlist\"\>", ",", "\<\"first\"\>", 
   ",", "\<\"FirstIndexOfVBundle\"\>", ",", "\<\"firstmetric\"\>", 
   ",", "\<\"firstmetricofvbundle\"\>", ",", "\<\"firstQ\"\>", 
   ",", "\<\"firsts\"\>", ",", "\<\"firules\"\>", ",", "\<\"flat\"\>", 
   ",", "\<\"flatPD\"\>", ",", "\<\"FlattenRowBox\"\>", 
   ",", "\<\"FlattenTimes\"\>", ",", "\<\"fm\"\>", ",", "\<\"forcesym\"\>", 
   ",", "\<\"form\"\>", ",", "\<\"form1\"\>", ",", "\<\"form2\"\>", 
   ",", "\<\"format\"\>", ",", "\<\"FormatIndexRule\"\>", 
   ",", "\<\"forms\"\>", ",", "\<\"free\"\>", ",", "\<\"freeindices\"\>", 
   ",", "\<\"frees\"\>", ",", "\<\"frees1\"\>", ",", "\<\"frees2\"\>", 
   ",", "\<\"freesLHS\"\>", ",", "\<\"freesof\"\>", ",", "\<\"freesRHS\"\>", 
   ",", "\<\"FRiemannName\"\>", ",", "\<\"frobeniusQ\"\>", 
   ",", "\<\"FromIndexExpr\"\>", ",", "\<\"FromTensorDerivative1\"\>", 
   ",", "\<\"FromTensorDerivativeIndex\"\>", ",", "\<\"frozen\"\>", 
   ",", "\<\"frozenQ\"\>", ",", "\<\"func\"\>", ",", "\<\"function\"\>", 
   ",", "\<\"fx\"\>", ",", "\<\"fy\"\>", ",", "\<\"g\"\>", ",", "\<\"G\"\>", 
   ",", "\<\"GaussCodazziRules\"\>", ",", "\<\"gd\"\>", 
   ",", "\<\"Gdeltasym\"\>", ",", "\<\"glist\"\>", ",", "\<\"gop\"\>", 
   ",", "\<\"gp\"\>", ",", "\<\"grade\"\>", ",", "\<\"GradeOfBIndex\"\>", 
   ",", "\<\"GradeOfDer\"\>", ",", "\<\"GradeOfIndex\"\>", 
   ",", "\<\"graderule\"\>", ",", "\<\"gradInvMetricTerm\"\>", 
   ",", "\<\"gradMetricTerm\"\>", ",", "\<\"gradMetricToChristoffel\"\>", 
   ",", "\<\"GradNormalToExtrinsicKRules\"\>", ",", "\<\"GrassmannQ\"\>", 
   ",", "\<\"grid\"\>", ",", "\<\"gridbox\"\>", ",", "\<\"group\"\>", 
   ",", "\<\"grouplist\"\>", ",", "\<\"groups\"\>", ",", "\<\"gs\"\>", 
   ",", "\<\"GS\"\>", ",", "\<\"h\"\>", ",", "\<\"HasOrthogonalIndexQ\"\>", 
   ",", "\<\"head\"\>", ",", "\<\"HEAD\"\>", ",", "\<\"head1\"\>", 
   ",", "\<\"head2\"\>", ",", "\<\"heads\"\>", ",", "\<\"HeldLHS\"\>", 
   ",", "\<\"HeldRHS\"\>", ",", "\<\"HELLO\"\>", ",", "\<\"HoldTimes\"\>", 
   ",", "\<\"hosts\"\>", ",", "\<\"hosts2\"\>", ",", "\<\"i\"\>", 
   ",", "\<\"i1\"\>", ",", "\<\"i1d\"\>", ",", "\<\"i2\"\>", 
   ",", "\<\"i2d\"\>", ",", "\<\"i3\"\>", ",", "\<\"i3d\"\>", 
   ",", "\<\"i4\"\>", ",", "\<\"i4d\"\>", ",", "\<\"i5\"\>", 
   ",", "\<\"Identify\"\>", ",", "\<\"Identity1\"\>", ",", "\<\"ie\"\>", 
   ",", "\<\"iexpr\"\>", ",", "\<\"iexpr1\"\>", ",", "\<\"iexpr2\"\>", 
   ",", "\<\"ih\"\>", ",", "\<\"ii1\"\>", ",", "\<\"ii2\"\>", 
   ",", "\<\"ii3\"\>", ",", "\<\"iindsQ\"\>", ",", "\<\"il\"\>", 
   ",", "\<\"ilist\"\>", ",", "\<\"im\"\>", ",", "\<\"image\"\>", 
   ",", "\<\"imdim\"\>", ",", "\<\"immQ\"\>", ",", "\<\"imod\"\>", 
   ",", "\<\"ImplodedName\"\>", ",", "\<\"ImplodedQ\"\>", ",", "\<\"ind\"\>", 
   ",", "\<\"ind1\"\>", ",", "\<\"ind2\"\>", ",", "\<\"inddagger\"\>", 
   ",", "\<\"index\"\>", ",", "\<\"Index\"\>", ",", "\<\"index1\"\>", 
   ",", "\<\"index2\"\>", ",", "\<\"index3\"\>", ",", "\<\"index4\"\>", 
   ",", "\<\"index5\"\>", ",", "\<\"index6\"\>", ",", "\<\"index7\"\>", 
   ",", "\<\"index8\"\>", ",", "\<\"IndexArray\"\>", 
   ",", "\<\"IndexCoefficient1\"\>", ",", "\<\"IndexCoefficient2\"\>", 
   ",", "\<\"IndexCoefficient3\"\>", ",", "\<\"IndexCoefficient4\"\>", 
   ",", "\<\"IndexExpr\"\>", ",", "\<\"indexgrid\"\>", 
   ",", "\<\"IndexGrid\"\>", ",", "\<\"IndexLength\"\>", 
   ",", "\<\"indexlist\"\>", ",", "\<\"indices\"\>", ",", "\<\"indices1\"\>", 
   ",", "\<\"indmetric\"\>", ",", "\<\"inds\"\>", ",", "\<\"inds1\"\>", 
   ",", "\<\"inds2\"\>", ",", "\<\"indsL\"\>", ",", "\<\"indsLHS\"\>", 
   ",", "\<\"indsR\"\>", ",", "\<\"indsRHS\"\>", 
   ",", "\<\"inducedDecomposition\"\>", 
   ",", "\<\"inducedDecompositionObject\"\>", ",", "\<\"inducedfrom\"\>", 
   ",", "\<\"inducedQ\"\>", ",", "\<\"indumetric\"\>", ",", "\<\"indv\"\>", 
   ",", "\<\"InerthHeadQ\"\>", ",", "\<\"info\"\>", ",", "\<\"initinds\"\>", 
   ",", "\<\"inout\"\>", ",", "\<\"inoutall\"\>", ",", "\<\"inoutlength\"\>", 
   ",", "\<\"inoutproject\"\>", ",", "\<\"inoutrules\"\>", 
   ",", "\<\"inouts\"\>", ",", "\<\"inside\"\>", ",", "\<\"int\"\>", 
   ",", "\<\"integerdimQ\"\>", ",", "\<\"integers\"\>", 
   ",", "\<\"intensor\"\>", ",", "\<\"InterpretSplitRules\"\>", 
   ",", "\<\"inv\"\>", ",", "\<\"invD\"\>", ",", "\<\"InvertibleMappingQ\"\>",
    ",", "\<\"invertQ\"\>", ",", "\<\"invmetric\"\>", 
   ",", "\<\"InvMetric\"\>", ",", "\<\"invnew\"\>", ",", "\<\"iperm\"\>", 
   ",", "\<\"iphi\"\>", ",", "\<\"ir\"\>", ",", "\<\"is\"\>", 
   ",", "\<\"islots\"\>", ",", "\<\"isolated\"\>", ",", "\<\"isolated2\"\>", 
   ",", "\<\"isorules\"\>", ",", "\<\"iv\"\>", ",", "\<\"iv1\"\>", 
   ",", "\<\"iv2\"\>", ",", "\<\"j\"\>", ",", "\<\"JoinCharacters\"\>", 
   ",", "\<\"JoinExprs\"\>", ",", "\<\"joininds\"\>", 
   ",", "\<\"JoinSGSCommuting\"\>", ",", "\<\"JoinSGSoverlap\"\>", 
   ",", "\<\"JoinSymmetries\"\>", ",", "\<\"k\"\>", 
   ",", "\<\"KretschmannName\"\>", ",", "\<\"l\"\>", ",", "\<\"label\"\>", 
   ",", "\<\"lambda\"\>", ",", "\<\"large\"\>", ",", "\<\"last\"\>", 
   ",", "\<\"LCmetric\"\>", ",", "\<\"left\"\>", ",", "\<\"left1\"\>", 
   ",", "\<\"left2\"\>", ",", "\<\"leibnitz\"\>", ",", "\<\"length\"\>", 
   ",", "\<\"lengths\"\>", ",", "\<\"LexicSorted\"\>", ",", "\<\"lhs\"\>", 
   ",", "\<\"LHS\"\>", ",", "\<\"LHSinfo\"\>", ",", "\<\"lied\"\>", 
   ",", "\<\"lieDcovDdiff\"\>", ",", "\<\"LieDTensor\"\>", 
   ",", "\<\"lietensor\"\>", ",", "\<\"lin\"\>", ",", "\<\"linds\"\>", 
   ",", "\<\"LinearPushString\"\>", ",", "\<\"LinearPushVBundles\"\>", 
   ",", "\<\"list\"\>", ",", "\<\"list1\"\>", ",", "\<\"list2\"\>", 
   ",", "\<\"ListableQ\"\>", ",", "\<\"lists\"\>", ",", "\<\"ll\"\>", 
   ",", "\<\"lproj\"\>", ",", "\<\"ltinds\"\>", ",", "\<\"m\"\>", 
   ",", "\<\"M\"\>", ",", "\<\"MakeBoxesCovD\"\>", 
   ",", "\<\"MakeBoxesParamD\"\>", ",", "\<\"makechangeCovD\"\>", 
   ",", "\<\"makeChangeCurvatureRules\"\>", 
   ",", "\<\"makeChangeRicciRule\"\>", 
   ",", "\<\"makeChangeRicciScalarRule\"\>", 
   ",", "\<\"makeChangeRiemannRule\"\>", ",", "\<\"makeChangeTorsionRule\"\>",
    ",", "\<\"makeChristoffel\"\>", ",", "\<\"makeChristoffelRule\"\>", 
   ",", "\<\"makeCommuteCovDs\"\>", ",", "\<\"MakeDistributiveProduct\"\>", 
   ",", "\<\"MakeDummySet\"\>", ",", "\<\"MakeLinearDerivative\"\>", 
   ",", "\<\"MakeLinearProduct\"\>", ",", "\<\"makepattern\"\>", 
   ",", "\<\"MakeProjectors\"\>", ",", "\<\"MakePullBackIndex\"\>", 
   ",", "\<\"makerule\"\>", ",", "\<\"makeScalar\"\>", 
   ",", "\<\"MakeSequenceBox\"\>", ",", "\<\"MakeTensorBoxes\"\>", 
   ",", "\<\"MakeTensorGridBoxes\"\>", ",", "\<\"MakeTensorialDerivative\"\>",
    ",", "\<\"MakeTensorScriptBoxes\"\>", ",", "\<\"MakeVBundlePair\"\>", 
   ",", "\<\"MakeVBundlePairs\"\>", ",", "\<\"man\"\>", 
   ",", "\<\"manicharpermQ\"\>", ",", "\<\"manichars\"\>", 
   ",", "\<\"manifold\"\>", ",", "\<\"manifold1\"\>", 
   ",", "\<\"manifold2\"\>", ",", "\<\"manifolds\"\>", 
   ",", "\<\"manifolds1\"\>", ",", "\<\"manifolds2\"\>", ",", "\<\"map\"\>", 
   ",", "\<\"MapOnIsolated\"\>", ",", "\<\"MappingName\"\>", 
   ",", "\<\"master\"\>", ",", "\<\"matrix\"\>", ",", "\<\"MBexpr\"\>", 
   ",", "\<\"mdummy\"\>", ",", "\<\"mess\"\>", ",", "\<\"met\"\>", 
   ",", "\<\"method\"\>", ",", "\<\"metric\"\>", ",", "\<\"metric1\"\>", 
   ",", "\<\"metric2\"\>", ",", "\<\"metriccovd\"\>", 
   ",", "\<\"MetricCovDQ\"\>", ",", "\<\"metricderstate\"\>", 
   ",", "\<\"metricendQ\"\>", ",", "\<\"metricof\"\>", 
   ",", "\<\"metricofcovd1\"\>", ",", "\<\"metricQ\"\>", 
   ",", "\<\"metrics\"\>", ",", "\<\"metricsign\"\>", 
   ",", "\<\"MetricsIn\"\>", ",", "\<\"metricsof\"\>", 
   ",", "\<\"metricsQ\"\>", ",", "\<\"metricstate\"\>", 
   ",", "\<\"metricstate1\"\>", ",", "\<\"MetricTensorQ\"\>", 
   ",", "\<\"min\"\>", ",", "\<\"MIndexQ\"\>", ",", "\<\"minds\"\>", 
   ",", "\<\"minimumdepth\"\>", ",", "\<\"mms\"\>", ",", "\<\"mo\"\>", 
   ",", "\<\"mono\"\>", ",", "\<\"monomial\"\>", ",", "\<\"monomials\"\>", 
   ",", "\<\"MonomialsOfTerm\"\>", ",", "\<\"movedindices\"\>", 
   ",", "\<\"movedpoints\"\>", ",", "\<\"mQ\"\>", ",", "\<\"ms\"\>", 
   ",", "\<\"mss\"\>", ",", "\<\"mstate\"\>", ",", "\<\"mstates\"\>", 
   ",", "\<\"mu\"\>", ",", "\<\"multiD\"\>", ",", "\<\"MyDer\"\>", 
   ",", "\<\"MyUnion\"\>", ",", "\<\"MyUnion1\"\>", ",", "\<\"n\"\>", 
   ",", "\<\"n1\"\>", ",", "\<\"n2\"\>", ",", "\<\"name\"\>", 
   ",", "\<\"needed\"\>", ",", "\<\"NeededChange\"\>", 
   ",", "\<\"NeededChanges\"\>", ",", "\<\"new\"\>", ",", "\<\"newbase\"\>", 
   ",", "\<\"newcovd\"\>", ",", "\<\"newders\"\>", ",", "\<\"newdummies\"\>", 
   ",", "\<\"newexpr\"\>", ",", "\<\"newexpr2\"\>", ",", "\<\"newfree\"\>", 
   ",", "\<\"newfrees\"\>", ",", "\<\"newindex\"\>", 
   ",", "\<\"newindices\"\>", ",", "\<\"newinds\"\>", ",", "\<\"newLHSs\"\>", 
   ",", "\<\"newmanichars\"\>", ",", "\<\"newSGS\"\>", ",", "\<\"newsyms\"\>",
    ",", "\<\"newtensor\"\>", ",", "\<\"newtensors\"\>", ",", "\<\"next\"\>", 
   ",", "\<\"next2\"\>", ",", "\<\"niceindices\"\>", ",", "\<\"nl\"\>", 
   ",", "\<\"no\"\>", ",", "\<\"nodummies\"\>", ",", "\<\"NonScalarVarD\"\>", 
   ",", "\<\"nonzero\"\>", ",", "\<\"norm\"\>", ",", "\<\"NormalVectorOf\"\>",
    ",", "\<\"normofvector\"\>", ",", "\<\"not\"\>", 
   ",", "\<\"NotGrassmannQ\"\>", ",", "\<\"ns\"\>", ",", "\<\"nstotal\"\>", 
   ",", "\<\"nu\"\>", ",", "\<\"number\"\>", ",", "\<\"numberpair\"\>", 
   ",", "\<\"numsym\"\>", ",", "\<\"nv\"\>", ",", "\<\"object\"\>", 
   ",", "\<\"Object\"\>", ",", "\<\"object1\"\>", ",", "\<\"object2\"\>", 
   ",", "\<\"ObjectOrderItems\"\>", ",", "\<\"objects\"\>", 
   ",", "\<\"ObjectSort\"\>", ",", "\<\"od\"\>", ",", "\<\"odeps\"\>", 
   ",", "\<\"old\"\>", ",", "\<\"oldcovd\"\>", ",", "\<\"oldind\"\>", 
   ",", "\<\"oneSterm\"\>", ",", "\<\"OneVBundleRules\"\>", ",", "\<\"op\"\>",
    ",", "\<\"options\"\>", ",", "\<\"order\"\>", 
   ",", "\<\"orderChristoffels\"\>", ",", "\<\"orig\"\>", 
   ",", "\<\"origin\"\>", ",", "\<\"originalmetric\"\>", 
   ",", "\<\"originalQ\"\>", ",", "\<\"orthogonalQ\"\>", 
   ",", "\<\"OrthogonalToVectoQ\"\>", ",", "\<\"OrthogonalToVector\"\>", 
   ",", "\<\"OrthogonalWithMetricQ\"\>", ",", "\<\"orthoQ\"\>", 
   ",", "\<\"ot\"\>", ",", "\<\"other\"\>", ",", "\<\"othervs\"\>", 
   ",", "\<\"OToVcheck\"\>", ",", "\<\"output\"\>", ",", "\<\"outside\"\>", 
   ",", "\<\"ov\"\>", ",", "\<\"OverDotTensor\"\>", ",", "\<\"owm\"\>", 
   ",", "\<\"p\"\>", ",", "\<\"P\"\>", ",", "\<\"p1\"\>", ",", "\<\"p2\"\>", 
   ",", "\<\"p3\"\>", ",", "\<\"pa\"\>", ",", "\<\"pair\"\>", 
   ",", "\<\"pairs\"\>", ",", "\<\"pairs1\"\>", ",", "\<\"pairs2\"\>", 
   ",", "\<\"par\"\>", ",", "\<\"param\"\>", ",", "\<\"param1\"\>", 
   ",", "\<\"ParamDTensor\"\>", ",", "\<\"parameters\"\>", 
   ",", "\<\"params\"\>", ",", "\<\"pars\"\>", ",", "\<\"patindsLHS\"\>", 
   ",", "\<\"pattern\"\>", ",", "\<\"patternisolated\"\>", 
   ",", "\<\"patternQ\"\>", ",", "\<\"patternTest\"\>", 
   ",", "\<\"PBIndexRules\"\>", ",", "\<\"pbs\"\>", ",", "\<\"pbsside\"\>", 
   ",", "\<\"pbx\"\>", ",", "\<\"PDK\"\>", ",", "\<\"pdtensor\"\>", 
   ",", "\<\"perm\"\>", ",", "\<\"perms1\"\>", ",", "\<\"PFIndexRules\"\>", 
   ",", "\<\"phi\"\>", ",", "\<\"phi1\"\>", ",", "\<\"phi2\"\>", 
   ",", "\<\"phirest\"\>", ",", "\<\"phis\"\>", ",", "\<\"pl\"\>", 
   ",", "\<\"PlusIndices\"\>", ",", "\<\"pmQ\"\>", ",", "\<\"pmQinds\"\>", 
   ",", "\<\"pns\"\>", ",", "\<\"point\"\>", ",", "\<\"points\"\>", 
   ",", "\<\"pos\"\>", ",", "\<\"posits\"\>", ",", "\<\"post\"\>", 
   ",", "\<\"pr\"\>", ",", "\<\"PrecomposeBox\"\>", 
   ",", "\<\"PrecomposeDependencies\"\>", ",", "\<\"PrecomposeDependency\"\>",
    ",", "\<\"PrecomposeString\"\>", ",", "\<\"PrecomposeVBundles\"\>", 
   ",", "\<\"PrecomposeWeight\"\>", ",", "\<\"PrefixFormatDer\"\>", 
   ",", "\<\"PrefixFormatDerString\"\>", ",", "\<\"printas\"\>", 
   ",", "\<\"PrintAsSmaller\"\>", ",", "\<\"PrintTimeThreshold\"\>", 
   ",", "\<\"PRJ\"\>", ",", "\<\"prod\"\>", ",", "\<\"prod1\"\>", 
   ",", "\<\"prod2\"\>", ",", "\<\"product\"\>", ",", "\<\"ProductSort\"\>", 
   ",", "\<\"proj\"\>", ",", "\<\"proj1\"\>", ",", "\<\"proj2\"\>", 
   ",", "\<\"project\"\>", ",", "\<\"ProjectDerivativeRules\"\>", 
   ",", "\<\"projectedQ\"\>", ",", "\<\"projectindex\"\>", 
   ",", "\<\"projector\"\>", ",", "\<\"projectorname\"\>", 
   ",", "\<\"projectors\"\>", ",", "\<\"ProjectTensor\"\>", 
   ",", "\<\"projs\"\>", ",", "\<\"projs1\"\>", ",", "\<\"projs2\"\>", 
   ",", "\<\"projs3\"\>", ",", "\<\"projsL\"\>", ",", "\<\"projsR\"\>", 
   ",", "\<\"props\"\>", ",", "\<\"prot\"\>", ",", "\<\"ps\"\>", 
   ",", "\<\"ps1\"\>", ",", "\<\"ps2\"\>", ",", "\<\"pslist\"\>", 
   ",", "\<\"ptim\"\>", ",", "\<\"PullBack1\"\>", 
   ",", "\<\"PullBackBasis\"\>", ",", "\<\"PullBackBox\"\>", 
   ",", "\<\"PullBackCharacter\"\>", ",", "\<\"PullBackIMod\"\>", 
   ",", "\<\"PullBackIndex\"\>", ",", "\<\"PullBackString\"\>", 
   ",", "\<\"PullBackVBundles\"\>", ",", "\<\"pullfactor1\"\>", 
   ",", "\<\"pushfactor1\"\>", ",", "\<\"PushForward1\"\>", 
   ",", "\<\"PushForwardBasis\"\>", ",", "\<\"PushForwardBox\"\>", 
   ",", "\<\"PushForwardString\"\>", ",", "\<\"PushVBundles\"\>", 
   ",", "\<\"puthead\"\>", ",", "\<\"putmetric\"\>", ",", "\<\"pw\"\>", 
   ",", "\<\"r\"\>", ",", "\<\"R\"\>", ",", "\<\"range\"\>", 
   ",", "\<\"ranges\"\>", ",", "\<\"rank\"\>", 
   ",", "\<\"recheckmetricstates\"\>", ",", "\<\"Reconstruct\"\>", 
   ",", "\<\"RecursiveIsolated\"\>", ",", "\<\"RegisterPullBackIndex\"\>", 
   ",", "\<\"RemoveIndicesInFirstList\"\>", ",", "\<\"RemoveSdelta\"\>", 
   ",", "\<\"removeTMPCovD\"\>", ",", "\<\"repargs\"\>", ",", "\<\"repes\"\>",
    ",", "\<\"ReplaceBasis1Index\"\>", ",", "\<\"ReplaceBasis2Index\"\>", 
   ",", "\<\"ReplaceConflictingDummies\"\>", ",", "\<\"ReplaceIsolated\"\>", 
   ",", "\<\"replall\"\>", ",", "\<\"res\"\>", ",", "\<\"rest\"\>", 
   ",", "\<\"result\"\>", ",", "\<\"rhs\"\>", ",", "\<\"RHS\"\>", 
   ",", "\<\"ricci\"\>", ",", "\<\"RicciName\"\>", ",", "\<\"ricciscalar\"\>",
    ",", "\<\"RicciScalarName\"\>", ",", "\<\"RicciToTFRicciRules\"\>", 
   ",", "\<\"riema\"\>", ",", "\<\"riemann\"\>", ",", "\<\"riemann1\"\>", 
   ",", "\<\"RiemannDownName\"\>", ",", "\<\"RiemannDownToRiemannRules\"\>", 
   ",", "\<\"RiemannName\"\>", ",", "\<\"riemannsymmetric\"\>", 
   ",", "\<\"RiemannToRiemannDownRules\"\>", ",", "\<\"rigging\"\>", 
   ",", "\<\"right\"\>", ",", "\<\"right1\"\>", ",", "\<\"right2\"\>", 
   ",", "\<\"rightbundles\"\>", ",", "\<\"righths\"\>", 
   ",", "\<\"rightups\"\>", ",", "\<\"risk\"\>", 
   ",", "\<\"riskyderbasisQ\"\>", ",", "\<\"riskydermetricQ\"\>", 
   ",", "\<\"riskyders\"\>", ",", "\<\"RiskyDers\"\>", ",", "\<\"rl\"\>", 
   ",", "\<\"rproj\"\>", ",", "\<\"rs\"\>", ",", "\<\"rule\"\>", 
   ",", "\<\"rules\"\>", ",", "\<\"rules1\"\>", ",", "\<\"rules2\"\>", 
   ",", "\<\"rulesLHS\"\>", ",", "\<\"s\"\>", ",", "\<\"SameExpressionsQ\"\>",
    ",", "\<\"samevbQ\"\>", ",", "\<\"SameVBundleQ\"\>", 
   ",", "\<\"SameVBundleRules2\"\>", ",", "\<\"sc\"\>", ",", "\<\"scal\"\>", 
   ",", "\<\"scalar\"\>", ",", "\<\"scalar1\"\>", 
   ",", "\<\"ScalarFuncionQ\"\>", ",", "\<\"ScalarMonomial\"\>", 
   ",", "\<\"scalars\"\>", ",", "\<\"scQ\"\>", ",", "\<\"Screen\"\>", 
   ",", "\<\"sd\"\>", ",", "\<\"secondarytype\"\>", ",", "\<\"secondcan\"\>", 
   ",", "\<\"SecondToCanonical\"\>", ",", "\<\"SelectIndices\"\>", 
   ",", "\<\"selecton\"\>", ",", "\<\"selector\"\>", ",", "\<\"selector1\"\>",
    ",", "\<\"selectors\"\>", ",", "\<\"semil\"\>", 
   ",", "\<\"separateDir\"\>", ",", "\<\"SeparateMetric1\"\>", 
   ",", "\<\"SeparateMetric2\"\>", ",", "\<\"seq\"\>", 
   ",", "\<\"SeriesDataMap\"\>", ",", "\<\"servants\"\>", 
   ",", "\<\"setcharacters\"\>", ",", "\<\"SetLastIndex\"\>", 
   ",", "\<\"sexpr\"\>", ",", "\<\"Sexpr\"\>", ",", "\<\"sf\"\>", 
   ",", "\<\"SGS\"\>", ",", "\<\"SGS1\"\>", ",", "\<\"SGS2\"\>", 
   ",", "\<\"SGSofsym\"\>", ",", "\<\"SGSs\"\>", ",", "\<\"sign\"\>", 
   ",", "\<\"signdet\"\>", ",", "\<\"SignedVBundleOfIndex\"\>", 
   ",", "\<\"SimpleObjectQ\"\>", ",", "\<\"sl\"\>", ",", "\<\"slot\"\>", 
   ",", "\<\"slotarray\"\>", ",", "\<\"slotlist\"\>", 
   ",", "\<\"SlotOfDerivative\"\>", ",", "\<\"slotrules\"\>", 
   ",", "\<\"slots\"\>", ",", "\<\"slots1\"\>", ",", "\<\"slots2\"\>", 
   ",", "\<\"small\"\>", ",", "\<\"smallgroup\"\>", ",", "\<\"SMP\"\>", 
   ",", "\<\"smt\"\>", ",", "\<\"solution\"\>", ",", "\<\"sortder\"\>", 
   ",", "\<\"sortedexpr\"\>", ",", "\<\"sortedfrees\"\>", 
   ",", "\<\"sortedfrees2\"\>", ",", "\<\"sortedindices\"\>", 
   ",", "\<\"SortingName\"\>", ",", "\<\"splitrules\"\>", 
   ",", "\<\"SplitTensor1\"\>", ",", "\<\"SplitTensorIndex\"\>", 
   ",", "\<\"splitting\"\>", ",", "\<\"spt\"\>", ",", "\<\"spts\"\>", 
   ",", "\<\"SSSBinds\"\>", ",", "\<\"stem\"\>", ",", "\<\"str\"\>", 
   ",", "\<\"strings\"\>", ",", "\<\"Strip\"\>", ",", "\<\"StripContext\"\>", 
   ",", "\<\"StripInertHead\"\>", ",", "\<\"stripped\"\>", 
   ",", "\<\"StrippedPlus\"\>", ",", "\<\"strippeds\"\>", 
   ",", "\<\"StripProduct\"\>", ",", "\<\"strtensor\"\>", 
   ",", "\<\"struct\"\>", ",", "\<\"structure\"\>", ",", "\<\"sub\"\>", 
   ",", "\<\"submanifold\"\>", ",", "\<\"submanifolds\"\>", 
   ",", "\<\"subQ\"\>", ",", "\<\"subsets\"\>", ",", "\<\"subvbs\"\>", 
   ",", "\<\"subvbundles\"\>", ",", "\<\"sum\"\>", ",", "\<\"supercd\"\>", 
   ",", "\<\"superCD\"\>", ",", "\<\"superepsilonname\"\>", 
   ",", "\<\"supermanifold\"\>", ",", "\<\"supermetric\"\>", 
   ",", "\<\"superRicci\"\>", ",", "\<\"superRicciScalar\"\>", 
   ",", "\<\"superRiemann\"\>", ",", "\<\"support\"\>", ",", "\<\"svb1\"\>", 
   ",", "\<\"svb2\"\>", ",", "\<\"svb3\"\>", ",", "\<\"sx\"\>", 
   ",", "\<\"sy\"\>", ",", "\<\"sym\"\>", ",", "\<\"sym1\"\>", 
   ",", "\<\"sym1vbundle\"\>", ",", "\<\"symbol\"\>", ",", "\<\"symbol1\"\>", 
   ",", "\<\"symbol2\"\>", ",", "\<\"symCombine\"\>", ",", "\<\"SymDers\"\>", 
   ",", "\<\"symexpr\"\>", ",", "\<\"syminds\"\>", 
   ",", "\<\"symListCombine\"\>", ",", "\<\"symmetry\"\>", 
   ",", "\<\"Symmetry1D\"\>", ",", "\<\"SymmetryIndexCoefficient\"\>", 
   ",", "\<\"SymmetryOfIndex\"\>", ",", "\<\"SymmetryOfMetric\"\>", 
   ",", "\<\"SymmetryOfObject\"\>", ",", "\<\"SymmetryOfVerbatimProduct\"\>", 
   ",", "\<\"SymmetryPerms\"\>", ",", "\<\"symmetryz\"\>", 
   ",", "\<\"symmetryz1\"\>", ",", "\<\"symmetryz2\"\>", 
   ",", "\<\"symnumslots\"\>", ",", "\<\"symperms\"\>", 
   ",", "\<\"symperms1\"\>", ",", "\<\"syms\"\>", ",", "\<\"symsign\"\>", 
   ",", "\<\"symsign1\"\>", ",", "\<\"symslots\"\>", 
   ",", "\<\"symtensorsLHS\"\>", ",", "\<\"systemQ\"\>", ",", "\<\"t\"\>", 
   ",", "\<\"tab\"\>", ",", "\<\"tableaux\"\>", ",", "\<\"TakeBlocked\"\>", 
   ",", "\<\"TakePairs\"\>", ",", "\<\"TangentBundleOfCovD\"\>", 
   ",", "\<\"tb\"\>", ",", "\<\"tb1\"\>", ",", "\<\"tb2\"\>", 
   ",", "\<\"tbinds\"\>", ",", "\<\"tbpmQ\"\>", ",", "\<\"tbQ\"\>", 
   ",", "\<\"tbundle\"\>", ",", "\<\"TDI\"\>", ",", "\<\"tdom\"\>", 
   ",", "\<\"tdompmQ\"\>", ",", "\<\"Tee\"\>", ",", "\<\"tensor\"\>", 
   ",", "\<\"tensor1\"\>", ",", "\<\"tensor2\"\>", ",", "\<\"TensorDerQ\"\>", 
   ",", "\<\"tensorID\"\>", ",", "\<\"tensors\"\>", ",", "\<\"term\"\>", 
   ",", "\<\"terms\"\>", ",", "\<\"TetraName\"\>", 
   ",", "\<\"TetraNamedag\"\>", ",", "\<\"tf\"\>", ",", "\<\"TFRicciName\"\>",
    ",", "\<\"TFRicciToRicciRules\"\>", ",", "\<\"ThreadCartesianProduct\"\>",
    ",", "\<\"ti\"\>", ",", "\<\"tim\"\>", ",", "\<\"time\"\>", 
   ",", "\<\"TimesIndices\"\>", ",", "\<\"timpmQ\"\>", 
   ",", "\<\"tindexlist\"\>", ",", "\<\"tinds\"\>", ",", "\<\"tindsQ\"\>", 
   ",", "\<\"tmetric\"\>", ",", "\<\"tmp\"\>", ",", "\<\"tmpchrhead\"\>", 
   ",", "\<\"TMPChristoffel\"\>", ",", "\<\"TMPChristoffelLieD\"\>", 
   ",", "\<\"TMPCovD\"\>", ",", "\<\"tmpcovdhead\"\>", 
   ",", "\<\"tmpmetric\"\>", ",", "\<\"TMPTensorDerivative\"\>", 
   ",", "\<\"ToCanonicalDers\"\>", ",", "\<\"ToCanonicalDersChangeCovD\"\>", 
   ",", "\<\"ToCanonicalDersImplode\"\>", ",", "\<\"ToCanonicalDir\"\>", 
   ",", "\<\"ToCanonicalIndex\"\>", ",", "\<\"ToCanonicalObject\"\>", 
   ",", "\<\"ToCanonicalScalar\"\>", ",", "\<\"ToCanonicalSimpleObject\"\>", 
   ",", "\<\"ToCanonicalTensorHead\"\>", ",", "\<\"todelta\"\>", 
   ",", "\<\"TODO\"\>", ",", "\<\"ToIndexExpr\"\>", ",", "\<\"ToObject\"\>", 
   ",", "\<\"torQ\"\>", ",", "\<\"torsion\"\>", ",", "\<\"TorsionName\"\>", 
   ",", "\<\"ToSlotRules\"\>", ",", "\<\"ToTensorDerivative1\"\>", 
   ",", "\<\"ToTensorDerivativeIndex\"\>", 
   ",", "\<\"ToTMPTensorDerivative\"\>", ",", "\<\"TraceBasisDummy\"\>", 
   ",", "\<\"TraceDummyExpr\"\>", ",", "\<\"TraceIndex\"\>", 
   ",", "\<\"traceinds\"\>", ",", "\<\"tracerules\"\>", 
   ",", "\<\"TransposeDaggerPairs\"\>", 
   ",", "\<\"TransposeDaggerPairsOneVBundle\"\>", 
   ",", "\<\"TransposeDaggerRules\"\>", ",", "\<\"trios\"\>", 
   ",", "\<\"trynext\"\>", ",", "\<\"tslots\"\>", ",", "\<\"type\"\>", 
   ",", "\<\"type1\"\>", ",", "\<\"type2\"\>", ",", "\<\"u\"\>", 
   ",", "\<\"u1\"\>", ",", "\<\"u2\"\>", ",", "\<\"ultraindex\"\>", 
   ",", "\<\"Uname\"\>", ",", "\<\"UncatchedValidate\"\>", 
   ",", "\<\"uniqueslots\"\>", ",", "\<\"update\"\>", 
   ",", "\<\"updummies\"\>", ",", "\<\"upind\"\>", ",", "\<\"ups\"\>", 
   ",", "\<\"upspt\"\>", ",", "\<\"upspts\"\>", ",", "\<\"upstr\"\>", 
   ",", "\<\"upstring\"\>", ",", "\<\"upvs\"\>", ",", "\<\"us\"\>", 
   ",", "\<\"used\"\>", ",", "\<\"UseMetric\"\>", ",", "\<\"UseRiemann\"\>", 
   ",", "\<\"UxSort\"\>", ",", "\<\"v\"\>", ",", "\<\"v1\"\>", 
   ",", "\<\"v1a\"\>", ",", "\<\"v1b\"\>", ",", "\<\"v2\"\>", 
   ",", "\<\"v2a\"\>", ",", "\<\"v2b\"\>", ",", "\<\"val\"\>", 
   ",", "\<\"valid\"\>", ",", "\<\"ValidateBracket\"\>", 
   ",", "\<\"validsymmetryhead\"\>", ",", "\<\"van\"\>", 
   ",", "\<\"vanishQ\"\>", ",", "\<\"var\"\>", ",", "\<\"varddelta\"\>", 
   ",", "\<\"VarDtake\"\>", ",", "\<\"vb\"\>", ",", "\<\"vb1\"\>", 
   ",", "\<\"vb2\"\>", ",", "\<\"vb3\"\>", ",", "\<\"vba\"\>", 
   ",", "\<\"vbb\"\>", ",", "\<\"vbdag\"\>", ",", "\<\"vbdagger\"\>", 
   ",", "\<\"vbinds\"\>", ",", "\<\"vbpmQ\"\>", ",", "\<\"vbQ\"\>", 
   ",", "\<\"vbs\"\>", ",", "\<\"vbundle\"\>", ",", "\<\"vbundle1\"\>", 
   ",", "\<\"vbundle2\"\>", ",", "\<\"vbundledag\"\>", 
   ",", "\<\"VBundleIndexPMQ\"\>", ",", "\<\"VBundleIndexQ\"\>", 
   ",", "\<\"VBundleName\"\>", ",", "\<\"VBundleProjector\"\>", 
   ",", "\<\"vbundleQ\"\>", ",", "\<\"vbundles\"\>", ",", "\<\"vbundles1\"\>",
    ",", "\<\"vbundles2\"\>", ",", "\<\"VBundleUpQ\"\>", 
   ",", "\<\"vdagmetric\"\>", ",", "\<\"vdinds\"\>", ",", "\<\"vdmetric\"\>", 
   ",", "\<\"vector\"\>", ",", "\<\"verb\"\>", ",", "\<\"VerbatimPlus\"\>", 
   ",", "\<\"VerbatimProduct\"\>", ",", "\<\"verbose\"\>", 
   ",", "\<\"vhead\"\>", ",", "\<\"vinds\"\>", ",", "\<\"vmetric\"\>", 
   ",", "\<\"vprod\"\>", ",", "\<\"w\"\>", ",", "\<\"wedge\"\>", 
   ",", "\<\"weight\"\>", ",", "\<\"WeightedCovDQ\"\>", 
   ",", "\<\"WeylName\"\>", ",", "\<\"wrap\"\>", ",", "\<\"wwb\"\>", 
   ",", "\<\"x\"\>", ",", "\<\"X\"\>", ",", "\<\"x1\"\>", ",", "\<\"x2\"\>", 
   ",", "\<\"xTensorBox\"\>", ",", "\<\"xxx\"\>", ",", "\<\"y\"\>", 
   ",", "\<\"Y\"\>", ",", "\<\"z\"\>", ",", "\<\"z1\"\>", ",", "\<\"z2\"\>", 
   ",", "\<\"zero\"\>", ",", "\<\"ZeroDerOnMetricQ\"\>", 
   ",", "\<\"zlist\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"1c9c4648-f6de-407e-8f09-28ce2f3052ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"c04e407b-912e-4b0f-98fe-fe89236cfd7f"],

Cell[BoxData["1228"], \
"Output",ExpressionUUID->"98a9dbf9-6d8d-47a8-8d07-7ab888da2165"]
}, Open  ]],

Cell["Symbols registered in the Global` context:", \
"Text",ExpressionUUID->"eb6a3974-3559-4369-97ac-ee48535d265a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Names", "[", "\"\<Global`*\>\"", 
  "]"}]], "Input",ExpressionUUID->"f089a3a6-9864-480c-9b69-b9fd2e8ad2bd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A$1610\"\>", ",", "\<\"a$1614\"\>", ",", "\<\"b$1\"\>", 
   ",", "\<\"EndExamples\"\>", ",", "\<\"expr\"\>", ",", "\<\"h\"\>", 
   ",", "\<\"H\"\>", ",", "\<\"head\"\>", ",", "\<\"J\"\>", 
   ",", "\<\"Polar\"\>", ",", "\<\"rule\"\>", ",", "\<\"symbols\"\>", 
   ",", "\<\"U\"\>", ",", "\<\"x\"\>", ",", "\<\"Z\"\>", 
   ",", "\<\"$DumpSupported\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"e4f1acea-762b-411f-9bde-67aebc81a0f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"65aea444-36e3-4ed8-acd1-c3a9b24eedf6"],

Cell[BoxData["16"], \
"Output",ExpressionUUID->"61b9c95e-930a-4edd-ae33-65432223217b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{"%%", ",", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"StringMatchQ", "[", 
      RowBox[{"#", ",", "\"\<*$*\>\""}], "]"}]}], "&"}]}], 
  "]"}]], "Input",ExpressionUUID->"93bcb894-bdb5-45fd-84be-415e09f8a171"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"EndExamples\"\>", ",", "\<\"expr\"\>", ",", "\<\"h\"\>", 
   ",", "\<\"H\"\>", ",", "\<\"head\"\>", ",", "\<\"J\"\>", 
   ",", "\<\"Polar\"\>", ",", "\<\"rule\"\>", ",", "\<\"symbols\"\>", 
   ",", "\<\"U\"\>", ",", "\<\"x\"\>", ",", "\<\"Z\"\>"}], 
  "}"}]], "Output",ExpressionUUID->"2e029e2e-eff8-46b6-8dd9-1c2747db9713"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "%", 
  "]"}]], "Input",ExpressionUUID->"cd588198-a264-497b-8d4c-f22385e85d92"],

Cell[BoxData["12"], \
"Output",ExpressionUUID->"5bbdb3dc-c167-48da-8719-974a94001728"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{987, 735},
WindowMargins->{{428, Automatic}, {Automatic, 22}},
PrivateNotebookOptions->{"FileOutlineCache"->False},
ShowSelection->True,
TaggingRules->{
 "DocuToolsSettingsInternal" -> {
   "$PacletVersion" -> "0.10.2122", "$MVersion" -> "12", "$FlaggedVersion" -> 
    11.3}, ScrollPosition -> {0., 24.}, "TryRealOnly" -> False},
TrackCellChangeTimes->False,
Magnification->1,
FrontEndVersion->"12.3 for Mac OS X x86 (64-bit) (June 19, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"6bef3606-b241-4243-8da2-ffa3a26187c6"
]

